/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 94;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 6,
  Feature_HasJSBit = 8,
  Feature_HasComplxNumBit = 66,
  Feature_HasRCPC_IMMOBit = 86,
  Feature_HasFPARMv8Bit = 7,
  Feature_HasNEONBit = 5,
  Feature_HasSM4Bit = 65,
  Feature_HasSHA3Bit = 64,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 10,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 29,
  Feature_HasLSEBit = 30,
  Feature_HasNoLSEBit = 93,
  Feature_HasRDMBit = 16,
  Feature_HasFullFP16Bit = 13,
  Feature_HasNoFullFP16Bit = 83,
  Feature_HasFP16FMLBit = 4,
  Feature_HasFuseAESBit = 77,
  Feature_HasSVEBit = 26,
  Feature_HasSVE2Bit = 27,
  Feature_HasSVE2p1Bit = 44,
  Feature_HasSVEAESBit = 37,
  Feature_HasSVE2SM4Bit = 41,
  Feature_HasSVE2SHA3Bit = 92,
  Feature_HasSVEBitPermBit = 39,
  Feature_HasSMEandIsNonStreamingSafeBit = 57,
  Feature_HasSMEBit = 50,
  Feature_HasSMEF64F64Bit = 52,
  Feature_HasSMEF16F16Bit = 63,
  Feature_HasSMEI16I64Bit = 55,
  Feature_HasSME2andIsNonStreamingSafeBit = 60,
  Feature_HasSME2Bit = 59,
  Feature_HasSME2p1Bit = 62,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasFP8FMABit = 23,
  Feature_HasSSVE_FP8FMABit = 47,
  Feature_HasFP8DOT2Bit = 24,
  Feature_HasSSVE_FP8DOT2Bit = 42,
  Feature_HasFP8DOT4Bit = 25,
  Feature_HasSSVE_FP8DOT4Bit = 48,
  Feature_HasLUTBit = 49,
  Feature_HasSME_LUTv2Bit = 61,
  Feature_HasSMEF8F16Bit = 53,
  Feature_HasSMEF8F32Bit = 51,
  Feature_HasSME_MOP4Bit = 56,
  Feature_HasCMPBRBit = 84,
  Feature_HasFPRCVTBit = 14,
  Feature_HasLSFEBit = 31,
  Feature_HasSVE_or_SMEBit = 0,
  Feature_HasNonStreamingSVE_or_SME2p2Bit = 40,
  Feature_HasSVE2_or_SMEBit = 33,
  Feature_HasSVE2_or_SME2Bit = 46,
  Feature_HasNonStreamingSVE2_or_SSVE_AESBit = 36,
  Feature_HasSVE2p1_or_SMEBit = 58,
  Feature_HasSVE2p1_or_SME2Bit = 28,
  Feature_HasSVE2p1_or_SME2p1Bit = 45,
  Feature_HasSVE2p2_or_SME2p2Bit = 32,
  Feature_HasSMEF16F16_or_SMEF8F16Bit = 54,
  Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit = 38,
  Feature_HasNEONandIsStreamingSafeBit = 17,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 74,
  Feature_HasRCPCBit = 85,
  Feature_HasFRInt3264Bit = 15,
  Feature_HasMTEBit = 11,
  Feature_HasTMEBit = 9,
  Feature_HasMatMulInt8Bit = 3,
  Feature_HasMatMulFP32Bit = 91,
  Feature_HasMatMulFP64Bit = 43,
  Feature_HasLS64Bit = 81,
  Feature_HasHBCBit = 12,
  Feature_HasRCPC3Bit = 82,
  Feature_HasGCSBit = 1,
  Feature_IsLEBit = 72,
  Feature_IsBEBit = 78,
  Feature_UseExperimentalZeroingPseudosBit = 35,
  Feature_UseAlternateSExtLoadCVTF32Bit = 76,
  Feature_UseScalarIncVLBit = 34,
  Feature_NoUseScalarIncVLBit = 89,
  Feature_UseSVEFPLD1RBit = 88,
  Feature_UseLDAPURBit = 87,
  Feature_AllowMisalignedMemAccessesBit = 90,
  Feature_NotForCodeSizeBit = 75,
  Feature_UseSTRQroBit = 73,
  Feature_TailCallX16X17Bit = 68,
  Feature_TailCallX17Bit = 79,
  Feature_TailCallNotX16Bit = 80,
  Feature_TailCallAnyBit = 67,
  Feature_SLSBLRMitigationBit = 71,
  Feature_NoSLSBLRMitigationBit = 70,
  Feature_OptimizedGISelOrOtherSelectorBit = 69,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SHA3())
    Features.set(Feature_HasSVE2SHA3Bit);
  if (Subtarget->hasSVEBitPerm())
    Features.set(Feature_HasSVEBitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF16F16())
    Features.set(Feature_HasSMEF16F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasFP8FMA())
    Features.set(Feature_HasFP8FMABit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasFP8DOT2())
    Features.set(Feature_HasFP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasFP8DOT4())
    Features.set(Feature_HasFP8DOT4Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_MOP4()))
    Features.set(Feature_HasSME_MOP4Bit);
  if (Subtarget->hasCMPBR())
    Features.set(Feature_HasCMPBRBit);
  if (Subtarget->hasFPRCVT())
    Features.set(Feature_HasFPRCVTBit);
  if (Subtarget->hasLSFE())
    Features.set(Feature_HasLSFEBit);
  if (Subtarget->hasSVE() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE_or_SMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p2Bit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2_or_SMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2_or_SME2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_AESBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_SMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_SME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_SME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2_or_SME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16_or_SMEF8F16Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_BitPerm()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!Subtarget->avoidLDAPUR())
    Features.set(Feature_UseLDAPURBit);
  if (!Subtarget->requiresStrictAlign())
    Features.set(Feature_AllowMisalignedMemAccessesBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasProperty(MachineFunctionProperties::Property::FailedISel) || !MF->getProperties().hasProperty(MachineFunctionProperties::Property::Legalized))
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFP8DOT2,
  GIFBS_HasFP8DOT4,
  GIFBS_HasFP8FMA,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLSFE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVE_or_SME2p2,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEF16F16_or_SMEF8F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSME_MOP4,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2SHA3,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2_or_SME,
  GIFBS_HasSVE2p1_or_SME,
  GIFBS_HasSVE2p1_or_SME2,
  GIFBS_HasSVE2p1_or_SME2p1,
  GIFBS_HasSVE_or_SME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2_or_SME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasSVE2_or_SME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFPRCVT_HasNEON,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2_or_SME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE_or_SME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVE_or_SME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES,
  GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm,
  GIFBS_HasRCPC_IMMO_UseLDAPUR,
  GIFBS_HasSMEF16F16_HasSME_MOP4,
  GIFBS_HasSMEF64F64_HasSME_MOP4,
  GIFBS_HasSMEI16I64_HasSME_MOP4,
  GIFBS_HasSVE_or_SME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFP8DOT2Bit, },
  {Feature_HasFP8DOT4Bit, },
  {Feature_HasFP8FMABit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLSFEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVE_or_SME2p2Bit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEF16F16_or_SMEF8F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2SHA3Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2_or_SMEBit, },
  {Feature_HasSVE2p1_or_SMEBit, },
  {Feature_HasSVE2p1_or_SME2Bit, },
  {Feature_HasSVE2p1_or_SME2p1Bit, },
  {Feature_HasSVE_or_SMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFPRCVTBit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit, Feature_HasSVEBitPermBit, },
  {Feature_HasRCPC_IMMOBit, Feature_UseLDAPURBit, },
  {Feature_HasSMEF16F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF64F64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEI16I64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSVE_or_SMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_AllowMisalignedMemAccessesBit, Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         return mi_match(MI, MRI, m_GAddLike(m_Reg(), m_Reg()));
      
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(889), /*)*//*default:*//*Label 157*/ GIMT_Encode4(414744),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3354),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(36617),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(50845),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(52674),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(52756), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(52838),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(60584),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(72631), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(79823), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(87347), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(97291),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(97782),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(98273),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(98541),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(98691),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(99182), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(99215),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(108025),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(109075), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(112044), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(125570),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(126921),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(127913),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(128905),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(130397), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(131889),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(132881),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(133873),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(134865),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(135857),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(136849),
     /*    254 */ /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 31*/ GIMT_Encode4(137841), GIMT_Encode4(0),
     /*    262 */ /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 32*/ GIMT_Encode4(138546),
     /*    266 */ /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 33*/ GIMT_Encode4(139251), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    286 */ /*TargetOpcode::G_FENCE*//*Label 34*/ GIMT_Encode4(139956), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    306 */ /*TargetOpcode::G_INTRINSIC*//*Label 35*/ GIMT_Encode4(140007),
     /*    310 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 36*/ GIMT_Encode4(249740), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    322 */ /*TargetOpcode::G_ANYEXT*//*Label 37*/ GIMT_Encode4(261060),
     /*    326 */ /*TargetOpcode::G_TRUNC*//*Label 38*/ GIMT_Encode4(261350),
     /*    330 */ /*TargetOpcode::G_CONSTANT*//*Label 39*/ GIMT_Encode4(262787),
     /*    334 */ /*TargetOpcode::G_FCONSTANT*//*Label 40*/ GIMT_Encode4(262907), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    346 */ /*TargetOpcode::G_SEXT*//*Label 41*/ GIMT_Encode4(263148),
     /*    350 */ /*TargetOpcode::G_SEXT_INREG*//*Label 42*/ GIMT_Encode4(265046),
     /*    354 */ /*TargetOpcode::G_ZEXT*//*Label 43*/ GIMT_Encode4(266700),
     /*    358 */ /*TargetOpcode::G_SHL*//*Label 44*/ GIMT_Encode4(269479),
     /*    362 */ /*TargetOpcode::G_LSHR*//*Label 45*/ GIMT_Encode4(270259),
     /*    366 */ /*TargetOpcode::G_ASHR*//*Label 46*/ GIMT_Encode4(270652), GIMT_Encode4(0),
     /*    374 */ /*TargetOpcode::G_FSHR*//*Label 47*/ GIMT_Encode4(271428),
     /*    378 */ /*TargetOpcode::G_ROTR*//*Label 48*/ GIMT_Encode4(271558), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ICMP*//*Label 49*/ GIMT_Encode4(272051), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    402 */ /*TargetOpcode::G_SELECT*//*Label 50*/ GIMT_Encode4(279828), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    446 */ /*TargetOpcode::G_UMULH*//*Label 51*/ GIMT_Encode4(280873),
     /*    450 */ /*TargetOpcode::G_SMULH*//*Label 52*/ GIMT_Encode4(281357),
     /*    454 */ /*TargetOpcode::G_UADDSAT*//*Label 53*/ GIMT_Encode4(281841),
     /*    458 */ /*TargetOpcode::G_SADDSAT*//*Label 54*/ GIMT_Encode4(282271),
     /*    462 */ /*TargetOpcode::G_USUBSAT*//*Label 55*/ GIMT_Encode4(282701),
     /*    466 */ /*TargetOpcode::G_SSUBSAT*//*Label 56*/ GIMT_Encode4(283131), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    510 */ /*TargetOpcode::G_FADD*//*Label 57*/ GIMT_Encode4(283561),
     /*    514 */ /*TargetOpcode::G_FSUB*//*Label 58*/ GIMT_Encode4(285359),
     /*    518 */ /*TargetOpcode::G_FMUL*//*Label 59*/ GIMT_Encode4(286097),
     /*    522 */ /*TargetOpcode::G_FMA*//*Label 60*/ GIMT_Encode4(290193), GIMT_Encode4(0),
     /*    530 */ /*TargetOpcode::G_FDIV*//*Label 61*/ GIMT_Encode4(306466), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    578 */ /*TargetOpcode::G_FNEG*//*Label 62*/ GIMT_Encode4(307082),
     /*    582 */ /*TargetOpcode::G_FPEXT*//*Label 63*/ GIMT_Encode4(310589),
     /*    586 */ /*TargetOpcode::G_FPTRUNC*//*Label 64*/ GIMT_Encode4(310837),
     /*    590 */ /*TargetOpcode::G_FPTOSI*//*Label 65*/ GIMT_Encode4(311025),
     /*    594 */ /*TargetOpcode::G_FPTOUI*//*Label 66*/ GIMT_Encode4(312088),
     /*    598 */ /*TargetOpcode::G_SITOFP*//*Label 67*/ GIMT_Encode4(313151),
     /*    602 */ /*TargetOpcode::G_UITOFP*//*Label 68*/ GIMT_Encode4(317548),
     /*    606 */ /*TargetOpcode::G_FPTOSI_SAT*//*Label 69*/ GIMT_Encode4(321323),
     /*    610 */ /*TargetOpcode::G_FPTOUI_SAT*//*Label 70*/ GIMT_Encode4(321643),
     /*    614 */ /*TargetOpcode::G_FABS*//*Label 71*/ GIMT_Encode4(321963), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    626 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 72*/ GIMT_Encode4(322820),
     /*    630 */ /*TargetOpcode::G_FMINNUM*//*Label 73*/ GIMT_Encode4(323102),
     /*    634 */ /*TargetOpcode::G_FMAXNUM*//*Label 74*/ GIMT_Encode4(323480),
     /*    638 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 75*/ GIMT_Encode4(323858),
     /*    642 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 76*/ GIMT_Encode4(324208),
     /*    646 */ /*TargetOpcode::G_FMINIMUM*//*Label 77*/ GIMT_Encode4(324558),
     /*    650 */ /*TargetOpcode::G_FMAXIMUM*//*Label 78*/ GIMT_Encode4(325261), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    686 */ /*TargetOpcode::G_SMIN*//*Label 79*/ GIMT_Encode4(325964),
     /*    690 */ /*TargetOpcode::G_SMAX*//*Label 80*/ GIMT_Encode4(326368),
     /*    694 */ /*TargetOpcode::G_UMIN*//*Label 81*/ GIMT_Encode4(326772),
     /*    698 */ /*TargetOpcode::G_UMAX*//*Label 82*/ GIMT_Encode4(327176),
     /*    702 */ /*TargetOpcode::G_ABS*//*Label 83*/ GIMT_Encode4(327580),
     /*    706 */ /*TargetOpcode::G_LROUND*//*Label 84*/ GIMT_Encode4(328395),
     /*    710 */ /*TargetOpcode::G_LLROUND*//*Label 85*/ GIMT_Encode4(328561),
     /*    714 */ /*TargetOpcode::G_BR*//*Label 86*/ GIMT_Encode4(328660), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 87*/ GIMT_Encode4(328676),
     /*    734 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 88*/ GIMT_Encode4(334048),
     /*    738 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 89*/ GIMT_Encode4(361445), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_SPLAT_VECTOR*//*Label 90*/ GIMT_Encode4(364363), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    758 */ /*TargetOpcode::G_CTTZ*//*Label 91*/ GIMT_Encode4(366683), GIMT_Encode4(0),
     /*    766 */ /*TargetOpcode::G_CTLZ*//*Label 92*/ GIMT_Encode4(366835), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTPOP*//*Label 93*/ GIMT_Encode4(367509),
     /*    778 */ /*TargetOpcode::G_BSWAP*//*Label 94*/ GIMT_Encode4(367669),
     /*    782 */ /*TargetOpcode::G_BITREVERSE*//*Label 95*/ GIMT_Encode4(367983),
     /*    786 */ /*TargetOpcode::G_FCEIL*//*Label 96*/ GIMT_Encode4(368137), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    834 */ /*TargetOpcode::G_FSQRT*//*Label 97*/ GIMT_Encode4(368628),
     /*    838 */ /*TargetOpcode::G_FFLOOR*//*Label 98*/ GIMT_Encode4(368928),
     /*    842 */ /*TargetOpcode::G_FRINT*//*Label 99*/ GIMT_Encode4(369419),
     /*    846 */ /*TargetOpcode::G_FNEARBYINT*//*Label 100*/ GIMT_Encode4(369910), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    874 */ /*TargetOpcode::G_STRICT_FADD*//*Label 101*/ GIMT_Encode4(370401),
     /*    878 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 102*/ GIMT_Encode4(371527),
     /*    882 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 103*/ GIMT_Encode4(372143),
     /*    886 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 104*/ GIMT_Encode4(375865), GIMT_Encode4(0),
     /*    894 */ /*TargetOpcode::G_STRICT_FMA*//*Label 105*/ GIMT_Encode4(376481),
     /*    898 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 106*/ GIMT_Encode4(392088), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    934 */ /*TargetOpcode::G_TRAP*//*Label 107*/ GIMT_Encode4(392388),
     /*    938 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 108*/ GIMT_Encode4(392402),
     /*    942 */ /*TargetOpcode::G_UBSANTRAP*//*Label 109*/ GIMT_Encode4(392423), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    954 */ /*TargetOpcode::G_VECREDUCE_FADD*//*Label 110*/ GIMT_Encode4(392448), GIMT_Encode4(0),
     /*    962 */ /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 111*/ GIMT_Encode4(392758),
     /*    966 */ /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 112*/ GIMT_Encode4(392929),
     /*    970 */ /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 113*/ GIMT_Encode4(393100),
     /*    974 */ /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 114*/ GIMT_Encode4(393271),
     /*    978 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 115*/ GIMT_Encode4(393442), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    998 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 116*/ GIMT_Encode4(394571),
     /*   1002 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 117*/ GIMT_Encode4(394774),
     /*   1006 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 118*/ GIMT_Encode4(394977),
     /*   1010 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 119*/ GIMT_Encode4(395180), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3202 */ /*AArch64::G_AARCH64_PREFETCH*//*Label 120*/ GIMT_Encode4(395383), GIMT_Encode4(0),
     /*   3210 */ /*AArch64::G_BSP*//*Label 121*/ GIMT_Encode4(395523),
     /*   3214 */ /*AArch64::G_DUP*//*Label 122*/ GIMT_Encode4(396063),
     /*   3218 */ /*AArch64::G_DUPLANE16*//*Label 123*/ GIMT_Encode4(397886),
     /*   3222 */ /*AArch64::G_DUPLANE32*//*Label 124*/ GIMT_Encode4(398141),
     /*   3226 */ /*AArch64::G_DUPLANE64*//*Label 125*/ GIMT_Encode4(398396),
     /*   3230 */ /*AArch64::G_DUPLANE8*//*Label 126*/ GIMT_Encode4(398542),
     /*   3234 */ /*AArch64::G_EXT*//*Label 127*/ GIMT_Encode4(398721),
     /*   3238 */ /*AArch64::G_FCMEQ*//*Label 128*/ GIMT_Encode4(400371),
     /*   3242 */ /*AArch64::G_FCMEQZ*//*Label 129*/ GIMT_Encode4(400710),
     /*   3246 */ /*AArch64::G_FCMGE*//*Label 130*/ GIMT_Encode4(400940),
     /*   3250 */ /*AArch64::G_FCMGEZ*//*Label 131*/ GIMT_Encode4(401604),
     /*   3254 */ /*AArch64::G_FCMGT*//*Label 132*/ GIMT_Encode4(401834),
     /*   3258 */ /*AArch64::G_FCMGTZ*//*Label 133*/ GIMT_Encode4(402498),
     /*   3262 */ /*AArch64::G_FCMLEZ*//*Label 134*/ GIMT_Encode4(402728),
     /*   3266 */ /*AArch64::G_FCMLTZ*//*Label 135*/ GIMT_Encode4(402958),
     /*   3270 */ /*AArch64::G_REV16*//*Label 136*/ GIMT_Encode4(403188),
     /*   3274 */ /*AArch64::G_REV32*//*Label 137*/ GIMT_Encode4(403342),
     /*   3278 */ /*AArch64::G_REV64*//*Label 138*/ GIMT_Encode4(403518),
     /*   3282 */ /*AArch64::G_SADDLP*//*Label 139*/ GIMT_Encode4(403792),
     /*   3286 */ /*AArch64::G_SADDLV*//*Label 140*/ GIMT_Encode4(403998),
     /*   3290 */ /*AArch64::G_SDOT*//*Label 141*/ GIMT_Encode4(404397),
     /*   3294 */ /*AArch64::G_SITOF*//*Label 142*/ GIMT_Encode4(404767),
     /*   3298 */ /*AArch64::G_SMULL*//*Label 143*/ GIMT_Encode4(404884),
     /*   3302 */ /*AArch64::G_TRN1*//*Label 144*/ GIMT_Encode4(406117),
     /*   3306 */ /*AArch64::G_TRN2*//*Label 145*/ GIMT_Encode4(406897),
     /*   3310 */ /*AArch64::G_UADDLP*//*Label 146*/ GIMT_Encode4(407677),
     /*   3314 */ /*AArch64::G_UADDLV*//*Label 147*/ GIMT_Encode4(407883),
     /*   3318 */ /*AArch64::G_UDOT*//*Label 148*/ GIMT_Encode4(408750),
     /*   3322 */ /*AArch64::G_UITOF*//*Label 149*/ GIMT_Encode4(409120),
     /*   3326 */ /*AArch64::G_UMULL*//*Label 150*/ GIMT_Encode4(409237),
     /*   3330 */ /*AArch64::G_UZP1*//*Label 151*/ GIMT_Encode4(410470),
     /*   3334 */ /*AArch64::G_UZP2*//*Label 152*/ GIMT_Encode4(411250),
     /*   3338 */ /*AArch64::G_VASHR*//*Label 153*/ GIMT_Encode4(412030),
     /*   3342 */ /*AArch64::G_VLSHR*//*Label 154*/ GIMT_Encode4(412728),
     /*   3346 */ /*AArch64::G_ZIP1*//*Label 155*/ GIMT_Encode4(413184),
     /*   3350 */ /*AArch64::G_ZIP2*//*Label 156*/ GIMT_Encode4(413964),
     /*   3354 */ // Label 0: @3354
     /*   3354 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 171*/ GIMT_Encode4(36616),
     /*   3365 */ /*GILLT_s32*//*Label 158*/ GIMT_Encode4(3453),
     /*   3369 */ /*GILLT_s64*//*Label 159*/ GIMT_Encode4(6232), GIMT_Encode4(0),
     /*   3377 */ /*GILLT_v2s32*//*Label 160*/ GIMT_Encode4(11828),
     /*   3381 */ /*GILLT_v2s64*//*Label 161*/ GIMT_Encode4(15436),
     /*   3385 */ /*GILLT_v4s16*//*Label 162*/ GIMT_Encode4(21338),
     /*   3389 */ /*GILLT_v4s32*//*Label 163*/ GIMT_Encode4(24836),
     /*   3393 */ /*GILLT_v8s8*//*Label 164*/ GIMT_Encode4(31014),
     /*   3397 */ /*GILLT_v8s16*//*Label 165*/ GIMT_Encode4(31864),
     /*   3401 */ /*GILLT_v16s8*//*Label 166*/ GIMT_Encode4(35442), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3421 */ /*GILLT_nxv2s64*//*Label 167*/ GIMT_Encode4(36166), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3433 */ /*GILLT_nxv4s32*//*Label 168*/ GIMT_Encode4(36538), GIMT_Encode4(0),
     /*   3441 */ /*GILLT_nxv8s16*//*Label 169*/ GIMT_Encode4(36564), GIMT_Encode4(0),
     /*   3449 */ /*GILLT_nxv16s8*//*Label 170*/ GIMT_Encode4(36590),
     /*   3453 */ // Label 158: @3453
     /*   3453 */ GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(6231),
     /*   3458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   3461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   3464 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(3497), // Rule ID 13135 //
     /*   3469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3477 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3484 */     // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3491 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3495 */     GIR_RootConstrainSelectedInstOperands,
     /*   3496 */     // GIR_Coverage, 13135,
     /*   3496 */     GIR_EraseRootFromParent_Done,
     /*   3497 */   // Label 173: @3497
     /*   3497 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(3649), // Rule ID 13562 //
     /*   3502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3529 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3532 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3537 */     // MIs[2] pattern
     /*   3537 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3540 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3551 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3551 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3554 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3558 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3565 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3568 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3572 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3577 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3580 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3584 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3587 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3592 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3597 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   3609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3614 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3617 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3621 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3631 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3648 */     // GIR_Coverage, 13562,
     /*   3648 */     GIR_EraseRootFromParent_Done,
     /*   3649 */   // Label 174: @3649
     /*   3649 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(3801), // Rule ID 15419 //
     /*   3654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3681 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3684 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   3689 */     // MIs[2] pattern
     /*   3689 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3692 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3703 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3703 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3706 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3710 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3717 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3720 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3724 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3729 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3732 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3736 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3739 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3744 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3749 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   3761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3766 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3769 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3773 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3783 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3795 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3800 */     // GIR_Coverage, 15419,
     /*   3800 */     GIR_EraseRootFromParent_Done,
     /*   3801 */   // Label 175: @3801
     /*   3801 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(3953), // Rule ID 15431 //
     /*   3806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3833 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3836 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   3841 */     // MIs[2] pattern
     /*   3841 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3844 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3855 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3855 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3858 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3862 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3869 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3872 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3876 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3881 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3884 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3888 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3891 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3896 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3901 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   3913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3918 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3921 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3925 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3935 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3952 */     // GIR_Coverage, 15431,
     /*   3952 */     GIR_EraseRootFromParent_Done,
     /*   3953 */   // Label 176: @3953
     /*   3953 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4105), // Rule ID 15443 //
     /*   3958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3985 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3988 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   3993 */     // MIs[2] pattern
     /*   3993 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3996 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4007 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4007 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4010 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4014 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4021 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4024 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4028 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4033 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4036 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   4040 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4043 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4048 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4053 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4070 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4077 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4087 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4094 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4099 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4104 */     // GIR_Coverage, 15443,
     /*   4104 */     GIR_EraseRootFromParent_Done,
     /*   4105 */   // Label 177: @4105
     /*   4105 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4138), // Rule ID 91 //
     /*   4110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   4125 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   4128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4130 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4132 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4136 */     GIR_RootConstrainSelectedInstOperands,
     /*   4137 */     // GIR_Coverage, 91,
     /*   4137 */     GIR_EraseRootFromParent_Done,
     /*   4138 */   // Label 178: @4138
     /*   4138 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4290), // Rule ID 2654 //
     /*   4143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4174 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4177 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   4182 */     // MIs[2] pattern
     /*   4182 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4185 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4192 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4192 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4195 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4199 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4204 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4206 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4209 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4213 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4218 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4221 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4225 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4228 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4233 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4238 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   4250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4255 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4262 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4272 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4279 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4289 */     // GIR_Coverage, 2654,
     /*   4289 */     GIR_EraseRootFromParent_Done,
     /*   4290 */   // Label 179: @4290
     /*   4290 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4442), // Rule ID 9894 //
     /*   4295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4310 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4314 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4326 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4329 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   4334 */     // MIs[2] pattern
     /*   4334 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4337 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4344 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4344 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4347 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4351 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4358 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4361 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4365 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4370 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4373 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4377 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4380 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4385 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4390 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4395 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4398 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   4402 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4407 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4410 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4414 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4417 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4424 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4441 */     // GIR_Coverage, 9894,
     /*   4441 */     GIR_EraseRootFromParent_Done,
     /*   4442 */   // Label 180: @4442
     /*   4442 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(4594), // Rule ID 9906 //
     /*   4447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4478 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4481 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   4486 */     // MIs[2] pattern
     /*   4486 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4489 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4496 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4496 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4499 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4503 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4510 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4513 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4517 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4522 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4525 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4529 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4532 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4537 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4542 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   4554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4562 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4566 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4576 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4583 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4593 */     // GIR_Coverage, 9906,
     /*   4593 */     GIR_EraseRootFromParent_Done,
     /*   4594 */   // Label 181: @4594
     /*   4594 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(4746), // Rule ID 9918 //
     /*   4599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4630 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4633 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4638 */     // MIs[2] pattern
     /*   4638 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4641 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4646 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4648 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4648 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4651 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4655 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4662 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4665 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4669 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4674 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4677 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4681 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4684 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4689 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4694 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4711 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4714 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4718 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4721 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4728 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4745 */     // GIR_Coverage, 9918,
     /*   4745 */     GIR_EraseRootFromParent_Done,
     /*   4746 */   // Label 182: @4746
     /*   4746 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(4903), // Rule ID 15462 //
     /*   4751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4778 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4781 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   4790 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4792 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4797 */     // MIs[2] pred
     /*   4797 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4808 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   4808 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4811 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4815 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4822 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4825 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4829 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4834 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4837 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   4841 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4844 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4849 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4854 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   4866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4871 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   4875 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4885 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4892 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4902 */     // GIR_Coverage, 15462,
     /*   4902 */     GIR_EraseRootFromParent_Done,
     /*   4903 */   // Label 183: @4903
     /*   4903 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(5060), // Rule ID 15463 //
     /*   4908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4935 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4938 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   4947 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4949 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4954 */     // MIs[2] pred
     /*   4954 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4965 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   4965 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4968 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4972 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4979 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4982 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4986 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4991 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4994 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   4998 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5001 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5006 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5011 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5028 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5032 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5042 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5059 */     // GIR_Coverage, 15463,
     /*   5059 */     GIR_EraseRootFromParent_Done,
     /*   5060 */   // Label 184: @5060
     /*   5060 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(5217), // Rule ID 15464 //
     /*   5065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5092 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5095 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5104 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5111 */     // MIs[2] pred
     /*   5111 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5122 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5122 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5125 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5129 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5136 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5139 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5143 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5148 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5151 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5155 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5158 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5163 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5168 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5185 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5189 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5199 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5216 */     // GIR_Coverage, 15464,
     /*   5216 */     GIR_EraseRootFromParent_Done,
     /*   5217 */   // Label 185: @5217
     /*   5217 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(5374), // Rule ID 15465 //
     /*   5222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5249 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5252 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5257 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5261 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5268 */     // MIs[2] pred
     /*   5268 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5279 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5279 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5282 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5286 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5293 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5296 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5300 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5305 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5308 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5312 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5315 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5320 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5325 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5330 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5333 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   5337 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5342 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5346 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5356 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5363 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5373 */     // GIR_Coverage, 15465,
     /*   5373 */     GIR_EraseRootFromParent_Done,
     /*   5374 */   // Label 186: @5374
     /*   5374 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(5531), // Rule ID 10010 //
     /*   5379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5410 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5413 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5418 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   5422 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5424 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5429 */     // MIs[2] pred
     /*   5429 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5436 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5436 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5439 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5443 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5450 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5453 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5457 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5462 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5465 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5469 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5472 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5477 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5482 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   5494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5499 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5503 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5513 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5525 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5530 */     // GIR_Coverage, 10010,
     /*   5530 */     GIR_EraseRootFromParent_Done,
     /*   5531 */   // Label 187: @5531
     /*   5531 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(5688), // Rule ID 10011 //
     /*   5536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5567 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5570 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5575 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5579 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5586 */     // MIs[2] pred
     /*   5586 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5593 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5593 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5596 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5600 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5605 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5607 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5610 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5614 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5619 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5622 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5626 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5629 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5634 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5639 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5656 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5660 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5663 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5670 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5687 */     // GIR_Coverage, 10011,
     /*   5687 */     GIR_EraseRootFromParent_Done,
     /*   5688 */   // Label 188: @5688
     /*   5688 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(5845), // Rule ID 10012 //
     /*   5693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5724 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5727 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5736 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5743 */     // MIs[2] pred
     /*   5743 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5750 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5750 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5753 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5757 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5764 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5767 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5771 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5776 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5779 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5783 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5786 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5791 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5796 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5813 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5817 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5827 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5839 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5844 */     // GIR_Coverage, 10012,
     /*   5844 */     GIR_EraseRootFromParent_Done,
     /*   5845 */   // Label 189: @5845
     /*   5845 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(6002), // Rule ID 10013 //
     /*   5850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5881 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5884 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5893 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5900 */     // MIs[2] pred
     /*   5900 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5907 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5907 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5910 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5914 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5919 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5921 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5924 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5928 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5933 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5936 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5940 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5943 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5948 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5953 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   5965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5970 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5974 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5984 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5996 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6001 */     // GIR_Coverage, 10013,
     /*   6001 */     GIR_EraseRootFromParent_Done,
     /*   6002 */   // Label 190: @6002
     /*   6002 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(6035), // Rule ID 13139 //
     /*   6007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6011 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6015 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6022 */     // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6029 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6033 */     GIR_RootConstrainSelectedInstOperands,
     /*   6034 */     // GIR_Coverage, 13139,
     /*   6034 */     GIR_EraseRootFromParent_Done,
     /*   6035 */   // Label 191: @6035
     /*   6035 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(6071), // Rule ID 13702 //
     /*   6040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6048 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6055 */     // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6062 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6066 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6069 */     GIR_RootConstrainSelectedInstOperands,
     /*   6070 */     // GIR_Coverage, 13702,
     /*   6070 */     GIR_EraseRootFromParent_Done,
     /*   6071 */   // Label 192: @6071
     /*   6071 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(6104), // Rule ID 97 //
     /*   6076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6084 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6091 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6096 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6098 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6102 */     GIR_RootConstrainSelectedInstOperands,
     /*   6103 */     // GIR_Coverage, 97,
     /*   6103 */     GIR_EraseRootFromParent_Done,
     /*   6104 */   // Label 193: @6104
     /*   6104 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(6140), // Rule ID 3909 //
     /*   6109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6117 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6124 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6131 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6138 */     GIR_RootConstrainSelectedInstOperands,
     /*   6139 */     // GIR_Coverage, 3909,
     /*   6139 */     GIR_EraseRootFromParent_Done,
     /*   6140 */   // Label 194: @6140
     /*   6140 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(6173), // Rule ID 13137 //
     /*   6145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6153 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6160 */     // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6167 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6171 */     GIR_RootConstrainSelectedInstOperands,
     /*   6172 */     // GIR_Coverage, 13137,
     /*   6172 */     GIR_EraseRootFromParent_Done,
     /*   6173 */   // Label 195: @6173
     /*   6173 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(6206), // Rule ID 95 //
     /*   6178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6186 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6193 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6200 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6204 */     GIR_RootConstrainSelectedInstOperands,
     /*   6205 */     // GIR_Coverage, 95,
     /*   6205 */     GIR_EraseRootFromParent_Done,
     /*   6206 */   // Label 196: @6206
     /*   6206 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(6230), // Rule ID 93 //
     /*   6211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6223 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*   6223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
     /*   6228 */     GIR_RootConstrainSelectedInstOperands,
     /*   6229 */     // GIR_Coverage, 93,
     /*   6229 */     GIR_Done,
     /*   6230 */   // Label 197: @6230
     /*   6230 */   GIM_Reject,
     /*   6231 */ // Label 172: @6231
     /*   6231 */ GIM_Reject,
     /*   6232 */ // Label 159: @6232
     /*   6232 */ GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(11827),
     /*   6237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6243 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(6379), // Rule ID 5360 //
     /*   6248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6281 */     // MIs[1] Operand 2
     /*   6281 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6292 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6296 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6300 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6304 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6308 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6312 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6316 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6321 */     // MIs[3] Operand 2
     /*   6321 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6332 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6334 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6346 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6361 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6378 */     // GIR_Coverage, 5360,
     /*   6378 */     GIR_EraseRootFromParent_Done,
     /*   6379 */   // Label 199: @6379
     /*   6379 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(6515), // Rule ID 5359 //
     /*   6384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6417 */     // MIs[1] Operand 2
     /*   6417 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6436 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6440 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6444 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6448 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6452 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6457 */     // MIs[3] Operand 2
     /*   6457 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6468 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6470 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6482 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6486 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6497 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6504 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6509 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6514 */     // GIR_Coverage, 5359,
     /*   6514 */     GIR_EraseRootFromParent_Done,
     /*   6515 */   // Label 200: @6515
     /*   6515 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(6651), // Rule ID 5369 //
     /*   6520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6553 */     // MIs[1] Operand 2
     /*   6553 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6572 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6576 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6580 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6584 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6588 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6593 */     // MIs[3] Operand 2
     /*   6593 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6604 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6606 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*   6613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6633 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6650 */     // GIR_Coverage, 5369,
     /*   6650 */     GIR_EraseRootFromParent_Done,
     /*   6651 */   // Label 201: @6651
     /*   6651 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(6787), // Rule ID 5358 //
     /*   6656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6672 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6676 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6680 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6689 */     // MIs[1] Operand 2
     /*   6689 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6700 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6704 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6708 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6712 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6716 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6720 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6724 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6729 */     // MIs[3] Operand 2
     /*   6729 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6740 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6742 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6762 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6769 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6781 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6786 */     // GIR_Coverage, 5358,
     /*   6786 */     GIR_EraseRootFromParent_Done,
     /*   6787 */   // Label 202: @6787
     /*   6787 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(6923), // Rule ID 5357 //
     /*   6792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6820 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6825 */     // MIs[1] Operand 2
     /*   6825 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6836 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6840 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6844 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6848 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6852 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6856 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6860 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6865 */     // MIs[3] Operand 2
     /*   6865 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6876 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6878 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6890 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6894 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6905 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6917 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6922 */     // GIR_Coverage, 5357,
     /*   6922 */     GIR_EraseRootFromParent_Done,
     /*   6923 */   // Label 203: @6923
     /*   6923 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(6991), // Rule ID 6882 //
     /*   6928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   6940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   6948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6953 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*   6957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   6961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   6965 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   6969 */     // MIs[2] Rn
     /*   6969 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   6974 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*   6978 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   6980 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   6980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   6983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6989 */     GIR_RootConstrainSelectedInstOperands,
     /*   6990 */     // GIR_Coverage, 6882,
     /*   6990 */     GIR_EraseRootFromParent_Done,
     /*   6991 */   // Label 204: @6991
     /*   6991 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(7059), // Rule ID 13863 //
     /*   6996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7021 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   7025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7033 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7037 */     // MIs[2] Rn
     /*   7037 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7042 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*   7046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7048 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7057 */     GIR_RootConstrainSelectedInstOperands,
     /*   7058 */     // GIR_Coverage, 13863,
     /*   7058 */     GIR_EraseRootFromParent_Done,
     /*   7059 */   // Label 205: @7059
     /*   7059 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(7092), // Rule ID 13136 //
     /*   7064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7079 */     // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   7086 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7090 */     GIR_RootConstrainSelectedInstOperands,
     /*   7091 */     // GIR_Coverage, 13136,
     /*   7091 */     GIR_EraseRootFromParent_Done,
     /*   7092 */   // Label 206: @7092
     /*   7092 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(7225), // Rule ID 3961 //
     /*   7097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7134 */     // MIs[2] Operand 2
     /*   7134 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7153 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7157 */     // MIs[3] Operand 1
     /*   7157 */     // No operand predicates
     /*   7157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7161 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7163 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7163 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7166 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7170 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7175 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7180 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7182 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7185 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7189 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7194 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7223 */     GIR_RootConstrainSelectedInstOperands,
     /*   7224 */     // GIR_Coverage, 3961,
     /*   7224 */     GIR_EraseRootFromParent_Done,
     /*   7225 */   // Label 207: @7225
     /*   7225 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(7320), // Rule ID 3959 //
     /*   7230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7258 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7275 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7279 */     // MIs[3] Operand 1
     /*   7279 */     // No operand predicates
     /*   7279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7283 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7285 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7297 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7302 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7318 */     GIR_RootConstrainSelectedInstOperands,
     /*   7319 */     // GIR_Coverage, 3959,
     /*   7319 */     GIR_EraseRootFromParent_Done,
     /*   7320 */   // Label 208: @7320
     /*   7320 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(7415), // Rule ID 3960 //
     /*   7325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7341 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7370 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7374 */     // MIs[3] Operand 1
     /*   7374 */     // No operand predicates
     /*   7374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7380 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7380 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7383 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7387 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7392 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7413 */     GIR_RootConstrainSelectedInstOperands,
     /*   7414 */     // GIR_Coverage, 3960,
     /*   7414 */     GIR_EraseRootFromParent_Done,
     /*   7415 */   // Label 209: @7415
     /*   7415 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(7448), // Rule ID 92 //
     /*   7420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7435 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   7442 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7446 */     GIR_RootConstrainSelectedInstOperands,
     /*   7447 */     // GIR_Coverage, 92,
     /*   7447 */     GIR_EraseRootFromParent_Done,
     /*   7448 */   // Label 210: @7448
     /*   7448 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(7581), // Rule ID 13712 //
     /*   7453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7489 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7494 */     // MIs[2] Operand 2
     /*   7494 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7505 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7509 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7513 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7517 */     // MIs[3] Operand 1
     /*   7517 */     // No operand predicates
     /*   7517 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7519 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7519 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7522 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7526 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7531 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7550 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7579 */     GIR_RootConstrainSelectedInstOperands,
     /*   7580 */     // GIR_Coverage, 13712,
     /*   7580 */     GIR_EraseRootFromParent_Done,
     /*   7581 */   // Label 211: @7581
     /*   7581 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(7676), // Rule ID 13710 //
     /*   7586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7602 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7622 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7631 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7635 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7639 */     // MIs[3] Operand 1
     /*   7639 */     // No operand predicates
     /*   7639 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7641 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7653 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7658 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7674 */     GIR_RootConstrainSelectedInstOperands,
     /*   7675 */     // GIR_Coverage, 13710,
     /*   7675 */     GIR_EraseRootFromParent_Done,
     /*   7676 */   // Label 212: @7676
     /*   7676 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(7771), // Rule ID 13711 //
     /*   7681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7730 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7734 */     // MIs[3] Operand 1
     /*   7734 */     // No operand predicates
     /*   7734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7736 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7748 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7769 */     GIR_RootConstrainSelectedInstOperands,
     /*   7770 */     // GIR_Coverage, 13711,
     /*   7770 */     GIR_EraseRootFromParent_Done,
     /*   7771 */   // Label 213: @7771
     /*   7771 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(7853), // Rule ID 13147 //
     /*   7776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7808 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7821 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7825 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7834 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7836 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7851 */     GIR_RootConstrainSelectedInstOperands,
     /*   7852 */     // GIR_Coverage, 13147,
     /*   7852 */     GIR_EraseRootFromParent_Done,
     /*   7853 */   // Label 214: @7853
     /*   7853 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(7935), // Rule ID 13148 //
     /*   7858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7890 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7903 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7907 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7916 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7918 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7933 */     GIR_RootConstrainSelectedInstOperands,
     /*   7934 */     // GIR_Coverage, 13148,
     /*   7934 */     GIR_EraseRootFromParent_Done,
     /*   7935 */   // Label 215: @7935
     /*   7935 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(8017), // Rule ID 123 //
     /*   7940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7989 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7993 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7998 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8000 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   8003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8015 */     GIR_RootConstrainSelectedInstOperands,
     /*   8016 */     // GIR_Coverage, 123,
     /*   8016 */     GIR_EraseRootFromParent_Done,
     /*   8017 */   // Label 216: @8017
     /*   8017 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(8099), // Rule ID 125 //
     /*   8022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8067 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8071 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8080 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8082 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8095 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8097 */     GIR_RootConstrainSelectedInstOperands,
     /*   8098 */     // GIR_Coverage, 125,
     /*   8098 */     GIR_EraseRootFromParent_Done,
     /*   8099 */   // Label 217: @8099
     /*   8099 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(8157), // Rule ID 13557 //
     /*   8104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8119 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8122 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8127 */     // MIs[1] pattern
     /*   8127 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8130 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8141 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8155 */     GIR_RootConstrainSelectedInstOperands,
     /*   8156 */     // GIR_Coverage, 13557,
     /*   8156 */     GIR_EraseRootFromParent_Done,
     /*   8157 */   // Label 218: @8157
     /*   8157 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(8215), // Rule ID 15414 //
     /*   8162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8177 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8180 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8185 */     // MIs[1] pattern
     /*   8185 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8188 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8199 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8213 */     GIR_RootConstrainSelectedInstOperands,
     /*   8214 */     // GIR_Coverage, 15414,
     /*   8214 */     GIR_EraseRootFromParent_Done,
     /*   8215 */   // Label 219: @8215
     /*   8215 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(8273), // Rule ID 15426 //
     /*   8220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8235 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8238 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8243 */     // MIs[1] pattern
     /*   8243 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8246 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8257 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8271 */     GIR_RootConstrainSelectedInstOperands,
     /*   8272 */     // GIR_Coverage, 15426,
     /*   8272 */     GIR_EraseRootFromParent_Done,
     /*   8273 */   // Label 220: @8273
     /*   8273 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8331), // Rule ID 15438 //
     /*   8278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8293 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8296 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8301 */     // MIs[1] pattern
     /*   8301 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8304 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8315 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8329 */     GIR_RootConstrainSelectedInstOperands,
     /*   8330 */     // GIR_Coverage, 15438,
     /*   8330 */     GIR_EraseRootFromParent_Done,
     /*   8331 */   // Label 221: @8331
     /*   8331 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8389), // Rule ID 2651 //
     /*   8336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8355 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8358 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8363 */     // MIs[1] pattern
     /*   8363 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8366 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8373 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8387 */     GIR_RootConstrainSelectedInstOperands,
     /*   8388 */     // GIR_Coverage, 2651,
     /*   8388 */     GIR_EraseRootFromParent_Done,
     /*   8389 */   // Label 222: @8389
     /*   8389 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(8447), // Rule ID 9891 //
     /*   8394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8413 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8416 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8421 */     // MIs[1] pattern
     /*   8421 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8424 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8431 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8445 */     GIR_RootConstrainSelectedInstOperands,
     /*   8446 */     // GIR_Coverage, 9891,
     /*   8446 */     GIR_EraseRootFromParent_Done,
     /*   8447 */   // Label 223: @8447
     /*   8447 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(8505), // Rule ID 9903 //
     /*   8452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8471 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8474 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8479 */     // MIs[1] pattern
     /*   8479 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8482 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8487 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8489 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8503 */     GIR_RootConstrainSelectedInstOperands,
     /*   8504 */     // GIR_Coverage, 9903,
     /*   8504 */     GIR_EraseRootFromParent_Done,
     /*   8505 */   // Label 224: @8505
     /*   8505 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(8563), // Rule ID 9915 //
     /*   8510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8529 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8532 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8537 */     // MIs[1] pattern
     /*   8537 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8540 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8547 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8552 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8561 */     GIR_RootConstrainSelectedInstOperands,
     /*   8562 */     // GIR_Coverage, 9915,
     /*   8562 */     GIR_EraseRootFromParent_Done,
     /*   8563 */   // Label 225: @8563
     /*   8563 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(8726), // Rule ID 13829 //
     /*   8568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   8592 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8600 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8605 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8610 */     // MIs[1] Operand 2
     /*   8610 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8627 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8627 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8630 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8634 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8641 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8644 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8648 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8653 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8656 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8660 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8663 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8668 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8673 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   8685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8690 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8693 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8697 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8708 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8725 */     // GIR_Coverage, 13829,
     /*   8725 */     GIR_EraseRootFromParent_Done,
     /*   8726 */   // Label 226: @8726
     /*   8726 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(8889), // Rule ID 13826 //
     /*   8731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   8755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   8763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8768 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8773 */     // MIs[1] Operand 2
     /*   8773 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8790 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8790 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8793 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8797 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8804 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8807 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8811 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8816 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8819 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   8823 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8826 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8831 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8836 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   8848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8853 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   8856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8860 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   8864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   8866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   8871 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   8878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8888 */     // GIR_Coverage, 13826,
     /*   8888 */     GIR_EraseRootFromParent_Done,
     /*   8889 */   // Label 227: @8889
     /*   8889 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(9039), // Rule ID 13835 //
     /*   8894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   8906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   8910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   8922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8927 */     // MIs[1] Operand 2
     /*   8927 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   8938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8944 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   8944 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   8947 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8951 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8956 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   8958 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   8961 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   8965 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8970 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   8973 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   8977 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   8980 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8985 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   8990 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   8995 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   8998 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9002 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9007 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9010 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9021 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9038 */     // GIR_Coverage, 13835,
     /*   9038 */     GIR_EraseRootFromParent_Done,
     /*   9039 */   // Label 228: @9039
     /*   9039 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(9189), // Rule ID 13838 //
     /*   9044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9072 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9077 */     // MIs[1] Operand 2
     /*   9077 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9094 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9094 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9097 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9101 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9108 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9111 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9115 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9120 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9123 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9127 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9130 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9135 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9140 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9157 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9160 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9171 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9183 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9188 */     // GIR_Coverage, 13838,
     /*   9188 */     GIR_EraseRootFromParent_Done,
     /*   9189 */   // Label 229: @9189
     /*   9189 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(9339), // Rule ID 13834 //
     /*   9194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9227 */     // MIs[1] Operand 2
     /*   9227 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9244 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9244 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9247 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9251 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9258 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9261 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9265 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9270 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9273 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9277 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9280 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9285 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9290 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9307 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9310 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9321 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9338 */     // GIR_Coverage, 13834,
     /*   9338 */     GIR_EraseRootFromParent_Done,
     /*   9339 */   // Label 230: @9339
     /*   9339 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(9502), // Rule ID 5342 //
     /*   9344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   9372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9385 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9390 */     // MIs[1] Operand 2
     /*   9390 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9403 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9403 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9406 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9410 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9417 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9420 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9424 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9429 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9432 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9436 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9439 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9444 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9449 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   9461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9466 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9469 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9473 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9484 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9496 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9501 */     // GIR_Coverage, 5342,
     /*   9501 */     GIR_EraseRootFromParent_Done,
     /*   9502 */   // Label 231: @9502
     /*   9502 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(9665), // Rule ID 5339 //
     /*   9507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9511 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   9535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9553 */     // MIs[1] Operand 2
     /*   9553 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9566 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9566 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9569 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9573 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9578 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9580 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9583 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9587 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9592 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9595 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9599 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9602 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9607 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9612 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   9624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9629 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9632 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9636 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9647 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9654 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9659 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9664 */     // GIR_Coverage, 5339,
     /*   9664 */     GIR_EraseRootFromParent_Done,
     /*   9665 */   // Label 232: @9665
     /*   9665 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(9815), // Rule ID 5366 //
     /*   9670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9707 */     // MIs[1] Operand 2
     /*   9707 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9720 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9720 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9723 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9727 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9734 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9737 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9741 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9746 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9749 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9753 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9756 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9761 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9766 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9783 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9786 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9797 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9814 */     // GIR_Coverage, 5366,
     /*   9814 */     GIR_EraseRootFromParent_Done,
     /*   9815 */   // Label 233: @9815
     /*   9815 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(9965), // Rule ID 5372 //
     /*   9820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9857 */     // MIs[1] Operand 2
     /*   9857 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9868 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9870 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9870 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9873 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9877 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9884 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9887 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9891 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9896 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9899 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   9903 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9906 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9911 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9916 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9933 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9936 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9947 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9954 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9959 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9964 */     // GIR_Coverage, 5372,
     /*   9964 */     GIR_EraseRootFromParent_Done,
     /*   9965 */   // Label 234: @9965
     /*   9965 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10115), // Rule ID 5365 //
     /*   9970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10007 */     // MIs[1] Operand 2
     /*  10007 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10020 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10020 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10023 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10027 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10034 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10037 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10041 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10046 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10049 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10053 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10056 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10061 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10066 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  10078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10083 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10086 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10090 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10097 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10104 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10109 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10114 */     // GIR_Coverage, 5365,
     /*  10114 */     GIR_EraseRootFromParent_Done,
     /*  10115 */   // Label 235: @10115
     /*  10115 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10148), // Rule ID 13140 //
     /*  10120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10135 */     // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10146 */     GIR_RootConstrainSelectedInstOperands,
     /*  10147 */     // GIR_Coverage, 13140,
     /*  10147 */     GIR_EraseRootFromParent_Done,
     /*  10148 */   // Label 236: @10148
     /*  10148 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10184), // Rule ID 13703 //
     /*  10153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10168 */     // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10175 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10179 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10182 */     GIR_RootConstrainSelectedInstOperands,
     /*  10183 */     // GIR_Coverage, 13703,
     /*  10183 */     GIR_EraseRootFromParent_Done,
     /*  10184 */   // Label 237: @10184
     /*  10184 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10217), // Rule ID 98 //
     /*  10189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10204 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10211 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10215 */     GIR_RootConstrainSelectedInstOperands,
     /*  10216 */     // GIR_Coverage, 98,
     /*  10216 */     GIR_EraseRootFromParent_Done,
     /*  10217 */   // Label 238: @10217
     /*  10217 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10253), // Rule ID 3910 //
     /*  10222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10230 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10237 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10242 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10244 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10251 */     GIR_RootConstrainSelectedInstOperands,
     /*  10252 */     // GIR_Coverage, 3910,
     /*  10252 */     GIR_EraseRootFromParent_Done,
     /*  10253 */   // Label 239: @10253
     /*  10253 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10286), // Rule ID 13138 //
     /*  10258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10266 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10273 */     // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10280 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10284 */     GIR_RootConstrainSelectedInstOperands,
     /*  10285 */     // GIR_Coverage, 13138,
     /*  10285 */     GIR_EraseRootFromParent_Done,
     /*  10286 */   // Label 240: @10286
     /*  10286 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10349), // Rule ID 15454 //
     /*  10291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10306 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10309 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10318 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10325 */     // MIs[1] pred
     /*  10325 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10336 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10347 */     GIR_RootConstrainSelectedInstOperands,
     /*  10348 */     // GIR_Coverage, 15454,
     /*  10348 */     GIR_EraseRootFromParent_Done,
     /*  10349 */   // Label 241: @10349
     /*  10349 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10412), // Rule ID 15455 //
     /*  10354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10369 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10372 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10381 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10388 */     // MIs[1] pred
     /*  10388 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10399 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10410 */     GIR_RootConstrainSelectedInstOperands,
     /*  10411 */     // GIR_Coverage, 15455,
     /*  10411 */     GIR_EraseRootFromParent_Done,
     /*  10412 */   // Label 242: @10412
     /*  10412 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10475), // Rule ID 15456 //
     /*  10417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10432 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10435 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10444 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10451 */     // MIs[1] pred
     /*  10451 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10462 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10473 */     GIR_RootConstrainSelectedInstOperands,
     /*  10474 */     // GIR_Coverage, 15456,
     /*  10474 */     GIR_EraseRootFromParent_Done,
     /*  10475 */   // Label 243: @10475
     /*  10475 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(10538), // Rule ID 15457 //
     /*  10480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10495 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10498 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10507 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10514 */     // MIs[1] pred
     /*  10514 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10525 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10536 */     GIR_RootConstrainSelectedInstOperands,
     /*  10537 */     // GIR_Coverage, 15457,
     /*  10537 */     GIR_EraseRootFromParent_Done,
     /*  10538 */   // Label 244: @10538
     /*  10538 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(10571), // Rule ID 96 //
     /*  10543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10551 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10558 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10563 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10565 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10569 */     GIR_RootConstrainSelectedInstOperands,
     /*  10570 */     // GIR_Coverage, 96,
     /*  10570 */     GIR_EraseRootFromParent_Done,
     /*  10571 */   // Label 245: @10571
     /*  10571 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(10634), // Rule ID 10002 //
     /*  10576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10583 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10595 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10598 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10607 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10614 */     // MIs[1] pred
     /*  10614 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10621 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  10624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10632 */     GIR_RootConstrainSelectedInstOperands,
     /*  10633 */     // GIR_Coverage, 10002,
     /*  10633 */     GIR_EraseRootFromParent_Done,
     /*  10634 */   // Label 246: @10634
     /*  10634 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(10697), // Rule ID 10003 //
     /*  10639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10658 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10661 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  10670 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10677 */     // MIs[1] pred
     /*  10677 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10684 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  10687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10693 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10695 */     GIR_RootConstrainSelectedInstOperands,
     /*  10696 */     // GIR_Coverage, 10003,
     /*  10696 */     GIR_EraseRootFromParent_Done,
     /*  10697 */   // Label 247: @10697
     /*  10697 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(10760), // Rule ID 10004 //
     /*  10702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10721 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10724 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  10733 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10740 */     // MIs[1] pred
     /*  10740 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10747 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  10750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10758 */     GIR_RootConstrainSelectedInstOperands,
     /*  10759 */     // GIR_Coverage, 10004,
     /*  10759 */     GIR_EraseRootFromParent_Done,
     /*  10760 */   // Label 248: @10760
     /*  10760 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(10823), // Rule ID 10005 //
     /*  10765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10784 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10787 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  10796 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10803 */     // MIs[1] pred
     /*  10803 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10810 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  10810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  10813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  10815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  10819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10821 */     GIR_RootConstrainSelectedInstOperands,
     /*  10822 */     // GIR_Coverage, 10005,
     /*  10822 */     GIR_EraseRootFromParent_Done,
     /*  10823 */   // Label 249: @10823
     /*  10823 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(10879), // Rule ID 13246 //
     /*  10828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10843 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10846 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  10851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10866 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  10869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10877 */     GIR_RootConstrainSelectedInstOperands,
     /*  10878 */     // GIR_Coverage, 13246,
     /*  10878 */     GIR_EraseRootFromParent_Done,
     /*  10879 */   // Label 250: @10879
     /*  10879 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(10935), // Rule ID 13258 //
     /*  10884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10899 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  10902 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  10907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  10911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10922 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  10922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  10925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  10933 */     GIR_RootConstrainSelectedInstOperands,
     /*  10934 */     // GIR_Coverage, 13258,
     /*  10934 */     GIR_EraseRootFromParent_Done,
     /*  10935 */   // Label 251: @10935
     /*  10935 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11002), // Rule ID 13464 //
     /*  10940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  10955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  10959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10964 */     // MIs[1] imm
     /*  10964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  10968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10972 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  10976 */     // MIs[2] Operand 1
     /*  10976 */     // No operand predicates
     /*  10976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10980 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  10984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10986 */     // (add:{ *:[i64] } (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  10989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  10993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11000 */     GIR_RootConstrainSelectedInstOperands,
     /*  11001 */     // GIR_Coverage, 13464,
     /*  11001 */     GIR_EraseRootFromParent_Done,
     /*  11002 */   // Label 252: @11002
     /*  11002 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11069), // Rule ID 13852 //
     /*  11007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11031 */     // MIs[1] imm
     /*  11031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11039 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11043 */     // MIs[2] Operand 1
     /*  11043 */     // No operand predicates
     /*  11043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11047 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11053 */     // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  11053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11064 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11067 */     GIR_RootConstrainSelectedInstOperands,
     /*  11068 */     // GIR_Coverage, 13852,
     /*  11068 */     GIR_EraseRootFromParent_Done,
     /*  11069 */   // Label 253: @11069
     /*  11069 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11136), // Rule ID 13467 //
     /*  11074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11098 */     // MIs[1] imm
     /*  11098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11106 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11110 */     // MIs[2] Operand 1
     /*  11110 */     // No operand predicates
     /*  11110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11114 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11120 */     // (add:{ *:[i64] } (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11134 */     GIR_RootConstrainSelectedInstOperands,
     /*  11135 */     // GIR_Coverage, 13467,
     /*  11135 */     GIR_EraseRootFromParent_Done,
     /*  11136 */   // Label 254: @11136
     /*  11136 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11203), // Rule ID 13855 //
     /*  11141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11165 */     // MIs[1] imm
     /*  11165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11173 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11177 */     // MIs[2] Operand 1
     /*  11177 */     // No operand predicates
     /*  11177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11181 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11187 */     // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  11187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11198 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11201 */     GIR_RootConstrainSelectedInstOperands,
     /*  11202 */     // GIR_Coverage, 13855,
     /*  11202 */     GIR_EraseRootFromParent_Done,
     /*  11203 */   // Label 255: @11203
     /*  11203 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11259), // Rule ID 997 //
     /*  11208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11227 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11230 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  11235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11246 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11251 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11257 */     GIR_RootConstrainSelectedInstOperands,
     /*  11258 */     // GIR_Coverage, 997,
     /*  11258 */     GIR_EraseRootFromParent_Done,
     /*  11259 */   // Label 256: @11259
     /*  11259 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11315), // Rule ID 1058 //
     /*  11264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11283 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11286 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  11291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11302 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11307 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11313 */     GIR_RootConstrainSelectedInstOperands,
     /*  11314 */     // GIR_Coverage, 1058,
     /*  11314 */     GIR_EraseRootFromParent_Done,
     /*  11315 */   // Label 257: @11315
     /*  11315 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11382), // Rule ID 2119 //
     /*  11320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11348 */     // MIs[1] imm
     /*  11348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11356 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11360 */     // MIs[2] Operand 1
     /*  11360 */     // No operand predicates
     /*  11360 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11366 */     // (add:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11380 */     GIR_RootConstrainSelectedInstOperands,
     /*  11381 */     // GIR_Coverage, 2119,
     /*  11381 */     GIR_EraseRootFromParent_Done,
     /*  11382 */   // Label 258: @11382
     /*  11382 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11449), // Rule ID 6260 //
     /*  11387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11415 */     // MIs[1] imm
     /*  11415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11423 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11427 */     // MIs[2] Operand 1
     /*  11427 */     // No operand predicates
     /*  11427 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11433 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  11433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11447 */     GIR_RootConstrainSelectedInstOperands,
     /*  11448 */     // GIR_Coverage, 6260,
     /*  11448 */     GIR_EraseRootFromParent_Done,
     /*  11449 */   // Label 259: @11449
     /*  11449 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11516), // Rule ID 2128 //
     /*  11454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11482 */     // MIs[1] imm
     /*  11482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11490 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11494 */     // MIs[2] Operand 1
     /*  11494 */     // No operand predicates
     /*  11494 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11500 */     // (add:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11514 */     GIR_RootConstrainSelectedInstOperands,
     /*  11515 */     // GIR_Coverage, 2128,
     /*  11515 */     GIR_EraseRootFromParent_Done,
     /*  11516 */   // Label 260: @11516
     /*  11516 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(11583), // Rule ID 6266 //
     /*  11521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11549 */     // MIs[1] imm
     /*  11549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11557 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11561 */     // MIs[2] Operand 1
     /*  11561 */     // No operand predicates
     /*  11561 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11565 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11567 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  11567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11581 */     GIR_RootConstrainSelectedInstOperands,
     /*  11582 */     // GIR_Coverage, 6266,
     /*  11582 */     GIR_EraseRootFromParent_Done,
     /*  11583 */   // Label 261: @11583
     /*  11583 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(11631), // Rule ID 13245 //
     /*  11588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11618 */     // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11629 */     GIR_RootConstrainSelectedInstOperands,
     /*  11630 */     // GIR_Coverage, 13245,
     /*  11630 */     GIR_EraseRootFromParent_Done,
     /*  11631 */   // Label 262: @11631
     /*  11631 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(11679), // Rule ID 13257 //
     /*  11636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11666 */     // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11677 */     GIR_RootConstrainSelectedInstOperands,
     /*  11678 */     // GIR_Coverage, 13257,
     /*  11678 */     GIR_EraseRootFromParent_Done,
     /*  11679 */   // Label 263: @11679
     /*  11679 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(11727), // Rule ID 996 //
     /*  11684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  11703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11714 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11719 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11725 */     GIR_RootConstrainSelectedInstOperands,
     /*  11726 */     // GIR_Coverage, 996,
     /*  11726 */     GIR_EraseRootFromParent_Done,
     /*  11727 */   // Label 264: @11727
     /*  11727 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(11775), // Rule ID 1057 //
     /*  11732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  11751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11762 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11773 */     GIR_RootConstrainSelectedInstOperands,
     /*  11774 */     // GIR_Coverage, 1057,
     /*  11774 */     GIR_EraseRootFromParent_Done,
     /*  11775 */   // Label 265: @11775
     /*  11775 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(11799), // Rule ID 94 //
     /*  11780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11792 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  11792 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
     /*  11797 */     GIR_RootConstrainSelectedInstOperands,
     /*  11798 */     // GIR_Coverage, 94,
     /*  11798 */     GIR_Done,
     /*  11799 */   // Label 266: @11799
     /*  11799 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(11826), // Rule ID 1607 //
     /*  11804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11819 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  11819 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
     /*  11824 */     GIR_RootConstrainSelectedInstOperands,
     /*  11825 */     // GIR_Coverage, 1607,
     /*  11825 */     GIR_Done,
     /*  11826 */   // Label 267: @11826
     /*  11826 */   GIM_Reject,
     /*  11827 */ // Label 198: @11827
     /*  11827 */ GIM_Reject,
     /*  11828 */ // Label 160: @11828
     /*  11828 */ GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(15435),
     /*  11833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11839 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12027), // Rule ID 6903 //
     /*  11844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  11856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  11868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  11881 */     // MIs[2] Operand 2
     /*  11881 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  11892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  11896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11900 */     // MIs[3] Rn
     /*  11900 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11905 */     // MIs[3] Operand 2
     /*  11905 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  11916 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  11920 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
     /*  11924 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11928 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11932 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  11936 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11940 */     // MIs[5] Rn
     /*  11940 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11945 */     // MIs[5] Operand 2
     /*  11945 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  11956 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  11960 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  11964 */     // MIs[6] Rn
     /*  11964 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  11969 */     // MIs[6] Operand 2
     /*  11969 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  11980 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  11982 */     // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  11982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  11985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  11989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  11994 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  11998 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12002 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12009 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12016 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12021 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12026 */     // GIR_Coverage, 6903,
     /*  12026 */     GIR_EraseRootFromParent_Done,
     /*  12027 */   // Label 269: @12027
     /*  12027 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12215), // Rule ID 13874 //
     /*  12032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  12044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12069 */     // MIs[2] Operand 2
     /*  12069 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  12080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  12084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12088 */     // MIs[3] Rn
     /*  12088 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12093 */     // MIs[3] Operand 2
     /*  12093 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  12104 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  12108 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
     /*  12112 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12116 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12120 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  12124 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12128 */     // MIs[5] Rn
     /*  12128 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12133 */     // MIs[5] Operand 2
     /*  12133 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  12144 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  12148 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12152 */     // MIs[6] Rn
     /*  12152 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12157 */     // MIs[6] Operand 2
     /*  12157 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  12168 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12170 */     // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  12170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  12173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  12177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12182 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12186 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12197 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12214 */     // GIR_Coverage, 13874,
     /*  12214 */     GIR_EraseRootFromParent_Done,
     /*  12215 */   // Label 270: @12215
     /*  12215 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12351), // Rule ID 5356 //
     /*  12220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12248 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12253 */     // MIs[1] Operand 2
     /*  12253 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12272 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12276 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12280 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12284 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12288 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12293 */     // MIs[3] Operand 2
     /*  12293 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12304 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12306 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12318 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12322 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12333 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12345 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12350 */     // GIR_Coverage, 5356,
     /*  12350 */     GIR_EraseRootFromParent_Done,
     /*  12351 */   // Label 271: @12351
     /*  12351 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12487), // Rule ID 5355 //
     /*  12356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12384 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12389 */     // MIs[1] Operand 2
     /*  12389 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12404 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12408 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12416 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12420 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12424 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12429 */     // MIs[3] Operand 2
     /*  12429 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12440 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12442 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12454 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12458 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12462 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12469 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12486 */     // GIR_Coverage, 5355,
     /*  12486 */     GIR_EraseRootFromParent_Done,
     /*  12487 */   // Label 272: @12487
     /*  12487 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12623), // Rule ID 5368 //
     /*  12492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12520 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12525 */     // MIs[1] Operand 2
     /*  12525 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12544 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12548 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12552 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12556 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12560 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12565 */     // MIs[3] Operand 2
     /*  12565 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12576 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12578 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  12585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12594 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12605 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12612 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12622 */     // GIR_Coverage, 5368,
     /*  12622 */     GIR_EraseRootFromParent_Done,
     /*  12623 */   // Label 273: @12623
     /*  12623 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(12759), // Rule ID 5354 //
     /*  12628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12661 */     // MIs[1] Operand 2
     /*  12661 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12680 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12684 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12688 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12692 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12696 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12701 */     // MIs[3] Operand 2
     /*  12701 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12712 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12714 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12726 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12741 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12748 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12758 */     // GIR_Coverage, 5354,
     /*  12758 */     GIR_EraseRootFromParent_Done,
     /*  12759 */   // Label 274: @12759
     /*  12759 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(12895), // Rule ID 5353 //
     /*  12764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12792 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12797 */     // MIs[1] Operand 2
     /*  12797 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12808 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12812 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12816 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12820 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12824 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12828 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12832 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12837 */     // MIs[3] Operand 2
     /*  12837 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12848 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12850 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12862 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12866 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12877 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12884 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12889 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12894 */     // GIR_Coverage, 5353,
     /*  12894 */     GIR_EraseRootFromParent_Done,
     /*  12895 */   // Label 275: @12895
     /*  12895 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13058), // Rule ID 13828 //
     /*  12900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  12924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  12932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12937 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12942 */     // MIs[1] Operand 2
     /*  12942 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12959 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12959 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  12962 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12966 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12971 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  12973 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  12976 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  12980 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12985 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  12988 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  12992 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  12995 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13000 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13005 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  13017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13022 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13025 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13040 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13057 */     // GIR_Coverage, 13828,
     /*  13057 */     GIR_EraseRootFromParent_Done,
     /*  13058 */   // Label 276: @13058
     /*  13058 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13221), // Rule ID 13825 //
     /*  13063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  13087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13091 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13105 */     // MIs[1] Operand 2
     /*  13105 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13122 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13122 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13125 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13129 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13136 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13139 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13143 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13148 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13151 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  13155 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13158 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13163 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13168 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  13180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13185 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13188 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13192 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13203 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13210 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13215 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13220 */     // GIR_Coverage, 13825,
     /*  13220 */     GIR_EraseRootFromParent_Done,
     /*  13221 */   // Label 277: @13221
     /*  13221 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(13371), // Rule ID 13833 //
     /*  13226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13259 */     // MIs[1] Operand 2
     /*  13259 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13276 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13276 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13279 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13283 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13288 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13290 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13293 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13297 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13302 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13305 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13309 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13312 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13317 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13322 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13339 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13342 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13353 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13365 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13370 */     // GIR_Coverage, 13833,
     /*  13370 */     GIR_EraseRootFromParent_Done,
     /*  13371 */   // Label 278: @13371
     /*  13371 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(13521), // Rule ID 13837 //
     /*  13376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13400 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13409 */     // MIs[1] Operand 2
     /*  13409 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13426 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13426 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13429 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13433 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13438 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13440 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13443 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13447 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13452 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13455 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13459 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13462 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13467 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13472 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  13484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13489 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13492 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13496 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13503 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13510 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13515 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13520 */     // GIR_Coverage, 13837,
     /*  13520 */     GIR_EraseRootFromParent_Done,
     /*  13521 */   // Label 279: @13521
     /*  13521 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(13671), // Rule ID 13832 //
     /*  13526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13554 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13559 */     // MIs[1] Operand 2
     /*  13559 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13574 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13576 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13576 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13579 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13583 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13590 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13593 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13597 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13602 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13605 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13609 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13612 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13617 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13622 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13639 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13642 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13653 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13670 */     // GIR_Coverage, 13832,
     /*  13670 */     GIR_EraseRootFromParent_Done,
     /*  13671 */   // Label 280: @13671
     /*  13671 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(13834), // Rule ID 5341 //
     /*  13676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  13704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13708 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13712 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13717 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13722 */     // MIs[1] Operand 2
     /*  13722 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13733 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13735 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13735 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13738 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13742 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13749 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13752 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13756 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13761 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13764 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13768 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13771 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13776 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13781 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13786 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13789 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  13793 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13798 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13801 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13805 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13816 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13823 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13833 */     // GIR_Coverage, 5341,
     /*  13833 */     GIR_EraseRootFromParent_Done,
     /*  13834 */   // Label 281: @13834
     /*  13834 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(13997), // Rule ID 5338 //
     /*  13839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  13867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13871 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13885 */     // MIs[1] Operand 2
     /*  13885 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13898 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13898 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13901 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13905 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13912 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13915 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13919 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13924 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13927 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  13931 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13934 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13939 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13944 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  13956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13961 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13964 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13968 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13979 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13986 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13991 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13996 */     // GIR_Coverage, 5338,
     /*  13996 */     GIR_EraseRootFromParent_Done,
     /*  13997 */   // Label 282: @13997
     /*  13997 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(14147), // Rule ID 5364 //
     /*  14002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  14030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14034 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14039 */     // MIs[1] Operand 2
     /*  14039 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14052 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14052 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14055 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14059 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14064 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14066 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14069 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14073 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14078 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14081 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14085 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14088 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14093 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14098 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14115 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14118 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14122 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14129 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14141 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14146 */     // GIR_Coverage, 5364,
     /*  14146 */     GIR_EraseRootFromParent_Done,
     /*  14147 */   // Label 283: @14147
     /*  14147 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(14297), // Rule ID 5371 //
     /*  14152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  14180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14189 */     // MIs[1] Operand 2
     /*  14189 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14202 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14202 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14205 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14209 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14216 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14219 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14223 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14228 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14231 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14235 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14238 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14243 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14248 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  14260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14265 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14268 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14279 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14286 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14291 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14296 */     // GIR_Coverage, 5371,
     /*  14296 */     GIR_EraseRootFromParent_Done,
     /*  14297 */   // Label 284: @14297
     /*  14297 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(14447), // Rule ID 5363 //
     /*  14302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14322 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14326 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14330 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14334 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14339 */     // MIs[1] Operand 2
     /*  14339 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14352 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14352 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14355 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14359 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14366 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14369 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14373 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14378 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14381 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14385 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14388 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14393 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14398 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14415 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14418 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14429 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14446 */     // GIR_Coverage, 5363,
     /*  14446 */     GIR_EraseRootFromParent_Done,
     /*  14447 */   // Label 285: @14447
     /*  14447 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(14516), // Rule ID 13280 //
     /*  14452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14467 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14470 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14479 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14499 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14514 */     GIR_RootConstrainSelectedInstOperands,
     /*  14515 */     // GIR_Coverage, 13280,
     /*  14515 */     GIR_EraseRootFromParent_Done,
     /*  14516 */   // Label 286: @14516
     /*  14516 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(14585), // Rule ID 13292 //
     /*  14521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14536 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14539 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14548 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14568 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14583 */     GIR_RootConstrainSelectedInstOperands,
     /*  14584 */     // GIR_Coverage, 13292,
     /*  14584 */     GIR_EraseRootFromParent_Done,
     /*  14585 */   // Label 287: @14585
     /*  14585 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(14641), // Rule ID 13242 //
     /*  14590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14605 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14608 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  14613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14628 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  14631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14639 */     GIR_RootConstrainSelectedInstOperands,
     /*  14640 */     // GIR_Coverage, 13242,
     /*  14640 */     GIR_EraseRootFromParent_Done,
     /*  14641 */   // Label 288: @14641
     /*  14641 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(14697), // Rule ID 13254 //
     /*  14646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14661 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14664 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  14669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14684 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  14684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  14687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14695 */     GIR_RootConstrainSelectedInstOperands,
     /*  14696 */     // GIR_Coverage, 13254,
     /*  14696 */     GIR_EraseRootFromParent_Done,
     /*  14697 */   // Label 289: @14697
     /*  14697 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(14764), // Rule ID 13484 //
     /*  14702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  14717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14726 */     // MIs[1] imm
     /*  14726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14734 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14738 */     // MIs[2] Operand 1
     /*  14738 */     // No operand predicates
     /*  14738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14742 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14748 */     // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  14751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14762 */     GIR_RootConstrainSelectedInstOperands,
     /*  14763 */     // GIR_Coverage, 13484,
     /*  14763 */     GIR_EraseRootFromParent_Done,
     /*  14764 */   // Label 290: @14764
     /*  14764 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(14831), // Rule ID 13505 //
     /*  14769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  14784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14793 */     // MIs[1] imm
     /*  14793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  14797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  14801 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  14805 */     // MIs[2] Operand 1
     /*  14805 */     // No operand predicates
     /*  14805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14809 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  14813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14815 */     // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  14815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  14818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  14829 */     GIR_RootConstrainSelectedInstOperands,
     /*  14830 */     // GIR_Coverage, 13505,
     /*  14830 */     GIR_EraseRootFromParent_Done,
     /*  14831 */   // Label 291: @14831
     /*  14831 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(14900), // Rule ID 1365 //
     /*  14836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14843 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14855 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14858 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14867 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14883 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14898 */     GIR_RootConstrainSelectedInstOperands,
     /*  14899 */     // GIR_Coverage, 1365,
     /*  14899 */     GIR_EraseRootFromParent_Done,
     /*  14900 */   // Label 292: @14900
     /*  14900 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(14969), // Rule ID 1488 //
     /*  14905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14924 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14927 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14936 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14950 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14952 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  14959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14967 */     GIR_RootConstrainSelectedInstOperands,
     /*  14968 */     // GIR_Coverage, 1488,
     /*  14968 */     GIR_EraseRootFromParent_Done,
     /*  14969 */   // Label 293: @14969
     /*  14969 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(15025), // Rule ID 993 //
     /*  14974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14993 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  14996 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  15001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  15005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15010 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15012 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15017 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15023 */     GIR_RootConstrainSelectedInstOperands,
     /*  15024 */     // GIR_Coverage, 993,
     /*  15024 */     GIR_EraseRootFromParent_Done,
     /*  15025 */   // Label 294: @15025
     /*  15025 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(15081), // Rule ID 1054 //
     /*  15030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15049 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  15052 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  15057 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  15061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15068 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15079 */     GIR_RootConstrainSelectedInstOperands,
     /*  15080 */     // GIR_Coverage, 1054,
     /*  15080 */     GIR_EraseRootFromParent_Done,
     /*  15081 */   // Label 295: @15081
     /*  15081 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(15148), // Rule ID 2236 //
     /*  15086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  15105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15114 */     // MIs[1] imm
     /*  15114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15122 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  15126 */     // MIs[2] Operand 1
     /*  15126 */     // No operand predicates
     /*  15126 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  15130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15132 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  15132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  15135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15146 */     GIR_RootConstrainSelectedInstOperands,
     /*  15147 */     // GIR_Coverage, 2236,
     /*  15147 */     GIR_EraseRootFromParent_Done,
     /*  15148 */   // Label 296: @15148
     /*  15148 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(15215), // Rule ID 2295 //
     /*  15153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  15172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15181 */     // MIs[1] imm
     /*  15181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15189 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  15193 */     // MIs[2] Operand 1
     /*  15193 */     // No operand predicates
     /*  15193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  15197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15199 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  15199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  15202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15213 */     GIR_RootConstrainSelectedInstOperands,
     /*  15214 */     // GIR_Coverage, 2295,
     /*  15214 */     GIR_EraseRootFromParent_Done,
     /*  15215 */   // Label 297: @15215
     /*  15215 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(15263), // Rule ID 13241 //
     /*  15220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15250 */     // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15261 */     GIR_RootConstrainSelectedInstOperands,
     /*  15262 */     // GIR_Coverage, 13241,
     /*  15262 */     GIR_EraseRootFromParent_Done,
     /*  15263 */   // Label 298: @15263
     /*  15263 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(15311), // Rule ID 13253 //
     /*  15268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15298 */     // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15309 */     GIR_RootConstrainSelectedInstOperands,
     /*  15310 */     // GIR_Coverage, 13253,
     /*  15310 */     GIR_EraseRootFromParent_Done,
     /*  15311 */   // Label 299: @15311
     /*  15311 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(15359), // Rule ID 992 //
     /*  15316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15346 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15351 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15357 */     GIR_RootConstrainSelectedInstOperands,
     /*  15358 */     // GIR_Coverage, 992,
     /*  15358 */     GIR_EraseRootFromParent_Done,
     /*  15359 */   // Label 300: @15359
     /*  15359 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(15407), // Rule ID 1053 //
     /*  15364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15394 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15399 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15405 */     GIR_RootConstrainSelectedInstOperands,
     /*  15406 */     // GIR_Coverage, 1053,
     /*  15406 */     GIR_EraseRootFromParent_Done,
     /*  15407 */   // Label 301: @15407
     /*  15407 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(15434), // Rule ID 1104 //
     /*  15412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15427 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
     /*  15432 */     GIR_RootConstrainSelectedInstOperands,
     /*  15433 */     // GIR_Coverage, 1104,
     /*  15433 */     GIR_Done,
     /*  15434 */   // Label 302: @15434
     /*  15434 */   GIM_Reject,
     /*  15435 */ // Label 268: @15435
     /*  15435 */ GIM_Reject,
     /*  15436 */ // Label 161: @15436
     /*  15436 */ GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(21337),
     /*  15441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  15444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  15447 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(15565), // Rule ID 13419 //
     /*  15452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15459 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15463 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15467 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15487 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15491 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15495 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15499 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15503 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15508 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15512 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15516 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15520 */     // MIs[4] Operand 1
     /*  15520 */     // No operand predicates
     /*  15520 */     // MIs[2] Operand 2
     /*  15520 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15535 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15537 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15544 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15560 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15563 */     GIR_RootConstrainSelectedInstOperands,
     /*  15564 */     // GIR_Coverage, 13419,
     /*  15564 */     GIR_EraseRootFromParent_Done,
     /*  15565 */   // Label 304: @15565
     /*  15565 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(15683), // Rule ID 13420 //
     /*  15570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15601 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15613 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15617 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15621 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15626 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15630 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15634 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15638 */     // MIs[4] Operand 1
     /*  15638 */     // No operand predicates
     /*  15638 */     // MIs[2] Operand 2
     /*  15638 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15653 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15655 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15662 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15678 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15681 */     GIR_RootConstrainSelectedInstOperands,
     /*  15682 */     // GIR_Coverage, 13420,
     /*  15682 */     GIR_EraseRootFromParent_Done,
     /*  15683 */   // Label 305: @15683
     /*  15683 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(15801), // Rule ID 13449 //
     /*  15688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15723 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15727 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15731 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15735 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15739 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15744 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15748 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15752 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15756 */     // MIs[4] Operand 1
     /*  15756 */     // No operand predicates
     /*  15756 */     // MIs[2] Operand 2
     /*  15756 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15771 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15773 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15780 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15799 */     GIR_RootConstrainSelectedInstOperands,
     /*  15800 */     // GIR_Coverage, 13449,
     /*  15800 */     GIR_EraseRootFromParent_Done,
     /*  15801 */   // Label 306: @15801
     /*  15801 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(15919), // Rule ID 13450 //
     /*  15806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  15821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15837 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15849 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15853 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15857 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15862 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15866 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15870 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15874 */     // MIs[4] Operand 1
     /*  15874 */     // No operand predicates
     /*  15874 */     // MIs[2] Operand 2
     /*  15874 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15889 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15891 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15898 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  15901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15917 */     GIR_RootConstrainSelectedInstOperands,
     /*  15918 */     // GIR_Coverage, 13450,
     /*  15918 */     GIR_EraseRootFromParent_Done,
     /*  15919 */   // Label 307: @15919
     /*  15919 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(16037), // Rule ID 2042 //
     /*  15924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15963 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15967 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15971 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15975 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15979 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15988 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15992 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15996 */     // MIs[4] Operand 1
     /*  15996 */     // No operand predicates
     /*  15996 */     // MIs[2] Operand 2
     /*  15996 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16007 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16016 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  16019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16035 */     GIR_RootConstrainSelectedInstOperands,
     /*  16036 */     // GIR_Coverage, 2042,
     /*  16036 */     GIR_EraseRootFromParent_Done,
     /*  16037 */   // Label 308: @16037
     /*  16037 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(16155), // Rule ID 13418 //
     /*  16042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16069 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16073 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16077 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16089 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16093 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16097 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16102 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16106 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16110 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16114 */     // MIs[4] Operand 1
     /*  16114 */     // No operand predicates
     /*  16114 */     // MIs[2] Operand 2
     /*  16114 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16125 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16127 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16134 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  16137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16153 */     GIR_RootConstrainSelectedInstOperands,
     /*  16154 */     // GIR_Coverage, 13418,
     /*  16154 */     GIR_EraseRootFromParent_Done,
     /*  16155 */   // Label 309: @16155
     /*  16155 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(16273), // Rule ID 2094 //
     /*  16160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16207 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16211 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16215 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16220 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16224 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16228 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16232 */     // MIs[4] Operand 1
     /*  16232 */     // No operand predicates
     /*  16232 */     // MIs[2] Operand 2
     /*  16232 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16243 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16245 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16252 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16271 */     GIR_RootConstrainSelectedInstOperands,
     /*  16272 */     // GIR_Coverage, 2094,
     /*  16272 */     GIR_EraseRootFromParent_Done,
     /*  16273 */   // Label 310: @16273
     /*  16273 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(16391), // Rule ID 13448 //
     /*  16278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16317 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16321 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16325 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16329 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16333 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16338 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16342 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16346 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16350 */     // MIs[4] Operand 1
     /*  16350 */     // No operand predicates
     /*  16350 */     // MIs[2] Operand 2
     /*  16350 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16361 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16363 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16370 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16375 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16377 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16389 */     GIR_RootConstrainSelectedInstOperands,
     /*  16390 */     // GIR_Coverage, 13448,
     /*  16390 */     GIR_EraseRootFromParent_Done,
     /*  16391 */   // Label 311: @16391
     /*  16391 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(16478), // Rule ID 13324 //
     /*  16396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16423 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16426 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16431 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16435 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16445 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16452 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16459 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16476 */     GIR_RootConstrainSelectedInstOperands,
     /*  16477 */     // GIR_Coverage, 13324,
     /*  16477 */     GIR_EraseRootFromParent_Done,
     /*  16478 */   // Label 312: @16478
     /*  16478 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(16565), // Rule ID 13348 //
     /*  16483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16510 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16513 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16522 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16532 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16539 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16546 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16563 */     GIR_RootConstrainSelectedInstOperands,
     /*  16564 */     // GIR_Coverage, 13348,
     /*  16564 */     GIR_EraseRootFromParent_Done,
     /*  16565 */   // Label 313: @16565
     /*  16565 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(16652), // Rule ID 1699 //
     /*  16570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16601 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16604 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16613 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16619 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16626 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16633 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16640 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16645 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16650 */     GIR_RootConstrainSelectedInstOperands,
     /*  16651 */     // GIR_Coverage, 1699,
     /*  16651 */     GIR_EraseRootFromParent_Done,
     /*  16652 */   // Label 314: @16652
     /*  16652 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(16739), // Rule ID 1777 //
     /*  16657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16688 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16691 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16700 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16706 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16713 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16720 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16737 */     GIR_RootConstrainSelectedInstOperands,
     /*  16738 */     // GIR_Coverage, 1777,
     /*  16738 */     GIR_EraseRootFromParent_Done,
     /*  16739 */   // Label 315: @16739
     /*  16739 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(16854), // Rule ID 13414 //
     /*  16744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16787 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16791 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16795 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16800 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16804 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16808 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16812 */     // MIs[4] Operand 1
     /*  16812 */     // No operand predicates
     /*  16812 */     // MIs[2] Operand 2
     /*  16812 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16832 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16834 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  16845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16852 */     GIR_RootConstrainSelectedInstOperands,
     /*  16853 */     // GIR_Coverage, 13414,
     /*  16853 */     GIR_EraseRootFromParent_Done,
     /*  16854 */   // Label 316: @16854
     /*  16854 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(16969), // Rule ID 13413 //
     /*  16859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  16887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16899 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16903 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16907 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16911 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16915 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16920 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16924 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16928 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16932 */     // MIs[4] Operand 1
     /*  16932 */     // No operand predicates
     /*  16932 */     // MIs[2] Operand 2
     /*  16932 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  16943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16947 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16949 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  16952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  16960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16967 */     GIR_RootConstrainSelectedInstOperands,
     /*  16968 */     // GIR_Coverage, 13413,
     /*  16968 */     GIR_EraseRootFromParent_Done,
     /*  16969 */   // Label 317: @16969
     /*  16969 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(17084), // Rule ID 13444 //
     /*  16974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17009 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17013 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17017 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17021 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17025 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17030 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17034 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17038 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17042 */     // MIs[4] Operand 1
     /*  17042 */     // No operand predicates
     /*  17042 */     // MIs[2] Operand 2
     /*  17042 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17062 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17064 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17082 */     GIR_RootConstrainSelectedInstOperands,
     /*  17083 */     // GIR_Coverage, 13444,
     /*  17083 */     GIR_EraseRootFromParent_Done,
     /*  17084 */   // Label 318: @17084
     /*  17084 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(17199), // Rule ID 13443 //
     /*  17089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17129 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17133 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17137 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17141 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17145 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17150 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17154 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17158 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17162 */     // MIs[4] Operand 1
     /*  17162 */     // No operand predicates
     /*  17162 */     // MIs[2] Operand 2
     /*  17162 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17177 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17179 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17197 */     GIR_RootConstrainSelectedInstOperands,
     /*  17198 */     // GIR_Coverage, 13443,
     /*  17198 */     GIR_EraseRootFromParent_Done,
     /*  17199 */   // Label 319: @17199
     /*  17199 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(17268), // Rule ID 1801 //
     /*  17204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17237 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17244 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17251 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17266 */     GIR_RootConstrainSelectedInstOperands,
     /*  17267 */     // GIR_Coverage, 1801,
     /*  17267 */     GIR_EraseRootFromParent_Done,
     /*  17268 */   // Label 320: @17268
     /*  17268 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(17337), // Rule ID 1800 //
     /*  17273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17306 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17313 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17320 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17335 */     GIR_RootConstrainSelectedInstOperands,
     /*  17336 */     // GIR_Coverage, 1800,
     /*  17336 */     GIR_EraseRootFromParent_Done,
     /*  17337 */   // Label 321: @17337
     /*  17337 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(17406), // Rule ID 1717 //
     /*  17342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17375 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17382 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17389 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
     /*  17392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17404 */     GIR_RootConstrainSelectedInstOperands,
     /*  17405 */     // GIR_Coverage, 1717,
     /*  17405 */     GIR_EraseRootFromParent_Done,
     /*  17406 */   // Label 322: @17406
     /*  17406 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(17475), // Rule ID 1799 //
     /*  17411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17444 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17451 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17458 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17473 */     GIR_RootConstrainSelectedInstOperands,
     /*  17474 */     // GIR_Coverage, 1799,
     /*  17474 */     GIR_EraseRootFromParent_Done,
     /*  17475 */   // Label 323: @17475
     /*  17475 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(17544), // Rule ID 1798 //
     /*  17480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17513 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17520 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17527 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17542 */     GIR_RootConstrainSelectedInstOperands,
     /*  17543 */     // GIR_Coverage, 1798,
     /*  17543 */     GIR_EraseRootFromParent_Done,
     /*  17544 */   // Label 324: @17544
     /*  17544 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(17659), // Rule ID 13412 //
     /*  17549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17584 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17596 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17600 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17604 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17609 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17613 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17617 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17621 */     // MIs[4] Operand 1
     /*  17621 */     // No operand predicates
     /*  17621 */     // MIs[2] Operand 2
     /*  17621 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17632 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17637 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17639 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17657 */     GIR_RootConstrainSelectedInstOperands,
     /*  17658 */     // GIR_Coverage, 13412,
     /*  17658 */     GIR_EraseRootFromParent_Done,
     /*  17659 */   // Label 325: @17659
     /*  17659 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(17774), // Rule ID 2040 //
     /*  17664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17704 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17708 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17712 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17716 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17720 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17724 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17729 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17733 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17737 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17741 */     // MIs[4] Operand 1
     /*  17741 */     // No operand predicates
     /*  17741 */     // MIs[2] Operand 2
     /*  17741 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17752 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17754 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17759 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17769 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17772 */     GIR_RootConstrainSelectedInstOperands,
     /*  17773 */     // GIR_Coverage, 2040,
     /*  17773 */     GIR_EraseRootFromParent_Done,
     /*  17774 */   // Label 326: @17774
     /*  17774 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(17889), // Rule ID 13442 //
     /*  17779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17818 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17822 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17826 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17830 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17834 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17839 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17843 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17847 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17851 */     // MIs[4] Operand 1
     /*  17851 */     // No operand predicates
     /*  17851 */     // MIs[2] Operand 2
     /*  17851 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17867 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17869 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17887 */     GIR_RootConstrainSelectedInstOperands,
     /*  17888 */     // GIR_Coverage, 13442,
     /*  17888 */     GIR_EraseRootFromParent_Done,
     /*  17889 */   // Label 327: @17889
     /*  17889 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(18004), // Rule ID 2092 //
     /*  17894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17917 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17938 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17942 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17946 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17950 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17954 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17959 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17963 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17967 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17971 */     // MIs[4] Operand 1
     /*  17971 */     // No operand predicates
     /*  17971 */     // MIs[2] Operand 2
     /*  17971 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17982 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17984 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17999 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  18002 */     GIR_RootConstrainSelectedInstOperands,
     /*  18003 */     // GIR_Coverage, 2092,
     /*  18003 */     GIR_EraseRootFromParent_Done,
     /*  18004 */   // Label 328: @18004
     /*  18004 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(18071), // Rule ID 13336 //
     /*  18009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18052 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  18055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18069 */     GIR_RootConstrainSelectedInstOperands,
     /*  18070 */     // GIR_Coverage, 13336,
     /*  18070 */     GIR_EraseRootFromParent_Done,
     /*  18071 */   // Label 329: @18071
     /*  18071 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(18138), // Rule ID 13366 //
     /*  18076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18103 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18105 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18112 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18119 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18136 */     GIR_RootConstrainSelectedInstOperands,
     /*  18137 */     // GIR_Coverage, 13366,
     /*  18137 */     GIR_EraseRootFromParent_Done,
     /*  18138 */   // Label 330: @18138
     /*  18138 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(18205), // Rule ID 1729 //
     /*  18143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18172 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18179 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18186 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  18189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18193 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18198 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18203 */     GIR_RootConstrainSelectedInstOperands,
     /*  18204 */     // GIR_Coverage, 1729,
     /*  18204 */     GIR_EraseRootFromParent_Done,
     /*  18205 */   // Label 331: @18205
     /*  18205 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(18272), // Rule ID 1819 //
     /*  18210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18239 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18246 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18253 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18258 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18270 */     GIR_RootConstrainSelectedInstOperands,
     /*  18271 */     // GIR_Coverage, 1819,
     /*  18271 */     GIR_EraseRootFromParent_Done,
     /*  18272 */   // Label 332: @18272
     /*  18272 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(18353), // Rule ID 13322 //
     /*  18277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18304 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18307 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18316 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18320 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18336 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18347 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18351 */     GIR_RootConstrainSelectedInstOperands,
     /*  18352 */     // GIR_Coverage, 13322,
     /*  18352 */     GIR_EraseRootFromParent_Done,
     /*  18353 */   // Label 333: @18353
     /*  18353 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(18434), // Rule ID 13346 //
     /*  18358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18385 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18388 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18393 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18397 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18401 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18417 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18432 */     GIR_RootConstrainSelectedInstOperands,
     /*  18433 */     // GIR_Coverage, 13346,
     /*  18433 */     GIR_EraseRootFromParent_Done,
     /*  18434 */   // Label 334: @18434
     /*  18434 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(18515), // Rule ID 1697 //
     /*  18439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18470 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18473 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18478 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18482 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18491 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18498 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18513 */     GIR_RootConstrainSelectedInstOperands,
     /*  18514 */     // GIR_Coverage, 1697,
     /*  18514 */     GIR_EraseRootFromParent_Done,
     /*  18515 */   // Label 335: @18515
     /*  18515 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(18596), // Rule ID 1775 //
     /*  18520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18551 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18554 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18559 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18563 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18572 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18579 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18594 */     GIR_RootConstrainSelectedInstOperands,
     /*  18595 */     // GIR_Coverage, 1775,
     /*  18595 */     GIR_EraseRootFromParent_Done,
     /*  18596 */   // Label 336: @18596
     /*  18596 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(18688), // Rule ID 13417 //
     /*  18601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18636 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18640 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18645 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18649 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18653 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18657 */     // MIs[3] Operand 1
     /*  18657 */     // No operand predicates
     /*  18657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18666 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18668 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18686 */     GIR_RootConstrainSelectedInstOperands,
     /*  18687 */     // GIR_Coverage, 13417,
     /*  18687 */     GIR_EraseRootFromParent_Done,
     /*  18688 */   // Label 337: @18688
     /*  18688 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(18780), // Rule ID 13416 //
     /*  18693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18729 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18733 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18742 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18746 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18750 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18754 */     // MIs[3] Operand 1
     /*  18754 */     // No operand predicates
     /*  18754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18758 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18760 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18778 */     GIR_RootConstrainSelectedInstOperands,
     /*  18779 */     // GIR_Coverage, 13416,
     /*  18779 */     GIR_EraseRootFromParent_Done,
     /*  18780 */   // Label 338: @18780
     /*  18780 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(18872), // Rule ID 13447 //
     /*  18785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18837 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18841 */     // MIs[3] Operand 1
     /*  18841 */     // No operand predicates
     /*  18841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18850 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18852 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18870 */     GIR_RootConstrainSelectedInstOperands,
     /*  18871 */     // GIR_Coverage, 13447,
     /*  18871 */     GIR_EraseRootFromParent_Done,
     /*  18872 */   // Label 339: @18872
     /*  18872 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(18964), // Rule ID 13446 //
     /*  18877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  18921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18926 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  18930 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18934 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18938 */     // MIs[3] Operand 1
     /*  18938 */     // No operand predicates
     /*  18938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  18944 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  18962 */     GIR_RootConstrainSelectedInstOperands,
     /*  18963 */     // GIR_Coverage, 13446,
     /*  18963 */     GIR_EraseRootFromParent_Done,
     /*  18964 */   // Label 340: @18964
     /*  18964 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(19056), // Rule ID 13415 //
     /*  18969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18976 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19025 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19029 */     // MIs[3] Operand 1
     /*  19029 */     // No operand predicates
     /*  19029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19034 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19036 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  19039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19054 */     GIR_RootConstrainSelectedInstOperands,
     /*  19055 */     // GIR_Coverage, 13415,
     /*  19055 */     GIR_EraseRootFromParent_Done,
     /*  19056 */   // Label 341: @19056
     /*  19056 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(19148), // Rule ID 2041 //
     /*  19061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19084 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19122 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19126 */     // MIs[3] Operand 1
     /*  19126 */     // No operand predicates
     /*  19126 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19128 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  19131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19146 */     GIR_RootConstrainSelectedInstOperands,
     /*  19147 */     // GIR_Coverage, 2041,
     /*  19147 */     GIR_EraseRootFromParent_Done,
     /*  19148 */   // Label 342: @19148
     /*  19148 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(19240), // Rule ID 13445 //
     /*  19153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19192 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19196 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19209 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19213 */     // MIs[3] Operand 1
     /*  19213 */     // No operand predicates
     /*  19213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19218 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19220 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19225 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19235 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19238 */     GIR_RootConstrainSelectedInstOperands,
     /*  19239 */     // GIR_Coverage, 13445,
     /*  19239 */     GIR_EraseRootFromParent_Done,
     /*  19240 */   // Label 343: @19240
     /*  19240 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(19332), // Rule ID 2093 //
     /*  19245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19298 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19302 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19306 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19310 */     // MIs[3] Operand 1
     /*  19310 */     // No operand predicates
     /*  19310 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19312 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19330 */     GIR_RootConstrainSelectedInstOperands,
     /*  19331 */     // GIR_Coverage, 2093,
     /*  19331 */     GIR_EraseRootFromParent_Done,
     /*  19332 */   // Label 344: @19332
     /*  19332 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(19383), // Rule ID 13360 //
     /*  19337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19362 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19369 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19381 */     GIR_RootConstrainSelectedInstOperands,
     /*  19382 */     // GIR_Coverage, 13360,
     /*  19382 */     GIR_EraseRootFromParent_Done,
     /*  19383 */   // Label 345: @19383
     /*  19383 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(19434), // Rule ID 13330 //
     /*  19388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19413 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19420 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19432 */     GIR_RootConstrainSelectedInstOperands,
     /*  19433 */     // GIR_Coverage, 13330,
     /*  19433 */     GIR_EraseRootFromParent_Done,
     /*  19434 */   // Label 346: @19434
     /*  19434 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(19485), // Rule ID 13359 //
     /*  19439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19464 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19471 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19478 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19483 */     GIR_RootConstrainSelectedInstOperands,
     /*  19484 */     // GIR_Coverage, 13359,
     /*  19484 */     GIR_EraseRootFromParent_Done,
     /*  19485 */   // Label 347: @19485
     /*  19485 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(19536), // Rule ID 1813 //
     /*  19490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19522 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19527 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19534 */     GIR_RootConstrainSelectedInstOperands,
     /*  19535 */     // GIR_Coverage, 1813,
     /*  19535 */     GIR_EraseRootFromParent_Done,
     /*  19536 */   // Label 348: @19536
     /*  19536 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(19587), // Rule ID 1723 //
     /*  19541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19566 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19573 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19585 */     GIR_RootConstrainSelectedInstOperands,
     /*  19586 */     // GIR_Coverage, 1723,
     /*  19586 */     GIR_EraseRootFromParent_Done,
     /*  19587 */   // Label 349: @19587
     /*  19587 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(19638), // Rule ID 1812 //
     /*  19592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19617 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19624 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19636 */     GIR_RootConstrainSelectedInstOperands,
     /*  19637 */     // GIR_Coverage, 1812,
     /*  19637 */     GIR_EraseRootFromParent_Done,
     /*  19638 */   // Label 350: @19638
     /*  19638 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(19694), // Rule ID 13248 //
     /*  19643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19658 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19661 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19681 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19692 */     GIR_RootConstrainSelectedInstOperands,
     /*  19693 */     // GIR_Coverage, 13248,
     /*  19693 */     GIR_EraseRootFromParent_Done,
     /*  19694 */   // Label 351: @19694
     /*  19694 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(19750), // Rule ID 13260 //
     /*  19699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19714 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19717 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19737 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19748 */     GIR_RootConstrainSelectedInstOperands,
     /*  19749 */     // GIR_Coverage, 13260,
     /*  19749 */     GIR_EraseRootFromParent_Done,
     /*  19750 */   // Label 352: @19750
     /*  19750 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(19817), // Rule ID 13488 //
     /*  19755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  19770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19779 */     // MIs[1] imm
     /*  19779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19787 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19791 */     // MIs[2] Operand 1
     /*  19791 */     // No operand predicates
     /*  19791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19795 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19799 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19801 */     // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  19804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19812 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19815 */     GIR_RootConstrainSelectedInstOperands,
     /*  19816 */     // GIR_Coverage, 13488,
     /*  19816 */     GIR_EraseRootFromParent_Done,
     /*  19817 */   // Label 353: @19817
     /*  19817 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(19884), // Rule ID 13509 //
     /*  19822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19829 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19833 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  19837 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  19841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19846 */     // MIs[1] imm
     /*  19846 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19850 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19854 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  19858 */     // MIs[2] Operand 1
     /*  19858 */     // No operand predicates
     /*  19858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19862 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  19866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  19868 */     // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  19868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  19871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  19882 */     GIR_RootConstrainSelectedInstOperands,
     /*  19883 */     // GIR_Coverage, 13509,
     /*  19883 */     GIR_EraseRootFromParent_Done,
     /*  19884 */   // Label 354: @19884
     /*  19884 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(19940), // Rule ID 999 //
     /*  19889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19908 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19911 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  19916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19927 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  19930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19938 */     GIR_RootConstrainSelectedInstOperands,
     /*  19939 */     // GIR_Coverage, 999,
     /*  19939 */     GIR_EraseRootFromParent_Done,
     /*  19940 */   // Label 355: @19940
     /*  19940 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(19996), // Rule ID 1060 //
     /*  19945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  19964 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  19967 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  19972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  19976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19983 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  19983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  19986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19994 */     GIR_RootConstrainSelectedInstOperands,
     /*  19995 */     // GIR_Coverage, 1060,
     /*  19995 */     GIR_EraseRootFromParent_Done,
     /*  19996 */   // Label 356: @19996
     /*  19996 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(20063), // Rule ID 2240 //
     /*  20001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  20020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20029 */     // MIs[1] imm
     /*  20029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20037 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  20041 */     // MIs[2] Operand 1
     /*  20041 */     // No operand predicates
     /*  20041 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  20045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20047 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  20047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  20050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20058 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  20061 */     GIR_RootConstrainSelectedInstOperands,
     /*  20062 */     // GIR_Coverage, 2240,
     /*  20062 */     GIR_EraseRootFromParent_Done,
     /*  20063 */   // Label 357: @20063
     /*  20063 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(20130), // Rule ID 2299 //
     /*  20068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  20087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20096 */     // MIs[1] imm
     /*  20096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20104 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  20108 */     // MIs[2] Operand 1
     /*  20108 */     // No operand predicates
     /*  20108 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  20112 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20114 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  20114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  20117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  20128 */     GIR_RootConstrainSelectedInstOperands,
     /*  20129 */     // GIR_Coverage, 2299,
     /*  20129 */     GIR_EraseRootFromParent_Done,
     /*  20130 */   // Label 358: @20130
     /*  20130 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(20200), // Rule ID 6899 //
     /*  20135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /*  20173 */     // MIs[2] Rn
     /*  20173 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20178 */     // MIs[2] Rm
     /*  20178 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20185 */     // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20194 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20198 */     GIR_RootConstrainSelectedInstOperands,
     /*  20199 */     // GIR_Coverage, 6899,
     /*  20199 */     GIR_EraseRootFromParent_Done,
     /*  20200 */   // Label 359: @20200
     /*  20200 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(20270), // Rule ID 13870 //
     /*  20205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  20217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20243 */     // MIs[2] Rn
     /*  20243 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20248 */     // MIs[2] Rm
     /*  20248 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20253 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20255 */     // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20268 */     GIR_RootConstrainSelectedInstOperands,
     /*  20269 */     // GIR_Coverage, 13870,
     /*  20269 */     GIR_EraseRootFromParent_Done,
     /*  20270 */   // Label 360: @20270
     /*  20270 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(20333), // Rule ID 1797 //
     /*  20275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20318 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20331 */     GIR_RootConstrainSelectedInstOperands,
     /*  20332 */     // GIR_Coverage, 1797,
     /*  20332 */     GIR_EraseRootFromParent_Done,
     /*  20333 */   // Label 361: @20333
     /*  20333 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(20396), // Rule ID 1796 //
     /*  20338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20381 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20394 */     GIR_RootConstrainSelectedInstOperands,
     /*  20395 */     // GIR_Coverage, 1796,
     /*  20395 */     GIR_EraseRootFromParent_Done,
     /*  20396 */   // Label 362: @20396
     /*  20396 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(20459), // Rule ID 1716 //
     /*  20401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20420 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20444 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*  20447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20457 */     GIR_RootConstrainSelectedInstOperands,
     /*  20458 */     // GIR_Coverage, 1716,
     /*  20458 */     GIR_EraseRootFromParent_Done,
     /*  20459 */   // Label 363: @20459
     /*  20459 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(20522), // Rule ID 1795 //
     /*  20464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20505 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20507 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20520 */     GIR_RootConstrainSelectedInstOperands,
     /*  20521 */     // GIR_Coverage, 1795,
     /*  20521 */     GIR_EraseRootFromParent_Done,
     /*  20522 */   // Label 364: @20522
     /*  20522 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(20585), // Rule ID 1794 //
     /*  20527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20563 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20568 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20570 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20583 */     GIR_RootConstrainSelectedInstOperands,
     /*  20584 */     // GIR_Coverage, 1794,
     /*  20584 */     GIR_EraseRootFromParent_Done,
     /*  20585 */   // Label 365: @20585
     /*  20585 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(20646), // Rule ID 13335 //
     /*  20590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20629 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20644 */     GIR_RootConstrainSelectedInstOperands,
     /*  20645 */     // GIR_Coverage, 13335,
     /*  20645 */     GIR_EraseRootFromParent_Done,
     /*  20646 */   // Label 366: @20646
     /*  20646 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(20707), // Rule ID 13365 //
     /*  20651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  20666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20670 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20674 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20679 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20690 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  20693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20705 */     GIR_RootConstrainSelectedInstOperands,
     /*  20706 */     // GIR_Coverage, 13365,
     /*  20706 */     GIR_EraseRootFromParent_Done,
     /*  20707 */   // Label 367: @20707
     /*  20707 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(20755), // Rule ID 13358 //
     /*  20712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20742 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20753 */     GIR_RootConstrainSelectedInstOperands,
     /*  20754 */     // GIR_Coverage, 13358,
     /*  20754 */     GIR_EraseRootFromParent_Done,
     /*  20755 */   // Label 368: @20755
     /*  20755 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(20803), // Rule ID 13247 //
     /*  20760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  20775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20788 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20790 */     // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20801 */     GIR_RootConstrainSelectedInstOperands,
     /*  20802 */     // GIR_Coverage, 13247,
     /*  20802 */     GIR_EraseRootFromParent_Done,
     /*  20803 */   // Label 369: @20803
     /*  20803 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(20851), // Rule ID 13329 //
     /*  20808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20838 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  20841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20849 */     GIR_RootConstrainSelectedInstOperands,
     /*  20850 */     // GIR_Coverage, 13329,
     /*  20850 */     GIR_EraseRootFromParent_Done,
     /*  20851 */   // Label 370: @20851
     /*  20851 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(20899), // Rule ID 13259 //
     /*  20856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  20871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  20875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20886 */     // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20897 */     GIR_RootConstrainSelectedInstOperands,
     /*  20898 */     // GIR_Coverage, 13259,
     /*  20898 */     GIR_EraseRootFromParent_Done,
     /*  20899 */   // Label 371: @20899
     /*  20899 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(20947), // Rule ID 13357 //
     /*  20904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20934 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  20937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  20941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  20945 */     GIR_RootConstrainSelectedInstOperands,
     /*  20946 */     // GIR_Coverage, 13357,
     /*  20946 */     GIR_EraseRootFromParent_Done,
     /*  20947 */   // Label 372: @20947
     /*  20947 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(21008), // Rule ID 1728 //
     /*  20952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  20971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  20979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20984 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20991 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  20994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21002 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  21006 */     GIR_RootConstrainSelectedInstOperands,
     /*  21007 */     // GIR_Coverage, 1728,
     /*  21007 */     GIR_EraseRootFromParent_Done,
     /*  21008 */   // Label 373: @21008
     /*  21008 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(21069), // Rule ID 1818 //
     /*  21013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  21032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  21040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21052 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  21055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  21067 */     GIR_RootConstrainSelectedInstOperands,
     /*  21068 */     // GIR_Coverage, 1818,
     /*  21068 */     GIR_EraseRootFromParent_Done,
     /*  21069 */   // Label 374: @21069
     /*  21069 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21117), // Rule ID 1811 //
     /*  21074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21104 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21115 */     GIR_RootConstrainSelectedInstOperands,
     /*  21116 */     // GIR_Coverage, 1811,
     /*  21116 */     GIR_EraseRootFromParent_Done,
     /*  21117 */   // Label 375: @21117
     /*  21117 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21165), // Rule ID 998 //
     /*  21122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  21141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21152 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  21155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21163 */     GIR_RootConstrainSelectedInstOperands,
     /*  21164 */     // GIR_Coverage, 998,
     /*  21164 */     GIR_EraseRootFromParent_Done,
     /*  21165 */   // Label 376: @21165
     /*  21165 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21213), // Rule ID 1722 //
     /*  21170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21177 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21200 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  21203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21211 */     GIR_RootConstrainSelectedInstOperands,
     /*  21212 */     // GIR_Coverage, 1722,
     /*  21212 */     GIR_EraseRootFromParent_Done,
     /*  21213 */   // Label 377: @21213
     /*  21213 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21261), // Rule ID 1059 //
     /*  21218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  21237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21248 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  21251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21259 */     GIR_RootConstrainSelectedInstOperands,
     /*  21260 */     // GIR_Coverage, 1059,
     /*  21260 */     GIR_EraseRootFromParent_Done,
     /*  21261 */   // Label 378: @21261
     /*  21261 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21309), // Rule ID 1810 //
     /*  21266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21296 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21301 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21307 */     GIR_RootConstrainSelectedInstOperands,
     /*  21308 */     // GIR_Coverage, 1810,
     /*  21308 */     GIR_EraseRootFromParent_Done,
     /*  21309 */   // Label 379: @21309
     /*  21309 */   GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(21336), // Rule ID 1106 //
     /*  21314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21329 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  21329 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
     /*  21334 */     GIR_RootConstrainSelectedInstOperands,
     /*  21335 */     // GIR_Coverage, 1106,
     /*  21335 */     GIR_Done,
     /*  21336 */   // Label 380: @21336
     /*  21336 */   GIM_Reject,
     /*  21337 */ // Label 303: @21337
     /*  21337 */ GIM_Reject,
     /*  21338 */ // Label 162: @21338
     /*  21338 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(24835),
     /*  21343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  21346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21349 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(21485), // Rule ID 5352 //
     /*  21354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21387 */     // MIs[1] Operand 2
     /*  21387 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21398 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21402 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21406 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21410 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21414 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21418 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21422 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21427 */     // MIs[3] Operand 2
     /*  21427 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21438 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21440 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21452 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21460 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21467 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21484 */     // GIR_Coverage, 5352,
     /*  21484 */     GIR_EraseRootFromParent_Done,
     /*  21485 */   // Label 382: @21485
     /*  21485 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(21621), // Rule ID 5351 //
     /*  21490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21518 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21523 */     // MIs[1] Operand 2
     /*  21523 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21542 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21546 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21550 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21554 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21558 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21563 */     // MIs[3] Operand 2
     /*  21563 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21574 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21576 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21588 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21603 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21615 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21620 */     // GIR_Coverage, 5351,
     /*  21620 */     GIR_EraseRootFromParent_Done,
     /*  21621 */   // Label 383: @21621
     /*  21621 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(21757), // Rule ID 5367 //
     /*  21626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21659 */     // MIs[1] Operand 2
     /*  21659 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21678 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21682 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21686 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21690 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21694 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21699 */     // MIs[3] Operand 2
     /*  21699 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21710 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21712 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  21719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21724 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21728 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21739 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21756 */     // GIR_Coverage, 5367,
     /*  21756 */     GIR_EraseRootFromParent_Done,
     /*  21757 */   // Label 384: @21757
     /*  21757 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(21893), // Rule ID 5350 //
     /*  21762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21795 */     // MIs[1] Operand 2
     /*  21795 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21814 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21818 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21822 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21826 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21830 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21835 */     // MIs[3] Operand 2
     /*  21835 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21846 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21848 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21860 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21864 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21875 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21882 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21887 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21892 */     // GIR_Coverage, 5350,
     /*  21892 */     GIR_EraseRootFromParent_Done,
     /*  21893 */   // Label 385: @21893
     /*  21893 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22029), // Rule ID 5349 //
     /*  21898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21926 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21931 */     // MIs[1] Operand 2
     /*  21931 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21942 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21946 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21950 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21954 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21958 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21962 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21966 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21971 */     // MIs[3] Operand 2
     /*  21971 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21982 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21984 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22000 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  22004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22011 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22018 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22028 */     // GIR_Coverage, 5349,
     /*  22028 */     GIR_EraseRootFromParent_Done,
     /*  22029 */   // Label 386: @22029
     /*  22029 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(22162), // Rule ID 13875 //
     /*  22034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  22058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  22075 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  22079 */     // MIs[1] Operand 2
     /*  22079 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22090 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  22094 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  22098 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22102 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  22106 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  22110 */     // MIs[5] Rn
     /*  22110 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22115 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22117 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22117 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22120 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22124 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22129 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22133 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22137 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22144 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22151 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22161 */     // GIR_Coverage, 13875,
     /*  22161 */     GIR_EraseRootFromParent_Done,
     /*  22162 */   // Label 387: @22162
     /*  22162 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(22295), // Rule ID 6904 //
     /*  22167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  22179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  22191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22195 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22200 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22204 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22208 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22212 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22216 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  22220 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22224 */     // MIs[4] Rn
     /*  22224 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22229 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22233 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  22237 */     // MIs[3] Operand 2
     /*  22237 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22248 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22250 */     // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22277 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22294 */     // GIR_Coverage, 6904,
     /*  22294 */     GIR_EraseRootFromParent_Done,
     /*  22295 */   // Label 388: @22295
     /*  22295 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(22458), // Rule ID 13827 //
     /*  22300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22342 */     // MIs[1] Operand 2
     /*  22342 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22359 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22359 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22362 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22366 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22373 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22376 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22380 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22385 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22388 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22392 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22395 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22400 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22422 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22425 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22429 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22440 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22457 */     // GIR_Coverage, 13827,
     /*  22457 */     GIR_EraseRootFromParent_Done,
     /*  22458 */   // Label 389: @22458
     /*  22458 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(22621), // Rule ID 13824 //
     /*  22463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  22487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22495 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22505 */     // MIs[1] Operand 2
     /*  22505 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22522 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22522 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22525 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22529 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22536 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22539 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22543 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22548 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22551 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22555 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22558 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22563 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22568 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  22580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22585 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22588 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22603 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22615 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22620 */     // GIR_Coverage, 13824,
     /*  22620 */     GIR_EraseRootFromParent_Done,
     /*  22621 */   // Label 390: @22621
     /*  22621 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(22771), // Rule ID 13831 //
     /*  22626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  22650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22659 */     // MIs[1] Operand 2
     /*  22659 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22674 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22676 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22676 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22679 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22683 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22690 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22693 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22697 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22702 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22705 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22709 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22712 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22717 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22722 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  22734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22739 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22742 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22753 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22770 */     // GIR_Coverage, 13831,
     /*  22770 */     GIR_EraseRootFromParent_Done,
     /*  22771 */   // Label 391: @22771
     /*  22771 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(22921), // Rule ID 13836 //
     /*  22776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  22800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22804 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22809 */     // MIs[1] Operand 2
     /*  22809 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22826 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22826 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22829 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22833 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22840 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22843 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22847 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22852 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22855 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  22859 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22862 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22867 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22872 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  22884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22889 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  22896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22903 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22910 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22915 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22920 */     // GIR_Coverage, 13836,
     /*  22920 */     GIR_EraseRootFromParent_Done,
     /*  22921 */   // Label 392: @22921
     /*  22921 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23071), // Rule ID 13830 //
     /*  22926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22959 */     // MIs[1] Operand 2
     /*  22959 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22976 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22976 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22979 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22983 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22990 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22993 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22997 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23002 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23005 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  23009 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23012 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23017 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23022 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23039 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23053 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23070 */     // GIR_Coverage, 13830,
     /*  23070 */     GIR_EraseRootFromParent_Done,
     /*  23071 */   // Label 393: @23071
     /*  23071 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23234), // Rule ID 5340 //
     /*  23076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  23104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23108 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23122 */     // MIs[1] Operand 2
     /*  23122 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23135 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23135 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23138 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23142 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23161 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23164 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23168 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23171 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23176 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  23193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23198 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23205 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23216 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23233 */     // GIR_Coverage, 5340,
     /*  23233 */     GIR_EraseRootFromParent_Done,
     /*  23234 */   // Label 394: @23234
     /*  23234 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(23397), // Rule ID 5337 //
     /*  23239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  23267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23285 */     // MIs[1] Operand 2
     /*  23285 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23298 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23298 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23301 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23305 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23312 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23315 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23319 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23324 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23327 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23331 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23334 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23339 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23344 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  23356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23361 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23379 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23386 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23396 */     // GIR_Coverage, 5337,
     /*  23396 */     GIR_EraseRootFromParent_Done,
     /*  23397 */   // Label 395: @23397
     /*  23397 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(23547), // Rule ID 5362 //
     /*  23402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  23430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23439 */     // MIs[1] Operand 2
     /*  23439 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23452 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23452 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23455 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23459 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23466 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23469 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23473 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23478 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23481 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23485 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23488 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23493 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23498 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23515 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23529 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23546 */     // GIR_Coverage, 5362,
     /*  23546 */     GIR_EraseRootFromParent_Done,
     /*  23547 */   // Label 396: @23547
     /*  23547 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(23697), // Rule ID 5370 //
     /*  23552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  23580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23589 */     // MIs[1] Operand 2
     /*  23589 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23602 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23602 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23605 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23609 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23616 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23619 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23623 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23628 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23631 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23635 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23638 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23643 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  23660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23665 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23668 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23679 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23691 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23696 */     // GIR_Coverage, 5370,
     /*  23696 */     GIR_EraseRootFromParent_Done,
     /*  23697 */   // Label 397: @23697
     /*  23697 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(23847), // Rule ID 5361 //
     /*  23702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23739 */     // MIs[1] Operand 2
     /*  23739 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23752 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23752 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23755 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23759 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23766 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23769 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23773 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23778 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23781 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23785 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23788 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23793 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23798 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23815 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23818 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23829 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23841 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23846 */     // GIR_Coverage, 5361,
     /*  23846 */     GIR_EraseRootFromParent_Done,
     /*  23847 */   // Label 398: @23847
     /*  23847 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(23916), // Rule ID 13276 //
     /*  23852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23867 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23870 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  23875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23879 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23899 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  23902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23914 */     GIR_RootConstrainSelectedInstOperands,
     /*  23915 */     // GIR_Coverage, 13276,
     /*  23915 */     GIR_EraseRootFromParent_Done,
     /*  23916 */   // Label 399: @23916
     /*  23916 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(23985), // Rule ID 13288 //
     /*  23921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  23936 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  23939 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  23944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23948 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  23952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23968 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  23968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  23971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  23975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  23979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  23983 */     GIR_RootConstrainSelectedInstOperands,
     /*  23984 */     // GIR_Coverage, 13288,
     /*  23984 */     GIR_EraseRootFromParent_Done,
     /*  23985 */   // Label 400: @23985
     /*  23985 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24041), // Rule ID 13238 //
     /*  23990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24005 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24008 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24028 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24039 */     GIR_RootConstrainSelectedInstOperands,
     /*  24040 */     // GIR_Coverage, 13238,
     /*  24040 */     GIR_EraseRootFromParent_Done,
     /*  24041 */   // Label 401: @24041
     /*  24041 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24097), // Rule ID 13250 //
     /*  24046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24061 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24064 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24084 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24095 */     GIR_RootConstrainSelectedInstOperands,
     /*  24096 */     // GIR_Coverage, 13250,
     /*  24096 */     GIR_EraseRootFromParent_Done,
     /*  24097 */   // Label 402: @24097
     /*  24097 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24164), // Rule ID 13480 //
     /*  24102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24126 */     // MIs[1] imm
     /*  24126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24134 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24138 */     // MIs[2] Operand 1
     /*  24138 */     // No operand predicates
     /*  24138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24142 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24148 */     // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24162 */     GIR_RootConstrainSelectedInstOperands,
     /*  24163 */     // GIR_Coverage, 13480,
     /*  24163 */     GIR_EraseRootFromParent_Done,
     /*  24164 */   // Label 403: @24164
     /*  24164 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24231), // Rule ID 13501 //
     /*  24169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24193 */     // MIs[1] imm
     /*  24193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24201 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24205 */     // MIs[2] Operand 1
     /*  24205 */     // No operand predicates
     /*  24205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24209 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24215 */     // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24229 */     GIR_RootConstrainSelectedInstOperands,
     /*  24230 */     // GIR_Coverage, 13501,
     /*  24230 */     GIR_EraseRootFromParent_Done,
     /*  24231 */   // Label 404: @24231
     /*  24231 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(24300), // Rule ID 1361 //
     /*  24236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24255 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24258 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24283 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  24286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24298 */     GIR_RootConstrainSelectedInstOperands,
     /*  24299 */     // GIR_Coverage, 1361,
     /*  24299 */     GIR_EraseRootFromParent_Done,
     /*  24300 */   // Label 405: @24300
     /*  24300 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(24369), // Rule ID 1484 //
     /*  24305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24324 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24327 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24336 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24352 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  24355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24367 */     GIR_RootConstrainSelectedInstOperands,
     /*  24368 */     // GIR_Coverage, 1484,
     /*  24368 */     GIR_EraseRootFromParent_Done,
     /*  24369 */   // Label 406: @24369
     /*  24369 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(24425), // Rule ID 989 //
     /*  24374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24393 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24396 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24412 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24423 */     GIR_RootConstrainSelectedInstOperands,
     /*  24424 */     // GIR_Coverage, 989,
     /*  24424 */     GIR_EraseRootFromParent_Done,
     /*  24425 */   // Label 407: @24425
     /*  24425 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(24481), // Rule ID 1050 //
     /*  24430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24449 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24452 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24468 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24479 */     GIR_RootConstrainSelectedInstOperands,
     /*  24480 */     // GIR_Coverage, 1050,
     /*  24480 */     GIR_EraseRootFromParent_Done,
     /*  24481 */   // Label 408: @24481
     /*  24481 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(24548), // Rule ID 2232 //
     /*  24486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24514 */     // MIs[1] imm
     /*  24514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24526 */     // MIs[2] Operand 1
     /*  24526 */     // No operand predicates
     /*  24526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24532 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24546 */     GIR_RootConstrainSelectedInstOperands,
     /*  24547 */     // GIR_Coverage, 2232,
     /*  24547 */     GIR_EraseRootFromParent_Done,
     /*  24548 */   // Label 409: @24548
     /*  24548 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(24615), // Rule ID 2291 //
     /*  24553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24581 */     // MIs[1] imm
     /*  24581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24593 */     // MIs[2] Operand 1
     /*  24593 */     // No operand predicates
     /*  24593 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24599 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24613 */     GIR_RootConstrainSelectedInstOperands,
     /*  24614 */     // GIR_Coverage, 2291,
     /*  24614 */     GIR_EraseRootFromParent_Done,
     /*  24615 */   // Label 410: @24615
     /*  24615 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(24663), // Rule ID 13237 //
     /*  24620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24650 */     // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24661 */     GIR_RootConstrainSelectedInstOperands,
     /*  24662 */     // GIR_Coverage, 13237,
     /*  24662 */     GIR_EraseRootFromParent_Done,
     /*  24663 */   // Label 411: @24663
     /*  24663 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(24711), // Rule ID 13249 //
     /*  24668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24698 */     // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24709 */     GIR_RootConstrainSelectedInstOperands,
     /*  24710 */     // GIR_Coverage, 13249,
     /*  24710 */     GIR_EraseRootFromParent_Done,
     /*  24711 */   // Label 412: @24711
     /*  24711 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(24759), // Rule ID 988 //
     /*  24716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  24735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24746 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24757 */     GIR_RootConstrainSelectedInstOperands,
     /*  24758 */     // GIR_Coverage, 988,
     /*  24758 */     GIR_EraseRootFromParent_Done,
     /*  24759 */   // Label 413: @24759
     /*  24759 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(24807), // Rule ID 1049 //
     /*  24764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  24783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24794 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24805 */     GIR_RootConstrainSelectedInstOperands,
     /*  24806 */     // GIR_Coverage, 1049,
     /*  24806 */     GIR_EraseRootFromParent_Done,
     /*  24807 */   // Label 414: @24807
     /*  24807 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(24834), // Rule ID 1102 //
     /*  24812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24827 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
     /*  24832 */     GIR_RootConstrainSelectedInstOperands,
     /*  24833 */     // GIR_Coverage, 1102,
     /*  24833 */     GIR_Done,
     /*  24834 */   // Label 415: @24834
     /*  24834 */   GIM_Reject,
     /*  24835 */ // Label 381: @24835
     /*  24835 */ GIM_Reject,
     /*  24836 */ // Label 163: @24836
     /*  24836 */ GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(31013),
     /*  24841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  24844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  24847 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(24965), // Rule ID 13410 //
     /*  24852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  24891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  24895 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24899 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  24903 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  24908 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  24912 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24916 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  24920 */     // MIs[4] Operand 1
     /*  24920 */     // No operand predicates
     /*  24920 */     // MIs[2] Operand 2
     /*  24920 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  24931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24935 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  24937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  24944 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  24944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  24947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  24956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  24960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  24963 */     GIR_RootConstrainSelectedInstOperands,
     /*  24964 */     // GIR_Coverage, 13410,
     /*  24964 */     GIR_EraseRootFromParent_Done,
     /*  24965 */   // Label 417: @24965
     /*  24965 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(25083), // Rule ID 13411 //
     /*  24970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  24985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25013 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25017 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25021 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25026 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25030 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25034 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25038 */     // MIs[4] Operand 1
     /*  25038 */     // No operand predicates
     /*  25038 */     // MIs[2] Operand 2
     /*  25038 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25053 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25062 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25081 */     GIR_RootConstrainSelectedInstOperands,
     /*  25082 */     // GIR_Coverage, 13411,
     /*  25082 */     GIR_EraseRootFromParent_Done,
     /*  25083 */   // Label 418: @25083
     /*  25083 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(25201), // Rule ID 13440 //
     /*  25088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25131 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25135 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25139 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25144 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25148 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25152 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25156 */     // MIs[4] Operand 1
     /*  25156 */     // No operand predicates
     /*  25156 */     // MIs[2] Operand 2
     /*  25156 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25171 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25180 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25199 */     GIR_RootConstrainSelectedInstOperands,
     /*  25200 */     // GIR_Coverage, 13440,
     /*  25200 */     GIR_EraseRootFromParent_Done,
     /*  25201 */   // Label 419: @25201
     /*  25201 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(25319), // Rule ID 13441 //
     /*  25206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25249 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25253 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25257 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25262 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25266 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25270 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25274 */     // MIs[4] Operand 1
     /*  25274 */     // No operand predicates
     /*  25274 */     // MIs[2] Operand 2
     /*  25274 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25289 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25298 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25317 */     GIR_RootConstrainSelectedInstOperands,
     /*  25318 */     // GIR_Coverage, 13441,
     /*  25318 */     GIR_EraseRootFromParent_Done,
     /*  25319 */   // Label 420: @25319
     /*  25319 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(25437), // Rule ID 2039 //
     /*  25324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25371 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25375 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25379 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25384 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25388 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25392 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25396 */     // MIs[4] Operand 1
     /*  25396 */     // No operand predicates
     /*  25396 */     // MIs[2] Operand 2
     /*  25396 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25407 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25416 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25435 */     GIR_RootConstrainSelectedInstOperands,
     /*  25436 */     // GIR_Coverage, 2039,
     /*  25436 */     GIR_EraseRootFromParent_Done,
     /*  25437 */   // Label 421: @25437
     /*  25437 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(25555), // Rule ID 13409 //
     /*  25442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25489 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25493 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25497 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25502 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25506 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25510 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25514 */     // MIs[4] Operand 1
     /*  25514 */     // No operand predicates
     /*  25514 */     // MIs[2] Operand 2
     /*  25514 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25525 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25534 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25553 */     GIR_RootConstrainSelectedInstOperands,
     /*  25554 */     // GIR_Coverage, 13409,
     /*  25554 */     GIR_EraseRootFromParent_Done,
     /*  25555 */   // Label 422: @25555
     /*  25555 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(25673), // Rule ID 2091 //
     /*  25560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25603 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25607 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25611 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25615 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25620 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25624 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25628 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25632 */     // MIs[4] Operand 1
     /*  25632 */     // No operand predicates
     /*  25632 */     // MIs[2] Operand 2
     /*  25632 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25643 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25652 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25671 */     GIR_RootConstrainSelectedInstOperands,
     /*  25672 */     // GIR_Coverage, 2091,
     /*  25672 */     GIR_EraseRootFromParent_Done,
     /*  25673 */   // Label 423: @25673
     /*  25673 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(25791), // Rule ID 13439 //
     /*  25678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25729 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25733 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25738 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25742 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25746 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25750 */     // MIs[4] Operand 1
     /*  25750 */     // No operand predicates
     /*  25750 */     // MIs[2] Operand 2
     /*  25750 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25761 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25763 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25770 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25789 */     GIR_RootConstrainSelectedInstOperands,
     /*  25790 */     // GIR_Coverage, 13439,
     /*  25790 */     GIR_EraseRootFromParent_Done,
     /*  25791 */   // Label 424: @25791
     /*  25791 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(25878), // Rule ID 13320 //
     /*  25796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25823 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25826 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  25831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25835 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25845 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25852 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25859 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  25862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25876 */     GIR_RootConstrainSelectedInstOperands,
     /*  25877 */     // GIR_Coverage, 13320,
     /*  25877 */     GIR_EraseRootFromParent_Done,
     /*  25878 */   // Label 425: @25878
     /*  25878 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(25965), // Rule ID 13344 //
     /*  25883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  25910 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  25913 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  25918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25922 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  25926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  25932 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25939 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25946 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  25946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  25949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  25963 */     GIR_RootConstrainSelectedInstOperands,
     /*  25964 */     // GIR_Coverage, 13344,
     /*  25964 */     GIR_EraseRootFromParent_Done,
     /*  25965 */   // Label 426: @25965
     /*  25965 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(26052), // Rule ID 1695 //
     /*  25970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  25989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26001 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26004 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  26009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26013 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26019 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26026 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26033 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  26036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26050 */     GIR_RootConstrainSelectedInstOperands,
     /*  26051 */     // GIR_Coverage, 1695,
     /*  26051 */     GIR_EraseRootFromParent_Done,
     /*  26052 */   // Label 427: @26052
     /*  26052 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(26139), // Rule ID 1773 //
     /*  26057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26088 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26091 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  26096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26100 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26106 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26113 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26120 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  26123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26137 */     GIR_RootConstrainSelectedInstOperands,
     /*  26138 */     // GIR_Coverage, 1773,
     /*  26138 */     GIR_EraseRootFromParent_Done,
     /*  26139 */   // Label 428: @26139
     /*  26139 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(26254), // Rule ID 13405 //
     /*  26144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26187 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26191 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26195 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26200 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26204 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26208 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26212 */     // MIs[4] Operand 1
     /*  26212 */     // No operand predicates
     /*  26212 */     // MIs[2] Operand 2
     /*  26212 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26232 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26234 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26252 */     GIR_RootConstrainSelectedInstOperands,
     /*  26253 */     // GIR_Coverage, 13405,
     /*  26253 */     GIR_EraseRootFromParent_Done,
     /*  26254 */   // Label 429: @26254
     /*  26254 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(26369), // Rule ID 13404 //
     /*  26259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26307 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26311 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26315 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26320 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26324 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26328 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26332 */     // MIs[4] Operand 1
     /*  26332 */     // No operand predicates
     /*  26332 */     // MIs[2] Operand 2
     /*  26332 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26347 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26349 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26367 */     GIR_RootConstrainSelectedInstOperands,
     /*  26368 */     // GIR_Coverage, 13404,
     /*  26368 */     GIR_EraseRootFromParent_Done,
     /*  26369 */   // Label 430: @26369
     /*  26369 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(26484), // Rule ID 13435 //
     /*  26374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26417 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26421 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26425 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26430 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26434 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26438 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26442 */     // MIs[4] Operand 1
     /*  26442 */     // No operand predicates
     /*  26442 */     // MIs[2] Operand 2
     /*  26442 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26462 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26464 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26482 */     GIR_RootConstrainSelectedInstOperands,
     /*  26483 */     // GIR_Coverage, 13435,
     /*  26483 */     GIR_EraseRootFromParent_Done,
     /*  26484 */   // Label 431: @26484
     /*  26484 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(26599), // Rule ID 13434 //
     /*  26489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26537 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26541 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26545 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26550 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26554 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26558 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26562 */     // MIs[4] Operand 1
     /*  26562 */     // No operand predicates
     /*  26562 */     // MIs[2] Operand 2
     /*  26562 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26577 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26579 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26597 */     GIR_RootConstrainSelectedInstOperands,
     /*  26598 */     // GIR_Coverage, 13434,
     /*  26598 */     GIR_EraseRootFromParent_Done,
     /*  26599 */   // Label 432: @26599
     /*  26599 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(26668), // Rule ID 1793 //
     /*  26604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26644 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26651 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26666 */     GIR_RootConstrainSelectedInstOperands,
     /*  26667 */     // GIR_Coverage, 1793,
     /*  26667 */     GIR_EraseRootFromParent_Done,
     /*  26668 */   // Label 433: @26668
     /*  26668 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(26737), // Rule ID 1792 //
     /*  26673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26713 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26720 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26735 */     GIR_RootConstrainSelectedInstOperands,
     /*  26736 */     // GIR_Coverage, 1792,
     /*  26736 */     GIR_EraseRootFromParent_Done,
     /*  26737 */   // Label 434: @26737
     /*  26737 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(26806), // Rule ID 1715 //
     /*  26742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  26769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26782 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26789 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
     /*  26792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26804 */     GIR_RootConstrainSelectedInstOperands,
     /*  26805 */     // GIR_Coverage, 1715,
     /*  26805 */     GIR_EraseRootFromParent_Done,
     /*  26806 */   // Label 435: @26806
     /*  26806 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(26875), // Rule ID 1791 //
     /*  26811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  26838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26858 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26873 */     GIR_RootConstrainSelectedInstOperands,
     /*  26874 */     // GIR_Coverage, 1791,
     /*  26874 */     GIR_EraseRootFromParent_Done,
     /*  26875 */   // Label 436: @26875
     /*  26875 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(26944), // Rule ID 1790 //
     /*  26880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  26903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26920 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26927 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  26930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  26932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26942 */     GIR_RootConstrainSelectedInstOperands,
     /*  26943 */     // GIR_Coverage, 1790,
     /*  26943 */     GIR_EraseRootFromParent_Done,
     /*  26944 */   // Label 437: @26944
     /*  26944 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(27059), // Rule ID 13403 //
     /*  26949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26996 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27000 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27004 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27009 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27013 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27017 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27021 */     // MIs[4] Operand 1
     /*  27021 */     // No operand predicates
     /*  27021 */     // MIs[2] Operand 2
     /*  27021 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27037 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27039 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27057 */     GIR_RootConstrainSelectedInstOperands,
     /*  27058 */     // GIR_Coverage, 13403,
     /*  27058 */     GIR_EraseRootFromParent_Done,
     /*  27059 */   // Label 438: @27059
     /*  27059 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(27174), // Rule ID 2037 //
     /*  27064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27116 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27120 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27124 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27129 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27133 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27137 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27141 */     // MIs[4] Operand 1
     /*  27141 */     // No operand predicates
     /*  27141 */     // MIs[2] Operand 2
     /*  27141 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27152 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27154 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27159 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27172 */     GIR_RootConstrainSelectedInstOperands,
     /*  27173 */     // GIR_Coverage, 2037,
     /*  27173 */     GIR_EraseRootFromParent_Done,
     /*  27174 */   // Label 439: @27174
     /*  27174 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(27289), // Rule ID 13433 //
     /*  27179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27226 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27230 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27234 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27239 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27243 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27247 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27251 */     // MIs[4] Operand 1
     /*  27251 */     // No operand predicates
     /*  27251 */     // MIs[2] Operand 2
     /*  27251 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27267 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27269 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27287 */     GIR_RootConstrainSelectedInstOperands,
     /*  27288 */     // GIR_Coverage, 13433,
     /*  27288 */     GIR_EraseRootFromParent_Done,
     /*  27289 */   // Label 440: @27289
     /*  27289 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(27404), // Rule ID 2089 //
     /*  27294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27346 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27350 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27354 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27359 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27363 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27367 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27371 */     // MIs[4] Operand 1
     /*  27371 */     // No operand predicates
     /*  27371 */     // MIs[2] Operand 2
     /*  27371 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27382 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27384 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27389 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27402 */     GIR_RootConstrainSelectedInstOperands,
     /*  27403 */     // GIR_Coverage, 2089,
     /*  27403 */     GIR_EraseRootFromParent_Done,
     /*  27404 */   // Label 441: @27404
     /*  27404 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(27471), // Rule ID 13334 //
     /*  27409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27452 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27469 */     GIR_RootConstrainSelectedInstOperands,
     /*  27470 */     // GIR_Coverage, 13334,
     /*  27470 */     GIR_EraseRootFromParent_Done,
     /*  27471 */   // Label 442: @27471
     /*  27471 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(27538), // Rule ID 13364 //
     /*  27476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27519 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27536 */     GIR_RootConstrainSelectedInstOperands,
     /*  27537 */     // GIR_Coverage, 13364,
     /*  27537 */     GIR_EraseRootFromParent_Done,
     /*  27538 */   // Label 443: @27538
     /*  27538 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(27605), // Rule ID 1727 //
     /*  27543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27572 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27586 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27603 */     GIR_RootConstrainSelectedInstOperands,
     /*  27604 */     // GIR_Coverage, 1727,
     /*  27604 */     GIR_EraseRootFromParent_Done,
     /*  27605 */   // Label 444: @27605
     /*  27605 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(27672), // Rule ID 1817 //
     /*  27610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27639 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27653 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27658 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27670 */     GIR_RootConstrainSelectedInstOperands,
     /*  27671 */     // GIR_Coverage, 1817,
     /*  27671 */     GIR_EraseRootFromParent_Done,
     /*  27672 */   // Label 445: @27672
     /*  27672 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(27753), // Rule ID 13318 //
     /*  27677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27704 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27707 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27716 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27734 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27736 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27751 */     GIR_RootConstrainSelectedInstOperands,
     /*  27752 */     // GIR_Coverage, 13318,
     /*  27752 */     GIR_EraseRootFromParent_Done,
     /*  27753 */   // Label 446: @27753
     /*  27753 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(27834), // Rule ID 13342 //
     /*  27758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27785 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27788 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27797 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27817 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27832 */     GIR_RootConstrainSelectedInstOperands,
     /*  27833 */     // GIR_Coverage, 13342,
     /*  27833 */     GIR_EraseRootFromParent_Done,
     /*  27834 */   // Label 447: @27834
     /*  27834 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(27915), // Rule ID 1693 //
     /*  27839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27870 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27873 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  27878 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27882 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27898 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  27901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27913 */     GIR_RootConstrainSelectedInstOperands,
     /*  27914 */     // GIR_Coverage, 1693,
     /*  27914 */     GIR_EraseRootFromParent_Done,
     /*  27915 */   // Label 448: @27915
     /*  27915 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(27996), // Rule ID 1771 //
     /*  27920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  27951 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  27954 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  27959 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27963 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  27967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27979 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  27979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  27982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27984 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  27990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  27994 */     GIR_RootConstrainSelectedInstOperands,
     /*  27995 */     // GIR_Coverage, 1771,
     /*  27995 */     GIR_EraseRootFromParent_Done,
     /*  27996 */   // Label 449: @27996
     /*  27996 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(28088), // Rule ID 13408 //
     /*  28001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28036 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28053 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28057 */     // MIs[3] Operand 1
     /*  28057 */     // No operand predicates
     /*  28057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28068 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28086 */     GIR_RootConstrainSelectedInstOperands,
     /*  28087 */     // GIR_Coverage, 13408,
     /*  28087 */     GIR_EraseRootFromParent_Done,
     /*  28088 */   // Label 450: @28088
     /*  28088 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(28180), // Rule ID 13407 //
     /*  28093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28150 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28154 */     // MIs[3] Operand 1
     /*  28154 */     // No operand predicates
     /*  28154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28160 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28178 */     GIR_RootConstrainSelectedInstOperands,
     /*  28179 */     // GIR_Coverage, 13407,
     /*  28179 */     GIR_EraseRootFromParent_Done,
     /*  28180 */   // Label 451: @28180
     /*  28180 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(28272), // Rule ID 13438 //
     /*  28185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28237 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28241 */     // MIs[3] Operand 1
     /*  28241 */     // No operand predicates
     /*  28241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28252 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28270 */     GIR_RootConstrainSelectedInstOperands,
     /*  28271 */     // GIR_Coverage, 13438,
     /*  28271 */     GIR_EraseRootFromParent_Done,
     /*  28272 */   // Label 452: @28272
     /*  28272 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(28364), // Rule ID 13437 //
     /*  28277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28321 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28334 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28338 */     // MIs[3] Operand 1
     /*  28338 */     // No operand predicates
     /*  28338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28342 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28344 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28362 */     GIR_RootConstrainSelectedInstOperands,
     /*  28363 */     // GIR_Coverage, 13437,
     /*  28363 */     GIR_EraseRootFromParent_Done,
     /*  28364 */   // Label 453: @28364
     /*  28364 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(28456), // Rule ID 13406 //
     /*  28369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28425 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28429 */     // MIs[3] Operand 1
     /*  28429 */     // No operand predicates
     /*  28429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28436 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28454 */     GIR_RootConstrainSelectedInstOperands,
     /*  28455 */     // GIR_Coverage, 13406,
     /*  28455 */     GIR_EraseRootFromParent_Done,
     /*  28456 */   // Label 454: @28456
     /*  28456 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(28548), // Rule ID 2038 //
     /*  28461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28522 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28526 */     // MIs[3] Operand 1
     /*  28526 */     // No operand predicates
     /*  28526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28528 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28546 */     GIR_RootConstrainSelectedInstOperands,
     /*  28547 */     // GIR_Coverage, 2038,
     /*  28547 */     GIR_EraseRootFromParent_Done,
     /*  28548 */   // Label 455: @28548
     /*  28548 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(28640), // Rule ID 13436 //
     /*  28553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28609 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28613 */     // MIs[3] Operand 1
     /*  28613 */     // No operand predicates
     /*  28613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28618 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28620 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28638 */     GIR_RootConstrainSelectedInstOperands,
     /*  28639 */     // GIR_Coverage, 13436,
     /*  28639 */     GIR_EraseRootFromParent_Done,
     /*  28640 */   // Label 456: @28640
     /*  28640 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(28732), // Rule ID 2090 //
     /*  28645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28706 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28710 */     // MIs[3] Operand 1
     /*  28710 */     // No operand predicates
     /*  28710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28712 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28730 */     GIR_RootConstrainSelectedInstOperands,
     /*  28731 */     // GIR_Coverage, 2090,
     /*  28731 */     GIR_EraseRootFromParent_Done,
     /*  28732 */   // Label 457: @28732
     /*  28732 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(28783), // Rule ID 13356 //
     /*  28737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28769 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28781 */     GIR_RootConstrainSelectedInstOperands,
     /*  28782 */     // GIR_Coverage, 13356,
     /*  28782 */     GIR_EraseRootFromParent_Done,
     /*  28783 */   // Label 458: @28783
     /*  28783 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(28834), // Rule ID 13328 //
     /*  28788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28820 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28832 */     GIR_RootConstrainSelectedInstOperands,
     /*  28833 */     // GIR_Coverage, 13328,
     /*  28833 */     GIR_EraseRootFromParent_Done,
     /*  28834 */   // Label 459: @28834
     /*  28834 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(28885), // Rule ID 13355 //
     /*  28839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28871 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  28878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28883 */     GIR_RootConstrainSelectedInstOperands,
     /*  28884 */     // GIR_Coverage, 13355,
     /*  28884 */     GIR_EraseRootFromParent_Done,
     /*  28885 */   // Label 460: @28885
     /*  28885 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(28936), // Rule ID 1809 //
     /*  28890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  28909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28922 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  28925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28934 */     GIR_RootConstrainSelectedInstOperands,
     /*  28935 */     // GIR_Coverage, 1809,
     /*  28935 */     GIR_EraseRootFromParent_Done,
     /*  28936 */   // Label 461: @28936
     /*  28936 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(28987), // Rule ID 1721 //
     /*  28941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  28960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28966 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28973 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  28976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  28978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  28980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  28985 */     GIR_RootConstrainSelectedInstOperands,
     /*  28986 */     // GIR_Coverage, 1721,
     /*  28986 */     GIR_EraseRootFromParent_Done,
     /*  28987 */   // Label 462: @28987
     /*  28987 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(29038), // Rule ID 1808 //
     /*  28992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29024 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  29027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  29031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29036 */     GIR_RootConstrainSelectedInstOperands,
     /*  29037 */     // GIR_Coverage, 1808,
     /*  29037 */     GIR_EraseRootFromParent_Done,
     /*  29038 */   // Label 463: @29038
     /*  29038 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(29107), // Rule ID 13282 //
     /*  29043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29058 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29061 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29070 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29090 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29105 */     GIR_RootConstrainSelectedInstOperands,
     /*  29106 */     // GIR_Coverage, 13282,
     /*  29106 */     GIR_EraseRootFromParent_Done,
     /*  29107 */   // Label 464: @29107
     /*  29107 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(29176), // Rule ID 13294 //
     /*  29112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29127 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29130 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29139 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29159 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29174 */     GIR_RootConstrainSelectedInstOperands,
     /*  29175 */     // GIR_Coverage, 13294,
     /*  29175 */     GIR_EraseRootFromParent_Done,
     /*  29176 */   // Label 465: @29176
     /*  29176 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(29232), // Rule ID 13244 //
     /*  29181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29196 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29199 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29219 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29230 */     GIR_RootConstrainSelectedInstOperands,
     /*  29231 */     // GIR_Coverage, 13244,
     /*  29231 */     GIR_EraseRootFromParent_Done,
     /*  29232 */   // Label 466: @29232
     /*  29232 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(29288), // Rule ID 13256 //
     /*  29237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29252 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29255 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29275 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29286 */     GIR_RootConstrainSelectedInstOperands,
     /*  29287 */     // GIR_Coverage, 13256,
     /*  29287 */     GIR_EraseRootFromParent_Done,
     /*  29288 */   // Label 467: @29288
     /*  29288 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(29355), // Rule ID 13486 //
     /*  29293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29317 */     // MIs[1] imm
     /*  29317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29325 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29329 */     // MIs[2] Operand 1
     /*  29329 */     // No operand predicates
     /*  29329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29333 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29339 */     // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29353 */     GIR_RootConstrainSelectedInstOperands,
     /*  29354 */     // GIR_Coverage, 13486,
     /*  29354 */     GIR_EraseRootFromParent_Done,
     /*  29355 */   // Label 468: @29355
     /*  29355 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(29422), // Rule ID 13507 //
     /*  29360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29384 */     // MIs[1] imm
     /*  29384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29392 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29396 */     // MIs[2] Operand 1
     /*  29396 */     // No operand predicates
     /*  29396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29400 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29406 */     // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29420 */     GIR_RootConstrainSelectedInstOperands,
     /*  29421 */     // GIR_Coverage, 13507,
     /*  29421 */     GIR_EraseRootFromParent_Done,
     /*  29422 */   // Label 469: @29422
     /*  29422 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(29491), // Rule ID 1367 //
     /*  29427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29446 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29449 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29458 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29462 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29474 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29489 */     GIR_RootConstrainSelectedInstOperands,
     /*  29490 */     // GIR_Coverage, 1367,
     /*  29490 */     GIR_EraseRootFromParent_Done,
     /*  29491 */   // Label 470: @29491
     /*  29491 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(29560), // Rule ID 1490 //
     /*  29496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29515 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29518 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29523 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29527 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29543 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29558 */     GIR_RootConstrainSelectedInstOperands,
     /*  29559 */     // GIR_Coverage, 1490,
     /*  29559 */     GIR_EraseRootFromParent_Done,
     /*  29560 */   // Label 471: @29560
     /*  29560 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(29616), // Rule ID 995 //
     /*  29565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29584 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29587 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29596 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29603 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29608 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29614 */     GIR_RootConstrainSelectedInstOperands,
     /*  29615 */     // GIR_Coverage, 995,
     /*  29615 */     GIR_EraseRootFromParent_Done,
     /*  29616 */   // Label 472: @29616
     /*  29616 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(29672), // Rule ID 1056 //
     /*  29621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29640 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29643 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29648 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29652 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29659 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29670 */     GIR_RootConstrainSelectedInstOperands,
     /*  29671 */     // GIR_Coverage, 1056,
     /*  29671 */     GIR_EraseRootFromParent_Done,
     /*  29672 */   // Label 473: @29672
     /*  29672 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(29739), // Rule ID 2238 //
     /*  29677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29705 */     // MIs[1] imm
     /*  29705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29713 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29717 */     // MIs[2] Operand 1
     /*  29717 */     // No operand predicates
     /*  29717 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29723 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29737 */     GIR_RootConstrainSelectedInstOperands,
     /*  29738 */     // GIR_Coverage, 2238,
     /*  29738 */     GIR_EraseRootFromParent_Done,
     /*  29739 */   // Label 474: @29739
     /*  29739 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(29806), // Rule ID 2297 //
     /*  29744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29751 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29772 */     // MIs[1] imm
     /*  29772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29780 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29784 */     // MIs[2] Operand 1
     /*  29784 */     // No operand predicates
     /*  29784 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29790 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29795 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29804 */     GIR_RootConstrainSelectedInstOperands,
     /*  29805 */     // GIR_Coverage, 2297,
     /*  29805 */     GIR_EraseRootFromParent_Done,
     /*  29806 */   // Label 475: @29806
     /*  29806 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(29876), // Rule ID 6900 //
     /*  29811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  29823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29831 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  29849 */     // MIs[2] Rn
     /*  29849 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29854 */     // MIs[2] Rm
     /*  29854 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29859 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29861 */     // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29866 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29874 */     GIR_RootConstrainSelectedInstOperands,
     /*  29875 */     // GIR_Coverage, 6900,
     /*  29875 */     GIR_EraseRootFromParent_Done,
     /*  29876 */   // Label 476: @29876
     /*  29876 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(29946), // Rule ID 13871 //
     /*  29881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  29893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  29919 */     // MIs[2] Rn
     /*  29919 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  29924 */     // MIs[2] Rm
     /*  29924 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  29929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29931 */     // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  29931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  29934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  29944 */     GIR_RootConstrainSelectedInstOperands,
     /*  29945 */     // GIR_Coverage, 13871,
     /*  29945 */     GIR_EraseRootFromParent_Done,
     /*  29946 */   // Label 477: @29946
     /*  29946 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(30009), // Rule ID 1789 //
     /*  29951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  29979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29992 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29994 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  29994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  29997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30007 */     GIR_RootConstrainSelectedInstOperands,
     /*  30008 */     // GIR_Coverage, 1789,
     /*  30008 */     GIR_EraseRootFromParent_Done,
     /*  30009 */   // Label 478: @30009
     /*  30009 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(30072), // Rule ID 1788 //
     /*  30014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30057 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30070 */     GIR_RootConstrainSelectedInstOperands,
     /*  30071 */     // GIR_Coverage, 1788,
     /*  30071 */     GIR_EraseRootFromParent_Done,
     /*  30072 */   // Label 479: @30072
     /*  30072 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(30135), // Rule ID 1714 //
     /*  30077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30101 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30105 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30109 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30120 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  30123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30133 */     GIR_RootConstrainSelectedInstOperands,
     /*  30134 */     // GIR_Coverage, 1714,
     /*  30134 */     GIR_EraseRootFromParent_Done,
     /*  30135 */   // Label 480: @30135
     /*  30135 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(30198), // Rule ID 1787 //
     /*  30140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30176 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30183 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30196 */     GIR_RootConstrainSelectedInstOperands,
     /*  30197 */     // GIR_Coverage, 1787,
     /*  30197 */     GIR_EraseRootFromParent_Done,
     /*  30198 */   // Label 481: @30198
     /*  30198 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(30261), // Rule ID 1786 //
     /*  30203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30222 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30239 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30246 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30259 */     GIR_RootConstrainSelectedInstOperands,
     /*  30260 */     // GIR_Coverage, 1786,
     /*  30260 */     GIR_EraseRootFromParent_Done,
     /*  30261 */   // Label 482: @30261
     /*  30261 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(30322), // Rule ID 13333 //
     /*  30266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30305 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30320 */     GIR_RootConstrainSelectedInstOperands,
     /*  30321 */     // GIR_Coverage, 13333,
     /*  30321 */     GIR_EraseRootFromParent_Done,
     /*  30322 */   // Label 483: @30322
     /*  30322 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(30383), // Rule ID 13363 //
     /*  30327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30346 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30350 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30366 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30381 */     GIR_RootConstrainSelectedInstOperands,
     /*  30382 */     // GIR_Coverage, 13363,
     /*  30382 */     GIR_EraseRootFromParent_Done,
     /*  30383 */   // Label 484: @30383
     /*  30383 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(30431), // Rule ID 13354 //
     /*  30388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30407 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30416 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30418 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30429 */     GIR_RootConstrainSelectedInstOperands,
     /*  30430 */     // GIR_Coverage, 13354,
     /*  30430 */     GIR_EraseRootFromParent_Done,
     /*  30431 */   // Label 485: @30431
     /*  30431 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(30479), // Rule ID 13243 //
     /*  30436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30466 */     // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30477 */     GIR_RootConstrainSelectedInstOperands,
     /*  30478 */     // GIR_Coverage, 13243,
     /*  30478 */     GIR_EraseRootFromParent_Done,
     /*  30479 */   // Label 486: @30479
     /*  30479 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(30527), // Rule ID 13327 //
     /*  30484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30514 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30525 */     GIR_RootConstrainSelectedInstOperands,
     /*  30526 */     // GIR_Coverage, 13327,
     /*  30526 */     GIR_EraseRootFromParent_Done,
     /*  30527 */   // Label 487: @30527
     /*  30527 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(30575), // Rule ID 13255 //
     /*  30532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30562 */     // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30573 */     GIR_RootConstrainSelectedInstOperands,
     /*  30574 */     // GIR_Coverage, 13255,
     /*  30574 */     GIR_EraseRootFromParent_Done,
     /*  30575 */   // Label 488: @30575
     /*  30575 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(30623), // Rule ID 13353 //
     /*  30580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30610 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30621 */     GIR_RootConstrainSelectedInstOperands,
     /*  30622 */     // GIR_Coverage, 13353,
     /*  30622 */     GIR_EraseRootFromParent_Done,
     /*  30623 */   // Label 489: @30623
     /*  30623 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(30684), // Rule ID 1726 //
     /*  30628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30665 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30667 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30672 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30682 */     GIR_RootConstrainSelectedInstOperands,
     /*  30683 */     // GIR_Coverage, 1726,
     /*  30683 */     GIR_EraseRootFromParent_Done,
     /*  30684 */   // Label 490: @30684
     /*  30684 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(30745), // Rule ID 1816 //
     /*  30689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30712 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30716 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30726 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30728 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30733 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30743 */     GIR_RootConstrainSelectedInstOperands,
     /*  30744 */     // GIR_Coverage, 1816,
     /*  30744 */     GIR_EraseRootFromParent_Done,
     /*  30745 */   // Label 491: @30745
     /*  30745 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(30793), // Rule ID 1807 //
     /*  30750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30780 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30791 */     GIR_RootConstrainSelectedInstOperands,
     /*  30792 */     // GIR_Coverage, 1807,
     /*  30792 */     GIR_EraseRootFromParent_Done,
     /*  30793 */   // Label 492: @30793
     /*  30793 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(30841), // Rule ID 994 //
     /*  30798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30828 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30839 */     GIR_RootConstrainSelectedInstOperands,
     /*  30840 */     // GIR_Coverage, 994,
     /*  30840 */     GIR_EraseRootFromParent_Done,
     /*  30841 */   // Label 493: @30841
     /*  30841 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(30889), // Rule ID 1720 //
     /*  30846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30876 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30887 */     GIR_RootConstrainSelectedInstOperands,
     /*  30888 */     // GIR_Coverage, 1720,
     /*  30888 */     GIR_EraseRootFromParent_Done,
     /*  30889 */   // Label 494: @30889
     /*  30889 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(30937), // Rule ID 1055 //
     /*  30894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30905 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30909 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30913 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30924 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30935 */     GIR_RootConstrainSelectedInstOperands,
     /*  30936 */     // GIR_Coverage, 1055,
     /*  30936 */     GIR_EraseRootFromParent_Done,
     /*  30937 */   // Label 495: @30937
     /*  30937 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(30985), // Rule ID 1806 //
     /*  30942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30949 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30972 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  30979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30983 */     GIR_RootConstrainSelectedInstOperands,
     /*  30984 */     // GIR_Coverage, 1806,
     /*  30984 */     GIR_EraseRootFromParent_Done,
     /*  30985 */   // Label 496: @30985
     /*  30985 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(31012), // Rule ID 1105 //
     /*  30990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31005 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  31005 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
     /*  31010 */     GIR_RootConstrainSelectedInstOperands,
     /*  31011 */     // GIR_Coverage, 1105,
     /*  31011 */     GIR_Done,
     /*  31012 */   // Label 497: @31012
     /*  31012 */   GIM_Reject,
     /*  31013 */ // Label 416: @31013
     /*  31013 */ GIM_Reject,
     /*  31014 */ // Label 164: @31014
     /*  31014 */ GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(31863),
     /*  31019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31022 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31025 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(31158), // Rule ID 13876 //
     /*  31030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  31042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  31054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31058 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31062 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31067 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  31071 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  31075 */     // MIs[1] Operand 2
     /*  31075 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  31086 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  31090 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  31094 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31098 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  31102 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  31106 */     // MIs[5] Rn
     /*  31106 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31111 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31113 */     // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31125 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31129 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31133 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31140 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31152 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31157 */     // GIR_Coverage, 13876,
     /*  31157 */     GIR_EraseRootFromParent_Done,
     /*  31158 */   // Label 499: @31158
     /*  31158 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(31291), // Rule ID 6905 //
     /*  31163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  31175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  31187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31191 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31196 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  31200 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  31204 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31208 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  31212 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  31216 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31220 */     // MIs[4] Rn
     /*  31220 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31225 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  31229 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  31233 */     // MIs[3] Operand 2
     /*  31233 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  31244 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31246 */     // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31258 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31273 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31290 */     // GIR_Coverage, 6905,
     /*  31290 */     GIR_EraseRootFromParent_Done,
     /*  31291 */   // Label 500: @31291
     /*  31291 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(31360), // Rule ID 13272 //
     /*  31296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31311 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31314 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31323 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31343 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31358 */     GIR_RootConstrainSelectedInstOperands,
     /*  31359 */     // GIR_Coverage, 13272,
     /*  31359 */     GIR_EraseRootFromParent_Done,
     /*  31360 */   // Label 501: @31360
     /*  31360 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(31429), // Rule ID 13284 //
     /*  31365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31380 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31383 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31392 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31412 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31427 */     GIR_RootConstrainSelectedInstOperands,
     /*  31428 */     // GIR_Coverage, 13284,
     /*  31428 */     GIR_EraseRootFromParent_Done,
     /*  31429 */   // Label 502: @31429
     /*  31429 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(31496), // Rule ID 13476 //
     /*  31434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31458 */     // MIs[1] imm
     /*  31458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31466 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31470 */     // MIs[2] Operand 1
     /*  31470 */     // No operand predicates
     /*  31470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31474 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31480 */     // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31494 */     GIR_RootConstrainSelectedInstOperands,
     /*  31495 */     // GIR_Coverage, 13476,
     /*  31495 */     GIR_EraseRootFromParent_Done,
     /*  31496 */   // Label 503: @31496
     /*  31496 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(31563), // Rule ID 13497 //
     /*  31501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31525 */     // MIs[1] imm
     /*  31525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31533 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31537 */     // MIs[2] Operand 1
     /*  31537 */     // No operand predicates
     /*  31537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31541 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31545 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31547 */     // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31561 */     GIR_RootConstrainSelectedInstOperands,
     /*  31562 */     // GIR_Coverage, 13497,
     /*  31562 */     GIR_EraseRootFromParent_Done,
     /*  31563 */   // Label 504: @31563
     /*  31563 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(31632), // Rule ID 1357 //
     /*  31568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31587 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31590 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31595 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31599 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31603 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31615 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31630 */     GIR_RootConstrainSelectedInstOperands,
     /*  31631 */     // GIR_Coverage, 1357,
     /*  31631 */     GIR_EraseRootFromParent_Done,
     /*  31632 */   // Label 505: @31632
     /*  31632 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(31701), // Rule ID 1480 //
     /*  31637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31656 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31659 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31668 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31684 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31699 */     GIR_RootConstrainSelectedInstOperands,
     /*  31700 */     // GIR_Coverage, 1480,
     /*  31700 */     GIR_EraseRootFromParent_Done,
     /*  31701 */   // Label 506: @31701
     /*  31701 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(31768), // Rule ID 2228 //
     /*  31706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31734 */     // MIs[1] imm
     /*  31734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31742 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31746 */     // MIs[2] Operand 1
     /*  31746 */     // No operand predicates
     /*  31746 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31752 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31763 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31766 */     GIR_RootConstrainSelectedInstOperands,
     /*  31767 */     // GIR_Coverage, 2228,
     /*  31767 */     GIR_EraseRootFromParent_Done,
     /*  31768 */   // Label 507: @31768
     /*  31768 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(31835), // Rule ID 2287 //
     /*  31773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31801 */     // MIs[1] imm
     /*  31801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31809 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31813 */     // MIs[2] Operand 1
     /*  31813 */     // No operand predicates
     /*  31813 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31819 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31833 */     GIR_RootConstrainSelectedInstOperands,
     /*  31834 */     // GIR_Coverage, 2287,
     /*  31834 */     GIR_EraseRootFromParent_Done,
     /*  31835 */   // Label 508: @31835
     /*  31835 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(31862), // Rule ID 1100 //
     /*  31840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31855 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31855 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
     /*  31860 */     GIR_RootConstrainSelectedInstOperands,
     /*  31861 */     // GIR_Coverage, 1100,
     /*  31861 */     GIR_Done,
     /*  31862 */   // Label 509: @31862
     /*  31862 */   GIM_Reject,
     /*  31863 */ // Label 498: @31863
     /*  31863 */ GIM_Reject,
     /*  31864 */ // Label 165: @31864
     /*  31864 */ GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(35441),
     /*  31869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  31875 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(31962), // Rule ID 13316 //
     /*  31880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31907 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31910 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31915 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31919 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31929 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31936 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  31943 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  31943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  31946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  31955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  31960 */     GIR_RootConstrainSelectedInstOperands,
     /*  31961 */     // GIR_Coverage, 13316,
     /*  31961 */     GIR_EraseRootFromParent_Done,
     /*  31962 */   // Label 511: @31962
     /*  31962 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(32049), // Rule ID 13340 //
     /*  31967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31994 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  31997 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32002 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32006 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32016 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32023 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32030 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  32033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32047 */     GIR_RootConstrainSelectedInstOperands,
     /*  32048 */     // GIR_Coverage, 13340,
     /*  32048 */     GIR_EraseRootFromParent_Done,
     /*  32049 */   // Label 512: @32049
     /*  32049 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(32136), // Rule ID 1691 //
     /*  32054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32061 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32085 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32088 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32097 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32101 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32103 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32110 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32117 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  32120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32122 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32134 */     GIR_RootConstrainSelectedInstOperands,
     /*  32135 */     // GIR_Coverage, 1691,
     /*  32135 */     GIR_EraseRootFromParent_Done,
     /*  32136 */   // Label 513: @32136
     /*  32136 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(32223), // Rule ID 1769 //
     /*  32141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32172 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32175 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32184 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32190 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32197 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32204 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  32207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32209 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32221 */     GIR_RootConstrainSelectedInstOperands,
     /*  32222 */     // GIR_Coverage, 1769,
     /*  32222 */     GIR_EraseRootFromParent_Done,
     /*  32223 */   // Label 514: @32223
     /*  32223 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(32292), // Rule ID 1785 //
     /*  32228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32261 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32268 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32275 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32290 */     GIR_RootConstrainSelectedInstOperands,
     /*  32291 */     // GIR_Coverage, 1785,
     /*  32291 */     GIR_EraseRootFromParent_Done,
     /*  32292 */   // Label 515: @32292
     /*  32292 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(32361), // Rule ID 1784 //
     /*  32297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32330 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32337 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32344 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32359 */     GIR_RootConstrainSelectedInstOperands,
     /*  32360 */     // GIR_Coverage, 1784,
     /*  32360 */     GIR_EraseRootFromParent_Done,
     /*  32361 */   // Label 516: @32361
     /*  32361 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(32430), // Rule ID 1713 //
     /*  32366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32399 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32406 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32413 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
     /*  32416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32428 */     GIR_RootConstrainSelectedInstOperands,
     /*  32429 */     // GIR_Coverage, 1713,
     /*  32429 */     GIR_EraseRootFromParent_Done,
     /*  32430 */   // Label 517: @32430
     /*  32430 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(32499), // Rule ID 1783 //
     /*  32435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32466 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32468 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32475 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32482 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32487 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32492 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32497 */     GIR_RootConstrainSelectedInstOperands,
     /*  32498 */     // GIR_Coverage, 1783,
     /*  32498 */     GIR_EraseRootFromParent_Done,
     /*  32499 */   // Label 518: @32499
     /*  32499 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(32568), // Rule ID 1782 //
     /*  32504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32537 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32544 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32551 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32566 */     GIR_RootConstrainSelectedInstOperands,
     /*  32567 */     // GIR_Coverage, 1782,
     /*  32567 */     GIR_EraseRootFromParent_Done,
     /*  32568 */   // Label 519: @32568
     /*  32568 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(32635), // Rule ID 13332 //
     /*  32573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32600 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32602 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32609 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32616 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32633 */     GIR_RootConstrainSelectedInstOperands,
     /*  32634 */     // GIR_Coverage, 13332,
     /*  32634 */     GIR_EraseRootFromParent_Done,
     /*  32635 */   // Label 520: @32635
     /*  32635 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(32702), // Rule ID 13362 //
     /*  32640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32669 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32676 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32683 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32700 */     GIR_RootConstrainSelectedInstOperands,
     /*  32701 */     // GIR_Coverage, 13362,
     /*  32701 */     GIR_EraseRootFromParent_Done,
     /*  32702 */   // Label 521: @32702
     /*  32702 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(32769), // Rule ID 1725 //
     /*  32707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32736 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32750 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  32753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32767 */     GIR_RootConstrainSelectedInstOperands,
     /*  32768 */     // GIR_Coverage, 1725,
     /*  32768 */     GIR_EraseRootFromParent_Done,
     /*  32769 */   // Label 522: @32769
     /*  32769 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(32836), // Rule ID 1815 //
     /*  32774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  32793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32803 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32810 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32817 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  32820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32824 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32829 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32834 */     GIR_RootConstrainSelectedInstOperands,
     /*  32835 */     // GIR_Coverage, 1815,
     /*  32835 */     GIR_EraseRootFromParent_Done,
     /*  32836 */   // Label 523: @32836
     /*  32836 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(32917), // Rule ID 13314 //
     /*  32841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32860 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32864 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32868 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32871 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32880 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32884 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32900 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  32903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32915 */     GIR_RootConstrainSelectedInstOperands,
     /*  32916 */     // GIR_Coverage, 13314,
     /*  32916 */     GIR_EraseRootFromParent_Done,
     /*  32917 */   // Label 524: @32917
     /*  32917 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(32998), // Rule ID 13338 //
     /*  32922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32949 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32952 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32961 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32965 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32981 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  32984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  32992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  32996 */     GIR_RootConstrainSelectedInstOperands,
     /*  32997 */     // GIR_Coverage, 13338,
     /*  32997 */     GIR_EraseRootFromParent_Done,
     /*  32998 */   // Label 525: @32998
     /*  32998 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(33079), // Rule ID 1689 //
     /*  33003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33034 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33037 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33046 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  33050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33055 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33062 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  33065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  33073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  33077 */     GIR_RootConstrainSelectedInstOperands,
     /*  33078 */     // GIR_Coverage, 1689,
     /*  33078 */     GIR_EraseRootFromParent_Done,
     /*  33079 */   // Label 526: @33079
     /*  33079 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(33160), // Rule ID 1767 //
     /*  33084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33115 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33118 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33123 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33127 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  33131 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33141 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33143 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  33146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  33154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  33158 */     GIR_RootConstrainSelectedInstOperands,
     /*  33159 */     // GIR_Coverage, 1767,
     /*  33159 */     GIR_EraseRootFromParent_Done,
     /*  33160 */   // Label 527: @33160
     /*  33160 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(33211), // Rule ID 13352 //
     /*  33165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33190 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33197 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33209 */     GIR_RootConstrainSelectedInstOperands,
     /*  33210 */     // GIR_Coverage, 13352,
     /*  33210 */     GIR_EraseRootFromParent_Done,
     /*  33211 */   // Label 528: @33211
     /*  33211 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(33262), // Rule ID 13326 //
     /*  33216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33248 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33260 */     GIR_RootConstrainSelectedInstOperands,
     /*  33261 */     // GIR_Coverage, 13326,
     /*  33261 */     GIR_EraseRootFromParent_Done,
     /*  33262 */   // Label 529: @33262
     /*  33262 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(33313), // Rule ID 13351 //
     /*  33267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33290 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33292 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33299 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33311 */     GIR_RootConstrainSelectedInstOperands,
     /*  33312 */     // GIR_Coverage, 13351,
     /*  33312 */     GIR_EraseRootFromParent_Done,
     /*  33313 */   // Label 530: @33313
     /*  33313 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(33364), // Rule ID 1805 //
     /*  33318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33341 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33343 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33350 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33355 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33362 */     GIR_RootConstrainSelectedInstOperands,
     /*  33363 */     // GIR_Coverage, 1805,
     /*  33363 */     GIR_EraseRootFromParent_Done,
     /*  33364 */   // Label 531: @33364
     /*  33364 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(33415), // Rule ID 1719 //
     /*  33369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33394 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33401 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33413 */     GIR_RootConstrainSelectedInstOperands,
     /*  33414 */     // GIR_Coverage, 1719,
     /*  33414 */     GIR_EraseRootFromParent_Done,
     /*  33415 */   // Label 532: @33415
     /*  33415 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(33466), // Rule ID 1804 //
     /*  33420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33452 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33464 */     GIR_RootConstrainSelectedInstOperands,
     /*  33465 */     // GIR_Coverage, 1804,
     /*  33465 */     GIR_EraseRootFromParent_Done,
     /*  33466 */   // Label 533: @33466
     /*  33466 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(33535), // Rule ID 13278 //
     /*  33471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33486 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33489 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33498 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33516 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33518 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33533 */     GIR_RootConstrainSelectedInstOperands,
     /*  33534 */     // GIR_Coverage, 13278,
     /*  33534 */     GIR_EraseRootFromParent_Done,
     /*  33535 */   // Label 534: @33535
     /*  33535 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(33604), // Rule ID 13290 //
     /*  33540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33555 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33558 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33567 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33587 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33602 */     GIR_RootConstrainSelectedInstOperands,
     /*  33603 */     // GIR_Coverage, 13290,
     /*  33603 */     GIR_EraseRootFromParent_Done,
     /*  33604 */   // Label 535: @33604
     /*  33604 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(33660), // Rule ID 13240 //
     /*  33609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33624 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33627 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  33632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33645 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33647 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  33650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33658 */     GIR_RootConstrainSelectedInstOperands,
     /*  33659 */     // GIR_Coverage, 13240,
     /*  33659 */     GIR_EraseRootFromParent_Done,
     /*  33660 */   // Label 536: @33660
     /*  33660 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(33716), // Rule ID 13252 //
     /*  33665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33680 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  33683 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  33688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  33692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33697 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33703 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  33703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  33706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33714 */     GIR_RootConstrainSelectedInstOperands,
     /*  33715 */     // GIR_Coverage, 13252,
     /*  33715 */     GIR_EraseRootFromParent_Done,
     /*  33716 */   // Label 537: @33716
     /*  33716 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(33783), // Rule ID 13482 //
     /*  33721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  33736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33745 */     // MIs[1] imm
     /*  33745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33753 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33757 */     // MIs[2] Operand 1
     /*  33757 */     // No operand predicates
     /*  33757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33761 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33767 */     // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  33770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33781 */     GIR_RootConstrainSelectedInstOperands,
     /*  33782 */     // GIR_Coverage, 13482,
     /*  33782 */     GIR_EraseRootFromParent_Done,
     /*  33783 */   // Label 538: @33783
     /*  33783 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(33850), // Rule ID 13503 //
     /*  33788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  33803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33812 */     // MIs[1] imm
     /*  33812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  33816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  33820 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  33824 */     // MIs[2] Operand 1
     /*  33824 */     // No operand predicates
     /*  33824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33828 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  33832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33834 */     // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  33834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  33837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  33845 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  33848 */     GIR_RootConstrainSelectedInstOperands,
     /*  33849 */     // GIR_Coverage, 13503,
     /*  33849 */     GIR_EraseRootFromParent_Done,
     /*  33850 */   // Label 539: @33850
     /*  33850 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(33919), // Rule ID 1363 //
     /*  33855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33874 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33877 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33886 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33902 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33917 */     GIR_RootConstrainSelectedInstOperands,
     /*  33918 */     // GIR_Coverage, 1363,
     /*  33918 */     GIR_EraseRootFromParent_Done,
     /*  33919 */   // Label 540: @33919
     /*  33919 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(33988), // Rule ID 1486 //
     /*  33924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33943 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33946 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33955 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33959 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33971 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33986 */     GIR_RootConstrainSelectedInstOperands,
     /*  33987 */     // GIR_Coverage, 1486,
     /*  33987 */     GIR_EraseRootFromParent_Done,
     /*  33988 */   // Label 541: @33988
     /*  33988 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(34044), // Rule ID 991 //
     /*  33993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34012 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  34015 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  34020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34031 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34042 */     GIR_RootConstrainSelectedInstOperands,
     /*  34043 */     // GIR_Coverage, 991,
     /*  34043 */     GIR_EraseRootFromParent_Done,
     /*  34044 */   // Label 542: @34044
     /*  34044 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(34100), // Rule ID 1052 //
     /*  34049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34056 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34068 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  34071 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  34076 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34087 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34098 */     GIR_RootConstrainSelectedInstOperands,
     /*  34099 */     // GIR_Coverage, 1052,
     /*  34099 */     GIR_EraseRootFromParent_Done,
     /*  34100 */   // Label 543: @34100
     /*  34100 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(34167), // Rule ID 2234 //
     /*  34105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  34124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34133 */     // MIs[1] imm
     /*  34133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34141 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34145 */     // MIs[2] Operand 1
     /*  34145 */     // No operand predicates
     /*  34145 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34151 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  34154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34165 */     GIR_RootConstrainSelectedInstOperands,
     /*  34166 */     // GIR_Coverage, 2234,
     /*  34166 */     GIR_EraseRootFromParent_Done,
     /*  34167 */   // Label 544: @34167
     /*  34167 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(34234), // Rule ID 2293 //
     /*  34172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  34191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34200 */     // MIs[1] imm
     /*  34200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34208 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34212 */     // MIs[2] Operand 1
     /*  34212 */     // No operand predicates
     /*  34212 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34218 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  34221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34232 */     GIR_RootConstrainSelectedInstOperands,
     /*  34233 */     // GIR_Coverage, 2293,
     /*  34233 */     GIR_EraseRootFromParent_Done,
     /*  34234 */   // Label 545: @34234
     /*  34234 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(34304), // Rule ID 6901 //
     /*  34239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  34251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  34277 */     // MIs[2] Rn
     /*  34277 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34282 */     // MIs[2] Rm
     /*  34282 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34289 */     // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34302 */     GIR_RootConstrainSelectedInstOperands,
     /*  34303 */     // GIR_Coverage, 6901,
     /*  34303 */     GIR_EraseRootFromParent_Done,
     /*  34304 */   // Label 546: @34304
     /*  34304 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(34374), // Rule ID 13872 //
     /*  34309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  34321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  34347 */     // MIs[2] Rn
     /*  34347 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34352 */     // MIs[2] Rm
     /*  34352 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34359 */     // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34372 */     GIR_RootConstrainSelectedInstOperands,
     /*  34373 */     // GIR_Coverage, 13872,
     /*  34373 */     GIR_EraseRootFromParent_Done,
     /*  34374 */   // Label 547: @34374
     /*  34374 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(34437), // Rule ID 1781 //
     /*  34379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34415 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34420 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34422 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34435 */     GIR_RootConstrainSelectedInstOperands,
     /*  34436 */     // GIR_Coverage, 1781,
     /*  34436 */     GIR_EraseRootFromParent_Done,
     /*  34437 */   // Label 548: @34437
     /*  34437 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(34500), // Rule ID 1780 //
     /*  34442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34485 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34498 */     GIR_RootConstrainSelectedInstOperands,
     /*  34499 */     // GIR_Coverage, 1780,
     /*  34499 */     GIR_EraseRootFromParent_Done,
     /*  34500 */   // Label 549: @34500
     /*  34500 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(34563), // Rule ID 1712 //
     /*  34505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34541 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34548 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  34551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34561 */     GIR_RootConstrainSelectedInstOperands,
     /*  34562 */     // GIR_Coverage, 1712,
     /*  34562 */     GIR_EraseRootFromParent_Done,
     /*  34563 */   // Label 550: @34563
     /*  34563 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(34626), // Rule ID 1779 //
     /*  34568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34611 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34624 */     GIR_RootConstrainSelectedInstOperands,
     /*  34625 */     // GIR_Coverage, 1779,
     /*  34625 */     GIR_EraseRootFromParent_Done,
     /*  34626 */   // Label 551: @34626
     /*  34626 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(34689), // Rule ID 1778 //
     /*  34631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34667 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34674 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34687 */     GIR_RootConstrainSelectedInstOperands,
     /*  34688 */     // GIR_Coverage, 1778,
     /*  34688 */     GIR_EraseRootFromParent_Done,
     /*  34689 */   // Label 552: @34689
     /*  34689 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(34750), // Rule ID 13331 //
     /*  34694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  34709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34733 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  34736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34748 */     GIR_RootConstrainSelectedInstOperands,
     /*  34749 */     // GIR_Coverage, 13331,
     /*  34749 */     GIR_EraseRootFromParent_Done,
     /*  34750 */   // Label 553: @34750
     /*  34750 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(34811), // Rule ID 13361 //
     /*  34755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  34770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  34778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34794 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  34797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34805 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34809 */     GIR_RootConstrainSelectedInstOperands,
     /*  34810 */     // GIR_Coverage, 13361,
     /*  34810 */     GIR_EraseRootFromParent_Done,
     /*  34811 */   // Label 554: @34811
     /*  34811 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(34859), // Rule ID 13350 //
     /*  34816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34846 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  34849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34857 */     GIR_RootConstrainSelectedInstOperands,
     /*  34858 */     // GIR_Coverage, 13350,
     /*  34858 */     GIR_EraseRootFromParent_Done,
     /*  34859 */   // Label 555: @34859
     /*  34859 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(34907), // Rule ID 13239 //
     /*  34864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  34879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34894 */     // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34905 */     GIR_RootConstrainSelectedInstOperands,
     /*  34906 */     // GIR_Coverage, 13239,
     /*  34906 */     GIR_EraseRootFromParent_Done,
     /*  34907 */   // Label 556: @34907
     /*  34907 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(34955), // Rule ID 13325 //
     /*  34912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34940 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34942 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  34945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  34949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  34953 */     GIR_RootConstrainSelectedInstOperands,
     /*  34954 */     // GIR_Coverage, 13325,
     /*  34954 */     GIR_EraseRootFromParent_Done,
     /*  34955 */   // Label 557: @34955
     /*  34955 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(35003), // Rule ID 13251 //
     /*  34960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  34975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34990 */     // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35001 */     GIR_RootConstrainSelectedInstOperands,
     /*  35002 */     // GIR_Coverage, 13251,
     /*  35002 */     GIR_EraseRootFromParent_Done,
     /*  35003 */   // Label 558: @35003
     /*  35003 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(35051), // Rule ID 13349 //
     /*  35008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35038 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  35045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35049 */     GIR_RootConstrainSelectedInstOperands,
     /*  35050 */     // GIR_Coverage, 13349,
     /*  35050 */     GIR_EraseRootFromParent_Done,
     /*  35051 */   // Label 559: @35051
     /*  35051 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(35112), // Rule ID 1724 //
     /*  35056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35063 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  35075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  35083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35095 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  35098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35102 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35110 */     GIR_RootConstrainSelectedInstOperands,
     /*  35111 */     // GIR_Coverage, 1724,
     /*  35111 */     GIR_EraseRootFromParent_Done,
     /*  35112 */   // Label 560: @35112
     /*  35112 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(35173), // Rule ID 1814 //
     /*  35117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  35136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35140 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  35144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35154 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35156 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  35159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35171 */     GIR_RootConstrainSelectedInstOperands,
     /*  35172 */     // GIR_Coverage, 1814,
     /*  35172 */     GIR_EraseRootFromParent_Done,
     /*  35173 */   // Label 561: @35173
     /*  35173 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(35221), // Rule ID 1803 //
     /*  35178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35185 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35208 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35213 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35219 */     GIR_RootConstrainSelectedInstOperands,
     /*  35220 */     // GIR_Coverage, 1803,
     /*  35220 */     GIR_EraseRootFromParent_Done,
     /*  35221 */   // Label 562: @35221
     /*  35221 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(35269), // Rule ID 990 //
     /*  35226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  35245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35256 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  35259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35267 */     GIR_RootConstrainSelectedInstOperands,
     /*  35268 */     // GIR_Coverage, 990,
     /*  35268 */     GIR_EraseRootFromParent_Done,
     /*  35269 */   // Label 563: @35269
     /*  35269 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(35317), // Rule ID 1718 //
     /*  35274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35297 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35304 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  35307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35315 */     GIR_RootConstrainSelectedInstOperands,
     /*  35316 */     // GIR_Coverage, 1718,
     /*  35316 */     GIR_EraseRootFromParent_Done,
     /*  35317 */   // Label 564: @35317
     /*  35317 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(35365), // Rule ID 1051 //
     /*  35322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  35341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35352 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  35355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35363 */     GIR_RootConstrainSelectedInstOperands,
     /*  35364 */     // GIR_Coverage, 1051,
     /*  35364 */     GIR_EraseRootFromParent_Done,
     /*  35365 */   // Label 565: @35365
     /*  35365 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(35413), // Rule ID 1802 //
     /*  35370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35400 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35411 */     GIR_RootConstrainSelectedInstOperands,
     /*  35412 */     // GIR_Coverage, 1802,
     /*  35412 */     GIR_EraseRootFromParent_Done,
     /*  35413 */   // Label 566: @35413
     /*  35413 */   GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(35440), // Rule ID 1103 //
     /*  35418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35433 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  35433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
     /*  35438 */     GIR_RootConstrainSelectedInstOperands,
     /*  35439 */     // GIR_Coverage, 1103,
     /*  35439 */     GIR_Done,
     /*  35440 */   // Label 567: @35440
     /*  35440 */   GIM_Reject,
     /*  35441 */ // Label 510: @35441
     /*  35441 */ GIM_Reject,
     /*  35442 */ // Label 166: @35442
     /*  35442 */ GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(36165),
     /*  35447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35453 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(35522), // Rule ID 13274 //
     /*  35458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35473 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35476 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35485 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35505 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35520 */     GIR_RootConstrainSelectedInstOperands,
     /*  35521 */     // GIR_Coverage, 13274,
     /*  35521 */     GIR_EraseRootFromParent_Done,
     /*  35522 */   // Label 569: @35522
     /*  35522 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(35591), // Rule ID 13286 //
     /*  35527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35542 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35545 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35554 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35572 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35574 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35589 */     GIR_RootConstrainSelectedInstOperands,
     /*  35590 */     // GIR_Coverage, 13286,
     /*  35590 */     GIR_EraseRootFromParent_Done,
     /*  35591 */   // Label 570: @35591
     /*  35591 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(35658), // Rule ID 13478 //
     /*  35596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35620 */     // MIs[1] imm
     /*  35620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35628 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35632 */     // MIs[2] Operand 1
     /*  35632 */     // No operand predicates
     /*  35632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35636 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35640 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35642 */     // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35656 */     GIR_RootConstrainSelectedInstOperands,
     /*  35657 */     // GIR_Coverage, 13478,
     /*  35657 */     GIR_EraseRootFromParent_Done,
     /*  35658 */   // Label 571: @35658
     /*  35658 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(35725), // Rule ID 13499 //
     /*  35663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35687 */     // MIs[1] imm
     /*  35687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35695 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35699 */     // MIs[2] Operand 1
     /*  35699 */     // No operand predicates
     /*  35699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35703 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35707 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35709 */     // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35723 */     GIR_RootConstrainSelectedInstOperands,
     /*  35724 */     // GIR_Coverage, 13499,
     /*  35724 */     GIR_EraseRootFromParent_Done,
     /*  35725 */   // Label 572: @35725
     /*  35725 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(35794), // Rule ID 1359 //
     /*  35730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35749 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35752 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35761 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35777 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35782 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35792 */     GIR_RootConstrainSelectedInstOperands,
     /*  35793 */     // GIR_Coverage, 1359,
     /*  35793 */     GIR_EraseRootFromParent_Done,
     /*  35794 */   // Label 573: @35794
     /*  35794 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(35863), // Rule ID 1482 //
     /*  35799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35818 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35821 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35830 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35846 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35861 */     GIR_RootConstrainSelectedInstOperands,
     /*  35862 */     // GIR_Coverage, 1482,
     /*  35862 */     GIR_EraseRootFromParent_Done,
     /*  35863 */   // Label 574: @35863
     /*  35863 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(35930), // Rule ID 2230 //
     /*  35868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  35887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35896 */     // MIs[1] imm
     /*  35896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35904 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35908 */     // MIs[2] Operand 1
     /*  35908 */     // No operand predicates
     /*  35908 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35914 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  35917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35928 */     GIR_RootConstrainSelectedInstOperands,
     /*  35929 */     // GIR_Coverage, 2230,
     /*  35929 */     GIR_EraseRootFromParent_Done,
     /*  35930 */   // Label 575: @35930
     /*  35930 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(35997), // Rule ID 2289 //
     /*  35935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35946 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35950 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  35954 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35963 */     // MIs[1] imm
     /*  35963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  35967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  35971 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  35975 */     // MIs[2] Operand 1
     /*  35975 */     // No operand predicates
     /*  35975 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  35979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35981 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  35981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  35984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35986 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  35995 */     GIR_RootConstrainSelectedInstOperands,
     /*  35996 */     // GIR_Coverage, 2289,
     /*  35996 */     GIR_EraseRootFromParent_Done,
     /*  35997 */   // Label 576: @35997
     /*  35997 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(36067), // Rule ID 6902 //
     /*  36002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  36014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  36036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  36040 */     // MIs[2] Rn
     /*  36040 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  36045 */     // MIs[2] Rm
     /*  36045 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  36050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36052 */     // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  36052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  36055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  36065 */     GIR_RootConstrainSelectedInstOperands,
     /*  36066 */     // GIR_Coverage, 6902,
     /*  36066 */     GIR_EraseRootFromParent_Done,
     /*  36067 */   // Label 577: @36067
     /*  36067 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(36137), // Rule ID 13873 //
     /*  36072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  36084 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  36106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  36110 */     // MIs[2] Rn
     /*  36110 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  36115 */     // MIs[2] Rm
     /*  36115 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  36120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36122 */     // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  36122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  36125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  36135 */     GIR_RootConstrainSelectedInstOperands,
     /*  36136 */     // GIR_Coverage, 13873,
     /*  36136 */     GIR_EraseRootFromParent_Done,
     /*  36137 */   // Label 578: @36137
     /*  36137 */   GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(36164), // Rule ID 1101 //
     /*  36142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36157 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  36157 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
     /*  36162 */     GIR_RootConstrainSelectedInstOperands,
     /*  36163 */     // GIR_Coverage, 1101,
     /*  36163 */     GIR_Done,
     /*  36164 */   // Label 579: @36164
     /*  36164 */   GIM_Reject,
     /*  36165 */ // Label 568: @36165
     /*  36165 */ GIM_Reject,
     /*  36166 */ // Label 167: @36166
     /*  36166 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(36537),
     /*  36171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36181 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(36243), // Rule ID 15057 //
     /*  36186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36217 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36230 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36241 */     GIR_RootConstrainSelectedInstOperands,
     /*  36242 */     // GIR_Coverage, 15057,
     /*  36242 */     GIR_EraseRootFromParent_Done,
     /*  36243 */   // Label 581: @36243
     /*  36243 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(36305), // Rule ID 15056 //
     /*  36248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36279 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36292 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36303 */     GIR_RootConstrainSelectedInstOperands,
     /*  36304 */     // GIR_Coverage, 15056,
     /*  36304 */     GIR_EraseRootFromParent_Done,
     /*  36305 */   // Label 582: @36305
     /*  36305 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(36367), // Rule ID 15055 //
     /*  36310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36325 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36329 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36333 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36337 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36341 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36352 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36354 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36359 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36365 */     GIR_RootConstrainSelectedInstOperands,
     /*  36366 */     // GIR_Coverage, 15055,
     /*  36366 */     GIR_EraseRootFromParent_Done,
     /*  36367 */   // Label 583: @36367
     /*  36367 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(36429), // Rule ID 8841 //
     /*  36372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36403 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36416 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36427 */     GIR_RootConstrainSelectedInstOperands,
     /*  36428 */     // GIR_Coverage, 8841,
     /*  36428 */     GIR_EraseRootFromParent_Done,
     /*  36429 */   // Label 584: @36429
     /*  36429 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(36475), // Rule ID 15058 //
     /*  36434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36449 */     // MIs[1] Operand 2
     /*  36449 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36462 */     // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36473 */     GIR_RootConstrainSelectedInstOperands,
     /*  36474 */     // GIR_Coverage, 15058,
     /*  36474 */     GIR_EraseRootFromParent_Done,
     /*  36475 */   // Label 585: @36475
     /*  36475 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(36521), // Rule ID 8842 //
     /*  36480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36495 */     // MIs[1] Operand 2
     /*  36495 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36506 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36508 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36519 */     GIR_RootConstrainSelectedInstOperands,
     /*  36520 */     // GIR_Coverage, 8842,
     /*  36520 */     GIR_EraseRootFromParent_Done,
     /*  36521 */   // Label 586: @36521
     /*  36521 */   GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(36536), // Rule ID 2778 //
     /*  36526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36529 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36529 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
     /*  36534 */     GIR_RootConstrainSelectedInstOperands,
     /*  36535 */     // GIR_Coverage, 2778,
     /*  36535 */     GIR_Done,
     /*  36536 */   // Label 587: @36536
     /*  36536 */   GIM_Reject,
     /*  36537 */ // Label 580: @36537
     /*  36537 */ GIM_Reject,
     /*  36538 */ // Label 168: @36538
     /*  36538 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(36563), // Rule ID 2777 //
     /*  36543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  36549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  36552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36556 */   // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  36556 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
     /*  36561 */   GIR_RootConstrainSelectedInstOperands,
     /*  36562 */   // GIR_Coverage, 2777,
     /*  36562 */   GIR_Done,
     /*  36563 */ // Label 588: @36563
     /*  36563 */ GIM_Reject,
     /*  36564 */ // Label 169: @36564
     /*  36564 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(36589), // Rule ID 2776 //
     /*  36569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  36575 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  36578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36582 */   // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  36582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
     /*  36587 */   GIR_RootConstrainSelectedInstOperands,
     /*  36588 */   // GIR_Coverage, 2776,
     /*  36588 */   GIR_Done,
     /*  36589 */ // Label 589: @36589
     /*  36589 */ GIM_Reject,
     /*  36590 */ // Label 170: @36590
     /*  36590 */ GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(36615), // Rule ID 2775 //
     /*  36595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  36601 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  36604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36608 */   // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  36608 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
     /*  36613 */   GIR_RootConstrainSelectedInstOperands,
     /*  36614 */   // GIR_Coverage, 2775,
     /*  36614 */   GIR_Done,
     /*  36615 */ // Label 590: @36615
     /*  36615 */ GIM_Reject,
     /*  36616 */ // Label 171: @36616
     /*  36616 */ GIM_Reject,
     /*  36617 */ // Label 1: @36617
     /*  36617 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 604*/ GIMT_Encode4(50844),
     /*  36628 */ /*GILLT_s32*//*Label 591*/ GIMT_Encode4(36716),
     /*  36632 */ /*GILLT_s64*//*Label 592*/ GIMT_Encode4(38198), GIMT_Encode4(0),
     /*  36640 */ /*GILLT_v2s32*//*Label 593*/ GIMT_Encode4(41480),
     /*  36644 */ /*GILLT_v2s64*//*Label 594*/ GIMT_Encode4(42971),
     /*  36648 */ /*GILLT_v4s16*//*Label 595*/ GIMT_Encode4(45431),
     /*  36652 */ /*GILLT_v4s32*//*Label 596*/ GIMT_Encode4(46922),
     /*  36656 */ /*GILLT_v8s8*//*Label 597*/ GIMT_Encode4(49382),
     /*  36660 */ /*GILLT_v8s16*//*Label 598*/ GIMT_Encode4(49457),
     /*  36664 */ /*GILLT_v16s8*//*Label 599*/ GIMT_Encode4(50665), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36684 */ /*GILLT_nxv2s64*//*Label 600*/ GIMT_Encode4(50740), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  36696 */ /*GILLT_nxv4s32*//*Label 601*/ GIMT_Encode4(50766), GIMT_Encode4(0),
     /*  36704 */ /*GILLT_nxv8s16*//*Label 602*/ GIMT_Encode4(50792), GIMT_Encode4(0),
     /*  36712 */ /*GILLT_nxv16s8*//*Label 603*/ GIMT_Encode4(50818),
     /*  36716 */ // Label 591: @36716
     /*  36716 */ GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(38197),
     /*  36721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36727 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(36879), // Rule ID 9888 //
     /*  36732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36763 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36766 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  36771 */     // MIs[2] pattern
     /*  36771 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36774 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36781 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36781 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36784 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36788 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36795 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36798 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36802 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36807 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36810 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36814 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36817 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36822 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36827 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  36839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36844 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36847 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  36851 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  36854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  36859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36861 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  36868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  36878 */     // GIR_Coverage, 9888,
     /*  36878 */     GIR_EraseRootFromParent_Done,
     /*  36879 */   // Label 606: @36879
     /*  36879 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(37031), // Rule ID 9900 //
     /*  36884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  36887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  36903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  36907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36915 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  36918 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  36923 */     // MIs[2] pattern
     /*  36923 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  36926 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  36931 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36933 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  36933 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  36936 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36940 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36945 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  36947 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  36950 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  36954 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36959 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  36962 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  36966 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  36969 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36974 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  36979 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  36984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  36987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  36991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36996 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  36999 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37003 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37013 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37025 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37030 */     // GIR_Coverage, 9900,
     /*  37030 */     GIR_EraseRootFromParent_Done,
     /*  37031 */   // Label 607: @37031
     /*  37031 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(37183), // Rule ID 9912 //
     /*  37036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37043 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37067 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37070 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  37075 */     // MIs[2] pattern
     /*  37075 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37078 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37085 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37085 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37088 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37092 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37099 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37102 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37106 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37111 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37114 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37118 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37121 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37126 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37131 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37136 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37139 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  37143 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37148 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37151 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37155 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37165 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37182 */     // GIR_Coverage, 9912,
     /*  37182 */     GIR_EraseRootFromParent_Done,
     /*  37183 */   // Label 608: @37183
     /*  37183 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(37335), // Rule ID 9924 //
     /*  37188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37219 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37222 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  37227 */     // MIs[2] pattern
     /*  37227 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37230 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37237 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37237 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37240 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37244 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37249 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37251 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37254 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37258 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37263 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37266 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37270 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37273 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37278 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37283 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  37295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37300 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37303 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37307 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37317 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37324 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37334 */     // GIR_Coverage, 9924,
     /*  37334 */     GIR_EraseRootFromParent_Done,
     /*  37335 */   // Label 609: @37335
     /*  37335 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(37397), // Rule ID 3941 //
     /*  37340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37344 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  37348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37356 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37360 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37376 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  37376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  37379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  37385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  37389 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37395 */     GIR_RootConstrainSelectedInstOperands,
     /*  37396 */     // GIR_Coverage, 3941,
     /*  37396 */     GIR_EraseRootFromParent_Done,
     /*  37397 */   // Label 610: @37397
     /*  37397 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(37554), // Rule ID 10026 //
     /*  37402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37433 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37436 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  37445 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37447 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37452 */     // MIs[2] pred
     /*  37452 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37459 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37459 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37462 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37466 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37471 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37473 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37476 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37480 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37485 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37488 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37492 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37495 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  37517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37526 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37536 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37543 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37553 */     // GIR_Coverage, 10026,
     /*  37553 */     GIR_EraseRootFromParent_Done,
     /*  37554 */   // Label 611: @37554
     /*  37554 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(37711), // Rule ID 10027 //
     /*  37559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37590 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37593 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  37602 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37609 */     // MIs[2] pred
     /*  37609 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37614 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37616 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37616 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37619 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37623 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37630 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37633 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37637 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37642 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37645 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37649 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37652 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37657 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37662 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  37674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37679 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37683 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37686 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37693 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37710 */     // GIR_Coverage, 10027,
     /*  37710 */     GIR_EraseRootFromParent_Done,
     /*  37711 */   // Label 612: @37711
     /*  37711 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(37868), // Rule ID 10028 //
     /*  37716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37747 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37750 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  37759 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37761 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37766 */     // MIs[2] pred
     /*  37766 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37773 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37773 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37776 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37780 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37787 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37790 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37794 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37799 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37802 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37806 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37809 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37814 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37819 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  37831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37836 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37840 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37843 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37850 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37867 */     // GIR_Coverage, 10028,
     /*  37867 */     GIR_EraseRootFromParent_Done,
     /*  37868 */   // Label 613: @37868
     /*  37868 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(38025), // Rule ID 10029 //
     /*  37873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37904 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37907 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37912 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  37916 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37923 */     // MIs[2] pred
     /*  37923 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37930 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37930 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37933 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37937 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37944 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37947 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37951 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37956 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37959 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37963 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37966 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37971 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37976 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37981 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37984 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  37988 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37993 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37997 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38007 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  38014 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38024 */     // GIR_Coverage, 10029,
     /*  38024 */     GIR_EraseRootFromParent_Done,
     /*  38025 */   // Label 614: @38025
     /*  38025 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(38061), // Rule ID 3906 //
     /*  38030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  38038 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*  38045 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
     /*  38045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
     /*  38048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38050 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  38052 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  38056 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38059 */     GIR_RootConstrainSelectedInstOperands,
     /*  38060 */     // GIR_Coverage, 3906,
     /*  38060 */     GIR_EraseRootFromParent_Done,
     /*  38061 */   // Label 615: @38061
     /*  38061 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(38094), // Rule ID 3911 //
     /*  38066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  38070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38074 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*  38081 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  38081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*  38084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38088 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  38092 */     GIR_RootConstrainSelectedInstOperands,
     /*  38093 */     // GIR_Coverage, 3911,
     /*  38093 */     GIR_EraseRootFromParent_Done,
     /*  38094 */   // Label 616: @38094
     /*  38094 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(38130), // Rule ID 3900 //
     /*  38099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  38107 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*  38114 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  38114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*  38117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38121 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  38125 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38128 */     GIR_RootConstrainSelectedInstOperands,
     /*  38129 */     // GIR_Coverage, 3900,
     /*  38129 */     GIR_EraseRootFromParent_Done,
     /*  38130 */   // Label 617: @38130
     /*  38130 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(38166), // Rule ID 3904 //
     /*  38135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*  38150 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
     /*  38150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
     /*  38153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38155 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38157 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  38161 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38164 */     GIR_RootConstrainSelectedInstOperands,
     /*  38165 */     // GIR_Coverage, 3904,
     /*  38165 */     GIR_EraseRootFromParent_Done,
     /*  38166 */   // Label 618: @38166
     /*  38166 */   GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(38196), // Rule ID 3902 //
     /*  38171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38183 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  38183 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
     /*  38188 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  38194 */     GIR_RootConstrainSelectedInstOperands,
     /*  38195 */     // GIR_Coverage, 3902,
     /*  38195 */     GIR_Done,
     /*  38196 */   // Label 619: @38196
     /*  38196 */   GIM_Reject,
     /*  38197 */ // Label 605: @38197
     /*  38197 */ GIM_Reject,
     /*  38198 */ // Label 592: @38198
     /*  38198 */ GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(41479),
     /*  38203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  38206 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  38209 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(38345), // Rule ID 5384 //
     /*  38214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38247 */     // MIs[1] Operand 2
     /*  38247 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38266 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38270 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38274 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38278 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38282 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38287 */     // MIs[3] Operand 2
     /*  38287 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38298 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38300 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38312 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38327 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38334 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38339 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38344 */     // GIR_Coverage, 5384,
     /*  38344 */     GIR_EraseRootFromParent_Done,
     /*  38345 */   // Label 621: @38345
     /*  38345 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(38481), // Rule ID 5383 //
     /*  38350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38383 */     // MIs[1] Operand 2
     /*  38383 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38394 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38398 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38402 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38406 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38410 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38414 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38418 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38423 */     // MIs[3] Operand 2
     /*  38423 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38434 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38436 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38448 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38452 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38456 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38463 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38480 */     // GIR_Coverage, 5383,
     /*  38480 */     GIR_EraseRootFromParent_Done,
     /*  38481 */   // Label 622: @38481
     /*  38481 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(38617), // Rule ID 5393 //
     /*  38486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38514 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38519 */     // MIs[1] Operand 2
     /*  38519 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38538 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38542 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38546 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38550 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38554 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38559 */     // MIs[3] Operand 2
     /*  38559 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38570 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38572 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38572 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38575 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  38579 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38584 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38588 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38599 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38606 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38616 */     // GIR_Coverage, 5393,
     /*  38616 */     GIR_EraseRootFromParent_Done,
     /*  38617 */   // Label 623: @38617
     /*  38617 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(38753), // Rule ID 5382 //
     /*  38622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38655 */     // MIs[1] Operand 2
     /*  38655 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38674 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38678 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38682 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38686 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38690 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38695 */     // MIs[3] Operand 2
     /*  38695 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38706 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38708 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38720 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38724 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38735 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38742 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38747 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38752 */     // GIR_Coverage, 5382,
     /*  38752 */     GIR_EraseRootFromParent_Done,
     /*  38753 */   // Label 624: @38753
     /*  38753 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(38889), // Rule ID 5381 //
     /*  38758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38791 */     // MIs[1] Operand 2
     /*  38791 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38810 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38814 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38818 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38822 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38826 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38831 */     // MIs[3] Operand 2
     /*  38831 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38842 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38844 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38860 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38871 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38888 */     // GIR_Coverage, 5381,
     /*  38888 */     GIR_EraseRootFromParent_Done,
     /*  38889 */   // Label 625: @38889
     /*  38889 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(39026), // Rule ID 3958 //
     /*  38894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  38902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  38910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  38918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  38926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  38930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38935 */     // MIs[2] Operand 2
     /*  38935 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  38946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  38950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  38954 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  38958 */     // MIs[3] Operand 1
     /*  38958 */     // No operand predicates
     /*  38958 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  38960 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  38960 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  38963 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  38967 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38972 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  38977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  38979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  38982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38991 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  38997 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39002 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39012 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  39018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39024 */     GIR_RootConstrainSelectedInstOperands,
     /*  39025 */     // GIR_Coverage, 3958,
     /*  39025 */     GIR_EraseRootFromParent_Done,
     /*  39026 */   // Label 626: @39026
     /*  39026 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(39125), // Rule ID 3956 //
     /*  39031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39035 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39080 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39084 */     // MIs[3] Operand 1
     /*  39084 */     // No operand predicates
     /*  39084 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39086 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  39086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39098 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39103 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39123 */     GIR_RootConstrainSelectedInstOperands,
     /*  39124 */     // GIR_Coverage, 3956,
     /*  39124 */     GIR_EraseRootFromParent_Done,
     /*  39125 */   // Label 627: @39125
     /*  39125 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(39224), // Rule ID 3957 //
     /*  39130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39134 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39179 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  39183 */     // MIs[3] Operand 1
     /*  39183 */     // No operand predicates
     /*  39183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39185 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  39185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39197 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39222 */     GIR_RootConstrainSelectedInstOperands,
     /*  39223 */     // GIR_Coverage, 3957,
     /*  39223 */     GIR_EraseRootFromParent_Done,
     /*  39224 */   // Label 628: @39224
     /*  39224 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(39310), // Rule ID 3951 //
     /*  39229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39261 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39274 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39278 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39282 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39287 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39289 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39302 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39308 */     GIR_RootConstrainSelectedInstOperands,
     /*  39309 */     // GIR_Coverage, 3951,
     /*  39309 */     GIR_EraseRootFromParent_Done,
     /*  39310 */   // Label 629: @39310
     /*  39310 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(39396), // Rule ID 3952 //
     /*  39315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39319 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39347 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39364 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39368 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39373 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39375 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39394 */     GIR_RootConstrainSelectedInstOperands,
     /*  39395 */     // GIR_Coverage, 3952,
     /*  39395 */     GIR_EraseRootFromParent_Done,
     /*  39396 */   // Label 630: @39396
     /*  39396 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(39529), // Rule ID 3964 //
     /*  39401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  39433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  39437 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39442 */     // MIs[2] Operand 2
     /*  39442 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  39453 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39457 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39461 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39465 */     // MIs[3] Operand 1
     /*  39465 */     // No operand predicates
     /*  39465 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39467 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39467 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  39470 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39474 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39479 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  39486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39498 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39504 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39509 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  39525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39527 */     GIR_RootConstrainSelectedInstOperands,
     /*  39528 */     // GIR_Coverage, 3964,
     /*  39528 */     GIR_EraseRootFromParent_Done,
     /*  39529 */   // Label 631: @39529
     /*  39529 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(39624), // Rule ID 3962 //
     /*  39534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39566 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39570 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39575 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39579 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39583 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39587 */     // MIs[3] Operand 1
     /*  39587 */     // No operand predicates
     /*  39587 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39589 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39601 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39622 */     GIR_RootConstrainSelectedInstOperands,
     /*  39623 */     // GIR_Coverage, 3962,
     /*  39623 */     GIR_EraseRootFromParent_Done,
     /*  39624 */   // Label 632: @39624
     /*  39624 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(39719), // Rule ID 3963 //
     /*  39629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39678 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  39682 */     // MIs[3] Operand 1
     /*  39682 */     // No operand predicates
     /*  39682 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39684 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  39684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39696 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39701 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39715 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39717 */     GIR_RootConstrainSelectedInstOperands,
     /*  39718 */     // GIR_Coverage, 3963,
     /*  39718 */     GIR_EraseRootFromParent_Done,
     /*  39719 */   // Label 633: @39719
     /*  39719 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(39801), // Rule ID 124 //
     /*  39724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39756 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39773 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39777 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39782 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39784 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39799 */     GIR_RootConstrainSelectedInstOperands,
     /*  39800 */     // GIR_Coverage, 124,
     /*  39800 */     GIR_EraseRootFromParent_Done,
     /*  39801 */   // Label 634: @39801
     /*  39801 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(39883), // Rule ID 126 //
     /*  39806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39826 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39851 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39855 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39859 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39864 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39866 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  39866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  39881 */     GIR_RootConstrainSelectedInstOperands,
     /*  39882 */     // GIR_Coverage, 126,
     /*  39882 */     GIR_EraseRootFromParent_Done,
     /*  39883 */   // Label 635: @39883
     /*  39883 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(39945), // Rule ID 3942 //
     /*  39888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39892 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39922 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39924 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  39924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  39927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  39933 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  39937 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39943 */     GIR_RootConstrainSelectedInstOperands,
     /*  39944 */     // GIR_Coverage, 3942,
     /*  39944 */     GIR_EraseRootFromParent_Done,
     /*  39945 */   // Label 636: @39945
     /*  39945 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(40003), // Rule ID 9885 //
     /*  39950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  39953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  39969 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  39972 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  39977 */     // MIs[1] pattern
     /*  39977 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  39980 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  39985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  39987 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  39987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  39990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  39992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  39994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  39998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40001 */     GIR_RootConstrainSelectedInstOperands,
     /*  40002 */     // GIR_Coverage, 9885,
     /*  40002 */     GIR_EraseRootFromParent_Done,
     /*  40003 */   // Label 637: @40003
     /*  40003 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(40061), // Rule ID 9897 //
     /*  40008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40027 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40030 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  40035 */     // MIs[1] pattern
     /*  40035 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40038 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40045 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  40048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40059 */     GIR_RootConstrainSelectedInstOperands,
     /*  40060 */     // GIR_Coverage, 9897,
     /*  40060 */     GIR_EraseRootFromParent_Done,
     /*  40061 */   // Label 638: @40061
     /*  40061 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(40119), // Rule ID 9909 //
     /*  40066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40085 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40088 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  40093 */     // MIs[1] pattern
     /*  40093 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40096 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40103 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  40106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40108 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40117 */     GIR_RootConstrainSelectedInstOperands,
     /*  40118 */     // GIR_Coverage, 9909,
     /*  40118 */     GIR_EraseRootFromParent_Done,
     /*  40119 */   // Label 639: @40119
     /*  40119 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(40177), // Rule ID 9921 //
     /*  40124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40143 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40146 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  40151 */     // MIs[1] pattern
     /*  40151 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40154 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40159 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40161 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  40164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40166 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40175 */     GIR_RootConstrainSelectedInstOperands,
     /*  40176 */     // GIR_Coverage, 9921,
     /*  40176 */     GIR_EraseRootFromParent_Done,
     /*  40177 */   // Label 640: @40177
     /*  40177 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40340), // Rule ID 5348 //
     /*  40182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  40210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40218 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40228 */     // MIs[1] Operand 2
     /*  40228 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40239 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40241 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40241 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40244 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40248 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40253 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40255 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40258 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40262 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40267 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40270 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40274 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40277 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40282 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40287 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  40299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40304 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40307 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40311 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40322 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40329 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40334 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40339 */     // GIR_Coverage, 5348,
     /*  40339 */     GIR_EraseRootFromParent_Done,
     /*  40340 */   // Label 641: @40340
     /*  40340 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(40503), // Rule ID 5345 //
     /*  40345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  40373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40391 */     // MIs[1] Operand 2
     /*  40391 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40404 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40404 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40407 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40411 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40418 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40421 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40425 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40430 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40433 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  40437 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40440 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40445 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40450 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  40462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40467 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40470 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40474 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  40478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40485 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40497 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40502 */     // GIR_Coverage, 5345,
     /*  40502 */     GIR_EraseRootFromParent_Done,
     /*  40503 */   // Label 642: @40503
     /*  40503 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(40653), // Rule ID 5390 //
     /*  40508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  40536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40545 */     // MIs[1] Operand 2
     /*  40545 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40558 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40558 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40561 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40565 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40570 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40572 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40575 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40579 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40584 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40587 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40591 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40594 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40599 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40604 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40621 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40624 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40635 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40652 */     // GIR_Coverage, 5390,
     /*  40652 */     GIR_EraseRootFromParent_Done,
     /*  40653 */   // Label 643: @40653
     /*  40653 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(40803), // Rule ID 5396 //
     /*  40658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40690 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40695 */     // MIs[1] Operand 2
     /*  40695 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40708 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40708 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40711 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40715 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40722 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40725 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40729 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40734 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40737 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40741 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40744 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40749 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40754 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  40766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40771 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40785 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40792 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40802 */     // GIR_Coverage, 5396,
     /*  40802 */     GIR_EraseRootFromParent_Done,
     /*  40803 */   // Label 644: @40803
     /*  40803 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(40953), // Rule ID 5389 //
     /*  40808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  40824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  40828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  40840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40845 */     // MIs[1] Operand 2
     /*  40845 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  40856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40858 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  40858 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  40861 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  40865 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40870 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  40872 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  40875 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  40879 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40884 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  40887 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  40891 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  40894 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40899 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40904 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  40912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  40916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40921 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  40924 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  40935 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  40942 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  40947 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  40952 */     // GIR_Coverage, 5389,
     /*  40952 */     GIR_EraseRootFromParent_Done,
     /*  40953 */   // Label 645: @40953
     /*  40953 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(40989), // Rule ID 3907 //
     /*  40958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40962 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40966 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  40973 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
     /*  40973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
     /*  40976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40978 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  40980 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  40984 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  40987 */     GIR_RootConstrainSelectedInstOperands,
     /*  40988 */     // GIR_Coverage, 3907,
     /*  40988 */     GIR_EraseRootFromParent_Done,
     /*  40989 */   // Label 646: @40989
     /*  40989 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(41022), // Rule ID 3912 //
     /*  40994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  40998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  41009 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  41009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*  41012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41014 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41016 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  41020 */     GIR_RootConstrainSelectedInstOperands,
     /*  41021 */     // GIR_Coverage, 3912,
     /*  41021 */     GIR_EraseRootFromParent_Done,
     /*  41022 */   // Label 647: @41022
     /*  41022 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(41058), // Rule ID 3901 //
     /*  41027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  41035 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*  41042 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  41042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  41045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41047 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41049 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  41053 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  41056 */     GIR_RootConstrainSelectedInstOperands,
     /*  41057 */     // GIR_Coverage, 3901,
     /*  41057 */     GIR_EraseRootFromParent_Done,
     /*  41058 */   // Label 648: @41058
     /*  41058 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(41094), // Rule ID 3905 //
     /*  41063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  41078 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
     /*  41078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
     /*  41081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  41089 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  41092 */     GIR_RootConstrainSelectedInstOperands,
     /*  41093 */     // GIR_Coverage, 3905,
     /*  41093 */     GIR_EraseRootFromParent_Done,
     /*  41094 */   // Label 649: @41094
     /*  41094 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(41157), // Rule ID 10018 //
     /*  41099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41118 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41121 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  41130 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41137 */     // MIs[1] pred
     /*  41137 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41144 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  41147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41153 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41155 */     GIR_RootConstrainSelectedInstOperands,
     /*  41156 */     // GIR_Coverage, 10018,
     /*  41156 */     GIR_EraseRootFromParent_Done,
     /*  41157 */   // Label 650: @41157
     /*  41157 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(41220), // Rule ID 10019 //
     /*  41162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41181 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41184 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  41193 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41200 */     // MIs[1] pred
     /*  41200 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41207 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  41210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41218 */     GIR_RootConstrainSelectedInstOperands,
     /*  41219 */     // GIR_Coverage, 10019,
     /*  41219 */     GIR_EraseRootFromParent_Done,
     /*  41220 */   // Label 651: @41220
     /*  41220 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(41283), // Rule ID 10020 //
     /*  41225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41244 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41247 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  41256 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41263 */     // MIs[1] pred
     /*  41263 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41270 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  41273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41279 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41281 */     GIR_RootConstrainSelectedInstOperands,
     /*  41282 */     // GIR_Coverage, 10020,
     /*  41282 */     GIR_EraseRootFromParent_Done,
     /*  41283 */   // Label 652: @41283
     /*  41283 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(41346), // Rule ID 10021 //
     /*  41288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  41291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  41307 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  41310 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  41315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  41319 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  41321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  41326 */     // MIs[1] pred
     /*  41326 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  41331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41333 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  41333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  41336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  41338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  41342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41344 */     GIR_RootConstrainSelectedInstOperands,
     /*  41345 */     // GIR_Coverage, 10021,
     /*  41345 */     GIR_EraseRootFromParent_Done,
     /*  41346 */   // Label 653: @41346
     /*  41346 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(41385), // Rule ID 1655 //
     /*  41351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41362 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41368 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41376 */     // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /*  41376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41383 */     GIR_RootConstrainSelectedInstOperands,
     /*  41384 */     // GIR_Coverage, 1655,
     /*  41384 */     GIR_EraseRootFromParent_Done,
     /*  41385 */   // Label 654: @41385
     /*  41385 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(41421), // Rule ID 5231 //
     /*  41390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41398 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  41404 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  41406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41412 */     // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /*  41412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  41415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41419 */     GIR_RootConstrainSelectedInstOperands,
     /*  41420 */     // GIR_Coverage, 5231,
     /*  41420 */     GIR_EraseRootFromParent_Done,
     /*  41421 */   // Label 655: @41421
     /*  41421 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(41448), // Rule ID 1644 //
     /*  41426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  41429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41441 */     // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  41441 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
     /*  41446 */     GIR_RootConstrainSelectedInstOperands,
     /*  41447 */     // GIR_Coverage, 1644,
     /*  41447 */     GIR_Done,
     /*  41448 */   // Label 656: @41448
     /*  41448 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(41478), // Rule ID 3903 //
     /*  41453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41465 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  41465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
     /*  41470 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  41476 */     GIR_RootConstrainSelectedInstOperands,
     /*  41477 */     // GIR_Coverage, 3903,
     /*  41477 */     GIR_Done,
     /*  41478 */   // Label 657: @41478
     /*  41478 */   GIM_Reject,
     /*  41479 */ // Label 620: @41479
     /*  41479 */ GIM_Reject,
     /*  41480 */ // Label 593: @41480
     /*  41480 */ GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(42970),
     /*  41485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41495 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(41627), // Rule ID 5380 //
     /*  41500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41524 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41529 */     // MIs[1] Operand 2
     /*  41529 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41540 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41544 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41548 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41552 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41556 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41560 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41564 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41569 */     // MIs[3] Operand 2
     /*  41569 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41580 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41582 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41594 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41598 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41609 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41621 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41626 */     // GIR_Coverage, 5380,
     /*  41626 */     GIR_EraseRootFromParent_Done,
     /*  41627 */   // Label 659: @41627
     /*  41627 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(41759), // Rule ID 5379 //
     /*  41632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41656 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41661 */     // MIs[1] Operand 2
     /*  41661 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41672 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41676 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41680 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41684 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41688 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41692 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41696 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41701 */     // MIs[3] Operand 2
     /*  41701 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41712 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41714 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41726 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41741 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41748 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41758 */     // GIR_Coverage, 5379,
     /*  41758 */     GIR_EraseRootFromParent_Done,
     /*  41759 */   // Label 660: @41759
     /*  41759 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(41891), // Rule ID 5392 //
     /*  41764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41793 */     // MIs[1] Operand 2
     /*  41793 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41804 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41808 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41812 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41816 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41820 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41824 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41828 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41833 */     // MIs[3] Operand 2
     /*  41833 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41844 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41846 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  41853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41862 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41866 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41873 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41890 */     // GIR_Coverage, 5392,
     /*  41890 */     GIR_EraseRootFromParent_Done,
     /*  41891 */   // Label 661: @41891
     /*  41891 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(42023), // Rule ID 5378 //
     /*  41896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  41900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41925 */     // MIs[1] Operand 2
     /*  41925 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  41940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41944 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  41948 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  41952 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41956 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  41960 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41965 */     // MIs[3] Operand 2
     /*  41965 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  41976 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  41978 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  41978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  41985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41994 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  41998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42005 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42022 */     // GIR_Coverage, 5378,
     /*  42022 */     GIR_EraseRootFromParent_Done,
     /*  42023 */   // Label 662: @42023
     /*  42023 */   GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(42155), // Rule ID 5377 //
     /*  42028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42052 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42057 */     // MIs[1] Operand 2
     /*  42057 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42076 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42080 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42084 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42088 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42092 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42097 */     // MIs[3] Operand 2
     /*  42097 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42108 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42110 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42110 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42113 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  42117 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42122 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42137 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42154 */     // GIR_Coverage, 5377,
     /*  42154 */     GIR_EraseRootFromParent_Done,
     /*  42155 */   // Label 663: @42155
     /*  42155 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(42314), // Rule ID 5347 //
     /*  42160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  42184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  42192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42197 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42202 */     // MIs[1] Operand 2
     /*  42202 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42215 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42215 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42218 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42222 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42229 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42232 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42236 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42241 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42244 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42248 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42251 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42256 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42261 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42266 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42269 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  42273 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42278 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42281 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42285 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42296 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42308 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42313 */     // GIR_Coverage, 5347,
     /*  42313 */     GIR_EraseRootFromParent_Done,
     /*  42314 */   // Label 664: @42314
     /*  42314 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(42473), // Rule ID 5344 //
     /*  42319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  42343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  42351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42361 */     // MIs[1] Operand 2
     /*  42361 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42372 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42374 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42374 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42377 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42381 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42386 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42388 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42391 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42395 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42400 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42403 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  42407 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42410 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42415 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42420 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  42432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42437 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42440 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42444 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  42448 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42455 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42462 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42467 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42472 */     // GIR_Coverage, 5344,
     /*  42472 */     GIR_EraseRootFromParent_Done,
     /*  42473 */   // Label 665: @42473
     /*  42473 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(42619), // Rule ID 5388 //
     /*  42478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42506 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42511 */     // MIs[1] Operand 2
     /*  42511 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42524 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42524 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42527 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42531 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42538 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42541 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42545 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42550 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42553 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42557 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42560 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42565 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42570 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42587 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42590 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42601 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42618 */     // GIR_Coverage, 5388,
     /*  42618 */     GIR_EraseRootFromParent_Done,
     /*  42619 */   // Label 666: @42619
     /*  42619 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(42765), // Rule ID 5395 //
     /*  42624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42657 */     // MIs[1] Operand 2
     /*  42657 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42670 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42670 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42673 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42677 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42684 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42687 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42691 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42696 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42699 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42703 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42706 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42711 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42716 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  42728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42733 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42736 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42740 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42747 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42764 */     // GIR_Coverage, 5395,
     /*  42764 */     GIR_EraseRootFromParent_Done,
     /*  42765 */   // Label 667: @42765
     /*  42765 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(42911), // Rule ID 5387 //
     /*  42770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42803 */     // MIs[1] Operand 2
     /*  42803 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  42816 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42816 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  42819 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42823 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  42830 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  42833 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  42837 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42842 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42845 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  42849 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  42852 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42857 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42862 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  42874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42879 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  42882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  42886 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42893 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42900 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42910 */     // GIR_Coverage, 5387,
     /*  42910 */     GIR_EraseRootFromParent_Done,
     /*  42911 */   // Label 668: @42911
     /*  42911 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(42946), // Rule ID 969 //
     /*  42916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42923 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42929 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42935 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42937 */     // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  42937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
     /*  42940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42944 */     GIR_RootConstrainSelectedInstOperands,
     /*  42945 */     // GIR_Coverage, 969,
     /*  42945 */     GIR_EraseRootFromParent_Done,
     /*  42946 */   // Label 669: @42946
     /*  42946 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(42969), // Rule ID 1476 //
     /*  42951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42962 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  42962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
     /*  42967 */     GIR_RootConstrainSelectedInstOperands,
     /*  42968 */     // GIR_Coverage, 1476,
     /*  42968 */     GIR_Done,
     /*  42969 */   // Label 670: @42969
     /*  42969 */   GIM_Reject,
     /*  42970 */ // Label 658: @42970
     /*  42970 */ GIM_Reject,
     /*  42971 */ // Label 594: @42971
     /*  42971 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(45430),
     /*  42976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  42979 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  42982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42986 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(43100), // Rule ID 2048 //
     /*  42991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43026 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43030 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43034 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43038 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43042 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43047 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43051 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43055 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43059 */     // MIs[4] Operand 1
     /*  43059 */     // No operand predicates
     /*  43059 */     // MIs[2] Operand 2
     /*  43059 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43070 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43072 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43079 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  43082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43098 */     GIR_RootConstrainSelectedInstOperands,
     /*  43099 */     // GIR_Coverage, 2048,
     /*  43099 */     GIR_EraseRootFromParent_Done,
     /*  43100 */   // Label 672: @43100
     /*  43100 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(43214), // Rule ID 13426 //
     /*  43105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43148 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43152 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43156 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43161 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43165 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43169 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43173 */     // MIs[4] Operand 1
     /*  43173 */     // No operand predicates
     /*  43173 */     // MIs[2] Operand 2
     /*  43173 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43184 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43186 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43193 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  43196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43212 */     GIR_RootConstrainSelectedInstOperands,
     /*  43213 */     // GIR_Coverage, 13426,
     /*  43213 */     GIR_EraseRootFromParent_Done,
     /*  43214 */   // Label 673: @43214
     /*  43214 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(43328), // Rule ID 2100 //
     /*  43219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43254 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43258 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43262 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43266 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43270 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43275 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43279 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43283 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43287 */     // MIs[4] Operand 1
     /*  43287 */     // No operand predicates
     /*  43287 */     // MIs[2] Operand 2
     /*  43287 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43298 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43300 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43307 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43326 */     GIR_RootConstrainSelectedInstOperands,
     /*  43327 */     // GIR_Coverage, 2100,
     /*  43327 */     GIR_EraseRootFromParent_Done,
     /*  43328 */   // Label 674: @43328
     /*  43328 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(43442), // Rule ID 13456 //
     /*  43333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  43348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43368 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43372 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43376 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43380 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43384 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43389 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43393 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43397 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43401 */     // MIs[4] Operand 1
     /*  43401 */     // No operand predicates
     /*  43401 */     // MIs[2] Operand 2
     /*  43401 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  43412 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43414 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43421 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  43424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43440 */     GIR_RootConstrainSelectedInstOperands,
     /*  43441 */     // GIR_Coverage, 13456,
     /*  43441 */     GIR_EraseRootFromParent_Done,
     /*  43442 */   // Label 675: @43442
     /*  43442 */   GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(43507), // Rule ID 1855 //
     /*  43447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43476 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43483 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43490 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43505 */     GIR_RootConstrainSelectedInstOperands,
     /*  43506 */     // GIR_Coverage, 1855,
     /*  43506 */     GIR_EraseRootFromParent_Done,
     /*  43507 */   // Label 676: @43507
     /*  43507 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(43572), // Rule ID 1854 //
     /*  43512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43539 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43541 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43548 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43555 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43570 */     GIR_RootConstrainSelectedInstOperands,
     /*  43571 */     // GIR_Coverage, 1854,
     /*  43571 */     GIR_EraseRootFromParent_Done,
     /*  43572 */   // Label 677: @43572
     /*  43572 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(43637), // Rule ID 1759 //
     /*  43577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43606 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43613 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43620 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
     /*  43623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43635 */     GIR_RootConstrainSelectedInstOperands,
     /*  43636 */     // GIR_Coverage, 1759,
     /*  43636 */     GIR_EraseRootFromParent_Done,
     /*  43637 */   // Label 678: @43637
     /*  43637 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(43702), // Rule ID 1853 //
     /*  43642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43671 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43678 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43685 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43700 */     GIR_RootConstrainSelectedInstOperands,
     /*  43701 */     // GIR_Coverage, 1853,
     /*  43701 */     GIR_EraseRootFromParent_Done,
     /*  43702 */   // Label 679: @43702
     /*  43702 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(43767), // Rule ID 1852 //
     /*  43707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  43726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43734 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43736 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43743 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  43750 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  43750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  43753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  43760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  43765 */     GIR_RootConstrainSelectedInstOperands,
     /*  43766 */     // GIR_Coverage, 1852,
     /*  43766 */     GIR_EraseRootFromParent_Done,
     /*  43767 */   // Label 680: @43767
     /*  43767 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(43878), // Rule ID 13424 //
     /*  43772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43791 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43803 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43811 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43815 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43819 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43823 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43828 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43832 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43836 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43840 */     // MIs[4] Operand 1
     /*  43840 */     // No operand predicates
     /*  43840 */     // MIs[2] Operand 2
     /*  43840 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43856 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43858 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  43869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43876 */     GIR_RootConstrainSelectedInstOperands,
     /*  43877 */     // GIR_Coverage, 13424,
     /*  43877 */     GIR_EraseRootFromParent_Done,
     /*  43878 */   // Label 681: @43878
     /*  43878 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(43989), // Rule ID 2046 //
     /*  43883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  43898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  43902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  43906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  43915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  43927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  43931 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43935 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  43939 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43944 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  43948 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  43952 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  43956 */     // MIs[4] Operand 1
     /*  43956 */     // No operand predicates
     /*  43956 */     // MIs[2] Operand 2
     /*  43956 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  43967 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43969 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  43969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  43972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  43976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  43980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  43984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  43987 */     GIR_RootConstrainSelectedInstOperands,
     /*  43988 */     // GIR_Coverage, 2046,
     /*  43988 */     GIR_EraseRootFromParent_Done,
     /*  43989 */   // Label 682: @43989
     /*  43989 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(44100), // Rule ID 13454 //
     /*  43994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44033 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44037 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44041 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44045 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44050 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44054 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44058 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44062 */     // MIs[4] Operand 1
     /*  44062 */     // No operand predicates
     /*  44062 */     // MIs[2] Operand 2
     /*  44062 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  44073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44078 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44080 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44098 */     GIR_RootConstrainSelectedInstOperands,
     /*  44099 */     // GIR_Coverage, 13454,
     /*  44099 */     GIR_EraseRootFromParent_Done,
     /*  44100 */   // Label 683: @44100
     /*  44100 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(44211), // Rule ID 2098 //
     /*  44105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44141 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44149 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44153 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44157 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44161 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44166 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44170 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44174 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44178 */     // MIs[4] Operand 1
     /*  44178 */     // No operand predicates
     /*  44178 */     // MIs[2] Operand 2
     /*  44178 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  44189 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44191 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44206 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44209 */     GIR_RootConstrainSelectedInstOperands,
     /*  44210 */     // GIR_Coverage, 2098,
     /*  44210 */     GIR_EraseRootFromParent_Done,
     /*  44211 */   // Label 684: @44211
     /*  44211 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(44274), // Rule ID 1735 //
     /*  44216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44241 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44248 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44255 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
     /*  44258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44260 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44272 */     GIR_RootConstrainSelectedInstOperands,
     /*  44273 */     // GIR_Coverage, 1735,
     /*  44273 */     GIR_EraseRootFromParent_Done,
     /*  44274 */   // Label 685: @44274
     /*  44274 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(44337), // Rule ID 1825 //
     /*  44279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44304 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44311 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44318 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
     /*  44321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44323 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44335 */     GIR_RootConstrainSelectedInstOperands,
     /*  44336 */     // GIR_Coverage, 1825,
     /*  44336 */     GIR_EraseRootFromParent_Done,
     /*  44337 */   // Label 686: @44337
     /*  44337 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(44425), // Rule ID 13425 //
     /*  44342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44365 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44369 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44373 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44377 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44381 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44394 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44398 */     // MIs[3] Operand 1
     /*  44398 */     // No operand predicates
     /*  44398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44403 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44405 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44416 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44420 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44423 */     GIR_RootConstrainSelectedInstOperands,
     /*  44424 */     // GIR_Coverage, 13425,
     /*  44424 */     GIR_EraseRootFromParent_Done,
     /*  44425 */   // Label 687: @44425
     /*  44425 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(44513), // Rule ID 2047 //
     /*  44430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44470 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44474 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44479 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44483 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44487 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44491 */     // MIs[3] Operand 1
     /*  44491 */     // No operand predicates
     /*  44491 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44493 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44498 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44500 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44504 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44508 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44511 */     GIR_RootConstrainSelectedInstOperands,
     /*  44512 */     // GIR_Coverage, 2047,
     /*  44512 */     GIR_EraseRootFromParent_Done,
     /*  44513 */   // Label 688: @44513
     /*  44513 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(44601), // Rule ID 13455 //
     /*  44518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44566 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44570 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44574 */     // MIs[3] Operand 1
     /*  44574 */     // No operand predicates
     /*  44574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44579 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44581 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44599 */     GIR_RootConstrainSelectedInstOperands,
     /*  44600 */     // GIR_Coverage, 13455,
     /*  44600 */     GIR_EraseRootFromParent_Done,
     /*  44601 */   // Label 689: @44601
     /*  44601 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(44689), // Rule ID 2099 //
     /*  44606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44646 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  44650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  44659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44663 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44667 */     // MIs[3] Operand 1
     /*  44667 */     // No operand predicates
     /*  44667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  44669 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  44672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  44687 */     GIR_RootConstrainSelectedInstOperands,
     /*  44688 */     // GIR_Coverage, 2099,
     /*  44688 */     GIR_EraseRootFromParent_Done,
     /*  44689 */   // Label 690: @44689
     /*  44689 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(44736), // Rule ID 1867 //
     /*  44694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44715 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44722 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44734 */     GIR_RootConstrainSelectedInstOperands,
     /*  44735 */     // GIR_Coverage, 1867,
     /*  44735 */     GIR_EraseRootFromParent_Done,
     /*  44736 */   // Label 691: @44736
     /*  44736 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(44783), // Rule ID 1765 //
     /*  44741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44744 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44769 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
     /*  44772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44781 */     GIR_RootConstrainSelectedInstOperands,
     /*  44782 */     // GIR_Coverage, 1765,
     /*  44782 */     GIR_EraseRootFromParent_Done,
     /*  44783 */   // Label 692: @44783
     /*  44783 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(44830), // Rule ID 1866 //
     /*  44788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44816 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  44819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  44823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  44828 */     GIR_RootConstrainSelectedInstOperands,
     /*  44829 */     // GIR_Coverage, 1866,
     /*  44829 */     GIR_EraseRootFromParent_Done,
     /*  44830 */   // Label 693: @44830
     /*  44830 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(44889), // Rule ID 1851 //
     /*  44835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44867 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44874 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44887 */     GIR_RootConstrainSelectedInstOperands,
     /*  44888 */     // GIR_Coverage, 1851,
     /*  44888 */     GIR_EraseRootFromParent_Done,
     /*  44889 */   // Label 694: @44889
     /*  44889 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(44948), // Rule ID 1850 //
     /*  44894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44926 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44931 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44933 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  44936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  44942 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  44946 */     GIR_RootConstrainSelectedInstOperands,
     /*  44947 */     // GIR_Coverage, 1850,
     /*  44947 */     GIR_EraseRootFromParent_Done,
     /*  44948 */   // Label 695: @44948
     /*  44948 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(45007), // Rule ID 1758 //
     /*  44953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44992 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  44992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  44995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45005 */     GIR_RootConstrainSelectedInstOperands,
     /*  45006 */     // GIR_Coverage, 1758,
     /*  45006 */     GIR_EraseRootFromParent_Done,
     /*  45007 */   // Label 696: @45007
     /*  45007 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(45066), // Rule ID 1849 //
     /*  45012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45027 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45044 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45049 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45051 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  45054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45064 */     GIR_RootConstrainSelectedInstOperands,
     /*  45065 */     // GIR_Coverage, 1849,
     /*  45065 */     GIR_EraseRootFromParent_Done,
     /*  45066 */   // Label 697: @45066
     /*  45066 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(45125), // Rule ID 1848 //
     /*  45071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45103 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45108 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45110 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  45113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45123 */     GIR_RootConstrainSelectedInstOperands,
     /*  45124 */     // GIR_Coverage, 1848,
     /*  45124 */     GIR_EraseRootFromParent_Done,
     /*  45125 */   // Label 698: @45125
     /*  45125 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(45160), // Rule ID 971 //
     /*  45130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45137 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  45143 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  45145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45151 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  45151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
     /*  45154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45158 */     GIR_RootConstrainSelectedInstOperands,
     /*  45159 */     // GIR_Coverage, 971,
     /*  45159 */     GIR_EraseRootFromParent_Done,
     /*  45160 */   // Label 699: @45160
     /*  45160 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(45217), // Rule ID 1734 //
     /*  45165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45168 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45184 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45200 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  45203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  45215 */     GIR_RootConstrainSelectedInstOperands,
     /*  45216 */     // GIR_Coverage, 1734,
     /*  45216 */     GIR_EraseRootFromParent_Done,
     /*  45217 */   // Label 700: @45217
     /*  45217 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(45274), // Rule ID 1824 //
     /*  45222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45257 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  45260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  45272 */     GIR_RootConstrainSelectedInstOperands,
     /*  45273 */     // GIR_Coverage, 1824,
     /*  45273 */     GIR_EraseRootFromParent_Done,
     /*  45274 */   // Label 701: @45274
     /*  45274 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(45318), // Rule ID 1865 //
     /*  45279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45305 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45316 */     GIR_RootConstrainSelectedInstOperands,
     /*  45317 */     // GIR_Coverage, 1865,
     /*  45317 */     GIR_EraseRootFromParent_Done,
     /*  45318 */   // Label 702: @45318
     /*  45318 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(45362), // Rule ID 1764 //
     /*  45323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45349 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  45352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45360 */     GIR_RootConstrainSelectedInstOperands,
     /*  45361 */     // GIR_Coverage, 1764,
     /*  45361 */     GIR_EraseRootFromParent_Done,
     /*  45362 */   // Label 703: @45362
     /*  45362 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(45406), // Rule ID 1864 //
     /*  45367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45391 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45393 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  45396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45398 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  45404 */     GIR_RootConstrainSelectedInstOperands,
     /*  45405 */     // GIR_Coverage, 1864,
     /*  45405 */     GIR_EraseRootFromParent_Done,
     /*  45406 */   // Label 704: @45406
     /*  45406 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(45429), // Rule ID 1478 //
     /*  45411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45422 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  45422 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
     /*  45427 */     GIR_RootConstrainSelectedInstOperands,
     /*  45428 */     // GIR_Coverage, 1478,
     /*  45428 */     GIR_Done,
     /*  45429 */   // Label 705: @45429
     /*  45429 */   GIM_Reject,
     /*  45430 */ // Label 671: @45430
     /*  45430 */ GIM_Reject,
     /*  45431 */ // Label 595: @45431
     /*  45431 */ GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(46921),
     /*  45436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  45439 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45446 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(45578), // Rule ID 5376 //
     /*  45451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45480 */     // MIs[1] Operand 2
     /*  45480 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45491 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45495 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45499 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45503 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45507 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45511 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45515 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45520 */     // MIs[3] Operand 2
     /*  45520 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45531 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45533 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45545 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45549 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45553 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45560 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45567 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45577 */     // GIR_Coverage, 5376,
     /*  45577 */     GIR_EraseRootFromParent_Done,
     /*  45578 */   // Label 707: @45578
     /*  45578 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(45710), // Rule ID 5375 //
     /*  45583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45607 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45612 */     // MIs[1] Operand 2
     /*  45612 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45631 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45635 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45639 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45643 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45647 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45652 */     // MIs[3] Operand 2
     /*  45652 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45663 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45665 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45677 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45681 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45692 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45704 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45709 */     // GIR_Coverage, 5375,
     /*  45709 */     GIR_EraseRootFromParent_Done,
     /*  45710 */   // Label 708: @45710
     /*  45710 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(45842), // Rule ID 5391 //
     /*  45715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45739 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45744 */     // MIs[1] Operand 2
     /*  45744 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45763 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45767 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45771 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45775 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45779 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45784 */     // MIs[3] Operand 2
     /*  45784 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45795 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45797 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  45804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45809 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45813 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45824 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45831 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45841 */     // GIR_Coverage, 5391,
     /*  45841 */     GIR_EraseRootFromParent_Done,
     /*  45842 */   // Label 709: @45842
     /*  45842 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(45974), // Rule ID 5374 //
     /*  45847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45851 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45855 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45871 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45876 */     // MIs[1] Operand 2
     /*  45876 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  45887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  45891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45895 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45899 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  45903 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45907 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  45911 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45916 */     // MIs[3] Operand 2
     /*  45916 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  45927 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45929 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  45929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  45932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  45936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  45941 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  45945 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  45949 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  45951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  45954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45956 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  45963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45973 */     // GIR_Coverage, 5374,
     /*  45973 */     GIR_EraseRootFromParent_Done,
     /*  45974 */   // Label 710: @45974
     /*  45974 */   GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(46106), // Rule ID 5373 //
     /*  45979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  45991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46008 */     // MIs[1] Operand 2
     /*  46008 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46027 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46031 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  46035 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46039 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46043 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46048 */     // MIs[3] Operand 2
     /*  46048 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  46059 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46061 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  46068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46073 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46077 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  46081 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46088 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46095 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46105 */     // GIR_Coverage, 5373,
     /*  46105 */     GIR_EraseRootFromParent_Done,
     /*  46106 */   // Label 711: @46106
     /*  46106 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(46265), // Rule ID 5346 //
     /*  46111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  46135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46139 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46143 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46148 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46153 */     // MIs[1] Operand 2
     /*  46153 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46166 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46166 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46169 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46173 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46180 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46183 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46187 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46192 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46195 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  46199 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46202 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46207 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46212 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  46224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46229 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46232 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46240 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46247 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46254 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46259 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46264 */     // GIR_Coverage, 5346,
     /*  46264 */     GIR_EraseRootFromParent_Done,
     /*  46265 */   // Label 712: @46265
     /*  46265 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(46424), // Rule ID 5343 //
     /*  46270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  46294 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46298 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  46302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46307 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46312 */     // MIs[1] Operand 2
     /*  46312 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46325 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46325 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46328 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46332 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46337 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46339 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46342 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46346 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46351 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46354 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  46358 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46361 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46366 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  46383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46388 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46391 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46395 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  46399 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46406 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46413 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46423 */     // GIR_Coverage, 5343,
     /*  46423 */     GIR_EraseRootFromParent_Done,
     /*  46424 */   // Label 713: @46424
     /*  46424 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(46570), // Rule ID 5386 //
     /*  46429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46441 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46457 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46462 */     // MIs[1] Operand 2
     /*  46462 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46475 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46475 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46478 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46482 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46489 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46492 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46496 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46501 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46504 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46508 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46511 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46516 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46521 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46538 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46541 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46552 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46564 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46569 */     // GIR_Coverage, 5386,
     /*  46569 */     GIR_EraseRootFromParent_Done,
     /*  46570 */   // Label 714: @46570
     /*  46570 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(46716), // Rule ID 5394 //
     /*  46575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46603 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46608 */     // MIs[1] Operand 2
     /*  46608 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46619 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46621 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46621 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46624 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46628 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46633 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46635 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46638 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46642 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46647 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46650 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46654 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46657 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46662 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46667 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  46679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46684 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46687 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46698 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46715 */     // GIR_Coverage, 5394,
     /*  46715 */     GIR_EraseRootFromParent_Done,
     /*  46716 */   // Label 715: @46716
     /*  46716 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(46862), // Rule ID 5385 //
     /*  46721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46749 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46754 */     // MIs[1] Operand 2
     /*  46754 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46767 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46767 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  46770 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  46774 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46779 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  46781 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  46784 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  46788 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46793 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  46796 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  46800 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  46803 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46808 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46813 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  46825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46830 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  46833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46837 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46844 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46861 */     // GIR_Coverage, 5385,
     /*  46861 */     GIR_EraseRootFromParent_Done,
     /*  46862 */   // Label 716: @46862
     /*  46862 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(46897), // Rule ID 967 //
     /*  46867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46874 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46880 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46886 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46888 */     // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  46888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
     /*  46891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46895 */     GIR_RootConstrainSelectedInstOperands,
     /*  46896 */     // GIR_Coverage, 967,
     /*  46896 */     GIR_EraseRootFromParent_Done,
     /*  46897 */   // Label 717: @46897
     /*  46897 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(46920), // Rule ID 1474 //
     /*  46902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46913 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  46913 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
     /*  46918 */     GIR_RootConstrainSelectedInstOperands,
     /*  46919 */     // GIR_Coverage, 1474,
     /*  46919 */     GIR_Done,
     /*  46920 */   // Label 718: @46920
     /*  46920 */   GIM_Reject,
     /*  46921 */ // Label 706: @46921
     /*  46921 */ GIM_Reject,
     /*  46922 */ // Label 596: @46922
     /*  46922 */ GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(49381),
     /*  46927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  46930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  46933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46937 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(47051), // Rule ID 2045 //
     /*  46942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  46969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  46981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  46985 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46989 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  46993 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  46998 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47002 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47006 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47010 */     // MIs[4] Operand 1
     /*  47010 */     // No operand predicates
     /*  47010 */     // MIs[2] Operand 2
     /*  47010 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47021 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47023 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47030 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  47033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47049 */     GIR_RootConstrainSelectedInstOperands,
     /*  47050 */     // GIR_Coverage, 2045,
     /*  47050 */     GIR_EraseRootFromParent_Done,
     /*  47051 */   // Label 720: @47051
     /*  47051 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(47165), // Rule ID 13423 //
     /*  47056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47091 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47095 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47099 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47103 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47107 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47112 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47116 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47120 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47124 */     // MIs[4] Operand 1
     /*  47124 */     // No operand predicates
     /*  47124 */     // MIs[2] Operand 2
     /*  47124 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47135 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47137 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47144 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  47147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47149 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47163 */     GIR_RootConstrainSelectedInstOperands,
     /*  47164 */     // GIR_Coverage, 13423,
     /*  47164 */     GIR_EraseRootFromParent_Done,
     /*  47165 */   // Label 721: @47165
     /*  47165 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(47279), // Rule ID 2097 //
     /*  47170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47209 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47213 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47217 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47221 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47226 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47230 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47234 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47238 */     // MIs[4] Operand 1
     /*  47238 */     // No operand predicates
     /*  47238 */     // MIs[2] Operand 2
     /*  47238 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47249 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47251 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47258 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47263 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47277 */     GIR_RootConstrainSelectedInstOperands,
     /*  47278 */     // GIR_Coverage, 2097,
     /*  47278 */     GIR_EraseRootFromParent_Done,
     /*  47279 */   // Label 722: @47279
     /*  47279 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(47393), // Rule ID 13453 //
     /*  47284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47315 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47319 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47323 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47327 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47331 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47335 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47340 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47344 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47348 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47352 */     // MIs[4] Operand 1
     /*  47352 */     // No operand predicates
     /*  47352 */     // MIs[2] Operand 2
     /*  47352 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  47363 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47365 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47372 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  47375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47391 */     GIR_RootConstrainSelectedInstOperands,
     /*  47392 */     // GIR_Coverage, 13453,
     /*  47392 */     GIR_EraseRootFromParent_Done,
     /*  47393 */   // Label 723: @47393
     /*  47393 */   GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(47458), // Rule ID 1847 //
     /*  47398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47427 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47434 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47441 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47456 */     GIR_RootConstrainSelectedInstOperands,
     /*  47457 */     // GIR_Coverage, 1847,
     /*  47457 */     GIR_EraseRootFromParent_Done,
     /*  47458 */   // Label 724: @47458
     /*  47458 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(47523), // Rule ID 1846 //
     /*  47463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47492 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47499 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47506 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47511 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47521 */     GIR_RootConstrainSelectedInstOperands,
     /*  47522 */     // GIR_Coverage, 1846,
     /*  47522 */     GIR_EraseRootFromParent_Done,
     /*  47523 */   // Label 725: @47523
     /*  47523 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(47588), // Rule ID 1757 //
     /*  47528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47557 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47564 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47571 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
     /*  47574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47586 */     GIR_RootConstrainSelectedInstOperands,
     /*  47587 */     // GIR_Coverage, 1757,
     /*  47587 */     GIR_EraseRootFromParent_Done,
     /*  47588 */   // Label 726: @47588
     /*  47588 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(47653), // Rule ID 1845 //
     /*  47593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47622 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47629 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47636 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47641 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47651 */     GIR_RootConstrainSelectedInstOperands,
     /*  47652 */     // GIR_Coverage, 1845,
     /*  47652 */     GIR_EraseRootFromParent_Done,
     /*  47653 */   // Label 727: @47653
     /*  47653 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(47718), // Rule ID 1844 //
     /*  47658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  47677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47687 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47694 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  47701 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  47701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  47704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  47711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  47716 */     GIR_RootConstrainSelectedInstOperands,
     /*  47717 */     // GIR_Coverage, 1844,
     /*  47717 */     GIR_EraseRootFromParent_Done,
     /*  47718 */   // Label 728: @47718
     /*  47718 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(47829), // Rule ID 13421 //
     /*  47723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47762 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47766 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47770 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47774 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47779 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47783 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47787 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47791 */     // MIs[4] Operand 1
     /*  47791 */     // No operand predicates
     /*  47791 */     // MIs[2] Operand 2
     /*  47791 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47807 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47809 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  47820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47827 */     GIR_RootConstrainSelectedInstOperands,
     /*  47828 */     // GIR_Coverage, 13421,
     /*  47828 */     GIR_EraseRootFromParent_Done,
     /*  47829 */   // Label 729: @47829
     /*  47829 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(47940), // Rule ID 2043 //
     /*  47834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47853 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47857 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47882 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47886 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47890 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  47895 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  47899 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  47903 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  47907 */     // MIs[4] Operand 1
     /*  47907 */     // No operand predicates
     /*  47907 */     // MIs[2] Operand 2
     /*  47907 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  47918 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47920 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  47920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  47923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  47927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  47931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  47935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  47938 */     GIR_RootConstrainSelectedInstOperands,
     /*  47939 */     // GIR_Coverage, 2043,
     /*  47939 */     GIR_EraseRootFromParent_Done,
     /*  47940 */   // Label 730: @47940
     /*  47940 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(48051), // Rule ID 13451 //
     /*  47945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  47960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47980 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  47984 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  47988 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47992 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  47996 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48001 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48005 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48009 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48013 */     // MIs[4] Operand 1
     /*  48013 */     // No operand predicates
     /*  48013 */     // MIs[2] Operand 2
     /*  48013 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  48024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48029 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48031 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48049 */     GIR_RootConstrainSelectedInstOperands,
     /*  48050 */     // GIR_Coverage, 13451,
     /*  48050 */     GIR_EraseRootFromParent_Done,
     /*  48051 */   // Label 731: @48051
     /*  48051 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(48162), // Rule ID 2095 //
     /*  48056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48096 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48100 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48104 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48108 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48112 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48117 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48121 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48125 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48129 */     // MIs[4] Operand 1
     /*  48129 */     // No operand predicates
     /*  48129 */     // MIs[2] Operand 2
     /*  48129 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  48140 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48142 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48147 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48157 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48160 */     GIR_RootConstrainSelectedInstOperands,
     /*  48161 */     // GIR_Coverage, 2095,
     /*  48161 */     GIR_EraseRootFromParent_Done,
     /*  48162 */   // Label 732: @48162
     /*  48162 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(48225), // Rule ID 1733 //
     /*  48167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48186 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48192 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48199 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48206 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
     /*  48209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48218 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48223 */     GIR_RootConstrainSelectedInstOperands,
     /*  48224 */     // GIR_Coverage, 1733,
     /*  48224 */     GIR_EraseRootFromParent_Done,
     /*  48225 */   // Label 733: @48225
     /*  48225 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(48288), // Rule ID 1823 //
     /*  48230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48255 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48262 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48269 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
     /*  48272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48281 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48286 */     GIR_RootConstrainSelectedInstOperands,
     /*  48287 */     // GIR_Coverage, 1823,
     /*  48287 */     GIR_EraseRootFromParent_Done,
     /*  48288 */   // Label 734: @48288
     /*  48288 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(48376), // Rule ID 13422 //
     /*  48293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48341 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48345 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48349 */     // MIs[3] Operand 1
     /*  48349 */     // No operand predicates
     /*  48349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48354 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48356 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48361 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48371 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48374 */     GIR_RootConstrainSelectedInstOperands,
     /*  48375 */     // GIR_Coverage, 13422,
     /*  48375 */     GIR_EraseRootFromParent_Done,
     /*  48376 */   // Label 735: @48376
     /*  48376 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(48464), // Rule ID 2044 //
     /*  48381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48425 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48438 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48442 */     // MIs[3] Operand 1
     /*  48442 */     // No operand predicates
     /*  48442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48444 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48459 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48462 */     GIR_RootConstrainSelectedInstOperands,
     /*  48463 */     // GIR_Coverage, 2044,
     /*  48463 */     GIR_EraseRootFromParent_Done,
     /*  48464 */   // Label 736: @48464
     /*  48464 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(48552), // Rule ID 13452 //
     /*  48469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48472 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48504 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48508 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48513 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48517 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48521 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48525 */     // MIs[3] Operand 1
     /*  48525 */     // No operand predicates
     /*  48525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48530 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48532 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48550 */     GIR_RootConstrainSelectedInstOperands,
     /*  48551 */     // GIR_Coverage, 13452,
     /*  48551 */     GIR_EraseRootFromParent_Done,
     /*  48552 */   // Label 737: @48552
     /*  48552 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(48640), // Rule ID 2096 //
     /*  48557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48597 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  48601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48606 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  48610 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48614 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48618 */     // MIs[3] Operand 1
     /*  48618 */     // No operand predicates
     /*  48618 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  48620 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  48623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  48638 */     GIR_RootConstrainSelectedInstOperands,
     /*  48639 */     // GIR_Coverage, 2096,
     /*  48639 */     GIR_EraseRootFromParent_Done,
     /*  48640 */   // Label 738: @48640
     /*  48640 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(48687), // Rule ID 1863 //
     /*  48645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48673 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48685 */     GIR_RootConstrainSelectedInstOperands,
     /*  48686 */     // GIR_Coverage, 1863,
     /*  48686 */     GIR_EraseRootFromParent_Done,
     /*  48687 */   // Label 739: @48687
     /*  48687 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(48734), // Rule ID 1763 //
     /*  48692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48713 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48720 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
     /*  48723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48732 */     GIR_RootConstrainSelectedInstOperands,
     /*  48733 */     // GIR_Coverage, 1763,
     /*  48733 */     GIR_EraseRootFromParent_Done,
     /*  48734 */   // Label 740: @48734
     /*  48734 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(48781), // Rule ID 1862 //
     /*  48739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  48760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48767 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  48770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48772 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  48774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  48779 */     GIR_RootConstrainSelectedInstOperands,
     /*  48780 */     // GIR_Coverage, 1862,
     /*  48780 */     GIR_EraseRootFromParent_Done,
     /*  48781 */   // Label 741: @48781
     /*  48781 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(48840), // Rule ID 1843 //
     /*  48786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48806 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48810 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48814 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48818 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48825 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48838 */     GIR_RootConstrainSelectedInstOperands,
     /*  48839 */     // GIR_Coverage, 1843,
     /*  48839 */     GIR_EraseRootFromParent_Done,
     /*  48840 */   // Label 742: @48840
     /*  48840 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(48899), // Rule ID 1842 //
     /*  48845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48877 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48884 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  48887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48897 */     GIR_RootConstrainSelectedInstOperands,
     /*  48898 */     // GIR_Coverage, 1842,
     /*  48898 */     GIR_EraseRootFromParent_Done,
     /*  48899 */   // Label 743: @48899
     /*  48899 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(48958), // Rule ID 1756 //
     /*  48904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48919 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48943 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  48943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  48946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  48956 */     GIR_RootConstrainSelectedInstOperands,
     /*  48957 */     // GIR_Coverage, 1756,
     /*  48957 */     GIR_EraseRootFromParent_Done,
     /*  48958 */   // Label 744: @48958
     /*  48958 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(49017), // Rule ID 1841 //
     /*  48963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49002 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  49005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49015 */     GIR_RootConstrainSelectedInstOperands,
     /*  49016 */     // GIR_Coverage, 1841,
     /*  49016 */     GIR_EraseRootFromParent_Done,
     /*  49017 */   // Label 745: @49017
     /*  49017 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(49076), // Rule ID 1840 //
     /*  49022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49054 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49059 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49061 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  49064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49074 */     GIR_RootConstrainSelectedInstOperands,
     /*  49075 */     // GIR_Coverage, 1840,
     /*  49075 */     GIR_EraseRootFromParent_Done,
     /*  49076 */   // Label 746: @49076
     /*  49076 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(49111), // Rule ID 970 //
     /*  49081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49088 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  49094 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  49096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49102 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  49102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
     /*  49105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49109 */     GIR_RootConstrainSelectedInstOperands,
     /*  49110 */     // GIR_Coverage, 970,
     /*  49110 */     GIR_EraseRootFromParent_Done,
     /*  49111 */   // Label 747: @49111
     /*  49111 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(49168), // Rule ID 1732 //
     /*  49116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49151 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  49154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  49166 */     GIR_RootConstrainSelectedInstOperands,
     /*  49167 */     // GIR_Coverage, 1732,
     /*  49167 */     GIR_EraseRootFromParent_Done,
     /*  49168 */   // Label 748: @49168
     /*  49168 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(49225), // Rule ID 1822 //
     /*  49173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49192 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49208 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  49211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49213 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  49223 */     GIR_RootConstrainSelectedInstOperands,
     /*  49224 */     // GIR_Coverage, 1822,
     /*  49224 */     GIR_EraseRootFromParent_Done,
     /*  49225 */   // Label 749: @49225
     /*  49225 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(49269), // Rule ID 1861 //
     /*  49230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49254 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49256 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49267 */     GIR_RootConstrainSelectedInstOperands,
     /*  49268 */     // GIR_Coverage, 1861,
     /*  49268 */     GIR_EraseRootFromParent_Done,
     /*  49269 */   // Label 750: @49269
     /*  49269 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(49313), // Rule ID 1762 //
     /*  49274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49300 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  49303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49311 */     GIR_RootConstrainSelectedInstOperands,
     /*  49312 */     // GIR_Coverage, 1762,
     /*  49312 */     GIR_EraseRootFromParent_Done,
     /*  49313 */   // Label 751: @49313
     /*  49313 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(49357), // Rule ID 1860 //
     /*  49318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49342 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49344 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  49347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  49355 */     GIR_RootConstrainSelectedInstOperands,
     /*  49356 */     // GIR_Coverage, 1860,
     /*  49356 */     GIR_EraseRootFromParent_Done,
     /*  49357 */   // Label 752: @49357
     /*  49357 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(49380), // Rule ID 1477 //
     /*  49362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49373 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  49373 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
     /*  49378 */     GIR_RootConstrainSelectedInstOperands,
     /*  49379 */     // GIR_Coverage, 1477,
     /*  49379 */     GIR_Done,
     /*  49380 */   // Label 753: @49380
     /*  49380 */   GIM_Reject,
     /*  49381 */ // Label 719: @49381
     /*  49381 */ GIM_Reject,
     /*  49382 */ // Label 597: @49382
     /*  49382 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(49456),
     /*  49387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49397 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(49432), // Rule ID 965 //
     /*  49402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49409 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  49415 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  49417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49421 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49423 */     // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  49423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
     /*  49426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49430 */     GIR_RootConstrainSelectedInstOperands,
     /*  49431 */     // GIR_Coverage, 965,
     /*  49431 */     GIR_EraseRootFromParent_Done,
     /*  49432 */   // Label 755: @49432
     /*  49432 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(49455), // Rule ID 1472 //
     /*  49437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49448 */     // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  49448 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
     /*  49453 */     GIR_RootConstrainSelectedInstOperands,
     /*  49454 */     // GIR_Coverage, 1472,
     /*  49454 */     GIR_Done,
     /*  49455 */   // Label 756: @49455
     /*  49455 */   GIM_Reject,
     /*  49456 */ // Label 754: @49456
     /*  49456 */ GIM_Reject,
     /*  49457 */ // Label 598: @49457
     /*  49457 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(50664),
     /*  49462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49472 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(49537), // Rule ID 1839 //
     /*  49477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49500 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49506 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49513 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49520 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49535 */     GIR_RootConstrainSelectedInstOperands,
     /*  49536 */     // GIR_Coverage, 1839,
     /*  49536 */     GIR_EraseRootFromParent_Done,
     /*  49537 */   // Label 758: @49537
     /*  49537 */   GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(49602), // Rule ID 1838 //
     /*  49542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49571 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49578 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49585 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49600 */     GIR_RootConstrainSelectedInstOperands,
     /*  49601 */     // GIR_Coverage, 1838,
     /*  49601 */     GIR_EraseRootFromParent_Done,
     /*  49602 */   // Label 759: @49602
     /*  49602 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(49667), // Rule ID 1755 //
     /*  49607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49630 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49636 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49643 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49650 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
     /*  49653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49665 */     GIR_RootConstrainSelectedInstOperands,
     /*  49666 */     // GIR_Coverage, 1755,
     /*  49666 */     GIR_EraseRootFromParent_Done,
     /*  49667 */   // Label 760: @49667
     /*  49667 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(49732), // Rule ID 1837 //
     /*  49672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49701 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49708 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49715 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49730 */     GIR_RootConstrainSelectedInstOperands,
     /*  49731 */     // GIR_Coverage, 1837,
     /*  49731 */     GIR_EraseRootFromParent_Done,
     /*  49732 */   // Label 761: @49732
     /*  49732 */   GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(49797), // Rule ID 1836 //
     /*  49737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49752 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49756 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49760 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49766 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49773 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49780 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  49783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49795 */     GIR_RootConstrainSelectedInstOperands,
     /*  49796 */     // GIR_Coverage, 1836,
     /*  49796 */     GIR_EraseRootFromParent_Done,
     /*  49797 */   // Label 762: @49797
     /*  49797 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(49860), // Rule ID 1731 //
     /*  49802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49827 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49841 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
     /*  49844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49846 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49858 */     GIR_RootConstrainSelectedInstOperands,
     /*  49859 */     // GIR_Coverage, 1731,
     /*  49859 */     GIR_EraseRootFromParent_Done,
     /*  49860 */   // Label 763: @49860
     /*  49860 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(49923), // Rule ID 1821 //
     /*  49865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49897 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49904 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
     /*  49907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49909 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49911 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49921 */     GIR_RootConstrainSelectedInstOperands,
     /*  49922 */     // GIR_Coverage, 1821,
     /*  49922 */     GIR_EraseRootFromParent_Done,
     /*  49923 */   // Label 764: @49923
     /*  49923 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(49970), // Rule ID 1859 //
     /*  49928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49947 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49949 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  49956 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  49956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  49959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49961 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49968 */     GIR_RootConstrainSelectedInstOperands,
     /*  49969 */     // GIR_Coverage, 1859,
     /*  49969 */     GIR_EraseRootFromParent_Done,
     /*  49970 */   // Label 765: @49970
     /*  49970 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(50017), // Rule ID 1761 //
     /*  49975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  49994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49996 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50003 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
     /*  50006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  50015 */     GIR_RootConstrainSelectedInstOperands,
     /*  50016 */     // GIR_Coverage, 1761,
     /*  50016 */     GIR_EraseRootFromParent_Done,
     /*  50017 */   // Label 766: @50017
     /*  50017 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(50064), // Rule ID 1858 //
     /*  50022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50025 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50041 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50043 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50050 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  50053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50055 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  50062 */     GIR_RootConstrainSelectedInstOperands,
     /*  50063 */     // GIR_Coverage, 1858,
     /*  50063 */     GIR_EraseRootFromParent_Done,
     /*  50064 */   // Label 767: @50064
     /*  50064 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(50123), // Rule ID 1835 //
     /*  50069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50108 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50121 */     GIR_RootConstrainSelectedInstOperands,
     /*  50122 */     // GIR_Coverage, 1835,
     /*  50122 */     GIR_EraseRootFromParent_Done,
     /*  50123 */   // Label 768: @50123
     /*  50123 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(50182), // Rule ID 1834 //
     /*  50128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50160 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50167 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50180 */     GIR_RootConstrainSelectedInstOperands,
     /*  50181 */     // GIR_Coverage, 1834,
     /*  50181 */     GIR_EraseRootFromParent_Done,
     /*  50182 */   // Label 769: @50182
     /*  50182 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(50241), // Rule ID 1754 //
     /*  50187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50219 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50226 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  50229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50239 */     GIR_RootConstrainSelectedInstOperands,
     /*  50240 */     // GIR_Coverage, 1754,
     /*  50240 */     GIR_EraseRootFromParent_Done,
     /*  50241 */   // Label 770: @50241
     /*  50241 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(50300), // Rule ID 1833 //
     /*  50246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50285 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50298 */     GIR_RootConstrainSelectedInstOperands,
     /*  50299 */     // GIR_Coverage, 1833,
     /*  50299 */     GIR_EraseRootFromParent_Done,
     /*  50300 */   // Label 771: @50300
     /*  50300 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(50359), // Rule ID 1832 //
     /*  50305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50344 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  50347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50357 */     GIR_RootConstrainSelectedInstOperands,
     /*  50358 */     // GIR_Coverage, 1832,
     /*  50358 */     GIR_EraseRootFromParent_Done,
     /*  50359 */   // Label 772: @50359
     /*  50359 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(50394), // Rule ID 968 //
     /*  50364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50371 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50377 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50383 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50385 */     // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  50385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
     /*  50388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50392 */     GIR_RootConstrainSelectedInstOperands,
     /*  50393 */     // GIR_Coverage, 968,
     /*  50393 */     GIR_EraseRootFromParent_Done,
     /*  50394 */   // Label 773: @50394
     /*  50394 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(50451), // Rule ID 1730 //
     /*  50399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  50414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50434 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  50437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50439 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50449 */     GIR_RootConstrainSelectedInstOperands,
     /*  50450 */     // GIR_Coverage, 1730,
     /*  50450 */     GIR_EraseRootFromParent_Done,
     /*  50451 */   // Label 774: @50451
     /*  50451 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(50508), // Rule ID 1820 //
     /*  50456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  50471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50491 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  50494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50506 */     GIR_RootConstrainSelectedInstOperands,
     /*  50507 */     // GIR_Coverage, 1820,
     /*  50507 */     GIR_EraseRootFromParent_Done,
     /*  50508 */   // Label 775: @50508
     /*  50508 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(50552), // Rule ID 1857 //
     /*  50513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50539 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50544 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50550 */     GIR_RootConstrainSelectedInstOperands,
     /*  50551 */     // GIR_Coverage, 1857,
     /*  50551 */     GIR_EraseRootFromParent_Done,
     /*  50552 */   // Label 776: @50552
     /*  50552 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(50596), // Rule ID 1760 //
     /*  50557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50583 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  50586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50588 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50594 */     GIR_RootConstrainSelectedInstOperands,
     /*  50595 */     // GIR_Coverage, 1760,
     /*  50595 */     GIR_EraseRootFromParent_Done,
     /*  50596 */   // Label 777: @50596
     /*  50596 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(50640), // Rule ID 1856 //
     /*  50601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50627 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  50630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50638 */     GIR_RootConstrainSelectedInstOperands,
     /*  50639 */     // GIR_Coverage, 1856,
     /*  50639 */     GIR_EraseRootFromParent_Done,
     /*  50640 */   // Label 778: @50640
     /*  50640 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(50663), // Rule ID 1475 //
     /*  50645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50656 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  50656 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
     /*  50661 */     GIR_RootConstrainSelectedInstOperands,
     /*  50662 */     // GIR_Coverage, 1475,
     /*  50662 */     GIR_Done,
     /*  50663 */   // Label 779: @50663
     /*  50663 */   GIM_Reject,
     /*  50664 */ // Label 757: @50664
     /*  50664 */ GIM_Reject,
     /*  50665 */ // Label 599: @50665
     /*  50665 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(50739),
     /*  50670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  50673 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50680 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(50715), // Rule ID 966 //
     /*  50685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50692 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50698 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50706 */     // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  50706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
     /*  50709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50713 */     GIR_RootConstrainSelectedInstOperands,
     /*  50714 */     // GIR_Coverage, 966,
     /*  50714 */     GIR_EraseRootFromParent_Done,
     /*  50715 */   // Label 781: @50715
     /*  50715 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(50738), // Rule ID 1473 //
     /*  50720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50731 */     // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50731 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
     /*  50736 */     GIR_RootConstrainSelectedInstOperands,
     /*  50737 */     // GIR_Coverage, 1473,
     /*  50737 */     GIR_Done,
     /*  50738 */   // Label 782: @50738
     /*  50738 */   GIM_Reject,
     /*  50739 */ // Label 780: @50739
     /*  50739 */ GIM_Reject,
     /*  50740 */ // Label 600: @50740
     /*  50740 */ GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(50765), // Rule ID 7392 //
     /*  50745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  50751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  50754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50758 */   // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  50758 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
     /*  50763 */   GIR_RootConstrainSelectedInstOperands,
     /*  50764 */   // GIR_Coverage, 7392,
     /*  50764 */   GIR_Done,
     /*  50765 */ // Label 783: @50765
     /*  50765 */ GIM_Reject,
     /*  50766 */ // Label 601: @50766
     /*  50766 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(50791), // Rule ID 7391 //
     /*  50771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  50777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  50780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50784 */   // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  50784 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
     /*  50789 */   GIR_RootConstrainSelectedInstOperands,
     /*  50790 */   // GIR_Coverage, 7391,
     /*  50790 */   GIR_Done,
     /*  50791 */ // Label 784: @50791
     /*  50791 */ GIM_Reject,
     /*  50792 */ // Label 602: @50792
     /*  50792 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(50817), // Rule ID 7390 //
     /*  50797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  50803 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  50806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50810 */   // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  50810 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
     /*  50815 */   GIR_RootConstrainSelectedInstOperands,
     /*  50816 */   // GIR_Coverage, 7390,
     /*  50816 */   GIR_Done,
     /*  50817 */ // Label 785: @50817
     /*  50817 */ GIM_Reject,
     /*  50818 */ // Label 603: @50818
     /*  50818 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(50843), // Rule ID 7389 //
     /*  50823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  50826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  50829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  50832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  50836 */   // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  50836 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
     /*  50841 */   GIR_RootConstrainSelectedInstOperands,
     /*  50842 */   // GIR_Coverage, 7389,
     /*  50842 */   GIR_Done,
     /*  50843 */ // Label 786: @50843
     /*  50843 */ GIM_Reject,
     /*  50844 */ // Label 604: @50844
     /*  50844 */ GIM_Reject,
     /*  50845 */ // Label 2: @50845
     /*  50845 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 795*/ GIMT_Encode4(52673),
     /*  50856 */ /*GILLT_s32*//*Label 787*/ GIMT_Encode4(50896),
     /*  50860 */ /*GILLT_s64*//*Label 788*/ GIMT_Encode4(51053), GIMT_Encode4(0),
     /*  50868 */ /*GILLT_v2s32*//*Label 789*/ GIMT_Encode4(51597), GIMT_Encode4(0),
     /*  50876 */ /*GILLT_v4s16*//*Label 790*/ GIMT_Encode4(51935),
     /*  50880 */ /*GILLT_v4s32*//*Label 791*/ GIMT_Encode4(52273),
     /*  50884 */ /*GILLT_v8s8*//*Label 792*/ GIMT_Encode4(52439),
     /*  50888 */ /*GILLT_v8s16*//*Label 793*/ GIMT_Encode4(52473),
     /*  50892 */ /*GILLT_v16s8*//*Label 794*/ GIMT_Encode4(52639),
     /*  50896 */ // Label 787: @50896
     /*  50896 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(51052),
     /*  50901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  50904 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  50907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50911 */   GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(50966), // Rule ID 3943 //
     /*  50916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50932 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50945 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50947 */     // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  50947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  50950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  50956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  50958 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50964 */     GIR_RootConstrainSelectedInstOperands,
     /*  50965 */     // GIR_Coverage, 3943,
     /*  50965 */     GIR_EraseRootFromParent_Done,
     /*  50966 */   // Label 797: @50966
     /*  50966 */   GIM_Try, /*On fail goto*//*Label 798*/ GIMT_Encode4(51021), // Rule ID 13706 //
     /*  50971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  50975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  50983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  50987 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  50991 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  50995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51002 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  51002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  51005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  51013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51019 */     GIR_RootConstrainSelectedInstOperands,
     /*  51020 */     // GIR_Coverage, 13706,
     /*  51020 */     GIR_EraseRootFromParent_Done,
     /*  51021 */   // Label 798: @51021
     /*  51021 */   GIM_Try, /*On fail goto*//*Label 799*/ GIMT_Encode4(51051), // Rule ID 3939 //
     /*  51026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51034 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  51034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
     /*  51037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51039 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  51043 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51049 */     GIR_RootConstrainSelectedInstOperands,
     /*  51050 */     // GIR_Coverage, 3939,
     /*  51050 */     GIR_EraseRootFromParent_Done,
     /*  51051 */   // Label 799: @51051
     /*  51051 */   GIM_Reject,
     /*  51052 */ // Label 796: @51052
     /*  51052 */ GIM_Reject,
     /*  51053 */ // Label 788: @51053
     /*  51053 */ GIM_Try, /*On fail goto*//*Label 800*/ GIMT_Encode4(51596),
     /*  51058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  51061 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  51064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51068 */   GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(51123), // Rule ID 3944 //
     /*  51073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51085 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51089 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51102 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51104 */     // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  51107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51113 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  51115 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51121 */     GIR_RootConstrainSelectedInstOperands,
     /*  51122 */     // GIR_Coverage, 3944,
     /*  51122 */     GIR_EraseRootFromParent_Done,
     /*  51123 */   // Label 801: @51123
     /*  51123 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(51178), // Rule ID 13707 //
     /*  51128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51148 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51157 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51159 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  51162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51168 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  51170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51176 */     GIR_RootConstrainSelectedInstOperands,
     /*  51177 */     // GIR_Coverage, 13707,
     /*  51177 */     GIR_EraseRootFromParent_Done,
     /*  51178 */   // Label 802: @51178
     /*  51178 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(51291), // Rule ID 3955 //
     /*  51183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  51191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  51195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51200 */     // MIs[1] Operand 2
     /*  51200 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  51211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51219 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51223 */     // MIs[2] Operand 1
     /*  51223 */     // No operand predicates
     /*  51223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51225 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51225 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  51228 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51232 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51237 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  51244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  51251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51256 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  51262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  51283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51289 */     GIR_RootConstrainSelectedInstOperands,
     /*  51290 */     // GIR_Coverage, 3955,
     /*  51290 */     GIR_EraseRootFromParent_Done,
     /*  51291 */   // Label 803: @51291
     /*  51291 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(51366), // Rule ID 3953 //
     /*  51296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51321 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  51325 */     // MIs[2] Operand 1
     /*  51325 */     // No operand predicates
     /*  51325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51327 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51339 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51344 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51358 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51364 */     GIR_RootConstrainSelectedInstOperands,
     /*  51365 */     // GIR_Coverage, 3953,
     /*  51365 */     GIR_EraseRootFromParent_Done,
     /*  51366 */   // Label 804: @51366
     /*  51366 */   GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(51441), // Rule ID 3954 //
     /*  51371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51396 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  51400 */     // MIs[2] Operand 1
     /*  51400 */     // No operand predicates
     /*  51400 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51402 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  51402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  51405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  51409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  51414 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  51419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  51421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  51433 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51439 */     GIR_RootConstrainSelectedInstOperands,
     /*  51440 */     // GIR_Coverage, 3954,
     /*  51440 */     GIR_EraseRootFromParent_Done,
     /*  51441 */   // Label 805: @51441
     /*  51441 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(51503), // Rule ID 3947 //
     /*  51446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51480 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51482 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  51485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51501 */     GIR_RootConstrainSelectedInstOperands,
     /*  51502 */     // GIR_Coverage, 3947,
     /*  51502 */     GIR_EraseRootFromParent_Done,
     /*  51503 */   // Label 806: @51503
     /*  51503 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(51565), // Rule ID 3950 //
     /*  51508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  51537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51542 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51544 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  51544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  51547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51563 */     GIR_RootConstrainSelectedInstOperands,
     /*  51564 */     // GIR_Coverage, 3950,
     /*  51564 */     GIR_EraseRootFromParent_Done,
     /*  51565 */   // Label 807: @51565
     /*  51565 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(51595), // Rule ID 3940 //
     /*  51570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  51578 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  51578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
     /*  51581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  51587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51593 */     GIR_RootConstrainSelectedInstOperands,
     /*  51594 */     // GIR_Coverage, 3940,
     /*  51594 */     GIR_EraseRootFromParent_Done,
     /*  51595 */   // Label 808: @51595
     /*  51595 */   GIM_Reject,
     /*  51596 */ // Label 800: @51596
     /*  51596 */ GIM_Reject,
     /*  51597 */ // Label 789: @51597
     /*  51597 */ GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(51934),
     /*  51602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  51605 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51612 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(51698), // Rule ID 13400 //
     /*  51617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  51628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  51636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  51640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51644 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51653 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  51657 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51661 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  51665 */     // MIs[3] Operand 1
     /*  51665 */     // No operand predicates
     /*  51665 */     // MIs[1] Operand 2
     /*  51665 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  51676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51680 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51682 */     // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  51685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  51696 */     GIR_RootConstrainSelectedInstOperands,
     /*  51697 */     // GIR_Coverage, 13400,
     /*  51697 */     GIR_EraseRootFromParent_Done,
     /*  51698 */   // Label 810: @51698
     /*  51698 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(51784), // Rule ID 2034 //
     /*  51703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  51718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  51726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  51730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51734 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  51747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51751 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  51755 */     // MIs[3] Operand 1
     /*  51755 */     // No operand predicates
     /*  51755 */     // MIs[1] Operand 2
     /*  51755 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  51766 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  51768 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  51771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51773 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  51782 */     GIR_RootConstrainSelectedInstOperands,
     /*  51783 */     // GIR_Coverage, 2034,
     /*  51783 */     GIR_EraseRootFromParent_Done,
     /*  51784 */   // Label 811: @51784
     /*  51784 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(51847), // Rule ID 13401 //
     /*  51789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  51800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51821 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  51825 */     // MIs[2] Operand 1
     /*  51825 */     // No operand predicates
     /*  51825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51829 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51831 */     // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  51834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  51845 */     GIR_RootConstrainSelectedInstOperands,
     /*  51846 */     // GIR_Coverage, 13401,
     /*  51846 */     GIR_EraseRootFromParent_Done,
     /*  51847 */   // Label 812: @51847
     /*  51847 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(51910), // Rule ID 2035 //
     /*  51852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  51867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  51871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  51875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  51884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51888 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  51892 */     // MIs[2] Operand 1
     /*  51892 */     // No operand predicates
     /*  51892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51894 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  51894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  51897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  51908 */     GIR_RootConstrainSelectedInstOperands,
     /*  51909 */     // GIR_Coverage, 2035,
     /*  51909 */     GIR_EraseRootFromParent_Done,
     /*  51910 */   // Label 813: @51910
     /*  51910 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(51933), // Rule ID 1352 //
     /*  51915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51926 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  51926 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
     /*  51931 */     GIR_RootConstrainSelectedInstOperands,
     /*  51932 */     // GIR_Coverage, 1352,
     /*  51932 */     GIR_Done,
     /*  51933 */   // Label 814: @51933
     /*  51933 */   GIM_Reject,
     /*  51934 */ // Label 809: @51934
     /*  51934 */ GIM_Reject,
     /*  51935 */ // Label 790: @51935
     /*  51935 */ GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(52272),
     /*  51940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  51943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51950 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(52036), // Rule ID 13397 //
     /*  51955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  51966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  51974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  51978 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  51982 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  51986 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  51991 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  51995 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  51999 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52003 */     // MIs[3] Operand 1
     /*  52003 */     // No operand predicates
     /*  52003 */     // MIs[1] Operand 2
     /*  52003 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52018 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52020 */     // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52031 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52034 */     GIR_RootConstrainSelectedInstOperands,
     /*  52035 */     // GIR_Coverage, 13397,
     /*  52035 */     GIR_EraseRootFromParent_Done,
     /*  52036 */   // Label 816: @52036
     /*  52036 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(52122), // Rule ID 2031 //
     /*  52041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  52056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  52064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  52085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52089 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52093 */     // MIs[3] Operand 1
     /*  52093 */     // No operand predicates
     /*  52093 */     // MIs[1] Operand 2
     /*  52093 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  52104 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  52106 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  52120 */     GIR_RootConstrainSelectedInstOperands,
     /*  52121 */     // GIR_Coverage, 2031,
     /*  52121 */     GIR_EraseRootFromParent_Done,
     /*  52122 */   // Label 817: @52122
     /*  52122 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(52185), // Rule ID 13398 //
     /*  52127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52159 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52163 */     // MIs[2] Operand 1
     /*  52163 */     // No operand predicates
     /*  52163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52167 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52169 */     // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52183 */     GIR_RootConstrainSelectedInstOperands,
     /*  52184 */     // GIR_Coverage, 13398,
     /*  52184 */     GIR_EraseRootFromParent_Done,
     /*  52185 */   // Label 818: @52185
     /*  52185 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(52248), // Rule ID 2032 //
     /*  52190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52226 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52230 */     // MIs[2] Operand 1
     /*  52230 */     // No operand predicates
     /*  52230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52232 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  52235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52246 */     GIR_RootConstrainSelectedInstOperands,
     /*  52247 */     // GIR_Coverage, 2032,
     /*  52247 */     GIR_EraseRootFromParent_Done,
     /*  52248 */   // Label 819: @52248
     /*  52248 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(52271), // Rule ID 1350 //
     /*  52253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52264 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  52264 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
     /*  52269 */     GIR_RootConstrainSelectedInstOperands,
     /*  52270 */     // GIR_Coverage, 1350,
     /*  52270 */     GIR_Done,
     /*  52271 */   // Label 820: @52271
     /*  52271 */   GIM_Reject,
     /*  52272 */ // Label 815: @52272
     /*  52272 */ GIM_Reject,
     /*  52273 */ // Label 791: @52273
     /*  52273 */ GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(52438),
     /*  52278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52281 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52284 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52288 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(52351), // Rule ID 13402 //
     /*  52293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52312 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52325 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52329 */     // MIs[2] Operand 1
     /*  52329 */     // No operand predicates
     /*  52329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52335 */     // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52349 */     GIR_RootConstrainSelectedInstOperands,
     /*  52350 */     // GIR_Coverage, 13402,
     /*  52350 */     GIR_EraseRootFromParent_Done,
     /*  52351 */   // Label 822: @52351
     /*  52351 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(52414), // Rule ID 2036 //
     /*  52356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  52371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  52375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52392 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  52396 */     // MIs[2] Operand 1
     /*  52396 */     // No operand predicates
     /*  52396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52398 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  52401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52403 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52412 */     GIR_RootConstrainSelectedInstOperands,
     /*  52413 */     // GIR_Coverage, 2036,
     /*  52413 */     GIR_EraseRootFromParent_Done,
     /*  52414 */   // Label 823: @52414
     /*  52414 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(52437), // Rule ID 1353 //
     /*  52419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52422 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52430 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  52430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
     /*  52435 */     GIR_RootConstrainSelectedInstOperands,
     /*  52436 */     // GIR_Coverage, 1353,
     /*  52436 */     GIR_Done,
     /*  52437 */   // Label 824: @52437
     /*  52437 */   GIM_Reject,
     /*  52438 */ // Label 821: @52438
     /*  52438 */ GIM_Reject,
     /*  52439 */ // Label 792: @52439
     /*  52439 */ GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(52472), // Rule ID 1348 //
     /*  52444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  52450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52461 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  52465 */   // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  52465 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
     /*  52470 */   GIR_RootConstrainSelectedInstOperands,
     /*  52471 */   // GIR_Coverage, 1348,
     /*  52471 */   GIR_Done,
     /*  52472 */ // Label 825: @52472
     /*  52472 */ GIM_Reject,
     /*  52473 */ // Label 793: @52473
     /*  52473 */ GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(52638),
     /*  52478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52481 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52484 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52488 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(52551), // Rule ID 13399 //
     /*  52493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52525 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52529 */     // MIs[2] Operand 1
     /*  52529 */     // No operand predicates
     /*  52529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52535 */     // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  52538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52546 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52549 */     GIR_RootConstrainSelectedInstOperands,
     /*  52550 */     // GIR_Coverage, 13399,
     /*  52550 */     GIR_EraseRootFromParent_Done,
     /*  52551 */   // Label 827: @52551
     /*  52551 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(52614), // Rule ID 2033 //
     /*  52556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  52571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  52575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  52584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  52588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  52596 */     // MIs[2] Operand 1
     /*  52596 */     // No operand predicates
     /*  52596 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52598 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  52598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  52601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  52612 */     GIR_RootConstrainSelectedInstOperands,
     /*  52613 */     // GIR_Coverage, 2033,
     /*  52613 */     GIR_EraseRootFromParent_Done,
     /*  52614 */   // Label 828: @52614
     /*  52614 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(52637), // Rule ID 1351 //
     /*  52619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52630 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  52630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
     /*  52635 */     GIR_RootConstrainSelectedInstOperands,
     /*  52636 */     // GIR_Coverage, 1351,
     /*  52636 */     GIR_Done,
     /*  52637 */   // Label 829: @52637
     /*  52637 */   GIM_Reject,
     /*  52638 */ // Label 826: @52638
     /*  52638 */ GIM_Reject,
     /*  52639 */ // Label 794: @52639
     /*  52639 */ GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(52672), // Rule ID 1349 //
     /*  52644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  52650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  52653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52661 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  52665 */   // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  52665 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
     /*  52670 */   GIR_RootConstrainSelectedInstOperands,
     /*  52671 */   // GIR_Coverage, 1349,
     /*  52671 */   GIR_Done,
     /*  52672 */ // Label 830: @52672
     /*  52672 */ GIM_Reject,
     /*  52673 */ // Label 795: @52673
     /*  52673 */ GIM_Reject,
     /*  52674 */ // Label 3: @52674
     /*  52674 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 833*/ GIMT_Encode4(52755),
     /*  52685 */ /*GILLT_s32*//*Label 831*/ GIMT_Encode4(52693),
     /*  52689 */ /*GILLT_s64*//*Label 832*/ GIMT_Encode4(52724),
     /*  52693 */ // Label 831: @52693
     /*  52693 */ GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(52723), // Rule ID 117 //
     /*  52698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  52704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52712 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52716 */   // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  52716 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /*  52721 */   GIR_RootConstrainSelectedInstOperands,
     /*  52722 */   // GIR_Coverage, 117,
     /*  52722 */   GIR_Done,
     /*  52723 */ // Label 834: @52723
     /*  52723 */ GIM_Reject,
     /*  52724 */ // Label 832: @52724
     /*  52724 */ GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(52754), // Rule ID 118 //
     /*  52729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  52735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52743 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52747 */   // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  52747 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /*  52752 */   GIR_RootConstrainSelectedInstOperands,
     /*  52753 */   // GIR_Coverage, 118,
     /*  52753 */   GIR_Done,
     /*  52754 */ // Label 835: @52754
     /*  52754 */ GIM_Reject,
     /*  52755 */ // Label 833: @52755
     /*  52755 */ GIM_Reject,
     /*  52756 */ // Label 4: @52756
     /*  52756 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 838*/ GIMT_Encode4(52837),
     /*  52767 */ /*GILLT_s32*//*Label 836*/ GIMT_Encode4(52775),
     /*  52771 */ /*GILLT_s64*//*Label 837*/ GIMT_Encode4(52806),
     /*  52775 */ // Label 836: @52775
     /*  52775 */ GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(52805), // Rule ID 115 //
     /*  52780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  52786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52794 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52798 */   // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  52798 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /*  52803 */   GIR_RootConstrainSelectedInstOperands,
     /*  52804 */   // GIR_Coverage, 115,
     /*  52804 */   GIR_Done,
     /*  52805 */ // Label 839: @52805
     /*  52805 */ GIM_Reject,
     /*  52806 */ // Label 837: @52806
     /*  52806 */ GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(52836), // Rule ID 116 //
     /*  52811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52814 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  52817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52825 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52829 */   // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  52829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /*  52834 */   GIR_RootConstrainSelectedInstOperands,
     /*  52835 */   // GIR_Coverage, 116,
     /*  52835 */   GIR_Done,
     /*  52836 */ // Label 840: @52836
     /*  52836 */ GIM_Reject,
     /*  52837 */ // Label 838: @52837
     /*  52837 */ GIM_Reject,
     /*  52838 */ // Label 5: @52838
     /*  52838 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 859*/ GIMT_Encode4(60583),
     /*  52849 */ /*GILLT_s32*//*Label 841*/ GIMT_Encode4(52937),
     /*  52853 */ /*GILLT_s64*//*Label 842*/ GIMT_Encode4(53435), GIMT_Encode4(0),
     /*  52861 */ /*GILLT_v2s32*//*Label 843*/ GIMT_Encode4(54870),
     /*  52865 */ /*GILLT_v2s64*//*Label 844*/ GIMT_Encode4(55030),
     /*  52869 */ /*GILLT_v4s16*//*Label 845*/ GIMT_Encode4(55190),
     /*  52873 */ /*GILLT_v4s32*//*Label 846*/ GIMT_Encode4(55350),
     /*  52877 */ /*GILLT_v8s8*//*Label 847*/ GIMT_Encode4(55510),
     /*  52881 */ /*GILLT_v8s16*//*Label 848*/ GIMT_Encode4(55670),
     /*  52885 */ /*GILLT_v16s8*//*Label 849*/ GIMT_Encode4(55830),
     /*  52889 */ /*GILLT_nxv1s1*//*Label 850*/ GIMT_Encode4(55990),
     /*  52893 */ /*GILLT_nxv2s1*//*Label 851*/ GIMT_Encode4(56531), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  52905 */ /*GILLT_nxv2s64*//*Label 852*/ GIMT_Encode4(57072),
     /*  52909 */ /*GILLT_nxv4s1*//*Label 853*/ GIMT_Encode4(57544), GIMT_Encode4(0),
     /*  52917 */ /*GILLT_nxv4s32*//*Label 854*/ GIMT_Encode4(58085),
     /*  52921 */ /*GILLT_nxv8s1*//*Label 855*/ GIMT_Encode4(58557),
     /*  52925 */ /*GILLT_nxv8s16*//*Label 856*/ GIMT_Encode4(59098),
     /*  52929 */ /*GILLT_nxv16s1*//*Label 857*/ GIMT_Encode4(59570),
     /*  52933 */ /*GILLT_nxv16s8*//*Label 858*/ GIMT_Encode4(60111),
     /*  52937 */ // Label 841: @52937
     /*  52937 */ GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(53434),
     /*  52942 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  52945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  52948 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(53003), // Rule ID 13159 //
     /*  52953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  52965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52973 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  52977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52983 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  52990 */     // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  52990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  52993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  52997 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53001 */     GIR_RootConstrainSelectedInstOperands,
     /*  53002 */     // GIR_Coverage, 13159,
     /*  53002 */     GIR_EraseRootFromParent_Done,
     /*  53003 */   // Label 861: @53003
     /*  53003 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(53058), // Rule ID 162 //
     /*  53008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53032 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53038 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53045 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  53048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53052 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53056 */     GIR_RootConstrainSelectedInstOperands,
     /*  53057 */     // GIR_Coverage, 162,
     /*  53057 */     GIR_EraseRootFromParent_Done,
     /*  53058 */   // Label 862: @53058
     /*  53058 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(53127), // Rule ID 5643 //
     /*  53063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53096 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  53100 */     // MIs[2] Operand 1
     /*  53100 */     // No operand predicates
     /*  53100 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53113 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /*  53113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  53116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53125 */     GIR_RootConstrainSelectedInstOperands,
     /*  53126 */     // GIR_Coverage, 5643,
     /*  53126 */     GIR_EraseRootFromParent_Done,
     /*  53127 */   // Label 863: @53127
     /*  53127 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(53196), // Rule ID 5644 //
     /*  53132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53165 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53169 */     // MIs[2] Operand 1
     /*  53169 */     // No operand predicates
     /*  53169 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53180 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53182 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /*  53182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  53185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53194 */     GIR_RootConstrainSelectedInstOperands,
     /*  53195 */     // GIR_Coverage, 5644,
     /*  53195 */     GIR_EraseRootFromParent_Done,
     /*  53196 */   // Label 864: @53196
     /*  53196 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(53249), // Rule ID 13157 //
     /*  53201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53226 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53236 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53247 */     GIR_RootConstrainSelectedInstOperands,
     /*  53248 */     // GIR_Coverage, 13157,
     /*  53248 */     GIR_EraseRootFromParent_Done,
     /*  53249 */   // Label 865: @53249
     /*  53249 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(53302), // Rule ID 160 //
     /*  53254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  53278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53283 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53289 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  53292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53294 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53300 */     GIR_RootConstrainSelectedInstOperands,
     /*  53301 */     // GIR_Coverage, 160,
     /*  53301 */     GIR_EraseRootFromParent_Done,
     /*  53302 */   // Label 866: @53302
     /*  53302 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(53343), // Rule ID 142 //
     /*  53307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  53311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53323 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  53327 */     // MIs[1] Operand 1
     /*  53327 */     // No operand predicates
     /*  53327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53329 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  53329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /*  53332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53336 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  53341 */     GIR_RootConstrainSelectedInstOperands,
     /*  53342 */     // GIR_Coverage, 142,
     /*  53342 */     GIR_EraseRootFromParent_Done,
     /*  53343 */   // Label 867: @53343
     /*  53343 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(53376), // Rule ID 13155 //
     /*  53348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53356 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53363 */     // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53370 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53374 */     GIR_RootConstrainSelectedInstOperands,
     /*  53375 */     // GIR_Coverage, 13155,
     /*  53375 */     GIR_EraseRootFromParent_Done,
     /*  53376 */   // Label 868: @53376
     /*  53376 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(53409), // Rule ID 158 //
     /*  53381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53385 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53389 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  53396 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  53396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  53399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53403 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53407 */     GIR_RootConstrainSelectedInstOperands,
     /*  53408 */     // GIR_Coverage, 158,
     /*  53408 */     GIR_EraseRootFromParent_Done,
     /*  53409 */   // Label 869: @53409
     /*  53409 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(53433), // Rule ID 156 //
     /*  53414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53426 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  53426 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
     /*  53431 */     GIR_RootConstrainSelectedInstOperands,
     /*  53432 */     // GIR_Coverage, 156,
     /*  53432 */     GIR_Done,
     /*  53433 */   // Label 870: @53433
     /*  53433 */   GIM_Reject,
     /*  53434 */ // Label 860: @53434
     /*  53434 */ GIM_Reject,
     /*  53435 */ // Label 842: @53435
     /*  53435 */ GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(54869),
     /*  53440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  53443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53446 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(53501), // Rule ID 13160 //
     /*  53451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53471 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53481 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  53488 */     // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  53488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  53491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53495 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53499 */     GIR_RootConstrainSelectedInstOperands,
     /*  53500 */     // GIR_Coverage, 13160,
     /*  53500 */     GIR_EraseRootFromParent_Done,
     /*  53501 */   // Label 872: @53501
     /*  53501 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(53556), // Rule ID 163 //
     /*  53506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  53522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  53526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53530 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  53534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53536 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  53543 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  53543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  53546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53550 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  53554 */     GIR_RootConstrainSelectedInstOperands,
     /*  53555 */     // GIR_Coverage, 163,
     /*  53555 */     GIR_EraseRootFromParent_Done,
     /*  53556 */   // Label 873: @53556
     /*  53556 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(53669), // Rule ID 5645 //
     /*  53561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  53573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  53589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53593 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53606 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  53610 */     // MIs[3] Operand 1
     /*  53610 */     // No operand predicates
     /*  53610 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53621 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53623 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
     /*  53623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  53630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  53639 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  53642 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53658 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53668 */     // GIR_Coverage, 5645,
     /*  53668 */     GIR_EraseRootFromParent_Done,
     /*  53669 */   // Label 874: @53669
     /*  53669 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(53782), // Rule ID 5646 //
     /*  53674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  53686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  53698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53719 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53723 */     // MIs[3] Operand 1
     /*  53723 */     // No operand predicates
     /*  53723 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53736 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
     /*  53736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  53743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53748 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  53752 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  53755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53781 */     // GIR_Coverage, 5646,
     /*  53781 */     GIR_EraseRootFromParent_Done,
     /*  53782 */   // Label 875: @53782
     /*  53782 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(53881), // Rule ID 7071 //
     /*  53787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53799 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  53802 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  53807 */     // MIs[1] addr
     /*  53807 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  53811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  53816 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /*  53820 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  53831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53833 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  53833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /*  53840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53845 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  53849 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53880 */     // GIR_Coverage, 7071,
     /*  53880 */     GIR_EraseRootFromParent_Done,
     /*  53881 */   // Label 876: @53881
     /*  53881 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(53980), // Rule ID 7072 //
     /*  53886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53898 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  53901 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  53906 */     // MIs[1] addr
     /*  53906 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  53910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  53915 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /*  53919 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  53930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53932 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  53932 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53935 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /*  53939 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53944 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  53948 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  53953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  53955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  53958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  53960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  53963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  53969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53974 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53979 */     // GIR_Coverage, 7072,
     /*  53979 */     GIR_EraseRootFromParent_Done,
     /*  53980 */   // Label 877: @53980
     /*  53980 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(54079), // Rule ID 7073 //
     /*  53985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  53989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  53997 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54000 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  54005 */     // MIs[1] addr
     /*  54005 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54014 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /*  54018 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54031 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /*  54038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54043 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54047 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54078 */     // GIR_Coverage, 7073,
     /*  54078 */     GIR_EraseRootFromParent_Done,
     /*  54079 */   // Label 878: @54079
     /*  54079 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(54178), // Rule ID 7078 //
     /*  54084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54096 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54099 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54104 */     // MIs[1] addr
     /*  54104 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54113 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /*  54117 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  54128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54130 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /*  54137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54146 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54151 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54167 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54172 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54177 */     // GIR_Coverage, 7078,
     /*  54177 */     GIR_EraseRootFromParent_Done,
     /*  54178 */   // Label 879: @54178
     /*  54178 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(54277), // Rule ID 7079 //
     /*  54183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54195 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54198 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54203 */     // MIs[1] addr
     /*  54203 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54212 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /*  54216 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  54227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54229 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /*  54236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54245 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54260 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54266 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54271 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54276 */     // GIR_Coverage, 7079,
     /*  54276 */     GIR_EraseRootFromParent_Done,
     /*  54277 */   // Label 880: @54277
     /*  54277 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(54376), // Rule ID 7080 //
     /*  54282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  54294 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  54297 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  54302 */     // MIs[1] addr
     /*  54302 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  54306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54311 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /*  54315 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54328 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  54328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /*  54335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54340 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  54344 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  54349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54365 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54370 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54375 */     // GIR_Coverage, 7080,
     /*  54375 */     GIR_EraseRootFromParent_Done,
     /*  54376 */   // Label 881: @54376
     /*  54376 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(54429), // Rule ID 13158 //
     /*  54381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54406 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54414 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54416 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54427 */     GIR_RootConstrainSelectedInstOperands,
     /*  54428 */     // GIR_Coverage, 13158,
     /*  54428 */     GIR_EraseRootFromParent_Done,
     /*  54429 */   // Label 882: @54429
     /*  54429 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(54482), // Rule ID 161 //
     /*  54434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54458 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54463 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54469 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  54472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54480 */     GIR_RootConstrainSelectedInstOperands,
     /*  54481 */     // GIR_Coverage, 161,
     /*  54481 */     GIR_EraseRootFromParent_Done,
     /*  54482 */   // Label 883: @54482
     /*  54482 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(54582), // Rule ID 3992 //
     /*  54487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54495 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  54506 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  54506 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  54509 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  54513 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54518 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  54524 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54529 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54534 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  54537 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  54541 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  54546 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54552 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  54555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  54557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  54560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  54562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  54565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  54568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  54571 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  54576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54581 */     // GIR_Coverage, 3992,
     /*  54581 */     GIR_EraseRootFromParent_Done,
     /*  54582 */   // Label 884: @54582
     /*  54582 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(54623), // Rule ID 143 //
     /*  54587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  54591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54603 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  54607 */     // MIs[1] Operand 1
     /*  54607 */     // No operand predicates
     /*  54607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54609 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  54609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
     /*  54612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54614 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54616 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  54621 */     GIR_RootConstrainSelectedInstOperands,
     /*  54622 */     // GIR_Coverage, 143,
     /*  54622 */     GIR_EraseRootFromParent_Done,
     /*  54623 */   // Label 885: @54623
     /*  54623 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(54656), // Rule ID 13156 //
     /*  54628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54636 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  54643 */     // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  54643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  54646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54650 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54654 */     GIR_RootConstrainSelectedInstOperands,
     /*  54655 */     // GIR_Coverage, 13156,
     /*  54655 */     GIR_EraseRootFromParent_Done,
     /*  54656 */   // Label 886: @54656
     /*  54656 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(54689), // Rule ID 159 //
     /*  54661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54665 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54669 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  54676 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  54676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  54679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54683 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54687 */     GIR_RootConstrainSelectedInstOperands,
     /*  54688 */     // GIR_Coverage, 159,
     /*  54688 */     GIR_EraseRootFromParent_Done,
     /*  54689 */   // Label 887: @54689
     /*  54689 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(54753), // Rule ID 13811 //
     /*  54694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54726 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54732 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54740 */     // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  54740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54745 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  54747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54751 */     GIR_RootConstrainSelectedInstOperands,
     /*  54752 */     // GIR_Coverage, 13811,
     /*  54752 */     GIR_EraseRootFromParent_Done,
     /*  54753 */   // Label 888: @54753
     /*  54753 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(54817), // Rule ID 5027 //
     /*  54758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  54781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54794 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54800 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54804 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  54804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54809 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  54811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54815 */     GIR_RootConstrainSelectedInstOperands,
     /*  54816 */     // GIR_Coverage, 5027,
     /*  54816 */     GIR_EraseRootFromParent_Done,
     /*  54817 */   // Label 889: @54817
     /*  54817 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(54841), // Rule ID 157 //
     /*  54822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54834 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
     /*  54839 */     GIR_RootConstrainSelectedInstOperands,
     /*  54840 */     // GIR_Coverage, 157,
     /*  54840 */     GIR_Done,
     /*  54841 */   // Label 890: @54841
     /*  54841 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(54868), // Rule ID 2482 //
     /*  54846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54861 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  54861 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  54866 */     GIR_RootConstrainSelectedInstOperands,
     /*  54867 */     // GIR_Coverage, 2482,
     /*  54867 */     GIR_Done,
     /*  54868 */   // Label 891: @54868
     /*  54868 */   GIM_Reject,
     /*  54869 */ // Label 871: @54869
     /*  54869 */ GIM_Reject,
     /*  54870 */ // Label 843: @54870
     /*  54870 */ GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(55029),
     /*  54875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  54878 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54885 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(54945), // Rule ID 13810 //
     /*  54890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  54905 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54918 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54924 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54932 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  54932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54937 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  54939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  54943 */     GIR_RootConstrainSelectedInstOperands,
     /*  54944 */     // GIR_Coverage, 13810,
     /*  54944 */     GIR_EraseRootFromParent_Done,
     /*  54945 */   // Label 893: @54945
     /*  54945 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(55005), // Rule ID 5026 //
     /*  54950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  54969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54973 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54982 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  54988 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  54990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54992 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  54992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  54995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54997 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  54999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55003 */     GIR_RootConstrainSelectedInstOperands,
     /*  55004 */     // GIR_Coverage, 5026,
     /*  55004 */     GIR_EraseRootFromParent_Done,
     /*  55005 */   // Label 894: @55005
     /*  55005 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(55028), // Rule ID 2481 //
     /*  55010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55021 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  55021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55026 */     GIR_RootConstrainSelectedInstOperands,
     /*  55027 */     // GIR_Coverage, 2481,
     /*  55027 */     GIR_Done,
     /*  55028 */   // Label 895: @55028
     /*  55028 */   GIM_Reject,
     /*  55029 */ // Label 892: @55029
     /*  55029 */ GIM_Reject,
     /*  55030 */ // Label 844: @55030
     /*  55030 */ GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(55189),
     /*  55035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55045 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(55105), // Rule ID 13814 //
     /*  55050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55065 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55069 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55074 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55078 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55084 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55092 */     // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55097 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55103 */     GIR_RootConstrainSelectedInstOperands,
     /*  55104 */     // GIR_Coverage, 13814,
     /*  55104 */     GIR_EraseRootFromParent_Done,
     /*  55105 */   // Label 897: @55105
     /*  55105 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(55165), // Rule ID 5030 //
     /*  55110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  55129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55142 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55148 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55152 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55157 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55163 */     GIR_RootConstrainSelectedInstOperands,
     /*  55164 */     // GIR_Coverage, 5030,
     /*  55164 */     GIR_EraseRootFromParent_Done,
     /*  55165 */   // Label 898: @55165
     /*  55165 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(55188), // Rule ID 2485 //
     /*  55170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55181 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  55181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55186 */     GIR_RootConstrainSelectedInstOperands,
     /*  55187 */     // GIR_Coverage, 2485,
     /*  55187 */     GIR_Done,
     /*  55188 */   // Label 899: @55188
     /*  55188 */   GIM_Reject,
     /*  55189 */ // Label 896: @55189
     /*  55189 */ GIM_Reject,
     /*  55190 */ // Label 845: @55190
     /*  55190 */ GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(55349),
     /*  55195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55205 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(55265), // Rule ID 13809 //
     /*  55210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55238 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55244 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55252 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55257 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55263 */     GIR_RootConstrainSelectedInstOperands,
     /*  55264 */     // GIR_Coverage, 13809,
     /*  55264 */     GIR_EraseRootFromParent_Done,
     /*  55265 */   // Label 901: @55265
     /*  55265 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(55325), // Rule ID 5025 //
     /*  55270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  55289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55302 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55308 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55310 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55312 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55317 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55323 */     GIR_RootConstrainSelectedInstOperands,
     /*  55324 */     // GIR_Coverage, 5025,
     /*  55324 */     GIR_EraseRootFromParent_Done,
     /*  55325 */   // Label 902: @55325
     /*  55325 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(55348), // Rule ID 2480 //
     /*  55330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55341 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  55341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55346 */     GIR_RootConstrainSelectedInstOperands,
     /*  55347 */     // GIR_Coverage, 2480,
     /*  55347 */     GIR_Done,
     /*  55348 */   // Label 903: @55348
     /*  55348 */   GIM_Reject,
     /*  55349 */ // Label 900: @55349
     /*  55349 */ GIM_Reject,
     /*  55350 */ // Label 846: @55350
     /*  55350 */ GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(55509),
     /*  55355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55365 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(55425), // Rule ID 13813 //
     /*  55370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55398 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55412 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55417 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55423 */     GIR_RootConstrainSelectedInstOperands,
     /*  55424 */     // GIR_Coverage, 13813,
     /*  55424 */     GIR_EraseRootFromParent_Done,
     /*  55425 */   // Label 905: @55425
     /*  55425 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(55485), // Rule ID 5029 //
     /*  55430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55433 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  55449 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55462 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55468 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55472 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55477 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55483 */     GIR_RootConstrainSelectedInstOperands,
     /*  55484 */     // GIR_Coverage, 5029,
     /*  55484 */     GIR_EraseRootFromParent_Done,
     /*  55485 */   // Label 906: @55485
     /*  55485 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(55508), // Rule ID 2484 //
     /*  55490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55501 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  55501 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55506 */     GIR_RootConstrainSelectedInstOperands,
     /*  55507 */     // GIR_Coverage, 2484,
     /*  55507 */     GIR_Done,
     /*  55508 */   // Label 907: @55508
     /*  55508 */   GIM_Reject,
     /*  55509 */ // Label 904: @55509
     /*  55509 */ GIM_Reject,
     /*  55510 */ // Label 847: @55510
     /*  55510 */ GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(55669),
     /*  55515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55525 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(55585), // Rule ID 13295 //
     /*  55530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55545 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55558 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55564 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55572 */     // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  55572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55583 */     GIR_RootConstrainSelectedInstOperands,
     /*  55584 */     // GIR_Coverage, 13295,
     /*  55584 */     GIR_EraseRootFromParent_Done,
     /*  55585 */   // Label 909: @55585
     /*  55585 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(55645), // Rule ID 1597 //
     /*  55590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  55609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55622 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55632 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  55632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  55635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55637 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55643 */     GIR_RootConstrainSelectedInstOperands,
     /*  55644 */     // GIR_Coverage, 1597,
     /*  55644 */     GIR_EraseRootFromParent_Done,
     /*  55645 */   // Label 910: @55645
     /*  55645 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(55668), // Rule ID 1595 //
     /*  55650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55653 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  55661 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  55661 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  55666 */     GIR_RootConstrainSelectedInstOperands,
     /*  55667 */     // GIR_Coverage, 1595,
     /*  55667 */     GIR_Done,
     /*  55668 */   // Label 911: @55668
     /*  55668 */   GIM_Reject,
     /*  55669 */ // Label 908: @55669
     /*  55669 */ GIM_Reject,
     /*  55670 */ // Label 848: @55670
     /*  55670 */ GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(55829),
     /*  55675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55685 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(55745), // Rule ID 13812 //
     /*  55690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55718 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55732 */     // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  55732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55737 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  55739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55743 */     GIR_RootConstrainSelectedInstOperands,
     /*  55744 */     // GIR_Coverage, 13812,
     /*  55744 */     GIR_EraseRootFromParent_Done,
     /*  55745 */   // Label 913: @55745
     /*  55745 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(55805), // Rule ID 5028 //
     /*  55750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55782 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55788 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55792 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  55792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55797 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  55799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  55803 */     GIR_RootConstrainSelectedInstOperands,
     /*  55804 */     // GIR_Coverage, 5028,
     /*  55804 */     GIR_EraseRootFromParent_Done,
     /*  55805 */   // Label 914: @55805
     /*  55805 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(55828), // Rule ID 2483 //
     /*  55810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55821 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  55821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55826 */     GIR_RootConstrainSelectedInstOperands,
     /*  55827 */     // GIR_Coverage, 2483,
     /*  55827 */     GIR_Done,
     /*  55828 */   // Label 915: @55828
     /*  55828 */   GIM_Reject,
     /*  55829 */ // Label 912: @55829
     /*  55829 */ GIM_Reject,
     /*  55830 */ // Label 849: @55830
     /*  55830 */ GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(55989),
     /*  55835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55845 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(55905), // Rule ID 13296 //
     /*  55850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55878 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55884 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55892 */     // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  55892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55903 */     GIR_RootConstrainSelectedInstOperands,
     /*  55904 */     // GIR_Coverage, 13296,
     /*  55904 */     GIR_EraseRootFromParent_Done,
     /*  55905 */   // Label 917: @55905
     /*  55905 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(55965), // Rule ID 1598 //
     /*  55910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55942 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  55948 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  55950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55952 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  55952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  55955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55963 */     GIR_RootConstrainSelectedInstOperands,
     /*  55964 */     // GIR_Coverage, 1598,
     /*  55964 */     GIR_EraseRootFromParent_Done,
     /*  55965 */   // Label 918: @55965
     /*  55965 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(55988), // Rule ID 1596 //
     /*  55970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55981 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  55981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  55986 */     GIR_RootConstrainSelectedInstOperands,
     /*  55987 */     // GIR_Coverage, 1596,
     /*  55987 */     GIR_Done,
     /*  55988 */   // Label 919: @55988
     /*  55988 */   GIM_Reject,
     /*  55989 */ // Label 916: @55989
     /*  55989 */ GIM_Reject,
     /*  55990 */ // Label 850: @55990
     /*  55990 */ GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(56530),
     /*  55995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  55998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  56005 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(56062), // Rule ID 15012 //
     /*  56010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56041 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56047 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56060 */     GIR_RootConstrainSelectedInstOperands,
     /*  56061 */     // GIR_Coverage, 15012,
     /*  56061 */     GIR_EraseRootFromParent_Done,
     /*  56062 */   // Label 921: @56062
     /*  56062 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(56119), // Rule ID 15015 //
     /*  56067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56082 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56094 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56098 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56104 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56117 */     GIR_RootConstrainSelectedInstOperands,
     /*  56118 */     // GIR_Coverage, 15015,
     /*  56118 */     GIR_EraseRootFromParent_Done,
     /*  56119 */   // Label 922: @56119
     /*  56119 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(56176), // Rule ID 15011 //
     /*  56124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56155 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56161 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56174 */     GIR_RootConstrainSelectedInstOperands,
     /*  56175 */     // GIR_Coverage, 15011,
     /*  56175 */     GIR_EraseRootFromParent_Done,
     /*  56176 */   // Label 923: @56176
     /*  56176 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(56233), // Rule ID 15014 //
     /*  56181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56212 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56218 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56231 */     GIR_RootConstrainSelectedInstOperands,
     /*  56232 */     // GIR_Coverage, 15014,
     /*  56232 */     GIR_EraseRootFromParent_Done,
     /*  56233 */   // Label 924: @56233
     /*  56233 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(56290), // Rule ID 15010 //
     /*  56238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56265 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56269 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56273 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56275 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56282 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56288 */     GIR_RootConstrainSelectedInstOperands,
     /*  56289 */     // GIR_Coverage, 15010,
     /*  56289 */     GIR_EraseRootFromParent_Done,
     /*  56290 */   // Label 925: @56290
     /*  56290 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(56347), // Rule ID 15013 //
     /*  56295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56310 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56326 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56332 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56339 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56345 */     GIR_RootConstrainSelectedInstOperands,
     /*  56346 */     // GIR_Coverage, 15013,
     /*  56346 */     GIR_EraseRootFromParent_Done,
     /*  56347 */   // Label 926: @56347
     /*  56347 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(56404), // Rule ID 8380 //
     /*  56352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56383 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56389 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56394 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56402 */     GIR_RootConstrainSelectedInstOperands,
     /*  56403 */     // GIR_Coverage, 8380,
     /*  56403 */     GIR_EraseRootFromParent_Done,
     /*  56404 */   // Label 927: @56404
     /*  56404 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(56461), // Rule ID 8381 //
     /*  56409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  56424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  56428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56440 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56446 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56451 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56459 */     GIR_RootConstrainSelectedInstOperands,
     /*  56460 */     // GIR_Coverage, 8381,
     /*  56460 */     GIR_EraseRootFromParent_Done,
     /*  56461 */   // Label 928: @56461
     /*  56461 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(56508), // Rule ID 10632 //
     /*  56466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  56477 */     // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
     /*  56477 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  56480 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  56484 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56489 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  56492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  56504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  56506 */     GIR_RootConstrainSelectedInstOperands,
     /*  56507 */     // GIR_Coverage, 10632,
     /*  56507 */     GIR_EraseRootFromParent_Done,
     /*  56508 */   // Label 929: @56508
     /*  56508 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(56529), // Rule ID 2751 //
     /*  56513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56516 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  56516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  56519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56521 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  56527 */     GIR_RootConstrainSelectedInstOperands,
     /*  56528 */     // GIR_Coverage, 2751,
     /*  56528 */     GIR_EraseRootFromParent_Done,
     /*  56529 */   // Label 930: @56529
     /*  56529 */   GIM_Reject,
     /*  56530 */ // Label 920: @56530
     /*  56530 */ GIM_Reject,
     /*  56531 */ // Label 851: @56531
     /*  56531 */ GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(57071),
     /*  56536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  56546 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(56603), // Rule ID 15003 //
     /*  56551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56578 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56582 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56586 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56588 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56601 */     GIR_RootConstrainSelectedInstOperands,
     /*  56602 */     // GIR_Coverage, 15003,
     /*  56602 */     GIR_EraseRootFromParent_Done,
     /*  56603 */   // Label 932: @56603
     /*  56603 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(56660), // Rule ID 15006 //
     /*  56608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56639 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56645 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56658 */     GIR_RootConstrainSelectedInstOperands,
     /*  56659 */     // GIR_Coverage, 15006,
     /*  56659 */     GIR_EraseRootFromParent_Done,
     /*  56660 */   // Label 933: @56660
     /*  56660 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(56717), // Rule ID 15002 //
     /*  56665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56696 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56700 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56702 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56715 */     GIR_RootConstrainSelectedInstOperands,
     /*  56716 */     // GIR_Coverage, 15002,
     /*  56716 */     GIR_EraseRootFromParent_Done,
     /*  56717 */   // Label 934: @56717
     /*  56717 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(56774), // Rule ID 15005 //
     /*  56722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56753 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56759 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  56768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56772 */     GIR_RootConstrainSelectedInstOperands,
     /*  56773 */     // GIR_Coverage, 15005,
     /*  56773 */     GIR_EraseRootFromParent_Done,
     /*  56774 */   // Label 935: @56774
     /*  56774 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(56831), // Rule ID 15001 //
     /*  56779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56782 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56786 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56790 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56794 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56810 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56816 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56829 */     GIR_RootConstrainSelectedInstOperands,
     /*  56830 */     // GIR_Coverage, 15001,
     /*  56830 */     GIR_EraseRootFromParent_Done,
     /*  56831 */   // Label 936: @56831
     /*  56831 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(56888), // Rule ID 15004 //
     /*  56836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  56859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56867 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56873 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56878 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  56886 */     GIR_RootConstrainSelectedInstOperands,
     /*  56887 */     // GIR_Coverage, 15004,
     /*  56887 */     GIR_EraseRootFromParent_Done,
     /*  56888 */   // Label 937: @56888
     /*  56888 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(56945), // Rule ID 8376 //
     /*  56893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56920 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  56924 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56930 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  56943 */     GIR_RootConstrainSelectedInstOperands,
     /*  56944 */     // GIR_Coverage, 8376,
     /*  56944 */     GIR_EraseRootFromParent_Done,
     /*  56945 */   // Label 938: @56945
     /*  56945 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(57002), // Rule ID 8377 //
     /*  56950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  56953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  56965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  56969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  56977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  56981 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  56985 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56987 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  56987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  56990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  56992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  56996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57000 */     GIR_RootConstrainSelectedInstOperands,
     /*  57001 */     // GIR_Coverage, 8377,
     /*  57001 */     GIR_EraseRootFromParent_Done,
     /*  57002 */   // Label 939: @57002
     /*  57002 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(57049), // Rule ID 10631 //
     /*  57007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  57018 */     // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
     /*  57018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  57021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  57025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  57030 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  57033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  57035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  57043 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  57045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  57047 */     GIR_RootConstrainSelectedInstOperands,
     /*  57048 */     // GIR_Coverage, 10631,
     /*  57048 */     GIR_EraseRootFromParent_Done,
     /*  57049 */   // Label 940: @57049
     /*  57049 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(57070), // Rule ID 2750 //
     /*  57054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57057 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  57057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  57060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57064 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  57068 */     GIR_RootConstrainSelectedInstOperands,
     /*  57069 */     // GIR_Coverage, 2750,
     /*  57069 */     GIR_EraseRootFromParent_Done,
     /*  57070 */   // Label 941: @57070
     /*  57070 */   GIM_Reject,
     /*  57071 */ // Label 931: @57071
     /*  57071 */ GIM_Reject,
     /*  57072 */ // Label 852: @57072
     /*  57072 */ GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(57543),
     /*  57077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57080 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  57087 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(57142), // Rule ID 14943 //
     /*  57092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57123 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57129 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57140 */     GIR_RootConstrainSelectedInstOperands,
     /*  57141 */     // GIR_Coverage, 14943,
     /*  57141 */     GIR_EraseRootFromParent_Done,
     /*  57142 */   // Label 943: @57142
     /*  57142 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(57197), // Rule ID 14946 //
     /*  57147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57174 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57178 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57184 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57195 */     GIR_RootConstrainSelectedInstOperands,
     /*  57196 */     // GIR_Coverage, 14946,
     /*  57196 */     GIR_EraseRootFromParent_Done,
     /*  57197 */   // Label 944: @57197
     /*  57197 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(57252), // Rule ID 14942 //
     /*  57202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57233 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57239 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57250 */     GIR_RootConstrainSelectedInstOperands,
     /*  57251 */     // GIR_Coverage, 14942,
     /*  57251 */     GIR_EraseRootFromParent_Done,
     /*  57252 */   // Label 945: @57252
     /*  57252 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(57307), // Rule ID 14945 //
     /*  57257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57288 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57294 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57305 */     GIR_RootConstrainSelectedInstOperands,
     /*  57306 */     // GIR_Coverage, 14945,
     /*  57306 */     GIR_EraseRootFromParent_Done,
     /*  57307 */   // Label 946: @57307
     /*  57307 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(57362), // Rule ID 14941 //
     /*  57312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57343 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57349 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57360 */     GIR_RootConstrainSelectedInstOperands,
     /*  57361 */     // GIR_Coverage, 14941,
     /*  57361 */     GIR_EraseRootFromParent_Done,
     /*  57362 */   // Label 947: @57362
     /*  57362 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(57417), // Rule ID 14944 //
     /*  57367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57382 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57394 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57398 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57404 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57415 */     GIR_RootConstrainSelectedInstOperands,
     /*  57416 */     // GIR_Coverage, 14944,
     /*  57416 */     GIR_EraseRootFromParent_Done,
     /*  57417 */   // Label 948: @57417
     /*  57417 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(57472), // Rule ID 7429 //
     /*  57422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57453 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57459 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57470 */     GIR_RootConstrainSelectedInstOperands,
     /*  57471 */     // GIR_Coverage, 7429,
     /*  57471 */     GIR_EraseRootFromParent_Done,
     /*  57472 */   // Label 949: @57472
     /*  57472 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(57527), // Rule ID 7430 //
     /*  57477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  57492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  57496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57508 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57514 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  57517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  57519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57525 */     GIR_RootConstrainSelectedInstOperands,
     /*  57526 */     // GIR_Coverage, 7430,
     /*  57526 */     GIR_EraseRootFromParent_Done,
     /*  57527 */   // Label 950: @57527
     /*  57527 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(57542), // Rule ID 3144 //
     /*  57532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57535 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  57535 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  57540 */     GIR_RootConstrainSelectedInstOperands,
     /*  57541 */     // GIR_Coverage, 3144,
     /*  57541 */     GIR_Done,
     /*  57542 */   // Label 951: @57542
     /*  57542 */   GIM_Reject,
     /*  57543 */ // Label 942: @57543
     /*  57543 */ GIM_Reject,
     /*  57544 */ // Label 853: @57544
     /*  57544 */ GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(58084),
     /*  57549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  57559 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(57616), // Rule ID 14994 //
     /*  57564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57595 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57599 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57601 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57614 */     GIR_RootConstrainSelectedInstOperands,
     /*  57615 */     // GIR_Coverage, 14994,
     /*  57615 */     GIR_EraseRootFromParent_Done,
     /*  57616 */   // Label 953: @57616
     /*  57616 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(57673), // Rule ID 14997 //
     /*  57621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57652 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57658 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57671 */     GIR_RootConstrainSelectedInstOperands,
     /*  57672 */     // GIR_Coverage, 14997,
     /*  57672 */     GIR_EraseRootFromParent_Done,
     /*  57673 */   // Label 954: @57673
     /*  57673 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(57730), // Rule ID 14993 //
     /*  57678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57709 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57713 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57715 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57728 */     GIR_RootConstrainSelectedInstOperands,
     /*  57729 */     // GIR_Coverage, 14993,
     /*  57729 */     GIR_EraseRootFromParent_Done,
     /*  57730 */   // Label 955: @57730
     /*  57730 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(57787), // Rule ID 14996 //
     /*  57735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57746 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57750 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57766 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57772 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  57781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57785 */     GIR_RootConstrainSelectedInstOperands,
     /*  57786 */     // GIR_Coverage, 14996,
     /*  57786 */     GIR_EraseRootFromParent_Done,
     /*  57787 */   // Label 956: @57787
     /*  57787 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(57844), // Rule ID 14992 //
     /*  57792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57823 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57829 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57834 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57842 */     GIR_RootConstrainSelectedInstOperands,
     /*  57843 */     // GIR_Coverage, 14992,
     /*  57843 */     GIR_EraseRootFromParent_Done,
     /*  57844 */   // Label 957: @57844
     /*  57844 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(57901), // Rule ID 14995 //
     /*  57849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57880 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57884 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57886 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57893 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57895 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  57899 */     GIR_RootConstrainSelectedInstOperands,
     /*  57900 */     // GIR_Coverage, 14995,
     /*  57900 */     GIR_EraseRootFromParent_Done,
     /*  57901 */   // Label 958: @57901
     /*  57901 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(57958), // Rule ID 8372 //
     /*  57906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57921 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  57937 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57943 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  57943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  57946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  57948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  57952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  57956 */     GIR_RootConstrainSelectedInstOperands,
     /*  57957 */     // GIR_Coverage, 8372,
     /*  57957 */     GIR_EraseRootFromParent_Done,
     /*  57958 */   // Label 959: @57958
     /*  57958 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(58015), // Rule ID 8373 //
     /*  57963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  57978 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  57982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  57994 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  57998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58000 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58013 */     GIR_RootConstrainSelectedInstOperands,
     /*  58014 */     // GIR_Coverage, 8373,
     /*  58014 */     GIR_EraseRootFromParent_Done,
     /*  58015 */   // Label 960: @58015
     /*  58015 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(58062), // Rule ID 10630 //
     /*  58020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58031 */     // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
     /*  58031 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  58034 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  58038 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58043 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  58046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58056 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  58058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  58060 */     GIR_RootConstrainSelectedInstOperands,
     /*  58061 */     // GIR_Coverage, 10630,
     /*  58061 */     GIR_EraseRootFromParent_Done,
     /*  58062 */   // Label 961: @58062
     /*  58062 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(58083), // Rule ID 2749 //
     /*  58067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58070 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  58070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58077 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  58081 */     GIR_RootConstrainSelectedInstOperands,
     /*  58082 */     // GIR_Coverage, 2749,
     /*  58082 */     GIR_EraseRootFromParent_Done,
     /*  58083 */   // Label 962: @58083
     /*  58083 */   GIM_Reject,
     /*  58084 */ // Label 952: @58084
     /*  58084 */ GIM_Reject,
     /*  58085 */ // Label 854: @58085
     /*  58085 */ GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(58556),
     /*  58090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  58100 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(58155), // Rule ID 14934 //
     /*  58105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58120 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58136 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58142 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58153 */     GIR_RootConstrainSelectedInstOperands,
     /*  58154 */     // GIR_Coverage, 14934,
     /*  58154 */     GIR_EraseRootFromParent_Done,
     /*  58155 */   // Label 964: @58155
     /*  58155 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(58210), // Rule ID 14937 //
     /*  58160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58191 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58195 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58197 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58208 */     GIR_RootConstrainSelectedInstOperands,
     /*  58209 */     // GIR_Coverage, 14937,
     /*  58209 */     GIR_EraseRootFromParent_Done,
     /*  58210 */   // Label 965: @58210
     /*  58210 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(58265), // Rule ID 14933 //
     /*  58215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58230 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58242 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58246 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58252 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58263 */     GIR_RootConstrainSelectedInstOperands,
     /*  58264 */     // GIR_Coverage, 14933,
     /*  58264 */     GIR_EraseRootFromParent_Done,
     /*  58265 */   // Label 966: @58265
     /*  58265 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(58320), // Rule ID 14936 //
     /*  58270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58285 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58297 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58301 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58307 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58318 */     GIR_RootConstrainSelectedInstOperands,
     /*  58319 */     // GIR_Coverage, 14936,
     /*  58319 */     GIR_EraseRootFromParent_Done,
     /*  58320 */   // Label 967: @58320
     /*  58320 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(58375), // Rule ID 14932 //
     /*  58325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58356 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58362 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58367 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58373 */     GIR_RootConstrainSelectedInstOperands,
     /*  58374 */     // GIR_Coverage, 14932,
     /*  58374 */     GIR_EraseRootFromParent_Done,
     /*  58375 */   // Label 968: @58375
     /*  58375 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(58430), // Rule ID 14935 //
     /*  58380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58411 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58415 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58417 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58428 */     GIR_RootConstrainSelectedInstOperands,
     /*  58429 */     // GIR_Coverage, 14935,
     /*  58429 */     GIR_EraseRootFromParent_Done,
     /*  58430 */   // Label 969: @58430
     /*  58430 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(58485), // Rule ID 7425 //
     /*  58435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58450 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58466 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58472 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58483 */     GIR_RootConstrainSelectedInstOperands,
     /*  58484 */     // GIR_Coverage, 7425,
     /*  58484 */     GIR_EraseRootFromParent_Done,
     /*  58485 */   // Label 970: @58485
     /*  58485 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(58540), // Rule ID 7426 //
     /*  58490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  58505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  58509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58521 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58525 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58527 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  58530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  58532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58538 */     GIR_RootConstrainSelectedInstOperands,
     /*  58539 */     // GIR_Coverage, 7426,
     /*  58539 */     GIR_EraseRootFromParent_Done,
     /*  58540 */   // Label 971: @58540
     /*  58540 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(58555), // Rule ID 3143 //
     /*  58545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58548 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  58548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  58553 */     GIR_RootConstrainSelectedInstOperands,
     /*  58554 */     // GIR_Coverage, 3143,
     /*  58554 */     GIR_Done,
     /*  58555 */   // Label 972: @58555
     /*  58555 */   GIM_Reject,
     /*  58556 */ // Label 963: @58556
     /*  58556 */ GIM_Reject,
     /*  58557 */ // Label 855: @58557
     /*  58557 */ GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(59097),
     /*  58562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  58572 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(58629), // Rule ID 14985 //
     /*  58577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58608 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58614 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58627 */     GIR_RootConstrainSelectedInstOperands,
     /*  58628 */     // GIR_Coverage, 14985,
     /*  58628 */     GIR_EraseRootFromParent_Done,
     /*  58629 */   // Label 974: @58629
     /*  58629 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(58686), // Rule ID 14988 //
     /*  58634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58665 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58671 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58684 */     GIR_RootConstrainSelectedInstOperands,
     /*  58685 */     // GIR_Coverage, 14988,
     /*  58685 */     GIR_EraseRootFromParent_Done,
     /*  58686 */   // Label 975: @58686
     /*  58686 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(58743), // Rule ID 14984 //
     /*  58691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58718 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58722 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58726 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58728 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58741 */     GIR_RootConstrainSelectedInstOperands,
     /*  58742 */     // GIR_Coverage, 14984,
     /*  58742 */     GIR_EraseRootFromParent_Done,
     /*  58743 */   // Label 976: @58743
     /*  58743 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(58800), // Rule ID 14987 //
     /*  58748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58779 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58783 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58785 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58798 */     GIR_RootConstrainSelectedInstOperands,
     /*  58799 */     // GIR_Coverage, 14987,
     /*  58799 */     GIR_EraseRootFromParent_Done,
     /*  58800 */   // Label 977: @58800
     /*  58800 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(58857), // Rule ID 14983 //
     /*  58805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58836 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58840 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58842 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58847 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58849 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58855 */     GIR_RootConstrainSelectedInstOperands,
     /*  58856 */     // GIR_Coverage, 14983,
     /*  58856 */     GIR_EraseRootFromParent_Done,
     /*  58857 */   // Label 978: @58857
     /*  58857 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(58914), // Rule ID 14986 //
     /*  58862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58889 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58893 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58899 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58912 */     GIR_RootConstrainSelectedInstOperands,
     /*  58913 */     // GIR_Coverage, 14986,
     /*  58913 */     GIR_EraseRootFromParent_Done,
     /*  58914 */   // Label 979: @58914
     /*  58914 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(58971), // Rule ID 8368 //
     /*  58919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58950 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58956 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  58956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58961 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58969 */     GIR_RootConstrainSelectedInstOperands,
     /*  58970 */     // GIR_Coverage, 8368,
     /*  58970 */     GIR_EraseRootFromParent_Done,
     /*  58971 */   // Label 980: @58971
     /*  58971 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(59028), // Rule ID 8369 //
     /*  58976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  58991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  58995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59007 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59011 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59013 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59018 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59026 */     GIR_RootConstrainSelectedInstOperands,
     /*  59027 */     // GIR_Coverage, 8369,
     /*  59027 */     GIR_EraseRootFromParent_Done,
     /*  59028 */   // Label 981: @59028
     /*  59028 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(59075), // Rule ID 10629 //
     /*  59033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59044 */     // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
     /*  59044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  59047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  59051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  59056 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  59059 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  59061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59066 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  59071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  59073 */     GIR_RootConstrainSelectedInstOperands,
     /*  59074 */     // GIR_Coverage, 10629,
     /*  59074 */     GIR_EraseRootFromParent_Done,
     /*  59075 */   // Label 982: @59075
     /*  59075 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(59096), // Rule ID 2748 //
     /*  59080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59083 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  59083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59088 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59090 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  59094 */     GIR_RootConstrainSelectedInstOperands,
     /*  59095 */     // GIR_Coverage, 2748,
     /*  59095 */     GIR_EraseRootFromParent_Done,
     /*  59096 */   // Label 983: @59096
     /*  59096 */   GIM_Reject,
     /*  59097 */ // Label 973: @59097
     /*  59097 */ GIM_Reject,
     /*  59098 */ // Label 856: @59098
     /*  59098 */ GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(59569),
     /*  59103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  59113 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(59168), // Rule ID 14925 //
     /*  59118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59145 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59149 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59155 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59166 */     GIR_RootConstrainSelectedInstOperands,
     /*  59167 */     // GIR_Coverage, 14925,
     /*  59167 */     GIR_EraseRootFromParent_Done,
     /*  59168 */   // Label 985: @59168
     /*  59168 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(59223), // Rule ID 14928 //
     /*  59173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59204 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59210 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59221 */     GIR_RootConstrainSelectedInstOperands,
     /*  59222 */     // GIR_Coverage, 14928,
     /*  59222 */     GIR_EraseRootFromParent_Done,
     /*  59223 */   // Label 986: @59223
     /*  59223 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(59278), // Rule ID 14924 //
     /*  59228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59259 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59265 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59276 */     GIR_RootConstrainSelectedInstOperands,
     /*  59277 */     // GIR_Coverage, 14924,
     /*  59277 */     GIR_EraseRootFromParent_Done,
     /*  59278 */   // Label 987: @59278
     /*  59278 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(59333), // Rule ID 14927 //
     /*  59283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59298 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59314 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59320 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59331 */     GIR_RootConstrainSelectedInstOperands,
     /*  59332 */     // GIR_Coverage, 14927,
     /*  59332 */     GIR_EraseRootFromParent_Done,
     /*  59333 */   // Label 988: @59333
     /*  59333 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(59388), // Rule ID 14923 //
     /*  59338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59353 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59369 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59375 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59380 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59386 */     GIR_RootConstrainSelectedInstOperands,
     /*  59387 */     // GIR_Coverage, 14923,
     /*  59387 */     GIR_EraseRootFromParent_Done,
     /*  59388 */   // Label 989: @59388
     /*  59388 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(59443), // Rule ID 14926 //
     /*  59393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59424 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59430 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59435 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59441 */     GIR_RootConstrainSelectedInstOperands,
     /*  59442 */     // GIR_Coverage, 14926,
     /*  59442 */     GIR_EraseRootFromParent_Done,
     /*  59443 */   // Label 990: @59443
     /*  59443 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(59498), // Rule ID 7421 //
     /*  59448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59475 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59479 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59485 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59492 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59496 */     GIR_RootConstrainSelectedInstOperands,
     /*  59497 */     // GIR_Coverage, 7421,
     /*  59497 */     GIR_EraseRootFromParent_Done,
     /*  59498 */   // Label 991: @59498
     /*  59498 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(59553), // Rule ID 7422 //
     /*  59503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  59518 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  59522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59534 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59540 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59551 */     GIR_RootConstrainSelectedInstOperands,
     /*  59552 */     // GIR_Coverage, 7422,
     /*  59552 */     GIR_EraseRootFromParent_Done,
     /*  59553 */   // Label 992: @59553
     /*  59553 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(59568), // Rule ID 3142 //
     /*  59558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59561 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  59561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  59566 */     GIR_RootConstrainSelectedInstOperands,
     /*  59567 */     // GIR_Coverage, 3142,
     /*  59567 */     GIR_Done,
     /*  59568 */   // Label 993: @59568
     /*  59568 */   GIM_Reject,
     /*  59569 */ // Label 984: @59569
     /*  59569 */ GIM_Reject,
     /*  59570 */ // Label 857: @59570
     /*  59570 */ GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(60110),
     /*  59575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  59585 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(59642), // Rule ID 14976 //
     /*  59590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59621 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59627 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59640 */     GIR_RootConstrainSelectedInstOperands,
     /*  59641 */     // GIR_Coverage, 14976,
     /*  59641 */     GIR_EraseRootFromParent_Done,
     /*  59642 */   // Label 995: @59642
     /*  59642 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(59699), // Rule ID 14979 //
     /*  59647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59678 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59684 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59697 */     GIR_RootConstrainSelectedInstOperands,
     /*  59698 */     // GIR_Coverage, 14979,
     /*  59698 */     GIR_EraseRootFromParent_Done,
     /*  59699 */   // Label 996: @59699
     /*  59699 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(59756), // Rule ID 14975 //
     /*  59704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59731 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59735 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59741 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59754 */     GIR_RootConstrainSelectedInstOperands,
     /*  59755 */     // GIR_Coverage, 14975,
     /*  59755 */     GIR_EraseRootFromParent_Done,
     /*  59756 */   // Label 997: @59756
     /*  59756 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(59813), // Rule ID 14978 //
     /*  59761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59792 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59798 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59811 */     GIR_RootConstrainSelectedInstOperands,
     /*  59812 */     // GIR_Coverage, 14978,
     /*  59812 */     GIR_EraseRootFromParent_Done,
     /*  59813 */   // Label 998: @59813
     /*  59813 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(59870), // Rule ID 14974 //
     /*  59818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59849 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59853 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59855 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59868 */     GIR_RootConstrainSelectedInstOperands,
     /*  59869 */     // GIR_Coverage, 14974,
     /*  59869 */     GIR_EraseRootFromParent_Done,
     /*  59870 */   // Label 999: @59870
     /*  59870 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(59927), // Rule ID 14977 //
     /*  59875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59906 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59912 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59919 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59925 */     GIR_RootConstrainSelectedInstOperands,
     /*  59926 */     // GIR_Coverage, 14977,
     /*  59926 */     GIR_EraseRootFromParent_Done,
     /*  59927 */   // Label 1000: @59927
     /*  59927 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(59984), // Rule ID 8364 //
     /*  59932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  59947 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  59951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59963 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59967 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59969 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  59969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59982 */     GIR_RootConstrainSelectedInstOperands,
     /*  59983 */     // GIR_Coverage, 8364,
     /*  59983 */     GIR_EraseRootFromParent_Done,
     /*  59984 */   // Label 1001: @59984
     /*  59984 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(60041), // Rule ID 8365 //
     /*  59989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  60004 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  60008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60016 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60020 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60026 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60031 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60033 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60039 */     GIR_RootConstrainSelectedInstOperands,
     /*  60040 */     // GIR_Coverage, 8365,
     /*  60040 */     GIR_EraseRootFromParent_Done,
     /*  60041 */   // Label 1002: @60041
     /*  60041 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(60088), // Rule ID 10628 //
     /*  60046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  60053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  60057 */     // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
     /*  60057 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  60060 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  60064 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60069 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  60072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  60084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  60086 */     GIR_RootConstrainSelectedInstOperands,
     /*  60087 */     // GIR_Coverage, 10628,
     /*  60087 */     GIR_EraseRootFromParent_Done,
     /*  60088 */   // Label 1003: @60088
     /*  60088 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(60109), // Rule ID 2747 //
     /*  60093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60096 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  60096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60101 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60103 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  60107 */     GIR_RootConstrainSelectedInstOperands,
     /*  60108 */     // GIR_Coverage, 2747,
     /*  60108 */     GIR_EraseRootFromParent_Done,
     /*  60109 */   // Label 1004: @60109
     /*  60109 */   GIM_Reject,
     /*  60110 */ // Label 994: @60110
     /*  60110 */ GIM_Reject,
     /*  60111 */ // Label 858: @60111
     /*  60111 */ GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(60582),
     /*  60116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60119 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  60126 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(60181), // Rule ID 14916 //
     /*  60131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60158 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60162 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60168 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60179 */     GIR_RootConstrainSelectedInstOperands,
     /*  60180 */     // GIR_Coverage, 14916,
     /*  60180 */     GIR_EraseRootFromParent_Done,
     /*  60181 */   // Label 1006: @60181
     /*  60181 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(60236), // Rule ID 14919 //
     /*  60186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60217 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60221 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60223 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60234 */     GIR_RootConstrainSelectedInstOperands,
     /*  60235 */     // GIR_Coverage, 14919,
     /*  60235 */     GIR_EraseRootFromParent_Done,
     /*  60236 */   // Label 1007: @60236
     /*  60236 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(60291), // Rule ID 14915 //
     /*  60241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60272 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60278 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60289 */     GIR_RootConstrainSelectedInstOperands,
     /*  60290 */     // GIR_Coverage, 14915,
     /*  60290 */     GIR_EraseRootFromParent_Done,
     /*  60291 */   // Label 1008: @60291
     /*  60291 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(60346), // Rule ID 14918 //
     /*  60296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60327 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60333 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60344 */     GIR_RootConstrainSelectedInstOperands,
     /*  60345 */     // GIR_Coverage, 14918,
     /*  60345 */     GIR_EraseRootFromParent_Done,
     /*  60346 */   // Label 1009: @60346
     /*  60346 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(60401), // Rule ID 14914 //
     /*  60351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60382 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60388 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60399 */     GIR_RootConstrainSelectedInstOperands,
     /*  60400 */     // GIR_Coverage, 14914,
     /*  60400 */     GIR_EraseRootFromParent_Done,
     /*  60401 */   // Label 1010: @60401
     /*  60401 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(60456), // Rule ID 14917 //
     /*  60406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60433 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60437 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60443 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60454 */     GIR_RootConstrainSelectedInstOperands,
     /*  60455 */     // GIR_Coverage, 14917,
     /*  60455 */     GIR_EraseRootFromParent_Done,
     /*  60456 */   // Label 1011: @60456
     /*  60456 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(60511), // Rule ID 7417 //
     /*  60461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60492 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60496 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60498 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60509 */     GIR_RootConstrainSelectedInstOperands,
     /*  60510 */     // GIR_Coverage, 7417,
     /*  60510 */     GIR_EraseRootFromParent_Done,
     /*  60511 */   // Label 1012: @60511
     /*  60511 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(60566), // Rule ID 7418 //
     /*  60516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  60531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  60535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60547 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60553 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60558 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60564 */     GIR_RootConstrainSelectedInstOperands,
     /*  60565 */     // GIR_Coverage, 7418,
     /*  60565 */     GIR_EraseRootFromParent_Done,
     /*  60566 */   // Label 1013: @60566
     /*  60566 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(60581), // Rule ID 3141 //
     /*  60571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60574 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  60574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  60579 */     GIR_RootConstrainSelectedInstOperands,
     /*  60580 */     // GIR_Coverage, 3141,
     /*  60580 */     GIR_Done,
     /*  60581 */   // Label 1014: @60581
     /*  60581 */   GIM_Reject,
     /*  60582 */ // Label 1005: @60582
     /*  60582 */ GIM_Reject,
     /*  60583 */ // Label 859: @60583
     /*  60583 */ GIM_Reject,
     /*  60584 */ // Label 6: @60584
     /*  60584 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1033*/ GIMT_Encode4(72630),
     /*  60595 */ /*GILLT_s32*//*Label 1015*/ GIMT_Encode4(60683),
     /*  60599 */ /*GILLT_s64*//*Label 1016*/ GIMT_Encode4(61043), GIMT_Encode4(0),
     /*  60607 */ /*GILLT_v2s32*//*Label 1017*/ GIMT_Encode4(63210),
     /*  60611 */ /*GILLT_v2s64*//*Label 1018*/ GIMT_Encode4(64518),
     /*  60615 */ /*GILLT_v4s16*//*Label 1019*/ GIMT_Encode4(65826),
     /*  60619 */ /*GILLT_v4s32*//*Label 1020*/ GIMT_Encode4(67134),
     /*  60623 */ /*GILLT_v8s8*//*Label 1021*/ GIMT_Encode4(68442),
     /*  60627 */ /*GILLT_v8s16*//*Label 1022*/ GIMT_Encode4(69750),
     /*  60631 */ /*GILLT_v16s8*//*Label 1023*/ GIMT_Encode4(71058),
     /*  60635 */ /*GILLT_nxv1s1*//*Label 1024*/ GIMT_Encode4(72366),
     /*  60639 */ /*GILLT_nxv2s1*//*Label 1025*/ GIMT_Encode4(72398), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  60651 */ /*GILLT_nxv2s64*//*Label 1026*/ GIMT_Encode4(72430),
     /*  60655 */ /*GILLT_nxv4s1*//*Label 1027*/ GIMT_Encode4(72456), GIMT_Encode4(0),
     /*  60663 */ /*GILLT_nxv4s32*//*Label 1028*/ GIMT_Encode4(72488),
     /*  60667 */ /*GILLT_nxv8s1*//*Label 1029*/ GIMT_Encode4(72514),
     /*  60671 */ /*GILLT_nxv8s16*//*Label 1030*/ GIMT_Encode4(72546),
     /*  60675 */ /*GILLT_nxv16s1*//*Label 1031*/ GIMT_Encode4(72572),
     /*  60679 */ /*GILLT_nxv16s8*//*Label 1032*/ GIMT_Encode4(72604),
     /*  60683 */ // Label 1015: @60683
     /*  60683 */ GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(61042),
     /*  60688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  60691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60694 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(60749), // Rule ID 13179 //
     /*  60699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  60715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  60719 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60729 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  60736 */     // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  60736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  60739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60743 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  60747 */     GIR_RootConstrainSelectedInstOperands,
     /*  60748 */     // GIR_Coverage, 13179,
     /*  60748 */     GIR_EraseRootFromParent_Done,
     /*  60749 */   // Label 1035: @60749
     /*  60749 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(60804), // Rule ID 174 //
     /*  60754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60758 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  60774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  60778 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  60791 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  60791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  60794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60798 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  60802 */     GIR_RootConstrainSelectedInstOperands,
     /*  60803 */     // GIR_Coverage, 174,
     /*  60803 */     GIR_EraseRootFromParent_Done,
     /*  60804 */   // Label 1036: @60804
     /*  60804 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(60845), // Rule ID 146 //
     /*  60809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  60813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  60825 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  60829 */     // MIs[1] Operand 1
     /*  60829 */     // No operand predicates
     /*  60829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60831 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  60831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
     /*  60834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60838 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  60843 */     GIR_RootConstrainSelectedInstOperands,
     /*  60844 */     // GIR_Coverage, 146,
     /*  60844 */     GIR_EraseRootFromParent_Done,
     /*  60845 */   // Label 1037: @60845
     /*  60845 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(60878), // Rule ID 13181 //
     /*  60850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60858 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  60865 */     // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  60865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  60868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60872 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  60876 */     GIR_RootConstrainSelectedInstOperands,
     /*  60877 */     // GIR_Coverage, 13181,
     /*  60877 */     GIR_EraseRootFromParent_Done,
     /*  60878 */   // Label 1038: @60878
     /*  60878 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(60911), // Rule ID 178 //
     /*  60883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  60898 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  60898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  60901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  60905 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  60909 */     GIR_RootConstrainSelectedInstOperands,
     /*  60910 */     // GIR_Coverage, 178,
     /*  60910 */     GIR_EraseRootFromParent_Done,
     /*  60911 */   // Label 1039: @60911
     /*  60911 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(60964), // Rule ID 13177 //
     /*  60916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  60932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  60936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60941 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  60945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60949 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  60951 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  60951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  60954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  60962 */     GIR_RootConstrainSelectedInstOperands,
     /*  60963 */     // GIR_Coverage, 13177,
     /*  60963 */     GIR_EraseRootFromParent_Done,
     /*  60964 */   // Label 1040: @60964
     /*  60964 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(61017), // Rule ID 172 //
     /*  60969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  60989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  60993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  60998 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61004 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  61007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61009 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  61015 */     GIR_RootConstrainSelectedInstOperands,
     /*  61016 */     // GIR_Coverage, 172,
     /*  61016 */     GIR_EraseRootFromParent_Done,
     /*  61017 */   // Label 1041: @61017
     /*  61017 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(61041), // Rule ID 176 //
     /*  61022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  61034 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  61034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  61039 */     GIR_RootConstrainSelectedInstOperands,
     /*  61040 */     // GIR_Coverage, 176,
     /*  61040 */     GIR_Done,
     /*  61041 */   // Label 1042: @61041
     /*  61041 */   GIM_Reject,
     /*  61042 */ // Label 1034: @61042
     /*  61042 */ GIM_Reject,
     /*  61043 */ // Label 1016: @61043
     /*  61043 */ GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(63209),
     /*  61048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  61051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  61054 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(61176), // Rule ID 4005 //
     /*  61059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  61087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61091 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61100 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  61104 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61115 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  61119 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61123 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  61127 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61131 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  61135 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  61139 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61143 */     // MIs[4] Rn
     /*  61143 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61148 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61152 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  61163 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61165 */     // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61174 */     GIR_RootConstrainSelectedInstOperands,
     /*  61175 */     // GIR_Coverage, 4005,
     /*  61175 */     GIR_EraseRootFromParent_Done,
     /*  61176 */   // Label 1044: @61176
     /*  61176 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(61298), // Rule ID 13729 //
     /*  61181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  61209 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61213 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61222 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  61226 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  61237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  61241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61245 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  61249 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61253 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  61257 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  61261 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61265 */     // MIs[4] Rn
     /*  61265 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61270 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  61274 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  61285 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61287 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  61287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  61290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  61296 */     GIR_RootConstrainSelectedInstOperands,
     /*  61297 */     // GIR_Coverage, 13729,
     /*  61297 */     GIR_EraseRootFromParent_Done,
     /*  61298 */   // Label 1045: @61298
     /*  61298 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(61353), // Rule ID 13180 //
     /*  61303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61323 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61333 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61340 */     // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  61347 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61351 */     GIR_RootConstrainSelectedInstOperands,
     /*  61352 */     // GIR_Coverage, 13180,
     /*  61352 */     GIR_EraseRootFromParent_Done,
     /*  61353 */   // Label 1046: @61353
     /*  61353 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(61408), // Rule ID 175 //
     /*  61358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  61366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61378 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61382 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  61386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  61388 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  61395 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  61395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  61398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  61400 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  61402 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  61406 */     GIR_RootConstrainSelectedInstOperands,
     /*  61407 */     // GIR_Coverage, 175,
     /*  61407 */     GIR_EraseRootFromParent_Done,
     /*  61408 */   // Label 1047: @61408
     /*  61408 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(61517), // Rule ID 13529 //
     /*  61413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61436 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61440 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61444 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61448 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61461 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61467 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61474 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61478 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61482 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  61486 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61491 */     // MIs[4] LHS
     /*  61491 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61496 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61498 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61515 */     GIR_RootConstrainSelectedInstOperands,
     /*  61516 */     // GIR_Coverage, 13529,
     /*  61516 */     GIR_EraseRootFromParent_Done,
     /*  61517 */   // Label 1048: @61517
     /*  61517 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(61626), // Rule ID 13528 //
     /*  61522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61570 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61576 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61578 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61583 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61587 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61591 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61595 */     // MIs[4] LHS
     /*  61595 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61600 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61605 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61607 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  61620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  61624 */     GIR_RootConstrainSelectedInstOperands,
     /*  61625 */     // GIR_Coverage, 13528,
     /*  61625 */     GIR_EraseRootFromParent_Done,
     /*  61626 */   // Label 1049: @61626
     /*  61626 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(61735), // Rule ID 13531 //
     /*  61631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61675 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61684 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61690 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61692 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61696 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61700 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  61704 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61709 */     // MIs[4] LHS
     /*  61709 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61714 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61716 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  61729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  61733 */     GIR_RootConstrainSelectedInstOperands,
     /*  61734 */     // GIR_Coverage, 13531,
     /*  61734 */     GIR_EraseRootFromParent_Done,
     /*  61735 */   // Label 1050: @61735
     /*  61735 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(61844), // Rule ID 13530 //
     /*  61740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61780 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61789 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  61793 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61799 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  61801 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  61805 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61809 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  61813 */     // MIs[4] LHS
     /*  61813 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  61818 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61823 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61825 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  61834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  61838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  61842 */     GIR_RootConstrainSelectedInstOperands,
     /*  61843 */     // GIR_Coverage, 13530,
     /*  61843 */     GIR_EraseRootFromParent_Done,
     /*  61844 */   // Label 1051: @61844
     /*  61844 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(61953), // Rule ID 2469 //
     /*  61849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  61898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  61902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61906 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  61910 */     // MIs[3] LHS
     /*  61910 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  61915 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  61919 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  61925 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  61927 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61932 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  61934 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  61934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  61937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  61943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  61947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  61951 */     GIR_RootConstrainSelectedInstOperands,
     /*  61952 */     // GIR_Coverage, 2469,
     /*  61952 */     GIR_EraseRootFromParent_Done,
     /*  61953 */   // Label 1052: @61953
     /*  61953 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(62062), // Rule ID 13526 //
     /*  61958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  61961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  61977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  61981 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  61991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  61995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  61999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62003 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62007 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  62011 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62015 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62019 */     // MIs[3] LHS
     /*  62019 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62024 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62028 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62034 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62041 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62043 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  62060 */     GIR_RootConstrainSelectedInstOperands,
     /*  62061 */     // GIR_Coverage, 13526,
     /*  62061 */     GIR_EraseRootFromParent_Done,
     /*  62062 */   // Label 1053: @62062
     /*  62062 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(62171), // Rule ID 13525 //
     /*  62067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62129 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62133 */     // MIs[3] LHS
     /*  62133 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  62138 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62142 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62148 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62150 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62152 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  62161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  62165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62169 */     GIR_RootConstrainSelectedInstOperands,
     /*  62170 */     // GIR_Coverage, 13525,
     /*  62170 */     GIR_EraseRootFromParent_Done,
     /*  62171 */   // Label 1054: @62171
     /*  62171 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(62280), // Rule ID 13527 //
     /*  62176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62195 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62209 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  62213 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  62217 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62221 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  62225 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62230 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  62234 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62238 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  62242 */     // MIs[3] LHS
     /*  62242 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  62247 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  62251 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  62257 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  62259 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  62261 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  62261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  62264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  62270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  62274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  62278 */     GIR_RootConstrainSelectedInstOperands,
     /*  62279 */     // GIR_Coverage, 13527,
     /*  62279 */     GIR_EraseRootFromParent_Done,
     /*  62280 */   // Label 1055: @62280
     /*  62280 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(62321), // Rule ID 147 //
     /*  62285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  62289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62301 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  62305 */     // MIs[1] Operand 1
     /*  62305 */     // No operand predicates
     /*  62305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62307 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  62307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
     /*  62310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62314 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  62319 */     GIR_RootConstrainSelectedInstOperands,
     /*  62320 */     // GIR_Coverage, 147,
     /*  62320 */     GIR_EraseRootFromParent_Done,
     /*  62321 */   // Label 1056: @62321
     /*  62321 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(62354), // Rule ID 13182 //
     /*  62326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62334 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62341 */     // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62348 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62352 */     GIR_RootConstrainSelectedInstOperands,
     /*  62353 */     // GIR_Coverage, 13182,
     /*  62353 */     GIR_EraseRootFromParent_Done,
     /*  62354 */   // Label 1057: @62354
     /*  62354 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(62387), // Rule ID 179 //
     /*  62359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62367 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  62374 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  62374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  62377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62381 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62385 */     GIR_RootConstrainSelectedInstOperands,
     /*  62386 */     // GIR_Coverage, 179,
     /*  62386 */     GIR_EraseRootFromParent_Done,
     /*  62387 */   // Label 1058: @62387
     /*  62387 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(62454), // Rule ID 13465 //
     /*  62392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62416 */     // MIs[1] imm
     /*  62416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62424 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62428 */     // MIs[2] Operand 1
     /*  62428 */     // No operand predicates
     /*  62428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62432 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62436 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62438 */     // (or:{ *:[i64] } (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62452 */     GIR_RootConstrainSelectedInstOperands,
     /*  62453 */     // GIR_Coverage, 13465,
     /*  62453 */     GIR_EraseRootFromParent_Done,
     /*  62454 */   // Label 1059: @62454
     /*  62454 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(62521), // Rule ID 13853 //
     /*  62459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62483 */     // MIs[1] imm
     /*  62483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62491 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62495 */     // MIs[2] Operand 1
     /*  62495 */     // No operand predicates
     /*  62495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62499 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62503 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62505 */     // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  62505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62519 */     GIR_RootConstrainSelectedInstOperands,
     /*  62520 */     // GIR_Coverage, 13853,
     /*  62520 */     GIR_EraseRootFromParent_Done,
     /*  62521 */   // Label 1060: @62521
     /*  62521 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(62588), // Rule ID 13468 //
     /*  62526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62550 */     // MIs[1] imm
     /*  62550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62558 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62562 */     // MIs[2] Operand 1
     /*  62562 */     // No operand predicates
     /*  62562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62566 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62572 */     // (or:{ *:[i64] } (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62586 */     GIR_RootConstrainSelectedInstOperands,
     /*  62587 */     // GIR_Coverage, 13468,
     /*  62587 */     GIR_EraseRootFromParent_Done,
     /*  62588 */   // Label 1061: @62588
     /*  62588 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(62655), // Rule ID 13856 //
     /*  62593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62617 */     // MIs[1] imm
     /*  62617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62625 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62629 */     // MIs[2] Operand 1
     /*  62629 */     // No operand predicates
     /*  62629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62633 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62637 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62639 */     // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  62639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  62646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62653 */     GIR_RootConstrainSelectedInstOperands,
     /*  62654 */     // GIR_Coverage, 13856,
     /*  62654 */     GIR_EraseRootFromParent_Done,
     /*  62655 */   // Label 1062: @62655
     /*  62655 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(62708), // Rule ID 13178 //
     /*  62660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  62680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62685 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62695 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  62695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  62698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62702 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  62706 */     GIR_RootConstrainSelectedInstOperands,
     /*  62707 */     // GIR_Coverage, 13178,
     /*  62707 */     GIR_EraseRootFromParent_Done,
     /*  62708 */   // Label 1063: @62708
     /*  62708 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(62775), // Rule ID 2120 //
     /*  62713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62741 */     // MIs[1] imm
     /*  62741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62749 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62753 */     // MIs[2] Operand 1
     /*  62753 */     // No operand predicates
     /*  62753 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62759 */     // (or:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62770 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62773 */     GIR_RootConstrainSelectedInstOperands,
     /*  62774 */     // GIR_Coverage, 2120,
     /*  62774 */     GIR_EraseRootFromParent_Done,
     /*  62775 */   // Label 1064: @62775
     /*  62775 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(62842), // Rule ID 6261 //
     /*  62780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  62799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62808 */     // MIs[1] imm
     /*  62808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62816 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62820 */     // MIs[2] Operand 1
     /*  62820 */     // No operand predicates
     /*  62820 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62826 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  62826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  62829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62831 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62840 */     GIR_RootConstrainSelectedInstOperands,
     /*  62841 */     // GIR_Coverage, 6261,
     /*  62841 */     GIR_EraseRootFromParent_Done,
     /*  62842 */   // Label 1065: @62842
     /*  62842 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(62909), // Rule ID 2129 //
     /*  62847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62875 */     // MIs[1] imm
     /*  62875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62883 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62887 */     // MIs[2] Operand 1
     /*  62887 */     // No operand predicates
     /*  62887 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62891 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62893 */     // (or:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  62893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62898 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62907 */     GIR_RootConstrainSelectedInstOperands,
     /*  62908 */     // GIR_Coverage, 2129,
     /*  62908 */     GIR_EraseRootFromParent_Done,
     /*  62909 */   // Label 1066: @62909
     /*  62909 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(62976), // Rule ID 6267 //
     /*  62914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  62917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  62933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  62937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  62942 */     // MIs[1] imm
     /*  62942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62950 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  62954 */     // MIs[2] Operand 1
     /*  62954 */     // No operand predicates
     /*  62954 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  62958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62960 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /*  62960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  62963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  62965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  62967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  62971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  62974 */     GIR_RootConstrainSelectedInstOperands,
     /*  62975 */     // GIR_Coverage, 6267,
     /*  62975 */     GIR_EraseRootFromParent_Done,
     /*  62976 */   // Label 1067: @62976
     /*  62976 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(63029), // Rule ID 173 //
     /*  62981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  62989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63010 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63016 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  63019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  63023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  63027 */     GIR_RootConstrainSelectedInstOperands,
     /*  63028 */     // GIR_Coverage, 173,
     /*  63028 */     GIR_EraseRootFromParent_Done,
     /*  63029 */   // Label 1068: @63029
     /*  63029 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(63093), // Rule ID 13817 //
     /*  63034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63066 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63072 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63080 */     // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63085 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  63087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63091 */     GIR_RootConstrainSelectedInstOperands,
     /*  63092 */     // GIR_Coverage, 13817,
     /*  63092 */     GIR_EraseRootFromParent_Done,
     /*  63093 */   // Label 1069: @63093
     /*  63093 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(63157), // Rule ID 5039 //
     /*  63098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63134 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63140 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  63142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  63144 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  63147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63149 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  63151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63155 */     GIR_RootConstrainSelectedInstOperands,
     /*  63156 */     // GIR_Coverage, 5039,
     /*  63156 */     GIR_EraseRootFromParent_Done,
     /*  63157 */   // Label 1070: @63157
     /*  63157 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(63181), // Rule ID 177 //
     /*  63162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63174 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  63174 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
     /*  63179 */     GIR_RootConstrainSelectedInstOperands,
     /*  63180 */     // GIR_Coverage, 177,
     /*  63180 */     GIR_Done,
     /*  63181 */   // Label 1071: @63181
     /*  63181 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(63208), // Rule ID 5045 //
     /*  63186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63201 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  63201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  63206 */     GIR_RootConstrainSelectedInstOperands,
     /*  63207 */     // GIR_Coverage, 5045,
     /*  63207 */     GIR_Done,
     /*  63208 */   // Label 1072: @63208
     /*  63208 */   GIM_Reject,
     /*  63209 */ // Label 1043: @63209
     /*  63209 */ GIM_Reject,
     /*  63210 */ // Label 1017: @63210
     /*  63210 */ GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(64517),
     /*  63215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63221 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(63330), // Rule ID 13522 //
     /*  63226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63261 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63274 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63280 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63287 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63291 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63295 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63299 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63304 */     // MIs[4] LHS
     /*  63304 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63309 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63311 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63328 */     GIR_RootConstrainSelectedInstOperands,
     /*  63329 */     // GIR_Coverage, 13522,
     /*  63329 */     GIR_EraseRootFromParent_Done,
     /*  63330 */   // Label 1074: @63330
     /*  63330 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(63439), // Rule ID 13521 //
     /*  63335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63383 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63389 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63396 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63400 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63404 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63408 */     // MIs[4] LHS
     /*  63408 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63413 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63418 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63420 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63437 */     GIR_RootConstrainSelectedInstOperands,
     /*  63438 */     // GIR_Coverage, 13521,
     /*  63438 */     GIR_EraseRootFromParent_Done,
     /*  63439 */   // Label 1075: @63439
     /*  63439 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(63548), // Rule ID 13524 //
     /*  63444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63497 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63503 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63505 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63509 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63513 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63517 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63522 */     // MIs[4] LHS
     /*  63522 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63527 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63529 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63546 */     GIR_RootConstrainSelectedInstOperands,
     /*  63547 */     // GIR_Coverage, 13524,
     /*  63547 */     GIR_EraseRootFromParent_Done,
     /*  63548 */   // Label 1076: @63548
     /*  63548 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(63657), // Rule ID 13523 //
     /*  63553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63593 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63597 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63606 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63612 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63614 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63618 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63622 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63626 */     // MIs[4] LHS
     /*  63626 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63631 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63636 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63638 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63655 */     GIR_RootConstrainSelectedInstOperands,
     /*  63656 */     // GIR_Coverage, 13523,
     /*  63656 */     GIR_EraseRootFromParent_Done,
     /*  63657 */   // Label 1077: @63657
     /*  63657 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(63766), // Rule ID 2468 //
     /*  63662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63719 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63723 */     // MIs[3] LHS
     /*  63723 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63728 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63732 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63738 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63745 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63747 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63764 */     GIR_RootConstrainSelectedInstOperands,
     /*  63765 */     // GIR_Coverage, 2468,
     /*  63765 */     GIR_EraseRootFromParent_Done,
     /*  63766 */   // Label 1078: @63766
     /*  63766 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(63875), // Rule ID 13519 //
     /*  63771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63828 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63832 */     // MIs[3] LHS
     /*  63832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  63837 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63841 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63847 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63854 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63856 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  63865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  63869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63873 */     GIR_RootConstrainSelectedInstOperands,
     /*  63874 */     // GIR_Coverage, 13519,
     /*  63874 */     GIR_EraseRootFromParent_Done,
     /*  63875 */   // Label 1079: @63875
     /*  63875 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(63984), // Rule ID 13518 //
     /*  63880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  63925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63942 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  63946 */     // MIs[3] LHS
     /*  63946 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63951 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63955 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63961 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63963 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63965 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  63965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  63982 */     GIR_RootConstrainSelectedInstOperands,
     /*  63983 */     // GIR_Coverage, 13518,
     /*  63983 */     GIR_EraseRootFromParent_Done,
     /*  63984 */   // Label 1080: @63984
     /*  63984 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(64093), // Rule ID 13520 //
     /*  63989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64051 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64055 */     // MIs[3] LHS
     /*  64055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64060 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64064 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64070 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64072 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64074 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  64074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64091 */     GIR_RootConstrainSelectedInstOperands,
     /*  64092 */     // GIR_Coverage, 13520,
     /*  64092 */     GIR_EraseRootFromParent_Done,
     /*  64093 */   // Label 1081: @64093
     /*  64093 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(64160), // Rule ID 13485 //
     /*  64098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64122 */     // MIs[1] imm
     /*  64122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64130 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64134 */     // MIs[2] Operand 1
     /*  64134 */     // No operand predicates
     /*  64134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64138 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64144 */     // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  64147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64158 */     GIR_RootConstrainSelectedInstOperands,
     /*  64159 */     // GIR_Coverage, 13485,
     /*  64159 */     GIR_EraseRootFromParent_Done,
     /*  64160 */   // Label 1082: @64160
     /*  64160 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(64227), // Rule ID 13506 //
     /*  64165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64189 */     // MIs[1] imm
     /*  64189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64197 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64201 */     // MIs[2] Operand 1
     /*  64201 */     // No operand predicates
     /*  64201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64205 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64211 */     // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  64214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64225 */     GIR_RootConstrainSelectedInstOperands,
     /*  64226 */     // GIR_Coverage, 13506,
     /*  64226 */     GIR_EraseRootFromParent_Done,
     /*  64227 */   // Label 1083: @64227
     /*  64227 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(64294), // Rule ID 2237 //
     /*  64232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64260 */     // MIs[1] imm
     /*  64260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64268 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64272 */     // MIs[2] Operand 1
     /*  64272 */     // No operand predicates
     /*  64272 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64278 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  64281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64292 */     GIR_RootConstrainSelectedInstOperands,
     /*  64293 */     // GIR_Coverage, 2237,
     /*  64293 */     GIR_EraseRootFromParent_Done,
     /*  64294 */   // Label 1084: @64294
     /*  64294 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(64361), // Rule ID 2296 //
     /*  64299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64327 */     // MIs[1] imm
     /*  64327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64335 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  64339 */     // MIs[2] Operand 1
     /*  64339 */     // No operand predicates
     /*  64339 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64345 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  64348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64359 */     GIR_RootConstrainSelectedInstOperands,
     /*  64360 */     // GIR_Coverage, 2296,
     /*  64360 */     GIR_EraseRootFromParent_Done,
     /*  64361 */   // Label 1085: @64361
     /*  64361 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(64425), // Rule ID 13816 //
     /*  64366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64398 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64412 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64417 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  64419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64423 */     GIR_RootConstrainSelectedInstOperands,
     /*  64424 */     // GIR_Coverage, 13816,
     /*  64424 */     GIR_EraseRootFromParent_Done,
     /*  64425 */   // Label 1086: @64425
     /*  64425 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(64489), // Rule ID 5038 //
     /*  64430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64466 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64472 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64476 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64481 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  64483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64487 */     GIR_RootConstrainSelectedInstOperands,
     /*  64488 */     // GIR_Coverage, 5038,
     /*  64488 */     GIR_EraseRootFromParent_Done,
     /*  64489 */   // Label 1087: @64489
     /*  64489 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(64516), // Rule ID 5044 //
     /*  64494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64509 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  64509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  64514 */     GIR_RootConstrainSelectedInstOperands,
     /*  64515 */     // GIR_Coverage, 5044,
     /*  64515 */     GIR_Done,
     /*  64516 */   // Label 1088: @64516
     /*  64516 */   GIM_Reject,
     /*  64517 */ // Label 1073: @64517
     /*  64517 */ GIM_Reject,
     /*  64518 */ // Label 1018: @64518
     /*  64518 */ GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(65825),
     /*  64523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64529 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(64638), // Rule ID 13550 //
     /*  64534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64582 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64588 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64595 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64599 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64603 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64607 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64612 */     // MIs[4] LHS
     /*  64612 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64617 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64619 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64636 */     GIR_RootConstrainSelectedInstOperands,
     /*  64637 */     // GIR_Coverage, 13550,
     /*  64637 */     GIR_EraseRootFromParent_Done,
     /*  64638 */   // Label 1090: @64638
     /*  64638 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(64747), // Rule ID 13549 //
     /*  64643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64682 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64691 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64697 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64704 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64708 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64712 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64716 */     // MIs[4] LHS
     /*  64716 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64721 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64726 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64728 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  64745 */     GIR_RootConstrainSelectedInstOperands,
     /*  64746 */     // GIR_Coverage, 13549,
     /*  64746 */     GIR_EraseRootFromParent_Done,
     /*  64747 */   // Label 1091: @64747
     /*  64747 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(64856), // Rule ID 13552 //
     /*  64752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64805 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64811 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64813 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64817 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64821 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64825 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64830 */     // MIs[4] LHS
     /*  64830 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64835 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64837 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  64850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64854 */     GIR_RootConstrainSelectedInstOperands,
     /*  64855 */     // GIR_Coverage, 13552,
     /*  64855 */     GIR_EraseRootFromParent_Done,
     /*  64856 */   // Label 1092: @64856
     /*  64856 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(64965), // Rule ID 13551 //
     /*  64861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64901 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64914 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64920 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64922 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64926 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64930 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64934 */     // MIs[4] LHS
     /*  64934 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  64939 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64944 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64946 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  64946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  64949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  64955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  64959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64963 */     GIR_RootConstrainSelectedInstOperands,
     /*  64964 */     // GIR_Coverage, 13551,
     /*  64964 */     GIR_EraseRootFromParent_Done,
     /*  64965 */   // Label 1093: @64965
     /*  64965 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(65074), // Rule ID 2472 //
     /*  64970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  64989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  64993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  64998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65027 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65031 */     // MIs[3] LHS
     /*  65031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65036 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65040 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65046 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65048 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65053 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65055 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65072 */     GIR_RootConstrainSelectedInstOperands,
     /*  65073 */     // GIR_Coverage, 2472,
     /*  65073 */     GIR_EraseRootFromParent_Done,
     /*  65074 */   // Label 1094: @65074
     /*  65074 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(65183), // Rule ID 13547 //
     /*  65079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65136 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65140 */     // MIs[3] LHS
     /*  65140 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65145 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65149 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65155 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65162 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65164 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65181 */     GIR_RootConstrainSelectedInstOperands,
     /*  65182 */     // GIR_Coverage, 13547,
     /*  65182 */     GIR_EraseRootFromParent_Done,
     /*  65183 */   // Label 1095: @65183
     /*  65183 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(65292), // Rule ID 13546 //
     /*  65188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65237 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65250 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65254 */     // MIs[3] LHS
     /*  65254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65259 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65263 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65269 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65271 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65273 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65290 */     GIR_RootConstrainSelectedInstOperands,
     /*  65291 */     // GIR_Coverage, 13546,
     /*  65291 */     GIR_EraseRootFromParent_Done,
     /*  65292 */   // Label 1096: @65292
     /*  65292 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(65401), // Rule ID 13548 //
     /*  65297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65359 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65363 */     // MIs[3] LHS
     /*  65363 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65368 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65372 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65378 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65380 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65382 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  65382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  65385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65399 */     GIR_RootConstrainSelectedInstOperands,
     /*  65400 */     // GIR_Coverage, 13548,
     /*  65400 */     GIR_EraseRootFromParent_Done,
     /*  65401 */   // Label 1097: @65401
     /*  65401 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(65468), // Rule ID 13489 //
     /*  65406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65430 */     // MIs[1] imm
     /*  65430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65438 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65442 */     // MIs[2] Operand 1
     /*  65442 */     // No operand predicates
     /*  65442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65446 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65452 */     // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65466 */     GIR_RootConstrainSelectedInstOperands,
     /*  65467 */     // GIR_Coverage, 13489,
     /*  65467 */     GIR_EraseRootFromParent_Done,
     /*  65468 */   // Label 1098: @65468
     /*  65468 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(65535), // Rule ID 13510 //
     /*  65473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65497 */     // MIs[1] imm
     /*  65497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65505 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65509 */     // MIs[2] Operand 1
     /*  65509 */     // No operand predicates
     /*  65509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65513 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65519 */     // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65533 */     GIR_RootConstrainSelectedInstOperands,
     /*  65534 */     // GIR_Coverage, 13510,
     /*  65534 */     GIR_EraseRootFromParent_Done,
     /*  65535 */   // Label 1099: @65535
     /*  65535 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(65602), // Rule ID 2241 //
     /*  65540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65568 */     // MIs[1] imm
     /*  65568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65576 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65580 */     // MIs[2] Operand 1
     /*  65580 */     // No operand predicates
     /*  65580 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65586 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  65589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65600 */     GIR_RootConstrainSelectedInstOperands,
     /*  65601 */     // GIR_Coverage, 2241,
     /*  65601 */     GIR_EraseRootFromParent_Done,
     /*  65602 */   // Label 1100: @65602
     /*  65602 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(65669), // Rule ID 2300 //
     /*  65607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65635 */     // MIs[1] imm
     /*  65635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65643 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  65647 */     // MIs[2] Operand 1
     /*  65647 */     // No operand predicates
     /*  65647 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65653 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  65656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65658 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65667 */     GIR_RootConstrainSelectedInstOperands,
     /*  65668 */     // GIR_Coverage, 2300,
     /*  65668 */     GIR_EraseRootFromParent_Done,
     /*  65669 */   // Label 1101: @65669
     /*  65669 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(65733), // Rule ID 13820 //
     /*  65674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65706 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65712 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65720 */     // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65725 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  65727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65731 */     GIR_RootConstrainSelectedInstOperands,
     /*  65732 */     // GIR_Coverage, 13820,
     /*  65732 */     GIR_EraseRootFromParent_Done,
     /*  65733 */   // Label 1102: @65733
     /*  65733 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(65797), // Rule ID 5042 //
     /*  65738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  65761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  65765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65774 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65780 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  65782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65784 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  65787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  65789 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  65791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65795 */     GIR_RootConstrainSelectedInstOperands,
     /*  65796 */     // GIR_Coverage, 5042,
     /*  65796 */     GIR_EraseRootFromParent_Done,
     /*  65797 */   // Label 1103: @65797
     /*  65797 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(65824), // Rule ID 5048 //
     /*  65802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  65817 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  65817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  65822 */     GIR_RootConstrainSelectedInstOperands,
     /*  65823 */     // GIR_Coverage, 5048,
     /*  65823 */     GIR_Done,
     /*  65824 */   // Label 1104: @65824
     /*  65824 */   GIM_Reject,
     /*  65825 */ // Label 1089: @65825
     /*  65825 */ GIM_Reject,
     /*  65826 */ // Label 1019: @65826
     /*  65826 */ GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(67133),
     /*  65831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65837 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(65946), // Rule ID 13515 //
     /*  65842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65881 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65890 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65896 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65903 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65907 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65911 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65915 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65920 */     // MIs[4] LHS
     /*  65920 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65925 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65927 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  65927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  65944 */     GIR_RootConstrainSelectedInstOperands,
     /*  65945 */     // GIR_Coverage, 13515,
     /*  65945 */     GIR_EraseRootFromParent_Done,
     /*  65946 */   // Label 1106: @65946
     /*  65946 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(66055), // Rule ID 13514 //
     /*  65951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  65986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  65990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65999 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66005 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66012 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66016 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66020 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66024 */     // MIs[4] LHS
     /*  66024 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66029 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66034 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66036 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66053 */     GIR_RootConstrainSelectedInstOperands,
     /*  66054 */     // GIR_Coverage, 13514,
     /*  66054 */     GIR_EraseRootFromParent_Done,
     /*  66055 */   // Label 1107: @66055
     /*  66055 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(66164), // Rule ID 13517 //
     /*  66060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66113 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66119 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66121 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66125 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66129 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66133 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66138 */     // MIs[4] LHS
     /*  66138 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66143 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66145 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66162 */     GIR_RootConstrainSelectedInstOperands,
     /*  66163 */     // GIR_Coverage, 13517,
     /*  66163 */     GIR_EraseRootFromParent_Done,
     /*  66164 */   // Label 1108: @66164
     /*  66164 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(66273), // Rule ID 13516 //
     /*  66169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66222 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66228 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66230 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66234 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66238 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66242 */     // MIs[4] LHS
     /*  66242 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66247 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66252 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66254 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66271 */     GIR_RootConstrainSelectedInstOperands,
     /*  66272 */     // GIR_Coverage, 13516,
     /*  66272 */     GIR_EraseRootFromParent_Done,
     /*  66273 */   // Label 1109: @66273
     /*  66273 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(66382), // Rule ID 2467 //
     /*  66278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66335 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66339 */     // MIs[3] LHS
     /*  66339 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66344 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66348 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66354 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66361 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66363 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66380 */     GIR_RootConstrainSelectedInstOperands,
     /*  66381 */     // GIR_Coverage, 2467,
     /*  66381 */     GIR_EraseRootFromParent_Done,
     /*  66382 */   // Label 1110: @66382
     /*  66382 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(66491), // Rule ID 13512 //
     /*  66387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66440 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66444 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66448 */     // MIs[3] LHS
     /*  66448 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66453 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66457 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66463 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66465 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66470 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66472 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66489 */     GIR_RootConstrainSelectedInstOperands,
     /*  66490 */     // GIR_Coverage, 13512,
     /*  66490 */     GIR_EraseRootFromParent_Done,
     /*  66491 */   // Label 1111: @66491
     /*  66491 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(66600), // Rule ID 13511 //
     /*  66496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66541 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66558 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66562 */     // MIs[3] LHS
     /*  66562 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66567 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66571 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66577 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66579 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66581 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66598 */     GIR_RootConstrainSelectedInstOperands,
     /*  66599 */     // GIR_Coverage, 13511,
     /*  66599 */     GIR_EraseRootFromParent_Done,
     /*  66600 */   // Label 1112: @66600
     /*  66600 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(66709), // Rule ID 13513 //
     /*  66605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66667 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  66671 */     // MIs[3] LHS
     /*  66671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66676 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66680 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66686 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66688 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66690 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  66690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  66693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66707 */     GIR_RootConstrainSelectedInstOperands,
     /*  66708 */     // GIR_Coverage, 13513,
     /*  66708 */     GIR_EraseRootFromParent_Done,
     /*  66709 */   // Label 1113: @66709
     /*  66709 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(66776), // Rule ID 13481 //
     /*  66714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66738 */     // MIs[1] imm
     /*  66738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66746 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66750 */     // MIs[2] Operand 1
     /*  66750 */     // No operand predicates
     /*  66750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66754 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66760 */     // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  66763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66774 */     GIR_RootConstrainSelectedInstOperands,
     /*  66775 */     // GIR_Coverage, 13481,
     /*  66775 */     GIR_EraseRootFromParent_Done,
     /*  66776 */   // Label 1114: @66776
     /*  66776 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(66843), // Rule ID 13502 //
     /*  66781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66805 */     // MIs[1] imm
     /*  66805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66813 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66817 */     // MIs[2] Operand 1
     /*  66817 */     // No operand predicates
     /*  66817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66821 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66827 */     // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  66830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  66834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66841 */     GIR_RootConstrainSelectedInstOperands,
     /*  66842 */     // GIR_Coverage, 13502,
     /*  66842 */     GIR_EraseRootFromParent_Done,
     /*  66843 */   // Label 1115: @66843
     /*  66843 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(66910), // Rule ID 2233 //
     /*  66848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  66867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66876 */     // MIs[1] imm
     /*  66876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66884 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66888 */     // MIs[2] Operand 1
     /*  66888 */     // No operand predicates
     /*  66888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66894 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  66897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66908 */     GIR_RootConstrainSelectedInstOperands,
     /*  66909 */     // GIR_Coverage, 2233,
     /*  66909 */     GIR_EraseRootFromParent_Done,
     /*  66910 */   // Label 1116: @66910
     /*  66910 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(66977), // Rule ID 2292 //
     /*  66915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  66938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66943 */     // MIs[1] imm
     /*  66943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66951 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  66955 */     // MIs[2] Operand 1
     /*  66955 */     // No operand predicates
     /*  66955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66961 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  66964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66966 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66975 */     GIR_RootConstrainSelectedInstOperands,
     /*  66976 */     // GIR_Coverage, 2292,
     /*  66976 */     GIR_EraseRootFromParent_Done,
     /*  66977 */   // Label 1117: @66977
     /*  66977 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(67041), // Rule ID 13815 //
     /*  66982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67014 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67020 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67026 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67028 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  67031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67033 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  67035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67039 */     GIR_RootConstrainSelectedInstOperands,
     /*  67040 */     // GIR_Coverage, 13815,
     /*  67040 */     GIR_EraseRootFromParent_Done,
     /*  67041 */   // Label 1118: @67041
     /*  67041 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(67105), // Rule ID 5037 //
     /*  67046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67082 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67088 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67092 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  67095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67097 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  67099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67103 */     GIR_RootConstrainSelectedInstOperands,
     /*  67104 */     // GIR_Coverage, 5037,
     /*  67104 */     GIR_EraseRootFromParent_Done,
     /*  67105 */   // Label 1119: @67105
     /*  67105 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(67132), // Rule ID 5043 //
     /*  67110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67125 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  67125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  67130 */     GIR_RootConstrainSelectedInstOperands,
     /*  67131 */     // GIR_Coverage, 5043,
     /*  67131 */     GIR_Done,
     /*  67132 */   // Label 1120: @67132
     /*  67132 */   GIM_Reject,
     /*  67133 */ // Label 1105: @67133
     /*  67133 */ GIM_Reject,
     /*  67134 */ // Label 1020: @67134
     /*  67134 */ GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(68441),
     /*  67139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67145 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(67254), // Rule ID 13543 //
     /*  67150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67198 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67211 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67215 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67219 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67223 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67228 */     // MIs[4] LHS
     /*  67228 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67233 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67235 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67252 */     GIR_RootConstrainSelectedInstOperands,
     /*  67253 */     // GIR_Coverage, 13543,
     /*  67253 */     GIR_EraseRootFromParent_Done,
     /*  67254 */   // Label 1122: @67254
     /*  67254 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(67363), // Rule ID 13542 //
     /*  67259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67307 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67313 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67320 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67324 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67328 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67332 */     // MIs[4] LHS
     /*  67332 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67337 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67342 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67344 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67361 */     GIR_RootConstrainSelectedInstOperands,
     /*  67362 */     // GIR_Coverage, 13542,
     /*  67362 */     GIR_EraseRootFromParent_Done,
     /*  67363 */   // Label 1123: @67363
     /*  67363 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(67472), // Rule ID 13545 //
     /*  67368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67421 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67427 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67429 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67433 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67437 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67441 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67446 */     // MIs[4] LHS
     /*  67446 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67451 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67453 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67470 */     GIR_RootConstrainSelectedInstOperands,
     /*  67471 */     // GIR_Coverage, 13545,
     /*  67471 */     GIR_EraseRootFromParent_Done,
     /*  67472 */   // Label 1124: @67472
     /*  67472 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(67581), // Rule ID 13544 //
     /*  67477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67530 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67536 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67538 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67542 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67546 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67550 */     // MIs[4] LHS
     /*  67550 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67555 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67560 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67562 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67579 */     GIR_RootConstrainSelectedInstOperands,
     /*  67580 */     // GIR_Coverage, 13544,
     /*  67580 */     GIR_EraseRootFromParent_Done,
     /*  67581 */   // Label 1125: @67581
     /*  67581 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(67690), // Rule ID 2471 //
     /*  67586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67643 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67647 */     // MIs[3] LHS
     /*  67647 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67652 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67656 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67662 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67669 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67671 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67688 */     GIR_RootConstrainSelectedInstOperands,
     /*  67689 */     // GIR_Coverage, 2471,
     /*  67689 */     GIR_EraseRootFromParent_Done,
     /*  67690 */   // Label 1126: @67690
     /*  67690 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(67799), // Rule ID 13540 //
     /*  67695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  67748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67752 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67756 */     // MIs[3] LHS
     /*  67756 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67761 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67765 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67771 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67778 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67780 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  67797 */     GIR_RootConstrainSelectedInstOperands,
     /*  67798 */     // GIR_Coverage, 13540,
     /*  67798 */     GIR_EraseRootFromParent_Done,
     /*  67799 */   // Label 1127: @67799
     /*  67799 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(67908), // Rule ID 13539 //
     /*  67804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67849 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67853 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67866 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67870 */     // MIs[3] LHS
     /*  67870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  67875 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67879 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67885 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67887 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67889 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  67898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  67902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  67906 */     GIR_RootConstrainSelectedInstOperands,
     /*  67907 */     // GIR_Coverage, 13539,
     /*  67907 */     GIR_EraseRootFromParent_Done,
     /*  67908 */   // Label 1128: @67908
     /*  67908 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(68017), // Rule ID 13541 //
     /*  67913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  67958 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67975 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67979 */     // MIs[3] LHS
     /*  67979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67988 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67994 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67996 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67998 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  67998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68015 */     GIR_RootConstrainSelectedInstOperands,
     /*  68016 */     // GIR_Coverage, 13541,
     /*  68016 */     GIR_EraseRootFromParent_Done,
     /*  68017 */   // Label 1129: @68017
     /*  68017 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(68084), // Rule ID 13487 //
     /*  68022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68046 */     // MIs[1] imm
     /*  68046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68054 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68058 */     // MIs[2] Operand 1
     /*  68058 */     // No operand predicates
     /*  68058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68068 */     // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  68071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68082 */     GIR_RootConstrainSelectedInstOperands,
     /*  68083 */     // GIR_Coverage, 13487,
     /*  68083 */     GIR_EraseRootFromParent_Done,
     /*  68084 */   // Label 1130: @68084
     /*  68084 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(68151), // Rule ID 13508 //
     /*  68089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68113 */     // MIs[1] imm
     /*  68113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68121 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68125 */     // MIs[2] Operand 1
     /*  68125 */     // No operand predicates
     /*  68125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68129 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68135 */     // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  68138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68149 */     GIR_RootConstrainSelectedInstOperands,
     /*  68150 */     // GIR_Coverage, 13508,
     /*  68150 */     GIR_EraseRootFromParent_Done,
     /*  68151 */   // Label 1131: @68151
     /*  68151 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(68218), // Rule ID 2239 //
     /*  68156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68184 */     // MIs[1] imm
     /*  68184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68192 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68196 */     // MIs[2] Operand 1
     /*  68196 */     // No operand predicates
     /*  68196 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68202 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  68205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68216 */     GIR_RootConstrainSelectedInstOperands,
     /*  68217 */     // GIR_Coverage, 2239,
     /*  68217 */     GIR_EraseRootFromParent_Done,
     /*  68218 */   // Label 1132: @68218
     /*  68218 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(68285), // Rule ID 2298 //
     /*  68223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68251 */     // MIs[1] imm
     /*  68251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68259 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  68263 */     // MIs[2] Operand 1
     /*  68263 */     // No operand predicates
     /*  68263 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68269 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  68272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68283 */     GIR_RootConstrainSelectedInstOperands,
     /*  68284 */     // GIR_Coverage, 2298,
     /*  68284 */     GIR_EraseRootFromParent_Done,
     /*  68285 */   // Label 1133: @68285
     /*  68285 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(68349), // Rule ID 13819 //
     /*  68290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68322 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68328 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68336 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68341 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  68343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68347 */     GIR_RootConstrainSelectedInstOperands,
     /*  68348 */     // GIR_Coverage, 13819,
     /*  68348 */     GIR_EraseRootFromParent_Done,
     /*  68349 */   // Label 1134: @68349
     /*  68349 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(68413), // Rule ID 5041 //
     /*  68354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68390 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68396 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68400 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  68403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68405 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  68407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68411 */     GIR_RootConstrainSelectedInstOperands,
     /*  68412 */     // GIR_Coverage, 5041,
     /*  68412 */     GIR_EraseRootFromParent_Done,
     /*  68413 */   // Label 1135: @68413
     /*  68413 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(68440), // Rule ID 5047 //
     /*  68418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68433 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  68433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  68438 */     GIR_RootConstrainSelectedInstOperands,
     /*  68439 */     // GIR_Coverage, 5047,
     /*  68439 */     GIR_Done,
     /*  68440 */   // Label 1136: @68440
     /*  68440 */   GIM_Reject,
     /*  68441 */ // Label 1121: @68441
     /*  68441 */ GIM_Reject,
     /*  68442 */ // Label 1021: @68442
     /*  68442 */ GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(69749),
     /*  68447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68453 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(68562), // Rule ID 13303 //
     /*  68458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68506 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68512 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68519 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68523 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68527 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68531 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68536 */     // MIs[4] Rd
     /*  68536 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68541 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68543 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68560 */     GIR_RootConstrainSelectedInstOperands,
     /*  68561 */     // GIR_Coverage, 13303,
     /*  68561 */     GIR_EraseRootFromParent_Done,
     /*  68562 */   // Label 1138: @68562
     /*  68562 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(68671), // Rule ID 13302 //
     /*  68567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68615 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68621 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68628 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68632 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68636 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68640 */     // MIs[4] Rd
     /*  68640 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68645 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68650 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68652 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  68669 */     GIR_RootConstrainSelectedInstOperands,
     /*  68670 */     // GIR_Coverage, 13302,
     /*  68670 */     GIR_EraseRootFromParent_Done,
     /*  68671 */   // Label 1139: @68671
     /*  68671 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(68780), // Rule ID 13305 //
     /*  68676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68729 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68737 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68741 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68745 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68749 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68754 */     // MIs[4] Rd
     /*  68754 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68759 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68761 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  68774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68778 */     GIR_RootConstrainSelectedInstOperands,
     /*  68779 */     // GIR_Coverage, 13305,
     /*  68779 */     GIR_EraseRootFromParent_Done,
     /*  68780 */   // Label 1140: @68780
     /*  68780 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(68889), // Rule ID 13304 //
     /*  68785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68829 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68834 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68838 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68844 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68846 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68850 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68854 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68858 */     // MIs[4] Rd
     /*  68858 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68863 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68868 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68870 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  68879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  68883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  68887 */     GIR_RootConstrainSelectedInstOperands,
     /*  68888 */     // GIR_Coverage, 13304,
     /*  68888 */     GIR_EraseRootFromParent_Done,
     /*  68889 */   // Label 1141: @68889
     /*  68889 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(68998), // Rule ID 1605 //
     /*  68894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  68939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68951 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  68955 */     // MIs[3] Rd
     /*  68955 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68960 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68964 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68970 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68977 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68979 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  68979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  68988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  68992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  68996 */     GIR_RootConstrainSelectedInstOperands,
     /*  68997 */     // GIR_Coverage, 1605,
     /*  68997 */     GIR_EraseRootFromParent_Done,
     /*  68998 */   // Label 1142: @68998
     /*  68998 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(69107), // Rule ID 13300 //
     /*  69003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69060 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69064 */     // MIs[3] Rd
     /*  69064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69069 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69073 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69079 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69088 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  69105 */     GIR_RootConstrainSelectedInstOperands,
     /*  69106 */     // GIR_Coverage, 13300,
     /*  69106 */     GIR_EraseRootFromParent_Done,
     /*  69107 */   // Label 1143: @69107
     /*  69107 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(69216), // Rule ID 13299 //
     /*  69112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69174 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69178 */     // MIs[3] Rd
     /*  69178 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69183 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69187 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69193 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69195 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69197 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  69206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  69210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69214 */     GIR_RootConstrainSelectedInstOperands,
     /*  69215 */     // GIR_Coverage, 13299,
     /*  69215 */     GIR_EraseRootFromParent_Done,
     /*  69216 */   // Label 1144: @69216
     /*  69216 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(69325), // Rule ID 13301 //
     /*  69221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69283 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69287 */     // MIs[3] Rd
     /*  69287 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69292 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69296 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69302 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69304 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69306 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  69309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  69315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  69323 */     GIR_RootConstrainSelectedInstOperands,
     /*  69324 */     // GIR_Coverage, 13301,
     /*  69324 */     GIR_EraseRootFromParent_Done,
     /*  69325 */   // Label 1145: @69325
     /*  69325 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(69392), // Rule ID 13477 //
     /*  69330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69354 */     // MIs[1] imm
     /*  69354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69362 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69366 */     // MIs[2] Operand 1
     /*  69366 */     // No operand predicates
     /*  69366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69370 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69376 */     // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  69379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69390 */     GIR_RootConstrainSelectedInstOperands,
     /*  69391 */     // GIR_Coverage, 13477,
     /*  69391 */     GIR_EraseRootFromParent_Done,
     /*  69392 */   // Label 1146: @69392
     /*  69392 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(69459), // Rule ID 13498 //
     /*  69397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69421 */     // MIs[1] imm
     /*  69421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69429 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69433 */     // MIs[2] Operand 1
     /*  69433 */     // No operand predicates
     /*  69433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69437 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69443 */     // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69457 */     GIR_RootConstrainSelectedInstOperands,
     /*  69458 */     // GIR_Coverage, 13498,
     /*  69458 */     GIR_EraseRootFromParent_Done,
     /*  69459 */   // Label 1147: @69459
     /*  69459 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(69526), // Rule ID 2229 //
     /*  69464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69492 */     // MIs[1] imm
     /*  69492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69500 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69504 */     // MIs[2] Operand 1
     /*  69504 */     // No operand predicates
     /*  69504 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69508 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69510 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  69513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69524 */     GIR_RootConstrainSelectedInstOperands,
     /*  69525 */     // GIR_Coverage, 2229,
     /*  69525 */     GIR_EraseRootFromParent_Done,
     /*  69526 */   // Label 1148: @69526
     /*  69526 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(69593), // Rule ID 2288 //
     /*  69531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69559 */     // MIs[1] imm
     /*  69559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69567 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  69571 */     // MIs[2] Operand 1
     /*  69571 */     // No operand predicates
     /*  69571 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69577 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  69580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69591 */     GIR_RootConstrainSelectedInstOperands,
     /*  69592 */     // GIR_Coverage, 2288,
     /*  69592 */     GIR_EraseRootFromParent_Done,
     /*  69593 */   // Label 1149: @69593
     /*  69593 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(69657), // Rule ID 13297 //
     /*  69598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69630 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69636 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69644 */     // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69655 */     GIR_RootConstrainSelectedInstOperands,
     /*  69656 */     // GIR_Coverage, 13297,
     /*  69656 */     GIR_EraseRootFromParent_Done,
     /*  69657 */   // Label 1150: @69657
     /*  69657 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(69721), // Rule ID 1601 //
     /*  69662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  69685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  69689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69698 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69704 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  69706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69708 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  69711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  69715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  69719 */     GIR_RootConstrainSelectedInstOperands,
     /*  69720 */     // GIR_Coverage, 1601,
     /*  69720 */     GIR_EraseRootFromParent_Done,
     /*  69721 */   // Label 1151: @69721
     /*  69721 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(69748), // Rule ID 1603 //
     /*  69726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  69741 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  69741 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  69746 */     GIR_RootConstrainSelectedInstOperands,
     /*  69747 */     // GIR_Coverage, 1603,
     /*  69747 */     GIR_Done,
     /*  69748 */   // Label 1152: @69748
     /*  69748 */   GIM_Reject,
     /*  69749 */ // Label 1137: @69749
     /*  69749 */ GIM_Reject,
     /*  69750 */ // Label 1022: @69750
     /*  69750 */ GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(71057),
     /*  69755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69761 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(69870), // Rule ID 13536 //
     /*  69766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69814 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69820 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69827 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69831 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69835 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69839 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69844 */     // MIs[4] LHS
     /*  69844 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69849 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69851 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  69864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  69868 */     GIR_RootConstrainSelectedInstOperands,
     /*  69869 */     // GIR_Coverage, 13536,
     /*  69869 */     GIR_EraseRootFromParent_Done,
     /*  69870 */   // Label 1154: @69870
     /*  69870 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(69979), // Rule ID 13535 //
     /*  69875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  69902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  69910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69923 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69929 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69936 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69940 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69944 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69948 */     // MIs[4] LHS
     /*  69948 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69953 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69958 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69960 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  69960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  69973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  69977 */     GIR_RootConstrainSelectedInstOperands,
     /*  69978 */     // GIR_Coverage, 13535,
     /*  69978 */     GIR_EraseRootFromParent_Done,
     /*  69979 */   // Label 1155: @69979
     /*  69979 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(70088), // Rule ID 13538 //
     /*  69984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70037 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70043 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70045 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70049 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70053 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70057 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70062 */     // MIs[4] LHS
     /*  70062 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70067 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70069 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  70082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70086 */     GIR_RootConstrainSelectedInstOperands,
     /*  70087 */     // GIR_Coverage, 13538,
     /*  70087 */     GIR_EraseRootFromParent_Done,
     /*  70088 */   // Label 1156: @70088
     /*  70088 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(70197), // Rule ID 13537 //
     /*  70093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70146 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70152 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70154 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70158 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70162 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70166 */     // MIs[4] LHS
     /*  70166 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70171 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70176 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70178 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  70187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  70191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70195 */     GIR_RootConstrainSelectedInstOperands,
     /*  70196 */     // GIR_Coverage, 13537,
     /*  70196 */     GIR_EraseRootFromParent_Done,
     /*  70197 */   // Label 1157: @70197
     /*  70197 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(70306), // Rule ID 2470 //
     /*  70202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70259 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70263 */     // MIs[3] LHS
     /*  70263 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70268 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70272 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70278 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70285 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70287 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  70296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  70300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  70304 */     GIR_RootConstrainSelectedInstOperands,
     /*  70305 */     // GIR_Coverage, 2470,
     /*  70305 */     GIR_EraseRootFromParent_Done,
     /*  70306 */   // Label 1158: @70306
     /*  70306 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(70415), // Rule ID 13533 //
     /*  70311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70368 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70372 */     // MIs[3] LHS
     /*  70372 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70377 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70381 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70387 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70394 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70396 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  70413 */     GIR_RootConstrainSelectedInstOperands,
     /*  70414 */     // GIR_Coverage, 13533,
     /*  70414 */     GIR_EraseRootFromParent_Done,
     /*  70415 */   // Label 1159: @70415
     /*  70415 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(70524), // Rule ID 13532 //
     /*  70420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70482 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70486 */     // MIs[3] LHS
     /*  70486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70491 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70495 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70501 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70503 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70505 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  70514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  70518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70522 */     GIR_RootConstrainSelectedInstOperands,
     /*  70523 */     // GIR_Coverage, 13532,
     /*  70523 */     GIR_EraseRootFromParent_Done,
     /*  70524 */   // Label 1160: @70524
     /*  70524 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(70633), // Rule ID 13534 //
     /*  70529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70574 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70591 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70595 */     // MIs[3] LHS
     /*  70595 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70600 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70604 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70610 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70612 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70614 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  70614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  70617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  70623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  70627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  70631 */     GIR_RootConstrainSelectedInstOperands,
     /*  70632 */     // GIR_Coverage, 13534,
     /*  70632 */     GIR_EraseRootFromParent_Done,
     /*  70633 */   // Label 1161: @70633
     /*  70633 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(70700), // Rule ID 13483 //
     /*  70638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  70653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70662 */     // MIs[1] imm
     /*  70662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70670 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70674 */     // MIs[2] Operand 1
     /*  70674 */     // No operand predicates
     /*  70674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70678 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70684 */     // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  70687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70698 */     GIR_RootConstrainSelectedInstOperands,
     /*  70699 */     // GIR_Coverage, 13483,
     /*  70699 */     GIR_EraseRootFromParent_Done,
     /*  70700 */   // Label 1162: @70700
     /*  70700 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(70767), // Rule ID 13504 //
     /*  70705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  70720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70729 */     // MIs[1] imm
     /*  70729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70737 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70741 */     // MIs[2] Operand 1
     /*  70741 */     // No operand predicates
     /*  70741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70745 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70751 */     // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  70754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  70758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70765 */     GIR_RootConstrainSelectedInstOperands,
     /*  70766 */     // GIR_Coverage, 13504,
     /*  70766 */     GIR_EraseRootFromParent_Done,
     /*  70767 */   // Label 1163: @70767
     /*  70767 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(70834), // Rule ID 2235 //
     /*  70772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  70791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70800 */     // MIs[1] imm
     /*  70800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70808 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70812 */     // MIs[2] Operand 1
     /*  70812 */     // No operand predicates
     /*  70812 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70818 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  70821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  70825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70832 */     GIR_RootConstrainSelectedInstOperands,
     /*  70833 */     // GIR_Coverage, 2235,
     /*  70833 */     GIR_EraseRootFromParent_Done,
     /*  70834 */   // Label 1164: @70834
     /*  70834 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(70901), // Rule ID 2294 //
     /*  70839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  70858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70867 */     // MIs[1] imm
     /*  70867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  70875 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  70879 */     // MIs[2] Operand 1
     /*  70879 */     // No operand predicates
     /*  70879 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  70883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70885 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  70885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  70888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  70892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  70899 */     GIR_RootConstrainSelectedInstOperands,
     /*  70900 */     // GIR_Coverage, 2294,
     /*  70900 */     GIR_EraseRootFromParent_Done,
     /*  70901 */   // Label 1165: @70901
     /*  70901 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(70965), // Rule ID 13818 //
     /*  70906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70938 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70944 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  70946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70952 */     // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  70952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  70955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70957 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  70959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70963 */     GIR_RootConstrainSelectedInstOperands,
     /*  70964 */     // GIR_Coverage, 13818,
     /*  70964 */     GIR_EraseRootFromParent_Done,
     /*  70965 */   // Label 1166: @70965
     /*  70965 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(71029), // Rule ID 5040 //
     /*  70970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  70993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  70997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71006 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71012 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71016 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  71019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71021 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  71023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71027 */     GIR_RootConstrainSelectedInstOperands,
     /*  71028 */     // GIR_Coverage, 5040,
     /*  71028 */     GIR_EraseRootFromParent_Done,
     /*  71029 */   // Label 1167: @71029
     /*  71029 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(71056), // Rule ID 5046 //
     /*  71034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71049 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  71049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  71054 */     GIR_RootConstrainSelectedInstOperands,
     /*  71055 */     // GIR_Coverage, 5046,
     /*  71055 */     GIR_Done,
     /*  71056 */   // Label 1168: @71056
     /*  71056 */   GIM_Reject,
     /*  71057 */ // Label 1153: @71057
     /*  71057 */ GIM_Reject,
     /*  71058 */ // Label 1023: @71058
     /*  71058 */ GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(72365),
     /*  71063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71069 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(71178), // Rule ID 13310 //
     /*  71074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71109 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71113 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71118 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71122 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71128 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71135 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71139 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71143 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71147 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71152 */     // MIs[4] Rd
     /*  71152 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71157 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71159 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  71172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71176 */     GIR_RootConstrainSelectedInstOperands,
     /*  71177 */     // GIR_Coverage, 13310,
     /*  71177 */     GIR_EraseRootFromParent_Done,
     /*  71178 */   // Label 1170: @71178
     /*  71178 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(71287), // Rule ID 13309 //
     /*  71183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71218 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71231 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71237 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71244 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71248 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71252 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71256 */     // MIs[4] Rd
     /*  71256 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71261 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71266 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71268 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  71281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  71285 */     GIR_RootConstrainSelectedInstOperands,
     /*  71286 */     // GIR_Coverage, 13309,
     /*  71286 */     GIR_EraseRootFromParent_Done,
     /*  71287 */   // Label 1171: @71287
     /*  71287 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(71396), // Rule ID 13312 //
     /*  71292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71332 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71345 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71351 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71353 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71357 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71361 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71365 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71370 */     // MIs[4] Rd
     /*  71370 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71375 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71377 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  71390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71394 */     GIR_RootConstrainSelectedInstOperands,
     /*  71395 */     // GIR_Coverage, 13312,
     /*  71395 */     GIR_EraseRootFromParent_Done,
     /*  71396 */   // Label 1172: @71396
     /*  71396 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(71505), // Rule ID 13311 //
     /*  71401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71445 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71450 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71454 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71460 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71462 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71466 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71470 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71474 */     // MIs[4] Rd
     /*  71474 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71479 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71484 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71486 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  71495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  71499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71503 */     GIR_RootConstrainSelectedInstOperands,
     /*  71504 */     // GIR_Coverage, 13311,
     /*  71504 */     GIR_EraseRootFromParent_Done,
     /*  71505 */   // Label 1173: @71505
     /*  71505 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(71614), // Rule ID 1606 //
     /*  71510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71555 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71559 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71563 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71567 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71571 */     // MIs[3] Rd
     /*  71571 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71576 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71580 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71586 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71588 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71593 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71595 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  71604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  71608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71612 */     GIR_RootConstrainSelectedInstOperands,
     /*  71613 */     // GIR_Coverage, 1606,
     /*  71613 */     GIR_EraseRootFromParent_Done,
     /*  71614 */   // Label 1174: @71614
     /*  71614 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(71723), // Rule ID 13307 //
     /*  71619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71652 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71656 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71660 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71664 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71668 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71672 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71676 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71680 */     // MIs[3] Rd
     /*  71680 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  71685 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71689 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71695 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71702 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71704 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  71721 */     GIR_RootConstrainSelectedInstOperands,
     /*  71722 */     // GIR_Coverage, 13307,
     /*  71722 */     GIR_EraseRootFromParent_Done,
     /*  71723 */   // Label 1175: @71723
     /*  71723 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(71832), // Rule ID 13306 //
     /*  71728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71773 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71777 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71790 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71794 */     // MIs[3] Rd
     /*  71794 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71799 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71803 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71809 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71811 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71813 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  71822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  71826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  71830 */     GIR_RootConstrainSelectedInstOperands,
     /*  71831 */     // GIR_Coverage, 13306,
     /*  71831 */     GIR_EraseRootFromParent_Done,
     /*  71832 */   // Label 1176: @71832
     /*  71832 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(71941), // Rule ID 13308 //
     /*  71837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71899 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  71903 */     // MIs[3] Rd
     /*  71903 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  71908 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71912 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71918 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71920 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71922 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  71922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  71939 */     GIR_RootConstrainSelectedInstOperands,
     /*  71940 */     // GIR_Coverage, 13308,
     /*  71940 */     GIR_EraseRootFromParent_Done,
     /*  71941 */   // Label 1177: @71941
     /*  71941 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(72008), // Rule ID 13479 //
     /*  71946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  71965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71970 */     // MIs[1] imm
     /*  71970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71978 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71982 */     // MIs[2] Operand 1
     /*  71982 */     // No operand predicates
     /*  71982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71986 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71990 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71992 */     // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  71995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  71999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72006 */     GIR_RootConstrainSelectedInstOperands,
     /*  72007 */     // GIR_Coverage, 13479,
     /*  72007 */     GIR_EraseRootFromParent_Done,
     /*  72008 */   // Label 1178: @72008
     /*  72008 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(72075), // Rule ID 13500 //
     /*  72013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72037 */     // MIs[1] imm
     /*  72037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72045 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72049 */     // MIs[2] Operand 1
     /*  72049 */     // No operand predicates
     /*  72049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72053 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72057 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72059 */     // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  72062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72073 */     GIR_RootConstrainSelectedInstOperands,
     /*  72074 */     // GIR_Coverage, 13500,
     /*  72074 */     GIR_EraseRootFromParent_Done,
     /*  72075 */   // Label 1179: @72075
     /*  72075 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(72142), // Rule ID 2231 //
     /*  72080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72087 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72108 */     // MIs[1] imm
     /*  72108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72116 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72120 */     // MIs[2] Operand 1
     /*  72120 */     // No operand predicates
     /*  72120 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72126 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  72129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72140 */     GIR_RootConstrainSelectedInstOperands,
     /*  72141 */     // GIR_Coverage, 2231,
     /*  72141 */     GIR_EraseRootFromParent_Done,
     /*  72142 */   // Label 1180: @72142
     /*  72142 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(72209), // Rule ID 2290 //
     /*  72147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72175 */     // MIs[1] imm
     /*  72175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72183 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  72187 */     // MIs[2] Operand 1
     /*  72187 */     // No operand predicates
     /*  72187 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72191 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72193 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  72196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72204 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72207 */     GIR_RootConstrainSelectedInstOperands,
     /*  72208 */     // GIR_Coverage, 2290,
     /*  72208 */     GIR_EraseRootFromParent_Done,
     /*  72209 */   // Label 1181: @72209
     /*  72209 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(72273), // Rule ID 13298 //
     /*  72214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72229 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72233 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72237 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72246 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72252 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72260 */     // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  72267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  72271 */     GIR_RootConstrainSelectedInstOperands,
     /*  72272 */     // GIR_Coverage, 13298,
     /*  72272 */     GIR_EraseRootFromParent_Done,
     /*  72273 */   // Label 1182: @72273
     /*  72273 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(72337), // Rule ID 1602 //
     /*  72278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72314 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72320 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72322 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72324 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  72331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  72335 */     GIR_RootConstrainSelectedInstOperands,
     /*  72336 */     // GIR_Coverage, 1602,
     /*  72336 */     GIR_EraseRootFromParent_Done,
     /*  72337 */   // Label 1183: @72337
     /*  72337 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(72364), // Rule ID 1604 //
     /*  72342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72357 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72357 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  72362 */     GIR_RootConstrainSelectedInstOperands,
     /*  72363 */     // GIR_Coverage, 1604,
     /*  72363 */     GIR_Done,
     /*  72364 */   // Label 1184: @72364
     /*  72364 */   GIM_Reject,
     /*  72365 */ // Label 1169: @72365
     /*  72365 */ GIM_Reject,
     /*  72366 */ // Label 1024: @72366
     /*  72366 */ GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(72397), // Rule ID 8403 //
     /*  72371 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  72377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  72380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72384 */   // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  72384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72389 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72391 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72393 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72395 */   GIR_RootConstrainSelectedInstOperands,
     /*  72396 */   // GIR_Coverage, 8403,
     /*  72396 */   GIR_EraseRootFromParent_Done,
     /*  72397 */ // Label 1185: @72397
     /*  72397 */ GIM_Reject,
     /*  72398 */ // Label 1025: @72398
     /*  72398 */ GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(72429), // Rule ID 8402 //
     /*  72403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  72409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  72412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72416 */   // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  72416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72421 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72423 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72425 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72427 */   GIR_RootConstrainSelectedInstOperands,
     /*  72428 */   // GIR_Coverage, 8402,
     /*  72428 */   GIR_EraseRootFromParent_Done,
     /*  72429 */ // Label 1186: @72429
     /*  72429 */ GIM_Reject,
     /*  72430 */ // Label 1026: @72430
     /*  72430 */ GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(72455), // Rule ID 7412 //
     /*  72435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  72441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  72444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72448 */   // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  72448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72453 */   GIR_RootConstrainSelectedInstOperands,
     /*  72454 */   // GIR_Coverage, 7412,
     /*  72454 */   GIR_Done,
     /*  72455 */ // Label 1187: @72455
     /*  72455 */ GIM_Reject,
     /*  72456 */ // Label 1027: @72456
     /*  72456 */ GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(72487), // Rule ID 8401 //
     /*  72461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  72467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  72470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72474 */   // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  72474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72479 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72481 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72483 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72485 */   GIR_RootConstrainSelectedInstOperands,
     /*  72486 */   // GIR_Coverage, 8401,
     /*  72486 */   GIR_EraseRootFromParent_Done,
     /*  72487 */ // Label 1188: @72487
     /*  72487 */ GIM_Reject,
     /*  72488 */ // Label 1028: @72488
     /*  72488 */ GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(72513), // Rule ID 7411 //
     /*  72493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  72499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  72502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72506 */   // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  72506 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72511 */   GIR_RootConstrainSelectedInstOperands,
     /*  72512 */   // GIR_Coverage, 7411,
     /*  72512 */   GIR_Done,
     /*  72513 */ // Label 1189: @72513
     /*  72513 */ GIM_Reject,
     /*  72514 */ // Label 1029: @72514
     /*  72514 */ GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(72545), // Rule ID 8400 //
     /*  72519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  72525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  72528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72532 */   // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  72532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72537 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72539 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72541 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72543 */   GIR_RootConstrainSelectedInstOperands,
     /*  72544 */   // GIR_Coverage, 8400,
     /*  72544 */   GIR_EraseRootFromParent_Done,
     /*  72545 */ // Label 1190: @72545
     /*  72545 */ GIM_Reject,
     /*  72546 */ // Label 1030: @72546
     /*  72546 */ GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(72571), // Rule ID 7410 //
     /*  72551 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72554 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  72557 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  72560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72564 */   // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  72564 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72569 */   GIR_RootConstrainSelectedInstOperands,
     /*  72570 */   // GIR_Coverage, 7410,
     /*  72570 */   GIR_Done,
     /*  72571 */ // Label 1191: @72571
     /*  72571 */ GIM_Reject,
     /*  72572 */ // Label 1031: @72572
     /*  72572 */ GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(72603), // Rule ID 8399 //
     /*  72577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  72583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  72586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  72590 */   // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  72590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  72593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  72595 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72597 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  72599 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  72601 */   GIR_RootConstrainSelectedInstOperands,
     /*  72602 */   // GIR_Coverage, 8399,
     /*  72602 */   GIR_EraseRootFromParent_Done,
     /*  72603 */ // Label 1192: @72603
     /*  72603 */ GIM_Reject,
     /*  72604 */ // Label 1032: @72604
     /*  72604 */ GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(72629), // Rule ID 7409 //
     /*  72609 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  72612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  72615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  72618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  72622 */   // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  72622 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  72627 */   GIR_RootConstrainSelectedInstOperands,
     /*  72628 */   // GIR_Coverage, 7409,
     /*  72628 */   GIR_Done,
     /*  72629 */ // Label 1193: @72629
     /*  72629 */ GIM_Reject,
     /*  72630 */ // Label 1033: @72630
     /*  72630 */ GIM_Reject,
     /*  72631 */ // Label 7: @72631
     /*  72631 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1212*/ GIMT_Encode4(79822),
     /*  72642 */ /*GILLT_s32*//*Label 1194*/ GIMT_Encode4(72730),
     /*  72646 */ /*GILLT_s64*//*Label 1195*/ GIMT_Encode4(73410), GIMT_Encode4(0),
     /*  72654 */ /*GILLT_v2s32*//*Label 1196*/ GIMT_Encode4(74253),
     /*  72658 */ /*GILLT_v2s64*//*Label 1197*/ GIMT_Encode4(74488),
     /*  72662 */ /*GILLT_v4s16*//*Label 1198*/ GIMT_Encode4(75177),
     /*  72666 */ /*GILLT_v4s32*//*Label 1199*/ GIMT_Encode4(75412),
     /*  72670 */ /*GILLT_v8s8*//*Label 1200*/ GIMT_Encode4(76101),
     /*  72674 */ /*GILLT_v8s16*//*Label 1201*/ GIMT_Encode4(76339),
     /*  72678 */ /*GILLT_v16s8*//*Label 1202*/ GIMT_Encode4(77028),
     /*  72682 */ /*GILLT_nxv1s1*//*Label 1203*/ GIMT_Encode4(77720),
     /*  72686 */ /*GILLT_nxv2s1*//*Label 1204*/ GIMT_Encode4(77770), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  72698 */ /*GILLT_nxv2s64*//*Label 1205*/ GIMT_Encode4(77820),
     /*  72702 */ /*GILLT_nxv4s1*//*Label 1206*/ GIMT_Encode4(78283), GIMT_Encode4(0),
     /*  72710 */ /*GILLT_nxv4s32*//*Label 1207*/ GIMT_Encode4(78333),
     /*  72714 */ /*GILLT_nxv8s1*//*Label 1208*/ GIMT_Encode4(78796),
     /*  72718 */ /*GILLT_nxv8s16*//*Label 1209*/ GIMT_Encode4(78846),
     /*  72722 */ /*GILLT_nxv16s1*//*Label 1210*/ GIMT_Encode4(79309),
     /*  72726 */ /*GILLT_nxv16s8*//*Label 1211*/ GIMT_Encode4(79359),
     /*  72730 */ // Label 1194: @72730
     /*  72730 */ GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(73409),
     /*  72735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  72738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  72741 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(72799), // Rule ID 13168 //
     /*  72746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72762 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72766 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72771 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72784 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72793 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72797 */     GIR_RootConstrainSelectedInstOperands,
     /*  72798 */     // GIR_Coverage, 13168,
     /*  72798 */     GIR_EraseRootFromParent_Done,
     /*  72799 */   // Label 1214: @72799
     /*  72799 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(72854), // Rule ID 13167 //
     /*  72804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72824 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  72828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72832 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72834 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72841 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  72848 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72852 */     GIR_RootConstrainSelectedInstOperands,
     /*  72853 */     // GIR_Coverage, 13167,
     /*  72853 */     GIR_EraseRootFromParent_Done,
     /*  72854 */   // Label 1215: @72854
     /*  72854 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(72912), // Rule ID 13165 //
     /*  72859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72884 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  72888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72897 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  72906 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72910 */     GIR_RootConstrainSelectedInstOperands,
     /*  72911 */     // GIR_Coverage, 13165,
     /*  72911 */     GIR_EraseRootFromParent_Done,
     /*  72912 */   // Label 1216: @72912
     /*  72912 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(72970), // Rule ID 166 //
     /*  72917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72942 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  72946 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  72948 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  72955 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  72955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  72958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72964 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  72968 */     GIR_RootConstrainSelectedInstOperands,
     /*  72969 */     // GIR_Coverage, 166,
     /*  72969 */     GIR_EraseRootFromParent_Done,
     /*  72970 */   // Label 1217: @72970
     /*  72970 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(73028), // Rule ID 13166 //
     /*  72975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  72979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  72991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  72995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73000 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73004 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73013 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  73016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73022 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73026 */     GIR_RootConstrainSelectedInstOperands,
     /*  73027 */     // GIR_Coverage, 13166,
     /*  73027 */     GIR_EraseRootFromParent_Done,
     /*  73028 */   // Label 1218: @73028
     /*  73028 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(73083), // Rule ID 13169 //
     /*  73033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73057 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73061 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73063 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73070 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  73073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73077 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73081 */     GIR_RootConstrainSelectedInstOperands,
     /*  73082 */     // GIR_Coverage, 13169,
     /*  73082 */     GIR_EraseRootFromParent_Done,
     /*  73083 */   // Label 1219: @73083
     /*  73083 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(73124), // Rule ID 144 //
     /*  73088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  73092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73104 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  73108 */     // MIs[1] Operand 1
     /*  73108 */     // No operand predicates
     /*  73108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73110 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  73110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /*  73113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73115 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73117 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  73122 */     GIR_RootConstrainSelectedInstOperands,
     /*  73123 */     // GIR_Coverage, 144,
     /*  73123 */     GIR_EraseRootFromParent_Done,
     /*  73124 */   // Label 1220: @73124
     /*  73124 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(73157), // Rule ID 13175 //
     /*  73129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73137 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73144 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  73147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73151 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73155 */     GIR_RootConstrainSelectedInstOperands,
     /*  73156 */     // GIR_Coverage, 13175,
     /*  73156 */     GIR_EraseRootFromParent_Done,
     /*  73157 */   // Label 1221: @73157
     /*  73157 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(73190), // Rule ID 170 //
     /*  73162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73170 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  73177 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  73177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  73180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73184 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73188 */     GIR_RootConstrainSelectedInstOperands,
     /*  73189 */     // GIR_Coverage, 170,
     /*  73189 */     GIR_EraseRootFromParent_Done,
     /*  73190 */   // Label 1222: @73190
     /*  73190 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(73243), // Rule ID 13161 //
     /*  73195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73220 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73228 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73230 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  73230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  73233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  73241 */     GIR_RootConstrainSelectedInstOperands,
     /*  73242 */     // GIR_Coverage, 13161,
     /*  73242 */     GIR_EraseRootFromParent_Done,
     /*  73243 */   // Label 1223: @73243
     /*  73243 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(73299), // Rule ID 164 //
     /*  73248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73278 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73284 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  73284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  73287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  73297 */     GIR_RootConstrainSelectedInstOperands,
     /*  73298 */     // GIR_Coverage, 164,
     /*  73298 */     GIR_EraseRootFromParent_Done,
     /*  73299 */   // Label 1224: @73299
     /*  73299 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(73352), // Rule ID 13162 //
     /*  73304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  73324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  73328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73333 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73339 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  73339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  73342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  73350 */     GIR_RootConstrainSelectedInstOperands,
     /*  73351 */     // GIR_Coverage, 13162,
     /*  73351 */     GIR_EraseRootFromParent_Done,
     /*  73352 */   // Label 1225: @73352
     /*  73352 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(73384), // Rule ID 3990 //
     /*  73357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73369 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
     /*  73369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  73372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73380 */     GIR_RootToRootCopy, /*OpIdx*/1, // Wm
     /*  73382 */     GIR_RootConstrainSelectedInstOperands,
     /*  73383 */     // GIR_Coverage, 3990,
     /*  73383 */     GIR_EraseRootFromParent_Done,
     /*  73384 */   // Label 1226: @73384
     /*  73384 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(73408), // Rule ID 168 //
     /*  73389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  73401 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  73401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
     /*  73406 */     GIR_RootConstrainSelectedInstOperands,
     /*  73407 */     // GIR_Coverage, 168,
     /*  73407 */     GIR_Done,
     /*  73408 */   // Label 1227: @73408
     /*  73408 */   GIM_Reject,
     /*  73409 */ // Label 1213: @73409
     /*  73409 */ GIM_Reject,
     /*  73410 */ // Label 1195: @73410
     /*  73410 */ GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(74252),
     /*  73415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  73418 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  73421 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(73479), // Rule ID 13173 //
     /*  73426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73451 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73464 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73473 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73477 */     GIR_RootConstrainSelectedInstOperands,
     /*  73478 */     // GIR_Coverage, 13173,
     /*  73478 */     GIR_EraseRootFromParent_Done,
     /*  73479 */   // Label 1229: @73479
     /*  73479 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(73534), // Rule ID 13172 //
     /*  73484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73492 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73496 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73500 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73504 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73514 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73521 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73528 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73532 */     GIR_RootConstrainSelectedInstOperands,
     /*  73533 */     // GIR_Coverage, 13172,
     /*  73533 */     GIR_EraseRootFromParent_Done,
     /*  73534 */   // Label 1230: @73534
     /*  73534 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(73592), // Rule ID 13170 //
     /*  73539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73564 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73570 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73577 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73586 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73590 */     GIR_RootConstrainSelectedInstOperands,
     /*  73591 */     // GIR_Coverage, 13170,
     /*  73591 */     GIR_EraseRootFromParent_Done,
     /*  73592 */   // Label 1231: @73592
     /*  73592 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(73650), // Rule ID 167 //
     /*  73597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73622 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  73626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73628 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73635 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73644 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73648 */     GIR_RootConstrainSelectedInstOperands,
     /*  73649 */     // GIR_Coverage, 167,
     /*  73649 */     GIR_EraseRootFromParent_Done,
     /*  73650 */   // Label 1232: @73650
     /*  73650 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(73708), // Rule ID 13171 //
     /*  73655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73680 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73686 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73693 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73702 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73706 */     GIR_RootConstrainSelectedInstOperands,
     /*  73707 */     // GIR_Coverage, 13171,
     /*  73707 */     GIR_EraseRootFromParent_Done,
     /*  73708 */   // Label 1233: @73708
     /*  73708 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(73763), // Rule ID 13174 //
     /*  73713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73733 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73737 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  73741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73750 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  73753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73757 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73761 */     GIR_RootConstrainSelectedInstOperands,
     /*  73762 */     // GIR_Coverage, 13174,
     /*  73762 */     GIR_EraseRootFromParent_Done,
     /*  73763 */   // Label 1234: @73763
     /*  73763 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(73863), // Rule ID 1613 //
     /*  73768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  73783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73787 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  73791 */     // MIs[1] Operand 1
     /*  73791 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  73796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  73808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  73812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73817 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  73822 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  73826 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73832 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  73834 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73838 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73844 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73846 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73848 */     // (xor:{ *:[v1i64] } (setcc:{ *:[v1i64] } (and:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm), immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v1i64] })  =>  (CMTSTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  73848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv1i64),
     /*  73851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  73857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  73861 */     GIR_RootConstrainSelectedInstOperands,
     /*  73862 */     // GIR_Coverage, 1613,
     /*  73862 */     GIR_EraseRootFromParent_Done,
     /*  73863 */   // Label 1235: @73863
     /*  73863 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(73904), // Rule ID 145 //
     /*  73868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  73872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73884 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  73888 */     // MIs[1] Operand 1
     /*  73888 */     // No operand predicates
     /*  73888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  73890 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  73890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
     /*  73893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73897 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  73902 */     GIR_RootConstrainSelectedInstOperands,
     /*  73903 */     // GIR_Coverage, 145,
     /*  73903 */     GIR_EraseRootFromParent_Done,
     /*  73904 */   // Label 1236: @73904
     /*  73904 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(73937), // Rule ID 13176 //
     /*  73909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73917 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73924 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  73927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73931 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73935 */     GIR_RootConstrainSelectedInstOperands,
     /*  73936 */     // GIR_Coverage, 13176,
     /*  73936 */     GIR_EraseRootFromParent_Done,
     /*  73937 */   // Label 1237: @73937
     /*  73937 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(73970), // Rule ID 171 //
     /*  73942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73950 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  73957 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  73957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  73960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  73964 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  73968 */     GIR_RootConstrainSelectedInstOperands,
     /*  73969 */     // GIR_Coverage, 171,
     /*  73969 */     GIR_EraseRootFromParent_Done,
     /*  73970 */   // Label 1238: @73970
     /*  73970 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(74023), // Rule ID 13163 //
     /*  73975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  73979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  73991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  73995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74000 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  74004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74010 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  74010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  74013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  74019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  74021 */     GIR_RootConstrainSelectedInstOperands,
     /*  74022 */     // GIR_Coverage, 13163,
     /*  74022 */     GIR_EraseRootFromParent_Done,
     /*  74023 */   // Label 1239: @74023
     /*  74023 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(74079), // Rule ID 165 //
     /*  74028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  74044 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  74048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74058 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  74062 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74064 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  74064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  74067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  74073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  74077 */     GIR_RootConstrainSelectedInstOperands,
     /*  74078 */     // GIR_Coverage, 165,
     /*  74078 */     GIR_EraseRootFromParent_Done,
     /*  74079 */   // Label 1240: @74079
     /*  74079 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(74132), // Rule ID 13164 //
     /*  74084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  74104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  74108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74113 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  74117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74119 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  74119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  74122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74124 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  74128 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  74130 */     GIR_RootConstrainSelectedInstOperands,
     /*  74131 */     // GIR_Coverage, 13164,
     /*  74131 */     GIR_EraseRootFromParent_Done,
     /*  74132 */   // Label 1241: @74132
     /*  74132 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(74164), // Rule ID 3991 //
     /*  74137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74145 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  74149 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
     /*  74149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  74152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74154 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74160 */     GIR_RootToRootCopy, /*OpIdx*/1, // Xm
     /*  74162 */     GIR_RootConstrainSelectedInstOperands,
     /*  74163 */     // GIR_Coverage, 3991,
     /*  74163 */     GIR_EraseRootFromParent_Done,
     /*  74164 */   // Label 1242: @74164
     /*  74164 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(74200), // Rule ID 4937 //
     /*  74169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74181 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74187 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  74189 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74191 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /*  74191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  74194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74196 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74198 */     GIR_RootConstrainSelectedInstOperands,
     /*  74199 */     // GIR_Coverage, 4937,
     /*  74199 */     GIR_EraseRootFromParent_Done,
     /*  74200 */   // Label 1243: @74200
     /*  74200 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(74224), // Rule ID 169 //
     /*  74205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  74217 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  74217 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
     /*  74222 */     GIR_RootConstrainSelectedInstOperands,
     /*  74223 */     // GIR_Coverage, 169,
     /*  74223 */     GIR_Done,
     /*  74224 */   // Label 1244: @74224
     /*  74224 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(74251), // Rule ID 5033 //
     /*  74229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74244 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  74244 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  74249 */     GIR_RootConstrainSelectedInstOperands,
     /*  74250 */     // GIR_Coverage, 5033,
     /*  74250 */     GIR_Done,
     /*  74251 */   // Label 1245: @74251
     /*  74251 */   GIM_Reject,
     /*  74252 */ // Label 1228: @74252
     /*  74252 */ GIM_Reject,
     /*  74253 */ // Label 1196: @74253
     /*  74253 */ GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(74487),
     /*  74258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  74261 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  74264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74268 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(74364), // Rule ID 1160 //
     /*  74273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  74288 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  74292 */     // MIs[1] Operand 1
     /*  74292 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  74309 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  74313 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  74327 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74333 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  74335 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74339 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74345 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74347 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74349 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  74349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  74352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  74358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  74362 */     GIR_RootConstrainSelectedInstOperands,
     /*  74363 */     // GIR_Coverage, 1160,
     /*  74363 */     GIR_EraseRootFromParent_Done,
     /*  74364 */   // Label 1247: @74364
     /*  74364 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(74431), // Rule ID 4981 //
     /*  74369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  74381 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  74385 */     // MIs[1] Operand 1
     /*  74385 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  74394 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74400 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  74402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  74406 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74412 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74414 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74416 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, v2i32:{ *:[v2i32] }:$Rn)
     /*  74416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  74419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74429 */     GIR_RootConstrainSelectedInstOperands,
     /*  74430 */     // GIR_Coverage, 4981,
     /*  74430 */     GIR_EraseRootFromParent_Done,
     /*  74431 */   // Label 1248: @74431
     /*  74431 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(74463), // Rule ID 4935 //
     /*  74436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74444 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74450 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  74452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  74454 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  74454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  74457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74461 */     GIR_RootConstrainSelectedInstOperands,
     /*  74462 */     // GIR_Coverage, 4935,
     /*  74462 */     GIR_EraseRootFromParent_Done,
     /*  74463 */   // Label 1249: @74463
     /*  74463 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(74486), // Rule ID 5032 //
     /*  74468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  74479 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  74479 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  74484 */     GIR_RootConstrainSelectedInstOperands,
     /*  74485 */     // GIR_Coverage, 5032,
     /*  74485 */     GIR_Done,
     /*  74486 */   // Label 1250: @74486
     /*  74486 */   GIM_Reject,
     /*  74487 */ // Label 1246: @74487
     /*  74487 */ GIM_Reject,
     /*  74488 */ // Label 1197: @74488
     /*  74488 */ GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(75176),
     /*  74493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74503 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(74599), // Rule ID 1162 //
     /*  74508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74523 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  74527 */     // MIs[1] Operand 1
     /*  74527 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74532 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74536 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74540 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74544 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  74562 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74568 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  74570 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74574 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74580 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  74582 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  74584 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  74584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  74587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  74593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  74597 */     GIR_RootConstrainSelectedInstOperands,
     /*  74598 */     // GIR_Coverage, 1162,
     /*  74598 */     GIR_EraseRootFromParent_Done,
     /*  74599 */   // Label 1252: @74599
     /*  74599 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(74666), // Rule ID 4983 //
     /*  74604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  74612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74616 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  74620 */     // MIs[1] Operand 1
     /*  74620 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  74625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  74629 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74635 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  74637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  74641 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74647 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74649 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74651 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, v2i64:{ *:[v2i64] }:$Rn)
     /*  74651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  74654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  74664 */     GIR_RootConstrainSelectedInstOperands,
     /*  74665 */     // GIR_Coverage, 4983,
     /*  74665 */     GIR_EraseRootFromParent_Done,
     /*  74666 */   // Label 1253: @74666
     /*  74666 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(74751), // Rule ID 13698 //
     /*  74671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74686 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74702 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74715 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74721 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74732 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74734 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  74741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74749 */     GIR_RootConstrainSelectedInstOperands,
     /*  74750 */     // GIR_Coverage, 13698,
     /*  74750 */     GIR_EraseRootFromParent_Done,
     /*  74751 */   // Label 1254: @74751
     /*  74751 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(74836), // Rule ID 13697 //
     /*  74756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74805 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74811 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74817 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74819 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  74826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  74830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74834 */     GIR_RootConstrainSelectedInstOperands,
     /*  74835 */     // GIR_Coverage, 13697,
     /*  74835 */     GIR_EraseRootFromParent_Done,
     /*  74836 */   // Label 1255: @74836
     /*  74836 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(74921), // Rule ID 13696 //
     /*  74841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74885 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74889 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74895 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74902 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74904 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74909 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  74911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  74915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  74919 */     GIR_RootConstrainSelectedInstOperands,
     /*  74920 */     // GIR_Coverage, 13696,
     /*  74920 */     GIR_EraseRootFromParent_Done,
     /*  74921 */   // Label 1256: @74921
     /*  74921 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(75006), // Rule ID 3818 //
     /*  74926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  74929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  74937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74962 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  74966 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  74970 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74975 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74979 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74985 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74987 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  74989 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  74989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  74992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  74994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  74996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75004 */     GIR_RootConstrainSelectedInstOperands,
     /*  75005 */     // GIR_Coverage, 3818,
     /*  75005 */     GIR_EraseRootFromParent_Done,
     /*  75006 */   // Label 1257: @75006
     /*  75006 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(75038), // Rule ID 4938 //
     /*  75011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75019 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75025 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  75027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75029 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  75029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  75032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  75036 */     GIR_RootConstrainSelectedInstOperands,
     /*  75037 */     // GIR_Coverage, 4938,
     /*  75037 */     GIR_EraseRootFromParent_Done,
     /*  75038 */   // Label 1258: @75038
     /*  75038 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(75095), // Rule ID 3814 //
     /*  75043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75076 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75078 */     // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  75078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  75081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  75087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  75093 */     GIR_RootConstrainSelectedInstOperands,
     /*  75094 */     // GIR_Coverage, 3814,
     /*  75094 */     GIR_EraseRootFromParent_Done,
     /*  75095 */   // Label 1259: @75095
     /*  75095 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(75152), // Rule ID 13686 //
     /*  75100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  75119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  75123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75135 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  75135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  75138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  75144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  75150 */     GIR_RootConstrainSelectedInstOperands,
     /*  75151 */     // GIR_Coverage, 13686,
     /*  75151 */     GIR_EraseRootFromParent_Done,
     /*  75152 */   // Label 1260: @75152
     /*  75152 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(75175), // Rule ID 5036 //
     /*  75157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75168 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  75168 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  75173 */     GIR_RootConstrainSelectedInstOperands,
     /*  75174 */     // GIR_Coverage, 5036,
     /*  75174 */     GIR_Done,
     /*  75175 */   // Label 1261: @75175
     /*  75175 */   GIM_Reject,
     /*  75176 */ // Label 1251: @75176
     /*  75176 */ GIM_Reject,
     /*  75177 */ // Label 1198: @75177
     /*  75177 */ GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(75411),
     /*  75182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  75185 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  75188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75192 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(75288), // Rule ID 1158 //
     /*  75197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  75212 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  75216 */     // MIs[1] Operand 1
     /*  75216 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  75233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  75237 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75242 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75247 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  75251 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75257 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  75259 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75263 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75269 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75271 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75273 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  75273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  75276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  75282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  75286 */     GIR_RootConstrainSelectedInstOperands,
     /*  75287 */     // GIR_Coverage, 1158,
     /*  75287 */     GIR_EraseRootFromParent_Done,
     /*  75288 */   // Label 1263: @75288
     /*  75288 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(75355), // Rule ID 4979 //
     /*  75293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  75305 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  75309 */     // MIs[1] Operand 1
     /*  75309 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  75318 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75324 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  75326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  75330 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75336 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75338 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75340 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, v4i16:{ *:[v4i16] }:$Rn)
     /*  75340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  75343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75353 */     GIR_RootConstrainSelectedInstOperands,
     /*  75354 */     // GIR_Coverage, 4979,
     /*  75354 */     GIR_EraseRootFromParent_Done,
     /*  75355 */   // Label 1264: @75355
     /*  75355 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(75387), // Rule ID 4933 //
     /*  75360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75368 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75374 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  75376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75378 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  75378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  75381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75383 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  75385 */     GIR_RootConstrainSelectedInstOperands,
     /*  75386 */     // GIR_Coverage, 4933,
     /*  75386 */     GIR_EraseRootFromParent_Done,
     /*  75387 */   // Label 1265: @75387
     /*  75387 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(75410), // Rule ID 5031 //
     /*  75392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  75403 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  75403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  75408 */     GIR_RootConstrainSelectedInstOperands,
     /*  75409 */     // GIR_Coverage, 5031,
     /*  75409 */     GIR_Done,
     /*  75410 */   // Label 1266: @75410
     /*  75410 */   GIM_Reject,
     /*  75411 */ // Label 1262: @75411
     /*  75411 */ GIM_Reject,
     /*  75412 */ // Label 1199: @75412
     /*  75412 */ GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(76100),
     /*  75417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75427 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(75523), // Rule ID 1161 //
     /*  75432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  75435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75447 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75451 */     // MIs[1] Operand 1
     /*  75451 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75468 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75472 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  75486 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75492 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  75494 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75498 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75504 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75506 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  75508 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  75508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  75511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  75517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  75521 */     GIR_RootConstrainSelectedInstOperands,
     /*  75522 */     // GIR_Coverage, 1161,
     /*  75522 */     GIR_EraseRootFromParent_Done,
     /*  75523 */   // Label 1268: @75523
     /*  75523 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(75590), // Rule ID 4982 //
     /*  75528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  75536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75540 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75544 */     // MIs[1] Operand 1
     /*  75544 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  75549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  75553 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75559 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  75561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  75565 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75571 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75575 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, v4i32:{ *:[v4i32] }:$Rn)
     /*  75575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  75578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  75588 */     GIR_RootConstrainSelectedInstOperands,
     /*  75589 */     // GIR_Coverage, 4982,
     /*  75589 */     GIR_EraseRootFromParent_Done,
     /*  75590 */   // Label 1269: @75590
     /*  75590 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(75675), // Rule ID 13695 //
     /*  75595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75626 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75630 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75639 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75645 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75656 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75658 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  75665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75673 */     GIR_RootConstrainSelectedInstOperands,
     /*  75674 */     // GIR_Coverage, 13695,
     /*  75674 */     GIR_EraseRootFromParent_Done,
     /*  75675 */   // Label 1270: @75675
     /*  75675 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(75760), // Rule ID 13694 //
     /*  75680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75729 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75741 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75743 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  75750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75758 */     GIR_RootConstrainSelectedInstOperands,
     /*  75759 */     // GIR_Coverage, 13694,
     /*  75759 */     GIR_EraseRootFromParent_Done,
     /*  75760 */   // Label 1271: @75760
     /*  75760 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(75845), // Rule ID 13693 //
     /*  75765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  75792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75796 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75800 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75804 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75813 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75819 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75826 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75828 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  75835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  75839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75843 */     GIR_RootConstrainSelectedInstOperands,
     /*  75844 */     // GIR_Coverage, 13693,
     /*  75844 */     GIR_EraseRootFromParent_Done,
     /*  75845 */   // Label 1272: @75845
     /*  75845 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(75930), // Rule ID 3817 //
     /*  75850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75886 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75890 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75894 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75899 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75903 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75909 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75911 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  75913 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  75913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  75916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  75918 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  75920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  75924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  75928 */     GIR_RootConstrainSelectedInstOperands,
     /*  75929 */     // GIR_Coverage, 3817,
     /*  75929 */     GIR_EraseRootFromParent_Done,
     /*  75930 */   // Label 1273: @75930
     /*  75930 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(75962), // Rule ID 4936 //
     /*  75935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  75943 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75949 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  75951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75953 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  75953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  75956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  75958 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  75960 */     GIR_RootConstrainSelectedInstOperands,
     /*  75961 */     // GIR_Coverage, 4936,
     /*  75961 */     GIR_EraseRootFromParent_Done,
     /*  75962 */   // Label 1274: @75962
     /*  75962 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(76019), // Rule ID 3813 //
     /*  75967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  75970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  75982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75991 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  75996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76002 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  76002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  76005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  76011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  76017 */     GIR_RootConstrainSelectedInstOperands,
     /*  76018 */     // GIR_Coverage, 3813,
     /*  76018 */     GIR_EraseRootFromParent_Done,
     /*  76019 */   // Label 1275: @76019
     /*  76019 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(76076), // Rule ID 13685 //
     /*  76024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  76043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  76047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76059 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  76059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  76062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  76068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  76074 */     GIR_RootConstrainSelectedInstOperands,
     /*  76075 */     // GIR_Coverage, 13685,
     /*  76075 */     GIR_EraseRootFromParent_Done,
     /*  76076 */   // Label 1276: @76076
     /*  76076 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(76099), // Rule ID 5035 //
     /*  76081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76092 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  76092 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  76097 */     GIR_RootConstrainSelectedInstOperands,
     /*  76098 */     // GIR_Coverage, 5035,
     /*  76098 */     GIR_Done,
     /*  76099 */   // Label 1277: @76099
     /*  76099 */   GIM_Reject,
     /*  76100 */ // Label 1267: @76100
     /*  76100 */ GIM_Reject,
     /*  76101 */ // Label 1200: @76101
     /*  76101 */ GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(76338),
     /*  76106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  76109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76116 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(76212), // Rule ID 1156 //
     /*  76121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76136 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76140 */     // MIs[1] Operand 1
     /*  76140 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  76157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76166 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  76175 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76181 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  76183 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76187 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76193 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76195 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76197 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  76197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  76200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  76206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  76210 */     GIR_RootConstrainSelectedInstOperands,
     /*  76211 */     // GIR_Coverage, 1156,
     /*  76211 */     GIR_EraseRootFromParent_Done,
     /*  76212 */   // Label 1279: @76212
     /*  76212 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(76279), // Rule ID 4977 //
     /*  76217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76229 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76233 */     // MIs[1] Operand 1
     /*  76233 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  76242 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76248 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  76250 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  76254 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76260 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76262 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76264 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rn)
     /*  76264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  76267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76277 */     GIR_RootConstrainSelectedInstOperands,
     /*  76278 */     // GIR_Coverage, 4977,
     /*  76278 */     GIR_EraseRootFromParent_Done,
     /*  76279 */   // Label 1280: @76279
     /*  76279 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(76314), // Rule ID 972 //
     /*  76284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76295 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76301 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  76303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76305 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  76305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  76308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  76312 */     GIR_RootConstrainSelectedInstOperands,
     /*  76313 */     // GIR_Coverage, 972,
     /*  76313 */     GIR_EraseRootFromParent_Done,
     /*  76314 */   // Label 1281: @76314
     /*  76314 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(76337), // Rule ID 1599 //
     /*  76319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  76330 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  76330 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  76335 */     GIR_RootConstrainSelectedInstOperands,
     /*  76336 */     // GIR_Coverage, 1599,
     /*  76336 */     GIR_Done,
     /*  76337 */   // Label 1282: @76337
     /*  76337 */   GIM_Reject,
     /*  76338 */ // Label 1278: @76338
     /*  76338 */ GIM_Reject,
     /*  76339 */ // Label 1201: @76339
     /*  76339 */ GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(77027),
     /*  76344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76347 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76354 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(76450), // Rule ID 1159 //
     /*  76359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76374 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76378 */     // MIs[1] Operand 1
     /*  76378 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76395 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76399 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76404 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  76413 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76419 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  76421 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76425 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76431 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76433 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76435 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  76435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  76438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  76444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  76448 */     GIR_RootConstrainSelectedInstOperands,
     /*  76449 */     // GIR_Coverage, 1159,
     /*  76449 */     GIR_EraseRootFromParent_Done,
     /*  76450 */   // Label 1284: @76450
     /*  76450 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(76517), // Rule ID 4980 //
     /*  76455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  76463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76467 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76471 */     // MIs[1] Operand 1
     /*  76471 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  76476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  76480 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76486 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  76488 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  76492 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76498 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76500 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76502 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, v8i16:{ *:[v8i16] }:$Rn)
     /*  76502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  76505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  76515 */     GIR_RootConstrainSelectedInstOperands,
     /*  76516 */     // GIR_Coverage, 4980,
     /*  76516 */     GIR_EraseRootFromParent_Done,
     /*  76517 */   // Label 1285: @76517
     /*  76517 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(76602), // Rule ID 13692 //
     /*  76522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76553 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76557 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76562 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76566 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76572 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76585 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76600 */     GIR_RootConstrainSelectedInstOperands,
     /*  76601 */     // GIR_Coverage, 13692,
     /*  76601 */     GIR_EraseRootFromParent_Done,
     /*  76602 */   // Label 1286: @76602
     /*  76602 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(76687), // Rule ID 13691 //
     /*  76607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76631 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76635 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76639 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76643 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76652 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76656 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76662 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76668 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76670 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  76677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  76681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76685 */     GIR_RootConstrainSelectedInstOperands,
     /*  76686 */     // GIR_Coverage, 13691,
     /*  76686 */     GIR_EraseRootFromParent_Done,
     /*  76687 */   // Label 1287: @76687
     /*  76687 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(76772), // Rule ID 13690 //
     /*  76692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76695 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76731 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76736 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76740 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76746 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76753 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76755 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76770 */     GIR_RootConstrainSelectedInstOperands,
     /*  76771 */     // GIR_Coverage, 13690,
     /*  76771 */     GIR_EraseRootFromParent_Done,
     /*  76772 */   // Label 1288: @76772
     /*  76772 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(76857), // Rule ID 3816 //
     /*  76777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76821 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76826 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76830 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76836 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  76840 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  76843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  76847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  76851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  76855 */     GIR_RootConstrainSelectedInstOperands,
     /*  76856 */     // GIR_Coverage, 3816,
     /*  76856 */     GIR_EraseRootFromParent_Done,
     /*  76857 */   // Label 1289: @76857
     /*  76857 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(76889), // Rule ID 4934 //
     /*  76862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76870 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76876 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  76878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76880 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  76880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  76883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  76885 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  76887 */     GIR_RootConstrainSelectedInstOperands,
     /*  76888 */     // GIR_Coverage, 4934,
     /*  76888 */     GIR_EraseRootFromParent_Done,
     /*  76889 */   // Label 1290: @76889
     /*  76889 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(76946), // Rule ID 3812 //
     /*  76894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76929 */     // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  76932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  76938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  76944 */     GIR_RootConstrainSelectedInstOperands,
     /*  76945 */     // GIR_Coverage, 3812,
     /*  76945 */     GIR_EraseRootFromParent_Done,
     /*  76946 */   // Label 1291: @76946
     /*  76946 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(77003), // Rule ID 13684 //
     /*  76951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  76954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  76970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  76974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76979 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  76984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76986 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  76986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  76989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  76995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  76999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  77001 */     GIR_RootConstrainSelectedInstOperands,
     /*  77002 */     // GIR_Coverage, 13684,
     /*  77002 */     GIR_EraseRootFromParent_Done,
     /*  77003 */   // Label 1292: @77003
     /*  77003 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(77026), // Rule ID 5034 //
     /*  77008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77019 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  77019 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  77024 */     GIR_RootConstrainSelectedInstOperands,
     /*  77025 */     // GIR_Coverage, 5034,
     /*  77025 */     GIR_Done,
     /*  77026 */   // Label 1293: @77026
     /*  77026 */   GIM_Reject,
     /*  77027 */ // Label 1283: @77027
     /*  77027 */ GIM_Reject,
     /*  77028 */ // Label 1202: @77028
     /*  77028 */ GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(77719),
     /*  77033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77043 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(77139), // Rule ID 1157 //
     /*  77048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  77059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77063 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77067 */     // MIs[1] Operand 1
     /*  77067 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  77072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  77102 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77108 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  77110 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77114 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77120 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77122 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77124 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  77124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  77127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  77129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  77133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  77137 */     GIR_RootConstrainSelectedInstOperands,
     /*  77138 */     // GIR_Coverage, 1157,
     /*  77138 */     GIR_EraseRootFromParent_Done,
     /*  77139 */   // Label 1295: @77139
     /*  77139 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(77206), // Rule ID 4978 //
     /*  77144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  77152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77156 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77160 */     // MIs[1] Operand 1
     /*  77160 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  77165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  77169 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77175 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  77177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  77181 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77187 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77189 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77191 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rn)
     /*  77191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  77194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  77196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  77204 */     GIR_RootConstrainSelectedInstOperands,
     /*  77205 */     // GIR_Coverage, 4978,
     /*  77205 */     GIR_EraseRootFromParent_Done,
     /*  77206 */   // Label 1296: @77206
     /*  77206 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(77291), // Rule ID 13689 //
     /*  77211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77242 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77255 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77261 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77272 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77274 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  77281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77289 */     GIR_RootConstrainSelectedInstOperands,
     /*  77290 */     // GIR_Coverage, 13689,
     /*  77290 */     GIR_EraseRootFromParent_Done,
     /*  77291 */   // Label 1297: @77291
     /*  77291 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(77376), // Rule ID 13688 //
     /*  77296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77332 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77336 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77341 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77345 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77351 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77357 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77359 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  77366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  77370 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77374 */     GIR_RootConstrainSelectedInstOperands,
     /*  77375 */     // GIR_Coverage, 13688,
     /*  77375 */     GIR_EraseRootFromParent_Done,
     /*  77376 */   // Label 1298: @77376
     /*  77376 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(77461), // Rule ID 13687 //
     /*  77381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77416 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77429 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77435 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77437 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77444 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  77451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77459 */     GIR_RootConstrainSelectedInstOperands,
     /*  77460 */     // GIR_Coverage, 13687,
     /*  77460 */     GIR_EraseRootFromParent_Done,
     /*  77461 */   // Label 1299: @77461
     /*  77461 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(77546), // Rule ID 3815 //
     /*  77466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77519 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77525 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77527 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77529 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  77532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  77536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  77540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  77544 */     GIR_RootConstrainSelectedInstOperands,
     /*  77545 */     // GIR_Coverage, 3815,
     /*  77545 */     GIR_EraseRootFromParent_Done,
     /*  77546 */   // Label 1300: @77546
     /*  77546 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(77581), // Rule ID 973 //
     /*  77551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77562 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77568 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  77570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77572 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  77572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  77575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  77577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  77579 */     GIR_RootConstrainSelectedInstOperands,
     /*  77580 */     // GIR_Coverage, 973,
     /*  77580 */     GIR_EraseRootFromParent_Done,
     /*  77581 */   // Label 1301: @77581
     /*  77581 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(77638), // Rule ID 3811 //
     /*  77586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77610 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77619 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77621 */     // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  77624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  77630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  77636 */     GIR_RootConstrainSelectedInstOperands,
     /*  77637 */     // GIR_Coverage, 3811,
     /*  77637 */     GIR_EraseRootFromParent_Done,
     /*  77638 */   // Label 1302: @77638
     /*  77638 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(77695), // Rule ID 13683 //
     /*  77643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  77646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  77662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  77678 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  77678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  77681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  77683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  77687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  77691 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  77693 */     GIR_RootConstrainSelectedInstOperands,
     /*  77694 */     // GIR_Coverage, 13683,
     /*  77694 */     GIR_EraseRootFromParent_Done,
     /*  77695 */   // Label 1303: @77695
     /*  77695 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(77718), // Rule ID 1600 //
     /*  77700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  77703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  77711 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  77711 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  77716 */     GIR_RootConstrainSelectedInstOperands,
     /*  77717 */     // GIR_Coverage, 1600,
     /*  77717 */     GIR_Done,
     /*  77718 */   // Label 1304: @77718
     /*  77718 */   GIM_Reject,
     /*  77719 */ // Label 1294: @77719
     /*  77719 */ GIM_Reject,
     /*  77720 */ // Label 1203: @77720
     /*  77720 */ GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(77769), // Rule ID 8393 //
     /*  77725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  77731 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  77734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77738 */   // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  77738 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  77741 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  77745 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77750 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  77753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  77758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  77760 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77763 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77765 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  77767 */   GIR_RootConstrainSelectedInstOperands,
     /*  77768 */   // GIR_Coverage, 8393,
     /*  77768 */   GIR_EraseRootFromParent_Done,
     /*  77769 */ // Label 1305: @77769
     /*  77769 */ GIM_Reject,
     /*  77770 */ // Label 1204: @77770
     /*  77770 */ GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(77819), // Rule ID 8392 //
     /*  77775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  77781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  77784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77788 */   // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  77788 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  77791 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  77795 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77800 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  77803 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  77805 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  77808 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  77810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77813 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77815 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  77817 */   GIR_RootConstrainSelectedInstOperands,
     /*  77818 */   // GIR_Coverage, 8392,
     /*  77818 */   GIR_EraseRootFromParent_Done,
     /*  77819 */ // Label 1306: @77819
     /*  77819 */ GIM_Reject,
     /*  77820 */ // Label 1205: @77820
     /*  77820 */ GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(78282),
     /*  77825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  77835 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(77906), // Rule ID 15541 //
     /*  77840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77871 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77875 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77879 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77885 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77887 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77889 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  77896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  77900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77904 */     GIR_RootConstrainSelectedInstOperands,
     /*  77905 */     // GIR_Coverage, 15541,
     /*  77905 */     GIR_EraseRootFromParent_Done,
     /*  77906 */   // Label 1308: @77906
     /*  77906 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(77977), // Rule ID 15540 //
     /*  77911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  77934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77950 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77956 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77958 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  77960 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  77963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  77967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  77971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77975 */     GIR_RootConstrainSelectedInstOperands,
     /*  77976 */     // GIR_Coverage, 15540,
     /*  77976 */     GIR_EraseRootFromParent_Done,
     /*  77977 */   // Label 1309: @77977
     /*  77977 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(78048), // Rule ID 15539 //
     /*  77982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  77989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78001 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78005 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78009 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78013 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78021 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78027 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78029 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78031 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78046 */     GIR_RootConstrainSelectedInstOperands,
     /*  78047 */     // GIR_Coverage, 15539,
     /*  78047 */     GIR_EraseRootFromParent_Done,
     /*  78048 */   // Label 1310: @78048
     /*  78048 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(78119), // Rule ID 11803 //
     /*  78053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78080 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78084 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78092 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78098 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78100 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78102 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78107 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78117 */     GIR_RootConstrainSelectedInstOperands,
     /*  78118 */     // GIR_Coverage, 11803,
     /*  78118 */     GIR_EraseRootFromParent_Done,
     /*  78119 */   // Label 1311: @78119
     /*  78119 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(78180), // Rule ID 11827 //
     /*  78124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  78135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78143 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  78147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78151 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78157 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  78159 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78161 */     // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  78164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  78174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78178 */     GIR_RootConstrainSelectedInstOperands,
     /*  78179 */     // GIR_Coverage, 11827,
     /*  78179 */     GIR_EraseRootFromParent_Done,
     /*  78180 */   // Label 1312: @78180
     /*  78180 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(78223), // Rule ID 13650 //
     /*  78185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78200 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78206 */     // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  78221 */     GIR_RootConstrainSelectedInstOperands,
     /*  78222 */     // GIR_Coverage, 13650,
     /*  78222 */     GIR_EraseRootFromParent_Done,
     /*  78223 */   // Label 1313: @78223
     /*  78223 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(78266), // Rule ID 3152 //
     /*  78228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  78243 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  78247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78249 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  78249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78264 */     GIR_RootConstrainSelectedInstOperands,
     /*  78265 */     // GIR_Coverage, 3152,
     /*  78265 */     GIR_EraseRootFromParent_Done,
     /*  78266 */   // Label 1314: @78266
     /*  78266 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(78281), // Rule ID 7416 //
     /*  78271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78274 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  78274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  78279 */     GIR_RootConstrainSelectedInstOperands,
     /*  78280 */     // GIR_Coverage, 7416,
     /*  78280 */     GIR_Done,
     /*  78281 */   // Label 1315: @78281
     /*  78281 */   GIM_Reject,
     /*  78282 */ // Label 1307: @78282
     /*  78282 */ GIM_Reject,
     /*  78283 */ // Label 1206: @78283
     /*  78283 */ GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(78332), // Rule ID 8391 //
     /*  78288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  78294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  78297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  78301 */   // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  78301 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  78304 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  78308 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78313 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  78316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  78321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  78323 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78326 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78328 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  78330 */   GIR_RootConstrainSelectedInstOperands,
     /*  78331 */   // GIR_Coverage, 8391,
     /*  78331 */   GIR_EraseRootFromParent_Done,
     /*  78332 */ // Label 1316: @78332
     /*  78332 */ GIM_Reject,
     /*  78333 */ // Label 1207: @78333
     /*  78333 */ GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(78795),
     /*  78338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78341 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  78348 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(78419), // Rule ID 15538 //
     /*  78353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78384 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78392 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78398 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78402 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78417 */     GIR_RootConstrainSelectedInstOperands,
     /*  78418 */     // GIR_Coverage, 15538,
     /*  78418 */     GIR_EraseRootFromParent_Done,
     /*  78419 */   // Label 1318: @78419
     /*  78419 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(78490), // Rule ID 15537 //
     /*  78424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78451 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78455 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78459 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78463 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78469 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78471 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78473 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78488 */     GIR_RootConstrainSelectedInstOperands,
     /*  78489 */     // GIR_Coverage, 15537,
     /*  78489 */     GIR_EraseRootFromParent_Done,
     /*  78490 */   // Label 1319: @78490
     /*  78490 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(78561), // Rule ID 15536 //
     /*  78495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78534 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78540 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78544 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78549 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78559 */     GIR_RootConstrainSelectedInstOperands,
     /*  78560 */     // GIR_Coverage, 15536,
     /*  78560 */     GIR_EraseRootFromParent_Done,
     /*  78561 */   // Label 1320: @78561
     /*  78561 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(78632), // Rule ID 11801 //
     /*  78566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78597 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78605 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78611 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78613 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78615 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78630 */     GIR_RootConstrainSelectedInstOperands,
     /*  78631 */     // GIR_Coverage, 11801,
     /*  78631 */     GIR_EraseRootFromParent_Done,
     /*  78632 */   // Label 1321: @78632
     /*  78632 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(78693), // Rule ID 11825 //
     /*  78637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  78648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78656 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  78660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78664 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78670 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  78672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  78674 */     // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  78677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  78683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  78687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78691 */     GIR_RootConstrainSelectedInstOperands,
     /*  78692 */     // GIR_Coverage, 11825,
     /*  78692 */     GIR_EraseRootFromParent_Done,
     /*  78693 */   // Label 1322: @78693
     /*  78693 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(78736), // Rule ID 13649 //
     /*  78698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78701 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78705 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78709 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78713 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78719 */     // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  78728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  78734 */     GIR_RootConstrainSelectedInstOperands,
     /*  78735 */     // GIR_Coverage, 13649,
     /*  78735 */     GIR_EraseRootFromParent_Done,
     /*  78736 */   // Label 1323: @78736
     /*  78736 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(78779), // Rule ID 3150 //
     /*  78741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  78748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78756 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  78762 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  78765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78767 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78777 */     GIR_RootConstrainSelectedInstOperands,
     /*  78778 */     // GIR_Coverage, 3150,
     /*  78778 */     GIR_EraseRootFromParent_Done,
     /*  78779 */   // Label 1324: @78779
     /*  78779 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(78794), // Rule ID 7415 //
     /*  78784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78787 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  78787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  78792 */     GIR_RootConstrainSelectedInstOperands,
     /*  78793 */     // GIR_Coverage, 7415,
     /*  78793 */     GIR_Done,
     /*  78794 */   // Label 1325: @78794
     /*  78794 */   GIM_Reject,
     /*  78795 */ // Label 1317: @78795
     /*  78795 */ GIM_Reject,
     /*  78796 */ // Label 1208: @78796
     /*  78796 */ GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(78845), // Rule ID 8390 //
     /*  78801 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  78804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  78807 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  78810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  78814 */   // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  78814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  78817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  78821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78826 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  78829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  78831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  78834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  78836 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78839 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  78841 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  78843 */   GIR_RootConstrainSelectedInstOperands,
     /*  78844 */   // GIR_Coverage, 8390,
     /*  78844 */   GIR_EraseRootFromParent_Done,
     /*  78845 */ // Label 1326: @78845
     /*  78845 */ GIM_Reject,
     /*  78846 */ // Label 1209: @78846
     /*  78846 */ GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(79308),
     /*  78851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  78861 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(78932), // Rule ID 15535 //
     /*  78866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78897 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78901 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78905 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78911 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78913 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78915 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78922 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78926 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78930 */     GIR_RootConstrainSelectedInstOperands,
     /*  78931 */     // GIR_Coverage, 15535,
     /*  78931 */     GIR_EraseRootFromParent_Done,
     /*  78932 */   // Label 1328: @78932
     /*  78932 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(79003), // Rule ID 15534 //
     /*  78937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  78968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  78972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78976 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78982 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78984 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  78986 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  78986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  78989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  78993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79001 */     GIR_RootConstrainSelectedInstOperands,
     /*  79002 */     // GIR_Coverage, 15534,
     /*  79002 */     GIR_EraseRootFromParent_Done,
     /*  79003 */   // Label 1329: @79003
     /*  79003 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(79074), // Rule ID 15533 //
     /*  79008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79039 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79047 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79053 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79055 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79057 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79072 */     GIR_RootConstrainSelectedInstOperands,
     /*  79073 */     // GIR_Coverage, 15533,
     /*  79073 */     GIR_EraseRootFromParent_Done,
     /*  79074 */   // Label 1330: @79074
     /*  79074 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(79145), // Rule ID 11799 //
     /*  79079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79106 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79110 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79118 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79124 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79126 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79128 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79143 */     GIR_RootConstrainSelectedInstOperands,
     /*  79144 */     // GIR_Coverage, 11799,
     /*  79144 */     GIR_EraseRootFromParent_Done,
     /*  79145 */   // Label 1331: @79145
     /*  79145 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(79206), // Rule ID 11823 //
     /*  79150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  79161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79169 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  79173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79177 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79183 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  79185 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79187 */     // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  79190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  79200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79204 */     GIR_RootConstrainSelectedInstOperands,
     /*  79205 */     // GIR_Coverage, 11823,
     /*  79205 */     GIR_EraseRootFromParent_Done,
     /*  79206 */   // Label 1332: @79206
     /*  79206 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(79249), // Rule ID 13648 //
     /*  79211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79232 */     // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79237 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  79247 */     GIR_RootConstrainSelectedInstOperands,
     /*  79248 */     // GIR_Coverage, 13648,
     /*  79248 */     GIR_EraseRootFromParent_Done,
     /*  79249 */   // Label 1333: @79249
     /*  79249 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(79292), // Rule ID 3148 //
     /*  79254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  79269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  79273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79275 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  79275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79290 */     GIR_RootConstrainSelectedInstOperands,
     /*  79291 */     // GIR_Coverage, 3148,
     /*  79291 */     GIR_EraseRootFromParent_Done,
     /*  79292 */   // Label 1334: @79292
     /*  79292 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(79307), // Rule ID 7414 //
     /*  79297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79300 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  79300 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  79305 */     GIR_RootConstrainSelectedInstOperands,
     /*  79306 */     // GIR_Coverage, 7414,
     /*  79306 */     GIR_Done,
     /*  79307 */   // Label 1335: @79307
     /*  79307 */   GIM_Reject,
     /*  79308 */ // Label 1327: @79308
     /*  79308 */ GIM_Reject,
     /*  79309 */ // Label 1210: @79309
     /*  79309 */ GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(79358), // Rule ID 8389 //
     /*  79314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  79320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  79323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  79327 */   // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  79327 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  79330 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  79334 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79339 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  79342 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  79344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  79347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  79349 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79352 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79354 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  79356 */   GIR_RootConstrainSelectedInstOperands,
     /*  79357 */   // GIR_Coverage, 8389,
     /*  79357 */   GIR_EraseRootFromParent_Done,
     /*  79358 */ // Label 1336: @79358
     /*  79358 */ GIM_Reject,
     /*  79359 */ // Label 1211: @79359
     /*  79359 */ GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(79821),
     /*  79364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  79374 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(79445), // Rule ID 15532 //
     /*  79379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79394 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79410 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79414 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79418 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79424 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79426 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79428 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  79435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79443 */     GIR_RootConstrainSelectedInstOperands,
     /*  79444 */     // GIR_Coverage, 15532,
     /*  79444 */     GIR_EraseRootFromParent_Done,
     /*  79445 */   // Label 1338: @79445
     /*  79445 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(79516), // Rule ID 15531 //
     /*  79450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79481 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79485 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79489 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79495 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79497 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79499 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  79506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79514 */     GIR_RootConstrainSelectedInstOperands,
     /*  79515 */     // GIR_Coverage, 15531,
     /*  79515 */     GIR_EraseRootFromParent_Done,
     /*  79516 */   // Label 1339: @79516
     /*  79516 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(79587), // Rule ID 15530 //
     /*  79521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79552 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79556 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79560 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79566 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79568 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79570 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79585 */     GIR_RootConstrainSelectedInstOperands,
     /*  79586 */     // GIR_Coverage, 15530,
     /*  79586 */     GIR_EraseRootFromParent_Done,
     /*  79587 */   // Label 1340: @79587
     /*  79587 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(79658), // Rule ID 11797 //
     /*  79592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79623 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79631 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79637 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79639 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  79641 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  79644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79656 */     GIR_RootConstrainSelectedInstOperands,
     /*  79657 */     // GIR_Coverage, 11797,
     /*  79657 */     GIR_EraseRootFromParent_Done,
     /*  79658 */   // Label 1341: @79658
     /*  79658 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(79719), // Rule ID 11821 //
     /*  79663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  79674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79682 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  79686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79690 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79696 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  79698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  79700 */     // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  79703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  79713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79717 */     GIR_RootConstrainSelectedInstOperands,
     /*  79718 */     // GIR_Coverage, 11821,
     /*  79718 */     GIR_EraseRootFromParent_Done,
     /*  79719 */   // Label 1342: @79719
     /*  79719 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(79762), // Rule ID 13647 //
     /*  79724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79743 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79745 */     // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  79760 */     GIR_RootConstrainSelectedInstOperands,
     /*  79761 */     // GIR_Coverage, 13647,
     /*  79761 */     GIR_EraseRootFromParent_Done,
     /*  79762 */   // Label 1343: @79762
     /*  79762 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(79805), // Rule ID 3146 //
     /*  79767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  79782 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  79786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79788 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  79788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  79791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  79795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79803 */     GIR_RootConstrainSelectedInstOperands,
     /*  79804 */     // GIR_Coverage, 3146,
     /*  79804 */     GIR_EraseRootFromParent_Done,
     /*  79805 */   // Label 1344: @79805
     /*  79805 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(79820), // Rule ID 7413 //
     /*  79810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  79813 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  79813 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  79818 */     GIR_RootConstrainSelectedInstOperands,
     /*  79819 */     // GIR_Coverage, 7413,
     /*  79819 */     GIR_Done,
     /*  79820 */   // Label 1345: @79820
     /*  79820 */   GIM_Reject,
     /*  79821 */ // Label 1337: @79821
     /*  79821 */ GIM_Reject,
     /*  79822 */ // Label 1212: @79822
     /*  79822 */ GIM_Reject,
     /*  79823 */ // Label 8: @79823
     /*  79823 */ GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(87346),
     /*  79828 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  79831 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1358*/ GIMT_Encode4(87345),
     /*  79842 */   /*GILLT_v2s64*//*Label 1347*/ GIMT_Encode4(79910), GIMT_Encode4(0),
     /*  79850 */   /*GILLT_v4s32*//*Label 1348*/ GIMT_Encode4(80431), GIMT_Encode4(0),
     /*  79858 */   /*GILLT_v8s16*//*Label 1349*/ GIMT_Encode4(82843),
     /*  79862 */   /*GILLT_v16s8*//*Label 1350*/ GIMT_Encode4(85252), GIMT_Encode4(0),
     /*  79870 */   /*GILLT_nxv2s1*//*Label 1351*/ GIMT_Encode4(87163), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  79886 */   /*GILLT_nxv4s1*//*Label 1352*/ GIMT_Encode4(87189),
     /*  79890 */   /*GILLT_nxv4s16*//*Label 1353*/ GIMT_Encode4(87215),
     /*  79894 */   /*GILLT_nxv4s32*//*Label 1354*/ GIMT_Encode4(87241),
     /*  79898 */   /*GILLT_nxv8s1*//*Label 1355*/ GIMT_Encode4(87267),
     /*  79902 */   /*GILLT_nxv8s16*//*Label 1356*/ GIMT_Encode4(87293),
     /*  79906 */   /*GILLT_nxv16s1*//*Label 1357*/ GIMT_Encode4(87319),
     /*  79910 */   // Label 1347: @79910
     /*  79910 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(80430),
     /*  79915 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  79918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  79921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79929 */     GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(79991), // Rule ID 5751 //
     /*  79934 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  79938 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79944 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  79946 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  79948 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
     /*  79948 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  79951 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  79955 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79960 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  79964 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  79966 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  79969 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  79971 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79974 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79977 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  79980 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  79985 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  79990 */       // GIR_Coverage, 5751,
     /*  79990 */       GIR_EraseRootFromParent_Done,
     /*  79991 */     // Label 1360: @79991
     /*  79991 */     GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(80053), // Rule ID 5755 //
     /*  79996 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80000 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80006 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  80008 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80010 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
     /*  80010 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  80013 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  80017 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80022 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  80026 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80028 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80031 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80033 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80036 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80039 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80042 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80047 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80052 */       // GIR_Coverage, 5755,
     /*  80052 */       GIR_EraseRootFromParent_Done,
     /*  80053 */     // Label 1361: @80053
     /*  80053 */     GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(80111), // Rule ID 5752 //
     /*  80058 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80062 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  80066 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80068 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
     /*  80068 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  80071 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80075 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80080 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80082 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80085 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80087 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80090 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  80092 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80095 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80100 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80105 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80110 */       // GIR_Coverage, 5752,
     /*  80110 */       GIR_EraseRootFromParent_Done,
     /*  80111 */     // Label 1362: @80111
     /*  80111 */     GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(80169), // Rule ID 5756 //
     /*  80116 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80120 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  80124 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80126 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
     /*  80126 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  80129 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80133 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80138 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  80140 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80143 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80145 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80148 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  80150 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  80153 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80158 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80163 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80168 */       // GIR_Coverage, 5756,
     /*  80168 */       GIR_EraseRootFromParent_Done,
     /*  80169 */     // Label 1363: @80169
     /*  80169 */     GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(80299), // Rule ID 5750 //
     /*  80174 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80178 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  80178 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  80181 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80185 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80190 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  80192 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  80195 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80199 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80204 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  80207 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  80211 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  80214 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80219 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80224 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80229 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80232 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80236 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80241 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80243 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80246 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80250 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80255 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80258 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80262 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80265 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80270 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80275 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80280 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  80283 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80285 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80288 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  80291 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  80294 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80297 */       GIR_RootConstrainSelectedInstOperands,
     /*  80298 */       // GIR_Coverage, 5750,
     /*  80298 */       GIR_EraseRootFromParent_Done,
     /*  80299 */     // Label 1364: @80299
     /*  80299 */     GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(80429), // Rule ID 5754 //
     /*  80304 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80308 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  80308 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  80311 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80315 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80320 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  80322 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  80325 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80329 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80334 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  80337 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  80341 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  80344 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80349 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80354 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80359 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80362 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80366 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80371 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80373 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80376 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  80380 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80385 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  80388 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80392 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80395 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80400 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80405 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80410 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  80413 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80415 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80418 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  80421 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  80424 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80427 */       GIR_RootConstrainSelectedInstOperands,
     /*  80428 */       // GIR_Coverage, 5754,
     /*  80428 */       GIR_EraseRootFromParent_Done,
     /*  80429 */     // Label 1365: @80429
     /*  80429 */     GIM_Reject,
     /*  80430 */   // Label 1359: @80430
     /*  80430 */   GIM_Reject,
     /*  80431 */   // Label 1348: @80431
     /*  80431 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(82842),
     /*  80436 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  80439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  80442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80446 */     GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(80575), // Rule ID 5414 //
     /*  80451 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80455 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80459 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80463 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80467 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80471 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80475 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80479 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80483 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80487 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80491 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80495 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80500 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  80504 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80510 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80512 */       // MIs[2] Operand 2
     /*  80512 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80523 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80525 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /*  80525 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80528 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80532 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80537 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80540 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80544 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80547 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80552 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80557 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  80560 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80562 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80565 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  80569 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  80573 */       GIR_RootConstrainSelectedInstOperands,
     /*  80574 */       // GIR_Coverage, 5414,
     /*  80574 */       GIR_EraseRootFromParent_Done,
     /*  80575 */     // Label 1367: @80575
     /*  80575 */     GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(80697), // Rule ID 5410 //
     /*  80580 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80584 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80588 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80592 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80596 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80600 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80604 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80608 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80612 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  80616 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80620 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80624 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80629 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80634 */       // MIs[2] Operand 2
     /*  80634 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80645 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80647 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  80647 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80650 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80654 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80659 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80662 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80666 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80669 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80674 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80679 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  80682 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80684 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80687 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  80691 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  80695 */       GIR_RootConstrainSelectedInstOperands,
     /*  80696 */       // GIR_Coverage, 5410,
     /*  80696 */       GIR_EraseRootFromParent_Done,
     /*  80697 */     // Label 1368: @80697
     /*  80697 */     GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(80819), // Rule ID 5412 //
     /*  80702 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80706 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80710 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80714 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80718 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80722 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80726 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80730 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80734 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  80738 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80742 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80746 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80751 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80756 */       // MIs[2] Operand 2
     /*  80756 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80767 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  80769 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  80769 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80772 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  80776 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80781 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  80784 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  80788 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  80791 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80796 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80801 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  80804 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  80806 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  80809 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  80813 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  80817 */       GIR_RootConstrainSelectedInstOperands,
     /*  80818 */       // GIR_Coverage, 5412,
     /*  80818 */       GIR_EraseRootFromParent_Done,
     /*  80819 */     // Label 1369: @80819
     /*  80819 */     GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(80921), // Rule ID 5560 //
     /*  80824 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80828 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80832 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80836 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80840 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80844 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80848 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80853 */       // MIs[2] Operand 2
     /*  80853 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  80864 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  80868 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  80872 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80876 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  80880 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  80884 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  80888 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80893 */       // MIs[4] Operand 2
     /*  80893 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
     /*  80904 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80906 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  80906 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /*  80909 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  80911 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  80915 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  80919 */       GIR_RootConstrainSelectedInstOperands,
     /*  80920 */       // GIR_Coverage, 5560,
     /*  80920 */       GIR_EraseRootFromParent_Done,
     /*  80921 */     // Label 1370: @80921
     /*  80921 */     GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(81050), // Rule ID 6314 //
     /*  80926 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  80930 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  80934 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  80938 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  80941 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  80946 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  80950 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  80954 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  80959 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
     /*  80963 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  80965 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /*  80965 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  80968 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  80972 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80977 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  80980 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  80982 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  80985 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  80989 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  80994 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  80996 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  80999 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81003 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81008 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81011 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  81015 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81018 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81023 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81028 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81033 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  81036 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81038 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81041 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  81045 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  81048 */       GIR_RootConstrainSelectedInstOperands,
     /*  81049 */       // GIR_Coverage, 6314,
     /*  81049 */       GIR_EraseRootFromParent_Done,
     /*  81050 */     // Label 1371: @81050
     /*  81050 */     GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(81092), // Rule ID 5761 //
     /*  81055 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  81062 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  81069 */       // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
     /*  81069 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81072 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81074 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  81079 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81082 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  81087 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81090 */       GIR_RootConstrainSelectedInstOperands,
     /*  81091 */       // GIR_Coverage, 5761,
     /*  81091 */       GIR_EraseRootFromParent_Done,
     /*  81092 */     // Label 1372: @81092
     /*  81092 */     GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(81134), // Rule ID 5765 //
     /*  81097 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  81104 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  81111 */       // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
     /*  81111 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  81114 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81116 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  81121 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81124 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  81129 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  81132 */       GIR_RootConstrainSelectedInstOperands,
     /*  81133 */       // GIR_Coverage, 5765,
     /*  81133 */       GIR_EraseRootFromParent_Done,
     /*  81134 */     // Label 1373: @81134
     /*  81134 */     GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(81257), // Rule ID 2576 //
     /*  81139 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81142 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81146 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81150 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81154 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81157 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  81162 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81166 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  81170 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81175 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  81179 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81183 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  81187 */       // MIs[2] Operand 1
     /*  81187 */       // No operand predicates
     /*  81187 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  81189 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  81189 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81192 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81196 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81201 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81203 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81206 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81210 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81215 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81218 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81222 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81225 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81230 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81235 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81240 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
     /*  81243 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81245 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81248 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81252 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  81255 */       GIR_RootConstrainSelectedInstOperands,
     /*  81256 */       // GIR_Coverage, 2576,
     /*  81256 */       GIR_EraseRootFromParent_Done,
     /*  81257 */     // Label 1374: @81257
     /*  81257 */     GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(81380), // Rule ID 6282 //
     /*  81262 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81265 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81269 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81273 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81277 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81281 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81285 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  81289 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81293 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81298 */       // MIs[2] imm
     /*  81298 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81302 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81306 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  81310 */       // MIs[3] Operand 1
     /*  81310 */       // No operand predicates
     /*  81310 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81312 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  81312 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81315 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81319 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81324 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81326 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81329 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81333 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81338 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81341 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81345 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81348 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81353 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81358 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81363 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  81366 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81368 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81371 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  81375 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  81378 */       GIR_RootConstrainSelectedInstOperands,
     /*  81379 */       // GIR_Coverage, 6282,
     /*  81379 */       GIR_EraseRootFromParent_Done,
     /*  81380 */     // Label 1375: @81380
     /*  81380 */     GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(81500), // Rule ID 6320 //
     /*  81385 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81389 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81393 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  81397 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81401 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81405 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  81409 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  81413 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81418 */       // MIs[2] imm
     /*  81418 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81422 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  81426 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  81430 */       // MIs[3] Operand 1
     /*  81430 */       // No operand predicates
     /*  81430 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  81432 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  81432 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81435 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81439 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81444 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81446 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81449 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81453 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81458 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81461 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81465 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81468 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81473 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81478 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81483 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /*  81486 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81488 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81491 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  81495 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  81498 */       GIR_RootConstrainSelectedInstOperands,
     /*  81499 */       // GIR_Coverage, 6320,
     /*  81499 */       GIR_EraseRootFromParent_Done,
     /*  81500 */     // Label 1376: @81500
     /*  81500 */     GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(81617), // Rule ID 2499 //
     /*  81505 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81508 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81512 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81516 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81520 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81523 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  81528 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81532 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81536 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81541 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81546 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81548 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81548 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81551 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81555 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81560 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81562 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81565 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81569 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81574 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81577 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81581 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81584 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81589 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81594 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81599 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  81602 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81604 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81607 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81611 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81615 */       GIR_RootConstrainSelectedInstOperands,
     /*  81616 */       // GIR_Coverage, 2499,
     /*  81616 */       GIR_EraseRootFromParent_Done,
     /*  81617 */     // Label 1377: @81617
     /*  81617 */     GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(81734), // Rule ID 5330 //
     /*  81622 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81625 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81629 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81633 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81637 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81640 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  81645 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81649 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81653 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81658 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81663 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81665 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81665 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81668 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81672 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81677 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81679 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81682 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81686 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81691 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81694 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81698 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81701 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81706 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81711 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81716 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  81719 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81721 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81724 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81728 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81732 */       GIR_RootConstrainSelectedInstOperands,
     /*  81733 */       // GIR_Coverage, 5330,
     /*  81733 */       GIR_EraseRootFromParent_Done,
     /*  81734 */     // Label 1378: @81734
     /*  81734 */     GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(81851), // Rule ID 5333 //
     /*  81739 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81742 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81746 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81750 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81754 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81757 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  81762 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81766 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81770 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81775 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81780 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81782 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81782 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81785 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81789 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81794 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81796 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81799 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81803 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81808 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81811 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81815 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81818 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81823 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81828 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81833 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  81836 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81838 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81841 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81845 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81849 */       GIR_RootConstrainSelectedInstOperands,
     /*  81850 */       // GIR_Coverage, 5333,
     /*  81850 */       GIR_EraseRootFromParent_Done,
     /*  81851 */     // Label 1379: @81851
     /*  81851 */     GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(81968), // Rule ID 5336 //
     /*  81856 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81859 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81863 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81867 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81871 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  81874 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  81879 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  81883 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  81887 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81892 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81897 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  81899 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  81899 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  81902 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  81906 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81911 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  81913 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  81916 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  81920 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  81925 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  81928 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  81932 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  81935 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81940 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  81945 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81950 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
     /*  81953 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  81955 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  81958 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  81962 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  81966 */       GIR_RootConstrainSelectedInstOperands,
     /*  81967 */       // GIR_Coverage, 5336,
     /*  81967 */       GIR_EraseRootFromParent_Done,
     /*  81968 */     // Label 1380: @81968
     /*  81968 */     GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(82072), // Rule ID 2495 //
     /*  81973 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  81976 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  81980 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  81984 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  81988 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  81991 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /*  81996 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  82000 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82005 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82007 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  82007 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82010 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82014 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82019 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82021 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82024 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82028 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82033 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82036 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82040 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82043 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82048 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82053 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82058 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
     /*  82061 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82063 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82066 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  82070 */       GIR_RootConstrainSelectedInstOperands,
     /*  82071 */       // GIR_Coverage, 2495,
     /*  82071 */       GIR_EraseRootFromParent_Done,
     /*  82072 */     // Label 1381: @82072
     /*  82072 */     GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(82128), // Rule ID 5493 //
     /*  82077 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82081 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82085 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  82089 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82094 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82098 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82102 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  82106 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82111 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  82113 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  82113 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /*  82116 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  82118 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  82122 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  82126 */       GIR_RootConstrainSelectedInstOperands,
     /*  82127 */       // GIR_Coverage, 5493,
     /*  82127 */       GIR_EraseRootFromParent_Done,
     /*  82128 */     // Label 1382: @82128
     /*  82128 */     GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(82194), // Rule ID 5759 //
     /*  82133 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82137 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82141 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82147 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  82149 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82151 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /*  82151 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  82154 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  82158 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82163 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  82167 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82169 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82172 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82174 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82177 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82180 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82183 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82188 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82193 */       // GIR_Coverage, 5759,
     /*  82193 */       GIR_EraseRootFromParent_Done,
     /*  82194 */     // Label 1383: @82194
     /*  82194 */     GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(82260), // Rule ID 5763 //
     /*  82199 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82203 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82207 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82213 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  82215 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82217 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
     /*  82217 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  82220 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  82224 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82229 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  82233 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82235 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82238 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82240 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82243 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82246 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82249 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82254 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82259 */       // GIR_Coverage, 5763,
     /*  82259 */       GIR_EraseRootFromParent_Done,
     /*  82260 */     // Label 1384: @82260
     /*  82260 */     GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(82353), // Rule ID 4900 //
     /*  82265 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82269 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82273 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  82277 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  82281 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82286 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82288 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /*  82288 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82291 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82295 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82300 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82302 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82305 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82309 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82314 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82317 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82321 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82324 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82329 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82334 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82339 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
     /*  82342 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82344 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82347 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  82351 */       GIR_RootConstrainSelectedInstOperands,
     /*  82352 */       // GIR_Coverage, 4900,
     /*  82352 */       GIR_EraseRootFromParent_Done,
     /*  82353 */     // Label 1385: @82353
     /*  82353 */     GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(82449), // Rule ID 4947 //
     /*  82358 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82361 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82365 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82369 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82373 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  82377 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82382 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82384 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
     /*  82384 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82387 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82391 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82396 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82398 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82401 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82405 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82410 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82413 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82417 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82420 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82425 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82430 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82435 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
     /*  82438 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82440 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82443 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  82447 */       GIR_RootConstrainSelectedInstOperands,
     /*  82448 */       // GIR_Coverage, 4947,
     /*  82448 */       GIR_EraseRootFromParent_Done,
     /*  82449 */     // Label 1386: @82449
     /*  82449 */     GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(82511), // Rule ID 5760 //
     /*  82454 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82458 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82462 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  82466 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82468 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
     /*  82468 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82471 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82475 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82480 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82482 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82485 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82487 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82490 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  82492 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82495 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82500 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82505 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82510 */       // GIR_Coverage, 5760,
     /*  82510 */       GIR_EraseRootFromParent_Done,
     /*  82511 */     // Label 1387: @82511
     /*  82511 */     GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(82573), // Rule ID 5764 //
     /*  82516 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82520 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82524 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  82528 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  82530 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
     /*  82530 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  82533 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82537 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82542 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  82544 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82547 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82549 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82552 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  82554 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  82557 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82562 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82567 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82572 */       // GIR_Coverage, 5764,
     /*  82572 */       GIR_EraseRootFromParent_Done,
     /*  82573 */     // Label 1388: @82573
     /*  82573 */     GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(82707), // Rule ID 5758 //
     /*  82578 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82582 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82586 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  82586 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  82589 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82593 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82598 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  82600 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  82603 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82607 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82612 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  82615 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  82619 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  82622 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82627 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82632 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82637 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82640 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82644 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82649 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82651 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82654 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82658 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82663 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82666 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82670 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82673 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82678 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82683 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82688 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  82691 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82693 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82696 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  82699 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  82702 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82705 */       GIR_RootConstrainSelectedInstOperands,
     /*  82706 */       // GIR_Coverage, 5758,
     /*  82706 */       GIR_EraseRootFromParent_Done,
     /*  82707 */     // Label 1389: @82707
     /*  82707 */     GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(82841), // Rule ID 5762 //
     /*  82712 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82716 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82720 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  82720 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  82723 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82727 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82732 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  82734 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  82737 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82741 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82746 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  82749 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  82753 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  82756 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82761 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82766 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82771 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  82774 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82778 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82783 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82785 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82788 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  82792 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82797 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82800 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82804 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82807 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82812 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82817 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82822 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  82825 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82827 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82830 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  82833 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  82836 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82839 */       GIR_RootConstrainSelectedInstOperands,
     /*  82840 */       // GIR_Coverage, 5762,
     /*  82840 */       GIR_EraseRootFromParent_Done,
     /*  82841 */     // Label 1390: @82841
     /*  82841 */     GIM_Reject,
     /*  82842 */   // Label 1366: @82842
     /*  82842 */   GIM_Reject,
     /*  82843 */   // Label 1349: @82843
     /*  82843 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(85251),
     /*  82848 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  82851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  82854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82858 */     GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(82987), // Rule ID 5408 //
     /*  82863 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82867 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  82871 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  82875 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82879 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82883 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  82887 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82891 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82895 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82899 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  82903 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  82907 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82912 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82916 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82922 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82924 */       // MIs[2] Operand 2
     /*  82924 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  82935 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82937 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /*  82937 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  82940 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  82944 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82949 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  82952 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  82956 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  82959 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  82964 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82969 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  82972 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82974 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82977 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  82981 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  82985 */       GIR_RootConstrainSelectedInstOperands,
     /*  82986 */       // GIR_Coverage, 5408,
     /*  82986 */       GIR_EraseRootFromParent_Done,
     /*  82987 */     // Label 1392: @82987
     /*  82987 */     GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(83109), // Rule ID 5404 //
     /*  82992 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  82996 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83000 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83004 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83008 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83012 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83016 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83020 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83024 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  83028 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83032 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83036 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83041 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83046 */       // MIs[2] Operand 2
     /*  83046 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  83057 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83059 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83059 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83062 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  83066 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83071 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  83074 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83078 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83081 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83086 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83091 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  83094 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83096 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83099 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  83103 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  83107 */       GIR_RootConstrainSelectedInstOperands,
     /*  83108 */       // GIR_Coverage, 5404,
     /*  83108 */       GIR_EraseRootFromParent_Done,
     /*  83109 */     // Label 1393: @83109
     /*  83109 */     GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(83231), // Rule ID 5406 //
     /*  83114 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83118 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83122 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83126 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83130 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83134 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83138 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83142 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83146 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  83150 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83154 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83158 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83163 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83168 */       // MIs[2] Operand 2
     /*  83168 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  83179 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83181 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83181 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83184 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  83188 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83193 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  83196 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83200 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83203 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83208 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83213 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  83216 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83218 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83221 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  83225 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  83229 */       GIR_RootConstrainSelectedInstOperands,
     /*  83230 */       // GIR_Coverage, 5406,
     /*  83230 */       GIR_EraseRootFromParent_Done,
     /*  83231 */     // Label 1394: @83231
     /*  83231 */     GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(83333), // Rule ID 5559 //
     /*  83236 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83240 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83244 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83248 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83252 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83256 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83260 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83265 */       // MIs[2] Operand 2
     /*  83265 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  83276 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  83280 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83284 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83288 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  83292 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83296 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83300 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83305 */       // MIs[4] Operand 2
     /*  83305 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
     /*  83316 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83318 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  83318 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /*  83321 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  83323 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  83327 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  83331 */       GIR_RootConstrainSelectedInstOperands,
     /*  83332 */       // GIR_Coverage, 5559,
     /*  83332 */       GIR_EraseRootFromParent_Done,
     /*  83333 */     // Label 1395: @83333
     /*  83333 */     GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(83462), // Rule ID 6313 //
     /*  83338 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83342 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83346 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83350 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83353 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  83358 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83362 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  83366 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83371 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
     /*  83375 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83377 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /*  83377 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  83380 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  83384 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83389 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  83392 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  83394 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83397 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83401 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83406 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83408 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83411 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83415 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83420 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83423 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  83427 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83430 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83435 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83440 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83445 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  83448 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83450 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83453 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  83457 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  83460 */       GIR_RootConstrainSelectedInstOperands,
     /*  83461 */       // GIR_Coverage, 6313,
     /*  83461 */       GIR_EraseRootFromParent_Done,
     /*  83462 */     // Label 1396: @83462
     /*  83462 */     GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(83504), // Rule ID 5769 //
     /*  83467 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  83474 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  83481 */       // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
     /*  83481 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  83484 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83486 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  83491 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83494 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83499 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83502 */       GIR_RootConstrainSelectedInstOperands,
     /*  83503 */       // GIR_Coverage, 5769,
     /*  83503 */       GIR_EraseRootFromParent_Done,
     /*  83504 */     // Label 1397: @83504
     /*  83504 */     GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(83546), // Rule ID 5773 //
     /*  83509 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  83516 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /*  83523 */       // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
     /*  83523 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  83526 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83528 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  83533 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83536 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  83541 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  83544 */       GIR_RootConstrainSelectedInstOperands,
     /*  83545 */       // GIR_Coverage, 5773,
     /*  83545 */       GIR_EraseRootFromParent_Done,
     /*  83546 */     // Label 1398: @83546
     /*  83546 */     GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(83669), // Rule ID 2574 //
     /*  83551 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83554 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83558 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83562 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83566 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83569 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  83574 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83578 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  83582 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83587 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  83591 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83595 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  83599 */       // MIs[2] Operand 1
     /*  83599 */       // No operand predicates
     /*  83599 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  83601 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  83601 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83604 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83608 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83613 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83615 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83618 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83622 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83627 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83630 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83634 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83637 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83642 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83647 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83652 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
     /*  83655 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83657 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83660 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  83664 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  83667 */       GIR_RootConstrainSelectedInstOperands,
     /*  83668 */       // GIR_Coverage, 2574,
     /*  83668 */       GIR_EraseRootFromParent_Done,
     /*  83669 */     // Label 1399: @83669
     /*  83669 */     GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(83792), // Rule ID 6281 //
     /*  83674 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83677 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83681 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83685 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83689 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83693 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83697 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  83701 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83705 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83710 */       // MIs[2] imm
     /*  83710 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83714 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83718 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  83722 */       // MIs[3] Operand 1
     /*  83722 */       // No operand predicates
     /*  83722 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83724 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  83724 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83727 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83731 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83736 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83738 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83741 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83745 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83750 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83753 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83757 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83760 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83765 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83770 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83775 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  83778 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83780 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83783 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  83787 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  83790 */       GIR_RootConstrainSelectedInstOperands,
     /*  83791 */       // GIR_Coverage, 6281,
     /*  83791 */       GIR_EraseRootFromParent_Done,
     /*  83792 */     // Label 1400: @83792
     /*  83792 */     GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(83912), // Rule ID 6319 //
     /*  83797 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83801 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83805 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  83809 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83813 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83817 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  83821 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  83825 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83830 */       // MIs[2] imm
     /*  83830 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83834 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  83838 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /*  83842 */       // MIs[3] Operand 1
     /*  83842 */       // No operand predicates
     /*  83842 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  83844 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /*  83844 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83847 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83851 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83856 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83858 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83861 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83865 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83870 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83873 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83877 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83880 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83885 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83890 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83895 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /*  83898 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  83900 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  83903 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  83907 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  83910 */       GIR_RootConstrainSelectedInstOperands,
     /*  83911 */       // GIR_Coverage, 6319,
     /*  83911 */       GIR_EraseRootFromParent_Done,
     /*  83912 */     // Label 1401: @83912
     /*  83912 */     GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(84029), // Rule ID 2498 //
     /*  83917 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  83920 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  83924 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  83928 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  83932 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  83935 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  83940 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  83944 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  83948 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83953 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  83958 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  83960 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  83960 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  83963 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  83967 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83972 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  83974 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  83977 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  83981 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  83986 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  83989 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  83993 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  83996 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84001 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84006 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84011 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /*  84014 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84016 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84019 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84023 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  84027 */       GIR_RootConstrainSelectedInstOperands,
     /*  84028 */       // GIR_Coverage, 2498,
     /*  84028 */       GIR_EraseRootFromParent_Done,
     /*  84029 */     // Label 1402: @84029
     /*  84029 */     GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(84146), // Rule ID 5329 //
     /*  84034 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84037 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84041 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84045 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84049 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  84052 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  84057 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84061 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84065 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84070 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84075 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84077 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  84077 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84080 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84084 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84089 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84091 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84094 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84098 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84103 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84106 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84110 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84113 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84118 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84123 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84128 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /*  84131 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84133 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84136 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84140 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  84144 */       GIR_RootConstrainSelectedInstOperands,
     /*  84145 */       // GIR_Coverage, 5329,
     /*  84145 */       GIR_EraseRootFromParent_Done,
     /*  84146 */     // Label 1403: @84146
     /*  84146 */     GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(84263), // Rule ID 5332 //
     /*  84151 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84154 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84158 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84162 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84166 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  84169 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  84174 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84178 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84182 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84187 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84192 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84194 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  84194 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84197 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84201 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84206 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84208 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84211 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84215 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84220 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84223 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84227 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84230 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84235 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84240 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84245 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /*  84248 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84250 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84253 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84257 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  84261 */       GIR_RootConstrainSelectedInstOperands,
     /*  84262 */       // GIR_Coverage, 5332,
     /*  84262 */       GIR_EraseRootFromParent_Done,
     /*  84263 */     // Label 1404: @84263
     /*  84263 */     GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(84380), // Rule ID 5335 //
     /*  84268 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84271 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84275 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84279 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84283 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  84286 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  84291 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84295 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  84299 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84304 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84309 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84311 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  84311 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84314 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84318 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84323 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84325 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84328 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84332 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84337 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84340 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84344 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84347 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84352 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84357 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84362 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
     /*  84365 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84367 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84370 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84374 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  84378 */       GIR_RootConstrainSelectedInstOperands,
     /*  84379 */       // GIR_Coverage, 5335,
     /*  84379 */       GIR_EraseRootFromParent_Done,
     /*  84380 */     // Label 1405: @84380
     /*  84380 */     GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(84481), // Rule ID 4894 //
     /*  84385 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84389 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84393 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  84397 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  84400 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /*  84405 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  84409 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84414 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84416 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  84416 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84419 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84423 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84428 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84430 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84433 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84437 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84442 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84445 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84449 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84452 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84457 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84462 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84467 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  84470 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84472 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84475 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  84479 */       GIR_RootConstrainSelectedInstOperands,
     /*  84480 */       // GIR_Coverage, 4894,
     /*  84480 */       GIR_EraseRootFromParent_Done,
     /*  84481 */     // Label 1406: @84481
     /*  84481 */     GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(84537), // Rule ID 5484 //
     /*  84486 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84490 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84494 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84498 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84503 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  84507 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84511 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84515 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84520 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  84522 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /*  84522 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /*  84525 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  84527 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  84531 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  84535 */       GIR_RootConstrainSelectedInstOperands,
     /*  84536 */       // GIR_Coverage, 5484,
     /*  84536 */       GIR_EraseRootFromParent_Done,
     /*  84537 */     // Label 1407: @84537
     /*  84537 */     GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(84603), // Rule ID 5767 //
     /*  84542 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84546 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84550 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84556 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  84558 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84560 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
     /*  84560 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84563 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  84567 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84572 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  84576 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84578 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84581 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84583 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84586 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84589 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84592 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84597 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84602 */       // GIR_Coverage, 5767,
     /*  84602 */       GIR_EraseRootFromParent_Done,
     /*  84603 */     // Label 1408: @84603
     /*  84603 */     GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(84669), // Rule ID 5771 //
     /*  84608 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84612 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84616 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84622 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  84624 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84626 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
     /*  84626 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  84629 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  84633 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84638 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  84642 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84644 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  84647 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84649 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84652 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84655 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84658 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84663 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84668 */       // GIR_Coverage, 5771,
     /*  84668 */       GIR_EraseRootFromParent_Done,
     /*  84669 */     // Label 1409: @84669
     /*  84669 */     GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(84762), // Rule ID 4902 //
     /*  84674 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84678 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84682 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /*  84686 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84690 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84695 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84697 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /*  84697 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84700 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84704 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84709 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84711 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84714 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84718 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84723 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84726 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84730 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84733 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84738 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84743 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84748 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  84751 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84753 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84756 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  84760 */       GIR_RootConstrainSelectedInstOperands,
     /*  84761 */       // GIR_Coverage, 4902,
     /*  84761 */       GIR_EraseRootFromParent_Done,
     /*  84762 */     // Label 1410: @84762
     /*  84762 */     GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(84858), // Rule ID 4946 //
     /*  84767 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  84770 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84774 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84778 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  84782 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  84786 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84791 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84793 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
     /*  84793 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  84796 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84800 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84805 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  84807 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  84810 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84814 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84819 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  84822 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  84826 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  84829 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84834 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84839 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84844 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
     /*  84847 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84849 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84852 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  84856 */       GIR_RootConstrainSelectedInstOperands,
     /*  84857 */       // GIR_Coverage, 4946,
     /*  84857 */       GIR_EraseRootFromParent_Done,
     /*  84858 */     // Label 1411: @84858
     /*  84858 */     GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(84920), // Rule ID 5768 //
     /*  84863 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84867 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84871 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  84875 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84877 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
     /*  84877 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  84880 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84884 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84889 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84891 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84894 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84896 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84899 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  84901 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84904 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84909 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84914 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84919 */       // GIR_Coverage, 5768,
     /*  84919 */       GIR_EraseRootFromParent_Done,
     /*  84920 */     // Label 1412: @84920
     /*  84920 */     GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(84982), // Rule ID 5772 //
     /*  84925 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84929 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  84933 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  84937 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  84939 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
     /*  84939 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  84942 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  84946 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  84951 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  84953 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  84956 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  84958 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  84961 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  84963 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  84966 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84971 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  84976 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84981 */       // GIR_Coverage, 5772,
     /*  84981 */       GIR_EraseRootFromParent_Done,
     /*  84982 */     // Label 1413: @84982
     /*  84982 */     GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(85116), // Rule ID 5766 //
     /*  84987 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84991 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  84995 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  84995 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  84998 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85002 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85007 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  85009 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  85012 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85016 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85021 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  85024 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  85028 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  85031 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85036 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85041 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85046 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85049 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85053 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85058 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85060 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85063 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85067 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85072 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85075 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85079 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85082 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85087 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85092 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85097 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  85100 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85102 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85105 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  85108 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  85111 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85114 */       GIR_RootConstrainSelectedInstOperands,
     /*  85115 */       // GIR_Coverage, 5766,
     /*  85115 */       GIR_EraseRootFromParent_Done,
     /*  85116 */     // Label 1414: @85116
     /*  85116 */     GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(85250), // Rule ID 5770 //
     /*  85121 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85125 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85129 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  85129 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  85132 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85136 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85141 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  85143 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  85146 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85150 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85155 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  85158 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  85162 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  85165 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85170 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85175 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85180 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85183 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85187 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85192 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85194 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85197 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85201 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85206 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85209 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85213 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85216 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85221 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85226 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85231 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  85234 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85236 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85239 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  85242 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  85245 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85248 */       GIR_RootConstrainSelectedInstOperands,
     /*  85249 */       // GIR_Coverage, 5770,
     /*  85249 */       GIR_EraseRootFromParent_Done,
     /*  85250 */     // Label 1415: @85250
     /*  85250 */     GIM_Reject,
     /*  85251 */   // Label 1391: @85251
     /*  85251 */   GIM_Reject,
     /*  85252 */   // Label 1350: @85252
     /*  85252 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(87162),
     /*  85257 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  85260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  85263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85267 */     GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(85396), // Rule ID 5402 //
     /*  85272 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85276 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85280 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85284 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85288 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85292 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85296 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85300 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85304 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85308 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85312 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85316 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85321 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85325 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85331 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85333 */       // MIs[2] Operand 2
     /*  85333 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85344 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85346 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /*  85346 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85349 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  85353 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85358 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  85361 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85365 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85368 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85373 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85378 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  85381 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85383 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85386 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  85390 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  85394 */       GIR_RootConstrainSelectedInstOperands,
     /*  85395 */       // GIR_Coverage, 5402,
     /*  85395 */       GIR_EraseRootFromParent_Done,
     /*  85396 */     // Label 1417: @85396
     /*  85396 */     GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(85518), // Rule ID 5398 //
     /*  85401 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85405 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85409 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85413 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85417 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85421 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85425 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85429 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85433 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  85437 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85441 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85445 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85450 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85455 */       // MIs[2] Operand 2
     /*  85455 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85466 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85468 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85468 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85471 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  85475 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85480 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  85483 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85487 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85490 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85495 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85500 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  85503 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85505 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85508 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  85512 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  85516 */       GIR_RootConstrainSelectedInstOperands,
     /*  85517 */       // GIR_Coverage, 5398,
     /*  85517 */       GIR_EraseRootFromParent_Done,
     /*  85518 */     // Label 1418: @85518
     /*  85518 */     GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(85640), // Rule ID 5400 //
     /*  85523 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85527 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85531 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85535 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85539 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85543 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85547 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85551 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85555 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  85559 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85563 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85567 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85572 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85577 */       // MIs[2] Operand 2
     /*  85577 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85588 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  85590 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  85590 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85593 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  85597 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85602 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  85605 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  85609 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85612 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85617 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85622 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  85625 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85627 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85630 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  85634 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  85638 */       GIR_RootConstrainSelectedInstOperands,
     /*  85639 */       // GIR_Coverage, 5400,
     /*  85639 */       GIR_EraseRootFromParent_Done,
     /*  85640 */     // Label 1419: @85640
     /*  85640 */     GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(85742), // Rule ID 5558 //
     /*  85645 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85649 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85653 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85657 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85661 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85665 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85669 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85674 */       // MIs[2] Operand 2
     /*  85674 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  85685 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  85689 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  85693 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85697 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  85701 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  85705 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  85709 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85714 */       // MIs[4] Operand 2
     /*  85714 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /*  85725 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  85727 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  85727 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /*  85730 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  85732 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  85736 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  85740 */       GIR_RootConstrainSelectedInstOperands,
     /*  85741 */       // GIR_Coverage, 5558,
     /*  85741 */       GIR_EraseRootFromParent_Done,
     /*  85742 */     // Label 1420: @85742
     /*  85742 */     GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(85871), // Rule ID 6312 //
     /*  85747 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85751 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85755 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85759 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85762 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  85767 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85771 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  85775 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85780 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
     /*  85784 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  85786 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /*  85786 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  85789 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  85793 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85798 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  85801 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  85803 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85806 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85810 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85815 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85817 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85820 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85824 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85829 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85832 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  85836 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  85839 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85844 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85849 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85854 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  85857 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85859 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  85862 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  85866 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  85869 */       GIR_RootConstrainSelectedInstOperands,
     /*  85870 */       // GIR_Coverage, 6312,
     /*  85870 */       GIR_EraseRootFromParent_Done,
     /*  85871 */     // Label 1421: @85871
     /*  85871 */     GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(85913), // Rule ID 5777 //
     /*  85876 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  85883 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  85890 */       // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
     /*  85890 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  85893 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  85895 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  85900 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85903 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  85908 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  85911 */       GIR_RootConstrainSelectedInstOperands,
     /*  85912 */       // GIR_Coverage, 5777,
     /*  85912 */       GIR_EraseRootFromParent_Done,
     /*  85913 */     // Label 1422: @85913
     /*  85913 */     GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(86036), // Rule ID 2572 //
     /*  85918 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  85921 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  85925 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  85929 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  85933 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  85936 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  85941 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85945 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  85949 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  85954 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  85958 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  85962 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  85966 */       // MIs[2] Operand 1
     /*  85966 */       // No operand predicates
     /*  85966 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  85968 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  85968 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  85971 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  85975 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85980 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  85982 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  85985 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  85989 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  85994 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  85997 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86001 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86004 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86009 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86014 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86019 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
     /*  86022 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86024 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86027 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86031 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  86034 */       GIR_RootConstrainSelectedInstOperands,
     /*  86035 */       // GIR_Coverage, 2572,
     /*  86035 */       GIR_EraseRootFromParent_Done,
     /*  86036 */     // Label 1423: @86036
     /*  86036 */     GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(86159), // Rule ID 6280 //
     /*  86041 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86044 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86048 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86052 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86056 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86060 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86064 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /*  86068 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86072 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86077 */       // MIs[2] imm
     /*  86077 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86081 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86085 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  86089 */       // MIs[3] Operand 1
     /*  86089 */       // No operand predicates
     /*  86089 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86091 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  86091 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86094 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86098 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86103 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86105 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86108 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86112 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86117 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86120 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86124 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86127 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86132 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86137 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86142 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  86145 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86147 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86150 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  86154 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  86157 */       GIR_RootConstrainSelectedInstOperands,
     /*  86158 */       // GIR_Coverage, 6280,
     /*  86158 */       GIR_EraseRootFromParent_Done,
     /*  86159 */     // Label 1424: @86159
     /*  86159 */     GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(86279), // Rule ID 6318 //
     /*  86164 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86168 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86172 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86176 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86180 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86184 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  86188 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86192 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86197 */       // MIs[2] imm
     /*  86197 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86201 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  86205 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /*  86209 */       // MIs[3] Operand 1
     /*  86209 */       // No operand predicates
     /*  86209 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  86211 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /*  86211 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86214 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86218 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86223 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86225 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86228 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86232 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86237 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86240 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86244 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86247 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86252 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86257 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86262 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /*  86265 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86267 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86270 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  86274 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /*  86277 */       GIR_RootConstrainSelectedInstOperands,
     /*  86278 */       // GIR_Coverage, 6318,
     /*  86278 */       GIR_EraseRootFromParent_Done,
     /*  86279 */     // Label 1425: @86279
     /*  86279 */     GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(86396), // Rule ID 2497 //
     /*  86284 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86287 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86291 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86295 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86299 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86302 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /*  86307 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86311 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86315 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86320 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86325 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86327 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86327 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86330 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86334 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86339 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86341 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86344 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86348 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86353 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86356 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86360 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86363 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86368 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86373 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86378 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /*  86381 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86383 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86386 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86390 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86394 */       GIR_RootConstrainSelectedInstOperands,
     /*  86395 */       // GIR_Coverage, 2497,
     /*  86395 */       GIR_EraseRootFromParent_Done,
     /*  86396 */     // Label 1426: @86396
     /*  86396 */     GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(86513), // Rule ID 5328 //
     /*  86401 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86404 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86408 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86412 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86416 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86419 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /*  86424 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86428 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86432 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86437 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86442 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86444 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86444 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86447 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86451 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86456 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86458 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86461 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86465 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86470 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86473 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86477 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86480 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86485 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86490 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86495 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /*  86498 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86500 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86503 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86507 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86511 */       GIR_RootConstrainSelectedInstOperands,
     /*  86512 */       // GIR_Coverage, 5328,
     /*  86512 */       GIR_EraseRootFromParent_Done,
     /*  86513 */     // Label 1427: @86513
     /*  86513 */     GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(86630), // Rule ID 5331 //
     /*  86518 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86521 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86525 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86529 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86533 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86536 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /*  86541 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86545 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86549 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86554 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86559 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86561 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86561 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86564 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86568 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86573 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86575 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86578 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86582 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86587 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86590 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86594 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86597 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86602 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86607 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86612 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /*  86615 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86617 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86620 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86624 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86628 */       GIR_RootConstrainSelectedInstOperands,
     /*  86629 */       // GIR_Coverage, 5331,
     /*  86629 */       GIR_EraseRootFromParent_Done,
     /*  86630 */     // Label 1428: @86630
     /*  86630 */     GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(86747), // Rule ID 5334 //
     /*  86635 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86638 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86642 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86646 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  86650 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  86653 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /*  86658 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86662 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86666 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86671 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86676 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86678 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  86678 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86681 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86685 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86690 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86692 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86695 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86699 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86704 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86707 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86711 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86714 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86719 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86724 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86729 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
     /*  86732 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86734 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86737 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  86741 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  86745 */       GIR_RootConstrainSelectedInstOperands,
     /*  86746 */       // GIR_Coverage, 5334,
     /*  86746 */       GIR_EraseRootFromParent_Done,
     /*  86747 */     // Label 1429: @86747
     /*  86747 */     GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(86803), // Rule ID 5475 //
     /*  86752 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86756 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86760 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86764 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86769 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86773 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86777 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86781 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86786 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  86788 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /*  86788 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /*  86791 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  86793 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  86797 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  86801 */       GIR_RootConstrainSelectedInstOperands,
     /*  86802 */       // GIR_Coverage, 5475,
     /*  86802 */       GIR_EraseRootFromParent_Done,
     /*  86803 */     // Label 1430: @86803
     /*  86803 */     GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(86869), // Rule ID 5775 //
     /*  86808 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86812 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86816 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86822 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  86824 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86826 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
     /*  86826 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  86829 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  86833 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86838 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  86842 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86844 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  86847 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86849 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86852 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86855 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  86858 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86863 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86868 */       // GIR_Coverage, 5775,
     /*  86868 */       GIR_EraseRootFromParent_Done,
     /*  86869 */     // Label 1431: @86869
     /*  86869 */     GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(86965), // Rule ID 4945 //
     /*  86874 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  86877 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86881 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86885 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  86889 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  86893 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86898 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86900 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
     /*  86900 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  86903 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86907 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86912 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  86914 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  86917 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  86921 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86926 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  86929 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  86933 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  86936 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86941 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  86946 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86951 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
     /*  86954 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  86956 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  86959 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  86963 */       GIR_RootConstrainSelectedInstOperands,
     /*  86964 */       // GIR_Coverage, 4945,
     /*  86964 */       GIR_EraseRootFromParent_Done,
     /*  86965 */     // Label 1432: @86965
     /*  86965 */     GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(87027), // Rule ID 5776 //
     /*  86970 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  86974 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  86978 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  86982 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  86984 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
     /*  86984 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  86987 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  86991 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  86996 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  86998 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  87001 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87003 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87006 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  87008 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  87011 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87016 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87021 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87026 */       // GIR_Coverage, 5776,
     /*  87026 */       GIR_EraseRootFromParent_Done,
     /*  87027 */     // Label 1433: @87027
     /*  87027 */     GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(87161), // Rule ID 5774 //
     /*  87032 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87036 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87040 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  87040 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  87043 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  87047 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87052 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  87054 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  87057 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  87061 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87066 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  87069 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  87073 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  87076 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87081 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87086 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87091 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  87094 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  87098 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87103 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  87105 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  87108 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  87112 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87117 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  87120 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  87124 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  87127 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87132 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87137 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87142 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  87145 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87147 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87150 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  87153 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  87156 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87159 */       GIR_RootConstrainSelectedInstOperands,
     /*  87160 */       // GIR_Coverage, 5774,
     /*  87160 */       GIR_EraseRootFromParent_Done,
     /*  87161 */     // Label 1434: @87161
     /*  87161 */     GIM_Reject,
     /*  87162 */   // Label 1416: @87162
     /*  87162 */   GIM_Reject,
     /*  87163 */   // Label 1351: @87163
     /*  87163 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(87188), // Rule ID 9020 //
     /*  87168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87171 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  87174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  87177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  87181 */     // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
     /*  87181 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /*  87186 */     GIR_RootConstrainSelectedInstOperands,
     /*  87187 */     // GIR_Coverage, 9020,
     /*  87187 */     GIR_Done,
     /*  87188 */   // Label 1435: @87188
     /*  87188 */   GIM_Reject,
     /*  87189 */   // Label 1352: @87189
     /*  87189 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(87214), // Rule ID 9021 //
     /*  87194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87197 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  87200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  87203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  87207 */     // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
     /*  87207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /*  87212 */     GIR_RootConstrainSelectedInstOperands,
     /*  87213 */     // GIR_Coverage, 9021,
     /*  87213 */     GIR_Done,
     /*  87214 */   // Label 1436: @87214
     /*  87214 */   GIM_Reject,
     /*  87215 */   // Label 1353: @87215
     /*  87215 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(87240), // Rule ID 9024 //
     /*  87220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87223 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /*  87226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /*  87229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  87233 */     // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
     /*  87233 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  87238 */     GIR_RootConstrainSelectedInstOperands,
     /*  87239 */     // GIR_Coverage, 9024,
     /*  87239 */     GIR_Done,
     /*  87240 */   // Label 1437: @87240
     /*  87240 */   GIM_Reject,
     /*  87241 */   // Label 1354: @87241
     /*  87241 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(87266), // Rule ID 9026 //
     /*  87246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87249 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /*  87252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /*  87255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  87259 */     // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
     /*  87259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /*  87264 */     GIR_RootConstrainSelectedInstOperands,
     /*  87265 */     // GIR_Coverage, 9026,
     /*  87265 */     GIR_Done,
     /*  87266 */   // Label 1438: @87266
     /*  87266 */   GIM_Reject,
     /*  87267 */   // Label 1355: @87267
     /*  87267 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(87292), // Rule ID 9022 //
     /*  87272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87275 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  87278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  87281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  87285 */     // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
     /*  87285 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /*  87290 */     GIR_RootConstrainSelectedInstOperands,
     /*  87291 */     // GIR_Coverage, 9022,
     /*  87291 */     GIR_Done,
     /*  87292 */   // Label 1439: @87292
     /*  87292 */   GIM_Reject,
     /*  87293 */   // Label 1356: @87293
     /*  87293 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(87318), // Rule ID 9025 //
     /*  87298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87301 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /*  87304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /*  87307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  87311 */     // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
     /*  87311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /*  87316 */     GIR_RootConstrainSelectedInstOperands,
     /*  87317 */     // GIR_Coverage, 9025,
     /*  87317 */     GIR_Done,
     /*  87318 */   // Label 1440: @87318
     /*  87318 */   GIM_Reject,
     /*  87319 */   // Label 1357: @87319
     /*  87319 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(87344), // Rule ID 9023 //
     /*  87324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87327 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  87330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  87333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  87337 */     // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
     /*  87337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /*  87342 */     GIR_RootConstrainSelectedInstOperands,
     /*  87343 */     // GIR_Coverage, 9023,
     /*  87343 */     GIR_Done,
     /*  87344 */   // Label 1441: @87344
     /*  87344 */   GIM_Reject,
     /*  87345 */   // Label 1358: @87345
     /*  87345 */   GIM_Reject,
     /*  87346 */ // Label 1346: @87346
     /*  87346 */ GIM_Reject,
     /*  87347 */ // Label 9: @87347
     /*  87347 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1456*/ GIMT_Encode4(97290),
     /*  87358 */ /*GILLT_s32*//*Label 1442*/ GIMT_Encode4(87446),
     /*  87362 */ /*GILLT_s64*//*Label 1443*/ GIMT_Encode4(87827),
     /*  87366 */ /*GILLT_s128*//*Label 1444*/ GIMT_Encode4(89802),
     /*  87370 */ /*GILLT_v2s32*//*Label 1445*/ GIMT_Encode4(90448),
     /*  87374 */ /*GILLT_v2s64*//*Label 1446*/ GIMT_Encode4(91363),
     /*  87378 */ /*GILLT_v4s16*//*Label 1447*/ GIMT_Encode4(92132),
     /*  87382 */ /*GILLT_v4s32*//*Label 1448*/ GIMT_Encode4(93047),
     /*  87386 */ /*GILLT_v8s8*//*Label 1449*/ GIMT_Encode4(93892),
     /*  87390 */ /*GILLT_v8s16*//*Label 1450*/ GIMT_Encode4(94453),
     /*  87394 */ /*GILLT_v16s8*//*Label 1451*/ GIMT_Encode4(95298), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  87414 */ /*GILLT_nxv2s64*//*Label 1452*/ GIMT_Encode4(95750), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  87426 */ /*GILLT_nxv4s32*//*Label 1453*/ GIMT_Encode4(96199), GIMT_Encode4(0),
     /*  87434 */ /*GILLT_nxv8s16*//*Label 1454*/ GIMT_Encode4(96648), GIMT_Encode4(0),
     /*  87442 */ /*GILLT_nxv16s8*//*Label 1455*/ GIMT_Encode4(97097),
     /*  87446 */ // Label 1442: @87446
     /*  87446 */ GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(87826),
     /*  87451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  87454 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(87524), // Rule ID 7031 //
     /*  87459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87471 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87474 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87481 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87484 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87490 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  87497 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15825>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  87497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  87500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87522 */     GIR_RootConstrainSelectedInstOperands,
     /*  87523 */     // GIR_Coverage, 7031,
     /*  87523 */     GIR_EraseRootFromParent_Done,
     /*  87524 */   // Label 1458: @87524
     /*  87524 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(87594), // Rule ID 7032 //
     /*  87529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87541 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87544 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87551 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87554 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87558 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87560 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  87567 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15825>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  87567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  87570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87592 */     GIR_RootConstrainSelectedInstOperands,
     /*  87593 */     // GIR_Coverage, 7032,
     /*  87593 */     GIR_EraseRootFromParent_Done,
     /*  87594 */   // Label 1459: @87594
     /*  87594 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(87659), // Rule ID 7033 //
     /*  87599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87611 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87614 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87621 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87624 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87628 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87630 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /*  87637 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15825>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  87637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /*  87640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87652 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87657 */     GIR_RootConstrainSelectedInstOperands,
     /*  87658 */     // GIR_Coverage, 7033,
     /*  87658 */     GIR_EraseRootFromParent_Done,
     /*  87659 */   // Label 1460: @87659
     /*  87659 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(87724), // Rule ID 7034 //
     /*  87664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87676 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87679 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /*  87686 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87689 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87693 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /*  87702 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15825>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  87702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /*  87705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  87717 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87722 */     GIR_RootConstrainSelectedInstOperands,
     /*  87723 */     // GIR_Coverage, 7034,
     /*  87723 */     GIR_EraseRootFromParent_Done,
     /*  87724 */   // Label 1461: @87724
     /*  87724 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(87777), // Rule ID 5741 //
     /*  87729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  87741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  87745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  87749 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  87753 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87755 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
     /*  87755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87760 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
     /*  87766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  87776 */     // GIR_Coverage, 5741,
     /*  87776 */     GIR_EraseRootFromParent_Done,
     /*  87777 */   // Label 1462: @87777
     /*  87777 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(87801), // Rule ID 6644 //
     /*  87782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87790 */     // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
     /*  87790 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87795 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87800 */     // GIR_Coverage, 6644,
     /*  87800 */     GIR_Done,
     /*  87801 */   // Label 1463: @87801
     /*  87801 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(87825), // Rule ID 6645 //
     /*  87806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  87814 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
     /*  87814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  87819 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87824 */     // GIR_Coverage, 6645,
     /*  87824 */     GIR_Done,
     /*  87825 */   // Label 1464: @87825
     /*  87825 */   GIM_Reject,
     /*  87826 */ // Label 1457: @87826
     /*  87826 */ GIM_Reject,
     /*  87827 */ // Label 1443: @87827
     /*  87827 */ GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(87900), // Rule ID 7035 //
     /*  87832 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87839 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87843 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87847 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87850 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  87857 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87860 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87864 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87866 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /*  87873 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15833>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /*  87873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /*  87876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87878 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87883 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87888 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87893 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87898 */   GIR_RootConstrainSelectedInstOperands,
     /*  87899 */   // GIR_Coverage, 7035,
     /*  87899 */   GIR_EraseRootFromParent_Done,
     /*  87900 */ // Label 1465: @87900
     /*  87900 */ GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(87973), // Rule ID 7036 //
     /*  87905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87912 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87916 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87920 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87923 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  87930 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  87933 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  87937 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87939 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /*  87946 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15833>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /*  87946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /*  87949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  87951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  87956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  87961 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  87966 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  87971 */   GIR_RootConstrainSelectedInstOperands,
     /*  87972 */   // GIR_Coverage, 7036,
     /*  87972 */   GIR_EraseRootFromParent_Done,
     /*  87973 */ // Label 1466: @87973
     /*  87973 */ GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(88041), // Rule ID 7037 //
     /*  87978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  87981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  87985 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87989 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  87993 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  87996 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  88003 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  88006 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88010 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88012 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /*  88019 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15833>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /*  88019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /*  88022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  88024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  88029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88034 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88039 */   GIR_RootConstrainSelectedInstOperands,
     /*  88040 */   // GIR_Coverage, 7037,
     /*  88040 */   GIR_EraseRootFromParent_Done,
     /*  88041 */ // Label 1467: @88041
     /*  88041 */ GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(88109), // Rule ID 7038 //
     /*  88046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88053 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88057 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /*  88061 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /*  88064 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /*  88071 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /*  88074 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /*  88078 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88080 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /*  88087 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15833>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /*  88087 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /*  88090 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  88092 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  88097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  88102 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  88107 */   GIR_RootConstrainSelectedInstOperands,
     /*  88108 */   // GIR_Coverage, 7038,
     /*  88108 */   GIR_EraseRootFromParent_Done,
     /*  88109 */ // Label 1468: @88109
     /*  88109 */ GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(88165), // Rule ID 5743 //
     /*  88114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88121 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88125 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  88129 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  88133 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88137 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*  88141 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88143 */   // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
     /*  88143 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88146 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  88148 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /*  88154 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88159 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  88164 */   // GIR_Coverage, 5743,
     /*  88164 */   GIR_EraseRootFromParent_Done,
     /*  88165 */ // Label 1469: @88165
     /*  88165 */ GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(88195), // Rule ID 6619 //
     /*  88170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88184 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
     /*  88184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88189 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88194 */   // GIR_Coverage, 6619,
     /*  88194 */   GIR_Done,
     /*  88195 */ // Label 1470: @88195
     /*  88195 */ GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(88225), // Rule ID 6620 //
     /*  88200 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88214 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
     /*  88214 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88224 */   // GIR_Coverage, 6620,
     /*  88224 */   GIR_Done,
     /*  88225 */ // Label 1471: @88225
     /*  88225 */ GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(88255), // Rule ID 6621 //
     /*  88230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88244 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
     /*  88244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88249 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88254 */   // GIR_Coverage, 6621,
     /*  88254 */   GIR_Done,
     /*  88255 */ // Label 1472: @88255
     /*  88255 */ GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(88285), // Rule ID 6622 //
     /*  88260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88274 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
     /*  88274 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88279 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88284 */   // GIR_Coverage, 6622,
     /*  88284 */   GIR_Done,
     /*  88285 */ // Label 1473: @88285
     /*  88285 */ GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(88315), // Rule ID 6623 //
     /*  88290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88304 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
     /*  88304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88309 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88314 */   // GIR_Coverage, 6623,
     /*  88314 */   GIR_Done,
     /*  88315 */ // Label 1474: @88315
     /*  88315 */ GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(88345), // Rule ID 6624 //
     /*  88320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88334 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  88334 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88339 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88344 */   // GIR_Coverage, 6624,
     /*  88344 */   GIR_Done,
     /*  88345 */ // Label 1475: @88345
     /*  88345 */ GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(88395), // Rule ID 6630 //
     /*  88350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88364 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
     /*  88364 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88367 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88371 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88376 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88380 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  88388 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88390 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88393 */   GIR_RootConstrainSelectedInstOperands,
     /*  88394 */   // GIR_Coverage, 6630,
     /*  88394 */   GIR_EraseRootFromParent_Done,
     /*  88395 */ // Label 1476: @88395
     /*  88395 */ GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(88445), // Rule ID 6631 //
     /*  88400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88414 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
     /*  88414 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88417 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88421 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88426 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88430 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88440 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88443 */   GIR_RootConstrainSelectedInstOperands,
     /*  88444 */   // GIR_Coverage, 6631,
     /*  88444 */   GIR_EraseRootFromParent_Done,
     /*  88445 */ // Label 1477: @88445
     /*  88445 */ GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(88495), // Rule ID 6632 //
     /*  88450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88464 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
     /*  88464 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88467 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88471 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88476 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88480 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88490 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88493 */   GIR_RootConstrainSelectedInstOperands,
     /*  88494 */   // GIR_Coverage, 6632,
     /*  88494 */   GIR_EraseRootFromParent_Done,
     /*  88495 */ // Label 1478: @88495
     /*  88495 */ GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(88545), // Rule ID 6633 //
     /*  88500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88514 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
     /*  88514 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88517 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88521 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88526 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88530 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88540 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88543 */   GIR_RootConstrainSelectedInstOperands,
     /*  88544 */   // GIR_Coverage, 6633,
     /*  88544 */   GIR_EraseRootFromParent_Done,
     /*  88545 */ // Label 1479: @88545
     /*  88545 */ GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(88595), // Rule ID 6634 //
     /*  88550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88560 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88564 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
     /*  88564 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  88567 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88571 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  88576 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /*  88580 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88590 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  88593 */   GIR_RootConstrainSelectedInstOperands,
     /*  88594 */   // GIR_Coverage, 6634,
     /*  88594 */   GIR_EraseRootFromParent_Done,
     /*  88595 */ // Label 1480: @88595
     /*  88595 */ GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(88622), // Rule ID 6635 //
     /*  88600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88607 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88611 */   // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88611 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88616 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88621 */   // GIR_Coverage, 6635,
     /*  88621 */   GIR_Done,
     /*  88622 */ // Label 1481: @88622
     /*  88622 */ GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(88649), // Rule ID 6636 //
     /*  88627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88638 */   // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88638 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88643 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88648 */   // GIR_Coverage, 6636,
     /*  88648 */   GIR_Done,
     /*  88649 */ // Label 1482: @88649
     /*  88649 */ GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(88676), // Rule ID 6637 //
     /*  88654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88665 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
     /*  88665 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88670 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88675 */   // GIR_Coverage, 6637,
     /*  88675 */   GIR_Done,
     /*  88676 */ // Label 1483: @88676
     /*  88676 */ GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(88703), // Rule ID 6646 //
     /*  88681 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88684 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88688 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88692 */   // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  88692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88697 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88702 */   // GIR_Coverage, 6646,
     /*  88702 */   GIR_Done,
     /*  88703 */ // Label 1484: @88703
     /*  88703 */ GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(88730), // Rule ID 6647 //
     /*  88708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88719 */   // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
     /*  88719 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88724 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88729 */   // GIR_Coverage, 6647,
     /*  88729 */   GIR_Done,
     /*  88730 */ // Label 1485: @88730
     /*  88730 */ GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(88757), // Rule ID 6648 //
     /*  88735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88746 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /*  88746 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88751 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88756 */   // GIR_Coverage, 6648,
     /*  88756 */   GIR_Done,
     /*  88757 */ // Label 1486: @88757
     /*  88757 */ GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(88789), // Rule ID 6649 //
     /*  88762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88776 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88779 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88781 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88783 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88788 */   // GIR_Coverage, 6649,
     /*  88788 */   GIR_EraseRootFromParent_Done,
     /*  88789 */ // Label 1487: @88789
     /*  88789 */ GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(88821), // Rule ID 6650 //
     /*  88794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88808 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88811 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88813 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88815 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88820 */   // GIR_Coverage, 6650,
     /*  88820 */   GIR_EraseRootFromParent_Done,
     /*  88821 */ // Label 1488: @88821
     /*  88821 */ GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(88853), // Rule ID 6651 //
     /*  88826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88840 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88843 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88845 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88847 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88852 */   // GIR_Coverage, 6651,
     /*  88852 */   GIR_EraseRootFromParent_Done,
     /*  88853 */ // Label 1489: @88853
     /*  88853 */ GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(88885), // Rule ID 6652 //
     /*  88858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88872 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88875 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88879 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88884 */   // GIR_Coverage, 6652,
     /*  88884 */   GIR_EraseRootFromParent_Done,
     /*  88885 */ // Label 1490: @88885
     /*  88885 */ GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(88917), // Rule ID 6653 //
     /*  88890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  88893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88904 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  88904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  88907 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  88909 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  88911 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88916 */   // GIR_Coverage, 6653,
     /*  88916 */   GIR_EraseRootFromParent_Done,
     /*  88917 */ // Label 1491: @88917
     /*  88917 */ GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(88943), // Rule ID 6654 //
     /*  88922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  88928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88936 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
     /*  88936 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  88941 */   GIR_RootConstrainSelectedInstOperands,
     /*  88942 */   // GIR_Coverage, 6654,
     /*  88942 */   GIR_Done,
     /*  88943 */ // Label 1492: @88943
     /*  88943 */ GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(88969), // Rule ID 6655 //
     /*  88948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  88954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88962 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
     /*  88962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  88967 */   GIR_RootConstrainSelectedInstOperands,
     /*  88968 */   // GIR_Coverage, 6655,
     /*  88968 */   GIR_Done,
     /*  88969 */ // Label 1493: @88969
     /*  88969 */ GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(88995), // Rule ID 6656 //
     /*  88974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  88977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  88980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88988 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
     /*  88988 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  88993 */   GIR_RootConstrainSelectedInstOperands,
     /*  88994 */   // GIR_Coverage, 6656,
     /*  88994 */   GIR_Done,
     /*  88995 */ // Label 1494: @88995
     /*  88995 */ GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(89021), // Rule ID 6657 //
     /*  89000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89014 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
     /*  89014 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89019 */   GIR_RootConstrainSelectedInstOperands,
     /*  89020 */   // GIR_Coverage, 6657,
     /*  89020 */   GIR_Done,
     /*  89021 */ // Label 1495: @89021
     /*  89021 */ GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(89047), // Rule ID 6658 //
     /*  89026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89040 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
     /*  89040 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89045 */   GIR_RootConstrainSelectedInstOperands,
     /*  89046 */   // GIR_Coverage, 6658,
     /*  89046 */   GIR_Done,
     /*  89047 */ // Label 1496: @89047
     /*  89047 */ GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(89076), // Rule ID 6659 //
     /*  89052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89063 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89066 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89068 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89070 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89075 */   // GIR_Coverage, 6659,
     /*  89075 */   GIR_EraseRootFromParent_Done,
     /*  89076 */ // Label 1497: @89076
     /*  89076 */ GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(89105), // Rule ID 6660 //
     /*  89081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89088 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89092 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /*  89092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89095 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89097 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89099 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89104 */   // GIR_Coverage, 6660,
     /*  89104 */   GIR_EraseRootFromParent_Done,
     /*  89105 */ // Label 1498: @89105
     /*  89105 */ GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(89137), // Rule ID 6714 //
     /*  89110 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89124 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89127 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89129 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89131 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89136 */   // GIR_Coverage, 6714,
     /*  89136 */   GIR_EraseRootFromParent_Done,
     /*  89137 */ // Label 1499: @89137
     /*  89137 */ GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(89169), // Rule ID 6715 //
     /*  89142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89156 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89156 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89159 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89161 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89163 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89168 */   // GIR_Coverage, 6715,
     /*  89168 */   GIR_EraseRootFromParent_Done,
     /*  89169 */ // Label 1500: @89169
     /*  89169 */ GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(89201), // Rule ID 6716 //
     /*  89174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89184 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89188 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89188 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89191 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89193 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89195 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89200 */   // GIR_Coverage, 6716,
     /*  89200 */   GIR_EraseRootFromParent_Done,
     /*  89201 */ // Label 1501: @89201
     /*  89201 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(89233), // Rule ID 6717 //
     /*  89206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89220 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89220 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89223 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89225 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89227 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89232 */   // GIR_Coverage, 6717,
     /*  89232 */   GIR_EraseRootFromParent_Done,
     /*  89233 */ // Label 1502: @89233
     /*  89233 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(89265), // Rule ID 6718 //
     /*  89238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89252 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89255 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89257 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89259 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89264 */   // GIR_Coverage, 6718,
     /*  89264 */   GIR_EraseRootFromParent_Done,
     /*  89265 */ // Label 1503: @89265
     /*  89265 */ GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(89291), // Rule ID 6719 //
     /*  89270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89284 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
     /*  89284 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89289 */   GIR_RootConstrainSelectedInstOperands,
     /*  89290 */   // GIR_Coverage, 6719,
     /*  89290 */   GIR_Done,
     /*  89291 */ // Label 1504: @89291
     /*  89291 */ GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(89317), // Rule ID 6720 //
     /*  89296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89310 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
     /*  89310 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89315 */   GIR_RootConstrainSelectedInstOperands,
     /*  89316 */   // GIR_Coverage, 6720,
     /*  89316 */   GIR_Done,
     /*  89317 */ // Label 1505: @89317
     /*  89317 */ GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(89343), // Rule ID 6721 //
     /*  89322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89336 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
     /*  89336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89341 */   GIR_RootConstrainSelectedInstOperands,
     /*  89342 */   // GIR_Coverage, 6721,
     /*  89342 */   GIR_Done,
     /*  89343 */ // Label 1506: @89343
     /*  89343 */ GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(89369), // Rule ID 6722 //
     /*  89348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89362 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
     /*  89362 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  89367 */   GIR_RootConstrainSelectedInstOperands,
     /*  89368 */   // GIR_Coverage, 6722,
     /*  89368 */   GIR_Done,
     /*  89369 */ // Label 1507: @89369
     /*  89369 */ GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(89395), // Rule ID 6723 //
     /*  89374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89388 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
     /*  89388 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89393 */   GIR_RootConstrainSelectedInstOperands,
     /*  89394 */   // GIR_Coverage, 6723,
     /*  89394 */   GIR_Done,
     /*  89395 */ // Label 1508: @89395
     /*  89395 */ GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(89424), // Rule ID 6724 //
     /*  89400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89411 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89411 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89414 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89416 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89418 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89423 */   // GIR_Coverage, 6724,
     /*  89423 */   GIR_EraseRootFromParent_Done,
     /*  89424 */ // Label 1509: @89424
     /*  89424 */ GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(89453), // Rule ID 6725 //
     /*  89429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89440 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /*  89440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89443 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89445 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89447 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89452 */   // GIR_Coverage, 6725,
     /*  89452 */   GIR_EraseRootFromParent_Done,
     /*  89453 */ // Label 1510: @89453
     /*  89453 */ GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(89485), // Rule ID 6726 //
     /*  89458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89472 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89475 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89477 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89479 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89484 */   // GIR_Coverage, 6726,
     /*  89484 */   GIR_EraseRootFromParent_Done,
     /*  89485 */ // Label 1511: @89485
     /*  89485 */ GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(89517), // Rule ID 6727 //
     /*  89490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89504 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89507 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89509 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89511 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89516 */   // GIR_Coverage, 6727,
     /*  89516 */   GIR_EraseRootFromParent_Done,
     /*  89517 */ // Label 1512: @89517
     /*  89517 */ GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(89549), // Rule ID 6728 //
     /*  89522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89536 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89539 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89541 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89543 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89548 */   // GIR_Coverage, 6728,
     /*  89548 */   GIR_EraseRootFromParent_Done,
     /*  89549 */ // Label 1513: @89549
     /*  89549 */ GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(89581), // Rule ID 6729 //
     /*  89554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89568 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89571 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89573 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89575 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89580 */   // GIR_Coverage, 6729,
     /*  89580 */   GIR_EraseRootFromParent_Done,
     /*  89581 */ // Label 1514: @89581
     /*  89581 */ GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(89613), // Rule ID 6730 //
     /*  89586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89600 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89603 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89605 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89607 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89612 */   // GIR_Coverage, 6730,
     /*  89612 */   GIR_EraseRootFromParent_Done,
     /*  89613 */ // Label 1515: @89613
     /*  89613 */ GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(89639), // Rule ID 6731 //
     /*  89618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89632 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
     /*  89632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89637 */   GIR_RootConstrainSelectedInstOperands,
     /*  89638 */   // GIR_Coverage, 6731,
     /*  89638 */   GIR_Done,
     /*  89639 */ // Label 1516: @89639
     /*  89639 */ GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(89665), // Rule ID 6732 //
     /*  89644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89658 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
     /*  89658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89663 */   GIR_RootConstrainSelectedInstOperands,
     /*  89664 */   // GIR_Coverage, 6732,
     /*  89664 */   GIR_Done,
     /*  89665 */ // Label 1517: @89665
     /*  89665 */ GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(89691), // Rule ID 6733 //
     /*  89670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  89676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89684 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
     /*  89684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  89689 */   GIR_RootConstrainSelectedInstOperands,
     /*  89690 */   // GIR_Coverage, 6733,
     /*  89690 */   GIR_Done,
     /*  89691 */ // Label 1518: @89691
     /*  89691 */ GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(89717), // Rule ID 6734 //
     /*  89696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89710 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
     /*  89710 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  89715 */   GIR_RootConstrainSelectedInstOperands,
     /*  89716 */   // GIR_Coverage, 6734,
     /*  89716 */   GIR_Done,
     /*  89717 */ // Label 1519: @89717
     /*  89717 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(89743), // Rule ID 6735 //
     /*  89722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  89725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  89728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89736 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
     /*  89736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  89741 */   GIR_RootConstrainSelectedInstOperands,
     /*  89742 */   // GIR_Coverage, 6735,
     /*  89742 */   GIR_Done,
     /*  89743 */ // Label 1520: @89743
     /*  89743 */ GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(89772), // Rule ID 6736 //
     /*  89748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89759 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89762 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89764 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89766 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89771 */   // GIR_Coverage, 6736,
     /*  89771 */   GIR_EraseRootFromParent_Done,
     /*  89772 */ // Label 1521: @89772
     /*  89772 */ GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(89801), // Rule ID 6737 //
     /*  89777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  89780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89788 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /*  89788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89791 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89793 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89795 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89800 */   // GIR_Coverage, 6737,
     /*  89800 */   GIR_EraseRootFromParent_Done,
     /*  89801 */ // Label 1522: @89801
     /*  89801 */ GIM_Reject,
     /*  89802 */ // Label 1444: @89802
     /*  89802 */ GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(89834), // Rule ID 6751 //
     /*  89807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89821 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89824 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89826 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89828 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89833 */   // GIR_Coverage, 6751,
     /*  89833 */   GIR_EraseRootFromParent_Done,
     /*  89834 */ // Label 1523: @89834
     /*  89834 */ GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(89866), // Rule ID 6752 //
     /*  89839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89853 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89856 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89858 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89860 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89865 */   // GIR_Coverage, 6752,
     /*  89865 */   GIR_EraseRootFromParent_Done,
     /*  89866 */ // Label 1524: @89866
     /*  89866 */ GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(89898), // Rule ID 6753 //
     /*  89871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89885 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89888 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89890 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89892 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89897 */   // GIR_Coverage, 6753,
     /*  89897 */   GIR_EraseRootFromParent_Done,
     /*  89898 */ // Label 1525: @89898
     /*  89898 */ GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(89930), // Rule ID 6754 //
     /*  89903 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89913 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89917 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89920 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89922 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89924 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89929 */   // GIR_Coverage, 6754,
     /*  89929 */   GIR_EraseRootFromParent_Done,
     /*  89930 */ // Label 1526: @89930
     /*  89930 */ GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(89962), // Rule ID 6755 //
     /*  89935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  89941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89949 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89952 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89954 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89956 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89961 */   // GIR_Coverage, 6755,
     /*  89961 */   GIR_EraseRootFromParent_Done,
     /*  89962 */ // Label 1527: @89962
     /*  89962 */ GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(89994), // Rule ID 6756 //
     /*  89967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  89970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  89973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89981 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  89981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  89984 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  89986 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  89988 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89993 */   // GIR_Coverage, 6756,
     /*  89993 */   GIR_EraseRootFromParent_Done,
     /*  89994 */ // Label 1528: @89994
     /*  89994 */ GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(90026), // Rule ID 6757 //
     /*  89999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90013 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /*  90013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90016 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90018 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90020 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90025 */   // GIR_Coverage, 6757,
     /*  90025 */   GIR_EraseRootFromParent_Done,
     /*  90026 */ // Label 1529: @90026
     /*  90026 */ GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(90059), // Rule ID 6758 //
     /*  90031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90045 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
     /*  90045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90050 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90052 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90057 */   GIR_RootConstrainSelectedInstOperands,
     /*  90058 */   // GIR_Coverage, 6758,
     /*  90058 */   GIR_EraseRootFromParent_Done,
     /*  90059 */ // Label 1530: @90059
     /*  90059 */ GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(90130), // Rule ID 6759 //
     /*  90064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90078 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
     /*  90078 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90081 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  90085 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90090 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90096 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90099 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  90103 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90108 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90112 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90119 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90125 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90128 */   GIR_RootConstrainSelectedInstOperands,
     /*  90129 */   // GIR_Coverage, 6759,
     /*  90129 */   GIR_EraseRootFromParent_Done,
     /*  90130 */ // Label 1531: @90130
     /*  90130 */ GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(90201), // Rule ID 6760 //
     /*  90135 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90145 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90149 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
     /*  90149 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90152 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90156 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90161 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90165 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90167 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90170 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90174 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90179 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90183 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90188 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90190 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90193 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90196 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90199 */   GIR_RootConstrainSelectedInstOperands,
     /*  90200 */   // GIR_Coverage, 6760,
     /*  90200 */   GIR_EraseRootFromParent_Done,
     /*  90201 */ // Label 1532: @90201
     /*  90201 */ GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(90272), // Rule ID 6761 //
     /*  90206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  90212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90220 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
     /*  90220 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90223 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90227 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90232 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90236 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90238 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90241 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  90245 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90250 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90254 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90259 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90261 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90264 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90270 */   GIR_RootConstrainSelectedInstOperands,
     /*  90271 */   // GIR_Coverage, 6761,
     /*  90271 */   GIR_EraseRootFromParent_Done,
     /*  90272 */ // Label 1533: @90272
     /*  90272 */ GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(90305), // Rule ID 6762 //
     /*  90277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90291 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
     /*  90291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90294 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90296 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90298 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90300 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90303 */   GIR_RootConstrainSelectedInstOperands,
     /*  90304 */   // GIR_Coverage, 6762,
     /*  90304 */   GIR_EraseRootFromParent_Done,
     /*  90305 */ // Label 1534: @90305
     /*  90305 */ GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(90376), // Rule ID 6763 //
     /*  90310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90324 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
     /*  90324 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90327 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  90331 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90336 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90340 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90342 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90345 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  90349 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90354 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90358 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90365 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90368 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90374 */   GIR_RootConstrainSelectedInstOperands,
     /*  90375 */   // GIR_Coverage, 6763,
     /*  90375 */   GIR_EraseRootFromParent_Done,
     /*  90376 */ // Label 1535: @90376
     /*  90376 */ GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(90447), // Rule ID 6764 //
     /*  90381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  90387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90395 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
     /*  90395 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  90398 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  90402 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90407 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90411 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  90413 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  90416 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  90420 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90425 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  90429 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  90431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  90434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90436 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90439 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  90442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  90445 */   GIR_RootConstrainSelectedInstOperands,
     /*  90446 */   // GIR_Coverage, 6764,
     /*  90446 */   GIR_EraseRootFromParent_Done,
     /*  90447 */ // Label 1536: @90447
     /*  90447 */ GIM_Reject,
     /*  90448 */ // Label 1445: @90448
     /*  90448 */ GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(90478), // Rule ID 6616 //
     /*  90453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90467 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  90467 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90472 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90477 */   // GIR_Coverage, 6616,
     /*  90477 */   GIR_Done,
     /*  90478 */ // Label 1537: @90478
     /*  90478 */ GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(90508), // Rule ID 6618 //
     /*  90483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90497 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  90497 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90502 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90507 */   // GIR_Coverage, 6618,
     /*  90507 */   GIR_Done,
     /*  90508 */ // Label 1538: @90508
     /*  90508 */ GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(90558), // Rule ID 6627 //
     /*  90513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90523 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90527 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  90527 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  90530 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90534 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90539 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  90543 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90553 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90556 */   GIR_RootConstrainSelectedInstOperands,
     /*  90557 */   // GIR_Coverage, 6627,
     /*  90557 */   GIR_EraseRootFromParent_Done,
     /*  90558 */ // Label 1539: @90558
     /*  90558 */ GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(90608), // Rule ID 6629 //
     /*  90563 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  90577 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  90577 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  90580 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90584 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  90589 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  90593 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90603 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  90606 */   GIR_RootConstrainSelectedInstOperands,
     /*  90607 */   // GIR_Coverage, 6629,
     /*  90607 */   GIR_EraseRootFromParent_Done,
     /*  90608 */ // Label 1540: @90608
     /*  90608 */ GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(90640), // Rule ID 6661 //
     /*  90613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90627 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90627 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90630 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90632 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90634 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90639 */   // GIR_Coverage, 6661,
     /*  90639 */   GIR_EraseRootFromParent_Done,
     /*  90640 */ // Label 1541: @90640
     /*  90640 */ GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(90672), // Rule ID 6662 //
     /*  90645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90659 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90662 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90664 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90666 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90671 */   // GIR_Coverage, 6662,
     /*  90671 */   GIR_EraseRootFromParent_Done,
     /*  90672 */ // Label 1542: @90672
     /*  90672 */ GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(90704), // Rule ID 6663 //
     /*  90677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  90683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90691 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90694 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90696 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90698 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90703 */   // GIR_Coverage, 6663,
     /*  90703 */   GIR_EraseRootFromParent_Done,
     /*  90704 */ // Label 1543: @90704
     /*  90704 */ GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(90736), // Rule ID 6664 //
     /*  90709 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90719 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90723 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90726 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90728 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90730 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90735 */   // GIR_Coverage, 6664,
     /*  90735 */   GIR_EraseRootFromParent_Done,
     /*  90736 */ // Label 1544: @90736
     /*  90736 */ GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(90768), // Rule ID 6665 //
     /*  90741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90755 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90758 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90760 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90762 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90767 */   // GIR_Coverage, 6665,
     /*  90767 */   GIR_EraseRootFromParent_Done,
     /*  90768 */ // Label 1545: @90768
     /*  90768 */ GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(90800), // Rule ID 6666 //
     /*  90773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90787 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90790 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90792 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90794 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90799 */   // GIR_Coverage, 6666,
     /*  90799 */   GIR_EraseRootFromParent_Done,
     /*  90800 */ // Label 1546: @90800
     /*  90800 */ GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(90826), // Rule ID 6667 //
     /*  90805 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90808 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90819 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
     /*  90819 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90824 */   GIR_RootConstrainSelectedInstOperands,
     /*  90825 */   // GIR_Coverage, 6667,
     /*  90825 */   GIR_Done,
     /*  90826 */ // Label 1547: @90826
     /*  90826 */ GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(90852), // Rule ID 6668 //
     /*  90831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90845 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
     /*  90845 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  90850 */   GIR_RootConstrainSelectedInstOperands,
     /*  90851 */   // GIR_Coverage, 6668,
     /*  90851 */   GIR_Done,
     /*  90852 */ // Label 1548: @90852
     /*  90852 */ GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(90878), // Rule ID 6669 //
     /*  90857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  90863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90871 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
     /*  90871 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  90876 */   GIR_RootConstrainSelectedInstOperands,
     /*  90877 */   // GIR_Coverage, 6669,
     /*  90877 */   GIR_Done,
     /*  90878 */ // Label 1549: @90878
     /*  90878 */ GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(90904), // Rule ID 6670 //
     /*  90883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90897 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
     /*  90897 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90902 */   GIR_RootConstrainSelectedInstOperands,
     /*  90903 */   // GIR_Coverage, 6670,
     /*  90903 */   GIR_Done,
     /*  90904 */ // Label 1550: @90904
     /*  90904 */ GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(90930), // Rule ID 6671 //
     /*  90909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90923 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
     /*  90923 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  90928 */   GIR_RootConstrainSelectedInstOperands,
     /*  90929 */   // GIR_Coverage, 6671,
     /*  90929 */   GIR_Done,
     /*  90930 */ // Label 1551: @90930
     /*  90930 */ GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(90956), // Rule ID 6672 //
     /*  90935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  90938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90949 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
     /*  90949 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  90954 */   GIR_RootConstrainSelectedInstOperands,
     /*  90955 */   // GIR_Coverage, 6672,
     /*  90955 */   GIR_Done,
     /*  90956 */ // Label 1552: @90956
     /*  90956 */ GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(90985), // Rule ID 6673 //
     /*  90961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  90964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90972 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /*  90972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  90975 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  90977 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  90979 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90984 */   // GIR_Coverage, 6673,
     /*  90984 */   GIR_EraseRootFromParent_Done,
     /*  90985 */ // Label 1553: @90985
     /*  90985 */ GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(91017), // Rule ID 6738 //
     /*  90990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  90993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  90996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91000 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91004 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91007 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91009 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91011 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91016 */   // GIR_Coverage, 6738,
     /*  91016 */   GIR_EraseRootFromParent_Done,
     /*  91017 */ // Label 1554: @91017
     /*  91017 */ GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(91049), // Rule ID 6739 //
     /*  91022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91036 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91039 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91041 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91043 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91048 */   // GIR_Coverage, 6739,
     /*  91048 */   GIR_EraseRootFromParent_Done,
     /*  91049 */ // Label 1555: @91049
     /*  91049 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(91081), // Rule ID 6740 //
     /*  91054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91064 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91068 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91071 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91073 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91075 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91080 */   // GIR_Coverage, 6740,
     /*  91080 */   GIR_EraseRootFromParent_Done,
     /*  91081 */ // Label 1556: @91081
     /*  91081 */ GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(91113), // Rule ID 6741 //
     /*  91086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91100 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91100 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91103 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91105 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91107 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91112 */   // GIR_Coverage, 6741,
     /*  91112 */   GIR_EraseRootFromParent_Done,
     /*  91113 */ // Label 1557: @91113
     /*  91113 */ GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(91145), // Rule ID 6742 //
     /*  91118 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91132 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91135 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91137 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91139 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91144 */   // GIR_Coverage, 6742,
     /*  91144 */   GIR_EraseRootFromParent_Done,
     /*  91145 */ // Label 1558: @91145
     /*  91145 */ GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(91177), // Rule ID 6743 //
     /*  91150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91164 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91167 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91169 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91171 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91176 */   // GIR_Coverage, 6743,
     /*  91176 */   GIR_EraseRootFromParent_Done,
     /*  91177 */ // Label 1559: @91177
     /*  91177 */ GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(91203), // Rule ID 6744 //
     /*  91182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91196 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
     /*  91196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91201 */   GIR_RootConstrainSelectedInstOperands,
     /*  91202 */   // GIR_Coverage, 6744,
     /*  91202 */   GIR_Done,
     /*  91203 */ // Label 1560: @91203
     /*  91203 */ GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(91229), // Rule ID 6745 //
     /*  91208 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91211 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91222 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
     /*  91222 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  91227 */   GIR_RootConstrainSelectedInstOperands,
     /*  91228 */   // GIR_Coverage, 6745,
     /*  91228 */   GIR_Done,
     /*  91229 */ // Label 1561: @91229
     /*  91229 */ GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(91255), // Rule ID 6746 //
     /*  91234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91248 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
     /*  91248 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  91253 */   GIR_RootConstrainSelectedInstOperands,
     /*  91254 */   // GIR_Coverage, 6746,
     /*  91254 */   GIR_Done,
     /*  91255 */ // Label 1562: @91255
     /*  91255 */ GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(91281), // Rule ID 6747 //
     /*  91260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91274 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
     /*  91274 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91279 */   GIR_RootConstrainSelectedInstOperands,
     /*  91280 */   // GIR_Coverage, 6747,
     /*  91280 */   GIR_Done,
     /*  91281 */ // Label 1563: @91281
     /*  91281 */ GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(91307), // Rule ID 6748 //
     /*  91286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  91292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91300 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
     /*  91300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /*  91305 */   GIR_RootConstrainSelectedInstOperands,
     /*  91306 */   // GIR_Coverage, 6748,
     /*  91306 */   GIR_Done,
     /*  91307 */ // Label 1564: @91307
     /*  91307 */ GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(91333), // Rule ID 6749 //
     /*  91312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  91318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91326 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
     /*  91326 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  91331 */   GIR_RootConstrainSelectedInstOperands,
     /*  91332 */   // GIR_Coverage, 6749,
     /*  91332 */   GIR_Done,
     /*  91333 */ // Label 1565: @91333
     /*  91333 */ GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(91362), // Rule ID 6750 //
     /*  91338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  91341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91349 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /*  91349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91352 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91354 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91356 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91361 */   // GIR_Coverage, 6750,
     /*  91361 */   GIR_EraseRootFromParent_Done,
     /*  91362 */ // Label 1566: @91362
     /*  91362 */ GIM_Reject,
     /*  91363 */ // Label 1446: @91363
     /*  91363 */ GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(91395), // Rule ID 6765 //
     /*  91368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91382 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91385 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91387 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91389 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91394 */   // GIR_Coverage, 6765,
     /*  91394 */   GIR_EraseRootFromParent_Done,
     /*  91395 */ // Label 1567: @91395
     /*  91395 */ GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(91427), // Rule ID 6766 //
     /*  91400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91414 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91417 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91419 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91421 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91426 */   // GIR_Coverage, 6766,
     /*  91426 */   GIR_EraseRootFromParent_Done,
     /*  91427 */ // Label 1568: @91427
     /*  91427 */ GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(91459), // Rule ID 6767 //
     /*  91432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91446 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91449 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91451 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91453 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91458 */   // GIR_Coverage, 6767,
     /*  91458 */   GIR_EraseRootFromParent_Done,
     /*  91459 */ // Label 1569: @91459
     /*  91459 */ GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(91491), // Rule ID 6768 //
     /*  91464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91478 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91481 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91483 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91485 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91490 */   // GIR_Coverage, 6768,
     /*  91490 */   GIR_EraseRootFromParent_Done,
     /*  91491 */ // Label 1570: @91491
     /*  91491 */ GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(91523), // Rule ID 6769 //
     /*  91496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91510 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91513 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91515 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91517 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91522 */   // GIR_Coverage, 6769,
     /*  91522 */   GIR_EraseRootFromParent_Done,
     /*  91523 */ // Label 1571: @91523
     /*  91523 */ GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(91555), // Rule ID 6770 //
     /*  91528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91542 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91545 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91547 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91554 */   // GIR_Coverage, 6770,
     /*  91554 */   GIR_EraseRootFromParent_Done,
     /*  91555 */ // Label 1572: @91555
     /*  91555 */ GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(91588), // Rule ID 6771 //
     /*  91560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91574 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  91574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  91577 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91579 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91581 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91583 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  91586 */   GIR_RootConstrainSelectedInstOperands,
     /*  91587 */   // GIR_Coverage, 6771,
     /*  91587 */   GIR_EraseRootFromParent_Done,
     /*  91588 */ // Label 1573: @91588
     /*  91588 */ GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(91614), // Rule ID 6772 //
     /*  91593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91607 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
     /*  91607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91612 */   GIR_RootConstrainSelectedInstOperands,
     /*  91613 */   // GIR_Coverage, 6772,
     /*  91613 */   GIR_Done,
     /*  91614 */ // Label 1574: @91614
     /*  91614 */ GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(91640), // Rule ID 6773 //
     /*  91619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91633 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
     /*  91633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91638 */   GIR_RootConstrainSelectedInstOperands,
     /*  91639 */   // GIR_Coverage, 6773,
     /*  91639 */   GIR_Done,
     /*  91640 */ // Label 1575: @91640
     /*  91640 */ GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(91666), // Rule ID 6774 //
     /*  91645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91655 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91659 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
     /*  91659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  91664 */   GIR_RootConstrainSelectedInstOperands,
     /*  91665 */   // GIR_Coverage, 6774,
     /*  91665 */   GIR_Done,
     /*  91666 */ // Label 1576: @91666
     /*  91666 */ GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(91692), // Rule ID 6775 //
     /*  91671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91681 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91685 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
     /*  91685 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  91690 */   GIR_RootConstrainSelectedInstOperands,
     /*  91691 */   // GIR_Coverage, 6775,
     /*  91691 */   GIR_Done,
     /*  91692 */ // Label 1577: @91692
     /*  91692 */ GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(91718), // Rule ID 6776 //
     /*  91697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91711 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
     /*  91711 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91716 */   GIR_RootConstrainSelectedInstOperands,
     /*  91717 */   // GIR_Coverage, 6776,
     /*  91717 */   GIR_Done,
     /*  91718 */ // Label 1578: @91718
     /*  91718 */ GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(91747), // Rule ID 6777 //
     /*  91723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  91726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91734 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /*  91734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91737 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91739 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91741 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91746 */   // GIR_Coverage, 6777,
     /*  91746 */   GIR_EraseRootFromParent_Done,
     /*  91747 */ // Label 1579: @91747
     /*  91747 */ GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(91779), // Rule ID 6791 //
     /*  91752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91766 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91766 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91769 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91771 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91773 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91778 */   // GIR_Coverage, 6791,
     /*  91778 */   GIR_EraseRootFromParent_Done,
     /*  91779 */ // Label 1580: @91779
     /*  91779 */ GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(91811), // Rule ID 6792 //
     /*  91784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91798 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91801 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91803 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91805 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91810 */   // GIR_Coverage, 6792,
     /*  91810 */   GIR_EraseRootFromParent_Done,
     /*  91811 */ // Label 1581: @91811
     /*  91811 */ GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(91843), // Rule ID 6793 //
     /*  91816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91830 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91830 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91833 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91835 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91837 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91842 */   // GIR_Coverage, 6793,
     /*  91842 */   GIR_EraseRootFromParent_Done,
     /*  91843 */ // Label 1582: @91843
     /*  91843 */ GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(91875), // Rule ID 6794 //
     /*  91848 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  91854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91862 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91865 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91867 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91869 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91874 */   // GIR_Coverage, 6794,
     /*  91874 */   GIR_EraseRootFromParent_Done,
     /*  91875 */ // Label 1583: @91875
     /*  91875 */ GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(91907), // Rule ID 6795 //
     /*  91880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91894 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91897 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91899 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91901 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91906 */   // GIR_Coverage, 6795,
     /*  91906 */   GIR_EraseRootFromParent_Done,
     /*  91907 */ // Label 1584: @91907
     /*  91907 */ GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(91939), // Rule ID 6796 //
     /*  91912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  91915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91926 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  91926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  91929 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  91931 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91933 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91938 */   // GIR_Coverage, 6796,
     /*  91938 */   GIR_EraseRootFromParent_Done,
     /*  91939 */ // Label 1585: @91939
     /*  91939 */ GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(91972), // Rule ID 6797 //
     /*  91944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  91950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91958 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /*  91958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  91961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91963 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91965 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  91967 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  91970 */   GIR_RootConstrainSelectedInstOperands,
     /*  91971 */   // GIR_Coverage, 6797,
     /*  91971 */   GIR_EraseRootFromParent_Done,
     /*  91972 */ // Label 1586: @91972
     /*  91972 */ GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(91998), // Rule ID 6798 //
     /*  91977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  91980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91987 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91991 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
     /*  91991 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  91996 */   GIR_RootConstrainSelectedInstOperands,
     /*  91997 */   // GIR_Coverage, 6798,
     /*  91997 */   GIR_Done,
     /*  91998 */ // Label 1587: @91998
     /*  91998 */ GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(92024), // Rule ID 6799 //
     /*  92003 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92006 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92013 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92017 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
     /*  92017 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  92022 */   GIR_RootConstrainSelectedInstOperands,
     /*  92023 */   // GIR_Coverage, 6799,
     /*  92023 */   GIR_Done,
     /*  92024 */ // Label 1588: @92024
     /*  92024 */ GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(92050), // Rule ID 6800 //
     /*  92029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92043 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
     /*  92043 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  92048 */   GIR_RootConstrainSelectedInstOperands,
     /*  92049 */   // GIR_Coverage, 6800,
     /*  92049 */   GIR_Done,
     /*  92050 */ // Label 1589: @92050
     /*  92050 */ GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(92076), // Rule ID 6801 //
     /*  92055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92065 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92069 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
     /*  92069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  92074 */   GIR_RootConstrainSelectedInstOperands,
     /*  92075 */   // GIR_Coverage, 6801,
     /*  92075 */   GIR_Done,
     /*  92076 */ // Label 1590: @92076
     /*  92076 */ GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(92102), // Rule ID 6802 //
     /*  92081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  92087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92095 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
     /*  92095 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  92100 */   GIR_RootConstrainSelectedInstOperands,
     /*  92101 */   // GIR_Coverage, 6802,
     /*  92101 */   GIR_Done,
     /*  92102 */ // Label 1591: @92102
     /*  92102 */ GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(92131), // Rule ID 6803 //
     /*  92107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92118 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /*  92118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92121 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92123 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92125 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92130 */   // GIR_Coverage, 6803,
     /*  92130 */   GIR_EraseRootFromParent_Done,
     /*  92131 */ // Label 1592: @92131
     /*  92131 */ GIM_Reject,
     /*  92132 */ // Label 1447: @92132
     /*  92132 */ GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(92162), // Rule ID 6615 //
     /*  92137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  92151 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  92151 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92156 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92161 */   // GIR_Coverage, 6615,
     /*  92161 */   GIR_Done,
     /*  92162 */ // Label 1593: @92162
     /*  92162 */ GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(92192), // Rule ID 6617 //
     /*  92167 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  92181 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  92181 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92186 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92191 */   // GIR_Coverage, 6617,
     /*  92191 */   GIR_Done,
     /*  92192 */ // Label 1594: @92192
     /*  92192 */ GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(92242), // Rule ID 6626 //
     /*  92197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  92211 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  92211 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  92214 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92218 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92223 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  92227 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92240 */   GIR_RootConstrainSelectedInstOperands,
     /*  92241 */   // GIR_Coverage, 6626,
     /*  92241 */   GIR_EraseRootFromParent_Done,
     /*  92242 */ // Label 1595: @92242
     /*  92242 */ GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(92292), // Rule ID 6628 //
     /*  92247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  92261 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  92261 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  92264 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92268 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92273 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  92277 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92290 */   GIR_RootConstrainSelectedInstOperands,
     /*  92291 */   // GIR_Coverage, 6628,
     /*  92291 */   GIR_EraseRootFromParent_Done,
     /*  92292 */ // Label 1596: @92292
     /*  92292 */ GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(92324), // Rule ID 6674 //
     /*  92297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92311 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92314 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92316 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92318 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92323 */   // GIR_Coverage, 6674,
     /*  92323 */   GIR_EraseRootFromParent_Done,
     /*  92324 */ // Label 1597: @92324
     /*  92324 */ GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(92356), // Rule ID 6675 //
     /*  92329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92343 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92343 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92346 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92348 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92350 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92355 */   // GIR_Coverage, 6675,
     /*  92355 */   GIR_EraseRootFromParent_Done,
     /*  92356 */ // Label 1598: @92356
     /*  92356 */ GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(92388), // Rule ID 6676 //
     /*  92361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92375 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92378 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92380 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92382 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92387 */   // GIR_Coverage, 6676,
     /*  92387 */   GIR_EraseRootFromParent_Done,
     /*  92388 */ // Label 1599: @92388
     /*  92388 */ GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(92420), // Rule ID 6677 //
     /*  92393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92407 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92410 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92412 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92414 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92419 */   // GIR_Coverage, 6677,
     /*  92419 */   GIR_EraseRootFromParent_Done,
     /*  92420 */ // Label 1600: @92420
     /*  92420 */ GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(92452), // Rule ID 6678 //
     /*  92425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92439 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92439 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92442 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92444 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92446 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92451 */   // GIR_Coverage, 6678,
     /*  92451 */   GIR_EraseRootFromParent_Done,
     /*  92452 */ // Label 1601: @92452
     /*  92452 */ GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(92484), // Rule ID 6679 //
     /*  92457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92471 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92474 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92476 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92478 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92483 */   // GIR_Coverage, 6679,
     /*  92483 */   GIR_EraseRootFromParent_Done,
     /*  92484 */ // Label 1602: @92484
     /*  92484 */ GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(92510), // Rule ID 6680 //
     /*  92489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92503 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
     /*  92503 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92508 */   GIR_RootConstrainSelectedInstOperands,
     /*  92509 */   // GIR_Coverage, 6680,
     /*  92509 */   GIR_Done,
     /*  92510 */ // Label 1603: @92510
     /*  92510 */ GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(92536), // Rule ID 6681 //
     /*  92515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92529 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
     /*  92529 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92534 */   GIR_RootConstrainSelectedInstOperands,
     /*  92535 */   // GIR_Coverage, 6681,
     /*  92535 */   GIR_Done,
     /*  92536 */ // Label 1604: @92536
     /*  92536 */ GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(92562), // Rule ID 6682 //
     /*  92541 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92544 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92555 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
     /*  92555 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  92560 */   GIR_RootConstrainSelectedInstOperands,
     /*  92561 */   // GIR_Coverage, 6682,
     /*  92561 */   GIR_Done,
     /*  92562 */ // Label 1605: @92562
     /*  92562 */ GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(92588), // Rule ID 6683 //
     /*  92567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92573 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92577 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92581 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
     /*  92581 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92586 */   GIR_RootConstrainSelectedInstOperands,
     /*  92587 */   // GIR_Coverage, 6683,
     /*  92587 */   GIR_Done,
     /*  92588 */ // Label 1606: @92588
     /*  92588 */ GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(92614), // Rule ID 6684 //
     /*  92593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92607 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
     /*  92607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92612 */   GIR_RootConstrainSelectedInstOperands,
     /*  92613 */   // GIR_Coverage, 6684,
     /*  92613 */   GIR_Done,
     /*  92614 */ // Label 1607: @92614
     /*  92614 */ GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(92640), // Rule ID 6685 //
     /*  92619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92633 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
     /*  92633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92638 */   GIR_RootConstrainSelectedInstOperands,
     /*  92639 */   // GIR_Coverage, 6685,
     /*  92639 */   GIR_Done,
     /*  92640 */ // Label 1608: @92640
     /*  92640 */ GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(92669), // Rule ID 6686 //
     /*  92645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  92648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92656 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /*  92656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92659 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92661 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92663 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92668 */   // GIR_Coverage, 6686,
     /*  92668 */   GIR_EraseRootFromParent_Done,
     /*  92669 */ // Label 1609: @92669
     /*  92669 */ GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(92701), // Rule ID 6687 //
     /*  92674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92688 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92691 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92693 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92695 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92700 */   // GIR_Coverage, 6687,
     /*  92700 */   GIR_EraseRootFromParent_Done,
     /*  92701 */ // Label 1610: @92701
     /*  92701 */ GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(92733), // Rule ID 6688 //
     /*  92706 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92709 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92716 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92720 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92720 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92723 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92725 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92727 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92732 */   // GIR_Coverage, 6688,
     /*  92732 */   GIR_EraseRootFromParent_Done,
     /*  92733 */ // Label 1611: @92733
     /*  92733 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(92765), // Rule ID 6689 //
     /*  92738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92752 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92755 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92757 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92759 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92764 */   // GIR_Coverage, 6689,
     /*  92764 */   GIR_EraseRootFromParent_Done,
     /*  92765 */ // Label 1612: @92765
     /*  92765 */ GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(92797), // Rule ID 6690 //
     /*  92770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92784 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92787 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92789 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92791 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92796 */   // GIR_Coverage, 6690,
     /*  92796 */   GIR_EraseRootFromParent_Done,
     /*  92797 */ // Label 1613: @92797
     /*  92797 */ GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(92829), // Rule ID 6691 //
     /*  92802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92816 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92816 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92819 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92821 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92823 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92828 */   // GIR_Coverage, 6691,
     /*  92828 */   GIR_EraseRootFromParent_Done,
     /*  92829 */ // Label 1614: @92829
     /*  92829 */ GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(92861), // Rule ID 6692 //
     /*  92834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  92837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92848 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  92848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  92851 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  92853 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  92855 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92860 */   // GIR_Coverage, 6692,
     /*  92860 */   GIR_EraseRootFromParent_Done,
     /*  92861 */ // Label 1615: @92861
     /*  92861 */ GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(92887), // Rule ID 6693 //
     /*  92866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92880 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
     /*  92880 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92885 */   GIR_RootConstrainSelectedInstOperands,
     /*  92886 */   // GIR_Coverage, 6693,
     /*  92886 */   GIR_Done,
     /*  92887 */ // Label 1616: @92887
     /*  92887 */ GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(92913), // Rule ID 6694 //
     /*  92892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92906 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
     /*  92906 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92911 */   GIR_RootConstrainSelectedInstOperands,
     /*  92912 */   // GIR_Coverage, 6694,
     /*  92912 */   GIR_Done,
     /*  92913 */ // Label 1617: @92913
     /*  92913 */ GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(92939), // Rule ID 6695 //
     /*  92918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  92924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92932 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
     /*  92932 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  92937 */   GIR_RootConstrainSelectedInstOperands,
     /*  92938 */   // GIR_Coverage, 6695,
     /*  92938 */   GIR_Done,
     /*  92939 */ // Label 1618: @92939
     /*  92939 */ GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(92965), // Rule ID 6696 //
     /*  92944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  92950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92958 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
     /*  92958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  92963 */   GIR_RootConstrainSelectedInstOperands,
     /*  92964 */   // GIR_Coverage, 6696,
     /*  92964 */   GIR_Done,
     /*  92965 */ // Label 1619: @92965
     /*  92965 */ GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(92991), // Rule ID 6697 //
     /*  92970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  92976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  92984 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
     /*  92984 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /*  92989 */   GIR_RootConstrainSelectedInstOperands,
     /*  92990 */   // GIR_Coverage, 6697,
     /*  92990 */   GIR_Done,
     /*  92991 */ // Label 1620: @92991
     /*  92991 */ GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(93017), // Rule ID 6698 //
     /*  92996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  92999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93010 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
     /*  93010 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /*  93015 */   GIR_RootConstrainSelectedInstOperands,
     /*  93016 */   // GIR_Coverage, 6698,
     /*  93016 */   GIR_Done,
     /*  93017 */ // Label 1621: @93017
     /*  93017 */ GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(93046), // Rule ID 6699 //
     /*  93022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  93025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93033 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /*  93033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93036 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93038 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93040 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93045 */   // GIR_Coverage, 6699,
     /*  93045 */   GIR_EraseRootFromParent_Done,
     /*  93046 */ // Label 1622: @93046
     /*  93046 */ GIM_Reject,
     /*  93047 */ // Label 1448: @93047
     /*  93047 */ GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(93079), // Rule ID 6778 //
     /*  93052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93066 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93069 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93071 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93073 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93078 */   // GIR_Coverage, 6778,
     /*  93078 */   GIR_EraseRootFromParent_Done,
     /*  93079 */ // Label 1623: @93079
     /*  93079 */ GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(93111), // Rule ID 6779 //
     /*  93084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93098 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93101 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93103 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93105 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93110 */   // GIR_Coverage, 6779,
     /*  93110 */   GIR_EraseRootFromParent_Done,
     /*  93111 */ // Label 1624: @93111
     /*  93111 */ GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(93143), // Rule ID 6780 //
     /*  93116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93130 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93133 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93135 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93137 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93142 */   // GIR_Coverage, 6780,
     /*  93142 */   GIR_EraseRootFromParent_Done,
     /*  93143 */ // Label 1625: @93143
     /*  93143 */ GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(93175), // Rule ID 6781 //
     /*  93148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93162 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93165 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93167 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93169 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93174 */   // GIR_Coverage, 6781,
     /*  93174 */   GIR_EraseRootFromParent_Done,
     /*  93175 */ // Label 1626: @93175
     /*  93175 */ GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(93207), // Rule ID 6782 //
     /*  93180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93194 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93197 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93199 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93201 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93206 */   // GIR_Coverage, 6782,
     /*  93206 */   GIR_EraseRootFromParent_Done,
     /*  93207 */ // Label 1627: @93207
     /*  93207 */ GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(93239), // Rule ID 6783 //
     /*  93212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93226 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93229 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93231 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93233 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93238 */   // GIR_Coverage, 6783,
     /*  93238 */   GIR_EraseRootFromParent_Done,
     /*  93239 */ // Label 1628: @93239
     /*  93239 */ GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(93310), // Rule ID 6784 //
     /*  93244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93258 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  93258 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  93261 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93265 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93270 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93276 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  93279 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93283 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93288 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93292 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  93297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93299 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93302 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  93305 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  93308 */   GIR_RootConstrainSelectedInstOperands,
     /*  93309 */   // GIR_Coverage, 6784,
     /*  93309 */   GIR_EraseRootFromParent_Done,
     /*  93310 */ // Label 1629: @93310
     /*  93310 */ GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(93336), // Rule ID 6785 //
     /*  93315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93329 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
     /*  93329 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  93334 */   GIR_RootConstrainSelectedInstOperands,
     /*  93335 */   // GIR_Coverage, 6785,
     /*  93335 */   GIR_Done,
     /*  93336 */ // Label 1630: @93336
     /*  93336 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(93362), // Rule ID 6786 //
     /*  93341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93355 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
     /*  93355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  93360 */   GIR_RootConstrainSelectedInstOperands,
     /*  93361 */   // GIR_Coverage, 6786,
     /*  93361 */   GIR_Done,
     /*  93362 */ // Label 1631: @93362
     /*  93362 */ GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(93388), // Rule ID 6787 //
     /*  93367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93381 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
     /*  93381 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  93386 */   GIR_RootConstrainSelectedInstOperands,
     /*  93387 */   // GIR_Coverage, 6787,
     /*  93387 */   GIR_Done,
     /*  93388 */ // Label 1632: @93388
     /*  93388 */ GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(93414), // Rule ID 6788 //
     /*  93393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93407 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
     /*  93407 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93412 */   GIR_RootConstrainSelectedInstOperands,
     /*  93413 */   // GIR_Coverage, 6788,
     /*  93413 */   GIR_Done,
     /*  93414 */ // Label 1633: @93414
     /*  93414 */ GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(93440), // Rule ID 6789 //
     /*  93419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93433 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
     /*  93433 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93438 */   GIR_RootConstrainSelectedInstOperands,
     /*  93439 */   // GIR_Coverage, 6789,
     /*  93439 */   GIR_Done,
     /*  93440 */ // Label 1634: @93440
     /*  93440 */ GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(93469), // Rule ID 6790 //
     /*  93445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93456 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /*  93456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93459 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93463 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93468 */   // GIR_Coverage, 6790,
     /*  93468 */   GIR_EraseRootFromParent_Done,
     /*  93469 */ // Label 1635: @93469
     /*  93469 */ GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(93501), // Rule ID 6804 //
     /*  93474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93480 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93484 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93488 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93491 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93493 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93495 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93500 */   // GIR_Coverage, 6804,
     /*  93500 */   GIR_EraseRootFromParent_Done,
     /*  93501 */ // Label 1636: @93501
     /*  93501 */ GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(93533), // Rule ID 6805 //
     /*  93506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93520 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93523 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93525 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93532 */   // GIR_Coverage, 6805,
     /*  93532 */   GIR_EraseRootFromParent_Done,
     /*  93533 */ // Label 1637: @93533
     /*  93533 */ GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(93565), // Rule ID 6806 //
     /*  93538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93552 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93552 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93555 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93557 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93559 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93564 */   // GIR_Coverage, 6806,
     /*  93564 */   GIR_EraseRootFromParent_Done,
     /*  93565 */ // Label 1638: @93565
     /*  93565 */ GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(93597), // Rule ID 6807 //
     /*  93570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93584 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93587 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93589 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93591 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93596 */   // GIR_Coverage, 6807,
     /*  93596 */   GIR_EraseRootFromParent_Done,
     /*  93597 */ // Label 1639: @93597
     /*  93597 */ GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(93629), // Rule ID 6808 //
     /*  93602 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93608 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93612 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93616 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93619 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93621 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93623 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93628 */   // GIR_Coverage, 6808,
     /*  93628 */   GIR_EraseRootFromParent_Done,
     /*  93629 */ // Label 1640: @93629
     /*  93629 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(93661), // Rule ID 6809 //
     /*  93634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93637 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93640 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93644 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93648 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93651 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93653 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93655 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93660 */   // GIR_Coverage, 6809,
     /*  93660 */   GIR_EraseRootFromParent_Done,
     /*  93661 */ // Label 1641: @93661
     /*  93661 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(93732), // Rule ID 6810 //
     /*  93666 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  93672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93680 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  93680 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  93683 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93687 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93692 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  93698 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  93701 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93705 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93710 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  93714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93716 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  93719 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93721 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93724 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  93727 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  93730 */   GIR_RootConstrainSelectedInstOperands,
     /*  93731 */   // GIR_Coverage, 6810,
     /*  93731 */   GIR_EraseRootFromParent_Done,
     /*  93732 */ // Label 1642: @93732
     /*  93732 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(93758), // Rule ID 6811 //
     /*  93737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93747 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93751 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
     /*  93751 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93756 */   GIR_RootConstrainSelectedInstOperands,
     /*  93757 */   // GIR_Coverage, 6811,
     /*  93757 */   GIR_Done,
     /*  93758 */ // Label 1643: @93758
     /*  93758 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(93784), // Rule ID 6812 //
     /*  93763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93777 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
     /*  93777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  93782 */   GIR_RootConstrainSelectedInstOperands,
     /*  93783 */   // GIR_Coverage, 6812,
     /*  93783 */   GIR_Done,
     /*  93784 */ // Label 1644: @93784
     /*  93784 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(93810), // Rule ID 6813 //
     /*  93789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  93795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93803 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
     /*  93803 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  93808 */   GIR_RootConstrainSelectedInstOperands,
     /*  93809 */   // GIR_Coverage, 6813,
     /*  93809 */   GIR_Done,
     /*  93810 */ // Label 1645: @93810
     /*  93810 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(93836), // Rule ID 6814 //
     /*  93815 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93818 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  93821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93825 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93829 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
     /*  93829 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /*  93834 */   GIR_RootConstrainSelectedInstOperands,
     /*  93835 */   // GIR_Coverage, 6814,
     /*  93835 */   GIR_Done,
     /*  93836 */ // Label 1646: @93836
     /*  93836 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(93862), // Rule ID 6815 //
     /*  93841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  93844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  93847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93855 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
     /*  93855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  93860 */   GIR_RootConstrainSelectedInstOperands,
     /*  93861 */   // GIR_Coverage, 6815,
     /*  93861 */   GIR_Done,
     /*  93862 */ // Label 1647: @93862
     /*  93862 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(93891), // Rule ID 6816 //
     /*  93867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  93870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93878 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /*  93878 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93881 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  93883 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  93885 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  93890 */   // GIR_Coverage, 6816,
     /*  93890 */   GIR_EraseRootFromParent_Done,
     /*  93891 */ // Label 1648: @93891
     /*  93891 */ GIM_Reject,
     /*  93892 */ // Label 1449: @93892
     /*  93892 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(93966), // Rule ID 5651 //
     /*  93897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93904 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93908 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  93912 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  93916 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  93921 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  93923 */   // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
     /*  93923 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  93926 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
     /*  93930 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  93935 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  93939 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  93941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  93944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  93946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  93949 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  93952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /*  93955 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93960 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  93965 */   // GIR_Coverage, 5651,
     /*  93965 */   GIR_EraseRootFromParent_Done,
     /*  93966 */ // Label 1649: @93966
     /*  93966 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(93996), // Rule ID 6614 //
     /*  93971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  93974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  93977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  93985 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /*  93985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  93990 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  93995 */   // GIR_Coverage, 6614,
     /*  93995 */   GIR_Done,
     /*  93996 */ // Label 1650: @93996
     /*  93996 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(94046), // Rule ID 6625 //
     /*  94001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94011 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  94015 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /*  94015 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  94018 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94022 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94027 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /*  94031 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  94039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94041 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94044 */   GIR_RootConstrainSelectedInstOperands,
     /*  94045 */   // GIR_Coverage, 6625,
     /*  94045 */   GIR_EraseRootFromParent_Done,
     /*  94046 */ // Label 1651: @94046
     /*  94046 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(94078), // Rule ID 6700 //
     /*  94051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94065 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94068 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94070 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94072 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94077 */   // GIR_Coverage, 6700,
     /*  94077 */   GIR_EraseRootFromParent_Done,
     /*  94078 */ // Label 1652: @94078
     /*  94078 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(94110), // Rule ID 6701 //
     /*  94083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  94089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94097 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94100 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94102 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94104 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94109 */   // GIR_Coverage, 6701,
     /*  94109 */   GIR_EraseRootFromParent_Done,
     /*  94110 */ // Label 1653: @94110
     /*  94110 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(94142), // Rule ID 6702 //
     /*  94115 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  94121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94129 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94129 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94132 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94134 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94136 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94141 */   // GIR_Coverage, 6702,
     /*  94141 */   GIR_EraseRootFromParent_Done,
     /*  94142 */ // Label 1654: @94142
     /*  94142 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(94174), // Rule ID 6703 //
     /*  94147 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94161 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94164 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94166 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94168 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94173 */   // GIR_Coverage, 6703,
     /*  94173 */   GIR_EraseRootFromParent_Done,
     /*  94174 */ // Label 1655: @94174
     /*  94174 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(94206), // Rule ID 6704 //
     /*  94179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  94185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94193 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94196 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94198 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94200 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94205 */   // GIR_Coverage, 6704,
     /*  94205 */   GIR_EraseRootFromParent_Done,
     /*  94206 */ // Label 1656: @94206
     /*  94206 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(94238), // Rule ID 6705 //
     /*  94211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94225 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94225 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94228 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94230 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94232 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94237 */   // GIR_Coverage, 6705,
     /*  94237 */   GIR_EraseRootFromParent_Done,
     /*  94238 */ // Label 1657: @94238
     /*  94238 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(94270), // Rule ID 6706 //
     /*  94243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  94249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94257 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /*  94257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94260 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94262 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94264 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94269 */   // GIR_Coverage, 6706,
     /*  94269 */   GIR_EraseRootFromParent_Done,
     /*  94270 */ // Label 1658: @94270
     /*  94270 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(94296), // Rule ID 6707 //
     /*  94275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94289 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
     /*  94289 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  94294 */   GIR_RootConstrainSelectedInstOperands,
     /*  94295 */   // GIR_Coverage, 6707,
     /*  94295 */   GIR_Done,
     /*  94296 */ // Label 1659: @94296
     /*  94296 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(94322), // Rule ID 6708 //
     /*  94301 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  94307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94315 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
     /*  94315 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  94320 */   GIR_RootConstrainSelectedInstOperands,
     /*  94321 */   // GIR_Coverage, 6708,
     /*  94321 */   GIR_Done,
     /*  94322 */ // Label 1660: @94322
     /*  94322 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(94348), // Rule ID 6709 //
     /*  94327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  94333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94341 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
     /*  94341 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  94346 */   GIR_RootConstrainSelectedInstOperands,
     /*  94347 */   // GIR_Coverage, 6709,
     /*  94347 */   GIR_Done,
     /*  94348 */ // Label 1661: @94348
     /*  94348 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(94374), // Rule ID 6710 //
     /*  94353 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94367 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
     /*  94367 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  94372 */   GIR_RootConstrainSelectedInstOperands,
     /*  94373 */   // GIR_Coverage, 6710,
     /*  94373 */   GIR_Done,
     /*  94374 */ // Label 1662: @94374
     /*  94374 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(94400), // Rule ID 6711 //
     /*  94379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  94385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94393 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
     /*  94393 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /*  94398 */   GIR_RootConstrainSelectedInstOperands,
     /*  94399 */   // GIR_Coverage, 6711,
     /*  94399 */   GIR_Done,
     /*  94400 */ // Label 1663: @94400
     /*  94400 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(94426), // Rule ID 6712 //
     /*  94405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  94411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94419 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
     /*  94419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /*  94424 */   GIR_RootConstrainSelectedInstOperands,
     /*  94425 */   // GIR_Coverage, 6712,
     /*  94425 */   GIR_Done,
     /*  94426 */ // Label 1664: @94426
     /*  94426 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(94452), // Rule ID 6713 //
     /*  94431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  94437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  94445 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
     /*  94445 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /*  94450 */   GIR_RootConstrainSelectedInstOperands,
     /*  94451 */   // GIR_Coverage, 6713,
     /*  94451 */   GIR_Done,
     /*  94452 */ // Label 1665: @94452
     /*  94452 */ GIM_Reject,
     /*  94453 */ // Label 1450: @94453
     /*  94453 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(94485), // Rule ID 6817 //
     /*  94458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94468 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94472 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94472 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94475 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94477 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94479 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94484 */   // GIR_Coverage, 6817,
     /*  94484 */   GIR_EraseRootFromParent_Done,
     /*  94485 */ // Label 1666: @94485
     /*  94485 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(94517), // Rule ID 6818 //
     /*  94490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94504 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94504 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94507 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94509 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94511 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94516 */   // GIR_Coverage, 6818,
     /*  94516 */   GIR_EraseRootFromParent_Done,
     /*  94517 */ // Label 1667: @94517
     /*  94517 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(94549), // Rule ID 6819 //
     /*  94522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94532 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94536 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94539 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94541 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94543 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94548 */   // GIR_Coverage, 6819,
     /*  94548 */   GIR_EraseRootFromParent_Done,
     /*  94549 */ // Label 1668: @94549
     /*  94549 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(94581), // Rule ID 6820 //
     /*  94554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94564 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94568 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94571 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94573 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94575 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94580 */   // GIR_Coverage, 6820,
     /*  94580 */   GIR_EraseRootFromParent_Done,
     /*  94581 */ // Label 1669: @94581
     /*  94581 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(94613), // Rule ID 6821 //
     /*  94586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94600 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94603 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94605 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94607 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94612 */   // GIR_Coverage, 6821,
     /*  94612 */   GIR_EraseRootFromParent_Done,
     /*  94613 */ // Label 1670: @94613
     /*  94613 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(94645), // Rule ID 6822 //
     /*  94618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94632 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94635 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94637 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94639 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94644 */   // GIR_Coverage, 6822,
     /*  94644 */   GIR_EraseRootFromParent_Done,
     /*  94645 */ // Label 1671: @94645
     /*  94645 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(94716), // Rule ID 6823 //
     /*  94650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94664 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  94664 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  94667 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94671 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94676 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94680 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  94682 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  94685 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94689 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94694 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  94698 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  94703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94705 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94708 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  94711 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  94714 */   GIR_RootConstrainSelectedInstOperands,
     /*  94715 */   // GIR_Coverage, 6823,
     /*  94715 */   GIR_EraseRootFromParent_Done,
     /*  94716 */ // Label 1672: @94716
     /*  94716 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(94742), // Rule ID 6824 //
     /*  94721 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94735 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
     /*  94735 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94740 */   GIR_RootConstrainSelectedInstOperands,
     /*  94741 */   // GIR_Coverage, 6824,
     /*  94741 */   GIR_Done,
     /*  94742 */ // Label 1673: @94742
     /*  94742 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(94768), // Rule ID 6825 //
     /*  94747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94761 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
     /*  94761 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94766 */   GIR_RootConstrainSelectedInstOperands,
     /*  94767 */   // GIR_Coverage, 6825,
     /*  94767 */   GIR_Done,
     /*  94768 */ // Label 1674: @94768
     /*  94768 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(94794), // Rule ID 6826 //
     /*  94773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94787 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
     /*  94787 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  94792 */   GIR_RootConstrainSelectedInstOperands,
     /*  94793 */   // GIR_Coverage, 6826,
     /*  94793 */   GIR_Done,
     /*  94794 */ // Label 1675: @94794
     /*  94794 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(94820), // Rule ID 6827 //
     /*  94799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94813 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
     /*  94813 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  94818 */   GIR_RootConstrainSelectedInstOperands,
     /*  94819 */   // GIR_Coverage, 6827,
     /*  94819 */   GIR_Done,
     /*  94820 */ // Label 1676: @94820
     /*  94820 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(94846), // Rule ID 6828 //
     /*  94825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  94828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94839 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
     /*  94839 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  94844 */   GIR_RootConstrainSelectedInstOperands,
     /*  94845 */   // GIR_Coverage, 6828,
     /*  94845 */   GIR_Done,
     /*  94846 */ // Label 1677: @94846
     /*  94846 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(94875), // Rule ID 6829 //
     /*  94851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  94854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94862 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /*  94862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94865 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94867 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94869 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94874 */   // GIR_Coverage, 6829,
     /*  94874 */   GIR_EraseRootFromParent_Done,
     /*  94875 */ // Label 1678: @94875
     /*  94875 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(94907), // Rule ID 6830 //
     /*  94880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  94886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94894 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94897 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94899 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94901 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94906 */   // GIR_Coverage, 6830,
     /*  94906 */   GIR_EraseRootFromParent_Done,
     /*  94907 */ // Label 1679: @94907
     /*  94907 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(94939), // Rule ID 6831 //
     /*  94912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  94918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94926 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94929 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94931 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94933 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94938 */   // GIR_Coverage, 6831,
     /*  94938 */   GIR_EraseRootFromParent_Done,
     /*  94939 */ // Label 1680: @94939
     /*  94939 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(94971), // Rule ID 6832 //
     /*  94944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  94950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94958 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94961 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94963 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94965 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94970 */   // GIR_Coverage, 6832,
     /*  94970 */   GIR_EraseRootFromParent_Done,
     /*  94971 */ // Label 1681: @94971
     /*  94971 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(95003), // Rule ID 6833 //
     /*  94976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  94979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  94982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  94990 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  94990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  94993 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  94995 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  94997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95002 */   // GIR_Coverage, 6833,
     /*  95002 */   GIR_EraseRootFromParent_Done,
     /*  95003 */ // Label 1682: @95003
     /*  95003 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(95035), // Rule ID 6834 //
     /*  95008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95022 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95025 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95027 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95029 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95034 */   // GIR_Coverage, 6834,
     /*  95034 */   GIR_EraseRootFromParent_Done,
     /*  95035 */ // Label 1683: @95035
     /*  95035 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(95067), // Rule ID 6835 //
     /*  95040 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95043 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95046 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95054 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95057 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95059 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95061 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95066 */   // GIR_Coverage, 6835,
     /*  95066 */   GIR_EraseRootFromParent_Done,
     /*  95067 */ // Label 1684: @95067
     /*  95067 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(95138), // Rule ID 6836 //
     /*  95072 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  95078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95086 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  95086 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  95089 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  95093 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95098 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95102 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95104 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  95107 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  95111 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95116 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95120 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  95125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  95127 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95130 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  95133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  95136 */   GIR_RootConstrainSelectedInstOperands,
     /*  95137 */   // GIR_Coverage, 6836,
     /*  95137 */   GIR_EraseRootFromParent_Done,
     /*  95138 */ // Label 1685: @95138
     /*  95138 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(95164), // Rule ID 6837 //
     /*  95143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95157 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
     /*  95157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  95162 */   GIR_RootConstrainSelectedInstOperands,
     /*  95163 */   // GIR_Coverage, 6837,
     /*  95163 */   GIR_Done,
     /*  95164 */ // Label 1686: @95164
     /*  95164 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(95190), // Rule ID 6838 //
     /*  95169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95179 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95183 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
     /*  95183 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  95188 */   GIR_RootConstrainSelectedInstOperands,
     /*  95189 */   // GIR_Coverage, 6838,
     /*  95189 */   GIR_Done,
     /*  95190 */ // Label 1687: @95190
     /*  95190 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(95216), // Rule ID 6839 //
     /*  95195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  95201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95209 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
     /*  95209 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  95214 */   GIR_RootConstrainSelectedInstOperands,
     /*  95215 */   // GIR_Coverage, 6839,
     /*  95215 */   GIR_Done,
     /*  95216 */ // Label 1688: @95216
     /*  95216 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(95242), // Rule ID 6840 //
     /*  95221 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95235 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
     /*  95235 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /*  95240 */   GIR_RootConstrainSelectedInstOperands,
     /*  95241 */   // GIR_Coverage, 6840,
     /*  95241 */   GIR_Done,
     /*  95242 */ // Label 1689: @95242
     /*  95242 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(95268), // Rule ID 6841 //
     /*  95247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95261 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
     /*  95261 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /*  95266 */   GIR_RootConstrainSelectedInstOperands,
     /*  95267 */   // GIR_Coverage, 6841,
     /*  95267 */   GIR_Done,
     /*  95268 */ // Label 1690: @95268
     /*  95268 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(95297), // Rule ID 6842 //
     /*  95273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95284 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /*  95284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95287 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95289 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95291 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95296 */   // GIR_Coverage, 6842,
     /*  95296 */   GIR_EraseRootFromParent_Done,
     /*  95297 */ // Label 1691: @95297
     /*  95297 */ GIM_Reject,
     /*  95298 */ // Label 1451: @95298
     /*  95298 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(95330), // Rule ID 6843 //
     /*  95303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  95309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95317 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95320 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95322 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95324 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95329 */   // GIR_Coverage, 6843,
     /*  95329 */   GIR_EraseRootFromParent_Done,
     /*  95330 */ // Label 1692: @95330
     /*  95330 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(95362), // Rule ID 6844 //
     /*  95335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95349 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95352 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95354 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95356 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95361 */   // GIR_Coverage, 6844,
     /*  95361 */   GIR_EraseRootFromParent_Done,
     /*  95362 */ // Label 1693: @95362
     /*  95362 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(95394), // Rule ID 6845 //
     /*  95367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95381 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95384 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95386 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95388 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95393 */   // GIR_Coverage, 6845,
     /*  95393 */   GIR_EraseRootFromParent_Done,
     /*  95394 */ // Label 1694: @95394
     /*  95394 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(95426), // Rule ID 6846 //
     /*  95399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95413 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95416 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95418 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95420 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95425 */   // GIR_Coverage, 6846,
     /*  95425 */   GIR_EraseRootFromParent_Done,
     /*  95426 */ // Label 1695: @95426
     /*  95426 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(95458), // Rule ID 6847 //
     /*  95431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95445 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95445 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95448 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95450 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95452 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95457 */   // GIR_Coverage, 6847,
     /*  95457 */   GIR_EraseRootFromParent_Done,
     /*  95458 */ // Label 1696: @95458
     /*  95458 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(95490), // Rule ID 6848 //
     /*  95463 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95477 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95480 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95482 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95484 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95489 */   // GIR_Coverage, 6848,
     /*  95489 */   GIR_EraseRootFromParent_Done,
     /*  95490 */ // Label 1697: @95490
     /*  95490 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(95522), // Rule ID 6849 //
     /*  95495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95509 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /*  95509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95512 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95514 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95516 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95521 */   // GIR_Coverage, 6849,
     /*  95521 */   GIR_EraseRootFromParent_Done,
     /*  95522 */ // Label 1698: @95522
     /*  95522 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(95593), // Rule ID 6850 //
     /*  95527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /*  95533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95541 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /*  95541 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  95544 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95548 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95553 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95557 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  95559 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  95562 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95566 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95571 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /*  95575 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95577 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /*  95580 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  95582 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95585 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  95588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /*  95591 */   GIR_RootConstrainSelectedInstOperands,
     /*  95592 */   // GIR_Coverage, 6850,
     /*  95592 */   GIR_EraseRootFromParent_Done,
     /*  95593 */ // Label 1699: @95593
     /*  95593 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(95619), // Rule ID 6851 //
     /*  95598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95612 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
     /*  95612 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95617 */   GIR_RootConstrainSelectedInstOperands,
     /*  95618 */   // GIR_Coverage, 6851,
     /*  95618 */   GIR_Done,
     /*  95619 */ // Label 1700: @95619
     /*  95619 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(95645), // Rule ID 6852 //
     /*  95624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95638 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
     /*  95638 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  95643 */   GIR_RootConstrainSelectedInstOperands,
     /*  95644 */   // GIR_Coverage, 6852,
     /*  95644 */   GIR_Done,
     /*  95645 */ // Label 1701: @95645
     /*  95645 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(95671), // Rule ID 6853 //
     /*  95650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95664 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
     /*  95664 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  95669 */   GIR_RootConstrainSelectedInstOperands,
     /*  95670 */   // GIR_Coverage, 6853,
     /*  95670 */   GIR_Done,
     /*  95671 */ // Label 1702: @95671
     /*  95671 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(95697), // Rule ID 6854 //
     /*  95676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  95682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95686 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95690 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
     /*  95690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /*  95695 */   GIR_RootConstrainSelectedInstOperands,
     /*  95696 */   // GIR_Coverage, 6854,
     /*  95696 */   GIR_Done,
     /*  95697 */ // Label 1703: @95697
     /*  95697 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(95723), // Rule ID 6855 //
     /*  95702 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95705 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  95708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95716 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
     /*  95716 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /*  95721 */   GIR_RootConstrainSelectedInstOperands,
     /*  95722 */   // GIR_Coverage, 6855,
     /*  95722 */   GIR_Done,
     /*  95723 */ // Label 1704: @95723
     /*  95723 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(95749), // Rule ID 6856 //
     /*  95728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /*  95731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  95734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  95742 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
     /*  95742 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /*  95747 */   GIR_RootConstrainSelectedInstOperands,
     /*  95748 */   // GIR_Coverage, 6856,
     /*  95748 */   GIR_Done,
     /*  95749 */ // Label 1705: @95749
     /*  95749 */ GIM_Reject,
     /*  95750 */ // Label 1452: @95750
     /*  95750 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(95782), // Rule ID 10509 //
     /*  95755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95769 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95772 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95774 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95776 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95781 */   // GIR_Coverage, 10509,
     /*  95781 */   GIR_EraseRootFromParent_Done,
     /*  95782 */ // Label 1706: @95782
     /*  95782 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(95814), // Rule ID 10510 //
     /*  95787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95801 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95804 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95806 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95808 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95813 */   // GIR_Coverage, 10510,
     /*  95813 */   GIR_EraseRootFromParent_Done,
     /*  95814 */ // Label 1707: @95814
     /*  95814 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(95846), // Rule ID 10511 //
     /*  95819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95833 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95836 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95838 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95840 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95845 */   // GIR_Coverage, 10511,
     /*  95845 */   GIR_EraseRootFromParent_Done,
     /*  95846 */ // Label 1708: @95846
     /*  95846 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(95878), // Rule ID 10512 //
     /*  95851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95865 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95868 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95870 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95872 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95877 */   // GIR_Coverage, 10512,
     /*  95877 */   GIR_EraseRootFromParent_Done,
     /*  95878 */ // Label 1709: @95878
     /*  95878 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(95910), // Rule ID 10513 //
     /*  95883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95897 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95900 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95902 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95904 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95909 */   // GIR_Coverage, 10513,
     /*  95909 */   GIR_EraseRootFromParent_Done,
     /*  95910 */ // Label 1710: @95910
     /*  95910 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(95942), // Rule ID 10514 //
     /*  95915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  95921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95929 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  95929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95932 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95934 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95936 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95941 */   // GIR_Coverage, 10514,
     /*  95941 */   GIR_EraseRootFromParent_Done,
     /*  95942 */ // Label 1711: @95942
     /*  95942 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(95974), // Rule ID 10527 //
     /*  95947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  95953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95961 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95964 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95966 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  95968 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95973 */   // GIR_Coverage, 10527,
     /*  95973 */   GIR_EraseRootFromParent_Done,
     /*  95974 */ // Label 1712: @95974
     /*  95974 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(96006), // Rule ID 10528 //
     /*  95979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  95982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95993 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  95993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  95996 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  95998 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96000 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96005 */   // GIR_Coverage, 10528,
     /*  96005 */   GIR_EraseRootFromParent_Done,
     /*  96006 */ // Label 1713: @96006
     /*  96006 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(96038), // Rule ID 10529 //
     /*  96011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96025 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96028 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96030 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96032 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96037 */   // GIR_Coverage, 10529,
     /*  96037 */   GIR_EraseRootFromParent_Done,
     /*  96038 */ // Label 1714: @96038
     /*  96038 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(96070), // Rule ID 10530 //
     /*  96043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96057 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96060 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96062 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96064 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96069 */   // GIR_Coverage, 10530,
     /*  96069 */   GIR_EraseRootFromParent_Done,
     /*  96070 */ // Label 1715: @96070
     /*  96070 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(96102), // Rule ID 10531 //
     /*  96075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96089 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96092 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96094 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96101 */   // GIR_Coverage, 10531,
     /*  96101 */   GIR_EraseRootFromParent_Done,
     /*  96102 */ // Label 1716: @96102
     /*  96102 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(96134), // Rule ID 10532 //
     /*  96107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96121 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96124 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96126 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96128 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96133 */   // GIR_Coverage, 10532,
     /*  96133 */   GIR_EraseRootFromParent_Done,
     /*  96134 */ // Label 1717: @96134
     /*  96134 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(96166), // Rule ID 10537 //
     /*  96139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96153 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /*  96153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96156 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96158 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96160 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96165 */   // GIR_Coverage, 10537,
     /*  96165 */   GIR_EraseRootFromParent_Done,
     /*  96166 */ // Label 1718: @96166
     /*  96166 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(96198), // Rule ID 10538 //
     /*  96171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96185 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /*  96185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96188 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96190 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96197 */   // GIR_Coverage, 10538,
     /*  96197 */   GIR_EraseRootFromParent_Done,
     /*  96198 */ // Label 1719: @96198
     /*  96198 */ GIM_Reject,
     /*  96199 */ // Label 1453: @96199
     /*  96199 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(96231), // Rule ID 10503 //
     /*  96204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96218 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96221 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96223 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96225 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96230 */   // GIR_Coverage, 10503,
     /*  96230 */   GIR_EraseRootFromParent_Done,
     /*  96231 */ // Label 1720: @96231
     /*  96231 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(96263), // Rule ID 10504 //
     /*  96236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96250 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96253 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96255 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96257 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96262 */   // GIR_Coverage, 10504,
     /*  96262 */   GIR_EraseRootFromParent_Done,
     /*  96263 */ // Label 1721: @96263
     /*  96263 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(96295), // Rule ID 10505 //
     /*  96268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96282 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96285 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96287 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96289 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96294 */   // GIR_Coverage, 10505,
     /*  96294 */   GIR_EraseRootFromParent_Done,
     /*  96295 */ // Label 1722: @96295
     /*  96295 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(96327), // Rule ID 10506 //
     /*  96300 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96306 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96310 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96314 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96314 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96317 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96319 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96321 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96326 */   // GIR_Coverage, 10506,
     /*  96326 */   GIR_EraseRootFromParent_Done,
     /*  96327 */ // Label 1723: @96327
     /*  96327 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(96359), // Rule ID 10507 //
     /*  96332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96346 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96349 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96351 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96353 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96358 */   // GIR_Coverage, 10507,
     /*  96358 */   GIR_EraseRootFromParent_Done,
     /*  96359 */ // Label 1724: @96359
     /*  96359 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(96391), // Rule ID 10508 //
     /*  96364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96378 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96381 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96383 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96385 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96390 */   // GIR_Coverage, 10508,
     /*  96390 */   GIR_EraseRootFromParent_Done,
     /*  96391 */ // Label 1725: @96391
     /*  96391 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(96423), // Rule ID 10521 //
     /*  96396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96410 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96410 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96413 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96415 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96417 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96422 */   // GIR_Coverage, 10521,
     /*  96422 */   GIR_EraseRootFromParent_Done,
     /*  96423 */ // Label 1726: @96423
     /*  96423 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(96455), // Rule ID 10522 //
     /*  96428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96438 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96442 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96445 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96447 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96449 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96454 */   // GIR_Coverage, 10522,
     /*  96454 */   GIR_EraseRootFromParent_Done,
     /*  96455 */ // Label 1727: @96455
     /*  96455 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(96487), // Rule ID 10523 //
     /*  96460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96474 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96477 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96479 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96481 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96486 */   // GIR_Coverage, 10523,
     /*  96486 */   GIR_EraseRootFromParent_Done,
     /*  96487 */ // Label 1728: @96487
     /*  96487 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(96519), // Rule ID 10524 //
     /*  96492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96506 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96509 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96511 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96513 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96518 */   // GIR_Coverage, 10524,
     /*  96518 */   GIR_EraseRootFromParent_Done,
     /*  96519 */ // Label 1729: @96519
     /*  96519 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(96551), // Rule ID 10525 //
     /*  96524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96534 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96538 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96541 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96543 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96545 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96550 */   // GIR_Coverage, 10525,
     /*  96550 */   GIR_EraseRootFromParent_Done,
     /*  96551 */ // Label 1730: @96551
     /*  96551 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(96583), // Rule ID 10526 //
     /*  96556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96570 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96573 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96575 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96577 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96582 */   // GIR_Coverage, 10526,
     /*  96582 */   GIR_EraseRootFromParent_Done,
     /*  96583 */ // Label 1731: @96583
     /*  96583 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(96615), // Rule ID 10535 //
     /*  96588 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96602 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /*  96602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96605 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96607 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96609 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96614 */   // GIR_Coverage, 10535,
     /*  96614 */   GIR_EraseRootFromParent_Done,
     /*  96615 */ // Label 1732: @96615
     /*  96615 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(96647), // Rule ID 10536 //
     /*  96620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  96623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96634 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /*  96634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96637 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96639 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96641 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96646 */   // GIR_Coverage, 10536,
     /*  96646 */   GIR_EraseRootFromParent_Done,
     /*  96647 */ // Label 1733: @96647
     /*  96647 */ GIM_Reject,
     /*  96648 */ // Label 1454: @96648
     /*  96648 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(96680), // Rule ID 10497 //
     /*  96653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96667 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96667 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96670 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96672 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96674 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96679 */   // GIR_Coverage, 10497,
     /*  96679 */   GIR_EraseRootFromParent_Done,
     /*  96680 */ // Label 1734: @96680
     /*  96680 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(96712), // Rule ID 10498 //
     /*  96685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96695 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96699 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96699 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96702 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96704 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96706 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96711 */   // GIR_Coverage, 10498,
     /*  96711 */   GIR_EraseRootFromParent_Done,
     /*  96712 */ // Label 1735: @96712
     /*  96712 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(96744), // Rule ID 10499 //
     /*  96717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96731 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96734 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96736 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96738 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96743 */   // GIR_Coverage, 10499,
     /*  96743 */   GIR_EraseRootFromParent_Done,
     /*  96744 */ // Label 1736: @96744
     /*  96744 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(96776), // Rule ID 10500 //
     /*  96749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96763 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96766 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96768 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96770 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96775 */   // GIR_Coverage, 10500,
     /*  96775 */   GIR_EraseRootFromParent_Done,
     /*  96776 */ // Label 1737: @96776
     /*  96776 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(96808), // Rule ID 10501 //
     /*  96781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96795 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96798 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96800 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96802 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96807 */   // GIR_Coverage, 10501,
     /*  96807 */   GIR_EraseRootFromParent_Done,
     /*  96808 */ // Label 1738: @96808
     /*  96808 */ GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(96840), // Rule ID 10502 //
     /*  96813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96827 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  96827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96830 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96832 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96834 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96839 */   // GIR_Coverage, 10502,
     /*  96839 */   GIR_EraseRootFromParent_Done,
     /*  96840 */ // Label 1739: @96840
     /*  96840 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(96872), // Rule ID 10515 //
     /*  96845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  96851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96859 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96862 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96864 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96866 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96871 */   // GIR_Coverage, 10515,
     /*  96871 */   GIR_EraseRootFromParent_Done,
     /*  96872 */ // Label 1740: @96872
     /*  96872 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(96904), // Rule ID 10516 //
     /*  96877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96891 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96894 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96896 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96898 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96903 */   // GIR_Coverage, 10516,
     /*  96903 */   GIR_EraseRootFromParent_Done,
     /*  96904 */ // Label 1741: @96904
     /*  96904 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(96936), // Rule ID 10517 //
     /*  96909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96923 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96926 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96928 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96930 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96935 */   // GIR_Coverage, 10517,
     /*  96935 */   GIR_EraseRootFromParent_Done,
     /*  96936 */ // Label 1742: @96936
     /*  96936 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(96968), // Rule ID 10518 //
     /*  96941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  96947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96955 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96958 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96960 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96962 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96967 */   // GIR_Coverage, 10518,
     /*  96967 */   GIR_EraseRootFromParent_Done,
     /*  96968 */ // Label 1743: @96968
     /*  96968 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(97000), // Rule ID 10519 //
     /*  96973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  96976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  96979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96987 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  96987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  96990 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  96992 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  96994 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  96999 */   // GIR_Coverage, 10519,
     /*  96999 */   GIR_EraseRootFromParent_Done,
     /*  97000 */ // Label 1744: @97000
     /*  97000 */ GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(97032), // Rule ID 10520 //
     /*  97005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  97008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  97011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97019 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97022 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97024 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97026 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97031 */   // GIR_Coverage, 10520,
     /*  97031 */   GIR_EraseRootFromParent_Done,
     /*  97032 */ // Label 1745: @97032
     /*  97032 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(97064), // Rule ID 10533 //
     /*  97037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  97040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97051 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /*  97051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97054 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97056 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97058 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97063 */   // GIR_Coverage, 10533,
     /*  97063 */   GIR_EraseRootFromParent_Done,
     /*  97064 */ // Label 1746: @97064
     /*  97064 */ GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(97096), // Rule ID 10534 //
     /*  97069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  97072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97079 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97083 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /*  97083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97086 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97088 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97090 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97095 */   // GIR_Coverage, 10534,
     /*  97095 */   GIR_EraseRootFromParent_Done,
     /*  97096 */ // Label 1747: @97096
     /*  97096 */ GIM_Reject,
     /*  97097 */ // Label 1455: @97097
     /*  97097 */ GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(97129), // Rule ID 10491 //
     /*  97102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  97105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97116 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97119 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97121 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97123 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97128 */   // GIR_Coverage, 10491,
     /*  97128 */   GIR_EraseRootFromParent_Done,
     /*  97129 */ // Label 1748: @97129
     /*  97129 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(97161), // Rule ID 10492 //
     /*  97134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  97137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  97140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97148 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97151 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97153 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97155 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97160 */   // GIR_Coverage, 10492,
     /*  97160 */   GIR_EraseRootFromParent_Done,
     /*  97161 */ // Label 1749: @97161
     /*  97161 */ GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(97193), // Rule ID 10493 //
     /*  97166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  97169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  97172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97180 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97183 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97185 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97192 */   // GIR_Coverage, 10493,
     /*  97192 */   GIR_EraseRootFromParent_Done,
     /*  97193 */ // Label 1750: @97193
     /*  97193 */ GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(97225), // Rule ID 10494 //
     /*  97198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  97201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97212 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97215 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97217 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97224 */   // GIR_Coverage, 10494,
     /*  97224 */   GIR_EraseRootFromParent_Done,
     /*  97225 */ // Label 1751: @97225
     /*  97225 */ GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(97257), // Rule ID 10495 //
     /*  97230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  97233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  97236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97244 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97247 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97249 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97251 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97256 */   // GIR_Coverage, 10495,
     /*  97256 */   GIR_EraseRootFromParent_Done,
     /*  97257 */ // Label 1752: @97257
     /*  97257 */ GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(97289), // Rule ID 10496 //
     /*  97262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /*  97265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  97268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97276 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /*  97276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97279 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  97281 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  97283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97288 */   // GIR_Coverage, 10496,
     /*  97288 */   GIR_EraseRootFromParent_Done,
     /*  97289 */ // Label 1753: @97289
     /*  97289 */ GIM_Reject,
     /*  97290 */ // Label 1456: @97290
     /*  97290 */ GIM_Reject,
     /*  97291 */ // Label 10: @97291
     /*  97291 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1762*/ GIMT_Encode4(97781),
     /*  97302 */ /*GILLT_s16*//*Label 1754*/ GIMT_Encode4(97342),
     /*  97306 */ /*GILLT_s32*//*Label 1755*/ GIMT_Encode4(97373),
     /*  97310 */ /*GILLT_s64*//*Label 1756*/ GIMT_Encode4(97404), GIMT_Encode4(0),
     /*  97318 */ /*GILLT_v2s32*//*Label 1757*/ GIMT_Encode4(97435),
     /*  97322 */ /*GILLT_v2s64*//*Label 1758*/ GIMT_Encode4(97466),
     /*  97326 */ /*GILLT_v4s16*//*Label 1759*/ GIMT_Encode4(97497),
     /*  97330 */ /*GILLT_v4s32*//*Label 1760*/ GIMT_Encode4(97528), GIMT_Encode4(0),
     /*  97338 */ /*GILLT_v8s16*//*Label 1761*/ GIMT_Encode4(97559),
     /*  97342 */ // Label 1754: @97342
     /*  97342 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(97372), // Rule ID 564 //
     /*  97347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  97350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  97353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  97357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  97361 */   // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  97361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
     /*  97366 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97370 */   GIR_RootConstrainSelectedInstOperands,
     /*  97371 */   // GIR_Coverage, 564,
     /*  97371 */   GIR_Done,
     /*  97372 */ // Label 1763: @97372
     /*  97372 */ GIM_Reject,
     /*  97373 */ // Label 1755: @97373
     /*  97373 */ GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(97403), // Rule ID 566 //
     /*  97378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  97381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  97384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  97388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  97392 */   // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  97392 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
     /*  97397 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97401 */   GIR_RootConstrainSelectedInstOperands,
     /*  97402 */   // GIR_Coverage, 566,
     /*  97402 */   GIR_Done,
     /*  97403 */ // Label 1764: @97403
     /*  97403 */ GIM_Reject,
     /*  97404 */ // Label 1756: @97404
     /*  97404 */ GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(97434), // Rule ID 568 //
     /*  97409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  97412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  97415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97423 */   // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  97423 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
     /*  97428 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97432 */   GIR_RootConstrainSelectedInstOperands,
     /*  97433 */   // GIR_Coverage, 568,
     /*  97433 */   GIR_Done,
     /*  97434 */ // Label 1765: @97434
     /*  97434 */ GIM_Reject,
     /*  97435 */ // Label 1757: @97435
     /*  97435 */ GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(97465), // Rule ID 933 //
     /*  97440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  97446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97454 */   // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  97454 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
     /*  97459 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97463 */   GIR_RootConstrainSelectedInstOperands,
     /*  97464 */   // GIR_Coverage, 933,
     /*  97464 */   GIR_Done,
     /*  97465 */ // Label 1766: @97465
     /*  97465 */ GIM_Reject,
     /*  97466 */ // Label 1758: @97466
     /*  97466 */ GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(97496), // Rule ID 937 //
     /*  97471 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97485 */   // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  97485 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
     /*  97490 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97494 */   GIR_RootConstrainSelectedInstOperands,
     /*  97495 */   // GIR_Coverage, 937,
     /*  97495 */   GIR_Done,
     /*  97496 */ // Label 1767: @97496
     /*  97496 */ GIM_Reject,
     /*  97497 */ // Label 1759: @97497
     /*  97497 */ GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(97527), // Rule ID 929 //
     /*  97502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  97508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97516 */   // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  97516 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
     /*  97521 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97525 */   GIR_RootConstrainSelectedInstOperands,
     /*  97526 */   // GIR_Coverage, 929,
     /*  97526 */   GIR_Done,
     /*  97527 */ // Label 1768: @97527
     /*  97527 */ GIM_Reject,
     /*  97528 */ // Label 1760: @97528
     /*  97528 */ GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(97558), // Rule ID 935 //
     /*  97533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  97539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97547 */   // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  97547 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97552 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97556 */   GIR_RootConstrainSelectedInstOperands,
     /*  97557 */   // GIR_Coverage, 935,
     /*  97557 */   GIR_Done,
     /*  97558 */ // Label 1769: @97558
     /*  97558 */ GIM_Reject,
     /*  97559 */ // Label 1761: @97559
     /*  97559 */ GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(97780),
     /*  97564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  97567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97575 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(97594), // Rule ID 931 //
     /*  97580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97583 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  97583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
     /*  97588 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97592 */     GIR_RootConstrainSelectedInstOperands,
     /*  97593 */     // GIR_Coverage, 931,
     /*  97593 */     GIR_Done,
     /*  97594 */   // Label 1771: @97594
     /*  97594 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(97779), // Rule ID 6975 //
     /*  97599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  97602 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  97602 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  97605 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  97609 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97614 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  97618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  97620 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  97623 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97627 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97632 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  97635 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  97637 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  97640 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  97644 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97649 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  97655 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97660 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97665 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  97668 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  97672 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97677 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  97680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  97682 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  97685 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /*  97689 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97694 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  97697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  97699 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  97702 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  97706 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97711 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  97714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  97716 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  97719 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  97723 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  97730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  97733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  97737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97742 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  97745 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  97748 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  97751 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97761 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  97769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  97771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  97777 */     GIR_RootConstrainSelectedInstOperands,
     /*  97778 */     // GIR_Coverage, 6975,
     /*  97778 */     GIR_EraseRootFromParent_Done,
     /*  97779 */   // Label 1772: @97779
     /*  97779 */   GIM_Reject,
     /*  97780 */ // Label 1770: @97780
     /*  97780 */ GIM_Reject,
     /*  97781 */ // Label 1762: @97781
     /*  97781 */ GIM_Reject,
     /*  97782 */ // Label 11: @97782
     /*  97782 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1781*/ GIMT_Encode4(98272),
     /*  97793 */ /*GILLT_s16*//*Label 1773*/ GIMT_Encode4(97833),
     /*  97797 */ /*GILLT_s32*//*Label 1774*/ GIMT_Encode4(97864),
     /*  97801 */ /*GILLT_s64*//*Label 1775*/ GIMT_Encode4(97895), GIMT_Encode4(0),
     /*  97809 */ /*GILLT_v2s32*//*Label 1776*/ GIMT_Encode4(97926),
     /*  97813 */ /*GILLT_v2s64*//*Label 1777*/ GIMT_Encode4(97957),
     /*  97817 */ /*GILLT_v4s16*//*Label 1778*/ GIMT_Encode4(97988),
     /*  97821 */ /*GILLT_v4s32*//*Label 1779*/ GIMT_Encode4(98019), GIMT_Encode4(0),
     /*  97829 */ /*GILLT_v8s16*//*Label 1780*/ GIMT_Encode4(98050),
     /*  97833 */ // Label 1773: @97833
     /*  97833 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(97863), // Rule ID 528 //
     /*  97838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  97841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  97844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  97848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  97852 */   // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  97852 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
     /*  97857 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97861 */   GIR_RootConstrainSelectedInstOperands,
     /*  97862 */   // GIR_Coverage, 528,
     /*  97862 */   GIR_Done,
     /*  97863 */ // Label 1782: @97863
     /*  97863 */ GIM_Reject,
     /*  97864 */ // Label 1774: @97864
     /*  97864 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(97894), // Rule ID 530 //
     /*  97869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  97872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  97875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  97879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  97883 */   // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  97883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
     /*  97888 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97892 */   GIR_RootConstrainSelectedInstOperands,
     /*  97893 */   // GIR_Coverage, 530,
     /*  97893 */   GIR_Done,
     /*  97894 */ // Label 1783: @97894
     /*  97894 */ GIM_Reject,
     /*  97895 */ // Label 1775: @97895
     /*  97895 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(97925), // Rule ID 532 //
     /*  97900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  97903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  97906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97914 */   // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  97914 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
     /*  97919 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97923 */   GIR_RootConstrainSelectedInstOperands,
     /*  97924 */   // GIR_Coverage, 532,
     /*  97924 */   GIR_Done,
     /*  97925 */ // Label 1784: @97925
     /*  97925 */ GIM_Reject,
     /*  97926 */ // Label 1776: @97926
     /*  97926 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(97956), // Rule ID 873 //
     /*  97931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  97937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  97945 */   // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  97945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
     /*  97950 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97954 */   GIR_RootConstrainSelectedInstOperands,
     /*  97955 */   // GIR_Coverage, 873,
     /*  97955 */   GIR_Done,
     /*  97956 */ // Label 1785: @97956
     /*  97956 */ GIM_Reject,
     /*  97957 */ // Label 1777: @97957
     /*  97957 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(97987), // Rule ID 877 //
     /*  97962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  97965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  97968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  97976 */   // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  97976 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
     /*  97981 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  97985 */   GIR_RootConstrainSelectedInstOperands,
     /*  97986 */   // GIR_Coverage, 877,
     /*  97986 */   GIR_Done,
     /*  97987 */ // Label 1786: @97987
     /*  97987 */ GIM_Reject,
     /*  97988 */ // Label 1778: @97988
     /*  97988 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(98018), // Rule ID 869 //
     /*  97993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  97996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  97999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98007 */   // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  98007 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
     /*  98012 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98016 */   GIR_RootConstrainSelectedInstOperands,
     /*  98017 */   // GIR_Coverage, 869,
     /*  98017 */   GIR_Done,
     /*  98018 */ // Label 1787: @98018
     /*  98018 */ GIM_Reject,
     /*  98019 */ // Label 1779: @98019
     /*  98019 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(98049), // Rule ID 875 //
     /*  98024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  98030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98038 */   // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  98038 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  98043 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98047 */   GIR_RootConstrainSelectedInstOperands,
     /*  98048 */   // GIR_Coverage, 875,
     /*  98048 */   GIR_Done,
     /*  98049 */ // Label 1788: @98049
     /*  98049 */ GIM_Reject,
     /*  98050 */ // Label 1780: @98050
     /*  98050 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(98271),
     /*  98055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  98058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98066 */   GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(98085), // Rule ID 871 //
     /*  98071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  98074 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  98074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
     /*  98079 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98083 */     GIR_RootConstrainSelectedInstOperands,
     /*  98084 */     // GIR_Coverage, 871,
     /*  98084 */     GIR_Done,
     /*  98085 */   // Label 1790: @98085
     /*  98085 */   GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(98270), // Rule ID 6969 //
     /*  98090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  98093 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  98093 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  98096 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  98100 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98105 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  98111 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  98114 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  98118 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98123 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  98126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  98128 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  98131 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  98135 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98140 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  98146 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98151 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98156 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  98159 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  98163 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98168 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  98171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  98173 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  98176 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /*  98180 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98185 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  98188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98190 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  98193 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  98197 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98202 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  98205 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  98207 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  98210 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98214 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  98221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  98224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98233 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  98236 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  98239 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  98242 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  98260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  98268 */     GIR_RootConstrainSelectedInstOperands,
     /*  98269 */     // GIR_Coverage, 6969,
     /*  98269 */     GIR_EraseRootFromParent_Done,
     /*  98270 */   // Label 1791: @98270
     /*  98270 */   GIM_Reject,
     /*  98271 */ // Label 1789: @98271
     /*  98271 */ GIM_Reject,
     /*  98272 */ // Label 1781: @98272
     /*  98272 */ GIM_Reject,
     /*  98273 */ // Label 12: @98273
     /*  98273 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1794*/ GIMT_Encode4(98540),
     /*  98284 */ /*GILLT_s32*//*Label 1792*/ GIMT_Encode4(98292),
     /*  98288 */ /*GILLT_s64*//*Label 1793*/ GIMT_Encode4(98416),
     /*  98292 */ // Label 1792: @98292
     /*  98292 */ GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(98335), // Rule ID 4771 //
     /*  98297 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98300 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  98303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98307 */   // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  98307 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  98310 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  98314 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98319 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98323 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98325 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /*  98328 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98330 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98333 */   GIR_RootConstrainSelectedInstOperands,
     /*  98334 */   // GIR_Coverage, 4771,
     /*  98334 */   GIR_EraseRootFromParent_Done,
     /*  98335 */ // Label 1795: @98335
     /*  98335 */ GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(98375), // Rule ID 4777 //
     /*  98340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  98343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98347 */   // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  98347 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98350 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  98354 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98359 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98365 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /*  98368 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98370 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98373 */   GIR_RootConstrainSelectedInstOperands,
     /*  98374 */   // GIR_Coverage, 4777,
     /*  98374 */   GIR_EraseRootFromParent_Done,
     /*  98375 */ // Label 1796: @98375
     /*  98375 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(98415), // Rule ID 4779 //
     /*  98380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  98383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  98387 */   // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  98387 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98390 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  98394 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98399 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98403 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /*  98408 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98410 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98413 */   GIR_RootConstrainSelectedInstOperands,
     /*  98414 */   // GIR_Coverage, 4779,
     /*  98414 */   GIR_EraseRootFromParent_Done,
     /*  98415 */ // Label 1797: @98415
     /*  98415 */ GIM_Reject,
     /*  98416 */ // Label 1793: @98416
     /*  98416 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(98459), // Rule ID 4773 //
     /*  98421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  98427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98431 */   // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  98431 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  98434 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  98438 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98443 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  98452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98454 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98457 */   GIR_RootConstrainSelectedInstOperands,
     /*  98458 */   // GIR_Coverage, 4773,
     /*  98458 */   GIR_EraseRootFromParent_Done,
     /*  98459 */ // Label 1798: @98459
     /*  98459 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(98499), // Rule ID 4781 //
     /*  98464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  98467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98471 */   // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  98471 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98474 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  98478 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98483 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98487 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  98492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98494 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98497 */   GIR_RootConstrainSelectedInstOperands,
     /*  98498 */   // GIR_Coverage, 4781,
     /*  98498 */   GIR_EraseRootFromParent_Done,
     /*  98499 */ // Label 1799: @98499
     /*  98499 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(98539), // Rule ID 4783 //
     /*  98504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  98507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98511 */   // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  98511 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98514 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  98518 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98523 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98527 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98529 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  98532 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98534 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98537 */   GIR_RootConstrainSelectedInstOperands,
     /*  98538 */   // GIR_Coverage, 4783,
     /*  98538 */   GIR_EraseRootFromParent_Done,
     /*  98539 */ // Label 1800: @98539
     /*  98539 */ GIM_Reject,
     /*  98540 */ // Label 1794: @98540
     /*  98540 */ GIM_Reject,
     /*  98541 */ // Label 13: @98541
     /*  98541 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(98690),
     /*  98546 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  98549 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1805*/ GIMT_Encode4(98689),
     /*  98560 */   /*GILLT_s16*//*Label 1802*/ GIMT_Encode4(98572),
     /*  98564 */   /*GILLT_s32*//*Label 1803*/ GIMT_Encode4(98613),
     /*  98568 */   /*GILLT_s64*//*Label 1804*/ GIMT_Encode4(98651),
     /*  98572 */   // Label 1802: @98572
     /*  98572 */   GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(98612), // Rule ID 4775 //
     /*  98577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98584 */     // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /*  98584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /*  98587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /*  98591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /*  98605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98610 */     GIR_RootConstrainSelectedInstOperands,
     /*  98611 */     // GIR_Coverage, 4775,
     /*  98611 */     GIR_EraseRootFromParent_Done,
     /*  98612 */   // Label 1806: @98612
     /*  98612 */   GIM_Reject,
     /*  98613 */   // Label 1803: @98613
     /*  98613 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(98650), // Rule ID 4785 //
     /*  98618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98622 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /*  98622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  98625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /*  98629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /*  98643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98648 */     GIR_RootConstrainSelectedInstOperands,
     /*  98649 */     // GIR_Coverage, 4785,
     /*  98649 */     GIR_EraseRootFromParent_Done,
     /*  98650 */   // Label 1807: @98650
     /*  98650 */   GIM_Reject,
     /*  98651 */   // Label 1804: @98651
     /*  98651 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(98688), // Rule ID 4787 //
     /*  98656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  98660 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /*  98660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /*  98667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98672 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98676 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /*  98681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  98683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98686 */     GIR_RootConstrainSelectedInstOperands,
     /*  98687 */     // GIR_Coverage, 4787,
     /*  98687 */     GIR_EraseRootFromParent_Done,
     /*  98688 */   // Label 1808: @98688
     /*  98688 */   GIM_Reject,
     /*  98689 */   // Label 1805: @98689
     /*  98689 */   GIM_Reject,
     /*  98690 */ // Label 1801: @98690
     /*  98690 */ GIM_Reject,
     /*  98691 */ // Label 14: @98691
     /*  98691 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1817*/ GIMT_Encode4(99181),
     /*  98702 */ /*GILLT_s16*//*Label 1809*/ GIMT_Encode4(98742),
     /*  98706 */ /*GILLT_s32*//*Label 1810*/ GIMT_Encode4(98773),
     /*  98710 */ /*GILLT_s64*//*Label 1811*/ GIMT_Encode4(98804), GIMT_Encode4(0),
     /*  98718 */ /*GILLT_v2s32*//*Label 1812*/ GIMT_Encode4(98835),
     /*  98722 */ /*GILLT_v2s64*//*Label 1813*/ GIMT_Encode4(98866),
     /*  98726 */ /*GILLT_v4s16*//*Label 1814*/ GIMT_Encode4(98897),
     /*  98730 */ /*GILLT_v4s32*//*Label 1815*/ GIMT_Encode4(98928), GIMT_Encode4(0),
     /*  98738 */ /*GILLT_v8s16*//*Label 1816*/ GIMT_Encode4(98959),
     /*  98742 */ // Label 1809: @98742
     /*  98742 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(98772), // Rule ID 546 //
     /*  98747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  98750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  98753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  98757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  98761 */   // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /*  98761 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
     /*  98766 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98770 */   GIR_RootConstrainSelectedInstOperands,
     /*  98771 */   // GIR_Coverage, 546,
     /*  98771 */   GIR_Done,
     /*  98772 */ // Label 1818: @98772
     /*  98772 */ GIM_Reject,
     /*  98773 */ // Label 1810: @98773
     /*  98773 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(98803), // Rule ID 548 //
     /*  98778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  98784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  98788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  98792 */   // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /*  98792 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
     /*  98797 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98801 */   GIR_RootConstrainSelectedInstOperands,
     /*  98802 */   // GIR_Coverage, 548,
     /*  98802 */   GIR_Done,
     /*  98803 */ // Label 1819: @98803
     /*  98803 */ GIM_Reject,
     /*  98804 */ // Label 1811: @98804
     /*  98804 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(98834), // Rule ID 550 //
     /*  98809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  98812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  98815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98823 */   // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /*  98823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
     /*  98828 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98832 */   GIR_RootConstrainSelectedInstOperands,
     /*  98833 */   // GIR_Coverage, 550,
     /*  98833 */   GIR_Done,
     /*  98834 */ // Label 1820: @98834
     /*  98834 */ GIM_Reject,
     /*  98835 */ // Label 1812: @98835
     /*  98835 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(98865), // Rule ID 903 //
     /*  98840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  98846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98854 */   // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /*  98854 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
     /*  98859 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98863 */   GIR_RootConstrainSelectedInstOperands,
     /*  98864 */   // GIR_Coverage, 903,
     /*  98864 */   GIR_Done,
     /*  98865 */ // Label 1821: @98865
     /*  98865 */ GIM_Reject,
     /*  98866 */ // Label 1813: @98866
     /*  98866 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(98896), // Rule ID 907 //
     /*  98871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  98877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98885 */   // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /*  98885 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
     /*  98890 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98894 */   GIR_RootConstrainSelectedInstOperands,
     /*  98895 */   // GIR_Coverage, 907,
     /*  98895 */   GIR_Done,
     /*  98896 */ // Label 1822: @98896
     /*  98896 */ GIM_Reject,
     /*  98897 */ // Label 1814: @98897
     /*  98897 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(98927), // Rule ID 899 //
     /*  98902 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  98905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  98908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98916 */   // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /*  98916 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
     /*  98921 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98925 */   GIR_RootConstrainSelectedInstOperands,
     /*  98926 */   // GIR_Coverage, 899,
     /*  98926 */   GIR_Done,
     /*  98927 */ // Label 1823: @98927
     /*  98927 */ GIM_Reject,
     /*  98928 */ // Label 1815: @98928
     /*  98928 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(98958), // Rule ID 905 //
     /*  98933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  98936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  98939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98943 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98947 */   // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /*  98947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  98952 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98956 */   GIR_RootConstrainSelectedInstOperands,
     /*  98957 */   // GIR_Coverage, 905,
     /*  98957 */   GIR_Done,
     /*  98958 */ // Label 1824: @98958
     /*  98958 */ GIM_Reject,
     /*  98959 */ // Label 1816: @98959
     /*  98959 */ GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(99180),
     /*  98964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  98967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98975 */   GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(98994), // Rule ID 901 //
     /*  98980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  98983 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /*  98983 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
     /*  98988 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /*  98992 */     GIR_RootConstrainSelectedInstOperands,
     /*  98993 */     // GIR_Coverage, 901,
     /*  98993 */     GIR_Done,
     /*  98994 */   // Label 1826: @98994
     /*  98994 */   GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(99179), // Rule ID 6971 //
     /*  98999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /*  99002 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /*  99002 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /*  99005 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /*  99009 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99014 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  99018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /*  99020 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /*  99023 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  99027 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99032 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /*  99035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /*  99037 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /*  99040 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  99044 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99049 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /*  99055 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99060 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99065 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /*  99068 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /*  99072 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99077 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /*  99080 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /*  99082 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /*  99085 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /*  99089 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99094 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /*  99097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99099 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /*  99102 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /*  99106 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99111 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  99114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99116 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99119 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99123 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99142 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99145 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  99148 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /*  99169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99171 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /*  99177 */     GIR_RootConstrainSelectedInstOperands,
     /*  99178 */     // GIR_Coverage, 6971,
     /*  99178 */     GIR_EraseRootFromParent_Done,
     /*  99179 */   // Label 1827: @99179
     /*  99179 */   GIM_Reject,
     /*  99180 */ // Label 1825: @99180
     /*  99180 */ GIM_Reject,
     /*  99181 */ // Label 1817: @99181
     /*  99181 */ GIM_Reject,
     /*  99182 */ // Label 15: @99182
     /*  99182 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(99214), // Rule ID 3892 //
     /*  99187 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  99190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  99194 */   // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
     /*  99194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /*  99197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99199 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
     /*  99209 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  99212 */   GIR_RootConstrainSelectedInstOperands,
     /*  99213 */   // GIR_Coverage, 3892,
     /*  99213 */   GIR_EraseRootFromParent_Done,
     /*  99214 */ // Label 1828: @99214
     /*  99214 */ GIM_Reject,
     /*  99215 */ // Label 16: @99215
     /*  99215 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 1849*/ GIMT_Encode4(108024),
     /*  99226 */ /*GILLT_s8*//*Label 1829*/ GIMT_Encode4(99322),
     /*  99230 */ /*GILLT_s16*//*Label 1830*/ GIMT_Encode4(99498),
     /*  99234 */ /*GILLT_s32*//*Label 1831*/ GIMT_Encode4(99674),
     /*  99238 */ /*GILLT_s64*//*Label 1832*/ GIMT_Encode4(101972),
     /*  99242 */ /*GILLT_s128*//*Label 1833*/ GIMT_Encode4(104653),
     /*  99246 */ /*GILLT_v2s32*//*Label 1834*/ GIMT_Encode4(104862),
     /*  99250 */ /*GILLT_v2s64*//*Label 1835*/ GIMT_Encode4(105240),
     /*  99254 */ /*GILLT_v4s16*//*Label 1836*/ GIMT_Encode4(105618),
     /*  99258 */ /*GILLT_v4s32*//*Label 1837*/ GIMT_Encode4(105996),
     /*  99262 */ /*GILLT_v8s8*//*Label 1838*/ GIMT_Encode4(106374),
     /*  99266 */ /*GILLT_v8s16*//*Label 1839*/ GIMT_Encode4(106582),
     /*  99270 */ /*GILLT_v16s8*//*Label 1840*/ GIMT_Encode4(106960), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99282 */ /*GILLT_nxv2s16*//*Label 1841*/ GIMT_Encode4(107168),
     /*  99286 */ /*GILLT_nxv2s32*//*Label 1842*/ GIMT_Encode4(107232),
     /*  99290 */ /*GILLT_nxv2s64*//*Label 1843*/ GIMT_Encode4(107296), GIMT_Encode4(0),
     /*  99298 */ /*GILLT_nxv4s16*//*Label 1844*/ GIMT_Encode4(107470),
     /*  99302 */ /*GILLT_nxv4s32*//*Label 1845*/ GIMT_Encode4(107534), GIMT_Encode4(0),
     /*  99310 */ /*GILLT_nxv8s16*//*Label 1846*/ GIMT_Encode4(107708),
     /*  99314 */ /*GILLT_nxv16s1*//*Label 1847*/ GIMT_Encode4(107882),
     /*  99318 */ /*GILLT_nxv16s8*//*Label 1848*/ GIMT_Encode4(107926),
     /*  99322 */ // Label 1829: @99322
     /*  99322 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(99497),
     /*  99327 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99330 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /*  99338 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99342 */   GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(99383), // Rule ID 237 //
     /*  99347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99350 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  99357 */     // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  99357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /*  99360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99372 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99377 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99381 */     GIR_RootConstrainSelectedInstOperands,
     /*  99382 */     // GIR_Coverage, 237,
     /*  99382 */     GIR_EraseRootFromParent_Done,
     /*  99383 */   // Label 1851: @99383
     /*  99383 */   GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(99424), // Rule ID 238 //
     /*  99388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  99398 */     // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  99398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /*  99401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99422 */     GIR_RootConstrainSelectedInstOperands,
     /*  99423 */     // GIR_Coverage, 238,
     /*  99423 */     GIR_EraseRootFromParent_Done,
     /*  99424 */   // Label 1852: @99424
     /*  99424 */   GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(99460), // Rule ID 261 //
     /*  99429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99432 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /*  99439 */     // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /*  99439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /*  99442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99458 */     GIR_RootConstrainSelectedInstOperands,
     /*  99459 */     // GIR_Coverage, 261,
     /*  99459 */     GIR_EraseRootFromParent_Done,
     /*  99460 */   // Label 1853: @99460
     /*  99460 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(99496), // Rule ID 282 //
     /*  99465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /*  99475 */     // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /*  99478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99494 */     GIR_RootConstrainSelectedInstOperands,
     /*  99495 */     // GIR_Coverage, 282,
     /*  99495 */     GIR_EraseRootFromParent_Done,
     /*  99496 */   // Label 1854: @99496
     /*  99496 */   GIM_Reject,
     /*  99497 */ // Label 1850: @99497
     /*  99497 */ GIM_Reject,
     /*  99498 */ // Label 1830: @99498
     /*  99498 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(99673),
     /*  99503 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99506 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /*  99514 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99518 */   GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(99559), // Rule ID 239 //
     /*  99523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99526 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /*  99533 */     // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /*  99533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /*  99536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99538 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99543 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99553 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99557 */     GIR_RootConstrainSelectedInstOperands,
     /*  99558 */     // GIR_Coverage, 239,
     /*  99558 */     GIR_EraseRootFromParent_Done,
     /*  99559 */   // Label 1856: @99559
     /*  99559 */   GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(99600), // Rule ID 240 //
     /*  99564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99567 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /*  99574 */     // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /*  99574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /*  99577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99598 */     GIR_RootConstrainSelectedInstOperands,
     /*  99599 */     // GIR_Coverage, 240,
     /*  99599 */     GIR_EraseRootFromParent_Done,
     /*  99600 */   // Label 1857: @99600
     /*  99600 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(99636), // Rule ID 262 //
     /*  99605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99608 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /*  99615 */     // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /*  99615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /*  99618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99634 */     GIR_RootConstrainSelectedInstOperands,
     /*  99635 */     // GIR_Coverage, 262,
     /*  99635 */     GIR_EraseRootFromParent_Done,
     /*  99636 */   // Label 1858: @99636
     /*  99636 */   GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(99672), // Rule ID 283 //
     /*  99641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99644 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /*  99651 */     // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /*  99651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /*  99654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /*  99666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99670 */     GIR_RootConstrainSelectedInstOperands,
     /*  99671 */     // GIR_Coverage, 283,
     /*  99671 */     GIR_EraseRootFromParent_Done,
     /*  99672 */   // Label 1859: @99672
     /*  99672 */   GIM_Reject,
     /*  99673 */ // Label 1855: @99673
     /*  99673 */ GIM_Reject,
     /*  99674 */ // Label 1831: @99674
     /*  99674 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(99727), // Rule ID 233 //
     /*  99679 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99682 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99690 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99694 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  99701 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  99701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /*  99704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99706 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99721 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99725 */   GIR_RootConstrainSelectedInstOperands,
     /*  99726 */   // GIR_Coverage, 233,
     /*  99726 */   GIR_EraseRootFromParent_Done,
     /*  99727 */ // Label 1860: @99727
     /*  99727 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(99780), // Rule ID 234 //
     /*  99732 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99735 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99743 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99747 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  99754 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  99754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /*  99757 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99764 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99769 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99774 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99778 */   GIR_RootConstrainSelectedInstOperands,
     /*  99779 */   // GIR_Coverage, 234,
     /*  99779 */   GIR_EraseRootFromParent_Done,
     /*  99780 */ // Label 1861: @99780
     /*  99780 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(99836), // Rule ID 241 //
     /*  99785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99788 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99791 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  99799 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99803 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /*  99810 */   // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /*  99810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /*  99813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99815 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99820 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99825 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99830 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99834 */   GIR_RootConstrainSelectedInstOperands,
     /*  99835 */   // GIR_Coverage, 241,
     /*  99835 */   GIR_EraseRootFromParent_Done,
     /*  99836 */ // Label 1862: @99836
     /*  99836 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(99892), // Rule ID 242 //
     /*  99841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  99844 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99847 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /*  99855 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99859 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /*  99866 */   // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /*  99866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /*  99869 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99871 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99876 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99881 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99886 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99890 */   GIR_RootConstrainSelectedInstOperands,
     /*  99891 */   // GIR_Coverage, 242,
     /*  99891 */   GIR_EraseRootFromParent_Done,
     /*  99892 */ // Label 1863: @99892
     /*  99892 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(99952), // Rule ID 4108 //
     /*  99897 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99900 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99904 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99915 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99919 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /*  99926 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /*  99926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /*  99929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99931 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99936 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /*  99941 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /*  99946 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99950 */   GIR_RootConstrainSelectedInstOperands,
     /*  99951 */   // GIR_Coverage, 4108,
     /*  99951 */   GIR_EraseRootFromParent_Done,
     /*  99952 */ // Label 1864: @99952
     /*  99952 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(100012), // Rule ID 4109 //
     /*  99957 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  99960 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /*  99964 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  99971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  99975 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /*  99979 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /*  99986 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /*  99986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /*  99989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  99991 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99996 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100001 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100006 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100010 */   GIR_RootConstrainSelectedInstOperands,
     /* 100011 */   // GIR_Coverage, 4109,
     /* 100011 */   GIR_EraseRootFromParent_Done,
     /* 100012 */ // Label 1865: @100012
     /* 100012 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(100072), // Rule ID 4110 //
     /* 100017 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100020 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100024 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100035 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100039 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 100046 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 100046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 100049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100061 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100066 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100070 */   GIR_RootConstrainSelectedInstOperands,
     /* 100071 */   // GIR_Coverage, 4110,
     /* 100071 */   GIR_EraseRootFromParent_Done,
     /* 100072 */ // Label 1866: @100072
     /* 100072 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(100132), // Rule ID 4111 //
     /* 100077 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100080 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100084 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100095 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100099 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 100106 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 100106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 100109 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100116 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100121 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100126 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100130 */   GIR_RootConstrainSelectedInstOperands,
     /* 100131 */   // GIR_Coverage, 4111,
     /* 100131 */   GIR_EraseRootFromParent_Done,
     /* 100132 */ // Label 1867: @100132
     /* 100132 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(100192), // Rule ID 4112 //
     /* 100137 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100140 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100144 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100155 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100159 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 100166 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 100166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 100169 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100171 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100181 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100186 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100190 */   GIR_RootConstrainSelectedInstOperands,
     /* 100191 */   // GIR_Coverage, 4112,
     /* 100191 */   GIR_EraseRootFromParent_Done,
     /* 100192 */ // Label 1868: @100192
     /* 100192 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(100252), // Rule ID 4113 //
     /* 100197 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100200 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100204 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100215 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100219 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 100226 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 100226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 100229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100236 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100241 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100246 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100250 */   GIR_RootConstrainSelectedInstOperands,
     /* 100251 */   // GIR_Coverage, 4113,
     /* 100251 */   GIR_EraseRootFromParent_Done,
     /* 100252 */ // Label 1869: @100252
     /* 100252 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(100300), // Rule ID 260 //
     /* 100257 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100260 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100268 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100272 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 100279 */   // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 100279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 100282 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100284 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100289 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100294 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100298 */   GIR_RootConstrainSelectedInstOperands,
     /* 100299 */   // GIR_Coverage, 260,
     /* 100299 */   GIR_EraseRootFromParent_Done,
     /* 100300 */ // Label 1870: @100300
     /* 100300 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(100351), // Rule ID 263 //
     /* 100305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100308 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100311 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 100319 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100323 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 100330 */   // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 100330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 100333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100345 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100349 */   GIR_RootConstrainSelectedInstOperands,
     /* 100350 */   // GIR_Coverage, 263,
     /* 100350 */   GIR_EraseRootFromParent_Done,
     /* 100351 */ // Label 1871: @100351
     /* 100351 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(100410), // Rule ID 6999 //
     /* 100356 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100359 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100366 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100373 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100377 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 100384 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15808>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 100384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 100387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100389 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100394 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100399 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 100404 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100408 */   GIR_RootConstrainSelectedInstOperands,
     /* 100409 */   // GIR_Coverage, 6999,
     /* 100409 */   GIR_EraseRootFromParent_Done,
     /* 100410 */ // Label 1872: @100410
     /* 100410 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(100469), // Rule ID 7001 //
     /* 100415 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100418 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100425 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100432 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100436 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 100443 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15808>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 100443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 100446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 100463 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100467 */   GIR_RootConstrainSelectedInstOperands,
     /* 100468 */   // GIR_Coverage, 7001,
     /* 100468 */   GIR_EraseRootFromParent_Done,
     /* 100469 */ // Label 1873: @100469
     /* 100469 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(100528), // Rule ID 7011 //
     /* 100474 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100477 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100484 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100491 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100495 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 100502 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15817>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 100502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 100505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100512 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100517 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100522 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100526 */   GIR_RootConstrainSelectedInstOperands,
     /* 100527 */   // GIR_Coverage, 7011,
     /* 100527 */   GIR_EraseRootFromParent_Done,
     /* 100528 */ // Label 1874: @100528
     /* 100528 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(100587), // Rule ID 7013 //
     /* 100533 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100536 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100543 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100550 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100554 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 100561 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15817>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 100561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 100564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100566 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100571 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100576 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100581 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100585 */   GIR_RootConstrainSelectedInstOperands,
     /* 100586 */   // GIR_Coverage, 7013,
     /* 100586 */   GIR_EraseRootFromParent_Done,
     /* 100587 */ // Label 1875: @100587
     /* 100587 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(100646), // Rule ID 7021 //
     /* 100592 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100595 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100602 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100609 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100613 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 100620 */   // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15825>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 100620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 100623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100625 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100630 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100635 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100640 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100644 */   GIR_RootConstrainSelectedInstOperands,
     /* 100645 */   // GIR_Coverage, 7021,
     /* 100645 */   GIR_EraseRootFromParent_Done,
     /* 100646 */ // Label 1876: @100646
     /* 100646 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(100705), // Rule ID 7022 //
     /* 100651 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100654 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 100661 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100668 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100672 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 100679 */   // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15825>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 100679 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 100682 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100684 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 100694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 100699 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100703 */   GIR_RootConstrainSelectedInstOperands,
     /* 100704 */   // GIR_Coverage, 7022,
     /* 100704 */   GIR_EraseRootFromParent_Done,
     /* 100705 */ // Label 1877: @100705
     /* 100705 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(100753), // Rule ID 281 //
     /* 100710 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100713 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100721 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100725 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100732 */   // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 100732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 100735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100747 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100751 */   GIR_RootConstrainSelectedInstOperands,
     /* 100752 */   // GIR_Coverage, 281,
     /* 100752 */   GIR_EraseRootFromParent_Done,
     /* 100753 */ // Label 1878: @100753
     /* 100753 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(100804), // Rule ID 284 //
     /* 100758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 100761 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 100764 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 100768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 100772 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100776 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 100783 */   // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 100783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 100786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100798 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100802 */   GIR_RootConstrainSelectedInstOperands,
     /* 100803 */   // GIR_Coverage, 284,
     /* 100803 */   GIR_EraseRootFromParent_Done,
     /* 100804 */ // Label 1879: @100804
     /* 100804 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(100858), // Rule ID 7003 //
     /* 100809 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100812 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100819 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100826 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100830 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 100837 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15808>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 100837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 100840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100852 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100856 */   GIR_RootConstrainSelectedInstOperands,
     /* 100857 */   // GIR_Coverage, 7003,
     /* 100857 */   GIR_EraseRootFromParent_Done,
     /* 100858 */ // Label 1880: @100858
     /* 100858 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(100912), // Rule ID 7005 //
     /* 100863 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100866 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 100873 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100880 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100884 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 100891 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15808>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 100894 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100896 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100901 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100906 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100910 */   GIR_RootConstrainSelectedInstOperands,
     /* 100911 */   // GIR_Coverage, 7005,
     /* 100911 */   GIR_EraseRootFromParent_Done,
     /* 100912 */ // Label 1881: @100912
     /* 100912 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(100966), // Rule ID 7015 //
     /* 100917 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100920 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100927 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100934 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100938 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 100945 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15817>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 100945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 100948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 100950 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 100955 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 100960 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 100964 */   GIR_RootConstrainSelectedInstOperands,
     /* 100965 */   // GIR_Coverage, 7015,
     /* 100965 */   GIR_EraseRootFromParent_Done,
     /* 100966 */ // Label 1882: @100966
     /* 100966 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(101020), // Rule ID 7017 //
     /* 100971 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 100974 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 100981 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 100984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 100988 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 100992 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 100999 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15817>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 100999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 101002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101014 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101018 */   GIR_RootConstrainSelectedInstOperands,
     /* 101019 */   // GIR_Coverage, 7017,
     /* 101019 */   GIR_EraseRootFromParent_Done,
     /* 101020 */ // Label 1883: @101020
     /* 101020 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(101074), // Rule ID 7023 //
     /* 101025 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101028 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101035 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101042 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101046 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 101053 */   // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15825>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 101053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 101056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101063 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101068 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101072 */   GIR_RootConstrainSelectedInstOperands,
     /* 101073 */   // GIR_Coverage, 7023,
     /* 101073 */   GIR_EraseRootFromParent_Done,
     /* 101074 */ // Label 1884: @101074
     /* 101074 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(101128), // Rule ID 7024 //
     /* 101079 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101082 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101089 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101096 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101100 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 101107 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15825>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 101110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101122 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101126 */   GIR_RootConstrainSelectedInstOperands,
     /* 101127 */   // GIR_Coverage, 7024,
     /* 101127 */   GIR_EraseRootFromParent_Done,
     /* 101128 */ // Label 1885: @101128
     /* 101128 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(101185), // Rule ID 7379 //
     /* 101133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 101136 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101139 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101146 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101153 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101157 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101164 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15806>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 101167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101169 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101179 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101183 */   GIR_RootConstrainSelectedInstOperands,
     /* 101184 */   // GIR_Coverage, 7379,
     /* 101184 */   GIR_EraseRootFromParent_Done,
     /* 101185 */ // Label 1886: @101185
     /* 101185 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(101242), // Rule ID 7381 //
     /* 101190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 101193 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101196 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101203 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101210 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101214 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 101221 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15815>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 101224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101236 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101240 */   GIR_RootConstrainSelectedInstOperands,
     /* 101241 */   // GIR_Coverage, 7381,
     /* 101241 */   GIR_EraseRootFromParent_Done,
     /* 101242 */ // Label 1887: @101242
     /* 101242 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(101299), // Rule ID 7383 //
     /* 101247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 101250 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101253 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101260 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101267 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101271 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 101278 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15800>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
     /* 101281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101283 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101288 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101293 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101297 */   GIR_RootConstrainSelectedInstOperands,
     /* 101298 */   // GIR_Coverage, 7383,
     /* 101298 */   GIR_EraseRootFromParent_Done,
     /* 101299 */ // Label 1888: @101299
     /* 101299 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(101354), // Rule ID 4135 //
     /* 101304 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101307 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101311 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101322 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101326 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 101333 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 101333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 101336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101338 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101343 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101348 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101352 */   GIR_RootConstrainSelectedInstOperands,
     /* 101353 */   // GIR_Coverage, 4135,
     /* 101353 */   GIR_EraseRootFromParent_Done,
     /* 101354 */ // Label 1889: @101354
     /* 101354 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(101409), // Rule ID 4136 //
     /* 101359 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101362 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101366 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101377 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101381 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 101388 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 101388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 101391 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101403 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101407 */   GIR_RootConstrainSelectedInstOperands,
     /* 101408 */   // GIR_Coverage, 4136,
     /* 101408 */   GIR_EraseRootFromParent_Done,
     /* 101409 */ // Label 1890: @101409
     /* 101409 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(101464), // Rule ID 4137 //
     /* 101414 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101417 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101421 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101432 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101436 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 101443 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 101443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 101446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101458 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101462 */   GIR_RootConstrainSelectedInstOperands,
     /* 101463 */   // GIR_Coverage, 4137,
     /* 101463 */   GIR_EraseRootFromParent_Done,
     /* 101464 */ // Label 1891: @101464
     /* 101464 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(101519), // Rule ID 4158 //
     /* 101469 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101472 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101476 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101487 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101491 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 101498 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 101501 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101503 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101508 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101513 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101517 */   GIR_RootConstrainSelectedInstOperands,
     /* 101518 */   // GIR_Coverage, 4158,
     /* 101518 */   GIR_EraseRootFromParent_Done,
     /* 101519 */ // Label 1892: @101519
     /* 101519 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(101574), // Rule ID 4159 //
     /* 101524 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101527 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101531 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101542 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101546 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101553 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 101556 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101558 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101563 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101568 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101572 */   GIR_RootConstrainSelectedInstOperands,
     /* 101573 */   // GIR_Coverage, 4159,
     /* 101573 */   GIR_EraseRootFromParent_Done,
     /* 101574 */ // Label 1893: @101574
     /* 101574 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(101629), // Rule ID 4160 //
     /* 101579 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101582 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101586 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101597 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101601 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 101608 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 101608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 101611 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 101613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 101618 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 101623 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 101627 */   GIR_RootConstrainSelectedInstOperands,
     /* 101628 */   // GIR_Coverage, 4160,
     /* 101628 */   GIR_EraseRootFromParent_Done,
     /* 101629 */ // Label 1894: @101629
     /* 101629 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(101669), // Rule ID 6991 //
     /* 101634 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 101637 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101640 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101647 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101654 */   // MIs[0] ptr
     /* 101654 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101662 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15796>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101662 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 101667 */   GIR_RootConstrainSelectedInstOperands,
     /* 101668 */   // GIR_Coverage, 6991,
     /* 101668 */   GIR_Done,
     /* 101669 */ // Label 1895: @101669
     /* 101669 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(101709), // Rule ID 6992 //
     /* 101674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 101677 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101680 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101687 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101694 */   // MIs[0] ptr
     /* 101694 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101698 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101702 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15798>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 101707 */   GIR_RootConstrainSelectedInstOperands,
     /* 101708 */   // GIR_Coverage, 6992,
     /* 101708 */   GIR_Done,
     /* 101709 */ // Label 1896: @101709
     /* 101709 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(101749), // Rule ID 6993 //
     /* 101714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 101717 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101720 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101727 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101734 */   // MIs[0] ptr
     /* 101734 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101742 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15800>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101742 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
     /* 101747 */   GIR_RootConstrainSelectedInstOperands,
     /* 101748 */   // GIR_Coverage, 6993,
     /* 101748 */   GIR_Done,
     /* 101749 */ // Label 1897: @101749
     /* 101749 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(101786), // Rule ID 6995 //
     /* 101754 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101757 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101764 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 101767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101771 */   // MIs[0] ptr
     /* 101771 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101775 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101779 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15804>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101779 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 101784 */   GIR_RootConstrainSelectedInstOperands,
     /* 101785 */   // GIR_Coverage, 6995,
     /* 101785 */   GIR_Done,
     /* 101786 */ // Label 1898: @101786
     /* 101786 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(101823), // Rule ID 6997 //
     /* 101791 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101794 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 101801 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101808 */   // MIs[0] ptr
     /* 101808 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101816 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_8>><<P:Predicate_anonymous_15806>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101816 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 101821 */   GIR_RootConstrainSelectedInstOperands,
     /* 101822 */   // GIR_Coverage, 6997,
     /* 101822 */   GIR_Done,
     /* 101823 */ // Label 1899: @101823
     /* 101823 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(101860), // Rule ID 7007 //
     /* 101828 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101831 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101838 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 101841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101845 */   // MIs[0] ptr
     /* 101845 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101853 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15813>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 101858 */   GIR_RootConstrainSelectedInstOperands,
     /* 101859 */   // GIR_Coverage, 7007,
     /* 101859 */   GIR_Done,
     /* 101860 */ // Label 1900: @101860
     /* 101860 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(101897), // Rule ID 7009 //
     /* 101865 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101868 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 101875 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101882 */   // MIs[0] ptr
     /* 101882 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101890 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_16>><<P:Predicate_anonymous_15815>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101890 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 101895 */   GIR_RootConstrainSelectedInstOperands,
     /* 101896 */   // GIR_Coverage, 7009,
     /* 101896 */   GIR_Done,
     /* 101897 */ // Label 1901: @101897
     /* 101897 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(101934), // Rule ID 7019 //
     /* 101902 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101905 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101912 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 101915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101919 */   // MIs[0] ptr
     /* 101919 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101927 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15822>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101927 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 101932 */   GIR_RootConstrainSelectedInstOperands,
     /* 101933 */   // GIR_Coverage, 7019,
     /* 101933 */   GIR_Done,
     /* 101934 */ // Label 1902: @101934
     /* 101934 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(101971), // Rule ID 7020 //
     /* 101939 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 101942 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 101949 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 101952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 101956 */   // MIs[0] ptr
     /* 101956 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 101960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 101964 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_32>><<P:Predicate_anonymous_15800>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 101964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 101969 */   GIR_RootConstrainSelectedInstOperands,
     /* 101970 */   // GIR_Coverage, 7020,
     /* 101970 */   GIR_Done,
     /* 101971 */ // Label 1903: @101971
     /* 101971 */ GIM_Reject,
     /* 101972 */ // Label 1832: @101972
     /* 101972 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(102025), // Rule ID 235 //
     /* 101977 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 101980 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 101984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 101988 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 101992 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 101999 */   // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 101999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 102002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102009 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102019 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102023 */   GIR_RootConstrainSelectedInstOperands,
     /* 102024 */   // GIR_Coverage, 235,
     /* 102024 */   GIR_EraseRootFromParent_Done,
     /* 102025 */ // Label 1904: @102025
     /* 102025 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(102078), // Rule ID 236 //
     /* 102030 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102033 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 102041 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102045 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102052 */   // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 102055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102057 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102062 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102067 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102072 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102076 */   GIR_RootConstrainSelectedInstOperands,
     /* 102077 */   // GIR_Coverage, 236,
     /* 102077 */   GIR_EraseRootFromParent_Done,
     /* 102078 */ // Label 1905: @102078
     /* 102078 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(102134), // Rule ID 243 //
     /* 102083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 102086 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102089 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102097 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102101 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102108 */   // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 102111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102113 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102118 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102123 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102128 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102132 */   GIR_RootConstrainSelectedInstOperands,
     /* 102133 */   // GIR_Coverage, 243,
     /* 102133 */   GIR_EraseRootFromParent_Done,
     /* 102134 */ // Label 1906: @102134
     /* 102134 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(102190), // Rule ID 244 //
     /* 102139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 102142 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102145 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102153 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102157 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102164 */   // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 102167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102169 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102179 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102184 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102188 */   GIR_RootConstrainSelectedInstOperands,
     /* 102189 */   // GIR_Coverage, 244,
     /* 102189 */   GIR_EraseRootFromParent_Done,
     /* 102190 */ // Label 1907: @102190
     /* 102190 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(102243), // Rule ID 4074 //
     /* 102195 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102198 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102206 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102210 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102217 */   // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 102220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102237 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102241 */   GIR_RootConstrainSelectedInstOperands,
     /* 102242 */   // GIR_Coverage, 4074,
     /* 102242 */   GIR_EraseRootFromParent_Done,
     /* 102243 */ // Label 1908: @102243
     /* 102243 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(102296), // Rule ID 4075 //
     /* 102248 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102251 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102259 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102263 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102270 */   // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 102273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102290 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102294 */   GIR_RootConstrainSelectedInstOperands,
     /* 102295 */   // GIR_Coverage, 4075,
     /* 102295 */   GIR_EraseRootFromParent_Done,
     /* 102296 */ // Label 1909: @102296
     /* 102296 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(102349), // Rule ID 4076 //
     /* 102301 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102304 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102312 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102316 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 102323 */   // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 102323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 102326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102338 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102343 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102347 */   GIR_RootConstrainSelectedInstOperands,
     /* 102348 */   // GIR_Coverage, 4076,
     /* 102348 */   GIR_EraseRootFromParent_Done,
     /* 102349 */ // Label 1910: @102349
     /* 102349 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(102402), // Rule ID 4077 //
     /* 102354 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102357 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102365 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102369 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 102376 */   // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 102376 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 102379 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 102381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102386 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102391 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102396 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102400 */   GIR_RootConstrainSelectedInstOperands,
     /* 102401 */   // GIR_Coverage, 4077,
     /* 102401 */   GIR_EraseRootFromParent_Done,
     /* 102402 */ // Label 1911: @102402
     /* 102402 */ GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(102494), // Rule ID 4100 //
     /* 102407 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102410 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102414 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102425 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102429 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 102436 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102436 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102439 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 102443 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102448 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102453 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102463 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102467 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102477 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102480 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102483 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102488 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102493 */   // GIR_Coverage, 4100,
     /* 102493 */   GIR_EraseRootFromParent_Done,
     /* 102494 */ // Label 1912: @102494
     /* 102494 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(102586), // Rule ID 4101 //
     /* 102499 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102502 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102506 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102517 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102521 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 102528 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102528 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102531 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 102535 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102545 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102550 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102555 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102559 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102564 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102569 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102572 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102575 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102580 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102585 */   // GIR_Coverage, 4101,
     /* 102585 */   GIR_EraseRootFromParent_Done,
     /* 102586 */ // Label 1913: @102586
     /* 102586 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(102678), // Rule ID 4102 //
     /* 102591 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102594 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102598 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102609 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102613 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 102620 */   // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102620 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102623 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 102627 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102632 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102647 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102651 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102653 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102656 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102658 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102661 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102664 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102667 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102672 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102677 */   // GIR_Coverage, 4102,
     /* 102677 */   GIR_EraseRootFromParent_Done,
     /* 102678 */ // Label 1914: @102678
     /* 102678 */ GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(102770), // Rule ID 4103 //
     /* 102683 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102686 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102690 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 102697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102701 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102705 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 102712 */   // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102712 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102715 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 102719 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102724 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102734 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102739 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102743 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102753 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102759 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102764 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102769 */   // GIR_Coverage, 4103,
     /* 102769 */   GIR_EraseRootFromParent_Done,
     /* 102770 */ // Label 1915: @102770
     /* 102770 */ GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(102862), // Rule ID 4104 //
     /* 102775 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102778 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102782 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 102789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102793 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102797 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 102804 */   // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102804 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102807 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 102811 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102826 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102831 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102837 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102840 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102845 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102856 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102861 */   // GIR_Coverage, 4104,
     /* 102861 */   GIR_EraseRootFromParent_Done,
     /* 102862 */ // Label 1916: @102862
     /* 102862 */ GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(102954), // Rule ID 4105 //
     /* 102867 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102870 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102874 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 102881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102885 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102889 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 102896 */   // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102896 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102899 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 102903 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 102918 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 102923 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 102927 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 102929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 102932 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102934 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102937 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102940 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 102943 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102948 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 102953 */   // GIR_Coverage, 4105,
     /* 102953 */   GIR_EraseRootFromParent_Done,
     /* 102954 */ // Label 1917: @102954
     /* 102954 */ GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(103046), // Rule ID 4106 //
     /* 102959 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 102962 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 102966 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 102973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 102977 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 102981 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 102988 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 102988 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 102991 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 102995 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103005 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103015 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103029 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103032 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103035 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103040 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103045 */   // GIR_Coverage, 4106,
     /* 103045 */   GIR_EraseRootFromParent_Done,
     /* 103046 */ // Label 1918: @103046
     /* 103046 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(103138), // Rule ID 4107 //
     /* 103051 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103054 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103058 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103069 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103073 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 103080 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 103080 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103083 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 103087 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103092 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103097 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103102 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103107 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103113 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103116 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103118 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103121 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103124 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103127 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103132 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103137 */   // GIR_Coverage, 4107,
     /* 103137 */   GIR_EraseRootFromParent_Done,
     /* 103138 */ // Label 1919: @103138
     /* 103138 */ GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(103186), // Rule ID 259 //
     /* 103143 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103146 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103154 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103158 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103165 */   // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 103168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103170 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103175 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103180 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103184 */   GIR_RootConstrainSelectedInstOperands,
     /* 103185 */   // GIR_Coverage, 259,
     /* 103185 */   GIR_EraseRootFromParent_Done,
     /* 103186 */ // Label 1920: @103186
     /* 103186 */ GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(103237), // Rule ID 264 //
     /* 103191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 103194 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103197 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103205 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103209 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103216 */   // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 103219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103221 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103231 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103235 */   GIR_RootConstrainSelectedInstOperands,
     /* 103236 */   // GIR_Coverage, 264,
     /* 103236 */   GIR_EraseRootFromParent_Done,
     /* 103237 */ // Label 1921: @103237
     /* 103237 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(103296), // Rule ID 7027 //
     /* 103242 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103245 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103252 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103259 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103263 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 103270 */   // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15833>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 103270 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 103273 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103290 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103294 */   GIR_RootConstrainSelectedInstOperands,
     /* 103295 */   // GIR_Coverage, 7027,
     /* 103295 */   GIR_EraseRootFromParent_Done,
     /* 103296 */ // Label 1922: @103296
     /* 103296 */ GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(103355), // Rule ID 7028 //
     /* 103301 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103304 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103311 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103318 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103322 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 103329 */   // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15833>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 103329 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 103332 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103339 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 103344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 103349 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103353 */   GIR_RootConstrainSelectedInstOperands,
     /* 103354 */   // GIR_Coverage, 7028,
     /* 103354 */   GIR_EraseRootFromParent_Done,
     /* 103355 */ // Label 1923: @103355
     /* 103355 */ GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(103403), // Rule ID 280 //
     /* 103360 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103363 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103371 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103375 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103382 */   // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 103382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 103385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103387 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103392 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103397 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103401 */   GIR_RootConstrainSelectedInstOperands,
     /* 103402 */   // GIR_Coverage, 280,
     /* 103402 */   GIR_EraseRootFromParent_Done,
     /* 103403 */ // Label 1924: @103403
     /* 103403 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(103454), // Rule ID 285 //
     /* 103408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 103411 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103414 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103422 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103426 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103433 */   // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 103433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 103436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103438 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103443 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103448 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103452 */   GIR_RootConstrainSelectedInstOperands,
     /* 103453 */   // GIR_Coverage, 285,
     /* 103453 */   GIR_EraseRootFromParent_Done,
     /* 103454 */ // Label 1925: @103454
     /* 103454 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(103508), // Rule ID 7029 //
     /* 103459 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103462 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103469 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103476 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103480 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103487 */   // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15833>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 103490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103492 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103497 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103502 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103506 */   GIR_RootConstrainSelectedInstOperands,
     /* 103507 */   // GIR_Coverage, 7029,
     /* 103507 */   GIR_EraseRootFromParent_Done,
     /* 103508 */ // Label 1926: @103508
     /* 103508 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(103562), // Rule ID 7030 //
     /* 103513 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103516 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103523 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103530 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103534 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103541 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15833>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 103544 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103551 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103556 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103560 */   GIR_RootConstrainSelectedInstOperands,
     /* 103561 */   // GIR_Coverage, 7030,
     /* 103561 */   GIR_EraseRootFromParent_Done,
     /* 103562 */ // Label 1927: @103562
     /* 103562 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(103619), // Rule ID 7384 //
     /* 103567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 103570 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 103573 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 103580 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 103583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 103587 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103591 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 103598 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15802>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 103598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
     /* 103601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103603 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103613 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103617 */   GIR_RootConstrainSelectedInstOperands,
     /* 103618 */   // GIR_Coverage, 7384,
     /* 103618 */   GIR_EraseRootFromParent_Done,
     /* 103619 */ // Label 1928: @103619
     /* 103619 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(103667), // Rule ID 4121 //
     /* 103624 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103627 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103635 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103639 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103646 */   // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 103649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103651 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103656 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103661 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103665 */   GIR_RootConstrainSelectedInstOperands,
     /* 103666 */   // GIR_Coverage, 4121,
     /* 103666 */   GIR_EraseRootFromParent_Done,
     /* 103667 */ // Label 1929: @103667
     /* 103667 */ GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(103715), // Rule ID 4122 //
     /* 103672 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103675 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103683 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103687 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 103694 */   // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 103694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 103697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 103699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103709 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103713 */   GIR_RootConstrainSelectedInstOperands,
     /* 103714 */   // GIR_Coverage, 4122,
     /* 103714 */   GIR_EraseRootFromParent_Done,
     /* 103715 */ // Label 1930: @103715
     /* 103715 */ GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(103802), // Rule ID 4138 //
     /* 103720 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103723 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103727 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 103734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103738 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103742 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 103749 */   // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 103749 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103752 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 103756 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103771 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103775 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103780 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103785 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103791 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103796 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103801 */   // GIR_Coverage, 4138,
     /* 103801 */   GIR_EraseRootFromParent_Done,
     /* 103802 */ // Label 1931: @103802
     /* 103802 */ GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(103889), // Rule ID 4139 //
     /* 103807 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103810 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103814 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 103821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103825 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103829 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 103836 */   // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 103836 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103839 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 103843 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103848 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103853 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103858 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103862 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103867 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103869 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103872 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103875 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103878 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103883 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103888 */   // GIR_Coverage, 4139,
     /* 103888 */   GIR_EraseRootFromParent_Done,
     /* 103889 */ // Label 1932: @103889
     /* 103889 */ GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(103976), // Rule ID 4140 //
     /* 103894 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103897 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103901 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103912 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 103916 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 103923 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 103923 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 103926 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 103930 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103935 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 103940 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 103945 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 103949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103956 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103959 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103962 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 103965 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103970 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 103975 */   // GIR_Coverage, 4140,
     /* 103975 */   GIR_EraseRootFromParent_Done,
     /* 103976 */ // Label 1933: @103976
     /* 103976 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(104063), // Rule ID 4141 //
     /* 103981 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 103984 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 103988 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 103995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 103999 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104003 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 104010 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 104010 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104013 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 104017 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104032 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104038 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104041 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104043 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104046 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104049 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104052 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104057 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104062 */   // GIR_Coverage, 4141,
     /* 104062 */   GIR_EraseRootFromParent_Done,
     /* 104063 */ // Label 1934: @104063
     /* 104063 */ GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(104111), // Rule ID 4149 //
     /* 104068 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104071 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104079 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104083 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 104090 */   // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 104093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104095 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104105 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104109 */   GIR_RootConstrainSelectedInstOperands,
     /* 104110 */   // GIR_Coverage, 4149,
     /* 104110 */   GIR_EraseRootFromParent_Done,
     /* 104111 */ // Label 1935: @104111
     /* 104111 */ GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(104159), // Rule ID 4150 //
     /* 104116 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104119 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104127 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104131 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 104138 */   // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 104138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 104141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104143 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104148 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104153 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104157 */   GIR_RootConstrainSelectedInstOperands,
     /* 104158 */   // GIR_Coverage, 4150,
     /* 104158 */   GIR_EraseRootFromParent_Done,
     /* 104159 */ // Label 1936: @104159
     /* 104159 */ GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(104246), // Rule ID 4161 //
     /* 104164 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104167 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104171 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 104178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104182 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104186 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 104193 */   // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 104193 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104196 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 104200 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104215 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104229 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104232 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104235 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104240 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104245 */   // GIR_Coverage, 4161,
     /* 104245 */   GIR_EraseRootFromParent_Done,
     /* 104246 */ // Label 1937: @104246
     /* 104246 */ GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(104333), // Rule ID 4162 //
     /* 104251 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104254 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104258 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 104265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104269 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104273 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 104280 */   // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 104280 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104283 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 104287 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104302 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104306 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104316 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104319 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104322 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104327 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104332 */   // GIR_Coverage, 4162,
     /* 104332 */   GIR_EraseRootFromParent_Done,
     /* 104333 */ // Label 1938: @104333
     /* 104333 */ GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(104420), // Rule ID 4163 //
     /* 104338 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104341 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104345 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104356 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104360 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 104367 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 104367 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104370 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 104374 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104379 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104384 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104389 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104400 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104403 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104406 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104409 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104414 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104419 */   // GIR_Coverage, 4163,
     /* 104419 */   GIR_EraseRootFromParent_Done,
     /* 104420 */ // Label 1939: @104420
     /* 104420 */ GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(104507), // Rule ID 4164 //
     /* 104425 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104428 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104432 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 104439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104443 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104447 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 104454 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 104454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 104457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 104461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104476 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 104482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104490 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 104496 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 104501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 104506 */   // GIR_Coverage, 4164,
     /* 104506 */   GIR_EraseRootFromParent_Done,
     /* 104507 */ // Label 1940: @104507
     /* 104507 */ GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(104547), // Rule ID 6994 //
     /* 104512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 104515 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104518 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104525 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104532 */   // MIs[0] ptr
     /* 104532 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104540 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15802>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 104540 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
     /* 104545 */   GIR_RootConstrainSelectedInstOperands,
     /* 104546 */   // GIR_Coverage, 6994,
     /* 104546 */   GIR_Done,
     /* 104547 */ // Label 1941: @104547
     /* 104547 */ GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(104584), // Rule ID 7025 //
     /* 104552 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104555 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104562 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 104565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104569 */   // MIs[0] ptr
     /* 104569 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104577 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15830>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 104577 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 104582 */   GIR_RootConstrainSelectedInstOperands,
     /* 104583 */   // GIR_Coverage, 7025,
     /* 104583 */   GIR_Done,
     /* 104584 */ // Label 1942: @104584
     /* 104584 */ GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(104621), // Rule ID 7026 //
     /* 104589 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 104592 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 104599 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 104602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 104606 */   // MIs[0] ptr
     /* 104606 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104610 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104614 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15802>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 104614 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 104619 */   GIR_RootConstrainSelectedInstOperands,
     /* 104620 */   // GIR_Coverage, 7026,
     /* 104620 */   GIR_Done,
     /* 104621 */ // Label 1943: @104621
     /* 104621 */ GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(104652), // Rule ID 6374 //
     /* 104626 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104629 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104637 */   // MIs[0] Rn
     /* 104637 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 104641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 104645 */   // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 104645 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
     /* 104650 */   GIR_RootConstrainSelectedInstOperands,
     /* 104651 */   // GIR_Coverage, 6374,
     /* 104651 */   GIR_Done,
     /* 104652 */ // Label 1944: @104652
     /* 104652 */ GIM_Reject,
     /* 104653 */ // Label 1833: @104653
     /* 104653 */ GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(104861),
     /* 104658 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104661 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104669 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104673 */   GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(104714), // Rule ID 245 //
     /* 104678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 104681 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 104688 */     // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 104688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 104691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104693 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104698 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104712 */     GIR_RootConstrainSelectedInstOperands,
     /* 104713 */     // GIR_Coverage, 245,
     /* 104713 */     GIR_EraseRootFromParent_Done,
     /* 104714 */   // Label 1946: @104714
     /* 104714 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(104755), // Rule ID 246 //
     /* 104719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 104722 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 104729 */     // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 104729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 104732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104753 */     GIR_RootConstrainSelectedInstOperands,
     /* 104754 */     // GIR_Coverage, 246,
     /* 104754 */     GIR_EraseRootFromParent_Done,
     /* 104755 */   // Label 1947: @104755
     /* 104755 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(104791), // Rule ID 265 //
     /* 104760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 104763 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 104770 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 104770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 104773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104789 */     GIR_RootConstrainSelectedInstOperands,
     /* 104790 */     // GIR_Coverage, 265,
     /* 104790 */     GIR_EraseRootFromParent_Done,
     /* 104791 */   // Label 1948: @104791
     /* 104791 */   GIM_Try, /*On fail goto*//*Label 1949*/ GIMT_Encode4(104827), // Rule ID 286 //
     /* 104796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 104799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 104806 */     // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 104806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 104809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104825 */     GIR_RootConstrainSelectedInstOperands,
     /* 104826 */     // GIR_Coverage, 286,
     /* 104826 */     GIR_EraseRootFromParent_Done,
     /* 104827 */   // Label 1949: @104827
     /* 104827 */   GIM_Try, /*On fail goto*//*Label 1950*/ GIMT_Encode4(104860), // Rule ID 4130 //
     /* 104832 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 104839 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 104839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 104842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104844 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104849 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 104854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104858 */     GIR_RootConstrainSelectedInstOperands,
     /* 104859 */     // GIR_Coverage, 4130,
     /* 104859 */     GIR_EraseRootFromParent_Done,
     /* 104860 */   // Label 1950: @104860
     /* 104860 */   GIM_Reject,
     /* 104861 */ // Label 1945: @104861
     /* 104861 */ GIM_Reject,
     /* 104862 */ // Label 1834: @104862
     /* 104862 */ GIM_Try, /*On fail goto*//*Label 1951*/ GIMT_Encode4(105239),
     /* 104867 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 104870 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 104874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104878 */   GIM_Try, /*On fail goto*//*Label 1952*/ GIMT_Encode4(104923), // Rule ID 4064 //
     /* 104883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104890 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 104897 */     // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 104897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 104900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104902 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104921 */     GIR_RootConstrainSelectedInstOperands,
     /* 104922 */     // GIR_Coverage, 4064,
     /* 104922 */     GIR_EraseRootFromParent_Done,
     /* 104923 */   // Label 1952: @104923
     /* 104923 */   GIM_Try, /*On fail goto*//*Label 1953*/ GIMT_Encode4(104968), // Rule ID 4065 //
     /* 104928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104931 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104935 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 104942 */     // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 104942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 104945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104947 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 104957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 104962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 104966 */     GIR_RootConstrainSelectedInstOperands,
     /* 104967 */     // GIR_Coverage, 4065,
     /* 104967 */     GIR_EraseRootFromParent_Done,
     /* 104968 */   // Label 1953: @104968
     /* 104968 */   GIM_Try, /*On fail goto*//*Label 1954*/ GIMT_Encode4(105013), // Rule ID 4066 //
     /* 104973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 104976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 104980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 104987 */     // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 104987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 104990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 104992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105011 */     GIR_RootConstrainSelectedInstOperands,
     /* 105012 */     // GIR_Coverage, 4066,
     /* 105012 */     GIR_EraseRootFromParent_Done,
     /* 105013 */   // Label 1954: @105013
     /* 105013 */   GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(105058), // Rule ID 4067 //
     /* 105018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105021 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105025 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105032 */     // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105056 */     GIR_RootConstrainSelectedInstOperands,
     /* 105057 */     // GIR_Coverage, 4067,
     /* 105057 */     GIR_EraseRootFromParent_Done,
     /* 105058 */   // Label 1955: @105058
     /* 105058 */   GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(105098), // Rule ID 4116 //
     /* 105063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105070 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105077 */     // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105096 */     GIR_RootConstrainSelectedInstOperands,
     /* 105097 */     // GIR_Coverage, 4116,
     /* 105097 */     GIR_EraseRootFromParent_Done,
     /* 105098 */   // Label 1956: @105098
     /* 105098 */   GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(105138), // Rule ID 4119 //
     /* 105103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105110 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105117 */     // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105122 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105132 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105136 */     GIR_RootConstrainSelectedInstOperands,
     /* 105137 */     // GIR_Coverage, 4119,
     /* 105137 */     GIR_EraseRootFromParent_Done,
     /* 105138 */   // Label 1957: @105138
     /* 105138 */   GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(105178), // Rule ID 4144 //
     /* 105143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105157 */     // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105176 */     GIR_RootConstrainSelectedInstOperands,
     /* 105177 */     // GIR_Coverage, 4144,
     /* 105177 */     GIR_EraseRootFromParent_Done,
     /* 105178 */   // Label 1958: @105178
     /* 105178 */   GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(105218), // Rule ID 4145 //
     /* 105183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105190 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105197 */     // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105212 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105216 */     GIR_RootConstrainSelectedInstOperands,
     /* 105217 */     // GIR_Coverage, 4145,
     /* 105217 */     GIR_EraseRootFromParent_Done,
     /* 105218 */   // Label 1959: @105218
     /* 105218 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(105238), // Rule ID 6373 //
     /* 105223 */     // MIs[0] Rn
     /* 105223 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105227 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105231 */     // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
     /* 105236 */     GIR_RootConstrainSelectedInstOperands,
     /* 105237 */     // GIR_Coverage, 6373,
     /* 105237 */     GIR_Done,
     /* 105238 */   // Label 1960: @105238
     /* 105238 */   GIM_Reject,
     /* 105239 */ // Label 1951: @105239
     /* 105239 */ GIM_Reject,
     /* 105240 */ // Label 1835: @105240
     /* 105240 */ GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(105617),
     /* 105245 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105248 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105256 */   GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(105301), // Rule ID 4078 //
     /* 105261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105268 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 105275 */     // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 105275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 105278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105299 */     GIR_RootConstrainSelectedInstOperands,
     /* 105300 */     // GIR_Coverage, 4078,
     /* 105300 */     GIR_EraseRootFromParent_Done,
     /* 105301 */   // Label 1962: @105301
     /* 105301 */   GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(105346), // Rule ID 4079 //
     /* 105306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105313 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 105320 */     // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 105320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 105323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105325 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105344 */     GIR_RootConstrainSelectedInstOperands,
     /* 105345 */     // GIR_Coverage, 4079,
     /* 105345 */     GIR_EraseRootFromParent_Done,
     /* 105346 */   // Label 1963: @105346
     /* 105346 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(105391), // Rule ID 4080 //
     /* 105351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105358 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 105365 */     // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 105365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 105368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105385 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105389 */     GIR_RootConstrainSelectedInstOperands,
     /* 105390 */     // GIR_Coverage, 4080,
     /* 105390 */     GIR_EraseRootFromParent_Done,
     /* 105391 */   // Label 1964: @105391
     /* 105391 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(105436), // Rule ID 4081 //
     /* 105396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105399 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 105410 */     // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 105410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 105413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105430 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105434 */     GIR_RootConstrainSelectedInstOperands,
     /* 105435 */     // GIR_Coverage, 4081,
     /* 105435 */     GIR_EraseRootFromParent_Done,
     /* 105436 */   // Label 1965: @105436
     /* 105436 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(105476), // Rule ID 4124 //
     /* 105441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105448 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105455 */     // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105460 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105465 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105474 */     GIR_RootConstrainSelectedInstOperands,
     /* 105475 */     // GIR_Coverage, 4124,
     /* 105475 */     GIR_EraseRootFromParent_Done,
     /* 105476 */   // Label 1966: @105476
     /* 105476 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(105516), // Rule ID 4128 //
     /* 105481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105484 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 105495 */     // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 105495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 105498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105514 */     GIR_RootConstrainSelectedInstOperands,
     /* 105515 */     // GIR_Coverage, 4128,
     /* 105515 */     GIR_EraseRootFromParent_Done,
     /* 105516 */   // Label 1967: @105516
     /* 105516 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(105556), // Rule ID 4151 //
     /* 105521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105528 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105535 */     // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105554 */     GIR_RootConstrainSelectedInstOperands,
     /* 105555 */     // GIR_Coverage, 4151,
     /* 105555 */     GIR_EraseRootFromParent_Done,
     /* 105556 */   // Label 1968: @105556
     /* 105556 */   GIM_Try, /*On fail goto*//*Label 1969*/ GIMT_Encode4(105596), // Rule ID 4152 //
     /* 105561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105568 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 105575 */     // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 105578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105580 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105594 */     GIR_RootConstrainSelectedInstOperands,
     /* 105595 */     // GIR_Coverage, 4152,
     /* 105595 */     GIR_EraseRootFromParent_Done,
     /* 105596 */   // Label 1969: @105596
     /* 105596 */   GIM_Try, /*On fail goto*//*Label 1970*/ GIMT_Encode4(105616), // Rule ID 6370 //
     /* 105601 */     // MIs[0] Rn
     /* 105601 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105609 */     // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
     /* 105614 */     GIR_RootConstrainSelectedInstOperands,
     /* 105615 */     // GIR_Coverage, 6370,
     /* 105615 */     GIR_Done,
     /* 105616 */   // Label 1970: @105616
     /* 105616 */   GIM_Reject,
     /* 105617 */ // Label 1961: @105617
     /* 105617 */ GIM_Reject,
     /* 105618 */ // Label 1836: @105618
     /* 105618 */ GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(105995),
     /* 105623 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 105626 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 105630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105634 */   GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(105679), // Rule ID 4070 //
     /* 105639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105642 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105646 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105653 */     // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105677 */     GIR_RootConstrainSelectedInstOperands,
     /* 105678 */     // GIR_Coverage, 4070,
     /* 105678 */     GIR_EraseRootFromParent_Done,
     /* 105679 */   // Label 1972: @105679
     /* 105679 */   GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(105724), // Rule ID 4071 //
     /* 105684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105698 */     // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105722 */     GIR_RootConstrainSelectedInstOperands,
     /* 105723 */     // GIR_Coverage, 4071,
     /* 105723 */     GIR_EraseRootFromParent_Done,
     /* 105724 */   // Label 1973: @105724
     /* 105724 */   GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(105769), // Rule ID 4072 //
     /* 105729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105736 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 105743 */     // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 105743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 105746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105767 */     GIR_RootConstrainSelectedInstOperands,
     /* 105768 */     // GIR_Coverage, 4072,
     /* 105768 */     GIR_EraseRootFromParent_Done,
     /* 105769 */   // Label 1974: @105769
     /* 105769 */   GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(105814), // Rule ID 4073 //
     /* 105774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105781 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 105788 */     // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 105788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 105791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 105803 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 105808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105812 */     GIR_RootConstrainSelectedInstOperands,
     /* 105813 */     // GIR_Coverage, 4073,
     /* 105813 */     GIR_EraseRootFromParent_Done,
     /* 105814 */   // Label 1975: @105814
     /* 105814 */   GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(105854), // Rule ID 4118 //
     /* 105819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105826 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105833 */     // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105852 */     GIR_RootConstrainSelectedInstOperands,
     /* 105853 */     // GIR_Coverage, 4118,
     /* 105853 */     GIR_EraseRootFromParent_Done,
     /* 105854 */   // Label 1976: @105854
     /* 105854 */   GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(105894), // Rule ID 4120 //
     /* 105859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105862 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105866 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 105873 */     // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 105873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 105876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105892 */     GIR_RootConstrainSelectedInstOperands,
     /* 105893 */     // GIR_Coverage, 4120,
     /* 105893 */     GIR_EraseRootFromParent_Done,
     /* 105894 */   // Label 1977: @105894
     /* 105894 */   GIM_Try, /*On fail goto*//*Label 1978*/ GIMT_Encode4(105934), // Rule ID 4146 //
     /* 105899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105902 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105906 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105913 */     // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105932 */     GIR_RootConstrainSelectedInstOperands,
     /* 105933 */     // GIR_Coverage, 4146,
     /* 105933 */     GIR_EraseRootFromParent_Done,
     /* 105934 */   // Label 1978: @105934
     /* 105934 */   GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(105974), // Rule ID 4148 //
     /* 105939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 105942 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 105946 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 105953 */     // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 105953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 105956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 105958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 105963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 105968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 105972 */     GIR_RootConstrainSelectedInstOperands,
     /* 105973 */     // GIR_Coverage, 4148,
     /* 105973 */     GIR_EraseRootFromParent_Done,
     /* 105974 */   // Label 1979: @105974
     /* 105974 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(105994), // Rule ID 6372 //
     /* 105979 */     // MIs[0] Rn
     /* 105979 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 105983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 105987 */     // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 105987 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
     /* 105992 */     GIR_RootConstrainSelectedInstOperands,
     /* 105993 */     // GIR_Coverage, 6372,
     /* 105993 */     GIR_Done,
     /* 105994 */   // Label 1980: @105994
     /* 105994 */   GIM_Reject,
     /* 105995 */ // Label 1971: @105995
     /* 105995 */ GIM_Reject,
     /* 105996 */ // Label 1837: @105996
     /* 105996 */ GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(106373),
     /* 106001 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106004 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106012 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(106057), // Rule ID 4082 //
     /* 106017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106024 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106031 */     // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106051 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106055 */     GIR_RootConstrainSelectedInstOperands,
     /* 106056 */     // GIR_Coverage, 4082,
     /* 106056 */     GIR_EraseRootFromParent_Done,
     /* 106057 */   // Label 1982: @106057
     /* 106057 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(106102), // Rule ID 4083 //
     /* 106062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106065 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106069 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 106076 */     // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 106076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 106079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106091 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106100 */     GIR_RootConstrainSelectedInstOperands,
     /* 106101 */     // GIR_Coverage, 4083,
     /* 106101 */     GIR_EraseRootFromParent_Done,
     /* 106102 */   // Label 1983: @106102
     /* 106102 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(106147), // Rule ID 4084 //
     /* 106107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106121 */     // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106145 */     GIR_RootConstrainSelectedInstOperands,
     /* 106146 */     // GIR_Coverage, 4084,
     /* 106146 */     GIR_EraseRootFromParent_Done,
     /* 106147 */   // Label 1984: @106147
     /* 106147 */   GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(106192), // Rule ID 4085 //
     /* 106152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106155 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106159 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 106166 */     // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 106166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 106169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106190 */     GIR_RootConstrainSelectedInstOperands,
     /* 106191 */     // GIR_Coverage, 4085,
     /* 106191 */     GIR_EraseRootFromParent_Done,
     /* 106192 */   // Label 1985: @106192
     /* 106192 */   GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(106232), // Rule ID 4123 //
     /* 106197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106204 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 106211 */     // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 106211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 106214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106230 */     GIR_RootConstrainSelectedInstOperands,
     /* 106231 */     // GIR_Coverage, 4123,
     /* 106231 */     GIR_EraseRootFromParent_Done,
     /* 106232 */   // Label 1986: @106232
     /* 106232 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(106272), // Rule ID 4127 //
     /* 106237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106240 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 106251 */     // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 106251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 106254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106256 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106270 */     GIR_RootConstrainSelectedInstOperands,
     /* 106271 */     // GIR_Coverage, 4127,
     /* 106271 */     GIR_EraseRootFromParent_Done,
     /* 106272 */   // Label 1987: @106272
     /* 106272 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(106312), // Rule ID 4153 //
     /* 106277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106280 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 106291 */     // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 106294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106310 */     GIR_RootConstrainSelectedInstOperands,
     /* 106311 */     // GIR_Coverage, 4153,
     /* 106311 */     GIR_EraseRootFromParent_Done,
     /* 106312 */   // Label 1988: @106312
     /* 106312 */   GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(106352), // Rule ID 4154 //
     /* 106317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106320 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106324 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 106331 */     // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 106334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106336 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106350 */     GIR_RootConstrainSelectedInstOperands,
     /* 106351 */     // GIR_Coverage, 4154,
     /* 106351 */     GIR_EraseRootFromParent_Done,
     /* 106352 */   // Label 1989: @106352
     /* 106352 */   GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(106372), // Rule ID 6369 //
     /* 106357 */     // MIs[0] Rn
     /* 106357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106365 */     // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106365 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
     /* 106370 */     GIR_RootConstrainSelectedInstOperands,
     /* 106371 */     // GIR_Coverage, 6369,
     /* 106371 */     GIR_Done,
     /* 106372 */   // Label 1990: @106372
     /* 106372 */   GIM_Reject,
     /* 106373 */ // Label 1981: @106373
     /* 106373 */ GIM_Reject,
     /* 106374 */ // Label 1838: @106374
     /* 106374 */ GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(106581),
     /* 106379 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106382 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106390 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(106435), // Rule ID 4068 //
     /* 106395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 106409 */     // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 106409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 106412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106433 */     GIR_RootConstrainSelectedInstOperands,
     /* 106434 */     // GIR_Coverage, 4068,
     /* 106434 */     GIR_EraseRootFromParent_Done,
     /* 106435 */   // Label 1992: @106435
     /* 106435 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(106480), // Rule ID 4069 //
     /* 106440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106447 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 106454 */     // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 106454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 106457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106478 */     GIR_RootConstrainSelectedInstOperands,
     /* 106479 */     // GIR_Coverage, 4069,
     /* 106479 */     GIR_EraseRootFromParent_Done,
     /* 106480 */   // Label 1993: @106480
     /* 106480 */   GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(106520), // Rule ID 4117 //
     /* 106485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106488 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 106499 */     // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 106499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 106502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106518 */     GIR_RootConstrainSelectedInstOperands,
     /* 106519 */     // GIR_Coverage, 4117,
     /* 106519 */     GIR_EraseRootFromParent_Done,
     /* 106520 */   // Label 1994: @106520
     /* 106520 */   GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(106560), // Rule ID 4147 //
     /* 106525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 106539 */     // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 106542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106558 */     GIR_RootConstrainSelectedInstOperands,
     /* 106559 */     // GIR_Coverage, 4147,
     /* 106559 */     GIR_EraseRootFromParent_Done,
     /* 106560 */   // Label 1995: @106560
     /* 106560 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(106580), // Rule ID 6371 //
     /* 106565 */     // MIs[0] Rn
     /* 106565 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106569 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106573 */     // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106573 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
     /* 106578 */     GIR_RootConstrainSelectedInstOperands,
     /* 106579 */     // GIR_Coverage, 6371,
     /* 106579 */     GIR_Done,
     /* 106580 */   // Label 1996: @106580
     /* 106580 */   GIM_Reject,
     /* 106581 */ // Label 1991: @106581
     /* 106581 */ GIM_Reject,
     /* 106582 */ // Label 1839: @106582
     /* 106582 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(106959),
     /* 106587 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106590 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106598 */   GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(106643), // Rule ID 4086 //
     /* 106603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106606 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106610 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106617 */     // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106622 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106641 */     GIR_RootConstrainSelectedInstOperands,
     /* 106642 */     // GIR_Coverage, 4086,
     /* 106642 */     GIR_EraseRootFromParent_Done,
     /* 106643 */   // Label 1998: @106643
     /* 106643 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(106688), // Rule ID 4087 //
     /* 106648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106655 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 106662 */     // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 106662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 106665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106672 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106686 */     GIR_RootConstrainSelectedInstOperands,
     /* 106687 */     // GIR_Coverage, 4087,
     /* 106687 */     GIR_EraseRootFromParent_Done,
     /* 106688 */   // Label 1999: @106688
     /* 106688 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(106733), // Rule ID 4088 //
     /* 106693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106700 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106707 */     // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106727 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106731 */     GIR_RootConstrainSelectedInstOperands,
     /* 106732 */     // GIR_Coverage, 4088,
     /* 106732 */     GIR_EraseRootFromParent_Done,
     /* 106733 */   // Label 2000: @106733
     /* 106733 */   GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(106778), // Rule ID 4089 //
     /* 106738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106741 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106745 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 106752 */     // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 106752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 106755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106776 */     GIR_RootConstrainSelectedInstOperands,
     /* 106777 */     // GIR_Coverage, 4089,
     /* 106777 */     GIR_EraseRootFromParent_Done,
     /* 106778 */   // Label 2001: @106778
     /* 106778 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(106818), // Rule ID 4126 //
     /* 106783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106790 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 106797 */     // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 106797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 106800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106816 */     GIR_RootConstrainSelectedInstOperands,
     /* 106817 */     // GIR_Coverage, 4126,
     /* 106817 */     GIR_EraseRootFromParent_Done,
     /* 106818 */   // Label 2002: @106818
     /* 106818 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(106858), // Rule ID 4129 //
     /* 106823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106830 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 106837 */     // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 106837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 106840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106856 */     GIR_RootConstrainSelectedInstOperands,
     /* 106857 */     // GIR_Coverage, 4129,
     /* 106857 */     GIR_EraseRootFromParent_Done,
     /* 106858 */   // Label 2003: @106858
     /* 106858 */   GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(106898), // Rule ID 4155 //
     /* 106863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106866 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106870 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 106877 */     // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 106880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106892 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106896 */     GIR_RootConstrainSelectedInstOperands,
     /* 106897 */     // GIR_Coverage, 4155,
     /* 106897 */     GIR_EraseRootFromParent_Done,
     /* 106898 */   // Label 2004: @106898
     /* 106898 */   GIM_Try, /*On fail goto*//*Label 2005*/ GIMT_Encode4(106938), // Rule ID 4157 //
     /* 106903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 106917 */     // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 106920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106927 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106932 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 106936 */     GIR_RootConstrainSelectedInstOperands,
     /* 106937 */     // GIR_Coverage, 4157,
     /* 106937 */     GIR_EraseRootFromParent_Done,
     /* 106938 */   // Label 2005: @106938
     /* 106938 */   GIM_Try, /*On fail goto*//*Label 2006*/ GIMT_Encode4(106958), // Rule ID 6368 //
     /* 106943 */     // MIs[0] Rn
     /* 106943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 106947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 106951 */     // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 106951 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
     /* 106956 */     GIR_RootConstrainSelectedInstOperands,
     /* 106957 */     // GIR_Coverage, 6368,
     /* 106957 */     GIR_Done,
     /* 106958 */   // Label 2006: @106958
     /* 106958 */   GIM_Reject,
     /* 106959 */ // Label 1997: @106959
     /* 106959 */ GIM_Reject,
     /* 106960 */ // Label 1840: @106960
     /* 106960 */ GIM_Try, /*On fail goto*//*Label 2007*/ GIMT_Encode4(107167),
     /* 106965 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 106968 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 106972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106976 */   GIM_Try, /*On fail goto*//*Label 2008*/ GIMT_Encode4(107021), // Rule ID 4090 //
     /* 106981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 106984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 106988 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 106995 */     // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 106995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 106998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107019 */     GIR_RootConstrainSelectedInstOperands,
     /* 107020 */     // GIR_Coverage, 4090,
     /* 107020 */     GIR_EraseRootFromParent_Done,
     /* 107021 */   // Label 2008: @107021
     /* 107021 */   GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(107066), // Rule ID 4091 //
     /* 107026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 107040 */     // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 107040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 107043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 107055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 107060 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107064 */     GIR_RootConstrainSelectedInstOperands,
     /* 107065 */     // GIR_Coverage, 4091,
     /* 107065 */     GIR_EraseRootFromParent_Done,
     /* 107066 */   // Label 2009: @107066
     /* 107066 */   GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(107106), // Rule ID 4125 //
     /* 107071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107078 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 107085 */     // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 107085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 107088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107104 */     GIR_RootConstrainSelectedInstOperands,
     /* 107105 */     // GIR_Coverage, 4125,
     /* 107105 */     GIR_EraseRootFromParent_Done,
     /* 107106 */   // Label 2010: @107106
     /* 107106 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(107146), // Rule ID 4156 //
     /* 107111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 107118 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 107125 */     // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 107125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 107128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107144 */     GIR_RootConstrainSelectedInstOperands,
     /* 107145 */     // GIR_Coverage, 4156,
     /* 107145 */     GIR_EraseRootFromParent_Done,
     /* 107146 */   // Label 2011: @107146
     /* 107146 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(107166), // Rule ID 6367 //
     /* 107151 */     // MIs[0] Rn
     /* 107151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107159 */     // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 107159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
     /* 107164 */     GIR_RootConstrainSelectedInstOperands,
     /* 107165 */     // GIR_Coverage, 6367,
     /* 107165 */     GIR_Done,
     /* 107166 */   // Label 2012: @107166
     /* 107166 */   GIM_Reject,
     /* 107167 */ // Label 2007: @107167
     /* 107167 */ GIM_Reject,
     /* 107168 */ // Label 1841: @107168
     /* 107168 */ GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(107231), // Rule ID 10893 //
     /* 107173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107176 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107179 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107187 */   // MIs[0] base
     /* 107187 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107195 */   // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 107202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107207 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107210 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
     /* 107215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107217 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107220 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107222 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107225 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107229 */   GIR_RootConstrainSelectedInstOperands,
     /* 107230 */   // GIR_Coverage, 10893,
     /* 107230 */   GIR_EraseRootFromParent_Done,
     /* 107231 */ // Label 2013: @107231
     /* 107231 */ GIM_Reject,
     /* 107232 */ // Label 1842: @107232
     /* 107232 */ GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(107295), // Rule ID 10899 //
     /* 107237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107240 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107243 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107251 */   // MIs[0] base
     /* 107251 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107259 */   // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107259 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107262 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 107266 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107271 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
     /* 107279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107281 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107284 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107286 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107289 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107293 */   GIR_RootConstrainSelectedInstOperands,
     /* 107294 */   // GIR_Coverage, 10899,
     /* 107294 */   GIR_EraseRootFromParent_Done,
     /* 107295 */ // Label 2014: @107295
     /* 107295 */ GIM_Reject,
     /* 107296 */ // Label 1843: @107296
     /* 107296 */ GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(107469),
     /* 107301 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107304 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107312 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107316 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(107364), // Rule ID 10884 //
     /* 107321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107328 */     // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 107335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107340 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107343 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 107348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107353 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107355 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107358 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107362 */     GIR_RootConstrainSelectedInstOperands,
     /* 107363 */     // GIR_Coverage, 10884,
     /* 107363 */     GIR_EraseRootFromParent_Done,
     /* 107364 */   // Label 2016: @107364
     /* 107364 */   GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(107412), // Rule ID 10902 //
     /* 107369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107376 */     // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 107383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107388 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 107396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107401 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107406 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107410 */     GIR_RootConstrainSelectedInstOperands,
     /* 107411 */     // GIR_Coverage, 10902,
     /* 107411 */     GIR_EraseRootFromParent_Done,
     /* 107412 */   // Label 2017: @107412
     /* 107412 */   GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(107440), // Rule ID 10929 //
     /* 107417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107424 */     // (ld:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107429 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107431 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107434 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107438 */     GIR_RootConstrainSelectedInstOperands,
     /* 107439 */     // GIR_Coverage, 10929,
     /* 107439 */     GIR_EraseRootFromParent_Done,
     /* 107440 */   // Label 2018: @107440
     /* 107440 */   GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(107468), // Rule ID 10941 //
     /* 107445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107452 */     // (ld:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107457 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107462 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107466 */     GIR_RootConstrainSelectedInstOperands,
     /* 107467 */     // GIR_Coverage, 10941,
     /* 107467 */     GIR_EraseRootFromParent_Done,
     /* 107468 */   // Label 2019: @107468
     /* 107468 */   GIM_Reject,
     /* 107469 */ // Label 2015: @107469
     /* 107469 */ GIM_Reject,
     /* 107470 */ // Label 1844: @107470
     /* 107470 */ GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(107533), // Rule ID 10890 //
     /* 107475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107478 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107481 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107489 */   // MIs[0] base
     /* 107489 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107497 */   // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 107504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107509 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107512 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
     /* 107517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107519 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107522 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107524 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107527 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107531 */   GIR_RootConstrainSelectedInstOperands,
     /* 107532 */   // GIR_Coverage, 10890,
     /* 107532 */   GIR_EraseRootFromParent_Done,
     /* 107533 */ // Label 2020: @107533
     /* 107533 */ GIM_Reject,
     /* 107534 */ // Label 1845: @107534
     /* 107534 */ GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(107707),
     /* 107539 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107542 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107550 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107554 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(107602), // Rule ID 10872 //
     /* 107559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107566 */     // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 107573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107578 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 107586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107591 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107593 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107600 */     GIR_RootConstrainSelectedInstOperands,
     /* 107601 */     // GIR_Coverage, 10872,
     /* 107601 */     GIR_EraseRootFromParent_Done,
     /* 107602 */   // Label 2022: @107602
     /* 107602 */   GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(107650), // Rule ID 10896 //
     /* 107607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107614 */     // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107614 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107617 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 107621 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107626 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 107634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107639 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107644 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107648 */     GIR_RootConstrainSelectedInstOperands,
     /* 107649 */     // GIR_Coverage, 10896,
     /* 107649 */     GIR_EraseRootFromParent_Done,
     /* 107650 */   // Label 2023: @107650
     /* 107650 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(107678), // Rule ID 10925 //
     /* 107655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107662 */     // (ld:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107667 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107676 */     GIR_RootConstrainSelectedInstOperands,
     /* 107677 */     // GIR_Coverage, 10925,
     /* 107677 */     GIR_EraseRootFromParent_Done,
     /* 107678 */   // Label 2024: @107678
     /* 107678 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(107706), // Rule ID 10937 //
     /* 107683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107690 */     // (ld:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107695 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107700 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107704 */     GIR_RootConstrainSelectedInstOperands,
     /* 107705 */     // GIR_Coverage, 10937,
     /* 107705 */     GIR_EraseRootFromParent_Done,
     /* 107706 */   // Label 2025: @107706
     /* 107706 */   GIM_Reject,
     /* 107707 */ // Label 2021: @107707
     /* 107707 */ GIM_Reject,
     /* 107708 */ // Label 1846: @107708
     /* 107708 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(107881),
     /* 107713 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107716 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107724 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107728 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(107776), // Rule ID 10851 //
     /* 107733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107740 */     // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 107747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107752 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 107760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107765 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107774 */     GIR_RootConstrainSelectedInstOperands,
     /* 107775 */     // GIR_Coverage, 10851,
     /* 107775 */     GIR_EraseRootFromParent_Done,
     /* 107776 */   // Label 2027: @107776
     /* 107776 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(107824), // Rule ID 10887 //
     /* 107781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107788 */     // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 107795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107800 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 107808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107813 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107822 */     GIR_RootConstrainSelectedInstOperands,
     /* 107823 */     // GIR_Coverage, 10887,
     /* 107823 */     GIR_EraseRootFromParent_Done,
     /* 107824 */   // Label 2028: @107824
     /* 107824 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(107852), // Rule ID 10921 //
     /* 107829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107832 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107836 */     // (ld:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107841 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107850 */     GIR_RootConstrainSelectedInstOperands,
     /* 107851 */     // GIR_Coverage, 10921,
     /* 107851 */     GIR_EraseRootFromParent_Done,
     /* 107852 */   // Label 2029: @107852
     /* 107852 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(107880), // Rule ID 10933 //
     /* 107857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 107860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 107864 */     // (ld:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 107867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107869 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107878 */     GIR_RootConstrainSelectedInstOperands,
     /* 107879 */     // GIR_Coverage, 10933,
     /* 107879 */     GIR_EraseRootFromParent_Done,
     /* 107880 */   // Label 2030: @107880
     /* 107880 */   GIM_Reject,
     /* 107881 */ // Label 2026: @107881
     /* 107881 */ GIM_Reject,
     /* 107882 */ // Label 1847: @107882
     /* 107882 */ GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(107925), // Rule ID 2426 //
     /* 107887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107890 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107893 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107897 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 107901 */   // MIs[0] base
     /* 107901 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107909 */   // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
     /* 107912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
     /* 107914 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107919 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107923 */   GIR_RootConstrainSelectedInstOperands,
     /* 107924 */   // GIR_Coverage, 2426,
     /* 107924 */   GIR_EraseRootFromParent_Done,
     /* 107925 */ // Label 2031: @107925
     /* 107925 */ GIM_Reject,
     /* 107926 */ // Label 1848: @107926
     /* 107926 */ GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(108023),
     /* 107931 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 107934 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 107938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 107942 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 107946 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(107994), // Rule ID 10819 //
     /* 107951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 107954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107958 */     // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 107958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 107961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 107965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107970 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 107973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 107975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
     /* 107978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 107980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107983 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 107985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 107988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 107992 */     GIR_RootConstrainSelectedInstOperands,
     /* 107993 */     // GIR_Coverage, 10819,
     /* 107993 */     GIR_EraseRootFromParent_Done,
     /* 107994 */   // Label 2033: @107994
     /* 107994 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(108022), // Rule ID 10917 //
     /* 107999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 108002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 108006 */     // (ld:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 108006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 108009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 108011 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 108013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108016 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108020 */     GIR_RootConstrainSelectedInstOperands,
     /* 108021 */     // GIR_Coverage, 10917,
     /* 108021 */     GIR_EraseRootFromParent_Done,
     /* 108022 */   // Label 2034: @108022
     /* 108022 */   GIM_Reject,
     /* 108023 */ // Label 2032: @108023
     /* 108023 */ GIM_Reject,
     /* 108024 */ // Label 1849: @108024
     /* 108024 */ GIM_Reject,
     /* 108025 */ // Label 17: @108025
     /* 108025 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2037*/ GIMT_Encode4(109074),
     /* 108036 */ /*GILLT_s32*//*Label 2035*/ GIMT_Encode4(108044),
     /* 108040 */ /*GILLT_s64*//*Label 2036*/ GIMT_Encode4(108458),
     /* 108044 */ // Label 2035: @108044
     /* 108044 */ GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(108457),
     /* 108049 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108052 */   GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(108105), // Rule ID 247 //
     /* 108057 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108072 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 108079 */     // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 108079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
     /* 108082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108089 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108094 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108099 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108103 */     GIR_RootConstrainSelectedInstOperands,
     /* 108104 */     // GIR_Coverage, 247,
     /* 108104 */     GIR_EraseRootFromParent_Done,
     /* 108105 */   // Label 2039: @108105
     /* 108105 */   GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(108158), // Rule ID 248 //
     /* 108110 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108132 */     // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
     /* 108135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108152 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108156 */     GIR_RootConstrainSelectedInstOperands,
     /* 108157 */     // GIR_Coverage, 248,
     /* 108157 */     GIR_EraseRootFromParent_Done,
     /* 108158 */   // Label 2040: @108158
     /* 108158 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(108211), // Rule ID 251 //
     /* 108163 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108174 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108185 */     // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
     /* 108188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108209 */     GIR_RootConstrainSelectedInstOperands,
     /* 108210 */     // GIR_Coverage, 251,
     /* 108210 */     GIR_EraseRootFromParent_Done,
     /* 108211 */   // Label 2041: @108211
     /* 108211 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(108264), // Rule ID 252 //
     /* 108216 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108227 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108231 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108238 */     // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 108238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
     /* 108241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108243 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108248 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108258 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108262 */     GIR_RootConstrainSelectedInstOperands,
     /* 108263 */     // GIR_Coverage, 252,
     /* 108263 */     GIR_EraseRootFromParent_Done,
     /* 108264 */   // Label 2042: @108264
     /* 108264 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(108312), // Rule ID 268 //
     /* 108269 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108280 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108284 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 108291 */     // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 108291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
     /* 108294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108310 */     GIR_RootConstrainSelectedInstOperands,
     /* 108311 */     // GIR_Coverage, 268,
     /* 108311 */     GIR_EraseRootFromParent_Done,
     /* 108312 */   // Label 2043: @108312
     /* 108312 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(108360), // Rule ID 270 //
     /* 108317 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108328 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108332 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 108339 */     // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 108339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
     /* 108342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108358 */     GIR_RootConstrainSelectedInstOperands,
     /* 108359 */     // GIR_Coverage, 270,
     /* 108359 */     GIR_EraseRootFromParent_Done,
     /* 108360 */   // Label 2044: @108360
     /* 108360 */   GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(108408), // Rule ID 289 //
     /* 108365 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108380 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 108387 */     // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
     /* 108390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108392 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108406 */     GIR_RootConstrainSelectedInstOperands,
     /* 108407 */     // GIR_Coverage, 289,
     /* 108407 */     GIR_EraseRootFromParent_Done,
     /* 108408 */   // Label 2045: @108408
     /* 108408 */   GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(108456), // Rule ID 291 //
     /* 108413 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 108424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 108435 */     // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
     /* 108438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108454 */     GIR_RootConstrainSelectedInstOperands,
     /* 108455 */     // GIR_Coverage, 291,
     /* 108455 */     GIR_EraseRootFromParent_Done,
     /* 108456 */   // Label 2046: @108456
     /* 108456 */   GIM_Reject,
     /* 108457 */ // Label 2038: @108457
     /* 108457 */ GIM_Reject,
     /* 108458 */ // Label 2036: @108458
     /* 108458 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(109073),
     /* 108463 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 108466 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(108519), // Rule ID 249 //
     /* 108471 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108486 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 108493 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 108493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
     /* 108496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108513 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108517 */     GIR_RootConstrainSelectedInstOperands,
     /* 108518 */     // GIR_Coverage, 249,
     /* 108518 */     GIR_EraseRootFromParent_Done,
     /* 108519 */   // Label 2048: @108519
     /* 108519 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(108572), // Rule ID 250 //
     /* 108524 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108535 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 108546 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 108546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
     /* 108549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108570 */     GIR_RootConstrainSelectedInstOperands,
     /* 108571 */     // GIR_Coverage, 250,
     /* 108571 */     GIR_EraseRootFromParent_Done,
     /* 108572 */   // Label 2049: @108572
     /* 108572 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(108625), // Rule ID 253 //
     /* 108577 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108588 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108592 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 108599 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 108599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
     /* 108602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108619 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108623 */     GIR_RootConstrainSelectedInstOperands,
     /* 108624 */     // GIR_Coverage, 253,
     /* 108624 */     GIR_EraseRootFromParent_Done,
     /* 108625 */   // Label 2050: @108625
     /* 108625 */   GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(108678), // Rule ID 254 //
     /* 108630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 108652 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 108652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
     /* 108655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108667 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108676 */     GIR_RootConstrainSelectedInstOperands,
     /* 108677 */     // GIR_Coverage, 254,
     /* 108677 */     GIR_EraseRootFromParent_Done,
     /* 108678 */   // Label 2051: @108678
     /* 108678 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(108731), // Rule ID 255 //
     /* 108683 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 108690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108698 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 108705 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 108705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
     /* 108708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108710 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108715 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108725 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108729 */     GIR_RootConstrainSelectedInstOperands,
     /* 108730 */     // GIR_Coverage, 255,
     /* 108730 */     GIR_EraseRootFromParent_Done,
     /* 108731 */   // Label 2052: @108731
     /* 108731 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(108784), // Rule ID 256 //
     /* 108736 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 108743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 108758 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 108758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
     /* 108761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 108773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 108778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108782 */     GIR_RootConstrainSelectedInstOperands,
     /* 108783 */     // GIR_Coverage, 256,
     /* 108783 */     GIR_EraseRootFromParent_Done,
     /* 108784 */   // Label 2053: @108784
     /* 108784 */   GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(108832), // Rule ID 269 //
     /* 108789 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108804 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 108811 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 108811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
     /* 108814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108826 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108830 */     GIR_RootConstrainSelectedInstOperands,
     /* 108831 */     // GIR_Coverage, 269,
     /* 108831 */     GIR_EraseRootFromParent_Done,
     /* 108832 */   // Label 2054: @108832
     /* 108832 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(108880), // Rule ID 271 //
     /* 108837 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108848 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108852 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 108859 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 108859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
     /* 108862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108874 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108878 */     GIR_RootConstrainSelectedInstOperands,
     /* 108879 */     // GIR_Coverage, 271,
     /* 108879 */     GIR_EraseRootFromParent_Done,
     /* 108880 */   // Label 2055: @108880
     /* 108880 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(108928), // Rule ID 272 //
     /* 108885 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 108892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 108907 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 108907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
     /* 108910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108926 */     GIR_RootConstrainSelectedInstOperands,
     /* 108927 */     // GIR_Coverage, 272,
     /* 108927 */     GIR_EraseRootFromParent_Done,
     /* 108928 */   // Label 2056: @108928
     /* 108928 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(108976), // Rule ID 290 //
     /* 108933 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 108940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108944 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108948 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 108955 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 108955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
     /* 108958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 108960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 108965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 108970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 108974 */     GIR_RootConstrainSelectedInstOperands,
     /* 108975 */     // GIR_Coverage, 290,
     /* 108975 */     GIR_EraseRootFromParent_Done,
     /* 108976 */   // Label 2057: @108976
     /* 108976 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(109024), // Rule ID 292 //
     /* 108981 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 108988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 108992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 108996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 109003 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
     /* 109006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109013 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109022 */     GIR_RootConstrainSelectedInstOperands,
     /* 109023 */     // GIR_Coverage, 292,
     /* 109023 */     GIR_EraseRootFromParent_Done,
     /* 109024 */   // Label 2058: @109024
     /* 109024 */   GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(109072), // Rule ID 293 //
     /* 109029 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 109036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109044 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 109051 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
     /* 109054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109070 */     GIR_RootConstrainSelectedInstOperands,
     /* 109071 */     // GIR_Coverage, 293,
     /* 109071 */     GIR_EraseRootFromParent_Done,
     /* 109072 */   // Label 2059: @109072
     /* 109072 */   GIM_Reject,
     /* 109073 */ // Label 2047: @109073
     /* 109073 */ GIM_Reject,
     /* 109074 */ // Label 2037: @109074
     /* 109074 */ GIM_Reject,
     /* 109075 */ // Label 18: @109075
     /* 109075 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2062*/ GIMT_Encode4(112043),
     /* 109086 */ /*GILLT_s32*//*Label 2060*/ GIMT_Encode4(109094),
     /* 109090 */ /*GILLT_s64*//*Label 2061*/ GIMT_Encode4(110553),
     /* 109094 */ // Label 2060: @109094
     /* 109094 */ GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(109150), // Rule ID 229 //
     /* 109099 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109102 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109113 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109117 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 109124 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 109124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 109127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109129 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109134 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109139 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109144 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109148 */   GIR_RootConstrainSelectedInstOperands,
     /* 109149 */   // GIR_Coverage, 229,
     /* 109149 */   GIR_EraseRootFromParent_Done,
     /* 109150 */ // Label 2063: @109150
     /* 109150 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(109206), // Rule ID 230 //
     /* 109155 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109158 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109169 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109173 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 109180 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 109180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 109183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109185 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109195 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109200 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109204 */   GIR_RootConstrainSelectedInstOperands,
     /* 109205 */   // GIR_Coverage, 230,
     /* 109205 */   GIR_EraseRootFromParent_Done,
     /* 109206 */ // Label 2064: @109206
     /* 109206 */ GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(109262), // Rule ID 231 //
     /* 109211 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109214 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109225 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109229 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 109236 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 109236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 109239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109241 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109246 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109251 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109256 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109260 */   GIR_RootConstrainSelectedInstOperands,
     /* 109261 */   // GIR_Coverage, 231,
     /* 109261 */   GIR_EraseRootFromParent_Done,
     /* 109262 */ // Label 2065: @109262
     /* 109262 */ GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(109318), // Rule ID 232 //
     /* 109267 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109270 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109281 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109285 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 109292 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 109292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 109295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109297 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109302 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109307 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109312 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109316 */   GIR_RootConstrainSelectedInstOperands,
     /* 109317 */   // GIR_Coverage, 232,
     /* 109317 */   GIR_EraseRootFromParent_Done,
     /* 109318 */ // Label 2066: @109318
     /* 109318 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(109374), // Rule ID 4114 //
     /* 109323 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109326 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109337 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109341 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 109348 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 109348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 109351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109353 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109358 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109363 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109368 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109372 */   GIR_RootConstrainSelectedInstOperands,
     /* 109373 */   // GIR_Coverage, 4114,
     /* 109373 */   GIR_EraseRootFromParent_Done,
     /* 109374 */ // Label 2067: @109374
     /* 109374 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(109430), // Rule ID 4115 //
     /* 109379 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109382 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109393 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109397 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 109404 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 109404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 109407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109409 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109414 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109419 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109424 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109428 */   GIR_RootConstrainSelectedInstOperands,
     /* 109429 */   // GIR_Coverage, 4115,
     /* 109429 */   GIR_EraseRootFromParent_Done,
     /* 109430 */ // Label 2068: @109430
     /* 109430 */ GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(109481), // Rule ID 266 //
     /* 109435 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109438 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109449 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109453 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 109460 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 109460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 109463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109470 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109475 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109479 */   GIR_RootConstrainSelectedInstOperands,
     /* 109480 */   // GIR_Coverage, 266,
     /* 109480 */   GIR_EraseRootFromParent_Done,
     /* 109481 */ // Label 2069: @109481
     /* 109481 */ GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(109532), // Rule ID 267 //
     /* 109486 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109489 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109500 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109504 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 109511 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 109511 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 109514 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109516 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109521 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109526 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109530 */   GIR_RootConstrainSelectedInstOperands,
     /* 109531 */   // GIR_Coverage, 267,
     /* 109531 */   GIR_EraseRootFromParent_Done,
     /* 109532 */ // Label 2070: @109532
     /* 109532 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(109591), // Rule ID 7000 //
     /* 109537 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109540 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109547 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109554 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109558 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 109565 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15808>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 109565 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 109568 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109570 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109575 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109585 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109589 */   GIR_RootConstrainSelectedInstOperands,
     /* 109590 */   // GIR_Coverage, 7000,
     /* 109590 */   GIR_EraseRootFromParent_Done,
     /* 109591 */ // Label 2071: @109591
     /* 109591 */ GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(109650), // Rule ID 7002 //
     /* 109596 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109599 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109606 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109613 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109617 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 109624 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15808>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 109624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 109627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109639 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 109644 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109648 */   GIR_RootConstrainSelectedInstOperands,
     /* 109649 */   // GIR_Coverage, 7002,
     /* 109649 */   GIR_EraseRootFromParent_Done,
     /* 109650 */ // Label 2072: @109650
     /* 109650 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(109709), // Rule ID 7012 //
     /* 109655 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109658 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109665 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109672 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109676 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 109683 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15817>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 109683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 109686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109688 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109693 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109703 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109707 */   GIR_RootConstrainSelectedInstOperands,
     /* 109708 */   // GIR_Coverage, 7012,
     /* 109708 */   GIR_EraseRootFromParent_Done,
     /* 109709 */ // Label 2073: @109709
     /* 109709 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(109768), // Rule ID 7014 //
     /* 109714 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 109717 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109724 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 109727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109731 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109735 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 109742 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15817>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 109742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 109745 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109747 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109752 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 109757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 109762 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109766 */   GIR_RootConstrainSelectedInstOperands,
     /* 109767 */   // GIR_Coverage, 7014,
     /* 109767 */   GIR_EraseRootFromParent_Done,
     /* 109768 */ // Label 2074: @109768
     /* 109768 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(109819), // Rule ID 287 //
     /* 109773 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109776 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109787 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109791 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109798 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 109801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109803 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109808 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109813 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109817 */   GIR_RootConstrainSelectedInstOperands,
     /* 109818 */   // GIR_Coverage, 287,
     /* 109818 */   GIR_EraseRootFromParent_Done,
     /* 109819 */ // Label 2075: @109819
     /* 109819 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(109870), // Rule ID 288 //
     /* 109824 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109827 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109838 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109842 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109849 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 109849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 109852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109859 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109864 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109868 */   GIR_RootConstrainSelectedInstOperands,
     /* 109869 */   // GIR_Coverage, 288,
     /* 109869 */   GIR_EraseRootFromParent_Done,
     /* 109870 */ // Label 2076: @109870
     /* 109870 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(109921), // Rule ID 4133 //
     /* 109875 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109878 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109885 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109889 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109893 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 109900 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 109900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 109903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109915 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109919 */   GIR_RootConstrainSelectedInstOperands,
     /* 109920 */   // GIR_Coverage, 4133,
     /* 109920 */   GIR_EraseRootFromParent_Done,
     /* 109921 */ // Label 2077: @109921
     /* 109921 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(109972), // Rule ID 4165 //
     /* 109926 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109929 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 109936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109940 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109944 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 109951 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 109951 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 109954 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 109956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 109961 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 109966 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 109970 */   GIR_RootConstrainSelectedInstOperands,
     /* 109971 */   // GIR_Coverage, 4165,
     /* 109971 */   GIR_EraseRootFromParent_Done,
     /* 109972 */ // Label 2078: @109972
     /* 109972 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(110023), // Rule ID 4166 //
     /* 109977 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 109980 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 109987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 109991 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 109995 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 110002 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110002 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 110005 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110007 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110012 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110017 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110021 */   GIR_RootConstrainSelectedInstOperands,
     /* 110022 */   // GIR_Coverage, 4166,
     /* 110022 */   GIR_EraseRootFromParent_Done,
     /* 110023 */ // Label 2079: @110023
     /* 110023 */ GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(110074), // Rule ID 4167 //
     /* 110028 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110031 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110042 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110046 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 110053 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 110056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110063 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110068 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110072 */   GIR_RootConstrainSelectedInstOperands,
     /* 110073 */   // GIR_Coverage, 4167,
     /* 110073 */   GIR_EraseRootFromParent_Done,
     /* 110074 */ // Label 2080: @110074
     /* 110074 */ GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(110128), // Rule ID 7004 //
     /* 110079 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110082 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110089 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110096 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110100 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 110107 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15808>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 110107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 110110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110122 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110126 */   GIR_RootConstrainSelectedInstOperands,
     /* 110127 */   // GIR_Coverage, 7004,
     /* 110127 */   GIR_EraseRootFromParent_Done,
     /* 110128 */ // Label 2081: @110128
     /* 110128 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(110182), // Rule ID 7006 //
     /* 110133 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110136 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110143 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110150 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110154 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 110161 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15808>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 110164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110166 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110171 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110176 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110180 */   GIR_RootConstrainSelectedInstOperands,
     /* 110181 */   // GIR_Coverage, 7006,
     /* 110181 */   GIR_EraseRootFromParent_Done,
     /* 110182 */ // Label 2082: @110182
     /* 110182 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(110236), // Rule ID 7016 //
     /* 110187 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110190 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110197 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110204 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110208 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 110215 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15817>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 110215 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 110218 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110220 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110225 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110230 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110234 */   GIR_RootConstrainSelectedInstOperands,
     /* 110235 */   // GIR_Coverage, 7016,
     /* 110235 */   GIR_EraseRootFromParent_Done,
     /* 110236 */ // Label 2083: @110236
     /* 110236 */ GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(110290), // Rule ID 7018 //
     /* 110241 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110244 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110251 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110258 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110262 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 110269 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15817>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 110272 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110274 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110279 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110284 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110288 */   GIR_RootConstrainSelectedInstOperands,
     /* 110289 */   // GIR_Coverage, 7018,
     /* 110289 */   GIR_EraseRootFromParent_Done,
     /* 110290 */ // Label 2084: @110290
     /* 110290 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(110347), // Rule ID 7380 //
     /* 110295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 110298 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110301 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110308 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110315 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110319 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 110326 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15806>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 110329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110331 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110341 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110345 */   GIR_RootConstrainSelectedInstOperands,
     /* 110346 */   // GIR_Coverage, 7380,
     /* 110346 */   GIR_EraseRootFromParent_Done,
     /* 110347 */ // Label 2085: @110347
     /* 110347 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(110404), // Rule ID 7382 //
     /* 110352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 110355 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110358 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110365 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110372 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110376 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 110383 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15815>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 110383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 110386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 110388 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 110398 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110402 */   GIR_RootConstrainSelectedInstOperands,
     /* 110403 */   // GIR_Coverage, 7382,
     /* 110403 */   GIR_EraseRootFromParent_Done,
     /* 110404 */ // Label 2086: @110404
     /* 110404 */ GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(110441), // Rule ID 6996 //
     /* 110409 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110412 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110419 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 110422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110426 */   // MIs[0] ptr
     /* 110426 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110430 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110434 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15804>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110434 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 110439 */   GIR_RootConstrainSelectedInstOperands,
     /* 110440 */   // GIR_Coverage, 6996,
     /* 110440 */   GIR_Done,
     /* 110441 */ // Label 2087: @110441
     /* 110441 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(110478), // Rule ID 6998 //
     /* 110446 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110449 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110456 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110463 */   // MIs[0] ptr
     /* 110463 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110471 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15806>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110471 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 110476 */   GIR_RootConstrainSelectedInstOperands,
     /* 110477 */   // GIR_Coverage, 6998,
     /* 110477 */   GIR_Done,
     /* 110478 */ // Label 2088: @110478
     /* 110478 */ GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(110515), // Rule ID 7008 //
     /* 110483 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110486 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110493 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 110496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110500 */   // MIs[0] ptr
     /* 110500 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110508 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15813>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110508 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 110513 */   GIR_RootConstrainSelectedInstOperands,
     /* 110514 */   // GIR_Coverage, 7008,
     /* 110514 */   GIR_Done,
     /* 110515 */ // Label 2089: @110515
     /* 110515 */ GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(110552), // Rule ID 7010 //
     /* 110520 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 110523 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110530 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 110533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110537 */   // MIs[0] ptr
     /* 110537 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 110541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 110545 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15815>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 110545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 110550 */   GIR_RootConstrainSelectedInstOperands,
     /* 110551 */   // GIR_Coverage, 7010,
     /* 110551 */   GIR_Done,
     /* 110552 */ // Label 2090: @110552
     /* 110552 */ GIM_Reject,
     /* 110553 */ // Label 2061: @110553
     /* 110553 */ GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(112042),
     /* 110558 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 110561 */   GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(110646), // Rule ID 4092 //
     /* 110566 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 110588 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 110595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110615 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110629 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110635 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110645 */     // GIR_Coverage, 4092,
     /* 110645 */     GIR_EraseRootFromParent_Done,
     /* 110646 */   // Label 2092: @110646
     /* 110646 */   GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(110731), // Rule ID 4093 //
     /* 110651 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 110658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110662 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 110673 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 110680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110690 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110695 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110700 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110717 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110725 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110730 */     // GIR_Coverage, 4093,
     /* 110730 */     GIR_EraseRootFromParent_Done,
     /* 110731 */   // Label 2093: @110731
     /* 110731 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(110816), // Rule ID 4094 //
     /* 110736 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110747 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 110758 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 110765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110785 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110815 */     // GIR_Coverage, 4094,
     /* 110815 */     GIR_EraseRootFromParent_Done,
     /* 110816 */   // Label 2094: @110816
     /* 110816 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(110901), // Rule ID 4095 //
     /* 110821 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 110828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110836 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 110843 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 110850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110855 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110860 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110865 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110870 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110874 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110900 */     // GIR_Coverage, 4095,
     /* 110900 */     GIR_EraseRootFromParent_Done,
     /* 110901 */   // Label 2095: @110901
     /* 110901 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(110986), // Rule ID 4096 //
     /* 110906 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 110913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 110921 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 110928 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 110928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 110931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 110935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 110945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 110950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 110955 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 110959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 110961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 110964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 110975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 110980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 110985 */     // GIR_Coverage, 4096,
     /* 110985 */     GIR_EraseRootFromParent_Done,
     /* 110986 */   // Label 2096: @110986
     /* 110986 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(111071), // Rule ID 4097 //
     /* 110991 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 110998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111002 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111006 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 111013 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 111020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111025 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111040 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111054 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111057 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111070 */     // GIR_Coverage, 4097,
     /* 111070 */     GIR_EraseRootFromParent_Done,
     /* 111071 */   // Label 2097: @111071
     /* 111071 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(111156), // Rule ID 4098 //
     /* 111076 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111087 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111091 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 111098 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 111105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111125 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111139 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111145 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111155 */     // GIR_Coverage, 4098,
     /* 111155 */     GIR_EraseRootFromParent_Done,
     /* 111156 */   // Label 2098: @111156
     /* 111156 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(111241), // Rule ID 4099 //
     /* 111161 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111176 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 111183 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 111183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 111190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 111205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 111210 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111230 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111235 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111240 */     // GIR_Coverage, 4099,
     /* 111240 */     GIR_EraseRootFromParent_Done,
     /* 111241 */   // Label 2099: @111241
     /* 111241 */   GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(111321), // Rule ID 4131 //
     /* 111246 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 111268 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 111268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 111275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111290 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111304 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111320 */     // GIR_Coverage, 4131,
     /* 111320 */     GIR_EraseRootFromParent_Done,
     /* 111321 */   // Label 2100: @111321
     /* 111321 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(111401), // Rule ID 4132 //
     /* 111326 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 111348 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 111348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 111355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111370 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111384 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111390 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111400 */     // GIR_Coverage, 4132,
     /* 111400 */     GIR_EraseRootFromParent_Done,
     /* 111401 */   // Label 2101: @111401
     /* 111401 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(111481), // Rule ID 4134 //
     /* 111406 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111421 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 111428 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 111428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 111435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111450 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111480 */     // GIR_Coverage, 4134,
     /* 111480 */     GIR_EraseRootFromParent_Done,
     /* 111481 */   // Label 2102: @111481
     /* 111481 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(111561), // Rule ID 4142 //
     /* 111486 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 111493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 111508 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 111508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 111515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111530 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111555 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111560 */     // GIR_Coverage, 4142,
     /* 111560 */     GIR_EraseRootFromParent_Done,
     /* 111561 */   // Label 2103: @111561
     /* 111561 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(111641), // Rule ID 4168 //
     /* 111566 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 111573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111577 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111581 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 111588 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 111595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111610 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111635 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111640 */     // GIR_Coverage, 4168,
     /* 111640 */     GIR_EraseRootFromParent_Done,
     /* 111641 */   // Label 2104: @111641
     /* 111641 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(111721), // Rule ID 4169 //
     /* 111646 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 111668 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 111675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111690 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111720 */     // GIR_Coverage, 4169,
     /* 111720 */     GIR_EraseRootFromParent_Done,
     /* 111721 */   // Label 2105: @111721
     /* 111721 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(111801), // Rule ID 4170 //
     /* 111726 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111737 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111741 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 111748 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 111755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111770 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111774 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111781 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111787 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111795 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111800 */     // GIR_Coverage, 4170,
     /* 111800 */     GIR_EraseRootFromParent_Done,
     /* 111801 */   // Label 2106: @111801
     /* 111801 */   GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(111881), // Rule ID 4171 //
     /* 111806 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 111828 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 111835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111850 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111880 */     // GIR_Coverage, 4171,
     /* 111880 */     GIR_EraseRootFromParent_Done,
     /* 111881 */   // Label 2107: @111881
     /* 111881 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(111961), // Rule ID 4172 //
     /* 111886 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 111893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 111908 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 111915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 111925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 111930 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 111934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 111936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 111939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 111941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 111944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 111950 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111955 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 111960 */     // GIR_Coverage, 4172,
     /* 111960 */     GIR_EraseRootFromParent_Done,
     /* 111961 */   // Label 2108: @111961
     /* 111961 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(112041), // Rule ID 4173 //
     /* 111966 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 111973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 111977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 111981 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 111988 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 111988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 111991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 111995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112010 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112024 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 112030 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 112035 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112040 */     // GIR_Coverage, 4173,
     /* 112040 */     GIR_EraseRootFromParent_Done,
     /* 112041 */   // Label 2109: @112041
     /* 112041 */   GIM_Reject,
     /* 112042 */ // Label 2091: @112042
     /* 112042 */ GIM_Reject,
     /* 112043 */ // Label 2062: @112043
     /* 112043 */ GIM_Reject,
     /* 112044 */ // Label 19: @112044
     /* 112044 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2130*/ GIMT_Encode4(125569),
     /* 112055 */ /*GILLT_s8*//*Label 2110*/ GIMT_Encode4(112151),
     /* 112059 */ /*GILLT_s16*//*Label 2111*/ GIMT_Encode4(112518),
     /* 112063 */ /*GILLT_s32*//*Label 2112*/ GIMT_Encode4(113657),
     /* 112067 */ /*GILLT_s64*//*Label 2113*/ GIMT_Encode4(118252),
     /* 112071 */ /*GILLT_s128*//*Label 2114*/ GIMT_Encode4(122021),
     /* 112075 */ /*GILLT_v2s32*//*Label 2115*/ GIMT_Encode4(122227),
     /* 112079 */ /*GILLT_v2s64*//*Label 2116*/ GIMT_Encode4(122633),
     /* 112083 */ /*GILLT_v4s16*//*Label 2117*/ GIMT_Encode4(123083),
     /* 112087 */ /*GILLT_v4s32*//*Label 2118*/ GIMT_Encode4(123489),
     /* 112091 */ /*GILLT_v8s8*//*Label 2119*/ GIMT_Encode4(123895),
     /* 112095 */ /*GILLT_v8s16*//*Label 2120*/ GIMT_Encode4(124115),
     /* 112099 */ /*GILLT_v16s8*//*Label 2121*/ GIMT_Encode4(124521), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 112111 */ /*GILLT_nxv2s16*//*Label 2122*/ GIMT_Encode4(124741),
     /* 112115 */ /*GILLT_nxv2s32*//*Label 2123*/ GIMT_Encode4(124801),
     /* 112119 */ /*GILLT_nxv2s64*//*Label 2124*/ GIMT_Encode4(124861), GIMT_Encode4(0),
     /* 112127 */ /*GILLT_nxv4s16*//*Label 2125*/ GIMT_Encode4(125031),
     /* 112131 */ /*GILLT_nxv4s32*//*Label 2126*/ GIMT_Encode4(125091), GIMT_Encode4(0),
     /* 112139 */ /*GILLT_nxv8s16*//*Label 2127*/ GIMT_Encode4(125261),
     /* 112143 */ /*GILLT_nxv16s1*//*Label 2128*/ GIMT_Encode4(125431),
     /* 112147 */ /*GILLT_nxv16s8*//*Label 2129*/ GIMT_Encode4(125475),
     /* 112151 */ // Label 2110: @112151
     /* 112151 */ GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(112517),
     /* 112156 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112159 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112163 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(112231), // Rule ID 13120 //
     /* 112168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 112193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112197 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 112201 */     // MIs[2] Operand 1
     /* 112201 */     // No operand predicates
     /* 112201 */     // MIs[0] Rn
     /* 112201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 112205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 112209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112211 */     // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 112211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 112214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 112218 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 112221 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 112223 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 112229 */     GIR_RootConstrainSelectedInstOperands,
     /* 112230 */     // GIR_Coverage, 13120,
     /* 112230 */     GIR_EraseRootFromParent_Done,
     /* 112231 */   // Label 2132: @112231
     /* 112231 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(112330), // Rule ID 13121 //
     /* 112236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 112248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112252 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 112261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 112265 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 112269 */     // MIs[2] Operand 1
     /* 112269 */     // No operand predicates
     /* 112269 */     // MIs[0] Rn
     /* 112269 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 112273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 112277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 112279 */     // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 112279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112291 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 112294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 112298 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 112301 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112306 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 112314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 112320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 112322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 112328 */     GIR_RootConstrainSelectedInstOperands,
     /* 112329 */     // GIR_Coverage, 13121,
     /* 112329 */     GIR_EraseRootFromParent_Done,
     /* 112330 */   // Label 2133: @112330
     /* 112330 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(112379), // Rule ID 303 //
     /* 112335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 112342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112346 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 112353 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 112353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
     /* 112356 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112377 */     GIR_RootConstrainSelectedInstOperands,
     /* 112378 */     // GIR_Coverage, 303,
     /* 112378 */     GIR_EraseRootFromParent_Done,
     /* 112379 */   // Label 2134: @112379
     /* 112379 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(112428), // Rule ID 304 //
     /* 112384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 112391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 112402 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 112402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
     /* 112405 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112426 */     GIR_RootConstrainSelectedInstOperands,
     /* 112427 */     // GIR_Coverage, 304,
     /* 112427 */     GIR_EraseRootFromParent_Done,
     /* 112428 */   // Label 2135: @112428
     /* 112428 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(112472), // Rule ID 313 //
     /* 112433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 112440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112444 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 112451 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 112451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
     /* 112454 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112470 */     GIR_RootConstrainSelectedInstOperands,
     /* 112471 */     // GIR_Coverage, 313,
     /* 112471 */     GIR_EraseRootFromParent_Done,
     /* 112472 */   // Label 2136: @112472
     /* 112472 */   GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(112516), // Rule ID 321 //
     /* 112477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 112480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 112484 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112488 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 112495 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 112495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
     /* 112498 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 112500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 112510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 112514 */     GIR_RootConstrainSelectedInstOperands,
     /* 112515 */     // GIR_Coverage, 321,
     /* 112515 */     GIR_EraseRootFromParent_Done,
     /* 112516 */   // Label 2137: @112516
     /* 112516 */   GIM_Reject,
     /* 112517 */ // Label 2131: @112517
     /* 112517 */ GIM_Reject,
     /* 112518 */ // Label 2111: @112518
     /* 112518 */ GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(113656),
     /* 112523 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 112526 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 112530 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(112629), // Rule ID 4470 //
     /* 112535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112556 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112560 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112564 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 112573 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 112573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112585 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 112604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112607 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112622 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112627 */     GIR_RootConstrainSelectedInstOperands,
     /* 112628 */     // GIR_Coverage, 4470,
     /* 112628 */     GIR_EraseRootFromParent_Done,
     /* 112629 */   // Label 2139: @112629
     /* 112629 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(112728), // Rule ID 4471 //
     /* 112634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112646 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112655 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112663 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112665 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 112672 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 112672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112684 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 112703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112726 */     GIR_RootConstrainSelectedInstOperands,
     /* 112727 */     // GIR_Coverage, 4471,
     /* 112727 */     GIR_EraseRootFromParent_Done,
     /* 112728 */   // Label 2140: @112728
     /* 112728 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(112827), // Rule ID 13118 //
     /* 112733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112754 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112764 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 112771 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 112771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112783 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112789 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112794 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 112802 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112810 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112825 */     GIR_RootConstrainSelectedInstOperands,
     /* 112826 */     // GIR_Coverage, 13118,
     /* 112826 */     GIR_EraseRootFromParent_Done,
     /* 112827 */   // Label 2141: @112827
     /* 112827 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(112926), // Rule ID 13119 //
     /* 112832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112853 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 112870 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 112870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112882 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112893 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 112901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 112909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 112914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 112919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 112924 */     GIR_RootConstrainSelectedInstOperands,
     /* 112925 */     // GIR_Coverage, 13119,
     /* 112925 */     GIR_EraseRootFromParent_Done,
     /* 112926 */   // Label 2142: @112926
     /* 112926 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(113020), // Rule ID 4499 //
     /* 112931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 112935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 112939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 112947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112952 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 112956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 112960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112962 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 112969 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 112969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 112972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112981 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 112987 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 112992 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 113000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113003 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113018 */     GIR_RootConstrainSelectedInstOperands,
     /* 113019 */     // GIR_Coverage, 4499,
     /* 113019 */     GIR_EraseRootFromParent_Done,
     /* 113020 */   // Label 2143: @113020
     /* 113020 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(113114), // Rule ID 4524 //
     /* 113025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113046 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113050 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113056 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 113063 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113075 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113086 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 113094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113112 */     GIR_RootConstrainSelectedInstOperands,
     /* 113113 */     // GIR_Coverage, 4524,
     /* 113113 */     GIR_EraseRootFromParent_Done,
     /* 113114 */   // Label 2144: @113114
     /* 113114 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(113208), // Rule ID 13117 //
     /* 113119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113140 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113150 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 113157 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 113157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113169 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113175 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113180 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 113188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113191 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113201 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113206 */     GIR_RootConstrainSelectedInstOperands,
     /* 113207 */     // GIR_Coverage, 13117,
     /* 113207 */     GIR_EraseRootFromParent_Done,
     /* 113208 */   // Label 2145: @113208
     /* 113208 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(113302), // Rule ID 13123 //
     /* 113213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113234 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113238 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113242 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113244 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 113251 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 113251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113263 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113269 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113274 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 113282 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113295 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113300 */     GIR_RootConstrainSelectedInstOperands,
     /* 113301 */     // GIR_Coverage, 13123,
     /* 113301 */     GIR_EraseRootFromParent_Done,
     /* 113302 */   // Label 2146: @113302
     /* 113302 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(113370), // Rule ID 6434 //
     /* 113307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113328 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113332 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 113336 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 113340 */     // MIs[2] Operand 1
     /* 113340 */     // No operand predicates
     /* 113340 */     // MIs[0] Rn
     /* 113340 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 113348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113350 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 113350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 113353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 113357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 113360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 113362 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 113368 */     GIR_RootConstrainSelectedInstOperands,
     /* 113369 */     // GIR_Coverage, 6434,
     /* 113369 */     GIR_EraseRootFromParent_Done,
     /* 113370 */   // Label 2147: @113370
     /* 113370 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(113469), // Rule ID 6439 //
     /* 113375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 113404 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 113408 */     // MIs[2] Operand 1
     /* 113408 */     // No operand predicates
     /* 113408 */     // MIs[0] Rn
     /* 113408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 113412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 113416 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113418 */     // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 113418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 113421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 113425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113430 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 113433 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 113437 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 113440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113445 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 113453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 113459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 113461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 113467 */     GIR_RootConstrainSelectedInstOperands,
     /* 113468 */     // GIR_Coverage, 6439,
     /* 113468 */     GIR_EraseRootFromParent_Done,
     /* 113469 */   // Label 2148: @113469
     /* 113469 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(113518), // Rule ID 305 //
     /* 113474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113481 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 113492 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 113492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 113495 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113497 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113502 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113516 */     GIR_RootConstrainSelectedInstOperands,
     /* 113517 */     // GIR_Coverage, 305,
     /* 113517 */     GIR_EraseRootFromParent_Done,
     /* 113518 */   // Label 2149: @113518
     /* 113518 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(113567), // Rule ID 306 //
     /* 113523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113530 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 113541 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 113541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 113544 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113565 */     GIR_RootConstrainSelectedInstOperands,
     /* 113566 */     // GIR_Coverage, 306,
     /* 113566 */     GIR_EraseRootFromParent_Done,
     /* 113567 */   // Label 2150: @113567
     /* 113567 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(113611), // Rule ID 314 //
     /* 113572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 113590 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 113590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 113593 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113609 */     GIR_RootConstrainSelectedInstOperands,
     /* 113610 */     // GIR_Coverage, 314,
     /* 113610 */     GIR_EraseRootFromParent_Done,
     /* 113611 */   // Label 2151: @113611
     /* 113611 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(113655), // Rule ID 322 //
     /* 113616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 113619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113623 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113627 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 113634 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 113634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 113637 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 113639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 113649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 113653 */     GIR_RootConstrainSelectedInstOperands,
     /* 113654 */     // GIR_Coverage, 322,
     /* 113654 */     GIR_EraseRootFromParent_Done,
     /* 113655 */   // Label 2152: @113655
     /* 113655 */   GIM_Reject,
     /* 113656 */ // Label 2138: @113656
     /* 113656 */ GIM_Reject,
     /* 113657 */ // Label 2112: @113657
     /* 113657 */ GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(113770), // Rule ID 4468 //
     /* 113662 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113665 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113669 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113676 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113680 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113684 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113688 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113692 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113697 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113701 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113705 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113707 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 113714 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 113714 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113717 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113721 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113726 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113732 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113737 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 113745 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113748 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113753 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113758 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113763 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113768 */   GIR_RootConstrainSelectedInstOperands,
     /* 113769 */   // GIR_Coverage, 4468,
     /* 113769 */   GIR_EraseRootFromParent_Done,
     /* 113770 */ // Label 2153: @113770
     /* 113770 */ GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(113883), // Rule ID 4469 //
     /* 113775 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113778 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113782 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 113789 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113793 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113797 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113801 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113805 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113810 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113814 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113818 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113820 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 113827 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 113827 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 113830 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113834 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113839 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 113845 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 113850 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 113858 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113866 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113871 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113876 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113881 */   GIR_RootConstrainSelectedInstOperands,
     /* 113882 */   // GIR_Coverage, 4469,
     /* 113882 */   GIR_EraseRootFromParent_Done,
     /* 113883 */ // Label 2154: @113883
     /* 113883 */ GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(113989), // Rule ID 4472 //
     /* 113888 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113891 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 113895 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 113899 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 113903 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113907 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 113911 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113916 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 113920 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 113924 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113926 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 113933 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 113933 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 113936 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113940 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113945 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 113951 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 113956 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 113964 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 113972 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 113977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 113982 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 113987 */   GIR_RootConstrainSelectedInstOperands,
     /* 113988 */   // GIR_Coverage, 4472,
     /* 113988 */   GIR_EraseRootFromParent_Done,
     /* 113989 */ // Label 2155: @113989
     /* 113989 */ GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(114095), // Rule ID 4473 //
     /* 113994 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 113997 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114001 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114005 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114009 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114013 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114017 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114022 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114026 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114030 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114032 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 114039 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 114039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114051 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114057 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114062 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 114070 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114073 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114078 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114083 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114088 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114093 */   GIR_RootConstrainSelectedInstOperands,
     /* 114094 */   // GIR_Coverage, 4473,
     /* 114094 */   GIR_EraseRootFromParent_Done,
     /* 114095 */ // Label 2156: @114095
     /* 114095 */ GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(114201), // Rule ID 4474 //
     /* 114100 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114103 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114107 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114111 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114115 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114119 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114123 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114128 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114132 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114136 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114138 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 114145 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 114145 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114148 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114152 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114157 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114163 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114168 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114173 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 114176 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114179 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114184 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114189 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114194 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114199 */   GIR_RootConstrainSelectedInstOperands,
     /* 114200 */   // GIR_Coverage, 4474,
     /* 114200 */   GIR_EraseRootFromParent_Done,
     /* 114201 */ // Label 2157: @114201
     /* 114201 */ GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(114307), // Rule ID 4475 //
     /* 114206 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114209 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114213 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114217 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114221 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114225 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114229 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114234 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114238 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114242 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114244 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 114251 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 114251 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114254 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114258 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114263 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114269 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114274 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114279 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 114282 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114290 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114295 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114300 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114305 */   GIR_RootConstrainSelectedInstOperands,
     /* 114306 */   // GIR_Coverage, 4475,
     /* 114306 */   GIR_EraseRootFromParent_Done,
     /* 114307 */ // Label 2158: @114307
     /* 114307 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(114413), // Rule ID 13125 //
     /* 114312 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114315 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114319 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114323 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114327 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114331 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114335 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114340 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114344 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114348 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114350 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 114357 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 114357 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114360 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114364 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114369 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114375 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114380 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114385 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 114388 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114391 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114396 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114401 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114406 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114411 */   GIR_RootConstrainSelectedInstOperands,
     /* 114412 */   // GIR_Coverage, 13125,
     /* 114412 */   GIR_EraseRootFromParent_Done,
     /* 114413 */ // Label 2159: @114413
     /* 114413 */ GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(114519), // Rule ID 13126 //
     /* 114418 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114421 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114425 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114429 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114433 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114437 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114441 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114446 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114450 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114454 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114456 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 114463 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 114463 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114466 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114470 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114475 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114481 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114486 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 114491 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 114494 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114497 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 114507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 114512 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114517 */   GIR_RootConstrainSelectedInstOperands,
     /* 114518 */   // GIR_Coverage, 13126,
     /* 114518 */   GIR_EraseRootFromParent_Done,
     /* 114519 */ // Label 2160: @114519
     /* 114519 */ GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(114627), // Rule ID 4498 //
     /* 114524 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114527 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114531 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114538 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114542 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114546 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114550 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114554 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114559 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114563 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114567 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114569 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 114576 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 114576 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114579 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114583 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114588 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 114594 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114599 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 114607 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114620 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114625 */   GIR_RootConstrainSelectedInstOperands,
     /* 114626 */   // GIR_Coverage, 4498,
     /* 114626 */   GIR_EraseRootFromParent_Done,
     /* 114627 */ // Label 2161: @114627
     /* 114627 */ GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(114728), // Rule ID 4500 //
     /* 114632 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114635 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114639 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114643 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114647 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114651 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114655 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114660 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114664 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114668 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114670 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 114677 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 114677 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114680 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114684 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114689 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114695 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114700 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 114708 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114716 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114721 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114726 */   GIR_RootConstrainSelectedInstOperands,
     /* 114727 */   // GIR_Coverage, 4500,
     /* 114727 */   GIR_EraseRootFromParent_Done,
     /* 114728 */ // Label 2162: @114728
     /* 114728 */ GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(114829), // Rule ID 4501 //
     /* 114733 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114736 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114740 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114744 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114748 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114752 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114756 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114761 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114765 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114769 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114771 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 114778 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 114778 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114781 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114785 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114790 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 114796 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 114801 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 114809 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114812 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114822 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114827 */   GIR_RootConstrainSelectedInstOperands,
     /* 114828 */   // GIR_Coverage, 4501,
     /* 114828 */   GIR_EraseRootFromParent_Done,
     /* 114829 */ // Label 2163: @114829
     /* 114829 */ GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(114937), // Rule ID 4523 //
     /* 114834 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114837 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114841 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 114848 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114852 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114856 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114860 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114864 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114869 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114873 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114877 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114879 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 114886 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114886 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 114889 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114893 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114898 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 114904 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 114909 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 114917 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 114925 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 114930 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 114935 */   GIR_RootConstrainSelectedInstOperands,
     /* 114936 */   // GIR_Coverage, 4523,
     /* 114936 */   GIR_EraseRootFromParent_Done,
     /* 114937 */ // Label 2164: @114937
     /* 114937 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(115038), // Rule ID 4525 //
     /* 114942 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 114945 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 114949 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 114953 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 114957 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114961 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114965 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114970 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 114974 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 114978 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114980 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 114987 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 114987 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114990 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114994 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114999 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115005 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115010 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115015 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 115018 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115031 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115036 */   GIR_RootConstrainSelectedInstOperands,
     /* 115037 */   // GIR_Coverage, 4525,
     /* 115037 */   GIR_EraseRootFromParent_Done,
     /* 115038 */ // Label 2165: @115038
     /* 115038 */ GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(115139), // Rule ID 4526 //
     /* 115043 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115046 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115050 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115054 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115058 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115062 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115066 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115071 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115075 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115079 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115081 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 115088 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 115088 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115091 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115095 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115100 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115106 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115111 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 115119 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115132 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115137 */   GIR_RootConstrainSelectedInstOperands,
     /* 115138 */   // GIR_Coverage, 4526,
     /* 115138 */   GIR_EraseRootFromParent_Done,
     /* 115139 */ // Label 2166: @115139
     /* 115139 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(115240), // Rule ID 13122 //
     /* 115144 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115147 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115151 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115155 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115159 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115163 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115167 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115172 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115176 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115180 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115182 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 115189 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 115189 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115192 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115196 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115201 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115207 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115212 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 115220 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115233 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115238 */   GIR_RootConstrainSelectedInstOperands,
     /* 115239 */   // GIR_Coverage, 13122,
     /* 115239 */   GIR_EraseRootFromParent_Done,
     /* 115240 */ // Label 2167: @115240
     /* 115240 */ GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(115341), // Rule ID 13124 //
     /* 115245 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115248 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115252 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115256 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115260 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115264 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115268 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115273 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 115277 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 115281 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115283 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 115290 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 115290 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115293 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115297 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115302 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 115308 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 115313 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 115321 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115324 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 115329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 115334 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 115339 */   GIR_RootConstrainSelectedInstOperands,
     /* 115340 */   // GIR_Coverage, 13124,
     /* 115340 */   GIR_EraseRootFromParent_Done,
     /* 115341 */ // Label 2168: @115341
     /* 115341 */ GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(115423), // Rule ID 6428 //
     /* 115346 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115349 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115353 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115360 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115364 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115368 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 115372 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115376 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115381 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115385 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115389 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 115393 */   // MIs[2] Operand 1
     /* 115393 */   // No operand predicates
     /* 115393 */   // MIs[0] Rn
     /* 115393 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115401 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115403 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115403 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 115406 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115410 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115413 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115415 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115421 */   GIR_RootConstrainSelectedInstOperands,
     /* 115422 */   // GIR_Coverage, 6428,
     /* 115422 */   GIR_EraseRootFromParent_Done,
     /* 115423 */ // Label 2169: @115423
     /* 115423 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(115505), // Rule ID 6429 //
     /* 115428 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115431 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115435 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115442 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115446 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115450 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 115454 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115458 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115463 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115467 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115471 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 115475 */   // MIs[2] Operand 1
     /* 115475 */   // No operand predicates
     /* 115475 */   // MIs[0] Rn
     /* 115475 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115483 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115485 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 115488 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115492 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115495 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115497 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115503 */   GIR_RootConstrainSelectedInstOperands,
     /* 115504 */   // GIR_Coverage, 6429,
     /* 115504 */   GIR_EraseRootFromParent_Done,
     /* 115505 */ // Label 2170: @115505
     /* 115505 */ GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(115580), // Rule ID 6430 //
     /* 115510 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115513 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115517 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115521 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115525 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115529 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115533 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115538 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115542 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115546 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 115550 */   // MIs[2] Operand 1
     /* 115550 */   // No operand predicates
     /* 115550 */   // MIs[0] Rn
     /* 115550 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115558 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115560 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 115563 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115567 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115570 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115572 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115578 */   GIR_RootConstrainSelectedInstOperands,
     /* 115579 */   // GIR_Coverage, 6430,
     /* 115579 */   GIR_EraseRootFromParent_Done,
     /* 115580 */ // Label 2171: @115580
     /* 115580 */ GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(115655), // Rule ID 6431 //
     /* 115585 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115588 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115592 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115596 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115600 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115604 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115608 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115613 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115617 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115621 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 115625 */   // MIs[2] Operand 1
     /* 115625 */   // No operand predicates
     /* 115625 */   // MIs[0] Rn
     /* 115625 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115633 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115635 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 115638 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115642 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115645 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115647 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115653 */   GIR_RootConstrainSelectedInstOperands,
     /* 115654 */   // GIR_Coverage, 6431,
     /* 115654 */   GIR_EraseRootFromParent_Done,
     /* 115655 */ // Label 2172: @115655
     /* 115655 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(115768), // Rule ID 6435 //
     /* 115660 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115663 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115667 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 115674 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115678 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115682 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 115686 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115690 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115695 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115699 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115703 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 115707 */   // MIs[2] Operand 1
     /* 115707 */   // No operand predicates
     /* 115707 */   // MIs[0] Rn
     /* 115707 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115715 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115717 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115717 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115720 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115724 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115729 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 115732 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115736 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115739 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115744 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 115752 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115755 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115758 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115760 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115766 */   GIR_RootConstrainSelectedInstOperands,
     /* 115767 */   // GIR_Coverage, 6435,
     /* 115767 */   GIR_EraseRootFromParent_Done,
     /* 115768 */ // Label 2173: @115768
     /* 115768 */ GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(115881), // Rule ID 6436 //
     /* 115773 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115776 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115780 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 115787 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115791 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115795 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 115799 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115803 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115808 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115812 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115816 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 115820 */   // MIs[2] Operand 1
     /* 115820 */   // No operand predicates
     /* 115820 */   // MIs[0] Rn
     /* 115820 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115828 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115830 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115830 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115833 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115837 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115842 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 115845 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115849 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115852 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115857 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115862 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 115865 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115868 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115871 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115873 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115879 */   GIR_RootConstrainSelectedInstOperands,
     /* 115880 */   // GIR_Coverage, 6436,
     /* 115880 */   GIR_EraseRootFromParent_Done,
     /* 115881 */ // Label 2174: @115881
     /* 115881 */ GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(115987), // Rule ID 6437 //
     /* 115886 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115889 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115893 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 115897 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 115901 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 115905 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 115909 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115914 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 115918 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 115922 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 115926 */   // MIs[2] Operand 1
     /* 115926 */   // No operand predicates
     /* 115926 */   // MIs[0] Rn
     /* 115926 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 115930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 115934 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 115936 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 115936 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 115939 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 115943 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115948 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 115951 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 115955 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 115958 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 115963 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 115968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 115971 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115974 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 115977 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 115979 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 115985 */   GIR_RootConstrainSelectedInstOperands,
     /* 115986 */   // GIR_Coverage, 6437,
     /* 115986 */   GIR_EraseRootFromParent_Done,
     /* 115987 */ // Label 2175: @115987
     /* 115987 */ GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(116093), // Rule ID 6438 //
     /* 115992 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 115995 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 115999 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116003 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 116007 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116011 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 116015 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116020 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 116024 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 116028 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 116032 */   // MIs[2] Operand 1
     /* 116032 */   // No operand predicates
     /* 116032 */   // MIs[0] Rn
     /* 116032 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 116036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 116040 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 116042 */   // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 116042 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 116045 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 116049 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116054 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 116057 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 116061 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 116064 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116069 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 116077 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116080 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 116083 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 116085 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 116091 */   GIR_RootConstrainSelectedInstOperands,
     /* 116092 */   // GIR_Coverage, 6438,
     /* 116092 */   GIR_EraseRootFromParent_Done,
     /* 116093 */ // Label 2176: @116093
     /* 116093 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(116153), // Rule ID 295 //
     /* 116098 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116101 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116105 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116116 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116120 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 116127 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 116127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 116130 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116132 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116137 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116142 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116147 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116151 */   GIR_RootConstrainSelectedInstOperands,
     /* 116152 */   // GIR_Coverage, 295,
     /* 116152 */   GIR_EraseRootFromParent_Done,
     /* 116153 */ // Label 2177: @116153
     /* 116153 */ GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(116213), // Rule ID 296 //
     /* 116158 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116161 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116165 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116176 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116180 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 116187 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 116187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 116190 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116192 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116197 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116202 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116207 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116211 */   GIR_RootConstrainSelectedInstOperands,
     /* 116212 */   // GIR_Coverage, 296,
     /* 116212 */   GIR_EraseRootFromParent_Done,
     /* 116213 */ // Label 2178: @116213
     /* 116213 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(116273), // Rule ID 297 //
     /* 116218 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116221 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116225 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116236 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116240 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 116247 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 116247 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 116250 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116252 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116257 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116262 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116267 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116271 */   GIR_RootConstrainSelectedInstOperands,
     /* 116272 */   // GIR_Coverage, 297,
     /* 116272 */   GIR_EraseRootFromParent_Done,
     /* 116273 */ // Label 2179: @116273
     /* 116273 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(116333), // Rule ID 298 //
     /* 116278 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116281 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116285 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116296 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116300 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 116307 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 116307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 116310 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116312 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116327 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116331 */   GIR_RootConstrainSelectedInstOperands,
     /* 116332 */   // GIR_Coverage, 298,
     /* 116332 */   GIR_EraseRootFromParent_Done,
     /* 116333 */ // Label 2180: @116333
     /* 116333 */ GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(116386), // Rule ID 299 //
     /* 116338 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116341 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116349 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116353 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 116360 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 116360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 116363 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116365 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116370 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116375 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116380 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116384 */   GIR_RootConstrainSelectedInstOperands,
     /* 116385 */   // GIR_Coverage, 299,
     /* 116385 */   GIR_EraseRootFromParent_Done,
     /* 116386 */ // Label 2181: @116386
     /* 116386 */ GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(116439), // Rule ID 300 //
     /* 116391 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116394 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116402 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116406 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 116413 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 116413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 116416 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116418 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116433 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116437 */   GIR_RootConstrainSelectedInstOperands,
     /* 116438 */   // GIR_Coverage, 300,
     /* 116438 */   GIR_EraseRootFromParent_Done,
     /* 116439 */ // Label 2182: @116439
     /* 116439 */ GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(116495), // Rule ID 307 //
     /* 116444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116447 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116450 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116458 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116462 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 116469 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 116469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 116472 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116474 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116479 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116489 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116493 */   GIR_RootConstrainSelectedInstOperands,
     /* 116494 */   // GIR_Coverage, 307,
     /* 116494 */   GIR_EraseRootFromParent_Done,
     /* 116495 */ // Label 2183: @116495
     /* 116495 */ GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(116551), // Rule ID 308 //
     /* 116500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116503 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116506 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116510 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116514 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116518 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 116525 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 116525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 116528 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116530 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116545 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116549 */   GIR_RootConstrainSelectedInstOperands,
     /* 116550 */   // GIR_Coverage, 308,
     /* 116550 */   GIR_EraseRootFromParent_Done,
     /* 116551 */ // Label 2184: @116551
     /* 116551 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(116603), // Rule ID 312 //
     /* 116556 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116559 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116567 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116571 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 116578 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 116581 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 116587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116597 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116601 */   GIR_RootConstrainSelectedInstOperands,
     /* 116602 */   // GIR_Coverage, 312,
     /* 116602 */   GIR_EraseRootFromParent_Done,
     /* 116603 */ // Label 2185: @116603
     /* 116603 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(116654), // Rule ID 315 //
     /* 116608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116611 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116614 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116622 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116626 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 116633 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 116633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 116636 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 116638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116648 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116652 */   GIR_RootConstrainSelectedInstOperands,
     /* 116653 */   // GIR_Coverage, 315,
     /* 116653 */   GIR_EraseRootFromParent_Done,
     /* 116654 */ // Label 2186: @116654
     /* 116654 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(116713), // Rule ID 317 //
     /* 116659 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116662 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116666 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 116673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116677 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116681 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 116688 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 116688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 116691 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 116697 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116702 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116707 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116711 */   GIR_RootConstrainSelectedInstOperands,
     /* 116712 */   // GIR_Coverage, 317,
     /* 116712 */   GIR_EraseRootFromParent_Done,
     /* 116713 */ // Label 2187: @116713
     /* 116713 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(116772), // Rule ID 318 //
     /* 116718 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 116721 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 116725 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116736 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116740 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 116747 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 116747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 116750 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 116756 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116761 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 116766 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116770 */   GIR_RootConstrainSelectedInstOperands,
     /* 116771 */   // GIR_Coverage, 318,
     /* 116771 */   GIR_EraseRootFromParent_Done,
     /* 116772 */ // Label 2188: @116772
     /* 116772 */ GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(116849), // Rule ID 7059 //
     /* 116777 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116780 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116787 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116790 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116794 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116798 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116802 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116807 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116811 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116813 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 116820 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15862>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 116820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 116823 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116827 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116832 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116837 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116842 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116847 */   GIR_RootConstrainSelectedInstOperands,
     /* 116848 */   // GIR_Coverage, 7059,
     /* 116848 */   GIR_EraseRootFromParent_Done,
     /* 116849 */ // Label 2189: @116849
     /* 116849 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(116926), // Rule ID 7060 //
     /* 116854 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116857 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 116864 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116867 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 116871 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 116875 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116879 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116884 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116888 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116890 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 116897 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15862>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 116897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 116900 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 116904 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116909 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116914 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116919 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 116924 */   GIR_RootConstrainSelectedInstOperands,
     /* 116925 */   // GIR_Coverage, 7060,
     /* 116925 */   GIR_EraseRootFromParent_Done,
     /* 116926 */ // Label 2190: @116926
     /* 116926 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(116985), // Rule ID 7040 //
     /* 116931 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116934 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 116941 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 116944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 116948 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 116952 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 116959 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15848>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 116959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 116962 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 116964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 116969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 116974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 116979 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 116983 */   GIR_RootConstrainSelectedInstOperands,
     /* 116984 */   // GIR_Coverage, 7040,
     /* 116984 */   GIR_EraseRootFromParent_Done,
     /* 116985 */ // Label 2191: @116985
     /* 116985 */ GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(117044), // Rule ID 7041 //
     /* 116990 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 116993 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117000 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117007 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117011 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 117018 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15848>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 117018 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 117021 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117023 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117028 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117033 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117038 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117042 */   GIR_RootConstrainSelectedInstOperands,
     /* 117043 */   // GIR_Coverage, 7041,
     /* 117043 */   GIR_EraseRootFromParent_Done,
     /* 117044 */ // Label 2192: @117044
     /* 117044 */ GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(117103), // Rule ID 7045 //
     /* 117049 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117052 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117059 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117066 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117070 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 117077 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15855>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 117077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 117080 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117087 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117092 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117097 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117101 */   GIR_RootConstrainSelectedInstOperands,
     /* 117102 */   // GIR_Coverage, 7045,
     /* 117102 */   GIR_EraseRootFromParent_Done,
     /* 117103 */ // Label 2193: @117103
     /* 117103 */ GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(117162), // Rule ID 7046 //
     /* 117108 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117111 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117118 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117125 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117129 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 117136 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15855>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 117136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 117139 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117141 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117146 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117151 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117156 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117160 */   GIR_RootConstrainSelectedInstOperands,
     /* 117161 */   // GIR_Coverage, 7046,
     /* 117161 */   GIR_EraseRootFromParent_Done,
     /* 117162 */ // Label 2194: @117162
     /* 117162 */ GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(117221), // Rule ID 7050 //
     /* 117167 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117170 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117177 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117184 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117188 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 117195 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15862>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 117195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 117198 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117210 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117215 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117219 */   GIR_RootConstrainSelectedInstOperands,
     /* 117220 */   // GIR_Coverage, 7050,
     /* 117220 */   GIR_EraseRootFromParent_Done,
     /* 117221 */ // Label 2195: @117221
     /* 117221 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(117280), // Rule ID 7051 //
     /* 117226 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117229 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117236 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117243 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117247 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 117254 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15862>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 117254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 117257 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117264 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 117269 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 117274 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117278 */   GIR_RootConstrainSelectedInstOperands,
     /* 117279 */   // GIR_Coverage, 7051,
     /* 117279 */   GIR_EraseRootFromParent_Done,
     /* 117280 */ // Label 2196: @117280
     /* 117280 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(117352), // Rule ID 7061 //
     /* 117285 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117288 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117295 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117298 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117302 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 117306 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117310 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117315 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117319 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117321 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 117328 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15862>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 117328 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 117331 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 117335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117345 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117350 */   GIR_RootConstrainSelectedInstOperands,
     /* 117351 */   // GIR_Coverage, 7061,
     /* 117351 */   GIR_EraseRootFromParent_Done,
     /* 117352 */ // Label 2197: @117352
     /* 117352 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(117424), // Rule ID 7062 //
     /* 117357 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117360 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117367 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117370 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 117374 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 117378 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117382 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117387 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117391 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117393 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117400 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15862>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117400 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 117403 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 117407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117417 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 117422 */   GIR_RootConstrainSelectedInstOperands,
     /* 117423 */   // GIR_Coverage, 7062,
     /* 117423 */   GIR_EraseRootFromParent_Done,
     /* 117424 */ // Label 2198: @117424
     /* 117424 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(117476), // Rule ID 320 //
     /* 117429 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117432 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117440 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117444 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117451 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 117454 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117460 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117470 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117474 */   GIR_RootConstrainSelectedInstOperands,
     /* 117475 */   // GIR_Coverage, 320,
     /* 117475 */   GIR_EraseRootFromParent_Done,
     /* 117476 */ // Label 2199: @117476
     /* 117476 */ GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(117527), // Rule ID 323 //
     /* 117481 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117484 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117487 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117495 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117499 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117506 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 117509 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 117511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117516 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117521 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117525 */   GIR_RootConstrainSelectedInstOperands,
     /* 117526 */   // GIR_Coverage, 323,
     /* 117526 */   GIR_EraseRootFromParent_Done,
     /* 117527 */ // Label 2200: @117527
     /* 117527 */ GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(117586), // Rule ID 326 //
     /* 117532 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117535 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117539 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117550 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117554 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 117561 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 117564 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117570 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117575 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117580 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117584 */   GIR_RootConstrainSelectedInstOperands,
     /* 117585 */   // GIR_Coverage, 326,
     /* 117585 */   GIR_EraseRootFromParent_Done,
     /* 117586 */ // Label 2201: @117586
     /* 117586 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(117645), // Rule ID 327 //
     /* 117591 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 117594 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 117598 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117609 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117613 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 117620 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 117620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 117623 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 117629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117639 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117643 */   GIR_RootConstrainSelectedInstOperands,
     /* 117644 */   // GIR_Coverage, 327,
     /* 117644 */   GIR_EraseRootFromParent_Done,
     /* 117645 */ // Label 2202: @117645
     /* 117645 */ GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(117699), // Rule ID 7042 //
     /* 117650 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117653 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117660 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117667 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117671 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 117678 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15848>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 117678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 117681 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117683 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117688 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117693 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117697 */   GIR_RootConstrainSelectedInstOperands,
     /* 117698 */   // GIR_Coverage, 7042,
     /* 117698 */   GIR_EraseRootFromParent_Done,
     /* 117699 */ // Label 2203: @117699
     /* 117699 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(117753), // Rule ID 7043 //
     /* 117704 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117707 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117714 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117721 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117725 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 117732 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15848>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 117735 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117747 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117751 */   GIR_RootConstrainSelectedInstOperands,
     /* 117752 */   // GIR_Coverage, 7043,
     /* 117752 */   GIR_EraseRootFromParent_Done,
     /* 117753 */ // Label 2204: @117753
     /* 117753 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(117807), // Rule ID 7047 //
     /* 117758 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117761 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117768 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117775 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117779 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 117786 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15855>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 117786 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 117789 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117791 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117796 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117801 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117805 */   GIR_RootConstrainSelectedInstOperands,
     /* 117806 */   // GIR_Coverage, 7047,
     /* 117806 */   GIR_EraseRootFromParent_Done,
     /* 117807 */ // Label 2205: @117807
     /* 117807 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(117861), // Rule ID 7048 //
     /* 117812 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117815 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 117822 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117829 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117833 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 117840 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15855>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 117843 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117845 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117855 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117859 */   GIR_RootConstrainSelectedInstOperands,
     /* 117860 */   // GIR_Coverage, 7048,
     /* 117860 */   GIR_EraseRootFromParent_Done,
     /* 117861 */ // Label 2206: @117861
     /* 117861 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(117915), // Rule ID 7052 //
     /* 117866 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117869 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117876 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117883 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117887 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 117894 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15862>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 117894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 117897 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117899 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117904 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117909 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117913 */   GIR_RootConstrainSelectedInstOperands,
     /* 117914 */   // GIR_Coverage, 7052,
     /* 117914 */   GIR_EraseRootFromParent_Done,
     /* 117915 */ // Label 2207: @117915
     /* 117915 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(117969), // Rule ID 7053 //
     /* 117920 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117923 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 117930 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117937 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117941 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 117948 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15862>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 117948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 117951 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 117953 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 117958 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 117963 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 117967 */   GIR_RootConstrainSelectedInstOperands,
     /* 117968 */   // GIR_Coverage, 7053,
     /* 117968 */   GIR_EraseRootFromParent_Done,
     /* 117969 */ // Label 2208: @117969
     /* 117969 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(118026), // Rule ID 7385 //
     /* 117974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 117977 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 117980 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 117987 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 117990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117994 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 117998 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118005 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15846>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
     /* 118008 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118010 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118015 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118020 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118024 */   GIR_RootConstrainSelectedInstOperands,
     /* 118025 */   // GIR_Coverage, 7385,
     /* 118025 */   GIR_EraseRootFromParent_Done,
     /* 118026 */ // Label 2209: @118026
     /* 118026 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(118083), // Rule ID 7386 //
     /* 118031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 118034 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118037 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118044 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118051 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118055 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118062 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15853>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
     /* 118065 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118067 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118072 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118077 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118081 */   GIR_RootConstrainSelectedInstOperands,
     /* 118082 */   // GIR_Coverage, 7386,
     /* 118082 */   GIR_EraseRootFromParent_Done,
     /* 118083 */ // Label 2210: @118083
     /* 118083 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(118140), // Rule ID 7387 //
     /* 118088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 118091 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118094 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118101 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118108 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118112 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 118119 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15860>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118119 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
     /* 118122 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 118124 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118129 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118134 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118138 */   GIR_RootConstrainSelectedInstOperands,
     /* 118139 */   // GIR_Coverage, 7387,
     /* 118139 */   GIR_EraseRootFromParent_Done,
     /* 118140 */ // Label 2211: @118140
     /* 118140 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(118177), // Rule ID 7039 //
     /* 118145 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118148 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118155 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118162 */   // MIs[0] ptr
     /* 118162 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118170 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15846>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 118170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
     /* 118175 */   GIR_RootConstrainSelectedInstOperands,
     /* 118176 */   // GIR_Coverage, 7039,
     /* 118176 */   GIR_Done,
     /* 118177 */ // Label 2212: @118177
     /* 118177 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(118214), // Rule ID 7044 //
     /* 118182 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118185 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118192 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118199 */   // MIs[0] ptr
     /* 118199 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118207 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15853>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 118207 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
     /* 118212 */   GIR_RootConstrainSelectedInstOperands,
     /* 118213 */   // GIR_Coverage, 7044,
     /* 118213 */   GIR_Done,
     /* 118214 */ // Label 2213: @118214
     /* 118214 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(118251), // Rule ID 7049 //
     /* 118219 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 118222 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 118229 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 118232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118236 */   // MIs[0] ptr
     /* 118236 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 118240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 118244 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15860>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 118244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
     /* 118249 */   GIR_RootConstrainSelectedInstOperands,
     /* 118250 */   // GIR_Coverage, 7049,
     /* 118250 */   GIR_Done,
     /* 118251 */ // Label 2214: @118251
     /* 118251 */ GIM_Reject,
     /* 118252 */ // Label 2113: @118252
     /* 118252 */ GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(118358), // Rule ID 4476 //
     /* 118257 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118260 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118264 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118268 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118272 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118276 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118280 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118285 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118289 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118293 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118295 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118302 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118302 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118305 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118309 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118314 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118320 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118325 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118333 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118336 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118341 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118346 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118351 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118356 */   GIR_RootConstrainSelectedInstOperands,
     /* 118357 */   // GIR_Coverage, 4476,
     /* 118357 */   GIR_EraseRootFromParent_Done,
     /* 118358 */ // Label 2215: @118358
     /* 118358 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(118464), // Rule ID 4477 //
     /* 118363 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118366 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118370 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118374 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118378 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118382 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118386 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118391 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118395 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118399 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118401 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118408 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118408 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118411 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118415 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118420 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118426 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118431 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118439 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118442 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118447 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118452 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118457 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118462 */   GIR_RootConstrainSelectedInstOperands,
     /* 118463 */   // GIR_Coverage, 4477,
     /* 118463 */   GIR_EraseRootFromParent_Done,
     /* 118464 */ // Label 2216: @118464
     /* 118464 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(118570), // Rule ID 4478 //
     /* 118469 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118472 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118476 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118480 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118484 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118488 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118492 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118497 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118501 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118505 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118507 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 118514 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 118514 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118517 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118521 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118526 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118532 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118537 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 118545 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118548 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118553 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118558 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118563 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118568 */   GIR_RootConstrainSelectedInstOperands,
     /* 118569 */   // GIR_Coverage, 4478,
     /* 118569 */   GIR_EraseRootFromParent_Done,
     /* 118570 */ // Label 2217: @118570
     /* 118570 */ GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(118676), // Rule ID 4479 //
     /* 118575 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118578 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118582 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118586 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118590 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118594 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118598 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118603 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118607 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118611 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118613 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 118620 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 118620 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118623 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118627 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118632 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118638 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118643 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 118651 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118654 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118659 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118664 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118669 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118674 */   GIR_RootConstrainSelectedInstOperands,
     /* 118675 */   // GIR_Coverage, 4479,
     /* 118675 */   GIR_EraseRootFromParent_Done,
     /* 118676 */ // Label 2218: @118676
     /* 118676 */ GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(118777), // Rule ID 4502 //
     /* 118681 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118684 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118688 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118692 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118696 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118700 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118704 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118709 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118713 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118717 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118719 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 118726 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 118726 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118729 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118733 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118738 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118744 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118749 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 118757 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118770 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118775 */   GIR_RootConstrainSelectedInstOperands,
     /* 118776 */   // GIR_Coverage, 4502,
     /* 118776 */   GIR_EraseRootFromParent_Done,
     /* 118777 */ // Label 2219: @118777
     /* 118777 */ GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(118878), // Rule ID 4503 //
     /* 118782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118785 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118789 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118793 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118797 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118801 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118805 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118810 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118814 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118818 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118820 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 118827 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 118827 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118830 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118834 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118839 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118845 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118850 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 118858 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118866 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118871 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118876 */   GIR_RootConstrainSelectedInstOperands,
     /* 118877 */   // GIR_Coverage, 4503,
     /* 118877 */   GIR_EraseRootFromParent_Done,
     /* 118878 */ // Label 2220: @118878
     /* 118878 */ GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(118979), // Rule ID 4527 //
     /* 118883 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118886 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118890 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118898 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 118902 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 118906 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118911 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 118915 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118919 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 118921 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 118928 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 118928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 118931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118940 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 118946 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118951 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 118959 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118972 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 118977 */   GIR_RootConstrainSelectedInstOperands,
     /* 118978 */   // GIR_Coverage, 4527,
     /* 118978 */   GIR_EraseRootFromParent_Done,
     /* 118979 */ // Label 2221: @118979
     /* 118979 */ GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(119080), // Rule ID 4528 //
     /* 118984 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118987 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118991 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 118995 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 118999 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119003 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119007 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119012 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 119016 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119020 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119022 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 119029 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119029 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 119032 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119036 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119041 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 119047 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119052 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 119060 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119063 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119068 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119073 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 119078 */   GIR_RootConstrainSelectedInstOperands,
     /* 119079 */   // GIR_Coverage, 4528,
     /* 119079 */   GIR_EraseRootFromParent_Done,
     /* 119080 */ // Label 2222: @119080
     /* 119080 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(119155), // Rule ID 6432 //
     /* 119085 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119088 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119092 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119096 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119100 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119104 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119108 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119113 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 119117 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119121 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 119125 */   // MIs[2] Operand 1
     /* 119125 */   // No operand predicates
     /* 119125 */   // MIs[0] Rn
     /* 119125 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119133 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119135 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 119135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 119138 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 119142 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 119145 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 119147 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 119153 */   GIR_RootConstrainSelectedInstOperands,
     /* 119154 */   // GIR_Coverage, 6432,
     /* 119154 */   GIR_EraseRootFromParent_Done,
     /* 119155 */ // Label 2223: @119155
     /* 119155 */ GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(119230), // Rule ID 6433 //
     /* 119160 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119163 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119167 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 119171 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 119175 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 119179 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 119183 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 119188 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 119192 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 119196 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 119200 */   // MIs[2] Operand 1
     /* 119200 */   // No operand predicates
     /* 119200 */   // MIs[0] Rn
     /* 119200 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 119204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 119208 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 119210 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 119210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 119213 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 119217 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 119220 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 119222 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 119228 */   GIR_RootConstrainSelectedInstOperands,
     /* 119229 */   // GIR_Coverage, 6433,
     /* 119229 */   GIR_EraseRootFromParent_Done,
     /* 119230 */ // Label 2224: @119230
     /* 119230 */ GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(119283), // Rule ID 301 //
     /* 119235 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119238 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119246 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119250 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119257 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 119260 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119262 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119267 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119272 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119277 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119281 */   GIR_RootConstrainSelectedInstOperands,
     /* 119282 */   // GIR_Coverage, 301,
     /* 119282 */   GIR_EraseRootFromParent_Done,
     /* 119283 */ // Label 2225: @119283
     /* 119283 */ GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(119336), // Rule ID 302 //
     /* 119288 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119291 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119299 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119303 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119310 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119310 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 119313 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119315 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119320 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119330 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119334 */   GIR_RootConstrainSelectedInstOperands,
     /* 119335 */   // GIR_Coverage, 302,
     /* 119335 */   GIR_EraseRootFromParent_Done,
     /* 119336 */ // Label 2226: @119336
     /* 119336 */ GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(119392), // Rule ID 309 //
     /* 119341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119344 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119347 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119355 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119359 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 119366 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 119366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 119369 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119371 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119381 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119386 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119390 */   GIR_RootConstrainSelectedInstOperands,
     /* 119391 */   // GIR_Coverage, 309,
     /* 119391 */   GIR_EraseRootFromParent_Done,
     /* 119392 */ // Label 2227: @119392
     /* 119392 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(119448), // Rule ID 310 //
     /* 119397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119400 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119403 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119411 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119415 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 119422 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 119422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 119425 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 119427 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119432 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119437 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119442 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119446 */   GIR_RootConstrainSelectedInstOperands,
     /* 119447 */   // GIR_Coverage, 310,
     /* 119447 */   GIR_EraseRootFromParent_Done,
     /* 119448 */ // Label 2228: @119448
     /* 119448 */ GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(119537), // Rule ID 4434 //
     /* 119453 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119456 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119460 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119471 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119475 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 119482 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 119482 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119485 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119489 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119494 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119500 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119505 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 119513 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119516 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119521 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119526 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119531 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119535 */   GIR_RootConstrainSelectedInstOperands,
     /* 119536 */   // GIR_Coverage, 4434,
     /* 119536 */   GIR_EraseRootFromParent_Done,
     /* 119537 */ // Label 2229: @119537
     /* 119537 */ GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(119626), // Rule ID 4435 //
     /* 119542 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119545 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119549 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119560 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119564 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 119571 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 119571 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119574 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119578 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119583 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119589 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119594 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 119602 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119605 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119620 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119624 */   GIR_RootConstrainSelectedInstOperands,
     /* 119625 */   // GIR_Coverage, 4435,
     /* 119625 */   GIR_EraseRootFromParent_Done,
     /* 119626 */ // Label 2230: @119626
     /* 119626 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(119715), // Rule ID 4436 //
     /* 119631 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119634 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119638 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119649 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119653 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 119660 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 119660 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119663 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119667 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119672 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119678 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119683 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 119691 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119709 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119713 */   GIR_RootConstrainSelectedInstOperands,
     /* 119714 */   // GIR_Coverage, 4436,
     /* 119714 */   GIR_EraseRootFromParent_Done,
     /* 119715 */ // Label 2231: @119715
     /* 119715 */ GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(119804), // Rule ID 4437 //
     /* 119720 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119723 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119727 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119738 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119742 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 119749 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 119749 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119752 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119756 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119761 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119767 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119772 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119777 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 119780 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119783 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119798 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119802 */   GIR_RootConstrainSelectedInstOperands,
     /* 119803 */   // GIR_Coverage, 4437,
     /* 119803 */   GIR_EraseRootFromParent_Done,
     /* 119804 */ // Label 2232: @119804
     /* 119804 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(119893), // Rule ID 4438 //
     /* 119809 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119812 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119816 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119827 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119831 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 119838 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 119838 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119841 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119845 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119850 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119856 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119861 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119866 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 119869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119872 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119877 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119882 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119887 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119891 */   GIR_RootConstrainSelectedInstOperands,
     /* 119892 */   // GIR_Coverage, 4438,
     /* 119892 */   GIR_EraseRootFromParent_Done,
     /* 119893 */ // Label 2233: @119893
     /* 119893 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(119982), // Rule ID 4439 //
     /* 119898 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119901 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119905 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119912 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119916 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119920 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 119927 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 119927 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 119930 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119934 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119939 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 119945 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119950 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 119955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 119958 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119961 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119966 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119971 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119976 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119980 */   GIR_RootConstrainSelectedInstOperands,
     /* 119981 */   // GIR_Coverage, 4439,
     /* 119981 */   GIR_EraseRootFromParent_Done,
     /* 119982 */ // Label 2234: @119982
     /* 119982 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(120035), // Rule ID 4450 //
     /* 119987 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119990 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 119998 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120002 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 120009 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 120009 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 120012 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120014 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120019 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120029 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120033 */   GIR_RootConstrainSelectedInstOperands,
     /* 120034 */   // GIR_Coverage, 4450,
     /* 120034 */   GIR_EraseRootFromParent_Done,
     /* 120035 */ // Label 2235: @120035
     /* 120035 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(120088), // Rule ID 4451 //
     /* 120040 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120043 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120051 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120055 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 120062 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 120062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 120065 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120067 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120072 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120082 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120086 */   GIR_RootConstrainSelectedInstOperands,
     /* 120087 */   // GIR_Coverage, 4451,
     /* 120087 */   GIR_EraseRootFromParent_Done,
     /* 120088 */ // Label 2236: @120088
     /* 120088 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(120141), // Rule ID 4452 //
     /* 120093 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120096 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120104 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120108 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 120115 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 120115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 120118 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120120 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120125 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120130 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120135 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120139 */   GIR_RootConstrainSelectedInstOperands,
     /* 120140 */   // GIR_Coverage, 4452,
     /* 120140 */   GIR_EraseRootFromParent_Done,
     /* 120141 */ // Label 2237: @120141
     /* 120141 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(120194), // Rule ID 4453 //
     /* 120146 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120149 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120157 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120161 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 120168 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 120168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 120171 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120183 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120188 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120192 */   GIR_RootConstrainSelectedInstOperands,
     /* 120193 */   // GIR_Coverage, 4453,
     /* 120193 */   GIR_EraseRootFromParent_Done,
     /* 120194 */ // Label 2238: @120194
     /* 120194 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(120246), // Rule ID 311 //
     /* 120199 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120202 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120210 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120214 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120221 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 120224 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 120230 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120235 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120240 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120244 */   GIR_RootConstrainSelectedInstOperands,
     /* 120245 */   // GIR_Coverage, 311,
     /* 120245 */   GIR_EraseRootFromParent_Done,
     /* 120246 */ // Label 2239: @120246
     /* 120246 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(120297), // Rule ID 316 //
     /* 120251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120254 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120257 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120265 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120269 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120276 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 120279 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120281 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120286 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120291 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120295 */   GIR_RootConstrainSelectedInstOperands,
     /* 120296 */   // GIR_Coverage, 316,
     /* 120296 */   GIR_EraseRootFromParent_Done,
     /* 120297 */ // Label 2240: @120297
     /* 120297 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(120345), // Rule ID 4480 //
     /* 120302 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120305 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120313 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120317 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120324 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 120327 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120339 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120343 */   GIR_RootConstrainSelectedInstOperands,
     /* 120344 */   // GIR_Coverage, 4480,
     /* 120344 */   GIR_EraseRootFromParent_Done,
     /* 120345 */ // Label 2241: @120345
     /* 120345 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(120393), // Rule ID 4481 //
     /* 120350 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120353 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120361 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120365 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120372 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 120372 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 120375 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 120377 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120382 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120387 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120391 */   GIR_RootConstrainSelectedInstOperands,
     /* 120392 */   // GIR_Coverage, 4481,
     /* 120392 */   GIR_EraseRootFromParent_Done,
     /* 120393 */ // Label 2242: @120393
     /* 120393 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(120477), // Rule ID 4495 //
     /* 120398 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120401 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120405 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120416 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120420 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 120427 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 120427 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120430 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120434 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120439 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120445 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120450 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 120458 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120471 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120475 */   GIR_RootConstrainSelectedInstOperands,
     /* 120476 */   // GIR_Coverage, 4495,
     /* 120476 */   GIR_EraseRootFromParent_Done,
     /* 120477 */ // Label 2243: @120477
     /* 120477 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(120561), // Rule ID 4496 //
     /* 120482 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120485 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120489 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120500 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120504 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 120511 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 120511 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120514 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120518 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120523 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120529 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120534 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 120542 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120545 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120550 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120555 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120559 */   GIR_RootConstrainSelectedInstOperands,
     /* 120560 */   // GIR_Coverage, 4496,
     /* 120560 */   GIR_EraseRootFromParent_Done,
     /* 120561 */ // Label 2244: @120561
     /* 120561 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(120645), // Rule ID 4497 //
     /* 120566 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120569 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120573 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120584 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120588 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 120595 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 120595 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 120598 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 120602 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120607 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 120613 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120618 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 120626 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120639 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120643 */   GIR_RootConstrainSelectedInstOperands,
     /* 120644 */   // GIR_Coverage, 4497,
     /* 120644 */   GIR_EraseRootFromParent_Done,
     /* 120645 */ // Label 2245: @120645
     /* 120645 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(120722), // Rule ID 7063 //
     /* 120650 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120653 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120660 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120663 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 120667 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 120671 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 120675 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120680 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120684 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120686 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 120693 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15869>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 120693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 120696 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 120700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120705 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120710 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120715 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120720 */   GIR_RootConstrainSelectedInstOperands,
     /* 120721 */   // GIR_Coverage, 7063,
     /* 120721 */   GIR_EraseRootFromParent_Done,
     /* 120722 */ // Label 2246: @120722
     /* 120722 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(120799), // Rule ID 7064 //
     /* 120727 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120730 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120737 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120740 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 120744 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 120748 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 120752 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120757 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120761 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120763 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 120770 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15869>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 120770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 120773 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 120777 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120782 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120787 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120792 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120797 */   GIR_RootConstrainSelectedInstOperands,
     /* 120798 */   // GIR_Coverage, 7064,
     /* 120798 */   GIR_EraseRootFromParent_Done,
     /* 120799 */ // Label 2247: @120799
     /* 120799 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(120858), // Rule ID 7055 //
     /* 120804 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120807 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120814 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120821 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120825 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 120832 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15869>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 120832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 120835 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120837 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120842 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120852 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120856 */   GIR_RootConstrainSelectedInstOperands,
     /* 120857 */   // GIR_Coverage, 7055,
     /* 120857 */   GIR_EraseRootFromParent_Done,
     /* 120858 */ // Label 2248: @120858
     /* 120858 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(120917), // Rule ID 7056 //
     /* 120863 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120866 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120873 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 120880 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120884 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 120891 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15869>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 120891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 120894 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 120896 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120901 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 120906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 120911 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120915 */   GIR_RootConstrainSelectedInstOperands,
     /* 120916 */   // GIR_Coverage, 7056,
     /* 120916 */   GIR_EraseRootFromParent_Done,
     /* 120917 */ // Label 2249: @120917
     /* 120917 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(120989), // Rule ID 7065 //
     /* 120922 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120925 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 120932 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 120935 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 120939 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 120943 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 120947 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 120952 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120956 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 120958 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 120965 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15869>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 120965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 120968 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 120972 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120982 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 120987 */   GIR_RootConstrainSelectedInstOperands,
     /* 120988 */   // GIR_Coverage, 7065,
     /* 120988 */   GIR_EraseRootFromParent_Done,
     /* 120989 */ // Label 2250: @120989
     /* 120989 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(121061), // Rule ID 7066 //
     /* 120994 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120997 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121004 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121007 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121011 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121015 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121019 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121024 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121028 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121030 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121037 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15869>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 121040 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 121044 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121049 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121054 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121059 */   GIR_RootConstrainSelectedInstOperands,
     /* 121060 */   // GIR_Coverage, 7066,
     /* 121060 */   GIR_EraseRootFromParent_Done,
     /* 121061 */ // Label 2251: @121061
     /* 121061 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(121158), // Rule ID 7377 //
     /* 121066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 121069 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121072 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121079 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121082 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121086 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121090 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121094 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 121098 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 121102 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 121106 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 121110 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121115 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 121119 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121123 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 121127 */   // MIs[3] Operand 1
     /* 121127 */   // No operand predicates
     /* 121127 */   // MIs[0] Rn
     /* 121127 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121135 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 121137 */   // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15867>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 121137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 121140 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
     /* 121144 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 121147 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121149 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 121156 */   GIR_RootConstrainSelectedInstOperands,
     /* 121157 */   // GIR_Coverage, 7377,
     /* 121157 */   GIR_EraseRootFromParent_Done,
     /* 121158 */ // Label 2252: @121158
     /* 121158 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(121210), // Rule ID 319 //
     /* 121163 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121166 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121174 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121178 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121185 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 121185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 121188 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 121194 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121199 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121204 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121208 */   GIR_RootConstrainSelectedInstOperands,
     /* 121209 */   // GIR_Coverage, 319,
     /* 121209 */   GIR_EraseRootFromParent_Done,
     /* 121210 */ // Label 2253: @121210
     /* 121210 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(121261), // Rule ID 324 //
     /* 121215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 121218 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121221 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121229 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121233 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121240 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 121240 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 121243 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121245 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121250 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121255 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121259 */   GIR_RootConstrainSelectedInstOperands,
     /* 121260 */   // GIR_Coverage, 324,
     /* 121260 */   GIR_EraseRootFromParent_Done,
     /* 121261 */ // Label 2254: @121261
     /* 121261 */ GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(121315), // Rule ID 7057 //
     /* 121266 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121269 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121276 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121283 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121287 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 121294 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15869>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 121294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 121297 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121299 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121304 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121309 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121313 */   GIR_RootConstrainSelectedInstOperands,
     /* 121314 */   // GIR_Coverage, 7057,
     /* 121314 */   GIR_EraseRootFromParent_Done,
     /* 121315 */ // Label 2255: @121315
     /* 121315 */ GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(121369), // Rule ID 7058 //
     /* 121320 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121323 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121330 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121337 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121341 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121348 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15869>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 121351 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121353 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121358 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121363 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121367 */   GIR_RootConstrainSelectedInstOperands,
     /* 121368 */   // GIR_Coverage, 7058,
     /* 121368 */   GIR_EraseRootFromParent_Done,
     /* 121369 */ // Label 2256: @121369
     /* 121369 */ GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(121426), // Rule ID 7388 //
     /* 121374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 121377 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121380 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121387 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121394 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121398 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121405 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15867>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121405 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
     /* 121408 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 121410 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121415 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121420 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121424 */   GIR_RootConstrainSelectedInstOperands,
     /* 121425 */   // GIR_Coverage, 7388,
     /* 121425 */   GIR_EraseRootFromParent_Done,
     /* 121426 */ // Label 2257: @121426
     /* 121426 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(121474), // Rule ID 4504 //
     /* 121431 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121434 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121442 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121446 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121453 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 121456 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121472 */   GIR_RootConstrainSelectedInstOperands,
     /* 121473 */   // GIR_Coverage, 4504,
     /* 121473 */   GIR_EraseRootFromParent_Done,
     /* 121474 */ // Label 2258: @121474
     /* 121474 */ GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(121522), // Rule ID 4505 //
     /* 121479 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121482 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121490 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121494 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 121501 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121501 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 121504 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 121506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121516 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121520 */   GIR_RootConstrainSelectedInstOperands,
     /* 121521 */   // GIR_Coverage, 4505,
     /* 121521 */   GIR_EraseRootFromParent_Done,
     /* 121522 */ // Label 2259: @121522
     /* 121522 */ GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(121606), // Rule ID 4520 //
     /* 121527 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121530 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121534 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121545 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121549 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 121556 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121556 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121559 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121563 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121568 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 121574 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121579 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 121587 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121590 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121595 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121600 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121604 */   GIR_RootConstrainSelectedInstOperands,
     /* 121605 */   // GIR_Coverage, 4520,
     /* 121605 */   GIR_EraseRootFromParent_Done,
     /* 121606 */ // Label 2260: @121606
     /* 121606 */ GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(121690), // Rule ID 4521 //
     /* 121611 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121614 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121618 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121629 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121633 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 121640 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121640 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121643 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121647 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121652 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 121658 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121663 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 121671 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121674 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121679 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121684 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121688 */   GIR_RootConstrainSelectedInstOperands,
     /* 121689 */   // GIR_Coverage, 4521,
     /* 121689 */   GIR_EraseRootFromParent_Done,
     /* 121690 */ // Label 2261: @121690
     /* 121690 */ GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(121774), // Rule ID 4522 //
     /* 121695 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121698 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121702 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121713 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121717 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 121724 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 121724 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121727 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121731 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121736 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 121742 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121747 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 121755 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121758 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121763 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 121768 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121772 */   GIR_RootConstrainSelectedInstOperands,
     /* 121773 */   // GIR_Coverage, 4522,
     /* 121773 */   GIR_EraseRootFromParent_Done,
     /* 121774 */ // Label 2262: @121774
     /* 121774 */ GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(121858), // Rule ID 7376 //
     /* 121779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 121782 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121785 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121792 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121795 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121799 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 121803 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 121807 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 121811 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121816 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 121820 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 121824 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 121828 */   // MIs[2] Operand 1
     /* 121828 */   // No operand predicates
     /* 121828 */   // MIs[0] Rn
     /* 121828 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121836 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121838 */   // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15867>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 121838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 121841 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 121845 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 121848 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121850 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 121856 */   GIR_RootConstrainSelectedInstOperands,
     /* 121857 */   // GIR_Coverage, 7376,
     /* 121857 */   GIR_EraseRootFromParent_Done,
     /* 121858 */ // Label 2263: @121858
     /* 121858 */ GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(121956), // Rule ID 7378 //
     /* 121863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 121866 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121869 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121876 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121879 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 121883 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 121887 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 121891 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121896 */   // MIs[0] Rn
     /* 121896 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121904 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 121906 */   // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15867>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
     /* 121906 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 121909 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121913 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121918 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 121921 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 121925 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 121928 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 121933 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121938 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 121941 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121944 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121947 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 121949 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 121954 */   GIR_RootConstrainSelectedInstOperands,
     /* 121955 */   // GIR_Coverage, 7378,
     /* 121955 */   GIR_EraseRootFromParent_Done,
     /* 121956 */ // Label 2264: @121956
     /* 121956 */ GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(121993), // Rule ID 7054 //
     /* 121961 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 121964 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 121971 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 121974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121978 */   // MIs[0] ptr
     /* 121978 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 121982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121986 */   // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15867>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 121986 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
     /* 121991 */   GIR_RootConstrainSelectedInstOperands,
     /* 121992 */   // GIR_Coverage, 7054,
     /* 121992 */   GIR_Done,
     /* 121993 */ // Label 2265: @121993
     /* 121993 */ GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(122020), // Rule ID 6382 //
     /* 121998 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122001 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122005 */   // MIs[0] Rn
     /* 122005 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122013 */   // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 122013 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
     /* 122018 */   GIR_RootConstrainSelectedInstOperands,
     /* 122019 */   // GIR_Coverage, 6382,
     /* 122019 */   GIR_Done,
     /* 122020 */ // Label 2266: @122020
     /* 122020 */ GIM_Reject,
     /* 122021 */ // Label 2114: @122021
     /* 122021 */ GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(122226),
     /* 122026 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122029 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122037 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122041 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(122082), // Rule ID 4432 //
     /* 122046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 122049 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122056 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 122059 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122080 */     GIR_RootConstrainSelectedInstOperands,
     /* 122081 */     // GIR_Coverage, 4432,
     /* 122081 */     GIR_EraseRootFromParent_Done,
     /* 122082 */   // Label 2268: @122082
     /* 122082 */   GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(122123), // Rule ID 4433 //
     /* 122087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 122090 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122097 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 122100 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122102 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122121 */     GIR_RootConstrainSelectedInstOperands,
     /* 122122 */     // GIR_Coverage, 4433,
     /* 122122 */     GIR_EraseRootFromParent_Done,
     /* 122123 */   // Label 2269: @122123
     /* 122123 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(122156), // Rule ID 4487 //
     /* 122128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122135 */     // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 122138 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122140 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122145 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122154 */     GIR_RootConstrainSelectedInstOperands,
     /* 122155 */     // GIR_Coverage, 4487,
     /* 122155 */     GIR_EraseRootFromParent_Done,
     /* 122156 */   // Label 2270: @122156
     /* 122156 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(122189), // Rule ID 4511 //
     /* 122161 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122168 */     // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122171 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122187 */     GIR_RootConstrainSelectedInstOperands,
     /* 122188 */     // GIR_Coverage, 4511,
     /* 122188 */     GIR_EraseRootFromParent_Done,
     /* 122189 */   // Label 2271: @122189
     /* 122189 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(122225), // Rule ID 325 //
     /* 122194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122197 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122204 */     // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 122204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122207 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122223 */     GIR_RootConstrainSelectedInstOperands,
     /* 122224 */     // GIR_Coverage, 325,
     /* 122224 */     GIR_EraseRootFromParent_Done,
     /* 122225 */   // Label 2272: @122225
     /* 122225 */   GIM_Reject,
     /* 122226 */ // Label 2267: @122226
     /* 122226 */ GIM_Reject,
     /* 122227 */ // Label 2115: @122227
     /* 122227 */ GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(122632),
     /* 122232 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122235 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122239 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(122288), // Rule ID 4440 //
     /* 122244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122251 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122255 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122262 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 122265 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122286 */     GIR_RootConstrainSelectedInstOperands,
     /* 122287 */     // GIR_Coverage, 4440,
     /* 122287 */     GIR_EraseRootFromParent_Done,
     /* 122288 */   // Label 2274: @122288
     /* 122288 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(122337), // Rule ID 4441 //
     /* 122293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122300 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122311 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 122314 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122331 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122335 */     GIR_RootConstrainSelectedInstOperands,
     /* 122336 */     // GIR_Coverage, 4441,
     /* 122336 */     GIR_EraseRootFromParent_Done,
     /* 122337 */   // Label 2275: @122337
     /* 122337 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(122386), // Rule ID 4442 //
     /* 122342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122353 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122360 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 122363 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122384 */     GIR_RootConstrainSelectedInstOperands,
     /* 122385 */     // GIR_Coverage, 4442,
     /* 122385 */     GIR_EraseRootFromParent_Done,
     /* 122386 */   // Label 2276: @122386
     /* 122386 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(122435), // Rule ID 4443 //
     /* 122391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122409 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 122412 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122424 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122433 */     GIR_RootConstrainSelectedInstOperands,
     /* 122434 */     // GIR_Coverage, 4443,
     /* 122434 */     GIR_EraseRootFromParent_Done,
     /* 122435 */   // Label 2277: @122435
     /* 122435 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(122479), // Rule ID 4482 //
     /* 122440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122447 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122451 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122458 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 122461 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122477 */     GIR_RootConstrainSelectedInstOperands,
     /* 122478 */     // GIR_Coverage, 4482,
     /* 122478 */     GIR_EraseRootFromParent_Done,
     /* 122479 */   // Label 2278: @122479
     /* 122479 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(122523), // Rule ID 4485 //
     /* 122484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122491 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122495 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122502 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 122505 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122507 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122512 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122521 */     GIR_RootConstrainSelectedInstOperands,
     /* 122522 */     // GIR_Coverage, 4485,
     /* 122522 */     GIR_EraseRootFromParent_Done,
     /* 122523 */   // Label 2279: @122523
     /* 122523 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(122567), // Rule ID 4506 //
     /* 122528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122535 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122539 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122546 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 122549 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122565 */     GIR_RootConstrainSelectedInstOperands,
     /* 122566 */     // GIR_Coverage, 4506,
     /* 122566 */     GIR_EraseRootFromParent_Done,
     /* 122567 */   // Label 2280: @122567
     /* 122567 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(122611), // Rule ID 4509 //
     /* 122572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122579 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122583 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122590 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 122593 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122609 */     GIR_RootConstrainSelectedInstOperands,
     /* 122610 */     // GIR_Coverage, 4509,
     /* 122610 */     GIR_EraseRootFromParent_Done,
     /* 122611 */   // Label 2281: @122611
     /* 122611 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(122631), // Rule ID 6381 //
     /* 122616 */     // MIs[0] Rn
     /* 122616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 122620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 122624 */     // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 122624 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
     /* 122629 */     GIR_RootConstrainSelectedInstOperands,
     /* 122630 */     // GIR_Coverage, 6381,
     /* 122630 */     GIR_Done,
     /* 122631 */   // Label 2282: @122631
     /* 122631 */   GIM_Reject,
     /* 122632 */ // Label 2273: @122632
     /* 122632 */ GIM_Reject,
     /* 122633 */ // Label 2116: @122633
     /* 122633 */ GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(123082),
     /* 122638 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122641 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122645 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(122694), // Rule ID 4454 //
     /* 122650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122661 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122668 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 122671 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122692 */     GIR_RootConstrainSelectedInstOperands,
     /* 122693 */     // GIR_Coverage, 4454,
     /* 122693 */     GIR_EraseRootFromParent_Done,
     /* 122694 */   // Label 2284: @122694
     /* 122694 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(122743), // Rule ID 4455 //
     /* 122699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122706 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122710 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122717 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 122717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 122720 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122741 */     GIR_RootConstrainSelectedInstOperands,
     /* 122742 */     // GIR_Coverage, 4455,
     /* 122742 */     GIR_EraseRootFromParent_Done,
     /* 122743 */   // Label 2285: @122743
     /* 122743 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(122792), // Rule ID 4456 //
     /* 122748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122755 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122759 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 122766 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 122766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 122769 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122771 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122781 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122790 */     GIR_RootConstrainSelectedInstOperands,
     /* 122791 */     // GIR_Coverage, 4456,
     /* 122791 */     GIR_EraseRootFromParent_Done,
     /* 122792 */   // Label 2286: @122792
     /* 122792 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(122841), // Rule ID 4457 //
     /* 122797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 122800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122804 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122808 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 122815 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 122815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 122818 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122839 */     GIR_RootConstrainSelectedInstOperands,
     /* 122840 */     // GIR_Coverage, 4457,
     /* 122840 */     GIR_EraseRootFromParent_Done,
     /* 122841 */   // Label 2287: @122841
     /* 122841 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(122885), // Rule ID 4489 //
     /* 122846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122853 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122857 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122864 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 122867 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122879 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122883 */     GIR_RootConstrainSelectedInstOperands,
     /* 122884 */     // GIR_Coverage, 4489,
     /* 122884 */     GIR_EraseRootFromParent_Done,
     /* 122885 */   // Label 2288: @122885
     /* 122885 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(122929), // Rule ID 4493 //
     /* 122890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 122908 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 122908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 122911 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122923 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122927 */     GIR_RootConstrainSelectedInstOperands,
     /* 122928 */     // GIR_Coverage, 4493,
     /* 122928 */     GIR_EraseRootFromParent_Done,
     /* 122929 */   // Label 2289: @122929
     /* 122929 */   GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(122973), // Rule ID 4513 //
     /* 122934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122941 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122952 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122955 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122971 */     GIR_RootConstrainSelectedInstOperands,
     /* 122972 */     // GIR_Coverage, 4513,
     /* 122972 */     GIR_EraseRootFromParent_Done,
     /* 122973 */   // Label 2290: @122973
     /* 122973 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(123017), // Rule ID 4517 //
     /* 122978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 122981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 122985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122989 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 122996 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 122999 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123006 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123015 */     GIR_RootConstrainSelectedInstOperands,
     /* 123016 */     // GIR_Coverage, 4517,
     /* 123016 */     GIR_EraseRootFromParent_Done,
     /* 123017 */   // Label 2291: @123017
     /* 123017 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(123061), // Rule ID 4518 //
     /* 123022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123040 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123043 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123059 */     GIR_RootConstrainSelectedInstOperands,
     /* 123060 */     // GIR_Coverage, 4518,
     /* 123060 */     GIR_EraseRootFromParent_Done,
     /* 123061 */   // Label 2292: @123061
     /* 123061 */   GIM_Try, /*On fail goto*//*Label 2293*/ GIMT_Encode4(123081), // Rule ID 6378 //
     /* 123066 */     // MIs[0] Rn
     /* 123066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123074 */     // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 123074 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
     /* 123079 */     GIR_RootConstrainSelectedInstOperands,
     /* 123080 */     // GIR_Coverage, 6378,
     /* 123080 */     GIR_Done,
     /* 123081 */   // Label 2293: @123081
     /* 123081 */   GIM_Reject,
     /* 123082 */ // Label 2283: @123082
     /* 123082 */ GIM_Reject,
     /* 123083 */ // Label 2117: @123083
     /* 123083 */ GIM_Try, /*On fail goto*//*Label 2294*/ GIMT_Encode4(123488),
     /* 123088 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123091 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123095 */   GIM_Try, /*On fail goto*//*Label 2295*/ GIMT_Encode4(123144), // Rule ID 4444 //
     /* 123100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123111 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123118 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 123121 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123123 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123128 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123133 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123142 */     GIR_RootConstrainSelectedInstOperands,
     /* 123143 */     // GIR_Coverage, 4444,
     /* 123143 */     GIR_EraseRootFromParent_Done,
     /* 123144 */   // Label 2295: @123144
     /* 123144 */   GIM_Try, /*On fail goto*//*Label 2296*/ GIMT_Encode4(123193), // Rule ID 4445 //
     /* 123149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123156 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123160 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123167 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 123170 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123182 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123191 */     GIR_RootConstrainSelectedInstOperands,
     /* 123192 */     // GIR_Coverage, 4445,
     /* 123192 */     GIR_EraseRootFromParent_Done,
     /* 123193 */   // Label 2296: @123193
     /* 123193 */   GIM_Try, /*On fail goto*//*Label 2297*/ GIMT_Encode4(123242), // Rule ID 4448 //
     /* 123198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123216 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 123219 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123226 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123231 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123240 */     GIR_RootConstrainSelectedInstOperands,
     /* 123241 */     // GIR_Coverage, 4448,
     /* 123241 */     GIR_EraseRootFromParent_Done,
     /* 123242 */   // Label 2297: @123242
     /* 123242 */   GIM_Try, /*On fail goto*//*Label 2298*/ GIMT_Encode4(123291), // Rule ID 4449 //
     /* 123247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123254 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123258 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123265 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 123268 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123275 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123289 */     GIR_RootConstrainSelectedInstOperands,
     /* 123290 */     // GIR_Coverage, 4449,
     /* 123290 */     GIR_EraseRootFromParent_Done,
     /* 123291 */   // Label 2298: @123291
     /* 123291 */   GIM_Try, /*On fail goto*//*Label 2299*/ GIMT_Encode4(123335), // Rule ID 4484 //
     /* 123296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123303 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123307 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123314 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 123317 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123333 */     GIR_RootConstrainSelectedInstOperands,
     /* 123334 */     // GIR_Coverage, 4484,
     /* 123334 */     GIR_EraseRootFromParent_Done,
     /* 123335 */   // Label 2299: @123335
     /* 123335 */   GIM_Try, /*On fail goto*//*Label 2300*/ GIMT_Encode4(123379), // Rule ID 4486 //
     /* 123340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123351 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123358 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 123361 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123363 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123368 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123377 */     GIR_RootConstrainSelectedInstOperands,
     /* 123378 */     // GIR_Coverage, 4486,
     /* 123378 */     GIR_EraseRootFromParent_Done,
     /* 123379 */   // Label 2300: @123379
     /* 123379 */   GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(123423), // Rule ID 4508 //
     /* 123384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123395 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123402 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 123405 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123407 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123421 */     GIR_RootConstrainSelectedInstOperands,
     /* 123422 */     // GIR_Coverage, 4508,
     /* 123422 */     GIR_EraseRootFromParent_Done,
     /* 123423 */   // Label 2301: @123423
     /* 123423 */   GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(123467), // Rule ID 4510 //
     /* 123428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123435 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123439 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123446 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 123449 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123465 */     GIR_RootConstrainSelectedInstOperands,
     /* 123466 */     // GIR_Coverage, 4510,
     /* 123466 */     GIR_EraseRootFromParent_Done,
     /* 123467 */   // Label 2302: @123467
     /* 123467 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(123487), // Rule ID 6380 //
     /* 123472 */     // MIs[0] Rn
     /* 123472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123480 */     // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 123480 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
     /* 123485 */     GIR_RootConstrainSelectedInstOperands,
     /* 123486 */     // GIR_Coverage, 6380,
     /* 123486 */     GIR_Done,
     /* 123487 */   // Label 2303: @123487
     /* 123487 */   GIM_Reject,
     /* 123488 */ // Label 2294: @123488
     /* 123488 */ GIM_Reject,
     /* 123489 */ // Label 2118: @123489
     /* 123489 */ GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(123894),
     /* 123494 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123497 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123501 */   GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(123550), // Rule ID 4458 //
     /* 123506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123524 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123527 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123548 */     GIR_RootConstrainSelectedInstOperands,
     /* 123549 */     // GIR_Coverage, 4458,
     /* 123549 */     GIR_EraseRootFromParent_Done,
     /* 123550 */   // Label 2305: @123550
     /* 123550 */   GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(123599), // Rule ID 4459 //
     /* 123555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123566 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123573 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123576 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123597 */     GIR_RootConstrainSelectedInstOperands,
     /* 123598 */     // GIR_Coverage, 4459,
     /* 123598 */     GIR_EraseRootFromParent_Done,
     /* 123599 */   // Label 2306: @123599
     /* 123599 */   GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(123648), // Rule ID 4460 //
     /* 123604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123615 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123622 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 123625 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123627 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123632 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123646 */     GIR_RootConstrainSelectedInstOperands,
     /* 123647 */     // GIR_Coverage, 4460,
     /* 123647 */     GIR_EraseRootFromParent_Done,
     /* 123648 */   // Label 2307: @123648
     /* 123648 */   GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(123697), // Rule ID 4461 //
     /* 123653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 123656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123664 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123671 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 123674 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123676 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123695 */     GIR_RootConstrainSelectedInstOperands,
     /* 123696 */     // GIR_Coverage, 4461,
     /* 123696 */     GIR_EraseRootFromParent_Done,
     /* 123697 */   // Label 2308: @123697
     /* 123697 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(123741), // Rule ID 4488 //
     /* 123702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123713 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123720 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123723 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123735 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123739 */     GIR_RootConstrainSelectedInstOperands,
     /* 123740 */     // GIR_Coverage, 4488,
     /* 123740 */     GIR_EraseRootFromParent_Done,
     /* 123741 */   // Label 2309: @123741
     /* 123741 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(123785), // Rule ID 4492 //
     /* 123746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123753 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123757 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123764 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 123767 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123783 */     GIR_RootConstrainSelectedInstOperands,
     /* 123784 */     // GIR_Coverage, 4492,
     /* 123784 */     GIR_EraseRootFromParent_Done,
     /* 123785 */   // Label 2310: @123785
     /* 123785 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(123829), // Rule ID 4512 //
     /* 123790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123797 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123801 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123808 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123811 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123823 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123827 */     GIR_RootConstrainSelectedInstOperands,
     /* 123828 */     // GIR_Coverage, 4512,
     /* 123828 */     GIR_EraseRootFromParent_Done,
     /* 123829 */   // Label 2311: @123829
     /* 123829 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(123873), // Rule ID 4516 //
     /* 123834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123845 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123852 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 123855 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123862 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123871 */     GIR_RootConstrainSelectedInstOperands,
     /* 123872 */     // GIR_Coverage, 4516,
     /* 123872 */     GIR_EraseRootFromParent_Done,
     /* 123873 */   // Label 2312: @123873
     /* 123873 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(123893), // Rule ID 6377 //
     /* 123878 */     // MIs[0] Rn
     /* 123878 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123886 */     // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 123886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
     /* 123891 */     GIR_RootConstrainSelectedInstOperands,
     /* 123892 */     // GIR_Coverage, 6377,
     /* 123892 */     GIR_Done,
     /* 123893 */   // Label 2313: @123893
     /* 123893 */   GIM_Reject,
     /* 123894 */ // Label 2304: @123894
     /* 123894 */ GIM_Reject,
     /* 123895 */ // Label 2119: @123895
     /* 123895 */ GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(124114),
     /* 123900 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123903 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123907 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(123956), // Rule ID 4446 //
     /* 123912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123923 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123930 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 123933 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123945 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123950 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123954 */     GIR_RootConstrainSelectedInstOperands,
     /* 123955 */     // GIR_Coverage, 4446,
     /* 123955 */     GIR_EraseRootFromParent_Done,
     /* 123956 */   // Label 2315: @123956
     /* 123956 */   GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(124005), // Rule ID 4447 //
     /* 123961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123968 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123972 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 123979 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 123979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 123982 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 123984 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123989 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124003 */     GIR_RootConstrainSelectedInstOperands,
     /* 124004 */     // GIR_Coverage, 4447,
     /* 124004 */     GIR_EraseRootFromParent_Done,
     /* 124005 */   // Label 2316: @124005
     /* 124005 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(124049), // Rule ID 4483 //
     /* 124010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 124017 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124021 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124028 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 124031 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124047 */     GIR_RootConstrainSelectedInstOperands,
     /* 124048 */     // GIR_Coverage, 4483,
     /* 124048 */     GIR_EraseRootFromParent_Done,
     /* 124049 */   // Label 2317: @124049
     /* 124049 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(124093), // Rule ID 4507 //
     /* 124054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 124061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124065 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 124072 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 124075 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124082 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124091 */     GIR_RootConstrainSelectedInstOperands,
     /* 124092 */     // GIR_Coverage, 4507,
     /* 124092 */     GIR_EraseRootFromParent_Done,
     /* 124093 */   // Label 2318: @124093
     /* 124093 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(124113), // Rule ID 6379 //
     /* 124098 */     // MIs[0] Rn
     /* 124098 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124106 */     // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 124106 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
     /* 124111 */     GIR_RootConstrainSelectedInstOperands,
     /* 124112 */     // GIR_Coverage, 6379,
     /* 124112 */     GIR_Done,
     /* 124113 */   // Label 2319: @124113
     /* 124113 */   GIM_Reject,
     /* 124114 */ // Label 2314: @124114
     /* 124114 */ GIM_Reject,
     /* 124115 */ // Label 2120: @124115
     /* 124115 */ GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(124520),
     /* 124120 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124123 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124127 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(124176), // Rule ID 4462 //
     /* 124132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124139 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124143 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124150 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 124153 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124174 */     GIR_RootConstrainSelectedInstOperands,
     /* 124175 */     // GIR_Coverage, 4462,
     /* 124175 */     GIR_EraseRootFromParent_Done,
     /* 124176 */   // Label 2321: @124176
     /* 124176 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(124225), // Rule ID 4463 //
     /* 124181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124192 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124199 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 124202 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124223 */     GIR_RootConstrainSelectedInstOperands,
     /* 124224 */     // GIR_Coverage, 4463,
     /* 124224 */     GIR_EraseRootFromParent_Done,
     /* 124225 */   // Label 2322: @124225
     /* 124225 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(124274), // Rule ID 4466 //
     /* 124230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124248 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 124251 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124253 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124272 */     GIR_RootConstrainSelectedInstOperands,
     /* 124273 */     // GIR_Coverage, 4466,
     /* 124273 */     GIR_EraseRootFromParent_Done,
     /* 124274 */   // Label 2323: @124274
     /* 124274 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(124323), // Rule ID 4467 //
     /* 124279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124286 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124290 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124297 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 124300 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124302 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124307 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124312 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124317 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124321 */     GIR_RootConstrainSelectedInstOperands,
     /* 124322 */     // GIR_Coverage, 4467,
     /* 124322 */     GIR_EraseRootFromParent_Done,
     /* 124323 */   // Label 2324: @124323
     /* 124323 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(124367), // Rule ID 4491 //
     /* 124328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124339 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124346 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 124349 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124356 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124361 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124365 */     GIR_RootConstrainSelectedInstOperands,
     /* 124366 */     // GIR_Coverage, 4491,
     /* 124366 */     GIR_EraseRootFromParent_Done,
     /* 124367 */   // Label 2325: @124367
     /* 124367 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(124411), // Rule ID 4494 //
     /* 124372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124390 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 124393 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124409 */     GIR_RootConstrainSelectedInstOperands,
     /* 124410 */     // GIR_Coverage, 4494,
     /* 124410 */     GIR_EraseRootFromParent_Done,
     /* 124411 */   // Label 2326: @124411
     /* 124411 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(124455), // Rule ID 4515 //
     /* 124416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124427 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124434 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 124437 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124453 */     GIR_RootConstrainSelectedInstOperands,
     /* 124454 */     // GIR_Coverage, 4515,
     /* 124454 */     GIR_EraseRootFromParent_Done,
     /* 124455 */   // Label 2327: @124455
     /* 124455 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(124499), // Rule ID 4519 //
     /* 124460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124467 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124471 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124478 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 124481 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124483 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124488 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124497 */     GIR_RootConstrainSelectedInstOperands,
     /* 124498 */     // GIR_Coverage, 4519,
     /* 124498 */     GIR_EraseRootFromParent_Done,
     /* 124499 */   // Label 2328: @124499
     /* 124499 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(124519), // Rule ID 6376 //
     /* 124504 */     // MIs[0] Rn
     /* 124504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124512 */     // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 124512 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
     /* 124517 */     GIR_RootConstrainSelectedInstOperands,
     /* 124518 */     // GIR_Coverage, 6376,
     /* 124518 */     GIR_Done,
     /* 124519 */   // Label 2329: @124519
     /* 124519 */   GIM_Reject,
     /* 124520 */ // Label 2320: @124520
     /* 124520 */ GIM_Reject,
     /* 124521 */ // Label 2121: @124521
     /* 124521 */ GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(124740),
     /* 124526 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124529 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124533 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(124582), // Rule ID 4464 //
     /* 124538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124545 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124549 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124556 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 124559 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124561 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124566 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124576 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124580 */     GIR_RootConstrainSelectedInstOperands,
     /* 124581 */     // GIR_Coverage, 4464,
     /* 124581 */     GIR_EraseRootFromParent_Done,
     /* 124582 */   // Label 2331: @124582
     /* 124582 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(124631), // Rule ID 4465 //
     /* 124587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 124590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124605 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 124608 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124629 */     GIR_RootConstrainSelectedInstOperands,
     /* 124630 */     // GIR_Coverage, 4465,
     /* 124630 */     GIR_EraseRootFromParent_Done,
     /* 124631 */   // Label 2332: @124631
     /* 124631 */   GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(124675), // Rule ID 4490 //
     /* 124636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124654 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 124657 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124673 */     GIR_RootConstrainSelectedInstOperands,
     /* 124674 */     // GIR_Coverage, 4490,
     /* 124674 */     GIR_EraseRootFromParent_Done,
     /* 124675 */   // Label 2333: @124675
     /* 124675 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(124719), // Rule ID 4514 //
     /* 124680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124687 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124691 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124698 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 124701 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 124703 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124713 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124717 */     GIR_RootConstrainSelectedInstOperands,
     /* 124718 */     // GIR_Coverage, 4514,
     /* 124718 */     GIR_EraseRootFromParent_Done,
     /* 124719 */   // Label 2334: @124719
     /* 124719 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(124739), // Rule ID 6375 //
     /* 124724 */     // MIs[0] Rn
     /* 124724 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124732 */     // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 124732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
     /* 124737 */     GIR_RootConstrainSelectedInstOperands,
     /* 124738 */     // GIR_Coverage, 6375,
     /* 124738 */     GIR_Done,
     /* 124739 */   // Label 2335: @124739
     /* 124739 */   GIM_Reject,
     /* 124740 */ // Label 2330: @124740
     /* 124740 */ GIM_Reject,
     /* 124741 */ // Label 2122: @124741
     /* 124741 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(124800), // Rule ID 10809 //
     /* 124746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124749 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124752 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124756 */   // MIs[0] base
     /* 124756 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124760 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124764 */   // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124764 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124767 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124771 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124776 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124779 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
     /* 124784 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124786 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124789 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124791 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124794 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124798 */   GIR_RootConstrainSelectedInstOperands,
     /* 124799 */   // GIR_Coverage, 10809,
     /* 124799 */   GIR_EraseRootFromParent_Done,
     /* 124800 */ // Label 2336: @124800
     /* 124800 */ GIM_Reject,
     /* 124801 */ // Label 2123: @124801
     /* 124801 */ GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(124860), // Rule ID 10815 //
     /* 124806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124809 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124812 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124816 */   // MIs[0] base
     /* 124816 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124820 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124824 */   // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124824 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124827 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124831 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124836 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124839 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124841 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
     /* 124844 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124846 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124849 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124851 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124854 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124858 */   GIR_RootConstrainSelectedInstOperands,
     /* 124859 */   // GIR_Coverage, 10815,
     /* 124859 */   GIR_EraseRootFromParent_Done,
     /* 124860 */ // Label 2337: @124860
     /* 124860 */ GIM_Reject,
     /* 124861 */ // Label 2124: @124861
     /* 124861 */ GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(125030),
     /* 124866 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124869 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124873 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124877 */   GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(124925), // Rule ID 10800 //
     /* 124882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124889 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124901 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 124909 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124914 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124923 */     GIR_RootConstrainSelectedInstOperands,
     /* 124924 */     // GIR_Coverage, 10800,
     /* 124924 */     GIR_EraseRootFromParent_Done,
     /* 124925 */   // Label 2339: @124925
     /* 124925 */   GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(124973), // Rule ID 10818 //
     /* 124930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 124933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 124937 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 124940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 124944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124949 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 124952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 124954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 124957 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124962 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124971 */     GIR_RootConstrainSelectedInstOperands,
     /* 124972 */     // GIR_Coverage, 10818,
     /* 124972 */     GIR_EraseRootFromParent_Done,
     /* 124973 */   // Label 2340: @124973
     /* 124973 */   GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(125001), // Rule ID 10930 //
     /* 124978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 124981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124985 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 124985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 124988 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 124990 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 124992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124995 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124999 */     GIR_RootConstrainSelectedInstOperands,
     /* 125000 */     // GIR_Coverage, 10930,
     /* 125000 */     GIR_EraseRootFromParent_Done,
     /* 125001 */   // Label 2341: @125001
     /* 125001 */   GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(125029), // Rule ID 10942 //
     /* 125006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125013 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125016 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125018 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125027 */     GIR_RootConstrainSelectedInstOperands,
     /* 125028 */     // GIR_Coverage, 10942,
     /* 125028 */     GIR_EraseRootFromParent_Done,
     /* 125029 */   // Label 2342: @125029
     /* 125029 */   GIM_Reject,
     /* 125030 */ // Label 2338: @125030
     /* 125030 */ GIM_Reject,
     /* 125031 */ // Label 2125: @125031
     /* 125031 */ GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(125090), // Rule ID 10806 //
     /* 125036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125039 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125042 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125046 */   // MIs[0] base
     /* 125046 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125054 */   // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125054 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125057 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125061 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125066 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
     /* 125074 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125076 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125079 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125084 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125088 */   GIR_RootConstrainSelectedInstOperands,
     /* 125089 */   // GIR_Coverage, 10806,
     /* 125089 */   GIR_EraseRootFromParent_Done,
     /* 125090 */ // Label 2343: @125090
     /* 125090 */ GIM_Reject,
     /* 125091 */ // Label 2126: @125091
     /* 125091 */ GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(125260),
     /* 125096 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125099 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125103 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125107 */   GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(125155), // Rule ID 10794 //
     /* 125112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125119 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125131 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 125139 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125144 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125153 */     GIR_RootConstrainSelectedInstOperands,
     /* 125154 */     // GIR_Coverage, 10794,
     /* 125154 */     GIR_EraseRootFromParent_Done,
     /* 125155 */   // Label 2345: @125155
     /* 125155 */   GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(125203), // Rule ID 10812 //
     /* 125160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125167 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125167 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125170 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 125174 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125179 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 125187 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125192 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125201 */     GIR_RootConstrainSelectedInstOperands,
     /* 125202 */     // GIR_Coverage, 10812,
     /* 125202 */     GIR_EraseRootFromParent_Done,
     /* 125203 */   // Label 2346: @125203
     /* 125203 */   GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(125231), // Rule ID 10926 //
     /* 125208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125215 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125218 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125220 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125225 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125229 */     GIR_RootConstrainSelectedInstOperands,
     /* 125230 */     // GIR_Coverage, 10926,
     /* 125230 */     GIR_EraseRootFromParent_Done,
     /* 125231 */   // Label 2347: @125231
     /* 125231 */   GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(125259), // Rule ID 10938 //
     /* 125236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125243 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125246 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125248 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125257 */     GIR_RootConstrainSelectedInstOperands,
     /* 125258 */     // GIR_Coverage, 10938,
     /* 125258 */     GIR_EraseRootFromParent_Done,
     /* 125259 */   // Label 2348: @125259
     /* 125259 */   GIM_Reject,
     /* 125260 */ // Label 2344: @125260
     /* 125260 */ GIM_Reject,
     /* 125261 */ // Label 2127: @125261
     /* 125261 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(125430),
     /* 125266 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125269 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125273 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125277 */   GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(125325), // Rule ID 10785 //
     /* 125282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125289 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 125296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125301 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125304 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 125309 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125314 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125323 */     GIR_RootConstrainSelectedInstOperands,
     /* 125324 */     // GIR_Coverage, 10785,
     /* 125324 */     GIR_EraseRootFromParent_Done,
     /* 125325 */   // Label 2350: @125325
     /* 125325 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(125373), // Rule ID 10803 //
     /* 125330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125337 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 125344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125349 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 125357 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125362 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125371 */     GIR_RootConstrainSelectedInstOperands,
     /* 125372 */     // GIR_Coverage, 10803,
     /* 125372 */     GIR_EraseRootFromParent_Done,
     /* 125373 */   // Label 2351: @125373
     /* 125373 */   GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(125401), // Rule ID 10922 //
     /* 125378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125385 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125388 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125390 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125399 */     GIR_RootConstrainSelectedInstOperands,
     /* 125400 */     // GIR_Coverage, 10922,
     /* 125400 */     GIR_EraseRootFromParent_Done,
     /* 125401 */   // Label 2352: @125401
     /* 125401 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(125429), // Rule ID 10934 //
     /* 125406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125413 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125416 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125418 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125427 */     GIR_RootConstrainSelectedInstOperands,
     /* 125428 */     // GIR_Coverage, 10934,
     /* 125428 */     GIR_EraseRootFromParent_Done,
     /* 125429 */   // Label 2353: @125429
     /* 125429 */   GIM_Reject,
     /* 125430 */ // Label 2349: @125430
     /* 125430 */ GIM_Reject,
     /* 125431 */ // Label 2128: @125431
     /* 125431 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(125474), // Rule ID 2428 //
     /* 125436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125439 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125442 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 125450 */   // MIs[0] base
     /* 125450 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125458 */   // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
     /* 125461 */   GIR_RootToRootCopy, /*OpIdx*/0, // Val
     /* 125463 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125465 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125472 */   GIR_RootConstrainSelectedInstOperands,
     /* 125473 */   // GIR_Coverage, 2428,
     /* 125473 */   GIR_EraseRootFromParent_Done,
     /* 125474 */ // Label 2354: @125474
     /* 125474 */ GIM_Reject,
     /* 125475 */ // Label 2129: @125475
     /* 125475 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(125568),
     /* 125480 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125483 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125487 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125491 */   GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(125539), // Rule ID 10771 //
     /* 125496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 125499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 125503 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 125506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 125510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125515 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 125518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 125520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
     /* 125523 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125528 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125537 */     GIR_RootConstrainSelectedInstOperands,
     /* 125538 */     // GIR_Coverage, 10771,
     /* 125538 */     GIR_EraseRootFromParent_Done,
     /* 125539 */   // Label 2356: @125539
     /* 125539 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(125567), // Rule ID 10918 //
     /* 125544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 125547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125551 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 125551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 125554 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 125556 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 125558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125565 */     GIR_RootConstrainSelectedInstOperands,
     /* 125566 */     // GIR_Coverage, 10918,
     /* 125566 */     GIR_EraseRootFromParent_Done,
     /* 125567 */   // Label 2357: @125567
     /* 125567 */   GIM_Reject,
     /* 125568 */ // Label 2355: @125568
     /* 125568 */ GIM_Reject,
     /* 125569 */ // Label 2130: @125569
     /* 125569 */ GIM_Reject,
     /* 125570 */ // Label 20: @125570
     /* 125570 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2360*/ GIMT_Encode4(126920),
     /* 125581 */ /*GILLT_s32*//*Label 2358*/ GIMT_Encode4(125589),
     /* 125585 */ /*GILLT_s64*//*Label 2359*/ GIMT_Encode4(126607),
     /* 125589 */ // Label 2358: @125589
     /* 125589 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(126606),
     /* 125594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 125597 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 125600 */   GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(125655), // Rule ID 7277 //
     /* 125605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125622 */     // MIs[0] Rn
     /* 125622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125638 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
     /* 125641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125647 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125649 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125653 */     GIR_RootConstrainSelectedInstOperands,
     /* 125654 */     // GIR_Coverage, 7277,
     /* 125654 */     GIR_EraseRootFromParent_Done,
     /* 125655 */   // Label 2362: @125655
     /* 125655 */   GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(125710), // Rule ID 7278 //
     /* 125660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125663 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125670 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125677 */     // MIs[0] Rn
     /* 125677 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125693 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
     /* 125696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125708 */     GIR_RootConstrainSelectedInstOperands,
     /* 125709 */     // GIR_Coverage, 7278,
     /* 125709 */     GIR_EraseRootFromParent_Done,
     /* 125710 */   // Label 2363: @125710
     /* 125710 */   GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(125765), // Rule ID 7279 //
     /* 125715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125718 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125725 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 125728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125732 */     // MIs[0] Rn
     /* 125732 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125748 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
     /* 125751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125759 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125763 */     GIR_RootConstrainSelectedInstOperands,
     /* 125764 */     // GIR_Coverage, 7279,
     /* 125764 */     GIR_EraseRootFromParent_Done,
     /* 125765 */   // Label 2364: @125765
     /* 125765 */   GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(125820), // Rule ID 7280 //
     /* 125770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125773 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125780 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 125783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125787 */     // MIs[0] Rn
     /* 125787 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125803 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 125806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125818 */     GIR_RootConstrainSelectedInstOperands,
     /* 125819 */     // GIR_Coverage, 7280,
     /* 125819 */     GIR_EraseRootFromParent_Done,
     /* 125820 */   // Label 2365: @125820
     /* 125820 */   GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(125875), // Rule ID 7281 //
     /* 125825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125828 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 125835 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 125838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125842 */     // MIs[0] Rn
     /* 125842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125854 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125858 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 125861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125867 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125869 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125873 */     GIR_RootConstrainSelectedInstOperands,
     /* 125874 */     // GIR_Coverage, 7281,
     /* 125874 */     GIR_EraseRootFromParent_Done,
     /* 125875 */   // Label 2366: @125875
     /* 125875 */   GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(125930), // Rule ID 7282 //
     /* 125880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125883 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125890 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 125893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125897 */     // MIs[0] Rn
     /* 125897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125913 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
     /* 125916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125928 */     GIR_RootConstrainSelectedInstOperands,
     /* 125929 */     // GIR_Coverage, 7282,
     /* 125929 */     GIR_EraseRootFromParent_Done,
     /* 125930 */   // Label 2367: @125930
     /* 125930 */   GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(125985), // Rule ID 7283 //
     /* 125935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125938 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 125945 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 125948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125952 */     // MIs[0] Rn
     /* 125952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 125968 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 125968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
     /* 125971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 125973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 125975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 125977 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 125979 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125983 */     GIR_RootConstrainSelectedInstOperands,
     /* 125984 */     // GIR_Coverage, 7283,
     /* 125984 */     GIR_EraseRootFromParent_Done,
     /* 125985 */   // Label 2368: @125985
     /* 125985 */   GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(126040), // Rule ID 7284 //
     /* 125990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 125993 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126000 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126007 */     // MIs[0] Rn
     /* 126007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126023 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
     /* 126026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126034 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126038 */     GIR_RootConstrainSelectedInstOperands,
     /* 126039 */     // GIR_Coverage, 7284,
     /* 126039 */     GIR_EraseRootFromParent_Done,
     /* 126040 */   // Label 2369: @126040
     /* 126040 */   GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(126095), // Rule ID 7285 //
     /* 126045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126048 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126055 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126062 */     // MIs[0] Rn
     /* 126062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126078 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 126081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126093 */     GIR_RootConstrainSelectedInstOperands,
     /* 126094 */     // GIR_Coverage, 7285,
     /* 126094 */     GIR_EraseRootFromParent_Done,
     /* 126095 */   // Label 2370: @126095
     /* 126095 */   GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(126150), // Rule ID 7286 //
     /* 126100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126103 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126110 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126117 */     // MIs[0] Rn
     /* 126117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126133 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 126136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126144 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126148 */     GIR_RootConstrainSelectedInstOperands,
     /* 126149 */     // GIR_Coverage, 7286,
     /* 126149 */     GIR_EraseRootFromParent_Done,
     /* 126150 */   // Label 2371: @126150
     /* 126150 */   GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(126205), // Rule ID 7287 //
     /* 126155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126158 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126165 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126172 */     // MIs[0] Rn
     /* 126172 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126176 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126188 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
     /* 126191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126197 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126203 */     GIR_RootConstrainSelectedInstOperands,
     /* 126204 */     // GIR_Coverage, 7287,
     /* 126204 */     GIR_EraseRootFromParent_Done,
     /* 126205 */   // Label 2372: @126205
     /* 126205 */   GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(126260), // Rule ID 7288 //
     /* 126210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126213 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126220 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126227 */     // MIs[0] Rn
     /* 126227 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126243 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
     /* 126246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126252 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126258 */     GIR_RootConstrainSelectedInstOperands,
     /* 126259 */     // GIR_Coverage, 7288,
     /* 126259 */     GIR_EraseRootFromParent_Done,
     /* 126260 */   // Label 2373: @126260
     /* 126260 */   GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(126315), // Rule ID 7289 //
     /* 126265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126268 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126275 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126282 */     // MIs[0] Rn
     /* 126282 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126286 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126294 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126298 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
     /* 126301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126307 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126309 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126313 */     GIR_RootConstrainSelectedInstOperands,
     /* 126314 */     // GIR_Coverage, 7289,
     /* 126314 */     GIR_EraseRootFromParent_Done,
     /* 126315 */   // Label 2374: @126315
     /* 126315 */   GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(126370), // Rule ID 7290 //
     /* 126320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126323 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126330 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126337 */     // MIs[0] Rn
     /* 126337 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126341 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126353 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 126356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126362 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126364 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126368 */     GIR_RootConstrainSelectedInstOperands,
     /* 126369 */     // GIR_Coverage, 7290,
     /* 126369 */     GIR_EraseRootFromParent_Done,
     /* 126370 */   // Label 2375: @126370
     /* 126370 */   GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(126425), // Rule ID 7291 //
     /* 126375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126378 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126385 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126392 */     // MIs[0] Rn
     /* 126392 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126404 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126408 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 126411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126419 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126423 */     GIR_RootConstrainSelectedInstOperands,
     /* 126424 */     // GIR_Coverage, 7291,
     /* 126424 */     GIR_EraseRootFromParent_Done,
     /* 126425 */   // Label 2376: @126425
     /* 126425 */   GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(126485), // Rule ID 13049 //
     /* 126430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 126433 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 126440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126444 */     // MIs[0] addr
     /* 126444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126460 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 126460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
     /* 126466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126468 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 126473 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 126475 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 126477 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 126479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126483 */     GIR_RootConstrainSelectedInstOperands,
     /* 126484 */     // GIR_Coverage, 13049,
     /* 126484 */     GIR_EraseRootFromParent_Done,
     /* 126485 */   // Label 2377: @126485
     /* 126485 */   GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(126545), // Rule ID 13050 //
     /* 126490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 126493 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 126500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126504 */     // MIs[0] addr
     /* 126504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126520 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 126520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
     /* 126526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126528 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 126533 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 126535 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 126537 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 126539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126543 */     GIR_RootConstrainSelectedInstOperands,
     /* 126544 */     // GIR_Coverage, 13050,
     /* 126544 */     GIR_EraseRootFromParent_Done,
     /* 126545 */   // Label 2378: @126545
     /* 126545 */   GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(126605), // Rule ID 13051 //
     /* 126550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 126553 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126564 */     // MIs[0] addr
     /* 126564 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126568 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126580 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 126580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
     /* 126586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126588 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 126593 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 126595 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 126597 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 126599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126603 */     GIR_RootConstrainSelectedInstOperands,
     /* 126604 */     // GIR_Coverage, 13051,
     /* 126604 */     GIR_EraseRootFromParent_Done,
     /* 126605 */   // Label 2379: @126605
     /* 126605 */   GIM_Reject,
     /* 126606 */ // Label 2361: @126606
     /* 126606 */ GIM_Reject,
     /* 126607 */ // Label 2359: @126607
     /* 126607 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(126919),
     /* 126612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 126615 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 126618 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 126625 */   GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(126673), // Rule ID 2587 //
     /* 126630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126633 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126640 */     // MIs[0] Rn
     /* 126640 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126656 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
     /* 126659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126665 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126671 */     GIR_RootConstrainSelectedInstOperands,
     /* 126672 */     // GIR_Coverage, 2587,
     /* 126672 */     GIR_EraseRootFromParent_Done,
     /* 126673 */   // Label 2381: @126673
     /* 126673 */   GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(126721), // Rule ID 2588 //
     /* 126678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126681 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 126684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126688 */     // MIs[0] Rn
     /* 126688 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126692 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126700 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126704 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
     /* 126707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126715 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126719 */     GIR_RootConstrainSelectedInstOperands,
     /* 126720 */     // GIR_Coverage, 2588,
     /* 126720 */     GIR_EraseRootFromParent_Done,
     /* 126721 */   // Label 2382: @126721
     /* 126721 */   GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(126769), // Rule ID 2589 //
     /* 126726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126729 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 126732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126736 */     // MIs[0] Rn
     /* 126736 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126752 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
     /* 126755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126767 */     GIR_RootConstrainSelectedInstOperands,
     /* 126768 */     // GIR_Coverage, 2589,
     /* 126768 */     GIR_EraseRootFromParent_Done,
     /* 126769 */   // Label 2383: @126769
     /* 126769 */   GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(126817), // Rule ID 2590 //
     /* 126774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126777 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 126780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126784 */     // MIs[0] Rn
     /* 126784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126800 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 126803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126815 */     GIR_RootConstrainSelectedInstOperands,
     /* 126816 */     // GIR_Coverage, 2590,
     /* 126816 */     GIR_EraseRootFromParent_Done,
     /* 126817 */   // Label 2384: @126817
     /* 126817 */   GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(126865), // Rule ID 2591 //
     /* 126822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126825 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 126828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126832 */     // MIs[0] Rn
     /* 126832 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126848 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 126848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 126851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 126853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 126855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 126857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126863 */     GIR_RootConstrainSelectedInstOperands,
     /* 126864 */     // GIR_Coverage, 2591,
     /* 126864 */     GIR_EraseRootFromParent_Done,
     /* 126865 */   // Label 2385: @126865
     /* 126865 */   GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(126918), // Rule ID 13052 //
     /* 126870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 126873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126877 */     // MIs[0] addr
     /* 126877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126893 */     // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
     /* 126893 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 126896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
     /* 126899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126901 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 126906 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 126908 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 126910 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 126912 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126916 */     GIR_RootConstrainSelectedInstOperands,
     /* 126917 */     // GIR_Coverage, 13052,
     /* 126917 */     GIR_EraseRootFromParent_Done,
     /* 126918 */   // Label 2386: @126918
     /* 126918 */   GIM_Reject,
     /* 126919 */ // Label 2380: @126919
     /* 126919 */ GIM_Reject,
     /* 126920 */ // Label 2360: @126920
     /* 126920 */ GIM_Reject,
     /* 126921 */ // Label 21: @126921
     /* 126921 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2389*/ GIMT_Encode4(127912),
     /* 126932 */ /*GILLT_s32*//*Label 2387*/ GIMT_Encode4(126940),
     /* 126936 */ /*GILLT_s64*//*Label 2388*/ GIMT_Encode4(127685),
     /* 126940 */ // Label 2387: @126940
     /* 126940 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(127684),
     /* 126945 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126948 */   GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(126997), // Rule ID 7262 //
     /* 126953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 126956 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 126963 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 126966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126970 */     // MIs[0] Rn
     /* 126970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 126982 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 126982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
     /* 126985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 126989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 126991 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126995 */     GIR_RootConstrainSelectedInstOperands,
     /* 126996 */     // GIR_Coverage, 7262,
     /* 126996 */     GIR_EraseRootFromParent_Done,
     /* 126997 */   // Label 2391: @126997
     /* 126997 */   GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(127046), // Rule ID 7263 //
     /* 127002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127005 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127012 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127019 */     // MIs[0] Rn
     /* 127019 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127031 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
     /* 127034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127044 */     GIR_RootConstrainSelectedInstOperands,
     /* 127045 */     // GIR_Coverage, 7263,
     /* 127045 */     GIR_EraseRootFromParent_Done,
     /* 127046 */   // Label 2392: @127046
     /* 127046 */   GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(127095), // Rule ID 7264 //
     /* 127051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127054 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127061 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127068 */     // MIs[0] Rn
     /* 127068 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127080 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
     /* 127083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127093 */     GIR_RootConstrainSelectedInstOperands,
     /* 127094 */     // GIR_Coverage, 7264,
     /* 127094 */     GIR_EraseRootFromParent_Done,
     /* 127095 */   // Label 2393: @127095
     /* 127095 */   GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(127144), // Rule ID 7265 //
     /* 127100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127103 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127110 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127117 */     // MIs[0] Rn
     /* 127117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127129 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 127132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127136 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127138 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127142 */     GIR_RootConstrainSelectedInstOperands,
     /* 127143 */     // GIR_Coverage, 7265,
     /* 127143 */     GIR_EraseRootFromParent_Done,
     /* 127144 */   // Label 2394: @127144
     /* 127144 */   GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(127193), // Rule ID 7266 //
     /* 127149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127152 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127159 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127166 */     // MIs[0] Rn
     /* 127166 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127178 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 127181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127191 */     GIR_RootConstrainSelectedInstOperands,
     /* 127192 */     // GIR_Coverage, 7266,
     /* 127192 */     GIR_EraseRootFromParent_Done,
     /* 127193 */   // Label 2395: @127193
     /* 127193 */   GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(127242), // Rule ID 7267 //
     /* 127198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127201 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127208 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127215 */     // MIs[0] Rn
     /* 127215 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127227 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
     /* 127230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127234 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127240 */     GIR_RootConstrainSelectedInstOperands,
     /* 127241 */     // GIR_Coverage, 7267,
     /* 127241 */     GIR_EraseRootFromParent_Done,
     /* 127242 */   // Label 2396: @127242
     /* 127242 */   GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(127291), // Rule ID 7268 //
     /* 127247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127250 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127257 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127264 */     // MIs[0] Rn
     /* 127264 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127276 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
     /* 127279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127289 */     GIR_RootConstrainSelectedInstOperands,
     /* 127290 */     // GIR_Coverage, 7268,
     /* 127290 */     GIR_EraseRootFromParent_Done,
     /* 127291 */   // Label 2397: @127291
     /* 127291 */   GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(127340), // Rule ID 7269 //
     /* 127296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127299 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127306 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127313 */     // MIs[0] Rn
     /* 127313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127325 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
     /* 127328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127338 */     GIR_RootConstrainSelectedInstOperands,
     /* 127339 */     // GIR_Coverage, 7269,
     /* 127339 */     GIR_EraseRootFromParent_Done,
     /* 127340 */   // Label 2398: @127340
     /* 127340 */   GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(127389), // Rule ID 7270 //
     /* 127345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127348 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127355 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127362 */     // MIs[0] Rn
     /* 127362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127374 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 127377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127383 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127387 */     GIR_RootConstrainSelectedInstOperands,
     /* 127388 */     // GIR_Coverage, 7270,
     /* 127388 */     GIR_EraseRootFromParent_Done,
     /* 127389 */   // Label 2399: @127389
     /* 127389 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(127438), // Rule ID 7271 //
     /* 127394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127397 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127404 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127411 */     // MIs[0] Rn
     /* 127411 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127423 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 127426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127430 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127436 */     GIR_RootConstrainSelectedInstOperands,
     /* 127437 */     // GIR_Coverage, 7271,
     /* 127437 */     GIR_EraseRootFromParent_Done,
     /* 127438 */   // Label 2400: @127438
     /* 127438 */   GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(127487), // Rule ID 7272 //
     /* 127443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127446 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127453 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127460 */     // MIs[0] Rn
     /* 127460 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127472 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
     /* 127475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127485 */     GIR_RootConstrainSelectedInstOperands,
     /* 127486 */     // GIR_Coverage, 7272,
     /* 127486 */     GIR_EraseRootFromParent_Done,
     /* 127487 */   // Label 2401: @127487
     /* 127487 */   GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(127536), // Rule ID 7273 //
     /* 127492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127495 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127502 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127509 */     // MIs[0] Rn
     /* 127509 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127521 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
     /* 127524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127534 */     GIR_RootConstrainSelectedInstOperands,
     /* 127535 */     // GIR_Coverage, 7273,
     /* 127535 */     GIR_EraseRootFromParent_Done,
     /* 127536 */   // Label 2402: @127536
     /* 127536 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(127585), // Rule ID 7274 //
     /* 127541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127544 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127551 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127558 */     // MIs[0] Rn
     /* 127558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127570 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
     /* 127573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127583 */     GIR_RootConstrainSelectedInstOperands,
     /* 127584 */     // GIR_Coverage, 7274,
     /* 127584 */     GIR_EraseRootFromParent_Done,
     /* 127585 */   // Label 2403: @127585
     /* 127585 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(127634), // Rule ID 7275 //
     /* 127590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127593 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127600 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127607 */     // MIs[0] Rn
     /* 127607 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127611 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127615 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127619 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 127622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127626 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127628 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127632 */     GIR_RootConstrainSelectedInstOperands,
     /* 127633 */     // GIR_Coverage, 7275,
     /* 127633 */     GIR_EraseRootFromParent_Done,
     /* 127634 */   // Label 2404: @127634
     /* 127634 */   GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(127683), // Rule ID 7276 //
     /* 127639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127642 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127649 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127656 */     // MIs[0] Rn
     /* 127656 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127668 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 127671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127675 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127677 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127681 */     GIR_RootConstrainSelectedInstOperands,
     /* 127682 */     // GIR_Coverage, 7276,
     /* 127682 */     GIR_EraseRootFromParent_Done,
     /* 127683 */   // Label 2405: @127683
     /* 127683 */   GIM_Reject,
     /* 127684 */ // Label 2390: @127684
     /* 127684 */ GIM_Reject,
     /* 127685 */ // Label 2388: @127685
     /* 127685 */ GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(127911),
     /* 127690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 127693 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 127700 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(127742), // Rule ID 7257 //
     /* 127705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127708 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127715 */     // MIs[0] Rn
     /* 127715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127727 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
     /* 127730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127740 */     GIR_RootConstrainSelectedInstOperands,
     /* 127741 */     // GIR_Coverage, 7257,
     /* 127741 */     GIR_EraseRootFromParent_Done,
     /* 127742 */   // Label 2407: @127742
     /* 127742 */   GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(127784), // Rule ID 7258 //
     /* 127747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127750 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 127753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127757 */     // MIs[0] Rn
     /* 127757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127769 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
     /* 127772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127782 */     GIR_RootConstrainSelectedInstOperands,
     /* 127783 */     // GIR_Coverage, 7258,
     /* 127783 */     GIR_EraseRootFromParent_Done,
     /* 127784 */   // Label 2408: @127784
     /* 127784 */   GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(127826), // Rule ID 7259 //
     /* 127789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127792 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 127795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127799 */     // MIs[0] Rn
     /* 127799 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127803 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127811 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
     /* 127814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127818 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127824 */     GIR_RootConstrainSelectedInstOperands,
     /* 127825 */     // GIR_Coverage, 7259,
     /* 127825 */     GIR_EraseRootFromParent_Done,
     /* 127826 */   // Label 2409: @127826
     /* 127826 */   GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(127868), // Rule ID 7260 //
     /* 127831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127834 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 127837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127841 */     // MIs[0] Rn
     /* 127841 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127845 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127853 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 127856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127866 */     GIR_RootConstrainSelectedInstOperands,
     /* 127867 */     // GIR_Coverage, 7260,
     /* 127867 */     GIR_EraseRootFromParent_Done,
     /* 127868 */   // Label 2410: @127868
     /* 127868 */   GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(127910), // Rule ID 7261 //
     /* 127873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127876 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 127879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127883 */     // MIs[0] Rn
     /* 127883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127887 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127895 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 127898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127904 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127908 */     GIR_RootConstrainSelectedInstOperands,
     /* 127909 */     // GIR_Coverage, 7261,
     /* 127909 */     GIR_EraseRootFromParent_Done,
     /* 127910 */   // Label 2411: @127910
     /* 127910 */   GIM_Reject,
     /* 127911 */ // Label 2406: @127911
     /* 127911 */ GIM_Reject,
     /* 127912 */ // Label 2389: @127912
     /* 127912 */ GIM_Reject,
     /* 127913 */ // Label 22: @127913
     /* 127913 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2414*/ GIMT_Encode4(128904),
     /* 127924 */ /*GILLT_s32*//*Label 2412*/ GIMT_Encode4(127932),
     /* 127928 */ /*GILLT_s64*//*Label 2413*/ GIMT_Encode4(128677),
     /* 127932 */ // Label 2412: @127932
     /* 127932 */ GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(128676),
     /* 127937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 127940 */   GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(127989), // Rule ID 7102 //
     /* 127945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127948 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127955 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 127958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127962 */     // MIs[0] Rn
     /* 127962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127974 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 127974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 127977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 127981 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 127983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127987 */     GIR_RootConstrainSelectedInstOperands,
     /* 127988 */     // GIR_Coverage, 7102,
     /* 127988 */     GIR_EraseRootFromParent_Done,
     /* 127989 */   // Label 2416: @127989
     /* 127989 */   GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(128038), // Rule ID 7103 //
     /* 127994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 127997 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128004 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128011 */     // MIs[0] Rn
     /* 128011 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128023 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 128026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128030 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128036 */     GIR_RootConstrainSelectedInstOperands,
     /* 128037 */     // GIR_Coverage, 7103,
     /* 128037 */     GIR_EraseRootFromParent_Done,
     /* 128038 */   // Label 2417: @128038
     /* 128038 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(128087), // Rule ID 7104 //
     /* 128043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128046 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128053 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128060 */     // MIs[0] Rn
     /* 128060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128072 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 128075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128085 */     GIR_RootConstrainSelectedInstOperands,
     /* 128086 */     // GIR_Coverage, 7104,
     /* 128086 */     GIR_EraseRootFromParent_Done,
     /* 128087 */   // Label 2418: @128087
     /* 128087 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(128136), // Rule ID 7105 //
     /* 128092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128095 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128102 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128109 */     // MIs[0] Rn
     /* 128109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128121 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 128124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128128 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128134 */     GIR_RootConstrainSelectedInstOperands,
     /* 128135 */     // GIR_Coverage, 7105,
     /* 128135 */     GIR_EraseRootFromParent_Done,
     /* 128136 */   // Label 2419: @128136
     /* 128136 */   GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(128185), // Rule ID 7106 //
     /* 128141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128144 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128151 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128158 */     // MIs[0] Rn
     /* 128158 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128170 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 128173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128179 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128183 */     GIR_RootConstrainSelectedInstOperands,
     /* 128184 */     // GIR_Coverage, 7106,
     /* 128184 */     GIR_EraseRootFromParent_Done,
     /* 128185 */   // Label 2420: @128185
     /* 128185 */   GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(128234), // Rule ID 7107 //
     /* 128190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128193 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128200 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128207 */     // MIs[0] Rn
     /* 128207 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128219 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 128222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128232 */     GIR_RootConstrainSelectedInstOperands,
     /* 128233 */     // GIR_Coverage, 7107,
     /* 128233 */     GIR_EraseRootFromParent_Done,
     /* 128234 */   // Label 2421: @128234
     /* 128234 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(128283), // Rule ID 7108 //
     /* 128239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128242 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128249 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128256 */     // MIs[0] Rn
     /* 128256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128268 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 128271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128277 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128281 */     GIR_RootConstrainSelectedInstOperands,
     /* 128282 */     // GIR_Coverage, 7108,
     /* 128282 */     GIR_EraseRootFromParent_Done,
     /* 128283 */   // Label 2422: @128283
     /* 128283 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(128332), // Rule ID 7109 //
     /* 128288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128291 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128298 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128305 */     // MIs[0] Rn
     /* 128305 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128317 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 128320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128324 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128326 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128330 */     GIR_RootConstrainSelectedInstOperands,
     /* 128331 */     // GIR_Coverage, 7109,
     /* 128331 */     GIR_EraseRootFromParent_Done,
     /* 128332 */   // Label 2423: @128332
     /* 128332 */   GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(128381), // Rule ID 7110 //
     /* 128337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128340 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128347 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128354 */     // MIs[0] Rn
     /* 128354 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128366 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 128369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128379 */     GIR_RootConstrainSelectedInstOperands,
     /* 128380 */     // GIR_Coverage, 7110,
     /* 128380 */     GIR_EraseRootFromParent_Done,
     /* 128381 */   // Label 2424: @128381
     /* 128381 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(128430), // Rule ID 7111 //
     /* 128386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128389 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128396 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128403 */     // MIs[0] Rn
     /* 128403 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128415 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 128418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128428 */     GIR_RootConstrainSelectedInstOperands,
     /* 128429 */     // GIR_Coverage, 7111,
     /* 128429 */     GIR_EraseRootFromParent_Done,
     /* 128430 */   // Label 2425: @128430
     /* 128430 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(128479), // Rule ID 7112 //
     /* 128435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128438 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128445 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128452 */     // MIs[0] Rn
     /* 128452 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128464 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 128467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128471 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128473 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128477 */     GIR_RootConstrainSelectedInstOperands,
     /* 128478 */     // GIR_Coverage, 7112,
     /* 128478 */     GIR_EraseRootFromParent_Done,
     /* 128479 */   // Label 2426: @128479
     /* 128479 */   GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(128528), // Rule ID 7113 //
     /* 128484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128487 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128494 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128501 */     // MIs[0] Rn
     /* 128501 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128505 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128513 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 128516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128520 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128522 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128526 */     GIR_RootConstrainSelectedInstOperands,
     /* 128527 */     // GIR_Coverage, 7113,
     /* 128527 */     GIR_EraseRootFromParent_Done,
     /* 128528 */   // Label 2427: @128528
     /* 128528 */   GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(128577), // Rule ID 7114 //
     /* 128533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128536 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128543 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128550 */     // MIs[0] Rn
     /* 128550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128554 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128562 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 128565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128569 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128571 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128575 */     GIR_RootConstrainSelectedInstOperands,
     /* 128576 */     // GIR_Coverage, 7114,
     /* 128576 */     GIR_EraseRootFromParent_Done,
     /* 128577 */   // Label 2428: @128577
     /* 128577 */   GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(128626), // Rule ID 7115 //
     /* 128582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128585 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128592 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128599 */     // MIs[0] Rn
     /* 128599 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128611 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 128614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128618 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128624 */     GIR_RootConstrainSelectedInstOperands,
     /* 128625 */     // GIR_Coverage, 7115,
     /* 128625 */     GIR_EraseRootFromParent_Done,
     /* 128626 */   // Label 2429: @128626
     /* 128626 */   GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(128675), // Rule ID 7116 //
     /* 128631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128634 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128641 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128648 */     // MIs[0] Rn
     /* 128648 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128660 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 128663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128667 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128669 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128673 */     GIR_RootConstrainSelectedInstOperands,
     /* 128674 */     // GIR_Coverage, 7116,
     /* 128674 */     GIR_EraseRootFromParent_Done,
     /* 128675 */   // Label 2430: @128675
     /* 128675 */   GIM_Reject,
     /* 128676 */ // Label 2415: @128676
     /* 128676 */ GIM_Reject,
     /* 128677 */ // Label 2413: @128677
     /* 128677 */ GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(128903),
     /* 128682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 128685 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 128692 */   GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(128734), // Rule ID 2577 //
     /* 128697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128700 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128707 */     // MIs[0] Rn
     /* 128707 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128719 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 128722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128726 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128728 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128732 */     GIR_RootConstrainSelectedInstOperands,
     /* 128733 */     // GIR_Coverage, 2577,
     /* 128733 */     GIR_EraseRootFromParent_Done,
     /* 128734 */   // Label 2432: @128734
     /* 128734 */   GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(128776), // Rule ID 2578 //
     /* 128739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128742 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128749 */     // MIs[0] Rn
     /* 128749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128761 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 128764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128774 */     GIR_RootConstrainSelectedInstOperands,
     /* 128775 */     // GIR_Coverage, 2578,
     /* 128775 */     GIR_EraseRootFromParent_Done,
     /* 128776 */   // Label 2433: @128776
     /* 128776 */   GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(128818), // Rule ID 2579 //
     /* 128781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128784 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 128787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128791 */     // MIs[0] Rn
     /* 128791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128803 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 128806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128816 */     GIR_RootConstrainSelectedInstOperands,
     /* 128817 */     // GIR_Coverage, 2579,
     /* 128817 */     GIR_EraseRootFromParent_Done,
     /* 128818 */   // Label 2434: @128818
     /* 128818 */   GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(128860), // Rule ID 2580 //
     /* 128823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 128829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128833 */     // MIs[0] Rn
     /* 128833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128845 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 128848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128858 */     GIR_RootConstrainSelectedInstOperands,
     /* 128859 */     // GIR_Coverage, 2580,
     /* 128859 */     GIR_EraseRootFromParent_Done,
     /* 128860 */   // Label 2435: @128860
     /* 128860 */   GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(128902), // Rule ID 2581 //
     /* 128865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 128871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128875 */     // MIs[0] Rn
     /* 128875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128887 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 128887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 128890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 128894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 128896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128900 */     GIR_RootConstrainSelectedInstOperands,
     /* 128901 */     // GIR_Coverage, 2581,
     /* 128901 */     GIR_EraseRootFromParent_Done,
     /* 128902 */   // Label 2436: @128902
     /* 128902 */   GIM_Reject,
     /* 128903 */ // Label 2431: @128903
     /* 128903 */ GIM_Reject,
     /* 128904 */ // Label 2414: @128904
     /* 128904 */ GIM_Reject,
     /* 128905 */ // Label 23: @128905
     /* 128905 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2439*/ GIMT_Encode4(130396),
     /* 128916 */ /*GILLT_s32*//*Label 2437*/ GIMT_Encode4(128924),
     /* 128920 */ /*GILLT_s64*//*Label 2438*/ GIMT_Encode4(130044),
     /* 128924 */ // Label 2437: @128924
     /* 128924 */ GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(130043),
     /* 128929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 128932 */   GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(129006), // Rule ID 7297 //
     /* 128937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 128940 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128947 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 128950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128954 */     // MIs[0] Rn
     /* 128954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 128958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 128962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128966 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 128966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 128973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128978 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128984 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 128988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 128993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128998 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129004 */     GIR_RootConstrainSelectedInstOperands,
     /* 129005 */     // GIR_Coverage, 7297,
     /* 129005 */     GIR_EraseRootFromParent_Done,
     /* 129006 */   // Label 2441: @129006
     /* 129006 */   GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(129080), // Rule ID 7298 //
     /* 129011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129014 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129021 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129028 */     // MIs[0] Rn
     /* 129028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129040 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129052 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 129067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129069 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129078 */     GIR_RootConstrainSelectedInstOperands,
     /* 129079 */     // GIR_Coverage, 7298,
     /* 129079 */     GIR_EraseRootFromParent_Done,
     /* 129080 */   // Label 2442: @129080
     /* 129080 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(129154), // Rule ID 7299 //
     /* 129085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129088 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129095 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129102 */     // MIs[0] Rn
     /* 129102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129114 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129126 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129132 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 129141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129146 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129148 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129152 */     GIR_RootConstrainSelectedInstOperands,
     /* 129153 */     // GIR_Coverage, 7299,
     /* 129153 */     GIR_EraseRootFromParent_Done,
     /* 129154 */   // Label 2443: @129154
     /* 129154 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(129228), // Rule ID 7300 //
     /* 129159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129162 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129169 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129176 */     // MIs[0] Rn
     /* 129176 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129188 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129200 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129206 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 129215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129226 */     GIR_RootConstrainSelectedInstOperands,
     /* 129227 */     // GIR_Coverage, 7300,
     /* 129227 */     GIR_EraseRootFromParent_Done,
     /* 129228 */   // Label 2444: @129228
     /* 129228 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(129302), // Rule ID 7301 //
     /* 129233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129236 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 129243 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129250 */     // MIs[0] Rn
     /* 129250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129262 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129262 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129265 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129269 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129274 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129280 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 129289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129294 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129300 */     GIR_RootConstrainSelectedInstOperands,
     /* 129301 */     // GIR_Coverage, 7301,
     /* 129301 */     GIR_EraseRootFromParent_Done,
     /* 129302 */   // Label 2445: @129302
     /* 129302 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(129376), // Rule ID 7302 //
     /* 129307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129310 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129317 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129324 */     // MIs[0] Rn
     /* 129324 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129336 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129348 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129354 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 129363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129368 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129370 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129374 */     GIR_RootConstrainSelectedInstOperands,
     /* 129375 */     // GIR_Coverage, 7302,
     /* 129375 */     GIR_EraseRootFromParent_Done,
     /* 129376 */   // Label 2446: @129376
     /* 129376 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(129450), // Rule ID 7303 //
     /* 129381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129384 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129391 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129398 */     // MIs[0] Rn
     /* 129398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129402 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129410 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129422 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129428 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 129437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129448 */     GIR_RootConstrainSelectedInstOperands,
     /* 129449 */     // GIR_Coverage, 7303,
     /* 129449 */     GIR_EraseRootFromParent_Done,
     /* 129450 */   // Label 2447: @129450
     /* 129450 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(129524), // Rule ID 7304 //
     /* 129455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129472 */     // MIs[0] Rn
     /* 129472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129484 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129496 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129502 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 129511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129522 */     GIR_RootConstrainSelectedInstOperands,
     /* 129523 */     // GIR_Coverage, 7304,
     /* 129523 */     GIR_EraseRootFromParent_Done,
     /* 129524 */   // Label 2448: @129524
     /* 129524 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(129598), // Rule ID 7305 //
     /* 129529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129532 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129539 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129546 */     // MIs[0] Rn
     /* 129546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129558 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129570 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129576 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 129585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129592 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129596 */     GIR_RootConstrainSelectedInstOperands,
     /* 129597 */     // GIR_Coverage, 7305,
     /* 129597 */     GIR_EraseRootFromParent_Done,
     /* 129598 */   // Label 2449: @129598
     /* 129598 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(129672), // Rule ID 7306 //
     /* 129603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129606 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129613 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129620 */     // MIs[0] Rn
     /* 129620 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129624 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129632 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129632 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129635 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129639 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129644 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 129659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129670 */     GIR_RootConstrainSelectedInstOperands,
     /* 129671 */     // GIR_Coverage, 7306,
     /* 129671 */     GIR_EraseRootFromParent_Done,
     /* 129672 */   // Label 2450: @129672
     /* 129672 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(129746), // Rule ID 7307 //
     /* 129677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129680 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129687 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 129690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129694 */     // MIs[0] Rn
     /* 129694 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129706 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129718 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129724 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 129733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129738 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129744 */     GIR_RootConstrainSelectedInstOperands,
     /* 129745 */     // GIR_Coverage, 7307,
     /* 129745 */     GIR_EraseRootFromParent_Done,
     /* 129746 */   // Label 2451: @129746
     /* 129746 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(129820), // Rule ID 7308 //
     /* 129751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129754 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129761 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129768 */     // MIs[0] Rn
     /* 129768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129780 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129792 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129798 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 129807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129818 */     GIR_RootConstrainSelectedInstOperands,
     /* 129819 */     // GIR_Coverage, 7308,
     /* 129819 */     GIR_EraseRootFromParent_Done,
     /* 129820 */   // Label 2452: @129820
     /* 129820 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(129894), // Rule ID 7309 //
     /* 129825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129828 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129835 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 129838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129842 */     // MIs[0] Rn
     /* 129842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129854 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129854 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129857 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129861 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129866 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129872 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 129881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129883 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129892 */     GIR_RootConstrainSelectedInstOperands,
     /* 129893 */     // GIR_Coverage, 7309,
     /* 129893 */     GIR_EraseRootFromParent_Done,
     /* 129894 */   // Label 2453: @129894
     /* 129894 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(129968), // Rule ID 7310 //
     /* 129899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129902 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129909 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 129912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129916 */     // MIs[0] Rn
     /* 129916 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129920 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129928 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 129928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 129935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129940 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 129950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 129955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129960 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 129962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129966 */     GIR_RootConstrainSelectedInstOperands,
     /* 129967 */     // GIR_Coverage, 7310,
     /* 129967 */     GIR_EraseRootFromParent_Done,
     /* 129968 */   // Label 2454: @129968
     /* 129968 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(130042), // Rule ID 7311 //
     /* 129973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 129976 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129983 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129990 */     // MIs[0] Rn
     /* 129990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130002 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 130009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130014 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130020 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 130029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130040 */     GIR_RootConstrainSelectedInstOperands,
     /* 130041 */     // GIR_Coverage, 7311,
     /* 130041 */     GIR_EraseRootFromParent_Done,
     /* 130042 */   // Label 2455: @130042
     /* 130042 */   GIM_Reject,
     /* 130043 */ // Label 2440: @130043
     /* 130043 */ GIM_Reject,
     /* 130044 */ // Label 2438: @130044
     /* 130044 */ GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(130395),
     /* 130049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 130052 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 130059 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(130126), // Rule ID 7292 //
     /* 130064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130067 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130074 */     // MIs[0] Rn
     /* 130074 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130078 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130086 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130086 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130089 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 130093 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130098 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130104 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 130113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130118 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130124 */     GIR_RootConstrainSelectedInstOperands,
     /* 130125 */     // GIR_Coverage, 7292,
     /* 130125 */     GIR_EraseRootFromParent_Done,
     /* 130126 */   // Label 2457: @130126
     /* 130126 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(130193), // Rule ID 7293 //
     /* 130131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130134 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130141 */     // MIs[0] Rn
     /* 130141 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130153 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 130160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130165 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130171 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 130180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130187 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130191 */     GIR_RootConstrainSelectedInstOperands,
     /* 130192 */     // GIR_Coverage, 7293,
     /* 130192 */     GIR_EraseRootFromParent_Done,
     /* 130193 */   // Label 2458: @130193
     /* 130193 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(130260), // Rule ID 7294 //
     /* 130198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130201 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130208 */     // MIs[0] Rn
     /* 130208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130220 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 130227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130232 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130238 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 130247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130252 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130258 */     GIR_RootConstrainSelectedInstOperands,
     /* 130259 */     // GIR_Coverage, 7294,
     /* 130259 */     GIR_EraseRootFromParent_Done,
     /* 130260 */   // Label 2459: @130260
     /* 130260 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(130327), // Rule ID 7295 //
     /* 130265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130268 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130275 */     // MIs[0] Rn
     /* 130275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130287 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 130294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130299 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130305 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 130314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130321 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130325 */     GIR_RootConstrainSelectedInstOperands,
     /* 130326 */     // GIR_Coverage, 7295,
     /* 130326 */     GIR_EraseRootFromParent_Done,
     /* 130327 */   // Label 2460: @130327
     /* 130327 */   GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(130394), // Rule ID 7296 //
     /* 130332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130335 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130342 */     // MIs[0] Rn
     /* 130342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 130354 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130354 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 130357 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 130361 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130366 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130372 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 130381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130392 */     GIR_RootConstrainSelectedInstOperands,
     /* 130393 */     // GIR_Coverage, 7296,
     /* 130393 */     GIR_EraseRootFromParent_Done,
     /* 130394 */   // Label 2461: @130394
     /* 130394 */   GIM_Reject,
     /* 130395 */ // Label 2456: @130395
     /* 130395 */ GIM_Reject,
     /* 130396 */ // Label 2439: @130396
     /* 130396 */ GIM_Reject,
     /* 130397 */ // Label 24: @130397
     /* 130397 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2464*/ GIMT_Encode4(131888),
     /* 130408 */ /*GILLT_s32*//*Label 2462*/ GIMT_Encode4(130416),
     /* 130412 */ /*GILLT_s64*//*Label 2463*/ GIMT_Encode4(131536),
     /* 130416 */ // Label 2462: @130416
     /* 130416 */ GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(131535),
     /* 130421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 130424 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(130498), // Rule ID 7317 //
     /* 130429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130432 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130439 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130446 */     // MIs[0] Rn
     /* 130446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130450 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130458 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130458 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130461 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130465 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130470 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130476 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130480 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
     /* 130485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130492 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130496 */     GIR_RootConstrainSelectedInstOperands,
     /* 130497 */     // GIR_Coverage, 7317,
     /* 130497 */     GIR_EraseRootFromParent_Done,
     /* 130498 */   // Label 2466: @130498
     /* 130498 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(130572), // Rule ID 7318 //
     /* 130503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130506 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130513 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130520 */     // MIs[0] Rn
     /* 130520 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130532 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130544 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130550 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
     /* 130559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130566 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130570 */     GIR_RootConstrainSelectedInstOperands,
     /* 130571 */     // GIR_Coverage, 7318,
     /* 130571 */     GIR_EraseRootFromParent_Done,
     /* 130572 */   // Label 2467: @130572
     /* 130572 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(130646), // Rule ID 7319 //
     /* 130577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130580 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130587 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130594 */     // MIs[0] Rn
     /* 130594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130606 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130618 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130624 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
     /* 130633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130644 */     GIR_RootConstrainSelectedInstOperands,
     /* 130645 */     // GIR_Coverage, 7319,
     /* 130645 */     GIR_EraseRootFromParent_Done,
     /* 130646 */   // Label 2468: @130646
     /* 130646 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(130720), // Rule ID 7320 //
     /* 130651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130654 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130661 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 130664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130668 */     // MIs[0] Rn
     /* 130668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130680 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130692 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130698 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 130707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130709 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130718 */     GIR_RootConstrainSelectedInstOperands,
     /* 130719 */     // GIR_Coverage, 7320,
     /* 130719 */     GIR_EraseRootFromParent_Done,
     /* 130720 */   // Label 2469: @130720
     /* 130720 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(130794), // Rule ID 7321 //
     /* 130725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130728 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130735 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 130738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130742 */     // MIs[0] Rn
     /* 130742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130754 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130766 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130772 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 130781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130786 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130792 */     GIR_RootConstrainSelectedInstOperands,
     /* 130793 */     // GIR_Coverage, 7321,
     /* 130793 */     GIR_EraseRootFromParent_Done,
     /* 130794 */   // Label 2470: @130794
     /* 130794 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(130868), // Rule ID 7322 //
     /* 130799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130802 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130809 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 130812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130816 */     // MIs[0] Rn
     /* 130816 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130828 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130840 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130846 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
     /* 130855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130862 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130866 */     GIR_RootConstrainSelectedInstOperands,
     /* 130867 */     // GIR_Coverage, 7322,
     /* 130867 */     GIR_EraseRootFromParent_Done,
     /* 130868 */   // Label 2471: @130868
     /* 130868 */   GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(130942), // Rule ID 7323 //
     /* 130873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130883 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 130886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130890 */     // MIs[0] Rn
     /* 130890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130902 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130914 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130920 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
     /* 130929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 130931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 130936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130940 */     GIR_RootConstrainSelectedInstOperands,
     /* 130941 */     // GIR_Coverage, 7323,
     /* 130941 */     GIR_EraseRootFromParent_Done,
     /* 130942 */   // Label 2472: @130942
     /* 130942 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(131016), // Rule ID 7324 //
     /* 130947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 130950 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130957 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 130960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130964 */     // MIs[0] Rn
     /* 130964 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 130968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 130972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130976 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 130976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 130983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130988 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130994 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 130998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
     /* 131003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131005 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131014 */     GIR_RootConstrainSelectedInstOperands,
     /* 131015 */     // GIR_Coverage, 7324,
     /* 131015 */     GIR_EraseRootFromParent_Done,
     /* 131016 */   // Label 2473: @131016
     /* 131016 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(131090), // Rule ID 7325 //
     /* 131021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131024 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131031 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131038 */     // MIs[0] Rn
     /* 131038 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131050 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131062 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131068 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 131077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131082 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131088 */     GIR_RootConstrainSelectedInstOperands,
     /* 131089 */     // GIR_Coverage, 7325,
     /* 131089 */     GIR_EraseRootFromParent_Done,
     /* 131090 */   // Label 2474: @131090
     /* 131090 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(131164), // Rule ID 7326 //
     /* 131095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131098 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131105 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131112 */     // MIs[0] Rn
     /* 131112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131124 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131136 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 131151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131162 */     GIR_RootConstrainSelectedInstOperands,
     /* 131163 */     // GIR_Coverage, 7326,
     /* 131163 */     GIR_EraseRootFromParent_Done,
     /* 131164 */   // Label 2475: @131164
     /* 131164 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(131238), // Rule ID 7327 //
     /* 131169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131172 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131179 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131186 */     // MIs[0] Rn
     /* 131186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131198 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131210 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131216 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
     /* 131225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131236 */     GIR_RootConstrainSelectedInstOperands,
     /* 131237 */     // GIR_Coverage, 7327,
     /* 131237 */     GIR_EraseRootFromParent_Done,
     /* 131238 */   // Label 2476: @131238
     /* 131238 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(131312), // Rule ID 7328 //
     /* 131243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131246 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131253 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131260 */     // MIs[0] Rn
     /* 131260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131272 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131284 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131290 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
     /* 131299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131310 */     GIR_RootConstrainSelectedInstOperands,
     /* 131311 */     // GIR_Coverage, 7328,
     /* 131311 */     GIR_EraseRootFromParent_Done,
     /* 131312 */   // Label 2477: @131312
     /* 131312 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(131386), // Rule ID 7329 //
     /* 131317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131320 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131327 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131334 */     // MIs[0] Rn
     /* 131334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131346 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131358 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131368 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
     /* 131373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131384 */     GIR_RootConstrainSelectedInstOperands,
     /* 131385 */     // GIR_Coverage, 7329,
     /* 131385 */     GIR_EraseRootFromParent_Done,
     /* 131386 */   // Label 2478: @131386
     /* 131386 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(131460), // Rule ID 7330 //
     /* 131391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131394 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131401 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131408 */     // MIs[0] Rn
     /* 131408 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131420 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131432 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131438 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 131447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131454 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131458 */     GIR_RootConstrainSelectedInstOperands,
     /* 131459 */     // GIR_Coverage, 7330,
     /* 131459 */     GIR_EraseRootFromParent_Done,
     /* 131460 */   // Label 2479: @131460
     /* 131460 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(131534), // Rule ID 7331 //
     /* 131465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131468 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131475 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131482 */     // MIs[0] Rn
     /* 131482 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131494 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 131501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131506 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 131521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131526 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131532 */     GIR_RootConstrainSelectedInstOperands,
     /* 131533 */     // GIR_Coverage, 7331,
     /* 131533 */     GIR_EraseRootFromParent_Done,
     /* 131534 */   // Label 2480: @131534
     /* 131534 */   GIM_Reject,
     /* 131535 */ // Label 2465: @131535
     /* 131535 */ GIM_Reject,
     /* 131536 */ // Label 2463: @131536
     /* 131536 */ GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(131887),
     /* 131541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 131544 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 131551 */   GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(131618), // Rule ID 7312 //
     /* 131556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131559 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131566 */     // MIs[0] Rn
     /* 131566 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131570 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131578 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131590 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131600 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
     /* 131605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131610 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131616 */     GIR_RootConstrainSelectedInstOperands,
     /* 131617 */     // GIR_Coverage, 7312,
     /* 131617 */     GIR_EraseRootFromParent_Done,
     /* 131618 */   // Label 2482: @131618
     /* 131618 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(131685), // Rule ID 7313 //
     /* 131623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131626 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131633 */     // MIs[0] Rn
     /* 131633 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131645 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131645 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131648 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131652 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131657 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131663 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131667 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
     /* 131672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131677 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131679 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131683 */     GIR_RootConstrainSelectedInstOperands,
     /* 131684 */     // GIR_Coverage, 7313,
     /* 131684 */     GIR_EraseRootFromParent_Done,
     /* 131685 */   // Label 2483: @131685
     /* 131685 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(131752), // Rule ID 7314 //
     /* 131690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131693 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 131696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131700 */     // MIs[0] Rn
     /* 131700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131712 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131724 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131730 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
     /* 131739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131750 */     GIR_RootConstrainSelectedInstOperands,
     /* 131751 */     // GIR_Coverage, 7314,
     /* 131751 */     GIR_EraseRootFromParent_Done,
     /* 131752 */   // Label 2484: @131752
     /* 131752 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(131819), // Rule ID 7315 //
     /* 131757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131760 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 131763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131767 */     // MIs[0] Rn
     /* 131767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131779 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131791 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131797 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131801 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 131806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131811 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131813 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131817 */     GIR_RootConstrainSelectedInstOperands,
     /* 131818 */     // GIR_Coverage, 7315,
     /* 131818 */     GIR_EraseRootFromParent_Done,
     /* 131819 */   // Label 2485: @131819
     /* 131819 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(131886), // Rule ID 7316 //
     /* 131824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131827 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 131830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131834 */     // MIs[0] Rn
     /* 131834 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 131846 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 131846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 131849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 131853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131858 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 131864 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 131868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 131873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131878 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131884 */     GIR_RootConstrainSelectedInstOperands,
     /* 131885 */     // GIR_Coverage, 7316,
     /* 131885 */     GIR_EraseRootFromParent_Done,
     /* 131886 */   // Label 2486: @131886
     /* 131886 */   GIM_Reject,
     /* 131887 */ // Label 2481: @131887
     /* 131887 */ GIM_Reject,
     /* 131888 */ // Label 2464: @131888
     /* 131888 */ GIM_Reject,
     /* 131889 */ // Label 25: @131889
     /* 131889 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2489*/ GIMT_Encode4(132880),
     /* 131900 */ /*GILLT_s32*//*Label 2487*/ GIMT_Encode4(131908),
     /* 131904 */ /*GILLT_s64*//*Label 2488*/ GIMT_Encode4(132653),
     /* 131908 */ // Label 2487: @131908
     /* 131908 */ GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(132652),
     /* 131913 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 131916 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(131965), // Rule ID 7122 //
     /* 131921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131924 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131931 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 131934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131938 */     // MIs[0] Rn
     /* 131938 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131950 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
     /* 131953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 131955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 131957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131963 */     GIR_RootConstrainSelectedInstOperands,
     /* 131964 */     // GIR_Coverage, 7122,
     /* 131964 */     GIR_EraseRootFromParent_Done,
     /* 131965 */   // Label 2491: @131965
     /* 131965 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(132014), // Rule ID 7123 //
     /* 131970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 131973 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 131980 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 131983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131987 */     // MIs[0] Rn
     /* 131987 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131999 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 131999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
     /* 132002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132006 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132012 */     GIR_RootConstrainSelectedInstOperands,
     /* 132013 */     // GIR_Coverage, 7123,
     /* 132013 */     GIR_EraseRootFromParent_Done,
     /* 132014 */   // Label 2492: @132014
     /* 132014 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(132063), // Rule ID 7124 //
     /* 132019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132022 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132029 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132036 */     // MIs[0] Rn
     /* 132036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132040 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132048 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
     /* 132051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132055 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132061 */     GIR_RootConstrainSelectedInstOperands,
     /* 132062 */     // GIR_Coverage, 7124,
     /* 132062 */     GIR_EraseRootFromParent_Done,
     /* 132063 */   // Label 2493: @132063
     /* 132063 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(132112), // Rule ID 7125 //
     /* 132068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132071 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132078 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132085 */     // MIs[0] Rn
     /* 132085 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132097 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 132100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132106 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132110 */     GIR_RootConstrainSelectedInstOperands,
     /* 132111 */     // GIR_Coverage, 7125,
     /* 132111 */     GIR_EraseRootFromParent_Done,
     /* 132112 */   // Label 2494: @132112
     /* 132112 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(132161), // Rule ID 7126 //
     /* 132117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132120 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132127 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132134 */     // MIs[0] Rn
     /* 132134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132146 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 132149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132153 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132159 */     GIR_RootConstrainSelectedInstOperands,
     /* 132160 */     // GIR_Coverage, 7126,
     /* 132160 */     GIR_EraseRootFromParent_Done,
     /* 132161 */   // Label 2495: @132161
     /* 132161 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(132210), // Rule ID 7127 //
     /* 132166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132169 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132176 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132183 */     // MIs[0] Rn
     /* 132183 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132187 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132195 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
     /* 132198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132202 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132208 */     GIR_RootConstrainSelectedInstOperands,
     /* 132209 */     // GIR_Coverage, 7127,
     /* 132209 */     GIR_EraseRootFromParent_Done,
     /* 132210 */   // Label 2496: @132210
     /* 132210 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(132259), // Rule ID 7128 //
     /* 132215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132218 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132225 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132232 */     // MIs[0] Rn
     /* 132232 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132244 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
     /* 132247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132251 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132253 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132257 */     GIR_RootConstrainSelectedInstOperands,
     /* 132258 */     // GIR_Coverage, 7128,
     /* 132258 */     GIR_EraseRootFromParent_Done,
     /* 132259 */   // Label 2497: @132259
     /* 132259 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(132308), // Rule ID 7129 //
     /* 132264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132267 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132274 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132281 */     // MIs[0] Rn
     /* 132281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132293 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
     /* 132296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132300 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132306 */     GIR_RootConstrainSelectedInstOperands,
     /* 132307 */     // GIR_Coverage, 7129,
     /* 132307 */     GIR_EraseRootFromParent_Done,
     /* 132308 */   // Label 2498: @132308
     /* 132308 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(132357), // Rule ID 7130 //
     /* 132313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132316 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132323 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132330 */     // MIs[0] Rn
     /* 132330 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132342 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 132345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132355 */     GIR_RootConstrainSelectedInstOperands,
     /* 132356 */     // GIR_Coverage, 7130,
     /* 132356 */     GIR_EraseRootFromParent_Done,
     /* 132357 */   // Label 2499: @132357
     /* 132357 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(132406), // Rule ID 7131 //
     /* 132362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132365 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132372 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132379 */     // MIs[0] Rn
     /* 132379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132391 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 132394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132398 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132404 */     GIR_RootConstrainSelectedInstOperands,
     /* 132405 */     // GIR_Coverage, 7131,
     /* 132405 */     GIR_EraseRootFromParent_Done,
     /* 132406 */   // Label 2500: @132406
     /* 132406 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(132455), // Rule ID 7132 //
     /* 132411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132414 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132421 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132428 */     // MIs[0] Rn
     /* 132428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132440 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
     /* 132443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132453 */     GIR_RootConstrainSelectedInstOperands,
     /* 132454 */     // GIR_Coverage, 7132,
     /* 132454 */     GIR_EraseRootFromParent_Done,
     /* 132455 */   // Label 2501: @132455
     /* 132455 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(132504), // Rule ID 7133 //
     /* 132460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132463 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132470 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132477 */     // MIs[0] Rn
     /* 132477 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132489 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
     /* 132492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132498 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132502 */     GIR_RootConstrainSelectedInstOperands,
     /* 132503 */     // GIR_Coverage, 7133,
     /* 132503 */     GIR_EraseRootFromParent_Done,
     /* 132504 */   // Label 2502: @132504
     /* 132504 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(132553), // Rule ID 7134 //
     /* 132509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132512 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132519 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132526 */     // MIs[0] Rn
     /* 132526 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132538 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
     /* 132541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132551 */     GIR_RootConstrainSelectedInstOperands,
     /* 132552 */     // GIR_Coverage, 7134,
     /* 132552 */     GIR_EraseRootFromParent_Done,
     /* 132553 */   // Label 2503: @132553
     /* 132553 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(132602), // Rule ID 7135 //
     /* 132558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132561 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132568 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132575 */     // MIs[0] Rn
     /* 132575 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132587 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 132590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132594 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132600 */     GIR_RootConstrainSelectedInstOperands,
     /* 132601 */     // GIR_Coverage, 7135,
     /* 132601 */     GIR_EraseRootFromParent_Done,
     /* 132602 */   // Label 2504: @132602
     /* 132602 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(132651), // Rule ID 7136 //
     /* 132607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132610 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 132617 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132624 */     // MIs[0] Rn
     /* 132624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132636 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 132639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132649 */     GIR_RootConstrainSelectedInstOperands,
     /* 132650 */     // GIR_Coverage, 7136,
     /* 132650 */     GIR_EraseRootFromParent_Done,
     /* 132651 */   // Label 2505: @132651
     /* 132651 */   GIM_Reject,
     /* 132652 */ // Label 2490: @132652
     /* 132652 */ GIM_Reject,
     /* 132653 */ // Label 2488: @132653
     /* 132653 */ GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(132879),
     /* 132658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 132661 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 132668 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(132710), // Rule ID 7117 //
     /* 132673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132676 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132683 */     // MIs[0] Rn
     /* 132683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132695 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
     /* 132698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132708 */     GIR_RootConstrainSelectedInstOperands,
     /* 132709 */     // GIR_Coverage, 7117,
     /* 132709 */     GIR_EraseRootFromParent_Done,
     /* 132710 */   // Label 2507: @132710
     /* 132710 */   GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(132752), // Rule ID 7118 //
     /* 132715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132718 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132725 */     // MIs[0] Rn
     /* 132725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132737 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
     /* 132740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132750 */     GIR_RootConstrainSelectedInstOperands,
     /* 132751 */     // GIR_Coverage, 7118,
     /* 132751 */     GIR_EraseRootFromParent_Done,
     /* 132752 */   // Label 2508: @132752
     /* 132752 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(132794), // Rule ID 7119 //
     /* 132757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132760 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 132763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132767 */     // MIs[0] Rn
     /* 132767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132779 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
     /* 132782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132786 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132792 */     GIR_RootConstrainSelectedInstOperands,
     /* 132793 */     // GIR_Coverage, 7119,
     /* 132793 */     GIR_EraseRootFromParent_Done,
     /* 132794 */   // Label 2509: @132794
     /* 132794 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(132836), // Rule ID 7120 //
     /* 132799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 132805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132809 */     // MIs[0] Rn
     /* 132809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132821 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 132824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132834 */     GIR_RootConstrainSelectedInstOperands,
     /* 132835 */     // GIR_Coverage, 7120,
     /* 132835 */     GIR_EraseRootFromParent_Done,
     /* 132836 */   // Label 2510: @132836
     /* 132836 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(132878), // Rule ID 7121 //
     /* 132841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132844 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 132847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132851 */     // MIs[0] Rn
     /* 132851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 132863 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 132866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132876 */     GIR_RootConstrainSelectedInstOperands,
     /* 132877 */     // GIR_Coverage, 7121,
     /* 132877 */     GIR_EraseRootFromParent_Done,
     /* 132878 */   // Label 2511: @132878
     /* 132878 */   GIM_Reject,
     /* 132879 */ // Label 2506: @132879
     /* 132879 */ GIM_Reject,
     /* 132880 */ // Label 2489: @132880
     /* 132880 */ GIM_Reject,
     /* 132881 */ // Label 26: @132881
     /* 132881 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2514*/ GIMT_Encode4(133872),
     /* 132892 */ /*GILLT_s32*//*Label 2512*/ GIMT_Encode4(132900),
     /* 132896 */ /*GILLT_s64*//*Label 2513*/ GIMT_Encode4(133645),
     /* 132900 */ // Label 2512: @132900
     /* 132900 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(133644),
     /* 132905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 132908 */   GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(132957), // Rule ID 7142 //
     /* 132913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132916 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132923 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 132926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132930 */     // MIs[0] Rn
     /* 132930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132942 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
     /* 132945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132951 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132955 */     GIR_RootConstrainSelectedInstOperands,
     /* 132956 */     // GIR_Coverage, 7142,
     /* 132956 */     GIR_EraseRootFromParent_Done,
     /* 132957 */   // Label 2516: @132957
     /* 132957 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(133006), // Rule ID 7143 //
     /* 132962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 132965 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 132972 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 132975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132979 */     // MIs[0] Rn
     /* 132979 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 132991 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 132991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
     /* 132994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 132996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 132998 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133004 */     GIR_RootConstrainSelectedInstOperands,
     /* 133005 */     // GIR_Coverage, 7143,
     /* 133005 */     GIR_EraseRootFromParent_Done,
     /* 133006 */   // Label 2517: @133006
     /* 133006 */   GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(133055), // Rule ID 7144 //
     /* 133011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133014 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133021 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133028 */     // MIs[0] Rn
     /* 133028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133040 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
     /* 133043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133047 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133049 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133053 */     GIR_RootConstrainSelectedInstOperands,
     /* 133054 */     // GIR_Coverage, 7144,
     /* 133054 */     GIR_EraseRootFromParent_Done,
     /* 133055 */   // Label 2518: @133055
     /* 133055 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(133104), // Rule ID 7145 //
     /* 133060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133063 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133070 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133077 */     // MIs[0] Rn
     /* 133077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133089 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 133092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133096 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133102 */     GIR_RootConstrainSelectedInstOperands,
     /* 133103 */     // GIR_Coverage, 7145,
     /* 133103 */     GIR_EraseRootFromParent_Done,
     /* 133104 */   // Label 2519: @133104
     /* 133104 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(133153), // Rule ID 7146 //
     /* 133109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133112 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133119 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133126 */     // MIs[0] Rn
     /* 133126 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133138 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 133141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133151 */     GIR_RootConstrainSelectedInstOperands,
     /* 133152 */     // GIR_Coverage, 7146,
     /* 133152 */     GIR_EraseRootFromParent_Done,
     /* 133153 */   // Label 2520: @133153
     /* 133153 */   GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(133202), // Rule ID 7147 //
     /* 133158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133161 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133168 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133175 */     // MIs[0] Rn
     /* 133175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133187 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
     /* 133190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133200 */     GIR_RootConstrainSelectedInstOperands,
     /* 133201 */     // GIR_Coverage, 7147,
     /* 133201 */     GIR_EraseRootFromParent_Done,
     /* 133202 */   // Label 2521: @133202
     /* 133202 */   GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(133251), // Rule ID 7148 //
     /* 133207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133210 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133217 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133224 */     // MIs[0] Rn
     /* 133224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133236 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
     /* 133239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133245 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133249 */     GIR_RootConstrainSelectedInstOperands,
     /* 133250 */     // GIR_Coverage, 7148,
     /* 133250 */     GIR_EraseRootFromParent_Done,
     /* 133251 */   // Label 2522: @133251
     /* 133251 */   GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(133300), // Rule ID 7149 //
     /* 133256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133259 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133266 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133273 */     // MIs[0] Rn
     /* 133273 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133285 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
     /* 133288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133292 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133298 */     GIR_RootConstrainSelectedInstOperands,
     /* 133299 */     // GIR_Coverage, 7149,
     /* 133299 */     GIR_EraseRootFromParent_Done,
     /* 133300 */   // Label 2523: @133300
     /* 133300 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(133349), // Rule ID 7150 //
     /* 133305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133308 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133315 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133322 */     // MIs[0] Rn
     /* 133322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133334 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 133337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133341 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133343 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133347 */     GIR_RootConstrainSelectedInstOperands,
     /* 133348 */     // GIR_Coverage, 7150,
     /* 133348 */     GIR_EraseRootFromParent_Done,
     /* 133349 */   // Label 2524: @133349
     /* 133349 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(133398), // Rule ID 7151 //
     /* 133354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133357 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133364 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133371 */     // MIs[0] Rn
     /* 133371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133383 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 133386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133396 */     GIR_RootConstrainSelectedInstOperands,
     /* 133397 */     // GIR_Coverage, 7151,
     /* 133397 */     GIR_EraseRootFromParent_Done,
     /* 133398 */   // Label 2525: @133398
     /* 133398 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(133447), // Rule ID 7152 //
     /* 133403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133406 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133413 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133420 */     // MIs[0] Rn
     /* 133420 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133432 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
     /* 133435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133439 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133441 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133445 */     GIR_RootConstrainSelectedInstOperands,
     /* 133446 */     // GIR_Coverage, 7152,
     /* 133446 */     GIR_EraseRootFromParent_Done,
     /* 133447 */   // Label 2526: @133447
     /* 133447 */   GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(133496), // Rule ID 7153 //
     /* 133452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133455 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133462 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133469 */     // MIs[0] Rn
     /* 133469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133481 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
     /* 133484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133488 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133494 */     GIR_RootConstrainSelectedInstOperands,
     /* 133495 */     // GIR_Coverage, 7153,
     /* 133495 */     GIR_EraseRootFromParent_Done,
     /* 133496 */   // Label 2527: @133496
     /* 133496 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(133545), // Rule ID 7154 //
     /* 133501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133504 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133511 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133518 */     // MIs[0] Rn
     /* 133518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133530 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
     /* 133533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133539 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133543 */     GIR_RootConstrainSelectedInstOperands,
     /* 133544 */     // GIR_Coverage, 7154,
     /* 133544 */     GIR_EraseRootFromParent_Done,
     /* 133545 */   // Label 2528: @133545
     /* 133545 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(133594), // Rule ID 7155 //
     /* 133550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133553 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133560 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133567 */     // MIs[0] Rn
     /* 133567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133571 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133579 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 133582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133592 */     GIR_RootConstrainSelectedInstOperands,
     /* 133593 */     // GIR_Coverage, 7155,
     /* 133593 */     GIR_EraseRootFromParent_Done,
     /* 133594 */   // Label 2529: @133594
     /* 133594 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(133643), // Rule ID 7156 //
     /* 133599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133602 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 133609 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133616 */     // MIs[0] Rn
     /* 133616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133628 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 133631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133635 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133637 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133641 */     GIR_RootConstrainSelectedInstOperands,
     /* 133642 */     // GIR_Coverage, 7156,
     /* 133642 */     GIR_EraseRootFromParent_Done,
     /* 133643 */   // Label 2530: @133643
     /* 133643 */   GIM_Reject,
     /* 133644 */ // Label 2515: @133644
     /* 133644 */ GIM_Reject,
     /* 133645 */ // Label 2513: @133645
     /* 133645 */ GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(133871),
     /* 133650 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 133653 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 133660 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(133702), // Rule ID 7137 //
     /* 133665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133668 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133675 */     // MIs[0] Rn
     /* 133675 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133687 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
     /* 133690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133694 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133696 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133700 */     GIR_RootConstrainSelectedInstOperands,
     /* 133701 */     // GIR_Coverage, 7137,
     /* 133701 */     GIR_EraseRootFromParent_Done,
     /* 133702 */   // Label 2532: @133702
     /* 133702 */   GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(133744), // Rule ID 7138 //
     /* 133707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133710 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133717 */     // MIs[0] Rn
     /* 133717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133729 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
     /* 133732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133742 */     GIR_RootConstrainSelectedInstOperands,
     /* 133743 */     // GIR_Coverage, 7138,
     /* 133743 */     GIR_EraseRootFromParent_Done,
     /* 133744 */   // Label 2533: @133744
     /* 133744 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(133786), // Rule ID 7139 //
     /* 133749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133752 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 133755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133759 */     // MIs[0] Rn
     /* 133759 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133763 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133771 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
     /* 133774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133778 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133780 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133784 */     GIR_RootConstrainSelectedInstOperands,
     /* 133785 */     // GIR_Coverage, 7139,
     /* 133785 */     GIR_EraseRootFromParent_Done,
     /* 133786 */   // Label 2534: @133786
     /* 133786 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(133828), // Rule ID 7140 //
     /* 133791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133794 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 133797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133801 */     // MIs[0] Rn
     /* 133801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133813 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 133816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133826 */     GIR_RootConstrainSelectedInstOperands,
     /* 133827 */     // GIR_Coverage, 7140,
     /* 133827 */     GIR_EraseRootFromParent_Done,
     /* 133828 */   // Label 2535: @133828
     /* 133828 */   GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(133870), // Rule ID 7141 //
     /* 133833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133836 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 133839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133843 */     // MIs[0] Rn
     /* 133843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 133855 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 133858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133868 */     GIR_RootConstrainSelectedInstOperands,
     /* 133869 */     // GIR_Coverage, 7141,
     /* 133869 */     GIR_EraseRootFromParent_Done,
     /* 133870 */   // Label 2536: @133870
     /* 133870 */   GIM_Reject,
     /* 133871 */ // Label 2531: @133871
     /* 133871 */ GIM_Reject,
     /* 133872 */ // Label 2514: @133872
     /* 133872 */ GIM_Reject,
     /* 133873 */ // Label 27: @133873
     /* 133873 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2539*/ GIMT_Encode4(134864),
     /* 133884 */ /*GILLT_s32*//*Label 2537*/ GIMT_Encode4(133892),
     /* 133888 */ /*GILLT_s64*//*Label 2538*/ GIMT_Encode4(134637),
     /* 133892 */ // Label 2537: @133892
     /* 133892 */ GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(134636),
     /* 133897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 133900 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(133949), // Rule ID 7182 //
     /* 133905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133908 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133915 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 133918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133922 */     // MIs[0] Rn
     /* 133922 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133934 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
     /* 133937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133947 */     GIR_RootConstrainSelectedInstOperands,
     /* 133948 */     // GIR_Coverage, 7182,
     /* 133948 */     GIR_EraseRootFromParent_Done,
     /* 133949 */   // Label 2541: @133949
     /* 133949 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(133998), // Rule ID 7183 //
     /* 133954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 133957 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 133964 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 133967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133971 */     // MIs[0] Rn
     /* 133971 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 133975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 133979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 133983 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 133983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
     /* 133986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 133988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 133990 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 133992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 133996 */     GIR_RootConstrainSelectedInstOperands,
     /* 133997 */     // GIR_Coverage, 7183,
     /* 133997 */     GIR_EraseRootFromParent_Done,
     /* 133998 */   // Label 2542: @133998
     /* 133998 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(134047), // Rule ID 7184 //
     /* 134003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134006 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134013 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134020 */     // MIs[0] Rn
     /* 134020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134032 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
     /* 134035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134039 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134045 */     GIR_RootConstrainSelectedInstOperands,
     /* 134046 */     // GIR_Coverage, 7184,
     /* 134046 */     GIR_EraseRootFromParent_Done,
     /* 134047 */   // Label 2543: @134047
     /* 134047 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(134096), // Rule ID 7185 //
     /* 134052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134055 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134062 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134069 */     // MIs[0] Rn
     /* 134069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134081 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 134084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134088 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134090 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134094 */     GIR_RootConstrainSelectedInstOperands,
     /* 134095 */     // GIR_Coverage, 7185,
     /* 134095 */     GIR_EraseRootFromParent_Done,
     /* 134096 */   // Label 2544: @134096
     /* 134096 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(134145), // Rule ID 7186 //
     /* 134101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134104 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134111 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134118 */     // MIs[0] Rn
     /* 134118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134130 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 134133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134143 */     GIR_RootConstrainSelectedInstOperands,
     /* 134144 */     // GIR_Coverage, 7186,
     /* 134144 */     GIR_EraseRootFromParent_Done,
     /* 134145 */   // Label 2545: @134145
     /* 134145 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(134194), // Rule ID 7187 //
     /* 134150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134153 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134160 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134167 */     // MIs[0] Rn
     /* 134167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134179 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
     /* 134182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134192 */     GIR_RootConstrainSelectedInstOperands,
     /* 134193 */     // GIR_Coverage, 7187,
     /* 134193 */     GIR_EraseRootFromParent_Done,
     /* 134194 */   // Label 2546: @134194
     /* 134194 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(134243), // Rule ID 7188 //
     /* 134199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134202 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134209 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134216 */     // MIs[0] Rn
     /* 134216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134228 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
     /* 134231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134235 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134241 */     GIR_RootConstrainSelectedInstOperands,
     /* 134242 */     // GIR_Coverage, 7188,
     /* 134242 */     GIR_EraseRootFromParent_Done,
     /* 134243 */   // Label 2547: @134243
     /* 134243 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(134292), // Rule ID 7189 //
     /* 134248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134251 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134258 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134265 */     // MIs[0] Rn
     /* 134265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134277 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
     /* 134280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134284 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134290 */     GIR_RootConstrainSelectedInstOperands,
     /* 134291 */     // GIR_Coverage, 7189,
     /* 134291 */     GIR_EraseRootFromParent_Done,
     /* 134292 */   // Label 2548: @134292
     /* 134292 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(134341), // Rule ID 7190 //
     /* 134297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134300 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134307 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134314 */     // MIs[0] Rn
     /* 134314 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134318 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134326 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 134329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134333 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134335 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134339 */     GIR_RootConstrainSelectedInstOperands,
     /* 134340 */     // GIR_Coverage, 7190,
     /* 134340 */     GIR_EraseRootFromParent_Done,
     /* 134341 */   // Label 2549: @134341
     /* 134341 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(134390), // Rule ID 7191 //
     /* 134346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134349 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134356 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134363 */     // MIs[0] Rn
     /* 134363 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134367 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134375 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 134378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134384 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134388 */     GIR_RootConstrainSelectedInstOperands,
     /* 134389 */     // GIR_Coverage, 7191,
     /* 134389 */     GIR_EraseRootFromParent_Done,
     /* 134390 */   // Label 2550: @134390
     /* 134390 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(134439), // Rule ID 7192 //
     /* 134395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134398 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134405 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134412 */     // MIs[0] Rn
     /* 134412 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134416 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134424 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
     /* 134427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134431 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134437 */     GIR_RootConstrainSelectedInstOperands,
     /* 134438 */     // GIR_Coverage, 7192,
     /* 134438 */     GIR_EraseRootFromParent_Done,
     /* 134439 */   // Label 2551: @134439
     /* 134439 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(134488), // Rule ID 7193 //
     /* 134444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134447 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134454 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134461 */     // MIs[0] Rn
     /* 134461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134473 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
     /* 134476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134482 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134486 */     GIR_RootConstrainSelectedInstOperands,
     /* 134487 */     // GIR_Coverage, 7193,
     /* 134487 */     GIR_EraseRootFromParent_Done,
     /* 134488 */   // Label 2552: @134488
     /* 134488 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(134537), // Rule ID 7194 //
     /* 134493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134496 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134503 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134510 */     // MIs[0] Rn
     /* 134510 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134522 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
     /* 134525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134529 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134531 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134535 */     GIR_RootConstrainSelectedInstOperands,
     /* 134536 */     // GIR_Coverage, 7194,
     /* 134536 */     GIR_EraseRootFromParent_Done,
     /* 134537 */   // Label 2553: @134537
     /* 134537 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(134586), // Rule ID 7195 //
     /* 134542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134545 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134552 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134559 */     // MIs[0] Rn
     /* 134559 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134563 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134571 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 134574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134584 */     GIR_RootConstrainSelectedInstOperands,
     /* 134585 */     // GIR_Coverage, 7195,
     /* 134585 */     GIR_EraseRootFromParent_Done,
     /* 134586 */   // Label 2554: @134586
     /* 134586 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(134635), // Rule ID 7196 //
     /* 134591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134594 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134601 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134608 */     // MIs[0] Rn
     /* 134608 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134620 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 134623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134627 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134633 */     GIR_RootConstrainSelectedInstOperands,
     /* 134634 */     // GIR_Coverage, 7196,
     /* 134634 */     GIR_EraseRootFromParent_Done,
     /* 134635 */   // Label 2555: @134635
     /* 134635 */   GIM_Reject,
     /* 134636 */ // Label 2540: @134636
     /* 134636 */ GIM_Reject,
     /* 134637 */ // Label 2538: @134637
     /* 134637 */ GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(134863),
     /* 134642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 134645 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 134652 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(134694), // Rule ID 7177 //
     /* 134657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134660 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134667 */     // MIs[0] Rn
     /* 134667 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134679 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
     /* 134682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134688 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134692 */     GIR_RootConstrainSelectedInstOperands,
     /* 134693 */     // GIR_Coverage, 7177,
     /* 134693 */     GIR_EraseRootFromParent_Done,
     /* 134694 */   // Label 2557: @134694
     /* 134694 */   GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(134736), // Rule ID 7178 //
     /* 134699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134702 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134709 */     // MIs[0] Rn
     /* 134709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134721 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
     /* 134724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134734 */     GIR_RootConstrainSelectedInstOperands,
     /* 134735 */     // GIR_Coverage, 7178,
     /* 134735 */     GIR_EraseRootFromParent_Done,
     /* 134736 */   // Label 2558: @134736
     /* 134736 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(134778), // Rule ID 7179 //
     /* 134741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134744 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 134747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134751 */     // MIs[0] Rn
     /* 134751 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134763 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
     /* 134766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134770 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134776 */     GIR_RootConstrainSelectedInstOperands,
     /* 134777 */     // GIR_Coverage, 7179,
     /* 134777 */     GIR_EraseRootFromParent_Done,
     /* 134778 */   // Label 2559: @134778
     /* 134778 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(134820), // Rule ID 7180 //
     /* 134783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134786 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 134789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134793 */     // MIs[0] Rn
     /* 134793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134805 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 134808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134818 */     GIR_RootConstrainSelectedInstOperands,
     /* 134819 */     // GIR_Coverage, 7180,
     /* 134819 */     GIR_EraseRootFromParent_Done,
     /* 134820 */   // Label 2560: @134820
     /* 134820 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(134862), // Rule ID 7181 //
     /* 134825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134828 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 134831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134835 */     // MIs[0] Rn
     /* 134835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 134847 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 134850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134860 */     GIR_RootConstrainSelectedInstOperands,
     /* 134861 */     // GIR_Coverage, 7181,
     /* 134861 */     GIR_EraseRootFromParent_Done,
     /* 134862 */   // Label 2561: @134862
     /* 134862 */   GIM_Reject,
     /* 134863 */ // Label 2556: @134863
     /* 134863 */ GIM_Reject,
     /* 134864 */ // Label 2539: @134864
     /* 134864 */ GIM_Reject,
     /* 134865 */ // Label 28: @134865
     /* 134865 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2564*/ GIMT_Encode4(135856),
     /* 134876 */ /*GILLT_s32*//*Label 2562*/ GIMT_Encode4(134884),
     /* 134880 */ /*GILLT_s64*//*Label 2563*/ GIMT_Encode4(135629),
     /* 134884 */ // Label 2562: @134884
     /* 134884 */ GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(135628),
     /* 134889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 134892 */   GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(134941), // Rule ID 7202 //
     /* 134897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134900 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134907 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 134910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134914 */     // MIs[0] Rn
     /* 134914 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134926 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
     /* 134929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134935 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134939 */     GIR_RootConstrainSelectedInstOperands,
     /* 134940 */     // GIR_Coverage, 7202,
     /* 134940 */     GIR_EraseRootFromParent_Done,
     /* 134941 */   // Label 2566: @134941
     /* 134941 */   GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(134990), // Rule ID 7203 //
     /* 134946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134949 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 134956 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 134959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134963 */     // MIs[0] Rn
     /* 134963 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 134975 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 134975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
     /* 134978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 134980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 134982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134984 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 134988 */     GIR_RootConstrainSelectedInstOperands,
     /* 134989 */     // GIR_Coverage, 7203,
     /* 134989 */     GIR_EraseRootFromParent_Done,
     /* 134990 */   // Label 2567: @134990
     /* 134990 */   GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(135039), // Rule ID 7204 //
     /* 134995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 134998 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135005 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135012 */     // MIs[0] Rn
     /* 135012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135024 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
     /* 135027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135031 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135037 */     GIR_RootConstrainSelectedInstOperands,
     /* 135038 */     // GIR_Coverage, 7204,
     /* 135038 */     GIR_EraseRootFromParent_Done,
     /* 135039 */   // Label 2568: @135039
     /* 135039 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(135088), // Rule ID 7205 //
     /* 135044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135047 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135054 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135061 */     // MIs[0] Rn
     /* 135061 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135073 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 135076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135080 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135086 */     GIR_RootConstrainSelectedInstOperands,
     /* 135087 */     // GIR_Coverage, 7205,
     /* 135087 */     GIR_EraseRootFromParent_Done,
     /* 135088 */   // Label 2569: @135088
     /* 135088 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(135137), // Rule ID 7206 //
     /* 135093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135096 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135103 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135110 */     // MIs[0] Rn
     /* 135110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135122 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 135125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135131 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135135 */     GIR_RootConstrainSelectedInstOperands,
     /* 135136 */     // GIR_Coverage, 7206,
     /* 135136 */     GIR_EraseRootFromParent_Done,
     /* 135137 */   // Label 2570: @135137
     /* 135137 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(135186), // Rule ID 7207 //
     /* 135142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135145 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135152 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135159 */     // MIs[0] Rn
     /* 135159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135171 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
     /* 135174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135184 */     GIR_RootConstrainSelectedInstOperands,
     /* 135185 */     // GIR_Coverage, 7207,
     /* 135185 */     GIR_EraseRootFromParent_Done,
     /* 135186 */   // Label 2571: @135186
     /* 135186 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(135235), // Rule ID 7208 //
     /* 135191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135194 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135201 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135208 */     // MIs[0] Rn
     /* 135208 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135220 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
     /* 135223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135229 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135233 */     GIR_RootConstrainSelectedInstOperands,
     /* 135234 */     // GIR_Coverage, 7208,
     /* 135234 */     GIR_EraseRootFromParent_Done,
     /* 135235 */   // Label 2572: @135235
     /* 135235 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(135284), // Rule ID 7209 //
     /* 135240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135243 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135250 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135257 */     // MIs[0] Rn
     /* 135257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135269 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
     /* 135272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135276 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135278 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135282 */     GIR_RootConstrainSelectedInstOperands,
     /* 135283 */     // GIR_Coverage, 7209,
     /* 135283 */     GIR_EraseRootFromParent_Done,
     /* 135284 */   // Label 2573: @135284
     /* 135284 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(135333), // Rule ID 7210 //
     /* 135289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135292 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135299 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135306 */     // MIs[0] Rn
     /* 135306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135318 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 135321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135331 */     GIR_RootConstrainSelectedInstOperands,
     /* 135332 */     // GIR_Coverage, 7210,
     /* 135332 */     GIR_EraseRootFromParent_Done,
     /* 135333 */   // Label 2574: @135333
     /* 135333 */   GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(135382), // Rule ID 7211 //
     /* 135338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135341 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135348 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135355 */     // MIs[0] Rn
     /* 135355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135367 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 135370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135380 */     GIR_RootConstrainSelectedInstOperands,
     /* 135381 */     // GIR_Coverage, 7211,
     /* 135381 */     GIR_EraseRootFromParent_Done,
     /* 135382 */   // Label 2575: @135382
     /* 135382 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(135431), // Rule ID 7212 //
     /* 135387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135390 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135397 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135404 */     // MIs[0] Rn
     /* 135404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135416 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
     /* 135419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135423 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135425 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135429 */     GIR_RootConstrainSelectedInstOperands,
     /* 135430 */     // GIR_Coverage, 7212,
     /* 135430 */     GIR_EraseRootFromParent_Done,
     /* 135431 */   // Label 2576: @135431
     /* 135431 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(135480), // Rule ID 7213 //
     /* 135436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135439 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135446 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135453 */     // MIs[0] Rn
     /* 135453 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135465 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
     /* 135468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135472 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135474 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135478 */     GIR_RootConstrainSelectedInstOperands,
     /* 135479 */     // GIR_Coverage, 7213,
     /* 135479 */     GIR_EraseRootFromParent_Done,
     /* 135480 */   // Label 2577: @135480
     /* 135480 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(135529), // Rule ID 7214 //
     /* 135485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135488 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135495 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135502 */     // MIs[0] Rn
     /* 135502 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135514 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
     /* 135517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135521 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135527 */     GIR_RootConstrainSelectedInstOperands,
     /* 135528 */     // GIR_Coverage, 7214,
     /* 135528 */     GIR_EraseRootFromParent_Done,
     /* 135529 */   // Label 2578: @135529
     /* 135529 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(135578), // Rule ID 7215 //
     /* 135534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135537 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135544 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135551 */     // MIs[0] Rn
     /* 135551 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135555 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135563 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 135566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135570 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135576 */     GIR_RootConstrainSelectedInstOperands,
     /* 135577 */     // GIR_Coverage, 7215,
     /* 135577 */     GIR_EraseRootFromParent_Done,
     /* 135578 */   // Label 2579: @135578
     /* 135578 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(135627), // Rule ID 7216 //
     /* 135583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135586 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135593 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135600 */     // MIs[0] Rn
     /* 135600 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135612 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 135615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135619 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135621 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135625 */     GIR_RootConstrainSelectedInstOperands,
     /* 135626 */     // GIR_Coverage, 7216,
     /* 135626 */     GIR_EraseRootFromParent_Done,
     /* 135627 */   // Label 2580: @135627
     /* 135627 */   GIM_Reject,
     /* 135628 */ // Label 2565: @135628
     /* 135628 */ GIM_Reject,
     /* 135629 */ // Label 2563: @135629
     /* 135629 */ GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(135855),
     /* 135634 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 135637 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 135644 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(135686), // Rule ID 7197 //
     /* 135649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135652 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135659 */     // MIs[0] Rn
     /* 135659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135671 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
     /* 135674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135684 */     GIR_RootConstrainSelectedInstOperands,
     /* 135685 */     // GIR_Coverage, 7197,
     /* 135685 */     GIR_EraseRootFromParent_Done,
     /* 135686 */   // Label 2582: @135686
     /* 135686 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(135728), // Rule ID 7198 //
     /* 135691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135694 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135701 */     // MIs[0] Rn
     /* 135701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135713 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
     /* 135716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135726 */     GIR_RootConstrainSelectedInstOperands,
     /* 135727 */     // GIR_Coverage, 7198,
     /* 135727 */     GIR_EraseRootFromParent_Done,
     /* 135728 */   // Label 2583: @135728
     /* 135728 */   GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(135770), // Rule ID 7199 //
     /* 135733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135736 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135743 */     // MIs[0] Rn
     /* 135743 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135755 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
     /* 135758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135762 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135768 */     GIR_RootConstrainSelectedInstOperands,
     /* 135769 */     // GIR_Coverage, 7199,
     /* 135769 */     GIR_EraseRootFromParent_Done,
     /* 135770 */   // Label 2584: @135770
     /* 135770 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(135812), // Rule ID 7200 //
     /* 135775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135778 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 135781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135785 */     // MIs[0] Rn
     /* 135785 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135797 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 135800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135810 */     GIR_RootConstrainSelectedInstOperands,
     /* 135811 */     // GIR_Coverage, 7200,
     /* 135811 */     GIR_EraseRootFromParent_Done,
     /* 135812 */   // Label 2585: @135812
     /* 135812 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(135854), // Rule ID 7201 //
     /* 135817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135820 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 135823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135827 */     // MIs[0] Rn
     /* 135827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 135839 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 135842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135846 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135852 */     GIR_RootConstrainSelectedInstOperands,
     /* 135853 */     // GIR_Coverage, 7201,
     /* 135853 */     GIR_EraseRootFromParent_Done,
     /* 135854 */   // Label 2586: @135854
     /* 135854 */   GIM_Reject,
     /* 135855 */ // Label 2581: @135855
     /* 135855 */ GIM_Reject,
     /* 135856 */ // Label 2564: @135856
     /* 135856 */ GIM_Reject,
     /* 135857 */ // Label 29: @135857
     /* 135857 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2589*/ GIMT_Encode4(136848),
     /* 135868 */ /*GILLT_s32*//*Label 2587*/ GIMT_Encode4(135876),
     /* 135872 */ /*GILLT_s64*//*Label 2588*/ GIMT_Encode4(136621),
     /* 135876 */ // Label 2587: @135876
     /* 135876 */ GIM_Try, /*On fail goto*//*Label 2590*/ GIMT_Encode4(136620),
     /* 135881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 135884 */   GIM_Try, /*On fail goto*//*Label 2591*/ GIMT_Encode4(135933), // Rule ID 7222 //
     /* 135889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135892 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135899 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 135902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135906 */     // MIs[0] Rn
     /* 135906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135918 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
     /* 135921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135931 */     GIR_RootConstrainSelectedInstOperands,
     /* 135932 */     // GIR_Coverage, 7222,
     /* 135932 */     GIR_EraseRootFromParent_Done,
     /* 135933 */   // Label 2591: @135933
     /* 135933 */   GIM_Try, /*On fail goto*//*Label 2592*/ GIMT_Encode4(135982), // Rule ID 7223 //
     /* 135938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135941 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135948 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 135951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135955 */     // MIs[0] Rn
     /* 135955 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135959 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135967 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 135967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
     /* 135970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 135972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 135974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135976 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135980 */     GIR_RootConstrainSelectedInstOperands,
     /* 135981 */     // GIR_Coverage, 7223,
     /* 135981 */     GIR_EraseRootFromParent_Done,
     /* 135982 */   // Label 2592: @135982
     /* 135982 */   GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(136031), // Rule ID 7224 //
     /* 135987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 135990 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135997 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136004 */     // MIs[0] Rn
     /* 136004 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136016 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
     /* 136019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136023 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136025 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136029 */     GIR_RootConstrainSelectedInstOperands,
     /* 136030 */     // GIR_Coverage, 7224,
     /* 136030 */     GIR_EraseRootFromParent_Done,
     /* 136031 */   // Label 2593: @136031
     /* 136031 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(136080), // Rule ID 7225 //
     /* 136036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136039 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136046 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136053 */     // MIs[0] Rn
     /* 136053 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136065 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 136068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136078 */     GIR_RootConstrainSelectedInstOperands,
     /* 136079 */     // GIR_Coverage, 7225,
     /* 136079 */     GIR_EraseRootFromParent_Done,
     /* 136080 */   // Label 2594: @136080
     /* 136080 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(136129), // Rule ID 7226 //
     /* 136085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136088 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136095 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136102 */     // MIs[0] Rn
     /* 136102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136114 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 136117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136127 */     GIR_RootConstrainSelectedInstOperands,
     /* 136128 */     // GIR_Coverage, 7226,
     /* 136128 */     GIR_EraseRootFromParent_Done,
     /* 136129 */   // Label 2595: @136129
     /* 136129 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(136178), // Rule ID 7227 //
     /* 136134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136137 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136144 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136151 */     // MIs[0] Rn
     /* 136151 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136155 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136163 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
     /* 136166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136168 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136172 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136176 */     GIR_RootConstrainSelectedInstOperands,
     /* 136177 */     // GIR_Coverage, 7227,
     /* 136177 */     GIR_EraseRootFromParent_Done,
     /* 136178 */   // Label 2596: @136178
     /* 136178 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(136227), // Rule ID 7228 //
     /* 136183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136186 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136193 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136200 */     // MIs[0] Rn
     /* 136200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136204 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136212 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
     /* 136215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136219 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136225 */     GIR_RootConstrainSelectedInstOperands,
     /* 136226 */     // GIR_Coverage, 7228,
     /* 136226 */     GIR_EraseRootFromParent_Done,
     /* 136227 */   // Label 2597: @136227
     /* 136227 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(136276), // Rule ID 7229 //
     /* 136232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136235 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136242 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136249 */     // MIs[0] Rn
     /* 136249 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136261 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
     /* 136264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136274 */     GIR_RootConstrainSelectedInstOperands,
     /* 136275 */     // GIR_Coverage, 7229,
     /* 136275 */     GIR_EraseRootFromParent_Done,
     /* 136276 */   // Label 2598: @136276
     /* 136276 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(136325), // Rule ID 7230 //
     /* 136281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136284 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136291 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136298 */     // MIs[0] Rn
     /* 136298 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136302 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136310 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 136313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136317 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136323 */     GIR_RootConstrainSelectedInstOperands,
     /* 136324 */     // GIR_Coverage, 7230,
     /* 136324 */     GIR_EraseRootFromParent_Done,
     /* 136325 */   // Label 2599: @136325
     /* 136325 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(136374), // Rule ID 7231 //
     /* 136330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136333 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136340 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136347 */     // MIs[0] Rn
     /* 136347 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136359 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 136362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136372 */     GIR_RootConstrainSelectedInstOperands,
     /* 136373 */     // GIR_Coverage, 7231,
     /* 136373 */     GIR_EraseRootFromParent_Done,
     /* 136374 */   // Label 2600: @136374
     /* 136374 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(136423), // Rule ID 7232 //
     /* 136379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136382 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136389 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136396 */     // MIs[0] Rn
     /* 136396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136408 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
     /* 136411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136415 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136417 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136421 */     GIR_RootConstrainSelectedInstOperands,
     /* 136422 */     // GIR_Coverage, 7232,
     /* 136422 */     GIR_EraseRootFromParent_Done,
     /* 136423 */   // Label 2601: @136423
     /* 136423 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(136472), // Rule ID 7233 //
     /* 136428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136431 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136438 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136445 */     // MIs[0] Rn
     /* 136445 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136457 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
     /* 136460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136464 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136466 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136470 */     GIR_RootConstrainSelectedInstOperands,
     /* 136471 */     // GIR_Coverage, 7233,
     /* 136471 */     GIR_EraseRootFromParent_Done,
     /* 136472 */   // Label 2602: @136472
     /* 136472 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(136521), // Rule ID 7234 //
     /* 136477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136480 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136487 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136494 */     // MIs[0] Rn
     /* 136494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136506 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
     /* 136509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136515 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136519 */     GIR_RootConstrainSelectedInstOperands,
     /* 136520 */     // GIR_Coverage, 7234,
     /* 136520 */     GIR_EraseRootFromParent_Done,
     /* 136521 */   // Label 2603: @136521
     /* 136521 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(136570), // Rule ID 7235 //
     /* 136526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136529 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136536 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136543 */     // MIs[0] Rn
     /* 136543 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136555 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 136558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136568 */     GIR_RootConstrainSelectedInstOperands,
     /* 136569 */     // GIR_Coverage, 7235,
     /* 136569 */     GIR_EraseRootFromParent_Done,
     /* 136570 */   // Label 2604: @136570
     /* 136570 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(136619), // Rule ID 7236 //
     /* 136575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136578 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136585 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136592 */     // MIs[0] Rn
     /* 136592 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136604 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 136607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136611 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136613 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136617 */     GIR_RootConstrainSelectedInstOperands,
     /* 136618 */     // GIR_Coverage, 7236,
     /* 136618 */     GIR_EraseRootFromParent_Done,
     /* 136619 */   // Label 2605: @136619
     /* 136619 */   GIM_Reject,
     /* 136620 */ // Label 2590: @136620
     /* 136620 */ GIM_Reject,
     /* 136621 */ // Label 2588: @136621
     /* 136621 */ GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(136847),
     /* 136626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 136629 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 136636 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(136678), // Rule ID 7217 //
     /* 136641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136644 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136651 */     // MIs[0] Rn
     /* 136651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136663 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
     /* 136666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136676 */     GIR_RootConstrainSelectedInstOperands,
     /* 136677 */     // GIR_Coverage, 7217,
     /* 136677 */     GIR_EraseRootFromParent_Done,
     /* 136678 */   // Label 2607: @136678
     /* 136678 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(136720), // Rule ID 7218 //
     /* 136683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136686 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136693 */     // MIs[0] Rn
     /* 136693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136705 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
     /* 136708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136718 */     GIR_RootConstrainSelectedInstOperands,
     /* 136719 */     // GIR_Coverage, 7218,
     /* 136719 */     GIR_EraseRootFromParent_Done,
     /* 136720 */   // Label 2608: @136720
     /* 136720 */   GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(136762), // Rule ID 7219 //
     /* 136725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136728 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136735 */     // MIs[0] Rn
     /* 136735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136747 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
     /* 136750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136754 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136760 */     GIR_RootConstrainSelectedInstOperands,
     /* 136761 */     // GIR_Coverage, 7219,
     /* 136761 */     GIR_EraseRootFromParent_Done,
     /* 136762 */   // Label 2609: @136762
     /* 136762 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(136804), // Rule ID 7220 //
     /* 136767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136770 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 136773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136777 */     // MIs[0] Rn
     /* 136777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136789 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 136792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136802 */     GIR_RootConstrainSelectedInstOperands,
     /* 136803 */     // GIR_Coverage, 7220,
     /* 136803 */     GIR_EraseRootFromParent_Done,
     /* 136804 */   // Label 2610: @136804
     /* 136804 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(136846), // Rule ID 7221 //
     /* 136809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136812 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 136815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136819 */     // MIs[0] Rn
     /* 136819 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 136831 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 136834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136844 */     GIR_RootConstrainSelectedInstOperands,
     /* 136845 */     // GIR_Coverage, 7221,
     /* 136845 */     GIR_EraseRootFromParent_Done,
     /* 136846 */   // Label 2611: @136846
     /* 136846 */   GIM_Reject,
     /* 136847 */ // Label 2606: @136847
     /* 136847 */ GIM_Reject,
     /* 136848 */ // Label 2589: @136848
     /* 136848 */ GIM_Reject,
     /* 136849 */ // Label 30: @136849
     /* 136849 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2614*/ GIMT_Encode4(137840),
     /* 136860 */ /*GILLT_s32*//*Label 2612*/ GIMT_Encode4(136868),
     /* 136864 */ /*GILLT_s64*//*Label 2613*/ GIMT_Encode4(137613),
     /* 136868 */ // Label 2612: @136868
     /* 136868 */ GIM_Try, /*On fail goto*//*Label 2615*/ GIMT_Encode4(137612),
     /* 136873 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 136876 */   GIM_Try, /*On fail goto*//*Label 2616*/ GIMT_Encode4(136925), // Rule ID 7242 //
     /* 136881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136884 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136891 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 136894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136898 */     // MIs[0] Rn
     /* 136898 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136910 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
     /* 136913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136919 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136923 */     GIR_RootConstrainSelectedInstOperands,
     /* 136924 */     // GIR_Coverage, 7242,
     /* 136924 */     GIR_EraseRootFromParent_Done,
     /* 136925 */   // Label 2616: @136925
     /* 136925 */   GIM_Try, /*On fail goto*//*Label 2617*/ GIMT_Encode4(136974), // Rule ID 7243 //
     /* 136930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136933 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136940 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 136943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136947 */     // MIs[0] Rn
     /* 136947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 136951 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 136955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136959 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 136959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
     /* 136962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 136964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 136966 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 136968 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136972 */     GIR_RootConstrainSelectedInstOperands,
     /* 136973 */     // GIR_Coverage, 7243,
     /* 136973 */     GIR_EraseRootFromParent_Done,
     /* 136974 */   // Label 2617: @136974
     /* 136974 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(137023), // Rule ID 7244 //
     /* 136979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 136982 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136989 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136996 */     // MIs[0] Rn
     /* 136996 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137008 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
     /* 137011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137015 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137021 */     GIR_RootConstrainSelectedInstOperands,
     /* 137022 */     // GIR_Coverage, 7244,
     /* 137022 */     GIR_EraseRootFromParent_Done,
     /* 137023 */   // Label 2618: @137023
     /* 137023 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(137072), // Rule ID 7245 //
     /* 137028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137031 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137038 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137045 */     // MIs[0] Rn
     /* 137045 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137057 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 137060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137064 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137070 */     GIR_RootConstrainSelectedInstOperands,
     /* 137071 */     // GIR_Coverage, 7245,
     /* 137071 */     GIR_EraseRootFromParent_Done,
     /* 137072 */   // Label 2619: @137072
     /* 137072 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(137121), // Rule ID 7246 //
     /* 137077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137080 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137087 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137094 */     // MIs[0] Rn
     /* 137094 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137106 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 137109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137113 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137119 */     GIR_RootConstrainSelectedInstOperands,
     /* 137120 */     // GIR_Coverage, 7246,
     /* 137120 */     GIR_EraseRootFromParent_Done,
     /* 137121 */   // Label 2620: @137121
     /* 137121 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(137170), // Rule ID 7247 //
     /* 137126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137129 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137136 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137143 */     // MIs[0] Rn
     /* 137143 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137147 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137155 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
     /* 137158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137162 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137164 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137168 */     GIR_RootConstrainSelectedInstOperands,
     /* 137169 */     // GIR_Coverage, 7247,
     /* 137169 */     GIR_EraseRootFromParent_Done,
     /* 137170 */   // Label 2621: @137170
     /* 137170 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(137219), // Rule ID 7248 //
     /* 137175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137178 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137185 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137192 */     // MIs[0] Rn
     /* 137192 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137204 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
     /* 137207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137211 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137217 */     GIR_RootConstrainSelectedInstOperands,
     /* 137218 */     // GIR_Coverage, 7248,
     /* 137218 */     GIR_EraseRootFromParent_Done,
     /* 137219 */   // Label 2622: @137219
     /* 137219 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(137268), // Rule ID 7249 //
     /* 137224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137227 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137234 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137241 */     // MIs[0] Rn
     /* 137241 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137253 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
     /* 137256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137260 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137262 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137266 */     GIR_RootConstrainSelectedInstOperands,
     /* 137267 */     // GIR_Coverage, 7249,
     /* 137267 */     GIR_EraseRootFromParent_Done,
     /* 137268 */   // Label 2623: @137268
     /* 137268 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(137317), // Rule ID 7250 //
     /* 137273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137276 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137283 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137290 */     // MIs[0] Rn
     /* 137290 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137302 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 137305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137309 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137311 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137315 */     GIR_RootConstrainSelectedInstOperands,
     /* 137316 */     // GIR_Coverage, 7250,
     /* 137316 */     GIR_EraseRootFromParent_Done,
     /* 137317 */   // Label 2624: @137317
     /* 137317 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(137366), // Rule ID 7251 //
     /* 137322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137325 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137332 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137339 */     // MIs[0] Rn
     /* 137339 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137351 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 137354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137358 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137364 */     GIR_RootConstrainSelectedInstOperands,
     /* 137365 */     // GIR_Coverage, 7251,
     /* 137365 */     GIR_EraseRootFromParent_Done,
     /* 137366 */   // Label 2625: @137366
     /* 137366 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(137415), // Rule ID 7252 //
     /* 137371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137374 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137381 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137388 */     // MIs[0] Rn
     /* 137388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137400 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
     /* 137403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137407 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137413 */     GIR_RootConstrainSelectedInstOperands,
     /* 137414 */     // GIR_Coverage, 7252,
     /* 137414 */     GIR_EraseRootFromParent_Done,
     /* 137415 */   // Label 2626: @137415
     /* 137415 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(137464), // Rule ID 7253 //
     /* 137420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137423 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137430 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137437 */     // MIs[0] Rn
     /* 137437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137441 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137449 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
     /* 137452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137462 */     GIR_RootConstrainSelectedInstOperands,
     /* 137463 */     // GIR_Coverage, 7253,
     /* 137463 */     GIR_EraseRootFromParent_Done,
     /* 137464 */   // Label 2627: @137464
     /* 137464 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(137513), // Rule ID 7254 //
     /* 137469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137472 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137479 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137486 */     // MIs[0] Rn
     /* 137486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137498 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
     /* 137501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137511 */     GIR_RootConstrainSelectedInstOperands,
     /* 137512 */     // GIR_Coverage, 7254,
     /* 137512 */     GIR_EraseRootFromParent_Done,
     /* 137513 */   // Label 2628: @137513
     /* 137513 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(137562), // Rule ID 7255 //
     /* 137518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137521 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137528 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137535 */     // MIs[0] Rn
     /* 137535 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137547 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 137550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137554 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137556 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137560 */     GIR_RootConstrainSelectedInstOperands,
     /* 137561 */     // GIR_Coverage, 7255,
     /* 137561 */     GIR_EraseRootFromParent_Done,
     /* 137562 */   // Label 2629: @137562
     /* 137562 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(137611), // Rule ID 7256 //
     /* 137567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137570 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137577 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137584 */     // MIs[0] Rn
     /* 137584 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137588 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137596 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 137599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137605 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137609 */     GIR_RootConstrainSelectedInstOperands,
     /* 137610 */     // GIR_Coverage, 7256,
     /* 137610 */     GIR_EraseRootFromParent_Done,
     /* 137611 */   // Label 2630: @137611
     /* 137611 */   GIM_Reject,
     /* 137612 */ // Label 2615: @137612
     /* 137612 */ GIM_Reject,
     /* 137613 */ // Label 2613: @137613
     /* 137613 */ GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(137839),
     /* 137618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 137621 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 137628 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(137670), // Rule ID 7237 //
     /* 137633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137636 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137643 */     // MIs[0] Rn
     /* 137643 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137647 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137655 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
     /* 137658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137662 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137664 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137668 */     GIR_RootConstrainSelectedInstOperands,
     /* 137669 */     // GIR_Coverage, 7237,
     /* 137669 */     GIR_EraseRootFromParent_Done,
     /* 137670 */   // Label 2632: @137670
     /* 137670 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(137712), // Rule ID 7238 //
     /* 137675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137685 */     // MIs[0] Rn
     /* 137685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137697 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
     /* 137700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137710 */     GIR_RootConstrainSelectedInstOperands,
     /* 137711 */     // GIR_Coverage, 7238,
     /* 137711 */     GIR_EraseRootFromParent_Done,
     /* 137712 */   // Label 2633: @137712
     /* 137712 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(137754), // Rule ID 7239 //
     /* 137717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137720 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137727 */     // MIs[0] Rn
     /* 137727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137739 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
     /* 137742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137752 */     GIR_RootConstrainSelectedInstOperands,
     /* 137753 */     // GIR_Coverage, 7239,
     /* 137753 */     GIR_EraseRootFromParent_Done,
     /* 137754 */   // Label 2634: @137754
     /* 137754 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(137796), // Rule ID 7240 //
     /* 137759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137762 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 137765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137769 */     // MIs[0] Rn
     /* 137769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137781 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 137784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137794 */     GIR_RootConstrainSelectedInstOperands,
     /* 137795 */     // GIR_Coverage, 7240,
     /* 137795 */     GIR_EraseRootFromParent_Done,
     /* 137796 */   // Label 2635: @137796
     /* 137796 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(137838), // Rule ID 7241 //
     /* 137801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 137804 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 137807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137811 */     // MIs[0] Rn
     /* 137811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 137823 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 137823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 137826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137830 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137832 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137836 */     GIR_RootConstrainSelectedInstOperands,
     /* 137837 */     // GIR_Coverage, 7241,
     /* 137837 */     GIR_EraseRootFromParent_Done,
     /* 137838 */   // Label 2636: @137838
     /* 137838 */   GIM_Reject,
     /* 137839 */ // Label 2631: @137839
     /* 137839 */ GIM_Reject,
     /* 137840 */ // Label 2614: @137840
     /* 137840 */ GIM_Reject,
     /* 137841 */ // Label 31: @137841
     /* 137841 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2640*/ GIMT_Encode4(138545),
     /* 137852 */ /*GILLT_s16*//*Label 2637*/ GIMT_Encode4(137864),
     /* 137856 */ /*GILLT_s32*//*Label 2638*/ GIMT_Encode4(138091),
     /* 137860 */ /*GILLT_s64*//*Label 2639*/ GIMT_Encode4(138318),
     /* 137864 */ // Label 2637: @137864
     /* 137864 */ GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(138090),
     /* 137869 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 137872 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137879 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(137921), // Rule ID 2582 //
     /* 137884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137887 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 137890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137894 */     // MIs[0] Rn
     /* 137894 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137906 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_monotonic>>  =>  (LDFADDH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDH),
     /* 137909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137915 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137919 */     GIR_RootConstrainSelectedInstOperands,
     /* 137920 */     // GIR_Coverage, 2582,
     /* 137920 */     GIR_EraseRootFromParent_Done,
     /* 137921 */   // Label 2642: @137921
     /* 137921 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(137963), // Rule ID 2583 //
     /* 137926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137929 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 137932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137936 */     // MIs[0] Rn
     /* 137936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137948 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acquire>>  =>  (LDFADDAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAH),
     /* 137951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137955 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137957 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137961 */     GIR_RootConstrainSelectedInstOperands,
     /* 137962 */     // GIR_Coverage, 2583,
     /* 137962 */     GIR_EraseRootFromParent_Done,
     /* 137963 */   // Label 2643: @137963
     /* 137963 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(138005), // Rule ID 2584 //
     /* 137968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 137971 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137978 */     // MIs[0] Rn
     /* 137978 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 137990 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_release>>  =>  (LDFADDLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 137990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLH),
     /* 137993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 137995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 137997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 137999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138003 */     GIR_RootConstrainSelectedInstOperands,
     /* 138004 */     // GIR_Coverage, 2584,
     /* 138004 */     GIR_EraseRootFromParent_Done,
     /* 138005 */   // Label 2644: @138005
     /* 138005 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(138047), // Rule ID 2585 //
     /* 138010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138013 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138020 */     // MIs[0] Rn
     /* 138020 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138032 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acq_rel>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 138035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138039 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138045 */     GIR_RootConstrainSelectedInstOperands,
     /* 138046 */     // GIR_Coverage, 2585,
     /* 138046 */     GIR_EraseRootFromParent_Done,
     /* 138047 */   // Label 2645: @138047
     /* 138047 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(138089), // Rule ID 2586 //
     /* 138052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138055 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138062 */     // MIs[0] Rn
     /* 138062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138074 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_seq_cst>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 138077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138081 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138083 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138087 */     GIR_RootConstrainSelectedInstOperands,
     /* 138088 */     // GIR_Coverage, 2586,
     /* 138088 */     GIR_EraseRootFromParent_Done,
     /* 138089 */   // Label 2646: @138089
     /* 138089 */   GIM_Reject,
     /* 138090 */ // Label 2641: @138090
     /* 138090 */ GIM_Reject,
     /* 138091 */ // Label 2638: @138091
     /* 138091 */ GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(138317),
     /* 138096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 138099 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 138106 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(138148), // Rule ID 7332 //
     /* 138111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138114 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138121 */     // MIs[0] Rn
     /* 138121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138133 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_monotonic>>  =>  (LDFADDS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDS),
     /* 138136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138140 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138146 */     GIR_RootConstrainSelectedInstOperands,
     /* 138147 */     // GIR_Coverage, 7332,
     /* 138147 */     GIR_EraseRootFromParent_Done,
     /* 138148 */   // Label 2648: @138148
     /* 138148 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(138190), // Rule ID 7333 //
     /* 138153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138156 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138163 */     // MIs[0] Rn
     /* 138163 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138175 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acquire>>  =>  (LDFADDAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAS),
     /* 138178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138188 */     GIR_RootConstrainSelectedInstOperands,
     /* 138189 */     // GIR_Coverage, 7333,
     /* 138189 */     GIR_EraseRootFromParent_Done,
     /* 138190 */   // Label 2649: @138190
     /* 138190 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(138232), // Rule ID 7334 //
     /* 138195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138198 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138205 */     // MIs[0] Rn
     /* 138205 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138217 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_release>>  =>  (LDFADDLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLS),
     /* 138220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138230 */     GIR_RootConstrainSelectedInstOperands,
     /* 138231 */     // GIR_Coverage, 7334,
     /* 138231 */     GIR_EraseRootFromParent_Done,
     /* 138232 */   // Label 2650: @138232
     /* 138232 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(138274), // Rule ID 7335 //
     /* 138237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138240 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138247 */     // MIs[0] Rn
     /* 138247 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138259 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acq_rel>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 138262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138266 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138268 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138272 */     GIR_RootConstrainSelectedInstOperands,
     /* 138273 */     // GIR_Coverage, 7335,
     /* 138273 */     GIR_EraseRootFromParent_Done,
     /* 138274 */   // Label 2651: @138274
     /* 138274 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(138316), // Rule ID 7336 //
     /* 138279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138282 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138289 */     // MIs[0] Rn
     /* 138289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138301 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_seq_cst>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 138304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138314 */     GIR_RootConstrainSelectedInstOperands,
     /* 138315 */     // GIR_Coverage, 7336,
     /* 138315 */     GIR_EraseRootFromParent_Done,
     /* 138316 */   // Label 2652: @138316
     /* 138316 */   GIM_Reject,
     /* 138317 */ // Label 2647: @138317
     /* 138317 */ GIM_Reject,
     /* 138318 */ // Label 2639: @138318
     /* 138318 */ GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(138544),
     /* 138323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 138326 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 138333 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(138375), // Rule ID 7337 //
     /* 138338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138341 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138348 */     // MIs[0] Rn
     /* 138348 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138360 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_monotonic>>  =>  (LDFADDD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDD),
     /* 138363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138367 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138373 */     GIR_RootConstrainSelectedInstOperands,
     /* 138374 */     // GIR_Coverage, 7337,
     /* 138374 */     GIR_EraseRootFromParent_Done,
     /* 138375 */   // Label 2654: @138375
     /* 138375 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(138417), // Rule ID 7338 //
     /* 138380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138383 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138390 */     // MIs[0] Rn
     /* 138390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138402 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acquire>>  =>  (LDFADDAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAD),
     /* 138405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138411 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138415 */     GIR_RootConstrainSelectedInstOperands,
     /* 138416 */     // GIR_Coverage, 7338,
     /* 138416 */     GIR_EraseRootFromParent_Done,
     /* 138417 */   // Label 2655: @138417
     /* 138417 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(138459), // Rule ID 7339 //
     /* 138422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138425 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138432 */     // MIs[0] Rn
     /* 138432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138444 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_release>>  =>  (LDFADDLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLD),
     /* 138447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138451 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138457 */     GIR_RootConstrainSelectedInstOperands,
     /* 138458 */     // GIR_Coverage, 7339,
     /* 138458 */     GIR_EraseRootFromParent_Done,
     /* 138459 */   // Label 2656: @138459
     /* 138459 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(138501), // Rule ID 7340 //
     /* 138464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138467 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138474 */     // MIs[0] Rn
     /* 138474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138486 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acq_rel>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 138489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138493 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138499 */     GIR_RootConstrainSelectedInstOperands,
     /* 138500 */     // GIR_Coverage, 7340,
     /* 138500 */     GIR_EraseRootFromParent_Done,
     /* 138501 */   // Label 2657: @138501
     /* 138501 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(138543), // Rule ID 7341 //
     /* 138506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138509 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138516 */     // MIs[0] Rn
     /* 138516 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138528 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_seq_cst>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 138531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138541 */     GIR_RootConstrainSelectedInstOperands,
     /* 138542 */     // GIR_Coverage, 7341,
     /* 138542 */     GIR_EraseRootFromParent_Done,
     /* 138543 */   // Label 2658: @138543
     /* 138543 */   GIM_Reject,
     /* 138544 */ // Label 2653: @138544
     /* 138544 */ GIM_Reject,
     /* 138545 */ // Label 2640: @138545
     /* 138545 */ GIM_Reject,
     /* 138546 */ // Label 32: @138546
     /* 138546 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2662*/ GIMT_Encode4(139250),
     /* 138557 */ /*GILLT_s16*//*Label 2659*/ GIMT_Encode4(138569),
     /* 138561 */ /*GILLT_s32*//*Label 2660*/ GIMT_Encode4(138796),
     /* 138565 */ /*GILLT_s64*//*Label 2661*/ GIMT_Encode4(139023),
     /* 138569 */ // Label 2659: @138569
     /* 138569 */ GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(138795),
     /* 138574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 138577 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138584 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(138626), // Rule ID 7342 //
     /* 138589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138592 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138599 */     // MIs[0] Rn
     /* 138599 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138611 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_monotonic>>  =>  (LDFMAXNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMH),
     /* 138614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138618 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138624 */     GIR_RootConstrainSelectedInstOperands,
     /* 138625 */     // GIR_Coverage, 7342,
     /* 138625 */     GIR_EraseRootFromParent_Done,
     /* 138626 */   // Label 2664: @138626
     /* 138626 */   GIM_Try, /*On fail goto*//*Label 2665*/ GIMT_Encode4(138668), // Rule ID 7343 //
     /* 138631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138634 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138641 */     // MIs[0] Rn
     /* 138641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138653 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acquire>>  =>  (LDFMAXNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAH),
     /* 138656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138660 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138666 */     GIR_RootConstrainSelectedInstOperands,
     /* 138667 */     // GIR_Coverage, 7343,
     /* 138667 */     GIR_EraseRootFromParent_Done,
     /* 138668 */   // Label 2665: @138668
     /* 138668 */   GIM_Try, /*On fail goto*//*Label 2666*/ GIMT_Encode4(138710), // Rule ID 7344 //
     /* 138673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138676 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138683 */     // MIs[0] Rn
     /* 138683 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138695 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_release>>  =>  (LDFMAXNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLH),
     /* 138698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138704 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138708 */     GIR_RootConstrainSelectedInstOperands,
     /* 138709 */     // GIR_Coverage, 7344,
     /* 138709 */     GIR_EraseRootFromParent_Done,
     /* 138710 */   // Label 2666: @138710
     /* 138710 */   GIM_Try, /*On fail goto*//*Label 2667*/ GIMT_Encode4(138752), // Rule ID 7345 //
     /* 138715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138718 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138725 */     // MIs[0] Rn
     /* 138725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138737 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acq_rel>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 138740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138750 */     GIR_RootConstrainSelectedInstOperands,
     /* 138751 */     // GIR_Coverage, 7345,
     /* 138751 */     GIR_EraseRootFromParent_Done,
     /* 138752 */   // Label 2667: @138752
     /* 138752 */   GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(138794), // Rule ID 7346 //
     /* 138757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138760 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138767 */     // MIs[0] Rn
     /* 138767 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 138779 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_seq_cst>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 138782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138786 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138792 */     GIR_RootConstrainSelectedInstOperands,
     /* 138793 */     // GIR_Coverage, 7346,
     /* 138793 */     GIR_EraseRootFromParent_Done,
     /* 138794 */   // Label 2668: @138794
     /* 138794 */   GIM_Reject,
     /* 138795 */ // Label 2663: @138795
     /* 138795 */ GIM_Reject,
     /* 138796 */ // Label 2660: @138796
     /* 138796 */ GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(139022),
     /* 138801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 138804 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 138811 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(138853), // Rule ID 7347 //
     /* 138816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138819 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 138822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138826 */     // MIs[0] Rn
     /* 138826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138830 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138838 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_monotonic>>  =>  (LDFMAXNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMS),
     /* 138841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138851 */     GIR_RootConstrainSelectedInstOperands,
     /* 138852 */     // GIR_Coverage, 7347,
     /* 138852 */     GIR_EraseRootFromParent_Done,
     /* 138853 */   // Label 2670: @138853
     /* 138853 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(138895), // Rule ID 7348 //
     /* 138858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138861 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 138864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138868 */     // MIs[0] Rn
     /* 138868 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138880 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acquire>>  =>  (LDFMAXNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAS),
     /* 138883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138887 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138893 */     GIR_RootConstrainSelectedInstOperands,
     /* 138894 */     // GIR_Coverage, 7348,
     /* 138894 */     GIR_EraseRootFromParent_Done,
     /* 138895 */   // Label 2671: @138895
     /* 138895 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(138937), // Rule ID 7349 //
     /* 138900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138903 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 138906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138910 */     // MIs[0] Rn
     /* 138910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138922 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_release>>  =>  (LDFMAXNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLS),
     /* 138925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138929 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138935 */     GIR_RootConstrainSelectedInstOperands,
     /* 138936 */     // GIR_Coverage, 7349,
     /* 138936 */     GIR_EraseRootFromParent_Done,
     /* 138937 */   // Label 2672: @138937
     /* 138937 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(138979), // Rule ID 7350 //
     /* 138942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138945 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 138948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138952 */     // MIs[0] Rn
     /* 138952 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138964 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acq_rel>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 138964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 138967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 138969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 138971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138977 */     GIR_RootConstrainSelectedInstOperands,
     /* 138978 */     // GIR_Coverage, 7350,
     /* 138978 */     GIR_EraseRootFromParent_Done,
     /* 138979 */   // Label 2673: @138979
     /* 138979 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(139021), // Rule ID 7351 //
     /* 138984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 138987 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 138990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 138994 */     // MIs[0] Rn
     /* 138994 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139006 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_seq_cst>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 139009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139015 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139019 */     GIR_RootConstrainSelectedInstOperands,
     /* 139020 */     // GIR_Coverage, 7351,
     /* 139020 */     GIR_EraseRootFromParent_Done,
     /* 139021 */   // Label 2674: @139021
     /* 139021 */   GIM_Reject,
     /* 139022 */ // Label 2669: @139022
     /* 139022 */ GIM_Reject,
     /* 139023 */ // Label 2661: @139023
     /* 139023 */ GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(139249),
     /* 139028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139031 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139038 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(139080), // Rule ID 7352 //
     /* 139043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139046 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139053 */     // MIs[0] Rn
     /* 139053 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139065 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_monotonic>>  =>  (LDFMAXNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMD),
     /* 139068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139078 */     GIR_RootConstrainSelectedInstOperands,
     /* 139079 */     // GIR_Coverage, 7352,
     /* 139079 */     GIR_EraseRootFromParent_Done,
     /* 139080 */   // Label 2676: @139080
     /* 139080 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(139122), // Rule ID 7353 //
     /* 139085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139088 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139095 */     // MIs[0] Rn
     /* 139095 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139107 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acquire>>  =>  (LDFMAXNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAD),
     /* 139110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139116 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139120 */     GIR_RootConstrainSelectedInstOperands,
     /* 139121 */     // GIR_Coverage, 7353,
     /* 139121 */     GIR_EraseRootFromParent_Done,
     /* 139122 */   // Label 2677: @139122
     /* 139122 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(139164), // Rule ID 7354 //
     /* 139127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139130 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139137 */     // MIs[0] Rn
     /* 139137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139149 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_release>>  =>  (LDFMAXNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLD),
     /* 139152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139162 */     GIR_RootConstrainSelectedInstOperands,
     /* 139163 */     // GIR_Coverage, 7354,
     /* 139163 */     GIR_EraseRootFromParent_Done,
     /* 139164 */   // Label 2678: @139164
     /* 139164 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(139206), // Rule ID 7355 //
     /* 139169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139172 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139179 */     // MIs[0] Rn
     /* 139179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139191 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acq_rel>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 139194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139204 */     GIR_RootConstrainSelectedInstOperands,
     /* 139205 */     // GIR_Coverage, 7355,
     /* 139205 */     GIR_EraseRootFromParent_Done,
     /* 139206 */   // Label 2679: @139206
     /* 139206 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(139248), // Rule ID 7356 //
     /* 139211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139214 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139221 */     // MIs[0] Rn
     /* 139221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139233 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_seq_cst>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 139236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139246 */     GIR_RootConstrainSelectedInstOperands,
     /* 139247 */     // GIR_Coverage, 7356,
     /* 139247 */     GIR_EraseRootFromParent_Done,
     /* 139248 */   // Label 2680: @139248
     /* 139248 */   GIM_Reject,
     /* 139249 */ // Label 2675: @139249
     /* 139249 */ GIM_Reject,
     /* 139250 */ // Label 2662: @139250
     /* 139250 */ GIM_Reject,
     /* 139251 */ // Label 33: @139251
     /* 139251 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2684*/ GIMT_Encode4(139955),
     /* 139262 */ /*GILLT_s16*//*Label 2681*/ GIMT_Encode4(139274),
     /* 139266 */ /*GILLT_s32*//*Label 2682*/ GIMT_Encode4(139501),
     /* 139270 */ /*GILLT_s64*//*Label 2683*/ GIMT_Encode4(139728),
     /* 139274 */ // Label 2681: @139274
     /* 139274 */ GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(139500),
     /* 139279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 139282 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 139289 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(139331), // Rule ID 7357 //
     /* 139294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139297 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139304 */     // MIs[0] Rn
     /* 139304 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139308 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139316 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_monotonic>>  =>  (LDFMINNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMH),
     /* 139319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139323 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139329 */     GIR_RootConstrainSelectedInstOperands,
     /* 139330 */     // GIR_Coverage, 7357,
     /* 139330 */     GIR_EraseRootFromParent_Done,
     /* 139331 */   // Label 2686: @139331
     /* 139331 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(139373), // Rule ID 7358 //
     /* 139336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139339 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139346 */     // MIs[0] Rn
     /* 139346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139358 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acquire>>  =>  (LDFMINNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAH),
     /* 139361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139367 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139371 */     GIR_RootConstrainSelectedInstOperands,
     /* 139372 */     // GIR_Coverage, 7358,
     /* 139372 */     GIR_EraseRootFromParent_Done,
     /* 139373 */   // Label 2687: @139373
     /* 139373 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(139415), // Rule ID 7359 //
     /* 139378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139381 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139388 */     // MIs[0] Rn
     /* 139388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139400 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_release>>  =>  (LDFMINNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLH),
     /* 139403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139407 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139409 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139413 */     GIR_RootConstrainSelectedInstOperands,
     /* 139414 */     // GIR_Coverage, 7359,
     /* 139414 */     GIR_EraseRootFromParent_Done,
     /* 139415 */   // Label 2688: @139415
     /* 139415 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(139457), // Rule ID 7360 //
     /* 139420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139423 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139430 */     // MIs[0] Rn
     /* 139430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139442 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acq_rel>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 139445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139449 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139455 */     GIR_RootConstrainSelectedInstOperands,
     /* 139456 */     // GIR_Coverage, 7360,
     /* 139456 */     GIR_EraseRootFromParent_Done,
     /* 139457 */   // Label 2689: @139457
     /* 139457 */   GIM_Try, /*On fail goto*//*Label 2690*/ GIMT_Encode4(139499), // Rule ID 7361 //
     /* 139462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139472 */     // MIs[0] Rn
     /* 139472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 139484 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_seq_cst>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 139487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139497 */     GIR_RootConstrainSelectedInstOperands,
     /* 139498 */     // GIR_Coverage, 7361,
     /* 139498 */     GIR_EraseRootFromParent_Done,
     /* 139499 */   // Label 2690: @139499
     /* 139499 */   GIM_Reject,
     /* 139500 */ // Label 2685: @139500
     /* 139500 */ GIM_Reject,
     /* 139501 */ // Label 2682: @139501
     /* 139501 */ GIM_Try, /*On fail goto*//*Label 2691*/ GIMT_Encode4(139727),
     /* 139506 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 139509 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139516 */   GIM_Try, /*On fail goto*//*Label 2692*/ GIMT_Encode4(139558), // Rule ID 7362 //
     /* 139521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139524 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139531 */     // MIs[0] Rn
     /* 139531 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139543 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_monotonic>>  =>  (LDFMINNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMS),
     /* 139546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139550 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139552 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139556 */     GIR_RootConstrainSelectedInstOperands,
     /* 139557 */     // GIR_Coverage, 7362,
     /* 139557 */     GIR_EraseRootFromParent_Done,
     /* 139558 */   // Label 2692: @139558
     /* 139558 */   GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(139600), // Rule ID 7363 //
     /* 139563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139566 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139573 */     // MIs[0] Rn
     /* 139573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139585 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acquire>>  =>  (LDFMINNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAS),
     /* 139588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139598 */     GIR_RootConstrainSelectedInstOperands,
     /* 139599 */     // GIR_Coverage, 7363,
     /* 139599 */     GIR_EraseRootFromParent_Done,
     /* 139600 */   // Label 2693: @139600
     /* 139600 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(139642), // Rule ID 7364 //
     /* 139605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139608 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139615 */     // MIs[0] Rn
     /* 139615 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139627 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_release>>  =>  (LDFMINNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLS),
     /* 139630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139640 */     GIR_RootConstrainSelectedInstOperands,
     /* 139641 */     // GIR_Coverage, 7364,
     /* 139641 */     GIR_EraseRootFromParent_Done,
     /* 139642 */   // Label 2694: @139642
     /* 139642 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(139684), // Rule ID 7365 //
     /* 139647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139650 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139657 */     // MIs[0] Rn
     /* 139657 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139669 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acq_rel>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 139672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139682 */     GIR_RootConstrainSelectedInstOperands,
     /* 139683 */     // GIR_Coverage, 7365,
     /* 139683 */     GIR_EraseRootFromParent_Done,
     /* 139684 */   // Label 2695: @139684
     /* 139684 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(139726), // Rule ID 7366 //
     /* 139689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139692 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139699 */     // MIs[0] Rn
     /* 139699 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 139711 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_seq_cst>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 139714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139720 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139724 */     GIR_RootConstrainSelectedInstOperands,
     /* 139725 */     // GIR_Coverage, 7366,
     /* 139725 */     GIR_EraseRootFromParent_Done,
     /* 139726 */   // Label 2696: @139726
     /* 139726 */   GIM_Reject,
     /* 139727 */ // Label 2691: @139727
     /* 139727 */ GIM_Reject,
     /* 139728 */ // Label 2683: @139728
     /* 139728 */ GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(139954),
     /* 139733 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 139736 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139743 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(139785), // Rule ID 7367 //
     /* 139748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139751 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 139754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139758 */     // MIs[0] Rn
     /* 139758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139770 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_monotonic>>  =>  (LDFMINNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMD),
     /* 139773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139783 */     GIR_RootConstrainSelectedInstOperands,
     /* 139784 */     // GIR_Coverage, 7367,
     /* 139784 */     GIR_EraseRootFromParent_Done,
     /* 139785 */   // Label 2698: @139785
     /* 139785 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(139827), // Rule ID 7368 //
     /* 139790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139793 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 139796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139800 */     // MIs[0] Rn
     /* 139800 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139804 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139812 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acquire>>  =>  (LDFMINNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAD),
     /* 139815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139825 */     GIR_RootConstrainSelectedInstOperands,
     /* 139826 */     // GIR_Coverage, 7368,
     /* 139826 */     GIR_EraseRootFromParent_Done,
     /* 139827 */   // Label 2699: @139827
     /* 139827 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(139869), // Rule ID 7369 //
     /* 139832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139835 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139842 */     // MIs[0] Rn
     /* 139842 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139850 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139854 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_release>>  =>  (LDFMINNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLD),
     /* 139857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139867 */     GIR_RootConstrainSelectedInstOperands,
     /* 139868 */     // GIR_Coverage, 7369,
     /* 139868 */     GIR_EraseRootFromParent_Done,
     /* 139869 */   // Label 2700: @139869
     /* 139869 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(139911), // Rule ID 7370 //
     /* 139874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139877 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 139880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139884 */     // MIs[0] Rn
     /* 139884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139888 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139896 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acq_rel>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 139899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139905 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139909 */     GIR_RootConstrainSelectedInstOperands,
     /* 139910 */     // GIR_Coverage, 7370,
     /* 139910 */     GIR_EraseRootFromParent_Done,
     /* 139911 */   // Label 2701: @139911
     /* 139911 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(139953), // Rule ID 7371 //
     /* 139916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 139919 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 139922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139926 */     // MIs[0] Rn
     /* 139926 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 139930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139938 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_seq_cst>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 139938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 139941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 139943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 139945 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 139947 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139951 */     GIR_RootConstrainSelectedInstOperands,
     /* 139952 */     // GIR_Coverage, 7371,
     /* 139952 */     GIR_EraseRootFromParent_Done,
     /* 139953 */   // Label 2702: @139953
     /* 139953 */   GIM_Reject,
     /* 139954 */ // Label 2697: @139954
     /* 139954 */ GIM_Reject,
     /* 139955 */ // Label 2684: @139955
     /* 139955 */ GIM_Reject,
     /* 139956 */ // Label 34: @139956
     /* 139956 */ GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(139983), // Rule ID 6989 //
     /* 139961 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 139964 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /* 139968 */   // MIs[0] Operand 1
     /* 139968 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 139971 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
     /* 139971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 139974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 139977 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139981 */   GIR_RootConstrainSelectedInstOperands,
     /* 139982 */   // GIR_Coverage, 6989,
     /* 139982 */   GIR_EraseRootFromParent_Done,
     /* 139983 */ // Label 2703: @139983
     /* 139983 */ GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(140006), // Rule ID 6990 //
     /* 139988 */   // MIs[0] Operand 0
     /* 139988 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 139991 */   // MIs[0] Operand 1
     /* 139991 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 139994 */   // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
     /* 139994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 139997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 140000 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140004 */   GIR_RootConstrainSelectedInstOperands,
     /* 140005 */   // GIR_Coverage, 6990,
     /* 140005 */   GIR_EraseRootFromParent_Done,
     /* 140006 */ // Label 2704: @140006
     /* 140006 */ GIM_Reject,
     /* 140007 */ // Label 35: @140007
     /* 140007 */ GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(152534),
     /* 140012 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 140015 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(140106), // Rule ID 6468 //
     /* 140020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 140023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 140028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 140031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 140034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 140046 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 140049 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 140054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 140058 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 140062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140074 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 140074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 140077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 140081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140086 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 140090 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 140094 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
     /* 140099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140101 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140104 */     GIR_RootConstrainSelectedInstOperands,
     /* 140105 */     // GIR_Coverage, 6468,
     /* 140105 */     GIR_EraseRootFromParent_Done,
     /* 140106 */   // Label 2706: @140106
     /* 140106 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(140197), // Rule ID 6469 //
     /* 140111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 140114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 140119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 140122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 140125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 140137 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 140140 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 140145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 140149 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 140153 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140165 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 140165 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 140168 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 140172 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140177 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 140181 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 140185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 140187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
     /* 140190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140195 */     GIR_RootConstrainSelectedInstOperands,
     /* 140196 */     // GIR_Coverage, 6469,
     /* 140196 */     GIR_EraseRootFromParent_Done,
     /* 140197 */   // Label 2707: @140197
     /* 140197 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(140258), // Rule ID 4884 //
     /* 140202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 140207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 140210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 140213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 140221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 140225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 140229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140234 */     // MIs[1] Operand 2
     /* 140234 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 140245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140247 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
     /* 140247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 140250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 140256 */     GIR_RootConstrainSelectedInstOperands,
     /* 140257 */     // GIR_Coverage, 4884,
     /* 140257 */     GIR_EraseRootFromParent_Done,
     /* 140258 */   // Label 2708: @140258
     /* 140258 */   GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(140298), // Rule ID 2649 //
     /* 140263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 140266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /* 140271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140278 */     // MIs[0] pattern
     /* 140278 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 140281 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 140286 */     // (intrinsic_wo_chain:{ *:[i64] } 1318:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 140286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
     /* 140289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140291 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 140293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 140296 */     GIR_RootConstrainSelectedInstOperands,
     /* 140297 */     // GIR_Coverage, 2649,
     /* 140297 */     GIR_EraseRootFromParent_Done,
     /* 140298 */   // Label 2709: @140298
     /* 140298 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(140338), // Rule ID 9874 //
     /* 140303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 140306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /* 140311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140318 */     // MIs[0] pattern
     /* 140318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 140321 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 140326 */     // (intrinsic_wo_chain:{ *:[i64] } 1320:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 140326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
     /* 140329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140331 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 140333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 140336 */     GIR_RootConstrainSelectedInstOperands,
     /* 140337 */     // GIR_Coverage, 9874,
     /* 140337 */     GIR_EraseRootFromParent_Done,
     /* 140338 */   // Label 2710: @140338
     /* 140338 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(140378), // Rule ID 9877 //
     /* 140343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 140346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /* 140351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140358 */     // MIs[0] pattern
     /* 140358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 140361 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 140366 */     // (intrinsic_wo_chain:{ *:[i64] } 1326:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 140366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
     /* 140369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140371 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 140373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 140376 */     GIR_RootConstrainSelectedInstOperands,
     /* 140377 */     // GIR_Coverage, 9877,
     /* 140377 */     GIR_EraseRootFromParent_Done,
     /* 140378 */   // Label 2711: @140378
     /* 140378 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(140418), // Rule ID 9880 //
     /* 140383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 140386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /* 140391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140398 */     // MIs[0] pattern
     /* 140398 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 140401 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 140406 */     // (intrinsic_wo_chain:{ *:[i64] } 1319:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 140406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
     /* 140409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140411 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 140413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 140416 */     GIR_RootConstrainSelectedInstOperands,
     /* 140417 */     // GIR_Coverage, 9880,
     /* 140417 */     GIR_EraseRootFromParent_Done,
     /* 140418 */   // Label 2712: @140418
     /* 140418 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(140457), // Rule ID 66 //
     /* 140423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
     /* 140426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
     /* 140431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140445 */     // (intrinsic_wo_chain:{ *:[i32] } 546:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
     /* 140448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140452 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 140455 */     GIR_RootConstrainSelectedInstOperands,
     /* 140456 */     // GIR_Coverage, 66,
     /* 140456 */     GIR_EraseRootFromParent_Done,
     /* 140457 */   // Label 2713: @140457
     /* 140457 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(140493), // Rule ID 346 //
     /* 140462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140484 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 140484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 140487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140491 */     GIR_RootConstrainSelectedInstOperands,
     /* 140492 */     // GIR_Coverage, 346,
     /* 140492 */     GIR_EraseRootFromParent_Done,
     /* 140493 */   // Label 2714: @140493
     /* 140493 */   GIM_Try, /*On fail goto*//*Label 2715*/ GIMT_Encode4(140529), // Rule ID 347 //
     /* 140498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140520 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 140523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140527 */     GIR_RootConstrainSelectedInstOperands,
     /* 140528 */     // GIR_Coverage, 347,
     /* 140528 */     GIR_EraseRootFromParent_Done,
     /* 140529 */   // Label 2715: @140529
     /* 140529 */   GIM_Try, /*On fail goto*//*Label 2716*/ GIMT_Encode4(140565), // Rule ID 348 //
     /* 140534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140556 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 140559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140563 */     GIR_RootConstrainSelectedInstOperands,
     /* 140564 */     // GIR_Coverage, 348,
     /* 140564 */     GIR_EraseRootFromParent_Done,
     /* 140565 */   // Label 2716: @140565
     /* 140565 */   GIM_Try, /*On fail goto*//*Label 2717*/ GIMT_Encode4(140601), // Rule ID 349 //
     /* 140570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140592 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 140595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140599 */     GIR_RootConstrainSelectedInstOperands,
     /* 140600 */     // GIR_Coverage, 349,
     /* 140600 */     GIR_EraseRootFromParent_Done,
     /* 140601 */   // Label 2717: @140601
     /* 140601 */   GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(140637), // Rule ID 350 //
     /* 140606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140628 */     // (intrinsic_wo_chain:{ *:[i32] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 140631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140635 */     GIR_RootConstrainSelectedInstOperands,
     /* 140636 */     // GIR_Coverage, 350,
     /* 140636 */     GIR_EraseRootFromParent_Done,
     /* 140637 */   // Label 2718: @140637
     /* 140637 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(140673), // Rule ID 351 //
     /* 140642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 140650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140664 */     // (intrinsic_wo_chain:{ *:[i64] } 583:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 140664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 140667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140671 */     GIR_RootConstrainSelectedInstOperands,
     /* 140672 */     // GIR_Coverage, 351,
     /* 140672 */     GIR_EraseRootFromParent_Done,
     /* 140673 */   // Label 2719: @140673
     /* 140673 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(140709), // Rule ID 352 //
     /* 140678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140700 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 140700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
     /* 140703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140707 */     GIR_RootConstrainSelectedInstOperands,
     /* 140708 */     // GIR_Coverage, 352,
     /* 140708 */     GIR_EraseRootFromParent_Done,
     /* 140709 */   // Label 2720: @140709
     /* 140709 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(140745), // Rule ID 353 //
     /* 140714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140736 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
     /* 140739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140743 */     GIR_RootConstrainSelectedInstOperands,
     /* 140744 */     // GIR_Coverage, 353,
     /* 140744 */     GIR_EraseRootFromParent_Done,
     /* 140745 */   // Label 2721: @140745
     /* 140745 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(140781), // Rule ID 354 //
     /* 140750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140772 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 140775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140779 */     GIR_RootConstrainSelectedInstOperands,
     /* 140780 */     // GIR_Coverage, 354,
     /* 140780 */     GIR_EraseRootFromParent_Done,
     /* 140781 */   // Label 2722: @140781
     /* 140781 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(140817), // Rule ID 355 //
     /* 140786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140808 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 140808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 140811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140815 */     GIR_RootConstrainSelectedInstOperands,
     /* 140816 */     // GIR_Coverage, 355,
     /* 140816 */     GIR_EraseRootFromParent_Done,
     /* 140817 */   // Label 2723: @140817
     /* 140817 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(140853), // Rule ID 356 //
     /* 140822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140844 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 140844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 140847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140851 */     GIR_RootConstrainSelectedInstOperands,
     /* 140852 */     // GIR_Coverage, 356,
     /* 140852 */     GIR_EraseRootFromParent_Done,
     /* 140853 */   // Label 2724: @140853
     /* 140853 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(140889), // Rule ID 357 //
     /* 140858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 140866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 140872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140880 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 140880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 140883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140887 */     GIR_RootConstrainSelectedInstOperands,
     /* 140888 */     // GIR_Coverage, 357,
     /* 140888 */     GIR_EraseRootFromParent_Done,
     /* 140889 */   // Label 2725: @140889
     /* 140889 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(140925), // Rule ID 358 //
     /* 140894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140916 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 140916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
     /* 140919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140923 */     GIR_RootConstrainSelectedInstOperands,
     /* 140924 */     // GIR_Coverage, 358,
     /* 140924 */     GIR_EraseRootFromParent_Done,
     /* 140925 */   // Label 2726: @140925
     /* 140925 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(140961), // Rule ID 359 //
     /* 140930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 140933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 140941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 140944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 140952 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 140952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
     /* 140955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140959 */     GIR_RootConstrainSelectedInstOperands,
     /* 140960 */     // GIR_Coverage, 359,
     /* 140960 */     GIR_EraseRootFromParent_Done,
     /* 140961 */   // Label 2727: @140961
     /* 140961 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(140997), // Rule ID 360 //
     /* 140966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 140974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 140977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 140980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 140988 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 140988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 140991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 140993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 140995 */     GIR_RootConstrainSelectedInstOperands,
     /* 140996 */     // GIR_Coverage, 360,
     /* 140996 */     GIR_EraseRootFromParent_Done,
     /* 140997 */   // Label 2728: @140997
     /* 140997 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(141033), // Rule ID 361 //
     /* 141002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 141010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141024 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 141024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 141027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141031 */     GIR_RootConstrainSelectedInstOperands,
     /* 141032 */     // GIR_Coverage, 361,
     /* 141032 */     GIR_EraseRootFromParent_Done,
     /* 141033 */   // Label 2729: @141033
     /* 141033 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(141069), // Rule ID 362 //
     /* 141038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 141046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141060 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 141060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 141063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141067 */     GIR_RootConstrainSelectedInstOperands,
     /* 141068 */     // GIR_Coverage, 362,
     /* 141068 */     GIR_EraseRootFromParent_Done,
     /* 141069 */   // Label 2730: @141069
     /* 141069 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(141105), // Rule ID 363 //
     /* 141074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 141082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141096 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 141099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141103 */     GIR_RootConstrainSelectedInstOperands,
     /* 141104 */     // GIR_Coverage, 363,
     /* 141104 */     GIR_EraseRootFromParent_Done,
     /* 141105 */   // Label 2731: @141105
     /* 141105 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(141141), // Rule ID 364 //
     /* 141110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 141118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141132 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 141132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
     /* 141135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141139 */     GIR_RootConstrainSelectedInstOperands,
     /* 141140 */     // GIR_Coverage, 364,
     /* 141140 */     GIR_EraseRootFromParent_Done,
     /* 141141 */   // Label 2732: @141141
     /* 141141 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(141177), // Rule ID 365 //
     /* 141146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 141154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141168 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 141168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
     /* 141171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141175 */     GIR_RootConstrainSelectedInstOperands,
     /* 141176 */     // GIR_Coverage, 365,
     /* 141176 */     GIR_EraseRootFromParent_Done,
     /* 141177 */   // Label 2733: @141177
     /* 141177 */   GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(141213), // Rule ID 366 //
     /* 141182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 141190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141204 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 141204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 141207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141211 */     GIR_RootConstrainSelectedInstOperands,
     /* 141212 */     // GIR_Coverage, 366,
     /* 141212 */     GIR_EraseRootFromParent_Done,
     /* 141213 */   // Label 2734: @141213
     /* 141213 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(141249), // Rule ID 367 //
     /* 141218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 141226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141240 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 141240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 141243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141247 */     GIR_RootConstrainSelectedInstOperands,
     /* 141248 */     // GIR_Coverage, 367,
     /* 141248 */     GIR_EraseRootFromParent_Done,
     /* 141249 */   // Label 2735: @141249
     /* 141249 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(141285), // Rule ID 368 //
     /* 141254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 141262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141276 */     // (intrinsic_wo_chain:{ *:[i32] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 141276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 141279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141283 */     GIR_RootConstrainSelectedInstOperands,
     /* 141284 */     // GIR_Coverage, 368,
     /* 141284 */     GIR_EraseRootFromParent_Done,
     /* 141285 */   // Label 2736: @141285
     /* 141285 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(141321), // Rule ID 369 //
     /* 141290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 141298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141312 */     // (intrinsic_wo_chain:{ *:[i64] } 586:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 141315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141319 */     GIR_RootConstrainSelectedInstOperands,
     /* 141320 */     // GIR_Coverage, 369,
     /* 141320 */     GIR_EraseRootFromParent_Done,
     /* 141321 */   // Label 2737: @141321
     /* 141321 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(141357), // Rule ID 370 //
     /* 141326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 141334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141348 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 141348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
     /* 141351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141355 */     GIR_RootConstrainSelectedInstOperands,
     /* 141356 */     // GIR_Coverage, 370,
     /* 141356 */     GIR_EraseRootFromParent_Done,
     /* 141357 */   // Label 2738: @141357
     /* 141357 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(141393), // Rule ID 371 //
     /* 141362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 141370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141384 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 141384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
     /* 141387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141391 */     GIR_RootConstrainSelectedInstOperands,
     /* 141392 */     // GIR_Coverage, 371,
     /* 141392 */     GIR_EraseRootFromParent_Done,
     /* 141393 */   // Label 2739: @141393
     /* 141393 */   GIM_Try, /*On fail goto*//*Label 2740*/ GIMT_Encode4(141429), // Rule ID 372 //
     /* 141398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 141406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141420 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 141420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
     /* 141423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141427 */     GIR_RootConstrainSelectedInstOperands,
     /* 141428 */     // GIR_Coverage, 372,
     /* 141428 */     GIR_EraseRootFromParent_Done,
     /* 141429 */   // Label 2740: @141429
     /* 141429 */   GIM_Try, /*On fail goto*//*Label 2741*/ GIMT_Encode4(141465), // Rule ID 373 //
     /* 141434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 141442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141456 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 141456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
     /* 141459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141463 */     GIR_RootConstrainSelectedInstOperands,
     /* 141464 */     // GIR_Coverage, 373,
     /* 141464 */     GIR_EraseRootFromParent_Done,
     /* 141465 */   // Label 2741: @141465
     /* 141465 */   GIM_Try, /*On fail goto*//*Label 2742*/ GIMT_Encode4(141501), // Rule ID 374 //
     /* 141470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 141478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141492 */     // (intrinsic_wo_chain:{ *:[i32] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 141492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
     /* 141495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141499 */     GIR_RootConstrainSelectedInstOperands,
     /* 141500 */     // GIR_Coverage, 374,
     /* 141500 */     GIR_EraseRootFromParent_Done,
     /* 141501 */   // Label 2742: @141501
     /* 141501 */   GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(141537), // Rule ID 375 //
     /* 141506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 141514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141528 */     // (intrinsic_wo_chain:{ *:[i64] } 587:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
     /* 141531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141535 */     GIR_RootConstrainSelectedInstOperands,
     /* 141536 */     // GIR_Coverage, 375,
     /* 141536 */     GIR_EraseRootFromParent_Done,
     /* 141537 */   // Label 2743: @141537
     /* 141537 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(141573), // Rule ID 376 //
     /* 141542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141564 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 141564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
     /* 141567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141571 */     GIR_RootConstrainSelectedInstOperands,
     /* 141572 */     // GIR_Coverage, 376,
     /* 141572 */     GIR_EraseRootFromParent_Done,
     /* 141573 */   // Label 2744: @141573
     /* 141573 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(141609), // Rule ID 377 //
     /* 141578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141600 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 141600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
     /* 141603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141607 */     GIR_RootConstrainSelectedInstOperands,
     /* 141608 */     // GIR_Coverage, 377,
     /* 141608 */     GIR_EraseRootFromParent_Done,
     /* 141609 */   // Label 2745: @141609
     /* 141609 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(141645), // Rule ID 378 //
     /* 141614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141636 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 141636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
     /* 141639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141643 */     GIR_RootConstrainSelectedInstOperands,
     /* 141644 */     // GIR_Coverage, 378,
     /* 141644 */     GIR_EraseRootFromParent_Done,
     /* 141645 */   // Label 2746: @141645
     /* 141645 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(141681), // Rule ID 379 //
     /* 141650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141672 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 141672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
     /* 141675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141679 */     GIR_RootConstrainSelectedInstOperands,
     /* 141680 */     // GIR_Coverage, 379,
     /* 141680 */     GIR_EraseRootFromParent_Done,
     /* 141681 */   // Label 2747: @141681
     /* 141681 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(141717), // Rule ID 380 //
     /* 141686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141708 */     // (intrinsic_wo_chain:{ *:[i32] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 141708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
     /* 141711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141715 */     GIR_RootConstrainSelectedInstOperands,
     /* 141716 */     // GIR_Coverage, 380,
     /* 141716 */     GIR_EraseRootFromParent_Done,
     /* 141717 */   // Label 2748: @141717
     /* 141717 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(141753), // Rule ID 381 //
     /* 141722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 141730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141744 */     // (intrinsic_wo_chain:{ *:[i64] } 588:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
     /* 141747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141751 */     GIR_RootConstrainSelectedInstOperands,
     /* 141752 */     // GIR_Coverage, 381,
     /* 141752 */     GIR_EraseRootFromParent_Done,
     /* 141753 */   // Label 2749: @141753
     /* 141753 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(141789), // Rule ID 382 //
     /* 141758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141780 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 141780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
     /* 141783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141787 */     GIR_RootConstrainSelectedInstOperands,
     /* 141788 */     // GIR_Coverage, 382,
     /* 141788 */     GIR_EraseRootFromParent_Done,
     /* 141789 */   // Label 2750: @141789
     /* 141789 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(141825), // Rule ID 383 //
     /* 141794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141816 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 141816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
     /* 141819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141823 */     GIR_RootConstrainSelectedInstOperands,
     /* 141824 */     // GIR_Coverage, 383,
     /* 141824 */     GIR_EraseRootFromParent_Done,
     /* 141825 */   // Label 2751: @141825
     /* 141825 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(141861), // Rule ID 384 //
     /* 141830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141852 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 141852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 141855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141859 */     GIR_RootConstrainSelectedInstOperands,
     /* 141860 */     // GIR_Coverage, 384,
     /* 141860 */     GIR_EraseRootFromParent_Done,
     /* 141861 */   // Label 2752: @141861
     /* 141861 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(141897), // Rule ID 385 //
     /* 141866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 141880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 141888 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 141888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 141891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141895 */     GIR_RootConstrainSelectedInstOperands,
     /* 141896 */     // GIR_Coverage, 385,
     /* 141896 */     GIR_EraseRootFromParent_Done,
     /* 141897 */   // Label 2753: @141897
     /* 141897 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(141933), // Rule ID 386 //
     /* 141902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141924 */     // (intrinsic_wo_chain:{ *:[i32] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 141924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 141927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141931 */     GIR_RootConstrainSelectedInstOperands,
     /* 141932 */     // GIR_Coverage, 386,
     /* 141932 */     GIR_EraseRootFromParent_Done,
     /* 141933 */   // Label 2754: @141933
     /* 141933 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(141969), // Rule ID 387 //
     /* 141938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 141946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 141949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 141952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141960 */     // (intrinsic_wo_chain:{ *:[i64] } 589:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 141960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 141963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 141965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 141967 */     GIR_RootConstrainSelectedInstOperands,
     /* 141968 */     // GIR_Coverage, 387,
     /* 141968 */     GIR_EraseRootFromParent_Done,
     /* 141969 */   // Label 2755: @141969
     /* 141969 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(142005), // Rule ID 388 //
     /* 141974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 141977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 141982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 141985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 141988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 141992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 141996 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 141996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
     /* 141999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142003 */     GIR_RootConstrainSelectedInstOperands,
     /* 142004 */     // GIR_Coverage, 388,
     /* 142004 */     GIR_EraseRootFromParent_Done,
     /* 142005 */   // Label 2756: @142005
     /* 142005 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(142041), // Rule ID 389 //
     /* 142010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 142013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 142018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 142024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 142032 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 142032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
     /* 142035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142039 */     GIR_RootConstrainSelectedInstOperands,
     /* 142040 */     // GIR_Coverage, 389,
     /* 142040 */     GIR_EraseRootFromParent_Done,
     /* 142041 */   // Label 2757: @142041
     /* 142041 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(142077), // Rule ID 390 //
     /* 142046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 142054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142068 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 142068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 142071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142075 */     GIR_RootConstrainSelectedInstOperands,
     /* 142076 */     // GIR_Coverage, 390,
     /* 142076 */     GIR_EraseRootFromParent_Done,
     /* 142077 */   // Label 2758: @142077
     /* 142077 */   GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(142113), // Rule ID 391 //
     /* 142082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 142090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142104 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 142104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 142107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142111 */     GIR_RootConstrainSelectedInstOperands,
     /* 142112 */     // GIR_Coverage, 391,
     /* 142112 */     GIR_EraseRootFromParent_Done,
     /* 142113 */   // Label 2759: @142113
     /* 142113 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(142149), // Rule ID 392 //
     /* 142118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 142126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 142136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142140 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 142140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 142143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142147 */     GIR_RootConstrainSelectedInstOperands,
     /* 142148 */     // GIR_Coverage, 392,
     /* 142148 */     GIR_EraseRootFromParent_Done,
     /* 142149 */   // Label 2760: @142149
     /* 142149 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(142185), // Rule ID 393 //
     /* 142154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 142157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 142162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 142172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142176 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 142176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 142179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142183 */     GIR_RootConstrainSelectedInstOperands,
     /* 142184 */     // GIR_Coverage, 393,
     /* 142184 */     GIR_EraseRootFromParent_Done,
     /* 142185 */   // Label 2761: @142185
     /* 142185 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(142221), // Rule ID 575 //
     /* 142190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 142193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 142198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142212 */     // (intrinsic_wo_chain:{ *:[f32] } 548:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 142212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
     /* 142215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142219 */     GIR_RootConstrainSelectedInstOperands,
     /* 142220 */     // GIR_Coverage, 575,
     /* 142220 */     GIR_EraseRootFromParent_Done,
     /* 142221 */   // Label 2762: @142221
     /* 142221 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(142257), // Rule ID 576 //
     /* 142226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 142229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 142234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142248 */     // (intrinsic_wo_chain:{ *:[f64] } 548:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 142248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 142251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142255 */     GIR_RootConstrainSelectedInstOperands,
     /* 142256 */     // GIR_Coverage, 576,
     /* 142256 */     GIR_EraseRootFromParent_Done,
     /* 142257 */   // Label 2763: @142257
     /* 142257 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(142293), // Rule ID 577 //
     /* 142262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 142265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 142270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142284 */     // (intrinsic_wo_chain:{ *:[f32] } 550:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 142284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
     /* 142287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142291 */     GIR_RootConstrainSelectedInstOperands,
     /* 142292 */     // GIR_Coverage, 577,
     /* 142292 */     GIR_EraseRootFromParent_Done,
     /* 142293 */   // Label 2764: @142293
     /* 142293 */   GIM_Try, /*On fail goto*//*Label 2765*/ GIMT_Encode4(142329), // Rule ID 578 //
     /* 142298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 142301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 142306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142320 */     // (intrinsic_wo_chain:{ *:[f64] } 550:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 142320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 142323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142327 */     GIR_RootConstrainSelectedInstOperands,
     /* 142328 */     // GIR_Coverage, 578,
     /* 142328 */     GIR_EraseRootFromParent_Done,
     /* 142329 */   // Label 2765: @142329
     /* 142329 */   GIM_Try, /*On fail goto*//*Label 2766*/ GIMT_Encode4(142365), // Rule ID 579 //
     /* 142334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 142337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 142342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142356 */     // (intrinsic_wo_chain:{ *:[f32] } 547:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 142356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
     /* 142359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142363 */     GIR_RootConstrainSelectedInstOperands,
     /* 142364 */     // GIR_Coverage, 579,
     /* 142364 */     GIR_EraseRootFromParent_Done,
     /* 142365 */   // Label 2766: @142365
     /* 142365 */   GIM_Try, /*On fail goto*//*Label 2767*/ GIMT_Encode4(142401), // Rule ID 580 //
     /* 142370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 142373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 142378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142392 */     // (intrinsic_wo_chain:{ *:[f64] } 547:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 142392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 142395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142399 */     GIR_RootConstrainSelectedInstOperands,
     /* 142400 */     // GIR_Coverage, 580,
     /* 142400 */     GIR_EraseRootFromParent_Done,
     /* 142401 */   // Label 2767: @142401
     /* 142401 */   GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(142437), // Rule ID 581 //
     /* 142406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 142409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 142414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 142417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 142420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 142428 */     // (intrinsic_wo_chain:{ *:[f32] } 549:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 142428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
     /* 142431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142435 */     GIR_RootConstrainSelectedInstOperands,
     /* 142436 */     // GIR_Coverage, 581,
     /* 142436 */     GIR_EraseRootFromParent_Done,
     /* 142437 */   // Label 2768: @142437
     /* 142437 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(142473), // Rule ID 582 //
     /* 142442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 142445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 142450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 142453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 142456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142464 */     // (intrinsic_wo_chain:{ *:[f64] } 549:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 142464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 142467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142471 */     GIR_RootConstrainSelectedInstOperands,
     /* 142472 */     // GIR_Coverage, 582,
     /* 142472 */     GIR_EraseRootFromParent_Done,
     /* 142473 */   // Label 2769: @142473
     /* 142473 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(142509), // Rule ID 710 //
     /* 142478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 142489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 142492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142500 */     // (intrinsic_wo_chain:{ *:[v8i8] } 575:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 142500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
     /* 142503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142507 */     GIR_RootConstrainSelectedInstOperands,
     /* 142508 */     // GIR_Coverage, 710,
     /* 142508 */     GIR_EraseRootFromParent_Done,
     /* 142509 */   // Label 2770: @142509
     /* 142509 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(142545), // Rule ID 711 //
     /* 142514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 142525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 142528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142536 */     // (intrinsic_wo_chain:{ *:[v16i8] } 575:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 142536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
     /* 142539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142543 */     GIR_RootConstrainSelectedInstOperands,
     /* 142544 */     // GIR_Coverage, 711,
     /* 142544 */     GIR_EraseRootFromParent_Done,
     /* 142545 */   // Label 2771: @142545
     /* 142545 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(142581), // Rule ID 712 //
     /* 142550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142572 */     // (intrinsic_wo_chain:{ *:[v4i16] } 575:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 142572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
     /* 142575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142579 */     GIR_RootConstrainSelectedInstOperands,
     /* 142580 */     // GIR_Coverage, 712,
     /* 142580 */     GIR_EraseRootFromParent_Done,
     /* 142581 */   // Label 2772: @142581
     /* 142581 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(142617), // Rule ID 713 //
     /* 142586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142608 */     // (intrinsic_wo_chain:{ *:[v8i16] } 575:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 142608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
     /* 142611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142615 */     GIR_RootConstrainSelectedInstOperands,
     /* 142616 */     // GIR_Coverage, 713,
     /* 142616 */     GIR_EraseRootFromParent_Done,
     /* 142617 */   // Label 2773: @142617
     /* 142617 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(142653), // Rule ID 714 //
     /* 142622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142644 */     // (intrinsic_wo_chain:{ *:[v2i32] } 575:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 142644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
     /* 142647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142651 */     GIR_RootConstrainSelectedInstOperands,
     /* 142652 */     // GIR_Coverage, 714,
     /* 142652 */     GIR_EraseRootFromParent_Done,
     /* 142653 */   // Label 2774: @142653
     /* 142653 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(142689), // Rule ID 715 //
     /* 142658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 142666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142680 */     // (intrinsic_wo_chain:{ *:[v4i32] } 575:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 142680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
     /* 142683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142687 */     GIR_RootConstrainSelectedInstOperands,
     /* 142688 */     // GIR_Coverage, 715,
     /* 142688 */     GIR_EraseRootFromParent_Done,
     /* 142689 */   // Label 2775: @142689
     /* 142689 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(142725), // Rule ID 796 //
     /* 142694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142716 */     // (intrinsic_wo_chain:{ *:[v4i16] } 583:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
     /* 142719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142723 */     GIR_RootConstrainSelectedInstOperands,
     /* 142724 */     // GIR_Coverage, 796,
     /* 142724 */     GIR_EraseRootFromParent_Done,
     /* 142725 */   // Label 2776: @142725
     /* 142725 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(142761), // Rule ID 797 //
     /* 142730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142752 */     // (intrinsic_wo_chain:{ *:[v8i16] } 583:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
     /* 142755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142759 */     GIR_RootConstrainSelectedInstOperands,
     /* 142760 */     // GIR_Coverage, 797,
     /* 142760 */     GIR_EraseRootFromParent_Done,
     /* 142761 */   // Label 2777: @142761
     /* 142761 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(142797), // Rule ID 798 //
     /* 142766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142788 */     // (intrinsic_wo_chain:{ *:[v2i32] } 583:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 142788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
     /* 142791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142795 */     GIR_RootConstrainSelectedInstOperands,
     /* 142796 */     // GIR_Coverage, 798,
     /* 142796 */     GIR_EraseRootFromParent_Done,
     /* 142797 */   // Label 2778: @142797
     /* 142797 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(142833), // Rule ID 799 //
     /* 142802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142824 */     // (intrinsic_wo_chain:{ *:[v4i32] } 583:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 142824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
     /* 142827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142831 */     GIR_RootConstrainSelectedInstOperands,
     /* 142832 */     // GIR_Coverage, 799,
     /* 142832 */     GIR_EraseRootFromParent_Done,
     /* 142833 */   // Label 2779: @142833
     /* 142833 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(142869), // Rule ID 800 //
     /* 142838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 142846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 142849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 142852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142860 */     // (intrinsic_wo_chain:{ *:[v2i64] } 583:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 142860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
     /* 142863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142867 */     GIR_RootConstrainSelectedInstOperands,
     /* 142868 */     // GIR_Coverage, 800,
     /* 142868 */     GIR_EraseRootFromParent_Done,
     /* 142869 */   // Label 2780: @142869
     /* 142869 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(142905), // Rule ID 801 //
     /* 142874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 142885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 142888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142896 */     // (intrinsic_wo_chain:{ *:[v4i16] } 584:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 142896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
     /* 142899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142903 */     GIR_RootConstrainSelectedInstOperands,
     /* 142904 */     // GIR_Coverage, 801,
     /* 142904 */     GIR_EraseRootFromParent_Done,
     /* 142905 */   // Label 2781: @142905
     /* 142905 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(142941), // Rule ID 802 //
     /* 142910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 142913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 142921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 142924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142932 */     // (intrinsic_wo_chain:{ *:[v8i16] } 584:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 142932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
     /* 142935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142939 */     GIR_RootConstrainSelectedInstOperands,
     /* 142940 */     // GIR_Coverage, 802,
     /* 142940 */     GIR_EraseRootFromParent_Done,
     /* 142941 */   // Label 2782: @142941
     /* 142941 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(142977), // Rule ID 803 //
     /* 142946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 142957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 142960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142968 */     // (intrinsic_wo_chain:{ *:[v2i32] } 584:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 142968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
     /* 142971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 142973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 142975 */     GIR_RootConstrainSelectedInstOperands,
     /* 142976 */     // GIR_Coverage, 803,
     /* 142976 */     GIR_EraseRootFromParent_Done,
     /* 142977 */   // Label 2783: @142977
     /* 142977 */   GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(143013), // Rule ID 804 //
     /* 142982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 142985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 142990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 142993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 142996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143004 */     // (intrinsic_wo_chain:{ *:[v4i32] } 584:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
     /* 143007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143011 */     GIR_RootConstrainSelectedInstOperands,
     /* 143012 */     // GIR_Coverage, 804,
     /* 143012 */     GIR_EraseRootFromParent_Done,
     /* 143013 */   // Label 2784: @143013
     /* 143013 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(143049), // Rule ID 805 //
     /* 143018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 143026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143040 */     // (intrinsic_wo_chain:{ *:[v2i64] } 584:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
     /* 143043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143047 */     GIR_RootConstrainSelectedInstOperands,
     /* 143048 */     // GIR_Coverage, 805,
     /* 143048 */     GIR_EraseRootFromParent_Done,
     /* 143049 */   // Label 2785: @143049
     /* 143049 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(143085), // Rule ID 806 //
     /* 143054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 143062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143076 */     // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
     /* 143079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143083 */     GIR_RootConstrainSelectedInstOperands,
     /* 143084 */     // GIR_Coverage, 806,
     /* 143084 */     GIR_EraseRootFromParent_Done,
     /* 143085 */   // Label 2786: @143085
     /* 143085 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(143121), // Rule ID 807 //
     /* 143090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 143098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143112 */     // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 143112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
     /* 143115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143119 */     GIR_RootConstrainSelectedInstOperands,
     /* 143120 */     // GIR_Coverage, 807,
     /* 143120 */     GIR_EraseRootFromParent_Done,
     /* 143121 */   // Label 2787: @143121
     /* 143121 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(143157), // Rule ID 808 //
     /* 143126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 143134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143148 */     // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
     /* 143151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143155 */     GIR_RootConstrainSelectedInstOperands,
     /* 143156 */     // GIR_Coverage, 808,
     /* 143156 */     GIR_EraseRootFromParent_Done,
     /* 143157 */   // Label 2788: @143157
     /* 143157 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(143193), // Rule ID 809 //
     /* 143162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 143170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143184 */     // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
     /* 143187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143191 */     GIR_RootConstrainSelectedInstOperands,
     /* 143192 */     // GIR_Coverage, 809,
     /* 143192 */     GIR_EraseRootFromParent_Done,
     /* 143193 */   // Label 2789: @143193
     /* 143193 */   GIM_Try, /*On fail goto*//*Label 2790*/ GIMT_Encode4(143229), // Rule ID 810 //
     /* 143198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 143206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143220 */     // (intrinsic_wo_chain:{ *:[v2i64] } 585:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
     /* 143223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143227 */     GIR_RootConstrainSelectedInstOperands,
     /* 143228 */     // GIR_Coverage, 810,
     /* 143228 */     GIR_EraseRootFromParent_Done,
     /* 143229 */   // Label 2790: @143229
     /* 143229 */   GIM_Try, /*On fail goto*//*Label 2791*/ GIMT_Encode4(143265), // Rule ID 811 //
     /* 143234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143256 */     // (intrinsic_wo_chain:{ *:[v4i16] } 586:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
     /* 143259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143263 */     GIR_RootConstrainSelectedInstOperands,
     /* 143264 */     // GIR_Coverage, 811,
     /* 143264 */     GIR_EraseRootFromParent_Done,
     /* 143265 */   // Label 2791: @143265
     /* 143265 */   GIM_Try, /*On fail goto*//*Label 2792*/ GIMT_Encode4(143301), // Rule ID 812 //
     /* 143270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143292 */     // (intrinsic_wo_chain:{ *:[v8i16] } 586:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 143292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
     /* 143295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143299 */     GIR_RootConstrainSelectedInstOperands,
     /* 143300 */     // GIR_Coverage, 812,
     /* 143300 */     GIR_EraseRootFromParent_Done,
     /* 143301 */   // Label 2792: @143301
     /* 143301 */   GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(143337), // Rule ID 813 //
     /* 143306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143328 */     // (intrinsic_wo_chain:{ *:[v2i32] } 586:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
     /* 143331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143335 */     GIR_RootConstrainSelectedInstOperands,
     /* 143336 */     // GIR_Coverage, 813,
     /* 143336 */     GIR_EraseRootFromParent_Done,
     /* 143337 */   // Label 2793: @143337
     /* 143337 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(143373), // Rule ID 814 //
     /* 143342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143364 */     // (intrinsic_wo_chain:{ *:[v4i32] } 586:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
     /* 143367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143371 */     GIR_RootConstrainSelectedInstOperands,
     /* 143372 */     // GIR_Coverage, 814,
     /* 143372 */     GIR_EraseRootFromParent_Done,
     /* 143373 */   // Label 2794: @143373
     /* 143373 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(143409), // Rule ID 815 //
     /* 143378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 143386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143400 */     // (intrinsic_wo_chain:{ *:[v2i64] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
     /* 143403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143407 */     GIR_RootConstrainSelectedInstOperands,
     /* 143408 */     // GIR_Coverage, 815,
     /* 143408 */     GIR_EraseRootFromParent_Done,
     /* 143409 */   // Label 2795: @143409
     /* 143409 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(143445), // Rule ID 816 //
     /* 143414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143436 */     // (intrinsic_wo_chain:{ *:[v4i16] } 587:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
     /* 143439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143443 */     GIR_RootConstrainSelectedInstOperands,
     /* 143444 */     // GIR_Coverage, 816,
     /* 143444 */     GIR_EraseRootFromParent_Done,
     /* 143445 */   // Label 2796: @143445
     /* 143445 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(143481), // Rule ID 817 //
     /* 143450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143472 */     // (intrinsic_wo_chain:{ *:[v8i16] } 587:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 143472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
     /* 143475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143479 */     GIR_RootConstrainSelectedInstOperands,
     /* 143480 */     // GIR_Coverage, 817,
     /* 143480 */     GIR_EraseRootFromParent_Done,
     /* 143481 */   // Label 2797: @143481
     /* 143481 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(143517), // Rule ID 818 //
     /* 143486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143508 */     // (intrinsic_wo_chain:{ *:[v2i32] } 587:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
     /* 143511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143515 */     GIR_RootConstrainSelectedInstOperands,
     /* 143516 */     // GIR_Coverage, 818,
     /* 143516 */     GIR_EraseRootFromParent_Done,
     /* 143517 */   // Label 2798: @143517
     /* 143517 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(143553), // Rule ID 819 //
     /* 143522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143544 */     // (intrinsic_wo_chain:{ *:[v4i32] } 587:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
     /* 143547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143551 */     GIR_RootConstrainSelectedInstOperands,
     /* 143552 */     // GIR_Coverage, 819,
     /* 143552 */     GIR_EraseRootFromParent_Done,
     /* 143553 */   // Label 2799: @143553
     /* 143553 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(143589), // Rule ID 820 //
     /* 143558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 143566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143580 */     // (intrinsic_wo_chain:{ *:[v2i64] } 587:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
     /* 143583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143587 */     GIR_RootConstrainSelectedInstOperands,
     /* 143588 */     // GIR_Coverage, 820,
     /* 143588 */     GIR_EraseRootFromParent_Done,
     /* 143589 */   // Label 2800: @143589
     /* 143589 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(143625), // Rule ID 821 //
     /* 143594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143616 */     // (intrinsic_wo_chain:{ *:[v4i16] } 588:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
     /* 143619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143623 */     GIR_RootConstrainSelectedInstOperands,
     /* 143624 */     // GIR_Coverage, 821,
     /* 143624 */     GIR_EraseRootFromParent_Done,
     /* 143625 */   // Label 2801: @143625
     /* 143625 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(143661), // Rule ID 822 //
     /* 143630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143652 */     // (intrinsic_wo_chain:{ *:[v8i16] } 588:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 143652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
     /* 143655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143659 */     GIR_RootConstrainSelectedInstOperands,
     /* 143660 */     // GIR_Coverage, 822,
     /* 143660 */     GIR_EraseRootFromParent_Done,
     /* 143661 */   // Label 2802: @143661
     /* 143661 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(143697), // Rule ID 823 //
     /* 143666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143688 */     // (intrinsic_wo_chain:{ *:[v2i32] } 588:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
     /* 143691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143695 */     GIR_RootConstrainSelectedInstOperands,
     /* 143696 */     // GIR_Coverage, 823,
     /* 143696 */     GIR_EraseRootFromParent_Done,
     /* 143697 */   // Label 2803: @143697
     /* 143697 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(143733), // Rule ID 824 //
     /* 143702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143724 */     // (intrinsic_wo_chain:{ *:[v4i32] } 588:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
     /* 143727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143731 */     GIR_RootConstrainSelectedInstOperands,
     /* 143732 */     // GIR_Coverage, 824,
     /* 143732 */     GIR_EraseRootFromParent_Done,
     /* 143733 */   // Label 2804: @143733
     /* 143733 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(143769), // Rule ID 825 //
     /* 143738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 143746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143760 */     // (intrinsic_wo_chain:{ *:[v2i64] } 588:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
     /* 143763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143767 */     GIR_RootConstrainSelectedInstOperands,
     /* 143768 */     // GIR_Coverage, 825,
     /* 143768 */     GIR_EraseRootFromParent_Done,
     /* 143769 */   // Label 2805: @143769
     /* 143769 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(143805), // Rule ID 826 //
     /* 143774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143796 */     // (intrinsic_wo_chain:{ *:[v4i16] } 589:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
     /* 143799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143803 */     GIR_RootConstrainSelectedInstOperands,
     /* 143804 */     // GIR_Coverage, 826,
     /* 143804 */     GIR_EraseRootFromParent_Done,
     /* 143805 */   // Label 2806: @143805
     /* 143805 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(143841), // Rule ID 827 //
     /* 143810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 143821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 143824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143832 */     // (intrinsic_wo_chain:{ *:[v8i16] } 589:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 143832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
     /* 143835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143839 */     GIR_RootConstrainSelectedInstOperands,
     /* 143840 */     // GIR_Coverage, 827,
     /* 143840 */     GIR_EraseRootFromParent_Done,
     /* 143841 */   // Label 2807: @143841
     /* 143841 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(143877), // Rule ID 828 //
     /* 143846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 143857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 143860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143868 */     // (intrinsic_wo_chain:{ *:[v2i32] } 589:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 143868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
     /* 143871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143875 */     GIR_RootConstrainSelectedInstOperands,
     /* 143876 */     // GIR_Coverage, 828,
     /* 143876 */     GIR_EraseRootFromParent_Done,
     /* 143877 */   // Label 2808: @143877
     /* 143877 */   GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(143913), // Rule ID 829 //
     /* 143882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 143893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 143896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143904 */     // (intrinsic_wo_chain:{ *:[v4i32] } 589:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 143904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
     /* 143907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143911 */     GIR_RootConstrainSelectedInstOperands,
     /* 143912 */     // GIR_Coverage, 829,
     /* 143912 */     GIR_EraseRootFromParent_Done,
     /* 143913 */   // Label 2809: @143913
     /* 143913 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(143949), // Rule ID 830 //
     /* 143918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 143921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 143926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 143929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 143932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143940 */     // (intrinsic_wo_chain:{ *:[v2i64] } 589:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 143940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
     /* 143943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143947 */     GIR_RootConstrainSelectedInstOperands,
     /* 143948 */     // GIR_Coverage, 830,
     /* 143948 */     GIR_EraseRootFromParent_Done,
     /* 143949 */   // Label 2810: @143949
     /* 143949 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(143985), // Rule ID 831 //
     /* 143954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 143965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 143968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143976 */     // (intrinsic_wo_chain:{ *:[v4i16] } 590:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 143976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
     /* 143979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 143981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 143983 */     GIR_RootConstrainSelectedInstOperands,
     /* 143984 */     // GIR_Coverage, 831,
     /* 143984 */     GIR_EraseRootFromParent_Done,
     /* 143985 */   // Label 2811: @143985
     /* 143985 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(144021), // Rule ID 832 //
     /* 143990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 143993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 143998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144012 */     // (intrinsic_wo_chain:{ *:[v8i16] } 590:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 144012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
     /* 144015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144019 */     GIR_RootConstrainSelectedInstOperands,
     /* 144020 */     // GIR_Coverage, 832,
     /* 144020 */     GIR_EraseRootFromParent_Done,
     /* 144021 */   // Label 2812: @144021
     /* 144021 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(144057), // Rule ID 833 //
     /* 144026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 144034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144048 */     // (intrinsic_wo_chain:{ *:[v2i32] } 590:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 144048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
     /* 144051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144055 */     GIR_RootConstrainSelectedInstOperands,
     /* 144056 */     // GIR_Coverage, 833,
     /* 144056 */     GIR_EraseRootFromParent_Done,
     /* 144057 */   // Label 2813: @144057
     /* 144057 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(144093), // Rule ID 834 //
     /* 144062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 144070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144084 */     // (intrinsic_wo_chain:{ *:[v4i32] } 590:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 144084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
     /* 144087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144091 */     GIR_RootConstrainSelectedInstOperands,
     /* 144092 */     // GIR_Coverage, 834,
     /* 144092 */     GIR_EraseRootFromParent_Done,
     /* 144093 */   // Label 2814: @144093
     /* 144093 */   GIM_Try, /*On fail goto*//*Label 2815*/ GIMT_Encode4(144129), // Rule ID 835 //
     /* 144098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 144106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144120 */     // (intrinsic_wo_chain:{ *:[v2i64] } 590:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 144120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
     /* 144123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144127 */     GIR_RootConstrainSelectedInstOperands,
     /* 144128 */     // GIR_Coverage, 835,
     /* 144128 */     GIR_EraseRootFromParent_Done,
     /* 144129 */   // Label 2815: @144129
     /* 144129 */   GIM_Try, /*On fail goto*//*Label 2816*/ GIMT_Encode4(144165), // Rule ID 836 //
     /* 144134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 144142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144156 */     // (intrinsic_wo_chain:{ *:[v2f32] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 144156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
     /* 144159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144163 */     GIR_RootConstrainSelectedInstOperands,
     /* 144164 */     // GIR_Coverage, 836,
     /* 144164 */     GIR_EraseRootFromParent_Done,
     /* 144165 */   // Label 2816: @144165
     /* 144165 */   GIM_Try, /*On fail goto*//*Label 2817*/ GIMT_Encode4(144201), // Rule ID 863 //
     /* 144170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 144178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144192 */     // (intrinsic_wo_chain:{ *:[v4f16] } 632:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 144192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
     /* 144195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144199 */     GIR_RootConstrainSelectedInstOperands,
     /* 144200 */     // GIR_Coverage, 863,
     /* 144200 */     GIR_EraseRootFromParent_Done,
     /* 144201 */   // Label 2817: @144201
     /* 144201 */   GIM_Try, /*On fail goto*//*Label 2818*/ GIMT_Encode4(144237), // Rule ID 864 //
     /* 144206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 144214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144228 */     // (intrinsic_wo_chain:{ *:[v8f16] } 632:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 144228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
     /* 144231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144235 */     GIR_RootConstrainSelectedInstOperands,
     /* 144236 */     // GIR_Coverage, 864,
     /* 144236 */     GIR_EraseRootFromParent_Done,
     /* 144237 */   // Label 2818: @144237
     /* 144237 */   GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(144273), // Rule ID 865 //
     /* 144242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 144250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144264 */     // (intrinsic_wo_chain:{ *:[v2f32] } 632:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
     /* 144267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144271 */     GIR_RootConstrainSelectedInstOperands,
     /* 144272 */     // GIR_Coverage, 865,
     /* 144272 */     GIR_EraseRootFromParent_Done,
     /* 144273 */   // Label 2819: @144273
     /* 144273 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(144309), // Rule ID 866 //
     /* 144278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 144286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144300 */     // (intrinsic_wo_chain:{ *:[v4f32] } 632:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
     /* 144303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144307 */     GIR_RootConstrainSelectedInstOperands,
     /* 144308 */     // GIR_Coverage, 866,
     /* 144308 */     GIR_EraseRootFromParent_Done,
     /* 144309 */   // Label 2820: @144309
     /* 144309 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(144345), // Rule ID 867 //
     /* 144314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 144322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144336 */     // (intrinsic_wo_chain:{ *:[v2f64] } 632:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
     /* 144339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144343 */     GIR_RootConstrainSelectedInstOperands,
     /* 144344 */     // GIR_Coverage, 867,
     /* 144344 */     GIR_EraseRootFromParent_Done,
     /* 144345 */   // Label 2821: @144345
     /* 144345 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(144381), // Rule ID 938 //
     /* 144350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 144358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144372 */     // (intrinsic_wo_chain:{ *:[v2f32] } 636:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
     /* 144375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144379 */     GIR_RootConstrainSelectedInstOperands,
     /* 144380 */     // GIR_Coverage, 938,
     /* 144380 */     GIR_EraseRootFromParent_Done,
     /* 144381 */   // Label 2822: @144381
     /* 144381 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(144417), // Rule ID 939 //
     /* 144386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 144394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144408 */     // (intrinsic_wo_chain:{ *:[v4f32] } 636:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
     /* 144411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144415 */     GIR_RootConstrainSelectedInstOperands,
     /* 144416 */     // GIR_Coverage, 939,
     /* 144416 */     GIR_EraseRootFromParent_Done,
     /* 144417 */   // Label 2823: @144417
     /* 144417 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(144453), // Rule ID 940 //
     /* 144422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 144430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144444 */     // (intrinsic_wo_chain:{ *:[v2f64] } 636:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
     /* 144447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144451 */     GIR_RootConstrainSelectedInstOperands,
     /* 144452 */     // GIR_Coverage, 940,
     /* 144452 */     GIR_EraseRootFromParent_Done,
     /* 144453 */   // Label 2824: @144453
     /* 144453 */   GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(144489), // Rule ID 941 //
     /* 144458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 144466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144480 */     // (intrinsic_wo_chain:{ *:[v2f32] } 638:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
     /* 144483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144487 */     GIR_RootConstrainSelectedInstOperands,
     /* 144488 */     // GIR_Coverage, 941,
     /* 144488 */     GIR_EraseRootFromParent_Done,
     /* 144489 */   // Label 2825: @144489
     /* 144489 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(144525), // Rule ID 942 //
     /* 144494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 144502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144516 */     // (intrinsic_wo_chain:{ *:[v4f32] } 638:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
     /* 144519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144523 */     GIR_RootConstrainSelectedInstOperands,
     /* 144524 */     // GIR_Coverage, 942,
     /* 144524 */     GIR_EraseRootFromParent_Done,
     /* 144525 */   // Label 2826: @144525
     /* 144525 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(144561), // Rule ID 943 //
     /* 144530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 144538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144552 */     // (intrinsic_wo_chain:{ *:[v2f64] } 638:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
     /* 144555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144559 */     GIR_RootConstrainSelectedInstOperands,
     /* 144560 */     // GIR_Coverage, 943,
     /* 144560 */     GIR_EraseRootFromParent_Done,
     /* 144561 */   // Label 2827: @144561
     /* 144561 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(144597), // Rule ID 944 //
     /* 144566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 144574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144588 */     // (intrinsic_wo_chain:{ *:[v2f32] } 635:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
     /* 144591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144595 */     GIR_RootConstrainSelectedInstOperands,
     /* 144596 */     // GIR_Coverage, 944,
     /* 144596 */     GIR_EraseRootFromParent_Done,
     /* 144597 */   // Label 2828: @144597
     /* 144597 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(144633), // Rule ID 945 //
     /* 144602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 144610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144624 */     // (intrinsic_wo_chain:{ *:[v4f32] } 635:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
     /* 144627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144631 */     GIR_RootConstrainSelectedInstOperands,
     /* 144632 */     // GIR_Coverage, 945,
     /* 144632 */     GIR_EraseRootFromParent_Done,
     /* 144633 */   // Label 2829: @144633
     /* 144633 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(144669), // Rule ID 946 //
     /* 144638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 144646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144660 */     // (intrinsic_wo_chain:{ *:[v2f64] } 635:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
     /* 144663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144667 */     GIR_RootConstrainSelectedInstOperands,
     /* 144668 */     // GIR_Coverage, 946,
     /* 144668 */     GIR_EraseRootFromParent_Done,
     /* 144669 */   // Label 2830: @144669
     /* 144669 */   GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(144705), // Rule ID 947 //
     /* 144674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 144682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144696 */     // (intrinsic_wo_chain:{ *:[v2f32] } 637:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
     /* 144699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144703 */     GIR_RootConstrainSelectedInstOperands,
     /* 144704 */     // GIR_Coverage, 947,
     /* 144704 */     GIR_EraseRootFromParent_Done,
     /* 144705 */   // Label 2831: @144705
     /* 144705 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(144741), // Rule ID 948 //
     /* 144710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 144718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144732 */     // (intrinsic_wo_chain:{ *:[v4f32] } 637:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
     /* 144735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144739 */     GIR_RootConstrainSelectedInstOperands,
     /* 144740 */     // GIR_Coverage, 948,
     /* 144740 */     GIR_EraseRootFromParent_Done,
     /* 144741 */   // Label 2832: @144741
     /* 144741 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(144777), // Rule ID 949 //
     /* 144746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 144749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 144754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144768 */     // (intrinsic_wo_chain:{ *:[v2f64] } 637:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
     /* 144771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144775 */     GIR_RootConstrainSelectedInstOperands,
     /* 144776 */     // GIR_Coverage, 949,
     /* 144776 */     GIR_EraseRootFromParent_Done,
     /* 144777 */   // Label 2833: @144777
     /* 144777 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(144813), // Rule ID 950 //
     /* 144782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 144796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144804 */     // (intrinsic_wo_chain:{ *:[v4f16] } 639:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 144804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
     /* 144807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144811 */     GIR_RootConstrainSelectedInstOperands,
     /* 144812 */     // GIR_Coverage, 950,
     /* 144812 */     GIR_EraseRootFromParent_Done,
     /* 144813 */   // Label 2834: @144813
     /* 144813 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(144849), // Rule ID 951 //
     /* 144818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 144821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 144829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 144832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144840 */     // (intrinsic_wo_chain:{ *:[v8f16] } 639:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 144840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
     /* 144843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144847 */     GIR_RootConstrainSelectedInstOperands,
     /* 144848 */     // GIR_Coverage, 951,
     /* 144848 */     GIR_EraseRootFromParent_Done,
     /* 144849 */   // Label 2835: @144849
     /* 144849 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(144885), // Rule ID 952 //
     /* 144854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 144865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 144868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144876 */     // (intrinsic_wo_chain:{ *:[v2f32] } 639:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 144876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
     /* 144879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144883 */     GIR_RootConstrainSelectedInstOperands,
     /* 144884 */     // GIR_Coverage, 952,
     /* 144884 */     GIR_EraseRootFromParent_Done,
     /* 144885 */   // Label 2836: @144885
     /* 144885 */   GIM_Try, /*On fail goto*//*Label 2837*/ GIMT_Encode4(144921), // Rule ID 953 //
     /* 144890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 144901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 144904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144912 */     // (intrinsic_wo_chain:{ *:[v4f32] } 639:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 144912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
     /* 144915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144919 */     GIR_RootConstrainSelectedInstOperands,
     /* 144920 */     // GIR_Coverage, 953,
     /* 144920 */     GIR_EraseRootFromParent_Done,
     /* 144921 */   // Label 2837: @144921
     /* 144921 */   GIM_Try, /*On fail goto*//*Label 2838*/ GIMT_Encode4(144957), // Rule ID 954 //
     /* 144926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 144934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 144937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 144940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 144948 */     // (intrinsic_wo_chain:{ *:[v2f64] } 639:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 144948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
     /* 144951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144955 */     GIR_RootConstrainSelectedInstOperands,
     /* 144956 */     // GIR_Coverage, 954,
     /* 144956 */     GIR_EraseRootFromParent_Done,
     /* 144957 */   // Label 2838: @144957
     /* 144957 */   GIM_Try, /*On fail goto*//*Label 2839*/ GIMT_Encode4(144993), // Rule ID 1001 //
     /* 144962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 144965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 144970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 144973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 144976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 144984 */     // (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 144984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 144987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 144989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 144991 */     GIR_RootConstrainSelectedInstOperands,
     /* 144992 */     // GIR_Coverage, 1001,
     /* 144992 */     GIR_EraseRootFromParent_Done,
     /* 144993 */   // Label 2839: @144993
     /* 144993 */   GIM_Try, /*On fail goto*//*Label 2840*/ GIMT_Encode4(145029), // Rule ID 1003 //
     /* 144998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 145006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 145012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145020 */     // (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 145020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 145023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145027 */     GIR_RootConstrainSelectedInstOperands,
     /* 145028 */     // GIR_Coverage, 1003,
     /* 145028 */     GIR_EraseRootFromParent_Done,
     /* 145029 */   // Label 2840: @145029
     /* 145029 */   GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(145065), // Rule ID 1005 //
     /* 145034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 145042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145056 */     // (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 145056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 145059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145063 */     GIR_RootConstrainSelectedInstOperands,
     /* 145064 */     // GIR_Coverage, 1005,
     /* 145064 */     GIR_EraseRootFromParent_Done,
     /* 145065 */   // Label 2841: @145065
     /* 145065 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(145101), // Rule ID 1007 //
     /* 145070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 145078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145092 */     // (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 145092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 145095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145099 */     GIR_RootConstrainSelectedInstOperands,
     /* 145100 */     // GIR_Coverage, 1007,
     /* 145100 */     GIR_EraseRootFromParent_Done,
     /* 145101 */   // Label 2842: @145101
     /* 145101 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(145137), // Rule ID 1009 //
     /* 145106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 145114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145128 */     // (intrinsic_wo_chain:{ *:[v1i64] } 660:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 145128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 145131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145135 */     GIR_RootConstrainSelectedInstOperands,
     /* 145136 */     // GIR_Coverage, 1009,
     /* 145136 */     GIR_EraseRootFromParent_Done,
     /* 145137 */   // Label 2843: @145137
     /* 145137 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(145173), // Rule ID 1011 //
     /* 145142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 145150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145164 */     // (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 145164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 145167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145171 */     GIR_RootConstrainSelectedInstOperands,
     /* 145172 */     // GIR_Coverage, 1011,
     /* 145172 */     GIR_EraseRootFromParent_Done,
     /* 145173 */   // Label 2844: @145173
     /* 145173 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(145209), // Rule ID 1022 //
     /* 145178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 145189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 145192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145200 */     // (intrinsic_wo_chain:{ *:[v8i8] } 678:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 145200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
     /* 145203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145207 */     GIR_RootConstrainSelectedInstOperands,
     /* 145208 */     // GIR_Coverage, 1022,
     /* 145208 */     GIR_EraseRootFromParent_Done,
     /* 145209 */   // Label 2845: @145209
     /* 145209 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(145245), // Rule ID 1023 //
     /* 145214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 145225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 145228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145236 */     // (intrinsic_wo_chain:{ *:[v16i8] } 678:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 145236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
     /* 145239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145243 */     GIR_RootConstrainSelectedInstOperands,
     /* 145244 */     // GIR_Coverage, 1023,
     /* 145244 */     GIR_EraseRootFromParent_Done,
     /* 145245 */   // Label 2846: @145245
     /* 145245 */   GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(145281), // Rule ID 1024 //
     /* 145250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145272 */     // (intrinsic_wo_chain:{ *:[v4i16] } 678:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 145272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
     /* 145275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145279 */     GIR_RootConstrainSelectedInstOperands,
     /* 145280 */     // GIR_Coverage, 1024,
     /* 145280 */     GIR_EraseRootFromParent_Done,
     /* 145281 */   // Label 2847: @145281
     /* 145281 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(145317), // Rule ID 1025 //
     /* 145286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145308 */     // (intrinsic_wo_chain:{ *:[v8i16] } 678:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 145308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
     /* 145311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145315 */     GIR_RootConstrainSelectedInstOperands,
     /* 145316 */     // GIR_Coverage, 1025,
     /* 145316 */     GIR_EraseRootFromParent_Done,
     /* 145317 */   // Label 2848: @145317
     /* 145317 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(145353), // Rule ID 1026 //
     /* 145322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145344 */     // (intrinsic_wo_chain:{ *:[v2i32] } 678:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 145344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
     /* 145347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145351 */     GIR_RootConstrainSelectedInstOperands,
     /* 145352 */     // GIR_Coverage, 1026,
     /* 145352 */     GIR_EraseRootFromParent_Done,
     /* 145353 */   // Label 2849: @145353
     /* 145353 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(145389), // Rule ID 1027 //
     /* 145358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145380 */     // (intrinsic_wo_chain:{ *:[v4i32] } 678:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 145380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
     /* 145383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145387 */     GIR_RootConstrainSelectedInstOperands,
     /* 145388 */     // GIR_Coverage, 1027,
     /* 145388 */     GIR_EraseRootFromParent_Done,
     /* 145389 */   // Label 2850: @145389
     /* 145389 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(145425), // Rule ID 1028 //
     /* 145394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 145402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145416 */     // (intrinsic_wo_chain:{ *:[v2i64] } 678:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 145416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
     /* 145419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145423 */     GIR_RootConstrainSelectedInstOperands,
     /* 145424 */     // GIR_Coverage, 1028,
     /* 145424 */     GIR_EraseRootFromParent_Done,
     /* 145425 */   // Label 2851: @145425
     /* 145425 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(145461), // Rule ID 1029 //
     /* 145430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 145441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 145444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145452 */     // (intrinsic_wo_chain:{ *:[v8i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 145452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
     /* 145455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145459 */     GIR_RootConstrainSelectedInstOperands,
     /* 145460 */     // GIR_Coverage, 1029,
     /* 145460 */     GIR_EraseRootFromParent_Done,
     /* 145461 */   // Label 2852: @145461
     /* 145461 */   GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(145497), // Rule ID 1030 //
     /* 145466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 145477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 145480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145488 */     // (intrinsic_wo_chain:{ *:[v16i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 145488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
     /* 145491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145495 */     GIR_RootConstrainSelectedInstOperands,
     /* 145496 */     // GIR_Coverage, 1030,
     /* 145496 */     GIR_EraseRootFromParent_Done,
     /* 145497 */   // Label 2853: @145497
     /* 145497 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(145533), // Rule ID 1031 //
     /* 145502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145524 */     // (intrinsic_wo_chain:{ *:[v4i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 145524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
     /* 145527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145531 */     GIR_RootConstrainSelectedInstOperands,
     /* 145532 */     // GIR_Coverage, 1031,
     /* 145532 */     GIR_EraseRootFromParent_Done,
     /* 145533 */   // Label 2854: @145533
     /* 145533 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(145569), // Rule ID 1032 //
     /* 145538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145560 */     // (intrinsic_wo_chain:{ *:[v8i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 145560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
     /* 145563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145567 */     GIR_RootConstrainSelectedInstOperands,
     /* 145568 */     // GIR_Coverage, 1032,
     /* 145568 */     GIR_EraseRootFromParent_Done,
     /* 145569 */   // Label 2855: @145569
     /* 145569 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(145605), // Rule ID 1033 //
     /* 145574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145596 */     // (intrinsic_wo_chain:{ *:[v2i32] } 685:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 145596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
     /* 145599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145603 */     GIR_RootConstrainSelectedInstOperands,
     /* 145604 */     // GIR_Coverage, 1033,
     /* 145604 */     GIR_EraseRootFromParent_Done,
     /* 145605 */   // Label 2856: @145605
     /* 145605 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(145641), // Rule ID 1034 //
     /* 145610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145632 */     // (intrinsic_wo_chain:{ *:[v4i32] } 685:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 145632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
     /* 145635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145639 */     GIR_RootConstrainSelectedInstOperands,
     /* 145640 */     // GIR_Coverage, 1034,
     /* 145640 */     GIR_EraseRootFromParent_Done,
     /* 145641 */   // Label 2857: @145641
     /* 145641 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(145677), // Rule ID 1035 //
     /* 145646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 145654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 145660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145668 */     // (intrinsic_wo_chain:{ *:[v2i64] } 685:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 145668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
     /* 145671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145675 */     GIR_RootConstrainSelectedInstOperands,
     /* 145676 */     // GIR_Coverage, 1035,
     /* 145676 */     GIR_EraseRootFromParent_Done,
     /* 145677 */   // Label 2858: @145677
     /* 145677 */   GIM_Try, /*On fail goto*//*Label 2859*/ GIMT_Encode4(145713), // Rule ID 1062 //
     /* 145682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 145693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 145696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145704 */     // (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 145704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 145707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145711 */     GIR_RootConstrainSelectedInstOperands,
     /* 145712 */     // GIR_Coverage, 1062,
     /* 145712 */     GIR_EraseRootFromParent_Done,
     /* 145713 */   // Label 2859: @145713
     /* 145713 */   GIM_Try, /*On fail goto*//*Label 2860*/ GIMT_Encode4(145749), // Rule ID 1064 //
     /* 145718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 145729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 145732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145740 */     // (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 145740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 145743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145747 */     GIR_RootConstrainSelectedInstOperands,
     /* 145748 */     // GIR_Coverage, 1064,
     /* 145748 */     GIR_EraseRootFromParent_Done,
     /* 145749 */   // Label 2860: @145749
     /* 145749 */   GIM_Try, /*On fail goto*//*Label 2861*/ GIMT_Encode4(145785), // Rule ID 1066 //
     /* 145754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 145768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145776 */     // (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 145776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 145779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145783 */     GIR_RootConstrainSelectedInstOperands,
     /* 145784 */     // GIR_Coverage, 1066,
     /* 145784 */     GIR_EraseRootFromParent_Done,
     /* 145785 */   // Label 2861: @145785
     /* 145785 */   GIM_Try, /*On fail goto*//*Label 2862*/ GIMT_Encode4(145821), // Rule ID 1068 //
     /* 145790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 145804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145812 */     // (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 145812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 145815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145819 */     GIR_RootConstrainSelectedInstOperands,
     /* 145820 */     // GIR_Coverage, 1068,
     /* 145820 */     GIR_EraseRootFromParent_Done,
     /* 145821 */   // Label 2862: @145821
     /* 145821 */   GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(145857), // Rule ID 1070 //
     /* 145826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 145837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145848 */     // (intrinsic_wo_chain:{ *:[v1i64] } 725:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 145848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 145851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145855 */     GIR_RootConstrainSelectedInstOperands,
     /* 145856 */     // GIR_Coverage, 1070,
     /* 145856 */     GIR_EraseRootFromParent_Done,
     /* 145857 */   // Label 2863: @145857
     /* 145857 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(145893), // Rule ID 1072 //
     /* 145862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 145870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 145873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145884 */     // (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 145884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 145887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145891 */     GIR_RootConstrainSelectedInstOperands,
     /* 145892 */     // GIR_Coverage, 1072,
     /* 145892 */     GIR_EraseRootFromParent_Done,
     /* 145893 */   // Label 2864: @145893
     /* 145893 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(145929), // Rule ID 1086 //
     /* 145898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 145906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145920 */     // (intrinsic_wo_chain:{ *:[v2i32] } 746:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 145920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
     /* 145923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145927 */     GIR_RootConstrainSelectedInstOperands,
     /* 145928 */     // GIR_Coverage, 1086,
     /* 145928 */     GIR_EraseRootFromParent_Done,
     /* 145929 */   // Label 2865: @145929
     /* 145929 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(145965), // Rule ID 1087 //
     /* 145934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 145942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 145945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 145948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 145956 */     // (intrinsic_wo_chain:{ *:[v4i32] } 746:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 145956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
     /* 145959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145963 */     GIR_RootConstrainSelectedInstOperands,
     /* 145964 */     // GIR_Coverage, 1087,
     /* 145964 */     GIR_EraseRootFromParent_Done,
     /* 145965 */   // Label 2866: @145965
     /* 145965 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(146001), // Rule ID 1088 //
     /* 145970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 145973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 145978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 145981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 145984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 145992 */     // (intrinsic_wo_chain:{ *:[v2i32] } 749:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 145992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
     /* 145995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 145999 */     GIR_RootConstrainSelectedInstOperands,
     /* 146000 */     // GIR_Coverage, 1088,
     /* 146000 */     GIR_EraseRootFromParent_Done,
     /* 146001 */   // Label 2867: @146001
     /* 146001 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(146037), // Rule ID 1089 //
     /* 146006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 146014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 146017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146028 */     // (intrinsic_wo_chain:{ *:[v4i32] } 749:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 146028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
     /* 146031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146035 */     GIR_RootConstrainSelectedInstOperands,
     /* 146036 */     // GIR_Coverage, 1089,
     /* 146036 */     GIR_EraseRootFromParent_Done,
     /* 146037 */   // Label 2868: @146037
     /* 146037 */   GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(146073), // Rule ID 1653 //
     /* 146042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
     /* 146050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146064 */     // (intrinsic_wo_chain:{ *:[f32] } 786:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 146064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
     /* 146067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146071 */     GIR_RootConstrainSelectedInstOperands,
     /* 146072 */     // GIR_Coverage, 1653,
     /* 146072 */     GIR_EraseRootFromParent_Done,
     /* 146073 */   // Label 2869: @146073
     /* 146073 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(146109), // Rule ID 1659 //
     /* 146078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 146086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146100 */     // (intrinsic_wo_chain:{ *:[i64] } 678:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 146100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 146103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146107 */     GIR_RootConstrainSelectedInstOperands,
     /* 146108 */     // GIR_Coverage, 1659,
     /* 146108 */     GIR_EraseRootFromParent_Done,
     /* 146109 */   // Label 2870: @146109
     /* 146109 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(146145), // Rule ID 1660 //
     /* 146114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 146122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146132 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146136 */     // (intrinsic_wo_chain:{ *:[i32] } 678:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 146136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
     /* 146139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146143 */     GIR_RootConstrainSelectedInstOperands,
     /* 146144 */     // GIR_Coverage, 1660,
     /* 146144 */     GIR_EraseRootFromParent_Done,
     /* 146145 */   // Label 2871: @146145
     /* 146145 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(146181), // Rule ID 1661 //
     /* 146150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 146158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146172 */     // (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 146172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 146175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146179 */     GIR_RootConstrainSelectedInstOperands,
     /* 146180 */     // GIR_Coverage, 1661,
     /* 146180 */     GIR_EraseRootFromParent_Done,
     /* 146181 */   // Label 2872: @146181
     /* 146181 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(146217), // Rule ID 1662 //
     /* 146186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 146194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146208 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 146208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
     /* 146211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146215 */     GIR_RootConstrainSelectedInstOperands,
     /* 146216 */     // GIR_Coverage, 1662,
     /* 146216 */     GIR_EraseRootFromParent_Done,
     /* 146217 */   // Label 2873: @146217
     /* 146217 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(146253), // Rule ID 1663 //
     /* 146222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
     /* 146230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146244 */     // (intrinsic_wo_chain:{ *:[f32] } 663:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 146244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
     /* 146247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146251 */     GIR_RootConstrainSelectedInstOperands,
     /* 146252 */     // GIR_Coverage, 1663,
     /* 146252 */     GIR_EraseRootFromParent_Done,
     /* 146253 */   // Label 2874: @146253
     /* 146253 */   GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(146289), // Rule ID 1664 //
     /* 146258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
     /* 146266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146280 */     // (intrinsic_wo_chain:{ *:[f32] } 664:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 146280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
     /* 146283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146287 */     GIR_RootConstrainSelectedInstOperands,
     /* 146288 */     // GIR_Coverage, 1664,
     /* 146288 */     GIR_EraseRootFromParent_Done,
     /* 146289 */   // Label 2875: @146289
     /* 146289 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(146325), // Rule ID 1670 //
     /* 146294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
     /* 146302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146316 */     // (intrinsic_wo_chain:{ *:[f32] } 665:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 146316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
     /* 146319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146323 */     GIR_RootConstrainSelectedInstOperands,
     /* 146324 */     // GIR_Coverage, 1670,
     /* 146324 */     GIR_EraseRootFromParent_Done,
     /* 146325 */   // Label 2876: @146325
     /* 146325 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(146361), // Rule ID 1943 //
     /* 146330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 146338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146352 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 146352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 146355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146359 */     GIR_RootConstrainSelectedInstOperands,
     /* 146360 */     // GIR_Coverage, 1943,
     /* 146360 */     GIR_EraseRootFromParent_Done,
     /* 146361 */   // Label 2877: @146361
     /* 146361 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(146397), // Rule ID 1945 //
     /* 146366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 146374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146388 */     // (intrinsic_wo_chain:{ *:[f16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 146388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 146391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146395 */     GIR_RootConstrainSelectedInstOperands,
     /* 146396 */     // GIR_Coverage, 1945,
     /* 146396 */     GIR_EraseRootFromParent_Done,
     /* 146397 */   // Label 2878: @146397
     /* 146397 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(146433), // Rule ID 1947 //
     /* 146402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 146410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146424 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 146427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146431 */     GIR_RootConstrainSelectedInstOperands,
     /* 146432 */     // GIR_Coverage, 1947,
     /* 146432 */     GIR_EraseRootFromParent_Done,
     /* 146433 */   // Label 2879: @146433
     /* 146433 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(146469), // Rule ID 1949 //
     /* 146438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 146446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146460 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 146460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 146463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146467 */     GIR_RootConstrainSelectedInstOperands,
     /* 146468 */     // GIR_Coverage, 1949,
     /* 146468 */     GIR_EraseRootFromParent_Done,
     /* 146469 */   // Label 2880: @146469
     /* 146469 */   GIM_Try, /*On fail goto*//*Label 2881*/ GIMT_Encode4(146505), // Rule ID 1951 //
     /* 146474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 146482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146496 */     // (intrinsic_wo_chain:{ *:[f16] } 599:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 146496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 146499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146503 */     GIR_RootConstrainSelectedInstOperands,
     /* 146504 */     // GIR_Coverage, 1951,
     /* 146504 */     GIR_EraseRootFromParent_Done,
     /* 146505 */   // Label 2881: @146505
     /* 146505 */   GIM_Try, /*On fail goto*//*Label 2882*/ GIMT_Encode4(146541), // Rule ID 1953 //
     /* 146510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 146518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146532 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 146535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146539 */     GIR_RootConstrainSelectedInstOperands,
     /* 146540 */     // GIR_Coverage, 1953,
     /* 146540 */     GIR_EraseRootFromParent_Done,
     /* 146541 */   // Label 2882: @146541
     /* 146541 */   GIM_Try, /*On fail goto*//*Label 2883*/ GIMT_Encode4(146577), // Rule ID 1955 //
     /* 146546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 146554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146568 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 146568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 146571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146575 */     GIR_RootConstrainSelectedInstOperands,
     /* 146576 */     // GIR_Coverage, 1955,
     /* 146576 */     GIR_EraseRootFromParent_Done,
     /* 146577 */   // Label 2883: @146577
     /* 146577 */   GIM_Try, /*On fail goto*//*Label 2884*/ GIMT_Encode4(146613), // Rule ID 1957 //
     /* 146582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 146590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146604 */     // (intrinsic_wo_chain:{ *:[f16] } 603:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 146604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 146607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146611 */     GIR_RootConstrainSelectedInstOperands,
     /* 146612 */     // GIR_Coverage, 1957,
     /* 146612 */     GIR_EraseRootFromParent_Done,
     /* 146613 */   // Label 2884: @146613
     /* 146613 */   GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(146649), // Rule ID 1959 //
     /* 146618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 146626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146640 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 146643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146647 */     GIR_RootConstrainSelectedInstOperands,
     /* 146648 */     // GIR_Coverage, 1959,
     /* 146648 */     GIR_EraseRootFromParent_Done,
     /* 146649 */   // Label 2885: @146649
     /* 146649 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(146685), // Rule ID 1961 //
     /* 146654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 146662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 146668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146676 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 146676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 146679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146683 */     GIR_RootConstrainSelectedInstOperands,
     /* 146684 */     // GIR_Coverage, 1961,
     /* 146684 */     GIR_EraseRootFromParent_Done,
     /* 146685 */   // Label 2886: @146685
     /* 146685 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(146721), // Rule ID 1963 //
     /* 146690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 146693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 146698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 146701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 146704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 146708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146712 */     // (intrinsic_wo_chain:{ *:[f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 146712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 146715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146719 */     GIR_RootConstrainSelectedInstOperands,
     /* 146720 */     // GIR_Coverage, 1963,
     /* 146720 */     GIR_EraseRootFromParent_Done,
     /* 146721 */   // Label 2887: @146721
     /* 146721 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(146757), // Rule ID 1965 //
     /* 146726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 146734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 146740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146748 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 146748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 146751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146755 */     GIR_RootConstrainSelectedInstOperands,
     /* 146756 */     // GIR_Coverage, 1965,
     /* 146756 */     GIR_EraseRootFromParent_Done,
     /* 146757 */   // Label 2888: @146757
     /* 146757 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(146793), // Rule ID 2303 //
     /* 146762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 146765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 146770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 146773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 146776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146784 */     // (intrinsic_wo_chain:{ *:[v16i8] } 514:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 146784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
     /* 146787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146791 */     GIR_RootConstrainSelectedInstOperands,
     /* 146792 */     // GIR_Coverage, 2303,
     /* 146792 */     GIR_EraseRootFromParent_Done,
     /* 146793 */   // Label 2889: @146793
     /* 146793 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(146829), // Rule ID 2304 //
     /* 146798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 146801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 146806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 146809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 146812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 146820 */     // (intrinsic_wo_chain:{ *:[v16i8] } 513:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 146820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
     /* 146823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146827 */     GIR_RootConstrainSelectedInstOperands,
     /* 146828 */     // GIR_Coverage, 2304,
     /* 146828 */     GIR_EraseRootFromParent_Done,
     /* 146829 */   // Label 2890: @146829
     /* 146829 */   GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(146865), // Rule ID 2312 //
     /* 146834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 146837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
     /* 146842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 146845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 146856 */     // (intrinsic_wo_chain:{ *:[i32] } 521:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 146856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
     /* 146859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146863 */     GIR_RootConstrainSelectedInstOperands,
     /* 146864 */     // GIR_Coverage, 2312,
     /* 146864 */     GIR_EraseRootFromParent_Done,
     /* 146865 */   // Label 2891: @146865
     /* 146865 */   GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(146901), // Rule ID 2513 //
     /* 146870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 146873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 146878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 146881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 146892 */     // (intrinsic_wo_chain:{ *:[v1i64] } 678:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 146892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 146895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 146899 */     GIR_RootConstrainSelectedInstOperands,
     /* 146900 */     // GIR_Coverage, 2513,
     /* 146900 */     GIR_EraseRootFromParent_Done,
     /* 146901 */   // Label 2892: @146901
     /* 146901 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(146940), // Rule ID 3546 //
     /* 146906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 146914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 146917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 146920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146928 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1613:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
     /* 146928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 146931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 146933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 146935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146938 */     GIR_RootConstrainSelectedInstOperands,
     /* 146939 */     // GIR_Coverage, 3546,
     /* 146939 */     GIR_EraseRootFromParent_Done,
     /* 146940 */   // Label 2893: @146940
     /* 146940 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(146979), // Rule ID 3547 //
     /* 146945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 146953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 146956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 146959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 146963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 146967 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1613:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
     /* 146967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 146970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 146972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 146974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 146977 */     GIR_RootConstrainSelectedInstOperands,
     /* 146978 */     // GIR_Coverage, 3547,
     /* 146978 */     GIR_EraseRootFromParent_Done,
     /* 146979 */   // Label 2894: @146979
     /* 146979 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(147018), // Rule ID 3548 //
     /* 146984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 146987 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 146992 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 146995 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 146998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 147002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147006 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1613:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
     /* 147006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 147009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 147011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 147013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147016 */     GIR_RootConstrainSelectedInstOperands,
     /* 147017 */     // GIR_Coverage, 3548,
     /* 147017 */     GIR_EraseRootFromParent_Done,
     /* 147018 */   // Label 2895: @147018
     /* 147018 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(147057), // Rule ID 3549 //
     /* 147023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 147026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 147031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 147034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 147037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 147041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147045 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1613:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
     /* 147045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 147048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 147050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 147052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147055 */     GIR_RootConstrainSelectedInstOperands,
     /* 147056 */     // GIR_Coverage, 3549,
     /* 147056 */     GIR_EraseRootFromParent_Done,
     /* 147057 */   // Label 2896: @147057
     /* 147057 */   GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(147113), // Rule ID 3553 //
     /* 147062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 147065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 147070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 147073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 147076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 147084 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1615:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
     /* 147084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 147087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 147091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
     /* 147101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 147103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 147111 */     GIR_RootConstrainSelectedInstOperands,
     /* 147112 */     // GIR_Coverage, 3553,
     /* 147112 */     GIR_EraseRootFromParent_Done,
     /* 147113 */   // Label 2897: @147113
     /* 147113 */   GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(147169), // Rule ID 3554 //
     /* 147118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 147121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 147126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 147129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 147132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 147140 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1615:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 147140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 147143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 147147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147152 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 147157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 147159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 147167 */     GIR_RootConstrainSelectedInstOperands,
     /* 147168 */     // GIR_Coverage, 3554,
     /* 147168 */     GIR_EraseRootFromParent_Done,
     /* 147169 */   // Label 2898: @147169
     /* 147169 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(147225), // Rule ID 3555 //
     /* 147174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 147177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 147182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 147185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 147188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 147196 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1615:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 147196 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 147199 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 147203 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147208 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 147213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 147215 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 147223 */     GIR_RootConstrainSelectedInstOperands,
     /* 147224 */     // GIR_Coverage, 3555,
     /* 147224 */     GIR_EraseRootFromParent_Done,
     /* 147225 */   // Label 2899: @147225
     /* 147225 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(147281), // Rule ID 3556 //
     /* 147230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 147233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 147238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 147241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 147244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 147248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 147252 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1615:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 147252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 147255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 147259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 147269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 147271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 147274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 147277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 147279 */     GIR_RootConstrainSelectedInstOperands,
     /* 147280 */     // GIR_Coverage, 3556,
     /* 147280 */     GIR_EraseRootFromParent_Done,
     /* 147281 */   // Label 2900: @147281
     /* 147281 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(147314), // Rule ID 3997 //
     /* 147286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
     /* 147291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147305 */     // (intrinsic_wo_chain:{ *:[i32] } 501:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 147305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 147308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147312 */     GIR_RootConstrainSelectedInstOperands,
     /* 147313 */     // GIR_Coverage, 3997,
     /* 147313 */     GIR_EraseRootFromParent_Done,
     /* 147314 */   // Label 2901: @147314
     /* 147314 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(147379), // Rule ID 3998 //
     /* 147319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
     /* 147324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147338 */     // (intrinsic_wo_chain:{ *:[i32] } 502:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
     /* 147338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 147341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 147345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 147350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 147354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 147356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 147359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 147361 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /* 147368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147378 */     // GIR_Coverage, 3998,
     /* 147378 */     GIR_EraseRootFromParent_Done,
     /* 147379 */   // Label 2902: @147379
     /* 147379 */   GIM_Try, /*On fail goto*//*Label 2903*/ GIMT_Encode4(147412), // Rule ID 4766 //
     /* 147384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 147389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147403 */     // (intrinsic_wo_chain:{ *:[v1f64] } 636:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 147406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147410 */     GIR_RootConstrainSelectedInstOperands,
     /* 147411 */     // GIR_Coverage, 4766,
     /* 147411 */     GIR_EraseRootFromParent_Done,
     /* 147412 */   // Label 2903: @147412
     /* 147412 */   GIM_Try, /*On fail goto*//*Label 2904*/ GIMT_Encode4(147445), // Rule ID 4767 //
     /* 147417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 147422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147436 */     // (intrinsic_wo_chain:{ *:[v1f64] } 638:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 147439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147443 */     GIR_RootConstrainSelectedInstOperands,
     /* 147444 */     // GIR_Coverage, 4767,
     /* 147444 */     GIR_EraseRootFromParent_Done,
     /* 147445 */   // Label 2904: @147445
     /* 147445 */   GIM_Try, /*On fail goto*//*Label 2905*/ GIMT_Encode4(147478), // Rule ID 4768 //
     /* 147450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 147455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147469 */     // (intrinsic_wo_chain:{ *:[v1f64] } 635:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 147472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147476 */     GIR_RootConstrainSelectedInstOperands,
     /* 147477 */     // GIR_Coverage, 4768,
     /* 147477 */     GIR_EraseRootFromParent_Done,
     /* 147478 */   // Label 2905: @147478
     /* 147478 */   GIM_Try, /*On fail goto*//*Label 2906*/ GIMT_Encode4(147511), // Rule ID 4769 //
     /* 147483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 147488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147502 */     // (intrinsic_wo_chain:{ *:[v1f64] } 637:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 147505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147509 */     GIR_RootConstrainSelectedInstOperands,
     /* 147510 */     // GIR_Coverage, 4769,
     /* 147510 */     GIR_EraseRootFromParent_Done,
     /* 147511 */   // Label 2906: @147511
     /* 147511 */   GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(147544), // Rule ID 4883 //
     /* 147516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 147521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 147524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 147527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147535 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
     /* 147535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 147538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147542 */     GIR_RootConstrainSelectedInstOperands,
     /* 147543 */     // GIR_Coverage, 4883,
     /* 147543 */     GIR_EraseRootFromParent_Done,
     /* 147544 */   // Label 2907: @147544
     /* 147544 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(147577), // Rule ID 4893 //
     /* 147549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 147554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 147557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 147560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 147568 */     // (intrinsic_wo_chain:{ *:[v4i16] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
     /* 147568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 147571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147575 */     GIR_RootConstrainSelectedInstOperands,
     /* 147576 */     // GIR_Coverage, 4893,
     /* 147576 */     GIR_EraseRootFromParent_Done,
     /* 147577 */   // Label 2908: @147577
     /* 147577 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(147613), // Rule ID 5232 //
     /* 147582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 147585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 147590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147604 */     // (intrinsic_wo_chain:{ *:[v1i64] } 685:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 147604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 147607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147611 */     GIR_RootConstrainSelectedInstOperands,
     /* 147612 */     // GIR_Coverage, 5232,
     /* 147612 */     GIR_EraseRootFromParent_Done,
     /* 147613 */   // Label 2909: @147613
     /* 147613 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(147646), // Rule ID 5235 //
     /* 147618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 147623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147637 */     // (intrinsic_wo_chain:{ *:[v1i64] } 583:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
     /* 147640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147644 */     GIR_RootConstrainSelectedInstOperands,
     /* 147645 */     // GIR_Coverage, 5235,
     /* 147645 */     GIR_EraseRootFromParent_Done,
     /* 147646 */   // Label 2910: @147646
     /* 147646 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(147679), // Rule ID 5236 //
     /* 147651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 147656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147670 */     // (intrinsic_wo_chain:{ *:[v1i64] } 584:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
     /* 147673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147677 */     GIR_RootConstrainSelectedInstOperands,
     /* 147678 */     // GIR_Coverage, 5236,
     /* 147678 */     GIR_EraseRootFromParent_Done,
     /* 147679 */   // Label 2911: @147679
     /* 147679 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(147712), // Rule ID 5237 //
     /* 147684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 147689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147703 */     // (intrinsic_wo_chain:{ *:[v1i64] } 585:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
     /* 147706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147710 */     GIR_RootConstrainSelectedInstOperands,
     /* 147711 */     // GIR_Coverage, 5237,
     /* 147711 */     GIR_EraseRootFromParent_Done,
     /* 147712 */   // Label 2912: @147712
     /* 147712 */   GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(147745), // Rule ID 5238 //
     /* 147717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 147722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147736 */     // (intrinsic_wo_chain:{ *:[v1i64] } 586:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
     /* 147739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147743 */     GIR_RootConstrainSelectedInstOperands,
     /* 147744 */     // GIR_Coverage, 5238,
     /* 147744 */     GIR_EraseRootFromParent_Done,
     /* 147745 */   // Label 2913: @147745
     /* 147745 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(147778), // Rule ID 5239 //
     /* 147750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 147755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147769 */     // (intrinsic_wo_chain:{ *:[v1i64] } 587:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
     /* 147772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147776 */     GIR_RootConstrainSelectedInstOperands,
     /* 147777 */     // GIR_Coverage, 5239,
     /* 147777 */     GIR_EraseRootFromParent_Done,
     /* 147778 */   // Label 2914: @147778
     /* 147778 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(147811), // Rule ID 5240 //
     /* 147783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 147788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147802 */     // (intrinsic_wo_chain:{ *:[v1i64] } 588:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
     /* 147805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147809 */     GIR_RootConstrainSelectedInstOperands,
     /* 147810 */     // GIR_Coverage, 5240,
     /* 147810 */     GIR_EraseRootFromParent_Done,
     /* 147811 */   // Label 2915: @147811
     /* 147811 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(147844), // Rule ID 5241 //
     /* 147816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 147821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147835 */     // (intrinsic_wo_chain:{ *:[v1i64] } 589:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
     /* 147838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147842 */     GIR_RootConstrainSelectedInstOperands,
     /* 147843 */     // GIR_Coverage, 5241,
     /* 147843 */     GIR_EraseRootFromParent_Done,
     /* 147844 */   // Label 2916: @147844
     /* 147844 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(147877), // Rule ID 5242 //
     /* 147849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 147854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147868 */     // (intrinsic_wo_chain:{ *:[v1i64] } 590:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
     /* 147871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147875 */     GIR_RootConstrainSelectedInstOperands,
     /* 147876 */     // GIR_Coverage, 5242,
     /* 147876 */     GIR_EraseRootFromParent_Done,
     /* 147877 */   // Label 2917: @147877
     /* 147877 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(147910), // Rule ID 5243 //
     /* 147882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 147887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147901 */     // (intrinsic_wo_chain:{ *:[v1i64] } 592:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 147904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147908 */     GIR_RootConstrainSelectedInstOperands,
     /* 147909 */     // GIR_Coverage, 5243,
     /* 147909 */     GIR_EraseRootFromParent_Done,
     /* 147910 */   // Label 2918: @147910
     /* 147910 */   GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(147943), // Rule ID 5244 //
     /* 147915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 147920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 147923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 147934 */     // (intrinsic_wo_chain:{ *:[v1i64] } 593:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 147934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 147937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147941 */     GIR_RootConstrainSelectedInstOperands,
     /* 147942 */     // GIR_Coverage, 5244,
     /* 147942 */     GIR_EraseRootFromParent_Done,
     /* 147943 */   // Label 2919: @147943
     /* 147943 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(147976), // Rule ID 5245 //
     /* 147948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 147953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 147956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 147959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 147967 */     // (intrinsic_wo_chain:{ *:[f16] } 632:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 147967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
     /* 147970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 147972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 147974 */     GIR_RootConstrainSelectedInstOperands,
     /* 147975 */     // GIR_Coverage, 5245,
     /* 147975 */     GIR_EraseRootFromParent_Done,
     /* 147976 */   // Label 2920: @147976
     /* 147976 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(148009), // Rule ID 5246 //
     /* 147981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 147986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 147989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 147996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148000 */     // (intrinsic_wo_chain:{ *:[f32] } 632:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 148000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
     /* 148003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148007 */     GIR_RootConstrainSelectedInstOperands,
     /* 148008 */     // GIR_Coverage, 5246,
     /* 148008 */     GIR_EraseRootFromParent_Done,
     /* 148009 */   // Label 2921: @148009
     /* 148009 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(148042), // Rule ID 5247 //
     /* 148014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 148019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148033 */     // (intrinsic_wo_chain:{ *:[f64] } 632:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 148033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 148036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148040 */     GIR_RootConstrainSelectedInstOperands,
     /* 148041 */     // GIR_Coverage, 5247,
     /* 148041 */     GIR_EraseRootFromParent_Done,
     /* 148042 */   // Label 2922: @148042
     /* 148042 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(148075), // Rule ID 5248 //
     /* 148047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 148052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148066 */     // (intrinsic_wo_chain:{ *:[v1f64] } 632:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 148066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 148069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148073 */     GIR_RootConstrainSelectedInstOperands,
     /* 148074 */     // GIR_Coverage, 5248,
     /* 148074 */     GIR_EraseRootFromParent_Done,
     /* 148075 */   // Label 2923: @148075
     /* 148075 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(148108), // Rule ID 5260 //
     /* 148080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 148085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 148091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148099 */     // (intrinsic_wo_chain:{ *:[f16] } 634:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 148099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
     /* 148102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148106 */     GIR_RootConstrainSelectedInstOperands,
     /* 148107 */     // GIR_Coverage, 5260,
     /* 148107 */     GIR_EraseRootFromParent_Done,
     /* 148108 */   // Label 2924: @148108
     /* 148108 */   GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(148141), // Rule ID 5261 //
     /* 148113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 148118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 148124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148132 */     // (intrinsic_wo_chain:{ *:[f32] } 634:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 148132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
     /* 148135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148139 */     GIR_RootConstrainSelectedInstOperands,
     /* 148140 */     // GIR_Coverage, 5261,
     /* 148140 */     GIR_EraseRootFromParent_Done,
     /* 148141 */   // Label 2925: @148141
     /* 148141 */   GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(148174), // Rule ID 5262 //
     /* 148146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 148151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148165 */     // (intrinsic_wo_chain:{ *:[f64] } 634:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 148165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
     /* 148168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148172 */     GIR_RootConstrainSelectedInstOperands,
     /* 148173 */     // GIR_Coverage, 5262,
     /* 148173 */     GIR_EraseRootFromParent_Done,
     /* 148174 */   // Label 2926: @148174
     /* 148174 */   GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(148207), // Rule ID 5263 //
     /* 148179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 148184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 148190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148198 */     // (intrinsic_wo_chain:{ *:[f16] } 639:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 148198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
     /* 148201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148205 */     GIR_RootConstrainSelectedInstOperands,
     /* 148206 */     // GIR_Coverage, 5263,
     /* 148206 */     GIR_EraseRootFromParent_Done,
     /* 148207 */   // Label 2927: @148207
     /* 148207 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(148240), // Rule ID 5264 //
     /* 148212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 148217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 148223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148231 */     // (intrinsic_wo_chain:{ *:[f32] } 639:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 148231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
     /* 148234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148238 */     GIR_RootConstrainSelectedInstOperands,
     /* 148239 */     // GIR_Coverage, 5264,
     /* 148239 */     GIR_EraseRootFromParent_Done,
     /* 148240 */   // Label 2928: @148240
     /* 148240 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(148273), // Rule ID 5265 //
     /* 148245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 148250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148264 */     // (intrinsic_wo_chain:{ *:[f64] } 639:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 148264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 148267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148271 */     GIR_RootConstrainSelectedInstOperands,
     /* 148272 */     // GIR_Coverage, 5265,
     /* 148272 */     GIR_EraseRootFromParent_Done,
     /* 148273 */   // Label 2929: @148273
     /* 148273 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(148306), // Rule ID 5266 //
     /* 148278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 148283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 148289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148297 */     // (intrinsic_wo_chain:{ *:[v1f64] } 639:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 148297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 148300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148304 */     GIR_RootConstrainSelectedInstOperands,
     /* 148305 */     // GIR_Coverage, 5266,
     /* 148305 */     GIR_EraseRootFromParent_Done,
     /* 148306 */   // Label 2930: @148306
     /* 148306 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(148339), // Rule ID 5596 //
     /* 148311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 148316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148330 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 148330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 148333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148337 */     GIR_RootConstrainSelectedInstOperands,
     /* 148338 */     // GIR_Coverage, 5596,
     /* 148338 */     GIR_EraseRootFromParent_Done,
     /* 148339 */   // Label 2931: @148339
     /* 148339 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(148424), // Rule ID 5597 //
     /* 148344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 148349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148363 */     // (intrinsic_wo_chain:{ *:[f32] } 580:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 148363 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 148366 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 148370 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148375 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148379 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148385 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 148388 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148392 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148397 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 148404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148409 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 148417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148419 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148422 */     GIR_RootConstrainSelectedInstOperands,
     /* 148423 */     // GIR_Coverage, 5597,
     /* 148423 */     GIR_EraseRootFromParent_Done,
     /* 148424 */   // Label 2932: @148424
     /* 148424 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(148457), // Rule ID 5598 //
     /* 148429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 148434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148448 */     // (intrinsic_wo_chain:{ *:[f64] } 580:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 148448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 148451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148455 */     GIR_RootConstrainSelectedInstOperands,
     /* 148456 */     // GIR_Coverage, 5598,
     /* 148456 */     GIR_EraseRootFromParent_Done,
     /* 148457 */   // Label 2933: @148457
     /* 148457 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(148490), // Rule ID 5600 //
     /* 148462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 148467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148481 */     // (intrinsic_wo_chain:{ *:[f32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 148481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 148484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148488 */     GIR_RootConstrainSelectedInstOperands,
     /* 148489 */     // GIR_Coverage, 5600,
     /* 148489 */     GIR_EraseRootFromParent_Done,
     /* 148490 */   // Label 2934: @148490
     /* 148490 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(148523), // Rule ID 5602 //
     /* 148495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 148500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148514 */     // (intrinsic_wo_chain:{ *:[f64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 148514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 148517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148521 */     GIR_RootConstrainSelectedInstOperands,
     /* 148522 */     // GIR_Coverage, 5602,
     /* 148522 */     GIR_EraseRootFromParent_Done,
     /* 148523 */   // Label 2935: @148523
     /* 148523 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(148556), // Rule ID 5604 //
     /* 148528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 148533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148547 */     // (intrinsic_wo_chain:{ *:[f32] } 599:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 148547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 148550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148554 */     GIR_RootConstrainSelectedInstOperands,
     /* 148555 */     // GIR_Coverage, 5604,
     /* 148555 */     GIR_EraseRootFromParent_Done,
     /* 148556 */   // Label 2936: @148556
     /* 148556 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(148589), // Rule ID 5606 //
     /* 148561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 148566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148580 */     // (intrinsic_wo_chain:{ *:[f64] } 599:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 148580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 148583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148587 */     GIR_RootConstrainSelectedInstOperands,
     /* 148588 */     // GIR_Coverage, 5606,
     /* 148588 */     GIR_EraseRootFromParent_Done,
     /* 148589 */   // Label 2937: @148589
     /* 148589 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(148622), // Rule ID 5608 //
     /* 148594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 148599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148613 */     // (intrinsic_wo_chain:{ *:[f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 148613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 148616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148620 */     GIR_RootConstrainSelectedInstOperands,
     /* 148621 */     // GIR_Coverage, 5608,
     /* 148621 */     GIR_EraseRootFromParent_Done,
     /* 148622 */   // Label 2938: @148622
     /* 148622 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(148655), // Rule ID 5610 //
     /* 148627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 148632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148646 */     // (intrinsic_wo_chain:{ *:[f64] } 603:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 148646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 148649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148653 */     GIR_RootConstrainSelectedInstOperands,
     /* 148654 */     // GIR_Coverage, 5610,
     /* 148654 */     GIR_EraseRootFromParent_Done,
     /* 148655 */   // Label 2939: @148655
     /* 148655 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(148688), // Rule ID 5612 //
     /* 148660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 148665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 148671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148679 */     // (intrinsic_wo_chain:{ *:[f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 148679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 148682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148686 */     GIR_RootConstrainSelectedInstOperands,
     /* 148687 */     // GIR_Coverage, 5612,
     /* 148687 */     GIR_EraseRootFromParent_Done,
     /* 148688 */   // Label 2940: @148688
     /* 148688 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(148721), // Rule ID 5614 //
     /* 148693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 148698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 148701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 148704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148712 */     // (intrinsic_wo_chain:{ *:[f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 148712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 148715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148719 */     GIR_RootConstrainSelectedInstOperands,
     /* 148720 */     // GIR_Coverage, 5614,
     /* 148720 */     GIR_EraseRootFromParent_Done,
     /* 148721 */   // Label 2941: @148721
     /* 148721 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(148754), // Rule ID 13056 //
     /* 148726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 148734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 148737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 148741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148745 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 148745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 148748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148752 */     GIR_RootConstrainSelectedInstOperands,
     /* 148753 */     // GIR_Coverage, 13056,
     /* 148753 */     GIR_EraseRootFromParent_Done,
     /* 148754 */   // Label 2942: @148754
     /* 148754 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(148787), // Rule ID 13058 //
     /* 148759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 148767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 148770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 148774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148778 */     // (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 148778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 148781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148785 */     GIR_RootConstrainSelectedInstOperands,
     /* 148786 */     // GIR_Coverage, 13058,
     /* 148786 */     GIR_EraseRootFromParent_Done,
     /* 148787 */   // Label 2943: @148787
     /* 148787 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(148820), // Rule ID 13060 //
     /* 148792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 148803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148811 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 148811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 148814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148818 */     GIR_RootConstrainSelectedInstOperands,
     /* 148819 */     // GIR_Coverage, 13060,
     /* 148819 */     GIR_EraseRootFromParent_Done,
     /* 148820 */   // Label 2944: @148820
     /* 148820 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(148853), // Rule ID 13062 //
     /* 148825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 148833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 148836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 148840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148844 */     // (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 148844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 148847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148851 */     GIR_RootConstrainSelectedInstOperands,
     /* 148852 */     // GIR_Coverage, 13062,
     /* 148852 */     GIR_EraseRootFromParent_Done,
     /* 148853 */   // Label 2945: @148853
     /* 148853 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(148968), // Rule ID 13063 //
     /* 148858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 148863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 148866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 148869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148877 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 148877 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 148880 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 148884 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148889 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 148893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 148895 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 148898 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 148902 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148907 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 148909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 148912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 148916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148921 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 148924 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 148927 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 148930 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 148948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 148950 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 148957 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 148962 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 148967 */     // GIR_Coverage, 13063,
     /* 148967 */     GIR_EraseRootFromParent_Done,
     /* 148968 */   // Label 2946: @148968
     /* 148968 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(149001), // Rule ID 13065 //
     /* 148973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 148978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 148981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 148984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 148988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 148992 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 148992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 148995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 148997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 148999 */     GIR_RootConstrainSelectedInstOperands,
     /* 149000 */     // GIR_Coverage, 13065,
     /* 149000 */     GIR_EraseRootFromParent_Done,
     /* 149001 */   // Label 2947: @149001
     /* 149001 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(149034), // Rule ID 13067 //
     /* 149006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 149011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 149017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149025 */     // (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 149025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 149028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149032 */     GIR_RootConstrainSelectedInstOperands,
     /* 149033 */     // GIR_Coverage, 13067,
     /* 149033 */     GIR_EraseRootFromParent_Done,
     /* 149034 */   // Label 2948: @149034
     /* 149034 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(149067), // Rule ID 13069 //
     /* 149039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 149044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149058 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 149058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 149061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149065 */     GIR_RootConstrainSelectedInstOperands,
     /* 149066 */     // GIR_Coverage, 13069,
     /* 149066 */     GIR_EraseRootFromParent_Done,
     /* 149067 */   // Label 2949: @149067
     /* 149067 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(149100), // Rule ID 13071 //
     /* 149072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 149077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 149083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149091 */     // (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 149091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 149094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149098 */     GIR_RootConstrainSelectedInstOperands,
     /* 149099 */     // GIR_Coverage, 13071,
     /* 149099 */     GIR_EraseRootFromParent_Done,
     /* 149100 */   // Label 2950: @149100
     /* 149100 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(149215), // Rule ID 13072 //
     /* 149105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 149110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 149116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149124 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149124 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 149127 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 149131 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149136 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149140 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149142 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149145 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149149 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149168 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149171 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149174 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 149177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149187 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149197 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149209 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149214 */     // GIR_Coverage, 13072,
     /* 149214 */     GIR_EraseRootFromParent_Done,
     /* 149215 */   // Label 2951: @149215
     /* 149215 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(149334), // Rule ID 13073 //
     /* 149220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 149225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149239 */     // (intrinsic_wo_chain:{ *:[i32] } 662:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149239 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149242 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 149246 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149251 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149255 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149259 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149261 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149264 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149268 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149287 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149290 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149293 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149301 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149306 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149316 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149323 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149333 */     // GIR_Coverage, 13073,
     /* 149333 */     GIR_EraseRootFromParent_Done,
     /* 149334 */   // Label 2952: @149334
     /* 149334 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(149449), // Rule ID 13074 //
     /* 149339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 149344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 149350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149358 */     // (intrinsic_wo_chain:{ *:[i64] } 662:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 149358 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149361 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 149365 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149370 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149374 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149376 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 149379 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149383 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 149393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149402 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149405 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149408 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149431 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 149438 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149443 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149448 */     // GIR_Coverage, 13074,
     /* 149448 */     GIR_EraseRootFromParent_Done,
     /* 149449 */   // Label 2953: @149449
     /* 149449 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(149568), // Rule ID 13075 //
     /* 149454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 149459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149473 */     // (intrinsic_wo_chain:{ *:[i32] } 727:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149473 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149476 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 149480 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149485 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149489 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149493 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149495 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149498 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149502 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149521 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149524 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149527 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149550 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149557 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149562 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149567 */     // GIR_Coverage, 13075,
     /* 149567 */     GIR_EraseRootFromParent_Done,
     /* 149568 */   // Label 2954: @149568
     /* 149568 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(149683), // Rule ID 13076 //
     /* 149573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 149578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 149581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 149584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149592 */     // (intrinsic_wo_chain:{ *:[i64] } 727:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 149592 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149595 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 149599 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149604 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149610 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 149613 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149617 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 149627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149636 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149639 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149642 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 149645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149665 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 149672 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149682 */     // GIR_Coverage, 13076,
     /* 149682 */     GIR_EraseRootFromParent_Done,
     /* 149683 */   // Label 2955: @149683
     /* 149683 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(149716), // Rule ID 13078 //
     /* 149688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 149699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149707 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 149707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 149710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149714 */     GIR_RootConstrainSelectedInstOperands,
     /* 149715 */     // GIR_Coverage, 13078,
     /* 149715 */     GIR_EraseRootFromParent_Done,
     /* 149716 */   // Label 2956: @149716
     /* 149716 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(149749), // Rule ID 13080 //
     /* 149721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 149729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 149732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 149736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149740 */     // (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 149740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 149743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149747 */     GIR_RootConstrainSelectedInstOperands,
     /* 149748 */     // GIR_Coverage, 13080,
     /* 149748 */     GIR_EraseRootFromParent_Done,
     /* 149749 */   // Label 2957: @149749
     /* 149749 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(149782), // Rule ID 13082 //
     /* 149754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 149765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149773 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 149773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 149776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149780 */     GIR_RootConstrainSelectedInstOperands,
     /* 149781 */     // GIR_Coverage, 13082,
     /* 149781 */     GIR_EraseRootFromParent_Done,
     /* 149782 */   // Label 2958: @149782
     /* 149782 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(149815), // Rule ID 13084 //
     /* 149787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 149795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 149798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 149802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149806 */     // (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 149806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 149809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 149811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 149813 */     GIR_RootConstrainSelectedInstOperands,
     /* 149814 */     // GIR_Coverage, 13084,
     /* 149814 */     GIR_EraseRootFromParent_Done,
     /* 149815 */   // Label 2959: @149815
     /* 149815 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(149930), // Rule ID 13085 //
     /* 149820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 149831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149839 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149839 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 149842 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 149846 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149851 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149857 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149860 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149864 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149883 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 149886 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 149889 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 149892 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149897 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 149910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 149912 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 149919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 149929 */     // GIR_Coverage, 13085,
     /* 149929 */     GIR_EraseRootFromParent_Done,
     /* 149930 */   // Label 2960: @149930
     /* 149930 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(150049), // Rule ID 13086 //
     /* 149935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 149940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 149943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 149946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 149950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 149954 */     // (intrinsic_wo_chain:{ *:[i32] } 672:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 149954 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 149957 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 149961 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149966 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149970 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 149974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 149976 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 149979 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 149983 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 149990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 149993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 149997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150002 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150005 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150008 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 150011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150016 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150021 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150031 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150038 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150043 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150048 */     // GIR_Coverage, 13086,
     /* 150048 */     GIR_EraseRootFromParent_Done,
     /* 150049 */   // Label 2961: @150049
     /* 150049 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(150082), // Rule ID 13088 //
     /* 150054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 150059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 150065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150073 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 150073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 150076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150080 */     GIR_RootConstrainSelectedInstOperands,
     /* 150081 */     // GIR_Coverage, 13088,
     /* 150081 */     GIR_EraseRootFromParent_Done,
     /* 150082 */   // Label 2962: @150082
     /* 150082 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(150115), // Rule ID 13090 //
     /* 150087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 150092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 150098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150102 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150106 */     // (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 150106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 150109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150113 */     GIR_RootConstrainSelectedInstOperands,
     /* 150114 */     // GIR_Coverage, 13090,
     /* 150114 */     GIR_EraseRootFromParent_Done,
     /* 150115 */   // Label 2963: @150115
     /* 150115 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(150148), // Rule ID 13092 //
     /* 150120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 150125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150139 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 150139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 150142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150146 */     GIR_RootConstrainSelectedInstOperands,
     /* 150147 */     // GIR_Coverage, 13092,
     /* 150147 */     GIR_EraseRootFromParent_Done,
     /* 150148 */   // Label 2964: @150148
     /* 150148 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(150181), // Rule ID 13094 //
     /* 150153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 150158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150172 */     // (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 150172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 150175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150179 */     GIR_RootConstrainSelectedInstOperands,
     /* 150180 */     // GIR_Coverage, 13094,
     /* 150180 */     GIR_EraseRootFromParent_Done,
     /* 150181 */   // Label 2965: @150181
     /* 150181 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(150296), // Rule ID 13095 //
     /* 150186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 150191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150205 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150205 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 150208 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 150212 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150217 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150223 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150226 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150230 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150235 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150249 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150252 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150255 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 150258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150278 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150295 */     // GIR_Coverage, 13095,
     /* 150295 */     GIR_EraseRootFromParent_Done,
     /* 150296 */   // Label 2966: @150296
     /* 150296 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(150415), // Rule ID 13096 //
     /* 150301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 150306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150320 */     // (intrinsic_wo_chain:{ *:[i32] } 675:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150320 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150323 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 150327 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150332 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150336 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150342 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150345 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150349 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150356 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150359 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150363 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150368 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150371 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150374 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 150377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150382 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150397 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150414 */     // GIR_Coverage, 13096,
     /* 150414 */     GIR_EraseRootFromParent_Done,
     /* 150415 */   // Label 2967: @150415
     /* 150415 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(150448), // Rule ID 13098 //
     /* 150420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 150425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 150431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150439 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 150439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 150442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150446 */     GIR_RootConstrainSelectedInstOperands,
     /* 150447 */     // GIR_Coverage, 13098,
     /* 150447 */     GIR_EraseRootFromParent_Done,
     /* 150448 */   // Label 2968: @150448
     /* 150448 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(150481), // Rule ID 13100 //
     /* 150453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 150458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 150464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150472 */     // (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 150472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 150475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150479 */     GIR_RootConstrainSelectedInstOperands,
     /* 150480 */     // GIR_Coverage, 13100,
     /* 150480 */     GIR_EraseRootFromParent_Done,
     /* 150481 */   // Label 2969: @150481
     /* 150481 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(150514), // Rule ID 13102 //
     /* 150486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 150491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150505 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 150505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 150508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150512 */     GIR_RootConstrainSelectedInstOperands,
     /* 150513 */     // GIR_Coverage, 13102,
     /* 150513 */     GIR_EraseRootFromParent_Done,
     /* 150514 */   // Label 2970: @150514
     /* 150514 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(150547), // Rule ID 13104 //
     /* 150519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 150524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150538 */     // (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 150538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 150541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150545 */     GIR_RootConstrainSelectedInstOperands,
     /* 150546 */     // GIR_Coverage, 13104,
     /* 150546 */     GIR_EraseRootFromParent_Done,
     /* 150547 */   // Label 2971: @150547
     /* 150547 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(150662), // Rule ID 13105 //
     /* 150552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 150557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150571 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150571 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 150574 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 150578 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150583 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150587 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150589 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150592 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150596 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150615 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150618 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150621 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 150624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150644 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150651 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150656 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150661 */     // GIR_Coverage, 13105,
     /* 150661 */     GIR_EraseRootFromParent_Done,
     /* 150662 */   // Label 2972: @150662
     /* 150662 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(150781), // Rule ID 13106 //
     /* 150667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 150672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 150678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150686 */     // (intrinsic_wo_chain:{ *:[i32] } 733:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150686 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 150689 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 150693 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150698 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150702 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150708 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150711 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150715 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150722 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150725 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150729 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150734 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150737 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150740 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 150743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 150761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 150763 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 150770 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150775 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150780 */     // GIR_Coverage, 13106,
     /* 150780 */     GIR_EraseRootFromParent_Done,
     /* 150781 */   // Label 2973: @150781
     /* 150781 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(150814), // Rule ID 13108 //
     /* 150786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 150797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150805 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 150805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 150808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150812 */     GIR_RootConstrainSelectedInstOperands,
     /* 150813 */     // GIR_Coverage, 13108,
     /* 150813 */     GIR_EraseRootFromParent_Done,
     /* 150814 */   // Label 2974: @150814
     /* 150814 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(150847), // Rule ID 13110 //
     /* 150819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 150827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 150830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 150834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150838 */     // (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 150838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 150841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150845 */     GIR_RootConstrainSelectedInstOperands,
     /* 150846 */     // GIR_Coverage, 13110,
     /* 150846 */     GIR_EraseRootFromParent_Done,
     /* 150847 */   // Label 2975: @150847
     /* 150847 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(150880), // Rule ID 13112 //
     /* 150852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 150863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 150871 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 150871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 150874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150878 */     GIR_RootConstrainSelectedInstOperands,
     /* 150879 */     // GIR_Coverage, 13112,
     /* 150879 */     GIR_EraseRootFromParent_Done,
     /* 150880 */   // Label 2976: @150880
     /* 150880 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(150913), // Rule ID 13114 //
     /* 150885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 150893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 150896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 150900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150904 */     // (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 150904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 150907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 150909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 150911 */     GIR_RootConstrainSelectedInstOperands,
     /* 150912 */     // GIR_Coverage, 13114,
     /* 150912 */     GIR_EraseRootFromParent_Done,
     /* 150913 */   // Label 2977: @150913
     /* 150913 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(151028), // Rule ID 13115 //
     /* 150918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 150923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 150926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 150929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 150933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150937 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 150937 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 150940 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 150944 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150949 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 150953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 150955 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 150958 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 150962 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150967 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 150969 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 150972 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 150976 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150981 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 150984 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 150987 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 150990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 150995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151000 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151010 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 151017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151022 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151027 */     // GIR_Coverage, 13115,
     /* 151027 */     GIR_EraseRootFromParent_Done,
     /* 151028 */   // Label 2978: @151028
     /* 151028 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(151147), // Rule ID 13116 //
     /* 151033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 151038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151052 */     // (intrinsic_wo_chain:{ *:[i32] } 736:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 151052 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 151055 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 151059 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151064 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151068 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 151072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 151074 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 151077 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 151081 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 151088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 151091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 151095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151100 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 151103 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 151106 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 151109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 151127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 151129 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 151136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 151141 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151146 */     // GIR_Coverage, 13116,
     /* 151146 */     GIR_EraseRootFromParent_Done,
     /* 151147 */   // Label 2979: @151147
     /* 151147 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(151179), // Rule ID 2391 //
     /* 151152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
     /* 151160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 151163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 151166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151170 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1655:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 151170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
     /* 151173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 151177 */     GIR_RootConstrainSelectedInstOperands,
     /* 151178 */     // GIR_Coverage, 2391,
     /* 151178 */     GIR_EraseRootFromParent_Done,
     /* 151179 */   // Label 2980: @151179
     /* 151179 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(151211), // Rule ID 2392 //
     /* 151184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
     /* 151192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 151195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 151198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151202 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1656:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 151202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
     /* 151205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 151209 */     GIR_RootConstrainSelectedInstOperands,
     /* 151210 */     // GIR_Coverage, 2392,
     /* 151210 */     GIR_EraseRootFromParent_Done,
     /* 151211 */   // Label 2981: @151211
     /* 151211 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(151243), // Rule ID 2393 //
     /* 151216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
     /* 151224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 151227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 151230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151234 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1657:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 151234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
     /* 151237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 151241 */     GIR_RootConstrainSelectedInstOperands,
     /* 151242 */     // GIR_Coverage, 2393,
     /* 151242 */     GIR_EraseRootFromParent_Done,
     /* 151243 */   // Label 2982: @151243
     /* 151243 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(151275), // Rule ID 3091 //
     /* 151248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 151256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 151259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 151262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151266 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1837:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 151266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
     /* 151269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151273 */     GIR_RootConstrainSelectedInstOperands,
     /* 151274 */     // GIR_Coverage, 3091,
     /* 151274 */     GIR_EraseRootFromParent_Done,
     /* 151275 */   // Label 2983: @151275
     /* 151275 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(151307), // Rule ID 3092 //
     /* 151280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 151288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 151291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 151294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151298 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1837:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 151298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
     /* 151301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151305 */     GIR_RootConstrainSelectedInstOperands,
     /* 151306 */     // GIR_Coverage, 3092,
     /* 151306 */     GIR_EraseRootFromParent_Done,
     /* 151307 */   // Label 2984: @151307
     /* 151307 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(151339), // Rule ID 3093 //
     /* 151312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 151315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 151320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 151323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 151326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151330 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1837:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 151330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
     /* 151333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151337 */     GIR_RootConstrainSelectedInstOperands,
     /* 151338 */     // GIR_Coverage, 3093,
     /* 151338 */     GIR_EraseRootFromParent_Done,
     /* 151339 */   // Label 2985: @151339
     /* 151339 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(151371), // Rule ID 3347 //
     /* 151344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 151352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 151355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 151358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151362 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1647:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 151362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 151365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151369 */     GIR_RootConstrainSelectedInstOperands,
     /* 151370 */     // GIR_Coverage, 3347,
     /* 151370 */     GIR_EraseRootFromParent_Done,
     /* 151371 */   // Label 2986: @151371
     /* 151371 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(151403), // Rule ID 3348 //
     /* 151376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 151384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 151387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 151390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151394 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1647:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 151394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 151397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151401 */     GIR_RootConstrainSelectedInstOperands,
     /* 151402 */     // GIR_Coverage, 3348,
     /* 151402 */     GIR_EraseRootFromParent_Done,
     /* 151403 */   // Label 2987: @151403
     /* 151403 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(151435), // Rule ID 3349 //
     /* 151408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 151411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 151416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 151419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 151422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 151426 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1647:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 151426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 151429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 151431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151433 */     GIR_RootConstrainSelectedInstOperands,
     /* 151434 */     // GIR_Coverage, 3349,
     /* 151434 */     GIR_EraseRootFromParent_Done,
     /* 151435 */   // Label 2988: @151435
     /* 151435 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(151467), // Rule ID 3428 //
     /* 151440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 151443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 151448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 151451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 151454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151458 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1408:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
     /* 151458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
     /* 151461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151465 */     GIR_RootConstrainSelectedInstOperands,
     /* 151466 */     // GIR_Coverage, 3428,
     /* 151466 */     GIR_EraseRootFromParent_Done,
     /* 151467 */   // Label 2989: @151467
     /* 151467 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(151499), // Rule ID 3429 //
     /* 151472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 151475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 151480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 151483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 151486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151490 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1408:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
     /* 151490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
     /* 151493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151497 */     GIR_RootConstrainSelectedInstOperands,
     /* 151498 */     // GIR_Coverage, 3429,
     /* 151498 */     GIR_EraseRootFromParent_Done,
     /* 151499 */   // Label 2990: @151499
     /* 151499 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(151531), // Rule ID 3430 //
     /* 151504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 151507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 151512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 151515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 151518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151522 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1408:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
     /* 151522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
     /* 151525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 151527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151529 */     GIR_RootConstrainSelectedInstOperands,
     /* 151530 */     // GIR_Coverage, 3430,
     /* 151530 */     GIR_EraseRootFromParent_Done,
     /* 151531 */   // Label 2991: @151531
     /* 151531 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(151563), // Rule ID 3456 //
     /* 151536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 151539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
     /* 151544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 151547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 151550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 151554 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1247:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 151554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
     /* 151557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 151559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 151561 */     GIR_RootConstrainSelectedInstOperands,
     /* 151562 */     // GIR_Coverage, 3456,
     /* 151562 */     GIR_EraseRootFromParent_Done,
     /* 151563 */   // Label 2992: @151563
     /* 151563 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(151595), // Rule ID 4611 //
     /* 151568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 151571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 151582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151586 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 151586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 151589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151593 */     GIR_RootConstrainSelectedInstOperands,
     /* 151594 */     // GIR_Coverage, 4611,
     /* 151594 */     GIR_EraseRootFromParent_Done,
     /* 151595 */   // Label 2993: @151595
     /* 151595 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(151627), // Rule ID 4612 //
     /* 151600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 151603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 151614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151618 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 151618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 151621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151625 */     GIR_RootConstrainSelectedInstOperands,
     /* 151626 */     // GIR_Coverage, 4612,
     /* 151626 */     GIR_EraseRootFromParent_Done,
     /* 151627 */   // Label 2994: @151627
     /* 151627 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(151656), // Rule ID 4613 //
     /* 151632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151647 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 151647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 151650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151654 */     GIR_RootConstrainSelectedInstOperands,
     /* 151655 */     // GIR_Coverage, 4613,
     /* 151655 */     GIR_EraseRootFromParent_Done,
     /* 151656 */   // Label 2995: @151656
     /* 151656 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(151685), // Rule ID 4614 //
     /* 151661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151676 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 151676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 151679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151683 */     GIR_RootConstrainSelectedInstOperands,
     /* 151684 */     // GIR_Coverage, 4614,
     /* 151684 */     GIR_EraseRootFromParent_Done,
     /* 151685 */   // Label 2996: @151685
     /* 151685 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(151714), // Rule ID 4615 //
     /* 151690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151705 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 151705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 151708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151712 */     GIR_RootConstrainSelectedInstOperands,
     /* 151713 */     // GIR_Coverage, 4615,
     /* 151713 */     GIR_EraseRootFromParent_Done,
     /* 151714 */   // Label 2997: @151714
     /* 151714 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(151743), // Rule ID 4616 //
     /* 151719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151734 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 151734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 151737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151741 */     GIR_RootConstrainSelectedInstOperands,
     /* 151742 */     // GIR_Coverage, 4616,
     /* 151742 */     GIR_EraseRootFromParent_Done,
     /* 151743 */   // Label 2998: @151743
     /* 151743 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(151775), // Rule ID 4623 //
     /* 151748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 151751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 151762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151766 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 151766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 151769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151773 */     GIR_RootConstrainSelectedInstOperands,
     /* 151774 */     // GIR_Coverage, 4623,
     /* 151774 */     GIR_EraseRootFromParent_Done,
     /* 151775 */   // Label 2999: @151775
     /* 151775 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(151807), // Rule ID 4624 //
     /* 151780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 151783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 151794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151798 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 151798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 151801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151805 */     GIR_RootConstrainSelectedInstOperands,
     /* 151806 */     // GIR_Coverage, 4624,
     /* 151806 */     GIR_EraseRootFromParent_Done,
     /* 151807 */   // Label 3000: @151807
     /* 151807 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(151836), // Rule ID 4625 //
     /* 151812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151827 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 151827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 151830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151834 */     GIR_RootConstrainSelectedInstOperands,
     /* 151835 */     // GIR_Coverage, 4625,
     /* 151835 */     GIR_EraseRootFromParent_Done,
     /* 151836 */   // Label 3001: @151836
     /* 151836 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(151865), // Rule ID 4626 //
     /* 151841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151856 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 151856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 151859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151863 */     GIR_RootConstrainSelectedInstOperands,
     /* 151864 */     // GIR_Coverage, 4626,
     /* 151864 */     GIR_EraseRootFromParent_Done,
     /* 151865 */   // Label 3002: @151865
     /* 151865 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(151894), // Rule ID 4627 //
     /* 151870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 151878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151885 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 151885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 151888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151892 */     GIR_RootConstrainSelectedInstOperands,
     /* 151893 */     // GIR_Coverage, 4627,
     /* 151893 */     GIR_EraseRootFromParent_Done,
     /* 151894 */   // Label 3003: @151894
     /* 151894 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(151923), // Rule ID 4628 //
     /* 151899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 151904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 151907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151914 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 151914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 151917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151921 */     GIR_RootConstrainSelectedInstOperands,
     /* 151922 */     // GIR_Coverage, 4628,
     /* 151922 */     GIR_EraseRootFromParent_Done,
     /* 151923 */   // Label 3004: @151923
     /* 151923 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(151952), // Rule ID 4923 //
     /* 151928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 151936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 151939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 151943 */     // (intrinsic_wo_chain:{ *:[v4i16] } 592:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 151943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 151946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151950 */     GIR_RootConstrainSelectedInstOperands,
     /* 151951 */     // GIR_Coverage, 4923,
     /* 151951 */     GIR_EraseRootFromParent_Done,
     /* 151952 */   // Label 3005: @151952
     /* 151952 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(151981), // Rule ID 4924 //
     /* 151957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 151965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 151968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 151972 */     // (intrinsic_wo_chain:{ *:[v8i16] } 592:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 151972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 151975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 151977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 151979 */     GIR_RootConstrainSelectedInstOperands,
     /* 151980 */     // GIR_Coverage, 4924,
     /* 151980 */     GIR_EraseRootFromParent_Done,
     /* 151981 */   // Label 3006: @151981
     /* 151981 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(152010), // Rule ID 4925 //
     /* 151986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 151991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 151994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 151997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152001 */     // (intrinsic_wo_chain:{ *:[v2i32] } 592:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 152001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 152004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152008 */     GIR_RootConstrainSelectedInstOperands,
     /* 152009 */     // GIR_Coverage, 4925,
     /* 152009 */     GIR_EraseRootFromParent_Done,
     /* 152010 */   // Label 3007: @152010
     /* 152010 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(152039), // Rule ID 4926 //
     /* 152015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 152020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152030 */     // (intrinsic_wo_chain:{ *:[v4i32] } 592:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 152030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 152033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152037 */     GIR_RootConstrainSelectedInstOperands,
     /* 152038 */     // GIR_Coverage, 4926,
     /* 152038 */     GIR_EraseRootFromParent_Done,
     /* 152039 */   // Label 3008: @152039
     /* 152039 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(152068), // Rule ID 4927 //
     /* 152044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 152049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152059 */     // (intrinsic_wo_chain:{ *:[v2i64] } 592:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 152059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 152062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152066 */     GIR_RootConstrainSelectedInstOperands,
     /* 152067 */     // GIR_Coverage, 4927,
     /* 152067 */     GIR_EraseRootFromParent_Done,
     /* 152068 */   // Label 3009: @152068
     /* 152068 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(152097), // Rule ID 4928 //
     /* 152073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 152078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 152081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152088 */     // (intrinsic_wo_chain:{ *:[v4i16] } 593:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 152088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 152091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152095 */     GIR_RootConstrainSelectedInstOperands,
     /* 152096 */     // GIR_Coverage, 4928,
     /* 152096 */     GIR_EraseRootFromParent_Done,
     /* 152097 */   // Label 3010: @152097
     /* 152097 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(152126), // Rule ID 4929 //
     /* 152102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 152107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 152110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 152113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152117 */     // (intrinsic_wo_chain:{ *:[v8i16] } 593:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 152117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 152120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152124 */     GIR_RootConstrainSelectedInstOperands,
     /* 152125 */     // GIR_Coverage, 4929,
     /* 152125 */     GIR_EraseRootFromParent_Done,
     /* 152126 */   // Label 3011: @152126
     /* 152126 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(152155), // Rule ID 4930 //
     /* 152131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 152136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 152139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 152142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152146 */     // (intrinsic_wo_chain:{ *:[v2i32] } 593:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 152146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 152149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152153 */     GIR_RootConstrainSelectedInstOperands,
     /* 152154 */     // GIR_Coverage, 4930,
     /* 152154 */     GIR_EraseRootFromParent_Done,
     /* 152155 */   // Label 3012: @152155
     /* 152155 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(152184), // Rule ID 4931 //
     /* 152160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 152165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152175 */     // (intrinsic_wo_chain:{ *:[v4i32] } 593:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 152175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 152178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152182 */     GIR_RootConstrainSelectedInstOperands,
     /* 152183 */     // GIR_Coverage, 4931,
     /* 152183 */     GIR_EraseRootFromParent_Done,
     /* 152184 */   // Label 3013: @152184
     /* 152184 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(152213), // Rule ID 4932 //
     /* 152189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 152194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 152197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 152200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152204 */     // (intrinsic_wo_chain:{ *:[v2i64] } 593:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 152204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 152207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 152209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 152211 */     GIR_RootConstrainSelectedInstOperands,
     /* 152212 */     // GIR_Coverage, 4932,
     /* 152212 */     GIR_EraseRootFromParent_Done,
     /* 152213 */   // Label 3014: @152213
     /* 152213 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(152245), // Rule ID 8352 //
     /* 152218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 152221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 152226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 152229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 152232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 152236 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1646:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 152236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 152239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 152241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152243 */     GIR_RootConstrainSelectedInstOperands,
     /* 152244 */     // GIR_Coverage, 8352,
     /* 152244 */     GIR_EraseRootFromParent_Done,
     /* 152245 */   // Label 3015: @152245
     /* 152245 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(152277), // Rule ID 8353 //
     /* 152250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 152253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 152258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 152261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 152264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 152268 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1646:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 152268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 152271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 152273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152275 */     GIR_RootConstrainSelectedInstOperands,
     /* 152276 */     // GIR_Coverage, 8353,
     /* 152276 */     GIR_EraseRootFromParent_Done,
     /* 152277 */   // Label 3016: @152277
     /* 152277 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(152309), // Rule ID 8354 //
     /* 152282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 152285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 152290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 152293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 152296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 152300 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1646:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 152300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 152303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 152305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152307 */     GIR_RootConstrainSelectedInstOperands,
     /* 152308 */     // GIR_Coverage, 8354,
     /* 152308 */     GIR_EraseRootFromParent_Done,
     /* 152309 */   // Label 3017: @152309
     /* 152309 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(152341), // Rule ID 11743 //
     /* 152314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 152317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 152322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 152325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 152328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 152332 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2030:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 152332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
     /* 152335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 152337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152339 */     GIR_RootConstrainSelectedInstOperands,
     /* 152340 */     // GIR_Coverage, 11743,
     /* 152340 */     GIR_EraseRootFromParent_Done,
     /* 152341 */   // Label 3018: @152341
     /* 152341 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(152373), // Rule ID 11744 //
     /* 152346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 152349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 152354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 152357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 152360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 152364 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2030:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 152364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
     /* 152367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 152369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152371 */     GIR_RootConstrainSelectedInstOperands,
     /* 152372 */     // GIR_Coverage, 11744,
     /* 152372 */     GIR_EraseRootFromParent_Done,
     /* 152373 */   // Label 3019: @152373
     /* 152373 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(152405), // Rule ID 11745 //
     /* 152378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 152381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 152386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 152389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 152392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 152396 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2030:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 152396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
     /* 152399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 152401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152403 */     GIR_RootConstrainSelectedInstOperands,
     /* 152404 */     // GIR_Coverage, 11745,
     /* 152404 */     GIR_EraseRootFromParent_Done,
     /* 152405 */   // Label 3020: @152405
     /* 152405 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(152437), // Rule ID 11746 //
     /* 152410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 152413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 152418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 152421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 152424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 152428 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1839:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 152428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
     /* 152431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 152433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152435 */     GIR_RootConstrainSelectedInstOperands,
     /* 152436 */     // GIR_Coverage, 11746,
     /* 152436 */     GIR_EraseRootFromParent_Done,
     /* 152437 */   // Label 3021: @152437
     /* 152437 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(152469), // Rule ID 11747 //
     /* 152442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 152445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 152450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 152453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 152456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 152460 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1839:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 152460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
     /* 152463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 152465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152467 */     GIR_RootConstrainSelectedInstOperands,
     /* 152468 */     // GIR_Coverage, 11747,
     /* 152468 */     GIR_EraseRootFromParent_Done,
     /* 152469 */   // Label 3022: @152469
     /* 152469 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(152501), // Rule ID 11748 //
     /* 152474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 152477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 152482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 152485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 152488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 152492 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1839:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 152492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
     /* 152495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 152497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152499 */     GIR_RootConstrainSelectedInstOperands,
     /* 152500 */     // GIR_Coverage, 11748,
     /* 152500 */     GIR_EraseRootFromParent_Done,
     /* 152501 */   // Label 3023: @152501
     /* 152501 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(152533), // Rule ID 11903 //
     /* 152506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 152509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
     /* 152514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 152517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 152520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 152524 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1246:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 152524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
     /* 152527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 152529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 152531 */     GIR_RootConstrainSelectedInstOperands,
     /* 152532 */     // GIR_Coverage, 11903,
     /* 152532 */     GIR_EraseRootFromParent_Done,
     /* 152533 */   // Label 3024: @152533
     /* 152533 */   GIM_Reject,
     /* 152534 */ // Label 2705: @152534
     /* 152534 */ GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(198845),
     /* 152539 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 152542 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(152726), // Rule ID 2566 //
     /* 152547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 152564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 152592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152596 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 152599 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152608 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 152621 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152625 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152629 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 152633 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152637 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152641 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 152645 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152650 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 152654 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152658 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 152662 */     // MIs[5] Operand 1
     /* 152662 */     // No operand predicates
     /* 152662 */     // MIs[3] Operand 2
     /* 152662 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 152673 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152677 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 152679 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 152679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 152682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152691 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 152697 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152702 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 152710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 152721 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 152724 */     GIR_RootConstrainSelectedInstOperands,
     /* 152725 */     // GIR_Coverage, 2566,
     /* 152725 */     GIR_EraseRootFromParent_Done,
     /* 152726 */   // Label 3026: @152726
     /* 152726 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(152910), // Rule ID 6230 //
     /* 152731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 152739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 152742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 152748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 152756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 152764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 152768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 152772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 152776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152780 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 152783 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152792 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 152805 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152809 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152813 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 152817 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152821 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152825 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 152829 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152834 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 152838 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 152842 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 152846 */     // MIs[5] Operand 1
     /* 152846 */     // No operand predicates
     /* 152846 */     // MIs[3] Operand 2
     /* 152846 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 152857 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 152861 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 152863 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 152863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 152866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 152870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 152875 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 152881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 152886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 152891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 152894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 152896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 152898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 152901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 152905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 152908 */     GIR_RootConstrainSelectedInstOperands,
     /* 152909 */     // GIR_Coverage, 6230,
     /* 152909 */     GIR_EraseRootFromParent_Done,
     /* 152910 */   // Label 3027: @152910
     /* 152910 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(153050), // Rule ID 2057 //
     /* 152915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 152918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 152923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 152926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 152929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 152932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 152940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 152944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 152948 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 152951 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 152956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 152960 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 152964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 152968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 152972 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152976 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 152980 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 152984 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 152988 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 152992 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 152997 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153001 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153005 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153009 */     // MIs[4] Operand 1
     /* 153009 */     // No operand predicates
     /* 153009 */     // MIs[2] Operand 2
     /* 153009 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 153020 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153022 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 153029 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 153032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 153041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153048 */     GIR_RootConstrainSelectedInstOperands,
     /* 153049 */     // GIR_Coverage, 2057,
     /* 153049 */     GIR_EraseRootFromParent_Done,
     /* 153050 */   // Label 3028: @153050
     /* 153050 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(153190), // Rule ID 2064 //
     /* 153055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 153072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153088 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153091 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153096 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153100 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153116 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153120 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153124 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153128 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153132 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153137 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153141 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153145 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153149 */     // MIs[4] Operand 1
     /* 153149 */     // No operand predicates
     /* 153149 */     // MIs[2] Operand 2
     /* 153149 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 153160 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 153169 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
     /* 153172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 153181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153188 */     GIR_RootConstrainSelectedInstOperands,
     /* 153189 */     // GIR_Coverage, 2064,
     /* 153189 */     GIR_EraseRootFromParent_Done,
     /* 153190 */   // Label 3029: @153190
     /* 153190 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(153330), // Rule ID 2060 //
     /* 153195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 153203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 153212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153228 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153231 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153240 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153256 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153260 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153264 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153268 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153272 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153277 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153281 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153285 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153289 */     // MIs[4] Operand 1
     /* 153289 */     // No operand predicates
     /* 153289 */     // MIs[2] Operand 2
     /* 153289 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 153300 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153302 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 153309 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 153312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 153321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153328 */     GIR_RootConstrainSelectedInstOperands,
     /* 153329 */     // GIR_Coverage, 2060,
     /* 153329 */     GIR_EraseRootFromParent_Done,
     /* 153330 */   // Label 3030: @153330
     /* 153330 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(153470), // Rule ID 2067 //
     /* 153335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 153352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153368 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153371 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153380 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153396 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153400 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153404 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153408 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153412 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153417 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153421 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153425 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153429 */     // MIs[4] Operand 1
     /* 153429 */     // No operand predicates
     /* 153429 */     // MIs[2] Operand 2
     /* 153429 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 153440 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153442 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 153449 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
     /* 153452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 153461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153468 */     GIR_RootConstrainSelectedInstOperands,
     /* 153469 */     // GIR_Coverage, 2067,
     /* 153469 */     GIR_EraseRootFromParent_Done,
     /* 153470 */   // Label 3031: @153470
     /* 153470 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(153607), // Rule ID 2055 //
     /* 153475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 153483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 153492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153508 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153511 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153516 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153520 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153541 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153545 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153549 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153553 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153557 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153562 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153566 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153570 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153574 */     // MIs[4] Operand 1
     /* 153574 */     // No operand predicates
     /* 153574 */     // MIs[2] Operand 2
     /* 153574 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 153585 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153587 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 153590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153605 */     GIR_RootConstrainSelectedInstOperands,
     /* 153606 */     // GIR_Coverage, 2055,
     /* 153606 */     GIR_EraseRootFromParent_Done,
     /* 153607 */   // Label 3032: @153607
     /* 153607 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(153744), // Rule ID 2062 //
     /* 153612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 153623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 153626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 153629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153645 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153648 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 153657 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 153661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153678 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153682 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 153686 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 153690 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153694 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 153699 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153703 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153707 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 153711 */     // MIs[4] Operand 1
     /* 153711 */     // No operand predicates
     /* 153711 */     // MIs[2] Operand 2
     /* 153711 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 153722 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153724 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 153727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153742 */     GIR_RootConstrainSelectedInstOperands,
     /* 153743 */     // GIR_Coverage, 2062,
     /* 153743 */     GIR_EraseRootFromParent_Done,
     /* 153744 */   // Label 3033: @153744
     /* 153744 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(153881), // Rule ID 2058 //
     /* 153749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 153757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 153766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153782 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153785 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153794 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153823 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153827 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153831 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153836 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153840 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153844 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153848 */     // MIs[4] Operand 1
     /* 153848 */     // No operand predicates
     /* 153848 */     // MIs[2] Operand 2
     /* 153848 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 153859 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153861 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 153864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 153866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 153868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 153872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 153876 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 153879 */     GIR_RootConstrainSelectedInstOperands,
     /* 153880 */     // GIR_Coverage, 2058,
     /* 153880 */     GIR_EraseRootFromParent_Done,
     /* 153881 */   // Label 3034: @153881
     /* 153881 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(154018), // Rule ID 2065 //
     /* 153886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 153889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 153894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 153897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 153900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 153903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 153915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 153919 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 153922 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 153927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 153931 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 153935 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 153940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 153944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 153948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153952 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 153956 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 153960 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 153964 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 153968 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 153973 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 153977 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 153981 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 153985 */     // MIs[4] Operand 1
     /* 153985 */     // No operand predicates
     /* 153985 */     // MIs[2] Operand 2
     /* 153985 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 153996 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 153998 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 153998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 154001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 154009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 154013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 154016 */     GIR_RootConstrainSelectedInstOperands,
     /* 154017 */     // GIR_Coverage, 2065,
     /* 154017 */     GIR_EraseRootFromParent_Done,
     /* 154018 */   // Label 3035: @154018
     /* 154018 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(154179), // Rule ID 2567 //
     /* 154023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 154031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 154034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 154056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154072 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 154075 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154080 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154084 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154088 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154093 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 154097 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154101 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154105 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 154109 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154114 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 154118 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154122 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154126 */     // MIs[4] Operand 1
     /* 154126 */     // No operand predicates
     /* 154126 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 154130 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 154132 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 154132 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 154135 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154139 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154144 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 154150 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 154155 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 154163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 154174 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 154177 */     GIR_RootConstrainSelectedInstOperands,
     /* 154178 */     // GIR_Coverage, 2567,
     /* 154178 */     GIR_EraseRootFromParent_Done,
     /* 154179 */   // Label 3036: @154179
     /* 154179 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(154340), // Rule ID 6231 //
     /* 154184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 154192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 154195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 154201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 154209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 154217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 154225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154233 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 154236 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154241 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154245 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154249 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154254 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 154258 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154262 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154266 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 154270 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154275 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 154279 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154283 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154287 */     // MIs[4] Operand 1
     /* 154287 */     // No operand predicates
     /* 154287 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 154291 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 154293 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 154293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 154296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 154300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 154305 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 154311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 154316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 154324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 154331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 154335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 154338 */     GIR_RootConstrainSelectedInstOperands,
     /* 154339 */     // GIR_Coverage, 6231,
     /* 154339 */     GIR_EraseRootFromParent_Done,
     /* 154340 */   // Label 3037: @154340
     /* 154340 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(154450), // Rule ID 2085 //
     /* 154345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154366 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154370 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154374 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 154386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 154390 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 154394 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 154399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 154403 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154407 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 154411 */     // MIs[3] Operand 1
     /* 154411 */     // No operand predicates
     /* 154411 */     // MIs[1] Operand 2
     /* 154411 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 154422 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 154424 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154431 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
     /* 154434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 154445 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 154448 */     GIR_RootConstrainSelectedInstOperands,
     /* 154449 */     // GIR_Coverage, 2085,
     /* 154449 */     GIR_EraseRootFromParent_Done,
     /* 154450 */   // Label 3038: @154450
     /* 154450 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(154560), // Rule ID 2088 //
     /* 154455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 154492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 154496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154500 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 154504 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154509 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 154513 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 154517 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 154521 */     // MIs[3] Operand 1
     /* 154521 */     // No operand predicates
     /* 154521 */     // MIs[1] Operand 2
     /* 154521 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 154532 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 154534 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154541 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 154541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
     /* 154544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 154546 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 154555 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 154558 */     GIR_RootConstrainSelectedInstOperands,
     /* 154559 */     // GIR_Coverage, 2088,
     /* 154559 */     GIR_EraseRootFromParent_Done,
     /* 154560 */   // Label 3039: @154560
     /* 154560 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(154649), // Rule ID 1743 //
     /* 154565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 154573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154598 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154601 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154606 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154610 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154616 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154623 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154630 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 154630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 154633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154637 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154642 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 154647 */     GIR_RootConstrainSelectedInstOperands,
     /* 154648 */     // GIR_Coverage, 1743,
     /* 154648 */     GIR_EraseRootFromParent_Done,
     /* 154649 */   // Label 3040: @154649
     /* 154649 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(154738), // Rule ID 1745 //
     /* 154654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 154662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 154668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 154671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154687 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154690 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154699 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154705 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154712 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154719 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 154719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 154722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154726 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 154736 */     GIR_RootConstrainSelectedInstOperands,
     /* 154737 */     // GIR_Coverage, 1745,
     /* 154737 */     GIR_EraseRootFromParent_Done,
     /* 154738 */   // Label 3041: @154738
     /* 154738 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(154827), // Rule ID 1747 //
     /* 154743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 154751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 154754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 154757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 154760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154776 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154779 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 154788 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 154792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154801 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 154808 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 154808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
     /* 154811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154815 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 154825 */     GIR_RootConstrainSelectedInstOperands,
     /* 154826 */     // GIR_Coverage, 1747,
     /* 154826 */     GIR_EraseRootFromParent_Done,
     /* 154827 */   // Label 3042: @154827
     /* 154827 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(154916), // Rule ID 1749 //
     /* 154832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 154835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 154840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 154843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 154846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 154849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 154861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 154865 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 154868 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 154873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154877 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 154883 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154890 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 154897 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 154897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
     /* 154900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 154902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 154904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 154909 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 154914 */     GIR_RootConstrainSelectedInstOperands,
     /* 154915 */     // GIR_Coverage, 1749,
     /* 154915 */     GIR_EraseRootFromParent_Done,
     /* 154916 */   // Label 3043: @154916
     /* 154916 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(155038), // Rule ID 6890 //
     /* 154921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 154926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 154929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 154932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 154935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 154939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 154943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 154951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 154956 */     // MIs[1] Operand 2
     /* 154956 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 154967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 154971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 154975 */     // MIs[2] Rn
     /* 154975 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 154980 */     // MIs[2] Operand 2
     /* 154980 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 154991 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 154993 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 154993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 154996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 155000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155005 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155009 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155020 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 155027 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155037 */     // GIR_Coverage, 6890,
     /* 155037 */     GIR_EraseRootFromParent_Done,
     /* 155038 */   // Label 3044: @155038
     /* 155038 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(155160), // Rule ID 6892 //
     /* 155043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 155048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 155051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155078 */     // MIs[1] Operand 2
     /* 155078 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 155089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 155093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155097 */     // MIs[2] Rn
     /* 155097 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 155102 */     // MIs[2] Operand 2
     /* 155102 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 155113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155115 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /* 155115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 155118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 155122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155127 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155131 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155142 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 155149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155154 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155159 */     // GIR_Coverage, 6892,
     /* 155159 */     GIR_EraseRootFromParent_Done,
     /* 155160 */   // Label 3045: @155160
     /* 155160 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(155282), // Rule ID 6894 //
     /* 155165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 155170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 155173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 155176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 155179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 155195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155200 */     // MIs[1] Operand 2
     /* 155200 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 155211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 155215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155219 */     // MIs[2] Rn
     /* 155219 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 155224 */     // MIs[2] Operand 2
     /* 155224 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 155235 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155237 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /* 155237 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 155240 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 155244 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155249 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155253 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155257 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155264 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 155271 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155276 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155281 */     // GIR_Coverage, 6894,
     /* 155281 */     GIR_EraseRootFromParent_Done,
     /* 155282 */   // Label 3046: @155282
     /* 155282 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(155404), // Rule ID 6896 //
     /* 155287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 155292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 155295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 155298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 155301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155322 */     // MIs[1] Operand 2
     /* 155322 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 155333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 155337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155341 */     // MIs[2] Rn
     /* 155341 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 155346 */     // MIs[2] Operand 2
     /* 155346 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 155357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155359 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
     /* 155359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 155362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 155366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155371 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155375 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155379 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155386 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 155393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155403 */     // GIR_Coverage, 6896,
     /* 155403 */     GIR_EraseRootFromParent_Done,
     /* 155404 */   // Label 3047: @155404
     /* 155404 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(155526), // Rule ID 6898 //
     /* 155409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 155414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 155417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155444 */     // MIs[1] Operand 2
     /* 155444 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 155455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 155459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155463 */     // MIs[2] Rn
     /* 155463 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 155468 */     // MIs[2] Operand 2
     /* 155468 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 155479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155481 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
     /* 155481 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 155484 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 155488 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155493 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155497 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 155501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 155503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155508 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 155515 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155525 */     // GIR_Coverage, 6898,
     /* 155525 */     GIR_EraseRootFromParent_Done,
     /* 155526 */   // Label 3048: @155526
     /* 155526 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(155709), // Rule ID 2565 //
     /* 155531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 155539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155580 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 155583 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155588 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155592 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155601 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155606 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155610 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155612 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 155612 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 155615 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 155619 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 155626 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 155629 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 155633 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155638 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 155641 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 155645 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 155648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155653 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155658 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 155666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155675 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 155681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 155694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155698 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 155704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155707 */     GIR_RootConstrainSelectedInstOperands,
     /* 155708 */     // GIR_Coverage, 2565,
     /* 155708 */     GIR_EraseRootFromParent_Done,
     /* 155709 */   // Label 3049: @155709
     /* 155709 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(155892), // Rule ID 6229 //
     /* 155714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 155717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 155722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 155725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 155731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 155739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 155743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 155747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 155751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 155755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 155763 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 155766 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 155771 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155775 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155779 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155789 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 155793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 155795 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 155795 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 155798 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 155802 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 155809 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 155812 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 155816 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155821 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 155824 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 155828 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 155831 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155836 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 155841 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155846 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 155849 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 155853 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 155858 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 155864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 155869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 155877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 155879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 155881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 155884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 155887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 155890 */     GIR_RootConstrainSelectedInstOperands,
     /* 155891 */     // GIR_Coverage, 6229,
     /* 155891 */     GIR_EraseRootFromParent_Done,
     /* 155892 */   // Label 3050: @155892
     /* 155892 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(155996), // Rule ID 13367 //
     /* 155897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 155900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 155905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 155908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 155911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 155914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 155922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 155926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 155934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 155938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 155942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 155946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 155951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 155955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 155959 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 155963 */     // MIs[3] Operand 1
     /* 155963 */     // No operand predicates
     /* 155963 */     // MIs[1] Operand 2
     /* 155963 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 155974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 155978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 155980 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 155980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 155983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 155985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 155987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 155991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 155994 */     GIR_RootConstrainSelectedInstOperands,
     /* 155995 */     // GIR_Coverage, 13367,
     /* 155995 */     GIR_EraseRootFromParent_Done,
     /* 155996 */   // Label 3051: @155996
     /* 155996 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(156100), // Rule ID 13370 //
     /* 156001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 156012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 156015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 156018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 156030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 156038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 156042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156046 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156059 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156063 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156067 */     // MIs[3] Operand 1
     /* 156067 */     // No operand predicates
     /* 156067 */     // MIs[1] Operand 2
     /* 156067 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 156078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156082 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156084 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 156087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 156091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156098 */     GIR_RootConstrainSelectedInstOperands,
     /* 156099 */     // GIR_Coverage, 13370,
     /* 156099 */     GIR_EraseRootFromParent_Done,
     /* 156100 */   // Label 3052: @156100
     /* 156100 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(156231), // Rule ID 2522 //
     /* 156105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 156108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 156116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 156119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 156122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156138 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156147 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 156151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 156155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156172 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156176 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156180 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156184 */     // MIs[3] Operand 1
     /* 156184 */     // No operand predicates
     /* 156184 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156186 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 156186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 156189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156198 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 156204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 156217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156229 */     GIR_RootConstrainSelectedInstOperands,
     /* 156230 */     // GIR_Coverage, 2522,
     /* 156230 */     GIR_EraseRootFromParent_Done,
     /* 156231 */   // Label 3053: @156231
     /* 156231 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(156362), // Rule ID 2523 //
     /* 156236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156278 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 156282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 156286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156307 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156311 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156315 */     // MIs[3] Operand 1
     /* 156315 */     // No operand predicates
     /* 156315 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156317 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 156317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156329 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 156335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 156348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156360 */     GIR_RootConstrainSelectedInstOperands,
     /* 156361 */     // GIR_Coverage, 2523,
     /* 156361 */     GIR_EraseRootFromParent_Done,
     /* 156362 */   // Label 3054: @156362
     /* 156362 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(156493), // Rule ID 2524 //
     /* 156367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 156400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156409 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 156413 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 156417 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156421 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 156425 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156429 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156434 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156438 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156442 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 156446 */     // MIs[3] Operand 1
     /* 156446 */     // No operand predicates
     /* 156446 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156448 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 156448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 156451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156460 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 156466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 156479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156491 */     GIR_RootConstrainSelectedInstOperands,
     /* 156492 */     // GIR_Coverage, 2524,
     /* 156492 */     GIR_EraseRootFromParent_Done,
     /* 156493 */   // Label 3055: @156493
     /* 156493 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(156624), // Rule ID 13553 //
     /* 156498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 156501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 156509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 156512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 156515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156548 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156552 */     // MIs[2] Operand 1
     /* 156552 */     // No operand predicates
     /* 156552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 156556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156560 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156564 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 156568 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156573 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 156577 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156579 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 156579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 156582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156591 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 156597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 156602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 156610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156622 */     GIR_RootConstrainSelectedInstOperands,
     /* 156623 */     // GIR_Coverage, 13553,
     /* 156623 */     GIR_EraseRootFromParent_Done,
     /* 156624 */   // Label 3056: @156624
     /* 156624 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(156755), // Rule ID 13554 //
     /* 156629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 156640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 156646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156679 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 156683 */     // MIs[2] Operand 1
     /* 156683 */     // No operand predicates
     /* 156683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 156687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156691 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 156695 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 156699 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156704 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 156708 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156710 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 156710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 156713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156722 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 156728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 156733 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 156741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156753 */     GIR_RootConstrainSelectedInstOperands,
     /* 156754 */     // GIR_Coverage, 13554,
     /* 156754 */     GIR_EraseRootFromParent_Done,
     /* 156755 */   // Label 3057: @156755
     /* 156755 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(156886), // Rule ID 13555 //
     /* 156760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 156768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 156771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 156777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 156785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 156793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 156797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 156806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156810 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 156814 */     // MIs[2] Operand 1
     /* 156814 */     // No operand predicates
     /* 156814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 156818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 156822 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 156826 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 156830 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156835 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 156839 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156841 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 156841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 156844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 156848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 156853 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 156859 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 156872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 156874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 156877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 156881 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 156884 */     GIR_RootConstrainSelectedInstOperands,
     /* 156885 */     // GIR_Coverage, 13555,
     /* 156885 */     GIR_EraseRootFromParent_Done,
     /* 156886 */   // Label 3058: @156886
     /* 156886 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(157000), // Rule ID 2056 //
     /* 156891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 156894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 156899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 156902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 156905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 156908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 156916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 156920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 156924 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 156927 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 156932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 156936 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 156940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 156945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 156949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 156953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 156957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 156961 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 156966 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 156970 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 156974 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 156978 */     // MIs[3] Operand 1
     /* 156978 */     // No operand predicates
     /* 156978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 156980 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 156980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 156983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 156985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 156987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 156991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 156995 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 156998 */     GIR_RootConstrainSelectedInstOperands,
     /* 156999 */     // GIR_Coverage, 2056,
     /* 156999 */     GIR_EraseRootFromParent_Done,
     /* 157000 */   // Label 3059: @157000
     /* 157000 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(157114), // Rule ID 2063 //
     /* 157005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 157013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 157016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 157019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 157022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 157038 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 157041 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157050 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 157063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157067 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157071 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157075 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157080 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157084 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157088 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157092 */     // MIs[3] Operand 1
     /* 157092 */     // No operand predicates
     /* 157092 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157094 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 157097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 157105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157112 */     GIR_RootConstrainSelectedInstOperands,
     /* 157113 */     // GIR_Coverage, 2063,
     /* 157113 */     GIR_EraseRootFromParent_Done,
     /* 157114 */   // Label 3060: @157114
     /* 157114 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(157228), // Rule ID 2059 //
     /* 157119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 157127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 157130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 157133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 157136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 157152 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 157155 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157164 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 157177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157198 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157202 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157206 */     // MIs[3] Operand 1
     /* 157206 */     // No operand predicates
     /* 157206 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157208 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 157211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 157219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157226 */     GIR_RootConstrainSelectedInstOperands,
     /* 157227 */     // GIR_Coverage, 2059,
     /* 157227 */     GIR_EraseRootFromParent_Done,
     /* 157228 */   // Label 3061: @157228
     /* 157228 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(157342), // Rule ID 2066 //
     /* 157233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 157241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 157244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 157247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 157250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 157266 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 157269 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 157278 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 157282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 157291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 157295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157303 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157316 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157320 */     // MIs[3] Operand 1
     /* 157320 */     // No operand predicates
     /* 157320 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157322 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 157325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 157333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157340 */     GIR_RootConstrainSelectedInstOperands,
     /* 157341 */     // GIR_Coverage, 2066,
     /* 157341 */     GIR_EraseRootFromParent_Done,
     /* 157342 */   // Label 3062: @157342
     /* 157342 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(157456), // Rule ID 2061 //
     /* 157347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 157355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 157364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 157380 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 157383 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 157388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 157392 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 157396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 157405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157413 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157422 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157426 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157430 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157434 */     // MIs[3] Operand 1
     /* 157434 */     // No operand predicates
     /* 157434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157436 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
     /* 157439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 157447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157454 */     GIR_RootConstrainSelectedInstOperands,
     /* 157455 */     // GIR_Coverage, 2061,
     /* 157455 */     GIR_EraseRootFromParent_Done,
     /* 157456 */   // Label 3063: @157456
     /* 157456 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(157570), // Rule ID 2068 //
     /* 157461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 157469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 157472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 157478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 157494 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 157497 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 157502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 157506 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 157510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 157519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 157523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 157527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157536 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157540 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157544 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 157548 */     // MIs[3] Operand 1
     /* 157548 */     // No operand predicates
     /* 157548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157550 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
     /* 157553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 157555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 157557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 157561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157568 */     GIR_RootConstrainSelectedInstOperands,
     /* 157569 */     // GIR_Coverage, 2068,
     /* 157569 */     GIR_EraseRootFromParent_Done,
     /* 157570 */   // Label 3064: @157570
     /* 157570 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(157674), // Rule ID 1987 //
     /* 157575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 157578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 157586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157628 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157637 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157641 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157645 */     // MIs[3] Operand 1
     /* 157645 */     // No operand predicates
     /* 157645 */     // MIs[1] Operand 2
     /* 157645 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157656 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157658 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 157661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157672 */     GIR_RootConstrainSelectedInstOperands,
     /* 157673 */     // GIR_Coverage, 1987,
     /* 157673 */     GIR_EraseRootFromParent_Done,
     /* 157674 */   // Label 3065: @157674
     /* 157674 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(157778), // Rule ID 2017 //
     /* 157679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 157687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 157690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157737 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157741 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157745 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157749 */     // MIs[3] Operand 1
     /* 157749 */     // No operand predicates
     /* 157749 */     // MIs[1] Operand 2
     /* 157749 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157760 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157762 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 157765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157776 */     GIR_RootConstrainSelectedInstOperands,
     /* 157777 */     // GIR_Coverage, 2017,
     /* 157777 */     GIR_EraseRootFromParent_Done,
     /* 157778 */   // Label 3066: @157778
     /* 157778 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(157882), // Rule ID 2024 //
     /* 157783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 157791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 157794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157828 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157832 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157836 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157841 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157845 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157849 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157853 */     // MIs[3] Operand 1
     /* 157853 */     // No operand predicates
     /* 157853 */     // MIs[1] Operand 2
     /* 157853 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157864 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157866 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 157869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157877 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157880 */     GIR_RootConstrainSelectedInstOperands,
     /* 157881 */     // GIR_Coverage, 2024,
     /* 157881 */     GIR_EraseRootFromParent_Done,
     /* 157882 */   // Label 3067: @157882
     /* 157882 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(157986), // Rule ID 2083 //
     /* 157887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 157895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 157898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 157901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 157904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 157908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 157916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 157920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 157928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 157932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 157936 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 157940 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 157945 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 157949 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 157953 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 157957 */     // MIs[3] Operand 1
     /* 157957 */     // No operand predicates
     /* 157957 */     // MIs[1] Operand 2
     /* 157957 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 157968 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 157970 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 157970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 157973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 157975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 157977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 157981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 157984 */     GIR_RootConstrainSelectedInstOperands,
     /* 157985 */     // GIR_Coverage, 2083,
     /* 157985 */     GIR_EraseRootFromParent_Done,
     /* 157986 */   // Label 3068: @157986
     /* 157986 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(158090), // Rule ID 1990 //
     /* 157991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 157994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 157999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 158002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 158005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 158008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 158024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 158036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158044 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158049 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158053 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158057 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 158061 */     // MIs[3] Operand 1
     /* 158061 */     // No operand predicates
     /* 158061 */     // MIs[1] Operand 2
     /* 158061 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 158072 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158074 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 158077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158088 */     GIR_RootConstrainSelectedInstOperands,
     /* 158089 */     // GIR_Coverage, 1990,
     /* 158089 */     GIR_EraseRootFromParent_Done,
     /* 158090 */   // Label 3069: @158090
     /* 158090 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(158194), // Rule ID 2020 //
     /* 158095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 158103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 158106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 158109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 158112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 158128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158132 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158136 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 158140 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158144 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158148 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158153 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158157 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158161 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 158165 */     // MIs[3] Operand 1
     /* 158165 */     // No operand predicates
     /* 158165 */     // MIs[1] Operand 2
     /* 158165 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 158176 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158178 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 158181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158192 */     GIR_RootConstrainSelectedInstOperands,
     /* 158193 */     // GIR_Coverage, 2020,
     /* 158193 */     GIR_EraseRootFromParent_Done,
     /* 158194 */   // Label 3070: @158194
     /* 158194 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(158298), // Rule ID 2027 //
     /* 158199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 158207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 158210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 158213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 158216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 158232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 158244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158248 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158252 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158261 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158265 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 158269 */     // MIs[3] Operand 1
     /* 158269 */     // No operand predicates
     /* 158269 */     // MIs[1] Operand 2
     /* 158269 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 158280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158282 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 158285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158293 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158296 */     GIR_RootConstrainSelectedInstOperands,
     /* 158297 */     // GIR_Coverage, 2027,
     /* 158297 */     GIR_EraseRootFromParent_Done,
     /* 158298 */   // Label 3071: @158298
     /* 158298 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(158402), // Rule ID 2086 //
     /* 158303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 158314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 158317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 158320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 158336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 158344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 158348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 158356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 158365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158369 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 158373 */     // MIs[3] Operand 1
     /* 158373 */     // No operand predicates
     /* 158373 */     // MIs[1] Operand 2
     /* 158373 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 158384 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 158386 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 158386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 158389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 158393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 158397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 158400 */     GIR_RootConstrainSelectedInstOperands,
     /* 158401 */     // GIR_Coverage, 2086,
     /* 158401 */     GIR_EraseRootFromParent_Done,
     /* 158402 */   // Label 3072: @158402
     /* 158402 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(158459), // Rule ID 1751 //
     /* 158407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 158418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 158421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 158424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 158435 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 158442 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 158442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
     /* 158445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 158452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 158457 */     GIR_RootConstrainSelectedInstOperands,
     /* 158458 */     // GIR_Coverage, 1751,
     /* 158458 */     GIR_EraseRootFromParent_Done,
     /* 158459 */   // Label 3073: @158459
     /* 158459 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(158516), // Rule ID 1753 //
     /* 158464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 158475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 158478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 158481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 158492 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 158499 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 158499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
     /* 158502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 158509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 158514 */     GIR_RootConstrainSelectedInstOperands,
     /* 158515 */     // GIR_Coverage, 1753,
     /* 158515 */     GIR_EraseRootFromParent_Done,
     /* 158516 */   // Label 3074: @158516
     /* 158516 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(158626), // Rule ID 6248 //
     /* 158521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 158526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 158529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 158547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 158551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 158555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158560 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 158571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 158575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 158579 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 158583 */     // MIs[2] Operand 1
     /* 158583 */     // No operand predicates
     /* 158583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 158585 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 158585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 158588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158597 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 158603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 158616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 158624 */     GIR_RootConstrainSelectedInstOperands,
     /* 158625 */     // GIR_Coverage, 6248,
     /* 158625 */     GIR_EraseRootFromParent_Done,
     /* 158626 */   // Label 3075: @158626
     /* 158626 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(158723), // Rule ID 13821 //
     /* 158631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 158634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 158642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 158648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 158664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158673 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158683 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 158683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 158686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158695 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 158701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 158714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 158718 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158721 */     GIR_RootConstrainSelectedInstOperands,
     /* 158722 */     // GIR_Coverage, 13821,
     /* 158722 */     GIR_EraseRootFromParent_Done,
     /* 158723 */   // Label 3076: @158723
     /* 158723 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(158820), // Rule ID 13822 //
     /* 158728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 158731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 158739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 158745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 158761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158770 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158780 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 158780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 158783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158792 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 158798 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158803 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 158811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 158815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158818 */     GIR_RootConstrainSelectedInstOperands,
     /* 158819 */     // GIR_Coverage, 13822,
     /* 158819 */     GIR_EraseRootFromParent_Done,
     /* 158820 */   // Label 3077: @158820
     /* 158820 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(158917), // Rule ID 13823 //
     /* 158825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 158828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 158833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 158836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 158842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 158850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 158854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 158858 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 158862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158867 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 158871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158875 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158877 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 158877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 158880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 158884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 158889 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 158895 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158900 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 158908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 158910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 158912 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 158915 */     GIR_RootConstrainSelectedInstOperands,
     /* 158916 */     // GIR_Coverage, 13823,
     /* 158916 */     GIR_EraseRootFromParent_Done,
     /* 158917 */   // Label 3078: @158917
     /* 158917 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(159000), // Rule ID 1742 //
     /* 158922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 158925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 158930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 158933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 158936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 158939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 158947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 158951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 158955 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 158958 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 158963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 158967 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 158971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 158983 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 158983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 158986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 158988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 158990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 158994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 158998 */     GIR_RootConstrainSelectedInstOperands,
     /* 158999 */     // GIR_Coverage, 1742,
     /* 158999 */     GIR_EraseRootFromParent_Done,
     /* 159000 */   // Label 3079: @159000
     /* 159000 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(159083), // Rule ID 1744 //
     /* 159005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 159013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 159016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 159019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 159022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159038 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159041 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 159046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 159050 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 159054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159059 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159066 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 159066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 159069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 159073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 159077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 159081 */     GIR_RootConstrainSelectedInstOperands,
     /* 159082 */     // GIR_Coverage, 1744,
     /* 159082 */     GIR_EraseRootFromParent_Done,
     /* 159083 */   // Label 3080: @159083
     /* 159083 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(159166), // Rule ID 1746 //
     /* 159088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 159096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 159099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 159102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 159105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159121 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159124 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 159129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159133 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159147 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159149 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 159149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
     /* 159152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 159156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 159160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 159164 */     GIR_RootConstrainSelectedInstOperands,
     /* 159165 */     // GIR_Coverage, 1746,
     /* 159165 */     GIR_EraseRootFromParent_Done,
     /* 159166 */   // Label 3081: @159166
     /* 159166 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(159249), // Rule ID 1748 //
     /* 159171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 159179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 159182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 159185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 159188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159204 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159207 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 159212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 159216 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 159220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159232 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 159232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
     /* 159235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 159239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 159243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 159247 */     GIR_RootConstrainSelectedInstOperands,
     /* 159248 */     // GIR_Coverage, 1748,
     /* 159248 */     GIR_EraseRootFromParent_Done,
     /* 159249 */   // Label 3082: @159249
     /* 159249 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(159329), // Rule ID 5220 //
     /* 159254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 159259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 159268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159276 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159280 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159284 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159287 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 159292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 159296 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 159300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159312 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 159312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
     /* 159315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 159319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 159323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 159327 */     GIR_RootConstrainSelectedInstOperands,
     /* 159328 */     // GIR_Coverage, 5220,
     /* 159328 */     GIR_EraseRootFromParent_Done,
     /* 159329 */   // Label 3083: @159329
     /* 159329 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(159409), // Rule ID 5221 //
     /* 159334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 159339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 159348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 159364 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 159367 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 159372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 159376 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 159380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159392 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 159392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
     /* 159395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 159397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 159399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 159403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 159407 */     GIR_RootConstrainSelectedInstOperands,
     /* 159408 */     // GIR_Coverage, 5221,
     /* 159408 */     GIR_EraseRootFromParent_Done,
     /* 159409 */   // Label 3084: @159409
     /* 159409 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(159506), // Rule ID 5217 //
     /* 159414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 159417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 159425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 159431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159460 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 159464 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159466 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 159466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 159469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159478 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 159484 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 159497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159504 */     GIR_RootConstrainSelectedInstOperands,
     /* 159505 */     // GIR_Coverage, 5217,
     /* 159505 */     GIR_EraseRootFromParent_Done,
     /* 159506 */   // Label 3085: @159506
     /* 159506 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(159603), // Rule ID 5218 //
     /* 159511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 159514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 159522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 159528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159557 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 159561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159563 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 159563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 159566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159575 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 159581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 159594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159598 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159601 */     GIR_RootConstrainSelectedInstOperands,
     /* 159602 */     // GIR_Coverage, 5218,
     /* 159602 */     GIR_EraseRootFromParent_Done,
     /* 159603 */   // Label 3086: @159603
     /* 159603 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(159700), // Rule ID 5219 //
     /* 159608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 159611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 159619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 159625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 159637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 159641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 159645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159654 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 159658 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 159660 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 159660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 159663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 159667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 159672 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 159678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 159691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 159695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 159698 */     GIR_RootConstrainSelectedInstOperands,
     /* 159699 */     // GIR_Coverage, 5219,
     /* 159699 */     GIR_EraseRootFromParent_Done,
     /* 159700 */   // Label 3087: @159700
     /* 159700 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(159781), // Rule ID 13368 //
     /* 159705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 159716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 159719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 159722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159734 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159738 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159755 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159759 */     // MIs[2] Operand 1
     /* 159759 */     // No operand predicates
     /* 159759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159763 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159765 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 159768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159779 */     GIR_RootConstrainSelectedInstOperands,
     /* 159780 */     // GIR_Coverage, 13368,
     /* 159780 */     GIR_EraseRootFromParent_Done,
     /* 159781 */   // Label 3088: @159781
     /* 159781 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(159862), // Rule ID 13369 //
     /* 159786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 159789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 159797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 159800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 159803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 159815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 159819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 159828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159836 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 159840 */     // MIs[2] Operand 1
     /* 159840 */     // No operand predicates
     /* 159840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159846 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 159849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159860 */     GIR_RootConstrainSelectedInstOperands,
     /* 159861 */     // GIR_Coverage, 13369,
     /* 159861 */     GIR_EraseRootFromParent_Done,
     /* 159862 */   // Label 3089: @159862
     /* 159862 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(159943), // Rule ID 13371 //
     /* 159867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 159878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 159881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 159884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 159896 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159900 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159917 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 159921 */     // MIs[2] Operand 1
     /* 159921 */     // No operand predicates
     /* 159921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159925 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 159927 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 159927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 159930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 159932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 159934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 159938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 159941 */     GIR_RootConstrainSelectedInstOperands,
     /* 159942 */     // GIR_Coverage, 13371,
     /* 159942 */     GIR_EraseRootFromParent_Done,
     /* 159943 */   // Label 3090: @159943
     /* 159943 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(160024), // Rule ID 13372 //
     /* 159948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 159951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 159956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 159959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 159962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 159965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 159973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 159977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 159981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 159985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 159990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 159994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 159998 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160002 */     // MIs[2] Operand 1
     /* 160002 */     // No operand predicates
     /* 160002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160008 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 160011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 160015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160019 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160022 */     GIR_RootConstrainSelectedInstOperands,
     /* 160023 */     // GIR_Coverage, 13372,
     /* 160023 */     GIR_EraseRootFromParent_Done,
     /* 160024 */   // Label 3091: @160024
     /* 160024 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(160105), // Rule ID 13373 //
     /* 160029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 160040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 160043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 160046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 160058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 160062 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160066 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160079 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 160083 */     // MIs[2] Operand 1
     /* 160083 */     // No operand predicates
     /* 160083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160089 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 160092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 160096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160100 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160103 */     GIR_RootConstrainSelectedInstOperands,
     /* 160104 */     // GIR_Coverage, 13373,
     /* 160104 */     GIR_EraseRootFromParent_Done,
     /* 160105 */   // Label 3092: @160105
     /* 160105 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(160186), // Rule ID 13374 //
     /* 160110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 160121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 160124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 160127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 160139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160160 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160164 */     // MIs[2] Operand 1
     /* 160164 */     // No operand predicates
     /* 160164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160170 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 160173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 160177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160184 */     GIR_RootConstrainSelectedInstOperands,
     /* 160185 */     // GIR_Coverage, 13374,
     /* 160185 */     GIR_EraseRootFromParent_Done,
     /* 160186 */   // Label 3093: @160186
     /* 160186 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(160267), // Rule ID 13375 //
     /* 160191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 160220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 160224 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160241 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 160245 */     // MIs[2] Operand 1
     /* 160245 */     // No operand predicates
     /* 160245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160251 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 160254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 160258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160265 */     GIR_RootConstrainSelectedInstOperands,
     /* 160266 */     // GIR_Coverage, 13375,
     /* 160266 */     GIR_EraseRootFromParent_Done,
     /* 160267 */   // Label 3094: @160267
     /* 160267 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(160348), // Rule ID 13376 //
     /* 160272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 160289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 160301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 160305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160322 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 160326 */     // MIs[2] Operand 1
     /* 160326 */     // No operand predicates
     /* 160326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160332 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 160335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 160339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160346 */     GIR_RootConstrainSelectedInstOperands,
     /* 160347 */     // GIR_Coverage, 13376,
     /* 160347 */     GIR_EraseRootFromParent_Done,
     /* 160348 */   // Label 3095: @160348
     /* 160348 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(160454), // Rule ID 6245 //
     /* 160353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 160358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 160361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 160367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 160379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 160383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160388 */     // MIs[1] Operand 2
     /* 160388 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 160399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 160403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160407 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 160411 */     // MIs[2] Operand 1
     /* 160411 */     // No operand predicates
     /* 160411 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160413 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 160413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 160416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 160420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160425 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 160431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160436 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 160444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 160452 */     GIR_RootConstrainSelectedInstOperands,
     /* 160453 */     // GIR_Coverage, 6245,
     /* 160453 */     GIR_EraseRootFromParent_Done,
     /* 160454 */   // Label 3096: @160454
     /* 160454 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(160535), // Rule ID 1988 //
     /* 160459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160513 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160517 */     // MIs[2] Operand 1
     /* 160517 */     // No operand predicates
     /* 160517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160519 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 160522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160533 */     GIR_RootConstrainSelectedInstOperands,
     /* 160534 */     // GIR_Coverage, 1988,
     /* 160534 */     GIR_EraseRootFromParent_Done,
     /* 160535 */   // Label 3097: @160535
     /* 160535 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(160616), // Rule ID 1989 //
     /* 160540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 160543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 160548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 160557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160594 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160598 */     // MIs[2] Operand 1
     /* 160598 */     // No operand predicates
     /* 160598 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160600 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 160603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160614 */     GIR_RootConstrainSelectedInstOperands,
     /* 160615 */     // GIR_Coverage, 1989,
     /* 160615 */     GIR_EraseRootFromParent_Done,
     /* 160616 */   // Label 3098: @160616
     /* 160616 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(160697), // Rule ID 2018 //
     /* 160621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 160629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160675 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160679 */     // MIs[2] Operand 1
     /* 160679 */     // No operand predicates
     /* 160679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160681 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 160684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160695 */     GIR_RootConstrainSelectedInstOperands,
     /* 160696 */     // GIR_Coverage, 2018,
     /* 160696 */     GIR_EraseRootFromParent_Done,
     /* 160697 */   // Label 3099: @160697
     /* 160697 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(160778), // Rule ID 2019 //
     /* 160702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 160710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 160719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160748 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160752 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160756 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160760 */     // MIs[2] Operand 1
     /* 160760 */     // No operand predicates
     /* 160760 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160762 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
     /* 160765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160773 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160776 */     GIR_RootConstrainSelectedInstOperands,
     /* 160777 */     // GIR_Coverage, 2019,
     /* 160777 */     GIR_EraseRootFromParent_Done,
     /* 160778 */   // Label 3100: @160778
     /* 160778 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(160859), // Rule ID 2025 //
     /* 160783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 160791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 160794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160837 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160841 */     // MIs[2] Operand 1
     /* 160841 */     // No operand predicates
     /* 160841 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160843 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 160846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160857 */     GIR_RootConstrainSelectedInstOperands,
     /* 160858 */     // GIR_Coverage, 2025,
     /* 160858 */     GIR_EraseRootFromParent_Done,
     /* 160859 */   // Label 3101: @160859
     /* 160859 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(160940), // Rule ID 2026 //
     /* 160864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 160872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 160875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 160878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 160881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160897 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160901 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160918 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 160922 */     // MIs[2] Operand 1
     /* 160922 */     // No operand predicates
     /* 160922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 160924 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 160924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
     /* 160927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 160931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 160935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 160938 */     GIR_RootConstrainSelectedInstOperands,
     /* 160939 */     // GIR_Coverage, 2026,
     /* 160939 */     GIR_EraseRootFromParent_Done,
     /* 160940 */   // Label 3102: @160940
     /* 160940 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(161021), // Rule ID 2084 //
     /* 160945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 160948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 160953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 160962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 160974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 160978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 160986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 160991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 160995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 160999 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 161003 */     // MIs[2] Operand 1
     /* 161003 */     // No operand predicates
     /* 161003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161005 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 161008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161019 */     GIR_RootConstrainSelectedInstOperands,
     /* 161020 */     // GIR_Coverage, 2084,
     /* 161020 */     GIR_EraseRootFromParent_Done,
     /* 161021 */   // Label 3103: @161021
     /* 161021 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(161102), // Rule ID 1991 //
     /* 161026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161040 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 161043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161080 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161084 */     // MIs[2] Operand 1
     /* 161084 */     // No operand predicates
     /* 161084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161086 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 161089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161100 */     GIR_RootConstrainSelectedInstOperands,
     /* 161101 */     // GIR_Coverage, 1991,
     /* 161101 */     GIR_EraseRootFromParent_Done,
     /* 161102 */   // Label 3104: @161102
     /* 161102 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(161183), // Rule ID 1992 //
     /* 161107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161161 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161165 */     // MIs[2] Operand 1
     /* 161165 */     // No operand predicates
     /* 161165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161167 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 161170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161181 */     GIR_RootConstrainSelectedInstOperands,
     /* 161182 */     // GIR_Coverage, 1992,
     /* 161182 */     GIR_EraseRootFromParent_Done,
     /* 161183 */   // Label 3105: @161183
     /* 161183 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(161264), // Rule ID 2021 //
     /* 161188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 161196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 161205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161242 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161246 */     // MIs[2] Operand 1
     /* 161246 */     // No operand predicates
     /* 161246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161248 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 161251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161262 */     GIR_RootConstrainSelectedInstOperands,
     /* 161263 */     // GIR_Coverage, 2021,
     /* 161263 */     GIR_EraseRootFromParent_Done,
     /* 161264 */   // Label 3106: @161264
     /* 161264 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(161345), // Rule ID 2022 //
     /* 161269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 161277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161294 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161298 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161302 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161306 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161323 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161327 */     // MIs[2] Operand 1
     /* 161327 */     // No operand predicates
     /* 161327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161329 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
     /* 161332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161343 */     GIR_RootConstrainSelectedInstOperands,
     /* 161344 */     // GIR_Coverage, 2022,
     /* 161344 */     GIR_EraseRootFromParent_Done,
     /* 161345 */   // Label 3107: @161345
     /* 161345 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(161426), // Rule ID 2028 //
     /* 161350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 161358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 161361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 161367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161404 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161408 */     // MIs[2] Operand 1
     /* 161408 */     // No operand predicates
     /* 161408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161410 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 161413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161421 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161424 */     GIR_RootConstrainSelectedInstOperands,
     /* 161425 */     // GIR_Coverage, 2028,
     /* 161425 */     GIR_EraseRootFromParent_Done,
     /* 161426 */   // Label 3108: @161426
     /* 161426 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(161507), // Rule ID 2029 //
     /* 161431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 161439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 161442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 161445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 161448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161485 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161489 */     // MIs[2] Operand 1
     /* 161489 */     // No operand predicates
     /* 161489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161491 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
     /* 161494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161505 */     GIR_RootConstrainSelectedInstOperands,
     /* 161506 */     // GIR_Coverage, 2029,
     /* 161506 */     GIR_EraseRootFromParent_Done,
     /* 161507 */   // Label 3109: @161507
     /* 161507 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(161588), // Rule ID 2087 //
     /* 161512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 161520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 161526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 161529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 161545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161566 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161570 */     // MIs[2] Operand 1
     /* 161570 */     // No operand predicates
     /* 161570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161572 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 161575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161586 */     GIR_RootConstrainSelectedInstOperands,
     /* 161587 */     // GIR_Coverage, 2087,
     /* 161587 */     GIR_EraseRootFromParent_Done,
     /* 161588 */   // Label 3110: @161588
     /* 161588 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(161669), // Rule ID 1993 //
     /* 161593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 161604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 161607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 161610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 161626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161647 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 161651 */     // MIs[2] Operand 1
     /* 161651 */     // No operand predicates
     /* 161651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161653 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 161656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161667 */     GIR_RootConstrainSelectedInstOperands,
     /* 161668 */     // GIR_Coverage, 1993,
     /* 161668 */     GIR_EraseRootFromParent_Done,
     /* 161669 */   // Label 3111: @161669
     /* 161669 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(161750), // Rule ID 1994 //
     /* 161674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 161677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 161685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 161691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 161711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 161720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161728 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 161732 */     // MIs[2] Operand 1
     /* 161732 */     // No operand predicates
     /* 161732 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161734 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 161737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161745 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161748 */     GIR_RootConstrainSelectedInstOperands,
     /* 161749 */     // GIR_Coverage, 1994,
     /* 161749 */     GIR_EraseRootFromParent_Done,
     /* 161750 */   // Label 3112: @161750
     /* 161750 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(161831), // Rule ID 1995 //
     /* 161755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161809 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161813 */     // MIs[2] Operand 1
     /* 161813 */     // No operand predicates
     /* 161813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161815 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 161818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161826 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161829 */     GIR_RootConstrainSelectedInstOperands,
     /* 161830 */     // GIR_Coverage, 1995,
     /* 161830 */     GIR_EraseRootFromParent_Done,
     /* 161831 */   // Label 3113: @161831
     /* 161831 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(161912), // Rule ID 1996 //
     /* 161836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 161844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 161853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 161873 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161890 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 161894 */     // MIs[2] Operand 1
     /* 161894 */     // No operand predicates
     /* 161894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161896 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 161899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161910 */     GIR_RootConstrainSelectedInstOperands,
     /* 161911 */     // GIR_Coverage, 1996,
     /* 161911 */     GIR_EraseRootFromParent_Done,
     /* 161912 */   // Label 3114: @161912
     /* 161912 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(161993), // Rule ID 2023 //
     /* 161917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 161920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 161925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 161934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 161946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 161950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 161954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 161958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 161963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 161967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 161971 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 161975 */     // MIs[2] Operand 1
     /* 161975 */     // No operand predicates
     /* 161975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 161977 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 161977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
     /* 161980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 161988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 161991 */     GIR_RootConstrainSelectedInstOperands,
     /* 161992 */     // GIR_Coverage, 2023,
     /* 161992 */     GIR_EraseRootFromParent_Done,
     /* 161993 */   // Label 3115: @161993
     /* 161993 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(162074), // Rule ID 2030 //
     /* 161998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 162006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 162031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162052 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 162056 */     // MIs[2] Operand 1
     /* 162056 */     // No operand predicates
     /* 162056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162058 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 162058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
     /* 162061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 162069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162072 */     GIR_RootConstrainSelectedInstOperands,
     /* 162073 */     // GIR_Coverage, 2030,
     /* 162073 */     GIR_EraseRootFromParent_Done,
     /* 162074 */   // Label 3116: @162074
     /* 162074 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(162152), // Rule ID 6232 //
     /* 162079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 162084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 162109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 162113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 162117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 162126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162130 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 162134 */     // MIs[2] Operand 1
     /* 162134 */     // No operand predicates
     /* 162134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 162136 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 162136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
     /* 162139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /* 162147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 162150 */     GIR_RootConstrainSelectedInstOperands,
     /* 162151 */     // GIR_Coverage, 6232,
     /* 162151 */     GIR_EraseRootFromParent_Done,
     /* 162152 */   // Label 3117: @162152
     /* 162152 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(162212), // Rule ID 6306 //
     /* 162157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 162162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 162165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 162168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /* 162183 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 162183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 162186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 162190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162195 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 162198 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 162200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 162203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 162207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 162210 */     GIR_RootConstrainSelectedInstOperands,
     /* 162211 */     // GIR_Coverage, 6306,
     /* 162211 */     GIR_EraseRootFromParent_Done,
     /* 162212 */   // Label 3118: @162212
     /* 162212 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(162272), // Rule ID 6307 //
     /* 162217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 162222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 162225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 162228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /* 162243 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 162243 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 162246 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 162250 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162255 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 162258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 162260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 162263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 162267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 162270 */     GIR_RootConstrainSelectedInstOperands,
     /* 162271 */     // GIR_Coverage, 6307,
     /* 162271 */     GIR_EraseRootFromParent_Done,
     /* 162272 */   // Label 3119: @162272
     /* 162272 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(162332), // Rule ID 6308 //
     /* 162277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 162282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 162285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 162288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 162299 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
     /* 162303 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 162303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 162306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 162310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 162315 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 162318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 162320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 162323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 162327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 162330 */     GIR_RootConstrainSelectedInstOperands,
     /* 162331 */     // GIR_Coverage, 6308,
     /* 162331 */     GIR_EraseRootFromParent_Done,
     /* 162332 */   // Label 3120: @162332
     /* 162332 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(162379), // Rule ID 3885 //
     /* 162337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 162340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 162345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162359 */     // MIs[0] Operand 3
     /* 162359 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 162370 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 162370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 162373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 162377 */     GIR_RootConstrainSelectedInstOperands,
     /* 162378 */     // GIR_Coverage, 3885,
     /* 162378 */     GIR_EraseRootFromParent_Done,
     /* 162379 */   // Label 3121: @162379
     /* 162379 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(162426), // Rule ID 3886 //
     /* 162384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 162387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 162392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162406 */     // MIs[0] Operand 3
     /* 162406 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 162417 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 162417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 162420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 162424 */     GIR_RootConstrainSelectedInstOperands,
     /* 162425 */     // GIR_Coverage, 3886,
     /* 162425 */     GIR_EraseRootFromParent_Done,
     /* 162426 */   // Label 3122: @162426
     /* 162426 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(162473), // Rule ID 3887 //
     /* 162431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 162434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 162439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162453 */     // MIs[0] Operand 3
     /* 162453 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 162464 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 162464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 162467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 162471 */     GIR_RootConstrainSelectedInstOperands,
     /* 162472 */     // GIR_Coverage, 3887,
     /* 162472 */     GIR_EraseRootFromParent_Done,
     /* 162473 */   // Label 3123: @162473
     /* 162473 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(162520), // Rule ID 3888 //
     /* 162478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 162481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 162486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162500 */     // MIs[0] Operand 3
     /* 162500 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 162511 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 162511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 162514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 162518 */     GIR_RootConstrainSelectedInstOperands,
     /* 162519 */     // GIR_Coverage, 3888,
     /* 162519 */     GIR_EraseRootFromParent_Done,
     /* 162520 */   // Label 3124: @162520
     /* 162520 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(162566), // Rule ID 3542 //
     /* 162525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 162528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 162533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 162536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 162539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 162543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162547 */     // MIs[0] Idx
     /* 162547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162550 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
     /* 162555 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1612:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
     /* 162555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 162558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 162560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 162562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 162564 */     GIR_RootConstrainSelectedInstOperands,
     /* 162565 */     // GIR_Coverage, 3542,
     /* 162565 */     GIR_EraseRootFromParent_Done,
     /* 162566 */   // Label 3125: @162566
     /* 162566 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(162612), // Rule ID 3543 //
     /* 162571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 162574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 162579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 162582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 162585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 162589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162593 */     // MIs[0] Idx
     /* 162593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162596 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 162601 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1612:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
     /* 162601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 162604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 162606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 162608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 162610 */     GIR_RootConstrainSelectedInstOperands,
     /* 162611 */     // GIR_Coverage, 3543,
     /* 162611 */     GIR_EraseRootFromParent_Done,
     /* 162612 */   // Label 3126: @162612
     /* 162612 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(162658), // Rule ID 3544 //
     /* 162617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 162620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 162625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 162628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 162631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 162635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162639 */     // MIs[0] Idx
     /* 162639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162642 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 162647 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1612:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
     /* 162647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 162650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 162652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 162654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 162656 */     GIR_RootConstrainSelectedInstOperands,
     /* 162657 */     // GIR_Coverage, 3544,
     /* 162657 */     GIR_EraseRootFromParent_Done,
     /* 162658 */   // Label 3127: @162658
     /* 162658 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(162704), // Rule ID 3545 //
     /* 162663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 162666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 162671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 162674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 162677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 162681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 162685 */     // MIs[0] Idx
     /* 162685 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 162688 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 162693 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1612:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
     /* 162693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 162696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 162698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 162700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 162702 */     GIR_RootConstrainSelectedInstOperands,
     /* 162703 */     // GIR_Coverage, 3545,
     /* 162703 */     GIR_EraseRootFromParent_Done,
     /* 162704 */   // Label 3128: @162704
     /* 162704 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(162760), // Rule ID 2108 //
     /* 162709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
     /* 162717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162742 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162746 */     // MIs[1] Operand 1
     /* 162746 */     // No operand predicates
     /* 162746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162748 */     // (intrinsic_wo_chain:{ *:[i32] } 692:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
     /* 162751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162758 */     GIR_RootConstrainSelectedInstOperands,
     /* 162759 */     // GIR_Coverage, 2108,
     /* 162759 */     GIR_EraseRootFromParent_Done,
     /* 162760 */   // Label 3129: @162760
     /* 162760 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(162816), // Rule ID 2109 //
     /* 162765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
     /* 162773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162798 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162802 */     // MIs[1] Operand 1
     /* 162802 */     // No operand predicates
     /* 162802 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162804 */     // (intrinsic_wo_chain:{ *:[i32] } 693:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
     /* 162807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162814 */     GIR_RootConstrainSelectedInstOperands,
     /* 162815 */     // GIR_Coverage, 2109,
     /* 162815 */     GIR_EraseRootFromParent_Done,
     /* 162816 */   // Label 3130: @162816
     /* 162816 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(162872), // Rule ID 2114 //
     /* 162821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
     /* 162829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162854 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162858 */     // MIs[1] Operand 1
     /* 162858 */     // No operand predicates
     /* 162858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162860 */     // (intrinsic_wo_chain:{ *:[i32] } 696:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
     /* 162863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162870 */     GIR_RootConstrainSelectedInstOperands,
     /* 162871 */     // GIR_Coverage, 2114,
     /* 162871 */     GIR_EraseRootFromParent_Done,
     /* 162872 */   // Label 3131: @162872
     /* 162872 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(162928), // Rule ID 2115 //
     /* 162877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
     /* 162885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162910 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162914 */     // MIs[1] Operand 1
     /* 162914 */     // No operand predicates
     /* 162914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162916 */     // (intrinsic_wo_chain:{ *:[i32] } 697:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
     /* 162919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162923 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162926 */     GIR_RootConstrainSelectedInstOperands,
     /* 162927 */     // GIR_Coverage, 2115,
     /* 162927 */     GIR_EraseRootFromParent_Done,
     /* 162928 */   // Label 3132: @162928
     /* 162928 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(162984), // Rule ID 2121 //
     /* 162933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
     /* 162941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 162950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 162962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 162966 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 162970 */     // MIs[1] Operand 1
     /* 162970 */     // No operand predicates
     /* 162970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 162972 */     // (intrinsic_wo_chain:{ *:[i32] } 741:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 162972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
     /* 162975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 162982 */     GIR_RootConstrainSelectedInstOperands,
     /* 162983 */     // GIR_Coverage, 2121,
     /* 162983 */     GIR_EraseRootFromParent_Done,
     /* 162984 */   // Label 3133: @162984
     /* 162984 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(163040), // Rule ID 2124 //
     /* 162989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 162992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
     /* 162997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163022 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163026 */     // MIs[1] Operand 1
     /* 163026 */     // No operand predicates
     /* 163026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163028 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
     /* 163031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163038 */     GIR_RootConstrainSelectedInstOperands,
     /* 163039 */     // GIR_Coverage, 2124,
     /* 163039 */     GIR_EraseRootFromParent_Done,
     /* 163040 */   // Label 3134: @163040
     /* 163040 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(163096), // Rule ID 2146 //
     /* 163045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 163053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 163056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163078 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 163082 */     // MIs[1] Operand 1
     /* 163082 */     // No operand predicates
     /* 163082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163084 */     // (intrinsic_wo_chain:{ *:[v8i8] } 657:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
     /* 163087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163094 */     GIR_RootConstrainSelectedInstOperands,
     /* 163095 */     // GIR_Coverage, 2146,
     /* 163095 */     GIR_EraseRootFromParent_Done,
     /* 163096 */   // Label 3135: @163096
     /* 163096 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(163152), // Rule ID 2148 //
     /* 163101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 163109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163134 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 163138 */     // MIs[1] Operand 1
     /* 163138 */     // No operand predicates
     /* 163138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163140 */     // (intrinsic_wo_chain:{ *:[v4i16] } 657:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
     /* 163143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163150 */     GIR_RootConstrainSelectedInstOperands,
     /* 163151 */     // GIR_Coverage, 2148,
     /* 163151 */     GIR_EraseRootFromParent_Done,
     /* 163152 */   // Label 3136: @163152
     /* 163152 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(163208), // Rule ID 2150 //
     /* 163157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 163165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 163194 */     // MIs[1] Operand 1
     /* 163194 */     // No operand predicates
     /* 163194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163196 */     // (intrinsic_wo_chain:{ *:[v2i32] } 657:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 163196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
     /* 163199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163206 */     GIR_RootConstrainSelectedInstOperands,
     /* 163207 */     // GIR_Coverage, 2150,
     /* 163207 */     GIR_EraseRootFromParent_Done,
     /* 163208 */   // Label 3137: @163208
     /* 163208 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(163261), // Rule ID 6233 //
     /* 163213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 163218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163243 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163247 */     // MIs[1] Operand 1
     /* 163247 */     // No operand predicates
     /* 163247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163249 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 163249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
     /* 163252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163259 */     GIR_RootConstrainSelectedInstOperands,
     /* 163260 */     // GIR_Coverage, 6233,
     /* 163260 */     GIR_EraseRootFromParent_Done,
     /* 163261 */   // Label 3138: @163261
     /* 163261 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(163314), // Rule ID 6234 //
     /* 163266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 163271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163296 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163300 */     // MIs[1] Operand 1
     /* 163300 */     // No operand predicates
     /* 163300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163302 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 163302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
     /* 163305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163312 */     GIR_RootConstrainSelectedInstOperands,
     /* 163313 */     // GIR_Coverage, 6234,
     /* 163313 */     GIR_EraseRootFromParent_Done,
     /* 163314 */   // Label 3139: @163314
     /* 163314 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(163367), // Rule ID 6235 //
     /* 163319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 163324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163349 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163353 */     // MIs[1] Operand 1
     /* 163353 */     // No operand predicates
     /* 163353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163355 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 163358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163362 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163365 */     GIR_RootConstrainSelectedInstOperands,
     /* 163366 */     // GIR_Coverage, 6235,
     /* 163366 */     GIR_EraseRootFromParent_Done,
     /* 163367 */   // Label 3140: @163367
     /* 163367 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(163420), // Rule ID 6236 //
     /* 163372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 163377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163402 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163406 */     // MIs[1] Operand 1
     /* 163406 */     // No operand predicates
     /* 163406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163408 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 163411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163418 */     GIR_RootConstrainSelectedInstOperands,
     /* 163419 */     // GIR_Coverage, 6236,
     /* 163419 */     GIR_EraseRootFromParent_Done,
     /* 163420 */   // Label 3141: @163420
     /* 163420 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(163473), // Rule ID 6237 //
     /* 163425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 163430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163455 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163459 */     // MIs[1] Operand 1
     /* 163459 */     // No operand predicates
     /* 163459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163461 */     // (intrinsic_wo_chain:{ *:[v1i64] } 762:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 163464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163471 */     GIR_RootConstrainSelectedInstOperands,
     /* 163472 */     // GIR_Coverage, 6237,
     /* 163472 */     GIR_EraseRootFromParent_Done,
     /* 163473 */   // Label 3142: @163473
     /* 163473 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(163526), // Rule ID 6238 //
     /* 163478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 163483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163508 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163512 */     // MIs[1] Operand 1
     /* 163512 */     // No operand predicates
     /* 163512 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163514 */     // (intrinsic_wo_chain:{ *:[v1i64] } 763:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 163517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163524 */     GIR_RootConstrainSelectedInstOperands,
     /* 163525 */     // GIR_Coverage, 6238,
     /* 163525 */     GIR_EraseRootFromParent_Done,
     /* 163526 */   // Label 3143: @163526
     /* 163526 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(163579), // Rule ID 6239 //
     /* 163531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163565 */     // MIs[1] Operand 1
     /* 163565 */     // No operand predicates
     /* 163565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163567 */     // (intrinsic_wo_chain:{ *:[f32] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 163567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
     /* 163570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163577 */     GIR_RootConstrainSelectedInstOperands,
     /* 163578 */     // GIR_Coverage, 6239,
     /* 163578 */     GIR_EraseRootFromParent_Done,
     /* 163579 */   // Label 3144: @163579
     /* 163579 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(163632), // Rule ID 6240 //
     /* 163584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163614 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163618 */     // MIs[1] Operand 1
     /* 163618 */     // No operand predicates
     /* 163618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163620 */     // (intrinsic_wo_chain:{ *:[f64] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 163623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163630 */     GIR_RootConstrainSelectedInstOperands,
     /* 163631 */     // GIR_Coverage, 6240,
     /* 163631 */     GIR_EraseRootFromParent_Done,
     /* 163632 */   // Label 3145: @163632
     /* 163632 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(163685), // Rule ID 6241 //
     /* 163637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163667 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163671 */     // MIs[1] Operand 1
     /* 163671 */     // No operand predicates
     /* 163671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163673 */     // (intrinsic_wo_chain:{ *:[v1f64] } 765:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 163676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163680 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163683 */     GIR_RootConstrainSelectedInstOperands,
     /* 163684 */     // GIR_Coverage, 6241,
     /* 163684 */     GIR_EraseRootFromParent_Done,
     /* 163685 */   // Label 3146: @163685
     /* 163685 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(163738), // Rule ID 6242 //
     /* 163690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163720 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163724 */     // MIs[1] Operand 1
     /* 163724 */     // No operand predicates
     /* 163724 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163726 */     // (intrinsic_wo_chain:{ *:[f64] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 163729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163736 */     GIR_RootConstrainSelectedInstOperands,
     /* 163737 */     // GIR_Coverage, 6242,
     /* 163737 */     GIR_EraseRootFromParent_Done,
     /* 163738 */   // Label 3147: @163738
     /* 163738 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(163791), // Rule ID 6243 //
     /* 163743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 163748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 163777 */     // MIs[1] Operand 1
     /* 163777 */     // No operand predicates
     /* 163777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163779 */     // (intrinsic_wo_chain:{ *:[v1f64] } 766:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 163779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 163782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163789 */     GIR_RootConstrainSelectedInstOperands,
     /* 163790 */     // GIR_Coverage, 6243,
     /* 163790 */     GIR_EraseRootFromParent_Done,
     /* 163791 */   // Label 3148: @163791
     /* 163791 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(163844), // Rule ID 6244 //
     /* 163796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 163804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163826 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 163830 */     // MIs[1] Operand 1
     /* 163830 */     // No operand predicates
     /* 163830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163832 */     // (intrinsic_wo_chain:{ *:[f32] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 163832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
     /* 163835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163842 */     GIR_RootConstrainSelectedInstOperands,
     /* 163843 */     // GIR_Coverage, 6244,
     /* 163843 */     GIR_EraseRootFromParent_Done,
     /* 163844 */   // Label 3149: @163844
     /* 163844 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(163926), // Rule ID 6246 //
     /* 163849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 163857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 163860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163879 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 163883 */     // MIs[1] Operand 1
     /* 163883 */     // No operand predicates
     /* 163883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163885 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 163885 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 163888 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 163892 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163897 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 163903 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163908 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 163913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 163916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 163921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 163924 */     GIR_RootConstrainSelectedInstOperands,
     /* 163925 */     // GIR_Coverage, 6246,
     /* 163925 */     GIR_EraseRootFromParent_Done,
     /* 163926 */   // Label 3150: @163926
     /* 163926 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(164008), // Rule ID 6247 //
     /* 163931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 163936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 163939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 163945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 163957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 163961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 163965 */     // MIs[1] Operand 1
     /* 163965 */     // No operand predicates
     /* 163965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 163967 */     // (intrinsic_wo_chain:{ *:[f16] } 765:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 163967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 163970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 163974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 163979 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 163985 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 163990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 163998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164006 */     GIR_RootConstrainSelectedInstOperands,
     /* 164007 */     // GIR_Coverage, 6247,
     /* 164007 */     GIR_EraseRootFromParent_Done,
     /* 164008 */   // Label 3151: @164008
     /* 164008 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(164090), // Rule ID 6249 //
     /* 164013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 164018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 164021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 164024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164043 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 164047 */     // MIs[1] Operand 1
     /* 164047 */     // No operand predicates
     /* 164047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164049 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 164049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 164052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164061 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 164067 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 164080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164088 */     GIR_RootConstrainSelectedInstOperands,
     /* 164089 */     // GIR_Coverage, 6249,
     /* 164089 */     GIR_EraseRootFromParent_Done,
     /* 164090 */   // Label 3152: @164090
     /* 164090 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(164172), // Rule ID 6250 //
     /* 164095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 164100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 164103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164125 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 164129 */     // MIs[1] Operand 1
     /* 164129 */     // No operand predicates
     /* 164129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164131 */     // (intrinsic_wo_chain:{ *:[f16] } 766:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 164131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 164134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 164138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164143 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 164149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 164162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 164170 */     GIR_RootConstrainSelectedInstOperands,
     /* 164171 */     // GIR_Coverage, 6250,
     /* 164171 */     GIR_EraseRootFromParent_Done,
     /* 164172 */   // Label 3153: @164172
     /* 164172 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(164278), // Rule ID 6251 //
     /* 164177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 164182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 164185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 164188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164207 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 164211 */     // MIs[1] Operand 1
     /* 164211 */     // No operand predicates
     /* 164211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164213 */     // (intrinsic_wo_chain:{ *:[i32] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 164213 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 164216 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 164220 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164225 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 164229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 164232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 164234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 164237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 164241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 164251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164256 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 164259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 164262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164277 */     // GIR_Coverage, 6251,
     /* 164277 */     GIR_EraseRootFromParent_Done,
     /* 164278 */   // Label 3154: @164278
     /* 164278 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(164384), // Rule ID 6252 //
     /* 164283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 164288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 164294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164313 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 164317 */     // MIs[1] Operand 1
     /* 164317 */     // No operand predicates
     /* 164317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164319 */     // (intrinsic_wo_chain:{ *:[i64] } 762:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 164319 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 164322 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 164326 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164331 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 164335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 164338 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 164340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 164343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 164347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164352 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 164357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 164365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 164368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164378 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164383 */     // GIR_Coverage, 6252,
     /* 164383 */     GIR_EraseRootFromParent_Done,
     /* 164384 */   // Label 3155: @164384
     /* 164384 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(164490), // Rule ID 6253 //
     /* 164389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 164394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 164397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 164400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164419 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 164423 */     // MIs[1] Operand 1
     /* 164423 */     // No operand predicates
     /* 164423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164425 */     // (intrinsic_wo_chain:{ *:[i32] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 164425 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 164428 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 164432 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164437 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 164441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 164444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 164446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 164449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 164453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 164463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 164471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 164474 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 164484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164489 */     // GIR_Coverage, 6253,
     /* 164489 */     GIR_EraseRootFromParent_Done,
     /* 164490 */   // Label 3156: @164490
     /* 164490 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(164596), // Rule ID 6254 //
     /* 164495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 164500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 164506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 164509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164525 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 164529 */     // MIs[1] Operand 1
     /* 164529 */     // No operand predicates
     /* 164529 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164531 */     // (intrinsic_wo_chain:{ *:[i64] } 763:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 164531 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 164534 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 164538 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164543 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 164547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 164550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 164552 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 164555 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 164559 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 164564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 164566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 164569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 164571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 164574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 164577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 164580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164590 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 164595 */     // GIR_Coverage, 6254,
     /* 164595 */     GIR_EraseRootFromParent_Done,
     /* 164596 */   // Label 3157: @164596
     /* 164596 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(164651), // Rule ID 6951 //
     /* 164601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 164606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 164609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 164612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 164615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 164623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 164627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 164631 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
     /* 164635 */     // MIs[1] Operand 1
     /* 164635 */     // No operand predicates
     /* 164635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 164637 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (PAUTH_BLEND:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm))
     /* 164637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PAUTH_BLEND),
     /* 164640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[disc]
     /* 164642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 164644 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
     /* 164649 */     GIR_RootConstrainSelectedInstOperands,
     /* 164650 */     // GIR_Coverage, 6951,
     /* 164650 */     GIR_EraseRootFromParent_Done,
     /* 164651 */   // Label 3158: @164651
     /* 164651 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(164693), // Rule ID 3043 //
     /* 164656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 164664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 164670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164674 */     // MIs[0] Op2
     /* 164674 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164677 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 164682 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1850:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 164682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
     /* 164685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164691 */     GIR_RootConstrainSelectedInstOperands,
     /* 164692 */     // GIR_Coverage, 3043,
     /* 164692 */     GIR_EraseRootFromParent_Done,
     /* 164693 */   // Label 3159: @164693
     /* 164693 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(164735), // Rule ID 3044 //
     /* 164698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 164706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164716 */     // MIs[0] Op2
     /* 164716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164719 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 164724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1850:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 164724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
     /* 164727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164733 */     GIR_RootConstrainSelectedInstOperands,
     /* 164734 */     // GIR_Coverage, 3044,
     /* 164734 */     GIR_EraseRootFromParent_Done,
     /* 164735 */   // Label 3160: @164735
     /* 164735 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(164777), // Rule ID 3045 //
     /* 164740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 164748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 164751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164758 */     // MIs[0] Op2
     /* 164758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164761 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 164766 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1850:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 164766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
     /* 164769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164775 */     GIR_RootConstrainSelectedInstOperands,
     /* 164776 */     // GIR_Coverage, 3045,
     /* 164776 */     GIR_EraseRootFromParent_Done,
     /* 164777 */   // Label 3161: @164777
     /* 164777 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(164819), // Rule ID 3079 //
     /* 164782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 164790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164800 */     // MIs[0] Op2
     /* 164800 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164803 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 164808 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1831:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 164808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
     /* 164811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164817 */     GIR_RootConstrainSelectedInstOperands,
     /* 164818 */     // GIR_Coverage, 3079,
     /* 164818 */     GIR_EraseRootFromParent_Done,
     /* 164819 */   // Label 3162: @164819
     /* 164819 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(164861), // Rule ID 3080 //
     /* 164824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164827 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 164832 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 164838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164842 */     // MIs[0] Op2
     /* 164842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164845 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 164850 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1831:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 164850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
     /* 164853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164859 */     GIR_RootConstrainSelectedInstOperands,
     /* 164860 */     // GIR_Coverage, 3080,
     /* 164860 */     GIR_EraseRootFromParent_Done,
     /* 164861 */   // Label 3163: @164861
     /* 164861 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(164903), // Rule ID 3081 //
     /* 164866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 164869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 164874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 164877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 164880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164884 */     // MIs[0] Op2
     /* 164884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164887 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 164892 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1831:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 164892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
     /* 164895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164901 */     GIR_RootConstrainSelectedInstOperands,
     /* 164902 */     // GIR_Coverage, 3081,
     /* 164902 */     GIR_EraseRootFromParent_Done,
     /* 164903 */   // Label 3164: @164903
     /* 164903 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(164945), // Rule ID 3528 //
     /* 164908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 164919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 164922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164926 */     // MIs[0] Op2
     /* 164926 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164929 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 164934 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1331:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
     /* 164934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
     /* 164937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164943 */     GIR_RootConstrainSelectedInstOperands,
     /* 164944 */     // GIR_Coverage, 3528,
     /* 164944 */     GIR_EraseRootFromParent_Done,
     /* 164945 */   // Label 3165: @164945
     /* 164945 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(164987), // Rule ID 3529 //
     /* 164950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 164958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 164961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 164964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 164968 */     // MIs[0] Op2
     /* 164968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 164971 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 164976 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1331:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 164976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 164979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 164981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 164983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 164985 */     GIR_RootConstrainSelectedInstOperands,
     /* 164986 */     // GIR_Coverage, 3529,
     /* 164986 */     GIR_EraseRootFromParent_Done,
     /* 164987 */   // Label 3166: @164987
     /* 164987 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(165029), // Rule ID 3530 //
     /* 164992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 164995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 165000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165010 */     // MIs[0] Op2
     /* 165010 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165013 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 165018 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1331:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 165018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 165021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165027 */     GIR_RootConstrainSelectedInstOperands,
     /* 165028 */     // GIR_Coverage, 3530,
     /* 165028 */     GIR_EraseRootFromParent_Done,
     /* 165029 */   // Label 3167: @165029
     /* 165029 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(165071), // Rule ID 3531 //
     /* 165034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 165037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 165042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 165045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165052 */     // MIs[0] Op2
     /* 165052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165055 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 165060 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1331:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 165060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 165063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165069 */     GIR_RootConstrainSelectedInstOperands,
     /* 165070 */     // GIR_Coverage, 3531,
     /* 165070 */     GIR_EraseRootFromParent_Done,
     /* 165071 */   // Label 3168: @165071
     /* 165071 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(165113), // Rule ID 3532 //
     /* 165076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 165079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 165084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165094 */     // MIs[0] Op2
     /* 165094 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165097 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 165102 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1331:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 165102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 165105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165111 */     GIR_RootConstrainSelectedInstOperands,
     /* 165112 */     // GIR_Coverage, 3532,
     /* 165112 */     GIR_EraseRootFromParent_Done,
     /* 165113 */   // Label 3169: @165113
     /* 165113 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(165155), // Rule ID 3533 //
     /* 165118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 165121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 165126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165136 */     // MIs[0] Op2
     /* 165136 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165139 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 165144 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1331:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 165144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 165147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165153 */     GIR_RootConstrainSelectedInstOperands,
     /* 165154 */     // GIR_Coverage, 3533,
     /* 165154 */     GIR_EraseRootFromParent_Done,
     /* 165155 */   // Label 3170: @165155
     /* 165155 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(165197), // Rule ID 3534 //
     /* 165160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 165163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 165168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 165171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165178 */     // MIs[0] Op2
     /* 165178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165181 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 165186 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1331:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 165186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 165189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165195 */     GIR_RootConstrainSelectedInstOperands,
     /* 165196 */     // GIR_Coverage, 3534,
     /* 165196 */     GIR_EraseRootFromParent_Done,
     /* 165197 */   // Label 3171: @165197
     /* 165197 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(165239), // Rule ID 11680 //
     /* 165202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 165210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165220 */     // MIs[0] Op2
     /* 165220 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165223 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165228 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1825:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
     /* 165231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165237 */     GIR_RootConstrainSelectedInstOperands,
     /* 165238 */     // GIR_Coverage, 11680,
     /* 165238 */     GIR_EraseRootFromParent_Done,
     /* 165239 */   // Label 3172: @165239
     /* 165239 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(165281), // Rule ID 11681 //
     /* 165244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 165252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165262 */     // MIs[0] Op2
     /* 165262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165265 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165270 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1825:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
     /* 165273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165279 */     GIR_RootConstrainSelectedInstOperands,
     /* 165280 */     // GIR_Coverage, 11681,
     /* 165280 */     GIR_EraseRootFromParent_Done,
     /* 165281 */   // Label 3173: @165281
     /* 165281 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(165323), // Rule ID 11682 //
     /* 165286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 165294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165304 */     // MIs[0] Op2
     /* 165304 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165307 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165312 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1825:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
     /* 165315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165321 */     GIR_RootConstrainSelectedInstOperands,
     /* 165322 */     // GIR_Coverage, 11682,
     /* 165322 */     GIR_EraseRootFromParent_Done,
     /* 165323 */   // Label 3174: @165323
     /* 165323 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(165365), // Rule ID 11683 //
     /* 165328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 165336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165346 */     // MIs[0] Op2
     /* 165346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165349 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165354 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1704:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
     /* 165357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165363 */     GIR_RootConstrainSelectedInstOperands,
     /* 165364 */     // GIR_Coverage, 11683,
     /* 165364 */     GIR_EraseRootFromParent_Done,
     /* 165365 */   // Label 3175: @165365
     /* 165365 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(165407), // Rule ID 11684 //
     /* 165370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 165378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165388 */     // MIs[0] Op2
     /* 165388 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165391 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165396 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1704:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
     /* 165399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165405 */     GIR_RootConstrainSelectedInstOperands,
     /* 165406 */     // GIR_Coverage, 11684,
     /* 165406 */     GIR_EraseRootFromParent_Done,
     /* 165407 */   // Label 3176: @165407
     /* 165407 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(165449), // Rule ID 11685 //
     /* 165412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 165420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165430 */     // MIs[0] Op2
     /* 165430 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165433 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165438 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1704:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
     /* 165441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165447 */     GIR_RootConstrainSelectedInstOperands,
     /* 165448 */     // GIR_Coverage, 11685,
     /* 165448 */     GIR_EraseRootFromParent_Done,
     /* 165449 */   // Label 3177: @165449
     /* 165449 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(165491), // Rule ID 11687 //
     /* 165454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 165462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165472 */     // MIs[0] Op2
     /* 165472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165475 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165480 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1662:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
     /* 165483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165489 */     GIR_RootConstrainSelectedInstOperands,
     /* 165490 */     // GIR_Coverage, 11687,
     /* 165490 */     GIR_EraseRootFromParent_Done,
     /* 165491 */   // Label 3178: @165491
     /* 165491 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(165533), // Rule ID 11689 //
     /* 165496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 165504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165514 */     // MIs[0] Op2
     /* 165514 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165517 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165522 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1662:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
     /* 165525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165531 */     GIR_RootConstrainSelectedInstOperands,
     /* 165532 */     // GIR_Coverage, 11689,
     /* 165532 */     GIR_EraseRootFromParent_Done,
     /* 165533 */   // Label 3179: @165533
     /* 165533 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(165575), // Rule ID 11691 //
     /* 165538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 165546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165556 */     // MIs[0] Op2
     /* 165556 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165559 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165564 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1662:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
     /* 165567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165573 */     GIR_RootConstrainSelectedInstOperands,
     /* 165574 */     // GIR_Coverage, 11691,
     /* 165574 */     GIR_EraseRootFromParent_Done,
     /* 165575 */   // Label 3180: @165575
     /* 165575 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(165617), // Rule ID 11692 //
     /* 165580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 165588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165598 */     // MIs[0] Op2
     /* 165598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165601 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165606 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1829:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
     /* 165609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165615 */     GIR_RootConstrainSelectedInstOperands,
     /* 165616 */     // GIR_Coverage, 11692,
     /* 165616 */     GIR_EraseRootFromParent_Done,
     /* 165617 */   // Label 3181: @165617
     /* 165617 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(165659), // Rule ID 11693 //
     /* 165622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 165630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165640 */     // MIs[0] Op2
     /* 165640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165643 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165648 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1829:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
     /* 165651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165657 */     GIR_RootConstrainSelectedInstOperands,
     /* 165658 */     // GIR_Coverage, 11693,
     /* 165658 */     GIR_EraseRootFromParent_Done,
     /* 165659 */   // Label 3182: @165659
     /* 165659 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(165701), // Rule ID 11694 //
     /* 165664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 165672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165682 */     // MIs[0] Op2
     /* 165682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165685 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165690 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1829:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
     /* 165693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165699 */     GIR_RootConstrainSelectedInstOperands,
     /* 165700 */     // GIR_Coverage, 11694,
     /* 165700 */     GIR_EraseRootFromParent_Done,
     /* 165701 */   // Label 3183: @165701
     /* 165701 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(165743), // Rule ID 11695 //
     /* 165706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 165714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165724 */     // MIs[0] Op2
     /* 165724 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165727 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165732 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1819:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
     /* 165735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165741 */     GIR_RootConstrainSelectedInstOperands,
     /* 165742 */     // GIR_Coverage, 11695,
     /* 165742 */     GIR_EraseRootFromParent_Done,
     /* 165743 */   // Label 3184: @165743
     /* 165743 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(165785), // Rule ID 11696 //
     /* 165748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 165756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165766 */     // MIs[0] Op2
     /* 165766 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165769 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165774 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1819:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
     /* 165777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165783 */     GIR_RootConstrainSelectedInstOperands,
     /* 165784 */     // GIR_Coverage, 11696,
     /* 165784 */     GIR_EraseRootFromParent_Done,
     /* 165785 */   // Label 3185: @165785
     /* 165785 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(165827), // Rule ID 11697 //
     /* 165790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 165798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165808 */     // MIs[0] Op2
     /* 165808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165811 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165816 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1819:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
     /* 165819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165825 */     GIR_RootConstrainSelectedInstOperands,
     /* 165826 */     // GIR_Coverage, 11697,
     /* 165826 */     GIR_EraseRootFromParent_Done,
     /* 165827 */   // Label 3186: @165827
     /* 165827 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(165869), // Rule ID 11698 //
     /* 165832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 165840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165850 */     // MIs[0] Op2
     /* 165850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165853 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165858 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2024:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
     /* 165861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165867 */     GIR_RootConstrainSelectedInstOperands,
     /* 165868 */     // GIR_Coverage, 11698,
     /* 165868 */     GIR_EraseRootFromParent_Done,
     /* 165869 */   // Label 3187: @165869
     /* 165869 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(165911), // Rule ID 11699 //
     /* 165874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 165882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 165885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 165888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165892 */     // MIs[0] Op2
     /* 165892 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165895 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 165900 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2024:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 165900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
     /* 165903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165909 */     GIR_RootConstrainSelectedInstOperands,
     /* 165910 */     // GIR_Coverage, 11699,
     /* 165910 */     GIR_EraseRootFromParent_Done,
     /* 165911 */   // Label 3188: @165911
     /* 165911 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(165953), // Rule ID 11700 //
     /* 165916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 165924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 165927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 165930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165934 */     // MIs[0] Op2
     /* 165934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 165942 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2024:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 165942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
     /* 165945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165951 */     GIR_RootConstrainSelectedInstOperands,
     /* 165952 */     // GIR_Coverage, 11700,
     /* 165952 */     GIR_EraseRootFromParent_Done,
     /* 165953 */   // Label 3189: @165953
     /* 165953 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(165995), // Rule ID 11701 //
     /* 165958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 165961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 165966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 165969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 165972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 165976 */     // MIs[0] Op2
     /* 165976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 165979 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 165984 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2021:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 165984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
     /* 165987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 165989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 165991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 165993 */     GIR_RootConstrainSelectedInstOperands,
     /* 165994 */     // GIR_Coverage, 11701,
     /* 165994 */     GIR_EraseRootFromParent_Done,
     /* 165995 */   // Label 3190: @165995
     /* 165995 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(166037), // Rule ID 11702 //
     /* 166000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 166008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166018 */     // MIs[0] Op2
     /* 166018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166021 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 166026 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2021:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 166026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
     /* 166029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166035 */     GIR_RootConstrainSelectedInstOperands,
     /* 166036 */     // GIR_Coverage, 11702,
     /* 166036 */     GIR_EraseRootFromParent_Done,
     /* 166037 */   // Label 3191: @166037
     /* 166037 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(166079), // Rule ID 11703 //
     /* 166042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 166050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 166056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166060 */     // MIs[0] Op2
     /* 166060 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166063 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 166068 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2021:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 166068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
     /* 166071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166077 */     GIR_RootConstrainSelectedInstOperands,
     /* 166078 */     // GIR_Coverage, 11703,
     /* 166078 */     GIR_EraseRootFromParent_Done,
     /* 166079 */   // Label 3192: @166079
     /* 166079 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(166121), // Rule ID 11761 //
     /* 166084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 166092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 166098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166102 */     // MIs[0] Op2
     /* 166102 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166105 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 166110 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1851:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 166110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
     /* 166113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166119 */     GIR_RootConstrainSelectedInstOperands,
     /* 166120 */     // GIR_Coverage, 11761,
     /* 166120 */     GIR_EraseRootFromParent_Done,
     /* 166121 */   // Label 3193: @166121
     /* 166121 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(166163), // Rule ID 11762 //
     /* 166126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 166134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 166140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166144 */     // MIs[0] Op2
     /* 166144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166147 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 166152 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1851:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 166152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
     /* 166155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166161 */     GIR_RootConstrainSelectedInstOperands,
     /* 166162 */     // GIR_Coverage, 11762,
     /* 166162 */     GIR_EraseRootFromParent_Done,
     /* 166163 */   // Label 3194: @166163
     /* 166163 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(166205), // Rule ID 11763 //
     /* 166168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 166176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 166179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166186 */     // MIs[0] Op2
     /* 166186 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166189 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 166194 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1851:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 166194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
     /* 166197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166203 */     GIR_RootConstrainSelectedInstOperands,
     /* 166204 */     // GIR_Coverage, 11763,
     /* 166204 */     GIR_EraseRootFromParent_Done,
     /* 166205 */   // Label 3195: @166205
     /* 166205 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(166247), // Rule ID 11764 //
     /* 166210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 166218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 166224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166228 */     // MIs[0] Op2
     /* 166228 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166231 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 166236 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2044:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 166236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
     /* 166239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166245 */     GIR_RootConstrainSelectedInstOperands,
     /* 166246 */     // GIR_Coverage, 11764,
     /* 166246 */     GIR_EraseRootFromParent_Done,
     /* 166247 */   // Label 3196: @166247
     /* 166247 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(166289), // Rule ID 11765 //
     /* 166252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 166260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 166266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166270 */     // MIs[0] Op2
     /* 166270 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166273 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 166278 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2044:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 166278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
     /* 166281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166287 */     GIR_RootConstrainSelectedInstOperands,
     /* 166288 */     // GIR_Coverage, 11765,
     /* 166288 */     GIR_EraseRootFromParent_Done,
     /* 166289 */   // Label 3197: @166289
     /* 166289 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(166331), // Rule ID 11766 //
     /* 166294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 166302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 166305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166312 */     // MIs[0] Op2
     /* 166312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166315 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 166320 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2044:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 166320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
     /* 166323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166329 */     GIR_RootConstrainSelectedInstOperands,
     /* 166330 */     // GIR_Coverage, 11766,
     /* 166330 */     GIR_EraseRootFromParent_Done,
     /* 166331 */   // Label 3198: @166331
     /* 166331 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(166373), // Rule ID 11767 //
     /* 166336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 166344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 166347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 166350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166354 */     // MIs[0] Op2
     /* 166354 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166357 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 166362 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2045:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 166362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
     /* 166365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166371 */     GIR_RootConstrainSelectedInstOperands,
     /* 166372 */     // GIR_Coverage, 11767,
     /* 166372 */     GIR_EraseRootFromParent_Done,
     /* 166373 */   // Label 3199: @166373
     /* 166373 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(166415), // Rule ID 11768 //
     /* 166378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 166386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 166389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 166392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166396 */     // MIs[0] Op2
     /* 166396 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166399 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 166404 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2045:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 166404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
     /* 166407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166413 */     GIR_RootConstrainSelectedInstOperands,
     /* 166414 */     // GIR_Coverage, 11768,
     /* 166414 */     GIR_EraseRootFromParent_Done,
     /* 166415 */   // Label 3200: @166415
     /* 166415 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(166457), // Rule ID 11769 //
     /* 166420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 166423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 166428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 166431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 166434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 166438 */     // MIs[0] Op2
     /* 166438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 166441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 166446 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2045:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 166446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
     /* 166449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 166451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 166453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 166455 */     GIR_RootConstrainSelectedInstOperands,
     /* 166456 */     // GIR_Coverage, 11769,
     /* 166456 */     GIR_EraseRootFromParent_Done,
     /* 166457 */   // Label 3201: @166457
     /* 166457 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(166509), // Rule ID 2130 //
     /* 166462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166495 */     // MIs[1] Operand 1
     /* 166495 */     // No operand predicates
     /* 166495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166497 */     // (intrinsic_wo_chain:{ *:[v4i16] } 762:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
     /* 166500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166507 */     GIR_RootConstrainSelectedInstOperands,
     /* 166508 */     // GIR_Coverage, 2130,
     /* 166508 */     GIR_EraseRootFromParent_Done,
     /* 166509 */   // Label 3202: @166509
     /* 166509 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(166561), // Rule ID 2131 //
     /* 166514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166547 */     // MIs[1] Operand 1
     /* 166547 */     // No operand predicates
     /* 166547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166549 */     // (intrinsic_wo_chain:{ *:[v8i16] } 762:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
     /* 166552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166556 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166559 */     GIR_RootConstrainSelectedInstOperands,
     /* 166560 */     // GIR_Coverage, 2131,
     /* 166560 */     GIR_EraseRootFromParent_Done,
     /* 166561 */   // Label 3203: @166561
     /* 166561 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(166613), // Rule ID 2132 //
     /* 166566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166599 */     // MIs[1] Operand 1
     /* 166599 */     // No operand predicates
     /* 166599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166601 */     // (intrinsic_wo_chain:{ *:[v2i32] } 762:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
     /* 166604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166611 */     GIR_RootConstrainSelectedInstOperands,
     /* 166612 */     // GIR_Coverage, 2132,
     /* 166612 */     GIR_EraseRootFromParent_Done,
     /* 166613 */   // Label 3204: @166613
     /* 166613 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(166665), // Rule ID 2133 //
     /* 166618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166651 */     // MIs[1] Operand 1
     /* 166651 */     // No operand predicates
     /* 166651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166653 */     // (intrinsic_wo_chain:{ *:[v4i32] } 762:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
     /* 166656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166663 */     GIR_RootConstrainSelectedInstOperands,
     /* 166664 */     // GIR_Coverage, 2133,
     /* 166664 */     GIR_EraseRootFromParent_Done,
     /* 166665 */   // Label 3205: @166665
     /* 166665 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(166717), // Rule ID 2134 //
     /* 166670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 166678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166703 */     // MIs[1] Operand 1
     /* 166703 */     // No operand predicates
     /* 166703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166705 */     // (intrinsic_wo_chain:{ *:[v2i64] } 762:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
     /* 166708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166715 */     GIR_RootConstrainSelectedInstOperands,
     /* 166716 */     // GIR_Coverage, 2134,
     /* 166716 */     GIR_EraseRootFromParent_Done,
     /* 166717 */   // Label 3206: @166717
     /* 166717 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(166769), // Rule ID 2135 //
     /* 166722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166755 */     // MIs[1] Operand 1
     /* 166755 */     // No operand predicates
     /* 166755 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166757 */     // (intrinsic_wo_chain:{ *:[v4i16] } 763:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
     /* 166760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166767 */     GIR_RootConstrainSelectedInstOperands,
     /* 166768 */     // GIR_Coverage, 2135,
     /* 166768 */     GIR_EraseRootFromParent_Done,
     /* 166769 */   // Label 3207: @166769
     /* 166769 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(166821), // Rule ID 2136 //
     /* 166774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166807 */     // MIs[1] Operand 1
     /* 166807 */     // No operand predicates
     /* 166807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166809 */     // (intrinsic_wo_chain:{ *:[v8i16] } 763:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
     /* 166812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166816 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166819 */     GIR_RootConstrainSelectedInstOperands,
     /* 166820 */     // GIR_Coverage, 2136,
     /* 166820 */     GIR_EraseRootFromParent_Done,
     /* 166821 */   // Label 3208: @166821
     /* 166821 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(166873), // Rule ID 2137 //
     /* 166826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166859 */     // MIs[1] Operand 1
     /* 166859 */     // No operand predicates
     /* 166859 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166861 */     // (intrinsic_wo_chain:{ *:[v2i32] } 763:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
     /* 166864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166871 */     GIR_RootConstrainSelectedInstOperands,
     /* 166872 */     // GIR_Coverage, 2137,
     /* 166872 */     GIR_EraseRootFromParent_Done,
     /* 166873 */   // Label 3209: @166873
     /* 166873 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(166925), // Rule ID 2138 //
     /* 166878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166911 */     // MIs[1] Operand 1
     /* 166911 */     // No operand predicates
     /* 166911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166913 */     // (intrinsic_wo_chain:{ *:[v4i32] } 763:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
     /* 166916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166923 */     GIR_RootConstrainSelectedInstOperands,
     /* 166924 */     // GIR_Coverage, 2138,
     /* 166924 */     GIR_EraseRootFromParent_Done,
     /* 166925 */   // Label 3210: @166925
     /* 166925 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(166977), // Rule ID 2139 //
     /* 166930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 166938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 166959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 166963 */     // MIs[1] Operand 1
     /* 166963 */     // No operand predicates
     /* 166963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 166965 */     // (intrinsic_wo_chain:{ *:[v2i64] } 763:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 166965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
     /* 166968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 166975 */     GIR_RootConstrainSelectedInstOperands,
     /* 166976 */     // GIR_Coverage, 2139,
     /* 166976 */     GIR_EraseRootFromParent_Done,
     /* 166977 */   // Label 3211: @166977
     /* 166977 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(167029), // Rule ID 2140 //
     /* 166982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 166990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 166999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167015 */     // MIs[1] Operand 1
     /* 167015 */     // No operand predicates
     /* 167015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167017 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
     /* 167020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167027 */     GIR_RootConstrainSelectedInstOperands,
     /* 167028 */     // GIR_Coverage, 2140,
     /* 167028 */     GIR_EraseRootFromParent_Done,
     /* 167029 */   // Label 3212: @167029
     /* 167029 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(167081), // Rule ID 2141 //
     /* 167034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 167042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167067 */     // MIs[1] Operand 1
     /* 167067 */     // No operand predicates
     /* 167067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167069 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
     /* 167072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167076 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167079 */     GIR_RootConstrainSelectedInstOperands,
     /* 167080 */     // GIR_Coverage, 2141,
     /* 167080 */     GIR_EraseRootFromParent_Done,
     /* 167081 */   // Label 3213: @167081
     /* 167081 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(167133), // Rule ID 2142 //
     /* 167086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 167094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167119 */     // MIs[1] Operand 1
     /* 167119 */     // No operand predicates
     /* 167119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167121 */     // (intrinsic_wo_chain:{ *:[v2f32] } 765:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
     /* 167124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167128 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167131 */     GIR_RootConstrainSelectedInstOperands,
     /* 167132 */     // GIR_Coverage, 2142,
     /* 167132 */     GIR_EraseRootFromParent_Done,
     /* 167133 */   // Label 3214: @167133
     /* 167133 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(167185), // Rule ID 2143 //
     /* 167138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 167146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167171 */     // MIs[1] Operand 1
     /* 167171 */     // No operand predicates
     /* 167171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167173 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
     /* 167176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167180 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167183 */     GIR_RootConstrainSelectedInstOperands,
     /* 167184 */     // GIR_Coverage, 2143,
     /* 167184 */     GIR_EraseRootFromParent_Done,
     /* 167185 */   // Label 3215: @167185
     /* 167185 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(167237), // Rule ID 2144 //
     /* 167190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 167198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167223 */     // MIs[1] Operand 1
     /* 167223 */     // No operand predicates
     /* 167223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167225 */     // (intrinsic_wo_chain:{ *:[v2f64] } 765:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
     /* 167228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167235 */     GIR_RootConstrainSelectedInstOperands,
     /* 167236 */     // GIR_Coverage, 2144,
     /* 167236 */     GIR_EraseRootFromParent_Done,
     /* 167237 */   // Label 3216: @167237
     /* 167237 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(167289), // Rule ID 2242 //
     /* 167242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 167250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 167253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167275 */     // MIs[1] Operand 1
     /* 167275 */     // No operand predicates
     /* 167275 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167277 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
     /* 167280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167287 */     GIR_RootConstrainSelectedInstOperands,
     /* 167288 */     // GIR_Coverage, 2242,
     /* 167288 */     GIR_EraseRootFromParent_Done,
     /* 167289 */   // Label 3217: @167289
     /* 167289 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(167341), // Rule ID 2243 //
     /* 167294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 167302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 167305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167327 */     // MIs[1] Operand 1
     /* 167327 */     // No operand predicates
     /* 167327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167329 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
     /* 167332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167339 */     GIR_RootConstrainSelectedInstOperands,
     /* 167340 */     // GIR_Coverage, 2243,
     /* 167340 */     GIR_EraseRootFromParent_Done,
     /* 167341 */   // Label 3218: @167341
     /* 167341 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(167393), // Rule ID 2244 //
     /* 167346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 167354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 167357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 167360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167379 */     // MIs[1] Operand 1
     /* 167379 */     // No operand predicates
     /* 167379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167381 */     // (intrinsic_wo_chain:{ *:[v2f32] } 766:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
     /* 167384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167391 */     GIR_RootConstrainSelectedInstOperands,
     /* 167392 */     // GIR_Coverage, 2244,
     /* 167392 */     GIR_EraseRootFromParent_Done,
     /* 167393 */   // Label 3219: @167393
     /* 167393 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(167445), // Rule ID 2245 //
     /* 167398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 167406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 167409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167431 */     // MIs[1] Operand 1
     /* 167431 */     // No operand predicates
     /* 167431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167433 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
     /* 167436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167443 */     GIR_RootConstrainSelectedInstOperands,
     /* 167444 */     // GIR_Coverage, 2245,
     /* 167444 */     GIR_EraseRootFromParent_Done,
     /* 167445 */   // Label 3220: @167445
     /* 167445 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(167497), // Rule ID 2246 //
     /* 167450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 167458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 167461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 167464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 167479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 167483 */     // MIs[1] Operand 1
     /* 167483 */     // No operand predicates
     /* 167483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 167485 */     // (intrinsic_wo_chain:{ *:[v2f64] } 766:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 167485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
     /* 167488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167492 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 167495 */     GIR_RootConstrainSelectedInstOperands,
     /* 167496 */     // GIR_Coverage, 2246,
     /* 167496 */     GIR_EraseRootFromParent_Done,
     /* 167497 */   // Label 3221: @167497
     /* 167497 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(167542), // Rule ID 63 //
     /* 167502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 167505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
     /* 167510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 167519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 167531 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 167531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
     /* 167534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167540 */     GIR_RootConstrainSelectedInstOperands,
     /* 167541 */     // GIR_Coverage, 63,
     /* 167541 */     GIR_EraseRootFromParent_Done,
     /* 167542 */   // Label 3222: @167542
     /* 167542 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(167587), // Rule ID 129 //
     /* 167547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
     /* 167555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167576 */     // (intrinsic_wo_chain:{ *:[i32] } 503:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
     /* 167579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167585 */     GIR_RootConstrainSelectedInstOperands,
     /* 167586 */     // GIR_Coverage, 129,
     /* 167586 */     GIR_EraseRootFromParent_Done,
     /* 167587 */   // Label 3223: @167587
     /* 167587 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(167632), // Rule ID 130 //
     /* 167592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
     /* 167600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167621 */     // (intrinsic_wo_chain:{ *:[i32] } 508:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
     /* 167624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167630 */     GIR_RootConstrainSelectedInstOperands,
     /* 167631 */     // GIR_Coverage, 130,
     /* 167631 */     GIR_EraseRootFromParent_Done,
     /* 167632 */   // Label 3224: @167632
     /* 167632 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(167677), // Rule ID 131 //
     /* 167637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
     /* 167645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167666 */     // (intrinsic_wo_chain:{ *:[i32] } 509:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
     /* 167669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167675 */     GIR_RootConstrainSelectedInstOperands,
     /* 167676 */     // GIR_Coverage, 131,
     /* 167676 */     GIR_EraseRootFromParent_Done,
     /* 167677 */   // Label 3225: @167677
     /* 167677 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(167722), // Rule ID 132 //
     /* 167682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
     /* 167690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 167699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167711 */     // (intrinsic_wo_chain:{ *:[i32] } 510:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 167711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
     /* 167714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167720 */     GIR_RootConstrainSelectedInstOperands,
     /* 167721 */     // GIR_Coverage, 132,
     /* 167721 */     GIR_EraseRootFromParent_Done,
     /* 167722 */   // Label 3226: @167722
     /* 167722 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(167767), // Rule ID 133 //
     /* 167727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
     /* 167735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167756 */     // (intrinsic_wo_chain:{ *:[i32] } 504:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
     /* 167759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167765 */     GIR_RootConstrainSelectedInstOperands,
     /* 167766 */     // GIR_Coverage, 133,
     /* 167766 */     GIR_EraseRootFromParent_Done,
     /* 167767 */   // Label 3227: @167767
     /* 167767 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(167812), // Rule ID 134 //
     /* 167772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
     /* 167780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167801 */     // (intrinsic_wo_chain:{ *:[i32] } 505:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
     /* 167804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167810 */     GIR_RootConstrainSelectedInstOperands,
     /* 167811 */     // GIR_Coverage, 134,
     /* 167811 */     GIR_EraseRootFromParent_Done,
     /* 167812 */   // Label 3228: @167812
     /* 167812 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(167857), // Rule ID 135 //
     /* 167817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
     /* 167825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 167834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167846 */     // (intrinsic_wo_chain:{ *:[i32] } 506:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 167846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
     /* 167849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167855 */     GIR_RootConstrainSelectedInstOperands,
     /* 167856 */     // GIR_Coverage, 135,
     /* 167856 */     GIR_EraseRootFromParent_Done,
     /* 167857 */   // Label 3229: @167857
     /* 167857 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(167902), // Rule ID 136 //
     /* 167862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 167865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
     /* 167870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 167879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167891 */     // (intrinsic_wo_chain:{ *:[i32] } 507:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 167891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
     /* 167894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 167900 */     GIR_RootConstrainSelectedInstOperands,
     /* 167901 */     // GIR_Coverage, 136,
     /* 167901 */     GIR_EraseRootFromParent_Done,
     /* 167902 */   // Label 3230: @167902
     /* 167902 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(167947), // Rule ID 1042 //
     /* 167907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 167918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 167921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 167924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167936 */     // (intrinsic_wo_chain:{ *:[v8i8] } 715:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 167936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
     /* 167939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167945 */     GIR_RootConstrainSelectedInstOperands,
     /* 167946 */     // GIR_Coverage, 1042,
     /* 167946 */     GIR_EraseRootFromParent_Done,
     /* 167947 */   // Label 3231: @167947
     /* 167947 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(167992), // Rule ID 1043 //
     /* 167952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 167960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 167969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167981 */     // (intrinsic_wo_chain:{ *:[v16i8] } 715:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 167981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
     /* 167984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 167988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 167990 */     GIR_RootConstrainSelectedInstOperands,
     /* 167991 */     // GIR_Coverage, 1043,
     /* 167991 */     GIR_EraseRootFromParent_Done,
     /* 167992 */   // Label 3232: @167992
     /* 167992 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(168037), // Rule ID 1044 //
     /* 167997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 168005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168026 */     // (intrinsic_wo_chain:{ *:[v4i16] } 715:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 168026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
     /* 168029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168035 */     GIR_RootConstrainSelectedInstOperands,
     /* 168036 */     // GIR_Coverage, 1044,
     /* 168036 */     GIR_EraseRootFromParent_Done,
     /* 168037 */   // Label 3233: @168037
     /* 168037 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(168082), // Rule ID 1045 //
     /* 168042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 168050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168071 */     // (intrinsic_wo_chain:{ *:[v8i16] } 715:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 168071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
     /* 168074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168080 */     GIR_RootConstrainSelectedInstOperands,
     /* 168081 */     // GIR_Coverage, 1045,
     /* 168081 */     GIR_EraseRootFromParent_Done,
     /* 168082 */   // Label 3234: @168082
     /* 168082 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(168127), // Rule ID 1046 //
     /* 168087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 168095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168116 */     // (intrinsic_wo_chain:{ *:[v2i32] } 715:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 168116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
     /* 168119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168125 */     GIR_RootConstrainSelectedInstOperands,
     /* 168126 */     // GIR_Coverage, 1046,
     /* 168126 */     GIR_EraseRootFromParent_Done,
     /* 168127 */   // Label 3235: @168127
     /* 168127 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(168172), // Rule ID 1047 //
     /* 168132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 168140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168161 */     // (intrinsic_wo_chain:{ *:[v4i32] } 715:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 168161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
     /* 168164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168170 */     GIR_RootConstrainSelectedInstOperands,
     /* 168171 */     // GIR_Coverage, 1047,
     /* 168171 */     GIR_EraseRootFromParent_Done,
     /* 168172 */   // Label 3236: @168172
     /* 168172 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(168217), // Rule ID 1048 //
     /* 168177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 168185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168206 */     // (intrinsic_wo_chain:{ *:[v2i64] } 715:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 168206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
     /* 168209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168215 */     GIR_RootConstrainSelectedInstOperands,
     /* 168216 */     // GIR_Coverage, 1048,
     /* 168216 */     GIR_EraseRootFromParent_Done,
     /* 168217 */   // Label 3237: @168217
     /* 168217 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(168262), // Rule ID 1090 //
     /* 168222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 168230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168251 */     // (intrinsic_wo_chain:{ *:[v8i8] } 754:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 168251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
     /* 168254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168260 */     GIR_RootConstrainSelectedInstOperands,
     /* 168261 */     // GIR_Coverage, 1090,
     /* 168261 */     GIR_EraseRootFromParent_Done,
     /* 168262 */   // Label 3238: @168262
     /* 168262 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(168307), // Rule ID 1091 //
     /* 168267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 168275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168296 */     // (intrinsic_wo_chain:{ *:[v16i8] } 754:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 168296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
     /* 168299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168305 */     GIR_RootConstrainSelectedInstOperands,
     /* 168306 */     // GIR_Coverage, 1091,
     /* 168306 */     GIR_EraseRootFromParent_Done,
     /* 168307 */   // Label 3239: @168307
     /* 168307 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(168352), // Rule ID 1092 //
     /* 168312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 168320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168341 */     // (intrinsic_wo_chain:{ *:[v4i16] } 754:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 168341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
     /* 168344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168350 */     GIR_RootConstrainSelectedInstOperands,
     /* 168351 */     // GIR_Coverage, 1092,
     /* 168351 */     GIR_EraseRootFromParent_Done,
     /* 168352 */   // Label 3240: @168352
     /* 168352 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(168397), // Rule ID 1093 //
     /* 168357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 168365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168386 */     // (intrinsic_wo_chain:{ *:[v8i16] } 754:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 168386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
     /* 168389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168395 */     GIR_RootConstrainSelectedInstOperands,
     /* 168396 */     // GIR_Coverage, 1093,
     /* 168396 */     GIR_EraseRootFromParent_Done,
     /* 168397 */   // Label 3241: @168397
     /* 168397 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(168442), // Rule ID 1094 //
     /* 168402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 168410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168431 */     // (intrinsic_wo_chain:{ *:[v2i32] } 754:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 168431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
     /* 168434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168440 */     GIR_RootConstrainSelectedInstOperands,
     /* 168441 */     // GIR_Coverage, 1094,
     /* 168441 */     GIR_EraseRootFromParent_Done,
     /* 168442 */   // Label 3242: @168442
     /* 168442 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(168487), // Rule ID 1095 //
     /* 168447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 168455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168476 */     // (intrinsic_wo_chain:{ *:[v4i32] } 754:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 168476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
     /* 168479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168485 */     GIR_RootConstrainSelectedInstOperands,
     /* 168486 */     // GIR_Coverage, 1095,
     /* 168486 */     GIR_EraseRootFromParent_Done,
     /* 168487 */   // Label 3243: @168487
     /* 168487 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(168532), // Rule ID 1096 //
     /* 168492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 168500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168521 */     // (intrinsic_wo_chain:{ *:[v2i64] } 754:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 168521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
     /* 168524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 168526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 168528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 168530 */     GIR_RootConstrainSelectedInstOperands,
     /* 168531 */     // GIR_Coverage, 1096,
     /* 168531 */     GIR_EraseRootFromParent_Done,
     /* 168532 */   // Label 3244: @168532
     /* 168532 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(168577), // Rule ID 1108 //
     /* 168537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 168548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 168551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 168554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168566 */     // (intrinsic_wo_chain:{ *:[v8i8] } 570:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 168566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
     /* 168569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168575 */     GIR_RootConstrainSelectedInstOperands,
     /* 168576 */     // GIR_Coverage, 1108,
     /* 168576 */     GIR_EraseRootFromParent_Done,
     /* 168577 */   // Label 3245: @168577
     /* 168577 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(168622), // Rule ID 1110 //
     /* 168582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 168593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 168596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 168599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168611 */     // (intrinsic_wo_chain:{ *:[v16i8] } 570:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 168611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 168614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168620 */     GIR_RootConstrainSelectedInstOperands,
     /* 168621 */     // GIR_Coverage, 1110,
     /* 168621 */     GIR_EraseRootFromParent_Done,
     /* 168622 */   // Label 3246: @168622
     /* 168622 */   GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(168667), // Rule ID 1112 //
     /* 168627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168656 */     // (intrinsic_wo_chain:{ *:[v4i16] } 570:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 168656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
     /* 168659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168665 */     GIR_RootConstrainSelectedInstOperands,
     /* 168666 */     // GIR_Coverage, 1112,
     /* 168666 */     GIR_EraseRootFromParent_Done,
     /* 168667 */   // Label 3247: @168667
     /* 168667 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(168712), // Rule ID 1114 //
     /* 168672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168701 */     // (intrinsic_wo_chain:{ *:[v8i16] } 570:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 168701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 168704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168710 */     GIR_RootConstrainSelectedInstOperands,
     /* 168711 */     // GIR_Coverage, 1114,
     /* 168711 */     GIR_EraseRootFromParent_Done,
     /* 168712 */   // Label 3248: @168712
     /* 168712 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(168757), // Rule ID 1116 //
     /* 168717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168746 */     // (intrinsic_wo_chain:{ *:[v2i32] } 570:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 168746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 168749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168755 */     GIR_RootConstrainSelectedInstOperands,
     /* 168756 */     // GIR_Coverage, 1116,
     /* 168756 */     GIR_EraseRootFromParent_Done,
     /* 168757 */   // Label 3249: @168757
     /* 168757 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(168802), // Rule ID 1118 //
     /* 168762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 168779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168791 */     // (intrinsic_wo_chain:{ *:[v4i32] } 570:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 168791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 168794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168800 */     GIR_RootConstrainSelectedInstOperands,
     /* 168801 */     // GIR_Coverage, 1118,
     /* 168801 */     GIR_EraseRootFromParent_Done,
     /* 168802 */   // Label 3250: @168802
     /* 168802 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(168847), // Rule ID 1120 //
     /* 168807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 168815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 168818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 168821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 168824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168836 */     // (intrinsic_wo_chain:{ *:[v2i64] } 570:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 168836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /* 168839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168845 */     GIR_RootConstrainSelectedInstOperands,
     /* 168846 */     // GIR_Coverage, 1120,
     /* 168846 */     GIR_EraseRootFromParent_Done,
     /* 168847 */   // Label 3251: @168847
     /* 168847 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(168892), // Rule ID 1163 //
     /* 168852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 168860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 168869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168881 */     // (intrinsic_wo_chain:{ *:[v4f16] } 576:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 168881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 168884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168890 */     GIR_RootConstrainSelectedInstOperands,
     /* 168891 */     // GIR_Coverage, 1163,
     /* 168891 */     GIR_EraseRootFromParent_Done,
     /* 168892 */   // Label 3252: @168892
     /* 168892 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(168937), // Rule ID 1164 //
     /* 168897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 168900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 168905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 168908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 168911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 168914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168926 */     // (intrinsic_wo_chain:{ *:[v8f16] } 576:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 168926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 168929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168935 */     GIR_RootConstrainSelectedInstOperands,
     /* 168936 */     // GIR_Coverage, 1164,
     /* 168936 */     GIR_EraseRootFromParent_Done,
     /* 168937 */   // Label 3253: @168937
     /* 168937 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(168982), // Rule ID 1165 //
     /* 168942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 168950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 168953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 168959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168971 */     // (intrinsic_wo_chain:{ *:[v2f32] } 576:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 168971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 168974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 168980 */     GIR_RootConstrainSelectedInstOperands,
     /* 168981 */     // GIR_Coverage, 1165,
     /* 168981 */     GIR_EraseRootFromParent_Done,
     /* 168982 */   // Label 3254: @168982
     /* 168982 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(169027), // Rule ID 1166 //
     /* 168987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 168995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169016 */     // (intrinsic_wo_chain:{ *:[v4f32] } 576:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 169019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169025 */     GIR_RootConstrainSelectedInstOperands,
     /* 169026 */     // GIR_Coverage, 1166,
     /* 169026 */     GIR_EraseRootFromParent_Done,
     /* 169027 */   // Label 3255: @169027
     /* 169027 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(169072), // Rule ID 1167 //
     /* 169032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 169040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169061 */     // (intrinsic_wo_chain:{ *:[v2f64] } 576:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 169064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169070 */     GIR_RootConstrainSelectedInstOperands,
     /* 169071 */     // GIR_Coverage, 1167,
     /* 169071 */     GIR_EraseRootFromParent_Done,
     /* 169072 */   // Label 3256: @169072
     /* 169072 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(169117), // Rule ID 1169 //
     /* 169077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 169085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169106 */     // (intrinsic_wo_chain:{ *:[v4i16] } 577:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 169109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169115 */     GIR_RootConstrainSelectedInstOperands,
     /* 169116 */     // GIR_Coverage, 1169,
     /* 169116 */     GIR_EraseRootFromParent_Done,
     /* 169117 */   // Label 3257: @169117
     /* 169117 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(169162), // Rule ID 1171 //
     /* 169122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 169130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169151 */     // (intrinsic_wo_chain:{ *:[v8i16] } 577:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 169154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169160 */     GIR_RootConstrainSelectedInstOperands,
     /* 169161 */     // GIR_Coverage, 1171,
     /* 169161 */     GIR_EraseRootFromParent_Done,
     /* 169162 */   // Label 3258: @169162
     /* 169162 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(169207), // Rule ID 1173 //
     /* 169167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 169175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169196 */     // (intrinsic_wo_chain:{ *:[v2i32] } 577:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 169199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169205 */     GIR_RootConstrainSelectedInstOperands,
     /* 169206 */     // GIR_Coverage, 1173,
     /* 169206 */     GIR_EraseRootFromParent_Done,
     /* 169207 */   // Label 3259: @169207
     /* 169207 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(169252), // Rule ID 1175 //
     /* 169212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 169220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169241 */     // (intrinsic_wo_chain:{ *:[v4i32] } 577:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 169244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169250 */     GIR_RootConstrainSelectedInstOperands,
     /* 169251 */     // GIR_Coverage, 1175,
     /* 169251 */     GIR_EraseRootFromParent_Done,
     /* 169252 */   // Label 3260: @169252
     /* 169252 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(169297), // Rule ID 1177 //
     /* 169257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 169265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169286 */     // (intrinsic_wo_chain:{ *:[v2i64] } 577:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 169289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169295 */     GIR_RootConstrainSelectedInstOperands,
     /* 169296 */     // GIR_Coverage, 1177,
     /* 169296 */     GIR_EraseRootFromParent_Done,
     /* 169297 */   // Label 3261: @169297
     /* 169297 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(169342), // Rule ID 1179 //
     /* 169302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 169310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169331 */     // (intrinsic_wo_chain:{ *:[v4i16] } 578:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 169334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169340 */     GIR_RootConstrainSelectedInstOperands,
     /* 169341 */     // GIR_Coverage, 1179,
     /* 169341 */     GIR_EraseRootFromParent_Done,
     /* 169342 */   // Label 3262: @169342
     /* 169342 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(169387), // Rule ID 1181 //
     /* 169347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 169355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169376 */     // (intrinsic_wo_chain:{ *:[v8i16] } 578:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 169379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169385 */     GIR_RootConstrainSelectedInstOperands,
     /* 169386 */     // GIR_Coverage, 1181,
     /* 169386 */     GIR_EraseRootFromParent_Done,
     /* 169387 */   // Label 3263: @169387
     /* 169387 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(169432), // Rule ID 1183 //
     /* 169392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 169400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169421 */     // (intrinsic_wo_chain:{ *:[v2i32] } 578:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 169424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169430 */     GIR_RootConstrainSelectedInstOperands,
     /* 169431 */     // GIR_Coverage, 1183,
     /* 169431 */     GIR_EraseRootFromParent_Done,
     /* 169432 */   // Label 3264: @169432
     /* 169432 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(169477), // Rule ID 1185 //
     /* 169437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 169445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169466 */     // (intrinsic_wo_chain:{ *:[v4i32] } 578:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 169469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169475 */     GIR_RootConstrainSelectedInstOperands,
     /* 169476 */     // GIR_Coverage, 1185,
     /* 169476 */     GIR_EraseRootFromParent_Done,
     /* 169477 */   // Label 3265: @169477
     /* 169477 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(169522), // Rule ID 1187 //
     /* 169482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 169490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169511 */     // (intrinsic_wo_chain:{ *:[v2i64] } 578:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 169514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169520 */     GIR_RootConstrainSelectedInstOperands,
     /* 169521 */     // GIR_Coverage, 1187,
     /* 169521 */     GIR_EraseRootFromParent_Done,
     /* 169522 */   // Label 3266: @169522
     /* 169522 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(169567), // Rule ID 1189 //
     /* 169527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169556 */     // (intrinsic_wo_chain:{ *:[v4f16] } 579:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 169559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169565 */     GIR_RootConstrainSelectedInstOperands,
     /* 169566 */     // GIR_Coverage, 1189,
     /* 169566 */     GIR_EraseRootFromParent_Done,
     /* 169567 */   // Label 3267: @169567
     /* 169567 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(169612), // Rule ID 1191 //
     /* 169572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169601 */     // (intrinsic_wo_chain:{ *:[v8f16] } 579:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 169604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169610 */     GIR_RootConstrainSelectedInstOperands,
     /* 169611 */     // GIR_Coverage, 1191,
     /* 169611 */     GIR_EraseRootFromParent_Done,
     /* 169612 */   // Label 3268: @169612
     /* 169612 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(169657), // Rule ID 1193 //
     /* 169617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169646 */     // (intrinsic_wo_chain:{ *:[v2f32] } 579:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
     /* 169649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169655 */     GIR_RootConstrainSelectedInstOperands,
     /* 169656 */     // GIR_Coverage, 1193,
     /* 169656 */     GIR_EraseRootFromParent_Done,
     /* 169657 */   // Label 3269: @169657
     /* 169657 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(169702), // Rule ID 1195 //
     /* 169662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169691 */     // (intrinsic_wo_chain:{ *:[v4f32] } 579:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 169694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169700 */     GIR_RootConstrainSelectedInstOperands,
     /* 169701 */     // GIR_Coverage, 1195,
     /* 169701 */     GIR_EraseRootFromParent_Done,
     /* 169702 */   // Label 3270: @169702
     /* 169702 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(169747), // Rule ID 1197 //
     /* 169707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 169715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169736 */     // (intrinsic_wo_chain:{ *:[v2f64] } 579:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 169739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169745 */     GIR_RootConstrainSelectedInstOperands,
     /* 169746 */     // GIR_Coverage, 1197,
     /* 169746 */     GIR_EraseRootFromParent_Done,
     /* 169747 */   // Label 3271: @169747
     /* 169747 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(169792), // Rule ID 1233 //
     /* 169752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 169760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169781 */     // (intrinsic_wo_chain:{ *:[v4f16] } 596:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 169781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
     /* 169784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169790 */     GIR_RootConstrainSelectedInstOperands,
     /* 169791 */     // GIR_Coverage, 1233,
     /* 169791 */     GIR_EraseRootFromParent_Done,
     /* 169792 */   // Label 3272: @169792
     /* 169792 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(169837), // Rule ID 1234 //
     /* 169797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 169805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 169808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 169814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169826 */     // (intrinsic_wo_chain:{ *:[v8f16] } 596:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 169826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
     /* 169829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169835 */     GIR_RootConstrainSelectedInstOperands,
     /* 169836 */     // GIR_Coverage, 1234,
     /* 169836 */     GIR_EraseRootFromParent_Done,
     /* 169837 */   // Label 3273: @169837
     /* 169837 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(169882), // Rule ID 1235 //
     /* 169842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 169850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 169853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 169859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169871 */     // (intrinsic_wo_chain:{ *:[v2f32] } 596:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 169871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
     /* 169874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169880 */     GIR_RootConstrainSelectedInstOperands,
     /* 169881 */     // GIR_Coverage, 1235,
     /* 169881 */     GIR_EraseRootFromParent_Done,
     /* 169882 */   // Label 3274: @169882
     /* 169882 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(169927), // Rule ID 1236 //
     /* 169887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 169895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 169898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 169904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169916 */     // (intrinsic_wo_chain:{ *:[v4f32] } 596:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 169916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
     /* 169919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169925 */     GIR_RootConstrainSelectedInstOperands,
     /* 169926 */     // GIR_Coverage, 1236,
     /* 169926 */     GIR_EraseRootFromParent_Done,
     /* 169927 */   // Label 3275: @169927
     /* 169927 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(169972), // Rule ID 1237 //
     /* 169932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 169935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 169940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 169943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 169949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169961 */     // (intrinsic_wo_chain:{ *:[v2f64] } 596:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 169961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
     /* 169964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 169970 */     GIR_RootConstrainSelectedInstOperands,
     /* 169971 */     // GIR_Coverage, 1237,
     /* 169971 */     GIR_EraseRootFromParent_Done,
     /* 169972 */   // Label 3276: @169972
     /* 169972 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(170017), // Rule ID 1248 //
     /* 169977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 169980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 169985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 169988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 169994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170006 */     // (intrinsic_wo_chain:{ *:[v4f16] } 598:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
     /* 170009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170015 */     GIR_RootConstrainSelectedInstOperands,
     /* 170016 */     // GIR_Coverage, 1248,
     /* 170016 */     GIR_EraseRootFromParent_Done,
     /* 170017 */   // Label 3277: @170017
     /* 170017 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(170062), // Rule ID 1249 //
     /* 170022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 170030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170051 */     // (intrinsic_wo_chain:{ *:[v8f16] } 598:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
     /* 170054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170060 */     GIR_RootConstrainSelectedInstOperands,
     /* 170061 */     // GIR_Coverage, 1249,
     /* 170061 */     GIR_EraseRootFromParent_Done,
     /* 170062 */   // Label 3278: @170062
     /* 170062 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(170107), // Rule ID 1250 //
     /* 170067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 170075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170096 */     // (intrinsic_wo_chain:{ *:[v2f32] } 598:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
     /* 170099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170105 */     GIR_RootConstrainSelectedInstOperands,
     /* 170106 */     // GIR_Coverage, 1250,
     /* 170106 */     GIR_EraseRootFromParent_Done,
     /* 170107 */   // Label 3279: @170107
     /* 170107 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(170152), // Rule ID 1251 //
     /* 170112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 170120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170141 */     // (intrinsic_wo_chain:{ *:[v4f32] } 598:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
     /* 170144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170150 */     GIR_RootConstrainSelectedInstOperands,
     /* 170151 */     // GIR_Coverage, 1251,
     /* 170151 */     GIR_EraseRootFromParent_Done,
     /* 170152 */   // Label 3280: @170152
     /* 170152 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(170197), // Rule ID 1252 //
     /* 170157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 170165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170186 */     // (intrinsic_wo_chain:{ *:[v2f64] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
     /* 170189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170195 */     GIR_RootConstrainSelectedInstOperands,
     /* 170196 */     // GIR_Coverage, 1252,
     /* 170196 */     GIR_EraseRootFromParent_Done,
     /* 170197 */   // Label 3281: @170197
     /* 170197 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(170242), // Rule ID 1263 //
     /* 170202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 170210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170231 */     // (intrinsic_wo_chain:{ *:[v4f16] } 602:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
     /* 170234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170240 */     GIR_RootConstrainSelectedInstOperands,
     /* 170241 */     // GIR_Coverage, 1263,
     /* 170241 */     GIR_EraseRootFromParent_Done,
     /* 170242 */   // Label 3282: @170242
     /* 170242 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(170287), // Rule ID 1264 //
     /* 170247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 170255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170276 */     // (intrinsic_wo_chain:{ *:[v8f16] } 602:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
     /* 170279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170285 */     GIR_RootConstrainSelectedInstOperands,
     /* 170286 */     // GIR_Coverage, 1264,
     /* 170286 */     GIR_EraseRootFromParent_Done,
     /* 170287 */   // Label 3283: @170287
     /* 170287 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(170332), // Rule ID 1265 //
     /* 170292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 170300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170321 */     // (intrinsic_wo_chain:{ *:[v2f32] } 602:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
     /* 170324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170330 */     GIR_RootConstrainSelectedInstOperands,
     /* 170331 */     // GIR_Coverage, 1265,
     /* 170331 */     GIR_EraseRootFromParent_Done,
     /* 170332 */   // Label 3284: @170332
     /* 170332 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(170377), // Rule ID 1266 //
     /* 170337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 170345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170366 */     // (intrinsic_wo_chain:{ *:[v4f32] } 602:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
     /* 170369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170375 */     GIR_RootConstrainSelectedInstOperands,
     /* 170376 */     // GIR_Coverage, 1266,
     /* 170376 */     GIR_EraseRootFromParent_Done,
     /* 170377 */   // Label 3285: @170377
     /* 170377 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(170422), // Rule ID 1267 //
     /* 170382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 170390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170411 */     // (intrinsic_wo_chain:{ *:[v2f64] } 602:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
     /* 170414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170420 */     GIR_RootConstrainSelectedInstOperands,
     /* 170421 */     // GIR_Coverage, 1267,
     /* 170421 */     GIR_EraseRootFromParent_Done,
     /* 170422 */   // Label 3286: @170422
     /* 170422 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(170467), // Rule ID 1278 //
     /* 170427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 170435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170456 */     // (intrinsic_wo_chain:{ *:[v4f16] } 604:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
     /* 170459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170465 */     GIR_RootConstrainSelectedInstOperands,
     /* 170466 */     // GIR_Coverage, 1278,
     /* 170466 */     GIR_EraseRootFromParent_Done,
     /* 170467 */   // Label 3287: @170467
     /* 170467 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(170512), // Rule ID 1279 //
     /* 170472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 170480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170501 */     // (intrinsic_wo_chain:{ *:[v8f16] } 604:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
     /* 170504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170510 */     GIR_RootConstrainSelectedInstOperands,
     /* 170511 */     // GIR_Coverage, 1279,
     /* 170511 */     GIR_EraseRootFromParent_Done,
     /* 170512 */   // Label 3288: @170512
     /* 170512 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(170557), // Rule ID 1280 //
     /* 170517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 170525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170546 */     // (intrinsic_wo_chain:{ *:[v2f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
     /* 170549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170555 */     GIR_RootConstrainSelectedInstOperands,
     /* 170556 */     // GIR_Coverage, 1280,
     /* 170556 */     GIR_EraseRootFromParent_Done,
     /* 170557 */   // Label 3289: @170557
     /* 170557 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(170602), // Rule ID 1281 //
     /* 170562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 170570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170591 */     // (intrinsic_wo_chain:{ *:[v4f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
     /* 170594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170600 */     GIR_RootConstrainSelectedInstOperands,
     /* 170601 */     // GIR_Coverage, 1281,
     /* 170601 */     GIR_EraseRootFromParent_Done,
     /* 170602 */   // Label 3290: @170602
     /* 170602 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(170647), // Rule ID 1282 //
     /* 170607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 170615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170636 */     // (intrinsic_wo_chain:{ *:[v2f64] } 604:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
     /* 170639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170645 */     GIR_RootConstrainSelectedInstOperands,
     /* 170646 */     // GIR_Coverage, 1282,
     /* 170646 */     GIR_EraseRootFromParent_Done,
     /* 170647 */   // Label 3291: @170647
     /* 170647 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(170692), // Rule ID 1313 //
     /* 170652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 170660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170681 */     // (intrinsic_wo_chain:{ *:[v4f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
     /* 170684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170690 */     GIR_RootConstrainSelectedInstOperands,
     /* 170691 */     // GIR_Coverage, 1313,
     /* 170691 */     GIR_EraseRootFromParent_Done,
     /* 170692 */   // Label 3292: @170692
     /* 170692 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(170737), // Rule ID 1314 //
     /* 170697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 170705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170726 */     // (intrinsic_wo_chain:{ *:[v8f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
     /* 170729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170735 */     GIR_RootConstrainSelectedInstOperands,
     /* 170736 */     // GIR_Coverage, 1314,
     /* 170736 */     GIR_EraseRootFromParent_Done,
     /* 170737 */   // Label 3293: @170737
     /* 170737 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(170782), // Rule ID 1315 //
     /* 170742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 170750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170771 */     // (intrinsic_wo_chain:{ *:[v2f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
     /* 170774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170780 */     GIR_RootConstrainSelectedInstOperands,
     /* 170781 */     // GIR_Coverage, 1315,
     /* 170781 */     GIR_EraseRootFromParent_Done,
     /* 170782 */   // Label 3294: @170782
     /* 170782 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(170827), // Rule ID 1316 //
     /* 170787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 170795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 170798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 170804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170816 */     // (intrinsic_wo_chain:{ *:[v4f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 170816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
     /* 170819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170825 */     GIR_RootConstrainSelectedInstOperands,
     /* 170826 */     // GIR_Coverage, 1316,
     /* 170826 */     GIR_EraseRootFromParent_Done,
     /* 170827 */   // Label 3295: @170827
     /* 170827 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(170872), // Rule ID 1317 //
     /* 170832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 170840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 170843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 170849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170861 */     // (intrinsic_wo_chain:{ *:[v2f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 170861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
     /* 170864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170870 */     GIR_RootConstrainSelectedInstOperands,
     /* 170871 */     // GIR_Coverage, 1317,
     /* 170871 */     GIR_EraseRootFromParent_Done,
     /* 170872 */   // Label 3296: @170872
     /* 170872 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(170917), // Rule ID 1328 //
     /* 170877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 170885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 170888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 170894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170906 */     // (intrinsic_wo_chain:{ *:[v4f16] } 633:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 170906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
     /* 170909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170915 */     GIR_RootConstrainSelectedInstOperands,
     /* 170916 */     // GIR_Coverage, 1328,
     /* 170916 */     GIR_EraseRootFromParent_Done,
     /* 170917 */   // Label 3297: @170917
     /* 170917 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(170962), // Rule ID 1329 //
     /* 170922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 170925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 170930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 170933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 170939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170951 */     // (intrinsic_wo_chain:{ *:[v8f16] } 633:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 170951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
     /* 170954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 170960 */     GIR_RootConstrainSelectedInstOperands,
     /* 170961 */     // GIR_Coverage, 1329,
     /* 170961 */     GIR_EraseRootFromParent_Done,
     /* 170962 */   // Label 3298: @170962
     /* 170962 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(171007), // Rule ID 1330 //
     /* 170967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 170970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 170975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 170978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 170984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170996 */     // (intrinsic_wo_chain:{ *:[v2f32] } 633:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 170996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
     /* 170999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171005 */     GIR_RootConstrainSelectedInstOperands,
     /* 171006 */     // GIR_Coverage, 1330,
     /* 171006 */     GIR_EraseRootFromParent_Done,
     /* 171007 */   // Label 3299: @171007
     /* 171007 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(171052), // Rule ID 1331 //
     /* 171012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 171020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171041 */     // (intrinsic_wo_chain:{ *:[v4f32] } 633:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 171041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
     /* 171044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171050 */     GIR_RootConstrainSelectedInstOperands,
     /* 171051 */     // GIR_Coverage, 1331,
     /* 171051 */     GIR_EraseRootFromParent_Done,
     /* 171052 */   // Label 3300: @171052
     /* 171052 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(171097), // Rule ID 1332 //
     /* 171057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 171065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 171074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171086 */     // (intrinsic_wo_chain:{ *:[v2f64] } 633:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 171086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
     /* 171089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171095 */     GIR_RootConstrainSelectedInstOperands,
     /* 171096 */     // GIR_Coverage, 1332,
     /* 171096 */     GIR_EraseRootFromParent_Done,
     /* 171097 */   // Label 3301: @171097
     /* 171097 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(171142), // Rule ID 1333 //
     /* 171102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 171110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171131 */     // (intrinsic_wo_chain:{ *:[v4f16] } 640:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 171131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
     /* 171134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171140 */     GIR_RootConstrainSelectedInstOperands,
     /* 171141 */     // GIR_Coverage, 1333,
     /* 171141 */     GIR_EraseRootFromParent_Done,
     /* 171142 */   // Label 3302: @171142
     /* 171142 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(171187), // Rule ID 1334 //
     /* 171147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 171150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 171155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171176 */     // (intrinsic_wo_chain:{ *:[v8f16] } 640:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 171176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
     /* 171179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171185 */     GIR_RootConstrainSelectedInstOperands,
     /* 171186 */     // GIR_Coverage, 1334,
     /* 171186 */     GIR_EraseRootFromParent_Done,
     /* 171187 */   // Label 3303: @171187
     /* 171187 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(171232), // Rule ID 1335 //
     /* 171192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 171200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171221 */     // (intrinsic_wo_chain:{ *:[v2f32] } 640:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 171221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
     /* 171224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171230 */     GIR_RootConstrainSelectedInstOperands,
     /* 171231 */     // GIR_Coverage, 1335,
     /* 171231 */     GIR_EraseRootFromParent_Done,
     /* 171232 */   // Label 3304: @171232
     /* 171232 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(171277), // Rule ID 1336 //
     /* 171237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 171245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171266 */     // (intrinsic_wo_chain:{ *:[v4f32] } 640:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 171266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
     /* 171269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171275 */     GIR_RootConstrainSelectedInstOperands,
     /* 171276 */     // GIR_Coverage, 1336,
     /* 171276 */     GIR_EraseRootFromParent_Done,
     /* 171277 */   // Label 3305: @171277
     /* 171277 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(171322), // Rule ID 1337 //
     /* 171282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 171290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 171293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 171296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 171299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171311 */     // (intrinsic_wo_chain:{ *:[v2f64] } 640:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 171311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
     /* 171314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171320 */     GIR_RootConstrainSelectedInstOperands,
     /* 171321 */     // GIR_Coverage, 1337,
     /* 171321 */     GIR_EraseRootFromParent_Done,
     /* 171322 */   // Label 3306: @171322
     /* 171322 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(171367), // Rule ID 1354 //
     /* 171327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 171335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171356 */     // (intrinsic_wo_chain:{ *:[v8i8] } 653:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
     /* 171359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171365 */     GIR_RootConstrainSelectedInstOperands,
     /* 171366 */     // GIR_Coverage, 1354,
     /* 171366 */     GIR_EraseRootFromParent_Done,
     /* 171367 */   // Label 3307: @171367
     /* 171367 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(171412), // Rule ID 1355 //
     /* 171372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 171380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171401 */     // (intrinsic_wo_chain:{ *:[v16i8] } 653:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
     /* 171404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171410 */     GIR_RootConstrainSelectedInstOperands,
     /* 171411 */     // GIR_Coverage, 1355,
     /* 171411 */     GIR_EraseRootFromParent_Done,
     /* 171412 */   // Label 3308: @171412
     /* 171412 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(171457), // Rule ID 1369 //
     /* 171417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171446 */     // (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
     /* 171449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171455 */     GIR_RootConstrainSelectedInstOperands,
     /* 171456 */     // GIR_Coverage, 1369,
     /* 171456 */     GIR_EraseRootFromParent_Done,
     /* 171457 */   // Label 3309: @171457
     /* 171457 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(171502), // Rule ID 1371 //
     /* 171462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171491 */     // (intrinsic_wo_chain:{ *:[v16i8] } 659:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
     /* 171494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171500 */     GIR_RootConstrainSelectedInstOperands,
     /* 171501 */     // GIR_Coverage, 1371,
     /* 171501 */     GIR_EraseRootFromParent_Done,
     /* 171502 */   // Label 3310: @171502
     /* 171502 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(171547), // Rule ID 1373 //
     /* 171507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171536 */     // (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
     /* 171539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171545 */     GIR_RootConstrainSelectedInstOperands,
     /* 171546 */     // GIR_Coverage, 1373,
     /* 171546 */     GIR_EraseRootFromParent_Done,
     /* 171547 */   // Label 3311: @171547
     /* 171547 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(171592), // Rule ID 1375 //
     /* 171552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171581 */     // (intrinsic_wo_chain:{ *:[v8i16] } 659:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
     /* 171584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171590 */     GIR_RootConstrainSelectedInstOperands,
     /* 171591 */     // GIR_Coverage, 1375,
     /* 171591 */     GIR_EraseRootFromParent_Done,
     /* 171592 */   // Label 3312: @171592
     /* 171592 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(171637), // Rule ID 1377 //
     /* 171597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171626 */     // (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
     /* 171629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171635 */     GIR_RootConstrainSelectedInstOperands,
     /* 171636 */     // GIR_Coverage, 1377,
     /* 171636 */     GIR_EraseRootFromParent_Done,
     /* 171637 */   // Label 3313: @171637
     /* 171637 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(171682), // Rule ID 1379 //
     /* 171642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 171650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171671 */     // (intrinsic_wo_chain:{ *:[v4i32] } 659:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
     /* 171674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171680 */     GIR_RootConstrainSelectedInstOperands,
     /* 171681 */     // GIR_Coverage, 1379,
     /* 171681 */     GIR_EraseRootFromParent_Done,
     /* 171682 */   // Label 3314: @171682
     /* 171682 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(171727), // Rule ID 1386 //
     /* 171687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171716 */     // (intrinsic_wo_chain:{ *:[v8i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
     /* 171719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171725 */     GIR_RootConstrainSelectedInstOperands,
     /* 171726 */     // GIR_Coverage, 1386,
     /* 171726 */     GIR_EraseRootFromParent_Done,
     /* 171727 */   // Label 3315: @171727
     /* 171727 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(171772), // Rule ID 1387 //
     /* 171732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 171743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 171749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171761 */     // (intrinsic_wo_chain:{ *:[v16i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 171761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
     /* 171764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171770 */     GIR_RootConstrainSelectedInstOperands,
     /* 171771 */     // GIR_Coverage, 1387,
     /* 171771 */     GIR_EraseRootFromParent_Done,
     /* 171772 */   // Label 3316: @171772
     /* 171772 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(171817), // Rule ID 1388 //
     /* 171777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 171788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 171794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171806 */     // (intrinsic_wo_chain:{ *:[v4i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 171806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
     /* 171809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171815 */     GIR_RootConstrainSelectedInstOperands,
     /* 171816 */     // GIR_Coverage, 1388,
     /* 171816 */     GIR_EraseRootFromParent_Done,
     /* 171817 */   // Label 3317: @171817
     /* 171817 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(171862), // Rule ID 1389 //
     /* 171822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 171833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 171839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171851 */     // (intrinsic_wo_chain:{ *:[v8i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 171851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
     /* 171854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171860 */     GIR_RootConstrainSelectedInstOperands,
     /* 171861 */     // GIR_Coverage, 1389,
     /* 171861 */     GIR_EraseRootFromParent_Done,
     /* 171862 */   // Label 3318: @171862
     /* 171862 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(171907), // Rule ID 1390 //
     /* 171867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 171878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 171884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171896 */     // (intrinsic_wo_chain:{ *:[v2i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 171896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
     /* 171899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171905 */     GIR_RootConstrainSelectedInstOperands,
     /* 171906 */     // GIR_Coverage, 1390,
     /* 171906 */     GIR_EraseRootFromParent_Done,
     /* 171907 */   // Label 3319: @171907
     /* 171907 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(171952), // Rule ID 1391 //
     /* 171912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 171920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 171923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 171929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171941 */     // (intrinsic_wo_chain:{ *:[v4i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 171941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
     /* 171944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171950 */     GIR_RootConstrainSelectedInstOperands,
     /* 171951 */     // GIR_Coverage, 1391,
     /* 171951 */     GIR_EraseRootFromParent_Done,
     /* 171952 */   // Label 3320: @171952
     /* 171952 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(171997), // Rule ID 1392 //
     /* 171957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 171960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 171965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 171968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 171974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171986 */     // (intrinsic_wo_chain:{ *:[v8i8] } 671:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 171986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
     /* 171989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 171995 */     GIR_RootConstrainSelectedInstOperands,
     /* 171996 */     // GIR_Coverage, 1392,
     /* 171996 */     GIR_EraseRootFromParent_Done,
     /* 171997 */   // Label 3321: @171997
     /* 171997 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(172042), // Rule ID 1393 //
     /* 172002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 172010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 172013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 172016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 172019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172031 */     // (intrinsic_wo_chain:{ *:[v16i8] } 671:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 172031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
     /* 172034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172040 */     GIR_RootConstrainSelectedInstOperands,
     /* 172041 */     // GIR_Coverage, 1393,
     /* 172041 */     GIR_EraseRootFromParent_Done,
     /* 172042 */   // Label 3322: @172042
     /* 172042 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(172087), // Rule ID 1394 //
     /* 172047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 172055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172076 */     // (intrinsic_wo_chain:{ *:[v4i16] } 671:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
     /* 172079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172085 */     GIR_RootConstrainSelectedInstOperands,
     /* 172086 */     // GIR_Coverage, 1394,
     /* 172086 */     GIR_EraseRootFromParent_Done,
     /* 172087 */   // Label 3323: @172087
     /* 172087 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(172132), // Rule ID 1395 //
     /* 172092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 172100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172121 */     // (intrinsic_wo_chain:{ *:[v8i16] } 671:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
     /* 172124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172130 */     GIR_RootConstrainSelectedInstOperands,
     /* 172131 */     // GIR_Coverage, 1395,
     /* 172131 */     GIR_EraseRootFromParent_Done,
     /* 172132 */   // Label 3324: @172132
     /* 172132 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(172177), // Rule ID 1396 //
     /* 172137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 172145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172166 */     // (intrinsic_wo_chain:{ *:[v2i32] } 671:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 172169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172175 */     GIR_RootConstrainSelectedInstOperands,
     /* 172176 */     // GIR_Coverage, 1396,
     /* 172176 */     GIR_EraseRootFromParent_Done,
     /* 172177 */   // Label 3325: @172177
     /* 172177 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(172222), // Rule ID 1397 //
     /* 172182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 172190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172211 */     // (intrinsic_wo_chain:{ *:[v4i32] } 671:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
     /* 172214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172220 */     GIR_RootConstrainSelectedInstOperands,
     /* 172221 */     // GIR_Coverage, 1397,
     /* 172221 */     GIR_EraseRootFromParent_Done,
     /* 172222 */   // Label 3326: @172222
     /* 172222 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(172267), // Rule ID 1404 //
     /* 172227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 172235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172256 */     // (intrinsic_wo_chain:{ *:[v8i8] } 674:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 172256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
     /* 172259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172265 */     GIR_RootConstrainSelectedInstOperands,
     /* 172266 */     // GIR_Coverage, 1404,
     /* 172266 */     GIR_EraseRootFromParent_Done,
     /* 172267 */   // Label 3327: @172267
     /* 172267 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(172312), // Rule ID 1405 //
     /* 172272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 172280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 172283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 172286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 172289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172301 */     // (intrinsic_wo_chain:{ *:[v16i8] } 674:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 172301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
     /* 172304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172310 */     GIR_RootConstrainSelectedInstOperands,
     /* 172311 */     // GIR_Coverage, 1405,
     /* 172311 */     GIR_EraseRootFromParent_Done,
     /* 172312 */   // Label 3328: @172312
     /* 172312 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(172357), // Rule ID 1406 //
     /* 172317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 172325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172346 */     // (intrinsic_wo_chain:{ *:[v4i16] } 674:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
     /* 172349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172355 */     GIR_RootConstrainSelectedInstOperands,
     /* 172356 */     // GIR_Coverage, 1406,
     /* 172356 */     GIR_EraseRootFromParent_Done,
     /* 172357 */   // Label 3329: @172357
     /* 172357 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(172402), // Rule ID 1407 //
     /* 172362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 172370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172391 */     // (intrinsic_wo_chain:{ *:[v8i16] } 674:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
     /* 172394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172400 */     GIR_RootConstrainSelectedInstOperands,
     /* 172401 */     // GIR_Coverage, 1407,
     /* 172401 */     GIR_EraseRootFromParent_Done,
     /* 172402 */   // Label 3330: @172402
     /* 172402 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(172447), // Rule ID 1408 //
     /* 172407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 172415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172436 */     // (intrinsic_wo_chain:{ *:[v2i32] } 674:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 172439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172445 */     GIR_RootConstrainSelectedInstOperands,
     /* 172446 */     // GIR_Coverage, 1408,
     /* 172446 */     GIR_EraseRootFromParent_Done,
     /* 172447 */   // Label 3331: @172447
     /* 172447 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(172492), // Rule ID 1409 //
     /* 172452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 172460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172481 */     // (intrinsic_wo_chain:{ *:[v4i32] } 674:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
     /* 172484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172490 */     GIR_RootConstrainSelectedInstOperands,
     /* 172491 */     // GIR_Coverage, 1409,
     /* 172491 */     GIR_EraseRootFromParent_Done,
     /* 172492 */   // Label 3332: @172492
     /* 172492 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(172537), // Rule ID 1416 //
     /* 172497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 172508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 172511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 172514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172526 */     // (intrinsic_wo_chain:{ *:[v8i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 172526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 172529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172535 */     GIR_RootConstrainSelectedInstOperands,
     /* 172536 */     // GIR_Coverage, 1416,
     /* 172536 */     GIR_EraseRootFromParent_Done,
     /* 172537 */   // Label 3333: @172537
     /* 172537 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(172582), // Rule ID 1417 //
     /* 172542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 172553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 172556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 172559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172571 */     // (intrinsic_wo_chain:{ *:[v16i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 172571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 172574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172580 */     GIR_RootConstrainSelectedInstOperands,
     /* 172581 */     // GIR_Coverage, 1417,
     /* 172581 */     GIR_EraseRootFromParent_Done,
     /* 172582 */   // Label 3334: @172582
     /* 172582 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(172627), // Rule ID 1418 //
     /* 172587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172616 */     // (intrinsic_wo_chain:{ *:[v4i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 172619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172625 */     GIR_RootConstrainSelectedInstOperands,
     /* 172626 */     // GIR_Coverage, 1418,
     /* 172626 */     GIR_EraseRootFromParent_Done,
     /* 172627 */   // Label 3335: @172627
     /* 172627 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(172672), // Rule ID 1419 //
     /* 172632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172661 */     // (intrinsic_wo_chain:{ *:[v8i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 172664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172670 */     GIR_RootConstrainSelectedInstOperands,
     /* 172671 */     // GIR_Coverage, 1419,
     /* 172671 */     GIR_EraseRootFromParent_Done,
     /* 172672 */   // Label 3336: @172672
     /* 172672 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(172717), // Rule ID 1420 //
     /* 172677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172706 */     // (intrinsic_wo_chain:{ *:[v2i32] } 679:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 172709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172715 */     GIR_RootConstrainSelectedInstOperands,
     /* 172716 */     // GIR_Coverage, 1420,
     /* 172716 */     GIR_EraseRootFromParent_Done,
     /* 172717 */   // Label 3337: @172717
     /* 172717 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(172762), // Rule ID 1421 //
     /* 172722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172751 */     // (intrinsic_wo_chain:{ *:[v4i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 172754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172760 */     GIR_RootConstrainSelectedInstOperands,
     /* 172761 */     // GIR_Coverage, 1421,
     /* 172761 */     GIR_EraseRootFromParent_Done,
     /* 172762 */   // Label 3338: @172762
     /* 172762 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(172807), // Rule ID 1422 //
     /* 172767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 172775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 172784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172796 */     // (intrinsic_wo_chain:{ *:[v2i64] } 679:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 172796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 172799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172805 */     GIR_RootConstrainSelectedInstOperands,
     /* 172806 */     // GIR_Coverage, 1422,
     /* 172806 */     GIR_EraseRootFromParent_Done,
     /* 172807 */   // Label 3339: @172807
     /* 172807 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(172852), // Rule ID 1423 //
     /* 172812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 172820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 172829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172841 */     // (intrinsic_wo_chain:{ *:[v4i16] } 680:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 172841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
     /* 172844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172850 */     GIR_RootConstrainSelectedInstOperands,
     /* 172851 */     // GIR_Coverage, 1423,
     /* 172851 */     GIR_EraseRootFromParent_Done,
     /* 172852 */   // Label 3340: @172852
     /* 172852 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(172897), // Rule ID 1424 //
     /* 172857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 172865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 172874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172886 */     // (intrinsic_wo_chain:{ *:[v8i16] } 680:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 172886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
     /* 172889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172895 */     GIR_RootConstrainSelectedInstOperands,
     /* 172896 */     // GIR_Coverage, 1424,
     /* 172896 */     GIR_EraseRootFromParent_Done,
     /* 172897 */   // Label 3341: @172897
     /* 172897 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(172942), // Rule ID 1425 //
     /* 172902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 172910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 172919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172931 */     // (intrinsic_wo_chain:{ *:[v2i32] } 680:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 172931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
     /* 172934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172940 */     GIR_RootConstrainSelectedInstOperands,
     /* 172941 */     // GIR_Coverage, 1425,
     /* 172941 */     GIR_EraseRootFromParent_Done,
     /* 172942 */   // Label 3342: @172942
     /* 172942 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(172987), // Rule ID 1426 //
     /* 172947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 172955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 172964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172976 */     // (intrinsic_wo_chain:{ *:[v4i32] } 680:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 172976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
     /* 172979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 172985 */     GIR_RootConstrainSelectedInstOperands,
     /* 172986 */     // GIR_Coverage, 1426,
     /* 172986 */     GIR_EraseRootFromParent_Done,
     /* 172987 */   // Label 3343: @172987
     /* 172987 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(173032), // Rule ID 1427 //
     /* 172992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 172995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 173000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173021 */     // (intrinsic_wo_chain:{ *:[v4i16] } 688:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
     /* 173024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173030 */     GIR_RootConstrainSelectedInstOperands,
     /* 173031 */     // GIR_Coverage, 1427,
     /* 173031 */     GIR_EraseRootFromParent_Done,
     /* 173032 */   // Label 3344: @173032
     /* 173032 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(173077), // Rule ID 1428 //
     /* 173037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 173045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173066 */     // (intrinsic_wo_chain:{ *:[v8i16] } 688:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
     /* 173069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173075 */     GIR_RootConstrainSelectedInstOperands,
     /* 173076 */     // GIR_Coverage, 1428,
     /* 173076 */     GIR_EraseRootFromParent_Done,
     /* 173077 */   // Label 3345: @173077
     /* 173077 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(173122), // Rule ID 1429 //
     /* 173082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 173090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173111 */     // (intrinsic_wo_chain:{ *:[v2i32] } 688:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
     /* 173114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173120 */     GIR_RootConstrainSelectedInstOperands,
     /* 173121 */     // GIR_Coverage, 1429,
     /* 173121 */     GIR_EraseRootFromParent_Done,
     /* 173122 */   // Label 3346: @173122
     /* 173122 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(173167), // Rule ID 1430 //
     /* 173127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 173135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173156 */     // (intrinsic_wo_chain:{ *:[v4i32] } 688:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
     /* 173159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173165 */     GIR_RootConstrainSelectedInstOperands,
     /* 173166 */     // GIR_Coverage, 1430,
     /* 173166 */     GIR_EraseRootFromParent_Done,
     /* 173167 */   // Label 3347: @173167
     /* 173167 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(173212), // Rule ID 1431 //
     /* 173172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 173180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173201 */     // (intrinsic_wo_chain:{ *:[v8i8] } 691:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
     /* 173204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173210 */     GIR_RootConstrainSelectedInstOperands,
     /* 173211 */     // GIR_Coverage, 1431,
     /* 173211 */     GIR_EraseRootFromParent_Done,
     /* 173212 */   // Label 3348: @173212
     /* 173212 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(173257), // Rule ID 1432 //
     /* 173217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 173225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173246 */     // (intrinsic_wo_chain:{ *:[v16i8] } 691:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
     /* 173249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173255 */     GIR_RootConstrainSelectedInstOperands,
     /* 173256 */     // GIR_Coverage, 1432,
     /* 173256 */     GIR_EraseRootFromParent_Done,
     /* 173257 */   // Label 3349: @173257
     /* 173257 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(173302), // Rule ID 1433 //
     /* 173262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 173270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173291 */     // (intrinsic_wo_chain:{ *:[v4i16] } 691:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
     /* 173294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173300 */     GIR_RootConstrainSelectedInstOperands,
     /* 173301 */     // GIR_Coverage, 1433,
     /* 173301 */     GIR_EraseRootFromParent_Done,
     /* 173302 */   // Label 3350: @173302
     /* 173302 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(173347), // Rule ID 1434 //
     /* 173307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 173315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173336 */     // (intrinsic_wo_chain:{ *:[v8i16] } 691:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
     /* 173339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173345 */     GIR_RootConstrainSelectedInstOperands,
     /* 173346 */     // GIR_Coverage, 1434,
     /* 173346 */     GIR_EraseRootFromParent_Done,
     /* 173347 */   // Label 3351: @173347
     /* 173347 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(173392), // Rule ID 1435 //
     /* 173352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 173360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173381 */     // (intrinsic_wo_chain:{ *:[v2i32] } 691:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
     /* 173384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173390 */     GIR_RootConstrainSelectedInstOperands,
     /* 173391 */     // GIR_Coverage, 1435,
     /* 173391 */     GIR_EraseRootFromParent_Done,
     /* 173392 */   // Label 3352: @173392
     /* 173392 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(173437), // Rule ID 1436 //
     /* 173397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 173405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173426 */     // (intrinsic_wo_chain:{ *:[v4i32] } 691:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
     /* 173429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173435 */     GIR_RootConstrainSelectedInstOperands,
     /* 173436 */     // GIR_Coverage, 1436,
     /* 173436 */     GIR_EraseRootFromParent_Done,
     /* 173437 */   // Label 3353: @173437
     /* 173437 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(173482), // Rule ID 1437 //
     /* 173442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 173450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173471 */     // (intrinsic_wo_chain:{ *:[v2i64] } 691:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
     /* 173474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173480 */     GIR_RootConstrainSelectedInstOperands,
     /* 173481 */     // GIR_Coverage, 1437,
     /* 173481 */     GIR_EraseRootFromParent_Done,
     /* 173482 */   // Label 3354: @173482
     /* 173482 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(173527), // Rule ID 1438 //
     /* 173487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173516 */     // (intrinsic_wo_chain:{ *:[v8i8] } 694:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
     /* 173519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173525 */     GIR_RootConstrainSelectedInstOperands,
     /* 173526 */     // GIR_Coverage, 1438,
     /* 173526 */     GIR_EraseRootFromParent_Done,
     /* 173527 */   // Label 3355: @173527
     /* 173527 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(173572), // Rule ID 1439 //
     /* 173532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173561 */     // (intrinsic_wo_chain:{ *:[v16i8] } 694:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
     /* 173564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173570 */     GIR_RootConstrainSelectedInstOperands,
     /* 173571 */     // GIR_Coverage, 1439,
     /* 173571 */     GIR_EraseRootFromParent_Done,
     /* 173572 */   // Label 3356: @173572
     /* 173572 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(173617), // Rule ID 1440 //
     /* 173577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173606 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
     /* 173609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173615 */     GIR_RootConstrainSelectedInstOperands,
     /* 173616 */     // GIR_Coverage, 1440,
     /* 173616 */     GIR_EraseRootFromParent_Done,
     /* 173617 */   // Label 3357: @173617
     /* 173617 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(173662), // Rule ID 1441 //
     /* 173622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173651 */     // (intrinsic_wo_chain:{ *:[v8i16] } 694:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
     /* 173654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173660 */     GIR_RootConstrainSelectedInstOperands,
     /* 173661 */     // GIR_Coverage, 1441,
     /* 173661 */     GIR_EraseRootFromParent_Done,
     /* 173662 */   // Label 3358: @173662
     /* 173662 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(173707), // Rule ID 1442 //
     /* 173667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173696 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 173696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
     /* 173699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173705 */     GIR_RootConstrainSelectedInstOperands,
     /* 173706 */     // GIR_Coverage, 1442,
     /* 173706 */     GIR_EraseRootFromParent_Done,
     /* 173707 */   // Label 3359: @173707
     /* 173707 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(173752), // Rule ID 1443 //
     /* 173712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 173726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 173729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173741 */     // (intrinsic_wo_chain:{ *:[v4i32] } 694:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 173741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
     /* 173744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173750 */     GIR_RootConstrainSelectedInstOperands,
     /* 173751 */     // GIR_Coverage, 1443,
     /* 173751 */     GIR_EraseRootFromParent_Done,
     /* 173752 */   // Label 3360: @173752
     /* 173752 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(173797), // Rule ID 1444 //
     /* 173757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 173765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 173771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 173774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173786 */     // (intrinsic_wo_chain:{ *:[v2i64] } 694:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 173786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
     /* 173789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173795 */     GIR_RootConstrainSelectedInstOperands,
     /* 173796 */     // GIR_Coverage, 1444,
     /* 173796 */     GIR_EraseRootFromParent_Done,
     /* 173797 */   // Label 3361: @173797
     /* 173797 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(173842), // Rule ID 1445 //
     /* 173802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 173813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 173816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 173819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173831 */     // (intrinsic_wo_chain:{ *:[v8i8] } 698:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 173831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 173834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173840 */     GIR_RootConstrainSelectedInstOperands,
     /* 173841 */     // GIR_Coverage, 1445,
     /* 173841 */     GIR_EraseRootFromParent_Done,
     /* 173842 */   // Label 3362: @173842
     /* 173842 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(173887), // Rule ID 1446 //
     /* 173847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 173858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 173861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 173864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173876 */     // (intrinsic_wo_chain:{ *:[v16i8] } 698:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 173876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 173879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173885 */     GIR_RootConstrainSelectedInstOperands,
     /* 173886 */     // GIR_Coverage, 1446,
     /* 173886 */     GIR_EraseRootFromParent_Done,
     /* 173887 */   // Label 3363: @173887
     /* 173887 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(173932), // Rule ID 1447 //
     /* 173892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 173903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173921 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 173921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 173924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173930 */     GIR_RootConstrainSelectedInstOperands,
     /* 173931 */     // GIR_Coverage, 1447,
     /* 173931 */     GIR_EraseRootFromParent_Done,
     /* 173932 */   // Label 3364: @173932
     /* 173932 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(173977), // Rule ID 1448 //
     /* 173937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173940 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173945 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 173948 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 173951 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 173954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173966 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 173966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 173969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 173973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 173975 */     GIR_RootConstrainSelectedInstOperands,
     /* 173976 */     // GIR_Coverage, 1448,
     /* 173976 */     GIR_EraseRootFromParent_Done,
     /* 173977 */   // Label 3365: @173977
     /* 173977 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(174022), // Rule ID 1449 //
     /* 173982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 173993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174011 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 174014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174020 */     GIR_RootConstrainSelectedInstOperands,
     /* 174021 */     // GIR_Coverage, 1449,
     /* 174021 */     GIR_EraseRootFromParent_Done,
     /* 174022 */   // Label 3366: @174022
     /* 174022 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(174067), // Rule ID 1450 //
     /* 174027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 174035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174056 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 174059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174065 */     GIR_RootConstrainSelectedInstOperands,
     /* 174066 */     // GIR_Coverage, 1450,
     /* 174066 */     GIR_EraseRootFromParent_Done,
     /* 174067 */   // Label 3367: @174067
     /* 174067 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(174112), // Rule ID 1451 //
     /* 174072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 174080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174101 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 174101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 174104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174110 */     GIR_RootConstrainSelectedInstOperands,
     /* 174111 */     // GIR_Coverage, 1451,
     /* 174111 */     GIR_EraseRootFromParent_Done,
     /* 174112 */   // Label 3368: @174112
     /* 174112 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(174157), // Rule ID 1458 //
     /* 174117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 174125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174146 */     // (intrinsic_wo_chain:{ *:[v8i8] } 702:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
     /* 174149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174155 */     GIR_RootConstrainSelectedInstOperands,
     /* 174156 */     // GIR_Coverage, 1458,
     /* 174156 */     GIR_EraseRootFromParent_Done,
     /* 174157 */   // Label 3369: @174157
     /* 174157 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(174202), // Rule ID 1459 //
     /* 174162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 174170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174187 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174191 */     // (intrinsic_wo_chain:{ *:[v16i8] } 702:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
     /* 174194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174200 */     GIR_RootConstrainSelectedInstOperands,
     /* 174201 */     // GIR_Coverage, 1459,
     /* 174201 */     GIR_EraseRootFromParent_Done,
     /* 174202 */   // Label 3370: @174202
     /* 174202 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(174247), // Rule ID 1460 //
     /* 174207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 174215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174236 */     // (intrinsic_wo_chain:{ *:[v4i16] } 702:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
     /* 174239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174245 */     GIR_RootConstrainSelectedInstOperands,
     /* 174246 */     // GIR_Coverage, 1460,
     /* 174246 */     GIR_EraseRootFromParent_Done,
     /* 174247 */   // Label 3371: @174247
     /* 174247 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(174292), // Rule ID 1461 //
     /* 174252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 174260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174281 */     // (intrinsic_wo_chain:{ *:[v8i16] } 702:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
     /* 174284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174290 */     GIR_RootConstrainSelectedInstOperands,
     /* 174291 */     // GIR_Coverage, 1461,
     /* 174291 */     GIR_EraseRootFromParent_Done,
     /* 174292 */   // Label 3372: @174292
     /* 174292 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(174337), // Rule ID 1462 //
     /* 174297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 174305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174322 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174326 */     // (intrinsic_wo_chain:{ *:[v2i32] } 702:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
     /* 174329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174335 */     GIR_RootConstrainSelectedInstOperands,
     /* 174336 */     // GIR_Coverage, 1462,
     /* 174336 */     GIR_EraseRootFromParent_Done,
     /* 174337 */   // Label 3373: @174337
     /* 174337 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(174382), // Rule ID 1463 //
     /* 174342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 174350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174371 */     // (intrinsic_wo_chain:{ *:[v4i32] } 702:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
     /* 174374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174380 */     GIR_RootConstrainSelectedInstOperands,
     /* 174381 */     // GIR_Coverage, 1463,
     /* 174381 */     GIR_EraseRootFromParent_Done,
     /* 174382 */   // Label 3374: @174382
     /* 174382 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(174427), // Rule ID 1464 //
     /* 174387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 174395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174416 */     // (intrinsic_wo_chain:{ *:[v2i64] } 702:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 174416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
     /* 174419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174425 */     GIR_RootConstrainSelectedInstOperands,
     /* 174426 */     // GIR_Coverage, 1464,
     /* 174426 */     GIR_EraseRootFromParent_Done,
     /* 174427 */   // Label 3375: @174427
     /* 174427 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(174472), // Rule ID 1465 //
     /* 174432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174461 */     // (intrinsic_wo_chain:{ *:[v8i8] } 703:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
     /* 174464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174470 */     GIR_RootConstrainSelectedInstOperands,
     /* 174471 */     // GIR_Coverage, 1465,
     /* 174471 */     GIR_EraseRootFromParent_Done,
     /* 174472 */   // Label 3376: @174472
     /* 174472 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(174517), // Rule ID 1466 //
     /* 174477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174506 */     // (intrinsic_wo_chain:{ *:[v16i8] } 703:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
     /* 174509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174515 */     GIR_RootConstrainSelectedInstOperands,
     /* 174516 */     // GIR_Coverage, 1466,
     /* 174516 */     GIR_EraseRootFromParent_Done,
     /* 174517 */   // Label 3377: @174517
     /* 174517 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(174562), // Rule ID 1467 //
     /* 174522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174551 */     // (intrinsic_wo_chain:{ *:[v4i16] } 703:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
     /* 174554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174560 */     GIR_RootConstrainSelectedInstOperands,
     /* 174561 */     // GIR_Coverage, 1467,
     /* 174561 */     GIR_EraseRootFromParent_Done,
     /* 174562 */   // Label 3378: @174562
     /* 174562 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(174607), // Rule ID 1468 //
     /* 174567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174596 */     // (intrinsic_wo_chain:{ *:[v8i16] } 703:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
     /* 174599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174605 */     GIR_RootConstrainSelectedInstOperands,
     /* 174606 */     // GIR_Coverage, 1468,
     /* 174606 */     GIR_EraseRootFromParent_Done,
     /* 174607 */   // Label 3379: @174607
     /* 174607 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(174652), // Rule ID 1469 //
     /* 174612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174641 */     // (intrinsic_wo_chain:{ *:[v2i32] } 703:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
     /* 174644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174650 */     GIR_RootConstrainSelectedInstOperands,
     /* 174651 */     // GIR_Coverage, 1469,
     /* 174651 */     GIR_EraseRootFromParent_Done,
     /* 174652 */   // Label 3380: @174652
     /* 174652 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(174697), // Rule ID 1470 //
     /* 174657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174686 */     // (intrinsic_wo_chain:{ *:[v4i32] } 703:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 174686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
     /* 174689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174695 */     GIR_RootConstrainSelectedInstOperands,
     /* 174696 */     // GIR_Coverage, 1470,
     /* 174696 */     GIR_EraseRootFromParent_Done,
     /* 174697 */   // Label 3381: @174697
     /* 174697 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(174742), // Rule ID 1471 //
     /* 174702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 174710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 174713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 174716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 174719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174727 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174731 */     // (intrinsic_wo_chain:{ *:[v2i64] } 703:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 174731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
     /* 174734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174740 */     GIR_RootConstrainSelectedInstOperands,
     /* 174741 */     // GIR_Coverage, 1471,
     /* 174741 */     GIR_EraseRootFromParent_Done,
     /* 174742 */   // Label 3382: @174742
     /* 174742 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(174787), // Rule ID 1492 //
     /* 174747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174772 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174776 */     // (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 174776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
     /* 174779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174785 */     GIR_RootConstrainSelectedInstOperands,
     /* 174786 */     // GIR_Coverage, 1492,
     /* 174786 */     GIR_EraseRootFromParent_Done,
     /* 174787 */   // Label 3383: @174787
     /* 174787 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(174832), // Rule ID 1494 //
     /* 174792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 174803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 174806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 174809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174817 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174821 */     // (intrinsic_wo_chain:{ *:[v16i8] } 724:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 174821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
     /* 174824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174830 */     GIR_RootConstrainSelectedInstOperands,
     /* 174831 */     // GIR_Coverage, 1494,
     /* 174831 */     GIR_EraseRootFromParent_Done,
     /* 174832 */   // Label 3384: @174832
     /* 174832 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(174877), // Rule ID 1496 //
     /* 174837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174866 */     // (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 174866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
     /* 174869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174875 */     GIR_RootConstrainSelectedInstOperands,
     /* 174876 */     // GIR_Coverage, 1496,
     /* 174876 */     GIR_EraseRootFromParent_Done,
     /* 174877 */   // Label 3385: @174877
     /* 174877 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(174922), // Rule ID 1498 //
     /* 174882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 174893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 174896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 174899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174911 */     // (intrinsic_wo_chain:{ *:[v8i16] } 724:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 174911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
     /* 174914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174920 */     GIR_RootConstrainSelectedInstOperands,
     /* 174921 */     // GIR_Coverage, 1498,
     /* 174921 */     GIR_EraseRootFromParent_Done,
     /* 174922 */   // Label 3386: @174922
     /* 174922 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(174967), // Rule ID 1500 //
     /* 174927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174956 */     // (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 174956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
     /* 174959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 174961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 174963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 174965 */     GIR_RootConstrainSelectedInstOperands,
     /* 174966 */     // GIR_Coverage, 1500,
     /* 174966 */     GIR_EraseRootFromParent_Done,
     /* 174967 */   // Label 3387: @174967
     /* 174967 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(175012), // Rule ID 1502 //
     /* 174972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 174980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 174983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 174986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 174989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175001 */     // (intrinsic_wo_chain:{ *:[v4i32] } 724:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
     /* 175004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175010 */     GIR_RootConstrainSelectedInstOperands,
     /* 175011 */     // GIR_Coverage, 1502,
     /* 175011 */     GIR_EraseRootFromParent_Done,
     /* 175012 */   // Label 3388: @175012
     /* 175012 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(175057), // Rule ID 1509 //
     /* 175017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 175025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175046 */     // (intrinsic_wo_chain:{ *:[v8i8] } 730:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
     /* 175049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175055 */     GIR_RootConstrainSelectedInstOperands,
     /* 175056 */     // GIR_Coverage, 1509,
     /* 175056 */     GIR_EraseRootFromParent_Done,
     /* 175057 */   // Label 3389: @175057
     /* 175057 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(175102), // Rule ID 1510 //
     /* 175062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 175070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175091 */     // (intrinsic_wo_chain:{ *:[v16i8] } 730:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
     /* 175094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175100 */     GIR_RootConstrainSelectedInstOperands,
     /* 175101 */     // GIR_Coverage, 1510,
     /* 175101 */     GIR_EraseRootFromParent_Done,
     /* 175102 */   // Label 3390: @175102
     /* 175102 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(175147), // Rule ID 1511 //
     /* 175107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 175115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175136 */     // (intrinsic_wo_chain:{ *:[v4i16] } 730:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
     /* 175139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175145 */     GIR_RootConstrainSelectedInstOperands,
     /* 175146 */     // GIR_Coverage, 1511,
     /* 175146 */     GIR_EraseRootFromParent_Done,
     /* 175147 */   // Label 3391: @175147
     /* 175147 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(175192), // Rule ID 1512 //
     /* 175152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 175160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175181 */     // (intrinsic_wo_chain:{ *:[v8i16] } 730:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
     /* 175184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175190 */     GIR_RootConstrainSelectedInstOperands,
     /* 175191 */     // GIR_Coverage, 1512,
     /* 175191 */     GIR_EraseRootFromParent_Done,
     /* 175192 */   // Label 3392: @175192
     /* 175192 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(175237), // Rule ID 1513 //
     /* 175197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 175205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175226 */     // (intrinsic_wo_chain:{ *:[v2i32] } 730:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
     /* 175229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175235 */     GIR_RootConstrainSelectedInstOperands,
     /* 175236 */     // GIR_Coverage, 1513,
     /* 175236 */     GIR_EraseRootFromParent_Done,
     /* 175237 */   // Label 3393: @175237
     /* 175237 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(175282), // Rule ID 1514 //
     /* 175242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 175250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175271 */     // (intrinsic_wo_chain:{ *:[v4i32] } 730:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
     /* 175274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175280 */     GIR_RootConstrainSelectedInstOperands,
     /* 175281 */     // GIR_Coverage, 1514,
     /* 175281 */     GIR_EraseRootFromParent_Done,
     /* 175282 */   // Label 3394: @175282
     /* 175282 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(175327), // Rule ID 1515 //
     /* 175287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 175295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175316 */     // (intrinsic_wo_chain:{ *:[v8i8] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
     /* 175319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175325 */     GIR_RootConstrainSelectedInstOperands,
     /* 175326 */     // GIR_Coverage, 1515,
     /* 175326 */     GIR_EraseRootFromParent_Done,
     /* 175327 */   // Label 3395: @175327
     /* 175327 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(175372), // Rule ID 1516 //
     /* 175332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 175340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175361 */     // (intrinsic_wo_chain:{ *:[v16i8] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
     /* 175364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175370 */     GIR_RootConstrainSelectedInstOperands,
     /* 175371 */     // GIR_Coverage, 1516,
     /* 175371 */     GIR_EraseRootFromParent_Done,
     /* 175372 */   // Label 3396: @175372
     /* 175372 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(175417), // Rule ID 1517 //
     /* 175377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 175385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175402 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175406 */     // (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
     /* 175409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175415 */     GIR_RootConstrainSelectedInstOperands,
     /* 175416 */     // GIR_Coverage, 1517,
     /* 175416 */     GIR_EraseRootFromParent_Done,
     /* 175417 */   // Label 3397: @175417
     /* 175417 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(175462), // Rule ID 1518 //
     /* 175422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 175430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175451 */     // (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
     /* 175454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175460 */     GIR_RootConstrainSelectedInstOperands,
     /* 175461 */     // GIR_Coverage, 1518,
     /* 175461 */     GIR_EraseRootFromParent_Done,
     /* 175462 */   // Label 3398: @175462
     /* 175462 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(175507), // Rule ID 1519 //
     /* 175467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 175475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175496 */     // (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 175499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175505 */     GIR_RootConstrainSelectedInstOperands,
     /* 175506 */     // GIR_Coverage, 1519,
     /* 175506 */     GIR_EraseRootFromParent_Done,
     /* 175507 */   // Label 3399: @175507
     /* 175507 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(175552), // Rule ID 1520 //
     /* 175512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 175520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175541 */     // (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
     /* 175544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175548 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175550 */     GIR_RootConstrainSelectedInstOperands,
     /* 175551 */     // GIR_Coverage, 1520,
     /* 175551 */     GIR_EraseRootFromParent_Done,
     /* 175552 */   // Label 3400: @175552
     /* 175552 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(175597), // Rule ID 1527 //
     /* 175557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175586 */     // (intrinsic_wo_chain:{ *:[v8i8] } 735:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
     /* 175589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175595 */     GIR_RootConstrainSelectedInstOperands,
     /* 175596 */     // GIR_Coverage, 1527,
     /* 175596 */     GIR_EraseRootFromParent_Done,
     /* 175597 */   // Label 3401: @175597
     /* 175597 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(175642), // Rule ID 1528 //
     /* 175602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175631 */     // (intrinsic_wo_chain:{ *:[v16i8] } 735:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
     /* 175634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175640 */     GIR_RootConstrainSelectedInstOperands,
     /* 175641 */     // GIR_Coverage, 1528,
     /* 175641 */     GIR_EraseRootFromParent_Done,
     /* 175642 */   // Label 3402: @175642
     /* 175642 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(175687), // Rule ID 1529 //
     /* 175647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175676 */     // (intrinsic_wo_chain:{ *:[v4i16] } 735:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
     /* 175679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175685 */     GIR_RootConstrainSelectedInstOperands,
     /* 175686 */     // GIR_Coverage, 1529,
     /* 175686 */     GIR_EraseRootFromParent_Done,
     /* 175687 */   // Label 3403: @175687
     /* 175687 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(175732), // Rule ID 1530 //
     /* 175692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175721 */     // (intrinsic_wo_chain:{ *:[v8i16] } 735:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
     /* 175724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175730 */     GIR_RootConstrainSelectedInstOperands,
     /* 175731 */     // GIR_Coverage, 1530,
     /* 175731 */     GIR_EraseRootFromParent_Done,
     /* 175732 */   // Label 3404: @175732
     /* 175732 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(175777), // Rule ID 1531 //
     /* 175737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175766 */     // (intrinsic_wo_chain:{ *:[v2i32] } 735:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 175766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 175769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175775 */     GIR_RootConstrainSelectedInstOperands,
     /* 175776 */     // GIR_Coverage, 1531,
     /* 175776 */     GIR_EraseRootFromParent_Done,
     /* 175777 */   // Label 3405: @175777
     /* 175777 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(175822), // Rule ID 1532 //
     /* 175782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 175790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 175793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 175796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 175799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175811 */     // (intrinsic_wo_chain:{ *:[v4i32] } 735:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 175811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
     /* 175814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175820 */     GIR_RootConstrainSelectedInstOperands,
     /* 175821 */     // GIR_Coverage, 1532,
     /* 175821 */     GIR_EraseRootFromParent_Done,
     /* 175822 */   // Label 3406: @175822
     /* 175822 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(175867), // Rule ID 1539 //
     /* 175827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 175838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 175841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 175844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175856 */     // (intrinsic_wo_chain:{ *:[v8i8] } 739:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 175856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 175859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175865 */     GIR_RootConstrainSelectedInstOperands,
     /* 175866 */     // GIR_Coverage, 1539,
     /* 175866 */     GIR_EraseRootFromParent_Done,
     /* 175867 */   // Label 3407: @175867
     /* 175867 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(175912), // Rule ID 1540 //
     /* 175872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 175883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 175886 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 175889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175901 */     // (intrinsic_wo_chain:{ *:[v16i8] } 739:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 175901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 175904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175910 */     GIR_RootConstrainSelectedInstOperands,
     /* 175911 */     // GIR_Coverage, 1540,
     /* 175911 */     GIR_EraseRootFromParent_Done,
     /* 175912 */   // Label 3408: @175912
     /* 175912 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(175957), // Rule ID 1541 //
     /* 175917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175946 */     // (intrinsic_wo_chain:{ *:[v4i16] } 739:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 175946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 175949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 175955 */     GIR_RootConstrainSelectedInstOperands,
     /* 175956 */     // GIR_Coverage, 1541,
     /* 175956 */     GIR_EraseRootFromParent_Done,
     /* 175957 */   // Label 3409: @175957
     /* 175957 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(176002), // Rule ID 1542 //
     /* 175962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 175970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 175973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 175976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 175979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175983 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175987 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175991 */     // (intrinsic_wo_chain:{ *:[v8i16] } 739:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 175991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 175994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 175998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176000 */     GIR_RootConstrainSelectedInstOperands,
     /* 176001 */     // GIR_Coverage, 1542,
     /* 176001 */     GIR_EraseRootFromParent_Done,
     /* 176002 */   // Label 3410: @176002
     /* 176002 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(176047), // Rule ID 1543 //
     /* 176007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 176015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176036 */     // (intrinsic_wo_chain:{ *:[v2i32] } 739:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 176039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176045 */     GIR_RootConstrainSelectedInstOperands,
     /* 176046 */     // GIR_Coverage, 1543,
     /* 176046 */     GIR_EraseRootFromParent_Done,
     /* 176047 */   // Label 3411: @176047
     /* 176047 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(176092), // Rule ID 1544 //
     /* 176052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 176060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176081 */     // (intrinsic_wo_chain:{ *:[v4i32] } 739:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 176084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176090 */     GIR_RootConstrainSelectedInstOperands,
     /* 176091 */     // GIR_Coverage, 1544,
     /* 176091 */     GIR_EraseRootFromParent_Done,
     /* 176092 */   // Label 3412: @176092
     /* 176092 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(176137), // Rule ID 1545 //
     /* 176097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 176105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176126 */     // (intrinsic_wo_chain:{ *:[v2i64] } 739:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 176129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176135 */     GIR_RootConstrainSelectedInstOperands,
     /* 176136 */     // GIR_Coverage, 1545,
     /* 176136 */     GIR_EraseRootFromParent_Done,
     /* 176137 */   // Label 3413: @176137
     /* 176137 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(176182), // Rule ID 1546 //
     /* 176142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 176150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176171 */     // (intrinsic_wo_chain:{ *:[v8i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
     /* 176174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176180 */     GIR_RootConstrainSelectedInstOperands,
     /* 176181 */     // GIR_Coverage, 1546,
     /* 176181 */     GIR_EraseRootFromParent_Done,
     /* 176182 */   // Label 3414: @176182
     /* 176182 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(176227), // Rule ID 1547 //
     /* 176187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 176195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176216 */     // (intrinsic_wo_chain:{ *:[v16i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
     /* 176219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176225 */     GIR_RootConstrainSelectedInstOperands,
     /* 176226 */     // GIR_Coverage, 1547,
     /* 176226 */     GIR_EraseRootFromParent_Done,
     /* 176227 */   // Label 3415: @176227
     /* 176227 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(176272), // Rule ID 1548 //
     /* 176232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 176240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176261 */     // (intrinsic_wo_chain:{ *:[v4i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
     /* 176264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176270 */     GIR_RootConstrainSelectedInstOperands,
     /* 176271 */     // GIR_Coverage, 1548,
     /* 176271 */     GIR_EraseRootFromParent_Done,
     /* 176272 */   // Label 3416: @176272
     /* 176272 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(176317), // Rule ID 1549 //
     /* 176277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 176285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176306 */     // (intrinsic_wo_chain:{ *:[v8i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
     /* 176309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176315 */     GIR_RootConstrainSelectedInstOperands,
     /* 176316 */     // GIR_Coverage, 1549,
     /* 176316 */     GIR_EraseRootFromParent_Done,
     /* 176317 */   // Label 3417: @176317
     /* 176317 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(176362), // Rule ID 1550 //
     /* 176322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 176330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176351 */     // (intrinsic_wo_chain:{ *:[v2i32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
     /* 176354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176360 */     GIR_RootConstrainSelectedInstOperands,
     /* 176361 */     // GIR_Coverage, 1550,
     /* 176361 */     GIR_EraseRootFromParent_Done,
     /* 176362 */   // Label 3418: @176362
     /* 176362 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(176407), // Rule ID 1551 //
     /* 176367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 176375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176396 */     // (intrinsic_wo_chain:{ *:[v4i32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
     /* 176399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176405 */     GIR_RootConstrainSelectedInstOperands,
     /* 176406 */     // GIR_Coverage, 1551,
     /* 176406 */     GIR_EraseRootFromParent_Done,
     /* 176407 */   // Label 3419: @176407
     /* 176407 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(176452), // Rule ID 1552 //
     /* 176412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 176420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176441 */     // (intrinsic_wo_chain:{ *:[v2i64] } 740:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
     /* 176444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176450 */     GIR_RootConstrainSelectedInstOperands,
     /* 176451 */     // GIR_Coverage, 1552,
     /* 176451 */     GIR_EraseRootFromParent_Done,
     /* 176452 */   // Label 3420: @176452
     /* 176452 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(176497), // Rule ID 1553 //
     /* 176457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176486 */     // (intrinsic_wo_chain:{ *:[v8i8] } 742:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
     /* 176489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176495 */     GIR_RootConstrainSelectedInstOperands,
     /* 176496 */     // GIR_Coverage, 1553,
     /* 176496 */     GIR_EraseRootFromParent_Done,
     /* 176497 */   // Label 3421: @176497
     /* 176497 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(176542), // Rule ID 1554 //
     /* 176502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176531 */     // (intrinsic_wo_chain:{ *:[v16i8] } 742:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
     /* 176534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176540 */     GIR_RootConstrainSelectedInstOperands,
     /* 176541 */     // GIR_Coverage, 1554,
     /* 176541 */     GIR_EraseRootFromParent_Done,
     /* 176542 */   // Label 3422: @176542
     /* 176542 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(176587), // Rule ID 1555 //
     /* 176547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176576 */     // (intrinsic_wo_chain:{ *:[v4i16] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
     /* 176579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176585 */     GIR_RootConstrainSelectedInstOperands,
     /* 176586 */     // GIR_Coverage, 1555,
     /* 176586 */     GIR_EraseRootFromParent_Done,
     /* 176587 */   // Label 3423: @176587
     /* 176587 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(176632), // Rule ID 1556 //
     /* 176592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176621 */     // (intrinsic_wo_chain:{ *:[v8i16] } 742:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
     /* 176624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176630 */     GIR_RootConstrainSelectedInstOperands,
     /* 176631 */     // GIR_Coverage, 1556,
     /* 176631 */     GIR_EraseRootFromParent_Done,
     /* 176632 */   // Label 3424: @176632
     /* 176632 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(176677), // Rule ID 1557 //
     /* 176637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176666 */     // (intrinsic_wo_chain:{ *:[v2i32] } 742:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
     /* 176669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176675 */     GIR_RootConstrainSelectedInstOperands,
     /* 176676 */     // GIR_Coverage, 1557,
     /* 176676 */     GIR_EraseRootFromParent_Done,
     /* 176677 */   // Label 3425: @176677
     /* 176677 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(176722), // Rule ID 1558 //
     /* 176682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 176696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 176699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176711 */     // (intrinsic_wo_chain:{ *:[v4i32] } 742:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 176711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
     /* 176714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176720 */     GIR_RootConstrainSelectedInstOperands,
     /* 176721 */     // GIR_Coverage, 1558,
     /* 176721 */     GIR_EraseRootFromParent_Done,
     /* 176722 */   // Label 3426: @176722
     /* 176722 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(176767), // Rule ID 1559 //
     /* 176727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 176735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 176741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 176744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176756 */     // (intrinsic_wo_chain:{ *:[v2i64] } 742:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 176756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
     /* 176759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176765 */     GIR_RootConstrainSelectedInstOperands,
     /* 176766 */     // GIR_Coverage, 1559,
     /* 176766 */     GIR_EraseRootFromParent_Done,
     /* 176767 */   // Label 3427: @176767
     /* 176767 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(176812), // Rule ID 1560 //
     /* 176772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 176783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 176786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 176789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176801 */     // (intrinsic_wo_chain:{ *:[v8i8] } 744:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 176801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 176804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176810 */     GIR_RootConstrainSelectedInstOperands,
     /* 176811 */     // GIR_Coverage, 1560,
     /* 176811 */     GIR_EraseRootFromParent_Done,
     /* 176812 */   // Label 3428: @176812
     /* 176812 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(176857), // Rule ID 1561 //
     /* 176817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 176828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 176831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 176834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176846 */     // (intrinsic_wo_chain:{ *:[v16i8] } 744:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 176846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 176849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176855 */     GIR_RootConstrainSelectedInstOperands,
     /* 176856 */     // GIR_Coverage, 1561,
     /* 176856 */     GIR_EraseRootFromParent_Done,
     /* 176857 */   // Label 3429: @176857
     /* 176857 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(176902), // Rule ID 1562 //
     /* 176862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176891 */     // (intrinsic_wo_chain:{ *:[v4i16] } 744:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 176891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 176894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176900 */     GIR_RootConstrainSelectedInstOperands,
     /* 176901 */     // GIR_Coverage, 1562,
     /* 176901 */     GIR_EraseRootFromParent_Done,
     /* 176902 */   // Label 3430: @176902
     /* 176902 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(176947), // Rule ID 1563 //
     /* 176907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 176918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 176921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 176924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176936 */     // (intrinsic_wo_chain:{ *:[v8i16] } 744:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 176936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 176939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176945 */     GIR_RootConstrainSelectedInstOperands,
     /* 176946 */     // GIR_Coverage, 1563,
     /* 176946 */     GIR_EraseRootFromParent_Done,
     /* 176947 */   // Label 3431: @176947
     /* 176947 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(176992), // Rule ID 1564 //
     /* 176952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 176960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176981 */     // (intrinsic_wo_chain:{ *:[v2i32] } 744:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 176981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 176984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 176990 */     GIR_RootConstrainSelectedInstOperands,
     /* 176991 */     // GIR_Coverage, 1564,
     /* 176991 */     GIR_EraseRootFromParent_Done,
     /* 176992 */   // Label 3432: @176992
     /* 176992 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(177037), // Rule ID 1565 //
     /* 176997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 177005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177026 */     // (intrinsic_wo_chain:{ *:[v4i32] } 744:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 177029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177035 */     GIR_RootConstrainSelectedInstOperands,
     /* 177036 */     // GIR_Coverage, 1565,
     /* 177036 */     GIR_EraseRootFromParent_Done,
     /* 177037 */   // Label 3433: @177037
     /* 177037 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(177082), // Rule ID 1566 //
     /* 177042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 177050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 177056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 177059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177071 */     // (intrinsic_wo_chain:{ *:[v2i64] } 744:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 177071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 177074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177080 */     GIR_RootConstrainSelectedInstOperands,
     /* 177081 */     // GIR_Coverage, 1566,
     /* 177081 */     GIR_EraseRootFromParent_Done,
     /* 177082 */   // Label 3434: @177082
     /* 177082 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(177127), // Rule ID 1573 //
     /* 177087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 177095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 177098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 177101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 177104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177116 */     // (intrinsic_wo_chain:{ *:[v8i8] } 748:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 177116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
     /* 177119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177125 */     GIR_RootConstrainSelectedInstOperands,
     /* 177126 */     // GIR_Coverage, 1573,
     /* 177126 */     GIR_EraseRootFromParent_Done,
     /* 177127 */   // Label 3435: @177127
     /* 177127 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(177172), // Rule ID 1574 //
     /* 177132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 177140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 177143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 177146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 177149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177161 */     // (intrinsic_wo_chain:{ *:[v16i8] } 748:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 177161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
     /* 177164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177170 */     GIR_RootConstrainSelectedInstOperands,
     /* 177171 */     // GIR_Coverage, 1574,
     /* 177171 */     GIR_EraseRootFromParent_Done,
     /* 177172 */   // Label 3436: @177172
     /* 177172 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(177217), // Rule ID 1575 //
     /* 177177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 177185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 177188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177198 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177206 */     // (intrinsic_wo_chain:{ *:[v4i16] } 748:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 177206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
     /* 177209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177215 */     GIR_RootConstrainSelectedInstOperands,
     /* 177216 */     // GIR_Coverage, 1575,
     /* 177216 */     GIR_EraseRootFromParent_Done,
     /* 177217 */   // Label 3437: @177217
     /* 177217 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(177262), // Rule ID 1576 //
     /* 177222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 177230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177251 */     // (intrinsic_wo_chain:{ *:[v8i16] } 748:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
     /* 177254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177260 */     GIR_RootConstrainSelectedInstOperands,
     /* 177261 */     // GIR_Coverage, 1576,
     /* 177261 */     GIR_EraseRootFromParent_Done,
     /* 177262 */   // Label 3438: @177262
     /* 177262 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(177307), // Rule ID 1577 //
     /* 177267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 177275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177296 */     // (intrinsic_wo_chain:{ *:[v2i32] } 748:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 177296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
     /* 177299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177305 */     GIR_RootConstrainSelectedInstOperands,
     /* 177306 */     // GIR_Coverage, 1577,
     /* 177306 */     GIR_EraseRootFromParent_Done,
     /* 177307 */   // Label 3439: @177307
     /* 177307 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(177352), // Rule ID 1578 //
     /* 177312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 177320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177341 */     // (intrinsic_wo_chain:{ *:[v4i32] } 748:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
     /* 177344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177350 */     GIR_RootConstrainSelectedInstOperands,
     /* 177351 */     // GIR_Coverage, 1578,
     /* 177351 */     GIR_EraseRootFromParent_Done,
     /* 177352 */   // Label 3440: @177352
     /* 177352 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(177397), // Rule ID 1579 //
     /* 177357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 177365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 177371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 177374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177386 */     // (intrinsic_wo_chain:{ *:[v2i64] } 748:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 177386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
     /* 177389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177395 */     GIR_RootConstrainSelectedInstOperands,
     /* 177396 */     // GIR_Coverage, 1579,
     /* 177396 */     GIR_EraseRootFromParent_Done,
     /* 177397 */   // Label 3441: @177397
     /* 177397 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(177442), // Rule ID 1580 //
     /* 177402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 177413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 177416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 177419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177431 */     // (intrinsic_wo_chain:{ *:[v8i8] } 751:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 177431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
     /* 177434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177440 */     GIR_RootConstrainSelectedInstOperands,
     /* 177441 */     // GIR_Coverage, 1580,
     /* 177441 */     GIR_EraseRootFromParent_Done,
     /* 177442 */   // Label 3442: @177442
     /* 177442 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(177487), // Rule ID 1581 //
     /* 177447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 177458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 177461 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 177464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177476 */     // (intrinsic_wo_chain:{ *:[v16i8] } 751:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 177476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
     /* 177479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177485 */     GIR_RootConstrainSelectedInstOperands,
     /* 177486 */     // GIR_Coverage, 1581,
     /* 177486 */     GIR_EraseRootFromParent_Done,
     /* 177487 */   // Label 3443: @177487
     /* 177487 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(177532), // Rule ID 1582 //
     /* 177492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 177503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177521 */     // (intrinsic_wo_chain:{ *:[v4i16] } 751:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 177521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
     /* 177524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177530 */     GIR_RootConstrainSelectedInstOperands,
     /* 177531 */     // GIR_Coverage, 1582,
     /* 177531 */     GIR_EraseRootFromParent_Done,
     /* 177532 */   // Label 3444: @177532
     /* 177532 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(177577), // Rule ID 1583 //
     /* 177537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 177548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 177551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 177554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177566 */     // (intrinsic_wo_chain:{ *:[v8i16] } 751:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
     /* 177569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177575 */     GIR_RootConstrainSelectedInstOperands,
     /* 177576 */     // GIR_Coverage, 1583,
     /* 177576 */     GIR_EraseRootFromParent_Done,
     /* 177577 */   // Label 3445: @177577
     /* 177577 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(177622), // Rule ID 1584 //
     /* 177582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 177593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177611 */     // (intrinsic_wo_chain:{ *:[v2i32] } 751:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 177611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
     /* 177614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177620 */     GIR_RootConstrainSelectedInstOperands,
     /* 177621 */     // GIR_Coverage, 1584,
     /* 177621 */     GIR_EraseRootFromParent_Done,
     /* 177622 */   // Label 3446: @177622
     /* 177622 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(177667), // Rule ID 1585 //
     /* 177627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 177641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 177644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177656 */     // (intrinsic_wo_chain:{ *:[v4i32] } 751:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
     /* 177659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177665 */     GIR_RootConstrainSelectedInstOperands,
     /* 177666 */     // GIR_Coverage, 1585,
     /* 177666 */     GIR_EraseRootFromParent_Done,
     /* 177667 */   // Label 3447: @177667
     /* 177667 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(177712), // Rule ID 1586 //
     /* 177672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 177680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 177686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 177689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177701 */     // (intrinsic_wo_chain:{ *:[v2i64] } 751:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 177701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
     /* 177704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177710 */     GIR_RootConstrainSelectedInstOperands,
     /* 177711 */     // GIR_Coverage, 1586,
     /* 177711 */     GIR_EraseRootFromParent_Done,
     /* 177712 */   // Label 3448: @177712
     /* 177712 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(177757), // Rule ID 1614 //
     /* 177717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 177725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177746 */     // (intrinsic_wo_chain:{ *:[f64] } 785:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 177749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177755 */     GIR_RootConstrainSelectedInstOperands,
     /* 177756 */     // GIR_Coverage, 1614,
     /* 177756 */     GIR_EraseRootFromParent_Done,
     /* 177757 */   // Label 3449: @177757
     /* 177757 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(177802), // Rule ID 1615 //
     /* 177762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 177770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177791 */     // (intrinsic_wo_chain:{ *:[f32] } 785:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 177794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177800 */     GIR_RootConstrainSelectedInstOperands,
     /* 177801 */     // GIR_Coverage, 1615,
     /* 177801 */     GIR_EraseRootFromParent_Done,
     /* 177802 */   // Label 3450: @177802
     /* 177802 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(177847), // Rule ID 1616 //
     /* 177807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 177810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 177815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177836 */     // (intrinsic_wo_chain:{ *:[f16] } 785:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 177836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 177839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177845 */     GIR_RootConstrainSelectedInstOperands,
     /* 177846 */     // GIR_Coverage, 1616,
     /* 177846 */     GIR_EraseRootFromParent_Done,
     /* 177847 */   // Label 3451: @177847
     /* 177847 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(177892), // Rule ID 1617 //
     /* 177852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 177860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177881 */     // (intrinsic_wo_chain:{ *:[i64] } 577:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 177884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177890 */     GIR_RootConstrainSelectedInstOperands,
     /* 177891 */     // GIR_Coverage, 1617,
     /* 177891 */     GIR_EraseRootFromParent_Done,
     /* 177892 */   // Label 3452: @177892
     /* 177892 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(177937), // Rule ID 1618 //
     /* 177897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 177905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177926 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 177926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
     /* 177929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177935 */     GIR_RootConstrainSelectedInstOperands,
     /* 177936 */     // GIR_Coverage, 1618,
     /* 177936 */     GIR_EraseRootFromParent_Done,
     /* 177937 */   // Label 3453: @177937
     /* 177937 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(177982), // Rule ID 1619 //
     /* 177942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 177950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177971 */     // (intrinsic_wo_chain:{ *:[i64] } 578:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 177971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 177974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 177980 */     GIR_RootConstrainSelectedInstOperands,
     /* 177981 */     // GIR_Coverage, 1619,
     /* 177981 */     GIR_EraseRootFromParent_Done,
     /* 177982 */   // Label 3454: @177982
     /* 177982 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(178027), // Rule ID 1620 //
     /* 177987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 177995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178016 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 178016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
     /* 178019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178025 */     GIR_RootConstrainSelectedInstOperands,
     /* 178026 */     // GIR_Coverage, 1620,
     /* 178026 */     GIR_EraseRootFromParent_Done,
     /* 178027 */   // Label 3455: @178027
     /* 178027 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(178072), // Rule ID 1627 //
     /* 178032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 178035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178061 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 178061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 178064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178070 */     GIR_RootConstrainSelectedInstOperands,
     /* 178071 */     // GIR_Coverage, 1627,
     /* 178071 */     GIR_EraseRootFromParent_Done,
     /* 178072 */   // Label 3456: @178072
     /* 178072 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(178117), // Rule ID 1628 //
     /* 178077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 178080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178106 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 178106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 178109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178115 */     GIR_RootConstrainSelectedInstOperands,
     /* 178116 */     // GIR_Coverage, 1628,
     /* 178116 */     GIR_EraseRootFromParent_Done,
     /* 178117 */   // Label 3457: @178117
     /* 178117 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(178162), // Rule ID 1629 //
     /* 178122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 178125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 178133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 178136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 178139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178147 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178151 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 178151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 178154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178160 */     GIR_RootConstrainSelectedInstOperands,
     /* 178161 */     // GIR_Coverage, 1629,
     /* 178161 */     GIR_EraseRootFromParent_Done,
     /* 178162 */   // Label 3458: @178162
     /* 178162 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(178207), // Rule ID 1630 //
     /* 178167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 178170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 178175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178196 */     // (intrinsic_wo_chain:{ *:[f64] } 633:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 178196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 178199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178205 */     GIR_RootConstrainSelectedInstOperands,
     /* 178206 */     // GIR_Coverage, 1630,
     /* 178206 */     GIR_EraseRootFromParent_Done,
     /* 178207 */   // Label 3459: @178207
     /* 178207 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(178252), // Rule ID 1631 //
     /* 178212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 178215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 178220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178241 */     // (intrinsic_wo_chain:{ *:[f32] } 633:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 178241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
     /* 178244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178250 */     GIR_RootConstrainSelectedInstOperands,
     /* 178251 */     // GIR_Coverage, 1631,
     /* 178251 */     GIR_EraseRootFromParent_Done,
     /* 178252 */   // Label 3460: @178252
     /* 178252 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(178297), // Rule ID 1632 //
     /* 178257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 178260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 178265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 178268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 178271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 178274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178286 */     // (intrinsic_wo_chain:{ *:[f16] } 633:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 178286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
     /* 178289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178295 */     GIR_RootConstrainSelectedInstOperands,
     /* 178296 */     // GIR_Coverage, 1632,
     /* 178296 */     GIR_EraseRootFromParent_Done,
     /* 178297 */   // Label 3461: @178297
     /* 178297 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(178342), // Rule ID 1633 //
     /* 178302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 178305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 178310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178331 */     // (intrinsic_wo_chain:{ *:[f64] } 640:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 178331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 178334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178340 */     GIR_RootConstrainSelectedInstOperands,
     /* 178341 */     // GIR_Coverage, 1633,
     /* 178341 */     GIR_EraseRootFromParent_Done,
     /* 178342 */   // Label 3462: @178342
     /* 178342 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(178387), // Rule ID 1634 //
     /* 178347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 178350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 178355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178376 */     // (intrinsic_wo_chain:{ *:[f32] } 640:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 178376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
     /* 178379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178385 */     GIR_RootConstrainSelectedInstOperands,
     /* 178386 */     // GIR_Coverage, 1634,
     /* 178386 */     GIR_EraseRootFromParent_Done,
     /* 178387 */   // Label 3463: @178387
     /* 178387 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(178432), // Rule ID 1635 //
     /* 178392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 178395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 178400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 178403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 178406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 178409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178421 */     // (intrinsic_wo_chain:{ *:[f16] } 640:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 178421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
     /* 178424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178430 */     GIR_RootConstrainSelectedInstOperands,
     /* 178431 */     // GIR_Coverage, 1635,
     /* 178431 */     GIR_EraseRootFromParent_Done,
     /* 178432 */   // Label 3464: @178432
     /* 178432 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(178477), // Rule ID 1636 //
     /* 178437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 178445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178462 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178466 */     // (intrinsic_wo_chain:{ *:[v1i64] } 679:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 178469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178475 */     GIR_RootConstrainSelectedInstOperands,
     /* 178476 */     // GIR_Coverage, 1636,
     /* 178476 */     GIR_EraseRootFromParent_Done,
     /* 178477 */   // Label 3465: @178477
     /* 178477 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(178522), // Rule ID 1637 //
     /* 178482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 178490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178511 */     // (intrinsic_wo_chain:{ *:[i32] } 680:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
     /* 178514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178520 */     GIR_RootConstrainSelectedInstOperands,
     /* 178521 */     // GIR_Coverage, 1637,
     /* 178521 */     GIR_EraseRootFromParent_Done,
     /* 178522 */   // Label 3466: @178522
     /* 178522 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(178567), // Rule ID 1638 //
     /* 178527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 178535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178556 */     // (intrinsic_wo_chain:{ *:[i32] } 688:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 178556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
     /* 178559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178565 */     GIR_RootConstrainSelectedInstOperands,
     /* 178566 */     // GIR_Coverage, 1638,
     /* 178566 */     GIR_EraseRootFromParent_Done,
     /* 178567 */   // Label 3467: @178567
     /* 178567 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(178612), // Rule ID 1639 //
     /* 178572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 178580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178601 */     // (intrinsic_wo_chain:{ *:[v1i64] } 691:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 178604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178610 */     GIR_RootConstrainSelectedInstOperands,
     /* 178611 */     // GIR_Coverage, 1639,
     /* 178611 */     GIR_EraseRootFromParent_Done,
     /* 178612 */   // Label 3468: @178612
     /* 178612 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(178657), // Rule ID 1640 //
     /* 178617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 178625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178646 */     // (intrinsic_wo_chain:{ *:[v1i64] } 694:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 178649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178655 */     GIR_RootConstrainSelectedInstOperands,
     /* 178656 */     // GIR_Coverage, 1640,
     /* 178656 */     GIR_EraseRootFromParent_Done,
     /* 178657 */   // Label 3469: @178657
     /* 178657 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(178702), // Rule ID 1641 //
     /* 178662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 178670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178691 */     // (intrinsic_wo_chain:{ *:[v1i64] } 698:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 178694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178698 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178700 */     GIR_RootConstrainSelectedInstOperands,
     /* 178701 */     // GIR_Coverage, 1641,
     /* 178701 */     GIR_EraseRootFromParent_Done,
     /* 178702 */   // Label 3470: @178702
     /* 178702 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(178747), // Rule ID 1642 //
     /* 178707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 178715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178736 */     // (intrinsic_wo_chain:{ *:[v1i64] } 702:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 178739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178745 */     GIR_RootConstrainSelectedInstOperands,
     /* 178746 */     // GIR_Coverage, 1642,
     /* 178746 */     GIR_EraseRootFromParent_Done,
     /* 178747 */   // Label 3471: @178747
     /* 178747 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(178792), // Rule ID 1643 //
     /* 178752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 178760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178781 */     // (intrinsic_wo_chain:{ *:[v1i64] } 703:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 178784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178790 */     GIR_RootConstrainSelectedInstOperands,
     /* 178791 */     // GIR_Coverage, 1643,
     /* 178791 */     GIR_EraseRootFromParent_Done,
     /* 178792 */   // Label 3472: @178792
     /* 178792 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(178837), // Rule ID 1645 //
     /* 178797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 178805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178826 */     // (intrinsic_wo_chain:{ *:[v1i64] } 739:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 178829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178835 */     GIR_RootConstrainSelectedInstOperands,
     /* 178836 */     // GIR_Coverage, 1645,
     /* 178836 */     GIR_EraseRootFromParent_Done,
     /* 178837 */   // Label 3473: @178837
     /* 178837 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(178882), // Rule ID 1646 //
     /* 178842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 178850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178871 */     // (intrinsic_wo_chain:{ *:[v1i64] } 740:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 178874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178880 */     GIR_RootConstrainSelectedInstOperands,
     /* 178881 */     // GIR_Coverage, 1646,
     /* 178881 */     GIR_EraseRootFromParent_Done,
     /* 178882 */   // Label 3474: @178882
     /* 178882 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(178927), // Rule ID 1647 //
     /* 178887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 178895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178916 */     // (intrinsic_wo_chain:{ *:[v1i64] } 742:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 178919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178925 */     GIR_RootConstrainSelectedInstOperands,
     /* 178926 */     // GIR_Coverage, 1647,
     /* 178926 */     GIR_EraseRootFromParent_Done,
     /* 178927 */   // Label 3475: @178927
     /* 178927 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(178972), // Rule ID 1648 //
     /* 178932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 178940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178961 */     // (intrinsic_wo_chain:{ *:[v1i64] } 744:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 178961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 178964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 178970 */     GIR_RootConstrainSelectedInstOperands,
     /* 178971 */     // GIR_Coverage, 1648,
     /* 178971 */     GIR_EraseRootFromParent_Done,
     /* 178972 */   // Label 3476: @178972
     /* 178972 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(179017), // Rule ID 1649 //
     /* 178977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 178985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179006 */     // (intrinsic_wo_chain:{ *:[v1i64] } 748:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 179006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 179009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179015 */     GIR_RootConstrainSelectedInstOperands,
     /* 179016 */     // GIR_Coverage, 1649,
     /* 179016 */     GIR_EraseRootFromParent_Done,
     /* 179017 */   // Label 3477: @179017
     /* 179017 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(179062), // Rule ID 1650 //
     /* 179022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 179030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179051 */     // (intrinsic_wo_chain:{ *:[v1i64] } 751:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 179051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 179054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179060 */     GIR_RootConstrainSelectedInstOperands,
     /* 179061 */     // GIR_Coverage, 1650,
     /* 179061 */     GIR_EraseRootFromParent_Done,
     /* 179062 */   // Label 3478: @179062
     /* 179062 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(179107), // Rule ID 1651 //
     /* 179067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 179075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179096 */     // (intrinsic_wo_chain:{ *:[i64] } 684:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 179096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
     /* 179099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179105 */     GIR_RootConstrainSelectedInstOperands,
     /* 179106 */     // GIR_Coverage, 1651,
     /* 179106 */     GIR_EraseRootFromParent_Done,
     /* 179107 */   // Label 3479: @179107
     /* 179107 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(179152), // Rule ID 1665 //
     /* 179112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 179120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179141 */     // (intrinsic_wo_chain:{ *:[i64] } 715:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 179141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 179144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179150 */     GIR_RootConstrainSelectedInstOperands,
     /* 179151 */     // GIR_Coverage, 1665,
     /* 179151 */     GIR_EraseRootFromParent_Done,
     /* 179152 */   // Label 3480: @179152
     /* 179152 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(179197), // Rule ID 1666 //
     /* 179157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 179165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179186 */     // (intrinsic_wo_chain:{ *:[i32] } 715:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 179186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
     /* 179189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179195 */     GIR_RootConstrainSelectedInstOperands,
     /* 179196 */     // GIR_Coverage, 1666,
     /* 179196 */     GIR_EraseRootFromParent_Done,
     /* 179197 */   // Label 3481: @179197
     /* 179197 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(179242), // Rule ID 1671 //
     /* 179202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 179210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 179213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 179216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 179219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179231 */     // (intrinsic_wo_chain:{ *:[i64] } 754:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 179231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 179234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179240 */     GIR_RootConstrainSelectedInstOperands,
     /* 179241 */     // GIR_Coverage, 1671,
     /* 179241 */     GIR_EraseRootFromParent_Done,
     /* 179242 */   // Label 3482: @179242
     /* 179242 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(179287), // Rule ID 1672 //
     /* 179247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 179255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 179258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 179261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 179264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 179276 */     // (intrinsic_wo_chain:{ *:[i32] } 754:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 179276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
     /* 179279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179285 */     GIR_RootConstrainSelectedInstOperands,
     /* 179286 */     // GIR_Coverage, 1672,
     /* 179286 */     GIR_EraseRootFromParent_Done,
     /* 179287 */   // Label 3483: @179287
     /* 179287 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(179332), // Rule ID 1673 //
     /* 179292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 179300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 179303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179321 */     // (intrinsic_wo_chain:{ *:[v8i8] } 569:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 179321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 179324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179330 */     GIR_RootConstrainSelectedInstOperands,
     /* 179331 */     // GIR_Coverage, 1673,
     /* 179331 */     GIR_EraseRootFromParent_Done,
     /* 179332 */   // Label 3484: @179332
     /* 179332 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(179377), // Rule ID 1674 //
     /* 179337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 179345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179366 */     // (intrinsic_wo_chain:{ *:[v4i16] } 569:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 179369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179375 */     GIR_RootConstrainSelectedInstOperands,
     /* 179376 */     // GIR_Coverage, 1674,
     /* 179376 */     GIR_EraseRootFromParent_Done,
     /* 179377 */   // Label 3485: @179377
     /* 179377 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(179422), // Rule ID 1675 //
     /* 179382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 179390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179411 */     // (intrinsic_wo_chain:{ *:[v2i32] } 569:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 179414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179420 */     GIR_RootConstrainSelectedInstOperands,
     /* 179421 */     // GIR_Coverage, 1675,
     /* 179421 */     GIR_EraseRootFromParent_Done,
     /* 179422 */   // Label 3486: @179422
     /* 179422 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(179467), // Rule ID 1676 //
     /* 179427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 179435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 179438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179456 */     // (intrinsic_wo_chain:{ *:[v8i8] } 714:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 179456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 179459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179465 */     GIR_RootConstrainSelectedInstOperands,
     /* 179466 */     // GIR_Coverage, 1676,
     /* 179466 */     GIR_EraseRootFromParent_Done,
     /* 179467 */   // Label 3487: @179467
     /* 179467 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(179512), // Rule ID 1677 //
     /* 179472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 179480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179501 */     // (intrinsic_wo_chain:{ *:[v4i16] } 714:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 179504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179510 */     GIR_RootConstrainSelectedInstOperands,
     /* 179511 */     // GIR_Coverage, 1677,
     /* 179511 */     GIR_EraseRootFromParent_Done,
     /* 179512 */   // Label 3488: @179512
     /* 179512 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(179557), // Rule ID 1678 //
     /* 179517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 179525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179546 */     // (intrinsic_wo_chain:{ *:[v2i32] } 714:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 179549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179555 */     GIR_RootConstrainSelectedInstOperands,
     /* 179556 */     // GIR_Coverage, 1678,
     /* 179556 */     GIR_EraseRootFromParent_Done,
     /* 179557 */   // Label 3489: @179557
     /* 179557 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(179602), // Rule ID 1679 //
     /* 179562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 179570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 179573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179591 */     // (intrinsic_wo_chain:{ *:[v8i8] } 656:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 179591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 179594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179600 */     GIR_RootConstrainSelectedInstOperands,
     /* 179601 */     // GIR_Coverage, 1679,
     /* 179601 */     GIR_EraseRootFromParent_Done,
     /* 179602 */   // Label 3490: @179602
     /* 179602 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(179647), // Rule ID 1680 //
     /* 179607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 179615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179636 */     // (intrinsic_wo_chain:{ *:[v4i16] } 656:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 179639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179645 */     GIR_RootConstrainSelectedInstOperands,
     /* 179646 */     // GIR_Coverage, 1680,
     /* 179646 */     GIR_EraseRootFromParent_Done,
     /* 179647 */   // Label 3491: @179647
     /* 179647 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(179692), // Rule ID 1681 //
     /* 179652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 179660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179681 */     // (intrinsic_wo_chain:{ *:[v2i32] } 656:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 179684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179690 */     GIR_RootConstrainSelectedInstOperands,
     /* 179691 */     // GIR_Coverage, 1681,
     /* 179691 */     GIR_EraseRootFromParent_Done,
     /* 179692 */   // Label 3492: @179692
     /* 179692 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(179737), // Rule ID 1682 //
     /* 179697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 179705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 179708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179726 */     // (intrinsic_wo_chain:{ *:[v8i8] } 658:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 179726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
     /* 179729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179735 */     GIR_RootConstrainSelectedInstOperands,
     /* 179736 */     // GIR_Coverage, 1682,
     /* 179736 */     GIR_EraseRootFromParent_Done,
     /* 179737 */   // Label 3493: @179737
     /* 179737 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(179782), // Rule ID 1683 //
     /* 179742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 179750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179771 */     // (intrinsic_wo_chain:{ *:[v4i16] } 658:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 179771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
     /* 179774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179780 */     GIR_RootConstrainSelectedInstOperands,
     /* 179781 */     // GIR_Coverage, 1683,
     /* 179781 */     GIR_EraseRootFromParent_Done,
     /* 179782 */   // Label 3494: @179782
     /* 179782 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(179827), // Rule ID 1684 //
     /* 179787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 179795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179816 */     // (intrinsic_wo_chain:{ *:[v2i32] } 658:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 179816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
     /* 179819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179825 */     GIR_RootConstrainSelectedInstOperands,
     /* 179826 */     // GIR_Coverage, 1684,
     /* 179826 */     GIR_EraseRootFromParent_Done,
     /* 179827 */   // Label 3495: @179827
     /* 179827 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(179872), // Rule ID 1750 //
     /* 179832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 179840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179861 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 179861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
     /* 179864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179870 */     GIR_RootConstrainSelectedInstOperands,
     /* 179871 */     // GIR_Coverage, 1750,
     /* 179871 */     GIR_EraseRootFromParent_Done,
     /* 179872 */   // Label 3496: @179872
     /* 179872 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(179917), // Rule ID 1752 //
     /* 179877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 179885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179906 */     // (intrinsic_wo_chain:{ *:[v2i64] } 683:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 179906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
     /* 179909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 179915 */     GIR_RootConstrainSelectedInstOperands,
     /* 179916 */     // GIR_Coverage, 1752,
     /* 179916 */     GIR_EraseRootFromParent_Done,
     /* 179917 */   // Label 3497: @179917
     /* 179917 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(179962), // Rule ID 2301 //
     /* 179922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 179925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 179930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 179933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 179936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 179939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179951 */     // (intrinsic_wo_chain:{ *:[v16i8] } 512:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 179951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 179954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 179956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 179958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 179960 */     GIR_RootConstrainSelectedInstOperands,
     /* 179961 */     // GIR_Coverage, 2301,
     /* 179961 */     GIR_EraseRootFromParent_Done,
     /* 179962 */   // Label 3498: @179962
     /* 179962 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(180007), // Rule ID 2302 //
     /* 179967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 179970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 179975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 179978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 179981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 179984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179996 */     // (intrinsic_wo_chain:{ *:[v16i8] } 511:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 179996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 179999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 180005 */     GIR_RootConstrainSelectedInstOperands,
     /* 180006 */     // GIR_Coverage, 2302,
     /* 180006 */     GIR_EraseRootFromParent_Done,
     /* 180007 */   // Label 3499: @180007
     /* 180007 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(180052), // Rule ID 2313 //
     /* 180012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 180015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
     /* 180020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180041 */     // (intrinsic_wo_chain:{ *:[v4i32] } 525:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 180041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
     /* 180044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 180050 */     GIR_RootConstrainSelectedInstOperands,
     /* 180051 */     // GIR_Coverage, 2313,
     /* 180051 */     GIR_EraseRootFromParent_Done,
     /* 180052 */   // Label 3500: @180052
     /* 180052 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(180097), // Rule ID 2314 //
     /* 180057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 180060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
     /* 180065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180086 */     // (intrinsic_wo_chain:{ *:[v4i32] } 528:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 180086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
     /* 180089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 180095 */     GIR_RootConstrainSelectedInstOperands,
     /* 180096 */     // GIR_Coverage, 2314,
     /* 180096 */     GIR_EraseRootFromParent_Done,
     /* 180097 */   // Label 3501: @180097
     /* 180097 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(180142), // Rule ID 2337 //
     /* 180102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 180105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 180110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 180113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 180116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 180119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180131 */     // (intrinsic_wo_chain:{ *:[v4f16] } 631:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 180131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
     /* 180134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180140 */     GIR_RootConstrainSelectedInstOperands,
     /* 180141 */     // GIR_Coverage, 2337,
     /* 180141 */     GIR_EraseRootFromParent_Done,
     /* 180142 */   // Label 3502: @180142
     /* 180142 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(180187), // Rule ID 2338 //
     /* 180147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 180150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 180155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 180158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 180161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 180164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180176 */     // (intrinsic_wo_chain:{ *:[v8f16] } 631:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 180176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
     /* 180179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180185 */     GIR_RootConstrainSelectedInstOperands,
     /* 180186 */     // GIR_Coverage, 2338,
     /* 180186 */     GIR_EraseRootFromParent_Done,
     /* 180187 */   // Label 3503: @180187
     /* 180187 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(180232), // Rule ID 2339 //
     /* 180192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 180195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 180200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180221 */     // (intrinsic_wo_chain:{ *:[v2f32] } 631:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 180221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
     /* 180224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180230 */     GIR_RootConstrainSelectedInstOperands,
     /* 180231 */     // GIR_Coverage, 2339,
     /* 180231 */     GIR_EraseRootFromParent_Done,
     /* 180232 */   // Label 3504: @180232
     /* 180232 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(180277), // Rule ID 2340 //
     /* 180237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 180240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 180245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180266 */     // (intrinsic_wo_chain:{ *:[v4f32] } 631:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 180266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
     /* 180269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180275 */     GIR_RootConstrainSelectedInstOperands,
     /* 180276 */     // GIR_Coverage, 2340,
     /* 180276 */     GIR_EraseRootFromParent_Done,
     /* 180277 */   // Label 3505: @180277
     /* 180277 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(180322), // Rule ID 2341 //
     /* 180282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 180285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 180290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180311 */     // (intrinsic_wo_chain:{ *:[v2f64] } 631:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 180311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
     /* 180314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180320 */     GIR_RootConstrainSelectedInstOperands,
     /* 180321 */     // GIR_Coverage, 2341,
     /* 180321 */     GIR_EraseRootFromParent_Done,
     /* 180322 */   // Label 3506: @180322
     /* 180322 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(180367), // Rule ID 2342 //
     /* 180327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 180335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 180338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 180341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 180344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180356 */     // (intrinsic_wo_chain:{ *:[v4f16] } 581:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 180356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 180359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180365 */     GIR_RootConstrainSelectedInstOperands,
     /* 180366 */     // GIR_Coverage, 2342,
     /* 180366 */     GIR_EraseRootFromParent_Done,
     /* 180367 */   // Label 3507: @180367
     /* 180367 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(180412), // Rule ID 2345 //
     /* 180372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 180380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 180383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 180386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 180389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180401 */     // (intrinsic_wo_chain:{ *:[v8f16] } 581:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 180401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 180404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180410 */     GIR_RootConstrainSelectedInstOperands,
     /* 180411 */     // GIR_Coverage, 2345,
     /* 180411 */     GIR_EraseRootFromParent_Done,
     /* 180412 */   // Label 3508: @180412
     /* 180412 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(180457), // Rule ID 2348 //
     /* 180417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 180425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180446 */     // (intrinsic_wo_chain:{ *:[v2f32] } 581:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 180446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 180449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180455 */     GIR_RootConstrainSelectedInstOperands,
     /* 180456 */     // GIR_Coverage, 2348,
     /* 180456 */     GIR_EraseRootFromParent_Done,
     /* 180457 */   // Label 3509: @180457
     /* 180457 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(180502), // Rule ID 2351 //
     /* 180462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 180470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180491 */     // (intrinsic_wo_chain:{ *:[v4f32] } 581:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 180491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 180494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180500 */     GIR_RootConstrainSelectedInstOperands,
     /* 180501 */     // GIR_Coverage, 2351,
     /* 180501 */     GIR_EraseRootFromParent_Done,
     /* 180502 */   // Label 3510: @180502
     /* 180502 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(180547), // Rule ID 2354 //
     /* 180507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 180515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180536 */     // (intrinsic_wo_chain:{ *:[v2f64] } 581:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 180536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 180539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180545 */     GIR_RootConstrainSelectedInstOperands,
     /* 180546 */     // GIR_Coverage, 2354,
     /* 180546 */     GIR_EraseRootFromParent_Done,
     /* 180547 */   // Label 3511: @180547
     /* 180547 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(180592), // Rule ID 2357 //
     /* 180552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 180563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 180566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 180569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180581 */     // (intrinsic_wo_chain:{ *:[v4f16] } 582:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 180581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 180584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180590 */     GIR_RootConstrainSelectedInstOperands,
     /* 180591 */     // GIR_Coverage, 2357,
     /* 180591 */     GIR_EraseRootFromParent_Done,
     /* 180592 */   // Label 3512: @180592
     /* 180592 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(180637), // Rule ID 2360 //
     /* 180597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 180608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 180611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 180614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180626 */     // (intrinsic_wo_chain:{ *:[v8f16] } 582:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 180626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 180629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180635 */     GIR_RootConstrainSelectedInstOperands,
     /* 180636 */     // GIR_Coverage, 2360,
     /* 180636 */     GIR_EraseRootFromParent_Done,
     /* 180637 */   // Label 3513: @180637
     /* 180637 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(180682), // Rule ID 2363 //
     /* 180642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 180656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 180659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180671 */     // (intrinsic_wo_chain:{ *:[v2f32] } 582:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 180671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 180674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180680 */     GIR_RootConstrainSelectedInstOperands,
     /* 180681 */     // GIR_Coverage, 2363,
     /* 180681 */     GIR_EraseRootFromParent_Done,
     /* 180682 */   // Label 3514: @180682
     /* 180682 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(180727), // Rule ID 2366 //
     /* 180687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 180698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 180704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180716 */     // (intrinsic_wo_chain:{ *:[v4f32] } 582:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 180716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 180719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180725 */     GIR_RootConstrainSelectedInstOperands,
     /* 180726 */     // GIR_Coverage, 2366,
     /* 180726 */     GIR_EraseRootFromParent_Done,
     /* 180727 */   // Label 3515: @180727
     /* 180727 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(180772), // Rule ID 2369 //
     /* 180732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 180735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 180740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 180743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 180749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180761 */     // (intrinsic_wo_chain:{ *:[v2f64] } 582:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 180761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 180764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180770 */     GIR_RootConstrainSelectedInstOperands,
     /* 180771 */     // GIR_Coverage, 2369,
     /* 180771 */     GIR_EraseRootFromParent_Done,
     /* 180772 */   // Label 3516: @180772
     /* 180772 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(180817), // Rule ID 2506 //
     /* 180777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 180785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180806 */     // (intrinsic_wo_chain:{ *:[i64] } 679:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 180806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 180809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180815 */     GIR_RootConstrainSelectedInstOperands,
     /* 180816 */     // GIR_Coverage, 2506,
     /* 180816 */     GIR_EraseRootFromParent_Done,
     /* 180817 */   // Label 3517: @180817
     /* 180817 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(180862), // Rule ID 2507 //
     /* 180822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 180830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180851 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 180851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
     /* 180854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180860 */     GIR_RootConstrainSelectedInstOperands,
     /* 180861 */     // GIR_Coverage, 2507,
     /* 180861 */     GIR_EraseRootFromParent_Done,
     /* 180862 */   // Label 3518: @180862
     /* 180862 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(180907), // Rule ID 2508 //
     /* 180867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 180875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180892 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180896 */     // (intrinsic_wo_chain:{ *:[v1f64] } 785:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 180896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 180899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180905 */     GIR_RootConstrainSelectedInstOperands,
     /* 180906 */     // GIR_Coverage, 2508,
     /* 180906 */     GIR_EraseRootFromParent_Done,
     /* 180907 */   // Label 3519: @180907
     /* 180907 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(180952), // Rule ID 2509 //
     /* 180912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 180920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180941 */     // (intrinsic_wo_chain:{ *:[v1i64] } 577:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 180941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 180944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 180950 */     GIR_RootConstrainSelectedInstOperands,
     /* 180951 */     // GIR_Coverage, 2509,
     /* 180951 */     GIR_EraseRootFromParent_Done,
     /* 180952 */   // Label 3520: @180952
     /* 180952 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(180997), // Rule ID 2514 //
     /* 180957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 180965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180986 */     // (intrinsic_wo_chain:{ *:[v1i64] } 715:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 180986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 180989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 180991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 180995 */     GIR_RootConstrainSelectedInstOperands,
     /* 180996 */     // GIR_Coverage, 2514,
     /* 180996 */     GIR_EraseRootFromParent_Done,
     /* 180997 */   // Label 3521: @180997
     /* 180997 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(181042), // Rule ID 2632 //
     /* 181002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 181010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 181019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181031 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 181031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
     /* 181034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 181036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 181038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181040 */     GIR_RootConstrainSelectedInstOperands,
     /* 181041 */     // GIR_Coverage, 2632,
     /* 181041 */     GIR_EraseRootFromParent_Done,
     /* 181042 */   // Label 3522: @181042
     /* 181042 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(181087), // Rule ID 2633 //
     /* 181047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 181055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 181064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181076 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 181076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
     /* 181079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 181081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 181083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181085 */     GIR_RootConstrainSelectedInstOperands,
     /* 181086 */     // GIR_Coverage, 2633,
     /* 181086 */     GIR_EraseRootFromParent_Done,
     /* 181087 */   // Label 3523: @181087
     /* 181087 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(181132), // Rule ID 2634 //
     /* 181092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 181100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 181109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181121 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 181121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
     /* 181124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 181126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 181128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181130 */     GIR_RootConstrainSelectedInstOperands,
     /* 181131 */     // GIR_Coverage, 2634,
     /* 181131 */     GIR_EraseRootFromParent_Done,
     /* 181132 */   // Label 3524: @181132
     /* 181132 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(181177), // Rule ID 2635 //
     /* 181137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 181145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 181154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 181162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181166 */     // (intrinsic_wo_chain:{ *:[i32] } 2011:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 181166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
     /* 181169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 181171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 181173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181175 */     GIR_RootConstrainSelectedInstOperands,
     /* 181176 */     // GIR_Coverage, 2635,
     /* 181176 */     GIR_EraseRootFromParent_Done,
     /* 181177 */   // Label 3525: @181177
     /* 181177 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(181222), // Rule ID 2636 //
     /* 181182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 181190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 181199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181211 */     // (intrinsic_wo_chain:{ *:[i64] } 1801:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 181211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
     /* 181214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 181216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 181218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181220 */     GIR_RootConstrainSelectedInstOperands,
     /* 181221 */     // GIR_Coverage, 2636,
     /* 181221 */     GIR_EraseRootFromParent_Done,
     /* 181222 */   // Label 3526: @181222
     /* 181222 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(181267), // Rule ID 2637 //
     /* 181227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 181235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 181244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181256 */     // (intrinsic_wo_chain:{ *:[i64] } 1801:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 181256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
     /* 181259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 181261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 181263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181265 */     GIR_RootConstrainSelectedInstOperands,
     /* 181266 */     // GIR_Coverage, 2637,
     /* 181266 */     GIR_EraseRootFromParent_Done,
     /* 181267 */   // Label 3527: @181267
     /* 181267 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(181312), // Rule ID 2638 //
     /* 181272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 181280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 181289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181301 */     // (intrinsic_wo_chain:{ *:[i64] } 1801:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 181301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
     /* 181304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 181306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 181308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181310 */     GIR_RootConstrainSelectedInstOperands,
     /* 181311 */     // GIR_Coverage, 2638,
     /* 181311 */     GIR_EraseRootFromParent_Done,
     /* 181312 */   // Label 3528: @181312
     /* 181312 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(181357), // Rule ID 2639 //
     /* 181317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 181320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 181325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 181334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 181342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 181346 */     // (intrinsic_wo_chain:{ *:[i64] } 1801:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 181346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
     /* 181349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 181351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 181353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181355 */     GIR_RootConstrainSelectedInstOperands,
     /* 181356 */     // GIR_Coverage, 2639,
     /* 181356 */     GIR_EraseRootFromParent_Done,
     /* 181357 */   // Label 3529: @181357
     /* 181357 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(181402), // Rule ID 3803 //
     /* 181362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 181365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
     /* 181370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 181373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181391 */     // (intrinsic_wo_chain:{ *:[v2i64] } 532:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 181391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
     /* 181394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 181396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 181398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 181400 */     GIR_RootConstrainSelectedInstOperands,
     /* 181401 */     // GIR_Coverage, 3803,
     /* 181401 */     GIR_EraseRootFromParent_Done,
     /* 181402 */   // Label 3530: @181402
     /* 181402 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(181447), // Rule ID 3831 //
     /* 181407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 181410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
     /* 181415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 181418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181432 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181436 */     // (intrinsic_wo_chain:{ *:[v2i64] } 519:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 181436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
     /* 181439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 181441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 181443 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 181445 */     GIR_RootConstrainSelectedInstOperands,
     /* 181446 */     // GIR_Coverage, 3831,
     /* 181446 */     GIR_EraseRootFromParent_Done,
     /* 181447 */   // Label 3531: @181447
     /* 181447 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(181492), // Rule ID 3841 //
     /* 181452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 181455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
     /* 181460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181481 */     // (intrinsic_wo_chain:{ *:[v4i32] } 542:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 181481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
     /* 181484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 181486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 181488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 181490 */     GIR_RootConstrainSelectedInstOperands,
     /* 181491 */     // GIR_Coverage, 3841,
     /* 181491 */     GIR_EraseRootFromParent_Done,
     /* 181492 */   // Label 3532: @181492
     /* 181492 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(181537), // Rule ID 3842 //
     /* 181497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 181500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
     /* 181505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181526 */     // (intrinsic_wo_chain:{ *:[v4i32] } 541:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 181526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
     /* 181529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 181531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 181533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 181535 */     GIR_RootConstrainSelectedInstOperands,
     /* 181536 */     // GIR_Coverage, 3842,
     /* 181536 */     GIR_EraseRootFromParent_Done,
     /* 181537 */   // Label 3533: @181537
     /* 181537 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(181585), // Rule ID 3843 //
     /* 181542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 181545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 181556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 181559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181571 */     // (intrinsic_wo_chain:{ *:[v4f16] } 756:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 181571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 181574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181583 */     GIR_RootConstrainSelectedInstOperands,
     /* 181584 */     // GIR_Coverage, 3843,
     /* 181584 */     GIR_EraseRootFromParent_Done,
     /* 181585 */   // Label 3534: @181585
     /* 181585 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(181633), // Rule ID 3844 //
     /* 181590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 181593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 181604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 181607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181619 */     // (intrinsic_wo_chain:{ *:[v4f16] } 755:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 181619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 181622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 181631 */     GIR_RootConstrainSelectedInstOperands,
     /* 181632 */     // GIR_Coverage, 3844,
     /* 181632 */     GIR_EraseRootFromParent_Done,
     /* 181633 */   // Label 3535: @181633
     /* 181633 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(181681), // Rule ID 3845 //
     /* 181638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 181641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 181649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 181655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181667 */     // (intrinsic_wo_chain:{ *:[v8f16] } 756:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 181667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 181670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181679 */     GIR_RootConstrainSelectedInstOperands,
     /* 181680 */     // GIR_Coverage, 3845,
     /* 181680 */     GIR_EraseRootFromParent_Done,
     /* 181681 */   // Label 3536: @181681
     /* 181681 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(181729), // Rule ID 3846 //
     /* 181686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 181689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 181697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 181703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181715 */     // (intrinsic_wo_chain:{ *:[v8f16] } 755:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 181715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 181718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181724 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 181727 */     GIR_RootConstrainSelectedInstOperands,
     /* 181728 */     // GIR_Coverage, 3846,
     /* 181728 */     GIR_EraseRootFromParent_Done,
     /* 181729 */   // Label 3537: @181729
     /* 181729 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(181777), // Rule ID 3847 //
     /* 181734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 181748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 181751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181763 */     // (intrinsic_wo_chain:{ *:[v2f32] } 756:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 181763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 181766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181775 */     GIR_RootConstrainSelectedInstOperands,
     /* 181776 */     // GIR_Coverage, 3847,
     /* 181776 */     GIR_EraseRootFromParent_Done,
     /* 181777 */   // Label 3538: @181777
     /* 181777 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(181825), // Rule ID 3848 //
     /* 181782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 181796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 181799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181811 */     // (intrinsic_wo_chain:{ *:[v2f32] } 755:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 181811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 181814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 181823 */     GIR_RootConstrainSelectedInstOperands,
     /* 181824 */     // GIR_Coverage, 3848,
     /* 181824 */     GIR_EraseRootFromParent_Done,
     /* 181825 */   // Label 3539: @181825
     /* 181825 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(181873), // Rule ID 3849 //
     /* 181830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181859 */     // (intrinsic_wo_chain:{ *:[v4f32] } 756:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 181859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 181862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181871 */     GIR_RootConstrainSelectedInstOperands,
     /* 181872 */     // GIR_Coverage, 3849,
     /* 181872 */     GIR_EraseRootFromParent_Done,
     /* 181873 */   // Label 3540: @181873
     /* 181873 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(181921), // Rule ID 3850 //
     /* 181878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 181889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 181895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181907 */     // (intrinsic_wo_chain:{ *:[v4f32] } 755:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 181907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 181910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 181919 */     GIR_RootConstrainSelectedInstOperands,
     /* 181920 */     // GIR_Coverage, 3850,
     /* 181920 */     GIR_EraseRootFromParent_Done,
     /* 181921 */   // Label 3541: @181921
     /* 181921 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(181969), // Rule ID 3851 //
     /* 181926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 181934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 181937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181955 */     // (intrinsic_wo_chain:{ *:[v2f64] } 756:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 181955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 181958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 181964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 181967 */     GIR_RootConstrainSelectedInstOperands,
     /* 181968 */     // GIR_Coverage, 3851,
     /* 181968 */     GIR_EraseRootFromParent_Done,
     /* 181969 */   // Label 3542: @181969
     /* 181969 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(182017), // Rule ID 3852 //
     /* 181974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 181977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 181982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 181985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 181991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 182003 */     // (intrinsic_wo_chain:{ *:[v2f64] } 755:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 182003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 182006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 182015 */     GIR_RootConstrainSelectedInstOperands,
     /* 182016 */     // GIR_Coverage, 3852,
     /* 182016 */     GIR_EraseRootFromParent_Done,
     /* 182017 */   // Label 3543: @182017
     /* 182017 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(182059), // Rule ID 3917 //
     /* 182022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 182027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182048 */     // (intrinsic_wo_chain:{ *:[i32] } 2155:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 182048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /* 182051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182057 */     GIR_RootConstrainSelectedInstOperands,
     /* 182058 */     // GIR_Coverage, 3917,
     /* 182058 */     GIR_EraseRootFromParent_Done,
     /* 182059 */   // Label 3544: @182059
     /* 182059 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(182101), // Rule ID 3918 //
     /* 182064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 182069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182090 */     // (intrinsic_wo_chain:{ *:[i64] } 2155:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 182090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /* 182093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182099 */     GIR_RootConstrainSelectedInstOperands,
     /* 182100 */     // GIR_Coverage, 3918,
     /* 182100 */     GIR_EraseRootFromParent_Done,
     /* 182101 */   // Label 3545: @182101
     /* 182101 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(182143), // Rule ID 3919 //
     /* 182106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 182111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 182132 */     // (intrinsic_wo_chain:{ *:[i32] } 779:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 182132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /* 182135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182141 */     GIR_RootConstrainSelectedInstOperands,
     /* 182142 */     // GIR_Coverage, 3919,
     /* 182142 */     GIR_EraseRootFromParent_Done,
     /* 182143 */   // Label 3546: @182143
     /* 182143 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(182185), // Rule ID 3920 //
     /* 182148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 182153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182174 */     // (intrinsic_wo_chain:{ *:[i64] } 779:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 182174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /* 182177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182183 */     GIR_RootConstrainSelectedInstOperands,
     /* 182184 */     // GIR_Coverage, 3920,
     /* 182184 */     GIR_EraseRootFromParent_Done,
     /* 182185 */   // Label 3547: @182185
     /* 182185 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(182227), // Rule ID 5190 //
     /* 182190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 182195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182216 */     // (intrinsic_wo_chain:{ *:[v1f64] } 576:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 182216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 182219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182225 */     GIR_RootConstrainSelectedInstOperands,
     /* 182226 */     // GIR_Coverage, 5190,
     /* 182226 */     GIR_EraseRootFromParent_Done,
     /* 182227 */   // Label 3548: @182227
     /* 182227 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(182272), // Rule ID 5194 //
     /* 182232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 182240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182261 */     // (intrinsic_wo_chain:{ *:[v1i64] } 578:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 182261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 182264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182270 */     GIR_RootConstrainSelectedInstOperands,
     /* 182271 */     // GIR_Coverage, 5194,
     /* 182271 */     GIR_EraseRootFromParent_Done,
     /* 182272 */   // Label 3549: @182272
     /* 182272 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(182317), // Rule ID 5198 //
     /* 182277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 182285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182306 */     // (intrinsic_wo_chain:{ *:[v1f64] } 610:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 182306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 182309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182315 */     GIR_RootConstrainSelectedInstOperands,
     /* 182316 */     // GIR_Coverage, 5198,
     /* 182316 */     GIR_EraseRootFromParent_Done,
     /* 182317 */   // Label 3550: @182317
     /* 182317 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(182362), // Rule ID 5199 //
     /* 182322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 182330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182351 */     // (intrinsic_wo_chain:{ *:[v1f64] } 633:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 182351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 182354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182360 */     GIR_RootConstrainSelectedInstOperands,
     /* 182361 */     // GIR_Coverage, 5199,
     /* 182361 */     GIR_EraseRootFromParent_Done,
     /* 182362 */   // Label 3551: @182362
     /* 182362 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(182407), // Rule ID 5200 //
     /* 182367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 182375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182396 */     // (intrinsic_wo_chain:{ *:[v1f64] } 640:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 182396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 182399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182405 */     GIR_RootConstrainSelectedInstOperands,
     /* 182406 */     // GIR_Coverage, 5200,
     /* 182406 */     GIR_EraseRootFromParent_Done,
     /* 182407 */   // Label 3552: @182407
     /* 182407 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(182452), // Rule ID 5201 //
     /* 182412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 182420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182441 */     // (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 182444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182450 */     GIR_RootConstrainSelectedInstOperands,
     /* 182451 */     // GIR_Coverage, 5201,
     /* 182451 */     GIR_EraseRootFromParent_Done,
     /* 182452 */   // Label 3553: @182452
     /* 182452 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(182497), // Rule ID 5202 //
     /* 182457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 182465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182486 */     // (intrinsic_wo_chain:{ *:[i32] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
     /* 182489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182495 */     GIR_RootConstrainSelectedInstOperands,
     /* 182496 */     // GIR_Coverage, 5202,
     /* 182496 */     GIR_EraseRootFromParent_Done,
     /* 182497 */   // Label 3554: @182497
     /* 182497 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(182542), // Rule ID 5203 //
     /* 182502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 182510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182531 */     // (intrinsic_wo_chain:{ *:[i64] } 694:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 182534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182540 */     GIR_RootConstrainSelectedInstOperands,
     /* 182541 */     // GIR_Coverage, 5203,
     /* 182541 */     GIR_EraseRootFromParent_Done,
     /* 182542 */   // Label 3555: @182542
     /* 182542 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(182587), // Rule ID 5204 //
     /* 182547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 182555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182572 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182576 */     // (intrinsic_wo_chain:{ *:[i32] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
     /* 182579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182585 */     GIR_RootConstrainSelectedInstOperands,
     /* 182586 */     // GIR_Coverage, 5204,
     /* 182586 */     GIR_EraseRootFromParent_Done,
     /* 182587 */   // Label 3556: @182587
     /* 182587 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(182632), // Rule ID 5205 //
     /* 182592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 182600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182621 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 182624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182630 */     GIR_RootConstrainSelectedInstOperands,
     /* 182631 */     // GIR_Coverage, 5205,
     /* 182631 */     GIR_EraseRootFromParent_Done,
     /* 182632 */   // Label 3557: @182632
     /* 182632 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(182677), // Rule ID 5206 //
     /* 182637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 182645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182658 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182666 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
     /* 182669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182675 */     GIR_RootConstrainSelectedInstOperands,
     /* 182676 */     // GIR_Coverage, 5206,
     /* 182676 */     GIR_EraseRootFromParent_Done,
     /* 182677 */   // Label 3558: @182677
     /* 182677 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(182722), // Rule ID 5207 //
     /* 182682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 182690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182711 */     // (intrinsic_wo_chain:{ *:[i64] } 739:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 182714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182720 */     GIR_RootConstrainSelectedInstOperands,
     /* 182721 */     // GIR_Coverage, 5207,
     /* 182721 */     GIR_EraseRootFromParent_Done,
     /* 182722 */   // Label 3559: @182722
     /* 182722 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(182767), // Rule ID 5208 //
     /* 182727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 182735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182756 */     // (intrinsic_wo_chain:{ *:[i32] } 739:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
     /* 182759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182765 */     GIR_RootConstrainSelectedInstOperands,
     /* 182766 */     // GIR_Coverage, 5208,
     /* 182766 */     GIR_EraseRootFromParent_Done,
     /* 182767 */   // Label 3560: @182767
     /* 182767 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(182812), // Rule ID 5209 //
     /* 182772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 182780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182801 */     // (intrinsic_wo_chain:{ *:[i64] } 740:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 182804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182810 */     GIR_RootConstrainSelectedInstOperands,
     /* 182811 */     // GIR_Coverage, 5209,
     /* 182811 */     GIR_EraseRootFromParent_Done,
     /* 182812 */   // Label 3561: @182812
     /* 182812 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(182857), // Rule ID 5210 //
     /* 182817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 182825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182838 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182846 */     // (intrinsic_wo_chain:{ *:[i32] } 740:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
     /* 182849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182855 */     GIR_RootConstrainSelectedInstOperands,
     /* 182856 */     // GIR_Coverage, 5210,
     /* 182856 */     GIR_EraseRootFromParent_Done,
     /* 182857 */   // Label 3562: @182857
     /* 182857 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(182902), // Rule ID 5211 //
     /* 182862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 182870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182891 */     // (intrinsic_wo_chain:{ *:[i64] } 742:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 182894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182900 */     GIR_RootConstrainSelectedInstOperands,
     /* 182901 */     // GIR_Coverage, 5211,
     /* 182901 */     GIR_EraseRootFromParent_Done,
     /* 182902 */   // Label 3563: @182902
     /* 182902 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(182947), // Rule ID 5212 //
     /* 182907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 182915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182936 */     // (intrinsic_wo_chain:{ *:[i32] } 742:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 182936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
     /* 182939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182945 */     GIR_RootConstrainSelectedInstOperands,
     /* 182946 */     // GIR_Coverage, 5212,
     /* 182946 */     GIR_EraseRootFromParent_Done,
     /* 182947 */   // Label 3564: @182947
     /* 182947 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(182992), // Rule ID 5213 //
     /* 182952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 182955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 182960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182981 */     // (intrinsic_wo_chain:{ *:[i64] } 744:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 182981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 182984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 182990 */     GIR_RootConstrainSelectedInstOperands,
     /* 182991 */     // GIR_Coverage, 5213,
     /* 182991 */     GIR_EraseRootFromParent_Done,
     /* 182992 */   // Label 3565: @182992
     /* 182992 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(183037), // Rule ID 5214 //
     /* 182997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 183005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 183014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183026 */     // (intrinsic_wo_chain:{ *:[i32] } 744:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 183026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
     /* 183029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183035 */     GIR_RootConstrainSelectedInstOperands,
     /* 183036 */     // GIR_Coverage, 5214,
     /* 183036 */     GIR_EraseRootFromParent_Done,
     /* 183037 */   // Label 3566: @183037
     /* 183037 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(183082), // Rule ID 5233 //
     /* 183042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 183045 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 183050 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183053 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183056 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183071 */     // (intrinsic_wo_chain:{ *:[v1i64] } 754:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 183071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 183074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 183078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 183080 */     GIR_RootConstrainSelectedInstOperands,
     /* 183081 */     // GIR_Coverage, 5233,
     /* 183081 */     GIR_EraseRootFromParent_Done,
     /* 183082 */   // Label 3567: @183082
     /* 183082 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(183124), // Rule ID 5567 //
     /* 183087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 183092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 183095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 183098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 183101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183113 */     // (intrinsic_wo_chain:{ *:[v8i8] } 716:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 183113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
     /* 183116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 183118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 183122 */     GIR_RootConstrainSelectedInstOperands,
     /* 183123 */     // GIR_Coverage, 5567,
     /* 183123 */     GIR_EraseRootFromParent_Done,
     /* 183124 */   // Label 3568: @183124
     /* 183124 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(183166), // Rule ID 5568 //
     /* 183129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 183134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 183137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 183140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 183143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 183155 */     // (intrinsic_wo_chain:{ *:[v16i8] } 716:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 183155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
     /* 183158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 183160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ri
     /* 183162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 183164 */     GIR_RootConstrainSelectedInstOperands,
     /* 183165 */     // GIR_Coverage, 5568,
     /* 183165 */     GIR_EraseRootFromParent_Done,
     /* 183166 */   // Label 3569: @183166
     /* 183166 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(183263), // Rule ID 6255 //
     /* 183171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 183176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 183182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 183185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183197 */     // (intrinsic_wo_chain:{ *:[i32] } 577:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 183197 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 183200 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
     /* 183204 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183209 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 183213 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 183217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 183219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 183222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 183247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183252 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183262 */     // GIR_Coverage, 6255,
     /* 183262 */     GIR_EraseRootFromParent_Done,
     /* 183263 */   // Label 3570: @183263
     /* 183263 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(183360), // Rule ID 6256 //
     /* 183268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 183273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 183279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 183282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183294 */     // (intrinsic_wo_chain:{ *:[i32] } 578:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 183294 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 183297 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
     /* 183301 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183306 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 183310 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 183314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 183316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 183319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 183323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 183328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 183330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 183333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 183335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 183338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 183341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 183344 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183349 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 183354 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 183359 */     // GIR_Coverage, 6256,
     /* 183359 */     GIR_EraseRootFromParent_Done,
     /* 183360 */   // Label 3571: @183360
     /* 183360 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(183402), // Rule ID 6909 //
     /* 183365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 183370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183391 */     // (intrinsic_wo_chain:{ *:[i64] } 703:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 183391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 183394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183400 */     GIR_RootConstrainSelectedInstOperands,
     /* 183401 */     // GIR_Coverage, 6909,
     /* 183401 */     GIR_EraseRootFromParent_Done,
     /* 183402 */   // Label 3572: @183402
     /* 183402 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(183444), // Rule ID 6910 //
     /* 183407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 183412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183433 */     // (intrinsic_wo_chain:{ *:[i64] } 751:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 183433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 183436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183442 */     GIR_RootConstrainSelectedInstOperands,
     /* 183443 */     // GIR_Coverage, 6910,
     /* 183443 */     GIR_EraseRootFromParent_Done,
     /* 183444 */   // Label 3573: @183444
     /* 183444 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(183486), // Rule ID 6911 //
     /* 183449 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 183454 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183457 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183460 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183475 */     // (intrinsic_wo_chain:{ *:[i64] } 702:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 183475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 183478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183484 */     GIR_RootConstrainSelectedInstOperands,
     /* 183485 */     // GIR_Coverage, 6911,
     /* 183485 */     GIR_EraseRootFromParent_Done,
     /* 183486 */   // Label 3574: @183486
     /* 183486 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(183528), // Rule ID 6912 //
     /* 183491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 183496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 183517 */     // (intrinsic_wo_chain:{ *:[i64] } 748:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 183517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 183520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 183526 */     GIR_RootConstrainSelectedInstOperands,
     /* 183527 */     // GIR_Coverage, 6912,
     /* 183527 */     GIR_EraseRootFromParent_Done,
     /* 183528 */   // Label 3575: @183528
     /* 183528 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(183576), // Rule ID 6952 //
     /* 183533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 183538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 183547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183551 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183555 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183559 */     // (intrinsic_wo_chain:{ *:[i64] } 294:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
     /* 183559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
     /* 183562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 183564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 183566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 183568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 183571 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 183574 */     GIR_RootConstrainSelectedInstOperands,
     /* 183575 */     // GIR_Coverage, 6952,
     /* 183575 */     GIR_EraseRootFromParent_Done,
     /* 183576 */   // Label 3576: @183576
     /* 183576 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(183621), // Rule ID 9974 //
     /* 183581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 183589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183610 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
     /* 183613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183619 */     GIR_RootConstrainSelectedInstOperands,
     /* 183620 */     // GIR_Coverage, 9974,
     /* 183620 */     GIR_EraseRootFromParent_Done,
     /* 183621 */   // Label 3577: @183621
     /* 183621 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(183666), // Rule ID 9975 //
     /* 183626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 183634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183655 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
     /* 183658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183664 */     GIR_RootConstrainSelectedInstOperands,
     /* 183665 */     // GIR_Coverage, 9975,
     /* 183665 */     GIR_EraseRootFromParent_Done,
     /* 183666 */   // Label 3578: @183666
     /* 183666 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(183711), // Rule ID 9976 //
     /* 183671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 183679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183700 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
     /* 183703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183709 */     GIR_RootConstrainSelectedInstOperands,
     /* 183710 */     // GIR_Coverage, 9976,
     /* 183710 */     GIR_EraseRootFromParent_Done,
     /* 183711 */   // Label 3579: @183711
     /* 183711 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(183756), // Rule ID 9977 //
     /* 183716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 183724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183745 */     // (intrinsic_wo_chain:{ *:[i64] } 2012:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
     /* 183748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183754 */     GIR_RootConstrainSelectedInstOperands,
     /* 183755 */     // GIR_Coverage, 9977,
     /* 183755 */     GIR_EraseRootFromParent_Done,
     /* 183756 */   // Label 3580: @183756
     /* 183756 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(183801), // Rule ID 9986 //
     /* 183761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 183769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183790 */     // (intrinsic_wo_chain:{ *:[i64] } 1767:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
     /* 183793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183799 */     GIR_RootConstrainSelectedInstOperands,
     /* 183800 */     // GIR_Coverage, 9986,
     /* 183800 */     GIR_EraseRootFromParent_Done,
     /* 183801 */   // Label 3581: @183801
     /* 183801 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(183846), // Rule ID 9987 //
     /* 183806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 183814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 183823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183835 */     // (intrinsic_wo_chain:{ *:[i64] } 1767:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
     /* 183838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183844 */     GIR_RootConstrainSelectedInstOperands,
     /* 183845 */     // GIR_Coverage, 9987,
     /* 183845 */     GIR_EraseRootFromParent_Done,
     /* 183846 */   // Label 3582: @183846
     /* 183846 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(183891), // Rule ID 9988 //
     /* 183851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 183859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 183868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183880 */     // (intrinsic_wo_chain:{ *:[i64] } 1767:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
     /* 183883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183889 */     GIR_RootConstrainSelectedInstOperands,
     /* 183890 */     // GIR_Coverage, 9988,
     /* 183890 */     GIR_EraseRootFromParent_Done,
     /* 183891 */   // Label 3583: @183891
     /* 183891 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(183936), // Rule ID 9989 //
     /* 183896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 183904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 183907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 183910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 183913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 183921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183925 */     // (intrinsic_wo_chain:{ *:[i64] } 1767:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 183925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
     /* 183928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183934 */     GIR_RootConstrainSelectedInstOperands,
     /* 183935 */     // GIR_Coverage, 9989,
     /* 183935 */     GIR_EraseRootFromParent_Done,
     /* 183936 */   // Label 3584: @183936
     /* 183936 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(183981), // Rule ID 9990 //
     /* 183941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 183949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 183955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 183958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 183966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 183970 */     // (intrinsic_wo_chain:{ *:[i32] } 1997:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 183970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
     /* 183973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 183975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 183977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 183979 */     GIR_RootConstrainSelectedInstOperands,
     /* 183980 */     // GIR_Coverage, 9990,
     /* 183980 */     GIR_EraseRootFromParent_Done,
     /* 183981 */   // Label 3585: @183981
     /* 183981 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(184026), // Rule ID 9991 //
     /* 183986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 183989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 183994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 183997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 184003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184015 */     // (intrinsic_wo_chain:{ *:[i32] } 1997:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 184015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
     /* 184018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184024 */     GIR_RootConstrainSelectedInstOperands,
     /* 184025 */     // GIR_Coverage, 9991,
     /* 184025 */     GIR_EraseRootFromParent_Done,
     /* 184026 */   // Label 3586: @184026
     /* 184026 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(184071), // Rule ID 9992 //
     /* 184031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 184039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 184048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184056 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184060 */     // (intrinsic_wo_chain:{ *:[i32] } 1997:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 184060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
     /* 184063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184069 */     GIR_RootConstrainSelectedInstOperands,
     /* 184070 */     // GIR_Coverage, 9992,
     /* 184070 */     GIR_EraseRootFromParent_Done,
     /* 184071 */   // Label 3587: @184071
     /* 184071 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(184116), // Rule ID 9993 //
     /* 184076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 184084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 184087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 184090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 184093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 184101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184105 */     // (intrinsic_wo_chain:{ *:[i32] } 1997:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 184105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
     /* 184108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184114 */     GIR_RootConstrainSelectedInstOperands,
     /* 184115 */     // GIR_Coverage, 9993,
     /* 184115 */     GIR_EraseRootFromParent_Done,
     /* 184116 */   // Label 3588: @184116
     /* 184116 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(184161), // Rule ID 9994 //
     /* 184121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 184129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184150 */     // (intrinsic_wo_chain:{ *:[i64] } 1998:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 184150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
     /* 184153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184159 */     GIR_RootConstrainSelectedInstOperands,
     /* 184160 */     // GIR_Coverage, 9994,
     /* 184160 */     GIR_EraseRootFromParent_Done,
     /* 184161 */   // Label 3589: @184161
     /* 184161 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(184206), // Rule ID 9995 //
     /* 184166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 184174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 184183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184195 */     // (intrinsic_wo_chain:{ *:[i64] } 1998:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 184195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
     /* 184198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184204 */     GIR_RootConstrainSelectedInstOperands,
     /* 184205 */     // GIR_Coverage, 9995,
     /* 184205 */     GIR_EraseRootFromParent_Done,
     /* 184206 */   // Label 3590: @184206
     /* 184206 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(184251), // Rule ID 9996 //
     /* 184211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 184219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 184228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184240 */     // (intrinsic_wo_chain:{ *:[i64] } 1998:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 184240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
     /* 184243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184249 */     GIR_RootConstrainSelectedInstOperands,
     /* 184250 */     // GIR_Coverage, 9996,
     /* 184250 */     GIR_EraseRootFromParent_Done,
     /* 184251 */   // Label 3591: @184251
     /* 184251 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(184296), // Rule ID 9997 //
     /* 184256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 184264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 184270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 184273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184285 */     // (intrinsic_wo_chain:{ *:[i64] } 1998:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 184285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
     /* 184288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 184290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 184292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184294 */     GIR_RootConstrainSelectedInstOperands,
     /* 184295 */     // GIR_Coverage, 9997,
     /* 184295 */     GIR_EraseRootFromParent_Done,
     /* 184296 */   // Label 3592: @184296
     /* 184296 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(184342), // Rule ID 138 //
     /* 184301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 184304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
     /* 184309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 184315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184319 */     // MIs[0] Rn
     /* 184319 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 184323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 184327 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184331 */     // (intrinsic_wo_chain:{ *:[i64] } 555:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 184331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
     /* 184334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184340 */     GIR_RootConstrainSelectedInstOperands,
     /* 184341 */     // GIR_Coverage, 138,
     /* 184341 */     GIR_EraseRootFromParent_Done,
     /* 184342 */   // Label 3593: @184342
     /* 184342 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(184389), // Rule ID 139 //
     /* 184347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 184350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
     /* 184355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 184358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 184362 */     // MIs[0] Rn
     /* 184362 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 184366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 184370 */     // MIs[0] Rm
     /* 184370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 184374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 184378 */     // (intrinsic_wo_chain:{ *:[i64] } 1228:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 184378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
     /* 184381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 184387 */     GIR_RootConstrainSelectedInstOperands,
     /* 184388 */     // GIR_Coverage, 139,
     /* 184388 */     GIR_EraseRootFromParent_Done,
     /* 184389 */   // Label 3594: @184389
     /* 184389 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(184426), // Rule ID 2397 //
     /* 184394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
     /* 184402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184415 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2137:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 184418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184424 */     GIR_RootConstrainSelectedInstOperands,
     /* 184425 */     // GIR_Coverage, 2397,
     /* 184425 */     GIR_EraseRootFromParent_Done,
     /* 184426 */   // Label 3595: @184426
     /* 184426 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(184463), // Rule ID 2398 //
     /* 184431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
     /* 184439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184452 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2138:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 184455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184461 */     GIR_RootConstrainSelectedInstOperands,
     /* 184462 */     // GIR_Coverage, 2398,
     /* 184462 */     GIR_EraseRootFromParent_Done,
     /* 184463 */   // Label 3596: @184463
     /* 184463 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(184500), // Rule ID 2399 //
     /* 184468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
     /* 184476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184489 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2139:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 184492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184498 */     GIR_RootConstrainSelectedInstOperands,
     /* 184499 */     // GIR_Coverage, 2399,
     /* 184499 */     GIR_EraseRootFromParent_Done,
     /* 184500 */   // Label 3597: @184500
     /* 184500 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(184537), // Rule ID 2401 //
     /* 184505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
     /* 184513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184526 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2142:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 184529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184535 */     GIR_RootConstrainSelectedInstOperands,
     /* 184536 */     // GIR_Coverage, 2401,
     /* 184536 */     GIR_EraseRootFromParent_Done,
     /* 184537 */   // Label 3598: @184537
     /* 184537 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(184574), // Rule ID 2402 //
     /* 184542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
     /* 184550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184563 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2143:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 184566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184572 */     GIR_RootConstrainSelectedInstOperands,
     /* 184573 */     // GIR_Coverage, 2402,
     /* 184573 */     GIR_EraseRootFromParent_Done,
     /* 184574 */   // Label 3599: @184574
     /* 184574 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(184611), // Rule ID 2403 //
     /* 184579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
     /* 184587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184600 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2144:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 184603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184609 */     GIR_RootConstrainSelectedInstOperands,
     /* 184610 */     // GIR_Coverage, 2403,
     /* 184610 */     GIR_EraseRootFromParent_Done,
     /* 184611 */   // Label 3600: @184611
     /* 184611 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(184648), // Rule ID 2405 //
     /* 184616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
     /* 184624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184637 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2063:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 184640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184646 */     GIR_RootConstrainSelectedInstOperands,
     /* 184647 */     // GIR_Coverage, 2405,
     /* 184647 */     GIR_EraseRootFromParent_Done,
     /* 184648 */   // Label 3601: @184648
     /* 184648 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(184685), // Rule ID 2406 //
     /* 184653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
     /* 184661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184674 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2064:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 184677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184683 */     GIR_RootConstrainSelectedInstOperands,
     /* 184684 */     // GIR_Coverage, 2406,
     /* 184684 */     GIR_EraseRootFromParent_Done,
     /* 184685 */   // Label 3602: @184685
     /* 184685 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(184722), // Rule ID 2407 //
     /* 184690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
     /* 184698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184711 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2065:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 184714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184720 */     GIR_RootConstrainSelectedInstOperands,
     /* 184721 */     // GIR_Coverage, 2407,
     /* 184721 */     GIR_EraseRootFromParent_Done,
     /* 184722 */   // Label 3603: @184722
     /* 184722 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(184759), // Rule ID 2409 //
     /* 184727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
     /* 184735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184748 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2068:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 184751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184757 */     GIR_RootConstrainSelectedInstOperands,
     /* 184758 */     // GIR_Coverage, 2409,
     /* 184758 */     GIR_EraseRootFromParent_Done,
     /* 184759 */   // Label 3604: @184759
     /* 184759 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(184796), // Rule ID 2410 //
     /* 184764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
     /* 184772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184785 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2069:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 184788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184794 */     GIR_RootConstrainSelectedInstOperands,
     /* 184795 */     // GIR_Coverage, 2410,
     /* 184795 */     GIR_EraseRootFromParent_Done,
     /* 184796 */   // Label 3605: @184796
     /* 184796 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(184833), // Rule ID 2411 //
     /* 184801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
     /* 184809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184822 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2070:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 184825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184831 */     GIR_RootConstrainSelectedInstOperands,
     /* 184832 */     // GIR_Coverage, 2411,
     /* 184832 */     GIR_EraseRootFromParent_Done,
     /* 184833 */   // Label 3606: @184833
     /* 184833 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(184870), // Rule ID 2413 //
     /* 184838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
     /* 184846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184859 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1907:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 184862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184868 */     GIR_RootConstrainSelectedInstOperands,
     /* 184869 */     // GIR_Coverage, 2413,
     /* 184869 */     GIR_EraseRootFromParent_Done,
     /* 184870 */   // Label 3607: @184870
     /* 184870 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(184907), // Rule ID 2414 //
     /* 184875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
     /* 184883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184896 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1908:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 184899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184905 */     GIR_RootConstrainSelectedInstOperands,
     /* 184906 */     // GIR_Coverage, 2414,
     /* 184906 */     GIR_EraseRootFromParent_Done,
     /* 184907 */   // Label 3608: @184907
     /* 184907 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(184944), // Rule ID 2415 //
     /* 184912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
     /* 184920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184933 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1909:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 184936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184942 */     GIR_RootConstrainSelectedInstOperands,
     /* 184943 */     // GIR_Coverage, 2415,
     /* 184943 */     GIR_EraseRootFromParent_Done,
     /* 184944 */   // Label 3609: @184944
     /* 184944 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(184981), // Rule ID 2417 //
     /* 184949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
     /* 184957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 184963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 184966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 184970 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1912:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 184970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 184973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 184975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 184977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 184979 */     GIR_RootConstrainSelectedInstOperands,
     /* 184980 */     // GIR_Coverage, 2417,
     /* 184980 */     GIR_EraseRootFromParent_Done,
     /* 184981 */   // Label 3610: @184981
     /* 184981 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(185018), // Rule ID 2418 //
     /* 184986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 184989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
     /* 184994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 184997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 185000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185007 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1913:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 185007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 185010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 185014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 185016 */     GIR_RootConstrainSelectedInstOperands,
     /* 185017 */     // GIR_Coverage, 2418,
     /* 185017 */     GIR_EraseRootFromParent_Done,
     /* 185018 */   // Label 3611: @185018
     /* 185018 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(185055), // Rule ID 2419 //
     /* 185023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
     /* 185031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 185037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185044 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1914:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 185044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 185047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 185049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 185051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 185053 */     GIR_RootConstrainSelectedInstOperands,
     /* 185054 */     // GIR_Coverage, 2419,
     /* 185054 */     GIR_EraseRootFromParent_Done,
     /* 185055 */   // Label 3612: @185055
     /* 185055 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(185092), // Rule ID 2420 //
     /* 185060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 185063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
     /* 185068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185081 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1532:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
     /* 185081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
     /* 185084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 185088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 185090 */     GIR_RootConstrainSelectedInstOperands,
     /* 185091 */     // GIR_Coverage, 2420,
     /* 185091 */     GIR_EraseRootFromParent_Done,
     /* 185092 */   // Label 3613: @185092
     /* 185092 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(185132), // Rule ID 2619 //
     /* 185097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
     /* 185105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 185111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185118 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1611:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 185118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
     /* 185121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 185123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185127 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185130 */     GIR_RootConstrainSelectedInstOperands,
     /* 185131 */     // GIR_Coverage, 2619,
     /* 185131 */     GIR_EraseRootFromParent_Done,
     /* 185132 */   // Label 3614: @185132
     /* 185132 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(185172), // Rule ID 2620 //
     /* 185137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 185145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 185148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 185151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185158 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1619:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 185158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
     /* 185161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 185163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185165 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185167 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185170 */     GIR_RootConstrainSelectedInstOperands,
     /* 185171 */     // GIR_Coverage, 2620,
     /* 185171 */     GIR_EraseRootFromParent_Done,
     /* 185172 */   // Label 3615: @185172
     /* 185172 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(185212), // Rule ID 2621 //
     /* 185177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 185185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 185188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 185191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 185194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185198 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1619:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 185198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
     /* 185201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 185203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185207 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185210 */     GIR_RootConstrainSelectedInstOperands,
     /* 185211 */     // GIR_Coverage, 2621,
     /* 185211 */     GIR_EraseRootFromParent_Done,
     /* 185212 */   // Label 3616: @185212
     /* 185212 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(185252), // Rule ID 2622 //
     /* 185217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 185225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 185228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 185231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 185234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185238 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1619:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 185238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
     /* 185241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 185243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185247 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185250 */     GIR_RootConstrainSelectedInstOperands,
     /* 185251 */     // GIR_Coverage, 2622,
     /* 185251 */     GIR_EraseRootFromParent_Done,
     /* 185252 */   // Label 3617: @185252
     /* 185252 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(185292), // Rule ID 2623 //
     /* 185257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 185265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 185268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 185271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 185274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 185278 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1619:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 185278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
     /* 185281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 185283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185287 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 185290 */     GIR_RootConstrainSelectedInstOperands,
     /* 185291 */     // GIR_Coverage, 2623,
     /* 185291 */     GIR_EraseRootFromParent_Done,
     /* 185292 */   // Label 3618: @185292
     /* 185292 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(185329), // Rule ID 2640 //
     /* 185297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 185305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 185314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185318 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1799:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 185318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
     /* 185321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 185323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185327 */     GIR_RootConstrainSelectedInstOperands,
     /* 185328 */     // GIR_Coverage, 2640,
     /* 185328 */     GIR_EraseRootFromParent_Done,
     /* 185329 */   // Label 3619: @185329
     /* 185329 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(185366), // Rule ID 2641 //
     /* 185334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 185342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 185351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185355 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1799:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 185355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
     /* 185358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 185360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185364 */     GIR_RootConstrainSelectedInstOperands,
     /* 185365 */     // GIR_Coverage, 2641,
     /* 185365 */     GIR_EraseRootFromParent_Done,
     /* 185366 */   // Label 3620: @185366
     /* 185366 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(185403), // Rule ID 2642 //
     /* 185371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 185379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 185388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185392 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1799:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 185392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
     /* 185395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 185397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185401 */     GIR_RootConstrainSelectedInstOperands,
     /* 185402 */     // GIR_Coverage, 2642,
     /* 185402 */     GIR_EraseRootFromParent_Done,
     /* 185403 */   // Label 3621: @185403
     /* 185403 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(185440), // Rule ID 2643 //
     /* 185408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 185416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 185422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 185425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185429 */     // (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 185429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
     /* 185432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185438 */     GIR_RootConstrainSelectedInstOperands,
     /* 185439 */     // GIR_Coverage, 2643,
     /* 185439 */     GIR_EraseRootFromParent_Done,
     /* 185440 */   // Label 3622: @185440
     /* 185440 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(185477), // Rule ID 2644 //
     /* 185445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 185453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 185459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 185462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185466 */     // (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 185466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
     /* 185469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185475 */     GIR_RootConstrainSelectedInstOperands,
     /* 185476 */     // GIR_Coverage, 2644,
     /* 185476 */     GIR_EraseRootFromParent_Done,
     /* 185477 */   // Label 3623: @185477
     /* 185477 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(185514), // Rule ID 2645 //
     /* 185482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 185490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 185496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 185499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185503 */     // (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 185503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
     /* 185506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185512 */     GIR_RootConstrainSelectedInstOperands,
     /* 185513 */     // GIR_Coverage, 2645,
     /* 185513 */     GIR_EraseRootFromParent_Done,
     /* 185514 */   // Label 3624: @185514
     /* 185514 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(185551), // Rule ID 2646 //
     /* 185519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 185522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 185527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 185533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 185536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185540 */     // (intrinsic_wo_chain:{ *:[i64] } 1321:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 185540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
     /* 185543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185549 */     GIR_RootConstrainSelectedInstOperands,
     /* 185550 */     // GIR_Coverage, 2646,
     /* 185550 */     GIR_EraseRootFromParent_Done,
     /* 185551 */   // Label 3625: @185551
     /* 185551 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(185588), // Rule ID 2824 //
     /* 185556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 185559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 185564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185577 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1529:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
     /* 185580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185586 */     GIR_RootConstrainSelectedInstOperands,
     /* 185587 */     // GIR_Coverage, 2824,
     /* 185587 */     GIR_EraseRootFromParent_Done,
     /* 185588 */   // Label 3626: @185588
     /* 185588 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(185625), // Rule ID 2825 //
     /* 185593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 185596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 185601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185614 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1529:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
     /* 185617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185623 */     GIR_RootConstrainSelectedInstOperands,
     /* 185624 */     // GIR_Coverage, 2825,
     /* 185624 */     GIR_EraseRootFromParent_Done,
     /* 185625 */   // Label 3627: @185625
     /* 185625 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(185662), // Rule ID 2826 //
     /* 185630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 185633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 185638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185651 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1529:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
     /* 185654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185660 */     GIR_RootConstrainSelectedInstOperands,
     /* 185661 */     // GIR_Coverage, 2826,
     /* 185661 */     GIR_EraseRootFromParent_Done,
     /* 185662 */   // Label 3628: @185662
     /* 185662 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(185699), // Rule ID 2997 //
     /* 185667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 185675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185688 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1781:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
     /* 185691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185697 */     GIR_RootConstrainSelectedInstOperands,
     /* 185698 */     // GIR_Coverage, 2997,
     /* 185698 */     GIR_EraseRootFromParent_Done,
     /* 185699 */   // Label 3629: @185699
     /* 185699 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(185736), // Rule ID 2998 //
     /* 185704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 185712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185725 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1781:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
     /* 185728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185734 */     GIR_RootConstrainSelectedInstOperands,
     /* 185735 */     // GIR_Coverage, 2998,
     /* 185735 */     GIR_EraseRootFromParent_Done,
     /* 185736 */   // Label 3630: @185736
     /* 185736 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(185773), // Rule ID 2999 //
     /* 185741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 185749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185762 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1781:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
     /* 185765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185771 */     GIR_RootConstrainSelectedInstOperands,
     /* 185772 */     // GIR_Coverage, 2999,
     /* 185772 */     GIR_EraseRootFromParent_Done,
     /* 185773 */   // Label 3631: @185773
     /* 185773 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(185810), // Rule ID 3000 //
     /* 185778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 185786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185799 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1781:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
     /* 185802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185808 */     GIR_RootConstrainSelectedInstOperands,
     /* 185809 */     // GIR_Coverage, 3000,
     /* 185809 */     GIR_EraseRootFromParent_Done,
     /* 185810 */   // Label 3632: @185810
     /* 185810 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(185847), // Rule ID 3001 //
     /* 185815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
     /* 185823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 185826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185836 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1616:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
     /* 185839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185845 */     GIR_RootConstrainSelectedInstOperands,
     /* 185846 */     // GIR_Coverage, 3001,
     /* 185846 */     GIR_EraseRootFromParent_Done,
     /* 185847 */   // Label 3633: @185847
     /* 185847 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(185884), // Rule ID 3023 //
     /* 185852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 185860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 185863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 185866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 185869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185873 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1674:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 185873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
     /* 185876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185882 */     GIR_RootConstrainSelectedInstOperands,
     /* 185883 */     // GIR_Coverage, 3023,
     /* 185883 */     GIR_EraseRootFromParent_Done,
     /* 185884 */   // Label 3634: @185884
     /* 185884 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(185921), // Rule ID 3024 //
     /* 185889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 185897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 185900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 185903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 185906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185910 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1674:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 185910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
     /* 185913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185919 */     GIR_RootConstrainSelectedInstOperands,
     /* 185920 */     // GIR_Coverage, 3024,
     /* 185920 */     GIR_EraseRootFromParent_Done,
     /* 185921 */   // Label 3635: @185921
     /* 185921 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(185958), // Rule ID 3025 //
     /* 185926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 185929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 185934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 185940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 185943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185947 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1674:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 185947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
     /* 185950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185956 */     GIR_RootConstrainSelectedInstOperands,
     /* 185957 */     // GIR_Coverage, 3025,
     /* 185957 */     GIR_EraseRootFromParent_Done,
     /* 185958 */   // Label 3636: @185958
     /* 185958 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(185995), // Rule ID 3029 //
     /* 185963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 185966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 185971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 185974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 185977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 185980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 185984 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1617:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 185984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
     /* 185987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 185989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 185991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 185993 */     GIR_RootConstrainSelectedInstOperands,
     /* 185994 */     // GIR_Coverage, 3029,
     /* 185994 */     GIR_EraseRootFromParent_Done,
     /* 185995 */   // Label 3637: @185995
     /* 185995 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(186032), // Rule ID 3030 //
     /* 186000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 186008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186021 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1617:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
     /* 186024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186030 */     GIR_RootConstrainSelectedInstOperands,
     /* 186031 */     // GIR_Coverage, 3030,
     /* 186031 */     GIR_EraseRootFromParent_Done,
     /* 186032 */   // Label 3638: @186032
     /* 186032 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(186069), // Rule ID 3031 //
     /* 186037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 186045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186058 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1617:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
     /* 186061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186067 */     GIR_RootConstrainSelectedInstOperands,
     /* 186068 */     // GIR_Coverage, 3031,
     /* 186068 */     GIR_EraseRootFromParent_Done,
     /* 186069 */   // Label 3639: @186069
     /* 186069 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(186106), // Rule ID 3032 //
     /* 186074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 186077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 186082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186095 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1259:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
     /* 186098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186104 */     GIR_RootConstrainSelectedInstOperands,
     /* 186105 */     // GIR_Coverage, 3032,
     /* 186105 */     GIR_EraseRootFromParent_Done,
     /* 186106 */   // Label 3640: @186106
     /* 186106 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(186143), // Rule ID 3033 //
     /* 186111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 186114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 186119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186132 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1259:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
     /* 186135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186141 */     GIR_RootConstrainSelectedInstOperands,
     /* 186142 */     // GIR_Coverage, 3033,
     /* 186142 */     GIR_EraseRootFromParent_Done,
     /* 186143 */   // Label 3641: @186143
     /* 186143 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(186180), // Rule ID 3034 //
     /* 186148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 186151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 186156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186169 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1259:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
     /* 186172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186178 */     GIR_RootConstrainSelectedInstOperands,
     /* 186179 */     // GIR_Coverage, 3034,
     /* 186179 */     GIR_EraseRootFromParent_Done,
     /* 186180 */   // Label 3642: @186180
     /* 186180 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(186217), // Rule ID 3035 //
     /* 186185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 186188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 186193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186206 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1259:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
     /* 186209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186215 */     GIR_RootConstrainSelectedInstOperands,
     /* 186216 */     // GIR_Coverage, 3035,
     /* 186216 */     GIR_EraseRootFromParent_Done,
     /* 186217 */   // Label 3643: @186217
     /* 186217 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(186254), // Rule ID 3036 //
     /* 186222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 186230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 186239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186243 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1675:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 186243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
     /* 186246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186252 */     GIR_RootConstrainSelectedInstOperands,
     /* 186253 */     // GIR_Coverage, 3036,
     /* 186253 */     GIR_EraseRootFromParent_Done,
     /* 186254 */   // Label 3644: @186254
     /* 186254 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(186291), // Rule ID 3037 //
     /* 186259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 186267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186280 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1675:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
     /* 186283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186289 */     GIR_RootConstrainSelectedInstOperands,
     /* 186290 */     // GIR_Coverage, 3037,
     /* 186290 */     GIR_EraseRootFromParent_Done,
     /* 186291 */   // Label 3645: @186291
     /* 186291 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(186328), // Rule ID 3038 //
     /* 186296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 186304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186317 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1675:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
     /* 186320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186326 */     GIR_RootConstrainSelectedInstOperands,
     /* 186327 */     // GIR_Coverage, 3038,
     /* 186327 */     GIR_EraseRootFromParent_Done,
     /* 186328 */   // Label 3646: @186328
     /* 186328 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(186365), // Rule ID 3085 //
     /* 186333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 186341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186354 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1236:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
     /* 186357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186363 */     GIR_RootConstrainSelectedInstOperands,
     /* 186364 */     // GIR_Coverage, 3085,
     /* 186364 */     GIR_EraseRootFromParent_Done,
     /* 186365 */   // Label 3647: @186365
     /* 186365 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(186402), // Rule ID 3086 //
     /* 186370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 186378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186391 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1236:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
     /* 186394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186400 */     GIR_RootConstrainSelectedInstOperands,
     /* 186401 */     // GIR_Coverage, 3086,
     /* 186401 */     GIR_EraseRootFromParent_Done,
     /* 186402 */   // Label 3648: @186402
     /* 186402 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(186439), // Rule ID 3087 //
     /* 186407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 186415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 186421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186428 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1236:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
     /* 186431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186437 */     GIR_RootConstrainSelectedInstOperands,
     /* 186438 */     // GIR_Coverage, 3087,
     /* 186438 */     GIR_EraseRootFromParent_Done,
     /* 186439 */   // Label 3649: @186439
     /* 186439 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(186476), // Rule ID 3094 //
     /* 186444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 186452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 186455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 186458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 186461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186465 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1838:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 186465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
     /* 186468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186474 */     GIR_RootConstrainSelectedInstOperands,
     /* 186475 */     // GIR_Coverage, 3094,
     /* 186475 */     GIR_EraseRootFromParent_Done,
     /* 186476 */   // Label 3650: @186476
     /* 186476 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(186513), // Rule ID 3095 //
     /* 186481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 186489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 186492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 186495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186502 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1838:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
     /* 186505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186511 */     GIR_RootConstrainSelectedInstOperands,
     /* 186512 */     // GIR_Coverage, 3095,
     /* 186512 */     GIR_EraseRootFromParent_Done,
     /* 186513 */   // Label 3651: @186513
     /* 186513 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(186550), // Rule ID 3096 //
     /* 186518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 186521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 186526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 186532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186539 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1838:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
     /* 186542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186548 */     GIR_RootConstrainSelectedInstOperands,
     /* 186549 */     // GIR_Coverage, 3096,
     /* 186549 */     GIR_EraseRootFromParent_Done,
     /* 186550 */   // Label 3652: @186550
     /* 186550 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(186590), // Rule ID 3200 //
     /* 186555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186576 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 186576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
     /* 186579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186585 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186588 */     GIR_RootConstrainSelectedInstOperands,
     /* 186589 */     // GIR_Coverage, 3200,
     /* 186589 */     GIR_EraseRootFromParent_Done,
     /* 186590 */   // Label 3653: @186590
     /* 186590 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(186630), // Rule ID 3201 //
     /* 186595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 186606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186616 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 186616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
     /* 186619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186625 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186628 */     GIR_RootConstrainSelectedInstOperands,
     /* 186629 */     // GIR_Coverage, 3201,
     /* 186629 */     GIR_EraseRootFromParent_Done,
     /* 186630 */   // Label 3654: @186630
     /* 186630 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(186670), // Rule ID 3202 //
     /* 186635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186638 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186643 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 186646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186656 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 186656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
     /* 186659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186665 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186668 */     GIR_RootConstrainSelectedInstOperands,
     /* 186669 */     // GIR_Coverage, 3202,
     /* 186669 */     GIR_EraseRootFromParent_Done,
     /* 186670 */   // Label 3655: @186670
     /* 186670 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(186710), // Rule ID 3203 //
     /* 186675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 186686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186696 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2118:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 186696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
     /* 186699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186705 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186708 */     GIR_RootConstrainSelectedInstOperands,
     /* 186709 */     // GIR_Coverage, 3203,
     /* 186709 */     GIR_EraseRootFromParent_Done,
     /* 186710 */   // Label 3656: @186710
     /* 186710 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(186750), // Rule ID 3208 //
     /* 186715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 186726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186736 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 186736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
     /* 186739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186745 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186748 */     GIR_RootConstrainSelectedInstOperands,
     /* 186749 */     // GIR_Coverage, 3208,
     /* 186749 */     GIR_EraseRootFromParent_Done,
     /* 186750 */   // Label 3657: @186750
     /* 186750 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(186790), // Rule ID 3209 //
     /* 186755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 186766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186776 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 186776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
     /* 186779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186788 */     GIR_RootConstrainSelectedInstOperands,
     /* 186789 */     // GIR_Coverage, 3209,
     /* 186789 */     GIR_EraseRootFromParent_Done,
     /* 186790 */   // Label 3658: @186790
     /* 186790 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(186830), // Rule ID 3210 //
     /* 186795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 186806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186816 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 186816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
     /* 186819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186825 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186828 */     GIR_RootConstrainSelectedInstOperands,
     /* 186829 */     // GIR_Coverage, 3210,
     /* 186829 */     GIR_EraseRootFromParent_Done,
     /* 186830 */   // Label 3659: @186830
     /* 186830 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(186870), // Rule ID 3211 //
     /* 186835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 186838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 186843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 186846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 186849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 186856 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2118:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 186856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
     /* 186859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 186861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186865 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 186868 */     GIR_RootConstrainSelectedInstOperands,
     /* 186869 */     // GIR_Coverage, 3211,
     /* 186869 */     GIR_EraseRootFromParent_Done,
     /* 186870 */   // Label 3660: @186870
     /* 186870 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(186907), // Rule ID 3400 //
     /* 186875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 186878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 186883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 186889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186896 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1327:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 186896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 186899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186905 */     GIR_RootConstrainSelectedInstOperands,
     /* 186906 */     // GIR_Coverage, 3400,
     /* 186906 */     GIR_EraseRootFromParent_Done,
     /* 186907 */   // Label 3661: @186907
     /* 186907 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(186944), // Rule ID 3401 //
     /* 186912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 186915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 186920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 186923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 186926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 186929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186933 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1327:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 186933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 186936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186942 */     GIR_RootConstrainSelectedInstOperands,
     /* 186943 */     // GIR_Coverage, 3401,
     /* 186943 */     GIR_EraseRootFromParent_Done,
     /* 186944 */   // Label 3662: @186944
     /* 186944 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(186981), // Rule ID 3402 //
     /* 186949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 186952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 186957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 186963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 186966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 186970 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1327:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 186970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 186973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 186975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 186977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 186979 */     GIR_RootConstrainSelectedInstOperands,
     /* 186980 */     // GIR_Coverage, 3402,
     /* 186980 */     GIR_EraseRootFromParent_Done,
     /* 186981 */   // Label 3663: @186981
     /* 186981 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(187018), // Rule ID 3403 //
     /* 186986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 186989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 186994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 186997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 187000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187007 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1327:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 187007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 187010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187016 */     GIR_RootConstrainSelectedInstOperands,
     /* 187017 */     // GIR_Coverage, 3403,
     /* 187017 */     GIR_EraseRootFromParent_Done,
     /* 187018 */   // Label 3664: @187018
     /* 187018 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(187055), // Rule ID 3425 //
     /* 187023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 187031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187044 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1530:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
     /* 187047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187053 */     GIR_RootConstrainSelectedInstOperands,
     /* 187054 */     // GIR_Coverage, 3425,
     /* 187054 */     GIR_EraseRootFromParent_Done,
     /* 187055 */   // Label 3665: @187055
     /* 187055 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(187092), // Rule ID 3426 //
     /* 187060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187063 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 187068 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187081 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1530:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
     /* 187084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187090 */     GIR_RootConstrainSelectedInstOperands,
     /* 187091 */     // GIR_Coverage, 3426,
     /* 187091 */     GIR_EraseRootFromParent_Done,
     /* 187092 */   // Label 3666: @187092
     /* 187092 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(187129), // Rule ID 3427 //
     /* 187097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 187100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 187105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187118 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1530:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
     /* 187121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187127 */     GIR_RootConstrainSelectedInstOperands,
     /* 187128 */     // GIR_Coverage, 3427,
     /* 187128 */     GIR_EraseRootFromParent_Done,
     /* 187129 */   // Label 3667: @187129
     /* 187129 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(187166), // Rule ID 3449 //
     /* 187134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 187137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
     /* 187142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 187145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 187148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 187151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 187155 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1280:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 187155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
     /* 187158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 187160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187164 */     GIR_RootConstrainSelectedInstOperands,
     /* 187165 */     // GIR_Coverage, 3449,
     /* 187165 */     GIR_EraseRootFromParent_Done,
     /* 187166 */   // Label 3668: @187166
     /* 187166 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(187203), // Rule ID 3454 //
     /* 187171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 187174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
     /* 187179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187192 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1710:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
     /* 187195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187201 */     GIR_RootConstrainSelectedInstOperands,
     /* 187202 */     // GIR_Coverage, 3454,
     /* 187202 */     GIR_EraseRootFromParent_Done,
     /* 187203 */   // Label 3669: @187203
     /* 187203 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(187240), // Rule ID 3455 //
     /* 187208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 187211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
     /* 187216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187229 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1245:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
     /* 187232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 187234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187238 */     GIR_RootConstrainSelectedInstOperands,
     /* 187239 */     // GIR_Coverage, 3455,
     /* 187239 */     GIR_EraseRootFromParent_Done,
     /* 187240 */   // Label 3670: @187240
     /* 187240 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(187277), // Rule ID 3464 //
     /* 187245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 187248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 187253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187266 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2140:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 187269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187275 */     GIR_RootConstrainSelectedInstOperands,
     /* 187276 */     // GIR_Coverage, 3464,
     /* 187276 */     GIR_EraseRootFromParent_Done,
     /* 187277 */   // Label 3671: @187277
     /* 187277 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(187314), // Rule ID 3465 //
     /* 187282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 187285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 187290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187303 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2140:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 187306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187312 */     GIR_RootConstrainSelectedInstOperands,
     /* 187313 */     // GIR_Coverage, 3465,
     /* 187313 */     GIR_EraseRootFromParent_Done,
     /* 187314 */   // Label 3672: @187314
     /* 187314 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(187351), // Rule ID 3466 //
     /* 187319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 187322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 187327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187340 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2140:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 187340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 187343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187349 */     GIR_RootConstrainSelectedInstOperands,
     /* 187350 */     // GIR_Coverage, 3466,
     /* 187350 */     GIR_EraseRootFromParent_Done,
     /* 187351 */   // Label 3673: @187351
     /* 187351 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(187388), // Rule ID 3467 //
     /* 187356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 187359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 187364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187377 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2140:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 187380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187386 */     GIR_RootConstrainSelectedInstOperands,
     /* 187387 */     // GIR_Coverage, 3467,
     /* 187387 */     GIR_EraseRootFromParent_Done,
     /* 187388 */   // Label 3674: @187388
     /* 187388 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(187425), // Rule ID 3468 //
     /* 187393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 187396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 187401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187414 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2140:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 187414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 187417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187423 */     GIR_RootConstrainSelectedInstOperands,
     /* 187424 */     // GIR_Coverage, 3468,
     /* 187424 */     GIR_EraseRootFromParent_Done,
     /* 187425 */   // Label 3675: @187425
     /* 187425 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(187462), // Rule ID 3469 //
     /* 187430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 187433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 187438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187451 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2140:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 187454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187460 */     GIR_RootConstrainSelectedInstOperands,
     /* 187461 */     // GIR_Coverage, 3469,
     /* 187461 */     GIR_EraseRootFromParent_Done,
     /* 187462 */   // Label 3676: @187462
     /* 187462 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(187499), // Rule ID 3470 //
     /* 187467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 187470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 187475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187488 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2140:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 187488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 187491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187497 */     GIR_RootConstrainSelectedInstOperands,
     /* 187498 */     // GIR_Coverage, 3470,
     /* 187498 */     GIR_EraseRootFromParent_Done,
     /* 187499 */   // Label 3677: @187499
     /* 187499 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(187536), // Rule ID 3525 //
     /* 187504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 187512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 187518 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187525 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1353:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 187525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
     /* 187528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187534 */     GIR_RootConstrainSelectedInstOperands,
     /* 187535 */     // GIR_Coverage, 3525,
     /* 187535 */     GIR_EraseRootFromParent_Done,
     /* 187536 */   // Label 3678: @187536
     /* 187536 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(187573), // Rule ID 3526 //
     /* 187541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 187549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 187555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187562 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1353:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 187562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
     /* 187565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187571 */     GIR_RootConstrainSelectedInstOperands,
     /* 187572 */     // GIR_Coverage, 3526,
     /* 187572 */     GIR_EraseRootFromParent_Done,
     /* 187573 */   // Label 3679: @187573
     /* 187573 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(187610), // Rule ID 3527 //
     /* 187578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 187586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 187592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187599 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1353:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 187599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
     /* 187602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187608 */     GIR_RootConstrainSelectedInstOperands,
     /* 187609 */     // GIR_Coverage, 3527,
     /* 187609 */     GIR_EraseRootFromParent_Done,
     /* 187610 */   // Label 3680: @187610
     /* 187610 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(187647), // Rule ID 3557 //
     /* 187615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 187623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 187626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 187629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187636 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1604:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
     /* 187639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187645 */     GIR_RootConstrainSelectedInstOperands,
     /* 187646 */     // GIR_Coverage, 3557,
     /* 187646 */     GIR_EraseRootFromParent_Done,
     /* 187647 */   // Label 3681: @187647
     /* 187647 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(187684), // Rule ID 3558 //
     /* 187652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 187660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 187666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187673 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1604:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
     /* 187676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187682 */     GIR_RootConstrainSelectedInstOperands,
     /* 187683 */     // GIR_Coverage, 3558,
     /* 187683 */     GIR_EraseRootFromParent_Done,
     /* 187684 */   // Label 3682: @187684
     /* 187684 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(187721), // Rule ID 3559 //
     /* 187689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 187697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 187703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187710 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1604:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
     /* 187713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187719 */     GIR_RootConstrainSelectedInstOperands,
     /* 187720 */     // GIR_Coverage, 3559,
     /* 187720 */     GIR_EraseRootFromParent_Done,
     /* 187721 */   // Label 3683: @187721
     /* 187721 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(187758), // Rule ID 3560 //
     /* 187726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 187734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 187740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187747 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1604:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
     /* 187750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 187752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187756 */     GIR_RootConstrainSelectedInstOperands,
     /* 187757 */     // GIR_Coverage, 3560,
     /* 187757 */     GIR_EraseRootFromParent_Done,
     /* 187758 */   // Label 3684: @187758
     /* 187758 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(187795), // Rule ID 3561 //
     /* 187763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 187774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 187777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 187780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187784 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2148:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 187784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
     /* 187787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187793 */     GIR_RootConstrainSelectedInstOperands,
     /* 187794 */     // GIR_Coverage, 3561,
     /* 187794 */     GIR_EraseRootFromParent_Done,
     /* 187795 */   // Label 3685: @187795
     /* 187795 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(187832), // Rule ID 3562 //
     /* 187800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187821 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2148:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 187821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 187824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187830 */     GIR_RootConstrainSelectedInstOperands,
     /* 187831 */     // GIR_Coverage, 3562,
     /* 187831 */     GIR_EraseRootFromParent_Done,
     /* 187832 */   // Label 3686: @187832
     /* 187832 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(187869), // Rule ID 3563 //
     /* 187837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187858 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2148:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 187858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 187861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187867 */     GIR_RootConstrainSelectedInstOperands,
     /* 187868 */     // GIR_Coverage, 3563,
     /* 187868 */     GIR_EraseRootFromParent_Done,
     /* 187869 */   // Label 3687: @187869
     /* 187869 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(187906), // Rule ID 3564 //
     /* 187874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 187891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187895 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2148:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 187895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 187898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187904 */     GIR_RootConstrainSelectedInstOperands,
     /* 187905 */     // GIR_Coverage, 3564,
     /* 187905 */     GIR_EraseRootFromParent_Done,
     /* 187906 */   // Label 3688: @187906
     /* 187906 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(187943), // Rule ID 3565 //
     /* 187911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 187922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 187925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 187928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187932 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2148:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 187932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 187935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187941 */     GIR_RootConstrainSelectedInstOperands,
     /* 187942 */     // GIR_Coverage, 3565,
     /* 187942 */     GIR_EraseRootFromParent_Done,
     /* 187943 */   // Label 3689: @187943
     /* 187943 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(187980), // Rule ID 3566 //
     /* 187948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 187959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 187962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 187965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 187969 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2148:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 187969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 187972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 187974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 187976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 187978 */     GIR_RootConstrainSelectedInstOperands,
     /* 187979 */     // GIR_Coverage, 3566,
     /* 187979 */     GIR_EraseRootFromParent_Done,
     /* 187980 */   // Label 3690: @187980
     /* 187980 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(188017), // Rule ID 3567 //
     /* 187985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 187988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 187993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 187996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 187999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188006 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2148:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 188006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 188009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188015 */     GIR_RootConstrainSelectedInstOperands,
     /* 188016 */     // GIR_Coverage, 3567,
     /* 188016 */     GIR_EraseRootFromParent_Done,
     /* 188017 */   // Label 3691: @188017
     /* 188017 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(188054), // Rule ID 3568 //
     /* 188022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 188030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 188033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 188036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 188039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188043 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1903:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 188043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
     /* 188046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188052 */     GIR_RootConstrainSelectedInstOperands,
     /* 188053 */     // GIR_Coverage, 3568,
     /* 188053 */     GIR_EraseRootFromParent_Done,
     /* 188054 */   // Label 3692: @188054
     /* 188054 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(188091), // Rule ID 3569 //
     /* 188059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 188067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188080 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1903:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 188083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188089 */     GIR_RootConstrainSelectedInstOperands,
     /* 188090 */     // GIR_Coverage, 3569,
     /* 188090 */     GIR_EraseRootFromParent_Done,
     /* 188091 */   // Label 3693: @188091
     /* 188091 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(188128), // Rule ID 3570 //
     /* 188096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 188104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188117 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1903:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 188120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188126 */     GIR_RootConstrainSelectedInstOperands,
     /* 188127 */     // GIR_Coverage, 3570,
     /* 188127 */     GIR_EraseRootFromParent_Done,
     /* 188128 */   // Label 3694: @188128
     /* 188128 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(188165), // Rule ID 3571 //
     /* 188133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 188141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188154 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1903:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 188157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188163 */     GIR_RootConstrainSelectedInstOperands,
     /* 188164 */     // GIR_Coverage, 3571,
     /* 188164 */     GIR_EraseRootFromParent_Done,
     /* 188165 */   // Label 3695: @188165
     /* 188165 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(188202), // Rule ID 3572 //
     /* 188170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 188178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 188181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 188184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 188187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188191 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1903:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 188191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 188194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188200 */     GIR_RootConstrainSelectedInstOperands,
     /* 188201 */     // GIR_Coverage, 3572,
     /* 188201 */     GIR_EraseRootFromParent_Done,
     /* 188202 */   // Label 3696: @188202
     /* 188202 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(188239), // Rule ID 3573 //
     /* 188207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 188215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188228 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1903:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 188231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188237 */     GIR_RootConstrainSelectedInstOperands,
     /* 188238 */     // GIR_Coverage, 3573,
     /* 188238 */     GIR_EraseRootFromParent_Done,
     /* 188239 */   // Label 3697: @188239
     /* 188239 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(188276), // Rule ID 3574 //
     /* 188244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 188247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 188252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188265 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1903:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 188268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188274 */     GIR_RootConstrainSelectedInstOperands,
     /* 188275 */     // GIR_Coverage, 3574,
     /* 188275 */     GIR_EraseRootFromParent_Done,
     /* 188276 */   // Label 3698: @188276
     /* 188276 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(188313), // Rule ID 8357 //
     /* 188281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
     /* 188289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 188295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 188298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188302 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1282:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 188302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
     /* 188305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188311 */     GIR_RootConstrainSelectedInstOperands,
     /* 188312 */     // GIR_Coverage, 8357,
     /* 188312 */     GIR_EraseRootFromParent_Done,
     /* 188313 */   // Label 3699: @188313
     /* 188313 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(188350), // Rule ID 8833 //
     /* 188318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 188326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188339 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1240:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
     /* 188342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188348 */     GIR_RootConstrainSelectedInstOperands,
     /* 188349 */     // GIR_Coverage, 8833,
     /* 188349 */     GIR_EraseRootFromParent_Done,
     /* 188350 */   // Label 3700: @188350
     /* 188350 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(188387), // Rule ID 8834 //
     /* 188355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 188363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188376 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1242:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
     /* 188379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188385 */     GIR_RootConstrainSelectedInstOperands,
     /* 188386 */     // GIR_Coverage, 8834,
     /* 188386 */     GIR_EraseRootFromParent_Done,
     /* 188387 */   // Label 3701: @188387
     /* 188387 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(188424), // Rule ID 8835 //
     /* 188392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 188400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188413 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1243:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
     /* 188416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188422 */     GIR_RootConstrainSelectedInstOperands,
     /* 188423 */     // GIR_Coverage, 8835,
     /* 188423 */     GIR_EraseRootFromParent_Done,
     /* 188424 */   // Label 3702: @188424
     /* 188424 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(188461), // Rule ID 8836 //
     /* 188429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 188437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 188440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 188443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 188446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188450 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1241:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 188450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
     /* 188453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188459 */     GIR_RootConstrainSelectedInstOperands,
     /* 188460 */     // GIR_Coverage, 8836,
     /* 188460 */     GIR_EraseRootFromParent_Done,
     /* 188461 */   // Label 3703: @188461
     /* 188461 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(188498), // Rule ID 8837 //
     /* 188466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 188474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188487 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1240:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
     /* 188490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188496 */     GIR_RootConstrainSelectedInstOperands,
     /* 188497 */     // GIR_Coverage, 8837,
     /* 188497 */     GIR_EraseRootFromParent_Done,
     /* 188498 */   // Label 3704: @188498
     /* 188498 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(188535), // Rule ID 8838 //
     /* 188503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 188511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188524 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1242:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
     /* 188527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188533 */     GIR_RootConstrainSelectedInstOperands,
     /* 188534 */     // GIR_Coverage, 8838,
     /* 188534 */     GIR_EraseRootFromParent_Done,
     /* 188535 */   // Label 3705: @188535
     /* 188535 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(188572), // Rule ID 8839 //
     /* 188540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 188548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188561 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1243:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
     /* 188564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188570 */     GIR_RootConstrainSelectedInstOperands,
     /* 188571 */     // GIR_Coverage, 8839,
     /* 188571 */     GIR_EraseRootFromParent_Done,
     /* 188572 */   // Label 3706: @188572
     /* 188572 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(188609), // Rule ID 8840 //
     /* 188577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 188580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 188585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 188588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 188591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 188594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 188598 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1241:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 188598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
     /* 188601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 188603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188607 */     GIR_RootConstrainSelectedInstOperands,
     /* 188608 */     // GIR_Coverage, 8840,
     /* 188608 */     GIR_EraseRootFromParent_Done,
     /* 188609 */   // Label 3707: @188609
     /* 188609 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(188649), // Rule ID 9840 //
     /* 188614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188635 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
     /* 188638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188644 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188647 */     GIR_RootConstrainSelectedInstOperands,
     /* 188648 */     // GIR_Coverage, 9840,
     /* 188648 */     GIR_EraseRootFromParent_Done,
     /* 188649 */   // Label 3708: @188649
     /* 188649 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(188689), // Rule ID 9841 //
     /* 188654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188675 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
     /* 188678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188684 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188687 */     GIR_RootConstrainSelectedInstOperands,
     /* 188688 */     // GIR_Coverage, 9841,
     /* 188688 */     GIR_EraseRootFromParent_Done,
     /* 188689 */   // Label 3709: @188689
     /* 188689 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(188729), // Rule ID 9842 //
     /* 188694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188715 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
     /* 188718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188724 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188727 */     GIR_RootConstrainSelectedInstOperands,
     /* 188728 */     // GIR_Coverage, 9842,
     /* 188728 */     GIR_EraseRootFromParent_Done,
     /* 188729 */   // Label 3710: @188729
     /* 188729 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(188769), // Rule ID 9843 //
     /* 188734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 188742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188755 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2100:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
     /* 188758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188764 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188767 */     GIR_RootConstrainSelectedInstOperands,
     /* 188768 */     // GIR_Coverage, 9843,
     /* 188768 */     GIR_EraseRootFromParent_Done,
     /* 188769 */   // Label 3711: @188769
     /* 188769 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(188809), // Rule ID 9844 //
     /* 188774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188795 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_B),
     /* 188798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188807 */     GIR_RootConstrainSelectedInstOperands,
     /* 188808 */     // GIR_Coverage, 9844,
     /* 188808 */     GIR_EraseRootFromParent_Done,
     /* 188809 */   // Label 3712: @188809
     /* 188809 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(188849), // Rule ID 9845 //
     /* 188814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188835 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_H),
     /* 188838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188844 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188847 */     GIR_RootConstrainSelectedInstOperands,
     /* 188848 */     // GIR_Coverage, 9845,
     /* 188848 */     GIR_EraseRootFromParent_Done,
     /* 188849 */   // Label 3713: @188849
     /* 188849 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(188889), // Rule ID 9846 //
     /* 188854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 188865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188875 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_S),
     /* 188878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188887 */     GIR_RootConstrainSelectedInstOperands,
     /* 188888 */     // GIR_Coverage, 9846,
     /* 188888 */     GIR_EraseRootFromParent_Done,
     /* 188889 */   // Label 3714: @188889
     /* 188889 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(188929), // Rule ID 9847 //
     /* 188894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 188902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 188905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188915 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2106:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELO_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PWW_D),
     /* 188918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188924 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188927 */     GIR_RootConstrainSelectedInstOperands,
     /* 188928 */     // GIR_Coverage, 9847,
     /* 188928 */     GIR_EraseRootFromParent_Done,
     /* 188929 */   // Label 3715: @188929
     /* 188929 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(188969), // Rule ID 9852 //
     /* 188934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 188945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188955 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
     /* 188958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 188960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 188962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 188964 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 188967 */     GIR_RootConstrainSelectedInstOperands,
     /* 188968 */     // GIR_Coverage, 9852,
     /* 188968 */     GIR_EraseRootFromParent_Done,
     /* 188969 */   // Label 3716: @188969
     /* 188969 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(189009), // Rule ID 9853 //
     /* 188974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 188977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 188982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 188985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 188988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 188991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 188995 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 188995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
     /* 188998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189004 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189007 */     GIR_RootConstrainSelectedInstOperands,
     /* 189008 */     // GIR_Coverage, 9853,
     /* 189008 */     GIR_EraseRootFromParent_Done,
     /* 189009 */   // Label 3717: @189009
     /* 189009 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(189049), // Rule ID 9854 //
     /* 189014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 189022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 189025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 189028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 189031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189035 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 189035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
     /* 189038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189044 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189047 */     GIR_RootConstrainSelectedInstOperands,
     /* 189048 */     // GIR_Coverage, 9854,
     /* 189048 */     GIR_EraseRootFromParent_Done,
     /* 189049 */   // Label 3718: @189049
     /* 189049 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(189089), // Rule ID 9855 //
     /* 189054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 189062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 189065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 189068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 189071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189075 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2112:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 189075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
     /* 189078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189087 */     GIR_RootConstrainSelectedInstOperands,
     /* 189088 */     // GIR_Coverage, 9855,
     /* 189088 */     GIR_EraseRootFromParent_Done,
     /* 189089 */   // Label 3719: @189089
     /* 189089 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(189129), // Rule ID 9856 //
     /* 189094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 189102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 189105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189115 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
     /* 189118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189124 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189127 */     GIR_RootConstrainSelectedInstOperands,
     /* 189128 */     // GIR_Coverage, 9856,
     /* 189128 */     GIR_EraseRootFromParent_Done,
     /* 189129 */   // Label 3720: @189129
     /* 189129 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(189169), // Rule ID 9857 //
     /* 189134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 189142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 189145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189148 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189155 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
     /* 189158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189164 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189167 */     GIR_RootConstrainSelectedInstOperands,
     /* 189168 */     // GIR_Coverage, 9857,
     /* 189168 */     GIR_EraseRootFromParent_Done,
     /* 189169 */   // Label 3721: @189169
     /* 189169 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(189209), // Rule ID 9858 //
     /* 189174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 189182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 189185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189195 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
     /* 189198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189207 */     GIR_RootConstrainSelectedInstOperands,
     /* 189208 */     // GIR_Coverage, 9858,
     /* 189208 */     GIR_EraseRootFromParent_Done,
     /* 189209 */   // Label 3722: @189209
     /* 189209 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(189249), // Rule ID 9859 //
     /* 189214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 189222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 189225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189235 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2100:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
     /* 189238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189244 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189247 */     GIR_RootConstrainSelectedInstOperands,
     /* 189248 */     // GIR_Coverage, 9859,
     /* 189248 */     GIR_EraseRootFromParent_Done,
     /* 189249 */   // Label 3723: @189249
     /* 189249 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(189289), // Rule ID 9860 //
     /* 189254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 189262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 189265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189275 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_B),
     /* 189278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189284 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189287 */     GIR_RootConstrainSelectedInstOperands,
     /* 189288 */     // GIR_Coverage, 9860,
     /* 189288 */     GIR_EraseRootFromParent_Done,
     /* 189289 */   // Label 3724: @189289
     /* 189289 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(189329), // Rule ID 9861 //
     /* 189294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 189302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 189305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189315 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_H),
     /* 189318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189324 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189327 */     GIR_RootConstrainSelectedInstOperands,
     /* 189328 */     // GIR_Coverage, 9861,
     /* 189328 */     GIR_EraseRootFromParent_Done,
     /* 189329 */   // Label 3725: @189329
     /* 189329 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(189369), // Rule ID 9862 //
     /* 189334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 189342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 189345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189355 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_S),
     /* 189358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189364 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189367 */     GIR_RootConstrainSelectedInstOperands,
     /* 189368 */     // GIR_Coverage, 9862,
     /* 189368 */     GIR_EraseRootFromParent_Done,
     /* 189369 */   // Label 3726: @189369
     /* 189369 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(189409), // Rule ID 9863 //
     /* 189374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelo),
     /* 189382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 189385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189395 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2106:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELO_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELO_PXX_D),
     /* 189398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189404 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189407 */     GIR_RootConstrainSelectedInstOperands,
     /* 189408 */     // GIR_Coverage, 9863,
     /* 189408 */     GIR_EraseRootFromParent_Done,
     /* 189409 */   // Label 3727: @189409
     /* 189409 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(189449), // Rule ID 9868 //
     /* 189414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 189422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 189425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189435 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 189438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189447 */     GIR_RootConstrainSelectedInstOperands,
     /* 189448 */     // GIR_Coverage, 9868,
     /* 189448 */     GIR_EraseRootFromParent_Done,
     /* 189449 */   // Label 3728: @189449
     /* 189449 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(189489), // Rule ID 9869 //
     /* 189454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 189462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 189465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189475 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 189478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189487 */     GIR_RootConstrainSelectedInstOperands,
     /* 189488 */     // GIR_Coverage, 9869,
     /* 189488 */     GIR_EraseRootFromParent_Done,
     /* 189489 */   // Label 3729: @189489
     /* 189489 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(189529), // Rule ID 9870 //
     /* 189494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 189502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 189505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189515 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 189518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189524 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189527 */     GIR_RootConstrainSelectedInstOperands,
     /* 189528 */     // GIR_Coverage, 9870,
     /* 189528 */     GIR_EraseRootFromParent_Done,
     /* 189529 */   // Label 3730: @189529
     /* 189529 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(189569), // Rule ID 9871 //
     /* 189534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 189542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 189545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 189548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 189551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 189555 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2112:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 189555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 189558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 189560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189564 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 189567 */     GIR_RootConstrainSelectedInstOperands,
     /* 189568 */     // GIR_Coverage, 9871,
     /* 189568 */     GIR_EraseRootFromParent_Done,
     /* 189569 */   // Label 3731: @189569
     /* 189569 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(189606), // Rule ID 10030 //
     /* 189574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 189582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 189591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189595 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2010:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 189595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
     /* 189598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189604 */     GIR_RootConstrainSelectedInstOperands,
     /* 189605 */     // GIR_Coverage, 10030,
     /* 189605 */     GIR_EraseRootFromParent_Done,
     /* 189606 */   // Label 3732: @189606
     /* 189606 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(189643), // Rule ID 10031 //
     /* 189611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 189619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 189628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189632 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2010:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 189632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
     /* 189635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189641 */     GIR_RootConstrainSelectedInstOperands,
     /* 189642 */     // GIR_Coverage, 10031,
     /* 189642 */     GIR_EraseRootFromParent_Done,
     /* 189643 */   // Label 3733: @189643
     /* 189643 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(189680), // Rule ID 10032 //
     /* 189648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 189656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 189665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189669 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2010:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 189669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
     /* 189672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189678 */     GIR_RootConstrainSelectedInstOperands,
     /* 189679 */     // GIR_Coverage, 10032,
     /* 189679 */     GIR_EraseRootFromParent_Done,
     /* 189680 */   // Label 3734: @189680
     /* 189680 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(189717), // Rule ID 10033 //
     /* 189685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 189693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 189702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189706 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1765:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 189706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
     /* 189709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189715 */     GIR_RootConstrainSelectedInstOperands,
     /* 189716 */     // GIR_Coverage, 10033,
     /* 189716 */     GIR_EraseRootFromParent_Done,
     /* 189717 */   // Label 3735: @189717
     /* 189717 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(189754), // Rule ID 10034 //
     /* 189722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 189730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 189739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189743 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1765:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 189743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
     /* 189746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189752 */     GIR_RootConstrainSelectedInstOperands,
     /* 189753 */     // GIR_Coverage, 10034,
     /* 189753 */     GIR_EraseRootFromParent_Done,
     /* 189754 */   // Label 3736: @189754
     /* 189754 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(189791), // Rule ID 10035 //
     /* 189759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 189767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 189776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189780 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1765:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 189780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
     /* 189783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189789 */     GIR_RootConstrainSelectedInstOperands,
     /* 189790 */     // GIR_Coverage, 10035,
     /* 189790 */     GIR_EraseRootFromParent_Done,
     /* 189791 */   // Label 3737: @189791
     /* 189791 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(189828), // Rule ID 10036 //
     /* 189796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 189804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 189813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189817 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1996:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 189817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
     /* 189820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189826 */     GIR_RootConstrainSelectedInstOperands,
     /* 189827 */     // GIR_Coverage, 10036,
     /* 189827 */     GIR_EraseRootFromParent_Done,
     /* 189828 */   // Label 3738: @189828
     /* 189828 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(189865), // Rule ID 10037 //
     /* 189833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 189841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 189844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 189847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 189850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189854 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1996:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 189854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
     /* 189857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189863 */     GIR_RootConstrainSelectedInstOperands,
     /* 189864 */     // GIR_Coverage, 10037,
     /* 189864 */     GIR_EraseRootFromParent_Done,
     /* 189865 */   // Label 3739: @189865
     /* 189865 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(189902), // Rule ID 10038 //
     /* 189870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 189873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 189878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 189881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 189884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 189887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189891 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1996:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 189891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
     /* 189894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 189896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189900 */     GIR_RootConstrainSelectedInstOperands,
     /* 189901 */     // GIR_Coverage, 10038,
     /* 189901 */     GIR_EraseRootFromParent_Done,
     /* 189902 */   // Label 3740: @189902
     /* 189902 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(189939), // Rule ID 11206 //
     /* 189907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 189918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 189921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 189924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189928 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2145:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 189928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189937 */     GIR_RootConstrainSelectedInstOperands,
     /* 189938 */     // GIR_Coverage, 11206,
     /* 189938 */     GIR_EraseRootFromParent_Done,
     /* 189939 */   // Label 3741: @189939
     /* 189939 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(189976), // Rule ID 11207 //
     /* 189944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 189965 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2145:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 189965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 189968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 189970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 189972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 189974 */     GIR_RootConstrainSelectedInstOperands,
     /* 189975 */     // GIR_Coverage, 11207,
     /* 189975 */     GIR_EraseRootFromParent_Done,
     /* 189976 */   // Label 3742: @189976
     /* 189976 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(190013), // Rule ID 11208 //
     /* 189981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 189984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 189989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 189992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 189995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 189998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190002 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2145:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 190002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 190005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190011 */     GIR_RootConstrainSelectedInstOperands,
     /* 190012 */     // GIR_Coverage, 11208,
     /* 190012 */     GIR_EraseRootFromParent_Done,
     /* 190013 */   // Label 3743: @190013
     /* 190013 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(190050), // Rule ID 11209 //
     /* 190018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 190026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190039 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2145:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 190042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190048 */     GIR_RootConstrainSelectedInstOperands,
     /* 190049 */     // GIR_Coverage, 11209,
     /* 190049 */     GIR_EraseRootFromParent_Done,
     /* 190050 */   // Label 3744: @190050
     /* 190050 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(190087), // Rule ID 11210 //
     /* 190055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 190063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190076 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2145:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 190079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190085 */     GIR_RootConstrainSelectedInstOperands,
     /* 190086 */     // GIR_Coverage, 11210,
     /* 190086 */     GIR_EraseRootFromParent_Done,
     /* 190087 */   // Label 3745: @190087
     /* 190087 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(190124), // Rule ID 11211 //
     /* 190092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 190100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190113 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2145:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 190116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190122 */     GIR_RootConstrainSelectedInstOperands,
     /* 190123 */     // GIR_Coverage, 11211,
     /* 190123 */     GIR_EraseRootFromParent_Done,
     /* 190124 */   // Label 3746: @190124
     /* 190124 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(190161), // Rule ID 11212 //
     /* 190129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 190137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190150 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2145:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 190153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190159 */     GIR_RootConstrainSelectedInstOperands,
     /* 190160 */     // GIR_Coverage, 11212,
     /* 190160 */     GIR_EraseRootFromParent_Done,
     /* 190161 */   // Label 3747: @190161
     /* 190161 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(190198), // Rule ID 11213 //
     /* 190166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 190174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 190177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190187 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2066:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 190190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190196 */     GIR_RootConstrainSelectedInstOperands,
     /* 190197 */     // GIR_Coverage, 11213,
     /* 190197 */     GIR_EraseRootFromParent_Done,
     /* 190198 */   // Label 3748: @190198
     /* 190198 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(190235), // Rule ID 11214 //
     /* 190203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 190211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2066:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 190227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190233 */     GIR_RootConstrainSelectedInstOperands,
     /* 190234 */     // GIR_Coverage, 11214,
     /* 190234 */     GIR_EraseRootFromParent_Done,
     /* 190235 */   // Label 3749: @190235
     /* 190235 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(190272), // Rule ID 11215 //
     /* 190240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 190248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190261 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2066:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 190261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 190264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190270 */     GIR_RootConstrainSelectedInstOperands,
     /* 190271 */     // GIR_Coverage, 11215,
     /* 190271 */     GIR_EraseRootFromParent_Done,
     /* 190272 */   // Label 3750: @190272
     /* 190272 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(190309), // Rule ID 11216 //
     /* 190277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 190285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190298 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2066:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 190301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190307 */     GIR_RootConstrainSelectedInstOperands,
     /* 190308 */     // GIR_Coverage, 11216,
     /* 190308 */     GIR_EraseRootFromParent_Done,
     /* 190309 */   // Label 3751: @190309
     /* 190309 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(190346), // Rule ID 11217 //
     /* 190314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 190322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190335 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2066:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 190338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190344 */     GIR_RootConstrainSelectedInstOperands,
     /* 190345 */     // GIR_Coverage, 11217,
     /* 190345 */     GIR_EraseRootFromParent_Done,
     /* 190346 */   // Label 3752: @190346
     /* 190346 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(190383), // Rule ID 11218 //
     /* 190351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 190359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190372 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2066:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 190375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190381 */     GIR_RootConstrainSelectedInstOperands,
     /* 190382 */     // GIR_Coverage, 11218,
     /* 190382 */     GIR_EraseRootFromParent_Done,
     /* 190383 */   // Label 3753: @190383
     /* 190383 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(190420), // Rule ID 11219 //
     /* 190388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 190396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190409 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2066:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 190412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190418 */     GIR_RootConstrainSelectedInstOperands,
     /* 190419 */     // GIR_Coverage, 11219,
     /* 190419 */     GIR_EraseRootFromParent_Done,
     /* 190420 */   // Label 3754: @190420
     /* 190420 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(190457), // Rule ID 11220 //
     /* 190425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 190436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190446 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2071:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190455 */     GIR_RootConstrainSelectedInstOperands,
     /* 190456 */     // GIR_Coverage, 11220,
     /* 190456 */     GIR_EraseRootFromParent_Done,
     /* 190457 */   // Label 3755: @190457
     /* 190457 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(190494), // Rule ID 11221 //
     /* 190462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190483 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2071:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190492 */     GIR_RootConstrainSelectedInstOperands,
     /* 190493 */     // GIR_Coverage, 11221,
     /* 190493 */     GIR_EraseRootFromParent_Done,
     /* 190494 */   // Label 3756: @190494
     /* 190494 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(190531), // Rule ID 11222 //
     /* 190499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190520 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2071:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 190520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190529 */     GIR_RootConstrainSelectedInstOperands,
     /* 190530 */     // GIR_Coverage, 11222,
     /* 190530 */     GIR_EraseRootFromParent_Done,
     /* 190531 */   // Label 3757: @190531
     /* 190531 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(190568), // Rule ID 11223 //
     /* 190536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190557 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2071:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190566 */     GIR_RootConstrainSelectedInstOperands,
     /* 190567 */     // GIR_Coverage, 11223,
     /* 190567 */     GIR_EraseRootFromParent_Done,
     /* 190568 */   // Label 3758: @190568
     /* 190568 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(190605), // Rule ID 11224 //
     /* 190573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190594 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2071:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190603 */     GIR_RootConstrainSelectedInstOperands,
     /* 190604 */     // GIR_Coverage, 11224,
     /* 190604 */     GIR_EraseRootFromParent_Done,
     /* 190605 */   // Label 3759: @190605
     /* 190605 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(190642), // Rule ID 11225 //
     /* 190610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190631 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2071:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190640 */     GIR_RootConstrainSelectedInstOperands,
     /* 190641 */     // GIR_Coverage, 11225,
     /* 190641 */     GIR_EraseRootFromParent_Done,
     /* 190642 */   // Label 3760: @190642
     /* 190642 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(190679), // Rule ID 11226 //
     /* 190647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 190655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190668 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2071:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 190671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190677 */     GIR_RootConstrainSelectedInstOperands,
     /* 190678 */     // GIR_Coverage, 11226,
     /* 190678 */     GIR_EraseRootFromParent_Done,
     /* 190679 */   // Label 3761: @190679
     /* 190679 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(190716), // Rule ID 11227 //
     /* 190684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 190695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190705 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1910:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190714 */     GIR_RootConstrainSelectedInstOperands,
     /* 190715 */     // GIR_Coverage, 11227,
     /* 190715 */     GIR_EraseRootFromParent_Done,
     /* 190716 */   // Label 3762: @190716
     /* 190716 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(190753), // Rule ID 11228 //
     /* 190721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190742 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1910:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 190742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190751 */     GIR_RootConstrainSelectedInstOperands,
     /* 190752 */     // GIR_Coverage, 11228,
     /* 190752 */     GIR_EraseRootFromParent_Done,
     /* 190753 */   // Label 3763: @190753
     /* 190753 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(190790), // Rule ID 11229 //
     /* 190758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190779 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1910:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 190779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190788 */     GIR_RootConstrainSelectedInstOperands,
     /* 190789 */     // GIR_Coverage, 11229,
     /* 190789 */     GIR_EraseRootFromParent_Done,
     /* 190790 */   // Label 3764: @190790
     /* 190790 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(190827), // Rule ID 11230 //
     /* 190795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190816 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1910:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 190816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190825 */     GIR_RootConstrainSelectedInstOperands,
     /* 190826 */     // GIR_Coverage, 11230,
     /* 190826 */     GIR_EraseRootFromParent_Done,
     /* 190827 */   // Label 3765: @190827
     /* 190827 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(190864), // Rule ID 11231 //
     /* 190832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 190843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 190846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 190849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190853 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1910:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 190853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190862 */     GIR_RootConstrainSelectedInstOperands,
     /* 190863 */     // GIR_Coverage, 11231,
     /* 190863 */     GIR_EraseRootFromParent_Done,
     /* 190864 */   // Label 3766: @190864
     /* 190864 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(190901), // Rule ID 11232 //
     /* 190869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190890 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1910:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 190890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190899 */     GIR_RootConstrainSelectedInstOperands,
     /* 190900 */     // GIR_Coverage, 11232,
     /* 190900 */     GIR_EraseRootFromParent_Done,
     /* 190901 */   // Label 3767: @190901
     /* 190901 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(190938), // Rule ID 11233 //
     /* 190906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 190914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 190917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 190920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 190923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190927 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1910:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 190927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 190930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190936 */     GIR_RootConstrainSelectedInstOperands,
     /* 190937 */     // GIR_Coverage, 11233,
     /* 190937 */     GIR_EraseRootFromParent_Done,
     /* 190938 */   // Label 3768: @190938
     /* 190938 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(190975), // Rule ID 11234 //
     /* 190943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 190954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 190957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 190960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 190964 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1915:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 190964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 190967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 190969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 190971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 190973 */     GIR_RootConstrainSelectedInstOperands,
     /* 190974 */     // GIR_Coverage, 11234,
     /* 190974 */     GIR_EraseRootFromParent_Done,
     /* 190975 */   // Label 3769: @190975
     /* 190975 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(191012), // Rule ID 11235 //
     /* 190980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 190983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 190988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 190991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 190994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 190997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191001 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1915:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 191004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191010 */     GIR_RootConstrainSelectedInstOperands,
     /* 191011 */     // GIR_Coverage, 11235,
     /* 191011 */     GIR_EraseRootFromParent_Done,
     /* 191012 */   // Label 3770: @191012
     /* 191012 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(191049), // Rule ID 11236 //
     /* 191017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 191025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191038 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1915:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 191038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 191041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191047 */     GIR_RootConstrainSelectedInstOperands,
     /* 191048 */     // GIR_Coverage, 11236,
     /* 191048 */     GIR_EraseRootFromParent_Done,
     /* 191049 */   // Label 3771: @191049
     /* 191049 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(191086), // Rule ID 11237 //
     /* 191054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 191062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191075 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1915:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 191078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191084 */     GIR_RootConstrainSelectedInstOperands,
     /* 191085 */     // GIR_Coverage, 11237,
     /* 191085 */     GIR_EraseRootFromParent_Done,
     /* 191086 */   // Label 3772: @191086
     /* 191086 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(191123), // Rule ID 11238 //
     /* 191091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 191099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191112 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1915:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 191112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 191115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191121 */     GIR_RootConstrainSelectedInstOperands,
     /* 191122 */     // GIR_Coverage, 11238,
     /* 191122 */     GIR_EraseRootFromParent_Done,
     /* 191123 */   // Label 3773: @191123
     /* 191123 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(191160), // Rule ID 11239 //
     /* 191128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 191136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191149 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1915:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 191152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191158 */     GIR_RootConstrainSelectedInstOperands,
     /* 191159 */     // GIR_Coverage, 11239,
     /* 191159 */     GIR_EraseRootFromParent_Done,
     /* 191160 */   // Label 3774: @191160
     /* 191160 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(191197), // Rule ID 11240 //
     /* 191165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 191168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 191173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191186 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1915:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 191186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 191189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191195 */     GIR_RootConstrainSelectedInstOperands,
     /* 191196 */     // GIR_Coverage, 11240,
     /* 191196 */     GIR_EraseRootFromParent_Done,
     /* 191197 */   // Label 3775: @191197
     /* 191197 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(191234), // Rule ID 11260 //
     /* 191202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 191210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 191213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191223 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1812:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
     /* 191226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191232 */     GIR_RootConstrainSelectedInstOperands,
     /* 191233 */     // GIR_Coverage, 11260,
     /* 191233 */     GIR_EraseRootFromParent_Done,
     /* 191234 */   // Label 3776: @191234
     /* 191234 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(191271), // Rule ID 11261 //
     /* 191239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 191247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191260 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1812:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
     /* 191263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191269 */     GIR_RootConstrainSelectedInstOperands,
     /* 191270 */     // GIR_Coverage, 11261,
     /* 191270 */     GIR_EraseRootFromParent_Done,
     /* 191271 */   // Label 3777: @191271
     /* 191271 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(191308), // Rule ID 11262 //
     /* 191276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 191284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191297 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1812:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
     /* 191300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191306 */     GIR_RootConstrainSelectedInstOperands,
     /* 191307 */     // GIR_Coverage, 11262,
     /* 191307 */     GIR_EraseRootFromParent_Done,
     /* 191308 */   // Label 3778: @191308
     /* 191308 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(191345), // Rule ID 11263 //
     /* 191313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 191321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 191327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 191330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191334 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1812:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 191334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
     /* 191337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191343 */     GIR_RootConstrainSelectedInstOperands,
     /* 191344 */     // GIR_Coverage, 11263,
     /* 191344 */     GIR_EraseRootFromParent_Done,
     /* 191345 */   // Label 3779: @191345
     /* 191345 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(191382), // Rule ID 11551 //
     /* 191350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 191358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191371 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1676:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
     /* 191374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191380 */     GIR_RootConstrainSelectedInstOperands,
     /* 191381 */     // GIR_Coverage, 11551,
     /* 191381 */     GIR_EraseRootFromParent_Done,
     /* 191382 */   // Label 3780: @191382
     /* 191382 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(191419), // Rule ID 11552 //
     /* 191387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 191395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191408 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1676:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
     /* 191411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191417 */     GIR_RootConstrainSelectedInstOperands,
     /* 191418 */     // GIR_Coverage, 11552,
     /* 191418 */     GIR_EraseRootFromParent_Done,
     /* 191419 */   // Label 3781: @191419
     /* 191419 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(191456), // Rule ID 11553 //
     /* 191424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 191432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191445 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1676:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
     /* 191448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191454 */     GIR_RootConstrainSelectedInstOperands,
     /* 191455 */     // GIR_Coverage, 11553,
     /* 191455 */     GIR_EraseRootFromParent_Done,
     /* 191456 */   // Label 3782: @191456
     /* 191456 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(191493), // Rule ID 11554 //
     /* 191461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 191469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191482 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1924:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
     /* 191485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191491 */     GIR_RootConstrainSelectedInstOperands,
     /* 191492 */     // GIR_Coverage, 11554,
     /* 191492 */     GIR_EraseRootFromParent_Done,
     /* 191493 */   // Label 3783: @191493
     /* 191493 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(191530), // Rule ID 11555 //
     /* 191498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 191506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191519 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1924:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
     /* 191522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191528 */     GIR_RootConstrainSelectedInstOperands,
     /* 191529 */     // GIR_Coverage, 11555,
     /* 191529 */     GIR_EraseRootFromParent_Done,
     /* 191530 */   // Label 3784: @191530
     /* 191530 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(191567), // Rule ID 11556 //
     /* 191535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 191543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191556 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1924:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
     /* 191559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191565 */     GIR_RootConstrainSelectedInstOperands,
     /* 191566 */     // GIR_Coverage, 11556,
     /* 191566 */     GIR_EraseRootFromParent_Done,
     /* 191567 */   // Label 3785: @191567
     /* 191567 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(191604), // Rule ID 11557 //
     /* 191572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 191580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191593 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1925:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
     /* 191596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191602 */     GIR_RootConstrainSelectedInstOperands,
     /* 191603 */     // GIR_Coverage, 11557,
     /* 191603 */     GIR_EraseRootFromParent_Done,
     /* 191604 */   // Label 3786: @191604
     /* 191604 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(191641), // Rule ID 11558 //
     /* 191609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 191617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191630 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1925:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
     /* 191633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191639 */     GIR_RootConstrainSelectedInstOperands,
     /* 191640 */     // GIR_Coverage, 11558,
     /* 191640 */     GIR_EraseRootFromParent_Done,
     /* 191641 */   // Label 3787: @191641
     /* 191641 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(191678), // Rule ID 11559 //
     /* 191646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 191654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191667 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1925:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
     /* 191670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191676 */     GIR_RootConstrainSelectedInstOperands,
     /* 191677 */     // GIR_Coverage, 11559,
     /* 191677 */     GIR_EraseRootFromParent_Done,
     /* 191678 */   // Label 3788: @191678
     /* 191678 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(191715), // Rule ID 11560 //
     /* 191683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 191691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191704 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1853:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
     /* 191707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191713 */     GIR_RootConstrainSelectedInstOperands,
     /* 191714 */     // GIR_Coverage, 11560,
     /* 191714 */     GIR_EraseRootFromParent_Done,
     /* 191715 */   // Label 3789: @191715
     /* 191715 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(191752), // Rule ID 11561 //
     /* 191720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 191728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191741 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1853:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
     /* 191744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191750 */     GIR_RootConstrainSelectedInstOperands,
     /* 191751 */     // GIR_Coverage, 11561,
     /* 191751 */     GIR_EraseRootFromParent_Done,
     /* 191752 */   // Label 3790: @191752
     /* 191752 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(191789), // Rule ID 11562 //
     /* 191757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 191765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191778 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1853:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
     /* 191781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191787 */     GIR_RootConstrainSelectedInstOperands,
     /* 191788 */     // GIR_Coverage, 11562,
     /* 191788 */     GIR_EraseRootFromParent_Done,
     /* 191789 */   // Label 3791: @191789
     /* 191789 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(191826), // Rule ID 11563 //
     /* 191794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 191802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191815 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1855:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
     /* 191818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191824 */     GIR_RootConstrainSelectedInstOperands,
     /* 191825 */     // GIR_Coverage, 11563,
     /* 191825 */     GIR_EraseRootFromParent_Done,
     /* 191826 */   // Label 3792: @191826
     /* 191826 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(191863), // Rule ID 11564 //
     /* 191831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 191839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191852 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1855:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
     /* 191855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191861 */     GIR_RootConstrainSelectedInstOperands,
     /* 191862 */     // GIR_Coverage, 11564,
     /* 191862 */     GIR_EraseRootFromParent_Done,
     /* 191863 */   // Label 3793: @191863
     /* 191863 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(191900), // Rule ID 11565 //
     /* 191868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 191876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191889 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1855:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 191889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
     /* 191892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191898 */     GIR_RootConstrainSelectedInstOperands,
     /* 191899 */     // GIR_Coverage, 11565,
     /* 191899 */     GIR_EraseRootFromParent_Done,
     /* 191900 */   // Label 3794: @191900
     /* 191900 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(191937), // Rule ID 11566 //
     /* 191905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 191913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 191916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 191919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 191922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191926 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2049:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 191926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
     /* 191929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191935 */     GIR_RootConstrainSelectedInstOperands,
     /* 191936 */     // GIR_Coverage, 11566,
     /* 191936 */     GIR_EraseRootFromParent_Done,
     /* 191937 */   // Label 3795: @191937
     /* 191937 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(191974), // Rule ID 11567 //
     /* 191942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 191950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 191953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 191956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 191959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 191963 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2049:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 191963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
     /* 191966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 191968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 191970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 191972 */     GIR_RootConstrainSelectedInstOperands,
     /* 191973 */     // GIR_Coverage, 11567,
     /* 191973 */     GIR_EraseRootFromParent_Done,
     /* 191974 */   // Label 3796: @191974
     /* 191974 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(192011), // Rule ID 11568 //
     /* 191979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 191982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 191987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 191990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 191993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 191996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192000 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2049:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
     /* 192003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192009 */     GIR_RootConstrainSelectedInstOperands,
     /* 192010 */     // GIR_Coverage, 11568,
     /* 192010 */     GIR_EraseRootFromParent_Done,
     /* 192011 */   // Label 3797: @192011
     /* 192011 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(192048), // Rule ID 11569 //
     /* 192016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 192024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192037 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2050:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
     /* 192040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192046 */     GIR_RootConstrainSelectedInstOperands,
     /* 192047 */     // GIR_Coverage, 11569,
     /* 192047 */     GIR_EraseRootFromParent_Done,
     /* 192048 */   // Label 3798: @192048
     /* 192048 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(192085), // Rule ID 11570 //
     /* 192053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 192061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192074 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2050:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
     /* 192077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192083 */     GIR_RootConstrainSelectedInstOperands,
     /* 192084 */     // GIR_Coverage, 11570,
     /* 192084 */     GIR_EraseRootFromParent_Done,
     /* 192085 */   // Label 3799: @192085
     /* 192085 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(192122), // Rule ID 11571 //
     /* 192090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 192098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192111 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2050:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
     /* 192114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192120 */     GIR_RootConstrainSelectedInstOperands,
     /* 192121 */     // GIR_Coverage, 11571,
     /* 192121 */     GIR_EraseRootFromParent_Done,
     /* 192122 */   // Label 3800: @192122
     /* 192122 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(192159), // Rule ID 11572 //
     /* 192127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 192135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192148 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1671:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
     /* 192151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192157 */     GIR_RootConstrainSelectedInstOperands,
     /* 192158 */     // GIR_Coverage, 11572,
     /* 192158 */     GIR_EraseRootFromParent_Done,
     /* 192159 */   // Label 3801: @192159
     /* 192159 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(192196), // Rule ID 11573 //
     /* 192164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 192172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192185 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1671:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
     /* 192188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192194 */     GIR_RootConstrainSelectedInstOperands,
     /* 192195 */     // GIR_Coverage, 11573,
     /* 192195 */     GIR_EraseRootFromParent_Done,
     /* 192196 */   // Label 3802: @192196
     /* 192196 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(192233), // Rule ID 11574 //
     /* 192201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 192209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192222 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1671:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
     /* 192225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192231 */     GIR_RootConstrainSelectedInstOperands,
     /* 192232 */     // GIR_Coverage, 11574,
     /* 192232 */     GIR_EraseRootFromParent_Done,
     /* 192233 */   // Label 3803: @192233
     /* 192233 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(192270), // Rule ID 11575 //
     /* 192238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 192246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192259 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1672:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
     /* 192262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192268 */     GIR_RootConstrainSelectedInstOperands,
     /* 192269 */     // GIR_Coverage, 11575,
     /* 192269 */     GIR_EraseRootFromParent_Done,
     /* 192270 */   // Label 3804: @192270
     /* 192270 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(192307), // Rule ID 11576 //
     /* 192275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 192283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1672:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
     /* 192299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192305 */     GIR_RootConstrainSelectedInstOperands,
     /* 192306 */     // GIR_Coverage, 11576,
     /* 192306 */     GIR_EraseRootFromParent_Done,
     /* 192307 */   // Label 3805: @192307
     /* 192307 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(192344), // Rule ID 11577 //
     /* 192312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 192320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192333 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1672:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
     /* 192336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192342 */     GIR_RootConstrainSelectedInstOperands,
     /* 192343 */     // GIR_Coverage, 11577,
     /* 192343 */     GIR_EraseRootFromParent_Done,
     /* 192344 */   // Label 3806: @192344
     /* 192344 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(192381), // Rule ID 11578 //
     /* 192349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 192357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192370 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1921:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
     /* 192373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192379 */     GIR_RootConstrainSelectedInstOperands,
     /* 192380 */     // GIR_Coverage, 11578,
     /* 192380 */     GIR_EraseRootFromParent_Done,
     /* 192381 */   // Label 3807: @192381
     /* 192381 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(192418), // Rule ID 11579 //
     /* 192386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 192394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192407 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1921:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
     /* 192410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192416 */     GIR_RootConstrainSelectedInstOperands,
     /* 192417 */     // GIR_Coverage, 11579,
     /* 192417 */     GIR_EraseRootFromParent_Done,
     /* 192418 */   // Label 3808: @192418
     /* 192418 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(192455), // Rule ID 11580 //
     /* 192423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 192431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192444 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1921:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
     /* 192447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192453 */     GIR_RootConstrainSelectedInstOperands,
     /* 192454 */     // GIR_Coverage, 11580,
     /* 192454 */     GIR_EraseRootFromParent_Done,
     /* 192455 */   // Label 3809: @192455
     /* 192455 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(192492), // Rule ID 11581 //
     /* 192460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 192468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 192474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192481 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1922:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
     /* 192484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192490 */     GIR_RootConstrainSelectedInstOperands,
     /* 192491 */     // GIR_Coverage, 11581,
     /* 192491 */     GIR_EraseRootFromParent_Done,
     /* 192492 */   // Label 3810: @192492
     /* 192492 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(192529), // Rule ID 11582 //
     /* 192497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 192505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192518 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1922:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
     /* 192521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192527 */     GIR_RootConstrainSelectedInstOperands,
     /* 192528 */     // GIR_Coverage, 11582,
     /* 192528 */     GIR_EraseRootFromParent_Done,
     /* 192529 */   // Label 3811: @192529
     /* 192529 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(192566), // Rule ID 11583 //
     /* 192534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 192542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192555 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1922:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
     /* 192558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192564 */     GIR_RootConstrainSelectedInstOperands,
     /* 192565 */     // GIR_Coverage, 11583,
     /* 192565 */     GIR_EraseRootFromParent_Done,
     /* 192566 */   // Label 3812: @192566
     /* 192566 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(192603), // Rule ID 11593 //
     /* 192571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 192579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192592 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1857:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
     /* 192595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192601 */     GIR_RootConstrainSelectedInstOperands,
     /* 192602 */     // GIR_Coverage, 11593,
     /* 192602 */     GIR_EraseRootFromParent_Done,
     /* 192603 */   // Label 3813: @192603
     /* 192603 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(192640), // Rule ID 11594 //
     /* 192608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 192616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192629 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1857:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
     /* 192632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192638 */     GIR_RootConstrainSelectedInstOperands,
     /* 192639 */     // GIR_Coverage, 11594,
     /* 192639 */     GIR_EraseRootFromParent_Done,
     /* 192640 */   // Label 3814: @192640
     /* 192640 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(192677), // Rule ID 11595 //
     /* 192645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 192653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192666 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1857:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
     /* 192669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192675 */     GIR_RootConstrainSelectedInstOperands,
     /* 192676 */     // GIR_Coverage, 11595,
     /* 192676 */     GIR_EraseRootFromParent_Done,
     /* 192677 */   // Label 3815: @192677
     /* 192677 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(192714), // Rule ID 11596 //
     /* 192682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 192690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192703 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1858:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
     /* 192706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192712 */     GIR_RootConstrainSelectedInstOperands,
     /* 192713 */     // GIR_Coverage, 11596,
     /* 192713 */     GIR_EraseRootFromParent_Done,
     /* 192714 */   // Label 3816: @192714
     /* 192714 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(192751), // Rule ID 11597 //
     /* 192719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 192727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192740 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1858:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
     /* 192743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192749 */     GIR_RootConstrainSelectedInstOperands,
     /* 192750 */     // GIR_Coverage, 11597,
     /* 192750 */     GIR_EraseRootFromParent_Done,
     /* 192751 */   // Label 3817: @192751
     /* 192751 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(192788), // Rule ID 11598 //
     /* 192756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 192764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192777 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1858:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
     /* 192780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192786 */     GIR_RootConstrainSelectedInstOperands,
     /* 192787 */     // GIR_Coverage, 11598,
     /* 192787 */     GIR_EraseRootFromParent_Done,
     /* 192788 */   // Label 3818: @192788
     /* 192788 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(192825), // Rule ID 11599 //
     /* 192793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 192801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192814 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2051:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
     /* 192817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192823 */     GIR_RootConstrainSelectedInstOperands,
     /* 192824 */     // GIR_Coverage, 11599,
     /* 192824 */     GIR_EraseRootFromParent_Done,
     /* 192825 */   // Label 3819: @192825
     /* 192825 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(192862), // Rule ID 11600 //
     /* 192830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 192838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192851 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2051:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
     /* 192854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192860 */     GIR_RootConstrainSelectedInstOperands,
     /* 192861 */     // GIR_Coverage, 11600,
     /* 192861 */     GIR_EraseRootFromParent_Done,
     /* 192862 */   // Label 3820: @192862
     /* 192862 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(192899), // Rule ID 11601 //
     /* 192867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 192875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192888 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2051:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
     /* 192891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192897 */     GIR_RootConstrainSelectedInstOperands,
     /* 192898 */     // GIR_Coverage, 11601,
     /* 192898 */     GIR_EraseRootFromParent_Done,
     /* 192899 */   // Label 3821: @192899
     /* 192899 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(192936), // Rule ID 11602 //
     /* 192904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 192912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 192915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 192918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 192921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192925 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2052:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 192925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
     /* 192928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192934 */     GIR_RootConstrainSelectedInstOperands,
     /* 192935 */     // GIR_Coverage, 11602,
     /* 192935 */     GIR_EraseRootFromParent_Done,
     /* 192936 */   // Label 3822: @192936
     /* 192936 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(192973), // Rule ID 11603 //
     /* 192941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 192949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 192952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 192955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 192958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192962 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2052:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 192962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
     /* 192965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 192967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 192969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 192971 */     GIR_RootConstrainSelectedInstOperands,
     /* 192972 */     // GIR_Coverage, 11603,
     /* 192972 */     GIR_EraseRootFromParent_Done,
     /* 192973 */   // Label 3823: @192973
     /* 192973 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(193010), // Rule ID 11604 //
     /* 192978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 192981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 192986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 192989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 192992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 192995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 192999 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2052:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 192999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
     /* 193002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193008 */     GIR_RootConstrainSelectedInstOperands,
     /* 193009 */     // GIR_Coverage, 11604,
     /* 193009 */     GIR_EraseRootFromParent_Done,
     /* 193010 */   // Label 3824: @193010
     /* 193010 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(193047), // Rule ID 11605 //
     /* 193015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 193023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193036 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1787:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
     /* 193039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193045 */     GIR_RootConstrainSelectedInstOperands,
     /* 193046 */     // GIR_Coverage, 11605,
     /* 193046 */     GIR_EraseRootFromParent_Done,
     /* 193047 */   // Label 3825: @193047
     /* 193047 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(193084), // Rule ID 11606 //
     /* 193052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 193060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193073 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1787:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
     /* 193076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193082 */     GIR_RootConstrainSelectedInstOperands,
     /* 193083 */     // GIR_Coverage, 11606,
     /* 193083 */     GIR_EraseRootFromParent_Done,
     /* 193084 */   // Label 3826: @193084
     /* 193084 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(193121), // Rule ID 11607 //
     /* 193089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 193097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193110 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1787:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
     /* 193113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193119 */     GIR_RootConstrainSelectedInstOperands,
     /* 193120 */     // GIR_Coverage, 11607,
     /* 193120 */     GIR_EraseRootFromParent_Done,
     /* 193121 */   // Label 3827: @193121
     /* 193121 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(193158), // Rule ID 11608 //
     /* 193126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 193134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193147 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1789:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
     /* 193150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193156 */     GIR_RootConstrainSelectedInstOperands,
     /* 193157 */     // GIR_Coverage, 11608,
     /* 193157 */     GIR_EraseRootFromParent_Done,
     /* 193158 */   // Label 3828: @193158
     /* 193158 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(193195), // Rule ID 11609 //
     /* 193163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 193171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193184 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1789:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
     /* 193187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193193 */     GIR_RootConstrainSelectedInstOperands,
     /* 193194 */     // GIR_Coverage, 11609,
     /* 193194 */     GIR_EraseRootFromParent_Done,
     /* 193195 */   // Label 3829: @193195
     /* 193195 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(193232), // Rule ID 11610 //
     /* 193200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 193208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193221 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1789:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
     /* 193224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193230 */     GIR_RootConstrainSelectedInstOperands,
     /* 193231 */     // GIR_Coverage, 11610,
     /* 193231 */     GIR_EraseRootFromParent_Done,
     /* 193232 */   // Label 3830: @193232
     /* 193232 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(193269), // Rule ID 11611 //
     /* 193237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 193245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193258 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1740:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
     /* 193261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193267 */     GIR_RootConstrainSelectedInstOperands,
     /* 193268 */     // GIR_Coverage, 11611,
     /* 193268 */     GIR_EraseRootFromParent_Done,
     /* 193269 */   // Label 3831: @193269
     /* 193269 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(193306), // Rule ID 11612 //
     /* 193274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 193282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193295 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1740:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
     /* 193298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193304 */     GIR_RootConstrainSelectedInstOperands,
     /* 193305 */     // GIR_Coverage, 11612,
     /* 193305 */     GIR_EraseRootFromParent_Done,
     /* 193306 */   // Label 3832: @193306
     /* 193306 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(193343), // Rule ID 11613 //
     /* 193311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 193319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1740:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
     /* 193335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193341 */     GIR_RootConstrainSelectedInstOperands,
     /* 193342 */     // GIR_Coverage, 11613,
     /* 193342 */     GIR_EraseRootFromParent_Done,
     /* 193343 */   // Label 3833: @193343
     /* 193343 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(193380), // Rule ID 11614 //
     /* 193348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 193356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193369 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1742:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
     /* 193372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193378 */     GIR_RootConstrainSelectedInstOperands,
     /* 193379 */     // GIR_Coverage, 11614,
     /* 193379 */     GIR_EraseRootFromParent_Done,
     /* 193380 */   // Label 3834: @193380
     /* 193380 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(193417), // Rule ID 11615 //
     /* 193385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 193393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193406 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1742:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
     /* 193409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193415 */     GIR_RootConstrainSelectedInstOperands,
     /* 193416 */     // GIR_Coverage, 11615,
     /* 193416 */     GIR_EraseRootFromParent_Done,
     /* 193417 */   // Label 3835: @193417
     /* 193417 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(193454), // Rule ID 11616 //
     /* 193422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 193430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193443 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1742:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
     /* 193446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193452 */     GIR_RootConstrainSelectedInstOperands,
     /* 193453 */     // GIR_Coverage, 11616,
     /* 193453 */     GIR_EraseRootFromParent_Done,
     /* 193454 */   // Label 3836: @193454
     /* 193454 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(193491), // Rule ID 11617 //
     /* 193459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 193467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193480 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1978:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
     /* 193483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193489 */     GIR_RootConstrainSelectedInstOperands,
     /* 193490 */     // GIR_Coverage, 11617,
     /* 193490 */     GIR_EraseRootFromParent_Done,
     /* 193491 */   // Label 3837: @193491
     /* 193491 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(193528), // Rule ID 11618 //
     /* 193496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 193504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193517 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1978:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
     /* 193520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193526 */     GIR_RootConstrainSelectedInstOperands,
     /* 193527 */     // GIR_Coverage, 11618,
     /* 193527 */     GIR_EraseRootFromParent_Done,
     /* 193528 */   // Label 3838: @193528
     /* 193528 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(193565), // Rule ID 11619 //
     /* 193533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 193541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193554 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1978:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
     /* 193557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193563 */     GIR_RootConstrainSelectedInstOperands,
     /* 193564 */     // GIR_Coverage, 11619,
     /* 193564 */     GIR_EraseRootFromParent_Done,
     /* 193565 */   // Label 3839: @193565
     /* 193565 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(193602), // Rule ID 11620 //
     /* 193570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 193578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193591 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1980:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
     /* 193594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193600 */     GIR_RootConstrainSelectedInstOperands,
     /* 193601 */     // GIR_Coverage, 11620,
     /* 193601 */     GIR_EraseRootFromParent_Done,
     /* 193602 */   // Label 3840: @193602
     /* 193602 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(193639), // Rule ID 11621 //
     /* 193607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 193615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193628 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1980:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
     /* 193631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193637 */     GIR_RootConstrainSelectedInstOperands,
     /* 193638 */     // GIR_Coverage, 11621,
     /* 193638 */     GIR_EraseRootFromParent_Done,
     /* 193639 */   // Label 3841: @193639
     /* 193639 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(193676), // Rule ID 11622 //
     /* 193644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 193652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 193655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193665 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1980:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
     /* 193668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193674 */     GIR_RootConstrainSelectedInstOperands,
     /* 193675 */     // GIR_Coverage, 11622,
     /* 193675 */     GIR_EraseRootFromParent_Done,
     /* 193676 */   // Label 3842: @193676
     /* 193676 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(193713), // Rule ID 11623 //
     /* 193681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 193689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 193695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 193698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193702 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1618:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 193702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
     /* 193705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193711 */     GIR_RootConstrainSelectedInstOperands,
     /* 193712 */     // GIR_Coverage, 11623,
     /* 193712 */     GIR_EraseRootFromParent_Done,
     /* 193713 */   // Label 3843: @193713
     /* 193713 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(193750), // Rule ID 11624 //
     /* 193718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 193726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193739 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1618:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
     /* 193742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193748 */     GIR_RootConstrainSelectedInstOperands,
     /* 193749 */     // GIR_Coverage, 11624,
     /* 193749 */     GIR_EraseRootFromParent_Done,
     /* 193750 */   // Label 3844: @193750
     /* 193750 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(193787), // Rule ID 11725 //
     /* 193755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 193763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193776 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1648:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
     /* 193779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193785 */     GIR_RootConstrainSelectedInstOperands,
     /* 193786 */     // GIR_Coverage, 11725,
     /* 193786 */     GIR_EraseRootFromParent_Done,
     /* 193787 */   // Label 3845: @193787
     /* 193787 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(193824), // Rule ID 11726 //
     /* 193792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 193800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193813 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1648:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
     /* 193816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193822 */     GIR_RootConstrainSelectedInstOperands,
     /* 193823 */     // GIR_Coverage, 11726,
     /* 193823 */     GIR_EraseRootFromParent_Done,
     /* 193824 */   // Label 3846: @193824
     /* 193824 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(193861), // Rule ID 11727 //
     /* 193829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 193837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193850 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1648:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
     /* 193853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193859 */     GIR_RootConstrainSelectedInstOperands,
     /* 193860 */     // GIR_Coverage, 11727,
     /* 193860 */     GIR_EraseRootFromParent_Done,
     /* 193861 */   // Label 3847: @193861
     /* 193861 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(193898), // Rule ID 11728 //
     /* 193866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 193874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193887 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1889:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
     /* 193890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193896 */     GIR_RootConstrainSelectedInstOperands,
     /* 193897 */     // GIR_Coverage, 11728,
     /* 193897 */     GIR_EraseRootFromParent_Done,
     /* 193898 */   // Label 3848: @193898
     /* 193898 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(193935), // Rule ID 11729 //
     /* 193903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 193911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 193914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 193917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 193920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193924 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1889:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 193924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
     /* 193927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193933 */     GIR_RootConstrainSelectedInstOperands,
     /* 193934 */     // GIR_Coverage, 11729,
     /* 193934 */     GIR_EraseRootFromParent_Done,
     /* 193935 */   // Label 3849: @193935
     /* 193935 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(193972), // Rule ID 11730 //
     /* 193940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 193948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 193951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 193954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 193957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193961 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1889:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 193961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
     /* 193964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 193966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 193968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 193970 */     GIR_RootConstrainSelectedInstOperands,
     /* 193971 */     // GIR_Coverage, 11730,
     /* 193971 */     GIR_EraseRootFromParent_Done,
     /* 193972 */   // Label 3850: @193972
     /* 193972 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(194009), // Rule ID 11731 //
     /* 193977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 193980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 193985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 193988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 193991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 193994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 193998 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1664:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 193998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
     /* 194001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194007 */     GIR_RootConstrainSelectedInstOperands,
     /* 194008 */     // GIR_Coverage, 11731,
     /* 194008 */     GIR_EraseRootFromParent_Done,
     /* 194009 */   // Label 3851: @194009
     /* 194009 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(194046), // Rule ID 11732 //
     /* 194014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 194022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194035 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1664:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
     /* 194038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194044 */     GIR_RootConstrainSelectedInstOperands,
     /* 194045 */     // GIR_Coverage, 11732,
     /* 194045 */     GIR_EraseRootFromParent_Done,
     /* 194046 */   // Label 3852: @194046
     /* 194046 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(194083), // Rule ID 11733 //
     /* 194051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 194059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 194065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 194068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194072 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1664:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 194072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
     /* 194075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194081 */     GIR_RootConstrainSelectedInstOperands,
     /* 194082 */     // GIR_Coverage, 11733,
     /* 194082 */     GIR_EraseRootFromParent_Done,
     /* 194083 */   // Label 3853: @194083
     /* 194083 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(194120), // Rule ID 11749 //
     /* 194088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 194096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 194099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194109 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2031:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
     /* 194112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194118 */     GIR_RootConstrainSelectedInstOperands,
     /* 194119 */     // GIR_Coverage, 11749,
     /* 194119 */     GIR_EraseRootFromParent_Done,
     /* 194120 */   // Label 3854: @194120
     /* 194120 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(194157), // Rule ID 11750 //
     /* 194125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 194133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194146 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2031:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
     /* 194149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194155 */     GIR_RootConstrainSelectedInstOperands,
     /* 194156 */     // GIR_Coverage, 11750,
     /* 194156 */     GIR_EraseRootFromParent_Done,
     /* 194157 */   // Label 3855: @194157
     /* 194157 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(194194), // Rule ID 11751 //
     /* 194162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 194170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 194179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194183 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2031:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 194183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
     /* 194186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194192 */     GIR_RootConstrainSelectedInstOperands,
     /* 194193 */     // GIR_Coverage, 11751,
     /* 194193 */     GIR_EraseRootFromParent_Done,
     /* 194194 */   // Label 3856: @194194
     /* 194194 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(194231), // Rule ID 11752 //
     /* 194199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 194207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 194210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194220 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1840:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
     /* 194223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194229 */     GIR_RootConstrainSelectedInstOperands,
     /* 194230 */     // GIR_Coverage, 11752,
     /* 194230 */     GIR_EraseRootFromParent_Done,
     /* 194231 */   // Label 3857: @194231
     /* 194231 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(194268), // Rule ID 11753 //
     /* 194236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 194244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194257 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1840:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
     /* 194260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194266 */     GIR_RootConstrainSelectedInstOperands,
     /* 194267 */     // GIR_Coverage, 11753,
     /* 194267 */     GIR_EraseRootFromParent_Done,
     /* 194268 */   // Label 3858: @194268
     /* 194268 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(194305), // Rule ID 11754 //
     /* 194273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 194281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 194290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194294 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1840:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 194294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
     /* 194297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194303 */     GIR_RootConstrainSelectedInstOperands,
     /* 194304 */     // GIR_Coverage, 11754,
     /* 194304 */     GIR_EraseRootFromParent_Done,
     /* 194305 */   // Label 3859: @194305
     /* 194305 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(194342), // Rule ID 11770 //
     /* 194310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 194318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194331 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1854:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
     /* 194334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194340 */     GIR_RootConstrainSelectedInstOperands,
     /* 194341 */     // GIR_Coverage, 11770,
     /* 194341 */     GIR_EraseRootFromParent_Done,
     /* 194342 */   // Label 3860: @194342
     /* 194342 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(194379), // Rule ID 11771 //
     /* 194347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 194355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194368 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1854:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
     /* 194371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194375 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194377 */     GIR_RootConstrainSelectedInstOperands,
     /* 194378 */     // GIR_Coverage, 11771,
     /* 194378 */     GIR_EraseRootFromParent_Done,
     /* 194379 */   // Label 3861: @194379
     /* 194379 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(194416), // Rule ID 11772 //
     /* 194384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 194392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194405 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1854:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
     /* 194408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194414 */     GIR_RootConstrainSelectedInstOperands,
     /* 194415 */     // GIR_Coverage, 11772,
     /* 194415 */     GIR_EraseRootFromParent_Done,
     /* 194416 */   // Label 3862: @194416
     /* 194416 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(194453), // Rule ID 11773 //
     /* 194421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 194429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 194432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 194435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 194438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194442 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1856:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 194442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
     /* 194445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194451 */     GIR_RootConstrainSelectedInstOperands,
     /* 194452 */     // GIR_Coverage, 11773,
     /* 194452 */     GIR_EraseRootFromParent_Done,
     /* 194453 */   // Label 3863: @194453
     /* 194453 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(194490), // Rule ID 11774 //
     /* 194458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 194466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 194469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 194472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 194475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194479 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1856:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 194479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
     /* 194482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194488 */     GIR_RootConstrainSelectedInstOperands,
     /* 194489 */     // GIR_Coverage, 11774,
     /* 194489 */     GIR_EraseRootFromParent_Done,
     /* 194490 */   // Label 3864: @194490
     /* 194490 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(194527), // Rule ID 11775 //
     /* 194495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 194503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 194506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 194509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 194512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 194516 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1856:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 194516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
     /* 194519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 194521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194525 */     GIR_RootConstrainSelectedInstOperands,
     /* 194526 */     // GIR_Coverage, 11775,
     /* 194526 */     GIR_EraseRootFromParent_Done,
     /* 194527 */   // Label 3865: @194527
     /* 194527 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(194567), // Rule ID 11850 //
     /* 194532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194553 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2076:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
     /* 194556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194565 */     GIR_RootConstrainSelectedInstOperands,
     /* 194566 */     // GIR_Coverage, 11850,
     /* 194566 */     GIR_EraseRootFromParent_Done,
     /* 194567 */   // Label 3866: @194567
     /* 194567 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(194607), // Rule ID 11851 //
     /* 194572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194593 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2076:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
     /* 194596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194605 */     GIR_RootConstrainSelectedInstOperands,
     /* 194606 */     // GIR_Coverage, 11851,
     /* 194606 */     GIR_EraseRootFromParent_Done,
     /* 194607 */   // Label 3867: @194607
     /* 194607 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(194647), // Rule ID 11852 //
     /* 194612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194633 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2076:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
     /* 194636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194645 */     GIR_RootConstrainSelectedInstOperands,
     /* 194646 */     // GIR_Coverage, 11852,
     /* 194646 */     GIR_EraseRootFromParent_Done,
     /* 194647 */   // Label 3868: @194647
     /* 194647 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(194687), // Rule ID 11853 //
     /* 194652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 194660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194673 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2076:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
     /* 194676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194685 */     GIR_RootConstrainSelectedInstOperands,
     /* 194686 */     // GIR_Coverage, 11853,
     /* 194686 */     GIR_EraseRootFromParent_Done,
     /* 194687 */   // Label 3869: @194687
     /* 194687 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(194727), // Rule ID 11854 //
     /* 194692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194713 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2082:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
     /* 194716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194725 */     GIR_RootConstrainSelectedInstOperands,
     /* 194726 */     // GIR_Coverage, 11854,
     /* 194726 */     GIR_EraseRootFromParent_Done,
     /* 194727 */   // Label 3870: @194727
     /* 194727 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(194767), // Rule ID 11855 //
     /* 194732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194753 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2082:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
     /* 194756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194765 */     GIR_RootConstrainSelectedInstOperands,
     /* 194766 */     // GIR_Coverage, 11855,
     /* 194766 */     GIR_EraseRootFromParent_Done,
     /* 194767 */   // Label 3871: @194767
     /* 194767 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(194807), // Rule ID 11856 //
     /* 194772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194793 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2082:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
     /* 194796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194805 */     GIR_RootConstrainSelectedInstOperands,
     /* 194806 */     // GIR_Coverage, 11856,
     /* 194806 */     GIR_EraseRootFromParent_Done,
     /* 194807 */   // Label 3872: @194807
     /* 194807 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(194847), // Rule ID 11857 //
     /* 194812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 194820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194833 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2082:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
     /* 194836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194842 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194845 */     GIR_RootConstrainSelectedInstOperands,
     /* 194846 */     // GIR_Coverage, 11857,
     /* 194846 */     GIR_EraseRootFromParent_Done,
     /* 194847 */   // Label 3873: @194847
     /* 194847 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(194887), // Rule ID 11862 //
     /* 194852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 194863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194873 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
     /* 194876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194882 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194885 */     GIR_RootConstrainSelectedInstOperands,
     /* 194886 */     // GIR_Coverage, 11862,
     /* 194886 */     GIR_EraseRootFromParent_Done,
     /* 194887 */   // Label 3874: @194887
     /* 194887 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(194927), // Rule ID 11863 //
     /* 194892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 194903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194913 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
     /* 194916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194922 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194925 */     GIR_RootConstrainSelectedInstOperands,
     /* 194926 */     // GIR_Coverage, 11863,
     /* 194926 */     GIR_EraseRootFromParent_Done,
     /* 194927 */   // Label 3875: @194927
     /* 194927 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(194967), // Rule ID 11864 //
     /* 194932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 194943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194953 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
     /* 194956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 194960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 194962 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 194965 */     GIR_RootConstrainSelectedInstOperands,
     /* 194966 */     // GIR_Coverage, 11864,
     /* 194966 */     GIR_EraseRootFromParent_Done,
     /* 194967 */   // Label 3876: @194967
     /* 194967 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(195007), // Rule ID 11865 //
     /* 194972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 194975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 194980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 194983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 194993 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2094:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 194993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
     /* 194996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 194998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195002 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195005 */     GIR_RootConstrainSelectedInstOperands,
     /* 195006 */     // GIR_Coverage, 11865,
     /* 195006 */     GIR_EraseRootFromParent_Done,
     /* 195007 */   // Label 3877: @195007
     /* 195007 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(195047), // Rule ID 11866 //
     /* 195012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 195023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195033 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2088:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 195033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
     /* 195036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195042 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195045 */     GIR_RootConstrainSelectedInstOperands,
     /* 195046 */     // GIR_Coverage, 11866,
     /* 195046 */     GIR_EraseRootFromParent_Done,
     /* 195047 */   // Label 3878: @195047
     /* 195047 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(195087), // Rule ID 11867 //
     /* 195052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 195063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195073 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2088:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 195073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
     /* 195076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195082 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195085 */     GIR_RootConstrainSelectedInstOperands,
     /* 195086 */     // GIR_Coverage, 11867,
     /* 195086 */     GIR_EraseRootFromParent_Done,
     /* 195087 */   // Label 3879: @195087
     /* 195087 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(195127), // Rule ID 11868 //
     /* 195092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195095 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195100 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 195103 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195106 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195113 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2088:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 195113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
     /* 195116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195125 */     GIR_RootConstrainSelectedInstOperands,
     /* 195126 */     // GIR_Coverage, 11868,
     /* 195126 */     GIR_EraseRootFromParent_Done,
     /* 195127 */   // Label 3880: @195127
     /* 195127 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(195167), // Rule ID 11869 //
     /* 195132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 195143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195153 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2088:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 195153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
     /* 195156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195165 */     GIR_RootConstrainSelectedInstOperands,
     /* 195166 */     // GIR_Coverage, 11869,
     /* 195166 */     GIR_EraseRootFromParent_Done,
     /* 195167 */   // Label 3881: @195167
     /* 195167 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(195207), // Rule ID 11874 //
     /* 195172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 195180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 195183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195193 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2076:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
     /* 195196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195202 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195205 */     GIR_RootConstrainSelectedInstOperands,
     /* 195206 */     // GIR_Coverage, 11874,
     /* 195206 */     GIR_EraseRootFromParent_Done,
     /* 195207 */   // Label 3882: @195207
     /* 195207 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(195247), // Rule ID 11875 //
     /* 195212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 195220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 195223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195233 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2076:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
     /* 195236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195242 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195245 */     GIR_RootConstrainSelectedInstOperands,
     /* 195246 */     // GIR_Coverage, 11875,
     /* 195246 */     GIR_EraseRootFromParent_Done,
     /* 195247 */   // Label 3883: @195247
     /* 195247 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(195287), // Rule ID 11876 //
     /* 195252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 195260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 195263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195273 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2076:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
     /* 195276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195282 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195285 */     GIR_RootConstrainSelectedInstOperands,
     /* 195286 */     // GIR_Coverage, 11876,
     /* 195286 */     GIR_EraseRootFromParent_Done,
     /* 195287 */   // Label 3884: @195287
     /* 195287 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(195327), // Rule ID 11877 //
     /* 195292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 195300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 195303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195313 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2076:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
     /* 195316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195322 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195325 */     GIR_RootConstrainSelectedInstOperands,
     /* 195326 */     // GIR_Coverage, 11877,
     /* 195326 */     GIR_EraseRootFromParent_Done,
     /* 195327 */   // Label 3885: @195327
     /* 195327 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(195367), // Rule ID 11878 //
     /* 195332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 195340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 195343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195353 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2082:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
     /* 195356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195362 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195365 */     GIR_RootConstrainSelectedInstOperands,
     /* 195366 */     // GIR_Coverage, 11878,
     /* 195366 */     GIR_EraseRootFromParent_Done,
     /* 195367 */   // Label 3886: @195367
     /* 195367 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(195407), // Rule ID 11879 //
     /* 195372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 195380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 195383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195393 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2082:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
     /* 195396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195402 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195405 */     GIR_RootConstrainSelectedInstOperands,
     /* 195406 */     // GIR_Coverage, 11879,
     /* 195406 */     GIR_EraseRootFromParent_Done,
     /* 195407 */   // Label 3887: @195407
     /* 195407 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(195447), // Rule ID 11880 //
     /* 195412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 195420 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 195423 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195426 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195433 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2082:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
     /* 195436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195442 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195445 */     GIR_RootConstrainSelectedInstOperands,
     /* 195446 */     // GIR_Coverage, 11880,
     /* 195446 */     GIR_EraseRootFromParent_Done,
     /* 195447 */   // Label 3888: @195447
     /* 195447 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(195487), // Rule ID 11881 //
     /* 195452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 195460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 195463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195473 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2082:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
     /* 195476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195482 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195485 */     GIR_RootConstrainSelectedInstOperands,
     /* 195486 */     // GIR_Coverage, 11881,
     /* 195486 */     GIR_EraseRootFromParent_Done,
     /* 195487 */   // Label 3889: @195487
     /* 195487 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(195527), // Rule ID 11886 //
     /* 195492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 195503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195513 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2094:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
     /* 195516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195522 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195525 */     GIR_RootConstrainSelectedInstOperands,
     /* 195526 */     // GIR_Coverage, 11886,
     /* 195526 */     GIR_EraseRootFromParent_Done,
     /* 195527 */   // Label 3890: @195527
     /* 195527 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(195567), // Rule ID 11887 //
     /* 195532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 195543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195553 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2094:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
     /* 195556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195562 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195565 */     GIR_RootConstrainSelectedInstOperands,
     /* 195566 */     // GIR_Coverage, 11887,
     /* 195566 */     GIR_EraseRootFromParent_Done,
     /* 195567 */   // Label 3891: @195567
     /* 195567 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(195607), // Rule ID 11888 //
     /* 195572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 195583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195593 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2094:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
     /* 195596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195602 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195605 */     GIR_RootConstrainSelectedInstOperands,
     /* 195606 */     // GIR_Coverage, 11888,
     /* 195606 */     GIR_EraseRootFromParent_Done,
     /* 195607 */   // Label 3892: @195607
     /* 195607 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(195647), // Rule ID 11889 //
     /* 195612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 195620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 195623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195633 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2094:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
     /* 195636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195642 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195645 */     GIR_RootConstrainSelectedInstOperands,
     /* 195646 */     // GIR_Coverage, 11889,
     /* 195646 */     GIR_EraseRootFromParent_Done,
     /* 195647 */   // Label 3893: @195647
     /* 195647 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(195687), // Rule ID 11890 //
     /* 195652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 195663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195673 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2088:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
     /* 195676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195682 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195685 */     GIR_RootConstrainSelectedInstOperands,
     /* 195686 */     // GIR_Coverage, 11890,
     /* 195686 */     GIR_EraseRootFromParent_Done,
     /* 195687 */   // Label 3894: @195687
     /* 195687 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(195727), // Rule ID 11891 //
     /* 195692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 195703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195713 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2088:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
     /* 195716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195722 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195725 */     GIR_RootConstrainSelectedInstOperands,
     /* 195726 */     // GIR_Coverage, 11891,
     /* 195726 */     GIR_EraseRootFromParent_Done,
     /* 195727 */   // Label 3895: @195727
     /* 195727 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(195767), // Rule ID 11892 //
     /* 195732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 195743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195753 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2088:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
     /* 195756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195762 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195765 */     GIR_RootConstrainSelectedInstOperands,
     /* 195766 */     // GIR_Coverage, 11892,
     /* 195766 */     GIR_EraseRootFromParent_Done,
     /* 195767 */   // Label 3896: @195767
     /* 195767 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(195807), // Rule ID 11893 //
     /* 195772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 195775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 195780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 195783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 195793 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2088:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 195793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
     /* 195796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 195798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195802 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 195805 */     GIR_RootConstrainSelectedInstOperands,
     /* 195806 */     // GIR_Coverage, 11893,
     /* 195806 */     GIR_EraseRootFromParent_Done,
     /* 195807 */   // Label 3897: @195807
     /* 195807 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(195844), // Rule ID 11902 //
     /* 195812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 195815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
     /* 195820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195833 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1244:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
     /* 195836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195842 */     GIR_RootConstrainSelectedInstOperands,
     /* 195843 */     // GIR_Coverage, 11902,
     /* 195843 */     GIR_EraseRootFromParent_Done,
     /* 195844 */   // Label 3898: @195844
     /* 195844 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(195881), // Rule ID 11904 //
     /* 195849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 195852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 195857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195870 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1618:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
     /* 195873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195879 */     GIR_RootConstrainSelectedInstOperands,
     /* 195880 */     // GIR_Coverage, 11904,
     /* 195880 */     GIR_EraseRootFromParent_Done,
     /* 195881 */   // Label 3899: @195881
     /* 195881 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(195918), // Rule ID 11905 //
     /* 195886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 195889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
     /* 195894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 195897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 195900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 195903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195907 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1709:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 195907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
     /* 195910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 195912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195916 */     GIR_RootConstrainSelectedInstOperands,
     /* 195917 */     // GIR_Coverage, 11905,
     /* 195917 */     GIR_EraseRootFromParent_Done,
     /* 195918 */   // Label 3900: @195918
     /* 195918 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(195955), // Rule ID 11906 //
     /* 195923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SHA3),
     /* 195926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
     /* 195931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 195934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 195937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 195940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195944 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1650:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 195944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
     /* 195947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195953 */     GIR_RootConstrainSelectedInstOperands,
     /* 195954 */     // GIR_Coverage, 11906,
     /* 195954 */     GIR_EraseRootFromParent_Done,
     /* 195955 */   // Label 3901: @195955
     /* 195955 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(195992), // Rule ID 11907 //
     /* 195960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 195963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 195968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 195971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 195974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 195977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 195981 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1258:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 195981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
     /* 195984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 195986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 195988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 195990 */     GIR_RootConstrainSelectedInstOperands,
     /* 195991 */     // GIR_Coverage, 11907,
     /* 195991 */     GIR_EraseRootFromParent_Done,
     /* 195992 */   // Label 3902: @195992
     /* 195992 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(196029), // Rule ID 11908 //
     /* 195997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 196000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 196005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 196008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 196011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196018 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1258:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
     /* 196021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196027 */     GIR_RootConstrainSelectedInstOperands,
     /* 196028 */     // GIR_Coverage, 11908,
     /* 196028 */     GIR_EraseRootFromParent_Done,
     /* 196029 */   // Label 3903: @196029
     /* 196029 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(196066), // Rule ID 11909 //
     /* 196034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 196037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 196042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196055 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1258:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
     /* 196058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196064 */     GIR_RootConstrainSelectedInstOperands,
     /* 196065 */     // GIR_Coverage, 11909,
     /* 196065 */     GIR_EraseRootFromParent_Done,
     /* 196066 */   // Label 3904: @196066
     /* 196066 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(196103), // Rule ID 11910 //
     /* 196071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 196074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 196079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 196085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196092 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1258:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
     /* 196095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196101 */     GIR_RootConstrainSelectedInstOperands,
     /* 196102 */     // GIR_Coverage, 11910,
     /* 196102 */     GIR_EraseRootFromParent_Done,
     /* 196103 */   // Label 3905: @196103
     /* 196103 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(196140), // Rule ID 11911 //
     /* 196108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 196111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 196116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 196119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 196122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196129 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1275:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
     /* 196132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196138 */     GIR_RootConstrainSelectedInstOperands,
     /* 196139 */     // GIR_Coverage, 11911,
     /* 196139 */     GIR_EraseRootFromParent_Done,
     /* 196140 */   // Label 3906: @196140
     /* 196140 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(196177), // Rule ID 11912 //
     /* 196145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 196148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 196153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 196156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 196159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196166 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1275:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
     /* 196169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196175 */     GIR_RootConstrainSelectedInstOperands,
     /* 196176 */     // GIR_Coverage, 11912,
     /* 196176 */     GIR_EraseRootFromParent_Done,
     /* 196177 */   // Label 3907: @196177
     /* 196177 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(196214), // Rule ID 11913 //
     /* 196182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 196185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 196190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 196193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 196196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196203 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1275:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
     /* 196206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196212 */     GIR_RootConstrainSelectedInstOperands,
     /* 196213 */     // GIR_Coverage, 11913,
     /* 196213 */     GIR_EraseRootFromParent_Done,
     /* 196214 */   // Label 3908: @196214
     /* 196214 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(196251), // Rule ID 11914 //
     /* 196219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 196222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 196227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 196230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 196233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 196240 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1275:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
     /* 196243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 196245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196249 */     GIR_RootConstrainSelectedInstOperands,
     /* 196250 */     // GIR_Coverage, 11914,
     /* 196250 */     GIR_EraseRootFromParent_Done,
     /* 196251 */   // Label 3909: @196251
     /* 196251 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(196288), // Rule ID 12027 //
     /* 196256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 196264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196277 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1424:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 196277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
     /* 196280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196286 */     GIR_RootConstrainSelectedInstOperands,
     /* 196287 */     // GIR_Coverage, 12027,
     /* 196287 */     GIR_EraseRootFromParent_Done,
     /* 196288 */   // Label 3910: @196288
     /* 196288 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(196325), // Rule ID 12028 //
     /* 196293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 196301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196314 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1424:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 196314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
     /* 196317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196323 */     GIR_RootConstrainSelectedInstOperands,
     /* 196324 */     // GIR_Coverage, 12028,
     /* 196324 */     GIR_EraseRootFromParent_Done,
     /* 196325 */   // Label 3911: @196325
     /* 196325 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(196362), // Rule ID 12029 //
     /* 196330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 196338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196351 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1424:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 196351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
     /* 196354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196360 */     GIR_RootConstrainSelectedInstOperands,
     /* 196361 */     // GIR_Coverage, 12029,
     /* 196361 */     GIR_EraseRootFromParent_Done,
     /* 196362 */   // Label 3912: @196362
     /* 196362 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(196399), // Rule ID 12030 //
     /* 196367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 196375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196388 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1442:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 196388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
     /* 196391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196397 */     GIR_RootConstrainSelectedInstOperands,
     /* 196398 */     // GIR_Coverage, 12030,
     /* 196398 */     GIR_EraseRootFromParent_Done,
     /* 196399 */   // Label 3913: @196399
     /* 196399 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(196436), // Rule ID 12031 //
     /* 196404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 196412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196425 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1442:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 196425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
     /* 196428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196434 */     GIR_RootConstrainSelectedInstOperands,
     /* 196435 */     // GIR_Coverage, 12031,
     /* 196435 */     GIR_EraseRootFromParent_Done,
     /* 196436 */   // Label 3914: @196436
     /* 196436 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(196473), // Rule ID 12032 //
     /* 196441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 196449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196462 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1442:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 196462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
     /* 196465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196471 */     GIR_RootConstrainSelectedInstOperands,
     /* 196472 */     // GIR_Coverage, 12032,
     /* 196472 */     GIR_EraseRootFromParent_Done,
     /* 196473 */   // Label 3915: @196473
     /* 196473 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(196510), // Rule ID 12033 //
     /* 196478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 196486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196499 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1427:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 196499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
     /* 196502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196508 */     GIR_RootConstrainSelectedInstOperands,
     /* 196509 */     // GIR_Coverage, 12033,
     /* 196509 */     GIR_EraseRootFromParent_Done,
     /* 196510 */   // Label 3916: @196510
     /* 196510 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(196547), // Rule ID 12034 //
     /* 196515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 196523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196536 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1427:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 196536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
     /* 196539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196545 */     GIR_RootConstrainSelectedInstOperands,
     /* 196546 */     // GIR_Coverage, 12034,
     /* 196546 */     GIR_EraseRootFromParent_Done,
     /* 196547 */   // Label 3917: @196547
     /* 196547 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(196584), // Rule ID 12035 //
     /* 196552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 196560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196573 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1427:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 196573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
     /* 196576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196582 */     GIR_RootConstrainSelectedInstOperands,
     /* 196583 */     // GIR_Coverage, 12035,
     /* 196583 */     GIR_EraseRootFromParent_Done,
     /* 196584 */   // Label 3918: @196584
     /* 196584 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(196621), // Rule ID 12036 //
     /* 196589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 196597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196610 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1445:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 196610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
     /* 196613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196619 */     GIR_RootConstrainSelectedInstOperands,
     /* 196620 */     // GIR_Coverage, 12036,
     /* 196620 */     GIR_EraseRootFromParent_Done,
     /* 196621 */   // Label 3919: @196621
     /* 196621 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(196658), // Rule ID 12037 //
     /* 196626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 196634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196647 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1445:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 196647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
     /* 196650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196656 */     GIR_RootConstrainSelectedInstOperands,
     /* 196657 */     // GIR_Coverage, 12037,
     /* 196657 */     GIR_EraseRootFromParent_Done,
     /* 196658 */   // Label 3920: @196658
     /* 196658 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(196695), // Rule ID 12038 //
     /* 196663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 196671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196684 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1445:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 196684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
     /* 196687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196693 */     GIR_RootConstrainSelectedInstOperands,
     /* 196694 */     // GIR_Coverage, 12038,
     /* 196694 */     GIR_EraseRootFromParent_Done,
     /* 196695 */   // Label 3921: @196695
     /* 196695 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(196732), // Rule ID 12039 //
     /* 196700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 196708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196721 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1339:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
     /* 196724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196730 */     GIR_RootConstrainSelectedInstOperands,
     /* 196731 */     // GIR_Coverage, 12039,
     /* 196731 */     GIR_EraseRootFromParent_Done,
     /* 196732 */   // Label 3922: @196732
     /* 196732 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(196769), // Rule ID 12040 //
     /* 196737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 196745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196758 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1339:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
     /* 196761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196767 */     GIR_RootConstrainSelectedInstOperands,
     /* 196768 */     // GIR_Coverage, 12040,
     /* 196768 */     GIR_EraseRootFromParent_Done,
     /* 196769 */   // Label 3923: @196769
     /* 196769 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(196806), // Rule ID 12041 //
     /* 196774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 196782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196795 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1339:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
     /* 196798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196804 */     GIR_RootConstrainSelectedInstOperands,
     /* 196805 */     // GIR_Coverage, 12041,
     /* 196805 */     GIR_EraseRootFromParent_Done,
     /* 196806 */   // Label 3924: @196806
     /* 196806 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(196843), // Rule ID 12042 //
     /* 196811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 196819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196832 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1339:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
     /* 196835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196841 */     GIR_RootConstrainSelectedInstOperands,
     /* 196842 */     // GIR_Coverage, 12042,
     /* 196842 */     GIR_EraseRootFromParent_Done,
     /* 196843 */   // Label 3925: @196843
     /* 196843 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(196880), // Rule ID 12043 //
     /* 196848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 196856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 196862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 196865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196869 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1251:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 196869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
     /* 196872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196878 */     GIR_RootConstrainSelectedInstOperands,
     /* 196879 */     // GIR_Coverage, 12043,
     /* 196879 */     GIR_EraseRootFromParent_Done,
     /* 196880 */   // Label 3926: @196880
     /* 196880 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(196917), // Rule ID 12044 //
     /* 196885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 196893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 196896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 196899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 196902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196906 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1251:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 196906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
     /* 196909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196915 */     GIR_RootConstrainSelectedInstOperands,
     /* 196916 */     // GIR_Coverage, 12044,
     /* 196916 */     GIR_EraseRootFromParent_Done,
     /* 196917 */   // Label 3927: @196917
     /* 196917 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(196954), // Rule ID 12045 //
     /* 196922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 196930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 196936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 196939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196943 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1251:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 196943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
     /* 196946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196952 */     GIR_RootConstrainSelectedInstOperands,
     /* 196953 */     // GIR_Coverage, 12045,
     /* 196953 */     GIR_EraseRootFromParent_Done,
     /* 196954 */   // Label 3928: @196954
     /* 196954 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(196991), // Rule ID 12046 //
     /* 196959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 196967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 196973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 196976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196980 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1251:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 196980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
     /* 196983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 196985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 196987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 196989 */     GIR_RootConstrainSelectedInstOperands,
     /* 196990 */     // GIR_Coverage, 12046,
     /* 196990 */     GIR_EraseRootFromParent_Done,
     /* 196991 */   // Label 3929: @196991
     /* 196991 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(197028), // Rule ID 12047 //
     /* 196996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 196999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 197004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 197007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 197010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197017 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1239:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
     /* 197020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197026 */     GIR_RootConstrainSelectedInstOperands,
     /* 197027 */     // GIR_Coverage, 12047,
     /* 197027 */     GIR_EraseRootFromParent_Done,
     /* 197028 */   // Label 3930: @197028
     /* 197028 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(197065), // Rule ID 12048 //
     /* 197033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 197041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 197047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197054 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1239:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
     /* 197057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197063 */     GIR_RootConstrainSelectedInstOperands,
     /* 197064 */     // GIR_Coverage, 12048,
     /* 197064 */     GIR_EraseRootFromParent_Done,
     /* 197065 */   // Label 3931: @197065
     /* 197065 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(197102), // Rule ID 12049 //
     /* 197070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 197078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 197084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197091 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1239:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
     /* 197094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197100 */     GIR_RootConstrainSelectedInstOperands,
     /* 197101 */     // GIR_Coverage, 12049,
     /* 197101 */     GIR_EraseRootFromParent_Done,
     /* 197102 */   // Label 3932: @197102
     /* 197102 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(197139), // Rule ID 12050 //
     /* 197107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 197115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 197121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197128 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1239:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
     /* 197131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197137 */     GIR_RootConstrainSelectedInstOperands,
     /* 197138 */     // GIR_Coverage, 12050,
     /* 197138 */     GIR_EraseRootFromParent_Done,
     /* 197139 */   // Label 3933: @197139
     /* 197139 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(197176), // Rule ID 12051 //
     /* 197144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 197152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 197155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 197158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197165 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1718:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
     /* 197168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197174 */     GIR_RootConstrainSelectedInstOperands,
     /* 197175 */     // GIR_Coverage, 12051,
     /* 197175 */     GIR_EraseRootFromParent_Done,
     /* 197176 */   // Label 3934: @197176
     /* 197176 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(197213), // Rule ID 12052 //
     /* 197181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 197189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 197195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197202 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1718:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
     /* 197205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197211 */     GIR_RootConstrainSelectedInstOperands,
     /* 197212 */     // GIR_Coverage, 12052,
     /* 197212 */     GIR_EraseRootFromParent_Done,
     /* 197213 */   // Label 3935: @197213
     /* 197213 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(197250), // Rule ID 12053 //
     /* 197218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 197226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 197232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197239 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1718:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
     /* 197242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197248 */     GIR_RootConstrainSelectedInstOperands,
     /* 197249 */     // GIR_Coverage, 12053,
     /* 197249 */     GIR_EraseRootFromParent_Done,
     /* 197250 */   // Label 3936: @197250
     /* 197250 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(197287), // Rule ID 12054 //
     /* 197255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 197263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 197269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197276 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1718:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
     /* 197279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197285 */     GIR_RootConstrainSelectedInstOperands,
     /* 197286 */     // GIR_Coverage, 12054,
     /* 197286 */     GIR_EraseRootFromParent_Done,
     /* 197287 */   // Label 3937: @197287
     /* 197287 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(197324), // Rule ID 12055 //
     /* 197292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 197300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 197303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 197306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197313 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1956:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
     /* 197316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197322 */     GIR_RootConstrainSelectedInstOperands,
     /* 197323 */     // GIR_Coverage, 12055,
     /* 197323 */     GIR_EraseRootFromParent_Done,
     /* 197324 */   // Label 3938: @197324
     /* 197324 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(197361), // Rule ID 12056 //
     /* 197329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 197337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 197343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197350 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1956:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
     /* 197353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197359 */     GIR_RootConstrainSelectedInstOperands,
     /* 197360 */     // GIR_Coverage, 12056,
     /* 197360 */     GIR_EraseRootFromParent_Done,
     /* 197361 */   // Label 3939: @197361
     /* 197361 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(197398), // Rule ID 12057 //
     /* 197366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 197374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 197380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197387 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1956:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
     /* 197390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197396 */     GIR_RootConstrainSelectedInstOperands,
     /* 197397 */     // GIR_Coverage, 12057,
     /* 197397 */     GIR_EraseRootFromParent_Done,
     /* 197398 */   // Label 3940: @197398
     /* 197398 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(197435), // Rule ID 12058 //
     /* 197403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 197411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 197417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197424 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1956:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
     /* 197427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197433 */     GIR_RootConstrainSelectedInstOperands,
     /* 197434 */     // GIR_Coverage, 12058,
     /* 197434 */     GIR_EraseRootFromParent_Done,
     /* 197435 */   // Label 3941: @197435
     /* 197435 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(197472), // Rule ID 12059 //
     /* 197440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 197448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 197451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 197454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197461 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1727:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
     /* 197464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197470 */     GIR_RootConstrainSelectedInstOperands,
     /* 197471 */     // GIR_Coverage, 12059,
     /* 197471 */     GIR_EraseRootFromParent_Done,
     /* 197472 */   // Label 3942: @197472
     /* 197472 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(197509), // Rule ID 12060 //
     /* 197477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 197485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 197491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197498 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1727:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
     /* 197501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197507 */     GIR_RootConstrainSelectedInstOperands,
     /* 197508 */     // GIR_Coverage, 12060,
     /* 197508 */     GIR_EraseRootFromParent_Done,
     /* 197509 */   // Label 3943: @197509
     /* 197509 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(197546), // Rule ID 12061 //
     /* 197514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 197522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 197528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197535 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1727:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
     /* 197538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197544 */     GIR_RootConstrainSelectedInstOperands,
     /* 197545 */     // GIR_Coverage, 12061,
     /* 197545 */     GIR_EraseRootFromParent_Done,
     /* 197546 */   // Label 3944: @197546
     /* 197546 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(197583), // Rule ID 12062 //
     /* 197551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 197559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 197565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197572 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1727:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
     /* 197575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197581 */     GIR_RootConstrainSelectedInstOperands,
     /* 197582 */     // GIR_Coverage, 12062,
     /* 197582 */     GIR_EraseRootFromParent_Done,
     /* 197583 */   // Label 3945: @197583
     /* 197583 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(197620), // Rule ID 12063 //
     /* 197588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 197596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 197599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 197602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197609 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1965:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
     /* 197612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197618 */     GIR_RootConstrainSelectedInstOperands,
     /* 197619 */     // GIR_Coverage, 12063,
     /* 197619 */     GIR_EraseRootFromParent_Done,
     /* 197620 */   // Label 3946: @197620
     /* 197620 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(197657), // Rule ID 12064 //
     /* 197625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 197633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 197639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197646 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1965:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
     /* 197649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197655 */     GIR_RootConstrainSelectedInstOperands,
     /* 197656 */     // GIR_Coverage, 12064,
     /* 197656 */     GIR_EraseRootFromParent_Done,
     /* 197657 */   // Label 3947: @197657
     /* 197657 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(197694), // Rule ID 12065 //
     /* 197662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 197670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 197676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197683 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1965:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
     /* 197686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197692 */     GIR_RootConstrainSelectedInstOperands,
     /* 197693 */     // GIR_Coverage, 12065,
     /* 197693 */     GIR_EraseRootFromParent_Done,
     /* 197694 */   // Label 3948: @197694
     /* 197694 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(197731), // Rule ID 12066 //
     /* 197699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 197707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 197713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197720 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1965:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
     /* 197723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 197725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197729 */     GIR_RootConstrainSelectedInstOperands,
     /* 197730 */     // GIR_Coverage, 12066,
     /* 197730 */     GIR_EraseRootFromParent_Done,
     /* 197731 */   // Label 3949: @197731
     /* 197731 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(197768), // Rule ID 12067 //
     /* 197736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197757 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2149:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 197757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
     /* 197760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197766 */     GIR_RootConstrainSelectedInstOperands,
     /* 197767 */     // GIR_Coverage, 12067,
     /* 197767 */     GIR_EraseRootFromParent_Done,
     /* 197768 */   // Label 3950: @197768
     /* 197768 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(197805), // Rule ID 12068 //
     /* 197773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197794 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2149:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 197794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 197797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197803 */     GIR_RootConstrainSelectedInstOperands,
     /* 197804 */     // GIR_Coverage, 12068,
     /* 197804 */     GIR_EraseRootFromParent_Done,
     /* 197805 */   // Label 3951: @197805
     /* 197805 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(197842), // Rule ID 12069 //
     /* 197810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197831 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2149:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 197831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 197834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197840 */     GIR_RootConstrainSelectedInstOperands,
     /* 197841 */     // GIR_Coverage, 12069,
     /* 197841 */     GIR_EraseRootFromParent_Done,
     /* 197842 */   // Label 3952: @197842
     /* 197842 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(197879), // Rule ID 12070 //
     /* 197847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197868 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2149:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 197868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 197871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197877 */     GIR_RootConstrainSelectedInstOperands,
     /* 197878 */     // GIR_Coverage, 12070,
     /* 197878 */     GIR_EraseRootFromParent_Done,
     /* 197879 */   // Label 3953: @197879
     /* 197879 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(197916), // Rule ID 12071 //
     /* 197884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 197895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 197898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 197901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197905 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2149:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 197905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 197908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197914 */     GIR_RootConstrainSelectedInstOperands,
     /* 197915 */     // GIR_Coverage, 12071,
     /* 197915 */     GIR_EraseRootFromParent_Done,
     /* 197916 */   // Label 3954: @197916
     /* 197916 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(197953), // Rule ID 12072 //
     /* 197921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197942 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2149:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 197942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 197945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197951 */     GIR_RootConstrainSelectedInstOperands,
     /* 197952 */     // GIR_Coverage, 12072,
     /* 197952 */     GIR_EraseRootFromParent_Done,
     /* 197953 */   // Label 3955: @197953
     /* 197953 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(197990), // Rule ID 12073 //
     /* 197958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 197966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 197969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 197972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 197975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197979 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2149:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 197979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 197982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 197984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 197986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 197988 */     GIR_RootConstrainSelectedInstOperands,
     /* 197989 */     // GIR_Coverage, 12073,
     /* 197989 */     GIR_EraseRootFromParent_Done,
     /* 197990 */   // Label 3956: @197990
     /* 197990 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(198027), // Rule ID 12074 //
     /* 197995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 197998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 198003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 198006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 198009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 198012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198016 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2074:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 198016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
     /* 198019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198025 */     GIR_RootConstrainSelectedInstOperands,
     /* 198026 */     // GIR_Coverage, 12074,
     /* 198026 */     GIR_EraseRootFromParent_Done,
     /* 198027 */   // Label 3957: @198027
     /* 198027 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(198064), // Rule ID 12075 //
     /* 198032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 198040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 198046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198053 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2074:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 198053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 198056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198062 */     GIR_RootConstrainSelectedInstOperands,
     /* 198063 */     // GIR_Coverage, 12075,
     /* 198063 */     GIR_EraseRootFromParent_Done,
     /* 198064 */   // Label 3958: @198064
     /* 198064 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(198101), // Rule ID 12076 //
     /* 198069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198072 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 198077 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198080 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 198083 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198090 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2074:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 198090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 198093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198099 */     GIR_RootConstrainSelectedInstOperands,
     /* 198100 */     // GIR_Coverage, 12076,
     /* 198100 */     GIR_EraseRootFromParent_Done,
     /* 198101 */   // Label 3959: @198101
     /* 198101 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(198138), // Rule ID 12077 //
     /* 198106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 198114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 198120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198127 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2074:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 198127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 198130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198136 */     GIR_RootConstrainSelectedInstOperands,
     /* 198137 */     // GIR_Coverage, 12077,
     /* 198137 */     GIR_EraseRootFromParent_Done,
     /* 198138 */   // Label 3960: @198138
     /* 198138 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(198175), // Rule ID 12078 //
     /* 198143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 198151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 198157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198164 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2074:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 198164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 198167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198173 */     GIR_RootConstrainSelectedInstOperands,
     /* 198174 */     // GIR_Coverage, 12078,
     /* 198174 */     GIR_EraseRootFromParent_Done,
     /* 198175 */   // Label 3961: @198175
     /* 198175 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(198212), // Rule ID 12079 //
     /* 198180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 198188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 198194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198201 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2074:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 198201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 198204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198210 */     GIR_RootConstrainSelectedInstOperands,
     /* 198211 */     // GIR_Coverage, 12079,
     /* 198211 */     GIR_EraseRootFromParent_Done,
     /* 198212 */   // Label 3962: @198212
     /* 198212 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(198249), // Rule ID 12080 //
     /* 198217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 198225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 198231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198238 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2074:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 198238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 198241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198247 */     GIR_RootConstrainSelectedInstOperands,
     /* 198248 */     // GIR_Coverage, 12080,
     /* 198248 */     GIR_EraseRootFromParent_Done,
     /* 198249 */   // Label 3963: @198249
     /* 198249 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(198286), // Rule ID 12081 //
     /* 198254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 198262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 198265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 198268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 198271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198275 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2075:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 198275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
     /* 198278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198284 */     GIR_RootConstrainSelectedInstOperands,
     /* 198285 */     // GIR_Coverage, 12081,
     /* 198285 */     GIR_EraseRootFromParent_Done,
     /* 198286 */   // Label 3964: @198286
     /* 198286 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(198323), // Rule ID 12082 //
     /* 198291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 198299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 198305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198312 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2075:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 198312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 198315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198321 */     GIR_RootConstrainSelectedInstOperands,
     /* 198322 */     // GIR_Coverage, 12082,
     /* 198322 */     GIR_EraseRootFromParent_Done,
     /* 198323 */   // Label 3965: @198323
     /* 198323 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(198360), // Rule ID 12083 //
     /* 198328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 198336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 198342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198349 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2075:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 198349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 198352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198358 */     GIR_RootConstrainSelectedInstOperands,
     /* 198359 */     // GIR_Coverage, 12083,
     /* 198359 */     GIR_EraseRootFromParent_Done,
     /* 198360 */   // Label 3966: @198360
     /* 198360 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(198397), // Rule ID 12084 //
     /* 198365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 198373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 198379 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198386 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2075:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 198386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 198389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198395 */     GIR_RootConstrainSelectedInstOperands,
     /* 198396 */     // GIR_Coverage, 12084,
     /* 198396 */     GIR_EraseRootFromParent_Done,
     /* 198397 */   // Label 3967: @198397
     /* 198397 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(198434), // Rule ID 12085 //
     /* 198402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 198410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 198413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 198416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 198419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198423 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2075:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 198423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 198426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198430 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198432 */     GIR_RootConstrainSelectedInstOperands,
     /* 198433 */     // GIR_Coverage, 12085,
     /* 198433 */     GIR_EraseRootFromParent_Done,
     /* 198434 */   // Label 3968: @198434
     /* 198434 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(198471), // Rule ID 12086 //
     /* 198439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 198447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 198450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 198453 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 198456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198460 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2075:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 198460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 198463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198469 */     GIR_RootConstrainSelectedInstOperands,
     /* 198470 */     // GIR_Coverage, 12086,
     /* 198470 */     GIR_EraseRootFromParent_Done,
     /* 198471 */   // Label 3969: @198471
     /* 198471 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(198508), // Rule ID 12087 //
     /* 198476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 198479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 198484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 198487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 198490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 198493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 198497 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2075:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 198497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 198500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 198502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198506 */     GIR_RootConstrainSelectedInstOperands,
     /* 198507 */     // GIR_Coverage, 12087,
     /* 198507 */     GIR_EraseRootFromParent_Done,
     /* 198508 */   // Label 3970: @198508
     /* 198508 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(198550), // Rule ID 3216 //
     /* 198513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
     /* 198521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 198524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198528 */     // MIs[0] Op1
     /* 198528 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198532 */     // MIs[0] Op2
     /* 198532 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198536 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2128:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
     /* 198539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198545 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198548 */     GIR_RootConstrainSelectedInstOperands,
     /* 198549 */     // GIR_Coverage, 3216,
     /* 198549 */     GIR_EraseRootFromParent_Done,
     /* 198550 */   // Label 3971: @198550
     /* 198550 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(198592), // Rule ID 3217 //
     /* 198555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
     /* 198563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 198566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198570 */     // MIs[0] Op1
     /* 198570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198574 */     // MIs[0] Op2
     /* 198574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198578 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2130:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
     /* 198581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198587 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198590 */     GIR_RootConstrainSelectedInstOperands,
     /* 198591 */     // GIR_Coverage, 3217,
     /* 198591 */     GIR_EraseRootFromParent_Done,
     /* 198592 */   // Label 3972: @198592
     /* 198592 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(198634), // Rule ID 3218 //
     /* 198597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
     /* 198605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 198608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198612 */     // MIs[0] Op1
     /* 198612 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198616 */     // MIs[0] Op2
     /* 198616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198620 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2131:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
     /* 198623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198629 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198632 */     GIR_RootConstrainSelectedInstOperands,
     /* 198633 */     // GIR_Coverage, 3218,
     /* 198633 */     GIR_EraseRootFromParent_Done,
     /* 198634 */   // Label 3973: @198634
     /* 198634 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(198676), // Rule ID 3219 //
     /* 198639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
     /* 198647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 198650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198654 */     // MIs[0] Op1
     /* 198654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198658 */     // MIs[0] Op2
     /* 198658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198662 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2129:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
     /* 198665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198674 */     GIR_RootConstrainSelectedInstOperands,
     /* 198675 */     // GIR_Coverage, 3219,
     /* 198675 */     GIR_EraseRootFromParent_Done,
     /* 198676 */   // Label 3974: @198676
     /* 198676 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(198718), // Rule ID 11898 //
     /* 198681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
     /* 198689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 198692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198696 */     // MIs[0] Op1
     /* 198696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198700 */     // MIs[0] Op2
     /* 198700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198704 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2124:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
     /* 198707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198713 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198716 */     GIR_RootConstrainSelectedInstOperands,
     /* 198717 */     // GIR_Coverage, 11898,
     /* 198717 */     GIR_EraseRootFromParent_Done,
     /* 198718 */   // Label 3975: @198718
     /* 198718 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(198760), // Rule ID 11899 //
     /* 198723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
     /* 198731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 198734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198738 */     // MIs[0] Op1
     /* 198738 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198742 */     // MIs[0] Op2
     /* 198742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198746 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2126:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
     /* 198749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198755 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198758 */     GIR_RootConstrainSelectedInstOperands,
     /* 198759 */     // GIR_Coverage, 11899,
     /* 198759 */     GIR_EraseRootFromParent_Done,
     /* 198760 */   // Label 3976: @198760
     /* 198760 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(198802), // Rule ID 11900 //
     /* 198765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
     /* 198773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 198776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198780 */     // MIs[0] Op1
     /* 198780 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198784 */     // MIs[0] Op2
     /* 198784 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198788 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2127:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
     /* 198791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198797 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198800 */     GIR_RootConstrainSelectedInstOperands,
     /* 198801 */     // GIR_Coverage, 11900,
     /* 198801 */     GIR_EraseRootFromParent_Done,
     /* 198802 */   // Label 3977: @198802
     /* 198802 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(198844), // Rule ID 11901 //
     /* 198807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 198810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
     /* 198815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 198818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198822 */     // MIs[0] Op1
     /* 198822 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 198826 */     // MIs[0] Op2
     /* 198826 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 198830 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2125:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 198830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
     /* 198833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 198835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 198837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 198839 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 198842 */     GIR_RootConstrainSelectedInstOperands,
     /* 198843 */     // GIR_Coverage, 11901,
     /* 198843 */     GIR_EraseRootFromParent_Done,
     /* 198844 */   // Label 3978: @198844
     /* 198844 */   GIM_Reject,
     /* 198845 */ // Label 3025: @198845
     /* 198845 */ GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(242628),
     /* 198850 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 198853 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(198966), // Rule ID 2069 //
     /* 198858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 198861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 198866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 198878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 198894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 198898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 198902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 198906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 198910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 198914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 198918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 198923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 198927 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 198931 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 198935 */     // MIs[3] Operand 1
     /* 198935 */     // No operand predicates
     /* 198935 */     // MIs[1] Operand 2
     /* 198935 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 198946 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 198948 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 198948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 198951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 198953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 198955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 198961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 198964 */     GIR_RootConstrainSelectedInstOperands,
     /* 198965 */     // GIR_Coverage, 2069,
     /* 198965 */     GIR_EraseRootFromParent_Done,
     /* 198966 */   // Label 3980: @198966
     /* 198966 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(199079), // Rule ID 2076 //
     /* 198971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 198974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 198979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198985 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198988 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 198991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 199011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 199015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 199023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 199027 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199031 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 199036 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199040 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199044 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 199048 */     // MIs[3] Operand 1
     /* 199048 */     // No operand predicates
     /* 199048 */     // MIs[1] Operand 2
     /* 199048 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 199059 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199061 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 199061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 199064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199066 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199074 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199077 */     GIR_RootConstrainSelectedInstOperands,
     /* 199078 */     // GIR_Coverage, 2076,
     /* 199078 */     GIR_EraseRootFromParent_Done,
     /* 199079 */   // Label 3981: @199079
     /* 199079 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(199192), // Rule ID 2072 //
     /* 199084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 199087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 199092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 199095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 199098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 199101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 199104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 199124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199149 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199153 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199157 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 199161 */     // MIs[3] Operand 1
     /* 199161 */     // No operand predicates
     /* 199161 */     // MIs[1] Operand 2
     /* 199161 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 199172 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199174 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 199174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 199177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199190 */     GIR_RootConstrainSelectedInstOperands,
     /* 199191 */     // GIR_Coverage, 2072,
     /* 199191 */     GIR_EraseRootFromParent_Done,
     /* 199192 */   // Label 3982: @199192
     /* 199192 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(199305), // Rule ID 2079 //
     /* 199197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 199200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 199205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 199208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 199211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 199214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 199217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 199237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199253 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199257 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199262 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199266 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199270 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 199274 */     // MIs[3] Operand 1
     /* 199274 */     // No operand predicates
     /* 199274 */     // MIs[1] Operand 2
     /* 199274 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 199285 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199287 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 199287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 199290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199303 */     GIR_RootConstrainSelectedInstOperands,
     /* 199304 */     // GIR_Coverage, 2079,
     /* 199304 */     GIR_EraseRootFromParent_Done,
     /* 199305 */   // Label 3983: @199305
     /* 199305 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(199410), // Rule ID 3857 //
     /* 199310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 199318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 199330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 199354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199366 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199370 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199379 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199383 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199387 */     // MIs[3] Operand 1
     /* 199387 */     // No operand predicates
     /* 199387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199389 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 199389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 199392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199405 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199408 */     GIR_RootConstrainSelectedInstOperands,
     /* 199409 */     // GIR_Coverage, 3857,
     /* 199409 */     GIR_EraseRootFromParent_Done,
     /* 199410 */   // Label 3984: @199410
     /* 199410 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(199515), // Rule ID 3858 //
     /* 199415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 199423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 199435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 199459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199471 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199475 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199480 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199484 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199488 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199492 */     // MIs[3] Operand 1
     /* 199492 */     // No operand predicates
     /* 199492 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199494 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 199494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 199497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199513 */     GIR_RootConstrainSelectedInstOperands,
     /* 199514 */     // GIR_Coverage, 3858,
     /* 199514 */     GIR_EraseRootFromParent_Done,
     /* 199515 */   // Label 3985: @199515
     /* 199515 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(199620), // Rule ID 3859 //
     /* 199520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 199528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 199540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 199564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199589 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199593 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199597 */     // MIs[3] Operand 1
     /* 199597 */     // No operand predicates
     /* 199597 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199599 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 199599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 199602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 199618 */     GIR_RootConstrainSelectedInstOperands,
     /* 199619 */     // GIR_Coverage, 3859,
     /* 199619 */     GIR_EraseRootFromParent_Done,
     /* 199620 */   // Label 3986: @199620
     /* 199620 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(199725), // Rule ID 3860 //
     /* 199625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 199633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 199636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 199639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 199642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 199645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 199669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199677 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199681 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199685 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199690 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199694 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199698 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 199702 */     // MIs[3] Operand 1
     /* 199702 */     // No operand predicates
     /* 199702 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199704 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 199704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 199707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 199723 */     GIR_RootConstrainSelectedInstOperands,
     /* 199724 */     // GIR_Coverage, 3860,
     /* 199724 */     GIR_EraseRootFromParent_Done,
     /* 199725 */   // Label 3987: @199725
     /* 199725 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(199830), // Rule ID 3865 //
     /* 199730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 199738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 199750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199803 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 199807 */     // MIs[3] Operand 1
     /* 199807 */     // No operand predicates
     /* 199807 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199809 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 199809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 199812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 199828 */     GIR_RootConstrainSelectedInstOperands,
     /* 199829 */     // GIR_Coverage, 3865,
     /* 199829 */     GIR_EraseRootFromParent_Done,
     /* 199830 */   // Label 3988: @199830
     /* 199830 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(199935), // Rule ID 3866 //
     /* 199835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 199843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 199855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 199895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 199904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 199908 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 199912 */     // MIs[3] Operand 1
     /* 199912 */     // No operand predicates
     /* 199912 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 199914 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 199914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 199917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 199919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 199921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 199923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 199927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 199930 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199933 */     GIR_RootConstrainSelectedInstOperands,
     /* 199934 */     // GIR_Coverage, 3866,
     /* 199934 */     GIR_EraseRootFromParent_Done,
     /* 199935 */   // Label 3989: @199935
     /* 199935 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(200040), // Rule ID 3867 //
     /* 199940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 199943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 199948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 199951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 199954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 199957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 199960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 199976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 199980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 199988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 199992 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 199996 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200000 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200013 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 200017 */     // MIs[3] Operand 1
     /* 200017 */     // No operand predicates
     /* 200017 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200019 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 200019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 200022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 200038 */     GIR_RootConstrainSelectedInstOperands,
     /* 200039 */     // GIR_Coverage, 3867,
     /* 200039 */     GIR_EraseRootFromParent_Done,
     /* 200040 */   // Label 3990: @200040
     /* 200040 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(200145), // Rule ID 3868 //
     /* 200045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 200048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 200053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 200056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 200059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 200062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 200065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 200085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 200089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 200097 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 200101 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200105 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200110 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200114 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200118 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 200122 */     // MIs[3] Operand 1
     /* 200122 */     // No operand predicates
     /* 200122 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200124 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 200124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 200127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 200143 */     GIR_RootConstrainSelectedInstOperands,
     /* 200144 */     // GIR_Coverage, 3868,
     /* 200144 */     GIR_EraseRootFromParent_Done,
     /* 200145 */   // Label 3991: @200145
     /* 200145 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(200250), // Rule ID 3881 //
     /* 200150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 200153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 200158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 200161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 200164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 200167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 200170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 200190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 200202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200206 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200223 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 200227 */     // MIs[3] Operand 1
     /* 200227 */     // No operand predicates
     /* 200227 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200229 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 200229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 200232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 200248 */     GIR_RootConstrainSelectedInstOperands,
     /* 200249 */     // GIR_Coverage, 3881,
     /* 200249 */     GIR_EraseRootFromParent_Done,
     /* 200250 */   // Label 3992: @200250
     /* 200250 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(200355), // Rule ID 3882 //
     /* 200255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 200258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 200263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 200266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 200269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 200272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 200275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 200295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 200307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200315 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200320 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200324 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200328 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 200332 */     // MIs[3] Operand 1
     /* 200332 */     // No operand predicates
     /* 200332 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200334 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 200334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 200337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 200353 */     GIR_RootConstrainSelectedInstOperands,
     /* 200354 */     // GIR_Coverage, 3882,
     /* 200354 */     GIR_EraseRootFromParent_Done,
     /* 200355 */   // Label 3993: @200355
     /* 200355 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(200460), // Rule ID 3883 //
     /* 200360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 200363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 200368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 200371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 200374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 200377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 200380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 200400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 200412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200416 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200429 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200433 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 200437 */     // MIs[3] Operand 1
     /* 200437 */     // No operand predicates
     /* 200437 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200439 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 200439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 200442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 200458 */     GIR_RootConstrainSelectedInstOperands,
     /* 200459 */     // GIR_Coverage, 3883,
     /* 200459 */     GIR_EraseRootFromParent_Done,
     /* 200460 */   // Label 3994: @200460
     /* 200460 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(200565), // Rule ID 3884 //
     /* 200465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 200468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 200473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 200476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 200479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 200482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 200485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 200501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 200505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 200513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 200517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 200521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 200525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 200534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 200538 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 200542 */     // MIs[3] Operand 1
     /* 200542 */     // No operand predicates
     /* 200542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 200544 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 200544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 200547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 200557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 200560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 200563 */     GIR_RootConstrainSelectedInstOperands,
     /* 200564 */     // GIR_Coverage, 3884,
     /* 200564 */     GIR_EraseRootFromParent_Done,
     /* 200565 */   // Label 3995: @200565
     /* 200565 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(200619), // Rule ID 59 //
     /* 200570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 200573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 200578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 200587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200595 */     // MIs[0] Operand 3
     /* 200595 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 200606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 200610 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 200610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
     /* 200613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200617 */     GIR_RootConstrainSelectedInstOperands,
     /* 200618 */     // GIR_Coverage, 59,
     /* 200618 */     GIR_EraseRootFromParent_Done,
     /* 200619 */   // Label 3996: @200619
     /* 200619 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(200673), // Rule ID 60 //
     /* 200624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 200627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 200632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 200641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200649 */     // MIs[0] Operand 3
     /* 200649 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 200660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 200664 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 200664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
     /* 200667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200671 */     GIR_RootConstrainSelectedInstOperands,
     /* 200672 */     // GIR_Coverage, 60,
     /* 200672 */     GIR_EraseRootFromParent_Done,
     /* 200673 */   // Label 3997: @200673
     /* 200673 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(200727), // Rule ID 61 //
     /* 200678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 200681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 200686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 200695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200703 */     // MIs[0] Operand 3
     /* 200703 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 200714 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 200718 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 200718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
     /* 200721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200725 */     GIR_RootConstrainSelectedInstOperands,
     /* 200726 */     // GIR_Coverage, 61,
     /* 200726 */     GIR_EraseRootFromParent_Done,
     /* 200727 */   // Label 3998: @200727
     /* 200727 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(200781), // Rule ID 62 //
     /* 200732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 200735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 200740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 200749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200757 */     // MIs[0] Operand 3
     /* 200757 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 200768 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 200772 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 200772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
     /* 200775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200779 */     GIR_RootConstrainSelectedInstOperands,
     /* 200780 */     // GIR_Coverage, 62,
     /* 200780 */     GIR_EraseRootFromParent_Done,
     /* 200781 */   // Label 3999: @200781
     /* 200781 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(200837), // Rule ID 2650 //
     /* 200786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
     /* 200794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 200797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 200800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 200808 */     // MIs[0] pattern
     /* 200808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200811 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200816 */     // MIs[0] imm4
     /* 200816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200819 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200824 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1796:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
     /* 200827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 200829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 200831 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200833 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200835 */     GIR_RootConstrainSelectedInstOperands,
     /* 200836 */     // GIR_Coverage, 2650,
     /* 200836 */     GIR_EraseRootFromParent_Done,
     /* 200837 */   // Label 4000: @200837
     /* 200837 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(200893), // Rule ID 2659 //
     /* 200842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
     /* 200850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200864 */     // MIs[0] pattern
     /* 200864 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200867 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200872 */     // MIs[0] imm4
     /* 200872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200875 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200880 */     // (intrinsic_wo_chain:{ *:[i32] } 2002:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
     /* 200883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200887 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200889 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200891 */     GIR_RootConstrainSelectedInstOperands,
     /* 200892 */     // GIR_Coverage, 2659,
     /* 200892 */     GIR_EraseRootFromParent_Done,
     /* 200893 */   // Label 4001: @200893
     /* 200893 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(200949), // Rule ID 2660 //
     /* 200898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
     /* 200906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200920 */     // MIs[0] pattern
     /* 200920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200923 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200928 */     // MIs[0] imm4
     /* 200928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200931 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200936 */     // (intrinsic_wo_chain:{ *:[i64] } 1792:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
     /* 200939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200943 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 200945 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 200947 */     GIR_RootConstrainSelectedInstOperands,
     /* 200948 */     // GIR_Coverage, 2660,
     /* 200948 */     GIR_EraseRootFromParent_Done,
     /* 200949 */   // Label 4002: @200949
     /* 200949 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(201005), // Rule ID 9929 //
     /* 200954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
     /* 200962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200976 */     // MIs[0] pattern
     /* 200976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 200979 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 200984 */     // MIs[0] imm4
     /* 200984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 200987 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 200992 */     // (intrinsic_wo_chain:{ *:[i32] } 1988:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 200992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
     /* 200995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200999 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201001 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201003 */     GIR_RootConstrainSelectedInstOperands,
     /* 201004 */     // GIR_Coverage, 9929,
     /* 201004 */     GIR_EraseRootFromParent_Done,
     /* 201005 */   // Label 4003: @201005
     /* 201005 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(201061), // Rule ID 9930 //
     /* 201010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
     /* 201018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201032 */     // MIs[0] pattern
     /* 201032 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201035 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201040 */     // MIs[0] imm4
     /* 201040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201043 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201048 */     // (intrinsic_wo_chain:{ *:[i64] } 2003:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
     /* 201051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201055 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201057 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201059 */     GIR_RootConstrainSelectedInstOperands,
     /* 201060 */     // GIR_Coverage, 9930,
     /* 201060 */     GIR_EraseRootFromParent_Done,
     /* 201061 */   // Label 4004: @201061
     /* 201061 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(201117), // Rule ID 9931 //
     /* 201066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
     /* 201074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201088 */     // MIs[0] pattern
     /* 201088 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201091 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201096 */     // MIs[0] imm4
     /* 201096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201099 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201104 */     // (intrinsic_wo_chain:{ *:[i64] } 1758:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
     /* 201107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201111 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201113 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201115 */     GIR_RootConstrainSelectedInstOperands,
     /* 201116 */     // GIR_Coverage, 9931,
     /* 201116 */     GIR_EraseRootFromParent_Done,
     /* 201117 */   // Label 4005: @201117
     /* 201117 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(201173), // Rule ID 9932 //
     /* 201122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
     /* 201130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201144 */     // MIs[0] pattern
     /* 201144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201147 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201152 */     // MIs[0] imm4
     /* 201152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201155 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201160 */     // (intrinsic_wo_chain:{ *:[i64] } 1989:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
     /* 201163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201167 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201169 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201171 */     GIR_RootConstrainSelectedInstOperands,
     /* 201172 */     // GIR_Coverage, 9932,
     /* 201172 */     GIR_EraseRootFromParent_Done,
     /* 201173 */   // Label 4006: @201173
     /* 201173 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(201229), // Rule ID 9935 //
     /* 201178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
     /* 201186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201200 */     // MIs[0] pattern
     /* 201200 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201203 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201208 */     // MIs[0] imm4
     /* 201208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201211 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201216 */     // (intrinsic_wo_chain:{ *:[i32] } 2008:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
     /* 201219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201223 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201225 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201227 */     GIR_RootConstrainSelectedInstOperands,
     /* 201228 */     // GIR_Coverage, 9935,
     /* 201228 */     GIR_EraseRootFromParent_Done,
     /* 201229 */   // Label 4007: @201229
     /* 201229 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(201285), // Rule ID 9938 //
     /* 201234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
     /* 201242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201256 */     // MIs[0] pattern
     /* 201256 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201259 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201264 */     // MIs[0] imm4
     /* 201264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201267 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201272 */     // (intrinsic_wo_chain:{ *:[i32] } 1994:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
     /* 201275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201279 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201281 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201283 */     GIR_RootConstrainSelectedInstOperands,
     /* 201284 */     // GIR_Coverage, 9938,
     /* 201284 */     GIR_EraseRootFromParent_Done,
     /* 201285 */   // Label 4008: @201285
     /* 201285 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(201341), // Rule ID 9939 //
     /* 201290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
     /* 201298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201312 */     // MIs[0] pattern
     /* 201312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201315 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201320 */     // MIs[0] imm4
     /* 201320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201323 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201328 */     // (intrinsic_wo_chain:{ *:[i64] } 1798:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
     /* 201331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201335 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201337 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201339 */     GIR_RootConstrainSelectedInstOperands,
     /* 201340 */     // GIR_Coverage, 9939,
     /* 201340 */     GIR_EraseRootFromParent_Done,
     /* 201341 */   // Label 4009: @201341
     /* 201341 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(201397), // Rule ID 9940 //
     /* 201346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
     /* 201354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201368 */     // MIs[0] pattern
     /* 201368 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201371 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201376 */     // MIs[0] imm4
     /* 201376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201379 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201384 */     // (intrinsic_wo_chain:{ *:[i64] } 2009:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
     /* 201387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201391 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201393 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201395 */     GIR_RootConstrainSelectedInstOperands,
     /* 201396 */     // GIR_Coverage, 9940,
     /* 201396 */     GIR_EraseRootFromParent_Done,
     /* 201397 */   // Label 4010: @201397
     /* 201397 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(201453), // Rule ID 9941 //
     /* 201402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
     /* 201410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201420 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201424 */     // MIs[0] pattern
     /* 201424 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201427 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201432 */     // MIs[0] imm4
     /* 201432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201435 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201440 */     // (intrinsic_wo_chain:{ *:[i64] } 1764:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
     /* 201443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201447 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201449 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201451 */     GIR_RootConstrainSelectedInstOperands,
     /* 201452 */     // GIR_Coverage, 9941,
     /* 201452 */     GIR_EraseRootFromParent_Done,
     /* 201453 */   // Label 4011: @201453
     /* 201453 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(201509), // Rule ID 9942 //
     /* 201458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
     /* 201466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201480 */     // MIs[0] pattern
     /* 201480 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201483 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201488 */     // MIs[0] imm4
     /* 201488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201491 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201496 */     // (intrinsic_wo_chain:{ *:[i64] } 1995:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
     /* 201499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201503 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201505 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201507 */     GIR_RootConstrainSelectedInstOperands,
     /* 201508 */     // GIR_Coverage, 9942,
     /* 201508 */     GIR_EraseRootFromParent_Done,
     /* 201509 */   // Label 4012: @201509
     /* 201509 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(201565), // Rule ID 9945 //
     /* 201514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
     /* 201522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201536 */     // MIs[0] pattern
     /* 201536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201539 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201544 */     // MIs[0] imm4
     /* 201544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201547 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201552 */     // (intrinsic_wo_chain:{ *:[i32] } 2014:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
     /* 201555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201559 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201561 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201563 */     GIR_RootConstrainSelectedInstOperands,
     /* 201564 */     // GIR_Coverage, 9945,
     /* 201564 */     GIR_EraseRootFromParent_Done,
     /* 201565 */   // Label 4013: @201565
     /* 201565 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(201621), // Rule ID 9948 //
     /* 201570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
     /* 201578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201592 */     // MIs[0] pattern
     /* 201592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201595 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201600 */     // MIs[0] imm4
     /* 201600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201603 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201608 */     // (intrinsic_wo_chain:{ *:[i32] } 2000:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
     /* 201611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201615 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201617 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201619 */     GIR_RootConstrainSelectedInstOperands,
     /* 201620 */     // GIR_Coverage, 9948,
     /* 201620 */     GIR_EraseRootFromParent_Done,
     /* 201621 */   // Label 4014: @201621
     /* 201621 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(201677), // Rule ID 9949 //
     /* 201626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
     /* 201634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201648 */     // MIs[0] pattern
     /* 201648 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201651 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201656 */     // MIs[0] imm4
     /* 201656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201659 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201664 */     // (intrinsic_wo_chain:{ *:[i64] } 1804:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
     /* 201667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201671 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201673 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201675 */     GIR_RootConstrainSelectedInstOperands,
     /* 201676 */     // GIR_Coverage, 9949,
     /* 201676 */     GIR_EraseRootFromParent_Done,
     /* 201677 */   // Label 4015: @201677
     /* 201677 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(201733), // Rule ID 9950 //
     /* 201682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
     /* 201690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201704 */     // MIs[0] pattern
     /* 201704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201707 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201712 */     // MIs[0] imm4
     /* 201712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201715 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201720 */     // (intrinsic_wo_chain:{ *:[i64] } 2015:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
     /* 201723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201727 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201729 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201731 */     GIR_RootConstrainSelectedInstOperands,
     /* 201732 */     // GIR_Coverage, 9950,
     /* 201732 */     GIR_EraseRootFromParent_Done,
     /* 201733 */   // Label 4016: @201733
     /* 201733 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(201789), // Rule ID 9951 //
     /* 201738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
     /* 201746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201760 */     // MIs[0] pattern
     /* 201760 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201763 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201768 */     // MIs[0] imm4
     /* 201768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201776 */     // (intrinsic_wo_chain:{ *:[i64] } 1770:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
     /* 201779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201783 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201785 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201787 */     GIR_RootConstrainSelectedInstOperands,
     /* 201788 */     // GIR_Coverage, 9951,
     /* 201788 */     GIR_EraseRootFromParent_Done,
     /* 201789 */   // Label 4017: @201789
     /* 201789 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(201845), // Rule ID 9952 //
     /* 201794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
     /* 201802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201816 */     // MIs[0] pattern
     /* 201816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201819 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201824 */     // MIs[0] imm4
     /* 201824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201827 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201832 */     // (intrinsic_wo_chain:{ *:[i64] } 2001:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
     /* 201835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201839 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201841 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201843 */     GIR_RootConstrainSelectedInstOperands,
     /* 201844 */     // GIR_Coverage, 9952,
     /* 201844 */     GIR_EraseRootFromParent_Done,
     /* 201845 */   // Label 4018: @201845
     /* 201845 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(201901), // Rule ID 9955 //
     /* 201850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
     /* 201858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201872 */     // MIs[0] pattern
     /* 201872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201875 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201880 */     // MIs[0] imm4
     /* 201880 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201883 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201888 */     // (intrinsic_wo_chain:{ *:[i32] } 2005:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
     /* 201891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201895 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201897 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201899 */     GIR_RootConstrainSelectedInstOperands,
     /* 201900 */     // GIR_Coverage, 9955,
     /* 201900 */     GIR_EraseRootFromParent_Done,
     /* 201901 */   // Label 4019: @201901
     /* 201901 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(201957), // Rule ID 9958 //
     /* 201906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
     /* 201914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201928 */     // MIs[0] pattern
     /* 201928 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201931 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201936 */     // MIs[0] imm4
     /* 201936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201939 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 201944 */     // (intrinsic_wo_chain:{ *:[i32] } 1991:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 201944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
     /* 201947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201951 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 201953 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 201955 */     GIR_RootConstrainSelectedInstOperands,
     /* 201956 */     // GIR_Coverage, 9958,
     /* 201956 */     GIR_EraseRootFromParent_Done,
     /* 201957 */   // Label 4020: @201957
     /* 201957 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(202013), // Rule ID 9959 //
     /* 201962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
     /* 201970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201984 */     // MIs[0] pattern
     /* 201984 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 201987 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 201992 */     // MIs[0] imm4
     /* 201992 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 201995 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202000 */     // (intrinsic_wo_chain:{ *:[i64] } 1795:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
     /* 202003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202007 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202009 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202011 */     GIR_RootConstrainSelectedInstOperands,
     /* 202012 */     // GIR_Coverage, 9959,
     /* 202012 */     GIR_EraseRootFromParent_Done,
     /* 202013 */   // Label 4021: @202013
     /* 202013 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(202069), // Rule ID 9960 //
     /* 202018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
     /* 202026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202040 */     // MIs[0] pattern
     /* 202040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202043 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202048 */     // MIs[0] imm4
     /* 202048 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202051 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202056 */     // (intrinsic_wo_chain:{ *:[i64] } 2006:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
     /* 202059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202063 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202065 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202067 */     GIR_RootConstrainSelectedInstOperands,
     /* 202068 */     // GIR_Coverage, 9960,
     /* 202068 */     GIR_EraseRootFromParent_Done,
     /* 202069 */   // Label 4022: @202069
     /* 202069 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(202125), // Rule ID 9961 //
     /* 202074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
     /* 202082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202096 */     // MIs[0] pattern
     /* 202096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202099 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202104 */     // MIs[0] imm4
     /* 202104 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202107 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202112 */     // (intrinsic_wo_chain:{ *:[i64] } 1761:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
     /* 202115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202119 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202121 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202123 */     GIR_RootConstrainSelectedInstOperands,
     /* 202124 */     // GIR_Coverage, 9961,
     /* 202124 */     GIR_EraseRootFromParent_Done,
     /* 202125 */   // Label 4023: @202125
     /* 202125 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(202181), // Rule ID 9962 //
     /* 202130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
     /* 202138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 202144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202152 */     // MIs[0] pattern
     /* 202152 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202155 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202160 */     // MIs[0] imm4
     /* 202160 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202163 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202168 */     // (intrinsic_wo_chain:{ *:[i64] } 1992:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
     /* 202171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 202173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 202175 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202177 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202179 */     GIR_RootConstrainSelectedInstOperands,
     /* 202180 */     // GIR_Coverage, 9962,
     /* 202180 */     GIR_EraseRootFromParent_Done,
     /* 202181 */   // Label 4024: @202181
     /* 202181 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(202237), // Rule ID 9963 //
     /* 202186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
     /* 202194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202208 */     // MIs[0] pattern
     /* 202208 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202211 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202216 */     // MIs[0] imm4
     /* 202216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202219 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202224 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2007:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
     /* 202227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202231 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202233 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202235 */     GIR_RootConstrainSelectedInstOperands,
     /* 202236 */     // GIR_Coverage, 9963,
     /* 202236 */     GIR_EraseRootFromParent_Done,
     /* 202237 */   // Label 4025: @202237
     /* 202237 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(202293), // Rule ID 9964 //
     /* 202242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
     /* 202250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202264 */     // MIs[0] pattern
     /* 202264 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202267 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202272 */     // MIs[0] imm4
     /* 202272 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202275 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202280 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1762:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
     /* 202283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202287 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202289 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202291 */     GIR_RootConstrainSelectedInstOperands,
     /* 202292 */     // GIR_Coverage, 9964,
     /* 202292 */     GIR_EraseRootFromParent_Done,
     /* 202293 */   // Label 4026: @202293
     /* 202293 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(202349), // Rule ID 9965 //
     /* 202298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
     /* 202306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202320 */     // MIs[0] pattern
     /* 202320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202323 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202328 */     // MIs[0] imm4
     /* 202328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202331 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202336 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1993:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
     /* 202339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202343 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202345 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202347 */     GIR_RootConstrainSelectedInstOperands,
     /* 202348 */     // GIR_Coverage, 9965,
     /* 202348 */     GIR_EraseRootFromParent_Done,
     /* 202349 */   // Label 4027: @202349
     /* 202349 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(202405), // Rule ID 9966 //
     /* 202354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
     /* 202362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202376 */     // MIs[0] pattern
     /* 202376 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202379 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202384 */     // MIs[0] imm4
     /* 202384 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202387 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202392 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1802:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
     /* 202395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202399 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202401 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202403 */     GIR_RootConstrainSelectedInstOperands,
     /* 202404 */     // GIR_Coverage, 9966,
     /* 202404 */     GIR_EraseRootFromParent_Done,
     /* 202405 */   // Label 4028: @202405
     /* 202405 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(202461), // Rule ID 9967 //
     /* 202410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
     /* 202418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202432 */     // MIs[0] pattern
     /* 202432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202435 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202440 */     // MIs[0] imm4
     /* 202440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202443 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202448 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2013:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
     /* 202451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202455 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202457 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202459 */     GIR_RootConstrainSelectedInstOperands,
     /* 202460 */     // GIR_Coverage, 9967,
     /* 202460 */     GIR_EraseRootFromParent_Done,
     /* 202461 */   // Label 4029: @202461
     /* 202461 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(202517), // Rule ID 9968 //
     /* 202466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
     /* 202474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202488 */     // MIs[0] pattern
     /* 202488 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202491 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202496 */     // MIs[0] imm4
     /* 202496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202499 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202504 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1768:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
     /* 202507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202511 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202513 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202515 */     GIR_RootConstrainSelectedInstOperands,
     /* 202516 */     // GIR_Coverage, 9968,
     /* 202516 */     GIR_EraseRootFromParent_Done,
     /* 202517 */   // Label 4030: @202517
     /* 202517 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(202573), // Rule ID 9969 //
     /* 202522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
     /* 202530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202544 */     // MIs[0] pattern
     /* 202544 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202547 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202552 */     // MIs[0] imm4
     /* 202552 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202555 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202560 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1999:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
     /* 202563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202567 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202569 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202571 */     GIR_RootConstrainSelectedInstOperands,
     /* 202572 */     // GIR_Coverage, 9969,
     /* 202572 */     GIR_EraseRootFromParent_Done,
     /* 202573 */   // Label 4031: @202573
     /* 202573 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(202629), // Rule ID 9970 //
     /* 202578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
     /* 202586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202600 */     // MIs[0] pattern
     /* 202600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202603 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202608 */     // MIs[0] imm4
     /* 202608 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202611 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202616 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1793:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
     /* 202619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202623 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202625 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202627 */     GIR_RootConstrainSelectedInstOperands,
     /* 202628 */     // GIR_Coverage, 9970,
     /* 202628 */     GIR_EraseRootFromParent_Done,
     /* 202629 */   // Label 4032: @202629
     /* 202629 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(202685), // Rule ID 9971 //
     /* 202634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
     /* 202642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202656 */     // MIs[0] pattern
     /* 202656 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202659 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202664 */     // MIs[0] imm4
     /* 202664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202667 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202672 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2004:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
     /* 202675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202679 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202681 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202683 */     GIR_RootConstrainSelectedInstOperands,
     /* 202684 */     // GIR_Coverage, 9971,
     /* 202684 */     GIR_EraseRootFromParent_Done,
     /* 202685 */   // Label 4033: @202685
     /* 202685 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(202741), // Rule ID 9972 //
     /* 202690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
     /* 202698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202712 */     // MIs[0] pattern
     /* 202712 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202715 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202720 */     // MIs[0] imm4
     /* 202720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202728 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1759:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
     /* 202731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202735 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202737 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202739 */     GIR_RootConstrainSelectedInstOperands,
     /* 202740 */     // GIR_Coverage, 9972,
     /* 202740 */     GIR_EraseRootFromParent_Done,
     /* 202741 */   // Label 4034: @202741
     /* 202741 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(202797), // Rule ID 9973 //
     /* 202746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
     /* 202754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202768 */     // MIs[0] pattern
     /* 202768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 202771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 202776 */     // MIs[0] imm4
     /* 202776 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 202779 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 202784 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1990:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 202784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
     /* 202787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202791 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 202793 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 202795 */     GIR_RootConstrainSelectedInstOperands,
     /* 202796 */     // GIR_Coverage, 9973,
     /* 202796 */     GIR_EraseRootFromParent_Done,
     /* 202797 */   // Label 4035: @202797
     /* 202797 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(202887), // Rule ID 47 //
     /* 202802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 202810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 202813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 202816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 202819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 202822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 202834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202850 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202863 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202867 */     // MIs[2] Operand 1
     /* 202867 */     // No operand predicates
     /* 202867 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202869 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
     /* 202872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202885 */     GIR_RootConstrainSelectedInstOperands,
     /* 202886 */     // GIR_Coverage, 47,
     /* 202886 */     GIR_EraseRootFromParent_Done,
     /* 202887 */   // Label 4036: @202887
     /* 202887 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(202977), // Rule ID 48 //
     /* 202892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 202900 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 202903 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 202906 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 202909 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 202912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 202924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 202928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 202932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 202936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 202940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 202945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 202949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 202953 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 202957 */     // MIs[2] Operand 1
     /* 202957 */     // No operand predicates
     /* 202957 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 202959 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 202959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
     /* 202962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 202964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 202966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 202968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 202972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 202975 */     GIR_RootConstrainSelectedInstOperands,
     /* 202976 */     // GIR_Coverage, 48,
     /* 202976 */     GIR_EraseRootFromParent_Done,
     /* 202977 */   // Label 4037: @202977
     /* 202977 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(203067), // Rule ID 49 //
     /* 202982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 202985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 202990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 202993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 202996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 202999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 203002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203026 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203030 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203043 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203047 */     // MIs[2] Operand 1
     /* 203047 */     // No operand predicates
     /* 203047 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203049 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
     /* 203052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203062 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203065 */     GIR_RootConstrainSelectedInstOperands,
     /* 203066 */     // GIR_Coverage, 49,
     /* 203066 */     GIR_EraseRootFromParent_Done,
     /* 203067 */   // Label 4038: @203067
     /* 203067 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(203157), // Rule ID 50 //
     /* 203072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 203075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 203080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 203083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 203086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 203089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 203092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203100 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203133 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203137 */     // MIs[2] Operand 1
     /* 203137 */     // No operand predicates
     /* 203137 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203139 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
     /* 203142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203155 */     GIR_RootConstrainSelectedInstOperands,
     /* 203156 */     // GIR_Coverage, 50,
     /* 203156 */     GIR_EraseRootFromParent_Done,
     /* 203157 */   // Label 4039: @203157
     /* 203157 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(203247), // Rule ID 51 //
     /* 203162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 203165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 203170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 203173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 203176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 203179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 203182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203223 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203227 */     // MIs[2] Operand 1
     /* 203227 */     // No operand predicates
     /* 203227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203229 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
     /* 203232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203245 */     GIR_RootConstrainSelectedInstOperands,
     /* 203246 */     // GIR_Coverage, 51,
     /* 203246 */     GIR_EraseRootFromParent_Done,
     /* 203247 */   // Label 4040: @203247
     /* 203247 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(203337), // Rule ID 52 //
     /* 203252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 203255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 203260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 203263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 203266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 203269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 203272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203313 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203317 */     // MIs[2] Operand 1
     /* 203317 */     // No operand predicates
     /* 203317 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203319 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
     /* 203322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203335 */     GIR_RootConstrainSelectedInstOperands,
     /* 203336 */     // GIR_Coverage, 52,
     /* 203336 */     GIR_EraseRootFromParent_Done,
     /* 203337 */   // Label 4041: @203337
     /* 203337 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(203427), // Rule ID 53 //
     /* 203342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 203345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 203350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 203353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 203356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 203359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 203362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203386 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203403 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203407 */     // MIs[2] Operand 1
     /* 203407 */     // No operand predicates
     /* 203407 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203409 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
     /* 203412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203425 */     GIR_RootConstrainSelectedInstOperands,
     /* 203426 */     // GIR_Coverage, 53,
     /* 203426 */     GIR_EraseRootFromParent_Done,
     /* 203427 */   // Label 4042: @203427
     /* 203427 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(203517), // Rule ID 54 //
     /* 203432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 203435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 203440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 203443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 203446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 203449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 203452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203493 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203497 */     // MIs[2] Operand 1
     /* 203497 */     // No operand predicates
     /* 203497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203499 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
     /* 203502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203515 */     GIR_RootConstrainSelectedInstOperands,
     /* 203516 */     // GIR_Coverage, 54,
     /* 203516 */     GIR_EraseRootFromParent_Done,
     /* 203517 */   // Label 4043: @203517
     /* 203517 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(203607), // Rule ID 2070 //
     /* 203522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 203530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 203533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 203536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 203539 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 203542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203583 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203587 */     // MIs[2] Operand 1
     /* 203587 */     // No operand predicates
     /* 203587 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203589 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 203592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203605 */     GIR_RootConstrainSelectedInstOperands,
     /* 203606 */     // GIR_Coverage, 2070,
     /* 203606 */     GIR_EraseRootFromParent_Done,
     /* 203607 */   // Label 4044: @203607
     /* 203607 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(203697), // Rule ID 2071 //
     /* 203612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 203620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 203623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 203626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 203629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 203632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203673 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203677 */     // MIs[2] Operand 1
     /* 203677 */     // No operand predicates
     /* 203677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203679 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
     /* 203682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203695 */     GIR_RootConstrainSelectedInstOperands,
     /* 203696 */     // GIR_Coverage, 2071,
     /* 203696 */     GIR_EraseRootFromParent_Done,
     /* 203697 */   // Label 4045: @203697
     /* 203697 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(203787), // Rule ID 2077 //
     /* 203702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 203710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 203713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 203716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 203719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 203722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203755 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203759 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203763 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203767 */     // MIs[2] Operand 1
     /* 203767 */     // No operand predicates
     /* 203767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203769 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 203772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203785 */     GIR_RootConstrainSelectedInstOperands,
     /* 203786 */     // GIR_Coverage, 2077,
     /* 203786 */     GIR_EraseRootFromParent_Done,
     /* 203787 */   // Label 4046: @203787
     /* 203787 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(203877), // Rule ID 2078 //
     /* 203792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 203800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 203803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 203806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 203809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 203812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 203832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 203836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 203845 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203849 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203853 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 203857 */     // MIs[2] Operand 1
     /* 203857 */     // No operand predicates
     /* 203857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203859 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
     /* 203862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203872 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203875 */     GIR_RootConstrainSelectedInstOperands,
     /* 203876 */     // GIR_Coverage, 2078,
     /* 203876 */     GIR_EraseRootFromParent_Done,
     /* 203877 */   // Label 4047: @203877
     /* 203877 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(203967), // Rule ID 2073 //
     /* 203882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 203890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 203893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 203896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 203899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 203902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 203914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 203918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 203922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 203926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 203930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 203939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 203943 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 203947 */     // MIs[2] Operand 1
     /* 203947 */     // No operand predicates
     /* 203947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 203949 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 203949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 203952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 203954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 203956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 203958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 203962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 203965 */     GIR_RootConstrainSelectedInstOperands,
     /* 203966 */     // GIR_Coverage, 2073,
     /* 203966 */     GIR_EraseRootFromParent_Done,
     /* 203967 */   // Label 4048: @203967
     /* 203967 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(204057), // Rule ID 2074 //
     /* 203972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 203975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 203980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 203983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 203986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 203989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 203992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 203996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 204012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 204016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204033 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 204037 */     // MIs[2] Operand 1
     /* 204037 */     // No operand predicates
     /* 204037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204039 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
     /* 204042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 204048 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 204052 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 204055 */     GIR_RootConstrainSelectedInstOperands,
     /* 204056 */     // GIR_Coverage, 2074,
     /* 204056 */     GIR_EraseRootFromParent_Done,
     /* 204057 */   // Label 4049: @204057
     /* 204057 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(204147), // Rule ID 2080 //
     /* 204062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 204065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 204070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 204073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 204076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 204079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 204082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 204094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 204102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 204106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204123 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 204127 */     // MIs[2] Operand 1
     /* 204127 */     // No operand predicates
     /* 204127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204129 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 204132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 204138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 204142 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 204145 */     GIR_RootConstrainSelectedInstOperands,
     /* 204146 */     // GIR_Coverage, 2080,
     /* 204146 */     GIR_EraseRootFromParent_Done,
     /* 204147 */   // Label 4050: @204147
     /* 204147 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(204237), // Rule ID 2081 //
     /* 204152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 204155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 204160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 204163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 204166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 204169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 204172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 204192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 204196 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204213 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 204217 */     // MIs[2] Operand 1
     /* 204217 */     // No operand predicates
     /* 204217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204219 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
     /* 204222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 204228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 204232 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 204235 */     GIR_RootConstrainSelectedInstOperands,
     /* 204236 */     // GIR_Coverage, 2081,
     /* 204236 */     GIR_EraseRootFromParent_Done,
     /* 204237 */   // Label 4051: @204237
     /* 204237 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(204327), // Rule ID 2075 //
     /* 204242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 204245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 204250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 204253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 204262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 204266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 204270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 204274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 204282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 204286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204303 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 204307 */     // MIs[2] Operand 1
     /* 204307 */     // No operand predicates
     /* 204307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204309 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
     /* 204312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 204318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 204322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 204325 */     GIR_RootConstrainSelectedInstOperands,
     /* 204326 */     // GIR_Coverage, 2075,
     /* 204326 */     GIR_EraseRootFromParent_Done,
     /* 204327 */   // Label 4052: @204327
     /* 204327 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(204417), // Rule ID 2082 //
     /* 204332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 204335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 204340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 204343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 204346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 204349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 204352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 204356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 204360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 204364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 204372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 204376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 204380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 204389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 204393 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 204397 */     // MIs[2] Operand 1
     /* 204397 */     // No operand predicates
     /* 204397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204399 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 204399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
     /* 204402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 204404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 204406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 204408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 204412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 204415 */     GIR_RootConstrainSelectedInstOperands,
     /* 204416 */     // GIR_Coverage, 2082,
     /* 204416 */     GIR_EraseRootFromParent_Done,
     /* 204417 */   // Label 4053: @204417
     /* 204417 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(204494), // Rule ID 2779 //
     /* 204422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204474 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204478 */     // MIs[2] Operand 1
     /* 204478 */     // No operand predicates
     /* 204478 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204480 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 204480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 204483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204489 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204492 */     GIR_RootConstrainSelectedInstOperands,
     /* 204493 */     // GIR_Coverage, 2779,
     /* 204493 */     GIR_EraseRootFromParent_Done,
     /* 204494 */   // Label 4054: @204494
     /* 204494 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(204571), // Rule ID 2780 //
     /* 204499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204551 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204555 */     // MIs[2] Operand 1
     /* 204555 */     // No operand predicates
     /* 204555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204557 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 204557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 204560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204569 */     GIR_RootConstrainSelectedInstOperands,
     /* 204570 */     // GIR_Coverage, 2780,
     /* 204570 */     GIR_EraseRootFromParent_Done,
     /* 204571 */   // Label 4055: @204571
     /* 204571 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(204648), // Rule ID 2781 //
     /* 204576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 204596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 204620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204628 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204632 */     // MIs[2] Operand 1
     /* 204632 */     // No operand predicates
     /* 204632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204634 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 204634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 204637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204646 */     GIR_RootConstrainSelectedInstOperands,
     /* 204647 */     // GIR_Coverage, 2781,
     /* 204647 */     GIR_EraseRootFromParent_Done,
     /* 204648 */   // Label 4056: @204648
     /* 204648 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(204725), // Rule ID 2782 //
     /* 204653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 204673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 204697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204705 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204709 */     // MIs[2] Operand 1
     /* 204709 */     // No operand predicates
     /* 204709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204711 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 204711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 204714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204723 */     GIR_RootConstrainSelectedInstOperands,
     /* 204724 */     // GIR_Coverage, 2782,
     /* 204724 */     GIR_EraseRootFromParent_Done,
     /* 204725 */   // Label 4057: @204725
     /* 204725 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(204802), // Rule ID 2783 //
     /* 204730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 204750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 204774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204782 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204786 */     // MIs[2] Operand 1
     /* 204786 */     // No operand predicates
     /* 204786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204788 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 204788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 204791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204800 */     GIR_RootConstrainSelectedInstOperands,
     /* 204801 */     // GIR_Coverage, 2783,
     /* 204801 */     GIR_EraseRootFromParent_Done,
     /* 204802 */   // Label 4058: @204802
     /* 204802 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(204879), // Rule ID 2784 //
     /* 204807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 204815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 204827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 204851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204859 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 204863 */     // MIs[2] Operand 1
     /* 204863 */     // No operand predicates
     /* 204863 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204865 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1349:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 204865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 204868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 204877 */     GIR_RootConstrainSelectedInstOperands,
     /* 204878 */     // GIR_Coverage, 2784,
     /* 204878 */     GIR_EraseRootFromParent_Done,
     /* 204879 */   // Label 4059: @204879
     /* 204879 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(204956), // Rule ID 7816 //
     /* 204884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 204924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 204928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 204932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 204936 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 204940 */     // MIs[2] Operand 1
     /* 204940 */     // No operand predicates
     /* 204940 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 204942 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1525:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 204942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 204945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 204947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 204949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 204951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 204954 */     GIR_RootConstrainSelectedInstOperands,
     /* 204955 */     // GIR_Coverage, 7816,
     /* 204955 */     GIR_EraseRootFromParent_Done,
     /* 204956 */   // Label 4060: @204956
     /* 204956 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(205033), // Rule ID 7817 //
     /* 204961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 204969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 204981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 204989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 204997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205013 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205017 */     // MIs[2] Operand 1
     /* 205017 */     // No operand predicates
     /* 205017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205019 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1525:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 205019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 205022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205031 */     GIR_RootConstrainSelectedInstOperands,
     /* 205032 */     // GIR_Coverage, 7817,
     /* 205032 */     GIR_EraseRootFromParent_Done,
     /* 205033 */   // Label 4061: @205033
     /* 205033 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(205110), // Rule ID 7818 //
     /* 205038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 205046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205090 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205094 */     // MIs[2] Operand 1
     /* 205094 */     // No operand predicates
     /* 205094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205096 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1525:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 205096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 205099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205108 */     GIR_RootConstrainSelectedInstOperands,
     /* 205109 */     // GIR_Coverage, 7818,
     /* 205109 */     GIR_EraseRootFromParent_Done,
     /* 205110 */   // Label 4062: @205110
     /* 205110 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(205187), // Rule ID 7819 //
     /* 205115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 205123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205167 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205171 */     // MIs[2] Operand 1
     /* 205171 */     // No operand predicates
     /* 205171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205173 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1525:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 205173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 205176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205185 */     GIR_RootConstrainSelectedInstOperands,
     /* 205186 */     // GIR_Coverage, 7819,
     /* 205186 */     GIR_EraseRootFromParent_Done,
     /* 205187 */   // Label 4063: @205187
     /* 205187 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(205264), // Rule ID 7820 //
     /* 205192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 205200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205244 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205248 */     // MIs[2] Operand 1
     /* 205248 */     // No operand predicates
     /* 205248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205250 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1525:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 205250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 205253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205262 */     GIR_RootConstrainSelectedInstOperands,
     /* 205263 */     // GIR_Coverage, 7820,
     /* 205263 */     GIR_EraseRootFromParent_Done,
     /* 205264 */   // Label 4064: @205264
     /* 205264 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(205341), // Rule ID 7821 //
     /* 205269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 205277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205313 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205317 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205321 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205325 */     // MIs[2] Operand 1
     /* 205325 */     // No operand predicates
     /* 205325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205327 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1525:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 205327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 205330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205339 */     GIR_RootConstrainSelectedInstOperands,
     /* 205340 */     // GIR_Coverage, 7821,
     /* 205340 */     GIR_EraseRootFromParent_Done,
     /* 205341 */   // Label 4065: @205341
     /* 205341 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(205418), // Rule ID 7822 //
     /* 205346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205374 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205398 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205402 */     // MIs[2] Operand 1
     /* 205402 */     // No operand predicates
     /* 205402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205404 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1463:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 205404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 205407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205416 */     GIR_RootConstrainSelectedInstOperands,
     /* 205417 */     // GIR_Coverage, 7822,
     /* 205417 */     GIR_EraseRootFromParent_Done,
     /* 205418 */   // Label 4066: @205418
     /* 205418 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(205495), // Rule ID 7823 //
     /* 205423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205475 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 205479 */     // MIs[2] Operand 1
     /* 205479 */     // No operand predicates
     /* 205479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205481 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1463:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 205481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 205484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205493 */     GIR_RootConstrainSelectedInstOperands,
     /* 205494 */     // GIR_Coverage, 7823,
     /* 205494 */     GIR_EraseRootFromParent_Done,
     /* 205495 */   // Label 4067: @205495
     /* 205495 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(205572), // Rule ID 7824 //
     /* 205500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205552 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205556 */     // MIs[2] Operand 1
     /* 205556 */     // No operand predicates
     /* 205556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205558 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1463:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 205558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 205561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205570 */     GIR_RootConstrainSelectedInstOperands,
     /* 205571 */     // GIR_Coverage, 7824,
     /* 205571 */     GIR_EraseRootFromParent_Done,
     /* 205572 */   // Label 4068: @205572
     /* 205572 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(205649), // Rule ID 7825 //
     /* 205577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 205621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205629 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 205633 */     // MIs[2] Operand 1
     /* 205633 */     // No operand predicates
     /* 205633 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205635 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1463:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 205635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 205638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205647 */     GIR_RootConstrainSelectedInstOperands,
     /* 205648 */     // GIR_Coverage, 7825,
     /* 205648 */     GIR_EraseRootFromParent_Done,
     /* 205649 */   // Label 4069: @205649
     /* 205649 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(205726), // Rule ID 7826 //
     /* 205654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205706 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205710 */     // MIs[2] Operand 1
     /* 205710 */     // No operand predicates
     /* 205710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205712 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1463:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 205712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 205715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205724 */     GIR_RootConstrainSelectedInstOperands,
     /* 205725 */     // GIR_Coverage, 7826,
     /* 205725 */     GIR_EraseRootFromParent_Done,
     /* 205726 */   // Label 4070: @205726
     /* 205726 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(205803), // Rule ID 7827 //
     /* 205731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 205739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 205745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 205751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 205775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205783 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 205787 */     // MIs[2] Operand 1
     /* 205787 */     // No operand predicates
     /* 205787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205789 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1463:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 205789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 205792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205801 */     GIR_RootConstrainSelectedInstOperands,
     /* 205802 */     // GIR_Coverage, 7827,
     /* 205802 */     GIR_EraseRootFromParent_Done,
     /* 205803 */   // Label 4071: @205803
     /* 205803 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(205880), // Rule ID 7828 //
     /* 205808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205848 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205860 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 205864 */     // MIs[2] Operand 1
     /* 205864 */     // No operand predicates
     /* 205864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205866 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1527:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 205866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 205869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 205878 */     GIR_RootConstrainSelectedInstOperands,
     /* 205879 */     // GIR_Coverage, 7828,
     /* 205879 */     GIR_EraseRootFromParent_Done,
     /* 205880 */   // Label 4072: @205880
     /* 205880 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(205957), // Rule ID 7829 //
     /* 205885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 205899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 205905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 205925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 205929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 205933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 205937 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 205941 */     // MIs[2] Operand 1
     /* 205941 */     // No operand predicates
     /* 205941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 205943 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1527:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 205943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 205946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 205948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 205950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 205952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 205955 */     GIR_RootConstrainSelectedInstOperands,
     /* 205956 */     // GIR_Coverage, 7829,
     /* 205956 */     GIR_EraseRootFromParent_Done,
     /* 205957 */   // Label 4073: @205957
     /* 205957 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(206034), // Rule ID 7830 //
     /* 205962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 205970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 205976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 205982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 205990 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 205998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206014 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 206018 */     // MIs[2] Operand 1
     /* 206018 */     // No operand predicates
     /* 206018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206020 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1527:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 206020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 206023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206032 */     GIR_RootConstrainSelectedInstOperands,
     /* 206033 */     // GIR_Coverage, 7830,
     /* 206033 */     GIR_EraseRootFromParent_Done,
     /* 206034 */   // Label 4074: @206034
     /* 206034 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(206111), // Rule ID 7831 //
     /* 206039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 206047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206091 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206095 */     // MIs[2] Operand 1
     /* 206095 */     // No operand predicates
     /* 206095 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206097 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1527:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 206097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 206100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206109 */     GIR_RootConstrainSelectedInstOperands,
     /* 206110 */     // GIR_Coverage, 7831,
     /* 206110 */     GIR_EraseRootFromParent_Done,
     /* 206111 */   // Label 4075: @206111
     /* 206111 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(206188), // Rule ID 7832 //
     /* 206116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 206124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206168 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 206172 */     // MIs[2] Operand 1
     /* 206172 */     // No operand predicates
     /* 206172 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206174 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1527:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 206174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 206177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206186 */     GIR_RootConstrainSelectedInstOperands,
     /* 206187 */     // GIR_Coverage, 7832,
     /* 206187 */     GIR_EraseRootFromParent_Done,
     /* 206188 */   // Label 4076: @206188
     /* 206188 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(206265), // Rule ID 7833 //
     /* 206193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 206201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206245 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206249 */     // MIs[2] Operand 1
     /* 206249 */     // No operand predicates
     /* 206249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206251 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1527:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 206251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 206254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206263 */     GIR_RootConstrainSelectedInstOperands,
     /* 206264 */     // GIR_Coverage, 7833,
     /* 206264 */     GIR_EraseRootFromParent_Done,
     /* 206265 */   // Label 4077: @206265
     /* 206265 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(206342), // Rule ID 7834 //
     /* 206270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 206278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206322 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206326 */     // MIs[2] Operand 1
     /* 206326 */     // No operand predicates
     /* 206326 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206328 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 206328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 206331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206337 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206340 */     GIR_RootConstrainSelectedInstOperands,
     /* 206341 */     // GIR_Coverage, 7834,
     /* 206341 */     GIR_EraseRootFromParent_Done,
     /* 206342 */   // Label 4078: @206342
     /* 206342 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(206419), // Rule ID 7835 //
     /* 206347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 206355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206375 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206399 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206403 */     // MIs[2] Operand 1
     /* 206403 */     // No operand predicates
     /* 206403 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206405 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 206405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 206408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206417 */     GIR_RootConstrainSelectedInstOperands,
     /* 206418 */     // GIR_Coverage, 7835,
     /* 206418 */     GIR_EraseRootFromParent_Done,
     /* 206419 */   // Label 4079: @206419
     /* 206419 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(206496), // Rule ID 7836 //
     /* 206424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 206432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206468 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206472 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206476 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206480 */     // MIs[2] Operand 1
     /* 206480 */     // No operand predicates
     /* 206480 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206482 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 206482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 206485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206494 */     GIR_RootConstrainSelectedInstOperands,
     /* 206495 */     // GIR_Coverage, 7836,
     /* 206495 */     GIR_EraseRootFromParent_Done,
     /* 206496 */   // Label 4080: @206496
     /* 206496 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(206573), // Rule ID 7837 //
     /* 206501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 206509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206525 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206553 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206557 */     // MIs[2] Operand 1
     /* 206557 */     // No operand predicates
     /* 206557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206559 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 206559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 206562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206571 */     GIR_RootConstrainSelectedInstOperands,
     /* 206572 */     // GIR_Coverage, 7837,
     /* 206572 */     GIR_EraseRootFromParent_Done,
     /* 206573 */   // Label 4081: @206573
     /* 206573 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(206650), // Rule ID 7838 //
     /* 206578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 206586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206630 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206634 */     // MIs[2] Operand 1
     /* 206634 */     // No operand predicates
     /* 206634 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206636 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 206636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 206639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206648 */     GIR_RootConstrainSelectedInstOperands,
     /* 206649 */     // GIR_Coverage, 7838,
     /* 206649 */     GIR_EraseRootFromParent_Done,
     /* 206650 */   // Label 4082: @206650
     /* 206650 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(206727), // Rule ID 7839 //
     /* 206655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 206663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 206669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 206675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 206699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206707 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206711 */     // MIs[2] Operand 1
     /* 206711 */     // No operand predicates
     /* 206711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206713 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1417:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 206713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 206716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206725 */     GIR_RootConstrainSelectedInstOperands,
     /* 206726 */     // GIR_Coverage, 7839,
     /* 206726 */     GIR_EraseRootFromParent_Done,
     /* 206727 */   // Label 4083: @206727
     /* 206727 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(206804), // Rule ID 7840 //
     /* 206732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206784 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206788 */     // MIs[2] Operand 1
     /* 206788 */     // No operand predicates
     /* 206788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206790 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 206790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 206793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206802 */     GIR_RootConstrainSelectedInstOperands,
     /* 206803 */     // GIR_Coverage, 7840,
     /* 206803 */     GIR_EraseRootFromParent_Done,
     /* 206804 */   // Label 4084: @206804
     /* 206804 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(206881), // Rule ID 7841 //
     /* 206809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 206823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 206829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 206853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206861 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 206865 */     // MIs[2] Operand 1
     /* 206865 */     // No operand predicates
     /* 206865 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206867 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 206867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 206870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 206879 */     GIR_RootConstrainSelectedInstOperands,
     /* 206880 */     // GIR_Coverage, 7841,
     /* 206880 */     GIR_EraseRootFromParent_Done,
     /* 206881 */   // Label 4085: @206881
     /* 206881 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(206958), // Rule ID 7842 //
     /* 206886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 206926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 206930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 206934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 206938 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 206942 */     // MIs[2] Operand 1
     /* 206942 */     // No operand predicates
     /* 206942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 206944 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 206944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 206947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 206951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 206953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 206956 */     GIR_RootConstrainSelectedInstOperands,
     /* 206957 */     // GIR_Coverage, 7842,
     /* 206957 */     GIR_EraseRootFromParent_Done,
     /* 206958 */   // Label 4086: @206958
     /* 206958 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(207035), // Rule ID 7843 //
     /* 206963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 206971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 206977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 206983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 206991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 206999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207015 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207019 */     // MIs[2] Operand 1
     /* 207019 */     // No operand predicates
     /* 207019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207021 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 207021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 207024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207033 */     GIR_RootConstrainSelectedInstOperands,
     /* 207034 */     // GIR_Coverage, 7843,
     /* 207034 */     GIR_EraseRootFromParent_Done,
     /* 207035 */   // Label 4087: @207035
     /* 207035 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(207112), // Rule ID 7844 //
     /* 207040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 207048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207092 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207096 */     // MIs[2] Operand 1
     /* 207096 */     // No operand predicates
     /* 207096 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207098 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 207098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 207101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207110 */     GIR_RootConstrainSelectedInstOperands,
     /* 207111 */     // GIR_Coverage, 7844,
     /* 207111 */     GIR_EraseRootFromParent_Done,
     /* 207112 */   // Label 4088: @207112
     /* 207112 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(207189), // Rule ID 7845 //
     /* 207117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 207125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207169 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207173 */     // MIs[2] Operand 1
     /* 207173 */     // No operand predicates
     /* 207173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207175 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1435:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 207175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 207178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207187 */     GIR_RootConstrainSelectedInstOperands,
     /* 207188 */     // GIR_Coverage, 7845,
     /* 207188 */     GIR_EraseRootFromParent_Done,
     /* 207189 */   // Label 4089: @207189
     /* 207189 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(207266), // Rule ID 7846 //
     /* 207194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 207202 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207205 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207208 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207211 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207246 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207250 */     // MIs[2] Operand 1
     /* 207250 */     // No operand predicates
     /* 207250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207252 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1411:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 207252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 207255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207261 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207264 */     GIR_RootConstrainSelectedInstOperands,
     /* 207265 */     // GIR_Coverage, 7846,
     /* 207265 */     GIR_EraseRootFromParent_Done,
     /* 207266 */   // Label 4090: @207266
     /* 207266 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(207343), // Rule ID 7847 //
     /* 207271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 207279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207323 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207327 */     // MIs[2] Operand 1
     /* 207327 */     // No operand predicates
     /* 207327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207329 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1411:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 207329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 207332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207341 */     GIR_RootConstrainSelectedInstOperands,
     /* 207342 */     // GIR_Coverage, 7847,
     /* 207342 */     GIR_EraseRootFromParent_Done,
     /* 207343 */   // Label 4091: @207343
     /* 207343 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(207420), // Rule ID 7848 //
     /* 207348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 207356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207376 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207392 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207396 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207400 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207404 */     // MIs[2] Operand 1
     /* 207404 */     // No operand predicates
     /* 207404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207406 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1411:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 207406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 207409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207418 */     GIR_RootConstrainSelectedInstOperands,
     /* 207419 */     // GIR_Coverage, 7848,
     /* 207419 */     GIR_EraseRootFromParent_Done,
     /* 207420 */   // Label 4092: @207420
     /* 207420 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(207497), // Rule ID 7849 //
     /* 207425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 207433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207477 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207481 */     // MIs[2] Operand 1
     /* 207481 */     // No operand predicates
     /* 207481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207483 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1411:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 207483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 207486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207495 */     GIR_RootConstrainSelectedInstOperands,
     /* 207496 */     // GIR_Coverage, 7849,
     /* 207496 */     GIR_EraseRootFromParent_Done,
     /* 207497 */   // Label 4093: @207497
     /* 207497 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(207574), // Rule ID 7850 //
     /* 207502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 207510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207554 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207558 */     // MIs[2] Operand 1
     /* 207558 */     // No operand predicates
     /* 207558 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207560 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1411:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 207560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 207563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207567 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207572 */     GIR_RootConstrainSelectedInstOperands,
     /* 207573 */     // GIR_Coverage, 7850,
     /* 207573 */     GIR_EraseRootFromParent_Done,
     /* 207574 */   // Label 4094: @207574
     /* 207574 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(207651), // Rule ID 7851 //
     /* 207579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 207587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 207623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207631 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207635 */     // MIs[2] Operand 1
     /* 207635 */     // No operand predicates
     /* 207635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207637 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1411:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 207637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 207640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207646 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207649 */     GIR_RootConstrainSelectedInstOperands,
     /* 207650 */     // GIR_Coverage, 7851,
     /* 207650 */     GIR_EraseRootFromParent_Done,
     /* 207651 */   // Label 4095: @207651
     /* 207651 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(207728), // Rule ID 7852 //
     /* 207656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207708 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207712 */     // MIs[2] Operand 1
     /* 207712 */     // No operand predicates
     /* 207712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207714 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1429:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 207714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 207717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207726 */     GIR_RootConstrainSelectedInstOperands,
     /* 207727 */     // GIR_Coverage, 7852,
     /* 207727 */     GIR_EraseRootFromParent_Done,
     /* 207728 */   // Label 4096: @207728
     /* 207728 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(207805), // Rule ID 7853 //
     /* 207733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 207747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207750 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 207753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207761 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 207777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207785 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207789 */     // MIs[2] Operand 1
     /* 207789 */     // No operand predicates
     /* 207789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207791 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1429:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 207791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 207794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207803 */     GIR_RootConstrainSelectedInstOperands,
     /* 207804 */     // GIR_Coverage, 7853,
     /* 207804 */     GIR_EraseRootFromParent_Done,
     /* 207805 */   // Label 4097: @207805
     /* 207805 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(207882), // Rule ID 7854 //
     /* 207810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207862 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 207866 */     // MIs[2] Operand 1
     /* 207866 */     // No operand predicates
     /* 207866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207868 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1429:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 207868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 207871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 207880 */     GIR_RootConstrainSelectedInstOperands,
     /* 207881 */     // GIR_Coverage, 7854,
     /* 207881 */     GIR_EraseRootFromParent_Done,
     /* 207882 */   // Label 4098: @207882
     /* 207882 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(207959), // Rule ID 7855 //
     /* 207887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 207901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207904 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 207907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 207923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 207927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 207931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 207935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 207939 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 207943 */     // MIs[2] Operand 1
     /* 207943 */     // No operand predicates
     /* 207943 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 207945 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1429:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 207945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 207948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 207950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 207952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 207954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 207957 */     GIR_RootConstrainSelectedInstOperands,
     /* 207958 */     // GIR_Coverage, 7855,
     /* 207958 */     GIR_EraseRootFromParent_Done,
     /* 207959 */   // Label 4099: @207959
     /* 207959 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(208036), // Rule ID 7856 //
     /* 207964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 207967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 207972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 207978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 207984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 207992 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 208008 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208012 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208016 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 208020 */     // MIs[2] Operand 1
     /* 208020 */     // No operand predicates
     /* 208020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208022 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1429:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 208022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 208025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 208034 */     GIR_RootConstrainSelectedInstOperands,
     /* 208035 */     // GIR_Coverage, 7856,
     /* 208035 */     GIR_EraseRootFromParent_Done,
     /* 208036 */   // Label 4100: @208036
     /* 208036 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(208113), // Rule ID 7857 //
     /* 208041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 208049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 208055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 208061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 208069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 208077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 208081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 208085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 208089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 208093 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 208097 */     // MIs[2] Operand 1
     /* 208097 */     // No operand predicates
     /* 208097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 208099 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1429:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 208099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 208102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 208106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 208108 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 208111 */     GIR_RootConstrainSelectedInstOperands,
     /* 208112 */     // GIR_Coverage, 7857,
     /* 208112 */     GIR_EraseRootFromParent_Done,
     /* 208113 */   // Label 4101: @208113
     /* 208113 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(208169), // Rule ID 55 //
     /* 208118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 208121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 208126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 208129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 208135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 208139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 208143 */     // MIs[0] Operand 3
     /* 208143 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 208154 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 208158 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 208158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
     /* 208161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 208167 */     GIR_RootConstrainSelectedInstOperands,
     /* 208168 */     // GIR_Coverage, 55,
     /* 208168 */     GIR_EraseRootFromParent_Done,
     /* 208169 */   // Label 4102: @208169
     /* 208169 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(208225), // Rule ID 56 //
     /* 208174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 208177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 208182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 208185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 208191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 208195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 208199 */     // MIs[0] Operand 3
     /* 208199 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 208210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 208214 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 208214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
     /* 208217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208221 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 208223 */     GIR_RootConstrainSelectedInstOperands,
     /* 208224 */     // GIR_Coverage, 56,
     /* 208224 */     GIR_EraseRootFromParent_Done,
     /* 208225 */   // Label 4103: @208225
     /* 208225 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(208281), // Rule ID 57 //
     /* 208230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 208233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 208238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 208241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 208247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 208251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 208255 */     // MIs[0] Operand 3
     /* 208255 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 208266 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 208270 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 208270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
     /* 208273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208277 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 208279 */     GIR_RootConstrainSelectedInstOperands,
     /* 208280 */     // GIR_Coverage, 57,
     /* 208280 */     GIR_EraseRootFromParent_Done,
     /* 208281 */   // Label 4104: @208281
     /* 208281 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(208337), // Rule ID 58 //
     /* 208286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 208289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 208294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 208297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 208300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 208303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 208307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 208311 */     // MIs[0] Operand 3
     /* 208311 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 208322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 208326 */     // (intrinsic_wo_chain:{ *:[i64] } 296:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 208326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
     /* 208329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 208331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 208333 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 208335 */     GIR_RootConstrainSelectedInstOperands,
     /* 208336 */     // GIR_Coverage, 58,
     /* 208336 */     GIR_EraseRootFromParent_Done,
     /* 208337 */   // Label 4105: @208337
     /* 208337 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(208392), // Rule ID 2797 //
     /* 208342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 208345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 208350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208371 */     // MIs[0] imm
     /* 208371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208374 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 208379 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1528:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 208379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
     /* 208382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 208386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 208388 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 208390 */     GIR_RootConstrainSelectedInstOperands,
     /* 208391 */     // GIR_Coverage, 2797,
     /* 208391 */     GIR_EraseRootFromParent_Done,
     /* 208392 */   // Label 4106: @208392
     /* 208392 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(208447), // Rule ID 2798 //
     /* 208397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 208400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 208405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208422 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208426 */     // MIs[0] imm
     /* 208426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208429 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 208434 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1528:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 208434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
     /* 208437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 208441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 208443 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 208445 */     GIR_RootConstrainSelectedInstOperands,
     /* 208446 */     // GIR_Coverage, 2798,
     /* 208446 */     GIR_EraseRootFromParent_Done,
     /* 208447 */   // Label 4107: @208447
     /* 208447 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(208502), // Rule ID 2799 //
     /* 208452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 208455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 208460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208481 */     // MIs[0] imm
     /* 208481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208484 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 208489 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1528:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 208489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
     /* 208492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 208494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 208496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 208498 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 208500 */     GIR_RootConstrainSelectedInstOperands,
     /* 208501 */     // GIR_Coverage, 2799,
     /* 208501 */     GIR_EraseRootFromParent_Done,
     /* 208502 */   // Label 4108: @208502
     /* 208502 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(208557), // Rule ID 3550 //
     /* 208507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 208510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 208515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 208524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208536 */     // MIs[0] Idx
     /* 208536 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208539 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
     /* 208544 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1614:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 208544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 208547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 208551 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 208553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 208555 */     GIR_RootConstrainSelectedInstOperands,
     /* 208556 */     // GIR_Coverage, 3550,
     /* 208556 */     GIR_EraseRootFromParent_Done,
     /* 208557 */   // Label 4109: @208557
     /* 208557 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(208612), // Rule ID 3551 //
     /* 208562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 208565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 208570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 208579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208591 */     // MIs[0] Idx
     /* 208591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208594 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
     /* 208599 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1614:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 208599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 208602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 208606 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 208608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 208610 */     GIR_RootConstrainSelectedInstOperands,
     /* 208611 */     // GIR_Coverage, 3551,
     /* 208611 */     GIR_EraseRootFromParent_Done,
     /* 208612 */   // Label 4110: @208612
     /* 208612 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(208667), // Rule ID 3552 //
     /* 208617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 208620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 208625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208631 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 208634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 208646 */     // MIs[0] Idx
     /* 208646 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208649 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
     /* 208654 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1614:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 208654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 208657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 208661 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 208663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 208665 */     GIR_RootConstrainSelectedInstOperands,
     /* 208666 */     // GIR_Coverage, 3552,
     /* 208666 */     GIR_EraseRootFromParent_Done,
     /* 208667 */   // Label 4111: @208667
     /* 208667 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(208722), // Rule ID 3832 //
     /* 208672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 208675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
     /* 208680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 208683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 208686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 208689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 208701 */     // MIs[0] imm
     /* 208701 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208704 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
     /* 208709 */     // (intrinsic_wo_chain:{ *:[v2i64] } 543:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
     /* 208709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
     /* 208712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 208714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 208716 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 208718 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 208720 */     GIR_RootConstrainSelectedInstOperands,
     /* 208721 */     // GIR_Coverage, 3832,
     /* 208721 */     GIR_EraseRootFromParent_Done,
     /* 208722 */   // Label 4112: @208722
     /* 208722 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(208769), // Rule ID 2851 //
     /* 208727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 208735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208748 */     // MIs[0] idx
     /* 208748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208751 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 208756 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1464:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 208756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 208759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208765 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 208767 */     GIR_RootConstrainSelectedInstOperands,
     /* 208768 */     // GIR_Coverage, 2851,
     /* 208768 */     GIR_EraseRootFromParent_Done,
     /* 208769 */   // Label 4113: @208769
     /* 208769 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(208816), // Rule ID 2852 //
     /* 208774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 208782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208795 */     // MIs[0] idx
     /* 208795 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208798 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 208803 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1464:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 208803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 208806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208812 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 208814 */     GIR_RootConstrainSelectedInstOperands,
     /* 208815 */     // GIR_Coverage, 2852,
     /* 208815 */     GIR_EraseRootFromParent_Done,
     /* 208816 */   // Label 4114: @208816
     /* 208816 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(208863), // Rule ID 2853 //
     /* 208821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 208824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 208829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208842 */     // MIs[0] idx
     /* 208842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208845 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 208850 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1464:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 208850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 208853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208859 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 208861 */     GIR_RootConstrainSelectedInstOperands,
     /* 208862 */     // GIR_Coverage, 2853,
     /* 208862 */     GIR_EraseRootFromParent_Done,
     /* 208863 */   // Label 4115: @208863
     /* 208863 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(208910), // Rule ID 3002 //
     /* 208868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 208876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208889 */     // MIs[0] Op3
     /* 208889 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208892 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 208897 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1595:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 208897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
     /* 208900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208906 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208908 */     GIR_RootConstrainSelectedInstOperands,
     /* 208909 */     // GIR_Coverage, 3002,
     /* 208909 */     GIR_EraseRootFromParent_Done,
     /* 208910 */   // Label 4116: @208910
     /* 208910 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(208957), // Rule ID 3003 //
     /* 208915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 208923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208936 */     // MIs[0] Op3
     /* 208936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208939 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 208944 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1595:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 208944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
     /* 208947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208953 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 208955 */     GIR_RootConstrainSelectedInstOperands,
     /* 208956 */     // GIR_Coverage, 3003,
     /* 208956 */     GIR_EraseRootFromParent_Done,
     /* 208957 */   // Label 4117: @208957
     /* 208957 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(209004), // Rule ID 3004 //
     /* 208962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 208970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 208976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 208979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208983 */     // MIs[0] Op3
     /* 208983 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 208986 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 208991 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1595:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 208991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
     /* 208994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209002 */     GIR_RootConstrainSelectedInstOperands,
     /* 209003 */     // GIR_Coverage, 3004,
     /* 209003 */     GIR_EraseRootFromParent_Done,
     /* 209004 */   // Label 4118: @209004
     /* 209004 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(209051), // Rule ID 3005 //
     /* 209009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 209017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209030 */     // MIs[0] Op3
     /* 209030 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209033 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209038 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1741:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
     /* 209041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209047 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209049 */     GIR_RootConstrainSelectedInstOperands,
     /* 209050 */     // GIR_Coverage, 3005,
     /* 209050 */     GIR_EraseRootFromParent_Done,
     /* 209051 */   // Label 4119: @209051
     /* 209051 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(209098), // Rule ID 3006 //
     /* 209056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 209064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209077 */     // MIs[0] Op3
     /* 209077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209080 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 209085 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1741:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 209085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
     /* 209088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209096 */     GIR_RootConstrainSelectedInstOperands,
     /* 209097 */     // GIR_Coverage, 3006,
     /* 209097 */     GIR_EraseRootFromParent_Done,
     /* 209098 */   // Label 4120: @209098
     /* 209098 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(209145), // Rule ID 3054 //
     /* 209103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 209111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209124 */     // MIs[0] Op3
     /* 209124 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209127 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 209132 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1852:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 209132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
     /* 209135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 209137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209141 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209143 */     GIR_RootConstrainSelectedInstOperands,
     /* 209144 */     // GIR_Coverage, 3054,
     /* 209144 */     GIR_EraseRootFromParent_Done,
     /* 209145 */   // Label 4121: @209145
     /* 209145 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(209192), // Rule ID 3056 //
     /* 209150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 209158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209171 */     // MIs[0] Op3
     /* 209171 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209174 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 209179 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1852:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 209179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
     /* 209182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 209184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209188 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209190 */     GIR_RootConstrainSelectedInstOperands,
     /* 209191 */     // GIR_Coverage, 3056,
     /* 209191 */     GIR_EraseRootFromParent_Done,
     /* 209192 */   // Label 4122: @209192
     /* 209192 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(209239), // Rule ID 3058 //
     /* 209197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 209205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209218 */     // MIs[0] Op3
     /* 209218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209221 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 209226 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1852:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 209226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
     /* 209229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 209231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209235 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209237 */     GIR_RootConstrainSelectedInstOperands,
     /* 209238 */     // GIR_Coverage, 3058,
     /* 209238 */     GIR_EraseRootFromParent_Done,
     /* 209239 */   // Label 4123: @209239
     /* 209239 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(209286), // Rule ID 3060 //
     /* 209244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209247 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 209252 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209265 */     // MIs[0] Op3
     /* 209265 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209268 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 209273 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1852:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 209273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
     /* 209276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 209278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209284 */     GIR_RootConstrainSelectedInstOperands,
     /* 209285 */     // GIR_Coverage, 3060,
     /* 209285 */     GIR_EraseRootFromParent_Done,
     /* 209286 */   // Label 4124: @209286
     /* 209286 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(209333), // Rule ID 3082 //
     /* 209291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 209299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209312 */     // MIs[0] Op3
     /* 209312 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209315 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 209320 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1832:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 209320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
     /* 209323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209329 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209331 */     GIR_RootConstrainSelectedInstOperands,
     /* 209332 */     // GIR_Coverage, 3082,
     /* 209332 */     GIR_EraseRootFromParent_Done,
     /* 209333 */   // Label 4125: @209333
     /* 209333 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(209380), // Rule ID 3083 //
     /* 209338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 209346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209359 */     // MIs[0] Op3
     /* 209359 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209362 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 209367 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1832:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 209367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
     /* 209370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209376 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209378 */     GIR_RootConstrainSelectedInstOperands,
     /* 209379 */     // GIR_Coverage, 3083,
     /* 209379 */     GIR_EraseRootFromParent_Done,
     /* 209380 */   // Label 4126: @209380
     /* 209380 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(209427), // Rule ID 3084 //
     /* 209385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 209393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209406 */     // MIs[0] Op3
     /* 209406 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209409 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 209414 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1832:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 209414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
     /* 209417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209423 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209425 */     GIR_RootConstrainSelectedInstOperands,
     /* 209426 */     // GIR_Coverage, 3084,
     /* 209426 */     GIR_EraseRootFromParent_Done,
     /* 209427 */   // Label 4127: @209427
     /* 209427 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(209474), // Rule ID 3153 //
     /* 209432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 209440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209453 */     // MIs[0] Op3
     /* 209453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209456 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 209461 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2133:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 209461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
     /* 209464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209470 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209472 */     GIR_RootConstrainSelectedInstOperands,
     /* 209473 */     // GIR_Coverage, 3153,
     /* 209473 */     GIR_EraseRootFromParent_Done,
     /* 209474 */   // Label 4128: @209474
     /* 209474 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(209521), // Rule ID 3154 //
     /* 209479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 209487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209500 */     // MIs[0] Op3
     /* 209500 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209503 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 209508 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2133:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 209508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
     /* 209511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209519 */     GIR_RootConstrainSelectedInstOperands,
     /* 209520 */     // GIR_Coverage, 3154,
     /* 209520 */     GIR_EraseRootFromParent_Done,
     /* 209521 */   // Label 4129: @209521
     /* 209521 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(209568), // Rule ID 3155 //
     /* 209526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 209534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209547 */     // MIs[0] Op3
     /* 209547 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209550 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 209555 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2133:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 209555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
     /* 209558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209564 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209566 */     GIR_RootConstrainSelectedInstOperands,
     /* 209567 */     // GIR_Coverage, 3155,
     /* 209567 */     GIR_EraseRootFromParent_Done,
     /* 209568 */   // Label 4130: @209568
     /* 209568 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(209615), // Rule ID 3156 //
     /* 209573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 209581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 209590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209594 */     // MIs[0] Op3
     /* 209594 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209597 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 209602 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2133:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 209602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
     /* 209605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209611 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209613 */     GIR_RootConstrainSelectedInstOperands,
     /* 209614 */     // GIR_Coverage, 3156,
     /* 209614 */     GIR_EraseRootFromParent_Done,
     /* 209615 */   // Label 4131: @209615
     /* 209615 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(209662), // Rule ID 3535 //
     /* 209620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 209623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
     /* 209628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209641 */     // MIs[0] Op3
     /* 209641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209644 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
     /* 209649 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1343:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
     /* 209649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
     /* 209652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 209654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209658 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209660 */     GIR_RootConstrainSelectedInstOperands,
     /* 209661 */     // GIR_Coverage, 3535,
     /* 209661 */     GIR_EraseRootFromParent_Done,
     /* 209662 */   // Label 4132: @209662
     /* 209662 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(209709), // Rule ID 3583 //
     /* 209667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 209675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209688 */     // MIs[0] Op3
     /* 209688 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209691 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 209696 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1582:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 209696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
     /* 209699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209705 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209707 */     GIR_RootConstrainSelectedInstOperands,
     /* 209708 */     // GIR_Coverage, 3583,
     /* 209708 */     GIR_EraseRootFromParent_Done,
     /* 209709 */   // Label 4133: @209709
     /* 209709 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(209756), // Rule ID 3584 //
     /* 209714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 209722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209728 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209735 */     // MIs[0] Op3
     /* 209735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209738 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 209743 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1582:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 209743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 209746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209752 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209754 */     GIR_RootConstrainSelectedInstOperands,
     /* 209755 */     // GIR_Coverage, 3584,
     /* 209755 */     GIR_EraseRootFromParent_Done,
     /* 209756 */   // Label 4134: @209756
     /* 209756 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(209803), // Rule ID 3585 //
     /* 209761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 209769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209782 */     // MIs[0] Op3
     /* 209782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 209790 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1582:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 209790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 209793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209799 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209801 */     GIR_RootConstrainSelectedInstOperands,
     /* 209802 */     // GIR_Coverage, 3585,
     /* 209802 */     GIR_EraseRootFromParent_Done,
     /* 209803 */   // Label 4135: @209803
     /* 209803 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(209850), // Rule ID 3586 //
     /* 209808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 209816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 209819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209829 */     // MIs[0] Op3
     /* 209829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209832 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 209837 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1583:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
     /* 209837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
     /* 209840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209846 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209848 */     GIR_RootConstrainSelectedInstOperands,
     /* 209849 */     // GIR_Coverage, 3586,
     /* 209849 */     GIR_EraseRootFromParent_Done,
     /* 209850 */   // Label 4136: @209850
     /* 209850 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(209897), // Rule ID 3587 //
     /* 209855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 209863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209876 */     // MIs[0] Op3
     /* 209876 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209879 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 209884 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1583:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 209884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 209887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209893 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209895 */     GIR_RootConstrainSelectedInstOperands,
     /* 209896 */     // GIR_Coverage, 3587,
     /* 209896 */     GIR_EraseRootFromParent_Done,
     /* 209897 */   // Label 4137: @209897
     /* 209897 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(209944), // Rule ID 3588 //
     /* 209902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 209905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 209910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209923 */     // MIs[0] Op3
     /* 209923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209926 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 209931 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1583:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 209931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 209934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209940 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209942 */     GIR_RootConstrainSelectedInstOperands,
     /* 209943 */     // GIR_Coverage, 3588,
     /* 209943 */     GIR_EraseRootFromParent_Done,
     /* 209944 */   // Label 4138: @209944
     /* 209944 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(209991), // Rule ID 11254 //
     /* 209949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 209957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209970 */     // MIs[0] Op3
     /* 209970 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 209973 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 209978 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1782:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 209978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
     /* 209981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209987 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 209989 */     GIR_RootConstrainSelectedInstOperands,
     /* 209990 */     // GIR_Coverage, 11254,
     /* 209990 */     GIR_EraseRootFromParent_Done,
     /* 209991 */   // Label 4139: @209991
     /* 209991 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(210038), // Rule ID 11255 //
     /* 209996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 210004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210017 */     // MIs[0] Op3
     /* 210017 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210020 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210025 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1782:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
     /* 210028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210036 */     GIR_RootConstrainSelectedInstOperands,
     /* 210037 */     // GIR_Coverage, 11255,
     /* 210037 */     GIR_EraseRootFromParent_Done,
     /* 210038 */   // Label 4140: @210038
     /* 210038 */   GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(210085), // Rule ID 11256 //
     /* 210043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 210051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210064 */     // MIs[0] Op3
     /* 210064 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210067 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 210072 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1782:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 210072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
     /* 210075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210081 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210083 */     GIR_RootConstrainSelectedInstOperands,
     /* 210084 */     // GIR_Coverage, 11256,
     /* 210084 */     GIR_EraseRootFromParent_Done,
     /* 210085 */   // Label 4141: @210085
     /* 210085 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(210132), // Rule ID 11257 //
     /* 210090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 210098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210111 */     // MIs[0] Op3
     /* 210111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210114 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210119 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1813:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
     /* 210122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210128 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210130 */     GIR_RootConstrainSelectedInstOperands,
     /* 210131 */     // GIR_Coverage, 11257,
     /* 210131 */     GIR_EraseRootFromParent_Done,
     /* 210132 */   // Label 4142: @210132
     /* 210132 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(210179), // Rule ID 11258 //
     /* 210137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 210145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210158 */     // MIs[0] Op3
     /* 210158 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210161 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210166 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1813:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
     /* 210169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210177 */     GIR_RootConstrainSelectedInstOperands,
     /* 210178 */     // GIR_Coverage, 11258,
     /* 210178 */     GIR_EraseRootFromParent_Done,
     /* 210179 */   // Label 4143: @210179
     /* 210179 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(210226), // Rule ID 11259 //
     /* 210184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 210192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210205 */     // MIs[0] Op3
     /* 210205 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210208 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 210213 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1813:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 210213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
     /* 210216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210222 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210224 */     GIR_RootConstrainSelectedInstOperands,
     /* 210225 */     // GIR_Coverage, 11259,
     /* 210225 */     GIR_EraseRootFromParent_Done,
     /* 210226 */   // Label 4144: @210226
     /* 210226 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(210273), // Rule ID 11282 //
     /* 210231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 210239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210252 */     // MIs[0] Op3
     /* 210252 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210255 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210260 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1743:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
     /* 210263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210269 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210271 */     GIR_RootConstrainSelectedInstOperands,
     /* 210272 */     // GIR_Coverage, 11282,
     /* 210272 */     GIR_EraseRootFromParent_Done,
     /* 210273 */   // Label 4145: @210273
     /* 210273 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(210320), // Rule ID 11283 //
     /* 210278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 210286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210299 */     // MIs[0] Op3
     /* 210299 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210302 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210307 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1743:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
     /* 210310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210316 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210318 */     GIR_RootConstrainSelectedInstOperands,
     /* 210319 */     // GIR_Coverage, 11283,
     /* 210319 */     GIR_EraseRootFromParent_Done,
     /* 210320 */   // Label 4146: @210320
     /* 210320 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(210367), // Rule ID 11284 //
     /* 210325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 210333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210346 */     // MIs[0] Op3
     /* 210346 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210349 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210354 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1979:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
     /* 210357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210363 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210365 */     GIR_RootConstrainSelectedInstOperands,
     /* 210366 */     // GIR_Coverage, 11284,
     /* 210366 */     GIR_EraseRootFromParent_Done,
     /* 210367 */   // Label 4147: @210367
     /* 210367 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(210414), // Rule ID 11285 //
     /* 210372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 210380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210393 */     // MIs[0] Op3
     /* 210393 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210396 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210401 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1979:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
     /* 210404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210410 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210412 */     GIR_RootConstrainSelectedInstOperands,
     /* 210413 */     // GIR_Coverage, 11285,
     /* 210413 */     GIR_EraseRootFromParent_Done,
     /* 210414 */   // Label 4148: @210414
     /* 210414 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(210461), // Rule ID 11286 //
     /* 210419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 210427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210440 */     // MIs[0] Op3
     /* 210440 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210443 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210448 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1981:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
     /* 210451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210457 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210459 */     GIR_RootConstrainSelectedInstOperands,
     /* 210460 */     // GIR_Coverage, 11286,
     /* 210460 */     GIR_EraseRootFromParent_Done,
     /* 210461 */   // Label 4149: @210461
     /* 210461 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(210508), // Rule ID 11287 //
     /* 210466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 210474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210487 */     // MIs[0] Op3
     /* 210487 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210490 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210495 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1981:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
     /* 210498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210504 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210506 */     GIR_RootConstrainSelectedInstOperands,
     /* 210507 */     // GIR_Coverage, 11287,
     /* 210507 */     GIR_EraseRootFromParent_Done,
     /* 210508 */   // Label 4150: @210508
     /* 210508 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(210555), // Rule ID 11288 //
     /* 210513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 210521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210534 */     // MIs[0] Op3
     /* 210534 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210537 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210542 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1788:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
     /* 210545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210551 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210553 */     GIR_RootConstrainSelectedInstOperands,
     /* 210554 */     // GIR_Coverage, 11288,
     /* 210554 */     GIR_EraseRootFromParent_Done,
     /* 210555 */   // Label 4151: @210555
     /* 210555 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(210602), // Rule ID 11289 //
     /* 210560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 210568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210581 */     // MIs[0] Op3
     /* 210581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210584 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210589 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1788:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
     /* 210592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210598 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210600 */     GIR_RootConstrainSelectedInstOperands,
     /* 210601 */     // GIR_Coverage, 11289,
     /* 210601 */     GIR_EraseRootFromParent_Done,
     /* 210602 */   // Label 4152: @210602
     /* 210602 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(210649), // Rule ID 11290 //
     /* 210607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 210615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210628 */     // MIs[0] Op3
     /* 210628 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210631 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 210636 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1790:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 210636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
     /* 210639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210645 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210647 */     GIR_RootConstrainSelectedInstOperands,
     /* 210648 */     // GIR_Coverage, 11290,
     /* 210648 */     GIR_EraseRootFromParent_Done,
     /* 210649 */   // Label 4153: @210649
     /* 210649 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(210696), // Rule ID 11291 //
     /* 210654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 210662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210675 */     // MIs[0] Op3
     /* 210675 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210678 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 210683 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1790:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 210683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
     /* 210686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210692 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210694 */     GIR_RootConstrainSelectedInstOperands,
     /* 210695 */     // GIR_Coverage, 11291,
     /* 210695 */     GIR_EraseRootFromParent_Done,
     /* 210696 */   // Label 4154: @210696
     /* 210696 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(210743), // Rule ID 11535 //
     /* 210701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 210709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 210715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210722 */     // MIs[0] Op3
     /* 210722 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210725 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210730 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1848:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
     /* 210733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210739 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210741 */     GIR_RootConstrainSelectedInstOperands,
     /* 210742 */     // GIR_Coverage, 11535,
     /* 210742 */     GIR_EraseRootFromParent_Done,
     /* 210743 */   // Label 4155: @210743
     /* 210743 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(210790), // Rule ID 11536 //
     /* 210748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 210756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 210762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210769 */     // MIs[0] Op3
     /* 210769 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210772 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 210777 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1848:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 210777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
     /* 210780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210788 */     GIR_RootConstrainSelectedInstOperands,
     /* 210789 */     // GIR_Coverage, 11536,
     /* 210789 */     GIR_EraseRootFromParent_Done,
     /* 210790 */   // Label 4156: @210790
     /* 210790 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(210837), // Rule ID 11537 //
     /* 210795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 210803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 210809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210816 */     // MIs[0] Op3
     /* 210816 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210819 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 210824 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1848:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 210824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
     /* 210827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210833 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210835 */     GIR_RootConstrainSelectedInstOperands,
     /* 210836 */     // GIR_Coverage, 11537,
     /* 210836 */     GIR_EraseRootFromParent_Done,
     /* 210837 */   // Label 4157: @210837
     /* 210837 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(210884), // Rule ID 11538 //
     /* 210842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 210850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 210856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210863 */     // MIs[0] Op3
     /* 210863 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210866 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 210871 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1848:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 210871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
     /* 210874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210880 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210882 */     GIR_RootConstrainSelectedInstOperands,
     /* 210883 */     // GIR_Coverage, 11538,
     /* 210883 */     GIR_EraseRootFromParent_Done,
     /* 210884 */   // Label 4158: @210884
     /* 210884 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(210931), // Rule ID 11539 //
     /* 210889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 210897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 210903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210910 */     // MIs[0] Op3
     /* 210910 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210913 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 210918 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2039:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 210918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
     /* 210921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210927 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210929 */     GIR_RootConstrainSelectedInstOperands,
     /* 210930 */     // GIR_Coverage, 11539,
     /* 210930 */     GIR_EraseRootFromParent_Done,
     /* 210931 */   // Label 4159: @210931
     /* 210931 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(210978), // Rule ID 11541 //
     /* 210936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 210944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 210950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210957 */     // MIs[0] Op3
     /* 210957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 210960 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 210965 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2039:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 210965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
     /* 210968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 210970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210974 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 210976 */     GIR_RootConstrainSelectedInstOperands,
     /* 210977 */     // GIR_Coverage, 11541,
     /* 210977 */     GIR_EraseRootFromParent_Done,
     /* 210978 */   // Label 4160: @210978
     /* 210978 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(211025), // Rule ID 11543 //
     /* 210983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 210991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 210997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211004 */     // MIs[0] Op3
     /* 211004 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211007 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211012 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2039:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
     /* 211015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211021 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211023 */     GIR_RootConstrainSelectedInstOperands,
     /* 211024 */     // GIR_Coverage, 11543,
     /* 211024 */     GIR_EraseRootFromParent_Done,
     /* 211025 */   // Label 4161: @211025
     /* 211025 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(211072), // Rule ID 11545 //
     /* 211030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 211038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 211044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211051 */     // MIs[0] Op3
     /* 211051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211054 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 211059 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2039:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 211059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
     /* 211062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211070 */     GIR_RootConstrainSelectedInstOperands,
     /* 211071 */     // GIR_Coverage, 11545,
     /* 211071 */     GIR_EraseRootFromParent_Done,
     /* 211072 */   // Label 4162: @211072
     /* 211072 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(211119), // Rule ID 11547 //
     /* 211077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 211085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 211091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211098 */     // MIs[0] Op3
     /* 211098 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211101 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 211106 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1828:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
     /* 211106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
     /* 211109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211113 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211115 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211117 */     GIR_RootConstrainSelectedInstOperands,
     /* 211118 */     // GIR_Coverage, 11547,
     /* 211118 */     GIR_EraseRootFromParent_Done,
     /* 211119 */   // Label 4163: @211119
     /* 211119 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(211166), // Rule ID 11548 //
     /* 211124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211127 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 211132 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211135 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 211138 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211145 */     // MIs[0] Op3
     /* 211145 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211148 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 211153 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1828:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
     /* 211153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
     /* 211156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211164 */     GIR_RootConstrainSelectedInstOperands,
     /* 211165 */     // GIR_Coverage, 11548,
     /* 211165 */     GIR_EraseRootFromParent_Done,
     /* 211166 */   // Label 4164: @211166
     /* 211166 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(211213), // Rule ID 11549 //
     /* 211171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 211179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 211185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211192 */     // MIs[0] Op3
     /* 211192 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211195 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 211200 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1828:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
     /* 211200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
     /* 211203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211209 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211211 */     GIR_RootConstrainSelectedInstOperands,
     /* 211212 */     // GIR_Coverage, 11549,
     /* 211212 */     GIR_EraseRootFromParent_Done,
     /* 211213 */   // Label 4165: @211213
     /* 211213 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(211260), // Rule ID 11550 //
     /* 211218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 211226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 211232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211239 */     // MIs[0] Op3
     /* 211239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211242 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
     /* 211247 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1828:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
     /* 211247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
     /* 211250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 211252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211256 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211258 */     GIR_RootConstrainSelectedInstOperands,
     /* 211259 */     // GIR_Coverage, 11550,
     /* 211259 */     GIR_EraseRootFromParent_Done,
     /* 211260 */   // Label 4166: @211260
     /* 211260 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(211307), // Rule ID 11625 //
     /* 211265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 211273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211286 */     // MIs[0] Op3
     /* 211286 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211289 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211294 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2048:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
     /* 211297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211303 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211305 */     GIR_RootConstrainSelectedInstOperands,
     /* 211306 */     // GIR_Coverage, 11625,
     /* 211306 */     GIR_EraseRootFromParent_Done,
     /* 211307 */   // Label 4167: @211307
     /* 211307 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(211354), // Rule ID 11627 //
     /* 211312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 211320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211333 */     // MIs[0] Op3
     /* 211333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211336 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211341 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2048:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
     /* 211344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211350 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211352 */     GIR_RootConstrainSelectedInstOperands,
     /* 211353 */     // GIR_Coverage, 11627,
     /* 211353 */     GIR_EraseRootFromParent_Done,
     /* 211354 */   // Label 4168: @211354
     /* 211354 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(211401), // Rule ID 11629 //
     /* 211359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 211367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211380 */     // MIs[0] Op3
     /* 211380 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211383 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211388 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2048:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
     /* 211391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211397 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211399 */     GIR_RootConstrainSelectedInstOperands,
     /* 211400 */     // GIR_Coverage, 11629,
     /* 211400 */     GIR_EraseRootFromParent_Done,
     /* 211401 */   // Label 4169: @211401
     /* 211401 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(211448), // Rule ID 11631 //
     /* 211406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 211414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211427 */     // MIs[0] Op3
     /* 211427 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211430 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 211435 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2048:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 211435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
     /* 211438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211444 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211446 */     GIR_RootConstrainSelectedInstOperands,
     /* 211447 */     // GIR_Coverage, 11631,
     /* 211447 */     GIR_EraseRootFromParent_Done,
     /* 211448 */   // Label 4170: @211448
     /* 211448 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(211495), // Rule ID 11633 //
     /* 211453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 211461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211474 */     // MIs[0] Op3
     /* 211474 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211477 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211482 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1849:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
     /* 211485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211491 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211493 */     GIR_RootConstrainSelectedInstOperands,
     /* 211494 */     // GIR_Coverage, 11633,
     /* 211494 */     GIR_EraseRootFromParent_Done,
     /* 211495 */   // Label 4171: @211495
     /* 211495 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(211542), // Rule ID 11634 //
     /* 211500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 211508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211521 */     // MIs[0] Op3
     /* 211521 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211524 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211529 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1849:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
     /* 211532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211540 */     GIR_RootConstrainSelectedInstOperands,
     /* 211541 */     // GIR_Coverage, 11634,
     /* 211541 */     GIR_EraseRootFromParent_Done,
     /* 211542 */   // Label 4172: @211542
     /* 211542 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(211589), // Rule ID 11635 //
     /* 211547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 211555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211568 */     // MIs[0] Op3
     /* 211568 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211571 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211576 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1849:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
     /* 211579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211585 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211587 */     GIR_RootConstrainSelectedInstOperands,
     /* 211588 */     // GIR_Coverage, 11635,
     /* 211588 */     GIR_EraseRootFromParent_Done,
     /* 211589 */   // Label 4173: @211589
     /* 211589 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(211636), // Rule ID 11636 //
     /* 211594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 211602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211615 */     // MIs[0] Op3
     /* 211615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211618 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 211623 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1849:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 211623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
     /* 211626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211634 */     GIR_RootConstrainSelectedInstOperands,
     /* 211635 */     // GIR_Coverage, 11636,
     /* 211635 */     GIR_EraseRootFromParent_Done,
     /* 211636 */   // Label 4174: @211636
     /* 211636 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(211683), // Rule ID 11641 //
     /* 211641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 211649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211662 */     // MIs[0] Op3
     /* 211662 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211665 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211670 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2041:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
     /* 211673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211681 */     GIR_RootConstrainSelectedInstOperands,
     /* 211682 */     // GIR_Coverage, 11641,
     /* 211682 */     GIR_EraseRootFromParent_Done,
     /* 211683 */   // Label 4175: @211683
     /* 211683 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(211730), // Rule ID 11642 //
     /* 211688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 211696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211709 */     // MIs[0] Op3
     /* 211709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211712 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211717 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2041:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
     /* 211720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211726 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211728 */     GIR_RootConstrainSelectedInstOperands,
     /* 211729 */     // GIR_Coverage, 11642,
     /* 211729 */     GIR_EraseRootFromParent_Done,
     /* 211730 */   // Label 4176: @211730
     /* 211730 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(211777), // Rule ID 11643 //
     /* 211735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 211743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211756 */     // MIs[0] Op3
     /* 211756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211759 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211764 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2041:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
     /* 211767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211773 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211775 */     GIR_RootConstrainSelectedInstOperands,
     /* 211776 */     // GIR_Coverage, 11643,
     /* 211776 */     GIR_EraseRootFromParent_Done,
     /* 211777 */   // Label 4177: @211777
     /* 211777 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(211824), // Rule ID 11644 //
     /* 211782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 211790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 211796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211803 */     // MIs[0] Op3
     /* 211803 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211806 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 211811 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2041:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 211811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
     /* 211814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 211816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211820 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211822 */     GIR_RootConstrainSelectedInstOperands,
     /* 211823 */     // GIR_Coverage, 11644,
     /* 211823 */     GIR_EraseRootFromParent_Done,
     /* 211824 */   // Label 4178: @211824
     /* 211824 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(211871), // Rule ID 11704 //
     /* 211829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 211837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211850 */     // MIs[0] Op3
     /* 211850 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211853 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211858 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1826:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
     /* 211861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211867 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211869 */     GIR_RootConstrainSelectedInstOperands,
     /* 211870 */     // GIR_Coverage, 11704,
     /* 211870 */     GIR_EraseRootFromParent_Done,
     /* 211871 */   // Label 4179: @211871
     /* 211871 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(211918), // Rule ID 11705 //
     /* 211876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 211884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211897 */     // MIs[0] Op3
     /* 211897 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211900 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 211905 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1826:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 211905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
     /* 211908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211914 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211916 */     GIR_RootConstrainSelectedInstOperands,
     /* 211917 */     // GIR_Coverage, 11705,
     /* 211917 */     GIR_EraseRootFromParent_Done,
     /* 211918 */   // Label 4180: @211918
     /* 211918 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(211965), // Rule ID 11706 //
     /* 211923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 211931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 211940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211944 */     // MIs[0] Op3
     /* 211944 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211947 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 211952 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1826:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 211952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
     /* 211955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211961 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 211963 */     GIR_RootConstrainSelectedInstOperands,
     /* 211964 */     // GIR_Coverage, 11706,
     /* 211964 */     GIR_EraseRootFromParent_Done,
     /* 211965 */   // Label 4181: @211965
     /* 211965 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(212012), // Rule ID 11707 //
     /* 211970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 211978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 211981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211991 */     // MIs[0] Op3
     /* 211991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 211994 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 211999 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1705:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 211999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
     /* 212002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212008 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212010 */     GIR_RootConstrainSelectedInstOperands,
     /* 212011 */     // GIR_Coverage, 11707,
     /* 212011 */     GIR_EraseRootFromParent_Done,
     /* 212012 */   // Label 4182: @212012
     /* 212012 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(212059), // Rule ID 11708 //
     /* 212017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 212025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212038 */     // MIs[0] Op3
     /* 212038 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212041 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212046 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1705:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
     /* 212049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212055 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212057 */     GIR_RootConstrainSelectedInstOperands,
     /* 212058 */     // GIR_Coverage, 11708,
     /* 212058 */     GIR_EraseRootFromParent_Done,
     /* 212059 */   // Label 4183: @212059
     /* 212059 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(212106), // Rule ID 11709 //
     /* 212064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 212072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212085 */     // MIs[0] Op3
     /* 212085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212088 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212093 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1705:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
     /* 212096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212104 */     GIR_RootConstrainSelectedInstOperands,
     /* 212105 */     // GIR_Coverage, 11709,
     /* 212105 */     GIR_EraseRootFromParent_Done,
     /* 212106 */   // Label 4184: @212106
     /* 212106 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(212153), // Rule ID 11710 //
     /* 212111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 212119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212132 */     // MIs[0] Op3
     /* 212132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212135 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212140 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1663:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
     /* 212143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212151 */     GIR_RootConstrainSelectedInstOperands,
     /* 212152 */     // GIR_Coverage, 11710,
     /* 212152 */     GIR_EraseRootFromParent_Done,
     /* 212153 */   // Label 4185: @212153
     /* 212153 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(212200), // Rule ID 11711 //
     /* 212158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 212166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212179 */     // MIs[0] Op3
     /* 212179 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212182 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212187 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1663:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
     /* 212190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212196 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212198 */     GIR_RootConstrainSelectedInstOperands,
     /* 212199 */     // GIR_Coverage, 11711,
     /* 212199 */     GIR_EraseRootFromParent_Done,
     /* 212200 */   // Label 4186: @212200
     /* 212200 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(212247), // Rule ID 11712 //
     /* 212205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 212213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212226 */     // MIs[0] Op3
     /* 212226 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212229 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212234 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1663:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
     /* 212237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212243 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212245 */     GIR_RootConstrainSelectedInstOperands,
     /* 212246 */     // GIR_Coverage, 11712,
     /* 212246 */     GIR_EraseRootFromParent_Done,
     /* 212247 */   // Label 4187: @212247
     /* 212247 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(212294), // Rule ID 11713 //
     /* 212252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 212260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212273 */     // MIs[0] Op3
     /* 212273 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212276 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212281 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1830:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
     /* 212284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212292 */     GIR_RootConstrainSelectedInstOperands,
     /* 212293 */     // GIR_Coverage, 11713,
     /* 212293 */     GIR_EraseRootFromParent_Done,
     /* 212294 */   // Label 4188: @212294
     /* 212294 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(212341), // Rule ID 11714 //
     /* 212299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 212307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212320 */     // MIs[0] Op3
     /* 212320 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212323 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212328 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1830:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
     /* 212331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212337 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212339 */     GIR_RootConstrainSelectedInstOperands,
     /* 212340 */     // GIR_Coverage, 11714,
     /* 212340 */     GIR_EraseRootFromParent_Done,
     /* 212341 */   // Label 4189: @212341
     /* 212341 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(212388), // Rule ID 11715 //
     /* 212346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 212354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212367 */     // MIs[0] Op3
     /* 212367 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212370 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212375 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1830:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
     /* 212378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212384 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212386 */     GIR_RootConstrainSelectedInstOperands,
     /* 212387 */     // GIR_Coverage, 11715,
     /* 212387 */     GIR_EraseRootFromParent_Done,
     /* 212388 */   // Label 4190: @212388
     /* 212388 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(212435), // Rule ID 11716 //
     /* 212393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 212401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212414 */     // MIs[0] Op3
     /* 212414 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212417 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212422 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1820:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
     /* 212425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212431 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212433 */     GIR_RootConstrainSelectedInstOperands,
     /* 212434 */     // GIR_Coverage, 11716,
     /* 212434 */     GIR_EraseRootFromParent_Done,
     /* 212435 */   // Label 4191: @212435
     /* 212435 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(212482), // Rule ID 11717 //
     /* 212440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 212448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212461 */     // MIs[0] Op3
     /* 212461 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212464 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212469 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1820:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
     /* 212472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212478 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212480 */     GIR_RootConstrainSelectedInstOperands,
     /* 212481 */     // GIR_Coverage, 11717,
     /* 212481 */     GIR_EraseRootFromParent_Done,
     /* 212482 */   // Label 4192: @212482
     /* 212482 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(212529), // Rule ID 11718 //
     /* 212487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 212495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212508 */     // MIs[0] Op3
     /* 212508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212511 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212516 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1820:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
     /* 212519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212527 */     GIR_RootConstrainSelectedInstOperands,
     /* 212528 */     // GIR_Coverage, 11718,
     /* 212528 */     GIR_EraseRootFromParent_Done,
     /* 212529 */   // Label 4193: @212529
     /* 212529 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(212576), // Rule ID 11719 //
     /* 212534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 212542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212555 */     // MIs[0] Op3
     /* 212555 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212558 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212563 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2025:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
     /* 212566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212574 */     GIR_RootConstrainSelectedInstOperands,
     /* 212575 */     // GIR_Coverage, 11719,
     /* 212575 */     GIR_EraseRootFromParent_Done,
     /* 212576 */   // Label 4194: @212576
     /* 212576 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(212623), // Rule ID 11720 //
     /* 212581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 212589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212602 */     // MIs[0] Op3
     /* 212602 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212605 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212610 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2025:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
     /* 212613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212619 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212621 */     GIR_RootConstrainSelectedInstOperands,
     /* 212622 */     // GIR_Coverage, 11720,
     /* 212622 */     GIR_EraseRootFromParent_Done,
     /* 212623 */   // Label 4195: @212623
     /* 212623 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(212670), // Rule ID 11721 //
     /* 212628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 212636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212649 */     // MIs[0] Op3
     /* 212649 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212652 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212657 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2025:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
     /* 212660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212666 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212668 */     GIR_RootConstrainSelectedInstOperands,
     /* 212669 */     // GIR_Coverage, 11721,
     /* 212669 */     GIR_EraseRootFromParent_Done,
     /* 212670 */   // Label 4196: @212670
     /* 212670 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(212717), // Rule ID 11722 //
     /* 212675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 212683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212696 */     // MIs[0] Op3
     /* 212696 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212699 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 212704 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2022:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 212704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
     /* 212707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212713 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212715 */     GIR_RootConstrainSelectedInstOperands,
     /* 212716 */     // GIR_Coverage, 11722,
     /* 212716 */     GIR_EraseRootFromParent_Done,
     /* 212717 */   // Label 4197: @212717
     /* 212717 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(212764), // Rule ID 11723 //
     /* 212722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 212730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212743 */     // MIs[0] Op3
     /* 212743 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212746 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 212751 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2022:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 212751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
     /* 212754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212762 */     GIR_RootConstrainSelectedInstOperands,
     /* 212763 */     // GIR_Coverage, 11723,
     /* 212763 */     GIR_EraseRootFromParent_Done,
     /* 212764 */   // Label 4198: @212764
     /* 212764 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(212811), // Rule ID 11724 //
     /* 212769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 212777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212790 */     // MIs[0] Op3
     /* 212790 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 212793 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 212798 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2022:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 212798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
     /* 212801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212807 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 212809 */     GIR_RootConstrainSelectedInstOperands,
     /* 212810 */     // GIR_Coverage, 11724,
     /* 212810 */     GIR_EraseRootFromParent_Done,
     /* 212811 */   // Label 4199: @212811
     /* 212811 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(212878), // Rule ID 2602 //
     /* 212816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 212824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 212833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 212836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212844 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212850 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2032:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
     /* 212867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212876 */     GIR_RootConstrainSelectedInstOperands,
     /* 212877 */     // GIR_Coverage, 2602,
     /* 212877 */     GIR_EraseRootFromParent_Done,
     /* 212878 */   // Label 4200: @212878
     /* 212878 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(212945), // Rule ID 7655 //
     /* 212883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 212891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 212900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 212903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212917 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1296:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
     /* 212934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 212939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 212941 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 212943 */     GIR_RootConstrainSelectedInstOperands,
     /* 212944 */     // GIR_Coverage, 7655,
     /* 212944 */     GIR_EraseRootFromParent_Done,
     /* 212945 */   // Label 4201: @212945
     /* 212945 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(213012), // Rule ID 7657 //
     /* 212950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 212953 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 212958 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212961 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212964 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 212967 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 212970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 212978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 212982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 212984 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1296:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 212987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 212991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 212996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 212998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
     /* 213001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213008 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213010 */     GIR_RootConstrainSelectedInstOperands,
     /* 213011 */     // GIR_Coverage, 7657,
     /* 213011 */     GIR_EraseRootFromParent_Done,
     /* 213012 */   // Label 4202: @213012
     /* 213012 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(213079), // Rule ID 7659 //
     /* 213017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 213025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213049 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213051 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1296:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
     /* 213068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213077 */     GIR_RootConstrainSelectedInstOperands,
     /* 213078 */     // GIR_Coverage, 7659,
     /* 213078 */     GIR_EraseRootFromParent_Done,
     /* 213079 */   // Label 4203: @213079
     /* 213079 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(213146), // Rule ID 7661 //
     /* 213084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 213092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213118 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1296:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
     /* 213135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213142 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213144 */     GIR_RootConstrainSelectedInstOperands,
     /* 213145 */     // GIR_Coverage, 7661,
     /* 213145 */     GIR_EraseRootFromParent_Done,
     /* 213146 */   // Label 4204: @213146
     /* 213146 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(213213), // Rule ID 7691 //
     /* 213151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 213159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 213168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213185 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1316:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213185 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213188 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213192 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
     /* 213202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213209 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213211 */     GIR_RootConstrainSelectedInstOperands,
     /* 213212 */     // GIR_Coverage, 7691,
     /* 213212 */     GIR_EraseRootFromParent_Done,
     /* 213213 */   // Label 4205: @213213
     /* 213213 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(213280), // Rule ID 7693 //
     /* 213218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 213226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 213235 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213252 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1316:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
     /* 213269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213276 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213278 */     GIR_RootConstrainSelectedInstOperands,
     /* 213279 */     // GIR_Coverage, 7693,
     /* 213279 */     GIR_EraseRootFromParent_Done,
     /* 213280 */   // Label 4206: @213280
     /* 213280 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(213347), // Rule ID 7695 //
     /* 213285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 213293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213317 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213319 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1316:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213319 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213322 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213326 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
     /* 213336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213345 */     GIR_RootConstrainSelectedInstOperands,
     /* 213346 */     // GIR_Coverage, 7695,
     /* 213346 */     GIR_EraseRootFromParent_Done,
     /* 213347 */   // Label 4207: @213347
     /* 213347 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(213414), // Rule ID 7697 //
     /* 213352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 213360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213386 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1316:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
     /* 213403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213410 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213412 */     GIR_RootConstrainSelectedInstOperands,
     /* 213413 */     // GIR_Coverage, 7697,
     /* 213413 */     GIR_EraseRootFromParent_Done,
     /* 213414 */   // Label 4208: @213414
     /* 213414 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(213481), // Rule ID 7703 //
     /* 213419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 213427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 213436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213453 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1602:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
     /* 213470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213479 */     GIR_RootConstrainSelectedInstOperands,
     /* 213480 */     // GIR_Coverage, 7703,
     /* 213480 */     GIR_EraseRootFromParent_Done,
     /* 213481 */   // Label 4209: @213481
     /* 213481 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(213548), // Rule ID 7705 //
     /* 213486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 213494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 213503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213520 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
     /* 213537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213544 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213546 */     GIR_RootConstrainSelectedInstOperands,
     /* 213547 */     // GIR_Coverage, 7705,
     /* 213547 */     GIR_EraseRootFromParent_Done,
     /* 213548 */   // Label 4210: @213548
     /* 213548 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(213615), // Rule ID 7707 //
     /* 213553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 213561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213587 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
     /* 213604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213611 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213613 */     GIR_RootConstrainSelectedInstOperands,
     /* 213614 */     // GIR_Coverage, 7707,
     /* 213614 */     GIR_EraseRootFromParent_Done,
     /* 213615 */   // Label 4211: @213615
     /* 213615 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(213682), // Rule ID 7709 //
     /* 213620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 213623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 213628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213654 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1602:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213654 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213657 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213661 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
     /* 213671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213680 */     GIR_RootConstrainSelectedInstOperands,
     /* 213681 */     // GIR_Coverage, 7709,
     /* 213681 */     GIR_EraseRootFromParent_Done,
     /* 213682 */   // Label 4212: @213682
     /* 213682 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(213749), // Rule ID 11417 //
     /* 213687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 213695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213721 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2040:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213733 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
     /* 213738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213745 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213747 */     GIR_RootConstrainSelectedInstOperands,
     /* 213748 */     // GIR_Coverage, 11417,
     /* 213748 */     GIR_EraseRootFromParent_Done,
     /* 213749 */   // Label 4213: @213749
     /* 213749 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(213816), // Rule ID 11419 //
     /* 213754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 213765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 213768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 213771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 213774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213788 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1745:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
     /* 213805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213812 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213814 */     GIR_RootConstrainSelectedInstOperands,
     /* 213815 */     // GIR_Coverage, 11419,
     /* 213815 */     GIR_EraseRootFromParent_Done,
     /* 213816 */   // Label 4214: @213816
     /* 213816 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(213883), // Rule ID 11421 //
     /* 213821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 213832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 213835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 213838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 213841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213855 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1745:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
     /* 213872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213874 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213881 */     GIR_RootConstrainSelectedInstOperands,
     /* 213882 */     // GIR_Coverage, 11421,
     /* 213882 */     GIR_EraseRootFromParent_Done,
     /* 213883 */   // Label 4215: @213883
     /* 213883 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(213950), // Rule ID 11423 //
     /* 213888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 213899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 213902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 213905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 213908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213922 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1745:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213922 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213925 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213929 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 213934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 213936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
     /* 213939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 213941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 213944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 213946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 213948 */     GIR_RootConstrainSelectedInstOperands,
     /* 213949 */     // GIR_Coverage, 11423,
     /* 213949 */     GIR_EraseRootFromParent_Done,
     /* 213950 */   // Label 4216: @213950
     /* 213950 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(214017), // Rule ID 11425 //
     /* 213955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 213958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 213963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 213966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 213969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 213972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 213975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 213979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 213983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 213987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 213989 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1745:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 213992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 213996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
     /* 214006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214013 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214015 */     GIR_RootConstrainSelectedInstOperands,
     /* 214016 */     // GIR_Coverage, 11425,
     /* 214016 */     GIR_EraseRootFromParent_Done,
     /* 214017 */   // Label 4217: @214017
     /* 214017 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(214084), // Rule ID 11431 //
     /* 214022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 214030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 214039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 214042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214056 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1805:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
     /* 214073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214082 */     GIR_RootConstrainSelectedInstOperands,
     /* 214083 */     // GIR_Coverage, 11431,
     /* 214083 */     GIR_EraseRootFromParent_Done,
     /* 214084 */   // Label 4218: @214084
     /* 214084 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(214151), // Rule ID 11433 //
     /* 214089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 214097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 214106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 214109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214121 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214123 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1805:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214135 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
     /* 214140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214149 */     GIR_RootConstrainSelectedInstOperands,
     /* 214150 */     // GIR_Coverage, 11433,
     /* 214150 */     GIR_EraseRootFromParent_Done,
     /* 214151 */   // Label 4219: @214151
     /* 214151 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(214218), // Rule ID 11435 //
     /* 214156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 214164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 214173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 214176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214190 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1805:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
     /* 214207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214214 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214216 */     GIR_RootConstrainSelectedInstOperands,
     /* 214217 */     // GIR_Coverage, 11435,
     /* 214217 */     GIR_EraseRootFromParent_Done,
     /* 214218 */   // Label 4220: @214218
     /* 214218 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(214285), // Rule ID 11437 //
     /* 214223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 214226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 214231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 214240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 214243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 214251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 214255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 214257 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1805:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 214260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 214264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 214269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 214271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
     /* 214274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 214279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 214281 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 214283 */     GIR_RootConstrainSelectedInstOperands,
     /* 214284 */     // GIR_Coverage, 11437,
     /* 214284 */     GIR_EraseRootFromParent_Done,
     /* 214285 */   // Label 4221: @214285
     /* 214285 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(214339), // Rule ID 30 //
     /* 214290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 214293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
     /* 214298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 214307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 214310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214322 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214326 */     // (intrinsic_wo_chain:{ *:[v4i32] } 676:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 214326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
     /* 214329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214335 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214337 */     GIR_RootConstrainSelectedInstOperands,
     /* 214338 */     // GIR_Coverage, 30,
     /* 214338 */     GIR_EraseRootFromParent_Done,
     /* 214339 */   // Label 4222: @214339
     /* 214339 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(214393), // Rule ID 31 //
     /* 214344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 214347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
     /* 214352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 214361 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 214364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214380 */     // (intrinsic_wo_chain:{ *:[v4i32] } 737:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 214380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
     /* 214383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214389 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214391 */     GIR_RootConstrainSelectedInstOperands,
     /* 214392 */     // GIR_Coverage, 31,
     /* 214392 */     GIR_EraseRootFromParent_Done,
     /* 214393 */   // Label 4223: @214393
     /* 214393 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(214447), // Rule ID 32 //
     /* 214398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 214401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
     /* 214406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 214415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 214418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214430 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214434 */     // (intrinsic_wo_chain:{ *:[v4i32] } 753:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 214434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
     /* 214437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214443 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214445 */     GIR_RootConstrainSelectedInstOperands,
     /* 214446 */     // GIR_Coverage, 32,
     /* 214446 */     GIR_EraseRootFromParent_Done,
     /* 214447 */   // Label 4224: @214447
     /* 214447 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(214501), // Rule ID 39 //
     /* 214452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 214460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214488 */     // (intrinsic_wo_chain:{ *:[v2f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 214488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
     /* 214491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214497 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214499 */     GIR_RootConstrainSelectedInstOperands,
     /* 214500 */     // GIR_Coverage, 39,
     /* 214500 */     GIR_EraseRootFromParent_Done,
     /* 214501 */   // Label 4225: @214501
     /* 214501 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(214555), // Rule ID 40 //
     /* 214506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 214514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214542 */     // (intrinsic_wo_chain:{ *:[v4f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 214542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
     /* 214545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214551 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214553 */     GIR_RootConstrainSelectedInstOperands,
     /* 214554 */     // GIR_Coverage, 40,
     /* 214554 */     GIR_EraseRootFromParent_Done,
     /* 214555 */   // Label 4226: @214555
     /* 214555 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(214609), // Rule ID 41 //
     /* 214560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 214568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214592 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214596 */     // (intrinsic_wo_chain:{ *:[v2f32] } 608:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 214596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
     /* 214599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214605 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214607 */     GIR_RootConstrainSelectedInstOperands,
     /* 214608 */     // GIR_Coverage, 41,
     /* 214608 */     GIR_EraseRootFromParent_Done,
     /* 214609 */   // Label 4227: @214609
     /* 214609 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(214663), // Rule ID 42 //
     /* 214614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 214622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214646 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214650 */     // (intrinsic_wo_chain:{ *:[v4f32] } 608:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 214650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
     /* 214653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214661 */     GIR_RootConstrainSelectedInstOperands,
     /* 214662 */     // GIR_Coverage, 42,
     /* 214662 */     GIR_EraseRootFromParent_Done,
     /* 214663 */   // Label 4228: @214663
     /* 214663 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(214717), // Rule ID 43 //
     /* 214668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 214676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214700 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214704 */     // (intrinsic_wo_chain:{ *:[v2f32] } 607:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 214704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
     /* 214707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214713 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214715 */     GIR_RootConstrainSelectedInstOperands,
     /* 214716 */     // GIR_Coverage, 43,
     /* 214716 */     GIR_EraseRootFromParent_Done,
     /* 214717 */   // Label 4229: @214717
     /* 214717 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(214771), // Rule ID 44 //
     /* 214722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 214730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214758 */     // (intrinsic_wo_chain:{ *:[v4f32] } 607:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 214758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
     /* 214761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214767 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214769 */     GIR_RootConstrainSelectedInstOperands,
     /* 214770 */     // GIR_Coverage, 44,
     /* 214770 */     GIR_EraseRootFromParent_Done,
     /* 214771 */   // Label 4230: @214771
     /* 214771 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(214825), // Rule ID 45 //
     /* 214776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 214784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 214787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 214790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214808 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214812 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 214812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
     /* 214815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214821 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214823 */     GIR_RootConstrainSelectedInstOperands,
     /* 214824 */     // GIR_Coverage, 45,
     /* 214824 */     GIR_EraseRootFromParent_Done,
     /* 214825 */   // Label 4231: @214825
     /* 214825 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(214879), // Rule ID 46 //
     /* 214830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 214833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 214838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 214844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214862 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214866 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 214866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
     /* 214869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214875 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214877 */     GIR_RootConstrainSelectedInstOperands,
     /* 214878 */     // GIR_Coverage, 46,
     /* 214878 */     GIR_EraseRootFromParent_Done,
     /* 214879 */   // Label 4232: @214879
     /* 214879 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(214933), // Rule ID 1587 //
     /* 214884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 214892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 214895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 214898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 214901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 214904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214916 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 214920 */     // (intrinsic_wo_chain:{ *:[v4i16] } 686:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 214920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
     /* 214923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214931 */     GIR_RootConstrainSelectedInstOperands,
     /* 214932 */     // GIR_Coverage, 1587,
     /* 214932 */     GIR_EraseRootFromParent_Done,
     /* 214933 */   // Label 4233: @214933
     /* 214933 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(214987), // Rule ID 1588 //
     /* 214938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 214946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 214952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 214955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 214958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214970 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214974 */     // (intrinsic_wo_chain:{ *:[v8i16] } 686:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 214974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
     /* 214977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 214979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 214981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 214983 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 214985 */     GIR_RootConstrainSelectedInstOperands,
     /* 214986 */     // GIR_Coverage, 1588,
     /* 214986 */     GIR_EraseRootFromParent_Done,
     /* 214987 */   // Label 4234: @214987
     /* 214987 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(215041), // Rule ID 1589 //
     /* 214992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 214995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 215000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 215003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 215006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 215009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 215012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215024 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215028 */     // (intrinsic_wo_chain:{ *:[v2i32] } 686:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 215028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
     /* 215031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215039 */     GIR_RootConstrainSelectedInstOperands,
     /* 215040 */     // GIR_Coverage, 1589,
     /* 215040 */     GIR_EraseRootFromParent_Done,
     /* 215041 */   // Label 4235: @215041
     /* 215041 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(215095), // Rule ID 1590 //
     /* 215046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 215054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215074 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215078 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215082 */     // (intrinsic_wo_chain:{ *:[v4i32] } 686:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
     /* 215085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215091 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215093 */     GIR_RootConstrainSelectedInstOperands,
     /* 215094 */     // GIR_Coverage, 1590,
     /* 215094 */     GIR_EraseRootFromParent_Done,
     /* 215095 */   // Label 4236: @215095
     /* 215095 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(215149), // Rule ID 1591 //
     /* 215100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 215108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 215111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 215114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 215117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 215120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215132 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215136 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 215136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
     /* 215139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215145 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215147 */     GIR_RootConstrainSelectedInstOperands,
     /* 215148 */     // GIR_Coverage, 1591,
     /* 215148 */     GIR_EraseRootFromParent_Done,
     /* 215149 */   // Label 4237: @215149
     /* 215149 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(215203), // Rule ID 1592 //
     /* 215154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 215162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 215165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 215168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 215171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 215174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215186 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215190 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 215190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
     /* 215193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215199 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215201 */     GIR_RootConstrainSelectedInstOperands,
     /* 215202 */     // GIR_Coverage, 1592,
     /* 215202 */     GIR_EraseRootFromParent_Done,
     /* 215203 */   // Label 4238: @215203
     /* 215203 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(215257), // Rule ID 1593 //
     /* 215208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 215216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 215219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 215222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 215225 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 215228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215240 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215244 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 215244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
     /* 215247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215253 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215255 */     GIR_RootConstrainSelectedInstOperands,
     /* 215256 */     // GIR_Coverage, 1593,
     /* 215256 */     GIR_EraseRootFromParent_Done,
     /* 215257 */   // Label 4239: @215257
     /* 215257 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(215311), // Rule ID 1594 //
     /* 215262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 215270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215294 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215298 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
     /* 215301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215307 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215309 */     GIR_RootConstrainSelectedInstOperands,
     /* 215310 */     // GIR_Coverage, 1594,
     /* 215310 */     GIR_EraseRootFromParent_Done,
     /* 215311 */   // Label 4240: @215311
     /* 215311 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(215365), // Rule ID 2305 //
     /* 215316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
     /* 215324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 215333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215344 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 215348 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215352 */     // (intrinsic_wo_chain:{ *:[v4i32] } 520:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
     /* 215355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215361 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215363 */     GIR_RootConstrainSelectedInstOperands,
     /* 215364 */     // GIR_Coverage, 2305,
     /* 215364 */     GIR_EraseRootFromParent_Done,
     /* 215365 */   // Label 4241: @215365
     /* 215365 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(215419), // Rule ID 2306 //
     /* 215370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
     /* 215378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 215387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 215402 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215406 */     // (intrinsic_wo_chain:{ *:[v4i32] } 523:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
     /* 215409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215415 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215417 */     GIR_RootConstrainSelectedInstOperands,
     /* 215418 */     // GIR_Coverage, 2306,
     /* 215418 */     GIR_EraseRootFromParent_Done,
     /* 215419 */   // Label 4242: @215419
     /* 215419 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(215473), // Rule ID 2307 //
     /* 215424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
     /* 215432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 215441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215452 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 215456 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215460 */     // (intrinsic_wo_chain:{ *:[v4i32] } 522:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
     /* 215463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215471 */     GIR_RootConstrainSelectedInstOperands,
     /* 215472 */     // GIR_Coverage, 2307,
     /* 215472 */     GIR_EraseRootFromParent_Done,
     /* 215473 */   // Label 4243: @215473
     /* 215473 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(215527), // Rule ID 2308 //
     /* 215478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
     /* 215486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215506 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215510 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215514 */     // (intrinsic_wo_chain:{ *:[v4i32] } 524:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
     /* 215517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215523 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215525 */     GIR_RootConstrainSelectedInstOperands,
     /* 215526 */     // GIR_Coverage, 2308,
     /* 215526 */     GIR_EraseRootFromParent_Done,
     /* 215527 */   // Label 4244: @215527
     /* 215527 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(215581), // Rule ID 2309 //
     /* 215532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
     /* 215540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215568 */     // (intrinsic_wo_chain:{ *:[v4i32] } 526:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
     /* 215571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215577 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215579 */     GIR_RootConstrainSelectedInstOperands,
     /* 215580 */     // GIR_Coverage, 2309,
     /* 215580 */     GIR_EraseRootFromParent_Done,
     /* 215581 */   // Label 4245: @215581
     /* 215581 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(215635), // Rule ID 2310 //
     /* 215586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
     /* 215594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215622 */     // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
     /* 215625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215631 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215633 */     GIR_RootConstrainSelectedInstOperands,
     /* 215634 */     // GIR_Coverage, 2310,
     /* 215634 */     GIR_EraseRootFromParent_Done,
     /* 215635 */   // Label 4246: @215635
     /* 215635 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(215689), // Rule ID 2311 //
     /* 215640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 215643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
     /* 215648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 215651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 215654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 215657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 215660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215672 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215676 */     // (intrinsic_wo_chain:{ *:[v4i32] } 529:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 215676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
     /* 215679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 215687 */     GIR_RootConstrainSelectedInstOperands,
     /* 215688 */     // GIR_Coverage, 2311,
     /* 215688 */     GIR_EraseRootFromParent_Done,
     /* 215689 */   // Label 4247: @215689
     /* 215689 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(215746), // Rule ID 3638 //
     /* 215694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 215697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 215702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 215711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 215714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 215718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 215730 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1637:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 215730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
     /* 215733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 215737 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 215739 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 215741 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215744 */     GIR_RootConstrainSelectedInstOperands,
     /* 215745 */     // GIR_Coverage, 3638,
     /* 215745 */     GIR_EraseRootFromParent_Done,
     /* 215746 */   // Label 4248: @215746
     /* 215746 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(215803), // Rule ID 3639 //
     /* 215751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 215754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 215759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 215768 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 215771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 215775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215783 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 215787 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1637:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 215787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
     /* 215790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 215794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 215796 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 215798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215801 */     GIR_RootConstrainSelectedInstOperands,
     /* 215802 */     // GIR_Coverage, 3639,
     /* 215802 */     GIR_EraseRootFromParent_Done,
     /* 215803 */   // Label 4249: @215803
     /* 215803 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(215860), // Rule ID 3640 //
     /* 215808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 215811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 215816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 215825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 215828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 215832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215840 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 215844 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1637:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 215844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
     /* 215847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 215851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 215853 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 215855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215858 */     GIR_RootConstrainSelectedInstOperands,
     /* 215859 */     // GIR_Coverage, 3640,
     /* 215859 */     GIR_EraseRootFromParent_Done,
     /* 215860 */   // Label 4250: @215860
     /* 215860 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(215917), // Rule ID 3641 //
     /* 215865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 215868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 215873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 215879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 215882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 215885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 215889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 215901 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1637:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 215901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
     /* 215904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 215908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 215910 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 215912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215915 */     GIR_RootConstrainSelectedInstOperands,
     /* 215916 */     // GIR_Coverage, 3641,
     /* 215916 */     GIR_EraseRootFromParent_Done,
     /* 215917 */   // Label 4251: @215917
     /* 215917 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(215971), // Rule ID 3804 //
     /* 215922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
     /* 215930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215954 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215958 */     // (intrinsic_wo_chain:{ *:[v2i64] } 530:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 215958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
     /* 215961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 215963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 215965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 215967 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 215969 */     GIR_RootConstrainSelectedInstOperands,
     /* 215970 */     // GIR_Coverage, 3804,
     /* 215970 */     GIR_EraseRootFromParent_Done,
     /* 215971 */   // Label 4252: @215971
     /* 215971 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(216025), // Rule ID 3805 //
     /* 215976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 215979 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
     /* 215984 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 215987 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 215990 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 215993 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 215996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216008 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216012 */     // (intrinsic_wo_chain:{ *:[v2i64] } 531:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 216012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
     /* 216015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 216017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216021 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216023 */     GIR_RootConstrainSelectedInstOperands,
     /* 216024 */     // GIR_Coverage, 3805,
     /* 216024 */     GIR_EraseRootFromParent_Done,
     /* 216025 */   // Label 4253: @216025
     /* 216025 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(216079), // Rule ID 3806 //
     /* 216030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
     /* 216038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 216044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 216047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 216050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216062 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216066 */     // (intrinsic_wo_chain:{ *:[v2i64] } 533:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 216066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
     /* 216069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 216071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216075 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216077 */     GIR_RootConstrainSelectedInstOperands,
     /* 216078 */     // GIR_Coverage, 3806,
     /* 216078 */     GIR_EraseRootFromParent_Done,
     /* 216079 */   // Label 4254: @216079
     /* 216079 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(216133), // Rule ID 3807 //
     /* 216084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 216092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 216095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 216098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 216101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 216104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216120 */     // (intrinsic_wo_chain:{ *:[v16i8] } 518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 216120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216129 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216131 */     GIR_RootConstrainSelectedInstOperands,
     /* 216132 */     // GIR_Coverage, 3807,
     /* 216132 */     GIR_EraseRootFromParent_Done,
     /* 216133 */   // Label 4255: @216133
     /* 216133 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(216187), // Rule ID 3808 //
     /* 216138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 216146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216166 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216170 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216174 */     // (intrinsic_wo_chain:{ *:[v8i16] } 518:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 216174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216183 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216185 */     GIR_RootConstrainSelectedInstOperands,
     /* 216186 */     // GIR_Coverage, 3808,
     /* 216186 */     GIR_EraseRootFromParent_Done,
     /* 216187 */   // Label 4256: @216187
     /* 216187 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(216241), // Rule ID 3809 //
     /* 216192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 216200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216224 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216228 */     // (intrinsic_wo_chain:{ *:[v4i32] } 518:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 216228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216239 */     GIR_RootConstrainSelectedInstOperands,
     /* 216240 */     // GIR_Coverage, 3809,
     /* 216240 */     GIR_EraseRootFromParent_Done,
     /* 216241 */   // Label 4257: @216241
     /* 216241 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(216295), // Rule ID 3810 //
     /* 216246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 216254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 216260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 216263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 216266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216282 */     // (intrinsic_wo_chain:{ *:[v2i64] } 518:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 216282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216293 */     GIR_RootConstrainSelectedInstOperands,
     /* 216294 */     // GIR_Coverage, 3810,
     /* 216294 */     GIR_EraseRootFromParent_Done,
     /* 216295 */   // Label 4258: @216295
     /* 216295 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(216349), // Rule ID 3819 //
     /* 216300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 216308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 216311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 216314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 216317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 216320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216336 */     // (intrinsic_wo_chain:{ *:[v16i8] } 516:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 216336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216345 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216347 */     GIR_RootConstrainSelectedInstOperands,
     /* 216348 */     // GIR_Coverage, 3819,
     /* 216348 */     GIR_EraseRootFromParent_Done,
     /* 216349 */   // Label 4259: @216349
     /* 216349 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(216403), // Rule ID 3820 //
     /* 216354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 216362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216368 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216371 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216382 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216386 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216390 */     // (intrinsic_wo_chain:{ *:[v8i16] } 516:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 216390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216401 */     GIR_RootConstrainSelectedInstOperands,
     /* 216402 */     // GIR_Coverage, 3820,
     /* 216402 */     GIR_EraseRootFromParent_Done,
     /* 216403 */   // Label 4260: @216403
     /* 216403 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(216457), // Rule ID 3821 //
     /* 216408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 216416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216440 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216444 */     // (intrinsic_wo_chain:{ *:[v4i32] } 516:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 216444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216453 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216455 */     GIR_RootConstrainSelectedInstOperands,
     /* 216456 */     // GIR_Coverage, 3821,
     /* 216456 */     GIR_EraseRootFromParent_Done,
     /* 216457 */   // Label 4261: @216457
     /* 216457 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(216511), // Rule ID 3822 //
     /* 216462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 216470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 216476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 216479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 216482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216494 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216498 */     // (intrinsic_wo_chain:{ *:[v2i64] } 516:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 216498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216507 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216509 */     GIR_RootConstrainSelectedInstOperands,
     /* 216510 */     // GIR_Coverage, 3822,
     /* 216510 */     GIR_EraseRootFromParent_Done,
     /* 216511 */   // Label 4262: @216511
     /* 216511 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(216565), // Rule ID 3823 //
     /* 216516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 216524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 216527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 216530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 216533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 216536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216548 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216552 */     // (intrinsic_wo_chain:{ *:[v16i8] } 517:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 216552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216561 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216563 */     GIR_RootConstrainSelectedInstOperands,
     /* 216564 */     // GIR_Coverage, 3823,
     /* 216564 */     GIR_EraseRootFromParent_Done,
     /* 216565 */   // Label 4263: @216565
     /* 216565 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(216619), // Rule ID 3824 //
     /* 216570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 216578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216602 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216606 */     // (intrinsic_wo_chain:{ *:[v8i16] } 517:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 216606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216615 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216617 */     GIR_RootConstrainSelectedInstOperands,
     /* 216618 */     // GIR_Coverage, 3824,
     /* 216618 */     GIR_EraseRootFromParent_Done,
     /* 216619 */   // Label 4264: @216619
     /* 216619 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(216673), // Rule ID 3825 //
     /* 216624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 216632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216660 */     // (intrinsic_wo_chain:{ *:[v4i32] } 517:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 216660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216671 */     GIR_RootConstrainSelectedInstOperands,
     /* 216672 */     // GIR_Coverage, 3825,
     /* 216672 */     GIR_EraseRootFromParent_Done,
     /* 216673 */   // Label 4265: @216673
     /* 216673 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(216727), // Rule ID 3826 //
     /* 216678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 216686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 216692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 216695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 216698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216710 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216714 */     // (intrinsic_wo_chain:{ *:[v2i64] } 517:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 216714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 216717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216723 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216725 */     GIR_RootConstrainSelectedInstOperands,
     /* 216726 */     // GIR_Coverage, 3826,
     /* 216726 */     GIR_EraseRootFromParent_Done,
     /* 216727 */   // Label 4266: @216727
     /* 216727 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(216781), // Rule ID 3827 //
     /* 216732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 216740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 216743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 216746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 216749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 216752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216764 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216768 */     // (intrinsic_wo_chain:{ *:[v16i8] } 515:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 216768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216777 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216779 */     GIR_RootConstrainSelectedInstOperands,
     /* 216780 */     // GIR_Coverage, 3827,
     /* 216780 */     GIR_EraseRootFromParent_Done,
     /* 216781 */   // Label 4267: @216781
     /* 216781 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(216835), // Rule ID 3828 //
     /* 216786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 216794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216818 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216822 */     // (intrinsic_wo_chain:{ *:[v8i16] } 515:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 216822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216831 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216833 */     GIR_RootConstrainSelectedInstOperands,
     /* 216834 */     // GIR_Coverage, 3828,
     /* 216834 */     GIR_EraseRootFromParent_Done,
     /* 216835 */   // Label 4268: @216835
     /* 216835 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(216889), // Rule ID 3829 //
     /* 216840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 216848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216872 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216876 */     // (intrinsic_wo_chain:{ *:[v4i32] } 515:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 216876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216885 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216887 */     GIR_RootConstrainSelectedInstOperands,
     /* 216888 */     // GIR_Coverage, 3829,
     /* 216888 */     GIR_EraseRootFromParent_Done,
     /* 216889 */   // Label 4269: @216889
     /* 216889 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(216943), // Rule ID 3830 //
     /* 216894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 216897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 216902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 216905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 216908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 216911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 216914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216926 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216930 */     // (intrinsic_wo_chain:{ *:[v2i64] } 515:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 216930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 216933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 216937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 216939 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 216941 */     GIR_RootConstrainSelectedInstOperands,
     /* 216942 */     // GIR_Coverage, 3830,
     /* 216942 */     GIR_EraseRootFromParent_Done,
     /* 216943 */   // Label 4270: @216943
     /* 216943 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(216997), // Rule ID 3834 //
     /* 216948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 216951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
     /* 216956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216976 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216980 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216984 */     // (intrinsic_wo_chain:{ *:[v4i32] } 536:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /* 216984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
     /* 216987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 216989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 216991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 216993 */     GIR_RootToRootCopy, /*OpIdx*/4, // Va
     /* 216995 */     GIR_RootConstrainSelectedInstOperands,
     /* 216996 */     // GIR_Coverage, 3834,
     /* 216996 */     GIR_EraseRootFromParent_Done,
     /* 216997 */   // Label 4271: @216997
     /* 216997 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(217051), // Rule ID 3835 //
     /* 217002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 217005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
     /* 217010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217038 */     // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 217038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
     /* 217041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 217043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 217045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 217047 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 217049 */     GIR_RootConstrainSelectedInstOperands,
     /* 217050 */     // GIR_Coverage, 3835,
     /* 217050 */     GIR_EraseRootFromParent_Done,
     /* 217051 */   // Label 4272: @217051
     /* 217051 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(217105), // Rule ID 3836 //
     /* 217056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 217059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
     /* 217064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217088 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217092 */     // (intrinsic_wo_chain:{ *:[v4i32] } 535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 217092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
     /* 217095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 217097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 217099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 217101 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 217103 */     GIR_RootConstrainSelectedInstOperands,
     /* 217104 */     // GIR_Coverage, 3836,
     /* 217104 */     GIR_EraseRootFromParent_Done,
     /* 217105 */   // Label 4273: @217105
     /* 217105 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(217162), // Rule ID 3853 //
     /* 217110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 217113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 217118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 217121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 217124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 217127 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 217130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217142 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217146 */     // (intrinsic_wo_chain:{ *:[v4f16] } 757:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 217146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 217149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217160 */     GIR_RootConstrainSelectedInstOperands,
     /* 217161 */     // GIR_Coverage, 3853,
     /* 217161 */     GIR_EraseRootFromParent_Done,
     /* 217162 */   // Label 4274: @217162
     /* 217162 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(217219), // Rule ID 3854 //
     /* 217167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 217170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 217175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 217178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 217181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 217184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 217187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217203 */     // (intrinsic_wo_chain:{ *:[v4f16] } 760:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 217203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 217206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217217 */     GIR_RootConstrainSelectedInstOperands,
     /* 217218 */     // GIR_Coverage, 3854,
     /* 217218 */     GIR_EraseRootFromParent_Done,
     /* 217219 */   // Label 4275: @217219
     /* 217219 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(217276), // Rule ID 3855 //
     /* 217224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 217227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 217232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 217235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 217238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 217241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 217244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217256 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217260 */     // (intrinsic_wo_chain:{ *:[v4f16] } 758:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
     /* 217260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 217263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217269 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217274 */     GIR_RootConstrainSelectedInstOperands,
     /* 217275 */     // GIR_Coverage, 3855,
     /* 217275 */     GIR_EraseRootFromParent_Done,
     /* 217276 */   // Label 4276: @217276
     /* 217276 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(217333), // Rule ID 3856 //
     /* 217281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 217284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 217292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 217295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 217298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 217301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217313 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217317 */     // (intrinsic_wo_chain:{ *:[v4f16] } 759:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
     /* 217317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 217320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217326 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217331 */     GIR_RootConstrainSelectedInstOperands,
     /* 217332 */     // GIR_Coverage, 3856,
     /* 217332 */     GIR_EraseRootFromParent_Done,
     /* 217333 */   // Label 4277: @217333
     /* 217333 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(217390), // Rule ID 3861 //
     /* 217338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 217341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 217346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 217349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 217352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 217355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 217358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217366 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217370 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217374 */     // (intrinsic_wo_chain:{ *:[v8f16] } 757:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 217374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 217377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217388 */     GIR_RootConstrainSelectedInstOperands,
     /* 217389 */     // GIR_Coverage, 3861,
     /* 217389 */     GIR_EraseRootFromParent_Done,
     /* 217390 */   // Label 4278: @217390
     /* 217390 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(217447), // Rule ID 3862 //
     /* 217395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 217398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 217403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 217406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 217409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 217412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 217415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217427 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217431 */     // (intrinsic_wo_chain:{ *:[v8f16] } 760:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 217431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 217434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217440 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217445 */     GIR_RootConstrainSelectedInstOperands,
     /* 217446 */     // GIR_Coverage, 3862,
     /* 217446 */     GIR_EraseRootFromParent_Done,
     /* 217447 */   // Label 4279: @217447
     /* 217447 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(217504), // Rule ID 3863 //
     /* 217452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 217455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 217460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 217463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 217466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 217469 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 217472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217484 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217488 */     // (intrinsic_wo_chain:{ *:[v8f16] } 758:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
     /* 217488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 217491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217497 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217499 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217502 */     GIR_RootConstrainSelectedInstOperands,
     /* 217503 */     // GIR_Coverage, 3863,
     /* 217503 */     GIR_EraseRootFromParent_Done,
     /* 217504 */   // Label 4280: @217504
     /* 217504 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(217561), // Rule ID 3864 //
     /* 217509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 217512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 217520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 217523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 217526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 217529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217541 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217545 */     // (intrinsic_wo_chain:{ *:[v8f16] } 759:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
     /* 217545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 217548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217559 */     GIR_RootConstrainSelectedInstOperands,
     /* 217560 */     // GIR_Coverage, 3864,
     /* 217560 */     GIR_EraseRootFromParent_Done,
     /* 217561 */   // Label 4281: @217561
     /* 217561 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(217618), // Rule ID 3869 //
     /* 217566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 217574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217598 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217602 */     // (intrinsic_wo_chain:{ *:[v2f32] } 757:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 217602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 217605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217611 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217616 */     GIR_RootConstrainSelectedInstOperands,
     /* 217617 */     // GIR_Coverage, 3869,
     /* 217617 */     GIR_EraseRootFromParent_Done,
     /* 217618 */   // Label 4282: @217618
     /* 217618 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(217675), // Rule ID 3870 //
     /* 217623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 217631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217659 */     // (intrinsic_wo_chain:{ *:[v2f32] } 760:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 217659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 217662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217668 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217673 */     GIR_RootConstrainSelectedInstOperands,
     /* 217674 */     // GIR_Coverage, 3870,
     /* 217674 */     GIR_EraseRootFromParent_Done,
     /* 217675 */   // Label 4283: @217675
     /* 217675 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(217732), // Rule ID 3871 //
     /* 217680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 217688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217712 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217716 */     // (intrinsic_wo_chain:{ *:[v2f32] } 758:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
     /* 217716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 217719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217725 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217730 */     GIR_RootConstrainSelectedInstOperands,
     /* 217731 */     // GIR_Coverage, 3871,
     /* 217731 */     GIR_EraseRootFromParent_Done,
     /* 217732 */   // Label 4284: @217732
     /* 217732 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(217789), // Rule ID 3872 //
     /* 217737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 217748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 217751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 217754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 217757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 217773 */     // (intrinsic_wo_chain:{ *:[v2f32] } 759:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
     /* 217773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 217776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217787 */     GIR_RootConstrainSelectedInstOperands,
     /* 217788 */     // GIR_Coverage, 3872,
     /* 217788 */     GIR_EraseRootFromParent_Done,
     /* 217789 */   // Label 4285: @217789
     /* 217789 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(217846), // Rule ID 3873 //
     /* 217794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 217802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217826 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217830 */     // (intrinsic_wo_chain:{ *:[v4f32] } 757:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 217830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 217833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 217844 */     GIR_RootConstrainSelectedInstOperands,
     /* 217845 */     // GIR_Coverage, 3873,
     /* 217845 */     GIR_EraseRootFromParent_Done,
     /* 217846 */   // Label 4286: @217846
     /* 217846 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(217903), // Rule ID 3874 //
     /* 217851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 217859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217887 */     // (intrinsic_wo_chain:{ *:[v4f32] } 760:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 217887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 217890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 217901 */     GIR_RootConstrainSelectedInstOperands,
     /* 217902 */     // GIR_Coverage, 3874,
     /* 217902 */     GIR_EraseRootFromParent_Done,
     /* 217903 */   // Label 4287: @217903
     /* 217903 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(217960), // Rule ID 3875 //
     /* 217908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 217916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217925 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217940 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217944 */     // (intrinsic_wo_chain:{ *:[v4f32] } 758:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
     /* 217944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 217947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217953 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 217955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217958 */     GIR_RootConstrainSelectedInstOperands,
     /* 217959 */     // GIR_Coverage, 3875,
     /* 217959 */     GIR_EraseRootFromParent_Done,
     /* 217960 */   // Label 4288: @217960
     /* 217960 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(218017), // Rule ID 3876 //
     /* 217965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217997 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218001 */     // (intrinsic_wo_chain:{ *:[v4f32] } 759:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
     /* 218001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 218004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 218012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 218015 */     GIR_RootConstrainSelectedInstOperands,
     /* 218016 */     // GIR_Coverage, 3876,
     /* 218016 */     GIR_EraseRootFromParent_Done,
     /* 218017 */   // Label 4289: @218017
     /* 218017 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(218074), // Rule ID 3877 //
     /* 218022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 218025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 218030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 218033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 218036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 218039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 218042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218054 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218058 */     // (intrinsic_wo_chain:{ *:[v2f64] } 757:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 218058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 218061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218067 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 218069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 218072 */     GIR_RootConstrainSelectedInstOperands,
     /* 218073 */     // GIR_Coverage, 3877,
     /* 218073 */     GIR_EraseRootFromParent_Done,
     /* 218074 */   // Label 4290: @218074
     /* 218074 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(218131), // Rule ID 3878 //
     /* 218079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 218082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 218087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 218090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 218093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 218096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 218099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218115 */     // (intrinsic_wo_chain:{ *:[v2f64] } 760:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 218115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 218118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218124 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 218126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 218129 */     GIR_RootConstrainSelectedInstOperands,
     /* 218130 */     // GIR_Coverage, 3878,
     /* 218130 */     GIR_EraseRootFromParent_Done,
     /* 218131 */   // Label 4291: @218131
     /* 218131 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(218188), // Rule ID 3879 //
     /* 218136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 218139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 218144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 218147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 218150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 218153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 218156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218168 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218172 */     // (intrinsic_wo_chain:{ *:[v2f64] } 758:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
     /* 218172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 218175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218181 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 218183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 218186 */     GIR_RootConstrainSelectedInstOperands,
     /* 218187 */     // GIR_Coverage, 3879,
     /* 218187 */     GIR_EraseRootFromParent_Done,
     /* 218188 */   // Label 4292: @218188
     /* 218188 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(218245), // Rule ID 3880 //
     /* 218193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 218196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 218201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 218204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 218207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 218210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 218213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218225 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218229 */     // (intrinsic_wo_chain:{ *:[v2f64] } 759:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
     /* 218229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 218232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218238 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 218240 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 218243 */     GIR_RootConstrainSelectedInstOperands,
     /* 218244 */     // GIR_Coverage, 3880,
     /* 218244 */     GIR_EraseRootFromParent_Done,
     /* 218245 */   // Label 4293: @218245
     /* 218245 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(218299), // Rule ID 5215 //
     /* 218250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 218253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 218258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 218267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 218270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 218274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 218278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 218282 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 218286 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 218286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
     /* 218289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218295 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 218297 */     GIR_RootConstrainSelectedInstOperands,
     /* 218298 */     // GIR_Coverage, 5215,
     /* 218298 */     GIR_EraseRootFromParent_Done,
     /* 218299 */   // Label 4294: @218299
     /* 218299 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(218353), // Rule ID 5216 //
     /* 218304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 218307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 218312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 218321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 218324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 218328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 218332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 218336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 218340 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 218340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
     /* 218343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 218351 */     GIR_RootConstrainSelectedInstOperands,
     /* 218352 */     // GIR_Coverage, 5216,
     /* 218352 */     GIR_EraseRootFromParent_Done,
     /* 218353 */   // Label 4295: @218353
     /* 218353 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(218404), // Rule ID 5569 //
     /* 218358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 218363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 218366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 218369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 218372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 218375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218387 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 218391 */     // (intrinsic_wo_chain:{ *:[v8i8] } 720:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 218391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
     /* 218394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 218400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ri
     /* 218402 */     GIR_RootConstrainSelectedInstOperands,
     /* 218403 */     // GIR_Coverage, 5569,
     /* 218403 */     GIR_EraseRootFromParent_Done,
     /* 218404 */   // Label 4296: @218404
     /* 218404 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(218455), // Rule ID 5570 //
     /* 218409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 218414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 218417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 218420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 218423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 218426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218438 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 218442 */     // (intrinsic_wo_chain:{ *:[v16i8] } 720:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 218442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
     /* 218445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 218447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 218449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 218451 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 218453 */     GIR_RootConstrainSelectedInstOperands,
     /* 218454 */     // GIR_Coverage, 5570,
     /* 218454 */     GIR_EraseRootFromParent_Done,
     /* 218455 */   // Label 4297: @218455
     /* 218455 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(218497), // Rule ID 2697 //
     /* 218460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 218471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 218474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 218477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 218480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218484 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1904:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 218484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
     /* 218487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218493 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218495 */     GIR_RootConstrainSelectedInstOperands,
     /* 218496 */     // GIR_Coverage, 2697,
     /* 218496 */     GIR_EraseRootFromParent_Done,
     /* 218497 */   // Label 4298: @218497
     /* 218497 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(218539), // Rule ID 2698 //
     /* 218502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218519 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218526 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1904:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 218529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218535 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218537 */     GIR_RootConstrainSelectedInstOperands,
     /* 218538 */     // GIR_Coverage, 2698,
     /* 218538 */     GIR_EraseRootFromParent_Done,
     /* 218539 */   // Label 4299: @218539
     /* 218539 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(218581), // Rule ID 2699 //
     /* 218544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218568 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1904:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 218571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218577 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218579 */     GIR_RootConstrainSelectedInstOperands,
     /* 218580 */     // GIR_Coverage, 2699,
     /* 218580 */     GIR_EraseRootFromParent_Done,
     /* 218581 */   // Label 4300: @218581
     /* 218581 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(218623), // Rule ID 2700 //
     /* 218586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 218600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218610 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1904:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 218613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218619 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218621 */     GIR_RootConstrainSelectedInstOperands,
     /* 218622 */     // GIR_Coverage, 2700,
     /* 218622 */     GIR_EraseRootFromParent_Done,
     /* 218623 */   // Label 4301: @218623
     /* 218623 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(218665), // Rule ID 2701 //
     /* 218628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218652 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1904:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 218652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 218655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218661 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218663 */     GIR_RootConstrainSelectedInstOperands,
     /* 218664 */     // GIR_Coverage, 2701,
     /* 218664 */     GIR_EraseRootFromParent_Done,
     /* 218665 */   // Label 4302: @218665
     /* 218665 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(218707), // Rule ID 2702 //
     /* 218670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 218687 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 218690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218694 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1904:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 218694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 218697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218703 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218705 */     GIR_RootConstrainSelectedInstOperands,
     /* 218706 */     // GIR_Coverage, 2702,
     /* 218706 */     GIR_EraseRootFromParent_Done,
     /* 218707 */   // Label 4303: @218707
     /* 218707 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(218749), // Rule ID 2703 //
     /* 218712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 218715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 218720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 218723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 218726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 218729 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 218732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218736 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1904:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 218736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 218739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 218741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218745 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218747 */     GIR_RootConstrainSelectedInstOperands,
     /* 218748 */     // GIR_Coverage, 2703,
     /* 218748 */     GIR_EraseRootFromParent_Done,
     /* 218749 */   // Label 4304: @218749
     /* 218749 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(218791), // Rule ID 2742 //
     /* 218754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 218762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 218765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 218768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 218771 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 218774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 218778 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1250:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 218778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 218781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218787 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218789 */     GIR_RootConstrainSelectedInstOperands,
     /* 218790 */     // GIR_Coverage, 2742,
     /* 218790 */     GIR_EraseRootFromParent_Done,
     /* 218791 */   // Label 4305: @218791
     /* 218791 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(218833), // Rule ID 2743 //
     /* 218796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 218804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 218807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 218813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 218816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 218820 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1250:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 218820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 218823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218829 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218831 */     GIR_RootConstrainSelectedInstOperands,
     /* 218832 */     // GIR_Coverage, 2743,
     /* 218832 */     GIR_EraseRootFromParent_Done,
     /* 218833 */   // Label 4306: @218833
     /* 218833 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(218875), // Rule ID 2744 //
     /* 218838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 218846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 218849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 218852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 218855 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 218858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 218862 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1250:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 218862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 218865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218871 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218873 */     GIR_RootConstrainSelectedInstOperands,
     /* 218874 */     // GIR_Coverage, 2744,
     /* 218874 */     GIR_EraseRootFromParent_Done,
     /* 218875 */   // Label 4307: @218875
     /* 218875 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(218917), // Rule ID 2745 //
     /* 218880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 218888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 218891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 218894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 218897 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 218900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 218904 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1250:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 218904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 218907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218913 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218915 */     GIR_RootConstrainSelectedInstOperands,
     /* 218916 */     // GIR_Coverage, 2745,
     /* 218916 */     GIR_EraseRootFromParent_Done,
     /* 218917 */   // Label 4308: @218917
     /* 218917 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(218959), // Rule ID 2746 //
     /* 218922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 218930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 218933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 218936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 218939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 218942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 218946 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1250:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 218946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 218949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 218951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218955 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218957 */     GIR_RootConstrainSelectedInstOperands,
     /* 218958 */     // GIR_Coverage, 2746,
     /* 218958 */     GIR_EraseRootFromParent_Done,
     /* 218959 */   // Label 4309: @218959
     /* 218959 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(219001), // Rule ID 2785 //
     /* 218964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 218972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 218978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 218981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 218984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218988 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1349:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 218988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
     /* 218991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 218995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 218997 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 218999 */     GIR_RootConstrainSelectedInstOperands,
     /* 219000 */     // GIR_Coverage, 2785,
     /* 219000 */     GIR_EraseRootFromParent_Done,
     /* 219001 */   // Label 4310: @219001
     /* 219001 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(219043), // Rule ID 2787 //
     /* 219006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 219014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219030 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1349:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
     /* 219033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219041 */     GIR_RootConstrainSelectedInstOperands,
     /* 219042 */     // GIR_Coverage, 2787,
     /* 219042 */     GIR_EraseRootFromParent_Done,
     /* 219043 */   // Label 4311: @219043
     /* 219043 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(219085), // Rule ID 2789 //
     /* 219048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 219056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219072 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1349:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
     /* 219075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219081 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219083 */     GIR_RootConstrainSelectedInstOperands,
     /* 219084 */     // GIR_Coverage, 2789,
     /* 219084 */     GIR_EraseRootFromParent_Done,
     /* 219085 */   // Label 4312: @219085
     /* 219085 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(219127), // Rule ID 2791 //
     /* 219090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 219098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219114 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1523:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
     /* 219117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219123 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219125 */     GIR_RootConstrainSelectedInstOperands,
     /* 219126 */     // GIR_Coverage, 2791,
     /* 219126 */     GIR_EraseRootFromParent_Done,
     /* 219127 */   // Label 4313: @219127
     /* 219127 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(219169), // Rule ID 2792 //
     /* 219132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 219140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219156 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1523:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
     /* 219159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219167 */     GIR_RootConstrainSelectedInstOperands,
     /* 219168 */     // GIR_Coverage, 2792,
     /* 219168 */     GIR_EraseRootFromParent_Done,
     /* 219169 */   // Label 4314: @219169
     /* 219169 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(219211), // Rule ID 2793 //
     /* 219174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 219182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219198 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1523:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
     /* 219201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219207 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219209 */     GIR_RootConstrainSelectedInstOperands,
     /* 219210 */     // GIR_Coverage, 2793,
     /* 219210 */     GIR_EraseRootFromParent_Done,
     /* 219211 */   // Label 4315: @219211
     /* 219211 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(219253), // Rule ID 2862 //
     /* 219216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
     /* 219224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219240 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1385:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
     /* 219243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219249 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219251 */     GIR_RootConstrainSelectedInstOperands,
     /* 219252 */     // GIR_Coverage, 2862,
     /* 219252 */     GIR_EraseRootFromParent_Done,
     /* 219253 */   // Label 4316: @219253
     /* 219253 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(219295), // Rule ID 2863 //
     /* 219258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
     /* 219266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 219275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219282 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1386:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
     /* 219285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219293 */     GIR_RootConstrainSelectedInstOperands,
     /* 219294 */     // GIR_Coverage, 2863,
     /* 219294 */     GIR_EraseRootFromParent_Done,
     /* 219295 */   // Label 4317: @219295
     /* 219295 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(219337), // Rule ID 2864 //
     /* 219300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
     /* 219308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219324 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1381:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
     /* 219327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219333 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219335 */     GIR_RootConstrainSelectedInstOperands,
     /* 219336 */     // GIR_Coverage, 2864,
     /* 219336 */     GIR_EraseRootFromParent_Done,
     /* 219337 */   // Label 4318: @219337
     /* 219337 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(219379), // Rule ID 2865 //
     /* 219342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
     /* 219350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 219359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219366 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1382:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
     /* 219369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219375 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219377 */     GIR_RootConstrainSelectedInstOperands,
     /* 219378 */     // GIR_Coverage, 2865,
     /* 219378 */     GIR_EraseRootFromParent_Done,
     /* 219379 */   // Label 4319: @219379
     /* 219379 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(219421), // Rule ID 2866 //
     /* 219384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
     /* 219392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 219401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219408 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1388:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
     /* 219411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219417 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219419 */     GIR_RootConstrainSelectedInstOperands,
     /* 219420 */     // GIR_Coverage, 2866,
     /* 219420 */     GIR_EraseRootFromParent_Done,
     /* 219421 */   // Label 4320: @219421
     /* 219421 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(219463), // Rule ID 2867 //
     /* 219426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 219434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 219440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219450 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1352:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
     /* 219453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219461 */     GIR_RootConstrainSelectedInstOperands,
     /* 219462 */     // GIR_Coverage, 2867,
     /* 219462 */     GIR_EraseRootFromParent_Done,
     /* 219463 */   // Label 4321: @219463
     /* 219463 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(219505), // Rule ID 2868 //
     /* 219468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 219476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219492 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1352:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
     /* 219495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219501 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219503 */     GIR_RootConstrainSelectedInstOperands,
     /* 219504 */     // GIR_Coverage, 2868,
     /* 219504 */     GIR_EraseRootFromParent_Done,
     /* 219505 */   // Label 4322: @219505
     /* 219505 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(219547), // Rule ID 2869 //
     /* 219510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 219518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219534 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1352:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
     /* 219537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219543 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219545 */     GIR_RootConstrainSelectedInstOperands,
     /* 219546 */     // GIR_Coverage, 2869,
     /* 219546 */     GIR_EraseRootFromParent_Done,
     /* 219547 */   // Label 4323: @219547
     /* 219547 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(219589), // Rule ID 2880 //
     /* 219552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
     /* 219560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219576 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1374:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
     /* 219579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219585 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219587 */     GIR_RootConstrainSelectedInstOperands,
     /* 219588 */     // GIR_Coverage, 2880,
     /* 219588 */     GIR_EraseRootFromParent_Done,
     /* 219589 */   // Label 4324: @219589
     /* 219589 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(219631), // Rule ID 2882 //
     /* 219594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
     /* 219602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219618 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1372:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
     /* 219621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219629 */     GIR_RootConstrainSelectedInstOperands,
     /* 219630 */     // GIR_Coverage, 2882,
     /* 219630 */     GIR_EraseRootFromParent_Done,
     /* 219631 */   // Label 4325: @219631
     /* 219631 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(219673), // Rule ID 2890 //
     /* 219636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 219644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 219653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219660 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1409:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 219660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
     /* 219663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219671 */     GIR_RootConstrainSelectedInstOperands,
     /* 219672 */     // GIR_Coverage, 2890,
     /* 219672 */     GIR_EraseRootFromParent_Done,
     /* 219673 */   // Label 4326: @219673
     /* 219673 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(219715), // Rule ID 2891 //
     /* 219678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 219686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 219695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219702 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1409:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 219702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
     /* 219705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219711 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219713 */     GIR_RootConstrainSelectedInstOperands,
     /* 219714 */     // GIR_Coverage, 2891,
     /* 219714 */     GIR_EraseRootFromParent_Done,
     /* 219715 */   // Label 4327: @219715
     /* 219715 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(219757), // Rule ID 2892 //
     /* 219720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 219728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 219737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219744 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1409:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
     /* 219747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219755 */     GIR_RootConstrainSelectedInstOperands,
     /* 219756 */     // GIR_Coverage, 2892,
     /* 219756 */     GIR_EraseRootFromParent_Done,
     /* 219757 */   // Label 4328: @219757
     /* 219757 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(219799), // Rule ID 2896 //
     /* 219762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
     /* 219770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 219779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219786 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1387:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 219786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
     /* 219789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 219791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219795 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219797 */     GIR_RootConstrainSelectedInstOperands,
     /* 219798 */     // GIR_Coverage, 2896,
     /* 219798 */     GIR_EraseRootFromParent_Done,
     /* 219799 */   // Label 4329: @219799
     /* 219799 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(219841), // Rule ID 2941 //
     /* 219804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 219812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 219818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219828 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1692:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
     /* 219831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219837 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219839 */     GIR_RootConstrainSelectedInstOperands,
     /* 219840 */     // GIR_Coverage, 2941,
     /* 219840 */     GIR_EraseRootFromParent_Done,
     /* 219841 */   // Label 4330: @219841
     /* 219841 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(219883), // Rule ID 2942 //
     /* 219846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 219854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 219860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 219863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 219866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219870 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1692:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 219870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
     /* 219873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219879 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219881 */     GIR_RootConstrainSelectedInstOperands,
     /* 219882 */     // GIR_Coverage, 2942,
     /* 219882 */     GIR_EraseRootFromParent_Done,
     /* 219883 */   // Label 4331: @219883
     /* 219883 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(219925), // Rule ID 2971 //
     /* 219888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 219896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 219899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 219902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 219905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 219908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219912 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1808:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 219912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
     /* 219915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219921 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219923 */     GIR_RootConstrainSelectedInstOperands,
     /* 219924 */     // GIR_Coverage, 2971,
     /* 219924 */     GIR_EraseRootFromParent_Done,
     /* 219925 */   // Label 4332: @219925
     /* 219925 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(219967), // Rule ID 2972 //
     /* 219930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 219938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 219941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 219944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 219947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 219950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219954 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1808:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 219954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
     /* 219957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 219959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 219961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 219963 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 219965 */     GIR_RootConstrainSelectedInstOperands,
     /* 219966 */     // GIR_Coverage, 2972,
     /* 219966 */     GIR_EraseRootFromParent_Done,
     /* 219967 */   // Label 4333: @219967
     /* 219967 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(220009), // Rule ID 2973 //
     /* 219972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 219975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 219980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 219989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 219992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219996 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1808:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 219996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
     /* 219999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220005 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220007 */     GIR_RootConstrainSelectedInstOperands,
     /* 220008 */     // GIR_Coverage, 2973,
     /* 220008 */     GIR_EraseRootFromParent_Done,
     /* 220009 */   // Label 4334: @220009
     /* 220009 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(220051), // Rule ID 2974 //
     /* 220014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 220022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220038 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1808:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
     /* 220041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220047 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220049 */     GIR_RootConstrainSelectedInstOperands,
     /* 220050 */     // GIR_Coverage, 2974,
     /* 220050 */     GIR_EraseRootFromParent_Done,
     /* 220051 */   // Label 4335: @220051
     /* 220051 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(220093), // Rule ID 2975 //
     /* 220056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 220064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220080 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1729:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
     /* 220083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220089 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220091 */     GIR_RootConstrainSelectedInstOperands,
     /* 220092 */     // GIR_Coverage, 2975,
     /* 220092 */     GIR_EraseRootFromParent_Done,
     /* 220093 */   // Label 4336: @220093
     /* 220093 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(220135), // Rule ID 2976 //
     /* 220098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 220106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220122 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1729:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
     /* 220125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220131 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220133 */     GIR_RootConstrainSelectedInstOperands,
     /* 220134 */     // GIR_Coverage, 2976,
     /* 220134 */     GIR_EraseRootFromParent_Done,
     /* 220135 */   // Label 4337: @220135
     /* 220135 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(220177), // Rule ID 2977 //
     /* 220140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 220148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1729:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
     /* 220167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220175 */     GIR_RootConstrainSelectedInstOperands,
     /* 220176 */     // GIR_Coverage, 2977,
     /* 220176 */     GIR_EraseRootFromParent_Done,
     /* 220177 */   // Label 4338: @220177
     /* 220177 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(220219), // Rule ID 3007 //
     /* 220182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 220190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 220196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220206 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1703:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
     /* 220209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220217 */     GIR_RootConstrainSelectedInstOperands,
     /* 220218 */     // GIR_Coverage, 3007,
     /* 220218 */     GIR_EraseRootFromParent_Done,
     /* 220219 */   // Label 4339: @220219
     /* 220219 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(220261), // Rule ID 3009 //
     /* 220224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 220232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220248 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1703:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
     /* 220251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220257 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220259 */     GIR_RootConstrainSelectedInstOperands,
     /* 220260 */     // GIR_Coverage, 3009,
     /* 220260 */     GIR_EraseRootFromParent_Done,
     /* 220261 */   // Label 4340: @220261
     /* 220261 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(220303), // Rule ID 3011 //
     /* 220266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 220274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220290 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1703:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
     /* 220293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220301 */     GIR_RootConstrainSelectedInstOperands,
     /* 220302 */     // GIR_Coverage, 3011,
     /* 220302 */     GIR_EraseRootFromParent_Done,
     /* 220303 */   // Label 4341: @220303
     /* 220303 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(220345), // Rule ID 3013 //
     /* 220308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 220316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220332 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1703:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
     /* 220335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 220337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220341 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220343 */     GIR_RootConstrainSelectedInstOperands,
     /* 220344 */     // GIR_Coverage, 3013,
     /* 220344 */     GIR_EraseRootFromParent_Done,
     /* 220345 */   // Label 4342: @220345
     /* 220345 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(220387), // Rule ID 3015 //
     /* 220350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 220358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 220364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220374 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1673:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
     /* 220377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220385 */     GIR_RootConstrainSelectedInstOperands,
     /* 220386 */     // GIR_Coverage, 3015,
     /* 220386 */     GIR_EraseRootFromParent_Done,
     /* 220387 */   // Label 4343: @220387
     /* 220387 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(220429), // Rule ID 3016 //
     /* 220392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 220400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 220406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220416 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1673:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
     /* 220419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220427 */     GIR_RootConstrainSelectedInstOperands,
     /* 220428 */     // GIR_Coverage, 3016,
     /* 220428 */     GIR_EraseRootFromParent_Done,
     /* 220429 */   // Label 4344: @220429
     /* 220429 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(220471), // Rule ID 3017 //
     /* 220434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 220442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 220448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220458 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1673:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
     /* 220461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220467 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220469 */     GIR_RootConstrainSelectedInstOperands,
     /* 220470 */     // GIR_Coverage, 3017,
     /* 220470 */     GIR_EraseRootFromParent_Done,
     /* 220471 */   // Label 4345: @220471
     /* 220471 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(220513), // Rule ID 3018 //
     /* 220476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 220484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220500 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2032:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
     /* 220503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220509 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220511 */     GIR_RootConstrainSelectedInstOperands,
     /* 220512 */     // GIR_Coverage, 3018,
     /* 220512 */     GIR_EraseRootFromParent_Done,
     /* 220513 */   // Label 4346: @220513
     /* 220513 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(220555), // Rule ID 3019 //
     /* 220518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 220526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 220535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220542 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1745:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
     /* 220545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220551 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220553 */     GIR_RootConstrainSelectedInstOperands,
     /* 220554 */     // GIR_Coverage, 3019,
     /* 220554 */     GIR_EraseRootFromParent_Done,
     /* 220555 */   // Label 4347: @220555
     /* 220555 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(220597), // Rule ID 3020 //
     /* 220560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 220568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 220577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220584 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1745:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
     /* 220587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220595 */     GIR_RootConstrainSelectedInstOperands,
     /* 220596 */     // GIR_Coverage, 3020,
     /* 220596 */     GIR_EraseRootFromParent_Done,
     /* 220597 */   // Label 4348: @220597
     /* 220597 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(220639), // Rule ID 3021 //
     /* 220602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 220610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 220619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220626 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1745:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
     /* 220629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220635 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220637 */     GIR_RootConstrainSelectedInstOperands,
     /* 220638 */     // GIR_Coverage, 3021,
     /* 220638 */     GIR_EraseRootFromParent_Done,
     /* 220639 */   // Label 4349: @220639
     /* 220639 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(220681), // Rule ID 3022 //
     /* 220644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 220652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 220661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220668 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1745:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
     /* 220671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220677 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220679 */     GIR_RootConstrainSelectedInstOperands,
     /* 220680 */     // GIR_Coverage, 3022,
     /* 220680 */     GIR_EraseRootFromParent_Done,
     /* 220681 */   // Label 4350: @220681
     /* 220681 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(220723), // Rule ID 3039 //
     /* 220686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 220694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220710 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1338:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
     /* 220713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220719 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220721 */     GIR_RootConstrainSelectedInstOperands,
     /* 220722 */     // GIR_Coverage, 3039,
     /* 220722 */     GIR_EraseRootFromParent_Done,
     /* 220723 */   // Label 4351: @220723
     /* 220723 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(220765), // Rule ID 3040 //
     /* 220728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 220736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220752 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1338:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
     /* 220755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220763 */     GIR_RootConstrainSelectedInstOperands,
     /* 220764 */     // GIR_Coverage, 3040,
     /* 220764 */     GIR_EraseRootFromParent_Done,
     /* 220765 */   // Label 4352: @220765
     /* 220765 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(220807), // Rule ID 3041 //
     /* 220770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 220778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220794 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1338:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
     /* 220797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220803 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220805 */     GIR_RootConstrainSelectedInstOperands,
     /* 220806 */     // GIR_Coverage, 3041,
     /* 220806 */     GIR_EraseRootFromParent_Done,
     /* 220807 */   // Label 4353: @220807
     /* 220807 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(220849), // Rule ID 3042 //
     /* 220812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 220820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 220832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220836 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1338:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 220836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
     /* 220839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 220841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220845 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220847 */     GIR_RootConstrainSelectedInstOperands,
     /* 220848 */     // GIR_Coverage, 3042,
     /* 220848 */     GIR_EraseRootFromParent_Done,
     /* 220849 */   // Label 4354: @220849
     /* 220849 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(220891), // Rule ID 3066 //
     /* 220854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 220862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 220865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 220868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 220871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 220874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220878 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1666:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 220878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
     /* 220881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220887 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220889 */     GIR_RootConstrainSelectedInstOperands,
     /* 220890 */     // GIR_Coverage, 3066,
     /* 220890 */     GIR_EraseRootFromParent_Done,
     /* 220891 */   // Label 4355: @220891
     /* 220891 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(220933), // Rule ID 3068 //
     /* 220896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 220904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 220907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 220910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 220913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 220916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220920 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1666:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 220920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
     /* 220923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220931 */     GIR_RootConstrainSelectedInstOperands,
     /* 220932 */     // GIR_Coverage, 3068,
     /* 220932 */     GIR_EraseRootFromParent_Done,
     /* 220933 */   // Label 4356: @220933
     /* 220933 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(220975), // Rule ID 3070 //
     /* 220938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 220946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 220949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 220952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 220955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 220958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 220962 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1666:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 220962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
     /* 220965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 220967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 220969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 220971 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 220973 */     GIR_RootConstrainSelectedInstOperands,
     /* 220974 */     // GIR_Coverage, 3070,
     /* 220974 */     GIR_EraseRootFromParent_Done,
     /* 220975 */   // Label 4357: @220975
     /* 220975 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(221017), // Rule ID 3072 //
     /* 220980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 220983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 220988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 220991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 220994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 220997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221004 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1666:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
     /* 221007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221013 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221015 */     GIR_RootConstrainSelectedInstOperands,
     /* 221016 */     // GIR_Coverage, 3072,
     /* 221016 */     GIR_EraseRootFromParent_Done,
     /* 221017 */   // Label 4358: @221017
     /* 221017 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(221059), // Rule ID 3074 //
     /* 221022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 221030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221046 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1667:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
     /* 221049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221055 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221057 */     GIR_RootConstrainSelectedInstOperands,
     /* 221058 */     // GIR_Coverage, 3074,
     /* 221058 */     GIR_EraseRootFromParent_Done,
     /* 221059 */   // Label 4359: @221059
     /* 221059 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(221101), // Rule ID 3075 //
     /* 221064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 221072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221088 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1667:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
     /* 221091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221099 */     GIR_RootConstrainSelectedInstOperands,
     /* 221100 */     // GIR_Coverage, 3075,
     /* 221100 */     GIR_EraseRootFromParent_Done,
     /* 221101 */   // Label 4360: @221101
     /* 221101 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(221143), // Rule ID 3076 //
     /* 221106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 221114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221130 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1667:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
     /* 221133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221141 */     GIR_RootConstrainSelectedInstOperands,
     /* 221142 */     // GIR_Coverage, 3076,
     /* 221142 */     GIR_EraseRootFromParent_Done,
     /* 221143 */   // Label 4361: @221143
     /* 221143 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(221185), // Rule ID 3077 //
     /* 221148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 221156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221172 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1230:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
     /* 221175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221181 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221183 */     GIR_RootConstrainSelectedInstOperands,
     /* 221184 */     // GIR_Coverage, 3077,
     /* 221184 */     GIR_EraseRootFromParent_Done,
     /* 221185 */   // Label 4362: @221185
     /* 221185 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(221227), // Rule ID 3078 //
     /* 221190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 221198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221214 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1230:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
     /* 221217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 221219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221223 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221225 */     GIR_RootConstrainSelectedInstOperands,
     /* 221226 */     // GIR_Coverage, 3078,
     /* 221226 */     GIR_EraseRootFromParent_Done,
     /* 221227 */   // Label 4363: @221227
     /* 221227 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(221269), // Rule ID 3088 //
     /* 221232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 221240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 221246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221256 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1237:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
     /* 221259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221267 */     GIR_RootConstrainSelectedInstOperands,
     /* 221268 */     // GIR_Coverage, 3088,
     /* 221268 */     GIR_EraseRootFromParent_Done,
     /* 221269 */   // Label 4364: @221269
     /* 221269 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(221311), // Rule ID 3089 //
     /* 221274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 221282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221298 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1237:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
     /* 221301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221307 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221309 */     GIR_RootConstrainSelectedInstOperands,
     /* 221310 */     // GIR_Coverage, 3089,
     /* 221310 */     GIR_EraseRootFromParent_Done,
     /* 221311 */   // Label 4365: @221311
     /* 221311 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(221353), // Rule ID 3090 //
     /* 221316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 221324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221340 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1237:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
     /* 221343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221351 */     GIR_RootConstrainSelectedInstOperands,
     /* 221352 */     // GIR_Coverage, 3090,
     /* 221352 */     GIR_EraseRootFromParent_Done,
     /* 221353 */   // Label 4366: @221353
     /* 221353 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(221395), // Rule ID 3107 //
     /* 221358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 221366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 221372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 221375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221382 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1296:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 221382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
     /* 221385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 221389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 221391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 221393 */     GIR_RootConstrainSelectedInstOperands,
     /* 221394 */     // GIR_Coverage, 3107,
     /* 221394 */     GIR_EraseRootFromParent_Done,
     /* 221395 */   // Label 4367: @221395
     /* 221395 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(221437), // Rule ID 3108 //
     /* 221400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 221408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 221417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221424 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1296:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 221424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
     /* 221427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 221431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 221433 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 221435 */     GIR_RootConstrainSelectedInstOperands,
     /* 221436 */     // GIR_Coverage, 3108,
     /* 221436 */     GIR_EraseRootFromParent_Done,
     /* 221437 */   // Label 4368: @221437
     /* 221437 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(221479), // Rule ID 3109 //
     /* 221442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 221450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 221459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221466 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1296:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 221466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
     /* 221469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 221473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 221475 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 221477 */     GIR_RootConstrainSelectedInstOperands,
     /* 221478 */     // GIR_Coverage, 3109,
     /* 221478 */     GIR_EraseRootFromParent_Done,
     /* 221479 */   // Label 4369: @221479
     /* 221479 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(221521), // Rule ID 3110 //
     /* 221484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 221492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 221501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221508 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1296:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 221508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
     /* 221511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 221513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 221515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 221517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 221519 */     GIR_RootConstrainSelectedInstOperands,
     /* 221520 */     // GIR_Coverage, 3110,
     /* 221520 */     GIR_EraseRootFromParent_Done,
     /* 221521 */   // Label 4370: @221521
     /* 221521 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(221563), // Rule ID 3145 //
     /* 221526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 221534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 221537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 221540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 221546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221550 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1337:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 221550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 221553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221559 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221561 */     GIR_RootConstrainSelectedInstOperands,
     /* 221562 */     // GIR_Coverage, 3145,
     /* 221562 */     GIR_EraseRootFromParent_Done,
     /* 221563 */   // Label 4371: @221563
     /* 221563 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(221605), // Rule ID 3147 //
     /* 221568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 221576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 221582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221592 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1337:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 221592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 221595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221601 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221603 */     GIR_RootConstrainSelectedInstOperands,
     /* 221604 */     // GIR_Coverage, 3147,
     /* 221604 */     GIR_EraseRootFromParent_Done,
     /* 221605 */   // Label 4372: @221605
     /* 221605 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(221647), // Rule ID 3149 //
     /* 221610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 221618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 221624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221634 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1337:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 221634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 221637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221645 */     GIR_RootConstrainSelectedInstOperands,
     /* 221646 */     // GIR_Coverage, 3149,
     /* 221646 */     GIR_EraseRootFromParent_Done,
     /* 221647 */   // Label 4373: @221647
     /* 221647 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(221689), // Rule ID 3151 //
     /* 221652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 221655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 221660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 221666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221676 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1337:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 221679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221687 */     GIR_RootConstrainSelectedInstOperands,
     /* 221688 */     // GIR_Coverage, 3151,
     /* 221688 */     GIR_EraseRootFromParent_Done,
     /* 221689 */   // Label 4374: @221689
     /* 221689 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(221734), // Rule ID 3190 //
     /* 221694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 221702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221718 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1301:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
     /* 221721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221727 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221729 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221732 */     GIR_RootConstrainSelectedInstOperands,
     /* 221733 */     // GIR_Coverage, 3190,
     /* 221733 */     GIR_EraseRootFromParent_Done,
     /* 221734 */   // Label 4375: @221734
     /* 221734 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(221779), // Rule ID 3191 //
     /* 221739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 221747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221763 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1301:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
     /* 221766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221772 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221774 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221777 */     GIR_RootConstrainSelectedInstOperands,
     /* 221778 */     // GIR_Coverage, 3191,
     /* 221778 */     GIR_EraseRootFromParent_Done,
     /* 221779 */   // Label 4376: @221779
     /* 221779 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(221824), // Rule ID 3192 //
     /* 221784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 221792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221808 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1301:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
     /* 221811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221817 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221819 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221822 */     GIR_RootConstrainSelectedInstOperands,
     /* 221823 */     // GIR_Coverage, 3192,
     /* 221823 */     GIR_EraseRootFromParent_Done,
     /* 221824 */   // Label 4377: @221824
     /* 221824 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(221869), // Rule ID 3193 //
     /* 221829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 221837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 221840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 221843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 221846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221853 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1303:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
     /* 221856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221864 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221867 */     GIR_RootConstrainSelectedInstOperands,
     /* 221868 */     // GIR_Coverage, 3193,
     /* 221868 */     GIR_EraseRootFromParent_Done,
     /* 221869 */   // Label 4378: @221869
     /* 221869 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(221914), // Rule ID 3194 //
     /* 221874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 221882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221898 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1303:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
     /* 221901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221909 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221912 */     GIR_RootConstrainSelectedInstOperands,
     /* 221913 */     // GIR_Coverage, 3194,
     /* 221913 */     GIR_EraseRootFromParent_Done,
     /* 221914 */   // Label 4379: @221914
     /* 221914 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(221959), // Rule ID 3195 //
     /* 221919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 221927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 221930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221943 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1303:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 221943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
     /* 221946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221952 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221954 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 221957 */     GIR_RootConstrainSelectedInstOperands,
     /* 221958 */     // GIR_Coverage, 3195,
     /* 221958 */     GIR_EraseRootFromParent_Done,
     /* 221959 */   // Label 4380: @221959
     /* 221959 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(222001), // Rule ID 3250 //
     /* 221964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 221972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 221975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 221988 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1347:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 221988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
     /* 221991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 221993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 221995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 221997 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 221999 */     GIR_RootConstrainSelectedInstOperands,
     /* 222000 */     // GIR_Coverage, 3250,
     /* 222000 */     GIR_EraseRootFromParent_Done,
     /* 222001 */   // Label 4381: @222001
     /* 222001 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(222043), // Rule ID 3251 //
     /* 222006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 222014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 222017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222023 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222030 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1347:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 222030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
     /* 222033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222041 */     GIR_RootConstrainSelectedInstOperands,
     /* 222042 */     // GIR_Coverage, 3251,
     /* 222042 */     GIR_EraseRootFromParent_Done,
     /* 222043 */   // Label 4382: @222043
     /* 222043 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(222085), // Rule ID 3252 //
     /* 222048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 222056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 222059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222072 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1347:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 222072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
     /* 222075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222081 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222083 */     GIR_RootConstrainSelectedInstOperands,
     /* 222084 */     // GIR_Coverage, 3252,
     /* 222084 */     GIR_EraseRootFromParent_Done,
     /* 222085 */   // Label 4383: @222085
     /* 222085 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(222127), // Rule ID 3304 //
     /* 222090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 222098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222114 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1253:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
     /* 222117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222121 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222123 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222125 */     GIR_RootConstrainSelectedInstOperands,
     /* 222126 */     // GIR_Coverage, 3304,
     /* 222126 */     GIR_EraseRootFromParent_Done,
     /* 222127 */   // Label 4384: @222127
     /* 222127 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(222169), // Rule ID 3305 //
     /* 222132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 222140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222156 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1253:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
     /* 222159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222167 */     GIR_RootConstrainSelectedInstOperands,
     /* 222168 */     // GIR_Coverage, 3305,
     /* 222168 */     GIR_EraseRootFromParent_Done,
     /* 222169 */   // Label 4385: @222169
     /* 222169 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(222211), // Rule ID 3306 //
     /* 222174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 222182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222198 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1253:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
     /* 222201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222207 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222209 */     GIR_RootConstrainSelectedInstOperands,
     /* 222210 */     // GIR_Coverage, 3306,
     /* 222210 */     GIR_EraseRootFromParent_Done,
     /* 222211 */   // Label 4386: @222211
     /* 222211 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(222253), // Rule ID 3307 //
     /* 222216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 222224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222233 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222240 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1253:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
     /* 222243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222249 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222251 */     GIR_RootConstrainSelectedInstOperands,
     /* 222252 */     // GIR_Coverage, 3307,
     /* 222252 */     GIR_EraseRootFromParent_Done,
     /* 222253 */   // Label 4387: @222253
     /* 222253 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(222295), // Rule ID 3316 //
     /* 222258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 222266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222275 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222282 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1255:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
     /* 222285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222291 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222293 */     GIR_RootConstrainSelectedInstOperands,
     /* 222294 */     // GIR_Coverage, 3316,
     /* 222294 */     GIR_EraseRootFromParent_Done,
     /* 222295 */   // Label 4388: @222295
     /* 222295 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(222337), // Rule ID 3317 //
     /* 222300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 222308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222324 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1255:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
     /* 222327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222333 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222335 */     GIR_RootConstrainSelectedInstOperands,
     /* 222336 */     // GIR_Coverage, 3317,
     /* 222336 */     GIR_EraseRootFromParent_Done,
     /* 222337 */   // Label 4389: @222337
     /* 222337 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(222379), // Rule ID 3318 //
     /* 222342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 222350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222356 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222359 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222366 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1255:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
     /* 222369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222375 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222377 */     GIR_RootConstrainSelectedInstOperands,
     /* 222378 */     // GIR_Coverage, 3318,
     /* 222378 */     GIR_EraseRootFromParent_Done,
     /* 222379 */   // Label 4390: @222379
     /* 222379 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(222421), // Rule ID 3357 //
     /* 222384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 222395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222408 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1292:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
     /* 222411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222415 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222417 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222419 */     GIR_RootConstrainSelectedInstOperands,
     /* 222420 */     // GIR_Coverage, 3357,
     /* 222420 */     GIR_EraseRootFromParent_Done,
     /* 222421 */   // Label 4391: @222421
     /* 222421 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(222463), // Rule ID 3358 //
     /* 222426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222450 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1292:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 222453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222459 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222461 */     GIR_RootConstrainSelectedInstOperands,
     /* 222462 */     // GIR_Coverage, 3358,
     /* 222462 */     GIR_EraseRootFromParent_Done,
     /* 222463 */   // Label 4392: @222463
     /* 222463 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(222505), // Rule ID 3359 //
     /* 222468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222485 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222492 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1292:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 222495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222501 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222503 */     GIR_RootConstrainSelectedInstOperands,
     /* 222504 */     // GIR_Coverage, 3359,
     /* 222504 */     GIR_EraseRootFromParent_Done,
     /* 222505 */   // Label 4393: @222505
     /* 222505 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(222547), // Rule ID 3360 //
     /* 222510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222527 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222534 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1292:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 222537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222543 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222545 */     GIR_RootConstrainSelectedInstOperands,
     /* 222546 */     // GIR_Coverage, 3360,
     /* 222546 */     GIR_EraseRootFromParent_Done,
     /* 222547 */   // Label 4394: @222547
     /* 222547 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(222589), // Rule ID 3361 //
     /* 222552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222576 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1292:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 222576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 222579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222585 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222587 */     GIR_RootConstrainSelectedInstOperands,
     /* 222588 */     // GIR_Coverage, 3361,
     /* 222588 */     GIR_EraseRootFromParent_Done,
     /* 222589 */   // Label 4395: @222589
     /* 222589 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(222631), // Rule ID 3362 //
     /* 222594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222618 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1292:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 222618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 222621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222629 */     GIR_RootConstrainSelectedInstOperands,
     /* 222630 */     // GIR_Coverage, 3362,
     /* 222630 */     GIR_EraseRootFromParent_Done,
     /* 222631 */   // Label 4396: @222631
     /* 222631 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(222673), // Rule ID 3363 //
     /* 222636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 222644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222653 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222660 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1292:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 222660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 222663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222671 */     GIR_RootConstrainSelectedInstOperands,
     /* 222672 */     // GIR_Coverage, 3363,
     /* 222672 */     GIR_EraseRootFromParent_Done,
     /* 222673 */   // Label 4397: @222673
     /* 222673 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(222715), // Rule ID 3446 //
     /* 222678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
     /* 222686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 222695 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 222698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222702 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1284:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 222702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
     /* 222705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222711 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222713 */     GIR_RootConstrainSelectedInstOperands,
     /* 222714 */     // GIR_Coverage, 3446,
     /* 222714 */     GIR_EraseRootFromParent_Done,
     /* 222715 */   // Label 4398: @222715
     /* 222715 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(222757), // Rule ID 3447 //
     /* 222720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
     /* 222728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 222737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 222740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222744 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1283:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 222744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
     /* 222747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
     /* 222749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222753 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222755 */     GIR_RootConstrainSelectedInstOperands,
     /* 222756 */     // GIR_Coverage, 3447,
     /* 222756 */     GIR_EraseRootFromParent_Done,
     /* 222757 */   // Label 4399: @222757
     /* 222757 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(222799), // Rule ID 3448 //
     /* 222762 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222765 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
     /* 222770 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 222779 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 222782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222786 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1279:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 222786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
     /* 222789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222795 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222797 */     GIR_RootConstrainSelectedInstOperands,
     /* 222798 */     // GIR_Coverage, 3448,
     /* 222798 */     GIR_EraseRootFromParent_Done,
     /* 222799 */   // Label 4400: @222799
     /* 222799 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(222844), // Rule ID 3450 //
     /* 222804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 222807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 222812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 222815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 222818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222821 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222828 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1586:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 222828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
     /* 222831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222837 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222839 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222842 */     GIR_RootConstrainSelectedInstOperands,
     /* 222843 */     // GIR_Coverage, 3450,
     /* 222843 */     GIR_EraseRootFromParent_Done,
     /* 222844 */   // Label 4401: @222844
     /* 222844 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(222889), // Rule ID 3451 //
     /* 222849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 222852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 222857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 222860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 222873 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1586:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 222873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
     /* 222876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 222878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222882 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222884 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 222887 */     GIR_RootConstrainSelectedInstOperands,
     /* 222888 */     // GIR_Coverage, 3451,
     /* 222888 */     GIR_EraseRootFromParent_Done,
     /* 222889 */   // Label 4402: @222889
     /* 222889 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(222931), // Rule ID 3452 //
     /* 222894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 222897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 222902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222918 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1531:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 222918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
     /* 222921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222927 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222929 */     GIR_RootConstrainSelectedInstOperands,
     /* 222930 */     // GIR_Coverage, 3452,
     /* 222930 */     GIR_EraseRootFromParent_Done,
     /* 222931 */   // Label 4403: @222931
     /* 222931 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(222973), // Rule ID 3453 //
     /* 222936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 222939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 222944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222960 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1531:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 222960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
     /* 222963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 222965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 222967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 222969 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 222971 */     GIR_RootConstrainSelectedInstOperands,
     /* 222972 */     // GIR_Coverage, 3453,
     /* 222972 */     GIR_EraseRootFromParent_Done,
     /* 222973 */   // Label 4404: @222973
     /* 222973 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(223015), // Rule ID 3458 //
     /* 222978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 222981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
     /* 222986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 222992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 222995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 222998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223002 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1737:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
     /* 223005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 223007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223011 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223013 */     GIR_RootConstrainSelectedInstOperands,
     /* 223014 */     // GIR_Coverage, 3458,
     /* 223014 */     GIR_EraseRootFromParent_Done,
     /* 223015 */   // Label 4405: @223015
     /* 223015 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(223057), // Rule ID 3497 //
     /* 223020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 223023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 223028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223044 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1360:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 223044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
     /* 223047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223053 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223055 */     GIR_RootConstrainSelectedInstOperands,
     /* 223056 */     // GIR_Coverage, 3497,
     /* 223056 */     GIR_EraseRootFromParent_Done,
     /* 223057 */   // Label 4406: @223057
     /* 223057 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(223099), // Rule ID 3499 //
     /* 223062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 223065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 223070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223086 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1360:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 223086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
     /* 223089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223095 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223097 */     GIR_RootConstrainSelectedInstOperands,
     /* 223098 */     // GIR_Coverage, 3499,
     /* 223098 */     GIR_EraseRootFromParent_Done,
     /* 223099 */   // Label 4407: @223099
     /* 223099 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(223141), // Rule ID 3501 //
     /* 223104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 223107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 223112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223128 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1360:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 223128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
     /* 223131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223137 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223139 */     GIR_RootConstrainSelectedInstOperands,
     /* 223140 */     // GIR_Coverage, 3501,
     /* 223140 */     GIR_EraseRootFromParent_Done,
     /* 223141 */   // Label 4408: @223141
     /* 223141 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(223183), // Rule ID 3503 //
     /* 223146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 223149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
     /* 223154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223170 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1698:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
     /* 223173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 223175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223179 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223181 */     GIR_RootConstrainSelectedInstOperands,
     /* 223182 */     // GIR_Coverage, 3503,
     /* 223182 */     GIR_EraseRootFromParent_Done,
     /* 223183 */   // Label 4409: @223183
     /* 223183 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(223225), // Rule ID 3630 //
     /* 223188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 223191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 223196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 223202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223212 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1682:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
     /* 223215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223221 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223223 */     GIR_RootConstrainSelectedInstOperands,
     /* 223224 */     // GIR_Coverage, 3630,
     /* 223224 */     GIR_EraseRootFromParent_Done,
     /* 223225 */   // Label 4410: @223225
     /* 223225 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(223267), // Rule ID 3632 //
     /* 223230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 223233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 223238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 223244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223254 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1682:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
     /* 223257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223263 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223265 */     GIR_RootConstrainSelectedInstOperands,
     /* 223266 */     // GIR_Coverage, 3632,
     /* 223266 */     GIR_EraseRootFromParent_Done,
     /* 223267 */   // Label 4411: @223267
     /* 223267 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(223309), // Rule ID 3634 //
     /* 223272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 223275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 223280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 223286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1682:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
     /* 223299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223305 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223307 */     GIR_RootConstrainSelectedInstOperands,
     /* 223308 */     // GIR_Coverage, 3634,
     /* 223308 */     GIR_EraseRootFromParent_Done,
     /* 223309 */   // Label 4412: @223309
     /* 223309 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(223351), // Rule ID 3636 //
     /* 223314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 223317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 223322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 223328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223338 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1682:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
     /* 223341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 223343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223347 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223349 */     GIR_RootConstrainSelectedInstOperands,
     /* 223350 */     // GIR_Coverage, 3636,
     /* 223350 */     GIR_EraseRootFromParent_Done,
     /* 223351 */   // Label 4413: @223351
     /* 223351 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(223393), // Rule ID 7441 //
     /* 223356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 223364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223380 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1891:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 223383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223389 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223391 */     GIR_RootConstrainSelectedInstOperands,
     /* 223392 */     // GIR_Coverage, 7441,
     /* 223392 */     GIR_EraseRootFromParent_Done,
     /* 223393 */   // Label 4414: @223393
     /* 223393 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(223435), // Rule ID 7443 //
     /* 223398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 223406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223422 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1891:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 223425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223431 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223433 */     GIR_RootConstrainSelectedInstOperands,
     /* 223434 */     // GIR_Coverage, 7443,
     /* 223434 */     GIR_EraseRootFromParent_Done,
     /* 223435 */   // Label 4415: @223435
     /* 223435 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(223477), // Rule ID 7445 //
     /* 223440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 223448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223464 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1891:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 223467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223473 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223475 */     GIR_RootConstrainSelectedInstOperands,
     /* 223476 */     // GIR_Coverage, 7445,
     /* 223476 */     GIR_EraseRootFromParent_Done,
     /* 223477 */   // Label 4416: @223477
     /* 223477 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(223519), // Rule ID 7447 //
     /* 223482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 223490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223506 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1891:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 223509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223515 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223517 */     GIR_RootConstrainSelectedInstOperands,
     /* 223518 */     // GIR_Coverage, 7447,
     /* 223518 */     GIR_EraseRootFromParent_Done,
     /* 223519 */   // Label 4417: @223519
     /* 223519 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(223561), // Rule ID 7465 //
     /* 223524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 223532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223548 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1276:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
     /* 223551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223557 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223559 */     GIR_RootConstrainSelectedInstOperands,
     /* 223560 */     // GIR_Coverage, 7465,
     /* 223560 */     GIR_EraseRootFromParent_Done,
     /* 223561 */   // Label 4418: @223561
     /* 223561 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(223603), // Rule ID 7466 //
     /* 223566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 223574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223590 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1276:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
     /* 223593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223599 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223601 */     GIR_RootConstrainSelectedInstOperands,
     /* 223602 */     // GIR_Coverage, 7466,
     /* 223602 */     GIR_EraseRootFromParent_Done,
     /* 223603 */   // Label 4419: @223603
     /* 223603 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(223645), // Rule ID 7467 //
     /* 223608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 223616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223632 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1276:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
     /* 223635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223641 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223643 */     GIR_RootConstrainSelectedInstOperands,
     /* 223644 */     // GIR_Coverage, 7467,
     /* 223644 */     GIR_EraseRootFromParent_Done,
     /* 223645 */   // Label 4420: @223645
     /* 223645 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(223687), // Rule ID 7468 //
     /* 223650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 223658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223674 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1276:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
     /* 223677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223683 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223685 */     GIR_RootConstrainSelectedInstOperands,
     /* 223686 */     // GIR_Coverage, 7468,
     /* 223686 */     GIR_EraseRootFromParent_Done,
     /* 223687 */   // Label 4421: @223687
     /* 223687 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(223729), // Rule ID 7581 //
     /* 223692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 223700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223716 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1738:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
     /* 223719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223725 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223727 */     GIR_RootConstrainSelectedInstOperands,
     /* 223728 */     // GIR_Coverage, 7581,
     /* 223728 */     GIR_EraseRootFromParent_Done,
     /* 223729 */   // Label 4422: @223729
     /* 223729 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(223771), // Rule ID 7582 //
     /* 223734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 223742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223758 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1738:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
     /* 223761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223767 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223769 */     GIR_RootConstrainSelectedInstOperands,
     /* 223770 */     // GIR_Coverage, 7582,
     /* 223770 */     GIR_EraseRootFromParent_Done,
     /* 223771 */   // Label 4423: @223771
     /* 223771 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(223813), // Rule ID 7583 //
     /* 223776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 223784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223800 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1738:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
     /* 223803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223809 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223811 */     GIR_RootConstrainSelectedInstOperands,
     /* 223812 */     // GIR_Coverage, 7583,
     /* 223812 */     GIR_EraseRootFromParent_Done,
     /* 223813 */   // Label 4424: @223813
     /* 223813 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(223855), // Rule ID 7584 //
     /* 223818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 223826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223842 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1738:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 223842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
     /* 223845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223851 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223853 */     GIR_RootConstrainSelectedInstOperands,
     /* 223854 */     // GIR_Coverage, 7584,
     /* 223854 */     GIR_EraseRootFromParent_Done,
     /* 223855 */   // Label 4425: @223855
     /* 223855 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(223897), // Rule ID 7585 //
     /* 223860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 223868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 223871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 223874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 223877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 223880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223884 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1976:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 223884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
     /* 223887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223893 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223895 */     GIR_RootConstrainSelectedInstOperands,
     /* 223896 */     // GIR_Coverage, 7585,
     /* 223896 */     GIR_EraseRootFromParent_Done,
     /* 223897 */   // Label 4426: @223897
     /* 223897 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(223939), // Rule ID 7586 //
     /* 223902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 223910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223926 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1976:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 223926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
     /* 223929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223935 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223937 */     GIR_RootConstrainSelectedInstOperands,
     /* 223938 */     // GIR_Coverage, 7586,
     /* 223938 */     GIR_EraseRootFromParent_Done,
     /* 223939 */   // Label 4427: @223939
     /* 223939 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(223981), // Rule ID 7587 //
     /* 223944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 223952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223968 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1976:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 223968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
     /* 223971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 223975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 223977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 223979 */     GIR_RootConstrainSelectedInstOperands,
     /* 223980 */     // GIR_Coverage, 7587,
     /* 223980 */     GIR_EraseRootFromParent_Done,
     /* 223981 */   // Label 4428: @223981
     /* 223981 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(224023), // Rule ID 7588 //
     /* 223986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 223994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224010 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1976:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
     /* 224013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224019 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224021 */     GIR_RootConstrainSelectedInstOperands,
     /* 224022 */     // GIR_Coverage, 7588,
     /* 224022 */     GIR_EraseRootFromParent_Done,
     /* 224023 */   // Label 4429: @224023
     /* 224023 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(224065), // Rule ID 7597 //
     /* 224028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 224036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1939:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
     /* 224055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224061 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224063 */     GIR_RootConstrainSelectedInstOperands,
     /* 224064 */     // GIR_Coverage, 7597,
     /* 224064 */     GIR_EraseRootFromParent_Done,
     /* 224065 */   // Label 4430: @224065
     /* 224065 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(224107), // Rule ID 7598 //
     /* 224070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 224078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224094 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1939:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
     /* 224097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224103 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224105 */     GIR_RootConstrainSelectedInstOperands,
     /* 224106 */     // GIR_Coverage, 7598,
     /* 224106 */     GIR_EraseRootFromParent_Done,
     /* 224107 */   // Label 4431: @224107
     /* 224107 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(224149), // Rule ID 7599 //
     /* 224112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 224120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224136 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1694:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
     /* 224139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224145 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224147 */     GIR_RootConstrainSelectedInstOperands,
     /* 224148 */     // GIR_Coverage, 7599,
     /* 224148 */     GIR_EraseRootFromParent_Done,
     /* 224149 */   // Label 4432: @224149
     /* 224149 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(224191), // Rule ID 7600 //
     /* 224154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 224162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224178 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1694:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
     /* 224181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224187 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224189 */     GIR_RootConstrainSelectedInstOperands,
     /* 224190 */     // GIR_Coverage, 7600,
     /* 224190 */     GIR_EraseRootFromParent_Done,
     /* 224191 */   // Label 4433: @224191
     /* 224191 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(224233), // Rule ID 7601 //
     /* 224196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 224204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224220 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1941:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
     /* 224223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224229 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224231 */     GIR_RootConstrainSelectedInstOperands,
     /* 224232 */     // GIR_Coverage, 7601,
     /* 224232 */     GIR_EraseRootFromParent_Done,
     /* 224233 */   // Label 4434: @224233
     /* 224233 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(224275), // Rule ID 7602 //
     /* 224238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 224246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224262 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1941:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
     /* 224265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224271 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224273 */     GIR_RootConstrainSelectedInstOperands,
     /* 224274 */     // GIR_Coverage, 7602,
     /* 224274 */     GIR_EraseRootFromParent_Done,
     /* 224275 */   // Label 4435: @224275
     /* 224275 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(224317), // Rule ID 7687 //
     /* 224280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 224288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 224294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 224297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224304 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1316:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 224304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
     /* 224307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224313 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224315 */     GIR_RootConstrainSelectedInstOperands,
     /* 224316 */     // GIR_Coverage, 7687,
     /* 224316 */     GIR_EraseRootFromParent_Done,
     /* 224317 */   // Label 4436: @224317
     /* 224317 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(224359), // Rule ID 7688 //
     /* 224322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 224330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 224339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224346 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1316:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 224346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
     /* 224349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224355 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224357 */     GIR_RootConstrainSelectedInstOperands,
     /* 224358 */     // GIR_Coverage, 7688,
     /* 224358 */     GIR_EraseRootFromParent_Done,
     /* 224359 */   // Label 4437: @224359
     /* 224359 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(224401), // Rule ID 7689 //
     /* 224364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 224372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 224381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224388 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1316:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 224388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
     /* 224391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224397 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224399 */     GIR_RootConstrainSelectedInstOperands,
     /* 224400 */     // GIR_Coverage, 7689,
     /* 224400 */     GIR_EraseRootFromParent_Done,
     /* 224401 */   // Label 4438: @224401
     /* 224401 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(224443), // Rule ID 7690 //
     /* 224406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 224414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 224423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224430 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1316:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 224430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
     /* 224433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224439 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224441 */     GIR_RootConstrainSelectedInstOperands,
     /* 224442 */     // GIR_Coverage, 7690,
     /* 224442 */     GIR_EraseRootFromParent_Done,
     /* 224443 */   // Label 4439: @224443
     /* 224443 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(224485), // Rule ID 7699 //
     /* 224448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 224456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 224462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 224465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224472 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1602:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 224472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
     /* 224475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224481 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224483 */     GIR_RootConstrainSelectedInstOperands,
     /* 224484 */     // GIR_Coverage, 7699,
     /* 224484 */     GIR_EraseRootFromParent_Done,
     /* 224485 */   // Label 4440: @224485
     /* 224485 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(224527), // Rule ID 7700 //
     /* 224490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 224498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 224507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224514 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 224514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
     /* 224517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224523 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224525 */     GIR_RootConstrainSelectedInstOperands,
     /* 224526 */     // GIR_Coverage, 7700,
     /* 224526 */     GIR_EraseRootFromParent_Done,
     /* 224527 */   // Label 4441: @224527
     /* 224527 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(224569), // Rule ID 7701 //
     /* 224532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 224540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 224549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224556 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 224556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
     /* 224559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224565 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224567 */     GIR_RootConstrainSelectedInstOperands,
     /* 224568 */     // GIR_Coverage, 7701,
     /* 224568 */     GIR_EraseRootFromParent_Done,
     /* 224569 */   // Label 4442: @224569
     /* 224569 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(224611), // Rule ID 7702 //
     /* 224574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 224582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 224588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 224591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224598 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1602:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 224598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
     /* 224601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 224603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 224605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 224607 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 224609 */     GIR_RootConstrainSelectedInstOperands,
     /* 224610 */     // GIR_Coverage, 7702,
     /* 224610 */     GIR_EraseRootFromParent_Done,
     /* 224611 */   // Label 4443: @224611
     /* 224611 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(224653), // Rule ID 7781 //
     /* 224616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 224624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224640 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1669:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
     /* 224643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224649 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224651 */     GIR_RootConstrainSelectedInstOperands,
     /* 224652 */     // GIR_Coverage, 7781,
     /* 224652 */     GIR_EraseRootFromParent_Done,
     /* 224653 */   // Label 4444: @224653
     /* 224653 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(224695), // Rule ID 7782 //
     /* 224658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 224666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224682 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1669:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
     /* 224685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224691 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224693 */     GIR_RootConstrainSelectedInstOperands,
     /* 224694 */     // GIR_Coverage, 7782,
     /* 224694 */     GIR_EraseRootFromParent_Done,
     /* 224695 */   // Label 4445: @224695
     /* 224695 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(224737), // Rule ID 7783 //
     /* 224700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 224708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1669:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
     /* 224727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224735 */     GIR_RootConstrainSelectedInstOperands,
     /* 224736 */     // GIR_Coverage, 7783,
     /* 224736 */     GIR_EraseRootFromParent_Done,
     /* 224737 */   // Label 4446: @224737
     /* 224737 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(224779), // Rule ID 7784 //
     /* 224742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 224750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224766 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1669:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
     /* 224769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224775 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224777 */     GIR_RootConstrainSelectedInstOperands,
     /* 224778 */     // GIR_Coverage, 7784,
     /* 224778 */     GIR_EraseRootFromParent_Done,
     /* 224779 */   // Label 4447: @224779
     /* 224779 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(224821), // Rule ID 7785 //
     /* 224784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 224792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 224795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 224798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 224801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 224804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224808 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1919:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 224808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
     /* 224811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224817 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224819 */     GIR_RootConstrainSelectedInstOperands,
     /* 224820 */     // GIR_Coverage, 7785,
     /* 224820 */     GIR_EraseRootFromParent_Done,
     /* 224821 */   // Label 4448: @224821
     /* 224821 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(224863), // Rule ID 7786 //
     /* 224826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 224834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224850 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1919:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 224850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
     /* 224853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224859 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224861 */     GIR_RootConstrainSelectedInstOperands,
     /* 224862 */     // GIR_Coverage, 7786,
     /* 224862 */     GIR_EraseRootFromParent_Done,
     /* 224863 */   // Label 4449: @224863
     /* 224863 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(224905), // Rule ID 7787 //
     /* 224868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 224876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224892 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1919:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 224892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
     /* 224895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224901 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224903 */     GIR_RootConstrainSelectedInstOperands,
     /* 224904 */     // GIR_Coverage, 7787,
     /* 224904 */     GIR_EraseRootFromParent_Done,
     /* 224905 */   // Label 4450: @224905
     /* 224905 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(224947), // Rule ID 7788 //
     /* 224910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 224918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224934 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1919:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 224934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
     /* 224937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224943 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224945 */     GIR_RootConstrainSelectedInstOperands,
     /* 224946 */     // GIR_Coverage, 7788,
     /* 224946 */     GIR_EraseRootFromParent_Done,
     /* 224947 */   // Label 4451: @224947
     /* 224947 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(224989), // Rule ID 7984 //
     /* 224952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 224960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224976 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1525:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 224976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
     /* 224979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 224983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 224985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 224987 */     GIR_RootConstrainSelectedInstOperands,
     /* 224988 */     // GIR_Coverage, 7984,
     /* 224988 */     GIR_EraseRootFromParent_Done,
     /* 224989 */   // Label 4452: @224989
     /* 224989 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(225031), // Rule ID 7986 //
     /* 224994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 225002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225018 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1525:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
     /* 225021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225027 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225029 */     GIR_RootConstrainSelectedInstOperands,
     /* 225030 */     // GIR_Coverage, 7986,
     /* 225030 */     GIR_EraseRootFromParent_Done,
     /* 225031 */   // Label 4453: @225031
     /* 225031 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(225073), // Rule ID 7988 //
     /* 225036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 225044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225060 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1525:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
     /* 225063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225069 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225071 */     GIR_RootConstrainSelectedInstOperands,
     /* 225072 */     // GIR_Coverage, 7988,
     /* 225072 */     GIR_EraseRootFromParent_Done,
     /* 225073 */   // Label 4454: @225073
     /* 225073 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(225115), // Rule ID 7996 //
     /* 225078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 225086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225102 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1527:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
     /* 225105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225111 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225113 */     GIR_RootConstrainSelectedInstOperands,
     /* 225114 */     // GIR_Coverage, 7996,
     /* 225114 */     GIR_EraseRootFromParent_Done,
     /* 225115 */   // Label 4455: @225115
     /* 225115 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(225157), // Rule ID 7998 //
     /* 225120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 225128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225144 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1527:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
     /* 225147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225153 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225155 */     GIR_RootConstrainSelectedInstOperands,
     /* 225156 */     // GIR_Coverage, 7998,
     /* 225156 */     GIR_EraseRootFromParent_Done,
     /* 225157 */   // Label 4456: @225157
     /* 225157 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(225199), // Rule ID 8000 //
     /* 225162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 225170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225186 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1527:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
     /* 225189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225195 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225197 */     GIR_RootConstrainSelectedInstOperands,
     /* 225198 */     // GIR_Coverage, 8000,
     /* 225198 */     GIR_EraseRootFromParent_Done,
     /* 225199 */   // Label 4457: @225199
     /* 225199 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(225241), // Rule ID 8038 //
     /* 225204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 225212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225228 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1344:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
     /* 225231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225239 */     GIR_RootConstrainSelectedInstOperands,
     /* 225240 */     // GIR_Coverage, 8038,
     /* 225240 */     GIR_EraseRootFromParent_Done,
     /* 225241 */   // Label 4458: @225241
     /* 225241 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(225283), // Rule ID 8039 //
     /* 225246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 225254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225270 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1344:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
     /* 225273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225279 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225281 */     GIR_RootConstrainSelectedInstOperands,
     /* 225282 */     // GIR_Coverage, 8039,
     /* 225282 */     GIR_EraseRootFromParent_Done,
     /* 225283 */   // Label 4459: @225283
     /* 225283 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(225325), // Rule ID 8040 //
     /* 225288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 225296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225312 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1344:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
     /* 225315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225321 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225323 */     GIR_RootConstrainSelectedInstOperands,
     /* 225324 */     // GIR_Coverage, 8040,
     /* 225324 */     GIR_EraseRootFromParent_Done,
     /* 225325 */   // Label 4460: @225325
     /* 225325 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(225367), // Rule ID 8041 //
     /* 225330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 225338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225354 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1466:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
     /* 225357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225363 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225365 */     GIR_RootConstrainSelectedInstOperands,
     /* 225366 */     // GIR_Coverage, 8041,
     /* 225366 */     GIR_EraseRootFromParent_Done,
     /* 225367 */   // Label 4461: @225367
     /* 225367 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(225409), // Rule ID 8042 //
     /* 225372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 225380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225396 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1466:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
     /* 225399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225405 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225407 */     GIR_RootConstrainSelectedInstOperands,
     /* 225408 */     // GIR_Coverage, 8042,
     /* 225408 */     GIR_EraseRootFromParent_Done,
     /* 225409 */   // Label 4462: @225409
     /* 225409 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(225451), // Rule ID 8043 //
     /* 225414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 225422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225438 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1466:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
     /* 225441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225449 */     GIR_RootConstrainSelectedInstOperands,
     /* 225450 */     // GIR_Coverage, 8043,
     /* 225450 */     GIR_EraseRootFromParent_Done,
     /* 225451 */   // Label 4463: @225451
     /* 225451 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(225493), // Rule ID 8044 //
     /* 225456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 225464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225480 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1405:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
     /* 225483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225489 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225491 */     GIR_RootConstrainSelectedInstOperands,
     /* 225492 */     // GIR_Coverage, 8044,
     /* 225492 */     GIR_EraseRootFromParent_Done,
     /* 225493 */   // Label 4464: @225493
     /* 225493 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(225535), // Rule ID 8045 //
     /* 225498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 225506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225522 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1405:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
     /* 225525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225531 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225533 */     GIR_RootConstrainSelectedInstOperands,
     /* 225534 */     // GIR_Coverage, 8045,
     /* 225534 */     GIR_EraseRootFromParent_Done,
     /* 225535 */   // Label 4465: @225535
     /* 225535 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(225577), // Rule ID 8046 //
     /* 225540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 225548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225564 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1405:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
     /* 225567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225573 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225575 */     GIR_RootConstrainSelectedInstOperands,
     /* 225576 */     // GIR_Coverage, 8046,
     /* 225576 */     GIR_EraseRootFromParent_Done,
     /* 225577 */   // Label 4466: @225577
     /* 225577 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(225619), // Rule ID 8047 //
     /* 225582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 225590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225606 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1403:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
     /* 225609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225615 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225617 */     GIR_RootConstrainSelectedInstOperands,
     /* 225618 */     // GIR_Coverage, 8047,
     /* 225618 */     GIR_EraseRootFromParent_Done,
     /* 225619 */   // Label 4467: @225619
     /* 225619 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(225661), // Rule ID 8048 //
     /* 225624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 225632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225648 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1403:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
     /* 225651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225657 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225659 */     GIR_RootConstrainSelectedInstOperands,
     /* 225660 */     // GIR_Coverage, 8048,
     /* 225660 */     GIR_EraseRootFromParent_Done,
     /* 225661 */   // Label 4468: @225661
     /* 225661 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(225703), // Rule ID 8049 //
     /* 225666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 225674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225690 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1403:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
     /* 225693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225701 */     GIR_RootConstrainSelectedInstOperands,
     /* 225702 */     // GIR_Coverage, 8049,
     /* 225702 */     GIR_EraseRootFromParent_Done,
     /* 225703 */   // Label 4469: @225703
     /* 225703 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(225745), // Rule ID 8086 //
     /* 225708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225732 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1345:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 225735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225741 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225743 */     GIR_RootConstrainSelectedInstOperands,
     /* 225744 */     // GIR_Coverage, 8086,
     /* 225744 */     GIR_EraseRootFromParent_Done,
     /* 225745 */   // Label 4470: @225745
     /* 225745 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(225787), // Rule ID 8088 //
     /* 225750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 225761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 225767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 225770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225774 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1345:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 225774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 225777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225783 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225785 */     GIR_RootConstrainSelectedInstOperands,
     /* 225786 */     // GIR_Coverage, 8088,
     /* 225786 */     GIR_EraseRootFromParent_Done,
     /* 225787 */   // Label 4471: @225787
     /* 225787 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(225829), // Rule ID 8090 //
     /* 225792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 225803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 225809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 225812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225816 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1345:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 225816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 225819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225825 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225827 */     GIR_RootConstrainSelectedInstOperands,
     /* 225828 */     // GIR_Coverage, 8090,
     /* 225828 */     GIR_EraseRootFromParent_Done,
     /* 225829 */   // Label 4472: @225829
     /* 225829 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(225871), // Rule ID 8092 //
     /* 225834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 225848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 225854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225858 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1345:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 225858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 225861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225867 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225869 */     GIR_RootConstrainSelectedInstOperands,
     /* 225870 */     // GIR_Coverage, 8092,
     /* 225870 */     GIR_EraseRootFromParent_Done,
     /* 225871 */   // Label 4473: @225871
     /* 225871 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(225913), // Rule ID 8094 //
     /* 225876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 225887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 225893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 225896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225900 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1345:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 225900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 225903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225911 */     GIR_RootConstrainSelectedInstOperands,
     /* 225912 */     // GIR_Coverage, 8094,
     /* 225912 */     GIR_EraseRootFromParent_Done,
     /* 225913 */   // Label 4474: @225913
     /* 225913 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(225955), // Rule ID 8096 //
     /* 225918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 225926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 225932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 225938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225942 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1345:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 225942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
     /* 225945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225951 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225953 */     GIR_RootConstrainSelectedInstOperands,
     /* 225954 */     // GIR_Coverage, 8096,
     /* 225954 */     GIR_EraseRootFromParent_Done,
     /* 225955 */   // Label 4475: @225955
     /* 225955 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(225997), // Rule ID 8098 //
     /* 225960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 225968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 225974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 225980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225984 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1467:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 225984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 225987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225993 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225995 */     GIR_RootConstrainSelectedInstOperands,
     /* 225996 */     // GIR_Coverage, 8098,
     /* 225996 */     GIR_EraseRootFromParent_Done,
     /* 225997 */   // Label 4476: @225997
     /* 225997 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(226039), // Rule ID 8099 //
     /* 226002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 226010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 226013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 226019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 226022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226026 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1467:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 226026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 226029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226035 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226037 */     GIR_RootConstrainSelectedInstOperands,
     /* 226038 */     // GIR_Coverage, 8099,
     /* 226038 */     GIR_EraseRootFromParent_Done,
     /* 226039 */   // Label 4477: @226039
     /* 226039 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(226081), // Rule ID 8100 //
     /* 226044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 226052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 226055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 226061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 226064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226068 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1467:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 226068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 226071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226077 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226079 */     GIR_RootConstrainSelectedInstOperands,
     /* 226080 */     // GIR_Coverage, 8100,
     /* 226080 */     GIR_EraseRootFromParent_Done,
     /* 226081 */   // Label 4478: @226081
     /* 226081 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(226123), // Rule ID 8101 //
     /* 226086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 226094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 226106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226110 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1467:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 226110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 226113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226119 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226121 */     GIR_RootConstrainSelectedInstOperands,
     /* 226122 */     // GIR_Coverage, 8101,
     /* 226122 */     GIR_EraseRootFromParent_Done,
     /* 226123 */   // Label 4479: @226123
     /* 226123 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(226165), // Rule ID 8102 //
     /* 226128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 226136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 226139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 226145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 226148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226152 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1467:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 226152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 226155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226163 */     GIR_RootConstrainSelectedInstOperands,
     /* 226164 */     // GIR_Coverage, 8102,
     /* 226164 */     GIR_EraseRootFromParent_Done,
     /* 226165 */   // Label 4480: @226165
     /* 226165 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(226207), // Rule ID 8103 //
     /* 226170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 226178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 226190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226194 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1467:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 226194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
     /* 226197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226205 */     GIR_RootConstrainSelectedInstOperands,
     /* 226206 */     // GIR_Coverage, 8103,
     /* 226206 */     GIR_EraseRootFromParent_Done,
     /* 226207 */   // Label 4481: @226207
     /* 226207 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(226249), // Rule ID 8356 //
     /* 226212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
     /* 226220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 226236 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1285:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
     /* 226239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226245 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226247 */     GIR_RootConstrainSelectedInstOperands,
     /* 226248 */     // GIR_Coverage, 8356,
     /* 226248 */     GIR_EraseRootFromParent_Done,
     /* 226249 */   // Label 4482: @226249
     /* 226249 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(226291), // Rule ID 8358 //
     /* 226254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
     /* 226262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 226278 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1281:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
     /* 226281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226287 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226289 */     GIR_RootConstrainSelectedInstOperands,
     /* 226290 */     // GIR_Coverage, 8358,
     /* 226290 */     GIR_EraseRootFromParent_Done,
     /* 226291 */   // Label 4483: @226291
     /* 226291 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(226333), // Rule ID 8359 //
     /* 226296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 226304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226320 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1278:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 226323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226329 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226331 */     GIR_RootConstrainSelectedInstOperands,
     /* 226332 */     // GIR_Coverage, 8359,
     /* 226332 */     GIR_EraseRootFromParent_Done,
     /* 226333 */   // Label 4484: @226333
     /* 226333 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(226375), // Rule ID 8360 //
     /* 226338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 226346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226362 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1278:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 226365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226371 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226373 */     GIR_RootConstrainSelectedInstOperands,
     /* 226374 */     // GIR_Coverage, 8360,
     /* 226374 */     GIR_EraseRootFromParent_Done,
     /* 226375 */   // Label 4485: @226375
     /* 226375 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(226417), // Rule ID 8361 //
     /* 226380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 226388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226404 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1278:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 226407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226413 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226415 */     GIR_RootConstrainSelectedInstOperands,
     /* 226416 */     // GIR_Coverage, 8361,
     /* 226416 */     GIR_EraseRootFromParent_Done,
     /* 226417 */   // Label 4486: @226417
     /* 226417 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(226459), // Rule ID 8362 //
     /* 226422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 226430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226446 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1278:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 226449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226455 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226457 */     GIR_RootConstrainSelectedInstOperands,
     /* 226458 */     // GIR_Coverage, 8362,
     /* 226458 */     GIR_EraseRootFromParent_Done,
     /* 226459 */   // Label 4487: @226459
     /* 226459 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(226501), // Rule ID 8363 //
     /* 226464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 226472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 226475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 226478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 226481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 226484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226488 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1278:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 226488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 226491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226497 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226499 */     GIR_RootConstrainSelectedInstOperands,
     /* 226500 */     // GIR_Coverage, 8363,
     /* 226500 */     GIR_EraseRootFromParent_Done,
     /* 226501 */   // Label 4488: @226501
     /* 226501 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(226543), // Rule ID 8384 //
     /* 226506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226530 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1336:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226539 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226541 */     GIR_RootConstrainSelectedInstOperands,
     /* 226542 */     // GIR_Coverage, 8384,
     /* 226542 */     GIR_EraseRootFromParent_Done,
     /* 226543 */   // Label 4489: @226543
     /* 226543 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(226585), // Rule ID 8385 //
     /* 226548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226572 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1336:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226581 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226583 */     GIR_RootConstrainSelectedInstOperands,
     /* 226584 */     // GIR_Coverage, 8385,
     /* 226584 */     GIR_EraseRootFromParent_Done,
     /* 226585 */   // Label 4490: @226585
     /* 226585 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(226627), // Rule ID 8386 //
     /* 226590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226607 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226614 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1336:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226623 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226625 */     GIR_RootConstrainSelectedInstOperands,
     /* 226626 */     // GIR_Coverage, 8386,
     /* 226626 */     GIR_EraseRootFromParent_Done,
     /* 226627 */   // Label 4491: @226627
     /* 226627 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(226669), // Rule ID 8387 //
     /* 226632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226649 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226656 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1336:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226663 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226665 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226667 */     GIR_RootConstrainSelectedInstOperands,
     /* 226668 */     // GIR_Coverage, 8387,
     /* 226668 */     GIR_EraseRootFromParent_Done,
     /* 226669 */   // Label 4492: @226669
     /* 226669 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(226711), // Rule ID 8388 //
     /* 226674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 226682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 226685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 226688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 226691 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 226694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226698 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1336:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 226698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 226701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226709 */     GIR_RootConstrainSelectedInstOperands,
     /* 226710 */     // GIR_Coverage, 8388,
     /* 226710 */     GIR_EraseRootFromParent_Done,
     /* 226711 */   // Label 4493: @226711
     /* 226711 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(226753), // Rule ID 8404 //
     /* 226716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226719 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 226724 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226740 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1607:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 226743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226749 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226751 */     GIR_RootConstrainSelectedInstOperands,
     /* 226752 */     // GIR_Coverage, 8404,
     /* 226752 */     GIR_EraseRootFromParent_Done,
     /* 226753 */   // Label 4494: @226753
     /* 226753 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(226795), // Rule ID 8405 //
     /* 226758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 226766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226775 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226782 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1607:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 226785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226791 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226793 */     GIR_RootConstrainSelectedInstOperands,
     /* 226794 */     // GIR_Coverage, 8405,
     /* 226794 */     GIR_EraseRootFromParent_Done,
     /* 226795 */   // Label 4495: @226795
     /* 226795 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(226837), // Rule ID 8406 //
     /* 226800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 226808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 226811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 226814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 226817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 226820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226824 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1607:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 226824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 226827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226833 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226835 */     GIR_RootConstrainSelectedInstOperands,
     /* 226836 */     // GIR_Coverage, 8406,
     /* 226836 */     GIR_EraseRootFromParent_Done,
     /* 226837 */   // Label 4496: @226837
     /* 226837 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(226879), // Rule ID 8407 //
     /* 226842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 226850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 226853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 226856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 226859 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 226862 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226866 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1607:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 226866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 226869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226875 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226877 */     GIR_RootConstrainSelectedInstOperands,
     /* 226878 */     // GIR_Coverage, 8407,
     /* 226878 */     GIR_EraseRootFromParent_Done,
     /* 226879 */   // Label 4497: @226879
     /* 226879 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(226921), // Rule ID 8408 //
     /* 226884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 226892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 226895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 226898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 226901 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 226904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226908 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1607:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 226908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 226911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226917 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226919 */     GIR_RootConstrainSelectedInstOperands,
     /* 226920 */     // GIR_Coverage, 8408,
     /* 226920 */     GIR_EraseRootFromParent_Done,
     /* 226921 */   // Label 4498: @226921
     /* 226921 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(226963), // Rule ID 8409 //
     /* 226926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 226934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 226937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 226940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 226943 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 226946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226950 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1603:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 226950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 226953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226959 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226961 */     GIR_RootConstrainSelectedInstOperands,
     /* 226962 */     // GIR_Coverage, 8409,
     /* 226962 */     GIR_EraseRootFromParent_Done,
     /* 226963 */   // Label 4499: @226963
     /* 226963 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(227005), // Rule ID 8410 //
     /* 226968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 226971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 226976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 226979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 226982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 226985 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 226988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 226992 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1603:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 226992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 226995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 226997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227001 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227003 */     GIR_RootConstrainSelectedInstOperands,
     /* 227004 */     // GIR_Coverage, 8410,
     /* 227004 */     GIR_EraseRootFromParent_Done,
     /* 227005 */   // Label 4500: @227005
     /* 227005 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(227047), // Rule ID 8411 //
     /* 227010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 227018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 227027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 227030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227034 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1603:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 227034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 227037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227043 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227045 */     GIR_RootConstrainSelectedInstOperands,
     /* 227046 */     // GIR_Coverage, 8411,
     /* 227046 */     GIR_EraseRootFromParent_Done,
     /* 227047 */   // Label 4501: @227047
     /* 227047 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(227089), // Rule ID 8412 //
     /* 227052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 227060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 227063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 227069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 227072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227076 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1603:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 227076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 227079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227085 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227087 */     GIR_RootConstrainSelectedInstOperands,
     /* 227088 */     // GIR_Coverage, 8412,
     /* 227088 */     GIR_EraseRootFromParent_Done,
     /* 227089 */   // Label 4502: @227089
     /* 227089 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(227131), // Rule ID 8413 //
     /* 227094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 227102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 227105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 227108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 227111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 227114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227118 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1603:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 227118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 227121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227127 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227129 */     GIR_RootConstrainSelectedInstOperands,
     /* 227130 */     // GIR_Coverage, 8413,
     /* 227130 */     GIR_EraseRootFromParent_Done,
     /* 227131 */   // Label 4503: @227131
     /* 227131 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(227173), // Rule ID 8414 //
     /* 227136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 227144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 227153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 227156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227160 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1601:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 227160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 227163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227169 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227171 */     GIR_RootConstrainSelectedInstOperands,
     /* 227172 */     // GIR_Coverage, 8414,
     /* 227172 */     GIR_EraseRootFromParent_Done,
     /* 227173 */   // Label 4504: @227173
     /* 227173 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(227215), // Rule ID 8415 //
     /* 227178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 227186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 227195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 227198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227202 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1601:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 227202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 227205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227211 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227213 */     GIR_RootConstrainSelectedInstOperands,
     /* 227214 */     // GIR_Coverage, 8415,
     /* 227214 */     GIR_EraseRootFromParent_Done,
     /* 227215 */   // Label 4505: @227215
     /* 227215 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(227257), // Rule ID 8416 //
     /* 227220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 227228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 227237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 227240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227244 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1601:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 227244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 227247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227253 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227255 */     GIR_RootConstrainSelectedInstOperands,
     /* 227256 */     // GIR_Coverage, 8416,
     /* 227256 */     GIR_EraseRootFromParent_Done,
     /* 227257 */   // Label 4506: @227257
     /* 227257 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(227299), // Rule ID 8417 //
     /* 227262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 227270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 227273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 227279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 227282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227286 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1601:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 227286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 227289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227295 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227297 */     GIR_RootConstrainSelectedInstOperands,
     /* 227298 */     // GIR_Coverage, 8417,
     /* 227298 */     GIR_EraseRootFromParent_Done,
     /* 227299 */   // Label 4507: @227299
     /* 227299 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(227341), // Rule ID 8418 //
     /* 227304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 227312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 227315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 227318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 227321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 227324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227328 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1601:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 227328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 227331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227335 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227337 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227339 */     GIR_RootConstrainSelectedInstOperands,
     /* 227340 */     // GIR_Coverage, 8418,
     /* 227340 */     GIR_EraseRootFromParent_Done,
     /* 227341 */   // Label 4508: @227341
     /* 227341 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(227383), // Rule ID 8419 //
     /* 227346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 227354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 227363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 227366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227370 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1597:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 227370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 227373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227379 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227381 */     GIR_RootConstrainSelectedInstOperands,
     /* 227382 */     // GIR_Coverage, 8419,
     /* 227382 */     GIR_EraseRootFromParent_Done,
     /* 227383 */   // Label 4509: @227383
     /* 227383 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(227425), // Rule ID 8420 //
     /* 227388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 227396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 227405 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 227408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227412 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1597:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 227412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 227415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227423 */     GIR_RootConstrainSelectedInstOperands,
     /* 227424 */     // GIR_Coverage, 8420,
     /* 227424 */     GIR_EraseRootFromParent_Done,
     /* 227425 */   // Label 4510: @227425
     /* 227425 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(227467), // Rule ID 8421 //
     /* 227430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 227438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 227447 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 227450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227454 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1597:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 227454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 227457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227463 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227465 */     GIR_RootConstrainSelectedInstOperands,
     /* 227466 */     // GIR_Coverage, 8421,
     /* 227466 */     GIR_EraseRootFromParent_Done,
     /* 227467 */   // Label 4511: @227467
     /* 227467 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(227509), // Rule ID 8422 //
     /* 227472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 227480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 227483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 227489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 227492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227496 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1597:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 227496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 227499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227505 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227507 */     GIR_RootConstrainSelectedInstOperands,
     /* 227508 */     // GIR_Coverage, 8422,
     /* 227508 */     GIR_EraseRootFromParent_Done,
     /* 227509 */   // Label 4512: @227509
     /* 227509 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(227551), // Rule ID 8423 //
     /* 227514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 227522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 227525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 227528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 227531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 227534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 227538 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1597:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 227538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 227541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227547 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227549 */     GIR_RootConstrainSelectedInstOperands,
     /* 227550 */     // GIR_Coverage, 8423,
     /* 227550 */     GIR_EraseRootFromParent_Done,
     /* 227551 */   // Label 4513: @227551
     /* 227551 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(227593), // Rule ID 8431 //
     /* 227556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 227576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227580 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1294:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 227580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
     /* 227583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227589 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227591 */     GIR_RootConstrainSelectedInstOperands,
     /* 227592 */     // GIR_Coverage, 8431,
     /* 227592 */     GIR_EraseRootFromParent_Done,
     /* 227593 */   // Label 4514: @227593
     /* 227593 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(227635), // Rule ID 8432 //
     /* 227598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227615 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227622 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1294:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 227622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 227625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227631 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227633 */     GIR_RootConstrainSelectedInstOperands,
     /* 227634 */     // GIR_Coverage, 8432,
     /* 227634 */     GIR_EraseRootFromParent_Done,
     /* 227635 */   // Label 4515: @227635
     /* 227635 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(227677), // Rule ID 8433 //
     /* 227640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227664 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1294:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 227664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 227667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227671 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227673 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227675 */     GIR_RootConstrainSelectedInstOperands,
     /* 227676 */     // GIR_Coverage, 8433,
     /* 227676 */     GIR_EraseRootFromParent_Done,
     /* 227677 */   // Label 4516: @227677
     /* 227677 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(227719), // Rule ID 8434 //
     /* 227682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227699 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227706 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1294:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 227709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227715 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227717 */     GIR_RootConstrainSelectedInstOperands,
     /* 227718 */     // GIR_Coverage, 8434,
     /* 227718 */     GIR_EraseRootFromParent_Done,
     /* 227719 */   // Label 4517: @227719
     /* 227719 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(227761), // Rule ID 8435 //
     /* 227724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227741 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 227744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227748 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1294:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 227748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 227751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227757 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227759 */     GIR_RootConstrainSelectedInstOperands,
     /* 227760 */     // GIR_Coverage, 8435,
     /* 227760 */     GIR_EraseRootFromParent_Done,
     /* 227761 */   // Label 4518: @227761
     /* 227761 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(227803), // Rule ID 8436 //
     /* 227766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 227786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227790 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1294:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 227790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 227793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227799 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227801 */     GIR_RootConstrainSelectedInstOperands,
     /* 227802 */     // GIR_Coverage, 8436,
     /* 227802 */     GIR_EraseRootFromParent_Done,
     /* 227803 */   // Label 4519: @227803
     /* 227803 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(227845), // Rule ID 8437 //
     /* 227808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 227816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227832 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1294:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 227832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 227835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227841 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227843 */     GIR_RootConstrainSelectedInstOperands,
     /* 227844 */     // GIR_Coverage, 8437,
     /* 227844 */     GIR_EraseRootFromParent_Done,
     /* 227845 */   // Label 4520: @227845
     /* 227845 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(227890), // Rule ID 9133 //
     /* 227850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 227858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227874 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1315:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
     /* 227877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227883 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227885 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227888 */     GIR_RootConstrainSelectedInstOperands,
     /* 227889 */     // GIR_Coverage, 9133,
     /* 227889 */     GIR_EraseRootFromParent_Done,
     /* 227890 */   // Label 4521: @227890
     /* 227890 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(227935), // Rule ID 9134 //
     /* 227895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 227903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 227906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227919 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1315:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
     /* 227922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227928 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227930 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227933 */     GIR_RootConstrainSelectedInstOperands,
     /* 227934 */     // GIR_Coverage, 9134,
     /* 227934 */     GIR_EraseRootFromParent_Done,
     /* 227935 */   // Label 4522: @227935
     /* 227935 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(227980), // Rule ID 9135 //
     /* 227940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 227948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 227951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 227960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 227964 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1315:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 227964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
     /* 227967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 227969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227975 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 227978 */     GIR_RootConstrainSelectedInstOperands,
     /* 227979 */     // GIR_Coverage, 9135,
     /* 227979 */     GIR_EraseRootFromParent_Done,
     /* 227980 */   // Label 4523: @227980
     /* 227980 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(228025), // Rule ID 9136 //
     /* 227985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 227988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 227993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 227996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228009 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1305:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
     /* 228012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228020 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228023 */     GIR_RootConstrainSelectedInstOperands,
     /* 228024 */     // GIR_Coverage, 9136,
     /* 228024 */     GIR_EraseRootFromParent_Done,
     /* 228025 */   // Label 4524: @228025
     /* 228025 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(228070), // Rule ID 9137 //
     /* 228030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 228038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228054 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1305:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
     /* 228057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228063 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228065 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228068 */     GIR_RootConstrainSelectedInstOperands,
     /* 228069 */     // GIR_Coverage, 9137,
     /* 228069 */     GIR_EraseRootFromParent_Done,
     /* 228070 */   // Label 4525: @228070
     /* 228070 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(228115), // Rule ID 9138 //
     /* 228075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 228083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228099 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1305:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
     /* 228102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228108 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228110 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228113 */     GIR_RootConstrainSelectedInstOperands,
     /* 228114 */     // GIR_Coverage, 9138,
     /* 228114 */     GIR_EraseRootFromParent_Done,
     /* 228115 */   // Label 4526: @228115
     /* 228115 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(228160), // Rule ID 9139 //
     /* 228120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 228128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228144 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1313:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
     /* 228147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228153 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228155 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228158 */     GIR_RootConstrainSelectedInstOperands,
     /* 228159 */     // GIR_Coverage, 9139,
     /* 228159 */     GIR_EraseRootFromParent_Done,
     /* 228160 */   // Label 4527: @228160
     /* 228160 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(228205), // Rule ID 9140 //
     /* 228165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 228173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228189 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1313:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
     /* 228192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228200 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228203 */     GIR_RootConstrainSelectedInstOperands,
     /* 228204 */     // GIR_Coverage, 9140,
     /* 228204 */     GIR_EraseRootFromParent_Done,
     /* 228205 */   // Label 4528: @228205
     /* 228205 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(228250), // Rule ID 9141 //
     /* 228210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 228218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228234 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1313:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
     /* 228237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228243 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228248 */     GIR_RootConstrainSelectedInstOperands,
     /* 228249 */     // GIR_Coverage, 9141,
     /* 228249 */     GIR_EraseRootFromParent_Done,
     /* 228250 */   // Label 4529: @228250
     /* 228250 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(228295), // Rule ID 9142 //
     /* 228255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 228263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228279 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1310:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
     /* 228282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228290 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228293 */     GIR_RootConstrainSelectedInstOperands,
     /* 228294 */     // GIR_Coverage, 9142,
     /* 228294 */     GIR_EraseRootFromParent_Done,
     /* 228295 */   // Label 4530: @228295
     /* 228295 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(228340), // Rule ID 9143 //
     /* 228300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 228308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228324 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1310:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
     /* 228327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228333 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228335 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228338 */     GIR_RootConstrainSelectedInstOperands,
     /* 228339 */     // GIR_Coverage, 9143,
     /* 228339 */     GIR_EraseRootFromParent_Done,
     /* 228340 */   // Label 4531: @228340
     /* 228340 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(228385), // Rule ID 9144 //
     /* 228345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 228353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228369 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1310:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
     /* 228372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228380 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228383 */     GIR_RootConstrainSelectedInstOperands,
     /* 228384 */     // GIR_Coverage, 9144,
     /* 228384 */     GIR_EraseRootFromParent_Done,
     /* 228385 */   // Label 4532: @228385
     /* 228385 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(228430), // Rule ID 9145 //
     /* 228390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 228398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228414 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1309:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
     /* 228417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228423 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228425 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228428 */     GIR_RootConstrainSelectedInstOperands,
     /* 228429 */     // GIR_Coverage, 9145,
     /* 228429 */     GIR_EraseRootFromParent_Done,
     /* 228430 */   // Label 4533: @228430
     /* 228430 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(228475), // Rule ID 9146 //
     /* 228435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 228443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228459 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1309:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
     /* 228462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228470 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228473 */     GIR_RootConstrainSelectedInstOperands,
     /* 228474 */     // GIR_Coverage, 9146,
     /* 228474 */     GIR_EraseRootFromParent_Done,
     /* 228475 */   // Label 4534: @228475
     /* 228475 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(228520), // Rule ID 9147 //
     /* 228480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 228488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228497 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228504 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1309:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
     /* 228507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228513 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228515 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228518 */     GIR_RootConstrainSelectedInstOperands,
     /* 228519 */     // GIR_Coverage, 9147,
     /* 228519 */     GIR_EraseRootFromParent_Done,
     /* 228520 */   // Label 4535: @228520
     /* 228520 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(228565), // Rule ID 9148 //
     /* 228525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 228533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228549 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1307:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
     /* 228552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228560 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228563 */     GIR_RootConstrainSelectedInstOperands,
     /* 228564 */     // GIR_Coverage, 9148,
     /* 228564 */     GIR_EraseRootFromParent_Done,
     /* 228565 */   // Label 4536: @228565
     /* 228565 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(228610), // Rule ID 9149 //
     /* 228570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 228578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228594 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1307:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
     /* 228597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228603 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228605 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228608 */     GIR_RootConstrainSelectedInstOperands,
     /* 228609 */     // GIR_Coverage, 9149,
     /* 228609 */     GIR_EraseRootFromParent_Done,
     /* 228610 */   // Label 4537: @228610
     /* 228610 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(228655), // Rule ID 9150 //
     /* 228615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 228623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228639 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1307:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
     /* 228642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228650 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228653 */     GIR_RootConstrainSelectedInstOperands,
     /* 228654 */     // GIR_Coverage, 9150,
     /* 228654 */     GIR_EraseRootFromParent_Done,
     /* 228655 */   // Label 4538: @228655
     /* 228655 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(228700), // Rule ID 9151 //
     /* 228660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 228668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228684 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1311:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
     /* 228687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228695 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228698 */     GIR_RootConstrainSelectedInstOperands,
     /* 228699 */     // GIR_Coverage, 9151,
     /* 228699 */     GIR_EraseRootFromParent_Done,
     /* 228700 */   // Label 4539: @228700
     /* 228700 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(228745), // Rule ID 9152 //
     /* 228705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 228713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228729 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1311:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
     /* 228732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228738 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228740 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228743 */     GIR_RootConstrainSelectedInstOperands,
     /* 228744 */     // GIR_Coverage, 9152,
     /* 228744 */     GIR_EraseRootFromParent_Done,
     /* 228745 */   // Label 4540: @228745
     /* 228745 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(228790), // Rule ID 9153 //
     /* 228750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 228758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228774 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1311:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
     /* 228777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228783 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228785 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228788 */     GIR_RootConstrainSelectedInstOperands,
     /* 228789 */     // GIR_Coverage, 9153,
     /* 228789 */     GIR_EraseRootFromParent_Done,
     /* 228790 */   // Label 4541: @228790
     /* 228790 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(228835), // Rule ID 9154 //
     /* 228795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 228803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 228806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 228809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228819 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1312:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
     /* 228822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228830 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228833 */     GIR_RootConstrainSelectedInstOperands,
     /* 228834 */     // GIR_Coverage, 9154,
     /* 228834 */     GIR_EraseRootFromParent_Done,
     /* 228835 */   // Label 4542: @228835
     /* 228835 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(228880), // Rule ID 9155 //
     /* 228840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 228848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228864 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1312:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
     /* 228867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228873 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228875 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228878 */     GIR_RootConstrainSelectedInstOperands,
     /* 228879 */     // GIR_Coverage, 9155,
     /* 228879 */     GIR_EraseRootFromParent_Done,
     /* 228880 */   // Label 4543: @228880
     /* 228880 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(228925), // Rule ID 9156 //
     /* 228885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 228893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 228905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228909 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1312:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 228909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
     /* 228912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228920 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 228923 */     GIR_RootConstrainSelectedInstOperands,
     /* 228924 */     // GIR_Coverage, 9156,
     /* 228924 */     GIR_EraseRootFromParent_Done,
     /* 228925 */   // Label 4544: @228925
     /* 228925 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(228967), // Rule ID 9553 //
     /* 228930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 228938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 228941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 228944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 228950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228954 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1348:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 228954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
     /* 228957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 228959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228963 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228965 */     GIR_RootConstrainSelectedInstOperands,
     /* 228966 */     // GIR_Coverage, 9553,
     /* 228966 */     GIR_EraseRootFromParent_Done,
     /* 228967 */   // Label 4545: @228967
     /* 228967 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(229009), // Rule ID 9554 //
     /* 228972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 228975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 228980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 228983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 228986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 228992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 228996 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1348:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 228996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
     /* 228999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229005 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229007 */     GIR_RootConstrainSelectedInstOperands,
     /* 229008 */     // GIR_Coverage, 9554,
     /* 229008 */     GIR_EraseRootFromParent_Done,
     /* 229009 */   // Label 4546: @229009
     /* 229009 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(229051), // Rule ID 9555 //
     /* 229014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 229022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 229025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 229038 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1348:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 229038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
     /* 229041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 229043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229047 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229049 */     GIR_RootConstrainSelectedInstOperands,
     /* 229050 */     // GIR_Coverage, 9555,
     /* 229050 */     GIR_EraseRootFromParent_Done,
     /* 229051 */   // Label 4547: @229051
     /* 229051 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(229093), // Rule ID 10093 //
     /* 229056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 229064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229080 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1579:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
     /* 229083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229089 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229091 */     GIR_RootConstrainSelectedInstOperands,
     /* 229092 */     // GIR_Coverage, 10093,
     /* 229092 */     GIR_EraseRootFromParent_Done,
     /* 229093 */   // Label 4548: @229093
     /* 229093 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(229135), // Rule ID 10094 //
     /* 229098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 229106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229122 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1579:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
     /* 229125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229131 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229133 */     GIR_RootConstrainSelectedInstOperands,
     /* 229134 */     // GIR_Coverage, 10094,
     /* 229134 */     GIR_EraseRootFromParent_Done,
     /* 229135 */   // Label 4549: @229135
     /* 229135 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(229177), // Rule ID 10095 //
     /* 229140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 229148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229157 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229164 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1579:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
     /* 229167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229175 */     GIR_RootConstrainSelectedInstOperands,
     /* 229176 */     // GIR_Coverage, 10095,
     /* 229176 */     GIR_EraseRootFromParent_Done,
     /* 229177 */   // Label 4550: @229177
     /* 229177 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(229219), // Rule ID 10096 //
     /* 229182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 229190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229199 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229206 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1579:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
     /* 229209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229217 */     GIR_RootConstrainSelectedInstOperands,
     /* 229218 */     // GIR_Coverage, 10096,
     /* 229218 */     GIR_EraseRootFromParent_Done,
     /* 229219 */   // Label 4551: @229219
     /* 229219 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(229261), // Rule ID 10097 //
     /* 229224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 229232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229248 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1576:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 229248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
     /* 229251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229257 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229259 */     GIR_RootConstrainSelectedInstOperands,
     /* 229260 */     // GIR_Coverage, 10097,
     /* 229260 */     GIR_EraseRootFromParent_Done,
     /* 229261 */   // Label 4552: @229261
     /* 229261 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(229303), // Rule ID 10098 //
     /* 229266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 229274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229283 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229290 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1576:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 229290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
     /* 229293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229301 */     GIR_RootConstrainSelectedInstOperands,
     /* 229302 */     // GIR_Coverage, 10098,
     /* 229302 */     GIR_EraseRootFromParent_Done,
     /* 229303 */   // Label 4553: @229303
     /* 229303 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(229345), // Rule ID 10099 //
     /* 229308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 229316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229332 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1576:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
     /* 229335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229341 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229343 */     GIR_RootConstrainSelectedInstOperands,
     /* 229344 */     // GIR_Coverage, 10099,
     /* 229344 */     GIR_EraseRootFromParent_Done,
     /* 229345 */   // Label 4554: @229345
     /* 229345 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(229387), // Rule ID 10100 //
     /* 229350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 229358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 229364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229374 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1576:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
     /* 229377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229385 */     GIR_RootConstrainSelectedInstOperands,
     /* 229386 */     // GIR_Coverage, 10100,
     /* 229386 */     GIR_EraseRootFromParent_Done,
     /* 229387 */   // Label 4555: @229387
     /* 229387 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(229429), // Rule ID 10113 //
     /* 229392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229395 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 229400 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229403 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229406 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229409 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229416 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1581:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
     /* 229419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229427 */     GIR_RootConstrainSelectedInstOperands,
     /* 229428 */     // GIR_Coverage, 10113,
     /* 229428 */     GIR_EraseRootFromParent_Done,
     /* 229429 */   // Label 4556: @229429
     /* 229429 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(229471), // Rule ID 10114 //
     /* 229434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 229442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229458 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1581:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
     /* 229461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229467 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229469 */     GIR_RootConstrainSelectedInstOperands,
     /* 229470 */     // GIR_Coverage, 10114,
     /* 229470 */     GIR_EraseRootFromParent_Done,
     /* 229471 */   // Label 4557: @229471
     /* 229471 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(229513), // Rule ID 10115 //
     /* 229476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 229484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229500 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1581:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
     /* 229503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229509 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229511 */     GIR_RootConstrainSelectedInstOperands,
     /* 229512 */     // GIR_Coverage, 10115,
     /* 229512 */     GIR_EraseRootFromParent_Done,
     /* 229513 */   // Label 4558: @229513
     /* 229513 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(229555), // Rule ID 10116 //
     /* 229518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 229526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 229532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 229535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229542 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1578:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
     /* 229545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229551 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229553 */     GIR_RootConstrainSelectedInstOperands,
     /* 229554 */     // GIR_Coverage, 10116,
     /* 229554 */     GIR_EraseRootFromParent_Done,
     /* 229555 */   // Label 4559: @229555
     /* 229555 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(229597), // Rule ID 10117 //
     /* 229560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 229568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 229574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229584 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1578:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
     /* 229587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229595 */     GIR_RootConstrainSelectedInstOperands,
     /* 229596 */     // GIR_Coverage, 10117,
     /* 229596 */     GIR_EraseRootFromParent_Done,
     /* 229597 */   // Label 4560: @229597
     /* 229597 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(229639), // Rule ID 10118 //
     /* 229602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 229610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 229616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229626 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1578:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
     /* 229629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 229631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229635 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229637 */     GIR_RootConstrainSelectedInstOperands,
     /* 229638 */     // GIR_Coverage, 10118,
     /* 229638 */     GIR_EraseRootFromParent_Done,
     /* 229639 */   // Label 4561: @229639
     /* 229639 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(229681), // Rule ID 10145 //
     /* 229644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
     /* 229652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229668 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1373:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 229668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
     /* 229671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229677 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229679 */     GIR_RootConstrainSelectedInstOperands,
     /* 229680 */     // GIR_Coverage, 10145,
     /* 229680 */     GIR_EraseRootFromParent_Done,
     /* 229681 */   // Label 4562: @229681
     /* 229681 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(229723), // Rule ID 10149 //
     /* 229686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
     /* 229694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229703 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229710 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1376:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 229710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
     /* 229713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229719 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229721 */     GIR_RootConstrainSelectedInstOperands,
     /* 229722 */     // GIR_Coverage, 10149,
     /* 229722 */     GIR_EraseRootFromParent_Done,
     /* 229723 */   // Label 4563: @229723
     /* 229723 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(229765), // Rule ID 10153 //
     /* 229728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
     /* 229736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229745 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229752 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1375:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 229752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
     /* 229755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229761 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229763 */     GIR_RootConstrainSelectedInstOperands,
     /* 229764 */     // GIR_Coverage, 10153,
     /* 229764 */     GIR_EraseRootFromParent_Done,
     /* 229765 */   // Label 4564: @229765
     /* 229765 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(229807), // Rule ID 10157 //
     /* 229770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
     /* 229778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229794 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1377:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 229794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
     /* 229797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229803 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229805 */     GIR_RootConstrainSelectedInstOperands,
     /* 229806 */     // GIR_Coverage, 10157,
     /* 229806 */     GIR_EraseRootFromParent_Done,
     /* 229807 */   // Label 4565: @229807
     /* 229807 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(229849), // Rule ID 10161 //
     /* 229812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
     /* 229820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229836 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1689:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
     /* 229839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229845 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229847 */     GIR_RootConstrainSelectedInstOperands,
     /* 229848 */     // GIR_Coverage, 10161,
     /* 229848 */     GIR_EraseRootFromParent_Done,
     /* 229849 */   // Label 4566: @229849
     /* 229849 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(229891), // Rule ID 10162 //
     /* 229854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
     /* 229862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229868 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229871 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229878 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1936:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
     /* 229881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229887 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229889 */     GIR_RootConstrainSelectedInstOperands,
     /* 229890 */     // GIR_Coverage, 10162,
     /* 229890 */     GIR_EraseRootFromParent_Done,
     /* 229891 */   // Label 4567: @229891
     /* 229891 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(229933), // Rule ID 10163 //
     /* 229896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
     /* 229904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229920 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1933:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 229920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
     /* 229923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229931 */     GIR_RootConstrainSelectedInstOperands,
     /* 229932 */     // GIR_Coverage, 10163,
     /* 229932 */     GIR_EraseRootFromParent_Done,
     /* 229933 */   // Label 4568: @229933
     /* 229933 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(229975), // Rule ID 10167 //
     /* 229938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
     /* 229946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229955 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229962 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1688:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 229962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
     /* 229965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229971 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229973 */     GIR_RootConstrainSelectedInstOperands,
     /* 229974 */     // GIR_Coverage, 10167,
     /* 229974 */     GIR_EraseRootFromParent_Done,
     /* 229975 */   // Label 4569: @229975
     /* 229975 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(230017), // Rule ID 10171 //
     /* 229980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
     /* 229988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229997 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230004 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1686:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
     /* 230007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230013 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230015 */     GIR_RootConstrainSelectedInstOperands,
     /* 230016 */     // GIR_Coverage, 10171,
     /* 230016 */     GIR_EraseRootFromParent_Done,
     /* 230017 */   // Label 4570: @230017
     /* 230017 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(230059), // Rule ID 10175 //
     /* 230022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
     /* 230030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230039 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230046 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1687:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
     /* 230049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230055 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230057 */     GIR_RootConstrainSelectedInstOperands,
     /* 230058 */     // GIR_Coverage, 10175,
     /* 230058 */     GIR_EraseRootFromParent_Done,
     /* 230059 */   // Label 4571: @230059
     /* 230059 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(230101), // Rule ID 10179 //
     /* 230064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
     /* 230072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230088 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1935:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
     /* 230091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230099 */     GIR_RootConstrainSelectedInstOperands,
     /* 230100 */     // GIR_Coverage, 10179,
     /* 230100 */     GIR_EraseRootFromParent_Done,
     /* 230101 */   // Label 4572: @230101
     /* 230101 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(230143), // Rule ID 10183 //
     /* 230106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
     /* 230114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230123 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230130 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1934:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
     /* 230133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230141 */     GIR_RootConstrainSelectedInstOperands,
     /* 230142 */     // GIR_Coverage, 10183,
     /* 230142 */     GIR_EraseRootFromParent_Done,
     /* 230143 */   // Label 4573: @230143
     /* 230143 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(230185), // Rule ID 10193 //
     /* 230148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
     /* 230156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230172 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1391:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 230172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
     /* 230175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230181 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230183 */     GIR_RootConstrainSelectedInstOperands,
     /* 230184 */     // GIR_Coverage, 10193,
     /* 230184 */     GIR_EraseRootFromParent_Done,
     /* 230185 */   // Label 4574: @230185
     /* 230185 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(230227), // Rule ID 10194 //
     /* 230190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
     /* 230198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230214 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1398:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 230214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
     /* 230217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230223 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230225 */     GIR_RootConstrainSelectedInstOperands,
     /* 230226 */     // GIR_Coverage, 10194,
     /* 230226 */     GIR_EraseRootFromParent_Done,
     /* 230227 */   // Label 4575: @230227
     /* 230227 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(230269), // Rule ID 10195 //
     /* 230232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
     /* 230240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230249 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230256 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1393:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 230256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
     /* 230259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230267 */     GIR_RootConstrainSelectedInstOperands,
     /* 230268 */     // GIR_Coverage, 10195,
     /* 230268 */     GIR_EraseRootFromParent_Done,
     /* 230269 */   // Label 4576: @230269
     /* 230269 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(230311), // Rule ID 10199 //
     /* 230274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
     /* 230282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230291 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230298 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1390:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 230298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
     /* 230301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230307 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230309 */     GIR_RootConstrainSelectedInstOperands,
     /* 230310 */     // GIR_Coverage, 10199,
     /* 230310 */     GIR_EraseRootFromParent_Done,
     /* 230311 */   // Label 4577: @230311
     /* 230311 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(230353), // Rule ID 10203 //
     /* 230316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
     /* 230324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230340 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1392:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 230340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
     /* 230343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230349 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230351 */     GIR_RootConstrainSelectedInstOperands,
     /* 230352 */     // GIR_Coverage, 10203,
     /* 230352 */     GIR_EraseRootFromParent_Done,
     /* 230353 */   // Label 4578: @230353
     /* 230353 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(230395), // Rule ID 10207 //
     /* 230358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
     /* 230366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230382 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1397:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 230382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
     /* 230385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230391 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230393 */     GIR_RootConstrainSelectedInstOperands,
     /* 230394 */     // GIR_Coverage, 10207,
     /* 230394 */     GIR_EraseRootFromParent_Done,
     /* 230395 */   // Label 4579: @230395
     /* 230395 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(230437), // Rule ID 10211 //
     /* 230400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
     /* 230408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230417 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230424 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1399:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 230424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
     /* 230427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230429 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230433 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230435 */     GIR_RootConstrainSelectedInstOperands,
     /* 230436 */     // GIR_Coverage, 10211,
     /* 230436 */     GIR_EraseRootFromParent_Done,
     /* 230437 */   // Label 4580: @230437
     /* 230437 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(230479), // Rule ID 10215 //
     /* 230442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
     /* 230450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230459 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230466 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1400:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 230466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
     /* 230469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230475 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230477 */     GIR_RootConstrainSelectedInstOperands,
     /* 230478 */     // GIR_Coverage, 10215,
     /* 230478 */     GIR_EraseRootFromParent_Done,
     /* 230479 */   // Label 4581: @230479
     /* 230479 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(230521), // Rule ID 11192 //
     /* 230484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 230487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
     /* 230492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230508 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1975:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
     /* 230511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230517 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230519 */     GIR_RootConstrainSelectedInstOperands,
     /* 230520 */     // GIR_Coverage, 11192,
     /* 230520 */     GIR_EraseRootFromParent_Done,
     /* 230521 */   // Label 4582: @230521
     /* 230521 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(230563), // Rule ID 11193 //
     /* 230526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 230529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
     /* 230534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230540 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230543 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230550 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
     /* 230553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230559 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230561 */     GIR_RootConstrainSelectedInstOperands,
     /* 230562 */     // GIR_Coverage, 11193,
     /* 230562 */     GIR_EraseRootFromParent_Done,
     /* 230563 */   // Label 4583: @230563
     /* 230563 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(230605), // Rule ID 11195 //
     /* 230568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
     /* 230571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 230576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230592 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1461:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 230592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
     /* 230595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230601 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230603 */     GIR_RootConstrainSelectedInstOperands,
     /* 230604 */     // GIR_Coverage, 11195,
     /* 230604 */     GIR_EraseRootFromParent_Done,
     /* 230605 */   // Label 4584: @230605
     /* 230605 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(230647), // Rule ID 11196 //
     /* 230610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
     /* 230613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 230618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230624 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230627 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230634 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1461:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 230634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
     /* 230637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230645 */     GIR_RootConstrainSelectedInstOperands,
     /* 230646 */     // GIR_Coverage, 11196,
     /* 230646 */     GIR_EraseRootFromParent_Done,
     /* 230647 */   // Label 4585: @230647
     /* 230647 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(230689), // Rule ID 11250 //
     /* 230652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 230660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230676 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1810:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
     /* 230679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230687 */     GIR_RootConstrainSelectedInstOperands,
     /* 230688 */     // GIR_Coverage, 11250,
     /* 230688 */     GIR_EraseRootFromParent_Done,
     /* 230689 */   // Label 4586: @230689
     /* 230689 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(230731), // Rule ID 11251 //
     /* 230694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 230702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230711 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230718 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1810:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
     /* 230721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230727 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230729 */     GIR_RootConstrainSelectedInstOperands,
     /* 230730 */     // GIR_Coverage, 11251,
     /* 230730 */     GIR_EraseRootFromParent_Done,
     /* 230731 */   // Label 4587: @230731
     /* 230731 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(230773), // Rule ID 11252 //
     /* 230736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 230744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230750 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230753 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230760 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1810:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
     /* 230763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230769 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230771 */     GIR_RootConstrainSelectedInstOperands,
     /* 230772 */     // GIR_Coverage, 11252,
     /* 230772 */     GIR_EraseRootFromParent_Done,
     /* 230773 */   // Label 4588: @230773
     /* 230773 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(230815), // Rule ID 11253 //
     /* 230778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 230786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 230795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230802 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1810:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 230802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
     /* 230805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230813 */     GIR_RootConstrainSelectedInstOperands,
     /* 230814 */     // GIR_Coverage, 11253,
     /* 230814 */     GIR_EraseRootFromParent_Done,
     /* 230815 */   // Label 4589: @230815
     /* 230815 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(230857), // Rule ID 11306 //
     /* 230820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 230828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230844 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1731:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
     /* 230847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230853 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230855 */     GIR_RootConstrainSelectedInstOperands,
     /* 230856 */     // GIR_Coverage, 11306,
     /* 230856 */     GIR_EraseRootFromParent_Done,
     /* 230857 */   // Label 4590: @230857
     /* 230857 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(230899), // Rule ID 11307 //
     /* 230862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 230870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 230879 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230886 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1731:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 230886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
     /* 230889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230895 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230897 */     GIR_RootConstrainSelectedInstOperands,
     /* 230898 */     // GIR_Coverage, 11307,
     /* 230898 */     GIR_EraseRootFromParent_Done,
     /* 230899 */   // Label 4591: @230899
     /* 230899 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(230941), // Rule ID 11308 //
     /* 230904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 230912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 230921 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230928 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1731:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 230928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
     /* 230931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230937 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230939 */     GIR_RootConstrainSelectedInstOperands,
     /* 230940 */     // GIR_Coverage, 11308,
     /* 230940 */     GIR_EraseRootFromParent_Done,
     /* 230941 */   // Label 4592: @230941
     /* 230941 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(230983), // Rule ID 11309 //
     /* 230946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 230954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 230963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230970 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1967:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 230970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
     /* 230973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 230975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 230977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 230979 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 230981 */     GIR_RootConstrainSelectedInstOperands,
     /* 230982 */     // GIR_Coverage, 11309,
     /* 230982 */     GIR_EraseRootFromParent_Done,
     /* 230983 */   // Label 4593: @230983
     /* 230983 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(231025), // Rule ID 11310 //
     /* 230988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 230996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231012 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1967:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
     /* 231015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231021 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231023 */     GIR_RootConstrainSelectedInstOperands,
     /* 231024 */     // GIR_Coverage, 11310,
     /* 231024 */     GIR_EraseRootFromParent_Done,
     /* 231025 */   // Label 4594: @231025
     /* 231025 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(231067), // Rule ID 11311 //
     /* 231030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 231038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231047 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231054 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1967:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
     /* 231057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231063 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231065 */     GIR_RootConstrainSelectedInstOperands,
     /* 231066 */     // GIR_Coverage, 11311,
     /* 231066 */     GIR_EraseRootFromParent_Done,
     /* 231067 */   // Label 4595: @231067
     /* 231067 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(231109), // Rule ID 11312 //
     /* 231072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 231080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231089 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231096 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1969:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
     /* 231099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231105 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231107 */     GIR_RootConstrainSelectedInstOperands,
     /* 231108 */     // GIR_Coverage, 11312,
     /* 231108 */     GIR_EraseRootFromParent_Done,
     /* 231109 */   // Label 4596: @231109
     /* 231109 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(231151), // Rule ID 11313 //
     /* 231114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 231122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231138 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1969:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
     /* 231141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231149 */     GIR_RootConstrainSelectedInstOperands,
     /* 231150 */     // GIR_Coverage, 11313,
     /* 231150 */     GIR_EraseRootFromParent_Done,
     /* 231151 */   // Label 4597: @231151
     /* 231151 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(231193), // Rule ID 11314 //
     /* 231156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 231164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231173 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231180 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1969:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
     /* 231183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231191 */     GIR_RootConstrainSelectedInstOperands,
     /* 231192 */     // GIR_Coverage, 11314,
     /* 231192 */     GIR_EraseRootFromParent_Done,
     /* 231193 */   // Label 4598: @231193
     /* 231193 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(231235), // Rule ID 11315 //
     /* 231198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 231206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231222 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1733:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
     /* 231225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231233 */     GIR_RootConstrainSelectedInstOperands,
     /* 231234 */     // GIR_Coverage, 11315,
     /* 231234 */     GIR_EraseRootFromParent_Done,
     /* 231235 */   // Label 4599: @231235
     /* 231235 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(231277), // Rule ID 11316 //
     /* 231240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 231248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231264 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1733:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
     /* 231267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231273 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231275 */     GIR_RootConstrainSelectedInstOperands,
     /* 231276 */     // GIR_Coverage, 11316,
     /* 231276 */     GIR_EraseRootFromParent_Done,
     /* 231277 */   // Label 4600: @231277
     /* 231277 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(231319), // Rule ID 11317 //
     /* 231282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 231290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231296 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231299 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231306 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1733:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
     /* 231309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231311 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231315 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231317 */     GIR_RootConstrainSelectedInstOperands,
     /* 231318 */     // GIR_Coverage, 11317,
     /* 231318 */     GIR_EraseRootFromParent_Done,
     /* 231319 */   // Label 4601: @231319
     /* 231319 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(231361), // Rule ID 11318 //
     /* 231324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 231332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231341 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231348 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1735:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
     /* 231351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231359 */     GIR_RootConstrainSelectedInstOperands,
     /* 231360 */     // GIR_Coverage, 11318,
     /* 231360 */     GIR_EraseRootFromParent_Done,
     /* 231361 */   // Label 4602: @231361
     /* 231361 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(231403), // Rule ID 11319 //
     /* 231366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 231374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231383 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231390 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1735:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
     /* 231393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231399 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231401 */     GIR_RootConstrainSelectedInstOperands,
     /* 231402 */     // GIR_Coverage, 11319,
     /* 231402 */     GIR_EraseRootFromParent_Done,
     /* 231403 */   // Label 4603: @231403
     /* 231403 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(231445), // Rule ID 11320 //
     /* 231408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 231416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231432 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1735:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
     /* 231435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231441 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231443 */     GIR_RootConstrainSelectedInstOperands,
     /* 231444 */     // GIR_Coverage, 11320,
     /* 231444 */     GIR_EraseRootFromParent_Done,
     /* 231445 */   // Label 4604: @231445
     /* 231445 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(231487), // Rule ID 11321 //
     /* 231450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 231458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231474 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1971:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
     /* 231477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231483 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231485 */     GIR_RootConstrainSelectedInstOperands,
     /* 231486 */     // GIR_Coverage, 11321,
     /* 231486 */     GIR_EraseRootFromParent_Done,
     /* 231487 */   // Label 4605: @231487
     /* 231487 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(231529), // Rule ID 11322 //
     /* 231492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 231500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231506 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231509 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231516 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1971:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
     /* 231519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231527 */     GIR_RootConstrainSelectedInstOperands,
     /* 231528 */     // GIR_Coverage, 11322,
     /* 231528 */     GIR_EraseRootFromParent_Done,
     /* 231529 */   // Label 4606: @231529
     /* 231529 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(231571), // Rule ID 11323 //
     /* 231534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 231542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231558 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1971:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
     /* 231561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231569 */     GIR_RootConstrainSelectedInstOperands,
     /* 231570 */     // GIR_Coverage, 11323,
     /* 231570 */     GIR_EraseRootFromParent_Done,
     /* 231571 */   // Label 4607: @231571
     /* 231571 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(231613), // Rule ID 11324 //
     /* 231576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 231584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231600 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1973:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
     /* 231603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231611 */     GIR_RootConstrainSelectedInstOperands,
     /* 231612 */     // GIR_Coverage, 11324,
     /* 231612 */     GIR_EraseRootFromParent_Done,
     /* 231613 */   // Label 4608: @231613
     /* 231613 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(231655), // Rule ID 11325 //
     /* 231618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 231626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231635 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231642 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1973:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
     /* 231645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231651 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231653 */     GIR_RootConstrainSelectedInstOperands,
     /* 231654 */     // GIR_Coverage, 11325,
     /* 231654 */     GIR_EraseRootFromParent_Done,
     /* 231655 */   // Label 4609: @231655
     /* 231655 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(231697), // Rule ID 11326 //
     /* 231660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231663 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 231668 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231671 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231674 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231677 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231684 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1973:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
     /* 231687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231695 */     GIR_RootConstrainSelectedInstOperands,
     /* 231696 */     // GIR_Coverage, 11326,
     /* 231696 */     GIR_EraseRootFromParent_Done,
     /* 231697 */   // Label 4610: @231697
     /* 231697 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(231739), // Rule ID 11335 //
     /* 231702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 231710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231726 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1771:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
     /* 231729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231735 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231737 */     GIR_RootConstrainSelectedInstOperands,
     /* 231738 */     // GIR_Coverage, 11335,
     /* 231738 */     GIR_EraseRootFromParent_Done,
     /* 231739 */   // Label 4611: @231739
     /* 231739 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(231781), // Rule ID 11336 //
     /* 231744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 231752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1771:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
     /* 231771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231777 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231779 */     GIR_RootConstrainSelectedInstOperands,
     /* 231780 */     // GIR_Coverage, 11336,
     /* 231780 */     GIR_EraseRootFromParent_Done,
     /* 231781 */   // Label 4612: @231781
     /* 231781 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(231823), // Rule ID 11337 //
     /* 231786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 231794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231803 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231810 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1771:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
     /* 231813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231817 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231819 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231821 */     GIR_RootConstrainSelectedInstOperands,
     /* 231822 */     // GIR_Coverage, 11337,
     /* 231822 */     GIR_EraseRootFromParent_Done,
     /* 231823 */   // Label 4613: @231823
     /* 231823 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(231865), // Rule ID 11338 //
     /* 231828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 231836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231845 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231852 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1774:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
     /* 231855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231861 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231863 */     GIR_RootConstrainSelectedInstOperands,
     /* 231864 */     // GIR_Coverage, 11338,
     /* 231864 */     GIR_EraseRootFromParent_Done,
     /* 231865 */   // Label 4614: @231865
     /* 231865 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(231907), // Rule ID 11339 //
     /* 231870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 231878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 231881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 231884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 231887 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 231890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231894 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1774:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 231894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
     /* 231897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231903 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231905 */     GIR_RootConstrainSelectedInstOperands,
     /* 231906 */     // GIR_Coverage, 11339,
     /* 231906 */     GIR_EraseRootFromParent_Done,
     /* 231907 */   // Label 4615: @231907
     /* 231907 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(231949), // Rule ID 11340 //
     /* 231912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 231920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 231923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 231926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 231929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 231932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231936 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1774:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 231936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
     /* 231939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231945 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231947 */     GIR_RootConstrainSelectedInstOperands,
     /* 231948 */     // GIR_Coverage, 11340,
     /* 231948 */     GIR_EraseRootFromParent_Done,
     /* 231949 */   // Label 4616: @231949
     /* 231949 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(231991), // Rule ID 11341 //
     /* 231954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 231962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 231965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 231968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 231971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 231974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 231978 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1776:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 231978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
     /* 231981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 231983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 231985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 231987 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 231989 */     GIR_RootConstrainSelectedInstOperands,
     /* 231990 */     // GIR_Coverage, 11341,
     /* 231990 */     GIR_EraseRootFromParent_Done,
     /* 231991 */   // Label 4617: @231991
     /* 231991 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(232033), // Rule ID 11342 //
     /* 231996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 231999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 232004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232020 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1776:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
     /* 232023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232029 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232031 */     GIR_RootConstrainSelectedInstOperands,
     /* 232032 */     // GIR_Coverage, 11342,
     /* 232032 */     GIR_EraseRootFromParent_Done,
     /* 232033 */   // Label 4618: @232033
     /* 232033 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(232075), // Rule ID 11343 //
     /* 232038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 232046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232062 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1776:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
     /* 232065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232071 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232073 */     GIR_RootConstrainSelectedInstOperands,
     /* 232074 */     // GIR_Coverage, 11343,
     /* 232074 */     GIR_EraseRootFromParent_Done,
     /* 232075 */   // Label 4619: @232075
     /* 232075 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(232117), // Rule ID 11344 //
     /* 232080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 232088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232097 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232104 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1779:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
     /* 232107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232113 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232115 */     GIR_RootConstrainSelectedInstOperands,
     /* 232116 */     // GIR_Coverage, 11344,
     /* 232116 */     GIR_EraseRootFromParent_Done,
     /* 232117 */   // Label 4620: @232117
     /* 232117 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(232159), // Rule ID 11345 //
     /* 232122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 232130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232139 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232146 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1779:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
     /* 232149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232155 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232157 */     GIR_RootConstrainSelectedInstOperands,
     /* 232158 */     // GIR_Coverage, 11345,
     /* 232158 */     GIR_EraseRootFromParent_Done,
     /* 232159 */   // Label 4621: @232159
     /* 232159 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(232201), // Rule ID 11346 //
     /* 232164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 232172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232181 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232188 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1779:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
     /* 232191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232195 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232197 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232199 */     GIR_RootConstrainSelectedInstOperands,
     /* 232200 */     // GIR_Coverage, 11346,
     /* 232200 */     GIR_EraseRootFromParent_Done,
     /* 232201 */   // Label 4622: @232201
     /* 232201 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(232243), // Rule ID 11347 //
     /* 232206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 232214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232230 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1773:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
     /* 232233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232239 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232241 */     GIR_RootConstrainSelectedInstOperands,
     /* 232242 */     // GIR_Coverage, 11347,
     /* 232242 */     GIR_EraseRootFromParent_Done,
     /* 232243 */   // Label 4623: @232243
     /* 232243 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(232285), // Rule ID 11348 //
     /* 232248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 232256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232272 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1773:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
     /* 232275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232281 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232283 */     GIR_RootConstrainSelectedInstOperands,
     /* 232284 */     // GIR_Coverage, 11348,
     /* 232284 */     GIR_EraseRootFromParent_Done,
     /* 232285 */   // Label 4624: @232285
     /* 232285 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(232327), // Rule ID 11349 //
     /* 232290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 232298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232314 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1773:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
     /* 232317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232325 */     GIR_RootConstrainSelectedInstOperands,
     /* 232326 */     // GIR_Coverage, 11349,
     /* 232326 */     GIR_EraseRootFromParent_Done,
     /* 232327 */   // Label 4625: @232327
     /* 232327 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(232369), // Rule ID 11350 //
     /* 232332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 232340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 232346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232356 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1778:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
     /* 232359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232365 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232367 */     GIR_RootConstrainSelectedInstOperands,
     /* 232368 */     // GIR_Coverage, 11350,
     /* 232368 */     GIR_EraseRootFromParent_Done,
     /* 232369 */   // Label 4626: @232369
     /* 232369 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(232411), // Rule ID 11351 //
     /* 232374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 232382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 232388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232391 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232398 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1778:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
     /* 232401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232407 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232409 */     GIR_RootConstrainSelectedInstOperands,
     /* 232410 */     // GIR_Coverage, 11351,
     /* 232410 */     GIR_EraseRootFromParent_Done,
     /* 232411 */   // Label 4627: @232411
     /* 232411 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(232453), // Rule ID 11352 //
     /* 232416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 232424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 232430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232440 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1778:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
     /* 232443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 232445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232449 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232451 */     GIR_RootConstrainSelectedInstOperands,
     /* 232452 */     // GIR_Coverage, 11352,
     /* 232452 */     GIR_EraseRootFromParent_Done,
     /* 232453 */   // Label 4628: @232453
     /* 232453 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(232495), // Rule ID 11353 //
     /* 232458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 232466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232482 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1946:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
     /* 232485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232491 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232493 */     GIR_RootConstrainSelectedInstOperands,
     /* 232494 */     // GIR_Coverage, 11353,
     /* 232494 */     GIR_EraseRootFromParent_Done,
     /* 232495 */   // Label 4629: @232495
     /* 232495 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(232537), // Rule ID 11355 //
     /* 232500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 232508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232524 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1946:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
     /* 232527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232533 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232535 */     GIR_RootConstrainSelectedInstOperands,
     /* 232536 */     // GIR_Coverage, 11355,
     /* 232536 */     GIR_EraseRootFromParent_Done,
     /* 232537 */   // Label 4630: @232537
     /* 232537 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(232579), // Rule ID 11357 //
     /* 232542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 232550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232559 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232566 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1946:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
     /* 232569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232575 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232577 */     GIR_RootConstrainSelectedInstOperands,
     /* 232578 */     // GIR_Coverage, 11357,
     /* 232578 */     GIR_EraseRootFromParent_Done,
     /* 232579 */   // Label 4631: @232579
     /* 232579 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(232621), // Rule ID 11359 //
     /* 232584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 232592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232608 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1946:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
     /* 232611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232619 */     GIR_RootConstrainSelectedInstOperands,
     /* 232620 */     // GIR_Coverage, 11359,
     /* 232620 */     GIR_EraseRootFromParent_Done,
     /* 232621 */   // Label 4632: @232621
     /* 232621 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(232663), // Rule ID 11361 //
     /* 232626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 232634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232643 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232650 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1706:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
     /* 232653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232659 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232661 */     GIR_RootConstrainSelectedInstOperands,
     /* 232662 */     // GIR_Coverage, 11361,
     /* 232662 */     GIR_EraseRootFromParent_Done,
     /* 232663 */   // Label 4633: @232663
     /* 232663 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(232705), // Rule ID 11362 //
     /* 232668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 232676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232685 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232692 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1706:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
     /* 232695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232701 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232703 */     GIR_RootConstrainSelectedInstOperands,
     /* 232704 */     // GIR_Coverage, 11362,
     /* 232704 */     GIR_EraseRootFromParent_Done,
     /* 232705 */   // Label 4634: @232705
     /* 232705 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(232747), // Rule ID 11363 //
     /* 232710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 232718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232727 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232734 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1706:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
     /* 232737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232743 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232745 */     GIR_RootConstrainSelectedInstOperands,
     /* 232746 */     // GIR_Coverage, 11363,
     /* 232746 */     GIR_EraseRootFromParent_Done,
     /* 232747 */   // Label 4635: @232747
     /* 232747 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(232789), // Rule ID 11364 //
     /* 232752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 232760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232769 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232776 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1706:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
     /* 232779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232787 */     GIR_RootConstrainSelectedInstOperands,
     /* 232788 */     // GIR_Coverage, 11364,
     /* 232788 */     GIR_EraseRootFromParent_Done,
     /* 232789 */   // Label 4636: @232789
     /* 232789 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(232831), // Rule ID 11365 //
     /* 232794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 232802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232818 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1947:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
     /* 232821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232829 */     GIR_RootConstrainSelectedInstOperands,
     /* 232830 */     // GIR_Coverage, 11365,
     /* 232830 */     GIR_EraseRootFromParent_Done,
     /* 232831 */   // Label 4637: @232831
     /* 232831 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(232873), // Rule ID 11366 //
     /* 232836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 232844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 232847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 232850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 232853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 232856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232860 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1947:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 232860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
     /* 232863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232869 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232871 */     GIR_RootConstrainSelectedInstOperands,
     /* 232872 */     // GIR_Coverage, 11366,
     /* 232872 */     GIR_EraseRootFromParent_Done,
     /* 232873 */   // Label 4638: @232873
     /* 232873 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(232915), // Rule ID 11367 //
     /* 232878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 232886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 232889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 232892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 232895 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 232898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232902 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1947:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 232902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
     /* 232905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232911 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232913 */     GIR_RootConstrainSelectedInstOperands,
     /* 232914 */     // GIR_Coverage, 11367,
     /* 232914 */     GIR_EraseRootFromParent_Done,
     /* 232915 */   // Label 4639: @232915
     /* 232915 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(232957), // Rule ID 11368 //
     /* 232920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 232928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 232931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 232934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 232937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 232940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232944 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1947:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 232944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
     /* 232947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232953 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232955 */     GIR_RootConstrainSelectedInstOperands,
     /* 232956 */     // GIR_Coverage, 11368,
     /* 232956 */     GIR_EraseRootFromParent_Done,
     /* 232957 */   // Label 4640: @232957
     /* 232957 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(232999), // Rule ID 11369 //
     /* 232962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 232965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 232970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 232973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 232979 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 232982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 232986 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1841:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 232986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
     /* 232989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 232991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 232993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 232995 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 232997 */     GIR_RootConstrainSelectedInstOperands,
     /* 232998 */     // GIR_Coverage, 11369,
     /* 232998 */     GIR_EraseRootFromParent_Done,
     /* 232999 */   // Label 4641: @232999
     /* 232999 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(233041), // Rule ID 11371 //
     /* 233004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 233012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233028 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1841:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
     /* 233031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233039 */     GIR_RootConstrainSelectedInstOperands,
     /* 233040 */     // GIR_Coverage, 11371,
     /* 233040 */     GIR_EraseRootFromParent_Done,
     /* 233041 */   // Label 4642: @233041
     /* 233041 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(233083), // Rule ID 11373 //
     /* 233046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 233054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233063 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233070 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1841:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
     /* 233073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233081 */     GIR_RootConstrainSelectedInstOperands,
     /* 233082 */     // GIR_Coverage, 11373,
     /* 233082 */     GIR_EraseRootFromParent_Done,
     /* 233083 */   // Label 4643: @233083
     /* 233083 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(233125), // Rule ID 11375 //
     /* 233088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 233096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233105 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233112 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1841:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
     /* 233115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233121 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233123 */     GIR_RootConstrainSelectedInstOperands,
     /* 233124 */     // GIR_Coverage, 11375,
     /* 233124 */     GIR_EraseRootFromParent_Done,
     /* 233125 */   // Label 4644: @233125
     /* 233125 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(233167), // Rule ID 11377 //
     /* 233130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 233138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233147 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233154 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2033:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
     /* 233157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233163 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233165 */     GIR_RootConstrainSelectedInstOperands,
     /* 233166 */     // GIR_Coverage, 11377,
     /* 233166 */     GIR_EraseRootFromParent_Done,
     /* 233167 */   // Label 4645: @233167
     /* 233167 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(233209), // Rule ID 11379 //
     /* 233172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 233180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233196 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2033:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
     /* 233199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233203 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233205 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233207 */     GIR_RootConstrainSelectedInstOperands,
     /* 233208 */     // GIR_Coverage, 11379,
     /* 233208 */     GIR_EraseRootFromParent_Done,
     /* 233209 */   // Label 4646: @233209
     /* 233209 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(233251), // Rule ID 11381 //
     /* 233214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 233222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233231 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233238 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2033:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
     /* 233241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233245 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233247 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233249 */     GIR_RootConstrainSelectedInstOperands,
     /* 233250 */     // GIR_Coverage, 11381,
     /* 233250 */     GIR_EraseRootFromParent_Done,
     /* 233251 */   // Label 4647: @233251
     /* 233251 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(233293), // Rule ID 11383 //
     /* 233256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 233264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233280 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2033:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
     /* 233283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233289 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233291 */     GIR_RootConstrainSelectedInstOperands,
     /* 233292 */     // GIR_Coverage, 11383,
     /* 233292 */     GIR_EraseRootFromParent_Done,
     /* 233293 */   // Label 4648: @233293
     /* 233293 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(233335), // Rule ID 11385 //
     /* 233298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 233306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233315 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233322 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1707:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
     /* 233325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233331 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233333 */     GIR_RootConstrainSelectedInstOperands,
     /* 233334 */     // GIR_Coverage, 11385,
     /* 233334 */     GIR_EraseRootFromParent_Done,
     /* 233335 */   // Label 4649: @233335
     /* 233335 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(233377), // Rule ID 11386 //
     /* 233340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 233348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233357 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233364 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1707:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
     /* 233367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233373 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233375 */     GIR_RootConstrainSelectedInstOperands,
     /* 233376 */     // GIR_Coverage, 11386,
     /* 233376 */     GIR_EraseRootFromParent_Done,
     /* 233377 */   // Label 4650: @233377
     /* 233377 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(233419), // Rule ID 11387 //
     /* 233382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 233390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233406 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1707:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
     /* 233409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233415 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233417 */     GIR_RootConstrainSelectedInstOperands,
     /* 233418 */     // GIR_Coverage, 11387,
     /* 233418 */     GIR_EraseRootFromParent_Done,
     /* 233419 */   // Label 4651: @233419
     /* 233419 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(233461), // Rule ID 11388 //
     /* 233424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 233432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233448 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1707:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
     /* 233451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233457 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233459 */     GIR_RootConstrainSelectedInstOperands,
     /* 233460 */     // GIR_Coverage, 11388,
     /* 233460 */     GIR_EraseRootFromParent_Done,
     /* 233461 */   // Label 4652: @233461
     /* 233461 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(233503), // Rule ID 11389 //
     /* 233466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 233474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233490 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1948:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
     /* 233493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233499 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233501 */     GIR_RootConstrainSelectedInstOperands,
     /* 233502 */     // GIR_Coverage, 11389,
     /* 233502 */     GIR_EraseRootFromParent_Done,
     /* 233503 */   // Label 4653: @233503
     /* 233503 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(233545), // Rule ID 11390 //
     /* 233508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 233516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233532 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1948:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
     /* 233535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233541 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233543 */     GIR_RootConstrainSelectedInstOperands,
     /* 233544 */     // GIR_Coverage, 11390,
     /* 233544 */     GIR_EraseRootFromParent_Done,
     /* 233545 */   // Label 4654: @233545
     /* 233545 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(233587), // Rule ID 11391 //
     /* 233550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 233558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233564 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233567 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233574 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1948:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
     /* 233577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233583 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233585 */     GIR_RootConstrainSelectedInstOperands,
     /* 233586 */     // GIR_Coverage, 11391,
     /* 233586 */     GIR_EraseRootFromParent_Done,
     /* 233587 */   // Label 4655: @233587
     /* 233587 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(233629), // Rule ID 11392 //
     /* 233592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 233600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233616 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1948:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
     /* 233619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233623 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233625 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233627 */     GIR_RootConstrainSelectedInstOperands,
     /* 233628 */     // GIR_Coverage, 11392,
     /* 233628 */     GIR_EraseRootFromParent_Done,
     /* 233629 */   // Label 4656: @233629
     /* 233629 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(233671), // Rule ID 11393 //
     /* 233634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 233642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233658 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1923:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
     /* 233661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233667 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233669 */     GIR_RootConstrainSelectedInstOperands,
     /* 233670 */     // GIR_Coverage, 11393,
     /* 233670 */     GIR_EraseRootFromParent_Done,
     /* 233671 */   // Label 4657: @233671
     /* 233671 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(233713), // Rule ID 11394 //
     /* 233676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233679 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 233684 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233687 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233690 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233693 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233700 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1923:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
     /* 233703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233709 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233711 */     GIR_RootConstrainSelectedInstOperands,
     /* 233712 */     // GIR_Coverage, 11394,
     /* 233712 */     GIR_EraseRootFromParent_Done,
     /* 233713 */   // Label 4658: @233713
     /* 233713 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(233755), // Rule ID 11395 //
     /* 233718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 233726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233735 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233742 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1923:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
     /* 233745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 233747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233751 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233753 */     GIR_RootConstrainSelectedInstOperands,
     /* 233754 */     // GIR_Coverage, 11395,
     /* 233754 */     GIR_EraseRootFromParent_Done,
     /* 233755 */   // Label 4659: @233755
     /* 233755 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(233797), // Rule ID 11396 //
     /* 233760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 233768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233784 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1238:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
     /* 233787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233789 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233793 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233795 */     GIR_RootConstrainSelectedInstOperands,
     /* 233796 */     // GIR_Coverage, 11396,
     /* 233796 */     GIR_EraseRootFromParent_Done,
     /* 233797 */   // Label 4660: @233797
     /* 233797 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(233839), // Rule ID 11397 //
     /* 233802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 233810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233826 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1238:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
     /* 233829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233835 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233837 */     GIR_RootConstrainSelectedInstOperands,
     /* 233838 */     // GIR_Coverage, 11397,
     /* 233838 */     GIR_EraseRootFromParent_Done,
     /* 233839 */   // Label 4661: @233839
     /* 233839 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(233881), // Rule ID 11398 //
     /* 233844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 233852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 233855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 233858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 233861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 233864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233868 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1238:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 233868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
     /* 233871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233877 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233879 */     GIR_RootConstrainSelectedInstOperands,
     /* 233880 */     // GIR_Coverage, 11398,
     /* 233880 */     GIR_EraseRootFromParent_Done,
     /* 233881 */   // Label 4662: @233881
     /* 233881 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(233923), // Rule ID 11399 //
     /* 233886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 233894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 233897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 233900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 233903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 233906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233910 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1238:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 233910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
     /* 233913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233919 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233921 */     GIR_RootConstrainSelectedInstOperands,
     /* 233922 */     // GIR_Coverage, 11399,
     /* 233922 */     GIR_EraseRootFromParent_Done,
     /* 233923 */   // Label 4663: @233923
     /* 233923 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(233965), // Rule ID 11400 //
     /* 233928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 233936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 233939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 233942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 233945 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 233948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233952 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1717:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 233952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
     /* 233955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 233959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 233961 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 233963 */     GIR_RootConstrainSelectedInstOperands,
     /* 233964 */     // GIR_Coverage, 11400,
     /* 233964 */     GIR_EraseRootFromParent_Done,
     /* 233965 */   // Label 4664: @233965
     /* 233965 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(234007), // Rule ID 11401 //
     /* 233970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 233973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 233978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 233981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 233984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 233987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 233990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 233994 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1717:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 233994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
     /* 233997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 233999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234003 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234005 */     GIR_RootConstrainSelectedInstOperands,
     /* 234006 */     // GIR_Coverage, 11401,
     /* 234006 */     GIR_EraseRootFromParent_Done,
     /* 234007 */   // Label 4665: @234007
     /* 234007 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(234049), // Rule ID 11402 //
     /* 234012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 234020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234036 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1717:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
     /* 234039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234045 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234047 */     GIR_RootConstrainSelectedInstOperands,
     /* 234048 */     // GIR_Coverage, 11402,
     /* 234048 */     GIR_EraseRootFromParent_Done,
     /* 234049 */   // Label 4666: @234049
     /* 234049 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(234091), // Rule ID 11403 //
     /* 234054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 234062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234078 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1717:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
     /* 234081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234087 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234089 */     GIR_RootConstrainSelectedInstOperands,
     /* 234090 */     // GIR_Coverage, 11403,
     /* 234090 */     GIR_EraseRootFromParent_Done,
     /* 234091 */   // Label 4667: @234091
     /* 234091 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(234133), // Rule ID 11404 //
     /* 234096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 234104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234120 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1955:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
     /* 234123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234129 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234131 */     GIR_RootConstrainSelectedInstOperands,
     /* 234132 */     // GIR_Coverage, 11404,
     /* 234132 */     GIR_EraseRootFromParent_Done,
     /* 234133 */   // Label 4668: @234133
     /* 234133 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(234175), // Rule ID 11405 //
     /* 234138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 234146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234155 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234162 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1955:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
     /* 234165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234171 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234173 */     GIR_RootConstrainSelectedInstOperands,
     /* 234174 */     // GIR_Coverage, 11405,
     /* 234174 */     GIR_EraseRootFromParent_Done,
     /* 234175 */   // Label 4669: @234175
     /* 234175 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(234217), // Rule ID 11406 //
     /* 234180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 234188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234204 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1955:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
     /* 234207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234213 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234215 */     GIR_RootConstrainSelectedInstOperands,
     /* 234216 */     // GIR_Coverage, 11406,
     /* 234216 */     GIR_EraseRootFromParent_Done,
     /* 234217 */   // Label 4670: @234217
     /* 234217 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(234259), // Rule ID 11407 //
     /* 234222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 234230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234239 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234246 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1955:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
     /* 234249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234253 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234255 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234257 */     GIR_RootConstrainSelectedInstOperands,
     /* 234258 */     // GIR_Coverage, 11407,
     /* 234258 */     GIR_EraseRootFromParent_Done,
     /* 234259 */   // Label 4671: @234259
     /* 234259 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(234301), // Rule ID 11408 //
     /* 234264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 234272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234288 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1726:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
     /* 234291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234297 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234299 */     GIR_RootConstrainSelectedInstOperands,
     /* 234300 */     // GIR_Coverage, 11408,
     /* 234300 */     GIR_EraseRootFromParent_Done,
     /* 234301 */   // Label 4672: @234301
     /* 234301 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(234343), // Rule ID 11409 //
     /* 234306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 234314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234330 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1726:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
     /* 234333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234339 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234341 */     GIR_RootConstrainSelectedInstOperands,
     /* 234342 */     // GIR_Coverage, 11409,
     /* 234342 */     GIR_EraseRootFromParent_Done,
     /* 234343 */   // Label 4673: @234343
     /* 234343 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(234385), // Rule ID 11410 //
     /* 234348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 234356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234365 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234372 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1726:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
     /* 234375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234381 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234383 */     GIR_RootConstrainSelectedInstOperands,
     /* 234384 */     // GIR_Coverage, 11410,
     /* 234384 */     GIR_EraseRootFromParent_Done,
     /* 234385 */   // Label 4674: @234385
     /* 234385 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(234427), // Rule ID 11411 //
     /* 234390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 234398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234414 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1726:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
     /* 234417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234423 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234425 */     GIR_RootConstrainSelectedInstOperands,
     /* 234426 */     // GIR_Coverage, 11411,
     /* 234426 */     GIR_EraseRootFromParent_Done,
     /* 234427 */   // Label 4675: @234427
     /* 234427 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(234469), // Rule ID 11412 //
     /* 234432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 234440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234456 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1964:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
     /* 234459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234465 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234467 */     GIR_RootConstrainSelectedInstOperands,
     /* 234468 */     // GIR_Coverage, 11412,
     /* 234468 */     GIR_EraseRootFromParent_Done,
     /* 234469 */   // Label 4676: @234469
     /* 234469 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(234511), // Rule ID 11413 //
     /* 234474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 234482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234498 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1964:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
     /* 234501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234507 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234509 */     GIR_RootConstrainSelectedInstOperands,
     /* 234510 */     // GIR_Coverage, 11413,
     /* 234510 */     GIR_EraseRootFromParent_Done,
     /* 234511 */   // Label 4677: @234511
     /* 234511 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(234553), // Rule ID 11414 //
     /* 234516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 234524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234533 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234540 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1964:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
     /* 234543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234549 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234551 */     GIR_RootConstrainSelectedInstOperands,
     /* 234552 */     // GIR_Coverage, 11414,
     /* 234552 */     GIR_EraseRootFromParent_Done,
     /* 234553 */   // Label 4678: @234553
     /* 234553 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(234595), // Rule ID 11415 //
     /* 234558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 234566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234575 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234582 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1964:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
     /* 234585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234591 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234593 */     GIR_RootConstrainSelectedInstOperands,
     /* 234594 */     // GIR_Coverage, 11415,
     /* 234594 */     GIR_EraseRootFromParent_Done,
     /* 234595 */   // Label 4679: @234595
     /* 234595 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(234637), // Rule ID 11416 //
     /* 234600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 234608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234624 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2040:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
     /* 234627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234633 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234635 */     GIR_RootConstrainSelectedInstOperands,
     /* 234636 */     // GIR_Coverage, 11416,
     /* 234636 */     GIR_EraseRootFromParent_Done,
     /* 234637 */   // Label 4680: @234637
     /* 234637 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(234679), // Rule ID 11427 //
     /* 234642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 234650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 234656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 234659 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234666 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1805:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
     /* 234669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234675 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234677 */     GIR_RootConstrainSelectedInstOperands,
     /* 234678 */     // GIR_Coverage, 11427,
     /* 234678 */     GIR_EraseRootFromParent_Done,
     /* 234679 */   // Label 4681: @234679
     /* 234679 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(234721), // Rule ID 11428 //
     /* 234684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 234692 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 234698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 234701 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234708 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1805:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
     /* 234711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234717 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234719 */     GIR_RootConstrainSelectedInstOperands,
     /* 234720 */     // GIR_Coverage, 11428,
     /* 234720 */     GIR_EraseRootFromParent_Done,
     /* 234721 */   // Label 4682: @234721
     /* 234721 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(234763), // Rule ID 11429 //
     /* 234726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 234734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 234740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 234743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234750 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1805:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
     /* 234753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234759 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234761 */     GIR_RootConstrainSelectedInstOperands,
     /* 234762 */     // GIR_Coverage, 11429,
     /* 234762 */     GIR_EraseRootFromParent_Done,
     /* 234763 */   // Label 4683: @234763
     /* 234763 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(234805), // Rule ID 11430 //
     /* 234768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 234776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 234782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 234785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234792 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1805:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
     /* 234795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 234797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234801 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234803 */     GIR_RootConstrainSelectedInstOperands,
     /* 234804 */     // GIR_Coverage, 11430,
     /* 234804 */     GIR_EraseRootFromParent_Done,
     /* 234805 */   // Label 4684: @234805
     /* 234805 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(234847), // Rule ID 11439 //
     /* 234810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 234818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234834 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1746:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 234834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
     /* 234837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234843 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234845 */     GIR_RootConstrainSelectedInstOperands,
     /* 234846 */     // GIR_Coverage, 11439,
     /* 234846 */     GIR_EraseRootFromParent_Done,
     /* 234847 */   // Label 4685: @234847
     /* 234847 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(234889), // Rule ID 11440 //
     /* 234852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 234860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 234863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 234866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 234869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 234872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234876 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1746:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 234876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
     /* 234879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234885 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234887 */     GIR_RootConstrainSelectedInstOperands,
     /* 234888 */     // GIR_Coverage, 11440,
     /* 234888 */     GIR_EraseRootFromParent_Done,
     /* 234889 */   // Label 4686: @234889
     /* 234889 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(234931), // Rule ID 11441 //
     /* 234894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 234902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 234905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 234908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 234911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 234914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234918 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1746:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 234918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
     /* 234921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234927 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234929 */     GIR_RootConstrainSelectedInstOperands,
     /* 234930 */     // GIR_Coverage, 11441,
     /* 234930 */     GIR_EraseRootFromParent_Done,
     /* 234931 */   // Label 4687: @234931
     /* 234931 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(234973), // Rule ID 11442 //
     /* 234936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 234944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 234947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 234950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 234953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 234956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 234960 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1746:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 234960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
     /* 234963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 234965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 234967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 234969 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 234971 */     GIR_RootConstrainSelectedInstOperands,
     /* 234972 */     // GIR_Coverage, 11442,
     /* 234972 */     GIR_EraseRootFromParent_Done,
     /* 234973 */   // Label 4688: @234973
     /* 234973 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(235015), // Rule ID 11443 //
     /* 234978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 234981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 234986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 234989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 234992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 234995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 234998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235002 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1982:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
     /* 235005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235011 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235013 */     GIR_RootConstrainSelectedInstOperands,
     /* 235014 */     // GIR_Coverage, 11443,
     /* 235014 */     GIR_EraseRootFromParent_Done,
     /* 235015 */   // Label 4689: @235015
     /* 235015 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(235057), // Rule ID 11444 //
     /* 235020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 235028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235037 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235044 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1982:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
     /* 235047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235053 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235055 */     GIR_RootConstrainSelectedInstOperands,
     /* 235056 */     // GIR_Coverage, 11444,
     /* 235056 */     GIR_EraseRootFromParent_Done,
     /* 235057 */   // Label 4690: @235057
     /* 235057 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(235099), // Rule ID 11445 //
     /* 235062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 235070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235086 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1982:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
     /* 235089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235095 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235097 */     GIR_RootConstrainSelectedInstOperands,
     /* 235098 */     // GIR_Coverage, 11445,
     /* 235098 */     GIR_EraseRootFromParent_Done,
     /* 235099 */   // Label 4691: @235099
     /* 235099 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(235141), // Rule ID 11446 //
     /* 235104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 235112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235128 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1982:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
     /* 235131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235137 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235139 */     GIR_RootConstrainSelectedInstOperands,
     /* 235140 */     // GIR_Coverage, 11446,
     /* 235140 */     GIR_EraseRootFromParent_Done,
     /* 235141 */   // Label 4692: @235141
     /* 235141 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(235183), // Rule ID 11447 //
     /* 235146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 235154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235163 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235170 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1833:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
     /* 235173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235179 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235181 */     GIR_RootConstrainSelectedInstOperands,
     /* 235182 */     // GIR_Coverage, 11447,
     /* 235182 */     GIR_EraseRootFromParent_Done,
     /* 235183 */   // Label 4693: @235183
     /* 235183 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(235225), // Rule ID 11448 //
     /* 235188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 235196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235205 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235212 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1833:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
     /* 235215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235221 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235223 */     GIR_RootConstrainSelectedInstOperands,
     /* 235224 */     // GIR_Coverage, 11448,
     /* 235224 */     GIR_EraseRootFromParent_Done,
     /* 235225 */   // Label 4694: @235225
     /* 235225 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(235267), // Rule ID 11449 //
     /* 235230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 235238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235254 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1833:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
     /* 235257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235263 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235265 */     GIR_RootConstrainSelectedInstOperands,
     /* 235266 */     // GIR_Coverage, 11449,
     /* 235266 */     GIR_EraseRootFromParent_Done,
     /* 235267 */   // Label 4695: @235267
     /* 235267 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(235309), // Rule ID 11450 //
     /* 235272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235275 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 235280 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235283 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235286 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235289 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235296 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1833:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
     /* 235299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235305 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235307 */     GIR_RootConstrainSelectedInstOperands,
     /* 235308 */     // GIR_Coverage, 11450,
     /* 235308 */     GIR_EraseRootFromParent_Done,
     /* 235309 */   // Label 4696: @235309
     /* 235309 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(235351), // Rule ID 11451 //
     /* 235314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 235322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235338 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2026:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
     /* 235341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235347 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235349 */     GIR_RootConstrainSelectedInstOperands,
     /* 235350 */     // GIR_Coverage, 11451,
     /* 235350 */     GIR_EraseRootFromParent_Done,
     /* 235351 */   // Label 4697: @235351
     /* 235351 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(235393), // Rule ID 11452 //
     /* 235356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 235364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235380 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2026:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
     /* 235383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235387 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235389 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235391 */     GIR_RootConstrainSelectedInstOperands,
     /* 235392 */     // GIR_Coverage, 11452,
     /* 235392 */     GIR_EraseRootFromParent_Done,
     /* 235393 */   // Label 4698: @235393
     /* 235393 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(235435), // Rule ID 11453 //
     /* 235398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 235406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235422 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2026:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
     /* 235425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235431 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235433 */     GIR_RootConstrainSelectedInstOperands,
     /* 235434 */     // GIR_Coverage, 11453,
     /* 235434 */     GIR_EraseRootFromParent_Done,
     /* 235435 */   // Label 4699: @235435
     /* 235435 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(235477), // Rule ID 11454 //
     /* 235440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 235448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235464 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2026:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
     /* 235467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235473 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235475 */     GIR_RootConstrainSelectedInstOperands,
     /* 235476 */     // GIR_Coverage, 11454,
     /* 235476 */     GIR_EraseRootFromParent_Done,
     /* 235477 */   // Label 4700: @235477
     /* 235477 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(235519), // Rule ID 11455 //
     /* 235482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 235490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235499 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235506 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1897:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
     /* 235509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235515 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235517 */     GIR_RootConstrainSelectedInstOperands,
     /* 235518 */     // GIR_Coverage, 11455,
     /* 235518 */     GIR_EraseRootFromParent_Done,
     /* 235519 */   // Label 4701: @235519
     /* 235519 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(235561), // Rule ID 11456 //
     /* 235524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 235532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235548 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1897:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
     /* 235551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235557 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235559 */     GIR_RootConstrainSelectedInstOperands,
     /* 235560 */     // GIR_Coverage, 11456,
     /* 235560 */     GIR_EraseRootFromParent_Done,
     /* 235561 */   // Label 4702: @235561
     /* 235561 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(235603), // Rule ID 11457 //
     /* 235566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 235574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235580 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235583 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235590 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1897:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
     /* 235593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235597 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235599 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235601 */     GIR_RootConstrainSelectedInstOperands,
     /* 235602 */     // GIR_Coverage, 11457,
     /* 235602 */     GIR_EraseRootFromParent_Done,
     /* 235603 */   // Label 4703: @235603
     /* 235603 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(235645), // Rule ID 11458 //
     /* 235608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 235616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235632 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1897:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
     /* 235635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235641 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235643 */     GIR_RootConstrainSelectedInstOperands,
     /* 235644 */     // GIR_Coverage, 11458,
     /* 235644 */     GIR_EraseRootFromParent_Done,
     /* 235645 */   // Label 4704: @235645
     /* 235645 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(235687), // Rule ID 11459 //
     /* 235650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 235658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235674 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2047:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
     /* 235677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235683 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235685 */     GIR_RootConstrainSelectedInstOperands,
     /* 235686 */     // GIR_Coverage, 11459,
     /* 235686 */     GIR_EraseRootFromParent_Done,
     /* 235687 */   // Label 4705: @235687
     /* 235687 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(235729), // Rule ID 11460 //
     /* 235692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 235700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235716 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2047:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
     /* 235719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235725 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235727 */     GIR_RootConstrainSelectedInstOperands,
     /* 235728 */     // GIR_Coverage, 11460,
     /* 235728 */     GIR_EraseRootFromParent_Done,
     /* 235729 */   // Label 4706: @235729
     /* 235729 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(235771), // Rule ID 11461 //
     /* 235734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 235742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235751 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235758 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2047:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
     /* 235761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235767 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235769 */     GIR_RootConstrainSelectedInstOperands,
     /* 235770 */     // GIR_Coverage, 11461,
     /* 235770 */     GIR_EraseRootFromParent_Done,
     /* 235771 */   // Label 4707: @235771
     /* 235771 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(235813), // Rule ID 11462 //
     /* 235776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 235784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235800 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2047:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
     /* 235803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235809 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235811 */     GIR_RootConstrainSelectedInstOperands,
     /* 235812 */     // GIR_Coverage, 11462,
     /* 235812 */     GIR_EraseRootFromParent_Done,
     /* 235813 */   // Label 4708: @235813
     /* 235813 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(235855), // Rule ID 11463 //
     /* 235818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 235826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235835 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235842 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1836:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
     /* 235845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235851 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235853 */     GIR_RootConstrainSelectedInstOperands,
     /* 235854 */     // GIR_Coverage, 11463,
     /* 235854 */     GIR_EraseRootFromParent_Done,
     /* 235855 */   // Label 4709: @235855
     /* 235855 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(235897), // Rule ID 11464 //
     /* 235860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 235868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235884 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1836:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
     /* 235887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235893 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235895 */     GIR_RootConstrainSelectedInstOperands,
     /* 235896 */     // GIR_Coverage, 11464,
     /* 235896 */     GIR_EraseRootFromParent_Done,
     /* 235897 */   // Label 4710: @235897
     /* 235897 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(235939), // Rule ID 11465 //
     /* 235902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 235910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235919 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235926 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1836:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
     /* 235929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235935 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235937 */     GIR_RootConstrainSelectedInstOperands,
     /* 235938 */     // GIR_Coverage, 11465,
     /* 235938 */     GIR_EraseRootFromParent_Done,
     /* 235939 */   // Label 4711: @235939
     /* 235939 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(235981), // Rule ID 11466 //
     /* 235944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 235952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235968 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1836:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
     /* 235971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235979 */     GIR_RootConstrainSelectedInstOperands,
     /* 235980 */     // GIR_Coverage, 11466,
     /* 235980 */     GIR_EraseRootFromParent_Done,
     /* 235981 */   // Label 4712: @235981
     /* 235981 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(236023), // Rule ID 11467 //
     /* 235986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 235994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236003 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236010 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2029:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
     /* 236013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236019 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236021 */     GIR_RootConstrainSelectedInstOperands,
     /* 236022 */     // GIR_Coverage, 11467,
     /* 236022 */     GIR_EraseRootFromParent_Done,
     /* 236023 */   // Label 4713: @236023
     /* 236023 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(236065), // Rule ID 11468 //
     /* 236028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 236036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236045 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236052 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2029:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
     /* 236055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236061 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236063 */     GIR_RootConstrainSelectedInstOperands,
     /* 236064 */     // GIR_Coverage, 11468,
     /* 236064 */     GIR_EraseRootFromParent_Done,
     /* 236065 */   // Label 4714: @236065
     /* 236065 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(236107), // Rule ID 11469 //
     /* 236070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 236078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236087 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236094 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2029:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
     /* 236097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236103 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236105 */     GIR_RootConstrainSelectedInstOperands,
     /* 236106 */     // GIR_Coverage, 11469,
     /* 236106 */     GIR_EraseRootFromParent_Done,
     /* 236107 */   // Label 4715: @236107
     /* 236107 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(236149), // Rule ID 11470 //
     /* 236112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 236120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236136 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2029:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
     /* 236139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236145 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236147 */     GIR_RootConstrainSelectedInstOperands,
     /* 236148 */     // GIR_Coverage, 11470,
     /* 236148 */     GIR_EraseRootFromParent_Done,
     /* 236149 */   // Label 4716: @236149
     /* 236149 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(236191), // Rule ID 11471 //
     /* 236154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 236162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236178 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1843:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
     /* 236181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236187 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236189 */     GIR_RootConstrainSelectedInstOperands,
     /* 236190 */     // GIR_Coverage, 11471,
     /* 236190 */     GIR_EraseRootFromParent_Done,
     /* 236191 */   // Label 4717: @236191
     /* 236191 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(236233), // Rule ID 11472 //
     /* 236196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 236204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236220 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1843:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
     /* 236223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236229 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236231 */     GIR_RootConstrainSelectedInstOperands,
     /* 236232 */     // GIR_Coverage, 11472,
     /* 236232 */     GIR_EraseRootFromParent_Done,
     /* 236233 */   // Label 4718: @236233
     /* 236233 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(236275), // Rule ID 11473 //
     /* 236238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 236246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236255 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236262 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1843:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
     /* 236265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236271 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236273 */     GIR_RootConstrainSelectedInstOperands,
     /* 236274 */     // GIR_Coverage, 11473,
     /* 236274 */     GIR_EraseRootFromParent_Done,
     /* 236275 */   // Label 4719: @236275
     /* 236275 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(236317), // Rule ID 11474 //
     /* 236280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 236288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236304 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1843:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
     /* 236307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236313 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236315 */     GIR_RootConstrainSelectedInstOperands,
     /* 236316 */     // GIR_Coverage, 11474,
     /* 236316 */     GIR_EraseRootFromParent_Done,
     /* 236317 */   // Label 4720: @236317
     /* 236317 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(236359), // Rule ID 11475 //
     /* 236322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 236330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236339 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236346 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2034:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
     /* 236349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236355 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236357 */     GIR_RootConstrainSelectedInstOperands,
     /* 236358 */     // GIR_Coverage, 11475,
     /* 236358 */     GIR_EraseRootFromParent_Done,
     /* 236359 */   // Label 4721: @236359
     /* 236359 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(236401), // Rule ID 11476 //
     /* 236364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 236372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236388 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2034:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
     /* 236391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236397 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236399 */     GIR_RootConstrainSelectedInstOperands,
     /* 236400 */     // GIR_Coverage, 11476,
     /* 236400 */     GIR_EraseRootFromParent_Done,
     /* 236401 */   // Label 4722: @236401
     /* 236401 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(236443), // Rule ID 11477 //
     /* 236406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 236414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236430 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2034:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
     /* 236433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236439 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236441 */     GIR_RootConstrainSelectedInstOperands,
     /* 236442 */     // GIR_Coverage, 11477,
     /* 236442 */     GIR_EraseRootFromParent_Done,
     /* 236443 */   // Label 4723: @236443
     /* 236443 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(236485), // Rule ID 11478 //
     /* 236448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 236456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236465 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236472 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2034:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
     /* 236475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236481 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236483 */     GIR_RootConstrainSelectedInstOperands,
     /* 236484 */     // GIR_Coverage, 11478,
     /* 236484 */     GIR_EraseRootFromParent_Done,
     /* 236485 */   // Label 4724: @236485
     /* 236485 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(236527), // Rule ID 11479 //
     /* 236490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 236498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236507 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236514 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1827:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
     /* 236517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236523 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236525 */     GIR_RootConstrainSelectedInstOperands,
     /* 236526 */     // GIR_Coverage, 11479,
     /* 236526 */     GIR_EraseRootFromParent_Done,
     /* 236527 */   // Label 4725: @236527
     /* 236527 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(236569), // Rule ID 11480 //
     /* 236532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 236540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236556 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1827:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
     /* 236559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236565 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236567 */     GIR_RootConstrainSelectedInstOperands,
     /* 236568 */     // GIR_Coverage, 11480,
     /* 236568 */     GIR_EraseRootFromParent_Done,
     /* 236569 */   // Label 4726: @236569
     /* 236569 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(236611), // Rule ID 11481 //
     /* 236574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 236582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236591 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236598 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1827:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
     /* 236601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236603 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236607 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236609 */     GIR_RootConstrainSelectedInstOperands,
     /* 236610 */     // GIR_Coverage, 11481,
     /* 236610 */     GIR_EraseRootFromParent_Done,
     /* 236611 */   // Label 4727: @236611
     /* 236611 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(236653), // Rule ID 11482 //
     /* 236616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 236624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236640 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1827:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
     /* 236643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236649 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236651 */     GIR_RootConstrainSelectedInstOperands,
     /* 236652 */     // GIR_Coverage, 11482,
     /* 236652 */     GIR_EraseRootFromParent_Done,
     /* 236653 */   // Label 4728: @236653
     /* 236653 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(236695), // Rule ID 11483 //
     /* 236658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 236666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236675 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236682 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2023:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
     /* 236685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236691 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236693 */     GIR_RootConstrainSelectedInstOperands,
     /* 236694 */     // GIR_Coverage, 11483,
     /* 236694 */     GIR_EraseRootFromParent_Done,
     /* 236695 */   // Label 4729: @236695
     /* 236695 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(236737), // Rule ID 11484 //
     /* 236700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 236708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236717 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236724 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2023:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
     /* 236727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236735 */     GIR_RootConstrainSelectedInstOperands,
     /* 236736 */     // GIR_Coverage, 11484,
     /* 236736 */     GIR_EraseRootFromParent_Done,
     /* 236737 */   // Label 4730: @236737
     /* 236737 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(236779), // Rule ID 11485 //
     /* 236742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 236750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236766 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2023:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
     /* 236769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236775 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236777 */     GIR_RootConstrainSelectedInstOperands,
     /* 236778 */     // GIR_Coverage, 11485,
     /* 236778 */     GIR_EraseRootFromParent_Done,
     /* 236779 */   // Label 4731: @236779
     /* 236779 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(236821), // Rule ID 11486 //
     /* 236784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 236792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236808 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2023:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
     /* 236811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236817 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236819 */     GIR_RootConstrainSelectedInstOperands,
     /* 236820 */     // GIR_Coverage, 11486,
     /* 236820 */     GIR_EraseRootFromParent_Done,
     /* 236821 */   // Label 4732: @236821
     /* 236821 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(236863), // Rule ID 11487 //
     /* 236826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 236834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236850 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1814:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
     /* 236853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236859 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236861 */     GIR_RootConstrainSelectedInstOperands,
     /* 236862 */     // GIR_Coverage, 11487,
     /* 236862 */     GIR_EraseRootFromParent_Done,
     /* 236863 */   // Label 4733: @236863
     /* 236863 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(236905), // Rule ID 11488 //
     /* 236868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 236876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236885 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236892 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1814:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
     /* 236895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236901 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236903 */     GIR_RootConstrainSelectedInstOperands,
     /* 236904 */     // GIR_Coverage, 11488,
     /* 236904 */     GIR_EraseRootFromParent_Done,
     /* 236905 */   // Label 4734: @236905
     /* 236905 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(236947), // Rule ID 11489 //
     /* 236910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 236918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236934 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1814:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
     /* 236937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236943 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236945 */     GIR_RootConstrainSelectedInstOperands,
     /* 236946 */     // GIR_Coverage, 11489,
     /* 236946 */     GIR_EraseRootFromParent_Done,
     /* 236947 */   // Label 4735: @236947
     /* 236947 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(236989), // Rule ID 11490 //
     /* 236952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 236960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236976 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1814:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
     /* 236979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236987 */     GIR_RootConstrainSelectedInstOperands,
     /* 236988 */     // GIR_Coverage, 11490,
     /* 236988 */     GIR_EraseRootFromParent_Done,
     /* 236989 */   // Label 4736: @236989
     /* 236989 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(237031), // Rule ID 11491 //
     /* 236994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 237002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 237008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237018 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2016:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
     /* 237021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237027 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237029 */     GIR_RootConstrainSelectedInstOperands,
     /* 237030 */     // GIR_Coverage, 11491,
     /* 237030 */     GIR_EraseRootFromParent_Done,
     /* 237031 */   // Label 4737: @237031
     /* 237031 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(237073), // Rule ID 11492 //
     /* 237036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 237044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 237050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237053 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237060 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2016:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
     /* 237063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237069 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237071 */     GIR_RootConstrainSelectedInstOperands,
     /* 237072 */     // GIR_Coverage, 11492,
     /* 237072 */     GIR_EraseRootFromParent_Done,
     /* 237073 */   // Label 4738: @237073
     /* 237073 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(237115), // Rule ID 11493 //
     /* 237078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 237086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 237092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237102 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2016:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
     /* 237105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237111 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237113 */     GIR_RootConstrainSelectedInstOperands,
     /* 237114 */     // GIR_Coverage, 11493,
     /* 237114 */     GIR_EraseRootFromParent_Done,
     /* 237115 */   // Label 4739: @237115
     /* 237115 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(237157), // Rule ID 11494 //
     /* 237120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 237128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237144 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2016:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
     /* 237147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 237149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237153 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237155 */     GIR_RootConstrainSelectedInstOperands,
     /* 237156 */     // GIR_Coverage, 11494,
     /* 237156 */     GIR_EraseRootFromParent_Done,
     /* 237157 */   // Label 4740: @237157
     /* 237157 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(237199), // Rule ID 11657 //
     /* 237162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 237170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237176 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237179 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237186 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1916:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
     /* 237189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237195 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237197 */     GIR_RootConstrainSelectedInstOperands,
     /* 237198 */     // GIR_Coverage, 11657,
     /* 237198 */     GIR_EraseRootFromParent_Done,
     /* 237199 */   // Label 4741: @237199
     /* 237199 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(237241), // Rule ID 11659 //
     /* 237204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 237212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237228 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1916:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
     /* 237231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237237 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237239 */     GIR_RootConstrainSelectedInstOperands,
     /* 237240 */     // GIR_Coverage, 11659,
     /* 237240 */     GIR_EraseRootFromParent_Done,
     /* 237241 */   // Label 4742: @237241
     /* 237241 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(237283), // Rule ID 11661 //
     /* 237246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 237254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237270 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1916:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
     /* 237273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237279 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237281 */     GIR_RootConstrainSelectedInstOperands,
     /* 237282 */     // GIR_Coverage, 11661,
     /* 237282 */     GIR_EraseRootFromParent_Done,
     /* 237283 */   // Label 4743: @237283
     /* 237283 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(237325), // Rule ID 11663 //
     /* 237288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 237296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237312 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1916:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
     /* 237315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237321 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237323 */     GIR_RootConstrainSelectedInstOperands,
     /* 237324 */     // GIR_Coverage, 11663,
     /* 237324 */     GIR_EraseRootFromParent_Done,
     /* 237325 */   // Label 4744: @237325
     /* 237325 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(237367), // Rule ID 11665 //
     /* 237330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 237338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237354 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1668:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
     /* 237357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237363 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237365 */     GIR_RootConstrainSelectedInstOperands,
     /* 237366 */     // GIR_Coverage, 11665,
     /* 237366 */     GIR_EraseRootFromParent_Done,
     /* 237367 */   // Label 4745: @237367
     /* 237367 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(237409), // Rule ID 11666 //
     /* 237372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 237380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237396 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1668:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
     /* 237399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237401 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237405 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237407 */     GIR_RootConstrainSelectedInstOperands,
     /* 237408 */     // GIR_Coverage, 11666,
     /* 237408 */     GIR_EraseRootFromParent_Done,
     /* 237409 */   // Label 4746: @237409
     /* 237409 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(237451), // Rule ID 11667 //
     /* 237414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 237422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237438 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1668:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
     /* 237441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237449 */     GIR_RootConstrainSelectedInstOperands,
     /* 237450 */     // GIR_Coverage, 11667,
     /* 237450 */     GIR_EraseRootFromParent_Done,
     /* 237451 */   // Label 4747: @237451
     /* 237451 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(237493), // Rule ID 11668 //
     /* 237456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 237464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237480 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1917:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
     /* 237483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237489 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237491 */     GIR_RootConstrainSelectedInstOperands,
     /* 237492 */     // GIR_Coverage, 11668,
     /* 237492 */     GIR_EraseRootFromParent_Done,
     /* 237493 */   // Label 4748: @237493
     /* 237493 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(237535), // Rule ID 11669 //
     /* 237498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 237506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237522 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1917:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
     /* 237525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237531 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237533 */     GIR_RootConstrainSelectedInstOperands,
     /* 237534 */     // GIR_Coverage, 11669,
     /* 237534 */     GIR_EraseRootFromParent_Done,
     /* 237535 */   // Label 4749: @237535
     /* 237535 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(237577), // Rule ID 11670 //
     /* 237540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 237548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237564 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1917:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
     /* 237567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237573 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237575 */     GIR_RootConstrainSelectedInstOperands,
     /* 237576 */     // GIR_Coverage, 11670,
     /* 237576 */     GIR_EraseRootFromParent_Done,
     /* 237577 */   // Label 4750: @237577
     /* 237577 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(237619), // Rule ID 11671 //
     /* 237582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 237590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237599 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237606 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1918:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
     /* 237609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237615 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237617 */     GIR_RootConstrainSelectedInstOperands,
     /* 237618 */     // GIR_Coverage, 11671,
     /* 237618 */     GIR_EraseRootFromParent_Done,
     /* 237619 */   // Label 4751: @237619
     /* 237619 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(237661), // Rule ID 11672 //
     /* 237624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 237632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237648 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1918:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
     /* 237651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237657 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237659 */     GIR_RootConstrainSelectedInstOperands,
     /* 237660 */     // GIR_Coverage, 11672,
     /* 237660 */     GIR_EraseRootFromParent_Done,
     /* 237661 */   // Label 4752: @237661
     /* 237661 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(237703), // Rule ID 11673 //
     /* 237666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 237674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237683 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237690 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1918:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
     /* 237693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237701 */     GIR_RootConstrainSelectedInstOperands,
     /* 237702 */     // GIR_Coverage, 11673,
     /* 237702 */     GIR_EraseRootFromParent_Done,
     /* 237703 */   // Label 4753: @237703
     /* 237703 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(237745), // Rule ID 11674 //
     /* 237708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 237716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237732 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1231:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
     /* 237735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237741 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237743 */     GIR_RootConstrainSelectedInstOperands,
     /* 237744 */     // GIR_Coverage, 11674,
     /* 237744 */     GIR_EraseRootFromParent_Done,
     /* 237745 */   // Label 4754: @237745
     /* 237745 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(237787), // Rule ID 11675 //
     /* 237750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 237758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237774 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1231:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
     /* 237777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237783 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237785 */     GIR_RootConstrainSelectedInstOperands,
     /* 237786 */     // GIR_Coverage, 11675,
     /* 237786 */     GIR_EraseRootFromParent_Done,
     /* 237787 */   // Label 4755: @237787
     /* 237787 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(237829), // Rule ID 11676 //
     /* 237792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 237800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237816 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1680:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
     /* 237819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237825 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237827 */     GIR_RootConstrainSelectedInstOperands,
     /* 237828 */     // GIR_Coverage, 11676,
     /* 237828 */     GIR_EraseRootFromParent_Done,
     /* 237829 */   // Label 4756: @237829
     /* 237829 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(237871), // Rule ID 11677 //
     /* 237834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 237842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237858 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1680:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
     /* 237861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237865 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237867 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237869 */     GIR_RootConstrainSelectedInstOperands,
     /* 237870 */     // GIR_Coverage, 11677,
     /* 237870 */     GIR_EraseRootFromParent_Done,
     /* 237871 */   // Label 4757: @237871
     /* 237871 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(237913), // Rule ID 11678 //
     /* 237876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 237884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237900 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1681:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
     /* 237903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237911 */     GIR_RootConstrainSelectedInstOperands,
     /* 237912 */     // GIR_Coverage, 11678,
     /* 237912 */     GIR_EraseRootFromParent_Done,
     /* 237913 */   // Label 4758: @237913
     /* 237913 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(237955), // Rule ID 11679 //
     /* 237918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 237926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237935 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237942 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1681:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
     /* 237945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237951 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237953 */     GIR_RootConstrainSelectedInstOperands,
     /* 237954 */     // GIR_Coverage, 11679,
     /* 237954 */     GIR_EraseRootFromParent_Done,
     /* 237955 */   // Label 4759: @237955
     /* 237955 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(237997), // Rule ID 11734 //
     /* 237960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 237968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237977 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237984 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1649:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
     /* 237987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237993 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237995 */     GIR_RootConstrainSelectedInstOperands,
     /* 237996 */     // GIR_Coverage, 11734,
     /* 237996 */     GIR_EraseRootFromParent_Done,
     /* 237997 */   // Label 4760: @237997
     /* 237997 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(238039), // Rule ID 11735 //
     /* 238002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 238010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238026 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1649:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
     /* 238029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238033 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238035 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238037 */     GIR_RootConstrainSelectedInstOperands,
     /* 238038 */     // GIR_Coverage, 11735,
     /* 238038 */     GIR_EraseRootFromParent_Done,
     /* 238039 */   // Label 4761: @238039
     /* 238039 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(238081), // Rule ID 11736 //
     /* 238044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 238052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238068 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1649:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
     /* 238071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238077 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238079 */     GIR_RootConstrainSelectedInstOperands,
     /* 238080 */     // GIR_Coverage, 11736,
     /* 238080 */     GIR_EraseRootFromParent_Done,
     /* 238081 */   // Label 4762: @238081
     /* 238081 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(238123), // Rule ID 11737 //
     /* 238086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238089 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 238094 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238103 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238110 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1890:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
     /* 238113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238119 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238121 */     GIR_RootConstrainSelectedInstOperands,
     /* 238122 */     // GIR_Coverage, 11737,
     /* 238122 */     GIR_EraseRootFromParent_Done,
     /* 238123 */   // Label 4763: @238123
     /* 238123 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(238165), // Rule ID 11738 //
     /* 238128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 238136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238152 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1890:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
     /* 238155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238163 */     GIR_RootConstrainSelectedInstOperands,
     /* 238164 */     // GIR_Coverage, 11738,
     /* 238164 */     GIR_EraseRootFromParent_Done,
     /* 238165 */   // Label 4764: @238165
     /* 238165 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(238207), // Rule ID 11739 //
     /* 238170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 238178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238184 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238187 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238194 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1890:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
     /* 238197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238205 */     GIR_RootConstrainSelectedInstOperands,
     /* 238206 */     // GIR_Coverage, 11739,
     /* 238206 */     GIR_EraseRootFromParent_Done,
     /* 238207 */   // Label 4765: @238207
     /* 238207 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(238249), // Rule ID 11740 //
     /* 238212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 238220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238236 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1665:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
     /* 238239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238245 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238247 */     GIR_RootConstrainSelectedInstOperands,
     /* 238248 */     // GIR_Coverage, 11740,
     /* 238248 */     GIR_EraseRootFromParent_Done,
     /* 238249 */   // Label 4766: @238249
     /* 238249 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(238291), // Rule ID 11741 //
     /* 238254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 238262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238278 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1665:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
     /* 238281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238287 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238289 */     GIR_RootConstrainSelectedInstOperands,
     /* 238290 */     // GIR_Coverage, 11741,
     /* 238290 */     GIR_EraseRootFromParent_Done,
     /* 238291 */   // Label 4767: @238291
     /* 238291 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(238333), // Rule ID 11742 //
     /* 238296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 238304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238320 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1665:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
     /* 238323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238327 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238329 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238331 */     GIR_RootConstrainSelectedInstOperands,
     /* 238332 */     // GIR_Coverage, 11742,
     /* 238332 */     GIR_EraseRootFromParent_Done,
     /* 238333 */   // Label 4768: @238333
     /* 238333 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(238378), // Rule ID 11755 //
     /* 238338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 238341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 238346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 238349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238355 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238362 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1600:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
     /* 238365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238371 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238373 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238376 */     GIR_RootConstrainSelectedInstOperands,
     /* 238377 */     // GIR_Coverage, 11755,
     /* 238377 */     GIR_EraseRootFromParent_Done,
     /* 238378 */   // Label 4769: @238378
     /* 238378 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(238423), // Rule ID 11756 //
     /* 238383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 238386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 238391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 238394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238407 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1600:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
     /* 238410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238418 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238421 */     GIR_RootConstrainSelectedInstOperands,
     /* 238422 */     // GIR_Coverage, 11756,
     /* 238422 */     GIR_EraseRootFromParent_Done,
     /* 238423 */   // Label 4770: @238423
     /* 238423 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(238465), // Rule ID 11757 //
     /* 238428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 238436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238445 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238452 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1340:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
     /* 238455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238463 */     GIR_RootConstrainSelectedInstOperands,
     /* 238464 */     // GIR_Coverage, 11757,
     /* 238464 */     GIR_EraseRootFromParent_Done,
     /* 238465 */   // Label 4771: @238465
     /* 238465 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(238507), // Rule ID 11758 //
     /* 238470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 238478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238494 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1340:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
     /* 238497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238505 */     GIR_RootConstrainSelectedInstOperands,
     /* 238506 */     // GIR_Coverage, 11758,
     /* 238506 */     GIR_EraseRootFromParent_Done,
     /* 238507 */   // Label 4772: @238507
     /* 238507 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(238549), // Rule ID 11759 //
     /* 238512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 238520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238536 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1340:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
     /* 238539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238545 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238547 */     GIR_RootConstrainSelectedInstOperands,
     /* 238548 */     // GIR_Coverage, 11759,
     /* 238548 */     GIR_EraseRootFromParent_Done,
     /* 238549 */   // Label 4773: @238549
     /* 238549 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(238591), // Rule ID 11760 //
     /* 238554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 238562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238571 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238578 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1340:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
     /* 238581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238587 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238589 */     GIR_RootConstrainSelectedInstOperands,
     /* 238590 */     // GIR_Coverage, 11760,
     /* 238590 */     GIR_EraseRootFromParent_Done,
     /* 238591 */   // Label 4774: @238591
     /* 238591 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(238633), // Rule ID 11776 //
     /* 238596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 238604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238620 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1423:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
     /* 238623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238631 */     GIR_RootConstrainSelectedInstOperands,
     /* 238632 */     // GIR_Coverage, 11776,
     /* 238632 */     GIR_EraseRootFromParent_Done,
     /* 238633 */   // Label 4775: @238633
     /* 238633 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(238675), // Rule ID 11777 //
     /* 238638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 238646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238662 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1423:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
     /* 238665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238671 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238673 */     GIR_RootConstrainSelectedInstOperands,
     /* 238674 */     // GIR_Coverage, 11777,
     /* 238674 */     GIR_EraseRootFromParent_Done,
     /* 238675 */   // Label 4776: @238675
     /* 238675 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(238717), // Rule ID 11778 //
     /* 238680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 238688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238704 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1423:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
     /* 238707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238713 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238715 */     GIR_RootConstrainSelectedInstOperands,
     /* 238716 */     // GIR_Coverage, 11778,
     /* 238716 */     GIR_EraseRootFromParent_Done,
     /* 238717 */   // Label 4777: @238717
     /* 238717 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(238759), // Rule ID 11779 //
     /* 238722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 238730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238746 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1441:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
     /* 238749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238757 */     GIR_RootConstrainSelectedInstOperands,
     /* 238758 */     // GIR_Coverage, 11779,
     /* 238758 */     GIR_EraseRootFromParent_Done,
     /* 238759 */   // Label 4778: @238759
     /* 238759 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(238801), // Rule ID 11780 //
     /* 238764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238767 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 238772 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238781 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238788 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1441:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
     /* 238791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238799 */     GIR_RootConstrainSelectedInstOperands,
     /* 238800 */     // GIR_Coverage, 11780,
     /* 238800 */     GIR_EraseRootFromParent_Done,
     /* 238801 */   // Label 4779: @238801
     /* 238801 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(238843), // Rule ID 11781 //
     /* 238806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 238814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238823 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238830 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1441:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
     /* 238833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238841 */     GIR_RootConstrainSelectedInstOperands,
     /* 238842 */     // GIR_Coverage, 11781,
     /* 238842 */     GIR_EraseRootFromParent_Done,
     /* 238843 */   // Label 4780: @238843
     /* 238843 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(238885), // Rule ID 11782 //
     /* 238848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 238856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238872 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1426:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
     /* 238875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238881 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238883 */     GIR_RootConstrainSelectedInstOperands,
     /* 238884 */     // GIR_Coverage, 11782,
     /* 238884 */     GIR_EraseRootFromParent_Done,
     /* 238885 */   // Label 4781: @238885
     /* 238885 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(238927), // Rule ID 11783 //
     /* 238890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 238898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238907 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238914 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1426:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
     /* 238917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238925 */     GIR_RootConstrainSelectedInstOperands,
     /* 238926 */     // GIR_Coverage, 11783,
     /* 238926 */     GIR_EraseRootFromParent_Done,
     /* 238927 */   // Label 4782: @238927
     /* 238927 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(238969), // Rule ID 11784 //
     /* 238932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 238940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238956 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1426:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
     /* 238959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238967 */     GIR_RootConstrainSelectedInstOperands,
     /* 238968 */     // GIR_Coverage, 11784,
     /* 238968 */     GIR_EraseRootFromParent_Done,
     /* 238969 */   // Label 4783: @238969
     /* 238969 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(239011), // Rule ID 11785 //
     /* 238974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 238982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238991 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238998 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1444:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
     /* 239001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239007 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239009 */     GIR_RootConstrainSelectedInstOperands,
     /* 239010 */     // GIR_Coverage, 11785,
     /* 239010 */     GIR_EraseRootFromParent_Done,
     /* 239011 */   // Label 4784: @239011
     /* 239011 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(239053), // Rule ID 11786 //
     /* 239016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 239024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239040 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1444:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 239040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
     /* 239043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239049 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239051 */     GIR_RootConstrainSelectedInstOperands,
     /* 239052 */     // GIR_Coverage, 11786,
     /* 239052 */     GIR_EraseRootFromParent_Done,
     /* 239053 */   // Label 4785: @239053
     /* 239053 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(239095), // Rule ID 11787 //
     /* 239058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 239066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239082 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1444:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 239082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
     /* 239085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239091 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239093 */     GIR_RootConstrainSelectedInstOperands,
     /* 239094 */     // GIR_Coverage, 11787,
     /* 239094 */     GIR_EraseRootFromParent_Done,
     /* 239095 */   // Label 4786: @239095
     /* 239095 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(239137), // Rule ID 11792 //
     /* 239100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
     /* 239108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239124 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1450:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
     /* 239127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239135 */     GIR_RootConstrainSelectedInstOperands,
     /* 239136 */     // GIR_Coverage, 11792,
     /* 239136 */     GIR_EraseRootFromParent_Done,
     /* 239137 */   // Label 4787: @239137
     /* 239137 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(239179), // Rule ID 11793 //
     /* 239142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
     /* 239150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239166 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1452:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
     /* 239169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239175 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239177 */     GIR_RootConstrainSelectedInstOperands,
     /* 239178 */     // GIR_Coverage, 11793,
     /* 239178 */     GIR_EraseRootFromParent_Done,
     /* 239179 */   // Label 4788: @239179
     /* 239179 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(239221), // Rule ID 11794 //
     /* 239184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
     /* 239192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239208 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1457:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
     /* 239211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239217 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239219 */     GIR_RootConstrainSelectedInstOperands,
     /* 239220 */     // GIR_Coverage, 11794,
     /* 239220 */     GIR_EraseRootFromParent_Done,
     /* 239221 */   // Label 4789: @239221
     /* 239221 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(239263), // Rule ID 11795 //
     /* 239226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
     /* 239234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239250 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1459:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
     /* 239253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239261 */     GIR_RootConstrainSelectedInstOperands,
     /* 239262 */     // GIR_Coverage, 11795,
     /* 239262 */     GIR_EraseRootFromParent_Done,
     /* 239263 */   // Label 4790: @239263
     /* 239263 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(239305), // Rule ID 11796 //
     /* 239268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 239276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239285 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239292 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1257:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 239295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239303 */     GIR_RootConstrainSelectedInstOperands,
     /* 239304 */     // GIR_Coverage, 11796,
     /* 239304 */     GIR_EraseRootFromParent_Done,
     /* 239305 */   // Label 4791: @239305
     /* 239305 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(239347), // Rule ID 11798 //
     /* 239310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 239318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239327 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239334 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1257:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 239337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239345 */     GIR_RootConstrainSelectedInstOperands,
     /* 239346 */     // GIR_Coverage, 11798,
     /* 239346 */     GIR_EraseRootFromParent_Done,
     /* 239347 */   // Label 4792: @239347
     /* 239347 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(239389), // Rule ID 11800 //
     /* 239352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 239360 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239369 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239376 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1257:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 239379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239385 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239387 */     GIR_RootConstrainSelectedInstOperands,
     /* 239388 */     // GIR_Coverage, 11800,
     /* 239388 */     GIR_EraseRootFromParent_Done,
     /* 239389 */   // Label 4793: @239389
     /* 239389 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(239431), // Rule ID 11802 //
     /* 239394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 239402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239411 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239418 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1257:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 239421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239427 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239429 */     GIR_RootConstrainSelectedInstOperands,
     /* 239430 */     // GIR_Coverage, 11802,
     /* 239430 */     GIR_EraseRootFromParent_Done,
     /* 239431 */   // Label 4794: @239431
     /* 239431 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(239473), // Rule ID 11804 //
     /* 239436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 239444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239460 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1286:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 239463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239469 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239471 */     GIR_RootConstrainSelectedInstOperands,
     /* 239472 */     // GIR_Coverage, 11804,
     /* 239472 */     GIR_EraseRootFromParent_Done,
     /* 239473 */   // Label 4795: @239473
     /* 239473 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(239515), // Rule ID 11806 //
     /* 239478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 239486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239502 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1286:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 239505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239511 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239513 */     GIR_RootConstrainSelectedInstOperands,
     /* 239514 */     // GIR_Coverage, 11806,
     /* 239514 */     GIR_EraseRootFromParent_Done,
     /* 239515 */   // Label 4796: @239515
     /* 239515 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(239557), // Rule ID 11808 //
     /* 239520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 239528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239537 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239544 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1286:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 239547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239553 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239555 */     GIR_RootConstrainSelectedInstOperands,
     /* 239556 */     // GIR_Coverage, 11808,
     /* 239556 */     GIR_EraseRootFromParent_Done,
     /* 239557 */   // Label 4797: @239557
     /* 239557 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(239599), // Rule ID 11810 //
     /* 239562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl),
     /* 239570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239579 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239586 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1286:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 239589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239591 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239595 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239597 */     GIR_RootConstrainSelectedInstOperands,
     /* 239598 */     // GIR_Coverage, 11810,
     /* 239598 */     GIR_EraseRootFromParent_Done,
     /* 239599 */   // Label 4798: @239599
     /* 239599 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(239641), // Rule ID 11812 //
     /* 239604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 239612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239621 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239628 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1287:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 239631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239637 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239639 */     GIR_RootConstrainSelectedInstOperands,
     /* 239640 */     // GIR_Coverage, 11812,
     /* 239640 */     GIR_EraseRootFromParent_Done,
     /* 239641 */   // Label 4799: @239641
     /* 239641 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(239683), // Rule ID 11813 //
     /* 239646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 239654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239663 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239670 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1287:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 239673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239679 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239681 */     GIR_RootConstrainSelectedInstOperands,
     /* 239682 */     // GIR_Coverage, 11813,
     /* 239682 */     GIR_EraseRootFromParent_Done,
     /* 239683 */   // Label 4800: @239683
     /* 239683 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(239725), // Rule ID 11814 //
     /* 239688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 239696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239712 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1287:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 239715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239723 */     GIR_RootConstrainSelectedInstOperands,
     /* 239724 */     // GIR_Coverage, 11814,
     /* 239724 */     GIR_EraseRootFromParent_Done,
     /* 239725 */   // Label 4801: @239725
     /* 239725 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(239767), // Rule ID 11815 //
     /* 239730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl1n),
     /* 239738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239754 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1287:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 239757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239765 */     GIR_RootConstrainSelectedInstOperands,
     /* 239766 */     // GIR_Coverage, 11815,
     /* 239766 */     GIR_EraseRootFromParent_Done,
     /* 239767 */   // Label 4802: @239767
     /* 239767 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(239809), // Rule ID 11816 //
     /* 239772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 239780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239796 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1288:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 239799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239807 */     GIR_RootConstrainSelectedInstOperands,
     /* 239808 */     // GIR_Coverage, 11816,
     /* 239808 */     GIR_EraseRootFromParent_Done,
     /* 239809 */   // Label 4803: @239809
     /* 239809 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(239851), // Rule ID 11817 //
     /* 239814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 239822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239838 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1288:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 239841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239847 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239849 */     GIR_RootConstrainSelectedInstOperands,
     /* 239850 */     // GIR_Coverage, 11817,
     /* 239850 */     GIR_EraseRootFromParent_Done,
     /* 239851 */   // Label 4804: @239851
     /* 239851 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(239893), // Rule ID 11818 //
     /* 239856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 239864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239880 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1288:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 239883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239891 */     GIR_RootConstrainSelectedInstOperands,
     /* 239892 */     // GIR_Coverage, 11818,
     /* 239892 */     GIR_EraseRootFromParent_Done,
     /* 239893 */   // Label 4805: @239893
     /* 239893 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(239935), // Rule ID 11819 //
     /* 239898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bsl2n),
     /* 239906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239915 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239922 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1288:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 239925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239933 */     GIR_RootConstrainSelectedInstOperands,
     /* 239934 */     // GIR_Coverage, 11819,
     /* 239934 */     GIR_EraseRootFromParent_Done,
     /* 239935 */   // Label 4806: @239935
     /* 239935 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(239977), // Rule ID 11820 //
     /* 239940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 239948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239964 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1598:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 239967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239973 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239975 */     GIR_RootConstrainSelectedInstOperands,
     /* 239976 */     // GIR_Coverage, 11820,
     /* 239976 */     GIR_EraseRootFromParent_Done,
     /* 239977 */   // Label 4807: @239977
     /* 239977 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(240019), // Rule ID 11822 //
     /* 239982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 239985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 239990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239999 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240006 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1598:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 240009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240017 */     GIR_RootConstrainSelectedInstOperands,
     /* 240018 */     // GIR_Coverage, 11822,
     /* 240018 */     GIR_EraseRootFromParent_Done,
     /* 240019 */   // Label 4808: @240019
     /* 240019 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(240061), // Rule ID 11824 //
     /* 240024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 240032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240048 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1598:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 240051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240059 */     GIR_RootConstrainSelectedInstOperands,
     /* 240060 */     // GIR_Coverage, 11824,
     /* 240060 */     GIR_EraseRootFromParent_Done,
     /* 240061 */   // Label 4809: @240061
     /* 240061 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(240103), // Rule ID 11826 //
     /* 240066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 240069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nbsl),
     /* 240074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240090 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1598:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /* 240093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240099 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240101 */     GIR_RootConstrainSelectedInstOperands,
     /* 240102 */     // GIR_Coverage, 11826,
     /* 240102 */     GIR_EraseRootFromParent_Done,
     /* 240103 */   // Label 4810: @240103
     /* 240103 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(240145), // Rule ID 11915 //
     /* 240108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 240111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 240116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 240122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240132 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1929:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
     /* 240135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240141 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240143 */     GIR_RootConstrainSelectedInstOperands,
     /* 240144 */     // GIR_Coverage, 11915,
     /* 240144 */     GIR_EraseRootFromParent_Done,
     /* 240145 */   // Label 4811: @240145
     /* 240145 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(240187), // Rule ID 11917 //
     /* 240150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 240153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 240158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240174 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1929:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
     /* 240177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240183 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240185 */     GIR_RootConstrainSelectedInstOperands,
     /* 240186 */     // GIR_Coverage, 11917,
     /* 240186 */     GIR_EraseRootFromParent_Done,
     /* 240187 */   // Label 4812: @240187
     /* 240187 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(240229), // Rule ID 11919 //
     /* 240192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 240195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 240200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240216 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1929:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
     /* 240219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240227 */     GIR_RootConstrainSelectedInstOperands,
     /* 240228 */     // GIR_Coverage, 11919,
     /* 240228 */     GIR_EraseRootFromParent_Done,
     /* 240229 */   // Label 4813: @240229
     /* 240229 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(240271), // Rule ID 11921 //
     /* 240234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 240237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 240242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240258 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1929:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
     /* 240261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240269 */     GIR_RootConstrainSelectedInstOperands,
     /* 240270 */     // GIR_Coverage, 11921,
     /* 240270 */     GIR_EraseRootFromParent_Done,
     /* 240271 */   // Label 4814: @240271
     /* 240271 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(240313), // Rule ID 11923 //
     /* 240276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 240279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
     /* 240284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240300 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1407:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
     /* 240303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240309 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240311 */     GIR_RootConstrainSelectedInstOperands,
     /* 240312 */     // GIR_Coverage, 11923,
     /* 240312 */     GIR_EraseRootFromParent_Done,
     /* 240313 */   // Label 4815: @240313
     /* 240313 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(240355), // Rule ID 11925 //
     /* 240318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 240321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
     /* 240326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240335 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240342 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1945:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
     /* 240345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 240347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240351 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240353 */     GIR_RootConstrainSelectedInstOperands,
     /* 240354 */     // GIR_Coverage, 11925,
     /* 240354 */     GIR_EraseRootFromParent_Done,
     /* 240355 */   // Label 4816: @240355
     /* 240355 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(240397), // Rule ID 12088 //
     /* 240360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 240374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240384 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1905:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
     /* 240387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240393 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240395 */     GIR_RootConstrainSelectedInstOperands,
     /* 240396 */     // GIR_Coverage, 12088,
     /* 240396 */     GIR_EraseRootFromParent_Done,
     /* 240397 */   // Label 4817: @240397
     /* 240397 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(240439), // Rule ID 12089 //
     /* 240402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240419 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240426 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1905:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 240429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240435 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240437 */     GIR_RootConstrainSelectedInstOperands,
     /* 240438 */     // GIR_Coverage, 12089,
     /* 240438 */     GIR_EraseRootFromParent_Done,
     /* 240439 */   // Label 4818: @240439
     /* 240439 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(240481), // Rule ID 12090 //
     /* 240444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240461 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240468 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1905:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 240471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240477 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240479 */     GIR_RootConstrainSelectedInstOperands,
     /* 240480 */     // GIR_Coverage, 12090,
     /* 240480 */     GIR_EraseRootFromParent_Done,
     /* 240481 */   // Label 4819: @240481
     /* 240481 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(240523), // Rule ID 12091 //
     /* 240486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240500 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240503 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240510 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1905:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 240513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240521 */     GIR_RootConstrainSelectedInstOperands,
     /* 240522 */     // GIR_Coverage, 12091,
     /* 240522 */     GIR_EraseRootFromParent_Done,
     /* 240523 */   // Label 4820: @240523
     /* 240523 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(240565), // Rule ID 12092 //
     /* 240528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240545 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240552 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1905:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 240555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240561 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240563 */     GIR_RootConstrainSelectedInstOperands,
     /* 240564 */     // GIR_Coverage, 12092,
     /* 240564 */     GIR_EraseRootFromParent_Done,
     /* 240565 */   // Label 4821: @240565
     /* 240565 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(240607), // Rule ID 12093 //
     /* 240570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240587 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240594 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1905:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 240597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240603 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240605 */     GIR_RootConstrainSelectedInstOperands,
     /* 240606 */     // GIR_Coverage, 12093,
     /* 240606 */     GIR_EraseRootFromParent_Done,
     /* 240607 */   // Label 4822: @240607
     /* 240607 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(240649), // Rule ID 12094 //
     /* 240612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 240615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 240620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240636 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1905:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 240639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240645 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240647 */     GIR_RootConstrainSelectedInstOperands,
     /* 240648 */     // GIR_Coverage, 12094,
     /* 240648 */     GIR_EraseRootFromParent_Done,
     /* 240649 */   // Label 4823: @240649
     /* 240649 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(240691), // Rule ID 12439 //
     /* 240654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 240662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240678 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1357:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
     /* 240681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240685 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240687 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240689 */     GIR_RootConstrainSelectedInstOperands,
     /* 240690 */     // GIR_Coverage, 12439,
     /* 240690 */     GIR_EraseRootFromParent_Done,
     /* 240691 */   // Label 4824: @240691
     /* 240691 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(240733), // Rule ID 12440 //
     /* 240696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 240704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240720 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1357:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
     /* 240723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240727 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240729 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240731 */     GIR_RootConstrainSelectedInstOperands,
     /* 240732 */     // GIR_Coverage, 12440,
     /* 240732 */     GIR_EraseRootFromParent_Done,
     /* 240733 */   // Label 4825: @240733
     /* 240733 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(240775), // Rule ID 12441 //
     /* 240738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 240746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240755 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240762 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1357:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
     /* 240765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240773 */     GIR_RootConstrainSelectedInstOperands,
     /* 240774 */     // GIR_Coverage, 12441,
     /* 240774 */     GIR_EraseRootFromParent_Done,
     /* 240775 */   // Label 4826: @240775
     /* 240775 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(240817), // Rule ID 12442 //
     /* 240780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 240788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240797 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240804 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1355:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
     /* 240807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240813 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240815 */     GIR_RootConstrainSelectedInstOperands,
     /* 240816 */     // GIR_Coverage, 12442,
     /* 240816 */     GIR_EraseRootFromParent_Done,
     /* 240817 */   // Label 4827: @240817
     /* 240817 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(240859), // Rule ID 12443 //
     /* 240822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 240830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240836 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240839 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240846 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1355:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 240846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
     /* 240849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240855 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240857 */     GIR_RootConstrainSelectedInstOperands,
     /* 240858 */     // GIR_Coverage, 12443,
     /* 240858 */     GIR_EraseRootFromParent_Done,
     /* 240859 */   // Label 4828: @240859
     /* 240859 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(240901), // Rule ID 12444 //
     /* 240864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240867 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 240872 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240881 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240888 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1355:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 240888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
     /* 240891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240897 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240899 */     GIR_RootConstrainSelectedInstOperands,
     /* 240900 */     // GIR_Coverage, 12444,
     /* 240900 */     GIR_EraseRootFromParent_Done,
     /* 240901 */   // Label 4829: @240901
     /* 240901 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(240943), // Rule ID 12445 //
     /* 240906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240923 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240930 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1356:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 240930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 240933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240939 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240941 */     GIR_RootConstrainSelectedInstOperands,
     /* 240942 */     // GIR_Coverage, 12445,
     /* 240942 */     GIR_EraseRootFromParent_Done,
     /* 240943 */   // Label 4830: @240943
     /* 240943 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(240985), // Rule ID 12448 //
     /* 240948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 240959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 240965 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 240968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240972 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1356:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 240972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 240975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240983 */     GIR_RootConstrainSelectedInstOperands,
     /* 240984 */     // GIR_Coverage, 12448,
     /* 240984 */     GIR_EraseRootFromParent_Done,
     /* 240985 */   // Label 4831: @240985
     /* 240985 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(241027), // Rule ID 12451 //
     /* 240990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 240993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 240998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 241001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 241007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 241010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241014 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1356:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 241014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 241017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241025 */     GIR_RootConstrainSelectedInstOperands,
     /* 241026 */     // GIR_Coverage, 12451,
     /* 241026 */     GIR_EraseRootFromParent_Done,
     /* 241027 */   // Label 4832: @241027
     /* 241027 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(241069), // Rule ID 12454 //
     /* 241032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 241040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241046 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241049 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241056 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1356:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 241059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241065 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241067 */     GIR_RootConstrainSelectedInstOperands,
     /* 241068 */     // GIR_Coverage, 12454,
     /* 241068 */     GIR_EraseRootFromParent_Done,
     /* 241069 */   // Label 4833: @241069
     /* 241069 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(241111), // Rule ID 12457 //
     /* 241074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 241082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 241085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 241091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 241094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241098 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1356:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 241098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 241101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241107 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241109 */     GIR_RootConstrainSelectedInstOperands,
     /* 241110 */     // GIR_Coverage, 12457,
     /* 241110 */     GIR_EraseRootFromParent_Done,
     /* 241111 */   // Label 4834: @241111
     /* 241111 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(241153), // Rule ID 12460 //
     /* 241116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 241124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241140 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1356:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
     /* 241143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241151 */     GIR_RootConstrainSelectedInstOperands,
     /* 241152 */     // GIR_Coverage, 12460,
     /* 241152 */     GIR_EraseRootFromParent_Done,
     /* 241153 */   // Label 4835: @241153
     /* 241153 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(241195), // Rule ID 12463 //
     /* 241158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 241166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241182 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1358:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 241185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241193 */     GIR_RootConstrainSelectedInstOperands,
     /* 241194 */     // GIR_Coverage, 12463,
     /* 241194 */     GIR_EraseRootFromParent_Done,
     /* 241195 */   // Label 4836: @241195
     /* 241195 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(241237), // Rule ID 12466 //
     /* 241200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 241208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 241211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 241217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 241220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241224 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1358:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 241224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 241227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241235 */     GIR_RootConstrainSelectedInstOperands,
     /* 241236 */     // GIR_Coverage, 12466,
     /* 241236 */     GIR_EraseRootFromParent_Done,
     /* 241237 */   // Label 4837: @241237
     /* 241237 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(241279), // Rule ID 12469 //
     /* 241242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 241250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 241253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 241259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 241262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241266 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1358:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 241266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 241269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241275 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241277 */     GIR_RootConstrainSelectedInstOperands,
     /* 241278 */     // GIR_Coverage, 12469,
     /* 241278 */     GIR_EraseRootFromParent_Done,
     /* 241279 */   // Label 4838: @241279
     /* 241279 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(241321), // Rule ID 12472 //
     /* 241284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241287 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 241292 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241295 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241298 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241301 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241308 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1358:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 241311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241319 */     GIR_RootConstrainSelectedInstOperands,
     /* 241320 */     // GIR_Coverage, 12472,
     /* 241320 */     GIR_EraseRootFromParent_Done,
     /* 241321 */   // Label 4839: @241321
     /* 241321 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(241363), // Rule ID 12475 //
     /* 241326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 241334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 241337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 241343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 241346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241350 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1358:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 241350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 241353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241359 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241361 */     GIR_RootConstrainSelectedInstOperands,
     /* 241362 */     // GIR_Coverage, 12475,
     /* 241362 */     GIR_EraseRootFromParent_Done,
     /* 241363 */   // Label 4840: @241363
     /* 241363 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(241405), // Rule ID 12478 //
     /* 241368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 241371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 241376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241392 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1358:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
     /* 241395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241401 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241403 */     GIR_RootConstrainSelectedInstOperands,
     /* 241404 */     // GIR_Coverage, 12478,
     /* 241404 */     GIR_EraseRootFromParent_Done,
     /* 241405 */   // Label 4841: @241405
     /* 241405 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(241548), // Rule ID 5571 //
     /* 241410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 241421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 241424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241431 */     // MIs[0] idx
     /* 241431 */     // No operand predicates
     /* 241431 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241431 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 241434 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241438 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 241445 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 241448 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241452 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241457 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 241460 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241464 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 241467 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241472 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241477 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241482 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241485 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241489 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241494 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241508 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241511 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241515 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241528 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 241536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 241544 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241546 */     GIR_RootConstrainSelectedInstOperands,
     /* 241547 */     // GIR_Coverage, 5571,
     /* 241547 */     GIR_EraseRootFromParent_Done,
     /* 241548 */   // Label 4842: @241548
     /* 241548 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(241639), // Rule ID 5572 //
     /* 241553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 241564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 241567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241574 */     // MIs[0] idx
     /* 241574 */     // No operand predicates
     /* 241574 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241574 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241577 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241581 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241586 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241600 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241603 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241607 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241615 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241620 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 241628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241635 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241637 */     GIR_RootConstrainSelectedInstOperands,
     /* 241638 */     // GIR_Coverage, 5572,
     /* 241638 */     GIR_EraseRootFromParent_Done,
     /* 241639 */   // Label 4843: @241639
     /* 241639 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(241730), // Rule ID 5573 //
     /* 241644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 241655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 241658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241665 */     // MIs[0] idx
     /* 241665 */     // No operand predicates
     /* 241665 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241665 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241668 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241672 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241677 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241679 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241682 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241686 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241691 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241694 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241698 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241701 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241706 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241711 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 241719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241726 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241728 */     GIR_RootConstrainSelectedInstOperands,
     /* 241729 */     // GIR_Coverage, 5573,
     /* 241729 */     GIR_EraseRootFromParent_Done,
     /* 241730 */   // Label 4844: @241730
     /* 241730 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(241769), // Rule ID 5574 //
     /* 241735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 241746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 241749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241756 */     // MIs[0] idx
     /* 241756 */     // No operand predicates
     /* 241756 */     // (intrinsic_wo_chain:{ *:[v16i8] } 769:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 241759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 241763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241765 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241767 */     GIR_RootConstrainSelectedInstOperands,
     /* 241768 */     // GIR_Coverage, 5574,
     /* 241768 */     GIR_EraseRootFromParent_Done,
     /* 241769 */   // Label 4845: @241769
     /* 241769 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(241912), // Rule ID 5575 //
     /* 241774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 241782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 241788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 241791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241795 */     // MIs[0] idx
     /* 241795 */     // No operand predicates
     /* 241795 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241795 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 241798 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241802 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 241809 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 241812 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241816 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241821 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 241824 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 241828 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 241831 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241836 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241841 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241846 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241849 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241853 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241872 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241875 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241879 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241882 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241892 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 241908 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 241910 */     GIR_RootConstrainSelectedInstOperands,
     /* 241911 */     // GIR_Coverage, 5575,
     /* 241911 */     GIR_EraseRootFromParent_Done,
     /* 241912 */   // Label 4846: @241912
     /* 241912 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(242003), // Rule ID 5576 //
     /* 241917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 241920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 241925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 241928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 241931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 241934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241938 */     // MIs[0] idx
     /* 241938 */     // No operand predicates
     /* 241938 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 241938 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 241941 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 241945 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241950 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 241952 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 241955 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 241959 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 241964 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 241967 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 241971 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 241974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241979 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 241984 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 241989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 241992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 241994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 241997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 241999 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242001 */     GIR_RootConstrainSelectedInstOperands,
     /* 242002 */     // GIR_Coverage, 5576,
     /* 242002 */     GIR_EraseRootFromParent_Done,
     /* 242003 */   // Label 4847: @242003
     /* 242003 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(242094), // Rule ID 5577 //
     /* 242008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 242016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 242019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 242022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 242025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242029 */     // MIs[0] idx
     /* 242029 */     // No operand predicates
     /* 242029 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 242029 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 242032 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 242036 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242041 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 242043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 242046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 242050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242055 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 242058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 242062 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 242065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 242080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 242083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 242087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242090 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242092 */     GIR_RootConstrainSelectedInstOperands,
     /* 242093 */     // GIR_Coverage, 5577,
     /* 242093 */     GIR_EraseRootFromParent_Done,
     /* 242094 */   // Label 4848: @242094
     /* 242094 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(242133), // Rule ID 5578 //
     /* 242099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 242107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 242110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 242113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 242116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242120 */     // MIs[0] idx
     /* 242120 */     // No operand predicates
     /* 242120 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 242120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 242123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 242127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 242129 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242131 */     GIR_RootConstrainSelectedInstOperands,
     /* 242132 */     // GIR_Coverage, 5578,
     /* 242132 */     GIR_EraseRootFromParent_Done,
     /* 242133 */   // Label 4849: @242133
     /* 242133 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(242276), // Rule ID 5579 //
     /* 242138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 242146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 242149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 242152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 242155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242159 */     // MIs[0] idx
     /* 242159 */     // No operand predicates
     /* 242159 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 242159 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 242162 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 242166 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 242173 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 242176 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 242180 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242185 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 242188 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 242192 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 242195 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242200 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242205 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 242210 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 242213 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 242217 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 242224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 242227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 242231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242236 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 242239 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 242243 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 242246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 242261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 242264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 242272 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242274 */     GIR_RootConstrainSelectedInstOperands,
     /* 242275 */     // GIR_Coverage, 5579,
     /* 242275 */     GIR_EraseRootFromParent_Done,
     /* 242276 */   // Label 4850: @242276
     /* 242276 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(242367), // Rule ID 5580 //
     /* 242281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 242289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 242292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 242295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 242298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242302 */     // MIs[0] idx
     /* 242302 */     // No operand predicates
     /* 242302 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 242302 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 242305 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 242309 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242314 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 242316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 242319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 242323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242328 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 242331 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 242335 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 242338 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 242353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 242356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 242363 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242365 */     GIR_RootConstrainSelectedInstOperands,
     /* 242366 */     // GIR_Coverage, 5580,
     /* 242366 */     GIR_EraseRootFromParent_Done,
     /* 242367 */   // Label 4851: @242367
     /* 242367 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(242458), // Rule ID 5581 //
     /* 242372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 242380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 242383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 242386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 242389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242393 */     // MIs[0] idx
     /* 242393 */     // No operand predicates
     /* 242393 */     // (intrinsic_wo_chain:{ *:[v8f16] } 768:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 242393 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 242396 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 242400 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 242407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 242410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 242414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242419 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 242422 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 242426 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 242429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 242444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 242447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 242451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242454 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242456 */     GIR_RootConstrainSelectedInstOperands,
     /* 242457 */     // GIR_Coverage, 5581,
     /* 242457 */     GIR_EraseRootFromParent_Done,
     /* 242458 */   // Label 4852: @242458
     /* 242458 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(242497), // Rule ID 5582 //
     /* 242463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 242471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 242474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 242477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 242480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242484 */     // MIs[0] idx
     /* 242484 */     // No operand predicates
     /* 242484 */     // (intrinsic_wo_chain:{ *:[v8f16] } 769:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 242484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 242487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 242491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 242493 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242495 */     GIR_RootConstrainSelectedInstOperands,
     /* 242496 */     // GIR_Coverage, 5582,
     /* 242496 */     GIR_EraseRootFromParent_Done,
     /* 242497 */   // Label 4853: @242497
     /* 242497 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(242536), // Rule ID 5583 //
     /* 242502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
     /* 242510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 242513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 242516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 242519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242523 */     // MIs[0] idx
     /* 242523 */     // No operand predicates
     /* 242523 */     // (intrinsic_wo_chain:{ *:[v16i8] } 772:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 242523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 242526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 242530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 242532 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242534 */     GIR_RootConstrainSelectedInstOperands,
     /* 242535 */     // GIR_Coverage, 5583,
     /* 242535 */     GIR_EraseRootFromParent_Done,
     /* 242536 */   // Label 4854: @242536
     /* 242536 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(242627), // Rule ID 5584 //
     /* 242541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 242544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
     /* 242549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 242552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 242555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 242558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242562 */     // MIs[0] idx
     /* 242562 */     // No operand predicates
     /* 242562 */     // (intrinsic_wo_chain:{ *:[v16i8] } 770:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 242562 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 242565 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 242569 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 242576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 242579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 242583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 242588 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 242591 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 242595 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 242598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 242608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 242613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 242616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 242618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 242620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 242623 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 242625 */     GIR_RootConstrainSelectedInstOperands,
     /* 242626 */     // GIR_Coverage, 5584,
     /* 242626 */     GIR_EraseRootFromParent_Done,
     /* 242627 */   // Label 4855: @242627
     /* 242627 */   GIM_Reject,
     /* 242628 */ // Label 3979: @242628
     /* 242628 */ GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(249739),
     /* 242633 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 242636 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(242683), // Rule ID 2963 //
     /* 242641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 242649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 242664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242668 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1589:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 242668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
     /* 242671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242677 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242679 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242681 */     GIR_RootConstrainSelectedInstOperands,
     /* 242682 */     // GIR_Coverage, 2963,
     /* 242682 */     GIR_EraseRootFromParent_Done,
     /* 242683 */   // Label 4857: @242683
     /* 242683 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(242730), // Rule ID 2965 //
     /* 242688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 242696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242715 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1589:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 242715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
     /* 242718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242726 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242728 */     GIR_RootConstrainSelectedInstOperands,
     /* 242729 */     // GIR_Coverage, 2965,
     /* 242729 */     GIR_EraseRootFromParent_Done,
     /* 242730 */   // Label 4858: @242730
     /* 242730 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(242777), // Rule ID 2967 //
     /* 242735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 242743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242762 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1589:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 242762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
     /* 242765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242773 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242775 */     GIR_RootConstrainSelectedInstOperands,
     /* 242776 */     // GIR_Coverage, 2967,
     /* 242776 */     GIR_EraseRootFromParent_Done,
     /* 242777 */   // Label 4859: @242777
     /* 242777 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(242824), // Rule ID 2969 //
     /* 242782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 242790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242809 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1589:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 242809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
     /* 242812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242820 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242822 */     GIR_RootConstrainSelectedInstOperands,
     /* 242823 */     // GIR_Coverage, 2969,
     /* 242823 */     GIR_EraseRootFromParent_Done,
     /* 242824 */   // Label 4860: @242824
     /* 242824 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(242871), // Rule ID 7537 //
     /* 242829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 242837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 242840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 242846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 242849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 242852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242856 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1592:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 242856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
     /* 242859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242867 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242869 */     GIR_RootConstrainSelectedInstOperands,
     /* 242870 */     // GIR_Coverage, 7537,
     /* 242870 */     GIR_EraseRootFromParent_Done,
     /* 242871 */   // Label 4861: @242871
     /* 242871 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(242918), // Rule ID 7539 //
     /* 242876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 242884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 242899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242903 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1592:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 242903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
     /* 242906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242914 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242916 */     GIR_RootConstrainSelectedInstOperands,
     /* 242917 */     // GIR_Coverage, 7539,
     /* 242917 */     GIR_EraseRootFromParent_Done,
     /* 242918 */   // Label 4862: @242918
     /* 242918 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(242965), // Rule ID 7541 //
     /* 242923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 242931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 242946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242950 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1592:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 242950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
     /* 242953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242959 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242961 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 242963 */     GIR_RootConstrainSelectedInstOperands,
     /* 242964 */     // GIR_Coverage, 7541,
     /* 242964 */     GIR_EraseRootFromParent_Done,
     /* 242965 */   // Label 4863: @242965
     /* 242965 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(243012), // Rule ID 7543 //
     /* 242970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 242978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 242993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242997 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1592:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 242997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
     /* 243000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 243002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243008 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243010 */     GIR_RootConstrainSelectedInstOperands,
     /* 243011 */     // GIR_Coverage, 7543,
     /* 243011 */     GIR_EraseRootFromParent_Done,
     /* 243012 */   // Label 4864: @243012
     /* 243012 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(243092), // Rule ID 5691 //
     /* 243017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 243022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 243025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 243028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 243031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 243034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 243037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 243049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243053 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 243057 */     // MIs[1] Operand 1
     /* 243057 */     // No operand predicates
     /* 243057 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 243065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243069 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 243073 */     // MIs[2] Operand 1
     /* 243073 */     // No operand predicates
     /* 243073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 243075 */     // (intrinsic_wo_chain:{ *:[v16i8] } 761:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
     /* 243075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 243078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 243080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 243085 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 243087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 243090 */     GIR_RootConstrainSelectedInstOperands,
     /* 243091 */     // GIR_Coverage, 5691,
     /* 243091 */     GIR_EraseRootFromParent_Done,
     /* 243092 */   // Label 4865: @243092
     /* 243092 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(243172), // Rule ID 5692 //
     /* 243097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 243102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 243105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 243108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 243111 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 243114 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 243117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 243129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243133 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 243137 */     // MIs[1] Operand 1
     /* 243137 */     // No operand predicates
     /* 243137 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 243145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243149 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 243153 */     // MIs[2] Operand 1
     /* 243153 */     // No operand predicates
     /* 243153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 243155 */     // (intrinsic_wo_chain:{ *:[v8i16] } 761:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
     /* 243155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 243158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 243160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 243165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 243167 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 243170 */     GIR_RootConstrainSelectedInstOperands,
     /* 243171 */     // GIR_Coverage, 5692,
     /* 243171 */     GIR_EraseRootFromParent_Done,
     /* 243172 */   // Label 4866: @243172
     /* 243172 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(243252), // Rule ID 5693 //
     /* 243177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 243182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 243185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 243188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 243191 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 243194 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 243197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 243209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243213 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 243217 */     // MIs[1] Operand 1
     /* 243217 */     // No operand predicates
     /* 243217 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 243225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243229 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 243233 */     // MIs[2] Operand 1
     /* 243233 */     // No operand predicates
     /* 243233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 243235 */     // (intrinsic_wo_chain:{ *:[v4i32] } 761:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
     /* 243235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 243238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 243240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 243245 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 243247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 243250 */     GIR_RootConstrainSelectedInstOperands,
     /* 243251 */     // GIR_Coverage, 5693,
     /* 243251 */     GIR_EraseRootFromParent_Done,
     /* 243252 */   // Label 4867: @243252
     /* 243252 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(243332), // Rule ID 5694 //
     /* 243257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 243262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 243265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 243268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 243271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 243274 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 243277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 243289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243293 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 243297 */     // MIs[1] Operand 1
     /* 243297 */     // No operand predicates
     /* 243297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 243305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 243309 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 243313 */     // MIs[2] Operand 1
     /* 243313 */     // No operand predicates
     /* 243313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 243315 */     // (intrinsic_wo_chain:{ *:[v2i64] } 761:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
     /* 243315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 243318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 243320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 243325 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 243327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 243330 */     GIR_RootConstrainSelectedInstOperands,
     /* 243331 */     // GIR_Coverage, 5694,
     /* 243331 */     GIR_EraseRootFromParent_Done,
     /* 243332 */   // Label 4868: @243332
     /* 243332 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(243396), // Rule ID 3837 //
     /* 243337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 243340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
     /* 243345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 243348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 243351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 243354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 243357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243373 */     // MIs[0] imm
     /* 243373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243376 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 243381 */     // (intrinsic_wo_chain:{ *:[v4i32] } 537:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 243381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
     /* 243384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 243386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 243390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 243392 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 243394 */     GIR_RootConstrainSelectedInstOperands,
     /* 243395 */     // GIR_Coverage, 3837,
     /* 243395 */     GIR_EraseRootFromParent_Done,
     /* 243396 */   // Label 4869: @243396
     /* 243396 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(243460), // Rule ID 3838 //
     /* 243401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 243404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
     /* 243409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 243412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 243415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 243418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 243421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243433 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243437 */     // MIs[0] imm
     /* 243437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243440 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 243445 */     // (intrinsic_wo_chain:{ *:[v4i32] } 538:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 243445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
     /* 243448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 243450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 243454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 243456 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 243458 */     GIR_RootConstrainSelectedInstOperands,
     /* 243459 */     // GIR_Coverage, 3838,
     /* 243459 */     GIR_EraseRootFromParent_Done,
     /* 243460 */   // Label 4870: @243460
     /* 243460 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(243524), // Rule ID 3839 //
     /* 243465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 243468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
     /* 243473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 243476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 243479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 243482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 243485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243497 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243501 */     // MIs[0] imm
     /* 243501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243504 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 243509 */     // (intrinsic_wo_chain:{ *:[v4i32] } 539:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 243509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
     /* 243512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 243514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 243518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 243520 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 243522 */     GIR_RootConstrainSelectedInstOperands,
     /* 243523 */     // GIR_Coverage, 3839,
     /* 243523 */     GIR_EraseRootFromParent_Done,
     /* 243524 */   // Label 4871: @243524
     /* 243524 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(243588), // Rule ID 3840 //
     /* 243529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 243532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
     /* 243537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 243540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 243543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 243546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 243549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243561 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 243565 */     // MIs[0] imm
     /* 243565 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243568 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 243573 */     // (intrinsic_wo_chain:{ *:[v4i32] } 540:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 243573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
     /* 243576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 243578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 243580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 243582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 243584 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 243586 */     GIR_RootConstrainSelectedInstOperands,
     /* 243587 */     // GIR_Coverage, 3840,
     /* 243587 */     GIR_EraseRootFromParent_Done,
     /* 243588 */   // Label 4872: @243588
     /* 243588 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(243640), // Rule ID 2848 //
     /* 243593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 243601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 243607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243610 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243617 */     // MIs[0] idx
     /* 243617 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243620 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243625 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1448:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 243625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
     /* 243628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243634 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243636 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243638 */     GIR_RootConstrainSelectedInstOperands,
     /* 243639 */     // GIR_Coverage, 2848,
     /* 243639 */     GIR_EraseRootFromParent_Done,
     /* 243640 */   // Label 4873: @243640
     /* 243640 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(243692), // Rule ID 2849 //
     /* 243645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 243653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243669 */     // MIs[0] idx
     /* 243669 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243672 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243677 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1448:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 243677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
     /* 243680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243688 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243690 */     GIR_RootConstrainSelectedInstOperands,
     /* 243691 */     // GIR_Coverage, 2849,
     /* 243691 */     GIR_EraseRootFromParent_Done,
     /* 243692 */   // Label 4874: @243692
     /* 243692 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(243744), // Rule ID 2850 //
     /* 243697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 243705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243721 */     // MIs[0] idx
     /* 243721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243724 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243729 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1448:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 243729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
     /* 243732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243738 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243740 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 243742 */     GIR_RootConstrainSelectedInstOperands,
     /* 243743 */     // GIR_Coverage, 2850,
     /* 243743 */     GIR_EraseRootFromParent_Done,
     /* 243744 */   // Label 4875: @243744
     /* 243744 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(243796), // Rule ID 2978 //
     /* 243749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 243757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 243760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 243763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243773 */     // MIs[0] Op4
     /* 243773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243776 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243781 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1588:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 243781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
     /* 243784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243790 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243792 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243794 */     GIR_RootConstrainSelectedInstOperands,
     /* 243795 */     // GIR_Coverage, 2978,
     /* 243795 */     GIR_EraseRootFromParent_Done,
     /* 243796 */   // Label 4876: @243796
     /* 243796 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(243848), // Rule ID 2979 //
     /* 243801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 243809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243825 */     // MIs[0] Op4
     /* 243825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243828 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243833 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1588:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
     /* 243836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243844 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243846 */     GIR_RootConstrainSelectedInstOperands,
     /* 243847 */     // GIR_Coverage, 2979,
     /* 243847 */     GIR_EraseRootFromParent_Done,
     /* 243848 */   // Label 4877: @243848
     /* 243848 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(243900), // Rule ID 2980 //
     /* 243853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 243861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 243870 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 243873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243877 */     // MIs[0] Op4
     /* 243877 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243880 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 243885 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1588:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 243885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
     /* 243888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243894 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243896 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243898 */     GIR_RootConstrainSelectedInstOperands,
     /* 243899 */     // GIR_Coverage, 2980,
     /* 243899 */     GIR_EraseRootFromParent_Done,
     /* 243900 */   // Label 4878: @243900
     /* 243900 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(243952), // Rule ID 2981 //
     /* 243905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 243913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 243916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 243919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 243922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 243925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243929 */     // MIs[0] Op4
     /* 243929 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243932 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 243937 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1730:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 243937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
     /* 243940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243948 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 243950 */     GIR_RootConstrainSelectedInstOperands,
     /* 243951 */     // GIR_Coverage, 2981,
     /* 243951 */     GIR_EraseRootFromParent_Done,
     /* 243952 */   // Label 4879: @243952
     /* 243952 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(244004), // Rule ID 2982 //
     /* 243957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 243960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 243965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 243968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 243971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 243974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 243977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 243981 */     // MIs[0] Op4
     /* 243981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 243984 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 243989 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1730:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 243989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
     /* 243992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 243994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244000 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244002 */     GIR_RootConstrainSelectedInstOperands,
     /* 244003 */     // GIR_Coverage, 2982,
     /* 244003 */     GIR_EraseRootFromParent_Done,
     /* 244004 */   // Label 4880: @244004
     /* 244004 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(244056), // Rule ID 2985 //
     /* 244009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 244017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244033 */     // MIs[0] Op4
     /* 244033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244036 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244041 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1696:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
     /* 244044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244050 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244052 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244054 */     GIR_RootConstrainSelectedInstOperands,
     /* 244055 */     // GIR_Coverage, 2985,
     /* 244055 */     GIR_EraseRootFromParent_Done,
     /* 244056 */   // Label 4881: @244056
     /* 244056 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(244108), // Rule ID 2986 //
     /* 244061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 244069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244085 */     // MIs[0] Op4
     /* 244085 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244088 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 244093 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1696:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 244093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
     /* 244096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244104 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244106 */     GIR_RootConstrainSelectedInstOperands,
     /* 244107 */     // GIR_Coverage, 2986,
     /* 244107 */     GIR_EraseRootFromParent_Done,
     /* 244108 */   // Label 4882: @244108
     /* 244108 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(244160), // Rule ID 3460 //
     /* 244113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 244116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
     /* 244121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244130 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244137 */     // MIs[0] Op4
     /* 244137 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244140 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244145 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2043:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
     /* 244148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244154 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244156 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244158 */     GIR_RootConstrainSelectedInstOperands,
     /* 244159 */     // GIR_Coverage, 3460,
     /* 244159 */     GIR_EraseRootFromParent_Done,
     /* 244160 */   // Label 4883: @244160
     /* 244160 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(244212), // Rule ID 3504 //
     /* 244165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 244168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
     /* 244173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244189 */     // MIs[0] Op4
     /* 244189 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244192 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244197 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1697:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
     /* 244200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244208 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244210 */     GIR_RootConstrainSelectedInstOperands,
     /* 244211 */     // GIR_Coverage, 3504,
     /* 244211 */     GIR_EraseRootFromParent_Done,
     /* 244212 */   // Label 4884: @244212
     /* 244212 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(244264), // Rule ID 7607 //
     /* 244217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 244225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244241 */     // MIs[0] Op4
     /* 244241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244244 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244249 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1943:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
     /* 244252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244260 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244262 */     GIR_RootConstrainSelectedInstOperands,
     /* 244263 */     // GIR_Coverage, 7607,
     /* 244263 */     GIR_EraseRootFromParent_Done,
     /* 244264 */   // Label 4885: @244264
     /* 244264 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(244316), // Rule ID 7608 //
     /* 244269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 244277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244293 */     // MIs[0] Op4
     /* 244293 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244296 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 244301 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1943:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 244301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
     /* 244304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244310 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244312 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244314 */     GIR_RootConstrainSelectedInstOperands,
     /* 244315 */     // GIR_Coverage, 7608,
     /* 244315 */     GIR_EraseRootFromParent_Done,
     /* 244316 */   // Label 4886: @244316
     /* 244316 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(244368), // Rule ID 8248 //
     /* 244321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 244329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 244335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244345 */     // MIs[0] idx
     /* 244345 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244348 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244353 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1455:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 244353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
     /* 244356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244364 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 244366 */     GIR_RootConstrainSelectedInstOperands,
     /* 244367 */     // GIR_Coverage, 8248,
     /* 244367 */     GIR_EraseRootFromParent_Done,
     /* 244368 */   // Label 4887: @244368
     /* 244368 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(244420), // Rule ID 8249 //
     /* 244373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 244381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244397 */     // MIs[0] idx
     /* 244397 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244400 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244405 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1455:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 244405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
     /* 244408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244414 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244416 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 244418 */     GIR_RootConstrainSelectedInstOperands,
     /* 244419 */     // GIR_Coverage, 8249,
     /* 244419 */     GIR_EraseRootFromParent_Done,
     /* 244420 */   // Label 4888: @244420
     /* 244420 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(244472), // Rule ID 8250 //
     /* 244425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 244433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244449 */     // MIs[0] idx
     /* 244449 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244452 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 244457 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1455:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 244457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
     /* 244460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244466 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244468 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 244470 */     GIR_RootConstrainSelectedInstOperands,
     /* 244471 */     // GIR_Coverage, 8250,
     /* 244471 */     GIR_EraseRootFromParent_Done,
     /* 244472 */   // Label 4889: @244472
     /* 244472 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(244524), // Rule ID 11194 //
     /* 244477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 244480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
     /* 244485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244501 */     // MIs[0] Op4
     /* 244501 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244504 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244509 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1892:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
     /* 244512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244520 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244522 */     GIR_RootConstrainSelectedInstOperands,
     /* 244523 */     // GIR_Coverage, 11194,
     /* 244523 */     GIR_EraseRootFromParent_Done,
     /* 244524 */   // Label 4890: @244524
     /* 244524 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(244576), // Rule ID 11241 //
     /* 244529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 244537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 244543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244553 */     // MIs[0] Op4
     /* 244553 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244556 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244561 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1591:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
     /* 244564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244570 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244572 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244574 */     GIR_RootConstrainSelectedInstOperands,
     /* 244575 */     // GIR_Coverage, 11241,
     /* 244575 */     GIR_EraseRootFromParent_Done,
     /* 244576 */   // Label 4891: @244576
     /* 244576 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(244628), // Rule ID 11242 //
     /* 244581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 244589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244605 */     // MIs[0] Op4
     /* 244605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244608 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244613 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1591:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
     /* 244616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244624 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244626 */     GIR_RootConstrainSelectedInstOperands,
     /* 244627 */     // GIR_Coverage, 11242,
     /* 244627 */     GIR_EraseRootFromParent_Done,
     /* 244628 */   // Label 4892: @244628
     /* 244628 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(244680), // Rule ID 11243 //
     /* 244633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 244641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244657 */     // MIs[0] Op4
     /* 244657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244660 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 244665 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1591:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 244665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
     /* 244668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244676 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244678 */     GIR_RootConstrainSelectedInstOperands,
     /* 244679 */     // GIR_Coverage, 11243,
     /* 244679 */     GIR_EraseRootFromParent_Done,
     /* 244680 */   // Label 4893: @244680
     /* 244680 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(244732), // Rule ID 11244 //
     /* 244685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 244693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 244699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244709 */     // MIs[0] Op4
     /* 244709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244712 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244717 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1809:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
     /* 244720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244726 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244728 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244730 */     GIR_RootConstrainSelectedInstOperands,
     /* 244731 */     // GIR_Coverage, 11244,
     /* 244731 */     GIR_EraseRootFromParent_Done,
     /* 244732 */   // Label 4894: @244732
     /* 244732 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(244784), // Rule ID 11245 //
     /* 244737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 244745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244761 */     // MIs[0] Op4
     /* 244761 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244764 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244769 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1809:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
     /* 244772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244778 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244780 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244782 */     GIR_RootConstrainSelectedInstOperands,
     /* 244783 */     // GIR_Coverage, 11245,
     /* 244783 */     GIR_EraseRootFromParent_Done,
     /* 244784 */   // Label 4895: @244784
     /* 244784 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(244836), // Rule ID 11246 //
     /* 244789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 244797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244813 */     // MIs[0] Op4
     /* 244813 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244816 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 244821 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1809:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 244821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
     /* 244824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244830 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244832 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244834 */     GIR_RootConstrainSelectedInstOperands,
     /* 244835 */     // GIR_Coverage, 11246,
     /* 244835 */     GIR_EraseRootFromParent_Done,
     /* 244836 */   // Label 4896: @244836
     /* 244836 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(244888), // Rule ID 11247 //
     /* 244841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 244849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 244855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244865 */     // MIs[0] Op4
     /* 244865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 244873 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1811:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 244873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
     /* 244876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244882 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244884 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244886 */     GIR_RootConstrainSelectedInstOperands,
     /* 244887 */     // GIR_Coverage, 11247,
     /* 244887 */     GIR_EraseRootFromParent_Done,
     /* 244888 */   // Label 4897: @244888
     /* 244888 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(244940), // Rule ID 11248 //
     /* 244893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 244901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 244907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244917 */     // MIs[0] Op4
     /* 244917 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244920 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 244925 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1811:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 244925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
     /* 244928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244934 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244936 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244938 */     GIR_RootConstrainSelectedInstOperands,
     /* 244939 */     // GIR_Coverage, 11248,
     /* 244939 */     GIR_EraseRootFromParent_Done,
     /* 244940 */   // Label 4898: @244940
     /* 244940 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(244992), // Rule ID 11249 //
     /* 244945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 244948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 244953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 244959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244969 */     // MIs[0] Op4
     /* 244969 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 244972 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 244977 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1811:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 244977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
     /* 244980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 244982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244986 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244988 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 244990 */     GIR_RootConstrainSelectedInstOperands,
     /* 244991 */     // GIR_Coverage, 11249,
     /* 244991 */     GIR_EraseRootFromParent_Done,
     /* 244992 */   // Label 4899: @244992
     /* 244992 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(245044), // Rule ID 11292 //
     /* 244997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 245005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245021 */     // MIs[0] Op4
     /* 245021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245024 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245029 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1732:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
     /* 245032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245040 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245042 */     GIR_RootConstrainSelectedInstOperands,
     /* 245043 */     // GIR_Coverage, 11292,
     /* 245043 */     GIR_EraseRootFromParent_Done,
     /* 245044 */   // Label 4900: @245044
     /* 245044 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(245096), // Rule ID 11293 //
     /* 245049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 245057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245073 */     // MIs[0] Op4
     /* 245073 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245076 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245081 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1732:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
     /* 245084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245090 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245092 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245094 */     GIR_RootConstrainSelectedInstOperands,
     /* 245095 */     // GIR_Coverage, 11293,
     /* 245095 */     GIR_EraseRootFromParent_Done,
     /* 245096 */   // Label 4901: @245096
     /* 245096 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(245148), // Rule ID 11294 //
     /* 245101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 245109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245125 */     // MIs[0] Op4
     /* 245125 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245128 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245133 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1968:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
     /* 245136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245142 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245144 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245146 */     GIR_RootConstrainSelectedInstOperands,
     /* 245147 */     // GIR_Coverage, 11294,
     /* 245147 */     GIR_EraseRootFromParent_Done,
     /* 245148 */   // Label 4902: @245148
     /* 245148 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(245200), // Rule ID 11295 //
     /* 245153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 245161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245177 */     // MIs[0] Op4
     /* 245177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245185 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1968:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
     /* 245188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245196 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245198 */     GIR_RootConstrainSelectedInstOperands,
     /* 245199 */     // GIR_Coverage, 11295,
     /* 245199 */     GIR_EraseRootFromParent_Done,
     /* 245200 */   // Label 4903: @245200
     /* 245200 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(245252), // Rule ID 11296 //
     /* 245205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 245213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245229 */     // MIs[0] Op4
     /* 245229 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245232 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245237 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1970:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
     /* 245240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245246 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245248 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245250 */     GIR_RootConstrainSelectedInstOperands,
     /* 245251 */     // GIR_Coverage, 11296,
     /* 245251 */     GIR_EraseRootFromParent_Done,
     /* 245252 */   // Label 4904: @245252
     /* 245252 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(245304), // Rule ID 11297 //
     /* 245257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 245265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245281 */     // MIs[0] Op4
     /* 245281 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245284 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245289 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1970:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
     /* 245292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245300 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245302 */     GIR_RootConstrainSelectedInstOperands,
     /* 245303 */     // GIR_Coverage, 11297,
     /* 245303 */     GIR_EraseRootFromParent_Done,
     /* 245304 */   // Label 4905: @245304
     /* 245304 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(245356), // Rule ID 11298 //
     /* 245309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 245317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245333 */     // MIs[0] Op4
     /* 245333 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245336 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245341 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1734:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
     /* 245344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245350 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245352 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245354 */     GIR_RootConstrainSelectedInstOperands,
     /* 245355 */     // GIR_Coverage, 11298,
     /* 245355 */     GIR_EraseRootFromParent_Done,
     /* 245356 */   // Label 4906: @245356
     /* 245356 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(245408), // Rule ID 11299 //
     /* 245361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 245369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245385 */     // MIs[0] Op4
     /* 245385 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245388 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245393 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1734:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
     /* 245396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245402 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245404 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245406 */     GIR_RootConstrainSelectedInstOperands,
     /* 245407 */     // GIR_Coverage, 11299,
     /* 245407 */     GIR_EraseRootFromParent_Done,
     /* 245408 */   // Label 4907: @245408
     /* 245408 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(245460), // Rule ID 11300 //
     /* 245413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 245421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245437 */     // MIs[0] Op4
     /* 245437 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245440 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245445 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1736:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
     /* 245448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245456 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245458 */     GIR_RootConstrainSelectedInstOperands,
     /* 245459 */     // GIR_Coverage, 11300,
     /* 245459 */     GIR_EraseRootFromParent_Done,
     /* 245460 */   // Label 4908: @245460
     /* 245460 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(245512), // Rule ID 11301 //
     /* 245465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 245473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245489 */     // MIs[0] Op4
     /* 245489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245492 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245497 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1736:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
     /* 245500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245506 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245508 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245510 */     GIR_RootConstrainSelectedInstOperands,
     /* 245511 */     // GIR_Coverage, 11301,
     /* 245511 */     GIR_EraseRootFromParent_Done,
     /* 245512 */   // Label 4909: @245512
     /* 245512 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(245564), // Rule ID 11302 //
     /* 245517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 245525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245534 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245541 */     // MIs[0] Op4
     /* 245541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245544 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245549 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1972:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
     /* 245552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245560 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245562 */     GIR_RootConstrainSelectedInstOperands,
     /* 245563 */     // GIR_Coverage, 11302,
     /* 245563 */     GIR_EraseRootFromParent_Done,
     /* 245564 */   // Label 4910: @245564
     /* 245564 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(245616), // Rule ID 11303 //
     /* 245569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 245577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245593 */     // MIs[0] Op4
     /* 245593 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245596 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245601 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1972:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
     /* 245604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245610 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245612 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245614 */     GIR_RootConstrainSelectedInstOperands,
     /* 245615 */     // GIR_Coverage, 11303,
     /* 245615 */     GIR_EraseRootFromParent_Done,
     /* 245616 */   // Label 4911: @245616
     /* 245616 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(245668), // Rule ID 11304 //
     /* 245621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 245629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245645 */     // MIs[0] Op4
     /* 245645 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245648 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245653 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1974:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
     /* 245656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245662 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245664 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245666 */     GIR_RootConstrainSelectedInstOperands,
     /* 245667 */     // GIR_Coverage, 11304,
     /* 245667 */     GIR_EraseRootFromParent_Done,
     /* 245668 */   // Label 4912: @245668
     /* 245668 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(245720), // Rule ID 11305 //
     /* 245673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 245681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245697 */     // MIs[0] Op4
     /* 245697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245700 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245705 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1974:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
     /* 245708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245714 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245716 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245718 */     GIR_RootConstrainSelectedInstOperands,
     /* 245719 */     // GIR_Coverage, 11305,
     /* 245719 */     GIR_EraseRootFromParent_Done,
     /* 245720 */   // Label 4913: @245720
     /* 245720 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(245772), // Rule ID 11327 //
     /* 245725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 245733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245749 */     // MIs[0] Op4
     /* 245749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245752 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245757 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1772:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
     /* 245760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245766 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245768 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245770 */     GIR_RootConstrainSelectedInstOperands,
     /* 245771 */     // GIR_Coverage, 11327,
     /* 245771 */     GIR_EraseRootFromParent_Done,
     /* 245772 */   // Label 4914: @245772
     /* 245772 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(245824), // Rule ID 11328 //
     /* 245777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 245785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245801 */     // MIs[0] Op4
     /* 245801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245804 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245809 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1772:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
     /* 245812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245820 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245822 */     GIR_RootConstrainSelectedInstOperands,
     /* 245823 */     // GIR_Coverage, 11328,
     /* 245823 */     GIR_EraseRootFromParent_Done,
     /* 245824 */   // Label 4915: @245824
     /* 245824 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(245876), // Rule ID 11329 //
     /* 245829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 245837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245853 */     // MIs[0] Op4
     /* 245853 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245856 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245861 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1775:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
     /* 245864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245872 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245874 */     GIR_RootConstrainSelectedInstOperands,
     /* 245875 */     // GIR_Coverage, 11329,
     /* 245875 */     GIR_EraseRootFromParent_Done,
     /* 245876 */   // Label 4916: @245876
     /* 245876 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(245928), // Rule ID 11330 //
     /* 245881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 245889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245905 */     // MIs[0] Op4
     /* 245905 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245908 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 245913 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1775:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 245913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
     /* 245916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245922 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245924 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245926 */     GIR_RootConstrainSelectedInstOperands,
     /* 245927 */     // GIR_Coverage, 11330,
     /* 245927 */     GIR_EraseRootFromParent_Done,
     /* 245928 */   // Label 4917: @245928
     /* 245928 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(245980), // Rule ID 11331 //
     /* 245933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 245941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 245947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245957 */     // MIs[0] Op4
     /* 245957 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 245960 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 245965 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1777:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 245965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
     /* 245968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 245970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245974 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245976 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 245978 */     GIR_RootConstrainSelectedInstOperands,
     /* 245979 */     // GIR_Coverage, 11331,
     /* 245979 */     GIR_EraseRootFromParent_Done,
     /* 245980 */   // Label 4918: @245980
     /* 245980 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(246032), // Rule ID 11332 //
     /* 245985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 245988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 245993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 245999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246009 */     // MIs[0] Op4
     /* 246009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246012 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246017 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1777:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
     /* 246020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246028 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246030 */     GIR_RootConstrainSelectedInstOperands,
     /* 246031 */     // GIR_Coverage, 11332,
     /* 246031 */     GIR_EraseRootFromParent_Done,
     /* 246032 */   // Label 4919: @246032
     /* 246032 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(246084), // Rule ID 11333 //
     /* 246037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 246045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246061 */     // MIs[0] Op4
     /* 246061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246064 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246069 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1780:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
     /* 246072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246078 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246080 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246082 */     GIR_RootConstrainSelectedInstOperands,
     /* 246083 */     // GIR_Coverage, 11333,
     /* 246083 */     GIR_EraseRootFromParent_Done,
     /* 246084 */   // Label 4920: @246084
     /* 246084 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(246136), // Rule ID 11334 //
     /* 246089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 246097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246113 */     // MIs[0] Op4
     /* 246113 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246116 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246121 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1780:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
     /* 246124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246130 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246132 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246134 */     GIR_RootConstrainSelectedInstOperands,
     /* 246135 */     // GIR_Coverage, 11334,
     /* 246135 */     GIR_EraseRootFromParent_Done,
     /* 246136 */   // Label 4921: @246136
     /* 246136 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(246188), // Rule ID 11788 //
     /* 246141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
     /* 246149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246165 */     // MIs[0] Op4
     /* 246165 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246168 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246173 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1451:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
     /* 246176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246182 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246184 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246186 */     GIR_RootConstrainSelectedInstOperands,
     /* 246187 */     // GIR_Coverage, 11788,
     /* 246187 */     GIR_EraseRootFromParent_Done,
     /* 246188 */   // Label 4922: @246188
     /* 246188 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(246240), // Rule ID 11789 //
     /* 246193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
     /* 246201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246217 */     // MIs[0] Op4
     /* 246217 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246220 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246225 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1453:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
     /* 246228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246234 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246236 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246238 */     GIR_RootConstrainSelectedInstOperands,
     /* 246239 */     // GIR_Coverage, 11789,
     /* 246239 */     GIR_EraseRootFromParent_Done,
     /* 246240 */   // Label 4923: @246240
     /* 246240 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(246292), // Rule ID 11790 //
     /* 246245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
     /* 246253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246269 */     // MIs[0] Op4
     /* 246269 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246272 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246277 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1458:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
     /* 246280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246288 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246290 */     GIR_RootConstrainSelectedInstOperands,
     /* 246291 */     // GIR_Coverage, 11790,
     /* 246291 */     GIR_EraseRootFromParent_Done,
     /* 246292 */   // Label 4924: @246292
     /* 246292 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(246344), // Rule ID 11791 //
     /* 246297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 246300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
     /* 246305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246321 */     // MIs[0] Op4
     /* 246321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246324 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 246329 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1460:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 246329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
     /* 246332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246340 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246342 */     GIR_RootConstrainSelectedInstOperands,
     /* 246343 */     // GIR_Coverage, 11791,
     /* 246343 */     GIR_EraseRootFromParent_Done,
     /* 246344 */   // Label 4925: @246344
     /* 246344 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(246396), // Rule ID 11924 //
     /* 246349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 246352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
     /* 246357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246373 */     // MIs[0] Op4
     /* 246373 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246376 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246381 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1406:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
     /* 246384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246390 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246392 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246394 */     GIR_RootConstrainSelectedInstOperands,
     /* 246395 */     // GIR_Coverage, 11924,
     /* 246395 */     GIR_EraseRootFromParent_Done,
     /* 246396 */   // Label 4926: @246396
     /* 246396 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(246448), // Rule ID 11926 //
     /* 246401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 246404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
     /* 246409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246425 */     // MIs[0] Op4
     /* 246425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 246428 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 246433 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1944:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 246433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
     /* 246436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246442 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246444 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246446 */     GIR_RootConstrainSelectedInstOperands,
     /* 246447 */     // GIR_Coverage, 11926,
     /* 246447 */     GIR_EraseRootFromParent_Done,
     /* 246448 */   // Label 4927: @246448
     /* 246448 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(246495), // Rule ID 2827 //
     /* 246453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246473 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246480 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 246480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 246483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246489 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246491 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246493 */     GIR_RootConstrainSelectedInstOperands,
     /* 246494 */     // GIR_Coverage, 2827,
     /* 246494 */     GIR_EraseRootFromParent_Done,
     /* 246495 */   // Label 4928: @246495
     /* 246495 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(246542), // Rule ID 2830 //
     /* 246500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246503 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246508 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 246511 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246514 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 246517 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 246520 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 246523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246527 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1447:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 246527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 246530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246536 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246538 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246540 */     GIR_RootConstrainSelectedInstOperands,
     /* 246541 */     // GIR_Coverage, 2830,
     /* 246541 */     GIR_EraseRootFromParent_Done,
     /* 246542 */   // Label 4929: @246542
     /* 246542 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(246589), // Rule ID 2833 //
     /* 246547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 246558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 246564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 246567 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 246570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246574 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1447:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 246574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 246577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246583 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246585 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246587 */     GIR_RootConstrainSelectedInstOperands,
     /* 246588 */     // GIR_Coverage, 2833,
     /* 246588 */     GIR_EraseRootFromParent_Done,
     /* 246589 */   // Label 4930: @246589
     /* 246589 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(246636), // Rule ID 2836 //
     /* 246594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246611 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246614 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246621 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 246621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 246624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246632 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246634 */     GIR_RootConstrainSelectedInstOperands,
     /* 246635 */     // GIR_Coverage, 2836,
     /* 246635 */     GIR_EraseRootFromParent_Done,
     /* 246636 */   // Label 4931: @246636
     /* 246636 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(246683), // Rule ID 2839 //
     /* 246641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 246652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 246658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 246661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 246664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246668 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1447:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 246668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 246671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246677 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246679 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246681 */     GIR_RootConstrainSelectedInstOperands,
     /* 246682 */     // GIR_Coverage, 2839,
     /* 246682 */     GIR_EraseRootFromParent_Done,
     /* 246683 */   // Label 4932: @246683
     /* 246683 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(246730), // Rule ID 2842 //
     /* 246688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 246696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246705 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246708 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246715 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 246715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
     /* 246718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 246720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246726 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246728 */     GIR_RootConstrainSelectedInstOperands,
     /* 246729 */     // GIR_Coverage, 2842,
     /* 246729 */     GIR_EraseRootFromParent_Done,
     /* 246730 */   // Label 4933: @246730
     /* 246730 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(246777), // Rule ID 2845 //
     /* 246735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 246743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246752 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246755 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246762 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1410:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 246762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
     /* 246765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246773 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246775 */     GIR_RootConstrainSelectedInstOperands,
     /* 246776 */     // GIR_Coverage, 2845,
     /* 246776 */     GIR_EraseRootFromParent_Done,
     /* 246777 */   // Label 4934: @246777
     /* 246777 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(246824), // Rule ID 2846 //
     /* 246782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 246790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246802 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246809 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1410:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 246809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
     /* 246812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246820 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246822 */     GIR_RootConstrainSelectedInstOperands,
     /* 246823 */     // GIR_Coverage, 2846,
     /* 246823 */     GIR_EraseRootFromParent_Done,
     /* 246824 */   // Label 4935: @246824
     /* 246824 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(246871), // Rule ID 2847 //
     /* 246829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 246837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 246843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 246846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246849 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 246852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246856 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1410:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 246856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
     /* 246859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246867 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246869 */     GIR_RootConstrainSelectedInstOperands,
     /* 246870 */     // GIR_Coverage, 2847,
     /* 246870 */     GIR_EraseRootFromParent_Done,
     /* 246871 */   // Label 4936: @246871
     /* 246871 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(246918), // Rule ID 2943 //
     /* 246876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 246884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 246896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 246899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246903 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1585:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 246903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
     /* 246906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246914 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246916 */     GIR_RootConstrainSelectedInstOperands,
     /* 246917 */     // GIR_Coverage, 2943,
     /* 246917 */     GIR_EraseRootFromParent_Done,
     /* 246918 */   // Label 4937: @246918
     /* 246918 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(246965), // Rule ID 2946 //
     /* 246923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 246931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 246946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246950 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1585:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 246950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
     /* 246953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246959 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246961 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 246963 */     GIR_RootConstrainSelectedInstOperands,
     /* 246964 */     // GIR_Coverage, 2946,
     /* 246964 */     GIR_EraseRootFromParent_Done,
     /* 246965 */   // Label 4938: @246965
     /* 246965 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(247012), // Rule ID 2949 //
     /* 246970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 246978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246990 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 246993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246997 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1585:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 246997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
     /* 247000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247008 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247010 */     GIR_RootConstrainSelectedInstOperands,
     /* 247011 */     // GIR_Coverage, 2949,
     /* 247011 */     GIR_EraseRootFromParent_Done,
     /* 247012 */   // Label 4939: @247012
     /* 247012 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(247059), // Rule ID 2952 //
     /* 247017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 247025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247037 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247044 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1585:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 247044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
     /* 247047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247053 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247055 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247057 */     GIR_RootConstrainSelectedInstOperands,
     /* 247058 */     // GIR_Coverage, 2952,
     /* 247058 */     GIR_EraseRootFromParent_Done,
     /* 247059 */   // Label 4940: @247059
     /* 247059 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(247106), // Rule ID 2955 //
     /* 247064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 247072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 247075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247081 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247084 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 247087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247091 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1587:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 247091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
     /* 247094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247100 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247102 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247104 */     GIR_RootConstrainSelectedInstOperands,
     /* 247105 */     // GIR_Coverage, 2955,
     /* 247105 */     GIR_EraseRootFromParent_Done,
     /* 247106 */   // Label 4941: @247106
     /* 247106 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(247153), // Rule ID 2957 //
     /* 247111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 247119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247128 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247131 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247138 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1587:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 247138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
     /* 247141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247149 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247151 */     GIR_RootConstrainSelectedInstOperands,
     /* 247152 */     // GIR_Coverage, 2957,
     /* 247152 */     GIR_EraseRootFromParent_Done,
     /* 247153 */   // Label 4942: @247153
     /* 247153 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(247200), // Rule ID 2959 //
     /* 247158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 247166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247175 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247178 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247185 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1587:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 247185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
     /* 247188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247196 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247198 */     GIR_RootConstrainSelectedInstOperands,
     /* 247199 */     // GIR_Coverage, 2959,
     /* 247199 */     GIR_EraseRootFromParent_Done,
     /* 247200 */   // Label 4943: @247200
     /* 247200 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(247247), // Rule ID 2961 //
     /* 247205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 247213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247232 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1587:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 247232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
     /* 247235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247241 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247243 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247245 */     GIR_RootConstrainSelectedInstOperands,
     /* 247246 */     // GIR_Coverage, 2961,
     /* 247246 */     GIR_EraseRootFromParent_Done,
     /* 247247 */   // Label 4944: @247247
     /* 247247 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(247294), // Rule ID 7517 //
     /* 247252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 247260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 247263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247272 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 247275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247279 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1593:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 247279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
     /* 247282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247290 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247292 */     GIR_RootConstrainSelectedInstOperands,
     /* 247293 */     // GIR_Coverage, 7517,
     /* 247293 */     GIR_EraseRootFromParent_Done,
     /* 247294 */   // Label 4945: @247294
     /* 247294 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(247341), // Rule ID 7520 //
     /* 247299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 247307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247319 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247326 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1593:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 247326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
     /* 247329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247335 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247337 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247339 */     GIR_RootConstrainSelectedInstOperands,
     /* 247340 */     // GIR_Coverage, 7520,
     /* 247340 */     GIR_EraseRootFromParent_Done,
     /* 247341 */   // Label 4946: @247341
     /* 247341 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(247388), // Rule ID 7523 //
     /* 247346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 247354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247363 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247366 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247373 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1593:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 247373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
     /* 247376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247384 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247386 */     GIR_RootConstrainSelectedInstOperands,
     /* 247387 */     // GIR_Coverage, 7523,
     /* 247387 */     GIR_EraseRootFromParent_Done,
     /* 247388 */   // Label 4947: @247388
     /* 247388 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(247435), // Rule ID 7526 //
     /* 247393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 247401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247413 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247420 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1593:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 247420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
     /* 247423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 247425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247429 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247431 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247433 */     GIR_RootConstrainSelectedInstOperands,
     /* 247434 */     // GIR_Coverage, 7526,
     /* 247434 */     GIR_EraseRootFromParent_Done,
     /* 247435 */   // Label 4948: @247435
     /* 247435 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(247482), // Rule ID 7529 //
     /* 247440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 247448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 247451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 247454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247460 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 247463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247467 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1590:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 247467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
     /* 247470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247478 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247480 */     GIR_RootConstrainSelectedInstOperands,
     /* 247481 */     // GIR_Coverage, 7529,
     /* 247481 */     GIR_EraseRootFromParent_Done,
     /* 247482 */   // Label 4949: @247482
     /* 247482 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(247529), // Rule ID 7531 //
     /* 247487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 247495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247507 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247514 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1590:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 247514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
     /* 247517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247523 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247525 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247527 */     GIR_RootConstrainSelectedInstOperands,
     /* 247528 */     // GIR_Coverage, 7531,
     /* 247528 */     GIR_EraseRootFromParent_Done,
     /* 247529 */   // Label 4950: @247529
     /* 247529 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(247576), // Rule ID 7533 //
     /* 247534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 247542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247551 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247554 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247561 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1590:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 247561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
     /* 247564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247570 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247572 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247574 */     GIR_RootConstrainSelectedInstOperands,
     /* 247575 */     // GIR_Coverage, 7533,
     /* 247575 */     GIR_EraseRootFromParent_Done,
     /* 247576 */   // Label 4951: @247576
     /* 247576 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(247623), // Rule ID 7535 //
     /* 247581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 247589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247601 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247608 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1590:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 247608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
     /* 247611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247619 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247621 */     GIR_RootConstrainSelectedInstOperands,
     /* 247622 */     // GIR_Coverage, 7535,
     /* 247622 */     GIR_EraseRootFromParent_Done,
     /* 247623 */   // Label 4952: @247623
     /* 247623 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(247670), // Rule ID 8161 //
     /* 247628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247648 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247655 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1454:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 247655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 247658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247666 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247668 */     GIR_RootConstrainSelectedInstOperands,
     /* 247669 */     // GIR_Coverage, 8161,
     /* 247669 */     GIR_EraseRootFromParent_Done,
     /* 247670 */   // Label 4953: @247670
     /* 247670 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(247717), // Rule ID 8164 //
     /* 247675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 247686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 247692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 247695 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 247698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247702 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1454:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 247702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 247705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247711 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247713 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247715 */     GIR_RootConstrainSelectedInstOperands,
     /* 247716 */     // GIR_Coverage, 8164,
     /* 247716 */     GIR_EraseRootFromParent_Done,
     /* 247717 */   // Label 4954: @247717
     /* 247717 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(247764), // Rule ID 8167 //
     /* 247722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 247733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 247739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 247742 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 247745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247749 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1454:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 247749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 247752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247760 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247762 */     GIR_RootConstrainSelectedInstOperands,
     /* 247763 */     // GIR_Coverage, 8167,
     /* 247763 */     GIR_EraseRootFromParent_Done,
     /* 247764 */   // Label 4955: @247764
     /* 247764 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(247811), // Rule ID 8170 //
     /* 247769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247789 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 247792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247796 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1454:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 247796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 247799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247805 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247807 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247809 */     GIR_RootConstrainSelectedInstOperands,
     /* 247810 */     // GIR_Coverage, 8170,
     /* 247810 */     GIR_EraseRootFromParent_Done,
     /* 247811 */   // Label 4956: @247811
     /* 247811 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(247858), // Rule ID 8173 //
     /* 247816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247824 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 247827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 247833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 247836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 247839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247843 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1454:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 247843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 247846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247854 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247856 */     GIR_RootConstrainSelectedInstOperands,
     /* 247857 */     // GIR_Coverage, 8173,
     /* 247857 */     GIR_EraseRootFromParent_Done,
     /* 247858 */   // Label 4957: @247858
     /* 247858 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(247905), // Rule ID 8176 //
     /* 247863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 247871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 247877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 247886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247890 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1454:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 247890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
     /* 247893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247899 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247901 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247903 */     GIR_RootConstrainSelectedInstOperands,
     /* 247904 */     // GIR_Coverage, 8176,
     /* 247904 */     GIR_EraseRootFromParent_Done,
     /* 247905 */   // Label 4958: @247905
     /* 247905 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(247952), // Rule ID 8179 //
     /* 247910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 247918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 247924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 247933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247937 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1470:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 247937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 247940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247948 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247950 */     GIR_RootConstrainSelectedInstOperands,
     /* 247951 */     // GIR_Coverage, 8179,
     /* 247951 */     GIR_EraseRootFromParent_Done,
     /* 247952 */   // Label 4959: @247952
     /* 247952 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(247999), // Rule ID 8180 //
     /* 247957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 247965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 247968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 247971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 247974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 247977 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 247980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247984 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1470:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 247984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 247987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247993 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247995 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 247997 */     GIR_RootConstrainSelectedInstOperands,
     /* 247998 */     // GIR_Coverage, 8180,
     /* 247998 */     GIR_EraseRootFromParent_Done,
     /* 247999 */   // Label 4960: @247999
     /* 247999 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(248046), // Rule ID 8181 //
     /* 248004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 248012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 248015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 248021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 248024 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 248027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248031 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 248031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 248034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248040 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248042 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248044 */     GIR_RootConstrainSelectedInstOperands,
     /* 248045 */     // GIR_Coverage, 8181,
     /* 248045 */     GIR_EraseRootFromParent_Done,
     /* 248046 */   // Label 4961: @248046
     /* 248046 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(248093), // Rule ID 8182 //
     /* 248051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 248059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248071 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248074 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248078 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1470:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 248081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248087 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248089 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248091 */     GIR_RootConstrainSelectedInstOperands,
     /* 248092 */     // GIR_Coverage, 8182,
     /* 248092 */     GIR_EraseRootFromParent_Done,
     /* 248093 */   // Label 4962: @248093
     /* 248093 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(248140), // Rule ID 8183 //
     /* 248098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 248106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 248109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 248115 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 248118 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 248121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248125 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 248125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 248128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248134 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248136 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248138 */     GIR_RootConstrainSelectedInstOperands,
     /* 248139 */     // GIR_Coverage, 8183,
     /* 248139 */     GIR_EraseRootFromParent_Done,
     /* 248140 */   // Label 4963: @248140
     /* 248140 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(248187), // Rule ID 8184 //
     /* 248145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 248153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248165 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248172 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1470:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
     /* 248175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248181 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248183 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248185 */     GIR_RootConstrainSelectedInstOperands,
     /* 248186 */     // GIR_Coverage, 8184,
     /* 248186 */     GIR_EraseRootFromParent_Done,
     /* 248187 */   // Label 4964: @248187
     /* 248187 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(248234), // Rule ID 8185 //
     /* 248192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 248200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248209 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248212 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248219 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1472:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 248222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248230 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248232 */     GIR_RootConstrainSelectedInstOperands,
     /* 248233 */     // GIR_Coverage, 8185,
     /* 248233 */     GIR_EraseRootFromParent_Done,
     /* 248234 */   // Label 4965: @248234
     /* 248234 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(248281), // Rule ID 8186 //
     /* 248239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 248247 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 248250 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248253 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 248256 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 248259 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 248262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248266 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1472:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 248266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 248269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248273 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248275 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248277 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248279 */     GIR_RootConstrainSelectedInstOperands,
     /* 248280 */     // GIR_Coverage, 8186,
     /* 248280 */     GIR_EraseRootFromParent_Done,
     /* 248281 */   // Label 4966: @248281
     /* 248281 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(248328), // Rule ID 8187 //
     /* 248286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 248294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 248297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248300 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 248303 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 248306 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 248309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248313 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1472:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 248313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 248316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248322 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248324 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248326 */     GIR_RootConstrainSelectedInstOperands,
     /* 248327 */     // GIR_Coverage, 8187,
     /* 248327 */     GIR_EraseRootFromParent_Done,
     /* 248328 */   // Label 4967: @248328
     /* 248328 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(248375), // Rule ID 8188 //
     /* 248333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 248341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248353 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248360 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1472:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 248363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248371 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248373 */     GIR_RootConstrainSelectedInstOperands,
     /* 248374 */     // GIR_Coverage, 8188,
     /* 248374 */     GIR_EraseRootFromParent_Done,
     /* 248375 */   // Label 4968: @248375
     /* 248375 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(248422), // Rule ID 8189 //
     /* 248380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 248388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 248391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 248397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 248400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 248403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248407 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1472:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 248407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 248410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248418 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248420 */     GIR_RootConstrainSelectedInstOperands,
     /* 248421 */     // GIR_Coverage, 8189,
     /* 248421 */     GIR_EraseRootFromParent_Done,
     /* 248422 */   // Label 4969: @248422
     /* 248422 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(248469), // Rule ID 8190 //
     /* 248427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 248435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248454 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1472:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
     /* 248457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248463 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248465 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248467 */     GIR_RootConstrainSelectedInstOperands,
     /* 248468 */     // GIR_Coverage, 8190,
     /* 248468 */     GIR_EraseRootFromParent_Done,
     /* 248469 */   // Label 4970: @248469
     /* 248469 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(248516), // Rule ID 8191 //
     /* 248474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 248482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248494 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248501 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1462:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
     /* 248504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248510 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248512 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248514 */     GIR_RootConstrainSelectedInstOperands,
     /* 248515 */     // GIR_Coverage, 8191,
     /* 248515 */     GIR_EraseRootFromParent_Done,
     /* 248516 */   // Label 4971: @248516
     /* 248516 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(248563), // Rule ID 8192 //
     /* 248521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 248529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248541 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248548 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1462:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
     /* 248551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248557 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248559 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248561 */     GIR_RootConstrainSelectedInstOperands,
     /* 248562 */     // GIR_Coverage, 8192,
     /* 248562 */     GIR_EraseRootFromParent_Done,
     /* 248563 */   // Label 4972: @248563
     /* 248563 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(248610), // Rule ID 8193 //
     /* 248568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 248576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248585 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248588 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248595 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1462:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
     /* 248598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248604 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248606 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248608 */     GIR_RootConstrainSelectedInstOperands,
     /* 248609 */     // GIR_Coverage, 8193,
     /* 248609 */     GIR_EraseRootFromParent_Done,
     /* 248610 */   // Label 4973: @248610
     /* 248610 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(248657), // Rule ID 8194 //
     /* 248615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 248623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248635 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248642 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1469:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
     /* 248645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248651 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248653 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248655 */     GIR_RootConstrainSelectedInstOperands,
     /* 248656 */     // GIR_Coverage, 8194,
     /* 248656 */     GIR_EraseRootFromParent_Done,
     /* 248657 */   // Label 4974: @248657
     /* 248657 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(248704), // Rule ID 8195 //
     /* 248662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 248670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248689 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1469:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
     /* 248692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248700 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248702 */     GIR_RootConstrainSelectedInstOperands,
     /* 248703 */     // GIR_Coverage, 8195,
     /* 248703 */     GIR_EraseRootFromParent_Done,
     /* 248704 */   // Label 4975: @248704
     /* 248704 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(248751), // Rule ID 8196 //
     /* 248709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 248717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248736 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1469:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
     /* 248739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248745 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248747 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248749 */     GIR_RootConstrainSelectedInstOperands,
     /* 248750 */     // GIR_Coverage, 8196,
     /* 248750 */     GIR_EraseRootFromParent_Done,
     /* 248751 */   // Label 4976: @248751
     /* 248751 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(248798), // Rule ID 8197 //
     /* 248756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 248764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248783 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1474:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
     /* 248786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248792 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248794 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248796 */     GIR_RootConstrainSelectedInstOperands,
     /* 248797 */     // GIR_Coverage, 8197,
     /* 248797 */     GIR_EraseRootFromParent_Done,
     /* 248798 */   // Label 4977: @248798
     /* 248798 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(248845), // Rule ID 8198 //
     /* 248803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 248811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 248826 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248830 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1474:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 248830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
     /* 248833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248839 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248841 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248843 */     GIR_RootConstrainSelectedInstOperands,
     /* 248844 */     // GIR_Coverage, 8198,
     /* 248844 */     GIR_EraseRootFromParent_Done,
     /* 248845 */   // Label 4978: @248845
     /* 248845 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(248892), // Rule ID 8199 //
     /* 248850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 248858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 248864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 248867 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 248870 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 248873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248877 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1474:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 248877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
     /* 248880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 248882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248886 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248888 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248890 */     GIR_RootConstrainSelectedInstOperands,
     /* 248891 */     // GIR_Coverage, 8199,
     /* 248891 */     GIR_EraseRootFromParent_Done,
     /* 248892 */   // Label 4979: @248892
     /* 248892 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(248939), // Rule ID 8200 //
     /* 248897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 248911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248917 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 248920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248924 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1456:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 248924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 248927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248933 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248935 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248937 */     GIR_RootConstrainSelectedInstOperands,
     /* 248938 */     // GIR_Coverage, 8200,
     /* 248938 */     GIR_EraseRootFromParent_Done,
     /* 248939 */   // Label 4980: @248939
     /* 248939 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(248986), // Rule ID 8203 //
     /* 248944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 248955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 248958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 248961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 248964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 248967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248971 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1456:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 248971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 248974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 248976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248980 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248982 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 248984 */     GIR_RootConstrainSelectedInstOperands,
     /* 248985 */     // GIR_Coverage, 8203,
     /* 248985 */     GIR_EraseRootFromParent_Done,
     /* 248986 */   // Label 4981: @248986
     /* 248986 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(249033), // Rule ID 8206 //
     /* 248991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 248994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 248999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 249002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 249008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 249011 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 249014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249018 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1456:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 249018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 249021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249027 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249029 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249031 */     GIR_RootConstrainSelectedInstOperands,
     /* 249032 */     // GIR_Coverage, 8206,
     /* 249032 */     GIR_EraseRootFromParent_Done,
     /* 249033 */   // Label 4982: @249033
     /* 249033 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(249080), // Rule ID 8209 //
     /* 249038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 249046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249055 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249058 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249065 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1456:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 249065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 249068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249074 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249076 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249078 */     GIR_RootConstrainSelectedInstOperands,
     /* 249079 */     // GIR_Coverage, 8209,
     /* 249079 */     GIR_EraseRootFromParent_Done,
     /* 249080 */   // Label 4983: @249080
     /* 249080 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(249127), // Rule ID 8212 //
     /* 249085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 249093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 249096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 249102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 249105 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 249108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249112 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1456:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 249112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 249115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249121 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249123 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249125 */     GIR_RootConstrainSelectedInstOperands,
     /* 249126 */     // GIR_Coverage, 8212,
     /* 249126 */     GIR_EraseRootFromParent_Done,
     /* 249127 */   // Label 4984: @249127
     /* 249127 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(249174), // Rule ID 8215 //
     /* 249132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 249140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249149 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249152 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 249155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249159 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1456:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 249159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
     /* 249162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249170 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249172 */     GIR_RootConstrainSelectedInstOperands,
     /* 249173 */     // GIR_Coverage, 8215,
     /* 249173 */     GIR_EraseRootFromParent_Done,
     /* 249174 */   // Label 4985: @249174
     /* 249174 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(249221), // Rule ID 8218 //
     /* 249179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 249187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 249202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249206 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1471:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 249206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 249209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249215 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249217 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249219 */     GIR_RootConstrainSelectedInstOperands,
     /* 249220 */     // GIR_Coverage, 8218,
     /* 249220 */     GIR_EraseRootFromParent_Done,
     /* 249221 */   // Label 4986: @249221
     /* 249221 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(249268), // Rule ID 8221 //
     /* 249226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 249234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 249237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 249243 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 249246 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 249249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249253 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1471:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 249253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 249256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249264 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249266 */     GIR_RootConstrainSelectedInstOperands,
     /* 249267 */     // GIR_Coverage, 8221,
     /* 249267 */     GIR_EraseRootFromParent_Done,
     /* 249268 */   // Label 4987: @249268
     /* 249268 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(249315), // Rule ID 8224 //
     /* 249273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 249281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 249284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 249290 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 249293 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 249296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249300 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 249300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 249303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249307 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249309 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249311 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249313 */     GIR_RootConstrainSelectedInstOperands,
     /* 249314 */     // GIR_Coverage, 8224,
     /* 249314 */     GIR_EraseRootFromParent_Done,
     /* 249315 */   // Label 4988: @249315
     /* 249315 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(249362), // Rule ID 8227 //
     /* 249320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 249328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249347 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1471:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 249347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 249350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249356 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249358 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249360 */     GIR_RootConstrainSelectedInstOperands,
     /* 249361 */     // GIR_Coverage, 8227,
     /* 249361 */     GIR_EraseRootFromParent_Done,
     /* 249362 */   // Label 4989: @249362
     /* 249362 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(249409), // Rule ID 8230 //
     /* 249367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 249375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 249378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 249384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 249387 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 249390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249394 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 249394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 249397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249405 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249407 */     GIR_RootConstrainSelectedInstOperands,
     /* 249408 */     // GIR_Coverage, 8230,
     /* 249408 */     GIR_EraseRootFromParent_Done,
     /* 249409 */   // Label 4990: @249409
     /* 249409 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(249456), // Rule ID 8233 //
     /* 249414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 249422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249431 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249434 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 249437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249441 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1471:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 249441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
     /* 249444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249452 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249454 */     GIR_RootConstrainSelectedInstOperands,
     /* 249455 */     // GIR_Coverage, 8233,
     /* 249455 */     GIR_EraseRootFromParent_Done,
     /* 249456 */   // Label 4991: @249456
     /* 249456 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(249503), // Rule ID 8236 //
     /* 249461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249481 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 249484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249488 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1473:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 249488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 249491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249495 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249497 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249499 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249501 */     GIR_RootConstrainSelectedInstOperands,
     /* 249502 */     // GIR_Coverage, 8236,
     /* 249502 */     GIR_EraseRootFromParent_Done,
     /* 249503 */   // Label 4992: @249503
     /* 249503 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(249550), // Rule ID 8238 //
     /* 249508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 249519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 249525 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 249528 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 249531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249535 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1473:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 249535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 249538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249544 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249546 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249548 */     GIR_RootConstrainSelectedInstOperands,
     /* 249549 */     // GIR_Coverage, 8238,
     /* 249549 */     GIR_EraseRootFromParent_Done,
     /* 249550 */   // Label 4993: @249550
     /* 249550 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(249597), // Rule ID 8240 //
     /* 249555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 249566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 249572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 249575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 249578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249582 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1473:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 249582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 249585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249591 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249593 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249595 */     GIR_RootConstrainSelectedInstOperands,
     /* 249596 */     // GIR_Coverage, 8240,
     /* 249596 */     GIR_EraseRootFromParent_Done,
     /* 249597 */   // Label 4994: @249597
     /* 249597 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(249644), // Rule ID 8242 //
     /* 249602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249622 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 249625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249629 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1473:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 249629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 249632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249638 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249640 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249642 */     GIR_RootConstrainSelectedInstOperands,
     /* 249643 */     // GIR_Coverage, 8242,
     /* 249643 */     GIR_EraseRootFromParent_Done,
     /* 249644 */   // Label 4995: @249644
     /* 249644 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(249691), // Rule ID 8244 //
     /* 249649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 249660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 249666 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 249669 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 249672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249676 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1473:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 249676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 249679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249681 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249685 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249687 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249689 */     GIR_RootConstrainSelectedInstOperands,
     /* 249690 */     // GIR_Coverage, 8244,
     /* 249690 */     GIR_EraseRootFromParent_Done,
     /* 249691 */   // Label 4996: @249691
     /* 249691 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(249738), // Rule ID 8246 //
     /* 249696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 249699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 249704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249713 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249716 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 249719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249723 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1473:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 249723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
     /* 249726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 249728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249732 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249734 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 249736 */     GIR_RootConstrainSelectedInstOperands,
     /* 249737 */     // GIR_Coverage, 8246,
     /* 249737 */     GIR_EraseRootFromParent_Done,
     /* 249738 */   // Label 4997: @249738
     /* 249738 */   GIM_Reject,
     /* 249739 */ // Label 4856: @249739
     /* 249739 */ GIM_Reject,
     /* 249740 */ // Label 36: @249740
     /* 249740 */ GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(249818),
     /* 249745 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 249748 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(249770), // Rule ID 78 //
     /* 249753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 249756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
     /* 249761 */     // (intrinsic_void 2152:{ *:[iPTR] })  =>  (TCOMMIT)
     /* 249761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
     /* 249764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249768 */     GIR_RootConstrainSelectedInstOperands,
     /* 249769 */     // GIR_Coverage, 78,
     /* 249769 */     GIR_EraseRootFromParent_Done,
     /* 249770 */   // Label 4999: @249770
     /* 249770 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(249795), // Rule ID 2384 //
     /* 249775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 249778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
     /* 249783 */     // (intrinsic_void 1702:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
     /* 249783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
     /* 249786 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 249789 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249793 */     GIR_RootConstrainSelectedInstOperands,
     /* 249794 */     // GIR_Coverage, 2384,
     /* 249794 */     GIR_EraseRootFromParent_Done,
     /* 249795 */   // Label 5000: @249795
     /* 249795 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(249817), // Rule ID 7101 //
     /* 249800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
     /* 249805 */     // (intrinsic_void 500:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
     /* 249805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
     /* 249808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 249811 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249815 */     GIR_RootConstrainSelectedInstOperands,
     /* 249816 */     // GIR_Coverage, 7101,
     /* 249816 */     GIR_EraseRootFromParent_Done,
     /* 249817 */   // Label 5001: @249817
     /* 249817 */   GIM_Reject,
     /* 249818 */ // Label 4998: @249818
     /* 249818 */ GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(250418),
     /* 249823 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 249826 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(249858), // Rule ID 79 //
     /* 249831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 249834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
     /* 249839 */     // MIs[0] imm
     /* 249839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 249842 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
     /* 249847 */     // (intrinsic_void 2151:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
     /* 249847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
     /* 249850 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 249852 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249856 */     GIR_RootConstrainSelectedInstOperands,
     /* 249857 */     // GIR_Coverage, 79,
     /* 249857 */     GIR_EraseRootFromParent_Done,
     /* 249858 */   // Label 5003: @249858
     /* 249858 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(249883), // Rule ID 227 //
     /* 249863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
     /* 249868 */     // MIs[0] imm
     /* 249868 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 249871 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 249876 */     // (intrinsic_void 498:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
     /* 249876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 249879 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 249881 */     GIR_RootConstrainSelectedInstOperands,
     /* 249882 */     // GIR_Coverage, 227,
     /* 249882 */     GIR_EraseRootFromParent_Done,
     /* 249883 */   // Label 5004: @249883
     /* 249883 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(249908), // Rule ID 228 //
     /* 249888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
     /* 249893 */     // MIs[0] imm
     /* 249893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 249896 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 249901 */     // (intrinsic_void 557:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
     /* 249901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
     /* 249904 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 249906 */     GIR_RootConstrainSelectedInstOperands,
     /* 249907 */     // GIR_Coverage, 228,
     /* 249907 */     GIR_EraseRootFromParent_Done,
     /* 249908 */   // Label 5005: @249908
     /* 249908 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(249940), // Rule ID 3622 //
     /* 249913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 249916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
     /* 249921 */     // MIs[0] imm
     /* 249921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 249924 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
     /* 249929 */     // (intrinsic_void 1208:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
     /* 249929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
     /* 249932 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 249934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 249938 */     GIR_RootConstrainSelectedInstOperands,
     /* 249939 */     // GIR_Coverage, 3622,
     /* 249939 */     GIR_EraseRootFromParent_Done,
     /* 249940 */   // Label 5006: @249940
     /* 249940 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(249980), // Rule ID 16 //
     /* 249945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
     /* 249950 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 249953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 249957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 249961 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
     /* 249965 */     // MIs[1] Operand 1
     /* 249965 */     // No operand predicates
     /* 249965 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 249967 */     // (intrinsic_void 556:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /* 249967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
     /* 249970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 249973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 249978 */     GIR_RootConstrainSelectedInstOperands,
     /* 249979 */     // GIR_Coverage, 16,
     /* 249979 */     GIR_EraseRootFromParent_Done,
     /* 249980 */   // Label 5007: @249980
     /* 249980 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(250020), // Rule ID 17 //
     /* 249985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
     /* 249990 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 249993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 249997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 250001 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 250005 */     // MIs[1] Operand 1
     /* 250005 */     // No operand predicates
     /* 250005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 250007 */     // (intrinsic_void 544:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
     /* 250007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 250010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 250013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 250018 */     GIR_RootConstrainSelectedInstOperands,
     /* 250019 */     // GIR_Coverage, 17,
     /* 250019 */     GIR_EraseRootFromParent_Done,
     /* 250020 */   // Label 5008: @250020
     /* 250020 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(250060), // Rule ID 18 //
     /* 250025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
     /* 250030 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 250033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 250037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 250041 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 250045 */     // MIs[1] Operand 1
     /* 250045 */     // No operand predicates
     /* 250045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 250047 */     // (intrinsic_void 545:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
     /* 250047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
     /* 250050 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 250053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 250058 */     GIR_RootConstrainSelectedInstOperands,
     /* 250059 */     // GIR_Coverage, 18,
     /* 250059 */     GIR_EraseRootFromParent_Done,
     /* 250060 */   // Label 5009: @250060
     /* 250060 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(250100), // Rule ID 19 //
     /* 250065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
     /* 250070 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 250073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 250077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 250081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 250085 */     // MIs[1] Operand 1
     /* 250085 */     // No operand predicates
     /* 250085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 250087 */     // (intrinsic_void 560:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
     /* 250087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
     /* 250090 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 250093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 250098 */     GIR_RootConstrainSelectedInstOperands,
     /* 250099 */     // GIR_Coverage, 19,
     /* 250099 */     GIR_EraseRootFromParent_Done,
     /* 250100 */   // Label 5010: @250100
     /* 250100 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(250124), // Rule ID 72 //
     /* 250105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
     /* 250110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250117 */     // (intrinsic_w_chain:{ *:[i64] } 553:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
     /* 250117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
     /* 250120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250122 */     GIR_RootConstrainSelectedInstOperands,
     /* 250123 */     // GIR_Coverage, 72,
     /* 250123 */     GIR_EraseRootFromParent_Done,
     /* 250124 */   // Label 5011: @250124
     /* 250124 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(250148), // Rule ID 74 //
     /* 250129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
     /* 250134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250141 */     // (intrinsic_w_chain:{ *:[i64] } 554:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
     /* 250141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
     /* 250144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250146 */     GIR_RootConstrainSelectedInstOperands,
     /* 250147 */     // GIR_Coverage, 74,
     /* 250147 */     GIR_EraseRootFromParent_Done,
     /* 250148 */   // Label 5012: @250148
     /* 250148 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(250179), // Rule ID 77 //
     /* 250153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 250156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
     /* 250161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250168 */     // (intrinsic_w_chain:{ *:[i64] } 2153:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
     /* 250168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
     /* 250171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 250173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250177 */     GIR_RootConstrainSelectedInstOperands,
     /* 250178 */     // GIR_Coverage, 77,
     /* 250178 */     GIR_EraseRootFromParent_Done,
     /* 250179 */   // Label 5013: @250179
     /* 250179 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(250206), // Rule ID 80 //
     /* 250184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 250187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
     /* 250192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250199 */     // (intrinsic_w_chain:{ *:[i64] } 2154:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
     /* 250199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
     /* 250202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 250204 */     GIR_RootConstrainSelectedInstOperands,
     /* 250205 */     // GIR_Coverage, 80,
     /* 250205 */     GIR_EraseRootFromParent_Done,
     /* 250206 */   // Label 5014: @250206
     /* 250206 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(250237), // Rule ID 2383 //
     /* 250211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 250214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
     /* 250219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 250222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 250226 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1652:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
     /* 250226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
     /* 250229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 250231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250235 */     GIR_RootConstrainSelectedInstOperands,
     /* 250236 */     // GIR_Coverage, 2383,
     /* 250236 */     GIR_EraseRootFromParent_Done,
     /* 250237 */   // Label 5015: @250237
     /* 250237 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(250277), // Rule ID 12701 //
     /* 250242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 250245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
     /* 250250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250257 */     // (intrinsic_w_chain:{ *:[i64] } 881:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
     /* 250257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 250260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 250262 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 250272 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 250275 */     GIR_RootConstrainSelectedInstOperands,
     /* 250276 */     // GIR_Coverage, 12701,
     /* 250276 */     GIR_EraseRootFromParent_Done,
     /* 250277 */   // Label 5016: @250277
     /* 250277 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(250311), // Rule ID 2385 //
     /* 250282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 250285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
     /* 250290 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 250293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 250297 */     // (intrinsic_void 2132:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
     /* 250297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
     /* 250300 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pn
     /* 250302 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 250305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250309 */     GIR_RootConstrainSelectedInstOperands,
     /* 250310 */     // GIR_Coverage, 2385,
     /* 250310 */     GIR_EraseRootFromParent_Done,
     /* 250311 */   // Label 5017: @250311
     /* 250311 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(250334), // Rule ID 73 //
     /* 250316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
     /* 250321 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 250324 */     // (intrinsic_void 780:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
     /* 250324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
     /* 250327 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 250329 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
     /* 250332 */     GIR_RootConstrainSelectedInstOperands,
     /* 250333 */     // GIR_Coverage, 73,
     /* 250333 */     GIR_EraseRootFromParent_Done,
     /* 250334 */   // Label 5018: @250334
     /* 250334 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(250357), // Rule ID 75 //
     /* 250339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
     /* 250344 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 250347 */     // (intrinsic_void 782:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
     /* 250347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
     /* 250350 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 250352 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
     /* 250355 */     GIR_RootConstrainSelectedInstOperands,
     /* 250356 */     // GIR_Coverage, 75,
     /* 250356 */     GIR_EraseRootFromParent_Done,
     /* 250357 */   // Label 5019: @250357
     /* 250357 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(250384), // Rule ID 76 //
     /* 250362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
     /* 250367 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 250370 */     // (intrinsic_void 781:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
     /* 250370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
     /* 250373 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 250375 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
     /* 250378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250382 */     GIR_RootConstrainSelectedInstOperands,
     /* 250383 */     // GIR_Coverage, 76,
     /* 250383 */     GIR_EraseRootFromParent_Done,
     /* 250384 */   // Label 5020: @250384
     /* 250384 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(250417), // Rule ID 12700 //
     /* 250389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 250392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
     /* 250397 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 250400 */     // (intrinsic_void 956:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
     /* 250400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
     /* 250403 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 250413 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 250415 */     GIR_RootConstrainSelectedInstOperands,
     /* 250416 */     // GIR_Coverage, 12700,
     /* 250416 */     GIR_EraseRootFromParent_Done,
     /* 250417 */   // Label 5021: @250417
     /* 250417 */   GIM_Reject,
     /* 250418 */ // Label 5002: @250418
     /* 250418 */ GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(251389),
     /* 250423 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 250426 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(250502), // Rule ID 7067 //
     /* 250431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 250436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250443 */     // MIs[0] addr
     /* 250443 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250451 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /* 250455 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /* 250462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250471 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250496 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250501 */     // GIR_Coverage, 7067,
     /* 250501 */     GIR_EraseRootFromParent_Done,
     /* 250502 */   // Label 5023: @250502
     /* 250502 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(250578), // Rule ID 7068 //
     /* 250507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 250512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250519 */     // MIs[0] addr
     /* 250519 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250527 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /* 250531 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250531 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250534 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /* 250538 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250543 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250547 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250551 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250567 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250577 */     // GIR_Coverage, 7068,
     /* 250577 */     GIR_EraseRootFromParent_Done,
     /* 250578 */   // Label 5024: @250578
     /* 250578 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(250654), // Rule ID 7069 //
     /* 250583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 250588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250595 */     // MIs[0] addr
     /* 250595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250603 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /* 250607 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /* 250614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250619 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250623 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250648 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250653 */     // GIR_Coverage, 7069,
     /* 250653 */     GIR_EraseRootFromParent_Done,
     /* 250654 */   // Label 5025: @250654
     /* 250654 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(250696), // Rule ID 7070 //
     /* 250659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 250664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250671 */     // MIs[0] addr
     /* 250671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250679 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
     /* 250683 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 250683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
     /* 250686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 250688 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 250690 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250694 */     GIR_RootConstrainSelectedInstOperands,
     /* 250695 */     // GIR_Coverage, 7070,
     /* 250695 */     GIR_EraseRootFromParent_Done,
     /* 250696 */   // Label 5026: @250696
     /* 250696 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(250772), // Rule ID 7074 //
     /* 250701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 250706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250713 */     // MIs[0] addr
     /* 250713 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250721 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /* 250725 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /* 250732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250737 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250741 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250771 */     // GIR_Coverage, 7074,
     /* 250771 */     GIR_EraseRootFromParent_Done,
     /* 250772 */   // Label 5027: @250772
     /* 250772 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(250848), // Rule ID 7075 //
     /* 250777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 250782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250789 */     // MIs[0] addr
     /* 250789 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250797 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /* 250801 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /* 250808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250813 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250817 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250842 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250847 */     // GIR_Coverage, 7075,
     /* 250847 */     GIR_EraseRootFromParent_Done,
     /* 250848 */   // Label 5028: @250848
     /* 250848 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(250924), // Rule ID 7076 //
     /* 250853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 250858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250865 */     // MIs[0] addr
     /* 250865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250873 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /* 250877 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 250877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 250880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /* 250884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 250889 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 250893 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250897 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 250899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 250902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 250904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 250907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 250910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 250913 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 250918 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 250923 */     // GIR_Coverage, 7076,
     /* 250923 */     GIR_EraseRootFromParent_Done,
     /* 250924 */   // Label 5029: @250924
     /* 250924 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(250966), // Rule ID 7077 //
     /* 250929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 250934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250941 */     // MIs[0] addr
     /* 250941 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 250945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 250949 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
     /* 250953 */     // (intrinsic_w_chain:{ *:[i64] } 563:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 250953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
     /* 250956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 250958 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 250960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 250964 */     GIR_RootConstrainSelectedInstOperands,
     /* 250965 */     // GIR_Coverage, 7077,
     /* 250965 */     GIR_EraseRootFromParent_Done,
     /* 250966 */   // Label 5030: @250966
     /* 250966 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(251006), // Rule ID 20 //
     /* 250971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
     /* 250974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
     /* 250979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 250982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 250985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 250993 */     // (intrinsic_w_chain:{ *:[i64] } 551:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 250993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
     /* 250996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 250998 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 251000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251004 */     GIR_RootConstrainSelectedInstOperands,
     /* 251005 */     // GIR_Coverage, 20,
     /* 251005 */     GIR_EraseRootFromParent_Done,
     /* 251006 */   // Label 5031: @251006
     /* 251006 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(251046), // Rule ID 2382 //
     /* 251011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 251014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
     /* 251019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 251022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 251029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 251033 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1653:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
     /* 251033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
     /* 251036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 251038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 251040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251044 */     GIR_RootConstrainSelectedInstOperands,
     /* 251045 */     // GIR_Coverage, 2382,
     /* 251045 */     GIR_EraseRootFromParent_Done,
     /* 251046 */   // Label 5032: @251046
     /* 251046 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(251086), // Rule ID 2493 //
     /* 251051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 251054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 251059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 251062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 251065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 251073 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F1CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 251073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL),
     /* 251076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 251078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251084 */     GIR_RootConstrainSelectedInstOperands,
     /* 251085 */     // GIR_Coverage, 2493,
     /* 251085 */     GIR_EraseRootFromParent_Done,
     /* 251086 */   // Label 5033: @251086
     /* 251086 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(251126), // Rule ID 2494 //
     /* 251091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 251094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 251099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 251102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 251105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251113 */     // (intrinsic_w_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F1CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 251113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL2),
     /* 251116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 251118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251120 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251124 */     GIR_RootConstrainSelectedInstOperands,
     /* 251125 */     // GIR_Coverage, 2494,
     /* 251125 */     GIR_EraseRootFromParent_Done,
     /* 251126 */   // Label 5034: @251126
     /* 251126 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(251166), // Rule ID 6956 //
     /* 251131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 251134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 251139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 251142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 251145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 251153 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F2CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 251153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL),
     /* 251156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 251158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251164 */     GIR_RootConstrainSelectedInstOperands,
     /* 251165 */     // GIR_Coverage, 6956,
     /* 251165 */     GIR_EraseRootFromParent_Done,
     /* 251166 */   // Label 5035: @251166
     /* 251166 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(251206), // Rule ID 6957 //
     /* 251171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 251174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 251179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 251182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 251185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 251193 */     // (intrinsic_w_chain:{ *:[v8f16] } 612:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F2CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 251193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL2),
     /* 251196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 251198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 251200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251204 */     GIR_RootConstrainSelectedInstOperands,
     /* 251205 */     // GIR_Coverage, 6957,
     /* 251205 */     GIR_EraseRootFromParent_Done,
     /* 251206 */   // Label 5036: @251206
     /* 251206 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(251242), // Rule ID 3575 //
     /* 251211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 251214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
     /* 251219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 251225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251229 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1477:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 251229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
     /* 251232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251240 */     GIR_RootConstrainSelectedInstOperands,
     /* 251241 */     // GIR_Coverage, 3575,
     /* 251241 */     GIR_EraseRootFromParent_Done,
     /* 251242 */   // Label 5037: @251242
     /* 251242 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(251280), // Rule ID 3989 //
     /* 251247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 251250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
     /* 251255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 251258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251265 */     // (intrinsic_w_chain:{ *:[i64] } 559:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
     /* 251265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
     /* 251268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 251270 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 251276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 251278 */     GIR_RootConstrainSelectedInstOperands,
     /* 251279 */     // GIR_Coverage, 3989,
     /* 251279 */     GIR_EraseRootFromParent_Done,
     /* 251280 */   // Label 5038: @251280
     /* 251280 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(251316), // Rule ID 12435 //
     /* 251285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 251288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
     /* 251293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 251299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251303 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1479:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 251303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
     /* 251306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251310 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251314 */     GIR_RootConstrainSelectedInstOperands,
     /* 251315 */     // GIR_Coverage, 12435,
     /* 251315 */     GIR_EraseRootFromParent_Done,
     /* 251316 */   // Label 5039: @251316
     /* 251316 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(251352), // Rule ID 12436 //
     /* 251321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 251324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
     /* 251329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 251335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251339 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1483:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 251339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
     /* 251342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251350 */     GIR_RootConstrainSelectedInstOperands,
     /* 251351 */     // GIR_Coverage, 12436,
     /* 251351 */     GIR_EraseRootFromParent_Done,
     /* 251352 */   // Label 5040: @251352
     /* 251352 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(251388), // Rule ID 12437 //
     /* 251357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 251360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
     /* 251365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 251371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251375 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1484:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 251375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
     /* 251378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 251386 */     GIR_RootConstrainSelectedInstOperands,
     /* 251387 */     // GIR_Coverage, 12437,
     /* 251387 */     GIR_EraseRootFromParent_Done,
     /* 251388 */   // Label 5041: @251388
     /* 251388 */   GIM_Reject,
     /* 251389 */ // Label 5022: @251389
     /* 251389 */ GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(255361),
     /* 251394 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 251397 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(251494), // Rule ID 7085 //
     /* 251402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 251407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 251425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 251429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 251433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 251441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 251445 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251450 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 251461 */     // MIs[0] addr
     /* 251461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251469 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 251473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 251475 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 251475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 251478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 251484 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 251492 */     GIR_RootConstrainSelectedInstOperands,
     /* 251493 */     // GIR_Coverage, 7085,
     /* 251493 */     GIR_EraseRootFromParent_Done,
     /* 251494 */   // Label 5043: @251494
     /* 251494 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(251591), // Rule ID 7086 //
     /* 251499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 251504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 251522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 251526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 251530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 251538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 251542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251547 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 251558 */     // MIs[0] addr
     /* 251558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251566 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 251570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 251572 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 251572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 251575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 251581 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 251589 */     GIR_RootConstrainSelectedInstOperands,
     /* 251590 */     // GIR_Coverage, 7086,
     /* 251590 */     GIR_EraseRootFromParent_Done,
     /* 251591 */   // Label 5044: @251591
     /* 251591 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(251688), // Rule ID 7095 //
     /* 251596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 251601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 251619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 251623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 251627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 251635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 251639 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251644 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 251655 */     // MIs[0] addr
     /* 251655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251663 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 251667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 251669 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 251669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 251672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 251678 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 251686 */     GIR_RootConstrainSelectedInstOperands,
     /* 251687 */     // GIR_Coverage, 7095,
     /* 251687 */     GIR_EraseRootFromParent_Done,
     /* 251688 */   // Label 5045: @251688
     /* 251688 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(251785), // Rule ID 7096 //
     /* 251693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 251698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 251716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 251720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 251724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 251732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 251736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251741 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 251752 */     // MIs[0] addr
     /* 251752 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251760 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 251764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 251766 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 251766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 251769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 251775 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251777 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 251783 */     GIR_RootConstrainSelectedInstOperands,
     /* 251784 */     // GIR_Coverage, 7096,
     /* 251784 */     GIR_EraseRootFromParent_Done,
     /* 251785 */   // Label 5046: @251785
     /* 251785 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(251896), // Rule ID 7088 //
     /* 251790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 251795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251826 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 251837 */     // MIs[0] addr
     /* 251837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251845 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 251849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251851 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251851 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251854 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251858 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251863 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251869 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 251882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251887 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 251889 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 251894 */     GIR_RootConstrainSelectedInstOperands,
     /* 251895 */     // GIR_Coverage, 7088,
     /* 251895 */     GIR_EraseRootFromParent_Done,
     /* 251896 */   // Label 5047: @251896
     /* 251896 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(252007), // Rule ID 7089 //
     /* 251901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 251906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 251909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 251912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 251920 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 251924 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 251928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 251932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251937 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 251948 */     // MIs[0] addr
     /* 251948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 251952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 251956 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 251960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 251962 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 251962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 251965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 251969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 251974 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 251980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 251985 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 251990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 251993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 251995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 251998 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252000 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252005 */     GIR_RootConstrainSelectedInstOperands,
     /* 252006 */     // GIR_Coverage, 7089,
     /* 252006 */     GIR_EraseRootFromParent_Done,
     /* 252007 */   // Label 5048: @252007
     /* 252007 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(252118), // Rule ID 7090 //
     /* 252012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 252017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 252035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 252039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 252043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252048 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 252059 */     // MIs[0] addr
     /* 252059 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252067 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 252071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252073 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 252073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 252080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252085 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 252091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 252104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252109 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252111 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252116 */     GIR_RootConstrainSelectedInstOperands,
     /* 252117 */     // GIR_Coverage, 7090,
     /* 252117 */     GIR_EraseRootFromParent_Done,
     /* 252118 */   // Label 5049: @252118
     /* 252118 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(252229), // Rule ID 7098 //
     /* 252123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 252128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 252146 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 252150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 252154 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252159 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 252170 */     // MIs[0] addr
     /* 252170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252178 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 252182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252184 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 252184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 252191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252196 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 252202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 252215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252217 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252220 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252227 */     GIR_RootConstrainSelectedInstOperands,
     /* 252228 */     // GIR_Coverage, 7098,
     /* 252228 */     GIR_EraseRootFromParent_Done,
     /* 252229 */   // Label 5050: @252229
     /* 252229 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(252340), // Rule ID 7099 //
     /* 252234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 252239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 252257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 252261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 252265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252270 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 252281 */     // MIs[0] addr
     /* 252281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252289 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 252293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252295 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 252295 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252298 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 252302 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252307 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 252313 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252318 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 252326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252331 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252338 */     GIR_RootConstrainSelectedInstOperands,
     /* 252339 */     // GIR_Coverage, 7099,
     /* 252339 */     GIR_EraseRootFromParent_Done,
     /* 252340 */   // Label 5051: @252340
     /* 252340 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(252451), // Rule ID 7100 //
     /* 252345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 252350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 252368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 252372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 252376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252381 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 252392 */     // MIs[0] addr
     /* 252392 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252400 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 252404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252406 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 252406 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 252409 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 252413 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 252418 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 252424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 252434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 252437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 252442 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252449 */     GIR_RootConstrainSelectedInstOperands,
     /* 252450 */     // GIR_Coverage, 7100,
     /* 252450 */     GIR_EraseRootFromParent_Done,
     /* 252451 */   // Label 5052: @252451
     /* 252451 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(252502), // Rule ID 70 //
     /* 252456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
     /* 252461 */     // MIs[0] ptr
     /* 252461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 252465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 252469 */     // MIs[0] accessinfo
     /* 252469 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 252472 */     // MIs[0] fixed_shadow
     /* 252472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 252475 */     // (intrinsic_void 191:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 252475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
     /* 252478 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 252480 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 252482 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 252484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 252487 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 252490 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 252493 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 252496 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252500 */     GIR_RootConstrainSelectedInstOperands,
     /* 252501 */     // GIR_Coverage, 70,
     /* 252501 */     GIR_EraseRootFromParent_Done,
     /* 252502 */   // Label 5053: @252502
     /* 252502 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(252553), // Rule ID 71 //
     /* 252507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
     /* 252512 */     // MIs[0] ptr
     /* 252512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 252516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 252520 */     // MIs[0] accessinfo
     /* 252520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 252523 */     // MIs[0] fixed_shadow
     /* 252523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 252526 */     // (intrinsic_void 193:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 252526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
     /* 252529 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 252531 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 252533 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 252535 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 252538 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 252541 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 252544 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 252547 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 252551 */     GIR_RootConstrainSelectedInstOperands,
     /* 252552 */     // GIR_Coverage, 71,
     /* 252552 */     GIR_EraseRootFromParent_Done,
     /* 252553 */   // Label 5054: @252553
     /* 252553 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(252622), // Rule ID 7087 //
     /* 252558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 252563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 252581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 252585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252590 */     // MIs[0] addr
     /* 252590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252594 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252598 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 252602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252604 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 252604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 252607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 252613 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252620 */     GIR_RootConstrainSelectedInstOperands,
     /* 252621 */     // GIR_Coverage, 7087,
     /* 252621 */     GIR_EraseRootFromParent_Done,
     /* 252622 */   // Label 5055: @252622
     /* 252622 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(252691), // Rule ID 7097 //
     /* 252627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 252632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 252635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 252638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 252646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 252650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 252654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 252659 */     // MIs[0] addr
     /* 252659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 252663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 252667 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 252671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 252673 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 252673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 252676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 252678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 252682 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 252684 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 252689 */     GIR_RootConstrainSelectedInstOperands,
     /* 252690 */     // GIR_Coverage, 7097,
     /* 252690 */     GIR_EraseRootFromParent_Done,
     /* 252691 */   // Label 5056: @252691
     /* 252691 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(252729), // Rule ID 3599 //
     /* 252696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 252704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252710 */     // MIs[0] tile
     /* 252710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252713 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252718 */     // (intrinsic_void 1005:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_BToS_PSEUDO),
     /* 252721 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252725 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252727 */     GIR_RootConstrainSelectedInstOperands,
     /* 252728 */     // GIR_Coverage, 3599,
     /* 252728 */     GIR_EraseRootFromParent_Done,
     /* 252729 */   // Label 5057: @252729
     /* 252729 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(252767), // Rule ID 3603 //
     /* 252734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 252742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252748 */     // MIs[0] tile
     /* 252748 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252751 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252756 */     // (intrinsic_void 1005:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HToS_PSEUDO),
     /* 252759 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252765 */     GIR_RootConstrainSelectedInstOperands,
     /* 252766 */     // GIR_Coverage, 3603,
     /* 252766 */     GIR_EraseRootFromParent_Done,
     /* 252767 */   // Label 5058: @252767
     /* 252767 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(252805), // Rule ID 3607 //
     /* 252772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 252775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_za64_wide_1x1),
     /* 252780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252786 */     // MIs[0] tile
     /* 252786 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252789 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252794 */     // (intrinsic_void 1009:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 252794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HtoD_PSEUDO),
     /* 252797 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252803 */     GIR_RootConstrainSelectedInstOperands,
     /* 252804 */     // GIR_Coverage, 3607,
     /* 252804 */     GIR_EraseRootFromParent_Done,
     /* 252805 */   // Label 5059: @252805
     /* 252805 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(252843), // Rule ID 3775 //
     /* 252810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 252813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 252818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252824 */     // MIs[0] tile
     /* 252824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252827 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 252832 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 252832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_H_PSEUDO),
     /* 252835 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252841 */     GIR_RootConstrainSelectedInstOperands,
     /* 252842 */     // GIR_Coverage, 3775,
     /* 252842 */     GIR_EraseRootFromParent_Done,
     /* 252843 */   // Label 5060: @252843
     /* 252843 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(252881), // Rule ID 3779 //
     /* 252848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 252856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 252859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252862 */     // MIs[0] tile
     /* 252862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252865 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252870 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4A_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 252870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_S_PSEUDO),
     /* 252873 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252879 */     GIR_RootConstrainSelectedInstOperands,
     /* 252880 */     // GIR_Coverage, 3779,
     /* 252880 */     GIR_EraseRootFromParent_Done,
     /* 252881 */   // Label 5061: @252881
     /* 252881 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(252919), // Rule ID 3783 //
     /* 252886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 252889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 252894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 252897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252900 */     // MIs[0] tile
     /* 252900 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252903 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 252908 */     // (intrinsic_void 902:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4A_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 252908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_D_PSEUDO),
     /* 252911 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252917 */     GIR_RootConstrainSelectedInstOperands,
     /* 252918 */     // GIR_Coverage, 3783,
     /* 252918 */     GIR_EraseRootFromParent_Done,
     /* 252919 */   // Label 5062: @252919
     /* 252919 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(252957), // Rule ID 3787 //
     /* 252924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_wide_1x1),
     /* 252932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 252935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252938 */     // MIs[0] tile
     /* 252938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252941 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252946 */     // (intrinsic_void 906:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 252946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_HtoS_PSEUDO),
     /* 252949 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252955 */     GIR_RootConstrainSelectedInstOperands,
     /* 252956 */     // GIR_Coverage, 3787,
     /* 252956 */     GIR_EraseRootFromParent_Done,
     /* 252957 */   // Label 5063: @252957
     /* 252957 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(252995), // Rule ID 12514 //
     /* 252962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 252965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 252970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 252973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252976 */     // MIs[0] tile
     /* 252976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 252979 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 252984 */     // (intrinsic_void 1013:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 252984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_BToS_PSEUDO),
     /* 252987 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 252989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 252991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 252993 */     GIR_RootConstrainSelectedInstOperands,
     /* 252994 */     // GIR_Coverage, 12514,
     /* 252994 */     GIR_EraseRootFromParent_Done,
     /* 252995 */   // Label 5064: @252995
     /* 252995 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(253033), // Rule ID 12518 //
     /* 253000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_wide_1x1),
     /* 253008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253014 */     // MIs[0] tile
     /* 253014 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253017 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253022 */     // (intrinsic_void 1056:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 253022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_BToS_PSEUDO),
     /* 253025 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253031 */     GIR_RootConstrainSelectedInstOperands,
     /* 253032 */     // GIR_Coverage, 12518,
     /* 253032 */     GIR_EraseRootFromParent_Done,
     /* 253033 */   // Label 5065: @253033
     /* 253033 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(253071), // Rule ID 12522 //
     /* 253038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_wide_1x1),
     /* 253046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253052 */     // MIs[0] tile
     /* 253052 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253055 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253060 */     // (intrinsic_void 1064:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 253060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_BToS_PSEUDO),
     /* 253063 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253069 */     GIR_RootConstrainSelectedInstOperands,
     /* 253070 */     // GIR_Coverage, 12522,
     /* 253070 */     GIR_EraseRootFromParent_Done,
     /* 253071 */   // Label 5066: @253071
     /* 253071 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(253109), // Rule ID 12526 //
     /* 253076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_wide_1x1),
     /* 253084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253090 */     // MIs[0] tile
     /* 253090 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253093 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253098 */     // (intrinsic_void 1172:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 253098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_BToS_PSEUDO),
     /* 253101 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253105 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253107 */     GIR_RootConstrainSelectedInstOperands,
     /* 253108 */     // GIR_Coverage, 12526,
     /* 253108 */     GIR_EraseRootFromParent_Done,
     /* 253109 */   // Label 5067: @253109
     /* 253109 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(253147), // Rule ID 12530 //
     /* 253114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_wide_1x1),
     /* 253122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253128 */     // MIs[0] tile
     /* 253128 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253131 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253136 */     // (intrinsic_void 1180:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 253136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_BToS_PSEUDO),
     /* 253139 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253143 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253145 */     GIR_RootConstrainSelectedInstOperands,
     /* 253146 */     // GIR_Coverage, 12530,
     /* 253146 */     GIR_EraseRootFromParent_Done,
     /* 253147 */   // Label 5068: @253147
     /* 253147 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(253185), // Rule ID 12534 //
     /* 253152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 253160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253166 */     // MIs[0] tile
     /* 253166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253169 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253174 */     // (intrinsic_void 1138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 253174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_BToS_PSEUDO),
     /* 253177 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253183 */     GIR_RootConstrainSelectedInstOperands,
     /* 253184 */     // GIR_Coverage, 12534,
     /* 253184 */     GIR_EraseRootFromParent_Done,
     /* 253185 */   // Label 5069: @253185
     /* 253185 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(253223), // Rule ID 12538 //
     /* 253190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 253198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253204 */     // MIs[0] tile
     /* 253204 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253207 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253212 */     // (intrinsic_void 1146:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 253212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_BToS_PSEUDO),
     /* 253215 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253221 */     GIR_RootConstrainSelectedInstOperands,
     /* 253222 */     // GIR_Coverage, 12538,
     /* 253222 */     GIR_EraseRootFromParent_Done,
     /* 253223 */   // Label 5070: @253223
     /* 253223 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(253261), // Rule ID 12542 //
     /* 253228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 253236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253242 */     // MIs[0] tile
     /* 253242 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253245 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253250 */     // (intrinsic_void 1013:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HToS_PSEUDO),
     /* 253253 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253259 */     GIR_RootConstrainSelectedInstOperands,
     /* 253260 */     // GIR_Coverage, 12542,
     /* 253260 */     GIR_EraseRootFromParent_Done,
     /* 253261 */   // Label 5071: @253261
     /* 253261 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(253299), // Rule ID 12546 //
     /* 253266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 253274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253280 */     // MIs[0] tile
     /* 253280 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253283 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253288 */     // (intrinsic_void 1138:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HToS_PSEUDO),
     /* 253291 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253297 */     GIR_RootConstrainSelectedInstOperands,
     /* 253298 */     // GIR_Coverage, 12546,
     /* 253298 */     GIR_EraseRootFromParent_Done,
     /* 253299 */   // Label 5072: @253299
     /* 253299 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(253337), // Rule ID 12550 //
     /* 253304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 253312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253318 */     // MIs[0] tile
     /* 253318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253321 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253326 */     // (intrinsic_void 1146:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HToS_PSEUDO),
     /* 253329 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253335 */     GIR_RootConstrainSelectedInstOperands,
     /* 253336 */     // GIR_Coverage, 12550,
     /* 253336 */     GIR_EraseRootFromParent_Done,
     /* 253337 */   // Label 5073: @253337
     /* 253337 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(253375), // Rule ID 12554 //
     /* 253342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_za64_wide_1x1),
     /* 253350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253356 */     // MIs[0] tile
     /* 253356 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253359 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253364 */     // (intrinsic_void 1017:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HtoD_PSEUDO),
     /* 253367 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253373 */     GIR_RootConstrainSelectedInstOperands,
     /* 253374 */     // GIR_Coverage, 12554,
     /* 253374 */     GIR_EraseRootFromParent_Done,
     /* 253375 */   // Label 5074: @253375
     /* 253375 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(253413), // Rule ID 12558 //
     /* 253380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_za64_wide_1x1),
     /* 253388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253394 */     // MIs[0] tile
     /* 253394 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253397 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253402 */     // (intrinsic_void 1060:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_HtoD_PSEUDO),
     /* 253405 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253411 */     GIR_RootConstrainSelectedInstOperands,
     /* 253412 */     // GIR_Coverage, 12558,
     /* 253412 */     GIR_EraseRootFromParent_Done,
     /* 253413 */   // Label 5075: @253413
     /* 253413 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(253451), // Rule ID 12562 //
     /* 253418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_za64_wide_1x1),
     /* 253426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253432 */     // MIs[0] tile
     /* 253432 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253435 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253440 */     // (intrinsic_void 1068:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_HtoD_PSEUDO),
     /* 253443 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253449 */     GIR_RootConstrainSelectedInstOperands,
     /* 253450 */     // GIR_Coverage, 12562,
     /* 253450 */     GIR_EraseRootFromParent_Done,
     /* 253451 */   // Label 5076: @253451
     /* 253451 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(253489), // Rule ID 12566 //
     /* 253456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_za64_wide_1x1),
     /* 253464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253470 */     // MIs[0] tile
     /* 253470 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253473 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253478 */     // (intrinsic_void 1142:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HtoD_PSEUDO),
     /* 253481 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253487 */     GIR_RootConstrainSelectedInstOperands,
     /* 253488 */     // GIR_Coverage, 12566,
     /* 253488 */     GIR_EraseRootFromParent_Done,
     /* 253489 */   // Label 5077: @253489
     /* 253489 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(253527), // Rule ID 12570 //
     /* 253494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_za64_wide_1x1),
     /* 253502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253508 */     // MIs[0] tile
     /* 253508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253511 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253516 */     // (intrinsic_void 1150:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HtoD_PSEUDO),
     /* 253519 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253525 */     GIR_RootConstrainSelectedInstOperands,
     /* 253526 */     // GIR_Coverage, 12570,
     /* 253526 */     GIR_EraseRootFromParent_Done,
     /* 253527 */   // Label 5078: @253527
     /* 253527 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(253565), // Rule ID 12574 //
     /* 253532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_za64_wide_1x1),
     /* 253540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253546 */     // MIs[0] tile
     /* 253546 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253549 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253554 */     // (intrinsic_void 1176:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_HtoD_PSEUDO),
     /* 253557 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253563 */     GIR_RootConstrainSelectedInstOperands,
     /* 253564 */     // GIR_Coverage, 12574,
     /* 253564 */     GIR_EraseRootFromParent_Done,
     /* 253565 */   // Label 5079: @253565
     /* 253565 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(253603), // Rule ID 12578 //
     /* 253570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 253573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_za64_wide_1x1),
     /* 253578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253584 */     // MIs[0] tile
     /* 253584 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253587 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253592 */     // (intrinsic_void 1184:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 253592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_HtoD_PSEUDO),
     /* 253595 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253601 */     GIR_RootConstrainSelectedInstOperands,
     /* 253602 */     // GIR_Coverage, 12578,
     /* 253602 */     GIR_EraseRootFromParent_Done,
     /* 253603 */   // Label 5080: @253603
     /* 253603 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(253641), // Rule ID 13024 //
     /* 253608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_wide_1x1),
     /* 253616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253622 */     // MIs[0] tile
     /* 253622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253625 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253630 */     // (intrinsic_void 914:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 253630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_HtoS_PSEUDO),
     /* 253633 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253639 */     GIR_RootConstrainSelectedInstOperands,
     /* 253640 */     // GIR_Coverage, 13024,
     /* 253640 */     GIR_EraseRootFromParent_Done,
     /* 253641 */   // Label 5081: @253641
     /* 253641 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(253679), // Rule ID 13028 //
     /* 253646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 253649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 253654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253660 */     // MIs[0] tile
     /* 253660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253663 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 253668 */     // (intrinsic_void 910:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4S_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 253668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_S_PSEUDO),
     /* 253671 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253677 */     GIR_RootConstrainSelectedInstOperands,
     /* 253678 */     // GIR_Coverage, 13028,
     /* 253678 */     GIR_EraseRootFromParent_Done,
     /* 253679 */   // Label 5082: @253679
     /* 253679 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(253717), // Rule ID 13032 //
     /* 253684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 253687 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 253692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253698 */     // MIs[0] tile
     /* 253698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253701 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 253706 */     // (intrinsic_void 910:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 253706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_H_PSEUDO),
     /* 253709 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253715 */     GIR_RootConstrainSelectedInstOperands,
     /* 253716 */     // GIR_Coverage, 13032,
     /* 253716 */     GIR_EraseRootFromParent_Done,
     /* 253717 */   // Label 5083: @253717
     /* 253717 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(253755), // Rule ID 13036 //
     /* 253722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 253725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 253730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 253733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253736 */     // MIs[0] tile
     /* 253736 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 253739 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 253744 */     // (intrinsic_void 910:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4S_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 253744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_D_PSEUDO),
     /* 253747 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 253749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 253751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 253753 */     GIR_RootConstrainSelectedInstOperands,
     /* 253754 */     // GIR_Coverage, 13036,
     /* 253754 */     GIR_EraseRootFromParent_Done,
     /* 253755 */   // Label 5084: @253755
     /* 253755 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(253809), // Rule ID 8800 //
     /* 253760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 253768 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 253771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253775 */     // MIs[0] base
     /* 253775 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253783 */     // MIs[0] prfop
     /* 253783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 253791 */     // (intrinsic_void 1620:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
     /* 253794 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 253796 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 253798 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 253800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253803 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253807 */     GIR_RootConstrainSelectedInstOperands,
     /* 253808 */     // GIR_Coverage, 8800,
     /* 253808 */     GIR_EraseRootFromParent_Done,
     /* 253809 */   // Label 5085: @253809
     /* 253809 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(253863), // Rule ID 8803 //
     /* 253814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 253822 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 253825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253829 */     // MIs[0] base
     /* 253829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253837 */     // MIs[0] prfop
     /* 253837 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253840 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 253845 */     // (intrinsic_void 1620:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
     /* 253848 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 253850 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 253852 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 253854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253857 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253861 */     GIR_RootConstrainSelectedInstOperands,
     /* 253862 */     // GIR_Coverage, 8803,
     /* 253862 */     GIR_EraseRootFromParent_Done,
     /* 253863 */   // Label 5086: @253863
     /* 253863 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(253917), // Rule ID 8806 //
     /* 253868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 253876 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 253879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253883 */     // MIs[0] base
     /* 253883 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253891 */     // MIs[0] prfop
     /* 253891 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253894 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 253899 */     // (intrinsic_void 1620:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
     /* 253902 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 253904 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 253906 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 253908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253915 */     GIR_RootConstrainSelectedInstOperands,
     /* 253916 */     // GIR_Coverage, 8806,
     /* 253916 */     GIR_EraseRootFromParent_Done,
     /* 253917 */   // Label 5087: @253917
     /* 253917 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(253971), // Rule ID 8809 //
     /* 253922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 253925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 253930 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 253933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 253937 */     // MIs[0] base
     /* 253937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 253941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253945 */     // MIs[0] prfop
     /* 253945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 253948 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 253953 */     // (intrinsic_void 1620:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 253953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
     /* 253956 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 253958 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 253960 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 253962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 253965 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 253969 */     GIR_RootConstrainSelectedInstOperands,
     /* 253970 */     // GIR_Coverage, 8809,
     /* 253970 */     GIR_EraseRootFromParent_Done,
     /* 253971 */   // Label 5088: @253971
     /* 253971 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(254025), // Rule ID 15 //
     /* 253976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
     /* 253981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 253984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 253987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 253990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 253994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 253998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 254002 */     // MIs[1] Operand 1
     /* 254002 */     // No operand predicates
     /* 254002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254006 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 254008 */     // (intrinsic_w_chain:{ *:[i64] } 1218:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
     /* 254008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
     /* 254011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
     /* 254016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 254018 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 254023 */     GIR_RootConstrainSelectedInstOperands,
     /* 254024 */     // GIR_Coverage, 15,
     /* 254024 */     GIR_EraseRootFromParent_Done,
     /* 254025 */   // Label 5089: @254025
     /* 254025 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(254093), // Rule ID 68 //
     /* 254030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
     /* 254035 */     // MIs[0] Operand 1
     /* 254035 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 254039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
     /* 254043 */     // MIs[0] ptr
     /* 254043 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 254047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 254051 */     // MIs[0] accessinfo
     /* 254051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254054 */     // (intrinsic_void 190:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 254054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254058 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254064 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
     /* 254068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
     /* 254071 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 254073 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 254075 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 254078 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 254081 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 254084 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 254087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254091 */     GIR_RootConstrainSelectedInstOperands,
     /* 254092 */     // GIR_Coverage, 68,
     /* 254092 */     GIR_EraseRootFromParent_Done,
     /* 254093 */   // Label 5090: @254093
     /* 254093 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(254161), // Rule ID 69 //
     /* 254098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 254103 */     // MIs[0] Operand 1
     /* 254103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 254107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
     /* 254111 */     // MIs[0] ptr
     /* 254111 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 254115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 254119 */     // MIs[0] accessinfo
     /* 254119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 254122 */     // (intrinsic_void 192:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 254122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254126 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254132 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
     /* 254136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 254139 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 254141 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 254143 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 254146 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 254149 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 254152 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 254155 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254159 */     GIR_RootConstrainSelectedInstOperands,
     /* 254160 */     // GIR_Coverage, 69,
     /* 254160 */     GIR_EraseRootFromParent_Done,
     /* 254161 */   // Label 5091: @254161
     /* 254161 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(254241), // Rule ID 7081 //
     /* 254166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 254171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254185 */     // MIs[0] addr
     /* 254185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254193 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 254197 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254209 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254220 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 254228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254230 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254233 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254239 */     GIR_RootConstrainSelectedInstOperands,
     /* 254240 */     // GIR_Coverage, 7081,
     /* 254240 */     GIR_EraseRootFromParent_Done,
     /* 254241 */   // Label 5092: @254241
     /* 254241 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(254321), // Rule ID 7082 //
     /* 254246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 254251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254265 */     // MIs[0] addr
     /* 254265 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254269 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254273 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 254277 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254289 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 254308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254313 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254315 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254319 */     GIR_RootConstrainSelectedInstOperands,
     /* 254320 */     // GIR_Coverage, 7082,
     /* 254320 */     GIR_EraseRootFromParent_Done,
     /* 254321 */   // Label 5093: @254321
     /* 254321 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(254401), // Rule ID 7083 //
     /* 254326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 254331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254345 */     // MIs[0] addr
     /* 254345 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254349 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254353 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 254357 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254369 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 254388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254393 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254399 */     GIR_RootConstrainSelectedInstOperands,
     /* 254400 */     // GIR_Coverage, 7083,
     /* 254400 */     GIR_EraseRootFromParent_Done,
     /* 254401 */   // Label 5094: @254401
     /* 254401 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(254452), // Rule ID 7084 //
     /* 254406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 254411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254425 */     // MIs[0] addr
     /* 254425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254433 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
     /* 254437 */     // (intrinsic_w_chain:{ *:[i32] } 1227:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 254437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
     /* 254440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254442 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 254444 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254450 */     GIR_RootConstrainSelectedInstOperands,
     /* 254451 */     // GIR_Coverage, 7084,
     /* 254451 */     GIR_EraseRootFromParent_Done,
     /* 254452 */   // Label 5095: @254452
     /* 254452 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(254532), // Rule ID 7091 //
     /* 254457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 254462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254476 */     // MIs[0] addr
     /* 254476 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254480 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254484 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 254488 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254500 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 254519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254524 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254530 */     GIR_RootConstrainSelectedInstOperands,
     /* 254531 */     // GIR_Coverage, 7091,
     /* 254531 */     GIR_EraseRootFromParent_Done,
     /* 254532 */   // Label 5096: @254532
     /* 254532 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(254612), // Rule ID 7092 //
     /* 254537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 254542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254556 */     // MIs[0] addr
     /* 254556 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254564 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 254568 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254580 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 254599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254604 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254610 */     GIR_RootConstrainSelectedInstOperands,
     /* 254611 */     // GIR_Coverage, 7092,
     /* 254611 */     GIR_EraseRootFromParent_Done,
     /* 254612 */   // Label 5097: @254612
     /* 254612 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(254692), // Rule ID 7093 //
     /* 254617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 254622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254636 */     // MIs[0] addr
     /* 254636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254644 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 254648 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 254648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 254651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 254655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 254660 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 254666 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254671 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 254679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 254684 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254690 */     GIR_RootConstrainSelectedInstOperands,
     /* 254691 */     // GIR_Coverage, 7093,
     /* 254691 */     GIR_EraseRootFromParent_Done,
     /* 254692 */   // Label 5098: @254692
     /* 254692 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(254743), // Rule ID 7094 //
     /* 254697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 254702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 254705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 254708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 254712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 254716 */     // MIs[0] addr
     /* 254716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254724 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
     /* 254728 */     // (intrinsic_w_chain:{ *:[i32] } 1225:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 254728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
     /* 254731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 254733 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 254735 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 254737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254741 */     GIR_RootConstrainSelectedInstOperands,
     /* 254742 */     // GIR_Coverage, 7094,
     /* 254742 */     GIR_EraseRootFromParent_Done,
     /* 254743 */   // Label 5099: @254743
     /* 254743 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(254792), // Rule ID 2486 //
     /* 254748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 254751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 254756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 254759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 254762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 254765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254777 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCVTN_F16v8f8:{ *:[v8i8] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 254777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v8f8),
     /* 254780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 254786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254790 */     GIR_RootConstrainSelectedInstOperands,
     /* 254791 */     // GIR_Coverage, 2486,
     /* 254791 */     GIR_EraseRootFromParent_Done,
     /* 254792 */   // Label 5100: @254792
     /* 254792 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(254841), // Rule ID 2487 //
     /* 254797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 254800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 254805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 254808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 254811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 254814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254826 */     // (intrinsic_w_chain:{ *:[v16i8] } 613:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTN_F16v16f8:{ *:[v16i8] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 254826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v16f8),
     /* 254829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 254835 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254839 */     GIR_RootConstrainSelectedInstOperands,
     /* 254840 */     // GIR_Coverage, 2487,
     /* 254840 */     GIR_EraseRootFromParent_Done,
     /* 254841 */   // Label 5101: @254841
     /* 254841 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(254890), // Rule ID 2488 //
     /* 254846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 254849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 254854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 254857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 254860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 254863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 254867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 254875 */     // (intrinsic_w_chain:{ *:[v8i8] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F32v8f8:{ *:[v8i8] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 254875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F32v8f8),
     /* 254878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 254880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 254882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 254884 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254888 */     GIR_RootConstrainSelectedInstOperands,
     /* 254889 */     // GIR_Coverage, 2488,
     /* 254889 */     GIR_EraseRootFromParent_Done,
     /* 254890 */   // Label 5102: @254890
     /* 254890 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(254943), // Rule ID 8686 //
     /* 254895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 254903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254917 */     // MIs[0] base
     /* 254917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254925 */     // (intrinsic_w_chain:{ *:[nxv4i32] } 1553:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 254928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 254930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254932 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254934 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254937 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254941 */     GIR_RootConstrainSelectedInstOperands,
     /* 254942 */     // GIR_Coverage, 8686,
     /* 254942 */     GIR_EraseRootFromParent_Done,
     /* 254943 */   // Label 5103: @254943
     /* 254943 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(254996), // Rule ID 8689 //
     /* 254948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 254951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 254956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 254962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 254970 */     // MIs[0] base
     /* 254970 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 254974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 254978 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1553:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 254978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 254981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 254983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 254985 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 254987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 254990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 254994 */     GIR_RootConstrainSelectedInstOperands,
     /* 254995 */     // GIR_Coverage, 8689,
     /* 254995 */     GIR_EraseRootFromParent_Done,
     /* 254996 */   // Label 5104: @254996
     /* 254996 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(255049), // Rule ID 8698 //
     /* 255001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 255009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 255015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255023 */     // MIs[0] base
     /* 255023 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 255027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255031 */     // (intrinsic_w_chain:{ *:[nxv2i64] } 1552:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 255034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 255036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 255038 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 255040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255043 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255047 */     GIR_RootConstrainSelectedInstOperands,
     /* 255048 */     // GIR_Coverage, 8698,
     /* 255048 */     GIR_EraseRootFromParent_Done,
     /* 255049 */   // Label 5105: @255049
     /* 255049 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(255102), // Rule ID 8701 //
     /* 255054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 255062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 255068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255076 */     // MIs[0] base
     /* 255076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 255080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255084 */     // (intrinsic_w_chain:{ *:[nxv2f64] } 1552:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 255087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 255089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 255091 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 255093 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255096 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255100 */     GIR_RootConstrainSelectedInstOperands,
     /* 255101 */     // GIR_Coverage, 8701,
     /* 255101 */     GIR_EraseRootFromParent_Done,
     /* 255102 */   // Label 5106: @255102
     /* 255102 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(255148), // Rule ID 137 //
     /* 255107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 255110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
     /* 255115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 255118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 255121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255125 */     // MIs[0] Rn
     /* 255125 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 255137 */     // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 255137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
     /* 255140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 255142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 255146 */     GIR_RootConstrainSelectedInstOperands,
     /* 255147 */     // GIR_Coverage, 137,
     /* 255147 */     GIR_EraseRootFromParent_Done,
     /* 255148 */   // Label 5107: @255148
     /* 255148 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(255201), // Rule ID 8692 //
     /* 255153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 255161 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 255164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 255167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255175 */     // MIs[0] base
     /* 255175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 255179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255183 */     // (intrinsic_void 1873:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 255186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 255188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 255190 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 255192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255199 */     GIR_RootConstrainSelectedInstOperands,
     /* 255200 */     // GIR_Coverage, 8692,
     /* 255200 */     GIR_EraseRootFromParent_Done,
     /* 255201 */   // Label 5108: @255201
     /* 255201 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(255254), // Rule ID 8695 //
     /* 255206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 255214 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 255217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 255220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255228 */     // MIs[0] base
     /* 255228 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 255232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255236 */     // (intrinsic_void 1873:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 255239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 255241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 255243 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 255245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255252 */     GIR_RootConstrainSelectedInstOperands,
     /* 255253 */     // GIR_Coverage, 8695,
     /* 255253 */     GIR_EraseRootFromParent_Done,
     /* 255254 */   // Label 5109: @255254
     /* 255254 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(255307), // Rule ID 8704 //
     /* 255259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 255267 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 255270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 255273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255281 */     // MIs[0] base
     /* 255281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 255285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255289 */     // (intrinsic_void 1869:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 255292 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 255294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 255296 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 255298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255301 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255305 */     GIR_RootConstrainSelectedInstOperands,
     /* 255306 */     // GIR_Coverage, 8704,
     /* 255306 */     GIR_EraseRootFromParent_Done,
     /* 255307 */   // Label 5110: @255307
     /* 255307 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(255360), // Rule ID 8707 //
     /* 255312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 255315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 255320 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 255323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 255326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255334 */     // MIs[0] base
     /* 255334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 255338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255342 */     // (intrinsic_void 1869:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 255342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 255345 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 255347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 255349 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 255351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 255354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255358 */     GIR_RootConstrainSelectedInstOperands,
     /* 255359 */     // GIR_Coverage, 8707,
     /* 255359 */     GIR_EraseRootFromParent_Done,
     /* 255360 */   // Label 5111: @255360
     /* 255360 */   GIM_Reject,
     /* 255361 */ // Label 5042: @255361
     /* 255361 */ GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(258066),
     /* 255366 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 255369 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(255440), // Rule ID 3411 //
     /* 255374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 255382 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 255391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 255403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 255407 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 255411 */     // MIs[1] Operand 1
     /* 255411 */     // No operand predicates
     /* 255411 */     // MIs[0] prfop
     /* 255411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255414 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255419 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 255421 */     // (intrinsic_void 1622:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 255421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
     /* 255424 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 255433 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 255438 */     GIR_RootConstrainSelectedInstOperands,
     /* 255439 */     // GIR_Coverage, 3411,
     /* 255439 */     GIR_EraseRootFromParent_Done,
     /* 255440 */   // Label 5113: @255440
     /* 255440 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(255511), // Rule ID 3424 //
     /* 255445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 255453 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 255459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 255462 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 255474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 255478 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 255482 */     // MIs[1] Operand 1
     /* 255482 */     // No operand predicates
     /* 255482 */     // MIs[0] prfop
     /* 255482 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255485 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 255492 */     // (intrinsic_void 1622:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 255492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
     /* 255495 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 255501 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 255504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 255509 */     GIR_RootConstrainSelectedInstOperands,
     /* 255510 */     // GIR_Coverage, 3424,
     /* 255510 */     GIR_EraseRootFromParent_Done,
     /* 255511 */   // Label 5114: @255511
     /* 255511 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(255570), // Rule ID 3611 //
     /* 255516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 255519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 255524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 255530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255533 */     // MIs[0] tile
     /* 255533 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255536 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255549 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255553 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 255553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
     /* 255556 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255558 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 255560 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 255562 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 255564 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255568 */     GIR_RootConstrainSelectedInstOperands,
     /* 255569 */     // GIR_Coverage, 3611,
     /* 255569 */     GIR_EraseRootFromParent_Done,
     /* 255570 */   // Label 5115: @255570
     /* 255570 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(255629), // Rule ID 3612 //
     /* 255575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 255578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 255583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 255589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255592 */     // MIs[0] tile
     /* 255592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255595 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255604 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255612 */     // (intrinsic_void 797:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 255612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
     /* 255615 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255617 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 255619 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 255621 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 255623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255627 */     GIR_RootConstrainSelectedInstOperands,
     /* 255628 */     // GIR_Coverage, 3612,
     /* 255628 */     GIR_EraseRootFromParent_Done,
     /* 255629 */   // Label 5116: @255629
     /* 255629 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(255688), // Rule ID 12495 //
     /* 255634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 255637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 255642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 255648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255651 */     // MIs[0] tile
     /* 255651 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255654 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 255659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255667 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255671 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 255671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
     /* 255674 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255676 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 255678 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 255680 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 255682 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255686 */     GIR_RootConstrainSelectedInstOperands,
     /* 255687 */     // GIR_Coverage, 12495,
     /* 255687 */     GIR_EraseRootFromParent_Done,
     /* 255688 */   // Label 5117: @255688
     /* 255688 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(255747), // Rule ID 12496 //
     /* 255693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 255696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 255701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 255707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255710 */     // MIs[0] tile
     /* 255710 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 255713 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 255718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255722 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255726 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255730 */     // (intrinsic_void 798:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 255730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
     /* 255733 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 255735 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 255737 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 255739 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 255741 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255745 */     GIR_RootConstrainSelectedInstOperands,
     /* 255746 */     // GIR_Coverage, 12496,
     /* 255746 */     GIR_EraseRootFromParent_Done,
     /* 255747 */   // Label 5118: @255747
     /* 255747 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(255807), // Rule ID 3409 //
     /* 255752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 255760 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255770 */     // MIs[0] Rn
     /* 255770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255782 */     // MIs[0] prfop
     /* 255782 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255785 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255790 */     // (intrinsic_void 1624:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 255790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
     /* 255793 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255795 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255805 */     GIR_RootConstrainSelectedInstOperands,
     /* 255806 */     // GIR_Coverage, 3409,
     /* 255806 */     GIR_EraseRootFromParent_Done,
     /* 255807 */   // Label 5119: @255807
     /* 255807 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(255867), // Rule ID 3410 //
     /* 255812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 255820 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 255823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255830 */     // MIs[0] Rn
     /* 255830 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255842 */     // MIs[0] prfop
     /* 255842 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255845 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255850 */     // (intrinsic_void 1623:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 255850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
     /* 255853 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255861 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255865 */     GIR_RootConstrainSelectedInstOperands,
     /* 255866 */     // GIR_Coverage, 3410,
     /* 255866 */     GIR_EraseRootFromParent_Done,
     /* 255867 */   // Label 5120: @255867
     /* 255867 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(255927), // Rule ID 3421 //
     /* 255872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 255880 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255883 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255890 */     // MIs[0] Rn
     /* 255890 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255902 */     // MIs[0] prfop
     /* 255902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255905 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255910 */     // (intrinsic_void 1624:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 255910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
     /* 255913 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255915 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255925 */     GIR_RootConstrainSelectedInstOperands,
     /* 255926 */     // GIR_Coverage, 3421,
     /* 255926 */     GIR_EraseRootFromParent_Done,
     /* 255927 */   // Label 5121: @255927
     /* 255927 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(255987), // Rule ID 3422 //
     /* 255932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 255940 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 255943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 255950 */     // MIs[0] Rn
     /* 255950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 255954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 255958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255962 */     // MIs[0] prfop
     /* 255962 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 255965 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 255970 */     // (intrinsic_void 1623:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 255970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
     /* 255973 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 255975 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 255977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 255979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 255981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 255985 */     GIR_RootConstrainSelectedInstOperands,
     /* 255986 */     // GIR_Coverage, 3422,
     /* 255986 */     GIR_EraseRootFromParent_Done,
     /* 255987 */   // Label 5122: @255987
     /* 255987 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(256047), // Rule ID 3423 //
     /* 255992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 255995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
     /* 256000 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256010 */     // MIs[0] Rn
     /* 256010 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256022 */     // MIs[0] prfop
     /* 256022 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256025 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256030 */     // (intrinsic_void 1621:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
     /* 256030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
     /* 256033 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256041 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256045 */     GIR_RootConstrainSelectedInstOperands,
     /* 256046 */     // GIR_Coverage, 3423,
     /* 256046 */     GIR_EraseRootFromParent_Done,
     /* 256047 */   // Label 5123: @256047
     /* 256047 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(256107), // Rule ID 8812 //
     /* 256052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 256060 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 256063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256070 */     // MIs[0] Rn
     /* 256070 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256082 */     // MIs[0] prfop
     /* 256082 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256085 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256090 */     // (intrinsic_void 1632:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
     /* 256090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
     /* 256093 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256095 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256105 */     GIR_RootConstrainSelectedInstOperands,
     /* 256106 */     // GIR_Coverage, 8812,
     /* 256106 */     GIR_EraseRootFromParent_Done,
     /* 256107 */   // Label 5124: @256107
     /* 256107 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(256167), // Rule ID 8813 //
     /* 256112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 256120 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 256123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256130 */     // MIs[0] Rn
     /* 256130 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256142 */     // MIs[0] prfop
     /* 256142 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256145 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256150 */     // (intrinsic_void 1631:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
     /* 256150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
     /* 256153 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256155 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256165 */     GIR_RootConstrainSelectedInstOperands,
     /* 256166 */     // GIR_Coverage, 8813,
     /* 256166 */     GIR_EraseRootFromParent_Done,
     /* 256167 */   // Label 5125: @256167
     /* 256167 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(256227), // Rule ID 8814 //
     /* 256172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 256180 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 256183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256190 */     // MIs[0] Rn
     /* 256190 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256202 */     // MIs[0] prfop
     /* 256202 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256205 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256210 */     // (intrinsic_void 1636:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
     /* 256210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
     /* 256213 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256215 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256225 */     GIR_RootConstrainSelectedInstOperands,
     /* 256226 */     // GIR_Coverage, 8814,
     /* 256226 */     GIR_EraseRootFromParent_Done,
     /* 256227 */   // Label 5126: @256227
     /* 256227 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(256287), // Rule ID 8815 //
     /* 256232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 256240 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 256243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256250 */     // MIs[0] Rn
     /* 256250 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256262 */     // MIs[0] prfop
     /* 256262 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256265 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256270 */     // (intrinsic_void 1635:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
     /* 256270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
     /* 256273 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256285 */     GIR_RootConstrainSelectedInstOperands,
     /* 256286 */     // GIR_Coverage, 8815,
     /* 256286 */     GIR_EraseRootFromParent_Done,
     /* 256287 */   // Label 5127: @256287
     /* 256287 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(256347), // Rule ID 8816 //
     /* 256292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 256300 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 256303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256310 */     // MIs[0] Rn
     /* 256310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256322 */     // MIs[0] prfop
     /* 256322 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256325 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256330 */     // (intrinsic_void 1628:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
     /* 256330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
     /* 256333 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256335 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256341 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256345 */     GIR_RootConstrainSelectedInstOperands,
     /* 256346 */     // GIR_Coverage, 8816,
     /* 256346 */     GIR_EraseRootFromParent_Done,
     /* 256347 */   // Label 5128: @256347
     /* 256347 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(256407), // Rule ID 8817 //
     /* 256352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256355 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 256360 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 256363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256366 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256370 */     // MIs[0] Rn
     /* 256370 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256382 */     // MIs[0] prfop
     /* 256382 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256385 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256390 */     // (intrinsic_void 1627:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
     /* 256390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
     /* 256393 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256395 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256401 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256405 */     GIR_RootConstrainSelectedInstOperands,
     /* 256406 */     // GIR_Coverage, 8817,
     /* 256406 */     GIR_EraseRootFromParent_Done,
     /* 256407 */   // Label 5129: @256407
     /* 256407 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(256467), // Rule ID 8818 //
     /* 256412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256415 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 256420 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256430 */     // MIs[0] Rn
     /* 256430 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256442 */     // MIs[0] prfop
     /* 256442 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256445 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256450 */     // (intrinsic_void 1632:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
     /* 256450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
     /* 256453 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256455 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256465 */     GIR_RootConstrainSelectedInstOperands,
     /* 256466 */     // GIR_Coverage, 8818,
     /* 256466 */     GIR_EraseRootFromParent_Done,
     /* 256467 */   // Label 5130: @256467
     /* 256467 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(256527), // Rule ID 8819 //
     /* 256472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 256480 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256490 */     // MIs[0] Rn
     /* 256490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256502 */     // MIs[0] prfop
     /* 256502 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256505 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256510 */     // (intrinsic_void 1631:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
     /* 256510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
     /* 256513 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256525 */     GIR_RootConstrainSelectedInstOperands,
     /* 256526 */     // GIR_Coverage, 8819,
     /* 256526 */     GIR_EraseRootFromParent_Done,
     /* 256527 */   // Label 5131: @256527
     /* 256527 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(256587), // Rule ID 8820 //
     /* 256532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 256540 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256550 */     // MIs[0] Rn
     /* 256550 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256562 */     // MIs[0] prfop
     /* 256562 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256565 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256570 */     // (intrinsic_void 1636:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
     /* 256570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
     /* 256573 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256581 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256585 */     GIR_RootConstrainSelectedInstOperands,
     /* 256586 */     // GIR_Coverage, 8820,
     /* 256586 */     GIR_EraseRootFromParent_Done,
     /* 256587 */   // Label 5132: @256587
     /* 256587 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(256647), // Rule ID 8821 //
     /* 256592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 256600 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256610 */     // MIs[0] Rn
     /* 256610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256622 */     // MIs[0] prfop
     /* 256622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256625 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256630 */     // (intrinsic_void 1635:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
     /* 256630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
     /* 256633 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256635 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256645 */     GIR_RootConstrainSelectedInstOperands,
     /* 256646 */     // GIR_Coverage, 8821,
     /* 256646 */     GIR_EraseRootFromParent_Done,
     /* 256647 */   // Label 5133: @256647
     /* 256647 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(256707), // Rule ID 8822 //
     /* 256652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 256660 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256670 */     // MIs[0] Rn
     /* 256670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256682 */     // MIs[0] prfop
     /* 256682 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256685 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256690 */     // (intrinsic_void 1628:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
     /* 256690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
     /* 256693 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256695 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256701 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256705 */     GIR_RootConstrainSelectedInstOperands,
     /* 256706 */     // GIR_Coverage, 8822,
     /* 256706 */     GIR_EraseRootFromParent_Done,
     /* 256707 */   // Label 5134: @256707
     /* 256707 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(256767), // Rule ID 8823 //
     /* 256712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 256720 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256730 */     // MIs[0] Rn
     /* 256730 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256742 */     // MIs[0] prfop
     /* 256742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256745 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256750 */     // (intrinsic_void 1627:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
     /* 256750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
     /* 256753 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256761 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256765 */     GIR_RootConstrainSelectedInstOperands,
     /* 256766 */     // GIR_Coverage, 8823,
     /* 256766 */     GIR_EraseRootFromParent_Done,
     /* 256767 */   // Label 5135: @256767
     /* 256767 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(256827), // Rule ID 8824 //
     /* 256772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
     /* 256780 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256790 */     // MIs[0] Rn
     /* 256790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256802 */     // MIs[0] prfop
     /* 256802 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256805 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256810 */     // (intrinsic_void 1629:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
     /* 256810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
     /* 256813 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256821 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256825 */     GIR_RootConstrainSelectedInstOperands,
     /* 256826 */     // GIR_Coverage, 8824,
     /* 256826 */     GIR_EraseRootFromParent_Done,
     /* 256827 */   // Label 5136: @256827
     /* 256827 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(256887), // Rule ID 8825 //
     /* 256832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
     /* 256840 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256850 */     // MIs[0] Rn
     /* 256850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256862 */     // MIs[0] prfop
     /* 256862 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256865 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256870 */     // (intrinsic_void 1633:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
     /* 256870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
     /* 256873 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256881 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256885 */     GIR_RootConstrainSelectedInstOperands,
     /* 256886 */     // GIR_Coverage, 8825,
     /* 256886 */     GIR_EraseRootFromParent_Done,
     /* 256887 */   // Label 5137: @256887
     /* 256887 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(256947), // Rule ID 8826 //
     /* 256892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 256895 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
     /* 256900 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 256903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256906 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 256910 */     // MIs[0] Rn
     /* 256910 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 256914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 256918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256922 */     // MIs[0] prfop
     /* 256922 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 256925 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 256930 */     // (intrinsic_void 1625:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
     /* 256930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
     /* 256933 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 256935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 256937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 256939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 256941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 256945 */     GIR_RootConstrainSelectedInstOperands,
     /* 256946 */     // GIR_Coverage, 8826,
     /* 256946 */     GIR_EraseRootFromParent_Done,
     /* 256947 */   // Label 5138: @256947
     /* 256947 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(257005), // Rule ID 2372 //
     /* 256952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 256955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb),
     /* 256960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 256963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 256966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 256969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 256972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256984 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 256988 */     // (intrinsic_w_chain:{ *:[v8f16] } 619:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 256988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBv8f16),
     /* 256991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 256993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 256995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 256997 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 256999 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257003 */     GIR_RootConstrainSelectedInstOperands,
     /* 257004 */     // GIR_Coverage, 2372,
     /* 257004 */     GIR_EraseRootFromParent_Done,
     /* 257005 */   // Label 5139: @257005
     /* 257005 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(257063), // Rule ID 2373 //
     /* 257010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt),
     /* 257018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257042 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257046 */     // (intrinsic_w_chain:{ *:[v8f16] } 629:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 257046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTv8f16),
     /* 257049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257055 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257057 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257061 */     GIR_RootConstrainSelectedInstOperands,
     /* 257062 */     // GIR_Coverage, 2373,
     /* 257062 */     GIR_EraseRootFromParent_Done,
     /* 257063 */   // Label 5140: @257063
     /* 257063 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(257121), // Rule ID 2374 //
     /* 257068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb),
     /* 257076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257100 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257104 */     // (intrinsic_w_chain:{ *:[v4f32] } 621:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 257104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBv4f32),
     /* 257107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257113 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257115 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257119 */     GIR_RootConstrainSelectedInstOperands,
     /* 257120 */     // GIR_Coverage, 2374,
     /* 257120 */     GIR_EraseRootFromParent_Done,
     /* 257121 */   // Label 5141: @257121
     /* 257121 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(257179), // Rule ID 2375 //
     /* 257126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt),
     /* 257134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257143 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257158 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257162 */     // (intrinsic_w_chain:{ *:[v4f32] } 623:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 257162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTv4f32),
     /* 257165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257171 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257177 */     GIR_RootConstrainSelectedInstOperands,
     /* 257178 */     // GIR_Coverage, 2375,
     /* 257178 */     GIR_EraseRootFromParent_Done,
     /* 257179 */   // Label 5142: @257179
     /* 257179 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(257237), // Rule ID 2376 //
     /* 257184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb),
     /* 257192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257201 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257216 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257220 */     // (intrinsic_w_chain:{ *:[v4f32] } 625:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 257220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBv4f32),
     /* 257223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257229 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257235 */     GIR_RootConstrainSelectedInstOperands,
     /* 257236 */     // GIR_Coverage, 2376,
     /* 257236 */     GIR_EraseRootFromParent_Done,
     /* 257237 */   // Label 5143: @257237
     /* 257237 */   GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(257295), // Rule ID 2377 //
     /* 257242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 257245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt),
     /* 257250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257274 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257278 */     // (intrinsic_w_chain:{ *:[v4f32] } 627:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 257278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTv4f32),
     /* 257281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257287 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257293 */     GIR_RootConstrainSelectedInstOperands,
     /* 257294 */     // GIR_Coverage, 2377,
     /* 257294 */     GIR_EraseRootFromParent_Done,
     /* 257295 */   // Label 5144: @257295
     /* 257295 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(257353), // Rule ID 2378 //
     /* 257300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 257303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 257308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 257311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 257314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 257320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257332 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257336 */     // (intrinsic_w_chain:{ *:[v4f16] } 615:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 257336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f16),
     /* 257339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257345 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257351 */     GIR_RootConstrainSelectedInstOperands,
     /* 257352 */     // GIR_Coverage, 2378,
     /* 257352 */     GIR_EraseRootFromParent_Done,
     /* 257353 */   // Label 5145: @257353
     /* 257353 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(257411), // Rule ID 2379 //
     /* 257358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 257361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 257366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257390 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257394 */     // (intrinsic_w_chain:{ *:[v8f16] } 615:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 257394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv8f16),
     /* 257397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257405 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257409 */     GIR_RootConstrainSelectedInstOperands,
     /* 257410 */     // GIR_Coverage, 2379,
     /* 257410 */     GIR_EraseRootFromParent_Done,
     /* 257411 */   // Label 5146: @257411
     /* 257411 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(257469), // Rule ID 2380 //
     /* 257416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 257419 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 257424 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 257427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 257430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 257436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257448 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257452 */     // (intrinsic_w_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 257452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv2f32),
     /* 257455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257463 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257467 */     GIR_RootConstrainSelectedInstOperands,
     /* 257468 */     // GIR_Coverage, 2380,
     /* 257468 */     GIR_EraseRootFromParent_Done,
     /* 257469 */   // Label 5147: @257469
     /* 257469 */   GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(257527), // Rule ID 2381 //
     /* 257474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 257477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 257482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 257485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 257488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257491 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 257494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257506 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257510 */     // (intrinsic_w_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 257510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f32),
     /* 257513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 257517 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257519 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257521 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257525 */     GIR_RootConstrainSelectedInstOperands,
     /* 257526 */     // GIR_Coverage, 2381,
     /* 257526 */     GIR_EraseRootFromParent_Done,
     /* 257527 */   // Label 5148: @257527
     /* 257527 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(257585), // Rule ID 2489 //
     /* 257532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 257535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn2),
     /* 257540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 257546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 257549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 257552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257564 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257568 */     // (intrinsic_w_chain:{ *:[v16i8] } 614:{ *:[iPTR] }, V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F322v16f8:{ *:[v16i8] } V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 257568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F322v16f8),
     /* 257571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 257573 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Rd
     /* 257575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 257577 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 257579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257583 */     GIR_RootConstrainSelectedInstOperands,
     /* 257584 */     // GIR_Coverage, 2489,
     /* 257584 */     GIR_EraseRootFromParent_Done,
     /* 257585 */   // Label 5149: @257585
     /* 257585 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(257641), // Rule ID 13053 //
     /* 257590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
     /* 257595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 257598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 257601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257616 */     // MIs[0] addr
     /* 257616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 257620 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257624 */     // (intrinsic_w_chain:{ *:[i32] } 1224:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 257624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
     /* 257627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 257629 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 257631 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 257633 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 257635 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257639 */     GIR_RootConstrainSelectedInstOperands,
     /* 257640 */     // GIR_Coverage, 13053,
     /* 257640 */     GIR_EraseRootFromParent_Done,
     /* 257641 */   // Label 5150: @257641
     /* 257641 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(257697), // Rule ID 13054 //
     /* 257646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
     /* 257651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 257654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 257657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 257660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 257664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257672 */     // MIs[0] addr
     /* 257672 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 257676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 257680 */     // (intrinsic_w_chain:{ *:[i32] } 1226:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 257680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
     /* 257683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 257685 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 257687 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 257689 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 257691 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257695 */     GIR_RootConstrainSelectedInstOperands,
     /* 257696 */     // GIR_Coverage, 13054,
     /* 257696 */     GIR_EraseRootFromParent_Done,
     /* 257697 */   // Label 5151: @257697
     /* 257697 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(257743), // Rule ID 3457 //
     /* 257702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 257705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 257710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 257716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257726 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1489:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
     /* 257729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257733 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257735 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257737 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257741 */     GIR_RootConstrainSelectedInstOperands,
     /* 257742 */     // GIR_Coverage, 3457,
     /* 257742 */     GIR_EraseRootFromParent_Done,
     /* 257743 */   // Label 5152: @257743
     /* 257743 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(257789), // Rule ID 3579 //
     /* 257748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
     /* 257756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 257762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257765 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257772 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1491:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
     /* 257775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257781 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257783 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257787 */     GIR_RootConstrainSelectedInstOperands,
     /* 257788 */     // GIR_Coverage, 3579,
     /* 257788 */     GIR_EraseRootFromParent_Done,
     /* 257789 */   // Label 5153: @257789
     /* 257789 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(257835), // Rule ID 12482 //
     /* 257794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
     /* 257802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 257808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257811 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257818 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1501:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
     /* 257821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257827 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257833 */     GIR_RootConstrainSelectedInstOperands,
     /* 257834 */     // GIR_Coverage, 12482,
     /* 257834 */     GIR_EraseRootFromParent_Done,
     /* 257835 */   // Label 5154: @257835
     /* 257835 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(257881), // Rule ID 12486 //
     /* 257840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
     /* 257848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257857 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257864 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1493:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
     /* 257867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257873 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257875 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257879 */     GIR_RootConstrainSelectedInstOperands,
     /* 257880 */     // GIR_Coverage, 12486,
     /* 257880 */     GIR_EraseRootFromParent_Done,
     /* 257881 */   // Label 5155: @257881
     /* 257881 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(257927), // Rule ID 12487 //
     /* 257886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
     /* 257894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257910 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1495:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
     /* 257913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257919 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257921 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257925 */     GIR_RootConstrainSelectedInstOperands,
     /* 257926 */     // GIR_Coverage, 12487,
     /* 257926 */     GIR_EraseRootFromParent_Done,
     /* 257927 */   // Label 5156: @257927
     /* 257927 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(257973), // Rule ID 12488 //
     /* 257932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
     /* 257940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257949 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257956 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1497:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 257956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
     /* 257959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 257961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257965 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 257971 */     GIR_RootConstrainSelectedInstOperands,
     /* 257972 */     // GIR_Coverage, 12488,
     /* 257972 */     GIR_EraseRootFromParent_Done,
     /* 257973 */   // Label 5157: @257973
     /* 257973 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(258019), // Rule ID 12489 //
     /* 257978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 257981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
     /* 257986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 257992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 257995 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 257998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258002 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1499:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 258002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
     /* 258005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258011 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258017 */     GIR_RootConstrainSelectedInstOperands,
     /* 258018 */     // GIR_Coverage, 12489,
     /* 258018 */     GIR_EraseRootFromParent_Done,
     /* 258019 */   // Label 5158: @258019
     /* 258019 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(258065), // Rule ID 12490 //
     /* 258024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 258027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 258032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 258038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258048 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1489:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 258048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
     /* 258051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 258053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258059 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258063 */     GIR_RootConstrainSelectedInstOperands,
     /* 258064 */     // GIR_Coverage, 12490,
     /* 258064 */     GIR_EraseRootFromParent_Done,
     /* 258065 */   // Label 5159: @258065
     /* 258065 */   GIM_Reject,
     /* 258066 */ // Label 5112: @258066
     /* 258066 */ GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(261059),
     /* 258071 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 258074 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(258142), // Rule ID 2516 //
     /* 258079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 258082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb_lane),
     /* 258087 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258090 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258093 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258096 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258111 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 258115 */     // MIs[0] Idx
     /* 258115 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258118 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 258123 */     // (intrinsic_w_chain:{ *:[v8f16] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALBlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBlanev8f16),
     /* 258126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258132 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258134 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258140 */     GIR_RootConstrainSelectedInstOperands,
     /* 258141 */     // GIR_Coverage, 2516,
     /* 258141 */     GIR_EraseRootFromParent_Done,
     /* 258142 */   // Label 5161: @258142
     /* 258142 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(258210), // Rule ID 2517 //
     /* 258147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 258150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb_lane),
     /* 258155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 258161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258164 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258179 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 258183 */     // MIs[0] Idx
     /* 258183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258186 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 258191 */     // (intrinsic_w_chain:{ *:[v4f32] } 622:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBlanev4f32),
     /* 258194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258200 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258202 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258204 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258208 */     GIR_RootConstrainSelectedInstOperands,
     /* 258209 */     // GIR_Coverage, 2517,
     /* 258209 */     GIR_EraseRootFromParent_Done,
     /* 258210 */   // Label 5162: @258210
     /* 258210 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(258278), // Rule ID 2518 //
     /* 258215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 258218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 258223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 258226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 258229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258251 */     // MIs[0] Idx
     /* 258251 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258254 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258259 */     // (intrinsic_w_chain:{ *:[v2f32] } 618:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev2f32),
     /* 258262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258268 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258270 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258276 */     GIR_RootConstrainSelectedInstOperands,
     /* 258277 */     // GIR_Coverage, 2518,
     /* 258277 */     GIR_EraseRootFromParent_Done,
     /* 258278 */   // Label 5163: @258278
     /* 258278 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(258346), // Rule ID 2519 //
     /* 258283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 258286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 258291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 258297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258319 */     // MIs[0] Idx
     /* 258319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258322 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 258327 */     // (intrinsic_w_chain:{ *:[v4f32] } 618:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f32),
     /* 258330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258338 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258340 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258344 */     GIR_RootConstrainSelectedInstOperands,
     /* 258345 */     // GIR_Coverage, 2519,
     /* 258345 */     GIR_EraseRootFromParent_Done,
     /* 258346 */   // Label 5164: @258346
     /* 258346 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(258414), // Rule ID 2520 //
     /* 258351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 258354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 258359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 258362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 258365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 258387 */     // MIs[0] Idx
     /* 258387 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258390 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 258395 */     // (intrinsic_w_chain:{ *:[v4f16] } 616:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f16),
     /* 258398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258406 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258412 */     GIR_RootConstrainSelectedInstOperands,
     /* 258413 */     // GIR_Coverage, 2520,
     /* 258413 */     GIR_EraseRootFromParent_Done,
     /* 258414 */   // Label 5165: @258414
     /* 258414 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(258482), // Rule ID 2521 //
     /* 258419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 258422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 258427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258451 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 258455 */     // MIs[0] Idx
     /* 258455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258458 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 258463 */     // (intrinsic_w_chain:{ *:[v8f16] } 616:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev8f16),
     /* 258466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258472 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258474 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258480 */     GIR_RootConstrainSelectedInstOperands,
     /* 258481 */     // GIR_Coverage, 2521,
     /* 258481 */     GIR_EraseRootFromParent_Done,
     /* 258482 */   // Label 5166: @258482
     /* 258482 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(258550), // Rule ID 6958 //
     /* 258487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 258490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt_lane),
     /* 258495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258511 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258519 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 258523 */     // MIs[0] Idx
     /* 258523 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258526 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 258531 */     // (intrinsic_w_chain:{ *:[v8f16] } 630:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTlanev8f16),
     /* 258534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258540 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258542 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258548 */     GIR_RootConstrainSelectedInstOperands,
     /* 258549 */     // GIR_Coverage, 6958,
     /* 258549 */     GIR_EraseRootFromParent_Done,
     /* 258550 */   // Label 5167: @258550
     /* 258550 */   GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(258618), // Rule ID 6959 //
     /* 258555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 258558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt_lane),
     /* 258563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 258569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258587 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 258591 */     // MIs[0] Idx
     /* 258591 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258594 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 258599 */     // (intrinsic_w_chain:{ *:[v4f32] } 624:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTlanev4f32),
     /* 258602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258606 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258608 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258610 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258612 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258616 */     GIR_RootConstrainSelectedInstOperands,
     /* 258617 */     // GIR_Coverage, 6959,
     /* 258617 */     GIR_EraseRootFromParent_Done,
     /* 258618 */   // Label 5168: @258618
     /* 258618 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(258686), // Rule ID 6960 //
     /* 258623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 258626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb_lane),
     /* 258631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 258637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258655 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 258659 */     // MIs[0] Idx
     /* 258659 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258662 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 258667 */     // (intrinsic_w_chain:{ *:[v4f32] } 626:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBlanev4f32),
     /* 258670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258678 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258684 */     GIR_RootConstrainSelectedInstOperands,
     /* 258685 */     // GIR_Coverage, 6960,
     /* 258685 */     GIR_EraseRootFromParent_Done,
     /* 258686 */   // Label 5169: @258686
     /* 258686 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(258754), // Rule ID 6961 //
     /* 258691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 258694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt_lane),
     /* 258699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 258702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 258705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258723 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 258727 */     // MIs[0] Idx
     /* 258727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 258730 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 258735 */     // (intrinsic_w_chain:{ *:[v4f32] } 628:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 258735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTlanev4f32),
     /* 258738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 258742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 258744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 258746 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 258748 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258752 */     GIR_RootConstrainSelectedInstOperands,
     /* 258753 */     // GIR_Coverage, 6961,
     /* 258753 */     GIR_EraseRootFromParent_Done,
     /* 258754 */   // Label 5170: @258754
     /* 258754 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(258814), // Rule ID 3591 //
     /* 258759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 258762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 258767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 258770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 258773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258776 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 258779 */     // MIs[0] tile
     /* 258779 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258782 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258795 */     // (intrinsic_void 918:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 258795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
     /* 258798 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258804 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258806 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258812 */     GIR_RootConstrainSelectedInstOperands,
     /* 258813 */     // GIR_Coverage, 3591,
     /* 258813 */     GIR_EraseRootFromParent_Done,
     /* 258814 */   // Label 5171: @258814
     /* 258814 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(258874), // Rule ID 3592 //
     /* 258819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
     /* 258822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
     /* 258827 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258830 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 258833 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258836 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258839 */     // MIs[0] tile
     /* 258839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258842 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 258847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258855 */     // (intrinsic_void 872:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 258855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
     /* 258858 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258864 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258866 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258872 */     GIR_RootConstrainSelectedInstOperands,
     /* 258873 */     // GIR_Coverage, 3592,
     /* 258873 */     GIR_EraseRootFromParent_Done,
     /* 258874 */   // Label 5172: @258874
     /* 258874 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(258934), // Rule ID 3593 //
     /* 258879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 258882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 258887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 258890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 258893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258896 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 258899 */     // MIs[0] tile
     /* 258899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258902 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 258907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258915 */     // (intrinsic_void 918:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 258915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
     /* 258918 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258924 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258926 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258932 */     GIR_RootConstrainSelectedInstOperands,
     /* 258933 */     // GIR_Coverage, 3593,
     /* 258933 */     GIR_EraseRootFromParent_Done,
     /* 258934 */   // Label 5173: @258934
     /* 258934 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(258994), // Rule ID 3594 //
     /* 258939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
     /* 258942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
     /* 258947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 258953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258959 */     // MIs[0] tile
     /* 258959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 258962 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 258967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 258975 */     // (intrinsic_void 871:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 258975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
     /* 258978 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 258980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 258982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 258984 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 258986 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 258988 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 258992 */     GIR_RootConstrainSelectedInstOperands,
     /* 258993 */     // GIR_Coverage, 3594,
     /* 258993 */     GIR_EraseRootFromParent_Done,
     /* 258994 */   // Label 5174: @258994
     /* 258994 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(259054), // Rule ID 3595 //
     /* 258999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 259002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 259007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259013 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259016 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259019 */     // MIs[0] tile
     /* 259019 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259022 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 259027 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259035 */     // (intrinsic_void 918:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 259035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
     /* 259038 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259044 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259046 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259048 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259052 */     GIR_RootConstrainSelectedInstOperands,
     /* 259053 */     // GIR_Coverage, 3595,
     /* 259053 */     GIR_EraseRootFromParent_Done,
     /* 259054 */   // Label 5175: @259054
     /* 259054 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(259114), // Rule ID 3596 //
     /* 259059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 259067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259076 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259079 */     // MIs[0] tile
     /* 259079 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259082 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259095 */     // (intrinsic_void 1021:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
     /* 259098 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259104 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259106 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259108 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259112 */     GIR_RootConstrainSelectedInstOperands,
     /* 259113 */     // GIR_Coverage, 3596,
     /* 259113 */     GIR_EraseRootFromParent_Done,
     /* 259114 */   // Label 5176: @259114
     /* 259114 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(259174), // Rule ID 3597 //
     /* 259119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 259127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259133 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259136 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259139 */     // MIs[0] tile
     /* 259139 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259142 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259151 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259155 */     // (intrinsic_void 1021:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
     /* 259158 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259166 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259168 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259172 */     GIR_RootConstrainSelectedInstOperands,
     /* 259173 */     // GIR_Coverage, 3597,
     /* 259173 */     GIR_EraseRootFromParent_Done,
     /* 259174 */   // Label 5177: @259174
     /* 259174 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(259234), // Rule ID 3598 //
     /* 259179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
     /* 259187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259199 */     // MIs[0] tile
     /* 259199 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259202 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259215 */     // (intrinsic_void 920:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 259215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
     /* 259218 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259226 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259228 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259232 */     GIR_RootConstrainSelectedInstOperands,
     /* 259233 */     // GIR_Coverage, 3598,
     /* 259233 */     GIR_EraseRootFromParent_Done,
     /* 259234 */   // Label 5178: @259234
     /* 259234 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(259294), // Rule ID 3692 //
     /* 259239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 259242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
     /* 259247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259259 */     // MIs[0] tile
     /* 259259 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259262 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259275 */     // (intrinsic_void 1022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
     /* 259278 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259284 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259286 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259292 */     GIR_RootConstrainSelectedInstOperands,
     /* 259293 */     // GIR_Coverage, 3692,
     /* 259293 */     GIR_EraseRootFromParent_Done,
     /* 259294 */   // Label 5179: @259294
     /* 259294 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(259354), // Rule ID 3693 //
     /* 259299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 259302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
     /* 259307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 259313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 259319 */     // MIs[0] tile
     /* 259319 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259322 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259335 */     // (intrinsic_void 799:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 259335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
     /* 259338 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259344 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259346 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259352 */     GIR_RootConstrainSelectedInstOperands,
     /* 259353 */     // GIR_Coverage, 3693,
     /* 259353 */     GIR_EraseRootFromParent_Done,
     /* 259354 */   // Label 5180: @259354
     /* 259354 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(259414), // Rule ID 12497 //
     /* 259359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 259367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 259370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 259373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 259379 */     // MIs[0] tile
     /* 259379 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259382 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259395 */     // (intrinsic_void 921:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 259395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
     /* 259398 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259406 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259408 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259412 */     GIR_RootConstrainSelectedInstOperands,
     /* 259413 */     // GIR_Coverage, 12497,
     /* 259413 */     GIR_EraseRootFromParent_Done,
     /* 259414 */   // Label 5181: @259414
     /* 259414 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(259474), // Rule ID 12498 //
     /* 259419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 259422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 259427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 259430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 259433 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259436 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 259439 */     // MIs[0] tile
     /* 259439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259442 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259455 */     // (intrinsic_void 921:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 259455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
     /* 259458 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259466 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259472 */     GIR_RootConstrainSelectedInstOperands,
     /* 259473 */     // GIR_Coverage, 12498,
     /* 259473 */     GIR_EraseRootFromParent_Done,
     /* 259474 */   // Label 5182: @259474
     /* 259474 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(259534), // Rule ID 12499 //
     /* 259479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
     /* 259487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259499 */     // MIs[0] tile
     /* 259499 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259502 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259515 */     // (intrinsic_void 923:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 259515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
     /* 259518 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259524 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259526 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259528 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259532 */     GIR_RootConstrainSelectedInstOperands,
     /* 259533 */     // GIR_Coverage, 12499,
     /* 259533 */     GIR_EraseRootFromParent_Done,
     /* 259534 */   // Label 5183: @259534
     /* 259534 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(259594), // Rule ID 12500 //
     /* 259539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 259547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259556 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259559 */     // MIs[0] tile
     /* 259559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259562 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259575 */     // (intrinsic_void 1023:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
     /* 259578 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259584 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259586 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259588 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259592 */     GIR_RootConstrainSelectedInstOperands,
     /* 259593 */     // GIR_Coverage, 12500,
     /* 259593 */     GIR_EraseRootFromParent_Done,
     /* 259594 */   // Label 5184: @259594
     /* 259594 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(259654), // Rule ID 12501 //
     /* 259599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 259607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259619 */     // MIs[0] tile
     /* 259619 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259622 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259635 */     // (intrinsic_void 1154:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
     /* 259638 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259646 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259652 */     GIR_RootConstrainSelectedInstOperands,
     /* 259653 */     // GIR_Coverage, 12501,
     /* 259653 */     GIR_EraseRootFromParent_Done,
     /* 259654 */   // Label 5185: @259654
     /* 259654 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(259714), // Rule ID 12502 //
     /* 259659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 259667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259679 */     // MIs[0] tile
     /* 259679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259682 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259695 */     // (intrinsic_void 1156:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
     /* 259698 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259704 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259706 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259708 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259712 */     GIR_RootConstrainSelectedInstOperands,
     /* 259713 */     // GIR_Coverage, 12502,
     /* 259713 */     GIR_EraseRootFromParent_Done,
     /* 259714 */   // Label 5186: @259714
     /* 259714 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(259774), // Rule ID 12503 //
     /* 259719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 259727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259733 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259736 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259739 */     // MIs[0] tile
     /* 259739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259742 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259755 */     // (intrinsic_void 1072:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
     /* 259758 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259764 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259766 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259768 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259772 */     GIR_RootConstrainSelectedInstOperands,
     /* 259773 */     // GIR_Coverage, 12503,
     /* 259773 */     GIR_EraseRootFromParent_Done,
     /* 259774 */   // Label 5187: @259774
     /* 259774 */   GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(259834), // Rule ID 12504 //
     /* 259779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 259787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259793 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259796 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259799 */     // MIs[0] tile
     /* 259799 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259802 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259815 */     // (intrinsic_void 1073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
     /* 259818 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259826 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259832 */     GIR_RootConstrainSelectedInstOperands,
     /* 259833 */     // GIR_Coverage, 12504,
     /* 259833 */     GIR_EraseRootFromParent_Done,
     /* 259834 */   // Label 5188: @259834
     /* 259834 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(259894), // Rule ID 12505 //
     /* 259839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 259847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259856 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259859 */     // MIs[0] tile
     /* 259859 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259862 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259875 */     // (intrinsic_void 1188:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
     /* 259878 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259886 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259892 */     GIR_RootConstrainSelectedInstOperands,
     /* 259893 */     // GIR_Coverage, 12505,
     /* 259893 */     GIR_EraseRootFromParent_Done,
     /* 259894 */   // Label 5189: @259894
     /* 259894 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(259954), // Rule ID 12506 //
     /* 259899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 259902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 259907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 259910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 259913 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259916 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 259919 */     // MIs[0] tile
     /* 259919 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259922 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 259927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259935 */     // (intrinsic_void 1189:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 259935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
     /* 259938 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 259940 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 259942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 259944 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 259946 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 259948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 259952 */     GIR_RootConstrainSelectedInstOperands,
     /* 259953 */     // GIR_Coverage, 12506,
     /* 259953 */     GIR_EraseRootFromParent_Done,
     /* 259954 */   // Label 5190: @259954
     /* 259954 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(260014), // Rule ID 12507 //
     /* 259959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 259962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 259967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 259970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 259973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 259979 */     // MIs[0] tile
     /* 259979 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 259982 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 259987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 259995 */     // (intrinsic_void 1023:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 259995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
     /* 259998 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260004 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260006 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260012 */     GIR_RootConstrainSelectedInstOperands,
     /* 260013 */     // GIR_Coverage, 12507,
     /* 260013 */     GIR_EraseRootFromParent_Done,
     /* 260014 */   // Label 5191: @260014
     /* 260014 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(260074), // Rule ID 12508 //
     /* 260019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 260022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 260027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260036 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260039 */     // MIs[0] tile
     /* 260039 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260042 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 260047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260055 */     // (intrinsic_void 1154:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
     /* 260058 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260066 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260068 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260072 */     GIR_RootConstrainSelectedInstOperands,
     /* 260073 */     // GIR_Coverage, 12508,
     /* 260073 */     GIR_EraseRootFromParent_Done,
     /* 260074 */   // Label 5192: @260074
     /* 260074 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(260134), // Rule ID 12509 //
     /* 260079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 260082 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 260087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260096 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260099 */     // MIs[0] tile
     /* 260099 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260102 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 260107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260115 */     // (intrinsic_void 1156:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
     /* 260118 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260124 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260126 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260128 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260132 */     GIR_RootConstrainSelectedInstOperands,
     /* 260133 */     // GIR_Coverage, 12509,
     /* 260133 */     GIR_EraseRootFromParent_Done,
     /* 260134 */   // Label 5193: @260134
     /* 260134 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(260194), // Rule ID 12510 //
     /* 260139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 260142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 260147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260159 */     // MIs[0] tile
     /* 260159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260162 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 260167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260175 */     // (intrinsic_void 1072:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
     /* 260178 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260184 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260186 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260188 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260192 */     GIR_RootConstrainSelectedInstOperands,
     /* 260193 */     // GIR_Coverage, 12510,
     /* 260193 */     GIR_EraseRootFromParent_Done,
     /* 260194 */   // Label 5194: @260194
     /* 260194 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(260254), // Rule ID 12511 //
     /* 260199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 260202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 260207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260216 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260219 */     // MIs[0] tile
     /* 260219 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260222 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 260227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260235 */     // (intrinsic_void 1073:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
     /* 260238 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260246 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260252 */     GIR_RootConstrainSelectedInstOperands,
     /* 260253 */     // GIR_Coverage, 12511,
     /* 260253 */     GIR_EraseRootFromParent_Done,
     /* 260254 */   // Label 5195: @260254
     /* 260254 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(260314), // Rule ID 12512 //
     /* 260259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 260262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 260267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260273 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260276 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260279 */     // MIs[0] tile
     /* 260279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260282 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 260287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260295 */     // (intrinsic_void 1188:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
     /* 260298 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260306 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260312 */     GIR_RootConstrainSelectedInstOperands,
     /* 260313 */     // GIR_Coverage, 12512,
     /* 260313 */     GIR_EraseRootFromParent_Done,
     /* 260314 */   // Label 5196: @260314
     /* 260314 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(260374), // Rule ID 12513 //
     /* 260319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 260322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 260327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260336 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260339 */     // MIs[0] tile
     /* 260339 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260342 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 260347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260351 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260355 */     // (intrinsic_void 1189:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
     /* 260358 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260364 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260366 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260372 */     GIR_RootConstrainSelectedInstOperands,
     /* 260373 */     // GIR_Coverage, 12513,
     /* 260373 */     GIR_EraseRootFromParent_Done,
     /* 260374 */   // Label 5197: @260374
     /* 260374 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(260434), // Rule ID 12878 //
     /* 260379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 260382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
     /* 260387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 260390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 260393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 260399 */     // MIs[0] tile
     /* 260399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260402 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260415 */     // (intrinsic_void 800:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 260415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
     /* 260418 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260424 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260426 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260432 */     GIR_RootConstrainSelectedInstOperands,
     /* 260433 */     // GIR_Coverage, 12878,
     /* 260433 */     GIR_EraseRootFromParent_Done,
     /* 260434 */   // Label 5198: @260434
     /* 260434 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(260494), // Rule ID 12879 //
     /* 260439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 260442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
     /* 260447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260453 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260456 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260459 */     // MIs[0] tile
     /* 260459 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260462 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260475 */     // (intrinsic_void 1024:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
     /* 260478 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260484 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260486 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260488 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260492 */     GIR_RootConstrainSelectedInstOperands,
     /* 260493 */     // GIR_Coverage, 12879,
     /* 260493 */     GIR_EraseRootFromParent_Done,
     /* 260494 */   // Label 5199: @260494
     /* 260494 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(260554), // Rule ID 12880 //
     /* 260499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 260502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
     /* 260507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260519 */     // MIs[0] tile
     /* 260519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260522 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260535 */     // (intrinsic_void 1155:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
     /* 260538 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260544 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260546 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260548 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260552 */     GIR_RootConstrainSelectedInstOperands,
     /* 260553 */     // GIR_Coverage, 12880,
     /* 260553 */     GIR_EraseRootFromParent_Done,
     /* 260554 */   // Label 5200: @260554
     /* 260554 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(260614), // Rule ID 12881 //
     /* 260559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 260562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
     /* 260567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260576 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260579 */     // MIs[0] tile
     /* 260579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260582 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 260587 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260591 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260595 */     // (intrinsic_void 1157:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 260595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
     /* 260598 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260604 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260606 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260612 */     GIR_RootConstrainSelectedInstOperands,
     /* 260613 */     // GIR_Coverage, 12881,
     /* 260613 */     GIR_EraseRootFromParent_Done,
     /* 260614 */   // Label 5201: @260614
     /* 260614 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(260674), // Rule ID 12992 //
     /* 260619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 260622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 260627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 260630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 260633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260636 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 260639 */     // MIs[0] tile
     /* 260639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 260642 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 260647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 260655 */     // (intrinsic_void 921:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 260655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
     /* 260658 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 260660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 260662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 260664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 260666 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 260668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260672 */     GIR_RootConstrainSelectedInstOperands,
     /* 260673 */     // GIR_Coverage, 12992,
     /* 260673 */     GIR_EraseRootFromParent_Done,
     /* 260674 */   // Label 5202: @260674
     /* 260674 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(260722), // Rule ID 3578 //
     /* 260679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
     /* 260687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260703 */     // MIs[0] Op4
     /* 260703 */     // No operand predicates
     /* 260703 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1492:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
     /* 260706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260714 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260720 */     GIR_RootConstrainSelectedInstOperands,
     /* 260721 */     // GIR_Coverage, 3578,
     /* 260721 */     GIR_EraseRootFromParent_Done,
     /* 260722 */   // Label 5203: @260722
     /* 260722 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(260770), // Rule ID 3580 //
     /* 260727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
     /* 260735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260751 */     // MIs[0] Op4
     /* 260751 */     // No operand predicates
     /* 260751 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1494:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
     /* 260754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260762 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260768 */     GIR_RootConstrainSelectedInstOperands,
     /* 260769 */     // GIR_Coverage, 3580,
     /* 260769 */     GIR_EraseRootFromParent_Done,
     /* 260770 */   // Label 5204: @260770
     /* 260770 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(260818), // Rule ID 3581 //
     /* 260775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 260778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 260783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260792 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260799 */     // MIs[0] Op4
     /* 260799 */     // No operand predicates
     /* 260799 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1490:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
     /* 260802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260808 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260810 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260816 */     GIR_RootConstrainSelectedInstOperands,
     /* 260817 */     // GIR_Coverage, 3581,
     /* 260817 */     GIR_EraseRootFromParent_Done,
     /* 260818 */   // Label 5205: @260818
     /* 260818 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(260866), // Rule ID 3582 //
     /* 260823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 260826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 260831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260847 */     // MIs[0] Op4
     /* 260847 */     // No operand predicates
     /* 260847 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1490:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
     /* 260850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260856 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260858 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260864 */     GIR_RootConstrainSelectedInstOperands,
     /* 260865 */     // GIR_Coverage, 3582,
     /* 260865 */     GIR_EraseRootFromParent_Done,
     /* 260866 */   // Label 5206: @260866
     /* 260866 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(260914), // Rule ID 12481 //
     /* 260871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
     /* 260879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260895 */     // MIs[0] Op4
     /* 260895 */     // No operand predicates
     /* 260895 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1502:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
     /* 260898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260906 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260908 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260912 */     GIR_RootConstrainSelectedInstOperands,
     /* 260913 */     // GIR_Coverage, 12481,
     /* 260913 */     GIR_EraseRootFromParent_Done,
     /* 260914 */   // Label 5207: @260914
     /* 260914 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(260962), // Rule ID 12483 //
     /* 260919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
     /* 260927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260943 */     // MIs[0] Op4
     /* 260943 */     // No operand predicates
     /* 260943 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1496:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
     /* 260946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260952 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260954 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 260960 */     GIR_RootConstrainSelectedInstOperands,
     /* 260961 */     // GIR_Coverage, 12483,
     /* 260961 */     GIR_EraseRootFromParent_Done,
     /* 260962 */   // Label 5208: @260962
     /* 260962 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(261010), // Rule ID 12484 //
     /* 260967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 260970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
     /* 260975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260991 */     // MIs[0] Op4
     /* 260991 */     // No operand predicates
     /* 260991 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1498:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 260991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
     /* 260994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261002 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261008 */     GIR_RootConstrainSelectedInstOperands,
     /* 261009 */     // GIR_Coverage, 12484,
     /* 261009 */     GIR_EraseRootFromParent_Done,
     /* 261010 */   // Label 5209: @261010
     /* 261010 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(261058), // Rule ID 12485 //
     /* 261015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 261018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
     /* 261023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 261032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 261035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261039 */     // MIs[0] Op4
     /* 261039 */     // No operand predicates
     /* 261039 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1500:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 261039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
     /* 261042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261048 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261050 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261052 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 261056 */     GIR_RootConstrainSelectedInstOperands,
     /* 261057 */     // GIR_Coverage, 12485,
     /* 261057 */     GIR_EraseRootFromParent_Done,
     /* 261058 */   // Label 5210: @261058
     /* 261058 */   GIM_Reject,
     /* 261059 */ // Label 5160: @261059
     /* 261059 */ GIM_Reject,
     /* 261060 */ // Label 37: @261060
     /* 261060 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5215*/ GIMT_Encode4(261349),
     /* 261071 */ /*GILLT_s64*//*Label 5211*/ GIMT_Encode4(261103), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 261083 */ /*GILLT_v2s64*//*Label 5212*/ GIMT_Encode4(261163), GIMT_Encode4(0),
     /* 261091 */ /*GILLT_v4s32*//*Label 5213*/ GIMT_Encode4(261225), GIMT_Encode4(0),
     /* 261099 */ /*GILLT_v8s16*//*Label 5214*/ GIMT_Encode4(261287),
     /* 261103 */ // Label 5211: @261103
     /* 261103 */ GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(261162), // Rule ID 6470 //
     /* 261108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 261111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 261115 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261119 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 261119 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 261122 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 261126 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 261131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 261133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 261136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261138 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 261141 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 261143 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 261146 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 261151 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 261156 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 261161 */   // GIR_Coverage, 6470,
     /* 261161 */   GIR_EraseRootFromParent_Done,
     /* 261162 */ // Label 5216: @261162
     /* 261162 */ GIM_Reject,
     /* 261163 */ // Label 5212: @261163
     /* 261163 */ GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(261224),
     /* 261168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 261171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261175 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(261202), // Rule ID 6342 //
     /* 261180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 261187 */     // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 261187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 261190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261200 */     GIR_RootConstrainSelectedInstOperands,
     /* 261201 */     // GIR_Coverage, 6342,
     /* 261201 */     GIR_EraseRootFromParent_Done,
     /* 261202 */   // Label 5218: @261202
     /* 261202 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(261223), // Rule ID 6335 //
     /* 261207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261211 */     // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 261211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 261214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261221 */     GIR_RootConstrainSelectedInstOperands,
     /* 261222 */     // GIR_Coverage, 6335,
     /* 261222 */     GIR_EraseRootFromParent_Done,
     /* 261223 */   // Label 5219: @261223
     /* 261223 */   GIM_Reject,
     /* 261224 */ // Label 5217: @261224
     /* 261224 */ GIM_Reject,
     /* 261225 */ // Label 5213: @261225
     /* 261225 */ GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(261286),
     /* 261230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 261233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261237 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(261264), // Rule ID 6339 //
     /* 261242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 261249 */     // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 261249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 261252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261254 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261262 */     GIR_RootConstrainSelectedInstOperands,
     /* 261263 */     // GIR_Coverage, 6339,
     /* 261263 */     GIR_EraseRootFromParent_Done,
     /* 261264 */   // Label 5221: @261264
     /* 261264 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(261285), // Rule ID 6332 //
     /* 261269 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261273 */     // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 261273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 261276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261283 */     GIR_RootConstrainSelectedInstOperands,
     /* 261284 */     // GIR_Coverage, 6332,
     /* 261284 */     GIR_EraseRootFromParent_Done,
     /* 261285 */   // Label 5222: @261285
     /* 261285 */   GIM_Reject,
     /* 261286 */ // Label 5220: @261286
     /* 261286 */ GIM_Reject,
     /* 261287 */ // Label 5214: @261287
     /* 261287 */ GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(261348),
     /* 261292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 261295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261299 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(261326), // Rule ID 6336 //
     /* 261304 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 261311 */     // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 261311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 261314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 261321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261324 */     GIR_RootConstrainSelectedInstOperands,
     /* 261325 */     // GIR_Coverage, 6336,
     /* 261325 */     GIR_EraseRootFromParent_Done,
     /* 261326 */   // Label 5224: @261326
     /* 261326 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(261347), // Rule ID 6329 //
     /* 261331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261335 */     // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 261335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 261338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 261342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 261345 */     GIR_RootConstrainSelectedInstOperands,
     /* 261346 */     // GIR_Coverage, 6329,
     /* 261346 */     GIR_EraseRootFromParent_Done,
     /* 261347 */   // Label 5225: @261347
     /* 261347 */   GIM_Reject,
     /* 261348 */ // Label 5223: @261348
     /* 261348 */ GIM_Reject,
     /* 261349 */ // Label 5215: @261349
     /* 261349 */ GIM_Reject,
     /* 261350 */ // Label 38: @261350
     /* 261350 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5230*/ GIMT_Encode4(262786),
     /* 261361 */ /*GILLT_s32*//*Label 5226*/ GIMT_Encode4(261393), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 261373 */ /*GILLT_v2s32*//*Label 5227*/ GIMT_Encode4(261432), GIMT_Encode4(0),
     /* 261381 */ /*GILLT_v4s16*//*Label 5228*/ GIMT_Encode4(261788), GIMT_Encode4(0),
     /* 261389 */ /*GILLT_v8s8*//*Label 5229*/ GIMT_Encode4(262287),
     /* 261393 */ // Label 5226: @261393
     /* 261393 */ GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(261431), // Rule ID 6491 //
     /* 261398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 261401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 261405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 261409 */   // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 261409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 261412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 261414 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
     /* 261420 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 261425 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 261430 */   // GIR_Coverage, 6491,
     /* 261430 */   GIR_EraseRootFromParent_Done,
     /* 261431 */ // Label 5231: @261431
     /* 261431 */ GIM_Reject,
     /* 261432 */ // Label 5227: @261432
     /* 261432 */ GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(261787),
     /* 261437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261444 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(261522), // Rule ID 5413 //
     /* 261449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 261469 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 261477 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 261486 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 261492 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 261494 */     // MIs[1] Operand 2
     /* 261494 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 261505 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 261507 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 261507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 261510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261520 */     GIR_RootConstrainSelectedInstOperands,
     /* 261521 */     // GIR_Coverage, 5413,
     /* 261521 */     GIR_EraseRootFromParent_Done,
     /* 261522 */   // Label 5233: @261522
     /* 261522 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(261593), // Rule ID 5409 //
     /* 261527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 261547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 261555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261565 */     // MIs[1] Operand 2
     /* 261565 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 261576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261578 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 261578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 261581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261591 */     GIR_RootConstrainSelectedInstOperands,
     /* 261592 */     // GIR_Coverage, 5409,
     /* 261592 */     GIR_EraseRootFromParent_Done,
     /* 261593 */   // Label 5234: @261593
     /* 261593 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(261664), // Rule ID 5411 //
     /* 261598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 261618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261622 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 261626 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261636 */     // MIs[1] Operand 2
     /* 261636 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 261647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261649 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 261649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 261652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261662 */     GIR_RootConstrainSelectedInstOperands,
     /* 261663 */     // GIR_Coverage, 5411,
     /* 261663 */     GIR_EraseRootFromParent_Done,
     /* 261664 */   // Label 5235: @261664
     /* 261664 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(261717), // Rule ID 2160 //
     /* 261669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 261680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261689 */     // MIs[1] imm
     /* 261689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 261693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261697 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 261701 */     // MIs[2] Operand 1
     /* 261701 */     // No operand predicates
     /* 261701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261703 */     // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 261703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 261706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 261712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 261715 */     GIR_RootConstrainSelectedInstOperands,
     /* 261716 */     // GIR_Coverage, 2160,
     /* 261716 */     GIR_EraseRootFromParent_Done,
     /* 261717 */   // Label 5236: @261717
     /* 261717 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(261767), // Rule ID 6317 //
     /* 261722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 261734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261739 */     // MIs[1] imm
     /* 261739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 261743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 261747 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 261751 */     // MIs[2] Operand 1
     /* 261751 */     // No operand predicates
     /* 261751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261753 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 261753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 261756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 261762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 261765 */     GIR_RootConstrainSelectedInstOperands,
     /* 261766 */     // GIR_Coverage, 6317,
     /* 261766 */     GIR_EraseRootFromParent_Done,
     /* 261767 */   // Label 5237: @261767
     /* 261767 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(261786), // Rule ID 1099 //
     /* 261772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 261775 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261779 */     // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
     /* 261779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 261784 */     GIR_RootConstrainSelectedInstOperands,
     /* 261785 */     // GIR_Coverage, 1099,
     /* 261785 */     GIR_Done,
     /* 261786 */   // Label 5238: @261786
     /* 261786 */   GIM_Reject,
     /* 261787 */ // Label 5232: @261787
     /* 261787 */ GIM_Reject,
     /* 261788 */ // Label 5228: @261788
     /* 261788 */ GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(262286),
     /* 261793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 261800 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(261878), // Rule ID 5407 //
     /* 261805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 261825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261833 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261838 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 261842 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 261848 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 261850 */     // MIs[1] Operand 2
     /* 261850 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 261861 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 261863 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 261863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 261866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261876 */     GIR_RootConstrainSelectedInstOperands,
     /* 261877 */     // GIR_Coverage, 5407,
     /* 261877 */     GIR_EraseRootFromParent_Done,
     /* 261878 */   // Label 5240: @261878
     /* 261878 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(261949), // Rule ID 5403 //
     /* 261883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 261903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261907 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261916 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261921 */     // MIs[1] Operand 2
     /* 261921 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 261932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 261934 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 261934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 261937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 261939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 261943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 261947 */     GIR_RootConstrainSelectedInstOperands,
     /* 261948 */     // GIR_Coverage, 5403,
     /* 261948 */     GIR_EraseRootFromParent_Done,
     /* 261949 */   // Label 5241: @261949
     /* 261949 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(262020), // Rule ID 5405 //
     /* 261954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 261958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 261962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 261970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 261974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 261978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 261982 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 261992 */     // MIs[1] Operand 2
     /* 261992 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 262003 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262005 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 262005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 262008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 262014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 262018 */     GIR_RootConstrainSelectedInstOperands,
     /* 262019 */     // GIR_Coverage, 5405,
     /* 262019 */     GIR_EraseRootFromParent_Done,
     /* 262020 */   // Label 5242: @262020
     /* 262020 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(262112), // Rule ID 5529 //
     /* 262025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 262033 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 262040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 262044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 262048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 262052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 262056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 262065 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 262069 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 262073 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262078 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262080 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
     /* 262080 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 262083 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 262087 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262092 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 262096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 262100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 262102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 262105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262110 */     GIR_RootConstrainSelectedInstOperands,
     /* 262111 */     // GIR_Coverage, 5529,
     /* 262111 */     GIR_EraseRootFromParent_Done,
     /* 262112 */   // Label 5243: @262112
     /* 262112 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(262165), // Rule ID 2159 //
     /* 262117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 262120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 262128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262137 */     // MIs[1] imm
     /* 262137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 262141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262145 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 262149 */     // MIs[2] Operand 1
     /* 262149 */     // No operand predicates
     /* 262149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262151 */     // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 262151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 262154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 262160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 262163 */     GIR_RootConstrainSelectedInstOperands,
     /* 262164 */     // GIR_Coverage, 2159,
     /* 262164 */     GIR_EraseRootFromParent_Done,
     /* 262165 */   // Label 5244: @262165
     /* 262165 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(262215), // Rule ID 6316 //
     /* 262170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 262178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262187 */     // MIs[1] imm
     /* 262187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 262191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262195 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 262199 */     // MIs[2] Operand 1
     /* 262199 */     // No operand predicates
     /* 262199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262201 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 262201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 262204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 262210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 262213 */     GIR_RootConstrainSelectedInstOperands,
     /* 262214 */     // GIR_Coverage, 6316,
     /* 262214 */     GIR_EraseRootFromParent_Done,
     /* 262215 */   // Label 5245: @262215
     /* 262215 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(262266), // Rule ID 5557 //
     /* 262220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 262228 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 262235 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 262239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262251 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
     /* 262251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 262254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 262260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 262264 */     GIR_RootConstrainSelectedInstOperands,
     /* 262265 */     // GIR_Coverage, 5557,
     /* 262265 */     GIR_EraseRootFromParent_Done,
     /* 262266 */   // Label 5246: @262266
     /* 262266 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(262285), // Rule ID 1098 //
     /* 262271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 262274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262278 */     // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
     /* 262278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 262283 */     GIR_RootConstrainSelectedInstOperands,
     /* 262284 */     // GIR_Coverage, 1098,
     /* 262284 */     GIR_Done,
     /* 262285 */   // Label 5247: @262285
     /* 262285 */   GIM_Reject,
     /* 262286 */ // Label 5239: @262286
     /* 262286 */ GIM_Reject,
     /* 262287 */ // Label 5229: @262287
     /* 262287 */ GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(262785),
     /* 262292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262299 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(262377), // Rule ID 5401 //
     /* 262304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 262312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 262320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 262324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 262332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262337 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 262341 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 262347 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 262349 */     // MIs[1] Operand 2
     /* 262349 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 262360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262362 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 262362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 262365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 262371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 262375 */     GIR_RootConstrainSelectedInstOperands,
     /* 262376 */     // GIR_Coverage, 5401,
     /* 262376 */     GIR_EraseRootFromParent_Done,
     /* 262377 */   // Label 5249: @262377
     /* 262377 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(262448), // Rule ID 5397 //
     /* 262382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 262390 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 262398 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 262402 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262406 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 262410 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262415 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262420 */     // MIs[1] Operand 2
     /* 262420 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 262431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262433 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 262433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 262436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 262442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 262446 */     GIR_RootConstrainSelectedInstOperands,
     /* 262447 */     // GIR_Coverage, 5397,
     /* 262447 */     GIR_EraseRootFromParent_Done,
     /* 262448 */   // Label 5250: @262448
     /* 262448 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(262519), // Rule ID 5399 //
     /* 262453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 262461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 262469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 262473 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262477 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 262481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262491 */     // MIs[1] Operand 2
     /* 262491 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 262502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262504 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 262504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 262507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 262513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 262517 */     GIR_RootConstrainSelectedInstOperands,
     /* 262518 */     // GIR_Coverage, 5399,
     /* 262518 */     GIR_EraseRootFromParent_Done,
     /* 262519 */   // Label 5251: @262519
     /* 262519 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(262611), // Rule ID 5502 //
     /* 262524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 262532 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 262539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 262543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 262547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 262551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 262564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 262568 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 262572 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262577 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 262579 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
     /* 262579 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 262582 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 262586 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262591 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 262595 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 262599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 262601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 262604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262609 */     GIR_RootConstrainSelectedInstOperands,
     /* 262610 */     // GIR_Coverage, 5502,
     /* 262610 */     GIR_EraseRootFromParent_Done,
     /* 262611 */   // Label 5252: @262611
     /* 262611 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(262664), // Rule ID 2158 //
     /* 262616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 262619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 262627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262636 */     // MIs[1] imm
     /* 262636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 262640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262644 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 262648 */     // MIs[2] Operand 1
     /* 262648 */     // No operand predicates
     /* 262648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262650 */     // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 262650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 262653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 262659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 262662 */     GIR_RootConstrainSelectedInstOperands,
     /* 262663 */     // GIR_Coverage, 2158,
     /* 262663 */     GIR_EraseRootFromParent_Done,
     /* 262664 */   // Label 5253: @262664
     /* 262664 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(262714), // Rule ID 6315 //
     /* 262669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 262677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 262681 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262686 */     // MIs[1] imm
     /* 262686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 262690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 262694 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 262698 */     // MIs[2] Operand 1
     /* 262698 */     // No operand predicates
     /* 262698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 262700 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 262700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 262703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 262709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 262712 */     GIR_RootConstrainSelectedInstOperands,
     /* 262713 */     // GIR_Coverage, 6315,
     /* 262713 */     GIR_EraseRootFromParent_Done,
     /* 262714 */   // Label 5254: @262714
     /* 262714 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(262765), // Rule ID 5556 //
     /* 262719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 262723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 262727 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 262730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 262734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 262738 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262743 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 262748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 262750 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
     /* 262750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 262753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 262759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 262763 */     GIR_RootConstrainSelectedInstOperands,
     /* 262764 */     // GIR_Coverage, 5556,
     /* 262764 */     GIR_EraseRootFromParent_Done,
     /* 262765 */   // Label 5255: @262765
     /* 262765 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(262784), // Rule ID 1097 //
     /* 262770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 262773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 262777 */     // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
     /* 262777 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 262782 */     GIR_RootConstrainSelectedInstOperands,
     /* 262783 */     // GIR_Coverage, 1097,
     /* 262783 */     GIR_Done,
     /* 262784 */   // Label 5256: @262784
     /* 262784 */   GIM_Reject,
     /* 262785 */ // Label 5248: @262785
     /* 262785 */ GIM_Reject,
     /* 262786 */ // Label 5230: @262786
     /* 262786 */ GIM_Reject,
     /* 262787 */ // Label 39: @262787
     /* 262787 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5259*/ GIMT_Encode4(262906),
     /* 262798 */ /*GILLT_s32*//*Label 5257*/ GIMT_Encode4(262806),
     /* 262802 */ /*GILLT_s64*//*Label 5258*/ GIMT_Encode4(262826),
     /* 262806 */ // Label 5257: @262806
     /* 262806 */ GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(262825), // Rule ID 81 //
     /* 262811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262815 */   // MIs[0] Operand 1
     /* 262815 */   // No operand predicates
     /* 262815 */   // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 262815 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 262818 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262820 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 262823 */   GIR_RootConstrainSelectedInstOperands,
     /* 262824 */   // GIR_Coverage, 81,
     /* 262824 */   GIR_EraseRootFromParent_Done,
     /* 262825 */ // Label 5260: @262825
     /* 262825 */ GIM_Reject,
     /* 262826 */ // Label 5258: @262826
     /* 262826 */ GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(262886), // Rule ID 3893 //
     /* 262831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
     /* 262834 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /* 262838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 262842 */   // MIs[0] Operand 1
     /* 262842 */   // No operand predicates
     /* 262842 */   // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
     /* 262842 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 262845 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 262849 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 262854 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
     /* 262859 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 262861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 262864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262866 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 262869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 262872 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 262875 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 262880 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 262885 */   // GIR_Coverage, 3893,
     /* 262885 */   GIR_EraseRootFromParent_Done,
     /* 262886 */ // Label 5261: @262886
     /* 262886 */ GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(262905), // Rule ID 82 //
     /* 262891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 262895 */   // MIs[0] Operand 1
     /* 262895 */   // No operand predicates
     /* 262895 */   // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 262895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
     /* 262898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 262900 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 262903 */   GIR_RootConstrainSelectedInstOperands,
     /* 262904 */   // GIR_Coverage, 82,
     /* 262904 */   GIR_EraseRootFromParent_Done,
     /* 262905 */ // Label 5262: @262905
     /* 262905 */ GIM_Reject,
     /* 262906 */ // Label 5259: @262906
     /* 262906 */ GIM_Reject,
     /* 262907 */ // Label 40: @262907
     /* 262907 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5266*/ GIMT_Encode4(263147),
     /* 262918 */ /*GILLT_s16*//*Label 5263*/ GIMT_Encode4(262930),
     /* 262922 */ /*GILLT_s32*//*Label 5264*/ GIMT_Encode4(262982),
     /* 262926 */ /*GILLT_s64*//*Label 5265*/ GIMT_Encode4(263095),
     /* 262930 */ // Label 5263: @262930
     /* 262930 */ GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(262953), // Rule ID 506 //
     /* 262935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 262938 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 262942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 262946 */   // MIs[0] Operand 1
     /* 262946 */   // No operand predicates
     /* 262946 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
     /* 262946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
     /* 262949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262951 */   GIR_RootConstrainSelectedInstOperands,
     /* 262952 */   // GIR_Coverage, 506,
     /* 262952 */   GIR_EraseRootFromParent_Done,
     /* 262953 */ // Label 5267: @262953
     /* 262953 */ GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(262981), // Rule ID 688 //
     /* 262958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 262961 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 262965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 262969 */   // MIs[0] Operand 1
     /* 262969 */   // No operand predicates
     /* 262969 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
     /* 262969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
     /* 262972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 262974 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
     /* 262979 */   GIR_RootConstrainSelectedInstOperands,
     /* 262980 */   // GIR_Coverage, 688,
     /* 262980 */   GIR_EraseRootFromParent_Done,
     /* 262981 */ // Label 5268: @262981
     /* 262981 */ GIM_Reject,
     /* 262982 */ // Label 5264: @262982
     /* 262982 */ GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(263005), // Rule ID 507 //
     /* 262987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 262990 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 262994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 262998 */   // MIs[0] Operand 1
     /* 262998 */   // No operand predicates
     /* 262998 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
     /* 262998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
     /* 263001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263003 */   GIR_RootConstrainSelectedInstOperands,
     /* 263004 */   // GIR_Coverage, 507,
     /* 263004 */   GIR_EraseRootFromParent_Done,
     /* 263005 */ // Label 5269: @263005
     /* 263005 */ GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(263033), // Rule ID 689 //
     /* 263010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 263013 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 263017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 263021 */   // MIs[0] Operand 1
     /* 263021 */   // No operand predicates
     /* 263021 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /* 263021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
     /* 263024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263026 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
     /* 263031 */   GIR_RootConstrainSelectedInstOperands,
     /* 263032 */   // GIR_Coverage, 689,
     /* 263032 */   GIR_EraseRootFromParent_Done,
     /* 263033 */ // Label 5270: @263033
     /* 263033 */ GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(263094), // Rule ID 5996 //
     /* 263038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 263041 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
     /* 263045 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 263049 */   // MIs[0] Operand 1
     /* 263049 */   // No operand predicates
     /* 263049 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
     /* 263049 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 263052 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
     /* 263056 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263061 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
     /* 263066 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 263069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 263071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 263074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 263076 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 263083 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 263088 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263093 */   // GIR_Coverage, 5996,
     /* 263093 */   GIR_EraseRootFromParent_Done,
     /* 263094 */ // Label 5271: @263094
     /* 263094 */ GIM_Reject,
     /* 263095 */ // Label 5265: @263095
     /* 263095 */ GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(263118), // Rule ID 508 //
     /* 263100 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 263103 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 263107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263111 */   // MIs[0] Operand 1
     /* 263111 */   // No operand predicates
     /* 263111 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
     /* 263111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
     /* 263114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263116 */   GIR_RootConstrainSelectedInstOperands,
     /* 263117 */   // GIR_Coverage, 508,
     /* 263117 */   GIR_EraseRootFromParent_Done,
     /* 263118 */ // Label 5272: @263118
     /* 263118 */ GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(263146), // Rule ID 690 //
     /* 263123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 263126 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 263130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263134 */   // MIs[0] Operand 1
     /* 263134 */   // No operand predicates
     /* 263134 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /* 263134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
     /* 263137 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263139 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
     /* 263144 */   GIR_RootConstrainSelectedInstOperands,
     /* 263145 */   // GIR_Coverage, 690,
     /* 263145 */   GIR_EraseRootFromParent_Done,
     /* 263146 */ // Label 5273: @263146
     /* 263146 */ GIM_Reject,
     /* 263147 */ // Label 5266: @263147
     /* 263147 */ GIM_Reject,
     /* 263148 */ // Label 41: @263148
     /* 263148 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5279*/ GIMT_Encode4(265045),
     /* 263159 */ /*GILLT_s32*//*Label 5274*/ GIMT_Encode4(263195),
     /* 263163 */ /*GILLT_s64*//*Label 5275*/ GIMT_Encode4(264636), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 263175 */ /*GILLT_v2s64*//*Label 5276*/ GIMT_Encode4(264859), GIMT_Encode4(0),
     /* 263183 */ /*GILLT_v4s32*//*Label 5277*/ GIMT_Encode4(264921), GIMT_Encode4(0),
     /* 263191 */ /*GILLT_v8s16*//*Label 5278*/ GIMT_Encode4(264983),
     /* 263195 */ // Label 5274: @263195
     /* 263195 */ GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(263315), // Rule ID 13055 //
     /* 263200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 263203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263207 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263211 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263215 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263218 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 263223 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 263227 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263232 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263234 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263234 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 263237 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 263241 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263246 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263252 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263255 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263259 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263264 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263266 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263269 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263273 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263278 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263281 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263284 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 263287 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263292 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263297 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263307 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263310 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263313 */   GIR_RootConstrainSelectedInstOperands,
     /* 263314 */   // GIR_Coverage, 13055,
     /* 263314 */   GIR_EraseRootFromParent_Done,
     /* 263315 */ // Label 5280: @263315
     /* 263315 */ GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(263435), // Rule ID 13057 //
     /* 263320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 263323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263327 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263331 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263335 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263338 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 263343 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 263347 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263352 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263354 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 662:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263354 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 263357 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 263361 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263366 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263370 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263372 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263375 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263379 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263384 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263386 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263389 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263393 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263398 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263401 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263404 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 263407 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263412 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263417 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263427 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263430 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263433 */   GIR_RootConstrainSelectedInstOperands,
     /* 263434 */   // GIR_Coverage, 13057,
     /* 263434 */   GIR_EraseRootFromParent_Done,
     /* 263435 */ // Label 5281: @263435
     /* 263435 */ GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(263555), // Rule ID 13059 //
     /* 263440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263447 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263451 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263455 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263458 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 263463 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263467 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263472 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263474 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263474 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 263477 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 263481 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263486 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263492 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263495 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263499 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263504 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263506 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263509 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263513 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263518 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263521 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263524 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 263527 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263532 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263537 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 263545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263547 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263550 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263553 */   GIR_RootConstrainSelectedInstOperands,
     /* 263554 */   // GIR_Coverage, 13059,
     /* 263554 */   GIR_EraseRootFromParent_Done,
     /* 263555 */ // Label 5282: @263555
     /* 263555 */ GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(263675), // Rule ID 13061 //
     /* 263560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263567 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263571 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263575 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263578 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 263583 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 263587 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263592 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263594 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 662:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263594 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 263597 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 263601 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263606 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263610 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263612 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263615 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263619 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263624 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263626 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263629 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263633 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263638 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263641 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263644 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 263647 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263652 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263657 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 263662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 263665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263667 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263673 */   GIR_RootConstrainSelectedInstOperands,
     /* 263674 */   // GIR_Coverage, 13061,
     /* 263674 */   GIR_EraseRootFromParent_Done,
     /* 263675 */ // Label 5283: @263675
     /* 263675 */ GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(263795), // Rule ID 13077 //
     /* 263680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 263683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263687 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263691 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263695 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263698 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 263703 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 263707 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263712 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263714 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263714 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 263717 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 263721 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263726 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263730 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263732 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263735 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263739 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263744 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263746 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263749 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263753 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263758 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263761 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263764 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 263767 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263772 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263777 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263790 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263793 */   GIR_RootConstrainSelectedInstOperands,
     /* 263794 */   // GIR_Coverage, 13077,
     /* 263794 */   GIR_EraseRootFromParent_Done,
     /* 263795 */ // Label 5284: @263795
     /* 263795 */ GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(263915), // Rule ID 13079 //
     /* 263800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 263803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263807 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263811 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263815 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263818 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 263823 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 263827 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263832 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263834 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 672:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263834 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 263837 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 263841 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263846 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263852 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263855 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263859 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263864 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263866 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263869 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263873 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263878 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 263881 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 263884 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 263887 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263892 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 263897 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 263902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 263905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 263907 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 263910 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 263913 */   GIR_RootConstrainSelectedInstOperands,
     /* 263914 */   // GIR_Coverage, 13079,
     /* 263914 */   GIR_EraseRootFromParent_Done,
     /* 263915 */ // Label 5285: @263915
     /* 263915 */ GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(264035), // Rule ID 13081 //
     /* 263920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 263923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 263927 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 263931 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 263935 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 263938 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 263943 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 263947 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 263952 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 263954 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 263954 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 263957 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 263961 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263966 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 263970 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 263972 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 263975 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 263979 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 263986 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 263989 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 263993 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 263998 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264001 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 264004 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 264007 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264012 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264017 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 264022 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264025 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264027 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264030 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264033 */   GIR_RootConstrainSelectedInstOperands,
     /* 264034 */   // GIR_Coverage, 13081,
     /* 264034 */   GIR_EraseRootFromParent_Done,
     /* 264035 */ // Label 5286: @264035
     /* 264035 */ GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(264155), // Rule ID 13083 //
     /* 264040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 264043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264047 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264051 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 264055 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264058 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 264063 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 264067 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264072 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264074 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 672:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 264074 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 264077 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 264081 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264086 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264090 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 264092 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 264095 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264099 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264104 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264106 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264109 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264113 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264118 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264121 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 264124 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 264127 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264132 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264137 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 264142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264147 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264153 */   GIR_RootConstrainSelectedInstOperands,
     /* 264154 */   // GIR_Coverage, 13083,
     /* 264154 */   GIR_EraseRootFromParent_Done,
     /* 264155 */ // Label 5287: @264155
     /* 264155 */ GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(264275), // Rule ID 13087 //
     /* 264160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 264163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264167 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264171 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 264175 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264178 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 264183 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 264187 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264192 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264194 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 264194 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 264197 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 264201 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264206 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264210 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 264212 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 264215 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264219 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264224 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264226 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264229 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264233 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264238 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264241 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 264244 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 264247 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264252 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264257 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 264262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 264265 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264267 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264273 */   GIR_RootConstrainSelectedInstOperands,
     /* 264274 */   // GIR_Coverage, 13087,
     /* 264274 */   GIR_EraseRootFromParent_Done,
     /* 264275 */ // Label 5288: @264275
     /* 264275 */ GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(264395), // Rule ID 13089 //
     /* 264280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 264283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264287 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264291 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 264295 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264298 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 264303 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 264307 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264312 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264314 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 675:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 264314 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 264317 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 264321 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264326 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 264332 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 264335 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264339 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264346 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264349 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264353 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264358 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264361 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 264364 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 264367 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264372 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264377 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 264382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 264385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264387 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264390 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264393 */   GIR_RootConstrainSelectedInstOperands,
     /* 264394 */   // GIR_Coverage, 13089,
     /* 264394 */   GIR_EraseRootFromParent_Done,
     /* 264395 */ // Label 5289: @264395
     /* 264395 */ GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(264515), // Rule ID 13091 //
     /* 264400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 264403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264407 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264411 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 264415 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264418 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 264423 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 264427 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264432 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264434 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 264434 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 264437 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 264441 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264446 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264450 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 264452 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 264455 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264459 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264464 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264466 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264469 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264473 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264478 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264481 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 264484 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 264487 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264492 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264497 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 264502 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264505 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264507 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264510 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264513 */   GIR_RootConstrainSelectedInstOperands,
     /* 264514 */   // GIR_Coverage, 13091,
     /* 264514 */   GIR_EraseRootFromParent_Done,
     /* 264515 */ // Label 5290: @264515
     /* 264515 */ GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(264635), // Rule ID 13093 //
     /* 264520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 264523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264527 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264531 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 264535 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 264538 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 264543 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 264547 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264552 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 264554 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 675:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 264554 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 264557 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 264561 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264566 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 264570 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 264572 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 264575 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264579 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264584 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264586 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 264589 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264593 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264598 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264601 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 264604 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 264607 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264612 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264617 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 264622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 264625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264627 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264633 */   GIR_RootConstrainSelectedInstOperands,
     /* 264634 */   // GIR_Coverage, 13093,
     /* 264634 */   GIR_EraseRootFromParent_Done,
     /* 264635 */ // Label 5291: @264635
     /* 264635 */ GIM_Reject,
     /* 264636 */ // Label 5275: @264636
     /* 264636 */ GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(264858),
     /* 264641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 264644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 264648 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(264702), // Rule ID 5640 //
     /* 264653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 264665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264682 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 264686 */     // MIs[2] Operand 1
     /* 264686 */     // No operand predicates
     /* 264686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264688 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 264688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 264691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 264697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 264700 */     GIR_RootConstrainSelectedInstOperands,
     /* 264701 */     // GIR_Coverage, 5640,
     /* 264701 */     GIR_EraseRootFromParent_Done,
     /* 264702 */   // Label 5293: @264702
     /* 264702 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(264781), // Rule ID 11169 //
     /* 264707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 264710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 264714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 264718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 264722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 264726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 264730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 264734 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 264738 */     // MIs[2] Operand 1
     /* 264738 */     // No operand predicates
     /* 264738 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 264740 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 264740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 264743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 264747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264752 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 264758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 264771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 264779 */     GIR_RootConstrainSelectedInstOperands,
     /* 264780 */     // GIR_Coverage, 11169,
     /* 264780 */     GIR_EraseRootFromParent_Done,
     /* 264781 */   // Label 5294: @264781
     /* 264781 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(264857), // Rule ID 6472 //
     /* 264786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264790 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 264790 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 264793 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 264797 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264802 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 264804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 264807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 264811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 264816 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 264819 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 264823 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 264826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 264836 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 264841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 264844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 264849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 264855 */     GIR_RootConstrainSelectedInstOperands,
     /* 264856 */     // GIR_Coverage, 6472,
     /* 264856 */     GIR_EraseRootFromParent_Done,
     /* 264857 */   // Label 5295: @264857
     /* 264857 */   GIM_Reject,
     /* 264858 */ // Label 5292: @264858
     /* 264858 */ GIM_Reject,
     /* 264859 */ // Label 5276: @264859
     /* 264859 */ GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(264920),
     /* 264864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 264867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264871 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(264898), // Rule ID 6344 //
     /* 264876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 264883 */     // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 264883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
     /* 264886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 264893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264896 */     GIR_RootConstrainSelectedInstOperands,
     /* 264897 */     // GIR_Coverage, 6344,
     /* 264897 */     GIR_EraseRootFromParent_Done,
     /* 264898 */   // Label 5297: @264898
     /* 264898 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(264919), // Rule ID 6333 //
     /* 264903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264907 */     // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 264907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 264910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264912 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264917 */     GIR_RootConstrainSelectedInstOperands,
     /* 264918 */     // GIR_Coverage, 6333,
     /* 264918 */     GIR_EraseRootFromParent_Done,
     /* 264919 */   // Label 5298: @264919
     /* 264919 */   GIM_Reject,
     /* 264920 */ // Label 5296: @264920
     /* 264920 */ GIM_Reject,
     /* 264921 */ // Label 5277: @264921
     /* 264921 */ GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(264982),
     /* 264926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 264929 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264933 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(264960), // Rule ID 6341 //
     /* 264938 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 264945 */     // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 264945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
     /* 264948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264950 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 264955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264958 */     GIR_RootConstrainSelectedInstOperands,
     /* 264959 */     // GIR_Coverage, 6341,
     /* 264959 */     GIR_EraseRootFromParent_Done,
     /* 264960 */   // Label 5300: @264960
     /* 264960 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(264981), // Rule ID 6330 //
     /* 264965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 264969 */     // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 264969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 264972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 264974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 264976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 264979 */     GIR_RootConstrainSelectedInstOperands,
     /* 264980 */     // GIR_Coverage, 6330,
     /* 264980 */     GIR_EraseRootFromParent_Done,
     /* 264981 */   // Label 5301: @264981
     /* 264981 */   GIM_Reject,
     /* 264982 */ // Label 5299: @264982
     /* 264982 */ GIM_Reject,
     /* 264983 */ // Label 5278: @264983
     /* 264983 */ GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(265044),
     /* 264988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 264991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 264995 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(265022), // Rule ID 6338 //
     /* 265000 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 265007 */     // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 265007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
     /* 265010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 265017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265020 */     GIR_RootConstrainSelectedInstOperands,
     /* 265021 */     // GIR_Coverage, 6338,
     /* 265021 */     GIR_EraseRootFromParent_Done,
     /* 265022 */   // Label 5303: @265022
     /* 265022 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(265043), // Rule ID 6327 //
     /* 265027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 265031 */     // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 265031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 265034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 265038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265041 */     GIR_RootConstrainSelectedInstOperands,
     /* 265042 */     // GIR_Coverage, 6327,
     /* 265042 */     GIR_EraseRootFromParent_Done,
     /* 265043 */   // Label 5304: @265043
     /* 265043 */   GIM_Reject,
     /* 265044 */ // Label 5302: @265044
     /* 265044 */ GIM_Reject,
     /* 265045 */ // Label 5279: @265045
     /* 265045 */ GIM_Reject,
     /* 265046 */ // Label 42: @265046
     /* 265046 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5310*/ GIMT_Encode4(266699),
     /* 265057 */ /*GILLT_s32*//*Label 5305*/ GIMT_Encode4(265137),
     /* 265061 */ /*GILLT_s64*//*Label 5306*/ GIMT_Encode4(265631), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 265113 */ /*GILLT_nxv2s64*//*Label 5307*/ GIMT_Encode4(266273), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 265125 */ /*GILLT_nxv4s32*//*Label 5308*/ GIMT_Encode4(266482), GIMT_Encode4(0),
     /* 265133 */ /*GILLT_nxv8s16*//*Label 5309*/ GIMT_Encode4(266626),
     /* 265137 */ // Label 5305: @265137
     /* 265137 */ GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(265630),
     /* 265142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 265145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265149 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(265214), // Rule ID 5635 //
     /* 265154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 265166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 265179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265183 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 265187 */     // MIs[2] Operand 1
     /* 265187 */     // No operand predicates
     /* 265187 */     // MIs[0] Operand 2
     /* 265187 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265200 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 265200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 265203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 265209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 265212 */     GIR_RootConstrainSelectedInstOperands,
     /* 265213 */     // GIR_Coverage, 5635,
     /* 265213 */     GIR_EraseRootFromParent_Done,
     /* 265214 */   // Label 5312: @265214
     /* 265214 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(265279), // Rule ID 5637 //
     /* 265219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 265231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 265244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265248 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 265252 */     // MIs[2] Operand 1
     /* 265252 */     // No operand predicates
     /* 265252 */     // MIs[0] Operand 2
     /* 265252 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265265 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 265265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 265268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 265274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 265277 */     GIR_RootConstrainSelectedInstOperands,
     /* 265278 */     // GIR_Coverage, 5637,
     /* 265278 */     GIR_EraseRootFromParent_Done,
     /* 265279 */   // Label 5313: @265279
     /* 265279 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(265344), // Rule ID 5639 //
     /* 265284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 265296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 265309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265313 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 265317 */     // MIs[2] Operand 1
     /* 265317 */     // No operand predicates
     /* 265317 */     // MIs[0] Operand 2
     /* 265317 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265330 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 265330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 265333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 265339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 265342 */     GIR_RootConstrainSelectedInstOperands,
     /* 265343 */     // GIR_Coverage, 5639,
     /* 265343 */     GIR_EraseRootFromParent_Done,
     /* 265344 */   // Label 5314: @265344
     /* 265344 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(265434), // Rule ID 11165 //
     /* 265349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 265352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 265364 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 265372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265376 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 265380 */     // MIs[2] Operand 1
     /* 265380 */     // No operand predicates
     /* 265380 */     // MIs[0] Operand 2
     /* 265380 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265393 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 265393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265405 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 265411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 265424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 265432 */     GIR_RootConstrainSelectedInstOperands,
     /* 265433 */     // GIR_Coverage, 11165,
     /* 265433 */     GIR_EraseRootFromParent_Done,
     /* 265434 */   // Label 5315: @265434
     /* 265434 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(265524), // Rule ID 11167 //
     /* 265439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 265442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 265454 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 265458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 265462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265466 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 265470 */     // MIs[2] Operand 1
     /* 265470 */     // No operand predicates
     /* 265470 */     // MIs[0] Operand 2
     /* 265470 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265481 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 265483 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 265483 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 265486 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265490 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265495 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 265501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 265514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 265522 */     GIR_RootConstrainSelectedInstOperands,
     /* 265523 */     // GIR_Coverage, 11167,
     /* 265523 */     GIR_EraseRootFromParent_Done,
     /* 265524 */   // Label 5316: @265524
     /* 265524 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(265559), // Rule ID 6477 //
     /* 265529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265533 */     // MIs[0] Operand 2
     /* 265533 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265544 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 265544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 265547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265549 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 265557 */     GIR_RootConstrainSelectedInstOperands,
     /* 265558 */     // GIR_Coverage, 6477,
     /* 265558 */     GIR_EraseRootFromParent_Done,
     /* 265559 */   // Label 5317: @265559
     /* 265559 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(265594), // Rule ID 6478 //
     /* 265564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265568 */     // MIs[0] Operand 2
     /* 265568 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265579 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 265579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 265582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265584 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 265592 */     GIR_RootConstrainSelectedInstOperands,
     /* 265593 */     // GIR_Coverage, 6478,
     /* 265593 */     GIR_EraseRootFromParent_Done,
     /* 265594 */   // Label 5318: @265594
     /* 265594 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(265629), // Rule ID 6479 //
     /* 265599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 265603 */     // MIs[0] Operand 2
     /* 265603 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 265614 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 265614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 265617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265619 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 265621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 265627 */     GIR_RootConstrainSelectedInstOperands,
     /* 265628 */     // GIR_Coverage, 6479,
     /* 265628 */     GIR_EraseRootFromParent_Done,
     /* 265629 */   // Label 5319: @265629
     /* 265629 */   GIM_Reject,
     /* 265630 */ // Label 5311: @265630
     /* 265630 */ GIM_Reject,
     /* 265631 */ // Label 5306: @265631
     /* 265631 */ GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(266272),
     /* 265636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 265639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 265643 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(265720), // Rule ID 5641 //
     /* 265648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 265656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 265664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265668 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 265672 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 265676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265681 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 265685 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265689 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 265693 */     // MIs[3] Operand 1
     /* 265693 */     // No operand predicates
     /* 265693 */     // MIs[0] Operand 2
     /* 265693 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265704 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 265706 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 265706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 265709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 265715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 265718 */     GIR_RootConstrainSelectedInstOperands,
     /* 265719 */     // GIR_Coverage, 5641,
     /* 265719 */     GIR_EraseRootFromParent_Done,
     /* 265720 */   // Label 5321: @265720
     /* 265720 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(265797), // Rule ID 5642 //
     /* 265725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 265733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 265741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 265749 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 265753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265758 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 265762 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265766 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 265770 */     // MIs[3] Operand 1
     /* 265770 */     // No operand predicates
     /* 265770 */     // MIs[0] Operand 2
     /* 265770 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265781 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 265783 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 265783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 265786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 265792 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 265795 */     GIR_RootConstrainSelectedInstOperands,
     /* 265796 */     // GIR_Coverage, 5642,
     /* 265796 */     GIR_EraseRootFromParent_Done,
     /* 265797 */   // Label 5322: @265797
     /* 265797 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(265899), // Rule ID 11166 //
     /* 265802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 265805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 265813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265817 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 265821 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265825 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 265829 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 265833 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 265837 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265841 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 265845 */     // MIs[3] Operand 1
     /* 265845 */     // No operand predicates
     /* 265845 */     // MIs[0] Operand 2
     /* 265845 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 265856 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 265858 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 265858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 265861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265870 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 265876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 265889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 265897 */     GIR_RootConstrainSelectedInstOperands,
     /* 265898 */     // GIR_Coverage, 11166,
     /* 265898 */     GIR_EraseRootFromParent_Done,
     /* 265899 */   // Label 5323: @265899
     /* 265899 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(266001), // Rule ID 11168 //
     /* 265904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 265907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 265915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 265919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 265923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 265927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 265931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 265935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 265939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265943 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 265947 */     // MIs[3] Operand 1
     /* 265947 */     // No operand predicates
     /* 265947 */     // MIs[0] Operand 2
     /* 265947 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 265958 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 265960 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 265960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 265963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 265967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 265972 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 265978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 265983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 265991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 265993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 265996 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 265999 */     GIR_RootConstrainSelectedInstOperands,
     /* 266000 */     // GIR_Coverage, 11168,
     /* 266000 */     GIR_EraseRootFromParent_Done,
     /* 266001 */   // Label 5324: @266001
     /* 266001 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(266066), // Rule ID 5636 //
     /* 266006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 266014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 266018 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 266022 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 266031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266035 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 266039 */     // MIs[2] Operand 1
     /* 266039 */     // No operand predicates
     /* 266039 */     // MIs[0] Operand 2
     /* 266039 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 266050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 266052 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 266052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 266055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 266061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 266064 */     GIR_RootConstrainSelectedInstOperands,
     /* 266065 */     // GIR_Coverage, 5636,
     /* 266065 */     GIR_EraseRootFromParent_Done,
     /* 266066 */   // Label 5325: @266066
     /* 266066 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(266131), // Rule ID 5638 //
     /* 266071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 266079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 266083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 266087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 266096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 266100 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 266104 */     // MIs[2] Operand 1
     /* 266104 */     // No operand predicates
     /* 266104 */     // MIs[0] Operand 2
     /* 266104 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 266115 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 266117 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 266117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 266120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 266126 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 266129 */     GIR_RootConstrainSelectedInstOperands,
     /* 266130 */     // GIR_Coverage, 5638,
     /* 266130 */     GIR_EraseRootFromParent_Done,
     /* 266131 */   // Label 5326: @266131
     /* 266131 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(266166), // Rule ID 6473 //
     /* 266136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266140 */     // MIs[0] Operand 2
     /* 266140 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 266151 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 266151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 266154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266156 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 266158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 266164 */     GIR_RootConstrainSelectedInstOperands,
     /* 266165 */     // GIR_Coverage, 6473,
     /* 266165 */     GIR_EraseRootFromParent_Done,
     /* 266166 */   // Label 5327: @266166
     /* 266166 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(266201), // Rule ID 6474 //
     /* 266171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266175 */     // MIs[0] Operand 2
     /* 266175 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 266186 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 266186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 266189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266191 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 266193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 266199 */     GIR_RootConstrainSelectedInstOperands,
     /* 266200 */     // GIR_Coverage, 6474,
     /* 266200 */     GIR_EraseRootFromParent_Done,
     /* 266201 */   // Label 5328: @266201
     /* 266201 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(266236), // Rule ID 6475 //
     /* 266206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266210 */     // MIs[0] Operand 2
     /* 266210 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 266221 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 266221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 266224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266226 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 266228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 266234 */     GIR_RootConstrainSelectedInstOperands,
     /* 266235 */     // GIR_Coverage, 6475,
     /* 266235 */     GIR_EraseRootFromParent_Done,
     /* 266236 */   // Label 5329: @266236
     /* 266236 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(266271), // Rule ID 6476 //
     /* 266241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266245 */     // MIs[0] Operand 2
     /* 266245 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 266256 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 266256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 266259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266261 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 266263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266269 */     GIR_RootConstrainSelectedInstOperands,
     /* 266270 */     // GIR_Coverage, 6476,
     /* 266270 */     GIR_EraseRootFromParent_Done,
     /* 266271 */   // Label 5330: @266271
     /* 266271 */   GIM_Reject,
     /* 266272 */ // Label 5320: @266272
     /* 266272 */ GIM_Reject,
     /* 266273 */ // Label 5307: @266273
     /* 266273 */ GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(266481),
     /* 266278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 266281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266285 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(266350), // Rule ID 10449 //
     /* 266290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266293 */     // MIs[0] Operand 2
     /* 266293 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 266304 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 266304 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 266307 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 266311 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266316 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 266319 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 266324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
     /* 266338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266340 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 266346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 266348 */     GIR_RootConstrainSelectedInstOperands,
     /* 266349 */     // GIR_Coverage, 10449,
     /* 266349 */     GIR_EraseRootFromParent_Done,
     /* 266350 */   // Label 5332: @266350
     /* 266350 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(266415), // Rule ID 10450 //
     /* 266355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266358 */     // MIs[0] Operand 2
     /* 266358 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 266369 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 266369 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 266372 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 266376 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266381 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 266384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 266389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266398 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
     /* 266403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266405 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 266411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 266413 */     GIR_RootConstrainSelectedInstOperands,
     /* 266414 */     // GIR_Coverage, 10450,
     /* 266414 */     GIR_EraseRootFromParent_Done,
     /* 266415 */   // Label 5333: @266415
     /* 266415 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(266480), // Rule ID 10451 //
     /* 266420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266423 */     // MIs[0] Operand 2
     /* 266423 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 266434 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 266434 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 266437 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 266441 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266446 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 266449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 266454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
     /* 266468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 266476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 266478 */     GIR_RootConstrainSelectedInstOperands,
     /* 266479 */     // GIR_Coverage, 10451,
     /* 266479 */     GIR_EraseRootFromParent_Done,
     /* 266480 */   // Label 5334: @266480
     /* 266480 */   GIM_Reject,
     /* 266481 */ // Label 5331: @266481
     /* 266481 */ GIM_Reject,
     /* 266482 */ // Label 5308: @266482
     /* 266482 */ GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(266625),
     /* 266487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 266490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266494 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(266559), // Rule ID 10452 //
     /* 266499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266502 */     // MIs[0] Operand 2
     /* 266502 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 266513 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 266513 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 266516 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 266520 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266525 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 266528 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266530 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 266533 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266537 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
     /* 266547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 266555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 266557 */     GIR_RootConstrainSelectedInstOperands,
     /* 266558 */     // GIR_Coverage, 10452,
     /* 266558 */     GIR_EraseRootFromParent_Done,
     /* 266559 */   // Label 5336: @266559
     /* 266559 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(266624), // Rule ID 10453 //
     /* 266564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266567 */     // MIs[0] Operand 2
     /* 266567 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 266578 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 266578 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 266581 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 266585 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266590 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 266593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266595 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 266598 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266602 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
     /* 266612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 266620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 266622 */     GIR_RootConstrainSelectedInstOperands,
     /* 266623 */     // GIR_Coverage, 10453,
     /* 266623 */     GIR_EraseRootFromParent_Done,
     /* 266624 */   // Label 5337: @266624
     /* 266624 */   GIM_Reject,
     /* 266625 */ // Label 5335: @266625
     /* 266625 */ GIM_Reject,
     /* 266626 */ // Label 5309: @266626
     /* 266626 */ GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(266698), // Rule ID 10454 //
     /* 266631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 266634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 266637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 266641 */   // MIs[0] Operand 2
     /* 266641 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 266652 */   // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
     /* 266652 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 266655 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 266659 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266664 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 266667 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 266669 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 266672 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266676 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266681 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266683 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
     /* 266686 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 266688 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266691 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 266694 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 266696 */   GIR_RootConstrainSelectedInstOperands,
     /* 266697 */   // GIR_Coverage, 10454,
     /* 266697 */   GIR_EraseRootFromParent_Done,
     /* 266698 */ // Label 5338: @266698
     /* 266698 */ GIM_Reject,
     /* 266699 */ // Label 5310: @266699
     /* 266699 */ GIM_Reject,
     /* 266700 */ // Label 43: @266700
     /* 266700 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5343*/ GIMT_Encode4(269478),
     /* 266711 */ /*GILLT_s32*//*Label 5339*/ GIMT_Encode4(266747), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 266727 */ /*GILLT_v2s64*//*Label 5340*/ GIMT_Encode4(268548), GIMT_Encode4(0),
     /* 266735 */ /*GILLT_v4s32*//*Label 5341*/ GIMT_Encode4(268858), GIMT_Encode4(0),
     /* 266743 */ /*GILLT_v8s16*//*Label 5342*/ GIMT_Encode4(269168),
     /* 266747 */ // Label 5339: @266747
     /* 266747 */ GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(266897), // Rule ID 13064 //
     /* 266752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 266755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266759 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266763 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266767 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266770 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 266775 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 266779 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266784 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266786 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266786 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 266789 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 266793 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266798 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266804 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266807 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266811 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266816 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266818 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266821 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266825 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266830 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266833 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266836 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 266839 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266844 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266849 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 266854 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266857 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266861 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266866 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 266873 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 266878 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 266886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266888 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266891 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266896 */   // GIR_Coverage, 13064,
     /* 266896 */   GIR_EraseRootFromParent_Done,
     /* 266897 */ // Label 5344: @266897
     /* 266897 */ GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(267047), // Rule ID 13066 //
     /* 266902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 266905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266909 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 266913 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 266917 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 266920 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 266925 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 266929 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266934 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 266936 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 266936 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 266939 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 266943 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266948 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 266952 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 266954 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 266957 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 266961 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 266968 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 266971 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 266975 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266980 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 266983 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 266986 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 266989 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266994 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266999 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 267004 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267007 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267011 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267016 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267023 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267028 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267038 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267041 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267046 */   // GIR_Coverage, 13066,
     /* 267046 */   GIR_EraseRootFromParent_Done,
     /* 267047 */ // Label 5345: @267047
     /* 267047 */ GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(267197), // Rule ID 13068 //
     /* 267052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 267055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267059 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267063 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267067 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267070 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 267075 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 267079 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267084 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267086 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267086 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 267089 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 267093 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267098 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267102 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267104 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267107 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267111 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267116 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267118 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267121 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267125 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267130 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267133 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267136 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 267139 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267144 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267149 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 267154 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267157 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267161 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267166 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267173 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267178 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267183 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267186 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267188 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267191 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267196 */   // GIR_Coverage, 13068,
     /* 267196 */   GIR_EraseRootFromParent_Done,
     /* 267197 */ // Label 5346: @267197
     /* 267197 */ GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(267347), // Rule ID 13070 //
     /* 267202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 267205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267209 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267213 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267217 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267220 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 267225 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 267229 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267234 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267236 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 727:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267236 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 267239 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 267243 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267248 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267252 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267254 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267257 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267261 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267268 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267271 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267275 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267280 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267283 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267286 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 267289 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267294 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267299 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 267304 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267307 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267311 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267316 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267323 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267328 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267333 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267336 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267338 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267341 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267346 */   // GIR_Coverage, 13070,
     /* 267346 */   GIR_EraseRootFromParent_Done,
     /* 267347 */ // Label 5347: @267347
     /* 267347 */ GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(267497), // Rule ID 13097 //
     /* 267352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 267355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267359 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267363 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267367 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267370 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 267375 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 267379 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267384 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267386 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267386 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 267389 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 267393 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267398 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267402 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267404 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267407 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267411 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267416 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267418 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267421 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267425 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267430 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267433 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267436 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 267439 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267444 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267449 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 267454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267466 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267473 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267478 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267488 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267491 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267496 */   // GIR_Coverage, 13097,
     /* 267496 */   GIR_EraseRootFromParent_Done,
     /* 267497 */ // Label 5348: @267497
     /* 267497 */ GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(267647), // Rule ID 13099 //
     /* 267502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 267505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267509 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267513 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267517 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267520 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 267525 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 267529 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267534 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267536 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 733:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267536 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 267539 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 267543 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267548 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267552 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267554 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267557 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267561 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267566 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267568 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267571 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267575 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267580 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267583 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267586 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 267589 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267594 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267599 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 267604 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267607 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267611 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267616 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267623 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267628 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267638 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267641 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267646 */   // GIR_Coverage, 13099,
     /* 267646 */   GIR_EraseRootFromParent_Done,
     /* 267647 */ // Label 5349: @267647
     /* 267647 */ GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(267797), // Rule ID 13101 //
     /* 267652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 267655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267659 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267663 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267667 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267670 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 267675 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 267679 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267684 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267686 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267686 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 267689 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 267693 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267698 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267702 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267704 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267707 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267711 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267718 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267721 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267725 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267730 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267733 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267736 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 267739 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267744 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267749 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 267754 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267757 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267761 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267766 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267773 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267778 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267788 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267791 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267796 */   // GIR_Coverage, 13101,
     /* 267796 */   GIR_EraseRootFromParent_Done,
     /* 267797 */ // Label 5350: @267797
     /* 267797 */ GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(267947), // Rule ID 13103 //
     /* 267802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 267805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267809 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267813 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267817 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267820 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 267825 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 267829 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267834 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267836 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 733:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267836 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 267839 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 267843 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267848 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 267852 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 267854 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 267857 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 267861 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267866 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 267868 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 267871 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 267875 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267880 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 267883 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 267886 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 267889 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267894 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267899 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 267904 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267907 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267911 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267916 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 267923 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 267928 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 267938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267946 */   // GIR_Coverage, 13103,
     /* 267946 */   GIR_EraseRootFromParent_Done,
     /* 267947 */ // Label 5351: @267947
     /* 267947 */ GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(268097), // Rule ID 13107 //
     /* 267952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 267955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267959 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 267963 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 267967 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 267970 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 267975 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 267979 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267984 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267986 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 267986 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 267989 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 267993 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267998 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268002 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 268004 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 268007 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268011 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268016 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 268018 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 268021 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 268025 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268030 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 268033 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 268036 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 268039 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268044 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268049 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 268054 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268057 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268061 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268066 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 268073 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 268078 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268083 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268086 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268088 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268096 */   // GIR_Coverage, 13107,
     /* 268096 */   GIR_EraseRootFromParent_Done,
     /* 268097 */ // Label 5352: @268097
     /* 268097 */ GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(268247), // Rule ID 13109 //
     /* 268102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 268105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268109 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268113 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268117 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 268120 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 268125 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 268129 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268134 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268136 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 736:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 268136 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 268139 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 268143 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268148 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268152 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 268154 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 268157 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268161 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268166 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 268168 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 268171 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 268175 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268180 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 268183 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 268186 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 268189 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268194 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268199 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 268204 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268207 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268211 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268216 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 268223 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 268228 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268238 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268241 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268246 */   // GIR_Coverage, 13109,
     /* 268246 */   GIR_EraseRootFromParent_Done,
     /* 268247 */ // Label 5353: @268247
     /* 268247 */ GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(268397), // Rule ID 13111 //
     /* 268252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 268255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268259 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268263 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268267 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 268270 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 268275 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268279 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268284 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268286 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 268286 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 268289 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 268293 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268298 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268302 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 268304 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 268307 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268311 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268316 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 268318 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 268321 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 268325 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268330 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 268333 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 268336 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 268339 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268344 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268349 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 268354 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268357 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268361 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268366 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 268373 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 268378 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268388 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268391 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268396 */   // GIR_Coverage, 13111,
     /* 268396 */   GIR_EraseRootFromParent_Done,
     /* 268397 */ // Label 5354: @268397
     /* 268397 */ GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(268547), // Rule ID 13113 //
     /* 268402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 268405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268409 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268413 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268417 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 268420 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 268425 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 268429 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268434 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268436 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 736:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 268436 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 268439 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 268443 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268448 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268452 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 268454 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 268457 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 268461 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268466 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 268468 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 268471 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 268475 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268480 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 268483 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 268486 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 268489 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268494 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268499 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 268504 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268507 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268511 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268516 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 268523 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 268528 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268533 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268536 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 268538 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268541 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268546 */   // GIR_Coverage, 13113,
     /* 268546 */   GIR_EraseRootFromParent_Done,
     /* 268547 */ // Label 5355: @268547
     /* 268547 */ GIM_Reject,
     /* 268548 */ // Label 5340: @268548
     /* 268548 */ GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(268857),
     /* 268553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 268556 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268560 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(268625), // Rule ID 702 //
     /* 268565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268576 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268579 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 268588 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 268592 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268594 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 268601 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 268608 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 268608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 268611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268623 */     GIR_RootConstrainSelectedInstOperands,
     /* 268624 */     // GIR_Coverage, 702,
     /* 268624 */     GIR_EraseRootFromParent_Done,
     /* 268625 */   // Label 5357: @268625
     /* 268625 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(268690), // Rule ID 1711 //
     /* 268630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268641 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268644 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 268653 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 268657 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268659 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 268666 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 268673 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 268673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
     /* 268676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268688 */     GIR_RootConstrainSelectedInstOperands,
     /* 268689 */     // GIR_Coverage, 1711,
     /* 268689 */     GIR_EraseRootFromParent_Done,
     /* 268690 */   // Label 5358: @268690
     /* 268690 */   GIM_Try, /*On fail goto*//*Label 5359*/ GIMT_Encode4(268749), // Rule ID 700 //
     /* 268695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268706 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268709 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 268718 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 268722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268732 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268734 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 724:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 268734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 268737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 268747 */     GIR_RootConstrainSelectedInstOperands,
     /* 268748 */     // GIR_Coverage, 700,
     /* 268748 */     GIR_EraseRootFromParent_Done,
     /* 268749 */   // Label 5359: @268749
     /* 268749 */   GIM_Try, /*On fail goto*//*Label 5360*/ GIMT_Encode4(268808), // Rule ID 1709 //
     /* 268754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268765 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268768 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 268777 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 268781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268786 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268793 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 659:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 268793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
     /* 268796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 268802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 268806 */     GIR_RootConstrainSelectedInstOperands,
     /* 268807 */     // GIR_Coverage, 1709,
     /* 268807 */     GIR_EraseRootFromParent_Done,
     /* 268808 */   // Label 5360: @268808
     /* 268808 */   GIM_Try, /*On fail goto*//*Label 5361*/ GIMT_Encode4(268835), // Rule ID 6343 //
     /* 268813 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 268820 */     // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 268820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 268823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268833 */     GIR_RootConstrainSelectedInstOperands,
     /* 268834 */     // GIR_Coverage, 6343,
     /* 268834 */     GIR_EraseRootFromParent_Done,
     /* 268835 */   // Label 5361: @268835
     /* 268835 */   GIM_Try, /*On fail goto*//*Label 5362*/ GIMT_Encode4(268856), // Rule ID 6334 //
     /* 268840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 268844 */     // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 268844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 268847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268849 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 268851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 268854 */     GIR_RootConstrainSelectedInstOperands,
     /* 268855 */     // GIR_Coverage, 6334,
     /* 268855 */     GIR_EraseRootFromParent_Done,
     /* 268856 */   // Label 5362: @268856
     /* 268856 */   GIM_Reject,
     /* 268857 */ // Label 5356: @268857
     /* 268857 */ GIM_Reject,
     /* 268858 */ // Label 5341: @268858
     /* 268858 */ GIM_Try, /*On fail goto*//*Label 5363*/ GIMT_Encode4(269167),
     /* 268863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 268866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 268870 */   GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(268935), // Rule ID 698 //
     /* 268875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268886 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268889 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 268894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268898 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 268902 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268904 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 268911 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 268918 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 268921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268933 */     GIR_RootConstrainSelectedInstOperands,
     /* 268934 */     // GIR_Coverage, 698,
     /* 268934 */     GIR_EraseRootFromParent_Done,
     /* 268935 */   // Label 5364: @268935
     /* 268935 */   GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(269000), // Rule ID 1707 //
     /* 268940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 268943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 268947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 268951 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 268954 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 268959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 268963 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 268967 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268969 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 268976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 268983 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 268983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
     /* 268986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 268988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 268993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 268998 */     GIR_RootConstrainSelectedInstOperands,
     /* 268999 */     // GIR_Coverage, 1707,
     /* 268999 */     GIR_EraseRootFromParent_Done,
     /* 269000 */   // Label 5365: @269000
     /* 269000 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(269059), // Rule ID 696 //
     /* 269005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 269008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269016 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 269019 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 269024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 269028 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 269032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269044 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 724:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 269044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 269047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 269057 */     GIR_RootConstrainSelectedInstOperands,
     /* 269058 */     // GIR_Coverage, 696,
     /* 269058 */     GIR_EraseRootFromParent_Done,
     /* 269059 */   // Label 5366: @269059
     /* 269059 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(269118), // Rule ID 1705 //
     /* 269064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 269067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269075 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 269078 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 269083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 269087 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 269091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269103 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 659:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 269103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
     /* 269106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 269116 */     GIR_RootConstrainSelectedInstOperands,
     /* 269117 */     // GIR_Coverage, 1705,
     /* 269117 */     GIR_EraseRootFromParent_Done,
     /* 269118 */   // Label 5367: @269118
     /* 269118 */   GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(269145), // Rule ID 6340 //
     /* 269123 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 269130 */     // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 269130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 269133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269135 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 269140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269143 */     GIR_RootConstrainSelectedInstOperands,
     /* 269144 */     // GIR_Coverage, 6340,
     /* 269144 */     GIR_EraseRootFromParent_Done,
     /* 269145 */   // Label 5368: @269145
     /* 269145 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(269166), // Rule ID 6331 //
     /* 269150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269154 */     // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 269154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 269157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269159 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269161 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269164 */     GIR_RootConstrainSelectedInstOperands,
     /* 269165 */     // GIR_Coverage, 6331,
     /* 269165 */     GIR_EraseRootFromParent_Done,
     /* 269166 */   // Label 5369: @269166
     /* 269166 */   GIM_Reject,
     /* 269167 */ // Label 5363: @269167
     /* 269167 */ GIM_Reject,
     /* 269168 */ // Label 5342: @269168
     /* 269168 */ GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(269477),
     /* 269173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 269176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269180 */   GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(269245), // Rule ID 694 //
     /* 269185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 269188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269196 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 269199 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 269204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 269208 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 269212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269214 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 269221 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 269228 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 269228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 269231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269233 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 269238 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 269243 */     GIR_RootConstrainSelectedInstOperands,
     /* 269244 */     // GIR_Coverage, 694,
     /* 269244 */     GIR_EraseRootFromParent_Done,
     /* 269245 */   // Label 5371: @269245
     /* 269245 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(269310), // Rule ID 1703 //
     /* 269250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 269253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269261 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 269264 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 269269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 269273 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 269277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 269286 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 269293 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 269293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
     /* 269296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269298 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 269303 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 269308 */     GIR_RootConstrainSelectedInstOperands,
     /* 269309 */     // GIR_Coverage, 1703,
     /* 269309 */     GIR_EraseRootFromParent_Done,
     /* 269310 */   // Label 5372: @269310
     /* 269310 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(269369), // Rule ID 692 //
     /* 269315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 269318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269326 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 269329 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 269334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 269338 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 269342 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269352 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269354 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 724:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 269354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 269357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 269367 */     GIR_RootConstrainSelectedInstOperands,
     /* 269368 */     // GIR_Coverage, 692,
     /* 269368 */     GIR_EraseRootFromParent_Done,
     /* 269369 */   // Label 5373: @269369
     /* 269369 */   GIM_Try, /*On fail goto*//*Label 5374*/ GIMT_Encode4(269428), // Rule ID 1701 //
     /* 269374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 269377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 269385 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 269388 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 269393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 269397 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 269401 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269411 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269413 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 659:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 269413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
     /* 269416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 269422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 269426 */     GIR_RootConstrainSelectedInstOperands,
     /* 269427 */     // GIR_Coverage, 1701,
     /* 269427 */     GIR_EraseRootFromParent_Done,
     /* 269428 */   // Label 5374: @269428
     /* 269428 */   GIM_Try, /*On fail goto*//*Label 5375*/ GIMT_Encode4(269455), // Rule ID 6337 //
     /* 269433 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 269440 */     // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 269440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 269443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 269450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269453 */     GIR_RootConstrainSelectedInstOperands,
     /* 269454 */     // GIR_Coverage, 6337,
     /* 269454 */     GIR_EraseRootFromParent_Done,
     /* 269455 */   // Label 5375: @269455
     /* 269455 */   GIM_Try, /*On fail goto*//*Label 5376*/ GIMT_Encode4(269476), // Rule ID 6328 //
     /* 269460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269464 */     // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 269464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 269467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269474 */     GIR_RootConstrainSelectedInstOperands,
     /* 269475 */     // GIR_Coverage, 6328,
     /* 269475 */     GIR_EraseRootFromParent_Done,
     /* 269476 */   // Label 5376: @269476
     /* 269476 */   GIM_Reject,
     /* 269477 */ // Label 5370: @269477
     /* 269477 */ GIM_Reject,
     /* 269478 */ // Label 5343: @269478
     /* 269478 */ GIM_Reject,
     /* 269479 */ // Label 44: @269479
     /* 269479 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5382*/ GIMT_Encode4(270258),
     /* 269490 */ /*GILLT_s32*//*Label 5377*/ GIMT_Encode4(269526),
     /* 269494 */ /*GILLT_s64*//*Label 5378*/ GIMT_Encode4(269658), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 269506 */ /*GILLT_v2s64*//*Label 5379*/ GIMT_Encode4(269831), GIMT_Encode4(0),
     /* 269514 */ /*GILLT_v4s32*//*Label 5380*/ GIMT_Encode4(269976), GIMT_Encode4(0),
     /* 269522 */ /*GILLT_v8s16*//*Label 5381*/ GIMT_Encode4(270117),
     /* 269526 */ // Label 5377: @269526
     /* 269526 */ GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(269657),
     /* 269531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 269534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269541 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269545 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(269582), // Rule ID 3923 //
     /* 269550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 269558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269569 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 269572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269580 */     GIR_RootConstrainSelectedInstOperands,
     /* 269581 */     // GIR_Coverage, 3923,
     /* 269581 */     GIR_EraseRootFromParent_Done,
     /* 269582 */   // Label 5384: @269582
     /* 269582 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(269619), // Rule ID 3924 //
     /* 269587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269599 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269604 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269606 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 269609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269611 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269617 */     GIR_RootConstrainSelectedInstOperands,
     /* 269618 */     // GIR_Coverage, 3924,
     /* 269618 */     GIR_EraseRootFromParent_Done,
     /* 269619 */   // Label 5385: @269619
     /* 269619 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(269656), // Rule ID 3922 //
     /* 269624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269643 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 269643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 269646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269654 */     GIR_RootConstrainSelectedInstOperands,
     /* 269655 */     // GIR_Coverage, 3922,
     /* 269655 */     GIR_EraseRootFromParent_Done,
     /* 269656 */   // Label 5386: @269656
     /* 269656 */   GIM_Reject,
     /* 269657 */ // Label 5383: @269657
     /* 269657 */ GIM_Reject,
     /* 269658 */ // Label 5378: @269658
     /* 269658 */ GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(269830),
     /* 269663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 269666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 269669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269677 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(269745), // Rule ID 3925 //
     /* 269682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269701 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 269701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 269704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 269708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269713 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 269716 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269720 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 269723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 269728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 269736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269738 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269743 */     GIR_RootConstrainSelectedInstOperands,
     /* 269744 */     // GIR_Coverage, 3925,
     /* 269744 */     GIR_EraseRootFromParent_Done,
     /* 269745 */   // Label 5388: @269745
     /* 269745 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(269813), // Rule ID 3926 //
     /* 269750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 269754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 269762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 269769 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 269769 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 269772 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 269776 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 269781 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 269784 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269788 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 269791 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 269796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 269801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 269804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269806 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 269808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 269811 */     GIR_RootConstrainSelectedInstOperands,
     /* 269812 */     // GIR_Coverage, 3926,
     /* 269812 */     GIR_EraseRootFromParent_Done,
     /* 269813 */   // Label 5389: @269813
     /* 269813 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(269829), // Rule ID 120 //
     /* 269818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269822 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 269822 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 269827 */     GIR_RootConstrainSelectedInstOperands,
     /* 269828 */     // GIR_Coverage, 120,
     /* 269828 */     GIR_Done,
     /* 269829 */   // Label 5390: @269829
     /* 269829 */   GIM_Reject,
     /* 269830 */ // Label 5387: @269830
     /* 269830 */ GIM_Reject,
     /* 269831 */ // Label 5379: @269831
     /* 269831 */ GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(269975),
     /* 269836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 269839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 269842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269846 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(269910), // Rule ID 6326 //
     /* 269851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 269859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 269863 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269868 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269872 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 269876 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 269880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 269884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269888 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 269892 */     // MIs[3] Operand 1
     /* 269892 */     // No operand predicates
     /* 269892 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 269894 */     // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 269894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 269897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269903 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 269908 */     GIR_RootConstrainSelectedInstOperands,
     /* 269909 */     // GIR_Coverage, 6326,
     /* 269909 */     GIR_EraseRootFromParent_Done,
     /* 269910 */   // Label 5392: @269910
     /* 269910 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(269974), // Rule ID 6323 //
     /* 269915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 269919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 269923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 269927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 269932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 269936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 269940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 269944 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 269948 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 269952 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 269956 */     // MIs[3] Operand 1
     /* 269956 */     // No operand predicates
     /* 269956 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 269958 */     // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 269958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 269961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 269963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 269967 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 269972 */     GIR_RootConstrainSelectedInstOperands,
     /* 269973 */     // GIR_Coverage, 6323,
     /* 269973 */     GIR_EraseRootFromParent_Done,
     /* 269974 */   // Label 5393: @269974
     /* 269974 */   GIM_Reject,
     /* 269975 */ // Label 5391: @269975
     /* 269975 */ GIM_Reject,
     /* 269976 */ // Label 5380: @269976
     /* 269976 */ GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(270116),
     /* 269981 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 269984 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 269987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 269991 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(270053), // Rule ID 6325 //
     /* 269996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 270008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 270021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 270025 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 270029 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270033 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 270037 */     // MIs[3] Operand 1
     /* 270037 */     // No operand predicates
     /* 270037 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 270039 */     // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 270039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 270042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 270051 */     GIR_RootConstrainSelectedInstOperands,
     /* 270052 */     // GIR_Coverage, 6325,
     /* 270052 */     GIR_EraseRootFromParent_Done,
     /* 270053 */   // Label 5395: @270053
     /* 270053 */   GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(270115), // Rule ID 6322 //
     /* 270058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 270070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 270083 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 270087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 270091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270095 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 270099 */     // MIs[3] Operand 1
     /* 270099 */     // No operand predicates
     /* 270099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 270101 */     // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 270101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 270104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270106 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 270113 */     GIR_RootConstrainSelectedInstOperands,
     /* 270114 */     // GIR_Coverage, 6322,
     /* 270114 */     GIR_EraseRootFromParent_Done,
     /* 270115 */   // Label 5396: @270115
     /* 270115 */   GIM_Reject,
     /* 270116 */ // Label 5394: @270116
     /* 270116 */ GIM_Reject,
     /* 270117 */ // Label 5381: @270117
     /* 270117 */ GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(270257),
     /* 270122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 270125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 270128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270132 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(270194), // Rule ID 6324 //
     /* 270137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270141 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270145 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 270149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 270162 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 270166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 270170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270174 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 270178 */     // MIs[3] Operand 1
     /* 270178 */     // No operand predicates
     /* 270178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 270180 */     // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 270180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 270183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 270192 */     GIR_RootConstrainSelectedInstOperands,
     /* 270193 */     // GIR_Coverage, 6324,
     /* 270193 */     GIR_EraseRootFromParent_Done,
     /* 270194 */   // Label 5398: @270194
     /* 270194 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(270256), // Rule ID 6321 //
     /* 270199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 270211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 270224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 270228 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 270232 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270236 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 270240 */     // MIs[3] Operand 1
     /* 270240 */     // No operand predicates
     /* 270240 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 270242 */     // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 270242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 270245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 270254 */     GIR_RootConstrainSelectedInstOperands,
     /* 270255 */     // GIR_Coverage, 6321,
     /* 270255 */     GIR_EraseRootFromParent_Done,
     /* 270256 */   // Label 5399: @270256
     /* 270256 */   GIM_Reject,
     /* 270257 */ // Label 5397: @270257
     /* 270257 */ GIM_Reject,
     /* 270258 */ // Label 5382: @270258
     /* 270258 */ GIM_Reject,
     /* 270259 */ // Label 45: @270259
     /* 270259 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5402*/ GIMT_Encode4(270651),
     /* 270270 */ /*GILLT_s32*//*Label 5400*/ GIMT_Encode4(270278),
     /* 270274 */ /*GILLT_s64*//*Label 5401*/ GIMT_Encode4(270444),
     /* 270278 */ // Label 5400: @270278
     /* 270278 */ GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(270443),
     /* 270283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 270286 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270297 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(270331), // Rule ID 4012 //
     /* 270302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270310 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 270314 */     // MIs[1] Operand 1
     /* 270314 */     // No operand predicates
     /* 270314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270316 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 270316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
     /* 270319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 270329 */     GIR_RootConstrainSelectedInstOperands,
     /* 270330 */     // GIR_Coverage, 4012,
     /* 270330 */     GIR_EraseRootFromParent_Done,
     /* 270331 */   // Label 5404: @270331
     /* 270331 */   GIM_Try, /*On fail goto*//*Label 5405*/ GIMT_Encode4(270368), // Rule ID 3929 //
     /* 270336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 270344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270353 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270355 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 270358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270366 */     GIR_RootConstrainSelectedInstOperands,
     /* 270367 */     // GIR_Coverage, 3929,
     /* 270367 */     GIR_EraseRootFromParent_Done,
     /* 270368 */   // Label 5405: @270368
     /* 270368 */   GIM_Try, /*On fail goto*//*Label 5406*/ GIMT_Encode4(270405), // Rule ID 3930 //
     /* 270373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270392 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 270395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270397 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270403 */     GIR_RootConstrainSelectedInstOperands,
     /* 270404 */     // GIR_Coverage, 3930,
     /* 270404 */     GIR_EraseRootFromParent_Done,
     /* 270405 */   // Label 5406: @270405
     /* 270405 */   GIM_Try, /*On fail goto*//*Label 5407*/ GIMT_Encode4(270442), // Rule ID 3928 //
     /* 270410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270429 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 270432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270440 */     GIR_RootConstrainSelectedInstOperands,
     /* 270441 */     // GIR_Coverage, 3928,
     /* 270441 */     GIR_EraseRootFromParent_Done,
     /* 270442 */   // Label 5407: @270442
     /* 270442 */   GIM_Reject,
     /* 270443 */ // Label 5403: @270443
     /* 270443 */ GIM_Reject,
     /* 270444 */ // Label 5401: @270444
     /* 270444 */ GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(270650),
     /* 270449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 270452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270463 */   GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(270497), // Rule ID 4013 //
     /* 270468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 270480 */     // MIs[1] Operand 1
     /* 270480 */     // No operand predicates
     /* 270480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270482 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 270482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
     /* 270485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 270495 */     GIR_RootConstrainSelectedInstOperands,
     /* 270496 */     // GIR_Coverage, 4013,
     /* 270496 */     GIR_EraseRootFromParent_Done,
     /* 270497 */   // Label 5409: @270497
     /* 270497 */   GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(270565), // Rule ID 3931 //
     /* 270502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270521 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 270521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 270528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270533 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 270536 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270540 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270548 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 270556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270558 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270563 */     GIR_RootConstrainSelectedInstOperands,
     /* 270564 */     // GIR_Coverage, 3931,
     /* 270564 */     GIR_EraseRootFromParent_Done,
     /* 270565 */   // Label 5410: @270565
     /* 270565 */   GIM_Try, /*On fail goto*//*Label 5411*/ GIMT_Encode4(270633), // Rule ID 3932 //
     /* 270570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270582 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270587 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270589 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 270589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 270592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 270596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270601 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 270604 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270608 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 270611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 270616 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 270624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270626 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270631 */     GIR_RootConstrainSelectedInstOperands,
     /* 270632 */     // GIR_Coverage, 3932,
     /* 270632 */     GIR_EraseRootFromParent_Done,
     /* 270633 */   // Label 5411: @270633
     /* 270633 */   GIM_Try, /*On fail goto*//*Label 5412*/ GIMT_Encode4(270649), // Rule ID 121 //
     /* 270638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270642 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 270642 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 270647 */     GIR_RootConstrainSelectedInstOperands,
     /* 270648 */     // GIR_Coverage, 121,
     /* 270648 */     GIR_Done,
     /* 270649 */   // Label 5412: @270649
     /* 270649 */   GIM_Reject,
     /* 270650 */ // Label 5408: @270650
     /* 270650 */ GIM_Reject,
     /* 270651 */ // Label 5402: @270651
     /* 270651 */ GIM_Reject,
     /* 270652 */ // Label 46: @270652
     /* 270652 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5415*/ GIMT_Encode4(271427),
     /* 270663 */ /*GILLT_s32*//*Label 5413*/ GIMT_Encode4(270671),
     /* 270667 */ /*GILLT_s64*//*Label 5414*/ GIMT_Encode4(270977),
     /* 270671 */ // Label 5413: @270671
     /* 270671 */ GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(270976),
     /* 270676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 270679 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270682 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270686 */   GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(270750), // Rule ID 6486 //
     /* 270691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 270699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270708 */     // MIs[1] Operand 2
     /* 270708 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 270719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270727 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 270731 */     // MIs[2] Operand 1
     /* 270731 */     // No operand predicates
     /* 270731 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 270733 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 270733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 270736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270738 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 270742 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 270745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 270748 */     GIR_RootConstrainSelectedInstOperands,
     /* 270749 */     // GIR_Coverage, 6486,
     /* 270749 */     GIR_EraseRootFromParent_Done,
     /* 270750 */   // Label 5417: @270750
     /* 270750 */   GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(270814), // Rule ID 6488 //
     /* 270755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 270759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 270763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270772 */     // MIs[1] Operand 2
     /* 270772 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 270783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 270787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270791 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 270795 */     // MIs[2] Operand 1
     /* 270795 */     // No operand predicates
     /* 270795 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 270797 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 270797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 270800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270802 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 270806 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 270809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 270812 */     GIR_RootConstrainSelectedInstOperands,
     /* 270813 */     // GIR_Coverage, 6488,
     /* 270813 */     GIR_EraseRootFromParent_Done,
     /* 270814 */   // Label 5418: @270814
     /* 270814 */   GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(270852), // Rule ID 4010 //
     /* 270819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270831 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 270835 */     // MIs[1] Operand 1
     /* 270835 */     // No operand predicates
     /* 270835 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270837 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 270837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 270840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270842 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270844 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 270847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 270850 */     GIR_RootConstrainSelectedInstOperands,
     /* 270851 */     // GIR_Coverage, 4010,
     /* 270851 */     GIR_EraseRootFromParent_Done,
     /* 270852 */   // Label 5419: @270852
     /* 270852 */   GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(270893), // Rule ID 2433 //
     /* 270857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 270869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270880 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 270883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270885 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270891 */     GIR_RootConstrainSelectedInstOperands,
     /* 270892 */     // GIR_Coverage, 2433,
     /* 270892 */     GIR_EraseRootFromParent_Done,
     /* 270893 */   // Label 5420: @270893
     /* 270893 */   GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(270934), // Rule ID 2434 //
     /* 270898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 270910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270914 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270919 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270921 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 270924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270932 */     GIR_RootConstrainSelectedInstOperands,
     /* 270933 */     // GIR_Coverage, 2434,
     /* 270933 */     GIR_EraseRootFromParent_Done,
     /* 270934 */   // Label 5421: @270934
     /* 270934 */   GIM_Try, /*On fail goto*//*Label 5422*/ GIMT_Encode4(270975), // Rule ID 2432 //
     /* 270939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 270951 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 270955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270962 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 270962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 270965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 270969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 270973 */     GIR_RootConstrainSelectedInstOperands,
     /* 270974 */     // GIR_Coverage, 2432,
     /* 270974 */     GIR_EraseRootFromParent_Done,
     /* 270975 */   // Label 5422: @270975
     /* 270975 */   GIM_Reject,
     /* 270976 */ // Label 5416: @270976
     /* 270976 */ GIM_Reject,
     /* 270977 */ // Label 5414: @270977
     /* 270977 */ GIM_Try, /*On fail goto*//*Label 5423*/ GIMT_Encode4(271426),
     /* 270982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 270985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270992 */   GIM_Try, /*On fail goto*//*Label 5424*/ GIMT_Encode4(271056), // Rule ID 6487 //
     /* 270997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 271005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 271009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271014 */     // MIs[1] Operand 2
     /* 271014 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 271025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 271029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271033 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 271037 */     // MIs[2] Operand 1
     /* 271037 */     // No operand predicates
     /* 271037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 271039 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 271039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 271042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 271048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 271051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 271054 */     GIR_RootConstrainSelectedInstOperands,
     /* 271055 */     // GIR_Coverage, 6487,
     /* 271055 */     GIR_EraseRootFromParent_Done,
     /* 271056 */   // Label 5424: @271056
     /* 271056 */   GIM_Try, /*On fail goto*//*Label 5425*/ GIMT_Encode4(271120), // Rule ID 6489 //
     /* 271061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 271069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 271073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271078 */     // MIs[1] Operand 2
     /* 271078 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 271089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 271093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271097 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 271101 */     // MIs[2] Operand 1
     /* 271101 */     // No operand predicates
     /* 271101 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 271103 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 271103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 271106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 271112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 271115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 271118 */     GIR_RootConstrainSelectedInstOperands,
     /* 271119 */     // GIR_Coverage, 6489,
     /* 271119 */     GIR_EraseRootFromParent_Done,
     /* 271120 */   // Label 5425: @271120
     /* 271120 */   GIM_Try, /*On fail goto*//*Label 5426*/ GIMT_Encode4(271223), // Rule ID 6490 //
     /* 271125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 271133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 271146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271150 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 271154 */     // MIs[2] Operand 1
     /* 271154 */     // No operand predicates
     /* 271154 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 271156 */     // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 271156 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 271159 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 271163 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 271170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 271173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 271177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271182 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 271185 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 271189 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 271192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 271210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 271218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 271221 */     GIR_RootConstrainSelectedInstOperands,
     /* 271222 */     // GIR_Coverage, 6490,
     /* 271222 */     GIR_EraseRootFromParent_Done,
     /* 271223 */   // Label 5426: @271223
     /* 271223 */   GIM_Try, /*On fail goto*//*Label 5427*/ GIMT_Encode4(271261), // Rule ID 4011 //
     /* 271228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271240 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 271244 */     // MIs[1] Operand 1
     /* 271244 */     // No operand predicates
     /* 271244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271246 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 271246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 271249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271251 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271253 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 271259 */     GIR_RootConstrainSelectedInstOperands,
     /* 271260 */     // GIR_Coverage, 4011,
     /* 271260 */     GIR_EraseRootFromParent_Done,
     /* 271261 */   // Label 5427: @271261
     /* 271261 */   GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(271333), // Rule ID 2435 //
     /* 271266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 271278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271289 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 271289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 271292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 271296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271301 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 271304 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271308 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 271311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 271324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271326 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271331 */     GIR_RootConstrainSelectedInstOperands,
     /* 271332 */     // GIR_Coverage, 2435,
     /* 271332 */     GIR_EraseRootFromParent_Done,
     /* 271333 */   // Label 5428: @271333
     /* 271333 */   GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(271405), // Rule ID 2436 //
     /* 271338 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 271350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271361 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 271361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 271364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 271368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271373 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 271376 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271380 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 271383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 271396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271398 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271403 */     GIR_RootConstrainSelectedInstOperands,
     /* 271404 */     // GIR_Coverage, 2436,
     /* 271404 */     GIR_EraseRootFromParent_Done,
     /* 271405 */   // Label 5429: @271405
     /* 271405 */   GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(271425), // Rule ID 119 //
     /* 271410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271418 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 271418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 271423 */     GIR_RootConstrainSelectedInstOperands,
     /* 271424 */     // GIR_Coverage, 119,
     /* 271424 */     GIR_Done,
     /* 271425 */   // Label 5430: @271425
     /* 271425 */   GIM_Reject,
     /* 271426 */ // Label 5423: @271426
     /* 271426 */ GIM_Reject,
     /* 271427 */ // Label 5415: @271427
     /* 271427 */ GIM_Reject,
     /* 271428 */ // Label 47: @271428
     /* 271428 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5433*/ GIMT_Encode4(271557),
     /* 271439 */ /*GILLT_s32*//*Label 5431*/ GIMT_Encode4(271447),
     /* 271443 */ /*GILLT_s64*//*Label 5432*/ GIMT_Encode4(271502),
     /* 271447 */ // Label 5431: @271447
     /* 271447 */ GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(271501), // Rule ID 188 //
     /* 271452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 271455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 271458 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 271461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271469 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271473 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271477 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271481 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 271485 */   // MIs[1] Operand 1
     /* 271485 */   // No operand predicates
     /* 271485 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271487 */   // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 271487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 271490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271492 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271494 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 271496 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271499 */   GIR_RootConstrainSelectedInstOperands,
     /* 271500 */   // GIR_Coverage, 188,
     /* 271500 */   GIR_EraseRootFromParent_Done,
     /* 271501 */ // Label 5434: @271501
     /* 271501 */ GIM_Reject,
     /* 271502 */ // Label 5432: @271502
     /* 271502 */ GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(271556), // Rule ID 189 //
     /* 271507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 271510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271513 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 271516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271524 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271528 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271532 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271536 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 271540 */   // MIs[1] Operand 1
     /* 271540 */   // No operand predicates
     /* 271540 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271542 */   // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 271542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 271545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271547 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271549 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 271551 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271554 */   GIR_RootConstrainSelectedInstOperands,
     /* 271555 */   // GIR_Coverage, 189,
     /* 271555 */   GIR_EraseRootFromParent_Done,
     /* 271556 */ // Label 5435: @271556
     /* 271556 */ GIM_Reject,
     /* 271557 */ // Label 5433: @271557
     /* 271557 */ GIM_Reject,
     /* 271558 */ // Label 48: @271558
     /* 271558 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5438*/ GIMT_Encode4(272050),
     /* 271569 */ /*GILLT_s32*//*Label 5436*/ GIMT_Encode4(271577),
     /* 271573 */ /*GILLT_s64*//*Label 5437*/ GIMT_Encode4(271793),
     /* 271577 */ // Label 5436: @271577
     /* 271577 */ GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(271792),
     /* 271582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 271585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271592 */   GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(271631), // Rule ID 184 //
     /* 271597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 271605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271614 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 271618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271620 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 271620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 271623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 271629 */     GIR_RootConstrainSelectedInstOperands,
     /* 271630 */     // GIR_Coverage, 184,
     /* 271630 */     GIR_EraseRootFromParent_Done,
     /* 271631 */   // Label 5440: @271631
     /* 271631 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(271668), // Rule ID 4006 //
     /* 271636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271648 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 271652 */     // MIs[1] Operand 1
     /* 271652 */     // No operand predicates
     /* 271652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271654 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 271654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 271657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271666 */     GIR_RootConstrainSelectedInstOperands,
     /* 271667 */     // GIR_Coverage, 4006,
     /* 271667 */     GIR_EraseRootFromParent_Done,
     /* 271668 */   // Label 5441: @271668
     /* 271668 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(271709), // Rule ID 3935 //
     /* 271673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 271685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271696 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 271699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271707 */     GIR_RootConstrainSelectedInstOperands,
     /* 271708 */     // GIR_Coverage, 3935,
     /* 271708 */     GIR_EraseRootFromParent_Done,
     /* 271709 */   // Label 5442: @271709
     /* 271709 */   GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(271750), // Rule ID 3936 //
     /* 271714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 271726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271737 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 271740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271748 */     GIR_RootConstrainSelectedInstOperands,
     /* 271749 */     // GIR_Coverage, 3936,
     /* 271749 */     GIR_EraseRootFromParent_Done,
     /* 271750 */   // Label 5443: @271750
     /* 271750 */   GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(271791), // Rule ID 3934 //
     /* 271755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 271767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271776 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271778 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 271778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 271781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271789 */     GIR_RootConstrainSelectedInstOperands,
     /* 271790 */     // GIR_Coverage, 3934,
     /* 271790 */     GIR_EraseRootFromParent_Done,
     /* 271791 */   // Label 5444: @271791
     /* 271791 */   GIM_Reject,
     /* 271792 */ // Label 5439: @271792
     /* 271792 */ GIM_Reject,
     /* 271793 */ // Label 5437: @271793
     /* 271793 */ GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(272049),
     /* 271798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 271801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 271804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271808 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(271847), // Rule ID 187 //
     /* 271813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 271817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 271821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 271825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271830 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 271834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271836 */     // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 271836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 271839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 271845 */     GIR_RootConstrainSelectedInstOperands,
     /* 271846 */     // GIR_Coverage, 187,
     /* 271846 */     GIR_EraseRootFromParent_Done,
     /* 271847 */   // Label 5446: @271847
     /* 271847 */   GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(271884), // Rule ID 4007 //
     /* 271852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 271868 */     // MIs[1] Operand 1
     /* 271868 */     // No operand predicates
     /* 271868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271870 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
     /* 271870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 271873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271875 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271877 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271882 */     GIR_RootConstrainSelectedInstOperands,
     /* 271883 */     // GIR_Coverage, 4007,
     /* 271883 */     GIR_EraseRootFromParent_Done,
     /* 271884 */   // Label 5447: @271884
     /* 271884 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(271956), // Rule ID 3937 //
     /* 271889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 271901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271912 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 271912 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 271915 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 271919 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271924 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 271927 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 271931 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 271934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 271939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 271947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 271951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 271954 */     GIR_RootConstrainSelectedInstOperands,
     /* 271955 */     // GIR_Coverage, 3937,
     /* 271955 */     GIR_EraseRootFromParent_Done,
     /* 271956 */   // Label 5448: @271956
     /* 271956 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(272028), // Rule ID 3938 //
     /* 271961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 271969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 271973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 271977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 271982 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271984 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 271984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 271987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 271991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 271996 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 271999 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 272003 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 272006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 272011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 272016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 272019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 272023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 272026 */     GIR_RootConstrainSelectedInstOperands,
     /* 272027 */     // GIR_Coverage, 3938,
     /* 272027 */     GIR_EraseRootFromParent_Done,
     /* 272028 */   // Label 5449: @272028
     /* 272028 */   GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(272048), // Rule ID 122 //
     /* 272033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 272041 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 272041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 272046 */     GIR_RootConstrainSelectedInstOperands,
     /* 272047 */     // GIR_Coverage, 122,
     /* 272047 */     GIR_Done,
     /* 272048 */   // Label 5450: @272048
     /* 272048 */   GIM_Reject,
     /* 272049 */ // Label 5445: @272049
     /* 272049 */ GIM_Reject,
     /* 272050 */ // Label 5438: @272050
     /* 272050 */ GIM_Reject,
     /* 272051 */ // Label 49: @272051
     /* 272051 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5459*/ GIMT_Encode4(279827),
     /* 272062 */ /*GILLT_s64*//*Label 5451*/ GIMT_Encode4(272098), GIMT_Encode4(0),
     /* 272070 */ /*GILLT_v2s32*//*Label 5452*/ GIMT_Encode4(272491),
     /* 272074 */ /*GILLT_v2s64*//*Label 5453*/ GIMT_Encode4(273539),
     /* 272078 */ /*GILLT_v4s16*//*Label 5454*/ GIMT_Encode4(274587),
     /* 272082 */ /*GILLT_v4s32*//*Label 5455*/ GIMT_Encode4(275635),
     /* 272086 */ /*GILLT_v8s8*//*Label 5456*/ GIMT_Encode4(276683),
     /* 272090 */ /*GILLT_v8s16*//*Label 5457*/ GIMT_Encode4(277731),
     /* 272094 */ /*GILLT_v16s8*//*Label 5458*/ GIMT_Encode4(278779),
     /* 272098 */ // Label 5451: @272098
     /* 272098 */ GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(272490),
     /* 272103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 272106 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 272109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272113 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(272149), // Rule ID 5225 //
     /* 272118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272121 */     // MIs[0] Operand 1
     /* 272121 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272130 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272136 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272140 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 272140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv1i64rz),
     /* 272143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272147 */     GIR_RootConstrainSelectedInstOperands,
     /* 272148 */     // GIR_Coverage, 5225,
     /* 272148 */     GIR_EraseRootFromParent_Done,
     /* 272149 */   // Label 5461: @272149
     /* 272149 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(272185), // Rule ID 5226 //
     /* 272154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272157 */     // MIs[0] Operand 1
     /* 272157 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272166 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272172 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272176 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 272176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 272179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272183 */     GIR_RootConstrainSelectedInstOperands,
     /* 272184 */     // GIR_Coverage, 5226,
     /* 272184 */     GIR_EraseRootFromParent_Done,
     /* 272185 */   // Label 5462: @272185
     /* 272185 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(272221), // Rule ID 2510 //
     /* 272190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272193 */     // MIs[0] Operand 1
     /* 272193 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272202 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272208 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272212 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 272212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64rz),
     /* 272215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272219 */     GIR_RootConstrainSelectedInstOperands,
     /* 272220 */     // GIR_Coverage, 2510,
     /* 272220 */     GIR_EraseRootFromParent_Done,
     /* 272221 */   // Label 5463: @272221
     /* 272221 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(272257), // Rule ID 5222 //
     /* 272226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272229 */     // MIs[0] Operand 1
     /* 272229 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272238 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272244 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272248 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGE:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 272248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 272251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272255 */     GIR_RootConstrainSelectedInstOperands,
     /* 272256 */     // GIR_Coverage, 5222,
     /* 272256 */     GIR_EraseRootFromParent_Done,
     /* 272257 */   // Label 5464: @272257
     /* 272257 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(272293), // Rule ID 5223 //
     /* 272262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272265 */     // MIs[0] Operand 1
     /* 272265 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272274 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272280 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 272282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272284 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 272284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 272287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272291 */     GIR_RootConstrainSelectedInstOperands,
     /* 272292 */     // GIR_Coverage, 5223,
     /* 272292 */     GIR_EraseRootFromParent_Done,
     /* 272293 */   // Label 5465: @272293
     /* 272293 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(272329), // Rule ID 5224 //
     /* 272298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272301 */     // MIs[0] Operand 1
     /* 272301 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272306 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272310 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272316 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272318 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272320 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 272320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64rz),
     /* 272323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272327 */     GIR_RootConstrainSelectedInstOperands,
     /* 272328 */     // GIR_Coverage, 5224,
     /* 272328 */     GIR_EraseRootFromParent_Done,
     /* 272329 */   // Label 5466: @272329
     /* 272329 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(272361), // Rule ID 1608 //
     /* 272334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272337 */     // MIs[0] Operand 1
     /* 272337 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272350 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 272350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64),
     /* 272353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272359 */     GIR_RootConstrainSelectedInstOperands,
     /* 272360 */     // GIR_Coverage, 1608,
     /* 272360 */     GIR_EraseRootFromParent_Done,
     /* 272361 */   // Label 5467: @272361
     /* 272361 */   GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(272393), // Rule ID 1609 //
     /* 272366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272369 */     // MIs[0] Operand 1
     /* 272369 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272382 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 272382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64),
     /* 272385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272391 */     GIR_RootConstrainSelectedInstOperands,
     /* 272392 */     // GIR_Coverage, 1609,
     /* 272392 */     GIR_EraseRootFromParent_Done,
     /* 272393 */   // Label 5468: @272393
     /* 272393 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(272425), // Rule ID 1610 //
     /* 272398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272401 */     // MIs[0] Operand 1
     /* 272401 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272414 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 272414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64),
     /* 272417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272421 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272423 */     GIR_RootConstrainSelectedInstOperands,
     /* 272424 */     // GIR_Coverage, 1610,
     /* 272424 */     GIR_EraseRootFromParent_Done,
     /* 272425 */   // Label 5469: @272425
     /* 272425 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(272457), // Rule ID 1611 //
     /* 272430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272433 */     // MIs[0] Operand 1
     /* 272433 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 272438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272446 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 272446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv1i64),
     /* 272449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272455 */     GIR_RootConstrainSelectedInstOperands,
     /* 272456 */     // GIR_Coverage, 1611,
     /* 272456 */     GIR_EraseRootFromParent_Done,
     /* 272457 */   // Label 5470: @272457
     /* 272457 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(272489), // Rule ID 1612 //
     /* 272462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272465 */     // MIs[0] Operand 1
     /* 272465 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 272470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272478 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 272478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv1i64),
     /* 272481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272483 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272485 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 272487 */     GIR_RootConstrainSelectedInstOperands,
     /* 272488 */     // GIR_Coverage, 1612,
     /* 272488 */     GIR_EraseRootFromParent_Done,
     /* 272489 */   // Label 5471: @272489
     /* 272489 */   GIM_Reject,
     /* 272490 */ // Label 5460: @272490
     /* 272490 */ GIM_Reject,
     /* 272491 */ // Label 5452: @272491
     /* 272491 */ GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(273538),
     /* 272496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 272499 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 272502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272506 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(272546), // Rule ID 754 //
     /* 272511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272514 */     // MIs[0] Operand 1
     /* 272514 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272523 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272529 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272537 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 272540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272544 */     GIR_RootConstrainSelectedInstOperands,
     /* 272545 */     // GIR_Coverage, 754,
     /* 272545 */     GIR_EraseRootFromParent_Done,
     /* 272546 */   // Label 5473: @272546
     /* 272546 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(272586), // Rule ID 761 //
     /* 272551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272554 */     // MIs[0] Operand 1
     /* 272554 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272563 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272569 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272575 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272577 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 272580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272584 */     GIR_RootConstrainSelectedInstOperands,
     /* 272585 */     // GIR_Coverage, 761,
     /* 272585 */     GIR_EraseRootFromParent_Done,
     /* 272586 */   // Label 5474: @272586
     /* 272586 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(272623), // Rule ID 5159 //
     /* 272591 */     // MIs[0] Operand 1
     /* 272591 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272600 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272606 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272614 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 272617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272621 */     GIR_RootConstrainSelectedInstOperands,
     /* 272622 */     // GIR_Coverage, 5159,
     /* 272622 */     GIR_EraseRootFromParent_Done,
     /* 272623 */   // Label 5475: @272623
     /* 272623 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(272660), // Rule ID 5166 //
     /* 272628 */     // MIs[0] Operand 1
     /* 272628 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272637 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272643 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272651 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 272654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272658 */     GIR_RootConstrainSelectedInstOperands,
     /* 272659 */     // GIR_Coverage, 5166,
     /* 272659 */     GIR_EraseRootFromParent_Done,
     /* 272660 */   // Label 5476: @272660
     /* 272660 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(272697), // Rule ID 5173 //
     /* 272665 */     // MIs[0] Operand 1
     /* 272665 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272674 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272680 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272688 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 272691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272695 */     GIR_RootConstrainSelectedInstOperands,
     /* 272696 */     // GIR_Coverage, 5173,
     /* 272696 */     GIR_EraseRootFromParent_Done,
     /* 272697 */   // Label 5477: @272697
     /* 272697 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(272734), // Rule ID 5180 //
     /* 272702 */     // MIs[0] Operand 1
     /* 272702 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 272707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272711 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272717 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272725 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 272728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272732 */     GIR_RootConstrainSelectedInstOperands,
     /* 272733 */     // GIR_Coverage, 5180,
     /* 272733 */     GIR_EraseRootFromParent_Done,
     /* 272734 */   // Label 5478: @272734
     /* 272734 */   GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(272771), // Rule ID 5187 //
     /* 272739 */     // MIs[0] Operand 1
     /* 272739 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 272744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 272748 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272754 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272756 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272762 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 272765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 272769 */     GIR_RootConstrainSelectedInstOperands,
     /* 272770 */     // GIR_Coverage, 5187,
     /* 272770 */     GIR_EraseRootFromParent_Done,
     /* 272771 */   // Label 5479: @272771
     /* 272771 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(272811), // Rule ID 726 //
     /* 272776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272779 */     // MIs[0] Operand 1
     /* 272779 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272792 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272798 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272802 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 272805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272809 */     GIR_RootConstrainSelectedInstOperands,
     /* 272810 */     // GIR_Coverage, 726,
     /* 272810 */     GIR_EraseRootFromParent_Done,
     /* 272811 */   // Label 5480: @272811
     /* 272811 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(272851), // Rule ID 737 //
     /* 272816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272819 */     // MIs[0] Operand 1
     /* 272819 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 272824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272832 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272838 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272840 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272842 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 272845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272849 */     GIR_RootConstrainSelectedInstOperands,
     /* 272850 */     // GIR_Coverage, 737,
     /* 272850 */     GIR_EraseRootFromParent_Done,
     /* 272851 */   // Label 5481: @272851
     /* 272851 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(272891), // Rule ID 738 //
     /* 272856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272859 */     // MIs[0] Operand 1
     /* 272859 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272872 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272878 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 272880 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272882 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 272885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272889 */     GIR_RootConstrainSelectedInstOperands,
     /* 272890 */     // GIR_Coverage, 738,
     /* 272890 */     GIR_EraseRootFromParent_Done,
     /* 272891 */   // Label 5482: @272891
     /* 272891 */   GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(272931), // Rule ID 747 //
     /* 272896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 272899 */     // MIs[0] Operand 1
     /* 272899 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272912 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272918 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272922 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 272925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272929 */     GIR_RootConstrainSelectedInstOperands,
     /* 272930 */     // GIR_Coverage, 747,
     /* 272930 */     GIR_EraseRootFromParent_Done,
     /* 272931 */   // Label 5483: @272931
     /* 272931 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(272968), // Rule ID 5124 //
     /* 272936 */     // MIs[0] Operand 1
     /* 272936 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 272941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272949 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272955 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272957 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272959 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 272962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 272964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272966 */     GIR_RootConstrainSelectedInstOperands,
     /* 272967 */     // GIR_Coverage, 5124,
     /* 272967 */     GIR_EraseRootFromParent_Done,
     /* 272968 */   // Label 5484: @272968
     /* 272968 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(273005), // Rule ID 5131 //
     /* 272973 */     // MIs[0] Operand 1
     /* 272973 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 272978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 272982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 272986 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 272992 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 272994 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 272996 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 272996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 272999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273003 */     GIR_RootConstrainSelectedInstOperands,
     /* 273004 */     // GIR_Coverage, 5131,
     /* 273004 */     GIR_EraseRootFromParent_Done,
     /* 273005 */   // Label 5485: @273005
     /* 273005 */   GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(273042), // Rule ID 5138 //
     /* 273010 */     // MIs[0] Operand 1
     /* 273010 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273023 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273029 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273031 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273033 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 273033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 273036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273040 */     GIR_RootConstrainSelectedInstOperands,
     /* 273041 */     // GIR_Coverage, 5138,
     /* 273041 */     GIR_EraseRootFromParent_Done,
     /* 273042 */   // Label 5486: @273042
     /* 273042 */   GIM_Try, /*On fail goto*//*Label 5487*/ GIMT_Encode4(273079), // Rule ID 5145 //
     /* 273047 */     // MIs[0] Operand 1
     /* 273047 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 273052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273060 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273066 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273068 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273070 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 273070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 273073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273077 */     GIR_RootConstrainSelectedInstOperands,
     /* 273078 */     // GIR_Coverage, 5145,
     /* 273078 */     GIR_EraseRootFromParent_Done,
     /* 273079 */   // Label 5487: @273079
     /* 273079 */   GIM_Try, /*On fail goto*//*Label 5488*/ GIMT_Encode4(273116), // Rule ID 5152 //
     /* 273084 */     // MIs[0] Operand 1
     /* 273084 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 273089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273097 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273103 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273107 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 273107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 273110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273114 */     GIR_RootConstrainSelectedInstOperands,
     /* 273115 */     // GIR_Coverage, 5152,
     /* 273115 */     GIR_EraseRootFromParent_Done,
     /* 273116 */   // Label 5488: @273116
     /* 273116 */   GIM_Try, /*On fail goto*//*Label 5489*/ GIMT_Encode4(273148), // Rule ID 1125 //
     /* 273121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273124 */     // MIs[0] Operand 1
     /* 273124 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273137 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 273137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 273140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273146 */     GIR_RootConstrainSelectedInstOperands,
     /* 273147 */     // GIR_Coverage, 1125,
     /* 273147 */     GIR_EraseRootFromParent_Done,
     /* 273148 */   // Label 5489: @273148
     /* 273148 */   GIM_Try, /*On fail goto*//*Label 5490*/ GIMT_Encode4(273180), // Rule ID 1132 //
     /* 273153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273156 */     // MIs[0] Operand 1
     /* 273156 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273165 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273169 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 273169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 273172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273178 */     GIR_RootConstrainSelectedInstOperands,
     /* 273179 */     // GIR_Coverage, 1132,
     /* 273179 */     GIR_EraseRootFromParent_Done,
     /* 273180 */   // Label 5490: @273180
     /* 273180 */   GIM_Try, /*On fail goto*//*Label 5491*/ GIMT_Encode4(273212), // Rule ID 1139 //
     /* 273185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273188 */     // MIs[0] Operand 1
     /* 273188 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273201 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 273201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 273204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273210 */     GIR_RootConstrainSelectedInstOperands,
     /* 273211 */     // GIR_Coverage, 1139,
     /* 273211 */     GIR_EraseRootFromParent_Done,
     /* 273212 */   // Label 5491: @273212
     /* 273212 */   GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(273244), // Rule ID 1146 //
     /* 273217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273220 */     // MIs[0] Operand 1
     /* 273220 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 273225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273233 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 273233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 273236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273242 */     GIR_RootConstrainSelectedInstOperands,
     /* 273243 */     // GIR_Coverage, 1146,
     /* 273243 */     GIR_EraseRootFromParent_Done,
     /* 273244 */   // Label 5492: @273244
     /* 273244 */   GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(273276), // Rule ID 1153 //
     /* 273249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273252 */     // MIs[0] Operand 1
     /* 273252 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 273257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273265 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 273265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 273268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273274 */     GIR_RootConstrainSelectedInstOperands,
     /* 273275 */     // GIR_Coverage, 1153,
     /* 273275 */     GIR_EraseRootFromParent_Done,
     /* 273276 */   // Label 5493: @273276
     /* 273276 */   GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(273305), // Rule ID 5061 //
     /* 273281 */     // MIs[0] Operand 1
     /* 273281 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273286 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273290 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273294 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 273294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 273297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273301 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273303 */     GIR_RootConstrainSelectedInstOperands,
     /* 273304 */     // GIR_Coverage, 5061,
     /* 273304 */     GIR_EraseRootFromParent_Done,
     /* 273305 */   // Label 5494: @273305
     /* 273305 */   GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(273334), // Rule ID 5068 //
     /* 273310 */     // MIs[0] Operand 1
     /* 273310 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273323 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 273323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 273326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273332 */     GIR_RootConstrainSelectedInstOperands,
     /* 273333 */     // GIR_Coverage, 5068,
     /* 273333 */     GIR_EraseRootFromParent_Done,
     /* 273334 */   // Label 5495: @273334
     /* 273334 */   GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(273363), // Rule ID 5075 //
     /* 273339 */     // MIs[0] Operand 1
     /* 273339 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273352 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 273352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 273355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273361 */     GIR_RootConstrainSelectedInstOperands,
     /* 273362 */     // GIR_Coverage, 5075,
     /* 273362 */     GIR_EraseRootFromParent_Done,
     /* 273363 */   // Label 5496: @273363
     /* 273363 */   GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(273392), // Rule ID 5082 //
     /* 273368 */     // MIs[0] Operand 1
     /* 273368 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 273373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273381 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 273381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 273384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273388 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273390 */     GIR_RootConstrainSelectedInstOperands,
     /* 273391 */     // GIR_Coverage, 5082,
     /* 273391 */     GIR_EraseRootFromParent_Done,
     /* 273392 */   // Label 5497: @273392
     /* 273392 */   GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(273421), // Rule ID 5089 //
     /* 273397 */     // MIs[0] Operand 1
     /* 273397 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 273402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273406 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273410 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 273410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 273413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273419 */     GIR_RootConstrainSelectedInstOperands,
     /* 273420 */     // GIR_Coverage, 5089,
     /* 273420 */     GIR_EraseRootFromParent_Done,
     /* 273421 */   // Label 5498: @273421
     /* 273421 */   GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(273450), // Rule ID 5096 //
     /* 273426 */     // MIs[0] Operand 1
     /* 273426 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 273431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273439 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 273439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 273442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273448 */     GIR_RootConstrainSelectedInstOperands,
     /* 273449 */     // GIR_Coverage, 5096,
     /* 273449 */     GIR_EraseRootFromParent_Done,
     /* 273450 */   // Label 5499: @273450
     /* 273450 */   GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(273479), // Rule ID 5103 //
     /* 273455 */     // MIs[0] Operand 1
     /* 273455 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 273460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273468 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 273468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 273471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273477 */     GIR_RootConstrainSelectedInstOperands,
     /* 273478 */     // GIR_Coverage, 5103,
     /* 273478 */     GIR_EraseRootFromParent_Done,
     /* 273479 */   // Label 5500: @273479
     /* 273479 */   GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(273508), // Rule ID 5110 //
     /* 273484 */     // MIs[0] Operand 1
     /* 273484 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 273489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273497 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 273497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 273500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273506 */     GIR_RootConstrainSelectedInstOperands,
     /* 273507 */     // GIR_Coverage, 5110,
     /* 273507 */     GIR_EraseRootFromParent_Done,
     /* 273508 */   // Label 5501: @273508
     /* 273508 */   GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(273537), // Rule ID 5117 //
     /* 273513 */     // MIs[0] Operand 1
     /* 273513 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 273518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273526 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 273526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 273529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 273533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273535 */     GIR_RootConstrainSelectedInstOperands,
     /* 273536 */     // GIR_Coverage, 5117,
     /* 273536 */     GIR_EraseRootFromParent_Done,
     /* 273537 */   // Label 5502: @273537
     /* 273537 */   GIM_Reject,
     /* 273538 */ // Label 5472: @273538
     /* 273538 */ GIM_Reject,
     /* 273539 */ // Label 5453: @273539
     /* 273539 */ GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(274586),
     /* 273544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 273547 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 273550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273554 */   GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(273594), // Rule ID 756 //
     /* 273559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273562 */     // MIs[0] Operand 1
     /* 273562 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273571 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273577 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273583 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273585 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 273588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273592 */     GIR_RootConstrainSelectedInstOperands,
     /* 273593 */     // GIR_Coverage, 756,
     /* 273593 */     GIR_EraseRootFromParent_Done,
     /* 273594 */   // Label 5504: @273594
     /* 273594 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(273634), // Rule ID 763 //
     /* 273599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273602 */     // MIs[0] Operand 1
     /* 273602 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273611 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273617 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273619 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273623 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273625 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 273628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273632 */     GIR_RootConstrainSelectedInstOperands,
     /* 273633 */     // GIR_Coverage, 763,
     /* 273633 */     GIR_EraseRootFromParent_Done,
     /* 273634 */   // Label 5505: @273634
     /* 273634 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(273671), // Rule ID 5161 //
     /* 273639 */     // MIs[0] Operand 1
     /* 273639 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273648 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273654 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273662 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 273665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273669 */     GIR_RootConstrainSelectedInstOperands,
     /* 273670 */     // GIR_Coverage, 5161,
     /* 273670 */     GIR_EraseRootFromParent_Done,
     /* 273671 */   // Label 5506: @273671
     /* 273671 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(273708), // Rule ID 5168 //
     /* 273676 */     // MIs[0] Operand 1
     /* 273676 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273685 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273691 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273699 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 273702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273706 */     GIR_RootConstrainSelectedInstOperands,
     /* 273707 */     // GIR_Coverage, 5168,
     /* 273707 */     GIR_EraseRootFromParent_Done,
     /* 273708 */   // Label 5507: @273708
     /* 273708 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(273745), // Rule ID 5175 //
     /* 273713 */     // MIs[0] Operand 1
     /* 273713 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273722 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273728 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273736 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 273739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273743 */     GIR_RootConstrainSelectedInstOperands,
     /* 273744 */     // GIR_Coverage, 5175,
     /* 273744 */     GIR_EraseRootFromParent_Done,
     /* 273745 */   // Label 5508: @273745
     /* 273745 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(273782), // Rule ID 5182 //
     /* 273750 */     // MIs[0] Operand 1
     /* 273750 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 273755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273759 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273765 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273773 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 273776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273780 */     GIR_RootConstrainSelectedInstOperands,
     /* 273781 */     // GIR_Coverage, 5182,
     /* 273781 */     GIR_EraseRootFromParent_Done,
     /* 273782 */   // Label 5509: @273782
     /* 273782 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(273819), // Rule ID 5189 //
     /* 273787 */     // MIs[0] Operand 1
     /* 273787 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 273792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 273796 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273802 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273804 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273808 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273810 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 273813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273817 */     GIR_RootConstrainSelectedInstOperands,
     /* 273818 */     // GIR_Coverage, 5189,
     /* 273818 */     GIR_EraseRootFromParent_Done,
     /* 273819 */   // Label 5510: @273819
     /* 273819 */   GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(273859), // Rule ID 728 //
     /* 273824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273827 */     // MIs[0] Operand 1
     /* 273827 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273840 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273846 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273850 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 273853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273857 */     GIR_RootConstrainSelectedInstOperands,
     /* 273858 */     // GIR_Coverage, 728,
     /* 273858 */     GIR_EraseRootFromParent_Done,
     /* 273859 */   // Label 5511: @273859
     /* 273859 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(273899), // Rule ID 741 //
     /* 273864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273867 */     // MIs[0] Operand 1
     /* 273867 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 273872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273880 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273886 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273890 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 273893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273897 */     GIR_RootConstrainSelectedInstOperands,
     /* 273898 */     // GIR_Coverage, 741,
     /* 273898 */     GIR_EraseRootFromParent_Done,
     /* 273899 */   // Label 5512: @273899
     /* 273899 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(273939), // Rule ID 742 //
     /* 273904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273907 */     // MIs[0] Operand 1
     /* 273907 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273916 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273920 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273926 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 273928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273930 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 273933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273937 */     GIR_RootConstrainSelectedInstOperands,
     /* 273938 */     // GIR_Coverage, 742,
     /* 273938 */     GIR_EraseRootFromParent_Done,
     /* 273939 */   // Label 5513: @273939
     /* 273939 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(273979), // Rule ID 749 //
     /* 273944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 273947 */     // MIs[0] Operand 1
     /* 273947 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 273952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273960 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 273966 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 273968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 273970 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 273970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 273973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 273975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273977 */     GIR_RootConstrainSelectedInstOperands,
     /* 273978 */     // GIR_Coverage, 749,
     /* 273978 */     GIR_EraseRootFromParent_Done,
     /* 273979 */   // Label 5514: @273979
     /* 273979 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(274016), // Rule ID 5126 //
     /* 273984 */     // MIs[0] Operand 1
     /* 273984 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 273989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 273997 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274003 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274007 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 274010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274014 */     GIR_RootConstrainSelectedInstOperands,
     /* 274015 */     // GIR_Coverage, 5126,
     /* 274015 */     GIR_EraseRootFromParent_Done,
     /* 274016 */   // Label 5515: @274016
     /* 274016 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(274053), // Rule ID 5133 //
     /* 274021 */     // MIs[0] Operand 1
     /* 274021 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274034 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274040 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274044 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 274047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274051 */     GIR_RootConstrainSelectedInstOperands,
     /* 274052 */     // GIR_Coverage, 5133,
     /* 274052 */     GIR_EraseRootFromParent_Done,
     /* 274053 */   // Label 5516: @274053
     /* 274053 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(274090), // Rule ID 5140 //
     /* 274058 */     // MIs[0] Operand 1
     /* 274058 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274071 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274077 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274081 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 274084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274088 */     GIR_RootConstrainSelectedInstOperands,
     /* 274089 */     // GIR_Coverage, 5140,
     /* 274089 */     GIR_EraseRootFromParent_Done,
     /* 274090 */   // Label 5517: @274090
     /* 274090 */   GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(274127), // Rule ID 5147 //
     /* 274095 */     // MIs[0] Operand 1
     /* 274095 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 274100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274108 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274114 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274118 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 274121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274125 */     GIR_RootConstrainSelectedInstOperands,
     /* 274126 */     // GIR_Coverage, 5147,
     /* 274126 */     GIR_EraseRootFromParent_Done,
     /* 274127 */   // Label 5518: @274127
     /* 274127 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(274164), // Rule ID 5154 //
     /* 274132 */     // MIs[0] Operand 1
     /* 274132 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 274137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274145 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274151 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274155 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 274155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 274158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274162 */     GIR_RootConstrainSelectedInstOperands,
     /* 274163 */     // GIR_Coverage, 5154,
     /* 274163 */     GIR_EraseRootFromParent_Done,
     /* 274164 */   // Label 5519: @274164
     /* 274164 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(274196), // Rule ID 1127 //
     /* 274169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274172 */     // MIs[0] Operand 1
     /* 274172 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274185 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 274185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 274188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274194 */     GIR_RootConstrainSelectedInstOperands,
     /* 274195 */     // GIR_Coverage, 1127,
     /* 274195 */     GIR_EraseRootFromParent_Done,
     /* 274196 */   // Label 5520: @274196
     /* 274196 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(274228), // Rule ID 1134 //
     /* 274201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274204 */     // MIs[0] Operand 1
     /* 274204 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274217 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 274217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 274220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274226 */     GIR_RootConstrainSelectedInstOperands,
     /* 274227 */     // GIR_Coverage, 1134,
     /* 274227 */     GIR_EraseRootFromParent_Done,
     /* 274228 */   // Label 5521: @274228
     /* 274228 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(274260), // Rule ID 1141 //
     /* 274233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274236 */     // MIs[0] Operand 1
     /* 274236 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274249 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 274249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 274252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274258 */     GIR_RootConstrainSelectedInstOperands,
     /* 274259 */     // GIR_Coverage, 1141,
     /* 274259 */     GIR_EraseRootFromParent_Done,
     /* 274260 */   // Label 5522: @274260
     /* 274260 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(274292), // Rule ID 1148 //
     /* 274265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274268 */     // MIs[0] Operand 1
     /* 274268 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 274273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274281 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 274281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 274284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274290 */     GIR_RootConstrainSelectedInstOperands,
     /* 274291 */     // GIR_Coverage, 1148,
     /* 274291 */     GIR_EraseRootFromParent_Done,
     /* 274292 */   // Label 5523: @274292
     /* 274292 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(274324), // Rule ID 1155 //
     /* 274297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274300 */     // MIs[0] Operand 1
     /* 274300 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 274305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274313 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 274313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 274316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274322 */     GIR_RootConstrainSelectedInstOperands,
     /* 274323 */     // GIR_Coverage, 1155,
     /* 274323 */     GIR_EraseRootFromParent_Done,
     /* 274324 */   // Label 5524: @274324
     /* 274324 */   GIM_Try, /*On fail goto*//*Label 5525*/ GIMT_Encode4(274353), // Rule ID 5063 //
     /* 274329 */     // MIs[0] Operand 1
     /* 274329 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274342 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 274342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 274345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274351 */     GIR_RootConstrainSelectedInstOperands,
     /* 274352 */     // GIR_Coverage, 5063,
     /* 274352 */     GIR_EraseRootFromParent_Done,
     /* 274353 */   // Label 5525: @274353
     /* 274353 */   GIM_Try, /*On fail goto*//*Label 5526*/ GIMT_Encode4(274382), // Rule ID 5070 //
     /* 274358 */     // MIs[0] Operand 1
     /* 274358 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274371 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 274371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 274374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274380 */     GIR_RootConstrainSelectedInstOperands,
     /* 274381 */     // GIR_Coverage, 5070,
     /* 274381 */     GIR_EraseRootFromParent_Done,
     /* 274382 */   // Label 5526: @274382
     /* 274382 */   GIM_Try, /*On fail goto*//*Label 5527*/ GIMT_Encode4(274411), // Rule ID 5077 //
     /* 274387 */     // MIs[0] Operand 1
     /* 274387 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274400 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 274400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 274403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274409 */     GIR_RootConstrainSelectedInstOperands,
     /* 274410 */     // GIR_Coverage, 5077,
     /* 274410 */     GIR_EraseRootFromParent_Done,
     /* 274411 */   // Label 5527: @274411
     /* 274411 */   GIM_Try, /*On fail goto*//*Label 5528*/ GIMT_Encode4(274440), // Rule ID 5084 //
     /* 274416 */     // MIs[0] Operand 1
     /* 274416 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 274421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274429 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 274429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 274432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274438 */     GIR_RootConstrainSelectedInstOperands,
     /* 274439 */     // GIR_Coverage, 5084,
     /* 274439 */     GIR_EraseRootFromParent_Done,
     /* 274440 */   // Label 5528: @274440
     /* 274440 */   GIM_Try, /*On fail goto*//*Label 5529*/ GIMT_Encode4(274469), // Rule ID 5091 //
     /* 274445 */     // MIs[0] Operand 1
     /* 274445 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 274450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274458 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 274458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 274461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274467 */     GIR_RootConstrainSelectedInstOperands,
     /* 274468 */     // GIR_Coverage, 5091,
     /* 274468 */     GIR_EraseRootFromParent_Done,
     /* 274469 */   // Label 5529: @274469
     /* 274469 */   GIM_Try, /*On fail goto*//*Label 5530*/ GIMT_Encode4(274498), // Rule ID 5098 //
     /* 274474 */     // MIs[0] Operand 1
     /* 274474 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 274479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274487 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 274487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 274490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274496 */     GIR_RootConstrainSelectedInstOperands,
     /* 274497 */     // GIR_Coverage, 5098,
     /* 274497 */     GIR_EraseRootFromParent_Done,
     /* 274498 */   // Label 5530: @274498
     /* 274498 */   GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(274527), // Rule ID 5105 //
     /* 274503 */     // MIs[0] Operand 1
     /* 274503 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 274508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274512 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274516 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 274516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 274519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274525 */     GIR_RootConstrainSelectedInstOperands,
     /* 274526 */     // GIR_Coverage, 5105,
     /* 274526 */     GIR_EraseRootFromParent_Done,
     /* 274527 */   // Label 5531: @274527
     /* 274527 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(274556), // Rule ID 5112 //
     /* 274532 */     // MIs[0] Operand 1
     /* 274532 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 274537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274545 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 274545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 274548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274554 */     GIR_RootConstrainSelectedInstOperands,
     /* 274555 */     // GIR_Coverage, 5112,
     /* 274555 */     GIR_EraseRootFromParent_Done,
     /* 274556 */   // Label 5532: @274556
     /* 274556 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(274585), // Rule ID 5119 //
     /* 274561 */     // MIs[0] Operand 1
     /* 274561 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 274566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274574 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 274574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 274577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 274581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274583 */     GIR_RootConstrainSelectedInstOperands,
     /* 274584 */     // GIR_Coverage, 5119,
     /* 274584 */     GIR_EraseRootFromParent_Done,
     /* 274585 */   // Label 5533: @274585
     /* 274585 */   GIM_Reject,
     /* 274586 */ // Label 5503: @274586
     /* 274586 */ GIM_Reject,
     /* 274587 */ // Label 5454: @274587
     /* 274587 */ GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(275634),
     /* 274592 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 274595 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 274598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274602 */   GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(274642), // Rule ID 752 //
     /* 274607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274610 */     // MIs[0] Operand 1
     /* 274610 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274619 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274625 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274633 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 274636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274640 */     GIR_RootConstrainSelectedInstOperands,
     /* 274641 */     // GIR_Coverage, 752,
     /* 274641 */     GIR_EraseRootFromParent_Done,
     /* 274642 */   // Label 5535: @274642
     /* 274642 */   GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(274682), // Rule ID 759 //
     /* 274647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274650 */     // MIs[0] Operand 1
     /* 274650 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274659 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274665 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274673 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 274676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274680 */     GIR_RootConstrainSelectedInstOperands,
     /* 274681 */     // GIR_Coverage, 759,
     /* 274681 */     GIR_EraseRootFromParent_Done,
     /* 274682 */   // Label 5536: @274682
     /* 274682 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(274719), // Rule ID 5157 //
     /* 274687 */     // MIs[0] Operand 1
     /* 274687 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274696 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274702 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274708 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274710 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 274713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274717 */     GIR_RootConstrainSelectedInstOperands,
     /* 274718 */     // GIR_Coverage, 5157,
     /* 274718 */     GIR_EraseRootFromParent_Done,
     /* 274719 */   // Label 5537: @274719
     /* 274719 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(274756), // Rule ID 5164 //
     /* 274724 */     // MIs[0] Operand 1
     /* 274724 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274733 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274739 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274747 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 274750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274754 */     GIR_RootConstrainSelectedInstOperands,
     /* 274755 */     // GIR_Coverage, 5164,
     /* 274755 */     GIR_EraseRootFromParent_Done,
     /* 274756 */   // Label 5538: @274756
     /* 274756 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(274793), // Rule ID 5171 //
     /* 274761 */     // MIs[0] Operand 1
     /* 274761 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274770 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274776 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274784 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 274787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274791 */     GIR_RootConstrainSelectedInstOperands,
     /* 274792 */     // GIR_Coverage, 5171,
     /* 274792 */     GIR_EraseRootFromParent_Done,
     /* 274793 */   // Label 5539: @274793
     /* 274793 */   GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(274830), // Rule ID 5178 //
     /* 274798 */     // MIs[0] Operand 1
     /* 274798 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 274803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274807 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274813 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274815 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274821 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 274824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274828 */     GIR_RootConstrainSelectedInstOperands,
     /* 274829 */     // GIR_Coverage, 5178,
     /* 274829 */     GIR_EraseRootFromParent_Done,
     /* 274830 */   // Label 5540: @274830
     /* 274830 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(274867), // Rule ID 5185 //
     /* 274835 */     // MIs[0] Operand 1
     /* 274835 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 274840 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 274844 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274850 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274858 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 274861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274865 */     GIR_RootConstrainSelectedInstOperands,
     /* 274866 */     // GIR_Coverage, 5185,
     /* 274866 */     GIR_EraseRootFromParent_Done,
     /* 274867 */   // Label 5541: @274867
     /* 274867 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(274907), // Rule ID 724 //
     /* 274872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274875 */     // MIs[0] Operand 1
     /* 274875 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 274880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274888 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274894 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274896 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274898 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 274901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274905 */     GIR_RootConstrainSelectedInstOperands,
     /* 274906 */     // GIR_Coverage, 724,
     /* 274906 */     GIR_EraseRootFromParent_Done,
     /* 274907 */   // Label 5542: @274907
     /* 274907 */   GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(274947), // Rule ID 733 //
     /* 274912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274915 */     // MIs[0] Operand 1
     /* 274915 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 274920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274928 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274934 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 274936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274938 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 274941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274945 */     GIR_RootConstrainSelectedInstOperands,
     /* 274946 */     // GIR_Coverage, 733,
     /* 274946 */     GIR_EraseRootFromParent_Done,
     /* 274947 */   // Label 5543: @274947
     /* 274947 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(274987), // Rule ID 734 //
     /* 274952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274955 */     // MIs[0] Operand 1
     /* 274955 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 274960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 274968 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 274974 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 274976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 274978 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 274978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 274981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 274983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 274985 */     GIR_RootConstrainSelectedInstOperands,
     /* 274986 */     // GIR_Coverage, 734,
     /* 274986 */     GIR_EraseRootFromParent_Done,
     /* 274987 */   // Label 5544: @274987
     /* 274987 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(275027), // Rule ID 745 //
     /* 274992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 274995 */     // MIs[0] Operand 1
     /* 274995 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275008 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275014 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275018 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 275021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275025 */     GIR_RootConstrainSelectedInstOperands,
     /* 275026 */     // GIR_Coverage, 745,
     /* 275026 */     GIR_EraseRootFromParent_Done,
     /* 275027 */   // Label 5545: @275027
     /* 275027 */   GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(275064), // Rule ID 5122 //
     /* 275032 */     // MIs[0] Operand 1
     /* 275032 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275045 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275051 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275055 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 275058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275062 */     GIR_RootConstrainSelectedInstOperands,
     /* 275063 */     // GIR_Coverage, 5122,
     /* 275063 */     GIR_EraseRootFromParent_Done,
     /* 275064 */   // Label 5546: @275064
     /* 275064 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(275101), // Rule ID 5129 //
     /* 275069 */     // MIs[0] Operand 1
     /* 275069 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275082 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275088 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275092 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 275095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275099 */     GIR_RootConstrainSelectedInstOperands,
     /* 275100 */     // GIR_Coverage, 5129,
     /* 275100 */     GIR_EraseRootFromParent_Done,
     /* 275101 */   // Label 5547: @275101
     /* 275101 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(275138), // Rule ID 5136 //
     /* 275106 */     // MIs[0] Operand 1
     /* 275106 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275119 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275125 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275129 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 275132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275136 */     GIR_RootConstrainSelectedInstOperands,
     /* 275137 */     // GIR_Coverage, 5136,
     /* 275137 */     GIR_EraseRootFromParent_Done,
     /* 275138 */   // Label 5548: @275138
     /* 275138 */   GIM_Try, /*On fail goto*//*Label 5549*/ GIMT_Encode4(275175), // Rule ID 5143 //
     /* 275143 */     // MIs[0] Operand 1
     /* 275143 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275156 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275162 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275166 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 275169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275173 */     GIR_RootConstrainSelectedInstOperands,
     /* 275174 */     // GIR_Coverage, 5143,
     /* 275174 */     GIR_EraseRootFromParent_Done,
     /* 275175 */   // Label 5549: @275175
     /* 275175 */   GIM_Try, /*On fail goto*//*Label 5550*/ GIMT_Encode4(275212), // Rule ID 5150 //
     /* 275180 */     // MIs[0] Operand 1
     /* 275180 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275193 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275199 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275203 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 275203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 275206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275210 */     GIR_RootConstrainSelectedInstOperands,
     /* 275211 */     // GIR_Coverage, 5150,
     /* 275211 */     GIR_EraseRootFromParent_Done,
     /* 275212 */   // Label 5550: @275212
     /* 275212 */   GIM_Try, /*On fail goto*//*Label 5551*/ GIMT_Encode4(275244), // Rule ID 1123 //
     /* 275217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275220 */     // MIs[0] Operand 1
     /* 275220 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275233 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 275236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275242 */     GIR_RootConstrainSelectedInstOperands,
     /* 275243 */     // GIR_Coverage, 1123,
     /* 275243 */     GIR_EraseRootFromParent_Done,
     /* 275244 */   // Label 5551: @275244
     /* 275244 */   GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(275276), // Rule ID 1130 //
     /* 275249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275252 */     // MIs[0] Operand 1
     /* 275252 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275265 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 275268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275274 */     GIR_RootConstrainSelectedInstOperands,
     /* 275275 */     // GIR_Coverage, 1130,
     /* 275275 */     GIR_EraseRootFromParent_Done,
     /* 275276 */   // Label 5552: @275276
     /* 275276 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(275308), // Rule ID 1137 //
     /* 275281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275284 */     // MIs[0] Operand 1
     /* 275284 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275297 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 275300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275306 */     GIR_RootConstrainSelectedInstOperands,
     /* 275307 */     // GIR_Coverage, 1137,
     /* 275307 */     GIR_EraseRootFromParent_Done,
     /* 275308 */   // Label 5553: @275308
     /* 275308 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(275340), // Rule ID 1144 //
     /* 275313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275316 */     // MIs[0] Operand 1
     /* 275316 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 275321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275329 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 275332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275338 */     GIR_RootConstrainSelectedInstOperands,
     /* 275339 */     // GIR_Coverage, 1144,
     /* 275339 */     GIR_EraseRootFromParent_Done,
     /* 275340 */   // Label 5554: @275340
     /* 275340 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(275372), // Rule ID 1151 //
     /* 275345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275348 */     // MIs[0] Operand 1
     /* 275348 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 275353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275361 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 275364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275370 */     GIR_RootConstrainSelectedInstOperands,
     /* 275371 */     // GIR_Coverage, 1151,
     /* 275371 */     GIR_EraseRootFromParent_Done,
     /* 275372 */   // Label 5555: @275372
     /* 275372 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(275401), // Rule ID 5059 //
     /* 275377 */     // MIs[0] Operand 1
     /* 275377 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275390 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 275393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275399 */     GIR_RootConstrainSelectedInstOperands,
     /* 275400 */     // GIR_Coverage, 5059,
     /* 275400 */     GIR_EraseRootFromParent_Done,
     /* 275401 */   // Label 5556: @275401
     /* 275401 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(275430), // Rule ID 5066 //
     /* 275406 */     // MIs[0] Operand 1
     /* 275406 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275415 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275419 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 275422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275428 */     GIR_RootConstrainSelectedInstOperands,
     /* 275429 */     // GIR_Coverage, 5066,
     /* 275429 */     GIR_EraseRootFromParent_Done,
     /* 275430 */   // Label 5557: @275430
     /* 275430 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(275459), // Rule ID 5073 //
     /* 275435 */     // MIs[0] Operand 1
     /* 275435 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275448 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 275451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275457 */     GIR_RootConstrainSelectedInstOperands,
     /* 275458 */     // GIR_Coverage, 5073,
     /* 275458 */     GIR_EraseRootFromParent_Done,
     /* 275459 */   // Label 5558: @275459
     /* 275459 */   GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(275488), // Rule ID 5080 //
     /* 275464 */     // MIs[0] Operand 1
     /* 275464 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 275469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275477 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 275480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275486 */     GIR_RootConstrainSelectedInstOperands,
     /* 275487 */     // GIR_Coverage, 5080,
     /* 275487 */     GIR_EraseRootFromParent_Done,
     /* 275488 */   // Label 5559: @275488
     /* 275488 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(275517), // Rule ID 5087 //
     /* 275493 */     // MIs[0] Operand 1
     /* 275493 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 275498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275506 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 275506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 275509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275515 */     GIR_RootConstrainSelectedInstOperands,
     /* 275516 */     // GIR_Coverage, 5087,
     /* 275516 */     GIR_EraseRootFromParent_Done,
     /* 275517 */   // Label 5560: @275517
     /* 275517 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(275546), // Rule ID 5094 //
     /* 275522 */     // MIs[0] Operand 1
     /* 275522 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275535 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 275535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 275538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275544 */     GIR_RootConstrainSelectedInstOperands,
     /* 275545 */     // GIR_Coverage, 5094,
     /* 275545 */     GIR_EraseRootFromParent_Done,
     /* 275546 */   // Label 5561: @275546
     /* 275546 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(275575), // Rule ID 5101 //
     /* 275551 */     // MIs[0] Operand 1
     /* 275551 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275564 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 275564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 275567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275573 */     GIR_RootConstrainSelectedInstOperands,
     /* 275574 */     // GIR_Coverage, 5101,
     /* 275574 */     GIR_EraseRootFromParent_Done,
     /* 275575 */   // Label 5562: @275575
     /* 275575 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(275604), // Rule ID 5108 //
     /* 275580 */     // MIs[0] Operand 1
     /* 275580 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 275585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275593 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 275593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 275596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275602 */     GIR_RootConstrainSelectedInstOperands,
     /* 275603 */     // GIR_Coverage, 5108,
     /* 275603 */     GIR_EraseRootFromParent_Done,
     /* 275604 */   // Label 5563: @275604
     /* 275604 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(275633), // Rule ID 5115 //
     /* 275609 */     // MIs[0] Operand 1
     /* 275609 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 275614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 275622 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 275622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 275625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 275629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275631 */     GIR_RootConstrainSelectedInstOperands,
     /* 275632 */     // GIR_Coverage, 5115,
     /* 275632 */     GIR_EraseRootFromParent_Done,
     /* 275633 */   // Label 5564: @275633
     /* 275633 */   GIM_Reject,
     /* 275634 */ // Label 5534: @275634
     /* 275634 */ GIM_Reject,
     /* 275635 */ // Label 5455: @275635
     /* 275635 */ GIM_Try, /*On fail goto*//*Label 5565*/ GIMT_Encode4(276682),
     /* 275640 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 275643 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 275646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275650 */   GIM_Try, /*On fail goto*//*Label 5566*/ GIMT_Encode4(275690), // Rule ID 755 //
     /* 275655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275658 */     // MIs[0] Operand 1
     /* 275658 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275667 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275673 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275681 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 275684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275688 */     GIR_RootConstrainSelectedInstOperands,
     /* 275689 */     // GIR_Coverage, 755,
     /* 275689 */     GIR_EraseRootFromParent_Done,
     /* 275690 */   // Label 5566: @275690
     /* 275690 */   GIM_Try, /*On fail goto*//*Label 5567*/ GIMT_Encode4(275730), // Rule ID 762 //
     /* 275695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275698 */     // MIs[0] Operand 1
     /* 275698 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275707 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275713 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275719 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275721 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 275724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275728 */     GIR_RootConstrainSelectedInstOperands,
     /* 275729 */     // GIR_Coverage, 762,
     /* 275729 */     GIR_EraseRootFromParent_Done,
     /* 275730 */   // Label 5567: @275730
     /* 275730 */   GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(275767), // Rule ID 5160 //
     /* 275735 */     // MIs[0] Operand 1
     /* 275735 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275744 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275750 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275758 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 275761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275763 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275765 */     GIR_RootConstrainSelectedInstOperands,
     /* 275766 */     // GIR_Coverage, 5160,
     /* 275766 */     GIR_EraseRootFromParent_Done,
     /* 275767 */   // Label 5568: @275767
     /* 275767 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(275804), // Rule ID 5167 //
     /* 275772 */     // MIs[0] Operand 1
     /* 275772 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 275777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275781 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275787 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275793 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275795 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 275798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275802 */     GIR_RootConstrainSelectedInstOperands,
     /* 275803 */     // GIR_Coverage, 5167,
     /* 275803 */     GIR_EraseRootFromParent_Done,
     /* 275804 */   // Label 5569: @275804
     /* 275804 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(275841), // Rule ID 5174 //
     /* 275809 */     // MIs[0] Operand 1
     /* 275809 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275818 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275824 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275826 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275832 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 275835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275839 */     GIR_RootConstrainSelectedInstOperands,
     /* 275840 */     // GIR_Coverage, 5174,
     /* 275840 */     GIR_EraseRootFromParent_Done,
     /* 275841 */   // Label 5570: @275841
     /* 275841 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(275878), // Rule ID 5181 //
     /* 275846 */     // MIs[0] Operand 1
     /* 275846 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 275851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275855 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275861 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275869 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 275872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275876 */     GIR_RootConstrainSelectedInstOperands,
     /* 275877 */     // GIR_Coverage, 5181,
     /* 275877 */     GIR_EraseRootFromParent_Done,
     /* 275878 */   // Label 5571: @275878
     /* 275878 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(275915), // Rule ID 5188 //
     /* 275883 */     // MIs[0] Operand 1
     /* 275883 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 275888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 275892 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275898 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275906 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 275909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 275913 */     GIR_RootConstrainSelectedInstOperands,
     /* 275914 */     // GIR_Coverage, 5188,
     /* 275914 */     GIR_EraseRootFromParent_Done,
     /* 275915 */   // Label 5572: @275915
     /* 275915 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(275955), // Rule ID 727 //
     /* 275920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275923 */     // MIs[0] Operand 1
     /* 275923 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 275928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275936 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275942 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275944 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275946 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 275949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275953 */     GIR_RootConstrainSelectedInstOperands,
     /* 275954 */     // GIR_Coverage, 727,
     /* 275954 */     GIR_EraseRootFromParent_Done,
     /* 275955 */   // Label 5573: @275955
     /* 275955 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(275995), // Rule ID 739 //
     /* 275960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 275963 */     // MIs[0] Operand 1
     /* 275963 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 275968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 275972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 275976 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 275982 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 275984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 275986 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 275986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 275989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 275991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 275993 */     GIR_RootConstrainSelectedInstOperands,
     /* 275994 */     // GIR_Coverage, 739,
     /* 275994 */     GIR_EraseRootFromParent_Done,
     /* 275995 */   // Label 5574: @275995
     /* 275995 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(276035), // Rule ID 740 //
     /* 276000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276003 */     // MIs[0] Operand 1
     /* 276003 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276016 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276022 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 276024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276026 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 276029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276033 */     GIR_RootConstrainSelectedInstOperands,
     /* 276034 */     // GIR_Coverage, 740,
     /* 276034 */     GIR_EraseRootFromParent_Done,
     /* 276035 */   // Label 5575: @276035
     /* 276035 */   GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(276075), // Rule ID 748 //
     /* 276040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276043 */     // MIs[0] Operand 1
     /* 276043 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276056 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276062 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276066 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 276069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276073 */     GIR_RootConstrainSelectedInstOperands,
     /* 276074 */     // GIR_Coverage, 748,
     /* 276074 */     GIR_EraseRootFromParent_Done,
     /* 276075 */   // Label 5576: @276075
     /* 276075 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(276112), // Rule ID 5125 //
     /* 276080 */     // MIs[0] Operand 1
     /* 276080 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276093 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276099 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276103 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 276106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276110 */     GIR_RootConstrainSelectedInstOperands,
     /* 276111 */     // GIR_Coverage, 5125,
     /* 276111 */     GIR_EraseRootFromParent_Done,
     /* 276112 */   // Label 5577: @276112
     /* 276112 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(276149), // Rule ID 5132 //
     /* 276117 */     // MIs[0] Operand 1
     /* 276117 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276130 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276136 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276140 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 276143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276147 */     GIR_RootConstrainSelectedInstOperands,
     /* 276148 */     // GIR_Coverage, 5132,
     /* 276148 */     GIR_EraseRootFromParent_Done,
     /* 276149 */   // Label 5578: @276149
     /* 276149 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(276186), // Rule ID 5139 //
     /* 276154 */     // MIs[0] Operand 1
     /* 276154 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276167 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276173 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276177 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 276180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276184 */     GIR_RootConstrainSelectedInstOperands,
     /* 276185 */     // GIR_Coverage, 5139,
     /* 276185 */     GIR_EraseRootFromParent_Done,
     /* 276186 */   // Label 5579: @276186
     /* 276186 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(276223), // Rule ID 5146 //
     /* 276191 */     // MIs[0] Operand 1
     /* 276191 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 276196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276204 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276210 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276214 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 276217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276221 */     GIR_RootConstrainSelectedInstOperands,
     /* 276222 */     // GIR_Coverage, 5146,
     /* 276222 */     GIR_EraseRootFromParent_Done,
     /* 276223 */   // Label 5580: @276223
     /* 276223 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(276260), // Rule ID 5153 //
     /* 276228 */     // MIs[0] Operand 1
     /* 276228 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276241 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276247 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276251 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 276251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 276254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276258 */     GIR_RootConstrainSelectedInstOperands,
     /* 276259 */     // GIR_Coverage, 5153,
     /* 276259 */     GIR_EraseRootFromParent_Done,
     /* 276260 */   // Label 5581: @276260
     /* 276260 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(276292), // Rule ID 1126 //
     /* 276265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276268 */     // MIs[0] Operand 1
     /* 276268 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276281 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 276284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276290 */     GIR_RootConstrainSelectedInstOperands,
     /* 276291 */     // GIR_Coverage, 1126,
     /* 276291 */     GIR_EraseRootFromParent_Done,
     /* 276292 */   // Label 5582: @276292
     /* 276292 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(276324), // Rule ID 1133 //
     /* 276297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276300 */     // MIs[0] Operand 1
     /* 276300 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276313 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 276316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276320 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276322 */     GIR_RootConstrainSelectedInstOperands,
     /* 276323 */     // GIR_Coverage, 1133,
     /* 276323 */     GIR_EraseRootFromParent_Done,
     /* 276324 */   // Label 5583: @276324
     /* 276324 */   GIM_Try, /*On fail goto*//*Label 5584*/ GIMT_Encode4(276356), // Rule ID 1140 //
     /* 276329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276332 */     // MIs[0] Operand 1
     /* 276332 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276345 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 276348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276354 */     GIR_RootConstrainSelectedInstOperands,
     /* 276355 */     // GIR_Coverage, 1140,
     /* 276355 */     GIR_EraseRootFromParent_Done,
     /* 276356 */   // Label 5584: @276356
     /* 276356 */   GIM_Try, /*On fail goto*//*Label 5585*/ GIMT_Encode4(276388), // Rule ID 1147 //
     /* 276361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276364 */     // MIs[0] Operand 1
     /* 276364 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 276369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276377 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 276380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276386 */     GIR_RootConstrainSelectedInstOperands,
     /* 276387 */     // GIR_Coverage, 1147,
     /* 276387 */     GIR_EraseRootFromParent_Done,
     /* 276388 */   // Label 5585: @276388
     /* 276388 */   GIM_Try, /*On fail goto*//*Label 5586*/ GIMT_Encode4(276420), // Rule ID 1154 //
     /* 276393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276396 */     // MIs[0] Operand 1
     /* 276396 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 276401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276409 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 276412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276418 */     GIR_RootConstrainSelectedInstOperands,
     /* 276419 */     // GIR_Coverage, 1154,
     /* 276419 */     GIR_EraseRootFromParent_Done,
     /* 276420 */   // Label 5586: @276420
     /* 276420 */   GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(276449), // Rule ID 5062 //
     /* 276425 */     // MIs[0] Operand 1
     /* 276425 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276438 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 276441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276447 */     GIR_RootConstrainSelectedInstOperands,
     /* 276448 */     // GIR_Coverage, 5062,
     /* 276448 */     GIR_EraseRootFromParent_Done,
     /* 276449 */   // Label 5587: @276449
     /* 276449 */   GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(276478), // Rule ID 5069 //
     /* 276454 */     // MIs[0] Operand 1
     /* 276454 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276467 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 276470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276476 */     GIR_RootConstrainSelectedInstOperands,
     /* 276477 */     // GIR_Coverage, 5069,
     /* 276477 */     GIR_EraseRootFromParent_Done,
     /* 276478 */   // Label 5588: @276478
     /* 276478 */   GIM_Try, /*On fail goto*//*Label 5589*/ GIMT_Encode4(276507), // Rule ID 5076 //
     /* 276483 */     // MIs[0] Operand 1
     /* 276483 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276496 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 276499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276505 */     GIR_RootConstrainSelectedInstOperands,
     /* 276506 */     // GIR_Coverage, 5076,
     /* 276506 */     GIR_EraseRootFromParent_Done,
     /* 276507 */   // Label 5589: @276507
     /* 276507 */   GIM_Try, /*On fail goto*//*Label 5590*/ GIMT_Encode4(276536), // Rule ID 5083 //
     /* 276512 */     // MIs[0] Operand 1
     /* 276512 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 276517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276521 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276525 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 276528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276534 */     GIR_RootConstrainSelectedInstOperands,
     /* 276535 */     // GIR_Coverage, 5083,
     /* 276535 */     GIR_EraseRootFromParent_Done,
     /* 276536 */   // Label 5590: @276536
     /* 276536 */   GIM_Try, /*On fail goto*//*Label 5591*/ GIMT_Encode4(276565), // Rule ID 5090 //
     /* 276541 */     // MIs[0] Operand 1
     /* 276541 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 276546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276554 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 276554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 276557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276563 */     GIR_RootConstrainSelectedInstOperands,
     /* 276564 */     // GIR_Coverage, 5090,
     /* 276564 */     GIR_EraseRootFromParent_Done,
     /* 276565 */   // Label 5591: @276565
     /* 276565 */   GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(276594), // Rule ID 5097 //
     /* 276570 */     // MIs[0] Operand 1
     /* 276570 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 276575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276583 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 276583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 276586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276592 */     GIR_RootConstrainSelectedInstOperands,
     /* 276593 */     // GIR_Coverage, 5097,
     /* 276593 */     GIR_EraseRootFromParent_Done,
     /* 276594 */   // Label 5592: @276594
     /* 276594 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(276623), // Rule ID 5104 //
     /* 276599 */     // MIs[0] Operand 1
     /* 276599 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276612 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 276612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 276615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276621 */     GIR_RootConstrainSelectedInstOperands,
     /* 276622 */     // GIR_Coverage, 5104,
     /* 276622 */     GIR_EraseRootFromParent_Done,
     /* 276623 */   // Label 5593: @276623
     /* 276623 */   GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(276652), // Rule ID 5111 //
     /* 276628 */     // MIs[0] Operand 1
     /* 276628 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 276633 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276637 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276641 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 276641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 276644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276650 */     GIR_RootConstrainSelectedInstOperands,
     /* 276651 */     // GIR_Coverage, 5111,
     /* 276651 */     GIR_EraseRootFromParent_Done,
     /* 276652 */   // Label 5594: @276652
     /* 276652 */   GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(276681), // Rule ID 5118 //
     /* 276657 */     // MIs[0] Operand 1
     /* 276657 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 276662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 276670 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 276670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 276673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 276677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 276679 */     GIR_RootConstrainSelectedInstOperands,
     /* 276680 */     // GIR_Coverage, 5118,
     /* 276680 */     GIR_EraseRootFromParent_Done,
     /* 276681 */   // Label 5595: @276681
     /* 276681 */   GIM_Reject,
     /* 276682 */ // Label 5565: @276682
     /* 276682 */ GIM_Reject,
     /* 276683 */ // Label 5456: @276683
     /* 276683 */ GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(277730),
     /* 276688 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 276691 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 276694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276698 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(276738), // Rule ID 750 //
     /* 276703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276706 */     // MIs[0] Operand 1
     /* 276706 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276715 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276721 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276729 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 276732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276736 */     GIR_RootConstrainSelectedInstOperands,
     /* 276737 */     // GIR_Coverage, 750,
     /* 276737 */     GIR_EraseRootFromParent_Done,
     /* 276738 */   // Label 5597: @276738
     /* 276738 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(276778), // Rule ID 757 //
     /* 276743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276746 */     // MIs[0] Operand 1
     /* 276746 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276755 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276761 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276769 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 276772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276776 */     GIR_RootConstrainSelectedInstOperands,
     /* 276777 */     // GIR_Coverage, 757,
     /* 276777 */     GIR_EraseRootFromParent_Done,
     /* 276778 */   // Label 5598: @276778
     /* 276778 */   GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(276815), // Rule ID 5155 //
     /* 276783 */     // MIs[0] Operand 1
     /* 276783 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276792 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276798 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276806 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 276809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276813 */     GIR_RootConstrainSelectedInstOperands,
     /* 276814 */     // GIR_Coverage, 5155,
     /* 276814 */     GIR_EraseRootFromParent_Done,
     /* 276815 */   // Label 5599: @276815
     /* 276815 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(276852), // Rule ID 5162 //
     /* 276820 */     // MIs[0] Operand 1
     /* 276820 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 276825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276829 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276835 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276841 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276843 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 276846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276850 */     GIR_RootConstrainSelectedInstOperands,
     /* 276851 */     // GIR_Coverage, 5162,
     /* 276851 */     GIR_EraseRootFromParent_Done,
     /* 276852 */   // Label 5600: @276852
     /* 276852 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(276889), // Rule ID 5169 //
     /* 276857 */     // MIs[0] Operand 1
     /* 276857 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 276862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276866 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276872 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276880 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 276883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276887 */     GIR_RootConstrainSelectedInstOperands,
     /* 276888 */     // GIR_Coverage, 5169,
     /* 276888 */     GIR_EraseRootFromParent_Done,
     /* 276889 */   // Label 5601: @276889
     /* 276889 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(276926), // Rule ID 5176 //
     /* 276894 */     // MIs[0] Operand 1
     /* 276894 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 276899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276903 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276909 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276915 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276917 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 276920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276924 */     GIR_RootConstrainSelectedInstOperands,
     /* 276925 */     // GIR_Coverage, 5176,
     /* 276925 */     GIR_EraseRootFromParent_Done,
     /* 276926 */   // Label 5602: @276926
     /* 276926 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(276963), // Rule ID 5183 //
     /* 276931 */     // MIs[0] Operand 1
     /* 276931 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 276936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 276940 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276946 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276954 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 276957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 276961 */     GIR_RootConstrainSelectedInstOperands,
     /* 276962 */     // GIR_Coverage, 5183,
     /* 276962 */     GIR_EraseRootFromParent_Done,
     /* 276963 */   // Label 5603: @276963
     /* 276963 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(277003), // Rule ID 722 //
     /* 276968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 276971 */     // MIs[0] Operand 1
     /* 276971 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 276976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 276980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 276984 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 276990 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 276992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 276994 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 276994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 276997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 276999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277001 */     GIR_RootConstrainSelectedInstOperands,
     /* 277002 */     // GIR_Coverage, 722,
     /* 277002 */     GIR_EraseRootFromParent_Done,
     /* 277003 */   // Label 5604: @277003
     /* 277003 */   GIM_Try, /*On fail goto*//*Label 5605*/ GIMT_Encode4(277043), // Rule ID 729 //
     /* 277008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277011 */     // MIs[0] Operand 1
     /* 277011 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277024 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277030 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277034 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 277037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277041 */     GIR_RootConstrainSelectedInstOperands,
     /* 277042 */     // GIR_Coverage, 729,
     /* 277042 */     GIR_EraseRootFromParent_Done,
     /* 277043 */   // Label 5605: @277043
     /* 277043 */   GIM_Try, /*On fail goto*//*Label 5606*/ GIMT_Encode4(277083), // Rule ID 730 //
     /* 277048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277051 */     // MIs[0] Operand 1
     /* 277051 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277064 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277070 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 277072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277074 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 277077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277081 */     GIR_RootConstrainSelectedInstOperands,
     /* 277082 */     // GIR_Coverage, 730,
     /* 277082 */     GIR_EraseRootFromParent_Done,
     /* 277083 */   // Label 5606: @277083
     /* 277083 */   GIM_Try, /*On fail goto*//*Label 5607*/ GIMT_Encode4(277123), // Rule ID 743 //
     /* 277088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277091 */     // MIs[0] Operand 1
     /* 277091 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277104 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277110 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277114 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 277117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277121 */     GIR_RootConstrainSelectedInstOperands,
     /* 277122 */     // GIR_Coverage, 743,
     /* 277122 */     GIR_EraseRootFromParent_Done,
     /* 277123 */   // Label 5607: @277123
     /* 277123 */   GIM_Try, /*On fail goto*//*Label 5608*/ GIMT_Encode4(277160), // Rule ID 5120 //
     /* 277128 */     // MIs[0] Operand 1
     /* 277128 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277141 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277147 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277151 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 277154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277158 */     GIR_RootConstrainSelectedInstOperands,
     /* 277159 */     // GIR_Coverage, 5120,
     /* 277159 */     GIR_EraseRootFromParent_Done,
     /* 277160 */   // Label 5608: @277160
     /* 277160 */   GIM_Try, /*On fail goto*//*Label 5609*/ GIMT_Encode4(277197), // Rule ID 5127 //
     /* 277165 */     // MIs[0] Operand 1
     /* 277165 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277178 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277184 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277188 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 277191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277195 */     GIR_RootConstrainSelectedInstOperands,
     /* 277196 */     // GIR_Coverage, 5127,
     /* 277196 */     GIR_EraseRootFromParent_Done,
     /* 277197 */   // Label 5609: @277197
     /* 277197 */   GIM_Try, /*On fail goto*//*Label 5610*/ GIMT_Encode4(277234), // Rule ID 5134 //
     /* 277202 */     // MIs[0] Operand 1
     /* 277202 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277215 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277221 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277225 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 277228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277232 */     GIR_RootConstrainSelectedInstOperands,
     /* 277233 */     // GIR_Coverage, 5134,
     /* 277233 */     GIR_EraseRootFromParent_Done,
     /* 277234 */   // Label 5610: @277234
     /* 277234 */   GIM_Try, /*On fail goto*//*Label 5611*/ GIMT_Encode4(277271), // Rule ID 5141 //
     /* 277239 */     // MIs[0] Operand 1
     /* 277239 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277252 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277258 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277262 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 277265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277269 */     GIR_RootConstrainSelectedInstOperands,
     /* 277270 */     // GIR_Coverage, 5141,
     /* 277270 */     GIR_EraseRootFromParent_Done,
     /* 277271 */   // Label 5611: @277271
     /* 277271 */   GIM_Try, /*On fail goto*//*Label 5612*/ GIMT_Encode4(277308), // Rule ID 5148 //
     /* 277276 */     // MIs[0] Operand 1
     /* 277276 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 277281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 277289 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277295 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277299 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 277299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 277302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277306 */     GIR_RootConstrainSelectedInstOperands,
     /* 277307 */     // GIR_Coverage, 5148,
     /* 277307 */     GIR_EraseRootFromParent_Done,
     /* 277308 */   // Label 5612: @277308
     /* 277308 */   GIM_Try, /*On fail goto*//*Label 5613*/ GIMT_Encode4(277340), // Rule ID 1121 //
     /* 277313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277316 */     // MIs[0] Operand 1
     /* 277316 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277329 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 277332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277338 */     GIR_RootConstrainSelectedInstOperands,
     /* 277339 */     // GIR_Coverage, 1121,
     /* 277339 */     GIR_EraseRootFromParent_Done,
     /* 277340 */   // Label 5613: @277340
     /* 277340 */   GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(277372), // Rule ID 1128 //
     /* 277345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277348 */     // MIs[0] Operand 1
     /* 277348 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277361 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 277364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277370 */     GIR_RootConstrainSelectedInstOperands,
     /* 277371 */     // GIR_Coverage, 1128,
     /* 277371 */     GIR_EraseRootFromParent_Done,
     /* 277372 */   // Label 5614: @277372
     /* 277372 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(277404), // Rule ID 1135 //
     /* 277377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277380 */     // MIs[0] Operand 1
     /* 277380 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277393 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 277396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277402 */     GIR_RootConstrainSelectedInstOperands,
     /* 277403 */     // GIR_Coverage, 1135,
     /* 277403 */     GIR_EraseRootFromParent_Done,
     /* 277404 */   // Label 5615: @277404
     /* 277404 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(277436), // Rule ID 1142 //
     /* 277409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277412 */     // MIs[0] Operand 1
     /* 277412 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 277417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277425 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 277428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277434 */     GIR_RootConstrainSelectedInstOperands,
     /* 277435 */     // GIR_Coverage, 1142,
     /* 277435 */     GIR_EraseRootFromParent_Done,
     /* 277436 */   // Label 5616: @277436
     /* 277436 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(277468), // Rule ID 1149 //
     /* 277441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277444 */     // MIs[0] Operand 1
     /* 277444 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 277449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277457 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 277460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277466 */     GIR_RootConstrainSelectedInstOperands,
     /* 277467 */     // GIR_Coverage, 1149,
     /* 277467 */     GIR_EraseRootFromParent_Done,
     /* 277468 */   // Label 5617: @277468
     /* 277468 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(277497), // Rule ID 5057 //
     /* 277473 */     // MIs[0] Operand 1
     /* 277473 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277486 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 277489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277495 */     GIR_RootConstrainSelectedInstOperands,
     /* 277496 */     // GIR_Coverage, 5057,
     /* 277496 */     GIR_EraseRootFromParent_Done,
     /* 277497 */   // Label 5618: @277497
     /* 277497 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(277526), // Rule ID 5064 //
     /* 277502 */     // MIs[0] Operand 1
     /* 277502 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277515 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 277518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277524 */     GIR_RootConstrainSelectedInstOperands,
     /* 277525 */     // GIR_Coverage, 5064,
     /* 277525 */     GIR_EraseRootFromParent_Done,
     /* 277526 */   // Label 5619: @277526
     /* 277526 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(277555), // Rule ID 5071 //
     /* 277531 */     // MIs[0] Operand 1
     /* 277531 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277544 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 277547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277553 */     GIR_RootConstrainSelectedInstOperands,
     /* 277554 */     // GIR_Coverage, 5071,
     /* 277554 */     GIR_EraseRootFromParent_Done,
     /* 277555 */   // Label 5620: @277555
     /* 277555 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(277584), // Rule ID 5078 //
     /* 277560 */     // MIs[0] Operand 1
     /* 277560 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 277565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277569 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277573 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 277576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277582 */     GIR_RootConstrainSelectedInstOperands,
     /* 277583 */     // GIR_Coverage, 5078,
     /* 277583 */     GIR_EraseRootFromParent_Done,
     /* 277584 */   // Label 5621: @277584
     /* 277584 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(277613), // Rule ID 5085 //
     /* 277589 */     // MIs[0] Operand 1
     /* 277589 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 277594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277602 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 277602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 277605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277611 */     GIR_RootConstrainSelectedInstOperands,
     /* 277612 */     // GIR_Coverage, 5085,
     /* 277612 */     GIR_EraseRootFromParent_Done,
     /* 277613 */   // Label 5622: @277613
     /* 277613 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(277642), // Rule ID 5092 //
     /* 277618 */     // MIs[0] Operand 1
     /* 277618 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277627 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277631 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 277631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 277634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277640 */     GIR_RootConstrainSelectedInstOperands,
     /* 277641 */     // GIR_Coverage, 5092,
     /* 277641 */     GIR_EraseRootFromParent_Done,
     /* 277642 */   // Label 5623: @277642
     /* 277642 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(277671), // Rule ID 5099 //
     /* 277647 */     // MIs[0] Operand 1
     /* 277647 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 277652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277660 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 277660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 277663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277669 */     GIR_RootConstrainSelectedInstOperands,
     /* 277670 */     // GIR_Coverage, 5099,
     /* 277670 */     GIR_EraseRootFromParent_Done,
     /* 277671 */   // Label 5624: @277671
     /* 277671 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(277700), // Rule ID 5106 //
     /* 277676 */     // MIs[0] Operand 1
     /* 277676 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 277681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277689 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 277689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 277692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277696 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277698 */     GIR_RootConstrainSelectedInstOperands,
     /* 277699 */     // GIR_Coverage, 5106,
     /* 277699 */     GIR_EraseRootFromParent_Done,
     /* 277700 */   // Label 5625: @277700
     /* 277700 */   GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(277729), // Rule ID 5113 //
     /* 277705 */     // MIs[0] Operand 1
     /* 277705 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 277710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277718 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 277718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 277721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 277725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 277727 */     GIR_RootConstrainSelectedInstOperands,
     /* 277728 */     // GIR_Coverage, 5113,
     /* 277728 */     GIR_EraseRootFromParent_Done,
     /* 277729 */   // Label 5626: @277729
     /* 277729 */   GIM_Reject,
     /* 277730 */ // Label 5596: @277730
     /* 277730 */ GIM_Reject,
     /* 277731 */ // Label 5457: @277731
     /* 277731 */ GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(278778),
     /* 277736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 277739 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 277742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277746 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(277786), // Rule ID 753 //
     /* 277751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277754 */     // MIs[0] Operand 1
     /* 277754 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277763 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277769 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277775 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277777 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 277780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277784 */     GIR_RootConstrainSelectedInstOperands,
     /* 277785 */     // GIR_Coverage, 753,
     /* 277785 */     GIR_EraseRootFromParent_Done,
     /* 277786 */   // Label 5628: @277786
     /* 277786 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(277826), // Rule ID 760 //
     /* 277791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277794 */     // MIs[0] Operand 1
     /* 277794 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277803 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277809 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277817 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 277820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277824 */     GIR_RootConstrainSelectedInstOperands,
     /* 277825 */     // GIR_Coverage, 760,
     /* 277825 */     GIR_EraseRootFromParent_Done,
     /* 277826 */   // Label 5629: @277826
     /* 277826 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(277863), // Rule ID 5158 //
     /* 277831 */     // MIs[0] Operand 1
     /* 277831 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 277836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277840 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277846 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277852 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277854 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 277857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277861 */     GIR_RootConstrainSelectedInstOperands,
     /* 277862 */     // GIR_Coverage, 5158,
     /* 277862 */     GIR_EraseRootFromParent_Done,
     /* 277863 */   // Label 5630: @277863
     /* 277863 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(277900), // Rule ID 5165 //
     /* 277868 */     // MIs[0] Operand 1
     /* 277868 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 277873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277877 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277883 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277891 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 277894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277898 */     GIR_RootConstrainSelectedInstOperands,
     /* 277899 */     // GIR_Coverage, 5165,
     /* 277899 */     GIR_EraseRootFromParent_Done,
     /* 277900 */   // Label 5631: @277900
     /* 277900 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(277937), // Rule ID 5172 //
     /* 277905 */     // MIs[0] Operand 1
     /* 277905 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 277910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277914 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277920 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277922 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277928 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 277931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277935 */     GIR_RootConstrainSelectedInstOperands,
     /* 277936 */     // GIR_Coverage, 5172,
     /* 277936 */     GIR_EraseRootFromParent_Done,
     /* 277937 */   // Label 5632: @277937
     /* 277937 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(277974), // Rule ID 5179 //
     /* 277942 */     // MIs[0] Operand 1
     /* 277942 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 277947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277951 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277957 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277963 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 277965 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 277965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 277968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 277972 */     GIR_RootConstrainSelectedInstOperands,
     /* 277973 */     // GIR_Coverage, 5179,
     /* 277973 */     GIR_EraseRootFromParent_Done,
     /* 277974 */   // Label 5633: @277974
     /* 277974 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(278011), // Rule ID 5186 //
     /* 277979 */     // MIs[0] Operand 1
     /* 277979 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 277984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 277988 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277994 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 277996 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278002 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 278005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278009 */     GIR_RootConstrainSelectedInstOperands,
     /* 278010 */     // GIR_Coverage, 5186,
     /* 278010 */     GIR_EraseRootFromParent_Done,
     /* 278011 */   // Label 5634: @278011
     /* 278011 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(278051), // Rule ID 725 //
     /* 278016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278019 */     // MIs[0] Operand 1
     /* 278019 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278032 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278038 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278040 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278042 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 278045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278049 */     GIR_RootConstrainSelectedInstOperands,
     /* 278050 */     // GIR_Coverage, 725,
     /* 278050 */     GIR_EraseRootFromParent_Done,
     /* 278051 */   // Label 5635: @278051
     /* 278051 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(278091), // Rule ID 735 //
     /* 278056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278059 */     // MIs[0] Operand 1
     /* 278059 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278072 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278078 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278082 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 278085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278089 */     GIR_RootConstrainSelectedInstOperands,
     /* 278090 */     // GIR_Coverage, 735,
     /* 278090 */     GIR_EraseRootFromParent_Done,
     /* 278091 */   // Label 5636: @278091
     /* 278091 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(278131), // Rule ID 736 //
     /* 278096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278099 */     // MIs[0] Operand 1
     /* 278099 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278112 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278118 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 278120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278122 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 278125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278129 */     GIR_RootConstrainSelectedInstOperands,
     /* 278130 */     // GIR_Coverage, 736,
     /* 278130 */     GIR_EraseRootFromParent_Done,
     /* 278131 */   // Label 5637: @278131
     /* 278131 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(278171), // Rule ID 746 //
     /* 278136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278139 */     // MIs[0] Operand 1
     /* 278139 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278152 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278158 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278162 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 278165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278169 */     GIR_RootConstrainSelectedInstOperands,
     /* 278170 */     // GIR_Coverage, 746,
     /* 278170 */     GIR_EraseRootFromParent_Done,
     /* 278171 */   // Label 5638: @278171
     /* 278171 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(278208), // Rule ID 5123 //
     /* 278176 */     // MIs[0] Operand 1
     /* 278176 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278189 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278195 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278199 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 278202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278206 */     GIR_RootConstrainSelectedInstOperands,
     /* 278207 */     // GIR_Coverage, 5123,
     /* 278207 */     GIR_EraseRootFromParent_Done,
     /* 278208 */   // Label 5639: @278208
     /* 278208 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(278245), // Rule ID 5130 //
     /* 278213 */     // MIs[0] Operand 1
     /* 278213 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278226 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278232 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278236 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 278239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278243 */     GIR_RootConstrainSelectedInstOperands,
     /* 278244 */     // GIR_Coverage, 5130,
     /* 278244 */     GIR_EraseRootFromParent_Done,
     /* 278245 */   // Label 5640: @278245
     /* 278245 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(278282), // Rule ID 5137 //
     /* 278250 */     // MIs[0] Operand 1
     /* 278250 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278263 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278269 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278273 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 278276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278280 */     GIR_RootConstrainSelectedInstOperands,
     /* 278281 */     // GIR_Coverage, 5137,
     /* 278281 */     GIR_EraseRootFromParent_Done,
     /* 278282 */   // Label 5641: @278282
     /* 278282 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(278319), // Rule ID 5144 //
     /* 278287 */     // MIs[0] Operand 1
     /* 278287 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 278292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278300 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278306 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278310 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 278313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278317 */     GIR_RootConstrainSelectedInstOperands,
     /* 278318 */     // GIR_Coverage, 5144,
     /* 278318 */     GIR_EraseRootFromParent_Done,
     /* 278319 */   // Label 5642: @278319
     /* 278319 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(278356), // Rule ID 5151 //
     /* 278324 */     // MIs[0] Operand 1
     /* 278324 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 278329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 278337 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278343 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278347 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 278347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 278350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278354 */     GIR_RootConstrainSelectedInstOperands,
     /* 278355 */     // GIR_Coverage, 5151,
     /* 278355 */     GIR_EraseRootFromParent_Done,
     /* 278356 */   // Label 5643: @278356
     /* 278356 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(278388), // Rule ID 1124 //
     /* 278361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278364 */     // MIs[0] Operand 1
     /* 278364 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278377 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 278380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278386 */     GIR_RootConstrainSelectedInstOperands,
     /* 278387 */     // GIR_Coverage, 1124,
     /* 278387 */     GIR_EraseRootFromParent_Done,
     /* 278388 */   // Label 5644: @278388
     /* 278388 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(278420), // Rule ID 1131 //
     /* 278393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278396 */     // MIs[0] Operand 1
     /* 278396 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278409 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 278412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278418 */     GIR_RootConstrainSelectedInstOperands,
     /* 278419 */     // GIR_Coverage, 1131,
     /* 278419 */     GIR_EraseRootFromParent_Done,
     /* 278420 */   // Label 5645: @278420
     /* 278420 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(278452), // Rule ID 1138 //
     /* 278425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278428 */     // MIs[0] Operand 1
     /* 278428 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278441 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 278444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278450 */     GIR_RootConstrainSelectedInstOperands,
     /* 278451 */     // GIR_Coverage, 1138,
     /* 278451 */     GIR_EraseRootFromParent_Done,
     /* 278452 */   // Label 5646: @278452
     /* 278452 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(278484), // Rule ID 1145 //
     /* 278457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278460 */     // MIs[0] Operand 1
     /* 278460 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 278465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278473 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 278476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278482 */     GIR_RootConstrainSelectedInstOperands,
     /* 278483 */     // GIR_Coverage, 1145,
     /* 278483 */     GIR_EraseRootFromParent_Done,
     /* 278484 */   // Label 5647: @278484
     /* 278484 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(278516), // Rule ID 1152 //
     /* 278489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278492 */     // MIs[0] Operand 1
     /* 278492 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 278497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278501 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278505 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 278508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278514 */     GIR_RootConstrainSelectedInstOperands,
     /* 278515 */     // GIR_Coverage, 1152,
     /* 278515 */     GIR_EraseRootFromParent_Done,
     /* 278516 */   // Label 5648: @278516
     /* 278516 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(278545), // Rule ID 5060 //
     /* 278521 */     // MIs[0] Operand 1
     /* 278521 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278534 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 278537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278543 */     GIR_RootConstrainSelectedInstOperands,
     /* 278544 */     // GIR_Coverage, 5060,
     /* 278544 */     GIR_EraseRootFromParent_Done,
     /* 278545 */   // Label 5649: @278545
     /* 278545 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(278574), // Rule ID 5067 //
     /* 278550 */     // MIs[0] Operand 1
     /* 278550 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278563 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 278566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278572 */     GIR_RootConstrainSelectedInstOperands,
     /* 278573 */     // GIR_Coverage, 5067,
     /* 278573 */     GIR_EraseRootFromParent_Done,
     /* 278574 */   // Label 5650: @278574
     /* 278574 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(278603), // Rule ID 5074 //
     /* 278579 */     // MIs[0] Operand 1
     /* 278579 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278592 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 278595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278601 */     GIR_RootConstrainSelectedInstOperands,
     /* 278602 */     // GIR_Coverage, 5074,
     /* 278602 */     GIR_EraseRootFromParent_Done,
     /* 278603 */   // Label 5651: @278603
     /* 278603 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(278632), // Rule ID 5081 //
     /* 278608 */     // MIs[0] Operand 1
     /* 278608 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 278613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278621 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 278624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278630 */     GIR_RootConstrainSelectedInstOperands,
     /* 278631 */     // GIR_Coverage, 5081,
     /* 278631 */     GIR_EraseRootFromParent_Done,
     /* 278632 */   // Label 5652: @278632
     /* 278632 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(278661), // Rule ID 5088 //
     /* 278637 */     // MIs[0] Operand 1
     /* 278637 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 278642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278650 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 278653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278659 */     GIR_RootConstrainSelectedInstOperands,
     /* 278660 */     // GIR_Coverage, 5088,
     /* 278660 */     GIR_EraseRootFromParent_Done,
     /* 278661 */   // Label 5653: @278661
     /* 278661 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(278690), // Rule ID 5095 //
     /* 278666 */     // MIs[0] Operand 1
     /* 278666 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 278671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278679 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 278679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 278682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278688 */     GIR_RootConstrainSelectedInstOperands,
     /* 278689 */     // GIR_Coverage, 5095,
     /* 278689 */     GIR_EraseRootFromParent_Done,
     /* 278690 */   // Label 5654: @278690
     /* 278690 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(278719), // Rule ID 5102 //
     /* 278695 */     // MIs[0] Operand 1
     /* 278695 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 278700 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278708 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 278708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 278711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278715 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278717 */     GIR_RootConstrainSelectedInstOperands,
     /* 278718 */     // GIR_Coverage, 5102,
     /* 278718 */     GIR_EraseRootFromParent_Done,
     /* 278719 */   // Label 5655: @278719
     /* 278719 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(278748), // Rule ID 5109 //
     /* 278724 */     // MIs[0] Operand 1
     /* 278724 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 278729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278737 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 278737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 278740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278746 */     GIR_RootConstrainSelectedInstOperands,
     /* 278747 */     // GIR_Coverage, 5109,
     /* 278747 */     GIR_EraseRootFromParent_Done,
     /* 278748 */   // Label 5656: @278748
     /* 278748 */   GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(278777), // Rule ID 5116 //
     /* 278753 */     // MIs[0] Operand 1
     /* 278753 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 278758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278766 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 278766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 278769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 278773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 278775 */     GIR_RootConstrainSelectedInstOperands,
     /* 278776 */     // GIR_Coverage, 5116,
     /* 278776 */     GIR_EraseRootFromParent_Done,
     /* 278777 */   // Label 5657: @278777
     /* 278777 */   GIM_Reject,
     /* 278778 */ // Label 5627: @278778
     /* 278778 */ GIM_Reject,
     /* 278779 */ // Label 5458: @278779
     /* 278779 */ GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(279826),
     /* 278784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 278787 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 278790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278794 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(278834), // Rule ID 751 //
     /* 278799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278802 */     // MIs[0] Operand 1
     /* 278802 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278811 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278817 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278823 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278825 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 278828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278832 */     GIR_RootConstrainSelectedInstOperands,
     /* 278833 */     // GIR_Coverage, 751,
     /* 278833 */     GIR_EraseRootFromParent_Done,
     /* 278834 */   // Label 5659: @278834
     /* 278834 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(278874), // Rule ID 758 //
     /* 278839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278842 */     // MIs[0] Operand 1
     /* 278842 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278847 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278851 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278857 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278865 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 278868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278872 */     GIR_RootConstrainSelectedInstOperands,
     /* 278873 */     // GIR_Coverage, 758,
     /* 278873 */     GIR_EraseRootFromParent_Done,
     /* 278874 */   // Label 5660: @278874
     /* 278874 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(278911), // Rule ID 5156 //
     /* 278879 */     // MIs[0] Operand 1
     /* 278879 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 278884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278888 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278894 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278902 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 278905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278909 */     GIR_RootConstrainSelectedInstOperands,
     /* 278910 */     // GIR_Coverage, 5156,
     /* 278910 */     GIR_EraseRootFromParent_Done,
     /* 278911 */   // Label 5661: @278911
     /* 278911 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(278948), // Rule ID 5163 //
     /* 278916 */     // MIs[0] Operand 1
     /* 278916 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 278921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278925 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278931 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278937 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278939 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 278942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278946 */     GIR_RootConstrainSelectedInstOperands,
     /* 278947 */     // GIR_Coverage, 5163,
     /* 278947 */     GIR_EraseRootFromParent_Done,
     /* 278948 */   // Label 5662: @278948
     /* 278948 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(278985), // Rule ID 5170 //
     /* 278953 */     // MIs[0] Operand 1
     /* 278953 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 278958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278962 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278968 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 278970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278976 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 278976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 278979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 278983 */     GIR_RootConstrainSelectedInstOperands,
     /* 278984 */     // GIR_Coverage, 5170,
     /* 278984 */     GIR_EraseRootFromParent_Done,
     /* 278985 */   // Label 5663: @278985
     /* 278985 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(279022), // Rule ID 5177 //
     /* 278990 */     // MIs[0] Operand 1
     /* 278990 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 278995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 278999 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279005 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279013 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 279016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279020 */     GIR_RootConstrainSelectedInstOperands,
     /* 279021 */     // GIR_Coverage, 5177,
     /* 279021 */     GIR_EraseRootFromParent_Done,
     /* 279022 */   // Label 5664: @279022
     /* 279022 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(279059), // Rule ID 5184 //
     /* 279027 */     // MIs[0] Operand 1
     /* 279027 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 279032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279036 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279042 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279050 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 279053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 279057 */     GIR_RootConstrainSelectedInstOperands,
     /* 279058 */     // GIR_Coverage, 5184,
     /* 279058 */     GIR_EraseRootFromParent_Done,
     /* 279059 */   // Label 5665: @279059
     /* 279059 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(279099), // Rule ID 723 //
     /* 279064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279067 */     // MIs[0] Operand 1
     /* 279067 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279080 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279086 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279090 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 279093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279097 */     GIR_RootConstrainSelectedInstOperands,
     /* 279098 */     // GIR_Coverage, 723,
     /* 279098 */     GIR_EraseRootFromParent_Done,
     /* 279099 */   // Label 5666: @279099
     /* 279099 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(279139), // Rule ID 731 //
     /* 279104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279107 */     // MIs[0] Operand 1
     /* 279107 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279120 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279126 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279130 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 279133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279137 */     GIR_RootConstrainSelectedInstOperands,
     /* 279138 */     // GIR_Coverage, 731,
     /* 279138 */     GIR_EraseRootFromParent_Done,
     /* 279139 */   // Label 5667: @279139
     /* 279139 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(279179), // Rule ID 732 //
     /* 279144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279147 */     // MIs[0] Operand 1
     /* 279147 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279160 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279166 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 279168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279170 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 279173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279177 */     GIR_RootConstrainSelectedInstOperands,
     /* 279178 */     // GIR_Coverage, 732,
     /* 279178 */     GIR_EraseRootFromParent_Done,
     /* 279179 */   // Label 5668: @279179
     /* 279179 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(279219), // Rule ID 744 //
     /* 279184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279187 */     // MIs[0] Operand 1
     /* 279187 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279200 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279206 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279210 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 279213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279217 */     GIR_RootConstrainSelectedInstOperands,
     /* 279218 */     // GIR_Coverage, 744,
     /* 279218 */     GIR_EraseRootFromParent_Done,
     /* 279219 */   // Label 5669: @279219
     /* 279219 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(279256), // Rule ID 5121 //
     /* 279224 */     // MIs[0] Operand 1
     /* 279224 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279237 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279243 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279247 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 279250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279254 */     GIR_RootConstrainSelectedInstOperands,
     /* 279255 */     // GIR_Coverage, 5121,
     /* 279255 */     GIR_EraseRootFromParent_Done,
     /* 279256 */   // Label 5670: @279256
     /* 279256 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(279293), // Rule ID 5128 //
     /* 279261 */     // MIs[0] Operand 1
     /* 279261 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279274 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279280 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279284 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 279287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279291 */     GIR_RootConstrainSelectedInstOperands,
     /* 279292 */     // GIR_Coverage, 5128,
     /* 279292 */     GIR_EraseRootFromParent_Done,
     /* 279293 */   // Label 5671: @279293
     /* 279293 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(279330), // Rule ID 5135 //
     /* 279298 */     // MIs[0] Operand 1
     /* 279298 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279311 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279317 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279321 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 279324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279328 */     GIR_RootConstrainSelectedInstOperands,
     /* 279329 */     // GIR_Coverage, 5135,
     /* 279329 */     GIR_EraseRootFromParent_Done,
     /* 279330 */   // Label 5672: @279330
     /* 279330 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(279367), // Rule ID 5142 //
     /* 279335 */     // MIs[0] Operand 1
     /* 279335 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 279340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279348 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279354 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279358 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 279361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279365 */     GIR_RootConstrainSelectedInstOperands,
     /* 279366 */     // GIR_Coverage, 5142,
     /* 279366 */     GIR_EraseRootFromParent_Done,
     /* 279367 */   // Label 5673: @279367
     /* 279367 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(279404), // Rule ID 5149 //
     /* 279372 */     // MIs[0] Operand 1
     /* 279372 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 279377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 279385 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 279391 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 279393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279395 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 279395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 279398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279402 */     GIR_RootConstrainSelectedInstOperands,
     /* 279403 */     // GIR_Coverage, 5149,
     /* 279403 */     GIR_EraseRootFromParent_Done,
     /* 279404 */   // Label 5674: @279404
     /* 279404 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(279436), // Rule ID 1122 //
     /* 279409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279412 */     // MIs[0] Operand 1
     /* 279412 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279425 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 279428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279434 */     GIR_RootConstrainSelectedInstOperands,
     /* 279435 */     // GIR_Coverage, 1122,
     /* 279435 */     GIR_EraseRootFromParent_Done,
     /* 279436 */   // Label 5675: @279436
     /* 279436 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(279468), // Rule ID 1129 //
     /* 279441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279444 */     // MIs[0] Operand 1
     /* 279444 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279457 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 279460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279466 */     GIR_RootConstrainSelectedInstOperands,
     /* 279467 */     // GIR_Coverage, 1129,
     /* 279467 */     GIR_EraseRootFromParent_Done,
     /* 279468 */   // Label 5676: @279468
     /* 279468 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(279500), // Rule ID 1136 //
     /* 279473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279476 */     // MIs[0] Operand 1
     /* 279476 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279489 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 279492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279498 */     GIR_RootConstrainSelectedInstOperands,
     /* 279499 */     // GIR_Coverage, 1136,
     /* 279499 */     GIR_EraseRootFromParent_Done,
     /* 279500 */   // Label 5677: @279500
     /* 279500 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(279532), // Rule ID 1143 //
     /* 279505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279508 */     // MIs[0] Operand 1
     /* 279508 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 279513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279517 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279521 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 279524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279530 */     GIR_RootConstrainSelectedInstOperands,
     /* 279531 */     // GIR_Coverage, 1143,
     /* 279531 */     GIR_EraseRootFromParent_Done,
     /* 279532 */   // Label 5678: @279532
     /* 279532 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(279564), // Rule ID 1150 //
     /* 279537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279540 */     // MIs[0] Operand 1
     /* 279540 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 279545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279549 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279553 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 279556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279562 */     GIR_RootConstrainSelectedInstOperands,
     /* 279563 */     // GIR_Coverage, 1150,
     /* 279563 */     GIR_EraseRootFromParent_Done,
     /* 279564 */   // Label 5679: @279564
     /* 279564 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(279593), // Rule ID 5058 //
     /* 279569 */     // MIs[0] Operand 1
     /* 279569 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 279574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279582 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 279585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279591 */     GIR_RootConstrainSelectedInstOperands,
     /* 279592 */     // GIR_Coverage, 5058,
     /* 279592 */     GIR_EraseRootFromParent_Done,
     /* 279593 */   // Label 5680: @279593
     /* 279593 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(279622), // Rule ID 5065 //
     /* 279598 */     // MIs[0] Operand 1
     /* 279598 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 279603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279611 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 279614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279620 */     GIR_RootConstrainSelectedInstOperands,
     /* 279621 */     // GIR_Coverage, 5065,
     /* 279621 */     GIR_EraseRootFromParent_Done,
     /* 279622 */   // Label 5681: @279622
     /* 279622 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(279651), // Rule ID 5072 //
     /* 279627 */     // MIs[0] Operand 1
     /* 279627 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 279632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279636 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279640 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 279643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279647 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279649 */     GIR_RootConstrainSelectedInstOperands,
     /* 279650 */     // GIR_Coverage, 5072,
     /* 279650 */     GIR_EraseRootFromParent_Done,
     /* 279651 */   // Label 5682: @279651
     /* 279651 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(279680), // Rule ID 5079 //
     /* 279656 */     // MIs[0] Operand 1
     /* 279656 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 279661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279669 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 279672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279678 */     GIR_RootConstrainSelectedInstOperands,
     /* 279679 */     // GIR_Coverage, 5079,
     /* 279679 */     GIR_EraseRootFromParent_Done,
     /* 279680 */   // Label 5683: @279680
     /* 279680 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(279709), // Rule ID 5086 //
     /* 279685 */     // MIs[0] Operand 1
     /* 279685 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 279690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279698 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 279698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 279701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279707 */     GIR_RootConstrainSelectedInstOperands,
     /* 279708 */     // GIR_Coverage, 5086,
     /* 279708 */     GIR_EraseRootFromParent_Done,
     /* 279709 */   // Label 5684: @279709
     /* 279709 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(279738), // Rule ID 5093 //
     /* 279714 */     // MIs[0] Operand 1
     /* 279714 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 279719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279727 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 279727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 279730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279736 */     GIR_RootConstrainSelectedInstOperands,
     /* 279737 */     // GIR_Coverage, 5093,
     /* 279737 */     GIR_EraseRootFromParent_Done,
     /* 279738 */   // Label 5685: @279738
     /* 279738 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(279767), // Rule ID 5100 //
     /* 279743 */     // MIs[0] Operand 1
     /* 279743 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 279748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279752 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279756 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 279756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 279759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279765 */     GIR_RootConstrainSelectedInstOperands,
     /* 279766 */     // GIR_Coverage, 5100,
     /* 279766 */     GIR_EraseRootFromParent_Done,
     /* 279767 */   // Label 5686: @279767
     /* 279767 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(279796), // Rule ID 5107 //
     /* 279772 */     // MIs[0] Operand 1
     /* 279772 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 279777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279785 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 279785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 279788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279794 */     GIR_RootConstrainSelectedInstOperands,
     /* 279795 */     // GIR_Coverage, 5107,
     /* 279795 */     GIR_EraseRootFromParent_Done,
     /* 279796 */   // Label 5687: @279796
     /* 279796 */   GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(279825), // Rule ID 5114 //
     /* 279801 */     // MIs[0] Operand 1
     /* 279801 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 279806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279814 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 279814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 279817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 279821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 279823 */     GIR_RootConstrainSelectedInstOperands,
     /* 279824 */     // GIR_Coverage, 5114,
     /* 279824 */     GIR_EraseRootFromParent_Done,
     /* 279825 */   // Label 5688: @279825
     /* 279825 */   GIM_Reject,
     /* 279826 */ // Label 5658: @279826
     /* 279826 */ GIM_Reject,
     /* 279827 */ // Label 5459: @279827
     /* 279827 */ GIM_Reject,
     /* 279828 */ // Label 50: @279828
     /* 279828 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5701*/ GIMT_Encode4(280872),
     /* 279839 */ /*GILLT_nxv1s1*//*Label 5689*/ GIMT_Encode4(279887),
     /* 279843 */ /*GILLT_nxv2s1*//*Label 5690*/ GIMT_Encode4(279916),
     /* 279847 */ /*GILLT_nxv2s16*//*Label 5691*/ GIMT_Encode4(279945),
     /* 279851 */ /*GILLT_nxv2s32*//*Label 5692*/ GIMT_Encode4(280030),
     /* 279855 */ /*GILLT_nxv2s64*//*Label 5693*/ GIMT_Encode4(280115),
     /* 279859 */ /*GILLT_nxv4s1*//*Label 5694*/ GIMT_Encode4(280281),
     /* 279863 */ /*GILLT_nxv4s16*//*Label 5695*/ GIMT_Encode4(280310),
     /* 279867 */ /*GILLT_nxv4s32*//*Label 5696*/ GIMT_Encode4(280395),
     /* 279871 */ /*GILLT_nxv8s1*//*Label 5697*/ GIMT_Encode4(280561),
     /* 279875 */ /*GILLT_nxv8s16*//*Label 5698*/ GIMT_Encode4(280590),
     /* 279879 */ /*GILLT_nxv16s1*//*Label 5699*/ GIMT_Encode4(280756),
     /* 279883 */ /*GILLT_nxv16s8*//*Label 5700*/ GIMT_Encode4(280785),
     /* 279887 */ // Label 5689: @279887
     /* 279887 */ GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(279915), // Rule ID 8398 //
     /* 279892 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279895 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 279898 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 279901 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 279904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 279908 */   // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 279908 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 279913 */   GIR_RootConstrainSelectedInstOperands,
     /* 279914 */   // GIR_Coverage, 8398,
     /* 279914 */   GIR_Done,
     /* 279915 */ // Label 5702: @279915
     /* 279915 */ GIM_Reject,
     /* 279916 */ // Label 5690: @279916
     /* 279916 */ GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(279944), // Rule ID 8397 //
     /* 279921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 279927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 279930 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 279933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 279937 */   // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 279937 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 279942 */   GIR_RootConstrainSelectedInstOperands,
     /* 279943 */   // GIR_Coverage, 8397,
     /* 279943 */   GIR_Done,
     /* 279944 */ // Label 5703: @279944
     /* 279944 */ GIM_Reject,
     /* 279945 */ // Label 5691: @279945
     /* 279945 */ GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(280029),
     /* 279950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 279953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 279956 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 279959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 279963 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(280013), // Rule ID 3159 //
     /* 279968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 279971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 279975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 279979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 279983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 279987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 279991 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 279995 */     // MIs[2] Operand 1
     /* 279995 */     // No operand predicates
     /* 279995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 279997 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv2f16:{ *:[nxv2f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 279997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 280000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 280002 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 280004 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 280006 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 280011 */     GIR_RootConstrainSelectedInstOperands,
     /* 280012 */     // GIR_Coverage, 3159,
     /* 280012 */     GIR_EraseRootFromParent_Done,
     /* 280013 */   // Label 5705: @280013
     /* 280013 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(280028), // Rule ID 2739 //
     /* 280018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280021 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 280021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 280026 */     GIR_RootConstrainSelectedInstOperands,
     /* 280027 */     // GIR_Coverage, 2739,
     /* 280027 */     GIR_Done,
     /* 280028 */   // Label 5706: @280028
     /* 280028 */   GIM_Reject,
     /* 280029 */ // Label 5704: @280029
     /* 280029 */ GIM_Reject,
     /* 280030 */ // Label 5692: @280030
     /* 280030 */ GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(280114),
     /* 280035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 280038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 280041 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 280044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280048 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(280098), // Rule ID 3161 //
     /* 280053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 280064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 280068 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280072 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 280076 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 280080 */     // MIs[2] Operand 1
     /* 280080 */     // No operand predicates
     /* 280080 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280082 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv2f32:{ *:[nxv2f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 280082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 280085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 280087 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 280089 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 280091 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 280096 */     GIR_RootConstrainSelectedInstOperands,
     /* 280097 */     // GIR_Coverage, 3161,
     /* 280097 */     GIR_EraseRootFromParent_Done,
     /* 280098 */   // Label 5708: @280098
     /* 280098 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(280113), // Rule ID 2740 //
     /* 280103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280106 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 280106 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 280111 */     GIR_RootConstrainSelectedInstOperands,
     /* 280112 */     // GIR_Coverage, 2740,
     /* 280112 */     GIR_Done,
     /* 280113 */   // Label 5709: @280113
     /* 280113 */   GIM_Reject,
     /* 280114 */ // Label 5707: @280114
     /* 280114 */ GIM_Reject,
     /* 280115 */ // Label 5693: @280115
     /* 280115 */ GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(280280),
     /* 280120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 280123 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 280126 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(280183), // Rule ID 3162 //
     /* 280131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 280137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 280149 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 280153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 280161 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 280165 */     // MIs[2] Operand 1
     /* 280165 */     // No operand predicates
     /* 280165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280167 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8), nxv2f64:{ *:[nxv2f64] }:$zd)  =>  (FCPY_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 280167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_D),
     /* 280170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 280172 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 280174 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 280176 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 280181 */     GIR_RootConstrainSelectedInstOperands,
     /* 280182 */     // GIR_Coverage, 3162,
     /* 280182 */     GIR_EraseRootFromParent_Done,
     /* 280183 */   // Label 5711: @280183
     /* 280183 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(280235), // Rule ID 7448 //
     /* 280188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 280203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 280207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 280211 */     // MIs[0] Op2
     /* 280211 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 280216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280218 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 280218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 280221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 280223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 280225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 280229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 280233 */     GIR_RootConstrainSelectedInstOperands,
     /* 280234 */     // GIR_Coverage, 7448,
     /* 280234 */     GIR_EraseRootFromParent_Done,
     /* 280235 */   // Label 5712: @280235
     /* 280235 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(280257), // Rule ID 2735 //
     /* 280240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 280246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280250 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 280250 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 280255 */     GIR_RootConstrainSelectedInstOperands,
     /* 280256 */     // GIR_Coverage, 2735,
     /* 280256 */     GIR_Done,
     /* 280257 */   // Label 5713: @280257
     /* 280257 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(280279), // Rule ID 2741 //
     /* 280262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 280268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280272 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 280272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 280277 */     GIR_RootConstrainSelectedInstOperands,
     /* 280278 */     // GIR_Coverage, 2741,
     /* 280278 */     GIR_Done,
     /* 280279 */   // Label 5714: @280279
     /* 280279 */   GIM_Reject,
     /* 280280 */ // Label 5710: @280280
     /* 280280 */ GIM_Reject,
     /* 280281 */ // Label 5694: @280281
     /* 280281 */ GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(280309), // Rule ID 8396 //
     /* 280286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 280292 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 280295 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 280298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 280302 */   // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 280302 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 280307 */   GIR_RootConstrainSelectedInstOperands,
     /* 280308 */   // GIR_Coverage, 8396,
     /* 280308 */   GIR_Done,
     /* 280309 */ // Label 5715: @280309
     /* 280309 */ GIM_Reject,
     /* 280310 */ // Label 5695: @280310
     /* 280310 */ GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(280394),
     /* 280315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 280318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 280321 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 280324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280328 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(280378), // Rule ID 3158 //
     /* 280333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 280344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 280356 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 280360 */     // MIs[2] Operand 1
     /* 280360 */     // No operand predicates
     /* 280360 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280362 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv4f16:{ *:[nxv4f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 280362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 280365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 280367 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 280369 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 280371 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 280376 */     GIR_RootConstrainSelectedInstOperands,
     /* 280377 */     // GIR_Coverage, 3158,
     /* 280377 */     GIR_EraseRootFromParent_Done,
     /* 280378 */   // Label 5717: @280378
     /* 280378 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(280393), // Rule ID 2737 //
     /* 280383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280386 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 280386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 280391 */     GIR_RootConstrainSelectedInstOperands,
     /* 280392 */     // GIR_Coverage, 2737,
     /* 280392 */     GIR_Done,
     /* 280393 */   // Label 5718: @280393
     /* 280393 */   GIM_Reject,
     /* 280394 */ // Label 5716: @280394
     /* 280394 */ GIM_Reject,
     /* 280395 */ // Label 5696: @280395
     /* 280395 */ GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(280560),
     /* 280400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 280403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 280406 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(280463), // Rule ID 3160 //
     /* 280411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 280417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 280429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 280433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 280441 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 280445 */     // MIs[2] Operand 1
     /* 280445 */     // No operand predicates
     /* 280445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280447 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv4f32:{ *:[nxv4f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 280447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 280450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 280452 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 280454 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 280456 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 280461 */     GIR_RootConstrainSelectedInstOperands,
     /* 280462 */     // GIR_Coverage, 3160,
     /* 280462 */     GIR_EraseRootFromParent_Done,
     /* 280463 */   // Label 5720: @280463
     /* 280463 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(280515), // Rule ID 7446 //
     /* 280468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 280483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 280487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 280491 */     // MIs[0] Op2
     /* 280491 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 280496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280498 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 280498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 280501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 280503 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 280505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 280509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 280513 */     GIR_RootConstrainSelectedInstOperands,
     /* 280514 */     // GIR_Coverage, 7446,
     /* 280514 */     GIR_EraseRootFromParent_Done,
     /* 280515 */   // Label 5721: @280515
     /* 280515 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(280537), // Rule ID 2734 //
     /* 280520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 280526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280530 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 280530 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 280535 */     GIR_RootConstrainSelectedInstOperands,
     /* 280536 */     // GIR_Coverage, 2734,
     /* 280536 */     GIR_Done,
     /* 280537 */   // Label 5722: @280537
     /* 280537 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(280559), // Rule ID 2738 //
     /* 280542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 280548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280552 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 280552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 280557 */     GIR_RootConstrainSelectedInstOperands,
     /* 280558 */     // GIR_Coverage, 2738,
     /* 280558 */     GIR_Done,
     /* 280559 */   // Label 5723: @280559
     /* 280559 */   GIM_Reject,
     /* 280560 */ // Label 5719: @280560
     /* 280560 */ GIM_Reject,
     /* 280561 */ // Label 5697: @280561
     /* 280561 */ GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(280589), // Rule ID 8395 //
     /* 280566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 280572 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 280575 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 280578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 280582 */   // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 280582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 280587 */   GIR_RootConstrainSelectedInstOperands,
     /* 280588 */   // GIR_Coverage, 8395,
     /* 280588 */   GIR_Done,
     /* 280589 */ // Label 5724: @280589
     /* 280589 */ GIM_Reject,
     /* 280590 */ // Label 5698: @280590
     /* 280590 */ GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(280755),
     /* 280595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 280598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 280601 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(280658), // Rule ID 3157 //
     /* 280606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 280612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 280624 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 280628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 280632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 280636 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 280640 */     // MIs[2] Operand 1
     /* 280640 */     // No operand predicates
     /* 280640 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280642 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$pg, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv8f16:{ *:[nxv8f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$zd, ?:{ *:[nxv8i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 280642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 280645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 280647 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 280649 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 280651 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 280656 */     GIR_RootConstrainSelectedInstOperands,
     /* 280657 */     // GIR_Coverage, 3157,
     /* 280657 */     GIR_EraseRootFromParent_Done,
     /* 280658 */   // Label 5726: @280658
     /* 280658 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(280710), // Rule ID 7444 //
     /* 280663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 280678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 280682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 280686 */     // MIs[0] Op2
     /* 280686 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 280691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280693 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 280693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 280696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 280698 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 280700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 280704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 280708 */     GIR_RootConstrainSelectedInstOperands,
     /* 280709 */     // GIR_Coverage, 7444,
     /* 280709 */     GIR_EraseRootFromParent_Done,
     /* 280710 */   // Label 5727: @280710
     /* 280710 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(280732), // Rule ID 2733 //
     /* 280715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 280721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280725 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 280725 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 280730 */     GIR_RootConstrainSelectedInstOperands,
     /* 280731 */     // GIR_Coverage, 2733,
     /* 280731 */     GIR_Done,
     /* 280732 */   // Label 5728: @280732
     /* 280732 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(280754), // Rule ID 2736 //
     /* 280737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 280743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280747 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 280747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 280752 */     GIR_RootConstrainSelectedInstOperands,
     /* 280753 */     // GIR_Coverage, 2736,
     /* 280753 */     GIR_Done,
     /* 280754 */   // Label 5729: @280754
     /* 280754 */   GIM_Reject,
     /* 280755 */ // Label 5725: @280755
     /* 280755 */ GIM_Reject,
     /* 280756 */ // Label 5699: @280756
     /* 280756 */ GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(280784), // Rule ID 8394 //
     /* 280761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 280767 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 280770 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 280773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 280777 */   // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 280777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 280782 */   GIR_RootConstrainSelectedInstOperands,
     /* 280783 */   // GIR_Coverage, 8394,
     /* 280783 */   GIR_Done,
     /* 280784 */ // Label 5730: @280784
     /* 280784 */ GIM_Reject,
     /* 280785 */ // Label 5700: @280785
     /* 280785 */ GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(280871),
     /* 280790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 280793 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 280796 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(280848), // Rule ID 7442 //
     /* 280801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 280812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 280816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 280820 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 280824 */     // MIs[0] Op2
     /* 280824 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 280829 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280831 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 280831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 280834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 280836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 280838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 280842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 280846 */     GIR_RootConstrainSelectedInstOperands,
     /* 280847 */     // GIR_Coverage, 7442,
     /* 280847 */     GIR_EraseRootFromParent_Done,
     /* 280848 */   // Label 5732: @280848
     /* 280848 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(280870), // Rule ID 2732 //
     /* 280853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 280856 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 280859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280863 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 280863 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
     /* 280868 */     GIR_RootConstrainSelectedInstOperands,
     /* 280869 */     // GIR_Coverage, 2732,
     /* 280869 */     GIR_Done,
     /* 280870 */   // Label 5733: @280870
     /* 280870 */   GIM_Reject,
     /* 280871 */ // Label 5731: @280871
     /* 280871 */ GIM_Reject,
     /* 280872 */ // Label 5701: @280872
     /* 280872 */ GIM_Reject,
     /* 280873 */ // Label 51: @280873
     /* 280873 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5738*/ GIMT_Encode4(281356),
     /* 280884 */ /*GILLT_s64*//*Label 5734*/ GIMT_Encode4(280920), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 280904 */ /*GILLT_v4s32*//*Label 5735*/ GIMT_Encode4(280951), GIMT_Encode4(0),
     /* 280912 */ /*GILLT_v8s16*//*Label 5736*/ GIMT_Encode4(281086),
     /* 280916 */ /*GILLT_v16s8*//*Label 5737*/ GIMT_Encode4(281221),
     /* 280920 */ // Label 5734: @280920
     /* 280920 */ GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(280950), // Rule ID 128 //
     /* 280925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 280928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 280931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280939 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280943 */   // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 280943 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
     /* 280948 */   GIR_RootConstrainSelectedInstOperands,
     /* 280949 */   // GIR_Coverage, 128,
     /* 280949 */   GIR_Done,
     /* 280950 */ // Label 5739: @280950
     /* 280950 */ GIM_Reject,
     /* 280951 */ // Label 5735: @280951
     /* 280951 */ GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(281085), // Rule ID 6500 //
     /* 280956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 280962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280974 */   // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 280974 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 280977 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 280981 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280986 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 280990 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 280994 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 280996 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 280999 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281003 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281008 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 281014 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281019 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281024 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 281027 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281031 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281036 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 281042 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281047 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281052 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281055 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 281059 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281064 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281067 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281070 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 281075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281077 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281080 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 281083 */   GIR_RootConstrainSelectedInstOperands,
     /* 281084 */   // GIR_Coverage, 6500,
     /* 281084 */   GIR_EraseRootFromParent_Done,
     /* 281085 */ // Label 5740: @281085
     /* 281085 */ GIM_Reject,
     /* 281086 */ // Label 5736: @281086
     /* 281086 */ GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(281220), // Rule ID 6499 //
     /* 281091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281094 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 281097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281105 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281109 */   // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 281109 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 281112 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 281116 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281121 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 281125 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 281129 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281131 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 281134 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281138 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281143 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 281149 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281154 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281159 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 281162 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281166 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281171 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 281177 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281182 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281187 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281190 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 281194 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281199 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281202 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 281210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281215 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 281218 */   GIR_RootConstrainSelectedInstOperands,
     /* 281219 */   // GIR_Coverage, 6499,
     /* 281219 */   GIR_EraseRootFromParent_Done,
     /* 281220 */ // Label 5741: @281220
     /* 281220 */ GIM_Reject,
     /* 281221 */ // Label 5737: @281221
     /* 281221 */ GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(281355), // Rule ID 6498 //
     /* 281226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 281229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 281232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281244 */   // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 281244 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 281247 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 281251 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281256 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 281260 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 281264 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281266 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 281269 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281273 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281278 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 281284 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281289 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281294 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 281297 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281301 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281306 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 281312 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281317 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281322 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281325 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 281329 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281334 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281337 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281340 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281342 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 281345 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281347 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281350 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 281353 */   GIR_RootConstrainSelectedInstOperands,
     /* 281354 */   // GIR_Coverage, 6498,
     /* 281354 */   GIR_EraseRootFromParent_Done,
     /* 281355 */ // Label 5742: @281355
     /* 281355 */ GIM_Reject,
     /* 281356 */ // Label 5738: @281356
     /* 281356 */ GIM_Reject,
     /* 281357 */ // Label 52: @281357
     /* 281357 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5747*/ GIMT_Encode4(281840),
     /* 281368 */ /*GILLT_s64*//*Label 5743*/ GIMT_Encode4(281404), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281388 */ /*GILLT_v4s32*//*Label 5744*/ GIMT_Encode4(281435), GIMT_Encode4(0),
     /* 281396 */ /*GILLT_v8s16*//*Label 5745*/ GIMT_Encode4(281570),
     /* 281400 */ /*GILLT_v16s8*//*Label 5746*/ GIMT_Encode4(281705),
     /* 281404 */ // Label 5743: @281404
     /* 281404 */ GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(281434), // Rule ID 127 //
     /* 281409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 281412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 281415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 281419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 281423 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 281427 */   // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 281427 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
     /* 281432 */   GIR_RootConstrainSelectedInstOperands,
     /* 281433 */   // GIR_Coverage, 127,
     /* 281433 */   GIR_Done,
     /* 281434 */ // Label 5748: @281434
     /* 281434 */ GIM_Reject,
     /* 281435 */ // Label 5744: @281435
     /* 281435 */ GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(281569), // Rule ID 6497 //
     /* 281440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 281443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 281446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281454 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281458 */   // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 281458 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 281461 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 281465 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281470 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 281474 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 281478 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281480 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 281483 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281487 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281492 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 281498 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281503 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281508 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 281511 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281515 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281520 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 281526 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281531 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281536 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281539 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 281543 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281548 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281551 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 281559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281561 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281564 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 281567 */   GIR_RootConstrainSelectedInstOperands,
     /* 281568 */   // GIR_Coverage, 6497,
     /* 281568 */   GIR_EraseRootFromParent_Done,
     /* 281569 */ // Label 5749: @281569
     /* 281569 */ GIM_Reject,
     /* 281570 */ // Label 5745: @281570
     /* 281570 */ GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(281704), // Rule ID 6496 //
     /* 281575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 281581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281589 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281593 */   // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 281593 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 281596 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 281600 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281605 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 281609 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 281613 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281615 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 281618 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281622 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281627 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 281633 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281638 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281643 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 281646 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281650 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281655 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 281661 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281666 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281671 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281674 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 281678 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281683 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281686 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 281694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281696 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281699 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 281702 */   GIR_RootConstrainSelectedInstOperands,
     /* 281703 */   // GIR_Coverage, 6496,
     /* 281703 */   GIR_EraseRootFromParent_Done,
     /* 281704 */ // Label 5750: @281704
     /* 281704 */ GIM_Reject,
     /* 281705 */ // Label 5746: @281705
     /* 281705 */ GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(281839), // Rule ID 6495 //
     /* 281710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 281713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 281716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281728 */   // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 281728 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 281731 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 281735 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281740 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 281744 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 281748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 281750 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 281753 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281757 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281762 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 281768 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281773 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281778 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 281781 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281785 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281790 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 281796 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281801 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281806 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 281809 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 281813 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281818 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 281821 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 281824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 281826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 281829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281831 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281834 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 281837 */   GIR_RootConstrainSelectedInstOperands,
     /* 281838 */   // GIR_Coverage, 6495,
     /* 281838 */   GIR_EraseRootFromParent_Done,
     /* 281839 */ // Label 5751: @281839
     /* 281839 */ GIM_Reject,
     /* 281840 */ // Label 5747: @281840
     /* 281840 */ GIM_Reject,
     /* 281841 */ // Label 53: @281841
     /* 281841 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5763*/ GIMT_Encode4(282270),
     /* 281852 */ /*GILLT_v2s32*//*Label 5752*/ GIMT_Encode4(281928),
     /* 281856 */ /*GILLT_v2s64*//*Label 5753*/ GIMT_Encode4(281962),
     /* 281860 */ /*GILLT_v4s16*//*Label 5754*/ GIMT_Encode4(281996),
     /* 281864 */ /*GILLT_v4s32*//*Label 5755*/ GIMT_Encode4(282030),
     /* 281868 */ /*GILLT_v8s8*//*Label 5756*/ GIMT_Encode4(282064),
     /* 281872 */ /*GILLT_v8s16*//*Label 5757*/ GIMT_Encode4(282098),
     /* 281876 */ /*GILLT_v16s8*//*Label 5758*/ GIMT_Encode4(282132), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281896 */ /*GILLT_nxv2s64*//*Label 5759*/ GIMT_Encode4(282166), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281908 */ /*GILLT_nxv4s32*//*Label 5760*/ GIMT_Encode4(282192), GIMT_Encode4(0),
     /* 281916 */ /*GILLT_nxv8s16*//*Label 5761*/ GIMT_Encode4(282218), GIMT_Encode4(0),
     /* 281924 */ /*GILLT_nxv16s8*//*Label 5762*/ GIMT_Encode4(282244),
     /* 281928 */ // Label 5752: @281928
     /* 281928 */ GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(281961), // Rule ID 5006 //
     /* 281933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 281939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 281942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281950 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281954 */   // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 281954 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 281959 */   GIR_RootConstrainSelectedInstOperands,
     /* 281960 */   // GIR_Coverage, 5006,
     /* 281960 */   GIR_Done,
     /* 281961 */ // Label 5764: @281961
     /* 281961 */ GIM_Reject,
     /* 281962 */ // Label 5753: @281962
     /* 281962 */ GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(281995), // Rule ID 5010 //
     /* 281967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 281973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 281976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281988 */   // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 281988 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 281993 */   GIR_RootConstrainSelectedInstOperands,
     /* 281994 */   // GIR_Coverage, 5010,
     /* 281994 */   GIR_Done,
     /* 281995 */ // Label 5765: @281995
     /* 281995 */ GIM_Reject,
     /* 281996 */ // Label 5754: @281996
     /* 281996 */ GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(282029), // Rule ID 5005 //
     /* 282001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 282007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 282010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282018 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282022 */   // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 282022 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 282027 */   GIR_RootConstrainSelectedInstOperands,
     /* 282028 */   // GIR_Coverage, 5005,
     /* 282028 */   GIR_Done,
     /* 282029 */ // Label 5766: @282029
     /* 282029 */ GIM_Reject,
     /* 282030 */ // Label 5755: @282030
     /* 282030 */ GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(282063), // Rule ID 5009 //
     /* 282035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 282044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282056 */   // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 282056 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 282061 */   GIR_RootConstrainSelectedInstOperands,
     /* 282062 */   // GIR_Coverage, 5009,
     /* 282062 */   GIR_Done,
     /* 282063 */ // Label 5767: @282063
     /* 282063 */ GIM_Reject,
     /* 282064 */ // Label 5756: @282064
     /* 282064 */ GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(282097), // Rule ID 5004 //
     /* 282069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 282075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 282078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282090 */   // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 282090 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 282095 */   GIR_RootConstrainSelectedInstOperands,
     /* 282096 */   // GIR_Coverage, 5004,
     /* 282096 */   GIR_Done,
     /* 282097 */ // Label 5768: @282097
     /* 282097 */ GIM_Reject,
     /* 282098 */ // Label 5757: @282098
     /* 282098 */ GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(282131), // Rule ID 5008 //
     /* 282103 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 282112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282120 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282124 */   // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 282124 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 282129 */   GIR_RootConstrainSelectedInstOperands,
     /* 282130 */   // GIR_Coverage, 5008,
     /* 282130 */   GIR_Done,
     /* 282131 */ // Label 5769: @282131
     /* 282131 */ GIM_Reject,
     /* 282132 */ // Label 5758: @282132
     /* 282132 */ GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(282165), // Rule ID 5007 //
     /* 282137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 282143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 282146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282154 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282158 */   // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 282158 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 282163 */   GIR_RootConstrainSelectedInstOperands,
     /* 282164 */   // GIR_Coverage, 5007,
     /* 282164 */   GIR_Done,
     /* 282165 */ // Label 5770: @282165
     /* 282165 */ GIM_Reject,
     /* 282166 */ // Label 5759: @282166
     /* 282166 */ GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(282191), // Rule ID 7400 //
     /* 282171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 282177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 282180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282184 */   // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 282184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
     /* 282189 */   GIR_RootConstrainSelectedInstOperands,
     /* 282190 */   // GIR_Coverage, 7400,
     /* 282190 */   GIR_Done,
     /* 282191 */ // Label 5771: @282191
     /* 282191 */ GIM_Reject,
     /* 282192 */ // Label 5760: @282192
     /* 282192 */ GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(282217), // Rule ID 7399 //
     /* 282197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 282203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 282206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282210 */   // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 282210 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
     /* 282215 */   GIR_RootConstrainSelectedInstOperands,
     /* 282216 */   // GIR_Coverage, 7399,
     /* 282216 */   GIR_Done,
     /* 282217 */ // Label 5772: @282217
     /* 282217 */ GIM_Reject,
     /* 282218 */ // Label 5761: @282218
     /* 282218 */ GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(282243), // Rule ID 7398 //
     /* 282223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 282229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 282232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282236 */   // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 282236 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
     /* 282241 */   GIR_RootConstrainSelectedInstOperands,
     /* 282242 */   // GIR_Coverage, 7398,
     /* 282242 */   GIR_Done,
     /* 282243 */ // Label 5773: @282243
     /* 282243 */ GIM_Reject,
     /* 282244 */ // Label 5762: @282244
     /* 282244 */ GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(282269), // Rule ID 7397 //
     /* 282249 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282252 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 282255 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 282258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282262 */   // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 282262 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
     /* 282267 */   GIR_RootConstrainSelectedInstOperands,
     /* 282268 */   // GIR_Coverage, 7397,
     /* 282268 */   GIR_Done,
     /* 282269 */ // Label 5774: @282269
     /* 282269 */ GIM_Reject,
     /* 282270 */ // Label 5763: @282270
     /* 282270 */ GIM_Reject,
     /* 282271 */ // Label 54: @282271
     /* 282271 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5786*/ GIMT_Encode4(282700),
     /* 282282 */ /*GILLT_v2s32*//*Label 5775*/ GIMT_Encode4(282358),
     /* 282286 */ /*GILLT_v2s64*//*Label 5776*/ GIMT_Encode4(282392),
     /* 282290 */ /*GILLT_v4s16*//*Label 5777*/ GIMT_Encode4(282426),
     /* 282294 */ /*GILLT_v4s32*//*Label 5778*/ GIMT_Encode4(282460),
     /* 282298 */ /*GILLT_v8s8*//*Label 5779*/ GIMT_Encode4(282494),
     /* 282302 */ /*GILLT_v8s16*//*Label 5780*/ GIMT_Encode4(282528),
     /* 282306 */ /*GILLT_v16s8*//*Label 5781*/ GIMT_Encode4(282562), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282326 */ /*GILLT_nxv2s64*//*Label 5782*/ GIMT_Encode4(282596), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282338 */ /*GILLT_nxv4s32*//*Label 5783*/ GIMT_Encode4(282622), GIMT_Encode4(0),
     /* 282346 */ /*GILLT_nxv8s16*//*Label 5784*/ GIMT_Encode4(282648), GIMT_Encode4(0),
     /* 282354 */ /*GILLT_nxv16s8*//*Label 5785*/ GIMT_Encode4(282674),
     /* 282358 */ // Label 5775: @282358
     /* 282358 */ GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(282391), // Rule ID 2475 //
     /* 282363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 282369 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 282372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282384 */   // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 282384 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 282389 */   GIR_RootConstrainSelectedInstOperands,
     /* 282390 */   // GIR_Coverage, 2475,
     /* 282390 */   GIR_Done,
     /* 282391 */ // Label 5787: @282391
     /* 282391 */ GIM_Reject,
     /* 282392 */ // Label 5776: @282392
     /* 282392 */ GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(282425), // Rule ID 2479 //
     /* 282397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 282403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 282406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282414 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282418 */   // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 282418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 282423 */   GIR_RootConstrainSelectedInstOperands,
     /* 282424 */   // GIR_Coverage, 2479,
     /* 282424 */   GIR_Done,
     /* 282425 */ // Label 5788: @282425
     /* 282425 */ GIM_Reject,
     /* 282426 */ // Label 5777: @282426
     /* 282426 */ GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(282459), // Rule ID 2474 //
     /* 282431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 282437 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 282440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282452 */   // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 282452 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 282457 */   GIR_RootConstrainSelectedInstOperands,
     /* 282458 */   // GIR_Coverage, 2474,
     /* 282458 */   GIR_Done,
     /* 282459 */ // Label 5789: @282459
     /* 282459 */ GIM_Reject,
     /* 282460 */ // Label 5778: @282460
     /* 282460 */ GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(282493), // Rule ID 2478 //
     /* 282465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282471 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 282474 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282478 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282482 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282486 */   // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 282486 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 282491 */   GIR_RootConstrainSelectedInstOperands,
     /* 282492 */   // GIR_Coverage, 2478,
     /* 282492 */   GIR_Done,
     /* 282493 */ // Label 5790: @282493
     /* 282493 */ GIM_Reject,
     /* 282494 */ // Label 5779: @282494
     /* 282494 */ GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(282527), // Rule ID 2473 //
     /* 282499 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 282505 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 282508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282520 */   // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 282520 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 282525 */   GIR_RootConstrainSelectedInstOperands,
     /* 282526 */   // GIR_Coverage, 2473,
     /* 282526 */   GIR_Done,
     /* 282527 */ // Label 5791: @282527
     /* 282527 */ GIM_Reject,
     /* 282528 */ // Label 5780: @282528
     /* 282528 */ GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(282561), // Rule ID 2477 //
     /* 282533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282539 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 282542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282546 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282550 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282554 */   // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 282554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 282559 */   GIR_RootConstrainSelectedInstOperands,
     /* 282560 */   // GIR_Coverage, 2477,
     /* 282560 */   GIR_Done,
     /* 282561 */ // Label 5792: @282561
     /* 282561 */ GIM_Reject,
     /* 282562 */ // Label 5781: @282562
     /* 282562 */ GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(282595), // Rule ID 2476 //
     /* 282567 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282570 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 282573 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 282576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282584 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282588 */   // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 282588 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 282593 */   GIR_RootConstrainSelectedInstOperands,
     /* 282594 */   // GIR_Coverage, 2476,
     /* 282594 */   GIR_Done,
     /* 282595 */ // Label 5793: @282595
     /* 282595 */ GIM_Reject,
     /* 282596 */ // Label 5782: @282596
     /* 282596 */ GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(282621), // Rule ID 7396 //
     /* 282601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 282607 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 282610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282614 */   // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 282614 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
     /* 282619 */   GIR_RootConstrainSelectedInstOperands,
     /* 282620 */   // GIR_Coverage, 7396,
     /* 282620 */   GIR_Done,
     /* 282621 */ // Label 5794: @282621
     /* 282621 */ GIM_Reject,
     /* 282622 */ // Label 5783: @282622
     /* 282622 */ GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(282647), // Rule ID 7395 //
     /* 282627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 282633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 282636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282640 */   // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 282640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
     /* 282645 */   GIR_RootConstrainSelectedInstOperands,
     /* 282646 */   // GIR_Coverage, 7395,
     /* 282646 */   GIR_Done,
     /* 282647 */ // Label 5795: @282647
     /* 282647 */ GIM_Reject,
     /* 282648 */ // Label 5784: @282648
     /* 282648 */ GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(282673), // Rule ID 7394 //
     /* 282653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 282659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 282662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282666 */   // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 282666 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
     /* 282671 */   GIR_RootConstrainSelectedInstOperands,
     /* 282672 */   // GIR_Coverage, 7394,
     /* 282672 */   GIR_Done,
     /* 282673 */ // Label 5796: @282673
     /* 282673 */ GIM_Reject,
     /* 282674 */ // Label 5785: @282674
     /* 282674 */ GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(282699), // Rule ID 7393 //
     /* 282679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 282685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 282688 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282692 */   // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 282692 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
     /* 282697 */   GIR_RootConstrainSelectedInstOperands,
     /* 282698 */   // GIR_Coverage, 7393,
     /* 282698 */   GIR_Done,
     /* 282699 */ // Label 5797: @282699
     /* 282699 */ GIM_Reject,
     /* 282700 */ // Label 5786: @282700
     /* 282700 */ GIM_Reject,
     /* 282701 */ // Label 55: @282701
     /* 282701 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5809*/ GIMT_Encode4(283130),
     /* 282712 */ /*GILLT_v2s32*//*Label 5798*/ GIMT_Encode4(282788),
     /* 282716 */ /*GILLT_v2s64*//*Label 5799*/ GIMT_Encode4(282822),
     /* 282720 */ /*GILLT_v4s16*//*Label 5800*/ GIMT_Encode4(282856),
     /* 282724 */ /*GILLT_v4s32*//*Label 5801*/ GIMT_Encode4(282890),
     /* 282728 */ /*GILLT_v8s8*//*Label 5802*/ GIMT_Encode4(282924),
     /* 282732 */ /*GILLT_v8s16*//*Label 5803*/ GIMT_Encode4(282958),
     /* 282736 */ /*GILLT_v16s8*//*Label 5804*/ GIMT_Encode4(282992), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282756 */ /*GILLT_nxv2s64*//*Label 5805*/ GIMT_Encode4(283026), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282768 */ /*GILLT_nxv4s32*//*Label 5806*/ GIMT_Encode4(283052), GIMT_Encode4(0),
     /* 282776 */ /*GILLT_nxv8s16*//*Label 5807*/ GIMT_Encode4(283078), GIMT_Encode4(0),
     /* 282784 */ /*GILLT_nxv16s8*//*Label 5808*/ GIMT_Encode4(283104),
     /* 282788 */ // Label 5798: @282788
     /* 282788 */ GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(282821), // Rule ID 5020 //
     /* 282793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 282799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 282802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282810 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282814 */   // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 282814 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 282819 */   GIR_RootConstrainSelectedInstOperands,
     /* 282820 */   // GIR_Coverage, 5020,
     /* 282820 */   GIR_Done,
     /* 282821 */ // Label 5810: @282821
     /* 282821 */ GIM_Reject,
     /* 282822 */ // Label 5799: @282822
     /* 282822 */ GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(282855), // Rule ID 5024 //
     /* 282827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 282833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 282836 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282840 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282844 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282848 */   // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 282848 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 282853 */   GIR_RootConstrainSelectedInstOperands,
     /* 282854 */   // GIR_Coverage, 5024,
     /* 282854 */   GIR_Done,
     /* 282855 */ // Label 5811: @282855
     /* 282855 */ GIM_Reject,
     /* 282856 */ // Label 5800: @282856
     /* 282856 */ GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(282889), // Rule ID 5019 //
     /* 282861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 282867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 282870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282878 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282882 */   // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 282882 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 282887 */   GIR_RootConstrainSelectedInstOperands,
     /* 282888 */   // GIR_Coverage, 5019,
     /* 282888 */   GIR_Done,
     /* 282889 */ // Label 5812: @282889
     /* 282889 */ GIM_Reject,
     /* 282890 */ // Label 5801: @282890
     /* 282890 */ GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(282923), // Rule ID 5023 //
     /* 282895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 282901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 282904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282912 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282916 */   // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 282916 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 282921 */   GIR_RootConstrainSelectedInstOperands,
     /* 282922 */   // GIR_Coverage, 5023,
     /* 282922 */   GIR_Done,
     /* 282923 */ // Label 5813: @282923
     /* 282923 */ GIM_Reject,
     /* 282924 */ // Label 5802: @282924
     /* 282924 */ GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(282957), // Rule ID 5018 //
     /* 282929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 282935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 282938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282946 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282950 */   // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 282950 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 282955 */   GIR_RootConstrainSelectedInstOperands,
     /* 282956 */   // GIR_Coverage, 5018,
     /* 282956 */   GIR_Done,
     /* 282957 */ // Label 5814: @282957
     /* 282957 */ GIM_Reject,
     /* 282958 */ // Label 5803: @282958
     /* 282958 */ GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(282991), // Rule ID 5022 //
     /* 282963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 282972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282980 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282984 */   // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 282984 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 282989 */   GIR_RootConstrainSelectedInstOperands,
     /* 282990 */   // GIR_Coverage, 5022,
     /* 282990 */   GIR_Done,
     /* 282991 */ // Label 5815: @282991
     /* 282991 */ GIM_Reject,
     /* 282992 */ // Label 5804: @282992
     /* 282992 */ GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(283025), // Rule ID 5021 //
     /* 282997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 283003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 283006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283018 */   // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 283018 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 283023 */   GIR_RootConstrainSelectedInstOperands,
     /* 283024 */   // GIR_Coverage, 5021,
     /* 283024 */   GIR_Done,
     /* 283025 */ // Label 5816: @283025
     /* 283025 */ GIM_Reject,
     /* 283026 */ // Label 5805: @283026
     /* 283026 */ GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(283051), // Rule ID 7408 //
     /* 283031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 283037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 283040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283044 */   // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 283044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
     /* 283049 */   GIR_RootConstrainSelectedInstOperands,
     /* 283050 */   // GIR_Coverage, 7408,
     /* 283050 */   GIR_Done,
     /* 283051 */ // Label 5817: @283051
     /* 283051 */ GIM_Reject,
     /* 283052 */ // Label 5806: @283052
     /* 283052 */ GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(283077), // Rule ID 7407 //
     /* 283057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 283063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 283066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283070 */   // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 283070 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
     /* 283075 */   GIR_RootConstrainSelectedInstOperands,
     /* 283076 */   // GIR_Coverage, 7407,
     /* 283076 */   GIR_Done,
     /* 283077 */ // Label 5818: @283077
     /* 283077 */ GIM_Reject,
     /* 283078 */ // Label 5807: @283078
     /* 283078 */ GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(283103), // Rule ID 7406 //
     /* 283083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 283089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 283092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283096 */   // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 283096 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
     /* 283101 */   GIR_RootConstrainSelectedInstOperands,
     /* 283102 */   // GIR_Coverage, 7406,
     /* 283102 */   GIR_Done,
     /* 283103 */ // Label 5819: @283103
     /* 283103 */ GIM_Reject,
     /* 283104 */ // Label 5808: @283104
     /* 283104 */ GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(283129), // Rule ID 7405 //
     /* 283109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 283115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 283118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283122 */   // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 283122 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
     /* 283127 */   GIR_RootConstrainSelectedInstOperands,
     /* 283128 */   // GIR_Coverage, 7405,
     /* 283128 */   GIR_Done,
     /* 283129 */ // Label 5820: @283129
     /* 283129 */ GIM_Reject,
     /* 283130 */ // Label 5809: @283130
     /* 283130 */ GIM_Reject,
     /* 283131 */ // Label 56: @283131
     /* 283131 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 5832*/ GIMT_Encode4(283560),
     /* 283142 */ /*GILLT_v2s32*//*Label 5821*/ GIMT_Encode4(283218),
     /* 283146 */ /*GILLT_v2s64*//*Label 5822*/ GIMT_Encode4(283252),
     /* 283150 */ /*GILLT_v4s16*//*Label 5823*/ GIMT_Encode4(283286),
     /* 283154 */ /*GILLT_v4s32*//*Label 5824*/ GIMT_Encode4(283320),
     /* 283158 */ /*GILLT_v8s8*//*Label 5825*/ GIMT_Encode4(283354),
     /* 283162 */ /*GILLT_v8s16*//*Label 5826*/ GIMT_Encode4(283388),
     /* 283166 */ /*GILLT_v16s8*//*Label 5827*/ GIMT_Encode4(283422), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283186 */ /*GILLT_nxv2s64*//*Label 5828*/ GIMT_Encode4(283456), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283198 */ /*GILLT_nxv4s32*//*Label 5829*/ GIMT_Encode4(283482), GIMT_Encode4(0),
     /* 283206 */ /*GILLT_nxv8s16*//*Label 5830*/ GIMT_Encode4(283508), GIMT_Encode4(0),
     /* 283214 */ /*GILLT_nxv16s8*//*Label 5831*/ GIMT_Encode4(283534),
     /* 283218 */ // Label 5821: @283218
     /* 283218 */ GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(283251), // Rule ID 5013 //
     /* 283223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 283229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 283232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283244 */   // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /* 283244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 283249 */   GIR_RootConstrainSelectedInstOperands,
     /* 283250 */   // GIR_Coverage, 5013,
     /* 283250 */   GIR_Done,
     /* 283251 */ // Label 5833: @283251
     /* 283251 */ GIM_Reject,
     /* 283252 */ // Label 5822: @283252
     /* 283252 */ GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(283285), // Rule ID 5017 //
     /* 283257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 283263 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 283266 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283270 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283274 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283278 */   // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /* 283278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 283283 */   GIR_RootConstrainSelectedInstOperands,
     /* 283284 */   // GIR_Coverage, 5017,
     /* 283284 */   GIR_Done,
     /* 283285 */ // Label 5834: @283285
     /* 283285 */ GIM_Reject,
     /* 283286 */ // Label 5823: @283286
     /* 283286 */ GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(283319), // Rule ID 5012 //
     /* 283291 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 283297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 283300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283312 */   // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /* 283312 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 283317 */   GIR_RootConstrainSelectedInstOperands,
     /* 283318 */   // GIR_Coverage, 5012,
     /* 283318 */   GIR_Done,
     /* 283319 */ // Label 5835: @283319
     /* 283319 */ GIM_Reject,
     /* 283320 */ // Label 5824: @283320
     /* 283320 */ GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(283353), // Rule ID 5016 //
     /* 283325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 283334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283346 */   // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /* 283346 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 283351 */   GIR_RootConstrainSelectedInstOperands,
     /* 283352 */   // GIR_Coverage, 5016,
     /* 283352 */   GIR_Done,
     /* 283353 */ // Label 5836: @283353
     /* 283353 */ GIM_Reject,
     /* 283354 */ // Label 5825: @283354
     /* 283354 */ GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(283387), // Rule ID 5011 //
     /* 283359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 283365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 283368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283376 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283380 */   // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$LHS, V64:{ *:[v8i8] }:$RHS)
     /* 283380 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 283385 */   GIR_RootConstrainSelectedInstOperands,
     /* 283386 */   // GIR_Coverage, 5011,
     /* 283386 */   GIR_Done,
     /* 283387 */ // Label 5837: @283387
     /* 283387 */ GIM_Reject,
     /* 283388 */ // Label 5826: @283388
     /* 283388 */ GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(283421), // Rule ID 5015 //
     /* 283393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 283402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283410 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283414 */   // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /* 283414 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 283419 */   GIR_RootConstrainSelectedInstOperands,
     /* 283420 */   // GIR_Coverage, 5015,
     /* 283420 */   GIR_Done,
     /* 283421 */ // Label 5838: @283421
     /* 283421 */ GIM_Reject,
     /* 283422 */ // Label 5827: @283422
     /* 283422 */ GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(283455), // Rule ID 5014 //
     /* 283427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 283430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 283433 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 283436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283444 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283448 */   // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$LHS, V128:{ *:[v16i8] }:$RHS)
     /* 283448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 283453 */   GIR_RootConstrainSelectedInstOperands,
     /* 283454 */   // GIR_Coverage, 5014,
     /* 283454 */   GIR_Done,
     /* 283455 */ // Label 5839: @283455
     /* 283455 */ GIM_Reject,
     /* 283456 */ // Label 5828: @283456
     /* 283456 */ GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(283481), // Rule ID 7404 //
     /* 283461 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 283467 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 283470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283474 */   // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 283474 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
     /* 283479 */   GIR_RootConstrainSelectedInstOperands,
     /* 283480 */   // GIR_Coverage, 7404,
     /* 283480 */   GIR_Done,
     /* 283481 */ // Label 5840: @283481
     /* 283481 */ GIM_Reject,
     /* 283482 */ // Label 5829: @283482
     /* 283482 */ GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(283507), // Rule ID 7403 //
     /* 283487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 283493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 283496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283500 */   // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 283500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
     /* 283505 */   GIR_RootConstrainSelectedInstOperands,
     /* 283506 */   // GIR_Coverage, 7403,
     /* 283506 */   GIR_Done,
     /* 283507 */ // Label 5841: @283507
     /* 283507 */ GIM_Reject,
     /* 283508 */ // Label 5830: @283508
     /* 283508 */ GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(283533), // Rule ID 7402 //
     /* 283513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 283519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 283522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283526 */   // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 283526 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
     /* 283531 */   GIR_RootConstrainSelectedInstOperands,
     /* 283532 */   // GIR_Coverage, 7402,
     /* 283532 */   GIR_Done,
     /* 283533 */ // Label 5842: @283533
     /* 283533 */ GIM_Reject,
     /* 283534 */ // Label 5831: @283534
     /* 283534 */ GIM_Try, /*On fail goto*//*Label 5843*/ GIMT_Encode4(283559), // Rule ID 7401 //
     /* 283539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 283542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 283545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 283548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 283552 */   // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 283552 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
     /* 283557 */   GIR_RootConstrainSelectedInstOperands,
     /* 283558 */   // GIR_Coverage, 7401,
     /* 283558 */   GIR_Done,
     /* 283559 */ // Label 5843: @283559
     /* 283559 */ GIM_Reject,
     /* 283560 */ // Label 5832: @283560
     /* 283560 */ GIM_Reject,
     /* 283561 */ // Label 57: @283561
     /* 283561 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5855*/ GIMT_Encode4(285358),
     /* 283572 */ /*GILLT_s16*//*Label 5844*/ GIMT_Encode4(283656),
     /* 283576 */ /*GILLT_s32*//*Label 5845*/ GIMT_Encode4(283882),
     /* 283580 */ /*GILLT_s64*//*Label 5846*/ GIMT_Encode4(284236), GIMT_Encode4(0),
     /* 283588 */ /*GILLT_v2s32*//*Label 5847*/ GIMT_Encode4(284408),
     /* 283592 */ /*GILLT_v2s64*//*Label 5848*/ GIMT_Encode4(284446),
     /* 283596 */ /*GILLT_v4s16*//*Label 5849*/ GIMT_Encode4(284622),
     /* 283600 */ /*GILLT_v4s32*//*Label 5850*/ GIMT_Encode4(284660), GIMT_Encode4(0),
     /* 283608 */ /*GILLT_v8s16*//*Label 5851*/ GIMT_Encode4(284836), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283632 */ /*GILLT_nxv2s64*//*Label 5852*/ GIMT_Encode4(285280), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 283644 */ /*GILLT_nxv4s32*//*Label 5853*/ GIMT_Encode4(285306), GIMT_Encode4(0),
     /* 283652 */ /*GILLT_nxv8s16*//*Label 5854*/ GIMT_Encode4(285332),
     /* 283656 */ // Label 5844: @283656
     /* 283656 */ GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(283881),
     /* 283661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 283667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283671 */   GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(283762), // Rule ID 6888 //
     /* 283676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283697 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283709 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283713 */     // MIs[2] Rn
     /* 283713 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283718 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 283722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283724 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 283724 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283727 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283731 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283736 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 283755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283760 */     GIR_RootConstrainSelectedInstOperands,
     /* 283761 */     // GIR_Coverage, 6888,
     /* 283761 */     GIR_EraseRootFromParent_Done,
     /* 283762 */   // Label 5857: @283762
     /* 283762 */   GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(283853), // Rule ID 13869 //
     /* 283767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 283779 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283788 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 283792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283800 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283804 */     // MIs[2] Rn
     /* 283804 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283809 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 283813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283815 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 283815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283827 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 283846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283851 */     GIR_RootConstrainSelectedInstOperands,
     /* 283852 */     // GIR_Coverage, 13869,
     /* 283852 */     GIR_EraseRootFromParent_Done,
     /* 283853 */   // Label 5858: @283853
     /* 283853 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(283880), // Rule ID 584 //
     /* 283858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 283861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283869 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 283869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 283874 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 283878 */     GIR_RootConstrainSelectedInstOperands,
     /* 283879 */     // GIR_Coverage, 584,
     /* 283879 */     GIR_Done,
     /* 283880 */   // Label 5859: @283880
     /* 283880 */   GIM_Reject,
     /* 283881 */ // Label 5856: @283881
     /* 283881 */ GIM_Reject,
     /* 283882 */ // Label 5845: @283882
     /* 283882 */ GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(284235),
     /* 283887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 283890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 283893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283897 */   GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(283988), // Rule ID 6886 //
     /* 283902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 283914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 283918 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283923 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 283927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 283931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 283935 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 283939 */     // MIs[2] Rn
     /* 283939 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 283944 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 283948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 283950 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 283950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 283953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283962 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 283968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 283981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 283983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283986 */     GIR_RootConstrainSelectedInstOperands,
     /* 283987 */     // GIR_Coverage, 6886,
     /* 283987 */     GIR_EraseRootFromParent_Done,
     /* 283988 */   // Label 5861: @283988
     /* 283988 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(284052), // Rule ID 13040 //
     /* 283993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 284005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284014 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 284018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284026 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284030 */     // MIs[2] Rn
     /* 284030 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284035 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 284039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284041 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 284041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 284044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284050 */     GIR_RootConstrainSelectedInstOperands,
     /* 284051 */     // GIR_Coverage, 13040,
     /* 284051 */     GIR_EraseRootFromParent_Done,
     /* 284052 */   // Label 5862: @284052
     /* 284052 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(284143), // Rule ID 13867 //
     /* 284057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284078 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 284082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284090 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284094 */     // MIs[2] Rn
     /* 284094 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284099 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 284103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284105 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 284105 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 284108 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284112 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284117 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 284123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 284136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284141 */     GIR_RootConstrainSelectedInstOperands,
     /* 284142 */     // GIR_Coverage, 13867,
     /* 284142 */     GIR_EraseRootFromParent_Done,
     /* 284143 */   // Label 5863: @284143
     /* 284143 */   GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(284207), // Rule ID 15542 //
     /* 284148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 284160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284169 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 284173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284185 */     // MIs[2] Rn
     /* 284185 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284190 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 284194 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284196 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 284196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 284199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284205 */     GIR_RootConstrainSelectedInstOperands,
     /* 284206 */     // GIR_Coverage, 15542,
     /* 284206 */     GIR_EraseRootFromParent_Done,
     /* 284207 */   // Label 5864: @284207
     /* 284207 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(284234), // Rule ID 586 //
     /* 284212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284223 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 284223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 284228 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284232 */     GIR_RootConstrainSelectedInstOperands,
     /* 284233 */     // GIR_Coverage, 586,
     /* 284233 */     GIR_Done,
     /* 284234 */   // Label 5865: @284234
     /* 284234 */   GIM_Reject,
     /* 284235 */ // Label 5860: @284235
     /* 284235 */ GIM_Reject,
     /* 284236 */ // Label 5846: @284236
     /* 284236 */ GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(284407),
     /* 284241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 284244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 284247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284251 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(284315), // Rule ID 6884 //
     /* 284256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284277 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 284281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284293 */     // MIs[2] Rn
     /* 284293 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284298 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 284302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284304 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 284304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 284307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284313 */     GIR_RootConstrainSelectedInstOperands,
     /* 284314 */     // GIR_Coverage, 6884,
     /* 284314 */     GIR_EraseRootFromParent_Done,
     /* 284315 */   // Label 5867: @284315
     /* 284315 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(284379), // Rule ID 13865 //
     /* 284320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 284336 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284341 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 284345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 284353 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 284357 */     // MIs[2] Rn
     /* 284357 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284362 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 284366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284368 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 284368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 284371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284377 */     GIR_RootConstrainSelectedInstOperands,
     /* 284378 */     // GIR_Coverage, 13865,
     /* 284378 */     GIR_EraseRootFromParent_Done,
     /* 284379 */   // Label 5868: @284379
     /* 284379 */   GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(284406), // Rule ID 588 //
     /* 284384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 284387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284395 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 284395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 284400 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284404 */     GIR_RootConstrainSelectedInstOperands,
     /* 284405 */     // GIR_Coverage, 588,
     /* 284405 */     GIR_Done,
     /* 284406 */   // Label 5869: @284406
     /* 284406 */   GIM_Reject,
     /* 284407 */ // Label 5866: @284407
     /* 284407 */ GIM_Reject,
     /* 284408 */ // Label 5847: @284408
     /* 284408 */ GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(284445), // Rule ID 1203 //
     /* 284413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 284419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 284422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284430 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284434 */   // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 284434 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 284439 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284443 */   GIR_RootConstrainSelectedInstOperands,
     /* 284444 */   // GIR_Coverage, 1203,
     /* 284444 */   GIR_Done,
     /* 284445 */ // Label 5870: @284445
     /* 284445 */ GIM_Reject,
     /* 284446 */ // Label 5848: @284446
     /* 284446 */ GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(284621),
     /* 284451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 284457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284461 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(284527), // Rule ID 6906 //
     /* 284466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /* 284474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 284482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /* 284500 */     // MIs[2] Rn
     /* 284500 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284505 */     // MIs[2] Rm
     /* 284505 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284512 */     // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 284512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 284515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284525 */     GIR_RootConstrainSelectedInstOperands,
     /* 284526 */     // GIR_Coverage, 6906,
     /* 284526 */     GIR_EraseRootFromParent_Done,
     /* 284527 */   // Label 5872: @284527
     /* 284527 */   GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(284593), // Rule ID 13877 //
     /* 284532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /* 284540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 284544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 284548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /* 284566 */     // MIs[2] Rn
     /* 284566 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284571 */     // MIs[2] Rm
     /* 284571 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284576 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284578 */     // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 284578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 284581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284591 */     GIR_RootConstrainSelectedInstOperands,
     /* 284592 */     // GIR_Coverage, 13877,
     /* 284592 */     GIR_EraseRootFromParent_Done,
     /* 284593 */   // Label 5873: @284593
     /* 284593 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(284620), // Rule ID 1207 //
     /* 284598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284609 */     // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 284609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 284614 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284618 */     GIR_RootConstrainSelectedInstOperands,
     /* 284619 */     // GIR_Coverage, 1207,
     /* 284619 */     GIR_Done,
     /* 284620 */   // Label 5874: @284620
     /* 284620 */   GIM_Reject,
     /* 284621 */ // Label 5871: @284621
     /* 284621 */ GIM_Reject,
     /* 284622 */ // Label 5849: @284622
     /* 284622 */ GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(284659), // Rule ID 1199 //
     /* 284627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 284633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 284636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284644 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284648 */   // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 284648 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 284653 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284657 */   GIR_RootConstrainSelectedInstOperands,
     /* 284658 */   // GIR_Coverage, 1199,
     /* 284658 */   GIR_Done,
     /* 284659 */ // Label 5875: @284659
     /* 284659 */ GIM_Reject,
     /* 284660 */ // Label 5850: @284660
     /* 284660 */ GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(284835),
     /* 284665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 284671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284675 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(284741), // Rule ID 6907 //
     /* 284680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 284688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 284696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 284714 */     // MIs[2] Rn
     /* 284714 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284719 */     // MIs[2] Rm
     /* 284719 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284724 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284726 */     // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 284726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 284729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284739 */     GIR_RootConstrainSelectedInstOperands,
     /* 284740 */     // GIR_Coverage, 6907,
     /* 284740 */     GIR_EraseRootFromParent_Done,
     /* 284741 */   // Label 5877: @284741
     /* 284741 */   GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(284807), // Rule ID 13878 //
     /* 284746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 284754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 284758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 284762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 284780 */     // MIs[2] Rn
     /* 284780 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284785 */     // MIs[2] Rm
     /* 284785 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284792 */     // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 284792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 284795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284805 */     GIR_RootConstrainSelectedInstOperands,
     /* 284806 */     // GIR_Coverage, 13878,
     /* 284806 */     GIR_EraseRootFromParent_Done,
     /* 284807 */   // Label 5878: @284807
     /* 284807 */   GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(284834), // Rule ID 1205 //
     /* 284812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284823 */     // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 284823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 284828 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 284832 */     GIR_RootConstrainSelectedInstOperands,
     /* 284833 */     // GIR_Coverage, 1205,
     /* 284833 */     GIR_Done,
     /* 284834 */   // Label 5879: @284834
     /* 284834 */   GIM_Reject,
     /* 284835 */ // Label 5876: @284835
     /* 284835 */ GIM_Reject,
     /* 284836 */ // Label 5851: @284836
     /* 284836 */ GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(285279),
     /* 284841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284851 */   GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(284920), // Rule ID 6908 //
     /* 284856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 284859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 284867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 284893 */     // MIs[2] Rn
     /* 284893 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284898 */     // MIs[2] Rm
     /* 284898 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284905 */     // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 284905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 284908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284918 */     GIR_RootConstrainSelectedInstOperands,
     /* 284919 */     // GIR_Coverage, 6908,
     /* 284919 */     GIR_EraseRootFromParent_Done,
     /* 284920 */   // Label 5881: @284920
     /* 284920 */   GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(284989), // Rule ID 13879 //
     /* 284925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 284928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 284936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 284940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284954 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 284958 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 284962 */     // MIs[2] Rn
     /* 284962 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 284967 */     // MIs[2] Rm
     /* 284967 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 284972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 284974 */     // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 284974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 284977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 284983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 284987 */     GIR_RootConstrainSelectedInstOperands,
     /* 284988 */     // GIR_Coverage, 13879,
     /* 284988 */     GIR_EraseRootFromParent_Done,
     /* 284989 */   // Label 5882: @284989
     /* 284989 */   GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(285016), // Rule ID 1201 //
     /* 284994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 284997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285005 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 285005 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 285010 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285014 */     GIR_RootConstrainSelectedInstOperands,
     /* 285015 */     // GIR_Coverage, 1201,
     /* 285015 */     GIR_Done,
     /* 285016 */   // Label 5883: @285016
     /* 285016 */   GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(285278), // Rule ID 6977 //
     /* 285021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 285024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285032 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 285032 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 285035 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 285039 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285044 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 285048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 285050 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 285053 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 285057 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285062 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 285066 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 285068 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 285071 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 285075 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285080 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 285083 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 285086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 285088 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 285091 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285095 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285100 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 285106 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285111 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285116 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 285119 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 285123 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285128 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 285131 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 285133 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 285136 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285140 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285145 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285151 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285156 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285161 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 285164 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 285168 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285173 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 285176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 285178 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 285181 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 285185 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285190 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 285193 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 285196 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 285198 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 285201 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 285205 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285210 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 285213 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 285215 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 285218 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285222 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 285229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 285232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285241 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 285244 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 285247 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 285250 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 285268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 285270 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285273 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 285276 */     GIR_RootConstrainSelectedInstOperands,
     /* 285277 */     // GIR_Coverage, 6977,
     /* 285277 */     GIR_EraseRootFromParent_Done,
     /* 285278 */   // Label 5884: @285278
     /* 285278 */   GIM_Reject,
     /* 285279 */ // Label 5880: @285279
     /* 285279 */ GIM_Reject,
     /* 285280 */ // Label 5852: @285280
     /* 285280 */ GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(285305), // Rule ID 2822 //
     /* 285285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 285291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 285294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285298 */   // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 285298 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
     /* 285303 */   GIR_RootConstrainSelectedInstOperands,
     /* 285304 */   // GIR_Coverage, 2822,
     /* 285304 */   GIR_Done,
     /* 285305 */ // Label 5885: @285305
     /* 285305 */ GIM_Reject,
     /* 285306 */ // Label 5853: @285306
     /* 285306 */ GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(285331), // Rule ID 2820 //
     /* 285311 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 285317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 285320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285324 */   // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 285324 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
     /* 285329 */   GIR_RootConstrainSelectedInstOperands,
     /* 285330 */   // GIR_Coverage, 2820,
     /* 285330 */   GIR_Done,
     /* 285331 */ // Label 5886: @285331
     /* 285331 */ GIM_Reject,
     /* 285332 */ // Label 5854: @285332
     /* 285332 */ GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(285357), // Rule ID 2818 //
     /* 285337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 285340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 285343 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 285346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 285350 */   // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 285350 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
     /* 285355 */   GIR_RootConstrainSelectedInstOperands,
     /* 285356 */   // GIR_Coverage, 2818,
     /* 285356 */   GIR_Done,
     /* 285357 */ // Label 5887: @285357
     /* 285357 */ GIM_Reject,
     /* 285358 */ // Label 5855: @285358
     /* 285358 */ GIM_Reject,
     /* 285359 */ // Label 58: @285359
     /* 285359 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5899*/ GIMT_Encode4(286096),
     /* 285370 */ /*GILLT_s16*//*Label 5888*/ GIMT_Encode4(285454),
     /* 285374 */ /*GILLT_s32*//*Label 5889*/ GIMT_Encode4(285492),
     /* 285378 */ /*GILLT_s64*//*Label 5890*/ GIMT_Encode4(285530), GIMT_Encode4(0),
     /* 285386 */ /*GILLT_v2s32*//*Label 5891*/ GIMT_Encode4(285568),
     /* 285390 */ /*GILLT_v2s64*//*Label 5892*/ GIMT_Encode4(285606),
     /* 285394 */ /*GILLT_v4s16*//*Label 5893*/ GIMT_Encode4(285644),
     /* 285398 */ /*GILLT_v4s32*//*Label 5894*/ GIMT_Encode4(285682), GIMT_Encode4(0),
     /* 285406 */ /*GILLT_v8s16*//*Label 5895*/ GIMT_Encode4(285720), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285430 */ /*GILLT_nxv2s64*//*Label 5896*/ GIMT_Encode4(286018), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285442 */ /*GILLT_nxv4s32*//*Label 5897*/ GIMT_Encode4(286044), GIMT_Encode4(0),
     /* 285450 */ /*GILLT_nxv8s16*//*Label 5898*/ GIMT_Encode4(286070),
     /* 285454 */ // Label 5888: @285454
     /* 285454 */ GIM_Try, /*On fail goto*//*Label 5900*/ GIMT_Encode4(285491), // Rule ID 632 //
     /* 285459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 285462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 285465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 285468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285476 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 285480 */   // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 285480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 285485 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285489 */   GIR_RootConstrainSelectedInstOperands,
     /* 285490 */   // GIR_Coverage, 632,
     /* 285490 */   GIR_Done,
     /* 285491 */ // Label 5900: @285491
     /* 285491 */ GIM_Reject,
     /* 285492 */ // Label 5889: @285492
     /* 285492 */ GIM_Try, /*On fail goto*//*Label 5901*/ GIMT_Encode4(285529), // Rule ID 634 //
     /* 285497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 285503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 285506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285514 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 285518 */   // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 285518 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 285523 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285527 */   GIR_RootConstrainSelectedInstOperands,
     /* 285528 */   // GIR_Coverage, 634,
     /* 285528 */   GIR_Done,
     /* 285529 */ // Label 5901: @285529
     /* 285529 */ GIM_Reject,
     /* 285530 */ // Label 5890: @285530
     /* 285530 */ GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(285567), // Rule ID 636 //
     /* 285535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 285538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 285541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 285544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285552 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285556 */   // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 285556 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 285561 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285565 */   GIR_RootConstrainSelectedInstOperands,
     /* 285566 */   // GIR_Coverage, 636,
     /* 285566 */   GIR_Done,
     /* 285567 */ // Label 5902: @285567
     /* 285567 */ GIM_Reject,
     /* 285568 */ // Label 5891: @285568
     /* 285568 */ GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(285605), // Rule ID 1343 //
     /* 285573 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 285579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 285582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285590 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285594 */   // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 285594 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 285599 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285603 */   GIR_RootConstrainSelectedInstOperands,
     /* 285604 */   // GIR_Coverage, 1343,
     /* 285604 */   GIR_Done,
     /* 285605 */ // Label 5903: @285605
     /* 285605 */ GIM_Reject,
     /* 285606 */ // Label 5892: @285606
     /* 285606 */ GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(285643), // Rule ID 1347 //
     /* 285611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285617 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 285620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285628 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285632 */   // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 285632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 285637 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285641 */   GIR_RootConstrainSelectedInstOperands,
     /* 285642 */   // GIR_Coverage, 1347,
     /* 285642 */   GIR_Done,
     /* 285643 */ // Label 5904: @285643
     /* 285643 */ GIM_Reject,
     /* 285644 */ // Label 5893: @285644
     /* 285644 */ GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(285681), // Rule ID 1339 //
     /* 285649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 285652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 285655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285666 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285670 */   // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 285670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 285675 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285679 */   GIR_RootConstrainSelectedInstOperands,
     /* 285680 */   // GIR_Coverage, 1339,
     /* 285680 */   GIR_Done,
     /* 285681 */ // Label 5905: @285681
     /* 285681 */ GIM_Reject,
     /* 285682 */ // Label 5894: @285682
     /* 285682 */ GIM_Try, /*On fail goto*//*Label 5906*/ GIMT_Encode4(285719), // Rule ID 1345 //
     /* 285687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 285693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 285696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285704 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285708 */   // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 285708 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 285713 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285717 */   GIR_RootConstrainSelectedInstOperands,
     /* 285718 */   // GIR_Coverage, 1345,
     /* 285718 */   GIR_Done,
     /* 285719 */ // Label 5906: @285719
     /* 285719 */ GIM_Reject,
     /* 285720 */ // Label 5895: @285720
     /* 285720 */ GIM_Try, /*On fail goto*//*Label 5907*/ GIMT_Encode4(286017),
     /* 285725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 285728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 285731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285739 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285743 */   GIM_Try, /*On fail goto*//*Label 5908*/ GIMT_Encode4(285762), // Rule ID 1341 //
     /* 285748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 285751 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 285751 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 285756 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 285760 */     GIR_RootConstrainSelectedInstOperands,
     /* 285761 */     // GIR_Coverage, 1341,
     /* 285761 */     GIR_Done,
     /* 285762 */   // Label 5908: @285762
     /* 285762 */   GIM_Try, /*On fail goto*//*Label 5909*/ GIMT_Encode4(286016), // Rule ID 6983 //
     /* 285767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 285770 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 285770 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 285773 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 285777 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285782 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 285786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 285788 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 285791 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 285795 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285800 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 285804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 285806 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 285809 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 285813 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285818 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 285821 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 285824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 285826 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 285829 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285833 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285838 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 285844 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285849 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285854 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 285857 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 285861 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285866 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 285869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 285871 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 285874 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285878 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285883 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 285889 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285894 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285899 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 285902 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 285906 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285911 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 285914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 285916 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 285919 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 285923 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285928 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 285931 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 285934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 285936 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 285939 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 285943 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285948 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 285951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 285953 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 285956 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 285960 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 285967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 285970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 285974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285979 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 285982 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 285985 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 285988 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 286006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 286008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 286014 */     GIR_RootConstrainSelectedInstOperands,
     /* 286015 */     // GIR_Coverage, 6983,
     /* 286015 */     GIR_EraseRootFromParent_Done,
     /* 286016 */   // Label 5909: @286016
     /* 286016 */   GIM_Reject,
     /* 286017 */ // Label 5907: @286017
     /* 286017 */ GIM_Reject,
     /* 286018 */ // Label 5896: @286018
     /* 286018 */ GIM_Try, /*On fail goto*//*Label 5910*/ GIMT_Encode4(286043), // Rule ID 8147 //
     /* 286023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 286026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 286029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 286032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 286036 */   // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 286036 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
     /* 286041 */   GIR_RootConstrainSelectedInstOperands,
     /* 286042 */   // GIR_Coverage, 8147,
     /* 286042 */   GIR_Done,
     /* 286043 */ // Label 5910: @286043
     /* 286043 */ GIM_Reject,
     /* 286044 */ // Label 5897: @286044
     /* 286044 */ GIM_Try, /*On fail goto*//*Label 5911*/ GIMT_Encode4(286069), // Rule ID 8145 //
     /* 286049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 286052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 286055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 286058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 286062 */   // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 286062 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
     /* 286067 */   GIR_RootConstrainSelectedInstOperands,
     /* 286068 */   // GIR_Coverage, 8145,
     /* 286068 */   GIR_Done,
     /* 286069 */ // Label 5911: @286069
     /* 286069 */ GIM_Reject,
     /* 286070 */ // Label 5898: @286070
     /* 286070 */ GIM_Try, /*On fail goto*//*Label 5912*/ GIMT_Encode4(286095), // Rule ID 8143 //
     /* 286075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 286078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 286081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 286084 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 286088 */   // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 286088 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
     /* 286093 */   GIR_RootConstrainSelectedInstOperands,
     /* 286094 */   // GIR_Coverage, 8143,
     /* 286094 */   GIR_Done,
     /* 286095 */ // Label 5912: @286095
     /* 286095 */ GIM_Reject,
     /* 286096 */ // Label 5899: @286096
     /* 286096 */ GIM_Reject,
     /* 286097 */ // Label 59: @286097
     /* 286097 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 5924*/ GIMT_Encode4(290192),
     /* 286108 */ /*GILLT_s16*//*Label 5913*/ GIMT_Encode4(286192),
     /* 286112 */ /*GILLT_s32*//*Label 5914*/ GIMT_Encode4(286834),
     /* 286116 */ /*GILLT_s64*//*Label 5915*/ GIMT_Encode4(287464), GIMT_Encode4(0),
     /* 286124 */ /*GILLT_v2s32*//*Label 5916*/ GIMT_Encode4(288094),
     /* 286128 */ /*GILLT_v2s64*//*Label 5917*/ GIMT_Encode4(288624),
     /* 286132 */ /*GILLT_v4s16*//*Label 5918*/ GIMT_Encode4(288982),
     /* 286136 */ /*GILLT_v4s32*//*Label 5919*/ GIMT_Encode4(289324), GIMT_Encode4(0),
     /* 286144 */ /*GILLT_v8s16*//*Label 5920*/ GIMT_Encode4(289682), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 286168 */ /*GILLT_nxv2s64*//*Label 5921*/ GIMT_Encode4(290114), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 286180 */ /*GILLT_nxv4s32*//*Label 5922*/ GIMT_Encode4(290140), GIMT_Encode4(0),
     /* 286188 */ /*GILLT_nxv8s16*//*Label 5923*/ GIMT_Encode4(290166),
     /* 286192 */ // Label 5913: @286192
     /* 286192 */ GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(286833),
     /* 286197 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 286200 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 286203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286207 */   GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(286320), // Rule ID 6210 //
     /* 286212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286236 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286248 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286252 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 286265 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286269 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 286273 */     // MIs[3] Operand 1
     /* 286273 */     // No operand predicates
     /* 286273 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286275 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 286275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 286278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286287 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 286293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 286306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 286315 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 286318 */     GIR_RootConstrainSelectedInstOperands,
     /* 286319 */     // GIR_Coverage, 6210,
     /* 286319 */     GIR_EraseRootFromParent_Done,
     /* 286320 */   // Label 5926: @286320
     /* 286320 */   GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(286433), // Rule ID 13840 //
     /* 286325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286357 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 286361 */     // MIs[2] Operand 1
     /* 286361 */     // No operand predicates
     /* 286361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 286365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286369 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286373 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 286377 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286382 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 286386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286388 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 286388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 286391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286400 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 286406 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 286419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286421 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286428 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286431 */     GIR_RootConstrainSelectedInstOperands,
     /* 286432 */     // GIR_Coverage, 13840,
     /* 286432 */     GIR_EraseRootFromParent_Done,
     /* 286433 */   // Label 5927: @286433
     /* 286433 */   GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(286512), // Rule ID 13777 //
     /* 286438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286462 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286470 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286472 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 286472 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 286475 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286479 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286484 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 286490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 286503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 286507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286510 */     GIR_RootConstrainSelectedInstOperands,
     /* 286511 */     // GIR_Coverage, 13777,
     /* 286511 */     GIR_EraseRootFromParent_Done,
     /* 286512 */   // Label 5928: @286512
     /* 286512 */   GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(286591), // Rule ID 4789 //
     /* 286517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286520 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286536 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286545 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286551 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 286551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 286554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286563 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 286569 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 286582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286589 */     GIR_RootConstrainSelectedInstOperands,
     /* 286590 */     // GIR_Coverage, 4789,
     /* 286590 */     GIR_EraseRootFromParent_Done,
     /* 286591 */   // Label 5929: @286591
     /* 286591 */   GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(286654), // Rule ID 13392 //
     /* 286596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286615 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 286620 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286624 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286628 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 286632 */     // MIs[2] Operand 1
     /* 286632 */     // No operand predicates
     /* 286632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286636 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286638 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 286638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 286641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286643 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 286645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286652 */     GIR_RootConstrainSelectedInstOperands,
     /* 286653 */     // GIR_Coverage, 13392,
     /* 286653 */     GIR_EraseRootFromParent_Done,
     /* 286654 */   // Label 5930: @286654
     /* 286654 */   GIM_Try, /*On fail goto*//*Label 5931*/ GIMT_Encode4(286717), // Rule ID 2012 //
     /* 286659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 286662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 286687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286695 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 286699 */     // MIs[2] Operand 1
     /* 286699 */     // No operand predicates
     /* 286699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 286701 */     // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 286701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 286704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286706 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 286715 */     GIR_RootConstrainSelectedInstOperands,
     /* 286716 */     // GIR_Coverage, 2012,
     /* 286716 */     GIR_EraseRootFromParent_Done,
     /* 286717 */   // Label 5931: @286717
     /* 286717 */   GIM_Try, /*On fail goto*//*Label 5932*/ GIMT_Encode4(286761), // Rule ID 4794 //
     /* 286722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 286737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286748 */     // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 286748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 286751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 286757 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 286759 */     GIR_RootConstrainSelectedInstOperands,
     /* 286760 */     // GIR_Coverage, 4794,
     /* 286760 */     GIR_EraseRootFromParent_Done,
     /* 286761 */   // Label 5932: @286761
     /* 286761 */   GIM_Try, /*On fail goto*//*Label 5933*/ GIMT_Encode4(286805), // Rule ID 13782 //
     /* 286766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 286781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 286785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286790 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286792 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 286792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 286795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 286801 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 286803 */     GIR_RootConstrainSelectedInstOperands,
     /* 286804 */     // GIR_Coverage, 13782,
     /* 286804 */     GIR_EraseRootFromParent_Done,
     /* 286805 */   // Label 5933: @286805
     /* 286805 */   GIM_Try, /*On fail goto*//*Label 5934*/ GIMT_Encode4(286832), // Rule ID 620 //
     /* 286810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 286813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 286821 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 286821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 286826 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 286830 */     GIR_RootConstrainSelectedInstOperands,
     /* 286831 */     // GIR_Coverage, 620,
     /* 286831 */     GIR_Done,
     /* 286832 */   // Label 5934: @286832
     /* 286832 */   GIM_Reject,
     /* 286833 */ // Label 5925: @286833
     /* 286833 */ GIM_Reject,
     /* 286834 */ // Label 5914: @286834
     /* 286834 */ GIM_Try, /*On fail goto*//*Label 5935*/ GIMT_Encode4(287463),
     /* 286839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 286842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 286845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286849 */   GIM_Try, /*On fail goto*//*Label 5936*/ GIMT_Encode4(286962), // Rule ID 6212 //
     /* 286854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286878 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 286882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 286898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 286907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286911 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 286915 */     // MIs[3] Operand 1
     /* 286915 */     // No operand predicates
     /* 286915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286917 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 286917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286929 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 286935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 286940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 286948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 286957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 286960 */     GIR_RootConstrainSelectedInstOperands,
     /* 286961 */     // GIR_Coverage, 6212,
     /* 286961 */     GIR_EraseRootFromParent_Done,
     /* 286962 */   // Label 5936: @286962
     /* 286962 */   GIM_Try, /*On fail goto*//*Label 5937*/ GIMT_Encode4(287075), // Rule ID 13842 //
     /* 286967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 286970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 286978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 286986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 286995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286999 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287003 */     // MIs[2] Operand 1
     /* 287003 */     // No operand predicates
     /* 287003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 287007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287011 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287015 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 287019 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287024 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 287028 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287030 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 287030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 287033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287042 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 287048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 287061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287073 */     GIR_RootConstrainSelectedInstOperands,
     /* 287074 */     // GIR_Coverage, 13842,
     /* 287074 */     GIR_EraseRootFromParent_Done,
     /* 287075 */   // Label 5937: @287075
     /* 287075 */   GIM_Try, /*On fail goto*//*Label 5938*/ GIMT_Encode4(287151), // Rule ID 13779 //
     /* 287080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287092 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287096 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287101 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287109 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287111 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 287111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 287114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287123 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 287129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 287142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287149 */     GIR_RootConstrainSelectedInstOperands,
     /* 287150 */     // GIR_Coverage, 13779,
     /* 287150 */     GIR_EraseRootFromParent_Done,
     /* 287151 */   // Label 5938: @287151
     /* 287151 */   GIM_Try, /*On fail goto*//*Label 5939*/ GIMT_Encode4(287227), // Rule ID 4791 //
     /* 287156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287176 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287181 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287187 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 287187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 287190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287199 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 287205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 287218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287225 */     GIR_RootConstrainSelectedInstOperands,
     /* 287226 */     // GIR_Coverage, 4791,
     /* 287226 */     GIR_EraseRootFromParent_Done,
     /* 287227 */   // Label 5939: @287227
     /* 287227 */   GIM_Try, /*On fail goto*//*Label 5940*/ GIMT_Encode4(287290), // Rule ID 13394 //
     /* 287232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287264 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287268 */     // MIs[2] Operand 1
     /* 287268 */     // No operand predicates
     /* 287268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287272 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287274 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 287277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287288 */     GIR_RootConstrainSelectedInstOperands,
     /* 287289 */     // GIR_Coverage, 13394,
     /* 287289 */     GIR_EraseRootFromParent_Done,
     /* 287290 */   // Label 5940: @287290
     /* 287290 */   GIM_Try, /*On fail goto*//*Label 5941*/ GIMT_Encode4(287353), // Rule ID 2014 //
     /* 287295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 287314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287318 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287331 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 287335 */     // MIs[2] Operand 1
     /* 287335 */     // No operand predicates
     /* 287335 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287337 */     // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 287340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287351 */     GIR_RootConstrainSelectedInstOperands,
     /* 287352 */     // GIR_Coverage, 2014,
     /* 287352 */     GIR_EraseRootFromParent_Done,
     /* 287353 */   // Label 5941: @287353
     /* 287353 */   GIM_Try, /*On fail goto*//*Label 5942*/ GIMT_Encode4(287394), // Rule ID 4795 //
     /* 287358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287381 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 287381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 287384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 287390 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 287392 */     GIR_RootConstrainSelectedInstOperands,
     /* 287393 */     // GIR_Coverage, 4795,
     /* 287393 */     GIR_EraseRootFromParent_Done,
     /* 287394 */   // Label 5942: @287394
     /* 287394 */   GIM_Try, /*On fail goto*//*Label 5943*/ GIMT_Encode4(287435), // Rule ID 13783 //
     /* 287399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287422 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 287422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 287425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 287431 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 287433 */     GIR_RootConstrainSelectedInstOperands,
     /* 287434 */     // GIR_Coverage, 13783,
     /* 287434 */     GIR_EraseRootFromParent_Done,
     /* 287435 */   // Label 5943: @287435
     /* 287435 */   GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(287462), // Rule ID 622 //
     /* 287440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 287443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 287451 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 287451 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 287456 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 287460 */     GIR_RootConstrainSelectedInstOperands,
     /* 287461 */     // GIR_Coverage, 622,
     /* 287461 */     GIR_Done,
     /* 287462 */   // Label 5944: @287462
     /* 287462 */   GIM_Reject,
     /* 287463 */ // Label 5935: @287463
     /* 287463 */ GIM_Reject,
     /* 287464 */ // Label 5915: @287464
     /* 287464 */ GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(288093),
     /* 287469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 287472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 287475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287479 */   GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(287592), // Rule ID 6214 //
     /* 287484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287508 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 287528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 287537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287541 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287545 */     // MIs[3] Operand 1
     /* 287545 */     // No operand predicates
     /* 287545 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287547 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287559 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 287565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 287578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287580 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 287587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 287590 */     GIR_RootConstrainSelectedInstOperands,
     /* 287591 */     // GIR_Coverage, 6214,
     /* 287591 */     GIR_EraseRootFromParent_Done,
     /* 287592 */   // Label 5946: @287592
     /* 287592 */   GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(287705), // Rule ID 13844 //
     /* 287597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287612 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287616 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287629 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287633 */     // MIs[2] Operand 1
     /* 287633 */     // No operand predicates
     /* 287633 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 287637 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287641 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287645 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 287649 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287654 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 287658 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 287660 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 287660 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287663 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287667 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287672 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 287678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 287691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287693 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287700 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287703 */     GIR_RootConstrainSelectedInstOperands,
     /* 287704 */     // GIR_Coverage, 13844,
     /* 287704 */     GIR_EraseRootFromParent_Done,
     /* 287705 */   // Label 5947: @287705
     /* 287705 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(287781), // Rule ID 13781 //
     /* 287710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287726 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287731 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287741 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 287741 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287744 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287748 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287753 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 287759 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 287772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287779 */     GIR_RootConstrainSelectedInstOperands,
     /* 287780 */     // GIR_Coverage, 13781,
     /* 287780 */     GIR_EraseRootFromParent_Done,
     /* 287781 */   // Label 5948: @287781
     /* 287781 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(287857), // Rule ID 4793 //
     /* 287786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287798 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287802 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287811 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 287815 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287817 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 287817 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287820 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287824 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287829 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 287835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 287848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287850 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287852 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287855 */     GIR_RootConstrainSelectedInstOperands,
     /* 287856 */     // GIR_Coverage, 4793,
     /* 287856 */     GIR_EraseRootFromParent_Done,
     /* 287857 */   // Label 5949: @287857
     /* 287857 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(287920), // Rule ID 13396 //
     /* 287862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287894 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287898 */     // MIs[2] Operand 1
     /* 287898 */     // No operand predicates
     /* 287898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287904 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 287907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 287911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287918 */     GIR_RootConstrainSelectedInstOperands,
     /* 287919 */     // GIR_Coverage, 13396,
     /* 287919 */     GIR_EraseRootFromParent_Done,
     /* 287920 */   // Label 5950: @287920
     /* 287920 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(287983), // Rule ID 2016 //
     /* 287925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 287928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 287932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 287940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 287944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 287948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 287953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 287957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287961 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 287965 */     // MIs[2] Operand 1
     /* 287965 */     // No operand predicates
     /* 287965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287967 */     // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 287967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 287970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287972 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 287981 */     GIR_RootConstrainSelectedInstOperands,
     /* 287982 */     // GIR_Coverage, 2016,
     /* 287982 */     GIR_EraseRootFromParent_Done,
     /* 287983 */   // Label 5951: @287983
     /* 287983 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(288024), // Rule ID 4796 //
     /* 287988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 287996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288009 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288011 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 288011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 288014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 288020 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 288022 */     GIR_RootConstrainSelectedInstOperands,
     /* 288023 */     // GIR_Coverage, 4796,
     /* 288023 */     GIR_EraseRootFromParent_Done,
     /* 288024 */   // Label 5952: @288024
     /* 288024 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(288065), // Rule ID 13784 //
     /* 288029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 288041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288052 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 288052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 288055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 288061 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 288063 */     GIR_RootConstrainSelectedInstOperands,
     /* 288064 */     // GIR_Coverage, 13784,
     /* 288064 */     GIR_EraseRootFromParent_Done,
     /* 288065 */   // Label 5953: @288065
     /* 288065 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(288092), // Rule ID 624 //
     /* 288070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 288073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288081 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 288081 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 288086 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 288090 */     GIR_RootConstrainSelectedInstOperands,
     /* 288091 */     // GIR_Coverage, 624,
     /* 288091 */     GIR_Done,
     /* 288092 */   // Label 5954: @288092
     /* 288092 */   GIM_Reject,
     /* 288093 */ // Label 5945: @288093
     /* 288093 */ GIM_Reject,
     /* 288094 */ // Label 5916: @288094
     /* 288094 */ GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(288623),
     /* 288099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 288102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 288105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288109 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(288195), // Rule ID 13385 //
     /* 288114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 288125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288150 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288154 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288158 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288162 */     // MIs[3] Operand 1
     /* 288162 */     // No operand predicates
     /* 288162 */     // MIs[1] Operand 2
     /* 288162 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 288173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288177 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288179 */     // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 288182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288193 */     GIR_RootConstrainSelectedInstOperands,
     /* 288194 */     // GIR_Coverage, 13385,
     /* 288194 */     GIR_EraseRootFromParent_Done,
     /* 288195 */   // Label 5956: @288195
     /* 288195 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(288281), // Rule ID 2005 //
     /* 288200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 288215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 288223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 288235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 288244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288248 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288252 */     // MIs[3] Operand 1
     /* 288252 */     // No operand predicates
     /* 288252 */     // MIs[1] Operand 2
     /* 288252 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 288263 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 288265 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 288268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 288276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 288279 */     GIR_RootConstrainSelectedInstOperands,
     /* 288280 */     // GIR_Coverage, 2005,
     /* 288280 */     GIR_EraseRootFromParent_Done,
     /* 288281 */   // Label 5957: @288281
     /* 288281 */   GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(288344), // Rule ID 13386 //
     /* 288286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288305 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288318 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288322 */     // MIs[2] Operand 1
     /* 288322 */     // No operand predicates
     /* 288322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288326 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288328 */     // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 288331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288339 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288342 */     GIR_RootConstrainSelectedInstOperands,
     /* 288343 */     // GIR_Coverage, 13386,
     /* 288343 */     GIR_EraseRootFromParent_Done,
     /* 288344 */   // Label 5958: @288344
     /* 288344 */   GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(288407), // Rule ID 2006 //
     /* 288349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 288364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 288368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288377 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288381 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288385 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 288389 */     // MIs[2] Operand 1
     /* 288389 */     // No operand predicates
     /* 288389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288391 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 288394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288405 */     GIR_RootConstrainSelectedInstOperands,
     /* 288406 */     // GIR_Coverage, 2006,
     /* 288406 */     GIR_EraseRootFromParent_Done,
     /* 288407 */   // Label 5959: @288407
     /* 288407 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(288501), // Rule ID 13846 //
     /* 288412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 288420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288435 */     // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 288435 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 288438 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 288442 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288447 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 288449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 288452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 288456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288461 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 288464 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288468 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 288471 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288476 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288481 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 288489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288499 */     GIR_RootConstrainSelectedInstOperands,
     /* 288500 */     // GIR_Coverage, 13846,
     /* 288500 */     GIR_EraseRootFromParent_Done,
     /* 288501 */   // Label 5960: @288501
     /* 288501 */   GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(288595), // Rule ID 6216 //
     /* 288506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 288518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288529 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 288529 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 288532 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 288536 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 288543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 288546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 288550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288555 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 288558 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288562 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 288565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288575 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 288580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 288583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288585 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288593 */     GIR_RootConstrainSelectedInstOperands,
     /* 288594 */     // GIR_Coverage, 6216,
     /* 288594 */     GIR_EraseRootFromParent_Done,
     /* 288595 */   // Label 5961: @288595
     /* 288595 */   GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(288622), // Rule ID 1323 //
     /* 288600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288611 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 288611 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 288616 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 288620 */     GIR_RootConstrainSelectedInstOperands,
     /* 288621 */     // GIR_Coverage, 1323,
     /* 288621 */     GIR_Done,
     /* 288622 */   // Label 5962: @288622
     /* 288622 */   GIM_Reject,
     /* 288623 */ // Label 5955: @288623
     /* 288623 */ GIM_Reject,
     /* 288624 */ // Label 5917: @288624
     /* 288624 */ GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(288981),
     /* 288629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 288635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288639 */   GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(288702), // Rule ID 13390 //
     /* 288644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 288655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288659 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288663 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288676 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 288680 */     // MIs[2] Operand 1
     /* 288680 */     // No operand predicates
     /* 288680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288684 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288686 */     // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 288689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288697 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288700 */     GIR_RootConstrainSelectedInstOperands,
     /* 288701 */     // GIR_Coverage, 13390,
     /* 288701 */     GIR_EraseRootFromParent_Done,
     /* 288702 */   // Label 5964: @288702
     /* 288702 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(288765), // Rule ID 2010 //
     /* 288707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288710 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 288722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 288726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 288730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 288739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288743 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 288747 */     // MIs[2] Operand 1
     /* 288747 */     // No operand predicates
     /* 288747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 288749 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 288749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 288752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288754 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 288763 */     GIR_RootConstrainSelectedInstOperands,
     /* 288764 */     // GIR_Coverage, 2010,
     /* 288764 */     GIR_EraseRootFromParent_Done,
     /* 288765 */   // Label 5965: @288765
     /* 288765 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(288859), // Rule ID 13850 //
     /* 288770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 288778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288793 */     // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 288793 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 288796 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 288800 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288805 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 288807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 288810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 288814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288819 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 288822 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288826 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 288829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288834 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 288847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288857 */     GIR_RootConstrainSelectedInstOperands,
     /* 288858 */     // GIR_Coverage, 13850,
     /* 288858 */     GIR_EraseRootFromParent_Done,
     /* 288859 */   // Label 5966: @288859
     /* 288859 */   GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(288953), // Rule ID 6220 //
     /* 288864 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 288876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288887 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 288887 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 288890 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 288894 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288899 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 288901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 288904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 288908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288913 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 288916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288920 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 288923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288933 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 288941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 288951 */     GIR_RootConstrainSelectedInstOperands,
     /* 288952 */     // GIR_Coverage, 6220,
     /* 288952 */     GIR_EraseRootFromParent_Done,
     /* 288953 */   // Label 5967: @288953
     /* 288953 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(288980), // Rule ID 1327 //
     /* 288958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 288969 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 288969 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 288974 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 288978 */     GIR_RootConstrainSelectedInstOperands,
     /* 288979 */     // GIR_Coverage, 1327,
     /* 288979 */     GIR_Done,
     /* 288980 */   // Label 5968: @288980
     /* 288980 */   GIM_Reject,
     /* 288981 */ // Label 5963: @288981
     /* 288981 */ GIM_Reject,
     /* 288982 */ // Label 5918: @288982
     /* 288982 */ GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(289323),
     /* 288987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 288990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 288993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288997 */   GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(289083), // Rule ID 13379 //
     /* 289002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 289013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 289025 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289029 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 289038 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 289042 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289046 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 289050 */     // MIs[3] Operand 1
     /* 289050 */     // No operand predicates
     /* 289050 */     // MIs[1] Operand 2
     /* 289050 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 289061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289065 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289067 */     // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 289070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 289081 */     GIR_RootConstrainSelectedInstOperands,
     /* 289082 */     // GIR_Coverage, 13379,
     /* 289082 */     GIR_EraseRootFromParent_Done,
     /* 289083 */   // Label 5970: @289083
     /* 289083 */   GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(289169), // Rule ID 1999 //
     /* 289088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 289103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 289111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 289115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289119 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 289123 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 289128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 289132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289136 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 289140 */     // MIs[3] Operand 1
     /* 289140 */     // No operand predicates
     /* 289140 */     // MIs[1] Operand 2
     /* 289140 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 289151 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 289153 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 289156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 289164 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 289167 */     GIR_RootConstrainSelectedInstOperands,
     /* 289168 */     // GIR_Coverage, 1999,
     /* 289168 */     GIR_EraseRootFromParent_Done,
     /* 289169 */   // Label 5971: @289169
     /* 289169 */   GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(289232), // Rule ID 13380 //
     /* 289174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 289185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 289198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289206 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 289210 */     // MIs[2] Operand 1
     /* 289210 */     // No operand predicates
     /* 289210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289216 */     // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 289219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289230 */     GIR_RootConstrainSelectedInstOperands,
     /* 289231 */     // GIR_Coverage, 13380,
     /* 289231 */     GIR_EraseRootFromParent_Done,
     /* 289232 */   // Label 5972: @289232
     /* 289232 */   GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(289295), // Rule ID 2000 //
     /* 289237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289240 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 289252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289256 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289260 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 289265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289273 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 289277 */     // MIs[2] Operand 1
     /* 289277 */     // No operand predicates
     /* 289277 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289279 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 289282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289284 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289290 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289293 */     GIR_RootConstrainSelectedInstOperands,
     /* 289294 */     // GIR_Coverage, 2000,
     /* 289294 */     GIR_EraseRootFromParent_Done,
     /* 289295 */   // Label 5973: @289295
     /* 289295 */   GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(289322), // Rule ID 1319 //
     /* 289300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289311 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 289311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 289316 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 289320 */     GIR_RootConstrainSelectedInstOperands,
     /* 289321 */     // GIR_Coverage, 1319,
     /* 289321 */     GIR_Done,
     /* 289322 */   // Label 5974: @289322
     /* 289322 */   GIM_Reject,
     /* 289323 */ // Label 5969: @289323
     /* 289323 */ GIM_Reject,
     /* 289324 */ // Label 5919: @289324
     /* 289324 */ GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(289681),
     /* 289329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289332 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 289335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289339 */   GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(289402), // Rule ID 13388 //
     /* 289344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 289355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289376 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289380 */     // MIs[2] Operand 1
     /* 289380 */     // No operand predicates
     /* 289380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289386 */     // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 289389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289400 */     GIR_RootConstrainSelectedInstOperands,
     /* 289401 */     // GIR_Coverage, 13388,
     /* 289401 */     GIR_EraseRootFromParent_Done,
     /* 289402 */   // Label 5976: @289402
     /* 289402 */   GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(289465), // Rule ID 2008 //
     /* 289407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 289422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 289426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289443 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 289447 */     // MIs[2] Operand 1
     /* 289447 */     // No operand predicates
     /* 289447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289449 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 289452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289463 */     GIR_RootConstrainSelectedInstOperands,
     /* 289464 */     // GIR_Coverage, 2008,
     /* 289464 */     GIR_EraseRootFromParent_Done,
     /* 289465 */   // Label 5977: @289465
     /* 289465 */   GIM_Try, /*On fail goto*//*Label 5978*/ GIMT_Encode4(289559), // Rule ID 13848 //
     /* 289470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289493 */     // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289493 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 289496 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 289500 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289505 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 289507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 289510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 289514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289519 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 289522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289526 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289529 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 289547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289551 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289554 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289557 */     GIR_RootConstrainSelectedInstOperands,
     /* 289558 */     // GIR_Coverage, 13848,
     /* 289558 */     GIR_EraseRootFromParent_Done,
     /* 289559 */   // Label 5978: @289559
     /* 289559 */   GIM_Try, /*On fail goto*//*Label 5979*/ GIMT_Encode4(289653), // Rule ID 6218 //
     /* 289564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 289576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 289580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289585 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289587 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 289587 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 289590 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 289594 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 289601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 289604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 289608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289613 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 289616 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289620 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 289623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 289638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 289641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 289648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 289651 */     GIR_RootConstrainSelectedInstOperands,
     /* 289652 */     // GIR_Coverage, 6218,
     /* 289652 */     GIR_EraseRootFromParent_Done,
     /* 289653 */   // Label 5979: @289653
     /* 289653 */   GIM_Try, /*On fail goto*//*Label 5980*/ GIMT_Encode4(289680), // Rule ID 1325 //
     /* 289658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289669 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 289669 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 289674 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 289678 */     GIR_RootConstrainSelectedInstOperands,
     /* 289679 */     // GIR_Coverage, 1325,
     /* 289679 */     GIR_Done,
     /* 289680 */   // Label 5980: @289680
     /* 289680 */   GIM_Reject,
     /* 289681 */ // Label 5975: @289681
     /* 289681 */ GIM_Reject,
     /* 289682 */ // Label 5920: @289682
     /* 289682 */ GIM_Try, /*On fail goto*//*Label 5981*/ GIMT_Encode4(290113),
     /* 289687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 289693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289697 */   GIM_Try, /*On fail goto*//*Label 5982*/ GIMT_Encode4(289760), // Rule ID 13382 //
     /* 289702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 289709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 289713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 289726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289734 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 289738 */     // MIs[2] Operand 1
     /* 289738 */     // No operand predicates
     /* 289738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289742 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289744 */     // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 289747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289758 */     GIR_RootConstrainSelectedInstOperands,
     /* 289759 */     // GIR_Coverage, 13382,
     /* 289759 */     GIR_EraseRootFromParent_Done,
     /* 289760 */   // Label 5982: @289760
     /* 289760 */   GIM_Try, /*On fail goto*//*Label 5983*/ GIMT_Encode4(289823), // Rule ID 2002 //
     /* 289765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 289780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 289784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 289788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 289793 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 289797 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 289801 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 289805 */     // MIs[2] Operand 1
     /* 289805 */     // No operand predicates
     /* 289805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 289807 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 289807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 289810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 289814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 289818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 289821 */     GIR_RootConstrainSelectedInstOperands,
     /* 289822 */     // GIR_Coverage, 2002,
     /* 289822 */     GIR_EraseRootFromParent_Done,
     /* 289823 */   // Label 5983: @289823
     /* 289823 */   GIM_Try, /*On fail goto*//*Label 5984*/ GIMT_Encode4(289850), // Rule ID 1321 //
     /* 289828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 289831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289839 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 289839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 289844 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 289848 */     GIR_RootConstrainSelectedInstOperands,
     /* 289849 */     // GIR_Coverage, 1321,
     /* 289849 */     GIR_Done,
     /* 289850 */   // Label 5984: @289850
     /* 289850 */   GIM_Try, /*On fail goto*//*Label 5985*/ GIMT_Encode4(290112), // Rule ID 6981 //
     /* 289855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 289858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289866 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 289866 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 289869 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 289873 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289878 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 289882 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 289884 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 289887 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 289891 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289896 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 289900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 289902 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 289905 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 289909 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289914 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 289917 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 289920 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 289922 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 289925 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289929 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289934 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 289940 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289945 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289950 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 289953 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 289957 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289962 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 289965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 289967 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 289970 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 289974 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 289979 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 289985 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289990 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289995 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 289998 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 290002 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290007 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 290010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 290012 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 290015 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 290019 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290024 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 290027 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 290030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 290032 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 290035 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 290039 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290044 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 290047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 290049 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 290052 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 290056 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 290063 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 290066 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 290070 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290075 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 290078 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 290081 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 290084 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 290102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290104 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 290110 */     GIR_RootConstrainSelectedInstOperands,
     /* 290111 */     // GIR_Coverage, 6981,
     /* 290111 */     GIR_EraseRootFromParent_Done,
     /* 290112 */   // Label 5985: @290112
     /* 290112 */   GIM_Reject,
     /* 290113 */ // Label 5981: @290113
     /* 290113 */ GIM_Reject,
     /* 290114 */ // Label 5921: @290114
     /* 290114 */ GIM_Try, /*On fail goto*//*Label 5986*/ GIMT_Encode4(290139), // Rule ID 8153 //
     /* 290119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 290122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 290125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 290128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 290132 */   // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 290132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
     /* 290137 */   GIR_RootConstrainSelectedInstOperands,
     /* 290138 */   // GIR_Coverage, 8153,
     /* 290138 */   GIR_Done,
     /* 290139 */ // Label 5986: @290139
     /* 290139 */ GIM_Reject,
     /* 290140 */ // Label 5922: @290140
     /* 290140 */ GIM_Try, /*On fail goto*//*Label 5987*/ GIMT_Encode4(290165), // Rule ID 8151 //
     /* 290145 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 290148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 290151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 290154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 290158 */   // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 290158 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
     /* 290163 */   GIR_RootConstrainSelectedInstOperands,
     /* 290164 */   // GIR_Coverage, 8151,
     /* 290164 */   GIR_Done,
     /* 290165 */ // Label 5987: @290165
     /* 290165 */ GIM_Reject,
     /* 290166 */ // Label 5923: @290166
     /* 290166 */ GIM_Try, /*On fail goto*//*Label 5988*/ GIMT_Encode4(290191), // Rule ID 8149 //
     /* 290171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 290174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 290177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 290180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 290184 */   // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 290184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
     /* 290189 */   GIR_RootConstrainSelectedInstOperands,
     /* 290190 */   // GIR_Coverage, 8149,
     /* 290190 */   GIR_Done,
     /* 290191 */ // Label 5988: @290191
     /* 290191 */ GIM_Reject,
     /* 290192 */ // Label 5924: @290192
     /* 290192 */ GIM_Reject,
     /* 290193 */ // Label 60: @290193
     /* 290193 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 5997*/ GIMT_Encode4(306465),
     /* 290204 */ /*GILLT_s16*//*Label 5989*/ GIMT_Encode4(290244),
     /* 290208 */ /*GILLT_s32*//*Label 5990*/ GIMT_Encode4(293248),
     /* 290212 */ /*GILLT_s64*//*Label 5991*/ GIMT_Encode4(296396), GIMT_Encode4(0),
     /* 290220 */ /*GILLT_v2s32*//*Label 5992*/ GIMT_Encode4(299544),
     /* 290224 */ /*GILLT_v2s64*//*Label 5993*/ GIMT_Encode4(301065),
     /* 290228 */ /*GILLT_v4s16*//*Label 5994*/ GIMT_Encode4(302586),
     /* 290232 */ /*GILLT_v4s32*//*Label 5995*/ GIMT_Encode4(303765), GIMT_Encode4(0),
     /* 290240 */ /*GILLT_v8s16*//*Label 5996*/ GIMT_Encode4(305286),
     /* 290244 */ // Label 5989: @290244
     /* 290244 */ GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(293247),
     /* 290249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 290252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 290255 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 290258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290262 */   GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(290412), // Rule ID 4851 //
     /* 290267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 290270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290291 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 290295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290316 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 290320 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 290324 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290328 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 290332 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290337 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290339 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 290339 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 290342 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290346 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290351 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 290357 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290362 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290379 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290390 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 290398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290403 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 290406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 290410 */     GIR_RootConstrainSelectedInstOperands,
     /* 290411 */     // GIR_Coverage, 4851,
     /* 290411 */     GIR_EraseRootFromParent_Done,
     /* 290412 */   // Label 5999: @290412
     /* 290412 */   GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(290559), // Rule ID 4815 //
     /* 290417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 290420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290432 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290436 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290441 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 290445 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290449 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290453 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 290457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 290461 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290465 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290469 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 290473 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290478 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 290482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290486 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290488 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 290488 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 290491 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290495 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290500 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 290506 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290511 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290528 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290534 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290539 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 290547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 290555 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 290557 */     GIR_RootConstrainSelectedInstOperands,
     /* 290558 */     // GIR_Coverage, 4815,
     /* 290558 */     GIR_EraseRootFromParent_Done,
     /* 290559 */   // Label 6000: @290559
     /* 290559 */   GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(290706), // Rule ID 13790 //
     /* 290564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 290567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 290579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290591 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 290595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290600 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 290604 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 290608 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290612 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290616 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 290620 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290625 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 290629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290633 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 290635 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 290635 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 290638 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290642 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290647 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 290653 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290658 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290675 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 290694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 290702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 290704 */     GIR_RootConstrainSelectedInstOperands,
     /* 290705 */     // GIR_Coverage, 13790,
     /* 290705 */     GIR_EraseRootFromParent_Done,
     /* 290706 */   // Label 6001: @290706
     /* 290706 */   GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(290837), // Rule ID 6048 //
     /* 290711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290735 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 290739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 290743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 290751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 290755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290759 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290763 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 290767 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 290772 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 290776 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290780 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 290784 */     // MIs[4] Operand 1
     /* 290784 */     // No operand predicates
     /* 290784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290788 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 290790 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 290790 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290793 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290797 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290802 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290808 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290813 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 290821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 290832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 290835 */     GIR_RootConstrainSelectedInstOperands,
     /* 290836 */     // GIR_Coverage, 6048,
     /* 290836 */     GIR_EraseRootFromParent_Done,
     /* 290837 */   // Label 6002: @290837
     /* 290837 */   GIM_Try, /*On fail goto*//*Label 6003*/ GIMT_Encode4(290968), // Rule ID 6080 //
     /* 290842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 290861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 290866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 290870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 290874 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 290878 */     // MIs[2] Operand 1
     /* 290878 */     // No operand predicates
     /* 290878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 290882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290886 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 290890 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 290894 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290898 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 290902 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 290906 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290911 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 290915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290919 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 290921 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 290921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 290924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 290928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 290933 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 290939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 290944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 290952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 290954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 290956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 290959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 290963 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 290966 */     GIR_RootConstrainSelectedInstOperands,
     /* 290967 */     // GIR_Coverage, 6080,
     /* 290967 */     GIR_EraseRootFromParent_Done,
     /* 290968 */   // Label 6003: @290968
     /* 290968 */   GIM_Try, /*On fail goto*//*Label 6004*/ GIMT_Encode4(291099), // Rule ID 6144 //
     /* 290973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 290976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 290980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 290984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 290988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 290992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 290996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291000 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291009 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 291013 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 291017 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291021 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291025 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 291029 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291034 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 291038 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291042 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291046 */     // MIs[4] Operand 1
     /* 291046 */     // No operand predicates
     /* 291046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291050 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 291052 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291064 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291075 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 291083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 291094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 291097 */     GIR_RootConstrainSelectedInstOperands,
     /* 291098 */     // GIR_Coverage, 6144,
     /* 291098 */     GIR_EraseRootFromParent_Done,
     /* 291099 */   // Label 6004: @291099
     /* 291099 */   GIM_Try, /*On fail goto*//*Label 6005*/ GIMT_Encode4(291230), // Rule ID 6112 //
     /* 291104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291127 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291131 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291135 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291148 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291152 */     // MIs[3] Operand 1
     /* 291152 */     // No operand predicates
     /* 291152 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 291156 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291160 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291164 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 291168 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291173 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 291177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291181 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 291183 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291195 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291201 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 291214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291218 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291228 */     GIR_RootConstrainSelectedInstOperands,
     /* 291229 */     // GIR_Coverage, 6112,
     /* 291229 */     GIR_EraseRootFromParent_Done,
     /* 291230 */   // Label 6005: @291230
     /* 291230 */   GIM_Try, /*On fail goto*//*Label 6006*/ GIMT_Encode4(291365), // Rule ID 2454 //
     /* 291235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291250 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291254 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291259 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291275 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291284 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 291288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291294 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 291294 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 291297 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291301 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291306 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 291312 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291317 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291334 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 291353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 291361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291363 */     GIR_RootConstrainSelectedInstOperands,
     /* 291364 */     // GIR_Coverage, 2454,
     /* 291364 */     GIR_EraseRootFromParent_Done,
     /* 291365 */   // Label 6006: @291365
     /* 291365 */   GIM_Try, /*On fail goto*//*Label 6007*/ GIMT_Encode4(291484), // Rule ID 6016 //
     /* 291370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291394 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291410 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 291423 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291427 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291431 */     // MIs[3] Operand 1
     /* 291431 */     // No operand predicates
     /* 291431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291435 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291437 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291449 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291460 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 291468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 291482 */     GIR_RootConstrainSelectedInstOperands,
     /* 291483 */     // GIR_Coverage, 6016,
     /* 291483 */     GIR_EraseRootFromParent_Done,
     /* 291484 */   // Label 6007: @291484
     /* 291484 */   GIM_Try, /*On fail goto*//*Label 6008*/ GIMT_Encode4(291603), // Rule ID 2536 //
     /* 291489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 291492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291504 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 291513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 291517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 291521 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 291525 */     // MIs[2] Operand 1
     /* 291525 */     // No operand predicates
     /* 291525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 291529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291533 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291537 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 291541 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291546 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 291550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 291556 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 291556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291568 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291574 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 291587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 291589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 291591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 291601 */     GIR_RootConstrainSelectedInstOperands,
     /* 291602 */     // GIR_Coverage, 2536,
     /* 291602 */     GIR_EraseRootFromParent_Done,
     /* 291603 */   // Label 6008: @291603
     /* 291603 */   GIM_Try, /*On fail goto*//*Label 6009*/ GIMT_Encode4(291703), // Rule ID 4813 //
     /* 291608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291632 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 291648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291657 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291659 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 291659 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291662 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291666 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291671 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291677 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291682 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 291690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291692 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 291699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291701 */     GIR_RootConstrainSelectedInstOperands,
     /* 291702 */     // GIR_Coverage, 4813,
     /* 291702 */     GIR_EraseRootFromParent_Done,
     /* 291703 */   // Label 6009: @291703
     /* 291703 */   GIM_Try, /*On fail goto*//*Label 6010*/ GIMT_Encode4(291803), // Rule ID 4849 //
     /* 291708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 291727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291732 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 291736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 291744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 291752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291759 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 291759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291771 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 291790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 291797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 291801 */     GIR_RootConstrainSelectedInstOperands,
     /* 291802 */     // GIR_Coverage, 4849,
     /* 291802 */     GIR_EraseRootFromParent_Done,
     /* 291803 */   // Label 6010: @291803
     /* 291803 */   GIM_Try, /*On fail goto*//*Label 6011*/ GIMT_Encode4(291900), // Rule ID 13786 //
     /* 291808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 291827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291835 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291839 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291844 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 291848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291858 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 291858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291870 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 291876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 291889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291898 */     GIR_RootConstrainSelectedInstOperands,
     /* 291899 */     // GIR_Coverage, 13786,
     /* 291899 */     GIR_EraseRootFromParent_Done,
     /* 291900 */   // Label 6011: @291900
     /* 291900 */   GIM_Try, /*On fail goto*//*Label 6012*/ GIMT_Encode4(292000), // Rule ID 13788 //
     /* 291905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 291908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 291912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 291916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 291920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 291929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 291933 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 291937 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 291941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291946 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 291950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291954 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 291956 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 291956 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 291959 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 291963 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 291968 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 291974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 291979 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 291984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 291987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 291992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 291996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 291998 */     GIR_RootConstrainSelectedInstOperands,
     /* 291999 */     // GIR_Coverage, 13788,
     /* 291999 */     GIR_EraseRootFromParent_Done,
     /* 292000 */   // Label 6012: @292000
     /* 292000 */   GIM_Try, /*On fail goto*//*Label 6013*/ GIMT_Encode4(292100), // Rule ID 4847 //
     /* 292005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292008 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292024 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292028 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292033 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 292041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292056 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 292056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292068 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 292074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 292087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 292098 */     GIR_RootConstrainSelectedInstOperands,
     /* 292099 */     // GIR_Coverage, 4847,
     /* 292099 */     GIR_EraseRootFromParent_Done,
     /* 292100 */   // Label 6013: @292100
     /* 292100 */   GIM_Try, /*On fail goto*//*Label 6014*/ GIMT_Encode4(292197), // Rule ID 4811 //
     /* 292105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292145 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 292149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292153 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292155 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 292155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292167 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 292173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 292186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292195 */     GIR_RootConstrainSelectedInstOperands,
     /* 292196 */     // GIR_Coverage, 4811,
     /* 292196 */     GIR_EraseRootFromParent_Done,
     /* 292197 */   // Label 6014: @292197
     /* 292197 */   GIM_Try, /*On fail goto*//*Label 6015*/ GIMT_Encode4(292281), // Rule ID 6078 //
     /* 292202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292213 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292217 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 292230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292234 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292238 */     // MIs[2] Operand 1
     /* 292238 */     // No operand predicates
     /* 292238 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 292242 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292246 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 292250 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292259 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292261 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 292264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 292272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292276 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 292279 */     GIR_RootConstrainSelectedInstOperands,
     /* 292280 */     // GIR_Coverage, 6078,
     /* 292280 */     GIR_EraseRootFromParent_Done,
     /* 292281 */   // Label 6015: @292281
     /* 292281 */   GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(292362), // Rule ID 6110 //
     /* 292286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292301 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292305 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292309 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292317 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292322 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 292326 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292330 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292334 */     // MIs[3] Operand 1
     /* 292334 */     // No operand predicates
     /* 292334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292342 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292344 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 292347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292360 */     GIR_RootConstrainSelectedInstOperands,
     /* 292361 */     // GIR_Coverage, 6110,
     /* 292361 */     GIR_EraseRootFromParent_Done,
     /* 292362 */   // Label 6016: @292362
     /* 292362 */   GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(292446), // Rule ID 6142 //
     /* 292367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292378 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 292391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292399 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292403 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292408 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 292412 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292416 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292420 */     // MIs[3] Operand 1
     /* 292420 */     // No operand predicates
     /* 292420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292424 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292426 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 292429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292441 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292444 */     GIR_RootConstrainSelectedInstOperands,
     /* 292445 */     // GIR_Coverage, 6142,
     /* 292445 */     GIR_EraseRootFromParent_Done,
     /* 292446 */   // Label 6017: @292446
     /* 292446 */   GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(292527), // Rule ID 6046 //
     /* 292451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 292474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292482 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 292486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292491 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 292495 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292499 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292503 */     // MIs[3] Operand 1
     /* 292503 */     // No operand predicates
     /* 292503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292507 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 292509 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 292512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 292522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 292525 */     GIR_RootConstrainSelectedInstOperands,
     /* 292526 */     // GIR_Coverage, 6046,
     /* 292526 */     GIR_EraseRootFromParent_Done,
     /* 292527 */   // Label 6018: @292527
     /* 292527 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(292612), // Rule ID 2452 //
     /* 292532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292556 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292570 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292582 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 292588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292593 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 292601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 292608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292610 */     GIR_RootConstrainSelectedInstOperands,
     /* 292611 */     // GIR_Coverage, 2452,
     /* 292611 */     GIR_EraseRootFromParent_Done,
     /* 292612 */   // Label 6019: @292612
     /* 292612 */   GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(292697), // Rule ID 2450 //
     /* 292617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 292620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292636 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292645 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 292649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292655 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 292655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 292658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 292662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 292667 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 292673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 292686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292688 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 292693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 292695 */     GIR_RootConstrainSelectedInstOperands,
     /* 292696 */     // GIR_Coverage, 2450,
     /* 292696 */     GIR_EraseRootFromParent_Done,
     /* 292697 */   // Label 6020: @292697
     /* 292697 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(292766), // Rule ID 2534 //
     /* 292702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 292730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292734 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292738 */     // MIs[2] Operand 1
     /* 292738 */     // No operand predicates
     /* 292738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292748 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 292751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 292764 */     GIR_RootConstrainSelectedInstOperands,
     /* 292765 */     // GIR_Coverage, 2534,
     /* 292765 */     GIR_EraseRootFromParent_Done,
     /* 292766 */   // Label 6021: @292766
     /* 292766 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(292835), // Rule ID 6014 //
     /* 292771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 292786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 292790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 292794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 292799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 292803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 292807 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 292811 */     // MIs[2] Operand 1
     /* 292811 */     // No operand predicates
     /* 292811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292817 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 292817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 292820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 292822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 292824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 292826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 292830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 292833 */     GIR_RootConstrainSelectedInstOperands,
     /* 292834 */     // GIR_Coverage, 6014,
     /* 292834 */     GIR_EraseRootFromParent_Done,
     /* 292835 */   // Label 6022: @292835
     /* 292835 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(292900), // Rule ID 4867 //
     /* 292840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 292868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292881 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292883 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 292886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 292894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 292898 */     GIR_RootConstrainSelectedInstOperands,
     /* 292899 */     // GIR_Coverage, 4867,
     /* 292899 */     GIR_EraseRootFromParent_Done,
     /* 292900 */   // Label 6023: @292900
     /* 292900 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(292965), // Rule ID 13806 //
     /* 292905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 292933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 292941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 292948 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 292948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 292951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 292957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 292959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 292963 */     GIR_RootConstrainSelectedInstOperands,
     /* 292964 */     // GIR_Coverage, 13806,
     /* 292964 */     GIR_EraseRootFromParent_Done,
     /* 292965 */   // Label 6024: @292965
     /* 292965 */   GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(293015), // Rule ID 4864 //
     /* 292970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 292973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 292977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 292981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 292985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 292998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293000 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 293000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 293003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 293009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 293011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293013 */     GIR_RootConstrainSelectedInstOperands,
     /* 293014 */     // GIR_Coverage, 4864,
     /* 293014 */     GIR_EraseRootFromParent_Done,
     /* 293015 */   // Label 6025: @293015
     /* 293015 */   GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(293065), // Rule ID 13232 //
     /* 293020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 293023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 293035 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293050 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 293050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 293053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293063 */     GIR_RootConstrainSelectedInstOperands,
     /* 293064 */     // GIR_Coverage, 13232,
     /* 293064 */     GIR_EraseRootFromParent_Done,
     /* 293065 */   // Label 6026: @293065
     /* 293065 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(293115), // Rule ID 644 //
     /* 293070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 293073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 293089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293094 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293098 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293100 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 293100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 293103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293113 */     GIR_RootConstrainSelectedInstOperands,
     /* 293114 */     // GIR_Coverage, 644,
     /* 293114 */     GIR_EraseRootFromParent_Done,
     /* 293115 */   // Label 6027: @293115
     /* 293115 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(293165), // Rule ID 13803 //
     /* 293120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 293123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 293139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293148 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293150 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 293150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 293153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 293159 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 293161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293163 */     GIR_RootConstrainSelectedInstOperands,
     /* 293164 */     // GIR_Coverage, 13803,
     /* 293164 */     GIR_EraseRootFromParent_Done,
     /* 293165 */   // Label 6028: @293165
     /* 293165 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(293215), // Rule ID 656 //
     /* 293170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 293173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293185 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293189 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 293193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293200 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 293200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 293203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 293207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 293209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 293213 */     GIR_RootConstrainSelectedInstOperands,
     /* 293214 */     // GIR_Coverage, 656,
     /* 293214 */     GIR_EraseRootFromParent_Done,
     /* 293215 */   // Label 6029: @293215
     /* 293215 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(293246), // Rule ID 638 //
     /* 293220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 293223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 293235 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 293235 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 293240 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 293244 */     GIR_RootConstrainSelectedInstOperands,
     /* 293245 */     // GIR_Coverage, 638,
     /* 293245 */     GIR_Done,
     /* 293246 */   // Label 6030: @293246
     /* 293246 */   GIM_Reject,
     /* 293247 */ // Label 5998: @293247
     /* 293247 */ GIM_Reject,
     /* 293248 */ // Label 5990: @293248
     /* 293248 */ GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(296395),
     /* 293253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 293256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 293259 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 293262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293266 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(293416), // Rule ID 4857 //
     /* 293271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 293274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293295 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293315 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293320 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 293324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 293328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293332 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 293336 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293341 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293343 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 293343 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 293346 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293350 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293355 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 293361 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293366 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293383 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293389 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 293402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293404 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 293410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 293414 */     GIR_RootConstrainSelectedInstOperands,
     /* 293415 */     // GIR_Coverage, 4857,
     /* 293415 */     GIR_EraseRootFromParent_Done,
     /* 293416 */   // Label 6032: @293416
     /* 293416 */   GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(293563), // Rule ID 4821 //
     /* 293421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 293424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293445 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293449 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293453 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293457 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 293461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 293465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293469 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293473 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 293477 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293482 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 293486 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293492 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 293492 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 293495 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293499 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293504 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 293510 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293515 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293532 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 293551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 293559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293561 */     GIR_RootConstrainSelectedInstOperands,
     /* 293562 */     // GIR_Coverage, 4821,
     /* 293562 */     GIR_EraseRootFromParent_Done,
     /* 293563 */   // Label 6033: @293563
     /* 293563 */   GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(293710), // Rule ID 13796 //
     /* 293568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 293571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293595 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 293599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293604 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 293608 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 293612 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293616 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293620 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 293624 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293629 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 293633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293637 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 293639 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 293639 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 293642 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293646 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293651 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 293657 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293662 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293679 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293685 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 293698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 293706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 293708 */     GIR_RootConstrainSelectedInstOperands,
     /* 293709 */     // GIR_Coverage, 13796,
     /* 293709 */     GIR_EraseRootFromParent_Done,
     /* 293710 */   // Label 6034: @293710
     /* 293710 */   GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(293841), // Rule ID 6064 //
     /* 293715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293739 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 293743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 293747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 293755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 293759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293763 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293767 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 293771 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293776 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 293780 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293784 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293788 */     // MIs[4] Operand 1
     /* 293788 */     // No operand predicates
     /* 293788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293792 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293794 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293794 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293797 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293801 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293806 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293812 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293817 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 293825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293827 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 293836 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 293839 */     GIR_RootConstrainSelectedInstOperands,
     /* 293840 */     // GIR_Coverage, 6064,
     /* 293840 */     GIR_EraseRootFromParent_Done,
     /* 293841 */   // Label 6035: @293841
     /* 293841 */   GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(293972), // Rule ID 6096 //
     /* 293846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 293865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 293874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 293878 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 293882 */     // MIs[2] Operand 1
     /* 293882 */     // No operand predicates
     /* 293882 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 293886 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293890 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 293894 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 293898 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 293902 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 293906 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 293910 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293915 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 293919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293923 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 293925 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 293925 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 293928 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 293932 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 293937 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 293943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 293948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 293956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 293958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 293960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 293963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 293967 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 293970 */     GIR_RootConstrainSelectedInstOperands,
     /* 293971 */     // GIR_Coverage, 6096,
     /* 293971 */     GIR_EraseRootFromParent_Done,
     /* 293972 */   // Label 6036: @293972
     /* 293972 */   GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(294103), // Rule ID 6160 //
     /* 293977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 293984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 293988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 293992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 293996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294004 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294008 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294013 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 294021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294025 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294029 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 294033 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294038 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 294042 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294046 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294050 */     // MIs[4] Operand 1
     /* 294050 */     // No operand predicates
     /* 294050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294054 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 294056 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294068 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 294087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 294098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 294101 */     GIR_RootConstrainSelectedInstOperands,
     /* 294102 */     // GIR_Coverage, 6160,
     /* 294102 */     GIR_EraseRootFromParent_Done,
     /* 294103 */   // Label 6037: @294103
     /* 294103 */   GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(294234), // Rule ID 6128 //
     /* 294108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294144 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294148 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294152 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294156 */     // MIs[3] Operand 1
     /* 294156 */     // No operand predicates
     /* 294156 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 294160 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294164 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294168 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 294172 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294177 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 294181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294185 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 294187 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294187 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294190 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294194 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294199 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 294218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294222 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294232 */     GIR_RootConstrainSelectedInstOperands,
     /* 294233 */     // GIR_Coverage, 6128,
     /* 294233 */     GIR_EraseRootFromParent_Done,
     /* 294234 */   // Label 6038: @294234
     /* 294234 */   GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(294369), // Rule ID 2460 //
     /* 294239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294263 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294279 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294283 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294288 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294298 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 294298 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 294301 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294305 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294310 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 294316 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294321 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294326 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294329 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294333 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294338 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 294357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294362 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 294365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294367 */     GIR_RootConstrainSelectedInstOperands,
     /* 294368 */     // GIR_Coverage, 2460,
     /* 294368 */     GIR_EraseRootFromParent_Done,
     /* 294369 */   // Label 6039: @294369
     /* 294369 */   GIM_Try, /*On fail goto*//*Label 6040*/ GIMT_Encode4(294488), // Rule ID 6032 //
     /* 294374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294393 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294398 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294414 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294418 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294423 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 294427 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294431 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294435 */     // MIs[3] Operand 1
     /* 294435 */     // No operand predicates
     /* 294435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294439 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294441 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294441 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294444 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294448 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294453 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 294472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294476 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 294486 */     GIR_RootConstrainSelectedInstOperands,
     /* 294487 */     // GIR_Coverage, 6032,
     /* 294487 */     GIR_EraseRootFromParent_Done,
     /* 294488 */   // Label 6040: @294488
     /* 294488 */   GIM_Try, /*On fail goto*//*Label 6041*/ GIMT_Encode4(294607), // Rule ID 2552 //
     /* 294493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 294521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 294525 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 294529 */     // MIs[2] Operand 1
     /* 294529 */     // No operand predicates
     /* 294529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 294533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294537 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294541 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 294545 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294550 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 294554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 294560 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 294560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294572 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 294591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 294593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 294595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 294602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 294605 */     GIR_RootConstrainSelectedInstOperands,
     /* 294606 */     // GIR_Coverage, 2552,
     /* 294606 */     GIR_EraseRootFromParent_Done,
     /* 294607 */   // Label 6041: @294607
     /* 294607 */   GIM_Try, /*On fail goto*//*Label 6042*/ GIMT_Encode4(294707), // Rule ID 4819 //
     /* 294612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294636 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294640 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294644 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294648 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 294652 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294661 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294663 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 294663 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294666 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294670 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294675 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 294694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 294703 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294705 */     GIR_RootConstrainSelectedInstOperands,
     /* 294706 */     // GIR_Coverage, 4819,
     /* 294706 */     GIR_EraseRootFromParent_Done,
     /* 294707 */   // Label 6042: @294707
     /* 294707 */   GIM_Try, /*On fail goto*//*Label 6043*/ GIMT_Encode4(294807), // Rule ID 4855 //
     /* 294712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 294731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294736 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 294740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 294748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 294756 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294763 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 294763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294775 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294786 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 294794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 294801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 294805 */     GIR_RootConstrainSelectedInstOperands,
     /* 294806 */     // GIR_Coverage, 4855,
     /* 294806 */     GIR_EraseRootFromParent_Done,
     /* 294807 */   // Label 6043: @294807
     /* 294807 */   GIM_Try, /*On fail goto*//*Label 6044*/ GIMT_Encode4(294904), // Rule ID 13792 //
     /* 294812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 294831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294848 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294860 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294862 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 294862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294874 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 294880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294885 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 294893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 294902 */     GIR_RootConstrainSelectedInstOperands,
     /* 294903 */     // GIR_Coverage, 13792,
     /* 294903 */     GIR_EraseRootFromParent_Done,
     /* 294904 */   // Label 6044: @294904
     /* 294904 */   GIM_Try, /*On fail goto*//*Label 6045*/ GIMT_Encode4(295004), // Rule ID 13794 //
     /* 294909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 294912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 294916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 294920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 294924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 294933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 294937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 294941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 294945 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294950 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 294954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 294960 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 294960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 294963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 294967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 294972 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 294978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 294983 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 294991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 294996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295002 */     GIR_RootConstrainSelectedInstOperands,
     /* 295003 */     // GIR_Coverage, 13794,
     /* 295003 */     GIR_EraseRootFromParent_Done,
     /* 295004 */   // Label 6045: @295004
     /* 295004 */   GIM_Try, /*On fail goto*//*Label 6046*/ GIMT_Encode4(295104), // Rule ID 4853 //
     /* 295009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295037 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 295045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 295053 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295058 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295060 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 295060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295072 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 295078 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295083 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 295091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 295102 */     GIR_RootConstrainSelectedInstOperands,
     /* 295103 */     // GIR_Coverage, 4853,
     /* 295103 */     GIR_EraseRootFromParent_Done,
     /* 295104 */   // Label 6046: @295104
     /* 295104 */   GIM_Try, /*On fail goto*//*Label 6047*/ GIMT_Encode4(295201), // Rule ID 4817 //
     /* 295109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295140 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295144 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295149 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 295153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295157 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295159 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 295159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295171 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 295177 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295182 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 295190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295192 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295194 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295197 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295199 */     GIR_RootConstrainSelectedInstOperands,
     /* 295200 */     // GIR_Coverage, 4817,
     /* 295200 */     GIR_EraseRootFromParent_Done,
     /* 295201 */   // Label 6047: @295201
     /* 295201 */   GIM_Try, /*On fail goto*//*Label 6048*/ GIMT_Encode4(295279), // Rule ID 6182 //
     /* 295206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295218 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295234 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 295243 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295247 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295251 */     // MIs[3] Operand 1
     /* 295251 */     // No operand predicates
     /* 295251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295259 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295261 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 295264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295274 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295277 */     GIR_RootConstrainSelectedInstOperands,
     /* 295278 */     // GIR_Coverage, 6182,
     /* 295278 */     GIR_EraseRootFromParent_Done,
     /* 295279 */   // Label 6048: @295279
     /* 295279 */   GIM_Try, /*On fail goto*//*Label 6049*/ GIMT_Encode4(295363), // Rule ID 6094 //
     /* 295284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295299 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 295312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295316 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295320 */     // MIs[2] Operand 1
     /* 295320 */     // No operand predicates
     /* 295320 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 295324 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295328 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 295332 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295341 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295343 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 295346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 295354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295358 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 295361 */     GIR_RootConstrainSelectedInstOperands,
     /* 295362 */     // GIR_Coverage, 6094,
     /* 295362 */     GIR_EraseRootFromParent_Done,
     /* 295363 */   // Label 6049: @295363
     /* 295363 */   GIM_Try, /*On fail goto*//*Label 6050*/ GIMT_Encode4(295444), // Rule ID 6126 //
     /* 295368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295391 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295395 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295399 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295404 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 295408 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295412 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295416 */     // MIs[3] Operand 1
     /* 295416 */     // No operand predicates
     /* 295416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295424 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295426 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 295429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295442 */     GIR_RootConstrainSelectedInstOperands,
     /* 295443 */     // GIR_Coverage, 6126,
     /* 295443 */     GIR_EraseRootFromParent_Done,
     /* 295444 */   // Label 6050: @295444
     /* 295444 */   GIM_Try, /*On fail goto*//*Label 6051*/ GIMT_Encode4(295528), // Rule ID 6158 //
     /* 295449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295460 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 295473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295481 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 295494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295498 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295502 */     // MIs[3] Operand 1
     /* 295502 */     // No operand predicates
     /* 295502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295506 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295508 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 295511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 295519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295526 */     GIR_RootConstrainSelectedInstOperands,
     /* 295527 */     // GIR_Coverage, 6158,
     /* 295527 */     GIR_EraseRootFromParent_Done,
     /* 295528 */   // Label 6051: @295528
     /* 295528 */   GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(295606), // Rule ID 6204 //
     /* 295533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295565 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295570 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 295574 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295578 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295582 */     // MIs[3] Operand 1
     /* 295582 */     // No operand predicates
     /* 295582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295588 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 295591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295604 */     GIR_RootConstrainSelectedInstOperands,
     /* 295605 */     // GIR_Coverage, 6204,
     /* 295605 */     GIR_EraseRootFromParent_Done,
     /* 295606 */   // Label 6052: @295606
     /* 295606 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(295687), // Rule ID 6062 //
     /* 295611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 295626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 295630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 295634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295642 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 295646 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295651 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 295655 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295659 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295663 */     // MIs[3] Operand 1
     /* 295663 */     // No operand predicates
     /* 295663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 295669 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 295672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 295682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 295685 */     GIR_RootConstrainSelectedInstOperands,
     /* 295686 */     // GIR_Coverage, 6062,
     /* 295686 */     GIR_EraseRootFromParent_Done,
     /* 295687 */   // Label 6053: @295687
     /* 295687 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(295772), // Rule ID 2458 //
     /* 295692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295716 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295724 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295730 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 295730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295742 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 295748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 295761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 295768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295770 */     GIR_RootConstrainSelectedInstOperands,
     /* 295771 */     // GIR_Coverage, 2458,
     /* 295771 */     GIR_EraseRootFromParent_Done,
     /* 295772 */   // Label 6054: @295772
     /* 295772 */   GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(295857), // Rule ID 2456 //
     /* 295777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 295780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295805 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 295809 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295815 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 295815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 295818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 295822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 295827 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 295833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 295846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295848 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295850 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 295853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 295855 */     GIR_RootConstrainSelectedInstOperands,
     /* 295856 */     // GIR_Coverage, 2456,
     /* 295856 */     GIR_EraseRootFromParent_Done,
     /* 295857 */   // Label 6055: @295857
     /* 295857 */   GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(295926), // Rule ID 2550 //
     /* 295862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 295869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 295890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295894 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295898 */     // MIs[2] Operand 1
     /* 295898 */     // No operand predicates
     /* 295898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295908 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 295911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295921 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 295924 */     GIR_RootConstrainSelectedInstOperands,
     /* 295925 */     // GIR_Coverage, 2550,
     /* 295925 */     GIR_EraseRootFromParent_Done,
     /* 295926 */   // Label 6056: @295926
     /* 295926 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(295995), // Rule ID 6030 //
     /* 295931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 295946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 295950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 295954 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295959 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 295963 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 295967 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 295971 */     // MIs[2] Operand 1
     /* 295971 */     // No operand predicates
     /* 295971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 295975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 295977 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 295977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 295980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 295982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 295984 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 295986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 295990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 295993 */     GIR_RootConstrainSelectedInstOperands,
     /* 295994 */     // GIR_Coverage, 6030,
     /* 295994 */     GIR_EraseRootFromParent_Done,
     /* 295995 */   // Label 6057: @295995
     /* 295995 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(296057), // Rule ID 4868 //
     /* 296000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 296025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 296033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296038 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296040 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 296040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 296043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 296051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 296055 */     GIR_RootConstrainSelectedInstOperands,
     /* 296056 */     // GIR_Coverage, 4868,
     /* 296056 */     GIR_EraseRootFromParent_Done,
     /* 296057 */   // Label 6058: @296057
     /* 296057 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(296119), // Rule ID 13807 //
     /* 296062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296078 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 296087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 296095 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296102 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 296102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 296105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 296113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 296117 */     GIR_RootConstrainSelectedInstOperands,
     /* 296118 */     // GIR_Coverage, 13807,
     /* 296118 */     GIR_EraseRootFromParent_Done,
     /* 296119 */   // Label 6059: @296119
     /* 296119 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(296166), // Rule ID 4865 //
     /* 296124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296151 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 296151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 296154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 296162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296164 */     GIR_RootConstrainSelectedInstOperands,
     /* 296165 */     // GIR_Coverage, 4865,
     /* 296165 */     GIR_EraseRootFromParent_Done,
     /* 296166 */   // Label 6060: @296166
     /* 296166 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(296216), // Rule ID 13234 //
     /* 296171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296201 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 296201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 296204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296214 */     GIR_RootConstrainSelectedInstOperands,
     /* 296215 */     // GIR_Coverage, 13234,
     /* 296215 */     GIR_EraseRootFromParent_Done,
     /* 296216 */   // Label 6061: @296216
     /* 296216 */   GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(296266), // Rule ID 646 //
     /* 296221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296224 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296251 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 296251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 296254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 296258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 296262 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296264 */     GIR_RootConstrainSelectedInstOperands,
     /* 296265 */     // GIR_Coverage, 646,
     /* 296265 */     GIR_EraseRootFromParent_Done,
     /* 296266 */   // Label 6062: @296266
     /* 296266 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(296313), // Rule ID 13804 //
     /* 296271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296292 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296298 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 296298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 296301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 296307 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 296309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296311 */     GIR_RootConstrainSelectedInstOperands,
     /* 296312 */     // GIR_Coverage, 13804,
     /* 296312 */     GIR_EraseRootFromParent_Done,
     /* 296313 */   // Label 6063: @296313
     /* 296313 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(296363), // Rule ID 658 //
     /* 296318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 296333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296348 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 296348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 296351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296353 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 296355 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 296357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 296361 */     GIR_RootConstrainSelectedInstOperands,
     /* 296362 */     // GIR_Coverage, 658,
     /* 296362 */     GIR_EraseRootFromParent_Done,
     /* 296363 */   // Label 6064: @296363
     /* 296363 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(296394), // Rule ID 640 //
     /* 296368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 296383 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 296383 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 296388 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 296392 */     GIR_RootConstrainSelectedInstOperands,
     /* 296393 */     // GIR_Coverage, 640,
     /* 296393 */     GIR_Done,
     /* 296394 */   // Label 6065: @296394
     /* 296394 */   GIM_Reject,
     /* 296395 */ // Label 6031: @296395
     /* 296395 */ GIM_Reject,
     /* 296396 */ // Label 5991: @296396
     /* 296396 */ GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(299543),
     /* 296401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 296404 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 296407 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 296410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296414 */   GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(296564), // Rule ID 4863 //
     /* 296419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296434 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296443 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296463 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296468 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296472 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 296476 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296480 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 296484 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296489 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296491 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 296491 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296494 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296498 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296503 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296509 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296514 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296531 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296537 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296542 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 296550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296555 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 296562 */     GIR_RootConstrainSelectedInstOperands,
     /* 296563 */     // GIR_Coverage, 4863,
     /* 296563 */     GIR_EraseRootFromParent_Done,
     /* 296564 */   // Label 6067: @296564
     /* 296564 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(296711), // Rule ID 4827 //
     /* 296569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296584 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296593 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 296609 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 296613 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296617 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296621 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296625 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296630 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 296634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296638 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296640 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 296640 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296643 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296647 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296652 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296658 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296663 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296680 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296686 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296691 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 296699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296707 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296709 */     GIR_RootConstrainSelectedInstOperands,
     /* 296710 */     // GIR_Coverage, 4827,
     /* 296710 */     GIR_EraseRootFromParent_Done,
     /* 296711 */   // Label 6068: @296711
     /* 296711 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(296858), // Rule ID 13802 //
     /* 296716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 296719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 296731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296743 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 296747 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296752 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 296756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 296760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296768 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296772 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296777 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 296781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 296787 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 296787 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 296790 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296794 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296799 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 296805 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296810 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296827 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296833 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 296846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 296854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 296856 */     GIR_RootConstrainSelectedInstOperands,
     /* 296857 */     // GIR_Coverage, 13802,
     /* 296857 */     GIR_EraseRootFromParent_Done,
     /* 296858 */   // Label 6069: @296858
     /* 296858 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(296989), // Rule ID 6068 //
     /* 296863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 296870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 296882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296887 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 296891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 296895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 296899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 296903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 296907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 296911 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 296915 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 296919 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296924 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 296928 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 296932 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 296936 */     // MIs[4] Operand 1
     /* 296936 */     // No operand predicates
     /* 296936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296940 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 296942 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 296942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 296945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 296949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 296954 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 296960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 296965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 296973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 296975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 296977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 296980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 296984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 296987 */     GIR_RootConstrainSelectedInstOperands,
     /* 296988 */     // GIR_Coverage, 6068,
     /* 296988 */     GIR_EraseRootFromParent_Done,
     /* 296989 */   // Label 6070: @296989
     /* 296989 */   GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(297120), // Rule ID 6100 //
     /* 296994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 296997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 297022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297026 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297030 */     // MIs[2] Operand 1
     /* 297030 */     // No operand predicates
     /* 297030 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 297034 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297038 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 297042 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 297046 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297050 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297054 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 297058 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297063 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 297067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297071 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 297073 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 297073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297085 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297091 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 297104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297108 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 297118 */     GIR_RootConstrainSelectedInstOperands,
     /* 297119 */     // GIR_Coverage, 6100,
     /* 297119 */     GIR_EraseRootFromParent_Done,
     /* 297120 */   // Label 6071: @297120
     /* 297120 */   GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(297251), // Rule ID 6164 //
     /* 297125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297148 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297152 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297156 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297161 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297165 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 297169 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297173 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297177 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297181 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297186 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 297190 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297194 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297198 */     // MIs[4] Operand 1
     /* 297198 */     // No operand predicates
     /* 297198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297202 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 297204 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 297204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297216 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 297235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297239 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 297246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 297249 */     GIR_RootConstrainSelectedInstOperands,
     /* 297250 */     // GIR_Coverage, 6164,
     /* 297250 */     GIR_EraseRootFromParent_Done,
     /* 297251 */   // Label 6072: @297251
     /* 297251 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(297382), // Rule ID 6132 //
     /* 297256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297279 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297283 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297287 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297292 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 297296 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297300 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297304 */     // MIs[3] Operand 1
     /* 297304 */     // No operand predicates
     /* 297304 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 297308 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297312 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297316 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 297320 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297325 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 297329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297333 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 297335 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 297335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297347 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 297366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297380 */     GIR_RootConstrainSelectedInstOperands,
     /* 297381 */     // GIR_Coverage, 6132,
     /* 297381 */     GIR_EraseRootFromParent_Done,
     /* 297382 */   // Label 6073: @297382
     /* 297382 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(297517), // Rule ID 2466 //
     /* 297387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297398 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297402 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297411 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297431 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297436 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 297440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297446 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 297446 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 297449 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297453 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297458 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297464 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297469 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297486 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 297505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297510 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 297513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297515 */     GIR_RootConstrainSelectedInstOperands,
     /* 297516 */     // GIR_Coverage, 2466,
     /* 297516 */     GIR_EraseRootFromParent_Done,
     /* 297517 */   // Label 6074: @297517
     /* 297517 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(297636), // Rule ID 6036 //
     /* 297522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297546 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297550 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297554 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297558 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297562 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 297575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297579 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297583 */     // MIs[3] Operand 1
     /* 297583 */     // No operand predicates
     /* 297583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297587 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297589 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 297589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297601 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 297620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297624 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297631 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 297634 */     GIR_RootConstrainSelectedInstOperands,
     /* 297635 */     // GIR_Coverage, 6036,
     /* 297635 */     GIR_EraseRootFromParent_Done,
     /* 297636 */   // Label 6075: @297636
     /* 297636 */   GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(297755), // Rule ID 2556 //
     /* 297641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 297644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 297669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 297673 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 297677 */     // MIs[2] Operand 1
     /* 297677 */     // No operand predicates
     /* 297677 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 297681 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297685 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297689 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 297693 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297698 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 297702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297706 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 297708 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 297708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297720 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297726 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297731 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 297739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 297741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 297743 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 297750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 297753 */     GIR_RootConstrainSelectedInstOperands,
     /* 297754 */     // GIR_Coverage, 2556,
     /* 297754 */     GIR_EraseRootFromParent_Done,
     /* 297755 */   // Label 6076: @297755
     /* 297755 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(297855), // Rule ID 4825 //
     /* 297760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297763 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297767 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297771 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297775 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297784 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 297792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297796 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 297800 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297809 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297811 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 297811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297823 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297834 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 297842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 297851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 297853 */     GIR_RootConstrainSelectedInstOperands,
     /* 297854 */     // GIR_Coverage, 4825,
     /* 297854 */     GIR_EraseRootFromParent_Done,
     /* 297855 */   // Label 6077: @297855
     /* 297855 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(297955), // Rule ID 4861 //
     /* 297860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297863 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297867 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297871 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 297879 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297884 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 297888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 297896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 297904 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297911 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 297911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 297914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297923 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297929 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 297942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 297949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 297953 */     GIR_RootConstrainSelectedInstOperands,
     /* 297954 */     // GIR_Coverage, 4861,
     /* 297954 */     GIR_EraseRootFromParent_Done,
     /* 297955 */   // Label 6078: @297955
     /* 297955 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(298052), // Rule ID 13798 //
     /* 297960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 297963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 297967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 297971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 297975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 297983 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 297987 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 297991 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297996 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298010 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298022 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298028 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298033 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 298041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298045 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298050 */     GIR_RootConstrainSelectedInstOperands,
     /* 298051 */     // GIR_Coverage, 13798,
     /* 298051 */     GIR_EraseRootFromParent_Done,
     /* 298052 */   // Label 6079: @298052
     /* 298052 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(298152), // Rule ID 13800 //
     /* 298057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 298081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298098 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298108 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298120 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298126 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 298139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298150 */     GIR_RootConstrainSelectedInstOperands,
     /* 298151 */     // GIR_Coverage, 13800,
     /* 298151 */     GIR_EraseRootFromParent_Done,
     /* 298152 */   // Label 6080: @298152
     /* 298152 */   GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(298252), // Rule ID 4859 //
     /* 298157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298185 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 298189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 298193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 298201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298208 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298220 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 298239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298241 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 298250 */     GIR_RootConstrainSelectedInstOperands,
     /* 298251 */     // GIR_Coverage, 4859,
     /* 298251 */     GIR_EraseRootFromParent_Done,
     /* 298252 */   // Label 6081: @298252
     /* 298252 */   GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(298349), // Rule ID 4823 //
     /* 298257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298288 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298292 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298297 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 298301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 298307 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298319 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298325 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 298338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298347 */     GIR_RootConstrainSelectedInstOperands,
     /* 298348 */     // GIR_Coverage, 4823,
     /* 298348 */     GIR_EraseRootFromParent_Done,
     /* 298349 */   // Label 6082: @298349
     /* 298349 */   GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(298427), // Rule ID 6186 //
     /* 298354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298366 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298370 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298374 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298378 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 298391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298395 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 298399 */     // MIs[3] Operand 1
     /* 298399 */     // No operand predicates
     /* 298399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298407 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298409 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 298409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298425 */     GIR_RootConstrainSelectedInstOperands,
     /* 298426 */     // GIR_Coverage, 6186,
     /* 298426 */     GIR_EraseRootFromParent_Done,
     /* 298427 */   // Label 6083: @298427
     /* 298427 */   GIM_Try, /*On fail goto*//*Label 6084*/ GIMT_Encode4(298511), // Rule ID 6098 //
     /* 298432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 298460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298464 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298468 */     // MIs[2] Operand 1
     /* 298468 */     // No operand predicates
     /* 298468 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 298472 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298476 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 298480 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298489 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298491 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 298502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 298506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 298509 */     GIR_RootConstrainSelectedInstOperands,
     /* 298510 */     // GIR_Coverage, 6098,
     /* 298510 */     GIR_EraseRootFromParent_Done,
     /* 298511 */   // Label 6084: @298511
     /* 298511 */   GIM_Try, /*On fail goto*//*Label 6085*/ GIMT_Encode4(298592), // Rule ID 6130 //
     /* 298516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298547 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298552 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298556 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298560 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298564 */     // MIs[3] Operand 1
     /* 298564 */     // No operand predicates
     /* 298564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298574 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 298583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298590 */     GIR_RootConstrainSelectedInstOperands,
     /* 298591 */     // GIR_Coverage, 6130,
     /* 298591 */     GIR_EraseRootFromParent_Done,
     /* 298592 */   // Label 6085: @298592
     /* 298592 */   GIM_Try, /*On fail goto*//*Label 6086*/ GIMT_Encode4(298676), // Rule ID 6162 //
     /* 298597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 298621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298629 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298633 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298638 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298642 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298646 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298650 */     // MIs[3] Operand 1
     /* 298650 */     // No operand predicates
     /* 298650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298654 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298656 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298661 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 298667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298671 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298674 */     GIR_RootConstrainSelectedInstOperands,
     /* 298675 */     // GIR_Coverage, 6162,
     /* 298675 */     GIR_EraseRootFromParent_Done,
     /* 298676 */   // Label 6086: @298676
     /* 298676 */   GIM_Try, /*On fail goto*//*Label 6087*/ GIMT_Encode4(298754), // Rule ID 6208 //
     /* 298681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298713 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 298722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298726 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 298730 */     // MIs[3] Operand 1
     /* 298730 */     // No operand predicates
     /* 298730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298736 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 298736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298743 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298752 */     GIR_RootConstrainSelectedInstOperands,
     /* 298753 */     // GIR_Coverage, 6208,
     /* 298753 */     GIR_EraseRootFromParent_Done,
     /* 298754 */   // Label 6087: @298754
     /* 298754 */   GIM_Try, /*On fail goto*//*Label 6088*/ GIMT_Encode4(298835), // Rule ID 6066 //
     /* 298759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298766 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298770 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 298774 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 298778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 298782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298790 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 298794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298799 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 298803 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298807 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 298811 */     // MIs[3] Operand 1
     /* 298811 */     // No operand predicates
     /* 298811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298815 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 298817 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 298817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 298820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 298824 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 298830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 298833 */     GIR_RootConstrainSelectedInstOperands,
     /* 298834 */     // GIR_Coverage, 6066,
     /* 298834 */     GIR_EraseRootFromParent_Done,
     /* 298835 */   // Label 6088: @298835
     /* 298835 */   GIM_Try, /*On fail goto*//*Label 6089*/ GIMT_Encode4(298920), // Rule ID 2464 //
     /* 298840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298864 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 298868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298876 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298878 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 298878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298890 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 298909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 298916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 298918 */     GIR_RootConstrainSelectedInstOperands,
     /* 298919 */     // GIR_Coverage, 2464,
     /* 298919 */     GIR_EraseRootFromParent_Done,
     /* 298920 */   // Label 6089: @298920
     /* 298920 */   GIM_Try, /*On fail goto*//*Label 6090*/ GIMT_Encode4(299005), // Rule ID 2462 //
     /* 298925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 298928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 298936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 298940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 298948 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298953 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 298957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298961 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 298963 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 298963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 298966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298975 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 298994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 298998 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 299001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 299003 */     GIR_RootConstrainSelectedInstOperands,
     /* 299004 */     // GIR_Coverage, 2462,
     /* 299004 */     GIR_EraseRootFromParent_Done,
     /* 299005 */   // Label 6090: @299005
     /* 299005 */   GIM_Try, /*On fail goto*//*Label 6091*/ GIMT_Encode4(299074), // Rule ID 2554 //
     /* 299010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299042 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 299046 */     // MIs[2] Operand 1
     /* 299046 */     // No operand predicates
     /* 299046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299056 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 299056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 299059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299072 */     GIR_RootConstrainSelectedInstOperands,
     /* 299073 */     // GIR_Coverage, 2554,
     /* 299073 */     GIR_EraseRootFromParent_Done,
     /* 299074 */   // Label 6091: @299074
     /* 299074 */   GIM_Try, /*On fail goto*//*Label 6092*/ GIMT_Encode4(299143), // Rule ID 6034 //
     /* 299079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 299094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 299098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299115 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 299119 */     // MIs[2] Operand 1
     /* 299119 */     // No operand predicates
     /* 299119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299123 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299125 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 299125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 299128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299132 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299141 */     GIR_RootConstrainSelectedInstOperands,
     /* 299142 */     // GIR_Coverage, 6034,
     /* 299142 */     GIR_EraseRootFromParent_Done,
     /* 299143 */   // Label 6092: @299143
     /* 299143 */   GIM_Try, /*On fail goto*//*Label 6093*/ GIMT_Encode4(299205), // Rule ID 4869 //
     /* 299148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 299173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 299181 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299188 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 299191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 299199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 299203 */     GIR_RootConstrainSelectedInstOperands,
     /* 299204 */     // GIR_Coverage, 4869,
     /* 299204 */     GIR_EraseRootFromParent_Done,
     /* 299205 */   // Label 6093: @299205
     /* 299205 */   GIM_Try, /*On fail goto*//*Label 6094*/ GIMT_Encode4(299267), // Rule ID 13808 //
     /* 299210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 299235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 299243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 299250 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 299253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299259 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 299261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 299265 */     GIR_RootConstrainSelectedInstOperands,
     /* 299266 */     // GIR_Coverage, 13808,
     /* 299266 */     GIR_EraseRootFromParent_Done,
     /* 299267 */   // Label 6094: @299267
     /* 299267 */   GIM_Try, /*On fail goto*//*Label 6095*/ GIMT_Encode4(299314), // Rule ID 4866 //
     /* 299272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299299 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 299302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 299310 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 299312 */     GIR_RootConstrainSelectedInstOperands,
     /* 299313 */     // GIR_Coverage, 4866,
     /* 299313 */     GIR_EraseRootFromParent_Done,
     /* 299314 */   // Label 6095: @299314
     /* 299314 */   GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(299364), // Rule ID 13236 //
     /* 299319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299347 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299349 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 299352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 299362 */     GIR_RootConstrainSelectedInstOperands,
     /* 299363 */     // GIR_Coverage, 13236,
     /* 299363 */     GIR_EraseRootFromParent_Done,
     /* 299364 */   // Label 6096: @299364
     /* 299364 */   GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(299414), // Rule ID 648 //
     /* 299369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299399 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 299402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299404 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 299412 */     GIR_RootConstrainSelectedInstOperands,
     /* 299413 */     // GIR_Coverage, 648,
     /* 299413 */     GIR_EraseRootFromParent_Done,
     /* 299414 */   // Label 6097: @299414
     /* 299414 */   GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(299461), // Rule ID 13805 //
     /* 299419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299446 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 299449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299455 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 299457 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 299459 */     GIR_RootConstrainSelectedInstOperands,
     /* 299460 */     // GIR_Coverage, 13805,
     /* 299460 */     GIR_EraseRootFromParent_Done,
     /* 299461 */   // Label 6098: @299461
     /* 299461 */   GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(299511), // Rule ID 660 //
     /* 299466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 299481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 299489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299496 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 299499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 299501 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 299505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 299509 */     GIR_RootConstrainSelectedInstOperands,
     /* 299510 */     // GIR_Coverage, 660,
     /* 299510 */     GIR_EraseRootFromParent_Done,
     /* 299511 */   // Label 6099: @299511
     /* 299511 */   GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(299542), // Rule ID 642 //
     /* 299516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 299519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299531 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 299531 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 299536 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 299540 */     GIR_RootConstrainSelectedInstOperands,
     /* 299541 */     // GIR_Coverage, 642,
     /* 299541 */     GIR_Done,
     /* 299542 */   // Label 6100: @299542
     /* 299542 */   GIM_Reject,
     /* 299543 */ // Label 6066: @299543
     /* 299543 */ GIM_Reject,
     /* 299544 */ // Label 5992: @299544
     /* 299544 */ GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(301064),
     /* 299549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299552 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299555 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299562 */   GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(299640), // Rule ID 6166 //
     /* 299567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 299604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299608 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299612 */     // MIs[3] Operand 1
     /* 299612 */     // No operand predicates
     /* 299612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299616 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299620 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299622 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299638 */     GIR_RootConstrainSelectedInstOperands,
     /* 299639 */     // GIR_Coverage, 6166,
     /* 299639 */     GIR_EraseRootFromParent_Done,
     /* 299640 */   // Label 6102: @299640
     /* 299640 */   GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(299724), // Rule ID 6082 //
     /* 299645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 299673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299677 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299681 */     // MIs[2] Operand 1
     /* 299681 */     // No operand predicates
     /* 299681 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 299685 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299689 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299693 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299702 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299704 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 299715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 299719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 299722 */     GIR_RootConstrainSelectedInstOperands,
     /* 299723 */     // GIR_Coverage, 6082,
     /* 299723 */     GIR_EraseRootFromParent_Done,
     /* 299724 */   // Label 6103: @299724
     /* 299724 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(299805), // Rule ID 6114 //
     /* 299729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299752 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299756 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299760 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299765 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299769 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299773 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299777 */     // MIs[3] Operand 1
     /* 299777 */     // No operand predicates
     /* 299777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299781 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299785 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299787 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299792 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 299796 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299800 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299803 */     GIR_RootConstrainSelectedInstOperands,
     /* 299804 */     // GIR_Coverage, 6114,
     /* 299804 */     GIR_EraseRootFromParent_Done,
     /* 299805 */   // Label 6104: @299805
     /* 299805 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(299889), // Rule ID 6146 //
     /* 299810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 299834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299846 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299859 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299863 */     // MIs[3] Operand 1
     /* 299863 */     // No operand predicates
     /* 299863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299867 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299869 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 299880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299884 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299887 */     GIR_RootConstrainSelectedInstOperands,
     /* 299888 */     // GIR_Coverage, 6146,
     /* 299888 */     GIR_EraseRootFromParent_Done,
     /* 299889 */   // Label 6105: @299889
     /* 299889 */   GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(299967), // Rule ID 6188 //
     /* 299894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 299914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299926 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299931 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 299935 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299939 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299943 */     // MIs[3] Operand 1
     /* 299943 */     // No operand predicates
     /* 299943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299947 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299949 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 299949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 299952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 299956 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 299958 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299965 */     GIR_RootConstrainSelectedInstOperands,
     /* 299966 */     // GIR_Coverage, 6188,
     /* 299966 */     GIR_EraseRootFromParent_Done,
     /* 299967 */   // Label 6106: @299967
     /* 299967 */   GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(300048), // Rule ID 6050 //
     /* 299972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 299987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 299991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 299995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300003 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300007 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300020 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300024 */     // MIs[3] Operand 1
     /* 300024 */     // No operand predicates
     /* 300024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300028 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300030 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300046 */     GIR_RootConstrainSelectedInstOperands,
     /* 300047 */     // GIR_Coverage, 6050,
     /* 300047 */     GIR_EraseRootFromParent_Done,
     /* 300048 */   // Label 6107: @300048
     /* 300048 */   GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(300117), // Rule ID 2538 //
     /* 300053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 300064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 300081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300085 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300089 */     // MIs[2] Operand 1
     /* 300089 */     // No operand predicates
     /* 300089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300097 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300099 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 300102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 300115 */     GIR_RootConstrainSelectedInstOperands,
     /* 300116 */     // GIR_Coverage, 2538,
     /* 300116 */     GIR_EraseRootFromParent_Done,
     /* 300117 */   // Label 6108: @300117
     /* 300117 */   GIM_Try, /*On fail goto*//*Label 6109*/ GIMT_Encode4(300186), // Rule ID 6018 //
     /* 300122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 300137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 300141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 300145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 300154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300158 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 300162 */     // MIs[2] Operand 1
     /* 300162 */     // No operand predicates
     /* 300162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300168 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 300168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 300171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300175 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 300184 */     GIR_RootConstrainSelectedInstOperands,
     /* 300185 */     // GIR_Coverage, 6018,
     /* 300185 */     GIR_EraseRootFromParent_Done,
     /* 300186 */   // Label 6109: @300186
     /* 300186 */   GIM_Try, /*On fail goto*//*Label 6110*/ GIMT_Encode4(300279), // Rule ID 6170 //
     /* 300191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 300199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300211 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 300215 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300228 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300230 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300230 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300233 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300237 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300242 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300245 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300249 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300277 */     GIR_RootConstrainSelectedInstOperands,
     /* 300278 */     // GIR_Coverage, 6170,
     /* 300278 */     GIR_EraseRootFromParent_Done,
     /* 300279 */   // Label 6110: @300279
     /* 300279 */   GIM_Try, /*On fail goto*//*Label 6111*/ GIMT_Encode4(300378), // Rule ID 6084 //
     /* 300284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 300295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 300308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300316 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300321 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300325 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300327 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300339 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300342 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300346 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300349 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300354 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 300370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300376 */     GIR_RootConstrainSelectedInstOperands,
     /* 300377 */     // GIR_Coverage, 6084,
     /* 300377 */     GIR_EraseRootFromParent_Done,
     /* 300378 */   // Label 6111: @300378
     /* 300378 */   GIM_Try, /*On fail goto*//*Label 6112*/ GIMT_Encode4(300474), // Rule ID 6116 //
     /* 300383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300398 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300402 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 300406 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 300410 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300423 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300425 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300437 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300440 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300444 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300472 */     GIR_RootConstrainSelectedInstOperands,
     /* 300473 */     // GIR_Coverage, 6116,
     /* 300473 */     GIR_EraseRootFromParent_Done,
     /* 300474 */   // Label 6112: @300474
     /* 300474 */   GIM_Try, /*On fail goto*//*Label 6113*/ GIMT_Encode4(300573), // Rule ID 6148 //
     /* 300479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 300503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 300507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 300511 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300516 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300522 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300522 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300525 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300529 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300534 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300537 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300541 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300544 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 300565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300571 */     GIR_RootConstrainSelectedInstOperands,
     /* 300572 */     // GIR_Coverage, 6148,
     /* 300572 */     GIR_EraseRootFromParent_Done,
     /* 300573 */   // Label 6113: @300573
     /* 300573 */   GIM_Try, /*On fail goto*//*Label 6114*/ GIMT_Encode4(300666), // Rule ID 6192 //
     /* 300578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 300590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 300606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300617 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300629 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300632 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300636 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300639 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300656 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300664 */     GIR_RootConstrainSelectedInstOperands,
     /* 300665 */     // GIR_Coverage, 6192,
     /* 300665 */     GIR_EraseRootFromParent_Done,
     /* 300666 */   // Label 6114: @300666
     /* 300666 */   GIM_Try, /*On fail goto*//*Label 6115*/ GIMT_Encode4(300762), // Rule ID 6052 //
     /* 300671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 300694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 300698 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 300702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 300713 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300713 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300716 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300720 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300725 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300728 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300732 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 300748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300752 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300760 */     GIR_RootConstrainSelectedInstOperands,
     /* 300761 */     // GIR_Coverage, 6052,
     /* 300761 */     GIR_EraseRootFromParent_Done,
     /* 300762 */   // Label 6115: @300762
     /* 300762 */   GIM_Try, /*On fail goto*//*Label 6116*/ GIMT_Encode4(300846), // Rule ID 2540 //
     /* 300767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 300778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300782 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300797 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300809 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300812 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300816 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300819 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 300832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300844 */     GIR_RootConstrainSelectedInstOperands,
     /* 300845 */     // GIR_Coverage, 2540,
     /* 300845 */     GIR_EraseRootFromParent_Done,
     /* 300846 */   // Label 6116: @300846
     /* 300846 */   GIM_Try, /*On fail goto*//*Label 6117*/ GIMT_Encode4(300896), // Rule ID 13266 //
     /* 300851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 300862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 300866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300881 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 300881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 300884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 300890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300894 */     GIR_RootConstrainSelectedInstOperands,
     /* 300895 */     // GIR_Coverage, 13266,
     /* 300895 */     GIR_EraseRootFromParent_Done,
     /* 300896 */   // Label 6117: @300896
     /* 300896 */   GIM_Try, /*On fail goto*//*Label 6118*/ GIMT_Encode4(300980), // Rule ID 6020 //
     /* 300901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 300916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 300920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300931 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 300931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 300934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 300938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 300943 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 300946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 300950 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 300953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 300963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 300966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 300970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 300972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 300975 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 300978 */     GIR_RootConstrainSelectedInstOperands,
     /* 300979 */     // GIR_Coverage, 6020,
     /* 300979 */     GIR_EraseRootFromParent_Done,
     /* 300980 */   // Label 6118: @300980
     /* 300980 */   GIM_Try, /*On fail goto*//*Label 6119*/ GIMT_Encode4(301030), // Rule ID 1308 //
     /* 300985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300992 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300996 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301000 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 301015 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 301015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 301018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301028 */     GIR_RootConstrainSelectedInstOperands,
     /* 301029 */     // GIR_Coverage, 1308,
     /* 301029 */     GIR_EraseRootFromParent_Done,
     /* 301030 */   // Label 6119: @301030
     /* 301030 */   GIM_Try, /*On fail goto*//*Label 6120*/ GIMT_Encode4(301063), // Rule ID 1298 //
     /* 301035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301050 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 301050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 301053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301059 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 301061 */     GIR_RootConstrainSelectedInstOperands,
     /* 301062 */     // GIR_Coverage, 1298,
     /* 301062 */     GIR_EraseRootFromParent_Done,
     /* 301063 */   // Label 6120: @301063
     /* 301063 */   GIM_Reject,
     /* 301064 */ // Label 6101: @301064
     /* 301064 */ GIM_Reject,
     /* 301065 */ // Label 5993: @301065
     /* 301065 */ GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(302585),
     /* 301070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 301076 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 301079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301083 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(301161), // Rule ID 6178 //
     /* 301088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 301096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301112 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 301125 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301129 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301133 */     // MIs[3] Operand 1
     /* 301133 */     // No operand predicates
     /* 301133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301141 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301143 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301159 */     GIR_RootConstrainSelectedInstOperands,
     /* 301160 */     // GIR_Coverage, 6178,
     /* 301160 */     GIR_EraseRootFromParent_Done,
     /* 301161 */   // Label 6122: @301161
     /* 301161 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(301245), // Rule ID 6090 //
     /* 301166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 301177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 301194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301198 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301202 */     // MIs[2] Operand 1
     /* 301202 */     // No operand predicates
     /* 301202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 301206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301210 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301214 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301223 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301225 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 301236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 301243 */     GIR_RootConstrainSelectedInstOperands,
     /* 301244 */     // GIR_Coverage, 6090,
     /* 301244 */     GIR_EraseRootFromParent_Done,
     /* 301245 */   // Label 6123: @301245
     /* 301245 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(301326), // Rule ID 6122 //
     /* 301250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 301273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 301290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301294 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301298 */     // MIs[3] Operand 1
     /* 301298 */     // No operand predicates
     /* 301298 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301308 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301321 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301324 */     GIR_RootConstrainSelectedInstOperands,
     /* 301325 */     // GIR_Coverage, 6122,
     /* 301325 */     GIR_EraseRootFromParent_Done,
     /* 301326 */   // Label 6124: @301326
     /* 301326 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(301410), // Rule ID 6154 //
     /* 301331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 301359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301363 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 301376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301380 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301384 */     // MIs[3] Operand 1
     /* 301384 */     // No operand predicates
     /* 301384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301388 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301390 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 301401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301408 */     GIR_RootConstrainSelectedInstOperands,
     /* 301409 */     // GIR_Coverage, 6154,
     /* 301409 */     GIR_EraseRootFromParent_Done,
     /* 301410 */   // Label 6125: @301410
     /* 301410 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(301488), // Rule ID 6200 //
     /* 301415 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 301427 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301431 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301443 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301447 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 301456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301460 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301464 */     // MIs[3] Operand 1
     /* 301464 */     // No operand predicates
     /* 301464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301468 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301470 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301486 */     GIR_RootConstrainSelectedInstOperands,
     /* 301487 */     // GIR_Coverage, 6200,
     /* 301487 */     GIR_EraseRootFromParent_Done,
     /* 301488 */   // Label 6126: @301488
     /* 301488 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(301569), // Rule ID 6058 //
     /* 301493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 301520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 301528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 301537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301541 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301545 */     // MIs[3] Operand 1
     /* 301545 */     // No operand predicates
     /* 301545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301549 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 301551 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301558 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 301567 */     GIR_RootConstrainSelectedInstOperands,
     /* 301568 */     // GIR_Coverage, 6058,
     /* 301568 */     GIR_EraseRootFromParent_Done,
     /* 301569 */   // Label 6127: @301569
     /* 301569 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(301638), // Rule ID 2546 //
     /* 301574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 301585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301589 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301598 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 301602 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301606 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301610 */     // MIs[2] Operand 1
     /* 301610 */     // No operand predicates
     /* 301610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301620 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 301623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301633 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 301636 */     GIR_RootConstrainSelectedInstOperands,
     /* 301637 */     // GIR_Coverage, 2546,
     /* 301637 */     GIR_EraseRootFromParent_Done,
     /* 301638 */   // Label 6128: @301638
     /* 301638 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(301707), // Rule ID 6026 //
     /* 301643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 301658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 301666 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 301675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301679 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 301683 */     // MIs[2] Operand 1
     /* 301683 */     // No operand predicates
     /* 301683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301689 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 301689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 301692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301696 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 301698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301702 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 301705 */     GIR_RootConstrainSelectedInstOperands,
     /* 301706 */     // GIR_Coverage, 6026,
     /* 301706 */     GIR_EraseRootFromParent_Done,
     /* 301707 */   // Label 6129: @301707
     /* 301707 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(301800), // Rule ID 6180 //
     /* 301712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301751 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301763 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301766 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301770 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301790 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301798 */     GIR_RootConstrainSelectedInstOperands,
     /* 301799 */     // GIR_Coverage, 6180,
     /* 301799 */     GIR_EraseRootFromParent_Done,
     /* 301800 */   // Label 6130: @301800
     /* 301800 */   GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(301899), // Rule ID 6092 //
     /* 301805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 301816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 301820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 301829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301837 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301842 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301846 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301848 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301848 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301851 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301855 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301860 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301863 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 301867 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 301891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301897 */     GIR_RootConstrainSelectedInstOperands,
     /* 301898 */     // GIR_Coverage, 6092,
     /* 301898 */     GIR_EraseRootFromParent_Done,
     /* 301899 */   // Label 6131: @301899
     /* 301899 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(301995), // Rule ID 6124 //
     /* 301904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 301911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 301915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 301923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 301927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 301931 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301940 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301944 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 301946 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 301946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 301949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 301953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 301958 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 301961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 301965 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 301968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 301981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 301985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 301987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 301990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 301993 */     GIR_RootConstrainSelectedInstOperands,
     /* 301994 */     // GIR_Coverage, 6124,
     /* 301994 */     GIR_EraseRootFromParent_Done,
     /* 301995 */   // Label 6132: @301995
     /* 301995 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(302094), // Rule ID 6156 //
     /* 302000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 302028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 302032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302041 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302043 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302055 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302058 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302062 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 302065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 302078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302092 */     GIR_RootConstrainSelectedInstOperands,
     /* 302093 */     // GIR_Coverage, 6156,
     /* 302093 */     GIR_EraseRootFromParent_Done,
     /* 302094 */   // Label 6133: @302094
     /* 302094 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(302187), // Rule ID 6202 //
     /* 302099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 302111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 302115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 302127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302138 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302150 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302153 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302157 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 302160 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 302173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302185 */     GIR_RootConstrainSelectedInstOperands,
     /* 302186 */     // GIR_Coverage, 6202,
     /* 302186 */     GIR_EraseRootFromParent_Done,
     /* 302187 */   // Label 6134: @302187
     /* 302187 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(302283), // Rule ID 6060 //
     /* 302192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 302219 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 302223 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302234 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302234 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302237 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302241 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302246 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302249 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302253 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 302256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 302269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302271 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302281 */     GIR_RootConstrainSelectedInstOperands,
     /* 302282 */     // GIR_Coverage, 6060,
     /* 302282 */     GIR_EraseRootFromParent_Done,
     /* 302283 */   // Label 6135: @302283
     /* 302283 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(302367), // Rule ID 2548 //
     /* 302288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 302299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 302303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302316 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302318 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302330 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302333 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302337 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 302340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 302353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302359 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302365 */     GIR_RootConstrainSelectedInstOperands,
     /* 302366 */     // GIR_Coverage, 2548,
     /* 302366 */     GIR_EraseRootFromParent_Done,
     /* 302367 */   // Label 6136: @302367
     /* 302367 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(302417), // Rule ID 13270 //
     /* 302372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302400 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302402 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 302402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 302405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302415 */     GIR_RootConstrainSelectedInstOperands,
     /* 302416 */     // GIR_Coverage, 13270,
     /* 302416 */     GIR_EraseRootFromParent_Done,
     /* 302417 */   // Label 6137: @302417
     /* 302417 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(302501), // Rule ID 6028 //
     /* 302422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 302437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 302441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302452 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 302452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 302455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 302459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 302464 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 302467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302471 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 302474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 302487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302493 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 302496 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 302499 */     GIR_RootConstrainSelectedInstOperands,
     /* 302500 */     // GIR_Coverage, 6028,
     /* 302500 */     GIR_EraseRootFromParent_Done,
     /* 302501 */   // Label 6138: @302501
     /* 302501 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(302551), // Rule ID 1312 //
     /* 302506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302513 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302517 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302521 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 302525 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302536 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 302536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 302539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302543 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302549 */     GIR_RootConstrainSelectedInstOperands,
     /* 302550 */     // GIR_Coverage, 1312,
     /* 302550 */     GIR_EraseRootFromParent_Done,
     /* 302551 */   // Label 6139: @302551
     /* 302551 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(302584), // Rule ID 1302 //
     /* 302556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302571 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 302571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 302574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 302582 */     GIR_RootConstrainSelectedInstOperands,
     /* 302583 */     // GIR_Coverage, 1302,
     /* 302583 */     GIR_EraseRootFromParent_Done,
     /* 302584 */   // Label 6140: @302584
     /* 302584 */   GIM_Reject,
     /* 302585 */ // Label 6121: @302585
     /* 302585 */ GIM_Reject,
     /* 302586 */ // Label 5994: @302586
     /* 302586 */ GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(303764),
     /* 302591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302597 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302604 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(302688), // Rule ID 6074 //
     /* 302609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 302637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302641 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302645 */     // MIs[2] Operand 1
     /* 302645 */     // No operand predicates
     /* 302645 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 302649 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302653 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302657 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302666 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302668 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 302679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 302686 */     GIR_RootConstrainSelectedInstOperands,
     /* 302687 */     // GIR_Coverage, 6074,
     /* 302687 */     GIR_EraseRootFromParent_Done,
     /* 302688 */   // Label 6142: @302688
     /* 302688 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(302769), // Rule ID 6106 //
     /* 302693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302708 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302712 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302716 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302720 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302724 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302737 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302741 */     // MIs[3] Operand 1
     /* 302741 */     // No operand predicates
     /* 302741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302751 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302767 */     GIR_RootConstrainSelectedInstOperands,
     /* 302768 */     // GIR_Coverage, 6106,
     /* 302768 */     GIR_EraseRootFromParent_Done,
     /* 302769 */   // Label 6143: @302769
     /* 302769 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(302853), // Rule ID 6138 //
     /* 302774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 302798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302802 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302806 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302810 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302815 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302819 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302823 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302827 */     // MIs[3] Operand 1
     /* 302827 */     // No operand predicates
     /* 302827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302831 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302833 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 302844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302851 */     GIR_RootConstrainSelectedInstOperands,
     /* 302852 */     // GIR_Coverage, 6138,
     /* 302852 */     GIR_EraseRootFromParent_Done,
     /* 302853 */   // Label 6144: @302853
     /* 302853 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(302934), // Rule ID 6042 //
     /* 302858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 302873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 302881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302906 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302910 */     // MIs[3] Operand 1
     /* 302910 */     // No operand predicates
     /* 302910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302916 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 302919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 302925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302932 */     GIR_RootConstrainSelectedInstOperands,
     /* 302933 */     // GIR_Coverage, 6042,
     /* 302933 */     GIR_EraseRootFromParent_Done,
     /* 302934 */   // Label 6145: @302934
     /* 302934 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(303003), // Rule ID 2530 //
     /* 302939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 302942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 302946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 302958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302963 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 302967 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302971 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302975 */     // MIs[2] Operand 1
     /* 302975 */     // No operand predicates
     /* 302975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302983 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 302985 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 302985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 302988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 302992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 302994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 302998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 303001 */     GIR_RootConstrainSelectedInstOperands,
     /* 303002 */     // GIR_Coverage, 2530,
     /* 303002 */     GIR_EraseRootFromParent_Done,
     /* 303003 */   // Label 6146: @303003
     /* 303003 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(303072), // Rule ID 6010 //
     /* 303008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 303023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 303036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 303040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303044 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 303048 */     // MIs[2] Operand 1
     /* 303048 */     // No operand predicates
     /* 303048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303054 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 303054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 303057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 303070 */     GIR_RootConstrainSelectedInstOperands,
     /* 303071 */     // GIR_Coverage, 6010,
     /* 303071 */     GIR_EraseRootFromParent_Done,
     /* 303072 */   // Label 6147: @303072
     /* 303072 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(303171), // Rule ID 6076 //
     /* 303077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 303088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 303092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303109 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303118 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303120 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303120 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 303123 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303127 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303132 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303135 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303139 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 303142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 303155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 303163 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303169 */     GIR_RootConstrainSelectedInstOperands,
     /* 303170 */     // GIR_Coverage, 6076,
     /* 303170 */     GIR_EraseRootFromParent_Done,
     /* 303171 */   // Label 6148: @303171
     /* 303171 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(303267), // Rule ID 6108 //
     /* 303176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 303199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 303203 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303218 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303218 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 303221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303225 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303230 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303233 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303237 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 303240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303245 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 303253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303265 */     GIR_RootConstrainSelectedInstOperands,
     /* 303266 */     // GIR_Coverage, 6108,
     /* 303266 */     GIR_EraseRootFromParent_Done,
     /* 303267 */   // Label 6149: @303267
     /* 303267 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(303366), // Rule ID 6140 //
     /* 303272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303292 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303296 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 303300 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 303304 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303313 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303315 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303315 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 303318 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303322 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303327 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303330 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303334 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 303337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 303350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303364 */     GIR_RootConstrainSelectedInstOperands,
     /* 303365 */     // GIR_Coverage, 6140,
     /* 303365 */     GIR_EraseRootFromParent_Done,
     /* 303366 */   // Label 6150: @303366
     /* 303366 */   GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(303462), // Rule ID 6044 //
     /* 303371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 303398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 303402 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303411 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303413 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 303416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303425 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303428 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303432 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 303435 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303440 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 303448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303460 */     GIR_RootConstrainSelectedInstOperands,
     /* 303461 */     // GIR_Coverage, 6044,
     /* 303461 */     GIR_EraseRootFromParent_Done,
     /* 303462 */   // Label 6151: @303462
     /* 303462 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(303546), // Rule ID 2532 //
     /* 303467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 303478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 303482 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303487 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303491 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303497 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 303500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303509 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303512 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303516 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 303519 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303524 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 303532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303538 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303544 */     GIR_RootConstrainSelectedInstOperands,
     /* 303545 */     // GIR_Coverage, 2532,
     /* 303545 */     GIR_EraseRootFromParent_Done,
     /* 303546 */   // Label 6152: @303546
     /* 303546 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(303596), // Rule ID 13262 //
     /* 303551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303566 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303581 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 303581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 303584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303594 */     GIR_RootConstrainSelectedInstOperands,
     /* 303595 */     // GIR_Coverage, 13262,
     /* 303595 */     GIR_EraseRootFromParent_Done,
     /* 303596 */   // Label 6153: @303596
     /* 303596 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(303680), // Rule ID 6012 //
     /* 303601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 303616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 303620 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303631 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 303631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 303634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 303638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303643 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 303646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303650 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 303653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303658 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 303663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 303666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 303678 */     GIR_RootConstrainSelectedInstOperands,
     /* 303679 */     // GIR_Coverage, 6012,
     /* 303679 */     GIR_EraseRootFromParent_Done,
     /* 303680 */   // Label 6154: @303680
     /* 303680 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(303730), // Rule ID 1304 //
     /* 303685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 303696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303700 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 303704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303709 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 303715 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 303715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 303718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303722 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 303724 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303728 */     GIR_RootConstrainSelectedInstOperands,
     /* 303729 */     // GIR_Coverage, 1304,
     /* 303729 */     GIR_EraseRootFromParent_Done,
     /* 303730 */   // Label 6155: @303730
     /* 303730 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(303763), // Rule ID 1294 //
     /* 303735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 303738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303746 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303750 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 303750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 303753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303759 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 303761 */     GIR_RootConstrainSelectedInstOperands,
     /* 303762 */     // GIR_Coverage, 1294,
     /* 303762 */     GIR_EraseRootFromParent_Done,
     /* 303763 */   // Label 6156: @303763
     /* 303763 */   GIM_Reject,
     /* 303764 */ // Label 6141: @303764
     /* 303764 */ GIM_Reject,
     /* 303765 */ // Label 5995: @303765
     /* 303765 */ GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(305285),
     /* 303770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303773 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 303776 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 303779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303783 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(303861), // Rule ID 6172 //
     /* 303788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303800 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303816 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 303825 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303829 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303833 */     // MIs[3] Operand 1
     /* 303833 */     // No operand predicates
     /* 303833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303841 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303843 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 303852 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 303856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 303859 */     GIR_RootConstrainSelectedInstOperands,
     /* 303860 */     // GIR_Coverage, 6172,
     /* 303860 */     GIR_EraseRootFromParent_Done,
     /* 303861 */   // Label 6158: @303861
     /* 303861 */   GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(303945), // Rule ID 6086 //
     /* 303866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 303894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303898 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303902 */     // MIs[2] Operand 1
     /* 303902 */     // No operand predicates
     /* 303902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 303906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303910 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303914 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303923 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 303925 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 303925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 303928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 303930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 303932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 303936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 303940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 303943 */     GIR_RootConstrainSelectedInstOperands,
     /* 303944 */     // GIR_Coverage, 6086,
     /* 303944 */     GIR_EraseRootFromParent_Done,
     /* 303945 */   // Label 6159: @303945
     /* 303945 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(304026), // Rule ID 6118 //
     /* 303950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 303961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 303969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 303973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303977 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 303990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 303994 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 303998 */     // MIs[3] Operand 1
     /* 303998 */     // No operand predicates
     /* 303998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304006 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304008 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 304008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 304024 */     GIR_RootConstrainSelectedInstOperands,
     /* 304025 */     // GIR_Coverage, 6118,
     /* 304025 */     GIR_EraseRootFromParent_Done,
     /* 304026 */   // Label 6160: @304026
     /* 304026 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(304110), // Rule ID 6150 //
     /* 304031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 304059 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304063 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 304076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304080 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 304084 */     // MIs[3] Operand 1
     /* 304084 */     // No operand predicates
     /* 304084 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304088 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304090 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 304090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 304108 */     GIR_RootConstrainSelectedInstOperands,
     /* 304109 */     // GIR_Coverage, 6150,
     /* 304109 */     GIR_EraseRootFromParent_Done,
     /* 304110 */   // Label 6161: @304110
     /* 304110 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(304188), // Rule ID 6194 //
     /* 304115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 304127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304143 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304147 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304152 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 304156 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304160 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 304164 */     // MIs[3] Operand 1
     /* 304164 */     // No operand predicates
     /* 304164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304168 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304170 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 304170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 304186 */     GIR_RootConstrainSelectedInstOperands,
     /* 304187 */     // GIR_Coverage, 6194,
     /* 304187 */     GIR_EraseRootFromParent_Done,
     /* 304188 */   // Label 6162: @304188
     /* 304188 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(304269), // Rule ID 6054 //
     /* 304193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 304220 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304224 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 304228 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304233 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 304237 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304241 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 304245 */     // MIs[3] Operand 1
     /* 304245 */     // No operand predicates
     /* 304245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304249 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 304251 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 304251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304258 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 304267 */     GIR_RootConstrainSelectedInstOperands,
     /* 304268 */     // GIR_Coverage, 6054,
     /* 304268 */     GIR_EraseRootFromParent_Done,
     /* 304269 */   // Label 6163: @304269
     /* 304269 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(304338), // Rule ID 2542 //
     /* 304274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 304285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 304302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304306 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 304310 */     // MIs[2] Operand 1
     /* 304310 */     // No operand predicates
     /* 304310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304314 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304320 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 304320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 304323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 304336 */     GIR_RootConstrainSelectedInstOperands,
     /* 304337 */     // GIR_Coverage, 2542,
     /* 304337 */     GIR_EraseRootFromParent_Done,
     /* 304338 */   // Label 6164: @304338
     /* 304338 */   GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(304407), // Rule ID 6022 //
     /* 304343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 304358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304362 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 304366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 304375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 304379 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 304383 */     // MIs[2] Operand 1
     /* 304383 */     // No operand predicates
     /* 304383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304389 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 304389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 304392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 304405 */     GIR_RootConstrainSelectedInstOperands,
     /* 304406 */     // GIR_Coverage, 6022,
     /* 304406 */     GIR_EraseRootFromParent_Done,
     /* 304407 */   // Label 6165: @304407
     /* 304407 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(304500), // Rule ID 6176 //
     /* 304412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 304436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304451 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304463 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304470 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304498 */     GIR_RootConstrainSelectedInstOperands,
     /* 304499 */     // GIR_Coverage, 6176,
     /* 304499 */     GIR_EraseRootFromParent_Done,
     /* 304500 */   // Label 6166: @304500
     /* 304500 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(304599), // Rule ID 6088 //
     /* 304505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304512 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304516 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304520 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304533 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304548 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304560 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304563 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 304567 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304570 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304575 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 304591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304597 */     GIR_RootConstrainSelectedInstOperands,
     /* 304598 */     // GIR_Coverage, 6088,
     /* 304598 */     GIR_EraseRootFromParent_Done,
     /* 304599 */   // Label 6167: @304599
     /* 304599 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(304695), // Rule ID 6120 //
     /* 304604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 304627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 304631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304646 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304658 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304661 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304665 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304668 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304683 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 304687 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304693 */     GIR_RootConstrainSelectedInstOperands,
     /* 304694 */     // GIR_Coverage, 6120,
     /* 304694 */     GIR_EraseRootFromParent_Done,
     /* 304695 */   // Label 6168: @304695
     /* 304695 */   GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(304794), // Rule ID 6152 //
     /* 304700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 304728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 304732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304741 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304743 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304755 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304758 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304762 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304792 */     GIR_RootConstrainSelectedInstOperands,
     /* 304793 */     // GIR_Coverage, 6152,
     /* 304793 */     GIR_EraseRootFromParent_Done,
     /* 304794 */   // Label 6169: @304794
     /* 304794 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(304887), // Rule ID 6198 //
     /* 304799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 304815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 304827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304838 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304850 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304853 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304857 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304877 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304885 */     GIR_RootConstrainSelectedInstOperands,
     /* 304886 */     // GIR_Coverage, 6198,
     /* 304886 */     GIR_EraseRootFromParent_Done,
     /* 304887 */   // Label 6170: @304887
     /* 304887 */   GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(304983), // Rule ID 6056 //
     /* 304892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 304903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 304907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 304915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 304919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 304923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304934 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 304934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 304941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304946 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 304949 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 304953 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 304956 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 304969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 304973 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 304975 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 304981 */     GIR_RootConstrainSelectedInstOperands,
     /* 304982 */     // GIR_Coverage, 6056,
     /* 304982 */     GIR_EraseRootFromParent_Done,
     /* 304983 */   // Label 6171: @304983
     /* 304983 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(305067), // Rule ID 2544 //
     /* 304988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 304999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 305003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305018 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 305021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305030 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305033 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305037 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 305040 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 305053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305065 */     GIR_RootConstrainSelectedInstOperands,
     /* 305066 */     // GIR_Coverage, 2544,
     /* 305066 */     GIR_EraseRootFromParent_Done,
     /* 305067 */   // Label 6172: @305067
     /* 305067 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(305117), // Rule ID 13268 //
     /* 305072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305100 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305102 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 305102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 305105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305115 */     GIR_RootConstrainSelectedInstOperands,
     /* 305116 */     // GIR_Coverage, 13268,
     /* 305116 */     GIR_EraseRootFromParent_Done,
     /* 305117 */   // Label 6173: @305117
     /* 305117 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(305201), // Rule ID 6024 //
     /* 305122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 305141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305152 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 305155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305164 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305167 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305171 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 305174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305179 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 305184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 305187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305199 */     GIR_RootConstrainSelectedInstOperands,
     /* 305200 */     // GIR_Coverage, 6024,
     /* 305200 */     GIR_EraseRootFromParent_Done,
     /* 305201 */   // Label 6174: @305201
     /* 305201 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(305251), // Rule ID 1310 //
     /* 305206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305236 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 305236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 305239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305249 */     GIR_RootConstrainSelectedInstOperands,
     /* 305250 */     // GIR_Coverage, 1310,
     /* 305250 */     GIR_EraseRootFromParent_Done,
     /* 305251 */   // Label 6175: @305251
     /* 305251 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(305284), // Rule ID 1300 //
     /* 305256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305259 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305271 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 305271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 305274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305280 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 305282 */     GIR_RootConstrainSelectedInstOperands,
     /* 305283 */     // GIR_Coverage, 1300,
     /* 305283 */     GIR_EraseRootFromParent_Done,
     /* 305284 */   // Label 6176: @305284
     /* 305284 */   GIM_Reject,
     /* 305285 */ // Label 6157: @305285
     /* 305285 */ GIM_Reject,
     /* 305286 */ // Label 5996: @305286
     /* 305286 */ GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(306464),
     /* 305291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 305297 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 305300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305304 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(305388), // Rule ID 6070 //
     /* 305309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305320 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305324 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305341 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305345 */     // MIs[2] Operand 1
     /* 305345 */     // No operand predicates
     /* 305345 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 305349 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305353 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305357 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305366 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305368 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 305379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305386 */     GIR_RootConstrainSelectedInstOperands,
     /* 305387 */     // GIR_Coverage, 6070,
     /* 305387 */     GIR_EraseRootFromParent_Done,
     /* 305388 */   // Label 6178: @305388
     /* 305388 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(305469), // Rule ID 6102 //
     /* 305393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305420 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305424 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305429 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305433 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305437 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305441 */     // MIs[3] Operand 1
     /* 305441 */     // No operand predicates
     /* 305441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305449 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305451 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305464 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305467 */     GIR_RootConstrainSelectedInstOperands,
     /* 305468 */     // GIR_Coverage, 6102,
     /* 305468 */     GIR_EraseRootFromParent_Done,
     /* 305469 */   // Label 6179: @305469
     /* 305469 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(305553), // Rule ID 6134 //
     /* 305474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305477 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305481 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305485 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305523 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305527 */     // MIs[3] Operand 1
     /* 305527 */     // No operand predicates
     /* 305527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305531 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305533 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 305544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305551 */     GIR_RootConstrainSelectedInstOperands,
     /* 305552 */     // GIR_Coverage, 6134,
     /* 305552 */     GIR_EraseRootFromParent_Done,
     /* 305553 */   // Label 6180: @305553
     /* 305553 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(305634), // Rule ID 6038 //
     /* 305558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305593 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305606 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305610 */     // MIs[3] Operand 1
     /* 305610 */     // No operand predicates
     /* 305610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305614 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305616 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305632 */     GIR_RootConstrainSelectedInstOperands,
     /* 305633 */     // GIR_Coverage, 6038,
     /* 305633 */     GIR_EraseRootFromParent_Done,
     /* 305634 */   // Label 6181: @305634
     /* 305634 */   GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(305703), // Rule ID 2526 //
     /* 305639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305654 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305658 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305663 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305667 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305671 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305675 */     // MIs[2] Operand 1
     /* 305675 */     // No operand predicates
     /* 305675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305679 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305685 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 305688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305701 */     GIR_RootConstrainSelectedInstOperands,
     /* 305702 */     // GIR_Coverage, 2526,
     /* 305702 */     GIR_EraseRootFromParent_Done,
     /* 305703 */   // Label 6182: @305703
     /* 305703 */   GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(305772), // Rule ID 6006 //
     /* 305708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 305723 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305727 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305731 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 305736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305744 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305748 */     // MIs[2] Operand 1
     /* 305748 */     // No operand predicates
     /* 305748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305754 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 305757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305770 */     GIR_RootConstrainSelectedInstOperands,
     /* 305771 */     // GIR_Coverage, 6006,
     /* 305771 */     GIR_EraseRootFromParent_Done,
     /* 305772 */   // Label 6183: @305772
     /* 305772 */   GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(305871), // Rule ID 6072 //
     /* 305777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 305788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 305792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305818 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305820 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305832 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305835 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305839 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 305863 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305869 */     GIR_RootConstrainSelectedInstOperands,
     /* 305870 */     // GIR_Coverage, 6072,
     /* 305870 */     GIR_EraseRootFromParent_Done,
     /* 305871 */   // Label 6184: @305871
     /* 305871 */   GIM_Try, /*On fail goto*//*Label 6185*/ GIMT_Encode4(305967), // Rule ID 6104 //
     /* 305876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 305895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 305899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 305903 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305912 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305916 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 305918 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 305918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 305921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 305925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305930 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 305933 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305937 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 305940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305945 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 305950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 305953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305955 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 305957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305962 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 305965 */     GIR_RootConstrainSelectedInstOperands,
     /* 305966 */     // GIR_Coverage, 6104,
     /* 305966 */     GIR_EraseRootFromParent_Done,
     /* 305967 */   // Label 6185: @305967
     /* 305967 */   GIM_Try, /*On fail goto*//*Label 6186*/ GIMT_Encode4(306066), // Rule ID 6136 //
     /* 305972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 305983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 306000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 306004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 306009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306013 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306015 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 306018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 306022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306027 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306030 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306034 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 306037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 306047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 306050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306052 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 306058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306064 */     GIR_RootConstrainSelectedInstOperands,
     /* 306065 */     // GIR_Coverage, 6136,
     /* 306065 */     GIR_EraseRootFromParent_Done,
     /* 306066 */   // Label 6186: @306066
     /* 306066 */   GIM_Try, /*On fail goto*//*Label 6187*/ GIMT_Encode4(306162), // Rule ID 6040 //
     /* 306071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306090 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 306094 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 306098 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 306102 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 306107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306113 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 306116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 306120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306125 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306132 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 306135 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306140 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 306145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 306148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306154 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306160 */     GIR_RootConstrainSelectedInstOperands,
     /* 306161 */     // GIR_Coverage, 6040,
     /* 306161 */     GIR_EraseRootFromParent_Done,
     /* 306162 */   // Label 6187: @306162
     /* 306162 */   GIM_Try, /*On fail goto*//*Label 6188*/ GIMT_Encode4(306246), // Rule ID 2528 //
     /* 306167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 306178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306182 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 306187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306191 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306197 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306197 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 306200 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 306204 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306209 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306212 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306216 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 306219 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306224 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 306229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 306232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306238 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306244 */     GIR_RootConstrainSelectedInstOperands,
     /* 306245 */     // GIR_Coverage, 2528,
     /* 306245 */     GIR_EraseRootFromParent_Done,
     /* 306246 */   // Label 6188: @306246
     /* 306246 */   GIM_Try, /*On fail goto*//*Label 6189*/ GIMT_Encode4(306296), // Rule ID 13264 //
     /* 306251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306262 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306275 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306281 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 306281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 306284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306294 */     GIR_RootConstrainSelectedInstOperands,
     /* 306295 */     // GIR_Coverage, 13264,
     /* 306295 */     GIR_EraseRootFromParent_Done,
     /* 306296 */   // Label 6189: @306296
     /* 306296 */   GIM_Try, /*On fail goto*//*Label 6190*/ GIMT_Encode4(306380), // Rule ID 6008 //
     /* 306301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306304 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 306316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 306325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306331 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 306331 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 306334 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 306338 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306343 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 306346 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306350 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 306353 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 306363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 306366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 306378 */     GIR_RootConstrainSelectedInstOperands,
     /* 306379 */     // GIR_Coverage, 6008,
     /* 306379 */     GIR_EraseRootFromParent_Done,
     /* 306380 */   // Label 6190: @306380
     /* 306380 */   GIM_Try, /*On fail goto*//*Label 6191*/ GIMT_Encode4(306430), // Rule ID 1306 //
     /* 306385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306415 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 306415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 306418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306428 */     GIR_RootConstrainSelectedInstOperands,
     /* 306429 */     // GIR_Coverage, 1306,
     /* 306429 */     GIR_EraseRootFromParent_Done,
     /* 306430 */   // Label 6191: @306430
     /* 306430 */   GIM_Try, /*On fail goto*//*Label 6192*/ GIMT_Encode4(306463), // Rule ID 1296 //
     /* 306435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306450 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 306450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 306453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 306455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 306457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 306461 */     GIR_RootConstrainSelectedInstOperands,
     /* 306462 */     // GIR_Coverage, 1296,
     /* 306462 */     GIR_EraseRootFromParent_Done,
     /* 306463 */   // Label 6192: @306463
     /* 306463 */   GIM_Reject,
     /* 306464 */ // Label 6177: @306464
     /* 306464 */ GIM_Reject,
     /* 306465 */ // Label 5997: @306465
     /* 306465 */ GIM_Reject,
     /* 306466 */ // Label 61: @306466
     /* 306466 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6201*/ GIMT_Encode4(307081),
     /* 306477 */ /*GILLT_s16*//*Label 6193*/ GIMT_Encode4(306517),
     /* 306481 */ /*GILLT_s32*//*Label 6194*/ GIMT_Encode4(306555),
     /* 306485 */ /*GILLT_s64*//*Label 6195*/ GIMT_Encode4(306593), GIMT_Encode4(0),
     /* 306493 */ /*GILLT_v2s32*//*Label 6196*/ GIMT_Encode4(306631),
     /* 306497 */ /*GILLT_v2s64*//*Label 6197*/ GIMT_Encode4(306669),
     /* 306501 */ /*GILLT_v4s16*//*Label 6198*/ GIMT_Encode4(306707),
     /* 306505 */ /*GILLT_v4s32*//*Label 6199*/ GIMT_Encode4(306745), GIMT_Encode4(0),
     /* 306513 */ /*GILLT_v8s16*//*Label 6200*/ GIMT_Encode4(306783),
     /* 306517 */ // Label 6193: @306517
     /* 306517 */ GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(306554), // Rule ID 590 //
     /* 306522 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306525 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 306528 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 306531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306539 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306543 */   // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 306543 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 306548 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306552 */   GIR_RootConstrainSelectedInstOperands,
     /* 306553 */   // GIR_Coverage, 590,
     /* 306553 */   GIR_Done,
     /* 306554 */ // Label 6202: @306554
     /* 306554 */ GIM_Reject,
     /* 306555 */ // Label 6194: @306555
     /* 306555 */ GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(306592), // Rule ID 592 //
     /* 306560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306566 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 306569 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306573 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306577 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306581 */   // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 306581 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 306586 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306590 */   GIR_RootConstrainSelectedInstOperands,
     /* 306591 */   // GIR_Coverage, 592,
     /* 306591 */   GIR_Done,
     /* 306592 */ // Label 6203: @306592
     /* 306592 */ GIM_Reject,
     /* 306593 */ // Label 6195: @306593
     /* 306593 */ GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(306630), // Rule ID 594 //
     /* 306598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 306607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306611 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306615 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306619 */   // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 306619 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 306624 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306628 */   GIR_RootConstrainSelectedInstOperands,
     /* 306629 */   // GIR_Coverage, 594,
     /* 306629 */   GIR_Done,
     /* 306630 */ // Label 6204: @306630
     /* 306630 */ GIM_Reject,
     /* 306631 */ // Label 6196: @306631
     /* 306631 */ GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(306668), // Rule ID 1228 //
     /* 306636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 306642 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 306645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306653 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306657 */   // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 306657 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 306662 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306666 */   GIR_RootConstrainSelectedInstOperands,
     /* 306667 */   // GIR_Coverage, 1228,
     /* 306667 */   GIR_Done,
     /* 306668 */ // Label 6205: @306668
     /* 306668 */ GIM_Reject,
     /* 306669 */ // Label 6197: @306669
     /* 306669 */ GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(306706), // Rule ID 1232 //
     /* 306674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 306683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306695 */   // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 306695 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 306700 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306704 */   GIR_RootConstrainSelectedInstOperands,
     /* 306705 */   // GIR_Coverage, 1232,
     /* 306705 */   GIR_Done,
     /* 306706 */ // Label 6206: @306706
     /* 306706 */ GIM_Reject,
     /* 306707 */ // Label 6198: @306707
     /* 306707 */ GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(306744), // Rule ID 1224 //
     /* 306712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 306718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 306721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306729 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306733 */   // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 306733 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 306738 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306742 */   GIR_RootConstrainSelectedInstOperands,
     /* 306743 */   // GIR_Coverage, 1224,
     /* 306743 */   GIR_Done,
     /* 306744 */ // Label 6207: @306744
     /* 306744 */ GIM_Reject,
     /* 306745 */ // Label 6199: @306745
     /* 306745 */ GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(306782), // Rule ID 1230 //
     /* 306750 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 306759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306763 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306767 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306771 */   // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 306771 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 306776 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306780 */   GIR_RootConstrainSelectedInstOperands,
     /* 306781 */   // GIR_Coverage, 1230,
     /* 306781 */   GIR_Done,
     /* 306782 */ // Label 6208: @306782
     /* 306782 */ GIM_Reject,
     /* 306783 */ // Label 6200: @306783
     /* 306783 */ GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(307080),
     /* 306788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 306794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306802 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306806 */   GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(306825), // Rule ID 1226 //
     /* 306811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306814 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 306814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 306819 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306823 */     GIR_RootConstrainSelectedInstOperands,
     /* 306824 */     // GIR_Coverage, 1226,
     /* 306824 */     GIR_Done,
     /* 306825 */   // Label 6210: @306825
     /* 306825 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(307079), // Rule ID 6979 //
     /* 306830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 306833 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 306833 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 306836 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 306840 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306845 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 306849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 306851 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 306854 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 306858 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306863 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 306867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 306869 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 306872 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 306876 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306881 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 306884 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 306887 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 306889 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 306892 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306896 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306901 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 306907 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306912 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306917 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 306920 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 306924 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306929 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 306932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 306934 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 306937 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306941 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306946 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 306952 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306957 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306962 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 306965 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 306969 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306974 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 306977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 306979 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 306982 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 306986 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306991 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 306994 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 306997 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 306999 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 307002 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 307006 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307011 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 307014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 307016 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 307019 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307023 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 307033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307042 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307045 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 307048 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 307051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 307069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 307071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307074 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 307077 */     GIR_RootConstrainSelectedInstOperands,
     /* 307078 */     // GIR_Coverage, 6979,
     /* 307078 */     GIR_EraseRootFromParent_Done,
     /* 307079 */   // Label 6211: @307079
     /* 307079 */   GIM_Reject,
     /* 307080 */ // Label 6209: @307080
     /* 307080 */ GIM_Reject,
     /* 307081 */ // Label 6201: @307081
     /* 307081 */ GIM_Reject,
     /* 307082 */ // Label 62: @307082
     /* 307082 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6220*/ GIMT_Encode4(310588),
     /* 307093 */ /*GILLT_s16*//*Label 6212*/ GIMT_Encode4(307133),
     /* 307097 */ /*GILLT_s32*//*Label 6213*/ GIMT_Encode4(308301),
     /* 307101 */ /*GILLT_s64*//*Label 6214*/ GIMT_Encode4(309324), GIMT_Encode4(0),
     /* 307109 */ /*GILLT_v2s32*//*Label 6215*/ GIMT_Encode4(310347),
     /* 307113 */ /*GILLT_v2s64*//*Label 6216*/ GIMT_Encode4(310374),
     /* 307117 */ /*GILLT_v4s16*//*Label 6217*/ GIMT_Encode4(310401),
     /* 307121 */ /*GILLT_v4s32*//*Label 6218*/ GIMT_Encode4(310481), GIMT_Encode4(0),
     /* 307129 */ /*GILLT_v8s16*//*Label 6219*/ GIMT_Encode4(310508),
     /* 307133 */ // Label 6212: @307133
     /* 307133 */ GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(308300),
     /* 307138 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 307141 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307145 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(307303), // Rule ID 4833 //
     /* 307150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 307161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307165 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307169 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307194 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307198 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 307202 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307206 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307210 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 307214 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307219 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 307223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307228 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307230 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 307230 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 307233 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307237 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307242 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 307248 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307253 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307270 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 307276 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307281 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 307297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307301 */     GIR_RootConstrainSelectedInstOperands,
     /* 307302 */     // GIR_Coverage, 4833,
     /* 307302 */     GIR_EraseRootFromParent_Done,
     /* 307303 */   // Label 6222: @307303
     /* 307303 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(307461), // Rule ID 4832 //
     /* 307308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 307319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307327 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307343 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307352 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 307360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307364 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307368 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 307372 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307377 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 307381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307386 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307388 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 307388 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 307391 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307395 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307400 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 307406 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307411 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307416 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307419 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307423 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307428 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 307434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307452 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 307455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307459 */     GIR_RootConstrainSelectedInstOperands,
     /* 307460 */     // GIR_Coverage, 4832,
     /* 307460 */     GIR_EraseRootFromParent_Done,
     /* 307461 */   // Label 6223: @307461
     /* 307461 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(307572), // Rule ID 4831 //
     /* 307466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 307477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307485 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307497 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307501 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307510 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307524 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307526 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 307526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307538 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 307544 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307549 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307559 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307570 */     GIR_RootConstrainSelectedInstOperands,
     /* 307571 */     // GIR_Coverage, 4831,
     /* 307571 */     GIR_EraseRootFromParent_Done,
     /* 307572 */   // Label 6224: @307572
     /* 307572 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(307683), // Rule ID 4829 //
     /* 307577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 307588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307592 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307596 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307626 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307637 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 307637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307649 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 307655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307681 */     GIR_RootConstrainSelectedInstOperands,
     /* 307682 */     // GIR_Coverage, 4829,
     /* 307682 */     GIR_EraseRootFromParent_Done,
     /* 307683 */   // Label 6225: @307683
     /* 307683 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(307794), // Rule ID 4830 //
     /* 307688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 307699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307707 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307727 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307732 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307741 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307748 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 307748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307760 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 307766 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307771 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307788 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307792 */     GIR_RootConstrainSelectedInstOperands,
     /* 307793 */     // GIR_Coverage, 4830,
     /* 307793 */     GIR_EraseRootFromParent_Done,
     /* 307794 */   // Label 6226: @307794
     /* 307794 */   GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(307905), // Rule ID 4828 //
     /* 307799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 307810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307818 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 307839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307848 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 307852 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307859 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 307859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 307862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307871 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 307877 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307882 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307896 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307903 */     GIR_RootConstrainSelectedInstOperands,
     /* 307904 */     // GIR_Coverage, 4828,
     /* 307904 */     GIR_EraseRootFromParent_Done,
     /* 307905 */   // Label 6227: @307905
     /* 307905 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(307969), // Rule ID 650 //
     /* 307910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 307921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307929 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 307948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307950 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 307950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 307953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 307959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 307963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 307967 */     GIR_RootConstrainSelectedInstOperands,
     /* 307968 */     // GIR_Coverage, 650,
     /* 307968 */     GIR_EraseRootFromParent_Done,
     /* 307969 */   // Label 6228: @307969
     /* 307969 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(308033), // Rule ID 649 //
     /* 307974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 307977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 307985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 307989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 307993 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 307997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308014 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 308014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 308017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308031 */     GIR_RootConstrainSelectedInstOperands,
     /* 308032 */     // GIR_Coverage, 649,
     /* 308032 */     GIR_EraseRootFromParent_Done,
     /* 308033 */   // Label 6229: @308033
     /* 308033 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(308084), // Rule ID 626 //
     /* 308038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 308049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 308057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308069 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 308069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 308072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308082 */     GIR_RootConstrainSelectedInstOperands,
     /* 308083 */     // GIR_Coverage, 626,
     /* 308083 */     GIR_EraseRootFromParent_Done,
     /* 308084 */   // Label 6230: @308084
     /* 308084 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(308135), // Rule ID 625 //
     /* 308089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 308100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 308104 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 308108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308120 */     // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 308120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 308123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308133 */     GIR_RootConstrainSelectedInstOperands,
     /* 308134 */     // GIR_Coverage, 625,
     /* 308134 */     GIR_EraseRootFromParent_Done,
     /* 308135 */   // Label 6231: @308135
     /* 308135 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(308154), // Rule ID 524 //
     /* 308140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 308143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308147 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 308147 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
     /* 308152 */     GIR_RootConstrainSelectedInstOperands,
     /* 308153 */     // GIR_Coverage, 524,
     /* 308153 */     GIR_Done,
     /* 308154 */   // Label 6232: @308154
     /* 308154 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(308299), // Rule ID 6346 //
     /* 308159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308163 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 308163 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 308166 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308170 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 308177 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 308180 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308184 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308189 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 308192 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 308196 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 308199 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308204 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308209 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308214 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 308217 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308221 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308226 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 308229 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 308234 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 308237 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /* 308241 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308246 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 308249 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 308254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308268 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308271 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 308281 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 308288 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 308293 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308298 */     // GIR_Coverage, 6346,
     /* 308298 */     GIR_EraseRootFromParent_Done,
     /* 308299 */   // Label 6233: @308299
     /* 308299 */   GIM_Reject,
     /* 308300 */ // Label 6221: @308300
     /* 308300 */ GIM_Reject,
     /* 308301 */ // Label 6213: @308301
     /* 308301 */ GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(309323),
     /* 308306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 308309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308313 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(308471), // Rule ID 4839 //
     /* 308318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 308329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308337 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308353 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308362 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308366 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 308370 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308374 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308378 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 308382 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308387 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 308391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308396 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308398 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 308398 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 308401 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308405 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308410 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 308416 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308421 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308438 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 308444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308449 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 308465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308469 */     GIR_RootConstrainSelectedInstOperands,
     /* 308470 */     // GIR_Coverage, 4839,
     /* 308470 */     GIR_EraseRootFromParent_Done,
     /* 308471 */   // Label 6235: @308471
     /* 308471 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(308629), // Rule ID 4838 //
     /* 308476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 308487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308495 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308511 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308515 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308520 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 308528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308532 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308536 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 308540 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308545 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 308549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308556 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 308556 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 308559 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308563 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308568 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 308574 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308579 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308596 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 308602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 308623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308627 */     GIR_RootConstrainSelectedInstOperands,
     /* 308628 */     // GIR_Coverage, 4838,
     /* 308628 */     GIR_EraseRootFromParent_Done,
     /* 308629 */   // Label 6236: @308629
     /* 308629 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(308740), // Rule ID 4837 //
     /* 308634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 308645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308653 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308669 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308673 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308678 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308694 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 308694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308706 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 308712 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308717 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308727 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308738 */     GIR_RootConstrainSelectedInstOperands,
     /* 308739 */     // GIR_Coverage, 4837,
     /* 308739 */     GIR_EraseRootFromParent_Done,
     /* 308740 */   // Label 6237: @308740
     /* 308740 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(308851), // Rule ID 4835 //
     /* 308745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 308756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308764 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308785 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308789 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308794 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308805 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 308805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308817 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 308823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 308842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308849 */     GIR_RootConstrainSelectedInstOperands,
     /* 308850 */     // GIR_Coverage, 4835,
     /* 308850 */     GIR_EraseRootFromParent_Done,
     /* 308851 */   // Label 6238: @308851
     /* 308851 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(308962), // Rule ID 4836 //
     /* 308856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 308867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308875 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 308887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308900 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 308904 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308916 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 308916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 308919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 308923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308928 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 308934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 308947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 308956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 308960 */     GIR_RootConstrainSelectedInstOperands,
     /* 308961 */     // GIR_Coverage, 4836,
     /* 308961 */     GIR_EraseRootFromParent_Done,
     /* 308962 */   // Label 6239: @308962
     /* 308962 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(309073), // Rule ID 4834 //
     /* 308967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 308970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 308978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 308986 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 308990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308995 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308999 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309003 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 309007 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309011 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309016 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309025 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309027 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 309027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 309030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309039 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 309045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 309058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309064 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309071 */     GIR_RootConstrainSelectedInstOperands,
     /* 309072 */     // GIR_Coverage, 4834,
     /* 309072 */     GIR_EraseRootFromParent_Done,
     /* 309073 */   // Label 6240: @309073
     /* 309073 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(309137), // Rule ID 652 //
     /* 309078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 309093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 309097 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 309101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309118 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 309118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 309121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309135 */     GIR_RootConstrainSelectedInstOperands,
     /* 309136 */     // GIR_Coverage, 652,
     /* 309136 */     GIR_EraseRootFromParent_Done,
     /* 309137 */   // Label 6241: @309137
     /* 309137 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(309201), // Rule ID 651 //
     /* 309142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 309157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 309161 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 309165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309180 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309182 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 309182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 309185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309199 */     GIR_RootConstrainSelectedInstOperands,
     /* 309200 */     // GIR_Coverage, 651,
     /* 309200 */     GIR_EraseRootFromParent_Done,
     /* 309201 */   // Label 6242: @309201
     /* 309201 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(309252), // Rule ID 628 //
     /* 309206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 309217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 309221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 309225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309237 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 309237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 309240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309250 */     GIR_RootConstrainSelectedInstOperands,
     /* 309251 */     // GIR_Coverage, 628,
     /* 309251 */     GIR_EraseRootFromParent_Done,
     /* 309252 */   // Label 6243: @309252
     /* 309252 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(309303), // Rule ID 627 //
     /* 309257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 309268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 309272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 309276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 309288 */     // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 309288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 309291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309301 */     GIR_RootConstrainSelectedInstOperands,
     /* 309302 */     // GIR_Coverage, 627,
     /* 309302 */     GIR_EraseRootFromParent_Done,
     /* 309303 */   // Label 6244: @309303
     /* 309303 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(309322), // Rule ID 525 //
     /* 309308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309315 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 309315 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
     /* 309320 */     GIR_RootConstrainSelectedInstOperands,
     /* 309321 */     // GIR_Coverage, 525,
     /* 309321 */     GIR_Done,
     /* 309322 */   // Label 6245: @309322
     /* 309322 */   GIM_Reject,
     /* 309323 */ // Label 6234: @309323
     /* 309323 */ GIM_Reject,
     /* 309324 */ // Label 6214: @309324
     /* 309324 */ GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(310346),
     /* 309329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 309332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309336 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(309494), // Rule ID 4845 //
     /* 309341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309356 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309360 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309385 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 309393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309397 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309401 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309405 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309410 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 309414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309419 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309421 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 309421 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309424 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309428 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309433 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 309439 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309444 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309461 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309492 */     GIR_RootConstrainSelectedInstOperands,
     /* 309493 */     // GIR_Coverage, 4845,
     /* 309493 */     GIR_EraseRootFromParent_Done,
     /* 309494 */   // Label 6247: @309494
     /* 309494 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(309652), // Rule ID 4844 //
     /* 309499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309518 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309543 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 309551 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309555 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309559 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309563 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309568 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 309572 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309577 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309579 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 309579 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 309582 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309586 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309591 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 309597 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309602 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309607 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309610 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309614 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309619 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309625 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309630 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309640 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309650 */     GIR_RootConstrainSelectedInstOperands,
     /* 309651 */     // GIR_Coverage, 4844,
     /* 309651 */     GIR_EraseRootFromParent_Done,
     /* 309652 */   // Label 6248: @309652
     /* 309652 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(309763), // Rule ID 4843 //
     /* 309657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309676 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309701 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309710 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309715 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309717 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 309717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309729 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309735 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309740 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309761 */     GIR_RootConstrainSelectedInstOperands,
     /* 309762 */     // GIR_Coverage, 4843,
     /* 309762 */     GIR_EraseRootFromParent_Done,
     /* 309763 */   // Label 6249: @309763
     /* 309763 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(309874), // Rule ID 4841 //
     /* 309768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 309779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309787 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309817 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309826 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309828 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 309828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309840 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 309846 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309851 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 309865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309872 */     GIR_RootConstrainSelectedInstOperands,
     /* 309873 */     // GIR_Coverage, 4841,
     /* 309873 */     GIR_EraseRootFromParent_Done,
     /* 309874 */   // Label 6250: @309874
     /* 309874 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(309985), // Rule ID 4842 //
     /* 309879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 309890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 309894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309898 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 309902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 309914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309923 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309937 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309939 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 309939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 309942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309951 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 309970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 309979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 309983 */     GIR_RootConstrainSelectedInstOperands,
     /* 309984 */     // GIR_Coverage, 4842,
     /* 309984 */     GIR_EraseRootFromParent_Done,
     /* 309985 */   // Label 6251: @309985
     /* 309985 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(310096), // Rule ID 4840 //
     /* 309990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 309993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 310001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310009 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 310013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 310022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310030 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310034 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310039 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310050 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 310050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 310053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310062 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 310068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 310081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310094 */     GIR_RootConstrainSelectedInstOperands,
     /* 310095 */     // GIR_Coverage, 4840,
     /* 310095 */     GIR_EraseRootFromParent_Done,
     /* 310096 */   // Label 6252: @310096
     /* 310096 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(310160), // Rule ID 654 //
     /* 310101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 310112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310116 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310120 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 310124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310134 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310141 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 310141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 310144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310158 */     GIR_RootConstrainSelectedInstOperands,
     /* 310159 */     // GIR_Coverage, 654,
     /* 310159 */     GIR_EraseRootFromParent_Done,
     /* 310160 */   // Label 6253: @310160
     /* 310160 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(310224), // Rule ID 653 //
     /* 310165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 310176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310184 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 310188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310198 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310205 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 310205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 310208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 310222 */     GIR_RootConstrainSelectedInstOperands,
     /* 310223 */     // GIR_Coverage, 653,
     /* 310223 */     GIR_EraseRootFromParent_Done,
     /* 310224 */   // Label 6254: @310224
     /* 310224 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(310275), // Rule ID 630 //
     /* 310229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 310240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310258 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310260 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 310260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 310263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310273 */     GIR_RootConstrainSelectedInstOperands,
     /* 310274 */     // GIR_Coverage, 630,
     /* 310274 */     GIR_EraseRootFromParent_Done,
     /* 310275 */   // Label 6255: @310275
     /* 310275 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(310326), // Rule ID 629 //
     /* 310280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 310291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 310295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310299 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310304 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310309 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 310311 */     // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 310311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 310314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 310320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 310324 */     GIR_RootConstrainSelectedInstOperands,
     /* 310325 */     // GIR_Coverage, 629,
     /* 310325 */     GIR_EraseRootFromParent_Done,
     /* 310326 */   // Label 6256: @310326
     /* 310326 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(310345), // Rule ID 526 //
     /* 310331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310338 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 310338 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
     /* 310343 */     GIR_RootConstrainSelectedInstOperands,
     /* 310344 */     // GIR_Coverage, 526,
     /* 310344 */     GIR_Done,
     /* 310345 */   // Label 6257: @310345
     /* 310345 */   GIM_Reject,
     /* 310346 */ // Label 6246: @310346
     /* 310346 */ GIM_Reject,
     /* 310347 */ // Label 6215: @310347
     /* 310347 */ GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(310373), // Rule ID 860 //
     /* 310352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 310355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 310358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310362 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310366 */   // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 310366 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
     /* 310371 */   GIR_RootConstrainSelectedInstOperands,
     /* 310372 */   // GIR_Coverage, 860,
     /* 310372 */   GIR_Done,
     /* 310373 */ // Label 6258: @310373
     /* 310373 */ GIM_Reject,
     /* 310374 */ // Label 6216: @310374
     /* 310374 */ GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(310400), // Rule ID 862 //
     /* 310379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 310382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310393 */   // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 310393 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
     /* 310398 */   GIR_RootConstrainSelectedInstOperands,
     /* 310399 */   // GIR_Coverage, 862,
     /* 310399 */   GIR_Done,
     /* 310400 */ // Label 6259: @310400
     /* 310400 */ GIM_Reject,
     /* 310401 */ // Label 6217: @310401
     /* 310401 */ GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(310480),
     /* 310406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 310409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310417 */   GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(310432), // Rule ID 858 //
     /* 310422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310425 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 310425 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
     /* 310430 */     GIR_RootConstrainSelectedInstOperands,
     /* 310431 */     // GIR_Coverage, 858,
     /* 310431 */     GIR_Done,
     /* 310432 */   // Label 6261: @310432
     /* 310432 */   GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(310479), // Rule ID 6349 //
     /* 310437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 310440 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 310440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 310443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
     /* 310447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310452 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 310462 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 310465 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /* 310470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310472 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310477 */     GIR_RootConstrainSelectedInstOperands,
     /* 310478 */     // GIR_Coverage, 6349,
     /* 310478 */     GIR_EraseRootFromParent_Done,
     /* 310479 */   // Label 6262: @310479
     /* 310479 */   GIM_Reject,
     /* 310480 */ // Label 6260: @310480
     /* 310480 */ GIM_Reject,
     /* 310481 */ // Label 6218: @310481
     /* 310481 */ GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(310507), // Rule ID 861 //
     /* 310486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 310489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 310492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310500 */   // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 310500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
     /* 310505 */   GIR_RootConstrainSelectedInstOperands,
     /* 310506 */   // GIR_Coverage, 861,
     /* 310506 */   GIR_Done,
     /* 310507 */ // Label 6263: @310507
     /* 310507 */ GIM_Reject,
     /* 310508 */ // Label 6219: @310508
     /* 310508 */ GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(310587),
     /* 310513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310516 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310520 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310524 */   GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(310539), // Rule ID 859 //
     /* 310529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310532 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 310532 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
     /* 310537 */     GIR_RootConstrainSelectedInstOperands,
     /* 310538 */     // GIR_Coverage, 859,
     /* 310538 */     GIR_Done,
     /* 310539 */   // Label 6265: @310539
     /* 310539 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(310586), // Rule ID 6350 //
     /* 310544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 310547 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 310547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 310550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
     /* 310554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310559 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 310569 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 310572 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 310574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /* 310577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 310581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310584 */     GIR_RootConstrainSelectedInstOperands,
     /* 310585 */     // GIR_Coverage, 6350,
     /* 310585 */     GIR_EraseRootFromParent_Done,
     /* 310586 */   // Label 6266: @310586
     /* 310586 */   GIM_Reject,
     /* 310587 */ // Label 6264: @310587
     /* 310587 */ GIM_Reject,
     /* 310588 */ // Label 6220: @310588
     /* 310588 */ GIM_Reject,
     /* 310589 */ // Label 63: @310589
     /* 310589 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(9), /*)*//*default:*//*Label 6271*/ GIMT_Encode4(310836),
     /* 310600 */ /*GILLT_s32*//*Label 6267*/ GIMT_Encode4(310628),
     /* 310604 */ /*GILLT_s64*//*Label 6268*/ GIMT_Encode4(310659), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 310616 */ /*GILLT_v2s64*//*Label 6269*/ GIMT_Encode4(310720), GIMT_Encode4(0),
     /* 310624 */ /*GILLT_v4s32*//*Label 6270*/ GIMT_Encode4(310778),
     /* 310628 */ // Label 6267: @310628
     /* 310628 */ GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(310658), // Rule ID 516 //
     /* 310633 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310647 */   // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
     /* 310647 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
     /* 310652 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310656 */   GIR_RootConstrainSelectedInstOperands,
     /* 310657 */   // GIR_Coverage, 516,
     /* 310657 */   GIR_Done,
     /* 310658 */ // Label 6272: @310658
     /* 310658 */ GIM_Reject,
     /* 310659 */ // Label 6268: @310659
     /* 310659 */ GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(310689), // Rule ID 514 //
     /* 310664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 310670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310678 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
     /* 310678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
     /* 310683 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310687 */   GIR_RootConstrainSelectedInstOperands,
     /* 310688 */   // GIR_Coverage, 514,
     /* 310688 */   GIR_Done,
     /* 310689 */ // Label 6273: @310689
     /* 310689 */ GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(310719), // Rule ID 518 //
     /* 310694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310708 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
     /* 310708 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
     /* 310713 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310717 */   GIR_RootConstrainSelectedInstOperands,
     /* 310718 */   // GIR_Coverage, 518,
     /* 310718 */   GIR_Done,
     /* 310719 */ // Label 6274: @310719
     /* 310719 */ GIM_Reject,
     /* 310720 */ // Label 6269: @310720
     /* 310720 */ GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(310777),
     /* 310725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 310728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310732 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(310756), // Rule ID 4888 //
     /* 310737 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 310744 */     // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
     /* 310744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
     /* 310747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 310754 */     GIR_RootConstrainSelectedInstOperands,
     /* 310755 */     // GIR_Coverage, 4888,
     /* 310755 */     GIR_EraseRootFromParent_Done,
     /* 310756 */   // Label 6276: @310756
     /* 310756 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(310776), // Rule ID 4886 //
     /* 310761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310765 */     // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
     /* 310765 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 310770 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310774 */     GIR_RootConstrainSelectedInstOperands,
     /* 310775 */     // GIR_Coverage, 4886,
     /* 310775 */     GIR_Done,
     /* 310776 */   // Label 6277: @310776
     /* 310776 */   GIM_Reject,
     /* 310777 */ // Label 6275: @310777
     /* 310777 */ GIM_Reject,
     /* 310778 */ // Label 6270: @310778
     /* 310778 */ GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(310835),
     /* 310783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 310786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310790 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(310814), // Rule ID 4892 //
     /* 310795 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 310802 */     // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
     /* 310802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 310805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310807 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 310812 */     GIR_RootConstrainSelectedInstOperands,
     /* 310813 */     // GIR_Coverage, 4892,
     /* 310813 */     GIR_EraseRootFromParent_Done,
     /* 310814 */   // Label 6279: @310814
     /* 310814 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(310834), // Rule ID 4890 //
     /* 310819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310823 */     // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
     /* 310823 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 310828 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310832 */     GIR_RootConstrainSelectedInstOperands,
     /* 310833 */     // GIR_Coverage, 4890,
     /* 310833 */     GIR_Done,
     /* 310834 */   // Label 6280: @310834
     /* 310834 */   GIM_Reject,
     /* 310835 */ // Label 6278: @310835
     /* 310835 */ GIM_Reject,
     /* 310836 */ // Label 6271: @310836
     /* 310836 */ GIM_Reject,
     /* 310837 */ // Label 64: @310837
     /* 310837 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6285*/ GIMT_Encode4(311024),
     /* 310848 */ /*GILLT_s16*//*Label 6281*/ GIMT_Encode4(310876),
     /* 310852 */ /*GILLT_s32*//*Label 6282*/ GIMT_Encode4(310937), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 310864 */ /*GILLT_v2s32*//*Label 6283*/ GIMT_Encode4(310968), GIMT_Encode4(0),
     /* 310872 */ /*GILLT_v4s16*//*Label 6284*/ GIMT_Encode4(310996),
     /* 310876 */ // Label 6281: @310876
     /* 310876 */ GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(310906), // Rule ID 510 //
     /* 310881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310891 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310895 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
     /* 310895 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
     /* 310900 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310904 */   GIR_RootConstrainSelectedInstOperands,
     /* 310905 */   // GIR_Coverage, 510,
     /* 310905 */   GIR_Done,
     /* 310906 */ // Label 6286: @310906
     /* 310906 */ GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(310936), // Rule ID 520 //
     /* 310911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 310917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310925 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
     /* 310925 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
     /* 310930 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310934 */   GIR_RootConstrainSelectedInstOperands,
     /* 310935 */   // GIR_Coverage, 520,
     /* 310935 */   GIR_Done,
     /* 310936 */ // Label 6287: @310936
     /* 310936 */ GIM_Reject,
     /* 310937 */ // Label 6282: @310937
     /* 310937 */ GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(310967), // Rule ID 512 //
     /* 310942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 310945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 310948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 310952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310956 */   // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 310956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
     /* 310961 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310965 */   GIR_RootConstrainSelectedInstOperands,
     /* 310966 */   // GIR_Coverage, 512,
     /* 310966 */   GIR_Done,
     /* 310967 */ // Label 6288: @310967
     /* 310967 */ GIM_Reject,
     /* 310968 */ // Label 6283: @310968
     /* 310968 */ GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(310995), // Rule ID 4896 //
     /* 310973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 310976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 310980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310984 */   // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 310984 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 310989 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 310993 */   GIR_RootConstrainSelectedInstOperands,
     /* 310994 */   // GIR_Coverage, 4896,
     /* 310994 */   GIR_Done,
     /* 310995 */ // Label 6289: @310995
     /* 310995 */ GIM_Reject,
     /* 310996 */ // Label 6284: @310996
     /* 310996 */ GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(311023), // Rule ID 4898 //
     /* 311001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 311004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311012 */   // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
     /* 311012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 311017 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311021 */   GIR_RootConstrainSelectedInstOperands,
     /* 311022 */   // GIR_Coverage, 4898,
     /* 311022 */   GIR_Done,
     /* 311023 */ // Label 6290: @311023
     /* 311023 */ GIM_Reject,
     /* 311024 */ // Label 6285: @311024
     /* 311024 */ GIM_Reject,
     /* 311025 */ // Label 65: @311025
     /* 311025 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6298*/ GIMT_Encode4(312087),
     /* 311036 */ /*GILLT_s32*//*Label 6291*/ GIMT_Encode4(311072),
     /* 311040 */ /*GILLT_s64*//*Label 6292*/ GIMT_Encode4(311459), GIMT_Encode4(0),
     /* 311048 */ /*GILLT_v2s32*//*Label 6293*/ GIMT_Encode4(311846),
     /* 311052 */ /*GILLT_v2s64*//*Label 6294*/ GIMT_Encode4(311920),
     /* 311056 */ /*GILLT_v4s16*//*Label 6295*/ GIMT_Encode4(311994),
     /* 311060 */ /*GILLT_v4s32*//*Label 6296*/ GIMT_Encode4(312025), GIMT_Encode4(0),
     /* 311068 */ /*GILLT_v8s16*//*Label 6297*/ GIMT_Encode4(312056),
     /* 311072 */ // Label 6291: @311072
     /* 311072 */ GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(311109), // Rule ID 4635 //
     /* 311077 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311084 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311088 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 311092 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311096 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311098 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 311098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 311101 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311103 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311107 */   GIR_RootConstrainSelectedInstOperands,
     /* 311108 */   // GIR_Coverage, 4635,
     /* 311108 */   GIR_EraseRootFromParent_Done,
     /* 311109 */ // Label 6299: @311109
     /* 311109 */ GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(311146), // Rule ID 4637 //
     /* 311114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311121 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311125 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 311129 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311133 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311135 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 311135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 311138 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311140 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311144 */   GIR_RootConstrainSelectedInstOperands,
     /* 311145 */   // GIR_Coverage, 4637,
     /* 311145 */   GIR_EraseRootFromParent_Done,
     /* 311146 */ // Label 6300: @311146
     /* 311146 */ GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(311183), // Rule ID 4655 //
     /* 311151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311158 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311162 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 311166 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311170 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311172 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 311172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 311175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311177 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311181 */   GIR_RootConstrainSelectedInstOperands,
     /* 311182 */   // GIR_Coverage, 4655,
     /* 311182 */   GIR_EraseRootFromParent_Done,
     /* 311183 */ // Label 6301: @311183
     /* 311183 */ GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(311220), // Rule ID 4657 //
     /* 311188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311195 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311199 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 311203 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311207 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311209 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 311209 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 311212 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311214 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311218 */   GIR_RootConstrainSelectedInstOperands,
     /* 311219 */   // GIR_Coverage, 4657,
     /* 311219 */   GIR_EraseRootFromParent_Done,
     /* 311220 */ // Label 6302: @311220
     /* 311220 */ GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(311257), // Rule ID 4695 //
     /* 311225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311232 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311236 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 311240 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311244 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311246 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 311246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 311249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311251 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311255 */   GIR_RootConstrainSelectedInstOperands,
     /* 311256 */   // GIR_Coverage, 4695,
     /* 311256 */   GIR_EraseRootFromParent_Done,
     /* 311257 */ // Label 6303: @311257
     /* 311257 */ GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(311294), // Rule ID 4697 //
     /* 311262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311269 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311273 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 311277 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311281 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311283 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 311283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 311286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311288 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311292 */   GIR_RootConstrainSelectedInstOperands,
     /* 311293 */   // GIR_Coverage, 4697,
     /* 311293 */   GIR_EraseRootFromParent_Done,
     /* 311294 */ // Label 6304: @311294
     /* 311294 */ GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(311331), // Rule ID 4675 //
     /* 311299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311306 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311310 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 311314 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311318 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311320 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 311320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 311323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311325 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311329 */   GIR_RootConstrainSelectedInstOperands,
     /* 311330 */   // GIR_Coverage, 4675,
     /* 311330 */   GIR_EraseRootFromParent_Done,
     /* 311331 */ // Label 6305: @311331
     /* 311331 */ GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(311368), // Rule ID 4677 //
     /* 311336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311343 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311347 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 311351 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311355 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311357 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 311357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 311360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311362 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311366 */   GIR_RootConstrainSelectedInstOperands,
     /* 311367 */   // GIR_Coverage, 4677,
     /* 311367 */   GIR_EraseRootFromParent_Done,
     /* 311368 */ // Label 6306: @311368
     /* 311368 */ GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(311398), // Rule ID 395 //
     /* 311373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 311379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311387 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 311387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 311392 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311396 */   GIR_RootConstrainSelectedInstOperands,
     /* 311397 */   // GIR_Coverage, 395,
     /* 311397 */   GIR_Done,
     /* 311398 */ // Label 6307: @311398
     /* 311398 */ GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(311428), // Rule ID 399 //
     /* 311403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311417 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 311417 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 311422 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311426 */   GIR_RootConstrainSelectedInstOperands,
     /* 311427 */   // GIR_Coverage, 399,
     /* 311427 */   GIR_Done,
     /* 311428 */ // Label 6308: @311428
     /* 311428 */ GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(311458), // Rule ID 403 //
     /* 311433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 311443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311447 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 311447 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 311452 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311456 */   GIR_RootConstrainSelectedInstOperands,
     /* 311457 */   // GIR_Coverage, 403,
     /* 311457 */   GIR_Done,
     /* 311458 */ // Label 6309: @311458
     /* 311458 */ GIM_Reject,
     /* 311459 */ // Label 6292: @311459
     /* 311459 */ GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(311496), // Rule ID 4636 //
     /* 311464 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311471 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311475 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 311479 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311483 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311485 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 311485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 311488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311490 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311494 */   GIR_RootConstrainSelectedInstOperands,
     /* 311495 */   // GIR_Coverage, 4636,
     /* 311495 */   GIR_EraseRootFromParent_Done,
     /* 311496 */ // Label 6310: @311496
     /* 311496 */ GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(311533), // Rule ID 4638 //
     /* 311501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311508 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311512 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 311516 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311520 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311522 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 311522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 311525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311527 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311531 */   GIR_RootConstrainSelectedInstOperands,
     /* 311532 */   // GIR_Coverage, 4638,
     /* 311532 */   GIR_EraseRootFromParent_Done,
     /* 311533 */ // Label 6311: @311533
     /* 311533 */ GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(311570), // Rule ID 4656 //
     /* 311538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311545 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311549 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 311553 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311557 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311559 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 311559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 311562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311564 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311568 */   GIR_RootConstrainSelectedInstOperands,
     /* 311569 */   // GIR_Coverage, 4656,
     /* 311569 */   GIR_EraseRootFromParent_Done,
     /* 311570 */ // Label 6312: @311570
     /* 311570 */ GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(311607), // Rule ID 4658 //
     /* 311575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311582 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311586 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 311590 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311594 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311596 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 311596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 311599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311601 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311605 */   GIR_RootConstrainSelectedInstOperands,
     /* 311606 */   // GIR_Coverage, 4658,
     /* 311606 */   GIR_EraseRootFromParent_Done,
     /* 311607 */ // Label 6313: @311607
     /* 311607 */ GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(311644), // Rule ID 4696 //
     /* 311612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311619 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311623 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 311627 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311631 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311633 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 311633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 311636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311638 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311642 */   GIR_RootConstrainSelectedInstOperands,
     /* 311643 */   // GIR_Coverage, 4696,
     /* 311643 */   GIR_EraseRootFromParent_Done,
     /* 311644 */ // Label 6314: @311644
     /* 311644 */ GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(311681), // Rule ID 4698 //
     /* 311649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311656 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311660 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 311664 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311668 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311670 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 311670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 311673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311675 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311679 */   GIR_RootConstrainSelectedInstOperands,
     /* 311680 */   // GIR_Coverage, 4698,
     /* 311680 */   GIR_EraseRootFromParent_Done,
     /* 311681 */ // Label 6315: @311681
     /* 311681 */ GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(311718), // Rule ID 4676 //
     /* 311686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311693 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311697 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 311701 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 311705 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311707 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 311707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 311710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311712 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311716 */   GIR_RootConstrainSelectedInstOperands,
     /* 311717 */   // GIR_Coverage, 4676,
     /* 311717 */   GIR_EraseRootFromParent_Done,
     /* 311718 */ // Label 6316: @311718
     /* 311718 */ GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(311755), // Rule ID 4678 //
     /* 311723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311730 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311734 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 311738 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 311742 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311744 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 311744 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 311747 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311749 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311753 */   GIR_RootConstrainSelectedInstOperands,
     /* 311754 */   // GIR_Coverage, 4678,
     /* 311754 */   GIR_EraseRootFromParent_Done,
     /* 311755 */ // Label 6317: @311755
     /* 311755 */ GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(311785), // Rule ID 397 //
     /* 311760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 311766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311774 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 311774 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 311779 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311783 */   GIR_RootConstrainSelectedInstOperands,
     /* 311784 */   // GIR_Coverage, 397,
     /* 311784 */   GIR_Done,
     /* 311785 */ // Label 6318: @311785
     /* 311785 */ GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(311815), // Rule ID 401 //
     /* 311790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 311796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 311804 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 311804 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 311809 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311813 */   GIR_RootConstrainSelectedInstOperands,
     /* 311814 */   // GIR_Coverage, 401,
     /* 311814 */   GIR_Done,
     /* 311815 */ // Label 6319: @311815
     /* 311815 */ GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(311845), // Rule ID 405 //
     /* 311820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 311823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 311826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 311830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311834 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 311834 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 311839 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311843 */   GIR_RootConstrainSelectedInstOperands,
     /* 311844 */   // GIR_Coverage, 405,
     /* 311844 */   GIR_Done,
     /* 311845 */ // Label 6320: @311845
     /* 311845 */ GIM_Reject,
     /* 311846 */ // Label 6293: @311846
     /* 311846 */ GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(311876), // Rule ID 843 //
     /* 311851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 311857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311865 */   // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 311865 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 311870 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311874 */   GIR_RootConstrainSelectedInstOperands,
     /* 311875 */   // GIR_Coverage, 843,
     /* 311875 */   GIR_Done,
     /* 311876 */ // Label 6321: @311876
     /* 311876 */ GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(311919), // Rule ID 13047 //
     /* 311881 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 311891 */   // (fp_to_sint:{ *:[v2i32] } v2f64:{ *:[v2f64] }:$src)  =>  (XTNv2i32:{ *:[v2i32] } (FCVTZSv2f64:{ *:[f128] } V128:{ *:[v2f64] }:$src))
     /* 311891 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 311894 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 311898 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311903 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 311907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 311909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 311912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311914 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311917 */   GIR_RootConstrainSelectedInstOperands,
     /* 311918 */   // GIR_Coverage, 13047,
     /* 311918 */   GIR_EraseRootFromParent_Done,
     /* 311919 */ // Label 6322: @311919
     /* 311919 */ GIM_Reject,
     /* 311920 */ // Label 6294: @311920
     /* 311920 */ GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(311950), // Rule ID 847 //
     /* 311925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 311931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311939 */   // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 311939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 311944 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 311948 */   GIR_RootConstrainSelectedInstOperands,
     /* 311949 */   // GIR_Coverage, 847,
     /* 311949 */   GIR_Done,
     /* 311950 */ // Label 6323: @311950
     /* 311950 */ GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(311993), // Rule ID 13045 //
     /* 311955 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 311958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 311961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311965 */   // (fp_to_sint:{ *:[v2i64] } v2f32:{ *:[v2f32] }:$src)  =>  (FCVTZSv2f64:{ *:[v2i64] } (FCVTLv2i32:{ *:[f128] } V64:{ *:[v2f32] }:$src))
     /* 311965 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 311968 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 311972 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311977 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 311981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 311983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 311986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311988 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311991 */   GIR_RootConstrainSelectedInstOperands,
     /* 311992 */   // GIR_Coverage, 13045,
     /* 311992 */   GIR_EraseRootFromParent_Done,
     /* 311993 */ // Label 6324: @311993
     /* 311993 */ GIM_Reject,
     /* 311994 */ // Label 6295: @311994
     /* 311994 */ GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(312024), // Rule ID 839 //
     /* 311999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 312005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312013 */   // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 312013 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 312018 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312022 */   GIR_RootConstrainSelectedInstOperands,
     /* 312023 */   // GIR_Coverage, 839,
     /* 312023 */   GIR_Done,
     /* 312024 */ // Label 6325: @312024
     /* 312024 */ GIM_Reject,
     /* 312025 */ // Label 6296: @312025
     /* 312025 */ GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(312055), // Rule ID 845 //
     /* 312030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312044 */   // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 312044 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 312049 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312053 */   GIR_RootConstrainSelectedInstOperands,
     /* 312054 */   // GIR_Coverage, 845,
     /* 312054 */   GIR_Done,
     /* 312055 */ // Label 6326: @312055
     /* 312055 */ GIM_Reject,
     /* 312056 */ // Label 6297: @312056
     /* 312056 */ GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(312086), // Rule ID 841 //
     /* 312061 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312071 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312075 */   // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 312075 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 312080 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312084 */   GIR_RootConstrainSelectedInstOperands,
     /* 312085 */   // GIR_Coverage, 841,
     /* 312085 */   GIR_Done,
     /* 312086 */ // Label 6327: @312086
     /* 312086 */ GIM_Reject,
     /* 312087 */ // Label 6298: @312087
     /* 312087 */ GIM_Reject,
     /* 312088 */ // Label 66: @312088
     /* 312088 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6335*/ GIMT_Encode4(313150),
     /* 312099 */ /*GILLT_s32*//*Label 6328*/ GIMT_Encode4(312135),
     /* 312103 */ /*GILLT_s64*//*Label 6329*/ GIMT_Encode4(312522), GIMT_Encode4(0),
     /* 312111 */ /*GILLT_v2s32*//*Label 6330*/ GIMT_Encode4(312909),
     /* 312115 */ /*GILLT_v2s64*//*Label 6331*/ GIMT_Encode4(312983),
     /* 312119 */ /*GILLT_v4s16*//*Label 6332*/ GIMT_Encode4(313057),
     /* 312123 */ /*GILLT_v4s32*//*Label 6333*/ GIMT_Encode4(313088), GIMT_Encode4(0),
     /* 312131 */ /*GILLT_v8s16*//*Label 6334*/ GIMT_Encode4(313119),
     /* 312135 */ // Label 6328: @312135
     /* 312135 */ GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(312172), // Rule ID 4645 //
     /* 312140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312147 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312151 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 312155 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312159 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312161 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 312161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 312164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312166 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312170 */   GIR_RootConstrainSelectedInstOperands,
     /* 312171 */   // GIR_Coverage, 4645,
     /* 312171 */   GIR_EraseRootFromParent_Done,
     /* 312172 */ // Label 6336: @312172
     /* 312172 */ GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(312209), // Rule ID 4647 //
     /* 312177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312184 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312188 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 312192 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312196 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312198 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 312198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 312201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312203 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312207 */   GIR_RootConstrainSelectedInstOperands,
     /* 312208 */   // GIR_Coverage, 4647,
     /* 312208 */   GIR_EraseRootFromParent_Done,
     /* 312209 */ // Label 6337: @312209
     /* 312209 */ GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(312246), // Rule ID 4665 //
     /* 312214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312221 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312225 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 312229 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312233 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312235 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 312235 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 312238 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312240 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312244 */   GIR_RootConstrainSelectedInstOperands,
     /* 312245 */   // GIR_Coverage, 4665,
     /* 312245 */   GIR_EraseRootFromParent_Done,
     /* 312246 */ // Label 6338: @312246
     /* 312246 */ GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(312283), // Rule ID 4667 //
     /* 312251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312258 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312262 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 312266 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312270 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312272 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 312272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 312275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312277 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312281 */   GIR_RootConstrainSelectedInstOperands,
     /* 312282 */   // GIR_Coverage, 4667,
     /* 312282 */   GIR_EraseRootFromParent_Done,
     /* 312283 */ // Label 6339: @312283
     /* 312283 */ GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(312320), // Rule ID 4705 //
     /* 312288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312295 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312299 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 312303 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312307 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312309 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 312309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 312312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312314 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312318 */   GIR_RootConstrainSelectedInstOperands,
     /* 312319 */   // GIR_Coverage, 4705,
     /* 312319 */   GIR_EraseRootFromParent_Done,
     /* 312320 */ // Label 6340: @312320
     /* 312320 */ GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(312357), // Rule ID 4707 //
     /* 312325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312332 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312336 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 312340 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312344 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312346 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 312346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 312349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312351 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312355 */   GIR_RootConstrainSelectedInstOperands,
     /* 312356 */   // GIR_Coverage, 4707,
     /* 312356 */   GIR_EraseRootFromParent_Done,
     /* 312357 */ // Label 6341: @312357
     /* 312357 */ GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(312394), // Rule ID 4685 //
     /* 312362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312365 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312369 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312373 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 312377 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312381 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312383 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 312383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 312386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312388 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312392 */   GIR_RootConstrainSelectedInstOperands,
     /* 312393 */   // GIR_Coverage, 4685,
     /* 312393 */   GIR_EraseRootFromParent_Done,
     /* 312394 */ // Label 6342: @312394
     /* 312394 */ GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(312431), // Rule ID 4687 //
     /* 312399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312406 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312410 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 312414 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312418 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312420 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 312420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 312423 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312425 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312429 */   GIR_RootConstrainSelectedInstOperands,
     /* 312430 */   // GIR_Coverage, 4687,
     /* 312430 */   GIR_EraseRootFromParent_Done,
     /* 312431 */ // Label 6343: @312431
     /* 312431 */ GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(312461), // Rule ID 407 //
     /* 312436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 312442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312450 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 312450 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 312455 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312459 */   GIR_RootConstrainSelectedInstOperands,
     /* 312460 */   // GIR_Coverage, 407,
     /* 312460 */   GIR_Done,
     /* 312461 */ // Label 6344: @312461
     /* 312461 */ GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(312491), // Rule ID 411 //
     /* 312466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312480 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 312480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 312485 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312489 */   GIR_RootConstrainSelectedInstOperands,
     /* 312490 */   // GIR_Coverage, 411,
     /* 312490 */   GIR_Done,
     /* 312491 */ // Label 6345: @312491
     /* 312491 */ GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(312521), // Rule ID 415 //
     /* 312496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 312506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312510 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 312510 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 312515 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312519 */   GIR_RootConstrainSelectedInstOperands,
     /* 312520 */   // GIR_Coverage, 415,
     /* 312520 */   GIR_Done,
     /* 312521 */ // Label 6346: @312521
     /* 312521 */ GIM_Reject,
     /* 312522 */ // Label 6329: @312522
     /* 312522 */ GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(312559), // Rule ID 4646 //
     /* 312527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312534 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312538 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 312542 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312546 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312548 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 312548 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 312551 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312553 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312557 */   GIR_RootConstrainSelectedInstOperands,
     /* 312558 */   // GIR_Coverage, 4646,
     /* 312558 */   GIR_EraseRootFromParent_Done,
     /* 312559 */ // Label 6347: @312559
     /* 312559 */ GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(312596), // Rule ID 4648 //
     /* 312564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312571 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312575 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 312579 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312583 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312585 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 312585 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 312588 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312590 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312594 */   GIR_RootConstrainSelectedInstOperands,
     /* 312595 */   // GIR_Coverage, 4648,
     /* 312595 */   GIR_EraseRootFromParent_Done,
     /* 312596 */ // Label 6348: @312596
     /* 312596 */ GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(312633), // Rule ID 4666 //
     /* 312601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312608 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312612 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 312616 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312620 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312622 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 312622 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 312625 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312627 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312631 */   GIR_RootConstrainSelectedInstOperands,
     /* 312632 */   // GIR_Coverage, 4666,
     /* 312632 */   GIR_EraseRootFromParent_Done,
     /* 312633 */ // Label 6349: @312633
     /* 312633 */ GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(312670), // Rule ID 4668 //
     /* 312638 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312645 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312649 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 312653 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312657 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312659 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 312659 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 312662 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312664 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312668 */   GIR_RootConstrainSelectedInstOperands,
     /* 312669 */   // GIR_Coverage, 4668,
     /* 312669 */   GIR_EraseRootFromParent_Done,
     /* 312670 */ // Label 6350: @312670
     /* 312670 */ GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(312707), // Rule ID 4706 //
     /* 312675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312682 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312686 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 312690 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312694 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312696 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 312696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 312699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312701 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312705 */   GIR_RootConstrainSelectedInstOperands,
     /* 312706 */   // GIR_Coverage, 4706,
     /* 312706 */   GIR_EraseRootFromParent_Done,
     /* 312707 */ // Label 6351: @312707
     /* 312707 */ GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(312744), // Rule ID 4708 //
     /* 312712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312719 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312723 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 312727 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312731 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312733 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 312733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 312736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312738 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312742 */   GIR_RootConstrainSelectedInstOperands,
     /* 312743 */   // GIR_Coverage, 4708,
     /* 312743 */   GIR_EraseRootFromParent_Done,
     /* 312744 */ // Label 6352: @312744
     /* 312744 */ GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(312781), // Rule ID 4686 //
     /* 312749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312756 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312760 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 312764 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312768 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312770 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 312770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 312773 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312775 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312779 */   GIR_RootConstrainSelectedInstOperands,
     /* 312780 */   // GIR_Coverage, 4686,
     /* 312780 */   GIR_EraseRootFromParent_Done,
     /* 312781 */ // Label 6353: @312781
     /* 312781 */ GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(312818), // Rule ID 4688 //
     /* 312786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312793 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312797 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 312801 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 312805 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312807 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 312807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 312810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312812 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312816 */   GIR_RootConstrainSelectedInstOperands,
     /* 312817 */   // GIR_Coverage, 4688,
     /* 312817 */   GIR_EraseRootFromParent_Done,
     /* 312818 */ // Label 6354: @312818
     /* 312818 */ GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(312848), // Rule ID 409 //
     /* 312823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 312829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312833 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312837 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 312837 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 312842 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312846 */   GIR_RootConstrainSelectedInstOperands,
     /* 312847 */   // GIR_Coverage, 409,
     /* 312847 */   GIR_Done,
     /* 312848 */ // Label 6355: @312848
     /* 312848 */ GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(312878), // Rule ID 413 //
     /* 312853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312863 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312867 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 312867 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 312872 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312876 */   GIR_RootConstrainSelectedInstOperands,
     /* 312877 */   // GIR_Coverage, 413,
     /* 312877 */   GIR_Done,
     /* 312878 */ // Label 6356: @312878
     /* 312878 */ GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(312908), // Rule ID 417 //
     /* 312883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 312889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 312893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312897 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 312897 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 312902 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312906 */   GIR_RootConstrainSelectedInstOperands,
     /* 312907 */   // GIR_Coverage, 417,
     /* 312907 */   GIR_Done,
     /* 312908 */ // Label 6357: @312908
     /* 312908 */ GIM_Reject,
     /* 312909 */ // Label 6330: @312909
     /* 312909 */ GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(312939), // Rule ID 853 //
     /* 312914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 312920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312928 */   // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 312928 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 312933 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312937 */   GIR_RootConstrainSelectedInstOperands,
     /* 312938 */   // GIR_Coverage, 853,
     /* 312938 */   GIR_Done,
     /* 312939 */ // Label 6358: @312939
     /* 312939 */ GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(312982), // Rule ID 13048 //
     /* 312944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 312954 */   // (fp_to_uint:{ *:[v2i32] } v2f64:{ *:[v2f64] }:$src)  =>  (XTNv2i32:{ *:[v2i32] } (FCVTZUv2f64:{ *:[f128] } V128:{ *:[v2f64] }:$src))
     /* 312954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 312957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 312961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312966 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 312970 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 312972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 312975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312977 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312980 */   GIR_RootConstrainSelectedInstOperands,
     /* 312981 */   // GIR_Coverage, 13048,
     /* 312981 */   GIR_EraseRootFromParent_Done,
     /* 312982 */ // Label 6359: @312982
     /* 312982 */ GIM_Reject,
     /* 312983 */ // Label 6331: @312983
     /* 312983 */ GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(313013), // Rule ID 857 //
     /* 312988 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 312991 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 312994 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313002 */   // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 313002 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 313007 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313011 */   GIR_RootConstrainSelectedInstOperands,
     /* 313012 */   // GIR_Coverage, 857,
     /* 313012 */   GIR_Done,
     /* 313013 */ // Label 6360: @313013
     /* 313013 */ GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(313056), // Rule ID 13046 //
     /* 313018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 313024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313028 */   // (fp_to_uint:{ *:[v2i64] } v2f32:{ *:[v2f32] }:$src)  =>  (FCVTZUv2f64:{ *:[v2i64] } (FCVTLv2i32:{ *:[f128] } V64:{ *:[v2f32] }:$src))
     /* 313028 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 313031 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 313035 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313040 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 313044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 313046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 313049 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313051 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313054 */   GIR_RootConstrainSelectedInstOperands,
     /* 313055 */   // GIR_Coverage, 13046,
     /* 313055 */   GIR_EraseRootFromParent_Done,
     /* 313056 */ // Label 6361: @313056
     /* 313056 */ GIM_Reject,
     /* 313057 */ // Label 6332: @313057
     /* 313057 */ GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(313087), // Rule ID 849 //
     /* 313062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 313068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313076 */   // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 313076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 313081 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313085 */   GIR_RootConstrainSelectedInstOperands,
     /* 313086 */   // GIR_Coverage, 849,
     /* 313086 */   GIR_Done,
     /* 313087 */ // Label 6362: @313087
     /* 313087 */ GIM_Reject,
     /* 313088 */ // Label 6333: @313088
     /* 313088 */ GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(313118), // Rule ID 855 //
     /* 313093 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313096 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313103 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313107 */   // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 313107 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 313112 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313116 */   GIR_RootConstrainSelectedInstOperands,
     /* 313117 */   // GIR_Coverage, 855,
     /* 313117 */   GIR_Done,
     /* 313118 */ // Label 6363: @313118
     /* 313118 */ GIM_Reject,
     /* 313119 */ // Label 6334: @313119
     /* 313119 */ GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(313149), // Rule ID 851 //
     /* 313124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 313127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313138 */   // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 313138 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 313143 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313147 */   GIR_RootConstrainSelectedInstOperands,
     /* 313148 */   // GIR_Coverage, 851,
     /* 313148 */   GIR_Done,
     /* 313149 */ // Label 6364: @313149
     /* 313149 */ GIM_Reject,
     /* 313150 */ // Label 6335: @313150
     /* 313150 */ GIM_Reject,
     /* 313151 */ // Label 67: @313151
     /* 313151 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6373*/ GIMT_Encode4(317547),
     /* 313162 */ /*GILLT_s16*//*Label 6365*/ GIMT_Encode4(313202),
     /* 313166 */ /*GILLT_s32*//*Label 6366*/ GIMT_Encode4(313483),
     /* 313170 */ /*GILLT_s64*//*Label 6367*/ GIMT_Encode4(315399), GIMT_Encode4(0),
     /* 313178 */ /*GILLT_v2s32*//*Label 6368*/ GIMT_Encode4(317303),
     /* 313182 */ /*GILLT_v2s64*//*Label 6369*/ GIMT_Encode4(317377),
     /* 313186 */ /*GILLT_v4s16*//*Label 6370*/ GIMT_Encode4(317454),
     /* 313190 */ /*GILLT_v4s32*//*Label 6371*/ GIMT_Encode4(317485), GIMT_Encode4(0),
     /* 313198 */ /*GILLT_v8s16*//*Label 6372*/ GIMT_Encode4(317516),
     /* 313202 */ // Label 6365: @313202
     /* 313202 */ GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(313305), // Rule ID 5306 //
     /* 313207 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 313210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313213 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313217 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313221 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 313225 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313229 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313233 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313237 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 313241 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313245 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313250 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 313254 */   // MIs[1] Operand 2
     /* 313254 */   GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 313265 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313267 */   // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 313267 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 313270 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313274 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313279 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 313285 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313290 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 313298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313300 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313303 */   GIR_RootConstrainSelectedInstOperands,
     /* 313304 */   // GIR_Coverage, 5306,
     /* 313304 */   GIR_EraseRootFromParent_Done,
     /* 313305 */ // Label 6374: @313305
     /* 313305 */ GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(313362), // Rule ID 5297 //
     /* 313310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 313313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313320 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313324 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 313328 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 313332 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313334 */   // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 313334 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 313337 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
     /* 313341 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313346 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 313350 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 313352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 313355 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313357 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313360 */   GIR_RootConstrainSelectedInstOperands,
     /* 313361 */   // GIR_Coverage, 5297,
     /* 313361 */   GIR_EraseRootFromParent_Done,
     /* 313362 */ // Label 6375: @313362
     /* 313362 */ GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(313392), // Rule ID 443 //
     /* 313367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 313381 */   // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 313381 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
     /* 313386 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313390 */   GIR_RootConstrainSelectedInstOperands,
     /* 313391 */   // GIR_Coverage, 443,
     /* 313391 */   GIR_Done,
     /* 313392 */ // Label 6376: @313392
     /* 313392 */ GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(313422), // Rule ID 449 //
     /* 313397 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 313400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 313411 */   // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 313411 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
     /* 313416 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313420 */   GIR_RootConstrainSelectedInstOperands,
     /* 313421 */   // GIR_Coverage, 449,
     /* 313421 */   GIR_Done,
     /* 313422 */ // Label 6377: @313422
     /* 313422 */ GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(313452), // Rule ID 491 //
     /* 313427 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 313430 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313437 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313441 */   // (sint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 313441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 313446 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313450 */   GIR_RootConstrainSelectedInstOperands,
     /* 313451 */   // GIR_Coverage, 491,
     /* 313451 */   GIR_Done,
     /* 313452 */ // Label 6378: @313452
     /* 313452 */ GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(313482), // Rule ID 495 //
     /* 313457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 313460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 313463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 313467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313471 */   // (sint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 313471 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 313476 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 313480 */   GIR_RootConstrainSelectedInstOperands,
     /* 313481 */   // GIR_Coverage, 495,
     /* 313481 */   GIR_Done,
     /* 313482 */ // Label 6379: @313482
     /* 313482 */ GIM_Reject,
     /* 313483 */ // Label 6366: @313483
     /* 313483 */ GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(313721), // Rule ID 6351 //
     /* 313488 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 313491 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313494 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313498 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313502 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 313506 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313509 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 313516 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313520 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313522 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 313529 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 313529 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 313532 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 313536 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 313551 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 313556 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 313563 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 313566 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313570 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313575 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 313577 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 313580 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313584 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313589 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 313592 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 313595 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 313598 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313603 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313608 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 313613 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 313616 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 313620 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313625 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 313628 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 313631 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 313633 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 313636 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313640 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313645 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 313652 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313657 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313662 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 313665 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 313669 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313674 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 313677 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 313680 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313682 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313685 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313689 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313694 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 313701 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313706 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 313714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313716 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313719 */   GIR_RootConstrainSelectedInstOperands,
     /* 313720 */   // GIR_Coverage, 6351,
     /* 313720 */   GIR_EraseRootFromParent_Done,
     /* 313721 */ // Label 6380: @313721
     /* 313721 */ GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(313959), // Rule ID 6352 //
     /* 313726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 313729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313736 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313740 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 313744 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313747 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 313754 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313758 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313760 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 313767 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 313767 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 313770 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 313774 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 313784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 313789 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 313794 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 313799 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 313801 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 313804 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 313808 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313813 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 313815 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 313818 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 313822 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313827 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 313830 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 313833 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 313836 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313841 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313846 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 313851 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 313854 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 313858 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313863 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 313866 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 313869 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 313871 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 313874 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313878 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313883 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 313890 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 313895 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313900 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 313903 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 313907 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313912 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 313915 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 313918 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 313920 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313923 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313927 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313932 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 313939 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313944 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 313952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313954 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313957 */   GIR_RootConstrainSelectedInstOperands,
     /* 313958 */   // GIR_Coverage, 6352,
     /* 313958 */   GIR_EraseRootFromParent_Done,
     /* 313959 */ // Label 6381: @313959
     /* 313959 */ GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(314148), // Rule ID 6355 //
     /* 313964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 313967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 313970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313974 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313978 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 313982 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 313985 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 313992 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 313996 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 313998 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 314005 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 314005 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 314008 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 314012 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314017 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 314027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 314032 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 314039 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 314042 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314046 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314053 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314056 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314060 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314065 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 314068 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 314071 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 314074 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314079 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314084 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314089 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314092 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 314096 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314101 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 314104 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 314107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314109 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314112 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314116 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314121 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 314128 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314133 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314143 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314146 */   GIR_RootConstrainSelectedInstOperands,
     /* 314147 */   // GIR_Coverage, 6355,
     /* 314147 */   GIR_EraseRootFromParent_Done,
     /* 314148 */ // Label 6382: @314148
     /* 314148 */ GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(314337), // Rule ID 6356 //
     /* 314153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314163 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314167 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 314171 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314174 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 314181 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314185 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314187 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 314194 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 314194 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 314197 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 314201 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314206 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314211 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 314216 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 314221 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314226 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 314228 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 314231 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314235 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314240 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314242 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314245 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314249 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314254 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 314257 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 314260 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 314263 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314268 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314273 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314278 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314281 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 314285 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314290 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 314293 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 314296 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314298 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314301 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314305 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314310 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 314317 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314322 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314332 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314335 */   GIR_RootConstrainSelectedInstOperands,
     /* 314336 */   // GIR_Coverage, 6356,
     /* 314336 */   GIR_EraseRootFromParent_Done,
     /* 314337 */ // Label 6383: @314337
     /* 314337 */ GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(314570), // Rule ID 6353 //
     /* 314342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314352 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314356 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 314360 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314363 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 314370 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314374 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314376 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 314383 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 314383 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 314386 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 314390 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314400 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 314405 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 314412 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 314415 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314419 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314424 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 314426 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 314429 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314433 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314438 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 314441 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 314444 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 314447 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314452 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314457 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 314462 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 314465 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 314469 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314474 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 314477 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 314480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314482 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314485 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314489 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314494 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 314501 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314506 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314511 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314514 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 314518 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314523 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 314526 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 314529 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314531 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314534 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314538 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314543 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 314550 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314555 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314565 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314568 */   GIR_RootConstrainSelectedInstOperands,
     /* 314569 */   // GIR_Coverage, 6353,
     /* 314569 */   GIR_EraseRootFromParent_Done,
     /* 314570 */ // Label 6384: @314570
     /* 314570 */ GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(314803), // Rule ID 6354 //
     /* 314575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314585 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314589 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 314593 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314596 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 314603 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314607 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314609 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 314616 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 314616 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 314619 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 314623 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314628 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314633 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 314638 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 314645 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 314648 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314652 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 314659 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 314662 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314666 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314671 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 314674 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 314677 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 314680 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314685 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314690 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 314695 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 314698 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 314702 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314707 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 314710 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 314713 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314715 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314718 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314722 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314727 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 314734 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314739 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314744 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314747 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 314751 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314756 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 314759 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 314762 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314764 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314767 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314771 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314776 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 314783 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314788 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314798 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314801 */   GIR_RootConstrainSelectedInstOperands,
     /* 314802 */   // GIR_Coverage, 6354,
     /* 314802 */   GIR_EraseRootFromParent_Done,
     /* 314803 */ // Label 6385: @314803
     /* 314803 */ GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(314987), // Rule ID 6357 //
     /* 314808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314818 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314822 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 314826 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 314829 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 314836 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 314840 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 314842 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 314849 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 314849 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 314852 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 314856 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 314866 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 314871 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 314876 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 314878 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 314881 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 314885 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314890 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 314892 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 314895 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 314899 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314904 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 314907 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 314910 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 314913 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314918 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 314923 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 314928 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 314931 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 314935 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314940 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 314943 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 314946 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 314948 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314951 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314955 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314960 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 314967 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314972 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 314980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314982 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314985 */   GIR_RootConstrainSelectedInstOperands,
     /* 314986 */   // GIR_Coverage, 6357,
     /* 314986 */   GIR_EraseRootFromParent_Done,
     /* 314987 */ // Label 6386: @314987
     /* 314987 */ GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(315171), // Rule ID 6358 //
     /* 314992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 314995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 314998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315002 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315006 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 315010 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315013 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 315020 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315024 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315026 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 315033 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 315033 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 315036 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 315040 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315045 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315050 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 315055 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 315062 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 315065 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315069 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315074 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315076 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315079 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315083 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315088 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 315091 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 315094 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 315097 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315102 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315107 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315112 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315115 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 315119 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315124 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315127 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315130 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315132 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315135 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315139 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315144 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 315151 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315156 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 315164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315166 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315169 */   GIR_RootConstrainSelectedInstOperands,
     /* 315170 */   // GIR_Coverage, 6358,
     /* 315170 */   GIR_EraseRootFromParent_Done,
     /* 315171 */ // Label 6387: @315171
     /* 315171 */ GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(315251), // Rule ID 5302 //
     /* 315176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 315179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315186 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315190 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315194 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315198 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315202 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315207 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315211 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315213 */   // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 315213 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315216 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315220 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315225 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 315231 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315236 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 315244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315246 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315249 */   GIR_RootConstrainSelectedInstOperands,
     /* 315250 */   // GIR_Coverage, 5302,
     /* 315250 */   GIR_EraseRootFromParent_Done,
     /* 315251 */ // Label 6388: @315251
     /* 315251 */ GIM_Try, /*On fail goto*//*Label 6389*/ GIMT_Encode4(315308), // Rule ID 5285 //
     /* 315256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 315259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315266 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315270 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 315274 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315278 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315280 */   // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 315280 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315283 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
     /* 315287 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315292 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 315296 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 315298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 315301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315303 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315306 */   GIR_RootConstrainSelectedInstOperands,
     /* 315307 */   // GIR_Coverage, 5285,
     /* 315307 */   GIR_EraseRootFromParent_Done,
     /* 315308 */ // Label 6389: @315308
     /* 315308 */ GIM_Try, /*On fail goto*//*Label 6390*/ GIMT_Encode4(315338), // Rule ID 445 //
     /* 315313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 315327 */   // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 315327 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
     /* 315332 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315336 */   GIR_RootConstrainSelectedInstOperands,
     /* 315337 */   // GIR_Coverage, 445,
     /* 315337 */   GIR_Done,
     /* 315338 */ // Label 6390: @315338
     /* 315338 */ GIM_Try, /*On fail goto*//*Label 6391*/ GIMT_Encode4(315368), // Rule ID 451 //
     /* 315343 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315346 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315349 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 315357 */   // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 315357 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
     /* 315362 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315366 */   GIR_RootConstrainSelectedInstOperands,
     /* 315367 */   // GIR_Coverage, 451,
     /* 315367 */   GIR_Done,
     /* 315368 */ // Label 6391: @315368
     /* 315368 */ GIM_Try, /*On fail goto*//*Label 6392*/ GIMT_Encode4(315398), // Rule ID 497 //
     /* 315373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 315376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315387 */   // (sint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 315387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 315392 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315396 */   GIR_RootConstrainSelectedInstOperands,
     /* 315397 */   // GIR_Coverage, 497,
     /* 315397 */   GIR_Done,
     /* 315398 */ // Label 6392: @315398
     /* 315398 */ GIM_Reject,
     /* 315399 */ // Label 6367: @315399
     /* 315399 */ GIM_Try, /*On fail goto*//*Label 6393*/ GIMT_Encode4(315585), // Rule ID 6363 //
     /* 315404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315414 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315418 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 315422 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315425 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 315429 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315433 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315435 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 315442 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 315442 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 315445 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 315449 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315454 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315459 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 315464 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 315469 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315474 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 315476 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 315479 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315483 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315488 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315490 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315493 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315497 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315502 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 315505 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 315508 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 315511 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315516 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315521 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315526 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315529 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 315533 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315538 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315541 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315546 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315549 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315553 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315558 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315565 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315570 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 315578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315580 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315583 */   GIR_RootConstrainSelectedInstOperands,
     /* 315584 */   // GIR_Coverage, 6363,
     /* 315584 */   GIR_EraseRootFromParent_Done,
     /* 315585 */ // Label 6393: @315585
     /* 315585 */ GIM_Try, /*On fail goto*//*Label 6394*/ GIMT_Encode4(315771), // Rule ID 6364 //
     /* 315590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315600 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315604 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 315608 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315611 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 315615 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315619 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315621 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 315628 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 315628 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 315631 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 315635 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315640 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 315650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 315655 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 315662 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 315665 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315669 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315676 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315679 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315683 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315688 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 315691 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 315694 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 315697 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315702 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315707 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315712 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315715 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 315719 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315724 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315727 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315730 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315732 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315735 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315739 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315744 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315751 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315756 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 315764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315766 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315769 */   GIR_RootConstrainSelectedInstOperands,
     /* 315770 */   // GIR_Coverage, 6364,
     /* 315770 */   GIR_EraseRootFromParent_Done,
     /* 315771 */ // Label 6394: @315771
     /* 315771 */ GIM_Try, /*On fail goto*//*Label 6395*/ GIMT_Encode4(316009), // Rule ID 6359 //
     /* 315776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 315779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 315782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315786 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315790 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 315794 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 315797 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 315804 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 315808 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315810 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 315817 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 315817 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 315820 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 315824 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 315834 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 315839 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 315844 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 315849 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 315851 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 315854 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 315858 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315863 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 315865 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 315868 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 315872 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315877 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 315880 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 315883 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 315886 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315891 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315896 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 315901 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 315904 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 315908 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315913 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 315916 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 315919 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 315921 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 315924 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315928 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315933 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315940 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315945 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315950 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 315953 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 315957 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315962 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 315965 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 315968 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 315970 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315973 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315977 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315982 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 315989 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315994 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316002 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316004 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316007 */   GIR_RootConstrainSelectedInstOperands,
     /* 316008 */   // GIR_Coverage, 6359,
     /* 316008 */   GIR_EraseRootFromParent_Done,
     /* 316009 */ // Label 6395: @316009
     /* 316009 */ GIM_Try, /*On fail goto*//*Label 6396*/ GIMT_Encode4(316247), // Rule ID 6360 //
     /* 316014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316024 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316028 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 316032 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316035 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 316042 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316046 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316048 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 316055 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 316055 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 316058 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 316062 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316067 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316072 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 316077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 316082 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 316089 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 316092 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316096 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 316103 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 316106 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316110 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316115 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 316118 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 316121 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 316124 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316129 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316134 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316139 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 316142 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316146 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316151 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 316154 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 316157 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316159 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316162 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316166 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316171 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316178 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316183 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316188 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316191 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 316195 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316200 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316203 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316206 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316208 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316211 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316215 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316220 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316227 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316232 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316237 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316240 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316242 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316245 */   GIR_RootConstrainSelectedInstOperands,
     /* 316246 */   // GIR_Coverage, 6360,
     /* 316246 */   GIR_EraseRootFromParent_Done,
     /* 316247 */ // Label 6396: @316247
     /* 316247 */ GIM_Try, /*On fail goto*//*Label 6397*/ GIMT_Encode4(316428), // Rule ID 6365 //
     /* 316252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316262 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316266 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 316270 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316273 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 316277 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316281 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316283 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 316290 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 316290 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 316293 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 316297 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316302 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316307 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 316312 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316317 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 316319 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 316322 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316326 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316331 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316333 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316336 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316340 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316345 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 316348 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 316351 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 316354 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316359 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316364 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316369 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316372 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 316376 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316381 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316384 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316387 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316389 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316392 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316396 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316401 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316408 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316413 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316423 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316426 */   GIR_RootConstrainSelectedInstOperands,
     /* 316427 */   // GIR_Coverage, 6365,
     /* 316427 */   GIR_EraseRootFromParent_Done,
     /* 316428 */ // Label 6397: @316428
     /* 316428 */ GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(316609), // Rule ID 6366 //
     /* 316433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316443 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316447 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 316451 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316454 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 316458 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316462 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316464 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 316471 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 316471 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 316474 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 316478 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316483 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 316493 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 316500 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 316503 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316507 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316512 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316514 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316517 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316521 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316526 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 316529 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 316532 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 316535 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316540 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316545 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 316550 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316553 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 316557 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316562 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316565 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316568 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316570 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316573 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316577 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316582 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316589 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316594 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316607 */   GIR_RootConstrainSelectedInstOperands,
     /* 316608 */   // GIR_Coverage, 6366,
     /* 316608 */   GIR_EraseRootFromParent_Done,
     /* 316609 */ // Label 6398: @316609
     /* 316609 */ GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(316842), // Rule ID 6361 //
     /* 316614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316624 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316628 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 316632 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316635 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 316642 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316646 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316648 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 316655 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 316655 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 316658 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 316662 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316667 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316672 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 316677 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316682 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 316684 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 316687 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316691 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316696 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 316698 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 316701 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316705 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316710 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 316713 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 316716 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 316719 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316724 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316729 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316734 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 316737 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316741 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316746 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 316749 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 316752 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316754 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316757 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316761 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316766 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316773 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316778 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316783 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 316786 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 316790 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316795 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 316798 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 316801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 316803 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316806 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316810 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316815 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 316822 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316827 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 316835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316837 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316840 */   GIR_RootConstrainSelectedInstOperands,
     /* 316841 */   // GIR_Coverage, 6361,
     /* 316841 */   GIR_EraseRootFromParent_Done,
     /* 316842 */ // Label 6399: @316842
     /* 316842 */ GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(317075), // Rule ID 6362 //
     /* 316847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 316850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 316853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316857 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316861 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 316865 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 316868 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 316875 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 316879 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 316881 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 316888 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 316888 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 316891 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 316895 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316900 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 316905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 316910 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 316915 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 316917 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 316920 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 316924 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316929 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 316931 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 316934 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 316938 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316943 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 316946 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 316949 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 316952 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316957 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316962 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 316967 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 316970 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 316974 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316979 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 316982 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 316985 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 316987 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 316990 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316994 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316999 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317006 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317011 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317016 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 317019 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 317023 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317028 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 317031 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 317034 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317036 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317039 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317043 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317048 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 317055 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317060 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317065 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 317068 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317070 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317073 */   GIR_RootConstrainSelectedInstOperands,
     /* 317074 */   // GIR_Coverage, 6362,
     /* 317074 */   GIR_EraseRootFromParent_Done,
     /* 317075 */ // Label 6400: @317075
     /* 317075 */ GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(317155), // Rule ID 5304 //
     /* 317080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317090 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317094 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317098 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317102 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317106 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317111 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317115 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317117 */   // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 317117 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317120 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317124 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317129 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317135 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317140 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 317148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317150 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317153 */   GIR_RootConstrainSelectedInstOperands,
     /* 317154 */   // GIR_Coverage, 5304,
     /* 317154 */   GIR_EraseRootFromParent_Done,
     /* 317155 */ // Label 6401: @317155
     /* 317155 */ GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(317212), // Rule ID 5281 //
     /* 317160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317170 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317174 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 317178 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317182 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317184 */   // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 317184 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317187 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 317191 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317196 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317200 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 317202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 317205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317207 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317210 */   GIR_RootConstrainSelectedInstOperands,
     /* 317211 */   // GIR_Coverage, 5281,
     /* 317211 */   GIR_EraseRootFromParent_Done,
     /* 317212 */ // Label 6402: @317212
     /* 317212 */ GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(317242), // Rule ID 447 //
     /* 317217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317231 */   // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 317231 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
     /* 317236 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317240 */   GIR_RootConstrainSelectedInstOperands,
     /* 317241 */   // GIR_Coverage, 447,
     /* 317241 */   GIR_Done,
     /* 317242 */ // Label 6403: @317242
     /* 317242 */ GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(317272), // Rule ID 453 //
     /* 317247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317261 */   // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 317261 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
     /* 317266 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317270 */   GIR_RootConstrainSelectedInstOperands,
     /* 317271 */   // GIR_Coverage, 453,
     /* 317271 */   GIR_Done,
     /* 317272 */ // Label 6404: @317272
     /* 317272 */ GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(317302), // Rule ID 493 //
     /* 317277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 317280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317291 */   // (sint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 317291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 317296 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317300 */   GIR_RootConstrainSelectedInstOperands,
     /* 317301 */   // GIR_Coverage, 493,
     /* 317301 */   GIR_Done,
     /* 317302 */ // Label 6405: @317302
     /* 317302 */ GIM_Reject,
     /* 317303 */ // Label 6368: @317303
     /* 317303 */ GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(317333), // Rule ID 1017 //
     /* 317308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317322 */   // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 317322 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
     /* 317327 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317331 */   GIR_RootConstrainSelectedInstOperands,
     /* 317332 */   // GIR_Coverage, 1017,
     /* 317332 */   GIR_Done,
     /* 317333 */ // Label 6406: @317333
     /* 317333 */ GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(317376), // Rule ID 13043 //
     /* 317338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317348 */   // (sint_to_fp:{ *:[v2f32] } v2i64:{ *:[v2i64] }:$src)  =>  (FCVTNv2i32:{ *:[v2f32] } (SCVTFv2f64:{ *:[f128] } V128:{ *:[v2i64] }:$src))
     /* 317348 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 317351 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 317355 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317360 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 317364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 317366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 317369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317374 */   GIR_RootConstrainSelectedInstOperands,
     /* 317375 */   // GIR_Coverage, 13043,
     /* 317375 */   GIR_EraseRootFromParent_Done,
     /* 317376 */ // Label 6407: @317376
     /* 317376 */ GIM_Reject,
     /* 317377 */ // Label 6369: @317377
     /* 317377 */ GIM_Try, /*On fail goto*//*Label 6408*/ GIMT_Encode4(317407), // Rule ID 1021 //
     /* 317382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317396 */   // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 317396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 317401 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317405 */   GIR_RootConstrainSelectedInstOperands,
     /* 317406 */   // GIR_Coverage, 1021,
     /* 317406 */   GIR_Done,
     /* 317407 */ // Label 6408: @317407
     /* 317407 */ GIM_Try, /*On fail goto*//*Label 6409*/ GIMT_Encode4(317453), // Rule ID 13041 //
     /* 317412 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317415 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 317418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317422 */   // (sint_to_fp:{ *:[v2f64] } v2i32:{ *:[v2i32] }:$src)  =>  (SCVTFv2f64:{ *:[v2f64] } (SSHLLv2i32_shift:{ *:[f128] } V64:{ *:[v2i32] }:$src, 0:{ *:[i32] }))
     /* 317422 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 317425 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 317429 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317434 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 317438 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 317441 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 317443 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 317446 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317448 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317451 */   GIR_RootConstrainSelectedInstOperands,
     /* 317452 */   // GIR_Coverage, 13041,
     /* 317452 */   GIR_EraseRootFromParent_Done,
     /* 317453 */ // Label 6409: @317453
     /* 317453 */ GIM_Reject,
     /* 317454 */ // Label 6370: @317454
     /* 317454 */ GIM_Try, /*On fail goto*//*Label 6410*/ GIMT_Encode4(317484), // Rule ID 1013 //
     /* 317459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 317462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 317465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317473 */   // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 317473 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
     /* 317478 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317482 */   GIR_RootConstrainSelectedInstOperands,
     /* 317483 */   // GIR_Coverage, 1013,
     /* 317483 */   GIR_Done,
     /* 317484 */ // Label 6410: @317484
     /* 317484 */ GIM_Reject,
     /* 317485 */ // Label 6371: @317485
     /* 317485 */ GIM_Try, /*On fail goto*//*Label 6411*/ GIMT_Encode4(317515), // Rule ID 1019 //
     /* 317490 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317493 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 317496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317500 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317504 */   // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 317504 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
     /* 317509 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317513 */   GIR_RootConstrainSelectedInstOperands,
     /* 317514 */   // GIR_Coverage, 1019,
     /* 317514 */   GIR_Done,
     /* 317515 */ // Label 6411: @317515
     /* 317515 */ GIM_Reject,
     /* 317516 */ // Label 6372: @317516
     /* 317516 */ GIM_Try, /*On fail goto*//*Label 6412*/ GIMT_Encode4(317546), // Rule ID 1015 //
     /* 317521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 317524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 317527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317535 */   // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 317535 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
     /* 317540 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317544 */   GIR_RootConstrainSelectedInstOperands,
     /* 317545 */   // GIR_Coverage, 1015,
     /* 317545 */   GIR_Done,
     /* 317546 */ // Label 6412: @317546
     /* 317546 */ GIM_Reject,
     /* 317547 */ // Label 6373: @317547
     /* 317547 */ GIM_Reject,
     /* 317548 */ // Label 68: @317548
     /* 317548 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6421*/ GIMT_Encode4(321322),
     /* 317559 */ /*GILLT_s16*//*Label 6413*/ GIMT_Encode4(317599),
     /* 317563 */ /*GILLT_s32*//*Label 6414*/ GIMT_Encode4(317884),
     /* 317567 */ /*GILLT_s64*//*Label 6415*/ GIMT_Encode4(319212), GIMT_Encode4(0),
     /* 317575 */ /*GILLT_v2s32*//*Label 6416*/ GIMT_Encode4(321078),
     /* 317579 */ /*GILLT_v2s64*//*Label 6417*/ GIMT_Encode4(321152),
     /* 317583 */ /*GILLT_v4s16*//*Label 6418*/ GIMT_Encode4(321229),
     /* 317587 */ /*GILLT_v4s32*//*Label 6419*/ GIMT_Encode4(321260), GIMT_Encode4(0),
     /* 317595 */ /*GILLT_v8s16*//*Label 6420*/ GIMT_Encode4(321291),
     /* 317599 */ // Label 6413: @317599
     /* 317599 */ GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(317706), // Rule ID 5307 //
     /* 317604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 317607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317614 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317618 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 317622 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 317626 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 317630 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317634 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317638 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 317642 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317646 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317651 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 317655 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 317666 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317668 */   // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 317668 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 317671 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317675 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317680 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 317686 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317691 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 317699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317701 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317704 */   GIR_RootConstrainSelectedInstOperands,
     /* 317705 */   // GIR_Coverage, 5307,
     /* 317705 */   GIR_EraseRootFromParent_Done,
     /* 317706 */ // Label 6422: @317706
     /* 317706 */ GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(317763), // Rule ID 5301 //
     /* 317711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 317714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317721 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317725 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 317729 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 317733 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317735 */   // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 317735 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 317738 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
     /* 317742 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317747 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 317751 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 317753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 317756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317758 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317761 */   GIR_RootConstrainSelectedInstOperands,
     /* 317762 */   // GIR_Coverage, 5301,
     /* 317762 */   GIR_EraseRootFromParent_Done,
     /* 317763 */ // Label 6423: @317763
     /* 317763 */ GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(317793), // Rule ID 467 //
     /* 317768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 317782 */   // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 317782 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
     /* 317787 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317791 */   GIR_RootConstrainSelectedInstOperands,
     /* 317792 */   // GIR_Coverage, 467,
     /* 317792 */   GIR_Done,
     /* 317793 */ // Label 6424: @317793
     /* 317793 */ GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(317823), // Rule ID 473 //
     /* 317798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 317801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 317812 */   // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 317812 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
     /* 317817 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317821 */   GIR_RootConstrainSelectedInstOperands,
     /* 317822 */   // GIR_Coverage, 473,
     /* 317822 */   GIR_Done,
     /* 317823 */ // Label 6425: @317823
     /* 317823 */ GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(317853), // Rule ID 499 //
     /* 317828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 317831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317842 */   // (uint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 317842 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 317847 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317851 */   GIR_RootConstrainSelectedInstOperands,
     /* 317852 */   // GIR_Coverage, 499,
     /* 317852 */   GIR_Done,
     /* 317853 */ // Label 6426: @317853
     /* 317853 */ GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(317883), // Rule ID 503 //
     /* 317858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 317861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 317864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 317868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317872 */   // (uint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 317872 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 317877 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 317881 */   GIR_RootConstrainSelectedInstOperands,
     /* 317882 */   // GIR_Coverage, 503,
     /* 317882 */   GIR_Done,
     /* 317883 */ // Label 6427: @317883
     /* 317883 */ GIM_Reject,
     /* 317884 */ // Label 6414: @317884
     /* 317884 */ GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(318024), // Rule ID 5308 //
     /* 317889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 317892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 317895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 317899 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317903 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 317907 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 317910 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 317917 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 317921 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 317923 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 317930 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 317930 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 317933 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 317937 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317942 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 317947 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 317952 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 317957 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 317962 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 317964 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 317967 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 317971 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317976 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 317978 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 317981 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 317985 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317990 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 317993 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 317996 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 317999 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318004 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318009 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 318014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318019 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318022 */   GIR_RootConstrainSelectedInstOperands,
     /* 318023 */   // GIR_Coverage, 5308,
     /* 318023 */   GIR_EraseRootFromParent_Done,
     /* 318024 */ // Label 6428: @318024
     /* 318024 */ GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(318164), // Rule ID 5309 //
     /* 318029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318039 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318043 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 318047 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318050 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 318057 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318061 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318063 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 318070 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 318070 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 318073 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 318077 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318087 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 318092 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 318097 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318102 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318104 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 318107 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318111 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318116 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318118 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318121 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318125 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318130 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318133 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318136 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 318139 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318144 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318149 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 318154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318157 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318159 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318162 */   GIR_RootConstrainSelectedInstOperands,
     /* 318163 */   // GIR_Coverage, 5309,
     /* 318163 */   GIR_EraseRootFromParent_Done,
     /* 318164 */ // Label 6429: @318164
     /* 318164 */ GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(318304), // Rule ID 5312 //
     /* 318169 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318172 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318179 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318183 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 318187 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318190 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 318197 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318201 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318203 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 318210 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 318210 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 318213 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 318217 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 318232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 318237 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318244 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 318247 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318251 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318256 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318258 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318261 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318265 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318270 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318273 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318276 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 318279 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318284 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318289 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318297 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318299 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318302 */   GIR_RootConstrainSelectedInstOperands,
     /* 318303 */   // GIR_Coverage, 5312,
     /* 318303 */   GIR_EraseRootFromParent_Done,
     /* 318304 */ // Label 6430: @318304
     /* 318304 */ GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(318444), // Rule ID 5313 //
     /* 318309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318319 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318323 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 318327 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318330 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 318337 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318341 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318343 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 318350 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 318350 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 318353 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 318357 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318362 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318367 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 318372 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 318377 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318382 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318384 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 318387 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318391 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318396 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318398 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318401 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318405 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318410 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318413 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318416 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 318419 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318424 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318429 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318439 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318442 */   GIR_RootConstrainSelectedInstOperands,
     /* 318443 */   // GIR_Coverage, 5313,
     /* 318443 */   GIR_EraseRootFromParent_Done,
     /* 318444 */ // Label 6431: @318444
     /* 318444 */ GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(318579), // Rule ID 5310 //
     /* 318449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318459 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318463 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 318467 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318470 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 318477 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318481 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318483 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 318490 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 318490 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 318493 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 318497 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318502 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318507 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 318512 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318519 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 318522 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318526 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318531 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318533 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318536 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318540 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318545 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318548 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318551 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 318554 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318559 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318564 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 318569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318574 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318577 */   GIR_RootConstrainSelectedInstOperands,
     /* 318578 */   // GIR_Coverage, 5310,
     /* 318578 */   GIR_EraseRootFromParent_Done,
     /* 318579 */ // Label 6432: @318579
     /* 318579 */ GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(318714), // Rule ID 5311 //
     /* 318584 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318594 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318598 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 318602 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318605 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 318612 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318616 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318618 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 318625 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 318625 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 318628 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 318632 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318637 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 318647 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318652 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318654 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 318657 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318661 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318666 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318668 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318671 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318675 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318680 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318683 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318686 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 318689 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318694 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318699 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 318704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318707 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318709 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318712 */   GIR_RootConstrainSelectedInstOperands,
     /* 318713 */   // GIR_Coverage, 5311,
     /* 318713 */   GIR_EraseRootFromParent_Done,
     /* 318714 */ // Label 6433: @318714
     /* 318714 */ GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(318849), // Rule ID 5314 //
     /* 318719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318729 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318733 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 318737 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318740 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 318747 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318751 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318753 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 318760 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 318760 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 318763 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 318767 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318772 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318777 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 318782 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318787 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318789 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 318792 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318796 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318803 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318806 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318810 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318815 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318818 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318821 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 318824 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318829 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318834 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318844 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318847 */   GIR_RootConstrainSelectedInstOperands,
     /* 318848 */   // GIR_Coverage, 5314,
     /* 318848 */   GIR_EraseRootFromParent_Done,
     /* 318849 */ // Label 6434: @318849
     /* 318849 */ GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(318984), // Rule ID 5315 //
     /* 318854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318864 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318868 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 318872 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 318875 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 318882 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 318886 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318888 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 318895 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 318895 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 318898 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 318902 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318907 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 318912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 318917 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 318922 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 318924 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 318927 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 318931 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318936 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 318938 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 318941 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 318945 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318950 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 318953 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 318956 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 318959 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318964 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318969 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 318974 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 318977 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318979 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318982 */   GIR_RootConstrainSelectedInstOperands,
     /* 318983 */   // GIR_Coverage, 5315,
     /* 318983 */   GIR_EraseRootFromParent_Done,
     /* 318984 */ // Label 6435: @318984
     /* 318984 */ GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(319064), // Rule ID 5303 //
     /* 318989 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 318992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 318995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 318999 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319003 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 319007 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319011 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319015 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319020 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 319024 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319026 */   // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 319026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 319029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 319033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319038 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 319044 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319049 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 319057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319059 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319062 */   GIR_RootConstrainSelectedInstOperands,
     /* 319063 */   // GIR_Coverage, 5303,
     /* 319063 */   GIR_EraseRootFromParent_Done,
     /* 319064 */ // Label 6436: @319064
     /* 319064 */ GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(319121), // Rule ID 5293 //
     /* 319069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319079 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319083 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 319087 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 319091 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319093 */   // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 319093 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 319096 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
     /* 319100 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319105 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319109 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 319111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 319114 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319116 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319119 */   GIR_RootConstrainSelectedInstOperands,
     /* 319120 */   // GIR_Coverage, 5293,
     /* 319120 */   GIR_EraseRootFromParent_Done,
     /* 319121 */ // Label 6437: @319121
     /* 319121 */ GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(319151), // Rule ID 469 //
     /* 319126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 319129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 319140 */   // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 319140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
     /* 319145 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319149 */   GIR_RootConstrainSelectedInstOperands,
     /* 319150 */   // GIR_Coverage, 469,
     /* 319150 */   GIR_Done,
     /* 319151 */ // Label 6438: @319151
     /* 319151 */ GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(319181), // Rule ID 475 //
     /* 319156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 319159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 319162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319166 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 319170 */   // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 319170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
     /* 319175 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319179 */   GIR_RootConstrainSelectedInstOperands,
     /* 319180 */   // GIR_Coverage, 475,
     /* 319180 */   GIR_Done,
     /* 319181 */ // Label 6439: @319181
     /* 319181 */ GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(319211), // Rule ID 505 //
     /* 319186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 319189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 319192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319200 */   // (uint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 319200 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 319205 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 319209 */   GIR_RootConstrainSelectedInstOperands,
     /* 319210 */   // GIR_Coverage, 505,
     /* 319210 */   GIR_Done,
     /* 319211 */ // Label 6440: @319211
     /* 319211 */ GIM_Reject,
     /* 319212 */ // Label 6415: @319212
     /* 319212 */ GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(319349), // Rule ID 5324 //
     /* 319217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319227 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319231 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 319235 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319238 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 319242 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319246 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319248 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 319255 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 319255 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 319258 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 319262 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319267 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319272 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 319277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 319282 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319287 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319289 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319292 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319296 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319303 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319306 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319310 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319315 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319318 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319321 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319324 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319329 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319334 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319344 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319347 */   GIR_RootConstrainSelectedInstOperands,
     /* 319348 */   // GIR_Coverage, 5324,
     /* 319348 */   GIR_EraseRootFromParent_Done,
     /* 319349 */ // Label 6441: @319349
     /* 319349 */ GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(319486), // Rule ID 5325 //
     /* 319354 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319357 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319364 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319368 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 319372 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319375 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 319379 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319383 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319385 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 319392 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 319392 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 319395 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 319399 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319404 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319409 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 319414 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 319419 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319424 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319426 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319429 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319433 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319452 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319455 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319458 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319461 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319466 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319471 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319479 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319481 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319484 */   GIR_RootConstrainSelectedInstOperands,
     /* 319485 */   // GIR_Coverage, 5325,
     /* 319485 */   GIR_EraseRootFromParent_Done,
     /* 319486 */ // Label 6442: @319486
     /* 319486 */ GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(319626), // Rule ID 5316 //
     /* 319491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319501 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319505 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319509 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319512 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 319519 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319523 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319525 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 319532 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 319532 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 319535 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 319539 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 319554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 319559 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319566 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319569 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319573 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319580 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319583 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319587 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319592 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319595 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319598 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 319601 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319606 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319611 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 319616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319621 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319624 */   GIR_RootConstrainSelectedInstOperands,
     /* 319625 */   // GIR_Coverage, 5316,
     /* 319625 */   GIR_EraseRootFromParent_Done,
     /* 319626 */ // Label 6443: @319626
     /* 319626 */ GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(319766), // Rule ID 5317 //
     /* 319631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319641 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319645 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319649 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319652 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 319659 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319663 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319665 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 319672 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 319672 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 319675 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 319679 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319684 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 319694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 319699 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319704 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319706 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319709 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319713 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319720 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319723 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319727 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319732 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319735 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319738 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 319741 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319746 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319751 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 319756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319761 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319764 */   GIR_RootConstrainSelectedInstOperands,
     /* 319765 */   // GIR_Coverage, 5317,
     /* 319765 */   GIR_EraseRootFromParent_Done,
     /* 319766 */ // Label 6444: @319766
     /* 319766 */ GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(319906), // Rule ID 5320 //
     /* 319771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319781 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319785 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319789 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319792 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 319799 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319803 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319805 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 319812 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 319812 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 319815 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 319819 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319824 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 319834 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 319839 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319844 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319846 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319849 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319853 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 319860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 319863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 319867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319872 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 319875 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 319878 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 319881 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319886 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319891 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 319896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 319899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 319901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319904 */   GIR_RootConstrainSelectedInstOperands,
     /* 319905 */   // GIR_Coverage, 5320,
     /* 319905 */   GIR_EraseRootFromParent_Done,
     /* 319906 */ // Label 6445: @319906
     /* 319906 */ GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(320046), // Rule ID 5321 //
     /* 319911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 319914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 319917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319921 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319925 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 319929 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 319932 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 319939 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 319943 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 319945 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 319952 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 319952 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 319955 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 319959 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 319969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 319974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 319979 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 319984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 319986 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 319989 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 319993 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319998 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320000 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320003 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320007 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320012 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320015 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320018 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 320021 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320026 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320031 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320041 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320044 */   GIR_RootConstrainSelectedInstOperands,
     /* 320045 */   // GIR_Coverage, 5321,
     /* 320045 */   GIR_EraseRootFromParent_Done,
     /* 320046 */ // Label 6446: @320046
     /* 320046 */ GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(320178), // Rule ID 5326 //
     /* 320051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320061 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320065 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 320069 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320072 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 320076 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320080 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320082 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 320089 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
     /* 320089 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 320092 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 320096 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320101 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320106 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 320111 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320116 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320118 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 320121 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320125 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320130 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320132 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320135 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320139 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320144 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320147 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320150 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320153 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320158 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320163 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320173 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320176 */   GIR_RootConstrainSelectedInstOperands,
     /* 320177 */   // GIR_Coverage, 5326,
     /* 320177 */   GIR_EraseRootFromParent_Done,
     /* 320178 */ // Label 6447: @320178
     /* 320178 */ GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(320310), // Rule ID 5327 //
     /* 320183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320189 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320193 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320197 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 320201 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320204 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 320208 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320212 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320214 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 320221 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
     /* 320221 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 320224 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 320228 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320233 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320238 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 320243 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320248 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320250 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 320253 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320257 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320262 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320264 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320267 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320271 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320276 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320279 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320282 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320285 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320290 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320295 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320300 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320303 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320305 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320308 */   GIR_RootConstrainSelectedInstOperands,
     /* 320309 */   // GIR_Coverage, 5327,
     /* 320309 */   GIR_EraseRootFromParent_Done,
     /* 320310 */ // Label 6448: @320310
     /* 320310 */ GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(320445), // Rule ID 5318 //
     /* 320315 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320325 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320329 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320333 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320336 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 320343 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320347 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320349 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 320356 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 320356 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 320359 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 320363 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320368 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 320378 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320383 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320385 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 320388 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320392 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320397 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320399 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320402 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320406 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320411 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320414 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320417 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 320420 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320425 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320430 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 320435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320440 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320443 */   GIR_RootConstrainSelectedInstOperands,
     /* 320444 */   // GIR_Coverage, 5318,
     /* 320444 */   GIR_EraseRootFromParent_Done,
     /* 320445 */ // Label 6449: @320445
     /* 320445 */ GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(320580), // Rule ID 5319 //
     /* 320450 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320460 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320464 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320468 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320471 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 320478 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320482 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320484 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 320491 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 320491 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 320494 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 320498 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320503 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320508 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 320513 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320520 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 320523 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320527 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320532 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320534 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320537 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320541 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320546 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320549 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320552 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 320555 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320560 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320565 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 320570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320575 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320578 */   GIR_RootConstrainSelectedInstOperands,
     /* 320579 */   // GIR_Coverage, 5319,
     /* 320579 */   GIR_EraseRootFromParent_Done,
     /* 320580 */ // Label 6450: @320580
     /* 320580 */ GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(320715), // Rule ID 5322 //
     /* 320585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320595 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320599 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320603 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320606 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 320613 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320617 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320619 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 320626 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 320626 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 320629 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 320633 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320638 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320643 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 320648 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320653 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320655 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 320658 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320662 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320667 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320669 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320672 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320676 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320681 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320684 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320687 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 320690 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320695 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320700 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320710 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320713 */   GIR_RootConstrainSelectedInstOperands,
     /* 320714 */   // GIR_Coverage, 5322,
     /* 320714 */   GIR_EraseRootFromParent_Done,
     /* 320715 */ // Label 6451: @320715
     /* 320715 */ GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(320850), // Rule ID 5323 //
     /* 320720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320730 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320734 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 320738 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 320741 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 320748 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 320752 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320754 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 320761 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 320761 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 320764 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 320768 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320773 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 320778 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 320783 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 320788 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 320790 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 320793 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 320797 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 320804 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320807 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 320811 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320816 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 320819 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 320822 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 320825 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320830 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320835 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 320840 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320843 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320845 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320848 */   GIR_RootConstrainSelectedInstOperands,
     /* 320849 */   // GIR_Coverage, 5323,
     /* 320849 */   GIR_EraseRootFromParent_Done,
     /* 320850 */ // Label 6452: @320850
     /* 320850 */ GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(320930), // Rule ID 5305 //
     /* 320855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320865 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320869 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 320873 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320877 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320881 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320886 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 320890 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320892 */   // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 320892 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320895 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 320899 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320904 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 320910 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320915 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320923 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320925 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320928 */   GIR_RootConstrainSelectedInstOperands,
     /* 320929 */   // GIR_Coverage, 5305,
     /* 320929 */   GIR_EraseRootFromParent_Done,
     /* 320930 */ // Label 6453: @320930
     /* 320930 */ GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(320987), // Rule ID 5289 //
     /* 320935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 320938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 320941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320945 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320949 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 320953 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 320957 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320959 */   // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 320959 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 320962 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 320966 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320971 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320975 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 320977 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 320980 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 320982 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320985 */   GIR_RootConstrainSelectedInstOperands,
     /* 320986 */   // GIR_Coverage, 5289,
     /* 320986 */   GIR_EraseRootFromParent_Done,
     /* 320987 */ // Label 6454: @320987
     /* 320987 */ GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(321017), // Rule ID 471 //
     /* 320992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 320995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 320998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321002 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321006 */   // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 321006 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
     /* 321011 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321015 */   GIR_RootConstrainSelectedInstOperands,
     /* 321016 */   // GIR_Coverage, 471,
     /* 321016 */   GIR_Done,
     /* 321017 */ // Label 6455: @321017
     /* 321017 */ GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(321047), // Rule ID 477 //
     /* 321022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 321025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 321028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 321036 */   // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 321036 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
     /* 321041 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321045 */   GIR_RootConstrainSelectedInstOperands,
     /* 321046 */   // GIR_Coverage, 477,
     /* 321046 */   GIR_Done,
     /* 321047 */ // Label 6456: @321047
     /* 321047 */ GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(321077), // Rule ID 501 //
     /* 321052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 321055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 321066 */   // (uint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 321066 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 321071 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321075 */   GIR_RootConstrainSelectedInstOperands,
     /* 321076 */   // GIR_Coverage, 501,
     /* 321076 */   GIR_Done,
     /* 321077 */ // Label 6457: @321077
     /* 321077 */ GIM_Reject,
     /* 321078 */ // Label 6416: @321078
     /* 321078 */ GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(321108), // Rule ID 1078 //
     /* 321083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 321089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321093 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321097 */   // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 321097 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
     /* 321102 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321106 */   GIR_RootConstrainSelectedInstOperands,
     /* 321107 */   // GIR_Coverage, 1078,
     /* 321107 */   GIR_Done,
     /* 321108 */ // Label 6458: @321108
     /* 321108 */ GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(321151), // Rule ID 13044 //
     /* 321113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321123 */   // (uint_to_fp:{ *:[v2f32] } v2i64:{ *:[v2i64] }:$src)  =>  (FCVTNv2i32:{ *:[v2f32] } (UCVTFv2f64:{ *:[f128] } V128:{ *:[v2i64] }:$src))
     /* 321123 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321126 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 321130 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321135 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 321139 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321141 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 321144 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321146 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321149 */   GIR_RootConstrainSelectedInstOperands,
     /* 321150 */   // GIR_Coverage, 13044,
     /* 321150 */   GIR_EraseRootFromParent_Done,
     /* 321151 */ // Label 6459: @321151
     /* 321151 */ GIM_Reject,
     /* 321152 */ // Label 6417: @321152
     /* 321152 */ GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(321182), // Rule ID 1082 //
     /* 321157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321163 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321167 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321171 */   // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 321171 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 321176 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321180 */   GIR_RootConstrainSelectedInstOperands,
     /* 321181 */   // GIR_Coverage, 1082,
     /* 321181 */   GIR_Done,
     /* 321182 */ // Label 6460: @321182
     /* 321182 */ GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(321228), // Rule ID 13042 //
     /* 321187 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321190 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 321193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321197 */   // (uint_to_fp:{ *:[v2f64] } v2i32:{ *:[v2i32] }:$src)  =>  (UCVTFv2f64:{ *:[v2f64] } (USHLLv2i32_shift:{ *:[f128] } V64:{ *:[v2i32] }:$src, 0:{ *:[i32] }))
     /* 321197 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321200 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 321204 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321209 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 321213 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321216 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 321218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 321221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 321223 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321226 */   GIR_RootConstrainSelectedInstOperands,
     /* 321227 */   // GIR_Coverage, 13042,
     /* 321227 */   GIR_EraseRootFromParent_Done,
     /* 321228 */ // Label 6461: @321228
     /* 321228 */ GIM_Reject,
     /* 321229 */ // Label 6418: @321229
     /* 321229 */ GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(321259), // Rule ID 1074 //
     /* 321234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321248 */   // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 321248 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
     /* 321253 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321257 */   GIR_RootConstrainSelectedInstOperands,
     /* 321258 */   // GIR_Coverage, 1074,
     /* 321258 */   GIR_Done,
     /* 321259 */ // Label 6462: @321259
     /* 321259 */ GIM_Reject,
     /* 321260 */ // Label 6419: @321260
     /* 321260 */ GIM_Try, /*On fail goto*//*Label 6463*/ GIMT_Encode4(321290), // Rule ID 1080 //
     /* 321265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321279 */   // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 321279 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
     /* 321284 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321288 */   GIR_RootConstrainSelectedInstOperands,
     /* 321289 */   // GIR_Coverage, 1080,
     /* 321289 */   GIR_Done,
     /* 321290 */ // Label 6463: @321290
     /* 321290 */ GIM_Reject,
     /* 321291 */ // Label 6420: @321291
     /* 321291 */ GIM_Try, /*On fail goto*//*Label 6464*/ GIMT_Encode4(321321), // Rule ID 1076 //
     /* 321296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321310 */   // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 321310 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
     /* 321315 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321319 */   GIR_RootConstrainSelectedInstOperands,
     /* 321320 */   // GIR_Coverage, 1076,
     /* 321320 */   GIR_Done,
     /* 321321 */ // Label 6464: @321321
     /* 321321 */ GIM_Reject,
     /* 321322 */ // Label 6421: @321322
     /* 321322 */ GIM_Reject,
     /* 321323 */ // Label 69: @321323
     /* 321323 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6472*/ GIMT_Encode4(321642),
     /* 321334 */ /*GILLT_s32*//*Label 6465*/ GIMT_Encode4(321370),
     /* 321338 */ /*GILLT_s64*//*Label 6466*/ GIMT_Encode4(321443), GIMT_Encode4(0),
     /* 321346 */ /*GILLT_v2s32*//*Label 6467*/ GIMT_Encode4(321516),
     /* 321350 */ /*GILLT_v2s64*//*Label 6468*/ GIMT_Encode4(321540),
     /* 321354 */ /*GILLT_v4s16*//*Label 6469*/ GIMT_Encode4(321564),
     /* 321358 */ /*GILLT_v4s32*//*Label 6470*/ GIMT_Encode4(321591), GIMT_Encode4(0),
     /* 321366 */ /*GILLT_v8s16*//*Label 6471*/ GIMT_Encode4(321615),
     /* 321370 */ // Label 6465: @321370
     /* 321370 */ GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(321396), // Rule ID 4569 //
     /* 321375 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 321381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321385 */   // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 321385 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 321390 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321394 */   GIR_RootConstrainSelectedInstOperands,
     /* 321395 */   // GIR_Coverage, 4569,
     /* 321395 */   GIR_Done,
     /* 321396 */ // Label 6473: @321396
     /* 321396 */ GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(321419), // Rule ID 4571 //
     /* 321401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321408 */   // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 321408 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 321413 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321417 */   GIR_RootConstrainSelectedInstOperands,
     /* 321418 */   // GIR_Coverage, 4571,
     /* 321418 */   GIR_Done,
     /* 321419 */ // Label 6474: @321419
     /* 321419 */ GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(321442), // Rule ID 4573 //
     /* 321424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 321427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321431 */   // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 321431 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 321436 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321440 */   GIR_RootConstrainSelectedInstOperands,
     /* 321441 */   // GIR_Coverage, 4573,
     /* 321441 */   GIR_Done,
     /* 321442 */ // Label 6475: @321442
     /* 321442 */ GIM_Reject,
     /* 321443 */ // Label 6466: @321443
     /* 321443 */ GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(321469), // Rule ID 4570 //
     /* 321448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 321454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 321458 */   // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 321458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 321463 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321467 */   GIR_RootConstrainSelectedInstOperands,
     /* 321468 */   // GIR_Coverage, 4570,
     /* 321468 */   GIR_Done,
     /* 321469 */ // Label 6476: @321469
     /* 321469 */ GIM_Try, /*On fail goto*//*Label 6477*/ GIMT_Encode4(321492), // Rule ID 4572 //
     /* 321474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 321481 */   // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 321481 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 321486 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321490 */   GIR_RootConstrainSelectedInstOperands,
     /* 321491 */   // GIR_Coverage, 4572,
     /* 321491 */   GIR_Done,
     /* 321492 */ // Label 6477: @321492
     /* 321492 */ GIM_Try, /*On fail goto*//*Label 6478*/ GIMT_Encode4(321515), // Rule ID 4574 //
     /* 321497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 321500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 321504 */   // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 321504 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 321509 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321513 */   GIR_RootConstrainSelectedInstOperands,
     /* 321514 */   // GIR_Coverage, 4574,
     /* 321514 */   GIR_Done,
     /* 321515 */ // Label 6478: @321515
     /* 321515 */ GIM_Reject,
     /* 321516 */ // Label 6467: @321516
     /* 321516 */ GIM_Try, /*On fail goto*//*Label 6479*/ GIMT_Encode4(321539), // Rule ID 4910 //
     /* 321521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 321524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321528 */   // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 321528 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 321533 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321537 */   GIR_RootConstrainSelectedInstOperands,
     /* 321538 */   // GIR_Coverage, 4910,
     /* 321538 */   GIR_Done,
     /* 321539 */ // Label 6479: @321539
     /* 321539 */ GIM_Reject,
     /* 321540 */ // Label 6468: @321540
     /* 321540 */ GIM_Try, /*On fail goto*//*Label 6480*/ GIMT_Encode4(321563), // Rule ID 4912 //
     /* 321545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321552 */   // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 321552 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 321557 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321561 */   GIR_RootConstrainSelectedInstOperands,
     /* 321562 */   // GIR_Coverage, 4912,
     /* 321562 */   GIR_Done,
     /* 321563 */ // Label 6480: @321563
     /* 321563 */ GIM_Reject,
     /* 321564 */ // Label 6469: @321564
     /* 321564 */ GIM_Try, /*On fail goto*//*Label 6481*/ GIMT_Encode4(321590), // Rule ID 4905 //
     /* 321569 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321572 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321579 */   // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 321579 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 321584 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321588 */   GIR_RootConstrainSelectedInstOperands,
     /* 321589 */   // GIR_Coverage, 4905,
     /* 321589 */   GIR_Done,
     /* 321590 */ // Label 6481: @321590
     /* 321590 */ GIM_Reject,
     /* 321591 */ // Label 6470: @321591
     /* 321591 */ GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(321614), // Rule ID 4911 //
     /* 321596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321603 */   // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 321603 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 321608 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321612 */   GIR_RootConstrainSelectedInstOperands,
     /* 321613 */   // GIR_Coverage, 4911,
     /* 321613 */   GIR_Done,
     /* 321614 */ // Label 6482: @321614
     /* 321614 */ GIM_Reject,
     /* 321615 */ // Label 6471: @321615
     /* 321615 */ GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(321641), // Rule ID 4906 //
     /* 321620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321630 */   // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 321630 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 321635 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321639 */   GIR_RootConstrainSelectedInstOperands,
     /* 321640 */   // GIR_Coverage, 4906,
     /* 321640 */   GIR_Done,
     /* 321641 */ // Label 6483: @321641
     /* 321641 */ GIM_Reject,
     /* 321642 */ // Label 6472: @321642
     /* 321642 */ GIM_Reject,
     /* 321643 */ // Label 70: @321643
     /* 321643 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6491*/ GIMT_Encode4(321962),
     /* 321654 */ /*GILLT_s32*//*Label 6484*/ GIMT_Encode4(321690),
     /* 321658 */ /*GILLT_s64*//*Label 6485*/ GIMT_Encode4(321763), GIMT_Encode4(0),
     /* 321666 */ /*GILLT_v2s32*//*Label 6486*/ GIMT_Encode4(321836),
     /* 321670 */ /*GILLT_v2s64*//*Label 6487*/ GIMT_Encode4(321860),
     /* 321674 */ /*GILLT_v4s16*//*Label 6488*/ GIMT_Encode4(321884),
     /* 321678 */ /*GILLT_v4s32*//*Label 6489*/ GIMT_Encode4(321911), GIMT_Encode4(0),
     /* 321686 */ /*GILLT_v8s16*//*Label 6490*/ GIMT_Encode4(321935),
     /* 321690 */ // Label 6484: @321690
     /* 321690 */ GIM_Try, /*On fail goto*//*Label 6492*/ GIMT_Encode4(321716), // Rule ID 4593 //
     /* 321695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 321701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321705 */   // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 321705 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 321710 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321714 */   GIR_RootConstrainSelectedInstOperands,
     /* 321715 */   // GIR_Coverage, 4593,
     /* 321715 */   GIR_Done,
     /* 321716 */ // Label 6492: @321716
     /* 321716 */ GIM_Try, /*On fail goto*//*Label 6493*/ GIMT_Encode4(321739), // Rule ID 4595 //
     /* 321721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321728 */   // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 321728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 321733 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321737 */   GIR_RootConstrainSelectedInstOperands,
     /* 321738 */   // GIR_Coverage, 4595,
     /* 321738 */   GIR_Done,
     /* 321739 */ // Label 6493: @321739
     /* 321739 */ GIM_Try, /*On fail goto*//*Label 6494*/ GIMT_Encode4(321762), // Rule ID 4597 //
     /* 321744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 321747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 321751 */   // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 321751 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 321756 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321760 */   GIR_RootConstrainSelectedInstOperands,
     /* 321761 */   // GIR_Coverage, 4597,
     /* 321761 */   GIR_Done,
     /* 321762 */ // Label 6494: @321762
     /* 321762 */ GIM_Reject,
     /* 321763 */ // Label 6485: @321763
     /* 321763 */ GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(321789), // Rule ID 4594 //
     /* 321768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 321774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 321778 */   // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 321778 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 321783 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321787 */   GIR_RootConstrainSelectedInstOperands,
     /* 321788 */   // GIR_Coverage, 4594,
     /* 321788 */   GIR_Done,
     /* 321789 */ // Label 6495: @321789
     /* 321789 */ GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(321812), // Rule ID 4596 //
     /* 321794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 321797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 321801 */   // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 321801 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 321806 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321810 */   GIR_RootConstrainSelectedInstOperands,
     /* 321811 */   // GIR_Coverage, 4596,
     /* 321811 */   GIR_Done,
     /* 321812 */ // Label 6496: @321812
     /* 321812 */ GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(321835), // Rule ID 4598 //
     /* 321817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 321820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 321824 */   // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 321824 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 321829 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321833 */   GIR_RootConstrainSelectedInstOperands,
     /* 321834 */   // GIR_Coverage, 4598,
     /* 321834 */   GIR_Done,
     /* 321835 */ // Label 6497: @321835
     /* 321835 */ GIM_Reject,
     /* 321836 */ // Label 6486: @321836
     /* 321836 */ GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(321859), // Rule ID 4920 //
     /* 321841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 321844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321848 */   // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 321848 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 321853 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321857 */   GIR_RootConstrainSelectedInstOperands,
     /* 321858 */   // GIR_Coverage, 4920,
     /* 321858 */   GIR_Done,
     /* 321859 */ // Label 6498: @321859
     /* 321859 */ GIM_Reject,
     /* 321860 */ // Label 6487: @321860
     /* 321860 */ GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(321883), // Rule ID 4922 //
     /* 321865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321872 */   // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 321872 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 321877 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321881 */   GIR_RootConstrainSelectedInstOperands,
     /* 321882 */   // GIR_Coverage, 4922,
     /* 321882 */   GIR_Done,
     /* 321883 */ // Label 6499: @321883
     /* 321883 */ GIM_Reject,
     /* 321884 */ // Label 6488: @321884
     /* 321884 */ GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(321910), // Rule ID 4915 //
     /* 321889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321899 */   // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 321899 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 321904 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321908 */   GIR_RootConstrainSelectedInstOperands,
     /* 321909 */   // GIR_Coverage, 4915,
     /* 321909 */   GIR_Done,
     /* 321910 */ // Label 6500: @321910
     /* 321910 */ GIM_Reject,
     /* 321911 */ // Label 6489: @321911
     /* 321911 */ GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(321934), // Rule ID 4921 //
     /* 321916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 321919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321923 */   // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 321923 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 321928 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321932 */   GIR_RootConstrainSelectedInstOperands,
     /* 321933 */   // GIR_Coverage, 4921,
     /* 321933 */   GIR_Done,
     /* 321934 */ // Label 6501: @321934
     /* 321934 */ GIM_Reject,
     /* 321935 */ // Label 6490: @321935
     /* 321935 */ GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(321961), // Rule ID 4916 //
     /* 321940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 321943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 321946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321950 */   // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 321950 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 321955 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 321959 */   GIR_RootConstrainSelectedInstOperands,
     /* 321960 */   // GIR_Coverage, 4916,
     /* 321960 */   GIR_Done,
     /* 321961 */ // Label 6502: @321961
     /* 321961 */ GIM_Reject,
     /* 321962 */ // Label 6491: @321962
     /* 321962 */ GIM_Reject,
     /* 321963 */ // Label 71: @321963
     /* 321963 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6511*/ GIMT_Encode4(322819),
     /* 321974 */ /*GILLT_s16*//*Label 6503*/ GIMT_Encode4(322014),
     /* 321978 */ /*GILLT_s32*//*Label 6504*/ GIMT_Encode4(322233),
     /* 321982 */ /*GILLT_s64*//*Label 6505*/ GIMT_Encode4(322307), GIMT_Encode4(0),
     /* 321990 */ /*GILLT_v2s32*//*Label 6506*/ GIMT_Encode4(322381),
     /* 321994 */ /*GILLT_v2s64*//*Label 6507*/ GIMT_Encode4(322455),
     /* 321998 */ /*GILLT_v4s16*//*Label 6508*/ GIMT_Encode4(322529),
     /* 322002 */ /*GILLT_v4s32*//*Label 6509*/ GIMT_Encode4(322637), GIMT_Encode4(0),
     /* 322010 */ /*GILLT_v8s16*//*Label 6510*/ GIMT_Encode4(322711),
     /* 322014 */ // Label 6503: @322014
     /* 322014 */ GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(322232),
     /* 322019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 322022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322026 */   GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(322067), // Rule ID 5191 //
     /* 322031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 322042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 322050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322052 */     // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
     /* 322052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 322055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 322065 */     GIR_RootConstrainSelectedInstOperands,
     /* 322066 */     // GIR_Coverage, 5191,
     /* 322066 */     GIR_EraseRootFromParent_Done,
     /* 322067 */   // Label 6513: @322067
     /* 322067 */   GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(322086), // Rule ID 521 //
     /* 322072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 322075 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322079 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 322079 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
     /* 322084 */     GIR_RootConstrainSelectedInstOperands,
     /* 322085 */     // GIR_Coverage, 521,
     /* 322085 */     GIR_Done,
     /* 322086 */   // Label 6514: @322086
     /* 322086 */   GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(322231), // Rule ID 6345 //
     /* 322091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322095 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 322095 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 322098 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 322102 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 322109 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 322112 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 322116 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322121 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 322124 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 322128 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 322131 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322136 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322141 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322146 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 322149 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 322153 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322158 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 322161 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 322166 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 322169 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /* 322173 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322178 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 322181 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 322186 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 322188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 322191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 322195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322200 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 322203 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 322211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322213 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 322220 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322225 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322230 */     // GIR_Coverage, 6345,
     /* 322230 */     GIR_EraseRootFromParent_Done,
     /* 322231 */   // Label 6515: @322231
     /* 322231 */   GIM_Reject,
     /* 322232 */ // Label 6512: @322232
     /* 322232 */ GIM_Reject,
     /* 322233 */ // Label 6504: @322233
     /* 322233 */ GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(322306),
     /* 322238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322245 */   GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(322286), // Rule ID 5192 //
     /* 322250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 322261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 322265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 322269 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322271 */     // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
     /* 322271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 322274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 322284 */     GIR_RootConstrainSelectedInstOperands,
     /* 322285 */     // GIR_Coverage, 5192,
     /* 322285 */     GIR_EraseRootFromParent_Done,
     /* 322286 */   // Label 6517: @322286
     /* 322286 */   GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(322305), // Rule ID 522 //
     /* 322291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 322294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322298 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 322298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
     /* 322303 */     GIR_RootConstrainSelectedInstOperands,
     /* 322304 */     // GIR_Coverage, 522,
     /* 322304 */     GIR_Done,
     /* 322305 */   // Label 6518: @322305
     /* 322305 */   GIM_Reject,
     /* 322306 */ // Label 6516: @322306
     /* 322306 */ GIM_Reject,
     /* 322307 */ // Label 6505: @322307
     /* 322307 */ GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(322380),
     /* 322312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322319 */   GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(322360), // Rule ID 5193 //
     /* 322324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 322335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 322339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322343 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322345 */     // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
     /* 322345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 322348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 322358 */     GIR_RootConstrainSelectedInstOperands,
     /* 322359 */     // GIR_Coverage, 5193,
     /* 322359 */     GIR_EraseRootFromParent_Done,
     /* 322360 */   // Label 6520: @322360
     /* 322360 */   GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(322379), // Rule ID 523 //
     /* 322365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 322368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322372 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 322372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
     /* 322377 */     GIR_RootConstrainSelectedInstOperands,
     /* 322378 */     // GIR_Coverage, 523,
     /* 322378 */     GIR_Done,
     /* 322379 */   // Label 6521: @322379
     /* 322379 */   GIM_Reject,
     /* 322380 */ // Label 6519: @322380
     /* 322380 */ GIM_Reject,
     /* 322381 */ // Label 6506: @322381
     /* 322381 */ GIM_Try, /*On fail goto*//*Label 6522*/ GIMT_Encode4(322454),
     /* 322386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 322389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322393 */   GIM_Try, /*On fail goto*//*Label 6523*/ GIMT_Encode4(322434), // Rule ID 4984 //
     /* 322398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 322409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 322413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 322417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322419 */     // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
     /* 322419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 322422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 322432 */     GIR_RootConstrainSelectedInstOperands,
     /* 322433 */     // GIR_Coverage, 4984,
     /* 322433 */     GIR_EraseRootFromParent_Done,
     /* 322434 */   // Label 6523: @322434
     /* 322434 */   GIM_Try, /*On fail goto*//*Label 6524*/ GIMT_Encode4(322453), // Rule ID 768 //
     /* 322439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322446 */     // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 322446 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
     /* 322451 */     GIR_RootConstrainSelectedInstOperands,
     /* 322452 */     // GIR_Coverage, 768,
     /* 322452 */     GIR_Done,
     /* 322453 */   // Label 6524: @322453
     /* 322453 */   GIM_Reject,
     /* 322454 */ // Label 6522: @322454
     /* 322454 */ GIM_Reject,
     /* 322455 */ // Label 6507: @322455
     /* 322455 */ GIM_Try, /*On fail goto*//*Label 6525*/ GIMT_Encode4(322528),
     /* 322460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322467 */   GIM_Try, /*On fail goto*//*Label 6526*/ GIMT_Encode4(322508), // Rule ID 4986 //
     /* 322472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 322483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 322491 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322493 */     // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
     /* 322493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 322496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 322506 */     GIR_RootConstrainSelectedInstOperands,
     /* 322507 */     // GIR_Coverage, 4986,
     /* 322507 */     GIR_EraseRootFromParent_Done,
     /* 322508 */   // Label 6526: @322508
     /* 322508 */   GIM_Try, /*On fail goto*//*Label 6527*/ GIMT_Encode4(322527), // Rule ID 770 //
     /* 322513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322520 */     // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 322520 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
     /* 322525 */     GIR_RootConstrainSelectedInstOperands,
     /* 322526 */     // GIR_Coverage, 770,
     /* 322526 */     GIR_Done,
     /* 322527 */   // Label 6527: @322527
     /* 322527 */   GIM_Reject,
     /* 322528 */ // Label 6525: @322528
     /* 322528 */ GIM_Reject,
     /* 322529 */ // Label 6508: @322529
     /* 322529 */ GIM_Try, /*On fail goto*//*Label 6528*/ GIMT_Encode4(322636),
     /* 322534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322541 */   GIM_Try, /*On fail goto*//*Label 6529*/ GIMT_Encode4(322582), // Rule ID 4987 //
     /* 322546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 322557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 322565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322567 */     // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
     /* 322567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 322570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 322580 */     GIR_RootConstrainSelectedInstOperands,
     /* 322581 */     // GIR_Coverage, 4987,
     /* 322581 */     GIR_EraseRootFromParent_Done,
     /* 322582 */   // Label 6529: @322582
     /* 322582 */   GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(322601), // Rule ID 766 //
     /* 322587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322590 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322594 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 322594 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
     /* 322599 */     GIR_RootConstrainSelectedInstOperands,
     /* 322600 */     // GIR_Coverage, 766,
     /* 322600 */     GIR_Done,
     /* 322601 */   // Label 6530: @322601
     /* 322601 */   GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(322635), // Rule ID 6347 //
     /* 322606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322613 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 322613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
     /* 322616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322618 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322620 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 322630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 322633 */     GIR_RootConstrainSelectedInstOperands,
     /* 322634 */     // GIR_Coverage, 6347,
     /* 322634 */     GIR_EraseRootFromParent_Done,
     /* 322635 */   // Label 6531: @322635
     /* 322635 */   GIM_Reject,
     /* 322636 */ // Label 6528: @322636
     /* 322636 */ GIM_Reject,
     /* 322637 */ // Label 6509: @322637
     /* 322637 */ GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(322710),
     /* 322642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322649 */   GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(322690), // Rule ID 4985 //
     /* 322654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 322665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 322669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 322673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322675 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
     /* 322675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 322678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 322688 */     GIR_RootConstrainSelectedInstOperands,
     /* 322689 */     // GIR_Coverage, 4985,
     /* 322689 */     GIR_EraseRootFromParent_Done,
     /* 322690 */   // Label 6533: @322690
     /* 322690 */   GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(322709), // Rule ID 769 //
     /* 322695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322702 */     // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 322702 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
     /* 322707 */     GIR_RootConstrainSelectedInstOperands,
     /* 322708 */     // GIR_Coverage, 769,
     /* 322708 */     GIR_Done,
     /* 322709 */   // Label 6534: @322709
     /* 322709 */   GIM_Reject,
     /* 322710 */ // Label 6532: @322710
     /* 322710 */ GIM_Reject,
     /* 322711 */ // Label 6510: @322711
     /* 322711 */ GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(322818),
     /* 322716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322723 */   GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(322764), // Rule ID 4988 //
     /* 322728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322731 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322735 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 322739 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322743 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 322747 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322749 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
     /* 322749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 322752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 322762 */     GIR_RootConstrainSelectedInstOperands,
     /* 322763 */     // GIR_Coverage, 4988,
     /* 322763 */     GIR_EraseRootFromParent_Done,
     /* 322764 */   // Label 6536: @322764
     /* 322764 */   GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(322783), // Rule ID 767 //
     /* 322769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322776 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 322776 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
     /* 322781 */     GIR_RootConstrainSelectedInstOperands,
     /* 322782 */     // GIR_Coverage, 767,
     /* 322782 */     GIR_Done,
     /* 322783 */   // Label 6537: @322783
     /* 322783 */   GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(322817), // Rule ID 6348 //
     /* 322788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322795 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 322795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
     /* 322798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322800 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322802 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 322812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 322815 */     GIR_RootConstrainSelectedInstOperands,
     /* 322816 */     // GIR_Coverage, 6348,
     /* 322816 */     GIR_EraseRootFromParent_Done,
     /* 322817 */   // Label 6538: @322817
     /* 322817 */   GIM_Reject,
     /* 322818 */ // Label 6535: @322818
     /* 322818 */ GIM_Reject,
     /* 322819 */ // Label 6511: @322819
     /* 322819 */ GIM_Reject,
     /* 322820 */ // Label 72: @322820
     /* 322820 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6547*/ GIMT_Encode4(323101),
     /* 322831 */ /*GILLT_s16*//*Label 6539*/ GIMT_Encode4(322871),
     /* 322835 */ /*GILLT_s32*//*Label 6540*/ GIMT_Encode4(322898),
     /* 322839 */ /*GILLT_s64*//*Label 6541*/ GIMT_Encode4(322922), GIMT_Encode4(0),
     /* 322847 */ /*GILLT_v2s32*//*Label 6542*/ GIMT_Encode4(322946),
     /* 322851 */ /*GILLT_v2s64*//*Label 6543*/ GIMT_Encode4(322977),
     /* 322855 */ /*GILLT_v4s16*//*Label 6544*/ GIMT_Encode4(323008),
     /* 322859 */ /*GILLT_v4s32*//*Label 6545*/ GIMT_Encode4(323039), GIMT_Encode4(0),
     /* 322867 */ /*GILLT_v8s16*//*Label 6546*/ GIMT_Encode4(323070),
     /* 322871 */ // Label 6539: @322871
     /* 322871 */ GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(322897), // Rule ID 4809 //
     /* 322876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 322879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 322882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 322886 */   // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
     /* 322886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 322889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322891 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322893 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322895 */   GIR_RootConstrainSelectedInstOperands,
     /* 322896 */   // GIR_Coverage, 4809,
     /* 322896 */   GIR_EraseRootFromParent_Done,
     /* 322897 */ // Label 6548: @322897
     /* 322897 */ GIM_Reject,
     /* 322898 */ // Label 6540: @322898
     /* 322898 */ GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(322921), // Rule ID 4806 //
     /* 322903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 322906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 322910 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
     /* 322910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 322913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322915 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322917 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322919 */   GIR_RootConstrainSelectedInstOperands,
     /* 322920 */   // GIR_Coverage, 4806,
     /* 322920 */   GIR_EraseRootFromParent_Done,
     /* 322921 */ // Label 6549: @322921
     /* 322921 */ GIM_Reject,
     /* 322922 */ // Label 6541: @322922
     /* 322922 */ GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(322945), // Rule ID 4803 //
     /* 322927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 322930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322934 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
     /* 322934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 322937 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322939 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322941 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 322943 */   GIR_RootConstrainSelectedInstOperands,
     /* 322944 */   // GIR_Coverage, 4803,
     /* 322944 */   GIR_EraseRootFromParent_Done,
     /* 322945 */ // Label 6550: @322945
     /* 322945 */ GIM_Reject,
     /* 322946 */ // Label 6542: @322946
     /* 322946 */ GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(322976), // Rule ID 4997 //
     /* 322951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 322957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322965 */   // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
     /* 322965 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 322968 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 322970 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322972 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322974 */   GIR_RootConstrainSelectedInstOperands,
     /* 322975 */   // GIR_Coverage, 4997,
     /* 322975 */   GIR_EraseRootFromParent_Done,
     /* 322976 */ // Label 6551: @322976
     /* 322976 */ GIM_Reject,
     /* 322977 */ // Label 6543: @322977
     /* 322977 */ GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(323007), // Rule ID 4991 //
     /* 322982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 322985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 322988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322996 */   // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
     /* 322996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 322999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323001 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323003 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323005 */   GIR_RootConstrainSelectedInstOperands,
     /* 323006 */   // GIR_Coverage, 4991,
     /* 323006 */   GIR_EraseRootFromParent_Done,
     /* 323007 */ // Label 6552: @323007
     /* 323007 */ GIM_Reject,
     /* 323008 */ // Label 6544: @323008
     /* 323008 */ GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(323038), // Rule ID 5003 //
     /* 323013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323027 */   // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
     /* 323027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 323030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323032 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323034 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323036 */   GIR_RootConstrainSelectedInstOperands,
     /* 323037 */   // GIR_Coverage, 5003,
     /* 323037 */   GIR_EraseRootFromParent_Done,
     /* 323038 */ // Label 6553: @323038
     /* 323038 */ GIM_Reject,
     /* 323039 */ // Label 6545: @323039
     /* 323039 */ GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(323069), // Rule ID 4994 //
     /* 323044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323058 */   // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
     /* 323058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 323061 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323063 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323065 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323067 */   GIR_RootConstrainSelectedInstOperands,
     /* 323068 */   // GIR_Coverage, 4994,
     /* 323068 */   GIR_EraseRootFromParent_Done,
     /* 323069 */ // Label 6554: @323069
     /* 323069 */ GIM_Reject,
     /* 323070 */ // Label 6546: @323070
     /* 323070 */ GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(323100), // Rule ID 5000 //
     /* 323075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323089 */   // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
     /* 323089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 323092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 323094 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323096 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323098 */   GIR_RootConstrainSelectedInstOperands,
     /* 323099 */   // GIR_Coverage, 5000,
     /* 323099 */   GIR_EraseRootFromParent_Done,
     /* 323100 */ // Label 6555: @323100
     /* 323100 */ GIM_Reject,
     /* 323101 */ // Label 6547: @323101
     /* 323101 */ GIM_Reject,
     /* 323102 */ // Label 73: @323102
     /* 323102 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6564*/ GIMT_Encode4(323479),
     /* 323113 */ /*GILLT_s16*//*Label 6556*/ GIMT_Encode4(323153),
     /* 323117 */ /*GILLT_s32*//*Label 6557*/ GIMT_Encode4(323191),
     /* 323121 */ /*GILLT_s64*//*Label 6558*/ GIMT_Encode4(323229), GIMT_Encode4(0),
     /* 323129 */ /*GILLT_v2s32*//*Label 6559*/ GIMT_Encode4(323289),
     /* 323133 */ /*GILLT_v2s64*//*Label 6560*/ GIMT_Encode4(323327),
     /* 323137 */ /*GILLT_v4s16*//*Label 6561*/ GIMT_Encode4(323365),
     /* 323141 */ /*GILLT_v4s32*//*Label 6562*/ GIMT_Encode4(323403), GIMT_Encode4(0),
     /* 323149 */ /*GILLT_v8s16*//*Label 6563*/ GIMT_Encode4(323441),
     /* 323153 */ // Label 6556: @323153
     /* 323153 */ GIM_Try, /*On fail goto*//*Label 6565*/ GIMT_Encode4(323190), // Rule ID 608 //
     /* 323158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 323161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 323164 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 323167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323175 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323179 */   // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 323179 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 323184 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323188 */   GIR_RootConstrainSelectedInstOperands,
     /* 323189 */   // GIR_Coverage, 608,
     /* 323189 */   GIR_Done,
     /* 323190 */ // Label 6565: @323190
     /* 323190 */ GIM_Reject,
     /* 323191 */ // Label 6557: @323191
     /* 323191 */ GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(323228), // Rule ID 610 //
     /* 323196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 323199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 323205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323209 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323213 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323217 */   // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 323217 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 323222 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323226 */   GIR_RootConstrainSelectedInstOperands,
     /* 323227 */   // GIR_Coverage, 610,
     /* 323227 */   GIR_Done,
     /* 323228 */ // Label 6566: @323228
     /* 323228 */ GIM_Reject,
     /* 323229 */ // Label 6558: @323229
     /* 323229 */ GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(323288),
     /* 323234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323237 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 323240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323248 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323252 */   GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(323271), // Rule ID 612 //
     /* 323257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 323260 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 323260 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 323265 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323269 */     GIR_RootConstrainSelectedInstOperands,
     /* 323270 */     // GIR_Coverage, 612,
     /* 323270 */     GIR_Done,
     /* 323271 */   // Label 6568: @323271
     /* 323271 */   GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(323287), // Rule ID 4800 //
     /* 323276 */     // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 323276 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 323281 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323285 */     GIR_RootConstrainSelectedInstOperands,
     /* 323286 */     // GIR_Coverage, 4800,
     /* 323286 */     GIR_Done,
     /* 323287 */   // Label 6569: @323287
     /* 323287 */   GIM_Reject,
     /* 323288 */ // Label 6567: @323288
     /* 323288 */ GIM_Reject,
     /* 323289 */ // Label 6559: @323289
     /* 323289 */ GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(323326), // Rule ID 1273 //
     /* 323294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 323303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323315 */   // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 323315 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 323320 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323324 */   GIR_RootConstrainSelectedInstOperands,
     /* 323325 */   // GIR_Coverage, 1273,
     /* 323325 */   GIR_Done,
     /* 323326 */ // Label 6570: @323326
     /* 323326 */ GIM_Reject,
     /* 323327 */ // Label 6560: @323327
     /* 323327 */ GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(323364), // Rule ID 1277 //
     /* 323332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 323341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323349 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323353 */   // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 323353 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 323358 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323362 */   GIR_RootConstrainSelectedInstOperands,
     /* 323363 */   // GIR_Coverage, 1277,
     /* 323363 */   GIR_Done,
     /* 323364 */ // Label 6571: @323364
     /* 323364 */ GIM_Reject,
     /* 323365 */ // Label 6561: @323365
     /* 323365 */ GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(323402), // Rule ID 1269 //
     /* 323370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323376 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 323379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323387 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323391 */   // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 323391 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 323396 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323400 */   GIR_RootConstrainSelectedInstOperands,
     /* 323401 */   // GIR_Coverage, 1269,
     /* 323401 */   GIR_Done,
     /* 323402 */ // Label 6572: @323402
     /* 323402 */ GIM_Reject,
     /* 323403 */ // Label 6562: @323403
     /* 323403 */ GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(323440), // Rule ID 1275 //
     /* 323408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 323417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323421 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323425 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323429 */   // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 323429 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 323434 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323438 */   GIR_RootConstrainSelectedInstOperands,
     /* 323439 */   // GIR_Coverage, 1275,
     /* 323439 */   GIR_Done,
     /* 323440 */ // Label 6573: @323440
     /* 323440 */ GIM_Reject,
     /* 323441 */ // Label 6563: @323441
     /* 323441 */ GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(323478), // Rule ID 1271 //
     /* 323446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323452 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 323455 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323459 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323463 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323467 */   // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 323467 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 323472 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323476 */   GIR_RootConstrainSelectedInstOperands,
     /* 323477 */   // GIR_Coverage, 1271,
     /* 323477 */   GIR_Done,
     /* 323478 */ // Label 6574: @323478
     /* 323478 */ GIM_Reject,
     /* 323479 */ // Label 6564: @323479
     /* 323479 */ GIM_Reject,
     /* 323480 */ // Label 74: @323480
     /* 323480 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6583*/ GIMT_Encode4(323857),
     /* 323491 */ /*GILLT_s16*//*Label 6575*/ GIMT_Encode4(323531),
     /* 323495 */ /*GILLT_s32*//*Label 6576*/ GIMT_Encode4(323569),
     /* 323499 */ /*GILLT_s64*//*Label 6577*/ GIMT_Encode4(323607), GIMT_Encode4(0),
     /* 323507 */ /*GILLT_v2s32*//*Label 6578*/ GIMT_Encode4(323667),
     /* 323511 */ /*GILLT_v2s64*//*Label 6579*/ GIMT_Encode4(323705),
     /* 323515 */ /*GILLT_v4s16*//*Label 6580*/ GIMT_Encode4(323743),
     /* 323519 */ /*GILLT_v4s32*//*Label 6581*/ GIMT_Encode4(323781), GIMT_Encode4(0),
     /* 323527 */ /*GILLT_v8s16*//*Label 6582*/ GIMT_Encode4(323819),
     /* 323531 */ // Label 6575: @323531
     /* 323531 */ GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(323568), // Rule ID 596 //
     /* 323536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 323539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 323542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 323545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323553 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323557 */   // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 323557 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 323562 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323566 */   GIR_RootConstrainSelectedInstOperands,
     /* 323567 */   // GIR_Coverage, 596,
     /* 323567 */   GIR_Done,
     /* 323568 */ // Label 6584: @323568
     /* 323568 */ GIM_Reject,
     /* 323569 */ // Label 6576: @323569
     /* 323569 */ GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(323606), // Rule ID 598 //
     /* 323574 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 323577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 323583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323591 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323595 */   // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 323595 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 323600 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323604 */   GIR_RootConstrainSelectedInstOperands,
     /* 323605 */   // GIR_Coverage, 598,
     /* 323605 */   GIR_Done,
     /* 323606 */ // Label 6585: @323606
     /* 323606 */ GIM_Reject,
     /* 323607 */ // Label 6577: @323607
     /* 323607 */ GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(323666),
     /* 323612 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323615 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 323618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323626 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323630 */   GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(323649), // Rule ID 600 //
     /* 323635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 323638 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 323638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 323643 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323647 */     GIR_RootConstrainSelectedInstOperands,
     /* 323648 */     // GIR_Coverage, 600,
     /* 323648 */     GIR_Done,
     /* 323649 */   // Label 6587: @323649
     /* 323649 */   GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(323665), // Rule ID 4799 //
     /* 323654 */     // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 323654 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 323659 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323663 */     GIR_RootConstrainSelectedInstOperands,
     /* 323664 */     // GIR_Coverage, 4799,
     /* 323664 */     GIR_Done,
     /* 323665 */   // Label 6588: @323665
     /* 323665 */   GIM_Reject,
     /* 323666 */ // Label 6586: @323666
     /* 323666 */ GIM_Reject,
     /* 323667 */ // Label 6578: @323667
     /* 323667 */ GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(323704), // Rule ID 1243 //
     /* 323672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 323678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 323681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323689 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323693 */   // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 323693 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 323698 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323702 */   GIR_RootConstrainSelectedInstOperands,
     /* 323703 */   // GIR_Coverage, 1243,
     /* 323703 */   GIR_Done,
     /* 323704 */ // Label 6589: @323704
     /* 323704 */ GIM_Reject,
     /* 323705 */ // Label 6579: @323705
     /* 323705 */ GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(323742), // Rule ID 1247 //
     /* 323710 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323713 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 323716 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 323719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323731 */   // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 323731 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 323736 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323740 */   GIR_RootConstrainSelectedInstOperands,
     /* 323741 */   // GIR_Coverage, 1247,
     /* 323741 */   GIR_Done,
     /* 323742 */ // Label 6590: @323742
     /* 323742 */ GIM_Reject,
     /* 323743 */ // Label 6580: @323743
     /* 323743 */ GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(323780), // Rule ID 1239 //
     /* 323748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 323757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323765 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323769 */   // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 323769 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 323774 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323778 */   GIR_RootConstrainSelectedInstOperands,
     /* 323779 */   // GIR_Coverage, 1239,
     /* 323779 */   GIR_Done,
     /* 323780 */ // Label 6591: @323780
     /* 323780 */ GIM_Reject,
     /* 323781 */ // Label 6581: @323781
     /* 323781 */ GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(323818), // Rule ID 1245 //
     /* 323786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 323795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323803 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323807 */   // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 323807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 323812 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323816 */   GIR_RootConstrainSelectedInstOperands,
     /* 323817 */   // GIR_Coverage, 1245,
     /* 323817 */   GIR_Done,
     /* 323818 */ // Label 6592: @323818
     /* 323818 */ GIM_Reject,
     /* 323819 */ // Label 6582: @323819
     /* 323819 */ GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(323856), // Rule ID 1241 //
     /* 323824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 323830 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 323833 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323837 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323841 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323845 */   // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 323845 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 323850 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323854 */   GIR_RootConstrainSelectedInstOperands,
     /* 323855 */   // GIR_Coverage, 1241,
     /* 323855 */   GIR_Done,
     /* 323856 */ // Label 6593: @323856
     /* 323856 */ GIM_Reject,
     /* 323857 */ // Label 6583: @323857
     /* 323857 */ GIM_Reject,
     /* 323858 */ // Label 75: @323858
     /* 323858 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6602*/ GIMT_Encode4(324207),
     /* 323869 */ /*GILLT_s16*//*Label 6594*/ GIMT_Encode4(323909),
     /* 323873 */ /*GILLT_s32*//*Label 6595*/ GIMT_Encode4(323947),
     /* 323877 */ /*GILLT_s64*//*Label 6596*/ GIMT_Encode4(323982), GIMT_Encode4(0),
     /* 323885 */ /*GILLT_v2s32*//*Label 6597*/ GIMT_Encode4(324017),
     /* 323889 */ /*GILLT_v2s64*//*Label 6598*/ GIMT_Encode4(324055),
     /* 323893 */ /*GILLT_v4s16*//*Label 6599*/ GIMT_Encode4(324093),
     /* 323897 */ /*GILLT_v4s32*//*Label 6600*/ GIMT_Encode4(324131), GIMT_Encode4(0),
     /* 323905 */ /*GILLT_v8s16*//*Label 6601*/ GIMT_Encode4(324169),
     /* 323909 */ // Label 6594: @323909
     /* 323909 */ GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(323946), // Rule ID 4807 //
     /* 323914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 323917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 323920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 323923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323931 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 323935 */   // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 323935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 323940 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323944 */   GIR_RootConstrainSelectedInstOperands,
     /* 323945 */   // GIR_Coverage, 4807,
     /* 323945 */   GIR_Done,
     /* 323946 */ // Label 6603: @323946
     /* 323946 */ GIM_Reject,
     /* 323947 */ // Label 6595: @323947
     /* 323947 */ GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(323981), // Rule ID 4804 //
     /* 323952 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 323955 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 323958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323966 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323970 */   // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 323970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 323975 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 323979 */   GIR_RootConstrainSelectedInstOperands,
     /* 323980 */   // GIR_Coverage, 4804,
     /* 323980 */   GIR_Done,
     /* 323981 */ // Label 6604: @323981
     /* 323981 */ GIM_Reject,
     /* 323982 */ // Label 6596: @323982
     /* 323982 */ GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(324016), // Rule ID 4801 //
     /* 323987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 323990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 323993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324001 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324005 */   // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 324005 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 324010 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324014 */   GIR_RootConstrainSelectedInstOperands,
     /* 324015 */   // GIR_Coverage, 4801,
     /* 324015 */   GIR_Done,
     /* 324016 */ // Label 6605: @324016
     /* 324016 */ GIM_Reject,
     /* 324017 */ // Label 6597: @324017
     /* 324017 */ GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(324054), // Rule ID 4995 //
     /* 324022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 324031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324039 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324043 */   // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 324043 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 324048 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324052 */   GIR_RootConstrainSelectedInstOperands,
     /* 324053 */   // GIR_Coverage, 4995,
     /* 324053 */   GIR_Done,
     /* 324054 */ // Label 6606: @324054
     /* 324054 */ GIM_Reject,
     /* 324055 */ // Label 6598: @324055
     /* 324055 */ GIM_Try, /*On fail goto*//*Label 6607*/ GIMT_Encode4(324092), // Rule ID 4989 //
     /* 324060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 324069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324081 */   // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 324081 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 324086 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324090 */   GIR_RootConstrainSelectedInstOperands,
     /* 324091 */   // GIR_Coverage, 4989,
     /* 324091 */   GIR_Done,
     /* 324092 */ // Label 6607: @324092
     /* 324092 */ GIM_Reject,
     /* 324093 */ // Label 6599: @324093
     /* 324093 */ GIM_Try, /*On fail goto*//*Label 6608*/ GIMT_Encode4(324130), // Rule ID 5001 //
     /* 324098 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324104 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 324107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324111 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324115 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324119 */   // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 324119 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 324124 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324128 */   GIR_RootConstrainSelectedInstOperands,
     /* 324129 */   // GIR_Coverage, 5001,
     /* 324129 */   GIR_Done,
     /* 324130 */ // Label 6608: @324130
     /* 324130 */ GIM_Reject,
     /* 324131 */ // Label 6600: @324131
     /* 324131 */ GIM_Try, /*On fail goto*//*Label 6609*/ GIMT_Encode4(324168), // Rule ID 4992 //
     /* 324136 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 324145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324153 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324157 */   // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 324157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 324162 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324166 */   GIR_RootConstrainSelectedInstOperands,
     /* 324167 */   // GIR_Coverage, 4992,
     /* 324167 */   GIR_Done,
     /* 324168 */ // Label 6609: @324168
     /* 324168 */ GIM_Reject,
     /* 324169 */ // Label 6601: @324169
     /* 324169 */ GIM_Try, /*On fail goto*//*Label 6610*/ GIMT_Encode4(324206), // Rule ID 4998 //
     /* 324174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 324183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324187 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324191 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324195 */   // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324195 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 324200 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324204 */   GIR_RootConstrainSelectedInstOperands,
     /* 324205 */   // GIR_Coverage, 4998,
     /* 324205 */   GIR_Done,
     /* 324206 */ // Label 6610: @324206
     /* 324206 */ GIM_Reject,
     /* 324207 */ // Label 6602: @324207
     /* 324207 */ GIM_Reject,
     /* 324208 */ // Label 76: @324208
     /* 324208 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6619*/ GIMT_Encode4(324557),
     /* 324219 */ /*GILLT_s16*//*Label 6611*/ GIMT_Encode4(324259),
     /* 324223 */ /*GILLT_s32*//*Label 6612*/ GIMT_Encode4(324297),
     /* 324227 */ /*GILLT_s64*//*Label 6613*/ GIMT_Encode4(324332), GIMT_Encode4(0),
     /* 324235 */ /*GILLT_v2s32*//*Label 6614*/ GIMT_Encode4(324367),
     /* 324239 */ /*GILLT_v2s64*//*Label 6615*/ GIMT_Encode4(324405),
     /* 324243 */ /*GILLT_v4s16*//*Label 6616*/ GIMT_Encode4(324443),
     /* 324247 */ /*GILLT_v4s32*//*Label 6617*/ GIMT_Encode4(324481), GIMT_Encode4(0),
     /* 324255 */ /*GILLT_v8s16*//*Label 6618*/ GIMT_Encode4(324519),
     /* 324259 */ // Label 6611: @324259
     /* 324259 */ GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(324296), // Rule ID 4808 //
     /* 324264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 324270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 324273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324281 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324285 */   // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 324285 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 324290 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324294 */   GIR_RootConstrainSelectedInstOperands,
     /* 324295 */   // GIR_Coverage, 4808,
     /* 324295 */   GIR_Done,
     /* 324296 */ // Label 6620: @324296
     /* 324296 */ GIM_Reject,
     /* 324297 */ // Label 6612: @324297
     /* 324297 */ GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(324331), // Rule ID 4805 //
     /* 324302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324305 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 324308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324316 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324320 */   // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 324320 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 324325 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324329 */   GIR_RootConstrainSelectedInstOperands,
     /* 324330 */   // GIR_Coverage, 4805,
     /* 324330 */   GIR_Done,
     /* 324331 */ // Label 6621: @324331
     /* 324331 */ GIM_Reject,
     /* 324332 */ // Label 6613: @324332
     /* 324332 */ GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(324366), // Rule ID 4802 //
     /* 324337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 324343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324355 */   // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 324355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 324360 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324364 */   GIR_RootConstrainSelectedInstOperands,
     /* 324365 */   // GIR_Coverage, 4802,
     /* 324365 */   GIR_Done,
     /* 324366 */ // Label 6622: @324366
     /* 324366 */ GIM_Reject,
     /* 324367 */ // Label 6614: @324367
     /* 324367 */ GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(324404), // Rule ID 4996 //
     /* 324372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324378 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 324381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324389 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324393 */   // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 324393 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 324398 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324402 */   GIR_RootConstrainSelectedInstOperands,
     /* 324403 */   // GIR_Coverage, 4996,
     /* 324403 */   GIR_Done,
     /* 324404 */ // Label 6623: @324404
     /* 324404 */ GIM_Reject,
     /* 324405 */ // Label 6615: @324405
     /* 324405 */ GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(324442), // Rule ID 4990 //
     /* 324410 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324413 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324416 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 324419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324427 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324431 */   // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 324431 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 324436 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324440 */   GIR_RootConstrainSelectedInstOperands,
     /* 324441 */   // GIR_Coverage, 4990,
     /* 324441 */   GIR_Done,
     /* 324442 */ // Label 6624: @324442
     /* 324442 */ GIM_Reject,
     /* 324443 */ // Label 6616: @324443
     /* 324443 */ GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(324480), // Rule ID 5002 //
     /* 324448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 324457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324469 */   // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 324469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 324474 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324478 */   GIR_RootConstrainSelectedInstOperands,
     /* 324479 */   // GIR_Coverage, 5002,
     /* 324479 */   GIR_Done,
     /* 324480 */ // Label 6625: @324480
     /* 324480 */ GIM_Reject,
     /* 324481 */ // Label 6617: @324481
     /* 324481 */ GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(324518), // Rule ID 4993 //
     /* 324486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324492 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 324495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324499 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324503 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324507 */   // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 324507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 324512 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324516 */   GIR_RootConstrainSelectedInstOperands,
     /* 324517 */   // GIR_Coverage, 4993,
     /* 324517 */   GIR_Done,
     /* 324518 */ // Label 6626: @324518
     /* 324518 */ GIM_Reject,
     /* 324519 */ // Label 6618: @324519
     /* 324519 */ GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(324556), // Rule ID 4999 //
     /* 324524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 324533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324541 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324545 */   // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 324545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 324550 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324554 */   GIR_RootConstrainSelectedInstOperands,
     /* 324555 */   // GIR_Coverage, 4999,
     /* 324555 */   GIR_Done,
     /* 324556 */ // Label 6627: @324556
     /* 324556 */ GIM_Reject,
     /* 324557 */ // Label 6619: @324557
     /* 324557 */ GIM_Reject,
     /* 324558 */ // Label 77: @324558
     /* 324558 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6636*/ GIMT_Encode4(325260),
     /* 324569 */ /*GILLT_s16*//*Label 6628*/ GIMT_Encode4(324609),
     /* 324573 */ /*GILLT_s32*//*Label 6629*/ GIMT_Encode4(324647),
     /* 324577 */ /*GILLT_s64*//*Label 6630*/ GIMT_Encode4(324685), GIMT_Encode4(0),
     /* 324585 */ /*GILLT_v2s32*//*Label 6631*/ GIMT_Encode4(324745),
     /* 324589 */ /*GILLT_v2s64*//*Label 6632*/ GIMT_Encode4(324848),
     /* 324593 */ /*GILLT_v4s16*//*Label 6633*/ GIMT_Encode4(324951),
     /* 324597 */ /*GILLT_v4s32*//*Label 6634*/ GIMT_Encode4(325054), GIMT_Encode4(0),
     /* 324605 */ /*GILLT_v8s16*//*Label 6635*/ GIMT_Encode4(325157),
     /* 324609 */ // Label 6628: @324609
     /* 324609 */ GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(324646), // Rule ID 614 //
     /* 324614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 324617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 324620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 324623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324631 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 324635 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 324635 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
     /* 324640 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324644 */   GIR_RootConstrainSelectedInstOperands,
     /* 324645 */   // GIR_Coverage, 614,
     /* 324645 */   GIR_Done,
     /* 324646 */ // Label 6637: @324646
     /* 324646 */ GIM_Reject,
     /* 324647 */ // Label 6629: @324647
     /* 324647 */ GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(324684), // Rule ID 616 //
     /* 324652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 324658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 324661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324669 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324673 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 324673 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
     /* 324678 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324682 */   GIR_RootConstrainSelectedInstOperands,
     /* 324683 */   // GIR_Coverage, 616,
     /* 324683 */   GIR_Done,
     /* 324684 */ // Label 6638: @324684
     /* 324684 */ GIM_Reject,
     /* 324685 */ // Label 6630: @324685
     /* 324685 */ GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(324744),
     /* 324690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 324693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 324696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324704 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324708 */   GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(324727), // Rule ID 618 //
     /* 324713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 324716 */     // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 324716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 324721 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324725 */     GIR_RootConstrainSelectedInstOperands,
     /* 324726 */     // GIR_Coverage, 618,
     /* 324726 */     GIR_Done,
     /* 324727 */   // Label 6640: @324727
     /* 324727 */   GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(324743), // Rule ID 4798 //
     /* 324732 */     // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 324732 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 324737 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324741 */     GIR_RootConstrainSelectedInstOperands,
     /* 324742 */     // GIR_Coverage, 4798,
     /* 324742 */     GIR_Done,
     /* 324743 */   // Label 6641: @324743
     /* 324743 */   GIM_Reject,
     /* 324744 */ // Label 6639: @324744
     /* 324744 */ GIM_Reject,
     /* 324745 */ // Label 6631: @324745
     /* 324745 */ GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(324847),
     /* 324750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324753 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 324756 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324760 */   GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(324819), // Rule ID 2364 //
     /* 324765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 324797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324804 */     // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 324804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 324807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324817 */     GIR_RootConstrainSelectedInstOperands,
     /* 324818 */     // GIR_Coverage, 2364,
     /* 324818 */     GIR_EraseRootFromParent_Done,
     /* 324819 */   // Label 6643: @324819
     /* 324819 */   GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(324846), // Rule ID 1288 //
     /* 324824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324835 */     // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 324835 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
     /* 324840 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324844 */     GIR_RootConstrainSelectedInstOperands,
     /* 324845 */     // GIR_Coverage, 1288,
     /* 324845 */     GIR_Done,
     /* 324846 */   // Label 6644: @324846
     /* 324846 */   GIM_Reject,
     /* 324847 */ // Label 6642: @324847
     /* 324847 */ GIM_Reject,
     /* 324848 */ // Label 6632: @324848
     /* 324848 */ GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(324950),
     /* 324853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 324859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324863 */   GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(324922), // Rule ID 2370 //
     /* 324868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 324900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324907 */     // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 324907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 324910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 324912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324920 */     GIR_RootConstrainSelectedInstOperands,
     /* 324921 */     // GIR_Coverage, 2370,
     /* 324921 */     GIR_EraseRootFromParent_Done,
     /* 324922 */   // Label 6646: @324922
     /* 324922 */   GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(324949), // Rule ID 1292 //
     /* 324927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324938 */     // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 324938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
     /* 324943 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 324947 */     GIR_RootConstrainSelectedInstOperands,
     /* 324948 */     // GIR_Coverage, 1292,
     /* 324948 */     GIR_Done,
     /* 324949 */   // Label 6647: @324949
     /* 324949 */   GIM_Reject,
     /* 324950 */ // Label 6645: @324950
     /* 324950 */ GIM_Reject,
     /* 324951 */ // Label 6633: @324951
     /* 324951 */ GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(325053),
     /* 324956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 324962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324966 */   GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(325025), // Rule ID 2358 //
     /* 324971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 324974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 324986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 324991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 324999 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325010 */     // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 325010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 325013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325023 */     GIR_RootConstrainSelectedInstOperands,
     /* 325024 */     // GIR_Coverage, 2358,
     /* 325024 */     GIR_EraseRootFromParent_Done,
     /* 325025 */   // Label 6649: @325025
     /* 325025 */   GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(325052), // Rule ID 1284 //
     /* 325030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325041 */     // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 325041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
     /* 325046 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325050 */     GIR_RootConstrainSelectedInstOperands,
     /* 325051 */     // GIR_Coverage, 1284,
     /* 325051 */     GIR_Done,
     /* 325052 */   // Label 6650: @325052
     /* 325052 */   GIM_Reject,
     /* 325053 */ // Label 6648: @325053
     /* 325053 */ GIM_Reject,
     /* 325054 */ // Label 6634: @325054
     /* 325054 */ GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(325156),
     /* 325059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 325065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325069 */   GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(325128), // Rule ID 2367 //
     /* 325074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 325077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325113 */     // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 325113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 325116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325126 */     GIR_RootConstrainSelectedInstOperands,
     /* 325127 */     // GIR_Coverage, 2367,
     /* 325127 */     GIR_EraseRootFromParent_Done,
     /* 325128 */   // Label 6652: @325128
     /* 325128 */   GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(325155), // Rule ID 1290 //
     /* 325133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325144 */     // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 325144 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
     /* 325149 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325153 */     GIR_RootConstrainSelectedInstOperands,
     /* 325154 */     // GIR_Coverage, 1290,
     /* 325154 */     GIR_Done,
     /* 325155 */   // Label 6653: @325155
     /* 325155 */   GIM_Reject,
     /* 325156 */ // Label 6651: @325156
     /* 325156 */ GIM_Reject,
     /* 325157 */ // Label 6635: @325157
     /* 325157 */ GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(325259),
     /* 325162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 325168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325172 */   GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(325231), // Rule ID 2361 //
     /* 325177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 325180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325209 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325216 */     // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 325219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325229 */     GIR_RootConstrainSelectedInstOperands,
     /* 325230 */     // GIR_Coverage, 2361,
     /* 325230 */     GIR_EraseRootFromParent_Done,
     /* 325231 */   // Label 6655: @325231
     /* 325231 */   GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(325258), // Rule ID 1286 //
     /* 325236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325247 */     // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
     /* 325252 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325256 */     GIR_RootConstrainSelectedInstOperands,
     /* 325257 */     // GIR_Coverage, 1286,
     /* 325257 */     GIR_Done,
     /* 325258 */   // Label 6656: @325258
     /* 325258 */   GIM_Reject,
     /* 325259 */ // Label 6654: @325259
     /* 325259 */ GIM_Reject,
     /* 325260 */ // Label 6636: @325260
     /* 325260 */ GIM_Reject,
     /* 325261 */ // Label 78: @325261
     /* 325261 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6665*/ GIMT_Encode4(325963),
     /* 325272 */ /*GILLT_s16*//*Label 6657*/ GIMT_Encode4(325312),
     /* 325276 */ /*GILLT_s32*//*Label 6658*/ GIMT_Encode4(325350),
     /* 325280 */ /*GILLT_s64*//*Label 6659*/ GIMT_Encode4(325388), GIMT_Encode4(0),
     /* 325288 */ /*GILLT_v2s32*//*Label 6660*/ GIMT_Encode4(325448),
     /* 325292 */ /*GILLT_v2s64*//*Label 6661*/ GIMT_Encode4(325551),
     /* 325296 */ /*GILLT_v4s16*//*Label 6662*/ GIMT_Encode4(325654),
     /* 325300 */ /*GILLT_v4s32*//*Label 6663*/ GIMT_Encode4(325757), GIMT_Encode4(0),
     /* 325308 */ /*GILLT_v8s16*//*Label 6664*/ GIMT_Encode4(325860),
     /* 325312 */ // Label 6657: @325312
     /* 325312 */ GIM_Try, /*On fail goto*//*Label 6666*/ GIMT_Encode4(325349), // Rule ID 602 //
     /* 325317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 325323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 325326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325338 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 325338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
     /* 325343 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325347 */   GIR_RootConstrainSelectedInstOperands,
     /* 325348 */   // GIR_Coverage, 602,
     /* 325348 */   GIR_Done,
     /* 325349 */ // Label 6666: @325349
     /* 325349 */ GIM_Reject,
     /* 325350 */ // Label 6658: @325350
     /* 325350 */ GIM_Try, /*On fail goto*//*Label 6667*/ GIMT_Encode4(325387), // Rule ID 604 //
     /* 325355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 325358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 325361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 325364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325376 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 325376 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
     /* 325381 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325385 */   GIR_RootConstrainSelectedInstOperands,
     /* 325386 */   // GIR_Coverage, 604,
     /* 325386 */   GIR_Done,
     /* 325387 */ // Label 6667: @325387
     /* 325387 */ GIM_Reject,
     /* 325388 */ // Label 6659: @325388
     /* 325388 */ GIM_Try, /*On fail goto*//*Label 6668*/ GIMT_Encode4(325447),
     /* 325393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 325396 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 325399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325411 */   GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(325430), // Rule ID 606 //
     /* 325416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 325419 */     // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 325419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 325424 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325428 */     GIR_RootConstrainSelectedInstOperands,
     /* 325429 */     // GIR_Coverage, 606,
     /* 325429 */     GIR_Done,
     /* 325430 */   // Label 6669: @325430
     /* 325430 */   GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(325446), // Rule ID 4797 //
     /* 325435 */     // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 325435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 325440 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325444 */     GIR_RootConstrainSelectedInstOperands,
     /* 325445 */     // GIR_Coverage, 4797,
     /* 325445 */     GIR_Done,
     /* 325446 */   // Label 6670: @325446
     /* 325446 */   GIM_Reject,
     /* 325447 */ // Label 6668: @325447
     /* 325447 */ GIM_Reject,
     /* 325448 */ // Label 6660: @325448
     /* 325448 */ GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(325550),
     /* 325453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 325459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325463 */   GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(325522), // Rule ID 2349 //
     /* 325468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 325471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325488 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325492 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325496 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 325500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325505 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325507 */     // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 325507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 325510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325516 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325520 */     GIR_RootConstrainSelectedInstOperands,
     /* 325521 */     // GIR_Coverage, 2349,
     /* 325521 */     GIR_EraseRootFromParent_Done,
     /* 325522 */   // Label 6672: @325522
     /* 325522 */   GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(325549), // Rule ID 1258 //
     /* 325527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325538 */     // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 325538 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
     /* 325543 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325547 */     GIR_RootConstrainSelectedInstOperands,
     /* 325548 */     // GIR_Coverage, 1258,
     /* 325548 */     GIR_Done,
     /* 325549 */   // Label 6673: @325549
     /* 325549 */   GIM_Reject,
     /* 325550 */ // Label 6671: @325550
     /* 325550 */ GIM_Reject,
     /* 325551 */ // Label 6661: @325551
     /* 325551 */ GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(325653),
     /* 325556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325559 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 325562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325566 */   GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(325625), // Rule ID 2355 //
     /* 325571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 325574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325599 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 325603 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325608 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325610 */     // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 325610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 325613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325623 */     GIR_RootConstrainSelectedInstOperands,
     /* 325624 */     // GIR_Coverage, 2355,
     /* 325624 */     GIR_EraseRootFromParent_Done,
     /* 325625 */   // Label 6675: @325625
     /* 325625 */   GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(325652), // Rule ID 1262 //
     /* 325630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325641 */     // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 325641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
     /* 325646 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325650 */     GIR_RootConstrainSelectedInstOperands,
     /* 325651 */     // GIR_Coverage, 1262,
     /* 325651 */     GIR_Done,
     /* 325652 */   // Label 6676: @325652
     /* 325652 */   GIM_Reject,
     /* 325653 */ // Label 6674: @325653
     /* 325653 */ GIM_Reject,
     /* 325654 */ // Label 6662: @325654
     /* 325654 */ GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(325756),
     /* 325659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 325665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325669 */   GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(325728), // Rule ID 2343 //
     /* 325674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 325677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 325706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325713 */     // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 325713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 325716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325726 */     GIR_RootConstrainSelectedInstOperands,
     /* 325727 */     // GIR_Coverage, 2343,
     /* 325727 */     GIR_EraseRootFromParent_Done,
     /* 325728 */   // Label 6678: @325728
     /* 325728 */   GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(325755), // Rule ID 1254 //
     /* 325733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325744 */     // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 325744 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
     /* 325749 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325753 */     GIR_RootConstrainSelectedInstOperands,
     /* 325754 */     // GIR_Coverage, 1254,
     /* 325754 */     GIR_Done,
     /* 325755 */   // Label 6679: @325755
     /* 325755 */   GIM_Reject,
     /* 325756 */ // Label 6677: @325756
     /* 325756 */ GIM_Reject,
     /* 325757 */ // Label 6663: @325757
     /* 325757 */ GIM_Try, /*On fail goto*//*Label 6680*/ GIMT_Encode4(325859),
     /* 325762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 325768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325772 */   GIM_Try, /*On fail goto*//*Label 6681*/ GIMT_Encode4(325831), // Rule ID 2352 //
     /* 325777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 325780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 325809 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325816 */     // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 325816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 325819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325829 */     GIR_RootConstrainSelectedInstOperands,
     /* 325830 */     // GIR_Coverage, 2352,
     /* 325830 */     GIR_EraseRootFromParent_Done,
     /* 325831 */   // Label 6681: @325831
     /* 325831 */   GIM_Try, /*On fail goto*//*Label 6682*/ GIMT_Encode4(325858), // Rule ID 1260 //
     /* 325836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 325839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325847 */     // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 325847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
     /* 325852 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325856 */     GIR_RootConstrainSelectedInstOperands,
     /* 325857 */     // GIR_Coverage, 1260,
     /* 325857 */     GIR_Done,
     /* 325858 */   // Label 6682: @325858
     /* 325858 */   GIM_Reject,
     /* 325859 */ // Label 6680: @325859
     /* 325859 */ GIM_Reject,
     /* 325860 */ // Label 6664: @325860
     /* 325860 */ GIM_Try, /*On fail goto*//*Label 6683*/ GIMT_Encode4(325962),
     /* 325865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 325871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325875 */   GIM_Try, /*On fail goto*//*Label 6684*/ GIMT_Encode4(325934), // Rule ID 2346 //
     /* 325880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 325883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 325908 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325912 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325919 */     // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 325922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 325924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325932 */     GIR_RootConstrainSelectedInstOperands,
     /* 325933 */     // GIR_Coverage, 2346,
     /* 325933 */     GIR_EraseRootFromParent_Done,
     /* 325934 */   // Label 6684: @325934
     /* 325934 */   GIM_Try, /*On fail goto*//*Label 6685*/ GIMT_Encode4(325961), // Rule ID 1256 //
     /* 325939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325950 */     // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
     /* 325955 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325959 */     GIR_RootConstrainSelectedInstOperands,
     /* 325960 */     // GIR_Coverage, 1256,
     /* 325960 */     GIR_Done,
     /* 325961 */   // Label 6685: @325961
     /* 325961 */   GIM_Reject,
     /* 325962 */ // Label 6683: @325962
     /* 325962 */ GIM_Reject,
     /* 325963 */ // Label 6665: @325963
     /* 325963 */ GIM_Reject,
     /* 325964 */ // Label 79: @325964
     /* 325964 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6694*/ GIMT_Encode4(326367),
     /* 325975 */ /*GILLT_s32*//*Label 6686*/ GIMT_Encode4(326015),
     /* 325979 */ /*GILLT_s64*//*Label 6687*/ GIMT_Encode4(326089), GIMT_Encode4(0),
     /* 325987 */ /*GILLT_v2s32*//*Label 6688*/ GIMT_Encode4(326163), GIMT_Encode4(0),
     /* 325995 */ /*GILLT_v4s16*//*Label 6689*/ GIMT_Encode4(326197),
     /* 325999 */ /*GILLT_v4s32*//*Label 6690*/ GIMT_Encode4(326231),
     /* 326003 */ /*GILLT_v8s8*//*Label 6691*/ GIMT_Encode4(326265),
     /* 326007 */ /*GILLT_v8s16*//*Label 6692*/ GIMT_Encode4(326299),
     /* 326011 */ /*GILLT_v16s8*//*Label 6693*/ GIMT_Encode4(326333),
     /* 326015 */ // Label 6686: @326015
     /* 326015 */ GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(326088),
     /* 326020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 326026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326034 */   GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(326068), // Rule ID 2326 //
     /* 326039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 326054 */     // MIs[1] Operand 1
     /* 326054 */     // No operand predicates
     /* 326054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326056 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 326056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
     /* 326059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 326066 */     GIR_RootConstrainSelectedInstOperands,
     /* 326067 */     // GIR_Coverage, 2326,
     /* 326067 */     GIR_EraseRootFromParent_Done,
     /* 326068 */   // Label 6696: @326068
     /* 326068 */   GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(326087), // Rule ID 2325 //
     /* 326073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326080 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 326080 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
     /* 326085 */     GIR_RootConstrainSelectedInstOperands,
     /* 326086 */     // GIR_Coverage, 2325,
     /* 326086 */     GIR_Done,
     /* 326087 */   // Label 6697: @326087
     /* 326087 */   GIM_Reject,
     /* 326088 */ // Label 6695: @326088
     /* 326088 */ GIM_Reject,
     /* 326089 */ // Label 6687: @326089
     /* 326089 */ GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(326162),
     /* 326094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 326097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 326100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326108 */   GIM_Try, /*On fail goto*//*Label 6699*/ GIMT_Encode4(326142), // Rule ID 2328 //
     /* 326113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326124 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 326128 */     // MIs[1] Operand 1
     /* 326128 */     // No operand predicates
     /* 326128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326130 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 326130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
     /* 326133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326137 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 326140 */     GIR_RootConstrainSelectedInstOperands,
     /* 326141 */     // GIR_Coverage, 2328,
     /* 326141 */     GIR_EraseRootFromParent_Done,
     /* 326142 */   // Label 6699: @326142
     /* 326142 */   GIM_Try, /*On fail goto*//*Label 6700*/ GIMT_Encode4(326161), // Rule ID 2327 //
     /* 326147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326154 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 326154 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
     /* 326159 */     GIR_RootConstrainSelectedInstOperands,
     /* 326160 */     // GIR_Coverage, 2327,
     /* 326160 */     GIR_Done,
     /* 326161 */   // Label 6700: @326161
     /* 326161 */   GIM_Reject,
     /* 326162 */ // Label 6698: @326162
     /* 326162 */ GIM_Reject,
     /* 326163 */ // Label 6688: @326163
     /* 326163 */ GIM_Try, /*On fail goto*//*Label 6701*/ GIMT_Encode4(326196), // Rule ID 1414 //
     /* 326168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 326177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326189 */   // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 326189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
     /* 326194 */   GIR_RootConstrainSelectedInstOperands,
     /* 326195 */   // GIR_Coverage, 1414,
     /* 326195 */   GIR_Done,
     /* 326196 */ // Label 6701: @326196
     /* 326196 */ GIM_Reject,
     /* 326197 */ // Label 6689: @326197
     /* 326197 */ GIM_Try, /*On fail goto*//*Label 6702*/ GIMT_Encode4(326230), // Rule ID 1412 //
     /* 326202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 326211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326219 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326223 */   // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 326223 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
     /* 326228 */   GIR_RootConstrainSelectedInstOperands,
     /* 326229 */   // GIR_Coverage, 1412,
     /* 326229 */   GIR_Done,
     /* 326230 */ // Label 6702: @326230
     /* 326230 */ GIM_Reject,
     /* 326231 */ // Label 6690: @326231
     /* 326231 */ GIM_Try, /*On fail goto*//*Label 6703*/ GIMT_Encode4(326264), // Rule ID 1415 //
     /* 326236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 326245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326253 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326257 */   // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 326257 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
     /* 326262 */   GIR_RootConstrainSelectedInstOperands,
     /* 326263 */   // GIR_Coverage, 1415,
     /* 326263 */   GIR_Done,
     /* 326264 */ // Label 6703: @326264
     /* 326264 */ GIM_Reject,
     /* 326265 */ // Label 6691: @326265
     /* 326265 */ GIM_Try, /*On fail goto*//*Label 6704*/ GIMT_Encode4(326298), // Rule ID 1410 //
     /* 326270 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 326276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 326279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326287 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326291 */   // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 326291 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
     /* 326296 */   GIR_RootConstrainSelectedInstOperands,
     /* 326297 */   // GIR_Coverage, 1410,
     /* 326297 */   GIR_Done,
     /* 326298 */ // Label 6704: @326298
     /* 326298 */ GIM_Reject,
     /* 326299 */ // Label 6692: @326299
     /* 326299 */ GIM_Try, /*On fail goto*//*Label 6705*/ GIMT_Encode4(326332), // Rule ID 1413 //
     /* 326304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326310 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 326313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326321 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326325 */   // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 326325 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
     /* 326330 */   GIR_RootConstrainSelectedInstOperands,
     /* 326331 */   // GIR_Coverage, 1413,
     /* 326331 */   GIR_Done,
     /* 326332 */ // Label 6705: @326332
     /* 326332 */ GIM_Reject,
     /* 326333 */ // Label 6693: @326333
     /* 326333 */ GIM_Try, /*On fail goto*//*Label 6706*/ GIMT_Encode4(326366), // Rule ID 1411 //
     /* 326338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 326344 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 326347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326355 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326359 */   // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 326359 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
     /* 326364 */   GIR_RootConstrainSelectedInstOperands,
     /* 326365 */   // GIR_Coverage, 1411,
     /* 326365 */   GIR_Done,
     /* 326366 */ // Label 6706: @326366
     /* 326366 */ GIM_Reject,
     /* 326367 */ // Label 6694: @326367
     /* 326367 */ GIM_Reject,
     /* 326368 */ // Label 80: @326368
     /* 326368 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6715*/ GIMT_Encode4(326771),
     /* 326379 */ /*GILLT_s32*//*Label 6707*/ GIMT_Encode4(326419),
     /* 326383 */ /*GILLT_s64*//*Label 6708*/ GIMT_Encode4(326493), GIMT_Encode4(0),
     /* 326391 */ /*GILLT_v2s32*//*Label 6709*/ GIMT_Encode4(326567), GIMT_Encode4(0),
     /* 326399 */ /*GILLT_v4s16*//*Label 6710*/ GIMT_Encode4(326601),
     /* 326403 */ /*GILLT_v4s32*//*Label 6711*/ GIMT_Encode4(326635),
     /* 326407 */ /*GILLT_v8s8*//*Label 6712*/ GIMT_Encode4(326669),
     /* 326411 */ /*GILLT_v8s16*//*Label 6713*/ GIMT_Encode4(326703),
     /* 326415 */ /*GILLT_v16s8*//*Label 6714*/ GIMT_Encode4(326737),
     /* 326419 */ // Label 6707: @326419
     /* 326419 */ GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(326492),
     /* 326424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 326430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326438 */   GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(326472), // Rule ID 2322 //
     /* 326443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326454 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 326458 */     // MIs[1] Operand 1
     /* 326458 */     // No operand predicates
     /* 326458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326460 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 326460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
     /* 326463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 326470 */     GIR_RootConstrainSelectedInstOperands,
     /* 326471 */     // GIR_Coverage, 2322,
     /* 326471 */     GIR_EraseRootFromParent_Done,
     /* 326472 */   // Label 6717: @326472
     /* 326472 */   GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(326491), // Rule ID 2321 //
     /* 326477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326484 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 326484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
     /* 326489 */     GIR_RootConstrainSelectedInstOperands,
     /* 326490 */     // GIR_Coverage, 2321,
     /* 326490 */     GIR_Done,
     /* 326491 */   // Label 6718: @326491
     /* 326491 */   GIM_Reject,
     /* 326492 */ // Label 6716: @326492
     /* 326492 */ GIM_Reject,
     /* 326493 */ // Label 6708: @326493
     /* 326493 */ GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(326566),
     /* 326498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 326501 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 326504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326512 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(326546), // Rule ID 2324 //
     /* 326517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326528 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 326532 */     // MIs[1] Operand 1
     /* 326532 */     // No operand predicates
     /* 326532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326534 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 326534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
     /* 326537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 326544 */     GIR_RootConstrainSelectedInstOperands,
     /* 326545 */     // GIR_Coverage, 2324,
     /* 326545 */     GIR_EraseRootFromParent_Done,
     /* 326546 */   // Label 6720: @326546
     /* 326546 */   GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(326565), // Rule ID 2323 //
     /* 326551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326558 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 326558 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
     /* 326563 */     GIR_RootConstrainSelectedInstOperands,
     /* 326564 */     // GIR_Coverage, 2323,
     /* 326564 */     GIR_Done,
     /* 326565 */   // Label 6721: @326565
     /* 326565 */   GIM_Reject,
     /* 326566 */ // Label 6719: @326566
     /* 326566 */ GIM_Reject,
     /* 326567 */ // Label 6709: @326567
     /* 326567 */ GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(326600), // Rule ID 1402 //
     /* 326572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 326581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326589 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326593 */   // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 326593 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
     /* 326598 */   GIR_RootConstrainSelectedInstOperands,
     /* 326599 */   // GIR_Coverage, 1402,
     /* 326599 */   GIR_Done,
     /* 326600 */ // Label 6722: @326600
     /* 326600 */ GIM_Reject,
     /* 326601 */ // Label 6710: @326601
     /* 326601 */ GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(326634), // Rule ID 1400 //
     /* 326606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 326615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326619 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326623 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326627 */   // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 326627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
     /* 326632 */   GIR_RootConstrainSelectedInstOperands,
     /* 326633 */   // GIR_Coverage, 1400,
     /* 326633 */   GIR_Done,
     /* 326634 */ // Label 6723: @326634
     /* 326634 */ GIM_Reject,
     /* 326635 */ // Label 6711: @326635
     /* 326635 */ GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(326668), // Rule ID 1403 //
     /* 326640 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326646 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 326649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326657 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326661 */   // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 326661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
     /* 326666 */   GIR_RootConstrainSelectedInstOperands,
     /* 326667 */   // GIR_Coverage, 1403,
     /* 326667 */   GIR_Done,
     /* 326668 */ // Label 6724: @326668
     /* 326668 */ GIM_Reject,
     /* 326669 */ // Label 6712: @326669
     /* 326669 */ GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(326702), // Rule ID 1398 //
     /* 326674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 326680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 326683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326695 */   // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 326695 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
     /* 326700 */   GIR_RootConstrainSelectedInstOperands,
     /* 326701 */   // GIR_Coverage, 1398,
     /* 326701 */   GIR_Done,
     /* 326702 */ // Label 6725: @326702
     /* 326702 */ GIM_Reject,
     /* 326703 */ // Label 6713: @326703
     /* 326703 */ GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(326736), // Rule ID 1401 //
     /* 326708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326714 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 326717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326721 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326725 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326729 */   // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 326729 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
     /* 326734 */   GIR_RootConstrainSelectedInstOperands,
     /* 326735 */   // GIR_Coverage, 1401,
     /* 326735 */   GIR_Done,
     /* 326736 */ // Label 6726: @326736
     /* 326736 */ GIM_Reject,
     /* 326737 */ // Label 6714: @326737
     /* 326737 */ GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(326770), // Rule ID 1399 //
     /* 326742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 326748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 326751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326763 */   // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 326763 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
     /* 326768 */   GIR_RootConstrainSelectedInstOperands,
     /* 326769 */   // GIR_Coverage, 1399,
     /* 326769 */   GIR_Done,
     /* 326770 */ // Label 6727: @326770
     /* 326770 */ GIM_Reject,
     /* 326771 */ // Label 6715: @326771
     /* 326771 */ GIM_Reject,
     /* 326772 */ // Label 81: @326772
     /* 326772 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6736*/ GIMT_Encode4(327175),
     /* 326783 */ /*GILLT_s32*//*Label 6728*/ GIMT_Encode4(326823),
     /* 326787 */ /*GILLT_s64*//*Label 6729*/ GIMT_Encode4(326897), GIMT_Encode4(0),
     /* 326795 */ /*GILLT_v2s32*//*Label 6730*/ GIMT_Encode4(326971), GIMT_Encode4(0),
     /* 326803 */ /*GILLT_v4s16*//*Label 6731*/ GIMT_Encode4(327005),
     /* 326807 */ /*GILLT_v4s32*//*Label 6732*/ GIMT_Encode4(327039),
     /* 326811 */ /*GILLT_v8s8*//*Label 6733*/ GIMT_Encode4(327073),
     /* 326815 */ /*GILLT_v8s16*//*Label 6734*/ GIMT_Encode4(327107),
     /* 326819 */ /*GILLT_v16s8*//*Label 6735*/ GIMT_Encode4(327141),
     /* 326823 */ // Label 6728: @326823
     /* 326823 */ GIM_Try, /*On fail goto*//*Label 6737*/ GIMT_Encode4(326896),
     /* 326828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 326831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 326834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326842 */   GIM_Try, /*On fail goto*//*Label 6738*/ GIMT_Encode4(326876), // Rule ID 2334 //
     /* 326847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326858 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 326862 */     // MIs[1] Operand 1
     /* 326862 */     // No operand predicates
     /* 326862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326864 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 326864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
     /* 326867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326869 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 326874 */     GIR_RootConstrainSelectedInstOperands,
     /* 326875 */     // GIR_Coverage, 2334,
     /* 326875 */     GIR_EraseRootFromParent_Done,
     /* 326876 */   // Label 6738: @326876
     /* 326876 */   GIM_Try, /*On fail goto*//*Label 6739*/ GIMT_Encode4(326895), // Rule ID 2333 //
     /* 326881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 326888 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 326888 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
     /* 326893 */     GIR_RootConstrainSelectedInstOperands,
     /* 326894 */     // GIR_Coverage, 2333,
     /* 326894 */     GIR_Done,
     /* 326895 */   // Label 6739: @326895
     /* 326895 */   GIM_Reject,
     /* 326896 */ // Label 6737: @326896
     /* 326896 */ GIM_Reject,
     /* 326897 */ // Label 6729: @326897
     /* 326897 */ GIM_Try, /*On fail goto*//*Label 6740*/ GIMT_Encode4(326970),
     /* 326902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 326905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 326908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326916 */   GIM_Try, /*On fail goto*//*Label 6741*/ GIMT_Encode4(326950), // Rule ID 2336 //
     /* 326921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 326928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 326932 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 326936 */     // MIs[1] Operand 1
     /* 326936 */     // No operand predicates
     /* 326936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 326938 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 326938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
     /* 326941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 326945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 326948 */     GIR_RootConstrainSelectedInstOperands,
     /* 326949 */     // GIR_Coverage, 2336,
     /* 326949 */     GIR_EraseRootFromParent_Done,
     /* 326950 */   // Label 6741: @326950
     /* 326950 */   GIM_Try, /*On fail goto*//*Label 6742*/ GIMT_Encode4(326969), // Rule ID 2335 //
     /* 326955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 326958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 326962 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 326962 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
     /* 326967 */     GIR_RootConstrainSelectedInstOperands,
     /* 326968 */     // GIR_Coverage, 2335,
     /* 326968 */     GIR_Done,
     /* 326969 */   // Label 6742: @326969
     /* 326969 */   GIM_Reject,
     /* 326970 */ // Label 6740: @326970
     /* 326970 */ GIM_Reject,
     /* 326971 */ // Label 6730: @326971
     /* 326971 */ GIM_Try, /*On fail goto*//*Label 6743*/ GIMT_Encode4(327004), // Rule ID 1537 //
     /* 326976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 326985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326993 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326997 */   // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 326997 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
     /* 327002 */   GIR_RootConstrainSelectedInstOperands,
     /* 327003 */   // GIR_Coverage, 1537,
     /* 327003 */   GIR_Done,
     /* 327004 */ // Label 6743: @327004
     /* 327004 */ GIM_Reject,
     /* 327005 */ // Label 6731: @327005
     /* 327005 */ GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(327038), // Rule ID 1535 //
     /* 327010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 327019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327027 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327031 */   // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 327031 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
     /* 327036 */   GIR_RootConstrainSelectedInstOperands,
     /* 327037 */   // GIR_Coverage, 1535,
     /* 327037 */   GIR_Done,
     /* 327038 */ // Label 6744: @327038
     /* 327038 */ GIM_Reject,
     /* 327039 */ // Label 6732: @327039
     /* 327039 */ GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(327072), // Rule ID 1538 //
     /* 327044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 327053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327061 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327065 */   // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 327065 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
     /* 327070 */   GIR_RootConstrainSelectedInstOperands,
     /* 327071 */   // GIR_Coverage, 1538,
     /* 327071 */   GIR_Done,
     /* 327072 */ // Label 6745: @327072
     /* 327072 */ GIM_Reject,
     /* 327073 */ // Label 6733: @327073
     /* 327073 */ GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(327106), // Rule ID 1533 //
     /* 327078 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327081 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 327084 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 327087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327095 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327099 */   // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 327099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
     /* 327104 */   GIR_RootConstrainSelectedInstOperands,
     /* 327105 */   // GIR_Coverage, 1533,
     /* 327105 */   GIR_Done,
     /* 327106 */ // Label 6746: @327106
     /* 327106 */ GIM_Reject,
     /* 327107 */ // Label 6734: @327107
     /* 327107 */ GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(327140), // Rule ID 1536 //
     /* 327112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327118 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 327121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327125 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327129 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327133 */   // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 327133 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
     /* 327138 */   GIR_RootConstrainSelectedInstOperands,
     /* 327139 */   // GIR_Coverage, 1536,
     /* 327139 */   GIR_Done,
     /* 327140 */ // Label 6747: @327140
     /* 327140 */ GIM_Reject,
     /* 327141 */ // Label 6735: @327141
     /* 327141 */ GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(327174), // Rule ID 1534 //
     /* 327146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 327152 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 327155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327163 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327167 */   // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 327167 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
     /* 327172 */   GIR_RootConstrainSelectedInstOperands,
     /* 327173 */   // GIR_Coverage, 1534,
     /* 327173 */   GIR_Done,
     /* 327174 */ // Label 6748: @327174
     /* 327174 */ GIM_Reject,
     /* 327175 */ // Label 6736: @327175
     /* 327175 */ GIM_Reject,
     /* 327176 */ // Label 82: @327176
     /* 327176 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6757*/ GIMT_Encode4(327579),
     /* 327187 */ /*GILLT_s32*//*Label 6749*/ GIMT_Encode4(327227),
     /* 327191 */ /*GILLT_s64*//*Label 6750*/ GIMT_Encode4(327301), GIMT_Encode4(0),
     /* 327199 */ /*GILLT_v2s32*//*Label 6751*/ GIMT_Encode4(327375), GIMT_Encode4(0),
     /* 327207 */ /*GILLT_v4s16*//*Label 6752*/ GIMT_Encode4(327409),
     /* 327211 */ /*GILLT_v4s32*//*Label 6753*/ GIMT_Encode4(327443),
     /* 327215 */ /*GILLT_v8s8*//*Label 6754*/ GIMT_Encode4(327477),
     /* 327219 */ /*GILLT_v8s16*//*Label 6755*/ GIMT_Encode4(327511),
     /* 327223 */ /*GILLT_v16s8*//*Label 6756*/ GIMT_Encode4(327545),
     /* 327227 */ // Label 6749: @327227
     /* 327227 */ GIM_Try, /*On fail goto*//*Label 6758*/ GIMT_Encode4(327300),
     /* 327232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 327235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 327238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327246 */   GIM_Try, /*On fail goto*//*Label 6759*/ GIMT_Encode4(327280), // Rule ID 2330 //
     /* 327251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327254 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 327258 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 327262 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 327266 */     // MIs[1] Operand 1
     /* 327266 */     // No operand predicates
     /* 327266 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327268 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 327268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
     /* 327271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327273 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 327275 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 327278 */     GIR_RootConstrainSelectedInstOperands,
     /* 327279 */     // GIR_Coverage, 2330,
     /* 327279 */     GIR_EraseRootFromParent_Done,
     /* 327280 */   // Label 6759: @327280
     /* 327280 */   GIM_Try, /*On fail goto*//*Label 6760*/ GIMT_Encode4(327299), // Rule ID 2329 //
     /* 327285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327292 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 327292 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
     /* 327297 */     GIR_RootConstrainSelectedInstOperands,
     /* 327298 */     // GIR_Coverage, 2329,
     /* 327298 */     GIR_Done,
     /* 327299 */   // Label 6760: @327299
     /* 327299 */   GIM_Reject,
     /* 327300 */ // Label 6758: @327300
     /* 327300 */ GIM_Reject,
     /* 327301 */ // Label 6750: @327301
     /* 327301 */ GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(327374),
     /* 327306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 327309 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 327312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327320 */   GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(327354), // Rule ID 2332 //
     /* 327325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 327332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 327336 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 327340 */     // MIs[1] Operand 1
     /* 327340 */     // No operand predicates
     /* 327340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327342 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 327342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
     /* 327345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 327349 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 327352 */     GIR_RootConstrainSelectedInstOperands,
     /* 327353 */     // GIR_Coverage, 2332,
     /* 327353 */     GIR_EraseRootFromParent_Done,
     /* 327354 */   // Label 6762: @327354
     /* 327354 */   GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(327373), // Rule ID 2331 //
     /* 327359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327366 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 327366 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
     /* 327371 */     GIR_RootConstrainSelectedInstOperands,
     /* 327372 */     // GIR_Coverage, 2331,
     /* 327372 */     GIR_Done,
     /* 327373 */   // Label 6763: @327373
     /* 327373 */   GIM_Reject,
     /* 327374 */ // Label 6761: @327374
     /* 327374 */ GIM_Reject,
     /* 327375 */ // Label 6751: @327375
     /* 327375 */ GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(327408), // Rule ID 1525 //
     /* 327380 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327383 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327386 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 327389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327393 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327397 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327401 */   // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 327401 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
     /* 327406 */   GIR_RootConstrainSelectedInstOperands,
     /* 327407 */   // GIR_Coverage, 1525,
     /* 327407 */   GIR_Done,
     /* 327408 */ // Label 6764: @327408
     /* 327408 */ GIM_Reject,
     /* 327409 */ // Label 6752: @327409
     /* 327409 */ GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(327442), // Rule ID 1523 //
     /* 327414 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 327423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327431 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327435 */   // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 327435 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
     /* 327440 */   GIR_RootConstrainSelectedInstOperands,
     /* 327441 */   // GIR_Coverage, 1523,
     /* 327441 */   GIR_Done,
     /* 327442 */ // Label 6765: @327442
     /* 327442 */ GIM_Reject,
     /* 327443 */ // Label 6753: @327443
     /* 327443 */ GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(327476), // Rule ID 1526 //
     /* 327448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327454 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 327457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327461 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327465 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327469 */   // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 327469 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
     /* 327474 */   GIR_RootConstrainSelectedInstOperands,
     /* 327475 */   // GIR_Coverage, 1526,
     /* 327475 */   GIR_Done,
     /* 327476 */ // Label 6766: @327476
     /* 327476 */ GIM_Reject,
     /* 327477 */ // Label 6754: @327477
     /* 327477 */ GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(327510), // Rule ID 1521 //
     /* 327482 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327485 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 327488 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 327491 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327495 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327499 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327503 */   // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 327503 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
     /* 327508 */   GIR_RootConstrainSelectedInstOperands,
     /* 327509 */   // GIR_Coverage, 1521,
     /* 327509 */   GIR_Done,
     /* 327510 */ // Label 6767: @327510
     /* 327510 */ GIM_Reject,
     /* 327511 */ // Label 6755: @327511
     /* 327511 */ GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(327544), // Rule ID 1524 //
     /* 327516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 327525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327529 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327533 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327537 */   // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 327537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
     /* 327542 */   GIR_RootConstrainSelectedInstOperands,
     /* 327543 */   // GIR_Coverage, 1524,
     /* 327543 */   GIR_Done,
     /* 327544 */ // Label 6768: @327544
     /* 327544 */ GIM_Reject,
     /* 327545 */ // Label 6756: @327545
     /* 327545 */ GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(327578), // Rule ID 1522 //
     /* 327550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 327556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 327559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327567 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327571 */   // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 327571 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
     /* 327576 */   GIR_RootConstrainSelectedInstOperands,
     /* 327577 */   // GIR_Coverage, 1522,
     /* 327577 */   GIR_Done,
     /* 327578 */ // Label 6769: @327578
     /* 327578 */ GIM_Reject,
     /* 327579 */ // Label 6757: @327579
     /* 327579 */ GIM_Reject,
     /* 327580 */ // Label 83: @327580
     /* 327580 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6779*/ GIMT_Encode4(328394),
     /* 327591 */ /*GILLT_s32*//*Label 6770*/ GIMT_Encode4(327631),
     /* 327595 */ /*GILLT_s64*//*Label 6771*/ GIMT_Encode4(327658), GIMT_Encode4(0),
     /* 327603 */ /*GILLT_v2s32*//*Label 6772*/ GIMT_Encode4(327737),
     /* 327607 */ /*GILLT_v2s64*//*Label 6773*/ GIMT_Encode4(327764),
     /* 327611 */ /*GILLT_v4s16*//*Label 6774*/ GIMT_Encode4(327947),
     /* 327615 */ /*GILLT_v4s32*//*Label 6775*/ GIMT_Encode4(327974),
     /* 327619 */ /*GILLT_v8s8*//*Label 6776*/ GIMT_Encode4(328157),
     /* 327623 */ /*GILLT_v8s16*//*Label 6777*/ GIMT_Encode4(328184),
     /* 327627 */ /*GILLT_v16s8*//*Label 6778*/ GIMT_Encode4(328367),
     /* 327631 */ // Label 6770: @327631
     /* 327631 */ GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(327657), // Rule ID 2315 //
     /* 327636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327639 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 327642 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327646 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327650 */   // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 327650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
     /* 327655 */   GIR_RootConstrainSelectedInstOperands,
     /* 327656 */   // GIR_Coverage, 2315,
     /* 327656 */   GIR_Done,
     /* 327657 */ // Label 6780: @327657
     /* 327657 */ GIM_Reject,
     /* 327658 */ // Label 6771: @327658
     /* 327658 */ GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(327736),
     /* 327663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 327666 */   GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(327689), // Rule ID 1652 //
     /* 327671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327678 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327682 */     // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 327682 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 327687 */     GIR_RootConstrainSelectedInstOperands,
     /* 327688 */     // GIR_Coverage, 1652,
     /* 327688 */     GIR_Done,
     /* 327689 */   // Label 6782: @327689
     /* 327689 */   GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(327712), // Rule ID 2316 //
     /* 327694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 327697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 327705 */     // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 327705 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
     /* 327710 */     GIR_RootConstrainSelectedInstOperands,
     /* 327711 */     // GIR_Coverage, 2316,
     /* 327711 */     GIR_Done,
     /* 327712 */   // Label 6783: @327712
     /* 327712 */   GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(327735), // Rule ID 2512 //
     /* 327717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
     /* 327720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327728 */     // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 327728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 327733 */     GIR_RootConstrainSelectedInstOperands,
     /* 327734 */     // GIR_Coverage, 2512,
     /* 327734 */     GIR_Done,
     /* 327735 */   // Label 6784: @327735
     /* 327735 */   GIM_Reject,
     /* 327736 */ // Label 6781: @327736
     /* 327736 */ GIM_Reject,
     /* 327737 */ // Label 6772: @327737
     /* 327737 */ GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(327763), // Rule ID 707 //
     /* 327742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327748 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327756 */   // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 327756 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
     /* 327761 */   GIR_RootConstrainSelectedInstOperands,
     /* 327762 */   // GIR_Coverage, 707,
     /* 327762 */   GIR_Done,
     /* 327763 */ // Label 6785: @327763
     /* 327763 */ GIM_Reject,
     /* 327764 */ // Label 6773: @327764
     /* 327764 */ GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(327946),
     /* 327769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327776 */   GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(327854), // Rule ID 4875 //
     /* 327781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 327789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 327797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327817 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327821 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327823 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 327830 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 327837 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
     /* 327837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 327840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327842 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 327847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 327852 */     GIR_RootConstrainSelectedInstOperands,
     /* 327853 */     // GIR_Coverage, 4875,
     /* 327853 */     GIR_EraseRootFromParent_Done,
     /* 327854 */   // Label 6787: @327854
     /* 327854 */   GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(327926), // Rule ID 4874 //
     /* 327859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 327867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 327871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 327875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327887 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 327900 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 327904 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327909 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327911 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
     /* 327911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 327914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 327920 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 327924 */     GIR_RootConstrainSelectedInstOperands,
     /* 327925 */     // GIR_Coverage, 4874,
     /* 327925 */     GIR_EraseRootFromParent_Done,
     /* 327926 */   // Label 6788: @327926
     /* 327926 */   GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(327945), // Rule ID 709 //
     /* 327931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327938 */     // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 327938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
     /* 327943 */     GIR_RootConstrainSelectedInstOperands,
     /* 327944 */     // GIR_Coverage, 709,
     /* 327944 */     GIR_Done,
     /* 327945 */   // Label 6789: @327945
     /* 327945 */   GIM_Reject,
     /* 327946 */ // Label 6786: @327946
     /* 327946 */ GIM_Reject,
     /* 327947 */ // Label 6774: @327947
     /* 327947 */ GIM_Try, /*On fail goto*//*Label 6790*/ GIMT_Encode4(327973), // Rule ID 705 //
     /* 327952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 327955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 327958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 327966 */   // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 327966 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
     /* 327971 */   GIR_RootConstrainSelectedInstOperands,
     /* 327972 */   // GIR_Coverage, 705,
     /* 327972 */   GIR_Done,
     /* 327973 */ // Label 6790: @327973
     /* 327973 */ GIM_Reject,
     /* 327974 */ // Label 6775: @327974
     /* 327974 */ GIM_Try, /*On fail goto*//*Label 6791*/ GIMT_Encode4(328156),
     /* 327979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327986 */   GIM_Try, /*On fail goto*//*Label 6792*/ GIMT_Encode4(328064), // Rule ID 4873 //
     /* 327991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 327999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 328007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 328015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 328023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 328027 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328031 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328033 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 328040 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 328047 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
     /* 328047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 328050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 328057 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 328062 */     GIR_RootConstrainSelectedInstOperands,
     /* 328063 */     // GIR_Coverage, 4873,
     /* 328063 */     GIR_EraseRootFromParent_Done,
     /* 328064 */   // Label 6792: @328064
     /* 328064 */   GIM_Try, /*On fail goto*//*Label 6793*/ GIMT_Encode4(328136), // Rule ID 4872 //
     /* 328069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 328077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 328085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 328093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328102 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 328106 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 328110 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 328114 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328119 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328121 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
     /* 328121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 328124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328126 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 328130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 328134 */     GIR_RootConstrainSelectedInstOperands,
     /* 328135 */     // GIR_Coverage, 4872,
     /* 328135 */     GIR_EraseRootFromParent_Done,
     /* 328136 */   // Label 6793: @328136
     /* 328136 */   GIM_Try, /*On fail goto*//*Label 6794*/ GIMT_Encode4(328155), // Rule ID 708 //
     /* 328141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328148 */     // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 328148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
     /* 328153 */     GIR_RootConstrainSelectedInstOperands,
     /* 328154 */     // GIR_Coverage, 708,
     /* 328154 */     GIR_Done,
     /* 328155 */   // Label 6794: @328155
     /* 328155 */   GIM_Reject,
     /* 328156 */ // Label 6791: @328156
     /* 328156 */ GIM_Reject,
     /* 328157 */ // Label 6776: @328157
     /* 328157 */ GIM_Try, /*On fail goto*//*Label 6795*/ GIMT_Encode4(328183), // Rule ID 703 //
     /* 328162 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328165 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 328168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328176 */   // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 328176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
     /* 328181 */   GIR_RootConstrainSelectedInstOperands,
     /* 328182 */   // GIR_Coverage, 703,
     /* 328182 */   GIR_Done,
     /* 328183 */ // Label 6795: @328183
     /* 328183 */ GIM_Reject,
     /* 328184 */ // Label 6777: @328184
     /* 328184 */ GIM_Try, /*On fail goto*//*Label 6796*/ GIMT_Encode4(328366),
     /* 328189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328196 */   GIM_Try, /*On fail goto*//*Label 6797*/ GIMT_Encode4(328274), // Rule ID 4871 //
     /* 328201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 328209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 328217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 328225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 328229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 328233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 328237 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 328241 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328243 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 328250 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 328257 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
     /* 328257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 328260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 328267 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 328272 */     GIR_RootConstrainSelectedInstOperands,
     /* 328273 */     // GIR_Coverage, 4871,
     /* 328273 */     GIR_EraseRootFromParent_Done,
     /* 328274 */   // Label 6797: @328274
     /* 328274 */   GIM_Try, /*On fail goto*//*Label 6798*/ GIMT_Encode4(328346), // Rule ID 4870 //
     /* 328279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 328287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 328291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 328295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 328303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 328307 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328312 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 328316 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 328320 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 328324 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328329 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328331 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
     /* 328331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 328334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 328340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 328344 */     GIR_RootConstrainSelectedInstOperands,
     /* 328345 */     // GIR_Coverage, 4870,
     /* 328345 */     GIR_EraseRootFromParent_Done,
     /* 328346 */   // Label 6798: @328346
     /* 328346 */   GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(328365), // Rule ID 706 //
     /* 328351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328358 */     // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 328358 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
     /* 328363 */     GIR_RootConstrainSelectedInstOperands,
     /* 328364 */     // GIR_Coverage, 706,
     /* 328364 */     GIR_Done,
     /* 328365 */   // Label 6799: @328365
     /* 328365 */   GIM_Reject,
     /* 328366 */ // Label 6796: @328366
     /* 328366 */ GIM_Reject,
     /* 328367 */ // Label 6778: @328367
     /* 328367 */ GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(328393), // Rule ID 704 //
     /* 328372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 328375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 328378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328382 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328386 */   // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 328386 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
     /* 328391 */   GIR_RootConstrainSelectedInstOperands,
     /* 328392 */   // GIR_Coverage, 704,
     /* 328392 */   GIR_Done,
     /* 328393 */ // Label 6800: @328393
     /* 328393 */ GIM_Reject,
     /* 328394 */ // Label 6779: @328394
     /* 328394 */ GIM_Reject,
     /* 328395 */ // Label 84: @328395
     /* 328395 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 6803*/ GIMT_Encode4(328560),
     /* 328406 */ /*GILLT_s32*//*Label 6801*/ GIMT_Encode4(328414),
     /* 328410 */ /*GILLT_s64*//*Label 6802*/ GIMT_Encode4(328487),
     /* 328414 */ // Label 6801: @328414
     /* 328414 */ GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(328440), // Rule ID 4716 //
     /* 328419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 328422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 328425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328429 */   // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 328429 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 328434 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328438 */   GIR_RootConstrainSelectedInstOperands,
     /* 328439 */   // GIR_Coverage, 4716,
     /* 328439 */   GIR_Done,
     /* 328440 */ // Label 6804: @328440
     /* 328440 */ GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(328463), // Rule ID 4722 //
     /* 328445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 328448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328452 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 328452 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 328457 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328461 */   GIR_RootConstrainSelectedInstOperands,
     /* 328462 */   // GIR_Coverage, 4722,
     /* 328462 */   GIR_Done,
     /* 328463 */ // Label 6805: @328463
     /* 328463 */ GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(328486), // Rule ID 4724 //
     /* 328468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 328471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 328475 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 328475 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 328480 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328484 */   GIR_RootConstrainSelectedInstOperands,
     /* 328485 */   // GIR_Coverage, 4724,
     /* 328485 */   GIR_Done,
     /* 328486 */ // Label 6806: @328486
     /* 328486 */ GIM_Reject,
     /* 328487 */ // Label 6802: @328487
     /* 328487 */ GIM_Try, /*On fail goto*//*Label 6807*/ GIMT_Encode4(328513), // Rule ID 4718 //
     /* 328492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 328495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 328498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328502 */   // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 328502 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 328507 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328511 */   GIR_RootConstrainSelectedInstOperands,
     /* 328512 */   // GIR_Coverage, 4718,
     /* 328512 */   GIR_Done,
     /* 328513 */ // Label 6807: @328513
     /* 328513 */ GIM_Try, /*On fail goto*//*Label 6808*/ GIMT_Encode4(328536), // Rule ID 4726 //
     /* 328518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 328521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328525 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 328525 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 328530 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328534 */   GIR_RootConstrainSelectedInstOperands,
     /* 328535 */   // GIR_Coverage, 4726,
     /* 328535 */   GIR_Done,
     /* 328536 */ // Label 6808: @328536
     /* 328536 */ GIM_Try, /*On fail goto*//*Label 6809*/ GIMT_Encode4(328559), // Rule ID 4728 //
     /* 328541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 328544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328548 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 328548 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 328553 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328557 */   GIR_RootConstrainSelectedInstOperands,
     /* 328558 */   // GIR_Coverage, 4728,
     /* 328558 */   GIR_Done,
     /* 328559 */ // Label 6809: @328559
     /* 328559 */ GIM_Reject,
     /* 328560 */ // Label 6803: @328560
     /* 328560 */ GIM_Reject,
     /* 328561 */ // Label 85: @328561
     /* 328561 */ GIM_Try, /*On fail goto*//*Label 6810*/ GIMT_Encode4(328659),
     /* 328566 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 328569 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 6814*/ GIMT_Encode4(328658),
     /* 328580 */   /*GILLT_s16*//*Label 6811*/ GIMT_Encode4(328592),
     /* 328584 */   /*GILLT_s32*//*Label 6812*/ GIMT_Encode4(328616),
     /* 328588 */   /*GILLT_s64*//*Label 6813*/ GIMT_Encode4(328637),
     /* 328592 */   // Label 6811: @328592
     /* 328592 */   GIM_Try, /*On fail goto*//*Label 6815*/ GIMT_Encode4(328615), // Rule ID 4720 //
     /* 328597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 328600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328604 */     // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 328604 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 328609 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328613 */     GIR_RootConstrainSelectedInstOperands,
     /* 328614 */     // GIR_Coverage, 4720,
     /* 328614 */     GIR_Done,
     /* 328615 */   // Label 6815: @328615
     /* 328615 */   GIM_Reject,
     /* 328616 */   // Label 6812: @328616
     /* 328616 */   GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(328636), // Rule ID 4730 //
     /* 328621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328625 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 328625 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 328630 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328634 */     GIR_RootConstrainSelectedInstOperands,
     /* 328635 */     // GIR_Coverage, 4730,
     /* 328635 */     GIR_Done,
     /* 328636 */   // Label 6816: @328636
     /* 328636 */   GIM_Reject,
     /* 328637 */   // Label 6813: @328637
     /* 328637 */   GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(328657), // Rule ID 4732 //
     /* 328642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 328646 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 328646 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 328651 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 328655 */     GIR_RootConstrainSelectedInstOperands,
     /* 328656 */     // GIR_Coverage, 4732,
     /* 328656 */     GIR_Done,
     /* 328657 */   // Label 6817: @328657
     /* 328657 */   GIM_Reject,
     /* 328658 */   // Label 6814: @328658
     /* 328658 */   GIM_Reject,
     /* 328659 */ // Label 6810: @328659
     /* 328659 */ GIM_Reject,
     /* 328660 */ // Label 86: @328660
     /* 328660 */ GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(328675), // Rule ID 225 //
     /* 328665 */   // MIs[0] addr
     /* 328665 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 328668 */   // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
     /* 328668 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
     /* 328673 */   GIR_RootConstrainSelectedInstOperands,
     /* 328674 */   // GIR_Coverage, 225,
     /* 328674 */   GIR_Done,
     /* 328675 */ // Label 6818: @328675
     /* 328675 */ GIM_Reject,
     /* 328676 */ // Label 87: @328676
     /* 328676 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 6830*/ GIMT_Encode4(334047),
     /* 328687 */ /*GILLT_s64*//*Label 6819*/ GIMT_Encode4(328759), GIMT_Encode4(0),
     /* 328695 */ /*GILLT_v2s32*//*Label 6820*/ GIMT_Encode4(329161), GIMT_Encode4(0),
     /* 328703 */ /*GILLT_v4s16*//*Label 6821*/ GIMT_Encode4(329563), GIMT_Encode4(0),
     /* 328711 */ /*GILLT_v8s8*//*Label 6822*/ GIMT_Encode4(329965), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 328723 */ /*GILLT_nxv1s1*//*Label 6823*/ GIMT_Encode4(330145),
     /* 328727 */ /*GILLT_nxv2s1*//*Label 6824*/ GIMT_Encode4(332408),
     /* 328731 */ /*GILLT_nxv2s16*//*Label 6825*/ GIMT_Encode4(333263),
     /* 328735 */ /*GILLT_nxv2s32*//*Label 6826*/ GIMT_Encode4(333550), GIMT_Encode4(0),
     /* 328743 */ /*GILLT_nxv4s1*//*Label 6827*/ GIMT_Encode4(333620),
     /* 328747 */ /*GILLT_nxv4s16*//*Label 6828*/ GIMT_Encode4(333907), GIMT_Encode4(0),
     /* 328755 */ /*GILLT_nxv8s1*//*Label 6829*/ GIMT_Encode4(333977),
     /* 328759 */ // Label 6819: @328759
     /* 328759 */ GIM_Try, /*On fail goto*//*Label 6831*/ GIMT_Encode4(329160),
     /* 328764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328771 */   GIM_Try, /*On fail goto*//*Label 6832*/ GIMT_Encode4(328823), // Rule ID 5563 //
     /* 328776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 328784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328788 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 328790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328795 */     // MIs[0] Operand 2
     /* 328795 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 328806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328808 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 328808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 328811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328821 */     GIR_RootConstrainSelectedInstOperands,
     /* 328822 */     // GIR_Coverage, 5563,
     /* 328822 */     GIR_EraseRootFromParent_Done,
     /* 328823 */   // Label 6832: @328823
     /* 328823 */   GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(328875), // Rule ID 5566 //
     /* 328828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 328836 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 328840 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 328842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328847 */     // MIs[0] Operand 2
     /* 328847 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 328858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328860 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 1:{ *:[i64] })  =>  (ZIP2v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 328860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 328863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 328873 */     GIR_RootConstrainSelectedInstOperands,
     /* 328874 */     // GIR_Coverage, 5566,
     /* 328874 */     GIR_EraseRootFromParent_Done,
     /* 328875 */   // Label 6833: @328875
     /* 328875 */   GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(328943), // Rule ID 5442 //
     /* 328880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328884 */     // MIs[0] Operand 2
     /* 328884 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 328895 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 328895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 328902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328907 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328911 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328915 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328918 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328925 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 328932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328942 */     // GIR_Coverage, 5442,
     /* 328942 */     GIR_EraseRootFromParent_Done,
     /* 328943 */   // Label 6834: @328943
     /* 328943 */   GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(329011), // Rule ID 5447 //
     /* 328948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328952 */     // MIs[0] Operand 2
     /* 328952 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 328963 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 328963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 328966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 328970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328975 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328979 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 328983 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 328986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 328988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 328993 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329005 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329010 */     // GIR_Coverage, 5447,
     /* 329010 */     GIR_EraseRootFromParent_Done,
     /* 329011 */   // Label 6835: @329011
     /* 329011 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(329053), // Rule ID 6862 //
     /* 329016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329020 */     // MIs[0] Operand 2
     /* 329020 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329031 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
     /* 329031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329036 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329052 */     // GIR_Coverage, 6862,
     /* 329052 */     GIR_EraseRootFromParent_Done,
     /* 329053 */   // Label 6836: @329053
     /* 329053 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(329095), // Rule ID 6863 //
     /* 329058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329062 */     // MIs[0] Operand 2
     /* 329062 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329073 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 329073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329078 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329089 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329094 */     // GIR_Coverage, 6863,
     /* 329094 */     GIR_EraseRootFromParent_Done,
     /* 329095 */   // Label 6837: @329095
     /* 329095 */   GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(329159), // Rule ID 6867 //
     /* 329100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329104 */     // MIs[0] Operand 2
     /* 329104 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329115 */     // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 329115 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329118 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 329122 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329127 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329131 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 329134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329141 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329158 */     // GIR_Coverage, 6867,
     /* 329158 */     GIR_EraseRootFromParent_Done,
     /* 329159 */   // Label 6838: @329159
     /* 329159 */   GIM_Reject,
     /* 329160 */ // Label 6831: @329160
     /* 329160 */ GIM_Reject,
     /* 329161 */ // Label 6820: @329161
     /* 329161 */ GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(329562),
     /* 329166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329173 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(329225), // Rule ID 5562 //
     /* 329178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 329186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329190 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 329192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329197 */     // MIs[0] Operand 2
     /* 329197 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329210 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 329210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 329213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 329219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 329223 */     GIR_RootConstrainSelectedInstOperands,
     /* 329224 */     // GIR_Coverage, 5562,
     /* 329224 */     GIR_EraseRootFromParent_Done,
     /* 329225 */   // Label 6840: @329225
     /* 329225 */   GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(329277), // Rule ID 5565 //
     /* 329230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 329238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329242 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 329244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329249 */     // MIs[0] Operand 2
     /* 329249 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 329260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329262 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 2:{ *:[i64] })  =>  (ZIP2v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 329262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 329265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 329271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 329275 */     GIR_RootConstrainSelectedInstOperands,
     /* 329276 */     // GIR_Coverage, 5565,
     /* 329276 */     GIR_EraseRootFromParent_Done,
     /* 329277 */   // Label 6841: @329277
     /* 329277 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(329345), // Rule ID 5432 //
     /* 329282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329286 */     // MIs[0] Operand 2
     /* 329286 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 329297 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 329297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 329304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329309 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329313 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329317 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 329320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329327 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329334 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329339 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329344 */     // GIR_Coverage, 5432,
     /* 329344 */     GIR_EraseRootFromParent_Done,
     /* 329345 */   // Label 6842: @329345
     /* 329345 */   GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(329413), // Rule ID 5437 //
     /* 329350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329354 */     // MIs[0] Operand 2
     /* 329354 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 329365 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 329365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 329372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329377 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329381 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329385 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 329388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329395 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329402 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329407 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329412 */     // GIR_Coverage, 5437,
     /* 329412 */     GIR_EraseRootFromParent_Done,
     /* 329413 */   // Label 6843: @329413
     /* 329413 */   GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(329455), // Rule ID 6859 //
     /* 329418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329422 */     // MIs[0] Operand 2
     /* 329422 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329433 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
     /* 329433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329438 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329444 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329449 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329454 */     // GIR_Coverage, 6859,
     /* 329454 */     GIR_EraseRootFromParent_Done,
     /* 329455 */   // Label 6844: @329455
     /* 329455 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(329497), // Rule ID 6861 //
     /* 329460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329464 */     // MIs[0] Operand 2
     /* 329464 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329475 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
     /* 329475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329480 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329496 */     // GIR_Coverage, 6861,
     /* 329496 */     GIR_EraseRootFromParent_Done,
     /* 329497 */   // Label 6845: @329497
     /* 329497 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(329561), // Rule ID 6866 //
     /* 329502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329506 */     // MIs[0] Operand 2
     /* 329506 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329517 */     // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 329517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 329524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329533 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 329536 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329543 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329555 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329560 */     // GIR_Coverage, 6866,
     /* 329560 */     GIR_EraseRootFromParent_Done,
     /* 329561 */   // Label 6846: @329561
     /* 329561 */   GIM_Reject,
     /* 329562 */ // Label 6839: @329562
     /* 329562 */ GIM_Reject,
     /* 329563 */ // Label 6821: @329563
     /* 329563 */ GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(329964),
     /* 329568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 329571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329575 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(329627), // Rule ID 5561 //
     /* 329580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 329588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 329592 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 329594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329599 */     // MIs[0] Operand 2
     /* 329599 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329612 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 329612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 329615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 329621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 329625 */     GIR_RootConstrainSelectedInstOperands,
     /* 329626 */     // GIR_Coverage, 5561,
     /* 329626 */     GIR_EraseRootFromParent_Done,
     /* 329627 */   // Label 6848: @329627
     /* 329627 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(329679), // Rule ID 5564 //
     /* 329632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 329640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 329644 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 329646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329651 */     // MIs[0] Operand 2
     /* 329651 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 329662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329664 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 4:{ *:[i64] })  =>  (ZIP2v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 329664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 329667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 329673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 329677 */     GIR_RootConstrainSelectedInstOperands,
     /* 329678 */     // GIR_Coverage, 5564,
     /* 329678 */     GIR_EraseRootFromParent_Done,
     /* 329679 */   // Label 6849: @329679
     /* 329679 */   GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(329747), // Rule ID 5422 //
     /* 329684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329688 */     // MIs[0] Operand 2
     /* 329688 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 329699 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 329699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 329706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329711 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329715 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329719 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 329722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329729 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329741 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329746 */     // GIR_Coverage, 5422,
     /* 329746 */     GIR_EraseRootFromParent_Done,
     /* 329747 */   // Label 6850: @329747
     /* 329747 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(329815), // Rule ID 5427 //
     /* 329752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329756 */     // MIs[0] Operand 2
     /* 329756 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 329767 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 329767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 329774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329779 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329783 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329787 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 329790 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329797 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329804 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329814 */     // GIR_Coverage, 5427,
     /* 329814 */     GIR_EraseRootFromParent_Done,
     /* 329815 */   // Label 6851: @329815
     /* 329815 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(329857), // Rule ID 6857 //
     /* 329820 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329824 */     // MIs[0] Operand 2
     /* 329824 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329835 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
     /* 329835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329840 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329856 */     // GIR_Coverage, 6857,
     /* 329856 */     GIR_EraseRootFromParent_Done,
     /* 329857 */   // Label 6852: @329857
     /* 329857 */   GIM_Try, /*On fail goto*//*Label 6853*/ GIMT_Encode4(329899), // Rule ID 6860 //
     /* 329862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329866 */     // MIs[0] Operand 2
     /* 329866 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 329877 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
     /* 329877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329882 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329898 */     // GIR_Coverage, 6860,
     /* 329898 */     GIR_EraseRootFromParent_Done,
     /* 329899 */   // Label 6853: @329899
     /* 329899 */   GIM_Try, /*On fail goto*//*Label 6854*/ GIMT_Encode4(329963), // Rule ID 6865 //
     /* 329904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329908 */     // MIs[0] Operand 2
     /* 329908 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 329919 */     // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 329919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 329926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329931 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 329935 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 329938 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 329945 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 329952 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329957 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329962 */     // GIR_Coverage, 6865,
     /* 329962 */     GIR_EraseRootFromParent_Done,
     /* 329963 */   // Label 6854: @329963
     /* 329963 */   GIM_Reject,
     /* 329964 */ // Label 6847: @329964
     /* 329964 */ GIM_Reject,
     /* 329965 */ // Label 6822: @329965
     /* 329965 */ GIM_Try, /*On fail goto*//*Label 6855*/ GIMT_Encode4(330144),
     /* 329970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 329973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329981 */   GIM_Try, /*On fail goto*//*Label 6856*/ GIMT_Encode4(330045), // Rule ID 5417 //
     /* 329986 */     // MIs[0] Operand 2
     /* 329986 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 329997 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 329997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 330000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 330004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330009 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 330013 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 330017 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 330020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330027 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 330034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330039 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330044 */     // GIR_Coverage, 5417,
     /* 330044 */     GIR_EraseRootFromParent_Done,
     /* 330045 */   // Label 6856: @330045
     /* 330045 */   GIM_Try, /*On fail goto*//*Label 6857*/ GIMT_Encode4(330083), // Rule ID 6858 //
     /* 330050 */     // MIs[0] Operand 2
     /* 330050 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 330061 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
     /* 330061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330066 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 330072 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330082 */     // GIR_Coverage, 6858,
     /* 330082 */     GIR_EraseRootFromParent_Done,
     /* 330083 */   // Label 6857: @330083
     /* 330083 */   GIM_Try, /*On fail goto*//*Label 6858*/ GIMT_Encode4(330143), // Rule ID 6864 //
     /* 330088 */     // MIs[0] Operand 2
     /* 330088 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 330099 */     // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 330099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 330102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 330106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330111 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 330115 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 330118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 330123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 330125 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 330132 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330142 */     // GIR_Coverage, 6864,
     /* 330142 */     GIR_EraseRootFromParent_Done,
     /* 330143 */   // Label 6858: @330143
     /* 330143 */   GIM_Reject,
     /* 330144 */ // Label 6855: @330144
     /* 330144 */ GIM_Reject,
     /* 330145 */ // Label 6823: @330145
     /* 330145 */ GIM_Try, /*On fail goto*//*Label 6859*/ GIMT_Encode4(330180), // Rule ID 8920 //
     /* 330150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 330156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330160 */   // MIs[0] Operand 2
     /* 330160 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 330171 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 330171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330176 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 330178 */   GIR_RootConstrainSelectedInstOperands,
     /* 330179 */   // GIR_Coverage, 8920,
     /* 330179 */   GIR_EraseRootFromParent_Done,
     /* 330180 */ // Label 6859: @330180
     /* 330180 */ GIM_Try, /*On fail goto*//*Label 6860*/ GIMT_Encode4(330215), // Rule ID 8921 //
     /* 330185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 330191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330195 */   // MIs[0] Operand 2
     /* 330195 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 330206 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 330206 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330209 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330211 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 330213 */   GIR_RootConstrainSelectedInstOperands,
     /* 330214 */   // GIR_Coverage, 8921,
     /* 330214 */   GIR_EraseRootFromParent_Done,
     /* 330215 */ // Label 6860: @330215
     /* 330215 */ GIM_Try, /*On fail goto*//*Label 6861*/ GIMT_Encode4(330269), // Rule ID 8928 //
     /* 330220 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 330226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330230 */   // MIs[0] Operand 2
     /* 330230 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 330241 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 330241 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330244 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330248 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330253 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330257 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330262 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330264 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330267 */   GIR_RootConstrainSelectedInstOperands,
     /* 330268 */   // GIR_Coverage, 8928,
     /* 330268 */   GIR_EraseRootFromParent_Done,
     /* 330269 */ // Label 6861: @330269
     /* 330269 */ GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(330323), // Rule ID 8929 //
     /* 330274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 330280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330284 */   // MIs[0] Operand 2
     /* 330284 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 330295 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 330295 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330298 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330302 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330307 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330311 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330313 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330316 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330318 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330321 */   GIR_RootConstrainSelectedInstOperands,
     /* 330322 */   // GIR_Coverage, 8929,
     /* 330322 */   GIR_EraseRootFromParent_Done,
     /* 330323 */ // Label 6862: @330323
     /* 330323 */ GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(330377), // Rule ID 8930 //
     /* 330328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 330334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330338 */   // MIs[0] Operand 2
     /* 330338 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 330349 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 330349 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330352 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330356 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330361 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330365 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330370 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330372 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330375 */   GIR_RootConstrainSelectedInstOperands,
     /* 330376 */   // GIR_Coverage, 8930,
     /* 330376 */   GIR_EraseRootFromParent_Done,
     /* 330377 */ // Label 6863: @330377
     /* 330377 */ GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(330431), // Rule ID 8931 //
     /* 330382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 330388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330392 */   // MIs[0] Operand 2
     /* 330392 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 330403 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 330403 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330406 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330410 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330415 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330421 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330424 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330426 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330429 */   GIR_RootConstrainSelectedInstOperands,
     /* 330430 */   // GIR_Coverage, 8931,
     /* 330430 */   GIR_EraseRootFromParent_Done,
     /* 330431 */ // Label 6864: @330431
     /* 330431 */ GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(330502), // Rule ID 8940 //
     /* 330436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330446 */   // MIs[0] Operand 2
     /* 330446 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 330457 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330457 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330460 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330464 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330469 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330473 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330475 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330478 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330482 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330487 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330490 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330492 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330495 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330497 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330500 */   GIR_RootConstrainSelectedInstOperands,
     /* 330501 */   // GIR_Coverage, 8940,
     /* 330501 */   GIR_EraseRootFromParent_Done,
     /* 330502 */ // Label 6865: @330502
     /* 330502 */ GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(330573), // Rule ID 8941 //
     /* 330507 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330510 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330517 */   // MIs[0] Operand 2
     /* 330517 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 330528 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330528 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330531 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330535 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330540 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330546 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330549 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330553 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330558 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330561 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330566 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330568 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330571 */   GIR_RootConstrainSelectedInstOperands,
     /* 330572 */   // GIR_Coverage, 8941,
     /* 330572 */   GIR_EraseRootFromParent_Done,
     /* 330573 */ // Label 6866: @330573
     /* 330573 */ GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(330644), // Rule ID 8942 //
     /* 330578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330588 */   // MIs[0] Operand 2
     /* 330588 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 330599 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330599 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330602 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330606 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330611 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330615 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330617 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330620 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330624 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330629 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330632 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330637 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330639 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330642 */   GIR_RootConstrainSelectedInstOperands,
     /* 330643 */   // GIR_Coverage, 8942,
     /* 330643 */   GIR_EraseRootFromParent_Done,
     /* 330644 */ // Label 6867: @330644
     /* 330644 */ GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(330715), // Rule ID 8943 //
     /* 330649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330659 */   // MIs[0] Operand 2
     /* 330659 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 330670 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330670 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330673 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330677 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330682 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330686 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330688 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330691 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330695 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330700 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330703 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330710 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330713 */   GIR_RootConstrainSelectedInstOperands,
     /* 330714 */   // GIR_Coverage, 8943,
     /* 330714 */   GIR_EraseRootFromParent_Done,
     /* 330715 */ // Label 6868: @330715
     /* 330715 */ GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(330786), // Rule ID 8944 //
     /* 330720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330730 */   // MIs[0] Operand 2
     /* 330730 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 330741 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330741 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330744 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330748 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330753 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330757 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330759 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330762 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330766 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330771 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330774 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330781 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330784 */   GIR_RootConstrainSelectedInstOperands,
     /* 330785 */   // GIR_Coverage, 8944,
     /* 330785 */   GIR_EraseRootFromParent_Done,
     /* 330786 */ // Label 6869: @330786
     /* 330786 */ GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(330857), // Rule ID 8945 //
     /* 330791 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330801 */   // MIs[0] Operand 2
     /* 330801 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 330812 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330812 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330815 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330819 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330824 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330828 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330830 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330833 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330837 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330842 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330845 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330852 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330855 */   GIR_RootConstrainSelectedInstOperands,
     /* 330856 */   // GIR_Coverage, 8945,
     /* 330856 */   GIR_EraseRootFromParent_Done,
     /* 330857 */ // Label 6870: @330857
     /* 330857 */ GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(330928), // Rule ID 8946 //
     /* 330862 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330872 */   // MIs[0] Operand 2
     /* 330872 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 330883 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330883 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330886 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330890 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330895 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330899 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330901 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330904 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330908 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330913 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330916 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 330921 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330923 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330926 */   GIR_RootConstrainSelectedInstOperands,
     /* 330927 */   // GIR_Coverage, 8946,
     /* 330927 */   GIR_EraseRootFromParent_Done,
     /* 330928 */ // Label 6871: @330928
     /* 330928 */ GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(330999), // Rule ID 8947 //
     /* 330933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 330936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 330939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 330943 */   // MIs[0] Operand 2
     /* 330943 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 330954 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 330954 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 330957 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330961 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330966 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 330970 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 330972 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 330975 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330979 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 330984 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 330987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 330989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 330992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 330994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 330997 */   GIR_RootConstrainSelectedInstOperands,
     /* 330998 */   // GIR_Coverage, 8947,
     /* 330998 */   GIR_EraseRootFromParent_Done,
     /* 330999 */ // Label 6872: @330999
     /* 330999 */ GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(331087), // Rule ID 8956 //
     /* 331004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331014 */   // MIs[0] Operand 2
     /* 331014 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 331025 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331025 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331028 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331032 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331037 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331043 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331046 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331050 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331055 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331058 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331072 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331085 */   GIR_RootConstrainSelectedInstOperands,
     /* 331086 */   // GIR_Coverage, 8956,
     /* 331086 */   GIR_EraseRootFromParent_Done,
     /* 331087 */ // Label 6873: @331087
     /* 331087 */ GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(331175), // Rule ID 8957 //
     /* 331092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331102 */   // MIs[0] Operand 2
     /* 331102 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 331113 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331113 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331116 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331120 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331125 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331129 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331131 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331134 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331138 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331143 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331146 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331148 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331151 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331155 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331160 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331163 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331170 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331173 */   GIR_RootConstrainSelectedInstOperands,
     /* 331174 */   // GIR_Coverage, 8957,
     /* 331174 */   GIR_EraseRootFromParent_Done,
     /* 331175 */ // Label 6874: @331175
     /* 331175 */ GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(331263), // Rule ID 8958 //
     /* 331180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331190 */   // MIs[0] Operand 2
     /* 331190 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 331201 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331201 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331204 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331208 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331213 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331219 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331222 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331226 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331231 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331236 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331239 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331243 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331248 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331258 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331261 */   GIR_RootConstrainSelectedInstOperands,
     /* 331262 */   // GIR_Coverage, 8958,
     /* 331262 */   GIR_EraseRootFromParent_Done,
     /* 331263 */ // Label 6875: @331263
     /* 331263 */ GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(331351), // Rule ID 8959 //
     /* 331268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331278 */   // MIs[0] Operand 2
     /* 331278 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 331289 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331289 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331292 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331296 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331301 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331307 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331310 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331314 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331319 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331322 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331324 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331327 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331331 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331336 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331339 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331341 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331344 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331346 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331349 */   GIR_RootConstrainSelectedInstOperands,
     /* 331350 */   // GIR_Coverage, 8959,
     /* 331350 */   GIR_EraseRootFromParent_Done,
     /* 331351 */ // Label 6876: @331351
     /* 331351 */ GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(331439), // Rule ID 8960 //
     /* 331356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331366 */   // MIs[0] Operand 2
     /* 331366 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 331377 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331377 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331380 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331384 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331389 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331393 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331395 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331398 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331402 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331407 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331412 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331415 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331419 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331424 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331427 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331434 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331437 */   GIR_RootConstrainSelectedInstOperands,
     /* 331438 */   // GIR_Coverage, 8960,
     /* 331438 */   GIR_EraseRootFromParent_Done,
     /* 331439 */ // Label 6877: @331439
     /* 331439 */ GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(331527), // Rule ID 8961 //
     /* 331444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331454 */   // MIs[0] Operand 2
     /* 331454 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 331465 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331465 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331468 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331472 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331477 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331481 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331483 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331486 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331490 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331495 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331498 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331500 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331503 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331507 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331512 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331522 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331525 */   GIR_RootConstrainSelectedInstOperands,
     /* 331526 */   // GIR_Coverage, 8961,
     /* 331526 */   GIR_EraseRootFromParent_Done,
     /* 331527 */ // Label 6878: @331527
     /* 331527 */ GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(331615), // Rule ID 8962 //
     /* 331532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331542 */   // MIs[0] Operand 2
     /* 331542 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 331553 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331553 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331556 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331560 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331565 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331569 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331571 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331574 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331578 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331583 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331586 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331588 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331591 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331595 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331600 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331610 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331613 */   GIR_RootConstrainSelectedInstOperands,
     /* 331614 */   // GIR_Coverage, 8962,
     /* 331614 */   GIR_EraseRootFromParent_Done,
     /* 331615 */ // Label 6879: @331615
     /* 331615 */ GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(331703), // Rule ID 8963 //
     /* 331620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331630 */   // MIs[0] Operand 2
     /* 331630 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 331641 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331641 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331644 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331648 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331653 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331659 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331662 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331666 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331671 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331674 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331676 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331679 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331683 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331688 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331691 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331693 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331696 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331698 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331701 */   GIR_RootConstrainSelectedInstOperands,
     /* 331702 */   // GIR_Coverage, 8963,
     /* 331702 */   GIR_EraseRootFromParent_Done,
     /* 331703 */ // Label 6880: @331703
     /* 331703 */ GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(331791), // Rule ID 8964 //
     /* 331708 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331711 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331718 */   // MIs[0] Operand 2
     /* 331718 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 331729 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331729 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331732 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331736 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331741 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331745 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331747 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331750 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331754 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331759 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331762 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331764 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331767 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331771 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331776 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331779 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331781 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331784 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331786 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331789 */   GIR_RootConstrainSelectedInstOperands,
     /* 331790 */   // GIR_Coverage, 8964,
     /* 331790 */   GIR_EraseRootFromParent_Done,
     /* 331791 */ // Label 6881: @331791
     /* 331791 */ GIM_Try, /*On fail goto*//*Label 6882*/ GIMT_Encode4(331879), // Rule ID 8965 //
     /* 331796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331806 */   // MIs[0] Operand 2
     /* 331806 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
     /* 331817 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331817 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331820 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331824 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331829 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331833 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331835 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331838 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331842 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331847 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331850 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331852 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331855 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331859 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331864 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331867 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331874 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331877 */   GIR_RootConstrainSelectedInstOperands,
     /* 331878 */   // GIR_Coverage, 8965,
     /* 331878 */   GIR_EraseRootFromParent_Done,
     /* 331879 */ // Label 6882: @331879
     /* 331879 */ GIM_Try, /*On fail goto*//*Label 6883*/ GIMT_Encode4(331967), // Rule ID 8966 //
     /* 331884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331894 */   // MIs[0] Operand 2
     /* 331894 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 331905 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331905 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331908 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331912 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331917 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 331921 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 331923 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 331926 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331930 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331935 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 331938 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 331940 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 331943 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 331947 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 331952 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 331955 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 331957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 331960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 331962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 331965 */   GIR_RootConstrainSelectedInstOperands,
     /* 331966 */   // GIR_Coverage, 8966,
     /* 331966 */   GIR_EraseRootFromParent_Done,
     /* 331967 */ // Label 6883: @331967
     /* 331967 */ GIM_Try, /*On fail goto*//*Label 6884*/ GIMT_Encode4(332055), // Rule ID 8967 //
     /* 331972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 331975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 331978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 331982 */   // MIs[0] Operand 2
     /* 331982 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
     /* 331993 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 331993 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 331996 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332000 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332005 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332009 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 332011 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332014 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332018 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332023 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332028 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332031 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332035 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332040 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332043 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332050 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332053 */   GIR_RootConstrainSelectedInstOperands,
     /* 332054 */   // GIR_Coverage, 8967,
     /* 332054 */   GIR_EraseRootFromParent_Done,
     /* 332055 */ // Label 6884: @332055
     /* 332055 */ GIM_Try, /*On fail goto*//*Label 6885*/ GIMT_Encode4(332143), // Rule ID 8968 //
     /* 332060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332070 */   // MIs[0] Operand 2
     /* 332070 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 332081 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 332081 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 332084 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332088 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332093 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332097 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 332099 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332102 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332106 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332111 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332114 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332116 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332119 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332123 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332128 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332131 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332133 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332136 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332138 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332141 */   GIR_RootConstrainSelectedInstOperands,
     /* 332142 */   // GIR_Coverage, 8968,
     /* 332142 */   GIR_EraseRootFromParent_Done,
     /* 332143 */ // Label 6885: @332143
     /* 332143 */ GIM_Try, /*On fail goto*//*Label 6886*/ GIMT_Encode4(332231), // Rule ID 8969 //
     /* 332148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332158 */   // MIs[0] Operand 2
     /* 332158 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
     /* 332169 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 332169 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 332172 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332176 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332181 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332185 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 332187 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332190 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332194 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332199 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332204 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332207 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332211 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332216 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332226 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332229 */   GIR_RootConstrainSelectedInstOperands,
     /* 332230 */   // GIR_Coverage, 8969,
     /* 332230 */   GIR_EraseRootFromParent_Done,
     /* 332231 */ // Label 6886: @332231
     /* 332231 */ GIM_Try, /*On fail goto*//*Label 6887*/ GIMT_Encode4(332319), // Rule ID 8970 //
     /* 332236 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332246 */   // MIs[0] Operand 2
     /* 332246 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 332257 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 332257 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 332260 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332264 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332269 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332273 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 332275 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332278 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332282 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332287 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332290 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332292 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332295 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332299 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332304 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332307 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332314 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332317 */   GIR_RootConstrainSelectedInstOperands,
     /* 332318 */   // GIR_Coverage, 8970,
     /* 332318 */   GIR_EraseRootFromParent_Done,
     /* 332319 */ // Label 6887: @332319
     /* 332319 */ GIM_Try, /*On fail goto*//*Label 6888*/ GIMT_Encode4(332407), // Rule ID 8971 //
     /* 332324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332334 */   // MIs[0] Operand 2
     /* 332334 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 332345 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 332345 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 332348 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332352 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332357 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332361 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 332363 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332366 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332370 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332375 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 332378 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332380 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332383 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332387 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332392 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332395 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332400 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332402 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332405 */   GIR_RootConstrainSelectedInstOperands,
     /* 332406 */   // GIR_Coverage, 8971,
     /* 332406 */   GIR_EraseRootFromParent_Done,
     /* 332407 */ // Label 6888: @332407
     /* 332407 */ GIM_Reject,
     /* 332408 */ // Label 6824: @332408
     /* 332408 */ GIM_Try, /*On fail goto*//*Label 6889*/ GIMT_Encode4(332443), // Rule ID 8922 //
     /* 332413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 332419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332423 */   // MIs[0] Operand 2
     /* 332423 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332434 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 332434 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332437 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332439 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 332441 */   GIR_RootConstrainSelectedInstOperands,
     /* 332442 */   // GIR_Coverage, 8922,
     /* 332442 */   GIR_EraseRootFromParent_Done,
     /* 332443 */ // Label 6889: @332443
     /* 332443 */ GIM_Try, /*On fail goto*//*Label 6890*/ GIMT_Encode4(332478), // Rule ID 8923 //
     /* 332448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 332454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332458 */   // MIs[0] Operand 2
     /* 332458 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 332469 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 332469 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332472 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332474 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 332476 */   GIR_RootConstrainSelectedInstOperands,
     /* 332477 */   // GIR_Coverage, 8923,
     /* 332477 */   GIR_EraseRootFromParent_Done,
     /* 332478 */ // Label 6890: @332478
     /* 332478 */ GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(332532), // Rule ID 8932 //
     /* 332483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 332489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332493 */   // MIs[0] Operand 2
     /* 332493 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332504 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 332504 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332507 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332511 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332516 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332520 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332530 */   GIR_RootConstrainSelectedInstOperands,
     /* 332531 */   // GIR_Coverage, 8932,
     /* 332531 */   GIR_EraseRootFromParent_Done,
     /* 332532 */ // Label 6891: @332532
     /* 332532 */ GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(332586), // Rule ID 8933 //
     /* 332537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 332543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332547 */   // MIs[0] Operand 2
     /* 332547 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 332558 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 332558 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332561 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332565 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332570 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332574 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332581 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332584 */   GIR_RootConstrainSelectedInstOperands,
     /* 332585 */   // GIR_Coverage, 8933,
     /* 332585 */   GIR_EraseRootFromParent_Done,
     /* 332586 */ // Label 6892: @332586
     /* 332586 */ GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(332640), // Rule ID 8934 //
     /* 332591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 332597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332601 */   // MIs[0] Operand 2
     /* 332601 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 332612 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 332612 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332615 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332619 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332624 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332635 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332638 */   GIR_RootConstrainSelectedInstOperands,
     /* 332639 */   // GIR_Coverage, 8934,
     /* 332639 */   GIR_EraseRootFromParent_Done,
     /* 332640 */ // Label 6893: @332640
     /* 332640 */ GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(332694), // Rule ID 8935 //
     /* 332645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 332651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332655 */   // MIs[0] Operand 2
     /* 332655 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 332666 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 332666 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332669 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332673 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332678 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332682 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332684 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332687 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332689 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332692 */   GIR_RootConstrainSelectedInstOperands,
     /* 332693 */   // GIR_Coverage, 8935,
     /* 332693 */   GIR_EraseRootFromParent_Done,
     /* 332694 */ // Label 6894: @332694
     /* 332694 */ GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(332765), // Rule ID 8948 //
     /* 332699 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332702 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332709 */   // MIs[0] Operand 2
     /* 332709 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 332720 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332720 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332723 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332727 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332732 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332736 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332738 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332741 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332745 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332750 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332753 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332755 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332758 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332760 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332763 */   GIR_RootConstrainSelectedInstOperands,
     /* 332764 */   // GIR_Coverage, 8948,
     /* 332764 */   GIR_EraseRootFromParent_Done,
     /* 332765 */ // Label 6895: @332765
     /* 332765 */ GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(332836), // Rule ID 8949 //
     /* 332770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332780 */   // MIs[0] Operand 2
     /* 332780 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 332791 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332791 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332794 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332798 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332803 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332807 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332821 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332824 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332826 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332829 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332831 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332834 */   GIR_RootConstrainSelectedInstOperands,
     /* 332835 */   // GIR_Coverage, 8949,
     /* 332835 */   GIR_EraseRootFromParent_Done,
     /* 332836 */ // Label 6896: @332836
     /* 332836 */ GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(332907), // Rule ID 8950 //
     /* 332841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332851 */   // MIs[0] Operand 2
     /* 332851 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 332862 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332862 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332865 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332869 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332874 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332878 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332880 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332883 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332887 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332892 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332895 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332900 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332902 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332905 */   GIR_RootConstrainSelectedInstOperands,
     /* 332906 */   // GIR_Coverage, 8950,
     /* 332906 */   GIR_EraseRootFromParent_Done,
     /* 332907 */ // Label 6897: @332907
     /* 332907 */ GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(332978), // Rule ID 8951 //
     /* 332912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332922 */   // MIs[0] Operand 2
     /* 332922 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 332933 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 332933 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 332936 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 332940 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332945 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 332949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 332951 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 332954 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332958 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332963 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 332966 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332968 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 332971 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 332973 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332976 */   GIR_RootConstrainSelectedInstOperands,
     /* 332977 */   // GIR_Coverage, 8951,
     /* 332977 */   GIR_EraseRootFromParent_Done,
     /* 332978 */ // Label 6898: @332978
     /* 332978 */ GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(333049), // Rule ID 8952 //
     /* 332983 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 332986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 332989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 332993 */   // MIs[0] Operand 2
     /* 332993 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 333004 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 333004 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333007 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333011 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333016 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333020 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333022 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333025 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333029 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333034 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333037 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333042 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333044 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333047 */   GIR_RootConstrainSelectedInstOperands,
     /* 333048 */   // GIR_Coverage, 8952,
     /* 333048 */   GIR_EraseRootFromParent_Done,
     /* 333049 */ // Label 6899: @333049
     /* 333049 */ GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(333120), // Rule ID 8953 //
     /* 333054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333060 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333064 */   // MIs[0] Operand 2
     /* 333064 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 333075 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 333075 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333078 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333082 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333087 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333091 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333093 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333096 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333100 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333105 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333108 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333115 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333118 */   GIR_RootConstrainSelectedInstOperands,
     /* 333119 */   // GIR_Coverage, 8953,
     /* 333119 */   GIR_EraseRootFromParent_Done,
     /* 333120 */ // Label 6900: @333120
     /* 333120 */ GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(333191), // Rule ID 8954 //
     /* 333125 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333128 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333135 */   // MIs[0] Operand 2
     /* 333135 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 333146 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 333146 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333149 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333153 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333158 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333164 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333167 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333171 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333176 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333179 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333181 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333184 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333186 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333189 */   GIR_RootConstrainSelectedInstOperands,
     /* 333190 */   // GIR_Coverage, 8954,
     /* 333190 */   GIR_EraseRootFromParent_Done,
     /* 333191 */ // Label 6901: @333191
     /* 333191 */ GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(333262), // Rule ID 8955 //
     /* 333196 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333206 */   // MIs[0] Operand 2
     /* 333206 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 333217 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 333217 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 333220 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333224 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333229 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333233 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333235 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333238 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333242 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333247 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 333250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333257 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333260 */   GIR_RootConstrainSelectedInstOperands,
     /* 333261 */   // GIR_Coverage, 8955,
     /* 333261 */   GIR_EraseRootFromParent_Done,
     /* 333262 */ // Label 6902: @333262
     /* 333262 */ GIM_Reject,
     /* 333263 */ // Label 6825: @333263
     /* 333263 */ GIM_Try, /*On fail goto*//*Label 6903*/ GIMT_Encode4(333298), // Rule ID 8972 //
     /* 333268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 333274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 333278 */   // MIs[0] Operand 2
     /* 333278 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333289 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 333289 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 333292 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 333294 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 333296 */   GIR_RootConstrainSelectedInstOperands,
     /* 333297 */   // GIR_Coverage, 8972,
     /* 333297 */   GIR_EraseRootFromParent_Done,
     /* 333298 */ // Label 6903: @333298
     /* 333298 */ GIM_Try, /*On fail goto*//*Label 6904*/ GIMT_Encode4(333333), // Rule ID 8973 //
     /* 333303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 333309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 333313 */   // MIs[0] Operand 2
     /* 333313 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 333324 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 333324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 333327 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 333329 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 333331 */   GIR_RootConstrainSelectedInstOperands,
     /* 333332 */   // GIR_Coverage, 8973,
     /* 333332 */   GIR_EraseRootFromParent_Done,
     /* 333333 */ // Label 6904: @333333
     /* 333333 */ GIM_Try, /*On fail goto*//*Label 6905*/ GIMT_Encode4(333387), // Rule ID 8978 //
     /* 333338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 333344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 333348 */   // MIs[0] Operand 2
     /* 333348 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333359 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 333359 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 333362 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 333366 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333371 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 333375 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 333380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 333382 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333385 */   GIR_RootConstrainSelectedInstOperands,
     /* 333386 */   // GIR_Coverage, 8978,
     /* 333386 */   GIR_EraseRootFromParent_Done,
     /* 333387 */ // Label 6905: @333387
     /* 333387 */ GIM_Try, /*On fail goto*//*Label 6906*/ GIMT_Encode4(333441), // Rule ID 8979 //
     /* 333392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 333398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 333402 */   // MIs[0] Operand 2
     /* 333402 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 333413 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 333413 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 333416 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 333420 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333425 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 333429 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 333434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 333436 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333439 */   GIR_RootConstrainSelectedInstOperands,
     /* 333440 */   // GIR_Coverage, 8979,
     /* 333440 */   GIR_EraseRootFromParent_Done,
     /* 333441 */ // Label 6906: @333441
     /* 333441 */ GIM_Try, /*On fail goto*//*Label 6907*/ GIMT_Encode4(333495), // Rule ID 8980 //
     /* 333446 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333449 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 333452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 333456 */   // MIs[0] Operand 2
     /* 333456 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 333467 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 333467 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 333470 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 333474 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333479 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 333483 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 333488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 333490 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333493 */   GIR_RootConstrainSelectedInstOperands,
     /* 333494 */   // GIR_Coverage, 8980,
     /* 333494 */   GIR_EraseRootFromParent_Done,
     /* 333495 */ // Label 6907: @333495
     /* 333495 */ GIM_Try, /*On fail goto*//*Label 6908*/ GIMT_Encode4(333549), // Rule ID 8981 //
     /* 333500 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333503 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 333506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 333510 */   // MIs[0] Operand 2
     /* 333510 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 333521 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 333521 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 333524 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 333528 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333533 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 333537 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333539 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 333542 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 333544 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333547 */   GIR_RootConstrainSelectedInstOperands,
     /* 333548 */   // GIR_Coverage, 8981,
     /* 333548 */   GIR_EraseRootFromParent_Done,
     /* 333549 */ // Label 6908: @333549
     /* 333549 */ GIM_Reject,
     /* 333550 */ // Label 6826: @333550
     /* 333550 */ GIM_Try, /*On fail goto*//*Label 6909*/ GIMT_Encode4(333619),
     /* 333555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 333558 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 333562 */   GIM_Try, /*On fail goto*//*Label 6910*/ GIMT_Encode4(333590), // Rule ID 8976 //
     /* 333567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333570 */     // MIs[0] Operand 2
     /* 333570 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333581 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 333581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 333584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 333586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 333588 */     GIR_RootConstrainSelectedInstOperands,
     /* 333589 */     // GIR_Coverage, 8976,
     /* 333589 */     GIR_EraseRootFromParent_Done,
     /* 333590 */   // Label 6910: @333590
     /* 333590 */   GIM_Try, /*On fail goto*//*Label 6911*/ GIMT_Encode4(333618), // Rule ID 8977 //
     /* 333595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333598 */     // MIs[0] Operand 2
     /* 333598 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 333609 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 333609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 333612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 333614 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 333616 */     GIR_RootConstrainSelectedInstOperands,
     /* 333617 */     // GIR_Coverage, 8977,
     /* 333617 */     GIR_EraseRootFromParent_Done,
     /* 333618 */   // Label 6911: @333618
     /* 333618 */   GIM_Reject,
     /* 333619 */ // Label 6909: @333619
     /* 333619 */ GIM_Reject,
     /* 333620 */ // Label 6827: @333620
     /* 333620 */ GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(333655), // Rule ID 8924 //
     /* 333625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333635 */   // MIs[0] Operand 2
     /* 333635 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333646 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 333646 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333649 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333651 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 333653 */   GIR_RootConstrainSelectedInstOperands,
     /* 333654 */   // GIR_Coverage, 8924,
     /* 333654 */   GIR_EraseRootFromParent_Done,
     /* 333655 */ // Label 6912: @333655
     /* 333655 */ GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(333690), // Rule ID 8925 //
     /* 333660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 333666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333670 */   // MIs[0] Operand 2
     /* 333670 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 333681 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 333681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333686 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 333688 */   GIR_RootConstrainSelectedInstOperands,
     /* 333689 */   // GIR_Coverage, 8925,
     /* 333689 */   GIR_EraseRootFromParent_Done,
     /* 333690 */ // Label 6913: @333690
     /* 333690 */ GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(333744), // Rule ID 8936 //
     /* 333695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333705 */   // MIs[0] Operand 2
     /* 333705 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333716 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 333716 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333719 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333723 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333728 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333732 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333737 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333739 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333742 */   GIR_RootConstrainSelectedInstOperands,
     /* 333743 */   // GIR_Coverage, 8936,
     /* 333743 */   GIR_EraseRootFromParent_Done,
     /* 333744 */ // Label 6914: @333744
     /* 333744 */ GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(333798), // Rule ID 8937 //
     /* 333749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333759 */   // MIs[0] Operand 2
     /* 333759 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 333770 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 333770 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333773 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333777 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333782 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333786 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333793 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333796 */   GIR_RootConstrainSelectedInstOperands,
     /* 333797 */   // GIR_Coverage, 8937,
     /* 333797 */   GIR_EraseRootFromParent_Done,
     /* 333798 */ // Label 6915: @333798
     /* 333798 */ GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(333852), // Rule ID 8938 //
     /* 333803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333813 */   // MIs[0] Operand 2
     /* 333813 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 333824 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 333824 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333827 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333831 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333836 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333840 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 333845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333847 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333850 */   GIR_RootConstrainSelectedInstOperands,
     /* 333851 */   // GIR_Coverage, 8938,
     /* 333851 */   GIR_EraseRootFromParent_Done,
     /* 333852 */ // Label 6916: @333852
     /* 333852 */ GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(333906), // Rule ID 8939 //
     /* 333857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333867 */   // MIs[0] Operand 2
     /* 333867 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 333878 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 333878 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 333881 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333885 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333890 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 333894 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 333896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 333899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 333901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333904 */   GIR_RootConstrainSelectedInstOperands,
     /* 333905 */   // GIR_Coverage, 8939,
     /* 333905 */   GIR_EraseRootFromParent_Done,
     /* 333906 */ // Label 6917: @333906
     /* 333906 */ GIM_Reject,
     /* 333907 */ // Label 6828: @333907
     /* 333907 */ GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(333976),
     /* 333912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 333915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 333919 */   GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(333947), // Rule ID 8974 //
     /* 333924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333927 */     // MIs[0] Operand 2
     /* 333927 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 333938 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 333938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 333941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 333943 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 333945 */     GIR_RootConstrainSelectedInstOperands,
     /* 333946 */     // GIR_Coverage, 8974,
     /* 333946 */     GIR_EraseRootFromParent_Done,
     /* 333947 */   // Label 6919: @333947
     /* 333947 */   GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(333975), // Rule ID 8975 //
     /* 333952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333955 */     // MIs[0] Operand 2
     /* 333955 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 333966 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 333966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 333969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 333971 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 333973 */     GIR_RootConstrainSelectedInstOperands,
     /* 333974 */     // GIR_Coverage, 8975,
     /* 333974 */     GIR_EraseRootFromParent_Done,
     /* 333975 */   // Label 6920: @333975
     /* 333975 */   GIM_Reject,
     /* 333976 */ // Label 6918: @333976
     /* 333976 */ GIM_Reject,
     /* 333977 */ // Label 6829: @333977
     /* 333977 */ GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(334046),
     /* 333982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 333985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 333989 */   GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(334017), // Rule ID 8926 //
     /* 333994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 333997 */     // MIs[0] Operand 2
     /* 333997 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 334008 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 334008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 334011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334013 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 334015 */     GIR_RootConstrainSelectedInstOperands,
     /* 334016 */     // GIR_Coverage, 8926,
     /* 334016 */     GIR_EraseRootFromParent_Done,
     /* 334017 */   // Label 6922: @334017
     /* 334017 */   GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(334045), // Rule ID 8927 //
     /* 334022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 334025 */     // MIs[0] Operand 2
     /* 334025 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 334036 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 334036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 334039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 334041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 334043 */     GIR_RootConstrainSelectedInstOperands,
     /* 334044 */     // GIR_Coverage, 8927,
     /* 334044 */     GIR_EraseRootFromParent_Done,
     /* 334045 */   // Label 6923: @334045
     /* 334045 */   GIM_Reject,
     /* 334046 */ // Label 6921: @334046
     /* 334046 */ GIM_Reject,
     /* 334047 */ // Label 6830: @334047
     /* 334047 */ GIM_Reject,
     /* 334048 */ // Label 88: @334048
     /* 334048 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 6939*/ GIMT_Encode4(361444),
     /* 334059 */ /*GILLT_s64*//*Label 6924*/ GIMT_Encode4(334143), GIMT_Encode4(0),
     /* 334067 */ /*GILLT_v2s32*//*Label 6925*/ GIMT_Encode4(334853),
     /* 334071 */ /*GILLT_v2s64*//*Label 6926*/ GIMT_Encode4(338384),
     /* 334075 */ /*GILLT_v4s16*//*Label 6927*/ GIMT_Encode4(341213),
     /* 334079 */ /*GILLT_v4s32*//*Label 6928*/ GIMT_Encode4(344853),
     /* 334083 */ /*GILLT_v8s8*//*Label 6929*/ GIMT_Encode4(347517),
     /* 334087 */ /*GILLT_v8s16*//*Label 6930*/ GIMT_Encode4(349361),
     /* 334091 */ /*GILLT_v16s8*//*Label 6931*/ GIMT_Encode4(352336), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 334103 */ /*GILLT_nxv2s16*//*Label 6932*/ GIMT_Encode4(353916),
     /* 334107 */ /*GILLT_nxv2s32*//*Label 6933*/ GIMT_Encode4(354041),
     /* 334111 */ /*GILLT_nxv2s64*//*Label 6934*/ GIMT_Encode4(354166), GIMT_Encode4(0),
     /* 334119 */ /*GILLT_nxv4s16*//*Label 6935*/ GIMT_Encode4(356080),
     /* 334123 */ /*GILLT_nxv4s32*//*Label 6936*/ GIMT_Encode4(356232), GIMT_Encode4(0),
     /* 334131 */ /*GILLT_nxv8s16*//*Label 6937*/ GIMT_Encode4(358200), GIMT_Encode4(0),
     /* 334139 */ /*GILLT_nxv16s8*//*Label 6938*/ GIMT_Encode4(360394),
     /* 334143 */ // Label 6924: @334143
     /* 334143 */ GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(334852),
     /* 334148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 334151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 334154 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 334157 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334161 */   GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(334291), // Rule ID 5711 //
     /* 334166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 334174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 334178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 334182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 334186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 334195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 334199 */     // MIs[2] Operand 1
     /* 334199 */     // No operand predicates
     /* 334199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 334203 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 334207 */     // MIs[3] Operand 1
     /* 334207 */     // No operand predicates
     /* 334207 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334209 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 334209 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334212 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334216 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334221 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334224 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 334228 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 334231 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334236 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 334244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 334248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334253 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334256 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 334259 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 334263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 334266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334273 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334280 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334290 */     // GIR_Coverage, 5711,
     /* 334290 */     GIR_EraseRootFromParent_Done,
     /* 334291 */   // Label 6941: @334291
     /* 334291 */   GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(334452), // Rule ID 5712 //
     /* 334296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 334304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 334308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 334312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 334316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 334325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 334329 */     // MIs[2] Operand 1
     /* 334329 */     // No operand predicates
     /* 334329 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 334333 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 334337 */     // MIs[3] Operand 1
     /* 334337 */     // No operand predicates
     /* 334337 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334339 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 334339 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 334342 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334346 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334351 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 334354 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 334358 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 334361 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334366 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334371 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334374 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334378 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334383 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334386 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 334390 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 334393 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334398 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 334406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 334410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334415 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334418 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 334421 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 334424 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 334427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334434 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334451 */     // GIR_Coverage, 5712,
     /* 334451 */     GIR_EraseRootFromParent_Done,
     /* 334452 */   // Label 6942: @334452
     /* 334452 */   GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(334582), // Rule ID 5735 //
     /* 334457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 334465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 334469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 334473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 334477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 334486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 334490 */     // MIs[2] Operand 1
     /* 334490 */     // No operand predicates
     /* 334490 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 334494 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 334498 */     // MIs[3] Operand 1
     /* 334498 */     // No operand predicates
     /* 334498 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334500 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 334500 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334503 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334507 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334512 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334515 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 334519 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 334522 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334527 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 334535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 334539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334544 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 334550 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 334554 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 334557 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334564 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334571 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334581 */     // GIR_Coverage, 5735,
     /* 334581 */     GIR_EraseRootFromParent_Done,
     /* 334582 */   // Label 6943: @334582
     /* 334582 */   GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(334743), // Rule ID 5736 //
     /* 334587 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 334595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 334599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 334603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 334607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 334616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 334620 */     // MIs[2] Operand 1
     /* 334620 */     // No operand predicates
     /* 334620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 334624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 334628 */     // MIs[3] Operand 1
     /* 334628 */     // No operand predicates
     /* 334628 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 334630 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 334630 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 334633 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334637 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334642 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 334645 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 334649 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 334652 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334657 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334662 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334665 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334669 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334674 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334677 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 334681 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 334684 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334689 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 334697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 334701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334706 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 334709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 334712 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 334715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 334718 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334725 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334732 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334742 */     // GIR_Coverage, 5736,
     /* 334742 */     GIR_EraseRootFromParent_Done,
     /* 334743 */   // Label 6944: @334743
     /* 334743 */   GIM_Try, /*On fail goto*//*Label 6945*/ GIMT_Encode4(334779), // Rule ID 6638 //
     /* 334748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 334760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334766 */     // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 334766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 334773 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334778 */     // GIR_Coverage, 6638,
     /* 334778 */     GIR_EraseRootFromParent_Done,
     /* 334779 */   // Label 6945: @334779
     /* 334779 */   GIM_Try, /*On fail goto*//*Label 6946*/ GIMT_Encode4(334815), // Rule ID 6640 //
     /* 334784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 334796 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334802 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 334802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 334809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334814 */     // GIR_Coverage, 6640,
     /* 334814 */     GIR_EraseRootFromParent_Done,
     /* 334815 */   // Label 6946: @334815
     /* 334815 */   GIM_Try, /*On fail goto*//*Label 6947*/ GIMT_Encode4(334851), // Rule ID 6642 //
     /* 334820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 334828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334838 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
     /* 334838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334841 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 334843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 334845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334850 */     // GIR_Coverage, 6642,
     /* 334850 */     GIR_EraseRootFromParent_Done,
     /* 334851 */   // Label 6947: @334851
     /* 334851 */   GIM_Reject,
     /* 334852 */ // Label 6940: @334852
     /* 334852 */ GIM_Reject,
     /* 334853 */ // Label 6925: @334853
     /* 334853 */ GIM_Try, /*On fail goto*//*Label 6948*/ GIMT_Encode4(338383),
     /* 334858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 334861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 334864 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 334867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334871 */   GIM_Try, /*On fail goto*//*Label 6949*/ GIMT_Encode4(334980), // Rule ID 4260 //
     /* 334876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334880 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334886 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 334892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334896 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334899 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 334903 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 334907 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 334911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 334913 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 334920 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 334920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 334927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 334947 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 334953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 334958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 334960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 334963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 334969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334974 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334979 */     // GIR_Coverage, 4260,
     /* 334979 */     GIR_EraseRootFromParent_Done,
     /* 334980 */   // Label 6949: @334980
     /* 334980 */   GIM_Try, /*On fail goto*//*Label 6950*/ GIMT_Encode4(335089), // Rule ID 4261 //
     /* 334985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334989 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 334995 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 334997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335005 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335008 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335012 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 335029 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 335029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 335036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 335056 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335078 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335083 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335088 */     // GIR_Coverage, 4261,
     /* 335088 */     GIR_EraseRootFromParent_Done,
     /* 335089 */   // Label 6950: @335089
     /* 335089 */   GIM_Try, /*On fail goto*//*Label 6951*/ GIMT_Encode4(335198), // Rule ID 4368 //
     /* 335094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335098 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 335104 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 335106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335114 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335117 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335121 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335131 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 335138 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 335138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 335145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 335165 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335187 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335192 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335197 */     // GIR_Coverage, 4368,
     /* 335197 */     GIR_EraseRootFromParent_Done,
     /* 335198 */   // Label 6951: @335198
     /* 335198 */   GIM_Try, /*On fail goto*//*Label 6952*/ GIMT_Encode4(335307), // Rule ID 4369 //
     /* 335203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335207 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 335213 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 335215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335223 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335226 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335230 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335240 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 335247 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 335247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 335254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 335274 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335296 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335301 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335306 */     // GIR_Coverage, 4369,
     /* 335306 */     GIR_EraseRootFromParent_Done,
     /* 335307 */   // Label 6952: @335307
     /* 335307 */   GIM_Try, /*On fail goto*//*Label 6953*/ GIMT_Encode4(335412), // Rule ID 4266 //
     /* 335312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335328 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335331 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335335 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335345 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 335352 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 335352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 335359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 335379 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335406 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335411 */     // GIR_Coverage, 4266,
     /* 335411 */     GIR_EraseRootFromParent_Done,
     /* 335412 */   // Label 6953: @335412
     /* 335412 */   GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(335517), // Rule ID 4268 //
     /* 335417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335433 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335436 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335440 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335450 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 335457 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 335457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 335464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 335484 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335511 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335516 */     // GIR_Coverage, 4268,
     /* 335516 */     GIR_EraseRootFromParent_Done,
     /* 335517 */   // Label 6954: @335517
     /* 335517 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(335622), // Rule ID 4374 //
     /* 335522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335538 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335541 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335545 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335549 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335555 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 335562 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 335562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 335569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 335589 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335621 */     // GIR_Coverage, 4374,
     /* 335621 */     GIR_EraseRootFromParent_Done,
     /* 335622 */   // Label 6955: @335622
     /* 335622 */   GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(335727), // Rule ID 4376 //
     /* 335627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 335635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335643 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335646 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335650 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 335667 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 335667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 335674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 335694 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335726 */     // GIR_Coverage, 4376,
     /* 335726 */     GIR_EraseRootFromParent_Done,
     /* 335727 */   // Label 6956: @335727
     /* 335727 */   GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(335831), // Rule ID 4258 //
     /* 335732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335736 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 335742 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 335744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335752 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335755 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335759 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335763 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335769 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 335776 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 335776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 335783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335798 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335825 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335830 */     // GIR_Coverage, 4258,
     /* 335830 */     GIR_EraseRootFromParent_Done,
     /* 335831 */   // Label 6957: @335831
     /* 335831 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(335935), // Rule ID 4259 //
     /* 335836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335840 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 335846 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 335848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335856 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335859 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335863 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335867 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335873 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 335880 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 335880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 335887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335902 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 335908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 335910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 335913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 335915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 335918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 335924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335934 */     // GIR_Coverage, 4259,
     /* 335934 */     GIR_EraseRootFromParent_Done,
     /* 335935 */   // Label 6958: @335935
     /* 335935 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(336039), // Rule ID 4366 //
     /* 335940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335944 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 335950 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 335952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 335956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335960 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335963 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 335967 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 335971 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 335975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 335977 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 335984 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 335984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 335987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 335991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336006 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336038 */     // GIR_Coverage, 4366,
     /* 336038 */     GIR_EraseRootFromParent_Done,
     /* 336039 */   // Label 6959: @336039
     /* 336039 */   GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(336143), // Rule ID 4367 //
     /* 336044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336048 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 336054 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 336056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336064 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336067 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336071 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336075 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336081 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 336088 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 336088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 336095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336110 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336132 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336142 */     // GIR_Coverage, 4367,
     /* 336142 */     GIR_EraseRootFromParent_Done,
     /* 336143 */   // Label 6960: @336143
     /* 336143 */   GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(336243), // Rule ID 4262 //
     /* 336148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336164 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336167 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336171 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336175 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 336188 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 336188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 336195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336210 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336232 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336242 */     // GIR_Coverage, 4262,
     /* 336242 */     GIR_EraseRootFromParent_Done,
     /* 336243 */   // Label 6961: @336243
     /* 336243 */   GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(336343), // Rule ID 4264 //
     /* 336248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336264 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336267 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336271 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336275 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336281 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 336288 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 336288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 336295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336310 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336342 */     // GIR_Coverage, 4264,
     /* 336342 */     GIR_EraseRootFromParent_Done,
     /* 336343 */   // Label 6962: @336343
     /* 336343 */   GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(336443), // Rule ID 4370 //
     /* 336348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336364 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336367 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336371 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336381 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 336388 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 336388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 336395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336410 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336442 */     // GIR_Coverage, 4370,
     /* 336442 */     GIR_EraseRootFromParent_Done,
     /* 336443 */   // Label 6963: @336443
     /* 336443 */   GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(336543), // Rule ID 4372 //
     /* 336448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336464 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336467 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336471 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 336475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336481 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 336488 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 336488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 336495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336510 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 336526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 336532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336537 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336542 */     // GIR_Coverage, 4372,
     /* 336542 */     GIR_EraseRootFromParent_Done,
     /* 336543 */   // Label 6964: @336543
     /* 336543 */   GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(336663), // Rule ID 6417 //
     /* 336548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 336551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336567 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336570 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336574 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336581 */     // MIs[2] Rn
     /* 336581 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 336585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 336590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336596 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 336596 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 336599 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336603 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 336617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336622 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336625 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 336628 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 336632 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336645 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336652 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336657 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336662 */     // GIR_Coverage, 6417,
     /* 336662 */     GIR_EraseRootFromParent_Done,
     /* 336663 */   // Label 6965: @336663
     /* 336663 */   GIM_Try, /*On fail goto*//*Label 6966*/ GIMT_Encode4(336783), // Rule ID 6419 //
     /* 336668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 336671 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336675 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 336679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 336683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 336687 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336690 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 336694 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 336701 */     // MIs[2] Rn
     /* 336701 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 336705 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 336710 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 336714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 336716 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 336716 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 336719 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336723 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 336737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336742 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336745 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 336748 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 336752 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 336758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336765 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336777 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336782 */     // GIR_Coverage, 6419,
     /* 336782 */     GIR_EraseRootFromParent_Done,
     /* 336783 */   // Label 6966: @336783
     /* 336783 */   GIM_Try, /*On fail goto*//*Label 6967*/ GIMT_Encode4(336913), // Rule ID 5705 //
     /* 336788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 336804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 336817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336821 */     // MIs[2] Operand 1
     /* 336821 */     // No operand predicates
     /* 336821 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 336825 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336829 */     // MIs[3] Operand 1
     /* 336829 */     // No operand predicates
     /* 336829 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336831 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 336831 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336834 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336838 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336843 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336846 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 336850 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 336853 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336858 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 336866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 336870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336875 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 336878 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 336881 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336885 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 336888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 336895 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336912 */     // GIR_Coverage, 5705,
     /* 336912 */     GIR_EraseRootFromParent_Done,
     /* 336913 */   // Label 6967: @336913
     /* 336913 */   GIM_Try, /*On fail goto*//*Label 6968*/ GIMT_Encode4(337074), // Rule ID 5706 //
     /* 336918 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336922 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 336926 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336930 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 336934 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 336947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336951 */     // MIs[2] Operand 1
     /* 336951 */     // No operand predicates
     /* 336951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 336955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 336959 */     // MIs[3] Operand 1
     /* 336959 */     // No operand predicates
     /* 336959 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 336961 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 336961 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 336964 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 336968 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336973 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 336976 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336980 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 336983 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336988 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336993 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336996 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337000 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337005 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337008 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 337012 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337015 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337020 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 337032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337037 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 337043 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 337049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337056 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337063 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337073 */     // GIR_Coverage, 5706,
     /* 337073 */     GIR_EraseRootFromParent_Done,
     /* 337074 */   // Label 6968: @337074
     /* 337074 */   GIM_Try, /*On fail goto*//*Label 6969*/ GIMT_Encode4(337204), // Rule ID 5729 //
     /* 337079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337087 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337091 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 337095 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 337108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337112 */     // MIs[2] Operand 1
     /* 337112 */     // No operand predicates
     /* 337112 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 337116 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337120 */     // MIs[3] Operand 1
     /* 337120 */     // No operand predicates
     /* 337120 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337122 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 337122 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337125 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337129 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337134 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337137 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 337141 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337144 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337149 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 337161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337166 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 337172 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 337179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337186 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337193 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337198 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337203 */     // GIR_Coverage, 5729,
     /* 337203 */     GIR_EraseRootFromParent_Done,
     /* 337204 */   // Label 6969: @337204
     /* 337204 */   GIM_Try, /*On fail goto*//*Label 6970*/ GIMT_Encode4(337365), // Rule ID 5730 //
     /* 337209 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 337225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 337238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337242 */     // MIs[2] Operand 1
     /* 337242 */     // No operand predicates
     /* 337242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 337246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337250 */     // MIs[3] Operand 1
     /* 337250 */     // No operand predicates
     /* 337250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 337252 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 337252 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 337255 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337259 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337264 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 337267 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337271 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 337274 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337279 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337284 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337287 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337291 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337296 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337299 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 337303 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337306 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337311 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 337323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337328 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337331 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 337334 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 337340 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337347 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337354 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337359 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337364 */     // GIR_Coverage, 5730,
     /* 337364 */     GIR_EraseRootFromParent_Done,
     /* 337365 */   // Label 6970: @337365
     /* 337365 */   GIM_Try, /*On fail goto*//*Label 6971*/ GIMT_Encode4(337431), // Rule ID 5660 //
     /* 337370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337382 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337386 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337388 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 337388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 337391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 337412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337415 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337430 */     // GIR_Coverage, 5660,
     /* 337430 */     GIR_EraseRootFromParent_Done,
     /* 337431 */   // Label 6971: @337431
     /* 337431 */   GIM_Try, /*On fail goto*//*Label 6972*/ GIMT_Encode4(337497), // Rule ID 5672 //
     /* 337436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 337444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 337452 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337454 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 337454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 337457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337466 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 337478 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 337481 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337496 */     // GIR_Coverage, 5672,
     /* 337496 */     GIR_EraseRootFromParent_Done,
     /* 337497 */   // Label 6972: @337497
     /* 337497 */   GIM_Try, /*On fail goto*//*Label 6973*/ GIMT_Encode4(337632), // Rule ID 5680 //
     /* 337502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 337514 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 337518 */     // MIs[1] Operand 1
     /* 337518 */     // No operand predicates
     /* 337518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 337522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337526 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 337530 */     // MIs[2] Operand 1
     /* 337530 */     // No operand predicates
     /* 337530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337532 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 337532 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 337535 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337539 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337546 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 337549 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337553 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337558 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 337561 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 337565 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337568 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337573 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337578 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 337590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337595 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337598 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 337601 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 337607 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337614 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337621 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337626 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337631 */     // GIR_Coverage, 5680,
     /* 337631 */     GIR_EraseRootFromParent_Done,
     /* 337632 */   // Label 6973: @337632
     /* 337632 */   GIM_Try, /*On fail goto*//*Label 6974*/ GIMT_Encode4(337764), // Rule ID 6425 //
     /* 337637 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337649 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337652 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 337656 */     // MIs[1] Rn
     /* 337656 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 337660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 337665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 337669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337673 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 337677 */     // MIs[2] Operand 1
     /* 337677 */     // No operand predicates
     /* 337677 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337679 */     // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 337679 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337682 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337686 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337691 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337694 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 337698 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337701 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337706 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 337718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337723 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337726 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 337729 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337733 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337739 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337746 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337758 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337763 */     // GIR_Coverage, 6425,
     /* 337763 */     GIR_EraseRootFromParent_Done,
     /* 337764 */   // Label 6974: @337764
     /* 337764 */   GIM_Try, /*On fail goto*//*Label 6975*/ GIMT_Encode4(337896), // Rule ID 6426 //
     /* 337769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 337781 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337784 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 337788 */     // MIs[1] Rn
     /* 337788 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 337792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 337797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 337801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337805 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 337809 */     // MIs[2] Operand 1
     /* 337809 */     // No operand predicates
     /* 337809 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337811 */     // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 337811 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 337814 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 337818 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337823 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 337826 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 337830 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 337833 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337838 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 337846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 337850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337855 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 337861 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337865 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 337871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 337878 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 337885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337895 */     // GIR_Coverage, 6426,
     /* 337895 */     GIR_EraseRootFromParent_Done,
     /* 337896 */   // Label 6975: @337896
     /* 337896 */   GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(338079), // Rule ID 5738 //
     /* 337901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 337905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 337909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 337913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 337922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 337926 */     // MIs[2] Operand 1
     /* 337926 */     // No operand predicates
     /* 337926 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337928 */     // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 337928 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
     /* 337931 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337935 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337940 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 337942 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 337945 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337949 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337954 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 337957 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 337961 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 337964 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337969 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337974 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337979 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 337982 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337986 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337991 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337993 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 337996 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338000 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338005 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 338008 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 338012 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 338015 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338020 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338025 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338030 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 338033 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 338037 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338042 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
     /* 338048 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 338051 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 338054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338061 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 338068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338078 */     // GIR_Coverage, 5738,
     /* 338078 */     GIR_EraseRootFromParent_Done,
     /* 338079 */   // Label 6976: @338079
     /* 338079 */   GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(338257), // Rule ID 5683 //
     /* 338084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 338096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338100 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 338104 */     // MIs[1] Operand 1
     /* 338104 */     // No operand predicates
     /* 338104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338106 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 338106 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 338109 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338113 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338118 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 338120 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 338123 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338127 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338132 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 338135 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 338139 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 338142 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338147 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338152 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338157 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 338160 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338164 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338171 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 338174 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338178 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338183 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 338186 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 338190 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 338193 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338198 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338203 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 338211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 338215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338220 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 338226 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 338229 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 338232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338239 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 338246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338256 */     // GIR_Coverage, 5683,
     /* 338256 */     GIR_EraseRootFromParent_Done,
     /* 338257 */   // Label 6977: @338257
     /* 338257 */   GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(338382), // Rule ID 5686 //
     /* 338262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 338270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 338274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 338278 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 338282 */     // MIs[1] Operand 1
     /* 338282 */     // No operand predicates
     /* 338282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338284 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 338284 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 338287 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338291 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338298 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 338301 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338305 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338310 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 338313 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 338317 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 338320 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338325 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338330 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 338338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 338342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338347 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 338353 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 338357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338364 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 338371 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338381 */     // GIR_Coverage, 5686,
     /* 338381 */     GIR_EraseRootFromParent_Done,
     /* 338382 */   // Label 6978: @338382
     /* 338382 */   GIM_Reject,
     /* 338383 */ // Label 6948: @338383
     /* 338383 */ GIM_Reject,
     /* 338384 */ // Label 6926: @338384
     /* 338384 */ GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(341212),
     /* 338389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 338392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 338395 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 338398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338402 */   GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(338511), // Rule ID 4284 //
     /* 338407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338411 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338417 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338427 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338430 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338434 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 338451 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 338458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338478 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338505 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338510 */     // GIR_Coverage, 4284,
     /* 338510 */     GIR_EraseRootFromParent_Done,
     /* 338511 */   // Label 6980: @338511
     /* 338511 */   GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(338620), // Rule ID 4285 //
     /* 338516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338520 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338526 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338536 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338539 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338543 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338553 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 338560 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 338567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338587 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338609 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338614 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338619 */     // GIR_Coverage, 4285,
     /* 338619 */     GIR_EraseRootFromParent_Done,
     /* 338620 */   // Label 6981: @338620
     /* 338620 */   GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(338729), // Rule ID 4392 //
     /* 338625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338629 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338635 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338645 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338648 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338652 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338662 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 338669 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 338676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338696 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338702 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338709 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338718 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338723 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338728 */     // GIR_Coverage, 4392,
     /* 338728 */     GIR_EraseRootFromParent_Done,
     /* 338729 */   // Label 6982: @338729
     /* 338729 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(338838), // Rule ID 4393 //
     /* 338734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338738 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 338744 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 338746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338754 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338757 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338761 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338765 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338769 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338771 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 338778 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338778 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338781 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 338785 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338805 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338827 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338837 */     // GIR_Coverage, 4393,
     /* 338837 */     GIR_EraseRootFromParent_Done,
     /* 338838 */   // Label 6983: @338838
     /* 338838 */   GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(338943), // Rule ID 4290 //
     /* 338843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338859 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338862 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338866 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338870 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338874 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338876 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 338883 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338883 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338886 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 338890 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338895 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338900 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338905 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338910 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 338916 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 338921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 338923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 338926 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 338932 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338937 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338942 */     // GIR_Coverage, 4290,
     /* 338942 */     GIR_EraseRootFromParent_Done,
     /* 338943 */   // Label 6984: @338943
     /* 338943 */   GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(339048), // Rule ID 4292 //
     /* 338948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 338956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 338960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338964 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338967 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 338971 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 338975 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 338979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 338981 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 338988 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 338988 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338991 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 338995 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339000 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339015 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339037 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339042 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339047 */     // GIR_Coverage, 4292,
     /* 339047 */     GIR_EraseRootFromParent_Done,
     /* 339048 */   // Label 6985: @339048
     /* 339048 */   GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(339153), // Rule ID 4398 //
     /* 339053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339061 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339065 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339069 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339072 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339076 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339084 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339086 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 339093 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 339093 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339096 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 339100 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339120 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339152 */     // GIR_Coverage, 4398,
     /* 339152 */     GIR_EraseRootFromParent_Done,
     /* 339153 */   // Label 6986: @339153
     /* 339153 */   GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(339258), // Rule ID 4400 //
     /* 339158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339174 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339177 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339181 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339185 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339191 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 339198 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 339198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 339205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339215 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339225 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339241 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339247 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339252 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339257 */     // GIR_Coverage, 4400,
     /* 339257 */     GIR_EraseRootFromParent_Done,
     /* 339258 */   // Label 6987: @339258
     /* 339258 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(339362), // Rule ID 4282 //
     /* 339263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339267 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 339273 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 339275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339283 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339286 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339290 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339300 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 339307 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 339307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 339314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339319 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339329 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339335 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339351 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339356 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339361 */     // GIR_Coverage, 4282,
     /* 339361 */     GIR_EraseRootFromParent_Done,
     /* 339362 */   // Label 6988: @339362
     /* 339362 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(339466), // Rule ID 4283 //
     /* 339367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339371 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 339377 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 339379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339387 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339390 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339394 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339398 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339402 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339404 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 339411 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 339411 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339414 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 339418 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339428 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339433 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339455 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339465 */     // GIR_Coverage, 4283,
     /* 339465 */     GIR_EraseRootFromParent_Done,
     /* 339466 */   // Label 6989: @339466
     /* 339466 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(339570), // Rule ID 4390 //
     /* 339471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339475 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 339481 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 339483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339491 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339494 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339498 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339502 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339508 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 339515 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 339515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 339522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339537 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339564 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339569 */     // GIR_Coverage, 4390,
     /* 339569 */     GIR_EraseRootFromParent_Done,
     /* 339570 */   // Label 6990: @339570
     /* 339570 */   GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(339674), // Rule ID 4391 //
     /* 339575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339579 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 339585 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 339587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339595 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339598 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339602 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339610 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339612 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 339619 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 339619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 339626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339636 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339641 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339647 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339657 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339663 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339668 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339673 */     // GIR_Coverage, 4391,
     /* 339673 */     GIR_EraseRootFromParent_Done,
     /* 339674 */   // Label 6991: @339674
     /* 339674 */   GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(339774), // Rule ID 4286 //
     /* 339679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339695 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339698 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339702 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339706 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339710 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339712 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 339719 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 339719 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339722 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 339726 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339731 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339736 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339741 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339747 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339763 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339768 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339773 */     // GIR_Coverage, 4286,
     /* 339773 */     GIR_EraseRootFromParent_Done,
     /* 339774 */   // Label 6992: @339774
     /* 339774 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(339874), // Rule ID 4288 //
     /* 339779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339795 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339798 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339802 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339810 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339812 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 339819 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 339819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 339826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339841 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339863 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339873 */     // GIR_Coverage, 4288,
     /* 339873 */     GIR_EraseRootFromParent_Done,
     /* 339874 */   // Label 6993: @339874
     /* 339874 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(339974), // Rule ID 4394 //
     /* 339879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339895 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339898 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 339902 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 339906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 339910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 339912 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 339919 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 339919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 339926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339941 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 339947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 339949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 339952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 339954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 339957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 339963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 339968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339973 */     // GIR_Coverage, 4394,
     /* 339973 */     GIR_EraseRootFromParent_Done,
     /* 339974 */   // Label 6994: @339974
     /* 339974 */   GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(340074), // Rule ID 4396 //
     /* 339979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 339987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 339991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339995 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339998 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 340002 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 340006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340012 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 340019 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 340019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 340026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340041 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 340057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 340063 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340073 */     // GIR_Coverage, 4396,
     /* 340073 */     GIR_EraseRootFromParent_Done,
     /* 340074 */   // Label 6995: @340074
     /* 340074 */   GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(340152), // Rule ID 1941 //
     /* 340079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 340094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 340098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 340102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 340111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340115 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340119 */     // MIs[2] Operand 1
     /* 340119 */     // No operand predicates
     /* 340119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 340123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340127 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340131 */     // MIs[3] Operand 1
     /* 340131 */     // No operand predicates
     /* 340131 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340133 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 340133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 340136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340138 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 340143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 340150 */     GIR_RootConstrainSelectedInstOperands,
     /* 340151 */     // GIR_Coverage, 1941,
     /* 340151 */     GIR_EraseRootFromParent_Done,
     /* 340152 */   // Label 6996: @340152
     /* 340152 */   GIM_Try, /*On fail goto*//*Label 6997*/ GIMT_Encode4(340243), // Rule ID 7373 //
     /* 340157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 340160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 340172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 340176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 340180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340184 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 340187 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 340194 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 340197 */     // MIs[2] Rn
     /* 340197 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 340201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 340210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340214 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340218 */     // MIs[3] Operand 1
     /* 340218 */     // No operand predicates
     /* 340218 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340220 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15802>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 340220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 340223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340225 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 340230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 340234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 340241 */     GIR_RootConstrainSelectedInstOperands,
     /* 340242 */     // GIR_Coverage, 7373,
     /* 340242 */     GIR_EraseRootFromParent_Done,
     /* 340243 */   // Label 6997: @340243
     /* 340243 */   GIM_Try, /*On fail goto*//*Label 6998*/ GIMT_Encode4(340310), // Rule ID 5709 //
     /* 340248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 340260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 340264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 340268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 340277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340281 */     // MIs[2] Operand 1
     /* 340281 */     // No operand predicates
     /* 340281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 340285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340289 */     // MIs[3] Operand 1
     /* 340289 */     // No operand predicates
     /* 340289 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340291 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 340291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 340294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340296 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 340298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 340301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 340308 */     GIR_RootConstrainSelectedInstOperands,
     /* 340309 */     // GIR_Coverage, 5709,
     /* 340309 */     GIR_EraseRootFromParent_Done,
     /* 340310 */   // Label 6998: @340310
     /* 340310 */   GIM_Try, /*On fail goto*//*Label 6999*/ GIMT_Encode4(340408), // Rule ID 5710 //
     /* 340315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 340327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 340331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 340335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 340344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340348 */     // MIs[2] Operand 1
     /* 340348 */     // No operand predicates
     /* 340348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 340352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340356 */     // MIs[3] Operand 1
     /* 340356 */     // No operand predicates
     /* 340356 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340358 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 340358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340370 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 340373 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340377 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 340380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340385 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 340393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340395 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 340397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 340400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 340406 */     GIR_RootConstrainSelectedInstOperands,
     /* 340407 */     // GIR_Coverage, 5710,
     /* 340407 */     GIR_EraseRootFromParent_Done,
     /* 340408 */   // Label 6999: @340408
     /* 340408 */   GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(340475), // Rule ID 5733 //
     /* 340413 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 340425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 340429 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 340433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 340442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340446 */     // MIs[2] Operand 1
     /* 340446 */     // No operand predicates
     /* 340446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 340450 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340454 */     // MIs[3] Operand 1
     /* 340454 */     // No operand predicates
     /* 340454 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340456 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 340456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 340459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340461 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 340463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 340466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 340473 */     GIR_RootConstrainSelectedInstOperands,
     /* 340474 */     // GIR_Coverage, 5733,
     /* 340474 */     GIR_EraseRootFromParent_Done,
     /* 340475 */   // Label 7000: @340475
     /* 340475 */   GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(340573), // Rule ID 5734 //
     /* 340480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 340492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 340496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 340500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 340509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340513 */     // MIs[2] Operand 1
     /* 340513 */     // No operand predicates
     /* 340513 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 340517 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340521 */     // MIs[3] Operand 1
     /* 340521 */     // No operand predicates
     /* 340521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 340523 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 340523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 340526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 340530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340535 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 340538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340542 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 340545 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 340558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340560 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 340562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 340565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 340571 */     GIR_RootConstrainSelectedInstOperands,
     /* 340572 */     // GIR_Coverage, 5734,
     /* 340572 */     GIR_EraseRootFromParent_Done,
     /* 340573 */   // Label 7001: @340573
     /* 340573 */   GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(340639), // Rule ID 5664 //
     /* 340578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340596 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), FPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
     /* 340596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 340599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 340620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 340623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340633 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340638 */     // GIR_Coverage, 5664,
     /* 340638 */     GIR_EraseRootFromParent_Done,
     /* 340639 */   // Label 7002: @340639
     /* 340639 */   GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(340705), // Rule ID 5674 //
     /* 340644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 340652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 340660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340662 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
     /* 340662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 340665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340674 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 340686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 340689 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340704 */     // GIR_Coverage, 5674,
     /* 340704 */     GIR_EraseRootFromParent_Done,
     /* 340705 */   // Label 7003: @340705
     /* 340705 */   GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(340783), // Rule ID 7372 //
     /* 340710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 340713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340725 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 340728 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 340735 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 340738 */     // MIs[1] Rn
     /* 340738 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340742 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340755 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340759 */     // MIs[2] Operand 1
     /* 340759 */     // No operand predicates
     /* 340759 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340761 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_64>><<P:Predicate_anonymous_15802>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 340761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 340764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340768 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 340771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340781 */     GIR_RootConstrainSelectedInstOperands,
     /* 340782 */     // GIR_Coverage, 7372,
     /* 340782 */     GIR_EraseRootFromParent_Done,
     /* 340783 */   // Label 7004: @340783
     /* 340783 */   GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(340852), // Rule ID 6408 //
     /* 340788 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340800 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340803 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340807 */     // MIs[1] Rn
     /* 340807 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340824 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340828 */     // MIs[2] Operand 1
     /* 340828 */     // No operand predicates
     /* 340828 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340830 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 340830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 340833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340835 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340837 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 340840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340844 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340850 */     GIR_RootConstrainSelectedInstOperands,
     /* 340851 */     // GIR_Coverage, 6408,
     /* 340851 */     GIR_EraseRootFromParent_Done,
     /* 340852 */   // Label 7005: @340852
     /* 340852 */   GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(340921), // Rule ID 6409 //
     /* 340857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 340869 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340872 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 340876 */     // MIs[1] Rn
     /* 340876 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 340880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 340885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340893 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340897 */     // MIs[2] Operand 1
     /* 340897 */     // No operand predicates
     /* 340897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340899 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 340899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 340902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 340906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 340909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 340919 */     GIR_RootConstrainSelectedInstOperands,
     /* 340920 */     // GIR_Coverage, 6409,
     /* 340920 */     GIR_EraseRootFromParent_Done,
     /* 340921 */   // Label 7006: @340921
     /* 340921 */   GIM_Try, /*On fail goto*//*Label 7007*/ GIMT_Encode4(340970), // Rule ID 5681 //
     /* 340926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 340934 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 340938 */     // MIs[1] Operand 1
     /* 340938 */     // No operand predicates
     /* 340938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 340946 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 340950 */     // MIs[2] Operand 1
     /* 340950 */     // No operand predicates
     /* 340950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 340952 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
     /* 340952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 340955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 340957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 340959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 340962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 340968 */     GIR_RootConstrainSelectedInstOperands,
     /* 340969 */     // GIR_Coverage, 5681,
     /* 340969 */     GIR_EraseRootFromParent_Done,
     /* 340970 */   // Label 7007: @340970
     /* 340970 */   GIM_Try, /*On fail goto*//*Label 7008*/ GIMT_Encode4(341071), // Rule ID 5739 //
     /* 340975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 340979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 340983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 340987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 340996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341000 */     // MIs[2] Operand 1
     /* 341000 */     // No operand predicates
     /* 341000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341002 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 341002 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 341005 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 341009 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 341016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 341019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 341023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341028 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 341031 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 341035 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 341038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 341056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341058 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 341060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 341063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341069 */     GIR_RootConstrainSelectedInstOperands,
     /* 341070 */     // GIR_Coverage, 5739,
     /* 341070 */     GIR_EraseRootFromParent_Done,
     /* 341071 */   // Label 7008: @341071
     /* 341071 */   GIM_Try, /*On fail goto*//*Label 7009*/ GIMT_Encode4(341115), // Rule ID 1937 //
     /* 341076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 341087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 341091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341095 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 341099 */     // MIs[1] Operand 1
     /* 341099 */     // No operand predicates
     /* 341099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341101 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
     /* 341101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 341104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341106 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 341108 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 341111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 341113 */     GIR_RootConstrainSelectedInstOperands,
     /* 341114 */     // GIR_Coverage, 1937,
     /* 341114 */     GIR_EraseRootFromParent_Done,
     /* 341115 */   // Label 7009: @341115
     /* 341115 */   GIM_Try, /*On fail goto*//*Label 7010*/ GIMT_Encode4(341211), // Rule ID 5685 //
     /* 341120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 341132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 341136 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 341140 */     // MIs[1] Operand 1
     /* 341140 */     // No operand predicates
     /* 341140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341142 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 341142 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 341145 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 341149 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 341156 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 341159 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 341163 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341168 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 341171 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 341175 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 341178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341183 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341188 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 341196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341198 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 341200 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 341203 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341209 */     GIR_RootConstrainSelectedInstOperands,
     /* 341210 */     // GIR_Coverage, 5685,
     /* 341210 */     GIR_EraseRootFromParent_Done,
     /* 341211 */   // Label 7010: @341211
     /* 341211 */   GIM_Reject,
     /* 341212 */ // Label 6979: @341212
     /* 341212 */ GIM_Reject,
     /* 341213 */ // Label 6927: @341213
     /* 341213 */ GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(344852),
     /* 341218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341221 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(341347), // Rule ID 4224 //
     /* 341226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341240 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341246 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341256 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341259 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341263 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341270 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341274 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341280 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 341287 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341287 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341290 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 341294 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341299 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341314 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341341 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341346 */     // GIR_Coverage, 4224,
     /* 341346 */     GIR_EraseRootFromParent_Done,
     /* 341347 */   // Label 7012: @341347
     /* 341347 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(341473), // Rule ID 4225 //
     /* 341352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341366 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341372 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341382 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341385 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341389 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341396 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341406 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 341413 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 341420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341440 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341462 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341467 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341472 */     // GIR_Coverage, 4225,
     /* 341472 */     GIR_EraseRootFromParent_Done,
     /* 341473 */   // Label 7013: @341473
     /* 341473 */   GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(341592), // Rule ID 4332 //
     /* 341478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341488 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341492 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341498 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341500 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341504 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341508 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341511 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341515 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341523 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341525 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 341532 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341532 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341535 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 341539 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341559 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341565 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341591 */     // GIR_Coverage, 4332,
     /* 341591 */     GIR_EraseRootFromParent_Done,
     /* 341592 */   // Label 7014: @341592
     /* 341592 */   GIM_Try, /*On fail goto*//*Label 7015*/ GIMT_Encode4(341711), // Rule ID 4333 //
     /* 341597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341611 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 341617 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 341619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341627 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341630 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341634 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341638 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341644 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 341651 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 341658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341663 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341668 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341678 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341710 */     // GIR_Coverage, 4333,
     /* 341710 */     GIR_EraseRootFromParent_Done,
     /* 341711 */   // Label 7015: @341711
     /* 341711 */   GIM_Try, /*On fail goto*//*Label 7016*/ GIMT_Encode4(341833), // Rule ID 4230 //
     /* 341716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341742 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341745 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341749 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341756 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341760 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341766 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 341773 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341773 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341776 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 341780 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341800 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341806 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341816 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341822 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341827 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341832 */     // GIR_Coverage, 4230,
     /* 341832 */     GIR_EraseRootFromParent_Done,
     /* 341833 */   // Label 7016: @341833
     /* 341833 */   GIM_Try, /*On fail goto*//*Label 7017*/ GIMT_Encode4(341955), // Rule ID 4232 //
     /* 341838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 341841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341864 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341867 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341871 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 341878 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 341886 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 341888 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 341895 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 341895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 341898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 341902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341907 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 341912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 341917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 341922 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 341928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 341930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 341933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341935 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 341938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 341941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 341944 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341949 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341954 */     // GIR_Coverage, 4232,
     /* 341954 */     GIR_EraseRootFromParent_Done,
     /* 341955 */   // Label 7017: @341955
     /* 341955 */   GIM_Try, /*On fail goto*//*Label 7018*/ GIMT_Encode4(342070), // Rule ID 4338 //
     /* 341960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 341963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 341966 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 341978 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 341982 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 341986 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 341989 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 341993 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 341997 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342003 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 342010 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 342010 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342013 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 342017 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 342032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 342037 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342059 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342064 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342069 */     // GIR_Coverage, 4338,
     /* 342069 */     GIR_EraseRootFromParent_Done,
     /* 342070 */   // Label 7018: @342070
     /* 342070 */   GIM_Try, /*On fail goto*//*Label 7019*/ GIMT_Encode4(342185), // Rule ID 4340 //
     /* 342075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342078 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342101 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342104 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342108 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342112 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342118 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 342125 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 342125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 342132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342137 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 342147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 342152 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342158 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342168 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342174 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342184 */     // GIR_Coverage, 4340,
     /* 342184 */     GIR_EraseRootFromParent_Done,
     /* 342185 */   // Label 7019: @342185
     /* 342185 */   GIM_Try, /*On fail goto*//*Label 7020*/ GIMT_Encode4(342306), // Rule ID 4222 //
     /* 342190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342204 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342210 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342220 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342223 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342227 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 342234 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342238 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342244 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 342251 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 342251 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342254 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 342258 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342273 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342305 */     // GIR_Coverage, 4222,
     /* 342305 */     GIR_EraseRootFromParent_Done,
     /* 342306 */   // Label 7020: @342306
     /* 342306 */   GIM_Try, /*On fail goto*//*Label 7021*/ GIMT_Encode4(342427), // Rule ID 4223 //
     /* 342311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342325 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342331 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342341 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342344 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342348 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 342355 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342365 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 342372 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 342372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 342379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342394 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342410 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342426 */     // GIR_Coverage, 4223,
     /* 342426 */     GIR_EraseRootFromParent_Done,
     /* 342427 */   // Label 7021: @342427
     /* 342427 */   GIM_Try, /*On fail goto*//*Label 7022*/ GIMT_Encode4(342541), // Rule ID 4330 //
     /* 342432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342446 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342452 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342462 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342465 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342469 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342473 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342477 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342479 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 342486 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 342486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 342493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342508 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342530 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342535 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342540 */     // GIR_Coverage, 4330,
     /* 342540 */     GIR_EraseRootFromParent_Done,
     /* 342541 */   // Label 7022: @342541
     /* 342541 */   GIM_Try, /*On fail goto*//*Label 7023*/ GIMT_Encode4(342655), // Rule ID 4331 //
     /* 342546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342560 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 342566 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 342568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342576 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342579 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342583 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342587 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342591 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342593 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 342600 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 342600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 342607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342612 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342617 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342622 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342649 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342654 */     // GIR_Coverage, 4331,
     /* 342654 */     GIR_EraseRootFromParent_Done,
     /* 342655 */   // Label 7023: @342655
     /* 342655 */   GIM_Try, /*On fail goto*//*Label 7024*/ GIMT_Encode4(342772), // Rule ID 4226 //
     /* 342660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342663 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342686 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342689 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342693 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 342700 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342710 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 342717 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 342717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 342724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342739 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342761 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342771 */     // GIR_Coverage, 4226,
     /* 342771 */     GIR_EraseRootFromParent_Done,
     /* 342772 */   // Label 7024: @342772
     /* 342772 */   GIM_Try, /*On fail goto*//*Label 7025*/ GIMT_Encode4(342889), // Rule ID 4228 //
     /* 342777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342803 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342806 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342810 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 342817 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342821 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342827 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 342834 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 342834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 342841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342856 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342888 */     // GIR_Coverage, 4228,
     /* 342888 */     GIR_EraseRootFromParent_Done,
     /* 342889 */   // Label 7025: @342889
     /* 342889 */   GIM_Try, /*On fail goto*//*Label 7026*/ GIMT_Encode4(342999), // Rule ID 4334 //
     /* 342894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 342900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 342912 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 342916 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 342920 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 342923 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 342927 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 342931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 342935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 342937 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 342944 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 342944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 342947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 342951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 342956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 342961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 342966 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 342972 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 342974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 342977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 342982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 342985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 342988 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342993 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342998 */     // GIR_Coverage, 4334,
     /* 342998 */     GIR_EraseRootFromParent_Done,
     /* 342999 */   // Label 7026: @342999
     /* 342999 */   GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(343109), // Rule ID 4336 //
     /* 343004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343030 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343033 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343037 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 343041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343047 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 343054 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 343054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 343057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 343061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343066 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 343071 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 343076 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343082 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 343098 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343103 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343108 */     // GIR_Coverage, 4336,
     /* 343108 */     GIR_EraseRootFromParent_Done,
     /* 343109 */   // Label 7027: @343109
     /* 343109 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(343239), // Rule ID 6421 //
     /* 343114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343135 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 343139 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 343143 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 343146 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 343150 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 343157 */     // MIs[2] Rn
     /* 343157 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 343161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 343166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343170 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 343172 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 343172 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 343175 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343179 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343184 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 343186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 343193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343198 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343201 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 343204 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 343208 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 343214 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343221 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343233 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343238 */     // GIR_Coverage, 6421,
     /* 343238 */     GIR_EraseRootFromParent_Done,
     /* 343239 */   // Label 7028: @343239
     /* 343239 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(343379), // Rule ID 5699 //
     /* 343244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 343266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343287 */     // MIs[2] Operand 1
     /* 343287 */     // No operand predicates
     /* 343287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343291 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343295 */     // MIs[3] Operand 1
     /* 343295 */     // No operand predicates
     /* 343295 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343297 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 343297 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 343300 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343304 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343309 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 343312 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 343316 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 343319 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343324 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 343336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343341 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343344 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 343347 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343351 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 343354 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343361 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343368 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343373 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343378 */     // GIR_Coverage, 5699,
     /* 343378 */     GIR_EraseRootFromParent_Done,
     /* 343379 */   // Label 7029: @343379
     /* 343379 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(343550), // Rule ID 5700 //
     /* 343384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 343406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343427 */     // MIs[2] Operand 1
     /* 343427 */     // No operand predicates
     /* 343427 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343431 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343435 */     // MIs[3] Operand 1
     /* 343435 */     // No operand predicates
     /* 343435 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343437 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 343437 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 343440 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343444 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343449 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 343452 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343456 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 343459 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343464 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343469 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 343472 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343476 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343481 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 343484 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 343488 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 343491 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343496 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 343508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343513 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343516 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 343519 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 343522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 343525 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343532 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343539 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343544 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343549 */     // GIR_Coverage, 5700,
     /* 343549 */     GIR_EraseRootFromParent_Done,
     /* 343550 */   // Label 7030: @343550
     /* 343550 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(343690), // Rule ID 5723 //
     /* 343555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 343577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343585 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343598 */     // MIs[2] Operand 1
     /* 343598 */     // No operand predicates
     /* 343598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343606 */     // MIs[3] Operand 1
     /* 343606 */     // No operand predicates
     /* 343606 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343608 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 343608 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 343611 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343615 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343620 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 343623 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 343627 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 343630 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343635 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 343647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343652 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343655 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 343658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 343665 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343672 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343679 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343684 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343689 */     // GIR_Coverage, 5723,
     /* 343689 */     GIR_EraseRootFromParent_Done,
     /* 343690 */   // Label 7031: @343690
     /* 343690 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(343861), // Rule ID 5724 //
     /* 343695 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343698 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343709 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 343713 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 343717 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343721 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 343725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 343734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343738 */     // MIs[2] Operand 1
     /* 343738 */     // No operand predicates
     /* 343738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 343742 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 343746 */     // MIs[3] Operand 1
     /* 343746 */     // No operand predicates
     /* 343746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 343748 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 343748 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 343751 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343755 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343760 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 343763 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 343767 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 343770 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343775 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343780 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 343783 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343787 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343792 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 343795 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 343799 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 343802 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343807 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 343815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 343819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343824 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 343827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 343830 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 343833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 343836 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343843 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 343850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343855 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343860 */     // GIR_Coverage, 5724,
     /* 343860 */     GIR_EraseRootFromParent_Done,
     /* 343861 */   // Label 7032: @343861
     /* 343861 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(343940), // Rule ID 5654 //
     /* 343866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 343888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343894 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 343894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 343897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 343901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343906 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 343910 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 343918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 343923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 343929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343934 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343939 */     // GIR_Coverage, 5654,
     /* 343939 */     GIR_EraseRootFromParent_Done,
     /* 343940 */   // Label 7033: @343940
     /* 343940 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(344016), // Rule ID 5656 //
     /* 343945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 343951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 343959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 343963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 343971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 343973 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 343973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 343976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 343980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 343985 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 343987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 343990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 343992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 343995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 343997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 344000 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344005 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344015 */     // GIR_Coverage, 5656,
     /* 344015 */     GIR_EraseRootFromParent_Done,
     /* 344016 */   // Label 7034: @344016
     /* 344016 */   GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(344092), // Rule ID 5666 //
     /* 344021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 344039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344043 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344049 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 344049 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 344052 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 344056 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 344066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 344073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 344076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344081 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344086 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344091 */     // GIR_Coverage, 5666,
     /* 344091 */     GIR_EraseRootFromParent_Done,
     /* 344092 */   // Label 7035: @344092
     /* 344092 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(344237), // Rule ID 5678 //
     /* 344097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 344119 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 344123 */     // MIs[1] Operand 1
     /* 344123 */     // No operand predicates
     /* 344123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 344127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344131 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 344135 */     // MIs[2] Operand 1
     /* 344135 */     // No operand predicates
     /* 344135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344137 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 344137 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 344140 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 344144 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344149 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 344151 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 344154 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 344158 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344163 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 344166 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 344170 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 344173 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344178 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344183 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 344191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 344195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344200 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 344206 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 344212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344219 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 344226 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344231 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344236 */     // GIR_Coverage, 5678,
     /* 344236 */     GIR_EraseRootFromParent_Done,
     /* 344237 */   // Label 7036: @344237
     /* 344237 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(344386), // Rule ID 6424 //
     /* 344242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344264 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344267 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 344271 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 344278 */     // MIs[1] Rn
     /* 344278 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 344282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 344287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 344291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344295 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 344299 */     // MIs[2] Operand 1
     /* 344299 */     // No operand predicates
     /* 344299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344301 */     // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 344301 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 344304 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344308 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344313 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 344316 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 344320 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 344323 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344328 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 344336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 344340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344345 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344348 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 344351 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344355 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344368 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 344375 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344385 */     // GIR_Coverage, 6424,
     /* 344385 */     GIR_EraseRootFromParent_Done,
     /* 344386 */   // Label 7037: @344386
     /* 344386 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(344528), // Rule ID 6427 //
     /* 344391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 344409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344413 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344416 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 344420 */     // MIs[1] Rn
     /* 344420 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 344424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 344429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 344433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344437 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 344441 */     // MIs[2] Operand 1
     /* 344441 */     // No operand predicates
     /* 344441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344443 */     // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 344443 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 344446 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344450 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344455 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 344458 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 344462 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 344465 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344470 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 344478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 344482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344487 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 344493 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344497 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344510 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 344517 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344527 */     // GIR_Coverage, 6427,
     /* 344527 */     GIR_EraseRootFromParent_Done,
     /* 344528 */   // Label 7038: @344528
     /* 344528 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(344716), // Rule ID 5676 //
     /* 344533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 344555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344559 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 344563 */     // MIs[1] Operand 1
     /* 344563 */     // No operand predicates
     /* 344563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344565 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 344565 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
     /* 344568 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 344572 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 344579 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
     /* 344582 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 344586 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344591 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 344594 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 344598 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 344601 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344606 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344611 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344616 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 344619 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 344623 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344628 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 344630 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 344633 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 344637 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344642 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 344645 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 344649 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 344652 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344657 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344662 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 344670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 344674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344679 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 344685 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 344688 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 344691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344698 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 344705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344715 */     // GIR_Coverage, 5676,
     /* 344715 */     GIR_EraseRootFromParent_Done,
     /* 344716 */   // Label 7039: @344716
     /* 344716 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(344851), // Rule ID 5687 //
     /* 344721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 344739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 344743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 344747 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 344751 */     // MIs[1] Operand 1
     /* 344751 */     // No operand predicates
     /* 344751 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 344753 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 344753 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 344756 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 344760 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344765 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 344767 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 344770 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 344774 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344779 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 344782 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 344786 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 344789 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344794 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344799 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 344807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 344811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344816 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 344819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 344822 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 344826 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 344831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344833 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 344840 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344850 */     // GIR_Coverage, 5687,
     /* 344850 */     GIR_EraseRootFromParent_Done,
     /* 344851 */   // Label 7040: @344851
     /* 344851 */   GIM_Reject,
     /* 344852 */ // Label 7011: @344852
     /* 344852 */ GIM_Reject,
     /* 344853 */ // Label 6928: @344853
     /* 344853 */ GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(347516),
     /* 344858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344861 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344864 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 344867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344871 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(344980), // Rule ID 4248 //
     /* 344876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344880 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344886 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 344896 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 344899 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 344903 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 344907 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 344911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344913 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 344920 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 344920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 344923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 344927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 344932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 344937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 344942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 344947 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 344953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 344955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 344958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 344960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 344963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 344966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 344969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344974 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344979 */     // GIR_Coverage, 4248,
     /* 344979 */     GIR_EraseRootFromParent_Done,
     /* 344980 */   // Label 7042: @344980
     /* 344980 */   GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(345089), // Rule ID 4249 //
     /* 344985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344989 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 344995 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 344997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345005 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345008 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345012 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 345029 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 345036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345051 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345056 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345069 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345072 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345078 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345083 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345088 */     // GIR_Coverage, 4249,
     /* 345088 */     GIR_EraseRootFromParent_Done,
     /* 345089 */   // Label 7043: @345089
     /* 345089 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(345198), // Rule ID 4356 //
     /* 345094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345098 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345104 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345114 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345117 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345121 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345131 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 345138 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 345145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345165 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345171 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345187 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345192 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345197 */     // GIR_Coverage, 4356,
     /* 345197 */     GIR_EraseRootFromParent_Done,
     /* 345198 */   // Label 7044: @345198
     /* 345198 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(345307), // Rule ID 4357 //
     /* 345203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345207 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345213 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345223 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345226 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345230 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345234 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345238 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345240 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 345247 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 345254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345259 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345264 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345274 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345296 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345301 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345306 */     // GIR_Coverage, 4357,
     /* 345306 */     GIR_EraseRootFromParent_Done,
     /* 345307 */   // Label 7045: @345307
     /* 345307 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(345412), // Rule ID 4254 //
     /* 345312 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345316 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345328 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345331 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345335 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345345 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 345352 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 345359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345369 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345379 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345401 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345406 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345411 */     // GIR_Coverage, 4254,
     /* 345411 */     GIR_EraseRootFromParent_Done,
     /* 345412 */   // Label 7046: @345412
     /* 345412 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(345517), // Rule ID 4256 //
     /* 345417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345433 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345436 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345440 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345450 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 345457 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 345464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345484 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345500 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345503 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345511 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345516 */     // GIR_Coverage, 4256,
     /* 345516 */     GIR_EraseRootFromParent_Done,
     /* 345517 */   // Label 7047: @345517
     /* 345517 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(345622), // Rule ID 4362 //
     /* 345522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345538 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345541 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345545 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345549 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345553 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345555 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 345562 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 345569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345589 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345621 */     // GIR_Coverage, 4362,
     /* 345621 */     GIR_EraseRootFromParent_Done,
     /* 345622 */   // Label 7048: @345622
     /* 345622 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(345727), // Rule ID 4364 //
     /* 345627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 345635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345643 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345646 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345650 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 345667 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 345667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 345674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 345689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 345694 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345710 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345726 */     // GIR_Coverage, 4364,
     /* 345726 */     GIR_EraseRootFromParent_Done,
     /* 345727 */   // Label 7049: @345727
     /* 345727 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(345831), // Rule ID 4246 //
     /* 345732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345736 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345742 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345744 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345748 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345752 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345755 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345759 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345763 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345769 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 345776 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 345776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 345783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345793 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345798 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345811 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345825 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345830 */     // GIR_Coverage, 4246,
     /* 345830 */     GIR_EraseRootFromParent_Done,
     /* 345831 */   // Label 7050: @345831
     /* 345831 */   GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(345935), // Rule ID 4247 //
     /* 345836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345840 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345846 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345856 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345859 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345863 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345867 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345871 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345873 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 345880 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 345880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 345887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 345897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 345902 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 345908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 345910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 345913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 345915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 345918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 345921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 345924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345934 */     // GIR_Coverage, 4247,
     /* 345934 */     GIR_EraseRootFromParent_Done,
     /* 345935 */   // Label 7051: @345935
     /* 345935 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(346039), // Rule ID 4354 //
     /* 345940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345944 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 345950 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 345952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 345960 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 345963 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 345967 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 345971 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 345975 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345977 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 345984 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 345984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 345987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 345991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 345996 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346001 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346006 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346038 */     // GIR_Coverage, 4354,
     /* 346038 */     GIR_EraseRootFromParent_Done,
     /* 346039 */   // Label 7052: @346039
     /* 346039 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(346143), // Rule ID 4355 //
     /* 346044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346048 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 346054 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 346056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346064 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346067 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346071 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346075 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346081 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 346088 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 346088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 346095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346105 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346110 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346116 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346132 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346137 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346142 */     // GIR_Coverage, 4355,
     /* 346142 */     GIR_EraseRootFromParent_Done,
     /* 346143 */   // Label 7053: @346143
     /* 346143 */   GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(346243), // Rule ID 4250 //
     /* 346148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346164 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346167 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346171 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346175 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 346188 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 346188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 346195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346210 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346232 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346242 */     // GIR_Coverage, 4250,
     /* 346242 */     GIR_EraseRootFromParent_Done,
     /* 346243 */   // Label 7054: @346243
     /* 346243 */   GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(346343), // Rule ID 4252 //
     /* 346248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346264 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346267 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346271 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346275 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346279 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346281 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 346288 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 346288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 346295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346310 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346337 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346342 */     // GIR_Coverage, 4252,
     /* 346342 */     GIR_EraseRootFromParent_Done,
     /* 346343 */   // Label 7055: @346343
     /* 346343 */   GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(346443), // Rule ID 4358 //
     /* 346348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346352 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346364 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346367 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346371 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346375 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346381 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 346388 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 346388 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346391 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 346395 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346410 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346416 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346432 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346442 */     // GIR_Coverage, 4358,
     /* 346442 */     GIR_EraseRootFromParent_Done,
     /* 346443 */   // Label 7056: @346443
     /* 346443 */   GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(346543), // Rule ID 4360 //
     /* 346448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 346460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 346464 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 346467 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 346471 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 346475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346479 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 346481 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 346488 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 346488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 346491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 346495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346500 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 346505 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 346510 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 346516 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 346526 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 346532 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346537 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346542 */     // GIR_Coverage, 4360,
     /* 346542 */     GIR_EraseRootFromParent_Done,
     /* 346543 */   // Label 7057: @346543
     /* 346543 */   GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(346621), // Rule ID 1940 //
     /* 346548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346584 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 346588 */     // MIs[2] Operand 1
     /* 346588 */     // No operand predicates
     /* 346588 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346592 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346596 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 346600 */     // MIs[3] Operand 1
     /* 346600 */     // No operand predicates
     /* 346600 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346602 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 346602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 346605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 346609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 346612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346616 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 346619 */     GIR_RootConstrainSelectedInstOperands,
     /* 346620 */     // GIR_Coverage, 1940,
     /* 346620 */     GIR_EraseRootFromParent_Done,
     /* 346621 */   // Label 7058: @346621
     /* 346621 */   GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(346688), // Rule ID 5703 //
     /* 346626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346659 */     // MIs[2] Operand 1
     /* 346659 */     // No operand predicates
     /* 346659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346667 */     // MIs[3] Operand 1
     /* 346667 */     // No operand predicates
     /* 346667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346669 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 346669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 346672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346674 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 346676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 346679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346683 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 346686 */     GIR_RootConstrainSelectedInstOperands,
     /* 346687 */     // GIR_Coverage, 5703,
     /* 346687 */     GIR_EraseRootFromParent_Done,
     /* 346688 */   // Label 7059: @346688
     /* 346688 */   GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(346786), // Rule ID 5704 //
     /* 346693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346726 */     // MIs[2] Operand 1
     /* 346726 */     // No operand predicates
     /* 346726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346734 */     // MIs[3] Operand 1
     /* 346734 */     // No operand predicates
     /* 346734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346736 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 346736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346748 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 346751 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346755 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 346758 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 346771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346773 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 346775 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 346778 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 346784 */     GIR_RootConstrainSelectedInstOperands,
     /* 346785 */     // GIR_Coverage, 5704,
     /* 346785 */     GIR_EraseRootFromParent_Done,
     /* 346786 */   // Label 7060: @346786
     /* 346786 */   GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(346853), // Rule ID 5727 //
     /* 346791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346807 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346811 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346824 */     // MIs[2] Operand 1
     /* 346824 */     // No operand predicates
     /* 346824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346828 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346832 */     // MIs[3] Operand 1
     /* 346832 */     // No operand predicates
     /* 346832 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346834 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 346834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 346837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346839 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 346841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 346844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 346851 */     GIR_RootConstrainSelectedInstOperands,
     /* 346852 */     // GIR_Coverage, 5727,
     /* 346852 */     GIR_EraseRootFromParent_Done,
     /* 346853 */   // Label 7061: @346853
     /* 346853 */   GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(346951), // Rule ID 5728 //
     /* 346858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 346870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 346878 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 346887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346891 */     // MIs[2] Operand 1
     /* 346891 */     // No operand predicates
     /* 346891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 346895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346899 */     // MIs[3] Operand 1
     /* 346899 */     // No operand predicates
     /* 346899 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 346901 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 346901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 346904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 346908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346913 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 346916 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 346920 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 346923 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 346936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346938 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 346940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 346943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346946 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 346949 */     GIR_RootConstrainSelectedInstOperands,
     /* 346950 */     // GIR_Coverage, 5728,
     /* 346950 */     GIR_EraseRootFromParent_Done,
     /* 346951 */   // Label 7062: @346951
     /* 346951 */   GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(347017), // Rule ID 5662 //
     /* 346956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 346960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 346964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 346968 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 346972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346974 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 346974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 346977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 346981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 346986 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 346988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 346991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 346993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 346996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 346998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 347001 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347016 */     // GIR_Coverage, 5662,
     /* 347016 */     GIR_EraseRootFromParent_Done,
     /* 347017 */   // Label 7063: @347017
     /* 347017 */   GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(347083), // Rule ID 5670 //
     /* 347022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347034 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347040 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 347040 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 347043 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 347047 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 347057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 347064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 347067 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347072 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347077 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347082 */     // GIR_Coverage, 5670,
     /* 347082 */     GIR_EraseRootFromParent_Done,
     /* 347083 */   // Label 7064: @347083
     /* 347083 */   GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(347136), // Rule ID 5679 //
     /* 347088 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 347100 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 347104 */     // MIs[1] Operand 1
     /* 347104 */     // No operand predicates
     /* 347104 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 347108 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347112 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 347116 */     // MIs[2] Operand 1
     /* 347116 */     // No operand predicates
     /* 347116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347118 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
     /* 347118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 347121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 347125 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 347128 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 347134 */     GIR_RootConstrainSelectedInstOperands,
     /* 347135 */     // GIR_Coverage, 5679,
     /* 347135 */     GIR_EraseRootFromParent_Done,
     /* 347136 */   // Label 7065: @347136
     /* 347136 */   GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(347205), // Rule ID 6406 //
     /* 347141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347153 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347156 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 347160 */     // MIs[1] Rn
     /* 347160 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 347164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 347169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 347173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347177 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 347181 */     // MIs[2] Operand 1
     /* 347181 */     // No operand predicates
     /* 347181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347183 */     // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 347183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 347186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 347190 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 347193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 347197 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347203 */     GIR_RootConstrainSelectedInstOperands,
     /* 347204 */     // GIR_Coverage, 6406,
     /* 347204 */     GIR_EraseRootFromParent_Done,
     /* 347205 */   // Label 7066: @347205
     /* 347205 */   GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(347274), // Rule ID 6407 //
     /* 347210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347222 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347225 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 347229 */     // MIs[1] Rn
     /* 347229 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 347233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 347238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 347242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347246 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 347250 */     // MIs[2] Operand 1
     /* 347250 */     // No operand predicates
     /* 347250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347252 */     // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 347252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 347255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 347259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 347262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 347266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347272 */     GIR_RootConstrainSelectedInstOperands,
     /* 347273 */     // GIR_Coverage, 6407,
     /* 347273 */     GIR_EraseRootFromParent_Done,
     /* 347274 */   // Label 7067: @347274
     /* 347274 */   GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(347375), // Rule ID 5737 //
     /* 347279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 347287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 347291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 347300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347304 */     // MIs[2] Operand 1
     /* 347304 */     // No operand predicates
     /* 347304 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347306 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 347306 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 347309 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 347313 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347318 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 347320 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 347323 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 347327 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347332 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347335 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 347339 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 347342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347347 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347352 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 347360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347362 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 347364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 347367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347373 */     GIR_RootConstrainSelectedInstOperands,
     /* 347374 */     // GIR_Coverage, 5737,
     /* 347374 */     GIR_EraseRootFromParent_Done,
     /* 347375 */   // Label 7068: @347375
     /* 347375 */   GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(347419), // Rule ID 1936 //
     /* 347380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347383 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 347395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 347403 */     // MIs[1] Operand 1
     /* 347403 */     // No operand predicates
     /* 347403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347405 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 347405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 347408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 347412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 347415 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 347417 */     GIR_RootConstrainSelectedInstOperands,
     /* 347418 */     // GIR_Coverage, 1936,
     /* 347418 */     GIR_EraseRootFromParent_Done,
     /* 347419 */   // Label 7069: @347419
     /* 347419 */   GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(347515), // Rule ID 5684 //
     /* 347424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 347436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347440 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 347444 */     // MIs[1] Operand 1
     /* 347444 */     // No operand predicates
     /* 347444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347446 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 347446 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 347449 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 347453 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 347460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 347463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 347467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347472 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 347475 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 347479 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 347482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 347497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 347500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347502 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 347504 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 347507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347513 */     GIR_RootConstrainSelectedInstOperands,
     /* 347514 */     // GIR_Coverage, 5684,
     /* 347514 */     GIR_EraseRootFromParent_Done,
     /* 347515 */   // Label 7070: @347515
     /* 347515 */   GIM_Reject,
     /* 347516 */ // Label 7041: @347516
     /* 347516 */ GIM_Reject,
     /* 347517 */ // Label 6929: @347517
     /* 347517 */ GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(349360),
     /* 347522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347525 */   GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(347651), // Rule ID 4188 //
     /* 347530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347544 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347550 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347560 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347563 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347567 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347574 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347584 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 347591 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 347591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 347598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347618 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347650 */     // GIR_Coverage, 4188,
     /* 347650 */     GIR_EraseRootFromParent_Done,
     /* 347651 */   // Label 7072: @347651
     /* 347651 */   GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(347777), // Rule ID 4189 //
     /* 347656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347670 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 347676 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 347678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347686 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347689 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347693 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347700 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347710 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 347717 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 347717 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347720 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 347724 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347729 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347734 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347744 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347763 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347766 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347776 */     // GIR_Coverage, 4189,
     /* 347776 */     GIR_EraseRootFromParent_Done,
     /* 347777 */   // Label 7073: @347777
     /* 347777 */   GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(347899), // Rule ID 4194 //
     /* 347782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347808 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347811 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347815 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347822 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347826 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347832 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 347839 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 347839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 347846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347866 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 347879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 347882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 347885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 347888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 347898 */     // GIR_Coverage, 4194,
     /* 347898 */     GIR_EraseRootFromParent_Done,
     /* 347899 */   // Label 7074: @347899
     /* 347899 */   GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(348021), // Rule ID 4196 //
     /* 347904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 347907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 347910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 347922 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 347926 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 347930 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 347933 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 347937 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 347944 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 347948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 347952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 347954 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 347961 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 347961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 347964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 347968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 347973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 347978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 347983 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 347988 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 347994 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 347996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 347999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348004 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 348010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348020 */     // GIR_Coverage, 4196,
     /* 348020 */     GIR_EraseRootFromParent_Done,
     /* 348021 */   // Label 7075: @348021
     /* 348021 */   GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(348142), // Rule ID 4186 //
     /* 348026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348040 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348046 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348056 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348059 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348063 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348070 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348074 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348078 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348080 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 348087 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 348087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 348090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 348094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348099 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348109 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348115 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348125 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 348131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348141 */     // GIR_Coverage, 4186,
     /* 348141 */     GIR_EraseRootFromParent_Done,
     /* 348142 */   // Label 7076: @348142
     /* 348142 */   GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(348263), // Rule ID 4187 //
     /* 348147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348161 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 348167 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 348169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348177 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348180 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348184 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348191 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348195 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348201 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 348208 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 348208 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 348211 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 348215 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348220 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348225 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348230 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 348252 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348262 */     // GIR_Coverage, 4187,
     /* 348262 */     GIR_EraseRootFromParent_Done,
     /* 348263 */   // Label 7077: @348263
     /* 348263 */   GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(348380), // Rule ID 4190 //
     /* 348268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348294 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348297 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348301 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348308 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348312 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348316 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348318 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 348325 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 348325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 348328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 348332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348342 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348347 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348363 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348366 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 348369 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348374 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348379 */     // GIR_Coverage, 4190,
     /* 348379 */     GIR_EraseRootFromParent_Done,
     /* 348380 */   // Label 7078: @348380
     /* 348380 */   GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(348497), // Rule ID 4192 //
     /* 348385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 348407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348411 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348414 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 348418 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348425 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 348429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348433 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348435 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 348442 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 348442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 348445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 348449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 348459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 348464 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 348470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 348486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 348496 */     // GIR_Coverage, 4192,
     /* 348496 */     GIR_EraseRootFromParent_Done,
     /* 348497 */   // Label 7079: @348497
     /* 348497 */   GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(348637), // Rule ID 5717 //
     /* 348502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 348524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 348528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 348532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348545 */     // MIs[2] Operand 1
     /* 348545 */     // No operand predicates
     /* 348545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 348549 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348553 */     // MIs[3] Operand 1
     /* 348553 */     // No operand predicates
     /* 348553 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348555 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 348555 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 348558 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348562 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348567 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 348570 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 348574 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 348577 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348582 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 348594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348599 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 348605 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 348609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 348612 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348619 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348626 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348636 */     // GIR_Coverage, 5717,
     /* 348636 */     GIR_EraseRootFromParent_Done,
     /* 348637 */   // Label 7080: @348637
     /* 348637 */   GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(348808), // Rule ID 5718 //
     /* 348642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 348664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 348668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 348672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 348681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348685 */     // MIs[2] Operand 1
     /* 348685 */     // No operand predicates
     /* 348685 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 348689 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348693 */     // MIs[3] Operand 1
     /* 348693 */     // No operand predicates
     /* 348693 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348695 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 348695 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 348698 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348702 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348707 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 348710 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 348714 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 348717 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348722 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348727 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 348730 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348734 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348739 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 348742 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 348746 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 348749 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348754 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 348766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348771 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348774 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 348777 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 348780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 348783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348790 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348807 */     // GIR_Coverage, 5718,
     /* 348807 */     GIR_EraseRootFromParent_Done,
     /* 348808 */   // Label 7081: @348808
     /* 348808 */   GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(348887), // Rule ID 5649 //
     /* 348813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 348831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348835 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 348839 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348841 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 348841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 348844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348853 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 348857 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 348870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 348873 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 348876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 348886 */     // GIR_Coverage, 5649,
     /* 348886 */     GIR_EraseRootFromParent_Done,
     /* 348887 */   // Label 7082: @348887
     /* 348887 */   GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(349036), // Rule ID 6423 //
     /* 348892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 348895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 348898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 348910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 348914 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 348917 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 348921 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 348928 */     // MIs[1] Rn
     /* 348928 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 348932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 348937 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 348941 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 348945 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 348949 */     // MIs[2] Operand 1
     /* 348949 */     // No operand predicates
     /* 348949 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 348951 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 348951 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 348954 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 348958 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348963 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 348966 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 348970 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 348973 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348978 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 348990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348995 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 348998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 349001 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 349005 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349011 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349018 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349025 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349030 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349035 */     // GIR_Coverage, 6423,
     /* 349035 */     GIR_EraseRootFromParent_Done,
     /* 349036 */   // Label 7083: @349036
     /* 349036 */   GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(349171), // Rule ID 5688 //
     /* 349041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349044 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 349059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 349063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349067 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 349071 */     // MIs[1] Operand 1
     /* 349071 */     // No operand predicates
     /* 349071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 349073 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 349073 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 349076 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 349080 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349085 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349087 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 349090 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 349094 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349099 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349102 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349106 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 349109 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349114 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349119 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 349131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349136 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 349142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 349146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349153 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349170 */     // GIR_Coverage, 5688,
     /* 349170 */     GIR_EraseRootFromParent_Done,
     /* 349171 */   // Label 7084: @349171
     /* 349171 */   GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(349359), // Rule ID 5689 //
     /* 349176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 349179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 349198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 349202 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 349206 */     // MIs[1] Operand 1
     /* 349206 */     // No operand predicates
     /* 349206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 349208 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 349208 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
     /* 349211 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 349215 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349220 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 349222 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 349225 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 349229 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349234 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 349237 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 349241 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 349244 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349249 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349254 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 349259 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 349262 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 349266 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 349273 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 349276 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 349280 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349285 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 349288 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349292 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 349295 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349300 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349305 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 349317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349322 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 349325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 349328 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 349331 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 349334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349341 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349358 */     // GIR_Coverage, 5689,
     /* 349358 */     GIR_EraseRootFromParent_Done,
     /* 349359 */   // Label 7085: @349359
     /* 349359 */   GIM_Reject,
     /* 349360 */ // Label 7071: @349360
     /* 349360 */ GIM_Reject,
     /* 349361 */ // Label 6930: @349361
     /* 349361 */ GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(352335),
     /* 349366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 349369 */   GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(349495), // Rule ID 4212 //
     /* 349374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349384 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349388 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349394 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349404 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349407 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349411 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 349418 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349422 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349426 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349428 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 349435 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 349442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349447 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349462 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349475 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349494 */     // GIR_Coverage, 4212,
     /* 349494 */     GIR_EraseRootFromParent_Done,
     /* 349495 */   // Label 7087: @349495
     /* 349495 */   GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(349621), // Rule ID 4213 //
     /* 349500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349514 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349520 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349530 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349533 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349537 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 349544 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349548 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349554 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 349561 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349561 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349564 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 349568 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349588 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349604 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349607 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349615 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349620 */     // GIR_Coverage, 4213,
     /* 349620 */     GIR_EraseRootFromParent_Done,
     /* 349621 */   // Label 7088: @349621
     /* 349621 */   GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(349740), // Rule ID 4320 //
     /* 349626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 349629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349640 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349646 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349656 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349659 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349663 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349673 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 349680 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349680 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349683 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 349687 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349707 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349739 */     // GIR_Coverage, 4320,
     /* 349739 */     GIR_EraseRootFromParent_Done,
     /* 349740 */   // Label 7089: @349740
     /* 349740 */   GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(349859), // Rule ID 4321 //
     /* 349745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 349748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349759 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 349765 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 349767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349775 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349778 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349782 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349786 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349790 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349792 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 349799 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 349806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349821 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349826 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349848 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349853 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349858 */     // GIR_Coverage, 4321,
     /* 349858 */     GIR_EraseRootFromParent_Done,
     /* 349859 */   // Label 7090: @349859
     /* 349859 */   GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(349981), // Rule ID 4218 //
     /* 349864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 349882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 349886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 349890 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 349893 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 349897 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 349904 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 349908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 349912 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 349914 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 349921 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 349921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 349924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 349928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349933 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 349938 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 349943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 349948 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 349954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 349959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 349964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 349970 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 349980 */     // GIR_Coverage, 4218,
     /* 349980 */     GIR_EraseRootFromParent_Done,
     /* 349981 */   // Label 7091: @349981
     /* 349981 */   GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(350103), // Rule ID 4220 //
     /* 349986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 349989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 349992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350012 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350015 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350019 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 350026 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350036 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 350043 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 350043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 350050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350055 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 350065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 350070 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350076 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350092 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350097 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350102 */     // GIR_Coverage, 4220,
     /* 350102 */     GIR_EraseRootFromParent_Done,
     /* 350103 */   // Label 7092: @350103
     /* 350103 */   GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(350218), // Rule ID 4326 //
     /* 350108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350134 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350137 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350141 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350145 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350151 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 350158 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 350158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 350165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350170 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 350180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 350185 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350201 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350204 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350207 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350212 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350217 */     // GIR_Coverage, 4326,
     /* 350217 */     GIR_EraseRootFromParent_Done,
     /* 350218 */   // Label 7093: @350218
     /* 350218 */   GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(350333), // Rule ID 4328 //
     /* 350223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350249 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350252 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350256 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350266 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 350273 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 350273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 350280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 350295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 350300 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350306 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350332 */     // GIR_Coverage, 4328,
     /* 350332 */     GIR_EraseRootFromParent_Done,
     /* 350333 */   // Label 7094: @350333
     /* 350333 */   GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(350454), // Rule ID 4210 //
     /* 350338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350352 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350358 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350368 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350371 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350375 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 350382 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350386 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350390 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350392 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 350399 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 350399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 350406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350416 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350421 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350443 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350448 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350453 */     // GIR_Coverage, 4210,
     /* 350453 */     GIR_EraseRootFromParent_Done,
     /* 350454 */   // Label 7095: @350454
     /* 350454 */   GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(350575), // Rule ID 4211 //
     /* 350459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350473 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350479 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350489 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350492 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350496 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 350503 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350507 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350513 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 350520 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 350520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 350527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350537 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350542 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350555 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350558 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350564 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350569 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350574 */     // GIR_Coverage, 4211,
     /* 350574 */     GIR_EraseRootFromParent_Done,
     /* 350575 */   // Label 7096: @350575
     /* 350575 */   GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(350689), // Rule ID 4318 //
     /* 350580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350594 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350600 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350610 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350613 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350617 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350621 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350625 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350627 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 350634 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 350634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 350641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350646 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350651 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350656 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350675 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350683 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350688 */     // GIR_Coverage, 4318,
     /* 350688 */     GIR_EraseRootFromParent_Done,
     /* 350689 */   // Label 7097: @350689
     /* 350689 */   GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(350803), // Rule ID 4319 //
     /* 350694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 350697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350708 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 350714 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 350716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350724 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350727 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350731 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350735 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350741 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 350748 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 350748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 350755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350770 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350783 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350792 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350797 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350802 */     // GIR_Coverage, 4319,
     /* 350802 */     GIR_EraseRootFromParent_Done,
     /* 350803 */   // Label 7098: @350803
     /* 350803 */   GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(350920), // Rule ID 4214 //
     /* 350808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350834 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350837 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350841 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 350848 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350852 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350856 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350858 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 350865 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 350865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 350872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 350887 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 350893 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 350898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 350900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 350903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 350909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350914 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 350919 */     // GIR_Coverage, 4214,
     /* 350919 */     GIR_EraseRootFromParent_Done,
     /* 350920 */   // Label 7099: @350920
     /* 350920 */   GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(351037), // Rule ID 4216 //
     /* 350925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 350928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 350931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 350935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 350939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 350943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 350947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 350951 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 350954 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 350958 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 350965 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 350969 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 350973 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 350975 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 350982 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 350982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 350985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 350989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350994 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 350999 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 351004 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351010 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351020 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351026 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351036 */     // GIR_Coverage, 4216,
     /* 351036 */     GIR_EraseRootFromParent_Done,
     /* 351037 */   // Label 7100: @351037
     /* 351037 */   GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(351147), // Rule ID 4322 //
     /* 351042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351068 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351071 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351075 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351079 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351085 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 351092 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 351092 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 351095 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 351099 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351104 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351109 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 351114 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351120 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351130 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351136 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351141 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351146 */     // GIR_Coverage, 4322,
     /* 351146 */     GIR_EraseRootFromParent_Done,
     /* 351147 */   // Label 7101: @351147
     /* 351147 */   GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(351257), // Rule ID 4324 //
     /* 351152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 351174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 351178 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 351181 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 351185 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 351189 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351193 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351195 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 351202 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 351202 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 351205 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 351209 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 351219 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 351224 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 351230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351251 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351256 */     // GIR_Coverage, 4324,
     /* 351256 */     GIR_EraseRootFromParent_Done,
     /* 351257 */   // Label 7102: @351257
     /* 351257 */   GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(351345), // Rule ID 1939 //
     /* 351262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 351265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 351287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 351291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 351295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351308 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 351312 */     // MIs[2] Operand 1
     /* 351312 */     // No operand predicates
     /* 351312 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 351316 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351320 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 351324 */     // MIs[3] Operand 1
     /* 351324 */     // No operand predicates
     /* 351324 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351326 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 351326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 351329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351331 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 351333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 351336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 351340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 351343 */     GIR_RootConstrainSelectedInstOperands,
     /* 351344 */     // GIR_Coverage, 1939,
     /* 351344 */     GIR_EraseRootFromParent_Done,
     /* 351345 */   // Label 7103: @351345
     /* 351345 */   GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(351422), // Rule ID 5697 //
     /* 351350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 351372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 351376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 351380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351393 */     // MIs[2] Operand 1
     /* 351393 */     // No operand predicates
     /* 351393 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 351397 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351401 */     // MIs[3] Operand 1
     /* 351401 */     // No operand predicates
     /* 351401 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351403 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 351403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 351406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351408 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 351410 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 351413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 351417 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 351420 */     GIR_RootConstrainSelectedInstOperands,
     /* 351421 */     // GIR_Coverage, 5697,
     /* 351421 */     GIR_EraseRootFromParent_Done,
     /* 351422 */   // Label 7104: @351422
     /* 351422 */   GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(351530), // Rule ID 5698 //
     /* 351427 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351430 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 351449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 351453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 351457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351470 */     // MIs[2] Operand 1
     /* 351470 */     // No operand predicates
     /* 351470 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 351474 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351478 */     // MIs[3] Operand 1
     /* 351478 */     // No operand predicates
     /* 351478 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351480 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 351480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 351483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351492 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 351495 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 351499 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 351502 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351507 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 351515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351517 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 351519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 351522 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 351528 */     GIR_RootConstrainSelectedInstOperands,
     /* 351529 */     // GIR_Coverage, 5698,
     /* 351529 */     GIR_EraseRootFromParent_Done,
     /* 351530 */   // Label 7105: @351530
     /* 351530 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(351607), // Rule ID 5721 //
     /* 351535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 351557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 351561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 351565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351570 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351574 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351578 */     // MIs[2] Operand 1
     /* 351578 */     // No operand predicates
     /* 351578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 351582 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351586 */     // MIs[3] Operand 1
     /* 351586 */     // No operand predicates
     /* 351586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351588 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 351588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 351591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351593 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 351595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 351598 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 351602 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 351605 */     GIR_RootConstrainSelectedInstOperands,
     /* 351606 */     // GIR_Coverage, 5721,
     /* 351606 */     GIR_EraseRootFromParent_Done,
     /* 351607 */   // Label 7106: @351607
     /* 351607 */   GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(351715), // Rule ID 5722 //
     /* 351612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351622 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 351634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 351638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 351642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 351651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351655 */     // MIs[2] Operand 1
     /* 351655 */     // No operand predicates
     /* 351655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 351659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351663 */     // MIs[3] Operand 1
     /* 351663 */     // No operand predicates
     /* 351663 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 351665 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 351665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 351668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351677 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 351680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 351684 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 351687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 351697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 351700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351702 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 351704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 351707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351710 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 351713 */     GIR_RootConstrainSelectedInstOperands,
     /* 351714 */     // GIR_Coverage, 5722,
     /* 351714 */     GIR_EraseRootFromParent_Done,
     /* 351715 */   // Label 7107: @351715
     /* 351715 */   GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(351794), // Rule ID 5652 //
     /* 351720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 351723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 351742 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351748 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 351748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 351751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 351755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351760 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 351764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 351772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 351777 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351780 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 351783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351788 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 351793 */     // GIR_Coverage, 5652,
     /* 351793 */     GIR_EraseRootFromParent_Done,
     /* 351794 */   // Label 7108: @351794
     /* 351794 */   GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(351870), // Rule ID 5658 //
     /* 351799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351821 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351827 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 351827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 351830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 351834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 351844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 351851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351854 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351859 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351864 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351869 */     // GIR_Coverage, 5658,
     /* 351869 */     GIR_EraseRootFromParent_Done,
     /* 351870 */   // Label 7109: @351870
     /* 351870 */   GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(351946), // Rule ID 5668 //
     /* 351875 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351878 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 351889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 351893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351897 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 351901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 351903 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 351903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 351906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 351910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 351920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 351927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 351930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 351945 */     // GIR_Coverage, 5668,
     /* 351945 */     GIR_EraseRootFromParent_Done,
     /* 351946 */   // Label 7110: @351946
     /* 351946 */   GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(352009), // Rule ID 5677 //
     /* 351951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 351954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 351957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 351965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 351969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 351973 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 351977 */     // MIs[1] Operand 1
     /* 351977 */     // No operand predicates
     /* 351977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 351981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 351985 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 351989 */     // MIs[2] Operand 1
     /* 351989 */     // No operand predicates
     /* 351989 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 351991 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
     /* 351991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 351994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 351996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 351998 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 352001 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 352007 */     GIR_RootConstrainSelectedInstOperands,
     /* 352008 */     // GIR_Coverage, 5677,
     /* 352008 */     GIR_EraseRootFromParent_Done,
     /* 352009 */   // Label 7111: @352009
     /* 352009 */   GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(352095), // Rule ID 6405 //
     /* 352014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352036 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352039 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 352043 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 352050 */     // MIs[1] Rn
     /* 352050 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 352054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 352059 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 352063 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352067 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 352071 */     // MIs[2] Operand 1
     /* 352071 */     // No operand predicates
     /* 352071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352073 */     // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 352073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 352076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352078 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 352080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 352083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352093 */     GIR_RootConstrainSelectedInstOperands,
     /* 352094 */     // GIR_Coverage, 6405,
     /* 352094 */     GIR_EraseRootFromParent_Done,
     /* 352095 */   // Label 7112: @352095
     /* 352095 */   GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(352174), // Rule ID 6410 //
     /* 352100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 352103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 352118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352122 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352125 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 352129 */     // MIs[1] Rn
     /* 352129 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 352133 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 352138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 352142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352146 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 352150 */     // MIs[2] Operand 1
     /* 352150 */     // No operand predicates
     /* 352150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352152 */     // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 352152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 352155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 352159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 352162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 352166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352172 */     GIR_RootConstrainSelectedInstOperands,
     /* 352173 */     // GIR_Coverage, 6410,
     /* 352173 */     GIR_EraseRootFromParent_Done,
     /* 352174 */   // Label 7113: @352174
     /* 352174 */   GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(352228), // Rule ID 1935 //
     /* 352179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 352182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 352200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 352204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 352212 */     // MIs[1] Operand 1
     /* 352212 */     // No operand predicates
     /* 352212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352214 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 352214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 352217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352219 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 352221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 352224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 352226 */     GIR_RootConstrainSelectedInstOperands,
     /* 352227 */     // GIR_Coverage, 1935,
     /* 352227 */     GIR_EraseRootFromParent_Done,
     /* 352228 */   // Label 7114: @352228
     /* 352228 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(352334), // Rule ID 5682 //
     /* 352233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 352236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352247 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 352255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 352259 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 352263 */     // MIs[1] Operand 1
     /* 352263 */     // No operand predicates
     /* 352263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 352265 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 352265 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 352268 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 352272 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 352282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 352286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352291 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352294 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 352298 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 352301 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352306 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 352316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 352319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 352323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 352326 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352332 */     GIR_RootConstrainSelectedInstOperands,
     /* 352333 */     // GIR_Coverage, 5682,
     /* 352333 */     GIR_EraseRootFromParent_Done,
     /* 352334 */   // Label 7115: @352334
     /* 352334 */   GIM_Reject,
     /* 352335 */ // Label 7086: @352335
     /* 352335 */ GIM_Reject,
     /* 352336 */ // Label 6931: @352336
     /* 352336 */ GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(353915),
     /* 352341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 352344 */   GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(352470), // Rule ID 4176 //
     /* 352349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352363 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352369 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352379 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352382 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352386 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352393 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352397 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352403 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 352410 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 352410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 352417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352437 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352443 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352453 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352456 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352459 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352464 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352469 */     // GIR_Coverage, 4176,
     /* 352469 */     GIR_EraseRootFromParent_Done,
     /* 352470 */   // Label 7117: @352470
     /* 352470 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(352596), // Rule ID 4177 //
     /* 352475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352489 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352495 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352505 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352508 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352512 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352519 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352523 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352527 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352529 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 352536 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 352536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 352543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352548 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352553 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352558 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352563 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352585 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352590 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352595 */     // GIR_Coverage, 4177,
     /* 352595 */     GIR_EraseRootFromParent_Done,
     /* 352596 */   // Label 7118: @352596
     /* 352596 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(352718), // Rule ID 4182 //
     /* 352601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352627 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352630 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352634 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352641 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352645 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352651 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 352658 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 352658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 352665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352685 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352691 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352712 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352717 */     // GIR_Coverage, 4182,
     /* 352717 */     GIR_EraseRootFromParent_Done,
     /* 352718 */   // Label 7119: @352718
     /* 352718 */   GIM_Try, /*On fail goto*//*Label 7120*/ GIMT_Encode4(352840), // Rule ID 4184 //
     /* 352723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 352741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352749 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352752 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352756 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352763 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352771 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352773 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 352780 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 352780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 352787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352797 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 352802 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 352807 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352813 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352823 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352829 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352834 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352839 */     // GIR_Coverage, 4184,
     /* 352839 */     GIR_EraseRootFromParent_Done,
     /* 352840 */   // Label 7120: @352840
     /* 352840 */   GIM_Try, /*On fail goto*//*Label 7121*/ GIMT_Encode4(352961), // Rule ID 4174 //
     /* 352845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352859 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352865 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352875 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352878 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 352882 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 352889 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 352893 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 352897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 352899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 352906 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 352906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 352909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 352913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 352923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 352928 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 352934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 352939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 352941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 352944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 352950 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352955 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 352960 */     // GIR_Coverage, 4174,
     /* 352960 */     GIR_EraseRootFromParent_Done,
     /* 352961 */   // Label 7121: @352961
     /* 352961 */   GIM_Try, /*On fail goto*//*Label 7122*/ GIMT_Encode4(353082), // Rule ID 4175 //
     /* 352966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 352969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 352972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 352976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 352980 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 352986 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 352988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 352992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 352996 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 352999 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353003 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 353010 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353020 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 353027 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 353027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 353030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 353034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353039 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353044 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 353049 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 353071 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353076 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 353081 */     // GIR_Coverage, 4175,
     /* 353081 */     GIR_EraseRootFromParent_Done,
     /* 353082 */   // Label 7122: @353082
     /* 353082 */   GIM_Try, /*On fail goto*//*Label 7123*/ GIMT_Encode4(353199), // Rule ID 4178 //
     /* 353087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353113 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353116 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353120 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 353127 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353131 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353137 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 353144 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 353144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 353147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 353151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 353166 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353172 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 353188 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353193 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 353198 */     // GIR_Coverage, 4178,
     /* 353198 */     GIR_EraseRootFromParent_Done,
     /* 353199 */   // Label 7123: @353199
     /* 353199 */   GIM_Try, /*On fail goto*//*Label 7124*/ GIMT_Encode4(353316), // Rule ID 4180 //
     /* 353204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 353226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353230 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353233 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 353237 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 353244 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 353248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353254 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 353261 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 353261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 353264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 353268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 353278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 353283 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353289 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353299 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 353305 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 353315 */     // GIR_Coverage, 4180,
     /* 353315 */     GIR_EraseRootFromParent_Done,
     /* 353316 */   // Label 7124: @353316
     /* 353316 */   GIM_Try, /*On fail goto*//*Label 7125*/ GIMT_Encode4(353404), // Rule ID 1938 //
     /* 353321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 353324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353334 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 353350 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353367 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 353371 */     // MIs[2] Operand 1
     /* 353371 */     // No operand predicates
     /* 353371 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353375 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353379 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 353383 */     // MIs[3] Operand 1
     /* 353383 */     // No operand predicates
     /* 353383 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353385 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 353385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 353388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 353392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 353395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 353402 */     GIR_RootConstrainSelectedInstOperands,
     /* 353403 */     // GIR_Coverage, 1938,
     /* 353403 */     GIR_EraseRootFromParent_Done,
     /* 353404 */   // Label 7125: @353404
     /* 353404 */   GIM_Try, /*On fail goto*//*Label 7126*/ GIMT_Encode4(353481), // Rule ID 5715 //
     /* 353409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 353435 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353452 */     // MIs[2] Operand 1
     /* 353452 */     // No operand predicates
     /* 353452 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353456 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353460 */     // MIs[3] Operand 1
     /* 353460 */     // No operand predicates
     /* 353460 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353462 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 353462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 353465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353467 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 353469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 353472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 353479 */     GIR_RootConstrainSelectedInstOperands,
     /* 353480 */     // GIR_Coverage, 5715,
     /* 353480 */     GIR_EraseRootFromParent_Done,
     /* 353481 */   // Label 7126: @353481
     /* 353481 */   GIM_Try, /*On fail goto*//*Label 7127*/ GIMT_Encode4(353589), // Rule ID 5716 //
     /* 353486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 353512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353529 */     // MIs[2] Operand 1
     /* 353529 */     // No operand predicates
     /* 353529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353537 */     // MIs[3] Operand 1
     /* 353537 */     // No operand predicates
     /* 353537 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353539 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 353539 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 353542 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353546 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353551 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 353554 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353558 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 353561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 353574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353576 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 353578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 353581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 353587 */     GIR_RootConstrainSelectedInstOperands,
     /* 353588 */     // GIR_Coverage, 5716,
     /* 353588 */     GIR_EraseRootFromParent_Done,
     /* 353589 */   // Label 7127: @353589
     /* 353589 */   GIM_Try, /*On fail goto*//*Label 7128*/ GIMT_Encode4(353668), // Rule ID 5647 //
     /* 353594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 353608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 353612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 353616 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 353620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353622 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 353622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 353625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353634 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 353638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 353657 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353662 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 353667 */     // GIR_Coverage, 5647,
     /* 353667 */     GIR_EraseRootFromParent_Done,
     /* 353668 */   // Label 7128: @353668
     /* 353668 */   GIM_Try, /*On fail goto*//*Label 7129*/ GIMT_Encode4(353754), // Rule ID 6404 //
     /* 353673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353683 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 353695 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 353698 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 353702 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 353709 */     // MIs[1] Rn
     /* 353709 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 353713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 353718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 353722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353726 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 353730 */     // MIs[2] Operand 1
     /* 353730 */     // No operand predicates
     /* 353730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 353732 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 353732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 353735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353737 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 353739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 353742 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 353752 */     GIR_RootConstrainSelectedInstOperands,
     /* 353753 */     // GIR_Coverage, 6404,
     /* 353753 */     GIR_EraseRootFromParent_Done,
     /* 353754 */   // Label 7129: @353754
     /* 353754 */   GIM_Try, /*On fail goto*//*Label 7130*/ GIMT_Encode4(353808), // Rule ID 1934 //
     /* 353759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 353762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 353765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 353780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 353784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353788 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 353792 */     // MIs[1] Operand 1
     /* 353792 */     // No operand predicates
     /* 353792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353794 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 353794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 353797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 353801 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 353804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 353806 */     GIR_RootConstrainSelectedInstOperands,
     /* 353807 */     // GIR_Coverage, 1934,
     /* 353807 */     GIR_EraseRootFromParent_Done,
     /* 353808 */   // Label 7130: @353808
     /* 353808 */   GIM_Try, /*On fail goto*//*Label 7131*/ GIMT_Encode4(353914), // Rule ID 5690 //
     /* 353813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 353816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 353831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 353835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353839 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 353843 */     // MIs[1] Operand 1
     /* 353843 */     // No operand predicates
     /* 353843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 353845 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 353845 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 353848 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 353852 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 353859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 353862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 353866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353871 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353874 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 353878 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 353881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353886 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 353896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 353899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353901 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 353903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 353906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 353912 */     GIR_RootConstrainSelectedInstOperands,
     /* 353913 */     // GIR_Coverage, 5690,
     /* 353913 */     GIR_EraseRootFromParent_Done,
     /* 353914 */   // Label 7131: @353914
     /* 353914 */   GIM_Reject,
     /* 353915 */ // Label 7116: @353915
     /* 353915 */ GIM_Reject,
     /* 353916 */ // Label 6932: @353916
     /* 353916 */ GIM_Try, /*On fail goto*//*Label 7132*/ GIMT_Encode4(354040), // Rule ID 11129 //
     /* 353921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 353927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 353930 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353937 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 353941 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 353945 */   // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
     /* 353945 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 353948 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 353952 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353957 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 353961 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 353963 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 353966 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 353970 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353975 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 353978 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 353981 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 353983 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 353986 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 353990 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353995 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 353998 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354000 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354003 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 354007 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354012 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354015 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 354018 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 354021 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 354024 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 354029 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354031 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 354033 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354036 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 354038 */   GIR_RootConstrainSelectedInstOperands,
     /* 354039 */   // GIR_Coverage, 11129,
     /* 354039 */   GIR_EraseRootFromParent_Done,
     /* 354040 */ // Label 7132: @354040
     /* 354040 */ GIM_Reject,
     /* 354041 */ // Label 6933: @354041
     /* 354041 */ GIM_Try, /*On fail goto*//*Label 7133*/ GIMT_Encode4(354165), // Rule ID 11132 //
     /* 354046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 354049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 354052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354055 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354062 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354066 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 354070 */   // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
     /* 354070 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 354073 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 354077 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354082 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 354086 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 354088 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 354091 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 354095 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354100 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 354103 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 354106 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 354108 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 354111 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 354115 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354120 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 354123 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 354125 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 354128 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 354132 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354137 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354140 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 354143 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 354146 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 354149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 354154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 354156 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 354158 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354161 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 354163 */   GIR_RootConstrainSelectedInstOperands,
     /* 354164 */   // GIR_Coverage, 11132,
     /* 354164 */   GIR_EraseRootFromParent_Done,
     /* 354165 */ // Label 7133: @354165
     /* 354165 */ GIM_Reject,
     /* 354166 */ // Label 6934: @354166
     /* 354166 */ GIM_Try, /*On fail goto*//*Label 7134*/ GIMT_Encode4(356079),
     /* 354171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 354174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 354177 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354184 */   GIM_Try, /*On fail goto*//*Label 7135*/ GIMT_Encode4(354293), // Rule ID 4308 //
     /* 354189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354193 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354199 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354209 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354212 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354216 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354226 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 354233 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 354240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354260 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354287 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354292 */     // GIR_Coverage, 4308,
     /* 354292 */     GIR_EraseRootFromParent_Done,
     /* 354293 */   // Label 7135: @354293
     /* 354293 */   GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(354402), // Rule ID 4309 //
     /* 354298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354302 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354308 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354318 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354321 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354325 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354329 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354335 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 354342 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 354349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354369 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354401 */     // GIR_Coverage, 4309,
     /* 354401 */     GIR_EraseRootFromParent_Done,
     /* 354402 */   // Label 7136: @354402
     /* 354402 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(354511), // Rule ID 4416 //
     /* 354407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354411 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354417 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354427 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354430 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354434 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 354451 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 354458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354478 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354505 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354510 */     // GIR_Coverage, 4416,
     /* 354510 */     GIR_EraseRootFromParent_Done,
     /* 354511 */   // Label 7137: @354511
     /* 354511 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(354620), // Rule ID 4417 //
     /* 354516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354520 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354526 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354536 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354539 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354543 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354551 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354553 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 354560 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 354567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354577 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354582 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354587 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354593 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354609 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354614 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354619 */     // GIR_Coverage, 4417,
     /* 354619 */     GIR_EraseRootFromParent_Done,
     /* 354620 */   // Label 7138: @354620
     /* 354620 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(354725), // Rule ID 4314 //
     /* 354625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354641 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354644 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354648 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354652 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354658 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 354665 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 354672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354677 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354682 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354687 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354692 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354714 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354719 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354724 */     // GIR_Coverage, 4314,
     /* 354724 */     GIR_EraseRootFromParent_Done,
     /* 354725 */   // Label 7139: @354725
     /* 354725 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(354830), // Rule ID 4316 //
     /* 354730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354746 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354749 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354753 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354757 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354761 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354763 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 354770 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354770 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354773 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 354777 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354797 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354813 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354819 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354824 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354829 */     // GIR_Coverage, 4316,
     /* 354829 */     GIR_EraseRootFromParent_Done,
     /* 354830 */   // Label 7140: @354830
     /* 354830 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(354935), // Rule ID 4422 //
     /* 354835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354851 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354854 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354858 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354868 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 354875 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 354882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354897 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354902 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354918 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 354924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 354929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354934 */     // GIR_Coverage, 4422,
     /* 354934 */     GIR_EraseRootFromParent_Done,
     /* 354935 */   // Label 7141: @354935
     /* 354935 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(355040), // Rule ID 4424 //
     /* 354940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354956 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354959 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354963 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354973 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 354980 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 354980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 354983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 354987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355007 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355029 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355039 */     // GIR_Coverage, 4424,
     /* 355039 */     GIR_EraseRootFromParent_Done,
     /* 355040 */   // Label 7142: @355040
     /* 355040 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(355144), // Rule ID 4306 //
     /* 355045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355049 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355055 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355065 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355068 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355072 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355080 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355082 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 355089 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 355089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 355096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355111 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355117 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355127 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355138 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355143 */     // GIR_Coverage, 4306,
     /* 355143 */     GIR_EraseRootFromParent_Done,
     /* 355144 */   // Label 7143: @355144
     /* 355144 */   GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(355248), // Rule ID 4307 //
     /* 355149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355153 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355159 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355169 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355172 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355176 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355180 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355184 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355186 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 355193 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 355193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 355200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355210 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355215 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355221 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355247 */     // GIR_Coverage, 4307,
     /* 355247 */     GIR_EraseRootFromParent_Done,
     /* 355248 */   // Label 7144: @355248
     /* 355248 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(355352), // Rule ID 4414 //
     /* 355253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355257 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355263 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355273 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355276 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355280 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355284 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355288 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355290 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 355297 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 355297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 355304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355319 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355341 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355346 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355351 */     // GIR_Coverage, 4414,
     /* 355351 */     GIR_EraseRootFromParent_Done,
     /* 355352 */   // Label 7145: @355352
     /* 355352 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(355456), // Rule ID 4415 //
     /* 355357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355361 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355367 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355377 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355380 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355384 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355394 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 355401 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 355401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 355408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355418 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355423 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355445 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355450 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355455 */     // GIR_Coverage, 4415,
     /* 355455 */     GIR_EraseRootFromParent_Done,
     /* 355456 */   // Label 7146: @355456
     /* 355456 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(355556), // Rule ID 4310 //
     /* 355461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355477 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355480 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355484 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355488 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355494 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 355501 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 355501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 355508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355523 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355539 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355550 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355555 */     // GIR_Coverage, 4310,
     /* 355555 */     GIR_EraseRootFromParent_Done,
     /* 355556 */   // Label 7147: @355556
     /* 355556 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(355656), // Rule ID 4312 //
     /* 355561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355577 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355580 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355584 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355594 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 355601 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 355601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 355608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355623 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355629 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355655 */     // GIR_Coverage, 4312,
     /* 355655 */     GIR_EraseRootFromParent_Done,
     /* 355656 */   // Label 7148: @355656
     /* 355656 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(355756), // Rule ID 4418 //
     /* 355661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355677 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355680 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355684 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355688 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355694 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 355701 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 355701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 355708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355723 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355750 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355755 */     // GIR_Coverage, 4418,
     /* 355755 */     GIR_EraseRootFromParent_Done,
     /* 355756 */   // Label 7149: @355756
     /* 355756 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(355856), // Rule ID 4420 //
     /* 355761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355777 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355780 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355784 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355792 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355794 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 355801 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 355801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 355804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 355808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355823 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 355845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 355850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355855 */     // GIR_Coverage, 4420,
     /* 355855 */     GIR_EraseRootFromParent_Done,
     /* 355856 */   // Label 7150: @355856
     /* 355856 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(355967), // Rule ID 11128 //
     /* 355861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355872 */     // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
     /* 355872 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 355875 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 355879 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355884 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 355888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 355890 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 355893 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 355897 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355902 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 355905 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 355908 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 355910 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 355913 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 355917 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355922 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 355925 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 355927 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 355930 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 355934 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355939 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 355942 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 355945 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 355948 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 355951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
     /* 355956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 355958 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 355960 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355963 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 355965 */     GIR_RootConstrainSelectedInstOperands,
     /* 355966 */     // GIR_Coverage, 11128,
     /* 355966 */     GIR_EraseRootFromParent_Done,
     /* 355967 */   // Label 7151: @355967
     /* 355967 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(356078), // Rule ID 11134 //
     /* 355972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 355975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 355983 */     // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
     /* 355983 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 355986 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 355990 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355995 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 355999 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 356001 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 356004 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 356008 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356013 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 356016 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 356019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356021 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 356024 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 356028 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356033 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 356036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 356041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 356045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356050 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356053 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 356056 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 356059 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 356062 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
     /* 356067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356069 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 356071 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356074 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 356076 */     GIR_RootConstrainSelectedInstOperands,
     /* 356077 */     // GIR_Coverage, 11134,
     /* 356077 */     GIR_EraseRootFromParent_Done,
     /* 356078 */   // Label 7152: @356078
     /* 356078 */   GIM_Reject,
     /* 356079 */ // Label 7134: @356079
     /* 356079 */ GIM_Reject,
     /* 356080 */ // Label 6935: @356080
     /* 356080 */ GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(356231), // Rule ID 11130 //
     /* 356085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 356088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 356091 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 356094 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356101 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 356105 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 356109 */   // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 356109 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 356112 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356116 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356121 */   GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 356127 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 356132 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 356137 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 356140 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 356144 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356149 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 356152 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 356154 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 356157 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 356161 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356166 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 356169 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 356172 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 356174 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 356177 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 356181 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356186 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 356189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356191 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 356194 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 356198 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356203 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356206 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 356209 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 356212 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 356215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 356220 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 356222 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 356224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356227 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 356229 */   GIR_RootConstrainSelectedInstOperands,
     /* 356230 */   // GIR_Coverage, 11130,
     /* 356230 */   GIR_EraseRootFromParent_Done,
     /* 356231 */ // Label 7153: @356231
     /* 356231 */ GIM_Reject,
     /* 356232 */ // Label 6936: @356232
     /* 356232 */ GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(358199),
     /* 356237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 356240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 356243 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 356246 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356250 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(356359), // Rule ID 4272 //
     /* 356255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356259 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356265 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356275 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356278 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356282 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356286 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356292 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 356299 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 356306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356316 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356321 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356326 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356348 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356353 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356358 */     // GIR_Coverage, 4272,
     /* 356358 */     GIR_EraseRootFromParent_Done,
     /* 356359 */   // Label 7155: @356359
     /* 356359 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(356468), // Rule ID 4273 //
     /* 356364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356368 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356374 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356384 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356387 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356391 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356395 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356399 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356401 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 356408 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356408 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356411 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 356415 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356435 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356457 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356462 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356467 */     // GIR_Coverage, 4273,
     /* 356467 */     GIR_EraseRootFromParent_Done,
     /* 356468 */   // Label 7156: @356468
     /* 356468 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(356577), // Rule ID 4380 //
     /* 356473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356477 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356483 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356493 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356496 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356500 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356504 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356508 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356510 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 356517 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 356524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356544 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356560 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356563 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356566 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356571 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356576 */     // GIR_Coverage, 4380,
     /* 356576 */     GIR_EraseRootFromParent_Done,
     /* 356577 */   // Label 7157: @356577
     /* 356577 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(356686), // Rule ID 4381 //
     /* 356582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356586 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 356592 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 356594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356602 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356605 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356609 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356613 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356617 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356619 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 356626 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 356633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356643 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356648 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356653 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356672 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356675 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356680 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356685 */     // GIR_Coverage, 4381,
     /* 356685 */     GIR_EraseRootFromParent_Done,
     /* 356686 */   // Label 7158: @356686
     /* 356686 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(356791), // Rule ID 4278 //
     /* 356691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356707 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356710 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356714 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356718 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356722 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356724 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 356731 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 356738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356758 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356790 */     // GIR_Coverage, 4278,
     /* 356790 */     GIR_EraseRootFromParent_Done,
     /* 356791 */   // Label 7159: @356791
     /* 356791 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(356896), // Rule ID 4280 //
     /* 356796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356812 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356815 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356819 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356829 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 356836 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 356843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356863 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356885 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356895 */     // GIR_Coverage, 4280,
     /* 356895 */     GIR_EraseRootFromParent_Done,
     /* 356896 */   // Label 7160: @356896
     /* 356896 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(357001), // Rule ID 4386 //
     /* 356901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356909 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356913 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356917 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356920 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356924 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356934 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 356941 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 356941 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356944 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 356948 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 356963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 356968 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356974 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356981 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356990 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 356995 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357000 */     // GIR_Coverage, 4386,
     /* 357000 */     GIR_EraseRootFromParent_Done,
     /* 357001 */   // Label 7161: @357001
     /* 357001 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(357106), // Rule ID 4388 //
     /* 357006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357022 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357025 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357029 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357037 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357039 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 357046 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 357046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 357053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 357068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 357073 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357079 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357092 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357095 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357105 */     // GIR_Coverage, 4388,
     /* 357105 */     GIR_EraseRootFromParent_Done,
     /* 357106 */   // Label 7162: @357106
     /* 357106 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(357210), // Rule ID 4270 //
     /* 357111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357115 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357121 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357131 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357134 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357138 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357142 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357148 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 357155 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 357155 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357158 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 357162 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357167 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357172 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357177 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357183 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357204 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357209 */     // GIR_Coverage, 4270,
     /* 357209 */     GIR_EraseRootFromParent_Done,
     /* 357210 */   // Label 7163: @357210
     /* 357210 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(357314), // Rule ID 4271 //
     /* 357215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357219 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357225 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357235 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357238 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357242 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357246 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357250 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357252 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 357259 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 357259 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357262 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 357266 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357276 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357281 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357303 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357308 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357313 */     // GIR_Coverage, 4271,
     /* 357313 */     GIR_EraseRootFromParent_Done,
     /* 357314 */   // Label 7164: @357314
     /* 357314 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(357418), // Rule ID 4378 //
     /* 357319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357323 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357329 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357339 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357342 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357346 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357356 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 357363 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 357363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 357370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357385 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357407 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357412 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357417 */     // GIR_Coverage, 4378,
     /* 357417 */     GIR_EraseRootFromParent_Done,
     /* 357418 */   // Label 7165: @357418
     /* 357418 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(357522), // Rule ID 4379 //
     /* 357423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357427 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 357433 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 357435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357443 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357446 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357450 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357460 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 357467 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 357467 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357470 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 357474 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357479 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357489 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357495 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357511 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357516 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357521 */     // GIR_Coverage, 4379,
     /* 357521 */     GIR_EraseRootFromParent_Done,
     /* 357522 */   // Label 7166: @357522
     /* 357522 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(357622), // Rule ID 4274 //
     /* 357527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357543 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357546 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357550 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357558 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357560 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 357567 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 357567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 357574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357589 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357595 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357621 */     // GIR_Coverage, 4274,
     /* 357621 */     GIR_EraseRootFromParent_Done,
     /* 357622 */   // Label 7167: @357622
     /* 357622 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(357722), // Rule ID 4276 //
     /* 357627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357643 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357646 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357650 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 357667 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 357667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 357674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357689 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357721 */     // GIR_Coverage, 4276,
     /* 357721 */     GIR_EraseRootFromParent_Done,
     /* 357722 */   // Label 7168: @357722
     /* 357722 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(357822), // Rule ID 4382 //
     /* 357727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357743 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357746 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357750 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357754 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357760 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 357767 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 357767 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357770 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 357774 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357789 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357811 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357816 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357821 */     // GIR_Coverage, 4382,
     /* 357821 */     GIR_EraseRootFromParent_Done,
     /* 357822 */   // Label 7169: @357822
     /* 357822 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(357922), // Rule ID 4384 //
     /* 357827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357835 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 357839 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357843 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357846 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 357850 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 357854 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357858 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357860 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 357867 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 357867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 357870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 357874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 357884 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 357889 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357895 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 357905 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357911 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 357916 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357921 */     // GIR_Coverage, 4384,
     /* 357921 */     GIR_EraseRootFromParent_Done,
     /* 357922 */   // Label 7170: @357922
     /* 357922 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(358060), // Rule ID 11127 //
     /* 357927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 357930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 357938 */     // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 357938 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 357941 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357945 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357950 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 357956 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357961 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 357966 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 357969 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 357973 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357978 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 357981 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 357983 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 357986 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 357990 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357995 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 357998 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 358001 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 358003 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 358006 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 358010 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358015 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 358018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 358020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 358023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 358027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358032 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358035 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 358038 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 358041 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 358044 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
     /* 358049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 358051 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 358053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358056 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 358058 */     GIR_RootConstrainSelectedInstOperands,
     /* 358059 */     // GIR_Coverage, 11127,
     /* 358059 */     GIR_EraseRootFromParent_Done,
     /* 358060 */   // Label 7171: @358060
     /* 358060 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(358198), // Rule ID 11133 //
     /* 358065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 358068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 358072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358076 */     // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
     /* 358076 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 358079 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358083 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358088 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 358094 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 358099 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 358104 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 358107 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 358111 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358116 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 358119 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 358121 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 358124 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 358128 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358133 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 358136 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 358139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 358141 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 358144 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 358148 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358153 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 358156 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 358158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 358161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 358165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358170 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358173 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 358176 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 358179 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 358182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 358187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 358189 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 358191 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358194 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 358196 */     GIR_RootConstrainSelectedInstOperands,
     /* 358197 */     // GIR_Coverage, 11133,
     /* 358197 */     GIR_EraseRootFromParent_Done,
     /* 358198 */   // Label 7172: @358198
     /* 358198 */   GIM_Reject,
     /* 358199 */ // Label 7154: @358199
     /* 358199 */ GIM_Reject,
     /* 358200 */ // Label 6937: @358200
     /* 358200 */ GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(360393),
     /* 358205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 358208 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(358334), // Rule ID 4236 //
     /* 358213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 358216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358227 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358233 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358243 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358246 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358250 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 358257 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358261 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358267 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 358274 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 358274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 358281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358296 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358301 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358307 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358317 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358323 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358333 */     // GIR_Coverage, 4236,
     /* 358333 */     GIR_EraseRootFromParent_Done,
     /* 358334 */   // Label 7174: @358334
     /* 358334 */   GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(358460), // Rule ID 4237 //
     /* 358339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 358342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358353 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358359 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358369 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358372 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358376 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 358383 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358387 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358393 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 358400 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 358400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 358407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358427 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358443 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358449 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358454 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358459 */     // GIR_Coverage, 4237,
     /* 358459 */     GIR_EraseRootFromParent_Done,
     /* 358460 */   // Label 7175: @358460
     /* 358460 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(358579), // Rule ID 4344 //
     /* 358465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 358468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358479 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358485 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358495 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358498 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358502 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358510 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358512 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 358519 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 358519 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358522 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 358526 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358536 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358546 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358552 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358568 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358573 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358578 */     // GIR_Coverage, 4344,
     /* 358578 */     GIR_EraseRootFromParent_Done,
     /* 358579 */   // Label 7176: @358579
     /* 358579 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(358698), // Rule ID 4345 //
     /* 358584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 358587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358598 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358604 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358614 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358617 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358621 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358625 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358631 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 358638 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 358638 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358641 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 358645 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358665 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358687 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358697 */     // GIR_Coverage, 4345,
     /* 358697 */     GIR_EraseRootFromParent_Done,
     /* 358698 */   // Label 7177: @358698
     /* 358698 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(358820), // Rule ID 4242 //
     /* 358703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 358706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358721 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358725 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358729 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358732 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358736 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 358743 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358747 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358751 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358753 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 358760 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 358760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 358767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358772 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358787 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358793 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358803 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358809 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358814 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358819 */     // GIR_Coverage, 4242,
     /* 358819 */     GIR_EraseRootFromParent_Done,
     /* 358820 */   // Label 7178: @358820
     /* 358820 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(358942), // Rule ID 4244 //
     /* 358825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 358828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358843 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358847 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358851 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358854 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358858 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 358865 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358869 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358873 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358875 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 358882 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 358882 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 358885 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 358889 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358894 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358899 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358904 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358909 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358925 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 358931 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 358941 */     // GIR_Coverage, 4244,
     /* 358941 */     GIR_EraseRootFromParent_Done,
     /* 358942 */   // Label 7179: @358942
     /* 358942 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(359057), // Rule ID 4350 //
     /* 358947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 358950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 358957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358973 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358976 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358980 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358984 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358988 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358990 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 358997 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 358997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 359004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359009 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359024 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359040 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359046 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359051 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359056 */     // GIR_Coverage, 4350,
     /* 359056 */     GIR_EraseRootFromParent_Done,
     /* 359057 */   // Label 7180: @359057
     /* 359057 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(359172), // Rule ID 4352 //
     /* 359062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359088 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359091 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359095 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359099 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359105 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 359112 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 359112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 359119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359124 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359129 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 359134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 359139 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359152 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359161 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359171 */     // GIR_Coverage, 4352,
     /* 359171 */     GIR_EraseRootFromParent_Done,
     /* 359172 */   // Label 7181: @359172
     /* 359172 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(359293), // Rule ID 4234 //
     /* 359177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359191 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359197 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359207 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359210 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359214 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 359221 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359231 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 359238 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 359238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 359245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359260 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359287 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359292 */     // GIR_Coverage, 4234,
     /* 359292 */     GIR_EraseRootFromParent_Done,
     /* 359293 */   // Label 7182: @359293
     /* 359293 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(359414), // Rule ID 4235 //
     /* 359298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359312 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359318 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359328 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359331 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359335 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 359342 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359346 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359352 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 359359 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 359359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 359366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359381 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359387 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359397 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359408 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359413 */     // GIR_Coverage, 4235,
     /* 359413 */     GIR_EraseRootFromParent_Done,
     /* 359414 */   // Label 7183: @359414
     /* 359414 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(359528), // Rule ID 4342 //
     /* 359419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359433 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359439 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359449 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359452 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359456 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359464 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 359473 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 359473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 359480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359495 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359517 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359527 */     // GIR_Coverage, 4342,
     /* 359527 */     GIR_EraseRootFromParent_Done,
     /* 359528 */   // Label 7184: @359528
     /* 359528 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(359642), // Rule ID 4343 //
     /* 359533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359547 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359553 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359563 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359566 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359570 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359574 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359580 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 359587 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 359587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 359594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359599 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359609 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359615 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359631 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359641 */     // GIR_Coverage, 4343,
     /* 359641 */     GIR_EraseRootFromParent_Done,
     /* 359642 */   // Label 7185: @359642
     /* 359642 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(359759), // Rule ID 4238 //
     /* 359647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359673 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359676 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359680 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 359687 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359695 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359697 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 359704 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 359704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 359711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359726 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359732 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359748 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359753 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359758 */     // GIR_Coverage, 4238,
     /* 359758 */     GIR_EraseRootFromParent_Done,
     /* 359759 */   // Label 7186: @359759
     /* 359759 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(359876), // Rule ID 4240 //
     /* 359764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 359767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359782 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359786 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359790 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359793 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359797 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 359804 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359812 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359814 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 359821 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 359821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 359828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359843 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359849 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359856 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359875 */     // GIR_Coverage, 4240,
     /* 359875 */     GIR_EraseRootFromParent_Done,
     /* 359876 */   // Label 7187: @359876
     /* 359876 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(359986), // Rule ID 4346 //
     /* 359881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359907 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359910 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359914 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359924 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 359931 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 359931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 359934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 359938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359953 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359959 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 359975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 359980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 359985 */     // GIR_Coverage, 4346,
     /* 359985 */     GIR_EraseRootFromParent_Done,
     /* 359986 */   // Label 7188: @359986
     /* 359986 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(360096), // Rule ID 4348 //
     /* 359991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 359994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 359997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360009 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360013 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360017 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360020 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360024 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360028 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360032 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360034 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 360041 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 360041 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 360044 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 360048 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360063 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 360085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360090 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360095 */     // GIR_Coverage, 4348,
     /* 360095 */     GIR_EraseRootFromParent_Done,
     /* 360096 */   // Label 7189: @360096
     /* 360096 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(360244), // Rule ID 11126 //
     /* 360101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 360118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360122 */     // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 360122 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 360125 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360129 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360134 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 360140 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 360145 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360150 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 360153 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 360157 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360162 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 360165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 360167 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 360170 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 360174 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360179 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 360182 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 360185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 360187 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 360190 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 360194 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360199 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 360202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 360207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 360211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360216 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360219 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 360222 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 360225 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 360228 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
     /* 360233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360235 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 360237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360240 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 360242 */     GIR_RootConstrainSelectedInstOperands,
     /* 360243 */     // GIR_Coverage, 11126,
     /* 360243 */     GIR_EraseRootFromParent_Done,
     /* 360244 */   // Label 7190: @360244
     /* 360244 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(360392), // Rule ID 11131 //
     /* 360249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 360252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 360255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 360266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360270 */     // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 360270 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 360273 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360277 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360282 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 360288 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 360293 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360298 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 360301 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 360305 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360310 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 360313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 360315 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 360318 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 360322 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360327 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 360330 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 360333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 360335 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 360338 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 360342 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360347 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 360350 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 360352 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 360355 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 360359 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360364 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 360367 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 360370 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 360373 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 360376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 360381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 360383 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 360385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360388 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 360390 */     GIR_RootConstrainSelectedInstOperands,
     /* 360391 */     // GIR_Coverage, 11131,
     /* 360391 */     GIR_EraseRootFromParent_Done,
     /* 360392 */   // Label 7191: @360392
     /* 360392 */   GIM_Reject,
     /* 360393 */ // Label 7173: @360393
     /* 360393 */ GIM_Reject,
     /* 360394 */ // Label 6938: @360394
     /* 360394 */ GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(361443),
     /* 360399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 360402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 360405 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 360408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360412 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(360528), // Rule ID 4200 //
     /* 360417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360421 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360427 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360437 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360440 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360444 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 360451 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360455 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360459 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360461 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 360468 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 360468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 360471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 360475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360495 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 360517 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 360527 */     // GIR_Coverage, 4200,
     /* 360527 */     GIR_EraseRootFromParent_Done,
     /* 360528 */   // Label 7193: @360528
     /* 360528 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(360644), // Rule ID 4201 //
     /* 360533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360537 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360543 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360553 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360556 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360560 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 360567 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360571 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360577 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 360584 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 360584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 360587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 360591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360596 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360611 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360617 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 360633 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 360643 */     // GIR_Coverage, 4201,
     /* 360643 */     GIR_EraseRootFromParent_Done,
     /* 360644 */   // Label 7194: @360644
     /* 360644 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(360756), // Rule ID 4206 //
     /* 360649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360665 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360668 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360672 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 360679 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360683 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360689 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 360696 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 360696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 360699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 360703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360723 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 360745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360750 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 360755 */     // GIR_Coverage, 4206,
     /* 360755 */     GIR_EraseRootFromParent_Done,
     /* 360756 */   // Label 7195: @360756
     /* 360756 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(360868), // Rule ID 4208 //
     /* 360761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360777 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360780 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360784 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 360791 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360795 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360799 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360801 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 360808 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 360808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 360811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 360815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360820 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360825 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 360830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 360835 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 360857 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360862 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 360867 */     // GIR_Coverage, 4208,
     /* 360867 */     GIR_EraseRootFromParent_Done,
     /* 360868 */   // Label 7196: @360868
     /* 360868 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(360979), // Rule ID 4198 //
     /* 360873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360877 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360883 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 360889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360893 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360896 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360900 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 360907 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 360911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360915 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360917 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 360924 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 360924 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 360927 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 360931 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 360941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 360946 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360959 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 360962 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 360968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 360978 */     // GIR_Coverage, 4198,
     /* 360978 */     GIR_EraseRootFromParent_Done,
     /* 360979 */   // Label 7197: @360979
     /* 360979 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(361090), // Rule ID 4199 //
     /* 360984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360988 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 360994 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 360996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361004 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361007 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361011 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 361018 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361026 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361028 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 361035 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 361035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 361038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 361042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361052 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361057 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361063 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 361079 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361084 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 361089 */     // GIR_Coverage, 4199,
     /* 361089 */     GIR_EraseRootFromParent_Done,
     /* 361090 */   // Label 7198: @361090
     /* 361090 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(361197), // Rule ID 4202 //
     /* 361095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361111 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361114 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361118 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 361125 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361135 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 361142 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 361142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 361145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 361149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361164 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361170 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 361186 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361191 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 361196 */     // GIR_Coverage, 4202,
     /* 361196 */     GIR_EraseRootFromParent_Done,
     /* 361197 */   // Label 7199: @361197
     /* 361197 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(361304), // Rule ID 4204 //
     /* 361202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361218 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361221 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361225 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 361232 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361240 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361242 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 361249 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 361249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 361252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 361256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 361271 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 361293 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 361303 */     // GIR_Coverage, 4204,
     /* 361303 */     GIR_EraseRootFromParent_Done,
     /* 361304 */   // Label 7200: @361304
     /* 361304 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(361442), // Rule ID 11125 //
     /* 361309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 361316 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 361320 */     // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 361320 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 361323 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361327 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361332 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 361338 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 361343 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 361348 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 361351 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 361355 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361360 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 361363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 361365 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 361368 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
     /* 361372 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361377 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 361380 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 361383 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 361385 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 361388 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 361392 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361397 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 361400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 361402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 361405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
     /* 361409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361414 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 361417 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 361420 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 361423 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 361426 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
     /* 361431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 361433 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 361435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361438 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 361440 */     GIR_RootConstrainSelectedInstOperands,
     /* 361441 */     // GIR_Coverage, 11125,
     /* 361441 */     GIR_EraseRootFromParent_Done,
     /* 361442 */   // Label 7201: @361442
     /* 361442 */   GIM_Reject,
     /* 361443 */ // Label 7192: @361443
     /* 361443 */ GIM_Reject,
     /* 361444 */ // Label 6939: @361444
     /* 361444 */ GIM_Reject,
     /* 361445 */ // Label 89: @361445
     /* 361445 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7205*/ GIMT_Encode4(364362),
     /* 361456 */ /*GILLT_s16*//*Label 7202*/ GIMT_Encode4(361468),
     /* 361460 */ /*GILLT_s32*//*Label 7203*/ GIMT_Encode4(362102),
     /* 361464 */ /*GILLT_s64*//*Label 7204*/ GIMT_Encode4(363695),
     /* 361468 */ // Label 7202: @361468
     /* 361468 */ GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(361512), // Rule ID 11174 //
     /* 361473 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 361479 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361486 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361490 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
     /* 361490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361495 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 361501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361506 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361511 */   // GIR_Coverage, 11174,
     /* 361511 */   GIR_EraseRootFromParent_Done,
     /* 361512 */ // Label 7206: @361512
     /* 361512 */ GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(361556), // Rule ID 11175 //
     /* 361517 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361520 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 361523 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361530 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361534 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
     /* 361534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361539 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 361545 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361550 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361555 */   // GIR_Coverage, 11175,
     /* 361555 */   GIR_EraseRootFromParent_Done,
     /* 361556 */ // Label 7207: @361556
     /* 361556 */ GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(361600), // Rule ID 11176 //
     /* 361561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 361567 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361570 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361574 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361578 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
     /* 361578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361583 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 361589 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361594 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361599 */   // GIR_Coverage, 11176,
     /* 361599 */   GIR_EraseRootFromParent_Done,
     /* 361600 */ // Label 7208: @361600
     /* 361600 */ GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(361645), // Rule ID 5746 //
     /* 361605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 361608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361619 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 361623 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
     /* 361623 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361626 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361628 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 361634 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361639 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361644 */   // GIR_Coverage, 5746,
     /* 361644 */   GIR_EraseRootFromParent_Done,
     /* 361645 */ // Label 7209: @361645
     /* 361645 */ GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(361690), // Rule ID 5749 //
     /* 361650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 361653 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361660 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361664 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361668 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361672 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 361676 */   // MIs[1] Operand 1
     /* 361676 */   // No operand predicates
     /* 361676 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361678 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 361678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 361681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361683 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361685 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 361688 */   GIR_RootConstrainSelectedInstOperands,
     /* 361689 */   // GIR_Coverage, 5749,
     /* 361689 */   GIR_EraseRootFromParent_Done,
     /* 361690 */ // Label 7210: @361690
     /* 361690 */ GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(361766), // Rule ID 11149 //
     /* 361695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 361701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361708 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361712 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361716 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 361720 */   // MIs[1] Operand 1
     /* 361720 */   // No operand predicates
     /* 361720 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361722 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
     /* 361722 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 361725 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 361729 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361734 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 361738 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 361741 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361746 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361748 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 361755 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361760 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361765 */   // GIR_Coverage, 11149,
     /* 361765 */   GIR_EraseRootFromParent_Done,
     /* 361766 */ // Label 7211: @361766
     /* 361766 */ GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(361842), // Rule ID 11150 //
     /* 361771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 361777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361784 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361788 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361792 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 361796 */   // MIs[1] Operand 1
     /* 361796 */   // No operand predicates
     /* 361796 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361798 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
     /* 361798 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 361801 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 361805 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361810 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 361814 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 361817 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361822 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361824 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 361831 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361836 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361841 */   // GIR_Coverage, 11150,
     /* 361841 */   GIR_EraseRootFromParent_Done,
     /* 361842 */ // Label 7212: @361842
     /* 361842 */ GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(361918), // Rule ID 11151 //
     /* 361847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 361853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361860 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361864 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361868 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 361872 */   // MIs[1] Operand 1
     /* 361872 */   // No operand predicates
     /* 361872 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361874 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
     /* 361874 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 361877 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 361881 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361886 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 361890 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 361893 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361895 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 361898 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361900 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 361907 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361912 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 361917 */   // GIR_Coverage, 11151,
     /* 361917 */   GIR_EraseRootFromParent_Done,
     /* 361918 */ // Label 7213: @361918
     /* 361918 */ GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(361979), // Rule ID 11139 //
     /* 361923 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 361929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 361940 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
     /* 361940 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 361943 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 361947 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361952 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 361958 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 361962 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 361965 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 361970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 361972 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361975 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 361977 */   GIR_RootConstrainSelectedInstOperands,
     /* 361978 */   // GIR_Coverage, 11139,
     /* 361978 */   GIR_EraseRootFromParent_Done,
     /* 361979 */ // Label 7214: @361979
     /* 361979 */ GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(362040), // Rule ID 11140 //
     /* 361984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 361987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 361990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 361993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361997 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362001 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
     /* 362001 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 362004 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 362008 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362013 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 362019 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 362023 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 362026 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 362031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 362033 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362036 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 362038 */   GIR_RootConstrainSelectedInstOperands,
     /* 362039 */   // GIR_Coverage, 11140,
     /* 362039 */   GIR_EraseRootFromParent_Done,
     /* 362040 */ // Label 7215: @362040
     /* 362040 */ GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(362101), // Rule ID 11141 //
     /* 362045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 362051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362058 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 362062 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
     /* 362062 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 362065 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 362069 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362074 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 362080 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 362084 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 362087 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 362092 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 362094 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362097 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 362099 */   GIR_RootConstrainSelectedInstOperands,
     /* 362100 */   // GIR_Coverage, 11141,
     /* 362100 */   GIR_EraseRootFromParent_Done,
     /* 362101 */ // Label 7216: @362101
     /* 362101 */ GIM_Reject,
     /* 362102 */ // Label 7203: @362102
     /* 362102 */ GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(362147), // Rule ID 6931 //
     /* 362107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362121 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362125 */   // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
     /* 362125 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362128 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362130 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 362136 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362141 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362146 */   // GIR_Coverage, 6931,
     /* 362146 */   GIR_EraseRootFromParent_Done,
     /* 362147 */ // Label 7217: @362147
     /* 362147 */ GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(362192), // Rule ID 6932 //
     /* 362152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 362155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362166 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362170 */   // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
     /* 362170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362175 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 362181 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362186 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362191 */   // GIR_Coverage, 6932,
     /* 362191 */   GIR_EraseRootFromParent_Done,
     /* 362192 */ // Label 7218: @362192
     /* 362192 */ GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(362236), // Rule ID 11170 //
     /* 362197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 362203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362210 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362214 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
     /* 362214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362219 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 362225 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362230 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362235 */   // GIR_Coverage, 11170,
     /* 362235 */   GIR_EraseRootFromParent_Done,
     /* 362236 */ // Label 7219: @362236
     /* 362236 */ GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(362280), // Rule ID 11171 //
     /* 362241 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 362247 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362254 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362258 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
     /* 362258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362263 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 362269 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362274 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362279 */   // GIR_Coverage, 11171,
     /* 362279 */   GIR_EraseRootFromParent_Done,
     /* 362280 */ // Label 7220: @362280
     /* 362280 */ GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(362324), // Rule ID 11172 //
     /* 362285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 362291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362298 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362302 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
     /* 362302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362307 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 362313 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362318 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362323 */   // GIR_Coverage, 11172,
     /* 362323 */   GIR_EraseRootFromParent_Done,
     /* 362324 */ // Label 7221: @362324
     /* 362324 */ GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(362368), // Rule ID 11177 //
     /* 362329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 362335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362342 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362346 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
     /* 362346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362351 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 362357 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362367 */   // GIR_Coverage, 11177,
     /* 362367 */   GIR_EraseRootFromParent_Done,
     /* 362368 */ // Label 7222: @362368
     /* 362368 */ GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(362412), // Rule ID 11178 //
     /* 362373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 362376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 362379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362386 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362390 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
     /* 362390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362393 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362395 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 362401 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362406 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362411 */   // GIR_Coverage, 11178,
     /* 362411 */   GIR_EraseRootFromParent_Done,
     /* 362412 */ // Label 7223: @362412
     /* 362412 */ GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(362457), // Rule ID 5745 //
     /* 362417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362420 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362423 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362427 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362431 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 362435 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
     /* 362435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362440 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 362446 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362451 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362456 */   // GIR_Coverage, 5745,
     /* 362456 */   GIR_EraseRootFromParent_Done,
     /* 362457 */ // Label 7224: @362457
     /* 362457 */ GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(362530), // Rule ID 11155 //
     /* 362462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 362468 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362475 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362479 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362483 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 362487 */   // MIs[1] Operand 1
     /* 362487 */   // No operand predicates
     /* 362487 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362489 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 362489 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 362492 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362496 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362501 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 362507 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362512 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362517 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 362520 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362522 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362525 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 362528 */   GIR_RootConstrainSelectedInstOperands,
     /* 362529 */   // GIR_Coverage, 11155,
     /* 362529 */   GIR_EraseRootFromParent_Done,
     /* 362530 */ // Label 7225: @362530
     /* 362530 */ GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(362603), // Rule ID 11156 //
     /* 362535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 362541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362548 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362552 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362556 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362560 */   // MIs[1] Operand 1
     /* 362560 */   // No operand predicates
     /* 362560 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362562 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 362562 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 362565 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362569 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362574 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 362580 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362585 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 362593 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362595 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362598 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 362601 */   GIR_RootConstrainSelectedInstOperands,
     /* 362602 */   // GIR_Coverage, 11156,
     /* 362602 */   GIR_EraseRootFromParent_Done,
     /* 362603 */ // Label 7226: @362603
     /* 362603 */ GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(362676), // Rule ID 11157 //
     /* 362608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 362614 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362621 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362625 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362629 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 362633 */   // MIs[1] Operand 1
     /* 362633 */   // No operand predicates
     /* 362633 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362635 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 362635 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 362638 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 362642 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362647 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 362653 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362658 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 362663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 362666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362668 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362671 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 362674 */   GIR_RootConstrainSelectedInstOperands,
     /* 362675 */   // GIR_Coverage, 11157,
     /* 362675 */   GIR_EraseRootFromParent_Done,
     /* 362676 */ // Label 7227: @362676
     /* 362676 */ GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(362724), // Rule ID 1926 //
     /* 362681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 362684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 362687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362698 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362702 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362706 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 362710 */   // MIs[1] Operand 1
     /* 362710 */   // No operand predicates
     /* 362710 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362712 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 362712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
     /* 362715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362717 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362719 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 362722 */   GIR_RootConstrainSelectedInstOperands,
     /* 362723 */   // GIR_Coverage, 1926,
     /* 362723 */   GIR_EraseRootFromParent_Done,
     /* 362724 */ // Label 7228: @362724
     /* 362724 */ GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(362772), // Rule ID 1927 //
     /* 362729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 362732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362742 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362746 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362750 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362754 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 362758 */   // MIs[1] Operand 1
     /* 362758 */   // No operand predicates
     /* 362758 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362760 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 362760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
     /* 362763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362765 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362767 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 362770 */   GIR_RootConstrainSelectedInstOperands,
     /* 362771 */   // GIR_Coverage, 1927,
     /* 362771 */   GIR_EraseRootFromParent_Done,
     /* 362772 */ // Label 7229: @362772
     /* 362772 */ GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(362820), // Rule ID 1928 //
     /* 362777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 362780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362783 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362794 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362798 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362802 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 362806 */   // MIs[1] Operand 1
     /* 362806 */   // No operand predicates
     /* 362806 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362808 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 362808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
     /* 362811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362813 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362815 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 362818 */   GIR_RootConstrainSelectedInstOperands,
     /* 362819 */   // GIR_Coverage, 1928,
     /* 362819 */   GIR_EraseRootFromParent_Done,
     /* 362820 */ // Label 7230: @362820
     /* 362820 */ GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(362868), // Rule ID 1930 //
     /* 362825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 362831 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362842 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362846 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362850 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 362854 */   // MIs[1] Operand 1
     /* 362854 */   // No operand predicates
     /* 362854 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362856 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 362856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 362859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362861 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362863 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 362866 */   GIR_RootConstrainSelectedInstOperands,
     /* 362867 */   // GIR_Coverage, 1930,
     /* 362867 */   GIR_EraseRootFromParent_Done,
     /* 362868 */ // Label 7231: @362868
     /* 362868 */ GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(362916), // Rule ID 1931 //
     /* 362873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 362879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362890 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362898 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 362902 */   // MIs[1] Operand 1
     /* 362902 */   // No operand predicates
     /* 362902 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362904 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 362904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 362907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362909 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362911 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 362914 */   GIR_RootConstrainSelectedInstOperands,
     /* 362915 */   // GIR_Coverage, 1931,
     /* 362915 */   GIR_EraseRootFromParent_Done,
     /* 362916 */ // Label 7232: @362916
     /* 362916 */ GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(362964), // Rule ID 1932 //
     /* 362921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 362924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 362934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362938 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362942 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362946 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 362950 */   // MIs[1] Operand 1
     /* 362950 */   // No operand predicates
     /* 362950 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362952 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 362952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 362955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 362957 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 362959 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 362962 */   GIR_RootConstrainSelectedInstOperands,
     /* 362963 */   // GIR_Coverage, 1932,
     /* 362963 */   GIR_EraseRootFromParent_Done,
     /* 362964 */ // Label 7233: @362964
     /* 362964 */ GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(363009), // Rule ID 5748 //
     /* 362969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 362972 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 362975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 362979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 362983 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 362987 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 362991 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 362995 */   // MIs[1] Operand 1
     /* 362995 */   // No operand predicates
     /* 362995 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 362997 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 362997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 363000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363002 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363004 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 363007 */   GIR_RootConstrainSelectedInstOperands,
     /* 363008 */   // GIR_Coverage, 5748,
     /* 363008 */   GIR_EraseRootFromParent_Done,
     /* 363009 */ // Label 7234: @363009
     /* 363009 */ GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(363085), // Rule ID 11145 //
     /* 363014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 363020 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363027 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363031 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363035 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 363039 */   // MIs[1] Operand 1
     /* 363039 */   // No operand predicates
     /* 363039 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363041 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
     /* 363041 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 363044 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 363048 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363053 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 363057 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 363060 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363065 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363067 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 363074 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363079 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363084 */   // GIR_Coverage, 11145,
     /* 363084 */   GIR_EraseRootFromParent_Done,
     /* 363085 */ // Label 7235: @363085
     /* 363085 */ GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(363161), // Rule ID 11146 //
     /* 363090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 363096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363103 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363107 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363111 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 363115 */   // MIs[1] Operand 1
     /* 363115 */   // No operand predicates
     /* 363115 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363117 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
     /* 363117 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 363120 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 363124 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363129 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 363133 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 363136 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363143 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 363150 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363155 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363160 */   // GIR_Coverage, 11146,
     /* 363160 */   GIR_EraseRootFromParent_Done,
     /* 363161 */ // Label 7236: @363161
     /* 363161 */ GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(363237), // Rule ID 11147 //
     /* 363166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 363172 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363175 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363179 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363183 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363187 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 363191 */   // MIs[1] Operand 1
     /* 363191 */   // No operand predicates
     /* 363191 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363193 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 363193 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 363196 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 363200 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363205 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 363209 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 363212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363219 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 363226 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363231 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363236 */   // GIR_Coverage, 11147,
     /* 363236 */   GIR_EraseRootFromParent_Done,
     /* 363237 */ // Label 7237: @363237
     /* 363237 */ GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(363313), // Rule ID 11152 //
     /* 363242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 363248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363255 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363259 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363263 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 363267 */   // MIs[1] Operand 1
     /* 363267 */   // No operand predicates
     /* 363267 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363269 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 363269 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 363272 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 363276 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363281 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 363285 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 363288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363295 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 363302 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363307 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363312 */   // GIR_Coverage, 11152,
     /* 363312 */   GIR_EraseRootFromParent_Done,
     /* 363313 */ // Label 7238: @363313
     /* 363313 */ GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(363389), // Rule ID 11153 //
     /* 363318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 363324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363331 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363335 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363339 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 363343 */   // MIs[1] Operand 1
     /* 363343 */   // No operand predicates
     /* 363343 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363345 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
     /* 363345 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 363348 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 363352 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363357 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 363361 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 363364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363371 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 363378 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363383 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363388 */   // GIR_Coverage, 11153,
     /* 363388 */   GIR_EraseRootFromParent_Done,
     /* 363389 */ // Label 7239: @363389
     /* 363389 */ GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(363450), // Rule ID 11135 //
     /* 363394 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 363400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 363407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363411 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
     /* 363411 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 363414 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 363418 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363423 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 363429 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 363433 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 363436 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
     /* 363441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363443 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363446 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 363448 */   GIR_RootConstrainSelectedInstOperands,
     /* 363449 */   // GIR_Coverage, 11135,
     /* 363449 */   GIR_EraseRootFromParent_Done,
     /* 363450 */ // Label 7240: @363450
     /* 363450 */ GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(363511), // Rule ID 11136 //
     /* 363455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 363461 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 363468 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363472 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
     /* 363472 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 363475 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 363479 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363484 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 363490 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 363494 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 363497 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
     /* 363502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363504 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363507 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 363509 */   GIR_RootConstrainSelectedInstOperands,
     /* 363510 */   // GIR_Coverage, 11136,
     /* 363510 */   GIR_EraseRootFromParent_Done,
     /* 363511 */ // Label 7241: @363511
     /* 363511 */ GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(363572), // Rule ID 11137 //
     /* 363516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 363522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 363529 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363533 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
     /* 363533 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 363536 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 363540 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363545 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 363551 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 363555 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 363558 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
     /* 363563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363565 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363568 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 363570 */   GIR_RootConstrainSelectedInstOperands,
     /* 363571 */   // GIR_Coverage, 11137,
     /* 363571 */   GIR_EraseRootFromParent_Done,
     /* 363572 */ // Label 7242: @363572
     /* 363572 */ GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(363633), // Rule ID 11142 //
     /* 363577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 363583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363590 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363594 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
     /* 363594 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 363597 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 363601 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363606 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 363612 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 363616 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 363619 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363621 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 363624 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 363626 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363629 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 363631 */   GIR_RootConstrainSelectedInstOperands,
     /* 363632 */   // GIR_Coverage, 11142,
     /* 363632 */   GIR_EraseRootFromParent_Done,
     /* 363633 */ // Label 7243: @363633
     /* 363633 */ GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(363694), // Rule ID 11143 //
     /* 363638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 363644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 363651 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363655 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
     /* 363655 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 363658 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 363662 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363667 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 363673 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 363677 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 363680 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 363685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 363687 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363690 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 363692 */   GIR_RootConstrainSelectedInstOperands,
     /* 363693 */   // GIR_Coverage, 11143,
     /* 363693 */   GIR_EraseRootFromParent_Done,
     /* 363694 */ // Label 7244: @363694
     /* 363694 */ GIM_Reject,
     /* 363695 */ // Label 7204: @363695
     /* 363695 */ GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(363740), // Rule ID 6930 //
     /* 363700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 363703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363714 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 363718 */   // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
     /* 363718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363723 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
     /* 363729 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363734 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363739 */   // GIR_Coverage, 6930,
     /* 363739 */   GIR_EraseRootFromParent_Done,
     /* 363740 */ // Label 7245: @363740
     /* 363740 */ GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(363784), // Rule ID 11173 //
     /* 363745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 363751 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363758 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 363762 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
     /* 363762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363767 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 363773 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363778 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363783 */   // GIR_Coverage, 11173,
     /* 363783 */   GIR_EraseRootFromParent_Done,
     /* 363784 */ // Label 7246: @363784
     /* 363784 */ GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(363828), // Rule ID 11179 //
     /* 363789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 363792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 363795 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363802 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 363806 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
     /* 363806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363811 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 363817 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363822 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363827 */   // GIR_Coverage, 11179,
     /* 363827 */   GIR_EraseRootFromParent_Done,
     /* 363828 */ // Label 7247: @363828
     /* 363828 */ GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(363873), // Rule ID 5744 //
     /* 363833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 363836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363847 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 363851 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 363851 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363854 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363856 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 363862 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363867 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363872 */   // GIR_Coverage, 5744,
     /* 363872 */   GIR_EraseRootFromParent_Done,
     /* 363873 */ // Label 7248: @363873
     /* 363873 */ GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(363946), // Rule ID 11158 //
     /* 363878 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 363884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363891 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363895 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363899 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 363903 */   // MIs[1] Operand 1
     /* 363903 */   // No operand predicates
     /* 363903 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363905 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
     /* 363905 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 363908 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363912 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363917 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 363923 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363928 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 363933 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 363936 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363938 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363941 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 363944 */   GIR_RootConstrainSelectedInstOperands,
     /* 363945 */   // GIR_Coverage, 11158,
     /* 363945 */   GIR_EraseRootFromParent_Done,
     /* 363946 */ // Label 7249: @363946
     /* 363946 */ GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(363994), // Rule ID 1929 //
     /* 363951 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 363954 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 363957 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 363960 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 363964 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363968 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363972 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363976 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 363980 */   // MIs[1] Operand 1
     /* 363980 */   // No operand predicates
     /* 363980 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363982 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 363982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
     /* 363985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 363987 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 363989 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 363992 */   GIR_RootConstrainSelectedInstOperands,
     /* 363993 */   // GIR_Coverage, 1929,
     /* 363993 */   GIR_EraseRootFromParent_Done,
     /* 363994 */ // Label 7250: @363994
     /* 363994 */ GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(364042), // Rule ID 1933 //
     /* 363999 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 364005 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364016 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364020 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364024 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 364028 */   // MIs[1] Operand 1
     /* 364028 */   // No operand predicates
     /* 364028 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364030 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 364030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 364033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364035 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 364037 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 364040 */   GIR_RootConstrainSelectedInstOperands,
     /* 364041 */   // GIR_Coverage, 1933,
     /* 364041 */   GIR_EraseRootFromParent_Done,
     /* 364042 */ // Label 7251: @364042
     /* 364042 */ GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(364087), // Rule ID 5747 //
     /* 364047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 364050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364061 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364065 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364069 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 364073 */   // MIs[1] Operand 1
     /* 364073 */   // No operand predicates
     /* 364073 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364075 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 364075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 364078 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364080 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 364082 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 364085 */   GIR_RootConstrainSelectedInstOperands,
     /* 364086 */   // GIR_Coverage, 5747,
     /* 364086 */   GIR_EraseRootFromParent_Done,
     /* 364087 */ // Label 7252: @364087
     /* 364087 */ GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(364163), // Rule ID 11148 //
     /* 364092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 364098 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364101 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364105 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364109 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364113 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 364117 */   // MIs[1] Operand 1
     /* 364117 */   // No operand predicates
     /* 364117 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364119 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 364119 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 364122 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 364126 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364131 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 364135 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 364138 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364140 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364143 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364145 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364152 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364157 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364162 */   // GIR_Coverage, 11148,
     /* 364162 */   GIR_EraseRootFromParent_Done,
     /* 364163 */ // Label 7253: @364163
     /* 364163 */ GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(364239), // Rule ID 11154 //
     /* 364168 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 364174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364181 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364185 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364189 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 364193 */   // MIs[1] Operand 1
     /* 364193 */   // No operand predicates
     /* 364193 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364195 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 364195 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 364198 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 364202 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364207 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 364211 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 364214 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364216 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364219 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364221 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364228 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364233 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364238 */   // GIR_Coverage, 11154,
     /* 364238 */   GIR_EraseRootFromParent_Done,
     /* 364239 */ // Label 7254: @364239
     /* 364239 */ GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(364300), // Rule ID 11138 //
     /* 364244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 364250 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364257 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364261 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
     /* 364261 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 364264 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 364268 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364273 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 364279 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 364283 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 364286 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
     /* 364291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 364293 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364296 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 364298 */   GIR_RootConstrainSelectedInstOperands,
     /* 364299 */   // GIR_Coverage, 11138,
     /* 364299 */   GIR_EraseRootFromParent_Done,
     /* 364300 */ // Label 7255: @364300
     /* 364300 */ GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(364361), // Rule ID 11144 //
     /* 364305 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 364311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 364314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364318 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 364322 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
     /* 364322 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 364325 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 364329 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364334 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 364340 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 364344 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 364347 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
     /* 364352 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 364354 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364357 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 364359 */   GIR_RootConstrainSelectedInstOperands,
     /* 364360 */   // GIR_Coverage, 11144,
     /* 364360 */   GIR_EraseRootFromParent_Done,
     /* 364361 */ // Label 7256: @364361
     /* 364361 */ GIM_Reject,
     /* 364362 */ // Label 7205: @364362
     /* 364362 */ GIM_Reject,
     /* 364363 */ // Label 90: @364363
     /* 364363 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7264*/ GIMT_Encode4(366682),
     /* 364374 */ /*GILLT_nxv2s16*//*Label 7257*/ GIMT_Encode4(364414),
     /* 364378 */ /*GILLT_nxv2s32*//*Label 7258*/ GIMT_Encode4(364773),
     /* 364382 */ /*GILLT_nxv2s64*//*Label 7259*/ GIMT_Encode4(365075), GIMT_Encode4(0),
     /* 364390 */ /*GILLT_nxv4s16*//*Label 7260*/ GIMT_Encode4(365450),
     /* 364394 */ /*GILLT_nxv4s32*//*Label 7261*/ GIMT_Encode4(365752), GIMT_Encode4(0),
     /* 364402 */ /*GILLT_nxv8s16*//*Label 7262*/ GIMT_Encode4(366127), GIMT_Encode4(0),
     /* 364410 */ /*GILLT_nxv16s8*//*Label 7263*/ GIMT_Encode4(366538),
     /* 364414 */ // Label 7257: @364414
     /* 364414 */ GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(364772),
     /* 364419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 364422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364426 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(364490), // Rule ID 5978 //
     /* 364431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 364442 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 364446 */     // MIs[1] Operand 1
     /* 364446 */     // No operand predicates
     /* 364446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364448 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 364448 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364451 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 364455 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364460 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 364463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364470 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 364479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364489 */     // GIR_Coverage, 5978,
     /* 364489 */     GIR_EraseRootFromParent_Done,
     /* 364490 */   // Label 7266: @364490
     /* 364490 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(364547), // Rule ID 2673 //
     /* 364495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 364510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364527 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 364531 */     // MIs[2] Operand 1
     /* 364531 */     // No operand predicates
     /* 364531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364533 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 364533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 364536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 364542 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 364545 */     GIR_RootConstrainSelectedInstOperands,
     /* 364546 */     // GIR_Coverage, 2673,
     /* 364546 */     GIR_EraseRootFromParent_Done,
     /* 364547 */   // Label 7267: @364547
     /* 364547 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(364604), // Rule ID 2675 //
     /* 364552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 364567 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364580 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364584 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 364588 */     // MIs[2] Operand 1
     /* 364588 */     // No operand predicates
     /* 364588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364590 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 364590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 364593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 364599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 364602 */     GIR_RootConstrainSelectedInstOperands,
     /* 364603 */     // GIR_Coverage, 2675,
     /* 364603 */     GIR_EraseRootFromParent_Done,
     /* 364604 */   // Label 7268: @364604
     /* 364604 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(364661), // Rule ID 8290 //
     /* 364609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 364624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364641 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 364645 */     // MIs[2] Operand 1
     /* 364645 */     // No operand predicates
     /* 364645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364647 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 364647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 364650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 364656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 364659 */     GIR_RootConstrainSelectedInstOperands,
     /* 364660 */     // GIR_Coverage, 8290,
     /* 364660 */     GIR_EraseRootFromParent_Done,
     /* 364661 */   // Label 7269: @364661
     /* 364661 */   GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(364695), // Rule ID 8333 //
     /* 364666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 364677 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 364681 */     // MIs[1] Operand 1
     /* 364681 */     // No operand predicates
     /* 364681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364683 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 364683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 364686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364688 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 364693 */     GIR_RootConstrainSelectedInstOperands,
     /* 364694 */     // GIR_Coverage, 8333,
     /* 364694 */     GIR_EraseRootFromParent_Done,
     /* 364695 */   // Label 7270: @364695
     /* 364695 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(364771), // Rule ID 8311 //
     /* 364700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364707 */     // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 364707 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 364710 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364714 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 364721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 364724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364733 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364736 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 364740 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 364743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364753 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 364761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364763 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364769 */     GIR_RootConstrainSelectedInstOperands,
     /* 364770 */     // GIR_Coverage, 8311,
     /* 364770 */     GIR_EraseRootFromParent_Done,
     /* 364771 */   // Label 7271: @364771
     /* 364771 */   GIM_Reject,
     /* 364772 */ // Label 7265: @364772
     /* 364772 */ GIM_Reject,
     /* 364773 */ // Label 7258: @364773
     /* 364773 */ GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(365074),
     /* 364778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 364781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364785 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(364849), // Rule ID 5976 //
     /* 364790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 364793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 364801 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 364805 */     // MIs[1] Operand 1
     /* 364805 */     // No operand predicates
     /* 364805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364807 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 364807 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364810 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 364814 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364819 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 364822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 364838 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364843 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364848 */     // GIR_Coverage, 5976,
     /* 364848 */     GIR_EraseRootFromParent_Done,
     /* 364849 */   // Label 7273: @364849
     /* 364849 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(364906), // Rule ID 8299 //
     /* 364854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364857 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364861 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364865 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 364869 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364878 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364882 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364886 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 364890 */     // MIs[2] Operand 1
     /* 364890 */     // No operand predicates
     /* 364890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364892 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 364892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 364895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 364901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 364904 */     GIR_RootConstrainSelectedInstOperands,
     /* 364905 */     // GIR_Coverage, 8299,
     /* 364905 */     GIR_EraseRootFromParent_Done,
     /* 364906 */   // Label 7274: @364906
     /* 364906 */   GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(364963), // Rule ID 8308 //
     /* 364911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 364922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 364926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 364930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 364935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 364939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364943 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 364947 */     // MIs[2] Operand 1
     /* 364947 */     // No operand predicates
     /* 364947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364949 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 364949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 364952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 364958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 364961 */     GIR_RootConstrainSelectedInstOperands,
     /* 364962 */     // GIR_Coverage, 8308,
     /* 364962 */     GIR_EraseRootFromParent_Done,
     /* 364963 */   // Label 7275: @364963
     /* 364963 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(364997), // Rule ID 8335 //
     /* 364968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 364971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 364979 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 364983 */     // MIs[1] Operand 1
     /* 364983 */     // No operand predicates
     /* 364983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364985 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 364985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 364988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 364990 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 364995 */     GIR_RootConstrainSelectedInstOperands,
     /* 364996 */     // GIR_Coverage, 8335,
     /* 364996 */     GIR_EraseRootFromParent_Done,
     /* 364997 */   // Label 7276: @364997
     /* 364997 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(365073), // Rule ID 8313 //
     /* 365002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365009 */     // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 365009 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 365012 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365016 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365021 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365023 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 365026 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365030 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365035 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365038 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 365042 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 365045 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365050 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365055 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 365063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365065 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365071 */     GIR_RootConstrainSelectedInstOperands,
     /* 365072 */     // GIR_Coverage, 8313,
     /* 365072 */     GIR_EraseRootFromParent_Done,
     /* 365073 */   // Label 7277: @365073
     /* 365073 */   GIM_Reject,
     /* 365074 */ // Label 7272: @365074
     /* 365074 */ GIM_Reject,
     /* 365075 */ // Label 7259: @365075
     /* 365075 */ GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(365449),
     /* 365080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 365083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365087 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(365141), // Rule ID 5971 //
     /* 365092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365095 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 365099 */     // (splat_vector:{ *:[nxv2i64] } 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 365099 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365102 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 365106 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365111 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365114 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365124 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 365130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365135 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365140 */     // GIR_Coverage, 5971,
     /* 365140 */     GIR_EraseRootFromParent_Done,
     /* 365141 */   // Label 7279: @365141
     /* 365141 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(365205), // Rule ID 5975 //
     /* 365146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365157 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 365161 */     // MIs[1] Operand 1
     /* 365161 */     // No operand predicates
     /* 365161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365163 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 365163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 365170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365175 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365178 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 365194 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365199 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365204 */     // GIR_Coverage, 5975,
     /* 365204 */     GIR_EraseRootFromParent_Done,
     /* 365205 */   // Label 7280: @365205
     /* 365205 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(365262), // Rule ID 2670 //
     /* 365210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 365225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365229 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365234 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365238 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365242 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 365246 */     // MIs[2] Operand 1
     /* 365246 */     // No operand predicates
     /* 365246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365248 */     // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 365248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 365251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365260 */     GIR_RootConstrainSelectedInstOperands,
     /* 365261 */     // GIR_Coverage, 2670,
     /* 365261 */     GIR_EraseRootFromParent_Done,
     /* 365262 */   // Label 7281: @365262
     /* 365262 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(365319), // Rule ID 8305 //
     /* 365267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 365282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365299 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 365303 */     // MIs[2] Operand 1
     /* 365303 */     // No operand predicates
     /* 365303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365305 */     // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 365305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 365308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365317 */     GIR_RootConstrainSelectedInstOperands,
     /* 365318 */     // GIR_Coverage, 8305,
     /* 365318 */     GIR_EraseRootFromParent_Done,
     /* 365319 */   // Label 7282: @365319
     /* 365319 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(365353), // Rule ID 8336 //
     /* 365324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365335 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 365339 */     // MIs[1] Operand 1
     /* 365339 */     // No operand predicates
     /* 365339 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365341 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 365341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
     /* 365344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365346 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 365351 */     GIR_RootConstrainSelectedInstOperands,
     /* 365352 */     // GIR_Coverage, 8336,
     /* 365352 */     GIR_EraseRootFromParent_Done,
     /* 365353 */   // Label 7283: @365353
     /* 365353 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(365372), // Rule ID 2389 //
     /* 365358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 365365 */     // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 365365 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 365370 */     GIR_RootConstrainSelectedInstOperands,
     /* 365371 */     // GIR_Coverage, 2389,
     /* 365371 */     GIR_Done,
     /* 365372 */   // Label 7284: @365372
     /* 365372 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(365448), // Rule ID 8314 //
     /* 365377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365384 */     // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 365384 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 365387 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365391 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 365401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365410 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365413 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 365417 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 365420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 365435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 365438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365440 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365446 */     GIR_RootConstrainSelectedInstOperands,
     /* 365447 */     // GIR_Coverage, 8314,
     /* 365447 */     GIR_EraseRootFromParent_Done,
     /* 365448 */   // Label 7285: @365448
     /* 365448 */   GIM_Reject,
     /* 365449 */ // Label 7278: @365449
     /* 365449 */ GIM_Reject,
     /* 365450 */ // Label 7260: @365450
     /* 365450 */ GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(365751),
     /* 365455 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 365458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365462 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(365526), // Rule ID 5979 //
     /* 365467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365478 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 365482 */     // MIs[1] Operand 1
     /* 365482 */     // No operand predicates
     /* 365482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365484 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 365484 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365487 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 365491 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365496 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 365515 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365520 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365525 */     // GIR_Coverage, 5979,
     /* 365525 */     GIR_EraseRootFromParent_Done,
     /* 365526 */   // Label 7287: @365526
     /* 365526 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(365583), // Rule ID 2674 //
     /* 365531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 365546 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365563 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 365567 */     // MIs[2] Operand 1
     /* 365567 */     // No operand predicates
     /* 365567 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365569 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 365569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 365572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365581 */     GIR_RootConstrainSelectedInstOperands,
     /* 365582 */     // GIR_Coverage, 2674,
     /* 365582 */     GIR_EraseRootFromParent_Done,
     /* 365583 */   // Label 7288: @365583
     /* 365583 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(365640), // Rule ID 8293 //
     /* 365588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 365603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365620 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 365624 */     // MIs[2] Operand 1
     /* 365624 */     // No operand predicates
     /* 365624 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365626 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 365626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 365629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365638 */     GIR_RootConstrainSelectedInstOperands,
     /* 365639 */     // GIR_Coverage, 8293,
     /* 365639 */     GIR_EraseRootFromParent_Done,
     /* 365640 */   // Label 7289: @365640
     /* 365640 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(365674), // Rule ID 8332 //
     /* 365645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365656 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 365660 */     // MIs[1] Operand 1
     /* 365660 */     // No operand predicates
     /* 365660 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365662 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 365662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 365665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365667 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 365672 */     GIR_RootConstrainSelectedInstOperands,
     /* 365673 */     // GIR_Coverage, 8332,
     /* 365673 */     GIR_EraseRootFromParent_Done,
     /* 365674 */   // Label 7290: @365674
     /* 365674 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(365750), // Rule ID 8310 //
     /* 365679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365686 */     // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 365686 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 365689 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 365693 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 365700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 365703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 365707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365712 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 365715 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 365719 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 365722 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 365737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 365740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365748 */     GIR_RootConstrainSelectedInstOperands,
     /* 365749 */     // GIR_Coverage, 8310,
     /* 365749 */     GIR_EraseRootFromParent_Done,
     /* 365750 */   // Label 7291: @365750
     /* 365750 */   GIM_Reject,
     /* 365751 */ // Label 7286: @365751
     /* 365751 */ GIM_Reject,
     /* 365752 */ // Label 7261: @365752
     /* 365752 */ GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(366126),
     /* 365757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 365760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365764 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(365818), // Rule ID 5972 //
     /* 365769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 365776 */     // (splat_vector:{ *:[nxv4i32] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 365776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 365783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365788 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 365807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365812 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365817 */     // GIR_Coverage, 5972,
     /* 365817 */     GIR_EraseRootFromParent_Done,
     /* 365818 */   // Label 7293: @365818
     /* 365818 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(365882), // Rule ID 5977 //
     /* 365823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 365826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 365834 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 365838 */     // MIs[1] Operand 1
     /* 365838 */     // No operand predicates
     /* 365838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 365840 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 365840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 365843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 365847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365852 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 365855 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 365871 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365881 */     // GIR_Coverage, 5977,
     /* 365881 */     GIR_EraseRootFromParent_Done,
     /* 365882 */   // Label 7294: @365882
     /* 365882 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(365939), // Rule ID 2667 //
     /* 365887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 365902 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365919 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 365923 */     // MIs[2] Operand 1
     /* 365923 */     // No operand predicates
     /* 365923 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365925 */     // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 365925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 365928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365934 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365937 */     GIR_RootConstrainSelectedInstOperands,
     /* 365938 */     // GIR_Coverage, 2667,
     /* 365938 */     GIR_EraseRootFromParent_Done,
     /* 365939 */   // Label 7295: @365939
     /* 365939 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(365996), // Rule ID 8302 //
     /* 365944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 365947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 365955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 365959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 365963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 365968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 365972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 365976 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 365980 */     // MIs[2] Operand 1
     /* 365980 */     // No operand predicates
     /* 365980 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365982 */     // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 365982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 365985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 365987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 365991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 365994 */     GIR_RootConstrainSelectedInstOperands,
     /* 365995 */     // GIR_Coverage, 8302,
     /* 365995 */     GIR_EraseRootFromParent_Done,
     /* 365996 */   // Label 7296: @365996
     /* 365996 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(366030), // Rule ID 8334 //
     /* 366001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 366012 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 366016 */     // MIs[1] Operand 1
     /* 366016 */     // No operand predicates
     /* 366016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366018 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 366018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 366021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 366023 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 366028 */     GIR_RootConstrainSelectedInstOperands,
     /* 366029 */     // GIR_Coverage, 8334,
     /* 366029 */     GIR_EraseRootFromParent_Done,
     /* 366030 */   // Label 7297: @366030
     /* 366030 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(366049), // Rule ID 2388 //
     /* 366035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 366042 */     // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
     /* 366042 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 366047 */     GIR_RootConstrainSelectedInstOperands,
     /* 366048 */     // GIR_Coverage, 2388,
     /* 366048 */     GIR_Done,
     /* 366049 */   // Label 7298: @366049
     /* 366049 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(366125), // Rule ID 8312 //
     /* 366054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366061 */     // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 366061 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 366064 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366068 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 366075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 366078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366087 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 366090 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 366094 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 366097 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366102 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366107 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 366115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 366117 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366123 */     GIR_RootConstrainSelectedInstOperands,
     /* 366124 */     // GIR_Coverage, 8312,
     /* 366124 */     GIR_EraseRootFromParent_Done,
     /* 366125 */   // Label 7299: @366125
     /* 366125 */   GIM_Reject,
     /* 366126 */ // Label 7292: @366126
     /* 366126 */ GIM_Reject,
     /* 366127 */ // Label 7262: @366127
     /* 366127 */ GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(366188), // Rule ID 5973 //
     /* 366132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 366138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366142 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 366146 */   // (splat_vector:{ *:[nxv8i16] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 366146 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 366149 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 366153 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366158 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 366161 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366166 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366168 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366171 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 366177 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366182 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366187 */   // GIR_Coverage, 5973,
     /* 366187 */   GIR_EraseRootFromParent_Done,
     /* 366188 */ // Label 7300: @366188
     /* 366188 */ GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(366259), // Rule ID 5980 //
     /* 366193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 366199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366203 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366207 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 366211 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 366215 */   // MIs[1] Operand 1
     /* 366215 */   // No operand predicates
     /* 366215 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366217 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 366217 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 366220 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 366224 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366229 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 366232 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366234 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366237 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366239 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366242 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366245 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 366248 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366253 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366258 */   // GIR_Coverage, 5980,
     /* 366258 */   GIR_EraseRootFromParent_Done,
     /* 366259 */ // Label 7301: @366259
     /* 366259 */ GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(366323), // Rule ID 2664 //
     /* 366264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 366270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366274 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366278 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366282 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 366286 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366290 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366295 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366299 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366303 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 366307 */   // MIs[2] Operand 1
     /* 366307 */   // No operand predicates
     /* 366307 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366309 */   // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 366309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 366312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 366314 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 366318 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 366321 */   GIR_RootConstrainSelectedInstOperands,
     /* 366322 */   // GIR_Coverage, 2664,
     /* 366322 */   GIR_EraseRootFromParent_Done,
     /* 366323 */ // Label 7302: @366323
     /* 366323 */ GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(366387), // Rule ID 8296 //
     /* 366328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 366334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366338 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366342 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366346 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 366350 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366354 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366359 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366363 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366367 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 366371 */   // MIs[2] Operand 1
     /* 366371 */   // No operand predicates
     /* 366371 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366373 */   // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 366373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 366376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 366378 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 366382 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 366385 */   GIR_RootConstrainSelectedInstOperands,
     /* 366386 */   // GIR_Coverage, 8296,
     /* 366386 */   GIR_EraseRootFromParent_Done,
     /* 366387 */ // Label 7303: @366387
     /* 366387 */ GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(366428), // Rule ID 8331 //
     /* 366392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 366398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366402 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366406 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 366410 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 366414 */   // MIs[1] Operand 1
     /* 366414 */   // No operand predicates
     /* 366414 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 366416 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 366416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 366419 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 366421 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 366426 */   GIR_RootConstrainSelectedInstOperands,
     /* 366427 */   // GIR_Coverage, 8331,
     /* 366427 */   GIR_EraseRootFromParent_Done,
     /* 366428 */ // Label 7304: @366428
     /* 366428 */ GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(366454), // Rule ID 2387 //
     /* 366433 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366436 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 366439 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366443 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 366447 */   // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
     /* 366447 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 366452 */   GIR_RootConstrainSelectedInstOperands,
     /* 366453 */   // GIR_Coverage, 2387,
     /* 366453 */   GIR_Done,
     /* 366454 */ // Label 7305: @366454
     /* 366454 */ GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(366537), // Rule ID 8309 //
     /* 366459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 366465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366473 */   // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 366473 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 366476 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366480 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366485 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 366487 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 366490 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366494 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366499 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 366502 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 366506 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 366509 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366514 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366519 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 366524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 366527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 366529 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366532 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366535 */   GIR_RootConstrainSelectedInstOperands,
     /* 366536 */   // GIR_Coverage, 8309,
     /* 366536 */   GIR_EraseRootFromParent_Done,
     /* 366537 */ // Label 7306: @366537
     /* 366537 */ GIM_Reject,
     /* 366538 */ // Label 7263: @366538
     /* 366538 */ GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(366681),
     /* 366543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 366546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366550 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(366604), // Rule ID 5974 //
     /* 366555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366558 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 366562 */     // (splat_vector:{ *:[nxv16i8] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 366562 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 366565 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 366569 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366574 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 366577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 366593 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366598 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366603 */     // GIR_Coverage, 5974,
     /* 366603 */     GIR_EraseRootFromParent_Done,
     /* 366604 */   // Label 7308: @366604
     /* 366604 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(366661), // Rule ID 2661 //
     /* 366609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 366624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 366633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366641 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 366645 */     // MIs[2] Operand 1
     /* 366645 */     // No operand predicates
     /* 366645 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366647 */     // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
     /* 366647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 366650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 366652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 366656 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 366659 */     GIR_RootConstrainSelectedInstOperands,
     /* 366660 */     // GIR_Coverage, 2661,
     /* 366660 */     GIR_EraseRootFromParent_Done,
     /* 366661 */   // Label 7309: @366661
     /* 366661 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(366680), // Rule ID 2386 //
     /* 366666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 366669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 366673 */     // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
     /* 366673 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 366678 */     GIR_RootConstrainSelectedInstOperands,
     /* 366679 */     // GIR_Coverage, 2386,
     /* 366679 */     GIR_Done,
     /* 366680 */   // Label 7310: @366680
     /* 366680 */   GIM_Reject,
     /* 366681 */ // Label 7307: @366681
     /* 366681 */ GIM_Reject,
     /* 366682 */ // Label 7264: @366682
     /* 366682 */ GIM_Reject,
     /* 366683 */ // Label 91: @366683
     /* 366683 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7313*/ GIMT_Encode4(366834),
     /* 366694 */ /*GILLT_s32*//*Label 7311*/ GIMT_Encode4(366702),
     /* 366698 */ /*GILLT_s64*//*Label 7312*/ GIMT_Encode4(366768),
     /* 366702 */ // Label 7311: @366702
     /* 366702 */ GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(366767),
     /* 366707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 366710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366718 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(366733), // Rule ID 2319 //
     /* 366723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 366726 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 366726 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
     /* 366731 */     GIR_RootConstrainSelectedInstOperands,
     /* 366732 */     // GIR_Coverage, 2319,
     /* 366732 */     GIR_Done,
     /* 366733 */   // Label 7315: @366733
     /* 366733 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(366766), // Rule ID 3993 //
     /* 366738 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
     /* 366738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 366745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 366754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 366759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366764 */     GIR_RootConstrainSelectedInstOperands,
     /* 366765 */     // GIR_Coverage, 3993,
     /* 366765 */     GIR_EraseRootFromParent_Done,
     /* 366766 */   // Label 7316: @366766
     /* 366766 */   GIM_Reject,
     /* 366767 */ // Label 7314: @366767
     /* 366767 */ GIM_Reject,
     /* 366768 */ // Label 7312: @366768
     /* 366768 */ GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(366833),
     /* 366773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 366776 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366780 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 366784 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(366799), // Rule ID 2320 //
     /* 366789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 366792 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 366792 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
     /* 366797 */     GIR_RootConstrainSelectedInstOperands,
     /* 366798 */     // GIR_Coverage, 2320,
     /* 366798 */     GIR_Done,
     /* 366799 */   // Label 7318: @366799
     /* 366799 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(366832), // Rule ID 3994 //
     /* 366804 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
     /* 366804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 366807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 366811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366816 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 366820 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 366825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366827 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366830 */     GIR_RootConstrainSelectedInstOperands,
     /* 366831 */     // GIR_Coverage, 3994,
     /* 366831 */     GIR_EraseRootFromParent_Done,
     /* 366832 */   // Label 7319: @366832
     /* 366832 */   GIM_Reject,
     /* 366833 */ // Label 7317: @366833
     /* 366833 */ GIM_Reject,
     /* 366834 */ // Label 7313: @366834
     /* 366834 */ GIM_Reject,
     /* 366835 */ // Label 92: @366835
     /* 366835 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7328*/ GIMT_Encode4(367508),
     /* 366846 */ /*GILLT_s32*//*Label 7320*/ GIMT_Encode4(366886),
     /* 366850 */ /*GILLT_s64*//*Label 7321*/ GIMT_Encode4(367116), GIMT_Encode4(0),
     /* 366858 */ /*GILLT_v2s32*//*Label 7322*/ GIMT_Encode4(367346), GIMT_Encode4(0),
     /* 366866 */ /*GILLT_v4s16*//*Label 7323*/ GIMT_Encode4(367373),
     /* 366870 */ /*GILLT_v4s32*//*Label 7324*/ GIMT_Encode4(367400),
     /* 366874 */ /*GILLT_v8s8*//*Label 7325*/ GIMT_Encode4(367427),
     /* 366878 */ /*GILLT_v8s16*//*Label 7326*/ GIMT_Encode4(367454),
     /* 366882 */ /*GILLT_v16s8*//*Label 7327*/ GIMT_Encode4(367481),
     /* 366886 */ // Label 7320: @366886
     /* 366886 */ GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(367115),
     /* 366891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 366894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366898 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(366998), // Rule ID 3995 //
     /* 366903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 366911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 366915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 366919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 366923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 366927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 366931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 366939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 366943 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 366947 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 366951 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 366955 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 366959 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 366963 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 366968 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 366972 */     // MIs[3] Rn
     /* 366972 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 366977 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 366981 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 366985 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 366987 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 366987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 366990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 366992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 366996 */     GIR_RootConstrainSelectedInstOperands,
     /* 366997 */     // GIR_Coverage, 3995,
     /* 366997 */     GIR_EraseRootFromParent_Done,
     /* 366998 */   // Label 7330: @366998
     /* 366998 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(367098), // Rule ID 13727 //
     /* 367003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 367011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367015 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 367019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 367023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 367027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 367031 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367035 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 367039 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 367043 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 367047 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 367051 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367056 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 367060 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 367064 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 367068 */     // MIs[4] Rn
     /* 367068 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 367073 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 367077 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 367081 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 367085 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 367087 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 367087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 367090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 367096 */     GIR_RootConstrainSelectedInstOperands,
     /* 367097 */     // GIR_Coverage, 13727,
     /* 367097 */     GIR_EraseRootFromParent_Done,
     /* 367098 */   // Label 7331: @367098
     /* 367098 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(367114), // Rule ID 180 //
     /* 367103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367107 */     // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 367107 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 367112 */     GIR_RootConstrainSelectedInstOperands,
     /* 367113 */     // GIR_Coverage, 180,
     /* 367113 */     GIR_Done,
     /* 367114 */   // Label 7332: @367114
     /* 367114 */   GIM_Reject,
     /* 367115 */ // Label 7329: @367115
     /* 367115 */ GIM_Reject,
     /* 367116 */ // Label 7321: @367116
     /* 367116 */ GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(367345),
     /* 367121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 367124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367128 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(367228), // Rule ID 3996 //
     /* 367133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 367141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 367145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 367153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 367157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 367161 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367165 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 367169 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 367173 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 367177 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 367181 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 367185 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /* 367189 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 367193 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367198 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 367202 */     // MIs[3] Rn
     /* 367202 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 367207 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 367211 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 367215 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 367217 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 367217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 367220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 367226 */     GIR_RootConstrainSelectedInstOperands,
     /* 367227 */     // GIR_Coverage, 3996,
     /* 367227 */     GIR_EraseRootFromParent_Done,
     /* 367228 */   // Label 7334: @367228
     /* 367228 */   GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(367328), // Rule ID 13728 //
     /* 367233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 367241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 367245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 367253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 367257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 367261 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 367265 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 367269 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 367273 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 367277 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 367281 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367286 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 367290 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 367294 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 367298 */     // MIs[4] Rn
     /* 367298 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 367303 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 367307 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 367311 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 367315 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 367317 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 367317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 367320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 367326 */     GIR_RootConstrainSelectedInstOperands,
     /* 367327 */     // GIR_Coverage, 13728,
     /* 367327 */     GIR_EraseRootFromParent_Done,
     /* 367328 */   // Label 7335: @367328
     /* 367328 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(367344), // Rule ID 181 //
     /* 367333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367337 */     // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 367337 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 367342 */     GIR_RootConstrainSelectedInstOperands,
     /* 367343 */     // GIR_Coverage, 181,
     /* 367343 */     GIR_Done,
     /* 367344 */   // Label 7336: @367344
     /* 367344 */   GIM_Reject,
     /* 367345 */ // Label 7333: @367345
     /* 367345 */ GIM_Reject,
     /* 367346 */ // Label 7322: @367346
     /* 367346 */ GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(367372), // Rule ID 720 //
     /* 367351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 367357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367365 */   // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 367365 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
     /* 367370 */   GIR_RootConstrainSelectedInstOperands,
     /* 367371 */   // GIR_Coverage, 720,
     /* 367371 */   GIR_Done,
     /* 367372 */ // Label 7337: @367372
     /* 367372 */ GIM_Reject,
     /* 367373 */ // Label 7323: @367373
     /* 367373 */ GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(367399), // Rule ID 718 //
     /* 367378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 367384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367392 */   // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 367392 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
     /* 367397 */   GIR_RootConstrainSelectedInstOperands,
     /* 367398 */   // GIR_Coverage, 718,
     /* 367398 */   GIR_Done,
     /* 367399 */ // Label 7338: @367399
     /* 367399 */ GIM_Reject,
     /* 367400 */ // Label 7324: @367400
     /* 367400 */ GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(367426), // Rule ID 721 //
     /* 367405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367419 */   // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 367419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
     /* 367424 */   GIR_RootConstrainSelectedInstOperands,
     /* 367425 */   // GIR_Coverage, 721,
     /* 367425 */   GIR_Done,
     /* 367426 */ // Label 7339: @367426
     /* 367426 */ GIM_Reject,
     /* 367427 */ // Label 7325: @367427
     /* 367427 */ GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(367453), // Rule ID 716 //
     /* 367432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 367438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367446 */   // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 367446 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
     /* 367451 */   GIR_RootConstrainSelectedInstOperands,
     /* 367452 */   // GIR_Coverage, 716,
     /* 367452 */   GIR_Done,
     /* 367453 */ // Label 7340: @367453
     /* 367453 */ GIM_Reject,
     /* 367454 */ // Label 7326: @367454
     /* 367454 */ GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(367480), // Rule ID 719 //
     /* 367459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367473 */   // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 367473 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
     /* 367478 */   GIR_RootConstrainSelectedInstOperands,
     /* 367479 */   // GIR_Coverage, 719,
     /* 367479 */   GIR_Done,
     /* 367480 */ // Label 7341: @367480
     /* 367480 */ GIM_Reject,
     /* 367481 */ // Label 7327: @367481
     /* 367481 */ GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(367507), // Rule ID 717 //
     /* 367486 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367489 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 367492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367496 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367500 */   // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 367500 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
     /* 367505 */   GIR_RootConstrainSelectedInstOperands,
     /* 367506 */   // GIR_Coverage, 717,
     /* 367506 */   GIR_Done,
     /* 367507 */ // Label 7342: @367507
     /* 367507 */ GIM_Reject,
     /* 367508 */ // Label 7328: @367508
     /* 367508 */ GIM_Reject,
     /* 367509 */ // Label 93: @367509
     /* 367509 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7347*/ GIMT_Encode4(367668),
     /* 367520 */ /*GILLT_s32*//*Label 7343*/ GIMT_Encode4(367560),
     /* 367524 */ /*GILLT_s64*//*Label 7344*/ GIMT_Encode4(367587), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 367548 */ /*GILLT_v8s8*//*Label 7345*/ GIMT_Encode4(367614), GIMT_Encode4(0),
     /* 367556 */ /*GILLT_v16s8*//*Label 7346*/ GIMT_Encode4(367641),
     /* 367560 */ // Label 7343: @367560
     /* 367560 */ GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(367586), // Rule ID 2317 //
     /* 367565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 367568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 367571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367579 */   // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 367579 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
     /* 367584 */   GIR_RootConstrainSelectedInstOperands,
     /* 367585 */   // GIR_Coverage, 2317,
     /* 367585 */   GIR_Done,
     /* 367586 */ // Label 7348: @367586
     /* 367586 */ GIM_Reject,
     /* 367587 */ // Label 7344: @367587
     /* 367587 */ GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(367613), // Rule ID 2318 //
     /* 367592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 367595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 367598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367606 */   // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 367606 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
     /* 367611 */   GIR_RootConstrainSelectedInstOperands,
     /* 367612 */   // GIR_Coverage, 2318,
     /* 367612 */   GIR_Done,
     /* 367613 */ // Label 7349: @367613
     /* 367613 */ GIM_Reject,
     /* 367614 */ // Label 7345: @367614
     /* 367614 */ GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(367640), // Rule ID 764 //
     /* 367619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 367625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367633 */   // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 367633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
     /* 367638 */   GIR_RootConstrainSelectedInstOperands,
     /* 367639 */   // GIR_Coverage, 764,
     /* 367639 */   GIR_Done,
     /* 367640 */ // Label 7350: @367640
     /* 367640 */ GIM_Reject,
     /* 367641 */ // Label 7346: @367641
     /* 367641 */ GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(367667), // Rule ID 765 //
     /* 367646 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 367652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367660 */   // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 367660 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
     /* 367665 */   GIR_RootConstrainSelectedInstOperands,
     /* 367666 */   // GIR_Coverage, 765,
     /* 367666 */   GIR_Done,
     /* 367667 */ // Label 7351: @367667
     /* 367667 */ GIM_Reject,
     /* 367668 */ // Label 7347: @367668
     /* 367668 */ GIM_Reject,
     /* 367669 */ // Label 94: @367669
     /* 367669 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7359*/ GIMT_Encode4(367982),
     /* 367680 */ /*GILLT_s32*//*Label 7352*/ GIMT_Encode4(367716),
     /* 367684 */ /*GILLT_s64*//*Label 7353*/ GIMT_Encode4(367789), GIMT_Encode4(0),
     /* 367692 */ /*GILLT_v2s32*//*Label 7354*/ GIMT_Encode4(367862),
     /* 367696 */ /*GILLT_v2s64*//*Label 7355*/ GIMT_Encode4(367886),
     /* 367700 */ /*GILLT_v4s16*//*Label 7356*/ GIMT_Encode4(367910),
     /* 367704 */ /*GILLT_v4s32*//*Label 7357*/ GIMT_Encode4(367934), GIMT_Encode4(0),
     /* 367712 */ /*GILLT_v8s16*//*Label 7358*/ GIMT_Encode4(367958),
     /* 367716 */ // Label 7352: @367716
     /* 367716 */ GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(367788),
     /* 367721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 367724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367728 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(367771), // Rule ID 3999 //
     /* 367733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 367741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367754 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 367758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367760 */     // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 367760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 367763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 367769 */     GIR_RootConstrainSelectedInstOperands,
     /* 367770 */     // GIR_Coverage, 3999,
     /* 367770 */     GIR_EraseRootFromParent_Done,
     /* 367771 */   // Label 7361: @367771
     /* 367771 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(367787), // Rule ID 185 //
     /* 367776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367780 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 367780 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
     /* 367785 */     GIR_RootConstrainSelectedInstOperands,
     /* 367786 */     // GIR_Coverage, 185,
     /* 367786 */     GIR_Done,
     /* 367787 */   // Label 7362: @367787
     /* 367787 */   GIM_Reject,
     /* 367788 */ // Label 7360: @367788
     /* 367788 */ GIM_Reject,
     /* 367789 */ // Label 7353: @367789
     /* 367789 */ GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(367861),
     /* 367794 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 367797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367801 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(367844), // Rule ID 4000 //
     /* 367806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 367814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 367818 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367827 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /* 367831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367833 */     // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 367833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 367836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 367838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 367842 */     GIR_RootConstrainSelectedInstOperands,
     /* 367843 */     // GIR_Coverage, 4000,
     /* 367843 */     GIR_EraseRootFromParent_Done,
     /* 367844 */   // Label 7364: @367844
     /* 367844 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(367860), // Rule ID 186 //
     /* 367849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 367853 */     // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 367853 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
     /* 367858 */     GIR_RootConstrainSelectedInstOperands,
     /* 367859 */     // GIR_Coverage, 186,
     /* 367859 */     GIR_Done,
     /* 367860 */   // Label 7365: @367860
     /* 367860 */   GIM_Reject,
     /* 367861 */ // Label 7363: @367861
     /* 367861 */ GIM_Reject,
     /* 367862 */ // Label 7354: @367862
     /* 367862 */ GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(367885), // Rule ID 4974 //
     /* 367867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 367870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367878 */   // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 367878 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 367883 */   GIR_RootConstrainSelectedInstOperands,
     /* 367884 */   // GIR_Coverage, 4974,
     /* 367884 */   GIR_Done,
     /* 367885 */ // Label 7366: @367885
     /* 367885 */ GIM_Reject,
     /* 367886 */ // Label 7355: @367886
     /* 367886 */ GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(367909), // Rule ID 4976 //
     /* 367891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 367894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367902 */   // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 367902 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 367907 */   GIR_RootConstrainSelectedInstOperands,
     /* 367908 */   // GIR_Coverage, 4976,
     /* 367908 */   GIR_Done,
     /* 367909 */ // Label 7367: @367909
     /* 367909 */ GIM_Reject,
     /* 367910 */ // Label 7356: @367910
     /* 367910 */ GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(367933), // Rule ID 4972 //
     /* 367915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 367918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367926 */   // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 367926 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 367931 */   GIR_RootConstrainSelectedInstOperands,
     /* 367932 */   // GIR_Coverage, 4972,
     /* 367932 */   GIR_Done,
     /* 367933 */ // Label 7368: @367933
     /* 367933 */ GIM_Reject,
     /* 367934 */ // Label 7357: @367934
     /* 367934 */ GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(367957), // Rule ID 4975 //
     /* 367939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367950 */   // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 367950 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 367955 */   GIR_RootConstrainSelectedInstOperands,
     /* 367956 */   // GIR_Coverage, 4975,
     /* 367956 */   GIR_Done,
     /* 367957 */ // Label 7369: @367957
     /* 367957 */ GIM_Reject,
     /* 367958 */ // Label 7358: @367958
     /* 367958 */ GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(367981), // Rule ID 4973 //
     /* 367963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 367966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367974 */   // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 367974 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 367979 */   GIR_RootConstrainSelectedInstOperands,
     /* 367980 */   // GIR_Coverage, 4973,
     /* 367980 */   GIR_Done,
     /* 367981 */ // Label 7370: @367981
     /* 367981 */ GIM_Reject,
     /* 367982 */ // Label 7359: @367982
     /* 367982 */ GIM_Reject,
     /* 367983 */ // Label 95: @367983
     /* 367983 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7375*/ GIMT_Encode4(368136),
     /* 367994 */ /*GILLT_s32*//*Label 7371*/ GIMT_Encode4(368034),
     /* 367998 */ /*GILLT_s64*//*Label 7372*/ GIMT_Encode4(368058), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 368022 */ /*GILLT_v8s8*//*Label 7373*/ GIMT_Encode4(368082), GIMT_Encode4(0),
     /* 368030 */ /*GILLT_v16s8*//*Label 7374*/ GIMT_Encode4(368109),
     /* 368034 */ // Label 7371: @368034
     /* 368034 */ GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(368057), // Rule ID 182 //
     /* 368039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 368042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 368046 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 368050 */   // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 368050 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 368055 */   GIR_RootConstrainSelectedInstOperands,
     /* 368056 */   // GIR_Coverage, 182,
     /* 368056 */   GIR_Done,
     /* 368057 */ // Label 7376: @368057
     /* 368057 */ GIM_Reject,
     /* 368058 */ // Label 7372: @368058
     /* 368058 */ GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(368081), // Rule ID 183 //
     /* 368063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 368066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 368074 */   // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 368074 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 368079 */   GIR_RootConstrainSelectedInstOperands,
     /* 368080 */   // GIR_Coverage, 183,
     /* 368080 */   GIR_Done,
     /* 368081 */ // Label 7377: @368081
     /* 368081 */ GIM_Reject,
     /* 368082 */ // Label 7373: @368082
     /* 368082 */ GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(368108), // Rule ID 974 //
     /* 368087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 368093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368097 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368101 */   // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 368101 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
     /* 368106 */   GIR_RootConstrainSelectedInstOperands,
     /* 368107 */   // GIR_Coverage, 974,
     /* 368107 */   GIR_Done,
     /* 368108 */ // Label 7378: @368108
     /* 368108 */ GIM_Reject,
     /* 368109 */ // Label 7374: @368109
     /* 368109 */ GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(368135), // Rule ID 975 //
     /* 368114 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 368120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368128 */   // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 368128 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
     /* 368133 */   GIR_RootConstrainSelectedInstOperands,
     /* 368134 */   // GIR_Coverage, 975,
     /* 368134 */   GIR_Done,
     /* 368135 */ // Label 7379: @368135
     /* 368135 */ GIM_Reject,
     /* 368136 */ // Label 7375: @368136
     /* 368136 */ GIM_Reject,
     /* 368137 */ // Label 96: @368137
     /* 368137 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7388*/ GIMT_Encode4(368627),
     /* 368148 */ /*GILLT_s16*//*Label 7380*/ GIMT_Encode4(368188),
     /* 368152 */ /*GILLT_s32*//*Label 7381*/ GIMT_Encode4(368219),
     /* 368156 */ /*GILLT_s64*//*Label 7382*/ GIMT_Encode4(368250), GIMT_Encode4(0),
     /* 368164 */ /*GILLT_v2s32*//*Label 7383*/ GIMT_Encode4(368281),
     /* 368168 */ /*GILLT_v2s64*//*Label 7384*/ GIMT_Encode4(368312),
     /* 368172 */ /*GILLT_v4s16*//*Label 7385*/ GIMT_Encode4(368343),
     /* 368176 */ /*GILLT_v4s32*//*Label 7386*/ GIMT_Encode4(368374), GIMT_Encode4(0),
     /* 368184 */ /*GILLT_v8s16*//*Label 7387*/ GIMT_Encode4(368405),
     /* 368188 */ // Label 7380: @368188
     /* 368188 */ GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(368218), // Rule ID 552 //
     /* 368193 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 368196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 368199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368203 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368207 */   // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 368207 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
     /* 368212 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368216 */   GIR_RootConstrainSelectedInstOperands,
     /* 368217 */   // GIR_Coverage, 552,
     /* 368217 */   GIR_Done,
     /* 368218 */ // Label 7389: @368218
     /* 368218 */ GIM_Reject,
     /* 368219 */ // Label 7381: @368219
     /* 368219 */ GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(368249), // Rule ID 554 //
     /* 368224 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 368230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368234 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368238 */   // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 368238 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
     /* 368243 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368247 */   GIR_RootConstrainSelectedInstOperands,
     /* 368248 */   // GIR_Coverage, 554,
     /* 368248 */   GIR_Done,
     /* 368249 */ // Label 7390: @368249
     /* 368249 */ GIM_Reject,
     /* 368250 */ // Label 7382: @368250
     /* 368250 */ GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(368280), // Rule ID 556 //
     /* 368255 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368258 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 368261 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368265 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368269 */   // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 368269 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
     /* 368274 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368278 */   GIR_RootConstrainSelectedInstOperands,
     /* 368279 */   // GIR_Coverage, 556,
     /* 368279 */   GIR_Done,
     /* 368280 */ // Label 7391: @368280
     /* 368280 */ GIM_Reject,
     /* 368281 */ // Label 7383: @368281
     /* 368281 */ GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(368311), // Rule ID 913 //
     /* 368286 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368289 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 368292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368296 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368300 */   // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 368300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
     /* 368305 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368309 */   GIR_RootConstrainSelectedInstOperands,
     /* 368310 */   // GIR_Coverage, 913,
     /* 368310 */   GIR_Done,
     /* 368311 */ // Label 7392: @368311
     /* 368311 */ GIM_Reject,
     /* 368312 */ // Label 7384: @368312
     /* 368312 */ GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(368342), // Rule ID 917 //
     /* 368317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368331 */   // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 368331 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
     /* 368336 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368340 */   GIR_RootConstrainSelectedInstOperands,
     /* 368341 */   // GIR_Coverage, 917,
     /* 368341 */   GIR_Done,
     /* 368342 */ // Label 7393: @368342
     /* 368342 */ GIM_Reject,
     /* 368343 */ // Label 7385: @368343
     /* 368343 */ GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(368373), // Rule ID 909 //
     /* 368348 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 368351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 368354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368362 */   // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 368362 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
     /* 368367 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368371 */   GIR_RootConstrainSelectedInstOperands,
     /* 368372 */   // GIR_Coverage, 909,
     /* 368372 */   GIR_Done,
     /* 368373 */ // Label 7394: @368373
     /* 368373 */ GIM_Reject,
     /* 368374 */ // Label 7386: @368374
     /* 368374 */ GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(368404), // Rule ID 915 //
     /* 368379 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368382 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368393 */   // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 368393 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 368398 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368402 */   GIR_RootConstrainSelectedInstOperands,
     /* 368403 */   // GIR_Coverage, 915,
     /* 368403 */   GIR_Done,
     /* 368404 */ // Label 7395: @368404
     /* 368404 */ GIM_Reject,
     /* 368405 */ // Label 7387: @368405
     /* 368405 */ GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(368626),
     /* 368410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368421 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(368440), // Rule ID 911 //
     /* 368426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 368429 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 368429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
     /* 368434 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368438 */     GIR_RootConstrainSelectedInstOperands,
     /* 368439 */     // GIR_Coverage, 911,
     /* 368439 */     GIR_Done,
     /* 368440 */   // Label 7397: @368440
     /* 368440 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(368625), // Rule ID 6963 //
     /* 368445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 368448 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 368448 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 368451 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 368455 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368460 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 368464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 368466 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 368469 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 368473 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368478 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 368481 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 368483 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 368486 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 368490 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368495 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 368501 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368506 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368511 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 368514 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 368518 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368523 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 368526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 368528 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 368531 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 368535 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368540 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 368543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 368545 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 368548 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 368552 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368557 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 368560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 368562 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 368565 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 368569 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 368576 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 368579 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 368583 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368588 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 368591 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 368594 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 368597 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 368615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368617 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 368623 */     GIR_RootConstrainSelectedInstOperands,
     /* 368624 */     // GIR_Coverage, 6963,
     /* 368624 */     GIR_EraseRootFromParent_Done,
     /* 368625 */   // Label 7398: @368625
     /* 368625 */   GIM_Reject,
     /* 368626 */ // Label 7396: @368626
     /* 368626 */ GIM_Reject,
     /* 368627 */ // Label 7388: @368627
     /* 368627 */ GIM_Reject,
     /* 368628 */ // Label 97: @368628
     /* 368628 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7407*/ GIMT_Encode4(368927),
     /* 368639 */ /*GILLT_s16*//*Label 7399*/ GIMT_Encode4(368679),
     /* 368643 */ /*GILLT_s32*//*Label 7400*/ GIMT_Encode4(368710),
     /* 368647 */ /*GILLT_s64*//*Label 7401*/ GIMT_Encode4(368741), GIMT_Encode4(0),
     /* 368655 */ /*GILLT_v2s32*//*Label 7402*/ GIMT_Encode4(368772),
     /* 368659 */ /*GILLT_v2s64*//*Label 7403*/ GIMT_Encode4(368803),
     /* 368663 */ /*GILLT_v4s16*//*Label 7404*/ GIMT_Encode4(368834),
     /* 368667 */ /*GILLT_v4s32*//*Label 7405*/ GIMT_Encode4(368865), GIMT_Encode4(0),
     /* 368675 */ /*GILLT_v8s16*//*Label 7406*/ GIMT_Encode4(368896),
     /* 368679 */ // Label 7399: @368679
     /* 368679 */ GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(368709), // Rule ID 570 //
     /* 368684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 368687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 368690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368698 */   // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 368698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 368703 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368707 */   GIR_RootConstrainSelectedInstOperands,
     /* 368708 */   // GIR_Coverage, 570,
     /* 368708 */   GIR_Done,
     /* 368709 */ // Label 7408: @368709
     /* 368709 */ GIM_Reject,
     /* 368710 */ // Label 7400: @368710
     /* 368710 */ GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(368740), // Rule ID 572 //
     /* 368715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 368721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 368729 */   // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 368729 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 368734 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368738 */   GIR_RootConstrainSelectedInstOperands,
     /* 368739 */   // GIR_Coverage, 572,
     /* 368739 */   GIR_Done,
     /* 368740 */ // Label 7409: @368740
     /* 368740 */ GIM_Reject,
     /* 368741 */ // Label 7401: @368741
     /* 368741 */ GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(368771), // Rule ID 574 //
     /* 368746 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 368749 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 368752 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368756 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368760 */   // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 368760 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 368765 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368769 */   GIR_RootConstrainSelectedInstOperands,
     /* 368770 */   // GIR_Coverage, 574,
     /* 368770 */   GIR_Done,
     /* 368771 */ // Label 7410: @368771
     /* 368771 */ GIM_Reject,
     /* 368772 */ // Label 7402: @368772
     /* 368772 */ GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(368802), // Rule ID 960 //
     /* 368777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 368783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368791 */   // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 368791 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 368796 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368800 */   GIR_RootConstrainSelectedInstOperands,
     /* 368801 */   // GIR_Coverage, 960,
     /* 368801 */   GIR_Done,
     /* 368802 */ // Label 7411: @368802
     /* 368802 */ GIM_Reject,
     /* 368803 */ // Label 7403: @368803
     /* 368803 */ GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(368833), // Rule ID 964 //
     /* 368808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 368814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368822 */   // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 368822 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 368827 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368831 */   GIR_RootConstrainSelectedInstOperands,
     /* 368832 */   // GIR_Coverage, 964,
     /* 368832 */   GIR_Done,
     /* 368833 */ // Label 7412: @368833
     /* 368833 */ GIM_Reject,
     /* 368834 */ // Label 7404: @368834
     /* 368834 */ GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(368864), // Rule ID 956 //
     /* 368839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 368842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 368845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368853 */   // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 368853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 368858 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368862 */   GIR_RootConstrainSelectedInstOperands,
     /* 368863 */   // GIR_Coverage, 956,
     /* 368863 */   GIR_Done,
     /* 368864 */ // Label 7413: @368864
     /* 368864 */ GIM_Reject,
     /* 368865 */ // Label 7405: @368865
     /* 368865 */ GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(368895), // Rule ID 962 //
     /* 368870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 368873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 368876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368884 */   // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 368884 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 368889 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368893 */   GIR_RootConstrainSelectedInstOperands,
     /* 368894 */   // GIR_Coverage, 962,
     /* 368894 */   GIR_Done,
     /* 368895 */ // Label 7414: @368895
     /* 368895 */ GIM_Reject,
     /* 368896 */ // Label 7406: @368896
     /* 368896 */ GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(368926), // Rule ID 958 //
     /* 368901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 368904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 368907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 368915 */   // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 368915 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 368920 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 368924 */   GIR_RootConstrainSelectedInstOperands,
     /* 368925 */   // GIR_Coverage, 958,
     /* 368925 */   GIR_Done,
     /* 368926 */ // Label 7415: @368926
     /* 368926 */ GIM_Reject,
     /* 368927 */ // Label 7407: @368927
     /* 368927 */ GIM_Reject,
     /* 368928 */ // Label 98: @368928
     /* 368928 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7424*/ GIMT_Encode4(369418),
     /* 368939 */ /*GILLT_s16*//*Label 7416*/ GIMT_Encode4(368979),
     /* 368943 */ /*GILLT_s32*//*Label 7417*/ GIMT_Encode4(369010),
     /* 368947 */ /*GILLT_s64*//*Label 7418*/ GIMT_Encode4(369041), GIMT_Encode4(0),
     /* 368955 */ /*GILLT_v2s32*//*Label 7419*/ GIMT_Encode4(369072),
     /* 368959 */ /*GILLT_v2s64*//*Label 7420*/ GIMT_Encode4(369103),
     /* 368963 */ /*GILLT_v4s16*//*Label 7421*/ GIMT_Encode4(369134),
     /* 368967 */ /*GILLT_v4s32*//*Label 7422*/ GIMT_Encode4(369165), GIMT_Encode4(0),
     /* 368975 */ /*GILLT_v8s16*//*Label 7423*/ GIMT_Encode4(369196),
     /* 368979 */ // Label 7416: @368979
     /* 368979 */ GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(369009), // Rule ID 540 //
     /* 368984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 368987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 368990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 368998 */   // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 368998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
     /* 369003 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369007 */   GIR_RootConstrainSelectedInstOperands,
     /* 369008 */   // GIR_Coverage, 540,
     /* 369008 */   GIR_Done,
     /* 369009 */ // Label 7425: @369009
     /* 369009 */ GIM_Reject,
     /* 369010 */ // Label 7417: @369010
     /* 369010 */ GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(369040), // Rule ID 542 //
     /* 369015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 369021 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369025 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369029 */   // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 369029 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
     /* 369034 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369038 */   GIR_RootConstrainSelectedInstOperands,
     /* 369039 */   // GIR_Coverage, 542,
     /* 369039 */   GIR_Done,
     /* 369040 */ // Label 7426: @369040
     /* 369040 */ GIM_Reject,
     /* 369041 */ // Label 7418: @369041
     /* 369041 */ GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(369071), // Rule ID 544 //
     /* 369046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 369052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369060 */   // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 369060 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
     /* 369065 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369069 */   GIR_RootConstrainSelectedInstOperands,
     /* 369070 */   // GIR_Coverage, 544,
     /* 369070 */   GIR_Done,
     /* 369071 */ // Label 7427: @369071
     /* 369071 */ GIM_Reject,
     /* 369072 */ // Label 7419: @369072
     /* 369072 */ GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(369102), // Rule ID 893 //
     /* 369077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 369083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369091 */   // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 369091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
     /* 369096 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369100 */   GIR_RootConstrainSelectedInstOperands,
     /* 369101 */   // GIR_Coverage, 893,
     /* 369101 */   GIR_Done,
     /* 369102 */ // Label 7428: @369102
     /* 369102 */ GIM_Reject,
     /* 369103 */ // Label 7420: @369103
     /* 369103 */ GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(369133), // Rule ID 897 //
     /* 369108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 369114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369122 */   // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 369122 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
     /* 369127 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369131 */   GIR_RootConstrainSelectedInstOperands,
     /* 369132 */   // GIR_Coverage, 897,
     /* 369132 */   GIR_Done,
     /* 369133 */ // Label 7429: @369133
     /* 369133 */ GIM_Reject,
     /* 369134 */ // Label 7421: @369134
     /* 369134 */ GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(369164), // Rule ID 889 //
     /* 369139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 369145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369153 */   // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 369153 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
     /* 369158 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369162 */   GIR_RootConstrainSelectedInstOperands,
     /* 369163 */   // GIR_Coverage, 889,
     /* 369163 */   GIR_Done,
     /* 369164 */ // Label 7430: @369164
     /* 369164 */ GIM_Reject,
     /* 369165 */ // Label 7422: @369165
     /* 369165 */ GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(369195), // Rule ID 895 //
     /* 369170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369176 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369180 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369184 */   // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 369184 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 369189 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369193 */   GIR_RootConstrainSelectedInstOperands,
     /* 369194 */   // GIR_Coverage, 895,
     /* 369194 */   GIR_Done,
     /* 369195 */ // Label 7431: @369195
     /* 369195 */ GIM_Reject,
     /* 369196 */ // Label 7423: @369196
     /* 369196 */ GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(369417),
     /* 369201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369212 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(369231), // Rule ID 891 //
     /* 369217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369220 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 369220 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
     /* 369225 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369229 */     GIR_RootConstrainSelectedInstOperands,
     /* 369230 */     // GIR_Coverage, 891,
     /* 369230 */     GIR_Done,
     /* 369231 */   // Label 7433: @369231
     /* 369231 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(369416), // Rule ID 6965 //
     /* 369236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 369239 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 369239 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 369242 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 369246 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369251 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 369255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 369257 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 369260 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 369264 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369269 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 369272 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 369274 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 369277 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369281 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369286 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 369292 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369297 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369302 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 369305 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 369309 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369314 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 369317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 369319 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 369322 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 369326 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369331 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 369334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 369336 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 369339 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 369343 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369348 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 369351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 369353 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 369356 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369360 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369379 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369382 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 369385 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 369388 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369393 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369398 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 369406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 369414 */     GIR_RootConstrainSelectedInstOperands,
     /* 369415 */     // GIR_Coverage, 6965,
     /* 369415 */     GIR_EraseRootFromParent_Done,
     /* 369416 */   // Label 7434: @369416
     /* 369416 */   GIM_Reject,
     /* 369417 */ // Label 7432: @369417
     /* 369417 */ GIM_Reject,
     /* 369418 */ // Label 7424: @369418
     /* 369418 */ GIM_Reject,
     /* 369419 */ // Label 99: @369419
     /* 369419 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7443*/ GIMT_Encode4(369909),
     /* 369430 */ /*GILLT_s16*//*Label 7435*/ GIMT_Encode4(369470),
     /* 369434 */ /*GILLT_s32*//*Label 7436*/ GIMT_Encode4(369501),
     /* 369438 */ /*GILLT_s64*//*Label 7437*/ GIMT_Encode4(369532), GIMT_Encode4(0),
     /* 369446 */ /*GILLT_v2s32*//*Label 7438*/ GIMT_Encode4(369563),
     /* 369450 */ /*GILLT_v2s64*//*Label 7439*/ GIMT_Encode4(369594),
     /* 369454 */ /*GILLT_v4s16*//*Label 7440*/ GIMT_Encode4(369625),
     /* 369458 */ /*GILLT_v4s32*//*Label 7441*/ GIMT_Encode4(369656), GIMT_Encode4(0),
     /* 369466 */ /*GILLT_v8s16*//*Label 7442*/ GIMT_Encode4(369687),
     /* 369470 */ // Label 7435: @369470
     /* 369470 */ GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(369500), // Rule ID 558 //
     /* 369475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 369478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 369481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369489 */   // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 369489 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 369494 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369498 */   GIR_RootConstrainSelectedInstOperands,
     /* 369499 */   // GIR_Coverage, 558,
     /* 369499 */   GIR_Done,
     /* 369500 */ // Label 7444: @369500
     /* 369500 */ GIM_Reject,
     /* 369501 */ // Label 7436: @369501
     /* 369501 */ GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(369531), // Rule ID 560 //
     /* 369506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 369512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369516 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 369520 */   // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 369520 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 369525 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369529 */   GIR_RootConstrainSelectedInstOperands,
     /* 369530 */   // GIR_Coverage, 560,
     /* 369530 */   GIR_Done,
     /* 369531 */ // Label 7445: @369531
     /* 369531 */ GIM_Reject,
     /* 369532 */ // Label 7437: @369532
     /* 369532 */ GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(369562), // Rule ID 562 //
     /* 369537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 369540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 369543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369551 */   // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 369551 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 369556 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369560 */   GIR_RootConstrainSelectedInstOperands,
     /* 369561 */   // GIR_Coverage, 562,
     /* 369561 */   GIR_Done,
     /* 369562 */ // Label 7446: @369562
     /* 369562 */ GIM_Reject,
     /* 369563 */ // Label 7438: @369563
     /* 369563 */ GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(369593), // Rule ID 923 //
     /* 369568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 369574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369582 */   // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 369582 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
     /* 369587 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369591 */   GIR_RootConstrainSelectedInstOperands,
     /* 369592 */   // GIR_Coverage, 923,
     /* 369592 */   GIR_Done,
     /* 369593 */ // Label 7447: @369593
     /* 369593 */ GIM_Reject,
     /* 369594 */ // Label 7439: @369594
     /* 369594 */ GIM_Try, /*On fail goto*//*Label 7448*/ GIMT_Encode4(369624), // Rule ID 927 //
     /* 369599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 369605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369613 */   // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 369613 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
     /* 369618 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369622 */   GIR_RootConstrainSelectedInstOperands,
     /* 369623 */   // GIR_Coverage, 927,
     /* 369623 */   GIR_Done,
     /* 369624 */ // Label 7448: @369624
     /* 369624 */ GIM_Reject,
     /* 369625 */ // Label 7440: @369625
     /* 369625 */ GIM_Try, /*On fail goto*//*Label 7449*/ GIMT_Encode4(369655), // Rule ID 919 //
     /* 369630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 369636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369644 */   // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 369644 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
     /* 369649 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369653 */   GIR_RootConstrainSelectedInstOperands,
     /* 369654 */   // GIR_Coverage, 919,
     /* 369654 */   GIR_Done,
     /* 369655 */ // Label 7449: @369655
     /* 369655 */ GIM_Reject,
     /* 369656 */ // Label 7441: @369656
     /* 369656 */ GIM_Try, /*On fail goto*//*Label 7450*/ GIMT_Encode4(369686), // Rule ID 925 //
     /* 369661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 369664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 369667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369675 */   // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 369675 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 369680 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369684 */   GIR_RootConstrainSelectedInstOperands,
     /* 369685 */   // GIR_Coverage, 925,
     /* 369685 */   GIR_Done,
     /* 369686 */ // Label 7450: @369686
     /* 369686 */ GIM_Reject,
     /* 369687 */ // Label 7442: @369687
     /* 369687 */ GIM_Try, /*On fail goto*//*Label 7451*/ GIMT_Encode4(369908),
     /* 369692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 369695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369703 */   GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(369722), // Rule ID 921 //
     /* 369708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 369711 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 369711 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
     /* 369716 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369720 */     GIR_RootConstrainSelectedInstOperands,
     /* 369721 */     // GIR_Coverage, 921,
     /* 369721 */     GIR_Done,
     /* 369722 */   // Label 7452: @369722
     /* 369722 */   GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(369907), // Rule ID 6973 //
     /* 369727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 369730 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 369730 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 369733 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 369737 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369742 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 369746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 369748 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 369751 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 369755 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369760 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 369763 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 369765 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 369768 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 369772 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369777 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 369783 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369788 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369793 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 369796 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 369800 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369805 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 369808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 369810 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 369813 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 369817 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369822 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 369825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 369827 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 369830 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 369834 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369839 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 369842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 369844 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 369847 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 369851 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 369858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 369865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369870 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 369873 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 369876 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 369879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 369897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369902 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 369905 */     GIR_RootConstrainSelectedInstOperands,
     /* 369906 */     // GIR_Coverage, 6973,
     /* 369906 */     GIR_EraseRootFromParent_Done,
     /* 369907 */   // Label 7453: @369907
     /* 369907 */   GIM_Reject,
     /* 369908 */ // Label 7451: @369908
     /* 369908 */ GIM_Reject,
     /* 369909 */ // Label 7443: @369909
     /* 369909 */ GIM_Reject,
     /* 369910 */ // Label 100: @369910
     /* 369910 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7462*/ GIMT_Encode4(370400),
     /* 369921 */ /*GILLT_s16*//*Label 7454*/ GIMT_Encode4(369961),
     /* 369925 */ /*GILLT_s32*//*Label 7455*/ GIMT_Encode4(369992),
     /* 369929 */ /*GILLT_s64*//*Label 7456*/ GIMT_Encode4(370023), GIMT_Encode4(0),
     /* 369937 */ /*GILLT_v2s32*//*Label 7457*/ GIMT_Encode4(370054),
     /* 369941 */ /*GILLT_v2s64*//*Label 7458*/ GIMT_Encode4(370085),
     /* 369945 */ /*GILLT_v4s16*//*Label 7459*/ GIMT_Encode4(370116),
     /* 369949 */ /*GILLT_v4s32*//*Label 7460*/ GIMT_Encode4(370147), GIMT_Encode4(0),
     /* 369957 */ /*GILLT_v8s16*//*Label 7461*/ GIMT_Encode4(370178),
     /* 369961 */ // Label 7454: @369961
     /* 369961 */ GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(369991), // Rule ID 534 //
     /* 369966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 369969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 369972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 369980 */   // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 369980 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
     /* 369985 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 369989 */   GIR_RootConstrainSelectedInstOperands,
     /* 369990 */   // GIR_Coverage, 534,
     /* 369990 */   GIR_Done,
     /* 369991 */ // Label 7463: @369991
     /* 369991 */ GIM_Reject,
     /* 369992 */ // Label 7455: @369992
     /* 369992 */ GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(370022), // Rule ID 536 //
     /* 369997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370011 */   // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 370011 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
     /* 370016 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370020 */   GIR_RootConstrainSelectedInstOperands,
     /* 370021 */   // GIR_Coverage, 536,
     /* 370021 */   GIR_Done,
     /* 370022 */ // Label 7464: @370022
     /* 370022 */ GIM_Reject,
     /* 370023 */ // Label 7456: @370023
     /* 370023 */ GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(370053), // Rule ID 538 //
     /* 370028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 370034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370042 */   // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 370042 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
     /* 370047 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370051 */   GIR_RootConstrainSelectedInstOperands,
     /* 370052 */   // GIR_Coverage, 538,
     /* 370052 */   GIR_Done,
     /* 370053 */ // Label 7465: @370053
     /* 370053 */ GIM_Reject,
     /* 370054 */ // Label 7457: @370054
     /* 370054 */ GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(370084), // Rule ID 883 //
     /* 370059 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 370065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370069 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370073 */   // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 370073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
     /* 370078 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370082 */   GIR_RootConstrainSelectedInstOperands,
     /* 370083 */   // GIR_Coverage, 883,
     /* 370083 */   GIR_Done,
     /* 370084 */ // Label 7466: @370084
     /* 370084 */ GIM_Reject,
     /* 370085 */ // Label 7458: @370085
     /* 370085 */ GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(370115), // Rule ID 887 //
     /* 370090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370104 */   // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 370104 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
     /* 370109 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370113 */   GIR_RootConstrainSelectedInstOperands,
     /* 370114 */   // GIR_Coverage, 887,
     /* 370114 */   GIR_Done,
     /* 370115 */ // Label 7467: @370115
     /* 370115 */ GIM_Reject,
     /* 370116 */ // Label 7459: @370116
     /* 370116 */ GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(370146), // Rule ID 879 //
     /* 370121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 370124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 370127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370135 */   // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 370135 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
     /* 370140 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370144 */   GIR_RootConstrainSelectedInstOperands,
     /* 370145 */   // GIR_Coverage, 879,
     /* 370145 */   GIR_Done,
     /* 370146 */ // Label 7468: @370146
     /* 370146 */ GIM_Reject,
     /* 370147 */ // Label 7460: @370147
     /* 370147 */ GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(370177), // Rule ID 885 //
     /* 370152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 370155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370166 */   // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 370166 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 370171 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370175 */   GIR_RootConstrainSelectedInstOperands,
     /* 370176 */   // GIR_Coverage, 885,
     /* 370176 */   GIR_Done,
     /* 370177 */ // Label 7469: @370177
     /* 370177 */ GIM_Reject,
     /* 370178 */ // Label 7461: @370178
     /* 370178 */ GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(370399),
     /* 370183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 370186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370194 */   GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(370213), // Rule ID 881 //
     /* 370199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 370202 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 370202 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
     /* 370207 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370211 */     GIR_RootConstrainSelectedInstOperands,
     /* 370212 */     // GIR_Coverage, 881,
     /* 370212 */     GIR_Done,
     /* 370213 */   // Label 7471: @370213
     /* 370213 */   GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(370398), // Rule ID 6967 //
     /* 370218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 370221 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 370221 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 370224 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 370228 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370233 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 370237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 370239 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 370242 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 370246 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370251 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 370254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 370256 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 370259 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370263 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370268 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370274 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370279 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370284 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 370287 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 370291 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370296 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 370299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 370301 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 370304 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 370308 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370313 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 370316 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 370318 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 370321 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 370325 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370330 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 370333 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 370335 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 370338 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 370342 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 370349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 370356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370361 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370364 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 370367 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 370370 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 370388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370393 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 370396 */     GIR_RootConstrainSelectedInstOperands,
     /* 370397 */     // GIR_Coverage, 6967,
     /* 370397 */     GIR_EraseRootFromParent_Done,
     /* 370398 */   // Label 7472: @370398
     /* 370398 */   GIM_Reject,
     /* 370399 */ // Label 7470: @370399
     /* 370399 */ GIM_Reject,
     /* 370400 */ // Label 7462: @370400
     /* 370400 */ GIM_Reject,
     /* 370401 */ // Label 101: @370401
     /* 370401 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7481*/ GIMT_Encode4(371526),
     /* 370412 */ /*GILLT_s16*//*Label 7473*/ GIMT_Encode4(370452),
     /* 370416 */ /*GILLT_s32*//*Label 7474*/ GIMT_Encode4(370678),
     /* 370420 */ /*GILLT_s64*//*Label 7475*/ GIMT_Encode4(370904), GIMT_Encode4(0),
     /* 370428 */ /*GILLT_v2s32*//*Label 7476*/ GIMT_Encode4(371076),
     /* 370432 */ /*GILLT_v2s64*//*Label 7477*/ GIMT_Encode4(371114),
     /* 370436 */ /*GILLT_v4s16*//*Label 7478*/ GIMT_Encode4(371152),
     /* 370440 */ /*GILLT_v4s32*//*Label 7479*/ GIMT_Encode4(371190), GIMT_Encode4(0),
     /* 370448 */ /*GILLT_v8s16*//*Label 7480*/ GIMT_Encode4(371228),
     /* 370452 */ // Label 7473: @370452
     /* 370452 */ GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(370677),
     /* 370457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 370460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 370463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370467 */   GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(370558), // Rule ID 6887 //
     /* 370472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 370484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370493 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370509 */     // MIs[2] Rn
     /* 370509 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370514 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 370518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370520 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 370520 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370523 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370527 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370532 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370538 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 370551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370553 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370556 */     GIR_RootConstrainSelectedInstOperands,
     /* 370557 */     // GIR_Coverage, 6887,
     /* 370557 */     GIR_EraseRootFromParent_Done,
     /* 370558 */   // Label 7483: @370558
     /* 370558 */   GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(370649), // Rule ID 13868 //
     /* 370563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 370575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370584 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 370588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370596 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370600 */     // MIs[2] Rn
     /* 370600 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370605 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 370609 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370611 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 370611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370623 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370629 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370634 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 370642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370647 */     GIR_RootConstrainSelectedInstOperands,
     /* 370648 */     // GIR_Coverage, 13868,
     /* 370648 */     GIR_EraseRootFromParent_Done,
     /* 370649 */   // Label 7484: @370649
     /* 370649 */   GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(370676), // Rule ID 583 //
     /* 370654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 370657 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 370665 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 370665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 370670 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370674 */     GIR_RootConstrainSelectedInstOperands,
     /* 370675 */     // GIR_Coverage, 583,
     /* 370675 */     GIR_Done,
     /* 370676 */   // Label 7485: @370676
     /* 370676 */   GIM_Reject,
     /* 370677 */ // Label 7482: @370677
     /* 370677 */ GIM_Reject,
     /* 370678 */ // Label 7474: @370678
     /* 370678 */ GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(370903),
     /* 370683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 370686 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370693 */   GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(370784), // Rule ID 6885 //
     /* 370698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370719 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370723 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370727 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370731 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370735 */     // MIs[2] Rn
     /* 370735 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370740 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 370744 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370746 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 370746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370758 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 370777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370782 */     GIR_RootConstrainSelectedInstOperands,
     /* 370783 */     // GIR_Coverage, 6885,
     /* 370783 */     GIR_EraseRootFromParent_Done,
     /* 370784 */   // Label 7487: @370784
     /* 370784 */   GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(370875), // Rule ID 13866 //
     /* 370789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 370801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370810 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 370814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370822 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370826 */     // MIs[2] Rn
     /* 370826 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370831 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 370835 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370837 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 370837 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 370840 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370844 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370849 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 370855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 370868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370873 */     GIR_RootConstrainSelectedInstOperands,
     /* 370874 */     // GIR_Coverage, 13866,
     /* 370874 */     GIR_EraseRootFromParent_Done,
     /* 370875 */   // Label 7488: @370875
     /* 370875 */   GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(370902), // Rule ID 585 //
     /* 370880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 370883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370891 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 370891 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 370896 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 370900 */     GIR_RootConstrainSelectedInstOperands,
     /* 370901 */     // GIR_Coverage, 585,
     /* 370901 */     GIR_Done,
     /* 370902 */   // Label 7489: @370902
     /* 370902 */   GIM_Reject,
     /* 370903 */ // Label 7486: @370903
     /* 370903 */ GIM_Reject,
     /* 370904 */ // Label 7475: @370904
     /* 370904 */ GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(371075),
     /* 370909 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 370912 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 370915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370919 */   GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(370983), // Rule ID 6883 //
     /* 370924 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370928 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370932 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 370936 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370940 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370945 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 370949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 370953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 370961 */     // MIs[2] Rn
     /* 370961 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 370966 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 370970 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370972 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 370972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 370975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 370977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370981 */     GIR_RootConstrainSelectedInstOperands,
     /* 370982 */     // GIR_Coverage, 6883,
     /* 370982 */     GIR_EraseRootFromParent_Done,
     /* 370983 */   // Label 7491: @370983
     /* 370983 */   GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(371047), // Rule ID 13864 //
     /* 370988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 371004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371009 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 371013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 371021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 371025 */     // MIs[2] Rn
     /* 371025 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 371030 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 371034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371036 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 371036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 371039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 371041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 371045 */     GIR_RootConstrainSelectedInstOperands,
     /* 371046 */     // GIR_Coverage, 13864,
     /* 371046 */     GIR_EraseRootFromParent_Done,
     /* 371047 */   // Label 7492: @371047
     /* 371047 */   GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(371074), // Rule ID 587 //
     /* 371052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371063 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 371063 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 371068 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371072 */     GIR_RootConstrainSelectedInstOperands,
     /* 371073 */     // GIR_Coverage, 587,
     /* 371073 */     GIR_Done,
     /* 371074 */   // Label 7493: @371074
     /* 371074 */   GIM_Reject,
     /* 371075 */ // Label 7490: @371075
     /* 371075 */ GIM_Reject,
     /* 371076 */ // Label 7476: @371076
     /* 371076 */ GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(371113), // Rule ID 1202 //
     /* 371081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 371087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 371090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371102 */   // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 371102 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 371107 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371111 */   GIR_RootConstrainSelectedInstOperands,
     /* 371112 */   // GIR_Coverage, 1202,
     /* 371112 */   GIR_Done,
     /* 371113 */ // Label 7494: @371113
     /* 371113 */ GIM_Reject,
     /* 371114 */ // Label 7477: @371114
     /* 371114 */ GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(371151), // Rule ID 1206 //
     /* 371119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 371128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371136 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371140 */   // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 371140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 371145 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371149 */   GIR_RootConstrainSelectedInstOperands,
     /* 371150 */   // GIR_Coverage, 1206,
     /* 371150 */   GIR_Done,
     /* 371151 */ // Label 7495: @371151
     /* 371151 */ GIM_Reject,
     /* 371152 */ // Label 7478: @371152
     /* 371152 */ GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(371189), // Rule ID 1198 //
     /* 371157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 371163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 371166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371174 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371178 */   // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 371178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 371183 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371187 */   GIR_RootConstrainSelectedInstOperands,
     /* 371188 */   // GIR_Coverage, 1198,
     /* 371188 */   GIR_Done,
     /* 371189 */ // Label 7496: @371189
     /* 371189 */ GIM_Reject,
     /* 371190 */ // Label 7479: @371190
     /* 371190 */ GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(371227), // Rule ID 1204 //
     /* 371195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 371204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371216 */   // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 371216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 371221 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371225 */   GIR_RootConstrainSelectedInstOperands,
     /* 371226 */   // GIR_Coverage, 1204,
     /* 371226 */   GIR_Done,
     /* 371227 */ // Label 7497: @371227
     /* 371227 */ GIM_Reject,
     /* 371228 */ // Label 7480: @371228
     /* 371228 */ GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(371525),
     /* 371233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 371239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371243 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371247 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371251 */   GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(371270), // Rule ID 1200 //
     /* 371256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371259 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 371259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 371264 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371268 */     GIR_RootConstrainSelectedInstOperands,
     /* 371269 */     // GIR_Coverage, 1200,
     /* 371269 */     GIR_Done,
     /* 371270 */   // Label 7499: @371270
     /* 371270 */   GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(371524), // Rule ID 6976 //
     /* 371275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 371278 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 371278 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 371281 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 371285 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371290 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 371294 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 371296 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 371299 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 371303 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371308 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 371312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 371314 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 371317 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 371321 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371326 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 371329 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 371332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 371334 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 371337 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371341 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371346 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 371352 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371357 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371362 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 371365 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 371369 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371374 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 371377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 371379 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 371382 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371386 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371391 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 371397 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371402 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371407 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 371410 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 371414 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371419 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 371422 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 371424 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 371427 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 371431 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371436 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 371439 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 371442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 371444 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 371447 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 371451 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371456 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 371459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 371461 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 371464 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 371468 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 371475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 371478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 371482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371487 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 371490 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 371493 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 371496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 371514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371519 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 371522 */     GIR_RootConstrainSelectedInstOperands,
     /* 371523 */     // GIR_Coverage, 6976,
     /* 371523 */     GIR_EraseRootFromParent_Done,
     /* 371524 */   // Label 7500: @371524
     /* 371524 */   GIM_Reject,
     /* 371525 */ // Label 7498: @371525
     /* 371525 */ GIM_Reject,
     /* 371526 */ // Label 7481: @371526
     /* 371526 */ GIM_Reject,
     /* 371527 */ // Label 102: @371527
     /* 371527 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7509*/ GIMT_Encode4(372142),
     /* 371538 */ /*GILLT_s16*//*Label 7501*/ GIMT_Encode4(371578),
     /* 371542 */ /*GILLT_s32*//*Label 7502*/ GIMT_Encode4(371616),
     /* 371546 */ /*GILLT_s64*//*Label 7503*/ GIMT_Encode4(371654), GIMT_Encode4(0),
     /* 371554 */ /*GILLT_v2s32*//*Label 7504*/ GIMT_Encode4(371692),
     /* 371558 */ /*GILLT_v2s64*//*Label 7505*/ GIMT_Encode4(371730),
     /* 371562 */ /*GILLT_v4s16*//*Label 7506*/ GIMT_Encode4(371768),
     /* 371566 */ /*GILLT_v4s32*//*Label 7507*/ GIMT_Encode4(371806), GIMT_Encode4(0),
     /* 371574 */ /*GILLT_v8s16*//*Label 7508*/ GIMT_Encode4(371844),
     /* 371578 */ // Label 7501: @371578
     /* 371578 */ GIM_Try, /*On fail goto*//*Label 7510*/ GIMT_Encode4(371615), // Rule ID 631 //
     /* 371583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 371586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 371589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371604 */   // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 371604 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 371609 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371613 */   GIR_RootConstrainSelectedInstOperands,
     /* 371614 */   // GIR_Coverage, 631,
     /* 371614 */   GIR_Done,
     /* 371615 */ // Label 7510: @371615
     /* 371615 */ GIM_Reject,
     /* 371616 */ // Label 7502: @371616
     /* 371616 */ GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(371653), // Rule ID 633 //
     /* 371621 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 371627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371638 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 371642 */   // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 371642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 371647 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371651 */   GIR_RootConstrainSelectedInstOperands,
     /* 371652 */   // GIR_Coverage, 633,
     /* 371652 */   GIR_Done,
     /* 371653 */ // Label 7511: @371653
     /* 371653 */ GIM_Reject,
     /* 371654 */ // Label 7503: @371654
     /* 371654 */ GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(371691), // Rule ID 635 //
     /* 371659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 371662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 371665 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 371668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371676 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371680 */   // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 371680 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 371685 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371689 */   GIR_RootConstrainSelectedInstOperands,
     /* 371690 */   // GIR_Coverage, 635,
     /* 371690 */   GIR_Done,
     /* 371691 */ // Label 7512: @371691
     /* 371691 */ GIM_Reject,
     /* 371692 */ // Label 7504: @371692
     /* 371692 */ GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(371729), // Rule ID 1342 //
     /* 371697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 371703 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 371706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371710 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371714 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371718 */   // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 371718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 371723 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371727 */   GIR_RootConstrainSelectedInstOperands,
     /* 371728 */   // GIR_Coverage, 1342,
     /* 371728 */   GIR_Done,
     /* 371729 */ // Label 7513: @371729
     /* 371729 */ GIM_Reject,
     /* 371730 */ // Label 7505: @371730
     /* 371730 */ GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(371767), // Rule ID 1346 //
     /* 371735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 371741 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 371744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371752 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371756 */   // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 371756 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 371761 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371765 */   GIR_RootConstrainSelectedInstOperands,
     /* 371766 */   // GIR_Coverage, 1346,
     /* 371766 */   GIR_Done,
     /* 371767 */ // Label 7514: @371767
     /* 371767 */ GIM_Reject,
     /* 371768 */ // Label 7506: @371768
     /* 371768 */ GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(371805), // Rule ID 1338 //
     /* 371773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 371779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 371782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371790 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371794 */   // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 371794 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 371799 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371803 */   GIR_RootConstrainSelectedInstOperands,
     /* 371804 */   // GIR_Coverage, 1338,
     /* 371804 */   GIR_Done,
     /* 371805 */ // Label 7515: @371805
     /* 371805 */ GIM_Reject,
     /* 371806 */ // Label 7507: @371806
     /* 371806 */ GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(371843), // Rule ID 1344 //
     /* 371811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 371814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 371817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 371820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371828 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371832 */   // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 371832 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 371837 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371841 */   GIR_RootConstrainSelectedInstOperands,
     /* 371842 */   // GIR_Coverage, 1344,
     /* 371842 */   GIR_Done,
     /* 371843 */ // Label 7516: @371843
     /* 371843 */ GIM_Reject,
     /* 371844 */ // Label 7508: @371844
     /* 371844 */ GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(372141),
     /* 371849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 371855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371859 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371863 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371867 */   GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(371886), // Rule ID 1340 //
     /* 371872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 371875 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 371875 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 371880 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 371884 */     GIR_RootConstrainSelectedInstOperands,
     /* 371885 */     // GIR_Coverage, 1340,
     /* 371885 */     GIR_Done,
     /* 371886 */   // Label 7518: @371886
     /* 371886 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(372140), // Rule ID 6982 //
     /* 371891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 371894 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 371894 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 371897 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 371901 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371906 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 371910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 371912 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 371915 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 371919 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371924 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 371928 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 371930 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 371933 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 371937 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371942 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 371945 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 371948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 371950 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 371953 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371957 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371962 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 371968 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371973 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371978 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 371981 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 371985 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371990 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 371993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 371995 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 371998 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372002 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372007 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 372013 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372018 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372023 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 372026 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 372030 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372035 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 372038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 372040 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 372043 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 372047 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372052 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 372055 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 372058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 372060 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 372063 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 372067 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372072 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 372075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 372077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 372080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 372084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 372091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 372094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 372098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372103 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 372106 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 372109 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 372112 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372117 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372122 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 372127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 372130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372132 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372135 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 372138 */     GIR_RootConstrainSelectedInstOperands,
     /* 372139 */     // GIR_Coverage, 6982,
     /* 372139 */     GIR_EraseRootFromParent_Done,
     /* 372140 */   // Label 7519: @372140
     /* 372140 */   GIM_Reject,
     /* 372141 */ // Label 7517: @372141
     /* 372141 */ GIM_Reject,
     /* 372142 */ // Label 7509: @372142
     /* 372142 */ GIM_Reject,
     /* 372143 */ // Label 103: @372143
     /* 372143 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7528*/ GIMT_Encode4(375864),
     /* 372154 */ /*GILLT_s16*//*Label 7520*/ GIMT_Encode4(372194),
     /* 372158 */ /*GILLT_s32*//*Label 7521*/ GIMT_Encode4(372748),
     /* 372162 */ /*GILLT_s64*//*Label 7522*/ GIMT_Encode4(373296), GIMT_Encode4(0),
     /* 372170 */ /*GILLT_v2s32*//*Label 7523*/ GIMT_Encode4(373844),
     /* 372174 */ /*GILLT_v2s64*//*Label 7524*/ GIMT_Encode4(374374),
     /* 372178 */ /*GILLT_v4s16*//*Label 7525*/ GIMT_Encode4(374732),
     /* 372182 */ /*GILLT_v4s32*//*Label 7526*/ GIMT_Encode4(375074), GIMT_Encode4(0),
     /* 372190 */ /*GILLT_v8s16*//*Label 7527*/ GIMT_Encode4(375432),
     /* 372194 */ // Label 7520: @372194
     /* 372194 */ GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(372747),
     /* 372199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 372202 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372209 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(372322), // Rule ID 6209 //
     /* 372214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372221 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372225 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372229 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372233 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372238 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372258 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372263 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372267 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372271 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372275 */     // MIs[3] Operand 1
     /* 372275 */     // No operand predicates
     /* 372275 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372277 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 372277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372289 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 372295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 372308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372320 */     GIR_RootConstrainSelectedInstOperands,
     /* 372321 */     // GIR_Coverage, 6209,
     /* 372321 */     GIR_EraseRootFromParent_Done,
     /* 372322 */   // Label 7530: @372322
     /* 372322 */   GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(372435), // Rule ID 13839 //
     /* 372327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372346 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372359 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372363 */     // MIs[2] Operand 1
     /* 372363 */     // No operand predicates
     /* 372363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372371 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372375 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 372379 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372384 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 372388 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372390 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 372390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372402 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 372408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372413 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 372421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372430 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372433 */     GIR_RootConstrainSelectedInstOperands,
     /* 372434 */     // GIR_Coverage, 13839,
     /* 372434 */     GIR_EraseRootFromParent_Done,
     /* 372435 */   // Label 7531: @372435
     /* 372435 */   GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(372514), // Rule ID 13776 //
     /* 372440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 372443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372464 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372474 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 372474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372486 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 372492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 372505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372512 */     GIR_RootConstrainSelectedInstOperands,
     /* 372513 */     // GIR_Coverage, 13776,
     /* 372513 */     GIR_EraseRootFromParent_Done,
     /* 372514 */   // Label 7532: @372514
     /* 372514 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(372593), // Rule ID 4788 //
     /* 372519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 372522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372547 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 372553 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 372553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372565 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 372571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 372584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372591 */     GIR_RootConstrainSelectedInstOperands,
     /* 372592 */     // GIR_Coverage, 4788,
     /* 372592 */     GIR_EraseRootFromParent_Done,
     /* 372593 */   // Label 7533: @372593
     /* 372593 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(372656), // Rule ID 13391 //
     /* 372598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 372622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372630 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372634 */     // MIs[2] Operand 1
     /* 372634 */     // No operand predicates
     /* 372634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372640 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 372640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 372643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 372647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372654 */     GIR_RootConstrainSelectedInstOperands,
     /* 372655 */     // GIR_Coverage, 13391,
     /* 372655 */     GIR_EraseRootFromParent_Done,
     /* 372656 */   // Label 7534: @372656
     /* 372656 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(372719), // Rule ID 2011 //
     /* 372661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 372664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 372672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372676 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 372680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372684 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 372689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372697 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 372701 */     // MIs[2] Operand 1
     /* 372701 */     // No operand predicates
     /* 372701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372703 */     // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 372703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 372706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372708 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 372710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372717 */     GIR_RootConstrainSelectedInstOperands,
     /* 372718 */     // GIR_Coverage, 2011,
     /* 372718 */     GIR_EraseRootFromParent_Done,
     /* 372719 */   // Label 7535: @372719
     /* 372719 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(372746), // Rule ID 619 //
     /* 372724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 372727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372735 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 372735 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 372740 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 372744 */     GIR_RootConstrainSelectedInstOperands,
     /* 372745 */     // GIR_Coverage, 619,
     /* 372745 */     GIR_Done,
     /* 372746 */   // Label 7536: @372746
     /* 372746 */   GIM_Reject,
     /* 372747 */ // Label 7529: @372747
     /* 372747 */ GIM_Reject,
     /* 372748 */ // Label 7521: @372748
     /* 372748 */ GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(373295),
     /* 372753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 372756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372759 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372763 */   GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(372876), // Rule ID 6211 //
     /* 372768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372792 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 372796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 372812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 372821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372825 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372829 */     // MIs[3] Operand 1
     /* 372829 */     // No operand predicates
     /* 372829 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372831 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 372831 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 372834 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372838 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372843 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 372849 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372854 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 372862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 372871 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 372874 */     GIR_RootConstrainSelectedInstOperands,
     /* 372875 */     // GIR_Coverage, 6211,
     /* 372875 */     GIR_EraseRootFromParent_Done,
     /* 372876 */   // Label 7538: @372876
     /* 372876 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(372989), // Rule ID 13841 //
     /* 372881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 372884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372892 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372896 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 372900 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 372909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 372913 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 372917 */     // MIs[2] Operand 1
     /* 372917 */     // No operand predicates
     /* 372917 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 372921 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 372925 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 372929 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 372933 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372938 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 372942 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 372944 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 372944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 372947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 372951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372956 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 372962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 372967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 372975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 372977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 372984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 372987 */     GIR_RootConstrainSelectedInstOperands,
     /* 372988 */     // GIR_Coverage, 13841,
     /* 372988 */     GIR_EraseRootFromParent_Done,
     /* 372989 */   // Label 7539: @372989
     /* 372989 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(373065), // Rule ID 13778 //
     /* 372994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373015 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373023 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373025 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 373025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 373028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373037 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 373043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 373056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373060 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373063 */     GIR_RootConstrainSelectedInstOperands,
     /* 373064 */     // GIR_Coverage, 13778,
     /* 373064 */     GIR_EraseRootFromParent_Done,
     /* 373065 */   // Label 7540: @373065
     /* 373065 */   GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(373141), // Rule ID 4790 //
     /* 373070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373095 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373101 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 373101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 373104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373113 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 373119 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373124 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 373132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373136 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373139 */     GIR_RootConstrainSelectedInstOperands,
     /* 373140 */     // GIR_Coverage, 4790,
     /* 373140 */     GIR_EraseRootFromParent_Done,
     /* 373141 */   // Label 7541: @373141
     /* 373141 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(373204), // Rule ID 13393 //
     /* 373146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373178 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373182 */     // MIs[2] Operand 1
     /* 373182 */     // No operand predicates
     /* 373182 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373188 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 373191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373202 */     GIR_RootConstrainSelectedInstOperands,
     /* 373203 */     // GIR_Coverage, 13393,
     /* 373203 */     GIR_EraseRootFromParent_Done,
     /* 373204 */   // Label 7542: @373204
     /* 373204 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(373267), // Rule ID 2013 //
     /* 373209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373212 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373228 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373237 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373241 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373245 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373249 */     // MIs[2] Operand 1
     /* 373249 */     // No operand predicates
     /* 373249 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373251 */     // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 373254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373265 */     GIR_RootConstrainSelectedInstOperands,
     /* 373266 */     // GIR_Coverage, 2013,
     /* 373266 */     GIR_EraseRootFromParent_Done,
     /* 373267 */   // Label 7543: @373267
     /* 373267 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(373294), // Rule ID 621 //
     /* 373272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 373283 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 373283 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 373288 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373292 */     GIR_RootConstrainSelectedInstOperands,
     /* 373293 */     // GIR_Coverage, 621,
     /* 373293 */     GIR_Done,
     /* 373294 */   // Label 7544: @373294
     /* 373294 */   GIM_Reject,
     /* 373295 */ // Label 7537: @373295
     /* 373295 */ GIM_Reject,
     /* 373296 */ // Label 7522: @373296
     /* 373296 */ GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(373843),
     /* 373301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 373304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 373307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373311 */   GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(373424), // Rule ID 6213 //
     /* 373316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373331 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373335 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373340 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373365 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373369 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373373 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 373377 */     // MIs[3] Operand 1
     /* 373377 */     // No operand predicates
     /* 373377 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373379 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 373379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373391 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 373397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 373410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373419 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373422 */     GIR_RootConstrainSelectedInstOperands,
     /* 373423 */     // GIR_Coverage, 6213,
     /* 373423 */     GIR_EraseRootFromParent_Done,
     /* 373424 */   // Label 7546: @373424
     /* 373424 */   GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(373537), // Rule ID 13843 //
     /* 373429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373461 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 373465 */     // MIs[2] Operand 1
     /* 373465 */     // No operand predicates
     /* 373465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 373469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373473 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373477 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 373481 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373486 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 373490 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373492 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 373492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373504 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 373510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 373523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373535 */     GIR_RootConstrainSelectedInstOperands,
     /* 373536 */     // GIR_Coverage, 13843,
     /* 373536 */     GIR_EraseRootFromParent_Done,
     /* 373537 */   // Label 7547: @373537
     /* 373537 */   GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(373613), // Rule ID 13780 //
     /* 373542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373554 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373563 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373571 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373573 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 373573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373585 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 373591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 373604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373608 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373611 */     GIR_RootConstrainSelectedInstOperands,
     /* 373612 */     // GIR_Coverage, 13780,
     /* 373612 */     GIR_EraseRootFromParent_Done,
     /* 373613 */   // Label 7548: @373613
     /* 373613 */   GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(373689), // Rule ID 4792 //
     /* 373618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373634 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373643 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 373647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 373649 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 373649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 373652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373661 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 373667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373672 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 373680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373682 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373687 */     GIR_RootConstrainSelectedInstOperands,
     /* 373688 */     // GIR_Coverage, 4792,
     /* 373688 */     GIR_EraseRootFromParent_Done,
     /* 373689 */   // Label 7549: @373689
     /* 373689 */   GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(373752), // Rule ID 13395 //
     /* 373694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373726 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 373730 */     // MIs[2] Operand 1
     /* 373730 */     // No operand predicates
     /* 373730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373734 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373736 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 373739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373750 */     GIR_RootConstrainSelectedInstOperands,
     /* 373751 */     // GIR_Coverage, 13395,
     /* 373751 */     GIR_EraseRootFromParent_Done,
     /* 373752 */   // Label 7550: @373752
     /* 373752 */   GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(373815), // Rule ID 2015 //
     /* 373757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 373776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373793 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 373797 */     // MIs[2] Operand 1
     /* 373797 */     // No operand predicates
     /* 373797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373799 */     // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 373802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 373810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 373813 */     GIR_RootConstrainSelectedInstOperands,
     /* 373814 */     // GIR_Coverage, 2015,
     /* 373814 */     GIR_EraseRootFromParent_Done,
     /* 373815 */   // Label 7551: @373815
     /* 373815 */   GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(373842), // Rule ID 623 //
     /* 373820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 373823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373831 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 373831 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 373836 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 373840 */     GIR_RootConstrainSelectedInstOperands,
     /* 373841 */     // GIR_Coverage, 623,
     /* 373841 */     GIR_Done,
     /* 373842 */   // Label 7552: @373842
     /* 373842 */   GIM_Reject,
     /* 373843 */ // Label 7545: @373843
     /* 373843 */ GIM_Reject,
     /* 373844 */ // Label 7523: @373844
     /* 373844 */ GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(374373),
     /* 373849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 373852 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 373855 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373859 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(373945), // Rule ID 13383 //
     /* 373864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 373875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373900 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373904 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373908 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 373912 */     // MIs[3] Operand 1
     /* 373912 */     // No operand predicates
     /* 373912 */     // MIs[1] Operand 2
     /* 373912 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 373923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373927 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373929 */     // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 373929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 373932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 373934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 373936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 373940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373943 */     GIR_RootConstrainSelectedInstOperands,
     /* 373944 */     // GIR_Coverage, 13383,
     /* 373944 */     GIR_EraseRootFromParent_Done,
     /* 373945 */   // Label 7554: @373945
     /* 373945 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(374031), // Rule ID 2003 //
     /* 373950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 373965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 373973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 373977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 373981 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373985 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373990 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373994 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373998 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 374002 */     // MIs[3] Operand 1
     /* 374002 */     // No operand predicates
     /* 374002 */     // MIs[1] Operand 2
     /* 374002 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 374013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374015 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 374018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374029 */     GIR_RootConstrainSelectedInstOperands,
     /* 374030 */     // GIR_Coverage, 2003,
     /* 374030 */     GIR_EraseRootFromParent_Done,
     /* 374031 */   // Label 7555: @374031
     /* 374031 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(374094), // Rule ID 13384 //
     /* 374036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 374047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374068 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 374072 */     // MIs[2] Operand 1
     /* 374072 */     // No operand predicates
     /* 374072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374076 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374078 */     // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 374081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374089 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374092 */     GIR_RootConstrainSelectedInstOperands,
     /* 374093 */     // GIR_Coverage, 13384,
     /* 374093 */     GIR_EraseRootFromParent_Done,
     /* 374094 */   // Label 7556: @374094
     /* 374094 */   GIM_Try, /*On fail goto*//*Label 7557*/ GIMT_Encode4(374157), // Rule ID 2004 //
     /* 374099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374102 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 374114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 374118 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374135 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 374139 */     // MIs[2] Operand 1
     /* 374139 */     // No operand predicates
     /* 374139 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374141 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 374144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374146 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374155 */     GIR_RootConstrainSelectedInstOperands,
     /* 374156 */     // GIR_Coverage, 2004,
     /* 374156 */     GIR_EraseRootFromParent_Done,
     /* 374157 */   // Label 7557: @374157
     /* 374157 */   GIM_Try, /*On fail goto*//*Label 7558*/ GIMT_Encode4(374251), // Rule ID 13845 //
     /* 374162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374183 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374185 */     // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374185 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 374188 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374192 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374197 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374199 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 374202 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374206 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374211 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374214 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374218 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374226 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 374239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374249 */     GIR_RootConstrainSelectedInstOperands,
     /* 374250 */     // GIR_Coverage, 13845,
     /* 374250 */     GIR_EraseRootFromParent_Done,
     /* 374251 */   // Label 7558: @374251
     /* 374251 */   GIM_Try, /*On fail goto*//*Label 7559*/ GIMT_Encode4(374345), // Rule ID 6215 //
     /* 374256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 374272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374279 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374279 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 374282 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374286 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374291 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 374296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374305 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374308 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374312 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 374315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374320 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374325 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 374333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374335 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374337 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374340 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374343 */     GIR_RootConstrainSelectedInstOperands,
     /* 374344 */     // GIR_Coverage, 6215,
     /* 374344 */     GIR_EraseRootFromParent_Done,
     /* 374345 */   // Label 7559: @374345
     /* 374345 */   GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(374372), // Rule ID 1322 //
     /* 374350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374361 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 374361 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 374366 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374370 */     GIR_RootConstrainSelectedInstOperands,
     /* 374371 */     // GIR_Coverage, 1322,
     /* 374371 */     GIR_Done,
     /* 374372 */   // Label 7560: @374372
     /* 374372 */   GIM_Reject,
     /* 374373 */ // Label 7553: @374373
     /* 374373 */ GIM_Reject,
     /* 374374 */ // Label 7524: @374374
     /* 374374 */ GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(374731),
     /* 374379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 374385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374389 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(374452), // Rule ID 13389 //
     /* 374394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 374405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374426 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374430 */     // MIs[2] Operand 1
     /* 374430 */     // No operand predicates
     /* 374430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374434 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374436 */     // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 374439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374450 */     GIR_RootConstrainSelectedInstOperands,
     /* 374451 */     // GIR_Coverage, 13389,
     /* 374451 */     GIR_EraseRootFromParent_Done,
     /* 374452 */   // Label 7562: @374452
     /* 374452 */   GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(374515), // Rule ID 2009 //
     /* 374457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 374472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 374476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374493 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 374497 */     // MIs[2] Operand 1
     /* 374497 */     // No operand predicates
     /* 374497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374499 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 374502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374504 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374513 */     GIR_RootConstrainSelectedInstOperands,
     /* 374514 */     // GIR_Coverage, 2009,
     /* 374514 */     GIR_EraseRootFromParent_Done,
     /* 374515 */   // Label 7563: @374515
     /* 374515 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(374609), // Rule ID 13849 //
     /* 374520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 374532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374541 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374543 */     // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374543 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 374546 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374550 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 374560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374569 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374572 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374576 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 374579 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 374597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374607 */     GIR_RootConstrainSelectedInstOperands,
     /* 374608 */     // GIR_Coverage, 13849,
     /* 374608 */     GIR_EraseRootFromParent_Done,
     /* 374609 */   // Label 7564: @374609
     /* 374609 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(374703), // Rule ID 6219 //
     /* 374614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 374626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 374630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374637 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374637 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 374640 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374644 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 374654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374663 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374666 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374670 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 374673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374683 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 374691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374693 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374701 */     GIR_RootConstrainSelectedInstOperands,
     /* 374702 */     // GIR_Coverage, 6219,
     /* 374702 */     GIR_EraseRootFromParent_Done,
     /* 374703 */   // Label 7565: @374703
     /* 374703 */   GIM_Try, /*On fail goto*//*Label 7566*/ GIMT_Encode4(374730), // Rule ID 1326 //
     /* 374708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374711 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374719 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 374719 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 374724 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 374728 */     GIR_RootConstrainSelectedInstOperands,
     /* 374729 */     // GIR_Coverage, 1326,
     /* 374729 */     GIR_Done,
     /* 374730 */   // Label 7566: @374730
     /* 374730 */   GIM_Reject,
     /* 374731 */ // Label 7561: @374731
     /* 374731 */ GIM_Reject,
     /* 374732 */ // Label 7525: @374732
     /* 374732 */ GIM_Try, /*On fail goto*//*Label 7567*/ GIMT_Encode4(375073),
     /* 374737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 374740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 374743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374747 */   GIM_Try, /*On fail goto*//*Label 7568*/ GIMT_Encode4(374833), // Rule ID 13377 //
     /* 374752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 374763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 374775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374779 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374783 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 374788 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374792 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374796 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374800 */     // MIs[3] Operand 1
     /* 374800 */     // No operand predicates
     /* 374800 */     // MIs[1] Operand 2
     /* 374800 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 374811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374815 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374817 */     // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 374820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374828 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374831 */     GIR_RootConstrainSelectedInstOperands,
     /* 374832 */     // GIR_Coverage, 13377,
     /* 374832 */     GIR_EraseRootFromParent_Done,
     /* 374833 */   // Label 7568: @374833
     /* 374833 */   GIM_Try, /*On fail goto*//*Label 7569*/ GIMT_Encode4(374919), // Rule ID 1997 //
     /* 374838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 374853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 374861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 374865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 374873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 374878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 374882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374886 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374890 */     // MIs[3] Operand 1
     /* 374890 */     // No operand predicates
     /* 374890 */     // MIs[1] Operand 2
     /* 374890 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 374901 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 374903 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 374906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374908 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 374914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 374917 */     GIR_RootConstrainSelectedInstOperands,
     /* 374918 */     // GIR_Coverage, 1997,
     /* 374918 */     GIR_EraseRootFromParent_Done,
     /* 374919 */   // Label 7569: @374919
     /* 374919 */   GIM_Try, /*On fail goto*//*Label 7570*/ GIMT_Encode4(374982), // Rule ID 13378 //
     /* 374924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 374935 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 374939 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 374943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 374948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 374952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374956 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374960 */     // MIs[2] Operand 1
     /* 374960 */     // No operand predicates
     /* 374960 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374964 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374966 */     // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 374966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 374969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 374971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 374977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374980 */     GIR_RootConstrainSelectedInstOperands,
     /* 374981 */     // GIR_Coverage, 13378,
     /* 374981 */     GIR_EraseRootFromParent_Done,
     /* 374982 */   // Label 7570: @374982
     /* 374982 */   GIM_Try, /*On fail goto*//*Label 7571*/ GIMT_Encode4(375045), // Rule ID 1998 //
     /* 374987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 374990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 374994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 375002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 375015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375023 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375027 */     // MIs[2] Operand 1
     /* 375027 */     // No operand predicates
     /* 375027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375029 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 375029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 375032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375040 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375043 */     GIR_RootConstrainSelectedInstOperands,
     /* 375044 */     // GIR_Coverage, 1998,
     /* 375044 */     GIR_EraseRootFromParent_Done,
     /* 375045 */   // Label 7571: @375045
     /* 375045 */   GIM_Try, /*On fail goto*//*Label 7572*/ GIMT_Encode4(375072), // Rule ID 1318 //
     /* 375050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375061 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 375061 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 375066 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375070 */     GIR_RootConstrainSelectedInstOperands,
     /* 375071 */     // GIR_Coverage, 1318,
     /* 375071 */     GIR_Done,
     /* 375072 */   // Label 7572: @375072
     /* 375072 */   GIM_Reject,
     /* 375073 */ // Label 7567: @375073
     /* 375073 */ GIM_Reject,
     /* 375074 */ // Label 7526: @375074
     /* 375074 */ GIM_Try, /*On fail goto*//*Label 7573*/ GIMT_Encode4(375431),
     /* 375079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 375085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375089 */   GIM_Try, /*On fail goto*//*Label 7574*/ GIMT_Encode4(375152), // Rule ID 13387 //
     /* 375094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 375105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375126 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 375130 */     // MIs[2] Operand 1
     /* 375130 */     // No operand predicates
     /* 375130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375136 */     // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 375136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 375139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375150 */     GIR_RootConstrainSelectedInstOperands,
     /* 375151 */     // GIR_Coverage, 13387,
     /* 375151 */     GIR_EraseRootFromParent_Done,
     /* 375152 */   // Label 7574: @375152
     /* 375152 */   GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(375215), // Rule ID 2007 //
     /* 375157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375160 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375164 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375168 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 375172 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 375176 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375193 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 375197 */     // MIs[2] Operand 1
     /* 375197 */     // No operand predicates
     /* 375197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375199 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 375199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 375202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375210 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375213 */     GIR_RootConstrainSelectedInstOperands,
     /* 375214 */     // GIR_Coverage, 2007,
     /* 375214 */     GIR_EraseRootFromParent_Done,
     /* 375215 */   // Label 7575: @375215
     /* 375215 */   GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(375309), // Rule ID 13847 //
     /* 375220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 375228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375232 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375243 */     // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375243 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 375246 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375250 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375255 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 375257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 375260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375269 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 375272 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375276 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 375279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375289 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 375297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375301 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375307 */     GIR_RootConstrainSelectedInstOperands,
     /* 375308 */     // GIR_Coverage, 13847,
     /* 375308 */     GIR_EraseRootFromParent_Done,
     /* 375309 */   // Label 7576: @375309
     /* 375309 */   GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(375403), // Rule ID 6217 //
     /* 375314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 375326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 375330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 375337 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 375337 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 375340 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375344 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375349 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 375351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 375354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375363 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 375366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375370 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 375373 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375378 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375383 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 375391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375401 */     GIR_RootConstrainSelectedInstOperands,
     /* 375402 */     // GIR_Coverage, 6217,
     /* 375402 */     GIR_EraseRootFromParent_Done,
     /* 375403 */   // Label 7577: @375403
     /* 375403 */   GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(375430), // Rule ID 1324 //
     /* 375408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 375411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375419 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 375419 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 375424 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375428 */     GIR_RootConstrainSelectedInstOperands,
     /* 375429 */     // GIR_Coverage, 1324,
     /* 375429 */     GIR_Done,
     /* 375430 */   // Label 7578: @375430
     /* 375430 */   GIM_Reject,
     /* 375431 */ // Label 7573: @375431
     /* 375431 */ GIM_Reject,
     /* 375432 */ // Label 7527: @375432
     /* 375432 */ GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(375863),
     /* 375437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375440 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 375443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375447 */   GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(375510), // Rule ID 13381 //
     /* 375452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375455 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375459 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 375463 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375467 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 375476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375484 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375488 */     // MIs[2] Operand 1
     /* 375488 */     // No operand predicates
     /* 375488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375494 */     // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 375494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 375497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 375501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375508 */     GIR_RootConstrainSelectedInstOperands,
     /* 375509 */     // GIR_Coverage, 13381,
     /* 375509 */     GIR_EraseRootFromParent_Done,
     /* 375510 */   // Label 7580: @375510
     /* 375510 */   GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(375573), // Rule ID 2001 //
     /* 375515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 375526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 375530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 375534 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 375538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 375543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 375547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 375551 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 375555 */     // MIs[2] Operand 1
     /* 375555 */     // No operand predicates
     /* 375555 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375557 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 375557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 375560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 375562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 375564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 375568 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 375571 */     GIR_RootConstrainSelectedInstOperands,
     /* 375572 */     // GIR_Coverage, 2001,
     /* 375572 */     GIR_EraseRootFromParent_Done,
     /* 375573 */   // Label 7581: @375573
     /* 375573 */   GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(375600), // Rule ID 1320 //
     /* 375578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 375581 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375589 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 375589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 375594 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375598 */     GIR_RootConstrainSelectedInstOperands,
     /* 375599 */     // GIR_Coverage, 1320,
     /* 375599 */     GIR_Done,
     /* 375600 */   // Label 7582: @375600
     /* 375600 */   GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(375862), // Rule ID 6980 //
     /* 375605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 375608 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375616 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 375616 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 375619 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 375623 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375628 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 375632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 375634 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 375637 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 375641 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375646 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 375650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 375652 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 375655 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 375659 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375664 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 375667 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 375670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 375672 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 375675 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375679 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375684 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 375690 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375695 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375700 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 375703 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 375707 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375712 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 375715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 375717 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 375720 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 375724 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375729 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 375735 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375740 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375745 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 375748 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 375752 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375757 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 375760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 375762 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 375765 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 375769 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375774 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 375777 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 375780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 375782 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 375785 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 375789 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375794 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 375797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 375799 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 375802 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 375806 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 375813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 375816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 375820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375825 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 375828 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 375831 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 375834 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 375849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 375852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 375860 */     GIR_RootConstrainSelectedInstOperands,
     /* 375861 */     // GIR_Coverage, 6980,
     /* 375861 */     GIR_EraseRootFromParent_Done,
     /* 375862 */   // Label 7583: @375862
     /* 375862 */   GIM_Reject,
     /* 375863 */ // Label 7579: @375863
     /* 375863 */ GIM_Reject,
     /* 375864 */ // Label 7528: @375864
     /* 375864 */ GIM_Reject,
     /* 375865 */ // Label 104: @375865
     /* 375865 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7592*/ GIMT_Encode4(376480),
     /* 375876 */ /*GILLT_s16*//*Label 7584*/ GIMT_Encode4(375916),
     /* 375880 */ /*GILLT_s32*//*Label 7585*/ GIMT_Encode4(375954),
     /* 375884 */ /*GILLT_s64*//*Label 7586*/ GIMT_Encode4(375992), GIMT_Encode4(0),
     /* 375892 */ /*GILLT_v2s32*//*Label 7587*/ GIMT_Encode4(376030),
     /* 375896 */ /*GILLT_v2s64*//*Label 7588*/ GIMT_Encode4(376068),
     /* 375900 */ /*GILLT_v4s16*//*Label 7589*/ GIMT_Encode4(376106),
     /* 375904 */ /*GILLT_v4s32*//*Label 7590*/ GIMT_Encode4(376144), GIMT_Encode4(0),
     /* 375912 */ /*GILLT_v8s16*//*Label 7591*/ GIMT_Encode4(376182),
     /* 375916 */ // Label 7584: @375916
     /* 375916 */ GIM_Try, /*On fail goto*//*Label 7593*/ GIMT_Encode4(375953), // Rule ID 589 //
     /* 375921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 375924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 375927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 375930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 375942 */   // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 375942 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 375947 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375951 */   GIR_RootConstrainSelectedInstOperands,
     /* 375952 */   // GIR_Coverage, 589,
     /* 375952 */   GIR_Done,
     /* 375953 */ // Label 7593: @375953
     /* 375953 */ GIM_Reject,
     /* 375954 */ // Label 7585: @375954
     /* 375954 */ GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(375991), // Rule ID 591 //
     /* 375959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 375962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 375965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375976 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 375980 */   // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 375980 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 375985 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 375989 */   GIR_RootConstrainSelectedInstOperands,
     /* 375990 */   // GIR_Coverage, 591,
     /* 375990 */   GIR_Done,
     /* 375991 */ // Label 7594: @375991
     /* 375991 */ GIM_Reject,
     /* 375992 */ // Label 7586: @375992
     /* 375992 */ GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(376029), // Rule ID 593 //
     /* 375997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 376000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 376003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 376006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376014 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376018 */   // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 376018 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 376023 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376027 */   GIR_RootConstrainSelectedInstOperands,
     /* 376028 */   // GIR_Coverage, 593,
     /* 376028 */   GIR_Done,
     /* 376029 */ // Label 7595: @376029
     /* 376029 */ GIM_Reject,
     /* 376030 */ // Label 7587: @376030
     /* 376030 */ GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(376067), // Rule ID 1227 //
     /* 376035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 376041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 376044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376056 */   // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 376056 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 376061 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376065 */   GIR_RootConstrainSelectedInstOperands,
     /* 376066 */   // GIR_Coverage, 1227,
     /* 376066 */   GIR_Done,
     /* 376067 */ // Label 7596: @376067
     /* 376067 */ GIM_Reject,
     /* 376068 */ // Label 7588: @376068
     /* 376068 */ GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(376105), // Rule ID 1231 //
     /* 376073 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 376079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 376082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376090 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376094 */   // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 376094 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 376099 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376103 */   GIR_RootConstrainSelectedInstOperands,
     /* 376104 */   // GIR_Coverage, 1231,
     /* 376104 */   GIR_Done,
     /* 376105 */ // Label 7597: @376105
     /* 376105 */ GIM_Reject,
     /* 376106 */ // Label 7589: @376106
     /* 376106 */ GIM_Try, /*On fail goto*//*Label 7598*/ GIMT_Encode4(376143), // Rule ID 1223 //
     /* 376111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 376117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 376120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376128 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376132 */   // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 376132 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 376137 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376141 */   GIR_RootConstrainSelectedInstOperands,
     /* 376142 */   // GIR_Coverage, 1223,
     /* 376142 */   GIR_Done,
     /* 376143 */ // Label 7598: @376143
     /* 376143 */ GIM_Reject,
     /* 376144 */ // Label 7590: @376144
     /* 376144 */ GIM_Try, /*On fail goto*//*Label 7599*/ GIMT_Encode4(376181), // Rule ID 1229 //
     /* 376149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 376155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 376158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376166 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376170 */   // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 376170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 376175 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376179 */   GIR_RootConstrainSelectedInstOperands,
     /* 376180 */   // GIR_Coverage, 1229,
     /* 376180 */   GIR_Done,
     /* 376181 */ // Label 7599: @376181
     /* 376181 */ GIM_Reject,
     /* 376182 */ // Label 7591: @376182
     /* 376182 */ GIM_Try, /*On fail goto*//*Label 7600*/ GIMT_Encode4(376479),
     /* 376187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376190 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 376193 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376197 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376201 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376205 */   GIM_Try, /*On fail goto*//*Label 7601*/ GIMT_Encode4(376224), // Rule ID 1225 //
     /* 376210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 376213 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 376213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 376218 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 376222 */     GIR_RootConstrainSelectedInstOperands,
     /* 376223 */     // GIR_Coverage, 1225,
     /* 376223 */     GIR_Done,
     /* 376224 */   // Label 7601: @376224
     /* 376224 */   GIM_Try, /*On fail goto*//*Label 7602*/ GIMT_Encode4(376478), // Rule ID 6978 //
     /* 376229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 376232 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 376232 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 376235 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 376239 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376244 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 376248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 376250 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 376253 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 376257 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376262 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 376266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 376268 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 376271 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 376275 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376280 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 376283 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 376286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 376288 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 376291 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376295 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376300 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 376306 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376311 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376316 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 376319 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 376323 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376328 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 376331 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 376333 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 376336 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376340 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376345 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 376351 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376356 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376361 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 376364 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 376368 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376373 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 376376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 376378 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 376381 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 376385 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376390 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 376393 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 376396 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 376398 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 376401 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 376405 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376410 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 376413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 376415 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 376418 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 376422 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376427 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 376429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 376432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 376436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376441 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 376444 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 376447 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 376450 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376455 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376460 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 376465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 376468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 376476 */     GIR_RootConstrainSelectedInstOperands,
     /* 376477 */     // GIR_Coverage, 6978,
     /* 376477 */     GIR_EraseRootFromParent_Done,
     /* 376478 */   // Label 7602: @376478
     /* 376478 */   GIM_Reject,
     /* 376479 */ // Label 7600: @376479
     /* 376479 */ GIM_Reject,
     /* 376480 */ // Label 7592: @376480
     /* 376480 */ GIM_Reject,
     /* 376481 */ // Label 105: @376481
     /* 376481 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7611*/ GIMT_Encode4(392087),
     /* 376492 */ /*GILLT_s16*//*Label 7603*/ GIMT_Encode4(376532),
     /* 376496 */ /*GILLT_s32*//*Label 7604*/ GIMT_Encode4(379306),
     /* 376500 */ /*GILLT_s64*//*Label 7605*/ GIMT_Encode4(382236), GIMT_Encode4(0),
     /* 376508 */ /*GILLT_v2s32*//*Label 7606*/ GIMT_Encode4(385166),
     /* 376512 */ /*GILLT_v2s64*//*Label 7607*/ GIMT_Encode4(386687),
     /* 376516 */ /*GILLT_v4s16*//*Label 7608*/ GIMT_Encode4(388208),
     /* 376520 */ /*GILLT_v4s32*//*Label 7609*/ GIMT_Encode4(389387), GIMT_Encode4(0),
     /* 376528 */ /*GILLT_v8s16*//*Label 7610*/ GIMT_Encode4(390908),
     /* 376532 */ // Label 7603: @376532
     /* 376532 */ GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(379305),
     /* 376537 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 376540 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 376543 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 376546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376550 */   GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(376700), // Rule ID 4850 //
     /* 376555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 376558 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376562 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376566 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376570 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376574 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376579 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 376583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376595 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376599 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376604 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 376608 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 376612 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376616 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 376620 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376625 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376627 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 376627 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 376630 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376634 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376639 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 376645 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376650 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376667 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 376686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 376694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 376698 */     GIR_RootConstrainSelectedInstOperands,
     /* 376699 */     // GIR_Coverage, 4850,
     /* 376699 */     GIR_EraseRootFromParent_Done,
     /* 376700 */   // Label 7613: @376700
     /* 376700 */   GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(376847), // Rule ID 4814 //
     /* 376705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 376708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376729 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 376733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 376745 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 376749 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376753 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376757 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 376761 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376766 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 376770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376774 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376776 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 376776 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 376779 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376783 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376788 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 376794 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376799 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376804 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376807 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376811 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376816 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 376835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 376843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 376845 */     GIR_RootConstrainSelectedInstOperands,
     /* 376846 */     // GIR_Coverage, 4814,
     /* 376846 */     GIR_EraseRootFromParent_Done,
     /* 376847 */   // Label 7614: @376847
     /* 376847 */   GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(376994), // Rule ID 13789 //
     /* 376852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 376855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 376863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 376867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 376871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376883 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376888 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 376892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 376896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376900 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 376904 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 376908 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376913 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 376917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376921 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376923 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 376923 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 376926 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376930 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376935 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 376941 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376946 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376951 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 376954 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376958 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376963 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 376969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 376974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 376982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 376984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376987 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 376990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 376992 */     GIR_RootConstrainSelectedInstOperands,
     /* 376993 */     // GIR_Coverage, 13789,
     /* 376993 */     GIR_EraseRootFromParent_Done,
     /* 376994 */   // Label 7615: @376994
     /* 376994 */   GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(377125), // Rule ID 6047 //
     /* 376999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377014 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377023 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377027 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377031 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377035 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 377039 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 377043 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377047 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377051 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 377055 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377060 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 377064 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377068 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377072 */     // MIs[4] Operand 1
     /* 377072 */     // No operand predicates
     /* 377072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377076 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 377078 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 377078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377090 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 377109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 377120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 377123 */     GIR_RootConstrainSelectedInstOperands,
     /* 377124 */     // GIR_Coverage, 6047,
     /* 377124 */     GIR_EraseRootFromParent_Done,
     /* 377125 */   // Label 7616: @377125
     /* 377125 */   GIM_Try, /*On fail goto*//*Label 7617*/ GIMT_Encode4(377256), // Rule ID 6079 //
     /* 377130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377158 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377162 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377166 */     // MIs[2] Operand 1
     /* 377166 */     // No operand predicates
     /* 377166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377174 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 377178 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 377182 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377186 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377190 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 377194 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377199 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 377203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377207 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 377209 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 377209 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377212 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377216 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377221 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377232 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 377240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377254 */     GIR_RootConstrainSelectedInstOperands,
     /* 377255 */     // GIR_Coverage, 6079,
     /* 377255 */     GIR_EraseRootFromParent_Done,
     /* 377256 */   // Label 7617: @377256
     /* 377256 */   GIM_Try, /*On fail goto*//*Label 7618*/ GIMT_Encode4(377387), // Rule ID 6143 //
     /* 377261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 377276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377288 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377292 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377297 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 377301 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377305 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377309 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377313 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 377317 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377322 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 377326 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377330 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377334 */     // MIs[4] Operand 1
     /* 377334 */     // No operand predicates
     /* 377334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377338 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 377340 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 377340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377352 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377358 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 377371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 377382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 377385 */     GIR_RootConstrainSelectedInstOperands,
     /* 377386 */     // GIR_Coverage, 6143,
     /* 377386 */     GIR_EraseRootFromParent_Done,
     /* 377387 */   // Label 7618: @377387
     /* 377387 */   GIM_Try, /*On fail goto*//*Label 7619*/ GIMT_Encode4(377518), // Rule ID 6111 //
     /* 377392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 377407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 377411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377415 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377419 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377423 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377428 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377432 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377436 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377440 */     // MIs[3] Operand 1
     /* 377440 */     // No operand predicates
     /* 377440 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 377444 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377448 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377452 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 377456 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377461 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 377465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377469 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 377471 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 377471 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377474 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377478 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377483 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377489 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377494 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 377502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377506 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377516 */     GIR_RootConstrainSelectedInstOperands,
     /* 377517 */     // GIR_Coverage, 6111,
     /* 377517 */     GIR_EraseRootFromParent_Done,
     /* 377518 */   // Label 7619: @377518
     /* 377518 */   GIM_Try, /*On fail goto*//*Label 7620*/ GIMT_Encode4(377653), // Rule ID 2453 //
     /* 377523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377534 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377538 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377547 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377563 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377567 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377572 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 377576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377582 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 377582 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 377585 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377589 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377594 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 377600 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377605 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377622 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 377641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377643 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 377649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 377651 */     GIR_RootConstrainSelectedInstOperands,
     /* 377652 */     // GIR_Coverage, 2453,
     /* 377652 */     GIR_EraseRootFromParent_Done,
     /* 377653 */   // Label 7620: @377653
     /* 377653 */   GIM_Try, /*On fail goto*//*Label 7621*/ GIMT_Encode4(377772), // Rule ID 6015 //
     /* 377658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377682 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377686 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377690 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377694 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377698 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 377702 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377707 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 377711 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377715 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377719 */     // MIs[3] Operand 1
     /* 377719 */     // No operand predicates
     /* 377719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377723 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377725 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 377725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377737 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 377756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377760 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 377770 */     GIR_RootConstrainSelectedInstOperands,
     /* 377771 */     // GIR_Coverage, 6015,
     /* 377771 */     GIR_EraseRootFromParent_Done,
     /* 377772 */   // Label 7621: @377772
     /* 377772 */   GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(377891), // Rule ID 2535 //
     /* 377777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 377780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 377801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377809 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 377813 */     // MIs[2] Operand 1
     /* 377813 */     // No operand predicates
     /* 377813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 377817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377821 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377825 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 377829 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377834 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 377838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377842 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377844 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 377844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377856 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 377875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 377879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 377886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377889 */     GIR_RootConstrainSelectedInstOperands,
     /* 377890 */     // GIR_Coverage, 2535,
     /* 377890 */     GIR_EraseRootFromParent_Done,
     /* 377891 */   // Label 7622: @377891
     /* 377891 */   GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(377991), // Rule ID 4812 //
     /* 377896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 377911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377920 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 377924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 377928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 377932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 377936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377947 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 377947 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 377950 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377954 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377959 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 377965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377970 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 377978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 377980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 377987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 377989 */     GIR_RootConstrainSelectedInstOperands,
     /* 377990 */     // GIR_Coverage, 4812,
     /* 377990 */     GIR_EraseRootFromParent_Done,
     /* 377991 */   // Label 7623: @377991
     /* 377991 */   GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(378091), // Rule ID 4848 //
     /* 377996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 377999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378020 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 378032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 378040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378047 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 378047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 378050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378059 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 378065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378070 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 378078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 378085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 378089 */     GIR_RootConstrainSelectedInstOperands,
     /* 378090 */     // GIR_Coverage, 4848,
     /* 378090 */     GIR_EraseRootFromParent_Done,
     /* 378091 */   // Label 7624: @378091
     /* 378091 */   GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(378188), // Rule ID 13785 //
     /* 378096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 378111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378123 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378132 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 378136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378146 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 378146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 378149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378158 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 378164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 378177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378186 */     GIR_RootConstrainSelectedInstOperands,
     /* 378187 */     // GIR_Coverage, 13785,
     /* 378187 */     GIR_EraseRootFromParent_Done,
     /* 378188 */   // Label 7625: @378188
     /* 378188 */   GIM_Try, /*On fail goto*//*Label 7626*/ GIMT_Encode4(378288), // Rule ID 13787 //
     /* 378193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 378208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378225 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378234 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 378238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378244 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 378244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 378247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378256 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 378262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 378275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378286 */     GIR_RootConstrainSelectedInstOperands,
     /* 378287 */     // GIR_Coverage, 13787,
     /* 378287 */     GIR_EraseRootFromParent_Done,
     /* 378288 */   // Label 7626: @378288
     /* 378288 */   GIM_Try, /*On fail goto*//*Label 7627*/ GIMT_Encode4(378388), // Rule ID 4846 //
     /* 378293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378321 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 378329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 378337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378344 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 378344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 378347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378356 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 378362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378367 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 378375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 378386 */     GIR_RootConstrainSelectedInstOperands,
     /* 378387 */     // GIR_Coverage, 4846,
     /* 378387 */     GIR_EraseRootFromParent_Done,
     /* 378388 */   // Label 7627: @378388
     /* 378388 */   GIM_Try, /*On fail goto*//*Label 7628*/ GIMT_Encode4(378485), // Rule ID 4810 //
     /* 378393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 378412 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378416 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378420 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378424 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378428 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378433 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 378437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378443 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 378443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 378446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378455 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 378461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 378474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378483 */     GIR_RootConstrainSelectedInstOperands,
     /* 378484 */     // GIR_Coverage, 4810,
     /* 378484 */     GIR_EraseRootFromParent_Done,
     /* 378485 */   // Label 7628: @378485
     /* 378485 */   GIM_Try, /*On fail goto*//*Label 7629*/ GIMT_Encode4(378569), // Rule ID 6077 //
     /* 378490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 378518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378526 */     // MIs[2] Operand 1
     /* 378526 */     // No operand predicates
     /* 378526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 378530 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378534 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 378538 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378547 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378549 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 378552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 378560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 378564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 378567 */     GIR_RootConstrainSelectedInstOperands,
     /* 378568 */     // GIR_Coverage, 6077,
     /* 378568 */     GIR_EraseRootFromParent_Done,
     /* 378569 */   // Label 7629: @378569
     /* 378569 */   GIM_Try, /*On fail goto*//*Label 7630*/ GIMT_Encode4(378650), // Rule ID 6109 //
     /* 378574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378577 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378581 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378585 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 378589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378601 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378605 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378610 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378614 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378618 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378622 */     // MIs[3] Operand 1
     /* 378622 */     // No operand predicates
     /* 378622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378630 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378632 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 378635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 378641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 378648 */     GIR_RootConstrainSelectedInstOperands,
     /* 378649 */     // GIR_Coverage, 6109,
     /* 378649 */     GIR_EraseRootFromParent_Done,
     /* 378650 */   // Label 7630: @378650
     /* 378650 */   GIM_Try, /*On fail goto*//*Label 7631*/ GIMT_Encode4(378734), // Rule ID 6141 //
     /* 378655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 378670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378691 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378704 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378708 */     // MIs[3] Operand 1
     /* 378708 */     // No operand predicates
     /* 378708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378712 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378714 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 378717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 378725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 378732 */     GIR_RootConstrainSelectedInstOperands,
     /* 378733 */     // GIR_Coverage, 6141,
     /* 378733 */     GIR_EraseRootFromParent_Done,
     /* 378734 */   // Label 7631: @378734
     /* 378734 */   GIM_Try, /*On fail goto*//*Label 7632*/ GIMT_Encode4(378815), // Rule ID 6045 //
     /* 378739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378742 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 378754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 378758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 378762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378770 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 378774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 378779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 378783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 378787 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 378791 */     // MIs[3] Operand 1
     /* 378791 */     // No operand predicates
     /* 378791 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378795 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 378797 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 378797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 378800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 378804 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 378810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 378813 */     GIR_RootConstrainSelectedInstOperands,
     /* 378814 */     // GIR_Coverage, 6045,
     /* 378814 */     GIR_EraseRootFromParent_Done,
     /* 378815 */   // Label 7632: @378815
     /* 378815 */   GIM_Try, /*On fail goto*//*Label 7633*/ GIMT_Encode4(378900), // Rule ID 2451 //
     /* 378820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378835 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378844 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378858 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 378858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 378861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378870 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 378876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 378889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 378896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378898 */     GIR_RootConstrainSelectedInstOperands,
     /* 378899 */     // GIR_Coverage, 2451,
     /* 378899 */     GIR_EraseRootFromParent_Done,
     /* 378900 */   // Label 7633: @378900
     /* 378900 */   GIM_Try, /*On fail goto*//*Label 7634*/ GIMT_Encode4(378985), // Rule ID 2449 //
     /* 378905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 378908 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 378916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 378920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 378924 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 378928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378933 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 378937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 378943 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 378943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 378946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 378950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378955 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 378961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 378966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 378971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 378974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 378976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 378978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 378983 */     GIR_RootConstrainSelectedInstOperands,
     /* 378984 */     // GIR_Coverage, 2449,
     /* 378984 */     GIR_EraseRootFromParent_Done,
     /* 378985 */   // Label 7634: @378985
     /* 378985 */   GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(379054), // Rule ID 2533 //
     /* 378990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 378993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378997 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379001 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379005 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379022 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379026 */     // MIs[2] Operand 1
     /* 379026 */     // No operand predicates
     /* 379026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379036 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 379039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379052 */     GIR_RootConstrainSelectedInstOperands,
     /* 379053 */     // GIR_Coverage, 2533,
     /* 379053 */     GIR_EraseRootFromParent_Done,
     /* 379054 */   // Label 7635: @379054
     /* 379054 */   GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(379123), // Rule ID 6013 //
     /* 379059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 379062 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379066 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379070 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379074 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 379078 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 379087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 379099 */     // MIs[2] Operand 1
     /* 379099 */     // No operand predicates
     /* 379099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379103 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379105 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 379105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 379108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379118 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 379121 */     GIR_RootConstrainSelectedInstOperands,
     /* 379122 */     // GIR_Coverage, 6013,
     /* 379122 */     GIR_EraseRootFromParent_Done,
     /* 379123 */   // Label 7636: @379123
     /* 379123 */   GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(379173), // Rule ID 13231 //
     /* 379128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 379131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 379143 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379158 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 379158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 379161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 379165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 379171 */     GIR_RootConstrainSelectedInstOperands,
     /* 379172 */     // GIR_Coverage, 13231,
     /* 379172 */     GIR_EraseRootFromParent_Done,
     /* 379173 */   // Label 7637: @379173
     /* 379173 */   GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(379223), // Rule ID 643 //
     /* 379178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 379181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 379189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 379197 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379202 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379206 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379208 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 379208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 379211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379213 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 379219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 379221 */     GIR_RootConstrainSelectedInstOperands,
     /* 379222 */     // GIR_Coverage, 643,
     /* 379222 */     GIR_EraseRootFromParent_Done,
     /* 379223 */   // Label 7638: @379223
     /* 379223 */   GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(379273), // Rule ID 655 //
     /* 379228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 379231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 379243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 379251 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 379258 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 379258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 379261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379263 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 379265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 379267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 379271 */     GIR_RootConstrainSelectedInstOperands,
     /* 379272 */     // GIR_Coverage, 655,
     /* 379272 */     GIR_EraseRootFromParent_Done,
     /* 379273 */   // Label 7639: @379273
     /* 379273 */   GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(379304), // Rule ID 637 //
     /* 379278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 379281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 379293 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 379293 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 379298 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 379302 */     GIR_RootConstrainSelectedInstOperands,
     /* 379303 */     // GIR_Coverage, 637,
     /* 379303 */     GIR_Done,
     /* 379304 */   // Label 7640: @379304
     /* 379304 */   GIM_Reject,
     /* 379305 */ // Label 7612: @379305
     /* 379305 */ GIM_Reject,
     /* 379306 */ // Label 7604: @379306
     /* 379306 */ GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(382235),
     /* 379311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 379314 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 379317 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 379320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379324 */   GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(379474), // Rule ID 4856 //
     /* 379329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 379332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379353 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 379357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379369 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379373 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379378 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 379382 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 379386 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379390 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 379394 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379401 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 379401 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 379404 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379408 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379413 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 379419 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379424 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379441 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 379460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 379468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 379472 */     GIR_RootConstrainSelectedInstOperands,
     /* 379473 */     // GIR_Coverage, 4856,
     /* 379473 */     GIR_EraseRootFromParent_Done,
     /* 379474 */   // Label 7642: @379474
     /* 379474 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(379621), // Rule ID 4820 //
     /* 379479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 379482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379494 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379498 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379503 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 379507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379519 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 379523 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379527 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379531 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 379535 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379540 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 379544 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379548 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379550 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 379550 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 379553 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379557 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379562 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 379568 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379573 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379590 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379601 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 379609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 379617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 379619 */     GIR_RootConstrainSelectedInstOperands,
     /* 379620 */     // GIR_Coverage, 4820,
     /* 379620 */     GIR_EraseRootFromParent_Done,
     /* 379621 */   // Label 7643: @379621
     /* 379621 */   GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(379768), // Rule ID 13795 //
     /* 379626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 379629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 379641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 379645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379657 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379662 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 379666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 379670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379674 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379678 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 379682 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379687 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 379691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379695 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379697 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 379697 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 379700 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379704 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379709 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 379715 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379720 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379737 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379743 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379748 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 379756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 379758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 379764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 379766 */     GIR_RootConstrainSelectedInstOperands,
     /* 379767 */     // GIR_Coverage, 13795,
     /* 379767 */     GIR_EraseRootFromParent_Done,
     /* 379768 */   // Label 7644: @379768
     /* 379768 */   GIM_Try, /*On fail goto*//*Label 7645*/ GIMT_Encode4(379899), // Rule ID 6063 //
     /* 379773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379776 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379780 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379784 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379797 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 379801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 379813 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 379817 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379821 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379825 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 379829 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379834 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 379838 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379842 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 379846 */     // MIs[4] Operand 1
     /* 379846 */     // No operand predicates
     /* 379846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379850 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 379852 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 379852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379864 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 379870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 379883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 379887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 379894 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 379897 */     GIR_RootConstrainSelectedInstOperands,
     /* 379898 */     // GIR_Coverage, 6063,
     /* 379898 */     GIR_EraseRootFromParent_Done,
     /* 379899 */   // Label 7645: @379899
     /* 379899 */   GIM_Try, /*On fail goto*//*Label 7646*/ GIMT_Encode4(380030), // Rule ID 6095 //
     /* 379904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 379907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 379923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 379932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379936 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 379940 */     // MIs[2] Operand 1
     /* 379940 */     // No operand predicates
     /* 379940 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 379944 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 379948 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 379952 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 379956 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379960 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 379964 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 379968 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 379973 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 379977 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 379981 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 379983 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 379983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 379986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 379990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379995 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380001 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 380014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 380028 */     GIR_RootConstrainSelectedInstOperands,
     /* 380029 */     // GIR_Coverage, 6095,
     /* 380029 */     GIR_EraseRootFromParent_Done,
     /* 380030 */   // Label 7646: @380030
     /* 380030 */   GIM_Try, /*On fail goto*//*Label 7647*/ GIMT_Encode4(380161), // Rule ID 6159 //
     /* 380035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380071 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 380075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 380079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380083 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380087 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 380091 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380096 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 380100 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380104 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380108 */     // MIs[4] Operand 1
     /* 380108 */     // No operand predicates
     /* 380108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380112 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 380114 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380126 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 380145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380149 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 380156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 380159 */     GIR_RootConstrainSelectedInstOperands,
     /* 380160 */     // GIR_Coverage, 6159,
     /* 380160 */     GIR_EraseRootFromParent_Done,
     /* 380161 */   // Label 7647: @380161
     /* 380161 */   GIM_Try, /*On fail goto*//*Label 7648*/ GIMT_Encode4(380292), // Rule ID 6127 //
     /* 380166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380193 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380197 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380210 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380214 */     // MIs[3] Operand 1
     /* 380214 */     // No operand predicates
     /* 380214 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 380218 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380222 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380226 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 380230 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380235 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 380239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380243 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 380245 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380257 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 380276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380290 */     GIR_RootConstrainSelectedInstOperands,
     /* 380291 */     // GIR_Coverage, 6127,
     /* 380291 */     GIR_EraseRootFromParent_Done,
     /* 380292 */   // Label 7648: @380292
     /* 380292 */   GIM_Try, /*On fail goto*//*Label 7649*/ GIMT_Encode4(380427), // Rule ID 2459 //
     /* 380297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380321 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 380325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380346 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 380350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380356 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 380356 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 380359 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380363 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380368 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 380374 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380379 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380396 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380407 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 380415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 380423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 380425 */     GIR_RootConstrainSelectedInstOperands,
     /* 380426 */     // GIR_Coverage, 2459,
     /* 380426 */     GIR_EraseRootFromParent_Done,
     /* 380427 */   // Label 7649: @380427
     /* 380427 */   GIM_Try, /*On fail goto*//*Label 7650*/ GIMT_Encode4(380546), // Rule ID 6031 //
     /* 380432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380447 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380456 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 380460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 380485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380489 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380493 */     // MIs[3] Operand 1
     /* 380493 */     // No operand predicates
     /* 380493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380497 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380499 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380499 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380502 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380506 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380511 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 380530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 380544 */     GIR_RootConstrainSelectedInstOperands,
     /* 380545 */     // GIR_Coverage, 6031,
     /* 380545 */     GIR_EraseRootFromParent_Done,
     /* 380546 */   // Label 7650: @380546
     /* 380546 */   GIM_Try, /*On fail goto*//*Label 7651*/ GIMT_Encode4(380665), // Rule ID 2551 //
     /* 380551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 380554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380570 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 380579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 380583 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 380587 */     // MIs[2] Operand 1
     /* 380587 */     // No operand predicates
     /* 380587 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 380591 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380595 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380599 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 380603 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380608 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 380612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380616 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 380618 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 380618 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380621 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380625 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380630 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380636 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380641 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 380649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 380653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 380660 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 380663 */     GIR_RootConstrainSelectedInstOperands,
     /* 380664 */     // GIR_Coverage, 2551,
     /* 380664 */     GIR_EraseRootFromParent_Done,
     /* 380665 */   // Label 7651: @380665
     /* 380665 */   GIM_Try, /*On fail goto*//*Label 7652*/ GIMT_Encode4(380765), // Rule ID 4818 //
     /* 380670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380694 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 380698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 380710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380721 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 380721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380733 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 380752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 380761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 380763 */     GIR_RootConstrainSelectedInstOperands,
     /* 380764 */     // GIR_Coverage, 4818,
     /* 380764 */     GIR_EraseRootFromParent_Done,
     /* 380765 */   // Label 7652: @380765
     /* 380765 */   GIM_Try, /*On fail goto*//*Label 7653*/ GIMT_Encode4(380865), // Rule ID 4854 //
     /* 380770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 380789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380794 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 380798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380802 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 380806 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380810 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 380814 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380819 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380821 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 380821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380833 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 380839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380844 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 380852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 380859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 380863 */     GIR_RootConstrainSelectedInstOperands,
     /* 380864 */     // GIR_Coverage, 4854,
     /* 380864 */     GIR_EraseRootFromParent_Done,
     /* 380865 */   // Label 7653: @380865
     /* 380865 */   GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(380962), // Rule ID 13791 //
     /* 380870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 380889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380897 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 380901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380906 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 380910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380918 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380920 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 380920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380932 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 380938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 380948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 380951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 380953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 380955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 380960 */     GIR_RootConstrainSelectedInstOperands,
     /* 380961 */     // GIR_Coverage, 13791,
     /* 380961 */     GIR_EraseRootFromParent_Done,
     /* 380962 */   // Label 7654: @380962
     /* 380962 */   GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(381062), // Rule ID 13793 //
     /* 380967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 380970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 380978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 380982 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 380995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 380999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381008 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 381012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381018 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 381018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381030 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 381036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 381049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381060 */     GIR_RootConstrainSelectedInstOperands,
     /* 381061 */     // GIR_Coverage, 13793,
     /* 381061 */     GIR_EraseRootFromParent_Done,
     /* 381062 */   // Label 7655: @381062
     /* 381062 */   GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(381162), // Rule ID 4852 //
     /* 381067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381095 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 381103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381107 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 381111 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381118 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 381118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381130 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 381136 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 381149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 381160 */     GIR_RootConstrainSelectedInstOperands,
     /* 381161 */     // GIR_Coverage, 4852,
     /* 381161 */     GIR_EraseRootFromParent_Done,
     /* 381162 */   // Label 7656: @381162
     /* 381162 */   GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(381259), // Rule ID 4816 //
     /* 381167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381182 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381198 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381202 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381207 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 381211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381217 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 381217 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381220 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381224 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381229 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 381235 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381240 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 381248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381250 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381252 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381255 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381257 */     GIR_RootConstrainSelectedInstOperands,
     /* 381258 */     // GIR_Coverage, 4816,
     /* 381258 */     GIR_EraseRootFromParent_Done,
     /* 381259 */   // Label 7657: @381259
     /* 381259 */   GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(381337), // Rule ID 6181 //
     /* 381264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381280 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381284 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381288 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381292 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 381301 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381305 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 381309 */     // MIs[3] Operand 1
     /* 381309 */     // No operand predicates
     /* 381309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381317 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381319 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 381322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381332 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381335 */     GIR_RootConstrainSelectedInstOperands,
     /* 381336 */     // GIR_Coverage, 6181,
     /* 381336 */     GIR_EraseRootFromParent_Done,
     /* 381337 */   // Label 7658: @381337
     /* 381337 */   GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(381421), // Rule ID 6093 //
     /* 381342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 381370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381374 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 381378 */     // MIs[2] Operand 1
     /* 381378 */     // No operand predicates
     /* 381378 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 381382 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381386 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 381390 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381401 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 381404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 381412 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381416 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 381419 */     GIR_RootConstrainSelectedInstOperands,
     /* 381420 */     // GIR_Coverage, 6093,
     /* 381420 */     GIR_EraseRootFromParent_Done,
     /* 381421 */   // Label 7659: @381421
     /* 381421 */   GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(381502), // Rule ID 6125 //
     /* 381426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381433 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381437 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381453 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381457 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381462 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381466 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381470 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 381474 */     // MIs[3] Operand 1
     /* 381474 */     // No operand predicates
     /* 381474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381482 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381484 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 381487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381497 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381500 */     GIR_RootConstrainSelectedInstOperands,
     /* 381501 */     // GIR_Coverage, 6125,
     /* 381501 */     GIR_EraseRootFromParent_Done,
     /* 381502 */   // Label 7660: @381502
     /* 381502 */   GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(381586), // Rule ID 6157 //
     /* 381507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381535 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381539 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381543 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381548 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381552 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381556 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 381560 */     // MIs[3] Operand 1
     /* 381560 */     // No operand predicates
     /* 381560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381564 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381566 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 381569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 381577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381581 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381584 */     GIR_RootConstrainSelectedInstOperands,
     /* 381585 */     // GIR_Coverage, 6157,
     /* 381585 */     GIR_EraseRootFromParent_Done,
     /* 381586 */   // Label 7661: @381586
     /* 381586 */   GIM_Try, /*On fail goto*//*Label 7662*/ GIMT_Encode4(381664), // Rule ID 6203 //
     /* 381591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381623 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381628 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 381632 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381636 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 381640 */     // MIs[3] Operand 1
     /* 381640 */     // No operand predicates
     /* 381640 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381644 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381646 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 381649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381662 */     GIR_RootConstrainSelectedInstOperands,
     /* 381663 */     // GIR_Coverage, 6203,
     /* 381663 */     GIR_EraseRootFromParent_Done,
     /* 381664 */   // Label 7662: @381664
     /* 381664 */   GIM_Try, /*On fail goto*//*Label 7663*/ GIMT_Encode4(381745), // Rule ID 6061 //
     /* 381669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 381684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 381688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 381692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381709 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381713 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381717 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 381721 */     // MIs[3] Operand 1
     /* 381721 */     // No operand predicates
     /* 381721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381725 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381727 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 381730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 381740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 381743 */     GIR_RootConstrainSelectedInstOperands,
     /* 381744 */     // GIR_Coverage, 6061,
     /* 381744 */     GIR_EraseRootFromParent_Done,
     /* 381745 */   // Label 7663: @381745
     /* 381745 */   GIM_Try, /*On fail goto*//*Label 7664*/ GIMT_Encode4(381830), // Rule ID 2457 //
     /* 381750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381774 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381788 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 381788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381800 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 381806 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381811 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 381819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 381826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381828 */     GIR_RootConstrainSelectedInstOperands,
     /* 381829 */     // GIR_Coverage, 2457,
     /* 381829 */     GIR_EraseRootFromParent_Done,
     /* 381830 */   // Label 7664: @381830
     /* 381830 */   GIM_Try, /*On fail goto*//*Label 7665*/ GIMT_Encode4(381915), // Rule ID 2455 //
     /* 381835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 381838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 381846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381858 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381863 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 381867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381871 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 381873 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 381873 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381876 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381880 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381885 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 381891 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 381904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 381906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 381908 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 381913 */     GIR_RootConstrainSelectedInstOperands,
     /* 381914 */     // GIR_Coverage, 2455,
     /* 381914 */     GIR_EraseRootFromParent_Done,
     /* 381915 */   // Label 7665: @381915
     /* 381915 */   GIM_Try, /*On fail goto*//*Label 7666*/ GIMT_Encode4(381984), // Rule ID 2549 //
     /* 381920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 381935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 381939 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 381944 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 381948 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381952 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 381956 */     // MIs[2] Operand 1
     /* 381956 */     // No operand predicates
     /* 381956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381960 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381964 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381966 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 381966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 381969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 381973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 381975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 381979 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 381982 */     GIR_RootConstrainSelectedInstOperands,
     /* 381983 */     // GIR_Coverage, 2549,
     /* 381983 */     GIR_EraseRootFromParent_Done,
     /* 381984 */   // Label 7666: @381984
     /* 381984 */   GIM_Try, /*On fail goto*//*Label 7667*/ GIMT_Encode4(382053), // Rule ID 6029 //
     /* 381989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 381992 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 382000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 382008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382017 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 382021 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382025 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 382029 */     // MIs[2] Operand 1
     /* 382029 */     // No operand predicates
     /* 382029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382035 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 382035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 382038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 382051 */     GIR_RootConstrainSelectedInstOperands,
     /* 382052 */     // GIR_Coverage, 6029,
     /* 382052 */     GIR_EraseRootFromParent_Done,
     /* 382053 */   // Label 7667: @382053
     /* 382053 */   GIM_Try, /*On fail goto*//*Label 7668*/ GIMT_Encode4(382103), // Rule ID 13233 //
     /* 382058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 382073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382082 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382088 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 382088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 382091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 382095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382101 */     GIR_RootConstrainSelectedInstOperands,
     /* 382102 */     // GIR_Coverage, 13233,
     /* 382102 */     GIR_EraseRootFromParent_Done,
     /* 382103 */   // Label 7668: @382103
     /* 382103 */   GIM_Try, /*On fail goto*//*Label 7669*/ GIMT_Encode4(382153), // Rule ID 645 //
     /* 382108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382111 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 382119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 382127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382138 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 382138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 382141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382151 */     GIR_RootConstrainSelectedInstOperands,
     /* 382152 */     // GIR_Coverage, 645,
     /* 382152 */     GIR_EraseRootFromParent_Done,
     /* 382153 */   // Label 7669: @382153
     /* 382153 */   GIM_Try, /*On fail goto*//*Label 7670*/ GIMT_Encode4(382203), // Rule ID 657 //
     /* 382158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 382173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 382181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 382188 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 382188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 382191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382193 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 382195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 382197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 382201 */     GIR_RootConstrainSelectedInstOperands,
     /* 382202 */     // GIR_Coverage, 657,
     /* 382202 */     GIR_EraseRootFromParent_Done,
     /* 382203 */   // Label 7670: @382203
     /* 382203 */   GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(382234), // Rule ID 639 //
     /* 382208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382223 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 382223 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 382228 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 382232 */     GIR_RootConstrainSelectedInstOperands,
     /* 382233 */     // GIR_Coverage, 639,
     /* 382233 */     GIR_Done,
     /* 382234 */   // Label 7671: @382234
     /* 382234 */   GIM_Reject,
     /* 382235 */ // Label 7641: @382235
     /* 382235 */ GIM_Reject,
     /* 382236 */ // Label 7605: @382236
     /* 382236 */ GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(385165),
     /* 382241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 382244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 382247 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382254 */   GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(382404), // Rule ID 4862 //
     /* 382259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382274 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382278 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382283 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382299 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382303 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382308 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 382312 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 382316 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382320 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 382324 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382329 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382331 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 382331 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 382334 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382338 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382343 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 382349 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382354 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382359 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382362 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382366 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382371 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382377 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382382 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 382390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382395 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 382398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 382402 */     GIR_RootConstrainSelectedInstOperands,
     /* 382403 */     // GIR_Coverage, 4862,
     /* 382403 */     GIR_EraseRootFromParent_Done,
     /* 382404 */   // Label 7673: @382404
     /* 382404 */   GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(382551), // Rule ID 4826 //
     /* 382409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382433 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 382449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 382453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382457 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382461 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 382465 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382470 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 382474 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382478 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382480 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 382480 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 382483 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382487 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382492 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 382498 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382503 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382508 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382511 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382515 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382520 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382526 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382531 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 382539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382544 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 382547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382549 */     GIR_RootConstrainSelectedInstOperands,
     /* 382550 */     // GIR_Coverage, 4826,
     /* 382550 */     GIR_EraseRootFromParent_Done,
     /* 382551 */   // Label 7674: @382551
     /* 382551 */   GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(382698), // Rule ID 13801 //
     /* 382556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 382559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 382571 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382575 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382579 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382583 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382587 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382592 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 382596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382604 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382608 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 382612 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382617 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 382621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382625 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 382627 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 382627 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 382630 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382634 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382639 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 382645 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382650 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382655 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382658 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382662 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382667 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382673 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382678 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 382686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 382688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 382694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 382696 */     GIR_RootConstrainSelectedInstOperands,
     /* 382697 */     // GIR_Coverage, 13801,
     /* 382697 */     GIR_EraseRootFromParent_Done,
     /* 382698 */   // Label 7675: @382698
     /* 382698 */   GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(382829), // Rule ID 6067 //
     /* 382703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382714 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382718 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382727 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 382731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 382743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 382747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382751 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382755 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 382759 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382764 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 382768 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382772 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 382776 */     // MIs[4] Operand 1
     /* 382776 */     // No operand predicates
     /* 382776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382780 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 382782 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 382782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382794 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 382813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382817 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 382824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 382827 */     GIR_RootConstrainSelectedInstOperands,
     /* 382828 */     // GIR_Coverage, 6067,
     /* 382828 */     GIR_EraseRootFromParent_Done,
     /* 382829 */   // Label 7676: @382829
     /* 382829 */   GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(382960), // Rule ID 6099 //
     /* 382834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382849 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 382853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 382862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 382866 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 382870 */     // MIs[2] Operand 1
     /* 382870 */     // No operand predicates
     /* 382870 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 382874 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382878 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 382882 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 382886 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382890 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382894 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 382898 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382903 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 382907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382911 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 382913 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 382913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 382916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382925 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 382931 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 382936 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 382941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 382944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 382948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 382955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 382958 */     GIR_RootConstrainSelectedInstOperands,
     /* 382959 */     // GIR_Coverage, 6099,
     /* 382959 */     GIR_EraseRootFromParent_Done,
     /* 382960 */   // Label 7677: @382960
     /* 382960 */   GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(383091), // Rule ID 6163 //
     /* 382965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 382968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 382976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 382980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 382984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 382988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 382992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 382996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383001 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 383005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 383009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383013 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383017 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 383021 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383026 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 383030 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383034 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 383038 */     // MIs[4] Operand 1
     /* 383038 */     // No operand predicates
     /* 383038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383042 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 383044 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 383044 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383047 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383051 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383056 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383062 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383067 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 383075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 383086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 383089 */     GIR_RootConstrainSelectedInstOperands,
     /* 383090 */     // GIR_Coverage, 6163,
     /* 383090 */     GIR_EraseRootFromParent_Done,
     /* 383091 */   // Label 7678: @383091
     /* 383091 */   GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(383222), // Rule ID 6131 //
     /* 383096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 383111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383123 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383132 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383136 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383140 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 383144 */     // MIs[3] Operand 1
     /* 383144 */     // No operand predicates
     /* 383144 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 383148 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383152 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383156 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 383160 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383165 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 383169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383173 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 383175 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 383175 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383178 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383182 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383187 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383193 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383198 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 383206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383210 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383220 */     GIR_RootConstrainSelectedInstOperands,
     /* 383221 */     // GIR_Coverage, 6131,
     /* 383221 */     GIR_EraseRootFromParent_Done,
     /* 383222 */   // Label 7679: @383222
     /* 383222 */   GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(383357), // Rule ID 2465 //
     /* 383227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383242 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383251 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383267 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383271 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383276 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 383280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383286 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 383286 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 383289 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383293 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383298 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 383304 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383309 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383326 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 383345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383350 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 383353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383355 */     GIR_RootConstrainSelectedInstOperands,
     /* 383356 */     // GIR_Coverage, 2465,
     /* 383356 */     GIR_EraseRootFromParent_Done,
     /* 383357 */   // Label 7680: @383357
     /* 383357 */   GIM_Try, /*On fail goto*//*Label 7681*/ GIMT_Encode4(383476), // Rule ID 6035 //
     /* 383362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383386 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383390 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383394 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383398 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383406 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 383415 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383419 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 383423 */     // MIs[3] Operand 1
     /* 383423 */     // No operand predicates
     /* 383423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383429 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 383429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383441 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383447 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 383460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383471 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 383474 */     GIR_RootConstrainSelectedInstOperands,
     /* 383475 */     // GIR_Coverage, 6035,
     /* 383475 */     GIR_EraseRootFromParent_Done,
     /* 383476 */   // Label 7681: @383476
     /* 383476 */   GIM_Try, /*On fail goto*//*Label 7682*/ GIMT_Encode4(383595), // Rule ID 2555 //
     /* 383481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 383484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 383509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 383513 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 383517 */     // MIs[2] Operand 1
     /* 383517 */     // No operand predicates
     /* 383517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 383521 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383525 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383529 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 383533 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383538 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 383542 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383546 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 383548 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 383548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383560 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383566 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 383579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 383583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383590 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 383593 */     GIR_RootConstrainSelectedInstOperands,
     /* 383594 */     // GIR_Coverage, 2555,
     /* 383594 */     GIR_EraseRootFromParent_Done,
     /* 383595 */   // Label 7682: @383595
     /* 383595 */   GIM_Try, /*On fail goto*//*Label 7683*/ GIMT_Encode4(383695), // Rule ID 4824 //
     /* 383600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383624 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383628 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383632 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383636 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 383640 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383649 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383651 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 383651 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383654 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383658 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383663 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 383682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 383691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383693 */     GIR_RootConstrainSelectedInstOperands,
     /* 383694 */     // GIR_Coverage, 4824,
     /* 383694 */     GIR_EraseRootFromParent_Done,
     /* 383695 */   // Label 7683: @383695
     /* 383695 */   GIM_Try, /*On fail goto*//*Label 7684*/ GIMT_Encode4(383795), // Rule ID 4860 //
     /* 383700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 383719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383724 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 383728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 383736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 383744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383751 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 383751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383763 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383774 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 383782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 383789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 383793 */     GIR_RootConstrainSelectedInstOperands,
     /* 383794 */     // GIR_Coverage, 4860,
     /* 383794 */     GIR_EraseRootFromParent_Done,
     /* 383795 */   // Label 7684: @383795
     /* 383795 */   GIM_Try, /*On fail goto*//*Label 7685*/ GIMT_Encode4(383892), // Rule ID 13797 //
     /* 383800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 383815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 383819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383827 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383831 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383836 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 383840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383850 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 383850 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383853 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383857 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383862 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 383868 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383873 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 383881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 383885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383890 */     GIR_RootConstrainSelectedInstOperands,
     /* 383891 */     // GIR_Coverage, 13797,
     /* 383891 */     GIR_EraseRootFromParent_Done,
     /* 383892 */   // Label 7685: @383892
     /* 383892 */   GIM_Try, /*On fail goto*//*Label 7686*/ GIMT_Encode4(383992), // Rule ID 13799 //
     /* 383897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 383900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 383908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 383912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 383925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 383929 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 383933 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383938 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 383942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383948 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 383948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 383951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 383955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383960 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 383966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 383971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 383976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 383979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 383981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 383988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 383990 */     GIR_RootConstrainSelectedInstOperands,
     /* 383991 */     // GIR_Coverage, 13799,
     /* 383991 */     GIR_EraseRootFromParent_Done,
     /* 383992 */   // Label 7686: @383992
     /* 383992 */   GIM_Try, /*On fail goto*//*Label 7687*/ GIMT_Encode4(384092), // Rule ID 4858 //
     /* 383997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384025 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 384029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 384033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 384041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384048 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 384048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 384051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384060 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 384066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 384079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384081 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384086 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 384090 */     GIR_RootConstrainSelectedInstOperands,
     /* 384091 */     // GIR_Coverage, 4858,
     /* 384091 */     GIR_EraseRootFromParent_Done,
     /* 384092 */   // Label 7687: @384092
     /* 384092 */   GIM_Try, /*On fail goto*//*Label 7688*/ GIMT_Encode4(384189), // Rule ID 4822 //
     /* 384097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 384116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384132 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384137 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 384141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384147 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 384147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 384150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384159 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 384165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384170 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 384178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384187 */     GIR_RootConstrainSelectedInstOperands,
     /* 384188 */     // GIR_Coverage, 4822,
     /* 384188 */     GIR_EraseRootFromParent_Done,
     /* 384189 */   // Label 7688: @384189
     /* 384189 */   GIM_Try, /*On fail goto*//*Label 7689*/ GIMT_Encode4(384267), // Rule ID 6185 //
     /* 384194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384227 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 384231 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384235 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384239 */     // MIs[3] Operand 1
     /* 384239 */     // No operand predicates
     /* 384239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384247 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384249 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 384252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384265 */     GIR_RootConstrainSelectedInstOperands,
     /* 384266 */     // GIR_Coverage, 6185,
     /* 384266 */     GIR_EraseRootFromParent_Done,
     /* 384267 */   // Label 7689: @384267
     /* 384267 */   GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(384351), // Rule ID 6097 //
     /* 384272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384304 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 384308 */     // MIs[2] Operand 1
     /* 384308 */     // No operand predicates
     /* 384308 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 384312 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384316 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 384320 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384329 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384331 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 384331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 384334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 384342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384349 */     GIR_RootConstrainSelectedInstOperands,
     /* 384350 */     // GIR_Coverage, 6097,
     /* 384350 */     GIR_EraseRootFromParent_Done,
     /* 384351 */   // Label 7690: @384351
     /* 384351 */   GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(384432), // Rule ID 6129 //
     /* 384356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 384371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384400 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 384404 */     // MIs[3] Operand 1
     /* 384404 */     // No operand predicates
     /* 384404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384412 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384414 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 384414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 384417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384427 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384430 */     GIR_RootConstrainSelectedInstOperands,
     /* 384431 */     // GIR_Coverage, 6129,
     /* 384431 */     GIR_EraseRootFromParent_Done,
     /* 384432 */   // Label 7691: @384432
     /* 384432 */   GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(384516), // Rule ID 6161 //
     /* 384437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 384452 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384457 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384461 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384465 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384469 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384473 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384486 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 384490 */     // MIs[3] Operand 1
     /* 384490 */     // No operand predicates
     /* 384490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384494 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384496 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 384496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 384499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 384507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384514 */     GIR_RootConstrainSelectedInstOperands,
     /* 384515 */     // GIR_Coverage, 6161,
     /* 384515 */     GIR_EraseRootFromParent_Done,
     /* 384516 */   // Label 7692: @384516
     /* 384516 */   GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(384594), // Rule ID 6207 //
     /* 384521 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 384562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384566 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 384570 */     // MIs[3] Operand 1
     /* 384570 */     // No operand predicates
     /* 384570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384574 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384576 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 384576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 384579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384583 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384589 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384592 */     GIR_RootConstrainSelectedInstOperands,
     /* 384593 */     // GIR_Coverage, 6207,
     /* 384593 */     GIR_EraseRootFromParent_Done,
     /* 384594 */   // Label 7693: @384594
     /* 384594 */   GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(384675), // Rule ID 6065 //
     /* 384599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384602 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 384618 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 384622 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384626 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384630 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384634 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384639 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384643 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384647 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 384651 */     // MIs[3] Operand 1
     /* 384651 */     // No operand predicates
     /* 384651 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384655 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384657 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 384657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 384660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 384670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 384673 */     GIR_RootConstrainSelectedInstOperands,
     /* 384674 */     // GIR_Coverage, 6065,
     /* 384674 */     GIR_EraseRootFromParent_Done,
     /* 384675 */   // Label 7694: @384675
     /* 384675 */   GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(384760), // Rule ID 2463 //
     /* 384680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384704 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 384708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384716 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384718 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 384718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 384721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384730 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 384736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 384749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 384756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384758 */     GIR_RootConstrainSelectedInstOperands,
     /* 384759 */     // GIR_Coverage, 2463,
     /* 384759 */     GIR_EraseRootFromParent_Done,
     /* 384760 */   // Label 7695: @384760
     /* 384760 */   GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(384845), // Rule ID 2461 //
     /* 384765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384784 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384788 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384793 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 384797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 384803 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 384803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 384806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384815 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 384821 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 384834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 384836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 384843 */     GIR_RootConstrainSelectedInstOperands,
     /* 384844 */     // GIR_Coverage, 2461,
     /* 384844 */     GIR_EraseRootFromParent_Done,
     /* 384845 */   // Label 7696: @384845
     /* 384845 */   GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(384914), // Rule ID 2553 //
     /* 384850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384882 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 384886 */     // MIs[2] Operand 1
     /* 384886 */     // No operand predicates
     /* 384886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384894 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384896 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 384896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 384899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 384905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384912 */     GIR_RootConstrainSelectedInstOperands,
     /* 384913 */     // GIR_Coverage, 2553,
     /* 384913 */     GIR_EraseRootFromParent_Done,
     /* 384914 */   // Label 7697: @384914
     /* 384914 */   GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(384983), // Rule ID 6033 //
     /* 384919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 384922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 384930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 384938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 384942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 384947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 384951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384955 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 384959 */     // MIs[2] Operand 1
     /* 384959 */     // No operand predicates
     /* 384959 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 384963 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384965 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 384965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 384968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 384972 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 384974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 384978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 384981 */     GIR_RootConstrainSelectedInstOperands,
     /* 384982 */     // GIR_Coverage, 6033,
     /* 384982 */     GIR_EraseRootFromParent_Done,
     /* 384983 */   // Label 7698: @384983
     /* 384983 */   GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(385033), // Rule ID 13235 //
     /* 384988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 384991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 384999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 385003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385018 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 385018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 385021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 385031 */     GIR_RootConstrainSelectedInstOperands,
     /* 385032 */     // GIR_Coverage, 13235,
     /* 385032 */     GIR_EraseRootFromParent_Done,
     /* 385033 */   // Label 7699: @385033
     /* 385033 */   GIM_Try, /*On fail goto*//*Label 7700*/ GIMT_Encode4(385083), // Rule ID 647 //
     /* 385038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 385057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385068 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 385068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 385071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 385081 */     GIR_RootConstrainSelectedInstOperands,
     /* 385082 */     // GIR_Coverage, 647,
     /* 385082 */     GIR_EraseRootFromParent_Done,
     /* 385083 */   // Label 7700: @385083
     /* 385083 */   GIM_Try, /*On fail goto*//*Label 7701*/ GIMT_Encode4(385133), // Rule ID 659 //
     /* 385088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 385103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 385111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 385118 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 385118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 385121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 385123 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 385127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 385131 */     GIR_RootConstrainSelectedInstOperands,
     /* 385132 */     // GIR_Coverage, 659,
     /* 385132 */     GIR_EraseRootFromParent_Done,
     /* 385133 */   // Label 7701: @385133
     /* 385133 */   GIM_Try, /*On fail goto*//*Label 7702*/ GIMT_Encode4(385164), // Rule ID 641 //
     /* 385138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 385141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385153 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 385153 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 385158 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 385162 */     GIR_RootConstrainSelectedInstOperands,
     /* 385163 */     // GIR_Coverage, 641,
     /* 385163 */     GIR_Done,
     /* 385164 */   // Label 7702: @385164
     /* 385164 */   GIM_Reject,
     /* 385165 */ // Label 7672: @385165
     /* 385165 */ GIM_Reject,
     /* 385166 */ // Label 7606: @385166
     /* 385166 */ GIM_Try, /*On fail goto*//*Label 7703*/ GIMT_Encode4(386686),
     /* 385171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 385177 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 385180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385184 */   GIM_Try, /*On fail goto*//*Label 7704*/ GIMT_Encode4(385262), // Rule ID 6165 //
     /* 385189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 385197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385217 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385222 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 385226 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385230 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385234 */     // MIs[3] Operand 1
     /* 385234 */     // No operand predicates
     /* 385234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385242 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385244 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385260 */     GIR_RootConstrainSelectedInstOperands,
     /* 385261 */     // GIR_Coverage, 6165,
     /* 385261 */     GIR_EraseRootFromParent_Done,
     /* 385262 */   // Label 7704: @385262
     /* 385262 */   GIM_Try, /*On fail goto*//*Label 7705*/ GIMT_Encode4(385346), // Rule ID 6081 //
     /* 385267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 385278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 385295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385299 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385303 */     // MIs[2] Operand 1
     /* 385303 */     // No operand predicates
     /* 385303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 385307 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385311 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385315 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385320 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385324 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385326 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 385337 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385341 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 385344 */     GIR_RootConstrainSelectedInstOperands,
     /* 385345 */     // GIR_Coverage, 6081,
     /* 385345 */     GIR_EraseRootFromParent_Done,
     /* 385346 */   // Label 7705: @385346
     /* 385346 */   GIM_Try, /*On fail goto*//*Label 7706*/ GIMT_Encode4(385427), // Rule ID 6113 //
     /* 385351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 385374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385378 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385395 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385399 */     // MIs[3] Operand 1
     /* 385399 */     // No operand predicates
     /* 385399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385407 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385409 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385418 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385422 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385425 */     GIR_RootConstrainSelectedInstOperands,
     /* 385426 */     // GIR_Coverage, 6113,
     /* 385426 */     GIR_EraseRootFromParent_Done,
     /* 385427 */   // Label 7706: @385427
     /* 385427 */   GIM_Try, /*On fail goto*//*Label 7707*/ GIMT_Encode4(385511), // Rule ID 6145 //
     /* 385432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385443 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 385460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385464 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385468 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385473 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385477 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385481 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385485 */     // MIs[3] Operand 1
     /* 385485 */     // No operand predicates
     /* 385485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385489 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385491 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 385502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385509 */     GIR_RootConstrainSelectedInstOperands,
     /* 385510 */     // GIR_Coverage, 6145,
     /* 385510 */     GIR_EraseRootFromParent_Done,
     /* 385511 */   // Label 7707: @385511
     /* 385511 */   GIM_Try, /*On fail goto*//*Label 7708*/ GIMT_Encode4(385589), // Rule ID 6187 //
     /* 385516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 385528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385553 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 385557 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385561 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385565 */     // MIs[3] Operand 1
     /* 385565 */     // No operand predicates
     /* 385565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385569 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385571 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385578 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385587 */     GIR_RootConstrainSelectedInstOperands,
     /* 385588 */     // GIR_Coverage, 6187,
     /* 385588 */     GIR_EraseRootFromParent_Done,
     /* 385589 */   // Label 7708: @385589
     /* 385589 */   GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(385670), // Rule ID 6049 //
     /* 385594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 385621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385625 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 385629 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385634 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 385638 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385642 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385646 */     // MIs[3] Operand 1
     /* 385646 */     // No operand predicates
     /* 385646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 385652 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 385668 */     GIR_RootConstrainSelectedInstOperands,
     /* 385669 */     // GIR_Coverage, 6049,
     /* 385669 */     GIR_EraseRootFromParent_Done,
     /* 385670 */   // Label 7709: @385670
     /* 385670 */   GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(385739), // Rule ID 2537 //
     /* 385675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 385686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 385703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385707 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385711 */     // MIs[2] Operand 1
     /* 385711 */     // No operand predicates
     /* 385711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385721 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 385724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385734 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 385737 */     GIR_RootConstrainSelectedInstOperands,
     /* 385738 */     // GIR_Coverage, 2537,
     /* 385738 */     GIR_EraseRootFromParent_Done,
     /* 385739 */   // Label 7710: @385739
     /* 385739 */   GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(385808), // Rule ID 6017 //
     /* 385744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 385755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 385759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 385763 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 385767 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 385776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 385780 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 385784 */     // MIs[2] Operand 1
     /* 385784 */     // No operand predicates
     /* 385784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385790 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 385790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 385793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 385799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 385806 */     GIR_RootConstrainSelectedInstOperands,
     /* 385807 */     // GIR_Coverage, 6017,
     /* 385807 */     GIR_EraseRootFromParent_Done,
     /* 385808 */   // Label 7711: @385808
     /* 385808 */   GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(385901), // Rule ID 6169 //
     /* 385813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 385821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 385829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 385837 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385852 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385852 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385855 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385859 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385864 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385867 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 385871 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385874 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385879 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385891 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 385893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385899 */     GIR_RootConstrainSelectedInstOperands,
     /* 385900 */     // GIR_Coverage, 6169,
     /* 385900 */     GIR_EraseRootFromParent_Done,
     /* 385901 */   // Label 7712: @385901
     /* 385901 */   GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(386000), // Rule ID 6083 //
     /* 385906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 385909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385913 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 385917 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 385921 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 385934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 385938 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 385947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385949 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 385949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 385952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385961 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 385964 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 385968 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 385971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 385976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 385981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 385984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 385988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 385992 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385998 */     GIR_RootConstrainSelectedInstOperands,
     /* 385999 */     // GIR_Coverage, 6083,
     /* 385999 */     GIR_EraseRootFromParent_Done,
     /* 386000 */   // Label 7713: @386000
     /* 386000 */   GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(386096), // Rule ID 6115 //
     /* 386005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 386020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 386028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 386032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386041 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386047 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386047 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386050 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386054 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386059 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386062 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386066 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 386069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 386082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386088 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386094 */     GIR_RootConstrainSelectedInstOperands,
     /* 386095 */     // GIR_Coverage, 6115,
     /* 386095 */     GIR_EraseRootFromParent_Done,
     /* 386096 */   // Label 7714: @386096
     /* 386096 */   GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(386195), // Rule ID 6147 //
     /* 386101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386108 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386112 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 386116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 386129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 386133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386144 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386156 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386159 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386163 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 386166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 386179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 386187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386193 */     GIR_RootConstrainSelectedInstOperands,
     /* 386194 */     // GIR_Coverage, 6147,
     /* 386194 */     GIR_EraseRootFromParent_Done,
     /* 386195 */   // Label 7715: @386195
     /* 386195 */   GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(386288), // Rule ID 6191 //
     /* 386200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 386212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 386216 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386220 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386224 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 386228 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386239 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386251 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386258 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 386261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386266 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 386274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386283 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386286 */     GIR_RootConstrainSelectedInstOperands,
     /* 386287 */     // GIR_Coverage, 6191,
     /* 386287 */     GIR_EraseRootFromParent_Done,
     /* 386288 */   // Label 7716: @386288
     /* 386288 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(386384), // Rule ID 6051 //
     /* 386293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386308 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 386312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 386320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 386324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386335 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386335 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386338 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386342 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386347 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386354 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 386357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 386370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386382 */     GIR_RootConstrainSelectedInstOperands,
     /* 386383 */     // GIR_Coverage, 6051,
     /* 386383 */     GIR_EraseRootFromParent_Done,
     /* 386384 */   // Label 7717: @386384
     /* 386384 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(386468), // Rule ID 2539 //
     /* 386389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 386400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 386404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386419 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386431 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386434 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386438 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 386441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 386454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386460 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386466 */     GIR_RootConstrainSelectedInstOperands,
     /* 386467 */     // GIR_Coverage, 2539,
     /* 386467 */     GIR_EraseRootFromParent_Done,
     /* 386468 */   // Label 7718: @386468
     /* 386468 */   GIM_Try, /*On fail goto*//*Label 7719*/ GIMT_Encode4(386518), // Rule ID 13265 //
     /* 386473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 386488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386503 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 386503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 386506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386516 */     GIR_RootConstrainSelectedInstOperands,
     /* 386517 */     // GIR_Coverage, 13265,
     /* 386517 */     GIR_EraseRootFromParent_Done,
     /* 386518 */   // Label 7719: @386518
     /* 386518 */   GIM_Try, /*On fail goto*//*Label 7720*/ GIMT_Encode4(386602), // Rule ID 6019 //
     /* 386523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 386538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 386542 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386551 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386553 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 386553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 386556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386565 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 386568 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386572 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 386575 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 386585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 386588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386594 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386600 */     GIR_RootConstrainSelectedInstOperands,
     /* 386601 */     // GIR_Coverage, 6019,
     /* 386601 */     GIR_EraseRootFromParent_Done,
     /* 386602 */   // Label 7720: @386602
     /* 386602 */   GIM_Try, /*On fail goto*//*Label 7721*/ GIMT_Encode4(386652), // Rule ID 1307 //
     /* 386607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 386626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386637 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 386637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 386640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386650 */     GIR_RootConstrainSelectedInstOperands,
     /* 386651 */     // GIR_Coverage, 1307,
     /* 386651 */     GIR_EraseRootFromParent_Done,
     /* 386652 */   // Label 7721: @386652
     /* 386652 */   GIM_Try, /*On fail goto*//*Label 7722*/ GIMT_Encode4(386685), // Rule ID 1297 //
     /* 386657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386660 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 386672 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 386672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 386675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 386683 */     GIR_RootConstrainSelectedInstOperands,
     /* 386684 */     // GIR_Coverage, 1297,
     /* 386684 */     GIR_EraseRootFromParent_Done,
     /* 386685 */   // Label 7722: @386685
     /* 386685 */   GIM_Reject,
     /* 386686 */ // Label 7703: @386686
     /* 386686 */ GIM_Reject,
     /* 386687 */ // Label 7607: @386687
     /* 386687 */ GIM_Try, /*On fail goto*//*Label 7723*/ GIMT_Encode4(388207),
     /* 386692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 386698 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 386701 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386705 */   GIM_Try, /*On fail goto*//*Label 7724*/ GIMT_Encode4(386783), // Rule ID 6177 //
     /* 386710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 386718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386722 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386738 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386743 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 386747 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386751 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386755 */     // MIs[3] Operand 1
     /* 386755 */     // No operand predicates
     /* 386755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386763 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386765 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 386768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386778 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 386781 */     GIR_RootConstrainSelectedInstOperands,
     /* 386782 */     // GIR_Coverage, 6177,
     /* 386782 */     GIR_EraseRootFromParent_Done,
     /* 386783 */   // Label 7724: @386783
     /* 386783 */   GIM_Try, /*On fail goto*//*Label 7725*/ GIMT_Encode4(386867), // Rule ID 6089 //
     /* 386788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 386799 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386803 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 386807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 386816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386820 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386824 */     // MIs[2] Operand 1
     /* 386824 */     // No operand predicates
     /* 386824 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 386828 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386832 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386836 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386845 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386847 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 386850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 386858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 386862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 386865 */     GIR_RootConstrainSelectedInstOperands,
     /* 386866 */     // GIR_Coverage, 6089,
     /* 386866 */     GIR_EraseRootFromParent_Done,
     /* 386867 */   // Label 7725: @386867
     /* 386867 */   GIM_Try, /*On fail goto*//*Label 7726*/ GIMT_Encode4(386948), // Rule ID 6121 //
     /* 386872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 386891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 386895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386903 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386908 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386912 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386916 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 386920 */     // MIs[3] Operand 1
     /* 386920 */     // No operand predicates
     /* 386920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386930 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 386930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 386933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 386937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 386939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 386943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 386946 */     GIR_RootConstrainSelectedInstOperands,
     /* 386947 */     // GIR_Coverage, 6121,
     /* 386947 */     GIR_EraseRootFromParent_Done,
     /* 386948 */   // Label 7726: @386948
     /* 386948 */   GIM_Try, /*On fail goto*//*Label 7727*/ GIMT_Encode4(387032), // Rule ID 6153 //
     /* 386953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 386956 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386960 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 386964 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 386981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 386985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386994 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386998 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387002 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387006 */     // MIs[3] Operand 1
     /* 387006 */     // No operand predicates
     /* 387006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387010 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387012 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 387012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387030 */     GIR_RootConstrainSelectedInstOperands,
     /* 387031 */     // GIR_Coverage, 6153,
     /* 387031 */     GIR_EraseRootFromParent_Done,
     /* 387032 */   // Label 7727: @387032
     /* 387032 */   GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(387110), // Rule ID 6199 //
     /* 387037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 387049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387057 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387061 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387065 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387069 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 387078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387082 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387086 */     // MIs[3] Operand 1
     /* 387086 */     // No operand predicates
     /* 387086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387090 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387092 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 387092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387108 */     GIR_RootConstrainSelectedInstOperands,
     /* 387109 */     // GIR_Coverage, 6199,
     /* 387109 */     GIR_EraseRootFromParent_Done,
     /* 387110 */   // Label 7728: @387110
     /* 387110 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(387191), // Rule ID 6057 //
     /* 387115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 387142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387146 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 387150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 387159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387163 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387167 */     // MIs[3] Operand 1
     /* 387167 */     // No operand predicates
     /* 387167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 387173 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 387173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 387189 */     GIR_RootConstrainSelectedInstOperands,
     /* 387190 */     // GIR_Coverage, 6057,
     /* 387190 */     GIR_EraseRootFromParent_Done,
     /* 387191 */   // Label 7729: @387191
     /* 387191 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(387260), // Rule ID 2545 //
     /* 387196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 387207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 387224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387228 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387232 */     // MIs[2] Operand 1
     /* 387232 */     // No operand predicates
     /* 387232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387240 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387242 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 387242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 387245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387255 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 387258 */     GIR_RootConstrainSelectedInstOperands,
     /* 387259 */     // GIR_Coverage, 2545,
     /* 387259 */     GIR_EraseRootFromParent_Done,
     /* 387260 */   // Label 7730: @387260
     /* 387260 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(387329), // Rule ID 6025 //
     /* 387265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 387280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 387288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387293 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 387297 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387301 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 387305 */     // MIs[2] Operand 1
     /* 387305 */     // No operand predicates
     /* 387305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387311 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 387311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 387314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387318 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 387327 */     GIR_RootConstrainSelectedInstOperands,
     /* 387328 */     // GIR_Coverage, 6025,
     /* 387328 */     GIR_EraseRootFromParent_Done,
     /* 387329 */   // Label 7731: @387329
     /* 387329 */   GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(387422), // Rule ID 6179 //
     /* 387334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 387342 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 387358 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387371 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387373 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387385 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 387388 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387392 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 387395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387400 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387414 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387420 */     GIR_RootConstrainSelectedInstOperands,
     /* 387421 */     // GIR_Coverage, 6179,
     /* 387421 */     GIR_EraseRootFromParent_Done,
     /* 387422 */   // Label 7732: @387422
     /* 387422 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(387521), // Rule ID 6091 //
     /* 387427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 387438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387442 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387459 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387464 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387470 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387470 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387473 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387477 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387482 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 387485 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387489 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 387492 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387497 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 387513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387519 */     GIR_RootConstrainSelectedInstOperands,
     /* 387520 */     // GIR_Coverage, 6091,
     /* 387520 */     GIR_EraseRootFromParent_Done,
     /* 387521 */   // Label 7733: @387521
     /* 387521 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(387617), // Rule ID 6123 //
     /* 387526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 387549 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 387553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387568 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387580 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 387583 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387587 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 387590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387595 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387605 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387615 */     GIR_RootConstrainSelectedInstOperands,
     /* 387616 */     // GIR_Coverage, 6123,
     /* 387616 */     GIR_EraseRootFromParent_Done,
     /* 387617 */   // Label 7734: @387617
     /* 387617 */   GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(387716), // Rule ID 6155 //
     /* 387622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 387646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 387650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 387654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387665 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387677 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 387680 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387684 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 387687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 387708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387714 */     GIR_RootConstrainSelectedInstOperands,
     /* 387715 */     // GIR_Coverage, 6155,
     /* 387715 */     GIR_EraseRootFromParent_Done,
     /* 387716 */   // Label 7735: @387716
     /* 387716 */   GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(387809), // Rule ID 6201 //
     /* 387721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 387733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387737 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387741 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387745 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 387749 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387754 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387760 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387772 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 387775 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387779 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 387782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387801 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387804 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387807 */     GIR_RootConstrainSelectedInstOperands,
     /* 387808 */     // GIR_Coverage, 6201,
     /* 387808 */     GIR_EraseRootFromParent_Done,
     /* 387809 */   // Label 7736: @387809
     /* 387809 */   GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(387905), // Rule ID 6059 //
     /* 387814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 387829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 387833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 387837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 387841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 387845 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387854 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 387856 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387868 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 387871 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 387875 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 387878 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 387891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387893 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387903 */     GIR_RootConstrainSelectedInstOperands,
     /* 387904 */     // GIR_Coverage, 6059,
     /* 387904 */     GIR_EraseRootFromParent_Done,
     /* 387905 */   // Label 7737: @387905
     /* 387905 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(387989), // Rule ID 2547 //
     /* 387910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 387917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 387921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 387925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387938 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387940 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 387940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 387943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 387947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387952 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 387955 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 387959 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 387962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 387975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 387979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 387981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387984 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 387987 */     GIR_RootConstrainSelectedInstOperands,
     /* 387988 */     // GIR_Coverage, 2547,
     /* 387988 */     GIR_EraseRootFromParent_Done,
     /* 387989 */   // Label 7738: @387989
     /* 387989 */   GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(388039), // Rule ID 13269 //
     /* 387994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388009 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388022 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388024 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 388024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 388027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388037 */     GIR_RootConstrainSelectedInstOperands,
     /* 388038 */     // GIR_Coverage, 13269,
     /* 388038 */     GIR_EraseRootFromParent_Done,
     /* 388039 */   // Label 7739: @388039
     /* 388039 */   GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(388123), // Rule ID 6027 //
     /* 388044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 388059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 388063 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388074 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 388077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388086 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388089 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388093 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 388096 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388101 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 388109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388113 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388121 */     GIR_RootConstrainSelectedInstOperands,
     /* 388122 */     // GIR_Coverage, 6027,
     /* 388122 */     GIR_EraseRootFromParent_Done,
     /* 388123 */   // Label 7740: @388123
     /* 388123 */   GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(388173), // Rule ID 1311 //
     /* 388128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388147 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388156 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388158 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 388158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 388161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388171 */     GIR_RootConstrainSelectedInstOperands,
     /* 388172 */     // GIR_Coverage, 1311,
     /* 388172 */     GIR_EraseRootFromParent_Done,
     /* 388173 */   // Label 7741: @388173
     /* 388173 */   GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(388206), // Rule ID 1301 //
     /* 388178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388193 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 388193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 388196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388202 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 388204 */     GIR_RootConstrainSelectedInstOperands,
     /* 388205 */     // GIR_Coverage, 1301,
     /* 388205 */     GIR_EraseRootFromParent_Done,
     /* 388206 */   // Label 7742: @388206
     /* 388206 */   GIM_Reject,
     /* 388207 */ // Label 7723: @388207
     /* 388207 */ GIM_Reject,
     /* 388208 */ // Label 7608: @388208
     /* 388208 */ GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(389386),
     /* 388213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 388219 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 388222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388226 */   GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(388310), // Rule ID 6073 //
     /* 388231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 388242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388246 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 388255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388263 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388267 */     // MIs[2] Operand 1
     /* 388267 */     // No operand predicates
     /* 388267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 388271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388275 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388279 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388288 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388290 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 388290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 388293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 388301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388305 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 388308 */     GIR_RootConstrainSelectedInstOperands,
     /* 388309 */     // GIR_Coverage, 6073,
     /* 388309 */     GIR_EraseRootFromParent_Done,
     /* 388310 */   // Label 7744: @388310
     /* 388310 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(388391), // Rule ID 6105 //
     /* 388315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 388338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 388351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388359 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388363 */     // MIs[3] Operand 1
     /* 388363 */     // No operand predicates
     /* 388363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388371 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388373 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 388373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 388376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388389 */     GIR_RootConstrainSelectedInstOperands,
     /* 388390 */     // GIR_Coverage, 6105,
     /* 388390 */     GIR_EraseRootFromParent_Done,
     /* 388391 */   // Label 7745: @388391
     /* 388391 */   GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(388475), // Rule ID 6137 //
     /* 388396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388416 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388420 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 388424 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388428 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 388437 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388441 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388445 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388449 */     // MIs[3] Operand 1
     /* 388449 */     // No operand predicates
     /* 388449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388453 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388455 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 388455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 388458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388470 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388473 */     GIR_RootConstrainSelectedInstOperands,
     /* 388474 */     // GIR_Coverage, 6137,
     /* 388474 */     GIR_EraseRootFromParent_Done,
     /* 388475 */   // Label 7746: @388475
     /* 388475 */   GIM_Try, /*On fail goto*//*Label 7747*/ GIMT_Encode4(388556), // Rule ID 6041 //
     /* 388480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 388507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388511 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 388515 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 388520 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 388524 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388528 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388532 */     // MIs[3] Operand 1
     /* 388532 */     // No operand predicates
     /* 388532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388536 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 388538 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 388538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 388541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388545 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 388554 */     GIR_RootConstrainSelectedInstOperands,
     /* 388555 */     // GIR_Coverage, 6041,
     /* 388555 */     GIR_EraseRootFromParent_Done,
     /* 388556 */   // Label 7747: @388556
     /* 388556 */   GIM_Try, /*On fail goto*//*Label 7748*/ GIMT_Encode4(388625), // Rule ID 2529 //
     /* 388561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 388572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388580 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 388585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388593 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388597 */     // MIs[2] Operand 1
     /* 388597 */     // No operand predicates
     /* 388597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388607 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 388607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 388610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 388623 */     GIR_RootConstrainSelectedInstOperands,
     /* 388624 */     // GIR_Coverage, 2529,
     /* 388624 */     GIR_EraseRootFromParent_Done,
     /* 388625 */   // Label 7748: @388625
     /* 388625 */   GIM_Try, /*On fail goto*//*Label 7749*/ GIMT_Encode4(388694), // Rule ID 6009 //
     /* 388630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 388645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 388653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 388658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 388662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388666 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388670 */     // MIs[2] Operand 1
     /* 388670 */     // No operand predicates
     /* 388670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388674 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388676 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 388676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 388679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 388692 */     GIR_RootConstrainSelectedInstOperands,
     /* 388693 */     // GIR_Coverage, 6009,
     /* 388693 */     GIR_EraseRootFromParent_Done,
     /* 388694 */   // Label 7749: @388694
     /* 388694 */   GIM_Try, /*On fail goto*//*Label 7750*/ GIMT_Encode4(388793), // Rule ID 6075 //
     /* 388699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 388710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 388714 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388731 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388740 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388742 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 388745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388754 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388757 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 388761 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 388764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 388777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 388785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388791 */     GIR_RootConstrainSelectedInstOperands,
     /* 388792 */     // GIR_Coverage, 6075,
     /* 388792 */     GIR_EraseRootFromParent_Done,
     /* 388793 */   // Label 7750: @388793
     /* 388793 */   GIM_Try, /*On fail goto*//*Label 7751*/ GIMT_Encode4(388889), // Rule ID 6107 //
     /* 388798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 388817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 388821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388825 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388834 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388840 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 388843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388852 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388855 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388859 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 388862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 388875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 388881 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388887 */     GIR_RootConstrainSelectedInstOperands,
     /* 388888 */     // GIR_Coverage, 6107,
     /* 388888 */     GIR_EraseRootFromParent_Done,
     /* 388889 */   // Label 7751: @388889
     /* 388889 */   GIM_Try, /*On fail goto*//*Label 7752*/ GIMT_Encode4(388988), // Rule ID 6139 //
     /* 388894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 388901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 388905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 388909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 388918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 388922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 388926 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388931 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 388937 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 388937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 388940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 388944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388949 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 388952 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 388956 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 388959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 388969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 388972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 388976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 388980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 388986 */     GIR_RootConstrainSelectedInstOperands,
     /* 388987 */     // GIR_Coverage, 6139,
     /* 388987 */     GIR_EraseRootFromParent_Done,
     /* 388988 */   // Label 7752: @388988
     /* 388988 */   GIM_Try, /*On fail goto*//*Label 7753*/ GIMT_Encode4(389084), // Rule ID 6043 //
     /* 388993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 388996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 389020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 389024 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 389029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389035 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 389038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389047 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389054 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 389057 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389062 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 389067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 389070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389074 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389079 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389082 */     GIR_RootConstrainSelectedInstOperands,
     /* 389083 */     // GIR_Coverage, 6043,
     /* 389083 */     GIR_EraseRootFromParent_Done,
     /* 389084 */   // Label 7753: @389084
     /* 389084 */   GIM_Try, /*On fail goto*//*Label 7754*/ GIMT_Encode4(389168), // Rule ID 2531 //
     /* 389089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 389100 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 389109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389117 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389119 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 389122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389131 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389138 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 389141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389146 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 389151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 389154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389160 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389166 */     GIR_RootConstrainSelectedInstOperands,
     /* 389167 */     // GIR_Coverage, 2531,
     /* 389167 */     GIR_EraseRootFromParent_Done,
     /* 389168 */   // Label 7754: @389168
     /* 389168 */   GIM_Try, /*On fail goto*//*Label 7755*/ GIMT_Encode4(389218), // Rule ID 13261 //
     /* 389173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389203 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 389203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 389206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389216 */     GIR_RootConstrainSelectedInstOperands,
     /* 389217 */     // GIR_Coverage, 13261,
     /* 389217 */     GIR_EraseRootFromParent_Done,
     /* 389218 */   // Label 7755: @389218
     /* 389218 */   GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(389302), // Rule ID 6011 //
     /* 389223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389226 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389230 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389234 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 389238 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 389242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 389247 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389251 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389253 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389253 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 389256 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389260 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389265 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389268 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389272 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 389275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 389285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 389288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389292 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389300 */     GIR_RootConstrainSelectedInstOperands,
     /* 389301 */     // GIR_Coverage, 6011,
     /* 389301 */     GIR_EraseRootFromParent_Done,
     /* 389302 */   // Label 7756: @389302
     /* 389302 */   GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(389352), // Rule ID 1303 //
     /* 389307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 389326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389337 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 389337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 389340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389350 */     GIR_RootConstrainSelectedInstOperands,
     /* 389351 */     // GIR_Coverage, 1303,
     /* 389351 */     GIR_EraseRootFromParent_Done,
     /* 389352 */   // Label 7757: @389352
     /* 389352 */   GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(389385), // Rule ID 1293 //
     /* 389357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 389360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389372 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 389372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 389375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 389383 */     GIR_RootConstrainSelectedInstOperands,
     /* 389384 */     // GIR_Coverage, 1293,
     /* 389384 */     GIR_EraseRootFromParent_Done,
     /* 389385 */   // Label 7758: @389385
     /* 389385 */   GIM_Reject,
     /* 389386 */ // Label 7743: @389386
     /* 389386 */ GIM_Reject,
     /* 389387 */ // Label 7609: @389387
     /* 389387 */ GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(390907),
     /* 389392 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389395 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 389398 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 389401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389405 */   GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(389483), // Rule ID 6171 //
     /* 389410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389422 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389434 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389438 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389443 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 389447 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389451 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389455 */     // MIs[3] Operand 1
     /* 389455 */     // No operand predicates
     /* 389455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389463 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389465 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389481 */     GIR_RootConstrainSelectedInstOperands,
     /* 389482 */     // GIR_Coverage, 6171,
     /* 389482 */     GIR_EraseRootFromParent_Done,
     /* 389483 */   // Label 7760: @389483
     /* 389483 */   GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(389567), // Rule ID 6085 //
     /* 389488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389520 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389524 */     // MIs[2] Operand 1
     /* 389524 */     // No operand predicates
     /* 389524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 389528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389532 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389536 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389545 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389547 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 389558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 389565 */     GIR_RootConstrainSelectedInstOperands,
     /* 389566 */     // GIR_Coverage, 6085,
     /* 389566 */     GIR_EraseRootFromParent_Done,
     /* 389567 */   // Label 7761: @389567
     /* 389567 */   GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(389648), // Rule ID 6117 //
     /* 389572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389575 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389579 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389583 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389599 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 389603 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389608 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389612 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389616 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389620 */     // MIs[3] Operand 1
     /* 389620 */     // No operand predicates
     /* 389620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389624 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389628 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389630 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389639 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389646 */     GIR_RootConstrainSelectedInstOperands,
     /* 389647 */     // GIR_Coverage, 6117,
     /* 389647 */     GIR_EraseRootFromParent_Done,
     /* 389648 */   // Label 7762: @389648
     /* 389648 */   GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(389732), // Rule ID 6149 //
     /* 389653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 389677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389681 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389685 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 389689 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389698 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389702 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389706 */     // MIs[3] Operand 1
     /* 389706 */     // No operand predicates
     /* 389706 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389712 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389717 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 389723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389730 */     GIR_RootConstrainSelectedInstOperands,
     /* 389731 */     // GIR_Coverage, 6149,
     /* 389731 */     GIR_EraseRootFromParent_Done,
     /* 389732 */   // Label 7763: @389732
     /* 389732 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(389810), // Rule ID 6193 //
     /* 389737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389753 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389765 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389769 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389774 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 389778 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389782 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389786 */     // MIs[3] Operand 1
     /* 389786 */     // No operand predicates
     /* 389786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389792 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389808 */     GIR_RootConstrainSelectedInstOperands,
     /* 389809 */     // GIR_Coverage, 6193,
     /* 389809 */     GIR_EraseRootFromParent_Done,
     /* 389810 */   // Label 7764: @389810
     /* 389810 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(389891), // Rule ID 6053 //
     /* 389815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 389830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 389838 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389842 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389846 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 389850 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 389859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389863 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389867 */     // MIs[3] Operand 1
     /* 389867 */     // No operand predicates
     /* 389867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389871 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 389873 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 389876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 389886 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 389889 */     GIR_RootConstrainSelectedInstOperands,
     /* 389890 */     // GIR_Coverage, 6053,
     /* 389890 */     GIR_EraseRootFromParent_Done,
     /* 389891 */   // Label 7765: @389891
     /* 389891 */   GIM_Try, /*On fail goto*//*Label 7766*/ GIMT_Encode4(389960), // Rule ID 2541 //
     /* 389896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389907 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389911 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389915 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389920 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389924 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389928 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 389932 */     // MIs[2] Operand 1
     /* 389932 */     // No operand predicates
     /* 389932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389936 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389940 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389942 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 389942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 389945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389947 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 389949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 389951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 389955 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 389958 */     GIR_RootConstrainSelectedInstOperands,
     /* 389959 */     // GIR_Coverage, 2541,
     /* 389959 */     GIR_EraseRootFromParent_Done,
     /* 389960 */   // Label 7766: @389960
     /* 389960 */   GIM_Try, /*On fail goto*//*Label 7767*/ GIMT_Encode4(390029), // Rule ID 6021 //
     /* 389965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389968 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389972 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389976 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 389980 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 389984 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390001 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 390005 */     // MIs[2] Operand 1
     /* 390005 */     // No operand predicates
     /* 390005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390011 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 390011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 390014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390018 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 390027 */     GIR_RootConstrainSelectedInstOperands,
     /* 390028 */     // GIR_Coverage, 6021,
     /* 390028 */     GIR_EraseRootFromParent_Done,
     /* 390029 */   // Label 7767: @390029
     /* 390029 */   GIM_Try, /*On fail goto*//*Label 7768*/ GIMT_Encode4(390122), // Rule ID 6175 //
     /* 390034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390073 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390085 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390088 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390092 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 390108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390120 */     GIR_RootConstrainSelectedInstOperands,
     /* 390121 */     // GIR_Coverage, 6175,
     /* 390121 */     GIR_EraseRootFromParent_Done,
     /* 390122 */   // Label 7768: @390122
     /* 390122 */   GIM_Try, /*On fail goto*//*Label 7769*/ GIMT_Encode4(390221), // Rule ID 6087 //
     /* 390127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390155 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390159 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390170 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390170 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390173 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390177 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390182 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390185 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390189 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390192 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390197 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 390205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 390213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390216 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390219 */     GIR_RootConstrainSelectedInstOperands,
     /* 390220 */     // GIR_Coverage, 6087,
     /* 390220 */     GIR_EraseRootFromParent_Done,
     /* 390221 */   // Label 7769: @390221
     /* 390221 */   GIM_Try, /*On fail goto*//*Label 7770*/ GIMT_Encode4(390317), // Rule ID 6119 //
     /* 390226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 390249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390253 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390268 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390280 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390283 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390287 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390290 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 390303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390305 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390315 */     GIR_RootConstrainSelectedInstOperands,
     /* 390316 */     // GIR_Coverage, 6119,
     /* 390316 */     GIR_EraseRootFromParent_Done,
     /* 390317 */   // Label 7770: @390317
     /* 390317 */   GIM_Try, /*On fail goto*//*Label 7771*/ GIMT_Encode4(390416), // Rule ID 6151 //
     /* 390322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 390346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 390350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390354 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390365 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390377 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390384 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390387 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 390400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 390408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390414 */     GIR_RootConstrainSelectedInstOperands,
     /* 390415 */     // GIR_Coverage, 6151,
     /* 390415 */     GIR_EraseRootFromParent_Done,
     /* 390416 */   // Label 7771: @390416
     /* 390416 */   GIM_Try, /*On fail goto*//*Label 7772*/ GIMT_Encode4(390509), // Rule ID 6197 //
     /* 390421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390458 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390460 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390460 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390463 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390467 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390472 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390475 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390479 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 390495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390497 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390499 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390501 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390507 */     GIR_RootConstrainSelectedInstOperands,
     /* 390508 */     // GIR_Coverage, 6197,
     /* 390508 */     GIR_EraseRootFromParent_Done,
     /* 390509 */   // Label 7772: @390509
     /* 390509 */   GIM_Try, /*On fail goto*//*Label 7773*/ GIMT_Encode4(390605), // Rule ID 6055 //
     /* 390514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 390537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 390541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 390545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390556 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390568 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390571 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 390575 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390583 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 390591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390593 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390597 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390603 */     GIR_RootConstrainSelectedInstOperands,
     /* 390604 */     // GIR_Coverage, 6055,
     /* 390604 */     GIR_EraseRootFromParent_Done,
     /* 390605 */   // Label 7773: @390605
     /* 390605 */   GIM_Try, /*On fail goto*//*Label 7774*/ GIMT_Encode4(390689), // Rule ID 2543 //
     /* 390610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390640 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390652 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390655 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390659 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 390675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390687 */     GIR_RootConstrainSelectedInstOperands,
     /* 390688 */     // GIR_Coverage, 2543,
     /* 390688 */     GIR_EraseRootFromParent_Done,
     /* 390689 */   // Label 7774: @390689
     /* 390689 */   GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(390739), // Rule ID 13267 //
     /* 390694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390722 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390724 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 390724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 390727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390731 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390737 */     GIR_RootConstrainSelectedInstOperands,
     /* 390738 */     // GIR_Coverage, 13267,
     /* 390738 */     GIR_EraseRootFromParent_Done,
     /* 390739 */   // Label 7775: @390739
     /* 390739 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(390823), // Rule ID 6023 //
     /* 390744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 390759 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 390763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390774 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390786 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390789 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390793 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390796 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390801 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 390809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390813 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390821 */     GIR_RootConstrainSelectedInstOperands,
     /* 390822 */     // GIR_Coverage, 6023,
     /* 390822 */     GIR_EraseRootFromParent_Done,
     /* 390823 */   // Label 7776: @390823
     /* 390823 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(390873), // Rule ID 1309 //
     /* 390828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 390839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 390847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390852 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390858 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 390858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 390861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390865 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 390867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 390871 */     GIR_RootConstrainSelectedInstOperands,
     /* 390872 */     // GIR_Coverage, 1309,
     /* 390872 */     GIR_EraseRootFromParent_Done,
     /* 390873 */   // Label 7777: @390873
     /* 390873 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(390906), // Rule ID 1299 //
     /* 390878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390893 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 390893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 390896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 390902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 390904 */     GIR_RootConstrainSelectedInstOperands,
     /* 390905 */     // GIR_Coverage, 1299,
     /* 390905 */     GIR_EraseRootFromParent_Done,
     /* 390906 */   // Label 7778: @390906
     /* 390906 */   GIM_Reject,
     /* 390907 */ // Label 7759: @390907
     /* 390907 */ GIM_Reject,
     /* 390908 */ // Label 7610: @390908
     /* 390908 */ GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(392086),
     /* 390913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390916 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 390919 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 390922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390926 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(391010), // Rule ID 6069 //
     /* 390931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 390934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 390942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390946 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390950 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 390955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390963 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 390967 */     // MIs[2] Operand 1
     /* 390967 */     // No operand predicates
     /* 390967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 390971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 390975 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 390979 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390988 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 390990 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 390990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 390993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 390997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 391001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391005 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 391008 */     GIR_RootConstrainSelectedInstOperands,
     /* 391009 */     // GIR_Coverage, 6069,
     /* 391009 */     GIR_EraseRootFromParent_Done,
     /* 391010 */   // Label 7780: @391010
     /* 391010 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(391091), // Rule ID 6101 //
     /* 391015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391026 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391030 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391034 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 391038 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391042 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391046 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 391051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391059 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 391063 */     // MIs[3] Operand 1
     /* 391063 */     // No operand predicates
     /* 391063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391071 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391073 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 391073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 391076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 391089 */     GIR_RootConstrainSelectedInstOperands,
     /* 391090 */     // GIR_Coverage, 6101,
     /* 391090 */     GIR_EraseRootFromParent_Done,
     /* 391091 */   // Label 7781: @391091
     /* 391091 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(391175), // Rule ID 6133 //
     /* 391096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391116 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391120 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 391124 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391128 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391132 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 391137 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391141 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391145 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 391149 */     // MIs[3] Operand 1
     /* 391149 */     // No operand predicates
     /* 391149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391153 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391155 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 391155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 391158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391162 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391166 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391170 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 391173 */     GIR_RootConstrainSelectedInstOperands,
     /* 391174 */     // GIR_Coverage, 6133,
     /* 391174 */     GIR_EraseRootFromParent_Done,
     /* 391175 */   // Label 7782: @391175
     /* 391175 */   GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(391256), // Rule ID 6037 //
     /* 391180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 391207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391211 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 391215 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 391220 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 391224 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391228 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 391232 */     // MIs[3] Operand 1
     /* 391232 */     // No operand predicates
     /* 391232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391236 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 391238 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 391238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 391241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 391254 */     GIR_RootConstrainSelectedInstOperands,
     /* 391255 */     // GIR_Coverage, 6037,
     /* 391255 */     GIR_EraseRootFromParent_Done,
     /* 391256 */   // Label 7783: @391256
     /* 391256 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(391325), // Rule ID 2525 //
     /* 391261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 391272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 391285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391293 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 391297 */     // MIs[2] Operand 1
     /* 391297 */     // No operand predicates
     /* 391297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391305 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391307 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 391307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 391310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391320 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 391323 */     GIR_RootConstrainSelectedInstOperands,
     /* 391324 */     // GIR_Coverage, 2525,
     /* 391324 */     GIR_EraseRootFromParent_Done,
     /* 391325 */   // Label 7784: @391325
     /* 391325 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(391394), // Rule ID 6005 //
     /* 391330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 391345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 391358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391366 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 391370 */     // MIs[2] Operand 1
     /* 391370 */     // No operand predicates
     /* 391370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391376 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 391376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 391379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391383 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391389 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 391392 */     GIR_RootConstrainSelectedInstOperands,
     /* 391393 */     // GIR_Coverage, 6005,
     /* 391393 */     GIR_EraseRootFromParent_Done,
     /* 391394 */   // Label 7785: @391394
     /* 391394 */   GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(391493), // Rule ID 6071 //
     /* 391399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 391410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391427 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391431 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391442 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 391445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391454 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391457 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391461 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391469 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 391477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 391485 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391488 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391491 */     GIR_RootConstrainSelectedInstOperands,
     /* 391492 */     // GIR_Coverage, 6071,
     /* 391492 */     GIR_EraseRootFromParent_Done,
     /* 391493 */   // Label 7786: @391493
     /* 391493 */   GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(391589), // Rule ID 6103 //
     /* 391498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391513 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391517 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 391521 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391540 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391540 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 391543 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391547 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391552 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391559 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 391575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391577 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391587 */     GIR_RootConstrainSelectedInstOperands,
     /* 391588 */     // GIR_Coverage, 6103,
     /* 391588 */     GIR_EraseRootFromParent_Done,
     /* 391589 */   // Label 7787: @391589
     /* 391589 */   GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(391688), // Rule ID 6135 //
     /* 391594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 391618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 391622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391626 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391631 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391637 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391637 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 391640 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391644 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391649 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391656 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391659 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391664 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 391672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 391680 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391686 */     GIR_RootConstrainSelectedInstOperands,
     /* 391687 */     // GIR_Coverage, 6135,
     /* 391687 */     GIR_EraseRootFromParent_Done,
     /* 391688 */   // Label 7788: @391688
     /* 391688 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(391784), // Rule ID 6039 //
     /* 391693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391696 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 391716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 391720 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 391724 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391729 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391733 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391735 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 391738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391747 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 391754 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391757 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391762 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 391770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391782 */     GIR_RootConstrainSelectedInstOperands,
     /* 391783 */     // GIR_Coverage, 6039,
     /* 391783 */     GIR_EraseRootFromParent_Done,
     /* 391784 */   // Label 7789: @391784
     /* 391784 */   GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(391868), // Rule ID 2527 //
     /* 391789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 391800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391819 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 391822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391831 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391834 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391838 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391846 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 391854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391856 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391860 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391863 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391866 */     GIR_RootConstrainSelectedInstOperands,
     /* 391867 */     // GIR_Coverage, 2527,
     /* 391867 */     GIR_EraseRootFromParent_Done,
     /* 391868 */   // Label 7790: @391868
     /* 391868 */   GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(391918), // Rule ID 13263 //
     /* 391873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 391884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 391888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391901 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391903 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 391903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 391906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 391912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391916 */     GIR_RootConstrainSelectedInstOperands,
     /* 391917 */     // GIR_Coverage, 13263,
     /* 391917 */     GIR_EraseRootFromParent_Done,
     /* 391918 */   // Label 7791: @391918
     /* 391918 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(392002), // Rule ID 6007 //
     /* 391923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 391926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 391934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 391938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 391942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391953 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 391956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391965 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391968 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 391972 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 391985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 391988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 391992 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 391994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 392000 */     GIR_RootConstrainSelectedInstOperands,
     /* 392001 */     // GIR_Coverage, 6007,
     /* 392001 */     GIR_EraseRootFromParent_Done,
     /* 392002 */   // Label 7792: @392002
     /* 392002 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(392052), // Rule ID 1305 //
     /* 392007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392010 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 392018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 392022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392031 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392035 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392037 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 392037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 392040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 392046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 392050 */     GIR_RootConstrainSelectedInstOperands,
     /* 392051 */     // GIR_Coverage, 1305,
     /* 392051 */     GIR_EraseRootFromParent_Done,
     /* 392052 */   // Label 7793: @392052
     /* 392052 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(392085), // Rule ID 1295 //
     /* 392057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392072 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 392072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 392075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 392077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 392079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 392081 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 392083 */     GIR_RootConstrainSelectedInstOperands,
     /* 392084 */     // GIR_Coverage, 1295,
     /* 392084 */     GIR_EraseRootFromParent_Done,
     /* 392085 */   // Label 7794: @392085
     /* 392085 */   GIM_Reject,
     /* 392086 */ // Label 7779: @392086
     /* 392086 */ GIM_Reject,
     /* 392087 */ // Label 7611: @392087
     /* 392087 */ GIM_Reject,
     /* 392088 */ // Label 106: @392088
     /* 392088 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7803*/ GIMT_Encode4(392387),
     /* 392099 */ /*GILLT_s16*//*Label 7795*/ GIMT_Encode4(392139),
     /* 392103 */ /*GILLT_s32*//*Label 7796*/ GIMT_Encode4(392170),
     /* 392107 */ /*GILLT_s64*//*Label 7797*/ GIMT_Encode4(392201), GIMT_Encode4(0),
     /* 392115 */ /*GILLT_v2s32*//*Label 7798*/ GIMT_Encode4(392232),
     /* 392119 */ /*GILLT_v2s64*//*Label 7799*/ GIMT_Encode4(392263),
     /* 392123 */ /*GILLT_v4s16*//*Label 7800*/ GIMT_Encode4(392294),
     /* 392127 */ /*GILLT_v4s32*//*Label 7801*/ GIMT_Encode4(392325), GIMT_Encode4(0),
     /* 392135 */ /*GILLT_v8s16*//*Label 7802*/ GIMT_Encode4(392356),
     /* 392139 */ // Label 7795: @392139
     /* 392139 */ GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(392169), // Rule ID 569 //
     /* 392144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 392147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 392150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392158 */   // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 392158 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 392163 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392167 */   GIR_RootConstrainSelectedInstOperands,
     /* 392168 */   // GIR_Coverage, 569,
     /* 392168 */   GIR_Done,
     /* 392169 */ // Label 7804: @392169
     /* 392169 */ GIM_Reject,
     /* 392170 */ // Label 7796: @392170
     /* 392170 */ GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(392200), // Rule ID 571 //
     /* 392175 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 392178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392185 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392189 */   // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 392189 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 392194 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392198 */   GIR_RootConstrainSelectedInstOperands,
     /* 392199 */   // GIR_Coverage, 571,
     /* 392199 */   GIR_Done,
     /* 392200 */ // Label 7805: @392200
     /* 392200 */ GIM_Reject,
     /* 392201 */ // Label 7797: @392201
     /* 392201 */ GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(392231), // Rule ID 573 //
     /* 392206 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 392209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392216 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392220 */   // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 392220 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 392225 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392229 */   GIR_RootConstrainSelectedInstOperands,
     /* 392230 */   // GIR_Coverage, 573,
     /* 392230 */   GIR_Done,
     /* 392231 */ // Label 7806: @392231
     /* 392231 */ GIM_Reject,
     /* 392232 */ // Label 7798: @392232
     /* 392232 */ GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(392262), // Rule ID 959 //
     /* 392237 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392240 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392251 */   // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 392251 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 392256 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392260 */   GIR_RootConstrainSelectedInstOperands,
     /* 392261 */   // GIR_Coverage, 959,
     /* 392261 */   GIR_Done,
     /* 392262 */ // Label 7807: @392262
     /* 392262 */ GIM_Reject,
     /* 392263 */ // Label 7799: @392263
     /* 392263 */ GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(392293), // Rule ID 963 //
     /* 392268 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392271 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392274 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392278 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392282 */   // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 392282 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 392287 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392291 */   GIR_RootConstrainSelectedInstOperands,
     /* 392292 */   // GIR_Coverage, 963,
     /* 392292 */   GIR_Done,
     /* 392293 */ // Label 7808: @392293
     /* 392293 */ GIM_Reject,
     /* 392294 */ // Label 7800: @392294
     /* 392294 */ GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(392324), // Rule ID 955 //
     /* 392299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392313 */   // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 392313 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 392318 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392322 */   GIR_RootConstrainSelectedInstOperands,
     /* 392323 */   // GIR_Coverage, 955,
     /* 392323 */   GIR_Done,
     /* 392324 */ // Label 7809: @392324
     /* 392324 */ GIM_Reject,
     /* 392325 */ // Label 7801: @392325
     /* 392325 */ GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(392355), // Rule ID 961 //
     /* 392330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392344 */   // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 392344 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 392349 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392353 */   GIR_RootConstrainSelectedInstOperands,
     /* 392354 */   // GIR_Coverage, 961,
     /* 392354 */   GIR_Done,
     /* 392355 */ // Label 7810: @392355
     /* 392355 */ GIM_Reject,
     /* 392356 */ // Label 7802: @392356
     /* 392356 */ GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(392386), // Rule ID 957 //
     /* 392361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392375 */   // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 392375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 392380 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392384 */   GIR_RootConstrainSelectedInstOperands,
     /* 392385 */   // GIR_Coverage, 957,
     /* 392385 */   GIR_Done,
     /* 392386 */ // Label 7811: @392386
     /* 392386 */ GIM_Reject,
     /* 392387 */ // Label 7803: @392387
     /* 392387 */ GIM_Reject,
     /* 392388 */ // Label 107: @392388
     /* 392388 */ GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(392401), // Rule ID 6492 //
     /* 392393 */   // (trap)  =>  (BRK 1:{ *:[i32] })
     /* 392393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 392396 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 392399 */   GIR_RootConstrainSelectedInstOperands,
     /* 392400 */   // GIR_Coverage, 6492,
     /* 392400 */   GIR_EraseRootFromParent_Done,
     /* 392401 */ // Label 7812: @392401
     /* 392401 */ GIM_Reject,
     /* 392402 */ // Label 108: @392402
     /* 392402 */ GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(392422), // Rule ID 6493 //
     /* 392407 */   // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
     /* 392407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 392410 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
     /* 392420 */   GIR_RootConstrainSelectedInstOperands,
     /* 392421 */   // GIR_Coverage, 6493,
     /* 392421 */   GIR_EraseRootFromParent_Done,
     /* 392422 */ // Label 7813: @392422
     /* 392422 */ GIM_Reject,
     /* 392423 */ // Label 109: @392423
     /* 392423 */ GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(392447), // Rule ID 6494 //
     /* 392428 */   // MIs[0] kind
     /* 392428 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 392431 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
     /* 392436 */   // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
     /* 392436 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 392439 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
     /* 392445 */   GIR_RootConstrainSelectedInstOperands,
     /* 392446 */   // GIR_Coverage, 6494,
     /* 392446 */   GIR_EraseRootFromParent_Done,
     /* 392447 */ // Label 7814: @392447
     /* 392447 */ GIM_Reject,
     /* 392448 */ // Label 110: @392448
     /* 392448 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7818*/ GIMT_Encode4(392757),
     /* 392459 */ /*GILLT_s16*//*Label 7815*/ GIMT_Encode4(392471),
     /* 392463 */ /*GILLT_s32*//*Label 7816*/ GIMT_Encode4(392624),
     /* 392467 */ /*GILLT_s64*//*Label 7817*/ GIMT_Encode4(392729),
     /* 392471 */ // Label 7815: @392471
     /* 392471 */ GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(392572), // Rule ID 5589 //
     /* 392476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 392479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392490 */   // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
     /* 392490 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 392493 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 392497 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392502 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392506 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392510 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 392512 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 392515 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 392519 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392524 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 392527 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392531 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 392533 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 392536 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 392540 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392545 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 392552 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392557 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392562 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 392565 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392567 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392570 */   GIR_RootConstrainSelectedInstOperands,
     /* 392571 */   // GIR_Coverage, 5589,
     /* 392571 */   GIR_EraseRootFromParent_Done,
     /* 392572 */ // Label 7819: @392572
     /* 392572 */ GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(392623), // Rule ID 5590 //
     /* 392577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 392580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392591 */   // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
     /* 392591 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 392594 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 392598 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392603 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392607 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392613 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 392616 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392618 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392621 */   GIR_RootConstrainSelectedInstOperands,
     /* 392622 */   // GIR_Coverage, 5590,
     /* 392622 */   GIR_EraseRootFromParent_Done,
     /* 392623 */ // Label 7820: @392623
     /* 392623 */ GIM_Reject,
     /* 392624 */ // Label 7816: @392624
     /* 392624 */ GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(392701), // Rule ID 5591 //
     /* 392629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392640 */   // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 392640 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 392643 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 392647 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392652 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392656 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 392662 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 392665 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 392669 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392674 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 392681 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392686 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 392694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392696 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392699 */   GIR_RootConstrainSelectedInstOperands,
     /* 392700 */   // GIR_Coverage, 5591,
     /* 392700 */   GIR_EraseRootFromParent_Done,
     /* 392701 */ // Label 7821: @392701
     /* 392701 */ GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(392728), // Rule ID 5592 //
     /* 392706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392717 */   // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 392717 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 392722 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392726 */   GIR_RootConstrainSelectedInstOperands,
     /* 392727 */   // GIR_Coverage, 5592,
     /* 392727 */   GIR_Done,
     /* 392728 */ // Label 7822: @392728
     /* 392728 */ GIM_Reject,
     /* 392729 */ // Label 7817: @392729
     /* 392729 */ GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(392756), // Rule ID 5593 //
     /* 392734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392745 */   // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 392745 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 392750 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392754 */   GIR_RootConstrainSelectedInstOperands,
     /* 392755 */   // GIR_Coverage, 5593,
     /* 392755 */   GIR_Done,
     /* 392756 */ // Label 7823: @392756
     /* 392756 */ GIM_Reject,
     /* 392757 */ // Label 7818: @392757
     /* 392757 */ GIM_Reject,
     /* 392758 */ // Label 111: @392758
     /* 392758 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7827*/ GIMT_Encode4(392928),
     /* 392769 */ /*GILLT_s16*//*Label 7824*/ GIMT_Encode4(392781),
     /* 392773 */ /*GILLT_s32*//*Label 7825*/ GIMT_Encode4(392842),
     /* 392777 */ /*GILLT_s64*//*Label 7826*/ GIMT_Encode4(392900),
     /* 392781 */ // Label 7824: @392781
     /* 392781 */ GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(392811), // Rule ID 1942 //
     /* 392786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392800 */   // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 392800 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 392805 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392809 */   GIR_RootConstrainSelectedInstOperands,
     /* 392810 */   // GIR_Coverage, 1942,
     /* 392810 */   GIR_Done,
     /* 392811 */ // Label 7828: @392811
     /* 392811 */ GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(392841), // Rule ID 1944 //
     /* 392816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392830 */   // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 392830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 392835 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392839 */   GIR_RootConstrainSelectedInstOperands,
     /* 392840 */   // GIR_Coverage, 1944,
     /* 392840 */   GIR_Done,
     /* 392841 */ // Label 7829: @392841
     /* 392841 */ GIM_Reject,
     /* 392842 */ // Label 7825: @392842
     /* 392842 */ GIM_Try, /*On fail goto*//*Label 7830*/ GIMT_Encode4(392872), // Rule ID 1946 //
     /* 392847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392857 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392861 */   // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 392861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 392866 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392870 */   GIR_RootConstrainSelectedInstOperands,
     /* 392871 */   // GIR_Coverage, 1946,
     /* 392871 */   GIR_Done,
     /* 392872 */ // Label 7830: @392872
     /* 392872 */ GIM_Try, /*On fail goto*//*Label 7831*/ GIMT_Encode4(392899), // Rule ID 5599 //
     /* 392877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 392884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392888 */   // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 392888 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 392893 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392897 */   GIR_RootConstrainSelectedInstOperands,
     /* 392898 */   // GIR_Coverage, 5599,
     /* 392898 */   GIR_Done,
     /* 392899 */ // Label 7831: @392899
     /* 392899 */ GIM_Reject,
     /* 392900 */ // Label 7826: @392900
     /* 392900 */ GIM_Try, /*On fail goto*//*Label 7832*/ GIMT_Encode4(392927), // Rule ID 5601 //
     /* 392905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 392908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392916 */   // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 392916 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 392921 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392925 */   GIR_RootConstrainSelectedInstOperands,
     /* 392926 */   // GIR_Coverage, 5601,
     /* 392926 */   GIR_Done,
     /* 392927 */ // Label 7832: @392927
     /* 392927 */ GIM_Reject,
     /* 392928 */ // Label 7827: @392928
     /* 392928 */ GIM_Reject,
     /* 392929 */ // Label 112: @392929
     /* 392929 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7836*/ GIMT_Encode4(393099),
     /* 392940 */ /*GILLT_s16*//*Label 7833*/ GIMT_Encode4(392952),
     /* 392944 */ /*GILLT_s32*//*Label 7834*/ GIMT_Encode4(393013),
     /* 392948 */ /*GILLT_s64*//*Label 7835*/ GIMT_Encode4(393071),
     /* 392952 */ // Label 7833: @392952
     /* 392952 */ GIM_Try, /*On fail goto*//*Label 7837*/ GIMT_Encode4(392982), // Rule ID 1954 //
     /* 392957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392963 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392967 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392971 */   // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 392971 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 392976 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 392980 */   GIR_RootConstrainSelectedInstOperands,
     /* 392981 */   // GIR_Coverage, 1954,
     /* 392981 */   GIR_Done,
     /* 392982 */ // Label 7837: @392982
     /* 392982 */ GIM_Try, /*On fail goto*//*Label 7838*/ GIMT_Encode4(393012), // Rule ID 1956 //
     /* 392987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 392990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 392997 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393001 */   // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 393001 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 393006 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393010 */   GIR_RootConstrainSelectedInstOperands,
     /* 393011 */   // GIR_Coverage, 1956,
     /* 393011 */   GIR_Done,
     /* 393012 */ // Label 7838: @393012
     /* 393012 */ GIM_Reject,
     /* 393013 */ // Label 7834: @393013
     /* 393013 */ GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(393043), // Rule ID 1958 //
     /* 393018 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393021 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393032 */   // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 393032 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 393037 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393041 */   GIR_RootConstrainSelectedInstOperands,
     /* 393042 */   // GIR_Coverage, 1958,
     /* 393042 */   GIR_Done,
     /* 393043 */ // Label 7839: @393043
     /* 393043 */ GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(393070), // Rule ID 5607 //
     /* 393048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393059 */   // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 393059 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 393064 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393068 */   GIR_RootConstrainSelectedInstOperands,
     /* 393069 */   // GIR_Coverage, 5607,
     /* 393069 */   GIR_Done,
     /* 393070 */ // Label 7840: @393070
     /* 393070 */ GIM_Reject,
     /* 393071 */ // Label 7835: @393071
     /* 393071 */ GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(393098), // Rule ID 5609 //
     /* 393076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393087 */   // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 393087 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 393092 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393096 */   GIR_RootConstrainSelectedInstOperands,
     /* 393097 */   // GIR_Coverage, 5609,
     /* 393097 */   GIR_Done,
     /* 393098 */ // Label 7841: @393098
     /* 393098 */ GIM_Reject,
     /* 393099 */ // Label 7836: @393099
     /* 393099 */ GIM_Reject,
     /* 393100 */ // Label 113: @393100
     /* 393100 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7845*/ GIMT_Encode4(393270),
     /* 393111 */ /*GILLT_s16*//*Label 7842*/ GIMT_Encode4(393123),
     /* 393115 */ /*GILLT_s32*//*Label 7843*/ GIMT_Encode4(393184),
     /* 393119 */ /*GILLT_s64*//*Label 7844*/ GIMT_Encode4(393242),
     /* 393123 */ // Label 7842: @393123
     /* 393123 */ GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(393153), // Rule ID 1948 //
     /* 393128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393142 */   // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 393142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 393147 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393151 */   GIR_RootConstrainSelectedInstOperands,
     /* 393152 */   // GIR_Coverage, 1948,
     /* 393152 */   GIR_Done,
     /* 393153 */ // Label 7846: @393153
     /* 393153 */ GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(393183), // Rule ID 1950 //
     /* 393158 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393172 */   // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 393172 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 393177 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393181 */   GIR_RootConstrainSelectedInstOperands,
     /* 393182 */   // GIR_Coverage, 1950,
     /* 393182 */   GIR_Done,
     /* 393183 */ // Label 7847: @393183
     /* 393183 */ GIM_Reject,
     /* 393184 */ // Label 7843: @393184
     /* 393184 */ GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(393214), // Rule ID 1952 //
     /* 393189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393203 */   // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 393203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 393208 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393212 */   GIR_RootConstrainSelectedInstOperands,
     /* 393213 */   // GIR_Coverage, 1952,
     /* 393213 */   GIR_Done,
     /* 393214 */ // Label 7848: @393214
     /* 393214 */ GIM_Try, /*On fail goto*//*Label 7849*/ GIMT_Encode4(393241), // Rule ID 5603 //
     /* 393219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393230 */   // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 393230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 393235 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393239 */   GIR_RootConstrainSelectedInstOperands,
     /* 393240 */   // GIR_Coverage, 5603,
     /* 393240 */   GIR_Done,
     /* 393241 */ // Label 7849: @393241
     /* 393241 */ GIM_Reject,
     /* 393242 */ // Label 7844: @393242
     /* 393242 */ GIM_Try, /*On fail goto*//*Label 7850*/ GIMT_Encode4(393269), // Rule ID 5605 //
     /* 393247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393258 */   // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 393258 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 393263 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393267 */   GIR_RootConstrainSelectedInstOperands,
     /* 393268 */   // GIR_Coverage, 5605,
     /* 393268 */   GIR_Done,
     /* 393269 */ // Label 7850: @393269
     /* 393269 */ GIM_Reject,
     /* 393270 */ // Label 7845: @393270
     /* 393270 */ GIM_Reject,
     /* 393271 */ // Label 114: @393271
     /* 393271 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7854*/ GIMT_Encode4(393441),
     /* 393282 */ /*GILLT_s16*//*Label 7851*/ GIMT_Encode4(393294),
     /* 393286 */ /*GILLT_s32*//*Label 7852*/ GIMT_Encode4(393355),
     /* 393290 */ /*GILLT_s64*//*Label 7853*/ GIMT_Encode4(393413),
     /* 393294 */ // Label 7851: @393294
     /* 393294 */ GIM_Try, /*On fail goto*//*Label 7855*/ GIMT_Encode4(393324), // Rule ID 1960 //
     /* 393299 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393313 */   // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 393313 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 393318 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393322 */   GIR_RootConstrainSelectedInstOperands,
     /* 393323 */   // GIR_Coverage, 1960,
     /* 393323 */   GIR_Done,
     /* 393324 */ // Label 7855: @393324
     /* 393324 */ GIM_Try, /*On fail goto*//*Label 7856*/ GIMT_Encode4(393354), // Rule ID 1962 //
     /* 393329 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393335 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393339 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393343 */   // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 393343 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 393348 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393352 */   GIR_RootConstrainSelectedInstOperands,
     /* 393353 */   // GIR_Coverage, 1962,
     /* 393353 */   GIR_Done,
     /* 393354 */ // Label 7856: @393354
     /* 393354 */ GIM_Reject,
     /* 393355 */ // Label 7852: @393355
     /* 393355 */ GIM_Try, /*On fail goto*//*Label 7857*/ GIMT_Encode4(393385), // Rule ID 1964 //
     /* 393360 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393366 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393370 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393374 */   // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 393374 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 393379 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393383 */   GIR_RootConstrainSelectedInstOperands,
     /* 393384 */   // GIR_Coverage, 1964,
     /* 393384 */   GIR_Done,
     /* 393385 */ // Label 7857: @393385
     /* 393385 */ GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(393412), // Rule ID 5611 //
     /* 393390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393401 */   // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 393401 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 393406 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393410 */   GIR_RootConstrainSelectedInstOperands,
     /* 393411 */   // GIR_Coverage, 5611,
     /* 393411 */   GIR_Done,
     /* 393412 */ // Label 7858: @393412
     /* 393412 */ GIM_Reject,
     /* 393413 */ // Label 7853: @393413
     /* 393413 */ GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(393440), // Rule ID 5613 //
     /* 393418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393429 */   // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 393429 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 393434 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393438 */   GIR_RootConstrainSelectedInstOperands,
     /* 393439 */   // GIR_Coverage, 5613,
     /* 393439 */   GIR_Done,
     /* 393440 */ // Label 7859: @393440
     /* 393440 */ GIM_Reject,
     /* 393441 */ // Label 7854: @393441
     /* 393441 */ GIM_Reject,
     /* 393442 */ // Label 115: @393442
     /* 393442 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 7864*/ GIMT_Encode4(394570),
     /* 393453 */ /*GILLT_s8*//*Label 7860*/ GIMT_Encode4(393469),
     /* 393457 */ /*GILLT_s16*//*Label 7861*/ GIMT_Encode4(393516),
     /* 393461 */ /*GILLT_s32*//*Label 7862*/ GIMT_Encode4(393931),
     /* 393465 */ /*GILLT_s64*//*Label 7863*/ GIMT_Encode4(394384),
     /* 393469 */ // Label 7860: @393469
     /* 393469 */ GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(393492), // Rule ID 5858 //
     /* 393474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 393477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 393481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393485 */   // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 393485 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 393490 */   GIR_RootConstrainSelectedInstOperands,
     /* 393491 */   // GIR_Coverage, 5858,
     /* 393491 */   GIR_Done,
     /* 393492 */ // Label 7865: @393492
     /* 393492 */ GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(393515), // Rule ID 5859 //
     /* 393497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 393500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 393504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393508 */   // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 393508 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 393513 */   GIR_RootConstrainSelectedInstOperands,
     /* 393514 */   // GIR_Coverage, 5859,
     /* 393514 */   GIR_Done,
     /* 393515 */ // Label 7866: @393515
     /* 393515 */ GIM_Reject,
     /* 393516 */ // Label 7861: @393516
     /* 393516 */ GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(393566), // Rule ID 5805 //
     /* 393521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393528 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393532 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393536 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393539 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 393544 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 393548 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393553 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393555 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 393555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 393558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393560 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393564 */   GIR_RootConstrainSelectedInstOperands,
     /* 393565 */   // GIR_Coverage, 5805,
     /* 393565 */   GIR_EraseRootFromParent_Done,
     /* 393566 */ // Label 7867: @393566
     /* 393566 */ GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(393616), // Rule ID 5807 //
     /* 393571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393578 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393582 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393586 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393589 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 393594 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 393598 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393603 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393605 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 393605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 393608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393610 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393614 */   GIR_RootConstrainSelectedInstOperands,
     /* 393615 */   // GIR_Coverage, 5807,
     /* 393615 */   GIR_EraseRootFromParent_Done,
     /* 393616 */ // Label 7868: @393616
     /* 393616 */ GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(393666), // Rule ID 5815 //
     /* 393621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393628 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393632 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393636 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393639 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 393644 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 393648 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393653 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393655 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 393655 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 393658 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393660 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393664 */   GIR_RootConstrainSelectedInstOperands,
     /* 393665 */   // GIR_Coverage, 5815,
     /* 393665 */   GIR_EraseRootFromParent_Done,
     /* 393666 */ // Label 7869: @393666
     /* 393666 */ GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(393716), // Rule ID 5817 //
     /* 393671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393674 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393678 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393682 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393686 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393689 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 393694 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 393698 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393703 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393705 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 393705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 393708 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393710 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393714 */   GIR_RootConstrainSelectedInstOperands,
     /* 393715 */   // GIR_Coverage, 5817,
     /* 393715 */   GIR_EraseRootFromParent_Done,
     /* 393716 */ // Label 7870: @393716
     /* 393716 */ GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(393758), // Rule ID 5814 //
     /* 393721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393728 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393732 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 393736 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 393740 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393745 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393747 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 393747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 393750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393752 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393756 */   GIR_RootConstrainSelectedInstOperands,
     /* 393757 */   // GIR_Coverage, 5814,
     /* 393757 */   GIR_EraseRootFromParent_Done,
     /* 393758 */ // Label 7871: @393758
     /* 393758 */ GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(393800), // Rule ID 5816 //
     /* 393763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393770 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393774 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 393778 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 393782 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393787 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393789 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 393789 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 393792 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393794 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393798 */   GIR_RootConstrainSelectedInstOperands,
     /* 393799 */   // GIR_Coverage, 5816,
     /* 393799 */   GIR_EraseRootFromParent_Done,
     /* 393800 */ // Label 7872: @393800
     /* 393800 */ GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(393842), // Rule ID 5804 //
     /* 393805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393812 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393816 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 393820 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 393824 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393829 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393831 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 393831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 393834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393836 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393840 */   GIR_RootConstrainSelectedInstOperands,
     /* 393841 */   // GIR_Coverage, 5804,
     /* 393841 */   GIR_EraseRootFromParent_Done,
     /* 393842 */ // Label 7873: @393842
     /* 393842 */ GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(393884), // Rule ID 5806 //
     /* 393847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393854 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393858 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 393862 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 393866 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393871 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393873 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 393873 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 393876 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393878 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393882 */   GIR_RootConstrainSelectedInstOperands,
     /* 393883 */   // GIR_Coverage, 5806,
     /* 393883 */   GIR_EraseRootFromParent_Done,
     /* 393884 */ // Label 7874: @393884
     /* 393884 */ GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(393907), // Rule ID 5860 //
     /* 393889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393900 */   // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 393900 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 393905 */   GIR_RootConstrainSelectedInstOperands,
     /* 393906 */   // GIR_Coverage, 5860,
     /* 393906 */   GIR_Done,
     /* 393907 */ // Label 7875: @393907
     /* 393907 */ GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(393930), // Rule ID 5861 //
     /* 393912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393923 */   // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 393923 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 393928 */   GIR_RootConstrainSelectedInstOperands,
     /* 393929 */   // GIR_Coverage, 5861,
     /* 393929 */   GIR_Done,
     /* 393930 */ // Label 7876: @393930
     /* 393930 */ GIM_Reject,
     /* 393931 */ // Label 7862: @393931
     /* 393931 */ GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(393981), // Rule ID 5809 //
     /* 393936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393943 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393947 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 393951 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 393954 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 393959 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 393963 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393968 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393970 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 393970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 393973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393975 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 393979 */   GIR_RootConstrainSelectedInstOperands,
     /* 393980 */   // GIR_Coverage, 5809,
     /* 393980 */   GIR_EraseRootFromParent_Done,
     /* 393981 */ // Label 7877: @393981
     /* 393981 */ GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(394031), // Rule ID 5811 //
     /* 393986 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393993 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393997 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 394001 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 394004 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 394009 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 394013 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394018 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394020 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 725:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 394020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 394023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394025 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 394029 */   GIR_RootConstrainSelectedInstOperands,
     /* 394030 */   // GIR_Coverage, 5811,
     /* 394030 */   GIR_EraseRootFromParent_Done,
     /* 394031 */ // Label 7878: @394031
     /* 394031 */ GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(394081), // Rule ID 5819 //
     /* 394036 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394043 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394047 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 394051 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 394054 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 394059 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 394063 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394068 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394070 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 660:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 394070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 394073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394075 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 394079 */   GIR_RootConstrainSelectedInstOperands,
     /* 394080 */   // GIR_Coverage, 5819,
     /* 394080 */   GIR_EraseRootFromParent_Done,
     /* 394081 */ // Label 7879: @394081
     /* 394081 */ GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(394131), // Rule ID 5821 //
     /* 394086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394089 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394093 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394097 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 394101 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 394104 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 394109 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 394113 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394118 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394120 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 660:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 394120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 394123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394125 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 394129 */   GIR_RootConstrainSelectedInstOperands,
     /* 394130 */   // GIR_Coverage, 5821,
     /* 394130 */   GIR_EraseRootFromParent_Done,
     /* 394131 */ // Label 7880: @394131
     /* 394131 */ GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(394173), // Rule ID 5818 //
     /* 394136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394143 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394147 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 394151 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394155 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394160 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394162 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 394162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 394165 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394167 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394171 */   GIR_RootConstrainSelectedInstOperands,
     /* 394172 */   // GIR_Coverage, 5818,
     /* 394172 */   GIR_EraseRootFromParent_Done,
     /* 394173 */ // Label 7881: @394173
     /* 394173 */ GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(394215), // Rule ID 5820 //
     /* 394178 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394181 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394185 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394189 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 394193 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394197 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394202 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394204 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 394204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 394207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394209 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394213 */   GIR_RootConstrainSelectedInstOperands,
     /* 394214 */   // GIR_Coverage, 5820,
     /* 394214 */   GIR_EraseRootFromParent_Done,
     /* 394215 */ // Label 7882: @394215
     /* 394215 */ GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(394257), // Rule ID 5808 //
     /* 394220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394227 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394231 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 394235 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394239 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394244 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394246 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 394246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 394249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394251 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394255 */   GIR_RootConstrainSelectedInstOperands,
     /* 394256 */   // GIR_Coverage, 5808,
     /* 394256 */   GIR_EraseRootFromParent_Done,
     /* 394257 */ // Label 7883: @394257
     /* 394257 */ GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(394299), // Rule ID 5810 //
     /* 394262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394269 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394273 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 394277 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394281 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394286 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394288 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 394288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 394291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394293 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394297 */   GIR_RootConstrainSelectedInstOperands,
     /* 394298 */   // GIR_Coverage, 5810,
     /* 394298 */   GIR_EraseRootFromParent_Done,
     /* 394299 */ // Label 7884: @394299
     /* 394299 */ GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(394360), // Rule ID 5862 //
     /* 394304 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394315 */   // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 394315 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394318 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 394322 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394327 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394331 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394335 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394342 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 394349 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394354 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394359 */   // GIR_Coverage, 5862,
     /* 394359 */   GIR_EraseRootFromParent_Done,
     /* 394360 */ // Label 7885: @394360
     /* 394360 */ GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(394383), // Rule ID 5863 //
     /* 394365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394372 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394376 */   // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 394376 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 394381 */   GIR_RootConstrainSelectedInstOperands,
     /* 394382 */   // GIR_Coverage, 5863,
     /* 394382 */   GIR_Done,
     /* 394383 */ // Label 7886: @394383
     /* 394383 */ GIM_Reject,
     /* 394384 */ // Label 7863: @394384
     /* 394384 */ GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(394569),
     /* 394389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394396 */   GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(394439), // Rule ID 5813 //
     /* 394401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 394409 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 394412 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 394417 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 394421 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394428 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 725:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 394428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 394431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 394437 */     GIR_RootConstrainSelectedInstOperands,
     /* 394438 */     // GIR_Coverage, 5813,
     /* 394438 */     GIR_EraseRootFromParent_Done,
     /* 394439 */   // Label 7888: @394439
     /* 394439 */   GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(394482), // Rule ID 5823 //
     /* 394444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 394452 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 394455 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 394460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 394464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394471 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 660:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 394471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 394474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 394480 */     GIR_RootConstrainSelectedInstOperands,
     /* 394481 */     // GIR_Coverage, 5823,
     /* 394481 */     GIR_EraseRootFromParent_Done,
     /* 394482 */   // Label 7889: @394482
     /* 394482 */   GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(394517), // Rule ID 5822 //
     /* 394487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 394495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394506 */     // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 394506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 394509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394515 */     GIR_RootConstrainSelectedInstOperands,
     /* 394516 */     // GIR_Coverage, 5822,
     /* 394516 */     GIR_EraseRootFromParent_Done,
     /* 394517 */   // Label 7890: @394517
     /* 394517 */   GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(394552), // Rule ID 5812 //
     /* 394522 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 394526 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 394530 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394534 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394539 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 394541 */     // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 394541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 394544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 394546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 394550 */     GIR_RootConstrainSelectedInstOperands,
     /* 394551 */     // GIR_Coverage, 5812,
     /* 394551 */     GIR_EraseRootFromParent_Done,
     /* 394552 */   // Label 7891: @394552
     /* 394552 */   GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(394568), // Rule ID 5864 //
     /* 394557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394561 */     // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
     /* 394561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 394566 */     GIR_RootConstrainSelectedInstOperands,
     /* 394567 */     // GIR_Coverage, 5864,
     /* 394567 */     GIR_Done,
     /* 394568 */   // Label 7892: @394568
     /* 394568 */   GIM_Reject,
     /* 394569 */ // Label 7887: @394569
     /* 394569 */ GIM_Reject,
     /* 394570 */ // Label 7864: @394570
     /* 394570 */ GIM_Reject,
     /* 394571 */ // Label 116: @394571
     /* 394571 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7896*/ GIMT_Encode4(394773),
     /* 394582 */ /*GILLT_s8*//*Label 7893*/ GIMT_Encode4(394594),
     /* 394586 */ /*GILLT_s16*//*Label 7894*/ GIMT_Encode4(394641),
     /* 394590 */ /*GILLT_s32*//*Label 7895*/ GIMT_Encode4(394688),
     /* 394594 */ // Label 7893: @394594
     /* 394594 */ GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(394617), // Rule ID 5955 //
     /* 394599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 394606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394610 */   // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 394610 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 394615 */   GIR_RootConstrainSelectedInstOperands,
     /* 394616 */   // GIR_Coverage, 5955,
     /* 394616 */   GIR_Done,
     /* 394617 */ // Label 7897: @394617
     /* 394617 */ GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(394640), // Rule ID 5956 //
     /* 394622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 394629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394633 */   // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 394633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 394638 */   GIR_RootConstrainSelectedInstOperands,
     /* 394639 */   // GIR_Coverage, 5956,
     /* 394639 */   GIR_Done,
     /* 394640 */ // Label 7898: @394640
     /* 394640 */ GIM_Reject,
     /* 394641 */ // Label 7894: @394641
     /* 394641 */ GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(394664), // Rule ID 5957 //
     /* 394646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394657 */   // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 394657 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 394662 */   GIR_RootConstrainSelectedInstOperands,
     /* 394663 */   // GIR_Coverage, 5957,
     /* 394663 */   GIR_Done,
     /* 394664 */ // Label 7899: @394664
     /* 394664 */ GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(394687), // Rule ID 5958 //
     /* 394669 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394676 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394680 */   // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 394680 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 394685 */   GIR_RootConstrainSelectedInstOperands,
     /* 394686 */   // GIR_Coverage, 5958,
     /* 394686 */   GIR_Done,
     /* 394687 */ // Label 7900: @394687
     /* 394687 */ GIM_Reject,
     /* 394688 */ // Label 7895: @394688
     /* 394688 */ GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(394711), // Rule ID 5959 //
     /* 394693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394704 */   // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 394704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 394709 */   GIR_RootConstrainSelectedInstOperands,
     /* 394710 */   // GIR_Coverage, 5959,
     /* 394710 */   GIR_Done,
     /* 394711 */ // Label 7901: @394711
     /* 394711 */ GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(394772), // Rule ID 5960 //
     /* 394716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394723 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394727 */   // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 394727 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394730 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 394734 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394739 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394743 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394754 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 394761 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394766 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394771 */   // GIR_Coverage, 5960,
     /* 394771 */   GIR_EraseRootFromParent_Done,
     /* 394772 */ // Label 7902: @394772
     /* 394772 */ GIM_Reject,
     /* 394773 */ // Label 7896: @394773
     /* 394773 */ GIM_Reject,
     /* 394774 */ // Label 117: @394774
     /* 394774 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7906*/ GIMT_Encode4(394976),
     /* 394785 */ /*GILLT_s8*//*Label 7903*/ GIMT_Encode4(394797),
     /* 394789 */ /*GILLT_s16*//*Label 7904*/ GIMT_Encode4(394844),
     /* 394793 */ /*GILLT_s32*//*Label 7905*/ GIMT_Encode4(394891),
     /* 394797 */ // Label 7903: @394797
     /* 394797 */ GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(394820), // Rule ID 5949 //
     /* 394802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 394805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 394809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394813 */   // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 394813 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 394818 */   GIR_RootConstrainSelectedInstOperands,
     /* 394819 */   // GIR_Coverage, 5949,
     /* 394819 */   GIR_Done,
     /* 394820 */ // Label 7907: @394820
     /* 394820 */ GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(394843), // Rule ID 5950 //
     /* 394825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 394828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 394832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394836 */   // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 394836 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 394841 */   GIR_RootConstrainSelectedInstOperands,
     /* 394842 */   // GIR_Coverage, 5950,
     /* 394842 */   GIR_Done,
     /* 394843 */ // Label 7908: @394843
     /* 394843 */ GIM_Reject,
     /* 394844 */ // Label 7904: @394844
     /* 394844 */ GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(394867), // Rule ID 5951 //
     /* 394849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394860 */   // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 394860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 394865 */   GIR_RootConstrainSelectedInstOperands,
     /* 394866 */   // GIR_Coverage, 5951,
     /* 394866 */   GIR_Done,
     /* 394867 */ // Label 7909: @394867
     /* 394867 */ GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(394890), // Rule ID 5952 //
     /* 394872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394883 */   // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 394883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 394888 */   GIR_RootConstrainSelectedInstOperands,
     /* 394889 */   // GIR_Coverage, 5952,
     /* 394889 */   GIR_Done,
     /* 394890 */ // Label 7910: @394890
     /* 394890 */ GIM_Reject,
     /* 394891 */ // Label 7905: @394891
     /* 394891 */ GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(394914), // Rule ID 5953 //
     /* 394896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394907 */   // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 394907 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 394912 */   GIR_RootConstrainSelectedInstOperands,
     /* 394913 */   // GIR_Coverage, 5953,
     /* 394913 */   GIR_Done,
     /* 394914 */ // Label 7911: @394914
     /* 394914 */ GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(394975), // Rule ID 5954 //
     /* 394919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394930 */   // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 394930 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 394933 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 394937 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394942 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394946 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394950 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 394952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394957 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 394964 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394969 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394974 */   // GIR_Coverage, 5954,
     /* 394974 */   GIR_EraseRootFromParent_Done,
     /* 394975 */ // Label 7912: @394975
     /* 394975 */ GIM_Reject,
     /* 394976 */ // Label 7906: @394976
     /* 394976 */ GIM_Reject,
     /* 394977 */ // Label 118: @394977
     /* 394977 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7916*/ GIMT_Encode4(395179),
     /* 394988 */ /*GILLT_s8*//*Label 7913*/ GIMT_Encode4(395000),
     /* 394992 */ /*GILLT_s16*//*Label 7914*/ GIMT_Encode4(395047),
     /* 394996 */ /*GILLT_s32*//*Label 7915*/ GIMT_Encode4(395094),
     /* 395000 */ // Label 7913: @395000
     /* 395000 */ GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(395023), // Rule ID 5943 //
     /* 395005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 395008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 395012 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395016 */   // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 395016 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 395021 */   GIR_RootConstrainSelectedInstOperands,
     /* 395022 */   // GIR_Coverage, 5943,
     /* 395022 */   GIR_Done,
     /* 395023 */ // Label 7917: @395023
     /* 395023 */ GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(395046), // Rule ID 5944 //
     /* 395028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 395031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 395035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395039 */   // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 395039 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 395044 */   GIR_RootConstrainSelectedInstOperands,
     /* 395045 */   // GIR_Coverage, 5944,
     /* 395045 */   GIR_Done,
     /* 395046 */ // Label 7918: @395046
     /* 395046 */ GIM_Reject,
     /* 395047 */ // Label 7914: @395047
     /* 395047 */ GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(395070), // Rule ID 5945 //
     /* 395052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395063 */   // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 395063 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 395068 */   GIR_RootConstrainSelectedInstOperands,
     /* 395069 */   // GIR_Coverage, 5945,
     /* 395069 */   GIR_Done,
     /* 395070 */ // Label 7919: @395070
     /* 395070 */ GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(395093), // Rule ID 5946 //
     /* 395075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395086 */   // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 395086 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 395091 */   GIR_RootConstrainSelectedInstOperands,
     /* 395092 */   // GIR_Coverage, 5946,
     /* 395092 */   GIR_Done,
     /* 395093 */ // Label 7920: @395093
     /* 395093 */ GIM_Reject,
     /* 395094 */ // Label 7915: @395094
     /* 395094 */ GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(395117), // Rule ID 5947 //
     /* 395099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395110 */   // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 395110 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 395115 */   GIR_RootConstrainSelectedInstOperands,
     /* 395116 */   // GIR_Coverage, 5947,
     /* 395116 */   GIR_Done,
     /* 395117 */ // Label 7921: @395117
     /* 395117 */ GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(395178), // Rule ID 5948 //
     /* 395122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395133 */   // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 395133 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395136 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 395140 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395145 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395149 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395153 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 395155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395158 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395160 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 395167 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395172 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395177 */   // GIR_Coverage, 5948,
     /* 395177 */   GIR_EraseRootFromParent_Done,
     /* 395178 */ // Label 7922: @395178
     /* 395178 */ GIM_Reject,
     /* 395179 */ // Label 7916: @395179
     /* 395179 */ GIM_Reject,
     /* 395180 */ // Label 119: @395180
     /* 395180 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 7926*/ GIMT_Encode4(395382),
     /* 395191 */ /*GILLT_s8*//*Label 7923*/ GIMT_Encode4(395203),
     /* 395195 */ /*GILLT_s16*//*Label 7924*/ GIMT_Encode4(395250),
     /* 395199 */ /*GILLT_s32*//*Label 7925*/ GIMT_Encode4(395297),
     /* 395203 */ // Label 7923: @395203
     /* 395203 */ GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(395226), // Rule ID 5937 //
     /* 395208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 395211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 395215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395219 */   // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 395219 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 395224 */   GIR_RootConstrainSelectedInstOperands,
     /* 395225 */   // GIR_Coverage, 5937,
     /* 395225 */   GIR_Done,
     /* 395226 */ // Label 7927: @395226
     /* 395226 */ GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(395249), // Rule ID 5938 //
     /* 395231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 395234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 395238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395242 */   // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 395242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 395247 */   GIR_RootConstrainSelectedInstOperands,
     /* 395248 */   // GIR_Coverage, 5938,
     /* 395248 */   GIR_Done,
     /* 395249 */ // Label 7928: @395249
     /* 395249 */ GIM_Reject,
     /* 395250 */ // Label 7924: @395250
     /* 395250 */ GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(395273), // Rule ID 5939 //
     /* 395255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395266 */   // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 395266 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 395271 */   GIR_RootConstrainSelectedInstOperands,
     /* 395272 */   // GIR_Coverage, 5939,
     /* 395272 */   GIR_Done,
     /* 395273 */ // Label 7929: @395273
     /* 395273 */ GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(395296), // Rule ID 5940 //
     /* 395278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395289 */   // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 395289 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 395294 */   GIR_RootConstrainSelectedInstOperands,
     /* 395295 */   // GIR_Coverage, 5940,
     /* 395295 */   GIR_Done,
     /* 395296 */ // Label 7930: @395296
     /* 395296 */ GIM_Reject,
     /* 395297 */ // Label 7925: @395297
     /* 395297 */ GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(395320), // Rule ID 5941 //
     /* 395302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395309 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395313 */   // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 395313 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 395318 */   GIR_RootConstrainSelectedInstOperands,
     /* 395319 */   // GIR_Coverage, 5941,
     /* 395319 */   GIR_Done,
     /* 395320 */ // Label 7931: @395320
     /* 395320 */ GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(395381), // Rule ID 5942 //
     /* 395325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395336 */   // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 395336 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395339 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 395343 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395348 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395352 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395356 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 395358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395363 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 395370 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395375 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395380 */   // GIR_Coverage, 5942,
     /* 395380 */   GIR_EraseRootFromParent_Done,
     /* 395381 */ // Label 7932: @395381
     /* 395381 */ GIM_Reject,
     /* 395382 */ // Label 7926: @395382
     /* 395382 */ GIM_Reject,
     /* 395383 */ // Label 120: @395383
     /* 395383 */ GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(395522),
     /* 395388 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 395391 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 395395 */   GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(395429), // Rule ID 257 //
     /* 395400 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 395407 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 395407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
     /* 395410 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 395412 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 395417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 395422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 395427 */     GIR_RootConstrainSelectedInstOperands,
     /* 395428 */     // GIR_Coverage, 257,
     /* 395428 */     GIR_EraseRootFromParent_Done,
     /* 395429 */   // Label 7934: @395429
     /* 395429 */   GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(395463), // Rule ID 258 //
     /* 395434 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 395441 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 395441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
     /* 395444 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 395446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 395451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 395456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 395461 */     GIR_RootConstrainSelectedInstOperands,
     /* 395462 */     // GIR_Coverage, 258,
     /* 395462 */     GIR_EraseRootFromParent_Done,
     /* 395463 */   // Label 7935: @395463
     /* 395463 */   GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(395492), // Rule ID 273 //
     /* 395468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 395475 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 395475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
     /* 395478 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 395480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 395485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 395490 */     GIR_RootConstrainSelectedInstOperands,
     /* 395491 */     // GIR_Coverage, 273,
     /* 395491 */     GIR_EraseRootFromParent_Done,
     /* 395492 */   // Label 7936: @395492
     /* 395492 */   GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(395521), // Rule ID 294 //
     /* 395497 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 395504 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 395504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
     /* 395507 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 395509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 395514 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 395519 */     GIR_RootConstrainSelectedInstOperands,
     /* 395520 */     // GIR_Coverage, 294,
     /* 395520 */     GIR_EraseRootFromParent_Done,
     /* 395521 */   // Label 7937: @395521
     /* 395521 */   GIM_Reject,
     /* 395522 */ // Label 7933: @395522
     /* 395522 */ GIM_Reject,
     /* 395523 */ // Label 121: @395523
     /* 395523 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7950*/ GIMT_Encode4(396062),
     /* 395534 */ /*GILLT_s64*//*Label 7938*/ GIMT_Encode4(395618), GIMT_Encode4(0),
     /* 395542 */ /*GILLT_v2s32*//*Label 7939*/ GIMT_Encode4(395656),
     /* 395546 */ /*GILLT_v2s64*//*Label 7940*/ GIMT_Encode4(395694),
     /* 395550 */ /*GILLT_v4s16*//*Label 7941*/ GIMT_Encode4(395732),
     /* 395554 */ /*GILLT_v4s32*//*Label 7942*/ GIMT_Encode4(395770),
     /* 395558 */ /*GILLT_v8s8*//*Label 7943*/ GIMT_Encode4(395808),
     /* 395562 */ /*GILLT_v8s16*//*Label 7944*/ GIMT_Encode4(395846),
     /* 395566 */ /*GILLT_v16s8*//*Label 7945*/ GIMT_Encode4(395884), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 395586 */ /*GILLT_nxv2s64*//*Label 7946*/ GIMT_Encode4(395922), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 395598 */ /*GILLT_nxv4s32*//*Label 7947*/ GIMT_Encode4(395957), GIMT_Encode4(0),
     /* 395606 */ /*GILLT_nxv8s16*//*Label 7948*/ GIMT_Encode4(395992), GIMT_Encode4(0),
     /* 395614 */ /*GILLT_nxv16s8*//*Label 7949*/ GIMT_Encode4(396027),
     /* 395618 */ // Label 7938: @395618
     /* 395618 */ GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(395655), // Rule ID 5052 //
     /* 395623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395626 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 395629 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 395632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395640 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395644 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395648 */   // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
     /* 395648 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 395653 */   GIR_RootConstrainSelectedInstOperands,
     /* 395654 */   // GIR_Coverage, 5052,
     /* 395654 */   GIR_Done,
     /* 395655 */ // Label 7951: @395655
     /* 395655 */ GIM_Reject,
     /* 395656 */ // Label 7939: @395656
     /* 395656 */ GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(395693), // Rule ID 5051 //
     /* 395661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 395667 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 395670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395678 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395682 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395686 */   // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 395686 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 395691 */   GIR_RootConstrainSelectedInstOperands,
     /* 395692 */   // GIR_Coverage, 5051,
     /* 395692 */   GIR_Done,
     /* 395693 */ // Label 7952: @395693
     /* 395693 */ GIM_Reject,
     /* 395694 */ // Label 7940: @395694
     /* 395694 */ GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(395731), // Rule ID 5056 //
     /* 395699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 395705 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 395708 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395712 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395716 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395720 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395724 */   // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 395724 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 395729 */   GIR_RootConstrainSelectedInstOperands,
     /* 395730 */   // GIR_Coverage, 5056,
     /* 395730 */   GIR_Done,
     /* 395731 */ // Label 7953: @395731
     /* 395731 */ GIM_Reject,
     /* 395732 */ // Label 7941: @395732
     /* 395732 */ GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(395769), // Rule ID 5050 //
     /* 395737 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395740 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 395743 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 395746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395754 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395758 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395762 */   // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 395762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 395767 */   GIR_RootConstrainSelectedInstOperands,
     /* 395768 */   // GIR_Coverage, 5050,
     /* 395768 */   GIR_Done,
     /* 395769 */ // Label 7954: @395769
     /* 395769 */ GIM_Reject,
     /* 395770 */ // Label 7942: @395770
     /* 395770 */ GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(395807), // Rule ID 5055 //
     /* 395775 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395778 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 395781 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 395784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395792 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395796 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395800 */   // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 395800 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 395805 */   GIR_RootConstrainSelectedInstOperands,
     /* 395806 */   // GIR_Coverage, 5055,
     /* 395806 */   GIR_Done,
     /* 395807 */ // Label 7955: @395807
     /* 395807 */ GIM_Reject,
     /* 395808 */ // Label 7943: @395808
     /* 395808 */ GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(395845), // Rule ID 5049 //
     /* 395813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 395816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 395819 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 395822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395830 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395834 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395838 */   // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 395838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 395843 */   GIR_RootConstrainSelectedInstOperands,
     /* 395844 */   // GIR_Coverage, 5049,
     /* 395844 */   GIR_Done,
     /* 395845 */ // Label 7956: @395845
     /* 395845 */ GIM_Reject,
     /* 395846 */ // Label 7944: @395846
     /* 395846 */ GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(395883), // Rule ID 5054 //
     /* 395851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 395857 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 395860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395868 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395872 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395876 */   // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 395876 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 395881 */   GIR_RootConstrainSelectedInstOperands,
     /* 395882 */   // GIR_Coverage, 5054,
     /* 395882 */   GIR_Done,
     /* 395883 */ // Label 7957: @395883
     /* 395883 */ GIM_Reject,
     /* 395884 */ // Label 7945: @395884
     /* 395884 */ GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(395921), // Rule ID 5053 //
     /* 395889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 395892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 395895 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 395898 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395902 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395906 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395910 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395914 */   // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 395914 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 395919 */   GIR_RootConstrainSelectedInstOperands,
     /* 395920 */   // GIR_Coverage, 5053,
     /* 395920 */   GIR_Done,
     /* 395921 */ // Label 7958: @395921
     /* 395921 */ GIM_Reject,
     /* 395922 */ // Label 7946: @395922
     /* 395922 */ GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(395956), // Rule ID 11811 //
     /* 395927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 395930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 395933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 395936 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 395939 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395943 */   // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 395943 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 395946 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 395948 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 395950 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 395952 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 395954 */   GIR_RootConstrainSelectedInstOperands,
     /* 395955 */   // GIR_Coverage, 11811,
     /* 395955 */   GIR_EraseRootFromParent_Done,
     /* 395956 */ // Label 7959: @395956
     /* 395956 */ GIM_Reject,
     /* 395957 */ // Label 7947: @395957
     /* 395957 */ GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(395991), // Rule ID 11809 //
     /* 395962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 395965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 395968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 395971 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 395974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 395978 */   // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 395978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 395981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 395983 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 395985 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 395987 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 395989 */   GIR_RootConstrainSelectedInstOperands,
     /* 395990 */   // GIR_Coverage, 11809,
     /* 395990 */   GIR_EraseRootFromParent_Done,
     /* 395991 */ // Label 7960: @395991
     /* 395991 */ GIM_Reject,
     /* 395992 */ // Label 7948: @395992
     /* 395992 */ GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(396026), // Rule ID 11807 //
     /* 395997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 396000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 396003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 396006 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 396009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 396013 */   // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 396013 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 396016 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 396018 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 396020 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 396022 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 396024 */   GIR_RootConstrainSelectedInstOperands,
     /* 396025 */   // GIR_Coverage, 11807,
     /* 396025 */   GIR_EraseRootFromParent_Done,
     /* 396026 */ // Label 7961: @396026
     /* 396026 */ GIM_Reject,
     /* 396027 */ // Label 7949: @396027
     /* 396027 */ GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(396061), // Rule ID 11805 //
     /* 396032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 396035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 396038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 396041 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 396044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 396048 */   // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 396048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 396051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 396053 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 396055 */   GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 396057 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 396059 */   GIR_RootConstrainSelectedInstOperands,
     /* 396060 */   // GIR_Coverage, 11805,
     /* 396060 */   GIR_EraseRootFromParent_Done,
     /* 396061 */ // Label 7962: @396061
     /* 396061 */ GIM_Reject,
     /* 396062 */ // Label 7950: @396062
     /* 396062 */ GIM_Reject,
     /* 396063 */ // Label 122: @396063
     /* 396063 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 7971*/ GIMT_Encode4(397885),
     /* 396074 */ /*GILLT_s64*//*Label 7963*/ GIMT_Encode4(396110), GIMT_Encode4(0),
     /* 396082 */ /*GILLT_v2s32*//*Label 7964*/ GIMT_Encode4(396305),
     /* 396086 */ /*GILLT_v2s64*//*Label 7965*/ GIMT_Encode4(396552),
     /* 396090 */ /*GILLT_v4s16*//*Label 7966*/ GIMT_Encode4(396799),
     /* 396094 */ /*GILLT_v4s32*//*Label 7967*/ GIMT_Encode4(397075),
     /* 396098 */ /*GILLT_v8s8*//*Label 7968*/ GIMT_Encode4(397322),
     /* 396102 */ /*GILLT_v8s16*//*Label 7969*/ GIMT_Encode4(397467),
     /* 396106 */ /*GILLT_v16s8*//*Label 7970*/ GIMT_Encode4(397743),
     /* 396110 */ // Label 7963: @396110
     /* 396110 */ GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(396304),
     /* 396115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 396118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396122 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(396169), // Rule ID 6390 //
     /* 396127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396135 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396138 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396142 */     // MIs[1] Rn
     /* 396142 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396153 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 396156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396167 */     GIR_RootConstrainSelectedInstOperands,
     /* 396168 */     // GIR_Coverage, 6390,
     /* 396168 */     GIR_EraseRootFromParent_Done,
     /* 396169 */   // Label 7973: @396169
     /* 396169 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(396216), // Rule ID 6401 //
     /* 396174 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396178 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396182 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396185 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396189 */     // MIs[1] Rn
     /* 396189 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396193 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396200 */     // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 396203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396209 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396214 */     GIR_RootConstrainSelectedInstOperands,
     /* 396215 */     // GIR_Coverage, 6401,
     /* 396215 */     GIR_EraseRootFromParent_Done,
     /* 396216 */   // Label 7974: @396216
     /* 396216 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(396263), // Rule ID 13134 //
     /* 396221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396225 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396229 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396232 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396236 */     // MIs[1] Rn
     /* 396236 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396247 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 396250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396261 */     GIR_RootConstrainSelectedInstOperands,
     /* 396262 */     // GIR_Coverage, 13134,
     /* 396262 */     GIR_EraseRootFromParent_Done,
     /* 396263 */   // Label 7975: @396263
     /* 396263 */   GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(396283), // Rule ID 5615 //
     /* 396268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 396272 */     // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
     /* 396272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396282 */     // GIR_Coverage, 5615,
     /* 396282 */     GIR_Done,
     /* 396283 */   // Label 7976: @396283
     /* 396283 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(396303), // Rule ID 5616 //
     /* 396288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396292 */     // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
     /* 396292 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396297 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396302 */     // GIR_Coverage, 5616,
     /* 396302 */     GIR_Done,
     /* 396303 */   // Label 7977: @396303
     /* 396303 */   GIM_Reject,
     /* 396304 */ // Label 7972: @396304
     /* 396304 */ GIM_Reject,
     /* 396305 */ // Label 7964: @396305
     /* 396305 */ GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(396551),
     /* 396310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396317 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(396364), // Rule ID 6387 //
     /* 396322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396330 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396333 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396337 */     // MIs[1] Rn
     /* 396337 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396348 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 396351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396357 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396362 */     GIR_RootConstrainSelectedInstOperands,
     /* 396363 */     // GIR_Coverage, 6387,
     /* 396363 */     GIR_EraseRootFromParent_Done,
     /* 396364 */   // Label 7979: @396364
     /* 396364 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(396411), // Rule ID 6398 //
     /* 396369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396377 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396380 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396384 */     // MIs[1] Rn
     /* 396384 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396395 */     // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 396398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396409 */     GIR_RootConstrainSelectedInstOperands,
     /* 396410 */     // GIR_Coverage, 6398,
     /* 396410 */     GIR_EraseRootFromParent_Done,
     /* 396411 */   // Label 7980: @396411
     /* 396411 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(396458), // Rule ID 13131 //
     /* 396416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396424 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396427 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396431 */     // MIs[1] Rn
     /* 396431 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396442 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 396445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396451 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396456 */     GIR_RootConstrainSelectedInstOperands,
     /* 396457 */     // GIR_Coverage, 13131,
     /* 396457 */     GIR_EraseRootFromParent_Done,
     /* 396458 */   // Label 7981: @396458
     /* 396458 */   GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(396477), // Rule ID 1916 //
     /* 396463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 396470 */     // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
     /* 396470 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
     /* 396475 */     GIR_RootConstrainSelectedInstOperands,
     /* 396476 */     // GIR_Coverage, 1916,
     /* 396476 */     GIR_Done,
     /* 396477 */   // Label 7982: @396477
     /* 396477 */   GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(396550), // Rule ID 5617 //
     /* 396482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396486 */     // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 396486 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 396489 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 396493 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396498 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 396503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 396507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396512 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 396515 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396519 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 396522 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396527 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396532 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 396540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396542 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396548 */     GIR_RootConstrainSelectedInstOperands,
     /* 396549 */     // GIR_Coverage, 5617,
     /* 396549 */     GIR_EraseRootFromParent_Done,
     /* 396550 */   // Label 7983: @396550
     /* 396550 */   GIM_Reject,
     /* 396551 */ // Label 7978: @396551
     /* 396551 */ GIM_Reject,
     /* 396552 */ // Label 7965: @396552
     /* 396552 */ GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(396798),
     /* 396557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 396560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396564 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(396611), // Rule ID 6389 //
     /* 396569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396577 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396580 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396584 */     // MIs[1] Rn
     /* 396584 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396595 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 396598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396609 */     GIR_RootConstrainSelectedInstOperands,
     /* 396610 */     // GIR_Coverage, 6389,
     /* 396610 */     GIR_EraseRootFromParent_Done,
     /* 396611 */   // Label 7985: @396611
     /* 396611 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(396658), // Rule ID 6400 //
     /* 396616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396624 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396627 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396631 */     // MIs[1] Rn
     /* 396631 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396642 */     // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 396645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396651 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396656 */     GIR_RootConstrainSelectedInstOperands,
     /* 396657 */     // GIR_Coverage, 6400,
     /* 396657 */     GIR_EraseRootFromParent_Done,
     /* 396658 */   // Label 7986: @396658
     /* 396658 */   GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(396705), // Rule ID 13133 //
     /* 396663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396671 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396674 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396678 */     // MIs[1] Rn
     /* 396678 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396689 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 396692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396698 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396703 */     GIR_RootConstrainSelectedInstOperands,
     /* 396704 */     // GIR_Coverage, 13133,
     /* 396704 */     GIR_EraseRootFromParent_Done,
     /* 396705 */   // Label 7987: @396705
     /* 396705 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(396724), // Rule ID 1918 //
     /* 396710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 396717 */     // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
     /* 396717 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
     /* 396722 */     GIR_RootConstrainSelectedInstOperands,
     /* 396723 */     // GIR_Coverage, 1918,
     /* 396723 */     GIR_Done,
     /* 396724 */   // Label 7988: @396724
     /* 396724 */   GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(396797), // Rule ID 5619 //
     /* 396729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396733 */     // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 396733 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 396736 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 396740 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 396750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 396754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396759 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 396762 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396766 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 396769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396774 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396779 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 396787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396789 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 396795 */     GIR_RootConstrainSelectedInstOperands,
     /* 396796 */     // GIR_Coverage, 5619,
     /* 396796 */     GIR_EraseRootFromParent_Done,
     /* 396797 */   // Label 7989: @396797
     /* 396797 */   GIM_Reject,
     /* 396798 */ // Label 7984: @396798
     /* 396798 */ GIM_Reject,
     /* 396799 */ // Label 7966: @396799
     /* 396799 */ GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(396860), // Rule ID 6385 //
     /* 396804 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396807 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396811 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396815 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396819 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396822 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396826 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 396833 */   // MIs[1] Rn
     /* 396833 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396837 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396842 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396844 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 396847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396849 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396853 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396858 */   GIR_RootConstrainSelectedInstOperands,
     /* 396859 */   // GIR_Coverage, 6385,
     /* 396859 */   GIR_EraseRootFromParent_Done,
     /* 396860 */ // Label 7990: @396860
     /* 396860 */ GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(396914), // Rule ID 6402 //
     /* 396865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396872 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396876 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396880 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396883 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396887 */   // MIs[1] Rn
     /* 396887 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396891 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396896 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396898 */   // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396898 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 396901 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396903 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396907 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396912 */   GIR_RootConstrainSelectedInstOperands,
     /* 396913 */   // GIR_Coverage, 6402,
     /* 396913 */   GIR_EraseRootFromParent_Done,
     /* 396914 */ // Label 7991: @396914
     /* 396914 */ GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(396968), // Rule ID 13129 //
     /* 396919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396926 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396930 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 396934 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 396937 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 396941 */   // MIs[1] Rn
     /* 396941 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 396945 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 396950 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 396952 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 396952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 396955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 396957 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396961 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 396966 */   GIR_RootConstrainSelectedInstOperands,
     /* 396967 */   // GIR_Coverage, 13129,
     /* 396967 */   GIR_EraseRootFromParent_Done,
     /* 396968 */ // Label 7992: @396968
     /* 396968 */ GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(396994), // Rule ID 1914 //
     /* 396973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 396987 */   // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
     /* 396987 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
     /* 396992 */   GIR_RootConstrainSelectedInstOperands,
     /* 396993 */   // GIR_Coverage, 1914,
     /* 396993 */   GIR_Done,
     /* 396994 */ // Label 7993: @396994
     /* 396994 */ GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(397074), // Rule ID 5620 //
     /* 396999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 397002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397010 */   // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 397010 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 397013 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 397017 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397022 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 397024 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 397027 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 397031 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397036 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 397039 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 397043 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 397046 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397051 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397056 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397061 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 397064 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397066 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397069 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397072 */   GIR_RootConstrainSelectedInstOperands,
     /* 397073 */   // GIR_Coverage, 5620,
     /* 397073 */   GIR_EraseRootFromParent_Done,
     /* 397074 */ // Label 7994: @397074
     /* 397074 */ GIM_Reject,
     /* 397075 */ // Label 7967: @397075
     /* 397075 */ GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(397321),
     /* 397080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397087 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(397134), // Rule ID 6388 //
     /* 397092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397100 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397103 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397107 */     // MIs[1] Rn
     /* 397107 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397111 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397118 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 397121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397127 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397132 */     GIR_RootConstrainSelectedInstOperands,
     /* 397133 */     // GIR_Coverage, 6388,
     /* 397133 */     GIR_EraseRootFromParent_Done,
     /* 397134 */   // Label 7996: @397134
     /* 397134 */   GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(397181), // Rule ID 6399 //
     /* 397139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397147 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397150 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397154 */     // MIs[1] Rn
     /* 397154 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397158 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397163 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397165 */     // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 397168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397170 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397174 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397179 */     GIR_RootConstrainSelectedInstOperands,
     /* 397180 */     // GIR_Coverage, 6399,
     /* 397180 */     GIR_EraseRootFromParent_Done,
     /* 397181 */   // Label 7997: @397181
     /* 397181 */   GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(397228), // Rule ID 13132 //
     /* 397186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397194 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397197 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397201 */     // MIs[1] Rn
     /* 397201 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397210 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397212 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 397215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397226 */     GIR_RootConstrainSelectedInstOperands,
     /* 397227 */     // GIR_Coverage, 13132,
     /* 397227 */     GIR_EraseRootFromParent_Done,
     /* 397228 */   // Label 7998: @397228
     /* 397228 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(397247), // Rule ID 1917 //
     /* 397233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 397240 */     // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
     /* 397240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
     /* 397245 */     GIR_RootConstrainSelectedInstOperands,
     /* 397246 */     // GIR_Coverage, 1917,
     /* 397246 */     GIR_Done,
     /* 397247 */   // Label 7999: @397247
     /* 397247 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(397320), // Rule ID 5618 //
     /* 397252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397256 */     // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 397256 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 397259 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 397263 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 397270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 397273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 397277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397282 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 397285 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 397289 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 397292 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 397310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397318 */     GIR_RootConstrainSelectedInstOperands,
     /* 397319 */     // GIR_Coverage, 5618,
     /* 397319 */     GIR_EraseRootFromParent_Done,
     /* 397320 */   // Label 8000: @397320
     /* 397320 */   GIM_Reject,
     /* 397321 */ // Label 7995: @397321
     /* 397321 */ GIM_Reject,
     /* 397322 */ // Label 7968: @397322
     /* 397322 */ GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(397379), // Rule ID 13127 //
     /* 397327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 397330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397334 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397338 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397342 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397345 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397349 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 397353 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397355 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 397362 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 397365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397367 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 397372 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397377 */   GIR_RootConstrainSelectedInstOperands,
     /* 397378 */   // GIR_Coverage, 13127,
     /* 397378 */   GIR_EraseRootFromParent_Done,
     /* 397379 */ // Label 8001: @397379
     /* 397379 */ GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(397440), // Rule ID 6383 //
     /* 397384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397391 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397395 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397399 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397402 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397406 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 397413 */   // MIs[1] Rn
     /* 397413 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397417 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397422 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397424 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397424 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 397427 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397429 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397433 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397438 */   GIR_RootConstrainSelectedInstOperands,
     /* 397439 */   // GIR_Coverage, 6383,
     /* 397439 */   GIR_EraseRootFromParent_Done,
     /* 397440 */ // Label 8002: @397440
     /* 397440 */ GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(397466), // Rule ID 1912 //
     /* 397445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 397459 */   // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
     /* 397459 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
     /* 397464 */   GIR_RootConstrainSelectedInstOperands,
     /* 397465 */   // GIR_Coverage, 1912,
     /* 397465 */   GIR_Done,
     /* 397466 */ // Label 8003: @397466
     /* 397466 */ GIM_Reject,
     /* 397467 */ // Label 7969: @397467
     /* 397467 */ GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(397528), // Rule ID 6386 //
     /* 397472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397479 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397483 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397487 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397490 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397494 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 397501 */   // MIs[1] Rn
     /* 397501 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397505 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397510 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397512 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 397515 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397517 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397521 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397526 */   GIR_RootConstrainSelectedInstOperands,
     /* 397527 */   // GIR_Coverage, 6386,
     /* 397527 */   GIR_EraseRootFromParent_Done,
     /* 397528 */ // Label 8004: @397528
     /* 397528 */ GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(397582), // Rule ID 6403 //
     /* 397533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 397536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397540 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397544 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397548 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397551 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397555 */   // MIs[1] Rn
     /* 397555 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397559 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397564 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397566 */   // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397566 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 397569 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397571 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397575 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397580 */   GIR_RootConstrainSelectedInstOperands,
     /* 397581 */   // GIR_Coverage, 6403,
     /* 397581 */   GIR_EraseRootFromParent_Done,
     /* 397582 */ // Label 8005: @397582
     /* 397582 */ GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(397636), // Rule ID 13130 //
     /* 397587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 397590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397594 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397598 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397602 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397605 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397609 */   // MIs[1] Rn
     /* 397609 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397613 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397618 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397620 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397620 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 397623 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397625 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397629 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397634 */   GIR_RootConstrainSelectedInstOperands,
     /* 397635 */   // GIR_Coverage, 13130,
     /* 397635 */   GIR_EraseRootFromParent_Done,
     /* 397636 */ // Label 8006: @397636
     /* 397636 */ GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(397662), // Rule ID 1915 //
     /* 397641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 397655 */   // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
     /* 397655 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
     /* 397660 */   GIR_RootConstrainSelectedInstOperands,
     /* 397661 */   // GIR_Coverage, 1915,
     /* 397661 */   GIR_Done,
     /* 397662 */ // Label 8007: @397662
     /* 397662 */ GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(397742), // Rule ID 5621 //
     /* 397667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 397670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397678 */   // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 397678 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 397681 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 397685 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397690 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 397692 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 397695 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 397699 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397704 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 397707 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 397711 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 397714 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397719 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397724 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 397732 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397734 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 397740 */   GIR_RootConstrainSelectedInstOperands,
     /* 397741 */   // GIR_Coverage, 5621,
     /* 397741 */   GIR_EraseRootFromParent_Done,
     /* 397742 */ // Label 8008: @397742
     /* 397742 */ GIM_Reject,
     /* 397743 */ // Label 7970: @397743
     /* 397743 */ GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(397804), // Rule ID 6384 //
     /* 397748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397755 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397759 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397763 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397766 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397770 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 397777 */   // MIs[1] Rn
     /* 397777 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397781 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397786 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397788 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 397791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397793 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397797 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397802 */   GIR_RootConstrainSelectedInstOperands,
     /* 397803 */   // GIR_Coverage, 6384,
     /* 397803 */   GIR_EraseRootFromParent_Done,
     /* 397804 */ // Label 8009: @397804
     /* 397804 */ GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(397858), // Rule ID 13128 //
     /* 397809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 397812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397816 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397820 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 397824 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 397827 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 397831 */   // MIs[1] Rn
     /* 397831 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 397835 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 397840 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397842 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 397842 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 397845 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 397847 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 397851 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 397856 */   GIR_RootConstrainSelectedInstOperands,
     /* 397857 */   // GIR_Coverage, 13128,
     /* 397857 */   GIR_EraseRootFromParent_Done,
     /* 397858 */ // Label 8010: @397858
     /* 397858 */ GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(397884), // Rule ID 1913 //
     /* 397863 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397866 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 397877 */   // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
     /* 397877 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
     /* 397882 */   GIR_RootConstrainSelectedInstOperands,
     /* 397883 */   // GIR_Coverage, 1913,
     /* 397883 */   GIR_Done,
     /* 397884 */ // Label 8011: @397884
     /* 397884 */ GIM_Reject,
     /* 397885 */ // Label 7971: @397885
     /* 397885 */ GIM_Reject,
     /* 397886 */ // Label 123: @397886
     /* 397886 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 8014*/ GIMT_Encode4(398140),
     /* 397897 */ /*GILLT_v4s16*//*Label 8012*/ GIMT_Encode4(397913), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 397909 */ /*GILLT_v8s16*//*Label 8013*/ GIMT_Encode4(397999),
     /* 397913 */ // Label 8012: @397913
     /* 397913 */ GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(397998),
     /* 397918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 397924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397932 */   GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(397966), // Rule ID 1922 //
     /* 397937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397952 */     // MIs[1] Operand 1
     /* 397952 */     // No operand predicates
     /* 397952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397954 */     // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 397954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 397957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397961 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 397964 */     GIR_RootConstrainSelectedInstOperands,
     /* 397965 */     // GIR_Coverage, 1922,
     /* 397965 */     GIR_EraseRootFromParent_Done,
     /* 397966 */   // Label 8016: @397966
     /* 397966 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(397997), // Rule ID 5622 //
     /* 397971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397979 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397983 */     // MIs[1] Operand 1
     /* 397983 */     // No operand predicates
     /* 397983 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397985 */     // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 397985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 397988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397990 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397992 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 397995 */     GIR_RootConstrainSelectedInstOperands,
     /* 397996 */     // GIR_Coverage, 5622,
     /* 397996 */     GIR_EraseRootFromParent_Done,
     /* 397997 */   // Label 8017: @397997
     /* 397997 */   GIM_Reject,
     /* 397998 */ // Label 8015: @397998
     /* 397998 */ GIM_Reject,
     /* 397999 */ // Label 8013: @397999
     /* 397999 */ GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(398139),
     /* 398004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 398007 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 398010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398014 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(398065), // Rule ID 6394 //
     /* 398019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 398027 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 398030 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 398034 */     // MIs[1] Rn
     /* 398034 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 398038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 398043 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 398047 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398049 */     // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 398049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 398052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 398054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 398063 */     GIR_RootConstrainSelectedInstOperands,
     /* 398064 */     // GIR_Coverage, 6394,
     /* 398064 */     GIR_EraseRootFromParent_Done,
     /* 398065 */   // Label 8019: @398065
     /* 398065 */   GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(398103), // Rule ID 1923 //
     /* 398070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398085 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398089 */     // MIs[1] Operand 1
     /* 398089 */     // No operand predicates
     /* 398089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398091 */     // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 398091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 398094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398096 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398098 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 398101 */     GIR_RootConstrainSelectedInstOperands,
     /* 398102 */     // GIR_Coverage, 1923,
     /* 398102 */     GIR_EraseRootFromParent_Done,
     /* 398103 */   // Label 8020: @398103
     /* 398103 */   GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(398138), // Rule ID 5623 //
     /* 398108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398120 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 398124 */     // MIs[1] Operand 1
     /* 398124 */     // No operand predicates
     /* 398124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398126 */     // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 398126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 398129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398136 */     GIR_RootConstrainSelectedInstOperands,
     /* 398137 */     // GIR_Coverage, 5623,
     /* 398137 */     GIR_EraseRootFromParent_Done,
     /* 398138 */   // Label 8021: @398138
     /* 398138 */   GIM_Reject,
     /* 398139 */ // Label 8018: @398139
     /* 398139 */ GIM_Reject,
     /* 398140 */ // Label 8014: @398140
     /* 398140 */ GIM_Reject,
     /* 398141 */ // Label 124: @398141
     /* 398141 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 8024*/ GIMT_Encode4(398395),
     /* 398152 */ /*GILLT_v2s32*//*Label 8022*/ GIMT_Encode4(398168), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 398164 */ /*GILLT_v4s32*//*Label 8023*/ GIMT_Encode4(398254),
     /* 398168 */ // Label 8022: @398168
     /* 398168 */ GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(398253),
     /* 398173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 398179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398187 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(398221), // Rule ID 1920 //
     /* 398192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398203 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398207 */     // MIs[1] Operand 1
     /* 398207 */     // No operand predicates
     /* 398207 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398209 */     // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 398209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 398212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398216 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 398219 */     GIR_RootConstrainSelectedInstOperands,
     /* 398220 */     // GIR_Coverage, 1920,
     /* 398220 */     GIR_EraseRootFromParent_Done,
     /* 398221 */   // Label 8026: @398221
     /* 398221 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(398252), // Rule ID 5624 //
     /* 398226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398234 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398238 */     // MIs[1] Operand 1
     /* 398238 */     // No operand predicates
     /* 398238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398240 */     // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 398240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 398243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398245 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398250 */     GIR_RootConstrainSelectedInstOperands,
     /* 398251 */     // GIR_Coverage, 5624,
     /* 398251 */     GIR_EraseRootFromParent_Done,
     /* 398252 */   // Label 8027: @398252
     /* 398252 */   GIM_Reject,
     /* 398253 */ // Label 8025: @398253
     /* 398253 */ GIM_Reject,
     /* 398254 */ // Label 8023: @398254
     /* 398254 */ GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(398394),
     /* 398259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 398265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398269 */   GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(398320), // Rule ID 6396 //
     /* 398274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 398282 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 398285 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 398289 */     // MIs[1] Rn
     /* 398289 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 398293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 398298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 398302 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398304 */     // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 398304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 398307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 398309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398313 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 398318 */     GIR_RootConstrainSelectedInstOperands,
     /* 398319 */     // GIR_Coverage, 6396,
     /* 398319 */     GIR_EraseRootFromParent_Done,
     /* 398320 */   // Label 8029: @398320
     /* 398320 */   GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(398358), // Rule ID 1921 //
     /* 398325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398328 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398340 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398344 */     // MIs[1] Operand 1
     /* 398344 */     // No operand predicates
     /* 398344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398346 */     // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 398346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 398349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398351 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398353 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 398356 */     GIR_RootConstrainSelectedInstOperands,
     /* 398357 */     // GIR_Coverage, 1921,
     /* 398357 */     GIR_EraseRootFromParent_Done,
     /* 398358 */   // Label 8030: @398358
     /* 398358 */   GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(398393), // Rule ID 5625 //
     /* 398363 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398375 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398379 */     // MIs[1] Operand 1
     /* 398379 */     // No operand predicates
     /* 398379 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398381 */     // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 398381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 398384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398391 */     GIR_RootConstrainSelectedInstOperands,
     /* 398392 */     // GIR_Coverage, 5625,
     /* 398392 */     GIR_EraseRootFromParent_Done,
     /* 398393 */   // Label 8031: @398393
     /* 398393 */   GIM_Reject,
     /* 398394 */ // Label 8028: @398394
     /* 398394 */ GIM_Reject,
     /* 398395 */ // Label 8024: @398395
     /* 398395 */ GIM_Reject,
     /* 398396 */ // Label 125: @398396
     /* 398396 */ GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(398541),
     /* 398401 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 398404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 398410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398414 */   GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(398465), // Rule ID 6397 //
     /* 398419 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398423 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 398427 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 398430 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 398434 */     // MIs[1] Rn
     /* 398434 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 398438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 398443 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 398447 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398449 */     // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 398449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 398452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 398454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398458 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 398463 */     GIR_RootConstrainSelectedInstOperands,
     /* 398464 */     // GIR_Coverage, 6397,
     /* 398464 */     GIR_EraseRootFromParent_Done,
     /* 398465 */   // Label 8033: @398465
     /* 398465 */   GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(398540),
     /* 398470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398474 */     GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(398508), // Rule ID 1919 //
     /* 398479 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398482 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398486 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398490 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398494 */       // MIs[1] Operand 1
     /* 398494 */       // No operand predicates
     /* 398494 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398496 */       // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 398496 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 398499 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398501 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398503 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 398506 */       GIR_RootConstrainSelectedInstOperands,
     /* 398507 */       // GIR_Coverage, 1919,
     /* 398507 */       GIR_EraseRootFromParent_Done,
     /* 398508 */     // Label 8035: @398508
     /* 398508 */     GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(398539), // Rule ID 5626 //
     /* 398513 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398517 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398521 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398525 */       // MIs[1] Operand 1
     /* 398525 */       // No operand predicates
     /* 398525 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398527 */       // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
     /* 398527 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 398530 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398532 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398534 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 398537 */       GIR_RootConstrainSelectedInstOperands,
     /* 398538 */       // GIR_Coverage, 5626,
     /* 398538 */       GIR_EraseRootFromParent_Done,
     /* 398539 */     // Label 8036: @398539
     /* 398539 */     GIM_Reject,
     /* 398540 */   // Label 8034: @398540
     /* 398540 */   GIM_Reject,
     /* 398541 */ // Label 8032: @398541
     /* 398541 */ GIM_Reject,
     /* 398542 */ // Label 126: @398542
     /* 398542 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8039*/ GIMT_Encode4(398720),
     /* 398553 */ /*GILLT_v8s8*//*Label 8037*/ GIMT_Encode4(398565), GIMT_Encode4(0),
     /* 398561 */ /*GILLT_v16s8*//*Label 8038*/ GIMT_Encode4(398614),
     /* 398565 */ // Label 8037: @398565
     /* 398565 */ GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(398613), // Rule ID 1924 //
     /* 398570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 398576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 398579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398587 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398591 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398595 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 398599 */   // MIs[1] Operand 1
     /* 398599 */   // No operand predicates
     /* 398599 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398601 */   // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 398601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 398604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398606 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398608 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 398611 */   GIR_RootConstrainSelectedInstOperands,
     /* 398612 */   // GIR_Coverage, 1924,
     /* 398612 */   GIR_EraseRootFromParent_Done,
     /* 398613 */ // Label 8040: @398613
     /* 398613 */ GIM_Reject,
     /* 398614 */ // Label 8038: @398614
     /* 398614 */ GIM_Try, /*On fail goto*//*Label 8041*/ GIMT_Encode4(398719),
     /* 398619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 398622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 398625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398629 */   GIM_Try, /*On fail goto*//*Label 8042*/ GIMT_Encode4(398680), // Rule ID 6392 //
     /* 398634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 398642 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 398645 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 398649 */     // MIs[1] Rn
     /* 398649 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 398653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 398658 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 398662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398664 */     // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 398664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 398667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 398669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 398678 */     GIR_RootConstrainSelectedInstOperands,
     /* 398679 */     // GIR_Coverage, 6392,
     /* 398679 */     GIR_EraseRootFromParent_Done,
     /* 398680 */   // Label 8042: @398680
     /* 398680 */   GIM_Try, /*On fail goto*//*Label 8043*/ GIMT_Encode4(398718), // Rule ID 1925 //
     /* 398685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398688 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398696 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398700 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 398704 */     // MIs[1] Operand 1
     /* 398704 */     // No operand predicates
     /* 398704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398706 */     // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 398706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 398709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398711 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 398716 */     GIR_RootConstrainSelectedInstOperands,
     /* 398717 */     // GIR_Coverage, 1925,
     /* 398717 */     GIR_EraseRootFromParent_Done,
     /* 398718 */   // Label 8043: @398718
     /* 398718 */   GIM_Reject,
     /* 398719 */ // Label 8041: @398719
     /* 398719 */ GIM_Reject,
     /* 398720 */ // Label 8039: @398720
     /* 398720 */ GIM_Reject,
     /* 398721 */ // Label 127: @398721
     /* 398721 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8053*/ GIMT_Encode4(400370),
     /* 398732 */ /*GILLT_s64*//*Label 8044*/ GIMT_Encode4(398816), GIMT_Encode4(0),
     /* 398740 */ /*GILLT_v2s32*//*Label 8045*/ GIMT_Encode4(399137),
     /* 398744 */ /*GILLT_v2s64*//*Label 8046*/ GIMT_Encode4(399458),
     /* 398748 */ /*GILLT_v4s16*//*Label 8047*/ GIMT_Encode4(399541),
     /* 398752 */ /*GILLT_v4s32*//*Label 8048*/ GIMT_Encode4(399862),
     /* 398756 */ /*GILLT_v8s8*//*Label 8049*/ GIMT_Encode4(399945),
     /* 398760 */ /*GILLT_v8s16*//*Label 8050*/ GIMT_Encode4(400154),
     /* 398764 */ /*GILLT_v16s8*//*Label 8051*/ GIMT_Encode4(400237), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 398812 */ /*GILLT_nxv16s8*//*Label 8052*/ GIMT_Encode4(400323),
     /* 398816 */ // Label 8044: @398816
     /* 398816 */ GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(399136),
     /* 398821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 398824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 398827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398831 */   GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(398946), // Rule ID 5443 //
     /* 398836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398848 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398853 */     // MIs[1] Operand 2
     /* 398853 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 398868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398872 */     // MIs[2] Rn
     /* 398872 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 398877 */     // MIs[2] Operand 2
     /* 398877 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 398888 */     // MIs[0] imm
     /* 398888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 398892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398896 */     // MIs[3] Operand 1
     /* 398896 */     // No operand predicates
     /* 398896 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398898 */     // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 398898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 398901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 398905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398914 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 398918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 398921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 398923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 398928 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 398935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398945 */     // GIR_Coverage, 5443,
     /* 398945 */     GIR_EraseRootFromParent_Done,
     /* 398946 */   // Label 8055: @398946
     /* 398946 */   GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(399061), // Rule ID 5448 //
     /* 398951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398968 */     // MIs[1] Operand 2
     /* 398968 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 398979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 398983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 398987 */     // MIs[2] Rn
     /* 398987 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 398992 */     // MIs[2] Operand 2
     /* 398992 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 399003 */     // MIs[0] imm
     /* 399003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 399007 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399011 */     // MIs[3] Operand 1
     /* 399011 */     // No operand predicates
     /* 399011 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399013 */     // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 399013 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 399016 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399020 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399025 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399033 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 399036 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399043 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 399050 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399055 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399060 */     // GIR_Coverage, 5448,
     /* 399060 */     GIR_EraseRootFromParent_Done,
     /* 399061 */   // Label 8056: @399061
     /* 399061 */   GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(399098), // Rule ID 5440 //
     /* 399066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399074 */     // MIs[0] imm
     /* 399074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399082 */     // MIs[1] Operand 1
     /* 399082 */     // No operand predicates
     /* 399082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399084 */     // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 399087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399096 */     GIR_RootConstrainSelectedInstOperands,
     /* 399097 */     // GIR_Coverage, 5440,
     /* 399097 */     GIR_EraseRootFromParent_Done,
     /* 399098 */   // Label 8057: @399098
     /* 399098 */   GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(399135), // Rule ID 5445 //
     /* 399103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399111 */     // MIs[0] imm
     /* 399111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399119 */     // MIs[1] Operand 1
     /* 399119 */     // No operand predicates
     /* 399119 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399121 */     // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 399124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399133 */     GIR_RootConstrainSelectedInstOperands,
     /* 399134 */     // GIR_Coverage, 5445,
     /* 399134 */     GIR_EraseRootFromParent_Done,
     /* 399135 */   // Label 8058: @399135
     /* 399135 */   GIM_Reject,
     /* 399136 */ // Label 8054: @399136
     /* 399136 */ GIM_Reject,
     /* 399137 */ // Label 8045: @399137
     /* 399137 */ GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(399457),
     /* 399142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 399148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399152 */   GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(399267), // Rule ID 5433 //
     /* 399157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399174 */     // MIs[1] Operand 2
     /* 399174 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 399189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399193 */     // MIs[2] Rn
     /* 399193 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 399198 */     // MIs[2] Operand 2
     /* 399198 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 399209 */     // MIs[0] imm
     /* 399209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 399213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399217 */     // MIs[3] Operand 1
     /* 399217 */     // No operand predicates
     /* 399217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399219 */     // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 399219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 399222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399231 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399235 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 399242 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399249 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 399256 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399261 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399266 */     // GIR_Coverage, 5433,
     /* 399266 */     GIR_EraseRootFromParent_Done,
     /* 399267 */   // Label 8060: @399267
     /* 399267 */   GIM_Try, /*On fail goto*//*Label 8061*/ GIMT_Encode4(399382), // Rule ID 5438 //
     /* 399272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399289 */     // MIs[1] Operand 2
     /* 399289 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 399304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399308 */     // MIs[2] Rn
     /* 399308 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 399313 */     // MIs[2] Operand 2
     /* 399313 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 399324 */     // MIs[0] imm
     /* 399324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 399328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399332 */     // MIs[3] Operand 1
     /* 399332 */     // No operand predicates
     /* 399332 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399334 */     // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 399334 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 399337 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399341 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399346 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399350 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 399357 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399364 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 399371 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399381 */     // GIR_Coverage, 5438,
     /* 399381 */     GIR_EraseRootFromParent_Done,
     /* 399382 */   // Label 8061: @399382
     /* 399382 */   GIM_Try, /*On fail goto*//*Label 8062*/ GIMT_Encode4(399419), // Rule ID 5430 //
     /* 399387 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399395 */     // MIs[0] imm
     /* 399395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399403 */     // MIs[1] Operand 1
     /* 399403 */     // No operand predicates
     /* 399403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399405 */     // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 399408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399417 */     GIR_RootConstrainSelectedInstOperands,
     /* 399418 */     // GIR_Coverage, 5430,
     /* 399418 */     GIR_EraseRootFromParent_Done,
     /* 399419 */   // Label 8062: @399419
     /* 399419 */   GIM_Try, /*On fail goto*//*Label 8063*/ GIMT_Encode4(399456), // Rule ID 5435 //
     /* 399424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399432 */     // MIs[0] imm
     /* 399432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399440 */     // MIs[1] Operand 1
     /* 399440 */     // No operand predicates
     /* 399440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399442 */     // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 399445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399454 */     GIR_RootConstrainSelectedInstOperands,
     /* 399455 */     // GIR_Coverage, 5435,
     /* 399455 */     GIR_EraseRootFromParent_Done,
     /* 399456 */   // Label 8063: @399456
     /* 399456 */   GIM_Reject,
     /* 399457 */ // Label 8059: @399457
     /* 399457 */ GIM_Reject,
     /* 399458 */ // Label 8046: @399458
     /* 399458 */ GIM_Try, /*On fail goto*//*Label 8064*/ GIMT_Encode4(399540),
     /* 399463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 399469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399481 */   GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(399510), // Rule ID 5441 //
     /* 399486 */     // MIs[0] imm
     /* 399486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399494 */     // MIs[1] Operand 1
     /* 399494 */     // No operand predicates
     /* 399494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399496 */     // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399501 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399505 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399508 */     GIR_RootConstrainSelectedInstOperands,
     /* 399509 */     // GIR_Coverage, 5441,
     /* 399509 */     GIR_EraseRootFromParent_Done,
     /* 399510 */   // Label 8065: @399510
     /* 399510 */   GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(399539), // Rule ID 5446 //
     /* 399515 */     // MIs[0] imm
     /* 399515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399523 */     // MIs[1] Operand 1
     /* 399523 */     // No operand predicates
     /* 399523 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399525 */     // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399534 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399537 */     GIR_RootConstrainSelectedInstOperands,
     /* 399538 */     // GIR_Coverage, 5446,
     /* 399538 */     GIR_EraseRootFromParent_Done,
     /* 399539 */   // Label 8066: @399539
     /* 399539 */   GIM_Reject,
     /* 399540 */ // Label 8064: @399540
     /* 399540 */ GIM_Reject,
     /* 399541 */ // Label 8047: @399541
     /* 399541 */ GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(399861),
     /* 399546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399549 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 399552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399556 */   GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(399671), // Rule ID 5423 //
     /* 399561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399578 */     // MIs[1] Operand 2
     /* 399578 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 399593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399597 */     // MIs[2] Rn
     /* 399597 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 399602 */     // MIs[2] Operand 2
     /* 399602 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 399613 */     // MIs[0] imm
     /* 399613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 399617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399621 */     // MIs[3] Operand 1
     /* 399621 */     // No operand predicates
     /* 399621 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399623 */     // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 399623 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 399626 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399630 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399635 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399639 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 399646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399653 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 399660 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399670 */     // GIR_Coverage, 5423,
     /* 399670 */     GIR_EraseRootFromParent_Done,
     /* 399671 */   // Label 8068: @399671
     /* 399671 */   GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(399786), // Rule ID 5428 //
     /* 399676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399693 */     // MIs[1] Operand 2
     /* 399693 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 399708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399712 */     // MIs[2] Rn
     /* 399712 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 399717 */     // MIs[2] Operand 2
     /* 399717 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 399728 */     // MIs[0] imm
     /* 399728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 399732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399736 */     // MIs[3] Operand 1
     /* 399736 */     // No operand predicates
     /* 399736 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399738 */     // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 399738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 399741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 399758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 399761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 399763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 399766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 399768 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 399775 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399785 */     // GIR_Coverage, 5428,
     /* 399785 */     GIR_EraseRootFromParent_Done,
     /* 399786 */   // Label 8069: @399786
     /* 399786 */   GIM_Try, /*On fail goto*//*Label 8070*/ GIMT_Encode4(399823), // Rule ID 5420 //
     /* 399791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399799 */     // MIs[0] imm
     /* 399799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399807 */     // MIs[1] Operand 1
     /* 399807 */     // No operand predicates
     /* 399807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399809 */     // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 399812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399821 */     GIR_RootConstrainSelectedInstOperands,
     /* 399822 */     // GIR_Coverage, 5420,
     /* 399822 */     GIR_EraseRootFromParent_Done,
     /* 399823 */   // Label 8070: @399823
     /* 399823 */   GIM_Try, /*On fail goto*//*Label 8071*/ GIMT_Encode4(399860), // Rule ID 5425 //
     /* 399828 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399836 */     // MIs[0] imm
     /* 399836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399844 */     // MIs[1] Operand 1
     /* 399844 */     // No operand predicates
     /* 399844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399846 */     // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 399849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399858 */     GIR_RootConstrainSelectedInstOperands,
     /* 399859 */     // GIR_Coverage, 5425,
     /* 399859 */     GIR_EraseRootFromParent_Done,
     /* 399860 */   // Label 8071: @399860
     /* 399860 */   GIM_Reject,
     /* 399861 */ // Label 8067: @399861
     /* 399861 */ GIM_Reject,
     /* 399862 */ // Label 8048: @399862
     /* 399862 */ GIM_Try, /*On fail goto*//*Label 8072*/ GIMT_Encode4(399944),
     /* 399867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399870 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 399873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399881 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399885 */   GIM_Try, /*On fail goto*//*Label 8073*/ GIMT_Encode4(399914), // Rule ID 5431 //
     /* 399890 */     // MIs[0] imm
     /* 399890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399898 */     // MIs[1] Operand 1
     /* 399898 */     // No operand predicates
     /* 399898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399900 */     // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399912 */     GIR_RootConstrainSelectedInstOperands,
     /* 399913 */     // GIR_Coverage, 5431,
     /* 399913 */     GIR_EraseRootFromParent_Done,
     /* 399914 */   // Label 8073: @399914
     /* 399914 */   GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(399943), // Rule ID 5436 //
     /* 399919 */     // MIs[0] imm
     /* 399919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 399923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399927 */     // MIs[1] Operand 1
     /* 399927 */     // No operand predicates
     /* 399927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399929 */     // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 399929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 399932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 399938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 399941 */     GIR_RootConstrainSelectedInstOperands,
     /* 399942 */     // GIR_Coverage, 5436,
     /* 399942 */     GIR_EraseRootFromParent_Done,
     /* 399943 */   // Label 8074: @399943
     /* 399943 */   GIM_Reject,
     /* 399944 */ // Label 8072: @399944
     /* 399944 */ GIM_Reject,
     /* 399945 */ // Label 8049: @399945
     /* 399945 */ GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(400153),
     /* 399950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 399953 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 399956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399960 */   GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(400075), // Rule ID 5418 //
     /* 399965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 399977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399982 */     // MIs[1] Operand 2
     /* 399982 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 399997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400001 */     // MIs[2] Rn
     /* 400001 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 400006 */     // MIs[2] Operand 2
     /* 400006 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 400017 */     // MIs[0] imm
     /* 400017 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 400021 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400025 */     // MIs[3] Operand 1
     /* 400025 */     // No operand predicates
     /* 400025 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400027 */     // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 400027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 400030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 400034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400039 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400043 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 400047 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 400050 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 400052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 400057 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 400064 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400069 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400074 */     // GIR_Coverage, 5418,
     /* 400074 */     GIR_EraseRootFromParent_Done,
     /* 400075 */   // Label 8076: @400075
     /* 400075 */   GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(400115), // Rule ID 1868 //
     /* 400080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400091 */     // MIs[0] imm
     /* 400091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 400095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400099 */     // MIs[1] Operand 1
     /* 400099 */     // No operand predicates
     /* 400099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400101 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 400101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 400104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400106 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 400110 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400113 */     GIR_RootConstrainSelectedInstOperands,
     /* 400114 */     // GIR_Coverage, 1868,
     /* 400114 */     GIR_EraseRootFromParent_Done,
     /* 400115 */   // Label 8077: @400115
     /* 400115 */   GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(400152), // Rule ID 5415 //
     /* 400120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400128 */     // MIs[0] imm
     /* 400128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 400132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400136 */     // MIs[1] Operand 1
     /* 400136 */     // No operand predicates
     /* 400136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400138 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 400138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 400141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 400147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400150 */     GIR_RootConstrainSelectedInstOperands,
     /* 400151 */     // GIR_Coverage, 5415,
     /* 400151 */     GIR_EraseRootFromParent_Done,
     /* 400152 */   // Label 8078: @400152
     /* 400152 */   GIM_Reject,
     /* 400153 */ // Label 8075: @400153
     /* 400153 */ GIM_Reject,
     /* 400154 */ // Label 8050: @400154
     /* 400154 */ GIM_Try, /*On fail goto*//*Label 8079*/ GIMT_Encode4(400236),
     /* 400159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400162 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 400165 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400169 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400173 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400177 */   GIM_Try, /*On fail goto*//*Label 8080*/ GIMT_Encode4(400206), // Rule ID 5421 //
     /* 400182 */     // MIs[0] imm
     /* 400182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 400186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400190 */     // MIs[1] Operand 1
     /* 400190 */     // No operand predicates
     /* 400190 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400192 */     // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 400192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 400195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400197 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 400201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400204 */     GIR_RootConstrainSelectedInstOperands,
     /* 400205 */     // GIR_Coverage, 5421,
     /* 400205 */     GIR_EraseRootFromParent_Done,
     /* 400206 */   // Label 8080: @400206
     /* 400206 */   GIM_Try, /*On fail goto*//*Label 8081*/ GIMT_Encode4(400235), // Rule ID 5426 //
     /* 400211 */     // MIs[0] imm
     /* 400211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 400215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400219 */     // MIs[1] Operand 1
     /* 400219 */     // No operand predicates
     /* 400219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400221 */     // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 400221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 400224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 400230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400233 */     GIR_RootConstrainSelectedInstOperands,
     /* 400234 */     // GIR_Coverage, 5426,
     /* 400234 */     GIR_EraseRootFromParent_Done,
     /* 400235 */   // Label 8081: @400235
     /* 400235 */   GIM_Reject,
     /* 400236 */ // Label 8079: @400236
     /* 400236 */ GIM_Reject,
     /* 400237 */ // Label 8051: @400237
     /* 400237 */ GIM_Try, /*On fail goto*//*Label 8082*/ GIMT_Encode4(400322),
     /* 400242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 400245 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 400248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400256 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400260 */   GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(400292), // Rule ID 1869 //
     /* 400265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400268 */     // MIs[0] imm
     /* 400268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 400272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400276 */     // MIs[1] Operand 1
     /* 400276 */     // No operand predicates
     /* 400276 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400278 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 400278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 400281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 400287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400290 */     GIR_RootConstrainSelectedInstOperands,
     /* 400291 */     // GIR_Coverage, 1869,
     /* 400291 */     GIR_EraseRootFromParent_Done,
     /* 400292 */   // Label 8083: @400292
     /* 400292 */   GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(400321), // Rule ID 5416 //
     /* 400297 */     // MIs[0] imm
     /* 400297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 400301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400305 */     // MIs[1] Operand 1
     /* 400305 */     // No operand predicates
     /* 400305 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400307 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 400307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 400310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 400316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 400319 */     GIR_RootConstrainSelectedInstOperands,
     /* 400320 */     // GIR_Coverage, 5416,
     /* 400320 */     GIR_EraseRootFromParent_Done,
     /* 400321 */   // Label 8084: @400321
     /* 400321 */   GIM_Reject,
     /* 400322 */ // Label 8082: @400322
     /* 400322 */ GIM_Reject,
     /* 400323 */ // Label 8052: @400323
     /* 400323 */ GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(400369), // Rule ID 2731 //
     /* 400328 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 400331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 400334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 400337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 400341 */   // MIs[0] Op3
     /* 400341 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 400345 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400349 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /* 400353 */   // MIs[1] Operand 1
     /* 400353 */   // No operand predicates
     /* 400353 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400355 */   // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
     /* 400355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
     /* 400358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 400360 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 400362 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /* 400364 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
     /* 400367 */   GIR_RootConstrainSelectedInstOperands,
     /* 400368 */   // GIR_Coverage, 2731,
     /* 400368 */   GIR_EraseRootFromParent_Done,
     /* 400369 */ // Label 8085: @400369
     /* 400369 */ GIM_Reject,
     /* 400370 */ // Label 8053: @400370
     /* 400370 */ GIM_Reject,
     /* 400371 */ // Label 128: @400371
     /* 400371 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8093*/ GIMT_Encode4(400709),
     /* 400382 */ /*GILLT_s32*//*Label 8086*/ GIMT_Encode4(400418),
     /* 400386 */ /*GILLT_s64*//*Label 8087*/ GIMT_Encode4(400456), GIMT_Encode4(0),
     /* 400394 */ /*GILLT_v2s32*//*Label 8088*/ GIMT_Encode4(400519),
     /* 400398 */ /*GILLT_v2s64*//*Label 8089*/ GIMT_Encode4(400557),
     /* 400402 */ /*GILLT_v4s16*//*Label 8090*/ GIMT_Encode4(400595),
     /* 400406 */ /*GILLT_v4s32*//*Label 8091*/ GIMT_Encode4(400633), GIMT_Encode4(0),
     /* 400414 */ /*GILLT_v8s16*//*Label 8092*/ GIMT_Encode4(400671),
     /* 400418 */ // Label 8086: @400418
     /* 400418 */ GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(400455), // Rule ID 1622 //
     /* 400423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 400429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 400432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400440 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400444 */   // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 400444 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
     /* 400449 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400453 */   GIR_RootConstrainSelectedInstOperands,
     /* 400454 */   // GIR_Coverage, 1622,
     /* 400454 */   GIR_Done,
     /* 400455 */ // Label 8094: @400455
     /* 400455 */ GIM_Reject,
     /* 400456 */ // Label 8087: @400456
     /* 400456 */ GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(400518),
     /* 400461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 400464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 400467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400471 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400475 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400479 */   GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(400498), // Rule ID 1621 //
     /* 400484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400487 */     // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 400487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 400492 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400496 */     GIR_RootConstrainSelectedInstOperands,
     /* 400497 */     // GIR_Coverage, 1621,
     /* 400497 */     GIR_Done,
     /* 400498 */   // Label 8096: @400498
     /* 400498 */   GIM_Try, /*On fail goto*//*Label 8097*/ GIMT_Encode4(400517), // Rule ID 5195 //
     /* 400503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400506 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 400506 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 400511 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400515 */     GIR_RootConstrainSelectedInstOperands,
     /* 400516 */     // GIR_Coverage, 5195,
     /* 400516 */     GIR_Done,
     /* 400517 */   // Label 8097: @400517
     /* 400517 */   GIM_Reject,
     /* 400518 */ // Label 8095: @400518
     /* 400518 */ GIM_Reject,
     /* 400519 */ // Label 8088: @400519
     /* 400519 */ GIM_Try, /*On fail goto*//*Label 8098*/ GIMT_Encode4(400556), // Rule ID 1210 //
     /* 400524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 400530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 400533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400541 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400545 */   // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 400545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
     /* 400550 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400554 */   GIR_RootConstrainSelectedInstOperands,
     /* 400555 */   // GIR_Coverage, 1210,
     /* 400555 */   GIR_Done,
     /* 400556 */ // Label 8098: @400556
     /* 400556 */ GIM_Reject,
     /* 400557 */ // Label 8089: @400557
     /* 400557 */ GIM_Try, /*On fail goto*//*Label 8099*/ GIMT_Encode4(400594), // Rule ID 1212 //
     /* 400562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 400571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400579 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400583 */   // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 400583 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
     /* 400588 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400592 */   GIR_RootConstrainSelectedInstOperands,
     /* 400593 */   // GIR_Coverage, 1212,
     /* 400593 */   GIR_Done,
     /* 400594 */ // Label 8099: @400594
     /* 400594 */ GIM_Reject,
     /* 400595 */ // Label 8090: @400595
     /* 400595 */ GIM_Try, /*On fail goto*//*Label 8100*/ GIMT_Encode4(400632), // Rule ID 1208 //
     /* 400600 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 400609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400617 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400621 */   // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 400621 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
     /* 400626 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400630 */   GIR_RootConstrainSelectedInstOperands,
     /* 400631 */   // GIR_Coverage, 1208,
     /* 400631 */   GIR_Done,
     /* 400632 */ // Label 8100: @400632
     /* 400632 */ GIM_Reject,
     /* 400633 */ // Label 8091: @400633
     /* 400633 */ GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(400670), // Rule ID 1211 //
     /* 400638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400644 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 400647 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400651 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400655 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400659 */   // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 400659 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
     /* 400664 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400668 */   GIR_RootConstrainSelectedInstOperands,
     /* 400669 */   // GIR_Coverage, 1211,
     /* 400669 */   GIR_Done,
     /* 400670 */ // Label 8101: @400670
     /* 400670 */ GIM_Reject,
     /* 400671 */ // Label 8092: @400671
     /* 400671 */ GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(400708), // Rule ID 1209 //
     /* 400676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 400685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400693 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400697 */   // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 400697 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
     /* 400702 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400706 */   GIR_RootConstrainSelectedInstOperands,
     /* 400707 */   // GIR_Coverage, 1209,
     /* 400707 */   GIR_Done,
     /* 400708 */ // Label 8102: @400708
     /* 400708 */ GIM_Reject,
     /* 400709 */ // Label 8093: @400709
     /* 400709 */ GIM_Reject,
     /* 400710 */ // Label 129: @400710
     /* 400710 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8109*/ GIMT_Encode4(400939),
     /* 400721 */ /*GILLT_s64*//*Label 8103*/ GIMT_Encode4(400753), GIMT_Encode4(0),
     /* 400729 */ /*GILLT_v2s32*//*Label 8104*/ GIMT_Encode4(400784),
     /* 400733 */ /*GILLT_v2s64*//*Label 8105*/ GIMT_Encode4(400815),
     /* 400737 */ /*GILLT_v4s16*//*Label 8106*/ GIMT_Encode4(400846),
     /* 400741 */ /*GILLT_v4s32*//*Label 8107*/ GIMT_Encode4(400877), GIMT_Encode4(0),
     /* 400749 */ /*GILLT_v8s16*//*Label 8108*/ GIMT_Encode4(400908),
     /* 400753 */ // Label 8103: @400753
     /* 400753 */ GIM_Try, /*On fail goto*//*Label 8110*/ GIMT_Encode4(400783), // Rule ID 2511 //
     /* 400758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 400764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400772 */   // (AArch64fcmeqz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 400772 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
     /* 400777 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400781 */   GIR_RootConstrainSelectedInstOperands,
     /* 400782 */   // GIR_Coverage, 2511,
     /* 400782 */   GIR_Done,
     /* 400783 */ // Label 8110: @400783
     /* 400783 */ GIM_Reject,
     /* 400784 */ // Label 8104: @400784
     /* 400784 */ GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(400814), // Rule ID 773 //
     /* 400789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 400795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400803 */   // (AArch64fcmeqz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 400803 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
     /* 400808 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400812 */   GIR_RootConstrainSelectedInstOperands,
     /* 400813 */   // GIR_Coverage, 773,
     /* 400813 */   GIR_Done,
     /* 400814 */ // Label 8111: @400814
     /* 400814 */ GIM_Reject,
     /* 400815 */ // Label 8105: @400815
     /* 400815 */ GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(400845), // Rule ID 775 //
     /* 400820 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400823 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 400826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400834 */   // (AArch64fcmeqz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 400834 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
     /* 400839 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400843 */   GIR_RootConstrainSelectedInstOperands,
     /* 400844 */   // GIR_Coverage, 775,
     /* 400844 */   GIR_Done,
     /* 400845 */ // Label 8112: @400845
     /* 400845 */ GIM_Reject,
     /* 400846 */ // Label 8106: @400846
     /* 400846 */ GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(400876), // Rule ID 771 //
     /* 400851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 400857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400865 */   // (AArch64fcmeqz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 400865 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
     /* 400870 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400874 */   GIR_RootConstrainSelectedInstOperands,
     /* 400875 */   // GIR_Coverage, 771,
     /* 400875 */   GIR_Done,
     /* 400876 */ // Label 8113: @400876
     /* 400876 */ GIM_Reject,
     /* 400877 */ // Label 8107: @400877
     /* 400877 */ GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(400907), // Rule ID 774 //
     /* 400882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400896 */   // (AArch64fcmeqz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 400896 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
     /* 400901 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400905 */   GIR_RootConstrainSelectedInstOperands,
     /* 400906 */   // GIR_Coverage, 774,
     /* 400906 */   GIR_Done,
     /* 400907 */ // Label 8114: @400907
     /* 400907 */ GIM_Reject,
     /* 400908 */ // Label 8108: @400908
     /* 400908 */ GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(400938), // Rule ID 772 //
     /* 400913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400927 */   // (AArch64fcmeqz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 400927 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
     /* 400932 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400936 */   GIR_RootConstrainSelectedInstOperands,
     /* 400937 */   // GIR_Coverage, 772,
     /* 400937 */   GIR_Done,
     /* 400938 */ // Label 8115: @400938
     /* 400938 */ GIM_Reject,
     /* 400939 */ // Label 8109: @400939
     /* 400939 */ GIM_Reject,
     /* 400940 */ // Label 130: @400940
     /* 400940 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8123*/ GIMT_Encode4(401603),
     /* 400951 */ /*GILLT_s32*//*Label 8116*/ GIMT_Encode4(400987),
     /* 400955 */ /*GILLT_s64*//*Label 8117*/ GIMT_Encode4(401025), GIMT_Encode4(0),
     /* 400963 */ /*GILLT_v2s32*//*Label 8118*/ GIMT_Encode4(401088),
     /* 400967 */ /*GILLT_v2s64*//*Label 8119*/ GIMT_Encode4(401191),
     /* 400971 */ /*GILLT_v4s16*//*Label 8120*/ GIMT_Encode4(401294),
     /* 400975 */ /*GILLT_v4s32*//*Label 8121*/ GIMT_Encode4(401397), GIMT_Encode4(0),
     /* 400983 */ /*GILLT_v8s16*//*Label 8122*/ GIMT_Encode4(401500),
     /* 400987 */ // Label 8116: @400987
     /* 400987 */ GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(401024), // Rule ID 1624 //
     /* 400992 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 400998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 401001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401005 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401009 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401013 */   // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 401013 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
     /* 401018 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401022 */   GIR_RootConstrainSelectedInstOperands,
     /* 401023 */   // GIR_Coverage, 1624,
     /* 401023 */   GIR_Done,
     /* 401024 */ // Label 8124: @401024
     /* 401024 */ GIM_Reject,
     /* 401025 */ // Label 8117: @401025
     /* 401025 */ GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(401087),
     /* 401030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 401033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 401036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401044 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401048 */   GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(401067), // Rule ID 1623 //
     /* 401053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401056 */     // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 401056 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 401061 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401065 */     GIR_RootConstrainSelectedInstOperands,
     /* 401066 */     // GIR_Coverage, 1623,
     /* 401066 */     GIR_Done,
     /* 401067 */   // Label 8126: @401067
     /* 401067 */   GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(401086), // Rule ID 5196 //
     /* 401072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401075 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 401075 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 401080 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401084 */     GIR_RootConstrainSelectedInstOperands,
     /* 401085 */     // GIR_Coverage, 5196,
     /* 401085 */     GIR_Done,
     /* 401086 */   // Label 8127: @401086
     /* 401086 */   GIM_Reject,
     /* 401087 */ // Label 8125: @401087
     /* 401087 */ GIM_Reject,
     /* 401088 */ // Label 8118: @401088
     /* 401088 */ GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(401190),
     /* 401093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 401099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401103 */   GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(401162), // Rule ID 1172 //
     /* 401108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401128 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401132 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401136 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401140 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401147 */     // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 401147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 401150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401160 */     GIR_RootConstrainSelectedInstOperands,
     /* 401161 */     // GIR_Coverage, 1172,
     /* 401161 */     GIR_EraseRootFromParent_Done,
     /* 401162 */   // Label 8129: @401162
     /* 401162 */   GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(401189), // Rule ID 1215 //
     /* 401167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401178 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 401178 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
     /* 401183 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401187 */     GIR_RootConstrainSelectedInstOperands,
     /* 401188 */     // GIR_Coverage, 1215,
     /* 401188 */     GIR_Done,
     /* 401189 */   // Label 8130: @401189
     /* 401189 */   GIM_Reject,
     /* 401190 */ // Label 8128: @401190
     /* 401190 */ GIM_Reject,
     /* 401191 */ // Label 8119: @401191
     /* 401191 */ GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(401293),
     /* 401196 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 401202 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401206 */   GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(401265), // Rule ID 1176 //
     /* 401211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401250 */     // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 401250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 401253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401263 */     GIR_RootConstrainSelectedInstOperands,
     /* 401264 */     // GIR_Coverage, 1176,
     /* 401264 */     GIR_EraseRootFromParent_Done,
     /* 401265 */   // Label 8132: @401265
     /* 401265 */   GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(401292), // Rule ID 1217 //
     /* 401270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401281 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 401281 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
     /* 401286 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401290 */     GIR_RootConstrainSelectedInstOperands,
     /* 401291 */     // GIR_Coverage, 1217,
     /* 401291 */     GIR_Done,
     /* 401292 */   // Label 8133: @401292
     /* 401292 */   GIM_Reject,
     /* 401293 */ // Label 8131: @401293
     /* 401293 */ GIM_Reject,
     /* 401294 */ // Label 8120: @401294
     /* 401294 */ GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(401396),
     /* 401299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401302 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 401305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401309 */   GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(401368), // Rule ID 1168 //
     /* 401314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401329 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401334 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401338 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401342 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401351 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401353 */     // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 401353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 401356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401366 */     GIR_RootConstrainSelectedInstOperands,
     /* 401367 */     // GIR_Coverage, 1168,
     /* 401367 */     GIR_EraseRootFromParent_Done,
     /* 401368 */   // Label 8135: @401368
     /* 401368 */   GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(401395), // Rule ID 1213 //
     /* 401373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401384 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 401384 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
     /* 401389 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401393 */     GIR_RootConstrainSelectedInstOperands,
     /* 401394 */     // GIR_Coverage, 1213,
     /* 401394 */     GIR_Done,
     /* 401395 */   // Label 8136: @401395
     /* 401395 */   GIM_Reject,
     /* 401396 */ // Label 8134: @401396
     /* 401396 */ GIM_Reject,
     /* 401397 */ // Label 8121: @401397
     /* 401397 */ GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(401499),
     /* 401402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 401408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401412 */   GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(401471), // Rule ID 1174 //
     /* 401417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401428 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401454 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401456 */     // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 401456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 401459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401469 */     GIR_RootConstrainSelectedInstOperands,
     /* 401470 */     // GIR_Coverage, 1174,
     /* 401470 */     GIR_EraseRootFromParent_Done,
     /* 401471 */   // Label 8138: @401471
     /* 401471 */   GIM_Try, /*On fail goto*//*Label 8139*/ GIMT_Encode4(401498), // Rule ID 1216 //
     /* 401476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401487 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 401487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
     /* 401492 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401496 */     GIR_RootConstrainSelectedInstOperands,
     /* 401497 */     // GIR_Coverage, 1216,
     /* 401497 */     GIR_Done,
     /* 401498 */   // Label 8139: @401498
     /* 401498 */   GIM_Reject,
     /* 401499 */ // Label 8137: @401499
     /* 401499 */ GIM_Reject,
     /* 401500 */ // Label 8122: @401500
     /* 401500 */ GIM_Try, /*On fail goto*//*Label 8140*/ GIMT_Encode4(401602),
     /* 401505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 401511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401515 */   GIM_Try, /*On fail goto*//*Label 8141*/ GIMT_Encode4(401574), // Rule ID 1170 //
     /* 401520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 401548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 401559 */     // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 401559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 401562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 401568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 401572 */     GIR_RootConstrainSelectedInstOperands,
     /* 401573 */     // GIR_Coverage, 1170,
     /* 401573 */     GIR_EraseRootFromParent_Done,
     /* 401574 */   // Label 8141: @401574
     /* 401574 */   GIM_Try, /*On fail goto*//*Label 8142*/ GIMT_Encode4(401601), // Rule ID 1214 //
     /* 401579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401590 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 401590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
     /* 401595 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401599 */     GIR_RootConstrainSelectedInstOperands,
     /* 401600 */     // GIR_Coverage, 1214,
     /* 401600 */     GIR_Done,
     /* 401601 */   // Label 8142: @401601
     /* 401601 */   GIM_Reject,
     /* 401602 */ // Label 8140: @401602
     /* 401602 */ GIM_Reject,
     /* 401603 */ // Label 8123: @401603
     /* 401603 */ GIM_Reject,
     /* 401604 */ // Label 131: @401604
     /* 401604 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8149*/ GIMT_Encode4(401833),
     /* 401615 */ /*GILLT_s64*//*Label 8143*/ GIMT_Encode4(401647), GIMT_Encode4(0),
     /* 401623 */ /*GILLT_v2s32*//*Label 8144*/ GIMT_Encode4(401678),
     /* 401627 */ /*GILLT_v2s64*//*Label 8145*/ GIMT_Encode4(401709),
     /* 401631 */ /*GILLT_v4s16*//*Label 8146*/ GIMT_Encode4(401740),
     /* 401635 */ /*GILLT_v4s32*//*Label 8147*/ GIMT_Encode4(401771), GIMT_Encode4(0),
     /* 401643 */ /*GILLT_v8s16*//*Label 8148*/ GIMT_Encode4(401802),
     /* 401647 */ // Label 8143: @401647
     /* 401647 */ GIM_Try, /*On fail goto*//*Label 8150*/ GIMT_Encode4(401677), // Rule ID 5227 //
     /* 401652 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 401658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401666 */   // (AArch64fcmgez:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 401666 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
     /* 401671 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401675 */   GIR_RootConstrainSelectedInstOperands,
     /* 401676 */   // GIR_Coverage, 5227,
     /* 401676 */   GIR_Done,
     /* 401677 */ // Label 8150: @401677
     /* 401677 */ GIM_Reject,
     /* 401678 */ // Label 8144: @401678
     /* 401678 */ GIM_Try, /*On fail goto*//*Label 8151*/ GIMT_Encode4(401708), // Rule ID 778 //
     /* 401683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401697 */   // (AArch64fcmgez:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 401697 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
     /* 401702 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401706 */   GIR_RootConstrainSelectedInstOperands,
     /* 401707 */   // GIR_Coverage, 778,
     /* 401707 */   GIR_Done,
     /* 401708 */ // Label 8151: @401708
     /* 401708 */ GIM_Reject,
     /* 401709 */ // Label 8145: @401709
     /* 401709 */ GIM_Try, /*On fail goto*//*Label 8152*/ GIMT_Encode4(401739), // Rule ID 780 //
     /* 401714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401724 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401728 */   // (AArch64fcmgez:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 401728 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
     /* 401733 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401737 */   GIR_RootConstrainSelectedInstOperands,
     /* 401738 */   // GIR_Coverage, 780,
     /* 401738 */   GIR_Done,
     /* 401739 */ // Label 8152: @401739
     /* 401739 */ GIM_Reject,
     /* 401740 */ // Label 8146: @401740
     /* 401740 */ GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(401770), // Rule ID 776 //
     /* 401745 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401748 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401759 */   // (AArch64fcmgez:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 401759 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
     /* 401764 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401768 */   GIR_RootConstrainSelectedInstOperands,
     /* 401769 */   // GIR_Coverage, 776,
     /* 401769 */   GIR_Done,
     /* 401770 */ // Label 8153: @401770
     /* 401770 */ GIM_Reject,
     /* 401771 */ // Label 8147: @401771
     /* 401771 */ GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(401801), // Rule ID 779 //
     /* 401776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401790 */   // (AArch64fcmgez:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 401790 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
     /* 401795 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401799 */   GIR_RootConstrainSelectedInstOperands,
     /* 401800 */   // GIR_Coverage, 779,
     /* 401800 */   GIR_Done,
     /* 401801 */ // Label 8154: @401801
     /* 401801 */ GIM_Reject,
     /* 401802 */ // Label 8148: @401802
     /* 401802 */ GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(401832), // Rule ID 777 //
     /* 401807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401821 */   // (AArch64fcmgez:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 401821 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
     /* 401826 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401830 */   GIR_RootConstrainSelectedInstOperands,
     /* 401831 */   // GIR_Coverage, 777,
     /* 401831 */   GIR_Done,
     /* 401832 */ // Label 8155: @401832
     /* 401832 */ GIM_Reject,
     /* 401833 */ // Label 8149: @401833
     /* 401833 */ GIM_Reject,
     /* 401834 */ // Label 132: @401834
     /* 401834 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8163*/ GIMT_Encode4(402497),
     /* 401845 */ /*GILLT_s32*//*Label 8156*/ GIMT_Encode4(401881),
     /* 401849 */ /*GILLT_s64*//*Label 8157*/ GIMT_Encode4(401919), GIMT_Encode4(0),
     /* 401857 */ /*GILLT_v2s32*//*Label 8158*/ GIMT_Encode4(401982),
     /* 401861 */ /*GILLT_v2s64*//*Label 8159*/ GIMT_Encode4(402085),
     /* 401865 */ /*GILLT_v4s16*//*Label 8160*/ GIMT_Encode4(402188),
     /* 401869 */ /*GILLT_v4s32*//*Label 8161*/ GIMT_Encode4(402291), GIMT_Encode4(0),
     /* 401877 */ /*GILLT_v8s16*//*Label 8162*/ GIMT_Encode4(402394),
     /* 401881 */ // Label 8156: @401881
     /* 401881 */ GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(401918), // Rule ID 1626 //
     /* 401886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 401892 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 401895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401903 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401907 */   // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 401907 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
     /* 401912 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401916 */   GIR_RootConstrainSelectedInstOperands,
     /* 401917 */   // GIR_Coverage, 1626,
     /* 401917 */   GIR_Done,
     /* 401918 */ // Label 8164: @401918
     /* 401918 */ GIM_Reject,
     /* 401919 */ // Label 8157: @401919
     /* 401919 */ GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(401981),
     /* 401924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 401927 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 401930 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401934 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401938 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401942 */   GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(401961), // Rule ID 1625 //
     /* 401947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401950 */     // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 401950 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 401955 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401959 */     GIR_RootConstrainSelectedInstOperands,
     /* 401960 */     // GIR_Coverage, 1625,
     /* 401960 */     GIR_Done,
     /* 401961 */   // Label 8166: @401961
     /* 401961 */   GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(401980), // Rule ID 5197 //
     /* 401966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401969 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 401969 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 401974 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401978 */     GIR_RootConstrainSelectedInstOperands,
     /* 401979 */     // GIR_Coverage, 5197,
     /* 401979 */     GIR_Done,
     /* 401980 */   // Label 8167: @401980
     /* 401980 */   GIM_Reject,
     /* 401981 */ // Label 8165: @401981
     /* 401981 */ GIM_Reject,
     /* 401982 */ // Label 8158: @401982
     /* 401982 */ GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(402084),
     /* 401987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401990 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 401993 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401997 */   GIM_Try, /*On fail goto*//*Label 8169*/ GIMT_Encode4(402056), // Rule ID 1182 //
     /* 402002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 402013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 402017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 402030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 402034 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402039 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402041 */     // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 402041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 402044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402054 */     GIR_RootConstrainSelectedInstOperands,
     /* 402055 */     // GIR_Coverage, 1182,
     /* 402055 */     GIR_EraseRootFromParent_Done,
     /* 402056 */   // Label 8169: @402056
     /* 402056 */   GIM_Try, /*On fail goto*//*Label 8170*/ GIMT_Encode4(402083), // Rule ID 1220 //
     /* 402061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402072 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 402072 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
     /* 402077 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402081 */     GIR_RootConstrainSelectedInstOperands,
     /* 402082 */     // GIR_Coverage, 1220,
     /* 402082 */     GIR_Done,
     /* 402083 */   // Label 8170: @402083
     /* 402083 */   GIM_Reject,
     /* 402084 */ // Label 8168: @402084
     /* 402084 */ GIM_Reject,
     /* 402085 */ // Label 8159: @402085
     /* 402085 */ GIM_Try, /*On fail goto*//*Label 8171*/ GIMT_Encode4(402187),
     /* 402090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 402093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 402096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402100 */   GIM_Try, /*On fail goto*//*Label 8172*/ GIMT_Encode4(402159), // Rule ID 1186 //
     /* 402105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 402116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 402120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 402133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 402137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402144 */     // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 402144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 402147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402157 */     GIR_RootConstrainSelectedInstOperands,
     /* 402158 */     // GIR_Coverage, 1186,
     /* 402158 */     GIR_EraseRootFromParent_Done,
     /* 402159 */   // Label 8172: @402159
     /* 402159 */   GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(402186), // Rule ID 1222 //
     /* 402164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402167 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402175 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 402175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
     /* 402180 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402184 */     GIR_RootConstrainSelectedInstOperands,
     /* 402185 */     // GIR_Coverage, 1222,
     /* 402185 */     GIR_Done,
     /* 402186 */   // Label 8173: @402186
     /* 402186 */   GIM_Reject,
     /* 402187 */ // Label 8171: @402187
     /* 402187 */ GIM_Reject,
     /* 402188 */ // Label 8160: @402188
     /* 402188 */ GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(402290),
     /* 402193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 402196 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 402199 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402203 */   GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(402262), // Rule ID 1178 //
     /* 402208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402211 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402215 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 402219 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 402223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 402236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 402240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402245 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402247 */     // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 402247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 402250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402260 */     GIR_RootConstrainSelectedInstOperands,
     /* 402261 */     // GIR_Coverage, 1178,
     /* 402261 */     GIR_EraseRootFromParent_Done,
     /* 402262 */   // Label 8175: @402262
     /* 402262 */   GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(402289), // Rule ID 1218 //
     /* 402267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402278 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 402278 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
     /* 402283 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402287 */     GIR_RootConstrainSelectedInstOperands,
     /* 402288 */     // GIR_Coverage, 1218,
     /* 402288 */     GIR_Done,
     /* 402289 */   // Label 8176: @402289
     /* 402289 */   GIM_Reject,
     /* 402290 */ // Label 8174: @402290
     /* 402290 */ GIM_Reject,
     /* 402291 */ // Label 8161: @402291
     /* 402291 */ GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(402393),
     /* 402296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 402302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402306 */   GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(402365), // Rule ID 1184 //
     /* 402311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 402322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 402339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402350 */     // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 402350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 402353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402363 */     GIR_RootConstrainSelectedInstOperands,
     /* 402364 */     // GIR_Coverage, 1184,
     /* 402364 */     GIR_EraseRootFromParent_Done,
     /* 402365 */   // Label 8178: @402365
     /* 402365 */   GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(402392), // Rule ID 1221 //
     /* 402370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402381 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 402381 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
     /* 402386 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402390 */     GIR_RootConstrainSelectedInstOperands,
     /* 402391 */     // GIR_Coverage, 1221,
     /* 402391 */     GIR_Done,
     /* 402392 */   // Label 8179: @402392
     /* 402392 */   GIM_Reject,
     /* 402393 */ // Label 8177: @402393
     /* 402393 */ GIM_Reject,
     /* 402394 */ // Label 8162: @402394
     /* 402394 */ GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(402496),
     /* 402399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402402 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 402405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402409 */   GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(402468), // Rule ID 1180 //
     /* 402414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 402425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 402442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402446 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402451 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402453 */     // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 402453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 402456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 402462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402466 */     GIR_RootConstrainSelectedInstOperands,
     /* 402467 */     // GIR_Coverage, 1180,
     /* 402467 */     GIR_EraseRootFromParent_Done,
     /* 402468 */   // Label 8181: @402468
     /* 402468 */   GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(402495), // Rule ID 1219 //
     /* 402473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402484 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 402484 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
     /* 402489 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402493 */     GIR_RootConstrainSelectedInstOperands,
     /* 402494 */     // GIR_Coverage, 1219,
     /* 402494 */     GIR_Done,
     /* 402495 */   // Label 8182: @402495
     /* 402495 */   GIM_Reject,
     /* 402496 */ // Label 8180: @402496
     /* 402496 */ GIM_Reject,
     /* 402497 */ // Label 8163: @402497
     /* 402497 */ GIM_Reject,
     /* 402498 */ // Label 133: @402498
     /* 402498 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8189*/ GIMT_Encode4(402727),
     /* 402509 */ /*GILLT_s64*//*Label 8183*/ GIMT_Encode4(402541), GIMT_Encode4(0),
     /* 402517 */ /*GILLT_v2s32*//*Label 8184*/ GIMT_Encode4(402572),
     /* 402521 */ /*GILLT_v2s64*//*Label 8185*/ GIMT_Encode4(402603),
     /* 402525 */ /*GILLT_v4s16*//*Label 8186*/ GIMT_Encode4(402634),
     /* 402529 */ /*GILLT_v4s32*//*Label 8187*/ GIMT_Encode4(402665), GIMT_Encode4(0),
     /* 402537 */ /*GILLT_v8s16*//*Label 8188*/ GIMT_Encode4(402696),
     /* 402541 */ // Label 8183: @402541
     /* 402541 */ GIM_Try, /*On fail goto*//*Label 8190*/ GIMT_Encode4(402571), // Rule ID 5228 //
     /* 402546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 402552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402560 */   // (AArch64fcmgtz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 402560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
     /* 402565 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402569 */   GIR_RootConstrainSelectedInstOperands,
     /* 402570 */   // GIR_Coverage, 5228,
     /* 402570 */   GIR_Done,
     /* 402571 */ // Label 8190: @402571
     /* 402571 */ GIM_Reject,
     /* 402572 */ // Label 8184: @402572
     /* 402572 */ GIM_Try, /*On fail goto*//*Label 8191*/ GIMT_Encode4(402602), // Rule ID 783 //
     /* 402577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 402583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402591 */   // (AArch64fcmgtz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 402591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
     /* 402596 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402600 */   GIR_RootConstrainSelectedInstOperands,
     /* 402601 */   // GIR_Coverage, 783,
     /* 402601 */   GIR_Done,
     /* 402602 */ // Label 8191: @402602
     /* 402602 */ GIM_Reject,
     /* 402603 */ // Label 8185: @402603
     /* 402603 */ GIM_Try, /*On fail goto*//*Label 8192*/ GIMT_Encode4(402633), // Rule ID 785 //
     /* 402608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 402614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402622 */   // (AArch64fcmgtz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 402622 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
     /* 402627 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402631 */   GIR_RootConstrainSelectedInstOperands,
     /* 402632 */   // GIR_Coverage, 785,
     /* 402632 */   GIR_Done,
     /* 402633 */ // Label 8192: @402633
     /* 402633 */ GIM_Reject,
     /* 402634 */ // Label 8186: @402634
     /* 402634 */ GIM_Try, /*On fail goto*//*Label 8193*/ GIMT_Encode4(402664), // Rule ID 781 //
     /* 402639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 402645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402653 */   // (AArch64fcmgtz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 402653 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
     /* 402658 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402662 */   GIR_RootConstrainSelectedInstOperands,
     /* 402663 */   // GIR_Coverage, 781,
     /* 402663 */   GIR_Done,
     /* 402664 */ // Label 8193: @402664
     /* 402664 */ GIM_Reject,
     /* 402665 */ // Label 8187: @402665
     /* 402665 */ GIM_Try, /*On fail goto*//*Label 8194*/ GIMT_Encode4(402695), // Rule ID 784 //
     /* 402670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402684 */   // (AArch64fcmgtz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 402684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
     /* 402689 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402693 */   GIR_RootConstrainSelectedInstOperands,
     /* 402694 */   // GIR_Coverage, 784,
     /* 402694 */   GIR_Done,
     /* 402695 */ // Label 8194: @402695
     /* 402695 */ GIM_Reject,
     /* 402696 */ // Label 8188: @402696
     /* 402696 */ GIM_Try, /*On fail goto*//*Label 8195*/ GIMT_Encode4(402726), // Rule ID 782 //
     /* 402701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402715 */   // (AArch64fcmgtz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 402715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
     /* 402720 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402724 */   GIR_RootConstrainSelectedInstOperands,
     /* 402725 */   // GIR_Coverage, 782,
     /* 402725 */   GIR_Done,
     /* 402726 */ // Label 8195: @402726
     /* 402726 */ GIM_Reject,
     /* 402727 */ // Label 8189: @402727
     /* 402727 */ GIM_Reject,
     /* 402728 */ // Label 134: @402728
     /* 402728 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8202*/ GIMT_Encode4(402957),
     /* 402739 */ /*GILLT_s64*//*Label 8196*/ GIMT_Encode4(402771), GIMT_Encode4(0),
     /* 402747 */ /*GILLT_v2s32*//*Label 8197*/ GIMT_Encode4(402802),
     /* 402751 */ /*GILLT_v2s64*//*Label 8198*/ GIMT_Encode4(402833),
     /* 402755 */ /*GILLT_v4s16*//*Label 8199*/ GIMT_Encode4(402864),
     /* 402759 */ /*GILLT_v4s32*//*Label 8200*/ GIMT_Encode4(402895), GIMT_Encode4(0),
     /* 402767 */ /*GILLT_v8s16*//*Label 8201*/ GIMT_Encode4(402926),
     /* 402771 */ // Label 8196: @402771
     /* 402771 */ GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(402801), // Rule ID 5229 //
     /* 402776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 402782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402790 */   // (AArch64fcmlez:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 402790 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
     /* 402795 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402799 */   GIR_RootConstrainSelectedInstOperands,
     /* 402800 */   // GIR_Coverage, 5229,
     /* 402800 */   GIR_Done,
     /* 402801 */ // Label 8203: @402801
     /* 402801 */ GIM_Reject,
     /* 402802 */ // Label 8197: @402802
     /* 402802 */ GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(402832), // Rule ID 788 //
     /* 402807 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 402813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402821 */   // (AArch64fcmlez:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 402821 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
     /* 402826 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402830 */   GIR_RootConstrainSelectedInstOperands,
     /* 402831 */   // GIR_Coverage, 788,
     /* 402831 */   GIR_Done,
     /* 402832 */ // Label 8204: @402832
     /* 402832 */ GIM_Reject,
     /* 402833 */ // Label 8198: @402833
     /* 402833 */ GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(402863), // Rule ID 790 //
     /* 402838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 402844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402852 */   // (AArch64fcmlez:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 402852 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
     /* 402857 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402861 */   GIR_RootConstrainSelectedInstOperands,
     /* 402862 */   // GIR_Coverage, 790,
     /* 402862 */   GIR_Done,
     /* 402863 */ // Label 8205: @402863
     /* 402863 */ GIM_Reject,
     /* 402864 */ // Label 8199: @402864
     /* 402864 */ GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(402894), // Rule ID 786 //
     /* 402869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 402875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 402883 */   // (AArch64fcmlez:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 402883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
     /* 402888 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402892 */   GIR_RootConstrainSelectedInstOperands,
     /* 402893 */   // GIR_Coverage, 786,
     /* 402893 */   GIR_Done,
     /* 402894 */ // Label 8206: @402894
     /* 402894 */ GIM_Reject,
     /* 402895 */ // Label 8200: @402895
     /* 402895 */ GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(402925), // Rule ID 789 //
     /* 402900 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 402903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 402906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402914 */   // (AArch64fcmlez:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 402914 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
     /* 402919 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402923 */   GIR_RootConstrainSelectedInstOperands,
     /* 402924 */   // GIR_Coverage, 789,
     /* 402924 */   GIR_Done,
     /* 402925 */ // Label 8207: @402925
     /* 402925 */ GIM_Reject,
     /* 402926 */ // Label 8201: @402926
     /* 402926 */ GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(402956), // Rule ID 787 //
     /* 402931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402945 */   // (AArch64fcmlez:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 402945 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
     /* 402950 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 402954 */   GIR_RootConstrainSelectedInstOperands,
     /* 402955 */   // GIR_Coverage, 787,
     /* 402955 */   GIR_Done,
     /* 402956 */ // Label 8208: @402956
     /* 402956 */ GIM_Reject,
     /* 402957 */ // Label 8202: @402957
     /* 402957 */ GIM_Reject,
     /* 402958 */ // Label 135: @402958
     /* 402958 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8215*/ GIMT_Encode4(403187),
     /* 402969 */ /*GILLT_s64*//*Label 8209*/ GIMT_Encode4(403001), GIMT_Encode4(0),
     /* 402977 */ /*GILLT_v2s32*//*Label 8210*/ GIMT_Encode4(403032),
     /* 402981 */ /*GILLT_v2s64*//*Label 8211*/ GIMT_Encode4(403063),
     /* 402985 */ /*GILLT_v4s16*//*Label 8212*/ GIMT_Encode4(403094),
     /* 402989 */ /*GILLT_v4s32*//*Label 8213*/ GIMT_Encode4(403125), GIMT_Encode4(0),
     /* 402997 */ /*GILLT_v8s16*//*Label 8214*/ GIMT_Encode4(403156),
     /* 403001 */ // Label 8209: @403001
     /* 403001 */ GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(403031), // Rule ID 5230 //
     /* 403006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 403012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403020 */   // (AArch64fcmltz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 403020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
     /* 403025 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403029 */   GIR_RootConstrainSelectedInstOperands,
     /* 403030 */   // GIR_Coverage, 5230,
     /* 403030 */   GIR_Done,
     /* 403031 */ // Label 8216: @403031
     /* 403031 */ GIM_Reject,
     /* 403032 */ // Label 8210: @403032
     /* 403032 */ GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(403062), // Rule ID 793 //
     /* 403037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403051 */   // (AArch64fcmltz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 403051 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
     /* 403056 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403060 */   GIR_RootConstrainSelectedInstOperands,
     /* 403061 */   // GIR_Coverage, 793,
     /* 403061 */   GIR_Done,
     /* 403062 */ // Label 8217: @403062
     /* 403062 */ GIM_Reject,
     /* 403063 */ // Label 8211: @403063
     /* 403063 */ GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(403093), // Rule ID 795 //
     /* 403068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 403074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403082 */   // (AArch64fcmltz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 403082 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
     /* 403087 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403091 */   GIR_RootConstrainSelectedInstOperands,
     /* 403092 */   // GIR_Coverage, 795,
     /* 403092 */   GIR_Done,
     /* 403093 */ // Label 8218: @403093
     /* 403093 */ GIM_Reject,
     /* 403094 */ // Label 8212: @403094
     /* 403094 */ GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(403124), // Rule ID 791 //
     /* 403099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403113 */   // (AArch64fcmltz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 403113 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
     /* 403118 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403122 */   GIR_RootConstrainSelectedInstOperands,
     /* 403123 */   // GIR_Coverage, 791,
     /* 403123 */   GIR_Done,
     /* 403124 */ // Label 8219: @403124
     /* 403124 */ GIM_Reject,
     /* 403125 */ // Label 8213: @403125
     /* 403125 */ GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(403155), // Rule ID 794 //
     /* 403130 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403140 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403144 */   // (AArch64fcmltz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 403144 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
     /* 403149 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403153 */   GIR_RootConstrainSelectedInstOperands,
     /* 403154 */   // GIR_Coverage, 794,
     /* 403154 */   GIR_Done,
     /* 403155 */ // Label 8220: @403155
     /* 403155 */ GIM_Reject,
     /* 403156 */ // Label 8214: @403156
     /* 403156 */ GIM_Try, /*On fail goto*//*Label 8221*/ GIMT_Encode4(403186), // Rule ID 792 //
     /* 403161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403175 */   // (AArch64fcmltz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 403175 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
     /* 403180 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 403184 */   GIR_RootConstrainSelectedInstOperands,
     /* 403185 */   // GIR_Coverage, 792,
     /* 403185 */   GIR_Done,
     /* 403186 */ // Label 8221: @403186
     /* 403186 */ GIM_Reject,
     /* 403187 */ // Label 8215: @403187
     /* 403187 */ GIM_Reject,
     /* 403188 */ // Label 136: @403188
     /* 403188 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 8226*/ GIMT_Encode4(403341),
     /* 403199 */ /*GILLT_s32*//*Label 8222*/ GIMT_Encode4(403239),
     /* 403203 */ /*GILLT_s64*//*Label 8223*/ GIMT_Encode4(403263), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 403227 */ /*GILLT_v8s8*//*Label 8224*/ GIMT_Encode4(403287), GIMT_Encode4(0),
     /* 403235 */ /*GILLT_v16s8*//*Label 8225*/ GIMT_Encode4(403314),
     /* 403239 */ // Label 8222: @403239
     /* 403239 */ GIM_Try, /*On fail goto*//*Label 8227*/ GIMT_Encode4(403262), // Rule ID 4003 //
     /* 403244 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 403247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 403251 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 403255 */   // (AArch64rev16:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 403255 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 403260 */   GIR_RootConstrainSelectedInstOperands,
     /* 403261 */   // GIR_Coverage, 4003,
     /* 403261 */   GIR_Done,
     /* 403262 */ // Label 8227: @403262
     /* 403262 */ GIM_Reject,
     /* 403263 */ // Label 8223: @403263
     /* 403263 */ GIM_Try, /*On fail goto*//*Label 8228*/ GIMT_Encode4(403286), // Rule ID 4004 //
     /* 403268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 403271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 403275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 403279 */   // (AArch64rev16:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 403279 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /* 403284 */   GIR_RootConstrainSelectedInstOperands,
     /* 403285 */   // GIR_Coverage, 4004,
     /* 403285 */   GIR_Done,
     /* 403286 */ // Label 8228: @403286
     /* 403286 */ GIM_Reject,
     /* 403287 */ // Label 8224: @403287
     /* 403287 */ GIM_Try, /*On fail goto*//*Label 8229*/ GIMT_Encode4(403313), // Rule ID 976 //
     /* 403292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 403298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403306 */   // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 403306 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 403311 */   GIR_RootConstrainSelectedInstOperands,
     /* 403312 */   // GIR_Coverage, 976,
     /* 403312 */   GIR_Done,
     /* 403313 */ // Label 8229: @403313
     /* 403313 */ GIM_Reject,
     /* 403314 */ // Label 8225: @403314
     /* 403314 */ GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(403340), // Rule ID 977 //
     /* 403319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 403325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403333 */   // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 403333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 403338 */   GIR_RootConstrainSelectedInstOperands,
     /* 403339 */   // GIR_Coverage, 977,
     /* 403339 */   GIR_Done,
     /* 403340 */ // Label 8230: @403340
     /* 403340 */ GIM_Reject,
     /* 403341 */ // Label 8226: @403341
     /* 403341 */ GIM_Reject,
     /* 403342 */ // Label 137: @403342
     /* 403342 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 8235*/ GIMT_Encode4(403517),
     /* 403353 */ /*GILLT_v4s16*//*Label 8231*/ GIMT_Encode4(403373), GIMT_Encode4(0),
     /* 403361 */ /*GILLT_v8s8*//*Label 8232*/ GIMT_Encode4(403418),
     /* 403365 */ /*GILLT_v8s16*//*Label 8233*/ GIMT_Encode4(403445),
     /* 403369 */ /*GILLT_v16s8*//*Label 8234*/ GIMT_Encode4(403490),
     /* 403373 */ // Label 8231: @403373
     /* 403373 */ GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(403417),
     /* 403378 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403385 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403389 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(403404), // Rule ID 980 //
     /* 403394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403397 */     // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 403397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 403402 */     GIR_RootConstrainSelectedInstOperands,
     /* 403403 */     // GIR_Coverage, 980,
     /* 403403 */     GIR_Done,
     /* 403404 */   // Label 8237: @403404
     /* 403404 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(403416), // Rule ID 4948 //
     /* 403409 */     // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 403409 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 403414 */     GIR_RootConstrainSelectedInstOperands,
     /* 403415 */     // GIR_Coverage, 4948,
     /* 403415 */     GIR_Done,
     /* 403416 */   // Label 8238: @403416
     /* 403416 */   GIM_Reject,
     /* 403417 */ // Label 8236: @403417
     /* 403417 */ GIM_Reject,
     /* 403418 */ // Label 8232: @403418
     /* 403418 */ GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(403444), // Rule ID 978 //
     /* 403423 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 403429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403437 */   // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 403437 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 403442 */   GIR_RootConstrainSelectedInstOperands,
     /* 403443 */   // GIR_Coverage, 978,
     /* 403443 */   GIR_Done,
     /* 403444 */ // Label 8239: @403444
     /* 403444 */ GIM_Reject,
     /* 403445 */ // Label 8233: @403445
     /* 403445 */ GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(403489),
     /* 403450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403457 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403461 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(403476), // Rule ID 981 //
     /* 403466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403469 */     // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 403469 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 403474 */     GIR_RootConstrainSelectedInstOperands,
     /* 403475 */     // GIR_Coverage, 981,
     /* 403475 */     GIR_Done,
     /* 403476 */   // Label 8241: @403476
     /* 403476 */   GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(403488), // Rule ID 4950 //
     /* 403481 */     // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 403481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 403486 */     GIR_RootConstrainSelectedInstOperands,
     /* 403487 */     // GIR_Coverage, 4950,
     /* 403487 */     GIR_Done,
     /* 403488 */   // Label 8242: @403488
     /* 403488 */   GIM_Reject,
     /* 403489 */ // Label 8240: @403489
     /* 403489 */ GIM_Reject,
     /* 403490 */ // Label 8234: @403490
     /* 403490 */ GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(403516), // Rule ID 979 //
     /* 403495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 403501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403509 */   // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 403509 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 403514 */   GIR_RootConstrainSelectedInstOperands,
     /* 403515 */   // GIR_Coverage, 979,
     /* 403515 */   GIR_Done,
     /* 403516 */ // Label 8243: @403516
     /* 403516 */ GIM_Reject,
     /* 403517 */ // Label 8235: @403517
     /* 403517 */ GIM_Reject,
     /* 403518 */ // Label 138: @403518
     /* 403518 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 8250*/ GIMT_Encode4(403791),
     /* 403529 */ /*GILLT_v2s32*//*Label 8244*/ GIMT_Encode4(403557), GIMT_Encode4(0),
     /* 403537 */ /*GILLT_v4s16*//*Label 8245*/ GIMT_Encode4(403602),
     /* 403541 */ /*GILLT_v4s32*//*Label 8246*/ GIMT_Encode4(403647),
     /* 403545 */ /*GILLT_v8s8*//*Label 8247*/ GIMT_Encode4(403692),
     /* 403549 */ /*GILLT_v8s16*//*Label 8248*/ GIMT_Encode4(403719),
     /* 403553 */ /*GILLT_v16s8*//*Label 8249*/ GIMT_Encode4(403764),
     /* 403557 */ // Label 8244: @403557
     /* 403557 */ GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(403601),
     /* 403562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403573 */   GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(403588), // Rule ID 986 //
     /* 403578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403581 */     // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 403581 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 403586 */     GIR_RootConstrainSelectedInstOperands,
     /* 403587 */     // GIR_Coverage, 986,
     /* 403587 */     GIR_Done,
     /* 403588 */   // Label 8252: @403588
     /* 403588 */   GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(403600), // Rule ID 4952 //
     /* 403593 */     // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 403593 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 403598 */     GIR_RootConstrainSelectedInstOperands,
     /* 403599 */     // GIR_Coverage, 4952,
     /* 403599 */     GIR_Done,
     /* 403600 */   // Label 8253: @403600
     /* 403600 */   GIM_Reject,
     /* 403601 */ // Label 8251: @403601
     /* 403601 */ GIM_Reject,
     /* 403602 */ // Label 8245: @403602
     /* 403602 */ GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(403646),
     /* 403607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403610 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403614 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403618 */   GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(403633), // Rule ID 984 //
     /* 403623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403626 */     // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 403626 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 403631 */     GIR_RootConstrainSelectedInstOperands,
     /* 403632 */     // GIR_Coverage, 984,
     /* 403632 */     GIR_Done,
     /* 403633 */   // Label 8255: @403633
     /* 403633 */   GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(403645), // Rule ID 4949 //
     /* 403638 */     // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 403638 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 403643 */     GIR_RootConstrainSelectedInstOperands,
     /* 403644 */     // GIR_Coverage, 4949,
     /* 403644 */     GIR_Done,
     /* 403645 */   // Label 8256: @403645
     /* 403645 */   GIM_Reject,
     /* 403646 */ // Label 8254: @403646
     /* 403646 */ GIM_Reject,
     /* 403647 */ // Label 8246: @403647
     /* 403647 */ GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(403691),
     /* 403652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403659 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403663 */   GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(403678), // Rule ID 987 //
     /* 403668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403671 */     // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 403671 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 403676 */     GIR_RootConstrainSelectedInstOperands,
     /* 403677 */     // GIR_Coverage, 987,
     /* 403677 */     GIR_Done,
     /* 403678 */   // Label 8258: @403678
     /* 403678 */   GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(403690), // Rule ID 4953 //
     /* 403683 */     // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 403683 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 403688 */     GIR_RootConstrainSelectedInstOperands,
     /* 403689 */     // GIR_Coverage, 4953,
     /* 403689 */     GIR_Done,
     /* 403690 */   // Label 8259: @403690
     /* 403690 */   GIM_Reject,
     /* 403691 */ // Label 8257: @403691
     /* 403691 */ GIM_Reject,
     /* 403692 */ // Label 8247: @403692
     /* 403692 */ GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(403718), // Rule ID 982 //
     /* 403697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 403703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403711 */   // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 403711 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 403716 */   GIR_RootConstrainSelectedInstOperands,
     /* 403717 */   // GIR_Coverage, 982,
     /* 403717 */   GIR_Done,
     /* 403718 */ // Label 8260: @403718
     /* 403718 */ GIM_Reject,
     /* 403719 */ // Label 8248: @403719
     /* 403719 */ GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(403763),
     /* 403724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403735 */   GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(403750), // Rule ID 985 //
     /* 403740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403743 */     // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 403743 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 403748 */     GIR_RootConstrainSelectedInstOperands,
     /* 403749 */     // GIR_Coverage, 985,
     /* 403749 */     GIR_Done,
     /* 403750 */   // Label 8262: @403750
     /* 403750 */   GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(403762), // Rule ID 4951 //
     /* 403755 */     // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 403755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 403760 */     GIR_RootConstrainSelectedInstOperands,
     /* 403761 */     // GIR_Coverage, 4951,
     /* 403761 */     GIR_Done,
     /* 403762 */   // Label 8263: @403762
     /* 403762 */   GIM_Reject,
     /* 403763 */ // Label 8261: @403763
     /* 403763 */ GIM_Reject,
     /* 403764 */ // Label 8249: @403764
     /* 403764 */ GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(403790), // Rule ID 983 //
     /* 403769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 403775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403783 */   // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 403783 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 403788 */   GIR_RootConstrainSelectedInstOperands,
     /* 403789 */   // GIR_Coverage, 983,
     /* 403789 */   GIR_Done,
     /* 403790 */ // Label 8264: @403790
     /* 403790 */ GIM_Reject,
     /* 403791 */ // Label 8250: @403791
     /* 403791 */ GIM_Reject,
     /* 403792 */ // Label 139: @403792
     /* 403792 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8271*/ GIMT_Encode4(403997),
     /* 403803 */ /*GILLT_s64*//*Label 8265*/ GIMT_Encode4(403835), GIMT_Encode4(0),
     /* 403811 */ /*GILLT_v2s32*//*Label 8266*/ GIMT_Encode4(403862),
     /* 403815 */ /*GILLT_v2s64*//*Label 8267*/ GIMT_Encode4(403889),
     /* 403819 */ /*GILLT_v4s16*//*Label 8268*/ GIMT_Encode4(403916),
     /* 403823 */ /*GILLT_v4s32*//*Label 8269*/ GIMT_Encode4(403943), GIMT_Encode4(0),
     /* 403831 */ /*GILLT_v8s16*//*Label 8270*/ GIMT_Encode4(403970),
     /* 403835 */ // Label 8265: @403835
     /* 403835 */ GIM_Try, /*On fail goto*//*Label 8272*/ GIMT_Encode4(403861), // Rule ID 1008 //
     /* 403840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 403846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403854 */   // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 403854 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 403859 */   GIR_RootConstrainSelectedInstOperands,
     /* 403860 */   // GIR_Coverage, 1008,
     /* 403860 */   GIR_Done,
     /* 403861 */ // Label 8272: @403861
     /* 403861 */ GIM_Reject,
     /* 403862 */ // Label 8266: @403862
     /* 403862 */ GIM_Try, /*On fail goto*//*Label 8273*/ GIMT_Encode4(403888), // Rule ID 1004 //
     /* 403867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 403873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403881 */   // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 403881 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 403886 */   GIR_RootConstrainSelectedInstOperands,
     /* 403887 */   // GIR_Coverage, 1004,
     /* 403887 */   GIR_Done,
     /* 403888 */ // Label 8273: @403888
     /* 403888 */ GIM_Reject,
     /* 403889 */ // Label 8267: @403889
     /* 403889 */ GIM_Try, /*On fail goto*//*Label 8274*/ GIMT_Encode4(403915), // Rule ID 1010 //
     /* 403894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 403900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403908 */   // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 403908 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 403913 */   GIR_RootConstrainSelectedInstOperands,
     /* 403914 */   // GIR_Coverage, 1010,
     /* 403914 */   GIR_Done,
     /* 403915 */ // Label 8274: @403915
     /* 403915 */ GIM_Reject,
     /* 403916 */ // Label 8268: @403916
     /* 403916 */ GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(403942), // Rule ID 1000 //
     /* 403921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 403927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 403935 */   // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 403935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 403940 */   GIR_RootConstrainSelectedInstOperands,
     /* 403941 */   // GIR_Coverage, 1000,
     /* 403941 */   GIR_Done,
     /* 403942 */ // Label 8275: @403942
     /* 403942 */ GIM_Reject,
     /* 403943 */ // Label 8269: @403943
     /* 403943 */ GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(403969), // Rule ID 1006 //
     /* 403948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403958 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403962 */   // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 403962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 403967 */   GIR_RootConstrainSelectedInstOperands,
     /* 403968 */   // GIR_Coverage, 1006,
     /* 403968 */   GIR_Done,
     /* 403969 */ // Label 8276: @403969
     /* 403969 */ GIM_Reject,
     /* 403970 */ // Label 8270: @403970
     /* 403970 */ GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(403996), // Rule ID 1002 //
     /* 403975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 403978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 403981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403989 */   // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 403989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 403994 */   GIR_RootConstrainSelectedInstOperands,
     /* 403995 */   // GIR_Coverage, 1002,
     /* 403995 */   GIR_Done,
     /* 403996 */ // Label 8277: @403996
     /* 403996 */ GIM_Reject,
     /* 403997 */ // Label 8271: @403997
     /* 403997 */ GIM_Reject,
     /* 403998 */ // Label 140: @403998
     /* 403998 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8280*/ GIMT_Encode4(404396),
     /* 404009 */ /*GILLT_v2s64*//*Label 8278*/ GIMT_Encode4(404021), GIMT_Encode4(0),
     /* 404017 */ /*GILLT_v4s32*//*Label 8279*/ GIMT_Encode4(404159),
     /* 404021 */ // Label 8278: @404021
     /* 404021 */ GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(404080), // Rule ID 5839 //
     /* 404026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404037 */   // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 404037 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 404040 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 404044 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404049 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 404053 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 404055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 404058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404060 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404063 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404066 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 404069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404074 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404079 */   // GIR_Coverage, 5839,
     /* 404079 */   GIR_EraseRootFromParent_Done,
     /* 404080 */ // Label 8281: @404080
     /* 404080 */ GIM_Try, /*On fail goto*//*Label 8282*/ GIMT_Encode4(404158), // Rule ID 5961 //
     /* 404085 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 404088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404092 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404096 */   // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 404096 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 404099 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 404103 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404108 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 404112 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 404114 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 404117 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 404121 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404126 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 404128 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 404131 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404133 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 404139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 404142 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404147 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404152 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404157 */   // GIR_Coverage, 5961,
     /* 404157 */   GIR_EraseRootFromParent_Done,
     /* 404158 */ // Label 8282: @404158
     /* 404158 */ GIM_Reject,
     /* 404159 */ // Label 8279: @404159
     /* 404159 */ GIM_Try, /*On fail goto*//*Label 8283*/ GIMT_Encode4(404218), // Rule ID 5835 //
     /* 404164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 404167 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404171 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404175 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 404175 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404178 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 404182 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404187 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 404191 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 404193 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 404196 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404198 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404201 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404204 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 404207 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404212 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404217 */   // GIR_Coverage, 5835,
     /* 404217 */   GIR_EraseRootFromParent_Done,
     /* 404218 */ // Label 8283: @404218
     /* 404218 */ GIM_Try, /*On fail goto*//*Label 8284*/ GIMT_Encode4(404277), // Rule ID 5836 //
     /* 404223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 404226 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404230 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404234 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 404234 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404237 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 404241 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404246 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 404250 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 404252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 404255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404257 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404260 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404263 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 404266 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404271 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404276 */   // GIR_Coverage, 5836,
     /* 404276 */   GIR_EraseRootFromParent_Done,
     /* 404277 */ // Label 8284: @404277
     /* 404277 */ GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(404336), // Rule ID 5837 //
     /* 404282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 404285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404293 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 404293 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404296 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 404300 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404305 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 404309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 404311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 404314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404316 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404319 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 404325 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404330 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404335 */   // GIR_Coverage, 5837,
     /* 404335 */   GIR_EraseRootFromParent_Done,
     /* 404336 */ // Label 8285: @404336
     /* 404336 */ GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(404395), // Rule ID 5838 //
     /* 404341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404352 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 404352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 404359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404364 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 404368 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 404370 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 404373 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404375 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 404378 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404381 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 404384 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404389 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404394 */   // GIR_Coverage, 5838,
     /* 404394 */   GIR_EraseRootFromParent_Done,
     /* 404395 */ // Label 8286: @404395
     /* 404395 */ GIM_Reject,
     /* 404396 */ // Label 8280: @404396
     /* 404396 */ GIM_Reject,
     /* 404397 */ // Label 141: @404397
     /* 404397 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8291*/ GIMT_Encode4(404766),
     /* 404408 */ /*GILLT_v2s32*//*Label 8287*/ GIMT_Encode4(404468), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 404420 */ /*GILLT_v4s32*//*Label 8288*/ GIMT_Encode4(404588), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 404452 */ /*GILLT_nxv2s64*//*Label 8289*/ GIMT_Encode4(404708), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 404464 */ /*GILLT_nxv4s32*//*Label 8290*/ GIMT_Encode4(404737),
     /* 404468 */ // Label 8287: @404468
     /* 404468 */ GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(404587),
     /* 404473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 404476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 404479 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 404482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404486 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404490 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404494 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(404567), // Rule ID 26 //
     /* 404499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 404502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 404510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 404514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404522 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404526 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404543 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404547 */     // MIs[3] Operand 1
     /* 404547 */     // No operand predicates
     /* 404547 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404549 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
     /* 404552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404554 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 404556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404565 */     GIR_RootConstrainSelectedInstOperands,
     /* 404566 */     // GIR_Coverage, 26,
     /* 404566 */     GIR_EraseRootFromParent_Done,
     /* 404567 */   // Label 8293: @404567
     /* 404567 */   GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(404586), // Rule ID 22 //
     /* 404572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 404575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404579 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 404579 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
     /* 404584 */     GIR_RootConstrainSelectedInstOperands,
     /* 404585 */     // GIR_Coverage, 22,
     /* 404585 */     GIR_Done,
     /* 404586 */   // Label 8294: @404586
     /* 404586 */   GIM_Reject,
     /* 404587 */ // Label 8292: @404587
     /* 404587 */ GIM_Reject,
     /* 404588 */ // Label 8288: @404588
     /* 404588 */ GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(404707),
     /* 404593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404596 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 404599 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 404602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404610 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404614 */   GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(404687), // Rule ID 27 //
     /* 404619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 404622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 404630 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404642 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404646 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404650 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404655 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404659 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404663 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404667 */     // MIs[3] Operand 1
     /* 404667 */     // No operand predicates
     /* 404667 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404669 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 404669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
     /* 404672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 404676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404678 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404682 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404685 */     GIR_RootConstrainSelectedInstOperands,
     /* 404686 */     // GIR_Coverage, 27,
     /* 404686 */     GIR_EraseRootFromParent_Done,
     /* 404687 */   // Label 8296: @404687
     /* 404687 */   GIM_Try, /*On fail goto*//*Label 8297*/ GIMT_Encode4(404706), // Rule ID 23 //
     /* 404692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 404695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404699 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 404699 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
     /* 404704 */     GIR_RootConstrainSelectedInstOperands,
     /* 404705 */     // GIR_Coverage, 23,
     /* 404705 */     GIR_Done,
     /* 404706 */   // Label 8297: @404706
     /* 404706 */   GIM_Reject,
     /* 404707 */ // Label 8295: @404707
     /* 404707 */ GIM_Reject,
     /* 404708 */ // Label 8289: @404708
     /* 404708 */ GIM_Try, /*On fail goto*//*Label 8298*/ GIMT_Encode4(404736), // Rule ID 2984 //
     /* 404713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 404719 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 404722 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 404725 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 404729 */   // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 404729 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
     /* 404734 */   GIR_RootConstrainSelectedInstOperands,
     /* 404735 */   // GIR_Coverage, 2984,
     /* 404735 */   GIR_Done,
     /* 404736 */ // Label 8298: @404736
     /* 404736 */ GIM_Reject,
     /* 404737 */ // Label 8290: @404737
     /* 404737 */ GIM_Try, /*On fail goto*//*Label 8299*/ GIMT_Encode4(404765), // Rule ID 2983 //
     /* 404742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 404745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 404748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 404751 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 404754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 404758 */   // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 404758 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
     /* 404763 */   GIR_RootConstrainSelectedInstOperands,
     /* 404764 */   // GIR_Coverage, 2983,
     /* 404764 */   GIR_Done,
     /* 404765 */ // Label 8299: @404765
     /* 404765 */ GIM_Reject,
     /* 404766 */ // Label 8291: @404766
     /* 404766 */ GIM_Reject,
     /* 404767 */ // Label 142: @404767
     /* 404767 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8303*/ GIMT_Encode4(404883),
     /* 404778 */ /*GILLT_s16*//*Label 8300*/ GIMT_Encode4(404790),
     /* 404782 */ /*GILLT_s32*//*Label 8301*/ GIMT_Encode4(404821),
     /* 404786 */ /*GILLT_s64*//*Label 8302*/ GIMT_Encode4(404852),
     /* 404790 */ // Label 8300: @404790
     /* 404790 */ GIM_Try, /*On fail goto*//*Label 8304*/ GIMT_Encode4(404820), // Rule ID 1658 //
     /* 404795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 404798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 404801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404809 */   // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 404809 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 404814 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404818 */   GIR_RootConstrainSelectedInstOperands,
     /* 404819 */   // GIR_Coverage, 1658,
     /* 404819 */   GIR_Done,
     /* 404820 */ // Label 8304: @404820
     /* 404820 */ GIM_Reject,
     /* 404821 */ // Label 8301: @404821
     /* 404821 */ GIM_Try, /*On fail goto*//*Label 8305*/ GIMT_Encode4(404851), // Rule ID 1657 //
     /* 404826 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 404829 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 404832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404836 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404840 */   // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 404840 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 404845 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404849 */   GIR_RootConstrainSelectedInstOperands,
     /* 404850 */   // GIR_Coverage, 1657,
     /* 404850 */   GIR_Done,
     /* 404851 */ // Label 8305: @404851
     /* 404851 */ GIM_Reject,
     /* 404852 */ // Label 8302: @404852
     /* 404852 */ GIM_Try, /*On fail goto*//*Label 8306*/ GIMT_Encode4(404882), // Rule ID 1656 //
     /* 404857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 404860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 404863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 404871 */   // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 404871 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 404876 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404880 */   GIR_RootConstrainSelectedInstOperands,
     /* 404881 */   // GIR_Coverage, 1656,
     /* 404881 */   GIR_Done,
     /* 404882 */ // Label 8306: @404882
     /* 404882 */ GIM_Reject,
     /* 404883 */ // Label 8303: @404883
     /* 404883 */ GIM_Reject,
     /* 404884 */ // Label 143: @404884
     /* 404884 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8310*/ GIMT_Encode4(406116),
     /* 404895 */ /*GILLT_v2s64*//*Label 8307*/ GIMT_Encode4(404915), GIMT_Encode4(0),
     /* 404903 */ /*GILLT_v4s32*//*Label 8308*/ GIMT_Encode4(405476), GIMT_Encode4(0),
     /* 404911 */ /*GILLT_v8s16*//*Label 8309*/ GIMT_Encode4(406037),
     /* 404915 */ // Label 8307: @404915
     /* 404915 */ GIM_Try, /*On fail goto*//*Label 8311*/ GIMT_Encode4(405475),
     /* 404920 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 404923 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 404926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404930 */   GIM_Try, /*On fail goto*//*Label 8312*/ GIMT_Encode4(405022), // Rule ID 2054 //
     /* 404935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404938 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404942 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 404946 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404950 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404954 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 404958 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404962 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404966 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404971 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 404975 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404979 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 404983 */     // MIs[3] Operand 1
     /* 404983 */     // No operand predicates
     /* 404983 */     // MIs[1] Operand 2
     /* 404983 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 404994 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404996 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 405003 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 405006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405008 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 405013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405017 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405020 */     GIR_RootConstrainSelectedInstOperands,
     /* 405021 */     // GIR_Coverage, 2054,
     /* 405021 */     GIR_EraseRootFromParent_Done,
     /* 405022 */   // Label 8312: @405022
     /* 405022 */   GIM_Try, /*On fail goto*//*Label 8313*/ GIMT_Encode4(405114), // Rule ID 13432 //
     /* 405027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 405038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 405050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405054 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405058 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405063 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405067 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405071 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405075 */     // MIs[3] Operand 1
     /* 405075 */     // No operand predicates
     /* 405075 */     // MIs[1] Operand 2
     /* 405075 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 405086 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405088 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 405095 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 405098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 405105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405112 */     GIR_RootConstrainSelectedInstOperands,
     /* 405113 */     // GIR_Coverage, 13432,
     /* 405113 */     GIR_EraseRootFromParent_Done,
     /* 405114 */   // Label 8313: @405114
     /* 405114 */   GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(405200), // Rule ID 13430 //
     /* 405119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 405130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 405142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405146 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405150 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405159 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405163 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405167 */     // MIs[3] Operand 1
     /* 405167 */     // No operand predicates
     /* 405167 */     // MIs[1] Operand 2
     /* 405167 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 405178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405182 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405184 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 405187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405198 */     GIR_RootConstrainSelectedInstOperands,
     /* 405199 */     // GIR_Coverage, 13430,
     /* 405199 */     GIR_EraseRootFromParent_Done,
     /* 405200 */   // Label 8314: @405200
     /* 405200 */   GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(405286), // Rule ID 2052 //
     /* 405205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 405220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405224 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405228 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 405232 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405236 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405240 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405249 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405253 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405257 */     // MIs[3] Operand 1
     /* 405257 */     // No operand predicates
     /* 405257 */     // MIs[1] Operand 2
     /* 405257 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 405268 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405270 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 405273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405284 */     GIR_RootConstrainSelectedInstOperands,
     /* 405285 */     // GIR_Coverage, 2052,
     /* 405285 */     GIR_EraseRootFromParent_Done,
     /* 405286 */   // Label 8315: @405286
     /* 405286 */   GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(405325), // Rule ID 1741 //
     /* 405291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 405301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 405308 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 405308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 405311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 405318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 405323 */     GIR_RootConstrainSelectedInstOperands,
     /* 405324 */     // GIR_Coverage, 1741,
     /* 405324 */     GIR_EraseRootFromParent_Done,
     /* 405325 */   // Label 8316: @405325
     /* 405325 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(405388), // Rule ID 13431 //
     /* 405330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 405341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405362 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405366 */     // MIs[2] Operand 1
     /* 405366 */     // No operand predicates
     /* 405366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405372 */     // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 405375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405383 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405386 */     GIR_RootConstrainSelectedInstOperands,
     /* 405387 */     // GIR_Coverage, 13431,
     /* 405387 */     GIR_EraseRootFromParent_Done,
     /* 405388 */   // Label 8317: @405388
     /* 405388 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(405451), // Rule ID 2053 //
     /* 405393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 405408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405429 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405433 */     // MIs[2] Operand 1
     /* 405433 */     // No operand predicates
     /* 405433 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405435 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 405438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405446 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405449 */     GIR_RootConstrainSelectedInstOperands,
     /* 405450 */     // GIR_Coverage, 2053,
     /* 405450 */     GIR_EraseRootFromParent_Done,
     /* 405451 */   // Label 8318: @405451
     /* 405451 */   GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(405474), // Rule ID 1740 //
     /* 405456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405467 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 405467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 405472 */     GIR_RootConstrainSelectedInstOperands,
     /* 405473 */     // GIR_Coverage, 1740,
     /* 405473 */     GIR_Done,
     /* 405474 */   // Label 8319: @405474
     /* 405474 */   GIM_Reject,
     /* 405475 */ // Label 8311: @405475
     /* 405475 */ GIM_Reject,
     /* 405476 */ // Label 8308: @405476
     /* 405476 */ GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(406036),
     /* 405481 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 405484 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 405487 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405491 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(405583), // Rule ID 2051 //
     /* 405496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 405507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 405519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405532 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405536 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405540 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405544 */     // MIs[3] Operand 1
     /* 405544 */     // No operand predicates
     /* 405544 */     // MIs[1] Operand 2
     /* 405544 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 405555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405557 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 405564 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 405567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 405574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405578 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405581 */     GIR_RootConstrainSelectedInstOperands,
     /* 405582 */     // GIR_Coverage, 2051,
     /* 405582 */     GIR_EraseRootFromParent_Done,
     /* 405583 */   // Label 8321: @405583
     /* 405583 */   GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(405675), // Rule ID 13429 //
     /* 405588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 405599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405607 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 405611 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405615 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405619 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405628 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405632 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405636 */     // MIs[3] Operand 1
     /* 405636 */     // No operand predicates
     /* 405636 */     // MIs[1] Operand 2
     /* 405636 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 405647 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405649 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 405656 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 405659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 405666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405673 */     GIR_RootConstrainSelectedInstOperands,
     /* 405674 */     // GIR_Coverage, 13429,
     /* 405674 */     GIR_EraseRootFromParent_Done,
     /* 405675 */   // Label 8322: @405675
     /* 405675 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(405761), // Rule ID 13427 //
     /* 405680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 405691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 405703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405711 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405716 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405720 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405724 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405728 */     // MIs[3] Operand 1
     /* 405728 */     // No operand predicates
     /* 405728 */     // MIs[1] Operand 2
     /* 405728 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 405739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405745 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 405748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405756 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405759 */     GIR_RootConstrainSelectedInstOperands,
     /* 405760 */     // GIR_Coverage, 13427,
     /* 405760 */     GIR_EraseRootFromParent_Done,
     /* 405761 */   // Label 8323: @405761
     /* 405761 */   GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(405847), // Rule ID 2049 //
     /* 405766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 405781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 405793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405814 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405818 */     // MIs[3] Operand 1
     /* 405818 */     // No operand predicates
     /* 405818 */     // MIs[1] Operand 2
     /* 405818 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 405829 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405831 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 405834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 405838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405845 */     GIR_RootConstrainSelectedInstOperands,
     /* 405846 */     // GIR_Coverage, 2049,
     /* 405846 */     GIR_EraseRootFromParent_Done,
     /* 405847 */   // Label 8324: @405847
     /* 405847 */   GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(405886), // Rule ID 1739 //
     /* 405852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405855 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 405862 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 405869 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 405869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 405872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 405879 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 405884 */     GIR_RootConstrainSelectedInstOperands,
     /* 405885 */     // GIR_Coverage, 1739,
     /* 405885 */     GIR_EraseRootFromParent_Done,
     /* 405886 */   // Label 8325: @405886
     /* 405886 */   GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(405949), // Rule ID 13428 //
     /* 405891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 405902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405906 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405910 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405915 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405919 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405923 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405927 */     // MIs[2] Operand 1
     /* 405927 */     // No operand predicates
     /* 405927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405931 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405933 */     // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 405936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 405940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405944 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405947 */     GIR_RootConstrainSelectedInstOperands,
     /* 405948 */     // GIR_Coverage, 13428,
     /* 405948 */     GIR_EraseRootFromParent_Done,
     /* 405949 */   // Label 8326: @405949
     /* 405949 */   GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(406012), // Rule ID 2050 //
     /* 405954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 405961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 405965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 405969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 405973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 405982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405990 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 405994 */     // MIs[2] Operand 1
     /* 405994 */     // No operand predicates
     /* 405994 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405996 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 405996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 405999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 406007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 406010 */     GIR_RootConstrainSelectedInstOperands,
     /* 406011 */     // GIR_Coverage, 2050,
     /* 406011 */     GIR_EraseRootFromParent_Done,
     /* 406012 */   // Label 8327: @406012
     /* 406012 */   GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(406035), // Rule ID 1738 //
     /* 406017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406028 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 406028 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 406033 */     GIR_RootConstrainSelectedInstOperands,
     /* 406034 */     // GIR_Coverage, 1738,
     /* 406034 */     GIR_Done,
     /* 406035 */   // Label 8328: @406035
     /* 406035 */   GIM_Reject,
     /* 406036 */ // Label 8320: @406036
     /* 406036 */ GIM_Reject,
     /* 406037 */ // Label 8309: @406037
     /* 406037 */ GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(406115),
     /* 406042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 406045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 406048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406052 */   GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(406091), // Rule ID 1737 //
     /* 406057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406060 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 406067 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 406074 */     // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 406074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 406077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406079 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 406084 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 406089 */     GIR_RootConstrainSelectedInstOperands,
     /* 406090 */     // GIR_Coverage, 1737,
     /* 406090 */     GIR_EraseRootFromParent_Done,
     /* 406091 */   // Label 8330: @406091
     /* 406091 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(406114), // Rule ID 1736 //
     /* 406096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406107 */     // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 406107 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 406112 */     GIR_RootConstrainSelectedInstOperands,
     /* 406113 */     // GIR_Coverage, 1736,
     /* 406113 */     GIR_Done,
     /* 406114 */   // Label 8331: @406114
     /* 406114 */   GIM_Reject,
     /* 406115 */ // Label 8329: @406115
     /* 406115 */ GIM_Reject,
     /* 406116 */ // Label 8310: @406116
     /* 406116 */ GIM_Reject,
     /* 406117 */ // Label 144: @406117
     /* 406117 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8350*/ GIMT_Encode4(406896),
     /* 406128 */ /*GILLT_v2s32*//*Label 8332*/ GIMT_Encode4(406204),
     /* 406132 */ /*GILLT_v2s64*//*Label 8333*/ GIMT_Encode4(406259),
     /* 406136 */ /*GILLT_v4s16*//*Label 8334*/ GIMT_Encode4(406314),
     /* 406140 */ /*GILLT_v4s32*//*Label 8335*/ GIMT_Encode4(406369),
     /* 406144 */ /*GILLT_v8s8*//*Label 8336*/ GIMT_Encode4(406424),
     /* 406148 */ /*GILLT_v8s16*//*Label 8337*/ GIMT_Encode4(406458),
     /* 406152 */ /*GILLT_v16s8*//*Label 8338*/ GIMT_Encode4(406513), GIMT_Encode4(0),
     /* 406160 */ /*GILLT_nxv2s1*//*Label 8339*/ GIMT_Encode4(406547),
     /* 406164 */ /*GILLT_nxv2s16*//*Label 8340*/ GIMT_Encode4(406573),
     /* 406168 */ /*GILLT_nxv2s32*//*Label 8341*/ GIMT_Encode4(406599),
     /* 406172 */ /*GILLT_nxv2s64*//*Label 8342*/ GIMT_Encode4(406625),
     /* 406176 */ /*GILLT_nxv4s1*//*Label 8343*/ GIMT_Encode4(406672),
     /* 406180 */ /*GILLT_nxv4s16*//*Label 8344*/ GIMT_Encode4(406698),
     /* 406184 */ /*GILLT_nxv4s32*//*Label 8345*/ GIMT_Encode4(406724),
     /* 406188 */ /*GILLT_nxv8s1*//*Label 8346*/ GIMT_Encode4(406771),
     /* 406192 */ /*GILLT_nxv8s16*//*Label 8347*/ GIMT_Encode4(406797),
     /* 406196 */ /*GILLT_nxv16s1*//*Label 8348*/ GIMT_Encode4(406844),
     /* 406200 */ /*GILLT_nxv16s8*//*Label 8349*/ GIMT_Encode4(406870),
     /* 406204 */ // Label 8332: @406204
     /* 406204 */ GIM_Try, /*On fail goto*//*Label 8351*/ GIMT_Encode4(406258),
     /* 406209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 406212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 406215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406219 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406223 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406227 */   GIM_Try, /*On fail goto*//*Label 8352*/ GIMT_Encode4(406242), // Rule ID 1874 //
     /* 406232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406235 */     // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 406235 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 406240 */     GIR_RootConstrainSelectedInstOperands,
     /* 406241 */     // GIR_Coverage, 1874,
     /* 406241 */     GIR_Done,
     /* 406242 */   // Label 8352: @406242
     /* 406242 */   GIM_Try, /*On fail goto*//*Label 8353*/ GIMT_Encode4(406257), // Rule ID 2503 //
     /* 406247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406250 */     // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 406250 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 406255 */     GIR_RootConstrainSelectedInstOperands,
     /* 406256 */     // GIR_Coverage, 2503,
     /* 406256 */     GIR_Done,
     /* 406257 */   // Label 8353: @406257
     /* 406257 */   GIM_Reject,
     /* 406258 */ // Label 8351: @406258
     /* 406258 */ GIM_Reject,
     /* 406259 */ // Label 8333: @406259
     /* 406259 */ GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(406313),
     /* 406264 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 406267 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 406270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406278 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406282 */   GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(406297), // Rule ID 1876 //
     /* 406287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406290 */     // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 406290 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 406295 */     GIR_RootConstrainSelectedInstOperands,
     /* 406296 */     // GIR_Coverage, 1876,
     /* 406296 */     GIR_Done,
     /* 406297 */   // Label 8355: @406297
     /* 406297 */   GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(406312), // Rule ID 2505 //
     /* 406302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406305 */     // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 406305 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 406310 */     GIR_RootConstrainSelectedInstOperands,
     /* 406311 */     // GIR_Coverage, 2505,
     /* 406311 */     GIR_Done,
     /* 406312 */   // Label 8356: @406312
     /* 406312 */   GIM_Reject,
     /* 406313 */ // Label 8354: @406313
     /* 406313 */ GIM_Reject,
     /* 406314 */ // Label 8334: @406314
     /* 406314 */ GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(406368),
     /* 406319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 406322 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 406325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406333 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406337 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(406352), // Rule ID 1872 //
     /* 406342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406345 */     // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 406345 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 406350 */     GIR_RootConstrainSelectedInstOperands,
     /* 406351 */     // GIR_Coverage, 1872,
     /* 406351 */     GIR_Done,
     /* 406352 */   // Label 8358: @406352
     /* 406352 */   GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(406367), // Rule ID 2501 //
     /* 406357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406360 */     // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 406360 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 406365 */     GIR_RootConstrainSelectedInstOperands,
     /* 406366 */     // GIR_Coverage, 2501,
     /* 406366 */     GIR_Done,
     /* 406367 */   // Label 8359: @406367
     /* 406367 */   GIM_Reject,
     /* 406368 */ // Label 8357: @406368
     /* 406368 */ GIM_Reject,
     /* 406369 */ // Label 8335: @406369
     /* 406369 */ GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(406423),
     /* 406374 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406377 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 406380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406388 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406392 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(406407), // Rule ID 1875 //
     /* 406397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406400 */     // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 406400 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 406405 */     GIR_RootConstrainSelectedInstOperands,
     /* 406406 */     // GIR_Coverage, 1875,
     /* 406406 */     GIR_Done,
     /* 406407 */   // Label 8361: @406407
     /* 406407 */   GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(406422), // Rule ID 2504 //
     /* 406412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406415 */     // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 406415 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 406420 */     GIR_RootConstrainSelectedInstOperands,
     /* 406421 */     // GIR_Coverage, 2504,
     /* 406421 */     GIR_Done,
     /* 406422 */   // Label 8362: @406422
     /* 406422 */   GIM_Reject,
     /* 406423 */ // Label 8360: @406423
     /* 406423 */ GIM_Reject,
     /* 406424 */ // Label 8336: @406424
     /* 406424 */ GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(406457), // Rule ID 1870 //
     /* 406429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 406435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 406438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406446 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406450 */   // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 406450 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
     /* 406455 */   GIR_RootConstrainSelectedInstOperands,
     /* 406456 */   // GIR_Coverage, 1870,
     /* 406456 */   GIR_Done,
     /* 406457 */ // Label 8363: @406457
     /* 406457 */ GIM_Reject,
     /* 406458 */ // Label 8337: @406458
     /* 406458 */ GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(406512),
     /* 406463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 406466 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 406469 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406473 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406477 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406481 */   GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(406496), // Rule ID 1873 //
     /* 406486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406489 */     // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 406489 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 406494 */     GIR_RootConstrainSelectedInstOperands,
     /* 406495 */     // GIR_Coverage, 1873,
     /* 406495 */     GIR_Done,
     /* 406496 */   // Label 8365: @406496
     /* 406496 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(406511), // Rule ID 2502 //
     /* 406501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406504 */     // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 406504 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 406509 */     GIR_RootConstrainSelectedInstOperands,
     /* 406510 */     // GIR_Coverage, 2502,
     /* 406510 */     GIR_Done,
     /* 406511 */   // Label 8366: @406511
     /* 406511 */   GIM_Reject,
     /* 406512 */ // Label 8364: @406512
     /* 406512 */ GIM_Reject,
     /* 406513 */ // Label 8338: @406513
     /* 406513 */ GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(406546), // Rule ID 1871 //
     /* 406518 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 406524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 406527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406531 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406535 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406539 */   // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 406539 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
     /* 406544 */   GIR_RootConstrainSelectedInstOperands,
     /* 406545 */   // GIR_Coverage, 1871,
     /* 406545 */   GIR_Done,
     /* 406546 */ // Label 8367: @406546
     /* 406546 */ GIM_Reject,
     /* 406547 */ // Label 8339: @406547
     /* 406547 */ GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(406572), // Rule ID 8916 //
     /* 406552 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406555 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 406558 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 406561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406565 */   // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 406565 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 406570 */   GIR_RootConstrainSelectedInstOperands,
     /* 406571 */   // GIR_Coverage, 8916,
     /* 406571 */   GIR_Done,
     /* 406572 */ // Label 8368: @406572
     /* 406572 */ GIM_Reject,
     /* 406573 */ // Label 8340: @406573
     /* 406573 */ GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(406598), // Rule ID 8892 //
     /* 406578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 406584 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 406587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406591 */   // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 406591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 406596 */   GIR_RootConstrainSelectedInstOperands,
     /* 406597 */   // GIR_Coverage, 8892,
     /* 406597 */   GIR_Done,
     /* 406598 */ // Label 8369: @406598
     /* 406598 */ GIM_Reject,
     /* 406599 */ // Label 8341: @406599
     /* 406599 */ GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(406624), // Rule ID 8893 //
     /* 406604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 406610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 406613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406617 */   // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 406617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 406622 */   GIR_RootConstrainSelectedInstOperands,
     /* 406623 */   // GIR_Coverage, 8893,
     /* 406623 */   GIR_Done,
     /* 406624 */ // Label 8370: @406624
     /* 406624 */ GIM_Reject,
     /* 406625 */ // Label 8342: @406625
     /* 406625 */ GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(406671),
     /* 406630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 406633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 406636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406640 */   GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(406655), // Rule ID 8888 //
     /* 406645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406648 */     // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 406648 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 406653 */     GIR_RootConstrainSelectedInstOperands,
     /* 406654 */     // GIR_Coverage, 8888,
     /* 406654 */     GIR_Done,
     /* 406655 */   // Label 8372: @406655
     /* 406655 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(406670), // Rule ID 8894 //
     /* 406660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406663 */     // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 406663 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 406668 */     GIR_RootConstrainSelectedInstOperands,
     /* 406669 */     // GIR_Coverage, 8894,
     /* 406669 */     GIR_Done,
     /* 406670 */   // Label 8373: @406670
     /* 406670 */   GIM_Reject,
     /* 406671 */ // Label 8371: @406671
     /* 406671 */ GIM_Reject,
     /* 406672 */ // Label 8343: @406672
     /* 406672 */ GIM_Try, /*On fail goto*//*Label 8374*/ GIMT_Encode4(406697), // Rule ID 8915 //
     /* 406677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 406683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 406686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406690 */   // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 406690 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 406695 */   GIR_RootConstrainSelectedInstOperands,
     /* 406696 */   // GIR_Coverage, 8915,
     /* 406696 */   GIR_Done,
     /* 406697 */ // Label 8374: @406697
     /* 406697 */ GIM_Reject,
     /* 406698 */ // Label 8344: @406698
     /* 406698 */ GIM_Try, /*On fail goto*//*Label 8375*/ GIMT_Encode4(406723), // Rule ID 8890 //
     /* 406703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 406709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 406712 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406716 */   // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 406716 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 406721 */   GIR_RootConstrainSelectedInstOperands,
     /* 406722 */   // GIR_Coverage, 8890,
     /* 406722 */   GIR_Done,
     /* 406723 */ // Label 8375: @406723
     /* 406723 */ GIM_Reject,
     /* 406724 */ // Label 8345: @406724
     /* 406724 */ GIM_Try, /*On fail goto*//*Label 8376*/ GIMT_Encode4(406770),
     /* 406729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 406732 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 406735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406739 */   GIM_Try, /*On fail goto*//*Label 8377*/ GIMT_Encode4(406754), // Rule ID 8887 //
     /* 406744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406747 */     // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 406747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 406752 */     GIR_RootConstrainSelectedInstOperands,
     /* 406753 */     // GIR_Coverage, 8887,
     /* 406753 */     GIR_Done,
     /* 406754 */   // Label 8377: @406754
     /* 406754 */   GIM_Try, /*On fail goto*//*Label 8378*/ GIMT_Encode4(406769), // Rule ID 8891 //
     /* 406759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406762 */     // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 406762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 406767 */     GIR_RootConstrainSelectedInstOperands,
     /* 406768 */     // GIR_Coverage, 8891,
     /* 406768 */     GIR_Done,
     /* 406769 */   // Label 8378: @406769
     /* 406769 */   GIM_Reject,
     /* 406770 */ // Label 8376: @406770
     /* 406770 */ GIM_Reject,
     /* 406771 */ // Label 8346: @406771
     /* 406771 */ GIM_Try, /*On fail goto*//*Label 8379*/ GIMT_Encode4(406796), // Rule ID 8914 //
     /* 406776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 406782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 406785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406789 */   // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 406789 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 406794 */   GIR_RootConstrainSelectedInstOperands,
     /* 406795 */   // GIR_Coverage, 8914,
     /* 406795 */   GIR_Done,
     /* 406796 */ // Label 8379: @406796
     /* 406796 */ GIM_Reject,
     /* 406797 */ // Label 8347: @406797
     /* 406797 */ GIM_Try, /*On fail goto*//*Label 8380*/ GIMT_Encode4(406843),
     /* 406802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 406805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 406808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406812 */   GIM_Try, /*On fail goto*//*Label 8381*/ GIMT_Encode4(406827), // Rule ID 8886 //
     /* 406817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406820 */     // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 406820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 406825 */     GIR_RootConstrainSelectedInstOperands,
     /* 406826 */     // GIR_Coverage, 8886,
     /* 406826 */     GIR_Done,
     /* 406827 */   // Label 8381: @406827
     /* 406827 */   GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(406842), // Rule ID 8889 //
     /* 406832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406835 */     // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 406835 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 406840 */     GIR_RootConstrainSelectedInstOperands,
     /* 406841 */     // GIR_Coverage, 8889,
     /* 406841 */     GIR_Done,
     /* 406842 */   // Label 8382: @406842
     /* 406842 */   GIM_Reject,
     /* 406843 */ // Label 8380: @406843
     /* 406843 */ GIM_Reject,
     /* 406844 */ // Label 8348: @406844
     /* 406844 */ GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(406869), // Rule ID 2412 //
     /* 406849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 406855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 406858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 406862 */   // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 406862 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
     /* 406867 */   GIR_RootConstrainSelectedInstOperands,
     /* 406868 */   // GIR_Coverage, 2412,
     /* 406868 */   GIR_Done,
     /* 406869 */ // Label 8383: @406869
     /* 406869 */ GIM_Reject,
     /* 406870 */ // Label 8349: @406870
     /* 406870 */ GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(406895), // Rule ID 8885 //
     /* 406875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 406878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 406881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 406884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 406888 */   // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 406888 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
     /* 406893 */   GIR_RootConstrainSelectedInstOperands,
     /* 406894 */   // GIR_Coverage, 8885,
     /* 406894 */   GIR_Done,
     /* 406895 */ // Label 8384: @406895
     /* 406895 */ GIM_Reject,
     /* 406896 */ // Label 8350: @406896
     /* 406896 */ GIM_Reject,
     /* 406897 */ // Label 145: @406897
     /* 406897 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8403*/ GIMT_Encode4(407676),
     /* 406908 */ /*GILLT_v2s32*//*Label 8385*/ GIMT_Encode4(406984),
     /* 406912 */ /*GILLT_v2s64*//*Label 8386*/ GIMT_Encode4(407039),
     /* 406916 */ /*GILLT_v4s16*//*Label 8387*/ GIMT_Encode4(407094),
     /* 406920 */ /*GILLT_v4s32*//*Label 8388*/ GIMT_Encode4(407149),
     /* 406924 */ /*GILLT_v8s8*//*Label 8389*/ GIMT_Encode4(407204),
     /* 406928 */ /*GILLT_v8s16*//*Label 8390*/ GIMT_Encode4(407238),
     /* 406932 */ /*GILLT_v16s8*//*Label 8391*/ GIMT_Encode4(407293), GIMT_Encode4(0),
     /* 406940 */ /*GILLT_nxv2s1*//*Label 8392*/ GIMT_Encode4(407327),
     /* 406944 */ /*GILLT_nxv2s16*//*Label 8393*/ GIMT_Encode4(407353),
     /* 406948 */ /*GILLT_nxv2s32*//*Label 8394*/ GIMT_Encode4(407379),
     /* 406952 */ /*GILLT_nxv2s64*//*Label 8395*/ GIMT_Encode4(407405),
     /* 406956 */ /*GILLT_nxv4s1*//*Label 8396*/ GIMT_Encode4(407452),
     /* 406960 */ /*GILLT_nxv4s16*//*Label 8397*/ GIMT_Encode4(407478),
     /* 406964 */ /*GILLT_nxv4s32*//*Label 8398*/ GIMT_Encode4(407504),
     /* 406968 */ /*GILLT_nxv8s1*//*Label 8399*/ GIMT_Encode4(407551),
     /* 406972 */ /*GILLT_nxv8s16*//*Label 8400*/ GIMT_Encode4(407577),
     /* 406976 */ /*GILLT_nxv16s1*//*Label 8401*/ GIMT_Encode4(407624),
     /* 406980 */ /*GILLT_nxv16s8*//*Label 8402*/ GIMT_Encode4(407650),
     /* 406984 */ // Label 8385: @406984
     /* 406984 */ GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(407038),
     /* 406989 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 406992 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 406995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 406999 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407003 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407007 */   GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(407022), // Rule ID 1881 //
     /* 407012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407015 */     // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 407015 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 407020 */     GIR_RootConstrainSelectedInstOperands,
     /* 407021 */     // GIR_Coverage, 1881,
     /* 407021 */     GIR_Done,
     /* 407022 */   // Label 8405: @407022
     /* 407022 */   GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(407037), // Rule ID 5452 //
     /* 407027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407030 */     // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 407030 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 407035 */     GIR_RootConstrainSelectedInstOperands,
     /* 407036 */     // GIR_Coverage, 5452,
     /* 407036 */     GIR_Done,
     /* 407037 */   // Label 8406: @407037
     /* 407037 */   GIM_Reject,
     /* 407038 */ // Label 8404: @407038
     /* 407038 */ GIM_Reject,
     /* 407039 */ // Label 8386: @407039
     /* 407039 */ GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(407093),
     /* 407044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 407050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407058 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407062 */   GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(407077), // Rule ID 1883 //
     /* 407067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407070 */     // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 407070 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 407075 */     GIR_RootConstrainSelectedInstOperands,
     /* 407076 */     // GIR_Coverage, 1883,
     /* 407076 */     GIR_Done,
     /* 407077 */   // Label 8408: @407077
     /* 407077 */   GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(407092), // Rule ID 5454 //
     /* 407082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407085 */     // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 407085 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 407090 */     GIR_RootConstrainSelectedInstOperands,
     /* 407091 */     // GIR_Coverage, 5454,
     /* 407091 */     GIR_Done,
     /* 407092 */   // Label 8409: @407092
     /* 407092 */   GIM_Reject,
     /* 407093 */ // Label 8407: @407093
     /* 407093 */ GIM_Reject,
     /* 407094 */ // Label 8387: @407094
     /* 407094 */ GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(407148),
     /* 407099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 407102 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 407105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407113 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407117 */   GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(407132), // Rule ID 1879 //
     /* 407122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407125 */     // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 407125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 407130 */     GIR_RootConstrainSelectedInstOperands,
     /* 407131 */     // GIR_Coverage, 1879,
     /* 407131 */     GIR_Done,
     /* 407132 */   // Label 8411: @407132
     /* 407132 */   GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(407147), // Rule ID 5450 //
     /* 407137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407140 */     // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 407140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 407145 */     GIR_RootConstrainSelectedInstOperands,
     /* 407146 */     // GIR_Coverage, 5450,
     /* 407146 */     GIR_Done,
     /* 407147 */   // Label 8412: @407147
     /* 407147 */   GIM_Reject,
     /* 407148 */ // Label 8410: @407148
     /* 407148 */ GIM_Reject,
     /* 407149 */ // Label 8388: @407149
     /* 407149 */ GIM_Try, /*On fail goto*//*Label 8413*/ GIMT_Encode4(407203),
     /* 407154 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407157 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 407160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407168 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407172 */   GIM_Try, /*On fail goto*//*Label 8414*/ GIMT_Encode4(407187), // Rule ID 1882 //
     /* 407177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407180 */     // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 407180 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 407185 */     GIR_RootConstrainSelectedInstOperands,
     /* 407186 */     // GIR_Coverage, 1882,
     /* 407186 */     GIR_Done,
     /* 407187 */   // Label 8414: @407187
     /* 407187 */   GIM_Try, /*On fail goto*//*Label 8415*/ GIMT_Encode4(407202), // Rule ID 5453 //
     /* 407192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407195 */     // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 407195 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 407200 */     GIR_RootConstrainSelectedInstOperands,
     /* 407201 */     // GIR_Coverage, 5453,
     /* 407201 */     GIR_Done,
     /* 407202 */   // Label 8415: @407202
     /* 407202 */   GIM_Reject,
     /* 407203 */ // Label 8413: @407203
     /* 407203 */ GIM_Reject,
     /* 407204 */ // Label 8389: @407204
     /* 407204 */ GIM_Try, /*On fail goto*//*Label 8416*/ GIMT_Encode4(407237), // Rule ID 1877 //
     /* 407209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 407215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 407218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407226 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407230 */   // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 407230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
     /* 407235 */   GIR_RootConstrainSelectedInstOperands,
     /* 407236 */   // GIR_Coverage, 1877,
     /* 407236 */   GIR_Done,
     /* 407237 */ // Label 8416: @407237
     /* 407237 */ GIM_Reject,
     /* 407238 */ // Label 8390: @407238
     /* 407238 */ GIM_Try, /*On fail goto*//*Label 8417*/ GIMT_Encode4(407292),
     /* 407243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 407249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407257 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407261 */   GIM_Try, /*On fail goto*//*Label 8418*/ GIMT_Encode4(407276), // Rule ID 1880 //
     /* 407266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407269 */     // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 407269 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 407274 */     GIR_RootConstrainSelectedInstOperands,
     /* 407275 */     // GIR_Coverage, 1880,
     /* 407275 */     GIR_Done,
     /* 407276 */   // Label 8418: @407276
     /* 407276 */   GIM_Try, /*On fail goto*//*Label 8419*/ GIMT_Encode4(407291), // Rule ID 5451 //
     /* 407281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407284 */     // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 407284 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 407289 */     GIR_RootConstrainSelectedInstOperands,
     /* 407290 */     // GIR_Coverage, 5451,
     /* 407290 */     GIR_Done,
     /* 407291 */   // Label 8419: @407291
     /* 407291 */   GIM_Reject,
     /* 407292 */ // Label 8417: @407292
     /* 407292 */ GIM_Reject,
     /* 407293 */ // Label 8391: @407293
     /* 407293 */ GIM_Try, /*On fail goto*//*Label 8420*/ GIMT_Encode4(407326), // Rule ID 1878 //
     /* 407298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 407304 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 407307 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407311 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407315 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407319 */   // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 407319 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
     /* 407324 */   GIR_RootConstrainSelectedInstOperands,
     /* 407325 */   // GIR_Coverage, 1878,
     /* 407325 */   GIR_Done,
     /* 407326 */ // Label 8420: @407326
     /* 407326 */ GIM_Reject,
     /* 407327 */ // Label 8392: @407327
     /* 407327 */ GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(407352), // Rule ID 8919 //
     /* 407332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 407338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 407341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 407345 */   // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 407345 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 407350 */   GIR_RootConstrainSelectedInstOperands,
     /* 407351 */   // GIR_Coverage, 8919,
     /* 407351 */   GIR_Done,
     /* 407352 */ // Label 8421: @407352
     /* 407352 */ GIM_Reject,
     /* 407353 */ // Label 8393: @407353
     /* 407353 */ GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(407378), // Rule ID 8902 //
     /* 407358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 407364 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 407367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407371 */   // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 407371 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 407376 */   GIR_RootConstrainSelectedInstOperands,
     /* 407377 */   // GIR_Coverage, 8902,
     /* 407377 */   GIR_Done,
     /* 407378 */ // Label 8422: @407378
     /* 407378 */ GIM_Reject,
     /* 407379 */ // Label 8394: @407379
     /* 407379 */ GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(407404), // Rule ID 8903 //
     /* 407384 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 407390 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 407393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407397 */   // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 407397 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 407402 */   GIR_RootConstrainSelectedInstOperands,
     /* 407403 */   // GIR_Coverage, 8903,
     /* 407403 */   GIR_Done,
     /* 407404 */ // Label 8423: @407404
     /* 407404 */ GIM_Reject,
     /* 407405 */ // Label 8395: @407405
     /* 407405 */ GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(407451),
     /* 407410 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 407413 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 407416 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407420 */   GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(407435), // Rule ID 8898 //
     /* 407425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407428 */     // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 407428 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 407433 */     GIR_RootConstrainSelectedInstOperands,
     /* 407434 */     // GIR_Coverage, 8898,
     /* 407434 */     GIR_Done,
     /* 407435 */   // Label 8425: @407435
     /* 407435 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(407450), // Rule ID 8904 //
     /* 407440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407443 */     // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 407443 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 407448 */     GIR_RootConstrainSelectedInstOperands,
     /* 407449 */     // GIR_Coverage, 8904,
     /* 407449 */     GIR_Done,
     /* 407450 */   // Label 8426: @407450
     /* 407450 */   GIM_Reject,
     /* 407451 */ // Label 8424: @407451
     /* 407451 */ GIM_Reject,
     /* 407452 */ // Label 8396: @407452
     /* 407452 */ GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(407477), // Rule ID 8918 //
     /* 407457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 407463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 407466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 407470 */   // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 407470 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 407475 */   GIR_RootConstrainSelectedInstOperands,
     /* 407476 */   // GIR_Coverage, 8918,
     /* 407476 */   GIR_Done,
     /* 407477 */ // Label 8427: @407477
     /* 407477 */ GIM_Reject,
     /* 407478 */ // Label 8397: @407478
     /* 407478 */ GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(407503), // Rule ID 8900 //
     /* 407483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 407489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 407492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407496 */   // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 407496 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 407501 */   GIR_RootConstrainSelectedInstOperands,
     /* 407502 */   // GIR_Coverage, 8900,
     /* 407502 */   GIR_Done,
     /* 407503 */ // Label 8428: @407503
     /* 407503 */ GIM_Reject,
     /* 407504 */ // Label 8398: @407504
     /* 407504 */ GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(407550),
     /* 407509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 407512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 407515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407519 */   GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(407534), // Rule ID 8897 //
     /* 407524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407527 */     // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 407527 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 407532 */     GIR_RootConstrainSelectedInstOperands,
     /* 407533 */     // GIR_Coverage, 8897,
     /* 407533 */     GIR_Done,
     /* 407534 */   // Label 8430: @407534
     /* 407534 */   GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(407549), // Rule ID 8901 //
     /* 407539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407542 */     // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 407542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 407547 */     GIR_RootConstrainSelectedInstOperands,
     /* 407548 */     // GIR_Coverage, 8901,
     /* 407548 */     GIR_Done,
     /* 407549 */   // Label 8431: @407549
     /* 407549 */   GIM_Reject,
     /* 407550 */ // Label 8429: @407550
     /* 407550 */ GIM_Reject,
     /* 407551 */ // Label 8399: @407551
     /* 407551 */ GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(407576), // Rule ID 8917 //
     /* 407556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 407562 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 407565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 407569 */   // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 407569 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 407574 */   GIR_RootConstrainSelectedInstOperands,
     /* 407575 */   // GIR_Coverage, 8917,
     /* 407575 */   GIR_Done,
     /* 407576 */ // Label 8432: @407576
     /* 407576 */ GIM_Reject,
     /* 407577 */ // Label 8400: @407577
     /* 407577 */ GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(407623),
     /* 407582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 407585 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 407588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407592 */   GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(407607), // Rule ID 8896 //
     /* 407597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407600 */     // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 407600 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 407605 */     GIR_RootConstrainSelectedInstOperands,
     /* 407606 */     // GIR_Coverage, 8896,
     /* 407606 */     GIR_Done,
     /* 407607 */   // Label 8434: @407607
     /* 407607 */   GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(407622), // Rule ID 8899 //
     /* 407612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407615 */     // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 407615 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 407620 */     GIR_RootConstrainSelectedInstOperands,
     /* 407621 */     // GIR_Coverage, 8899,
     /* 407621 */     GIR_Done,
     /* 407622 */   // Label 8435: @407622
     /* 407622 */   GIM_Reject,
     /* 407623 */ // Label 8433: @407623
     /* 407623 */ GIM_Reject,
     /* 407624 */ // Label 8401: @407624
     /* 407624 */ GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(407649), // Rule ID 2416 //
     /* 407629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 407635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 407638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 407642 */   // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 407642 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
     /* 407647 */   GIR_RootConstrainSelectedInstOperands,
     /* 407648 */   // GIR_Coverage, 2416,
     /* 407648 */   GIR_Done,
     /* 407649 */ // Label 8436: @407649
     /* 407649 */ GIM_Reject,
     /* 407650 */ // Label 8402: @407650
     /* 407650 */ GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(407675), // Rule ID 8895 //
     /* 407655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 407658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 407661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 407664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 407668 */   // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 407668 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
     /* 407673 */   GIR_RootConstrainSelectedInstOperands,
     /* 407674 */   // GIR_Coverage, 8895,
     /* 407674 */   GIR_Done,
     /* 407675 */ // Label 8437: @407675
     /* 407675 */ GIM_Reject,
     /* 407676 */ // Label 8403: @407676
     /* 407676 */ GIM_Reject,
     /* 407677 */ // Label 146: @407677
     /* 407677 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8444*/ GIMT_Encode4(407882),
     /* 407688 */ /*GILLT_s64*//*Label 8438*/ GIMT_Encode4(407720), GIMT_Encode4(0),
     /* 407696 */ /*GILLT_v2s32*//*Label 8439*/ GIMT_Encode4(407747),
     /* 407700 */ /*GILLT_v2s64*//*Label 8440*/ GIMT_Encode4(407774),
     /* 407704 */ /*GILLT_v4s16*//*Label 8441*/ GIMT_Encode4(407801),
     /* 407708 */ /*GILLT_v4s32*//*Label 8442*/ GIMT_Encode4(407828), GIMT_Encode4(0),
     /* 407716 */ /*GILLT_v8s16*//*Label 8443*/ GIMT_Encode4(407855),
     /* 407720 */ // Label 8438: @407720
     /* 407720 */ GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(407746), // Rule ID 1069 //
     /* 407725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 407731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407739 */   // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 407739 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 407744 */   GIR_RootConstrainSelectedInstOperands,
     /* 407745 */   // GIR_Coverage, 1069,
     /* 407745 */   GIR_Done,
     /* 407746 */ // Label 8445: @407746
     /* 407746 */ GIM_Reject,
     /* 407747 */ // Label 8439: @407747
     /* 407747 */ GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(407773), // Rule ID 1065 //
     /* 407752 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 407758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407766 */   // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 407766 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 407771 */   GIR_RootConstrainSelectedInstOperands,
     /* 407772 */   // GIR_Coverage, 1065,
     /* 407772 */   GIR_Done,
     /* 407773 */ // Label 8446: @407773
     /* 407773 */ GIM_Reject,
     /* 407774 */ // Label 8440: @407774
     /* 407774 */ GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(407800), // Rule ID 1071 //
     /* 407779 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407782 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407793 */   // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 407793 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 407798 */   GIR_RootConstrainSelectedInstOperands,
     /* 407799 */   // GIR_Coverage, 1071,
     /* 407799 */   GIR_Done,
     /* 407800 */ // Label 8447: @407800
     /* 407800 */ GIM_Reject,
     /* 407801 */ // Label 8441: @407801
     /* 407801 */ GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(407827), // Rule ID 1061 //
     /* 407806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 407812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407820 */   // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 407820 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 407825 */   GIR_RootConstrainSelectedInstOperands,
     /* 407826 */   // GIR_Coverage, 1061,
     /* 407826 */   GIR_Done,
     /* 407827 */ // Label 8448: @407827
     /* 407827 */ GIM_Reject,
     /* 407828 */ // Label 8442: @407828
     /* 407828 */ GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(407854), // Rule ID 1067 //
     /* 407833 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407836 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 407839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407847 */   // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 407847 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 407852 */   GIR_RootConstrainSelectedInstOperands,
     /* 407853 */   // GIR_Coverage, 1067,
     /* 407853 */   GIR_Done,
     /* 407854 */ // Label 8449: @407854
     /* 407854 */ GIM_Reject,
     /* 407855 */ // Label 8443: @407855
     /* 407855 */ GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(407881), // Rule ID 1063 //
     /* 407860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 407866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407874 */   // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 407874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 407879 */   GIR_RootConstrainSelectedInstOperands,
     /* 407880 */   // GIR_Coverage, 1063,
     /* 407880 */   GIR_Done,
     /* 407881 */ // Label 8450: @407881
     /* 407881 */ GIM_Reject,
     /* 407882 */ // Label 8444: @407882
     /* 407882 */ GIM_Reject,
     /* 407883 */ // Label 147: @407883
     /* 407883 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8453*/ GIMT_Encode4(408749),
     /* 407894 */ /*GILLT_v2s64*//*Label 8451*/ GIMT_Encode4(407906), GIMT_Encode4(0),
     /* 407902 */ /*GILLT_v4s32*//*Label 8452*/ GIMT_Encode4(408200),
     /* 407906 */ // Label 8451: @407906
     /* 407906 */ GIM_Try, /*On fail goto*//*Label 8454*/ GIMT_Encode4(407988), // Rule ID 5825 //
     /* 407911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407918 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407922 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 407926 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 407929 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 407934 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 407938 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407943 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407945 */   // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 725:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 407945 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407948 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 407952 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407957 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 407961 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 407963 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 407966 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407968 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 407971 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407974 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 407977 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407982 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407987 */   // GIR_Coverage, 5825,
     /* 407987 */   GIR_EraseRootFromParent_Done,
     /* 407988 */ // Label 8454: @407988
     /* 407988 */ GIM_Try, /*On fail goto*//*Label 8455*/ GIMT_Encode4(408062), // Rule ID 5824 //
     /* 407993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408000 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408004 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 408008 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408012 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408017 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408019 */   // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 408019 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 408022 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 408026 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408031 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 408035 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408042 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408045 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 408051 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408056 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408061 */   // GIR_Coverage, 5824,
     /* 408061 */   GIR_EraseRootFromParent_Done,
     /* 408062 */ // Label 8455: @408062
     /* 408062 */ GIM_Try, /*On fail goto*//*Label 8456*/ GIMT_Encode4(408121), // Rule ID 5834 //
     /* 408067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408078 */   // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 408078 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408081 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 408085 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408090 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408094 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408096 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408099 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408101 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408104 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 408110 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408115 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408120 */   // GIR_Coverage, 5834,
     /* 408120 */   GIR_EraseRootFromParent_Done,
     /* 408121 */ // Label 8456: @408121
     /* 408121 */ GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(408199), // Rule ID 5962 //
     /* 408126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408129 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408133 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408137 */   // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 408137 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 408140 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 408144 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408149 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408153 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 408155 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 408158 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 408162 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408167 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408169 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 408172 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408174 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408177 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 408180 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 408183 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408188 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408193 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408198 */   // GIR_Coverage, 5962,
     /* 408198 */   GIR_EraseRootFromParent_Done,
     /* 408199 */ // Label 8457: @408199
     /* 408199 */ GIM_Reject,
     /* 408200 */ // Label 8452: @408200
     /* 408200 */ GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(408282), // Rule ID 5827 //
     /* 408205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408212 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408216 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 408220 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 408223 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 408228 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 408232 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408237 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408239 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 725:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 408239 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 408242 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 408246 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408251 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 408255 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408262 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408265 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 408271 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408276 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408281 */   // GIR_Coverage, 5827,
     /* 408281 */   GIR_EraseRootFromParent_Done,
     /* 408282 */ // Label 8458: @408282
     /* 408282 */ GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(408364), // Rule ID 5829 //
     /* 408287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 408290 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408294 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408298 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 408302 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 408305 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 408310 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 408314 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408319 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408321 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 725:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 408321 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 408324 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 408328 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408333 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 408337 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408347 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408350 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 408353 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408358 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408363 */   // GIR_Coverage, 5829,
     /* 408363 */   GIR_EraseRootFromParent_Done,
     /* 408364 */ // Label 8459: @408364
     /* 408364 */ GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(408438), // Rule ID 5826 //
     /* 408369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408376 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408380 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 408384 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 408388 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408393 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408395 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 408395 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 408398 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 408402 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408407 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 408411 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408416 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408421 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408424 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 408427 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408432 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408437 */   // GIR_Coverage, 5826,
     /* 408437 */   GIR_EraseRootFromParent_Done,
     /* 408438 */ // Label 8460: @408438
     /* 408438 */ GIM_Try, /*On fail goto*//*Label 8461*/ GIMT_Encode4(408512), // Rule ID 5828 //
     /* 408443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 408446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408450 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408454 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 408458 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 408462 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408467 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 408469 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 408469 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 408472 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 408476 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408481 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 408485 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408492 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408495 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 408501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408506 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408511 */   // GIR_Coverage, 5828,
     /* 408511 */   GIR_EraseRootFromParent_Done,
     /* 408512 */ // Label 8461: @408512
     /* 408512 */ GIM_Try, /*On fail goto*//*Label 8462*/ GIMT_Encode4(408571), // Rule ID 5830 //
     /* 408517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 408520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408528 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 408528 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 408531 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 408535 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408540 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408544 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408546 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408549 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408551 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408554 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 408560 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408565 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408570 */   // GIR_Coverage, 5830,
     /* 408570 */   GIR_EraseRootFromParent_Done,
     /* 408571 */ // Label 8462: @408571
     /* 408571 */ GIM_Try, /*On fail goto*//*Label 8463*/ GIMT_Encode4(408630), // Rule ID 5831 //
     /* 408576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 408579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408587 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 408587 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 408590 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 408594 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408599 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408608 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408613 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408616 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 408619 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408624 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408629 */   // GIR_Coverage, 5831,
     /* 408629 */   GIR_EraseRootFromParent_Done,
     /* 408630 */ // Label 8463: @408630
     /* 408630 */ GIM_Try, /*On fail goto*//*Label 8464*/ GIMT_Encode4(408689), // Rule ID 5832 //
     /* 408635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 408638 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408642 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408646 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 408646 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 408649 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 408653 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408658 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408662 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408672 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408675 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 408678 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408683 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 408688 */   // GIR_Coverage, 5832,
     /* 408688 */   GIR_EraseRootFromParent_Done,
     /* 408689 */ // Label 8464: @408689
     /* 408689 */ GIM_Try, /*On fail goto*//*Label 8465*/ GIMT_Encode4(408748), // Rule ID 5833 //
     /* 408694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 408697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408705 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 408705 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 408708 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 408712 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408717 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 408721 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 408723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 408726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408728 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 408731 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408734 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 408737 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408742 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 408747 */   // GIR_Coverage, 5833,
     /* 408747 */   GIR_EraseRootFromParent_Done,
     /* 408748 */ // Label 8465: @408748
     /* 408748 */ GIM_Reject,
     /* 408749 */ // Label 8453: @408749
     /* 408749 */ GIM_Reject,
     /* 408750 */ // Label 148: @408750
     /* 408750 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8470*/ GIMT_Encode4(409119),
     /* 408761 */ /*GILLT_v2s32*//*Label 8466*/ GIMT_Encode4(408821), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 408773 */ /*GILLT_v4s32*//*Label 8467*/ GIMT_Encode4(408941), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 408805 */ /*GILLT_nxv2s64*//*Label 8468*/ GIMT_Encode4(409061), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 408817 */ /*GILLT_nxv4s32*//*Label 8469*/ GIMT_Encode4(409090),
     /* 408821 */ // Label 8466: @408821
     /* 408821 */ GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(408940),
     /* 408826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 408832 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 408835 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408839 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408843 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408847 */   GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(408920), // Rule ID 28 //
     /* 408852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 408855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 408859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 408863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 408867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408875 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408879 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408883 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408888 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408892 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408896 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 408900 */     // MIs[3] Operand 1
     /* 408900 */     // No operand predicates
     /* 408900 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408902 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 408902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
     /* 408905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 408909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 408911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408915 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408918 */     GIR_RootConstrainSelectedInstOperands,
     /* 408919 */     // GIR_Coverage, 28,
     /* 408919 */     GIR_EraseRootFromParent_Done,
     /* 408920 */   // Label 8472: @408920
     /* 408920 */   GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(408939), // Rule ID 24 //
     /* 408925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 408928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408932 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 408932 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
     /* 408937 */     GIR_RootConstrainSelectedInstOperands,
     /* 408938 */     // GIR_Coverage, 24,
     /* 408938 */     GIR_Done,
     /* 408939 */   // Label 8473: @408939
     /* 408939 */   GIM_Reject,
     /* 408940 */ // Label 8471: @408940
     /* 408940 */ GIM_Reject,
     /* 408941 */ // Label 8467: @408941
     /* 408941 */ GIM_Try, /*On fail goto*//*Label 8474*/ GIMT_Encode4(409060),
     /* 408946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 408952 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 408955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408959 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408963 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408967 */   GIM_Try, /*On fail goto*//*Label 8475*/ GIMT_Encode4(409040), // Rule ID 29 //
     /* 408972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 408975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 408979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 408983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 408995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 408999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409003 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409008 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409012 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409016 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409020 */     // MIs[3] Operand 1
     /* 409020 */     // No operand predicates
     /* 409020 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409022 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
     /* 409025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409027 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 409029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409038 */     GIR_RootConstrainSelectedInstOperands,
     /* 409039 */     // GIR_Coverage, 29,
     /* 409039 */     GIR_EraseRootFromParent_Done,
     /* 409040 */   // Label 8475: @409040
     /* 409040 */   GIM_Try, /*On fail goto*//*Label 8476*/ GIMT_Encode4(409059), // Rule ID 25 //
     /* 409045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 409048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409052 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 409052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
     /* 409057 */     GIR_RootConstrainSelectedInstOperands,
     /* 409058 */     // GIR_Coverage, 25,
     /* 409058 */     GIR_Done,
     /* 409059 */   // Label 8476: @409059
     /* 409059 */   GIM_Reject,
     /* 409060 */ // Label 8474: @409060
     /* 409060 */ GIM_Reject,
     /* 409061 */ // Label 8468: @409061
     /* 409061 */ GIM_Try, /*On fail goto*//*Label 8477*/ GIMT_Encode4(409089), // Rule ID 7606 //
     /* 409066 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 409072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 409075 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 409078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 409082 */   // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 409082 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
     /* 409087 */   GIR_RootConstrainSelectedInstOperands,
     /* 409088 */   // GIR_Coverage, 7606,
     /* 409088 */   GIR_Done,
     /* 409089 */ // Label 8477: @409089
     /* 409089 */ GIM_Reject,
     /* 409090 */ // Label 8469: @409090
     /* 409090 */ GIM_Try, /*On fail goto*//*Label 8478*/ GIMT_Encode4(409118), // Rule ID 7605 //
     /* 409095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 409098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 409101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 409104 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 409107 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 409111 */   // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 409111 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
     /* 409116 */   GIR_RootConstrainSelectedInstOperands,
     /* 409117 */   // GIR_Coverage, 7605,
     /* 409117 */   GIR_Done,
     /* 409118 */ // Label 8478: @409118
     /* 409118 */ GIM_Reject,
     /* 409119 */ // Label 8470: @409119
     /* 409119 */ GIM_Reject,
     /* 409120 */ // Label 149: @409120
     /* 409120 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8482*/ GIMT_Encode4(409236),
     /* 409131 */ /*GILLT_s16*//*Label 8479*/ GIMT_Encode4(409143),
     /* 409135 */ /*GILLT_s32*//*Label 8480*/ GIMT_Encode4(409174),
     /* 409139 */ /*GILLT_s64*//*Label 8481*/ GIMT_Encode4(409205),
     /* 409143 */ // Label 8479: @409143
     /* 409143 */ GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(409173), // Rule ID 1669 //
     /* 409148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 409151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 409154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 409158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 409162 */   // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 409162 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 409167 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 409171 */   GIR_RootConstrainSelectedInstOperands,
     /* 409172 */   // GIR_Coverage, 1669,
     /* 409172 */   GIR_Done,
     /* 409173 */ // Label 8483: @409173
     /* 409173 */ GIM_Reject,
     /* 409174 */ // Label 8480: @409174
     /* 409174 */ GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(409204), // Rule ID 1668 //
     /* 409179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 409182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 409185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 409193 */   // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 409193 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 409198 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 409202 */   GIR_RootConstrainSelectedInstOperands,
     /* 409203 */   // GIR_Coverage, 1668,
     /* 409203 */   GIR_Done,
     /* 409204 */ // Label 8484: @409204
     /* 409204 */ GIM_Reject,
     /* 409205 */ // Label 8481: @409205
     /* 409205 */ GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(409235), // Rule ID 1667 //
     /* 409210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 409213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 409216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409224 */   // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 409224 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 409229 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 409233 */   GIR_RootConstrainSelectedInstOperands,
     /* 409234 */   // GIR_Coverage, 1667,
     /* 409234 */   GIR_Done,
     /* 409235 */ // Label 8485: @409235
     /* 409235 */ GIM_Reject,
     /* 409236 */ // Label 8482: @409236
     /* 409236 */ GIM_Reject,
     /* 409237 */ // Label 150: @409237
     /* 409237 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8489*/ GIMT_Encode4(410469),
     /* 409248 */ /*GILLT_v2s64*//*Label 8486*/ GIMT_Encode4(409268), GIMT_Encode4(0),
     /* 409256 */ /*GILLT_v4s32*//*Label 8487*/ GIMT_Encode4(409829), GIMT_Encode4(0),
     /* 409264 */ /*GILLT_v8s16*//*Label 8488*/ GIMT_Encode4(410390),
     /* 409268 */ // Label 8486: @409268
     /* 409268 */ GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(409828),
     /* 409273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 409276 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 409279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409283 */   GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(409375), // Rule ID 2106 //
     /* 409288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409303 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409307 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409311 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409315 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409324 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409328 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409332 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409336 */     // MIs[3] Operand 1
     /* 409336 */     // No operand predicates
     /* 409336 */     // MIs[1] Operand 2
     /* 409336 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 409347 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 409356 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 409359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409361 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409373 */     GIR_RootConstrainSelectedInstOperands,
     /* 409374 */     // GIR_Coverage, 2106,
     /* 409374 */     GIR_EraseRootFromParent_Done,
     /* 409375 */   // Label 8491: @409375
     /* 409375 */   GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(409467), // Rule ID 13462 //
     /* 409380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409411 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409416 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409420 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409424 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409428 */     // MIs[3] Operand 1
     /* 409428 */     // No operand predicates
     /* 409428 */     // MIs[1] Operand 2
     /* 409428 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 409439 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409441 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 409448 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 409451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409453 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409462 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409465 */     GIR_RootConstrainSelectedInstOperands,
     /* 409466 */     // GIR_Coverage, 13462,
     /* 409466 */     GIR_EraseRootFromParent_Done,
     /* 409467 */   // Label 8492: @409467
     /* 409467 */   GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(409553), // Rule ID 13460 //
     /* 409472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409499 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409503 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409516 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409520 */     // MIs[3] Operand 1
     /* 409520 */     // No operand predicates
     /* 409520 */     // MIs[1] Operand 2
     /* 409520 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 409531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409535 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409537 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 409540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409548 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409551 */     GIR_RootConstrainSelectedInstOperands,
     /* 409552 */     // GIR_Coverage, 13460,
     /* 409552 */     GIR_EraseRootFromParent_Done,
     /* 409553 */   // Label 8493: @409553
     /* 409553 */   GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(409639), // Rule ID 2104 //
     /* 409558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409593 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409598 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409602 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409606 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409610 */     // MIs[3] Operand 1
     /* 409610 */     // No operand predicates
     /* 409610 */     // MIs[1] Operand 2
     /* 409610 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 409621 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409623 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 409626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409628 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409637 */     GIR_RootConstrainSelectedInstOperands,
     /* 409638 */     // GIR_Coverage, 2104,
     /* 409638 */     GIR_EraseRootFromParent_Done,
     /* 409639 */   // Label 8494: @409639
     /* 409639 */   GIM_Try, /*On fail goto*//*Label 8495*/ GIMT_Encode4(409678), // Rule ID 1831 //
     /* 409644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409647 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 409654 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 409661 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 409661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 409664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409666 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409671 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 409676 */     GIR_RootConstrainSelectedInstOperands,
     /* 409677 */     // GIR_Coverage, 1831,
     /* 409677 */     GIR_EraseRootFromParent_Done,
     /* 409678 */   // Label 8495: @409678
     /* 409678 */   GIM_Try, /*On fail goto*//*Label 8496*/ GIMT_Encode4(409741), // Rule ID 13461 //
     /* 409683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409698 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409702 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409715 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409719 */     // MIs[2] Operand 1
     /* 409719 */     // No operand predicates
     /* 409719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409725 */     // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 409728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409739 */     GIR_RootConstrainSelectedInstOperands,
     /* 409740 */     // GIR_Coverage, 13461,
     /* 409740 */     GIR_EraseRootFromParent_Done,
     /* 409741 */   // Label 8496: @409741
     /* 409741 */   GIM_Try, /*On fail goto*//*Label 8497*/ GIMT_Encode4(409804), // Rule ID 2105 //
     /* 409746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 409761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 409765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409782 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409786 */     // MIs[2] Operand 1
     /* 409786 */     // No operand predicates
     /* 409786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409788 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 409791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409802 */     GIR_RootConstrainSelectedInstOperands,
     /* 409803 */     // GIR_Coverage, 2105,
     /* 409803 */     GIR_EraseRootFromParent_Done,
     /* 409804 */   // Label 8497: @409804
     /* 409804 */   GIM_Try, /*On fail goto*//*Label 8498*/ GIMT_Encode4(409827), // Rule ID 1830 //
     /* 409809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409820 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 409820 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 409825 */     GIR_RootConstrainSelectedInstOperands,
     /* 409826 */     // GIR_Coverage, 1830,
     /* 409826 */     GIR_Done,
     /* 409827 */   // Label 8498: @409827
     /* 409827 */   GIM_Reject,
     /* 409828 */ // Label 8490: @409828
     /* 409828 */ GIM_Reject,
     /* 409829 */ // Label 8487: @409829
     /* 409829 */ GIM_Try, /*On fail goto*//*Label 8499*/ GIMT_Encode4(410389),
     /* 409834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 409837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 409840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409844 */   GIM_Try, /*On fail goto*//*Label 8500*/ GIMT_Encode4(409936), // Rule ID 2103 //
     /* 409849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 409885 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409889 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409893 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 409897 */     // MIs[3] Operand 1
     /* 409897 */     // No operand predicates
     /* 409897 */     // MIs[1] Operand 2
     /* 409897 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 409908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409910 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 409917 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 409917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 409920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409922 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 409927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409934 */     GIR_RootConstrainSelectedInstOperands,
     /* 409935 */     // GIR_Coverage, 2103,
     /* 409935 */     GIR_EraseRootFromParent_Done,
     /* 409936 */   // Label 8500: @409936
     /* 409936 */   GIM_Try, /*On fail goto*//*Label 8501*/ GIMT_Encode4(410028), // Rule ID 13459 //
     /* 409941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 409952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 409964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 409968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 409977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409985 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 409989 */     // MIs[3] Operand 1
     /* 409989 */     // No operand predicates
     /* 409989 */     // MIs[1] Operand 2
     /* 409989 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 410000 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410002 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 410009 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 410009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 410012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410014 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 410019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410026 */     GIR_RootConstrainSelectedInstOperands,
     /* 410027 */     // GIR_Coverage, 13459,
     /* 410027 */     GIR_EraseRootFromParent_Done,
     /* 410028 */   // Label 8501: @410028
     /* 410028 */   GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(410114), // Rule ID 13457 //
     /* 410033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 410044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 410056 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410060 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410064 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 410069 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410073 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410077 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 410081 */     // MIs[3] Operand 1
     /* 410081 */     // No operand predicates
     /* 410081 */     // MIs[1] Operand 2
     /* 410081 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 410092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410096 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410098 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 410098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 410101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410109 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410112 */     GIR_RootConstrainSelectedInstOperands,
     /* 410113 */     // GIR_Coverage, 13457,
     /* 410113 */     GIR_EraseRootFromParent_Done,
     /* 410114 */   // Label 8502: @410114
     /* 410114 */   GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(410200), // Rule ID 2101 //
     /* 410119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 410134 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 410146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410150 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 410159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410163 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410167 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 410171 */     // MIs[3] Operand 1
     /* 410171 */     // No operand predicates
     /* 410171 */     // MIs[1] Operand 2
     /* 410171 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 410182 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410184 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 410184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 410187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410195 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410198 */     GIR_RootConstrainSelectedInstOperands,
     /* 410199 */     // GIR_Coverage, 2101,
     /* 410199 */     GIR_EraseRootFromParent_Done,
     /* 410200 */   // Label 8503: @410200
     /* 410200 */   GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(410239), // Rule ID 1829 //
     /* 410205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410208 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 410215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 410222 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 410222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 410225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 410232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 410237 */     GIR_RootConstrainSelectedInstOperands,
     /* 410238 */     // GIR_Coverage, 1829,
     /* 410238 */     GIR_EraseRootFromParent_Done,
     /* 410239 */   // Label 8504: @410239
     /* 410239 */   GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(410302), // Rule ID 13458 //
     /* 410244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 410255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 410268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410276 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 410280 */     // MIs[2] Operand 1
     /* 410280 */     // No operand predicates
     /* 410280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410286 */     // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 410286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 410289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410297 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410300 */     GIR_RootConstrainSelectedInstOperands,
     /* 410301 */     // GIR_Coverage, 13458,
     /* 410301 */     GIR_EraseRootFromParent_Done,
     /* 410302 */   // Label 8505: @410302
     /* 410302 */   GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(410365), // Rule ID 2102 //
     /* 410307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 410322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410330 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 410335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410343 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 410347 */     // MIs[2] Operand 1
     /* 410347 */     // No operand predicates
     /* 410347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410349 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 410349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 410352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410363 */     GIR_RootConstrainSelectedInstOperands,
     /* 410364 */     // GIR_Coverage, 2102,
     /* 410364 */     GIR_EraseRootFromParent_Done,
     /* 410365 */   // Label 8506: @410365
     /* 410365 */   GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(410388), // Rule ID 1828 //
     /* 410370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410381 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 410381 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 410386 */     GIR_RootConstrainSelectedInstOperands,
     /* 410387 */     // GIR_Coverage, 1828,
     /* 410387 */     GIR_Done,
     /* 410388 */   // Label 8507: @410388
     /* 410388 */   GIM_Reject,
     /* 410389 */ // Label 8499: @410389
     /* 410389 */ GIM_Reject,
     /* 410390 */ // Label 8488: @410390
     /* 410390 */ GIM_Try, /*On fail goto*//*Label 8508*/ GIMT_Encode4(410468),
     /* 410395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 410398 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 410401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410405 */   GIM_Try, /*On fail goto*//*Label 8509*/ GIMT_Encode4(410444), // Rule ID 1827 //
     /* 410410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410413 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 410420 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 410427 */     // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 410427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 410430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410432 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 410437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 410442 */     GIR_RootConstrainSelectedInstOperands,
     /* 410443 */     // GIR_Coverage, 1827,
     /* 410443 */     GIR_EraseRootFromParent_Done,
     /* 410444 */   // Label 8509: @410444
     /* 410444 */   GIM_Try, /*On fail goto*//*Label 8510*/ GIMT_Encode4(410467), // Rule ID 1826 //
     /* 410449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410460 */     // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 410460 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 410465 */     GIR_RootConstrainSelectedInstOperands,
     /* 410466 */     // GIR_Coverage, 1826,
     /* 410466 */     GIR_Done,
     /* 410467 */   // Label 8510: @410467
     /* 410467 */   GIM_Reject,
     /* 410468 */ // Label 8508: @410468
     /* 410468 */ GIM_Reject,
     /* 410469 */ // Label 8489: @410469
     /* 410469 */ GIM_Reject,
     /* 410470 */ // Label 151: @410470
     /* 410470 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8529*/ GIMT_Encode4(411249),
     /* 410481 */ /*GILLT_v2s32*//*Label 8511*/ GIMT_Encode4(410557),
     /* 410485 */ /*GILLT_v2s64*//*Label 8512*/ GIMT_Encode4(410612),
     /* 410489 */ /*GILLT_v4s16*//*Label 8513*/ GIMT_Encode4(410667),
     /* 410493 */ /*GILLT_v4s32*//*Label 8514*/ GIMT_Encode4(410722),
     /* 410497 */ /*GILLT_v8s8*//*Label 8515*/ GIMT_Encode4(410777),
     /* 410501 */ /*GILLT_v8s16*//*Label 8516*/ GIMT_Encode4(410811),
     /* 410505 */ /*GILLT_v16s8*//*Label 8517*/ GIMT_Encode4(410866), GIMT_Encode4(0),
     /* 410513 */ /*GILLT_nxv2s1*//*Label 8518*/ GIMT_Encode4(410900),
     /* 410517 */ /*GILLT_nxv2s16*//*Label 8519*/ GIMT_Encode4(410926),
     /* 410521 */ /*GILLT_nxv2s32*//*Label 8520*/ GIMT_Encode4(410952),
     /* 410525 */ /*GILLT_nxv2s64*//*Label 8521*/ GIMT_Encode4(410978),
     /* 410529 */ /*GILLT_nxv4s1*//*Label 8522*/ GIMT_Encode4(411025),
     /* 410533 */ /*GILLT_nxv4s16*//*Label 8523*/ GIMT_Encode4(411051),
     /* 410537 */ /*GILLT_nxv4s32*//*Label 8524*/ GIMT_Encode4(411077),
     /* 410541 */ /*GILLT_nxv8s1*//*Label 8525*/ GIMT_Encode4(411124),
     /* 410545 */ /*GILLT_nxv8s16*//*Label 8526*/ GIMT_Encode4(411150),
     /* 410549 */ /*GILLT_nxv16s1*//*Label 8527*/ GIMT_Encode4(411197),
     /* 410553 */ /*GILLT_nxv16s8*//*Label 8528*/ GIMT_Encode4(411223),
     /* 410557 */ // Label 8511: @410557
     /* 410557 */ GIM_Try, /*On fail goto*//*Label 8530*/ GIMT_Encode4(410611),
     /* 410562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 410568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410576 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410580 */   GIM_Try, /*On fail goto*//*Label 8531*/ GIMT_Encode4(410595), // Rule ID 1888 //
     /* 410585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410588 */     // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 410588 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 410593 */     GIR_RootConstrainSelectedInstOperands,
     /* 410594 */     // GIR_Coverage, 1888,
     /* 410594 */     GIR_Done,
     /* 410595 */   // Label 8531: @410595
     /* 410595 */   GIM_Try, /*On fail goto*//*Label 8532*/ GIMT_Encode4(410610), // Rule ID 5457 //
     /* 410600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410603 */     // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 410603 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 410608 */     GIR_RootConstrainSelectedInstOperands,
     /* 410609 */     // GIR_Coverage, 5457,
     /* 410609 */     GIR_Done,
     /* 410610 */   // Label 8532: @410610
     /* 410610 */   GIM_Reject,
     /* 410611 */ // Label 8530: @410611
     /* 410611 */ GIM_Reject,
     /* 410612 */ // Label 8512: @410612
     /* 410612 */ GIM_Try, /*On fail goto*//*Label 8533*/ GIMT_Encode4(410666),
     /* 410617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 410623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410627 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410631 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410635 */   GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(410650), // Rule ID 1890 //
     /* 410640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410643 */     // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 410643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 410648 */     GIR_RootConstrainSelectedInstOperands,
     /* 410649 */     // GIR_Coverage, 1890,
     /* 410649 */     GIR_Done,
     /* 410650 */   // Label 8534: @410650
     /* 410650 */   GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(410665), // Rule ID 5459 //
     /* 410655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410658 */     // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 410658 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 410663 */     GIR_RootConstrainSelectedInstOperands,
     /* 410664 */     // GIR_Coverage, 5459,
     /* 410664 */     GIR_Done,
     /* 410665 */   // Label 8535: @410665
     /* 410665 */   GIM_Reject,
     /* 410666 */ // Label 8533: @410666
     /* 410666 */ GIM_Reject,
     /* 410667 */ // Label 8513: @410667
     /* 410667 */ GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(410721),
     /* 410672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 410675 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 410678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410686 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410690 */   GIM_Try, /*On fail goto*//*Label 8537*/ GIMT_Encode4(410705), // Rule ID 1886 //
     /* 410695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410698 */     // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 410698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 410703 */     GIR_RootConstrainSelectedInstOperands,
     /* 410704 */     // GIR_Coverage, 1886,
     /* 410704 */     GIR_Done,
     /* 410705 */   // Label 8537: @410705
     /* 410705 */   GIM_Try, /*On fail goto*//*Label 8538*/ GIMT_Encode4(410720), // Rule ID 5455 //
     /* 410710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410713 */     // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 410713 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 410718 */     GIR_RootConstrainSelectedInstOperands,
     /* 410719 */     // GIR_Coverage, 5455,
     /* 410719 */     GIR_Done,
     /* 410720 */   // Label 8538: @410720
     /* 410720 */   GIM_Reject,
     /* 410721 */ // Label 8536: @410721
     /* 410721 */ GIM_Reject,
     /* 410722 */ // Label 8514: @410722
     /* 410722 */ GIM_Try, /*On fail goto*//*Label 8539*/ GIMT_Encode4(410776),
     /* 410727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 410733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410741 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410745 */   GIM_Try, /*On fail goto*//*Label 8540*/ GIMT_Encode4(410760), // Rule ID 1889 //
     /* 410750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410753 */     // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 410753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 410758 */     GIR_RootConstrainSelectedInstOperands,
     /* 410759 */     // GIR_Coverage, 1889,
     /* 410759 */     GIR_Done,
     /* 410760 */   // Label 8540: @410760
     /* 410760 */   GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(410775), // Rule ID 5458 //
     /* 410765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410768 */     // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 410768 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 410773 */     GIR_RootConstrainSelectedInstOperands,
     /* 410774 */     // GIR_Coverage, 5458,
     /* 410774 */     GIR_Done,
     /* 410775 */   // Label 8541: @410775
     /* 410775 */   GIM_Reject,
     /* 410776 */ // Label 8539: @410776
     /* 410776 */ GIM_Reject,
     /* 410777 */ // Label 8515: @410777
     /* 410777 */ GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(410810), // Rule ID 1884 //
     /* 410782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 410788 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 410791 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410795 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410799 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410803 */   // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 410803 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 410808 */   GIR_RootConstrainSelectedInstOperands,
     /* 410809 */   // GIR_Coverage, 1884,
     /* 410809 */   GIR_Done,
     /* 410810 */ // Label 8542: @410810
     /* 410810 */ GIM_Reject,
     /* 410811 */ // Label 8516: @410811
     /* 410811 */ GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(410865),
     /* 410816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 410819 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 410822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410830 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410834 */   GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(410849), // Rule ID 1887 //
     /* 410839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410842 */     // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 410842 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 410847 */     GIR_RootConstrainSelectedInstOperands,
     /* 410848 */     // GIR_Coverage, 1887,
     /* 410848 */     GIR_Done,
     /* 410849 */   // Label 8544: @410849
     /* 410849 */   GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(410864), // Rule ID 5456 //
     /* 410854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410857 */     // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 410857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 410862 */     GIR_RootConstrainSelectedInstOperands,
     /* 410863 */     // GIR_Coverage, 5456,
     /* 410863 */     GIR_Done,
     /* 410864 */   // Label 8545: @410864
     /* 410864 */   GIM_Reject,
     /* 410865 */ // Label 8543: @410865
     /* 410865 */ GIM_Reject,
     /* 410866 */ // Label 8517: @410866
     /* 410866 */ GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(410899), // Rule ID 1885 //
     /* 410871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 410877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 410880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410888 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410892 */   // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 410892 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 410897 */   GIR_RootConstrainSelectedInstOperands,
     /* 410898 */   // GIR_Coverage, 1885,
     /* 410898 */   GIR_Done,
     /* 410899 */ // Label 8546: @410899
     /* 410899 */ GIM_Reject,
     /* 410900 */ // Label 8518: @410900
     /* 410900 */ GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(410925), // Rule ID 8910 //
     /* 410905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 410911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 410914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 410918 */   // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 410918 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 410923 */   GIR_RootConstrainSelectedInstOperands,
     /* 410924 */   // GIR_Coverage, 8910,
     /* 410924 */   GIR_Done,
     /* 410925 */ // Label 8547: @410925
     /* 410925 */ GIM_Reject,
     /* 410926 */ // Label 8519: @410926
     /* 410926 */ GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(410951), // Rule ID 8872 //
     /* 410931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 410937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 410940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410944 */   // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 410944 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 410949 */   GIR_RootConstrainSelectedInstOperands,
     /* 410950 */   // GIR_Coverage, 8872,
     /* 410950 */   GIR_Done,
     /* 410951 */ // Label 8548: @410951
     /* 410951 */ GIM_Reject,
     /* 410952 */ // Label 8520: @410952
     /* 410952 */ GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(410977), // Rule ID 8873 //
     /* 410957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 410960 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 410963 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 410966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410970 */   // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 410970 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 410975 */   GIR_RootConstrainSelectedInstOperands,
     /* 410976 */   // GIR_Coverage, 8873,
     /* 410976 */   GIR_Done,
     /* 410977 */ // Label 8549: @410977
     /* 410977 */ GIM_Reject,
     /* 410978 */ // Label 8521: @410978
     /* 410978 */ GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(411024),
     /* 410983 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 410986 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 410989 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 410993 */   GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(411008), // Rule ID 8868 //
     /* 410998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411001 */     // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 411001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 411006 */     GIR_RootConstrainSelectedInstOperands,
     /* 411007 */     // GIR_Coverage, 8868,
     /* 411007 */     GIR_Done,
     /* 411008 */   // Label 8551: @411008
     /* 411008 */   GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(411023), // Rule ID 8874 //
     /* 411013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411016 */     // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 411016 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 411021 */     GIR_RootConstrainSelectedInstOperands,
     /* 411022 */     // GIR_Coverage, 8874,
     /* 411022 */     GIR_Done,
     /* 411023 */   // Label 8552: @411023
     /* 411023 */   GIM_Reject,
     /* 411024 */ // Label 8550: @411024
     /* 411024 */ GIM_Reject,
     /* 411025 */ // Label 8522: @411025
     /* 411025 */ GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(411050), // Rule ID 8909 //
     /* 411030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 411036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 411039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411043 */   // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 411043 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 411048 */   GIR_RootConstrainSelectedInstOperands,
     /* 411049 */   // GIR_Coverage, 8909,
     /* 411049 */   GIR_Done,
     /* 411050 */ // Label 8553: @411050
     /* 411050 */ GIM_Reject,
     /* 411051 */ // Label 8523: @411051
     /* 411051 */ GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(411076), // Rule ID 8870 //
     /* 411056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 411062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 411065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411069 */   // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 411069 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 411074 */   GIR_RootConstrainSelectedInstOperands,
     /* 411075 */   // GIR_Coverage, 8870,
     /* 411075 */   GIR_Done,
     /* 411076 */ // Label 8554: @411076
     /* 411076 */ GIM_Reject,
     /* 411077 */ // Label 8524: @411077
     /* 411077 */ GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(411123),
     /* 411082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 411085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 411088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411092 */   GIM_Try, /*On fail goto*//*Label 8556*/ GIMT_Encode4(411107), // Rule ID 8867 //
     /* 411097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411100 */     // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 411100 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 411105 */     GIR_RootConstrainSelectedInstOperands,
     /* 411106 */     // GIR_Coverage, 8867,
     /* 411106 */     GIR_Done,
     /* 411107 */   // Label 8556: @411107
     /* 411107 */   GIM_Try, /*On fail goto*//*Label 8557*/ GIMT_Encode4(411122), // Rule ID 8871 //
     /* 411112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411115 */     // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 411115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 411120 */     GIR_RootConstrainSelectedInstOperands,
     /* 411121 */     // GIR_Coverage, 8871,
     /* 411121 */     GIR_Done,
     /* 411122 */   // Label 8557: @411122
     /* 411122 */   GIM_Reject,
     /* 411123 */ // Label 8555: @411123
     /* 411123 */ GIM_Reject,
     /* 411124 */ // Label 8525: @411124
     /* 411124 */ GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(411149), // Rule ID 8908 //
     /* 411129 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411132 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 411135 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 411138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411142 */   // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 411142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 411147 */   GIR_RootConstrainSelectedInstOperands,
     /* 411148 */   // GIR_Coverage, 8908,
     /* 411148 */   GIR_Done,
     /* 411149 */ // Label 8558: @411149
     /* 411149 */ GIM_Reject,
     /* 411150 */ // Label 8526: @411150
     /* 411150 */ GIM_Try, /*On fail goto*//*Label 8559*/ GIMT_Encode4(411196),
     /* 411155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 411158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 411161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411165 */   GIM_Try, /*On fail goto*//*Label 8560*/ GIMT_Encode4(411180), // Rule ID 8866 //
     /* 411170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411173 */     // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 411173 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 411178 */     GIR_RootConstrainSelectedInstOperands,
     /* 411179 */     // GIR_Coverage, 8866,
     /* 411179 */     GIR_Done,
     /* 411180 */   // Label 8560: @411180
     /* 411180 */   GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(411195), // Rule ID 8869 //
     /* 411185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411188 */     // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 411188 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 411193 */     GIR_RootConstrainSelectedInstOperands,
     /* 411194 */     // GIR_Coverage, 8869,
     /* 411194 */     GIR_Done,
     /* 411195 */   // Label 8561: @411195
     /* 411195 */   GIM_Reject,
     /* 411196 */ // Label 8559: @411196
     /* 411196 */ GIM_Reject,
     /* 411197 */ // Label 8527: @411197
     /* 411197 */ GIM_Try, /*On fail goto*//*Label 8562*/ GIMT_Encode4(411222), // Rule ID 2404 //
     /* 411202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 411208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 411211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411215 */   // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 411215 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 411220 */   GIR_RootConstrainSelectedInstOperands,
     /* 411221 */   // GIR_Coverage, 2404,
     /* 411221 */   GIR_Done,
     /* 411222 */ // Label 8562: @411222
     /* 411222 */ GIM_Reject,
     /* 411223 */ // Label 8528: @411223
     /* 411223 */ GIM_Try, /*On fail goto*//*Label 8563*/ GIMT_Encode4(411248), // Rule ID 8865 //
     /* 411228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 411234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 411237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411241 */   // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 411241 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
     /* 411246 */   GIR_RootConstrainSelectedInstOperands,
     /* 411247 */   // GIR_Coverage, 8865,
     /* 411247 */   GIR_Done,
     /* 411248 */ // Label 8563: @411248
     /* 411248 */ GIM_Reject,
     /* 411249 */ // Label 8529: @411249
     /* 411249 */ GIM_Reject,
     /* 411250 */ // Label 152: @411250
     /* 411250 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8582*/ GIMT_Encode4(412029),
     /* 411261 */ /*GILLT_v2s32*//*Label 8564*/ GIMT_Encode4(411337),
     /* 411265 */ /*GILLT_v2s64*//*Label 8565*/ GIMT_Encode4(411392),
     /* 411269 */ /*GILLT_v4s16*//*Label 8566*/ GIMT_Encode4(411447),
     /* 411273 */ /*GILLT_v4s32*//*Label 8567*/ GIMT_Encode4(411502),
     /* 411277 */ /*GILLT_v8s8*//*Label 8568*/ GIMT_Encode4(411557),
     /* 411281 */ /*GILLT_v8s16*//*Label 8569*/ GIMT_Encode4(411591),
     /* 411285 */ /*GILLT_v16s8*//*Label 8570*/ GIMT_Encode4(411646), GIMT_Encode4(0),
     /* 411293 */ /*GILLT_nxv2s1*//*Label 8571*/ GIMT_Encode4(411680),
     /* 411297 */ /*GILLT_nxv2s16*//*Label 8572*/ GIMT_Encode4(411706),
     /* 411301 */ /*GILLT_nxv2s32*//*Label 8573*/ GIMT_Encode4(411732),
     /* 411305 */ /*GILLT_nxv2s64*//*Label 8574*/ GIMT_Encode4(411758),
     /* 411309 */ /*GILLT_nxv4s1*//*Label 8575*/ GIMT_Encode4(411805),
     /* 411313 */ /*GILLT_nxv4s16*//*Label 8576*/ GIMT_Encode4(411831),
     /* 411317 */ /*GILLT_nxv4s32*//*Label 8577*/ GIMT_Encode4(411857),
     /* 411321 */ /*GILLT_nxv8s1*//*Label 8578*/ GIMT_Encode4(411904),
     /* 411325 */ /*GILLT_nxv8s16*//*Label 8579*/ GIMT_Encode4(411930),
     /* 411329 */ /*GILLT_nxv16s1*//*Label 8580*/ GIMT_Encode4(411977),
     /* 411333 */ /*GILLT_nxv16s8*//*Label 8581*/ GIMT_Encode4(412003),
     /* 411337 */ // Label 8564: @411337
     /* 411337 */ GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(411391),
     /* 411342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411345 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 411348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411356 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411360 */   GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(411375), // Rule ID 1895 //
     /* 411365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411368 */     // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 411368 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 411373 */     GIR_RootConstrainSelectedInstOperands,
     /* 411374 */     // GIR_Coverage, 1895,
     /* 411374 */     GIR_Done,
     /* 411375 */   // Label 8584: @411375
     /* 411375 */   GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(411390), // Rule ID 5462 //
     /* 411380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411383 */     // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 411383 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 411388 */     GIR_RootConstrainSelectedInstOperands,
     /* 411389 */     // GIR_Coverage, 5462,
     /* 411389 */     GIR_Done,
     /* 411390 */   // Label 8585: @411390
     /* 411390 */   GIM_Reject,
     /* 411391 */ // Label 8583: @411391
     /* 411391 */ GIM_Reject,
     /* 411392 */ // Label 8565: @411392
     /* 411392 */ GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(411446),
     /* 411397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 411403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411407 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411411 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411415 */   GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(411430), // Rule ID 1897 //
     /* 411420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411423 */     // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 411423 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 411428 */     GIR_RootConstrainSelectedInstOperands,
     /* 411429 */     // GIR_Coverage, 1897,
     /* 411429 */     GIR_Done,
     /* 411430 */   // Label 8587: @411430
     /* 411430 */   GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(411445), // Rule ID 5464 //
     /* 411435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411438 */     // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 411438 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 411443 */     GIR_RootConstrainSelectedInstOperands,
     /* 411444 */     // GIR_Coverage, 5464,
     /* 411444 */     GIR_Done,
     /* 411445 */   // Label 8588: @411445
     /* 411445 */   GIM_Reject,
     /* 411446 */ // Label 8586: @411446
     /* 411446 */ GIM_Reject,
     /* 411447 */ // Label 8566: @411447
     /* 411447 */ GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(411501),
     /* 411452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 411455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 411458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411470 */   GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(411485), // Rule ID 1893 //
     /* 411475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411478 */     // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 411478 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 411483 */     GIR_RootConstrainSelectedInstOperands,
     /* 411484 */     // GIR_Coverage, 1893,
     /* 411484 */     GIR_Done,
     /* 411485 */   // Label 8590: @411485
     /* 411485 */   GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(411500), // Rule ID 5460 //
     /* 411490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411493 */     // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 411493 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 411498 */     GIR_RootConstrainSelectedInstOperands,
     /* 411499 */     // GIR_Coverage, 5460,
     /* 411499 */     GIR_Done,
     /* 411500 */   // Label 8591: @411500
     /* 411500 */   GIM_Reject,
     /* 411501 */ // Label 8589: @411501
     /* 411501 */ GIM_Reject,
     /* 411502 */ // Label 8567: @411502
     /* 411502 */ GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(411556),
     /* 411507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 411510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 411513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411521 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411525 */   GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(411540), // Rule ID 1896 //
     /* 411530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411533 */     // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 411533 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 411538 */     GIR_RootConstrainSelectedInstOperands,
     /* 411539 */     // GIR_Coverage, 1896,
     /* 411539 */     GIR_Done,
     /* 411540 */   // Label 8593: @411540
     /* 411540 */   GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(411555), // Rule ID 5463 //
     /* 411545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411548 */     // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 411548 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 411553 */     GIR_RootConstrainSelectedInstOperands,
     /* 411554 */     // GIR_Coverage, 5463,
     /* 411554 */     GIR_Done,
     /* 411555 */   // Label 8594: @411555
     /* 411555 */   GIM_Reject,
     /* 411556 */ // Label 8592: @411556
     /* 411556 */ GIM_Reject,
     /* 411557 */ // Label 8568: @411557
     /* 411557 */ GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(411590), // Rule ID 1891 //
     /* 411562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 411568 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 411571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411579 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411583 */   // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 411583 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
     /* 411588 */   GIR_RootConstrainSelectedInstOperands,
     /* 411589 */   // GIR_Coverage, 1891,
     /* 411589 */   GIR_Done,
     /* 411590 */ // Label 8595: @411590
     /* 411590 */ GIM_Reject,
     /* 411591 */ // Label 8569: @411591
     /* 411591 */ GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(411645),
     /* 411596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 411599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 411602 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411606 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411610 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411614 */   GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(411629), // Rule ID 1894 //
     /* 411619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411622 */     // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 411622 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 411627 */     GIR_RootConstrainSelectedInstOperands,
     /* 411628 */     // GIR_Coverage, 1894,
     /* 411628 */     GIR_Done,
     /* 411629 */   // Label 8597: @411629
     /* 411629 */   GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(411644), // Rule ID 5461 //
     /* 411634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411637 */     // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 411637 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 411642 */     GIR_RootConstrainSelectedInstOperands,
     /* 411643 */     // GIR_Coverage, 5461,
     /* 411643 */     GIR_Done,
     /* 411644 */   // Label 8598: @411644
     /* 411644 */   GIM_Reject,
     /* 411645 */ // Label 8596: @411645
     /* 411645 */ GIM_Reject,
     /* 411646 */ // Label 8570: @411646
     /* 411646 */ GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(411679), // Rule ID 1892 //
     /* 411651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 411657 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 411660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411668 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411672 */   // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 411672 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 411677 */   GIR_RootConstrainSelectedInstOperands,
     /* 411678 */   // GIR_Coverage, 1892,
     /* 411678 */   GIR_Done,
     /* 411679 */ // Label 8599: @411679
     /* 411679 */ GIM_Reject,
     /* 411680 */ // Label 8571: @411680
     /* 411680 */ GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(411705), // Rule ID 8913 //
     /* 411685 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411688 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 411691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 411694 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411698 */   // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 411698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 411703 */   GIR_RootConstrainSelectedInstOperands,
     /* 411704 */   // GIR_Coverage, 8913,
     /* 411704 */   GIR_Done,
     /* 411705 */ // Label 8600: @411705
     /* 411705 */ GIM_Reject,
     /* 411706 */ // Label 8572: @411706
     /* 411706 */ GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(411731), // Rule ID 8882 //
     /* 411711 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411714 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 411717 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 411720 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411724 */   // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 411724 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 411729 */   GIR_RootConstrainSelectedInstOperands,
     /* 411730 */   // GIR_Coverage, 8882,
     /* 411730 */   GIR_Done,
     /* 411731 */ // Label 8601: @411731
     /* 411731 */ GIM_Reject,
     /* 411732 */ // Label 8573: @411732
     /* 411732 */ GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(411757), // Rule ID 8883 //
     /* 411737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 411743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 411746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411750 */   // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 411750 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 411755 */   GIR_RootConstrainSelectedInstOperands,
     /* 411756 */   // GIR_Coverage, 8883,
     /* 411756 */   GIR_Done,
     /* 411757 */ // Label 8602: @411757
     /* 411757 */ GIM_Reject,
     /* 411758 */ // Label 8574: @411758
     /* 411758 */ GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(411804),
     /* 411763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 411766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 411769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411773 */   GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(411788), // Rule ID 8878 //
     /* 411778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411781 */     // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 411781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 411786 */     GIR_RootConstrainSelectedInstOperands,
     /* 411787 */     // GIR_Coverage, 8878,
     /* 411787 */     GIR_Done,
     /* 411788 */   // Label 8604: @411788
     /* 411788 */   GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(411803), // Rule ID 8884 //
     /* 411793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411796 */     // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 411796 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 411801 */     GIR_RootConstrainSelectedInstOperands,
     /* 411802 */     // GIR_Coverage, 8884,
     /* 411802 */     GIR_Done,
     /* 411803 */   // Label 8605: @411803
     /* 411803 */   GIM_Reject,
     /* 411804 */ // Label 8603: @411804
     /* 411804 */ GIM_Reject,
     /* 411805 */ // Label 8575: @411805
     /* 411805 */ GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(411830), // Rule ID 8912 //
     /* 411810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 411816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 411819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411823 */   // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 411823 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 411828 */   GIR_RootConstrainSelectedInstOperands,
     /* 411829 */   // GIR_Coverage, 8912,
     /* 411829 */   GIR_Done,
     /* 411830 */ // Label 8606: @411830
     /* 411830 */ GIM_Reject,
     /* 411831 */ // Label 8576: @411831
     /* 411831 */ GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(411856), // Rule ID 8880 //
     /* 411836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 411842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 411845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411849 */   // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 411849 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 411854 */   GIR_RootConstrainSelectedInstOperands,
     /* 411855 */   // GIR_Coverage, 8880,
     /* 411855 */   GIR_Done,
     /* 411856 */ // Label 8607: @411856
     /* 411856 */ GIM_Reject,
     /* 411857 */ // Label 8577: @411857
     /* 411857 */ GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(411903),
     /* 411862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 411865 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 411868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411872 */   GIM_Try, /*On fail goto*//*Label 8609*/ GIMT_Encode4(411887), // Rule ID 8877 //
     /* 411877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411880 */     // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 411880 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 411885 */     GIR_RootConstrainSelectedInstOperands,
     /* 411886 */     // GIR_Coverage, 8877,
     /* 411886 */     GIR_Done,
     /* 411887 */   // Label 8609: @411887
     /* 411887 */   GIM_Try, /*On fail goto*//*Label 8610*/ GIMT_Encode4(411902), // Rule ID 8881 //
     /* 411892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411895 */     // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 411895 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 411900 */     GIR_RootConstrainSelectedInstOperands,
     /* 411901 */     // GIR_Coverage, 8881,
     /* 411901 */     GIR_Done,
     /* 411902 */   // Label 8610: @411902
     /* 411902 */   GIM_Reject,
     /* 411903 */ // Label 8608: @411903
     /* 411903 */ GIM_Reject,
     /* 411904 */ // Label 8578: @411904
     /* 411904 */ GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(411929), // Rule ID 8911 //
     /* 411909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 411915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 411918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411922 */   // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 411922 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 411927 */   GIR_RootConstrainSelectedInstOperands,
     /* 411928 */   // GIR_Coverage, 8911,
     /* 411928 */   GIR_Done,
     /* 411929 */ // Label 8611: @411929
     /* 411929 */ GIM_Reject,
     /* 411930 */ // Label 8579: @411930
     /* 411930 */ GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(411976),
     /* 411935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 411938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 411941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 411945 */   GIM_Try, /*On fail goto*//*Label 8613*/ GIMT_Encode4(411960), // Rule ID 8876 //
     /* 411950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411953 */     // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 411953 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 411958 */     GIR_RootConstrainSelectedInstOperands,
     /* 411959 */     // GIR_Coverage, 8876,
     /* 411959 */     GIR_Done,
     /* 411960 */   // Label 8613: @411960
     /* 411960 */   GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(411975), // Rule ID 8879 //
     /* 411965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411968 */     // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 411968 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 411973 */     GIR_RootConstrainSelectedInstOperands,
     /* 411974 */     // GIR_Coverage, 8879,
     /* 411974 */     GIR_Done,
     /* 411975 */   // Label 8614: @411975
     /* 411975 */   GIM_Reject,
     /* 411976 */ // Label 8612: @411976
     /* 411976 */ GIM_Reject,
     /* 411977 */ // Label 8580: @411977
     /* 411977 */ GIM_Try, /*On fail goto*//*Label 8615*/ GIMT_Encode4(412002), // Rule ID 2408 //
     /* 411982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 411985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 411988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 411991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 411995 */   // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 411995 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
     /* 412000 */   GIR_RootConstrainSelectedInstOperands,
     /* 412001 */   // GIR_Coverage, 2408,
     /* 412001 */   GIR_Done,
     /* 412002 */ // Label 8615: @412002
     /* 412002 */ GIM_Reject,
     /* 412003 */ // Label 8581: @412003
     /* 412003 */ GIM_Try, /*On fail goto*//*Label 8616*/ GIMT_Encode4(412028), // Rule ID 8875 //
     /* 412008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 412011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 412014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 412017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 412021 */   // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 412021 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
     /* 412026 */   GIR_RootConstrainSelectedInstOperands,
     /* 412027 */   // GIR_Coverage, 8875,
     /* 412027 */   GIR_Done,
     /* 412028 */ // Label 8616: @412028
     /* 412028 */ GIM_Reject,
     /* 412029 */ // Label 8582: @412029
     /* 412029 */ GIM_Reject,
     /* 412030 */ // Label 153: @412030
     /* 412030 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8625*/ GIMT_Encode4(412727),
     /* 412041 */ /*GILLT_s64*//*Label 8617*/ GIMT_Encode4(412077), GIMT_Encode4(0),
     /* 412049 */ /*GILLT_v2s32*//*Label 8618*/ GIMT_Encode4(412188),
     /* 412053 */ /*GILLT_v2s64*//*Label 8619*/ GIMT_Encode4(412265),
     /* 412057 */ /*GILLT_v4s16*//*Label 8620*/ GIMT_Encode4(412342),
     /* 412061 */ /*GILLT_v4s32*//*Label 8621*/ GIMT_Encode4(412419),
     /* 412065 */ /*GILLT_v8s8*//*Label 8622*/ GIMT_Encode4(412496),
     /* 412069 */ /*GILLT_v8s16*//*Label 8623*/ GIMT_Encode4(412573),
     /* 412073 */ /*GILLT_v16s8*//*Label 8624*/ GIMT_Encode4(412650),
     /* 412077 */ // Label 8617: @412077
     /* 412077 */ GIM_Try, /*On fail goto*//*Label 8626*/ GIMT_Encode4(412187),
     /* 412082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 412085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412093 */   GIM_Try, /*On fail goto*//*Label 8627*/ GIMT_Encode4(412118), // Rule ID 5234 //
     /* 412098 */     // MIs[0] Operand 2
     /* 412098 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 412109 */     // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /* 412109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 412112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412116 */     GIR_RootConstrainSelectedInstOperands,
     /* 412117 */     // GIR_Coverage, 5234,
     /* 412117 */     GIR_EraseRootFromParent_Done,
     /* 412118 */   // Label 8627: @412118
     /* 412118 */   GIM_Try, /*On fail goto*//*Label 8628*/ GIMT_Encode4(412152), // Rule ID 2118 //
     /* 412123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412126 */     // MIs[0] imm
     /* 412126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412134 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 412138 */     // MIs[1] Operand 1
     /* 412138 */     // No operand predicates
     /* 412138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412140 */     // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 412143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412150 */     GIR_RootConstrainSelectedInstOperands,
     /* 412151 */     // GIR_Coverage, 2118,
     /* 412151 */     GIR_EraseRootFromParent_Done,
     /* 412152 */   // Label 8628: @412152
     /* 412152 */   GIM_Try, /*On fail goto*//*Label 8629*/ GIMT_Encode4(412186), // Rule ID 6259 //
     /* 412157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412160 */     // MIs[0] imm
     /* 412160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412168 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 412172 */     // MIs[1] Operand 1
     /* 412172 */     // No operand predicates
     /* 412172 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412174 */     // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 412174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 412177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412179 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412184 */     GIR_RootConstrainSelectedInstOperands,
     /* 412185 */     // GIR_Coverage, 6259,
     /* 412185 */     GIR_EraseRootFromParent_Done,
     /* 412186 */   // Label 8629: @412186
     /* 412186 */   GIM_Reject,
     /* 412187 */ // Label 8626: @412187
     /* 412187 */ GIM_Reject,
     /* 412188 */ // Label 8618: @412188
     /* 412188 */ GIM_Try, /*On fail goto*//*Label 8630*/ GIMT_Encode4(412264),
     /* 412193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412204 */   GIM_Try, /*On fail goto*//*Label 8631*/ GIMT_Encode4(412229), // Rule ID 4878 //
     /* 412209 */     // MIs[0] Operand 2
     /* 412209 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 412220 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 412220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 412223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412225 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412227 */     GIR_RootConstrainSelectedInstOperands,
     /* 412228 */     // GIR_Coverage, 4878,
     /* 412228 */     GIR_EraseRootFromParent_Done,
     /* 412229 */   // Label 8631: @412229
     /* 412229 */   GIM_Try, /*On fail goto*//*Label 8632*/ GIMT_Encode4(412263), // Rule ID 2225 //
     /* 412234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412237 */     // MIs[0] imm
     /* 412237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412245 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 412249 */     // MIs[1] Operand 1
     /* 412249 */     // No operand predicates
     /* 412249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412251 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
     /* 412254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412256 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412258 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412261 */     GIR_RootConstrainSelectedInstOperands,
     /* 412262 */     // GIR_Coverage, 2225,
     /* 412262 */     GIR_EraseRootFromParent_Done,
     /* 412263 */   // Label 8632: @412263
     /* 412263 */   GIM_Reject,
     /* 412264 */ // Label 8630: @412264
     /* 412264 */ GIM_Reject,
     /* 412265 */ // Label 8619: @412265
     /* 412265 */ GIM_Try, /*On fail goto*//*Label 8633*/ GIMT_Encode4(412341),
     /* 412270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412281 */   GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(412306), // Rule ID 4882 //
     /* 412286 */     // MIs[0] Operand 2
     /* 412286 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 412297 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 412297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 412300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412302 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412304 */     GIR_RootConstrainSelectedInstOperands,
     /* 412305 */     // GIR_Coverage, 4882,
     /* 412305 */     GIR_EraseRootFromParent_Done,
     /* 412306 */   // Label 8634: @412306
     /* 412306 */   GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(412340), // Rule ID 2227 //
     /* 412311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412314 */     // MIs[0] imm
     /* 412314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412322 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 412326 */     // MIs[1] Operand 1
     /* 412326 */     // No operand predicates
     /* 412326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412328 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
     /* 412331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412333 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412338 */     GIR_RootConstrainSelectedInstOperands,
     /* 412339 */     // GIR_Coverage, 2227,
     /* 412339 */     GIR_EraseRootFromParent_Done,
     /* 412340 */   // Label 8635: @412340
     /* 412340 */   GIM_Reject,
     /* 412341 */ // Label 8633: @412341
     /* 412341 */ GIM_Reject,
     /* 412342 */ // Label 8620: @412342
     /* 412342 */ GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(412418),
     /* 412347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412358 */   GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(412383), // Rule ID 4877 //
     /* 412363 */     // MIs[0] Operand 2
     /* 412363 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 412374 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 412374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 412377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412381 */     GIR_RootConstrainSelectedInstOperands,
     /* 412382 */     // GIR_Coverage, 4877,
     /* 412382 */     GIR_EraseRootFromParent_Done,
     /* 412383 */   // Label 8637: @412383
     /* 412383 */   GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(412417), // Rule ID 2223 //
     /* 412388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412391 */     // MIs[0] imm
     /* 412391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412395 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412399 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 412403 */     // MIs[1] Operand 1
     /* 412403 */     // No operand predicates
     /* 412403 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412405 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
     /* 412408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412415 */     GIR_RootConstrainSelectedInstOperands,
     /* 412416 */     // GIR_Coverage, 2223,
     /* 412416 */     GIR_EraseRootFromParent_Done,
     /* 412417 */   // Label 8638: @412417
     /* 412417 */   GIM_Reject,
     /* 412418 */ // Label 8636: @412418
     /* 412418 */ GIM_Reject,
     /* 412419 */ // Label 8621: @412419
     /* 412419 */ GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(412495),
     /* 412424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 412427 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412431 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412435 */   GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(412460), // Rule ID 4881 //
     /* 412440 */     // MIs[0] Operand 2
     /* 412440 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 412451 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 412451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 412454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412456 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412458 */     GIR_RootConstrainSelectedInstOperands,
     /* 412459 */     // GIR_Coverage, 4881,
     /* 412459 */     GIR_EraseRootFromParent_Done,
     /* 412460 */   // Label 8640: @412460
     /* 412460 */   GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(412494), // Rule ID 2226 //
     /* 412465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412468 */     // MIs[0] imm
     /* 412468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412476 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 412480 */     // MIs[1] Operand 1
     /* 412480 */     // No operand predicates
     /* 412480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412482 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
     /* 412485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412492 */     GIR_RootConstrainSelectedInstOperands,
     /* 412493 */     // GIR_Coverage, 2226,
     /* 412493 */     GIR_EraseRootFromParent_Done,
     /* 412494 */   // Label 8641: @412494
     /* 412494 */   GIM_Reject,
     /* 412495 */ // Label 8639: @412495
     /* 412495 */ GIM_Reject,
     /* 412496 */ // Label 8622: @412496
     /* 412496 */ GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(412572),
     /* 412501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 412504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412512 */   GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(412537), // Rule ID 4876 //
     /* 412517 */     // MIs[0] Operand 2
     /* 412517 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 412528 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 412528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 412531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412535 */     GIR_RootConstrainSelectedInstOperands,
     /* 412536 */     // GIR_Coverage, 4876,
     /* 412536 */     GIR_EraseRootFromParent_Done,
     /* 412537 */   // Label 8643: @412537
     /* 412537 */   GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(412571), // Rule ID 2221 //
     /* 412542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412545 */     // MIs[0] imm
     /* 412545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412553 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 412557 */     // MIs[1] Operand 1
     /* 412557 */     // No operand predicates
     /* 412557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412559 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
     /* 412562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412564 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412569 */     GIR_RootConstrainSelectedInstOperands,
     /* 412570 */     // GIR_Coverage, 2221,
     /* 412570 */     GIR_EraseRootFromParent_Done,
     /* 412571 */   // Label 8644: @412571
     /* 412571 */   GIM_Reject,
     /* 412572 */ // Label 8642: @412572
     /* 412572 */ GIM_Reject,
     /* 412573 */ // Label 8623: @412573
     /* 412573 */ GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(412649),
     /* 412578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 412581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412589 */   GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(412614), // Rule ID 4880 //
     /* 412594 */     // MIs[0] Operand 2
     /* 412594 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 412605 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 412605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 412608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412610 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412612 */     GIR_RootConstrainSelectedInstOperands,
     /* 412613 */     // GIR_Coverage, 4880,
     /* 412613 */     GIR_EraseRootFromParent_Done,
     /* 412614 */   // Label 8646: @412614
     /* 412614 */   GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(412648), // Rule ID 2224 //
     /* 412619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412622 */     // MIs[0] imm
     /* 412622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412630 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 412634 */     // MIs[1] Operand 1
     /* 412634 */     // No operand predicates
     /* 412634 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412636 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
     /* 412639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412646 */     GIR_RootConstrainSelectedInstOperands,
     /* 412647 */     // GIR_Coverage, 2224,
     /* 412647 */     GIR_EraseRootFromParent_Done,
     /* 412648 */   // Label 8647: @412648
     /* 412648 */   GIM_Reject,
     /* 412649 */ // Label 8645: @412649
     /* 412649 */ GIM_Reject,
     /* 412650 */ // Label 8624: @412650
     /* 412650 */ GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(412726),
     /* 412655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 412658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412666 */   GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(412691), // Rule ID 4879 //
     /* 412671 */     // MIs[0] Operand 2
     /* 412671 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 412682 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 412682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 412685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412689 */     GIR_RootConstrainSelectedInstOperands,
     /* 412690 */     // GIR_Coverage, 4879,
     /* 412690 */     GIR_EraseRootFromParent_Done,
     /* 412691 */   // Label 8649: @412691
     /* 412691 */   GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(412725), // Rule ID 2222 //
     /* 412696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412699 */     // MIs[0] imm
     /* 412699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412707 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 412711 */     // MIs[1] Operand 1
     /* 412711 */     // No operand predicates
     /* 412711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412713 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
     /* 412716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412720 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412723 */     GIR_RootConstrainSelectedInstOperands,
     /* 412724 */     // GIR_Coverage, 2222,
     /* 412724 */     GIR_EraseRootFromParent_Done,
     /* 412725 */   // Label 8650: @412725
     /* 412725 */   GIM_Reject,
     /* 412726 */ // Label 8648: @412726
     /* 412726 */ GIM_Reject,
     /* 412727 */ // Label 8625: @412727
     /* 412727 */ GIM_Reject,
     /* 412728 */ // Label 154: @412728
     /* 412728 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8659*/ GIMT_Encode4(413183),
     /* 412739 */ /*GILLT_s64*//*Label 8651*/ GIMT_Encode4(412775), GIMT_Encode4(0),
     /* 412747 */ /*GILLT_v2s32*//*Label 8652*/ GIMT_Encode4(412861),
     /* 412751 */ /*GILLT_v2s64*//*Label 8653*/ GIMT_Encode4(412907),
     /* 412755 */ /*GILLT_v4s16*//*Label 8654*/ GIMT_Encode4(412953),
     /* 412759 */ /*GILLT_v4s32*//*Label 8655*/ GIMT_Encode4(412999),
     /* 412763 */ /*GILLT_v8s8*//*Label 8656*/ GIMT_Encode4(413045),
     /* 412767 */ /*GILLT_v8s16*//*Label 8657*/ GIMT_Encode4(413091),
     /* 412771 */ /*GILLT_v16s8*//*Label 8658*/ GIMT_Encode4(413137),
     /* 412775 */ // Label 8651: @412775
     /* 412775 */ GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(412860),
     /* 412780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 412783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412791 */   GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(412825), // Rule ID 2127 //
     /* 412796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412799 */     // MIs[0] imm
     /* 412799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412807 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 412811 */     // MIs[1] Operand 1
     /* 412811 */     // No operand predicates
     /* 412811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412813 */     // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 412816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412818 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412820 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412823 */     GIR_RootConstrainSelectedInstOperands,
     /* 412824 */     // GIR_Coverage, 2127,
     /* 412824 */     GIR_EraseRootFromParent_Done,
     /* 412825 */   // Label 8661: @412825
     /* 412825 */   GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(412859), // Rule ID 6265 //
     /* 412830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412833 */     // MIs[0] imm
     /* 412833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412841 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 412845 */     // MIs[1] Operand 1
     /* 412845 */     // No operand predicates
     /* 412845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412847 */     // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 412847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 412850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412857 */     GIR_RootConstrainSelectedInstOperands,
     /* 412858 */     // GIR_Coverage, 6265,
     /* 412858 */     GIR_EraseRootFromParent_Done,
     /* 412859 */   // Label 8662: @412859
     /* 412859 */   GIM_Reject,
     /* 412860 */ // Label 8660: @412860
     /* 412860 */ GIM_Reject,
     /* 412861 */ // Label 8652: @412861
     /* 412861 */ GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(412906), // Rule ID 2284 //
     /* 412866 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 412872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412876 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412880 */   // MIs[0] imm
     /* 412880 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412884 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412888 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 412892 */   // MIs[1] Operand 1
     /* 412892 */   // No operand predicates
     /* 412892 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412894 */   // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
     /* 412897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412899 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412901 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412904 */   GIR_RootConstrainSelectedInstOperands,
     /* 412905 */   // GIR_Coverage, 2284,
     /* 412905 */   GIR_EraseRootFromParent_Done,
     /* 412906 */ // Label 8663: @412906
     /* 412906 */ GIM_Reject,
     /* 412907 */ // Label 8653: @412907
     /* 412907 */ GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(412952), // Rule ID 2286 //
     /* 412912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412926 */   // MIs[0] imm
     /* 412926 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412930 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412934 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 412938 */   // MIs[1] Operand 1
     /* 412938 */   // No operand predicates
     /* 412938 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412940 */   // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
     /* 412943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412945 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412947 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412950 */   GIR_RootConstrainSelectedInstOperands,
     /* 412951 */   // GIR_Coverage, 2286,
     /* 412951 */   GIR_EraseRootFromParent_Done,
     /* 412952 */ // Label 8664: @412952
     /* 412952 */ GIM_Reject,
     /* 412953 */ // Label 8654: @412953
     /* 412953 */ GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(412998), // Rule ID 2282 //
     /* 412958 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 412964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412968 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412972 */   // MIs[0] imm
     /* 412972 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412976 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412980 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 412984 */   // MIs[1] Operand 1
     /* 412984 */   // No operand predicates
     /* 412984 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 412986 */   // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 412986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
     /* 412989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 412991 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412993 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 412996 */   GIR_RootConstrainSelectedInstOperands,
     /* 412997 */   // GIR_Coverage, 2282,
     /* 412997 */   GIR_EraseRootFromParent_Done,
     /* 412998 */ // Label 8665: @412998
     /* 412998 */ GIM_Reject,
     /* 412999 */ // Label 8655: @412999
     /* 412999 */ GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(413044), // Rule ID 2285 //
     /* 413004 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413007 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413010 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413014 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413018 */   // MIs[0] imm
     /* 413018 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413022 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413026 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 413030 */   // MIs[1] Operand 1
     /* 413030 */   // No operand predicates
     /* 413030 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413032 */   // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 413032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
     /* 413035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413037 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413039 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 413042 */   GIR_RootConstrainSelectedInstOperands,
     /* 413043 */   // GIR_Coverage, 2285,
     /* 413043 */   GIR_EraseRootFromParent_Done,
     /* 413044 */ // Label 8666: @413044
     /* 413044 */ GIM_Reject,
     /* 413045 */ // Label 8656: @413045
     /* 413045 */ GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(413090), // Rule ID 2280 //
     /* 413050 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413053 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 413056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413064 */   // MIs[0] imm
     /* 413064 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413068 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413072 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 413076 */   // MIs[1] Operand 1
     /* 413076 */   // No operand predicates
     /* 413076 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413078 */   // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 413078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
     /* 413081 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413083 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413085 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 413088 */   GIR_RootConstrainSelectedInstOperands,
     /* 413089 */   // GIR_Coverage, 2280,
     /* 413089 */   GIR_EraseRootFromParent_Done,
     /* 413090 */ // Label 8667: @413090
     /* 413090 */ GIM_Reject,
     /* 413091 */ // Label 8657: @413091
     /* 413091 */ GIM_Try, /*On fail goto*//*Label 8668*/ GIMT_Encode4(413136), // Rule ID 2283 //
     /* 413096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413110 */   // MIs[0] imm
     /* 413110 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413114 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413118 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 413122 */   // MIs[1] Operand 1
     /* 413122 */   // No operand predicates
     /* 413122 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413124 */   // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 413124 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
     /* 413127 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413129 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413131 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 413134 */   GIR_RootConstrainSelectedInstOperands,
     /* 413135 */   // GIR_Coverage, 2283,
     /* 413135 */   GIR_EraseRootFromParent_Done,
     /* 413136 */ // Label 8668: @413136
     /* 413136 */ GIM_Reject,
     /* 413137 */ // Label 8658: @413137
     /* 413137 */ GIM_Try, /*On fail goto*//*Label 8669*/ GIMT_Encode4(413182), // Rule ID 2281 //
     /* 413142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 413148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413156 */   // MIs[0] imm
     /* 413156 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413160 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413164 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 413168 */   // MIs[1] Operand 1
     /* 413168 */   // No operand predicates
     /* 413168 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413170 */   // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 413170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
     /* 413173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 413175 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413177 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 413180 */   GIR_RootConstrainSelectedInstOperands,
     /* 413181 */   // GIR_Coverage, 2281,
     /* 413181 */   GIR_EraseRootFromParent_Done,
     /* 413182 */ // Label 8669: @413182
     /* 413182 */ GIM_Reject,
     /* 413183 */ // Label 8659: @413183
     /* 413183 */ GIM_Reject,
     /* 413184 */ // Label 155: @413184
     /* 413184 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8688*/ GIMT_Encode4(413963),
     /* 413195 */ /*GILLT_v2s32*//*Label 8670*/ GIMT_Encode4(413271),
     /* 413199 */ /*GILLT_v2s64*//*Label 8671*/ GIMT_Encode4(413326),
     /* 413203 */ /*GILLT_v4s16*//*Label 8672*/ GIMT_Encode4(413381),
     /* 413207 */ /*GILLT_v4s32*//*Label 8673*/ GIMT_Encode4(413436),
     /* 413211 */ /*GILLT_v8s8*//*Label 8674*/ GIMT_Encode4(413491),
     /* 413215 */ /*GILLT_v8s16*//*Label 8675*/ GIMT_Encode4(413525),
     /* 413219 */ /*GILLT_v16s8*//*Label 8676*/ GIMT_Encode4(413580), GIMT_Encode4(0),
     /* 413227 */ /*GILLT_nxv2s1*//*Label 8677*/ GIMT_Encode4(413614),
     /* 413231 */ /*GILLT_nxv2s16*//*Label 8678*/ GIMT_Encode4(413640),
     /* 413235 */ /*GILLT_nxv2s32*//*Label 8679*/ GIMT_Encode4(413666),
     /* 413239 */ /*GILLT_nxv2s64*//*Label 8680*/ GIMT_Encode4(413692),
     /* 413243 */ /*GILLT_nxv4s1*//*Label 8681*/ GIMT_Encode4(413739),
     /* 413247 */ /*GILLT_nxv4s16*//*Label 8682*/ GIMT_Encode4(413765),
     /* 413251 */ /*GILLT_nxv4s32*//*Label 8683*/ GIMT_Encode4(413791),
     /* 413255 */ /*GILLT_nxv8s1*//*Label 8684*/ GIMT_Encode4(413838),
     /* 413259 */ /*GILLT_nxv8s16*//*Label 8685*/ GIMT_Encode4(413864),
     /* 413263 */ /*GILLT_nxv16s1*//*Label 8686*/ GIMT_Encode4(413911),
     /* 413267 */ /*GILLT_nxv16s8*//*Label 8687*/ GIMT_Encode4(413937),
     /* 413271 */ // Label 8670: @413271
     /* 413271 */ GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(413325),
     /* 413276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 413279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 413282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413290 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413294 */   GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(413309), // Rule ID 1902 //
     /* 413299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413302 */     // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 413302 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 413307 */     GIR_RootConstrainSelectedInstOperands,
     /* 413308 */     // GIR_Coverage, 1902,
     /* 413308 */     GIR_Done,
     /* 413309 */   // Label 8690: @413309
     /* 413309 */   GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(413324), // Rule ID 5467 //
     /* 413314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413317 */     // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 413317 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 413322 */     GIR_RootConstrainSelectedInstOperands,
     /* 413323 */     // GIR_Coverage, 5467,
     /* 413323 */     GIR_Done,
     /* 413324 */   // Label 8691: @413324
     /* 413324 */   GIM_Reject,
     /* 413325 */ // Label 8689: @413325
     /* 413325 */ GIM_Reject,
     /* 413326 */ // Label 8671: @413326
     /* 413326 */ GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(413380),
     /* 413331 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413334 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 413337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413345 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413349 */   GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(413364), // Rule ID 1904 //
     /* 413354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413357 */     // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 413357 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 413362 */     GIR_RootConstrainSelectedInstOperands,
     /* 413363 */     // GIR_Coverage, 1904,
     /* 413363 */     GIR_Done,
     /* 413364 */   // Label 8693: @413364
     /* 413364 */   GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(413379), // Rule ID 5469 //
     /* 413369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413372 */     // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 413372 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 413377 */     GIR_RootConstrainSelectedInstOperands,
     /* 413378 */     // GIR_Coverage, 5469,
     /* 413378 */     GIR_Done,
     /* 413379 */   // Label 8694: @413379
     /* 413379 */   GIM_Reject,
     /* 413380 */ // Label 8692: @413380
     /* 413380 */ GIM_Reject,
     /* 413381 */ // Label 8672: @413381
     /* 413381 */ GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(413435),
     /* 413386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 413392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413400 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413404 */   GIM_Try, /*On fail goto*//*Label 8696*/ GIMT_Encode4(413419), // Rule ID 1900 //
     /* 413409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413412 */     // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 413412 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 413417 */     GIR_RootConstrainSelectedInstOperands,
     /* 413418 */     // GIR_Coverage, 1900,
     /* 413418 */     GIR_Done,
     /* 413419 */   // Label 8696: @413419
     /* 413419 */   GIM_Try, /*On fail goto*//*Label 8697*/ GIMT_Encode4(413434), // Rule ID 5465 //
     /* 413424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413427 */     // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 413427 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 413432 */     GIR_RootConstrainSelectedInstOperands,
     /* 413433 */     // GIR_Coverage, 5465,
     /* 413433 */     GIR_Done,
     /* 413434 */   // Label 8697: @413434
     /* 413434 */   GIM_Reject,
     /* 413435 */ // Label 8695: @413435
     /* 413435 */ GIM_Reject,
     /* 413436 */ // Label 8673: @413436
     /* 413436 */ GIM_Try, /*On fail goto*//*Label 8698*/ GIMT_Encode4(413490),
     /* 413441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 413444 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 413447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413451 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413455 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413459 */   GIM_Try, /*On fail goto*//*Label 8699*/ GIMT_Encode4(413474), // Rule ID 1903 //
     /* 413464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413467 */     // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 413467 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 413472 */     GIR_RootConstrainSelectedInstOperands,
     /* 413473 */     // GIR_Coverage, 1903,
     /* 413473 */     GIR_Done,
     /* 413474 */   // Label 8699: @413474
     /* 413474 */   GIM_Try, /*On fail goto*//*Label 8700*/ GIMT_Encode4(413489), // Rule ID 5468 //
     /* 413479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413482 */     // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 413482 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 413487 */     GIR_RootConstrainSelectedInstOperands,
     /* 413488 */     // GIR_Coverage, 5468,
     /* 413488 */     GIR_Done,
     /* 413489 */   // Label 8700: @413489
     /* 413489 */   GIM_Reject,
     /* 413490 */ // Label 8698: @413490
     /* 413490 */ GIM_Reject,
     /* 413491 */ // Label 8674: @413491
     /* 413491 */ GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(413524), // Rule ID 1898 //
     /* 413496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 413502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 413505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413513 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413517 */   // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 413517 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 413522 */   GIR_RootConstrainSelectedInstOperands,
     /* 413523 */   // GIR_Coverage, 1898,
     /* 413523 */   GIR_Done,
     /* 413524 */ // Label 8701: @413524
     /* 413524 */ GIM_Reject,
     /* 413525 */ // Label 8675: @413525
     /* 413525 */ GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(413579),
     /* 413530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 413536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413544 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413548 */   GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(413563), // Rule ID 1901 //
     /* 413553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413556 */     // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 413556 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 413561 */     GIR_RootConstrainSelectedInstOperands,
     /* 413562 */     // GIR_Coverage, 1901,
     /* 413562 */     GIR_Done,
     /* 413563 */   // Label 8703: @413563
     /* 413563 */   GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(413578), // Rule ID 5466 //
     /* 413568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413571 */     // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 413571 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 413576 */     GIR_RootConstrainSelectedInstOperands,
     /* 413577 */     // GIR_Coverage, 5466,
     /* 413577 */     GIR_Done,
     /* 413578 */   // Label 8704: @413578
     /* 413578 */   GIM_Reject,
     /* 413579 */ // Label 8702: @413579
     /* 413579 */ GIM_Reject,
     /* 413580 */ // Label 8676: @413580
     /* 413580 */ GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(413613), // Rule ID 1899 //
     /* 413585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 413591 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 413594 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413598 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413602 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413606 */   // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 413606 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
     /* 413611 */   GIR_RootConstrainSelectedInstOperands,
     /* 413612 */   // GIR_Coverage, 1899,
     /* 413612 */   GIR_Done,
     /* 413613 */ // Label 8705: @413613
     /* 413613 */ GIM_Reject,
     /* 413614 */ // Label 8677: @413614
     /* 413614 */ GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(413639), // Rule ID 3346 //
     /* 413619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 413625 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 413628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 413632 */   // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 413632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 413637 */   GIR_RootConstrainSelectedInstOperands,
     /* 413638 */   // GIR_Coverage, 3346,
     /* 413638 */   GIR_Done,
     /* 413639 */ // Label 8706: @413639
     /* 413639 */ GIM_Reject,
     /* 413640 */ // Label 8678: @413640
     /* 413640 */ GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(413665), // Rule ID 2877 //
     /* 413645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 413651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 413654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413658 */   // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 413658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 413663 */   GIR_RootConstrainSelectedInstOperands,
     /* 413664 */   // GIR_Coverage, 2877,
     /* 413664 */   GIR_Done,
     /* 413665 */ // Label 8707: @413665
     /* 413665 */ GIM_Reject,
     /* 413666 */ // Label 8679: @413666
     /* 413666 */ GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(413691), // Rule ID 2878 //
     /* 413671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 413677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 413680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413684 */   // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 413684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 413689 */   GIR_RootConstrainSelectedInstOperands,
     /* 413690 */   // GIR_Coverage, 2878,
     /* 413690 */   GIR_Done,
     /* 413691 */ // Label 8708: @413691
     /* 413691 */ GIM_Reject,
     /* 413692 */ // Label 8680: @413692
     /* 413692 */ GIM_Try, /*On fail goto*//*Label 8709*/ GIMT_Encode4(413738),
     /* 413697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 413700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 413703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413707 */   GIM_Try, /*On fail goto*//*Label 8710*/ GIMT_Encode4(413722), // Rule ID 2873 //
     /* 413712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413715 */     // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 413715 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 413720 */     GIR_RootConstrainSelectedInstOperands,
     /* 413721 */     // GIR_Coverage, 2873,
     /* 413721 */     GIR_Done,
     /* 413722 */   // Label 8710: @413722
     /* 413722 */   GIM_Try, /*On fail goto*//*Label 8711*/ GIMT_Encode4(413737), // Rule ID 2879 //
     /* 413727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413730 */     // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 413730 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 413735 */     GIR_RootConstrainSelectedInstOperands,
     /* 413736 */     // GIR_Coverage, 2879,
     /* 413736 */     GIR_Done,
     /* 413737 */   // Label 8711: @413737
     /* 413737 */   GIM_Reject,
     /* 413738 */ // Label 8709: @413738
     /* 413738 */ GIM_Reject,
     /* 413739 */ // Label 8681: @413739
     /* 413739 */ GIM_Try, /*On fail goto*//*Label 8712*/ GIMT_Encode4(413764), // Rule ID 3345 //
     /* 413744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 413750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 413753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 413757 */   // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 413757 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 413762 */   GIR_RootConstrainSelectedInstOperands,
     /* 413763 */   // GIR_Coverage, 3345,
     /* 413763 */   GIR_Done,
     /* 413764 */ // Label 8712: @413764
     /* 413764 */ GIM_Reject,
     /* 413765 */ // Label 8682: @413765
     /* 413765 */ GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(413790), // Rule ID 2875 //
     /* 413770 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413773 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 413776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 413779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413783 */   // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 413783 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 413788 */   GIR_RootConstrainSelectedInstOperands,
     /* 413789 */   // GIR_Coverage, 2875,
     /* 413789 */   GIR_Done,
     /* 413790 */ // Label 8713: @413790
     /* 413790 */ GIM_Reject,
     /* 413791 */ // Label 8683: @413791
     /* 413791 */ GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(413837),
     /* 413796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 413799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 413802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413806 */   GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(413821), // Rule ID 2872 //
     /* 413811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413814 */     // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 413814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 413819 */     GIR_RootConstrainSelectedInstOperands,
     /* 413820 */     // GIR_Coverage, 2872,
     /* 413820 */     GIR_Done,
     /* 413821 */   // Label 8715: @413821
     /* 413821 */   GIM_Try, /*On fail goto*//*Label 8716*/ GIMT_Encode4(413836), // Rule ID 2876 //
     /* 413826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413829 */     // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 413829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 413834 */     GIR_RootConstrainSelectedInstOperands,
     /* 413835 */     // GIR_Coverage, 2876,
     /* 413835 */     GIR_Done,
     /* 413836 */   // Label 8716: @413836
     /* 413836 */   GIM_Reject,
     /* 413837 */ // Label 8714: @413837
     /* 413837 */ GIM_Reject,
     /* 413838 */ // Label 8684: @413838
     /* 413838 */ GIM_Try, /*On fail goto*//*Label 8717*/ GIMT_Encode4(413863), // Rule ID 3344 //
     /* 413843 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 413849 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 413852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 413856 */   // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 413856 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 413861 */   GIR_RootConstrainSelectedInstOperands,
     /* 413862 */   // GIR_Coverage, 3344,
     /* 413862 */   GIR_Done,
     /* 413863 */ // Label 8717: @413863
     /* 413863 */ GIM_Reject,
     /* 413864 */ // Label 8685: @413864
     /* 413864 */ GIM_Try, /*On fail goto*//*Label 8718*/ GIMT_Encode4(413910),
     /* 413869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 413872 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 413875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413879 */   GIM_Try, /*On fail goto*//*Label 8719*/ GIMT_Encode4(413894), // Rule ID 2871 //
     /* 413884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413887 */     // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 413887 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 413892 */     GIR_RootConstrainSelectedInstOperands,
     /* 413893 */     // GIR_Coverage, 2871,
     /* 413893 */     GIR_Done,
     /* 413894 */   // Label 8719: @413894
     /* 413894 */   GIM_Try, /*On fail goto*//*Label 8720*/ GIMT_Encode4(413909), // Rule ID 2874 //
     /* 413899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413902 */     // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 413902 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 413907 */     GIR_RootConstrainSelectedInstOperands,
     /* 413908 */     // GIR_Coverage, 2874,
     /* 413908 */     GIR_Done,
     /* 413909 */   // Label 8720: @413909
     /* 413909 */   GIM_Reject,
     /* 413910 */ // Label 8718: @413910
     /* 413910 */ GIM_Reject,
     /* 413911 */ // Label 8686: @413911
     /* 413911 */ GIM_Try, /*On fail goto*//*Label 8721*/ GIMT_Encode4(413936), // Rule ID 2396 //
     /* 413916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 413922 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 413925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 413929 */   // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 413929 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
     /* 413934 */   GIR_RootConstrainSelectedInstOperands,
     /* 413935 */   // GIR_Coverage, 2396,
     /* 413935 */   GIR_Done,
     /* 413936 */ // Label 8721: @413936
     /* 413936 */ GIM_Reject,
     /* 413937 */ // Label 8687: @413937
     /* 413937 */ GIM_Try, /*On fail goto*//*Label 8722*/ GIMT_Encode4(413962), // Rule ID 2870 //
     /* 413942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 413945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 413948 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 413951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 413955 */   // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 413955 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
     /* 413960 */   GIR_RootConstrainSelectedInstOperands,
     /* 413961 */   // GIR_Coverage, 2870,
     /* 413961 */   GIR_Done,
     /* 413962 */ // Label 8722: @413962
     /* 413962 */ GIM_Reject,
     /* 413963 */ // Label 8688: @413963
     /* 413963 */ GIM_Reject,
     /* 413964 */ // Label 156: @413964
     /* 413964 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8741*/ GIMT_Encode4(414743),
     /* 413975 */ /*GILLT_v2s32*//*Label 8723*/ GIMT_Encode4(414051),
     /* 413979 */ /*GILLT_v2s64*//*Label 8724*/ GIMT_Encode4(414106),
     /* 413983 */ /*GILLT_v4s16*//*Label 8725*/ GIMT_Encode4(414161),
     /* 413987 */ /*GILLT_v4s32*//*Label 8726*/ GIMT_Encode4(414216),
     /* 413991 */ /*GILLT_v8s8*//*Label 8727*/ GIMT_Encode4(414271),
     /* 413995 */ /*GILLT_v8s16*//*Label 8728*/ GIMT_Encode4(414305),
     /* 413999 */ /*GILLT_v16s8*//*Label 8729*/ GIMT_Encode4(414360), GIMT_Encode4(0),
     /* 414007 */ /*GILLT_nxv2s1*//*Label 8730*/ GIMT_Encode4(414394),
     /* 414011 */ /*GILLT_nxv2s16*//*Label 8731*/ GIMT_Encode4(414420),
     /* 414015 */ /*GILLT_nxv2s32*//*Label 8732*/ GIMT_Encode4(414446),
     /* 414019 */ /*GILLT_nxv2s64*//*Label 8733*/ GIMT_Encode4(414472),
     /* 414023 */ /*GILLT_nxv4s1*//*Label 8734*/ GIMT_Encode4(414519),
     /* 414027 */ /*GILLT_nxv4s16*//*Label 8735*/ GIMT_Encode4(414545),
     /* 414031 */ /*GILLT_nxv4s32*//*Label 8736*/ GIMT_Encode4(414571),
     /* 414035 */ /*GILLT_nxv8s1*//*Label 8737*/ GIMT_Encode4(414618),
     /* 414039 */ /*GILLT_nxv8s16*//*Label 8738*/ GIMT_Encode4(414644),
     /* 414043 */ /*GILLT_nxv16s1*//*Label 8739*/ GIMT_Encode4(414691),
     /* 414047 */ /*GILLT_nxv16s8*//*Label 8740*/ GIMT_Encode4(414717),
     /* 414051 */ // Label 8723: @414051
     /* 414051 */ GIM_Try, /*On fail goto*//*Label 8742*/ GIMT_Encode4(414105),
     /* 414056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 414059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 414062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414070 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414074 */   GIM_Try, /*On fail goto*//*Label 8743*/ GIMT_Encode4(414089), // Rule ID 1909 //
     /* 414079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414082 */     // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 414082 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 414087 */     GIR_RootConstrainSelectedInstOperands,
     /* 414088 */     // GIR_Coverage, 1909,
     /* 414088 */     GIR_Done,
     /* 414089 */   // Label 8743: @414089
     /* 414089 */   GIM_Try, /*On fail goto*//*Label 8744*/ GIMT_Encode4(414104), // Rule ID 5472 //
     /* 414094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414097 */     // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 414097 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 414102 */     GIR_RootConstrainSelectedInstOperands,
     /* 414103 */     // GIR_Coverage, 5472,
     /* 414103 */     GIR_Done,
     /* 414104 */   // Label 8744: @414104
     /* 414104 */   GIM_Reject,
     /* 414105 */ // Label 8742: @414105
     /* 414105 */ GIM_Reject,
     /* 414106 */ // Label 8724: @414106
     /* 414106 */ GIM_Try, /*On fail goto*//*Label 8745*/ GIMT_Encode4(414160),
     /* 414111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 414114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 414117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414125 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414129 */   GIM_Try, /*On fail goto*//*Label 8746*/ GIMT_Encode4(414144), // Rule ID 1911 //
     /* 414134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414137 */     // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 414137 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 414142 */     GIR_RootConstrainSelectedInstOperands,
     /* 414143 */     // GIR_Coverage, 1911,
     /* 414143 */     GIR_Done,
     /* 414144 */   // Label 8746: @414144
     /* 414144 */   GIM_Try, /*On fail goto*//*Label 8747*/ GIMT_Encode4(414159), // Rule ID 5474 //
     /* 414149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414152 */     // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 414152 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 414157 */     GIR_RootConstrainSelectedInstOperands,
     /* 414158 */     // GIR_Coverage, 5474,
     /* 414158 */     GIR_Done,
     /* 414159 */   // Label 8747: @414159
     /* 414159 */   GIM_Reject,
     /* 414160 */ // Label 8745: @414160
     /* 414160 */ GIM_Reject,
     /* 414161 */ // Label 8725: @414161
     /* 414161 */ GIM_Try, /*On fail goto*//*Label 8748*/ GIMT_Encode4(414215),
     /* 414166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414169 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 414172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414180 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414184 */   GIM_Try, /*On fail goto*//*Label 8749*/ GIMT_Encode4(414199), // Rule ID 1907 //
     /* 414189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414192 */     // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 414192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 414197 */     GIR_RootConstrainSelectedInstOperands,
     /* 414198 */     // GIR_Coverage, 1907,
     /* 414198 */     GIR_Done,
     /* 414199 */   // Label 8749: @414199
     /* 414199 */   GIM_Try, /*On fail goto*//*Label 8750*/ GIMT_Encode4(414214), // Rule ID 5470 //
     /* 414204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414207 */     // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 414207 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 414212 */     GIR_RootConstrainSelectedInstOperands,
     /* 414213 */     // GIR_Coverage, 5470,
     /* 414213 */     GIR_Done,
     /* 414214 */   // Label 8750: @414214
     /* 414214 */   GIM_Reject,
     /* 414215 */ // Label 8748: @414215
     /* 414215 */ GIM_Reject,
     /* 414216 */ // Label 8726: @414216
     /* 414216 */ GIM_Try, /*On fail goto*//*Label 8751*/ GIMT_Encode4(414270),
     /* 414221 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414224 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 414227 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414231 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414235 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414239 */   GIM_Try, /*On fail goto*//*Label 8752*/ GIMT_Encode4(414254), // Rule ID 1910 //
     /* 414244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414247 */     // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 414247 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 414252 */     GIR_RootConstrainSelectedInstOperands,
     /* 414253 */     // GIR_Coverage, 1910,
     /* 414253 */     GIR_Done,
     /* 414254 */   // Label 8752: @414254
     /* 414254 */   GIM_Try, /*On fail goto*//*Label 8753*/ GIMT_Encode4(414269), // Rule ID 5473 //
     /* 414259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414262 */     // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 414262 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 414267 */     GIR_RootConstrainSelectedInstOperands,
     /* 414268 */     // GIR_Coverage, 5473,
     /* 414268 */     GIR_Done,
     /* 414269 */   // Label 8753: @414269
     /* 414269 */   GIM_Reject,
     /* 414270 */ // Label 8751: @414270
     /* 414270 */ GIM_Reject,
     /* 414271 */ // Label 8727: @414271
     /* 414271 */ GIM_Try, /*On fail goto*//*Label 8754*/ GIMT_Encode4(414304), // Rule ID 1905 //
     /* 414276 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414279 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 414282 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 414285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414289 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414293 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414297 */   // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 414297 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 414302 */   GIR_RootConstrainSelectedInstOperands,
     /* 414303 */   // GIR_Coverage, 1905,
     /* 414303 */   GIR_Done,
     /* 414304 */ // Label 8754: @414304
     /* 414304 */ GIM_Reject,
     /* 414305 */ // Label 8728: @414305
     /* 414305 */ GIM_Try, /*On fail goto*//*Label 8755*/ GIMT_Encode4(414359),
     /* 414310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 414313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 414316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414324 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414328 */   GIM_Try, /*On fail goto*//*Label 8756*/ GIMT_Encode4(414343), // Rule ID 1908 //
     /* 414333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414336 */     // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 414336 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 414341 */     GIR_RootConstrainSelectedInstOperands,
     /* 414342 */     // GIR_Coverage, 1908,
     /* 414342 */     GIR_Done,
     /* 414343 */   // Label 8756: @414343
     /* 414343 */   GIM_Try, /*On fail goto*//*Label 8757*/ GIMT_Encode4(414358), // Rule ID 5471 //
     /* 414348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414351 */     // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 414351 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 414356 */     GIR_RootConstrainSelectedInstOperands,
     /* 414357 */     // GIR_Coverage, 5471,
     /* 414357 */     GIR_Done,
     /* 414358 */   // Label 8757: @414358
     /* 414358 */   GIM_Reject,
     /* 414359 */ // Label 8755: @414359
     /* 414359 */ GIM_Reject,
     /* 414360 */ // Label 8729: @414360
     /* 414360 */ GIM_Try, /*On fail goto*//*Label 8758*/ GIMT_Encode4(414393), // Rule ID 1906 //
     /* 414365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414368 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 414371 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 414374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414382 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414386 */   // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 414386 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
     /* 414391 */   GIR_RootConstrainSelectedInstOperands,
     /* 414392 */   // GIR_Coverage, 1906,
     /* 414392 */   GIR_Done,
     /* 414393 */ // Label 8758: @414393
     /* 414393 */ GIM_Reject,
     /* 414394 */ // Label 8730: @414394
     /* 414394 */ GIM_Try, /*On fail goto*//*Label 8759*/ GIMT_Encode4(414419), // Rule ID 8907 //
     /* 414399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 414405 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 414408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 414412 */   // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 414412 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 414417 */   GIR_RootConstrainSelectedInstOperands,
     /* 414418 */   // GIR_Coverage, 8907,
     /* 414418 */   GIR_Done,
     /* 414419 */ // Label 8759: @414419
     /* 414419 */ GIM_Reject,
     /* 414420 */ // Label 8731: @414420
     /* 414420 */ GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(414445), // Rule ID 8862 //
     /* 414425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 414431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 414434 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414438 */   // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 414438 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 414443 */   GIR_RootConstrainSelectedInstOperands,
     /* 414444 */   // GIR_Coverage, 8862,
     /* 414444 */   GIR_Done,
     /* 414445 */ // Label 8760: @414445
     /* 414445 */ GIM_Reject,
     /* 414446 */ // Label 8732: @414446
     /* 414446 */ GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(414471), // Rule ID 8863 //
     /* 414451 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414454 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 414457 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 414460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414464 */   // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 414464 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 414469 */   GIR_RootConstrainSelectedInstOperands,
     /* 414470 */   // GIR_Coverage, 8863,
     /* 414470 */   GIR_Done,
     /* 414471 */ // Label 8761: @414471
     /* 414471 */ GIM_Reject,
     /* 414472 */ // Label 8733: @414472
     /* 414472 */ GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(414518),
     /* 414477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 414480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 414483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414487 */   GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(414502), // Rule ID 8858 //
     /* 414492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414495 */     // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 414495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 414500 */     GIR_RootConstrainSelectedInstOperands,
     /* 414501 */     // GIR_Coverage, 8858,
     /* 414501 */     GIR_Done,
     /* 414502 */   // Label 8763: @414502
     /* 414502 */   GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(414517), // Rule ID 8864 //
     /* 414507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414510 */     // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 414510 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 414515 */     GIR_RootConstrainSelectedInstOperands,
     /* 414516 */     // GIR_Coverage, 8864,
     /* 414516 */     GIR_Done,
     /* 414517 */   // Label 8764: @414517
     /* 414517 */   GIM_Reject,
     /* 414518 */ // Label 8762: @414518
     /* 414518 */ GIM_Reject,
     /* 414519 */ // Label 8734: @414519
     /* 414519 */ GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(414544), // Rule ID 8906 //
     /* 414524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 414530 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 414533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 414537 */   // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 414537 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 414542 */   GIR_RootConstrainSelectedInstOperands,
     /* 414543 */   // GIR_Coverage, 8906,
     /* 414543 */   GIR_Done,
     /* 414544 */ // Label 8765: @414544
     /* 414544 */ GIM_Reject,
     /* 414545 */ // Label 8735: @414545
     /* 414545 */ GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(414570), // Rule ID 8860 //
     /* 414550 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414553 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 414556 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 414559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414563 */   // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 414563 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 414568 */   GIR_RootConstrainSelectedInstOperands,
     /* 414569 */   // GIR_Coverage, 8860,
     /* 414569 */   GIR_Done,
     /* 414570 */ // Label 8766: @414570
     /* 414570 */ GIM_Reject,
     /* 414571 */ // Label 8736: @414571
     /* 414571 */ GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(414617),
     /* 414576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 414579 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 414582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414586 */   GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(414601), // Rule ID 8857 //
     /* 414591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414594 */     // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 414594 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 414599 */     GIR_RootConstrainSelectedInstOperands,
     /* 414600 */     // GIR_Coverage, 8857,
     /* 414600 */     GIR_Done,
     /* 414601 */   // Label 8768: @414601
     /* 414601 */   GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(414616), // Rule ID 8861 //
     /* 414606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414609 */     // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 414609 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 414614 */     GIR_RootConstrainSelectedInstOperands,
     /* 414615 */     // GIR_Coverage, 8861,
     /* 414615 */     GIR_Done,
     /* 414616 */   // Label 8769: @414616
     /* 414616 */   GIM_Reject,
     /* 414617 */ // Label 8767: @414617
     /* 414617 */ GIM_Reject,
     /* 414618 */ // Label 8737: @414618
     /* 414618 */ GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(414643), // Rule ID 8905 //
     /* 414623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 414629 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 414632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 414636 */   // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 414636 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 414641 */   GIR_RootConstrainSelectedInstOperands,
     /* 414642 */   // GIR_Coverage, 8905,
     /* 414642 */   GIR_Done,
     /* 414643 */ // Label 8770: @414643
     /* 414643 */ GIM_Reject,
     /* 414644 */ // Label 8738: @414644
     /* 414644 */ GIM_Try, /*On fail goto*//*Label 8771*/ GIMT_Encode4(414690),
     /* 414649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 414652 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 414655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414659 */   GIM_Try, /*On fail goto*//*Label 8772*/ GIMT_Encode4(414674), // Rule ID 8856 //
     /* 414664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414667 */     // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 414667 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 414672 */     GIR_RootConstrainSelectedInstOperands,
     /* 414673 */     // GIR_Coverage, 8856,
     /* 414673 */     GIR_Done,
     /* 414674 */   // Label 8772: @414674
     /* 414674 */   GIM_Try, /*On fail goto*//*Label 8773*/ GIMT_Encode4(414689), // Rule ID 8859 //
     /* 414679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414682 */     // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 414682 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 414687 */     GIR_RootConstrainSelectedInstOperands,
     /* 414688 */     // GIR_Coverage, 8859,
     /* 414688 */     GIR_Done,
     /* 414689 */   // Label 8773: @414689
     /* 414689 */   GIM_Reject,
     /* 414690 */ // Label 8771: @414690
     /* 414690 */ GIM_Reject,
     /* 414691 */ // Label 8739: @414691
     /* 414691 */ GIM_Try, /*On fail goto*//*Label 8774*/ GIMT_Encode4(414716), // Rule ID 2400 //
     /* 414696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 414702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 414705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 414709 */   // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 414709 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
     /* 414714 */   GIR_RootConstrainSelectedInstOperands,
     /* 414715 */   // GIR_Coverage, 2400,
     /* 414715 */   GIR_Done,
     /* 414716 */ // Label 8774: @414716
     /* 414716 */ GIM_Reject,
     /* 414717 */ // Label 8740: @414717
     /* 414717 */ GIM_Try, /*On fail goto*//*Label 8775*/ GIMT_Encode4(414742), // Rule ID 8855 //
     /* 414722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 414725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 414728 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 414731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 414735 */   // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 414735 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
     /* 414740 */   GIR_RootConstrainSelectedInstOperands,
     /* 414741 */   // GIR_Coverage, 8855,
     /* 414741 */   GIR_Done,
     /* 414742 */ // Label 8775: @414742
     /* 414742 */ GIM_Reject,
     /* 414743 */ // Label 8741: @414743
     /* 414743 */ GIM_Reject,
     /* 414744 */ // Label 157: @414744
     /* 414744 */ GIM_Reject,
     /* 414745 */ }; // Size: 414745 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
